

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

/* arithmetics */
#define EXP90 1.220403294317841e+039
#define m00_hypot(v00,x,y)      v00 = sqrt((x)*(x)+(y)*(y));
#define m10_hypot(v10,v00,x,y)  v10 = (x)/(v00);
#define m11_hypot(v11,v00,x,y)  v11 = (y)/(v00);
#define m00_max(v00,x,y)        v00 = ((x)>(y))?(x):(y);
#define m10_max(v10,v00,x,y)    v10 = ((x)>(y))?1.0:0.0;
#define m11_max(v11,v00,x,y)    v11 = ((x)>(y))?0.0:1.0;
#define m00_min(v00,x,y)        v00 = ((x)<(y))?(x):(y);
#define m10_min(v10,v00,x,y)    v10 = ((x)<(y))?1.0:0.0;
#define m11_min(v11,v00,x,y)    v11 = ((x)<(y))?0.0:1.0;
#define m00_pow(v00,x,y)        v00 = pow(x,y);
#define m10_pow(v10,v00,x,y)    v10 = (x==0.0)?0.0:(v00)*(y)/(x);
#define m11_pow(v11,v00,x,y)    v11 = (x==0.0)?0.0:(log(x)*(v00));
#define m00_div(v00,v10,x,y)    double v10=1/(y); double v00=(x)*v10;
#define m10_div(v10,v00,vv,x,y)
#define m11_div(v11,v00,vv,x,y) double v11 = -v00*vv;
#define m00_mult(v00,v10,v11,x,y) double v10=(x); double v11=(y); double v00=v10*v11;
#define m00_add(v00,x,y)        double v00=(x)+(y);
#define m00_cos(v00,x)          v00 = cos(x);
#define m10_cos(v10,v00,x)      v10 = (-sin(x));
#define m00_sin(v00,x)          v00 = sin(x);
#define m10_sin(v10,v00,x)      v10 = (cos(x));
#define m00_tan(v00,x)          v00 = tan(x);
#define m10_tan(v10,v00,x)      v10 = (1.0/cos(x)/cos(x));
#define m00_cosh(v00,x)         v00 = cosh(x);
#define m10_cosh(v10,v00,x)     v10 = (sinh(x));
#define m00_sinh(v00,x)         v00 = sinh(x);
#define m10_sinh(v10,v00,x)     v10 = (cosh(x));
#define m00_tanh(v00,x)         v00 = tanh(x);
#define m10_tanh(v10,v00,x)     v10 = (1.0/cosh(x)/cosh(x));
#define m00_acos(v00,x)         v00 = acos(x);
#define m10_acos(v10,v00,x)     v10 = (-1.0/sqrt(1-x*x));
#define m00_asin(v00,x)         v00 = asin(x);
#define m10_asin(v10,v00,x)     v10 = (+1.0/sqrt(1-x*x));
#define m00_atan(v00,x)         v00 = atan(x);
#define m10_atan(v10,v00,x)     v10 = (+1.0/(1+x*x));
#define m00_logE(v00,x)         v00 = log(x);
#define m10_logE(v10,v00,x)     v10 = (1.0/x);
#define m00_log10(v00,x)        v00 = log10(x);
#define m10_log10(v10,v00,x)    v10 = (1.0/x/log(10));
#define m00_sqrt(v00,x)         v00 = sqrt(x);
#define m10_sqrt(v10,v00,x)     v10 = (0.5/v00);
#define m00_fabs(v00,x)         v00 = fabs(x);
#define m10_fabs(v10,v00,x)     v10 = (((x)>=0)?(+1.0):(-1.0));
#define m00_exp(v00,x)          v00 = exp(x);
#define m10_exp(v10,v00,x)      v10 = v00;
#define m00_abs(v00)            ((v00)<(0)?(-(v00)):(v00))
#define m00_floor(v00,x)        v00 = floor(x);
#define m00_ceil(v00,x)         v00 = ceil(x);
#define m00_limexp(v00,x)       v00 = ((x)<90.0?exp(x):EXP90*(x-89.0));
#define m10_limexp(v10,v00,x)   v10 = ((x)<90.0?(v00):EXP90);
#define m00_atan2(v00,x,y)      v00 = atan2(x,y);
#define m10_atan2(v10,x,y)      v10 = (-(y)/((x)*(x)+(y)*(y)));
#define m11_atan2(v11,x,y)      v11 = ((x)/((x)*(x)+(y)*(y)));
#define m00_acosh(v00,x)        v00 = acosh(x);
#define m10_acosh(v10,v00,x)    v10 = (1.0/(sqrt(x-1)*sqrt(x+1)));
#define m00_asinh(v00,x)        v00 = asinh(x);
#define m10_asinh(v10,v00,x)    v10 = (1.0/(sqrt(x*x+1)));
#define m00_atanh(v00,x)        v00 = atanh(x);
#define m10_atanh(v10,v00,x)    v10 = (1.0/(1-x*x));

#define m20_logE(v00)         (-1.0/v00/v00)
#define m20_exp(v00)          exp(v00)
#define m20_limexp(v00)       ((v00)<90.0?exp(v00):0.0)
#define m20_sqrt(v00)         (-0.25/(v00)/sqrt(v00))
#define m20_fabs(v00)         0.0

/*wrapper*/
#define pModel model
#define pInst here
#define mint_get_circuit_tempK() _circuit_temp
#define voltages(n) NP(n)
#define _DDT(q) q
#define _DDX
#define _DERIVATEFORDDX
pInst->fpnoise0=0.0; pInst->fenoise0=0.0;
pInst->fpnoise1=0.0; pInst->fenoise1=0.0;
pInst->wnoise0=0.0;
pInst->wnoise1=0.0;
pInst->wnoise2=0.0;
pInst->wnoise3=0.0;
pInst->wnoise4=0.0;
pInst->wnoise5=0.0;
pInst->wnoise6=0.0;
pInst->wnoise7=0.0;
pInst->wnoise8=0.0;
pInst->wnoise9=0.0;
pInst->wnoise10=0.0;
pInst->wnoise11=0.0;
pInst->wnoise12=0.0;
pInst->wnoise13=0.0;
pInst->wnoise14=0.0;
double Gnoise;
#if defined(_DERIVATE)
double Gnoise_Vgi_bi;
double Gnoise_Vdi_bi;
double Gnoise_Vsi_bi;
double Gnoise_Tempt_GND;
#endif
double Ggate;
#if defined(_DERIVATE)
double Ggate_Vgi_bi;
double Ggate_Vdi_bi;
double Ggate_Vsi_bi;
double Ggate_Tempt_GND;
#endif
double gspr;
#if defined(_DERIVATE)
double gspr_Tempt_GND;
double gspr_Vgi_bi;
double gspr_Vdi_bi;
double gspr_Vsi_bi;
#endif
double gdpr;
#if defined(_DERIVATE)
double gdpr_Tempt_GND;
double gdpr_Vgi_bi;
double gdpr_Vdi_bi;
double gdpr_Vsi_bi;
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX)
double QGI_Tempt_GND;
double QGI_Vdbulk_di;
double QGI_Vsbulk_si;
double QGI_Vgi_bi;
double QGI_Vdi_bi;
double QGI_Vsi_bi;
#if defined(_DERIVATE2)
  double QGI_Vsi_bi_Tempt_GND;
  double QGI_Vsi_bi_Vdbulk_di;
  double QGI_Vsi_bi_Vsbulk_si;
  double QGI_Vsi_bi_Vgi_bi;
  double QGI_Vsi_bi_Vdi_bi;
  double QGI_Vsi_bi_Vsi_bi;
  double QGI_Vdi_bi_Tempt_GND;
  double QGI_Vdi_bi_Vdbulk_di;
  double QGI_Vdi_bi_Vsbulk_si;
  double QGI_Vdi_bi_Vgi_bi;
  double QGI_Vdi_bi_Vdi_bi;
  double QGI_Vdi_bi_Vsi_bi;
  double QGI_Vgi_bi_Tempt_GND;
  double QGI_Vgi_bi_Vdbulk_di;
  double QGI_Vgi_bi_Vsbulk_si;
  double QGI_Vgi_bi_Vgi_bi;
  double QGI_Vgi_bi_Vdi_bi;
  double QGI_Vgi_bi_Vsi_bi;
  double QGI_Vsbulk_si_Tempt_GND;
  double QGI_Vsbulk_si_Vdbulk_di;
  double QGI_Vsbulk_si_Vsbulk_si;
  double QGI_Vsbulk_si_Vgi_bi;
  double QGI_Vsbulk_si_Vdi_bi;
  double QGI_Vsbulk_si_Vsi_bi;
  double QGI_Vdbulk_di_Tempt_GND;
  double QGI_Vdbulk_di_Vdbulk_di;
  double QGI_Vdbulk_di_Vsbulk_si;
  double QGI_Vdbulk_di_Vgi_bi;
  double QGI_Vdbulk_di_Vdi_bi;
  double QGI_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX)
double QDI_Vdbulk_di;
double QDI_Vsbulk_si;
double QDI_Tempt_GND;
double QDI_Vgi_bi;
double QDI_Vdi_bi;
double QDI_Vsi_bi;
#if defined(_DERIVATE2)
  double QDI_Vsi_bi_Vdbulk_di;
  double QDI_Vsi_bi_Vsbulk_si;
  double QDI_Vsi_bi_Tempt_GND;
  double QDI_Vsi_bi_Vgi_bi;
  double QDI_Vsi_bi_Vdi_bi;
  double QDI_Vsi_bi_Vsi_bi;
  double QDI_Vdi_bi_Vdbulk_di;
  double QDI_Vdi_bi_Vsbulk_si;
  double QDI_Vdi_bi_Tempt_GND;
  double QDI_Vdi_bi_Vgi_bi;
  double QDI_Vdi_bi_Vdi_bi;
  double QDI_Vdi_bi_Vsi_bi;
  double QDI_Vgi_bi_Vdbulk_di;
  double QDI_Vgi_bi_Vsbulk_si;
  double QDI_Vgi_bi_Tempt_GND;
  double QDI_Vgi_bi_Vgi_bi;
  double QDI_Vgi_bi_Vdi_bi;
  double QDI_Vgi_bi_Vsi_bi;
  double QDI_Vsbulk_si_Vdbulk_di;
  double QDI_Vsbulk_si_Vsbulk_si;
  double QDI_Vsbulk_si_Tempt_GND;
  double QDI_Vsbulk_si_Vgi_bi;
  double QDI_Vsbulk_si_Vdi_bi;
  double QDI_Vsbulk_si_Vsi_bi;
  double QDI_Vdbulk_di_Vdbulk_di;
  double QDI_Vdbulk_di_Vsbulk_si;
  double QDI_Vdbulk_di_Tempt_GND;
  double QDI_Vdbulk_di_Vgi_bi;
  double QDI_Vdbulk_di_Vdi_bi;
  double QDI_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX)
double QSI_Vdbulk_di;
double QSI_Vsbulk_si;
double QSI_Tempt_GND;
double QSI_Vgi_bi;
double QSI_Vdi_bi;
double QSI_Vsi_bi;
#if defined(_DERIVATE2)
  double QSI_Vsi_bi_Vdbulk_di;
  double QSI_Vsi_bi_Vsbulk_si;
  double QSI_Vsi_bi_Tempt_GND;
  double QSI_Vsi_bi_Vgi_bi;
  double QSI_Vsi_bi_Vdi_bi;
  double QSI_Vsi_bi_Vsi_bi;
  double QSI_Vdi_bi_Vdbulk_di;
  double QSI_Vdi_bi_Vsbulk_si;
  double QSI_Vdi_bi_Tempt_GND;
  double QSI_Vdi_bi_Vgi_bi;
  double QSI_Vdi_bi_Vdi_bi;
  double QSI_Vdi_bi_Vsi_bi;
  double QSI_Vgi_bi_Vdbulk_di;
  double QSI_Vgi_bi_Vsbulk_si;
  double QSI_Vgi_bi_Tempt_GND;
  double QSI_Vgi_bi_Vgi_bi;
  double QSI_Vgi_bi_Vdi_bi;
  double QSI_Vgi_bi_Vsi_bi;
  double QSI_Vsbulk_si_Vdbulk_di;
  double QSI_Vsbulk_si_Vsbulk_si;
  double QSI_Vsbulk_si_Tempt_GND;
  double QSI_Vsbulk_si_Vgi_bi;
  double QSI_Vsbulk_si_Vdi_bi;
  double QSI_Vsbulk_si_Vsi_bi;
  double QSI_Vdbulk_di_Vdbulk_di;
  double QSI_Vdbulk_di_Vsbulk_si;
  double QSI_Vdbulk_di_Tempt_GND;
  double QSI_Vdbulk_di_Vgi_bi;
  double QSI_Vdbulk_di_Vdi_bi;
  double QSI_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
double ids_edge;
#if defined(_DERIVATEFORDDX)
double ids_edge_Vgm_si;
double ids_edge_Vgm_di;
double ids_edge_Vdbulk_di;
double ids_edge_Vsbulk_si;
double ids_edge_Vgi_bi;
double ids_edge_Tempt_GND;
double ids_edge_Vdi_bi;
double ids_edge_Vsi_bi;
#if defined(_DERIVATE2)
  double ids_edge_Vsi_bi_Vgm_si;
  double ids_edge_Vsi_bi_Vgm_di;
  double ids_edge_Vsi_bi_Vdbulk_di;
  double ids_edge_Vsi_bi_Vsbulk_si;
  double ids_edge_Vsi_bi_Vgi_bi;
  double ids_edge_Vsi_bi_Tempt_GND;
  double ids_edge_Vsi_bi_Vdi_bi;
  double ids_edge_Vsi_bi_Vsi_bi;
  double ids_edge_Vdi_bi_Vgm_si;
  double ids_edge_Vdi_bi_Vgm_di;
  double ids_edge_Vdi_bi_Vdbulk_di;
  double ids_edge_Vdi_bi_Vsbulk_si;
  double ids_edge_Vdi_bi_Vgi_bi;
  double ids_edge_Vdi_bi_Tempt_GND;
  double ids_edge_Vdi_bi_Vdi_bi;
  double ids_edge_Vdi_bi_Vsi_bi;
  double ids_edge_Vgi_bi_Vgm_si;
  double ids_edge_Vgi_bi_Vgm_di;
  double ids_edge_Vgi_bi_Vdbulk_di;
  double ids_edge_Vgi_bi_Vsbulk_si;
  double ids_edge_Vgi_bi_Vgi_bi;
  double ids_edge_Vgi_bi_Tempt_GND;
  double ids_edge_Vgi_bi_Vdi_bi;
  double ids_edge_Vgi_bi_Vsi_bi;
  double ids_edge_Vdbulk_di_Vgm_si;
  double ids_edge_Vdbulk_di_Vgm_di;
  double ids_edge_Vdbulk_di_Vdbulk_di;
  double ids_edge_Vdbulk_di_Vsbulk_si;
  double ids_edge_Vdbulk_di_Vgi_bi;
  double ids_edge_Vdbulk_di_Tempt_GND;
  double ids_edge_Vdbulk_di_Vdi_bi;
  double ids_edge_Vdbulk_di_Vsi_bi;
  double ids_edge_Vgm_di_Vgm_si;
  double ids_edge_Vgm_di_Vgm_di;
  double ids_edge_Vgm_di_Vdbulk_di;
  double ids_edge_Vgm_di_Vsbulk_si;
  double ids_edge_Vgm_di_Vgi_bi;
  double ids_edge_Vgm_di_Tempt_GND;
  double ids_edge_Vgm_di_Vdi_bi;
  double ids_edge_Vgm_di_Vsi_bi;
#endif
#endif
double Vdssate;
#if defined(_DERIVATEFORDDX)
double Vdssate_Vgm_si;
double Vdssate_Vdbulk_di;
double Vdssate_Vsbulk_si;
double Vdssate_Vgi_bi;
double Vdssate_Vdi_bi;
double Vdssate_Vsi_bi;
double Vdssate_Tempt_GND;
double Vdssate_Vgm_di;
#if defined(_DERIVATE2)
  double Vdssate_Vgm_di_Vgm_si;
  double Vdssate_Vgm_di_Vdbulk_di;
  double Vdssate_Vgm_di_Vsbulk_si;
  double Vdssate_Vgm_di_Vgi_bi;
  double Vdssate_Vgm_di_Vdi_bi;
  double Vdssate_Vgm_di_Vsi_bi;
  double Vdssate_Vgm_di_Tempt_GND;
  double Vdssate_Vgm_di_Vgm_di;
  double Vdssate_Vsi_bi_Vgm_si;
  double Vdssate_Vsi_bi_Vdbulk_di;
  double Vdssate_Vsi_bi_Vsbulk_si;
  double Vdssate_Vsi_bi_Vgi_bi;
  double Vdssate_Vsi_bi_Vdi_bi;
  double Vdssate_Vsi_bi_Vsi_bi;
  double Vdssate_Vsi_bi_Tempt_GND;
  double Vdssate_Vsi_bi_Vgm_di;
  double Vdssate_Vdi_bi_Vgm_si;
  double Vdssate_Vdi_bi_Vdbulk_di;
  double Vdssate_Vdi_bi_Vsbulk_si;
  double Vdssate_Vdi_bi_Vgi_bi;
  double Vdssate_Vdi_bi_Vdi_bi;
  double Vdssate_Vdi_bi_Vsi_bi;
  double Vdssate_Vdi_bi_Tempt_GND;
  double Vdssate_Vdi_bi_Vgm_di;
  double Vdssate_Vgi_bi_Vgm_si;
  double Vdssate_Vgi_bi_Vdbulk_di;
  double Vdssate_Vgi_bi_Vsbulk_si;
  double Vdssate_Vgi_bi_Vgi_bi;
  double Vdssate_Vgi_bi_Vdi_bi;
  double Vdssate_Vgi_bi_Vsi_bi;
  double Vdssate_Vgi_bi_Tempt_GND;
  double Vdssate_Vgi_bi_Vgm_di;
  double Vdssate_Vdbulk_di_Vgm_si;
  double Vdssate_Vdbulk_di_Vdbulk_di;
  double Vdssate_Vdbulk_di_Vsbulk_si;
  double Vdssate_Vdbulk_di_Vgi_bi;
  double Vdssate_Vdbulk_di_Vdi_bi;
  double Vdssate_Vdbulk_di_Vsi_bi;
  double Vdssate_Vdbulk_di_Tempt_GND;
  double Vdssate_Vdbulk_di_Vgm_di;
#endif
#endif
double Vdsatedge;
#if defined(_DERIVATEFORDDX)
double Vdsatedge_Vgm_si;
double Vdsatedge_Vdbulk_di;
double Vdsatedge_Vsbulk_si;
double Vdsatedge_Vgi_bi;
double Vdsatedge_Vdi_bi;
double Vdsatedge_Vsi_bi;
double Vdsatedge_Tempt_GND;
double Vdsatedge_Vgm_di;
#if defined(_DERIVATE2)
  double Vdsatedge_Vgm_di_Vgm_si;
  double Vdsatedge_Vgm_di_Vdbulk_di;
  double Vdsatedge_Vgm_di_Vsbulk_si;
  double Vdsatedge_Vgm_di_Vgi_bi;
  double Vdsatedge_Vgm_di_Vdi_bi;
  double Vdsatedge_Vgm_di_Vsi_bi;
  double Vdsatedge_Vgm_di_Tempt_GND;
  double Vdsatedge_Vgm_di_Vgm_di;
  double Vdsatedge_Vsi_bi_Vgm_si;
  double Vdsatedge_Vsi_bi_Vdbulk_di;
  double Vdsatedge_Vsi_bi_Vsbulk_si;
  double Vdsatedge_Vsi_bi_Vgi_bi;
  double Vdsatedge_Vsi_bi_Vdi_bi;
  double Vdsatedge_Vsi_bi_Vsi_bi;
  double Vdsatedge_Vsi_bi_Tempt_GND;
  double Vdsatedge_Vsi_bi_Vgm_di;
  double Vdsatedge_Vdi_bi_Vgm_si;
  double Vdsatedge_Vdi_bi_Vdbulk_di;
  double Vdsatedge_Vdi_bi_Vsbulk_si;
  double Vdsatedge_Vdi_bi_Vgi_bi;
  double Vdsatedge_Vdi_bi_Vdi_bi;
  double Vdsatedge_Vdi_bi_Vsi_bi;
  double Vdsatedge_Vdi_bi_Tempt_GND;
  double Vdsatedge_Vdi_bi_Vgm_di;
  double Vdsatedge_Vgi_bi_Vgm_si;
  double Vdsatedge_Vgi_bi_Vdbulk_di;
  double Vdsatedge_Vgi_bi_Vsbulk_si;
  double Vdsatedge_Vgi_bi_Vgi_bi;
  double Vdsatedge_Vgi_bi_Vdi_bi;
  double Vdsatedge_Vgi_bi_Vsi_bi;
  double Vdsatedge_Vgi_bi_Tempt_GND;
  double Vdsatedge_Vgi_bi_Vgm_di;
  double Vdsatedge_Vdbulk_di_Vgm_si;
  double Vdsatedge_Vdbulk_di_Vdbulk_di;
  double Vdsatedge_Vdbulk_di_Vsbulk_si;
  double Vdsatedge_Vdbulk_di_Vgi_bi;
  double Vdsatedge_Vdbulk_di_Vdi_bi;
  double Vdsatedge_Vdbulk_di_Vsi_bi;
  double Vdsatedge_Vdbulk_di_Tempt_GND;
  double Vdsatedge_Vdbulk_di_Vgm_di;
#endif
#endif
double vdsatedge;
#if defined(_DERIVATEFORDDX)
double vdsatedge_Vgm_si;
double vdsatedge_Vdbulk_di;
double vdsatedge_Vsbulk_si;
double vdsatedge_Vgi_bi;
double vdsatedge_Vdi_bi;
double vdsatedge_Vsi_bi;
double vdsatedge_Tempt_GND;
double vdsatedge_Vgm_di;
#if defined(_DERIVATE2)
  double vdsatedge_Vgm_di_Vgm_si;
  double vdsatedge_Vgm_di_Vdbulk_di;
  double vdsatedge_Vgm_di_Vsbulk_si;
  double vdsatedge_Vgm_di_Vgi_bi;
  double vdsatedge_Vgm_di_Vdi_bi;
  double vdsatedge_Vgm_di_Vsi_bi;
  double vdsatedge_Vgm_di_Tempt_GND;
  double vdsatedge_Vgm_di_Vgm_di;
  double vdsatedge_Vsi_bi_Vgm_si;
  double vdsatedge_Vsi_bi_Vdbulk_di;
  double vdsatedge_Vsi_bi_Vsbulk_si;
  double vdsatedge_Vsi_bi_Vgi_bi;
  double vdsatedge_Vsi_bi_Vdi_bi;
  double vdsatedge_Vsi_bi_Vsi_bi;
  double vdsatedge_Vsi_bi_Tempt_GND;
  double vdsatedge_Vsi_bi_Vgm_di;
  double vdsatedge_Vdi_bi_Vgm_si;
  double vdsatedge_Vdi_bi_Vdbulk_di;
  double vdsatedge_Vdi_bi_Vsbulk_si;
  double vdsatedge_Vdi_bi_Vgi_bi;
  double vdsatedge_Vdi_bi_Vdi_bi;
  double vdsatedge_Vdi_bi_Vsi_bi;
  double vdsatedge_Vdi_bi_Tempt_GND;
  double vdsatedge_Vdi_bi_Vgm_di;
  double vdsatedge_Vgi_bi_Vgm_si;
  double vdsatedge_Vgi_bi_Vdbulk_di;
  double vdsatedge_Vgi_bi_Vsbulk_si;
  double vdsatedge_Vgi_bi_Vgi_bi;
  double vdsatedge_Vgi_bi_Vdi_bi;
  double vdsatedge_Vgi_bi_Vsi_bi;
  double vdsatedge_Vgi_bi_Tempt_GND;
  double vdsatedge_Vgi_bi_Vgm_di;
  double vdsatedge_Vdbulk_di_Vgm_si;
  double vdsatedge_Vdbulk_di_Vdbulk_di;
  double vdsatedge_Vdbulk_di_Vsbulk_si;
  double vdsatedge_Vdbulk_di_Vgi_bi;
  double vdsatedge_Vdbulk_di_Vdi_bi;
  double vdsatedge_Vdbulk_di_Vsi_bi;
  double vdsatedge_Vdbulk_di_Tempt_GND;
  double vdsatedge_Vdbulk_di_Vgm_di;
#endif
#endif
double DGAMMAEDGE_i;
double dvth_sce;
#if defined(_DERIVATEFORDDX)
double dvth_sce_Vgm_di;
double dvth_sce_Vgm_si;
double dvth_sce_Vdbulk_di;
double dvth_sce_Vsbulk_si;
double dvth_sce_Vgi_bi;
double dvth_sce_Vdi_bi;
double dvth_sce_Vsi_bi;
double dvth_sce_Tempt_GND;
#if defined(_DERIVATE2)
  double dvth_sce_Vsi_bi_Vgm_di;
  double dvth_sce_Vsi_bi_Vgm_si;
  double dvth_sce_Vsi_bi_Vdbulk_di;
  double dvth_sce_Vsi_bi_Vsbulk_si;
  double dvth_sce_Vsi_bi_Vgi_bi;
  double dvth_sce_Vsi_bi_Vdi_bi;
  double dvth_sce_Vsi_bi_Vsi_bi;
  double dvth_sce_Vsi_bi_Tempt_GND;
  double dvth_sce_Vdi_bi_Vgm_di;
  double dvth_sce_Vdi_bi_Vgm_si;
  double dvth_sce_Vdi_bi_Vdbulk_di;
  double dvth_sce_Vdi_bi_Vsbulk_si;
  double dvth_sce_Vdi_bi_Vgi_bi;
  double dvth_sce_Vdi_bi_Vdi_bi;
  double dvth_sce_Vdi_bi_Vsi_bi;
  double dvth_sce_Vdi_bi_Tempt_GND;
  double dvth_sce_Vgi_bi_Vgm_di;
  double dvth_sce_Vgi_bi_Vgm_si;
  double dvth_sce_Vgi_bi_Vdbulk_di;
  double dvth_sce_Vgi_bi_Vsbulk_si;
  double dvth_sce_Vgi_bi_Vgi_bi;
  double dvth_sce_Vgi_bi_Vdi_bi;
  double dvth_sce_Vgi_bi_Vsi_bi;
  double dvth_sce_Vgi_bi_Tempt_GND;
  double dvth_sce_Vdbulk_di_Vgm_di;
  double dvth_sce_Vdbulk_di_Vgm_si;
  double dvth_sce_Vdbulk_di_Vdbulk_di;
  double dvth_sce_Vdbulk_di_Vsbulk_si;
  double dvth_sce_Vdbulk_di_Vgi_bi;
  double dvth_sce_Vdbulk_di_Vdi_bi;
  double dvth_sce_Vdbulk_di_Vsi_bi;
  double dvth_sce_Vdbulk_di_Tempt_GND;
  double dvth_sce_Vgm_di_Vgm_di;
  double dvth_sce_Vgm_di_Vgm_si;
  double dvth_sce_Vgm_di_Vdbulk_di;
  double dvth_sce_Vgm_di_Vsbulk_si;
  double dvth_sce_Vgm_di_Vgi_bi;
  double dvth_sce_Vgm_di_Vdi_bi;
  double dvth_sce_Vgm_di_Vsi_bi;
  double dvth_sce_Vgm_di_Tempt_GND;
#endif
#endif
double theta_sce_edge;
#if defined(_DERIVATEFORDDX)
double theta_sce_edge_Vgm_di;
double theta_sce_edge_Vgm_si;
double theta_sce_edge_Vdbulk_di;
double theta_sce_edge_Vsbulk_si;
double theta_sce_edge_Vgi_bi;
double theta_sce_edge_Vdi_bi;
double theta_sce_edge_Vsi_bi;
double theta_sce_edge_Tempt_GND;
#if defined(_DERIVATE2)
  double theta_sce_edge_Vsi_bi_Vgm_di;
  double theta_sce_edge_Vsi_bi_Vgm_si;
  double theta_sce_edge_Vsi_bi_Vdbulk_di;
  double theta_sce_edge_Vsi_bi_Vsbulk_si;
  double theta_sce_edge_Vsi_bi_Vgi_bi;
  double theta_sce_edge_Vsi_bi_Vdi_bi;
  double theta_sce_edge_Vsi_bi_Vsi_bi;
  double theta_sce_edge_Vsi_bi_Tempt_GND;
  double theta_sce_edge_Vdi_bi_Vgm_di;
  double theta_sce_edge_Vdi_bi_Vgm_si;
  double theta_sce_edge_Vdi_bi_Vdbulk_di;
  double theta_sce_edge_Vdi_bi_Vsbulk_si;
  double theta_sce_edge_Vdi_bi_Vgi_bi;
  double theta_sce_edge_Vdi_bi_Vdi_bi;
  double theta_sce_edge_Vdi_bi_Vsi_bi;
  double theta_sce_edge_Vdi_bi_Tempt_GND;
  double theta_sce_edge_Vgi_bi_Vgm_di;
  double theta_sce_edge_Vgi_bi_Vgm_si;
  double theta_sce_edge_Vgi_bi_Vdbulk_di;
  double theta_sce_edge_Vgi_bi_Vsbulk_si;
  double theta_sce_edge_Vgi_bi_Vgi_bi;
  double theta_sce_edge_Vgi_bi_Vdi_bi;
  double theta_sce_edge_Vgi_bi_Vsi_bi;
  double theta_sce_edge_Vgi_bi_Tempt_GND;
  double theta_sce_edge_Vdbulk_di_Vgm_di;
  double theta_sce_edge_Vdbulk_di_Vgm_si;
  double theta_sce_edge_Vdbulk_di_Vdbulk_di;
  double theta_sce_edge_Vdbulk_di_Vsbulk_si;
  double theta_sce_edge_Vdbulk_di_Vgi_bi;
  double theta_sce_edge_Vdbulk_di_Vdi_bi;
  double theta_sce_edge_Vdbulk_di_Vsi_bi;
  double theta_sce_edge_Vdbulk_di_Tempt_GND;
  double theta_sce_edge_Vgm_di_Vgm_di;
  double theta_sce_edge_Vgm_di_Vgm_si;
  double theta_sce_edge_Vgm_di_Vdbulk_di;
  double theta_sce_edge_Vgm_di_Vsbulk_si;
  double theta_sce_edge_Vgm_di_Vgi_bi;
  double theta_sce_edge_Vgm_di_Vdi_bi;
  double theta_sce_edge_Vgm_di_Vsi_bi;
  double theta_sce_edge_Vgm_di_Tempt_GND;
#endif
#endif
double litl_edge;
#if defined(_DERIVATEFORDDX)
double litl_edge_Vdi_bi;
double litl_edge_Vsi_bi;
double litl_edge_Tempt_GND;
#if defined(_DERIVATE2)
  double litl_edge_Vsi_bi_Vdi_bi;
  double litl_edge_Vsi_bi_Vsi_bi;
  double litl_edge_Vsi_bi_Tempt_GND;
  double litl_edge_Vdi_bi_Vdi_bi;
  double litl_edge_Vdi_bi_Vsi_bi;
  double litl_edge_Vdi_bi_Tempt_GND;
#endif
#endif
double dvth_dibl;
#if defined(_DERIVATEFORDDX)
double dvth_dibl_Tempt_GND;
double dvth_dibl_Vdi_bi;
double dvth_dibl_Vsi_bi;
#if defined(_DERIVATE2)
  double dvth_dibl_Vsi_bi_Tempt_GND;
  double dvth_dibl_Vsi_bi_Vdi_bi;
  double dvth_dibl_Vsi_bi_Vsi_bi;
  double dvth_dibl_Vdi_bi_Tempt_GND;
  double dvth_dibl_Vdi_bi_Vdi_bi;
  double dvth_dibl_Vdi_bi_Vsi_bi;
#endif
#endif
double ETA0EDGE_t;
#if defined(_DERIVATE)
double ETA0EDGE_t_Tempt_GND;
#endif
double NFACTOREDGE_t;
#if defined(_DERIVATE)
double NFACTOREDGE_t_Tempt_GND;
#endif
double Qovg;
#if defined(_DYNAMIC)
double Qovb;
#if defined(_DERIVATEFORDDX)
double Qovb_Vgm_bi;
#if defined(_DERIVATE2)
  double Qovb_Vgm_bi_Vgm_bi;
#endif
#endif
#endif
double Vgdov;
#if defined(_DERIVATEFORDDX)
double Vgdov_Vgm_di;
double Vgdov_Tempt_GND;
double Vgdov_Vgm_si;
double Vgdov_Vdbulk_di;
double Vgdov_Vsbulk_si;
double Vgdov_Vgi_bi;
double Vgdov_Vdi_bi;
double Vgdov_Vsi_bi;
#if defined(_DERIVATE2)
  double Vgdov_Vsi_bi_Vgm_di;
  double Vgdov_Vsi_bi_Tempt_GND;
  double Vgdov_Vsi_bi_Vgm_si;
  double Vgdov_Vsi_bi_Vdbulk_di;
  double Vgdov_Vsi_bi_Vsbulk_si;
  double Vgdov_Vsi_bi_Vgi_bi;
  double Vgdov_Vsi_bi_Vdi_bi;
  double Vgdov_Vsi_bi_Vsi_bi;
  double Vgdov_Vdi_bi_Vgm_di;
  double Vgdov_Vdi_bi_Tempt_GND;
  double Vgdov_Vdi_bi_Vgm_si;
  double Vgdov_Vdi_bi_Vdbulk_di;
  double Vgdov_Vdi_bi_Vsbulk_si;
  double Vgdov_Vdi_bi_Vgi_bi;
  double Vgdov_Vdi_bi_Vdi_bi;
  double Vgdov_Vdi_bi_Vsi_bi;
  double Vgdov_Vgi_bi_Vgm_di;
  double Vgdov_Vgi_bi_Tempt_GND;
  double Vgdov_Vgi_bi_Vgm_si;
  double Vgdov_Vgi_bi_Vdbulk_di;
  double Vgdov_Vgi_bi_Vsbulk_si;
  double Vgdov_Vgi_bi_Vgi_bi;
  double Vgdov_Vgi_bi_Vdi_bi;
  double Vgdov_Vgi_bi_Vsi_bi;
  double Vgdov_Vsbulk_si_Vgm_di;
  double Vgdov_Vsbulk_si_Tempt_GND;
  double Vgdov_Vsbulk_si_Vgm_si;
  double Vgdov_Vsbulk_si_Vdbulk_di;
  double Vgdov_Vsbulk_si_Vsbulk_si;
  double Vgdov_Vsbulk_si_Vgi_bi;
  double Vgdov_Vsbulk_si_Vdi_bi;
  double Vgdov_Vsbulk_si_Vsi_bi;
  double Vgdov_Vdbulk_di_Vgm_di;
  double Vgdov_Vdbulk_di_Tempt_GND;
  double Vgdov_Vdbulk_di_Vgm_si;
  double Vgdov_Vdbulk_di_Vdbulk_di;
  double Vgdov_Vdbulk_di_Vsbulk_si;
  double Vgdov_Vdbulk_di_Vgi_bi;
  double Vgdov_Vdbulk_di_Vdi_bi;
  double Vgdov_Vdbulk_di_Vsi_bi;
  double Vgdov_Vgm_si_Vgm_di;
  double Vgdov_Vgm_si_Tempt_GND;
  double Vgdov_Vgm_si_Vgm_si;
  double Vgdov_Vgm_si_Vdbulk_di;
  double Vgdov_Vgm_si_Vsbulk_si;
  double Vgdov_Vgm_si_Vgi_bi;
  double Vgdov_Vgm_si_Vdi_bi;
  double Vgdov_Vgm_si_Vsi_bi;
  double Vgdov_Vgm_di_Vgm_di;
  double Vgdov_Vgm_di_Tempt_GND;
  double Vgdov_Vgm_di_Vgm_si;
  double Vgdov_Vgm_di_Vdbulk_di;
  double Vgdov_Vgm_di_Vsbulk_si;
  double Vgdov_Vgm_di_Vgi_bi;
  double Vgdov_Vgm_di_Vdi_bi;
  double Vgdov_Vgm_di_Vsi_bi;
#endif
#endif
double Vgsov;
#if defined(_DERIVATEFORDDX)
double Vgsov_Vgm_si;
double Vgsov_Tempt_GND;
double Vgsov_Vdbulk_di;
double Vgsov_Vsbulk_si;
double Vgsov_Vgi_bi;
double Vgsov_Vdi_bi;
double Vgsov_Vsi_bi;
#if defined(_DERIVATE2)
  double Vgsov_Vsi_bi_Vgm_si;
  double Vgsov_Vsi_bi_Tempt_GND;
  double Vgsov_Vsi_bi_Vdbulk_di;
  double Vgsov_Vsi_bi_Vsbulk_si;
  double Vgsov_Vsi_bi_Vgi_bi;
  double Vgsov_Vsi_bi_Vdi_bi;
  double Vgsov_Vsi_bi_Vsi_bi;
  double Vgsov_Vdi_bi_Vgm_si;
  double Vgsov_Vdi_bi_Tempt_GND;
  double Vgsov_Vdi_bi_Vdbulk_di;
  double Vgsov_Vdi_bi_Vsbulk_si;
  double Vgsov_Vdi_bi_Vgi_bi;
  double Vgsov_Vdi_bi_Vdi_bi;
  double Vgsov_Vdi_bi_Vsi_bi;
  double Vgsov_Vgi_bi_Vgm_si;
  double Vgsov_Vgi_bi_Tempt_GND;
  double Vgsov_Vgi_bi_Vdbulk_di;
  double Vgsov_Vgi_bi_Vsbulk_si;
  double Vgsov_Vgi_bi_Vgi_bi;
  double Vgsov_Vgi_bi_Vdi_bi;
  double Vgsov_Vgi_bi_Vsi_bi;
  double Vgsov_Vsbulk_si_Vgm_si;
  double Vgsov_Vsbulk_si_Tempt_GND;
  double Vgsov_Vsbulk_si_Vdbulk_di;
  double Vgsov_Vsbulk_si_Vsbulk_si;
  double Vgsov_Vsbulk_si_Vgi_bi;
  double Vgsov_Vsbulk_si_Vdi_bi;
  double Vgsov_Vsbulk_si_Vsi_bi;
  double Vgsov_Vdbulk_di_Vgm_si;
  double Vgsov_Vdbulk_di_Tempt_GND;
  double Vgsov_Vdbulk_di_Vdbulk_di;
  double Vgsov_Vdbulk_di_Vsbulk_si;
  double Vgsov_Vdbulk_di_Vgi_bi;
  double Vgsov_Vdbulk_di_Vdi_bi;
  double Vgsov_Vdbulk_di_Vsi_bi;
  double Vgsov_Vgm_si_Vgm_si;
  double Vgsov_Vgm_si_Tempt_GND;
  double Vgsov_Vgm_si_Vdbulk_di;
  double Vgsov_Vgm_si_Vsbulk_si;
  double Vgsov_Vgm_si_Vgi_bi;
  double Vgsov_Vgm_si_Vdi_bi;
  double Vgsov_Vgm_si_Vsi_bi;
#endif
#endif
#if defined(_DYNAMIC)
double Qovd;
#if defined(_DERIVATEFORDDX)
double Qovd_Tempt_GND;
double Qovd_Vgm_si;
double Qovd_Vdbulk_di;
double Qovd_Vsbulk_si;
double Qovd_Vgi_bi;
double Qovd_Vdi_bi;
double Qovd_Vsi_bi;
double Qovd_Vgm_di;
#if defined(_DERIVATE2)
  double Qovd_Vgm_di_Tempt_GND;
  double Qovd_Vgm_di_Vgm_si;
  double Qovd_Vgm_di_Vdbulk_di;
  double Qovd_Vgm_di_Vsbulk_si;
  double Qovd_Vgm_di_Vgi_bi;
  double Qovd_Vgm_di_Vdi_bi;
  double Qovd_Vgm_di_Vsi_bi;
  double Qovd_Vgm_di_Vgm_di;
  double Qovd_Vsi_bi_Tempt_GND;
  double Qovd_Vsi_bi_Vgm_si;
  double Qovd_Vsi_bi_Vdbulk_di;
  double Qovd_Vsi_bi_Vsbulk_si;
  double Qovd_Vsi_bi_Vgi_bi;
  double Qovd_Vsi_bi_Vdi_bi;
  double Qovd_Vsi_bi_Vsi_bi;
  double Qovd_Vsi_bi_Vgm_di;
  double Qovd_Vdi_bi_Tempt_GND;
  double Qovd_Vdi_bi_Vgm_si;
  double Qovd_Vdi_bi_Vdbulk_di;
  double Qovd_Vdi_bi_Vsbulk_si;
  double Qovd_Vdi_bi_Vgi_bi;
  double Qovd_Vdi_bi_Vdi_bi;
  double Qovd_Vdi_bi_Vsi_bi;
  double Qovd_Vdi_bi_Vgm_di;
  double Qovd_Vgi_bi_Tempt_GND;
  double Qovd_Vgi_bi_Vgm_si;
  double Qovd_Vgi_bi_Vdbulk_di;
  double Qovd_Vgi_bi_Vsbulk_si;
  double Qovd_Vgi_bi_Vgi_bi;
  double Qovd_Vgi_bi_Vdi_bi;
  double Qovd_Vgi_bi_Vsi_bi;
  double Qovd_Vgi_bi_Vgm_di;
  double Qovd_Vsbulk_si_Tempt_GND;
  double Qovd_Vsbulk_si_Vgm_si;
  double Qovd_Vsbulk_si_Vdbulk_di;
  double Qovd_Vsbulk_si_Vsbulk_si;
  double Qovd_Vsbulk_si_Vgi_bi;
  double Qovd_Vsbulk_si_Vdi_bi;
  double Qovd_Vsbulk_si_Vsi_bi;
  double Qovd_Vsbulk_si_Vgm_di;
  double Qovd_Vdbulk_di_Tempt_GND;
  double Qovd_Vdbulk_di_Vgm_si;
  double Qovd_Vdbulk_di_Vdbulk_di;
  double Qovd_Vdbulk_di_Vsbulk_si;
  double Qovd_Vdbulk_di_Vgi_bi;
  double Qovd_Vdbulk_di_Vdi_bi;
  double Qovd_Vdbulk_di_Vsi_bi;
  double Qovd_Vdbulk_di_Vgm_di;
  double Qovd_Vgm_si_Tempt_GND;
  double Qovd_Vgm_si_Vgm_si;
  double Qovd_Vgm_si_Vdbulk_di;
  double Qovd_Vgm_si_Vsbulk_si;
  double Qovd_Vgm_si_Vgi_bi;
  double Qovd_Vgm_si_Vdi_bi;
  double Qovd_Vgm_si_Vsi_bi;
  double Qovd_Vgm_si_Vgm_di;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qovs;
#if defined(_DERIVATEFORDDX)
double Qovs_Tempt_GND;
double Qovs_Vdbulk_di;
double Qovs_Vsbulk_si;
double Qovs_Vgi_bi;
double Qovs_Vdi_bi;
double Qovs_Vsi_bi;
double Qovs_Vgm_si;
#if defined(_DERIVATE2)
  double Qovs_Vgm_si_Tempt_GND;
  double Qovs_Vgm_si_Vdbulk_di;
  double Qovs_Vgm_si_Vsbulk_si;
  double Qovs_Vgm_si_Vgi_bi;
  double Qovs_Vgm_si_Vdi_bi;
  double Qovs_Vgm_si_Vsi_bi;
  double Qovs_Vgm_si_Vgm_si;
  double Qovs_Vsi_bi_Tempt_GND;
  double Qovs_Vsi_bi_Vdbulk_di;
  double Qovs_Vsi_bi_Vsbulk_si;
  double Qovs_Vsi_bi_Vgi_bi;
  double Qovs_Vsi_bi_Vdi_bi;
  double Qovs_Vsi_bi_Vsi_bi;
  double Qovs_Vsi_bi_Vgm_si;
  double Qovs_Vdi_bi_Tempt_GND;
  double Qovs_Vdi_bi_Vdbulk_di;
  double Qovs_Vdi_bi_Vsbulk_si;
  double Qovs_Vdi_bi_Vgi_bi;
  double Qovs_Vdi_bi_Vdi_bi;
  double Qovs_Vdi_bi_Vsi_bi;
  double Qovs_Vdi_bi_Vgm_si;
  double Qovs_Vgi_bi_Tempt_GND;
  double Qovs_Vgi_bi_Vdbulk_di;
  double Qovs_Vgi_bi_Vsbulk_si;
  double Qovs_Vgi_bi_Vgi_bi;
  double Qovs_Vgi_bi_Vdi_bi;
  double Qovs_Vgi_bi_Vsi_bi;
  double Qovs_Vgi_bi_Vgm_si;
  double Qovs_Vsbulk_si_Tempt_GND;
  double Qovs_Vsbulk_si_Vdbulk_di;
  double Qovs_Vsbulk_si_Vsbulk_si;
  double Qovs_Vsbulk_si_Vgi_bi;
  double Qovs_Vsbulk_si_Vdi_bi;
  double Qovs_Vsbulk_si_Vsi_bi;
  double Qovs_Vsbulk_si_Vgm_si;
  double Qovs_Vdbulk_di_Tempt_GND;
  double Qovs_Vdbulk_di_Vdbulk_di;
  double Qovs_Vdbulk_di_Vsbulk_si;
  double Qovs_Vdbulk_di_Vgi_bi;
  double Qovs_Vdbulk_di_Vdi_bi;
  double Qovs_Vdbulk_di_Vsi_bi;
  double Qovs_Vdbulk_di_Vgm_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Cgdof;
#endif
#if defined(_DYNAMIC)
double Cgsof;
#endif
#if defined(_DYNAMIC)
double QGi;
#if defined(_DERIVATEFORDDX)
double QGi_Tempt_GND;
double QGi_Vdbulk_di;
double QGi_Vsbulk_si;
double QGi_Vgi_bi;
double QGi_Vdi_bi;
double QGi_Vsi_bi;
#if defined(_DERIVATE2)
  double QGi_Vsi_bi_Tempt_GND;
  double QGi_Vsi_bi_Vdbulk_di;
  double QGi_Vsi_bi_Vsbulk_si;
  double QGi_Vsi_bi_Vgi_bi;
  double QGi_Vsi_bi_Vdi_bi;
  double QGi_Vsi_bi_Vsi_bi;
  double QGi_Vdi_bi_Tempt_GND;
  double QGi_Vdi_bi_Vdbulk_di;
  double QGi_Vdi_bi_Vsbulk_si;
  double QGi_Vdi_bi_Vgi_bi;
  double QGi_Vdi_bi_Vdi_bi;
  double QGi_Vdi_bi_Vsi_bi;
  double QGi_Vgi_bi_Tempt_GND;
  double QGi_Vgi_bi_Vdbulk_di;
  double QGi_Vgi_bi_Vsbulk_si;
  double QGi_Vgi_bi_Vgi_bi;
  double QGi_Vgi_bi_Vdi_bi;
  double QGi_Vgi_bi_Vsi_bi;
  double QGi_Vsbulk_si_Tempt_GND;
  double QGi_Vsbulk_si_Vdbulk_di;
  double QGi_Vsbulk_si_Vsbulk_si;
  double QGi_Vsbulk_si_Vgi_bi;
  double QGi_Vsbulk_si_Vdi_bi;
  double QGi_Vsbulk_si_Vsi_bi;
  double QGi_Vdbulk_di_Tempt_GND;
  double QGi_Vdbulk_di_Vdbulk_di;
  double QGi_Vdbulk_di_Vsbulk_si;
  double QGi_Vdbulk_di_Vgi_bi;
  double QGi_Vdbulk_di_Vdi_bi;
  double QGi_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double WLCOXVtinv;
#if defined(_DERIVATEFORDDX)
double WLCOXVtinv_Vdbulk_di;
double WLCOXVtinv_Vsbulk_si;
double WLCOXVtinv_Vgi_bi;
double WLCOXVtinv_Vdi_bi;
double WLCOXVtinv_Vsi_bi;
double WLCOXVtinv_Tempt_GND;
#if defined(_DERIVATE2)
  double WLCOXVtinv_Vsi_bi_Vdbulk_di;
  double WLCOXVtinv_Vsi_bi_Vsbulk_si;
  double WLCOXVtinv_Vsi_bi_Vgi_bi;
  double WLCOXVtinv_Vsi_bi_Vdi_bi;
  double WLCOXVtinv_Vsi_bi_Vsi_bi;
  double WLCOXVtinv_Vsi_bi_Tempt_GND;
  double WLCOXVtinv_Vdi_bi_Vdbulk_di;
  double WLCOXVtinv_Vdi_bi_Vsbulk_si;
  double WLCOXVtinv_Vdi_bi_Vgi_bi;
  double WLCOXVtinv_Vdi_bi_Vdi_bi;
  double WLCOXVtinv_Vdi_bi_Vsi_bi;
  double WLCOXVtinv_Vdi_bi_Tempt_GND;
  double WLCOXVtinv_Vgi_bi_Vdbulk_di;
  double WLCOXVtinv_Vgi_bi_Vsbulk_si;
  double WLCOXVtinv_Vgi_bi_Vgi_bi;
  double WLCOXVtinv_Vgi_bi_Vdi_bi;
  double WLCOXVtinv_Vgi_bi_Vsi_bi;
  double WLCOXVtinv_Vgi_bi_Tempt_GND;
  double WLCOXVtinv_Vsbulk_si_Vdbulk_di;
  double WLCOXVtinv_Vsbulk_si_Vsbulk_si;
  double WLCOXVtinv_Vsbulk_si_Vgi_bi;
  double WLCOXVtinv_Vsbulk_si_Vdi_bi;
  double WLCOXVtinv_Vsbulk_si_Vsi_bi;
  double WLCOXVtinv_Vsbulk_si_Tempt_GND;
  double WLCOXVtinv_Vdbulk_di_Vdbulk_di;
  double WLCOXVtinv_Vdbulk_di_Vsbulk_si;
  double WLCOXVtinv_Vdbulk_di_Vgi_bi;
  double WLCOXVtinv_Vdbulk_di_Vdi_bi;
  double WLCOXVtinv_Vdbulk_di_Vsi_bi;
  double WLCOXVtinv_Vdbulk_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double QBi;
#if defined(_DERIVATEFORDDX)
double QBi_Tempt_GND;
double QBi_Vdbulk_di;
double QBi_Vsbulk_si;
double QBi_Vgi_bi;
double QBi_Vdi_bi;
double QBi_Vsi_bi;
#if defined(_DERIVATE2)
  double QBi_Vsi_bi_Tempt_GND;
  double QBi_Vsi_bi_Vdbulk_di;
  double QBi_Vsi_bi_Vsbulk_si;
  double QBi_Vsi_bi_Vgi_bi;
  double QBi_Vsi_bi_Vdi_bi;
  double QBi_Vsi_bi_Vsi_bi;
  double QBi_Vdi_bi_Tempt_GND;
  double QBi_Vdi_bi_Vdbulk_di;
  double QBi_Vdi_bi_Vsbulk_si;
  double QBi_Vdi_bi_Vgi_bi;
  double QBi_Vdi_bi_Vdi_bi;
  double QBi_Vdi_bi_Vsi_bi;
  double QBi_Vgi_bi_Tempt_GND;
  double QBi_Vgi_bi_Vdbulk_di;
  double QBi_Vgi_bi_Vsbulk_si;
  double QBi_Vgi_bi_Vgi_bi;
  double QBi_Vgi_bi_Vdi_bi;
  double QBi_Vgi_bi_Vsi_bi;
  double QBi_Vsbulk_si_Tempt_GND;
  double QBi_Vsbulk_si_Vdbulk_di;
  double QBi_Vsbulk_si_Vsbulk_si;
  double QBi_Vsbulk_si_Vgi_bi;
  double QBi_Vsbulk_si_Vdi_bi;
  double QBi_Vsbulk_si_Vsi_bi;
  double QBi_Vdbulk_di_Tempt_GND;
  double QBi_Vdbulk_di_Vdbulk_di;
  double QBi_Vdbulk_di_Vsbulk_si;
  double QBi_Vdbulk_di_Vgi_bi;
  double QBi_Vdbulk_di_Vdi_bi;
  double QBi_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Coxeffinv;
#if defined(_DERIVATEFORDDX)
double Coxeffinv_Vdbulk_di;
double Coxeffinv_Vsbulk_si;
double Coxeffinv_Vgi_bi;
double Coxeffinv_Vdi_bi;
double Coxeffinv_Vsi_bi;
double Coxeffinv_Tempt_GND;
#if defined(_DERIVATE2)
  double Coxeffinv_Vsi_bi_Vdbulk_di;
  double Coxeffinv_Vsi_bi_Vsbulk_si;
  double Coxeffinv_Vsi_bi_Vgi_bi;
  double Coxeffinv_Vsi_bi_Vdi_bi;
  double Coxeffinv_Vsi_bi_Vsi_bi;
  double Coxeffinv_Vsi_bi_Tempt_GND;
  double Coxeffinv_Vdi_bi_Vdbulk_di;
  double Coxeffinv_Vdi_bi_Vsbulk_si;
  double Coxeffinv_Vdi_bi_Vgi_bi;
  double Coxeffinv_Vdi_bi_Vdi_bi;
  double Coxeffinv_Vdi_bi_Vsi_bi;
  double Coxeffinv_Vdi_bi_Tempt_GND;
  double Coxeffinv_Vgi_bi_Vdbulk_di;
  double Coxeffinv_Vgi_bi_Vsbulk_si;
  double Coxeffinv_Vgi_bi_Vgi_bi;
  double Coxeffinv_Vgi_bi_Vdi_bi;
  double Coxeffinv_Vgi_bi_Vsi_bi;
  double Coxeffinv_Vgi_bi_Tempt_GND;
  double Coxeffinv_Vsbulk_si_Vdbulk_di;
  double Coxeffinv_Vsbulk_si_Vsbulk_si;
  double Coxeffinv_Vsbulk_si_Vgi_bi;
  double Coxeffinv_Vsbulk_si_Vdi_bi;
  double Coxeffinv_Vsbulk_si_Vsi_bi;
  double Coxeffinv_Vsbulk_si_Tempt_GND;
  double Coxeffinv_Vdbulk_di_Vdbulk_di;
  double Coxeffinv_Vdbulk_di_Vsbulk_si;
  double Coxeffinv_Vdbulk_di_Vgi_bi;
  double Coxeffinv_Vdbulk_di_Vdi_bi;
  double Coxeffinv_Vdbulk_di_Vsi_bi;
  double Coxeffinv_Vdbulk_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double XDCinv;
#if defined(_DERIVATEFORDDX)
double XDCinv_Vdbulk_di;
double XDCinv_Vsbulk_si;
double XDCinv_Vgi_bi;
double XDCinv_Vdi_bi;
double XDCinv_Vsi_bi;
double XDCinv_Tempt_GND;
#if defined(_DERIVATE2)
  double XDCinv_Vsi_bi_Vdbulk_di;
  double XDCinv_Vsi_bi_Vsbulk_si;
  double XDCinv_Vsi_bi_Vgi_bi;
  double XDCinv_Vsi_bi_Vdi_bi;
  double XDCinv_Vsi_bi_Vsi_bi;
  double XDCinv_Vsi_bi_Tempt_GND;
  double XDCinv_Vdi_bi_Vdbulk_di;
  double XDCinv_Vdi_bi_Vsbulk_si;
  double XDCinv_Vdi_bi_Vgi_bi;
  double XDCinv_Vdi_bi_Vdi_bi;
  double XDCinv_Vdi_bi_Vsi_bi;
  double XDCinv_Vdi_bi_Tempt_GND;
  double XDCinv_Vgi_bi_Vdbulk_di;
  double XDCinv_Vgi_bi_Vsbulk_si;
  double XDCinv_Vgi_bi_Vgi_bi;
  double XDCinv_Vgi_bi_Vdi_bi;
  double XDCinv_Vgi_bi_Vsi_bi;
  double XDCinv_Vgi_bi_Tempt_GND;
  double XDCinv_Vsbulk_si_Vdbulk_di;
  double XDCinv_Vsbulk_si_Vsbulk_si;
  double XDCinv_Vsbulk_si_Vgi_bi;
  double XDCinv_Vsbulk_si_Vdi_bi;
  double XDCinv_Vsbulk_si_Vsi_bi;
  double XDCinv_Vsbulk_si_Tempt_GND;
  double XDCinv_Vdbulk_di_Vdbulk_di;
  double XDCinv_Vdbulk_di_Vsbulk_si;
  double XDCinv_Vdbulk_di_Vgi_bi;
  double XDCinv_Vdbulk_di_Vdi_bi;
  double XDCinv_Vdbulk_di_Vsi_bi;
  double XDCinv_Vdbulk_di_Tempt_GND;
#endif
#endif
#endif
double qiaCV;
#if defined(_DERIVATEFORDDX)
double qiaCV_Tempt_GND;
double qiaCV_Vdbulk_di;
double qiaCV_Vsbulk_si;
double qiaCV_Vgi_bi;
double qiaCV_Vdi_bi;
double qiaCV_Vsi_bi;
#if defined(_DERIVATE2)
  double qiaCV_Vsi_bi_Tempt_GND;
  double qiaCV_Vsi_bi_Vdbulk_di;
  double qiaCV_Vsi_bi_Vsbulk_si;
  double qiaCV_Vsi_bi_Vgi_bi;
  double qiaCV_Vsi_bi_Vdi_bi;
  double qiaCV_Vsi_bi_Vsi_bi;
  double qiaCV_Vdi_bi_Tempt_GND;
  double qiaCV_Vdi_bi_Vdbulk_di;
  double qiaCV_Vdi_bi_Vsbulk_si;
  double qiaCV_Vdi_bi_Vgi_bi;
  double qiaCV_Vdi_bi_Vdi_bi;
  double qiaCV_Vdi_bi_Vsi_bi;
  double qiaCV_Vgi_bi_Tempt_GND;
  double qiaCV_Vgi_bi_Vdbulk_di;
  double qiaCV_Vgi_bi_Vsbulk_si;
  double qiaCV_Vgi_bi_Vgi_bi;
  double qiaCV_Vgi_bi_Vdi_bi;
  double qiaCV_Vgi_bi_Vsi_bi;
  double qiaCV_Vsbulk_si_Tempt_GND;
  double qiaCV_Vsbulk_si_Vdbulk_di;
  double qiaCV_Vsbulk_si_Vsbulk_si;
  double qiaCV_Vsbulk_si_Vgi_bi;
  double qiaCV_Vsbulk_si_Vdi_bi;
  double qiaCV_Vsbulk_si_Vsi_bi;
  double qiaCV_Vdbulk_di_Tempt_GND;
  double qiaCV_Vdbulk_di_Vdbulk_di;
  double qiaCV_Vdbulk_di_Vsbulk_si;
  double qiaCV_Vdbulk_di_Vgi_bi;
  double qiaCV_Vdbulk_di_Vdi_bi;
  double qiaCV_Vdbulk_di_Vsi_bi;
#endif
#endif
double qbaCV;
#if defined(_DERIVATEFORDDX)
double qbaCV_Tempt_GND;
double qbaCV_Vdbulk_di;
double qbaCV_Vsbulk_si;
double qbaCV_Vgi_bi;
double qbaCV_Vdi_bi;
double qbaCV_Vsi_bi;
#if defined(_DERIVATE2)
  double qbaCV_Vsi_bi_Tempt_GND;
  double qbaCV_Vsi_bi_Vdbulk_di;
  double qbaCV_Vsi_bi_Vsbulk_si;
  double qbaCV_Vsi_bi_Vgi_bi;
  double qbaCV_Vsi_bi_Vdi_bi;
  double qbaCV_Vsi_bi_Vsi_bi;
  double qbaCV_Vdi_bi_Tempt_GND;
  double qbaCV_Vdi_bi_Vdbulk_di;
  double qbaCV_Vdi_bi_Vsbulk_si;
  double qbaCV_Vdi_bi_Vgi_bi;
  double qbaCV_Vdi_bi_Vdi_bi;
  double qbaCV_Vdi_bi_Vsi_bi;
  double qbaCV_Vgi_bi_Tempt_GND;
  double qbaCV_Vgi_bi_Vdbulk_di;
  double qbaCV_Vgi_bi_Vsbulk_si;
  double qbaCV_Vgi_bi_Vgi_bi;
  double qbaCV_Vgi_bi_Vdi_bi;
  double qbaCV_Vgi_bi_Vsi_bi;
  double qbaCV_Vsbulk_si_Tempt_GND;
  double qbaCV_Vsbulk_si_Vdbulk_di;
  double qbaCV_Vsbulk_si_Vsbulk_si;
  double qbaCV_Vsbulk_si_Vgi_bi;
  double qbaCV_Vsbulk_si_Vdi_bi;
  double qbaCV_Vsbulk_si_Vsi_bi;
  double qbaCV_Vdbulk_di_Tempt_GND;
  double qbaCV_Vdbulk_di_Vdbulk_di;
  double qbaCV_Vdbulk_di_Vsbulk_si;
  double qbaCV_Vdbulk_di_Vgi_bi;
  double qbaCV_Vdbulk_di_Vdi_bi;
  double qbaCV_Vdbulk_di_Vsi_bi;
#endif
#endif
double Qd2;
#if defined(_DERIVATEFORDDX)
double Qd2_Vdbulk_di;
double Qd2_Vsbulk_si;
double Qd2_Vgi_bi;
double Qd2_Tempt_GND;
double Qd2_Vdi_bi;
double Qd2_Vsi_bi;
#if defined(_DERIVATE2)
  double Qd2_Vsi_bi_Vdbulk_di;
  double Qd2_Vsi_bi_Vsbulk_si;
  double Qd2_Vsi_bi_Vgi_bi;
  double Qd2_Vsi_bi_Tempt_GND;
  double Qd2_Vsi_bi_Vdi_bi;
  double Qd2_Vsi_bi_Vsi_bi;
  double Qd2_Vdi_bi_Vdbulk_di;
  double Qd2_Vdi_bi_Vsbulk_si;
  double Qd2_Vdi_bi_Vgi_bi;
  double Qd2_Vdi_bi_Tempt_GND;
  double Qd2_Vdi_bi_Vdi_bi;
  double Qd2_Vdi_bi_Vsi_bi;
  double Qd2_Vgi_bi_Vdbulk_di;
  double Qd2_Vgi_bi_Vsbulk_si;
  double Qd2_Vgi_bi_Vgi_bi;
  double Qd2_Vgi_bi_Tempt_GND;
  double Qd2_Vgi_bi_Vdi_bi;
  double Qd2_Vgi_bi_Vsi_bi;
  double Qd2_Vsbulk_si_Vdbulk_di;
  double Qd2_Vsbulk_si_Vsbulk_si;
  double Qd2_Vsbulk_si_Vgi_bi;
  double Qd2_Vsbulk_si_Tempt_GND;
  double Qd2_Vsbulk_si_Vdi_bi;
  double Qd2_Vsbulk_si_Vsi_bi;
  double Qd2_Vdbulk_di_Vdbulk_di;
  double Qd2_Vdbulk_di_Vsbulk_si;
  double Qd2_Vdbulk_di_Vgi_bi;
  double Qd2_Vdbulk_di_Tempt_GND;
  double Qd2_Vdbulk_di_Vdi_bi;
  double Qd2_Vdbulk_di_Vsi_bi;
#endif
#endif
double Qd1;
#if defined(_DERIVATEFORDDX)
double Qd1_Vdbulk_di;
double Qd1_Vsbulk_si;
double Qd1_Vgi_bi;
double Qd1_Tempt_GND;
double Qd1_Vdi_bi;
double Qd1_Vsi_bi;
#if defined(_DERIVATE2)
  double Qd1_Vsi_bi_Vdbulk_di;
  double Qd1_Vsi_bi_Vsbulk_si;
  double Qd1_Vsi_bi_Vgi_bi;
  double Qd1_Vsi_bi_Tempt_GND;
  double Qd1_Vsi_bi_Vdi_bi;
  double Qd1_Vsi_bi_Vsi_bi;
  double Qd1_Vdi_bi_Vdbulk_di;
  double Qd1_Vdi_bi_Vsbulk_si;
  double Qd1_Vdi_bi_Vgi_bi;
  double Qd1_Vdi_bi_Tempt_GND;
  double Qd1_Vdi_bi_Vdi_bi;
  double Qd1_Vdi_bi_Vsi_bi;
  double Qd1_Vgi_bi_Vdbulk_di;
  double Qd1_Vgi_bi_Vsbulk_si;
  double Qd1_Vgi_bi_Vgi_bi;
  double Qd1_Vgi_bi_Tempt_GND;
  double Qd1_Vgi_bi_Vdi_bi;
  double Qd1_Vgi_bi_Vsi_bi;
  double Qd1_Vsbulk_si_Vdbulk_di;
  double Qd1_Vsbulk_si_Vsbulk_si;
  double Qd1_Vsbulk_si_Vgi_bi;
  double Qd1_Vsbulk_si_Tempt_GND;
  double Qd1_Vsbulk_si_Vdi_bi;
  double Qd1_Vsbulk_si_Vsi_bi;
  double Qd1_Vdbulk_di_Vdbulk_di;
  double Qd1_Vdbulk_di_Vsbulk_si;
  double Qd1_Vdbulk_di_Vgi_bi;
  double Qd1_Vdbulk_di_Tempt_GND;
  double Qd1_Vdbulk_di_Vdi_bi;
  double Qd1_Vdbulk_di_Vsi_bi;
#endif
#endif
double Qi;
#if defined(_DERIVATEFORDDX)
double Qi_Vdbulk_di;
double Qi_Vsbulk_si;
double Qi_Vgi_bi;
double Qi_Tempt_GND;
double Qi_Vdi_bi;
double Qi_Vsi_bi;
#if defined(_DERIVATE2)
  double Qi_Vsi_bi_Vdbulk_di;
  double Qi_Vsi_bi_Vsbulk_si;
  double Qi_Vsi_bi_Vgi_bi;
  double Qi_Vsi_bi_Tempt_GND;
  double Qi_Vsi_bi_Vdi_bi;
  double Qi_Vsi_bi_Vsi_bi;
  double Qi_Vdi_bi_Vdbulk_di;
  double Qi_Vdi_bi_Vsbulk_si;
  double Qi_Vdi_bi_Vgi_bi;
  double Qi_Vdi_bi_Tempt_GND;
  double Qi_Vdi_bi_Vdi_bi;
  double Qi_Vdi_bi_Vsi_bi;
  double Qi_Vgi_bi_Vdbulk_di;
  double Qi_Vgi_bi_Vsbulk_si;
  double Qi_Vgi_bi_Vgi_bi;
  double Qi_Vgi_bi_Tempt_GND;
  double Qi_Vgi_bi_Vdi_bi;
  double Qi_Vgi_bi_Vsi_bi;
  double Qi_Vsbulk_si_Vdbulk_di;
  double Qi_Vsbulk_si_Vsbulk_si;
  double Qi_Vsbulk_si_Vgi_bi;
  double Qi_Vsbulk_si_Tempt_GND;
  double Qi_Vsbulk_si_Vdi_bi;
  double Qi_Vsbulk_si_Vsi_bi;
  double Qi_Vdbulk_di_Vdbulk_di;
  double Qi_Vdbulk_di_Vsbulk_si;
  double Qi_Vdbulk_di_Vgi_bi;
  double Qi_Vdbulk_di_Tempt_GND;
  double Qi_Vdbulk_di_Vdi_bi;
  double Qi_Vdbulk_di_Vsi_bi;
#endif
#endif
double qbeff;
#if defined(_DERIVATEFORDDX)
double qbeff_Vgi_bi;
double qbeff_Vdi_bi;
double qbeff_Vsi_bi;
double qbeff_Tempt_GND;
double qbeff_Vdbulk_di;
double qbeff_Vsbulk_si;
#if defined(_DERIVATE2)
  double qbeff_Vsbulk_si_Vgi_bi;
  double qbeff_Vsbulk_si_Vdi_bi;
  double qbeff_Vsbulk_si_Vsi_bi;
  double qbeff_Vsbulk_si_Tempt_GND;
  double qbeff_Vsbulk_si_Vdbulk_di;
  double qbeff_Vsbulk_si_Vsbulk_si;
  double qbeff_Vdbulk_di_Vgi_bi;
  double qbeff_Vdbulk_di_Vdi_bi;
  double qbeff_Vdbulk_di_Vsi_bi;
  double qbeff_Vdbulk_di_Tempt_GND;
  double qbeff_Vdbulk_di_Vdbulk_di;
  double qbeff_Vdbulk_di_Vsbulk_si;
  double qbeff_Vsi_bi_Vgi_bi;
  double qbeff_Vsi_bi_Vdi_bi;
  double qbeff_Vsi_bi_Vsi_bi;
  double qbeff_Vsi_bi_Tempt_GND;
  double qbeff_Vsi_bi_Vdbulk_di;
  double qbeff_Vsi_bi_Vsbulk_si;
  double qbeff_Vdi_bi_Vgi_bi;
  double qbeff_Vdi_bi_Vdi_bi;
  double qbeff_Vdi_bi_Vsi_bi;
  double qbeff_Vdi_bi_Tempt_GND;
  double qbeff_Vdi_bi_Vdbulk_di;
  double qbeff_Vdi_bi_Vsbulk_si;
  double qbeff_Vgi_bi_Vgi_bi;
  double qbeff_Vgi_bi_Vdi_bi;
  double qbeff_Vgi_bi_Vsi_bi;
  double qbeff_Vgi_bi_Tempt_GND;
  double qbeff_Vgi_bi_Vdbulk_di;
  double qbeff_Vgi_bi_Vsbulk_si;
#endif
#endif
double dqgeff;
#if defined(_DERIVATEFORDDX)
double dqgeff_Vgi_bi;
double dqgeff_Vdi_bi;
double dqgeff_Vsi_bi;
double dqgeff_Tempt_GND;
double dqgeff_Vdbulk_di;
double dqgeff_Vsbulk_si;
#if defined(_DERIVATE2)
  double dqgeff_Vsbulk_si_Vgi_bi;
  double dqgeff_Vsbulk_si_Vdi_bi;
  double dqgeff_Vsbulk_si_Vsi_bi;
  double dqgeff_Vsbulk_si_Tempt_GND;
  double dqgeff_Vsbulk_si_Vdbulk_di;
  double dqgeff_Vsbulk_si_Vsbulk_si;
  double dqgeff_Vdbulk_di_Vgi_bi;
  double dqgeff_Vdbulk_di_Vdi_bi;
  double dqgeff_Vdbulk_di_Vsi_bi;
  double dqgeff_Vdbulk_di_Tempt_GND;
  double dqgeff_Vdbulk_di_Vdbulk_di;
  double dqgeff_Vdbulk_di_Vsbulk_si;
  double dqgeff_Vsi_bi_Vgi_bi;
  double dqgeff_Vsi_bi_Vdi_bi;
  double dqgeff_Vsi_bi_Vsi_bi;
  double dqgeff_Vsi_bi_Tempt_GND;
  double dqgeff_Vsi_bi_Vdbulk_di;
  double dqgeff_Vsi_bi_Vsbulk_si;
  double dqgeff_Vdi_bi_Vgi_bi;
  double dqgeff_Vdi_bi_Vdi_bi;
  double dqgeff_Vdi_bi_Vsi_bi;
  double dqgeff_Vdi_bi_Tempt_GND;
  double dqgeff_Vdi_bi_Vdbulk_di;
  double dqgeff_Vdi_bi_Vsbulk_si;
  double dqgeff_Vgi_bi_Vgi_bi;
  double dqgeff_Vgi_bi_Vdi_bi;
  double dqgeff_Vgi_bi_Vsi_bi;
  double dqgeff_Vgi_bi_Tempt_GND;
  double dqgeff_Vgi_bi_Vdbulk_di;
  double dqgeff_Vgi_bi_Vsbulk_si;
#endif
#endif
double Tempd;
#if defined(_DERIVATEFORDDX)
double Tempd_Vdbulk_di;
double Tempd_Vsbulk_si;
double Tempd_Vgi_bi;
double Tempd_Vdi_bi;
double Tempd_Vsi_bi;
double Tempd_Tempt_GND;
#if defined(_DERIVATE2)
  double Tempd_Vsi_bi_Vdbulk_di;
  double Tempd_Vsi_bi_Vsbulk_si;
  double Tempd_Vsi_bi_Vgi_bi;
  double Tempd_Vsi_bi_Vdi_bi;
  double Tempd_Vsi_bi_Vsi_bi;
  double Tempd_Vsi_bi_Tempt_GND;
  double Tempd_Vdi_bi_Vdbulk_di;
  double Tempd_Vdi_bi_Vsbulk_si;
  double Tempd_Vdi_bi_Vgi_bi;
  double Tempd_Vdi_bi_Vdi_bi;
  double Tempd_Vdi_bi_Vsi_bi;
  double Tempd_Vdi_bi_Tempt_GND;
  double Tempd_Vgi_bi_Vdbulk_di;
  double Tempd_Vgi_bi_Vsbulk_si;
  double Tempd_Vgi_bi_Vgi_bi;
  double Tempd_Vgi_bi_Vdi_bi;
  double Tempd_Vgi_bi_Vsi_bi;
  double Tempd_Vgi_bi_Tempt_GND;
  double Tempd_Vsbulk_si_Vdbulk_di;
  double Tempd_Vsbulk_si_Vsbulk_si;
  double Tempd_Vsbulk_si_Vgi_bi;
  double Tempd_Vsbulk_si_Vdi_bi;
  double Tempd_Vsbulk_si_Vsi_bi;
  double Tempd_Vsbulk_si_Tempt_GND;
  double Tempd_Vdbulk_di_Vdbulk_di;
  double Tempd_Vdbulk_di_Vsbulk_si;
  double Tempd_Vdbulk_di_Vgi_bi;
  double Tempd_Vdbulk_di_Vdi_bi;
  double Tempd_Vdbulk_di_Vsi_bi;
  double Tempd_Vdbulk_di_Tempt_GND;
#endif
#endif
double Temps;
#if defined(_DERIVATEFORDDX)
double Temps_Vdbulk_di;
double Temps_Vsbulk_si;
double Temps_Vgi_bi;
double Temps_Vdi_bi;
double Temps_Vsi_bi;
double Temps_Tempt_GND;
#if defined(_DERIVATE2)
  double Temps_Vsi_bi_Vdbulk_di;
  double Temps_Vsi_bi_Vsbulk_si;
  double Temps_Vsi_bi_Vgi_bi;
  double Temps_Vsi_bi_Vdi_bi;
  double Temps_Vsi_bi_Vsi_bi;
  double Temps_Vsi_bi_Tempt_GND;
  double Temps_Vdi_bi_Vdbulk_di;
  double Temps_Vdi_bi_Vsbulk_si;
  double Temps_Vdi_bi_Vgi_bi;
  double Temps_Vdi_bi_Vdi_bi;
  double Temps_Vdi_bi_Vsi_bi;
  double Temps_Vdi_bi_Tempt_GND;
  double Temps_Vgi_bi_Vdbulk_di;
  double Temps_Vgi_bi_Vsbulk_si;
  double Temps_Vgi_bi_Vgi_bi;
  double Temps_Vgi_bi_Vdi_bi;
  double Temps_Vgi_bi_Vsi_bi;
  double Temps_Vgi_bi_Tempt_GND;
  double Temps_Vsbulk_si_Vdbulk_di;
  double Temps_Vsbulk_si_Vsbulk_si;
  double Temps_Vsbulk_si_Vgi_bi;
  double Temps_Vsbulk_si_Vdi_bi;
  double Temps_Vsbulk_si_Vsi_bi;
  double Temps_Vsbulk_si_Tempt_GND;
  double Temps_Vdbulk_di_Vdbulk_di;
  double Temps_Vdbulk_di_Vsbulk_si;
  double Temps_Vdbulk_di_Vgi_bi;
  double Temps_Vdbulk_di_Vdi_bi;
  double Temps_Vdbulk_di_Vsi_bi;
  double Temps_Vdbulk_di_Tempt_GND;
#endif
#endif
double sid;
#if defined(_DERIVATEFORDDX)
double sid_Vgi_bi;
double sid_Vdi_bi;
double sid_Vsi_bi;
double sid_Tempt_GND;
double sid_Vdbulk_di;
double sid_Vsbulk_si;
#if defined(_DERIVATE2)
  double sid_Vsbulk_si_Vgi_bi;
  double sid_Vsbulk_si_Vdi_bi;
  double sid_Vsbulk_si_Vsi_bi;
  double sid_Vsbulk_si_Tempt_GND;
  double sid_Vsbulk_si_Vdbulk_di;
  double sid_Vsbulk_si_Vsbulk_si;
  double sid_Vdbulk_di_Vgi_bi;
  double sid_Vdbulk_di_Vdi_bi;
  double sid_Vdbulk_di_Vsi_bi;
  double sid_Vdbulk_di_Tempt_GND;
  double sid_Vdbulk_di_Vdbulk_di;
  double sid_Vdbulk_di_Vsbulk_si;
  double sid_Vsi_bi_Vgi_bi;
  double sid_Vsi_bi_Vdi_bi;
  double sid_Vsi_bi_Vsi_bi;
  double sid_Vsi_bi_Tempt_GND;
  double sid_Vsi_bi_Vdbulk_di;
  double sid_Vsi_bi_Vsbulk_si;
  double sid_Vdi_bi_Vgi_bi;
  double sid_Vdi_bi_Vdi_bi;
  double sid_Vdi_bi_Vsi_bi;
  double sid_Vdi_bi_Tempt_GND;
  double sid_Vdi_bi_Vdbulk_di;
  double sid_Vdi_bi_Vsbulk_si;
  double sid_Vgi_bi_Vgi_bi;
  double sid_Vgi_bi_Vdi_bi;
  double sid_Vgi_bi_Vsi_bi;
  double sid_Vgi_bi_Tempt_GND;
  double sid_Vgi_bi_Vdbulk_di;
  double sid_Vgi_bi_Vsbulk_si;
#endif
#endif
double sis;
#if defined(_DERIVATEFORDDX)
double sis_Vgi_bi;
double sis_Vdi_bi;
double sis_Vsi_bi;
double sis_Tempt_GND;
double sis_Vdbulk_di;
double sis_Vsbulk_si;
#if defined(_DERIVATE2)
  double sis_Vsbulk_si_Vgi_bi;
  double sis_Vsbulk_si_Vdi_bi;
  double sis_Vsbulk_si_Vsi_bi;
  double sis_Vsbulk_si_Tempt_GND;
  double sis_Vsbulk_si_Vdbulk_di;
  double sis_Vsbulk_si_Vsbulk_si;
  double sis_Vdbulk_di_Vgi_bi;
  double sis_Vdbulk_di_Vdi_bi;
  double sis_Vdbulk_di_Vsi_bi;
  double sis_Vdbulk_di_Tempt_GND;
  double sis_Vdbulk_di_Vdbulk_di;
  double sis_Vdbulk_di_Vsbulk_si;
  double sis_Vsi_bi_Vgi_bi;
  double sis_Vsi_bi_Vdi_bi;
  double sis_Vsi_bi_Vsi_bi;
  double sis_Vsi_bi_Tempt_GND;
  double sis_Vsi_bi_Vdbulk_di;
  double sis_Vsi_bi_Vsbulk_si;
  double sis_Vdi_bi_Vgi_bi;
  double sis_Vdi_bi_Vdi_bi;
  double sis_Vdi_bi_Vsi_bi;
  double sis_Vdi_bi_Tempt_GND;
  double sis_Vdi_bi_Vdbulk_di;
  double sis_Vdi_bi_Vsbulk_si;
  double sis_Vgi_bi_Vgi_bi;
  double sis_Vgi_bi_Vdi_bi;
  double sis_Vgi_bi_Vsi_bi;
  double sis_Vgi_bi_Tempt_GND;
  double sis_Vgi_bi_Vdbulk_di;
  double sis_Vgi_bi_Vsbulk_si;
#endif
#endif
double vgpqm;
#if defined(_DERIVATEFORDDX)
double vgpqm_Vgi_bi;
double vgpqm_Vdi_bi;
double vgpqm_Vsi_bi;
double vgpqm_Tempt_GND;
double vgpqm_Vdbulk_di;
double vgpqm_Vsbulk_si;
#if defined(_DERIVATE2)
  double vgpqm_Vsbulk_si_Vgi_bi;
  double vgpqm_Vsbulk_si_Vdi_bi;
  double vgpqm_Vsbulk_si_Vsi_bi;
  double vgpqm_Vsbulk_si_Tempt_GND;
  double vgpqm_Vsbulk_si_Vdbulk_di;
  double vgpqm_Vsbulk_si_Vsbulk_si;
  double vgpqm_Vdbulk_di_Vgi_bi;
  double vgpqm_Vdbulk_di_Vdi_bi;
  double vgpqm_Vdbulk_di_Vsi_bi;
  double vgpqm_Vdbulk_di_Tempt_GND;
  double vgpqm_Vdbulk_di_Vdbulk_di;
  double vgpqm_Vdbulk_di_Vsbulk_si;
  double vgpqm_Vsi_bi_Vgi_bi;
  double vgpqm_Vsi_bi_Vdi_bi;
  double vgpqm_Vsi_bi_Vsi_bi;
  double vgpqm_Vsi_bi_Tempt_GND;
  double vgpqm_Vsi_bi_Vdbulk_di;
  double vgpqm_Vsi_bi_Vsbulk_si;
  double vgpqm_Vdi_bi_Vgi_bi;
  double vgpqm_Vdi_bi_Vdi_bi;
  double vgpqm_Vdi_bi_Vsi_bi;
  double vgpqm_Vdi_bi_Tempt_GND;
  double vgpqm_Vdi_bi_Vdbulk_di;
  double vgpqm_Vdi_bi_Vsbulk_si;
  double vgpqm_Vgi_bi_Vgi_bi;
  double vgpqm_Vgi_bi_Vdi_bi;
  double vgpqm_Vgi_bi_Vsi_bi;
  double vgpqm_Vgi_bi_Tempt_GND;
  double vgpqm_Vgi_bi_Vdbulk_di;
  double vgpqm_Vgi_bi_Vsbulk_si;
#endif
#endif
double MdL_less_1;
#if defined(_DERIVATEFORDDX)
double MdL_less_1_Vdbulk_di;
double MdL_less_1_Vsbulk_si;
double MdL_less_1_Vgi_bi;
double MdL_less_1_Vdi_bi;
double MdL_less_1_Vsi_bi;
double MdL_less_1_Tempt_GND;
#if defined(_DERIVATE2)
  double MdL_less_1_Vsi_bi_Vdbulk_di;
  double MdL_less_1_Vsi_bi_Vsbulk_si;
  double MdL_less_1_Vsi_bi_Vgi_bi;
  double MdL_less_1_Vsi_bi_Vdi_bi;
  double MdL_less_1_Vsi_bi_Vsi_bi;
  double MdL_less_1_Vsi_bi_Tempt_GND;
  double MdL_less_1_Vdi_bi_Vdbulk_di;
  double MdL_less_1_Vdi_bi_Vsbulk_si;
  double MdL_less_1_Vdi_bi_Vgi_bi;
  double MdL_less_1_Vdi_bi_Vdi_bi;
  double MdL_less_1_Vdi_bi_Vsi_bi;
  double MdL_less_1_Vdi_bi_Tempt_GND;
  double MdL_less_1_Vgi_bi_Vdbulk_di;
  double MdL_less_1_Vgi_bi_Vsbulk_si;
  double MdL_less_1_Vgi_bi_Vgi_bi;
  double MdL_less_1_Vgi_bi_Vdi_bi;
  double MdL_less_1_Vgi_bi_Vsi_bi;
  double MdL_less_1_Vgi_bi_Tempt_GND;
  double MdL_less_1_Vsbulk_si_Vdbulk_di;
  double MdL_less_1_Vsbulk_si_Vsbulk_si;
  double MdL_less_1_Vsbulk_si_Vgi_bi;
  double MdL_less_1_Vsbulk_si_Vdi_bi;
  double MdL_less_1_Vsbulk_si_Vsi_bi;
  double MdL_less_1_Vsbulk_si_Tempt_GND;
  double MdL_less_1_Vdbulk_di_Vdbulk_di;
  double MdL_less_1_Vdbulk_di_Vsbulk_si;
  double MdL_less_1_Vdbulk_di_Vgi_bi;
  double MdL_less_1_Vdbulk_di_Vdi_bi;
  double MdL_less_1_Vdbulk_di_Vsi_bi;
  double MdL_less_1_Vdbulk_di_Tempt_GND;
#endif
#endif
double inv_MdL_2;
#if defined(_DERIVATEFORDDX)
double inv_MdL_2_Vdbulk_di;
double inv_MdL_2_Vsbulk_si;
double inv_MdL_2_Vgi_bi;
double inv_MdL_2_Vdi_bi;
double inv_MdL_2_Vsi_bi;
double inv_MdL_2_Tempt_GND;
#if defined(_DERIVATE2)
  double inv_MdL_2_Vsi_bi_Vdbulk_di;
  double inv_MdL_2_Vsi_bi_Vsbulk_si;
  double inv_MdL_2_Vsi_bi_Vgi_bi;
  double inv_MdL_2_Vsi_bi_Vdi_bi;
  double inv_MdL_2_Vsi_bi_Vsi_bi;
  double inv_MdL_2_Vsi_bi_Tempt_GND;
  double inv_MdL_2_Vdi_bi_Vdbulk_di;
  double inv_MdL_2_Vdi_bi_Vsbulk_si;
  double inv_MdL_2_Vdi_bi_Vgi_bi;
  double inv_MdL_2_Vdi_bi_Vdi_bi;
  double inv_MdL_2_Vdi_bi_Vsi_bi;
  double inv_MdL_2_Vdi_bi_Tempt_GND;
  double inv_MdL_2_Vgi_bi_Vdbulk_di;
  double inv_MdL_2_Vgi_bi_Vsbulk_si;
  double inv_MdL_2_Vgi_bi_Vgi_bi;
  double inv_MdL_2_Vgi_bi_Vdi_bi;
  double inv_MdL_2_Vgi_bi_Vsi_bi;
  double inv_MdL_2_Vgi_bi_Tempt_GND;
  double inv_MdL_2_Vsbulk_si_Vdbulk_di;
  double inv_MdL_2_Vsbulk_si_Vsbulk_si;
  double inv_MdL_2_Vsbulk_si_Vgi_bi;
  double inv_MdL_2_Vsbulk_si_Vdi_bi;
  double inv_MdL_2_Vsbulk_si_Vsi_bi;
  double inv_MdL_2_Vsbulk_si_Tempt_GND;
  double inv_MdL_2_Vdbulk_di_Vdbulk_di;
  double inv_MdL_2_Vdbulk_di_Vsbulk_si;
  double inv_MdL_2_Vdbulk_di_Vgi_bi;
  double inv_MdL_2_Vdbulk_di_Vdi_bi;
  double inv_MdL_2_Vdbulk_di_Vsi_bi;
  double inv_MdL_2_Vdbulk_di_Tempt_GND;
#endif
#endif
double inv_MdL;
#if defined(_DERIVATEFORDDX)
double inv_MdL_Vdbulk_di;
double inv_MdL_Vsbulk_si;
double inv_MdL_Vgi_bi;
double inv_MdL_Vdi_bi;
double inv_MdL_Vsi_bi;
double inv_MdL_Tempt_GND;
#if defined(_DERIVATE2)
  double inv_MdL_Vsi_bi_Vdbulk_di;
  double inv_MdL_Vsi_bi_Vsbulk_si;
  double inv_MdL_Vsi_bi_Vgi_bi;
  double inv_MdL_Vsi_bi_Vdi_bi;
  double inv_MdL_Vsi_bi_Vsi_bi;
  double inv_MdL_Vsi_bi_Tempt_GND;
  double inv_MdL_Vdi_bi_Vdbulk_di;
  double inv_MdL_Vdi_bi_Vsbulk_si;
  double inv_MdL_Vdi_bi_Vgi_bi;
  double inv_MdL_Vdi_bi_Vdi_bi;
  double inv_MdL_Vdi_bi_Vsi_bi;
  double inv_MdL_Vdi_bi_Tempt_GND;
  double inv_MdL_Vgi_bi_Vdbulk_di;
  double inv_MdL_Vgi_bi_Vsbulk_si;
  double inv_MdL_Vgi_bi_Vgi_bi;
  double inv_MdL_Vgi_bi_Vdi_bi;
  double inv_MdL_Vgi_bi_Vsi_bi;
  double inv_MdL_Vgi_bi_Tempt_GND;
  double inv_MdL_Vsbulk_si_Vdbulk_di;
  double inv_MdL_Vsbulk_si_Vsbulk_si;
  double inv_MdL_Vsbulk_si_Vgi_bi;
  double inv_MdL_Vsbulk_si_Vdi_bi;
  double inv_MdL_Vsbulk_si_Vsi_bi;
  double inv_MdL_Vsbulk_si_Tempt_GND;
  double inv_MdL_Vdbulk_di_Vdbulk_di;
  double inv_MdL_Vdbulk_di_Vsbulk_si;
  double inv_MdL_Vdbulk_di_Vgi_bi;
  double inv_MdL_Vdbulk_di_Vdi_bi;
  double inv_MdL_Vdbulk_di_Vsi_bi;
  double inv_MdL_Vdbulk_di_Tempt_GND;
#endif
#endif
double MdL_2;
#if defined(_DERIVATEFORDDX)
double MdL_2_Vdbulk_di;
double MdL_2_Vsbulk_si;
double MdL_2_Vgi_bi;
double MdL_2_Vdi_bi;
double MdL_2_Vsi_bi;
double MdL_2_Tempt_GND;
#if defined(_DERIVATE2)
  double MdL_2_Vsi_bi_Vdbulk_di;
  double MdL_2_Vsi_bi_Vsbulk_si;
  double MdL_2_Vsi_bi_Vgi_bi;
  double MdL_2_Vsi_bi_Vdi_bi;
  double MdL_2_Vsi_bi_Vsi_bi;
  double MdL_2_Vsi_bi_Tempt_GND;
  double MdL_2_Vdi_bi_Vdbulk_di;
  double MdL_2_Vdi_bi_Vsbulk_si;
  double MdL_2_Vdi_bi_Vgi_bi;
  double MdL_2_Vdi_bi_Vdi_bi;
  double MdL_2_Vdi_bi_Vsi_bi;
  double MdL_2_Vdi_bi_Tempt_GND;
  double MdL_2_Vgi_bi_Vdbulk_di;
  double MdL_2_Vgi_bi_Vsbulk_si;
  double MdL_2_Vgi_bi_Vgi_bi;
  double MdL_2_Vgi_bi_Vdi_bi;
  double MdL_2_Vgi_bi_Vsi_bi;
  double MdL_2_Vgi_bi_Tempt_GND;
  double MdL_2_Vsbulk_si_Vdbulk_di;
  double MdL_2_Vsbulk_si_Vsbulk_si;
  double MdL_2_Vsbulk_si_Vgi_bi;
  double MdL_2_Vsbulk_si_Vdi_bi;
  double MdL_2_Vsbulk_si_Vsi_bi;
  double MdL_2_Vsbulk_si_Tempt_GND;
  double MdL_2_Vdbulk_di_Vdbulk_di;
  double MdL_2_Vdbulk_di_Vsbulk_si;
  double MdL_2_Vdbulk_di_Vgi_bi;
  double MdL_2_Vdbulk_di_Vdi_bi;
  double MdL_2_Vdbulk_di_Vsi_bi;
  double MdL_2_Vdbulk_di_Tempt_GND;
#endif
#endif
double zsat;
#if defined(_DERIVATEFORDDX)
double zsat_Vdbulk_di;
double zsat_Vsbulk_si;
double zsat_Vgi_bi;
double zsat_Vdi_bi;
double zsat_Vsi_bi;
double zsat_Tempt_GND;
#if defined(_DERIVATE2)
  double zsat_Vsi_bi_Vdbulk_di;
  double zsat_Vsi_bi_Vsbulk_si;
  double zsat_Vsi_bi_Vgi_bi;
  double zsat_Vsi_bi_Vdi_bi;
  double zsat_Vsi_bi_Vsi_bi;
  double zsat_Vsi_bi_Tempt_GND;
  double zsat_Vdi_bi_Vdbulk_di;
  double zsat_Vdi_bi_Vsbulk_si;
  double zsat_Vdi_bi_Vgi_bi;
  double zsat_Vdi_bi_Vdi_bi;
  double zsat_Vdi_bi_Vsi_bi;
  double zsat_Vdi_bi_Tempt_GND;
  double zsat_Vgi_bi_Vdbulk_di;
  double zsat_Vgi_bi_Vsbulk_si;
  double zsat_Vgi_bi_Vgi_bi;
  double zsat_Vgi_bi_Vdi_bi;
  double zsat_Vgi_bi_Vsi_bi;
  double zsat_Vgi_bi_Tempt_GND;
  double zsat_Vsbulk_si_Vdbulk_di;
  double zsat_Vsbulk_si_Vsbulk_si;
  double zsat_Vsbulk_si_Vgi_bi;
  double zsat_Vsbulk_si_Vdi_bi;
  double zsat_Vsbulk_si_Vsi_bi;
  double zsat_Vsbulk_si_Tempt_GND;
  double zsat_Vdbulk_di_Vdbulk_di;
  double zsat_Vdbulk_di_Vsbulk_si;
  double zsat_Vdbulk_di_Vgi_bi;
  double zsat_Vdbulk_di_Vdi_bi;
  double zsat_Vdbulk_di_Vsi_bi;
  double zsat_Vdbulk_di_Tempt_GND;
#endif
#endif
double dps;
#if defined(_DERIVATEFORDDX)
double dps_Vdbulk_di;
double dps_Vsbulk_si;
double dps_Vgi_bi;
double dps_Vdi_bi;
double dps_Vsi_bi;
double dps_Tempt_GND;
#if defined(_DERIVATE2)
  double dps_Vsi_bi_Vdbulk_di;
  double dps_Vsi_bi_Vsbulk_si;
  double dps_Vsi_bi_Vgi_bi;
  double dps_Vsi_bi_Vdi_bi;
  double dps_Vsi_bi_Vsi_bi;
  double dps_Vsi_bi_Tempt_GND;
  double dps_Vdi_bi_Vdbulk_di;
  double dps_Vdi_bi_Vsbulk_si;
  double dps_Vdi_bi_Vgi_bi;
  double dps_Vdi_bi_Vdi_bi;
  double dps_Vdi_bi_Vsi_bi;
  double dps_Vdi_bi_Tempt_GND;
  double dps_Vgi_bi_Vdbulk_di;
  double dps_Vgi_bi_Vsbulk_si;
  double dps_Vgi_bi_Vgi_bi;
  double dps_Vgi_bi_Vdi_bi;
  double dps_Vgi_bi_Vsi_bi;
  double dps_Vgi_bi_Tempt_GND;
  double dps_Vsbulk_si_Vdbulk_di;
  double dps_Vsbulk_si_Vsbulk_si;
  double dps_Vsbulk_si_Vgi_bi;
  double dps_Vsbulk_si_Vdi_bi;
  double dps_Vsbulk_si_Vsi_bi;
  double dps_Vsbulk_si_Tempt_GND;
  double dps_Vdbulk_di_Vdbulk_di;
  double dps_Vdbulk_di_Vsbulk_si;
  double dps_Vdbulk_di_Vgi_bi;
  double dps_Vdbulk_di_Vdi_bi;
  double dps_Vdbulk_di_Vsi_bi;
  double dps_Vdbulk_di_Tempt_GND;
#endif
#endif
double qb;
#if defined(_DERIVATEFORDDX)
double qb_Vdbulk_di;
double qb_Vsbulk_si;
double qb_Vgi_bi;
double qb_Vdi_bi;
double qb_Vsi_bi;
double qb_Tempt_GND;
#if defined(_DERIVATE2)
  double qb_Vsi_bi_Vdbulk_di;
  double qb_Vsi_bi_Vsbulk_si;
  double qb_Vsi_bi_Vgi_bi;
  double qb_Vsi_bi_Vdi_bi;
  double qb_Vsi_bi_Vsi_bi;
  double qb_Vsi_bi_Tempt_GND;
  double qb_Vdi_bi_Vdbulk_di;
  double qb_Vdi_bi_Vsbulk_si;
  double qb_Vdi_bi_Vgi_bi;
  double qb_Vdi_bi_Vdi_bi;
  double qb_Vdi_bi_Vsi_bi;
  double qb_Vdi_bi_Tempt_GND;
  double qb_Vgi_bi_Vdbulk_di;
  double qb_Vgi_bi_Vsbulk_si;
  double qb_Vgi_bi_Vgi_bi;
  double qb_Vgi_bi_Vdi_bi;
  double qb_Vgi_bi_Vsi_bi;
  double qb_Vgi_bi_Tempt_GND;
  double qb_Vsbulk_si_Vdbulk_di;
  double qb_Vsbulk_si_Vsbulk_si;
  double qb_Vsbulk_si_Vgi_bi;
  double qb_Vsbulk_si_Vdi_bi;
  double qb_Vsbulk_si_Vsi_bi;
  double qb_Vsbulk_si_Tempt_GND;
  double qb_Vdbulk_di_Vdbulk_di;
  double qb_Vdbulk_di_Vsbulk_si;
  double qb_Vdbulk_di_Vgi_bi;
  double qb_Vdbulk_di_Vdi_bi;
  double qb_Vdbulk_di_Vsi_bi;
  double qb_Vdbulk_di_Tempt_GND;
#endif
#endif
double qbd;
#if defined(_DERIVATEFORDDX)
double qbd_Vdbulk_di;
double qbd_Vsbulk_si;
double qbd_Vgi_bi;
double qbd_Vdi_bi;
double qbd_Vsi_bi;
double qbd_Tempt_GND;
#if defined(_DERIVATE2)
  double qbd_Vsi_bi_Vdbulk_di;
  double qbd_Vsi_bi_Vsbulk_si;
  double qbd_Vsi_bi_Vgi_bi;
  double qbd_Vsi_bi_Vdi_bi;
  double qbd_Vsi_bi_Vsi_bi;
  double qbd_Vsi_bi_Tempt_GND;
  double qbd_Vdi_bi_Vdbulk_di;
  double qbd_Vdi_bi_Vsbulk_si;
  double qbd_Vdi_bi_Vgi_bi;
  double qbd_Vdi_bi_Vdi_bi;
  double qbd_Vdi_bi_Vsi_bi;
  double qbd_Vdi_bi_Tempt_GND;
  double qbd_Vgi_bi_Vdbulk_di;
  double qbd_Vgi_bi_Vsbulk_si;
  double qbd_Vgi_bi_Vgi_bi;
  double qbd_Vgi_bi_Vdi_bi;
  double qbd_Vgi_bi_Vsi_bi;
  double qbd_Vgi_bi_Tempt_GND;
  double qbd_Vsbulk_si_Vdbulk_di;
  double qbd_Vsbulk_si_Vsbulk_si;
  double qbd_Vsbulk_si_Vgi_bi;
  double qbd_Vsbulk_si_Vdi_bi;
  double qbd_Vsbulk_si_Vsi_bi;
  double qbd_Vsbulk_si_Tempt_GND;
  double qbd_Vdbulk_di_Vdbulk_di;
  double qbd_Vdbulk_di_Vsbulk_si;
  double qbd_Vdbulk_di_Vgi_bi;
  double qbd_Vdbulk_di_Vdi_bi;
  double qbd_Vdbulk_di_Vsi_bi;
  double qbd_Vdbulk_di_Tempt_GND;
#endif
#endif
double VdssatCV;
#if defined(_DERIVATEFORDDX)
double VdssatCV_Vdbulk_di;
double VdssatCV_Vsbulk_si;
double VdssatCV_Vgi_bi;
double VdssatCV_Vdi_bi;
double VdssatCV_Vsi_bi;
double VdssatCV_Tempt_GND;
#if defined(_DERIVATE2)
  double VdssatCV_Vsi_bi_Vdbulk_di;
  double VdssatCV_Vsi_bi_Vsbulk_si;
  double VdssatCV_Vsi_bi_Vgi_bi;
  double VdssatCV_Vsi_bi_Vdi_bi;
  double VdssatCV_Vsi_bi_Vsi_bi;
  double VdssatCV_Vsi_bi_Tempt_GND;
  double VdssatCV_Vdi_bi_Vdbulk_di;
  double VdssatCV_Vdi_bi_Vsbulk_si;
  double VdssatCV_Vdi_bi_Vgi_bi;
  double VdssatCV_Vdi_bi_Vdi_bi;
  double VdssatCV_Vdi_bi_Vsi_bi;
  double VdssatCV_Vdi_bi_Tempt_GND;
  double VdssatCV_Vgi_bi_Vdbulk_di;
  double VdssatCV_Vgi_bi_Vsbulk_si;
  double VdssatCV_Vgi_bi_Vgi_bi;
  double VdssatCV_Vgi_bi_Vdi_bi;
  double VdssatCV_Vgi_bi_Vsi_bi;
  double VdssatCV_Vgi_bi_Tempt_GND;
  double VdssatCV_Vsbulk_si_Vdbulk_di;
  double VdssatCV_Vsbulk_si_Vsbulk_si;
  double VdssatCV_Vsbulk_si_Vgi_bi;
  double VdssatCV_Vsbulk_si_Vdi_bi;
  double VdssatCV_Vsbulk_si_Vsi_bi;
  double VdssatCV_Vsbulk_si_Tempt_GND;
  double VdssatCV_Vdbulk_di_Vdbulk_di;
  double VdssatCV_Vdbulk_di_Vsbulk_si;
  double VdssatCV_Vdbulk_di_Vgi_bi;
  double VdssatCV_Vdbulk_di_Vdi_bi;
  double VdssatCV_Vdbulk_di_Vsi_bi;
  double VdssatCV_Vdbulk_di_Tempt_GND;
#endif
#endif
double VdsatCV;
#if defined(_DERIVATEFORDDX)
double VdsatCV_Vdbulk_di;
double VdsatCV_Vsbulk_si;
double VdsatCV_Vgi_bi;
double VdsatCV_Vdi_bi;
double VdsatCV_Vsi_bi;
double VdsatCV_Tempt_GND;
#if defined(_DERIVATE2)
  double VdsatCV_Vsi_bi_Vdbulk_di;
  double VdsatCV_Vsi_bi_Vsbulk_si;
  double VdsatCV_Vsi_bi_Vgi_bi;
  double VdsatCV_Vsi_bi_Vdi_bi;
  double VdsatCV_Vsi_bi_Vsi_bi;
  double VdsatCV_Vsi_bi_Tempt_GND;
  double VdsatCV_Vdi_bi_Vdbulk_di;
  double VdsatCV_Vdi_bi_Vsbulk_si;
  double VdsatCV_Vdi_bi_Vgi_bi;
  double VdsatCV_Vdi_bi_Vdi_bi;
  double VdsatCV_Vdi_bi_Vsi_bi;
  double VdsatCV_Vdi_bi_Tempt_GND;
  double VdsatCV_Vgi_bi_Vdbulk_di;
  double VdsatCV_Vgi_bi_Vsbulk_si;
  double VdsatCV_Vgi_bi_Vgi_bi;
  double VdsatCV_Vgi_bi_Vdi_bi;
  double VdsatCV_Vgi_bi_Vsi_bi;
  double VdsatCV_Vgi_bi_Tempt_GND;
  double VdsatCV_Vsbulk_si_Vdbulk_di;
  double VdsatCV_Vsbulk_si_Vsbulk_si;
  double VdsatCV_Vsbulk_si_Vgi_bi;
  double VdsatCV_Vsbulk_si_Vdi_bi;
  double VdsatCV_Vsbulk_si_Vsi_bi;
  double VdsatCV_Vsbulk_si_Tempt_GND;
  double VdsatCV_Vdbulk_di_Vdbulk_di;
  double VdsatCV_Vdbulk_di_Vsbulk_si;
  double VdsatCV_Vdbulk_di_Vgi_bi;
  double VdsatCV_Vdbulk_di_Vdi_bi;
  double VdsatCV_Vdbulk_di_Vsi_bi;
  double VdsatCV_Vdbulk_di_Tempt_GND;
#endif
#endif
double vdsatcv;
#if defined(_DERIVATEFORDDX)
double vdsatcv_Vdbulk_di;
double vdsatcv_Vsbulk_si;
double vdsatcv_Vgi_bi;
double vdsatcv_Vdi_bi;
double vdsatcv_Vsi_bi;
double vdsatcv_Tempt_GND;
#if defined(_DERIVATE2)
  double vdsatcv_Vsi_bi_Vdbulk_di;
  double vdsatcv_Vsi_bi_Vsbulk_si;
  double vdsatcv_Vsi_bi_Vgi_bi;
  double vdsatcv_Vsi_bi_Vdi_bi;
  double vdsatcv_Vsi_bi_Vsi_bi;
  double vdsatcv_Vsi_bi_Tempt_GND;
  double vdsatcv_Vdi_bi_Vdbulk_di;
  double vdsatcv_Vdi_bi_Vsbulk_si;
  double vdsatcv_Vdi_bi_Vgi_bi;
  double vdsatcv_Vdi_bi_Vdi_bi;
  double vdsatcv_Vdi_bi_Vsi_bi;
  double vdsatcv_Vdi_bi_Tempt_GND;
  double vdsatcv_Vgi_bi_Vdbulk_di;
  double vdsatcv_Vgi_bi_Vsbulk_si;
  double vdsatcv_Vgi_bi_Vgi_bi;
  double vdsatcv_Vgi_bi_Vdi_bi;
  double vdsatcv_Vgi_bi_Vsi_bi;
  double vdsatcv_Vgi_bi_Tempt_GND;
  double vdsatcv_Vsbulk_si_Vdbulk_di;
  double vdsatcv_Vsbulk_si_Vsbulk_si;
  double vdsatcv_Vsbulk_si_Vgi_bi;
  double vdsatcv_Vsbulk_si_Vdi_bi;
  double vdsatcv_Vsbulk_si_Vsi_bi;
  double vdsatcv_Vsbulk_si_Tempt_GND;
  double vdsatcv_Vdbulk_di_Vdbulk_di;
  double vdsatcv_Vdbulk_di_Vsbulk_si;
  double vdsatcv_Vdbulk_di_Vgi_bi;
  double vdsatcv_Vdbulk_di_Vdi_bi;
  double vdsatcv_Vdbulk_di_Vsi_bi;
  double vdsatcv_Vdbulk_di_Tempt_GND;
#endif
#endif
double LambdaC_by2;
#if defined(_DERIVATEFORDDX)
double LambdaC_by2_Tempt_GND;
double LambdaC_by2_Vdi_bi;
double LambdaC_by2_Vsi_bi;
double LambdaC_by2_Vdbulk_di;
double LambdaC_by2_Vsbulk_si;
double LambdaC_by2_Vgi_bi;
#if defined(_DERIVATE2)
  double LambdaC_by2_Vgi_bi_Tempt_GND;
  double LambdaC_by2_Vgi_bi_Vdi_bi;
  double LambdaC_by2_Vgi_bi_Vsi_bi;
  double LambdaC_by2_Vgi_bi_Vdbulk_di;
  double LambdaC_by2_Vgi_bi_Vsbulk_si;
  double LambdaC_by2_Vgi_bi_Vgi_bi;
  double LambdaC_by2_Vsbulk_si_Tempt_GND;
  double LambdaC_by2_Vsbulk_si_Vdi_bi;
  double LambdaC_by2_Vsbulk_si_Vsi_bi;
  double LambdaC_by2_Vsbulk_si_Vdbulk_di;
  double LambdaC_by2_Vsbulk_si_Vsbulk_si;
  double LambdaC_by2_Vsbulk_si_Vgi_bi;
  double LambdaC_by2_Vdbulk_di_Tempt_GND;
  double LambdaC_by2_Vdbulk_di_Vdi_bi;
  double LambdaC_by2_Vdbulk_di_Vsi_bi;
  double LambdaC_by2_Vdbulk_di_Vdbulk_di;
  double LambdaC_by2_Vdbulk_di_Vsbulk_si;
  double LambdaC_by2_Vdbulk_di_Vgi_bi;
  double LambdaC_by2_Vsi_bi_Tempt_GND;
  double LambdaC_by2_Vsi_bi_Vdi_bi;
  double LambdaC_by2_Vsi_bi_Vsi_bi;
  double LambdaC_by2_Vsi_bi_Vdbulk_di;
  double LambdaC_by2_Vsi_bi_Vsbulk_si;
  double LambdaC_by2_Vsi_bi_Vgi_bi;
  double LambdaC_by2_Vdi_bi_Tempt_GND;
  double LambdaC_by2_Vdi_bi_Vdi_bi;
  double LambdaC_by2_Vdi_bi_Vsi_bi;
  double LambdaC_by2_Vdi_bi_Vdbulk_di;
  double LambdaC_by2_Vdi_bi_Vsbulk_si;
  double LambdaC_by2_Vdi_bi_Vgi_bi;
#endif
#endif
double DPD;
double invgamg2;
#if defined(_DERIVATE)
double invgamg2_Tempt_GND;
#endif
double gamg2;
#if defined(_DERIVATE)
double gamg2_Tempt_GND;
#endif
double vgfbCV;
#if defined(_DERIVATEFORDDX)
double vgfbCV_Vgi_bi;
double vgfbCV_Vdi_bi;
double vgfbCV_Vsi_bi;
double vgfbCV_Tempt_GND;
#if defined(_DERIVATE2)
  double vgfbCV_Vsi_bi_Vgi_bi;
  double vgfbCV_Vsi_bi_Vdi_bi;
  double vgfbCV_Vsi_bi_Vsi_bi;
  double vgfbCV_Vsi_bi_Tempt_GND;
  double vgfbCV_Vdi_bi_Vgi_bi;
  double vgfbCV_Vdi_bi_Vdi_bi;
  double vgfbCV_Vdi_bi_Vsi_bi;
  double vgfbCV_Vdi_bi_Tempt_GND;
  double vgfbCV_Vgi_bi_Vgi_bi;
  double vgfbCV_Vgi_bi_Vdi_bi;
  double vgfbCV_Vgi_bi_Vsi_bi;
  double vgfbCV_Vgi_bi_Tempt_GND;
#endif
#endif
double sqig;
#if defined(_DERIVATE)
double sqig_Tempt_GND;
double sqig_Vgi_bi;
double sqig_Vdi_bi;
double sqig_Vsi_bi;
double sqig_Vdbulk_di;
double sqig_Vsbulk_si;
#endif
double sqid;
#if defined(_DERIVATE)
double sqid_Tempt_GND;
double sqid_Vdbulk_di;
double sqid_Vsbulk_si;
double sqid_Vgi_bi;
double sqid_Vdi_bi;
double sqid_Vsi_bi;
#endif
double migid;
#if defined(_DERIVATE)
double migid_Vdbulk_di;
double migid_Vsbulk_si;
double migid_Vgi_bi;
double migid_Vdi_bi;
double migid_Vsi_bi;
double migid_Tempt_GND;
#endif
double mig;
#if defined(_DERIVATE)
double mig_Vgi_bi;
double mig_Vdi_bi;
double mig_Vsi_bi;
double mig_Tempt_GND;
double mig_Vdbulk_di;
double mig_Vsbulk_si;
#endif
double mid;
#if defined(_DERIVATE)
double mid_Vdbulk_di;
double mid_Vsbulk_si;
double mid_Vgi_bi;
double mid_Vdi_bi;
double mid_Vsi_bi;
double mid_Tempt_GND;
#endif
double Lvsat;
#if defined(_DERIVATEFORDDX)
double Lvsat_Vgi_bi;
double Lvsat_Vdi_bi;
double Lvsat_Vsi_bi;
double Lvsat_Tempt_GND;
#if defined(_DERIVATE2)
  double Lvsat_Vsi_bi_Vgi_bi;
  double Lvsat_Vsi_bi_Vdi_bi;
  double Lvsat_Vsi_bi_Vsi_bi;
  double Lvsat_Vsi_bi_Tempt_GND;
  double Lvsat_Vdi_bi_Vgi_bi;
  double Lvsat_Vdi_bi_Vdi_bi;
  double Lvsat_Vdi_bi_Vsi_bi;
  double Lvsat_Vdi_bi_Tempt_GND;
  double Lvsat_Vgi_bi_Vgi_bi;
  double Lvsat_Vgi_bi_Vdi_bi;
  double Lvsat_Vgi_bi_Vsi_bi;
  double Lvsat_Vgi_bi_Tempt_GND;
#endif
#endif
double Vtn;
#if defined(_DERIVATEFORDDX)
double Vtn_Vgi_bi;
double Vtn_Tempt_GND;
double Vtn_Vdi_bi;
double Vtn_Vsi_bi;
#if defined(_DERIVATE2)
  double Vtn_Vsi_bi_Vgi_bi;
  double Vtn_Vsi_bi_Tempt_GND;
  double Vtn_Vsi_bi_Vdi_bi;
  double Vtn_Vsi_bi_Vsi_bi;
  double Vtn_Vdi_bi_Vgi_bi;
  double Vtn_Vdi_bi_Tempt_GND;
  double Vtn_Vdi_bi_Vdi_bi;
  double Vtn_Vdi_bi_Vsi_bi;
  double Vtn_Vgi_bi_Vgi_bi;
  double Vtn_Vgi_bi_Tempt_GND;
  double Vtn_Vgi_bi_Vdi_bi;
  double Vtn_Vgi_bi_Vsi_bi;
#endif
#endif
double sidn;
#if defined(_DERIVATE)
double sidn_Tempt_GND;
double sidn_Vdbulk_di;
double sidn_Vsbulk_si;
double sidn_Vgi_bi;
double sidn_Vdi_bi;
double sidn_Vsi_bi;
#endif
double Gtnoi;
#if defined(_DERIVATE)
double Gtnoi_Vdbulk_di;
double Gtnoi_Vsbulk_si;
double Gtnoi_Vgi_bi;
double Gtnoi_Vdi_bi;
double Gtnoi_Vsi_bi;
double Gtnoi_Tempt_GND;
#endif
double QDi;
#if defined(_DERIVATEFORDDX)
double QDi_Vdbulk_di;
double QDi_Vsbulk_si;
double QDi_Tempt_GND;
double QDi_Vgi_bi;
double QDi_Vdi_bi;
double QDi_Vsi_bi;
#if defined(_DERIVATE2)
  double QDi_Vsi_bi_Vdbulk_di;
  double QDi_Vsi_bi_Vsbulk_si;
  double QDi_Vsi_bi_Tempt_GND;
  double QDi_Vsi_bi_Vgi_bi;
  double QDi_Vsi_bi_Vdi_bi;
  double QDi_Vsi_bi_Vsi_bi;
  double QDi_Vdi_bi_Vdbulk_di;
  double QDi_Vdi_bi_Vsbulk_si;
  double QDi_Vdi_bi_Tempt_GND;
  double QDi_Vdi_bi_Vgi_bi;
  double QDi_Vdi_bi_Vdi_bi;
  double QDi_Vdi_bi_Vsi_bi;
  double QDi_Vgi_bi_Vdbulk_di;
  double QDi_Vgi_bi_Vsbulk_si;
  double QDi_Vgi_bi_Tempt_GND;
  double QDi_Vgi_bi_Vgi_bi;
  double QDi_Vgi_bi_Vdi_bi;
  double QDi_Vgi_bi_Vsi_bi;
  double QDi_Vsbulk_si_Vdbulk_di;
  double QDi_Vsbulk_si_Vsbulk_si;
  double QDi_Vsbulk_si_Tempt_GND;
  double QDi_Vsbulk_si_Vgi_bi;
  double QDi_Vsbulk_si_Vdi_bi;
  double QDi_Vsbulk_si_Vsi_bi;
  double QDi_Vdbulk_di_Vdbulk_di;
  double QDi_Vdbulk_di_Vsbulk_si;
  double QDi_Vdbulk_di_Tempt_GND;
  double QDi_Vdbulk_di_Vgi_bi;
  double QDi_Vdbulk_di_Vdi_bi;
  double QDi_Vdbulk_di_Vsi_bi;
#endif
#endif
double QSi;
#if defined(_DERIVATEFORDDX)
double QSi_Vdbulk_di;
double QSi_Vsbulk_si;
double QSi_Tempt_GND;
double QSi_Vgi_bi;
double QSi_Vdi_bi;
double QSi_Vsi_bi;
#if defined(_DERIVATE2)
  double QSi_Vsi_bi_Vdbulk_di;
  double QSi_Vsi_bi_Vsbulk_si;
  double QSi_Vsi_bi_Tempt_GND;
  double QSi_Vsi_bi_Vgi_bi;
  double QSi_Vsi_bi_Vdi_bi;
  double QSi_Vsi_bi_Vsi_bi;
  double QSi_Vdi_bi_Vdbulk_di;
  double QSi_Vdi_bi_Vsbulk_si;
  double QSi_Vdi_bi_Tempt_GND;
  double QSi_Vdi_bi_Vgi_bi;
  double QSi_Vdi_bi_Vdi_bi;
  double QSi_Vdi_bi_Vsi_bi;
  double QSi_Vgi_bi_Vdbulk_di;
  double QSi_Vgi_bi_Vsbulk_si;
  double QSi_Vgi_bi_Tempt_GND;
  double QSi_Vgi_bi_Vgi_bi;
  double QSi_Vgi_bi_Vdi_bi;
  double QSi_Vgi_bi_Vsi_bi;
  double QSi_Vsbulk_si_Vdbulk_di;
  double QSi_Vsbulk_si_Vsbulk_si;
  double QSi_Vsbulk_si_Tempt_GND;
  double QSi_Vsbulk_si_Vgi_bi;
  double QSi_Vsbulk_si_Vdi_bi;
  double QSi_Vsbulk_si_Vsi_bi;
  double QSi_Vdbulk_di_Vdbulk_di;
  double QSi_Vdbulk_di_Vsbulk_si;
  double QSi_Vdbulk_di_Tempt_GND;
  double QSi_Vdbulk_di_Vgi_bi;
  double QSi_Vdbulk_di_Vdi_bi;
  double QSi_Vdbulk_di_Vsi_bi;
#endif
#endif
double cm_igid;
#if defined(_DERIVATE)
double cm_igid_Vdbulk_di;
double cm_igid_Vsbulk_si;
double cm_igid_Vgi_bi;
double cm_igid_Vdi_bi;
double cm_igid_Vsi_bi;
double cm_igid_Tempt_GND;
#endif
double thetanoisq;
#if defined(_DERIVATE)
double thetanoisq_Vdbulk_di;
double thetanoisq_Vsbulk_si;
double thetanoisq_Vgi_bi;
double thetanoisq_Vdi_bi;
double thetanoisq_Vsi_bi;
double thetanoisq_Tempt_GND;
#endif
double betaLowId;
#if defined(_DERIVATE)
double betaLowId_Vdbulk_di;
double betaLowId_Vsbulk_si;
double betaLowId_Vgi_bi;
double betaLowId_Vdi_bi;
double betaLowId_Vsi_bi;
double betaLowId_Tempt_GND;
#endif
double betanoisq;
#if defined(_DERIVATE)
double betanoisq_Vdbulk_di;
double betanoisq_Vsbulk_si;
double betanoisq_Vgi_bi;
double betanoisq_Vdi_bi;
double betanoisq_Vsi_bi;
double betanoisq_Tempt_GND;
#endif
double ctnoi;
#if defined(_DERIVATE)
double ctnoi_Vdbulk_di;
double ctnoi_Vsbulk_si;
double ctnoi_Vgi_bi;
double ctnoi_Vdi_bi;
double ctnoi_Vsi_bi;
double ctnoi_Tempt_GND;
#endif
double Swi;
#if defined(_DERIVATEFORDDX)
double Swi_Tempt_GND;
double Swi_Vdbulk_di;
double Swi_Vsbulk_si;
double Swi_Vgi_bi;
double Swi_Vdi_bi;
double Swi_Vsi_bi;
#if defined(_DERIVATE2)
  double Swi_Vsi_bi_Tempt_GND;
  double Swi_Vsi_bi_Vdbulk_di;
  double Swi_Vsi_bi_Vsbulk_si;
  double Swi_Vsi_bi_Vgi_bi;
  double Swi_Vsi_bi_Vdi_bi;
  double Swi_Vsi_bi_Vsi_bi;
  double Swi_Vdi_bi_Tempt_GND;
  double Swi_Vdi_bi_Vdbulk_di;
  double Swi_Vdi_bi_Vsbulk_si;
  double Swi_Vdi_bi_Vgi_bi;
  double Swi_Vdi_bi_Vdi_bi;
  double Swi_Vdi_bi_Vsi_bi;
  double Swi_Vgi_bi_Tempt_GND;
  double Swi_Vgi_bi_Vdbulk_di;
  double Swi_Vgi_bi_Vsbulk_si;
  double Swi_Vgi_bi_Vgi_bi;
  double Swi_Vgi_bi_Vdi_bi;
  double Swi_Vgi_bi_Vsi_bi;
  double Swi_Vsbulk_si_Tempt_GND;
  double Swi_Vsbulk_si_Vdbulk_di;
  double Swi_Vsbulk_si_Vsbulk_si;
  double Swi_Vsbulk_si_Vgi_bi;
  double Swi_Vsbulk_si_Vdi_bi;
  double Swi_Vsbulk_si_Vsi_bi;
  double Swi_Vdbulk_di_Tempt_GND;
  double Swi_Vdbulk_di_Vdbulk_di;
  double Swi_Vdbulk_di_Vsbulk_si;
  double Swi_Vdbulk_di_Vgi_bi;
  double Swi_Vdbulk_di_Vdi_bi;
  double Swi_Vdbulk_di_Vsi_bi;
#endif
#endif
double Ssi;
#if defined(_DERIVATEFORDDX)
double Ssi_Tempt_GND;
double Ssi_Vgi_bi;
double Ssi_Vdi_bi;
double Ssi_Vsi_bi;
double Ssi_Vdbulk_di;
double Ssi_Vsbulk_si;
#if defined(_DERIVATE2)
  double Ssi_Vsbulk_si_Tempt_GND;
  double Ssi_Vsbulk_si_Vgi_bi;
  double Ssi_Vsbulk_si_Vdi_bi;
  double Ssi_Vsbulk_si_Vsi_bi;
  double Ssi_Vsbulk_si_Vdbulk_di;
  double Ssi_Vsbulk_si_Vsbulk_si;
  double Ssi_Vdbulk_di_Tempt_GND;
  double Ssi_Vdbulk_di_Vgi_bi;
  double Ssi_Vdbulk_di_Vdi_bi;
  double Ssi_Vdbulk_di_Vsi_bi;
  double Ssi_Vdbulk_di_Vdbulk_di;
  double Ssi_Vdbulk_di_Vsbulk_si;
  double Ssi_Vsi_bi_Tempt_GND;
  double Ssi_Vsi_bi_Vgi_bi;
  double Ssi_Vsi_bi_Vdi_bi;
  double Ssi_Vsi_bi_Vsi_bi;
  double Ssi_Vsi_bi_Vdbulk_di;
  double Ssi_Vsi_bi_Vsbulk_si;
  double Ssi_Vdi_bi_Tempt_GND;
  double Ssi_Vdi_bi_Vgi_bi;
  double Ssi_Vdi_bi_Vdi_bi;
  double Ssi_Vdi_bi_Vsi_bi;
  double Ssi_Vdi_bi_Vdbulk_di;
  double Ssi_Vdi_bi_Vsbulk_si;
  double Ssi_Vgi_bi_Tempt_GND;
  double Ssi_Vgi_bi_Vgi_bi;
  double Ssi_Vgi_bi_Vdi_bi;
  double Ssi_Vgi_bi_Vsi_bi;
  double Ssi_Vgi_bi_Vdbulk_di;
  double Ssi_Vgi_bi_Vsbulk_si;
#endif
#endif
double N0;
#if defined(_DERIVATEFORDDX)
double N0_Vgi_bi;
double N0_Tempt_GND;
double N0_Vdi_bi;
double N0_Vsi_bi;
#if defined(_DERIVATE2)
  double N0_Vsi_bi_Vgi_bi;
  double N0_Vsi_bi_Tempt_GND;
  double N0_Vsi_bi_Vdi_bi;
  double N0_Vsi_bi_Vsi_bi;
  double N0_Vdi_bi_Vgi_bi;
  double N0_Vdi_bi_Tempt_GND;
  double N0_Vdi_bi_Vdi_bi;
  double N0_Vdi_bi_Vsi_bi;
  double N0_Vgi_bi_Vgi_bi;
  double N0_Vgi_bi_Tempt_GND;
  double N0_Vgi_bi_Vdi_bi;
  double N0_Vgi_bi_Vsi_bi;
#endif
#endif
double FNPowerAt1Hz;
#if defined(_DERIVATE)
double FNPowerAt1Hz_Tempt_GND;
double FNPowerAt1Hz_Vgi_bi;
double FNPowerAt1Hz_Vdi_bi;
double FNPowerAt1Hz_Vsi_bi;
double FNPowerAt1Hz_Vdbulk_di;
double FNPowerAt1Hz_Vsbulk_si;
#endif
double FNPowerAt1Hz_h;
#if defined(_DERIVATE)
double FNPowerAt1Hz_h_Vdbulk_di;
double FNPowerAt1Hz_h_Vsbulk_si;
double FNPowerAt1Hz_h_Vgi_bi;
double FNPowerAt1Hz_h_Vdi_bi;
double FNPowerAt1Hz_h_Vsi_bi;
double FNPowerAt1Hz_h_Tempt_GND;
#endif
double T10;
#if defined(_DERIVATEFORDDX)
double T10_Vdbulk_di;
double T10_Vsbulk_si;
double T10_Vgi_bi;
double T10_Vdi_bi;
double T10_Vsi_bi;
double T10_Tempt_GND;
#if defined(_DERIVATE2)
  double T10_Vsi_bi_Vdbulk_di;
  double T10_Vsi_bi_Vsbulk_si;
  double T10_Vsi_bi_Vgi_bi;
  double T10_Vsi_bi_Vdi_bi;
  double T10_Vsi_bi_Vsi_bi;
  double T10_Vsi_bi_Tempt_GND;
  double T10_Vdi_bi_Vdbulk_di;
  double T10_Vdi_bi_Vsbulk_si;
  double T10_Vdi_bi_Vgi_bi;
  double T10_Vdi_bi_Vdi_bi;
  double T10_Vdi_bi_Vsi_bi;
  double T10_Vdi_bi_Tempt_GND;
  double T10_Vgi_bi_Vdbulk_di;
  double T10_Vgi_bi_Vsbulk_si;
  double T10_Vgi_bi_Vgi_bi;
  double T10_Vgi_bi_Vdi_bi;
  double T10_Vgi_bi_Vsi_bi;
  double T10_Vgi_bi_Tempt_GND;
  double T10_Vsbulk_si_Vdbulk_di;
  double T10_Vsbulk_si_Vsbulk_si;
  double T10_Vsbulk_si_Vgi_bi;
  double T10_Vsbulk_si_Vdi_bi;
  double T10_Vsbulk_si_Vsi_bi;
  double T10_Vsbulk_si_Tempt_GND;
  double T10_Vdbulk_di_Vdbulk_di;
  double T10_Vdbulk_di_Vsbulk_si;
  double T10_Vdbulk_di_Vgi_bi;
  double T10_Vdbulk_di_Vdi_bi;
  double T10_Vdbulk_di_Vsi_bi;
  double T10_Vdbulk_di_Tempt_GND;
#endif
#endif
double Swi_h;
#if defined(_DERIVATEFORDDX)
double Swi_h_Vdbulk_di;
double Swi_h_Vsbulk_si;
double Swi_h_Vgi_bi;
double Swi_h_Vdi_bi;
double Swi_h_Vsi_bi;
double Swi_h_Tempt_GND;
#if defined(_DERIVATE2)
  double Swi_h_Vsi_bi_Vdbulk_di;
  double Swi_h_Vsi_bi_Vsbulk_si;
  double Swi_h_Vsi_bi_Vgi_bi;
  double Swi_h_Vsi_bi_Vdi_bi;
  double Swi_h_Vsi_bi_Vsi_bi;
  double Swi_h_Vsi_bi_Tempt_GND;
  double Swi_h_Vdi_bi_Vdbulk_di;
  double Swi_h_Vdi_bi_Vsbulk_si;
  double Swi_h_Vdi_bi_Vgi_bi;
  double Swi_h_Vdi_bi_Vdi_bi;
  double Swi_h_Vdi_bi_Vsi_bi;
  double Swi_h_Vdi_bi_Tempt_GND;
  double Swi_h_Vgi_bi_Vdbulk_di;
  double Swi_h_Vgi_bi_Vsbulk_si;
  double Swi_h_Vgi_bi_Vgi_bi;
  double Swi_h_Vgi_bi_Vdi_bi;
  double Swi_h_Vgi_bi_Vsi_bi;
  double Swi_h_Vgi_bi_Tempt_GND;
  double Swi_h_Vsbulk_si_Vdbulk_di;
  double Swi_h_Vsbulk_si_Vsbulk_si;
  double Swi_h_Vsbulk_si_Vgi_bi;
  double Swi_h_Vsbulk_si_Vdi_bi;
  double Swi_h_Vsbulk_si_Vsi_bi;
  double Swi_h_Vsbulk_si_Tempt_GND;
  double Swi_h_Vdbulk_di_Vdbulk_di;
  double Swi_h_Vdbulk_di_Vsbulk_si;
  double Swi_h_Vdbulk_di_Vgi_bi;
  double Swi_h_Vdbulk_di_Vdi_bi;
  double Swi_h_Vdbulk_di_Vsi_bi;
  double Swi_h_Vdbulk_di_Tempt_GND;
#endif
#endif
double FNPowerAt1Hz_ch;
#if defined(_DERIVATE)
double FNPowerAt1Hz_ch_Tempt_GND;
double FNPowerAt1Hz_ch_Vgi_bi;
double FNPowerAt1Hz_ch_Vdi_bi;
double FNPowerAt1Hz_ch_Vsi_bi;
double FNPowerAt1Hz_ch_Vdbulk_di;
double FNPowerAt1Hz_ch_Vsbulk_si;
#endif
double Swi_ch;
#if defined(_DERIVATEFORDDX)
double Swi_ch_Tempt_GND;
double Swi_ch_Vdbulk_di;
double Swi_ch_Vsbulk_si;
double Swi_ch_Vgi_bi;
double Swi_ch_Vdi_bi;
double Swi_ch_Vsi_bi;
#if defined(_DERIVATE2)
  double Swi_ch_Vsi_bi_Tempt_GND;
  double Swi_ch_Vsi_bi_Vdbulk_di;
  double Swi_ch_Vsi_bi_Vsbulk_si;
  double Swi_ch_Vsi_bi_Vgi_bi;
  double Swi_ch_Vsi_bi_Vdi_bi;
  double Swi_ch_Vsi_bi_Vsi_bi;
  double Swi_ch_Vdi_bi_Tempt_GND;
  double Swi_ch_Vdi_bi_Vdbulk_di;
  double Swi_ch_Vdi_bi_Vsbulk_si;
  double Swi_ch_Vdi_bi_Vgi_bi;
  double Swi_ch_Vdi_bi_Vdi_bi;
  double Swi_ch_Vdi_bi_Vsi_bi;
  double Swi_ch_Vgi_bi_Tempt_GND;
  double Swi_ch_Vgi_bi_Vdbulk_di;
  double Swi_ch_Vgi_bi_Vsbulk_si;
  double Swi_ch_Vgi_bi_Vgi_bi;
  double Swi_ch_Vgi_bi_Vdi_bi;
  double Swi_ch_Vgi_bi_Vsi_bi;
  double Swi_ch_Vsbulk_si_Tempt_GND;
  double Swi_ch_Vsbulk_si_Vdbulk_di;
  double Swi_ch_Vsbulk_si_Vsbulk_si;
  double Swi_ch_Vsbulk_si_Vgi_bi;
  double Swi_ch_Vsbulk_si_Vdi_bi;
  double Swi_ch_Vsbulk_si_Vsi_bi;
  double Swi_ch_Vdbulk_di_Tempt_GND;
  double Swi_ch_Vdbulk_di_Vdbulk_di;
  double Swi_ch_Vdbulk_di_Vsbulk_si;
  double Swi_ch_Vdbulk_di_Vgi_bi;
  double Swi_ch_Vdbulk_di_Vdi_bi;
  double Swi_ch_Vdbulk_di_Vsi_bi;
#endif
#endif
double Ssi_ch;
#if defined(_DERIVATEFORDDX)
double Ssi_ch_Tempt_GND;
double Ssi_ch_Vgi_bi;
double Ssi_ch_Vdi_bi;
double Ssi_ch_Vsi_bi;
double Ssi_ch_Vdbulk_di;
double Ssi_ch_Vsbulk_si;
#if defined(_DERIVATE2)
  double Ssi_ch_Vsbulk_si_Tempt_GND;
  double Ssi_ch_Vsbulk_si_Vgi_bi;
  double Ssi_ch_Vsbulk_si_Vdi_bi;
  double Ssi_ch_Vsbulk_si_Vsi_bi;
  double Ssi_ch_Vsbulk_si_Vdbulk_di;
  double Ssi_ch_Vsbulk_si_Vsbulk_si;
  double Ssi_ch_Vdbulk_di_Tempt_GND;
  double Ssi_ch_Vdbulk_di_Vgi_bi;
  double Ssi_ch_Vdbulk_di_Vdi_bi;
  double Ssi_ch_Vdbulk_di_Vsi_bi;
  double Ssi_ch_Vdbulk_di_Vdbulk_di;
  double Ssi_ch_Vdbulk_di_Vsbulk_si;
  double Ssi_ch_Vsi_bi_Tempt_GND;
  double Ssi_ch_Vsi_bi_Vgi_bi;
  double Ssi_ch_Vsi_bi_Vdi_bi;
  double Ssi_ch_Vsi_bi_Vsi_bi;
  double Ssi_ch_Vsi_bi_Vdbulk_di;
  double Ssi_ch_Vsi_bi_Vsbulk_si;
  double Ssi_ch_Vdi_bi_Tempt_GND;
  double Ssi_ch_Vdi_bi_Vgi_bi;
  double Ssi_ch_Vdi_bi_Vdi_bi;
  double Ssi_ch_Vdi_bi_Vsi_bi;
  double Ssi_ch_Vdi_bi_Vdbulk_di;
  double Ssi_ch_Vdi_bi_Vsbulk_si;
  double Ssi_ch_Vgi_bi_Tempt_GND;
  double Ssi_ch_Vgi_bi_Vgi_bi;
  double Ssi_ch_Vgi_bi_Vdi_bi;
  double Ssi_ch_Vgi_bi_Vsi_bi;
  double Ssi_ch_Vgi_bi_Vdbulk_di;
  double Ssi_ch_Vgi_bi_Vsbulk_si;
#endif
#endif
double Leffnoisq;
double Leffnoi;
double Np2;
#if defined(_DERIVATEFORDDX)
double Np2_Vgi_bi;
double Np2_Tempt_GND;
double Np2_Vdi_bi;
double Np2_Vsi_bi;
#if defined(_DERIVATE2)
  double Np2_Vsi_bi_Vgi_bi;
  double Np2_Vsi_bi_Tempt_GND;
  double Np2_Vsi_bi_Vdi_bi;
  double Np2_Vsi_bi_Vsi_bi;
  double Np2_Vdi_bi_Vgi_bi;
  double Np2_Vdi_bi_Tempt_GND;
  double Np2_Vdi_bi_Vdi_bi;
  double Np2_Vdi_bi_Vsi_bi;
  double Np2_Vgi_bi_Vgi_bi;
  double Np2_Vgi_bi_Tempt_GND;
  double Np2_Vgi_bi_Vdi_bi;
  double Np2_Vgi_bi_Vsi_bi;
#endif
#endif
double CF_h;
#if defined(_DERIVATE)
double CF_h_Tempt_GND;
double CF_h_Vdi_bi;
double CF_h_Vsi_bi;
double CF_h_Vgi_bi;
double CF_h_Vdbulk_di;
double CF_h_Vsbulk_si;
#endif
double CF_ch;
#if defined(_DERIVATE)
double CF_ch_Tempt_GND;
double CF_ch_Vdbulk_di;
double CF_ch_Vsbulk_si;
double CF_ch_Vgi_bi;
double CF_ch_Vdi_bi;
double CF_ch_Vsi_bi;
#endif
double t_tot;
#if defined(_DERIVATE)
double t_tot_Tempt_GND;
double t_tot_Vdbulk_di;
double t_tot_Vsbulk_si;
double t_tot_Vgi_bi;
double t_tot_Vdi_bi;
double t_tot_Vsi_bi;
#endif
double R_h;
#if defined(_DERIVATE)
double R_h_Tempt_GND;
double R_h_Vdi_bi;
double R_h_Vsi_bi;
double R_h_Vgi_bi;
#endif
double R_ch;
#if defined(_DERIVATE)
double R_ch_Tempt_GND;
double R_ch_Vdbulk_di;
double R_ch_Vsbulk_si;
double R_ch_Vgi_bi;
double R_ch_Vdi_bi;
double R_ch_Vsi_bi;
#endif
double gm_ch;
#if defined(_DERIVATE)
double gm_ch_Tempt_GND;
double gm_ch_Vdi_bi;
double gm_ch_Vsi_bi;
double gm_ch_Vgi_bi;
#endif
double gds_ch;
#if defined(_DERIVATE)
double gds_ch_Vgi_bi;
double gds_ch_Tempt_GND;
double gds_ch_Vdi_bi;
double gds_ch_Vsi_bi;
#endif
double gds_h;
#if defined(_DERIVATE)
double gds_h_Tempt_GND;
double gds_h_Vdbulk_di;
double gds_h_Vsbulk_si;
double gds_h_Vgi_bi;
double gds_h_Vdi_bi;
double gds_h_Vsi_bi;
#endif
double qsch;
#if defined(_DERIVATEFORDDX)
double qsch_Vgi_bi;
double qsch_Vdi_bi;
double qsch_Vsi_bi;
double qsch_Tempt_GND;
#if defined(_DERIVATE2)
  double qsch_Vsi_bi_Vgi_bi;
  double qsch_Vsi_bi_Vdi_bi;
  double qsch_Vsi_bi_Vsi_bi;
  double qsch_Vsi_bi_Tempt_GND;
  double qsch_Vdi_bi_Vgi_bi;
  double qsch_Vdi_bi_Vdi_bi;
  double qsch_Vdi_bi_Vsi_bi;
  double qsch_Vdi_bi_Tempt_GND;
  double qsch_Vgi_bi_Vgi_bi;
  double qsch_Vgi_bi_Vdi_bi;
  double qsch_Vgi_bi_Vsi_bi;
  double qsch_Vgi_bi_Tempt_GND;
#endif
#endif
double qdh;
#if defined(_DERIVATE)
double qdh_Vdbulk_di;
double qdh_Vsbulk_si;
double qdh_Vgi_bi;
double qdh_Vdi_bi;
double qdh_Vsi_bi;
double qdh_Tempt_GND;
#endif
double i2;
#if defined(_DERIVATEFORDDX)
double i2_Vgi_bi;
double i2_Tempt_GND;
double i2_Vdi_bi;
double i2_Vsi_bi;
#if defined(_DERIVATE2)
  double i2_Vsi_bi_Vgi_bi;
  double i2_Vsi_bi_Tempt_GND;
  double i2_Vsi_bi_Vdi_bi;
  double i2_Vsi_bi_Vsi_bi;
  double i2_Vdi_bi_Vgi_bi;
  double i2_Vdi_bi_Tempt_GND;
  double i2_Vdi_bi_Vdi_bi;
  double i2_Vdi_bi_Vsi_bi;
  double i2_Vgi_bi_Vgi_bi;
  double i2_Vgi_bi_Tempt_GND;
  double i2_Vgi_bi_Vdi_bi;
  double i2_Vgi_bi_Vsi_bi;
#endif
#endif
double i1;
#if defined(_DERIVATEFORDDX)
double i1_Vgi_bi;
double i1_Tempt_GND;
double i1_Vdi_bi;
double i1_Vsi_bi;
double i1_Vdbulk_di;
double i1_Vsbulk_si;
#if defined(_DERIVATE2)
  double i1_Vsbulk_si_Vgi_bi;
  double i1_Vsbulk_si_Tempt_GND;
  double i1_Vsbulk_si_Vdi_bi;
  double i1_Vsbulk_si_Vsi_bi;
  double i1_Vsbulk_si_Vdbulk_di;
  double i1_Vsbulk_si_Vsbulk_si;
  double i1_Vdbulk_di_Vgi_bi;
  double i1_Vdbulk_di_Tempt_GND;
  double i1_Vdbulk_di_Vdi_bi;
  double i1_Vdbulk_di_Vsi_bi;
  double i1_Vdbulk_di_Vdbulk_di;
  double i1_Vdbulk_di_Vsbulk_si;
  double i1_Vsi_bi_Vgi_bi;
  double i1_Vsi_bi_Tempt_GND;
  double i1_Vsi_bi_Vdi_bi;
  double i1_Vsi_bi_Vsi_bi;
  double i1_Vsi_bi_Vdbulk_di;
  double i1_Vsi_bi_Vsbulk_si;
  double i1_Vdi_bi_Vgi_bi;
  double i1_Vdi_bi_Tempt_GND;
  double i1_Vdi_bi_Vdi_bi;
  double i1_Vdi_bi_Vsi_bi;
  double i1_Vdi_bi_Vdbulk_di;
  double i1_Vdi_bi_Vsbulk_si;
  double i1_Vgi_bi_Vgi_bi;
  double i1_Vgi_bi_Tempt_GND;
  double i1_Vgi_bi_Vdi_bi;
  double i1_Vgi_bi_Vsi_bi;
  double i1_Vgi_bi_Vdbulk_di;
  double i1_Vgi_bi_Vsbulk_si;
#endif
#endif
double beta_ch;
#if defined(_DERIVATEFORDDX)
double beta_ch_Tempt_GND;
double beta_ch_Vdi_bi;
double beta_ch_Vsi_bi;
double beta_ch_Vgi_bi;
#if defined(_DERIVATE2)
  double beta_ch_Vgi_bi_Tempt_GND;
  double beta_ch_Vgi_bi_Vdi_bi;
  double beta_ch_Vgi_bi_Vsi_bi;
  double beta_ch_Vgi_bi_Vgi_bi;
  double beta_ch_Vsi_bi_Tempt_GND;
  double beta_ch_Vsi_bi_Vdi_bi;
  double beta_ch_Vsi_bi_Vsi_bi;
  double beta_ch_Vsi_bi_Vgi_bi;
  double beta_ch_Vdi_bi_Tempt_GND;
  double beta_ch_Vdi_bi_Vdi_bi;
  double beta_ch_Vdi_bi_Vsi_bi;
  double beta_ch_Vdi_bi_Vgi_bi;
#endif
#endif
double beta_h;
#if defined(_DERIVATEFORDDX)
double beta_h_Tempt_GND;
double beta_h_Vdi_bi;
double beta_h_Vsi_bi;
double beta_h_Vgi_bi;
#if defined(_DERIVATE2)
  double beta_h_Vgi_bi_Tempt_GND;
  double beta_h_Vgi_bi_Vdi_bi;
  double beta_h_Vgi_bi_Vsi_bi;
  double beta_h_Vgi_bi_Vgi_bi;
  double beta_h_Vsi_bi_Tempt_GND;
  double beta_h_Vsi_bi_Vdi_bi;
  double beta_h_Vsi_bi_Vsi_bi;
  double beta_h_Vsi_bi_Vgi_bi;
  double beta_h_Vdi_bi_Tempt_GND;
  double beta_h_Vdi_bi_Vdi_bi;
  double beta_h_Vdi_bi_Vsi_bi;
  double beta_h_Vdi_bi_Vgi_bi;
#endif
#endif
double U0_i_h;
#if defined(_DERIVATEFORDDX)
double U0_i_h_Tempt_GND;
double U0_i_h_Vdi_bi;
double U0_i_h_Vsi_bi;
double U0_i_h_Vgi_bi;
#if defined(_DERIVATE2)
  double U0_i_h_Vgi_bi_Tempt_GND;
  double U0_i_h_Vgi_bi_Vdi_bi;
  double U0_i_h_Vgi_bi_Vsi_bi;
  double U0_i_h_Vgi_bi_Vgi_bi;
  double U0_i_h_Vsi_bi_Tempt_GND;
  double U0_i_h_Vsi_bi_Vdi_bi;
  double U0_i_h_Vsi_bi_Vsi_bi;
  double U0_i_h_Vsi_bi_Vgi_bi;
  double U0_i_h_Vdi_bi_Tempt_GND;
  double U0_i_h_Vdi_bi_Vdi_bi;
  double U0_i_h_Vdi_bi_Vsi_bi;
  double U0_i_h_Vdi_bi_Vgi_bi;
#endif
#endif
double nq_h;
#if defined(_DERIVATEFORDDX)
double nq_h_Tempt_GND;
double nq_h_Vdbulk_di;
double nq_h_Vsbulk_si;
double nq_h_Vgi_bi;
double nq_h_Vdi_bi;
double nq_h_Vsi_bi;
#if defined(_DERIVATE2)
  double nq_h_Vsi_bi_Tempt_GND;
  double nq_h_Vsi_bi_Vdbulk_di;
  double nq_h_Vsi_bi_Vsbulk_si;
  double nq_h_Vsi_bi_Vgi_bi;
  double nq_h_Vsi_bi_Vdi_bi;
  double nq_h_Vsi_bi_Vsi_bi;
  double nq_h_Vdi_bi_Tempt_GND;
  double nq_h_Vdi_bi_Vdbulk_di;
  double nq_h_Vdi_bi_Vsbulk_si;
  double nq_h_Vdi_bi_Vgi_bi;
  double nq_h_Vdi_bi_Vdi_bi;
  double nq_h_Vdi_bi_Vsi_bi;
  double nq_h_Vgi_bi_Tempt_GND;
  double nq_h_Vgi_bi_Vdbulk_di;
  double nq_h_Vgi_bi_Vsbulk_si;
  double nq_h_Vgi_bi_Vgi_bi;
  double nq_h_Vgi_bi_Vdi_bi;
  double nq_h_Vgi_bi_Vsi_bi;
  double nq_h_Vsbulk_si_Tempt_GND;
  double nq_h_Vsbulk_si_Vdbulk_di;
  double nq_h_Vsbulk_si_Vsbulk_si;
  double nq_h_Vsbulk_si_Vgi_bi;
  double nq_h_Vsbulk_si_Vdi_bi;
  double nq_h_Vsbulk_si_Vsi_bi;
  double nq_h_Vdbulk_di_Tempt_GND;
  double nq_h_Vdbulk_di_Vdbulk_di;
  double nq_h_Vdbulk_di_Vsbulk_si;
  double nq_h_Vdbulk_di_Vgi_bi;
  double nq_h_Vdbulk_di_Vdi_bi;
  double nq_h_Vdbulk_di_Vsi_bi;
#endif
#endif
double qsh;
#if defined(_DERIVATEFORDDX)
double qsh_Vdbulk_di;
double qsh_Vsbulk_si;
double qsh_Vgi_bi;
double qsh_Vdi_bi;
double qsh_Vsi_bi;
double qsh_Tempt_GND;
#if defined(_DERIVATE2)
  double qsh_Vsi_bi_Vdbulk_di;
  double qsh_Vsi_bi_Vsbulk_si;
  double qsh_Vsi_bi_Vgi_bi;
  double qsh_Vsi_bi_Vdi_bi;
  double qsh_Vsi_bi_Vsi_bi;
  double qsh_Vsi_bi_Tempt_GND;
  double qsh_Vdi_bi_Vdbulk_di;
  double qsh_Vdi_bi_Vsbulk_si;
  double qsh_Vdi_bi_Vgi_bi;
  double qsh_Vdi_bi_Vdi_bi;
  double qsh_Vdi_bi_Vsi_bi;
  double qsh_Vdi_bi_Tempt_GND;
  double qsh_Vgi_bi_Vdbulk_di;
  double qsh_Vgi_bi_Vsbulk_si;
  double qsh_Vgi_bi_Vgi_bi;
  double qsh_Vgi_bi_Vdi_bi;
  double qsh_Vgi_bi_Vsi_bi;
  double qsh_Vgi_bi_Tempt_GND;
  double qsh_Vsbulk_si_Vdbulk_di;
  double qsh_Vsbulk_si_Vsbulk_si;
  double qsh_Vsbulk_si_Vgi_bi;
  double qsh_Vsbulk_si_Vdi_bi;
  double qsh_Vsbulk_si_Vsi_bi;
  double qsh_Vsbulk_si_Tempt_GND;
  double qsh_Vdbulk_di_Vdbulk_di;
  double qsh_Vdbulk_di_Vsbulk_si;
  double qsh_Vdbulk_di_Vgi_bi;
  double qsh_Vdbulk_di_Vdi_bi;
  double qsh_Vdbulk_di_Vsi_bi;
  double qsh_Vdbulk_di_Tempt_GND;
#endif
#endif
double psiph;
#if defined(_DERIVATEFORDDX)
double psiph_Vdbulk_di;
double psiph_Vsbulk_si;
double psiph_Vgi_bi;
double psiph_Vdi_bi;
double psiph_Vsi_bi;
double psiph_Tempt_GND;
#if defined(_DERIVATE2)
  double psiph_Vsi_bi_Vdbulk_di;
  double psiph_Vsi_bi_Vsbulk_si;
  double psiph_Vsi_bi_Vgi_bi;
  double psiph_Vsi_bi_Vdi_bi;
  double psiph_Vsi_bi_Vsi_bi;
  double psiph_Vsi_bi_Tempt_GND;
  double psiph_Vdi_bi_Vdbulk_di;
  double psiph_Vdi_bi_Vsbulk_si;
  double psiph_Vdi_bi_Vgi_bi;
  double psiph_Vdi_bi_Vdi_bi;
  double psiph_Vdi_bi_Vsi_bi;
  double psiph_Vdi_bi_Tempt_GND;
  double psiph_Vgi_bi_Vdbulk_di;
  double psiph_Vgi_bi_Vsbulk_si;
  double psiph_Vgi_bi_Vgi_bi;
  double psiph_Vgi_bi_Vdi_bi;
  double psiph_Vgi_bi_Vsi_bi;
  double psiph_Vgi_bi_Tempt_GND;
  double psiph_Vsbulk_si_Vdbulk_di;
  double psiph_Vsbulk_si_Vsbulk_si;
  double psiph_Vsbulk_si_Vgi_bi;
  double psiph_Vsbulk_si_Vdi_bi;
  double psiph_Vsbulk_si_Vsi_bi;
  double psiph_Vsbulk_si_Tempt_GND;
  double psiph_Vdbulk_di_Vdbulk_di;
  double psiph_Vdbulk_di_Vsbulk_si;
  double psiph_Vdbulk_di_Vgi_bi;
  double psiph_Vdbulk_di_Vdi_bi;
  double psiph_Vdbulk_di_Vsi_bi;
  double psiph_Vdbulk_di_Tempt_GND;
#endif
#endif
double phib_h;
#if defined(_DERIVATE)
double phib_h_Tempt_GND;
#endif
double gam_h;
#if defined(_DERIVATE)
double gam_h_Tempt_GND;
#endif
double vgfbh;
#if defined(_DERIVATEFORDDX)
double vgfbh_Vgi_bi;
double vgfbh_Tempt_GND;
#if defined(_DERIVATE2)
  double vgfbh_Vgi_bi_Vgi_bi;
  double vgfbh_Vgi_bi_Tempt_GND;
#endif
#endif
double LeffnoiH;
double LINTNOI_i;
double T0e;
#if defined(_DERIVATE)
double T0e_Tempt_GND;
#endif
double T0d;
#if defined(_DERIVATEFORDDX)
double T0d_Vgi_bi;
double T0d_Tempt_GND;
double T0d_Vdi_bi;
double T0d_Vsi_bi;
#if defined(_DERIVATE2)
  double T0d_Vsi_bi_Vgi_bi;
  double T0d_Vsi_bi_Tempt_GND;
  double T0d_Vsi_bi_Vdi_bi;
  double T0d_Vsi_bi_Vsi_bi;
  double T0d_Vdi_bi_Vgi_bi;
  double T0d_Vdi_bi_Tempt_GND;
  double T0d_Vdi_bi_Vdi_bi;
  double T0d_Vdi_bi_Vsi_bi;
  double T0d_Vgi_bi_Vgi_bi;
  double T0d_Vgi_bi_Tempt_GND;
  double T0d_Vgi_bi_Vdi_bi;
  double T0d_Vgi_bi_Vsi_bi;
#endif
#endif
double T0c;
#if defined(_DERIVATEFORDDX)
double T0c_Vgi_bi;
double T0c_Tempt_GND;
double T0c_Vdi_bi;
double T0c_Vsi_bi;
#if defined(_DERIVATE2)
  double T0c_Vsi_bi_Vgi_bi;
  double T0c_Vsi_bi_Tempt_GND;
  double T0c_Vsi_bi_Vdi_bi;
  double T0c_Vsi_bi_Vsi_bi;
  double T0c_Vdi_bi_Vgi_bi;
  double T0c_Vdi_bi_Tempt_GND;
  double T0c_Vdi_bi_Vdi_bi;
  double T0c_Vdi_bi_Vsi_bi;
  double T0c_Vgi_bi_Vgi_bi;
  double T0c_Vgi_bi_Tempt_GND;
  double T0c_Vgi_bi_Vdi_bi;
  double T0c_Vgi_bi_Vsi_bi;
#endif
#endif
double T0b;
#if defined(_DERIVATEFORDDX)
double T0b_Tempt_GND;
double T0b_Vgi_bi;
double T0b_Vdi_bi;
double T0b_Vsi_bi;
#if defined(_DERIVATE2)
  double T0b_Vsi_bi_Tempt_GND;
  double T0b_Vsi_bi_Vgi_bi;
  double T0b_Vsi_bi_Vdi_bi;
  double T0b_Vsi_bi_Vsi_bi;
  double T0b_Vdi_bi_Tempt_GND;
  double T0b_Vdi_bi_Vgi_bi;
  double T0b_Vdi_bi_Vdi_bi;
  double T0b_Vdi_bi_Vsi_bi;
  double T0b_Vgi_bi_Tempt_GND;
  double T0b_Vgi_bi_Vgi_bi;
  double T0b_Vgi_bi_Vdi_bi;
  double T0b_Vgi_bi_Vsi_bi;
#endif
#endif
double T0a;
#if defined(_DERIVATEFORDDX)
double T0a_Tempt_GND;
double T0a_Vgi_bi;
double T0a_Vdi_bi;
double T0a_Vsi_bi;
#if defined(_DERIVATE2)
  double T0a_Vsi_bi_Tempt_GND;
  double T0a_Vsi_bi_Vgi_bi;
  double T0a_Vsi_bi_Vdi_bi;
  double T0a_Vsi_bi_Vsi_bi;
  double T0a_Vdi_bi_Tempt_GND;
  double T0a_Vdi_bi_Vgi_bi;
  double T0a_Vdi_bi_Vdi_bi;
  double T0a_Vdi_bi_Vsi_bi;
  double T0a_Vgi_bi_Tempt_GND;
  double T0a_Vgi_bi_Vgi_bi;
  double T0a_Vgi_bi_Vdi_bi;
  double T0a_Vgi_bi_Vsi_bi;
#endif
#endif
double Nl;
#if defined(_DERIVATEFORDDX)
double Nl_Vgi_bi;
double Nl_Tempt_GND;
double Nl_Vdi_bi;
double Nl_Vsi_bi;
#if defined(_DERIVATE2)
  double Nl_Vsi_bi_Vgi_bi;
  double Nl_Vsi_bi_Tempt_GND;
  double Nl_Vsi_bi_Vdi_bi;
  double Nl_Vsi_bi_Vsi_bi;
  double Nl_Vdi_bi_Vgi_bi;
  double Nl_Vdi_bi_Tempt_GND;
  double Nl_Vdi_bi_Vdi_bi;
  double Nl_Vdi_bi_Vsi_bi;
  double Nl_Vgi_bi_Vgi_bi;
  double Nl_Vgi_bi_Tempt_GND;
  double Nl_Vgi_bi_Vdi_bi;
  double Nl_Vgi_bi_Vsi_bi;
#endif
#endif
double Nstar;
#if defined(_DERIVATEFORDDX)
double Nstar_Tempt_GND;
double Nstar_Vdi_bi;
double Nstar_Vsi_bi;
#if defined(_DERIVATE2)
  double Nstar_Vsi_bi_Tempt_GND;
  double Nstar_Vsi_bi_Vdi_bi;
  double Nstar_Vsi_bi_Vsi_bi;
  double Nstar_Vdi_bi_Tempt_GND;
  double Nstar_Vdi_bi_Vdi_bi;
  double Nstar_Vdi_bi_Vsi_bi;
#endif
#endif
double DelClm;
#if defined(_DERIVATEFORDDX)
double DelClm_Vdbulk_di;
double DelClm_Vsbulk_si;
double DelClm_Vgi_bi;
double DelClm_Vdi_bi;
double DelClm_Vsi_bi;
double DelClm_Tempt_GND;
#if defined(_DERIVATE2)
  double DelClm_Vsi_bi_Vdbulk_di;
  double DelClm_Vsi_bi_Vsbulk_si;
  double DelClm_Vsi_bi_Vgi_bi;
  double DelClm_Vsi_bi_Vdi_bi;
  double DelClm_Vsi_bi_Vsi_bi;
  double DelClm_Vsi_bi_Tempt_GND;
  double DelClm_Vdi_bi_Vdbulk_di;
  double DelClm_Vdi_bi_Vsbulk_si;
  double DelClm_Vdi_bi_Vgi_bi;
  double DelClm_Vdi_bi_Vdi_bi;
  double DelClm_Vdi_bi_Vsi_bi;
  double DelClm_Vdi_bi_Tempt_GND;
  double DelClm_Vgi_bi_Vdbulk_di;
  double DelClm_Vgi_bi_Vsbulk_si;
  double DelClm_Vgi_bi_Vgi_bi;
  double DelClm_Vgi_bi_Vdi_bi;
  double DelClm_Vgi_bi_Vsi_bi;
  double DelClm_Vgi_bi_Tempt_GND;
  double DelClm_Vsbulk_si_Vdbulk_di;
  double DelClm_Vsbulk_si_Vsbulk_si;
  double DelClm_Vsbulk_si_Vgi_bi;
  double DelClm_Vsbulk_si_Vdi_bi;
  double DelClm_Vsbulk_si_Vsi_bi;
  double DelClm_Vsbulk_si_Tempt_GND;
  double DelClm_Vdbulk_di_Vdbulk_di;
  double DelClm_Vdbulk_di_Vsbulk_si;
  double DelClm_Vdbulk_di_Vgi_bi;
  double DelClm_Vdbulk_di_Vdi_bi;
  double DelClm_Vdbulk_di_Vsi_bi;
  double DelClm_Vdbulk_di_Tempt_GND;
#endif
#endif
double Esatnoi;
#if defined(_DERIVATEFORDDX)
double Esatnoi_Tempt_GND;
double Esatnoi_Vdi_bi;
double Esatnoi_Vsi_bi;
double Esatnoi_Vgi_bi;
#if defined(_DERIVATE2)
  double Esatnoi_Vgi_bi_Tempt_GND;
  double Esatnoi_Vgi_bi_Vdi_bi;
  double Esatnoi_Vgi_bi_Vsi_bi;
  double Esatnoi_Vgi_bi_Vgi_bi;
  double Esatnoi_Vsi_bi_Tempt_GND;
  double Esatnoi_Vsi_bi_Vdi_bi;
  double Esatnoi_Vsi_bi_Vsi_bi;
  double Esatnoi_Vsi_bi_Vgi_bi;
  double Esatnoi_Vdi_bi_Tempt_GND;
  double Esatnoi_Vdi_bi_Vdi_bi;
  double Esatnoi_Vdi_bi_Vsi_bi;
  double Esatnoi_Vdi_bi_Vgi_bi;
#endif
#endif
double Nt;
#if defined(_DERIVATE)
double Nt_Tempt_GND;
#endif
double Issl;
#if defined(_DERIVATE)
double Issl_Vdbulk_di;
double Issl_Vsbulk_si;
double Issl_Vgi_bi;
double Issl_Vdi_bi;
double Issl_Vsi_bi;
double Issl_Tempt_GND;
double Issl_Vg_b;
#endif
double PHIB_SSL;
#if defined(_DERIVATE)
double PHIB_SSL_Vg_b;
double PHIB_SSL_Vdi_bi;
double PHIB_SSL_Vsi_bi;
double PHIB_SSL_Tempt_GND;
#endif
double SSL1_NT;
#if defined(_DERIVATE)
double SSL1_NT_Vdbulk_di;
double SSL1_NT_Vsbulk_si;
double SSL1_NT_Vgi_bi;
double SSL1_NT_Vdi_bi;
double SSL1_NT_Vsi_bi;
double SSL1_NT_Tempt_GND;
#endif
double SSL0_NT;
#if defined(_DERIVATE)
double SSL0_NT_Vdbulk_di;
double SSL0_NT_Vsbulk_si;
double SSL0_NT_Vgi_bi;
double SSL0_NT_Vdi_bi;
double SSL0_NT_Vsi_bi;
double SSL0_NT_Tempt_GND;
#endif
#if defined(_DYNAMIC)
double Qbdj;
#if defined(_DERIVATEFORDDX)
double Qbdj_Tempt_GND;
double Qbdj_Vdbulk_di;
double Qbdj_Vsbulk_si;
double Qbdj_Vgi_bi;
double Qbdj_Vdi_bi;
double Qbdj_Vsi_bi;
#if defined(_DERIVATE2)
  double Qbdj_Vsi_bi_Tempt_GND;
  double Qbdj_Vsi_bi_Vdbulk_di;
  double Qbdj_Vsi_bi_Vsbulk_si;
  double Qbdj_Vsi_bi_Vgi_bi;
  double Qbdj_Vsi_bi_Vdi_bi;
  double Qbdj_Vsi_bi_Vsi_bi;
  double Qbdj_Vdi_bi_Tempt_GND;
  double Qbdj_Vdi_bi_Vdbulk_di;
  double Qbdj_Vdi_bi_Vsbulk_si;
  double Qbdj_Vdi_bi_Vgi_bi;
  double Qbdj_Vdi_bi_Vdi_bi;
  double Qbdj_Vdi_bi_Vsi_bi;
  double Qbdj_Vgi_bi_Tempt_GND;
  double Qbdj_Vgi_bi_Vdbulk_di;
  double Qbdj_Vgi_bi_Vsbulk_si;
  double Qbdj_Vgi_bi_Vgi_bi;
  double Qbdj_Vgi_bi_Vdi_bi;
  double Qbdj_Vgi_bi_Vsi_bi;
  double Qbdj_Vsbulk_si_Tempt_GND;
  double Qbdj_Vsbulk_si_Vdbulk_di;
  double Qbdj_Vsbulk_si_Vsbulk_si;
  double Qbdj_Vsbulk_si_Vgi_bi;
  double Qbdj_Vsbulk_si_Vdi_bi;
  double Qbdj_Vsbulk_si_Vsi_bi;
  double Qbdj_Vdbulk_di_Tempt_GND;
  double Qbdj_Vdbulk_di_Vdbulk_di;
  double Qbdj_Vdbulk_di_Vsbulk_si;
  double Qbdj_Vdbulk_di_Vgi_bi;
  double Qbdj_Vdbulk_di_Vdi_bi;
  double Qbdj_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qbdj3;
#if defined(_DERIVATEFORDDX)
double Qbdj3_Tempt_GND;
double Qbdj3_Vdbulk_di;
double Qbdj3_Vsbulk_si;
double Qbdj3_Vgi_bi;
double Qbdj3_Vdi_bi;
double Qbdj3_Vsi_bi;
#if defined(_DERIVATE2)
  double Qbdj3_Vsi_bi_Tempt_GND;
  double Qbdj3_Vsi_bi_Vdbulk_di;
  double Qbdj3_Vsi_bi_Vsbulk_si;
  double Qbdj3_Vsi_bi_Vgi_bi;
  double Qbdj3_Vsi_bi_Vdi_bi;
  double Qbdj3_Vsi_bi_Vsi_bi;
  double Qbdj3_Vdi_bi_Tempt_GND;
  double Qbdj3_Vdi_bi_Vdbulk_di;
  double Qbdj3_Vdi_bi_Vsbulk_si;
  double Qbdj3_Vdi_bi_Vgi_bi;
  double Qbdj3_Vdi_bi_Vdi_bi;
  double Qbdj3_Vdi_bi_Vsi_bi;
  double Qbdj3_Vgi_bi_Tempt_GND;
  double Qbdj3_Vgi_bi_Vdbulk_di;
  double Qbdj3_Vgi_bi_Vsbulk_si;
  double Qbdj3_Vgi_bi_Vgi_bi;
  double Qbdj3_Vgi_bi_Vdi_bi;
  double Qbdj3_Vgi_bi_Vsi_bi;
  double Qbdj3_Vsbulk_si_Tempt_GND;
  double Qbdj3_Vsbulk_si_Vdbulk_di;
  double Qbdj3_Vsbulk_si_Vsbulk_si;
  double Qbdj3_Vsbulk_si_Vgi_bi;
  double Qbdj3_Vsbulk_si_Vdi_bi;
  double Qbdj3_Vsbulk_si_Vsi_bi;
  double Qbdj3_Vdbulk_di_Tempt_GND;
  double Qbdj3_Vdbulk_di_Vdbulk_di;
  double Qbdj3_Vdbulk_di_Vsbulk_si;
  double Qbdj3_Vdbulk_di_Vgi_bi;
  double Qbdj3_Vdbulk_di_Vdi_bi;
  double Qbdj3_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qbdj2;
#if defined(_DERIVATEFORDDX)
double Qbdj2_Tempt_GND;
double Qbdj2_Vdbulk_di;
double Qbdj2_Vsbulk_si;
double Qbdj2_Vgi_bi;
double Qbdj2_Vdi_bi;
double Qbdj2_Vsi_bi;
#if defined(_DERIVATE2)
  double Qbdj2_Vsi_bi_Tempt_GND;
  double Qbdj2_Vsi_bi_Vdbulk_di;
  double Qbdj2_Vsi_bi_Vsbulk_si;
  double Qbdj2_Vsi_bi_Vgi_bi;
  double Qbdj2_Vsi_bi_Vdi_bi;
  double Qbdj2_Vsi_bi_Vsi_bi;
  double Qbdj2_Vdi_bi_Tempt_GND;
  double Qbdj2_Vdi_bi_Vdbulk_di;
  double Qbdj2_Vdi_bi_Vsbulk_si;
  double Qbdj2_Vdi_bi_Vgi_bi;
  double Qbdj2_Vdi_bi_Vdi_bi;
  double Qbdj2_Vdi_bi_Vsi_bi;
  double Qbdj2_Vgi_bi_Tempt_GND;
  double Qbdj2_Vgi_bi_Vdbulk_di;
  double Qbdj2_Vgi_bi_Vsbulk_si;
  double Qbdj2_Vgi_bi_Vgi_bi;
  double Qbdj2_Vgi_bi_Vdi_bi;
  double Qbdj2_Vgi_bi_Vsi_bi;
  double Qbdj2_Vsbulk_si_Tempt_GND;
  double Qbdj2_Vsbulk_si_Vdbulk_di;
  double Qbdj2_Vsbulk_si_Vsbulk_si;
  double Qbdj2_Vsbulk_si_Vgi_bi;
  double Qbdj2_Vsbulk_si_Vdi_bi;
  double Qbdj2_Vsbulk_si_Vsi_bi;
  double Qbdj2_Vdbulk_di_Tempt_GND;
  double Qbdj2_Vdbulk_di_Vdbulk_di;
  double Qbdj2_Vdbulk_di_Vsbulk_si;
  double Qbdj2_Vdbulk_di_Vgi_bi;
  double Qbdj2_Vdbulk_di_Vdi_bi;
  double Qbdj2_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qbdj1;
#if defined(_DERIVATEFORDDX)
double Qbdj1_Tempt_GND;
double Qbdj1_Vdbulk_di;
double Qbdj1_Vsbulk_si;
double Qbdj1_Vgi_bi;
double Qbdj1_Vdi_bi;
double Qbdj1_Vsi_bi;
#if defined(_DERIVATE2)
  double Qbdj1_Vsi_bi_Tempt_GND;
  double Qbdj1_Vsi_bi_Vdbulk_di;
  double Qbdj1_Vsi_bi_Vsbulk_si;
  double Qbdj1_Vsi_bi_Vgi_bi;
  double Qbdj1_Vsi_bi_Vdi_bi;
  double Qbdj1_Vsi_bi_Vsi_bi;
  double Qbdj1_Vdi_bi_Tempt_GND;
  double Qbdj1_Vdi_bi_Vdbulk_di;
  double Qbdj1_Vdi_bi_Vsbulk_si;
  double Qbdj1_Vdi_bi_Vgi_bi;
  double Qbdj1_Vdi_bi_Vdi_bi;
  double Qbdj1_Vdi_bi_Vsi_bi;
  double Qbdj1_Vgi_bi_Tempt_GND;
  double Qbdj1_Vgi_bi_Vdbulk_di;
  double Qbdj1_Vgi_bi_Vsbulk_si;
  double Qbdj1_Vgi_bi_Vgi_bi;
  double Qbdj1_Vgi_bi_Vdi_bi;
  double Qbdj1_Vgi_bi_Vsi_bi;
  double Qbdj1_Vsbulk_si_Tempt_GND;
  double Qbdj1_Vsbulk_si_Vdbulk_di;
  double Qbdj1_Vsbulk_si_Vsbulk_si;
  double Qbdj1_Vsbulk_si_Vgi_bi;
  double Qbdj1_Vsbulk_si_Vdi_bi;
  double Qbdj1_Vsbulk_si_Vsi_bi;
  double Qbdj1_Vdbulk_di_Tempt_GND;
  double Qbdj1_Vdbulk_di_Vdbulk_di;
  double Qbdj1_Vdbulk_di_Vsbulk_si;
  double Qbdj1_Vdbulk_di_Vgi_bi;
  double Qbdj1_Vdbulk_di_Vdi_bi;
  double Qbdj1_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double czbdswg_p2;
#endif
double czbdswg_p1;
#if defined(_DYNAMIC)
double czbdsw_p2;
#endif
double czbdsw_p1;
#if defined(_DYNAMIC)
double czbd_p2;
#endif
double czbd_p1;
double Czbdswg;
#if defined(_DERIVATE)
double Czbdswg_Tempt_GND;
#endif
double Czbdsw;
#if defined(_DERIVATE)
double Czbdsw_Tempt_GND;
#endif
double Czbd;
#if defined(_DERIVATE)
double Czbd_Tempt_GND;
#endif
#if defined(_DYNAMIC)
double Qbsj;
#if defined(_DERIVATEFORDDX)
double Qbsj_Tempt_GND;
double Qbsj_Vdbulk_di;
double Qbsj_Vsbulk_si;
double Qbsj_Vgi_bi;
double Qbsj_Vdi_bi;
double Qbsj_Vsi_bi;
#if defined(_DERIVATE2)
  double Qbsj_Vsi_bi_Tempt_GND;
  double Qbsj_Vsi_bi_Vdbulk_di;
  double Qbsj_Vsi_bi_Vsbulk_si;
  double Qbsj_Vsi_bi_Vgi_bi;
  double Qbsj_Vsi_bi_Vdi_bi;
  double Qbsj_Vsi_bi_Vsi_bi;
  double Qbsj_Vdi_bi_Tempt_GND;
  double Qbsj_Vdi_bi_Vdbulk_di;
  double Qbsj_Vdi_bi_Vsbulk_si;
  double Qbsj_Vdi_bi_Vgi_bi;
  double Qbsj_Vdi_bi_Vdi_bi;
  double Qbsj_Vdi_bi_Vsi_bi;
  double Qbsj_Vgi_bi_Tempt_GND;
  double Qbsj_Vgi_bi_Vdbulk_di;
  double Qbsj_Vgi_bi_Vsbulk_si;
  double Qbsj_Vgi_bi_Vgi_bi;
  double Qbsj_Vgi_bi_Vdi_bi;
  double Qbsj_Vgi_bi_Vsi_bi;
  double Qbsj_Vsbulk_si_Tempt_GND;
  double Qbsj_Vsbulk_si_Vdbulk_di;
  double Qbsj_Vsbulk_si_Vsbulk_si;
  double Qbsj_Vsbulk_si_Vgi_bi;
  double Qbsj_Vsbulk_si_Vdi_bi;
  double Qbsj_Vsbulk_si_Vsi_bi;
  double Qbsj_Vdbulk_di_Tempt_GND;
  double Qbsj_Vdbulk_di_Vdbulk_di;
  double Qbsj_Vdbulk_di_Vsbulk_si;
  double Qbsj_Vdbulk_di_Vgi_bi;
  double Qbsj_Vdbulk_di_Vdi_bi;
  double Qbsj_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qbsj3;
#if defined(_DERIVATEFORDDX)
double Qbsj3_Tempt_GND;
double Qbsj3_Vdbulk_di;
double Qbsj3_Vsbulk_si;
double Qbsj3_Vgi_bi;
double Qbsj3_Vdi_bi;
double Qbsj3_Vsi_bi;
#if defined(_DERIVATE2)
  double Qbsj3_Vsi_bi_Tempt_GND;
  double Qbsj3_Vsi_bi_Vdbulk_di;
  double Qbsj3_Vsi_bi_Vsbulk_si;
  double Qbsj3_Vsi_bi_Vgi_bi;
  double Qbsj3_Vsi_bi_Vdi_bi;
  double Qbsj3_Vsi_bi_Vsi_bi;
  double Qbsj3_Vdi_bi_Tempt_GND;
  double Qbsj3_Vdi_bi_Vdbulk_di;
  double Qbsj3_Vdi_bi_Vsbulk_si;
  double Qbsj3_Vdi_bi_Vgi_bi;
  double Qbsj3_Vdi_bi_Vdi_bi;
  double Qbsj3_Vdi_bi_Vsi_bi;
  double Qbsj3_Vgi_bi_Tempt_GND;
  double Qbsj3_Vgi_bi_Vdbulk_di;
  double Qbsj3_Vgi_bi_Vsbulk_si;
  double Qbsj3_Vgi_bi_Vgi_bi;
  double Qbsj3_Vgi_bi_Vdi_bi;
  double Qbsj3_Vgi_bi_Vsi_bi;
  double Qbsj3_Vsbulk_si_Tempt_GND;
  double Qbsj3_Vsbulk_si_Vdbulk_di;
  double Qbsj3_Vsbulk_si_Vsbulk_si;
  double Qbsj3_Vsbulk_si_Vgi_bi;
  double Qbsj3_Vsbulk_si_Vdi_bi;
  double Qbsj3_Vsbulk_si_Vsi_bi;
  double Qbsj3_Vdbulk_di_Tempt_GND;
  double Qbsj3_Vdbulk_di_Vdbulk_di;
  double Qbsj3_Vdbulk_di_Vsbulk_si;
  double Qbsj3_Vdbulk_di_Vgi_bi;
  double Qbsj3_Vdbulk_di_Vdi_bi;
  double Qbsj3_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qbsj2;
#if defined(_DERIVATEFORDDX)
double Qbsj2_Tempt_GND;
double Qbsj2_Vdbulk_di;
double Qbsj2_Vsbulk_si;
double Qbsj2_Vgi_bi;
double Qbsj2_Vdi_bi;
double Qbsj2_Vsi_bi;
#if defined(_DERIVATE2)
  double Qbsj2_Vsi_bi_Tempt_GND;
  double Qbsj2_Vsi_bi_Vdbulk_di;
  double Qbsj2_Vsi_bi_Vsbulk_si;
  double Qbsj2_Vsi_bi_Vgi_bi;
  double Qbsj2_Vsi_bi_Vdi_bi;
  double Qbsj2_Vsi_bi_Vsi_bi;
  double Qbsj2_Vdi_bi_Tempt_GND;
  double Qbsj2_Vdi_bi_Vdbulk_di;
  double Qbsj2_Vdi_bi_Vsbulk_si;
  double Qbsj2_Vdi_bi_Vgi_bi;
  double Qbsj2_Vdi_bi_Vdi_bi;
  double Qbsj2_Vdi_bi_Vsi_bi;
  double Qbsj2_Vgi_bi_Tempt_GND;
  double Qbsj2_Vgi_bi_Vdbulk_di;
  double Qbsj2_Vgi_bi_Vsbulk_si;
  double Qbsj2_Vgi_bi_Vgi_bi;
  double Qbsj2_Vgi_bi_Vdi_bi;
  double Qbsj2_Vgi_bi_Vsi_bi;
  double Qbsj2_Vsbulk_si_Tempt_GND;
  double Qbsj2_Vsbulk_si_Vdbulk_di;
  double Qbsj2_Vsbulk_si_Vsbulk_si;
  double Qbsj2_Vsbulk_si_Vgi_bi;
  double Qbsj2_Vsbulk_si_Vdi_bi;
  double Qbsj2_Vsbulk_si_Vsi_bi;
  double Qbsj2_Vdbulk_di_Tempt_GND;
  double Qbsj2_Vdbulk_di_Vdbulk_di;
  double Qbsj2_Vdbulk_di_Vsbulk_si;
  double Qbsj2_Vdbulk_di_Vgi_bi;
  double Qbsj2_Vdbulk_di_Vdi_bi;
  double Qbsj2_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qbsj1;
#if defined(_DERIVATEFORDDX)
double Qbsj1_Tempt_GND;
double Qbsj1_Vdbulk_di;
double Qbsj1_Vsbulk_si;
double Qbsj1_Vgi_bi;
double Qbsj1_Vdi_bi;
double Qbsj1_Vsi_bi;
#if defined(_DERIVATE2)
  double Qbsj1_Vsi_bi_Tempt_GND;
  double Qbsj1_Vsi_bi_Vdbulk_di;
  double Qbsj1_Vsi_bi_Vsbulk_si;
  double Qbsj1_Vsi_bi_Vgi_bi;
  double Qbsj1_Vsi_bi_Vdi_bi;
  double Qbsj1_Vsi_bi_Vsi_bi;
  double Qbsj1_Vdi_bi_Tempt_GND;
  double Qbsj1_Vdi_bi_Vdbulk_di;
  double Qbsj1_Vdi_bi_Vsbulk_si;
  double Qbsj1_Vdi_bi_Vgi_bi;
  double Qbsj1_Vdi_bi_Vdi_bi;
  double Qbsj1_Vdi_bi_Vsi_bi;
  double Qbsj1_Vgi_bi_Tempt_GND;
  double Qbsj1_Vgi_bi_Vdbulk_di;
  double Qbsj1_Vgi_bi_Vsbulk_si;
  double Qbsj1_Vgi_bi_Vgi_bi;
  double Qbsj1_Vgi_bi_Vdi_bi;
  double Qbsj1_Vgi_bi_Vsi_bi;
  double Qbsj1_Vsbulk_si_Tempt_GND;
  double Qbsj1_Vsbulk_si_Vdbulk_di;
  double Qbsj1_Vsbulk_si_Vsbulk_si;
  double Qbsj1_Vsbulk_si_Vgi_bi;
  double Qbsj1_Vsbulk_si_Vdi_bi;
  double Qbsj1_Vsbulk_si_Vsi_bi;
  double Qbsj1_Vdbulk_di_Tempt_GND;
  double Qbsj1_Vdbulk_di_Vdbulk_di;
  double Qbsj1_Vdbulk_di_Vsbulk_si;
  double Qbsj1_Vdbulk_di_Vgi_bi;
  double Qbsj1_Vdbulk_di_Vdi_bi;
  double Qbsj1_Vdbulk_di_Vsi_bi;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double sarg;
#if defined(_DERIVATEFORDDX)
double sarg_Vdbulk_di;
double sarg_Vsbulk_si;
double sarg_Vgi_bi;
double sarg_Vdi_bi;
double sarg_Vsi_bi;
double sarg_Tempt_GND;
#if defined(_DERIVATE2)
  double sarg_Vsi_bi_Vdbulk_di;
  double sarg_Vsi_bi_Vsbulk_si;
  double sarg_Vsi_bi_Vgi_bi;
  double sarg_Vsi_bi_Vdi_bi;
  double sarg_Vsi_bi_Vsi_bi;
  double sarg_Vsi_bi_Tempt_GND;
  double sarg_Vdi_bi_Vdbulk_di;
  double sarg_Vdi_bi_Vsbulk_si;
  double sarg_Vdi_bi_Vgi_bi;
  double sarg_Vdi_bi_Vdi_bi;
  double sarg_Vdi_bi_Vsi_bi;
  double sarg_Vdi_bi_Tempt_GND;
  double sarg_Vgi_bi_Vdbulk_di;
  double sarg_Vgi_bi_Vsbulk_si;
  double sarg_Vgi_bi_Vgi_bi;
  double sarg_Vgi_bi_Vdi_bi;
  double sarg_Vgi_bi_Vsi_bi;
  double sarg_Vgi_bi_Tempt_GND;
  double sarg_Vsbulk_si_Vdbulk_di;
  double sarg_Vsbulk_si_Vsbulk_si;
  double sarg_Vsbulk_si_Vgi_bi;
  double sarg_Vsbulk_si_Vdi_bi;
  double sarg_Vsbulk_si_Vsi_bi;
  double sarg_Vsbulk_si_Tempt_GND;
  double sarg_Vdbulk_di_Vdbulk_di;
  double sarg_Vdbulk_di_Vsbulk_si;
  double sarg_Vdbulk_di_Vgi_bi;
  double sarg_Vdbulk_di_Vdi_bi;
  double sarg_Vdbulk_di_Vsi_bi;
  double sarg_Vdbulk_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double arg;
#if defined(_DERIVATEFORDDX)
double arg_Vdbulk_di;
double arg_Vsbulk_si;
double arg_Vgi_bi;
double arg_Vdi_bi;
double arg_Vsi_bi;
double arg_Tempt_GND;
#if defined(_DERIVATE2)
  double arg_Vsi_bi_Vdbulk_di;
  double arg_Vsi_bi_Vsbulk_si;
  double arg_Vsi_bi_Vgi_bi;
  double arg_Vsi_bi_Vdi_bi;
  double arg_Vsi_bi_Vsi_bi;
  double arg_Vsi_bi_Tempt_GND;
  double arg_Vdi_bi_Vdbulk_di;
  double arg_Vdi_bi_Vsbulk_si;
  double arg_Vdi_bi_Vgi_bi;
  double arg_Vdi_bi_Vdi_bi;
  double arg_Vdi_bi_Vsi_bi;
  double arg_Vdi_bi_Tempt_GND;
  double arg_Vgi_bi_Vdbulk_di;
  double arg_Vgi_bi_Vsbulk_si;
  double arg_Vgi_bi_Vgi_bi;
  double arg_Vgi_bi_Vdi_bi;
  double arg_Vgi_bi_Vsi_bi;
  double arg_Vgi_bi_Tempt_GND;
  double arg_Vsbulk_si_Vdbulk_di;
  double arg_Vsbulk_si_Vsbulk_si;
  double arg_Vsbulk_si_Vgi_bi;
  double arg_Vsbulk_si_Vdi_bi;
  double arg_Vsbulk_si_Vsi_bi;
  double arg_Vsbulk_si_Tempt_GND;
  double arg_Vdbulk_di_Vdbulk_di;
  double arg_Vdbulk_di_Vsbulk_si;
  double arg_Vdbulk_di_Vgi_bi;
  double arg_Vdbulk_di_Vdi_bi;
  double arg_Vdbulk_di_Vsi_bi;
  double arg_Vdbulk_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double czbsswg_p2;
#endif
double czbsswg_p1;
#if defined(_DYNAMIC)
double czbssw_p2;
#endif
double czbssw_p1;
#if defined(_DYNAMIC)
double czbs_p2;
#endif
double czbs_p1;
double Czbsswg;
#if defined(_DERIVATE)
double Czbsswg_Tempt_GND;
#endif
double Czbssw;
#if defined(_DERIVATE)
double Czbssw_Tempt_GND;
#endif
double Czbs;
#if defined(_DERIVATE)
double Czbs_Tempt_GND;
#endif
double Ibd;
#if defined(_DERIVATE)
double Ibd_Vdbulk_di;
double Ibd_Vsbulk_si;
double Ibd_Vgi_bi;
double Ibd_Vdi_bi;
double Ibd_Vsi_bi;
double Ibd_Tempt_GND;
#endif
double Ibs;
#if defined(_DERIVATE)
double Ibs_Vsbulk_si;
double Ibs_Vgi_bi;
double Ibs_Vdi_bi;
double Ibs_Vsi_bi;
double Ibs_Tempt_GND;
#endif
#if defined(_DERIVATE)
double IGISL_Vgi_bi;
double IGISL_Vdi_bi;
double IGISL_Vsi_bi;
double IGISL_Tempt_GND;
#endif
#if defined(_DERIVATE)
double IGIDL_Vgi_bi;
double IGIDL_Vdi_bi;
double IGIDL_Vsi_bi;
double IGIDL_Tempt_GND;
#endif
double igidl;
#if defined(_DERIVATE)
double igidl_Vgi_bi;
double igidl_Vdi_bi;
double igidl_Vsi_bi;
double igidl_Tempt_GND;
#endif
double igisl;
#if defined(_DERIVATE)
double igisl_Vgi_bi;
double igisl_Vdi_bi;
double igisl_Vsi_bi;
double igisl_Tempt_GND;
#endif
#if defined(_DERIVATE)
double IGCD_Vgi_bi;
double IGCD_Vdi_bi;
double IGCD_Vsi_bi;
double IGCD_Tempt_GND;
#endif
#if defined(_DERIVATE)
double IGCS_Vgi_bi;
double IGCS_Vdi_bi;
double IGCS_Vsi_bi;
double IGCS_Tempt_GND;
#endif
#if defined(_DERIVATE)
double IGB_Vgi_bi;
double IGB_Vdi_bi;
double IGB_Vsi_bi;
double IGB_Tempt_GND;
#endif
#if defined(_DERIVATE)
double IGD_Tempt_GND;
double IGD_Vgi_bi;
double IGD_Vdi_bi;
double IGD_Vsi_bi;
#endif
#if defined(_DERIVATE)
double IGS_Tempt_GND;
double IGS_Vgi_bi;
double IGS_Vsi_bi;
double IGS_Vdi_bi;
#endif
double igd_mult;
#if defined(_DERIVATE)
double igd_mult_Tempt_GND;
#endif
double igs_mult;
#if defined(_DERIVATE)
double igs_mult_Tempt_GND;
#endif
double T1_exp;
#if defined(_DERIVATEFORDDX)
double T1_exp_Vgi_bi;
double T1_exp_Vdi_bi;
double T1_exp_Vsi_bi;
double T1_exp_Tempt_GND;
#if defined(_DERIVATE2)
  double T1_exp_Vsi_bi_Vgi_bi;
  double T1_exp_Vsi_bi_Vdi_bi;
  double T1_exp_Vsi_bi_Vsi_bi;
  double T1_exp_Vsi_bi_Tempt_GND;
  double T1_exp_Vdi_bi_Vgi_bi;
  double T1_exp_Vdi_bi_Vdi_bi;
  double T1_exp_Vdi_bi_Vsi_bi;
  double T1_exp_Vdi_bi_Tempt_GND;
  double T1_exp_Vgi_bi_Vgi_bi;
  double T1_exp_Vgi_bi_Vdi_bi;
  double T1_exp_Vgi_bi_Vsi_bi;
  double T1_exp_Vgi_bi_Tempt_GND;
#endif
#endif
double Vdseffx;
#if defined(_DERIVATEFORDDX)
double Vdseffx_Vdi_bi;
double Vdseffx_Vsi_bi;
double Vdseffx_Vgi_bi;
double Vdseffx_Tempt_GND;
#if defined(_DERIVATE2)
  double Vdseffx_Vgi_bi_Vdi_bi;
  double Vdseffx_Vgi_bi_Vsi_bi;
  double Vdseffx_Vgi_bi_Vgi_bi;
  double Vdseffx_Vgi_bi_Tempt_GND;
  double Vdseffx_Vsi_bi_Vdi_bi;
  double Vdseffx_Vsi_bi_Vsi_bi;
  double Vdseffx_Vsi_bi_Vgi_bi;
  double Vdseffx_Vsi_bi_Tempt_GND;
  double Vdseffx_Vdi_bi_Vdi_bi;
  double Vdseffx_Vdi_bi_Vsi_bi;
  double Vdseffx_Vdi_bi_Vgi_bi;
  double Vdseffx_Vdi_bi_Tempt_GND;
#endif
#endif
double igc0;
#if defined(_DERIVATE)
double igc0_Vgi_bi;
double igc0_Vdi_bi;
double igc0_Vsi_bi;
double igc0_Tempt_GND;
#endif
double Vaux_Igbinv;
#if defined(_DERIVATE)
double Vaux_Igbinv_Tempt_GND;
double Vaux_Igbinv_Vgi_bi;
double Vaux_Igbinv_Vdi_bi;
double Vaux_Igbinv_Vsi_bi;
#endif
double Vaux_Igbacc;
#if defined(_DERIVATE)
double Vaux_Igbacc_Tempt_GND;
double Vaux_Igbacc_Vgi_bi;
double Vaux_Igbacc_Vdi_bi;
double Vaux_Igbacc_Vsi_bi;
#endif
double Voxminv;
#if defined(_DERIVATEFORDDX)
double Voxminv_Vdi_bi;
double Voxminv_Vsi_bi;
double Voxminv_Tempt_GND;
double Voxminv_Vgi_bi;
#if defined(_DERIVATE2)
  double Voxminv_Vgi_bi_Vdi_bi;
  double Voxminv_Vgi_bi_Vsi_bi;
  double Voxminv_Vgi_bi_Tempt_GND;
  double Voxminv_Vgi_bi_Vgi_bi;
  double Voxminv_Vsi_bi_Vdi_bi;
  double Voxminv_Vsi_bi_Vsi_bi;
  double Voxminv_Vsi_bi_Tempt_GND;
  double Voxminv_Vsi_bi_Vgi_bi;
  double Voxminv_Vdi_bi_Vdi_bi;
  double Voxminv_Vdi_bi_Vsi_bi;
  double Voxminv_Vdi_bi_Tempt_GND;
  double Voxminv_Vdi_bi_Vgi_bi;
#endif
#endif
double Voxmacc;
#if defined(_DERIVATEFORDDX)
double Voxmacc_Vdi_bi;
double Voxmacc_Vsi_bi;
double Voxmacc_Tempt_GND;
double Voxmacc_Vgi_bi;
#if defined(_DERIVATE2)
  double Voxmacc_Vgi_bi_Vdi_bi;
  double Voxmacc_Vgi_bi_Vsi_bi;
  double Voxmacc_Vgi_bi_Tempt_GND;
  double Voxmacc_Vgi_bi_Vgi_bi;
  double Voxmacc_Vsi_bi_Vdi_bi;
  double Voxmacc_Vsi_bi_Vsi_bi;
  double Voxmacc_Vsi_bi_Tempt_GND;
  double Voxmacc_Vsi_bi_Vgi_bi;
  double Voxmacc_Vdi_bi_Vdi_bi;
  double Voxmacc_Vdi_bi_Vsi_bi;
  double Voxmacc_Vdi_bi_Tempt_GND;
  double Voxmacc_Vdi_bi_Vgi_bi;
#endif
#endif
double Voxm;
#if defined(_DERIVATEFORDDX)
double Voxm_Vdi_bi;
double Voxm_Vsi_bi;
double Voxm_Tempt_GND;
double Voxm_Vgi_bi;
#if defined(_DERIVATE2)
  double Voxm_Vgi_bi_Vdi_bi;
  double Voxm_Vgi_bi_Vsi_bi;
  double Voxm_Vgi_bi_Tempt_GND;
  double Voxm_Vgi_bi_Vgi_bi;
  double Voxm_Vsi_bi_Vdi_bi;
  double Voxm_Vsi_bi_Vsi_bi;
  double Voxm_Vsi_bi_Tempt_GND;
  double Voxm_Vsi_bi_Vgi_bi;
  double Voxm_Vdi_bi_Vdi_bi;
  double Voxm_Vdi_bi_Vsi_bi;
  double Voxm_Vdi_bi_Tempt_GND;
  double Voxm_Vdi_bi_Vgi_bi;
#endif
#endif
double igd;
#if defined(_DERIVATE)
double igd_Tempt_GND;
double igd_Vgi_bi;
double igd_Vdi_bi;
double igd_Vsi_bi;
#endif
double igs;
#if defined(_DERIVATE)
double igs_Tempt_GND;
double igs_Vgi_bi;
double igs_Vsi_bi;
double igs_Vdi_bi;
#endif
double igcd;
#if defined(_DERIVATE)
double igcd_Vgi_bi;
double igcd_Vdi_bi;
double igcd_Vsi_bi;
double igcd_Tempt_GND;
#endif
double igcs;
#if defined(_DERIVATE)
double igcs_Vgi_bi;
double igcs_Vdi_bi;
double igcs_Vsi_bi;
double igcs_Tempt_GND;
#endif
double igb;
#if defined(_DERIVATE)
double igb_Vgi_bi;
double igb_Vdi_bi;
double igb_Vsi_bi;
double igb_Tempt_GND;
#endif
double igbacc;
#if defined(_DERIVATE)
double igbacc_Vgi_bi;
double igbacc_Vdi_bi;
double igbacc_Vsi_bi;
double igbacc_Tempt_GND;
#endif
double igbinv;
#if defined(_DERIVATE)
double igbinv_Vgi_bi;
double igbinv_Vdi_bi;
double igbinv_Vsi_bi;
double igbinv_Tempt_GND;
#endif
#if defined(_DERIVATE)
double ISUB_Vdi_bi;
double ISUB_Vsi_bi;
double ISUB_Vgi_bi;
double ISUB_Tempt_GND;
#endif
double Iii;
#if defined(_DERIVATE)
double Iii_Vdi_bi;
double Iii_Vsi_bi;
double Iii_Vgi_bi;
double Iii_Tempt_GND;
#endif
double idsovvds;
#if defined(_DERIVATE)
double idsovvds_Tempt_GND;
double idsovvds_Vdi_bi;
double idsovvds_Vsi_bi;
double idsovvds_Vgi_bi;
#endif
double Gcrg;
#if defined(_DERIVATE)
double Gcrg_Vgi_bi;
double Gcrg_Vdi_bi;
double Gcrg_Vsi_bi;
double Gcrg_Tempt_GND;
#endif
double ids;
#if defined(_DERIVATEFORDDX)
double ids_Vgm_si;
double ids_Vgm_di;
double ids_Vdbulk_di;
double ids_Vsbulk_si;
double ids_Vgi_bi;
double ids_Tempt_GND;
double ids_Vdi_bi;
double ids_Vsi_bi;
#if defined(_DERIVATE2)
  double ids_Vsi_bi_Vgm_si;
  double ids_Vsi_bi_Vgm_di;
  double ids_Vsi_bi_Vdbulk_di;
  double ids_Vsi_bi_Vsbulk_si;
  double ids_Vsi_bi_Vgi_bi;
  double ids_Vsi_bi_Tempt_GND;
  double ids_Vsi_bi_Vdi_bi;
  double ids_Vsi_bi_Vsi_bi;
  double ids_Vdi_bi_Vgm_si;
  double ids_Vdi_bi_Vgm_di;
  double ids_Vdi_bi_Vdbulk_di;
  double ids_Vdi_bi_Vsbulk_si;
  double ids_Vdi_bi_Vgi_bi;
  double ids_Vdi_bi_Tempt_GND;
  double ids_Vdi_bi_Vdi_bi;
  double ids_Vdi_bi_Vsi_bi;
  double ids_Vgi_bi_Vgm_si;
  double ids_Vgi_bi_Vgm_di;
  double ids_Vgi_bi_Vdbulk_di;
  double ids_Vgi_bi_Vsbulk_si;
  double ids_Vgi_bi_Vgi_bi;
  double ids_Vgi_bi_Tempt_GND;
  double ids_Vgi_bi_Vdi_bi;
  double ids_Vgi_bi_Vsi_bi;
  double ids_Vsbulk_si_Vgm_si;
  double ids_Vsbulk_si_Vgm_di;
  double ids_Vsbulk_si_Vdbulk_di;
  double ids_Vsbulk_si_Vsbulk_si;
  double ids_Vsbulk_si_Vgi_bi;
  double ids_Vsbulk_si_Tempt_GND;
  double ids_Vsbulk_si_Vdi_bi;
  double ids_Vsbulk_si_Vsi_bi;
  double ids_Vdbulk_di_Vgm_si;
  double ids_Vdbulk_di_Vgm_di;
  double ids_Vdbulk_di_Vdbulk_di;
  double ids_Vdbulk_di_Vsbulk_si;
  double ids_Vdbulk_di_Vgi_bi;
  double ids_Vdbulk_di_Tempt_GND;
  double ids_Vdbulk_di_Vdi_bi;
  double ids_Vdbulk_di_Vsi_bi;
  double ids_Vgm_di_Vgm_si;
  double ids_Vgm_di_Vgm_di;
  double ids_Vgm_di_Vdbulk_di;
  double ids_Vgm_di_Vsbulk_si;
  double ids_Vgm_di_Vgi_bi;
  double ids_Vgm_di_Tempt_GND;
  double ids_Vgm_di_Vdi_bi;
  double ids_Vgm_di_Vsi_bi;
  double ids_Vgm_si_Vgm_si;
  double ids_Vgm_si_Vgm_di;
  double ids_Vgm_si_Vdbulk_di;
  double ids_Vgm_si_Vsbulk_si;
  double ids_Vgm_si_Vgi_bi;
  double ids_Vgm_si_Tempt_GND;
  double ids_Vgm_si_Vdi_bi;
  double ids_Vgm_si_Vsi_bi;
#endif
#endif
double ueff;
#if defined(_DERIVATEFORDDX)
double ueff_Tempt_GND;
double ueff_Vdi_bi;
double ueff_Vsi_bi;
double ueff_Vgi_bi;
#if defined(_DERIVATE2)
  double ueff_Vgi_bi_Tempt_GND;
  double ueff_Vgi_bi_Vdi_bi;
  double ueff_Vgi_bi_Vsi_bi;
  double ueff_Vgi_bi_Vgi_bi;
  double ueff_Vsi_bi_Tempt_GND;
  double ueff_Vsi_bi_Vdi_bi;
  double ueff_Vsi_bi_Vsi_bi;
  double ueff_Vsi_bi_Vgi_bi;
  double ueff_Vdi_bi_Tempt_GND;
  double ueff_Vdi_bi_Vdi_bi;
  double ueff_Vdi_bi_Vsi_bi;
  double ueff_Vdi_bi_Vgi_bi;
#endif
#endif
double Dtot;
#if defined(_DERIVATEFORDDX)
double Dtot_Vgi_bi;
double Dtot_Vdi_bi;
double Dtot_Vsi_bi;
double Dtot_Tempt_GND;
#if defined(_DERIVATE2)
  double Dtot_Vsi_bi_Vgi_bi;
  double Dtot_Vsi_bi_Vdi_bi;
  double Dtot_Vsi_bi_Vsi_bi;
  double Dtot_Vsi_bi_Tempt_GND;
  double Dtot_Vdi_bi_Vgi_bi;
  double Dtot_Vdi_bi_Vdi_bi;
  double Dtot_Vdi_bi_Vsi_bi;
  double Dtot_Vdi_bi_Tempt_GND;
  double Dtot_Vgi_bi_Vgi_bi;
  double Dtot_Vgi_bi_Vdi_bi;
  double Dtot_Vgi_bi_Vsi_bi;
  double Dtot_Vgi_bi_Tempt_GND;
#endif
#endif
double Mnud;
#if defined(_DERIVATEFORDDX)
double Mnud_Vgi_bi;
double Mnud_Vdi_bi;
double Mnud_Vsi_bi;
double Mnud_Tempt_GND;
#if defined(_DERIVATE2)
  double Mnud_Vsi_bi_Vgi_bi;
  double Mnud_Vsi_bi_Vdi_bi;
  double Mnud_Vsi_bi_Vsi_bi;
  double Mnud_Vsi_bi_Tempt_GND;
  double Mnud_Vdi_bi_Vgi_bi;
  double Mnud_Vdi_bi_Vdi_bi;
  double Mnud_Vdi_bi_Vsi_bi;
  double Mnud_Vdi_bi_Tempt_GND;
  double Mnud_Vgi_bi_Vgi_bi;
  double Mnud_Vgi_bi_Vdi_bi;
  double Mnud_Vgi_bi_Vsi_bi;
  double Mnud_Vgi_bi_Tempt_GND;
#endif
#endif
double Nsat;
#if defined(_DERIVATEFORDDX)
double Nsat_Vgi_bi;
double Nsat_Vdi_bi;
double Nsat_Vsi_bi;
double Nsat_Tempt_GND;
#if defined(_DERIVATE2)
  double Nsat_Vsi_bi_Vgi_bi;
  double Nsat_Vsi_bi_Vdi_bi;
  double Nsat_Vsi_bi_Vsi_bi;
  double Nsat_Vsi_bi_Tempt_GND;
  double Nsat_Vdi_bi_Vgi_bi;
  double Nsat_Vdi_bi_Vdi_bi;
  double Nsat_Vdi_bi_Vsi_bi;
  double Nsat_Vdi_bi_Tempt_GND;
  double Nsat_Vgi_bi_Vgi_bi;
  double Nsat_Vgi_bi_Vdi_bi;
  double Nsat_Vgi_bi_Vsi_bi;
  double Nsat_Vgi_bi_Tempt_GND;
#endif
#endif
double DQSD;
#if defined(_DERIVATEFORDDX)
double DQSD_Vdbulk_di;
double DQSD_Vsbulk_si;
double DQSD_Vgi_bi;
double DQSD_Vdi_bi;
double DQSD_Vsi_bi;
double DQSD_Tempt_GND;
#if defined(_DERIVATE2)
  double DQSD_Vsi_bi_Vdbulk_di;
  double DQSD_Vsi_bi_Vsbulk_si;
  double DQSD_Vsi_bi_Vgi_bi;
  double DQSD_Vsi_bi_Vdi_bi;
  double DQSD_Vsi_bi_Vsi_bi;
  double DQSD_Vsi_bi_Tempt_GND;
  double DQSD_Vdi_bi_Vdbulk_di;
  double DQSD_Vdi_bi_Vsbulk_si;
  double DQSD_Vdi_bi_Vgi_bi;
  double DQSD_Vdi_bi_Vdi_bi;
  double DQSD_Vdi_bi_Vsi_bi;
  double DQSD_Vdi_bi_Tempt_GND;
  double DQSD_Vgi_bi_Vdbulk_di;
  double DQSD_Vgi_bi_Vsbulk_si;
  double DQSD_Vgi_bi_Vgi_bi;
  double DQSD_Vgi_bi_Vdi_bi;
  double DQSD_Vgi_bi_Vsi_bi;
  double DQSD_Vgi_bi_Tempt_GND;
  double DQSD_Vsbulk_si_Vdbulk_di;
  double DQSD_Vsbulk_si_Vsbulk_si;
  double DQSD_Vsbulk_si_Vgi_bi;
  double DQSD_Vsbulk_si_Vdi_bi;
  double DQSD_Vsbulk_si_Vsi_bi;
  double DQSD_Vsbulk_si_Tempt_GND;
  double DQSD_Vdbulk_di_Vdbulk_di;
  double DQSD_Vdbulk_di_Vsbulk_si;
  double DQSD_Vdbulk_di_Vgi_bi;
  double DQSD_Vdbulk_di_Vdi_bi;
  double DQSD_Vdbulk_di_Vsi_bi;
  double DQSD_Vdbulk_di_Tempt_GND;
#endif
#endif
double Vgd_eff;
#if defined(_DERIVATEFORDDX)
double Vgd_eff_Vgi_bi;
double Vgd_eff_Vdi_bi;
double Vgd_eff_Vsi_bi;
double Vgd_eff_Tempt_GND;
#if defined(_DERIVATE2)
  double Vgd_eff_Vsi_bi_Vgi_bi;
  double Vgd_eff_Vsi_bi_Vdi_bi;
  double Vgd_eff_Vsi_bi_Vsi_bi;
  double Vgd_eff_Vsi_bi_Tempt_GND;
  double Vgd_eff_Vdi_bi_Vgi_bi;
  double Vgd_eff_Vdi_bi_Vdi_bi;
  double Vgd_eff_Vdi_bi_Vsi_bi;
  double Vgd_eff_Vdi_bi_Tempt_GND;
  double Vgd_eff_Vgi_bi_Vgi_bi;
  double Vgd_eff_Vgi_bi_Vdi_bi;
  double Vgd_eff_Vgi_bi_Vsi_bi;
  double Vgd_eff_Vgi_bi_Tempt_GND;
#endif
#endif
double Vgs_eff;
#if defined(_DERIVATEFORDDX)
double Vgs_eff_Vgi_bi;
double Vgs_eff_Vdi_bi;
double Vgs_eff_Vsi_bi;
double Vgs_eff_Tempt_GND;
#if defined(_DERIVATE2)
  double Vgs_eff_Vsi_bi_Vgi_bi;
  double Vgs_eff_Vsi_bi_Vdi_bi;
  double Vgs_eff_Vsi_bi_Vsi_bi;
  double Vgs_eff_Vsi_bi_Tempt_GND;
  double Vgs_eff_Vdi_bi_Vgi_bi;
  double Vgs_eff_Vdi_bi_Vdi_bi;
  double Vgs_eff_Vdi_bi_Vsi_bi;
  double Vgs_eff_Vdi_bi_Tempt_GND;
  double Vgs_eff_Vgi_bi_Vgi_bi;
  double Vgs_eff_Vgi_bi_Vdi_bi;
  double Vgs_eff_Vgi_bi_Vsi_bi;
  double Vgs_eff_Vgi_bi_Tempt_GND;
#endif
#endif
double Dr;
#if defined(_DERIVATEFORDDX)
double Dr_Tempt_GND;
double Dr_Vdi_bi;
double Dr_Vsi_bi;
double Dr_Vgi_bi;
#if defined(_DERIVATE2)
  double Dr_Vgi_bi_Tempt_GND;
  double Dr_Vgi_bi_Vdi_bi;
  double Dr_Vgi_bi_Vsi_bi;
  double Dr_Vgi_bi_Vgi_bi;
  double Dr_Vsi_bi_Tempt_GND;
  double Dr_Vsi_bi_Vdi_bi;
  double Dr_Vsi_bi_Vsi_bi;
  double Dr_Vsi_bi_Vgi_bi;
  double Dr_Vdi_bi_Tempt_GND;
  double Dr_Vdi_bi_Vdi_bi;
  double Dr_Vdi_bi_Vsi_bi;
  double Dr_Vdi_bi_Vgi_bi;
#endif
#endif
double Rdsi;
#if defined(_DERIVATEFORDDX)
double Rdsi_Tempt_GND;
double Rdsi_Vgi_bi;
double Rdsi_Vdi_bi;
double Rdsi_Vsi_bi;
#if defined(_DERIVATE2)
  double Rdsi_Vsi_bi_Tempt_GND;
  double Rdsi_Vsi_bi_Vgi_bi;
  double Rdsi_Vsi_bi_Vdi_bi;
  double Rdsi_Vsi_bi_Vsi_bi;
  double Rdsi_Vdi_bi_Tempt_GND;
  double Rdsi_Vdi_bi_Vgi_bi;
  double Rdsi_Vdi_bi_Vdi_bi;
  double Rdsi_Vdi_bi_Vsi_bi;
  double Rdsi_Vgi_bi_Tempt_GND;
  double Rdsi_Vgi_bi_Vgi_bi;
  double Rdsi_Vgi_bi_Vdi_bi;
  double Rdsi_Vgi_bi_Vsi_bi;
#endif
#endif
double Rdrain;
#if defined(_DERIVATE)
double Rdrain_Tempt_GND;
double Rdrain_Vgi_bi;
double Rdrain_Vdi_bi;
double Rdrain_Vsi_bi;
#endif
double Rsource;
#if defined(_DERIVATE)
double Rsource_Tempt_GND;
double Rsource_Vgi_bi;
double Rsource_Vdi_bi;
double Rsource_Vsi_bi;
#endif
double Dptwg;
#if defined(_DERIVATEFORDDX)
double Dptwg_Vgi_bi;
double Dptwg_Vdi_bi;
double Dptwg_Vsi_bi;
double Dptwg_Tempt_GND;
#if defined(_DERIVATE2)
  double Dptwg_Vsi_bi_Vgi_bi;
  double Dptwg_Vsi_bi_Vdi_bi;
  double Dptwg_Vsi_bi_Vsi_bi;
  double Dptwg_Vsi_bi_Tempt_GND;
  double Dptwg_Vdi_bi_Vgi_bi;
  double Dptwg_Vdi_bi_Vdi_bi;
  double Dptwg_Vdi_bi_Vsi_bi;
  double Dptwg_Vdi_bi_Tempt_GND;
  double Dptwg_Vgi_bi_Vgi_bi;
  double Dptwg_Vgi_bi_Vdi_bi;
  double Dptwg_Vgi_bi_Vsi_bi;
  double Dptwg_Vgi_bi_Tempt_GND;
#endif
#endif
double Dvsat;
#if defined(_DERIVATEFORDDX)
double Dvsat_Vdbulk_di;
double Dvsat_Vsbulk_si;
double Dvsat_Vgi_bi;
double Dvsat_Vdi_bi;
double Dvsat_Vsi_bi;
double Dvsat_Tempt_GND;
#if defined(_DERIVATE2)
  double Dvsat_Vsi_bi_Vdbulk_di;
  double Dvsat_Vsi_bi_Vsbulk_si;
  double Dvsat_Vsi_bi_Vgi_bi;
  double Dvsat_Vsi_bi_Vdi_bi;
  double Dvsat_Vsi_bi_Vsi_bi;
  double Dvsat_Vsi_bi_Tempt_GND;
  double Dvsat_Vdi_bi_Vdbulk_di;
  double Dvsat_Vdi_bi_Vsbulk_si;
  double Dvsat_Vdi_bi_Vgi_bi;
  double Dvsat_Vdi_bi_Vdi_bi;
  double Dvsat_Vdi_bi_Vsi_bi;
  double Dvsat_Vdi_bi_Tempt_GND;
  double Dvsat_Vgi_bi_Vdbulk_di;
  double Dvsat_Vgi_bi_Vsbulk_si;
  double Dvsat_Vgi_bi_Vgi_bi;
  double Dvsat_Vgi_bi_Vdi_bi;
  double Dvsat_Vgi_bi_Vsi_bi;
  double Dvsat_Vgi_bi_Tempt_GND;
  double Dvsat_Vsbulk_si_Vdbulk_di;
  double Dvsat_Vsbulk_si_Vsbulk_si;
  double Dvsat_Vsbulk_si_Vgi_bi;
  double Dvsat_Vsbulk_si_Vdi_bi;
  double Dvsat_Vsbulk_si_Vsi_bi;
  double Dvsat_Vsbulk_si_Tempt_GND;
  double Dvsat_Vdbulk_di_Vdbulk_di;
  double Dvsat_Vdbulk_di_Vsbulk_si;
  double Dvsat_Vdbulk_di_Vgi_bi;
  double Dvsat_Vdbulk_di_Vdi_bi;
  double Dvsat_Vdbulk_di_Vsi_bi;
  double Dvsat_Vdbulk_di_Tempt_GND;
#endif
#endif
double Mscbe;
#if defined(_DERIVATEFORDDX)
double Mscbe_Vdi_bi;
double Mscbe_Vsi_bi;
double Mscbe_Vgi_bi;
double Mscbe_Tempt_GND;
#if defined(_DERIVATE2)
  double Mscbe_Vgi_bi_Vdi_bi;
  double Mscbe_Vgi_bi_Vsi_bi;
  double Mscbe_Vgi_bi_Vgi_bi;
  double Mscbe_Vgi_bi_Tempt_GND;
  double Mscbe_Vsi_bi_Vdi_bi;
  double Mscbe_Vsi_bi_Vsi_bi;
  double Mscbe_Vsi_bi_Vgi_bi;
  double Mscbe_Vsi_bi_Tempt_GND;
  double Mscbe_Vdi_bi_Vdi_bi;
  double Mscbe_Vdi_bi_Vsi_bi;
  double Mscbe_Vdi_bi_Vgi_bi;
  double Mscbe_Vdi_bi_Tempt_GND;
#endif
#endif
double VaSCBE;
#if defined(_DERIVATEFORDDX)
double VaSCBE_Vgi_bi;
double VaSCBE_Vdi_bi;
double VaSCBE_Vsi_bi;
double VaSCBE_Tempt_GND;
#if defined(_DERIVATE2)
  double VaSCBE_Vsi_bi_Vgi_bi;
  double VaSCBE_Vsi_bi_Vdi_bi;
  double VaSCBE_Vsi_bi_Vsi_bi;
  double VaSCBE_Vsi_bi_Tempt_GND;
  double VaSCBE_Vdi_bi_Vgi_bi;
  double VaSCBE_Vdi_bi_Vdi_bi;
  double VaSCBE_Vdi_bi_Vsi_bi;
  double VaSCBE_Vdi_bi_Tempt_GND;
  double VaSCBE_Vgi_bi_Vgi_bi;
  double VaSCBE_Vgi_bi_Vdi_bi;
  double VaSCBE_Vgi_bi_Vsi_bi;
  double VaSCBE_Vgi_bi_Tempt_GND;
#endif
#endif
double VaDITS;
#if defined(_DERIVATEFORDDX)
double VaDITS_Vgi_bi;
double VaDITS_Vdi_bi;
double VaDITS_Vsi_bi;
double VaDITS_Tempt_GND;
#if defined(_DERIVATE2)
  double VaDITS_Vsi_bi_Vgi_bi;
  double VaDITS_Vsi_bi_Vdi_bi;
  double VaDITS_Vsi_bi_Vsi_bi;
  double VaDITS_Vsi_bi_Tempt_GND;
  double VaDITS_Vdi_bi_Vgi_bi;
  double VaDITS_Vdi_bi_Vdi_bi;
  double VaDITS_Vdi_bi_Vsi_bi;
  double VaDITS_Vdi_bi_Tempt_GND;
  double VaDITS_Vgi_bi_Vgi_bi;
  double VaDITS_Vgi_bi_Vdi_bi;
  double VaDITS_Vgi_bi_Vsi_bi;
  double VaDITS_Vgi_bi_Tempt_GND;
#endif
#endif
double MdL;
#if defined(_DERIVATEFORDDX)
double MdL_Vdbulk_di;
double MdL_Vsbulk_si;
double MdL_Vgi_bi;
double MdL_Vdi_bi;
double MdL_Vsi_bi;
double MdL_Tempt_GND;
#if defined(_DERIVATE2)
  double MdL_Vsi_bi_Vdbulk_di;
  double MdL_Vsi_bi_Vsbulk_si;
  double MdL_Vsi_bi_Vgi_bi;
  double MdL_Vsi_bi_Vdi_bi;
  double MdL_Vsi_bi_Vsi_bi;
  double MdL_Vsi_bi_Tempt_GND;
  double MdL_Vdi_bi_Vdbulk_di;
  double MdL_Vdi_bi_Vsbulk_si;
  double MdL_Vdi_bi_Vgi_bi;
  double MdL_Vdi_bi_Vdi_bi;
  double MdL_Vdi_bi_Vsi_bi;
  double MdL_Vdi_bi_Tempt_GND;
  double MdL_Vgi_bi_Vdbulk_di;
  double MdL_Vgi_bi_Vsbulk_si;
  double MdL_Vgi_bi_Vgi_bi;
  double MdL_Vgi_bi_Vdi_bi;
  double MdL_Vgi_bi_Vsi_bi;
  double MdL_Vgi_bi_Tempt_GND;
  double MdL_Vsbulk_si_Vdbulk_di;
  double MdL_Vsbulk_si_Vsbulk_si;
  double MdL_Vsbulk_si_Vgi_bi;
  double MdL_Vsbulk_si_Vdi_bi;
  double MdL_Vsbulk_si_Vsi_bi;
  double MdL_Vsbulk_si_Tempt_GND;
  double MdL_Vdbulk_di_Vdbulk_di;
  double MdL_Vdbulk_di_Vsbulk_si;
  double MdL_Vdbulk_di_Vgi_bi;
  double MdL_Vdbulk_di_Vdi_bi;
  double MdL_Vdbulk_di_Vsi_bi;
  double MdL_Vdbulk_di_Tempt_GND;
#endif
#endif
double Vasat;
#if defined(_DERIVATEFORDDX)
double Vasat_Vdbulk_di;
double Vasat_Vsbulk_si;
double Vasat_Vgi_bi;
double Vasat_Vdi_bi;
double Vasat_Vsi_bi;
double Vasat_Tempt_GND;
#if defined(_DERIVATE2)
  double Vasat_Vsi_bi_Vdbulk_di;
  double Vasat_Vsi_bi_Vsbulk_si;
  double Vasat_Vsi_bi_Vgi_bi;
  double Vasat_Vsi_bi_Vdi_bi;
  double Vasat_Vsi_bi_Vsi_bi;
  double Vasat_Vsi_bi_Tempt_GND;
  double Vasat_Vdi_bi_Vdbulk_di;
  double Vasat_Vdi_bi_Vsbulk_si;
  double Vasat_Vdi_bi_Vgi_bi;
  double Vasat_Vdi_bi_Vdi_bi;
  double Vasat_Vdi_bi_Vsi_bi;
  double Vasat_Vdi_bi_Tempt_GND;
  double Vasat_Vgi_bi_Vdbulk_di;
  double Vasat_Vgi_bi_Vsbulk_si;
  double Vasat_Vgi_bi_Vgi_bi;
  double Vasat_Vgi_bi_Vdi_bi;
  double Vasat_Vgi_bi_Vsi_bi;
  double Vasat_Vgi_bi_Tempt_GND;
  double Vasat_Vsbulk_si_Vdbulk_di;
  double Vasat_Vsbulk_si_Vsbulk_si;
  double Vasat_Vsbulk_si_Vgi_bi;
  double Vasat_Vsbulk_si_Vdi_bi;
  double Vasat_Vsbulk_si_Vsi_bi;
  double Vasat_Vsbulk_si_Tempt_GND;
  double Vasat_Vdbulk_di_Vdbulk_di;
  double Vasat_Vdbulk_di_Vsbulk_si;
  double Vasat_Vdbulk_di_Vgi_bi;
  double Vasat_Vdbulk_di_Vdi_bi;
  double Vasat_Vdbulk_di_Vsi_bi;
  double Vasat_Vdbulk_di_Tempt_GND;
#endif
#endif
double Fp;
#if defined(_DERIVATEFORDDX)
double Fp_Vdi_bi;
double Fp_Vsi_bi;
double Fp_Tempt_GND;
double Fp_Vgi_bi;
#if defined(_DERIVATE2)
  double Fp_Vgi_bi_Vdi_bi;
  double Fp_Vgi_bi_Vsi_bi;
  double Fp_Vgi_bi_Tempt_GND;
  double Fp_Vgi_bi_Vgi_bi;
  double Fp_Vsi_bi_Vdi_bi;
  double Fp_Vsi_bi_Vsi_bi;
  double Fp_Vsi_bi_Tempt_GND;
  double Fp_Vsi_bi_Vgi_bi;
  double Fp_Vdi_bi_Vdi_bi;
  double Fp_Vdi_bi_Vsi_bi;
  double Fp_Vdi_bi_Tempt_GND;
  double Fp_Vdi_bi_Vgi_bi;
#endif
#endif
double Moc;
#if defined(_DERIVATEFORDDX)
double Moc_Vdi_bi;
double Moc_Vsi_bi;
double Moc_Vgi_bi;
double Moc_Tempt_GND;
#if defined(_DERIVATE2)
  double Moc_Vgi_bi_Vdi_bi;
  double Moc_Vgi_bi_Vsi_bi;
  double Moc_Vgi_bi_Vgi_bi;
  double Moc_Vgi_bi_Tempt_GND;
  double Moc_Vsi_bi_Vdi_bi;
  double Moc_Vsi_bi_Vsi_bi;
  double Moc_Vsi_bi_Vgi_bi;
  double Moc_Vsi_bi_Tempt_GND;
  double Moc_Vdi_bi_Vdi_bi;
  double Moc_Vdi_bi_Vsi_bi;
  double Moc_Vdi_bi_Vgi_bi;
  double Moc_Vdi_bi_Tempt_GND;
#endif
#endif
double VaDIBL;
#if defined(_DERIVATEFORDDX)
double VaDIBL_Vdi_bi;
double VaDIBL_Vsi_bi;
double VaDIBL_Tempt_GND;
double VaDIBL_Vgi_bi;
#if defined(_DERIVATE2)
  double VaDIBL_Vgi_bi_Vdi_bi;
  double VaDIBL_Vgi_bi_Vsi_bi;
  double VaDIBL_Vgi_bi_Tempt_GND;
  double VaDIBL_Vgi_bi_Vgi_bi;
  double VaDIBL_Vsi_bi_Vdi_bi;
  double VaDIBL_Vsi_bi_Vsi_bi;
  double VaDIBL_Vsi_bi_Tempt_GND;
  double VaDIBL_Vsi_bi_Vgi_bi;
  double VaDIBL_Vdi_bi_Vdi_bi;
  double VaDIBL_Vdi_bi_Vsi_bi;
  double VaDIBL_Vdi_bi_Tempt_GND;
  double VaDIBL_Vdi_bi_Vgi_bi;
#endif
#endif
double Vgst2Vtm;
#if defined(_DERIVATEFORDDX)
double Vgst2Vtm_Vdi_bi;
double Vgst2Vtm_Vsi_bi;
double Vgst2Vtm_Tempt_GND;
double Vgst2Vtm_Vgi_bi;
#if defined(_DERIVATE2)
  double Vgst2Vtm_Vgi_bi_Vdi_bi;
  double Vgst2Vtm_Vgi_bi_Vsi_bi;
  double Vgst2Vtm_Vgi_bi_Tempt_GND;
  double Vgst2Vtm_Vgi_bi_Vgi_bi;
  double Vgst2Vtm_Vsi_bi_Vdi_bi;
  double Vgst2Vtm_Vsi_bi_Vsi_bi;
  double Vgst2Vtm_Vsi_bi_Tempt_GND;
  double Vgst2Vtm_Vsi_bi_Vgi_bi;
  double Vgst2Vtm_Vdi_bi_Vdi_bi;
  double Vgst2Vtm_Vdi_bi_Vsi_bi;
  double Vgst2Vtm_Vdi_bi_Tempt_GND;
  double Vgst2Vtm_Vdi_bi_Vgi_bi;
#endif
#endif
double diffVds;
#if defined(_DERIVATEFORDDX)
double diffVds_Vdbulk_di;
double diffVds_Vsbulk_si;
double diffVds_Vdi_bi;
double diffVds_Vsi_bi;
double diffVds_Vgi_bi;
double diffVds_Tempt_GND;
#if defined(_DERIVATE2)
  double diffVds_Vgi_bi_Vdbulk_di;
  double diffVds_Vgi_bi_Vsbulk_si;
  double diffVds_Vgi_bi_Vdi_bi;
  double diffVds_Vgi_bi_Vsi_bi;
  double diffVds_Vgi_bi_Vgi_bi;
  double diffVds_Vgi_bi_Tempt_GND;
  double diffVds_Vsi_bi_Vdbulk_di;
  double diffVds_Vsi_bi_Vsbulk_si;
  double diffVds_Vsi_bi_Vdi_bi;
  double diffVds_Vsi_bi_Vsi_bi;
  double diffVds_Vsi_bi_Vgi_bi;
  double diffVds_Vsi_bi_Tempt_GND;
  double diffVds_Vdi_bi_Vdbulk_di;
  double diffVds_Vdi_bi_Vsbulk_si;
  double diffVds_Vdi_bi_Vdi_bi;
  double diffVds_Vdi_bi_Vsi_bi;
  double diffVds_Vdi_bi_Vgi_bi;
  double diffVds_Vdi_bi_Tempt_GND;
  double diffVds_Vsbulk_si_Vdbulk_di;
  double diffVds_Vsbulk_si_Vsbulk_si;
  double diffVds_Vsbulk_si_Vdi_bi;
  double diffVds_Vsbulk_si_Vsi_bi;
  double diffVds_Vsbulk_si_Vgi_bi;
  double diffVds_Vsbulk_si_Tempt_GND;
  double diffVds_Vdbulk_di_Vdbulk_di;
  double diffVds_Vdbulk_di_Vsbulk_si;
  double diffVds_Vdbulk_di_Vdi_bi;
  double diffVds_Vdbulk_di_Vsi_bi;
  double diffVds_Vdbulk_di_Vgi_bi;
  double diffVds_Vdbulk_di_Tempt_GND;
#endif
#endif
double DIBLfactor;
#if defined(_DERIVATEFORDDX)
double DIBLfactor_Vdi_bi;
double DIBLfactor_Vsi_bi;
double DIBLfactor_Tempt_GND;
#if defined(_DERIVATE2)
  double DIBLfactor_Vsi_bi_Vdi_bi;
  double DIBLfactor_Vsi_bi_Vsi_bi;
  double DIBLfactor_Vsi_bi_Tempt_GND;
  double DIBLfactor_Vdi_bi_Vdi_bi;
  double DIBLfactor_Vdi_bi_Vsi_bi;
  double DIBLfactor_Vdi_bi_Tempt_GND;
#endif
#endif
double PVAGfactor;
#if defined(_DERIVATEFORDDX)
double PVAGfactor_Vdi_bi;
double PVAGfactor_Vsi_bi;
double PVAGfactor_Tempt_GND;
double PVAGfactor_Vgi_bi;
#if defined(_DERIVATE2)
  double PVAGfactor_Vgi_bi_Vdi_bi;
  double PVAGfactor_Vgi_bi_Vsi_bi;
  double PVAGfactor_Vgi_bi_Tempt_GND;
  double PVAGfactor_Vgi_bi_Vgi_bi;
  double PVAGfactor_Vsi_bi_Vdi_bi;
  double PVAGfactor_Vsi_bi_Vsi_bi;
  double PVAGfactor_Vsi_bi_Tempt_GND;
  double PVAGfactor_Vsi_bi_Vgi_bi;
  double PVAGfactor_Vdi_bi_Vdi_bi;
  double PVAGfactor_Vdi_bi_Vsi_bi;
  double PVAGfactor_Vdi_bi_Tempt_GND;
  double PVAGfactor_Vdi_bi_Vgi_bi;
#endif
#endif
double EsatL;
#if defined(_DERIVATEFORDDX)
double EsatL_Vdbulk_di;
double EsatL_Vsbulk_si;
double EsatL_Tempt_GND;
double EsatL_Vdi_bi;
double EsatL_Vsi_bi;
double EsatL_Vgi_bi;
#if defined(_DERIVATE2)
  double EsatL_Vgi_bi_Vdbulk_di;
  double EsatL_Vgi_bi_Vsbulk_si;
  double EsatL_Vgi_bi_Tempt_GND;
  double EsatL_Vgi_bi_Vdi_bi;
  double EsatL_Vgi_bi_Vsi_bi;
  double EsatL_Vgi_bi_Vgi_bi;
  double EsatL_Vsi_bi_Vdbulk_di;
  double EsatL_Vsi_bi_Vsbulk_si;
  double EsatL_Vsi_bi_Tempt_GND;
  double EsatL_Vsi_bi_Vdi_bi;
  double EsatL_Vsi_bi_Vsi_bi;
  double EsatL_Vsi_bi_Vgi_bi;
  double EsatL_Vdi_bi_Vdbulk_di;
  double EsatL_Vdi_bi_Vsbulk_si;
  double EsatL_Vdi_bi_Tempt_GND;
  double EsatL_Vdi_bi_Vdi_bi;
  double EsatL_Vdi_bi_Vsi_bi;
  double EsatL_Vdi_bi_Vgi_bi;
  double EsatL_Vsbulk_si_Vdbulk_di;
  double EsatL_Vsbulk_si_Vsbulk_si;
  double EsatL_Vsbulk_si_Tempt_GND;
  double EsatL_Vsbulk_si_Vdi_bi;
  double EsatL_Vsbulk_si_Vsi_bi;
  double EsatL_Vsbulk_si_Vgi_bi;
  double EsatL_Vdbulk_di_Vdbulk_di;
  double EsatL_Vdbulk_di_Vsbulk_si;
  double EsatL_Vdbulk_di_Tempt_GND;
  double EsatL_Vdbulk_di_Vdi_bi;
  double EsatL_Vdbulk_di_Vsi_bi;
  double EsatL_Vdbulk_di_Vgi_bi;
#endif
#endif
double Esat;
#if defined(_DERIVATEFORDDX)
double Esat_Vdbulk_di;
double Esat_Vsbulk_si;
double Esat_Tempt_GND;
double Esat_Vdi_bi;
double Esat_Vsi_bi;
double Esat_Vgi_bi;
#if defined(_DERIVATE2)
  double Esat_Vgi_bi_Vdbulk_di;
  double Esat_Vgi_bi_Vsbulk_si;
  double Esat_Vgi_bi_Tempt_GND;
  double Esat_Vgi_bi_Vdi_bi;
  double Esat_Vgi_bi_Vsi_bi;
  double Esat_Vgi_bi_Vgi_bi;
  double Esat_Vsi_bi_Vdbulk_di;
  double Esat_Vsi_bi_Vsbulk_si;
  double Esat_Vsi_bi_Tempt_GND;
  double Esat_Vsi_bi_Vdi_bi;
  double Esat_Vsi_bi_Vsi_bi;
  double Esat_Vsi_bi_Vgi_bi;
  double Esat_Vdi_bi_Vdbulk_di;
  double Esat_Vdi_bi_Vsbulk_si;
  double Esat_Vdi_bi_Tempt_GND;
  double Esat_Vdi_bi_Vdi_bi;
  double Esat_Vdi_bi_Vsi_bi;
  double Esat_Vdi_bi_Vgi_bi;
  double Esat_Vsbulk_si_Vdbulk_di;
  double Esat_Vsbulk_si_Vsbulk_si;
  double Esat_Vsbulk_si_Tempt_GND;
  double Esat_Vsbulk_si_Vdi_bi;
  double Esat_Vsbulk_si_Vsi_bi;
  double Esat_Vsbulk_si_Vgi_bi;
  double Esat_Vdbulk_di_Vdbulk_di;
  double Esat_Vdbulk_di_Vsbulk_si;
  double Esat_Vdbulk_di_Tempt_GND;
  double Esat_Vdbulk_di_Vdi_bi;
  double Esat_Vdbulk_di_Vsi_bi;
  double Esat_Vdbulk_di_Vgi_bi;
#endif
#endif
double Dmob;
#if defined(_DERIVATEFORDDX)
double Dmob_Vdbulk_di;
double Dmob_Vsbulk_si;
double Dmob_Vgi_bi;
double Dmob_Vdi_bi;
double Dmob_Vsi_bi;
double Dmob_Tempt_GND;
#if defined(_DERIVATE2)
  double Dmob_Vsi_bi_Vdbulk_di;
  double Dmob_Vsi_bi_Vsbulk_si;
  double Dmob_Vsi_bi_Vgi_bi;
  double Dmob_Vsi_bi_Vdi_bi;
  double Dmob_Vsi_bi_Vsi_bi;
  double Dmob_Vsi_bi_Tempt_GND;
  double Dmob_Vdi_bi_Vdbulk_di;
  double Dmob_Vdi_bi_Vsbulk_si;
  double Dmob_Vdi_bi_Vgi_bi;
  double Dmob_Vdi_bi_Vdi_bi;
  double Dmob_Vdi_bi_Vsi_bi;
  double Dmob_Vdi_bi_Tempt_GND;
  double Dmob_Vgi_bi_Vdbulk_di;
  double Dmob_Vgi_bi_Vsbulk_si;
  double Dmob_Vgi_bi_Vgi_bi;
  double Dmob_Vgi_bi_Vdi_bi;
  double Dmob_Vgi_bi_Vsi_bi;
  double Dmob_Vgi_bi_Tempt_GND;
  double Dmob_Vsbulk_si_Vdbulk_di;
  double Dmob_Vsbulk_si_Vsbulk_si;
  double Dmob_Vsbulk_si_Vgi_bi;
  double Dmob_Vsbulk_si_Vdi_bi;
  double Dmob_Vsbulk_si_Vsi_bi;
  double Dmob_Vsbulk_si_Tempt_GND;
  double Dmob_Vdbulk_di_Vdbulk_di;
  double Dmob_Vdbulk_di_Vsbulk_si;
  double Dmob_Vdbulk_di_Vgi_bi;
  double Dmob_Vdbulk_di_Vdi_bi;
  double Dmob_Vdbulk_di_Vsi_bi;
  double Dmob_Vdbulk_di_Tempt_GND;
#endif
#endif
double Eeffm;
#if defined(_DERIVATEFORDDX)
double Eeffm_Vdbulk_di;
double Eeffm_Vsbulk_si;
double Eeffm_Vdi_bi;
double Eeffm_Vsi_bi;
double Eeffm_Tempt_GND;
double Eeffm_Vgi_bi;
#if defined(_DERIVATE2)
  double Eeffm_Vgi_bi_Vdbulk_di;
  double Eeffm_Vgi_bi_Vsbulk_si;
  double Eeffm_Vgi_bi_Vdi_bi;
  double Eeffm_Vgi_bi_Vsi_bi;
  double Eeffm_Vgi_bi_Tempt_GND;
  double Eeffm_Vgi_bi_Vgi_bi;
  double Eeffm_Vsi_bi_Vdbulk_di;
  double Eeffm_Vsi_bi_Vsbulk_si;
  double Eeffm_Vsi_bi_Vdi_bi;
  double Eeffm_Vsi_bi_Vsi_bi;
  double Eeffm_Vsi_bi_Tempt_GND;
  double Eeffm_Vsi_bi_Vgi_bi;
  double Eeffm_Vdi_bi_Vdbulk_di;
  double Eeffm_Vdi_bi_Vsbulk_si;
  double Eeffm_Vdi_bi_Vdi_bi;
  double Eeffm_Vdi_bi_Vsi_bi;
  double Eeffm_Vdi_bi_Tempt_GND;
  double Eeffm_Vdi_bi_Vgi_bi;
  double Eeffm_Vsbulk_si_Vdbulk_di;
  double Eeffm_Vsbulk_si_Vsbulk_si;
  double Eeffm_Vsbulk_si_Vdi_bi;
  double Eeffm_Vsbulk_si_Vsi_bi;
  double Eeffm_Vsbulk_si_Tempt_GND;
  double Eeffm_Vsbulk_si_Vgi_bi;
  double Eeffm_Vdbulk_di_Vdbulk_di;
  double Eeffm_Vdbulk_di_Vsbulk_si;
  double Eeffm_Vdbulk_di_Vdi_bi;
  double Eeffm_Vdbulk_di_Vsi_bi;
  double Eeffm_Vdbulk_di_Tempt_GND;
  double Eeffm_Vdbulk_di_Vgi_bi;
#endif
#endif
double qia;
#if defined(_DERIVATEFORDDX)
double qia_Vdbulk_di;
double qia_Vsbulk_si;
double qia_Vdi_bi;
double qia_Vsi_bi;
double qia_Tempt_GND;
double qia_Vgi_bi;
#if defined(_DERIVATE2)
  double qia_Vgi_bi_Vdbulk_di;
  double qia_Vgi_bi_Vsbulk_si;
  double qia_Vgi_bi_Vdi_bi;
  double qia_Vgi_bi_Vsi_bi;
  double qia_Vgi_bi_Tempt_GND;
  double qia_Vgi_bi_Vgi_bi;
  double qia_Vsi_bi_Vdbulk_di;
  double qia_Vsi_bi_Vsbulk_si;
  double qia_Vsi_bi_Vdi_bi;
  double qia_Vsi_bi_Vsi_bi;
  double qia_Vsi_bi_Tempt_GND;
  double qia_Vsi_bi_Vgi_bi;
  double qia_Vdi_bi_Vdbulk_di;
  double qia_Vdi_bi_Vsbulk_si;
  double qia_Vdi_bi_Vdi_bi;
  double qia_Vdi_bi_Vsi_bi;
  double qia_Vdi_bi_Tempt_GND;
  double qia_Vdi_bi_Vgi_bi;
  double qia_Vsbulk_si_Vdbulk_di;
  double qia_Vsbulk_si_Vsbulk_si;
  double qia_Vsbulk_si_Vdi_bi;
  double qia_Vsbulk_si_Vsi_bi;
  double qia_Vsbulk_si_Tempt_GND;
  double qia_Vsbulk_si_Vgi_bi;
  double qia_Vdbulk_di_Vdbulk_di;
  double qia_Vdbulk_di_Vsbulk_si;
  double qia_Vdbulk_di_Vdi_bi;
  double qia_Vdbulk_di_Vsi_bi;
  double qia_Vdbulk_di_Tempt_GND;
  double qia_Vdbulk_di_Vgi_bi;
#endif
#endif
double qba;
#if defined(_DERIVATEFORDDX)
double qba_Vdi_bi;
double qba_Vsi_bi;
double qba_Tempt_GND;
double qba_Vgi_bi;
#if defined(_DERIVATE2)
  double qba_Vgi_bi_Vdi_bi;
  double qba_Vgi_bi_Vsi_bi;
  double qba_Vgi_bi_Tempt_GND;
  double qba_Vgi_bi_Vgi_bi;
  double qba_Vsi_bi_Vdi_bi;
  double qba_Vsi_bi_Vsi_bi;
  double qba_Vsi_bi_Tempt_GND;
  double qba_Vsi_bi_Vgi_bi;
  double qba_Vdi_bi_Vdi_bi;
  double qba_Vdi_bi_Vsi_bi;
  double qba_Vdi_bi_Tempt_GND;
  double qba_Vdi_bi_Vgi_bi;
#endif
#endif
double Qd;
#if defined(_DERIVATEFORDDX)
double Qd_Vdbulk_di;
double Qd_Vsbulk_si;
double Qd_Vgi_bi;
double Qd_Vdi_bi;
double Qd_Vsi_bi;
double Qd_Tempt_GND;
#if defined(_DERIVATE2)
  double Qd_Vsi_bi_Vdbulk_di;
  double Qd_Vsi_bi_Vsbulk_si;
  double Qd_Vsi_bi_Vgi_bi;
  double Qd_Vsi_bi_Vdi_bi;
  double Qd_Vsi_bi_Vsi_bi;
  double Qd_Vsi_bi_Tempt_GND;
  double Qd_Vdi_bi_Vdbulk_di;
  double Qd_Vdi_bi_Vsbulk_si;
  double Qd_Vdi_bi_Vgi_bi;
  double Qd_Vdi_bi_Vdi_bi;
  double Qd_Vdi_bi_Vsi_bi;
  double Qd_Vdi_bi_Tempt_GND;
  double Qd_Vgi_bi_Vdbulk_di;
  double Qd_Vgi_bi_Vsbulk_si;
  double Qd_Vgi_bi_Vgi_bi;
  double Qd_Vgi_bi_Vdi_bi;
  double Qd_Vgi_bi_Vsi_bi;
  double Qd_Vgi_bi_Tempt_GND;
  double Qd_Vsbulk_si_Vdbulk_di;
  double Qd_Vsbulk_si_Vsbulk_si;
  double Qd_Vsbulk_si_Vgi_bi;
  double Qd_Vsbulk_si_Vdi_bi;
  double Qd_Vsbulk_si_Vsi_bi;
  double Qd_Vsbulk_si_Tempt_GND;
  double Qd_Vdbulk_di_Vdbulk_di;
  double Qd_Vdbulk_di_Vsbulk_si;
  double Qd_Vdbulk_di_Vgi_bi;
  double Qd_Vdbulk_di_Vdi_bi;
  double Qd_Vdbulk_di_Vsi_bi;
  double Qd_Vdbulk_di_Tempt_GND;
#endif
#endif
double Qs;
#if defined(_DERIVATEFORDDX)
double Qs_Vdbulk_di;
double Qs_Vsbulk_si;
double Qs_Vgi_bi;
double Qs_Vdi_bi;
double Qs_Vsi_bi;
double Qs_Tempt_GND;
#if defined(_DERIVATE2)
  double Qs_Vsi_bi_Vdbulk_di;
  double Qs_Vsi_bi_Vsbulk_si;
  double Qs_Vsi_bi_Vgi_bi;
  double Qs_Vsi_bi_Vdi_bi;
  double Qs_Vsi_bi_Vsi_bi;
  double Qs_Vsi_bi_Tempt_GND;
  double Qs_Vdi_bi_Vdbulk_di;
  double Qs_Vdi_bi_Vsbulk_si;
  double Qs_Vdi_bi_Vgi_bi;
  double Qs_Vdi_bi_Vdi_bi;
  double Qs_Vdi_bi_Vsi_bi;
  double Qs_Vdi_bi_Tempt_GND;
  double Qs_Vgi_bi_Vdbulk_di;
  double Qs_Vgi_bi_Vsbulk_si;
  double Qs_Vgi_bi_Vgi_bi;
  double Qs_Vgi_bi_Vdi_bi;
  double Qs_Vgi_bi_Vsi_bi;
  double Qs_Vgi_bi_Tempt_GND;
  double Qs_Vsbulk_si_Vdbulk_di;
  double Qs_Vsbulk_si_Vsbulk_si;
  double Qs_Vsbulk_si_Vgi_bi;
  double Qs_Vsbulk_si_Vdi_bi;
  double Qs_Vsbulk_si_Vsi_bi;
  double Qs_Vsbulk_si_Tempt_GND;
  double Qs_Vdbulk_di_Vdbulk_di;
  double Qs_Vdbulk_di_Vsbulk_si;
  double Qs_Vdbulk_di_Vgi_bi;
  double Qs_Vdbulk_di_Vdi_bi;
  double Qs_Vdbulk_di_Vsi_bi;
  double Qs_Vdbulk_di_Tempt_GND;
#endif
#endif
double Qb;
#if defined(_DERIVATEFORDDX)
double Qb_Vdbulk_di;
double Qb_Vsbulk_si;
double Qb_Vgi_bi;
double Qb_Vdi_bi;
double Qb_Vsi_bi;
double Qb_Tempt_GND;
#if defined(_DERIVATE2)
  double Qb_Vsi_bi_Vdbulk_di;
  double Qb_Vsi_bi_Vsbulk_si;
  double Qb_Vsi_bi_Vgi_bi;
  double Qb_Vsi_bi_Vdi_bi;
  double Qb_Vsi_bi_Vsi_bi;
  double Qb_Vsi_bi_Tempt_GND;
  double Qb_Vdi_bi_Vdbulk_di;
  double Qb_Vdi_bi_Vsbulk_si;
  double Qb_Vdi_bi_Vgi_bi;
  double Qb_Vdi_bi_Vdi_bi;
  double Qb_Vdi_bi_Vsi_bi;
  double Qb_Vdi_bi_Tempt_GND;
  double Qb_Vgi_bi_Vdbulk_di;
  double Qb_Vgi_bi_Vsbulk_si;
  double Qb_Vgi_bi_Vgi_bi;
  double Qb_Vgi_bi_Vdi_bi;
  double Qb_Vgi_bi_Vsi_bi;
  double Qb_Vgi_bi_Tempt_GND;
  double Qb_Vsbulk_si_Vdbulk_di;
  double Qb_Vsbulk_si_Vsbulk_si;
  double Qb_Vsbulk_si_Vgi_bi;
  double Qb_Vsbulk_si_Vdi_bi;
  double Qb_Vsbulk_si_Vsi_bi;
  double Qb_Vsbulk_si_Tempt_GND;
  double Qb_Vdbulk_di_Vdbulk_di;
  double Qb_Vdbulk_di_Vsbulk_si;
  double Qb_Vdbulk_di_Vgi_bi;
  double Qb_Vdbulk_di_Vdi_bi;
  double Qb_Vdbulk_di_Vsi_bi;
  double Qb_Vdbulk_di_Tempt_GND;
#endif
#endif
double DQSD2;
#if defined(_DERIVATEFORDDX)
double DQSD2_Vdbulk_di;
double DQSD2_Vsbulk_si;
double DQSD2_Vgi_bi;
double DQSD2_Vdi_bi;
double DQSD2_Vsi_bi;
double DQSD2_Tempt_GND;
#if defined(_DERIVATE2)
  double DQSD2_Vsi_bi_Vdbulk_di;
  double DQSD2_Vsi_bi_Vsbulk_si;
  double DQSD2_Vsi_bi_Vgi_bi;
  double DQSD2_Vsi_bi_Vdi_bi;
  double DQSD2_Vsi_bi_Vsi_bi;
  double DQSD2_Vsi_bi_Tempt_GND;
  double DQSD2_Vdi_bi_Vdbulk_di;
  double DQSD2_Vdi_bi_Vsbulk_si;
  double DQSD2_Vdi_bi_Vgi_bi;
  double DQSD2_Vdi_bi_Vdi_bi;
  double DQSD2_Vdi_bi_Vsi_bi;
  double DQSD2_Vdi_bi_Tempt_GND;
  double DQSD2_Vgi_bi_Vdbulk_di;
  double DQSD2_Vgi_bi_Vsbulk_si;
  double DQSD2_Vgi_bi_Vgi_bi;
  double DQSD2_Vgi_bi_Vdi_bi;
  double DQSD2_Vgi_bi_Vsi_bi;
  double DQSD2_Vgi_bi_Tempt_GND;
  double DQSD2_Vsbulk_si_Vdbulk_di;
  double DQSD2_Vsbulk_si_Vsbulk_si;
  double DQSD2_Vsbulk_si_Vgi_bi;
  double DQSD2_Vsbulk_si_Vdi_bi;
  double DQSD2_Vsbulk_si_Vsi_bi;
  double DQSD2_Vsbulk_si_Tempt_GND;
  double DQSD2_Vdbulk_di_Vdbulk_di;
  double DQSD2_Vdbulk_di_Vsbulk_si;
  double DQSD2_Vdbulk_di_Vgi_bi;
  double DQSD2_Vdbulk_di_Vdi_bi;
  double DQSD2_Vdbulk_di_Vsi_bi;
  double DQSD2_Vdbulk_di_Tempt_GND;
#endif
#endif
double qdeff;
#if defined(_DERIVATEFORDDX)
double qdeff_Vgm_si;
double qdeff_Vgm_di;
double qdeff_Vdbulk_di;
double qdeff_Vsbulk_si;
double qdeff_Vgi_bi;
double qdeff_Vdi_bi;
double qdeff_Vsi_bi;
double qdeff_Tempt_GND;
#if defined(_DERIVATE2)
  double qdeff_Vsi_bi_Vgm_si;
  double qdeff_Vsi_bi_Vgm_di;
  double qdeff_Vsi_bi_Vdbulk_di;
  double qdeff_Vsi_bi_Vsbulk_si;
  double qdeff_Vsi_bi_Vgi_bi;
  double qdeff_Vsi_bi_Vdi_bi;
  double qdeff_Vsi_bi_Vsi_bi;
  double qdeff_Vsi_bi_Tempt_GND;
  double qdeff_Vdi_bi_Vgm_si;
  double qdeff_Vdi_bi_Vgm_di;
  double qdeff_Vdi_bi_Vdbulk_di;
  double qdeff_Vdi_bi_Vsbulk_si;
  double qdeff_Vdi_bi_Vgi_bi;
  double qdeff_Vdi_bi_Vdi_bi;
  double qdeff_Vdi_bi_Vsi_bi;
  double qdeff_Vdi_bi_Tempt_GND;
  double qdeff_Vgi_bi_Vgm_si;
  double qdeff_Vgi_bi_Vgm_di;
  double qdeff_Vgi_bi_Vdbulk_di;
  double qdeff_Vgi_bi_Vsbulk_si;
  double qdeff_Vgi_bi_Vgi_bi;
  double qdeff_Vgi_bi_Vdi_bi;
  double qdeff_Vgi_bi_Vsi_bi;
  double qdeff_Vgi_bi_Tempt_GND;
  double qdeff_Vsbulk_si_Vgm_si;
  double qdeff_Vsbulk_si_Vgm_di;
  double qdeff_Vsbulk_si_Vdbulk_di;
  double qdeff_Vsbulk_si_Vsbulk_si;
  double qdeff_Vsbulk_si_Vgi_bi;
  double qdeff_Vsbulk_si_Vdi_bi;
  double qdeff_Vsbulk_si_Vsi_bi;
  double qdeff_Vsbulk_si_Tempt_GND;
  double qdeff_Vdbulk_di_Vgm_si;
  double qdeff_Vdbulk_di_Vgm_di;
  double qdeff_Vdbulk_di_Vdbulk_di;
  double qdeff_Vdbulk_di_Vsbulk_si;
  double qdeff_Vdbulk_di_Vgi_bi;
  double qdeff_Vdbulk_di_Vdi_bi;
  double qdeff_Vdbulk_di_Vsi_bi;
  double qdeff_Vdbulk_di_Tempt_GND;
  double qdeff_Vgm_di_Vgm_si;
  double qdeff_Vgm_di_Vgm_di;
  double qdeff_Vgm_di_Vdbulk_di;
  double qdeff_Vgm_di_Vsbulk_si;
  double qdeff_Vgm_di_Vgi_bi;
  double qdeff_Vgm_di_Vdi_bi;
  double qdeff_Vgm_di_Vsi_bi;
  double qdeff_Vgm_di_Tempt_GND;
  double qdeff_Vgm_si_Vgm_si;
  double qdeff_Vgm_si_Vgm_di;
  double qdeff_Vgm_si_Vdbulk_di;
  double qdeff_Vgm_si_Vsbulk_si;
  double qdeff_Vgm_si_Vgi_bi;
  double qdeff_Vgm_si_Vdi_bi;
  double qdeff_Vgm_si_Vsi_bi;
  double qdeff_Vgm_si_Tempt_GND;
#endif
#endif
double vdeff;
#if defined(_DERIVATEFORDDX)
double vdeff_Vgm_di;
double vdeff_Vgm_si;
double vdeff_Vdbulk_di;
double vdeff_Vsbulk_si;
double vdeff_Vdi_bi;
double vdeff_Vsi_bi;
double vdeff_Vgi_bi;
double vdeff_Tempt_GND;
#if defined(_DERIVATE2)
  double vdeff_Vgi_bi_Vgm_di;
  double vdeff_Vgi_bi_Vgm_si;
  double vdeff_Vgi_bi_Vdbulk_di;
  double vdeff_Vgi_bi_Vsbulk_si;
  double vdeff_Vgi_bi_Vdi_bi;
  double vdeff_Vgi_bi_Vsi_bi;
  double vdeff_Vgi_bi_Vgi_bi;
  double vdeff_Vgi_bi_Tempt_GND;
  double vdeff_Vsi_bi_Vgm_di;
  double vdeff_Vsi_bi_Vgm_si;
  double vdeff_Vsi_bi_Vdbulk_di;
  double vdeff_Vsi_bi_Vsbulk_si;
  double vdeff_Vsi_bi_Vdi_bi;
  double vdeff_Vsi_bi_Vsi_bi;
  double vdeff_Vsi_bi_Vgi_bi;
  double vdeff_Vsi_bi_Tempt_GND;
  double vdeff_Vdi_bi_Vgm_di;
  double vdeff_Vdi_bi_Vgm_si;
  double vdeff_Vdi_bi_Vdbulk_di;
  double vdeff_Vdi_bi_Vsbulk_si;
  double vdeff_Vdi_bi_Vdi_bi;
  double vdeff_Vdi_bi_Vsi_bi;
  double vdeff_Vdi_bi_Vgi_bi;
  double vdeff_Vdi_bi_Tempt_GND;
  double vdeff_Vsbulk_si_Vgm_di;
  double vdeff_Vsbulk_si_Vgm_si;
  double vdeff_Vsbulk_si_Vdbulk_di;
  double vdeff_Vsbulk_si_Vsbulk_si;
  double vdeff_Vsbulk_si_Vdi_bi;
  double vdeff_Vsbulk_si_Vsi_bi;
  double vdeff_Vsbulk_si_Vgi_bi;
  double vdeff_Vsbulk_si_Tempt_GND;
  double vdeff_Vdbulk_di_Vgm_di;
  double vdeff_Vdbulk_di_Vgm_si;
  double vdeff_Vdbulk_di_Vdbulk_di;
  double vdeff_Vdbulk_di_Vsbulk_si;
  double vdeff_Vdbulk_di_Vdi_bi;
  double vdeff_Vdbulk_di_Vsi_bi;
  double vdeff_Vdbulk_di_Vgi_bi;
  double vdeff_Vdbulk_di_Tempt_GND;
  double vdeff_Vgm_si_Vgm_di;
  double vdeff_Vgm_si_Vgm_si;
  double vdeff_Vgm_si_Vdbulk_di;
  double vdeff_Vgm_si_Vsbulk_si;
  double vdeff_Vgm_si_Vdi_bi;
  double vdeff_Vgm_si_Vsi_bi;
  double vdeff_Vgm_si_Vgi_bi;
  double vdeff_Vgm_si_Tempt_GND;
  double vdeff_Vgm_di_Vgm_di;
  double vdeff_Vgm_di_Vgm_si;
  double vdeff_Vgm_di_Vdbulk_di;
  double vdeff_Vgm_di_Vsbulk_si;
  double vdeff_Vgm_di_Vdi_bi;
  double vdeff_Vgm_di_Vsi_bi;
  double vdeff_Vgm_di_Vgi_bi;
  double vdeff_Vgm_di_Tempt_GND;
#endif
#endif
double Vdseff;
#if defined(_DERIVATEFORDDX)
double Vdseff_Vgm_di;
double Vdseff_Vgm_si;
double Vdseff_Vdbulk_di;
double Vdseff_Vsbulk_si;
double Vdseff_Vdi_bi;
double Vdseff_Vsi_bi;
double Vdseff_Vgi_bi;
double Vdseff_Tempt_GND;
#if defined(_DERIVATE2)
  double Vdseff_Vgi_bi_Vgm_di;
  double Vdseff_Vgi_bi_Vgm_si;
  double Vdseff_Vgi_bi_Vdbulk_di;
  double Vdseff_Vgi_bi_Vsbulk_si;
  double Vdseff_Vgi_bi_Vdi_bi;
  double Vdseff_Vgi_bi_Vsi_bi;
  double Vdseff_Vgi_bi_Vgi_bi;
  double Vdseff_Vgi_bi_Tempt_GND;
  double Vdseff_Vsi_bi_Vgm_di;
  double Vdseff_Vsi_bi_Vgm_si;
  double Vdseff_Vsi_bi_Vdbulk_di;
  double Vdseff_Vsi_bi_Vsbulk_si;
  double Vdseff_Vsi_bi_Vdi_bi;
  double Vdseff_Vsi_bi_Vsi_bi;
  double Vdseff_Vsi_bi_Vgi_bi;
  double Vdseff_Vsi_bi_Tempt_GND;
  double Vdseff_Vdi_bi_Vgm_di;
  double Vdseff_Vdi_bi_Vgm_si;
  double Vdseff_Vdi_bi_Vdbulk_di;
  double Vdseff_Vdi_bi_Vsbulk_si;
  double Vdseff_Vdi_bi_Vdi_bi;
  double Vdseff_Vdi_bi_Vsi_bi;
  double Vdseff_Vdi_bi_Vgi_bi;
  double Vdseff_Vdi_bi_Tempt_GND;
  double Vdseff_Vsbulk_si_Vgm_di;
  double Vdseff_Vsbulk_si_Vgm_si;
  double Vdseff_Vsbulk_si_Vdbulk_di;
  double Vdseff_Vsbulk_si_Vsbulk_si;
  double Vdseff_Vsbulk_si_Vdi_bi;
  double Vdseff_Vsbulk_si_Vsi_bi;
  double Vdseff_Vsbulk_si_Vgi_bi;
  double Vdseff_Vsbulk_si_Tempt_GND;
  double Vdseff_Vdbulk_di_Vgm_di;
  double Vdseff_Vdbulk_di_Vgm_si;
  double Vdseff_Vdbulk_di_Vdbulk_di;
  double Vdseff_Vdbulk_di_Vsbulk_si;
  double Vdseff_Vdbulk_di_Vdi_bi;
  double Vdseff_Vdbulk_di_Vsi_bi;
  double Vdseff_Vdbulk_di_Vgi_bi;
  double Vdseff_Vdbulk_di_Tempt_GND;
  double Vdseff_Vgm_si_Vgm_di;
  double Vdseff_Vgm_si_Vgm_si;
  double Vdseff_Vgm_si_Vdbulk_di;
  double Vdseff_Vgm_si_Vsbulk_si;
  double Vdseff_Vgm_si_Vdi_bi;
  double Vdseff_Vgm_si_Vsi_bi;
  double Vdseff_Vgm_si_Vgi_bi;
  double Vdseff_Vgm_si_Tempt_GND;
  double Vdseff_Vgm_di_Vgm_di;
  double Vdseff_Vgm_di_Vgm_si;
  double Vdseff_Vgm_di_Vdbulk_di;
  double Vdseff_Vgm_di_Vsbulk_si;
  double Vdseff_Vgm_di_Vdi_bi;
  double Vdseff_Vgm_di_Vsi_bi;
  double Vdseff_Vgm_di_Vgi_bi;
  double Vdseff_Vgm_di_Tempt_GND;
#endif
#endif
double Vdssat;
#if defined(_DERIVATEFORDDX)
double Vdssat_Vgi_bi;
double Vdssat_Vdi_bi;
double Vdssat_Vsi_bi;
double Vdssat_Tempt_GND;
#if defined(_DERIVATE2)
  double Vdssat_Vsi_bi_Vgi_bi;
  double Vdssat_Vsi_bi_Vdi_bi;
  double Vdssat_Vsi_bi_Vsi_bi;
  double Vdssat_Vsi_bi_Tempt_GND;
  double Vdssat_Vdi_bi_Vgi_bi;
  double Vdssat_Vdi_bi_Vdi_bi;
  double Vdssat_Vdi_bi_Vsi_bi;
  double Vdssat_Vdi_bi_Tempt_GND;
  double Vdssat_Vgi_bi_Vgi_bi;
  double Vdssat_Vgi_bi_Vdi_bi;
  double Vdssat_Vgi_bi_Vsi_bi;
  double Vdssat_Vgi_bi_Tempt_GND;
#endif
#endif
double Vdsat;
#if defined(_DERIVATEFORDDX)
double Vdsat_Vgi_bi;
double Vdsat_Vdi_bi;
double Vdsat_Vsi_bi;
double Vdsat_Tempt_GND;
#if defined(_DERIVATE2)
  double Vdsat_Vsi_bi_Vgi_bi;
  double Vdsat_Vsi_bi_Vdi_bi;
  double Vdsat_Vsi_bi_Vsi_bi;
  double Vdsat_Vsi_bi_Tempt_GND;
  double Vdsat_Vdi_bi_Vgi_bi;
  double Vdsat_Vdi_bi_Vdi_bi;
  double Vdsat_Vdi_bi_Vsi_bi;
  double Vdsat_Vdi_bi_Tempt_GND;
  double Vdsat_Vgi_bi_Vgi_bi;
  double Vdsat_Vgi_bi_Vdi_bi;
  double Vdsat_Vgi_bi_Vsi_bi;
  double Vdsat_Vgi_bi_Tempt_GND;
#endif
#endif
double vdsat;
#if defined(_DERIVATEFORDDX)
double vdsat_Vgi_bi;
double vdsat_Vdi_bi;
double vdsat_Vsi_bi;
double vdsat_Tempt_GND;
#if defined(_DERIVATE2)
  double vdsat_Vsi_bi_Vgi_bi;
  double vdsat_Vsi_bi_Vdi_bi;
  double vdsat_Vsi_bi_Vsi_bi;
  double vdsat_Vsi_bi_Tempt_GND;
  double vdsat_Vdi_bi_Vgi_bi;
  double vdsat_Vdi_bi_Vdi_bi;
  double vdsat_Vdi_bi_Vsi_bi;
  double vdsat_Vdi_bi_Tempt_GND;
  double vdsat_Vgi_bi_Vgi_bi;
  double vdsat_Vgi_bi_Vdi_bi;
  double vdsat_Vgi_bi_Vsi_bi;
  double vdsat_Vgi_bi_Tempt_GND;
#endif
#endif
double T12;
#if defined(_DERIVATEFORDDX)
double T12_Vdbulk_di;
double T12_Vsbulk_si;
double T12_Vgi_bi;
double T12_Tempt_GND;
double T12_Vdi_bi;
double T12_Vsi_bi;
#if defined(_DERIVATE2)
  double T12_Vsi_bi_Vdbulk_di;
  double T12_Vsi_bi_Vsbulk_si;
  double T12_Vsi_bi_Vgi_bi;
  double T12_Vsi_bi_Tempt_GND;
  double T12_Vsi_bi_Vdi_bi;
  double T12_Vsi_bi_Vsi_bi;
  double T12_Vdi_bi_Vdbulk_di;
  double T12_Vdi_bi_Vsbulk_si;
  double T12_Vdi_bi_Vgi_bi;
  double T12_Vdi_bi_Tempt_GND;
  double T12_Vdi_bi_Vdi_bi;
  double T12_Vdi_bi_Vsi_bi;
  double T12_Vgi_bi_Vdbulk_di;
  double T12_Vgi_bi_Vsbulk_si;
  double T12_Vgi_bi_Vgi_bi;
  double T12_Vgi_bi_Tempt_GND;
  double T12_Vgi_bi_Vdi_bi;
  double T12_Vgi_bi_Vsi_bi;
  double T12_Vsbulk_si_Vdbulk_di;
  double T12_Vsbulk_si_Vsbulk_si;
  double T12_Vsbulk_si_Vgi_bi;
  double T12_Vsbulk_si_Tempt_GND;
  double T12_Vsbulk_si_Vdi_bi;
  double T12_Vsbulk_si_Vsi_bi;
  double T12_Vdbulk_di_Vdbulk_di;
  double T12_Vdbulk_di_Vsbulk_si;
  double T12_Vdbulk_di_Vgi_bi;
  double T12_Vdbulk_di_Tempt_GND;
  double T12_Vdbulk_di_Vdi_bi;
  double T12_Vdbulk_di_Vsi_bi;
#endif
#endif
double T11;
#if defined(_DERIVATEFORDDX)
double T11_Vgi_bi;
double T11_Tempt_GND;
double T11_Vdi_bi;
double T11_Vsi_bi;
#if defined(_DERIVATE2)
  double T11_Vsi_bi_Vgi_bi;
  double T11_Vsi_bi_Tempt_GND;
  double T11_Vsi_bi_Vdi_bi;
  double T11_Vsi_bi_Vsi_bi;
  double T11_Vdi_bi_Vgi_bi;
  double T11_Vdi_bi_Tempt_GND;
  double T11_Vdi_bi_Vdi_bi;
  double T11_Vdi_bi_Vsi_bi;
  double T11_Vgi_bi_Vgi_bi;
  double T11_Vgi_bi_Tempt_GND;
  double T11_Vgi_bi_Vdi_bi;
  double T11_Vgi_bi_Vsi_bi;
#endif
#endif
double qdsat;
#if defined(_DERIVATEFORDDX)
double qdsat_Vdbulk_di;
double qdsat_Vsbulk_si;
double qdsat_Vgi_bi;
double qdsat_Vdi_bi;
double qdsat_Vsi_bi;
double qdsat_Tempt_GND;
#if defined(_DERIVATE2)
  double qdsat_Vsi_bi_Vdbulk_di;
  double qdsat_Vsi_bi_Vsbulk_si;
  double qdsat_Vsi_bi_Vgi_bi;
  double qdsat_Vsi_bi_Vdi_bi;
  double qdsat_Vsi_bi_Vsi_bi;
  double qdsat_Vsi_bi_Tempt_GND;
  double qdsat_Vdi_bi_Vdbulk_di;
  double qdsat_Vdi_bi_Vsbulk_si;
  double qdsat_Vdi_bi_Vgi_bi;
  double qdsat_Vdi_bi_Vdi_bi;
  double qdsat_Vdi_bi_Vsi_bi;
  double qdsat_Vdi_bi_Tempt_GND;
  double qdsat_Vgi_bi_Vdbulk_di;
  double qdsat_Vgi_bi_Vsbulk_si;
  double qdsat_Vgi_bi_Vgi_bi;
  double qdsat_Vgi_bi_Vdi_bi;
  double qdsat_Vgi_bi_Vsi_bi;
  double qdsat_Vgi_bi_Tempt_GND;
  double qdsat_Vsbulk_si_Vdbulk_di;
  double qdsat_Vsbulk_si_Vsbulk_si;
  double qdsat_Vsbulk_si_Vgi_bi;
  double qdsat_Vsbulk_si_Vdi_bi;
  double qdsat_Vsbulk_si_Vsi_bi;
  double qdsat_Vsbulk_si_Tempt_GND;
  double qdsat_Vdbulk_di_Vdbulk_di;
  double qdsat_Vdbulk_di_Vsbulk_si;
  double qdsat_Vdbulk_di_Vgi_bi;
  double qdsat_Vdbulk_di_Vdi_bi;
  double qdsat_Vdbulk_di_Vsi_bi;
  double qdsat_Vdbulk_di_Tempt_GND;
#endif
#endif
double ln_T1_T2;
#if defined(_DERIVATEFORDDX)
double ln_T1_T2_Vgi_bi;
double ln_T1_T2_Vdi_bi;
double ln_T1_T2_Vsi_bi;
double ln_T1_T2_Tempt_GND;
#if defined(_DERIVATE2)
  double ln_T1_T2_Vsi_bi_Vgi_bi;
  double ln_T1_T2_Vsi_bi_Vdi_bi;
  double ln_T1_T2_Vsi_bi_Vsi_bi;
  double ln_T1_T2_Vsi_bi_Tempt_GND;
  double ln_T1_T2_Vdi_bi_Vgi_bi;
  double ln_T1_T2_Vdi_bi_Vdi_bi;
  double ln_T1_T2_Vdi_bi_Vsi_bi;
  double ln_T1_T2_Vdi_bi_Tempt_GND;
  double ln_T1_T2_Vgi_bi_Vgi_bi;
  double ln_T1_T2_Vgi_bi_Vdi_bi;
  double ln_T1_T2_Vgi_bi_Vsi_bi;
  double ln_T1_T2_Vgi_bi_Tempt_GND;
#endif
#endif
double LambdaC;
#if defined(_DERIVATEFORDDX)
double LambdaC_Vdbulk_di;
double LambdaC_Vsbulk_si;
double LambdaC_Tempt_GND;
double LambdaC_Vdi_bi;
double LambdaC_Vsi_bi;
double LambdaC_Vgi_bi;
#if defined(_DERIVATE2)
  double LambdaC_Vgi_bi_Vdbulk_di;
  double LambdaC_Vgi_bi_Vsbulk_si;
  double LambdaC_Vgi_bi_Tempt_GND;
  double LambdaC_Vgi_bi_Vdi_bi;
  double LambdaC_Vgi_bi_Vsi_bi;
  double LambdaC_Vgi_bi_Vgi_bi;
  double LambdaC_Vsi_bi_Vdbulk_di;
  double LambdaC_Vsi_bi_Vsbulk_si;
  double LambdaC_Vsi_bi_Tempt_GND;
  double LambdaC_Vsi_bi_Vdi_bi;
  double LambdaC_Vsi_bi_Vsi_bi;
  double LambdaC_Vsi_bi_Vgi_bi;
  double LambdaC_Vdi_bi_Vdbulk_di;
  double LambdaC_Vdi_bi_Vsbulk_si;
  double LambdaC_Vdi_bi_Tempt_GND;
  double LambdaC_Vdi_bi_Vdi_bi;
  double LambdaC_Vdi_bi_Vsi_bi;
  double LambdaC_Vdi_bi_Vgi_bi;
  double LambdaC_Vsbulk_si_Vdbulk_di;
  double LambdaC_Vsbulk_si_Vsbulk_si;
  double LambdaC_Vsbulk_si_Tempt_GND;
  double LambdaC_Vsbulk_si_Vdi_bi;
  double LambdaC_Vsbulk_si_Vsi_bi;
  double LambdaC_Vsbulk_si_Vgi_bi;
  double LambdaC_Vdbulk_di_Vdbulk_di;
  double LambdaC_Vdbulk_di_Vsbulk_si;
  double LambdaC_Vdbulk_di_Tempt_GND;
  double LambdaC_Vdbulk_di_Vdi_bi;
  double LambdaC_Vdbulk_di_Vsi_bi;
  double LambdaC_Vdbulk_di_Vgi_bi;
#endif
#endif
double Rdss;
#if defined(_DERIVATEFORDDX)
double Rdss_Vgi_bi;
double Rdss_Vdi_bi;
double Rdss_Vsi_bi;
double Rdss_Tempt_GND;
#if defined(_DERIVATE2)
  double Rdss_Vsi_bi_Vgi_bi;
  double Rdss_Vsi_bi_Vdi_bi;
  double Rdss_Vsi_bi_Vsi_bi;
  double Rdss_Vsi_bi_Tempt_GND;
  double Rdss_Vdi_bi_Vgi_bi;
  double Rdss_Vdi_bi_Vdi_bi;
  double Rdss_Vdi_bi_Vsi_bi;
  double Rdss_Vdi_bi_Tempt_GND;
  double Rdss_Vgi_bi_Vgi_bi;
  double Rdss_Vgi_bi_Vdi_bi;
  double Rdss_Vgi_bi_Vsi_bi;
  double Rdss_Vgi_bi_Tempt_GND;
#endif
#endif
double WeffWRFactor;
double Dmobs;
#if defined(_DERIVATEFORDDX)
double Dmobs_Vdbulk_di;
double Dmobs_Vsbulk_si;
double Dmobs_Vgi_bi;
double Dmobs_Vdi_bi;
double Dmobs_Vsi_bi;
double Dmobs_Tempt_GND;
#if defined(_DERIVATE2)
  double Dmobs_Vsi_bi_Vdbulk_di;
  double Dmobs_Vsi_bi_Vsbulk_si;
  double Dmobs_Vsi_bi_Vgi_bi;
  double Dmobs_Vsi_bi_Vdi_bi;
  double Dmobs_Vsi_bi_Vsi_bi;
  double Dmobs_Vsi_bi_Tempt_GND;
  double Dmobs_Vdi_bi_Vdbulk_di;
  double Dmobs_Vdi_bi_Vsbulk_si;
  double Dmobs_Vdi_bi_Vgi_bi;
  double Dmobs_Vdi_bi_Vdi_bi;
  double Dmobs_Vdi_bi_Vsi_bi;
  double Dmobs_Vdi_bi_Tempt_GND;
  double Dmobs_Vgi_bi_Vdbulk_di;
  double Dmobs_Vgi_bi_Vsbulk_si;
  double Dmobs_Vgi_bi_Vgi_bi;
  double Dmobs_Vgi_bi_Vdi_bi;
  double Dmobs_Vgi_bi_Vsi_bi;
  double Dmobs_Vgi_bi_Tempt_GND;
  double Dmobs_Vsbulk_si_Vdbulk_di;
  double Dmobs_Vsbulk_si_Vsbulk_si;
  double Dmobs_Vsbulk_si_Vgi_bi;
  double Dmobs_Vsbulk_si_Vdi_bi;
  double Dmobs_Vsbulk_si_Vsi_bi;
  double Dmobs_Vsbulk_si_Tempt_GND;
  double Dmobs_Vdbulk_di_Vdbulk_di;
  double Dmobs_Vdbulk_di_Vsbulk_si;
  double Dmobs_Vdbulk_di_Vgi_bi;
  double Dmobs_Vdbulk_di_Vdi_bi;
  double Dmobs_Vdbulk_di_Vsi_bi;
  double Dmobs_Vdbulk_di_Tempt_GND;
#endif
#endif
double Eeffs;
#if defined(_DERIVATEFORDDX)
double Eeffs_Vdbulk_di;
double Eeffs_Vsbulk_si;
double Eeffs_Vgi_bi;
double Eeffs_Vdi_bi;
double Eeffs_Vsi_bi;
double Eeffs_Tempt_GND;
#if defined(_DERIVATE2)
  double Eeffs_Vsi_bi_Vdbulk_di;
  double Eeffs_Vsi_bi_Vsbulk_si;
  double Eeffs_Vsi_bi_Vgi_bi;
  double Eeffs_Vsi_bi_Vdi_bi;
  double Eeffs_Vsi_bi_Vsi_bi;
  double Eeffs_Vsi_bi_Tempt_GND;
  double Eeffs_Vdi_bi_Vdbulk_di;
  double Eeffs_Vdi_bi_Vsbulk_si;
  double Eeffs_Vdi_bi_Vgi_bi;
  double Eeffs_Vdi_bi_Vdi_bi;
  double Eeffs_Vdi_bi_Vsi_bi;
  double Eeffs_Vdi_bi_Tempt_GND;
  double Eeffs_Vgi_bi_Vdbulk_di;
  double Eeffs_Vgi_bi_Vsbulk_si;
  double Eeffs_Vgi_bi_Vgi_bi;
  double Eeffs_Vgi_bi_Vdi_bi;
  double Eeffs_Vgi_bi_Vsi_bi;
  double Eeffs_Vgi_bi_Tempt_GND;
  double Eeffs_Vsbulk_si_Vdbulk_di;
  double Eeffs_Vsbulk_si_Vsbulk_si;
  double Eeffs_Vsbulk_si_Vgi_bi;
  double Eeffs_Vsbulk_si_Vdi_bi;
  double Eeffs_Vsbulk_si_Vsi_bi;
  double Eeffs_Vsbulk_si_Tempt_GND;
  double Eeffs_Vdbulk_di_Vdbulk_di;
  double Eeffs_Vdbulk_di_Vsbulk_si;
  double Eeffs_Vdbulk_di_Vgi_bi;
  double Eeffs_Vdbulk_di_Vdi_bi;
  double Eeffs_Vdbulk_di_Vsi_bi;
  double Eeffs_Vdbulk_di_Tempt_GND;
#endif
#endif
double qis;
#if defined(_DERIVATEFORDDX)
double qis_Vdbulk_di;
double qis_Vsbulk_si;
double qis_Vgi_bi;
double qis_Tempt_GND;
double qis_Vdi_bi;
double qis_Vsi_bi;
#if defined(_DERIVATE2)
  double qis_Vsi_bi_Vdbulk_di;
  double qis_Vsi_bi_Vsbulk_si;
  double qis_Vsi_bi_Vgi_bi;
  double qis_Vsi_bi_Tempt_GND;
  double qis_Vsi_bi_Vdi_bi;
  double qis_Vsi_bi_Vsi_bi;
  double qis_Vdi_bi_Vdbulk_di;
  double qis_Vdi_bi_Vsbulk_si;
  double qis_Vdi_bi_Vgi_bi;
  double qis_Vdi_bi_Tempt_GND;
  double qis_Vdi_bi_Vdi_bi;
  double qis_Vdi_bi_Vsi_bi;
  double qis_Vgi_bi_Vdbulk_di;
  double qis_Vgi_bi_Vsbulk_si;
  double qis_Vgi_bi_Vgi_bi;
  double qis_Vgi_bi_Tempt_GND;
  double qis_Vgi_bi_Vdi_bi;
  double qis_Vgi_bi_Vsi_bi;
  double qis_Vsbulk_si_Vdbulk_di;
  double qis_Vsbulk_si_Vsbulk_si;
  double qis_Vsbulk_si_Vgi_bi;
  double qis_Vsbulk_si_Tempt_GND;
  double qis_Vsbulk_si_Vdi_bi;
  double qis_Vsbulk_si_Vsi_bi;
  double qis_Vdbulk_di_Vdbulk_di;
  double qis_Vdbulk_di_Vsbulk_si;
  double qis_Vdbulk_di_Vgi_bi;
  double qis_Vdbulk_di_Tempt_GND;
  double qis_Vdbulk_di_Vdi_bi;
  double qis_Vdbulk_di_Vsi_bi;
#endif
#endif
double qbs;
#if defined(_DERIVATEFORDDX)
double qbs_Vdbulk_di;
double qbs_Vsbulk_si;
double qbs_Vgi_bi;
double qbs_Vdi_bi;
double qbs_Vsi_bi;
double qbs_Tempt_GND;
#if defined(_DERIVATE2)
  double qbs_Vsi_bi_Vdbulk_di;
  double qbs_Vsi_bi_Vsbulk_si;
  double qbs_Vsi_bi_Vgi_bi;
  double qbs_Vsi_bi_Vdi_bi;
  double qbs_Vsi_bi_Vsi_bi;
  double qbs_Vsi_bi_Tempt_GND;
  double qbs_Vdi_bi_Vdbulk_di;
  double qbs_Vdi_bi_Vsbulk_si;
  double qbs_Vdi_bi_Vgi_bi;
  double qbs_Vdi_bi_Vdi_bi;
  double qbs_Vdi_bi_Vsi_bi;
  double qbs_Vdi_bi_Tempt_GND;
  double qbs_Vgi_bi_Vdbulk_di;
  double qbs_Vgi_bi_Vsbulk_si;
  double qbs_Vgi_bi_Vgi_bi;
  double qbs_Vgi_bi_Vdi_bi;
  double qbs_Vgi_bi_Vsi_bi;
  double qbs_Vgi_bi_Tempt_GND;
  double qbs_Vsbulk_si_Vdbulk_di;
  double qbs_Vsbulk_si_Vsbulk_si;
  double qbs_Vsbulk_si_Vgi_bi;
  double qbs_Vsbulk_si_Vdi_bi;
  double qbs_Vsbulk_si_Vsi_bi;
  double qbs_Vsbulk_si_Tempt_GND;
  double qbs_Vdbulk_di_Vdbulk_di;
  double qbs_Vdbulk_di_Vsbulk_si;
  double qbs_Vdbulk_di_Vgi_bi;
  double qbs_Vdbulk_di_Vdi_bi;
  double qbs_Vdbulk_di_Vsi_bi;
  double qbs_Vdbulk_di_Tempt_GND;
#endif
#endif
double EeffFactor;
double psiavg;
#if defined(_DERIVATEFORDDX)
double psiavg_Vgm_di;
double psiavg_Vgm_si;
double psiavg_Vdbulk_di;
double psiavg_Vsbulk_si;
double psiavg_Vgi_bi;
double psiavg_Vdi_bi;
double psiavg_Vsi_bi;
double psiavg_Tempt_GND;
#if defined(_DERIVATE2)
  double psiavg_Vsi_bi_Vgm_di;
  double psiavg_Vsi_bi_Vgm_si;
  double psiavg_Vsi_bi_Vdbulk_di;
  double psiavg_Vsi_bi_Vsbulk_si;
  double psiavg_Vsi_bi_Vgi_bi;
  double psiavg_Vsi_bi_Vdi_bi;
  double psiavg_Vsi_bi_Vsi_bi;
  double psiavg_Vsi_bi_Tempt_GND;
  double psiavg_Vdi_bi_Vgm_di;
  double psiavg_Vdi_bi_Vgm_si;
  double psiavg_Vdi_bi_Vdbulk_di;
  double psiavg_Vdi_bi_Vsbulk_si;
  double psiavg_Vdi_bi_Vgi_bi;
  double psiavg_Vdi_bi_Vdi_bi;
  double psiavg_Vdi_bi_Vsi_bi;
  double psiavg_Vdi_bi_Tempt_GND;
  double psiavg_Vgi_bi_Vgm_di;
  double psiavg_Vgi_bi_Vgm_si;
  double psiavg_Vgi_bi_Vdbulk_di;
  double psiavg_Vgi_bi_Vsbulk_si;
  double psiavg_Vgi_bi_Vgi_bi;
  double psiavg_Vgi_bi_Vdi_bi;
  double psiavg_Vgi_bi_Vsi_bi;
  double psiavg_Vgi_bi_Tempt_GND;
  double psiavg_Vsbulk_si_Vgm_di;
  double psiavg_Vsbulk_si_Vgm_si;
  double psiavg_Vsbulk_si_Vdbulk_di;
  double psiavg_Vsbulk_si_Vsbulk_si;
  double psiavg_Vsbulk_si_Vgi_bi;
  double psiavg_Vsbulk_si_Vdi_bi;
  double psiavg_Vsbulk_si_Vsi_bi;
  double psiavg_Vsbulk_si_Tempt_GND;
  double psiavg_Vdbulk_di_Vgm_di;
  double psiavg_Vdbulk_di_Vgm_si;
  double psiavg_Vdbulk_di_Vdbulk_di;
  double psiavg_Vdbulk_di_Vsbulk_si;
  double psiavg_Vdbulk_di_Vgi_bi;
  double psiavg_Vdbulk_di_Vdi_bi;
  double psiavg_Vdbulk_di_Vsi_bi;
  double psiavg_Vdbulk_di_Tempt_GND;
  double psiavg_Vgm_si_Vgm_di;
  double psiavg_Vgm_si_Vgm_si;
  double psiavg_Vgm_si_Vdbulk_di;
  double psiavg_Vgm_si_Vsbulk_si;
  double psiavg_Vgm_si_Vgi_bi;
  double psiavg_Vgm_si_Vdi_bi;
  double psiavg_Vgm_si_Vsi_bi;
  double psiavg_Vgm_si_Tempt_GND;
  double psiavg_Vgm_di_Vgm_di;
  double psiavg_Vgm_di_Vgm_si;
  double psiavg_Vgm_di_Vdbulk_di;
  double psiavg_Vgm_di_Vsbulk_si;
  double psiavg_Vgm_di_Vgi_bi;
  double psiavg_Vgm_di_Vdi_bi;
  double psiavg_Vgm_di_Vsi_bi;
  double psiavg_Vgm_di_Tempt_GND;
#endif
#endif
double psipclamp;
#if defined(_DERIVATEFORDDX)
double psipclamp_Vgm_di;
double psipclamp_Vgm_si;
double psipclamp_Vdbulk_di;
double psipclamp_Vsbulk_si;
double psipclamp_Vgi_bi;
double psipclamp_Vdi_bi;
double psipclamp_Vsi_bi;
double psipclamp_Tempt_GND;
#if defined(_DERIVATE2)
  double psipclamp_Vsi_bi_Vgm_di;
  double psipclamp_Vsi_bi_Vgm_si;
  double psipclamp_Vsi_bi_Vdbulk_di;
  double psipclamp_Vsi_bi_Vsbulk_si;
  double psipclamp_Vsi_bi_Vgi_bi;
  double psipclamp_Vsi_bi_Vdi_bi;
  double psipclamp_Vsi_bi_Vsi_bi;
  double psipclamp_Vsi_bi_Tempt_GND;
  double psipclamp_Vdi_bi_Vgm_di;
  double psipclamp_Vdi_bi_Vgm_si;
  double psipclamp_Vdi_bi_Vdbulk_di;
  double psipclamp_Vdi_bi_Vsbulk_si;
  double psipclamp_Vdi_bi_Vgi_bi;
  double psipclamp_Vdi_bi_Vdi_bi;
  double psipclamp_Vdi_bi_Vsi_bi;
  double psipclamp_Vdi_bi_Tempt_GND;
  double psipclamp_Vgi_bi_Vgm_di;
  double psipclamp_Vgi_bi_Vgm_si;
  double psipclamp_Vgi_bi_Vdbulk_di;
  double psipclamp_Vgi_bi_Vsbulk_si;
  double psipclamp_Vgi_bi_Vgi_bi;
  double psipclamp_Vgi_bi_Vdi_bi;
  double psipclamp_Vgi_bi_Vsi_bi;
  double psipclamp_Vgi_bi_Tempt_GND;
  double psipclamp_Vsbulk_si_Vgm_di;
  double psipclamp_Vsbulk_si_Vgm_si;
  double psipclamp_Vsbulk_si_Vdbulk_di;
  double psipclamp_Vsbulk_si_Vsbulk_si;
  double psipclamp_Vsbulk_si_Vgi_bi;
  double psipclamp_Vsbulk_si_Vdi_bi;
  double psipclamp_Vsbulk_si_Vsi_bi;
  double psipclamp_Vsbulk_si_Tempt_GND;
  double psipclamp_Vdbulk_di_Vgm_di;
  double psipclamp_Vdbulk_di_Vgm_si;
  double psipclamp_Vdbulk_di_Vdbulk_di;
  double psipclamp_Vdbulk_di_Vsbulk_si;
  double psipclamp_Vdbulk_di_Vgi_bi;
  double psipclamp_Vdbulk_di_Vdi_bi;
  double psipclamp_Vdbulk_di_Vsi_bi;
  double psipclamp_Vdbulk_di_Tempt_GND;
  double psipclamp_Vgm_si_Vgm_di;
  double psipclamp_Vgm_si_Vgm_si;
  double psipclamp_Vgm_si_Vdbulk_di;
  double psipclamp_Vgm_si_Vsbulk_si;
  double psipclamp_Vgm_si_Vgi_bi;
  double psipclamp_Vgm_si_Vdi_bi;
  double psipclamp_Vgm_si_Vsi_bi;
  double psipclamp_Vgm_si_Tempt_GND;
  double psipclamp_Vgm_di_Vgm_di;
  double psipclamp_Vgm_di_Vgm_si;
  double psipclamp_Vgm_di_Vdbulk_di;
  double psipclamp_Vgm_di_Vsbulk_si;
  double psipclamp_Vgm_di_Vgi_bi;
  double psipclamp_Vgm_di_Vdi_bi;
  double psipclamp_Vgm_di_Vsi_bi;
  double psipclamp_Vgm_di_Tempt_GND;
#endif
#endif
double T7;
#if defined(_DERIVATEFORDDX)
double T7_Vgm_si;
double T7_Vgm_di;
double T7_Vdbulk_di;
double T7_Vsbulk_si;
double T7_Vgi_bi;
double T7_Vdi_bi;
double T7_Vsi_bi;
double T7_Tempt_GND;
#if defined(_DERIVATE2)
  double T7_Vsi_bi_Vgm_si;
  double T7_Vsi_bi_Vgm_di;
  double T7_Vsi_bi_Vdbulk_di;
  double T7_Vsi_bi_Vsbulk_si;
  double T7_Vsi_bi_Vgi_bi;
  double T7_Vsi_bi_Vdi_bi;
  double T7_Vsi_bi_Vsi_bi;
  double T7_Vsi_bi_Tempt_GND;
  double T7_Vdi_bi_Vgm_si;
  double T7_Vdi_bi_Vgm_di;
  double T7_Vdi_bi_Vdbulk_di;
  double T7_Vdi_bi_Vsbulk_si;
  double T7_Vdi_bi_Vgi_bi;
  double T7_Vdi_bi_Vdi_bi;
  double T7_Vdi_bi_Vsi_bi;
  double T7_Vdi_bi_Tempt_GND;
  double T7_Vgi_bi_Vgm_si;
  double T7_Vgi_bi_Vgm_di;
  double T7_Vgi_bi_Vdbulk_di;
  double T7_Vgi_bi_Vsbulk_si;
  double T7_Vgi_bi_Vgi_bi;
  double T7_Vgi_bi_Vdi_bi;
  double T7_Vgi_bi_Vsi_bi;
  double T7_Vgi_bi_Tempt_GND;
  double T7_Vsbulk_si_Vgm_si;
  double T7_Vsbulk_si_Vgm_di;
  double T7_Vsbulk_si_Vdbulk_di;
  double T7_Vsbulk_si_Vsbulk_si;
  double T7_Vsbulk_si_Vgi_bi;
  double T7_Vsbulk_si_Vdi_bi;
  double T7_Vsbulk_si_Vsi_bi;
  double T7_Vsbulk_si_Tempt_GND;
  double T7_Vdbulk_di_Vgm_si;
  double T7_Vdbulk_di_Vgm_di;
  double T7_Vdbulk_di_Vdbulk_di;
  double T7_Vdbulk_di_Vsbulk_si;
  double T7_Vdbulk_di_Vgi_bi;
  double T7_Vdbulk_di_Vdi_bi;
  double T7_Vdbulk_di_Vsi_bi;
  double T7_Vdbulk_di_Tempt_GND;
  double T7_Vgm_di_Vgm_si;
  double T7_Vgm_di_Vgm_di;
  double T7_Vgm_di_Vdbulk_di;
  double T7_Vgm_di_Vsbulk_si;
  double T7_Vgm_di_Vgi_bi;
  double T7_Vgm_di_Vdi_bi;
  double T7_Vgm_di_Vsi_bi;
  double T7_Vgm_di_Tempt_GND;
  double T7_Vgm_si_Vgm_si;
  double T7_Vgm_si_Vgm_di;
  double T7_Vgm_si_Vdbulk_di;
  double T7_Vgm_si_Vsbulk_si;
  double T7_Vgm_si_Vgi_bi;
  double T7_Vgm_si_Vdi_bi;
  double T7_Vgm_si_Vsi_bi;
  double T7_Vgm_si_Tempt_GND;
#endif
#endif
double sqrtpsisainv;
#if defined(_DERIVATEFORDDX)
double sqrtpsisainv_Vgm_di;
double sqrtpsisainv_Vgm_si;
double sqrtpsisainv_Vdbulk_di;
double sqrtpsisainv_Vsbulk_si;
double sqrtpsisainv_Vgi_bi;
double sqrtpsisainv_Vdi_bi;
double sqrtpsisainv_Vsi_bi;
double sqrtpsisainv_Tempt_GND;
#if defined(_DERIVATE2)
  double sqrtpsisainv_Vsi_bi_Vgm_di;
  double sqrtpsisainv_Vsi_bi_Vgm_si;
  double sqrtpsisainv_Vsi_bi_Vdbulk_di;
  double sqrtpsisainv_Vsi_bi_Vsbulk_si;
  double sqrtpsisainv_Vsi_bi_Vgi_bi;
  double sqrtpsisainv_Vsi_bi_Vdi_bi;
  double sqrtpsisainv_Vsi_bi_Vsi_bi;
  double sqrtpsisainv_Vsi_bi_Tempt_GND;
  double sqrtpsisainv_Vdi_bi_Vgm_di;
  double sqrtpsisainv_Vdi_bi_Vgm_si;
  double sqrtpsisainv_Vdi_bi_Vdbulk_di;
  double sqrtpsisainv_Vdi_bi_Vsbulk_si;
  double sqrtpsisainv_Vdi_bi_Vgi_bi;
  double sqrtpsisainv_Vdi_bi_Vdi_bi;
  double sqrtpsisainv_Vdi_bi_Vsi_bi;
  double sqrtpsisainv_Vdi_bi_Tempt_GND;
  double sqrtpsisainv_Vgi_bi_Vgm_di;
  double sqrtpsisainv_Vgi_bi_Vgm_si;
  double sqrtpsisainv_Vgi_bi_Vdbulk_di;
  double sqrtpsisainv_Vgi_bi_Vsbulk_si;
  double sqrtpsisainv_Vgi_bi_Vgi_bi;
  double sqrtpsisainv_Vgi_bi_Vdi_bi;
  double sqrtpsisainv_Vgi_bi_Vsi_bi;
  double sqrtpsisainv_Vgi_bi_Tempt_GND;
  double sqrtpsisainv_Vsbulk_si_Vgm_di;
  double sqrtpsisainv_Vsbulk_si_Vgm_si;
  double sqrtpsisainv_Vsbulk_si_Vdbulk_di;
  double sqrtpsisainv_Vsbulk_si_Vsbulk_si;
  double sqrtpsisainv_Vsbulk_si_Vgi_bi;
  double sqrtpsisainv_Vsbulk_si_Vdi_bi;
  double sqrtpsisainv_Vsbulk_si_Vsi_bi;
  double sqrtpsisainv_Vsbulk_si_Tempt_GND;
  double sqrtpsisainv_Vdbulk_di_Vgm_di;
  double sqrtpsisainv_Vdbulk_di_Vgm_si;
  double sqrtpsisainv_Vdbulk_di_Vdbulk_di;
  double sqrtpsisainv_Vdbulk_di_Vsbulk_si;
  double sqrtpsisainv_Vdbulk_di_Vgi_bi;
  double sqrtpsisainv_Vdbulk_di_Vdi_bi;
  double sqrtpsisainv_Vdbulk_di_Vsi_bi;
  double sqrtpsisainv_Vdbulk_di_Tempt_GND;
  double sqrtpsisainv_Vgm_si_Vgm_di;
  double sqrtpsisainv_Vgm_si_Vgm_si;
  double sqrtpsisainv_Vgm_si_Vdbulk_di;
  double sqrtpsisainv_Vgm_si_Vsbulk_si;
  double sqrtpsisainv_Vgm_si_Vgi_bi;
  double sqrtpsisainv_Vgm_si_Vdi_bi;
  double sqrtpsisainv_Vgm_si_Vsi_bi;
  double sqrtpsisainv_Vgm_si_Tempt_GND;
  double sqrtpsisainv_Vgm_di_Vgm_di;
  double sqrtpsisainv_Vgm_di_Vgm_si;
  double sqrtpsisainv_Vgm_di_Vdbulk_di;
  double sqrtpsisainv_Vgm_di_Vsbulk_si;
  double sqrtpsisainv_Vgm_di_Vgi_bi;
  double sqrtpsisainv_Vgm_di_Vdi_bi;
  double sqrtpsisainv_Vgm_di_Vsi_bi;
  double sqrtpsisainv_Vgm_di_Tempt_GND;
#endif
#endif
double qs;
#if defined(_DERIVATEFORDDX)
double qs_Vgm_si;
double qs_Vgm_di;
double qs_Vdbulk_di;
double qs_Vsbulk_si;
double qs_Vgi_bi;
double qs_Vdi_bi;
double qs_Vsi_bi;
double qs_Tempt_GND;
#if defined(_DERIVATE2)
  double qs_Vsi_bi_Vgm_si;
  double qs_Vsi_bi_Vgm_di;
  double qs_Vsi_bi_Vdbulk_di;
  double qs_Vsi_bi_Vsbulk_si;
  double qs_Vsi_bi_Vgi_bi;
  double qs_Vsi_bi_Vdi_bi;
  double qs_Vsi_bi_Vsi_bi;
  double qs_Vsi_bi_Tempt_GND;
  double qs_Vdi_bi_Vgm_si;
  double qs_Vdi_bi_Vgm_di;
  double qs_Vdi_bi_Vdbulk_di;
  double qs_Vdi_bi_Vsbulk_si;
  double qs_Vdi_bi_Vgi_bi;
  double qs_Vdi_bi_Vdi_bi;
  double qs_Vdi_bi_Vsi_bi;
  double qs_Vdi_bi_Tempt_GND;
  double qs_Vgi_bi_Vgm_si;
  double qs_Vgi_bi_Vgm_di;
  double qs_Vgi_bi_Vdbulk_di;
  double qs_Vgi_bi_Vsbulk_si;
  double qs_Vgi_bi_Vgi_bi;
  double qs_Vgi_bi_Vdi_bi;
  double qs_Vgi_bi_Vsi_bi;
  double qs_Vgi_bi_Tempt_GND;
  double qs_Vsbulk_si_Vgm_si;
  double qs_Vsbulk_si_Vgm_di;
  double qs_Vsbulk_si_Vdbulk_di;
  double qs_Vsbulk_si_Vsbulk_si;
  double qs_Vsbulk_si_Vgi_bi;
  double qs_Vsbulk_si_Vdi_bi;
  double qs_Vsbulk_si_Vsi_bi;
  double qs_Vsbulk_si_Tempt_GND;
  double qs_Vdbulk_di_Vgm_si;
  double qs_Vdbulk_di_Vgm_di;
  double qs_Vdbulk_di_Vdbulk_di;
  double qs_Vdbulk_di_Vsbulk_si;
  double qs_Vdbulk_di_Vgi_bi;
  double qs_Vdbulk_di_Vdi_bi;
  double qs_Vdbulk_di_Vsi_bi;
  double qs_Vdbulk_di_Tempt_GND;
  double qs_Vgm_di_Vgm_si;
  double qs_Vgm_di_Vgm_di;
  double qs_Vgm_di_Vdbulk_di;
  double qs_Vgm_di_Vsbulk_si;
  double qs_Vgm_di_Vgi_bi;
  double qs_Vgm_di_Vdi_bi;
  double qs_Vgm_di_Vsi_bi;
  double qs_Vgm_di_Tempt_GND;
  double qs_Vgm_si_Vgm_si;
  double qs_Vgm_si_Vgm_di;
  double qs_Vgm_si_Vdbulk_di;
  double qs_Vgm_si_Vsbulk_si;
  double qs_Vgm_si_Vgi_bi;
  double qs_Vgm_si_Vdi_bi;
  double qs_Vgm_si_Vsi_bi;
  double qs_Vgm_si_Tempt_GND;
#endif
#endif
double T6;
#if defined(_DERIVATEFORDDX)
double T6_Vgm_di;
double T6_Vgm_si;
double T6_Vdbulk_di;
double T6_Vsbulk_si;
double T6_Vgi_bi;
double T6_Vdi_bi;
double T6_Vsi_bi;
double T6_Tempt_GND;
#if defined(_DERIVATE2)
  double T6_Vsi_bi_Vgm_di;
  double T6_Vsi_bi_Vgm_si;
  double T6_Vsi_bi_Vdbulk_di;
  double T6_Vsi_bi_Vsbulk_si;
  double T6_Vsi_bi_Vgi_bi;
  double T6_Vsi_bi_Vdi_bi;
  double T6_Vsi_bi_Vsi_bi;
  double T6_Vsi_bi_Tempt_GND;
  double T6_Vdi_bi_Vgm_di;
  double T6_Vdi_bi_Vgm_si;
  double T6_Vdi_bi_Vdbulk_di;
  double T6_Vdi_bi_Vsbulk_si;
  double T6_Vdi_bi_Vgi_bi;
  double T6_Vdi_bi_Vdi_bi;
  double T6_Vdi_bi_Vsi_bi;
  double T6_Vdi_bi_Tempt_GND;
  double T6_Vgi_bi_Vgm_di;
  double T6_Vgi_bi_Vgm_si;
  double T6_Vgi_bi_Vdbulk_di;
  double T6_Vgi_bi_Vsbulk_si;
  double T6_Vgi_bi_Vgi_bi;
  double T6_Vgi_bi_Vdi_bi;
  double T6_Vgi_bi_Vsi_bi;
  double T6_Vgi_bi_Tempt_GND;
  double T6_Vsbulk_si_Vgm_di;
  double T6_Vsbulk_si_Vgm_si;
  double T6_Vsbulk_si_Vdbulk_di;
  double T6_Vsbulk_si_Vsbulk_si;
  double T6_Vsbulk_si_Vgi_bi;
  double T6_Vsbulk_si_Vdi_bi;
  double T6_Vsbulk_si_Vsi_bi;
  double T6_Vsbulk_si_Tempt_GND;
  double T6_Vdbulk_di_Vgm_di;
  double T6_Vdbulk_di_Vgm_si;
  double T6_Vdbulk_di_Vdbulk_di;
  double T6_Vdbulk_di_Vsbulk_si;
  double T6_Vdbulk_di_Vgi_bi;
  double T6_Vdbulk_di_Vdi_bi;
  double T6_Vdbulk_di_Vsi_bi;
  double T6_Vdbulk_di_Tempt_GND;
  double T6_Vgm_si_Vgm_di;
  double T6_Vgm_si_Vgm_si;
  double T6_Vgm_si_Vdbulk_di;
  double T6_Vgm_si_Vsbulk_si;
  double T6_Vgm_si_Vgi_bi;
  double T6_Vgm_si_Vdi_bi;
  double T6_Vgm_si_Vsi_bi;
  double T6_Vgm_si_Tempt_GND;
  double T6_Vgm_di_Vgm_di;
  double T6_Vgm_di_Vgm_si;
  double T6_Vgm_di_Vdbulk_di;
  double T6_Vgm_di_Vsbulk_si;
  double T6_Vgm_di_Vgi_bi;
  double T6_Vgm_di_Vdi_bi;
  double T6_Vgm_di_Vsi_bi;
  double T6_Vgm_di_Tempt_GND;
#endif
#endif
double T5;
#if defined(_DERIVATEFORDDX)
double T5_Vgm_si;
double T5_Vgm_di;
double T5_Vdbulk_di;
double T5_Vsbulk_si;
double T5_Vgi_bi;
double T5_Vdi_bi;
double T5_Vsi_bi;
double T5_Tempt_GND;
#if defined(_DERIVATE2)
  double T5_Vsi_bi_Vgm_si;
  double T5_Vsi_bi_Vgm_di;
  double T5_Vsi_bi_Vdbulk_di;
  double T5_Vsi_bi_Vsbulk_si;
  double T5_Vsi_bi_Vgi_bi;
  double T5_Vsi_bi_Vdi_bi;
  double T5_Vsi_bi_Vsi_bi;
  double T5_Vsi_bi_Tempt_GND;
  double T5_Vdi_bi_Vgm_si;
  double T5_Vdi_bi_Vgm_di;
  double T5_Vdi_bi_Vdbulk_di;
  double T5_Vdi_bi_Vsbulk_si;
  double T5_Vdi_bi_Vgi_bi;
  double T5_Vdi_bi_Vdi_bi;
  double T5_Vdi_bi_Vsi_bi;
  double T5_Vdi_bi_Tempt_GND;
  double T5_Vgi_bi_Vgm_si;
  double T5_Vgi_bi_Vgm_di;
  double T5_Vgi_bi_Vdbulk_di;
  double T5_Vgi_bi_Vsbulk_si;
  double T5_Vgi_bi_Vgi_bi;
  double T5_Vgi_bi_Vdi_bi;
  double T5_Vgi_bi_Vsi_bi;
  double T5_Vgi_bi_Tempt_GND;
  double T5_Vsbulk_si_Vgm_si;
  double T5_Vsbulk_si_Vgm_di;
  double T5_Vsbulk_si_Vdbulk_di;
  double T5_Vsbulk_si_Vsbulk_si;
  double T5_Vsbulk_si_Vgi_bi;
  double T5_Vsbulk_si_Vdi_bi;
  double T5_Vsbulk_si_Vsi_bi;
  double T5_Vsbulk_si_Tempt_GND;
  double T5_Vdbulk_di_Vgm_si;
  double T5_Vdbulk_di_Vgm_di;
  double T5_Vdbulk_di_Vdbulk_di;
  double T5_Vdbulk_di_Vsbulk_si;
  double T5_Vdbulk_di_Vgi_bi;
  double T5_Vdbulk_di_Vdi_bi;
  double T5_Vdbulk_di_Vsi_bi;
  double T5_Vdbulk_di_Tempt_GND;
  double T5_Vgm_di_Vgm_si;
  double T5_Vgm_di_Vgm_di;
  double T5_Vgm_di_Vdbulk_di;
  double T5_Vgm_di_Vsbulk_si;
  double T5_Vgm_di_Vgi_bi;
  double T5_Vgm_di_Vdi_bi;
  double T5_Vgm_di_Vsi_bi;
  double T5_Vgm_di_Tempt_GND;
  double T5_Vgm_si_Vgm_si;
  double T5_Vgm_si_Vgm_di;
  double T5_Vgm_si_Vdbulk_di;
  double T5_Vgm_si_Vsbulk_si;
  double T5_Vgm_si_Vgi_bi;
  double T5_Vgm_si_Vdi_bi;
  double T5_Vgm_si_Vsi_bi;
  double T5_Vgm_si_Tempt_GND;
#endif
#endif
double sqrtpsisa;
#if defined(_DERIVATEFORDDX)
double sqrtpsisa_Vgm_di;
double sqrtpsisa_Vgm_si;
double sqrtpsisa_Vdbulk_di;
double sqrtpsisa_Vsbulk_si;
double sqrtpsisa_Vgi_bi;
double sqrtpsisa_Vdi_bi;
double sqrtpsisa_Vsi_bi;
double sqrtpsisa_Tempt_GND;
#if defined(_DERIVATE2)
  double sqrtpsisa_Vsi_bi_Vgm_di;
  double sqrtpsisa_Vsi_bi_Vgm_si;
  double sqrtpsisa_Vsi_bi_Vdbulk_di;
  double sqrtpsisa_Vsi_bi_Vsbulk_si;
  double sqrtpsisa_Vsi_bi_Vgi_bi;
  double sqrtpsisa_Vsi_bi_Vdi_bi;
  double sqrtpsisa_Vsi_bi_Vsi_bi;
  double sqrtpsisa_Vsi_bi_Tempt_GND;
  double sqrtpsisa_Vdi_bi_Vgm_di;
  double sqrtpsisa_Vdi_bi_Vgm_si;
  double sqrtpsisa_Vdi_bi_Vdbulk_di;
  double sqrtpsisa_Vdi_bi_Vsbulk_si;
  double sqrtpsisa_Vdi_bi_Vgi_bi;
  double sqrtpsisa_Vdi_bi_Vdi_bi;
  double sqrtpsisa_Vdi_bi_Vsi_bi;
  double sqrtpsisa_Vdi_bi_Tempt_GND;
  double sqrtpsisa_Vgi_bi_Vgm_di;
  double sqrtpsisa_Vgi_bi_Vgm_si;
  double sqrtpsisa_Vgi_bi_Vdbulk_di;
  double sqrtpsisa_Vgi_bi_Vsbulk_si;
  double sqrtpsisa_Vgi_bi_Vgi_bi;
  double sqrtpsisa_Vgi_bi_Vdi_bi;
  double sqrtpsisa_Vgi_bi_Vsi_bi;
  double sqrtpsisa_Vgi_bi_Tempt_GND;
  double sqrtpsisa_Vsbulk_si_Vgm_di;
  double sqrtpsisa_Vsbulk_si_Vgm_si;
  double sqrtpsisa_Vsbulk_si_Vdbulk_di;
  double sqrtpsisa_Vsbulk_si_Vsbulk_si;
  double sqrtpsisa_Vsbulk_si_Vgi_bi;
  double sqrtpsisa_Vsbulk_si_Vdi_bi;
  double sqrtpsisa_Vsbulk_si_Vsi_bi;
  double sqrtpsisa_Vsbulk_si_Tempt_GND;
  double sqrtpsisa_Vdbulk_di_Vgm_di;
  double sqrtpsisa_Vdbulk_di_Vgm_si;
  double sqrtpsisa_Vdbulk_di_Vdbulk_di;
  double sqrtpsisa_Vdbulk_di_Vsbulk_si;
  double sqrtpsisa_Vdbulk_di_Vgi_bi;
  double sqrtpsisa_Vdbulk_di_Vdi_bi;
  double sqrtpsisa_Vdbulk_di_Vsi_bi;
  double sqrtpsisa_Vdbulk_di_Tempt_GND;
  double sqrtpsisa_Vgm_si_Vgm_di;
  double sqrtpsisa_Vgm_si_Vgm_si;
  double sqrtpsisa_Vgm_si_Vdbulk_di;
  double sqrtpsisa_Vgm_si_Vsbulk_si;
  double sqrtpsisa_Vgm_si_Vgi_bi;
  double sqrtpsisa_Vgm_si_Vdi_bi;
  double sqrtpsisa_Vgm_si_Vsi_bi;
  double sqrtpsisa_Vgm_si_Tempt_GND;
  double sqrtpsisa_Vgm_di_Vgm_di;
  double sqrtpsisa_Vgm_di_Vgm_si;
  double sqrtpsisa_Vgm_di_Vdbulk_di;
  double sqrtpsisa_Vgm_di_Vsbulk_si;
  double sqrtpsisa_Vgm_di_Vgi_bi;
  double sqrtpsisa_Vgm_di_Vdi_bi;
  double sqrtpsisa_Vgm_di_Vsi_bi;
  double sqrtpsisa_Vgm_di_Tempt_GND;
#endif
#endif
double T9;
#if defined(_DERIVATEFORDDX)
double T9_Vgm_si;
double T9_Vgm_di;
double T9_Vdbulk_di;
double T9_Vsbulk_si;
double T9_Vdi_bi;
double T9_Vsi_bi;
double T9_Tempt_GND;
double T9_Vgi_bi;
#if defined(_DERIVATE2)
  double T9_Vgi_bi_Vgm_si;
  double T9_Vgi_bi_Vgm_di;
  double T9_Vgi_bi_Vdbulk_di;
  double T9_Vgi_bi_Vsbulk_si;
  double T9_Vgi_bi_Vdi_bi;
  double T9_Vgi_bi_Vsi_bi;
  double T9_Vgi_bi_Tempt_GND;
  double T9_Vgi_bi_Vgi_bi;
  double T9_Vsi_bi_Vgm_si;
  double T9_Vsi_bi_Vgm_di;
  double T9_Vsi_bi_Vdbulk_di;
  double T9_Vsi_bi_Vsbulk_si;
  double T9_Vsi_bi_Vdi_bi;
  double T9_Vsi_bi_Vsi_bi;
  double T9_Vsi_bi_Tempt_GND;
  double T9_Vsi_bi_Vgi_bi;
  double T9_Vdi_bi_Vgm_si;
  double T9_Vdi_bi_Vgm_di;
  double T9_Vdi_bi_Vdbulk_di;
  double T9_Vdi_bi_Vsbulk_si;
  double T9_Vdi_bi_Vdi_bi;
  double T9_Vdi_bi_Vsi_bi;
  double T9_Vdi_bi_Tempt_GND;
  double T9_Vdi_bi_Vgi_bi;
  double T9_Vsbulk_si_Vgm_si;
  double T9_Vsbulk_si_Vgm_di;
  double T9_Vsbulk_si_Vdbulk_di;
  double T9_Vsbulk_si_Vsbulk_si;
  double T9_Vsbulk_si_Vdi_bi;
  double T9_Vsbulk_si_Vsi_bi;
  double T9_Vsbulk_si_Tempt_GND;
  double T9_Vsbulk_si_Vgi_bi;
  double T9_Vdbulk_di_Vgm_si;
  double T9_Vdbulk_di_Vgm_di;
  double T9_Vdbulk_di_Vdbulk_di;
  double T9_Vdbulk_di_Vsbulk_si;
  double T9_Vdbulk_di_Vdi_bi;
  double T9_Vdbulk_di_Vsi_bi;
  double T9_Vdbulk_di_Tempt_GND;
  double T9_Vdbulk_di_Vgi_bi;
  double T9_Vgm_di_Vgm_si;
  double T9_Vgm_di_Vgm_di;
  double T9_Vgm_di_Vdbulk_di;
  double T9_Vgm_di_Vsbulk_si;
  double T9_Vgm_di_Vdi_bi;
  double T9_Vgm_di_Vsi_bi;
  double T9_Vgm_di_Tempt_GND;
  double T9_Vgm_di_Vgi_bi;
  double T9_Vgm_si_Vgm_si;
  double T9_Vgm_si_Vgm_di;
  double T9_Vgm_si_Vdbulk_di;
  double T9_Vgm_si_Vsbulk_si;
  double T9_Vgm_si_Vdi_bi;
  double T9_Vgm_si_Vsi_bi;
  double T9_Vgm_si_Tempt_GND;
  double T9_Vgm_si_Vgi_bi;
#endif
#endif
double sqrtpsip;
#if defined(_DERIVATEFORDDX)
double sqrtpsip_Vgm_di;
double sqrtpsip_Vgm_si;
double sqrtpsip_Vdbulk_di;
double sqrtpsip_Vsbulk_si;
double sqrtpsip_Vgi_bi;
double sqrtpsip_Vdi_bi;
double sqrtpsip_Vsi_bi;
double sqrtpsip_Tempt_GND;
#if defined(_DERIVATE2)
  double sqrtpsip_Vsi_bi_Vgm_di;
  double sqrtpsip_Vsi_bi_Vgm_si;
  double sqrtpsip_Vsi_bi_Vdbulk_di;
  double sqrtpsip_Vsi_bi_Vsbulk_si;
  double sqrtpsip_Vsi_bi_Vgi_bi;
  double sqrtpsip_Vsi_bi_Vdi_bi;
  double sqrtpsip_Vsi_bi_Vsi_bi;
  double sqrtpsip_Vsi_bi_Tempt_GND;
  double sqrtpsip_Vdi_bi_Vgm_di;
  double sqrtpsip_Vdi_bi_Vgm_si;
  double sqrtpsip_Vdi_bi_Vdbulk_di;
  double sqrtpsip_Vdi_bi_Vsbulk_si;
  double sqrtpsip_Vdi_bi_Vgi_bi;
  double sqrtpsip_Vdi_bi_Vdi_bi;
  double sqrtpsip_Vdi_bi_Vsi_bi;
  double sqrtpsip_Vdi_bi_Tempt_GND;
  double sqrtpsip_Vgi_bi_Vgm_di;
  double sqrtpsip_Vgi_bi_Vgm_si;
  double sqrtpsip_Vgi_bi_Vdbulk_di;
  double sqrtpsip_Vgi_bi_Vsbulk_si;
  double sqrtpsip_Vgi_bi_Vgi_bi;
  double sqrtpsip_Vgi_bi_Vdi_bi;
  double sqrtpsip_Vgi_bi_Vsi_bi;
  double sqrtpsip_Vgi_bi_Tempt_GND;
  double sqrtpsip_Vsbulk_si_Vgm_di;
  double sqrtpsip_Vsbulk_si_Vgm_si;
  double sqrtpsip_Vsbulk_si_Vdbulk_di;
  double sqrtpsip_Vsbulk_si_Vsbulk_si;
  double sqrtpsip_Vsbulk_si_Vgi_bi;
  double sqrtpsip_Vsbulk_si_Vdi_bi;
  double sqrtpsip_Vsbulk_si_Vsi_bi;
  double sqrtpsip_Vsbulk_si_Tempt_GND;
  double sqrtpsip_Vdbulk_di_Vgm_di;
  double sqrtpsip_Vdbulk_di_Vgm_si;
  double sqrtpsip_Vdbulk_di_Vdbulk_di;
  double sqrtpsip_Vdbulk_di_Vsbulk_si;
  double sqrtpsip_Vdbulk_di_Vgi_bi;
  double sqrtpsip_Vdbulk_di_Vdi_bi;
  double sqrtpsip_Vdbulk_di_Vsi_bi;
  double sqrtpsip_Vdbulk_di_Tempt_GND;
  double sqrtpsip_Vgm_si_Vgm_di;
  double sqrtpsip_Vgm_si_Vgm_si;
  double sqrtpsip_Vgm_si_Vdbulk_di;
  double sqrtpsip_Vgm_si_Vsbulk_si;
  double sqrtpsip_Vgm_si_Vgi_bi;
  double sqrtpsip_Vgm_si_Vdi_bi;
  double sqrtpsip_Vgm_si_Vsi_bi;
  double sqrtpsip_Vgm_si_Tempt_GND;
  double sqrtpsip_Vgm_di_Vgm_di;
  double sqrtpsip_Vgm_di_Vgm_si;
  double sqrtpsip_Vgm_di_Vdbulk_di;
  double sqrtpsip_Vgm_di_Vsbulk_si;
  double sqrtpsip_Vgm_di_Vgi_bi;
  double sqrtpsip_Vgm_di_Vdi_bi;
  double sqrtpsip_Vgm_di_Vsi_bi;
  double sqrtpsip_Vgm_di_Tempt_GND;
#endif
#endif
double T8;
#if defined(_DERIVATEFORDDX)
double T8_Vgm_di;
double T8_Vgm_si;
double T8_Vdbulk_di;
double T8_Vsbulk_si;
double T8_Vgi_bi;
double T8_Vdi_bi;
double T8_Vsi_bi;
double T8_Tempt_GND;
#if defined(_DERIVATE2)
  double T8_Vsi_bi_Vgm_di;
  double T8_Vsi_bi_Vgm_si;
  double T8_Vsi_bi_Vdbulk_di;
  double T8_Vsi_bi_Vsbulk_si;
  double T8_Vsi_bi_Vgi_bi;
  double T8_Vsi_bi_Vdi_bi;
  double T8_Vsi_bi_Vsi_bi;
  double T8_Vsi_bi_Tempt_GND;
  double T8_Vdi_bi_Vgm_di;
  double T8_Vdi_bi_Vgm_si;
  double T8_Vdi_bi_Vdbulk_di;
  double T8_Vdi_bi_Vsbulk_si;
  double T8_Vdi_bi_Vgi_bi;
  double T8_Vdi_bi_Vdi_bi;
  double T8_Vdi_bi_Vsi_bi;
  double T8_Vdi_bi_Tempt_GND;
  double T8_Vgi_bi_Vgm_di;
  double T8_Vgi_bi_Vgm_si;
  double T8_Vgi_bi_Vdbulk_di;
  double T8_Vgi_bi_Vsbulk_si;
  double T8_Vgi_bi_Vgi_bi;
  double T8_Vgi_bi_Vdi_bi;
  double T8_Vgi_bi_Vsi_bi;
  double T8_Vgi_bi_Tempt_GND;
  double T8_Vsbulk_si_Vgm_di;
  double T8_Vsbulk_si_Vgm_si;
  double T8_Vsbulk_si_Vdbulk_di;
  double T8_Vsbulk_si_Vsbulk_si;
  double T8_Vsbulk_si_Vgi_bi;
  double T8_Vsbulk_si_Vdi_bi;
  double T8_Vsbulk_si_Vsi_bi;
  double T8_Vsbulk_si_Tempt_GND;
  double T8_Vdbulk_di_Vgm_di;
  double T8_Vdbulk_di_Vgm_si;
  double T8_Vdbulk_di_Vdbulk_di;
  double T8_Vdbulk_di_Vsbulk_si;
  double T8_Vdbulk_di_Vgi_bi;
  double T8_Vdbulk_di_Vdi_bi;
  double T8_Vdbulk_di_Vsi_bi;
  double T8_Vdbulk_di_Tempt_GND;
  double T8_Vgm_si_Vgm_di;
  double T8_Vgm_si_Vgm_si;
  double T8_Vgm_si_Vdbulk_di;
  double T8_Vgm_si_Vsbulk_si;
  double T8_Vgm_si_Vgi_bi;
  double T8_Vgm_si_Vdi_bi;
  double T8_Vgm_si_Vsi_bi;
  double T8_Vgm_si_Tempt_GND;
  double T8_Vgm_di_Vgm_di;
  double T8_Vgm_di_Vgm_si;
  double T8_Vgm_di_Vdbulk_di;
  double T8_Vgm_di_Vsbulk_si;
  double T8_Vgm_di_Vgi_bi;
  double T8_Vgm_di_Vdi_bi;
  double T8_Vgm_di_Vsi_bi;
  double T8_Vgm_di_Tempt_GND;
#endif
#endif
double psip;
#if defined(_DERIVATEFORDDX)
double psip_Vgm_di;
double psip_Vgm_si;
double psip_Vdbulk_di;
double psip_Vsbulk_si;
double psip_Vgi_bi;
double psip_Vdi_bi;
double psip_Vsi_bi;
double psip_Tempt_GND;
#if defined(_DERIVATE2)
  double psip_Vsi_bi_Vgm_di;
  double psip_Vsi_bi_Vgm_si;
  double psip_Vsi_bi_Vdbulk_di;
  double psip_Vsi_bi_Vsbulk_si;
  double psip_Vsi_bi_Vgi_bi;
  double psip_Vsi_bi_Vdi_bi;
  double psip_Vsi_bi_Vsi_bi;
  double psip_Vsi_bi_Tempt_GND;
  double psip_Vdi_bi_Vgm_di;
  double psip_Vdi_bi_Vgm_si;
  double psip_Vdi_bi_Vdbulk_di;
  double psip_Vdi_bi_Vsbulk_si;
  double psip_Vdi_bi_Vgi_bi;
  double psip_Vdi_bi_Vdi_bi;
  double psip_Vdi_bi_Vsi_bi;
  double psip_Vdi_bi_Tempt_GND;
  double psip_Vgi_bi_Vgm_di;
  double psip_Vgi_bi_Vgm_si;
  double psip_Vgi_bi_Vdbulk_di;
  double psip_Vgi_bi_Vsbulk_si;
  double psip_Vgi_bi_Vgi_bi;
  double psip_Vgi_bi_Vdi_bi;
  double psip_Vgi_bi_Vsi_bi;
  double psip_Vgi_bi_Tempt_GND;
  double psip_Vsbulk_si_Vgm_di;
  double psip_Vsbulk_si_Vgm_si;
  double psip_Vsbulk_si_Vdbulk_di;
  double psip_Vsbulk_si_Vsbulk_si;
  double psip_Vsbulk_si_Vgi_bi;
  double psip_Vsbulk_si_Vdi_bi;
  double psip_Vsbulk_si_Vsi_bi;
  double psip_Vsbulk_si_Tempt_GND;
  double psip_Vdbulk_di_Vgm_di;
  double psip_Vdbulk_di_Vgm_si;
  double psip_Vdbulk_di_Vdbulk_di;
  double psip_Vdbulk_di_Vsbulk_si;
  double psip_Vdbulk_di_Vgi_bi;
  double psip_Vdbulk_di_Vdi_bi;
  double psip_Vdbulk_di_Vsi_bi;
  double psip_Vdbulk_di_Tempt_GND;
  double psip_Vgm_si_Vgm_di;
  double psip_Vgm_si_Vgm_si;
  double psip_Vgm_si_Vdbulk_di;
  double psip_Vgm_si_Vsbulk_si;
  double psip_Vgm_si_Vgi_bi;
  double psip_Vgm_si_Vdi_bi;
  double psip_Vgm_si_Vsi_bi;
  double psip_Vgm_si_Tempt_GND;
  double psip_Vgm_di_Vgm_di;
  double psip_Vgm_di_Vgm_si;
  double psip_Vgm_di_Vdbulk_di;
  double psip_Vgm_di_Vsbulk_si;
  double psip_Vgm_di_Vgi_bi;
  double psip_Vgm_di_Vdi_bi;
  double psip_Vgm_di_Vsi_bi;
  double psip_Vgm_di_Tempt_GND;
#endif
#endif
double gammaPD;
#if defined(_DERIVATEFORDDX)
double gammaPD_Vgm_si;
double gammaPD_Vdbulk_di;
double gammaPD_Vsbulk_si;
double gammaPD_Vgi_bi;
double gammaPD_Vdi_bi;
double gammaPD_Vsi_bi;
double gammaPD_Tempt_GND;
#if defined(_DERIVATE2)
  double gammaPD_Vsi_bi_Vgm_si;
  double gammaPD_Vsi_bi_Vdbulk_di;
  double gammaPD_Vsi_bi_Vsbulk_si;
  double gammaPD_Vsi_bi_Vgi_bi;
  double gammaPD_Vsi_bi_Vdi_bi;
  double gammaPD_Vsi_bi_Vsi_bi;
  double gammaPD_Vsi_bi_Tempt_GND;
  double gammaPD_Vdi_bi_Vgm_si;
  double gammaPD_Vdi_bi_Vdbulk_di;
  double gammaPD_Vdi_bi_Vsbulk_si;
  double gammaPD_Vdi_bi_Vgi_bi;
  double gammaPD_Vdi_bi_Vdi_bi;
  double gammaPD_Vdi_bi_Vsi_bi;
  double gammaPD_Vdi_bi_Tempt_GND;
  double gammaPD_Vgi_bi_Vgm_si;
  double gammaPD_Vgi_bi_Vdbulk_di;
  double gammaPD_Vgi_bi_Vsbulk_si;
  double gammaPD_Vgi_bi_Vgi_bi;
  double gammaPD_Vgi_bi_Vdi_bi;
  double gammaPD_Vgi_bi_Vsi_bi;
  double gammaPD_Vgi_bi_Tempt_GND;
  double gammaPD_Vsbulk_si_Vgm_si;
  double gammaPD_Vsbulk_si_Vdbulk_di;
  double gammaPD_Vsbulk_si_Vsbulk_si;
  double gammaPD_Vsbulk_si_Vgi_bi;
  double gammaPD_Vsbulk_si_Vdi_bi;
  double gammaPD_Vsbulk_si_Vsi_bi;
  double gammaPD_Vsbulk_si_Tempt_GND;
  double gammaPD_Vdbulk_di_Vgm_si;
  double gammaPD_Vdbulk_di_Vdbulk_di;
  double gammaPD_Vdbulk_di_Vsbulk_si;
  double gammaPD_Vdbulk_di_Vgi_bi;
  double gammaPD_Vdbulk_di_Vdi_bi;
  double gammaPD_Vdbulk_di_Vsi_bi;
  double gammaPD_Vdbulk_di_Tempt_GND;
  double gammaPD_Vgm_si_Vgm_si;
  double gammaPD_Vgm_si_Vdbulk_di;
  double gammaPD_Vgm_si_Vsbulk_si;
  double gammaPD_Vgm_si_Vgi_bi;
  double gammaPD_Vgm_si_Vdi_bi;
  double gammaPD_Vgm_si_Vsi_bi;
  double gammaPD_Vgm_si_Tempt_GND;
#endif
#endif
double vgfbPD;
#if defined(_DERIVATEFORDDX)
double vgfbPD_Vgm_si;
double vgfbPD_Vgm_di;
double vgfbPD_Vdbulk_di;
double vgfbPD_Vsbulk_si;
double vgfbPD_Vgi_bi;
double vgfbPD_Vdi_bi;
double vgfbPD_Vsi_bi;
double vgfbPD_Tempt_GND;
#if defined(_DERIVATE2)
  double vgfbPD_Vsi_bi_Vgm_si;
  double vgfbPD_Vsi_bi_Vgm_di;
  double vgfbPD_Vsi_bi_Vdbulk_di;
  double vgfbPD_Vsi_bi_Vsbulk_si;
  double vgfbPD_Vsi_bi_Vgi_bi;
  double vgfbPD_Vsi_bi_Vdi_bi;
  double vgfbPD_Vsi_bi_Vsi_bi;
  double vgfbPD_Vsi_bi_Tempt_GND;
  double vgfbPD_Vdi_bi_Vgm_si;
  double vgfbPD_Vdi_bi_Vgm_di;
  double vgfbPD_Vdi_bi_Vdbulk_di;
  double vgfbPD_Vdi_bi_Vsbulk_si;
  double vgfbPD_Vdi_bi_Vgi_bi;
  double vgfbPD_Vdi_bi_Vdi_bi;
  double vgfbPD_Vdi_bi_Vsi_bi;
  double vgfbPD_Vdi_bi_Tempt_GND;
  double vgfbPD_Vgi_bi_Vgm_si;
  double vgfbPD_Vgi_bi_Vgm_di;
  double vgfbPD_Vgi_bi_Vdbulk_di;
  double vgfbPD_Vgi_bi_Vsbulk_si;
  double vgfbPD_Vgi_bi_Vgi_bi;
  double vgfbPD_Vgi_bi_Vdi_bi;
  double vgfbPD_Vgi_bi_Vsi_bi;
  double vgfbPD_Vgi_bi_Tempt_GND;
  double vgfbPD_Vsbulk_si_Vgm_si;
  double vgfbPD_Vsbulk_si_Vgm_di;
  double vgfbPD_Vsbulk_si_Vdbulk_di;
  double vgfbPD_Vsbulk_si_Vsbulk_si;
  double vgfbPD_Vsbulk_si_Vgi_bi;
  double vgfbPD_Vsbulk_si_Vdi_bi;
  double vgfbPD_Vsbulk_si_Vsi_bi;
  double vgfbPD_Vsbulk_si_Tempt_GND;
  double vgfbPD_Vdbulk_di_Vgm_si;
  double vgfbPD_Vdbulk_di_Vgm_di;
  double vgfbPD_Vdbulk_di_Vdbulk_di;
  double vgfbPD_Vdbulk_di_Vsbulk_si;
  double vgfbPD_Vdbulk_di_Vgi_bi;
  double vgfbPD_Vdbulk_di_Vdi_bi;
  double vgfbPD_Vdbulk_di_Vsi_bi;
  double vgfbPD_Vdbulk_di_Tempt_GND;
  double vgfbPD_Vgm_di_Vgm_si;
  double vgfbPD_Vgm_di_Vgm_di;
  double vgfbPD_Vgm_di_Vdbulk_di;
  double vgfbPD_Vgm_di_Vsbulk_si;
  double vgfbPD_Vgm_di_Vgi_bi;
  double vgfbPD_Vgm_di_Vdi_bi;
  double vgfbPD_Vgm_di_Vsi_bi;
  double vgfbPD_Vgm_di_Tempt_GND;
  double vgfbPD_Vgm_si_Vgm_si;
  double vgfbPD_Vgm_si_Vgm_di;
  double vgfbPD_Vgm_si_Vdbulk_di;
  double vgfbPD_Vgm_si_Vsbulk_si;
  double vgfbPD_Vgm_si_Vgi_bi;
  double vgfbPD_Vgm_si_Vdi_bi;
  double vgfbPD_Vgm_si_Vsi_bi;
  double vgfbPD_Vgm_si_Tempt_GND;
#endif
#endif
double phib_n;
#if defined(_DERIVATEFORDDX)
double phib_n_Vgm_si;
double phib_n_Vdbulk_di;
double phib_n_Vsbulk_si;
double phib_n_Vgi_bi;
double phib_n_Tempt_GND;
double phib_n_Vdi_bi;
double phib_n_Vsi_bi;
#if defined(_DERIVATE2)
  double phib_n_Vsi_bi_Vgm_si;
  double phib_n_Vsi_bi_Vdbulk_di;
  double phib_n_Vsi_bi_Vsbulk_si;
  double phib_n_Vsi_bi_Vgi_bi;
  double phib_n_Vsi_bi_Tempt_GND;
  double phib_n_Vsi_bi_Vdi_bi;
  double phib_n_Vsi_bi_Vsi_bi;
  double phib_n_Vdi_bi_Vgm_si;
  double phib_n_Vdi_bi_Vdbulk_di;
  double phib_n_Vdi_bi_Vsbulk_si;
  double phib_n_Vdi_bi_Vgi_bi;
  double phib_n_Vdi_bi_Tempt_GND;
  double phib_n_Vdi_bi_Vdi_bi;
  double phib_n_Vdi_bi_Vsi_bi;
  double phib_n_Vgi_bi_Vgm_si;
  double phib_n_Vgi_bi_Vdbulk_di;
  double phib_n_Vgi_bi_Vsbulk_si;
  double phib_n_Vgi_bi_Vgi_bi;
  double phib_n_Vgi_bi_Tempt_GND;
  double phib_n_Vgi_bi_Vdi_bi;
  double phib_n_Vgi_bi_Vsi_bi;
  double phib_n_Vsbulk_si_Vgm_si;
  double phib_n_Vsbulk_si_Vdbulk_di;
  double phib_n_Vsbulk_si_Vsbulk_si;
  double phib_n_Vsbulk_si_Vgi_bi;
  double phib_n_Vsbulk_si_Tempt_GND;
  double phib_n_Vsbulk_si_Vdi_bi;
  double phib_n_Vsbulk_si_Vsi_bi;
  double phib_n_Vdbulk_di_Vgm_si;
  double phib_n_Vdbulk_di_Vdbulk_di;
  double phib_n_Vdbulk_di_Vsbulk_si;
  double phib_n_Vdbulk_di_Vgi_bi;
  double phib_n_Vdbulk_di_Tempt_GND;
  double phib_n_Vdbulk_di_Vdi_bi;
  double phib_n_Vdbulk_di_Vsi_bi;
  double phib_n_Vgm_si_Vgm_si;
  double phib_n_Vgm_si_Vdbulk_di;
  double phib_n_Vgm_si_Vsbulk_si;
  double phib_n_Vgm_si_Vgi_bi;
  double phib_n_Vgm_si_Tempt_GND;
  double phib_n_Vgm_si_Vdi_bi;
  double phib_n_Vgm_si_Vsi_bi;
#endif
#endif
double inv_gam;
#if defined(_DERIVATEFORDDX)
double inv_gam_Vgm_si;
double inv_gam_Vdbulk_di;
double inv_gam_Vsbulk_si;
double inv_gam_Vgi_bi;
double inv_gam_Vdi_bi;
double inv_gam_Vsi_bi;
double inv_gam_Tempt_GND;
#if defined(_DERIVATE2)
  double inv_gam_Vsi_bi_Vgm_si;
  double inv_gam_Vsi_bi_Vdbulk_di;
  double inv_gam_Vsi_bi_Vsbulk_si;
  double inv_gam_Vsi_bi_Vgi_bi;
  double inv_gam_Vsi_bi_Vdi_bi;
  double inv_gam_Vsi_bi_Vsi_bi;
  double inv_gam_Vsi_bi_Tempt_GND;
  double inv_gam_Vdi_bi_Vgm_si;
  double inv_gam_Vdi_bi_Vdbulk_di;
  double inv_gam_Vdi_bi_Vsbulk_si;
  double inv_gam_Vdi_bi_Vgi_bi;
  double inv_gam_Vdi_bi_Vdi_bi;
  double inv_gam_Vdi_bi_Vsi_bi;
  double inv_gam_Vdi_bi_Tempt_GND;
  double inv_gam_Vgi_bi_Vgm_si;
  double inv_gam_Vgi_bi_Vdbulk_di;
  double inv_gam_Vgi_bi_Vsbulk_si;
  double inv_gam_Vgi_bi_Vgi_bi;
  double inv_gam_Vgi_bi_Vdi_bi;
  double inv_gam_Vgi_bi_Vsi_bi;
  double inv_gam_Vgi_bi_Tempt_GND;
  double inv_gam_Vsbulk_si_Vgm_si;
  double inv_gam_Vsbulk_si_Vdbulk_di;
  double inv_gam_Vsbulk_si_Vsbulk_si;
  double inv_gam_Vsbulk_si_Vgi_bi;
  double inv_gam_Vsbulk_si_Vdi_bi;
  double inv_gam_Vsbulk_si_Vsi_bi;
  double inv_gam_Vsbulk_si_Tempt_GND;
  double inv_gam_Vdbulk_di_Vgm_si;
  double inv_gam_Vdbulk_di_Vdbulk_di;
  double inv_gam_Vdbulk_di_Vsbulk_si;
  double inv_gam_Vdbulk_di_Vgi_bi;
  double inv_gam_Vdbulk_di_Vdi_bi;
  double inv_gam_Vdbulk_di_Vsi_bi;
  double inv_gam_Vdbulk_di_Tempt_GND;
  double inv_gam_Vgm_si_Vgm_si;
  double inv_gam_Vgm_si_Vdbulk_di;
  double inv_gam_Vgm_si_Vsbulk_si;
  double inv_gam_Vgm_si_Vgi_bi;
  double inv_gam_Vgm_si_Vdi_bi;
  double inv_gam_Vgm_si_Vsi_bi;
  double inv_gam_Vgm_si_Tempt_GND;
#endif
#endif
#if defined(_DERIVATE)
double VTH_Vdi_bi;
double VTH_Vsi_bi;
double VTH_Tempt_GND;
#endif
double psip_th;
#if defined(_DERIVATE)
double psip_th_Vdi_bi;
double psip_th_Vsi_bi;
double psip_th_Tempt_GND;
#endif
double nq;
#if defined(_DERIVATEFORDDX)
double nq_Vgm_si;
double nq_Vgm_di;
double nq_Vdbulk_di;
double nq_Vsbulk_si;
double nq_Vgi_bi;
double nq_Tempt_GND;
double nq_Vdi_bi;
double nq_Vsi_bi;
#if defined(_DERIVATE2)
  double nq_Vsi_bi_Vgm_si;
  double nq_Vsi_bi_Vgm_di;
  double nq_Vsi_bi_Vdbulk_di;
  double nq_Vsi_bi_Vsbulk_si;
  double nq_Vsi_bi_Vgi_bi;
  double nq_Vsi_bi_Tempt_GND;
  double nq_Vsi_bi_Vdi_bi;
  double nq_Vsi_bi_Vsi_bi;
  double nq_Vdi_bi_Vgm_si;
  double nq_Vdi_bi_Vgm_di;
  double nq_Vdi_bi_Vdbulk_di;
  double nq_Vdi_bi_Vsbulk_si;
  double nq_Vdi_bi_Vgi_bi;
  double nq_Vdi_bi_Tempt_GND;
  double nq_Vdi_bi_Vdi_bi;
  double nq_Vdi_bi_Vsi_bi;
  double nq_Vgi_bi_Vgm_si;
  double nq_Vgi_bi_Vgm_di;
  double nq_Vgi_bi_Vdbulk_di;
  double nq_Vgi_bi_Vsbulk_si;
  double nq_Vgi_bi_Vgi_bi;
  double nq_Vgi_bi_Tempt_GND;
  double nq_Vgi_bi_Vdi_bi;
  double nq_Vgi_bi_Vsi_bi;
  double nq_Vsbulk_si_Vgm_si;
  double nq_Vsbulk_si_Vgm_di;
  double nq_Vsbulk_si_Vdbulk_di;
  double nq_Vsbulk_si_Vsbulk_si;
  double nq_Vsbulk_si_Vgi_bi;
  double nq_Vsbulk_si_Tempt_GND;
  double nq_Vsbulk_si_Vdi_bi;
  double nq_Vsbulk_si_Vsi_bi;
  double nq_Vdbulk_di_Vgm_si;
  double nq_Vdbulk_di_Vgm_di;
  double nq_Vdbulk_di_Vdbulk_di;
  double nq_Vdbulk_di_Vsbulk_si;
  double nq_Vdbulk_di_Vgi_bi;
  double nq_Vdbulk_di_Tempt_GND;
  double nq_Vdbulk_di_Vdi_bi;
  double nq_Vdbulk_di_Vsi_bi;
  double nq_Vgm_di_Vgm_si;
  double nq_Vgm_di_Vgm_di;
  double nq_Vgm_di_Vdbulk_di;
  double nq_Vgm_di_Vsbulk_si;
  double nq_Vgm_di_Vgi_bi;
  double nq_Vgm_di_Tempt_GND;
  double nq_Vgm_di_Vdi_bi;
  double nq_Vgm_di_Vsi_bi;
  double nq_Vgm_si_Vgm_si;
  double nq_Vgm_si_Vgm_di;
  double nq_Vgm_si_Vdbulk_di;
  double nq_Vgm_si_Vsbulk_si;
  double nq_Vgm_si_Vgi_bi;
  double nq_Vgm_si_Tempt_GND;
  double nq_Vgm_si_Vdi_bi;
  double nq_Vgm_si_Vsi_bi;
#endif
#endif
double q_vth;
double gam;
#if defined(_DERIVATEFORDDX)
double gam_Vgm_si;
double gam_Vdbulk_di;
double gam_Vsbulk_si;
double gam_Vgi_bi;
double gam_Vdi_bi;
double gam_Vsi_bi;
double gam_Tempt_GND;
#if defined(_DERIVATE2)
  double gam_Vsi_bi_Vgm_si;
  double gam_Vsi_bi_Vdbulk_di;
  double gam_Vsi_bi_Vsbulk_si;
  double gam_Vsi_bi_Vgi_bi;
  double gam_Vsi_bi_Vdi_bi;
  double gam_Vsi_bi_Vsi_bi;
  double gam_Vsi_bi_Tempt_GND;
  double gam_Vdi_bi_Vgm_si;
  double gam_Vdi_bi_Vdbulk_di;
  double gam_Vdi_bi_Vsbulk_si;
  double gam_Vdi_bi_Vgi_bi;
  double gam_Vdi_bi_Vdi_bi;
  double gam_Vdi_bi_Vsi_bi;
  double gam_Vdi_bi_Tempt_GND;
  double gam_Vgi_bi_Vgm_si;
  double gam_Vgi_bi_Vdbulk_di;
  double gam_Vgi_bi_Vsbulk_si;
  double gam_Vgi_bi_Vgi_bi;
  double gam_Vgi_bi_Vdi_bi;
  double gam_Vgi_bi_Vsi_bi;
  double gam_Vgi_bi_Tempt_GND;
  double gam_Vsbulk_si_Vgm_si;
  double gam_Vsbulk_si_Vdbulk_di;
  double gam_Vsbulk_si_Vsbulk_si;
  double gam_Vsbulk_si_Vgi_bi;
  double gam_Vsbulk_si_Vdi_bi;
  double gam_Vsbulk_si_Vsi_bi;
  double gam_Vsbulk_si_Tempt_GND;
  double gam_Vdbulk_di_Vgm_si;
  double gam_Vdbulk_di_Vdbulk_di;
  double gam_Vdbulk_di_Vsbulk_si;
  double gam_Vdbulk_di_Vgi_bi;
  double gam_Vdbulk_di_Vdi_bi;
  double gam_Vdbulk_di_Vsi_bi;
  double gam_Vdbulk_di_Tempt_GND;
  double gam_Vgm_si_Vgm_si;
  double gam_Vgm_si_Vdbulk_di;
  double gam_Vgm_si_Vsbulk_si;
  double gam_Vgm_si_Vgi_bi;
  double gam_Vgm_si_Vdi_bi;
  double gam_Vgm_si_Vsi_bi;
  double gam_Vgm_si_Tempt_GND;
#endif
#endif
double vgfb;
#if defined(_DERIVATEFORDDX)
double vgfb_Vgm_si;
double vgfb_Vdbulk_di;
double vgfb_Vsbulk_si;
double vgfb_Vgm_di;
double vgfb_Vgi_bi;
double vgfb_Vdi_bi;
double vgfb_Vsi_bi;
double vgfb_Tempt_GND;
#if defined(_DERIVATE2)
  double vgfb_Vsi_bi_Vgm_si;
  double vgfb_Vsi_bi_Vdbulk_di;
  double vgfb_Vsi_bi_Vsbulk_si;
  double vgfb_Vsi_bi_Vgm_di;
  double vgfb_Vsi_bi_Vgi_bi;
  double vgfb_Vsi_bi_Vdi_bi;
  double vgfb_Vsi_bi_Vsi_bi;
  double vgfb_Vsi_bi_Tempt_GND;
  double vgfb_Vdi_bi_Vgm_si;
  double vgfb_Vdi_bi_Vdbulk_di;
  double vgfb_Vdi_bi_Vsbulk_si;
  double vgfb_Vdi_bi_Vgm_di;
  double vgfb_Vdi_bi_Vgi_bi;
  double vgfb_Vdi_bi_Vdi_bi;
  double vgfb_Vdi_bi_Vsi_bi;
  double vgfb_Vdi_bi_Tempt_GND;
  double vgfb_Vgi_bi_Vgm_si;
  double vgfb_Vgi_bi_Vdbulk_di;
  double vgfb_Vgi_bi_Vsbulk_si;
  double vgfb_Vgi_bi_Vgm_di;
  double vgfb_Vgi_bi_Vgi_bi;
  double vgfb_Vgi_bi_Vdi_bi;
  double vgfb_Vgi_bi_Vsi_bi;
  double vgfb_Vgi_bi_Tempt_GND;
  double vgfb_Vgm_di_Vgm_si;
  double vgfb_Vgm_di_Vdbulk_di;
  double vgfb_Vgm_di_Vsbulk_si;
  double vgfb_Vgm_di_Vgm_di;
  double vgfb_Vgm_di_Vgi_bi;
  double vgfb_Vgm_di_Vdi_bi;
  double vgfb_Vgm_di_Vsi_bi;
  double vgfb_Vgm_di_Tempt_GND;
  double vgfb_Vsbulk_si_Vgm_si;
  double vgfb_Vsbulk_si_Vdbulk_di;
  double vgfb_Vsbulk_si_Vsbulk_si;
  double vgfb_Vsbulk_si_Vgm_di;
  double vgfb_Vsbulk_si_Vgi_bi;
  double vgfb_Vsbulk_si_Vdi_bi;
  double vgfb_Vsbulk_si_Vsi_bi;
  double vgfb_Vsbulk_si_Tempt_GND;
  double vgfb_Vdbulk_di_Vgm_si;
  double vgfb_Vdbulk_di_Vdbulk_di;
  double vgfb_Vdbulk_di_Vsbulk_si;
  double vgfb_Vdbulk_di_Vgm_di;
  double vgfb_Vdbulk_di_Vgi_bi;
  double vgfb_Vdbulk_di_Vdi_bi;
  double vgfb_Vdbulk_di_Vsi_bi;
  double vgfb_Vdbulk_di_Tempt_GND;
  double vgfb_Vgm_si_Vgm_si;
  double vgfb_Vgm_si_Vdbulk_di;
  double vgfb_Vgm_si_Vsbulk_si;
  double vgfb_Vgm_si_Vgm_di;
  double vgfb_Vgm_si_Vgi_bi;
  double vgfb_Vgm_si_Vdi_bi;
  double vgfb_Vgm_si_Vsi_bi;
  double vgfb_Vgm_si_Tempt_GND;
#endif
#endif
double Vth_shift;
#if defined(_DERIVATEFORDDX)
double Vth_shift_Vgm_di;
double Vth_shift_Vgm_si;
double Vth_shift_Vdbulk_di;
double Vth_shift_Vsbulk_si;
double Vth_shift_Vgi_bi;
double Vth_shift_Tempt_GND;
double Vth_shift_Vdi_bi;
double Vth_shift_Vsi_bi;
#if defined(_DERIVATE2)
  double Vth_shift_Vsi_bi_Vgm_di;
  double Vth_shift_Vsi_bi_Vgm_si;
  double Vth_shift_Vsi_bi_Vdbulk_di;
  double Vth_shift_Vsi_bi_Vsbulk_si;
  double Vth_shift_Vsi_bi_Vgi_bi;
  double Vth_shift_Vsi_bi_Tempt_GND;
  double Vth_shift_Vsi_bi_Vdi_bi;
  double Vth_shift_Vsi_bi_Vsi_bi;
  double Vth_shift_Vdi_bi_Vgm_di;
  double Vth_shift_Vdi_bi_Vgm_si;
  double Vth_shift_Vdi_bi_Vdbulk_di;
  double Vth_shift_Vdi_bi_Vsbulk_si;
  double Vth_shift_Vdi_bi_Vgi_bi;
  double Vth_shift_Vdi_bi_Tempt_GND;
  double Vth_shift_Vdi_bi_Vdi_bi;
  double Vth_shift_Vdi_bi_Vsi_bi;
  double Vth_shift_Vgi_bi_Vgm_di;
  double Vth_shift_Vgi_bi_Vgm_si;
  double Vth_shift_Vgi_bi_Vdbulk_di;
  double Vth_shift_Vgi_bi_Vsbulk_si;
  double Vth_shift_Vgi_bi_Vgi_bi;
  double Vth_shift_Vgi_bi_Tempt_GND;
  double Vth_shift_Vgi_bi_Vdi_bi;
  double Vth_shift_Vgi_bi_Vsi_bi;
  double Vth_shift_Vsbulk_si_Vgm_di;
  double Vth_shift_Vsbulk_si_Vgm_si;
  double Vth_shift_Vsbulk_si_Vdbulk_di;
  double Vth_shift_Vsbulk_si_Vsbulk_si;
  double Vth_shift_Vsbulk_si_Vgi_bi;
  double Vth_shift_Vsbulk_si_Tempt_GND;
  double Vth_shift_Vsbulk_si_Vdi_bi;
  double Vth_shift_Vsbulk_si_Vsi_bi;
  double Vth_shift_Vdbulk_di_Vgm_di;
  double Vth_shift_Vdbulk_di_Vgm_si;
  double Vth_shift_Vdbulk_di_Vdbulk_di;
  double Vth_shift_Vdbulk_di_Vsbulk_si;
  double Vth_shift_Vdbulk_di_Vgi_bi;
  double Vth_shift_Vdbulk_di_Tempt_GND;
  double Vth_shift_Vdbulk_di_Vdi_bi;
  double Vth_shift_Vdbulk_di_Vsi_bi;
  double Vth_shift_Vgm_si_Vgm_di;
  double Vth_shift_Vgm_si_Vgm_si;
  double Vth_shift_Vgm_si_Vdbulk_di;
  double Vth_shift_Vgm_si_Vsbulk_si;
  double Vth_shift_Vgm_si_Vgi_bi;
  double Vth_shift_Vgm_si_Tempt_GND;
  double Vth_shift_Vgm_si_Vdi_bi;
  double Vth_shift_Vgm_si_Vsi_bi;
  double Vth_shift_Vgm_di_Vgm_di;
  double Vth_shift_Vgm_di_Vgm_si;
  double Vth_shift_Vgm_di_Vdbulk_di;
  double Vth_shift_Vgm_di_Vsbulk_si;
  double Vth_shift_Vgm_di_Vgi_bi;
  double Vth_shift_Vgm_di_Tempt_GND;
  double Vth_shift_Vgm_di_Vdi_bi;
  double Vth_shift_Vgm_di_Vsi_bi;
#endif
#endif
double dVth_VNUD;
#if defined(_DERIVATEFORDDX)
double dVth_VNUD_Tempt_GND;
double dVth_VNUD_Vdi_bi;
double dVth_VNUD_Vsi_bi;
#if defined(_DERIVATE2)
  double dVth_VNUD_Vsi_bi_Tempt_GND;
  double dVth_VNUD_Vsi_bi_Vdi_bi;
  double dVth_VNUD_Vsi_bi_Vsi_bi;
  double dVth_VNUD_Vdi_bi_Tempt_GND;
  double dVth_VNUD_Vdi_bi_Vdi_bi;
  double dVth_VNUD_Vdi_bi_Vsi_bi;
#endif
#endif
double vfb;
#if defined(_DERIVATEFORDDX)
double vfb_Vgm_si;
double vfb_Vdbulk_di;
double vfb_Vsbulk_si;
double vfb_Vgi_bi;
double vfb_Vdi_bi;
double vfb_Vsi_bi;
double vfb_Tempt_GND;
#if defined(_DERIVATE2)
  double vfb_Vsi_bi_Vgm_si;
  double vfb_Vsi_bi_Vdbulk_di;
  double vfb_Vsi_bi_Vsbulk_si;
  double vfb_Vsi_bi_Vgi_bi;
  double vfb_Vsi_bi_Vdi_bi;
  double vfb_Vsi_bi_Vsi_bi;
  double vfb_Vsi_bi_Tempt_GND;
  double vfb_Vdi_bi_Vgm_si;
  double vfb_Vdi_bi_Vdbulk_di;
  double vfb_Vdi_bi_Vsbulk_si;
  double vfb_Vdi_bi_Vgi_bi;
  double vfb_Vdi_bi_Vdi_bi;
  double vfb_Vdi_bi_Vsi_bi;
  double vfb_Vdi_bi_Tempt_GND;
  double vfb_Vgi_bi_Vgm_si;
  double vfb_Vgi_bi_Vdbulk_di;
  double vfb_Vgi_bi_Vsbulk_si;
  double vfb_Vgi_bi_Vgi_bi;
  double vfb_Vgi_bi_Vdi_bi;
  double vfb_Vgi_bi_Vsi_bi;
  double vfb_Vgi_bi_Tempt_GND;
  double vfb_Vsbulk_si_Vgm_si;
  double vfb_Vsbulk_si_Vdbulk_di;
  double vfb_Vsbulk_si_Vsbulk_si;
  double vfb_Vsbulk_si_Vgi_bi;
  double vfb_Vsbulk_si_Vdi_bi;
  double vfb_Vsbulk_si_Vsi_bi;
  double vfb_Vsbulk_si_Tempt_GND;
  double vfb_Vdbulk_di_Vgm_si;
  double vfb_Vdbulk_di_Vdbulk_di;
  double vfb_Vdbulk_di_Vsbulk_si;
  double vfb_Vdbulk_di_Vgi_bi;
  double vfb_Vdbulk_di_Vdi_bi;
  double vfb_Vdbulk_di_Vsi_bi;
  double vfb_Vdbulk_di_Tempt_GND;
  double vfb_Vgm_si_Vgm_si;
  double vfb_Vgm_si_Vdbulk_di;
  double vfb_Vgm_si_Vsbulk_si;
  double vfb_Vgm_si_Vgi_bi;
  double vfb_Vgm_si_Vdi_bi;
  double vfb_Vgm_si_Vsi_bi;
  double vfb_Vgm_si_Tempt_GND;
#endif
#endif
double vs;
#if defined(_DERIVATEFORDDX)
double vs_Vgm_si;
double vs_Vdbulk_di;
double vs_Vsbulk_si;
double vs_Vgi_bi;
double vs_Vdi_bi;
double vs_Vsi_bi;
double vs_Tempt_GND;
#if defined(_DERIVATE2)
  double vs_Vsi_bi_Vgm_si;
  double vs_Vsi_bi_Vdbulk_di;
  double vs_Vsi_bi_Vsbulk_si;
  double vs_Vsi_bi_Vgi_bi;
  double vs_Vsi_bi_Vdi_bi;
  double vs_Vsi_bi_Vsi_bi;
  double vs_Vsi_bi_Tempt_GND;
  double vs_Vdi_bi_Vgm_si;
  double vs_Vdi_bi_Vdbulk_di;
  double vs_Vdi_bi_Vsbulk_si;
  double vs_Vdi_bi_Vgi_bi;
  double vs_Vdi_bi_Vdi_bi;
  double vs_Vdi_bi_Vsi_bi;
  double vs_Vdi_bi_Tempt_GND;
  double vs_Vgi_bi_Vgm_si;
  double vs_Vgi_bi_Vdbulk_di;
  double vs_Vgi_bi_Vsbulk_si;
  double vs_Vgi_bi_Vgi_bi;
  double vs_Vgi_bi_Vdi_bi;
  double vs_Vgi_bi_Vsi_bi;
  double vs_Vgi_bi_Tempt_GND;
  double vs_Vsbulk_si_Vgm_si;
  double vs_Vsbulk_si_Vdbulk_di;
  double vs_Vsbulk_si_Vsbulk_si;
  double vs_Vsbulk_si_Vgi_bi;
  double vs_Vsbulk_si_Vdi_bi;
  double vs_Vsbulk_si_Vsi_bi;
  double vs_Vsbulk_si_Tempt_GND;
  double vs_Vdbulk_di_Vgm_si;
  double vs_Vdbulk_di_Vdbulk_di;
  double vs_Vdbulk_di_Vsbulk_si;
  double vs_Vdbulk_di_Vgi_bi;
  double vs_Vdbulk_di_Vdi_bi;
  double vs_Vdbulk_di_Vsi_bi;
  double vs_Vdbulk_di_Tempt_GND;
  double vs_Vgm_si_Vgm_si;
  double vs_Vgm_si_Vdbulk_di;
  double vs_Vgm_si_Vsbulk_si;
  double vs_Vgm_si_Vgi_bi;
  double vs_Vgm_si_Vdi_bi;
  double vs_Vgm_si_Vsi_bi;
  double vs_Vgm_si_Tempt_GND;
#endif
#endif
double vg;
#if defined(_DERIVATEFORDDX)
double vg_Vgm_si;
double vg_Vdbulk_di;
double vg_Vsbulk_si;
double vg_Vgi_bi;
double vg_Vdi_bi;
double vg_Vsi_bi;
double vg_Tempt_GND;
#if defined(_DERIVATE2)
  double vg_Vsi_bi_Vgm_si;
  double vg_Vsi_bi_Vdbulk_di;
  double vg_Vsi_bi_Vsbulk_si;
  double vg_Vsi_bi_Vgi_bi;
  double vg_Vsi_bi_Vdi_bi;
  double vg_Vsi_bi_Vsi_bi;
  double vg_Vsi_bi_Tempt_GND;
  double vg_Vdi_bi_Vgm_si;
  double vg_Vdi_bi_Vdbulk_di;
  double vg_Vdi_bi_Vsbulk_si;
  double vg_Vdi_bi_Vgi_bi;
  double vg_Vdi_bi_Vdi_bi;
  double vg_Vdi_bi_Vsi_bi;
  double vg_Vdi_bi_Tempt_GND;
  double vg_Vgi_bi_Vgm_si;
  double vg_Vgi_bi_Vdbulk_di;
  double vg_Vgi_bi_Vsbulk_si;
  double vg_Vgi_bi_Vgi_bi;
  double vg_Vgi_bi_Vdi_bi;
  double vg_Vgi_bi_Vsi_bi;
  double vg_Vgi_bi_Tempt_GND;
  double vg_Vsbulk_si_Vgm_si;
  double vg_Vsbulk_si_Vdbulk_di;
  double vg_Vsbulk_si_Vsbulk_si;
  double vg_Vsbulk_si_Vgi_bi;
  double vg_Vsbulk_si_Vdi_bi;
  double vg_Vsbulk_si_Vsi_bi;
  double vg_Vsbulk_si_Tempt_GND;
  double vg_Vdbulk_di_Vgm_si;
  double vg_Vdbulk_di_Vdbulk_di;
  double vg_Vdbulk_di_Vsbulk_si;
  double vg_Vdbulk_di_Vgi_bi;
  double vg_Vdbulk_di_Vdi_bi;
  double vg_Vdbulk_di_Vsi_bi;
  double vg_Vdbulk_di_Tempt_GND;
  double vg_Vgm_si_Vgm_si;
  double vg_Vgm_si_Vdbulk_di;
  double vg_Vgm_si_Vsbulk_si;
  double vg_Vgm_si_Vgi_bi;
  double vg_Vgm_si_Vdi_bi;
  double vg_Vgm_si_Vsi_bi;
  double vg_Vgm_si_Tempt_GND;
#endif
#endif
double T4;
#if defined(_DERIVATEFORDDX)
double T4_Vgm_si;
double T4_Vgm_di;
double T4_Vdbulk_di;
double T4_Vsbulk_si;
double T4_Vgi_bi;
double T4_Vdi_bi;
double T4_Vsi_bi;
double T4_Tempt_GND;
#if defined(_DERIVATE2)
  double T4_Vsi_bi_Vgm_si;
  double T4_Vsi_bi_Vgm_di;
  double T4_Vsi_bi_Vdbulk_di;
  double T4_Vsi_bi_Vsbulk_si;
  double T4_Vsi_bi_Vgi_bi;
  double T4_Vsi_bi_Vdi_bi;
  double T4_Vsi_bi_Vsi_bi;
  double T4_Vsi_bi_Tempt_GND;
  double T4_Vdi_bi_Vgm_si;
  double T4_Vdi_bi_Vgm_di;
  double T4_Vdi_bi_Vdbulk_di;
  double T4_Vdi_bi_Vsbulk_si;
  double T4_Vdi_bi_Vgi_bi;
  double T4_Vdi_bi_Vdi_bi;
  double T4_Vdi_bi_Vsi_bi;
  double T4_Vdi_bi_Tempt_GND;
  double T4_Vgi_bi_Vgm_si;
  double T4_Vgi_bi_Vgm_di;
  double T4_Vgi_bi_Vdbulk_di;
  double T4_Vgi_bi_Vsbulk_si;
  double T4_Vgi_bi_Vgi_bi;
  double T4_Vgi_bi_Vdi_bi;
  double T4_Vgi_bi_Vsi_bi;
  double T4_Vgi_bi_Tempt_GND;
  double T4_Vsbulk_si_Vgm_si;
  double T4_Vsbulk_si_Vgm_di;
  double T4_Vsbulk_si_Vdbulk_di;
  double T4_Vsbulk_si_Vsbulk_si;
  double T4_Vsbulk_si_Vgi_bi;
  double T4_Vsbulk_si_Vdi_bi;
  double T4_Vsbulk_si_Vsi_bi;
  double T4_Vsbulk_si_Tempt_GND;
  double T4_Vdbulk_di_Vgm_si;
  double T4_Vdbulk_di_Vgm_di;
  double T4_Vdbulk_di_Vdbulk_di;
  double T4_Vdbulk_di_Vsbulk_si;
  double T4_Vdbulk_di_Vgi_bi;
  double T4_Vdbulk_di_Vdi_bi;
  double T4_Vdbulk_di_Vsi_bi;
  double T4_Vdbulk_di_Tempt_GND;
  double T4_Vgm_di_Vgm_si;
  double T4_Vgm_di_Vgm_di;
  double T4_Vgm_di_Vdbulk_di;
  double T4_Vgm_di_Vsbulk_si;
  double T4_Vgm_di_Vgi_bi;
  double T4_Vgm_di_Vdi_bi;
  double T4_Vgm_di_Vsi_bi;
  double T4_Vgm_di_Tempt_GND;
  double T4_Vgm_si_Vgm_si;
  double T4_Vgm_si_Vgm_di;
  double T4_Vgm_si_Vdbulk_di;
  double T4_Vgm_si_Vsbulk_si;
  double T4_Vgm_si_Vgi_bi;
  double T4_Vgm_si_Vdi_bi;
  double T4_Vgm_si_Vsi_bi;
  double T4_Vgm_si_Tempt_GND;
#endif
#endif
double dVth_ldop;
#if defined(_DERIVATEFORDDX)
double dVth_ldop_Vdi_bi;
double dVth_ldop_Vsi_bi;
double dVth_ldop_Tempt_GND;
#if defined(_DERIVATE2)
  double dVth_ldop_Vsi_bi_Vdi_bi;
  double dVth_ldop_Vsi_bi_Vsi_bi;
  double dVth_ldop_Vsi_bi_Tempt_GND;
  double dVth_ldop_Vdi_bi_Vdi_bi;
  double dVth_ldop_Vdi_bi_Vsi_bi;
  double dVth_ldop_Vdi_bi_Tempt_GND;
#endif
#endif
double dvth_temp;
#if defined(_DERIVATEFORDDX)
double dvth_temp_Vdi_bi;
double dvth_temp_Vsi_bi;
double dvth_temp_Tempt_GND;
#if defined(_DERIVATE2)
  double dvth_temp_Vsi_bi_Vdi_bi;
  double dvth_temp_Vsi_bi_Vsi_bi;
  double dvth_temp_Vsi_bi_Tempt_GND;
  double dvth_temp_Vdi_bi_Vdi_bi;
  double dvth_temp_Vdi_bi_Vsi_bi;
  double dvth_temp_Vdi_bi_Tempt_GND;
#endif
#endif
double dVth_dibl;
#if defined(_DERIVATEFORDDX)
double dVth_dibl_Tempt_GND;
double dVth_dibl_Vdi_bi;
double dVth_dibl_Vsi_bi;
#if defined(_DERIVATE2)
  double dVth_dibl_Vsi_bi_Tempt_GND;
  double dVth_dibl_Vsi_bi_Vdi_bi;
  double dVth_dibl_Vsi_bi_Vsi_bi;
  double dVth_dibl_Vdi_bi_Tempt_GND;
  double dVth_dibl_Vdi_bi_Vdi_bi;
  double dVth_dibl_Vdi_bi_Vsi_bi;
#endif
#endif
double inv_nVt;
#if defined(_DERIVATEFORDDX)
double inv_nVt_Vgm_si;
double inv_nVt_Vdbulk_di;
double inv_nVt_Vsbulk_si;
double inv_nVt_Vgi_bi;
double inv_nVt_Vdi_bi;
double inv_nVt_Vsi_bi;
double inv_nVt_Tempt_GND;
#if defined(_DERIVATE2)
  double inv_nVt_Vsi_bi_Vgm_si;
  double inv_nVt_Vsi_bi_Vdbulk_di;
  double inv_nVt_Vsi_bi_Vsbulk_si;
  double inv_nVt_Vsi_bi_Vgi_bi;
  double inv_nVt_Vsi_bi_Vdi_bi;
  double inv_nVt_Vsi_bi_Vsi_bi;
  double inv_nVt_Vsi_bi_Tempt_GND;
  double inv_nVt_Vdi_bi_Vgm_si;
  double inv_nVt_Vdi_bi_Vdbulk_di;
  double inv_nVt_Vdi_bi_Vsbulk_si;
  double inv_nVt_Vdi_bi_Vgi_bi;
  double inv_nVt_Vdi_bi_Vdi_bi;
  double inv_nVt_Vdi_bi_Vsi_bi;
  double inv_nVt_Vdi_bi_Tempt_GND;
  double inv_nVt_Vgi_bi_Vgm_si;
  double inv_nVt_Vgi_bi_Vdbulk_di;
  double inv_nVt_Vgi_bi_Vsbulk_si;
  double inv_nVt_Vgi_bi_Vgi_bi;
  double inv_nVt_Vgi_bi_Vdi_bi;
  double inv_nVt_Vgi_bi_Vsi_bi;
  double inv_nVt_Vgi_bi_Tempt_GND;
  double inv_nVt_Vsbulk_si_Vgm_si;
  double inv_nVt_Vsbulk_si_Vdbulk_di;
  double inv_nVt_Vsbulk_si_Vsbulk_si;
  double inv_nVt_Vsbulk_si_Vgi_bi;
  double inv_nVt_Vsbulk_si_Vdi_bi;
  double inv_nVt_Vsbulk_si_Vsi_bi;
  double inv_nVt_Vsbulk_si_Tempt_GND;
  double inv_nVt_Vdbulk_di_Vgm_si;
  double inv_nVt_Vdbulk_di_Vdbulk_di;
  double inv_nVt_Vdbulk_di_Vsbulk_si;
  double inv_nVt_Vdbulk_di_Vgi_bi;
  double inv_nVt_Vdbulk_di_Vdi_bi;
  double inv_nVt_Vdbulk_di_Vsi_bi;
  double inv_nVt_Vdbulk_di_Tempt_GND;
  double inv_nVt_Vgm_si_Vgm_si;
  double inv_nVt_Vgm_si_Vdbulk_di;
  double inv_nVt_Vgm_si_Vsbulk_si;
  double inv_nVt_Vgm_si_Vgi_bi;
  double inv_nVt_Vgm_si_Vdi_bi;
  double inv_nVt_Vgm_si_Vsi_bi;
  double inv_nVt_Vgm_si_Tempt_GND;
#endif
#endif
double nVt;
#if defined(_DERIVATEFORDDX)
double nVt_Vgm_si;
double nVt_Vdbulk_di;
double nVt_Vsbulk_si;
double nVt_Vgi_bi;
double nVt_Vdi_bi;
double nVt_Vsi_bi;
double nVt_Tempt_GND;
#if defined(_DERIVATE2)
  double nVt_Vsi_bi_Vgm_si;
  double nVt_Vsi_bi_Vdbulk_di;
  double nVt_Vsi_bi_Vsbulk_si;
  double nVt_Vsi_bi_Vgi_bi;
  double nVt_Vsi_bi_Vdi_bi;
  double nVt_Vsi_bi_Vsi_bi;
  double nVt_Vsi_bi_Tempt_GND;
  double nVt_Vdi_bi_Vgm_si;
  double nVt_Vdi_bi_Vdbulk_di;
  double nVt_Vdi_bi_Vsbulk_si;
  double nVt_Vdi_bi_Vgi_bi;
  double nVt_Vdi_bi_Vdi_bi;
  double nVt_Vdi_bi_Vsi_bi;
  double nVt_Vdi_bi_Tempt_GND;
  double nVt_Vgi_bi_Vgm_si;
  double nVt_Vgi_bi_Vdbulk_di;
  double nVt_Vgi_bi_Vsbulk_si;
  double nVt_Vgi_bi_Vgi_bi;
  double nVt_Vgi_bi_Vdi_bi;
  double nVt_Vgi_bi_Vsi_bi;
  double nVt_Vgi_bi_Tempt_GND;
  double nVt_Vsbulk_si_Vgm_si;
  double nVt_Vsbulk_si_Vdbulk_di;
  double nVt_Vsbulk_si_Vsbulk_si;
  double nVt_Vsbulk_si_Vgi_bi;
  double nVt_Vsbulk_si_Vdi_bi;
  double nVt_Vsbulk_si_Vsi_bi;
  double nVt_Vsbulk_si_Tempt_GND;
  double nVt_Vdbulk_di_Vgm_si;
  double nVt_Vdbulk_di_Vdbulk_di;
  double nVt_Vdbulk_di_Vsbulk_si;
  double nVt_Vdbulk_di_Vgi_bi;
  double nVt_Vdbulk_di_Vdi_bi;
  double nVt_Vdbulk_di_Vsi_bi;
  double nVt_Vdbulk_di_Tempt_GND;
  double nVt_Vgm_si_Vgm_si;
  double nVt_Vgm_si_Vdbulk_di;
  double nVt_Vgm_si_Vsbulk_si;
  double nVt_Vgm_si_Vgi_bi;
  double nVt_Vgm_si_Vdi_bi;
  double nVt_Vgm_si_Vsi_bi;
  double nVt_Vgm_si_Tempt_GND;
#endif
#endif
double n;
#if defined(_DERIVATEFORDDX)
double n_Vgm_si;
double n_Vdbulk_di;
double n_Vsbulk_si;
double n_Vgi_bi;
double n_Vdi_bi;
double n_Vsi_bi;
double n_Tempt_GND;
#if defined(_DERIVATE2)
  double n_Vsi_bi_Vgm_si;
  double n_Vsi_bi_Vdbulk_di;
  double n_Vsi_bi_Vsbulk_si;
  double n_Vsi_bi_Vgi_bi;
  double n_Vsi_bi_Vdi_bi;
  double n_Vsi_bi_Vsi_bi;
  double n_Vsi_bi_Tempt_GND;
  double n_Vdi_bi_Vgm_si;
  double n_Vdi_bi_Vdbulk_di;
  double n_Vdi_bi_Vsbulk_si;
  double n_Vdi_bi_Vgi_bi;
  double n_Vdi_bi_Vdi_bi;
  double n_Vdi_bi_Vsi_bi;
  double n_Vdi_bi_Tempt_GND;
  double n_Vgi_bi_Vgm_si;
  double n_Vgi_bi_Vdbulk_di;
  double n_Vgi_bi_Vsbulk_si;
  double n_Vgi_bi_Vgi_bi;
  double n_Vgi_bi_Vdi_bi;
  double n_Vgi_bi_Vsi_bi;
  double n_Vgi_bi_Tempt_GND;
  double n_Vsbulk_si_Vgm_si;
  double n_Vsbulk_si_Vdbulk_di;
  double n_Vsbulk_si_Vsbulk_si;
  double n_Vsbulk_si_Vgi_bi;
  double n_Vsbulk_si_Vdi_bi;
  double n_Vsbulk_si_Vsi_bi;
  double n_Vsbulk_si_Tempt_GND;
  double n_Vdbulk_di_Vgm_si;
  double n_Vdbulk_di_Vdbulk_di;
  double n_Vdbulk_di_Vsbulk_si;
  double n_Vdbulk_di_Vgi_bi;
  double n_Vdbulk_di_Vdi_bi;
  double n_Vdbulk_di_Vsi_bi;
  double n_Vdbulk_di_Tempt_GND;
  double n_Vgm_si_Vgm_si;
  double n_Vgm_si_Vdbulk_di;
  double n_Vgm_si_Vsbulk_si;
  double n_Vgm_si_Vgi_bi;
  double n_Vgm_si_Vdi_bi;
  double n_Vgm_si_Vsi_bi;
  double n_Vgm_si_Tempt_GND;
#endif
#endif
double cdsc;
#if defined(_DERIVATEFORDDX)
double cdsc_Tempt_GND;
double cdsc_Vdi_bi;
double cdsc_Vsi_bi;
#if defined(_DERIVATE2)
  double cdsc_Vsi_bi_Tempt_GND;
  double cdsc_Vsi_bi_Vdi_bi;
  double cdsc_Vsi_bi_Vsi_bi;
  double cdsc_Vdi_bi_Tempt_GND;
  double cdsc_Vdi_bi_Vdi_bi;
  double cdsc_Vdi_bi_Vsi_bi;
#endif
#endif
double Cdep;
#if defined(_DERIVATEFORDDX)
double Cdep_Tempt_GND;
double Cdep_Vdi_bi;
double Cdep_Vsi_bi;
#if defined(_DERIVATE2)
  double Cdep_Vsi_bi_Tempt_GND;
  double Cdep_Vsi_bi_Vdi_bi;
  double Cdep_Vsi_bi_Vsi_bi;
  double Cdep_Vdi_bi_Tempt_GND;
  double Cdep_Vdi_bi_Vdi_bi;
  double Cdep_Vdi_bi_Vsi_bi;
#endif
#endif
double Xdep;
#if defined(_DERIVATEFORDDX)
double Xdep_Tempt_GND;
double Xdep_Vdi_bi;
double Xdep_Vsi_bi;
#if defined(_DERIVATE2)
  double Xdep_Vsi_bi_Tempt_GND;
  double Xdep_Vsi_bi_Vdi_bi;
  double Xdep_Vsi_bi_Vsi_bi;
  double Xdep_Vdi_bi_Tempt_GND;
  double Xdep_Vdi_bi_Vdi_bi;
  double Xdep_Vdi_bi_Vsi_bi;
#endif
#endif
double sqrtPhistVbs;
#if defined(_DERIVATEFORDDX)
double sqrtPhistVbs_Tempt_GND;
double sqrtPhistVbs_Vdi_bi;
double sqrtPhistVbs_Vsi_bi;
#if defined(_DERIVATE2)
  double sqrtPhistVbs_Vsi_bi_Tempt_GND;
  double sqrtPhistVbs_Vsi_bi_Vdi_bi;
  double sqrtPhistVbs_Vsi_bi_Vsi_bi;
  double sqrtPhistVbs_Vdi_bi_Tempt_GND;
  double sqrtPhistVbs_Vdi_bi_Vdi_bi;
  double sqrtPhistVbs_Vdi_bi_Vsi_bi;
#endif
#endif
double PhistVbs;
#if defined(_DERIVATEFORDDX)
double PhistVbs_Tempt_GND;
double PhistVbs_Vdi_bi;
double PhistVbs_Vsi_bi;
#if defined(_DERIVATE2)
  double PhistVbs_Vsi_bi_Tempt_GND;
  double PhistVbs_Vsi_bi_Vdi_bi;
  double PhistVbs_Vsi_bi_Vsi_bi;
  double PhistVbs_Vdi_bi_Tempt_GND;
  double PhistVbs_Vdi_bi_Vdi_bi;
  double PhistVbs_Vdi_bi_Vsi_bi;
#endif
#endif
double UCS_a;
#if defined(_DERIVATEFORDDX)
double UCS_a_Tempt_GND;
double UCS_a_Vdi_bi;
double UCS_a_Vsi_bi;
#if defined(_DERIVATE2)
  double UCS_a_Vsi_bi_Tempt_GND;
  double UCS_a_Vsi_bi_Vdi_bi;
  double UCS_a_Vsi_bi_Vsi_bi;
  double UCS_a_Vdi_bi_Tempt_GND;
  double UCS_a_Vdi_bi_Vdi_bi;
  double UCS_a_Vdi_bi_Vsi_bi;
#endif
#endif
double UC_a;
#if defined(_DERIVATEFORDDX)
double UC_a_Tempt_GND;
double UC_a_Vdi_bi;
double UC_a_Vsi_bi;
#if defined(_DERIVATE2)
  double UC_a_Vsi_bi_Tempt_GND;
  double UC_a_Vsi_bi_Vdi_bi;
  double UC_a_Vsi_bi_Vsi_bi;
  double UC_a_Vdi_bi_Tempt_GND;
  double UC_a_Vdi_bi_Vdi_bi;
  double UC_a_Vdi_bi_Vsi_bi;
#endif
#endif
double UA_a;
#if defined(_DERIVATEFORDDX)
double UA_a_Tempt_GND;
double UA_a_Vdi_bi;
double UA_a_Vsi_bi;
#if defined(_DERIVATE2)
  double UA_a_Vsi_bi_Tempt_GND;
  double UA_a_Vsi_bi_Vdi_bi;
  double UA_a_Vsi_bi_Vsi_bi;
  double UA_a_Vdi_bi_Tempt_GND;
  double UA_a_Vdi_bi_Vdi_bi;
  double UA_a_Vdi_bi_Vsi_bi;
#endif
#endif
double U0_a;
#if defined(_DERIVATEFORDDX)
double U0_a_Tempt_GND;
double U0_a_Vdi_bi;
double U0_a_Vsi_bi;
#if defined(_DERIVATE2)
  double U0_a_Vsi_bi_Tempt_GND;
  double U0_a_Vsi_bi_Vdi_bi;
  double U0_a_Vsi_bi_Vsi_bi;
  double U0_a_Vdi_bi_Tempt_GND;
  double U0_a_Vdi_bi_Vdi_bi;
  double U0_a_Vdi_bi_Vsi_bi;
#endif
#endif
double PTWG_a;
#if defined(_DERIVATEFORDDX)
double PTWG_a_Tempt_GND;
double PTWG_a_Vdi_bi;
double PTWG_a_Vsi_bi;
#if defined(_DERIVATE2)
  double PTWG_a_Vsi_bi_Tempt_GND;
  double PTWG_a_Vsi_bi_Vdi_bi;
  double PTWG_a_Vsi_bi_Vsi_bi;
  double PTWG_a_Vdi_bi_Tempt_GND;
  double PTWG_a_Vdi_bi_Vdi_bi;
  double PTWG_a_Vdi_bi_Vsi_bi;
#endif
#endif
double VSAT_a;
#if defined(_DERIVATEFORDDX)
double VSAT_a_Tempt_GND;
double VSAT_a_Vdi_bi;
double VSAT_a_Vsi_bi;
#if defined(_DERIVATE2)
  double VSAT_a_Vsi_bi_Tempt_GND;
  double VSAT_a_Vsi_bi_Vdi_bi;
  double VSAT_a_Vsi_bi_Vsi_bi;
  double VSAT_a_Vdi_bi_Tempt_GND;
  double VSAT_a_Vdi_bi_Vdi_bi;
  double VSAT_a_Vdi_bi_Vsi_bi;
#endif
#endif
double PSAT_a;
#if defined(_DERIVATEFORDDX)
double PSAT_a_Vdi_bi;
double PSAT_a_Vsi_bi;
double PSAT_a_Tempt_GND;
#if defined(_DERIVATE2)
  double PSAT_a_Vsi_bi_Vdi_bi;
  double PSAT_a_Vsi_bi_Vsi_bi;
  double PSAT_a_Vsi_bi_Tempt_GND;
  double PSAT_a_Vdi_bi_Vdi_bi;
  double PSAT_a_Vdi_bi_Vsi_bi;
  double PSAT_a_Vdi_bi_Tempt_GND;
#endif
#endif
double PCLM_a;
#if defined(_DERIVATEFORDDX)
double PCLM_a_Vdi_bi;
double PCLM_a_Vsi_bi;
double PCLM_a_Tempt_GND;
#if defined(_DERIVATE2)
  double PCLM_a_Vsi_bi_Vdi_bi;
  double PCLM_a_Vsi_bi_Vsi_bi;
  double PCLM_a_Vsi_bi_Tempt_GND;
  double PCLM_a_Vdi_bi_Vdi_bi;
  double PCLM_a_Vdi_bi_Vsi_bi;
  double PCLM_a_Vdi_bi_Tempt_GND;
#endif
#endif
double PDIBLC_a;
#if defined(_DERIVATEFORDDX)
double PDIBLC_a_Vdi_bi;
double PDIBLC_a_Vsi_bi;
double PDIBLC_a_Tempt_GND;
#if defined(_DERIVATE2)
  double PDIBLC_a_Vsi_bi_Vdi_bi;
  double PDIBLC_a_Vsi_bi_Vsi_bi;
  double PDIBLC_a_Vsi_bi_Tempt_GND;
  double PDIBLC_a_Vdi_bi_Vdi_bi;
  double PDIBLC_a_Vdi_bi_Vsi_bi;
  double PDIBLC_a_Vdi_bi_Tempt_GND;
#endif
#endif
double ETA0_a;
#if defined(_DERIVATEFORDDX)
double ETA0_a_Tempt_GND;
double ETA0_a_Vdi_bi;
double ETA0_a_Vsi_bi;
#if defined(_DERIVATE2)
  double ETA0_a_Vsi_bi_Tempt_GND;
  double ETA0_a_Vsi_bi_Vdi_bi;
  double ETA0_a_Vsi_bi_Vsi_bi;
  double ETA0_a_Vdi_bi_Tempt_GND;
  double ETA0_a_Vdi_bi_Vdi_bi;
  double ETA0_a_Vdi_bi_Vsi_bi;
#endif
#endif
double CDSCD_a;
#if defined(_DERIVATEFORDDX)
double CDSCD_a_Vdi_bi;
double CDSCD_a_Vsi_bi;
double CDSCD_a_Tempt_GND;
#if defined(_DERIVATE2)
  double CDSCD_a_Vsi_bi_Vdi_bi;
  double CDSCD_a_Vsi_bi_Vsi_bi;
  double CDSCD_a_Vsi_bi_Tempt_GND;
  double CDSCD_a_Vdi_bi_Vdi_bi;
  double CDSCD_a_Vdi_bi_Vsi_bi;
  double CDSCD_a_Vdi_bi_Tempt_GND;
#endif
#endif
double wr;
#if defined(_DERIVATEFORDDX)
double wr_Vdi_bi;
double wr_Vsi_bi;
double wr_Tempt_GND;
#if defined(_DERIVATE2)
  double wr_Vsi_bi_Vdi_bi;
  double wr_Vsi_bi_Vsi_bi;
  double wr_Vsi_bi_Tempt_GND;
  double wr_Vdi_bi_Vdi_bi;
  double wr_Vdi_bi_Vsi_bi;
  double wr_Vdi_bi_Tempt_GND;
#endif
#endif
double wf;
#if defined(_DERIVATEFORDDX)
double wf_Vdi_bi;
double wf_Vsi_bi;
double wf_Tempt_GND;
#if defined(_DERIVATE2)
  double wf_Vsi_bi_Vdi_bi;
  double wf_Vsi_bi_Vsi_bi;
  double wf_Vsi_bi_Tempt_GND;
  double wf_Vdi_bi_Vdi_bi;
  double wf_Vdi_bi_Vsi_bi;
  double wf_Vdi_bi_Tempt_GND;
#endif
#endif
double Vbsx;
#if defined(_DERIVATEFORDDX)
double Vbsx_Vdi_bi;
double Vbsx_Vsi_bi;
double Vbsx_Tempt_GND;
#if defined(_DERIVATE2)
  double Vbsx_Vsi_bi_Vdi_bi;
  double Vbsx_Vsi_bi_Vsi_bi;
  double Vbsx_Vsi_bi_Tempt_GND;
  double Vbsx_Vdi_bi_Vdi_bi;
  double Vbsx_Vdi_bi_Vsi_bi;
  double Vbsx_Vdi_bi_Tempt_GND;
#endif
#endif
double Vdsx;
#if defined(_DERIVATEFORDDX)
double Vdsx_Vdi_bi;
double Vdsx_Vsi_bi;
double Vdsx_Tempt_GND;
#if defined(_DERIVATE2)
  double Vdsx_Vsi_bi_Vdi_bi;
  double Vdsx_Vsi_bi_Vsi_bi;
  double Vdsx_Vsi_bi_Tempt_GND;
  double Vdsx_Vdi_bi_Vdi_bi;
  double Vdsx_Vdi_bi_Vsi_bi;
  double Vdsx_Vdi_bi_Tempt_GND;
#endif
#endif
double sigvds;
double Vgs_ov_noswap;
#if defined(_DERIVATEFORDDX)
double Vgs_ov_noswap_Vgm_si;
#if defined(_DERIVATE2)
  double Vgs_ov_noswap_Vgm_si_Vgm_si;
#endif
#endif
double Vgd_ov_noswap;
#if defined(_DERIVATEFORDDX)
double Vgd_ov_noswap_Vgm_di;
#if defined(_DERIVATE2)
  double Vgd_ov_noswap_Vgm_di_Vgm_di;
#endif
#endif
double Vgs_noswap;
#if defined(_DERIVATEFORDDX)
double Vgs_noswap_Vgi_bi;
double Vgs_noswap_Vsi_bi;
#if defined(_DERIVATE2)
  double Vgs_noswap_Vsi_bi_Vgi_bi;
  double Vgs_noswap_Vsi_bi_Vsi_bi;
  double Vgs_noswap_Vgi_bi_Vgi_bi;
  double Vgs_noswap_Vgi_bi_Vsi_bi;
#endif
#endif
double Vgd_noswap;
#if defined(_DERIVATEFORDDX)
double Vgd_noswap_Vgi_bi;
double Vgd_noswap_Vdi_bi;
#if defined(_DERIVATE2)
  double Vgd_noswap_Vdi_bi_Vgi_bi;
  double Vgd_noswap_Vdi_bi_Vdi_bi;
  double Vgd_noswap_Vgi_bi_Vgi_bi;
  double Vgd_noswap_Vgi_bi_Vdi_bi;
#endif
#endif
double Vbd_jct;
#if defined(_DERIVATEFORDDX)
double Vbd_jct_Vdbulk_di;
#if defined(_DERIVATE2)
  double Vbd_jct_Vdbulk_di_Vdbulk_di;
#endif
#endif
double Vbs_jct;
#if defined(_DERIVATEFORDDX)
double Vbs_jct_Vsbulk_si;
#if defined(_DERIVATE2)
  double Vbs_jct_Vsbulk_si_Vsbulk_si;
#endif
#endif
double Vdb_noswap;
#if defined(_DERIVATEFORDDX)
double Vdb_noswap_Vdi_bi;
#if defined(_DERIVATE2)
  double Vdb_noswap_Vdi_bi_Vdi_bi;
#endif
#endif
double Vsb_noswap;
#if defined(_DERIVATEFORDDX)
double Vsb_noswap_Vsi_bi;
#if defined(_DERIVATE2)
  double Vsb_noswap_Vsi_bi_Vsi_bi;
#endif
#endif
double Vds_noswap;
#if defined(_DERIVATEFORDDX)
double Vds_noswap_Vdi_bi;
double Vds_noswap_Vsi_bi;
#if defined(_DERIVATE2)
  double Vds_noswap_Vsi_bi_Vdi_bi;
  double Vds_noswap_Vsi_bi_Vsi_bi;
  double Vds_noswap_Vdi_bi_Vdi_bi;
  double Vds_noswap_Vdi_bi_Vsi_bi;
#endif
#endif
double Vds;
#if defined(_DERIVATEFORDDX)
double Vds_Vdi_bi;
double Vds_Vsi_bi;
#if defined(_DERIVATE2)
  double Vds_Vsi_bi_Vdi_bi;
  double Vds_Vsi_bi_Vsi_bi;
  double Vds_Vdi_bi_Vdi_bi;
  double Vds_Vdi_bi_Vsi_bi;
#endif
#endif
double Vs;
#if defined(_DERIVATEFORDDX)
double Vs_Vdi_bi;
double Vs_Vsi_bi;
#if defined(_DERIVATE2)
  double Vs_Vsi_bi_Vdi_bi;
  double Vs_Vsi_bi_Vsi_bi;
  double Vs_Vdi_bi_Vdi_bi;
  double Vs_Vdi_bi_Vsi_bi;
#endif
#endif
double Vd;
#if defined(_DERIVATEFORDDX)
double Vd_Vsi_bi;
double Vd_Vdi_bi;
#if defined(_DERIVATE2)
  double Vd_Vdi_bi_Vsi_bi;
  double Vd_Vdi_bi_Vdi_bi;
  double Vd_Vsi_bi_Vsi_bi;
  double Vd_Vsi_bi_Vdi_bi;
#endif
#endif
double Vg;
#if defined(_DERIVATEFORDDX)
double Vg_Vgi_bi;
#if defined(_DERIVATE2)
  double Vg_Vgi_bi_Vgi_bi;
#endif
#endif
double mu_well;
#if defined(_DERIVATE)
double mu_well_Tempt_GND;
#endif
double k2_well;
#if defined(_DERIVATE)
double k2_well_Tempt_GND;
#endif
double vth0_well;
#if defined(_DERIVATE)
double vth0_well_Tempt_GND;
#endif
double Wdrn;
double k2_stress;
#if defined(_DERIVATE)
double k2_stress_Tempt_GND;
#endif
double vth0_stress;
#if defined(_DERIVATE)
double vth0_stress_Tempt_GND;
#endif
double vsat_mult;
#if defined(_DERIVATE)
double vsat_mult_Tempt_GND;
#endif
double mu0_mult;
#if defined(_DERIVATE)
double mu0_mult_Tempt_GND;
#endif
double rho;
#if defined(_DERIVATE)
double rho_Tempt_GND;
#endif
double Inv_od;
#if defined(_DERIVATE)
double Inv_od_Tempt_GND;
#endif
double rho_ref;
#if defined(_DERIVATE)
double rho_ref_Tempt_GND;
#endif
double Inv_odref;
double Inv_sbref;
double Inv_saref;
int i;
double ku0_temp;
#if defined(_DERIVATE)
double ku0_temp_Tempt_GND;
#endif
double kstress_vth0;
#if defined(_DERIVATE)
double kstress_vth0_Tempt_GND;
#endif
double tmp1_stress_vth;
#if defined(_DERIVATE)
double tmp1_stress_vth_Tempt_GND;
#endif
double kstress_u0;
#if defined(_DERIVATE)
double kstress_u0_Tempt_GND;
#endif
double tmp1_stress;
#if defined(_DERIVATE)
double tmp1_stress_Tempt_GND;
#endif
double W_tmp_stress;
double DslpRev;
#if defined(_DERIVATE)
double DslpRev_Tempt_GND;
#endif
double IVjdmRev;
#if defined(_DERIVATE)
double IVjdmRev_Tempt_GND;
#endif
double VjdmRev;
#if defined(_DERIVATE)
double VjdmRev_Tempt_GND;
#endif
double DslpFwd;
#if defined(_DERIVATE)
double DslpFwd_Tempt_GND;
#endif
double IVjdmFwd;
#if defined(_DERIVATE)
double IVjdmFwd_Tempt_GND;
#endif
double VjdmFwd;
#if defined(_DERIVATE)
double VjdmFwd_Tempt_GND;
#endif
double XExpBVD;
#if defined(_DERIVATE)
double XExpBVD_Tempt_GND;
#endif
double Nvtmd;
#if defined(_DERIVATE)
double Nvtmd_Tempt_GND;
#endif
double Isbd;
#if defined(_DERIVATE)
double Isbd_Tempt_GND;
#endif
double SslpRev;
#if defined(_DERIVATE)
double SslpRev_Tempt_GND;
#endif
double IVjsmRev;
#if defined(_DERIVATE)
double IVjsmRev_Tempt_GND;
#endif
double VjsmRev;
#if defined(_DERIVATE)
double VjsmRev_Tempt_GND;
#endif
double SslpFwd;
#if defined(_DERIVATE)
double SslpFwd_Tempt_GND;
#endif
double IVjsmFwd;
#if defined(_DERIVATE)
double IVjsmFwd_Tempt_GND;
#endif
double VjsmFwd;
#if defined(_DERIVATE)
double VjsmFwd_Tempt_GND;
#endif
double Tb;
#if defined(_DERIVATE)
double Tb_Tempt_GND;
#endif
double T2;
#if defined(_DERIVATEFORDDX)
double T2_Vgm_di;
double T2_Vgm_si;
double T2_Vdbulk_di;
double T2_Vsbulk_si;
double T2_Vgi_bi;
double T2_Vdi_bi;
double T2_Vsi_bi;
double T2_Tempt_GND;
#if defined(_DERIVATE2)
  double T2_Vsi_bi_Vgm_di;
  double T2_Vsi_bi_Vgm_si;
  double T2_Vsi_bi_Vdbulk_di;
  double T2_Vsi_bi_Vsbulk_si;
  double T2_Vsi_bi_Vgi_bi;
  double T2_Vsi_bi_Vdi_bi;
  double T2_Vsi_bi_Vsi_bi;
  double T2_Vsi_bi_Tempt_GND;
  double T2_Vdi_bi_Vgm_di;
  double T2_Vdi_bi_Vgm_si;
  double T2_Vdi_bi_Vdbulk_di;
  double T2_Vdi_bi_Vsbulk_si;
  double T2_Vdi_bi_Vgi_bi;
  double T2_Vdi_bi_Vdi_bi;
  double T2_Vdi_bi_Vsi_bi;
  double T2_Vdi_bi_Tempt_GND;
  double T2_Vgi_bi_Vgm_di;
  double T2_Vgi_bi_Vgm_si;
  double T2_Vgi_bi_Vdbulk_di;
  double T2_Vgi_bi_Vsbulk_si;
  double T2_Vgi_bi_Vgi_bi;
  double T2_Vgi_bi_Vdi_bi;
  double T2_Vgi_bi_Vsi_bi;
  double T2_Vgi_bi_Tempt_GND;
  double T2_Vsbulk_si_Vgm_di;
  double T2_Vsbulk_si_Vgm_si;
  double T2_Vsbulk_si_Vdbulk_di;
  double T2_Vsbulk_si_Vsbulk_si;
  double T2_Vsbulk_si_Vgi_bi;
  double T2_Vsbulk_si_Vdi_bi;
  double T2_Vsbulk_si_Vsi_bi;
  double T2_Vsbulk_si_Tempt_GND;
  double T2_Vdbulk_di_Vgm_di;
  double T2_Vdbulk_di_Vgm_si;
  double T2_Vdbulk_di_Vdbulk_di;
  double T2_Vdbulk_di_Vsbulk_si;
  double T2_Vdbulk_di_Vgi_bi;
  double T2_Vdbulk_di_Vdi_bi;
  double T2_Vdbulk_di_Vsi_bi;
  double T2_Vdbulk_di_Tempt_GND;
  double T2_Vgm_si_Vgm_di;
  double T2_Vgm_si_Vgm_si;
  double T2_Vgm_si_Vdbulk_di;
  double T2_Vgm_si_Vsbulk_si;
  double T2_Vgm_si_Vgi_bi;
  double T2_Vgm_si_Vdi_bi;
  double T2_Vgm_si_Vsi_bi;
  double T2_Vgm_si_Tempt_GND;
  double T2_Vgm_di_Vgm_di;
  double T2_Vgm_di_Vgm_si;
  double T2_Vgm_di_Vdbulk_di;
  double T2_Vgm_di_Vsbulk_si;
  double T2_Vgm_di_Vgi_bi;
  double T2_Vgm_di_Vdi_bi;
  double T2_Vgm_di_Vsi_bi;
  double T2_Vgm_di_Tempt_GND;
#endif
#endif
double XExpBVS;
#if defined(_DERIVATE)
double XExpBVS_Tempt_GND;
#endif
double Nvtms;
#if defined(_DERIVATE)
double Nvtms_Tempt_GND;
#endif
double Isbs;
#if defined(_DERIVATE)
double Isbs_Tempt_GND;
#endif
double PDeff;
#if defined(_DERIVATE)
double PDeff_Tempt_GND;
#endif
double PSeff;
#if defined(_DERIVATE)
double PSeff_Tempt_GND;
#endif
double ADeff;
#if defined(_DERIVATE)
double ADeff_Tempt_GND;
#endif
double ASeff;
#if defined(_DERIVATE)
double ASeff_Tempt_GND;
#endif
double temp_ADeff;
#if defined(_DERIVATE)
double temp_ADeff_Tempt_GND;
#endif
double temp_ASeff;
#if defined(_DERIVATE)
double temp_ASeff_Tempt_GND;
#endif
double temp_PDeff;
#if defined(_DERIVATE)
double temp_PDeff_Tempt_GND;
#endif
double temp_PSeff;
#if defined(_DERIVATE)
double temp_PSeff_Tempt_GND;
#endif
double ADmer;
double ASmer;
double ADsha;
double ASsha;
double ADiso;
#if defined(_DERIVATE)
double ADiso_Tempt_GND;
#endif
double ASiso;
#if defined(_DERIVATE)
double ASiso_Tempt_GND;
#endif
double PDmer;
double PSmer;
double PDsha;
#if defined(_DERIVATE)
double PDsha_Tempt_GND;
#endif
double PSsha;
#if defined(_DERIVATE)
double PSsha_Tempt_GND;
#endif
double PDiso;
#if defined(_DERIVATE)
double PDiso_Tempt_GND;
#endif
double PSiso;
#if defined(_DERIVATE)
double PSiso_Tempt_GND;
#endif
double NJTSSWGD_t;
#if defined(_DERIVATE)
double NJTSSWGD_t_Tempt_GND;
#endif
double NJTSSWD_t;
#if defined(_DERIVATE)
double NJTSSWD_t_Tempt_GND;
#endif
double NJTSD_t;
#if defined(_DERIVATE)
double NJTSD_t_Tempt_GND;
#endif
double NJTSSWG_t;
#if defined(_DERIVATE)
double NJTSSWG_t_Tempt_GND;
#endif
double NJTSSW_t;
#if defined(_DERIVATE)
double NJTSSW_t_Tempt_GND;
#endif
double NJTS_t;
#if defined(_DERIVATE)
double NJTS_t_Tempt_GND;
#endif
double JTSSWGD_t;
#if defined(_DERIVATE)
double JTSSWGD_t_Tempt_GND;
#endif
double JTSSWD_t;
#if defined(_DERIVATE)
double JTSSWD_t_Tempt_GND;
#endif
double JTSD_t;
#if defined(_DERIVATE)
double JTSD_t_Tempt_GND;
#endif
double JTSSWGS_t;
#if defined(_DERIVATE)
double JTSSWGS_t_Tempt_GND;
#endif
double JTSSWS_t;
#if defined(_DERIVATE)
double JTSSWS_t_Tempt_GND;
#endif
double JTSS_t;
#if defined(_DERIVATE)
double JTSS_t_Tempt_GND;
#endif
double JSWGD_t;
#if defined(_DERIVATE)
double JSWGD_t_Tempt_GND;
#endif
double JSWD_t;
#if defined(_DERIVATE)
double JSWD_t_Tempt_GND;
#endif
double JSD_t;
#if defined(_DERIVATE)
double JSD_t_Tempt_GND;
#endif
double JSWGS_t;
#if defined(_DERIVATE)
double JSWGS_t_Tempt_GND;
#endif
double JSWS_t;
#if defined(_DERIVATE)
double JSWS_t_Tempt_GND;
#endif
double JSS_t;
#if defined(_DERIVATE)
double JSS_t_Tempt_GND;
#endif
double T3;
#if defined(_DERIVATEFORDDX)
double T3_Vgm_si;
double T3_Vgm_di;
double T3_Vdbulk_di;
double T3_Vsbulk_si;
double T3_Vgi_bi;
double T3_Vdi_bi;
double T3_Vsi_bi;
double T3_Tempt_GND;
#if defined(_DERIVATE2)
  double T3_Vsi_bi_Vgm_si;
  double T3_Vsi_bi_Vgm_di;
  double T3_Vsi_bi_Vdbulk_di;
  double T3_Vsi_bi_Vsbulk_si;
  double T3_Vsi_bi_Vgi_bi;
  double T3_Vsi_bi_Vdi_bi;
  double T3_Vsi_bi_Vsi_bi;
  double T3_Vsi_bi_Tempt_GND;
  double T3_Vdi_bi_Vgm_si;
  double T3_Vdi_bi_Vgm_di;
  double T3_Vdi_bi_Vdbulk_di;
  double T3_Vdi_bi_Vsbulk_si;
  double T3_Vdi_bi_Vgi_bi;
  double T3_Vdi_bi_Vdi_bi;
  double T3_Vdi_bi_Vsi_bi;
  double T3_Vdi_bi_Tempt_GND;
  double T3_Vgi_bi_Vgm_si;
  double T3_Vgi_bi_Vgm_di;
  double T3_Vgi_bi_Vdbulk_di;
  double T3_Vgi_bi_Vsbulk_si;
  double T3_Vgi_bi_Vgi_bi;
  double T3_Vgi_bi_Vdi_bi;
  double T3_Vgi_bi_Vsi_bi;
  double T3_Vgi_bi_Tempt_GND;
  double T3_Vsbulk_si_Vgm_si;
  double T3_Vsbulk_si_Vgm_di;
  double T3_Vsbulk_si_Vdbulk_di;
  double T3_Vsbulk_si_Vsbulk_si;
  double T3_Vsbulk_si_Vgi_bi;
  double T3_Vsbulk_si_Vdi_bi;
  double T3_Vsbulk_si_Vsi_bi;
  double T3_Vsbulk_si_Tempt_GND;
  double T3_Vdbulk_di_Vgm_si;
  double T3_Vdbulk_di_Vgm_di;
  double T3_Vdbulk_di_Vdbulk_di;
  double T3_Vdbulk_di_Vsbulk_si;
  double T3_Vdbulk_di_Vgi_bi;
  double T3_Vdbulk_di_Vdi_bi;
  double T3_Vdbulk_di_Vsi_bi;
  double T3_Vdbulk_di_Tempt_GND;
  double T3_Vgm_di_Vgm_si;
  double T3_Vgm_di_Vgm_di;
  double T3_Vgm_di_Vdbulk_di;
  double T3_Vgm_di_Vsbulk_si;
  double T3_Vgm_di_Vgi_bi;
  double T3_Vgm_di_Vdi_bi;
  double T3_Vgm_di_Vsi_bi;
  double T3_Vgm_di_Tempt_GND;
  double T3_Vgm_si_Vgm_si;
  double T3_Vgm_si_Vgm_di;
  double T3_Vgm_si_Vdbulk_di;
  double T3_Vgm_si_Vsbulk_si;
  double T3_Vgm_si_Vgi_bi;
  double T3_Vgm_si_Vdi_bi;
  double T3_Vgm_si_Vsi_bi;
  double T3_Vgm_si_Tempt_GND;
#endif
#endif
double PBSWGD_t;
#if defined(_DERIVATE)
double PBSWGD_t_Tempt_GND;
#endif
double PBSWGS_t;
#if defined(_DERIVATE)
double PBSWGS_t_Tempt_GND;
#endif
double PBSWD_t;
#if defined(_DERIVATE)
double PBSWD_t_Tempt_GND;
#endif
double PBSWS_t;
#if defined(_DERIVATE)
double PBSWS_t_Tempt_GND;
#endif
double PBD_t;
#if defined(_DERIVATE)
double PBD_t_Tempt_GND;
#endif
double PBS_t;
#if defined(_DERIVATE)
double PBS_t_Tempt_GND;
#endif
double CJSWGD_t;
#if defined(_DERIVATE)
double CJSWGD_t_Tempt_GND;
#endif
double CJSWGS_t;
#if defined(_DERIVATE)
double CJSWGS_t_Tempt_GND;
#endif
double CJSWD_t;
#if defined(_DERIVATE)
double CJSWD_t_Tempt_GND;
#endif
double CJSWS_t;
#if defined(_DERIVATE)
double CJSWS_t_Tempt_GND;
#endif
double CJD_t;
#if defined(_DERIVATE)
double CJD_t_Tempt_GND;
#endif
double CJS_t;
#if defined(_DERIVATE)
double CJS_t_Tempt_GND;
#endif
double igtemp;
#if defined(_DERIVATE)
double igtemp_Tempt_GND;
#endif
double BGISL_t;
#if defined(_DERIVATE)
double BGISL_t_Tempt_GND;
#endif
double BGIDL_t;
#if defined(_DERIVATE)
double BGIDL_t_Tempt_GND;
#endif
double BETA0_t;
#if defined(_DERIVATE)
double BETA0_t_Tempt_GND;
#endif
double A2_t;
#if defined(_DERIVATE)
double A2_t_Tempt_GND;
#endif
double A1_t;
#if defined(_DERIVATE)
double A1_t_Tempt_GND;
#endif
double PTWG_t;
#if defined(_DERIVATE)
double PTWG_t_Tempt_GND;
#endif
double DELTA_t;
#if defined(_DERIVATE)
double DELTA_t_Tempt_GND;
#endif
double VSATCV_t;
#if defined(_DERIVATE)
double VSATCV_t_Tempt_GND;
#endif
double VSAT_t;
#if defined(_DERIVATE)
double VSAT_t_Tempt_GND;
#endif
double rdstemp;
#if defined(_DERIVATE)
double rdstemp_Tempt_GND;
#endif
double UCS_t;
#if defined(_DERIVATE)
double UCS_t_Tempt_GND;
#endif
double UD_t;
#if defined(_DERIVATE)
double UD_t_Tempt_GND;
#endif
double UC_t;
#if defined(_DERIVATE)
double UC_t_Tempt_GND;
#endif
double UA_t;
#if defined(_DERIVATE)
double UA_t_Tempt_GND;
#endif
double U0_t;
#if defined(_DERIVATE)
double U0_t_Tempt_GND;
#endif
double eta_mu;
double ETA0_t;
#if defined(_DERIVATE)
double ETA0_t_Tempt_GND;
#endif
double NFACTOR_t;
#if defined(_DERIVATE)
double NFACTOR_t_Tempt_GND;
#endif
double litl;
double T1DEP;
double sqrtPhist;
#if defined(_DERIVATE)
double sqrtPhist_Tempt_GND;
#endif
double Phist;
#if defined(_DERIVATE)
double Phist_Tempt_GND;
#endif
double Vfbsdr;
#if defined(_DERIVATE)
double Vfbsdr_Tempt_GND;
#endif
double Vbi;
#if defined(_DERIVATE)
double Vbi_Tempt_GND;
#endif
double phib;
#if defined(_DERIVATE)
double phib_Tempt_GND;
#endif
double ni;
#if defined(_DERIVATE)
double ni_Tempt_GND;
#endif
double T1;
#if defined(_DERIVATEFORDDX)
double T1_Vgm_di;
double T1_Vgm_si;
double T1_Vdbulk_di;
double T1_Vsbulk_si;
double T1_Vgi_bi;
double T1_Vdi_bi;
double T1_Vsi_bi;
double T1_Tempt_GND;
#if defined(_DERIVATE2)
  double T1_Vsi_bi_Vgm_di;
  double T1_Vsi_bi_Vgm_si;
  double T1_Vsi_bi_Vdbulk_di;
  double T1_Vsi_bi_Vsbulk_si;
  double T1_Vsi_bi_Vgi_bi;
  double T1_Vsi_bi_Vdi_bi;
  double T1_Vsi_bi_Vsi_bi;
  double T1_Vsi_bi_Tempt_GND;
  double T1_Vdi_bi_Vgm_di;
  double T1_Vdi_bi_Vgm_si;
  double T1_Vdi_bi_Vdbulk_di;
  double T1_Vdi_bi_Vsbulk_si;
  double T1_Vdi_bi_Vgi_bi;
  double T1_Vdi_bi_Vdi_bi;
  double T1_Vdi_bi_Vsi_bi;
  double T1_Vdi_bi_Tempt_GND;
  double T1_Vgi_bi_Vgm_di;
  double T1_Vgi_bi_Vgm_si;
  double T1_Vgi_bi_Vdbulk_di;
  double T1_Vgi_bi_Vsbulk_si;
  double T1_Vgi_bi_Vgi_bi;
  double T1_Vgi_bi_Vdi_bi;
  double T1_Vgi_bi_Vsi_bi;
  double T1_Vgi_bi_Tempt_GND;
  double T1_Vsbulk_si_Vgm_di;
  double T1_Vsbulk_si_Vgm_si;
  double T1_Vsbulk_si_Vdbulk_di;
  double T1_Vsbulk_si_Vsbulk_si;
  double T1_Vsbulk_si_Vgi_bi;
  double T1_Vsbulk_si_Vdi_bi;
  double T1_Vsbulk_si_Vsi_bi;
  double T1_Vsbulk_si_Tempt_GND;
  double T1_Vdbulk_di_Vgm_di;
  double T1_Vdbulk_di_Vgm_si;
  double T1_Vdbulk_di_Vdbulk_di;
  double T1_Vdbulk_di_Vsbulk_si;
  double T1_Vdbulk_di_Vgi_bi;
  double T1_Vdbulk_di_Vdi_bi;
  double T1_Vdbulk_di_Vsi_bi;
  double T1_Vdbulk_di_Tempt_GND;
  double T1_Vgm_si_Vgm_di;
  double T1_Vgm_si_Vgm_si;
  double T1_Vgm_si_Vdbulk_di;
  double T1_Vgm_si_Vsbulk_si;
  double T1_Vgm_si_Vgi_bi;
  double T1_Vgm_si_Vdi_bi;
  double T1_Vgm_si_Vsi_bi;
  double T1_Vgm_si_Tempt_GND;
  double T1_Vgm_di_Vgm_di;
  double T1_Vgm_di_Vgm_si;
  double T1_Vgm_di_Vdbulk_di;
  double T1_Vgm_di_Vsbulk_si;
  double T1_Vgm_di_Vgi_bi;
  double T1_Vgm_di_Vdi_bi;
  double T1_Vgm_di_Vsi_bi;
  double T1_Vgm_di_Tempt_GND;
#endif
#endif
double Eg0;
double Eg;
#if defined(_DERIVATE)
double Eg_Tempt_GND;
#endif
double Vtm0;
double Vtm;
#if defined(_DERIVATE)
double Vtm_Tempt_GND;
#endif
double delTemp;
#if defined(_DERIVATE)
double delTemp_Tempt_GND;
#endif
double TRatio;
#if defined(_DERIVATE)
double TRatio_Tempt_GND;
#endif
double inv_Vt;
#if defined(_DERIVATE)
double inv_Vt_Tempt_GND;
#endif
double Vt;
#if defined(_DERIVATE)
double Vt_Tempt_GND;
#endif
double delTemp1;
#if defined(_DERIVATE)
double delTemp1_Tempt_GND;
#endif
double DevTemp;
#if defined(_DERIVATE)
double DevTemp_Tempt_GND;
#endif
double Tnom;
double T0;
#if defined(_DERIVATEFORDDX)
double T0_Vgm_di;
double T0_Vgm_si;
double T0_Vdbulk_di;
double T0_Vsbulk_si;
double T0_Vgi_bi;
double T0_Vdi_bi;
double T0_Vsi_bi;
double T0_Tempt_GND;
#if defined(_DERIVATE2)
  double T0_Vsi_bi_Vgm_di;
  double T0_Vsi_bi_Vgm_si;
  double T0_Vsi_bi_Vdbulk_di;
  double T0_Vsi_bi_Vsbulk_si;
  double T0_Vsi_bi_Vgi_bi;
  double T0_Vsi_bi_Vdi_bi;
  double T0_Vsi_bi_Vsi_bi;
  double T0_Vsi_bi_Tempt_GND;
  double T0_Vdi_bi_Vgm_di;
  double T0_Vdi_bi_Vgm_si;
  double T0_Vdi_bi_Vdbulk_di;
  double T0_Vdi_bi_Vsbulk_si;
  double T0_Vdi_bi_Vgi_bi;
  double T0_Vdi_bi_Vdi_bi;
  double T0_Vdi_bi_Vsi_bi;
  double T0_Vdi_bi_Tempt_GND;
  double T0_Vgi_bi_Vgm_di;
  double T0_Vgi_bi_Vgm_si;
  double T0_Vgi_bi_Vdbulk_di;
  double T0_Vgi_bi_Vsbulk_si;
  double T0_Vgi_bi_Vgi_bi;
  double T0_Vgi_bi_Vdi_bi;
  double T0_Vgi_bi_Vsi_bi;
  double T0_Vgi_bi_Tempt_GND;
  double T0_Vsbulk_si_Vgm_di;
  double T0_Vsbulk_si_Vgm_si;
  double T0_Vsbulk_si_Vdbulk_di;
  double T0_Vsbulk_si_Vsbulk_si;
  double T0_Vsbulk_si_Vgi_bi;
  double T0_Vsbulk_si_Vdi_bi;
  double T0_Vsbulk_si_Vsi_bi;
  double T0_Vsbulk_si_Tempt_GND;
  double T0_Vdbulk_di_Vgm_di;
  double T0_Vdbulk_di_Vgm_si;
  double T0_Vdbulk_di_Vdbulk_di;
  double T0_Vdbulk_di_Vsbulk_si;
  double T0_Vdbulk_di_Vgi_bi;
  double T0_Vdbulk_di_Vdi_bi;
  double T0_Vdbulk_di_Vsi_bi;
  double T0_Vdbulk_di_Tempt_GND;
  double T0_Vgm_si_Vgm_di;
  double T0_Vgm_si_Vgm_si;
  double T0_Vgm_si_Vdbulk_di;
  double T0_Vgm_si_Vsbulk_si;
  double T0_Vgm_si_Vgi_bi;
  double T0_Vgm_si_Vdi_bi;
  double T0_Vgm_si_Vsi_bi;
  double T0_Vgm_si_Tempt_GND;
  double T0_Vgm_di_Vgm_di;
  double T0_Vgm_di_Vgm_si;
  double T0_Vgm_di_Vdbulk_di;
  double T0_Vgm_di_Vsbulk_si;
  double T0_Vgm_di_Vgi_bi;
  double T0_Vgm_di_Vdi_bi;
  double T0_Vgm_di_Vsi_bi;
  double T0_Vgm_di_Tempt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double cth;
#endif
double gth;
double Weff_SH;
double BechvbEdge;
double AechvbEdge;
double Bechvb;
double Aechvb;
double ToxRatioEdge;
double ToxRatio;
double T2y;
double Grgeltd;
double Rbpby;
double Rbpbx;
double Rbdby;
double Rbdbx;
double Rbsby;
double Rbsbx;
double Rbsb;
double Rbdb;
double Rbps;
double Rbpd;
double Rbpb;
double Bodymode;
double Lnnf;
double Lnw;
double Lnl;
double Grbpd;
double Grbps;
double Grbpb;
double Grbdb;
double Grbsb;
double RDrainGeo;
double RSourceGeo;
double DMDGeff;
double DMCIeff;
double DMCGeff;
double Rint;
double Rend;
double nuIntS;
double nuIntD;
double nuEndS;
double nuEndD;
double PIGCD_i;
double T1y;
double T0y;
double NFACTOREDGE_i;
double A21_i;
double A2_i;
double A11_i;
double A1_i;
double PSATB_i;
double KT2_i;
double KT1_i;
double NTOX_i;
double DLCIGD_i;
double DLCIG_i;
double POXEDGE_i;
double CIGD_i;
double BIGD_i;
double AIGD_i;
double CIGS_i;
double BIGS_i;
double AIGS_i;
double CIGC_i;
double BIGC_i;
double AIGC_i;
double NIGBACC_i;
double CIGBACC_i;
double BIGBACC_i;
double AIGBACC_i;
double NIGBINV_i;
double EIGBINV_i;
double CIGBINV_i;
double BIGBINV_i;
double AIGBINV_i;
double IGT_i;
double TGIDL_i;
double IIT_i;
double PTWGT_i;
double AT_i;
double PRT_i;
double UCSTE_i;
double UD1_i;
double UC1_i;
double UA1_i;
double UTE_i;
double EGISL_i;
double CGISL_i;
double BGISL_i;
double AGISL_i;
double EGIDL_i;
double CGIDL_i;
double BGIDL_i;
double AGIDL_i;
double KU0WE_i;
double K2WE_i;
double KVTH0WE_i;
double BETA0_i;
double ALPHA0_i;
double CKAPPAD_i;
double CKAPPAS_i;
#if defined(_DYNAMIC)
double CGDL_i;
#endif
#if defined(_DYNAMIC)
double CGSL_i;
#endif
#if defined(_DYNAMIC)
double CF_i;
#endif
double VSATCV_i;
double PSAT_i;
double VSAT_i;
double PVAG_i;
double FPROUT_i;
double PDITSD_i;
double PDITS_i;
double PSCBE2_i;
double PSCBE1_i;
double PDIBLCB_i;
double PDIBLC_i;
double PTWG_i;
double RDSWMIN_i;
double RDSW_i;
double RDWMIN_i;
double RSWMIN_i;
double WR_i;
double PRWB_i;
double PRWG_i;
double RDW_i;
double RSW_i;
double PCLMCV_i;
double PCLM_i;
double UC_i;
double UCS_i;
double EU_i;
double UD_i;
double UA_i;
double U0_i;
double DELTA_i;
double ETAB_i;
double ETA0_i;
double PHIN_i;
double XJ_i;
double K1_i;
double K2_i;
#if defined(_DERIVATE)
double K2_i_Tempt_GND;
#endif
double DVTP5_i;
double DVTP4_i;
double DVTP3_i;
double DVTP2_i;
double DVTP1_i;
double DVTP0_i;
double CDSCB_i;
double CDSCD_i;
double NFACTOR_i;
double CIT_i;
double NGATE_i;
double NDEPCV_i;
double NDEP_i;
double NSD_i;
double VFBCV_i;
double VFB_i;
double BIN_WL;
double BIN_W;
double BIN_L;
double Weff1;
double Leff1;
double dWB;
double LW_WLN_WWN1;
double dLB;
double LW_LLN_LWN1;
double Inv_WL;
double Inv_Wwide;
double Inv_Llong;
double Inv_Wact;
double Inv_Lact;
double Inv_W;
double Inv_L;
double Weffcj;
double dWJ;
double Wact;
double Lact;
double dWCV;
double dLCV;
double Weff;
double Leff;
double dWIV;
double LW_WLN_WWN;
double W_WWN;
double L_WLN;
double dLIV;
double LW_LLN_LWN;
double W_LWN;
double L_LLN;
double Wnew;
double W_by_NF;
double Lnew;
double W_mult;
double L_mult;
#if defined(_DYNAMIC)
double BSIMBULKTOXP;
#endif
double epsratio;
double Cox;
double epsox;
double epssi;
int devsign;
double STETA0EDGE_i;
double STK2EDGE_i;
double KVTH0EDGE_i;
double K2EDGE_i;
double TETA0EDGE_i;
double TNFACTOREDGE_i;
double KT1EXPEDGE_i;
double KT2EDGE_i;
double KT1LEDGE_i;
double KT1EDGE_i;
double ETABEDGE_i;
double ETA0EDGE_i;
double CDSCBEDGE_i;
double CDSCDEDGE_i;
double CITEDGE_i;
double M0_t;
#if defined(_DERIVATE)
double M0_t_Tempt_GND;
#endif
double K0_t;
#if defined(_DERIVATE)
double K0_t_Tempt_GND;
#endif
double M01_i;
double K01_i;
double M0_i;
double K0_i;
double eta_stress_EDGE;
#if defined(_DERIVATE)
double eta_stress_EDGE_Tempt_GND;
#endif
double ETA0_EDGE;
#if defined(_DERIVATE)
double ETA0_EDGE_Tempt_GND;
#endif
double K2_EDGE;
#if defined(_DERIVATE)
double K2_EDGE_Tempt_GND;
#endif
double eta_stress;
#if defined(_DERIVATE)
double eta_stress_Tempt_GND;
#endif
double k2_stress_EDGE;
#if defined(_DERIVATE)
double k2_stress_EDGE_Tempt_GND;
#endif
double vth0_stress_EDGE;
#if defined(_DERIVATE)
double vth0_stress_EDGE_Tempt_GND;
#endif
double Inv_sb;
#if defined(_DERIVATE)
double Inv_sb_Tempt_GND;
#endif
double Inv_sa;
#if defined(_DERIVATE)
double Inv_sa_Tempt_GND;
#endif
double local_scc;
#if defined(_DERIVATE)
double local_scc_Tempt_GND;
#endif
double local_scb;
#if defined(_DERIVATE)
double local_scb_Tempt_GND;
#endif
double local_sca;
#if defined(_DERIVATE)
double local_sca_Tempt_GND;
#endif
double W_WWN1;
double W_LWN1;
double VSATR_t;
#if defined(_DERIVATE)
double VSATR_t_Tempt_GND;
#endif
double VSATR_i;
double UD_a;
#if defined(_DERIVATEFORDDX)
double UD_a_Tempt_GND;
double UD_a_Vdi_bi;
double UD_a_Vsi_bi;
#if defined(_DERIVATE2)
  double UD_a_Vsi_bi_Tempt_GND;
  double UD_a_Vsi_bi_Vdi_bi;
  double UD_a_Vsi_bi_Vsi_bi;
  double UD_a_Vdi_bi_Tempt_GND;
  double UD_a_Vdi_bi_Vdi_bi;
  double UD_a_Vdi_bi_Vsi_bi;
#endif
#endif
double UDR_t;
#if defined(_DERIVATE)
double UDR_t_Tempt_GND;
#endif
double UDR_i;
double UCSR_t;
#if defined(_DERIVATE)
double UCSR_t_Tempt_GND;
#endif
double UCSR_i;
double UCR_t;
#if defined(_DERIVATE)
double UCR_t_Tempt_GND;
#endif
double UCR_i;
double UAR_t;
#if defined(_DERIVATE)
double UAR_t_Tempt_GND;
#endif
double UAR_i;
double U0R_t;
#if defined(_DERIVATE)
double U0R_t_Tempt_GND;
#endif
double U0R_i;
double PTWGR_t;
#if defined(_DERIVATE)
double PTWGR_t_Tempt_GND;
#endif
double PTWGR_i;
double PSATR_i;
double PDIBLCR_i;
double PCLMR_i;
double L_WLN1;
double L_LLN1;
double ETA0R_t;
#if defined(_DERIVATE)
double ETA0R_t_Tempt_GND;
#endif
double ETA0R_i;
double CDSCDR_i;
CDSCDR_i=0.0;
EXIT_IF_ISNAN(0.0)
ETA0R_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
ETA0R_t_Tempt_GND=0.0;
#endif
ETA0R_t=0.0;
EXIT_IF_ISNAN(0.0)
L_LLN1=0.0;
EXIT_IF_ISNAN(0.0)
L_WLN1=0.0;
EXIT_IF_ISNAN(0.0)
PCLMR_i=0.0;
EXIT_IF_ISNAN(0.0)
PDIBLCR_i=0.0;
EXIT_IF_ISNAN(0.0)
PSATR_i=0.0;
EXIT_IF_ISNAN(0.0)
PTWGR_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
PTWGR_t_Tempt_GND=0.0;
#endif
PTWGR_t=0.0;
EXIT_IF_ISNAN(0.0)
U0R_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
U0R_t_Tempt_GND=0.0;
#endif
U0R_t=0.0;
EXIT_IF_ISNAN(0.0)
UAR_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UAR_t_Tempt_GND=0.0;
#endif
UAR_t=0.0;
EXIT_IF_ISNAN(0.0)
UCR_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UCR_t_Tempt_GND=0.0;
#endif
UCR_t=0.0;
EXIT_IF_ISNAN(0.0)
UCSR_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UCSR_t_Tempt_GND=0.0;
#endif
UCSR_t=0.0;
EXIT_IF_ISNAN(0.0)
UDR_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UDR_t_Tempt_GND=0.0;
#endif
UDR_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
UD_a_Tempt_GND=0.0;
#endif
UD_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  UD_a_Vdi_bi_Tempt_GND=0.0;
  UD_a_Vdi_bi_Vdi_bi=0.0;
  UD_a_Vdi_bi_Vsi_bi=0.0;
#endif
UD_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  UD_a_Vsi_bi_Tempt_GND=0.0;
  UD_a_Vsi_bi_Vdi_bi=0.0;
  UD_a_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
UD_a=0.0;
EXIT_IF_ISNAN(0.0)
VSATR_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VSATR_t_Tempt_GND=0.0;
#endif
VSATR_t=0.0;
EXIT_IF_ISNAN(0.0)
W_LWN1=0.0;
EXIT_IF_ISNAN(0.0)
W_WWN1=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_sca_Tempt_GND=0.0;
#endif
local_sca=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_scb_Tempt_GND=0.0;
#endif
local_scb=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_scc_Tempt_GND=0.0;
#endif
local_scc=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
Inv_sa_Tempt_GND=0.0;
#endif
Inv_sa=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
Inv_sb_Tempt_GND=0.0;
#endif
Inv_sb=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
vth0_stress_EDGE_Tempt_GND=0.0;
#endif
vth0_stress_EDGE=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
k2_stress_EDGE_Tempt_GND=0.0;
#endif
k2_stress_EDGE=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
eta_stress_Tempt_GND=0.0;
#endif
eta_stress=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
K2_EDGE_Tempt_GND=0.0;
#endif
K2_EDGE=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
ETA0_EDGE_Tempt_GND=0.0;
#endif
ETA0_EDGE=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
eta_stress_EDGE_Tempt_GND=0.0;
#endif
eta_stress_EDGE=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_sca_Tempt_GND=0.0;
#endif
local_sca=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_scb_Tempt_GND=0.0;
#endif
local_scb=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_scc_Tempt_GND=0.0;
#endif
local_scc=0.0;
EXIT_IF_ISNAN(0.0)
K0_i=0.0;
EXIT_IF_ISNAN(0.0)
M0_i=0.0;
EXIT_IF_ISNAN(0.0)
K01_i=0.0;
EXIT_IF_ISNAN(0.0)
M01_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
K0_t_Tempt_GND=0.0;
#endif
K0_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
M0_t_Tempt_GND=0.0;
#endif
M0_t=0.0;
EXIT_IF_ISNAN(0.0)
CITEDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
CDSCDEDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
CDSCBEDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
ETA0EDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
ETABEDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
KT1EDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
KT1LEDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
KT2EDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
KT1EXPEDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
TNFACTOREDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
TETA0EDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
K2EDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
KVTH0EDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
STK2EDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
STETA0EDGE_i=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->TYPE==1))
{
devsign=1;
EXIT_IF_ISNAN(1)
}
else
{
devsign=(-1);
EXIT_IF_ISNAN((-1))
}
epssi=(pModel->EPSRSUB*8.85418e-12);
EXIT_IF_ISNAN((pModel->EPSRSUB*8.85418e-12))
epsox=(pModel->EPSROX*8.85418e-12);
EXIT_IF_ISNAN((pModel->EPSROX*8.85418e-12))
Cox=((pModel->EPSROX*8.85418e-12)/pModel->TOXE);
EXIT_IF_ISNAN(((pModel->EPSROX*8.85418e-12)/pModel->TOXE))
epsratio=(pModel->EPSRSUB/pModel->EPSROX);
EXIT_IF_ISNAN((pModel->EPSRSUB/pModel->EPSROX))
#ifdef _DYNAMIC
if
((!(model->TOXP_Given)))
{
#if defined(_DYNAMIC)
BSIMBULKTOXP=(((pModel->TOXE*pModel->EPSROX)/3.9)-pModel->DTOX);
EXIT_IF_ISNAN((((pModel->TOXE*pModel->EPSROX)/3.9)-pModel->DTOX))
#endif
}
else
{
#if defined(_DYNAMIC)
BSIMBULKTOXP=pModel->TOXP;
EXIT_IF_ISNAN(pModel->TOXP)
#endif
}
#endif /* if(...) */
L_mult=(pInst->L*pModel->LMLT);
EXIT_IF_ISNAN((pInst->L*pModel->LMLT))
W_mult=(pInst->W*pModel->WMLT);
EXIT_IF_ISNAN((pInst->W*pModel->WMLT))
Lnew=(L_mult+pModel->XL);
EXIT_IF_ISNAN((L_mult+pModel->XL))
if
((Lnew<=0.0))
{
printf("Fatal: Ldrawn * LMLT + XL = %e for BSIMBULK is non-positive",Lnew);
printf("\n");
controlled_exit(0);
}
W_by_NF=(W_mult/pInst->NF);
EXIT_IF_ISNAN((W_mult/pInst->NF))
Wnew=(W_by_NF+pModel->XW);
EXIT_IF_ISNAN((W_by_NF+pModel->XW))
if
((Wnew<=0.0))
{
printf("Fatal: W / NF * WMLT + XW = %e for BSIMBULK is non-positive",Wnew);
printf("\n");
controlled_exit(0);
}
{
double m00_pow(d00_pow0,Lnew,(-pModel->LLN))
L_LLN=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,Wnew,(-pModel->LWN))
W_LWN=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
LW_LLN_LWN=(L_LLN*W_LWN);
EXIT_IF_ISNAN((L_LLN*W_LWN))
dLIV=(((pModel->LINT+(pModel->LL*L_LLN))+(pModel->LW*W_LWN))+(pModel->LWL*LW_LLN_LWN));
EXIT_IF_ISNAN((((pModel->LINT+(pModel->LL*L_LLN))+(pModel->LW*W_LWN))+(pModel->LWL*LW_LLN_LWN)))
{
double m00_pow(d00_pow0,Lnew,(-pModel->WLN))
L_WLN=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,Wnew,(-pModel->WWN))
W_WWN=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
LW_WLN_WWN=(L_WLN*W_WWN);
EXIT_IF_ISNAN((L_WLN*W_WWN))
dWIV=(((pModel->WINT+(pModel->WL*L_WLN))+(pModel->WW*W_WWN))+(pModel->WWL*LW_WLN_WWN));
EXIT_IF_ISNAN((((pModel->WINT+(pModel->WL*L_WLN))+(pModel->WW*W_WWN))+(pModel->WWL*LW_WLN_WWN)))
Leff=(Lnew-(2.0*dLIV));
EXIT_IF_ISNAN((Lnew-(2.0*dLIV)))
if
((Leff<=0.0))
{
printf("Fatal: Effective channel length = %e for  BSIMBULK is non-positive",Leff);
printf("\n");
controlled_exit(0);
}
else
{
if
((Leff<=1.0e-9))
{
printf("Warning: Effective channel length = %e for BSIMBULK is <= 1.0e-9. Recommended Leff >= 1e-8",Leff);
printf("\n");
}
}
Weff=(Wnew-(2.0*dWIV));
EXIT_IF_ISNAN((Wnew-(2.0*dWIV)))
if
((Weff<=0.0))
{
printf("Fatal: Effective channel Width = %e for BSIMBULK is non-positive",Weff);
printf("\n");
controlled_exit(0);
}
else
{
if
((Weff<=1.0e-9))
{
printf("Warning: Effective channel width = %e for BSIMBULK is <= 1.0e-9. Recommended Weff >= 1e-8",Weff);
printf("\n");
}
}
dLCV=(((pModel->DLC+(pModel->LLC*L_LLN))+(pModel->LWC*W_LWN))+(pModel->LWLC*LW_LLN_LWN));
EXIT_IF_ISNAN((((pModel->DLC+(pModel->LLC*L_LLN))+(pModel->LWC*W_LWN))+(pModel->LWLC*LW_LLN_LWN)))
dWCV=(((pModel->DWC+(pModel->WLC*L_WLN))+(pModel->WWC*W_WWN))+(pModel->WWLC*LW_WLN_WWN));
EXIT_IF_ISNAN((((pModel->DWC+(pModel->WLC*L_WLN))+(pModel->WWC*W_WWN))+(pModel->WWLC*LW_WLN_WWN)))
Lact=(Lnew-(2.0*dLCV));
EXIT_IF_ISNAN((Lnew-(2.0*dLCV)))
if
((Lact<=0.0))
{
printf("Fatal: Effective channel length for CV = %e for BSIMBULK is non-positive",Lact);
printf("\n");
controlled_exit(0);
}
else
{
if
((Lact<=1.0e-9))
{
printf("Warning: Effective channel length for CV = %e for BSIMBULK is <= 1.0e-9. Recommended Lact >= 1e-8",Lact);
printf("\n");
}
}
Wact=(Wnew-(2.0*dWCV));
EXIT_IF_ISNAN((Wnew-(2.0*dWCV)))
if
((Wact<=0.0))
{
printf("Fatal: Effective channel width for CV = %e for BSIMBULK is non-positive",Wact);
printf("\n");
controlled_exit(0);
}
else
{
if
((Wact<=1.0e-9))
{
printf("Warning: Effective channel width for CV = %e for BSIMBULK is <= 1.0e-9. Recommended Wact >= 1e-8",Wact);
printf("\n");
}
}
{
double m00_pow(d00_pow0,Lnew,pModel->WLN)
double m00_pow(d00_pow1,Wnew,pModel->WWN)
double m00_pow(d00_pow2,Lnew,pModel->WLN)
double m00_pow(d00_pow3,Wnew,pModel->WWN)
dWJ=(((pModel->DWJ+(pModel->WLC/d00_pow0))+(pModel->WWC/d00_pow1))+((pModel->WWLC/d00_pow2)/d00_pow3));
EXIT_IF_ISNAN((((pModel->DWJ+(pModel->WLC/d00_pow0))+(pModel->WWC/d00_pow1))+((pModel->WWLC/d00_pow2)/d00_pow3)))
}
Weffcj=(Wnew-(2.0*dWJ));
EXIT_IF_ISNAN((Wnew-(2.0*dWJ)))
if
((Weffcj<=0.0))
{
printf("Fatal: Effective channel width for S/D junctions = %e for BSIMBULK is non-positive",Weffcj);
printf("\n");
controlled_exit(0);
}
Inv_L=(1.0e-6/Leff);
EXIT_IF_ISNAN((1.0e-6/Leff))
Inv_W=(1.0e-6/Weff);
EXIT_IF_ISNAN((1.0e-6/Weff))
Inv_Lact=(1.0e-6/Lact);
EXIT_IF_ISNAN((1.0e-6/Lact))
Inv_Wact=(1.0e-6/Wact);
EXIT_IF_ISNAN((1.0e-6/Wact))
Inv_Llong=(1.0e-6/pModel->LLONG);
EXIT_IF_ISNAN((1.0e-6/pModel->LLONG))
Inv_Wwide=(1.0e-6/pModel->WWIDE);
EXIT_IF_ISNAN((1.0e-6/pModel->WWIDE))
Inv_WL=(Inv_L*Inv_W);
EXIT_IF_ISNAN((Inv_L*Inv_W))
L_LLN1=L_LLN;
EXIT_IF_ISNAN(L_LLN)
L_WLN1=L_WLN;
EXIT_IF_ISNAN(L_WLN)
if
((pModel->DLBIN!=0.0))
{
if
((pModel->DLBIN<=(-Lnew)))
{
printf("Fatal: DLBIN for BSIMBULK = %e is <= -Ldrawn * LMLT",pModel->DLBIN);
printf("\n");
controlled_exit(0);
}
else
{
{
double m00_pow(d00_pow0,(Lnew+pModel->DLBIN),(-pModel->LLN))
L_LLN1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(Lnew+pModel->DLBIN),(-pModel->WLN))
L_WLN1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
}
W_LWN1=W_LWN;
EXIT_IF_ISNAN(W_LWN)
W_WWN1=W_WWN;
EXIT_IF_ISNAN(W_WWN)
if
((pModel->DWBIN!=0.0))
{
if
((pModel->DWBIN<=(-Wnew)))
{
printf("Fatal: DWBIN for BSIMBULK = %e is <= -Wdrawn * WMLT",pModel->DWBIN);
printf("\n");
controlled_exit(0);
}
else
{
{
double m00_pow(d00_pow0,(Wnew+pModel->DWBIN),(-pModel->LWN))
W_LWN1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(Wnew+pModel->DWBIN),(-pModel->WWN))
W_WWN1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
}
LW_LLN_LWN1=(L_LLN1*W_LWN1);
EXIT_IF_ISNAN((L_LLN1*W_LWN1))
dLB=(((pModel->LINT+(pModel->LL*L_LLN1))+(pModel->LW*W_LWN1))+(pModel->LWL*LW_LLN_LWN1));
EXIT_IF_ISNAN((((pModel->LINT+(pModel->LL*L_LLN1))+(pModel->LW*W_LWN1))+(pModel->LWL*LW_LLN_LWN1)))
LW_WLN_WWN1=(L_WLN1*W_WWN1);
EXIT_IF_ISNAN((L_WLN1*W_WWN1))
dWB=(((pModel->WINT+(pModel->WL*L_WLN1))+(pModel->WW*W_WWN1))+(pModel->WWL*LW_WLN_WWN1));
EXIT_IF_ISNAN((((pModel->WINT+(pModel->WL*L_WLN1))+(pModel->WW*W_WWN1))+(pModel->WWL*LW_WLN_WWN1)))
Leff1=((Lnew-(2.0*dLB))+pModel->DLBIN);
EXIT_IF_ISNAN(((Lnew-(2.0*dLB))+pModel->DLBIN))
if
((Leff1<=0.0))
{
printf("Fatal: Effective channel length for binning = %e for BSIMBULK is non-positive",Leff1);
printf("\n");
controlled_exit(0);
}
Weff1=((Wnew-(2.0*dWB))+pModel->DWBIN);
EXIT_IF_ISNAN(((Wnew-(2.0*dWB))+pModel->DWBIN))
if
((Weff1<=0.0))
{
printf("Fatal: Effective channel width for binning = %e for BSIMBULK is non-positive",Weff1);
printf("\n");
controlled_exit(0);
}
if
((pModel->BINUNIT==1))
{
BIN_L=(1.0e-6/Leff1);
EXIT_IF_ISNAN((1.0e-6/Leff1))
BIN_W=(1.0e-6/Weff1);
EXIT_IF_ISNAN((1.0e-6/Weff1))
}
else
{
BIN_L=(1.0/Leff1);
EXIT_IF_ISNAN((1.0/Leff1))
BIN_W=(1.0/Weff1);
EXIT_IF_ISNAN((1.0/Weff1))
}
BIN_WL=(BIN_L*BIN_W);
EXIT_IF_ISNAN((BIN_L*BIN_W))
VFB_i=(((pModel->VFB+(BIN_L*pModel->LVFB))+(BIN_W*pModel->WVFB))+(BIN_WL*pModel->PVFB));
EXIT_IF_ISNAN((((pModel->VFB+(BIN_L*pModel->LVFB))+(BIN_W*pModel->WVFB))+(BIN_WL*pModel->PVFB)))
VFBCV_i=(((pModel->VFBCV+(BIN_L*pModel->LVFBCV))+(BIN_W*pModel->WVFBCV))+(BIN_WL*pModel->PVFBCV));
EXIT_IF_ISNAN((((pModel->VFBCV+(BIN_L*pModel->LVFBCV))+(BIN_W*pModel->WVFBCV))+(BIN_WL*pModel->PVFBCV)))
NSD_i=(((pModel->NSD+(BIN_L*pModel->LNSD))+(BIN_W*pModel->WNSD))+(BIN_WL*pModel->PNSD));
EXIT_IF_ISNAN((((pModel->NSD+(BIN_L*pModel->LNSD))+(BIN_W*pModel->WNSD))+(BIN_WL*pModel->PNSD)))
NDEP_i=(((pModel->NDEP+(BIN_L*pModel->LNDEP))+(BIN_W*pModel->WNDEP))+(BIN_WL*pModel->PNDEP));
EXIT_IF_ISNAN((((pModel->NDEP+(BIN_L*pModel->LNDEP))+(BIN_W*pModel->WNDEP))+(BIN_WL*pModel->PNDEP)))
NDEPCV_i=(((pModel->NDEPCV+(BIN_L*pModel->LNDEPCV))+(BIN_W*pModel->WNDEPCV))+(BIN_WL*pModel->PNDEPCV));
EXIT_IF_ISNAN((((pModel->NDEPCV+(BIN_L*pModel->LNDEPCV))+(BIN_W*pModel->WNDEPCV))+(BIN_WL*pModel->PNDEPCV)))
NGATE_i=(((pModel->NGATE+(BIN_L*pModel->LNGATE))+(BIN_W*pModel->WNGATE))+(BIN_WL*pModel->PNGATE));
EXIT_IF_ISNAN((((pModel->NGATE+(BIN_L*pModel->LNGATE))+(BIN_W*pModel->WNGATE))+(BIN_WL*pModel->PNGATE)))
CIT_i=(((pModel->CIT+(BIN_L*pModel->LCIT))+(BIN_W*pModel->WCIT))+(BIN_WL*pModel->PCIT));
EXIT_IF_ISNAN((((pModel->CIT+(BIN_L*pModel->LCIT))+(BIN_W*pModel->WCIT))+(BIN_WL*pModel->PCIT)))
NFACTOR_i=(((pModel->NFACTOR+(BIN_L*pModel->LNFACTOR))+(BIN_W*pModel->WNFACTOR))+(BIN_WL*pModel->PNFACTOR));
EXIT_IF_ISNAN((((pModel->NFACTOR+(BIN_L*pModel->LNFACTOR))+(BIN_W*pModel->WNFACTOR))+(BIN_WL*pModel->PNFACTOR)))
CDSCD_i=(((pModel->CDSCD+(BIN_L*pModel->LCDSCD))+(BIN_W*pModel->WCDSCD))+(BIN_WL*pModel->PCDSCD));
EXIT_IF_ISNAN((((pModel->CDSCD+(BIN_L*pModel->LCDSCD))+(BIN_W*pModel->WCDSCD))+(BIN_WL*pModel->PCDSCD)))
CDSCB_i=(((pModel->CDSCB+(BIN_L*pModel->LCDSCB))+(BIN_W*pModel->WCDSCB))+(BIN_WL*pModel->PCDSCB));
EXIT_IF_ISNAN((((pModel->CDSCB+(BIN_L*pModel->LCDSCB))+(BIN_W*pModel->WCDSCB))+(BIN_WL*pModel->PCDSCB)))
DVTP0_i=(((pModel->DVTP0+(BIN_L*pModel->LDVTP0))+(BIN_W*pModel->WDVTP0))+(BIN_WL*pModel->PDVTP0));
EXIT_IF_ISNAN((((pModel->DVTP0+(BIN_L*pModel->LDVTP0))+(BIN_W*pModel->WDVTP0))+(BIN_WL*pModel->PDVTP0)))
DVTP1_i=(((pModel->DVTP1+(BIN_L*pModel->LDVTP1))+(BIN_W*pModel->WDVTP1))+(BIN_WL*pModel->PDVTP1));
EXIT_IF_ISNAN((((pModel->DVTP1+(BIN_L*pModel->LDVTP1))+(BIN_W*pModel->WDVTP1))+(BIN_WL*pModel->PDVTP1)))
DVTP2_i=(((pModel->DVTP2+(BIN_L*pModel->LDVTP2))+(BIN_W*pModel->WDVTP2))+(BIN_WL*pModel->PDVTP2));
EXIT_IF_ISNAN((((pModel->DVTP2+(BIN_L*pModel->LDVTP2))+(BIN_W*pModel->WDVTP2))+(BIN_WL*pModel->PDVTP2)))
DVTP3_i=(((pModel->DVTP3+(BIN_L*pModel->LDVTP3))+(BIN_W*pModel->WDVTP3))+(BIN_WL*pModel->PDVTP3));
EXIT_IF_ISNAN((((pModel->DVTP3+(BIN_L*pModel->LDVTP3))+(BIN_W*pModel->WDVTP3))+(BIN_WL*pModel->PDVTP3)))
DVTP4_i=(((pModel->DVTP4+(BIN_L*pModel->LDVTP4))+(BIN_W*pModel->WDVTP4))+(BIN_WL*pModel->PDVTP4));
EXIT_IF_ISNAN((((pModel->DVTP4+(BIN_L*pModel->LDVTP4))+(BIN_W*pModel->WDVTP4))+(BIN_WL*pModel->PDVTP4)))
DVTP5_i=(((pModel->DVTP5+(BIN_L*pModel->LDVTP5))+(BIN_W*pModel->WDVTP5))+(BIN_WL*pModel->PDVTP5));
EXIT_IF_ISNAN((((pModel->DVTP5+(BIN_L*pModel->LDVTP5))+(BIN_W*pModel->WDVTP5))+(BIN_WL*pModel->PDVTP5)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
K2_i_Tempt_GND=0.0;
#endif
K2_i=(((pModel->K2+(BIN_L*pModel->LK2))+(BIN_W*pModel->WK2))+(BIN_WL*pModel->PK2));
EXIT_IF_ISNAN((((pModel->K2+(BIN_L*pModel->LK2))+(BIN_W*pModel->WK2))+(BIN_WL*pModel->PK2)))
K1_i=(((pModel->K1+(BIN_L*pModel->LK1))+(BIN_W*pModel->WK1))+(BIN_WL*pModel->PK1));
EXIT_IF_ISNAN((((pModel->K1+(BIN_L*pModel->LK1))+(BIN_W*pModel->WK1))+(BIN_WL*pModel->PK1)))
XJ_i=(((pModel->XJ+(BIN_L*pModel->LXJ))+(BIN_W*pModel->WXJ))+(BIN_WL*pModel->PXJ));
EXIT_IF_ISNAN((((pModel->XJ+(BIN_L*pModel->LXJ))+(BIN_W*pModel->WXJ))+(BIN_WL*pModel->PXJ)))
PHIN_i=(((pModel->PHIN+(BIN_L*pModel->LPHIN))+(BIN_W*pModel->WPHIN))+(BIN_WL*pModel->PPHIN));
EXIT_IF_ISNAN((((pModel->PHIN+(BIN_L*pModel->LPHIN))+(BIN_W*pModel->WPHIN))+(BIN_WL*pModel->PPHIN)))
ETA0_i=(((pModel->ETA0+(BIN_L*pModel->LETA0))+(BIN_W*pModel->WETA0))+(BIN_WL*pModel->PETA0));
EXIT_IF_ISNAN((((pModel->ETA0+(BIN_L*pModel->LETA0))+(BIN_W*pModel->WETA0))+(BIN_WL*pModel->PETA0)))
ETAB_i=(((pModel->ETAB+(BIN_L*pModel->LETAB))+(BIN_W*pModel->WETAB))+(BIN_WL*pModel->PETAB));
EXIT_IF_ISNAN((((pModel->ETAB+(BIN_L*pModel->LETAB))+(BIN_W*pModel->WETAB))+(BIN_WL*pModel->PETAB)))
DELTA_i=(((pModel->DELTA+(BIN_L*pModel->LDELTA))+(BIN_W*pModel->WDELTA))+(BIN_WL*pModel->PDELTA));
EXIT_IF_ISNAN((((pModel->DELTA+(BIN_L*pModel->LDELTA))+(BIN_W*pModel->WDELTA))+(BIN_WL*pModel->PDELTA)))
U0_i=(((pModel->U0+(BIN_L*pModel->LU0))+(BIN_W*pModel->WU0))+(BIN_WL*pModel->PU0));
EXIT_IF_ISNAN((((pModel->U0+(BIN_L*pModel->LU0))+(BIN_W*pModel->WU0))+(BIN_WL*pModel->PU0)))
UA_i=(((pModel->UA+(BIN_L*pModel->LUA))+(BIN_W*pModel->WUA))+(BIN_WL*pModel->PUA));
EXIT_IF_ISNAN((((pModel->UA+(BIN_L*pModel->LUA))+(BIN_W*pModel->WUA))+(BIN_WL*pModel->PUA)))
UD_i=(((pModel->UD+(BIN_L*pModel->LUD))+(BIN_W*pModel->WUD))+(BIN_WL*pModel->PUD));
EXIT_IF_ISNAN((((pModel->UD+(BIN_L*pModel->LUD))+(BIN_W*pModel->WUD))+(BIN_WL*pModel->PUD)))
EU_i=(((pModel->EU+(BIN_L*pModel->LEU))+(BIN_W*pModel->WEU))+(BIN_WL*pModel->PEU));
EXIT_IF_ISNAN((((pModel->EU+(BIN_L*pModel->LEU))+(BIN_W*pModel->WEU))+(BIN_WL*pModel->PEU)))
UCS_i=(((pModel->UCS+(BIN_L*pModel->LUCS))+(BIN_W*pModel->WUCS))+(BIN_WL*pModel->PUCS));
EXIT_IF_ISNAN((((pModel->UCS+(BIN_L*pModel->LUCS))+(BIN_W*pModel->WUCS))+(BIN_WL*pModel->PUCS)))
UC_i=(((pModel->UC+(BIN_L*pModel->LUC))+(BIN_W*pModel->WUC))+(BIN_WL*pModel->PUC));
EXIT_IF_ISNAN((((pModel->UC+(BIN_L*pModel->LUC))+(BIN_W*pModel->WUC))+(BIN_WL*pModel->PUC)))
PCLM_i=(((pModel->PCLM+(BIN_L*pModel->LPCLM))+(BIN_W*pModel->WPCLM))+(BIN_WL*pModel->PPCLM));
EXIT_IF_ISNAN((((pModel->PCLM+(BIN_L*pModel->LPCLM))+(BIN_W*pModel->WPCLM))+(BIN_WL*pModel->PPCLM)))
PCLMCV_i=(((pModel->PCLMCV+(BIN_L*pModel->LPCLMCV))+(BIN_W*pModel->WPCLMCV))+(BIN_WL*pModel->PPCLMCV));
EXIT_IF_ISNAN((((pModel->PCLMCV+(BIN_L*pModel->LPCLMCV))+(BIN_W*pModel->WPCLMCV))+(BIN_WL*pModel->PPCLMCV)))
RSW_i=(((pModel->RSW+(BIN_L*pModel->LRSW))+(BIN_W*pModel->WRSW))+(BIN_WL*pModel->PRSW));
EXIT_IF_ISNAN((((pModel->RSW+(BIN_L*pModel->LRSW))+(BIN_W*pModel->WRSW))+(BIN_WL*pModel->PRSW)))
RDW_i=(((pModel->RDW+(BIN_L*pModel->LRDW))+(BIN_W*pModel->WRDW))+(BIN_WL*pModel->PRDW));
EXIT_IF_ISNAN((((pModel->RDW+(BIN_L*pModel->LRDW))+(BIN_W*pModel->WRDW))+(BIN_WL*pModel->PRDW)))
PRWG_i=(((pModel->PRWG+(BIN_L*pModel->LPRWG))+(BIN_W*pModel->WPRWG))+(BIN_WL*pModel->PPRWG));
EXIT_IF_ISNAN((((pModel->PRWG+(BIN_L*pModel->LPRWG))+(BIN_W*pModel->WPRWG))+(BIN_WL*pModel->PPRWG)))
PRWB_i=(((pModel->PRWB+(BIN_L*pModel->LPRWB))+(BIN_W*pModel->WPRWB))+(BIN_WL*pModel->PPRWB));
EXIT_IF_ISNAN((((pModel->PRWB+(BIN_L*pModel->LPRWB))+(BIN_W*pModel->WPRWB))+(BIN_WL*pModel->PPRWB)))
WR_i=(((pModel->WR+(BIN_L*pModel->LWR))+(BIN_W*pModel->WWR))+(BIN_WL*pModel->PWR));
EXIT_IF_ISNAN((((pModel->WR+(BIN_L*pModel->LWR))+(BIN_W*pModel->WWR))+(BIN_WL*pModel->PWR)))
RSWMIN_i=(((pModel->RSWMIN+(BIN_L*pModel->LRSWMIN))+(BIN_W*pModel->WRSWMIN))+(BIN_WL*pModel->PRSWMIN));
EXIT_IF_ISNAN((((pModel->RSWMIN+(BIN_L*pModel->LRSWMIN))+(BIN_W*pModel->WRSWMIN))+(BIN_WL*pModel->PRSWMIN)))
RDWMIN_i=(((pModel->RDWMIN+(BIN_L*pModel->LRDWMIN))+(BIN_W*pModel->WRDWMIN))+(BIN_WL*pModel->PRDWMIN));
EXIT_IF_ISNAN((((pModel->RDWMIN+(BIN_L*pModel->LRDWMIN))+(BIN_W*pModel->WRDWMIN))+(BIN_WL*pModel->PRDWMIN)))
RDSW_i=(((pModel->RDSW+(BIN_L*pModel->LRDSW))+(BIN_W*pModel->WRDSW))+(BIN_WL*pModel->PRDSW));
EXIT_IF_ISNAN((((pModel->RDSW+(BIN_L*pModel->LRDSW))+(BIN_W*pModel->WRDSW))+(BIN_WL*pModel->PRDSW)))
RDSWMIN_i=(((pModel->RDSWMIN+(BIN_L*pModel->LRDSWMIN))+(BIN_W*pModel->WRDSWMIN))+(BIN_WL*pModel->PRDSWMIN));
EXIT_IF_ISNAN((((pModel->RDSWMIN+(BIN_L*pModel->LRDSWMIN))+(BIN_W*pModel->WRDSWMIN))+(BIN_WL*pModel->PRDSWMIN)))
PTWG_i=(((pModel->PTWG+(BIN_L*pModel->LPTWG))+(BIN_W*pModel->WPTWG))+(BIN_WL*pModel->PPTWG));
EXIT_IF_ISNAN((((pModel->PTWG+(BIN_L*pModel->LPTWG))+(BIN_W*pModel->WPTWG))+(BIN_WL*pModel->PPTWG)))
PDIBLC_i=(((pModel->PDIBLC+(BIN_L*pModel->LPDIBLC))+(BIN_W*pModel->WPDIBLC))+(BIN_WL*pModel->PPDIBLC));
EXIT_IF_ISNAN((((pModel->PDIBLC+(BIN_L*pModel->LPDIBLC))+(BIN_W*pModel->WPDIBLC))+(BIN_WL*pModel->PPDIBLC)))
PDIBLCB_i=(((pModel->PDIBLCB+(BIN_L*pModel->LPDIBLCB))+(BIN_W*pModel->WPDIBLCB))+(BIN_WL*pModel->PPDIBLCB));
EXIT_IF_ISNAN((((pModel->PDIBLCB+(BIN_L*pModel->LPDIBLCB))+(BIN_W*pModel->WPDIBLCB))+(BIN_WL*pModel->PPDIBLCB)))
PSCBE1_i=(((pModel->PSCBE1+(BIN_L*pModel->LPSCBE1))+(BIN_W*pModel->WPSCBE1))+(BIN_WL*pModel->PPSCBE1));
EXIT_IF_ISNAN((((pModel->PSCBE1+(BIN_L*pModel->LPSCBE1))+(BIN_W*pModel->WPSCBE1))+(BIN_WL*pModel->PPSCBE1)))
PSCBE2_i=(((pModel->PSCBE2+(BIN_L*pModel->LPSCBE2))+(BIN_W*pModel->WPSCBE2))+(BIN_WL*pModel->PPSCBE2));
EXIT_IF_ISNAN((((pModel->PSCBE2+(BIN_L*pModel->LPSCBE2))+(BIN_W*pModel->WPSCBE2))+(BIN_WL*pModel->PPSCBE2)))
PDITS_i=(((pModel->PDITS+(BIN_L*pModel->LPDITS))+(BIN_W*pModel->WPDITS))+(BIN_WL*pModel->PPDITS));
EXIT_IF_ISNAN((((pModel->PDITS+(BIN_L*pModel->LPDITS))+(BIN_W*pModel->WPDITS))+(BIN_WL*pModel->PPDITS)))
PDITSD_i=(((pModel->PDITSD+(BIN_L*pModel->LPDITSD))+(BIN_W*pModel->WPDITSD))+(BIN_WL*pModel->PPDITSD));
EXIT_IF_ISNAN((((pModel->PDITSD+(BIN_L*pModel->LPDITSD))+(BIN_W*pModel->WPDITSD))+(BIN_WL*pModel->PPDITSD)))
FPROUT_i=(((pModel->FPROUT+(BIN_L*pModel->LFPROUT))+(BIN_W*pModel->WFPROUT))+(BIN_WL*pModel->PFPROUT));
EXIT_IF_ISNAN((((pModel->FPROUT+(BIN_L*pModel->LFPROUT))+(BIN_W*pModel->WFPROUT))+(BIN_WL*pModel->PFPROUT)))
PVAG_i=(((pModel->PVAG+(BIN_L*pModel->LPVAG))+(BIN_W*pModel->WPVAG))+(BIN_WL*pModel->PPVAG));
EXIT_IF_ISNAN((((pModel->PVAG+(BIN_L*pModel->LPVAG))+(BIN_W*pModel->WPVAG))+(BIN_WL*pModel->PPVAG)))
VSAT_i=(((pModel->VSAT+(BIN_L*pModel->LVSAT))+(BIN_W*pModel->WVSAT))+(BIN_WL*pModel->PVSAT));
EXIT_IF_ISNAN((((pModel->VSAT+(BIN_L*pModel->LVSAT))+(BIN_W*pModel->WVSAT))+(BIN_WL*pModel->PVSAT)))
PSAT_i=(((pModel->PSAT+(BIN_L*pModel->LPSAT))+(BIN_W*pModel->WPSAT))+(BIN_WL*pModel->PPSAT));
EXIT_IF_ISNAN((((pModel->PSAT+(BIN_L*pModel->LPSAT))+(BIN_W*pModel->WPSAT))+(BIN_WL*pModel->PPSAT)))
VSATCV_i=(((pModel->VSATCV+(BIN_L*pModel->LVSATCV))+(BIN_W*pModel->WVSATCV))+(BIN_WL*pModel->PVSATCV));
EXIT_IF_ISNAN((((pModel->VSATCV+(BIN_L*pModel->LVSATCV))+(BIN_W*pModel->WVSATCV))+(BIN_WL*pModel->PVSATCV)))
#if defined(_DYNAMIC)
CF_i=(((pModel->CF+(BIN_L*pModel->LCF))+(BIN_W*pModel->WCF))+(BIN_WL*pModel->PCF));
EXIT_IF_ISNAN((((pModel->CF+(BIN_L*pModel->LCF))+(BIN_W*pModel->WCF))+(BIN_WL*pModel->PCF)))
#endif
#if defined(_DYNAMIC)
CGSL_i=(((pModel->CGSL+(BIN_L*pModel->LCGSL))+(BIN_W*pModel->WCGSL))+(BIN_WL*pModel->PCGSL));
EXIT_IF_ISNAN((((pModel->CGSL+(BIN_L*pModel->LCGSL))+(BIN_W*pModel->WCGSL))+(BIN_WL*pModel->PCGSL)))
#endif
#if defined(_DYNAMIC)
CGDL_i=(((pModel->CGDL+(BIN_L*pModel->LCGDL))+(BIN_W*pModel->WCGDL))+(BIN_WL*pModel->PCGDL));
EXIT_IF_ISNAN((((pModel->CGDL+(BIN_L*pModel->LCGDL))+(BIN_W*pModel->WCGDL))+(BIN_WL*pModel->PCGDL)))
#endif
CKAPPAS_i=(((pModel->CKAPPAS+(BIN_L*pModel->LCKAPPAS))+(BIN_W*pModel->WCKAPPAS))+(BIN_WL*pModel->PCKAPPAS));
EXIT_IF_ISNAN((((pModel->CKAPPAS+(BIN_L*pModel->LCKAPPAS))+(BIN_W*pModel->WCKAPPAS))+(BIN_WL*pModel->PCKAPPAS)))
CKAPPAD_i=(((pModel->CKAPPAD+(BIN_L*pModel->LCKAPPAD))+(BIN_W*pModel->WCKAPPAD))+(BIN_WL*pModel->PCKAPPAD));
EXIT_IF_ISNAN((((pModel->CKAPPAD+(BIN_L*pModel->LCKAPPAD))+(BIN_W*pModel->WCKAPPAD))+(BIN_WL*pModel->PCKAPPAD)))
ALPHA0_i=(((pModel->ALPHA0+(BIN_L*pModel->LALPHA0))+(BIN_W*pModel->WALPHA0))+(BIN_WL*pModel->PALPHA0));
EXIT_IF_ISNAN((((pModel->ALPHA0+(BIN_L*pModel->LALPHA0))+(BIN_W*pModel->WALPHA0))+(BIN_WL*pModel->PALPHA0)))
BETA0_i=(((pModel->BETA0+(BIN_L*pModel->LBETA0))+(BIN_W*pModel->WBETA0))+(BIN_WL*pModel->PBETA0));
EXIT_IF_ISNAN((((pModel->BETA0+(BIN_L*pModel->LBETA0))+(BIN_W*pModel->WBETA0))+(BIN_WL*pModel->PBETA0)))
KVTH0WE_i=(((pModel->KVTH0WE+(BIN_L*pModel->LKVTH0WE))+(BIN_W*pModel->WKVTH0WE))+(BIN_WL*pModel->PKVTH0WE));
EXIT_IF_ISNAN((((pModel->KVTH0WE+(BIN_L*pModel->LKVTH0WE))+(BIN_W*pModel->WKVTH0WE))+(BIN_WL*pModel->PKVTH0WE)))
K2WE_i=(((pModel->K2WE+(BIN_L*pModel->LK2WE))+(BIN_W*pModel->WK2WE))+(BIN_WL*pModel->PK2WE));
EXIT_IF_ISNAN((((pModel->K2WE+(BIN_L*pModel->LK2WE))+(BIN_W*pModel->WK2WE))+(BIN_WL*pModel->PK2WE)))
KU0WE_i=(((pModel->KU0WE+(BIN_L*pModel->LKU0WE))+(BIN_W*pModel->WKU0WE))+(BIN_WL*pModel->PKU0WE));
EXIT_IF_ISNAN((((pModel->KU0WE+(BIN_L*pModel->LKU0WE))+(BIN_W*pModel->WKU0WE))+(BIN_WL*pModel->PKU0WE)))
AGIDL_i=(((pModel->AGIDL+(BIN_L*pModel->LAGIDL))+(BIN_W*pModel->WAGIDL))+(BIN_WL*pModel->PAGIDL));
EXIT_IF_ISNAN((((pModel->AGIDL+(BIN_L*pModel->LAGIDL))+(BIN_W*pModel->WAGIDL))+(BIN_WL*pModel->PAGIDL)))
BGIDL_i=(((pModel->BGIDL+(BIN_L*pModel->LBGIDL))+(BIN_W*pModel->WBGIDL))+(BIN_WL*pModel->PBGIDL));
EXIT_IF_ISNAN((((pModel->BGIDL+(BIN_L*pModel->LBGIDL))+(BIN_W*pModel->WBGIDL))+(BIN_WL*pModel->PBGIDL)))
CGIDL_i=(((pModel->CGIDL+(BIN_L*pModel->LCGIDL))+(BIN_W*pModel->WCGIDL))+(BIN_WL*pModel->PCGIDL));
EXIT_IF_ISNAN((((pModel->CGIDL+(BIN_L*pModel->LCGIDL))+(BIN_W*pModel->WCGIDL))+(BIN_WL*pModel->PCGIDL)))
EGIDL_i=(((pModel->EGIDL+(BIN_L*pModel->LEGIDL))+(BIN_W*pModel->WEGIDL))+(BIN_WL*pModel->PEGIDL));
EXIT_IF_ISNAN((((pModel->EGIDL+(BIN_L*pModel->LEGIDL))+(BIN_W*pModel->WEGIDL))+(BIN_WL*pModel->PEGIDL)))
AGISL_i=(((pModel->AGISL+(BIN_L*pModel->LAGISL))+(BIN_W*pModel->WAGISL))+(BIN_WL*pModel->PAGISL));
EXIT_IF_ISNAN((((pModel->AGISL+(BIN_L*pModel->LAGISL))+(BIN_W*pModel->WAGISL))+(BIN_WL*pModel->PAGISL)))
BGISL_i=(((pModel->BGISL+(BIN_L*pModel->LBGISL))+(BIN_W*pModel->WBGISL))+(BIN_WL*pModel->PBGISL));
EXIT_IF_ISNAN((((pModel->BGISL+(BIN_L*pModel->LBGISL))+(BIN_W*pModel->WBGISL))+(BIN_WL*pModel->PBGISL)))
CGISL_i=(((pModel->CGISL+(BIN_L*pModel->LCGISL))+(BIN_W*pModel->WCGISL))+(BIN_WL*pModel->PCGISL));
EXIT_IF_ISNAN((((pModel->CGISL+(BIN_L*pModel->LCGISL))+(BIN_W*pModel->WCGISL))+(BIN_WL*pModel->PCGISL)))
EGISL_i=(((pModel->EGISL+(BIN_L*pModel->LEGISL))+(BIN_W*pModel->WEGISL))+(BIN_WL*pModel->PEGISL));
EXIT_IF_ISNAN((((pModel->EGISL+(BIN_L*pModel->LEGISL))+(BIN_W*pModel->WEGISL))+(BIN_WL*pModel->PEGISL)))
UTE_i=(((pModel->UTE+(BIN_L*pModel->LUTE))+(BIN_W*pModel->WUTE))+(BIN_WL*pModel->PUTE));
EXIT_IF_ISNAN((((pModel->UTE+(BIN_L*pModel->LUTE))+(BIN_W*pModel->WUTE))+(BIN_WL*pModel->PUTE)))
UA1_i=(((pModel->UA1+(BIN_L*pModel->LUA1))+(BIN_W*pModel->WUA1))+(BIN_WL*pModel->PUA1));
EXIT_IF_ISNAN((((pModel->UA1+(BIN_L*pModel->LUA1))+(BIN_W*pModel->WUA1))+(BIN_WL*pModel->PUA1)))
UC1_i=(((pModel->UC1+(BIN_L*pModel->LUC1))+(BIN_W*pModel->WUC1))+(BIN_WL*pModel->PUC1));
EXIT_IF_ISNAN((((pModel->UC1+(BIN_L*pModel->LUC1))+(BIN_W*pModel->WUC1))+(BIN_WL*pModel->PUC1)))
UD1_i=(((pModel->UD1+(BIN_L*pModel->LUD1))+(BIN_W*pModel->WUD1))+(BIN_WL*pModel->PUD1));
EXIT_IF_ISNAN((((pModel->UD1+(BIN_L*pModel->LUD1))+(BIN_W*pModel->WUD1))+(BIN_WL*pModel->PUD1)))
UCSTE_i=(((pModel->UCSTE+(BIN_L*pModel->LUCSTE))+(BIN_W*pModel->WUCSTE))+(BIN_WL*pModel->PUCSTE));
EXIT_IF_ISNAN((((pModel->UCSTE+(BIN_L*pModel->LUCSTE))+(BIN_W*pModel->WUCSTE))+(BIN_WL*pModel->PUCSTE)))
PRT_i=(((pModel->PRT+(BIN_L*pModel->LPRT))+(BIN_W*pModel->WPRT))+(BIN_WL*pModel->PPRT));
EXIT_IF_ISNAN((((pModel->PRT+(BIN_L*pModel->LPRT))+(BIN_W*pModel->WPRT))+(BIN_WL*pModel->PPRT)))
AT_i=(((pModel->AT+(BIN_L*pModel->LAT))+(BIN_W*pModel->WAT))+(BIN_WL*pModel->PAT));
EXIT_IF_ISNAN((((pModel->AT+(BIN_L*pModel->LAT))+(BIN_W*pModel->WAT))+(BIN_WL*pModel->PAT)))
PTWGT_i=(((pModel->PTWGT+(BIN_L*pModel->LPTWGT))+(BIN_W*pModel->WPTWGT))+(BIN_WL*pModel->PPTWGT));
EXIT_IF_ISNAN((((pModel->PTWGT+(BIN_L*pModel->LPTWGT))+(BIN_W*pModel->WPTWGT))+(BIN_WL*pModel->PPTWGT)))
IIT_i=(((pModel->IIT+(BIN_L*pModel->LIIT))+(BIN_W*pModel->WIIT))+(BIN_WL*pModel->PIIT));
EXIT_IF_ISNAN((((pModel->IIT+(BIN_L*pModel->LIIT))+(BIN_W*pModel->WIIT))+(BIN_WL*pModel->PIIT)))
TGIDL_i=(((pModel->TGIDL+(BIN_L*pModel->LTGIDL))+(BIN_W*pModel->WTGIDL))+(BIN_WL*pModel->PTGIDL));
EXIT_IF_ISNAN((((pModel->TGIDL+(BIN_L*pModel->LTGIDL))+(BIN_W*pModel->WTGIDL))+(BIN_WL*pModel->PTGIDL)))
IGT_i=(((pModel->IGT+(BIN_L*pModel->LIGT))+(BIN_W*pModel->WIGT))+(BIN_WL*pModel->PIGT));
EXIT_IF_ISNAN((((pModel->IGT+(BIN_L*pModel->LIGT))+(BIN_W*pModel->WIGT))+(BIN_WL*pModel->PIGT)))
AIGBINV_i=(((pModel->AIGBINV+(BIN_L*pModel->LAIGBINV))+(BIN_W*pModel->WAIGBINV))+(BIN_WL*pModel->PAIGBINV));
EXIT_IF_ISNAN((((pModel->AIGBINV+(BIN_L*pModel->LAIGBINV))+(BIN_W*pModel->WAIGBINV))+(BIN_WL*pModel->PAIGBINV)))
BIGBINV_i=(((pModel->BIGBINV+(BIN_L*pModel->LBIGBINV))+(BIN_W*pModel->WBIGBINV))+(BIN_WL*pModel->PBIGBINV));
EXIT_IF_ISNAN((((pModel->BIGBINV+(BIN_L*pModel->LBIGBINV))+(BIN_W*pModel->WBIGBINV))+(BIN_WL*pModel->PBIGBINV)))
CIGBINV_i=(((pModel->CIGBINV+(BIN_L*pModel->LCIGBINV))+(BIN_W*pModel->WCIGBINV))+(BIN_WL*pModel->PCIGBINV));
EXIT_IF_ISNAN((((pModel->CIGBINV+(BIN_L*pModel->LCIGBINV))+(BIN_W*pModel->WCIGBINV))+(BIN_WL*pModel->PCIGBINV)))
EIGBINV_i=(((pModel->EIGBINV+(BIN_L*pModel->LEIGBINV))+(BIN_W*pModel->WEIGBINV))+(BIN_WL*pModel->PEIGBINV));
EXIT_IF_ISNAN((((pModel->EIGBINV+(BIN_L*pModel->LEIGBINV))+(BIN_W*pModel->WEIGBINV))+(BIN_WL*pModel->PEIGBINV)))
NIGBINV_i=(((pModel->NIGBINV+(BIN_L*pModel->LNIGBINV))+(BIN_W*pModel->WNIGBINV))+(BIN_WL*pModel->PNIGBINV));
EXIT_IF_ISNAN((((pModel->NIGBINV+(BIN_L*pModel->LNIGBINV))+(BIN_W*pModel->WNIGBINV))+(BIN_WL*pModel->PNIGBINV)))
AIGBACC_i=(((pModel->AIGBACC+(BIN_L*pModel->LAIGBACC))+(BIN_W*pModel->WAIGBACC))+(BIN_WL*pModel->PAIGBACC));
EXIT_IF_ISNAN((((pModel->AIGBACC+(BIN_L*pModel->LAIGBACC))+(BIN_W*pModel->WAIGBACC))+(BIN_WL*pModel->PAIGBACC)))
BIGBACC_i=(((pModel->BIGBACC+(BIN_L*pModel->LBIGBACC))+(BIN_W*pModel->WBIGBACC))+(BIN_WL*pModel->PBIGBACC));
EXIT_IF_ISNAN((((pModel->BIGBACC+(BIN_L*pModel->LBIGBACC))+(BIN_W*pModel->WBIGBACC))+(BIN_WL*pModel->PBIGBACC)))
CIGBACC_i=(((pModel->CIGBACC+(BIN_L*pModel->LCIGBACC))+(BIN_W*pModel->WCIGBACC))+(BIN_WL*pModel->PCIGBACC));
EXIT_IF_ISNAN((((pModel->CIGBACC+(BIN_L*pModel->LCIGBACC))+(BIN_W*pModel->WCIGBACC))+(BIN_WL*pModel->PCIGBACC)))
NIGBACC_i=(((pModel->NIGBACC+(BIN_L*pModel->LNIGBACC))+(BIN_W*pModel->WNIGBACC))+(BIN_WL*pModel->PNIGBACC));
EXIT_IF_ISNAN((((pModel->NIGBACC+(BIN_L*pModel->LNIGBACC))+(BIN_W*pModel->WNIGBACC))+(BIN_WL*pModel->PNIGBACC)))
AIGC_i=(((pModel->AIGC+(BIN_L*pModel->LAIGC))+(BIN_W*pModel->WAIGC))+(BIN_WL*pModel->PAIGC));
EXIT_IF_ISNAN((((pModel->AIGC+(BIN_L*pModel->LAIGC))+(BIN_W*pModel->WAIGC))+(BIN_WL*pModel->PAIGC)))
BIGC_i=(((pModel->BIGC+(BIN_L*pModel->LBIGC))+(BIN_W*pModel->WBIGC))+(BIN_WL*pModel->PBIGC));
EXIT_IF_ISNAN((((pModel->BIGC+(BIN_L*pModel->LBIGC))+(BIN_W*pModel->WBIGC))+(BIN_WL*pModel->PBIGC)))
CIGC_i=(((pModel->CIGC+(BIN_L*pModel->LCIGC))+(BIN_W*pModel->WCIGC))+(BIN_WL*pModel->PCIGC));
EXIT_IF_ISNAN((((pModel->CIGC+(BIN_L*pModel->LCIGC))+(BIN_W*pModel->WCIGC))+(BIN_WL*pModel->PCIGC)))
AIGS_i=(((pModel->AIGS+(BIN_L*pModel->LAIGS))+(BIN_W*pModel->WAIGS))+(BIN_WL*pModel->PAIGS));
EXIT_IF_ISNAN((((pModel->AIGS+(BIN_L*pModel->LAIGS))+(BIN_W*pModel->WAIGS))+(BIN_WL*pModel->PAIGS)))
BIGS_i=(((pModel->BIGS+(BIN_L*pModel->LBIGS))+(BIN_W*pModel->WBIGS))+(BIN_WL*pModel->PBIGS));
EXIT_IF_ISNAN((((pModel->BIGS+(BIN_L*pModel->LBIGS))+(BIN_W*pModel->WBIGS))+(BIN_WL*pModel->PBIGS)))
CIGS_i=(((pModel->CIGS+(BIN_L*pModel->LCIGS))+(BIN_W*pModel->WCIGS))+(BIN_WL*pModel->PCIGS));
EXIT_IF_ISNAN((((pModel->CIGS+(BIN_L*pModel->LCIGS))+(BIN_W*pModel->WCIGS))+(BIN_WL*pModel->PCIGS)))
AIGD_i=(((pModel->AIGD+(BIN_L*pModel->LAIGD))+(BIN_W*pModel->WAIGD))+(BIN_WL*pModel->PAIGD));
EXIT_IF_ISNAN((((pModel->AIGD+(BIN_L*pModel->LAIGD))+(BIN_W*pModel->WAIGD))+(BIN_WL*pModel->PAIGD)))
BIGD_i=(((pModel->BIGD+(BIN_L*pModel->LBIGD))+(BIN_W*pModel->WBIGD))+(BIN_WL*pModel->PBIGD));
EXIT_IF_ISNAN((((pModel->BIGD+(BIN_L*pModel->LBIGD))+(BIN_W*pModel->WBIGD))+(BIN_WL*pModel->PBIGD)))
CIGD_i=(((pModel->CIGD+(BIN_L*pModel->LCIGD))+(BIN_W*pModel->WCIGD))+(BIN_WL*pModel->PCIGD));
EXIT_IF_ISNAN((((pModel->CIGD+(BIN_L*pModel->LCIGD))+(BIN_W*pModel->WCIGD))+(BIN_WL*pModel->PCIGD)))
POXEDGE_i=(((pModel->POXEDGE+(BIN_L*pModel->LPOXEDGE))+(BIN_W*pModel->WPOXEDGE))+(BIN_WL*pModel->PPOXEDGE));
EXIT_IF_ISNAN((((pModel->POXEDGE+(BIN_L*pModel->LPOXEDGE))+(BIN_W*pModel->WPOXEDGE))+(BIN_WL*pModel->PPOXEDGE)))
DLCIG_i=(((pModel->DLCIG+(BIN_L*pModel->LDLCIG))+(BIN_W*pModel->WDLCIG))+(BIN_WL*pModel->PDLCIG));
EXIT_IF_ISNAN((((pModel->DLCIG+(BIN_L*pModel->LDLCIG))+(BIN_W*pModel->WDLCIG))+(BIN_WL*pModel->PDLCIG)))
DLCIGD_i=(((pModel->DLCIGD+(BIN_L*pModel->LDLCIGD))+(BIN_W*pModel->WDLCIGD))+(BIN_WL*pModel->PDLCIGD));
EXIT_IF_ISNAN((((pModel->DLCIGD+(BIN_L*pModel->LDLCIGD))+(BIN_W*pModel->WDLCIGD))+(BIN_WL*pModel->PDLCIGD)))
NTOX_i=(((pModel->NTOX+(BIN_L*pModel->LNTOX))+(BIN_W*pModel->WNTOX))+(BIN_WL*pModel->PNTOX));
EXIT_IF_ISNAN((((pModel->NTOX+(BIN_L*pModel->LNTOX))+(BIN_W*pModel->WNTOX))+(BIN_WL*pModel->PNTOX)))
KT1_i=(((pModel->KT1+(BIN_L*pModel->LKT1))+(BIN_W*pModel->WKT1))+(BIN_WL*pModel->PKT1));
EXIT_IF_ISNAN((((pModel->KT1+(BIN_L*pModel->LKT1))+(BIN_W*pModel->WKT1))+(BIN_WL*pModel->PKT1)))
KT2_i=(((pModel->KT2+(BIN_L*pModel->LKT2))+(BIN_W*pModel->WKT2))+(BIN_WL*pModel->PKT2));
EXIT_IF_ISNAN((((pModel->KT2+(BIN_L*pModel->LKT2))+(BIN_W*pModel->WKT2))+(BIN_WL*pModel->PKT2)))
PSATB_i=(((pModel->PSATB+(BIN_L*pModel->LPSATB))+(BIN_W*pModel->WPSATB))+(BIN_WL*pModel->PPSATB));
EXIT_IF_ISNAN((((pModel->PSATB+(BIN_L*pModel->LPSATB))+(BIN_W*pModel->WPSATB))+(BIN_WL*pModel->PPSATB)))
A1_i=(((pModel->A1+(BIN_L*pModel->LA1))+(BIN_W*pModel->WA1))+(BIN_WL*pModel->PA1));
EXIT_IF_ISNAN((((pModel->A1+(BIN_L*pModel->LA1))+(BIN_W*pModel->WA1))+(BIN_WL*pModel->PA1)))
A11_i=(((pModel->A11+(BIN_L*pModel->LA11))+(BIN_W*pModel->WA11))+(BIN_WL*pModel->PA11));
EXIT_IF_ISNAN((((pModel->A11+(BIN_L*pModel->LA11))+(BIN_W*pModel->WA11))+(BIN_WL*pModel->PA11)))
A2_i=(((pModel->A2+(BIN_L*pModel->LA2))+(BIN_W*pModel->WA2))+(BIN_WL*pModel->PA2));
EXIT_IF_ISNAN((((pModel->A2+(BIN_L*pModel->LA2))+(BIN_W*pModel->WA2))+(BIN_WL*pModel->PA2)))
A21_i=(((pModel->A21+(BIN_L*pModel->LA21))+(BIN_W*pModel->WA21))+(BIN_WL*pModel->PA21));
EXIT_IF_ISNAN((((pModel->A21+(BIN_L*pModel->LA21))+(BIN_W*pModel->WA21))+(BIN_WL*pModel->PA21)))
K0_i=(((pModel->K0+(BIN_L*pModel->LK0))+(BIN_W*pModel->WK0))+(BIN_WL*pModel->PK0));
EXIT_IF_ISNAN((((pModel->K0+(BIN_L*pModel->LK0))+(BIN_W*pModel->WK0))+(BIN_WL*pModel->PK0)))
M0_i=(((pModel->M0+(BIN_L*pModel->LM0))+(BIN_W*pModel->WM0))+(BIN_WL*pModel->PM0));
EXIT_IF_ISNAN((((pModel->M0+(BIN_L*pModel->LM0))+(BIN_W*pModel->WM0))+(BIN_WL*pModel->PM0)))
K01_i=(((pModel->K01+(BIN_L*pModel->LK01))+(BIN_W*pModel->WK01))+(BIN_WL*pModel->PK01));
EXIT_IF_ISNAN((((pModel->K01+(BIN_L*pModel->LK01))+(BIN_W*pModel->WK01))+(BIN_WL*pModel->PK01)))
M01_i=(((pModel->M01+(BIN_L*pModel->LM01))+(BIN_W*pModel->WM01))+(BIN_WL*pModel->PM01));
EXIT_IF_ISNAN((((pModel->M01+(BIN_L*pModel->LM01))+(BIN_W*pModel->WM01))+(BIN_WL*pModel->PM01)))
NFACTOREDGE_i=(((pModel->NFACTOREDGE+(BIN_L*pModel->LNFACTOREDGE))+(BIN_W*pModel->WNFACTOREDGE))+(BIN_WL*pModel->PNFACTOREDGE));
EXIT_IF_ISNAN((((pModel->NFACTOREDGE+(BIN_L*pModel->LNFACTOREDGE))+(BIN_W*pModel->WNFACTOREDGE))+(BIN_WL*pModel->PNFACTOREDGE)))
CITEDGE_i=(((pModel->CITEDGE+(BIN_L*pModel->LCITEDGE))+(BIN_W*pModel->WCITEDGE))+(BIN_WL*pModel->PCITEDGE));
EXIT_IF_ISNAN((((pModel->CITEDGE+(BIN_L*pModel->LCITEDGE))+(BIN_W*pModel->WCITEDGE))+(BIN_WL*pModel->PCITEDGE)))
CDSCDEDGE_i=(((pModel->CDSCDEDGE+(BIN_L*pModel->LCDSCDEDGE))+(BIN_W*pModel->WCDSCDEDGE))+(BIN_WL*pModel->PCDSCDEDGE));
EXIT_IF_ISNAN((((pModel->CDSCDEDGE+(BIN_L*pModel->LCDSCDEDGE))+(BIN_W*pModel->WCDSCDEDGE))+(BIN_WL*pModel->PCDSCDEDGE)))
CDSCBEDGE_i=(((pModel->CDSCBEDGE+(BIN_L*pModel->LCDSCBEDGE))+(BIN_W*pModel->WCDSCBEDGE))+(BIN_WL*pModel->PCDSCBEDGE));
EXIT_IF_ISNAN((((pModel->CDSCBEDGE+(BIN_L*pModel->LCDSCBEDGE))+(BIN_W*pModel->WCDSCBEDGE))+(BIN_WL*pModel->PCDSCBEDGE)))
ETA0EDGE_i=(((pModel->ETA0EDGE+(BIN_L*pModel->LETA0EDGE))+(BIN_W*pModel->WETA0EDGE))+(BIN_WL*pModel->PETA0EDGE));
EXIT_IF_ISNAN((((pModel->ETA0EDGE+(BIN_L*pModel->LETA0EDGE))+(BIN_W*pModel->WETA0EDGE))+(BIN_WL*pModel->PETA0EDGE)))
ETABEDGE_i=(((pModel->ETABEDGE+(BIN_L*pModel->LETABEDGE))+(BIN_W*pModel->WETABEDGE))+(BIN_WL*pModel->PETABEDGE));
EXIT_IF_ISNAN((((pModel->ETABEDGE+(BIN_L*pModel->LETABEDGE))+(BIN_W*pModel->WETABEDGE))+(BIN_WL*pModel->PETABEDGE)))
KT1EDGE_i=(((pModel->KT1EDGE+(BIN_L*pModel->LKT1EDGE))+(BIN_W*pModel->WKT1EDGE))+(BIN_WL*pModel->PKT1EDGE));
EXIT_IF_ISNAN((((pModel->KT1EDGE+(BIN_L*pModel->LKT1EDGE))+(BIN_W*pModel->WKT1EDGE))+(BIN_WL*pModel->PKT1EDGE)))
KT1LEDGE_i=(((pModel->KT1LEDGE+(BIN_L*pModel->LKT1LEDGE))+(BIN_W*pModel->WKT1LEDGE))+(BIN_WL*pModel->PKT1LEDGE));
EXIT_IF_ISNAN((((pModel->KT1LEDGE+(BIN_L*pModel->LKT1LEDGE))+(BIN_W*pModel->WKT1LEDGE))+(BIN_WL*pModel->PKT1LEDGE)))
KT2EDGE_i=(((pModel->KT2EDGE+(BIN_L*pModel->LKT2EDGE))+(BIN_W*pModel->WKT2EDGE))+(BIN_WL*pModel->PKT2EDGE));
EXIT_IF_ISNAN((((pModel->KT2EDGE+(BIN_L*pModel->LKT2EDGE))+(BIN_W*pModel->WKT2EDGE))+(BIN_WL*pModel->PKT2EDGE)))
KT1EXPEDGE_i=(((pModel->KT1EXPEDGE+(BIN_L*pModel->LKT1EXPEDGE))+(BIN_W*pModel->WKT1EXPEDGE))+(BIN_WL*pModel->PKT1EXPEDGE));
EXIT_IF_ISNAN((((pModel->KT1EXPEDGE+(BIN_L*pModel->LKT1EXPEDGE))+(BIN_W*pModel->WKT1EXPEDGE))+(BIN_WL*pModel->PKT1EXPEDGE)))
TNFACTOREDGE_i=(((pModel->TNFACTOREDGE+(BIN_L*pModel->LTNFACTOREDGE))+(BIN_W*pModel->WTNFACTOREDGE))+(BIN_WL*pModel->PTNFACTOREDGE));
EXIT_IF_ISNAN((((pModel->TNFACTOREDGE+(BIN_L*pModel->LTNFACTOREDGE))+(BIN_W*pModel->WTNFACTOREDGE))+(BIN_WL*pModel->PTNFACTOREDGE)))
TETA0EDGE_i=(((pModel->TETA0EDGE+(BIN_L*pModel->LTETA0EDGE))+(BIN_W*pModel->WTETA0EDGE))+(BIN_WL*pModel->PTETA0EDGE));
EXIT_IF_ISNAN((((pModel->TETA0EDGE+(BIN_L*pModel->LTETA0EDGE))+(BIN_W*pModel->WTETA0EDGE))+(BIN_WL*pModel->PTETA0EDGE)))
K2EDGE_i=(((pModel->K2EDGE+(BIN_L*pModel->LK2EDGE))+(BIN_W*pModel->WK2EDGE))+(BIN_WL*pModel->PK2EDGE));
EXIT_IF_ISNAN((((pModel->K2EDGE+(BIN_L*pModel->LK2EDGE))+(BIN_W*pModel->WK2EDGE))+(BIN_WL*pModel->PK2EDGE)))
KVTH0EDGE_i=(((pModel->KVTH0EDGE+(BIN_L*pModel->LKVTH0EDGE))+(BIN_W*pModel->WKVTH0EDGE))+(BIN_WL*pModel->PKVTH0EDGE));
EXIT_IF_ISNAN((((pModel->KVTH0EDGE+(BIN_L*pModel->LKVTH0EDGE))+(BIN_W*pModel->WKVTH0EDGE))+(BIN_WL*pModel->PKVTH0EDGE)))
STK2EDGE_i=(((pModel->STK2EDGE+(BIN_L*pModel->LSTK2EDGE))+(BIN_W*pModel->WSTK2EDGE))+(BIN_WL*pModel->PSTK2EDGE));
EXIT_IF_ISNAN((((pModel->STK2EDGE+(BIN_L*pModel->LSTK2EDGE))+(BIN_W*pModel->WSTK2EDGE))+(BIN_WL*pModel->PSTK2EDGE)))
STETA0EDGE_i=(((pModel->STETA0EDGE+(BIN_L*pModel->LSTETA0EDGE))+(BIN_W*pModel->WSTETA0EDGE))+(BIN_WL*pModel->PSTETA0EDGE));
EXIT_IF_ISNAN((((pModel->STETA0EDGE+(BIN_L*pModel->LSTETA0EDGE))+(BIN_W*pModel->WSTETA0EDGE))+(BIN_WL*pModel->PSTETA0EDGE)))
if
((pModel->ASYMMOD!=0))
{
CDSCDR_i=(((pModel->CDSCDR+(BIN_L*pModel->LCDSCDR))+(BIN_W*pModel->WCDSCDR))+(BIN_WL*pModel->PCDSCDR));
EXIT_IF_ISNAN((((pModel->CDSCDR+(BIN_L*pModel->LCDSCDR))+(BIN_W*pModel->WCDSCDR))+(BIN_WL*pModel->PCDSCDR)))
ETA0R_i=(((pModel->ETA0R+(BIN_L*pModel->LETA0R))+(BIN_W*pModel->WETA0R))+(BIN_WL*pModel->PETA0R));
EXIT_IF_ISNAN((((pModel->ETA0R+(BIN_L*pModel->LETA0R))+(BIN_W*pModel->WETA0R))+(BIN_WL*pModel->PETA0R)))
U0R_i=(((pModel->U0R+(BIN_L*pModel->LU0R))+(BIN_W*pModel->WU0R))+(BIN_WL*pModel->PU0R));
EXIT_IF_ISNAN((((pModel->U0R+(BIN_L*pModel->LU0R))+(BIN_W*pModel->WU0R))+(BIN_WL*pModel->PU0R)))
UAR_i=(((pModel->UAR+(BIN_L*pModel->LUAR))+(BIN_W*pModel->WUAR))+(BIN_WL*pModel->PUAR));
EXIT_IF_ISNAN((((pModel->UAR+(BIN_L*pModel->LUAR))+(BIN_W*pModel->WUAR))+(BIN_WL*pModel->PUAR)))
UDR_i=(((pModel->UDR+(BIN_L*pModel->LUDR))+(BIN_W*pModel->WUDR))+(BIN_WL*pModel->PUDR));
EXIT_IF_ISNAN((((pModel->UDR+(BIN_L*pModel->LUDR))+(BIN_W*pModel->WUDR))+(BIN_WL*pModel->PUDR)))
UCSR_i=(((pModel->UCSR+(BIN_L*pModel->LUCSR))+(BIN_W*pModel->WUCSR))+(BIN_WL*pModel->PUCSR));
EXIT_IF_ISNAN((((pModel->UCSR+(BIN_L*pModel->LUCSR))+(BIN_W*pModel->WUCSR))+(BIN_WL*pModel->PUCSR)))
UCR_i=(((pModel->UCR+(BIN_L*pModel->LUCR))+(BIN_W*pModel->WUCR))+(BIN_WL*pModel->PUCR));
EXIT_IF_ISNAN((((pModel->UCR+(BIN_L*pModel->LUCR))+(BIN_W*pModel->WUCR))+(BIN_WL*pModel->PUCR)))
PCLMR_i=(((pModel->PCLMR+(BIN_L*pModel->LPCLMR))+(BIN_W*pModel->WPCLMR))+(BIN_WL*pModel->PPCLMR));
EXIT_IF_ISNAN((((pModel->PCLMR+(BIN_L*pModel->LPCLMR))+(BIN_W*pModel->WPCLMR))+(BIN_WL*pModel->PPCLMR)))
PDIBLCR_i=(((pModel->PDIBLCR+(BIN_L*pModel->LPDIBLCR))+(BIN_W*pModel->WPDIBLCR))+(BIN_WL*pModel->PPDIBLCR));
EXIT_IF_ISNAN((((pModel->PDIBLCR+(BIN_L*pModel->LPDIBLCR))+(BIN_W*pModel->WPDIBLCR))+(BIN_WL*pModel->PPDIBLCR)))
VSATR_i=(((pModel->VSATR+(BIN_L*pModel->LVSATR))+(BIN_W*pModel->WVSATR))+(BIN_WL*pModel->PVSATR));
EXIT_IF_ISNAN((((pModel->VSATR+(BIN_L*pModel->LVSATR))+(BIN_W*pModel->WVSATR))+(BIN_WL*pModel->PVSATR)))
PSATR_i=(((pModel->PSATR+(BIN_L*pModel->LPSATR))+(BIN_W*pModel->WPSATR))+(BIN_WL*pModel->PPSATR));
EXIT_IF_ISNAN((((pModel->PSATR+(BIN_L*pModel->LPSATR))+(BIN_W*pModel->WPSATR))+(BIN_WL*pModel->PPSATR)))
PTWGR_i=(((pModel->PTWGR+(BIN_L*pModel->LPTWGR))+(BIN_W*pModel->WPTWGR))+(BIN_WL*pModel->PPTWGR));
EXIT_IF_ISNAN((((pModel->PTWGR+(BIN_L*pModel->LPTWGR))+(BIN_W*pModel->WPTWGR))+(BIN_WL*pModel->PPTWGR)))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->NDEPLEXP1)
double m00_pow(d00_pow1,Inv_Llong,pModel->NDEPLEXP1)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_L,pModel->NDEPLEXP2)
double m00_pow(d00_pow4,Inv_Llong,pModel->NDEPLEXP2)
double m00_max(d00_max5,(d00_pow3-d00_pow4),0.0)
T0y=((pModel->NDEPL1*d00_max2)+(pModel->NDEPL2*d00_max5));
EXIT_IF_ISNAN(((pModel->NDEPL1*d00_max2)+(pModel->NDEPL2*d00_max5)))
}
{
double m00_pow(d00_pow0,Inv_W,pModel->NDEPWEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->NDEPWEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,(Inv_W*Inv_L),pModel->NDEPWLEXP)
T1y=((pModel->NDEPW*d00_max2)+(pModel->NDEPWL*d00_pow3));
EXIT_IF_ISNAN(((pModel->NDEPW*d00_max2)+(pModel->NDEPWL*d00_pow3)))
}
NDEP_i=(NDEP_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((NDEP_i*((1.0+T0y)+T1y)))
{
double m00_pow(d00_pow0,Inv_L,pModel->NFACTORLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->NFACTORLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(pModel->NFACTORL*d00_max2);
EXIT_IF_ISNAN((pModel->NFACTORL*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_W,pModel->NFACTORWEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->NFACTORWEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_WL,pModel->NFACTORWLEXP)
T1y=((pModel->NFACTORW*d00_max2)+(pModel->NFACTORWL*d00_pow3));
EXIT_IF_ISNAN(((pModel->NFACTORW*d00_max2)+(pModel->NFACTORWL*d00_pow3)))
}
NFACTOR_i=(NFACTOR_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((NFACTOR_i*((1.0+T0y)+T1y)))
{
double m00_pow(d00_pow0,Inv_L,pModel->CDSCDLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->CDSCDLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(1.0+(pModel->CDSCDL*d00_max2));
EXIT_IF_ISNAN((1.0+(pModel->CDSCDL*d00_max2)))
}
CDSCD_i=(CDSCD_i*T0y);
EXIT_IF_ISNAN((CDSCD_i*T0y))
if
((pModel->ASYMMOD!=0))
{
CDSCDR_i=(CDSCDR_i*T0y);
EXIT_IF_ISNAN((CDSCDR_i*T0y))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->CDSCBLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->CDSCBLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
CDSCB_i=(CDSCB_i*(1.0+(pModel->CDSCBL*d00_max2)));
EXIT_IF_ISNAN((CDSCB_i*(1.0+(pModel->CDSCBL*d00_max2))))
}
U0_i=(pInst->MULU0*U0_i);
EXIT_IF_ISNAN((pInst->MULU0*U0_i))
if
((pModel->MOBSCALE!=1))
{
if
((pModel->U0LEXP>0.0))
{
{
double m00_pow(d00_pow0,Inv_L,pModel->U0LEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->U0LEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
U0_i=(U0_i*(1.0-(pModel->U0L*d00_max2)));
EXIT_IF_ISNAN((U0_i*(1.0-(pModel->U0L*d00_max2))))
}
if
((pModel->ASYMMOD!=0))
{
{
double m00_pow(d00_pow0,Inv_L,pModel->U0LEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->U0LEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
U0R_i=(U0R_i*(1.0-(pModel->U0L*d00_max2)));
EXIT_IF_ISNAN((U0R_i*(1.0-(pModel->U0L*d00_max2))))
}
}
}
else
{
U0_i=(U0_i*(1.0-pModel->U0L));
EXIT_IF_ISNAN((U0_i*(1.0-pModel->U0L)))
if
((pModel->ASYMMOD!=0))
{
U0R_i=(U0R_i*(1.0-pModel->U0L));
EXIT_IF_ISNAN((U0R_i*(1.0-pModel->U0L)))
}
}
}
else
{
U0_i=(U0_i*((1.0-(pModel->UP1*bsimbulk_lexp(((-Leff)/pModel->LP1))))-(pModel->UP2*bsimbulk_lexp(((-Leff)/pModel->LP2)))));
EXIT_IF_ISNAN((U0_i*((1.0-(pModel->UP1*bsimbulk_lexp(((-Leff)/pModel->LP1))))-(pModel->UP2*bsimbulk_lexp(((-Leff)/pModel->LP2))))))
if
((pModel->ASYMMOD!=0))
{
U0R_i=(U0R_i*((1.0-(pModel->UP1*bsimbulk_lexp(((-Leff)/pModel->LP1))))-(pModel->UP2*bsimbulk_lexp(((-Leff)/pModel->LP2)))));
EXIT_IF_ISNAN((U0R_i*((1.0-(pModel->UP1*bsimbulk_lexp(((-Leff)/pModel->LP1))))-(pModel->UP2*bsimbulk_lexp(((-Leff)/pModel->LP2))))))
}
}
{
double m00_pow(d00_pow0,Inv_L,pModel->UALEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->UALEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(pModel->UAL*d00_max2);
EXIT_IF_ISNAN((pModel->UAL*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_W,pModel->UAWEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->UAWEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_WL,pModel->UAWLEXP)
T1y=((pModel->UAW*d00_max2)+(pModel->UAWL*d00_pow3));
EXIT_IF_ISNAN(((pModel->UAW*d00_max2)+(pModel->UAWL*d00_pow3)))
}
UA_i=(UA_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((UA_i*((1.0+T0y)+T1y)))
if
((pModel->ASYMMOD!=0))
{
UAR_i=(UAR_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((UAR_i*((1.0+T0y)+T1y)))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->EULEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->EULEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(pModel->EUL*d00_max2);
EXIT_IF_ISNAN((pModel->EUL*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_W,pModel->EUWEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->EUWEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_WL,pModel->EUWLEXP)
T1y=((pModel->EUW*d00_max2)+(pModel->EUWL*d00_pow3));
EXIT_IF_ISNAN(((pModel->EUW*d00_max2)+(pModel->EUWL*d00_pow3)))
}
EU_i=(EU_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((EU_i*((1.0+T0y)+T1y)))
{
double m00_pow(d00_pow0,Inv_L,pModel->UDLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->UDLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(1.0+(pModel->UDL*d00_max2));
EXIT_IF_ISNAN((1.0+(pModel->UDL*d00_max2)))
}
UD_i=(UD_i*T0y);
EXIT_IF_ISNAN((UD_i*T0y))
if
((pModel->ASYMMOD!=0))
{
UDR_i=(UDR_i*T0y);
EXIT_IF_ISNAN((UDR_i*T0y))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->UCLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->UCLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(pModel->UCL*d00_max2);
EXIT_IF_ISNAN((pModel->UCL*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_W,pModel->UCWEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->UCWEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_WL,pModel->UCWLEXP)
T1y=((pModel->UCW*d00_max2)+(pModel->UCWL*d00_pow3));
EXIT_IF_ISNAN(((pModel->UCW*d00_max2)+(pModel->UCWL*d00_pow3)))
}
UC_i=(UC_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((UC_i*((1.0+T0y)+T1y)))
if
((pModel->ASYMMOD!=0))
{
UCR_i=(UCR_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((UCR_i*((1.0+T0y)+T1y)))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->DSUB)
double m00_pow(d00_pow1,Inv_Llong,pModel->DSUB)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=d00_max2;
EXIT_IF_ISNAN(d00_max2)
}
ETA0_i=(ETA0_i*T0y);
EXIT_IF_ISNAN((ETA0_i*T0y))
if
((pModel->ASYMMOD!=0))
{
ETA0R_i=(ETA0R_i*T0y);
EXIT_IF_ISNAN((ETA0R_i*T0y))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->ETABEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->ETABEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
ETAB_i=(ETAB_i*d00_max2);
EXIT_IF_ISNAN((ETAB_i*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->PDIBLCLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->PDIBLCLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(1.0+(pModel->PDIBLCL*d00_max2));
EXIT_IF_ISNAN((1.0+(pModel->PDIBLCL*d00_max2)))
}
PDIBLC_i=(PDIBLC_i*T0y);
EXIT_IF_ISNAN((PDIBLC_i*T0y))
if
((pModel->ASYMMOD!=0))
{
PDIBLCR_i=(PDIBLCR_i*T0y);
EXIT_IF_ISNAN((PDIBLCR_i*T0y))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->DELTALEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->DELTALEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(DELTA_i*(1.0+(pModel->DELTAL*d00_max2)));
EXIT_IF_ISNAN((DELTA_i*(1.0+(pModel->DELTAL*d00_max2))))
}
{
double m00_min(d00_min0,T0y,0.5)
DELTA_i=d00_min0;
EXIT_IF_ISNAN(d00_min0)
}
{
double m00_pow(d00_pow0,Inv_L,pModel->FPROUTLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->FPROUTLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
FPROUT_i=(FPROUT_i*(1.0+(pModel->FPROUTL*d00_max2)));
EXIT_IF_ISNAN((FPROUT_i*(1.0+(pModel->FPROUTL*d00_max2))))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->PCLMLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->PCLMLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(1.0+(pModel->PCLML*d00_max2));
EXIT_IF_ISNAN((1.0+(pModel->PCLML*d00_max2)))
}
PCLM_i=(PCLM_i*T0y);
EXIT_IF_ISNAN((PCLM_i*T0y))
{
double m00_max(d00_max0,PCLM_i,0.0)
PCLM_i=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
if
((pModel->ASYMMOD!=0))
{
PCLMR_i=(PCLMR_i*T0y);
EXIT_IF_ISNAN((PCLMR_i*T0y))
{
double m00_max(d00_max0,PCLMR_i,0.0)
PCLMR_i=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
}
{
double m00_pow(d00_pow0,Inv_L,pModel->VSATLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->VSATLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(pModel->VSATL*d00_max2);
EXIT_IF_ISNAN((pModel->VSATL*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_W,pModel->VSATWEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->VSATWEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_WL,pModel->VSATWLEXP)
T1y=((pModel->VSATW*d00_max2)+(pModel->VSATWL*d00_pow3));
EXIT_IF_ISNAN(((pModel->VSATW*d00_max2)+(pModel->VSATWL*d00_pow3)))
}
VSAT_i=(VSAT_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((VSAT_i*((1.0+T0y)+T1y)))
if
((pModel->ASYMMOD!=0))
{
VSATR_i=(VSATR_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((VSATR_i*((1.0+T0y)+T1y)))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->PSATLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->PSATLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_max(d00_max3,(PSAT_i*(1.0+(pModel->PSATL*d00_max2))),0.25)
PSAT_i=d00_max3;
EXIT_IF_ISNAN(d00_max3)
}
if
((pModel->ASYMMOD!=0))
{
{
double m00_pow(d00_pow0,Inv_L,pModel->PSATLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->PSATLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_max(d00_max3,(PSATR_i*(1.0+(pModel->PSATL*d00_max2))),0.25)
PSATR_i=d00_max3;
EXIT_IF_ISNAN(d00_max3)
}
}
{
double m00_pow(d00_pow0,Inv_L,pModel->PTWGLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->PTWGLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(1.0+(pModel->PTWGL*d00_max2));
EXIT_IF_ISNAN((1.0+(pModel->PTWGL*d00_max2)))
}
PTWG_i=(PTWG_i*T0y);
EXIT_IF_ISNAN((PTWG_i*T0y))
if
((pModel->ASYMMOD!=0))
{
PTWGR_i=(PTWGR_i*T0y);
EXIT_IF_ISNAN((PTWGR_i*T0y))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->ALPHA0LEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->ALPHA0LEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
ALPHA0_i=(ALPHA0_i*(1.0+(pModel->ALPHA0L*d00_max2)));
EXIT_IF_ISNAN((ALPHA0_i*(1.0+(pModel->ALPHA0L*d00_max2))))
}
AGIDL_i=(AGIDL_i*((1.0+(pModel->AGIDLL*Inv_L))+(pModel->AGIDLW*Inv_W)));
EXIT_IF_ISNAN((AGIDL_i*((1.0+(pModel->AGIDLL*Inv_L))+(pModel->AGIDLW*Inv_W))))
AGISL_i=(AGISL_i*((1.0+(pModel->AGISLL*Inv_L))+(pModel->AGISLW*Inv_W)));
EXIT_IF_ISNAN((AGISL_i*((1.0+(pModel->AGISLL*Inv_L))+(pModel->AGISLW*Inv_W))))
AIGC_i=(AIGC_i*((1.0+(pModel->AIGCL*Inv_L))+(pModel->AIGCW*Inv_W)));
EXIT_IF_ISNAN((AIGC_i*((1.0+(pModel->AIGCL*Inv_L))+(pModel->AIGCW*Inv_W))))
AIGS_i=(AIGS_i*((1.0+(pModel->AIGSL*Inv_L))+(pModel->AIGSW*Inv_W)));
EXIT_IF_ISNAN((AIGS_i*((1.0+(pModel->AIGSL*Inv_L))+(pModel->AIGSW*Inv_W))))
AIGD_i=(AIGD_i*((1.0+(pModel->AIGDL*Inv_L))+(pModel->AIGDW*Inv_W)));
EXIT_IF_ISNAN((AIGD_i*((1.0+(pModel->AIGDL*Inv_L))+(pModel->AIGDW*Inv_W))))
PIGCD_i=(pModel->PIGCD*(1.0+(pModel->PIGCDL*Inv_L)));
EXIT_IF_ISNAN((pModel->PIGCD*(1.0+(pModel->PIGCDL*Inv_L))))
{
double m00_pow(d00_pow0,Inv_Lact,pModel->NDEPCVLEXP1)
double m00_pow(d00_pow1,Inv_Llong,pModel->NDEPCVLEXP1)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_Lact,pModel->NDEPCVLEXP2)
double m00_pow(d00_pow4,Inv_Llong,pModel->NDEPCVLEXP2)
double m00_max(d00_max5,(d00_pow3-d00_pow4),0.0)
T0y=((pModel->NDEPCVL1*d00_max2)+(pModel->NDEPCVL2*d00_max5));
EXIT_IF_ISNAN(((pModel->NDEPCVL1*d00_max2)+(pModel->NDEPCVL2*d00_max5)))
}
{
double m00_pow(d00_pow0,Inv_Wact,pModel->NDEPCVWEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->NDEPCVWEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,(Inv_Wact*Inv_Lact),pModel->NDEPCVWLEXP)
T1y=((pModel->NDEPCVW*d00_max2)+(pModel->NDEPCVWL*d00_pow3));
EXIT_IF_ISNAN(((pModel->NDEPCVW*d00_max2)+(pModel->NDEPCVWL*d00_pow3)))
}
NDEPCV_i=(NDEPCV_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((NDEPCV_i*((1.0+T0y)+T1y)))
{
double m00_pow(d00_pow0,Inv_Lact,pModel->VFBCVLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->VFBCVLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(pModel->VFBCVL*d00_max2);
EXIT_IF_ISNAN((pModel->VFBCVL*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_Wact,pModel->VFBCVWEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->VFBCVWEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_WL,pModel->VFBCVWLEXP)
T1y=((pModel->VFBCVW*d00_max2)+(pModel->VFBCVWL*d00_pow3));
EXIT_IF_ISNAN(((pModel->VFBCVW*d00_max2)+(pModel->VFBCVWL*d00_pow3)))
}
VFBCV_i=(VFBCV_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((VFBCV_i*((1.0+T0y)+T1y)))
{
double m00_pow(d00_pow0,Inv_Lact,pModel->VSATCVLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->VSATCVLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(pModel->VSATCVL*d00_max2);
EXIT_IF_ISNAN((pModel->VSATCVL*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_W,pModel->VSATCVWEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->VSATCVWEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_WL,pModel->VSATCVWLEXP)
T1y=((pModel->VSATCVW*d00_max2)+(pModel->VSATCVWL*d00_pow3));
EXIT_IF_ISNAN(((pModel->VSATCVW*d00_max2)+(pModel->VSATCVWL*d00_pow3)))
}
VSATCV_i=(VSATCV_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((VSATCV_i*((1.0+T0y)+T1y)))
{
double m00_pow(d00_pow0,Inv_Lact,pModel->PCLMCVLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->PCLMCVLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
PCLMCV_i=(PCLMCV_i*(1.0+(pModel->PCLMCVL*d00_max2)));
EXIT_IF_ISNAN((PCLMCV_i*(1.0+(pModel->PCLMCVL*d00_max2))))
}
{
double m00_max(d00_max0,PCLMCV_i,0.0)
PCLMCV_i=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
{
double m00_pow(d00_pow0,Inv_L,pModel->K1LEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->K1LEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(pModel->K1L*d00_max2);
EXIT_IF_ISNAN((pModel->K1L*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_W,pModel->K1WEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->K1WEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_WL,pModel->K1WLEXP)
T1y=((pModel->K1W*d00_max2)+(pModel->K1WL*d00_pow3));
EXIT_IF_ISNAN(((pModel->K1W*d00_max2)+(pModel->K1WL*d00_pow3)))
}
K1_i=(K1_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((K1_i*((1.0+T0y)+T1y)))
{
double m00_pow(d00_pow0,Inv_L,pModel->K2LEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->K2LEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
T0y=(pModel->K2L*d00_max2);
EXIT_IF_ISNAN((pModel->K2L*d00_max2))
}
{
double m00_pow(d00_pow0,Inv_W,pModel->K2WEXP)
double m00_pow(d00_pow1,Inv_Wwide,pModel->K2WEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
double m00_pow(d00_pow3,Inv_WL,pModel->K2WLEXP)
T1y=((pModel->K2W*d00_max2)+(pModel->K2WL*d00_pow3));
EXIT_IF_ISNAN(((pModel->K2W*d00_max2)+(pModel->K2WL*d00_pow3)))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
K2_i_Tempt_GND=0.0;
#endif
K2_i=(K2_i*((1.0+T0y)+T1y));
EXIT_IF_ISNAN((K2_i*((1.0+T0y)+T1y)))
{
double m00_pow(d00_pow0,Inv_L,pModel->PRWBLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->PRWBLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0)
PRWB_i=(PRWB_i*(1.0+(pModel->PRWBL*d00_max2)));
EXIT_IF_ISNAN((PRWB_i*(1.0+(pModel->PRWBL*d00_max2))))
}
UTE_i=(UTE_i*(1.0+(Inv_L*pModel->UTEL)));
EXIT_IF_ISNAN((UTE_i*(1.0+(Inv_L*pModel->UTEL))))
UA1_i=(UA1_i*(1.0+(Inv_L*pModel->UA1L)));
EXIT_IF_ISNAN((UA1_i*(1.0+(Inv_L*pModel->UA1L))))
UD1_i=(UD1_i*(1.0+(Inv_L*pModel->UD1L)));
EXIT_IF_ISNAN((UD1_i*(1.0+(Inv_L*pModel->UD1L))))
AT_i=(AT_i*(1.0+(Inv_L*pModel->ATL)));
EXIT_IF_ISNAN((AT_i*(1.0+(Inv_L*pModel->ATL))))
PTWGT_i=(PTWGT_i*(1.0+(Inv_L*pModel->PTWGTL)));
EXIT_IF_ISNAN((PTWGT_i*(1.0+(Inv_L*pModel->PTWGTL))))
if
(((here->tNode_connected /* port_connected 12 */)==0))
{
if
(((pModel->SHMOD==0)||(pModel->RTH0==0.0)))
{
  _load_static_residual1(t,0.0)
}
else
{
printf("5 terminal Module, while 't' node is not connected, SH is activated.");
printf("\n");
}
}
if
((pModel->RDSMOD==1))
{
{
double m00_pow(d00_pow0,Inv_L,pModel->RSWLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->RSWLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
RSW_i=(RSW_i*(1.0+(pModel->RSWL*d00_max2)));
EXIT_IF_ISNAN((RSW_i*(1.0+(pModel->RSWL*d00_max2))))
}
{
double m00_pow(d00_pow0,Inv_L,pModel->RDWLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->RDWLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
RDW_i=(RDW_i*(1.0+(pModel->RDWL*d00_max2)));
EXIT_IF_ISNAN((RDW_i*(1.0+(pModel->RDWL*d00_max2))))
}
}
else
{
{
double m00_pow(d00_pow0,Inv_L,pModel->RDSWLEXP)
double m00_pow(d00_pow1,Inv_Llong,pModel->RDSWLEXP)
double m00_max(d00_max2,(d00_pow0-d00_pow1),0.0)
RDSW_i=(RDSW_i*(1.0+(pModel->RDSWL*d00_max2)));
EXIT_IF_ISNAN((RDSW_i*(1.0+(pModel->RDSWL*d00_max2))))
}
}
if
((UCS_i<1.0))
{
UCS_i=1.0;
EXIT_IF_ISNAN(1.0)
}
else
{
if
((UCS_i>2.0))
{
UCS_i=2.0;
EXIT_IF_ISNAN(2.0)
}
}
if
((pModel->ASYMMOD!=0))
{
if
((UCSR_i<1.0))
{
UCSR_i=1.0;
EXIT_IF_ISNAN(1.0)
}
else
{
if
((UCSR_i>2.0))
{
UCSR_i=2.0;
EXIT_IF_ISNAN(2.0)
}
}
}
if
((CGIDL_i<0.0))
{
printf("Fatal: CGIDL_i = %e is negative.",CGIDL_i);
printf("\n");
controlled_exit(0);
}
if
((CGISL_i<0.0))
{
printf("Fatal: CGISL_i = %e is negative.",CGISL_i);
printf("\n");
controlled_exit(0);
}
if
((CKAPPAD_i<=0.0))
{
printf("Fatal: CKAPPAD_i = %e is non-positive.",CKAPPAD_i);
printf("\n");
controlled_exit(0);
}
if
((CKAPPAS_i<=0.0))
{
printf("Fatal: CKAPPAS_i = %e is non-positive.",CKAPPAS_i);
printf("\n");
controlled_exit(0);
}
if
((PDITS_i<0.0))
{
printf("Fatal: PDITS_i = %e is negative.",PDITS_i);
printf("\n");
controlled_exit(0);
}
if
((CIT_i<0.0))
{
printf("Fatal: CIT_i = %e is negative.",CIT_i);
printf("\n");
controlled_exit(0);
}
if
((NFACTOR_i<0.0))
{
printf("Fatal: NFACTOR_i = %e is negative.",NFACTOR_i);
printf("\n");
controlled_exit(0);
}
if
((K1_i<0.0))
{
printf("Fatal: K1_i = %e is negative.",K1_i);
printf("\n");
controlled_exit(0);
}
if
((NSD_i<=0.0))
{
printf("Fatal: NSD_i = %e is non-positive.",NSD_i);
printf("\n");
controlled_exit(0);
}
if
((NDEP_i<=0.0))
{
printf("Fatal: NDEP_i = %e is non-positive.",NDEP_i);
printf("\n");
controlled_exit(0);
}
if
((NDEPCV_i<=0.0))
{
printf("Fatal: NDEPCV_i = %e is non-positive.",NDEPCV_i);
printf("\n");
controlled_exit(0);
}
if
((pModel->IGBMOD!=0))
{
if
((NIGBINV_i<=0.0))
{
printf("Fatal: NIGBINV_i = %e is non-positive.",NIGBINV_i);
printf("\n");
controlled_exit(0);
}
if
((NIGBACC_i<=0.0))
{
printf("Fatal: NIGBACC_i = %e is non-positive.",NIGBACC_i);
printf("\n");
controlled_exit(0);
}
}
if
((pModel->IGCMOD!=0))
{
if
((POXEDGE_i<=0.0))
{
printf("Fatal: POXEDGE_i = %e is non-positive.",POXEDGE_i);
printf("\n");
controlled_exit(0);
}
}
if
((CDSCD_i<0.0))
{
printf("Fatal: CDSCD_i = %e is negative.",CDSCD_i);
printf("\n");
controlled_exit(0);
}
if
((pModel->ASYMMOD!=0))
{
if
((CDSCDR_i<0.0))
{
printf("Fatal: CDSCDR_i = %e is negative.",CDSCDR_i);
printf("\n");
controlled_exit(0);
}
}
if
((DLCIG_i<0.0))
{
printf("Warning: DLCIG = %e is negative, setting it to 0.",DLCIG_i);
printf("\n");
DLCIG_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((DLCIGD_i<0.0))
{
printf("Warning: DLCIGD = %e is negative, setting it to 0.",DLCIGD_i);
printf("\n");
DLCIGD_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((M0_i<0.0))
{
printf("Warning: M0_i = %e is negative, setting it to 0.",M0_i);
printf("\n");
M0_i=0.0;
EXIT_IF_ISNAN(0.0)
}
nuEndD=0.0;
EXIT_IF_ISNAN(0.0)
nuEndS=0.0;
EXIT_IF_ISNAN(0.0)
nuIntD=0.0;
EXIT_IF_ISNAN(0.0)
nuIntS=0.0;
EXIT_IF_ISNAN(0.0)
Rend=0.0;
EXIT_IF_ISNAN(0.0)
Rint=0.0;
EXIT_IF_ISNAN(0.0)
DMCGeff=(pModel->DMCG-pModel->DMCGT);
EXIT_IF_ISNAN((pModel->DMCG-pModel->DMCGT))
DMCIeff=pModel->DMCI;
EXIT_IF_ISNAN(pModel->DMCI)
DMDGeff=(pModel->DMDG-pModel->DMCGT);
EXIT_IF_ISNAN((pModel->DMDG-pModel->DMCGT))
if
((here->NRS_Given))
{
RSourceGeo=(pModel->RSH*pInst->NRS);
EXIT_IF_ISNAN((pModel->RSH*pInst->NRS))
}
else
{
if
(((pInst->RGEOMOD>0)&&(pModel->RSH>0.0)))
{
{
if
((pInst->GEOMOD<9))
{
if
(((pInst->NF%2)!=0))
{
nuEndD=1.0;
EXIT_IF_ISNAN(1.0)
nuEndS=1.0;
EXIT_IF_ISNAN(1.0)
{
double m00_max(d00_max0,((pInst->NF-1.0)/2.0),0.0)
nuIntD=(2.0*d00_max0);
EXIT_IF_ISNAN((2.0*d00_max0))
}
nuIntS=nuIntD;
EXIT_IF_ISNAN(nuIntD)
}
else
{
if
((pInst->MINZ==1))
{
nuEndD=2.0;
EXIT_IF_ISNAN(2.0)
{
double m00_max(d00_max0,((pInst->NF/2.0)-1.0),0.0)
nuIntD=(2.0*d00_max0);
EXIT_IF_ISNAN((2.0*d00_max0))
}
nuEndS=0.0;
EXIT_IF_ISNAN(0.0)
nuIntS=pInst->NF;
EXIT_IF_ISNAN(pInst->NF)
}
else
{
nuEndD=0.0;
EXIT_IF_ISNAN(0.0)
nuIntD=pInst->NF;
EXIT_IF_ISNAN(pInst->NF)
nuEndS=2.0;
EXIT_IF_ISNAN(2.0)
{
double m00_max(d00_max0,((pInst->NF/2.0)-1.0),0.0)
nuIntS=(2.0*d00_max0);
EXIT_IF_ISNAN((2.0*d00_max0))
}
}
}
if
((1==1))
{
if
((nuIntS==0.0))
{
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rint=((pModel->RSH*DMCGeff)/(Weff*nuIntS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuIntS)))
}
}
else
{
if
((nuIntD==0.0))
{
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rint=((pModel->RSH*DMCGeff)/(Weff*nuIntD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuIntD)))
}
}
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->GEOMOD)==(0)))
{
if
((1==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(1)))
{
if
((1==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
else
{
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(2)))
{
if
((1==1))
{
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(3)))
{
if
((1==1))
{
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
{
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(4)))
{
if
((1==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
else
{
Rend=((pModel->RSH*DMDGeff)/Weff);
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/Weff))
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(5)))
{
if
((1==1))
{
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
{
if
((nuEndD==0))
{
Rend=0;
EXIT_IF_ISNAN(0)
}
else
{
Rend=((pModel->RSH*DMDGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/(Weff*nuEndD)))
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(6)))
{
if
((1==1))
{
Rend=((pModel->RSH*DMDGeff)/Weff);
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/Weff))
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(7)))
{
if
((1==1))
{
if
((nuEndS==0))
{
Rend=0;
EXIT_IF_ISNAN(0)
}
else
{
Rend=((pModel->RSH*DMDGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/(Weff*nuEndS)))
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(8)))
{
Rend=((pModel->RSH*DMDGeff)/Weff);
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/Weff))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(9)))
{
if
((1==1))
{
Rend=(((0.5*pModel->RSH)*DMCGeff)/Weff);
EXIT_IF_ISNAN((((0.5*pModel->RSH)*DMCGeff)/Weff))
if
((pInst->NF==2.0))
{
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rint=((pModel->RSH*DMCGeff)/(Weff*(pInst->NF-2.0)));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*(pInst->NF-2.0))))
}
}
else
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
Rint=((pModel->RSH*DMCGeff)/(Weff*pInst->NF));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*pInst->NF)))
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(10)))
{
if
((1==1))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
Rint=((pModel->RSH*DMCGeff)/(Weff*pInst->NF));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*pInst->NF)))
}
else
{
Rend=(((0.5*pModel->RSH)*DMCGeff)/Weff);
EXIT_IF_ISNAN((((0.5*pModel->RSH)*DMCGeff)/Weff))
if
((pInst->NF==2.0))
{
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rint=((pModel->RSH*DMCGeff)/(Weff*(pInst->NF-2.0)));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*(pInst->NF-2.0))))
}
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified GEO=%d not matched (BSIMBULKRdseffGeo), Rint is set to zero.",pInst->GEOMOD);
printf("\n");
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
if
((Rint<=0.0))
{
RSourceGeo=Rend;
EXIT_IF_ISNAN(Rend)
}
else
{
if
((Rend<=0.0))
{
RSourceGeo=Rint;
EXIT_IF_ISNAN(Rint)
}
else
{
RSourceGeo=((Rint*Rend)/(Rint+Rend));
EXIT_IF_ISNAN(((Rint*Rend)/(Rint+Rend)))
}
}
if
((RSourceGeo==0.0))
{
printf("Warning: (instance BSIMBULK) Zero resistance returned from RdseffGeo");
printf("\n");
}
}
}
else
{
RSourceGeo=0.0;
EXIT_IF_ISNAN(0.0)
}
}
if
((here->NRD_Given))
{
RDrainGeo=(pModel->RSH*pInst->NRD);
EXIT_IF_ISNAN((pModel->RSH*pInst->NRD))
}
else
{
if
(((pInst->RGEOMOD>0)&&(pModel->RSH>0.0)))
{
{
if
((pInst->GEOMOD<9))
{
if
(((pInst->NF%2)!=0))
{
nuEndD=1.0;
EXIT_IF_ISNAN(1.0)
nuEndS=1.0;
EXIT_IF_ISNAN(1.0)
{
double m00_max(d00_max0,((pInst->NF-1.0)/2.0),0.0)
nuIntD=(2.0*d00_max0);
EXIT_IF_ISNAN((2.0*d00_max0))
}
nuIntS=nuIntD;
EXIT_IF_ISNAN(nuIntD)
}
else
{
if
((pInst->MINZ==1))
{
nuEndD=2.0;
EXIT_IF_ISNAN(2.0)
{
double m00_max(d00_max0,((pInst->NF/2.0)-1.0),0.0)
nuIntD=(2.0*d00_max0);
EXIT_IF_ISNAN((2.0*d00_max0))
}
nuEndS=0.0;
EXIT_IF_ISNAN(0.0)
nuIntS=pInst->NF;
EXIT_IF_ISNAN(pInst->NF)
}
else
{
nuEndD=0.0;
EXIT_IF_ISNAN(0.0)
nuIntD=pInst->NF;
EXIT_IF_ISNAN(pInst->NF)
nuEndS=2.0;
EXIT_IF_ISNAN(2.0)
{
double m00_max(d00_max0,((pInst->NF/2.0)-1.0),0.0)
nuIntS=(2.0*d00_max0);
EXIT_IF_ISNAN((2.0*d00_max0))
}
}
}
if
((0==1))
{
if
((nuIntS==0.0))
{
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rint=((pModel->RSH*DMCGeff)/(Weff*nuIntS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuIntS)))
}
}
else
{
if
((nuIntD==0.0))
{
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rint=((pModel->RSH*DMCGeff)/(Weff*nuIntD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuIntD)))
}
}
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->GEOMOD)==(0)))
{
if
((0==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(1)))
{
if
((0==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
else
{
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(2)))
{
if
((0==1))
{
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(3)))
{
if
((0==1))
{
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
{
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(4)))
{
if
((0==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
else
{
Rend=((pModel->RSH*DMDGeff)/Weff);
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/Weff))
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(5)))
{
if
((0==1))
{
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndS)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndS==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndS)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
{
if
((nuEndD==0))
{
Rend=0;
EXIT_IF_ISNAN(0)
}
else
{
Rend=((pModel->RSH*DMDGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/(Weff*nuEndD)))
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(6)))
{
if
((0==1))
{
Rend=((pModel->RSH*DMDGeff)/Weff);
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/Weff))
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndIso), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
printf("(DMCG + DMCI) can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff))))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndIso type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(7)))
{
if
((0==1))
{
if
((nuEndS==0))
{
Rend=0;
EXIT_IF_ISNAN(0)
}
else
{
Rend=((pModel->RSH*DMDGeff)/(Weff*nuEndS));
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/(Weff*nuEndS)))
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO = %d not matched (BSIMBULKRdsEndSha), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(1))||((pInst->RGEOMOD)==(3))||((pInst->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*DMCGeff)/(Weff*nuEndD));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*nuEndD)))
}
}
else
/* CASE ITEM */
if
(((pInst->RGEOMOD)==(2))||((pInst->RGEOMOD)==(4))||((pInst->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
printf("DMCG can not be equal to zero");
printf("\n");
}
if
((nuEndD==0.0))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rend=((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
EXIT_IF_ISNAN(((pModel->RSH*Weff)/((6.0*nuEndD)*DMCGeff)))
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified RGEO=%d not matched (BSIMBULKRdsEndSha \
                type 2), Rend is set to zero.",pInst->RGEOMOD);
printf("\n");
Rend=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(8)))
{
Rend=((pModel->RSH*DMDGeff)/Weff);
EXIT_IF_ISNAN(((pModel->RSH*DMDGeff)/Weff))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(9)))
{
if
((0==1))
{
Rend=(((0.5*pModel->RSH)*DMCGeff)/Weff);
EXIT_IF_ISNAN((((0.5*pModel->RSH)*DMCGeff)/Weff))
if
((pInst->NF==2.0))
{
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rint=((pModel->RSH*DMCGeff)/(Weff*(pInst->NF-2.0)));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*(pInst->NF-2.0))))
}
}
else
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
Rint=((pModel->RSH*DMCGeff)/(Weff*pInst->NF));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*pInst->NF)))
}
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(10)))
{
if
((0==1))
{
Rend=0.0;
EXIT_IF_ISNAN(0.0)
Rint=((pModel->RSH*DMCGeff)/(Weff*pInst->NF));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*pInst->NF)))
}
else
{
Rend=(((0.5*pModel->RSH)*DMCGeff)/Weff);
EXIT_IF_ISNAN((((0.5*pModel->RSH)*DMCGeff)/Weff))
if
((pInst->NF==2.0))
{
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
Rint=((pModel->RSH*DMCGeff)/(Weff*(pInst->NF-2.0)));
EXIT_IF_ISNAN(((pModel->RSH*DMCGeff)/(Weff*(pInst->NF-2.0))))
}
}
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified GEO=%d not matched (BSIMBULKRdseffGeo), Rint is set to zero.",pInst->GEOMOD);
printf("\n");
Rint=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE END -- */;
if
((Rint<=0.0))
{
RDrainGeo=Rend;
EXIT_IF_ISNAN(Rend)
}
else
{
if
((Rend<=0.0))
{
RDrainGeo=Rint;
EXIT_IF_ISNAN(Rint)
}
else
{
RDrainGeo=((Rint*Rend)/(Rint+Rend));
EXIT_IF_ISNAN(((Rint*Rend)/(Rint+Rend)))
}
}
if
((RDrainGeo==0.0))
{
printf("Warning: (instance BSIMBULK) Zero resistance returned from RdseffGeo");
printf("\n");
}
}
}
else
{
RDrainGeo=0.0;
EXIT_IF_ISNAN(0.0)
}
}
if
((RSourceGeo<=1.0e-3))
{
RSourceGeo=1.0e-3;
EXIT_IF_ISNAN(1.0e-3)
}
if
((RDrainGeo<=1.0e-3))
{
RDrainGeo=1.0e-3;
EXIT_IF_ISNAN(1.0e-3)
}
if
((pModel->RDSMOD==1))
{
if
((RSWMIN_i<=0.0))
{
RSWMIN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RDWMIN_i<=0.0))
{
RDWMIN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RSW_i<=0.0))
{
RSW_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RDW_i<=0.0))
{
RDW_i=0.0;
EXIT_IF_ISNAN(0.0)
}
}
else
{
if
((RDSWMIN_i<=0.0))
{
RDSWMIN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RDSW_i<=0.0))
{
RDSW_i=0.0;
EXIT_IF_ISNAN(0.0)
}
}
Grbsb=0.0;
EXIT_IF_ISNAN(0.0)
Grbdb=0.0;
EXIT_IF_ISNAN(0.0)
Grbpb=0.0;
EXIT_IF_ISNAN(0.0)
Grbps=0.0;
EXIT_IF_ISNAN(0.0)
Grbpd=0.0;
EXIT_IF_ISNAN(0.0)
if
((pInst->RBODYMOD!=0))
{
Lnl=bsimbulk_lln((Leff*1.0e6));
EXIT_IF_ISNAN(bsimbulk_lln((Leff*1.0e6)))
Lnw=bsimbulk_lln((Weff*1.0e6));
EXIT_IF_ISNAN(bsimbulk_lln((Weff*1.0e6)))
Lnnf=bsimbulk_lln(pInst->NF);
EXIT_IF_ISNAN(bsimbulk_lln(pInst->NF))
Bodymode=5;
EXIT_IF_ISNAN(5)
Rbpb=pInst->RBPB;
EXIT_IF_ISNAN(pInst->RBPB)
Rbpd=pInst->RBPD;
EXIT_IF_ISNAN(pInst->RBPD)
Rbps=pInst->RBPS;
EXIT_IF_ISNAN(pInst->RBPS)
Rbdb=pInst->RBDB;
EXIT_IF_ISNAN(pInst->RBDB)
Rbsb=pInst->RBSB;
EXIT_IF_ISNAN(pInst->RBSB)
if
(((!(model->RBPS0_Given))||(!(model->RBPD0_Given))))
{
Bodymode=1;
EXIT_IF_ISNAN(1)
}
else
{
if
((((!(model->RBSBX0_Given))&&(!(model->RBSBY0_Given)))||((!(model->RBDBX0_Given))&&(!(model->RBDBY0_Given)))))
{
Bodymode=3;
EXIT_IF_ISNAN(3)
}
}
if
((pInst->RBODYMOD==2))
{
if
((Bodymode==5))
{
Rbsbx=(pModel->RBSBX0*bsimbulk_lexp((((pModel->RBSDBXL*Lnl)+(pModel->RBSDBXW*Lnw))+(pModel->RBSDBXNF*Lnnf))));
EXIT_IF_ISNAN((pModel->RBSBX0*bsimbulk_lexp((((pModel->RBSDBXL*Lnl)+(pModel->RBSDBXW*Lnw))+(pModel->RBSDBXNF*Lnnf)))))
Rbsby=(pModel->RBSBY0*bsimbulk_lexp((((pModel->RBSDBYL*Lnl)+(pModel->RBSDBYW*Lnw))+(pModel->RBSDBYNF*Lnnf))));
EXIT_IF_ISNAN((pModel->RBSBY0*bsimbulk_lexp((((pModel->RBSDBYL*Lnl)+(pModel->RBSDBYW*Lnw))+(pModel->RBSDBYNF*Lnnf)))))
Rbsb=((Rbsbx*Rbsby)/(Rbsbx+Rbsby));
EXIT_IF_ISNAN(((Rbsbx*Rbsby)/(Rbsbx+Rbsby)))
Rbdbx=(pModel->RBDBX0*bsimbulk_lexp((((pModel->RBSDBXL*Lnl)+(pModel->RBSDBXW*Lnw))+(pModel->RBSDBXNF*Lnnf))));
EXIT_IF_ISNAN((pModel->RBDBX0*bsimbulk_lexp((((pModel->RBSDBXL*Lnl)+(pModel->RBSDBXW*Lnw))+(pModel->RBSDBXNF*Lnnf)))))
Rbdby=(pModel->RBDBY0*bsimbulk_lexp((((pModel->RBSDBYL*Lnl)+(pModel->RBSDBYW*Lnw))+(pModel->RBSDBYNF*Lnnf))));
EXIT_IF_ISNAN((pModel->RBDBY0*bsimbulk_lexp((((pModel->RBSDBYL*Lnl)+(pModel->RBSDBYW*Lnw))+(pModel->RBSDBYNF*Lnnf)))))
Rbdb=((Rbdbx*Rbdby)/(Rbdbx+Rbdby));
EXIT_IF_ISNAN(((Rbdbx*Rbdby)/(Rbdbx+Rbdby)))
}
if
(((Bodymode==3)||(Bodymode==5)))
{
Rbps=(pModel->RBPS0*bsimbulk_lexp((((pModel->RBPSL*Lnl)+(pModel->RBPSW*Lnw))+(pModel->RBPSNF*Lnnf))));
EXIT_IF_ISNAN((pModel->RBPS0*bsimbulk_lexp((((pModel->RBPSL*Lnl)+(pModel->RBPSW*Lnw))+(pModel->RBPSNF*Lnnf)))))
Rbpd=(pModel->RBPD0*bsimbulk_lexp((((pModel->RBPDL*Lnl)+(pModel->RBPDW*Lnw))+(pModel->RBPDNF*Lnnf))));
EXIT_IF_ISNAN((pModel->RBPD0*bsimbulk_lexp((((pModel->RBPDL*Lnl)+(pModel->RBPDW*Lnw))+(pModel->RBPDNF*Lnnf)))))
}
Rbpbx=(pModel->RBPBX0*bsimbulk_lexp((((pModel->RBPBXL*Lnl)+(pModel->RBPBXW*Lnw))+(pModel->RBPBXNF*Lnnf))));
EXIT_IF_ISNAN((pModel->RBPBX0*bsimbulk_lexp((((pModel->RBPBXL*Lnl)+(pModel->RBPBXW*Lnw))+(pModel->RBPBXNF*Lnnf)))))
Rbpby=(pModel->RBPBY0*bsimbulk_lexp((((pModel->RBPBYL*Lnl)+(pModel->RBPBYW*Lnw))+(pModel->RBPBYNF*Lnnf))));
EXIT_IF_ISNAN((pModel->RBPBY0*bsimbulk_lexp((((pModel->RBPBYL*Lnl)+(pModel->RBPBYW*Lnw))+(pModel->RBPBYNF*Lnnf)))))
Rbpb=((Rbpbx*Rbpby)/(Rbpbx+Rbpby));
EXIT_IF_ISNAN(((Rbpbx*Rbpby)/(Rbpbx+Rbpby)))
}
if
(((pInst->RBODYMOD==1)||((pInst->RBODYMOD==2)&&(Bodymode==5))))
{
if
((Rbdb<1.0e-3))
{
Grbdb=1.0e3;
EXIT_IF_ISNAN(1.0e3)
}
else
{
Grbdb=(pModel->GBMIN+(1.0/Rbdb));
EXIT_IF_ISNAN((pModel->GBMIN+(1.0/Rbdb)))
}
if
((Rbpb<1.0e-3))
{
Grbpb=1.0e3;
EXIT_IF_ISNAN(1.0e3)
}
else
{
Grbpb=(pModel->GBMIN+(1.0/Rbpb));
EXIT_IF_ISNAN((pModel->GBMIN+(1.0/Rbpb)))
}
if
((Rbps<1.0e-3))
{
Grbps=1.0e3;
EXIT_IF_ISNAN(1.0e3)
}
else
{
Grbps=(pModel->GBMIN+(1.0/Rbps));
EXIT_IF_ISNAN((pModel->GBMIN+(1.0/Rbps)))
}
if
((Rbsb<1.0e-3))
{
Grbsb=1.0e3;
EXIT_IF_ISNAN(1.0e3)
}
else
{
Grbsb=(pModel->GBMIN+(1.0/Rbsb));
EXIT_IF_ISNAN((pModel->GBMIN+(1.0/Rbsb)))
}
if
((Rbpd<1.0e-3))
{
Grbpd=1.0e3;
EXIT_IF_ISNAN(1.0e3)
}
else
{
Grbpd=(pModel->GBMIN+(1.0/Rbpd));
EXIT_IF_ISNAN((pModel->GBMIN+(1.0/Rbpd)))
}
}
else
{
if
(((pInst->RBODYMOD==2)&&(Bodymode==3)))
{
Grbdb=pModel->GBMIN;
EXIT_IF_ISNAN(pModel->GBMIN)
Grbsb=pModel->GBMIN;
EXIT_IF_ISNAN(pModel->GBMIN)
if
((Rbpb<1.0e-3))
{
Grbpb=1.0e3;
EXIT_IF_ISNAN(1.0e3)
}
else
{
Grbpb=(pModel->GBMIN+(1.0/Rbpb));
EXIT_IF_ISNAN((pModel->GBMIN+(1.0/Rbpb)))
}
if
((Rbps<1.0e-3))
{
Grbps=1.0e3;
EXIT_IF_ISNAN(1.0e3)
}
else
{
Grbps=(pModel->GBMIN+(1.0/Rbps));
EXIT_IF_ISNAN((pModel->GBMIN+(1.0/Rbps)))
}
if
((Rbpd<1.0e-3))
{
Grbpd=1.0e3;
EXIT_IF_ISNAN(1.0e3)
}
else
{
Grbpd=(pModel->GBMIN+(1.0/Rbpd));
EXIT_IF_ISNAN((pModel->GBMIN+(1.0/Rbpd)))
}
}
else
{
if
(((pInst->RBODYMOD==2)&&(Bodymode==1)))
{
Grbdb=pModel->GBMIN;
EXIT_IF_ISNAN(pModel->GBMIN)
Grbsb=pModel->GBMIN;
EXIT_IF_ISNAN(pModel->GBMIN)
Grbps=1.0e3;
EXIT_IF_ISNAN(1.0e3)
Grbpd=1.0e3;
EXIT_IF_ISNAN(1.0e3)
if
((Rbpb<1.0e-3))
{
Grbpb=1.0e3;
EXIT_IF_ISNAN(1.0e3)
}
else
{
Grbpb=(pModel->GBMIN+(1.0/Rbpb));
EXIT_IF_ISNAN((pModel->GBMIN+(1.0/Rbpb)))
}
}
}
}
}
Grgeltd=((pModel->RSHG*(pInst->XGW+((Weffcj/3.0)/pInst->NGCON)))/((pInst->NGCON*pInst->NF)*(Lnew-pModel->XGL)));
EXIT_IF_ISNAN(((pModel->RSHG*(pInst->XGW+((Weffcj/3.0)/pInst->NGCON)))/((pInst->NGCON*pInst->NF)*(Lnew-pModel->XGL))))
if
((Grgeltd>0.0))
{
Grgeltd=(1.0/Grgeltd);
EXIT_IF_ISNAN((1.0/Grgeltd))
}
else
{
Grgeltd=1.0e3;
EXIT_IF_ISNAN(1.0e3)
if
((pInst->RGATEMOD!=0))
{
printf("Warning: (instance BSIMBULK) The gate conductance reset to 1.0e3 mho.");
printf("\n");
}
}
T0y=(pModel->TOXE*pModel->TOXE);
EXIT_IF_ISNAN((pModel->TOXE*pModel->TOXE))
T1y=(pModel->TOXE*POXEDGE_i);
EXIT_IF_ISNAN((pModel->TOXE*POXEDGE_i))
T2y=(T1y*T1y);
EXIT_IF_ISNAN((T1y*T1y))
ToxRatio=(bsimbulk_lexp((NTOX_i*bsimbulk_lln((pModel->TOXREF/pModel->TOXE))))/T0y);
EXIT_IF_ISNAN((bsimbulk_lexp((NTOX_i*bsimbulk_lln((pModel->TOXREF/pModel->TOXE))))/T0y))
ToxRatioEdge=(bsimbulk_lexp((NTOX_i*bsimbulk_lln((pModel->TOXREF/T1y))))/T2y);
EXIT_IF_ISNAN((bsimbulk_lexp((NTOX_i*bsimbulk_lln((pModel->TOXREF/T1y))))/T2y))
Aechvb=((pModel->TYPE==1)?4.97232e-7:3.42537e-7);
EXIT_IF_ISNAN(((pModel->TYPE==1)?4.97232e-7:3.42537e-7))
Bechvb=((pModel->TYPE==1)?7.45669e11:1.16645e12);
EXIT_IF_ISNAN(((pModel->TYPE==1)?7.45669e11:1.16645e12))
AechvbEdge=((Aechvb*Weff)*ToxRatioEdge);
EXIT_IF_ISNAN(((Aechvb*Weff)*ToxRatioEdge))
BechvbEdge=(((-Bechvb)*pModel->TOXE)*POXEDGE_i);
EXIT_IF_ISNAN((((-Bechvb)*pModel->TOXE)*POXEDGE_i))
Aechvb=(Aechvb*((Weff*Leff)*ToxRatio));
EXIT_IF_ISNAN((Aechvb*((Weff*Leff)*ToxRatio)))
Bechvb=((-Bechvb)*pModel->TOXE);
EXIT_IF_ISNAN(((-Bechvb)*pModel->TOXE))
Weff_SH=(pModel->WTH0+Weff);
EXIT_IF_ISNAN((pModel->WTH0+Weff))
if
((((pModel->SHMOD!=0)&&(pModel->RTH0>0.0))&&(Weff_SH>0.0)))
{
gth=((Weff_SH*pInst->NF)/pModel->RTH0);
EXIT_IF_ISNAN(((Weff_SH*pInst->NF)/pModel->RTH0))
#if defined(_DYNAMIC)
cth=((pModel->CTH0*Weff_SH)*pInst->NF);
EXIT_IF_ISNAN(((pModel->CTH0*Weff_SH)*pInst->NF))
#endif
}
else
{
gth=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DYNAMIC)
cth=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
if
((pModel->TNOM<=(-273.15)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=0.0;
#endif
#endif
T0=(300.15-273.15);
EXIT_IF_ISNAN((300.15-273.15))
printf("Warning: TNOM = %e C <= %e C. Setting TNOM to %e C.",pModel->TNOM,(-273.15),T0);
printf("\n");
Tnom=300.15;
EXIT_IF_ISNAN(300.15)
}
else
{
Tnom=(pModel->TNOM+273.15);
EXIT_IF_ISNAN((pModel->TNOM+273.15))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
DevTemp_Tempt_GND=0.0;
#endif
DevTemp=(mint_get_circuit_tempK()+pInst->DTEMP);
EXIT_IF_ISNAN((mint_get_circuit_tempK()+pInst->DTEMP))
if
((((pModel->SHMOD!=0)&&(pModel->RTH0>0.0))&&(Weff_SH>0.0)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
delTemp1_Tempt_GND=1.0;
#endif
delTemp1=NP(t);
EXIT_IF_ISNAN(NP(t))
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
delTemp1_Tempt_GND=0.0;
#endif
delTemp1=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
DevTemp_Tempt_GND=(delTemp1_Tempt_GND+DevTemp_Tempt_GND);
#endif
DevTemp=(delTemp1+DevTemp);
EXIT_IF_ISNAN((delTemp1+DevTemp))
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_T_DELTA_SH]=NP(t);
EXIT_IF_ISNAN(NP(t))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_T_TOTAL_K]=DevTemp;
EXIT_IF_ISNAN(DevTemp)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_T_TOTAL_C]=(DevTemp-273.15);
EXIT_IF_ISNAN((DevTemp-273.15))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Vt_Tempt_GND=(8.617087e-5*DevTemp_Tempt_GND);
#endif
Vt=(8.617087e-5*DevTemp);
EXIT_IF_ISNAN((8.617087e-5*DevTemp))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND) */
inv_Vt_Tempt_GND=(-Vt_Tempt_GND/Vt/Vt);
#endif
inv_Vt=(1.0/Vt);
EXIT_IF_ISNAN((1.0/Vt))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
TRatio_Tempt_GND=(DevTemp_Tempt_GND/Tnom);
#endif
TRatio=(DevTemp/Tnom);
EXIT_IF_ISNAN((DevTemp/Tnom))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
delTemp_Tempt_GND=DevTemp_Tempt_GND;
#endif
delTemp=(DevTemp-Tnom);
EXIT_IF_ISNAN((DevTemp-Tnom))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
Vtm_Tempt_GND=(8.617087e-5*DevTemp_Tempt_GND);
#endif
Vtm=(8.617087e-5*DevTemp);
EXIT_IF_ISNAN((8.617087e-5*DevTemp))
Vtm0=(8.617087e-5*Tnom);
EXIT_IF_ISNAN((8.617087e-5*Tnom))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
Eg_Tempt_GND=(-(((((pModel->TBGASUB*DevTemp_Tempt_GND)*DevTemp)+((pModel->TBGASUB*DevTemp)*DevTemp_Tempt_GND))*(DevTemp+pModel->TBGBSUB)-((pModel->TBGASUB*DevTemp)*DevTemp)*DevTemp_Tempt_GND)/(DevTemp+pModel->TBGBSUB)/(DevTemp+pModel->TBGBSUB)));
#endif
Eg=(pModel->BG0SUB-(((pModel->TBGASUB*DevTemp)*DevTemp)/(DevTemp+pModel->TBGBSUB)));
EXIT_IF_ISNAN((pModel->BG0SUB-(((pModel->TBGASUB*DevTemp)*DevTemp)/(DevTemp+pModel->TBGBSUB))))
Eg0=(pModel->BG0SUB-(((pModel->TBGASUB*Tnom)*Tnom)/(Tnom+pModel->TBGBSUB)));
EXIT_IF_ISNAN((pModel->BG0SUB-(((pModel->TBGASUB*Tnom)*Tnom)/(Tnom+pModel->TBGBSUB))))
{
double m00_sqrt(d00_sqrt0,(DevTemp/Tnom))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(DevTemp/Tnom))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((DevTemp_Tempt_GND/Tnom)*d00_sqrt0)+((DevTemp/Tnom)*(DevTemp_Tempt_GND/Tnom)*d10_sqrt0));
#endif
#endif
T1=((DevTemp/Tnom)*d00_sqrt0);
EXIT_IF_ISNAN(((DevTemp/Tnom)*d00_sqrt0))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND) */
ni_Tempt_GND=(((pModel->NI0SUB*T1_Tempt_GND)*bsimbulk_lexp(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm)))))+((pModel->NI0SUB*T1)*bsimbulk_d_lexp(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm))),((Eg_Tempt_GND/(2.0*Vtm0))-((Eg_Tempt_GND*(2.0*Vtm)-Eg*(2.0*Vtm_Tempt_GND))/(2.0*Vtm)/(2.0*Vtm))))));
#endif
ni=((pModel->NI0SUB*T1)*bsimbulk_lexp(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm)))));
EXIT_IF_ISNAN(((pModel->NI0SUB*T1)*bsimbulk_lexp(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm))))))
if
((((pModel->SHMOD!=0)&&(pModel->RTH0>0.0))&&(Weff_SH>0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=bsimbulk_d_lln((NDEP_i/ni),(-NDEP_i*ni_Tempt_GND/ni/ni));
#endif
#endif
T0=bsimbulk_lln((NDEP_i/ni));
EXIT_IF_ISNAN(bsimbulk_lln((NDEP_i/ni)))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+1.0e-6))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+1.0e-6))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
phib_Tempt_GND=((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0;
#endif
phib=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
phib_Tempt_GND=bsimbulk_d_lln((NDEP_i/ni),(-NDEP_i*ni_Tempt_GND/ni/ni));
#endif
phib=bsimbulk_lln((NDEP_i/ni));
EXIT_IF_ISNAN(bsimbulk_lln((NDEP_i/ni)))
}
if
((((pModel->SHMOD!=0)&&(pModel->RTH0>0.0))&&(Weff_SH>0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=bsimbulk_d_lln(((NDEP_i*NSD_i)/(ni*ni)),(-(NDEP_i*NSD_i)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)));
#endif
#endif
T0=bsimbulk_lln(((NDEP_i*NSD_i)/(ni*ni)));
EXIT_IF_ISNAN(bsimbulk_lln(((NDEP_i*NSD_i)/(ni*ni))))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+1.0e-6))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+1.0e-6))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
Vbi_Tempt_GND=((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0;
#endif
Vbi=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
Vbi_Tempt_GND=bsimbulk_d_lln(((NDEP_i*NSD_i)/(ni*ni)),(-(NDEP_i*NSD_i)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)));
#endif
Vbi=bsimbulk_lln(((NDEP_i*NSD_i)/(ni*ni)));
EXIT_IF_ISNAN(bsimbulk_lln(((NDEP_i*NSD_i)/(ni*ni))))
}
if
((NGATE_i>0.0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(si,GND)V(bi,GND) */
Vfbsdr_Tempt_GND=((((-devsign)*Vt_Tempt_GND)*bsimbulk_lln((NGATE_i/NSD_i)))+(((-devsign)*Vt)*bsimbulk_d_lln((NGATE_i/NSD_i),0.0)));
#endif
Vfbsdr=((((-devsign)*Vt)*bsimbulk_lln((NGATE_i/NSD_i)))+pInst->VFBSDOFF);
EXIT_IF_ISNAN(((((-devsign)*Vt)*bsimbulk_lln((NGATE_i/NSD_i)))+pInst->VFBSDOFF))
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(si,GND)V(bi,GND) */
Vfbsdr_Tempt_GND=0.0;
#endif
Vfbsdr=0.0;
EXIT_IF_ISNAN(0.0)
}
{
double m00_max(d00_max0,((0.4+(Vt*phib))+PHIN_i),0.4)
#if defined(_DERIVATE)
double m10_max(d10_max0,d00_max0,((0.4+(Vt*phib))+PHIN_i),0.4)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Phist_Tempt_GND=(d10_max0*((Vt_Tempt_GND*phib)+(Vt*phib_Tempt_GND)));
#endif
Phist=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
{
double m00_sqrt(d00_sqrt0,Phist)
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,Phist)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
sqrtPhist_Tempt_GND=Phist_Tempt_GND*d10_sqrt0;
#endif
sqrtPhist=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_sqrt(d00_sqrt0,((2.0*epssi)/(1.60219e-19*NDEP_i)))
T1DEP=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_sqrt(d00_sqrt0,(((epssi/epsox)*pModel->TOXE)*XJ_i))
litl=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND) */
NFACTOR_t_Tempt_GND=(NFACTOR_i*bsimbulk_d_hypsmooth((1.0+(pModel->TNFACTOR*(TRatio-1.0))),1e-3,(pModel->TNFACTOR*TRatio_Tempt_GND),0.0));
#endif
NFACTOR_t=(NFACTOR_i*bsimbulk_hypsmooth((1.0+(pModel->TNFACTOR*(TRatio-1.0))),1e-3));
EXIT_IF_ISNAN((NFACTOR_i*bsimbulk_hypsmooth((1.0+(pModel->TNFACTOR*(TRatio-1.0))),1e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
ETA0_t_Tempt_GND=(ETA0_i*(pModel->TETA0*TRatio_Tempt_GND));
#endif
ETA0_t=(ETA0_i*(1.0+(pModel->TETA0*(TRatio-1.0))));
EXIT_IF_ISNAN((ETA0_i*(1.0+(pModel->TETA0*(TRatio-1.0)))))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
ETA0R_t_Tempt_GND=(ETA0R_i*(pModel->TETA0*TRatio_Tempt_GND));
#endif
ETA0R_t=(ETA0R_i*(1.0+(pModel->TETA0*(TRatio-1.0))));
EXIT_IF_ISNAN((ETA0R_i*(1.0+(pModel->TETA0*(TRatio-1.0)))))
}
eta_mu=((pModel->TYPE!=1)?(0.33333333333333333*pModel->ETAMOB):(0.5*pModel->ETAMOB));
EXIT_IF_ISNAN(((pModel->TYPE!=1)?(0.33333333333333333*pModel->ETAMOB):(0.5*pModel->ETAMOB)))
{
double m00_pow(d00_pow0,TRatio,UTE_i)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,UTE_i)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
U0_t_Tempt_GND=(U0_i*(d10_pow0*TRatio_Tempt_GND));
#endif
U0_t=(U0_i*d00_pow0);
EXIT_IF_ISNAN((U0_i*d00_pow0))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UA_t_Tempt_GND=(UA_i*bsimbulk_d_hypsmooth(((1.0+(UA1_i*delTemp))-1.0e-6),1.0e-3,(UA1_i*delTemp_Tempt_GND),0.0));
#endif
UA_t=(UA_i*bsimbulk_hypsmooth(((1.0+(UA1_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((UA_i*bsimbulk_hypsmooth(((1.0+(UA1_i*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UC_t_Tempt_GND=(UC_i*bsimbulk_d_hypsmooth(((1.0+(UC1_i*delTemp))-1.0e-6),1.0e-3,(UC1_i*delTemp_Tempt_GND),0.0));
#endif
UC_t=(UC_i*bsimbulk_hypsmooth(((1.0+(UC1_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((UC_i*bsimbulk_hypsmooth(((1.0+(UC1_i*delTemp))-1.0e-6),1.0e-3)))
{
double m00_pow(d00_pow0,TRatio,UD1_i)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,UD1_i)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UD_t_Tempt_GND=(UD_i*(d10_pow0*TRatio_Tempt_GND));
#endif
UD_t=(UD_i*d00_pow0);
EXIT_IF_ISNAN((UD_i*d00_pow0))
}
{
double m00_pow(d00_pow0,TRatio,UCSTE_i)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,UCSTE_i)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UCS_t_Tempt_GND=(UCS_i*(d10_pow0*TRatio_Tempt_GND));
#endif
UCS_t=(UCS_i*d00_pow0);
EXIT_IF_ISNAN((UCS_i*d00_pow0))
}
if
((pModel->ASYMMOD!=0))
{
{
double m00_pow(d00_pow0,TRatio,UTE_i)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,UTE_i)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
U0R_t_Tempt_GND=(U0R_i*(d10_pow0*TRatio_Tempt_GND));
#endif
U0R_t=(U0R_i*d00_pow0);
EXIT_IF_ISNAN((U0R_i*d00_pow0))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UAR_t_Tempt_GND=(UAR_i*bsimbulk_d_hypsmooth(((1.0+(UA1_i*delTemp))-1.0e-6),1.0e-3,(UA1_i*delTemp_Tempt_GND),0.0));
#endif
UAR_t=(UAR_i*bsimbulk_hypsmooth(((1.0+(UA1_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((UAR_i*bsimbulk_hypsmooth(((1.0+(UA1_i*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UCR_t_Tempt_GND=(UCR_i*bsimbulk_d_hypsmooth(((1.0+(UC1_i*delTemp))-1.0e-6),1.0e-3,(UC1_i*delTemp_Tempt_GND),0.0));
#endif
UCR_t=(UCR_i*bsimbulk_hypsmooth(((1.0+(UC1_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((UCR_i*bsimbulk_hypsmooth(((1.0+(UC1_i*delTemp))-1.0e-6),1.0e-3)))
{
double m00_pow(d00_pow0,TRatio,UD1_i)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,UD1_i)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UDR_t_Tempt_GND=(UDR_i*(d10_pow0*TRatio_Tempt_GND));
#endif
UDR_t=(UDR_i*d00_pow0);
EXIT_IF_ISNAN((UDR_i*d00_pow0))
}
{
double m00_pow(d00_pow0,TRatio,UCSTE_i)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,UCSTE_i)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
UCSR_t_Tempt_GND=(UCSR_i*(d10_pow0*TRatio_Tempt_GND));
#endif
UCSR_t=(UCSR_i*d00_pow0);
EXIT_IF_ISNAN((UCSR_i*d00_pow0))
}
}
{
double m00_pow(d00_pow0,TRatio,PRT_i)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,PRT_i)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
rdstemp_Tempt_GND=(d10_pow0*TRatio_Tempt_GND);
#endif
rdstemp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,TRatio,(-AT_i))
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,(-AT_i))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VSAT_t_Tempt_GND=(VSAT_i*(d10_pow0*TRatio_Tempt_GND));
#endif
VSAT_t=(VSAT_i*d00_pow0);
EXIT_IF_ISNAN((VSAT_i*d00_pow0))
}
if
((VSAT_t<100.0))
{
printf("Warning: VSAT(%f) = %e is less than 100, setting it to 100.",DevTemp,VSAT_t);
printf("\n");
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VSAT_t_Tempt_GND=0.0;
#endif
VSAT_t=100.0;
EXIT_IF_ISNAN(100.0)
}
if
((pModel->ASYMMOD!=0))
{
{
double m00_pow(d00_pow0,TRatio,(-AT_i))
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,(-AT_i))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VSATR_t_Tempt_GND=(VSATR_i*(d10_pow0*TRatio_Tempt_GND));
#endif
VSATR_t=(VSATR_i*d00_pow0);
EXIT_IF_ISNAN((VSATR_i*d00_pow0))
}
if
((VSATR_t<100.0))
{
printf("Warning: VSATR(%f) = %e is less than 100, setting it to 100.",DevTemp,VSATR_t);
printf("\n");
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VSATR_t_Tempt_GND=0.0;
#endif
VSATR_t=100.0;
EXIT_IF_ISNAN(100.0)
}
}
{
double m00_pow(d00_pow0,TRatio,(-AT_i))
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,(-AT_i))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
VSATCV_t_Tempt_GND=(VSATCV_i*(d10_pow0*TRatio_Tempt_GND));
#endif
VSATCV_t=(VSATCV_i*d00_pow0);
EXIT_IF_ISNAN((VSATCV_i*d00_pow0))
}
if
((VSATCV_t<100.0))
{
printf("Warning: VSATCV(%f) = %e is less than 100, setting it to 100.",DevTemp,VSATCV_t);
printf("\n");
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
VSATCV_t_Tempt_GND=0.0;
#endif
VSATCV_t=100.0;
EXIT_IF_ISNAN(100.0)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
DELTA_t_Tempt_GND=(-bsimbulk_d_hypsmooth((((1.0/DELTA_i)*(1.0+(pModel->TDELTA*delTemp)))-2.0),1.0e-3,((1.0/DELTA_i)*(pModel->TDELTA*delTemp_Tempt_GND)),0.0)/(bsimbulk_hypsmooth((((1.0/DELTA_i)*(1.0+(pModel->TDELTA*delTemp)))-2.0),1.0e-3)+2.0)/(bsimbulk_hypsmooth((((1.0/DELTA_i)*(1.0+(pModel->TDELTA*delTemp)))-2.0),1.0e-3)+2.0));
#endif
DELTA_t=(1.0/(bsimbulk_hypsmooth((((1.0/DELTA_i)*(1.0+(pModel->TDELTA*delTemp)))-2.0),1.0e-3)+2.0));
EXIT_IF_ISNAN((1.0/(bsimbulk_hypsmooth((((1.0/DELTA_i)*(1.0+(pModel->TDELTA*delTemp)))-2.0),1.0e-3)+2.0)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
PTWG_t_Tempt_GND=(PTWG_i*bsimbulk_d_hypsmooth(((1.0-(PTWGT_i*delTemp))-1.0e-6),1.0e-3,(-(PTWGT_i*delTemp_Tempt_GND)),0.0));
#endif
PTWG_t=(PTWG_i*bsimbulk_hypsmooth(((1.0-(PTWGT_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((PTWG_i*bsimbulk_hypsmooth(((1.0-(PTWGT_i*delTemp))-1.0e-6),1.0e-3)))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
PTWGR_t_Tempt_GND=(PTWGR_i*bsimbulk_d_hypsmooth(((1.0-(PTWGT_i*delTemp))-1.0e-6),1.0e-3,(-(PTWGT_i*delTemp_Tempt_GND)),0.0));
#endif
PTWGR_t=(PTWGR_i*bsimbulk_hypsmooth(((1.0-(PTWGT_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((PTWGR_i*bsimbulk_hypsmooth(((1.0-(PTWGT_i*delTemp))-1.0e-6),1.0e-3)))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
A1_t_Tempt_GND=(A1_i*bsimbulk_d_hypsmooth(((1.0+(A11_i*delTemp))-1.0e-6),1.0e-3,(A11_i*delTemp_Tempt_GND),0.0));
#endif
A1_t=(A1_i*bsimbulk_hypsmooth(((1.0+(A11_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((A1_i*bsimbulk_hypsmooth(((1.0+(A11_i*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
A2_t_Tempt_GND=(A2_i*bsimbulk_d_hypsmooth(((1.0+(A21_i*delTemp))-1.0e-6),1.0e-3,(A21_i*delTemp_Tempt_GND),0.0));
#endif
A2_t=(A2_i*bsimbulk_hypsmooth(((1.0+(A21_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((A2_i*bsimbulk_hypsmooth(((1.0+(A21_i*delTemp))-1.0e-6),1.0e-3)))
{
double m00_pow(d00_pow0,TRatio,IIT_i)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,TRatio,IIT_i)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
BETA0_t_Tempt_GND=(BETA0_i*(d10_pow0*TRatio_Tempt_GND));
#endif
BETA0_t=(BETA0_i*d00_pow0);
EXIT_IF_ISNAN((BETA0_i*d00_pow0))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
BGIDL_t_Tempt_GND=(BGIDL_i*bsimbulk_d_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3,(TGIDL_i*delTemp_Tempt_GND),0.0));
#endif
BGIDL_t=(BGIDL_i*bsimbulk_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((BGIDL_i*bsimbulk_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
BGISL_t_Tempt_GND=(BGISL_i*bsimbulk_d_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3,(TGIDL_i*delTemp_Tempt_GND),0.0));
#endif
BGISL_t=(BGISL_i*bsimbulk_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((BGISL_i*bsimbulk_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
igtemp_Tempt_GND=bsimbulk_d_lexp((IGT_i*bsimbulk_lln(TRatio)),(IGT_i*bsimbulk_d_lln(TRatio,TRatio_Tempt_GND)));
#endif
igtemp=bsimbulk_lexp((IGT_i*bsimbulk_lln(TRatio)));
EXIT_IF_ISNAN(bsimbulk_lexp((IGT_i*bsimbulk_lln(TRatio))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
K0_t_Tempt_GND=(K0_i*bsimbulk_d_hypsmooth(((1.0+(K01_i*delTemp))-1.0e-6),1.0e-3,(K01_i*delTemp_Tempt_GND),0.0));
#endif
K0_t=(K0_i*bsimbulk_hypsmooth(((1.0+(K01_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((K0_i*bsimbulk_hypsmooth(((1.0+(K01_i*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
M0_t_Tempt_GND=(M0_i*bsimbulk_d_hypsmooth(((1.0+(M01_i*delTemp))-1.0e-6),1.0e-3,(M01_i*delTemp_Tempt_GND),0.0));
#endif
M0_t=(M0_i*bsimbulk_hypsmooth(((1.0+(M01_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((M0_i*bsimbulk_hypsmooth(((1.0+(M01_i*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
CJS_t_Tempt_GND=(pModel->CJS*bsimbulk_d_hypsmooth(((1.0+(pModel->TCJ*delTemp))-1.0e-6),1.0e-3,(pModel->TCJ*delTemp_Tempt_GND),0.0));
#endif
CJS_t=(pModel->CJS*bsimbulk_hypsmooth(((1.0+(pModel->TCJ*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((pModel->CJS*bsimbulk_hypsmooth(((1.0+(pModel->TCJ*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
CJD_t_Tempt_GND=(pModel->CJD*bsimbulk_d_hypsmooth(((1.0+(pModel->TCJ*delTemp))-1.0e-6),1.0e-3,(pModel->TCJ*delTemp_Tempt_GND),0.0));
#endif
CJD_t=(pModel->CJD*bsimbulk_hypsmooth(((1.0+(pModel->TCJ*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((pModel->CJD*bsimbulk_hypsmooth(((1.0+(pModel->TCJ*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
CJSWS_t_Tempt_GND=(pModel->CJSWS*bsimbulk_d_hypsmooth(((1.0+(pModel->TCJSW*delTemp))-1.0e-6),1.0e-3,(pModel->TCJSW*delTemp_Tempt_GND),0.0));
#endif
CJSWS_t=(pModel->CJSWS*bsimbulk_hypsmooth(((1.0+(pModel->TCJSW*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((pModel->CJSWS*bsimbulk_hypsmooth(((1.0+(pModel->TCJSW*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
CJSWD_t_Tempt_GND=(pModel->CJSWD*bsimbulk_d_hypsmooth(((1.0+(pModel->TCJSW*delTemp))-1.0e-6),1.0e-3,(pModel->TCJSW*delTemp_Tempt_GND),0.0));
#endif
CJSWD_t=(pModel->CJSWD*bsimbulk_hypsmooth(((1.0+(pModel->TCJSW*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((pModel->CJSWD*bsimbulk_hypsmooth(((1.0+(pModel->TCJSW*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
CJSWGS_t_Tempt_GND=(pModel->CJSWGS*bsimbulk_d_hypsmooth(((1.0+(pModel->TCJSWG*delTemp))-1.0e-6),1.0e-3,(pModel->TCJSWG*delTemp_Tempt_GND),0.0));
#endif
CJSWGS_t=(pModel->CJSWGS*bsimbulk_hypsmooth(((1.0+(pModel->TCJSWG*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((pModel->CJSWGS*bsimbulk_hypsmooth(((1.0+(pModel->TCJSWG*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
CJSWGD_t_Tempt_GND=(pModel->CJSWGD*bsimbulk_d_hypsmooth(((1.0+(pModel->TCJSWG*delTemp))-1.0e-6),1.0e-3,(pModel->TCJSWG*delTemp_Tempt_GND),0.0));
#endif
CJSWGD_t=(pModel->CJSWGD*bsimbulk_hypsmooth(((1.0+(pModel->TCJSWG*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((pModel->CJSWGD*bsimbulk_hypsmooth(((1.0+(pModel->TCJSWG*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
PBS_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->PBS-(pModel->TPB*delTemp))-0.01),1.0e-3,(-(pModel->TPB*delTemp_Tempt_GND)),0.0);
#endif
PBS_t=(bsimbulk_hypsmooth(((pModel->PBS-(pModel->TPB*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->PBS-(pModel->TPB*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
PBD_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->PBD-(pModel->TPB*delTemp))-0.01),1.0e-3,(-(pModel->TPB*delTemp_Tempt_GND)),0.0);
#endif
PBD_t=(bsimbulk_hypsmooth(((pModel->PBD-(pModel->TPB*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->PBD-(pModel->TPB*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
PBSWS_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->PBSWS-(pModel->TPBSW*delTemp))-0.01),1.0e-3,(-(pModel->TPBSW*delTemp_Tempt_GND)),0.0);
#endif
PBSWS_t=(bsimbulk_hypsmooth(((pModel->PBSWS-(pModel->TPBSW*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->PBSWS-(pModel->TPBSW*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
PBSWD_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->PBSWD-(pModel->TPBSW*delTemp))-0.01),1.0e-3,(-(pModel->TPBSW*delTemp_Tempt_GND)),0.0);
#endif
PBSWD_t=(bsimbulk_hypsmooth(((pModel->PBSWD-(pModel->TPBSW*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->PBSWD-(pModel->TPBSW*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
PBSWGS_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->PBSWGS-(pModel->TPBSWG*delTemp))-0.01),1.0e-3,(-(pModel->TPBSWG*delTemp_Tempt_GND)),0.0);
#endif
PBSWGS_t=(bsimbulk_hypsmooth(((pModel->PBSWGS-(pModel->TPBSWG*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->PBSWGS-(pModel->TPBSWG*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
PBSWGD_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->PBSWGD-(pModel->TPBSWG*delTemp))-0.01),1.0e-3,(-(pModel->TPBSWG*delTemp_Tempt_GND)),0.0);
#endif
PBSWGD_t=(bsimbulk_hypsmooth(((pModel->PBSWGD-(pModel->TPBSWG*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->PBSWGD-(pModel->TPBSWG*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm));
#endif
#endif
T0=((Eg0/Vtm0)-(Eg/Vtm));
EXIT_IF_ISNAN(((Eg0/Vtm0)-(Eg/Vtm)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lln(TRatio,TRatio_Tempt_GND);
#endif
#endif
T1=bsimbulk_lln(TRatio);
EXIT_IF_ISNAN(bsimbulk_lln(TRatio))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=0.0;
  T3_Vdi_bi_Vgm_di=0.0;
  T3_Vdi_bi_Vdbulk_di=0.0;
  T3_Vdi_bi_Vsbulk_si=0.0;
  T3_Vdi_bi_Vgi_bi=0.0;
  T3_Vdi_bi_Vdi_bi=0.0;
  T3_Vdi_bi_Vsi_bi=0.0;
  T3_Vdi_bi_Tempt_GND=0.0;
#endif
T3_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=0.0;
  T3_Vsi_bi_Vgm_di=0.0;
  T3_Vsi_bi_Vdbulk_di=0.0;
  T3_Vsi_bi_Vsbulk_si=0.0;
  T3_Vsi_bi_Vgi_bi=0.0;
  T3_Vsi_bi_Vdi_bi=0.0;
  T3_Vsi_bi_Vsi_bi=0.0;
  T3_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(((T0+(pModel->XTIS*T1))/pModel->NJS),((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))/pModel->NJS));
#endif
#endif
T3=bsimbulk_lexp(((T0+(pModel->XTIS*T1))/pModel->NJS));
EXIT_IF_ISNAN(bsimbulk_lexp(((T0+(pModel->XTIS*T1))/pModel->NJS)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
JSS_t_Tempt_GND=(pModel->JSS*T3_Tempt_GND);
#endif
JSS_t=(pModel->JSS*T3);
EXIT_IF_ISNAN((pModel->JSS*T3))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
JSWS_t_Tempt_GND=(pModel->JSWS*T3_Tempt_GND);
#endif
JSWS_t=(pModel->JSWS*T3);
EXIT_IF_ISNAN((pModel->JSWS*T3))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
JSWGS_t_Tempt_GND=(pModel->JSWGS*T3_Tempt_GND);
#endif
JSWGS_t=(pModel->JSWGS*T3);
EXIT_IF_ISNAN((pModel->JSWGS*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=0.0;
  T3_Vdi_bi_Vgm_di=0.0;
  T3_Vdi_bi_Vdbulk_di=0.0;
  T3_Vdi_bi_Vsbulk_si=0.0;
  T3_Vdi_bi_Vgi_bi=0.0;
  T3_Vdi_bi_Vdi_bi=0.0;
  T3_Vdi_bi_Vsi_bi=0.0;
  T3_Vdi_bi_Tempt_GND=0.0;
#endif
T3_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=0.0;
  T3_Vsi_bi_Vgm_di=0.0;
  T3_Vsi_bi_Vdbulk_di=0.0;
  T3_Vsi_bi_Vsbulk_si=0.0;
  T3_Vsi_bi_Vgi_bi=0.0;
  T3_Vsi_bi_Vdi_bi=0.0;
  T3_Vsi_bi_Vsi_bi=0.0;
  T3_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(((T0+(pModel->XTID*T1))/pModel->NJD),((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))/pModel->NJD));
#endif
#endif
T3=bsimbulk_lexp(((T0+(pModel->XTID*T1))/pModel->NJD));
EXIT_IF_ISNAN(bsimbulk_lexp(((T0+(pModel->XTID*T1))/pModel->NJD)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
JSD_t_Tempt_GND=(pModel->JSD*T3_Tempt_GND);
#endif
JSD_t=(pModel->JSD*T3);
EXIT_IF_ISNAN((pModel->JSD*T3))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
JSWD_t_Tempt_GND=(pModel->JSWD*T3_Tempt_GND);
#endif
JSWD_t=(pModel->JSWD*T3);
EXIT_IF_ISNAN((pModel->JSWD*T3))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
JSWGD_t_Tempt_GND=(pModel->JSWGD*T3_Tempt_GND);
#endif
JSWGD_t=(pModel->JSWGD*T3);
EXIT_IF_ISNAN((pModel->JSWGD*T3))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSS_t_Tempt_GND=(pModel->JTSS*bsimbulk_d_lexp((((Eg0*pModel->XTSS)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSS)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSS)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSS_t=(pModel->JTSS*bsimbulk_lexp((((Eg0*pModel->XTSS)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN((pModel->JTSS*bsimbulk_lexp((((Eg0*pModel->XTSS)*(TRatio-1.0))/Vtm))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWS_t_Tempt_GND=(pModel->JTSSWS*bsimbulk_d_lexp((((Eg0*pModel->XTSSWS)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSSWS)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSSWS)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSSWS_t=(pModel->JTSSWS*bsimbulk_lexp((((Eg0*pModel->XTSSWS)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN((pModel->JTSSWS*bsimbulk_lexp((((Eg0*pModel->XTSSWS)*(TRatio-1.0))/Vtm))))
{
double m00_sqrt(d00_sqrt0,(pModel->JTWEFF/Weffcj))
#if defined(_DERIVATE)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWGS_t_Tempt_GND=((pModel->JTSSWGS*(d00_sqrt0+1.0))*bsimbulk_d_lexp((((Eg0*pModel->XTSSWGS)*(TRatio-1))/Vtm),((((Eg0*pModel->XTSSWGS)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSSWGS)*(TRatio-1))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSSWGS_t=((pModel->JTSSWGS*(d00_sqrt0+1.0))*bsimbulk_lexp((((Eg0*pModel->XTSSWGS)*(TRatio-1))/Vtm)));
EXIT_IF_ISNAN(((pModel->JTSSWGS*(d00_sqrt0+1.0))*bsimbulk_lexp((((Eg0*pModel->XTSSWGS)*(TRatio-1))/Vtm))))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSD_t_Tempt_GND=(pModel->JTSD*bsimbulk_d_lexp((((Eg0*pModel->XTSD)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSD)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSD)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSD_t=(pModel->JTSD*bsimbulk_lexp((((Eg0*pModel->XTSD)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN((pModel->JTSD*bsimbulk_lexp((((Eg0*pModel->XTSD)*(TRatio-1.0))/Vtm))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWD_t_Tempt_GND=(pModel->JTSSWD*bsimbulk_d_lexp((((Eg0*pModel->XTSSWD)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSSWD)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSSWD)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSSWD_t=(pModel->JTSSWD*bsimbulk_lexp((((Eg0*pModel->XTSSWD)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN((pModel->JTSSWD*bsimbulk_lexp((((Eg0*pModel->XTSSWD)*(TRatio-1.0))/Vtm))))
{
double m00_sqrt(d00_sqrt0,(pModel->JTWEFF/Weffcj))
#if defined(_DERIVATE)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWGD_t_Tempt_GND=((pModel->JTSSWGD*(d00_sqrt0+1.0))*bsimbulk_d_lexp((((Eg0*pModel->XTSSWGD)*(TRatio-1))/Vtm),((((Eg0*pModel->XTSSWGD)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSSWGD)*(TRatio-1))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSSWGD_t=((pModel->JTSSWGD*(d00_sqrt0+1.0))*bsimbulk_lexp((((Eg0*pModel->XTSSWGD)*(TRatio-1))/Vtm)));
EXIT_IF_ISNAN(((pModel->JTSSWGD*(d00_sqrt0+1.0))*bsimbulk_lexp((((Eg0*pModel->XTSSWGD)*(TRatio-1))/Vtm))))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
NJTS_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->NJTS*(1.0+(pModel->TNJTS*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTS*(pModel->TNJTS*TRatio_Tempt_GND)),0.0);
#endif
NJTS_t=(bsimbulk_hypsmooth(((pModel->NJTS*(1.0+(pModel->TNJTS*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->NJTS*(1.0+(pModel->TNJTS*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
NJTSSW_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->NJTSSW*(1.0+(pModel->TNJTSSW*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSSW*(pModel->TNJTSSW*TRatio_Tempt_GND)),0.0);
#endif
NJTSSW_t=(bsimbulk_hypsmooth(((pModel->NJTSSW*(1.0+(pModel->TNJTSSW*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->NJTSSW*(1.0+(pModel->TNJTSSW*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
NJTSSWG_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->NJTSSWG*(1.0+(pModel->TNJTSSWG*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSSWG*(pModel->TNJTSSWG*TRatio_Tempt_GND)),0.0);
#endif
NJTSSWG_t=(bsimbulk_hypsmooth(((pModel->NJTSSWG*(1.0+(pModel->TNJTSSWG*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->NJTSSWG*(1.0+(pModel->TNJTSSWG*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
NJTSD_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->NJTSD*(1.0+(pModel->TNJTSD*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSD*(pModel->TNJTSD*TRatio_Tempt_GND)),0.0);
#endif
NJTSD_t=(bsimbulk_hypsmooth(((pModel->NJTSD*(1.0+(pModel->TNJTSD*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->NJTSD*(1.0+(pModel->TNJTSD*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
NJTSSWD_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->NJTSSWD*(1.0+(pModel->TNJTSSWD*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSSWD*(pModel->TNJTSSWD*TRatio_Tempt_GND)),0.0);
#endif
NJTSSWD_t=(bsimbulk_hypsmooth(((pModel->NJTSSWD*(1.0+(pModel->TNJTSSWD*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->NJTSSWD*(1.0+(pModel->TNJTSSWD*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
NJTSSWGD_t_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->NJTSSWGD*(1.0+(pModel->TNJTSSWGD*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSSWGD*(pModel->TNJTSSWGD*TRatio_Tempt_GND)),0.0);
#endif
NJTSSWGD_t=(bsimbulk_hypsmooth(((pModel->NJTSSWGD*(1.0+(pModel->TNJTSSWGD*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->NJTSSWGD*(1.0+(pModel->TNJTSSWGD*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
{
if
((pInst->GEOMOD<9))
{
if
(((pInst->NF%2)!=0))
{
nuEndD=1.0;
EXIT_IF_ISNAN(1.0)
nuEndS=1.0;
EXIT_IF_ISNAN(1.0)
{
double m00_max(d00_max0,((pInst->NF-1.0)/2.0),0.0)
nuIntD=(2.0*d00_max0);
EXIT_IF_ISNAN((2.0*d00_max0))
}
nuIntS=nuIntD;
EXIT_IF_ISNAN(nuIntD)
}
else
{
if
((pInst->MINZ==1))
{
nuEndD=2.0;
EXIT_IF_ISNAN(2.0)
{
double m00_max(d00_max0,((pInst->NF/2.0)-1.0),0.0)
nuIntD=(2.0*d00_max0);
EXIT_IF_ISNAN((2.0*d00_max0))
}
nuEndS=0.0;
EXIT_IF_ISNAN(0.0)
nuIntS=pInst->NF;
EXIT_IF_ISNAN(pInst->NF)
}
else
{
nuEndD=0.0;
EXIT_IF_ISNAN(0.0)
nuIntD=pInst->NF;
EXIT_IF_ISNAN(pInst->NF)
nuEndS=2.0;
EXIT_IF_ISNAN(2.0)
{
double m00_max(d00_max0,((pInst->NF/2.0)-1.0),0.0)
nuIntS=(2.0*d00_max0);
EXIT_IF_ISNAN((2.0*d00_max0))
}
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=0.0;
#endif
#endif
T0=(DMCGeff+DMCIeff);
EXIT_IF_ISNAN((DMCGeff+DMCIeff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=(DMCGeff+DMCGeff);
EXIT_IF_ISNAN((DMCGeff+DMCGeff))
T2y=(DMDGeff+DMDGeff);
EXIT_IF_ISNAN((DMDGeff+DMDGeff))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
PSiso_Tempt_GND=(T0_Tempt_GND+T0_Tempt_GND);
#endif
PSiso=((T0+T0)+Weffcj);
EXIT_IF_ISNAN(((T0+T0)+Weffcj))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
PDiso_Tempt_GND=(T0_Tempt_GND+T0_Tempt_GND);
#endif
PDiso=((T0+T0)+Weffcj);
EXIT_IF_ISNAN(((T0+T0)+Weffcj))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
PSsha_Tempt_GND=T1_Tempt_GND;
#endif
PSsha=T1;
EXIT_IF_ISNAN(T1)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
PDsha_Tempt_GND=T1_Tempt_GND;
#endif
PDsha=T1;
EXIT_IF_ISNAN(T1)
PSmer=T2y;
EXIT_IF_ISNAN(T2y)
PDmer=T2y;
EXIT_IF_ISNAN(T2y)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
ASiso_Tempt_GND=T0_Tempt_GND*Weffcj;
#endif
ASiso=(T0*Weffcj);
EXIT_IF_ISNAN((T0*Weffcj))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
ADiso_Tempt_GND=T0_Tempt_GND*Weffcj;
#endif
ADiso=(T0*Weffcj);
EXIT_IF_ISNAN((T0*Weffcj))
ASsha=(DMCGeff*Weffcj);
EXIT_IF_ISNAN((DMCGeff*Weffcj))
ADsha=(DMCGeff*Weffcj);
EXIT_IF_ISNAN((DMCGeff*Weffcj))
ASmer=(DMDGeff*Weffcj);
EXIT_IF_ISNAN((DMDGeff*Weffcj))
ADmer=(DMDGeff*Weffcj);
EXIT_IF_ISNAN((DMDGeff*Weffcj))
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pInst->GEOMOD)==(0)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=((nuEndS*PSiso_Tempt_GND)+(nuIntS*PSsha_Tempt_GND));
#endif
temp_PSeff=((nuEndS*PSiso)+(nuIntS*PSsha));
EXIT_IF_ISNAN(((nuEndS*PSiso)+(nuIntS*PSsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=((nuEndD*PDiso_Tempt_GND)+(nuIntD*PDsha_Tempt_GND));
#endif
temp_PDeff=((nuEndD*PDiso)+(nuIntD*PDsha));
EXIT_IF_ISNAN(((nuEndD*PDiso)+(nuIntD*PDsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=(nuEndS*ASiso_Tempt_GND);
#endif
temp_ASeff=((nuEndS*ASiso)+(nuIntS*ASsha));
EXIT_IF_ISNAN(((nuEndS*ASiso)+(nuIntS*ASsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=(nuEndD*ADiso_Tempt_GND);
#endif
temp_ADeff=((nuEndD*ADiso)+(nuIntD*ADsha));
EXIT_IF_ISNAN(((nuEndD*ADiso)+(nuIntD*ADsha)))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(1)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=((nuEndS*PSiso_Tempt_GND)+(nuIntS*PSsha_Tempt_GND));
#endif
temp_PSeff=((nuEndS*PSiso)+(nuIntS*PSsha));
EXIT_IF_ISNAN(((nuEndS*PSiso)+(nuIntS*PSsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=((nuEndD+nuIntD)*PDsha_Tempt_GND);
#endif
temp_PDeff=((nuEndD+nuIntD)*PDsha);
EXIT_IF_ISNAN(((nuEndD+nuIntD)*PDsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=(nuEndS*ASiso_Tempt_GND);
#endif
temp_ASeff=((nuEndS*ASiso)+(nuIntS*ASsha));
EXIT_IF_ISNAN(((nuEndS*ASiso)+(nuIntS*ASsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=0.0;
#endif
temp_ADeff=((nuEndD+nuIntD)*ADsha);
EXIT_IF_ISNAN(((nuEndD+nuIntD)*ADsha))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(2)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=((nuEndS+nuIntS)*PSsha_Tempt_GND);
#endif
temp_PSeff=((nuEndS+nuIntS)*PSsha);
EXIT_IF_ISNAN(((nuEndS+nuIntS)*PSsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=((nuEndD*PDiso_Tempt_GND)+(nuIntD*PDsha_Tempt_GND));
#endif
temp_PDeff=((nuEndD*PDiso)+(nuIntD*PDsha));
EXIT_IF_ISNAN(((nuEndD*PDiso)+(nuIntD*PDsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=0.0;
#endif
temp_ASeff=((nuEndS+nuIntS)*ASsha);
EXIT_IF_ISNAN(((nuEndS+nuIntS)*ASsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=(nuEndD*ADiso_Tempt_GND);
#endif
temp_ADeff=((nuEndD*ADiso)+(nuIntD*ADsha));
EXIT_IF_ISNAN(((nuEndD*ADiso)+(nuIntD*ADsha)))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(3)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=((nuEndS+nuIntS)*PSsha_Tempt_GND);
#endif
temp_PSeff=((nuEndS+nuIntS)*PSsha);
EXIT_IF_ISNAN(((nuEndS+nuIntS)*PSsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=((nuEndD+nuIntD)*PDsha_Tempt_GND);
#endif
temp_PDeff=((nuEndD+nuIntD)*PDsha);
EXIT_IF_ISNAN(((nuEndD+nuIntD)*PDsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=0.0;
#endif
temp_ASeff=((nuEndS+nuIntS)*ASsha);
EXIT_IF_ISNAN(((nuEndS+nuIntS)*ASsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=0.0;
#endif
temp_ADeff=((nuEndD+nuIntD)*ADsha);
EXIT_IF_ISNAN(((nuEndD+nuIntD)*ADsha))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(4)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=((nuEndS*PSiso_Tempt_GND)+(nuIntS*PSsha_Tempt_GND));
#endif
temp_PSeff=((nuEndS*PSiso)+(nuIntS*PSsha));
EXIT_IF_ISNAN(((nuEndS*PSiso)+(nuIntS*PSsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=(nuIntD*PDsha_Tempt_GND);
#endif
temp_PDeff=((nuEndD*PDmer)+(nuIntD*PDsha));
EXIT_IF_ISNAN(((nuEndD*PDmer)+(nuIntD*PDsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=(nuEndS*ASiso_Tempt_GND);
#endif
temp_ASeff=((nuEndS*ASiso)+(nuIntS*ASsha));
EXIT_IF_ISNAN(((nuEndS*ASiso)+(nuIntS*ASsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=0.0;
#endif
temp_ADeff=((nuEndD*ADmer)+(nuIntD*ADsha));
EXIT_IF_ISNAN(((nuEndD*ADmer)+(nuIntD*ADsha)))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(5)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=((nuEndS+nuIntS)*PSsha_Tempt_GND);
#endif
temp_PSeff=((nuEndS+nuIntS)*PSsha);
EXIT_IF_ISNAN(((nuEndS+nuIntS)*PSsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=(nuIntD*PDsha_Tempt_GND);
#endif
temp_PDeff=((nuEndD*PDmer)+(nuIntD*PDsha));
EXIT_IF_ISNAN(((nuEndD*PDmer)+(nuIntD*PDsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=0.0;
#endif
temp_ASeff=((nuEndS+nuIntS)*ASsha);
EXIT_IF_ISNAN(((nuEndS+nuIntS)*ASsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=0.0;
#endif
temp_ADeff=((nuEndD*ADmer)+(nuIntD*ADsha));
EXIT_IF_ISNAN(((nuEndD*ADmer)+(nuIntD*ADsha)))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(6)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=(nuIntS*PSsha_Tempt_GND);
#endif
temp_PSeff=((nuEndS*PSmer)+(nuIntS*PSsha));
EXIT_IF_ISNAN(((nuEndS*PSmer)+(nuIntS*PSsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=((nuEndD*PDiso_Tempt_GND)+(nuIntD*PDsha_Tempt_GND));
#endif
temp_PDeff=((nuEndD*PDiso)+(nuIntD*PDsha));
EXIT_IF_ISNAN(((nuEndD*PDiso)+(nuIntD*PDsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=0.0;
#endif
temp_ASeff=((nuEndS*ASmer)+(nuIntS*ASsha));
EXIT_IF_ISNAN(((nuEndS*ASmer)+(nuIntS*ASsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=(nuEndD*ADiso_Tempt_GND);
#endif
temp_ADeff=((nuEndD*ADiso)+(nuIntD*ADsha));
EXIT_IF_ISNAN(((nuEndD*ADiso)+(nuIntD*ADsha)))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(7)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=(nuIntS*PSsha_Tempt_GND);
#endif
temp_PSeff=((nuEndS*PSmer)+(nuIntS*PSsha));
EXIT_IF_ISNAN(((nuEndS*PSmer)+(nuIntS*PSsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=((nuEndD+nuIntD)*PDsha_Tempt_GND);
#endif
temp_PDeff=((nuEndD+nuIntD)*PDsha);
EXIT_IF_ISNAN(((nuEndD+nuIntD)*PDsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=0.0;
#endif
temp_ASeff=((nuEndS*ASmer)+(nuIntS*ASsha));
EXIT_IF_ISNAN(((nuEndS*ASmer)+(nuIntS*ASsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=0.0;
#endif
temp_ADeff=((nuEndD+nuIntD)*ADsha);
EXIT_IF_ISNAN(((nuEndD+nuIntD)*ADsha))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(8)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=(nuIntS*PSsha_Tempt_GND);
#endif
temp_PSeff=((nuEndS*PSmer)+(nuIntS*PSsha));
EXIT_IF_ISNAN(((nuEndS*PSmer)+(nuIntS*PSsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=(nuIntD*PDsha_Tempt_GND);
#endif
temp_PDeff=((nuEndD*PDmer)+(nuIntD*PDsha));
EXIT_IF_ISNAN(((nuEndD*PDmer)+(nuIntD*PDsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=0.0;
#endif
temp_ASeff=((nuEndS*ASmer)+(nuIntS*ASsha));
EXIT_IF_ISNAN(((nuEndS*ASmer)+(nuIntS*ASsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=0.0;
#endif
temp_ADeff=((nuEndD*ADmer)+(nuIntD*ADsha));
EXIT_IF_ISNAN(((nuEndD*ADmer)+(nuIntD*ADsha)))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(9)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=(PSiso_Tempt_GND+((pInst->NF-1.0)*PSsha_Tempt_GND));
#endif
temp_PSeff=(PSiso+((pInst->NF-1.0)*PSsha));
EXIT_IF_ISNAN((PSiso+((pInst->NF-1.0)*PSsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=(pInst->NF*PDsha_Tempt_GND);
#endif
temp_PDeff=(pInst->NF*PDsha);
EXIT_IF_ISNAN((pInst->NF*PDsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=ASiso_Tempt_GND;
#endif
temp_ASeff=(ASiso+((pInst->NF-1.0)*ASsha));
EXIT_IF_ISNAN((ASiso+((pInst->NF-1.0)*ASsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=0.0;
#endif
temp_ADeff=(pInst->NF*ADsha);
EXIT_IF_ISNAN((pInst->NF*ADsha))
}
else
/* CASE ITEM */
if
(((pInst->GEOMOD)==(10)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=(pInst->NF*PSsha_Tempt_GND);
#endif
temp_PSeff=(pInst->NF*PSsha);
EXIT_IF_ISNAN((pInst->NF*PSsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=(PDiso_Tempt_GND+((pInst->NF-1.0)*PDsha_Tempt_GND));
#endif
temp_PDeff=(PDiso+((pInst->NF-1.0)*PDsha));
EXIT_IF_ISNAN((PDiso+((pInst->NF-1.0)*PDsha)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=0.0;
#endif
temp_ASeff=(pInst->NF*ASsha);
EXIT_IF_ISNAN((pInst->NF*ASsha))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=ADiso_Tempt_GND;
#endif
temp_ADeff=(ADiso+((pInst->NF-1.0)*ADsha));
EXIT_IF_ISNAN((ADiso+((pInst->NF-1.0)*ADsha)))
}
else
/* CASE DEFAULT */
{
printf("Warning: (instance BSIMBULK) Specified GEO=%d not matched (BSIMBULKPAeffGeo \
            ), PS,PD,AS,AD set to zero.",pInst->GEOMOD);
printf("\n");
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_PSeff_Tempt_GND=0.0;
#endif
temp_PSeff=0;
EXIT_IF_ISNAN(0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_PDeff_Tempt_GND=0.0;
#endif
temp_PDeff=0;
EXIT_IF_ISNAN(0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
temp_ASeff_Tempt_GND=0.0;
#endif
temp_ASeff=0;
EXIT_IF_ISNAN(0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
temp_ADeff_Tempt_GND=0.0;
#endif
temp_ADeff=0;
EXIT_IF_ISNAN(0)
}
/* -- CASE END -- */;
}
if
((here->AS_Given))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
ASeff_Tempt_GND=0.0;
#endif
ASeff=((pInst->AS*pModel->WMLT)*pModel->LMLT);
EXIT_IF_ISNAN(((pInst->AS*pModel->WMLT)*pModel->LMLT))
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
ASeff_Tempt_GND=temp_ASeff_Tempt_GND;
#endif
ASeff=temp_ASeff;
EXIT_IF_ISNAN(temp_ASeff)
}
if
((ASeff<0.0))
{
printf("Warning: (instance BSIMBULK) ASeff = %e is negative, set to zero.",ASeff);
printf("\n");
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
ASeff_Tempt_GND=0.0;
#endif
ASeff=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((here->AD_Given))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
ADeff_Tempt_GND=0.0;
#endif
ADeff=((pInst->AD*pModel->WMLT)*pModel->LMLT);
EXIT_IF_ISNAN(((pInst->AD*pModel->WMLT)*pModel->LMLT))
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
ADeff_Tempt_GND=temp_ADeff_Tempt_GND;
#endif
ADeff=temp_ADeff;
EXIT_IF_ISNAN(temp_ADeff)
}
if
((ADeff<0.0))
{
printf("Warning: (instance BSIMBULK) ADeff = %e is negative, set to zero.",ADeff);
printf("\n");
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
ADeff_Tempt_GND=0.0;
#endif
ADeff=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((here->PS_Given))
{
if
((pModel->PERMOD==0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
PSeff_Tempt_GND=0.0;
#endif
PSeff=(pInst->PS*pModel->WMLT);
EXIT_IF_ISNAN((pInst->PS*pModel->WMLT))
}
else
{
{
double m00_max(d00_max0,((pInst->PS*pModel->WMLT)-(Weffcj*pInst->NF)),0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
PSeff_Tempt_GND=0.0;
#endif
PSeff=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
}
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
PSeff_Tempt_GND=temp_PSeff_Tempt_GND;
#endif
PSeff=temp_PSeff;
EXIT_IF_ISNAN(temp_PSeff)
if
((PSeff<0.0))
{
printf("Warning: (instance BSIMBULK) PSeff = %e is negative.Set to 0.0",PSeff);
printf("\n");
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
PSeff_Tempt_GND=0.0;
#endif
PSeff=0.0;
EXIT_IF_ISNAN(0.0)
}
}
if
((here->PD_Given))
{
if
((pModel->PERMOD==0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
PDeff_Tempt_GND=0.0;
#endif
PDeff=(pInst->PD*pModel->WMLT);
EXIT_IF_ISNAN((pInst->PD*pModel->WMLT))
}
else
{
{
double m00_max(d00_max0,((pInst->PD*pModel->WMLT)-(Weffcj*pInst->NF)),0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
PDeff_Tempt_GND=0.0;
#endif
PDeff=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
}
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
PDeff_Tempt_GND=temp_PDeff_Tempt_GND;
#endif
PDeff=temp_PDeff;
EXIT_IF_ISNAN(temp_PDeff)
if
((PDeff<0.0))
{
printf("Warning: (instance BSIMBULK) PDeff = %e is negative.Set to 0.0",PDeff);
printf("\n");
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
PDeff_Tempt_GND=0.0;
#endif
PDeff=0.0;
EXIT_IF_ISNAN(0.0)
}
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Isbs_Tempt_GND=((((ASeff_Tempt_GND*JSS_t)+(ASeff*JSS_t_Tempt_GND))+((PSeff_Tempt_GND*JSWS_t)+(PSeff*JSWS_t_Tempt_GND)))+((Weffcj*pInst->NF)*JSWGS_t_Tempt_GND));
#endif
Isbs=(((ASeff*JSS_t)+(PSeff*JSWS_t))+((Weffcj*pInst->NF)*JSWGS_t));
EXIT_IF_ISNAN((((ASeff*JSS_t)+(PSeff*JSWS_t))+((Weffcj*pInst->NF)*JSWGS_t)))
if
((Isbs>0.0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
Nvtms_Tempt_GND=Vtm_Tempt_GND*pModel->NJS;
#endif
Nvtms=(Vtm*pModel->NJS);
EXIT_IF_ISNAN((Vtm*pModel->NJS))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
XExpBVS_Tempt_GND=bsimbulk_d_lexp(((-pModel->BVS)/Nvtms),(-(-pModel->BVS)*Nvtms_Tempt_GND/Nvtms/Nvtms))*pModel->XJBVS;
#endif
XExpBVS=(bsimbulk_lexp(((-pModel->BVS)/Nvtms))*pModel->XJBVS);
EXIT_IF_ISNAN((bsimbulk_lexp(((-pModel->BVS)/Nvtms))*pModel->XJBVS))
{
double m00_max(d00_max0,(pModel->IJTHSFWD/Isbs),10.0)
#if defined(_DERIVATEFORDDX)
double m10_max(d10_max0,d00_max0,(pModel->IJTHSFWD/Isbs),10.0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(d10_max0*(-pModel->IJTHSFWD*Isbs_Tempt_GND/Isbs/Isbs));
#endif
#endif
T2=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Tb_Tempt_GND=(T2_Tempt_GND-XExpBVS_Tempt_GND);
#endif
Tb=((1.0+T2)-XExpBVS);
EXIT_IF_ISNAN(((1.0+T2)-XExpBVS))
{
double m00_sqrt(d00_sqrt0,((Tb*Tb)+(4.0*XExpBVS)))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Tb*Tb)+(4.0*XExpBVS)))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VjsmFwd_Tempt_GND=((Nvtms_Tempt_GND*bsimbulk_lln((0.5*(Tb+d00_sqrt0))))+(Nvtms*bsimbulk_d_lln((0.5*(Tb+d00_sqrt0)),(0.5*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVS_Tempt_GND))*d10_sqrt0)))));
#endif
VjsmFwd=(Nvtms*bsimbulk_lln((0.5*(Tb+d00_sqrt0))));
EXIT_IF_ISNAN((Nvtms*bsimbulk_lln((0.5*(Tb+d00_sqrt0)))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=bsimbulk_d_lexp((VjsmFwd/Nvtms),((VjsmFwd_Tempt_GND*Nvtms-VjsmFwd*Nvtms_Tempt_GND)/Nvtms/Nvtms));
#endif
#endif
T0=bsimbulk_lexp((VjsmFwd/Nvtms));
EXIT_IF_ISNAN(bsimbulk_lexp((VjsmFwd/Nvtms)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
IVjsmFwd_Tempt_GND=((Isbs_Tempt_GND*(((T0-(XExpBVS/T0))+XExpBVS)-1.0))+(Isbs*((T0_Tempt_GND-((XExpBVS_Tempt_GND*T0-XExpBVS*T0_Tempt_GND)/T0/T0))+XExpBVS_Tempt_GND)));
#endif
IVjsmFwd=(Isbs*(((T0-(XExpBVS/T0))+XExpBVS)-1.0));
EXIT_IF_ISNAN((Isbs*(((T0-(XExpBVS/T0))+XExpBVS)-1.0)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
SslpFwd_Tempt_GND=((((Isbs_Tempt_GND*(T0+(XExpBVS/T0)))+(Isbs*(T0_Tempt_GND+((XExpBVS_Tempt_GND*T0-XExpBVS*T0_Tempt_GND)/T0/T0))))*Nvtms-(Isbs*(T0+(XExpBVS/T0)))*Nvtms_Tempt_GND)/Nvtms/Nvtms);
#endif
SslpFwd=((Isbs*(T0+(XExpBVS/T0)))/Nvtms);
EXIT_IF_ISNAN(((Isbs*(T0+(XExpBVS/T0)))/Nvtms))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->IJTHSREV/Isbs)-10.0),1.0e-3,(-pModel->IJTHSREV*Isbs_Tempt_GND/Isbs/Isbs),0.0);
#endif
#endif
T2=(bsimbulk_hypsmooth(((pModel->IJTHSREV/Isbs)-10.0),1.0e-3)+10.0);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->IJTHSREV/Isbs)-10.0),1.0e-3)+10.0))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
VjsmRev_Tempt_GND=(-((Nvtms_Tempt_GND*bsimbulk_lln(((T2-1.0)/pModel->XJBVS)))+(Nvtms*bsimbulk_d_lln(((T2-1.0)/pModel->XJBVS),(T2_Tempt_GND/pModel->XJBVS)))));
#endif
VjsmRev=((-pModel->BVS)-(Nvtms*bsimbulk_lln(((T2-1.0)/pModel->XJBVS))));
EXIT_IF_ISNAN(((-pModel->BVS)-(Nvtms*bsimbulk_lln(((T2-1.0)/pModel->XJBVS)))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(pModel->XJBVS*bsimbulk_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms)));
#endif
#endif
T1=(pModel->XJBVS*bsimbulk_lexp(((-(pModel->BVS+VjsmRev))/Nvtms)));
EXIT_IF_ISNAN((pModel->XJBVS*bsimbulk_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
IVjsmRev_Tempt_GND=((Isbs_Tempt_GND*(1.0+T1))+(Isbs*T1_Tempt_GND));
#endif
IVjsmRev=(Isbs*(1.0+T1));
EXIT_IF_ISNAN((Isbs*(1.0+T1)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
SslpRev_Tempt_GND=(((((-Isbs_Tempt_GND)*T1)+((-Isbs)*T1_Tempt_GND))*Nvtms-((-Isbs)*T1)*Nvtms_Tempt_GND)/Nvtms/Nvtms);
#endif
SslpRev=(((-Isbs)*T1)/Nvtms);
EXIT_IF_ISNAN((((-Isbs)*T1)/Nvtms))
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
Nvtms_Tempt_GND=0.0;
#endif
Nvtms=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
XExpBVS_Tempt_GND=0.0;
#endif
XExpBVS=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VjsmFwd_Tempt_GND=0.0;
#endif
VjsmFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
IVjsmFwd_Tempt_GND=0.0;
#endif
IVjsmFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
SslpFwd_Tempt_GND=0.0;
#endif
SslpFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
VjsmRev_Tempt_GND=0.0;
#endif
VjsmRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
IVjsmRev_Tempt_GND=0.0;
#endif
IVjsmRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
SslpRev_Tempt_GND=0.0;
#endif
SslpRev=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Isbd_Tempt_GND=((((ADeff_Tempt_GND*JSD_t)+(ADeff*JSD_t_Tempt_GND))+((PDeff_Tempt_GND*JSWD_t)+(PDeff*JSWD_t_Tempt_GND)))+((Weffcj*pInst->NF)*JSWGD_t_Tempt_GND));
#endif
Isbd=(((ADeff*JSD_t)+(PDeff*JSWD_t))+((Weffcj*pInst->NF)*JSWGD_t));
EXIT_IF_ISNAN((((ADeff*JSD_t)+(PDeff*JSWD_t))+((Weffcj*pInst->NF)*JSWGD_t)))
if
((Isbd>0.0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
Nvtmd_Tempt_GND=Vtm_Tempt_GND*pModel->NJD;
#endif
Nvtmd=(Vtm*pModel->NJD);
EXIT_IF_ISNAN((Vtm*pModel->NJD))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
XExpBVD_Tempt_GND=bsimbulk_d_lexp(((-pModel->BVD)/Nvtmd),(-(-pModel->BVD)*Nvtmd_Tempt_GND/Nvtmd/Nvtmd))*pModel->XJBVD;
#endif
XExpBVD=(bsimbulk_lexp(((-pModel->BVD)/Nvtmd))*pModel->XJBVD);
EXIT_IF_ISNAN((bsimbulk_lexp(((-pModel->BVD)/Nvtmd))*pModel->XJBVD))
{
double m00_max(d00_max0,(pModel->IJTHDFWD/Isbd),10.0)
#if defined(_DERIVATEFORDDX)
double m10_max(d10_max0,d00_max0,(pModel->IJTHDFWD/Isbd),10.0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(d10_max0*(-pModel->IJTHDFWD*Isbd_Tempt_GND/Isbd/Isbd));
#endif
#endif
T2=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Tb_Tempt_GND=(T2_Tempt_GND-XExpBVD_Tempt_GND);
#endif
Tb=((1.0+T2)-XExpBVD);
EXIT_IF_ISNAN(((1.0+T2)-XExpBVD))
{
double m00_sqrt(d00_sqrt0,((Tb*Tb)+(4.0*XExpBVD)))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Tb*Tb)+(4.0*XExpBVD)))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VjdmFwd_Tempt_GND=((Nvtmd_Tempt_GND*bsimbulk_lln((0.5*(Tb+d00_sqrt0))))+(Nvtmd*bsimbulk_d_lln((0.5*(Tb+d00_sqrt0)),(0.5*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVD_Tempt_GND))*d10_sqrt0)))));
#endif
VjdmFwd=(Nvtmd*bsimbulk_lln((0.5*(Tb+d00_sqrt0))));
EXIT_IF_ISNAN((Nvtmd*bsimbulk_lln((0.5*(Tb+d00_sqrt0)))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=bsimbulk_d_lexp((VjdmFwd/Nvtmd),((VjdmFwd_Tempt_GND*Nvtmd-VjdmFwd*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd));
#endif
#endif
T0=bsimbulk_lexp((VjdmFwd/Nvtmd));
EXIT_IF_ISNAN(bsimbulk_lexp((VjdmFwd/Nvtmd)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
IVjdmFwd_Tempt_GND=((Isbd_Tempt_GND*(((T0-(XExpBVD/T0))+XExpBVD)-1.0))+(Isbd*((T0_Tempt_GND-((XExpBVD_Tempt_GND*T0-XExpBVD*T0_Tempt_GND)/T0/T0))+XExpBVD_Tempt_GND)));
#endif
IVjdmFwd=(Isbd*(((T0-(XExpBVD/T0))+XExpBVD)-1.0));
EXIT_IF_ISNAN((Isbd*(((T0-(XExpBVD/T0))+XExpBVD)-1.0)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
DslpFwd_Tempt_GND=((((Isbd_Tempt_GND*(T0+(XExpBVD/T0)))+(Isbd*(T0_Tempt_GND+((XExpBVD_Tempt_GND*T0-XExpBVD*T0_Tempt_GND)/T0/T0))))*Nvtmd-(Isbd*(T0+(XExpBVD/T0)))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd);
#endif
DslpFwd=((Isbd*(T0+(XExpBVD/T0)))/Nvtmd);
EXIT_IF_ISNAN(((Isbd*(T0+(XExpBVD/T0)))/Nvtmd))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=bsimbulk_d_hypsmooth(((pModel->IJTHDREV/Isbd)-10.0),1.0e-3,(-pModel->IJTHDREV*Isbd_Tempt_GND/Isbd/Isbd),0.0);
#endif
#endif
T2=(bsimbulk_hypsmooth(((pModel->IJTHDREV/Isbd)-10.0),1.0e-3)+10.0);
EXIT_IF_ISNAN((bsimbulk_hypsmooth(((pModel->IJTHDREV/Isbd)-10.0),1.0e-3)+10.0))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
VjdmRev_Tempt_GND=(-((Nvtmd_Tempt_GND*bsimbulk_lln(((T2-1.0)/pModel->XJBVD)))+(Nvtmd*bsimbulk_d_lln(((T2-1.0)/pModel->XJBVD),(T2_Tempt_GND/pModel->XJBVD)))));
#endif
VjdmRev=((-pModel->BVD)-(Nvtmd*bsimbulk_lln(((T2-1.0)/pModel->XJBVD))));
EXIT_IF_ISNAN(((-pModel->BVD)-(Nvtmd*bsimbulk_lln(((T2-1.0)/pModel->XJBVD)))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(pModel->XJBVD*bsimbulk_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd)));
#endif
#endif
T1=(pModel->XJBVD*bsimbulk_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd)));
EXIT_IF_ISNAN((pModel->XJBVD*bsimbulk_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
IVjdmRev_Tempt_GND=((Isbd_Tempt_GND*(1.0+T1))+(Isbd*T1_Tempt_GND));
#endif
IVjdmRev=(Isbd*(1.0+T1));
EXIT_IF_ISNAN((Isbd*(1.0+T1)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
DslpRev_Tempt_GND=(((((-Isbd_Tempt_GND)*T1)+((-Isbd)*T1_Tempt_GND))*Nvtmd-((-Isbd)*T1)*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd);
#endif
DslpRev=(((-Isbd)*T1)/Nvtmd);
EXIT_IF_ISNAN((((-Isbd)*T1)/Nvtmd))
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
Nvtmd_Tempt_GND=0.0;
#endif
Nvtmd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
XExpBVD_Tempt_GND=0.0;
#endif
XExpBVD=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VjdmFwd_Tempt_GND=0.0;
#endif
VjdmFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
IVjdmFwd_Tempt_GND=0.0;
#endif
IVjdmFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
DslpFwd_Tempt_GND=0.0;
#endif
DslpFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
VjdmRev_Tempt_GND=0.0;
#endif
VjdmRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
IVjdmRev_Tempt_GND=0.0;
#endif
IVjdmRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
DslpRev_Tempt_GND=0.0;
#endif
DslpRev=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((((pInst->SA>0.0)&&(pInst->SB>0.0))&&((pInst->NF==1.0)||((pInst->NF>1.0)&&(pInst->SD>0.0)))))
{
{
double m00_pow(d00_pow0,Lnew,pModel->LLODKU0)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=0.0;
#endif
#endif
T0=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
W_tmp_stress=(Wnew+pModel->WLOD);
EXIT_IF_ISNAN((Wnew+pModel->WLOD))
{
double m00_pow(d00_pow0,W_tmp_stress,pModel->WLODKU0)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
tmp1_stress_Tempt_GND=(((-pModel->LKU0*T0_Tempt_GND/T0/T0)+(-pModel->WKU0*T1_Tempt_GND/T1/T1))+(-pModel->PKU0*((T0_Tempt_GND*T1)+(T0*T1_Tempt_GND))/(T0*T1)/(T0*T1)));
#endif
tmp1_stress=(((pModel->LKU0/T0)+(pModel->WKU0/T1))+(pModel->PKU0/(T0*T1)));
EXIT_IF_ISNAN((((pModel->LKU0/T0)+(pModel->WKU0/T1))+(pModel->PKU0/(T0*T1))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
kstress_u0_Tempt_GND=tmp1_stress_Tempt_GND;
#endif
kstress_u0=(1.0+tmp1_stress);
EXIT_IF_ISNAN((1.0+tmp1_stress))
{
double m00_pow(d00_pow0,Lnew,pModel->LLODVTH)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=0.0;
#endif
#endif
T0=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,W_tmp_stress,pModel->WLODVTH)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
tmp1_stress_vth_Tempt_GND=(((-pModel->LKVTH0*T0_Tempt_GND/T0/T0)+(-pModel->WKVTH0*T1_Tempt_GND/T1/T1))+(-pModel->PKVTH0*((T0_Tempt_GND*T1)+(T0*T1_Tempt_GND))/(T0*T1)/(T0*T1)));
#endif
tmp1_stress_vth=(((pModel->LKVTH0/T0)+(pModel->WKVTH0/T1))+(pModel->PKVTH0/(T0*T1)));
EXIT_IF_ISNAN((((pModel->LKVTH0/T0)+(pModel->WKVTH0/T1))+(pModel->PKVTH0/(T0*T1))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
kstress_vth0_Tempt_GND=tmp1_stress_vth_Tempt_GND;
#endif
kstress_vth0=(1.0+tmp1_stress_vth);
EXIT_IF_ISNAN((1.0+tmp1_stress_vth))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=TRatio_Tempt_GND;
#endif
#endif
T0=(TRatio-1.0);
EXIT_IF_ISNAN((TRatio-1.0))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
ku0_temp_Tempt_GND=((kstress_u0_Tempt_GND*(1.0+(pModel->TKU0*T0)))+(kstress_u0*(pModel->TKU0*T0_Tempt_GND)));
#endif
ku0_temp=((kstress_u0*(1.0+(pModel->TKU0*T0)))+1.0e-9);
EXIT_IF_ISNAN(((kstress_u0*(1.0+(pModel->TKU0*T0)))+1.0e-9))
i=0;
EXIT_IF_ISNAN(0)
while
((i<pInst->NF))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=0.0;
#endif
#endif
T0=((1.0/pInst->NF)/((pInst->SA+(0.5*L_mult))+(i*(pInst->SD+L_mult))));
EXIT_IF_ISNAN(((1.0/pInst->NF)/((pInst->SA+(0.5*L_mult))+(i*(pInst->SD+L_mult)))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=((1.0/pInst->NF)/((pInst->SB+(0.5*L_mult))+(i*(pInst->SD+L_mult))));
EXIT_IF_ISNAN(((1.0/pInst->NF)/((pInst->SB+(0.5*L_mult))+(i*(pInst->SD+L_mult)))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
Inv_sa_Tempt_GND=(Inv_sa_Tempt_GND+T0_Tempt_GND);
#endif
Inv_sa=(Inv_sa+T0);
EXIT_IF_ISNAN((Inv_sa+T0))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
Inv_sb_Tempt_GND=(Inv_sb_Tempt_GND+T1_Tempt_GND);
#endif
Inv_sb=(Inv_sb+T1);
EXIT_IF_ISNAN((Inv_sb+T1))
i=(i+1);
EXIT_IF_ISNAN((i+1))
}
Inv_saref=(1.0/(pModel->SAREF+(0.5*L_mult)));
EXIT_IF_ISNAN((1.0/(pModel->SAREF+(0.5*L_mult))))
Inv_sbref=(1.0/(pModel->SBREF+(0.5*L_mult)));
EXIT_IF_ISNAN((1.0/(pModel->SBREF+(0.5*L_mult))))
Inv_odref=(Inv_saref+Inv_sbref);
EXIT_IF_ISNAN((Inv_saref+Inv_sbref))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
rho_ref_Tempt_GND=(-pModel->KU0*ku0_temp_Tempt_GND/ku0_temp/ku0_temp)*Inv_odref;
#endif
rho_ref=((pModel->KU0/ku0_temp)*Inv_odref);
EXIT_IF_ISNAN(((pModel->KU0/ku0_temp)*Inv_odref))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Inv_od_Tempt_GND=(Inv_sa_Tempt_GND+Inv_sb_Tempt_GND);
#endif
Inv_od=(Inv_sa+Inv_sb);
EXIT_IF_ISNAN((Inv_sa+Inv_sb))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
rho_Tempt_GND=(((-pModel->KU0*ku0_temp_Tempt_GND/ku0_temp/ku0_temp)*Inv_od)+((pModel->KU0/ku0_temp)*Inv_od_Tempt_GND));
#endif
rho=((pModel->KU0/ku0_temp)*Inv_od);
EXIT_IF_ISNAN(((pModel->KU0/ku0_temp)*Inv_od))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
mu0_mult_Tempt_GND=((rho_Tempt_GND*(1.0+rho_ref)-(1.0+rho)*rho_ref_Tempt_GND)/(1.0+rho_ref)/(1.0+rho_ref));
#endif
mu0_mult=((1.0+rho)/(1.0+rho_ref));
EXIT_IF_ISNAN(((1.0+rho)/(1.0+rho_ref)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vsat_mult_Tempt_GND=((rho_Tempt_GND*pModel->KVSAT*(1.0+(rho_ref*pModel->KVSAT))-(1.0+(rho*pModel->KVSAT))*rho_ref_Tempt_GND*pModel->KVSAT)/(1.0+(rho_ref*pModel->KVSAT))/(1.0+(rho_ref*pModel->KVSAT)));
#endif
vsat_mult=((1.0+(rho*pModel->KVSAT))/(1.0+(rho_ref*pModel->KVSAT)));
EXIT_IF_ISNAN(((1.0+(rho*pModel->KVSAT))/(1.0+(rho_ref*pModel->KVSAT))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
vth0_stress_Tempt_GND=(((-pModel->KVTH0*kstress_vth0_Tempt_GND/kstress_vth0/kstress_vth0)*(Inv_od-Inv_odref))+((pModel->KVTH0/kstress_vth0)*Inv_od_Tempt_GND));
#endif
vth0_stress=((pModel->KVTH0/kstress_vth0)*(Inv_od-Inv_odref));
EXIT_IF_ISNAN(((pModel->KVTH0/kstress_vth0)*(Inv_od-Inv_odref)))
{
double m00_pow(d00_pow0,kstress_vth0,pModel->LODK2)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,kstress_vth0,pModel->LODK2)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
k2_stress_Tempt_GND=(((-pModel->STK2*(d10_pow0*kstress_vth0_Tempt_GND)/d00_pow0/d00_pow0)*(Inv_od-Inv_odref))+((pModel->STK2/d00_pow0)*Inv_od_Tempt_GND));
#endif
k2_stress=((pModel->STK2/d00_pow0)*(Inv_od-Inv_odref));
EXIT_IF_ISNAN(((pModel->STK2/d00_pow0)*(Inv_od-Inv_odref)))
}
{
double m00_pow(d00_pow0,kstress_vth0,pModel->LODETA0)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,kstress_vth0,pModel->LODETA0)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
eta_stress_Tempt_GND=(((-pModel->STETA0*(d10_pow0*kstress_vth0_Tempt_GND)/d00_pow0/d00_pow0)*(Inv_od-Inv_odref))+((pModel->STETA0/d00_pow0)*Inv_od_Tempt_GND));
#endif
eta_stress=((pModel->STETA0/d00_pow0)*(Inv_od-Inv_odref));
EXIT_IF_ISNAN(((pModel->STETA0/d00_pow0)*(Inv_od-Inv_odref)))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
U0_t_Tempt_GND=((U0_t_Tempt_GND*mu0_mult)+(U0_t*mu0_mult_Tempt_GND));
#endif
U0_t=(U0_t*mu0_mult);
EXIT_IF_ISNAN((U0_t*mu0_mult))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
VSAT_t_Tempt_GND=((VSAT_t_Tempt_GND*vsat_mult)+(VSAT_t*vsat_mult_Tempt_GND));
#endif
VSAT_t=(VSAT_t*vsat_mult);
EXIT_IF_ISNAN((VSAT_t*vsat_mult))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
K2_i_Tempt_GND=(K2_i_Tempt_GND+k2_stress_Tempt_GND);
#endif
K2_i=(K2_i+k2_stress);
EXIT_IF_ISNAN((K2_i+k2_stress))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
ETA0_t_Tempt_GND=(ETA0_t_Tempt_GND+eta_stress_Tempt_GND);
#endif
ETA0_t=(ETA0_t+eta_stress);
EXIT_IF_ISNAN((ETA0_t+eta_stress))
if
((pInst->EDGEFET==1))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
vth0_stress_EDGE_Tempt_GND=(((-KVTH0EDGE_i*kstress_vth0_Tempt_GND/kstress_vth0/kstress_vth0)*(Inv_od-Inv_odref))+((KVTH0EDGE_i/kstress_vth0)*Inv_od_Tempt_GND));
#endif
vth0_stress_EDGE=((KVTH0EDGE_i/kstress_vth0)*(Inv_od-Inv_odref));
EXIT_IF_ISNAN(((KVTH0EDGE_i/kstress_vth0)*(Inv_od-Inv_odref)))
{
double m00_pow(d00_pow0,kstress_vth0,pModel->LODK2)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,kstress_vth0,pModel->LODK2)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
k2_stress_EDGE_Tempt_GND=(((-STK2EDGE_i*(d10_pow0*kstress_vth0_Tempt_GND)/d00_pow0/d00_pow0)*(Inv_od-Inv_odref))+((STK2EDGE_i/d00_pow0)*Inv_od_Tempt_GND));
#endif
k2_stress_EDGE=((STK2EDGE_i/d00_pow0)*(Inv_od-Inv_odref));
EXIT_IF_ISNAN(((STK2EDGE_i/d00_pow0)*(Inv_od-Inv_odref)))
}
{
double m00_pow(d00_pow0,kstress_vth0,pModel->LODETA0)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,kstress_vth0,pModel->LODETA0)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
eta_stress_EDGE_Tempt_GND=(((-STETA0EDGE_i*(d10_pow0*kstress_vth0_Tempt_GND)/d00_pow0/d00_pow0)*(Inv_od-Inv_odref))+((STETA0EDGE_i/d00_pow0)*Inv_od_Tempt_GND));
#endif
eta_stress_EDGE=((STETA0EDGE_i/d00_pow0)*(Inv_od-Inv_odref));
EXIT_IF_ISNAN(((STETA0EDGE_i/d00_pow0)*(Inv_od-Inv_odref)))
}
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
K2_EDGE_Tempt_GND=k2_stress_EDGE_Tempt_GND;
#endif
K2_EDGE=(K2EDGE_i+k2_stress_EDGE);
EXIT_IF_ISNAN((K2EDGE_i+k2_stress_EDGE))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
ETA0_EDGE_Tempt_GND=eta_stress_EDGE_Tempt_GND;
#endif
ETA0_EDGE=(ETA0EDGE_i+eta_stress_EDGE);
EXIT_IF_ISNAN((ETA0EDGE_i+eta_stress_EDGE))
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
vth0_stress_Tempt_GND=0.0;
#endif
vth0_stress=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
vth0_stress_EDGE_Tempt_GND=0.0;
#endif
vth0_stress_EDGE=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((pModel->WPEMOD==1))
{
Wdrn=(pInst->W/pInst->NF);
EXIT_IF_ISNAN((pInst->W/pInst->NF))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_sca_Tempt_GND=0.0;
#endif
local_sca=pInst->SCA;
EXIT_IF_ISNAN(pInst->SCA)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_scb_Tempt_GND=0.0;
#endif
local_scb=pInst->SCB;
EXIT_IF_ISNAN(pInst->SCB)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_scc_Tempt_GND=0.0;
#endif
local_scc=pInst->SCC;
EXIT_IF_ISNAN(pInst->SCC)
if
((((!(here->SCA_Given))&&(!(here->SCB_Given)))&&(!(here->SCC_Given))))
{
if
(((here->SC_Given)&&(pInst->SC>0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=(pInst->SC+Wdrn);
EXIT_IF_ISNAN((pInst->SC+Wdrn))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=0.0;
#endif
#endif
T2=(1.0/pModel->SCREF);
EXIT_IF_ISNAN((1.0/pModel->SCREF))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_sca_Tempt_GND=(-(pModel->SCREF*pModel->SCREF)*(pInst->SC*T1_Tempt_GND)/(pInst->SC*T1)/(pInst->SC*T1));
#endif
local_sca=((pModel->SCREF*pModel->SCREF)/(pInst->SC*T1));
EXIT_IF_ISNAN(((pModel->SCREF*pModel->SCREF)/(pInst->SC*T1)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_scb_Tempt_GND=(((((0.1*pInst->SC)+(0.01*pModel->SCREF))*bsimbulk_d_lexp((((-10.0)*pInst->SC)*T2),(((-10.0)*pInst->SC)*T2_Tempt_GND)))-(((0.1*T1_Tempt_GND)*bsimbulk_lexp((((-10.0)*T1)*T2)))+(((0.1*T1)+(0.01*pModel->SCREF))*bsimbulk_d_lexp((((-10.0)*T1)*T2),((((-10.0)*T1_Tempt_GND)*T2)+(((-10.0)*T1)*T2_Tempt_GND))))))/Wdrn);
#endif
local_scb=(((((0.1*pInst->SC)+(0.01*pModel->SCREF))*bsimbulk_lexp((((-10.0)*pInst->SC)*T2)))-(((0.1*T1)+(0.01*pModel->SCREF))*bsimbulk_lexp((((-10.0)*T1)*T2))))/Wdrn);
EXIT_IF_ISNAN((((((0.1*pInst->SC)+(0.01*pModel->SCREF))*bsimbulk_lexp((((-10.0)*pInst->SC)*T2)))-(((0.1*T1)+(0.01*pModel->SCREF))*bsimbulk_lexp((((-10.0)*T1)*T2))))/Wdrn))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
local_scc_Tempt_GND=(((((0.05*pInst->SC)+(0.0025*pModel->SCREF))*bsimbulk_d_lexp((((-20.0)*pInst->SC)*T2),(((-20.0)*pInst->SC)*T2_Tempt_GND)))-(((0.05*T1_Tempt_GND)*bsimbulk_lexp((((-20.0)*T1)*T2)))+(((0.05*T1)+(0.0025*pModel->SCREF))*bsimbulk_d_lexp((((-20.0)*T1)*T2),((((-20.0)*T1_Tempt_GND)*T2)+(((-20.0)*T1)*T2_Tempt_GND))))))/Wdrn);
#endif
local_scc=(((((0.05*pInst->SC)+(0.0025*pModel->SCREF))*bsimbulk_lexp((((-20.0)*pInst->SC)*T2)))-(((0.05*T1)+(0.0025*pModel->SCREF))*bsimbulk_lexp((((-20.0)*T1)*T2))))/Wdrn);
EXIT_IF_ISNAN((((((0.05*pInst->SC)+(0.0025*pModel->SCREF))*bsimbulk_lexp((((-20.0)*pInst->SC)*T2)))-(((0.05*T1)+(0.0025*pModel->SCREF))*bsimbulk_lexp((((-20.0)*T1)*T2))))/Wdrn))
}
else
{
printf("Warning: (Instance BSIMBULK) No WPE as none of SCA, SCB, SCC, SC is given and/or SC not positive.");
printf("\n");
}
}
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
vth0_well_Tempt_GND=(KVTH0WE_i*((local_sca_Tempt_GND+(pModel->WEB*local_scb_Tempt_GND))+(pModel->WEC*local_scc_Tempt_GND)));
#endif
vth0_well=(KVTH0WE_i*((local_sca+(pModel->WEB*local_scb))+(pModel->WEC*local_scc)));
EXIT_IF_ISNAN((KVTH0WE_i*((local_sca+(pModel->WEB*local_scb))+(pModel->WEC*local_scc))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
k2_well_Tempt_GND=(K2WE_i*((local_sca_Tempt_GND+(pModel->WEB*local_scb_Tempt_GND))+(pModel->WEC*local_scc_Tempt_GND)));
#endif
k2_well=(K2WE_i*((local_sca+(pModel->WEB*local_scb))+(pModel->WEC*local_scc)));
EXIT_IF_ISNAN((K2WE_i*((local_sca+(pModel->WEB*local_scb))+(pModel->WEC*local_scc))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
mu_well_Tempt_GND=(KU0WE_i*((local_sca_Tempt_GND+(pModel->WEB*local_scb_Tempt_GND))+(pModel->WEC*local_scc_Tempt_GND)));
#endif
mu_well=(1.0+(KU0WE_i*((local_sca+(pModel->WEB*local_scb))+(pModel->WEC*local_scc))));
EXIT_IF_ISNAN((1.0+(KU0WE_i*((local_sca+(pModel->WEB*local_scb))+(pModel->WEC*local_scc)))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
U0_t_Tempt_GND=((U0_t_Tempt_GND*mu_well)+(U0_t*mu_well_Tempt_GND));
#endif
U0_t=(U0_t*mu_well);
EXIT_IF_ISNAN((U0_t*mu_well))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
K2_i_Tempt_GND=(K2_i_Tempt_GND+k2_well_Tempt_GND);
#endif
K2_i=(K2_i+k2_well);
EXIT_IF_ISNAN((K2_i+k2_well))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Vg_Vgi_bi=(devsign);
#if defined(_DERIVATE2)
  Vg_Vgi_bi_Vgi_bi=(+0.0*(NP(gi)-NP(bi))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
Vg=(devsign*(NP(gi)-NP(bi)));
EXIT_IF_ISNAN((devsign*(NP(gi)-NP(bi))))
#if defined(_DERIVATEFORDDX) /* probe=V(si,bi)V(di,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
Vd_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Vd_Vsi_bi_Vsi_bi=0.0;
  Vd_Vsi_bi_Vdi_bi=0.0;
#endif
Vd_Vdi_bi=(devsign);
#if defined(_DERIVATE2)
  Vd_Vdi_bi_Vsi_bi=(+0.0*(NP(di)-NP(bi))+0.0*0.0+0.0*1.0+devsign*0.0);
  Vd_Vdi_bi_Vdi_bi=(+0.0*(NP(di)-NP(bi))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
Vd=(devsign*(NP(di)-NP(bi)));
EXIT_IF_ISNAN((devsign*(NP(di)-NP(bi))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Vs_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Vs_Vdi_bi_Vdi_bi=0.0;
  Vs_Vdi_bi_Vsi_bi=0.0;
#endif
Vs_Vsi_bi=(devsign);
#if defined(_DERIVATE2)
  Vs_Vsi_bi_Vdi_bi=(+0.0*(NP(si)-NP(bi))+0.0*0.0+0.0*1.0+devsign*0.0);
  Vs_Vsi_bi_Vsi_bi=(+0.0*(NP(si)-NP(bi))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
Vs=(devsign*(NP(si)-NP(bi)));
EXIT_IF_ISNAN((devsign*(NP(si)-NP(bi))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Vds_Vdi_bi=(Vd_Vdi_bi-Vs_Vdi_bi);
#if defined(_DERIVATE2)
  Vds_Vdi_bi_Vdi_bi=(+Vd_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi);
  Vds_Vdi_bi_Vsi_bi=(+Vd_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi);
#endif
Vds_Vsi_bi=(Vd_Vsi_bi-Vs_Vsi_bi);
#if defined(_DERIVATE2)
  Vds_Vsi_bi_Vdi_bi=(+Vd_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi);
  Vds_Vsi_bi_Vsi_bi=(+Vd_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi);
#endif
#endif
Vds=(Vd-Vs);
EXIT_IF_ISNAN((Vd-Vs))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
Vds_noswap_Vdi_bi=Vds_Vdi_bi;
#if defined(_DERIVATE2)
  Vds_noswap_Vdi_bi_Vdi_bi=Vds_Vdi_bi_Vdi_bi;
  Vds_noswap_Vdi_bi_Vsi_bi=Vds_Vdi_bi_Vsi_bi;
#endif
Vds_noswap_Vsi_bi=Vds_Vsi_bi;
#if defined(_DERIVATE2)
  Vds_noswap_Vsi_bi_Vdi_bi=Vds_Vsi_bi_Vdi_bi;
  Vds_noswap_Vsi_bi_Vsi_bi=Vds_Vsi_bi_Vsi_bi;
#endif
#endif
Vds_noswap=Vds;
EXIT_IF_ISNAN(Vds)
#if defined(_DERIVATEFORDDX) /* probe=V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
Vsb_noswap_Vsi_bi=Vs_Vsi_bi;
#if defined(_DERIVATE2)
  Vsb_noswap_Vsi_bi_Vsi_bi=Vs_Vsi_bi_Vsi_bi;
#endif
#endif
Vsb_noswap=Vs;
EXIT_IF_ISNAN(Vs)
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
Vdb_noswap_Vdi_bi=Vd_Vdi_bi;
#if defined(_DERIVATE2)
  Vdb_noswap_Vdi_bi_Vdi_bi=Vd_Vdi_bi_Vdi_bi;
#endif
#endif
Vdb_noswap=Vd;
EXIT_IF_ISNAN(Vd)
#if defined(_DERIVATEFORDDX) /* probe=V(sbulk,si) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
Vbs_jct_Vsbulk_si=(devsign);
#if defined(_DERIVATE2)
  Vbs_jct_Vsbulk_si_Vsbulk_si=(+0.0*(NP(sbulk)-NP(si))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
Vbs_jct=(devsign*(NP(sbulk)-NP(si)));
EXIT_IF_ISNAN((devsign*(NP(sbulk)-NP(si))))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
Vbd_jct_Vdbulk_di=(devsign);
#if defined(_DERIVATE2)
  Vbd_jct_Vdbulk_di_Vdbulk_di=(+0.0*(NP(dbulk)-NP(di))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
Vbd_jct=(devsign*(NP(dbulk)-NP(di)));
EXIT_IF_ISNAN((devsign*(NP(dbulk)-NP(di))))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
Vgd_noswap_Vgi_bi=Vg_Vgi_bi;
#if defined(_DERIVATE2)
  Vgd_noswap_Vgi_bi_Vgi_bi=(+Vg_Vgi_bi_Vgi_bi-0.0);
  Vgd_noswap_Vgi_bi_Vdi_bi=(+0.0-0.0);
#endif
Vgd_noswap_Vdi_bi=(-Vd_Vdi_bi);
#if defined(_DERIVATE2)
  Vgd_noswap_Vdi_bi_Vgi_bi=(+0.0-0.0);
  Vgd_noswap_Vdi_bi_Vdi_bi=(+0.0-Vd_Vdi_bi_Vdi_bi);
#endif
#endif
Vgd_noswap=(Vg-Vd);
EXIT_IF_ISNAN((Vg-Vd))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
Vgs_noswap_Vgi_bi=Vg_Vgi_bi;
#if defined(_DERIVATE2)
  Vgs_noswap_Vgi_bi_Vgi_bi=(+Vg_Vgi_bi_Vgi_bi-0.0);
  Vgs_noswap_Vgi_bi_Vsi_bi=(+0.0-0.0);
#endif
Vgs_noswap_Vsi_bi=(-Vs_Vsi_bi);
#if defined(_DERIVATE2)
  Vgs_noswap_Vsi_bi_Vgi_bi=(+0.0-0.0);
  Vgs_noswap_Vsi_bi_Vsi_bi=(+0.0-Vs_Vsi_bi_Vsi_bi);
#endif
#endif
Vgs_noswap=(Vg-Vs);
EXIT_IF_ISNAN((Vg-Vs))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di) ddxprobe=V(gi,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(si,GND)V(bi,GND) */
Vgd_ov_noswap_Vgm_di=(devsign);
#if defined(_DERIVATE2)
  Vgd_ov_noswap_Vgm_di_Vgm_di=(+0.0*(NP(gm)-NP(di))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
Vgd_ov_noswap=(devsign*(NP(gm)-NP(di)));
EXIT_IF_ISNAN((devsign*(NP(gm)-NP(di))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si) ddxprobe=V(dbulk,GND)V(gi,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(bi,GND) */
Vgs_ov_noswap_Vgm_si=(devsign);
#if defined(_DERIVATE2)
  Vgs_ov_noswap_Vgm_si_Vgm_si=(+0.0*(NP(gm)-NP(si))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
Vgs_ov_noswap=(devsign*(NP(gm)-NP(si)));
EXIT_IF_ISNAN((devsign*(NP(gm)-NP(si))))
sigvds=1.0;
EXIT_IF_ISNAN(1.0)
if
((Vds<0.0))
{
sigvds=(-1.0);
EXIT_IF_ISNAN((-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(si,bi)V(di,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
Vd_Vsi_bi=(devsign);
#if defined(_DERIVATE2)
  Vd_Vsi_bi_Vsi_bi=(+0.0*(NP(si)-NP(bi))+0.0*1.0+0.0*1.0+devsign*0.0);
  Vd_Vsi_bi_Vdi_bi=(+0.0*(NP(si)-NP(bi))+0.0*0.0+0.0*1.0+devsign*0.0);
#endif
Vd_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Vd_Vdi_bi_Vsi_bi=0.0;
  Vd_Vdi_bi_Vdi_bi=0.0;
#endif
#endif
Vd=(devsign*(NP(si)-NP(bi)));
EXIT_IF_ISNAN((devsign*(NP(si)-NP(bi))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Vs_Vdi_bi=(devsign);
#if defined(_DERIVATE2)
  Vs_Vdi_bi_Vdi_bi=(+0.0*(NP(di)-NP(bi))+0.0*1.0+0.0*1.0+devsign*0.0);
  Vs_Vdi_bi_Vsi_bi=(+0.0*(NP(di)-NP(bi))+0.0*0.0+0.0*1.0+devsign*0.0);
#endif
Vs_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Vs_Vsi_bi_Vdi_bi=0.0;
  Vs_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
Vs=(devsign*(NP(di)-NP(bi)));
EXIT_IF_ISNAN((devsign*(NP(di)-NP(bi))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Vds_Vdi_bi=(Vd_Vdi_bi-Vs_Vdi_bi);
#if defined(_DERIVATE2)
  Vds_Vdi_bi_Vdi_bi=(+Vd_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi);
  Vds_Vdi_bi_Vsi_bi=(+Vd_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi);
#endif
Vds_Vsi_bi=(Vd_Vsi_bi-Vs_Vsi_bi);
#if defined(_DERIVATE2)
  Vds_Vsi_bi_Vdi_bi=(+Vd_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi);
  Vds_Vsi_bi_Vsi_bi=(+Vd_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi);
#endif
#endif
Vds=(Vd-Vs);
EXIT_IF_ISNAN((Vd-Vs))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=(pModel->AVDSX*Vds_Vdi_bi);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+pModel->AVDSX*0.0);
  T0_Vdi_bi_Vgm_si=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+pModel->AVDSX*0.0);
  T0_Vdi_bi_Vdbulk_di=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+pModel->AVDSX*0.0);
  T0_Vdi_bi_Vsbulk_si=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+pModel->AVDSX*0.0);
  T0_Vdi_bi_Vgi_bi=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+pModel->AVDSX*0.0);
  T0_Vdi_bi_Vdi_bi=(+0.0*Vds+0.0*Vds_Vdi_bi+0.0*Vds_Vdi_bi+pModel->AVDSX*Vds_Vdi_bi_Vdi_bi);
  T0_Vdi_bi_Vsi_bi=(+0.0*Vds+0.0*Vds_Vsi_bi+0.0*Vds_Vdi_bi+pModel->AVDSX*Vds_Vdi_bi_Vsi_bi);
  T0_Vdi_bi_Tempt_GND=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+pModel->AVDSX*0.0);
#endif
T0_Vsi_bi=(pModel->AVDSX*Vds_Vsi_bi);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+pModel->AVDSX*0.0);
  T0_Vsi_bi_Vgm_si=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+pModel->AVDSX*0.0);
  T0_Vsi_bi_Vdbulk_di=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+pModel->AVDSX*0.0);
  T0_Vsi_bi_Vsbulk_si=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+pModel->AVDSX*0.0);
  T0_Vsi_bi_Vgi_bi=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+pModel->AVDSX*0.0);
  T0_Vsi_bi_Vdi_bi=(+0.0*Vds+0.0*Vds_Vdi_bi+0.0*Vds_Vsi_bi+pModel->AVDSX*Vds_Vsi_bi_Vdi_bi);
  T0_Vsi_bi_Vsi_bi=(+0.0*Vds+0.0*Vds_Vsi_bi+0.0*Vds_Vsi_bi+pModel->AVDSX*Vds_Vsi_bi_Vsi_bi);
  T0_Vsi_bi_Tempt_GND=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+pModel->AVDSX*0.0);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=0.0;
#endif
#endif
T0=(pModel->AVDSX*Vds);
EXIT_IF_ISNAN((pModel->AVDSX*Vds))
if
((T0>80.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=T0_Vdi_bi;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=T0_Vdi_bi_Vgm_di;
  T1_Vdi_bi_Vgm_si=T0_Vdi_bi_Vgm_si;
  T1_Vdi_bi_Vdbulk_di=T0_Vdi_bi_Vdbulk_di;
  T1_Vdi_bi_Vsbulk_si=T0_Vdi_bi_Vsbulk_si;
  T1_Vdi_bi_Vgi_bi=T0_Vdi_bi_Vgi_bi;
  T1_Vdi_bi_Vdi_bi=T0_Vdi_bi_Vdi_bi;
  T1_Vdi_bi_Vsi_bi=T0_Vdi_bi_Vsi_bi;
  T1_Vdi_bi_Tempt_GND=T0_Vdi_bi_Tempt_GND;
#endif
T1_Vsi_bi=T0_Vsi_bi;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=T0_Vsi_bi_Vgm_di;
  T1_Vsi_bi_Vgm_si=T0_Vsi_bi_Vgm_si;
  T1_Vsi_bi_Vdbulk_di=T0_Vsi_bi_Vdbulk_di;
  T1_Vsi_bi_Vsbulk_si=T0_Vsi_bi_Vsbulk_si;
  T1_Vsi_bi_Vgi_bi=T0_Vsi_bi_Vgi_bi;
  T1_Vsi_bi_Vdi_bi=T0_Vsi_bi_Vdi_bi;
  T1_Vsi_bi_Vsi_bi=T0_Vsi_bi_Vsi_bi;
  T1_Vsi_bi_Tempt_GND=T0_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=T0_Tempt_GND;
#endif
#endif
T1=T0;
EXIT_IF_ISNAN(T0)
}
else
{
{
double m00_exp(d00_exp0,T0)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=T0_Vdi_bi*d10_exp0*d10_logE1;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(m20_logE((1.0+d00_exp0))*T0_Vgm_di*d10_exp0*T0_Vdi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vgm_di*T0_Vdi_bi+d10_exp0*T0_Vdi_bi_Vgm_di)));
  T1_Vdi_bi_Vgm_si=(m20_logE((1.0+d00_exp0))*T0_Vgm_si*d10_exp0*T0_Vdi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vgm_si*T0_Vdi_bi+d10_exp0*T0_Vdi_bi_Vgm_si)));
  T1_Vdi_bi_Vdbulk_di=(m20_logE((1.0+d00_exp0))*T0_Vdbulk_di*d10_exp0*T0_Vdi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vdbulk_di*T0_Vdi_bi+d10_exp0*T0_Vdi_bi_Vdbulk_di)));
  T1_Vdi_bi_Vsbulk_si=(m20_logE((1.0+d00_exp0))*T0_Vsbulk_si*d10_exp0*T0_Vdi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vsbulk_si*T0_Vdi_bi+d10_exp0*T0_Vdi_bi_Vsbulk_si)));
  T1_Vdi_bi_Vgi_bi=(m20_logE((1.0+d00_exp0))*T0_Vgi_bi*d10_exp0*T0_Vdi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vgi_bi*T0_Vdi_bi+d10_exp0*T0_Vdi_bi_Vgi_bi)));
  T1_Vdi_bi_Vdi_bi=(m20_logE((1.0+d00_exp0))*T0_Vdi_bi*d10_exp0*T0_Vdi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vdi_bi*T0_Vdi_bi+d10_exp0*T0_Vdi_bi_Vdi_bi)));
  T1_Vdi_bi_Vsi_bi=(m20_logE((1.0+d00_exp0))*T0_Vsi_bi*d10_exp0*T0_Vdi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vsi_bi*T0_Vdi_bi+d10_exp0*T0_Vdi_bi_Vsi_bi)));
  T1_Vdi_bi_Tempt_GND=(m20_logE((1.0+d00_exp0))*T0_Tempt_GND*d10_exp0*T0_Vdi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Tempt_GND*T0_Vdi_bi+d10_exp0*T0_Vdi_bi_Tempt_GND)));
#endif
T1_Vsi_bi=T0_Vsi_bi*d10_exp0*d10_logE1;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(m20_logE((1.0+d00_exp0))*T0_Vgm_di*d10_exp0*T0_Vsi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vgm_di*T0_Vsi_bi+d10_exp0*T0_Vsi_bi_Vgm_di)));
  T1_Vsi_bi_Vgm_si=(m20_logE((1.0+d00_exp0))*T0_Vgm_si*d10_exp0*T0_Vsi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vgm_si*T0_Vsi_bi+d10_exp0*T0_Vsi_bi_Vgm_si)));
  T1_Vsi_bi_Vdbulk_di=(m20_logE((1.0+d00_exp0))*T0_Vdbulk_di*d10_exp0*T0_Vsi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vdbulk_di*T0_Vsi_bi+d10_exp0*T0_Vsi_bi_Vdbulk_di)));
  T1_Vsi_bi_Vsbulk_si=(m20_logE((1.0+d00_exp0))*T0_Vsbulk_si*d10_exp0*T0_Vsi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vsbulk_si*T0_Vsi_bi+d10_exp0*T0_Vsi_bi_Vsbulk_si)));
  T1_Vsi_bi_Vgi_bi=(m20_logE((1.0+d00_exp0))*T0_Vgi_bi*d10_exp0*T0_Vsi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vgi_bi*T0_Vsi_bi+d10_exp0*T0_Vsi_bi_Vgi_bi)));
  T1_Vsi_bi_Vdi_bi=(m20_logE((1.0+d00_exp0))*T0_Vdi_bi*d10_exp0*T0_Vsi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vdi_bi*T0_Vsi_bi+d10_exp0*T0_Vsi_bi_Vdi_bi)));
  T1_Vsi_bi_Vsi_bi=(m20_logE((1.0+d00_exp0))*T0_Vsi_bi*d10_exp0*T0_Vsi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Vsi_bi*T0_Vsi_bi+d10_exp0*T0_Vsi_bi_Vsi_bi)));
  T1_Vsi_bi_Tempt_GND=(m20_logE((1.0+d00_exp0))*T0_Tempt_GND*d10_exp0*T0_Vsi_bi*d10_exp0+d10_logE1*(+0.0+(m20_exp(T0)*T0_Tempt_GND*T0_Vsi_bi+d10_exp0*T0_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=T0_Tempt_GND*d10_exp0*d10_logE1;
#endif
#endif
T1=d00_logE1;
EXIT_IF_ISNAN(d00_logE1)
}
}
{
double m00_logE(d00_logE0,2.0)
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Vdsx_Vdi_bi=(((2.0/pModel->AVDSX)*T1_Vdi_bi)-Vds_Vdi_bi);
#if defined(_DERIVATE2)
  Vdsx_Vdi_bi_Vdi_bi=(+(+(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*T1+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+(2.0/pModel->AVDSX)*T1_Vdi_bi_Vdi_bi)-Vds_Vdi_bi_Vdi_bi)-(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*d00_logE0+0.0*0.0+0.0*0.0+(2.0/pModel->AVDSX)*0.0));
  Vdsx_Vdi_bi_Vsi_bi=(+(+(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*T1+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+(2.0/pModel->AVDSX)*T1_Vdi_bi_Vsi_bi)-Vds_Vdi_bi_Vsi_bi)-(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*d00_logE0+0.0*0.0+0.0*0.0+(2.0/pModel->AVDSX)*0.0));
  Vdsx_Vdi_bi_Tempt_GND=(+(+(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*T1+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+(2.0/pModel->AVDSX)*T1_Vdi_bi_Tempt_GND)-0.0)-(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*d00_logE0+0.0*0.0+0.0*0.0+(2.0/pModel->AVDSX)*0.0));
#endif
Vdsx_Vsi_bi=(((2.0/pModel->AVDSX)*T1_Vsi_bi)-Vds_Vsi_bi);
#if defined(_DERIVATE2)
  Vdsx_Vsi_bi_Vdi_bi=(+(+(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*T1+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+(2.0/pModel->AVDSX)*T1_Vsi_bi_Vdi_bi)-Vds_Vsi_bi_Vdi_bi)-(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*d00_logE0+0.0*0.0+0.0*0.0+(2.0/pModel->AVDSX)*0.0));
  Vdsx_Vsi_bi_Vsi_bi=(+(+(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*T1+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+(2.0/pModel->AVDSX)*T1_Vsi_bi_Vsi_bi)-Vds_Vsi_bi_Vsi_bi)-(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*d00_logE0+0.0*0.0+0.0*0.0+(2.0/pModel->AVDSX)*0.0));
  Vdsx_Vsi_bi_Tempt_GND=(+(+(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*T1+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+(2.0/pModel->AVDSX)*T1_Vsi_bi_Tempt_GND)-0.0)-(+(0.0/pModel->AVDSX-(0.0*0.0+0.0*0.0+2.0*0.0)/pModel->AVDSX/pModel->AVDSX+2*2.0*0.0*0.0/pModel->AVDSX/pModel->AVDSX/pModel->AVDSX)*d00_logE0+0.0*0.0+0.0*0.0+(2.0/pModel->AVDSX)*0.0));
#endif
#if defined(_DERIVATE)
Vdsx_Tempt_GND=((2.0/pModel->AVDSX)*T1_Tempt_GND);
#endif
#endif
Vdsx=((((2.0/pModel->AVDSX)*T1)-Vds)-((2.0/pModel->AVDSX)*d00_logE0));
EXIT_IF_ISNAN(((((2.0/pModel->AVDSX)*T1)-Vds)-((2.0/pModel->AVDSX)*d00_logE0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Vbsx_Vdi_bi=(-(Vs_Vdi_bi+(0.5*(Vds_Vdi_bi-Vdsx_Vdi_bi))));
#if defined(_DERIVATE2)
  Vbsx_Vdi_bi_Vdi_bi=0.0;
  Vbsx_Vdi_bi_Vsi_bi=0.0;
  Vbsx_Vdi_bi_Tempt_GND=0.0;
#endif
Vbsx_Vsi_bi=(-(Vs_Vsi_bi+(0.5*(Vds_Vsi_bi-Vdsx_Vsi_bi))));
#if defined(_DERIVATE2)
  Vbsx_Vsi_bi_Vdi_bi=0.0;
  Vbsx_Vsi_bi_Vsi_bi=0.0;
  Vbsx_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
Vbsx_Tempt_GND=(-(0.5*(-Vdsx_Tempt_GND)));
#endif
#endif
Vbsx=(-(Vs+(0.5*(Vds-Vdsx))));
EXIT_IF_ISNAN((-(Vs+(0.5*(Vds-Vdsx)))))
{
double m00_tanh(d00_tanh0,((0.6*Vds_noswap)/Vtm))
#if defined(_DERIVATEFORDDX)
double m10_tanh(d10_tanh0,d00_tanh0,((0.6*Vds_noswap)/Vtm))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=((0.6*Vds_noswap_Vdi_bi)/Vtm)*d10_tanh0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vdi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vdi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vdi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_bi_Vgm_si=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vdi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vdi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vdi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_bi_Vdbulk_di=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vdi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vdi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vdi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_bi_Vsbulk_si=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vdi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vdi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vdi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_bi_Vgi_bi=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vdi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vdi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vdi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_bi_Vdi_bi=(m20_tanh(((0.6*Vds_noswap)/Vtm))*(((0.6*Vds_noswap_Vdi_bi))/Vtm)*((0.6*Vds_noswap_Vdi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*Vds_noswap_Vdi_bi+0.0*Vds_noswap_Vdi_bi+0.6*Vds_noswap_Vdi_bi_Vdi_bi)/Vtm-((0.6*Vds_noswap_Vdi_bi)*0.0+((0.6*Vds_noswap_Vdi_bi))*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_bi_Vsi_bi=(m20_tanh(((0.6*Vds_noswap)/Vtm))*(((0.6*Vds_noswap_Vsi_bi))/Vtm)*((0.6*Vds_noswap_Vdi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*Vds_noswap_Vsi_bi+0.0*Vds_noswap_Vdi_bi+0.6*Vds_noswap_Vdi_bi_Vsi_bi)/Vtm-((0.6*Vds_noswap_Vdi_bi)*0.0+((0.6*Vds_noswap_Vsi_bi))*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_bi_Tempt_GND=(m20_tanh(((0.6*Vds_noswap)/Vtm))*(((0.0)*Vtm-(0.6*Vds_noswap)*Vtm_Tempt_GND)/Vtm/Vtm)*((0.6*Vds_noswap_Vdi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vdi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vdi_bi)*Vtm_Tempt_GND+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm));
#endif
T0_Vsi_bi=((0.6*Vds_noswap_Vsi_bi)/Vtm)*d10_tanh0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vsi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vsi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vsi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vsi_bi_Vgm_si=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vsi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vsi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vsi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vsi_bi_Vdbulk_di=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vsi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vsi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vsi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vsi_bi_Vsbulk_si=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vsi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vsi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vsi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vsi_bi_Vgi_bi=(m20_tanh(((0.6*Vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*Vds_noswap_Vsi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vsi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vsi_bi)*0.0+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vsi_bi_Vdi_bi=(m20_tanh(((0.6*Vds_noswap)/Vtm))*(((0.6*Vds_noswap_Vdi_bi))/Vtm)*((0.6*Vds_noswap_Vsi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*Vds_noswap_Vdi_bi+0.0*Vds_noswap_Vsi_bi+0.6*Vds_noswap_Vsi_bi_Vdi_bi)/Vtm-((0.6*Vds_noswap_Vsi_bi)*0.0+((0.6*Vds_noswap_Vdi_bi))*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vsi_bi_Vsi_bi=(m20_tanh(((0.6*Vds_noswap)/Vtm))*(((0.6*Vds_noswap_Vsi_bi))/Vtm)*((0.6*Vds_noswap_Vsi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*Vds_noswap_Vsi_bi+0.0*Vds_noswap_Vsi_bi+0.6*Vds_noswap_Vsi_bi_Vsi_bi)/Vtm-((0.6*Vds_noswap_Vsi_bi)*0.0+((0.6*Vds_noswap_Vsi_bi))*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vsi_bi_Tempt_GND=(m20_tanh(((0.6*Vds_noswap)/Vtm))*(((0.0)*Vtm-(0.6*Vds_noswap)*Vtm_Tempt_GND)/Vtm/Vtm)*((0.6*Vds_noswap_Vsi_bi)/Vtm)+d10_tanh0*((+0.0*Vds_noswap+0.0*0.0+0.0*Vds_noswap_Vsi_bi+0.6*0.0)/Vtm-((0.6*Vds_noswap_Vsi_bi)*Vtm_Tempt_GND+(0.0)*0.0+(0.6*Vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*Vds_noswap)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-(0.6*Vds_noswap)*Vtm_Tempt_GND/Vtm/Vtm)*d10_tanh0;
#endif
#endif
T0=d00_tanh0;
EXIT_IF_ISNAN(d00_tanh0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
wf_Vdi_bi=(0.5*T0_Vdi_bi);
#if defined(_DERIVATE2)
  wf_Vdi_bi_Vdi_bi=(+0.0+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+0.5*T0_Vdi_bi_Vdi_bi));
  wf_Vdi_bi_Vsi_bi=(+0.0+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+0.5*T0_Vdi_bi_Vsi_bi));
  wf_Vdi_bi_Tempt_GND=(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+0.5*T0_Vdi_bi_Tempt_GND));
#endif
wf_Vsi_bi=(0.5*T0_Vsi_bi);
#if defined(_DERIVATE2)
  wf_Vsi_bi_Vdi_bi=(+0.0+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+0.5*T0_Vsi_bi_Vdi_bi));
  wf_Vsi_bi_Vsi_bi=(+0.0+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+0.5*T0_Vsi_bi_Vsi_bi));
  wf_Vsi_bi_Tempt_GND=(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+0.5*T0_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
wf_Tempt_GND=(0.5*T0_Tempt_GND);
#endif
#endif
wf=(0.5+(0.5*T0));
EXIT_IF_ISNAN((0.5+(0.5*T0)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
wr_Vdi_bi=(-wf_Vdi_bi);
#if defined(_DERIVATE2)
  wr_Vdi_bi_Vdi_bi=(+0.0-wf_Vdi_bi_Vdi_bi);
  wr_Vdi_bi_Vsi_bi=(+0.0-wf_Vdi_bi_Vsi_bi);
  wr_Vdi_bi_Tempt_GND=(+0.0-wf_Vdi_bi_Tempt_GND);
#endif
wr_Vsi_bi=(-wf_Vsi_bi);
#if defined(_DERIVATE2)
  wr_Vsi_bi_Vdi_bi=(+0.0-wf_Vsi_bi_Vdi_bi);
  wr_Vsi_bi_Vsi_bi=(+0.0-wf_Vsi_bi_Vsi_bi);
  wr_Vsi_bi_Tempt_GND=(+0.0-wf_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
wr_Tempt_GND=(-wf_Tempt_GND);
#endif
#endif
wr=(1.0-wf);
EXIT_IF_ISNAN((1.0-wf))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND) */
CDSCD_a_Vdi_bi=((CDSCDR_i*wr_Vdi_bi)+(CDSCD_i*wf_Vdi_bi));
#if defined(_DERIVATE2)
  CDSCD_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+CDSCDR_i*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+CDSCD_i*wf_Vdi_bi_Vdi_bi));
  CDSCD_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+CDSCDR_i*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+CDSCD_i*wf_Vdi_bi_Vsi_bi));
  CDSCD_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_bi+CDSCDR_i*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_bi+CDSCD_i*wf_Vdi_bi_Tempt_GND));
#endif
CDSCD_a_Vsi_bi=((CDSCDR_i*wr_Vsi_bi)+(CDSCD_i*wf_Vsi_bi));
#if defined(_DERIVATE2)
  CDSCD_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+CDSCDR_i*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+CDSCD_i*wf_Vsi_bi_Vdi_bi));
  CDSCD_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+CDSCDR_i*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+CDSCD_i*wf_Vsi_bi_Vsi_bi));
  CDSCD_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vsi_bi+CDSCDR_i*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vsi_bi+CDSCD_i*wf_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
CDSCD_a_Tempt_GND=((CDSCDR_i*wr_Tempt_GND)+(CDSCD_i*wf_Tempt_GND));
#endif
#endif
CDSCD_a=((CDSCDR_i*wr)+(CDSCD_i*wf));
EXIT_IF_ISNAN(((CDSCDR_i*wr)+(CDSCD_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
ETA0_a_Tempt_GND=(((ETA0R_t_Tempt_GND*wr)+(ETA0R_t*wr_Tempt_GND))+((ETA0_t_Tempt_GND*wf)+(ETA0_t*wf_Tempt_GND)));
#endif
ETA0_a_Vdi_bi=((ETA0R_t*wr_Vdi_bi)+(ETA0_t*wf_Vdi_bi));
#if defined(_DERIVATE2)
  ETA0_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+ETA0R_t_Tempt_GND*wr_Vdi_bi+ETA0R_t*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+ETA0_t_Tempt_GND*wf_Vdi_bi+ETA0_t*wf_Vdi_bi_Tempt_GND));
  ETA0_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+ETA0R_t*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+ETA0_t*wf_Vdi_bi_Vdi_bi));
  ETA0_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+ETA0R_t*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+ETA0_t*wf_Vdi_bi_Vsi_bi));
#endif
ETA0_a_Vsi_bi=((ETA0R_t*wr_Vsi_bi)+(ETA0_t*wf_Vsi_bi));
#if defined(_DERIVATE2)
  ETA0_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+ETA0R_t_Tempt_GND*wr_Vsi_bi+ETA0R_t*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+ETA0_t_Tempt_GND*wf_Vsi_bi+ETA0_t*wf_Vsi_bi_Tempt_GND));
  ETA0_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+ETA0R_t*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+ETA0_t*wf_Vsi_bi_Vdi_bi));
  ETA0_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+ETA0R_t*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+ETA0_t*wf_Vsi_bi_Vsi_bi));
#endif
#endif
ETA0_a=((ETA0R_t*wr)+(ETA0_t*wf));
EXIT_IF_ISNAN(((ETA0R_t*wr)+(ETA0_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND) */
PDIBLC_a_Vdi_bi=((PDIBLCR_i*wr_Vdi_bi)+(PDIBLC_i*wf_Vdi_bi));
#if defined(_DERIVATE2)
  PDIBLC_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+PDIBLCR_i*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+PDIBLC_i*wf_Vdi_bi_Vdi_bi));
  PDIBLC_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+PDIBLCR_i*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+PDIBLC_i*wf_Vdi_bi_Vsi_bi));
  PDIBLC_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_bi+PDIBLCR_i*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_bi+PDIBLC_i*wf_Vdi_bi_Tempt_GND));
#endif
PDIBLC_a_Vsi_bi=((PDIBLCR_i*wr_Vsi_bi)+(PDIBLC_i*wf_Vsi_bi));
#if defined(_DERIVATE2)
  PDIBLC_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+PDIBLCR_i*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+PDIBLC_i*wf_Vsi_bi_Vdi_bi));
  PDIBLC_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+PDIBLCR_i*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+PDIBLC_i*wf_Vsi_bi_Vsi_bi));
  PDIBLC_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vsi_bi+PDIBLCR_i*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vsi_bi+PDIBLC_i*wf_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
PDIBLC_a_Tempt_GND=((PDIBLCR_i*wr_Tempt_GND)+(PDIBLC_i*wf_Tempt_GND));
#endif
#endif
PDIBLC_a=((PDIBLCR_i*wr)+(PDIBLC_i*wf));
EXIT_IF_ISNAN(((PDIBLCR_i*wr)+(PDIBLC_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
PCLM_a_Vdi_bi=((PCLMR_i*wr_Vdi_bi)+(PCLM_i*wf_Vdi_bi));
#if defined(_DERIVATE2)
  PCLM_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+PCLMR_i*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+PCLM_i*wf_Vdi_bi_Vdi_bi));
  PCLM_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+PCLMR_i*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+PCLM_i*wf_Vdi_bi_Vsi_bi));
  PCLM_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_bi+PCLMR_i*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_bi+PCLM_i*wf_Vdi_bi_Tempt_GND));
#endif
PCLM_a_Vsi_bi=((PCLMR_i*wr_Vsi_bi)+(PCLM_i*wf_Vsi_bi));
#if defined(_DERIVATE2)
  PCLM_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+PCLMR_i*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+PCLM_i*wf_Vsi_bi_Vdi_bi));
  PCLM_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+PCLMR_i*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+PCLM_i*wf_Vsi_bi_Vsi_bi));
  PCLM_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vsi_bi+PCLMR_i*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vsi_bi+PCLM_i*wf_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
PCLM_a_Tempt_GND=((PCLMR_i*wr_Tempt_GND)+(PCLM_i*wf_Tempt_GND));
#endif
#endif
PCLM_a=((PCLMR_i*wr)+(PCLM_i*wf));
EXIT_IF_ISNAN(((PCLMR_i*wr)+(PCLM_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
PSAT_a_Vdi_bi=((PSATR_i*wr_Vdi_bi)+(PSAT_i*wf_Vdi_bi));
#if defined(_DERIVATE2)
  PSAT_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+PSATR_i*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+PSAT_i*wf_Vdi_bi_Vdi_bi));
  PSAT_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+PSATR_i*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+PSAT_i*wf_Vdi_bi_Vsi_bi));
  PSAT_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_bi+PSATR_i*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_bi+PSAT_i*wf_Vdi_bi_Tempt_GND));
#endif
PSAT_a_Vsi_bi=((PSATR_i*wr_Vsi_bi)+(PSAT_i*wf_Vsi_bi));
#if defined(_DERIVATE2)
  PSAT_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+PSATR_i*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+PSAT_i*wf_Vsi_bi_Vdi_bi));
  PSAT_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+PSATR_i*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+PSAT_i*wf_Vsi_bi_Vsi_bi));
  PSAT_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vsi_bi+PSATR_i*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vsi_bi+PSAT_i*wf_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
PSAT_a_Tempt_GND=((PSATR_i*wr_Tempt_GND)+(PSAT_i*wf_Tempt_GND));
#endif
#endif
PSAT_a=((PSATR_i*wr)+(PSAT_i*wf));
EXIT_IF_ISNAN(((PSATR_i*wr)+(PSAT_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
VSAT_a_Tempt_GND=(((VSATR_t_Tempt_GND*wr)+(VSATR_t*wr_Tempt_GND))+((VSAT_t_Tempt_GND*wf)+(VSAT_t*wf_Tempt_GND)));
#endif
VSAT_a_Vdi_bi=((VSATR_t*wr_Vdi_bi)+(VSAT_t*wf_Vdi_bi));
#if defined(_DERIVATE2)
  VSAT_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+VSATR_t_Tempt_GND*wr_Vdi_bi+VSATR_t*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+VSAT_t_Tempt_GND*wf_Vdi_bi+VSAT_t*wf_Vdi_bi_Tempt_GND));
  VSAT_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+VSATR_t*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+VSAT_t*wf_Vdi_bi_Vdi_bi));
  VSAT_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+VSATR_t*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+VSAT_t*wf_Vdi_bi_Vsi_bi));
#endif
VSAT_a_Vsi_bi=((VSATR_t*wr_Vsi_bi)+(VSAT_t*wf_Vsi_bi));
#if defined(_DERIVATE2)
  VSAT_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+VSATR_t_Tempt_GND*wr_Vsi_bi+VSATR_t*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+VSAT_t_Tempt_GND*wf_Vsi_bi+VSAT_t*wf_Vsi_bi_Tempt_GND));
  VSAT_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+VSATR_t*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+VSAT_t*wf_Vsi_bi_Vdi_bi));
  VSAT_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+VSATR_t*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+VSAT_t*wf_Vsi_bi_Vsi_bi));
#endif
#endif
VSAT_a=((VSATR_t*wr)+(VSAT_t*wf));
EXIT_IF_ISNAN(((VSATR_t*wr)+(VSAT_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
PTWG_a_Tempt_GND=(((PTWGR_t_Tempt_GND*wr)+(PTWGR_t*wr_Tempt_GND))+((PTWG_t_Tempt_GND*wf)+(PTWG_t*wf_Tempt_GND)));
#endif
PTWG_a_Vdi_bi=((PTWGR_t*wr_Vdi_bi)+(PTWG_t*wf_Vdi_bi));
#if defined(_DERIVATE2)
  PTWG_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+PTWGR_t_Tempt_GND*wr_Vdi_bi+PTWGR_t*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+PTWG_t_Tempt_GND*wf_Vdi_bi+PTWG_t*wf_Vdi_bi_Tempt_GND));
  PTWG_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+PTWGR_t*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+PTWG_t*wf_Vdi_bi_Vdi_bi));
  PTWG_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+PTWGR_t*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+PTWG_t*wf_Vdi_bi_Vsi_bi));
#endif
PTWG_a_Vsi_bi=((PTWGR_t*wr_Vsi_bi)+(PTWG_t*wf_Vsi_bi));
#if defined(_DERIVATE2)
  PTWG_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+PTWGR_t_Tempt_GND*wr_Vsi_bi+PTWGR_t*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+PTWG_t_Tempt_GND*wf_Vsi_bi+PTWG_t*wf_Vsi_bi_Tempt_GND));
  PTWG_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+PTWGR_t*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+PTWG_t*wf_Vsi_bi_Vdi_bi));
  PTWG_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+PTWGR_t*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+PTWG_t*wf_Vsi_bi_Vsi_bi));
#endif
#endif
PTWG_a=((PTWGR_t*wr)+(PTWG_t*wf));
EXIT_IF_ISNAN(((PTWGR_t*wr)+(PTWG_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
U0_a_Tempt_GND=(((U0R_t_Tempt_GND*wr)+(U0R_t*wr_Tempt_GND))+((U0_t_Tempt_GND*wf)+(U0_t*wf_Tempt_GND)));
#endif
U0_a_Vdi_bi=((U0R_t*wr_Vdi_bi)+(U0_t*wf_Vdi_bi));
#if defined(_DERIVATE2)
  U0_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+U0R_t_Tempt_GND*wr_Vdi_bi+U0R_t*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+U0_t_Tempt_GND*wf_Vdi_bi+U0_t*wf_Vdi_bi_Tempt_GND));
  U0_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+U0R_t*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+U0_t*wf_Vdi_bi_Vdi_bi));
  U0_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+U0R_t*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+U0_t*wf_Vdi_bi_Vsi_bi));
#endif
U0_a_Vsi_bi=((U0R_t*wr_Vsi_bi)+(U0_t*wf_Vsi_bi));
#if defined(_DERIVATE2)
  U0_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+U0R_t_Tempt_GND*wr_Vsi_bi+U0R_t*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+U0_t_Tempt_GND*wf_Vsi_bi+U0_t*wf_Vsi_bi_Tempt_GND));
  U0_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+U0R_t*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+U0_t*wf_Vsi_bi_Vdi_bi));
  U0_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+U0R_t*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+U0_t*wf_Vsi_bi_Vsi_bi));
#endif
#endif
U0_a=((U0R_t*wr)+(U0_t*wf));
EXIT_IF_ISNAN(((U0R_t*wr)+(U0_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
UA_a_Tempt_GND=(((UAR_t_Tempt_GND*wr)+(UAR_t*wr_Tempt_GND))+((UA_t_Tempt_GND*wf)+(UA_t*wf_Tempt_GND)));
#endif
UA_a_Vdi_bi=((UAR_t*wr_Vdi_bi)+(UA_t*wf_Vdi_bi));
#if defined(_DERIVATE2)
  UA_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UAR_t_Tempt_GND*wr_Vdi_bi+UAR_t*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UA_t_Tempt_GND*wf_Vdi_bi+UA_t*wf_Vdi_bi_Tempt_GND));
  UA_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+UAR_t*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+UA_t*wf_Vdi_bi_Vdi_bi));
  UA_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+UAR_t*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+UA_t*wf_Vdi_bi_Vsi_bi));
#endif
UA_a_Vsi_bi=((UAR_t*wr_Vsi_bi)+(UA_t*wf_Vsi_bi));
#if defined(_DERIVATE2)
  UA_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UAR_t_Tempt_GND*wr_Vsi_bi+UAR_t*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UA_t_Tempt_GND*wf_Vsi_bi+UA_t*wf_Vsi_bi_Tempt_GND));
  UA_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+UAR_t*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+UA_t*wf_Vsi_bi_Vdi_bi));
  UA_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+UAR_t*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+UA_t*wf_Vsi_bi_Vsi_bi));
#endif
#endif
UA_a=((UAR_t*wr)+(UA_t*wf));
EXIT_IF_ISNAN(((UAR_t*wr)+(UA_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
UC_a_Tempt_GND=(((UCR_t_Tempt_GND*wr)+(UCR_t*wr_Tempt_GND))+((UC_t_Tempt_GND*wf)+(UC_t*wf_Tempt_GND)));
#endif
UC_a_Vdi_bi=((UCR_t*wr_Vdi_bi)+(UC_t*wf_Vdi_bi));
#if defined(_DERIVATE2)
  UC_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UCR_t_Tempt_GND*wr_Vdi_bi+UCR_t*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UC_t_Tempt_GND*wf_Vdi_bi+UC_t*wf_Vdi_bi_Tempt_GND));
  UC_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+UCR_t*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+UC_t*wf_Vdi_bi_Vdi_bi));
  UC_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+UCR_t*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+UC_t*wf_Vdi_bi_Vsi_bi));
#endif
UC_a_Vsi_bi=((UCR_t*wr_Vsi_bi)+(UC_t*wf_Vsi_bi));
#if defined(_DERIVATE2)
  UC_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UCR_t_Tempt_GND*wr_Vsi_bi+UCR_t*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UC_t_Tempt_GND*wf_Vsi_bi+UC_t*wf_Vsi_bi_Tempt_GND));
  UC_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+UCR_t*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+UC_t*wf_Vsi_bi_Vdi_bi));
  UC_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+UCR_t*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+UC_t*wf_Vsi_bi_Vsi_bi));
#endif
#endif
UC_a=((UCR_t*wr)+(UC_t*wf));
EXIT_IF_ISNAN(((UCR_t*wr)+(UC_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
UD_a_Tempt_GND=(((UDR_t_Tempt_GND*wr)+(UDR_t*wr_Tempt_GND))+((UD_t_Tempt_GND*wf)+(UD_t*wf_Tempt_GND)));
#endif
UD_a_Vdi_bi=((UDR_t*wr_Vdi_bi)+(UD_t*wf_Vdi_bi));
#if defined(_DERIVATE2)
  UD_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UDR_t_Tempt_GND*wr_Vdi_bi+UDR_t*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UD_t_Tempt_GND*wf_Vdi_bi+UD_t*wf_Vdi_bi_Tempt_GND));
  UD_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+UDR_t*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+UD_t*wf_Vdi_bi_Vdi_bi));
  UD_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+UDR_t*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+UD_t*wf_Vdi_bi_Vsi_bi));
#endif
UD_a_Vsi_bi=((UDR_t*wr_Vsi_bi)+(UD_t*wf_Vsi_bi));
#if defined(_DERIVATE2)
  UD_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UDR_t_Tempt_GND*wr_Vsi_bi+UDR_t*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UD_t_Tempt_GND*wf_Vsi_bi+UD_t*wf_Vsi_bi_Tempt_GND));
  UD_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+UDR_t*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+UD_t*wf_Vsi_bi_Vdi_bi));
  UD_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+UDR_t*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+UD_t*wf_Vsi_bi_Vsi_bi));
#endif
#endif
UD_a=((UDR_t*wr)+(UD_t*wf));
EXIT_IF_ISNAN(((UDR_t*wr)+(UD_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
UCS_a_Tempt_GND=(((UCSR_t_Tempt_GND*wr)+(UCSR_t*wr_Tempt_GND))+((UCS_t_Tempt_GND*wf)+(UCS_t*wf_Tempt_GND)));
#endif
UCS_a_Vdi_bi=((UCSR_t*wr_Vdi_bi)+(UCS_t*wf_Vdi_bi));
#if defined(_DERIVATE2)
  UCS_a_Vdi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UCSR_t_Tempt_GND*wr_Vdi_bi+UCSR_t*wr_Vdi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UCS_t_Tempt_GND*wf_Vdi_bi+UCS_t*wf_Vdi_bi_Tempt_GND));
  UCS_a_Vdi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vdi_bi+UCSR_t*wr_Vdi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vdi_bi+UCS_t*wf_Vdi_bi_Vdi_bi));
  UCS_a_Vdi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vdi_bi+UCSR_t*wr_Vdi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vdi_bi+UCS_t*wf_Vdi_bi_Vsi_bi));
#endif
UCS_a_Vsi_bi=((UCSR_t*wr_Vsi_bi)+(UCS_t*wf_Vsi_bi));
#if defined(_DERIVATE2)
  UCS_a_Vsi_bi_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UCSR_t_Tempt_GND*wr_Vsi_bi+UCSR_t*wr_Vsi_bi_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UCS_t_Tempt_GND*wf_Vsi_bi+UCS_t*wf_Vsi_bi_Tempt_GND));
  UCS_a_Vsi_bi_Vdi_bi=(+(+0.0*wr+0.0*wr_Vdi_bi+0.0*wr_Vsi_bi+UCSR_t*wr_Vsi_bi_Vdi_bi)+(+0.0*wf+0.0*wf_Vdi_bi+0.0*wf_Vsi_bi+UCS_t*wf_Vsi_bi_Vdi_bi));
  UCS_a_Vsi_bi_Vsi_bi=(+(+0.0*wr+0.0*wr_Vsi_bi+0.0*wr_Vsi_bi+UCSR_t*wr_Vsi_bi_Vsi_bi)+(+0.0*wf+0.0*wf_Vsi_bi+0.0*wf_Vsi_bi+UCS_t*wf_Vsi_bi_Vsi_bi));
#endif
#endif
UCS_a=((UCSR_t*wr)+(UCS_t*wf));
EXIT_IF_ISNAN(((UCSR_t*wr)+(UCS_t*wf)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND) */
CDSCD_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  CDSCD_a_Vdi_bi_Vdi_bi=0.0;
  CDSCD_a_Vdi_bi_Vsi_bi=0.0;
  CDSCD_a_Vdi_bi_Tempt_GND=0.0;
#endif
CDSCD_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  CDSCD_a_Vsi_bi_Vdi_bi=0.0;
  CDSCD_a_Vsi_bi_Vsi_bi=0.0;
  CDSCD_a_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
CDSCD_a_Tempt_GND=0.0;
#endif
#endif
CDSCD_a=CDSCD_i;
EXIT_IF_ISNAN(CDSCD_i)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
ETA0_a_Tempt_GND=ETA0_t_Tempt_GND;
#endif
ETA0_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  ETA0_a_Vdi_bi_Tempt_GND=0.0;
  ETA0_a_Vdi_bi_Vdi_bi=0.0;
  ETA0_a_Vdi_bi_Vsi_bi=0.0;
#endif
ETA0_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  ETA0_a_Vsi_bi_Tempt_GND=0.0;
  ETA0_a_Vsi_bi_Vdi_bi=0.0;
  ETA0_a_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
ETA0_a=ETA0_t;
EXIT_IF_ISNAN(ETA0_t)
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND) */
PDIBLC_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  PDIBLC_a_Vdi_bi_Vdi_bi=0.0;
  PDIBLC_a_Vdi_bi_Vsi_bi=0.0;
  PDIBLC_a_Vdi_bi_Tempt_GND=0.0;
#endif
PDIBLC_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  PDIBLC_a_Vsi_bi_Vdi_bi=0.0;
  PDIBLC_a_Vsi_bi_Vsi_bi=0.0;
  PDIBLC_a_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
PDIBLC_a_Tempt_GND=0.0;
#endif
#endif
PDIBLC_a=PDIBLC_i;
EXIT_IF_ISNAN(PDIBLC_i)
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
PCLM_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  PCLM_a_Vdi_bi_Vdi_bi=0.0;
  PCLM_a_Vdi_bi_Vsi_bi=0.0;
  PCLM_a_Vdi_bi_Tempt_GND=0.0;
#endif
PCLM_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  PCLM_a_Vsi_bi_Vdi_bi=0.0;
  PCLM_a_Vsi_bi_Vsi_bi=0.0;
  PCLM_a_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
PCLM_a_Tempt_GND=0.0;
#endif
#endif
PCLM_a=PCLM_i;
EXIT_IF_ISNAN(PCLM_i)
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
PSAT_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  PSAT_a_Vdi_bi_Vdi_bi=0.0;
  PSAT_a_Vdi_bi_Vsi_bi=0.0;
  PSAT_a_Vdi_bi_Tempt_GND=0.0;
#endif
PSAT_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  PSAT_a_Vsi_bi_Vdi_bi=0.0;
  PSAT_a_Vsi_bi_Vsi_bi=0.0;
  PSAT_a_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
PSAT_a_Tempt_GND=0.0;
#endif
#endif
PSAT_a=PSAT_i;
EXIT_IF_ISNAN(PSAT_i)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
VSAT_a_Tempt_GND=VSAT_t_Tempt_GND;
#endif
VSAT_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  VSAT_a_Vdi_bi_Tempt_GND=0.0;
  VSAT_a_Vdi_bi_Vdi_bi=0.0;
  VSAT_a_Vdi_bi_Vsi_bi=0.0;
#endif
VSAT_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  VSAT_a_Vsi_bi_Tempt_GND=0.0;
  VSAT_a_Vsi_bi_Vdi_bi=0.0;
  VSAT_a_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
VSAT_a=VSAT_t;
EXIT_IF_ISNAN(VSAT_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
PTWG_a_Tempt_GND=PTWG_t_Tempt_GND;
#endif
PTWG_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  PTWG_a_Vdi_bi_Tempt_GND=0.0;
  PTWG_a_Vdi_bi_Vdi_bi=0.0;
  PTWG_a_Vdi_bi_Vsi_bi=0.0;
#endif
PTWG_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  PTWG_a_Vsi_bi_Tempt_GND=0.0;
  PTWG_a_Vsi_bi_Vdi_bi=0.0;
  PTWG_a_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
PTWG_a=PTWG_t;
EXIT_IF_ISNAN(PTWG_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
U0_a_Tempt_GND=U0_t_Tempt_GND;
#endif
U0_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  U0_a_Vdi_bi_Tempt_GND=0.0;
  U0_a_Vdi_bi_Vdi_bi=0.0;
  U0_a_Vdi_bi_Vsi_bi=0.0;
#endif
U0_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  U0_a_Vsi_bi_Tempt_GND=0.0;
  U0_a_Vsi_bi_Vdi_bi=0.0;
  U0_a_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
U0_a=U0_t;
EXIT_IF_ISNAN(U0_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
UA_a_Tempt_GND=UA_t_Tempt_GND;
#endif
UA_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  UA_a_Vdi_bi_Tempt_GND=0.0;
  UA_a_Vdi_bi_Vdi_bi=0.0;
  UA_a_Vdi_bi_Vsi_bi=0.0;
#endif
UA_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  UA_a_Vsi_bi_Tempt_GND=0.0;
  UA_a_Vsi_bi_Vdi_bi=0.0;
  UA_a_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
UA_a=UA_t;
EXIT_IF_ISNAN(UA_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
UC_a_Tempt_GND=UC_t_Tempt_GND;
#endif
UC_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  UC_a_Vdi_bi_Tempt_GND=0.0;
  UC_a_Vdi_bi_Vdi_bi=0.0;
  UC_a_Vdi_bi_Vsi_bi=0.0;
#endif
UC_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  UC_a_Vsi_bi_Tempt_GND=0.0;
  UC_a_Vsi_bi_Vdi_bi=0.0;
  UC_a_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
UC_a=UC_t;
EXIT_IF_ISNAN(UC_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
UD_a_Tempt_GND=UD_t_Tempt_GND;
#endif
UD_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  UD_a_Vdi_bi_Tempt_GND=0.0;
  UD_a_Vdi_bi_Vdi_bi=0.0;
  UD_a_Vdi_bi_Vsi_bi=0.0;
#endif
UD_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  UD_a_Vsi_bi_Tempt_GND=0.0;
  UD_a_Vsi_bi_Vdi_bi=0.0;
  UD_a_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
UD_a=UD_t;
EXIT_IF_ISNAN(UD_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
UCS_a_Tempt_GND=UCS_t_Tempt_GND;
#endif
UCS_a_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  UCS_a_Vdi_bi_Tempt_GND=0.0;
  UCS_a_Vdi_bi_Vdi_bi=0.0;
  UCS_a_Vdi_bi_Vsi_bi=0.0;
#endif
UCS_a_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  UCS_a_Vsi_bi_Tempt_GND=0.0;
  UCS_a_Vsi_bi_Vdi_bi=0.0;
  UCS_a_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
UCS_a=UCS_t;
EXIT_IF_ISNAN(UCS_t)
}
{
double m00_sqrt(d00_sqrt0,((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
PhistVbs_Tempt_GND=(0.5*((Phist_Tempt_GND-Vbsx_Tempt_GND)+(((Phist_Tempt_GND-Vbsx_Tempt_GND)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(Phist_Tempt_GND-Vbsx_Tempt_GND)))*d10_sqrt0));
#endif
PhistVbs_Vdi_bi=(0.5*((-Vbsx_Vdi_bi)+(((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  PhistVbs_Vdi_bi_Tempt_GND=(+0.0*(((Phist-Vbsx)+0.05)+d00_sqrt0)+0.0*((Phist_Tempt_GND-Vbsx_Tempt_GND)+(((((Phist_Tempt_GND-Vbsx_Tempt_GND)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(Phist_Tempt_GND-Vbsx_Tempt_GND))))+((0.0)*0.1))*d10_sqrt0)+0.0*((-Vbsx_Vdi_bi)+(((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0-Vbsx_Vdi_bi_Tempt_GND)+0.0)+(m20_sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))*(((((Phist_Tempt_GND-Vbsx_Tempt_GND)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(Phist_Tempt_GND-Vbsx_Tempt_GND))))+((0.0)*0.1))*(((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi)))+d10_sqrt0*(+(+(+(+0.0-Vbsx_Vdi_bi_Tempt_GND)-0.0)*((Phist-Vbsx)-0.05)+(-Vbsx_Vdi_bi)*(Phist_Tempt_GND-Vbsx_Tempt_GND)+(Phist_Tempt_GND-Vbsx_Tempt_GND)*(-Vbsx_Vdi_bi)+((Phist-Vbsx)-0.05)*(+(+0.0-Vbsx_Vdi_bi_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  PhistVbs_Vdi_bi_Vdi_bi=(+0.0*(((Phist-Vbsx)+0.05)+d00_sqrt0)+0.0*((-Vbsx_Vdi_bi)+(((((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi))))+((0.0)*0.1))*d10_sqrt0)+0.0*((-Vbsx_Vdi_bi)+(((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0-Vbsx_Vdi_bi_Vdi_bi)+0.0)+(m20_sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))*(((((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi))))+((0.0)*0.1))*(((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi)))+d10_sqrt0*(+(+(+(+0.0-Vbsx_Vdi_bi_Vdi_bi)-0.0)*((Phist-Vbsx)-0.05)+(-Vbsx_Vdi_bi)*(-Vbsx_Vdi_bi)+(-Vbsx_Vdi_bi)*(-Vbsx_Vdi_bi)+((Phist-Vbsx)-0.05)*(+(+0.0-Vbsx_Vdi_bi_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  PhistVbs_Vdi_bi_Vsi_bi=(+0.0*(((Phist-Vbsx)+0.05)+d00_sqrt0)+0.0*((-Vbsx_Vsi_bi)+(((((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi))))+((0.0)*0.1))*d10_sqrt0)+0.0*((-Vbsx_Vdi_bi)+(((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0-Vbsx_Vdi_bi_Vsi_bi)+0.0)+(m20_sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))*(((((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi))))+((0.0)*0.1))*(((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi)))+d10_sqrt0*(+(+(+(+0.0-Vbsx_Vdi_bi_Vsi_bi)-0.0)*((Phist-Vbsx)-0.05)+(-Vbsx_Vdi_bi)*(-Vbsx_Vsi_bi)+(-Vbsx_Vsi_bi)*(-Vbsx_Vdi_bi)+((Phist-Vbsx)-0.05)*(+(+0.0-Vbsx_Vdi_bi_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
PhistVbs_Vsi_bi=(0.5*((-Vbsx_Vsi_bi)+(((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  PhistVbs_Vsi_bi_Tempt_GND=(+0.0*(((Phist-Vbsx)+0.05)+d00_sqrt0)+0.0*((Phist_Tempt_GND-Vbsx_Tempt_GND)+(((((Phist_Tempt_GND-Vbsx_Tempt_GND)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(Phist_Tempt_GND-Vbsx_Tempt_GND))))+((0.0)*0.1))*d10_sqrt0)+0.0*((-Vbsx_Vsi_bi)+(((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0-Vbsx_Vsi_bi_Tempt_GND)+0.0)+(m20_sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))*(((((Phist_Tempt_GND-Vbsx_Tempt_GND)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(Phist_Tempt_GND-Vbsx_Tempt_GND))))+((0.0)*0.1))*(((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi)))+d10_sqrt0*(+(+(+(+0.0-Vbsx_Vsi_bi_Tempt_GND)-0.0)*((Phist-Vbsx)-0.05)+(-Vbsx_Vsi_bi)*(Phist_Tempt_GND-Vbsx_Tempt_GND)+(Phist_Tempt_GND-Vbsx_Tempt_GND)*(-Vbsx_Vsi_bi)+((Phist-Vbsx)-0.05)*(+(+0.0-Vbsx_Vsi_bi_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  PhistVbs_Vsi_bi_Vdi_bi=(+0.0*(((Phist-Vbsx)+0.05)+d00_sqrt0)+0.0*((-Vbsx_Vdi_bi)+(((((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi))))+((0.0)*0.1))*d10_sqrt0)+0.0*((-Vbsx_Vsi_bi)+(((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0-Vbsx_Vsi_bi_Vdi_bi)+0.0)+(m20_sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))*(((((-Vbsx_Vdi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vdi_bi))))+((0.0)*0.1))*(((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi)))+d10_sqrt0*(+(+(+(+0.0-Vbsx_Vsi_bi_Vdi_bi)-0.0)*((Phist-Vbsx)-0.05)+(-Vbsx_Vsi_bi)*(-Vbsx_Vdi_bi)+(-Vbsx_Vdi_bi)*(-Vbsx_Vsi_bi)+((Phist-Vbsx)-0.05)*(+(+0.0-Vbsx_Vsi_bi_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  PhistVbs_Vsi_bi_Vsi_bi=(+0.0*(((Phist-Vbsx)+0.05)+d00_sqrt0)+0.0*((-Vbsx_Vsi_bi)+(((((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi))))+((0.0)*0.1))*d10_sqrt0)+0.0*((-Vbsx_Vsi_bi)+(((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0-Vbsx_Vsi_bi_Vsi_bi)+0.0)+(m20_sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))*(((((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi))))+((0.0)*0.1))*(((-Vbsx_Vsi_bi)*((Phist-Vbsx)-0.05))+(((Phist-Vbsx)-0.05)*(-Vbsx_Vsi_bi)))+d10_sqrt0*(+(+(+(+0.0-Vbsx_Vsi_bi_Vsi_bi)-0.0)*((Phist-Vbsx)-0.05)+(-Vbsx_Vsi_bi)*(-Vbsx_Vsi_bi)+(-Vbsx_Vsi_bi)*(-Vbsx_Vsi_bi)+((Phist-Vbsx)-0.05)*(+(+0.0-Vbsx_Vsi_bi_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
#endif
PhistVbs=(0.5*(((Phist-Vbsx)+0.05)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(((Phist-Vbsx)+0.05)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,PhistVbs)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,PhistVbs)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
sqrtPhistVbs_Tempt_GND=PhistVbs_Tempt_GND*d10_sqrt0;
#endif
sqrtPhistVbs_Vdi_bi=PhistVbs_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtPhistVbs_Vdi_bi_Tempt_GND=(m20_sqrt(PhistVbs)*PhistVbs_Tempt_GND*PhistVbs_Vdi_bi+d10_sqrt0*PhistVbs_Vdi_bi_Tempt_GND);
  sqrtPhistVbs_Vdi_bi_Vdi_bi=(m20_sqrt(PhistVbs)*PhistVbs_Vdi_bi*PhistVbs_Vdi_bi+d10_sqrt0*PhistVbs_Vdi_bi_Vdi_bi);
  sqrtPhistVbs_Vdi_bi_Vsi_bi=(m20_sqrt(PhistVbs)*PhistVbs_Vsi_bi*PhistVbs_Vdi_bi+d10_sqrt0*PhistVbs_Vdi_bi_Vsi_bi);
#endif
sqrtPhistVbs_Vsi_bi=PhistVbs_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtPhistVbs_Vsi_bi_Tempt_GND=(m20_sqrt(PhistVbs)*PhistVbs_Tempt_GND*PhistVbs_Vsi_bi+d10_sqrt0*PhistVbs_Vsi_bi_Tempt_GND);
  sqrtPhistVbs_Vsi_bi_Vdi_bi=(m20_sqrt(PhistVbs)*PhistVbs_Vdi_bi*PhistVbs_Vsi_bi+d10_sqrt0*PhistVbs_Vsi_bi_Vdi_bi);
  sqrtPhistVbs_Vsi_bi_Vsi_bi=(m20_sqrt(PhistVbs)*PhistVbs_Vsi_bi*PhistVbs_Vsi_bi+d10_sqrt0*PhistVbs_Vsi_bi_Vsi_bi);
#endif
#endif
sqrtPhistVbs=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
#if defined(_DERIVATE)
Xdep_Tempt_GND=(T1DEP*sqrtPhistVbs_Tempt_GND);
#endif
Xdep_Vdi_bi=(T1DEP*sqrtPhistVbs_Vdi_bi);
#if defined(_DERIVATE2)
  Xdep_Vdi_bi_Tempt_GND=(+0.0*sqrtPhistVbs+0.0*sqrtPhistVbs_Tempt_GND+0.0*sqrtPhistVbs_Vdi_bi+T1DEP*sqrtPhistVbs_Vdi_bi_Tempt_GND);
  Xdep_Vdi_bi_Vdi_bi=(+0.0*sqrtPhistVbs+0.0*sqrtPhistVbs_Vdi_bi+0.0*sqrtPhistVbs_Vdi_bi+T1DEP*sqrtPhistVbs_Vdi_bi_Vdi_bi);
  Xdep_Vdi_bi_Vsi_bi=(+0.0*sqrtPhistVbs+0.0*sqrtPhistVbs_Vsi_bi+0.0*sqrtPhistVbs_Vdi_bi+T1DEP*sqrtPhistVbs_Vdi_bi_Vsi_bi);
#endif
Xdep_Vsi_bi=(T1DEP*sqrtPhistVbs_Vsi_bi);
#if defined(_DERIVATE2)
  Xdep_Vsi_bi_Tempt_GND=(+0.0*sqrtPhistVbs+0.0*sqrtPhistVbs_Tempt_GND+0.0*sqrtPhistVbs_Vsi_bi+T1DEP*sqrtPhistVbs_Vsi_bi_Tempt_GND);
  Xdep_Vsi_bi_Vdi_bi=(+0.0*sqrtPhistVbs+0.0*sqrtPhistVbs_Vdi_bi+0.0*sqrtPhistVbs_Vsi_bi+T1DEP*sqrtPhistVbs_Vsi_bi_Vdi_bi);
  Xdep_Vsi_bi_Vsi_bi=(+0.0*sqrtPhistVbs+0.0*sqrtPhistVbs_Vsi_bi+0.0*sqrtPhistVbs_Vsi_bi+T1DEP*sqrtPhistVbs_Vsi_bi_Vsi_bi);
#endif
#endif
Xdep=(T1DEP*sqrtPhistVbs);
EXIT_IF_ISNAN((T1DEP*sqrtPhistVbs))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
#if defined(_DERIVATE)
Cdep_Tempt_GND=(-epssi*Xdep_Tempt_GND/Xdep/Xdep);
#endif
Cdep_Vdi_bi=(-epssi*Xdep_Vdi_bi/Xdep/Xdep);
#if defined(_DERIVATE2)
  Cdep_Vdi_bi_Tempt_GND=(0.0/Xdep-(0.0*Xdep_Tempt_GND+0.0*Xdep_Vdi_bi+epssi*Xdep_Vdi_bi_Tempt_GND)/Xdep/Xdep+2*epssi*Xdep_Vdi_bi*Xdep_Tempt_GND/Xdep/Xdep/Xdep);
  Cdep_Vdi_bi_Vdi_bi=(0.0/Xdep-(0.0*Xdep_Vdi_bi+0.0*Xdep_Vdi_bi+epssi*Xdep_Vdi_bi_Vdi_bi)/Xdep/Xdep+2*epssi*Xdep_Vdi_bi*Xdep_Vdi_bi/Xdep/Xdep/Xdep);
  Cdep_Vdi_bi_Vsi_bi=(0.0/Xdep-(0.0*Xdep_Vsi_bi+0.0*Xdep_Vdi_bi+epssi*Xdep_Vdi_bi_Vsi_bi)/Xdep/Xdep+2*epssi*Xdep_Vdi_bi*Xdep_Vsi_bi/Xdep/Xdep/Xdep);
#endif
Cdep_Vsi_bi=(-epssi*Xdep_Vsi_bi/Xdep/Xdep);
#if defined(_DERIVATE2)
  Cdep_Vsi_bi_Tempt_GND=(0.0/Xdep-(0.0*Xdep_Tempt_GND+0.0*Xdep_Vsi_bi+epssi*Xdep_Vsi_bi_Tempt_GND)/Xdep/Xdep+2*epssi*Xdep_Vsi_bi*Xdep_Tempt_GND/Xdep/Xdep/Xdep);
  Cdep_Vsi_bi_Vdi_bi=(0.0/Xdep-(0.0*Xdep_Vdi_bi+0.0*Xdep_Vsi_bi+epssi*Xdep_Vsi_bi_Vdi_bi)/Xdep/Xdep+2*epssi*Xdep_Vsi_bi*Xdep_Vdi_bi/Xdep/Xdep/Xdep);
  Cdep_Vsi_bi_Vsi_bi=(0.0/Xdep-(0.0*Xdep_Vsi_bi+0.0*Xdep_Vsi_bi+epssi*Xdep_Vsi_bi_Vsi_bi)/Xdep/Xdep+2*epssi*Xdep_Vsi_bi*Xdep_Vsi_bi/Xdep/Xdep/Xdep);
#endif
#endif
Cdep=(epssi/Xdep);
EXIT_IF_ISNAN((epssi/Xdep))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
#if defined(_DERIVATE)
cdsc_Tempt_GND=((NFACTOR_t_Tempt_GND+((CDSCD_a_Tempt_GND*Vdsx)+(CDSCD_a*Vdsx_Tempt_GND)))-(CDSCB_i*Vbsx_Tempt_GND));
#endif
cdsc_Vdi_bi=(((CDSCD_a_Vdi_bi*Vdsx)+(CDSCD_a*Vdsx_Vdi_bi))-(CDSCB_i*Vbsx_Vdi_bi));
#if defined(_DERIVATE2)
  cdsc_Vdi_bi_Tempt_GND=(+(+(+0.0+0.0)+(+CDSCD_a_Vdi_bi_Tempt_GND*Vdsx+CDSCD_a_Vdi_bi*Vdsx_Tempt_GND+CDSCD_a_Tempt_GND*Vdsx_Vdi_bi+CDSCD_a*Vdsx_Vdi_bi_Tempt_GND))-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vdi_bi+CDSCB_i*Vbsx_Vdi_bi_Tempt_GND));
  cdsc_Vdi_bi_Vdi_bi=(+(+(+0.0+0.0)+(+CDSCD_a_Vdi_bi_Vdi_bi*Vdsx+CDSCD_a_Vdi_bi*Vdsx_Vdi_bi+CDSCD_a_Vdi_bi*Vdsx_Vdi_bi+CDSCD_a*Vdsx_Vdi_bi_Vdi_bi))-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+CDSCB_i*Vbsx_Vdi_bi_Vdi_bi));
  cdsc_Vdi_bi_Vsi_bi=(+(+(+0.0+0.0)+(+CDSCD_a_Vdi_bi_Vsi_bi*Vdsx+CDSCD_a_Vdi_bi*Vdsx_Vsi_bi+CDSCD_a_Vsi_bi*Vdsx_Vdi_bi+CDSCD_a*Vdsx_Vdi_bi_Vsi_bi))-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+CDSCB_i*Vbsx_Vdi_bi_Vsi_bi));
#endif
cdsc_Vsi_bi=(((CDSCD_a_Vsi_bi*Vdsx)+(CDSCD_a*Vdsx_Vsi_bi))-(CDSCB_i*Vbsx_Vsi_bi));
#if defined(_DERIVATE2)
  cdsc_Vsi_bi_Tempt_GND=(+(+(+0.0+0.0)+(+CDSCD_a_Vsi_bi_Tempt_GND*Vdsx+CDSCD_a_Vsi_bi*Vdsx_Tempt_GND+CDSCD_a_Tempt_GND*Vdsx_Vsi_bi+CDSCD_a*Vdsx_Vsi_bi_Tempt_GND))-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vsi_bi+CDSCB_i*Vbsx_Vsi_bi_Tempt_GND));
  cdsc_Vsi_bi_Vdi_bi=(+(+(+0.0+0.0)+(+CDSCD_a_Vsi_bi_Vdi_bi*Vdsx+CDSCD_a_Vsi_bi*Vdsx_Vdi_bi+CDSCD_a_Vdi_bi*Vdsx_Vsi_bi+CDSCD_a*Vdsx_Vsi_bi_Vdi_bi))-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+CDSCB_i*Vbsx_Vsi_bi_Vdi_bi));
  cdsc_Vsi_bi_Vsi_bi=(+(+(+0.0+0.0)+(+CDSCD_a_Vsi_bi_Vsi_bi*Vdsx+CDSCD_a_Vsi_bi*Vdsx_Vsi_bi+CDSCD_a_Vsi_bi*Vdsx_Vsi_bi+CDSCD_a*Vdsx_Vsi_bi_Vsi_bi))-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+CDSCB_i*Vbsx_Vsi_bi_Vsi_bi));
#endif
#endif
cdsc=(((CIT_i+NFACTOR_t)+(CDSCD_a*Vdsx))-(CDSCB_i*Vbsx));
EXIT_IF_ISNAN((((CIT_i+NFACTOR_t)+(CDSCD_a*Vdsx))-(CDSCB_i*Vbsx)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=(cdsc_Vdi_bi/Cox);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vgm_si=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vdbulk_di=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vsbulk_si=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vgi_bi=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vdi_bi=(+0.0+(cdsc_Vdi_bi_Vdi_bi/Cox-(cdsc_Vdi_bi*0.0+cdsc_Vdi_bi*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vsi_bi=(+0.0+(cdsc_Vdi_bi_Vsi_bi/Cox-(cdsc_Vdi_bi*0.0+cdsc_Vsi_bi*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Tempt_GND=(+0.0+(cdsc_Vdi_bi_Tempt_GND/Cox-(cdsc_Vdi_bi*0.0+cdsc_Tempt_GND*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
#endif
T1_Vsi_bi=(cdsc_Vsi_bi/Cox);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vgm_si=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vdbulk_di=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vsbulk_si=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vgi_bi=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vdi_bi=(+0.0+(cdsc_Vsi_bi_Vdi_bi/Cox-(cdsc_Vsi_bi*0.0+cdsc_Vdi_bi*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vsi_bi=(+0.0+(cdsc_Vsi_bi_Vsi_bi/Cox-(cdsc_Vsi_bi*0.0+cdsc_Vsi_bi*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Tempt_GND=(+0.0+(cdsc_Vsi_bi_Tempt_GND/Cox-(cdsc_Vsi_bi*0.0+cdsc_Tempt_GND*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(cdsc_Tempt_GND/Cox);
#endif
#endif
T1=(1.0+(cdsc/Cox));
EXIT_IF_ISNAN((1.0+(cdsc/Cox)))
{
double m00_sqrt(d00_sqrt0,(((T1-1)*(T1-1))+((0.25*0.05)*0.05)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T1-1)*(T1-1))+((0.25*0.05)*0.05)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
n_Vgm_si=0.0;
#if defined(_DERIVATE2)
  n_Vgm_si_Vgm_si=0.0;
  n_Vgm_si_Vdbulk_di=0.0;
  n_Vgm_si_Vsbulk_si=0.0;
  n_Vgm_si_Vgi_bi=0.0;
  n_Vgm_si_Vdi_bi=0.0;
  n_Vgm_si_Vsi_bi=0.0;
  n_Vgm_si_Tempt_GND=0.0;
#endif
n_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  n_Vdbulk_di_Vgm_si=0.0;
  n_Vdbulk_di_Vdbulk_di=0.0;
  n_Vdbulk_di_Vsbulk_si=0.0;
  n_Vdbulk_di_Vgi_bi=0.0;
  n_Vdbulk_di_Vdi_bi=0.0;
  n_Vdbulk_di_Vsi_bi=0.0;
  n_Vdbulk_di_Tempt_GND=0.0;
#endif
n_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  n_Vsbulk_si_Vgm_si=0.0;
  n_Vsbulk_si_Vdbulk_di=0.0;
  n_Vsbulk_si_Vsbulk_si=0.0;
  n_Vsbulk_si_Vgi_bi=0.0;
  n_Vsbulk_si_Vdi_bi=0.0;
  n_Vsbulk_si_Vsi_bi=0.0;
  n_Vsbulk_si_Tempt_GND=0.0;
#endif
n_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  n_Vgi_bi_Vgm_si=0.0;
  n_Vgi_bi_Vdbulk_di=0.0;
  n_Vgi_bi_Vsbulk_si=0.0;
  n_Vgi_bi_Vgi_bi=0.0;
  n_Vgi_bi_Vdi_bi=0.0;
  n_Vgi_bi_Vsi_bi=0.0;
  n_Vgi_bi_Tempt_GND=0.0;
#endif
n_Vdi_bi=(0.5*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  n_Vdi_bi_Vgm_si=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vgm_si+((((T1_Vgm_si*(T1-1))+((T1-1)*T1_Vgm_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vgm_si*(T1-1))+((T1-1)*T1_Vgm_si)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vgm_si-0.0)*(T1-1)+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+(T1-1)*(+T1_Vdi_bi_Vgm_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vdbulk_di=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*(T1-1))+((T1-1)*T1_Vdbulk_di)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vdbulk_di*(T1-1))+((T1-1)*T1_Vdbulk_di)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vdbulk_di-0.0)*(T1-1)+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+(T1-1)*(+T1_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vsbulk_si=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*(T1-1))+((T1-1)*T1_Vsbulk_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vsbulk_si*(T1-1))+((T1-1)*T1_Vsbulk_si)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vsbulk_si-0.0)*(T1-1)+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+(T1-1)*(+T1_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vgi_bi=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*(T1-1))+((T1-1)*T1_Vgi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vgi_bi*(T1-1))+((T1-1)*T1_Vgi_bi)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vgi_bi-0.0)*(T1-1)+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+(T1-1)*(+T1_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vdi_bi=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vdi_bi-0.0)*(T1-1)+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+(T1-1)*(+T1_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vsi_bi=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vsi_bi-0.0)*(T1-1)+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+(T1-1)*(+T1_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Tempt_GND=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*(T1-1))+((T1-1)*T1_Tempt_GND)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Tempt_GND*(T1-1))+((T1-1)*T1_Tempt_GND)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Tempt_GND-0.0)*(T1-1)+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+(T1-1)*(+T1_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
#endif
n_Vsi_bi=(0.5*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  n_Vsi_bi_Vgm_si=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vgm_si+((((T1_Vgm_si*(T1-1))+((T1-1)*T1_Vgm_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vgm_si*(T1-1))+((T1-1)*T1_Vgm_si)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vgm_si-0.0)*(T1-1)+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+(T1-1)*(+T1_Vsi_bi_Vgm_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vdbulk_di=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*(T1-1))+((T1-1)*T1_Vdbulk_di)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vdbulk_di*(T1-1))+((T1-1)*T1_Vdbulk_di)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vdbulk_di-0.0)*(T1-1)+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+(T1-1)*(+T1_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vsbulk_si=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*(T1-1))+((T1-1)*T1_Vsbulk_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vsbulk_si*(T1-1))+((T1-1)*T1_Vsbulk_si)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vsbulk_si-0.0)*(T1-1)+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+(T1-1)*(+T1_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vgi_bi=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*(T1-1))+((T1-1)*T1_Vgi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vgi_bi*(T1-1))+((T1-1)*T1_Vgi_bi)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vgi_bi-0.0)*(T1-1)+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+(T1-1)*(+T1_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vdi_bi=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vdi_bi*(T1-1))+((T1-1)*T1_Vdi_bi)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vdi_bi-0.0)*(T1-1)+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+(T1-1)*(+T1_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vsi_bi=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vsi_bi-0.0)*(T1-1)+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+(T1-1)*(+T1_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Tempt_GND=(+0.0*((T1+1)+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*(T1-1))+((T1-1)*T1_Tempt_GND)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))*((((T1_Tempt_GND*(T1-1))+((T1-1)*T1_Tempt_GND)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1))+((T1-1)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Tempt_GND-0.0)*(T1-1)+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+(T1-1)*(+T1_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
#endif
#if defined(_DERIVATE)
n_Tempt_GND=(0.5*(T1_Tempt_GND+((T1_Tempt_GND*(T1-1))+((T1-1)*T1_Tempt_GND))*d10_sqrt0));
#endif
#endif
n=(0.5*((T1+1)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T1+1)+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
nVt_Vgm_si=0.0;
#if defined(_DERIVATE2)
  nVt_Vgm_si_Vgm_si=0.0;
  nVt_Vgm_si_Vdbulk_di=0.0;
  nVt_Vgm_si_Vsbulk_si=0.0;
  nVt_Vgm_si_Vgi_bi=0.0;
  nVt_Vgm_si_Vdi_bi=0.0;
  nVt_Vgm_si_Vsi_bi=0.0;
  nVt_Vgm_si_Tempt_GND=0.0;
#endif
nVt_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  nVt_Vdbulk_di_Vgm_si=0.0;
  nVt_Vdbulk_di_Vdbulk_di=0.0;
  nVt_Vdbulk_di_Vsbulk_si=0.0;
  nVt_Vdbulk_di_Vgi_bi=0.0;
  nVt_Vdbulk_di_Vdi_bi=0.0;
  nVt_Vdbulk_di_Vsi_bi=0.0;
  nVt_Vdbulk_di_Tempt_GND=0.0;
#endif
nVt_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  nVt_Vsbulk_si_Vgm_si=0.0;
  nVt_Vsbulk_si_Vdbulk_di=0.0;
  nVt_Vsbulk_si_Vsbulk_si=0.0;
  nVt_Vsbulk_si_Vgi_bi=0.0;
  nVt_Vsbulk_si_Vdi_bi=0.0;
  nVt_Vsbulk_si_Vsi_bi=0.0;
  nVt_Vsbulk_si_Tempt_GND=0.0;
#endif
nVt_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  nVt_Vgi_bi_Vgm_si=0.0;
  nVt_Vgi_bi_Vdbulk_di=0.0;
  nVt_Vgi_bi_Vsbulk_si=0.0;
  nVt_Vgi_bi_Vgi_bi=0.0;
  nVt_Vgi_bi_Vdi_bi=0.0;
  nVt_Vgi_bi_Vsi_bi=0.0;
  nVt_Vgi_bi_Tempt_GND=0.0;
#endif
nVt_Vdi_bi=n_Vdi_bi*Vt;
#if defined(_DERIVATE2)
  nVt_Vdi_bi_Vgm_si=(+n_Vdi_bi_Vgm_si*Vt+n_Vdi_bi*0.0+n_Vgm_si*0.0+n*0.0);
  nVt_Vdi_bi_Vdbulk_di=(+n_Vdi_bi_Vdbulk_di*Vt+n_Vdi_bi*0.0+n_Vdbulk_di*0.0+n*0.0);
  nVt_Vdi_bi_Vsbulk_si=(+n_Vdi_bi_Vsbulk_si*Vt+n_Vdi_bi*0.0+n_Vsbulk_si*0.0+n*0.0);
  nVt_Vdi_bi_Vgi_bi=(+n_Vdi_bi_Vgi_bi*Vt+n_Vdi_bi*0.0+n_Vgi_bi*0.0+n*0.0);
  nVt_Vdi_bi_Vdi_bi=(+n_Vdi_bi_Vdi_bi*Vt+n_Vdi_bi*0.0+n_Vdi_bi*0.0+n*0.0);
  nVt_Vdi_bi_Vsi_bi=(+n_Vdi_bi_Vsi_bi*Vt+n_Vdi_bi*0.0+n_Vsi_bi*0.0+n*0.0);
  nVt_Vdi_bi_Tempt_GND=(+n_Vdi_bi_Tempt_GND*Vt+n_Vdi_bi*Vt_Tempt_GND+n_Tempt_GND*0.0+n*0.0);
#endif
nVt_Vsi_bi=n_Vsi_bi*Vt;
#if defined(_DERIVATE2)
  nVt_Vsi_bi_Vgm_si=(+n_Vsi_bi_Vgm_si*Vt+n_Vsi_bi*0.0+n_Vgm_si*0.0+n*0.0);
  nVt_Vsi_bi_Vdbulk_di=(+n_Vsi_bi_Vdbulk_di*Vt+n_Vsi_bi*0.0+n_Vdbulk_di*0.0+n*0.0);
  nVt_Vsi_bi_Vsbulk_si=(+n_Vsi_bi_Vsbulk_si*Vt+n_Vsi_bi*0.0+n_Vsbulk_si*0.0+n*0.0);
  nVt_Vsi_bi_Vgi_bi=(+n_Vsi_bi_Vgi_bi*Vt+n_Vsi_bi*0.0+n_Vgi_bi*0.0+n*0.0);
  nVt_Vsi_bi_Vdi_bi=(+n_Vsi_bi_Vdi_bi*Vt+n_Vsi_bi*0.0+n_Vdi_bi*0.0+n*0.0);
  nVt_Vsi_bi_Vsi_bi=(+n_Vsi_bi_Vsi_bi*Vt+n_Vsi_bi*0.0+n_Vsi_bi*0.0+n*0.0);
  nVt_Vsi_bi_Tempt_GND=(+n_Vsi_bi_Tempt_GND*Vt+n_Vsi_bi*Vt_Tempt_GND+n_Tempt_GND*0.0+n*0.0);
#endif
#if defined(_DERIVATE)
nVt_Tempt_GND=((n_Tempt_GND*Vt)+(n*Vt_Tempt_GND));
#endif
#endif
nVt=(n*Vt);
EXIT_IF_ISNAN((n*Vt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
inv_nVt_Vgm_si=0.0;
#if defined(_DERIVATE2)
  inv_nVt_Vgm_si_Vgm_si=0.0;
  inv_nVt_Vgm_si_Vdbulk_di=0.0;
  inv_nVt_Vgm_si_Vsbulk_si=0.0;
  inv_nVt_Vgm_si_Vgi_bi=0.0;
  inv_nVt_Vgm_si_Vdi_bi=0.0;
  inv_nVt_Vgm_si_Vsi_bi=0.0;
  inv_nVt_Vgm_si_Tempt_GND=0.0;
#endif
inv_nVt_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  inv_nVt_Vdbulk_di_Vgm_si=0.0;
  inv_nVt_Vdbulk_di_Vdbulk_di=0.0;
  inv_nVt_Vdbulk_di_Vsbulk_si=0.0;
  inv_nVt_Vdbulk_di_Vgi_bi=0.0;
  inv_nVt_Vdbulk_di_Vdi_bi=0.0;
  inv_nVt_Vdbulk_di_Vsi_bi=0.0;
  inv_nVt_Vdbulk_di_Tempt_GND=0.0;
#endif
inv_nVt_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  inv_nVt_Vsbulk_si_Vgm_si=0.0;
  inv_nVt_Vsbulk_si_Vdbulk_di=0.0;
  inv_nVt_Vsbulk_si_Vsbulk_si=0.0;
  inv_nVt_Vsbulk_si_Vgi_bi=0.0;
  inv_nVt_Vsbulk_si_Vdi_bi=0.0;
  inv_nVt_Vsbulk_si_Vsi_bi=0.0;
  inv_nVt_Vsbulk_si_Tempt_GND=0.0;
#endif
inv_nVt_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  inv_nVt_Vgi_bi_Vgm_si=0.0;
  inv_nVt_Vgi_bi_Vdbulk_di=0.0;
  inv_nVt_Vgi_bi_Vsbulk_si=0.0;
  inv_nVt_Vgi_bi_Vgi_bi=0.0;
  inv_nVt_Vgi_bi_Vdi_bi=0.0;
  inv_nVt_Vgi_bi_Vsi_bi=0.0;
  inv_nVt_Vgi_bi_Tempt_GND=0.0;
#endif
inv_nVt_Vdi_bi=(-nVt_Vdi_bi/nVt/nVt);
#if defined(_DERIVATE2)
  inv_nVt_Vdi_bi_Vgm_si=(0.0/nVt-(0.0*nVt_Vgm_si+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vgm_si)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vgm_si/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vdbulk_di=(0.0/nVt-(0.0*nVt_Vdbulk_di+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vdbulk_di)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vdbulk_di/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vsbulk_si=(0.0/nVt-(0.0*nVt_Vsbulk_si+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vsbulk_si)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vsbulk_si/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vgi_bi=(0.0/nVt-(0.0*nVt_Vgi_bi+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vgi_bi)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vgi_bi/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vdi_bi=(0.0/nVt-(0.0*nVt_Vdi_bi+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vdi_bi)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vdi_bi/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vsi_bi=(0.0/nVt-(0.0*nVt_Vsi_bi+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vsi_bi)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vsi_bi/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Tempt_GND=(0.0/nVt-(0.0*nVt_Tempt_GND+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Tempt_GND)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Tempt_GND/nVt/nVt/nVt);
#endif
inv_nVt_Vsi_bi=(-nVt_Vsi_bi/nVt/nVt);
#if defined(_DERIVATE2)
  inv_nVt_Vsi_bi_Vgm_si=(0.0/nVt-(0.0*nVt_Vgm_si+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vgm_si)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vgm_si/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vdbulk_di=(0.0/nVt-(0.0*nVt_Vdbulk_di+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vdbulk_di)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vdbulk_di/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vsbulk_si=(0.0/nVt-(0.0*nVt_Vsbulk_si+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vsbulk_si)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vsbulk_si/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vgi_bi=(0.0/nVt-(0.0*nVt_Vgi_bi+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vgi_bi)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vgi_bi/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vdi_bi=(0.0/nVt-(0.0*nVt_Vdi_bi+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vdi_bi)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vdi_bi/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vsi_bi=(0.0/nVt-(0.0*nVt_Vsi_bi+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vsi_bi)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vsi_bi/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Tempt_GND=(0.0/nVt-(0.0*nVt_Tempt_GND+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Tempt_GND)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Tempt_GND/nVt/nVt/nVt);
#endif
#if defined(_DERIVATE)
inv_nVt_Tempt_GND=(-nVt_Tempt_GND/nVt/nVt);
#endif
#endif
inv_nVt=(1.0/nVt);
EXIT_IF_ISNAN((1.0/nVt))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
dVth_dibl_Tempt_GND=(((-(ETA0_a_Tempt_GND+(ETAB_i*Vbsx_Tempt_GND)))*Vdsx)+((-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx_Tempt_GND));
#endif
dVth_dibl_Vdi_bi=(((-(ETA0_a_Vdi_bi+(ETAB_i*Vbsx_Vdi_bi)))*Vdsx)+((-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx_Vdi_bi));
#if defined(_DERIVATE2)
  dVth_dibl_Vdi_bi_Tempt_GND=(+0.0*Vdsx+(-(ETA0_a_Vdi_bi+(ETAB_i*Vbsx_Vdi_bi)))*Vdsx_Tempt_GND+(-(ETA0_a_Tempt_GND+((ETAB_i*Vbsx_Tempt_GND))))*Vdsx_Vdi_bi+(-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx_Vdi_bi_Tempt_GND);
  dVth_dibl_Vdi_bi_Vdi_bi=(+0.0*Vdsx+(-(ETA0_a_Vdi_bi+(ETAB_i*Vbsx_Vdi_bi)))*Vdsx_Vdi_bi+(-(ETA0_a_Vdi_bi+((ETAB_i*Vbsx_Vdi_bi))))*Vdsx_Vdi_bi+(-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx_Vdi_bi_Vdi_bi);
  dVth_dibl_Vdi_bi_Vsi_bi=(+0.0*Vdsx+(-(ETA0_a_Vdi_bi+(ETAB_i*Vbsx_Vdi_bi)))*Vdsx_Vsi_bi+(-(ETA0_a_Vsi_bi+((ETAB_i*Vbsx_Vsi_bi))))*Vdsx_Vdi_bi+(-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx_Vdi_bi_Vsi_bi);
#endif
dVth_dibl_Vsi_bi=(((-(ETA0_a_Vsi_bi+(ETAB_i*Vbsx_Vsi_bi)))*Vdsx)+((-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx_Vsi_bi));
#if defined(_DERIVATE2)
  dVth_dibl_Vsi_bi_Tempt_GND=(+0.0*Vdsx+(-(ETA0_a_Vsi_bi+(ETAB_i*Vbsx_Vsi_bi)))*Vdsx_Tempt_GND+(-(ETA0_a_Tempt_GND+((ETAB_i*Vbsx_Tempt_GND))))*Vdsx_Vsi_bi+(-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx_Vsi_bi_Tempt_GND);
  dVth_dibl_Vsi_bi_Vdi_bi=(+0.0*Vdsx+(-(ETA0_a_Vsi_bi+(ETAB_i*Vbsx_Vsi_bi)))*Vdsx_Vdi_bi+(-(ETA0_a_Vdi_bi+((ETAB_i*Vbsx_Vdi_bi))))*Vdsx_Vsi_bi+(-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx_Vsi_bi_Vdi_bi);
  dVth_dibl_Vsi_bi_Vsi_bi=(+0.0*Vdsx+(-(ETA0_a_Vsi_bi+(ETAB_i*Vbsx_Vsi_bi)))*Vdsx_Vsi_bi+(-(ETA0_a_Vsi_bi+((ETAB_i*Vbsx_Vsi_bi))))*Vdsx_Vsi_bi+(-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx_Vsi_bi_Vsi_bi);
#endif
#endif
dVth_dibl=((-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx);
EXIT_IF_ISNAN(((-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx))
{
double m00_pow(d00_pow0,TRatio,pModel->KT1EXP)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,TRatio,pModel->KT1EXP)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
dvth_temp_Vdi_bi=(KT2_i*Vbsx_Vdi_bi)*(d00_pow0-1.0);
#if defined(_DERIVATE2)
  dvth_temp_Vdi_bi_Vdi_bi=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+pModel->KT1L*0.0)/Leff/Leff+2*pModel->KT1L*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+KT2_i*Vbsx_Vdi_bi_Vdi_bi))*(d00_pow0-1.0)+(KT2_i*Vbsx_Vdi_bi)*0.0+((KT2_i*Vbsx_Vdi_bi))*0.0+((KT1_i+(pModel->KT1L/Leff))+(KT2_i*Vbsx))*(+fixme-0.0));
  dvth_temp_Vdi_bi_Vsi_bi=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+pModel->KT1L*0.0)/Leff/Leff+2*pModel->KT1L*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+KT2_i*Vbsx_Vdi_bi_Vsi_bi))*(d00_pow0-1.0)+(KT2_i*Vbsx_Vdi_bi)*0.0+((KT2_i*Vbsx_Vsi_bi))*0.0+((KT1_i+(pModel->KT1L/Leff))+(KT2_i*Vbsx))*(+fixme-0.0));
  dvth_temp_Vdi_bi_Tempt_GND=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+pModel->KT1L*0.0)/Leff/Leff+2*pModel->KT1L*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vdi_bi+KT2_i*Vbsx_Vdi_bi_Tempt_GND))*(d00_pow0-1.0)+(KT2_i*Vbsx_Vdi_bi)*(d10_pow0*TRatio_Tempt_GND)+((KT2_i*Vbsx_Tempt_GND))*0.0+((KT1_i+(pModel->KT1L/Leff))+(KT2_i*Vbsx))*(+fixme-0.0));
#endif
dvth_temp_Vsi_bi=(KT2_i*Vbsx_Vsi_bi)*(d00_pow0-1.0);
#if defined(_DERIVATE2)
  dvth_temp_Vsi_bi_Vdi_bi=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+pModel->KT1L*0.0)/Leff/Leff+2*pModel->KT1L*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+KT2_i*Vbsx_Vsi_bi_Vdi_bi))*(d00_pow0-1.0)+(KT2_i*Vbsx_Vsi_bi)*0.0+((KT2_i*Vbsx_Vdi_bi))*0.0+((KT1_i+(pModel->KT1L/Leff))+(KT2_i*Vbsx))*(+fixme-0.0));
  dvth_temp_Vsi_bi_Vsi_bi=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+pModel->KT1L*0.0)/Leff/Leff+2*pModel->KT1L*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+KT2_i*Vbsx_Vsi_bi_Vsi_bi))*(d00_pow0-1.0)+(KT2_i*Vbsx_Vsi_bi)*0.0+((KT2_i*Vbsx_Vsi_bi))*0.0+((KT1_i+(pModel->KT1L/Leff))+(KT2_i*Vbsx))*(+fixme-0.0));
  dvth_temp_Vsi_bi_Tempt_GND=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+pModel->KT1L*0.0)/Leff/Leff+2*pModel->KT1L*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vsi_bi+KT2_i*Vbsx_Vsi_bi_Tempt_GND))*(d00_pow0-1.0)+(KT2_i*Vbsx_Vsi_bi)*(d10_pow0*TRatio_Tempt_GND)+((KT2_i*Vbsx_Tempt_GND))*0.0+((KT1_i+(pModel->KT1L/Leff))+(KT2_i*Vbsx))*(+fixme-0.0));
#endif
#if defined(_DERIVATE)
dvth_temp_Tempt_GND=(((KT2_i*Vbsx_Tempt_GND)*(d00_pow0-1.0))+(((KT1_i+(pModel->KT1L/Leff))+(KT2_i*Vbsx))*(d10_pow0*TRatio_Tempt_GND)));
#endif
#endif
dvth_temp=(((KT1_i+(pModel->KT1L/Leff))+(KT2_i*Vbsx))*(d00_pow0-1.0));
EXIT_IF_ISNAN((((KT1_i+(pModel->KT1L/Leff))+(KT2_i*Vbsx))*(d00_pow0-1.0)))
}
{
double m00_sqrt(d00_sqrt0,((dVth_dibl*dVth_dibl)+((0.25*5.0e-5)*5.0e-5)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((dVth_dibl*dVth_dibl)+((0.25*5.0e-5)*5.0e-5)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
dVth_dibl_Tempt_GND=(0.5*(dVth_dibl_Tempt_GND-((dVth_dibl_Tempt_GND*dVth_dibl)+(dVth_dibl*dVth_dibl_Tempt_GND))*d10_sqrt0));
#endif
dVth_dibl_Vdi_bi=(0.5*(dVth_dibl_Vdi_bi-((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  dVth_dibl_Vdi_bi_Tempt_GND=(+(+0.0*(dVth_dibl-d00_sqrt0)+0.0*(dVth_dibl_Tempt_GND-((((dVth_dibl_Tempt_GND*dVth_dibl)+(dVth_dibl*dVth_dibl_Tempt_GND)))+((0.0)*5.0e-5))*d10_sqrt0)+0.0*(dVth_dibl_Vdi_bi-((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi))*d10_sqrt0)+0.5*(+(+dVth_dibl_Vdi_bi_Tempt_GND+0.0)-(m20_sqrt(((dVth_dibl*dVth_dibl)+((0.25*5.0e-5)*5.0e-5)))*((((dVth_dibl_Tempt_GND*dVth_dibl)+(dVth_dibl*dVth_dibl_Tempt_GND)))+((0.0)*5.0e-5))*((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi))+d10_sqrt0*(+(+(+dVth_dibl_Vdi_bi_Tempt_GND-0.0)*dVth_dibl+dVth_dibl_Vdi_bi*dVth_dibl_Tempt_GND+dVth_dibl_Tempt_GND*dVth_dibl_Vdi_bi+dVth_dibl*(+dVth_dibl_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0)*5.0e-5+0.0*0.0+(0.0)*0.0+(0.25*5.0e-5)*0.0)))))+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0));
  dVth_dibl_Vdi_bi_Vdi_bi=(+(+0.0*(dVth_dibl-d00_sqrt0)+0.0*(dVth_dibl_Vdi_bi-((((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi)))+((0.0)*5.0e-5))*d10_sqrt0)+0.0*(dVth_dibl_Vdi_bi-((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi))*d10_sqrt0)+0.5*(+(+dVth_dibl_Vdi_bi_Vdi_bi+0.0)-(m20_sqrt(((dVth_dibl*dVth_dibl)+((0.25*5.0e-5)*5.0e-5)))*((((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi)))+((0.0)*5.0e-5))*((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi))+d10_sqrt0*(+(+(+dVth_dibl_Vdi_bi_Vdi_bi-0.0)*dVth_dibl+dVth_dibl_Vdi_bi*dVth_dibl_Vdi_bi+dVth_dibl_Vdi_bi*dVth_dibl_Vdi_bi+dVth_dibl*(+dVth_dibl_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0)*5.0e-5+0.0*0.0+(0.0)*0.0+(0.25*5.0e-5)*0.0)))))+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0));
  dVth_dibl_Vdi_bi_Vsi_bi=(+(+0.0*(dVth_dibl-d00_sqrt0)+0.0*(dVth_dibl_Vsi_bi-((((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi)))+((0.0)*5.0e-5))*d10_sqrt0)+0.0*(dVth_dibl_Vdi_bi-((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi))*d10_sqrt0)+0.5*(+(+dVth_dibl_Vdi_bi_Vsi_bi+0.0)-(m20_sqrt(((dVth_dibl*dVth_dibl)+((0.25*5.0e-5)*5.0e-5)))*((((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi)))+((0.0)*5.0e-5))*((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi))+d10_sqrt0*(+(+(+dVth_dibl_Vdi_bi_Vsi_bi-0.0)*dVth_dibl+dVth_dibl_Vdi_bi*dVth_dibl_Vsi_bi+dVth_dibl_Vsi_bi*dVth_dibl_Vdi_bi+dVth_dibl*(+dVth_dibl_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0)*5.0e-5+0.0*0.0+(0.0)*0.0+(0.25*5.0e-5)*0.0)))))+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0));
#endif
dVth_dibl_Vsi_bi=(0.5*(dVth_dibl_Vsi_bi-((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  dVth_dibl_Vsi_bi_Tempt_GND=(+(+0.0*(dVth_dibl-d00_sqrt0)+0.0*(dVth_dibl_Tempt_GND-((((dVth_dibl_Tempt_GND*dVth_dibl)+(dVth_dibl*dVth_dibl_Tempt_GND)))+((0.0)*5.0e-5))*d10_sqrt0)+0.0*(dVth_dibl_Vsi_bi-((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi))*d10_sqrt0)+0.5*(+(+dVth_dibl_Vsi_bi_Tempt_GND+0.0)-(m20_sqrt(((dVth_dibl*dVth_dibl)+((0.25*5.0e-5)*5.0e-5)))*((((dVth_dibl_Tempt_GND*dVth_dibl)+(dVth_dibl*dVth_dibl_Tempt_GND)))+((0.0)*5.0e-5))*((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi))+d10_sqrt0*(+(+(+dVth_dibl_Vsi_bi_Tempt_GND-0.0)*dVth_dibl+dVth_dibl_Vsi_bi*dVth_dibl_Tempt_GND+dVth_dibl_Tempt_GND*dVth_dibl_Vsi_bi+dVth_dibl*(+dVth_dibl_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0)*5.0e-5+0.0*0.0+(0.0)*0.0+(0.25*5.0e-5)*0.0)))))+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0));
  dVth_dibl_Vsi_bi_Vdi_bi=(+(+0.0*(dVth_dibl-d00_sqrt0)+0.0*(dVth_dibl_Vdi_bi-((((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi)))+((0.0)*5.0e-5))*d10_sqrt0)+0.0*(dVth_dibl_Vsi_bi-((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi))*d10_sqrt0)+0.5*(+(+dVth_dibl_Vsi_bi_Vdi_bi+0.0)-(m20_sqrt(((dVth_dibl*dVth_dibl)+((0.25*5.0e-5)*5.0e-5)))*((((dVth_dibl_Vdi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vdi_bi)))+((0.0)*5.0e-5))*((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi))+d10_sqrt0*(+(+(+dVth_dibl_Vsi_bi_Vdi_bi-0.0)*dVth_dibl+dVth_dibl_Vsi_bi*dVth_dibl_Vdi_bi+dVth_dibl_Vdi_bi*dVth_dibl_Vsi_bi+dVth_dibl*(+dVth_dibl_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0)*5.0e-5+0.0*0.0+(0.0)*0.0+(0.25*5.0e-5)*0.0)))))+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0));
  dVth_dibl_Vsi_bi_Vsi_bi=(+(+0.0*(dVth_dibl-d00_sqrt0)+0.0*(dVth_dibl_Vsi_bi-((((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi)))+((0.0)*5.0e-5))*d10_sqrt0)+0.0*(dVth_dibl_Vsi_bi-((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi))*d10_sqrt0)+0.5*(+(+dVth_dibl_Vsi_bi_Vsi_bi+0.0)-(m20_sqrt(((dVth_dibl*dVth_dibl)+((0.25*5.0e-5)*5.0e-5)))*((((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi)))+((0.0)*5.0e-5))*((dVth_dibl_Vsi_bi*dVth_dibl)+(dVth_dibl*dVth_dibl_Vsi_bi))+d10_sqrt0*(+(+(+dVth_dibl_Vsi_bi_Vsi_bi-0.0)*dVth_dibl+dVth_dibl_Vsi_bi*dVth_dibl_Vsi_bi+dVth_dibl_Vsi_bi*dVth_dibl_Vsi_bi+dVth_dibl*(+dVth_dibl_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0)*5.0e-5+0.0*0.0+(0.0)*0.0+(0.25*5.0e-5)*0.0)))))+(+0.0*5.0e-5+0.0*0.0+0.0*0.0+0.25*0.0));
#endif
#endif
dVth_dibl=((0.5*(dVth_dibl-d00_sqrt0))+(0.25*5.0e-5));
EXIT_IF_ISNAN(((0.5*(dVth_dibl-d00_sqrt0))+(0.25*5.0e-5)))
}
if
((DVTP0_i>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=((-DVTP1_i)*Vdsx_Vdi_bi);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vdi_bi+(-DVTP1_i)*0.0);
  T0_Vdi_bi_Vgm_si=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vdi_bi+(-DVTP1_i)*0.0);
  T0_Vdi_bi_Vdbulk_di=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vdi_bi+(-DVTP1_i)*0.0);
  T0_Vdi_bi_Vsbulk_si=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vdi_bi+(-DVTP1_i)*0.0);
  T0_Vdi_bi_Vgi_bi=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vdi_bi+(-DVTP1_i)*0.0);
  T0_Vdi_bi_Vdi_bi=(+0.0*Vdsx+0.0*Vdsx_Vdi_bi+0.0*Vdsx_Vdi_bi+(-DVTP1_i)*Vdsx_Vdi_bi_Vdi_bi);
  T0_Vdi_bi_Vsi_bi=(+0.0*Vdsx+0.0*Vdsx_Vsi_bi+0.0*Vdsx_Vdi_bi+(-DVTP1_i)*Vdsx_Vdi_bi_Vsi_bi);
  T0_Vdi_bi_Tempt_GND=(+0.0*Vdsx+0.0*Vdsx_Tempt_GND+0.0*Vdsx_Vdi_bi+(-DVTP1_i)*Vdsx_Vdi_bi_Tempt_GND);
#endif
T0_Vsi_bi=((-DVTP1_i)*Vdsx_Vsi_bi);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vsi_bi+(-DVTP1_i)*0.0);
  T0_Vsi_bi_Vgm_si=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vsi_bi+(-DVTP1_i)*0.0);
  T0_Vsi_bi_Vdbulk_di=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vsi_bi+(-DVTP1_i)*0.0);
  T0_Vsi_bi_Vsbulk_si=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vsi_bi+(-DVTP1_i)*0.0);
  T0_Vsi_bi_Vgi_bi=(+0.0*Vdsx+0.0*0.0+0.0*Vdsx_Vsi_bi+(-DVTP1_i)*0.0);
  T0_Vsi_bi_Vdi_bi=(+0.0*Vdsx+0.0*Vdsx_Vdi_bi+0.0*Vdsx_Vsi_bi+(-DVTP1_i)*Vdsx_Vsi_bi_Vdi_bi);
  T0_Vsi_bi_Vsi_bi=(+0.0*Vdsx+0.0*Vdsx_Vsi_bi+0.0*Vdsx_Vsi_bi+(-DVTP1_i)*Vdsx_Vsi_bi_Vsi_bi);
  T0_Vsi_bi_Tempt_GND=(+0.0*Vdsx+0.0*Vdsx_Tempt_GND+0.0*Vdsx_Vsi_bi+(-DVTP1_i)*Vdsx_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((-DVTP1_i)*Vdsx_Tempt_GND);
#endif
#endif
T0=((-DVTP1_i)*Vdsx);
EXIT_IF_ISNAN(((-DVTP1_i)*Vdsx))
if
((T0<(-80.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=0.0;
#endif
#endif
T2=1.804851387e-35;
EXIT_IF_ISNAN(1.804851387e-35)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=bsimbulk_d_lexp(T0,T0_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=T0_Vdi_bi_Vgm_di;
  T2_Vdi_bi_Vgm_si=T0_Vdi_bi_Vgm_si;
  T2_Vdi_bi_Vdbulk_di=T0_Vdi_bi_Vdbulk_di;
  T2_Vdi_bi_Vsbulk_si=T0_Vdi_bi_Vsbulk_si;
  T2_Vdi_bi_Vgi_bi=T0_Vdi_bi_Vgi_bi;
  T2_Vdi_bi_Vdi_bi=T0_Vdi_bi_Vdi_bi;
  T2_Vdi_bi_Vsi_bi=T0_Vdi_bi_Vsi_bi;
  T2_Vdi_bi_Tempt_GND=T0_Vdi_bi_Tempt_GND;
#endif
T2_Vsi_bi=bsimbulk_d_lexp(T0,T0_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=T0_Vsi_bi_Vgm_di;
  T2_Vsi_bi_Vgm_si=T0_Vsi_bi_Vgm_si;
  T2_Vsi_bi_Vdbulk_di=T0_Vsi_bi_Vdbulk_di;
  T2_Vsi_bi_Vsbulk_si=T0_Vsi_bi_Vsbulk_si;
  T2_Vsi_bi_Vgi_bi=T0_Vsi_bi_Vgi_bi;
  T2_Vsi_bi_Vdi_bi=T0_Vsi_bi_Vdi_bi;
  T2_Vsi_bi_Vsi_bi=T0_Vsi_bi_Vsi_bi;
  T2_Vsi_bi_Tempt_GND=T0_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=bsimbulk_d_lexp(T0,T0_Tempt_GND);
#endif
#endif
T2=bsimbulk_lexp(T0);
EXIT_IF_ISNAN(bsimbulk_lexp(T0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=(DVTP0_i*T2_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+DVTP0_i*(+0.0+T2_Vdi_bi_Vgm_si)));
  T3_Vdi_bi_Vgm_di=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+DVTP0_i*(+0.0+T2_Vdi_bi_Vgm_di)));
  T3_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+DVTP0_i*(+0.0+T2_Vdi_bi_Vdbulk_di)));
  T3_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+DVTP0_i*(+0.0+T2_Vdi_bi_Vsbulk_si)));
  T3_Vdi_bi_Vgi_bi=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+DVTP0_i*(+0.0+T2_Vdi_bi_Vgi_bi)));
  T3_Vdi_bi_Vdi_bi=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+DVTP0_i*(+0.0+T2_Vdi_bi_Vdi_bi)));
  T3_Vdi_bi_Vsi_bi=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+DVTP0_i*(+0.0+T2_Vdi_bi_Vsi_bi)));
  T3_Vdi_bi_Tempt_GND=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+DVTP0_i*(+0.0+T2_Vdi_bi_Tempt_GND)));
#endif
T3_Vsi_bi=(DVTP0_i*T2_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+DVTP0_i*(+0.0+T2_Vsi_bi_Vgm_si)));
  T3_Vsi_bi_Vgm_di=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+DVTP0_i*(+0.0+T2_Vsi_bi_Vgm_di)));
  T3_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+DVTP0_i*(+0.0+T2_Vsi_bi_Vdbulk_di)));
  T3_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+DVTP0_i*(+0.0+T2_Vsi_bi_Vsbulk_si)));
  T3_Vsi_bi_Vgi_bi=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+DVTP0_i*(+0.0+T2_Vsi_bi_Vgi_bi)));
  T3_Vsi_bi_Vdi_bi=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+DVTP0_i*(+0.0+T2_Vsi_bi_Vdi_bi)));
  T3_Vsi_bi_Vsi_bi=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+DVTP0_i*(+0.0+T2_Vsi_bi_Vsi_bi)));
  T3_Vsi_bi_Tempt_GND=(+0.0+(+0.0*(1.0+T2)+0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+DVTP0_i*(+0.0+T2_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(DVTP0_i*T2_Tempt_GND);
#endif
#endif
T3=(Leff+(DVTP0_i*(1.0+T2)));
EXIT_IF_ISNAN((Leff+(DVTP0_i*(1.0+T2))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
dVth_ldop_Vdi_bi=(((-nVt_Vdi_bi)*bsimbulk_lln((Leff/T3)))+((-nVt)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vdi_bi/T3/T3))));
#if defined(_DERIVATE2)
  dVth_ldop_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln((Leff/T3))+(-nVt_Vdi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vdi_bi/T3/T3))+(-nVt_Vdi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vdi_bi/T3/T3))+(-nVt)*(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+Leff*T3_Vdi_bi_Vdi_bi)/T3/T3+2*Leff*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3));
  dVth_ldop_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln((Leff/T3))+(-nVt_Vdi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vdi_bi/T3/T3))+(-nVt_Vsi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vdi_bi/T3/T3))+(-nVt)*(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+Leff*T3_Vdi_bi_Vsi_bi)/T3/T3+2*Leff*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3));
  dVth_ldop_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln((Leff/T3))+(-nVt_Vdi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vdi_bi/T3/T3))+(-nVt_Tempt_GND)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vdi_bi/T3/T3))+(-nVt)*(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+Leff*T3_Vdi_bi_Tempt_GND)/T3/T3+2*Leff*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3));
#endif
dVth_ldop_Vsi_bi=(((-nVt_Vsi_bi)*bsimbulk_lln((Leff/T3)))+((-nVt)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vsi_bi/T3/T3))));
#if defined(_DERIVATE2)
  dVth_ldop_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln((Leff/T3))+(-nVt_Vsi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vsi_bi/T3/T3))+(-nVt_Vdi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vsi_bi/T3/T3))+(-nVt)*(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+Leff*T3_Vsi_bi_Vdi_bi)/T3/T3+2*Leff*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3));
  dVth_ldop_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln((Leff/T3))+(-nVt_Vsi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vsi_bi/T3/T3))+(-nVt_Vsi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vsi_bi/T3/T3))+(-nVt)*(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+Leff*T3_Vsi_bi_Vsi_bi)/T3/T3+2*Leff*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3));
  dVth_ldop_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln((Leff/T3))+(-nVt_Vsi_bi)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vsi_bi/T3/T3))+(-nVt_Tempt_GND)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Vsi_bi/T3/T3))+(-nVt)*(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+Leff*T3_Vsi_bi_Tempt_GND)/T3/T3+2*Leff*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3));
#endif
#if defined(_DERIVATE)
dVth_ldop_Tempt_GND=(((-nVt_Tempt_GND)*bsimbulk_lln((Leff/T3)))+((-nVt)*bsimbulk_d_lln((Leff/T3),(-Leff*T3_Tempt_GND/T3/T3))));
#endif
#endif
dVth_ldop=((-nVt)*bsimbulk_lln((Leff/T3)));
EXIT_IF_ISNAN(((-nVt)*bsimbulk_lln((Leff/T3))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
dVth_ldop_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  dVth_ldop_Vdi_bi_Vdi_bi=0.0;
  dVth_ldop_Vdi_bi_Vsi_bi=0.0;
  dVth_ldop_Vdi_bi_Tempt_GND=0.0;
#endif
dVth_ldop_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  dVth_ldop_Vsi_bi_Vdi_bi=0.0;
  dVth_ldop_Vsi_bi_Vsi_bi=0.0;
  dVth_ldop_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
dVth_ldop_Tempt_GND=0.0;
#endif
#endif
dVth_ldop=0.0;
EXIT_IF_ISNAN(0.0)
}
{
double m00_pow(d00_pow0,Leff,DVTP3_i)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=0.0;
#endif
#endif
T4=(DVTP5_i+(DVTP2_i/d00_pow0));
EXIT_IF_ISNAN((DVTP5_i+(DVTP2_i/d00_pow0)))
}
{
double m00_tanh(d00_tanh0,(DVTP4_i*Vdsx))
#if defined(_DERIVATEFORDDX)
double m10_tanh(d10_tanh0,d00_tanh0,(DVTP4_i*Vdsx))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
dVth_ldop_Vdi_bi=(dVth_ldop_Vdi_bi-((T4_Vdi_bi*d00_tanh0)+(T4*(DVTP4_i*Vdsx_Vdi_bi)*d10_tanh0)));
#if defined(_DERIVATE2)
  dVth_ldop_Vdi_bi_Vdi_bi=(+dVth_ldop_Vdi_bi_Vdi_bi-(+T4_Vdi_bi_Vdi_bi*d00_tanh0+T4_Vdi_bi*((DVTP4_i*Vdsx_Vdi_bi))*d10_tanh0+T4_Vdi_bi*(DVTP4_i*Vdsx_Vdi_bi)*d10_tanh0+T4*(m20_tanh((DVTP4_i*Vdsx))*((DVTP4_i*Vdsx_Vdi_bi))*(DVTP4_i*Vdsx_Vdi_bi)+d10_tanh0*(+0.0*Vdsx+0.0*Vdsx_Vdi_bi+0.0*Vdsx_Vdi_bi+DVTP4_i*Vdsx_Vdi_bi_Vdi_bi))));
  dVth_ldop_Vdi_bi_Vsi_bi=(+dVth_ldop_Vdi_bi_Vsi_bi-(+T4_Vdi_bi_Vsi_bi*d00_tanh0+T4_Vdi_bi*((DVTP4_i*Vdsx_Vsi_bi))*d10_tanh0+T4_Vsi_bi*(DVTP4_i*Vdsx_Vdi_bi)*d10_tanh0+T4*(m20_tanh((DVTP4_i*Vdsx))*((DVTP4_i*Vdsx_Vsi_bi))*(DVTP4_i*Vdsx_Vdi_bi)+d10_tanh0*(+0.0*Vdsx+0.0*Vdsx_Vsi_bi+0.0*Vdsx_Vdi_bi+DVTP4_i*Vdsx_Vdi_bi_Vsi_bi))));
  dVth_ldop_Vdi_bi_Tempt_GND=(+dVth_ldop_Vdi_bi_Tempt_GND-(+T4_Vdi_bi_Tempt_GND*d00_tanh0+T4_Vdi_bi*((DVTP4_i*Vdsx_Tempt_GND))*d10_tanh0+T4_Tempt_GND*(DVTP4_i*Vdsx_Vdi_bi)*d10_tanh0+T4*(m20_tanh((DVTP4_i*Vdsx))*((DVTP4_i*Vdsx_Tempt_GND))*(DVTP4_i*Vdsx_Vdi_bi)+d10_tanh0*(+0.0*Vdsx+0.0*Vdsx_Tempt_GND+0.0*Vdsx_Vdi_bi+DVTP4_i*Vdsx_Vdi_bi_Tempt_GND))));
#endif
dVth_ldop_Vsi_bi=(dVth_ldop_Vsi_bi-((T4_Vsi_bi*d00_tanh0)+(T4*(DVTP4_i*Vdsx_Vsi_bi)*d10_tanh0)));
#if defined(_DERIVATE2)
  dVth_ldop_Vsi_bi_Vdi_bi=(+dVth_ldop_Vsi_bi_Vdi_bi-(+T4_Vsi_bi_Vdi_bi*d00_tanh0+T4_Vsi_bi*((DVTP4_i*Vdsx_Vdi_bi))*d10_tanh0+T4_Vdi_bi*(DVTP4_i*Vdsx_Vsi_bi)*d10_tanh0+T4*(m20_tanh((DVTP4_i*Vdsx))*((DVTP4_i*Vdsx_Vdi_bi))*(DVTP4_i*Vdsx_Vsi_bi)+d10_tanh0*(+0.0*Vdsx+0.0*Vdsx_Vdi_bi+0.0*Vdsx_Vsi_bi+DVTP4_i*Vdsx_Vsi_bi_Vdi_bi))));
  dVth_ldop_Vsi_bi_Vsi_bi=(+dVth_ldop_Vsi_bi_Vsi_bi-(+T4_Vsi_bi_Vsi_bi*d00_tanh0+T4_Vsi_bi*((DVTP4_i*Vdsx_Vsi_bi))*d10_tanh0+T4_Vsi_bi*(DVTP4_i*Vdsx_Vsi_bi)*d10_tanh0+T4*(m20_tanh((DVTP4_i*Vdsx))*((DVTP4_i*Vdsx_Vsi_bi))*(DVTP4_i*Vdsx_Vsi_bi)+d10_tanh0*(+0.0*Vdsx+0.0*Vdsx_Vsi_bi+0.0*Vdsx_Vsi_bi+DVTP4_i*Vdsx_Vsi_bi_Vsi_bi))));
  dVth_ldop_Vsi_bi_Tempt_GND=(+dVth_ldop_Vsi_bi_Tempt_GND-(+T4_Vsi_bi_Tempt_GND*d00_tanh0+T4_Vsi_bi*((DVTP4_i*Vdsx_Tempt_GND))*d10_tanh0+T4_Tempt_GND*(DVTP4_i*Vdsx_Vsi_bi)*d10_tanh0+T4*(m20_tanh((DVTP4_i*Vdsx))*((DVTP4_i*Vdsx_Tempt_GND))*(DVTP4_i*Vdsx_Vsi_bi)+d10_tanh0*(+0.0*Vdsx+0.0*Vdsx_Tempt_GND+0.0*Vdsx_Vsi_bi+DVTP4_i*Vdsx_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
dVth_ldop_Tempt_GND=(dVth_ldop_Tempt_GND-((T4_Tempt_GND*d00_tanh0)+(T4*(DVTP4_i*Vdsx_Tempt_GND)*d10_tanh0)));
#endif
#endif
dVth_ldop=(dVth_ldop-(T4*d00_tanh0));
EXIT_IF_ISNAN((dVth_ldop-(T4*d00_tanh0)))
}
VFB_i=(VFB_i+pInst->DELVTO);
EXIT_IF_ISNAN((VFB_i+pInst->DELVTO))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vg_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vg_Vgm_si_Vgm_si=0.0;
  vg_Vgm_si_Vdbulk_di=0.0;
  vg_Vgm_si_Vsbulk_si=0.0;
  vg_Vgm_si_Vgi_bi=0.0;
  vg_Vgm_si_Vdi_bi=0.0;
  vg_Vgm_si_Vsi_bi=0.0;
  vg_Vgm_si_Tempt_GND=0.0;
#endif
vg_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  vg_Vdbulk_di_Vgm_si=0.0;
  vg_Vdbulk_di_Vdbulk_di=0.0;
  vg_Vdbulk_di_Vsbulk_si=0.0;
  vg_Vdbulk_di_Vgi_bi=0.0;
  vg_Vdbulk_di_Vdi_bi=0.0;
  vg_Vdbulk_di_Vsi_bi=0.0;
  vg_Vdbulk_di_Tempt_GND=0.0;
#endif
vg_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  vg_Vsbulk_si_Vgm_si=0.0;
  vg_Vsbulk_si_Vdbulk_di=0.0;
  vg_Vsbulk_si_Vsbulk_si=0.0;
  vg_Vsbulk_si_Vgi_bi=0.0;
  vg_Vsbulk_si_Vdi_bi=0.0;
  vg_Vsbulk_si_Vsi_bi=0.0;
  vg_Vsbulk_si_Tempt_GND=0.0;
#endif
vg_Vgi_bi=((Vg_Vgi_bi*inv_nVt)+(Vg*inv_nVt_Vgi_bi));
#if defined(_DERIVATE2)
  vg_Vgi_bi_Vgm_si=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vgm_si+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vgm_si);
  vg_Vgi_bi_Vdbulk_di=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vdbulk_di);
  vg_Vgi_bi_Vsbulk_si=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vsbulk_si);
  vg_Vgi_bi_Vgi_bi=(+Vg_Vgi_bi_Vgi_bi*inv_nVt+Vg_Vgi_bi*inv_nVt_Vgi_bi+Vg_Vgi_bi*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vgi_bi);
  vg_Vgi_bi_Vdi_bi=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vdi_bi+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vdi_bi);
  vg_Vgi_bi_Vsi_bi=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vsi_bi+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vsi_bi);
  vg_Vgi_bi_Tempt_GND=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Tempt_GND+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Tempt_GND);
#endif
vg_Vdi_bi=(Vg*inv_nVt_Vdi_bi);
#if defined(_DERIVATE2)
  vg_Vdi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vgm_si);
  vg_Vdi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vdbulk_di);
  vg_Vdi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vsbulk_si);
  vg_Vdi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+Vg_Vgi_bi*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vgi_bi);
  vg_Vdi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vdi_bi);
  vg_Vdi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vsi_bi);
  vg_Vdi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Tempt_GND);
#endif
vg_Vsi_bi=(Vg*inv_nVt_Vsi_bi);
#if defined(_DERIVATE2)
  vg_Vsi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vgm_si);
  vg_Vsi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vdbulk_di);
  vg_Vsi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vsbulk_si);
  vg_Vsi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+Vg_Vgi_bi*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vgi_bi);
  vg_Vsi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vdi_bi);
  vg_Vsi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vsi_bi);
  vg_Vsi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
vg_Tempt_GND=(Vg*inv_nVt_Tempt_GND);
#endif
#endif
vg=(Vg*inv_nVt);
EXIT_IF_ISNAN((Vg*inv_nVt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
vs_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vs_Vgm_si_Vgm_si=0.0;
  vs_Vgm_si_Vdbulk_di=0.0;
  vs_Vgm_si_Vsbulk_si=0.0;
  vs_Vgm_si_Vgi_bi=0.0;
  vs_Vgm_si_Vdi_bi=0.0;
  vs_Vgm_si_Vsi_bi=0.0;
  vs_Vgm_si_Tempt_GND=0.0;
#endif
vs_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  vs_Vdbulk_di_Vgm_si=0.0;
  vs_Vdbulk_di_Vdbulk_di=0.0;
  vs_Vdbulk_di_Vsbulk_si=0.0;
  vs_Vdbulk_di_Vgi_bi=0.0;
  vs_Vdbulk_di_Vdi_bi=0.0;
  vs_Vdbulk_di_Vsi_bi=0.0;
  vs_Vdbulk_di_Tempt_GND=0.0;
#endif
vs_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  vs_Vsbulk_si_Vgm_si=0.0;
  vs_Vsbulk_si_Vdbulk_di=0.0;
  vs_Vsbulk_si_Vsbulk_si=0.0;
  vs_Vsbulk_si_Vgi_bi=0.0;
  vs_Vsbulk_si_Vdi_bi=0.0;
  vs_Vsbulk_si_Vsi_bi=0.0;
  vs_Vsbulk_si_Tempt_GND=0.0;
#endif
vs_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  vs_Vgi_bi_Vgm_si=0.0;
  vs_Vgi_bi_Vdbulk_di=0.0;
  vs_Vgi_bi_Vsbulk_si=0.0;
  vs_Vgi_bi_Vgi_bi=0.0;
  vs_Vgi_bi_Vdi_bi=0.0;
  vs_Vgi_bi_Vsi_bi=0.0;
  vs_Vgi_bi_Tempt_GND=0.0;
#endif
vs_Vdi_bi=((Vs_Vdi_bi*inv_nVt)+(Vs*inv_nVt_Vdi_bi));
#if defined(_DERIVATE2)
  vs_Vdi_bi_Vgm_si=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Vgm_si+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vgm_si);
  vs_Vdi_bi_Vdbulk_di=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vdbulk_di);
  vs_Vdi_bi_Vsbulk_si=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vsbulk_si);
  vs_Vdi_bi_Vgi_bi=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Vgi_bi+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vgi_bi);
  vs_Vdi_bi_Vdi_bi=(+Vs_Vdi_bi_Vdi_bi*inv_nVt+Vs_Vdi_bi*inv_nVt_Vdi_bi+Vs_Vdi_bi*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vdi_bi);
  vs_Vdi_bi_Vsi_bi=(+Vs_Vdi_bi_Vsi_bi*inv_nVt+Vs_Vdi_bi*inv_nVt_Vsi_bi+Vs_Vsi_bi*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vsi_bi);
  vs_Vdi_bi_Tempt_GND=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Tempt_GND+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Tempt_GND);
#endif
vs_Vsi_bi=((Vs_Vsi_bi*inv_nVt)+(Vs*inv_nVt_Vsi_bi));
#if defined(_DERIVATE2)
  vs_Vsi_bi_Vgm_si=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Vgm_si+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vgm_si);
  vs_Vsi_bi_Vdbulk_di=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vdbulk_di);
  vs_Vsi_bi_Vsbulk_si=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vsbulk_si);
  vs_Vsi_bi_Vgi_bi=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Vgi_bi+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vgi_bi);
  vs_Vsi_bi_Vdi_bi=(+Vs_Vsi_bi_Vdi_bi*inv_nVt+Vs_Vsi_bi*inv_nVt_Vdi_bi+Vs_Vdi_bi*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vdi_bi);
  vs_Vsi_bi_Vsi_bi=(+Vs_Vsi_bi_Vsi_bi*inv_nVt+Vs_Vsi_bi*inv_nVt_Vsi_bi+Vs_Vsi_bi*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vsi_bi);
  vs_Vsi_bi_Tempt_GND=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Tempt_GND+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
vs_Tempt_GND=(Vs*inv_nVt_Tempt_GND);
#endif
#endif
vs=(Vs*inv_nVt);
EXIT_IF_ISNAN((Vs*inv_nVt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vfb_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vfb_Vgm_si_Vgm_si=0.0;
  vfb_Vgm_si_Vdbulk_di=0.0;
  vfb_Vgm_si_Vsbulk_si=0.0;
  vfb_Vgm_si_Vgi_bi=0.0;
  vfb_Vgm_si_Vdi_bi=0.0;
  vfb_Vgm_si_Vsi_bi=0.0;
  vfb_Vgm_si_Tempt_GND=0.0;
#endif
vfb_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  vfb_Vdbulk_di_Vgm_si=0.0;
  vfb_Vdbulk_di_Vdbulk_di=0.0;
  vfb_Vdbulk_di_Vsbulk_si=0.0;
  vfb_Vdbulk_di_Vgi_bi=0.0;
  vfb_Vdbulk_di_Vdi_bi=0.0;
  vfb_Vdbulk_di_Vsi_bi=0.0;
  vfb_Vdbulk_di_Tempt_GND=0.0;
#endif
vfb_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  vfb_Vsbulk_si_Vgm_si=0.0;
  vfb_Vsbulk_si_Vdbulk_di=0.0;
  vfb_Vsbulk_si_Vsbulk_si=0.0;
  vfb_Vsbulk_si_Vgi_bi=0.0;
  vfb_Vsbulk_si_Vdi_bi=0.0;
  vfb_Vsbulk_si_Vsi_bi=0.0;
  vfb_Vsbulk_si_Tempt_GND=0.0;
#endif
vfb_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  vfb_Vgi_bi_Vgm_si=0.0;
  vfb_Vgi_bi_Vdbulk_di=0.0;
  vfb_Vgi_bi_Vsbulk_si=0.0;
  vfb_Vgi_bi_Vgi_bi=0.0;
  vfb_Vgi_bi_Vdi_bi=0.0;
  vfb_Vgi_bi_Vsi_bi=0.0;
  vfb_Vgi_bi_Tempt_GND=0.0;
#endif
vfb_Vdi_bi=(VFB_i*inv_nVt_Vdi_bi);
#if defined(_DERIVATE2)
  vfb_Vdi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vgm_si);
  vfb_Vdi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vdbulk_di);
  vfb_Vdi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vsbulk_si);
  vfb_Vdi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vgi_bi);
  vfb_Vdi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vdi_bi);
  vfb_Vdi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vsi_bi);
  vfb_Vdi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Tempt_GND);
#endif
vfb_Vsi_bi=(VFB_i*inv_nVt_Vsi_bi);
#if defined(_DERIVATE2)
  vfb_Vsi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vgm_si);
  vfb_Vsi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vdbulk_di);
  vfb_Vsi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vsbulk_si);
  vfb_Vsi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vgi_bi);
  vfb_Vsi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vdi_bi);
  vfb_Vsi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vsi_bi);
  vfb_Vsi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
vfb_Tempt_GND=(VFB_i*inv_nVt_Tempt_GND);
#endif
#endif
vfb=(VFB_i*inv_nVt);
EXIT_IF_ISNAN((VFB_i*inv_nVt))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
dVth_VNUD_Tempt_GND=((K1_i*(sqrtPhistVbs_Tempt_GND-sqrtPhist_Tempt_GND))-((K2_i_Tempt_GND*Vbsx)+(K2_i*Vbsx_Tempt_GND)));
#endif
dVth_VNUD_Vdi_bi=((K1_i*sqrtPhistVbs_Vdi_bi)-(K2_i*Vbsx_Vdi_bi));
#if defined(_DERIVATE2)
  dVth_VNUD_Vdi_bi_Tempt_GND=(+(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*(sqrtPhistVbs_Tempt_GND-sqrtPhist_Tempt_GND)+0.0*sqrtPhistVbs_Vdi_bi+K1_i*(+sqrtPhistVbs_Vdi_bi_Tempt_GND-0.0))-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+K2_i_Tempt_GND*Vbsx_Vdi_bi+K2_i*Vbsx_Vdi_bi_Tempt_GND));
  dVth_VNUD_Vdi_bi_Vdi_bi=(+(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vdi_bi+0.0*sqrtPhistVbs_Vdi_bi+K1_i*(+sqrtPhistVbs_Vdi_bi_Vdi_bi-0.0))-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+K2_i*Vbsx_Vdi_bi_Vdi_bi));
  dVth_VNUD_Vdi_bi_Vsi_bi=(+(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vsi_bi+0.0*sqrtPhistVbs_Vdi_bi+K1_i*(+sqrtPhistVbs_Vdi_bi_Vsi_bi-0.0))-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+K2_i*Vbsx_Vdi_bi_Vsi_bi));
#endif
dVth_VNUD_Vsi_bi=((K1_i*sqrtPhistVbs_Vsi_bi)-(K2_i*Vbsx_Vsi_bi));
#if defined(_DERIVATE2)
  dVth_VNUD_Vsi_bi_Tempt_GND=(+(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*(sqrtPhistVbs_Tempt_GND-sqrtPhist_Tempt_GND)+0.0*sqrtPhistVbs_Vsi_bi+K1_i*(+sqrtPhistVbs_Vsi_bi_Tempt_GND-0.0))-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+K2_i_Tempt_GND*Vbsx_Vsi_bi+K2_i*Vbsx_Vsi_bi_Tempt_GND));
  dVth_VNUD_Vsi_bi_Vdi_bi=(+(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vdi_bi+0.0*sqrtPhistVbs_Vsi_bi+K1_i*(+sqrtPhistVbs_Vsi_bi_Vdi_bi-0.0))-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+K2_i*Vbsx_Vsi_bi_Vdi_bi));
  dVth_VNUD_Vsi_bi_Vsi_bi=(+(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vsi_bi+0.0*sqrtPhistVbs_Vsi_bi+K1_i*(+sqrtPhistVbs_Vsi_bi_Vsi_bi-0.0))-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+K2_i*Vbsx_Vsi_bi_Vsi_bi));
#endif
#endif
dVth_VNUD=((K1_i*(sqrtPhistVbs-sqrtPhist))-(K2_i*Vbsx));
EXIT_IF_ISNAN(((K1_i*(sqrtPhistVbs-sqrtPhist))-(K2_i*Vbsx)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Vth_shift_Vgm_di=0.0;
#if defined(_DERIVATE2)
  Vth_shift_Vgm_di_Vgm_di=0.0;
  Vth_shift_Vgm_di_Vgm_si=0.0;
  Vth_shift_Vgm_di_Vdbulk_di=0.0;
  Vth_shift_Vgm_di_Vsbulk_si=0.0;
  Vth_shift_Vgm_di_Vgi_bi=0.0;
  Vth_shift_Vgm_di_Tempt_GND=0.0;
  Vth_shift_Vgm_di_Vdi_bi=0.0;
  Vth_shift_Vgm_di_Vsi_bi=0.0;
#endif
Vth_shift_Vgm_si=0.0;
#if defined(_DERIVATE2)
  Vth_shift_Vgm_si_Vgm_di=0.0;
  Vth_shift_Vgm_si_Vgm_si=0.0;
  Vth_shift_Vgm_si_Vdbulk_di=0.0;
  Vth_shift_Vgm_si_Vsbulk_si=0.0;
  Vth_shift_Vgm_si_Vgi_bi=0.0;
  Vth_shift_Vgm_si_Tempt_GND=0.0;
  Vth_shift_Vgm_si_Vdi_bi=0.0;
  Vth_shift_Vgm_si_Vsi_bi=0.0;
#endif
Vth_shift_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Vth_shift_Vdbulk_di_Vgm_di=0.0;
  Vth_shift_Vdbulk_di_Vgm_si=0.0;
  Vth_shift_Vdbulk_di_Vdbulk_di=0.0;
  Vth_shift_Vdbulk_di_Vsbulk_si=0.0;
  Vth_shift_Vdbulk_di_Vgi_bi=0.0;
  Vth_shift_Vdbulk_di_Tempt_GND=0.0;
  Vth_shift_Vdbulk_di_Vdi_bi=0.0;
  Vth_shift_Vdbulk_di_Vsi_bi=0.0;
#endif
Vth_shift_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Vth_shift_Vsbulk_si_Vgm_di=0.0;
  Vth_shift_Vsbulk_si_Vgm_si=0.0;
  Vth_shift_Vsbulk_si_Vdbulk_di=0.0;
  Vth_shift_Vsbulk_si_Vsbulk_si=0.0;
  Vth_shift_Vsbulk_si_Vgi_bi=0.0;
  Vth_shift_Vsbulk_si_Tempt_GND=0.0;
  Vth_shift_Vsbulk_si_Vdi_bi=0.0;
  Vth_shift_Vsbulk_si_Vsi_bi=0.0;
#endif
Vth_shift_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Vth_shift_Vgi_bi_Vgm_di=0.0;
  Vth_shift_Vgi_bi_Vgm_si=0.0;
  Vth_shift_Vgi_bi_Vdbulk_di=0.0;
  Vth_shift_Vgi_bi_Vsbulk_si=0.0;
  Vth_shift_Vgi_bi_Vgi_bi=0.0;
  Vth_shift_Vgi_bi_Tempt_GND=0.0;
  Vth_shift_Vgi_bi_Vdi_bi=0.0;
  Vth_shift_Vgi_bi_Vsi_bi=0.0;
#endif
#if defined(_DERIVATE)
Vth_shift_Tempt_GND=(((((dVth_dibl_Tempt_GND+dVth_ldop_Tempt_GND)+dVth_VNUD_Tempt_GND)-dvth_temp_Tempt_GND)+vth0_stress_Tempt_GND)+vth0_well_Tempt_GND);
#endif
Vth_shift_Vdi_bi=(((dVth_dibl_Vdi_bi+dVth_ldop_Vdi_bi)+dVth_VNUD_Vdi_bi)-dvth_temp_Vdi_bi);
#if defined(_DERIVATE2)
  Vth_shift_Vdi_bi_Vgm_di=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vdi_bi_Vgm_si=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vdi_bi_Vdbulk_di=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vdi_bi_Vsbulk_si=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vdi_bi_Tempt_GND=(+(+(+(+(+dVth_dibl_Vdi_bi_Tempt_GND+dVth_ldop_Vdi_bi_Tempt_GND)+dVth_VNUD_Vdi_bi_Tempt_GND)-dvth_temp_Vdi_bi_Tempt_GND)+0.0)+0.0);
  Vth_shift_Vdi_bi_Vdi_bi=(+(+(+(+(+dVth_dibl_Vdi_bi_Vdi_bi+dVth_ldop_Vdi_bi_Vdi_bi)+dVth_VNUD_Vdi_bi_Vdi_bi)-dvth_temp_Vdi_bi_Vdi_bi)+0.0)+0.0);
  Vth_shift_Vdi_bi_Vsi_bi=(+(+(+(+(+dVth_dibl_Vdi_bi_Vsi_bi+dVth_ldop_Vdi_bi_Vsi_bi)+dVth_VNUD_Vdi_bi_Vsi_bi)-dvth_temp_Vdi_bi_Vsi_bi)+0.0)+0.0);
#endif
Vth_shift_Vsi_bi=(((dVth_dibl_Vsi_bi+dVth_ldop_Vsi_bi)+dVth_VNUD_Vsi_bi)-dvth_temp_Vsi_bi);
#if defined(_DERIVATE2)
  Vth_shift_Vsi_bi_Vgm_di=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vsi_bi_Vgm_si=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vsi_bi_Vdbulk_di=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vsi_bi_Vsbulk_si=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0+0.0)+0.0)-0.0)+0.0)+0.0);
  Vth_shift_Vsi_bi_Tempt_GND=(+(+(+(+(+dVth_dibl_Vsi_bi_Tempt_GND+dVth_ldop_Vsi_bi_Tempt_GND)+dVth_VNUD_Vsi_bi_Tempt_GND)-dvth_temp_Vsi_bi_Tempt_GND)+0.0)+0.0);
  Vth_shift_Vsi_bi_Vdi_bi=(+(+(+(+(+dVth_dibl_Vsi_bi_Vdi_bi+dVth_ldop_Vsi_bi_Vdi_bi)+dVth_VNUD_Vsi_bi_Vdi_bi)-dvth_temp_Vsi_bi_Vdi_bi)+0.0)+0.0);
  Vth_shift_Vsi_bi_Vsi_bi=(+(+(+(+(+dVth_dibl_Vsi_bi_Vsi_bi+dVth_ldop_Vsi_bi_Vsi_bi)+dVth_VNUD_Vsi_bi_Vsi_bi)-dvth_temp_Vsi_bi_Vsi_bi)+0.0)+0.0);
#endif
#endif
Vth_shift=(((((dVth_dibl+dVth_ldop)+dVth_VNUD)-dvth_temp)+vth0_stress)+vth0_well);
EXIT_IF_ISNAN((((((dVth_dibl+dVth_ldop)+dVth_VNUD)-dvth_temp)+vth0_stress)+vth0_well))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gm,di)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
vgfb_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vgfb_Vgm_si_Vgm_si=0.0;
  vgfb_Vgm_si_Vdbulk_di=0.0;
  vgfb_Vgm_si_Vsbulk_si=0.0;
  vgfb_Vgm_si_Vgm_di=0.0;
  vgfb_Vgm_si_Vgi_bi=0.0;
  vgfb_Vgm_si_Vdi_bi=0.0;
  vgfb_Vgm_si_Vsi_bi=0.0;
  vgfb_Vgm_si_Tempt_GND=0.0;
#endif
vgfb_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  vgfb_Vdbulk_di_Vgm_si=0.0;
  vgfb_Vdbulk_di_Vdbulk_di=0.0;
  vgfb_Vdbulk_di_Vsbulk_si=0.0;
  vgfb_Vdbulk_di_Vgm_di=0.0;
  vgfb_Vdbulk_di_Vgi_bi=0.0;
  vgfb_Vdbulk_di_Vdi_bi=0.0;
  vgfb_Vdbulk_di_Vsi_bi=0.0;
  vgfb_Vdbulk_di_Tempt_GND=0.0;
#endif
vgfb_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  vgfb_Vsbulk_si_Vgm_si=0.0;
  vgfb_Vsbulk_si_Vdbulk_di=0.0;
  vgfb_Vsbulk_si_Vsbulk_si=0.0;
  vgfb_Vsbulk_si_Vgm_di=0.0;
  vgfb_Vsbulk_si_Vgi_bi=0.0;
  vgfb_Vsbulk_si_Vdi_bi=0.0;
  vgfb_Vsbulk_si_Vsi_bi=0.0;
  vgfb_Vsbulk_si_Tempt_GND=0.0;
#endif
vgfb_Vgm_di=0.0;
#if defined(_DERIVATE2)
  vgfb_Vgm_di_Vgm_si=0.0;
  vgfb_Vgm_di_Vdbulk_di=0.0;
  vgfb_Vgm_di_Vsbulk_si=0.0;
  vgfb_Vgm_di_Vgm_di=0.0;
  vgfb_Vgm_di_Vgi_bi=0.0;
  vgfb_Vgm_di_Vdi_bi=0.0;
  vgfb_Vgm_di_Vsi_bi=0.0;
  vgfb_Vgm_di_Tempt_GND=0.0;
#endif
vgfb_Vgi_bi=((vg_Vgi_bi-vfb_Vgi_bi)-((Vth_shift_Vgi_bi*inv_nVt)+(Vth_shift*inv_nVt_Vgi_bi)));
#if defined(_DERIVATE2)
  vgfb_Vgi_bi_Vgm_si=(+(+vg_Vgi_bi_Vgm_si-vfb_Vgi_bi_Vgm_si)-(+Vth_shift_Vgi_bi_Vgm_si*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vgm_si+Vth_shift_Vgm_si*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vgm_si));
  vgfb_Vgi_bi_Vdbulk_di=(+(+vg_Vgi_bi_Vdbulk_di-vfb_Vgi_bi_Vdbulk_di)-(+Vth_shift_Vgi_bi_Vdbulk_di*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vdbulk_di));
  vgfb_Vgi_bi_Vsbulk_si=(+(+vg_Vgi_bi_Vsbulk_si-vfb_Vgi_bi_Vsbulk_si)-(+Vth_shift_Vgi_bi_Vsbulk_si*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vsbulk_si));
  vgfb_Vgi_bi_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vgi_bi_Vgm_di*inv_nVt+Vth_shift_Vgi_bi*0.0+Vth_shift_Vgm_di*inv_nVt_Vgi_bi+Vth_shift*0.0));
  vgfb_Vgi_bi_Vgi_bi=(+(+vg_Vgi_bi_Vgi_bi-vfb_Vgi_bi_Vgi_bi)-(+Vth_shift_Vgi_bi_Vgi_bi*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vgi_bi));
  vgfb_Vgi_bi_Vdi_bi=(+(+vg_Vgi_bi_Vdi_bi-vfb_Vgi_bi_Vdi_bi)-(+Vth_shift_Vgi_bi_Vdi_bi*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vdi_bi));
  vgfb_Vgi_bi_Vsi_bi=(+(+vg_Vgi_bi_Vsi_bi-vfb_Vgi_bi_Vsi_bi)-(+Vth_shift_Vgi_bi_Vsi_bi*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vsi_bi));
  vgfb_Vgi_bi_Tempt_GND=(+(+vg_Vgi_bi_Tempt_GND-vfb_Vgi_bi_Tempt_GND)-(+Vth_shift_Vgi_bi_Tempt_GND*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Tempt_GND));
#endif
vgfb_Vdi_bi=((vg_Vdi_bi-vfb_Vdi_bi)-((Vth_shift_Vdi_bi*inv_nVt)+(Vth_shift*inv_nVt_Vdi_bi)));
#if defined(_DERIVATE2)
  vgfb_Vdi_bi_Vgm_si=(+(+vg_Vdi_bi_Vgm_si-vfb_Vdi_bi_Vgm_si)-(+Vth_shift_Vdi_bi_Vgm_si*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vgm_si+Vth_shift_Vgm_si*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vgm_si));
  vgfb_Vdi_bi_Vdbulk_di=(+(+vg_Vdi_bi_Vdbulk_di-vfb_Vdi_bi_Vdbulk_di)-(+Vth_shift_Vdi_bi_Vdbulk_di*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vdbulk_di));
  vgfb_Vdi_bi_Vsbulk_si=(+(+vg_Vdi_bi_Vsbulk_si-vfb_Vdi_bi_Vsbulk_si)-(+Vth_shift_Vdi_bi_Vsbulk_si*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vsbulk_si));
  vgfb_Vdi_bi_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vdi_bi_Vgm_di*inv_nVt+Vth_shift_Vdi_bi*0.0+Vth_shift_Vgm_di*inv_nVt_Vdi_bi+Vth_shift*0.0));
  vgfb_Vdi_bi_Vgi_bi=(+(+vg_Vdi_bi_Vgi_bi-vfb_Vdi_bi_Vgi_bi)-(+Vth_shift_Vdi_bi_Vgi_bi*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vgi_bi));
  vgfb_Vdi_bi_Vdi_bi=(+(+vg_Vdi_bi_Vdi_bi-vfb_Vdi_bi_Vdi_bi)-(+Vth_shift_Vdi_bi_Vdi_bi*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vdi_bi));
  vgfb_Vdi_bi_Vsi_bi=(+(+vg_Vdi_bi_Vsi_bi-vfb_Vdi_bi_Vsi_bi)-(+Vth_shift_Vdi_bi_Vsi_bi*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vsi_bi));
  vgfb_Vdi_bi_Tempt_GND=(+(+vg_Vdi_bi_Tempt_GND-vfb_Vdi_bi_Tempt_GND)-(+Vth_shift_Vdi_bi_Tempt_GND*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Tempt_GND));
#endif
vgfb_Vsi_bi=((vg_Vsi_bi-vfb_Vsi_bi)-((Vth_shift_Vsi_bi*inv_nVt)+(Vth_shift*inv_nVt_Vsi_bi)));
#if defined(_DERIVATE2)
  vgfb_Vsi_bi_Vgm_si=(+(+vg_Vsi_bi_Vgm_si-vfb_Vsi_bi_Vgm_si)-(+Vth_shift_Vsi_bi_Vgm_si*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vgm_si+Vth_shift_Vgm_si*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vgm_si));
  vgfb_Vsi_bi_Vdbulk_di=(+(+vg_Vsi_bi_Vdbulk_di-vfb_Vsi_bi_Vdbulk_di)-(+Vth_shift_Vsi_bi_Vdbulk_di*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vdbulk_di));
  vgfb_Vsi_bi_Vsbulk_si=(+(+vg_Vsi_bi_Vsbulk_si-vfb_Vsi_bi_Vsbulk_si)-(+Vth_shift_Vsi_bi_Vsbulk_si*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vsbulk_si));
  vgfb_Vsi_bi_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vsi_bi_Vgm_di*inv_nVt+Vth_shift_Vsi_bi*0.0+Vth_shift_Vgm_di*inv_nVt_Vsi_bi+Vth_shift*0.0));
  vgfb_Vsi_bi_Vgi_bi=(+(+vg_Vsi_bi_Vgi_bi-vfb_Vsi_bi_Vgi_bi)-(+Vth_shift_Vsi_bi_Vgi_bi*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vgi_bi));
  vgfb_Vsi_bi_Vdi_bi=(+(+vg_Vsi_bi_Vdi_bi-vfb_Vsi_bi_Vdi_bi)-(+Vth_shift_Vsi_bi_Vdi_bi*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vdi_bi));
  vgfb_Vsi_bi_Vsi_bi=(+(+vg_Vsi_bi_Vsi_bi-vfb_Vsi_bi_Vsi_bi)-(+Vth_shift_Vsi_bi_Vsi_bi*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vsi_bi));
  vgfb_Vsi_bi_Tempt_GND=(+(+vg_Vsi_bi_Tempt_GND-vfb_Vsi_bi_Tempt_GND)-(+Vth_shift_Vsi_bi_Tempt_GND*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
vgfb_Tempt_GND=((vg_Tempt_GND-vfb_Tempt_GND)-((Vth_shift_Tempt_GND*inv_nVt)+(Vth_shift*inv_nVt_Tempt_GND)));
#endif
#endif
vgfb=((vg-vfb)-(Vth_shift*inv_nVt));
EXIT_IF_ISNAN(((vg-vfb)-(Vth_shift*inv_nVt)))
{
double m00_sqrt(d00_sqrt0,((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_Vt))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_Vt))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gam_Vgm_si=0.0;
#if defined(_DERIVATE2)
  gam_Vgm_si_Vgm_si=0.0;
  gam_Vgm_si_Vdbulk_di=0.0;
  gam_Vgm_si_Vsbulk_si=0.0;
  gam_Vgm_si_Vgi_bi=0.0;
  gam_Vgm_si_Vdi_bi=0.0;
  gam_Vgm_si_Vsi_bi=0.0;
  gam_Vgm_si_Tempt_GND=0.0;
#endif
gam_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  gam_Vdbulk_di_Vgm_si=0.0;
  gam_Vdbulk_di_Vdbulk_di=0.0;
  gam_Vdbulk_di_Vsbulk_si=0.0;
  gam_Vdbulk_di_Vgi_bi=0.0;
  gam_Vdbulk_di_Vdi_bi=0.0;
  gam_Vdbulk_di_Vsi_bi=0.0;
  gam_Vdbulk_di_Tempt_GND=0.0;
#endif
gam_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  gam_Vsbulk_si_Vgm_si=0.0;
  gam_Vsbulk_si_Vdbulk_di=0.0;
  gam_Vsbulk_si_Vsbulk_si=0.0;
  gam_Vsbulk_si_Vgi_bi=0.0;
  gam_Vsbulk_si_Vdi_bi=0.0;
  gam_Vsbulk_si_Vsi_bi=0.0;
  gam_Vsbulk_si_Tempt_GND=0.0;
#endif
gam_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  gam_Vgi_bi_Vgm_si=0.0;
  gam_Vgi_bi_Vdbulk_di=0.0;
  gam_Vgi_bi_Vsbulk_si=0.0;
  gam_Vgi_bi_Vgi_bi=0.0;
  gam_Vgi_bi_Vdi_bi=0.0;
  gam_Vgi_bi_Vsi_bi=0.0;
  gam_Vgi_bi_Tempt_GND=0.0;
#endif
gam_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  gam_Vdi_bi_Vgm_si=0.0;
  gam_Vdi_bi_Vdbulk_di=0.0;
  gam_Vdi_bi_Vsbulk_si=0.0;
  gam_Vdi_bi_Vgi_bi=0.0;
  gam_Vdi_bi_Vdi_bi=0.0;
  gam_Vdi_bi_Vsi_bi=0.0;
  gam_Vdi_bi_Tempt_GND=0.0;
#endif
gam_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  gam_Vsi_bi_Vgm_si=0.0;
  gam_Vsi_bi_Vdbulk_di=0.0;
  gam_Vsi_bi_Vsbulk_si=0.0;
  gam_Vsi_bi_Vgi_bi=0.0;
  gam_Vsi_bi_Vdi_bi=0.0;
  gam_Vsi_bi_Vsi_bi=0.0;
  gam_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
gam_Tempt_GND=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_Vt_Tempt_GND)*d10_sqrt0/Cox);
#endif
#endif
gam=(d00_sqrt0/Cox);
EXIT_IF_ISNAN((d00_sqrt0/Cox))
}
q_vth=0.5;
EXIT_IF_ISNAN(0.5)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=bsimbulk_d_hypsmooth(((2.0*phib)+(Vs*inv_Vt)),1.0e-3,Vs_Vdi_bi*inv_Vt,0.0);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=bsimbulk_d_hypsmooth(((2.0*phib)+(Vs*inv_Vt)),1.0e-3,Vs_Vsi_bi*inv_Vt,0.0);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=bsimbulk_d_hypsmooth(((2.0*phib)+(Vs*inv_Vt)),1.0e-3,((2.0*phib_Tempt_GND)+(Vs*inv_Vt_Tempt_GND)),0.0);
#endif
#endif
T0=bsimbulk_hypsmooth(((2.0*phib)+(Vs*inv_Vt)),1.0e-3);
EXIT_IF_ISNAN(bsimbulk_hypsmooth(((2.0*phib)+(Vs*inv_Vt)),1.0e-3))
{
double m00_sqrt(d00_sqrt0,T0)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
nq_Vgm_si=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_si_Vgm_si=0.0;
  nq_Vgm_si_Vgm_di=0.0;
  nq_Vgm_si_Vdbulk_di=0.0;
  nq_Vgm_si_Vsbulk_si=0.0;
  nq_Vgm_si_Vgi_bi=0.0;
  nq_Vgm_si_Tempt_GND=0.0;
  nq_Vgm_si_Vdi_bi=0.0;
  nq_Vgm_si_Vsi_bi=0.0;
#endif
nq_Vgm_di=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_di_Vgm_si=0.0;
  nq_Vgm_di_Vgm_di=0.0;
  nq_Vgm_di_Vdbulk_di=0.0;
  nq_Vgm_di_Vsbulk_si=0.0;
  nq_Vgm_di_Vgi_bi=0.0;
  nq_Vgm_di_Tempt_GND=0.0;
  nq_Vgm_di_Vdi_bi=0.0;
  nq_Vgm_di_Vsi_bi=0.0;
#endif
nq_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  nq_Vdbulk_di_Vgm_si=0.0;
  nq_Vdbulk_di_Vgm_di=0.0;
  nq_Vdbulk_di_Vdbulk_di=0.0;
  nq_Vdbulk_di_Vsbulk_si=0.0;
  nq_Vdbulk_di_Vgi_bi=0.0;
  nq_Vdbulk_di_Tempt_GND=0.0;
  nq_Vdbulk_di_Vdi_bi=0.0;
  nq_Vdbulk_di_Vsi_bi=0.0;
#endif
nq_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  nq_Vsbulk_si_Vgm_si=0.0;
  nq_Vsbulk_si_Vgm_di=0.0;
  nq_Vsbulk_si_Vdbulk_di=0.0;
  nq_Vsbulk_si_Vsbulk_si=0.0;
  nq_Vsbulk_si_Vgi_bi=0.0;
  nq_Vsbulk_si_Tempt_GND=0.0;
  nq_Vsbulk_si_Vdi_bi=0.0;
  nq_Vsbulk_si_Vsi_bi=0.0;
#endif
nq_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  nq_Vgi_bi_Vgm_si=0.0;
  nq_Vgi_bi_Vgm_di=0.0;
  nq_Vgi_bi_Vdbulk_di=0.0;
  nq_Vgi_bi_Vsbulk_si=0.0;
  nq_Vgi_bi_Vgi_bi=0.0;
  nq_Vgi_bi_Tempt_GND=0.0;
  nq_Vgi_bi_Vdi_bi=0.0;
  nq_Vgi_bi_Vsi_bi=0.0;
#endif
#if defined(_DERIVATE)
nq_Tempt_GND=((gam_Tempt_GND*(2.0*d00_sqrt0)-gam*(2.0*T0_Tempt_GND*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0));
#endif
nq_Vdi_bi=((gam_Vdi_bi*(2.0*d00_sqrt0)-gam*(2.0*T0_Vdi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(2.0*d00_sqrt0)-(gam_Vdi_bi*((2.0*T0_Vgm_si*d10_sqrt0))+gam_Vgm_si*(2.0*T0_Vdi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vgm_si*d10_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vgm_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_si)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vdi_bi*d10_sqrt0)*((2.0*T0_Vgm_si*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vdi_bi_Vgm_di=(+0.0+(0.0/(2.0*d00_sqrt0)-(gam_Vdi_bi*((2.0*T0_Vgm_di*d10_sqrt0))+0.0*(2.0*T0_Vdi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vgm_di*d10_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vgm_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_di)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vdi_bi*d10_sqrt0)*((2.0*T0_Vgm_di*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*d00_sqrt0)-(gam_Vdi_bi*((2.0*T0_Vdbulk_di*d10_sqrt0))+gam_Vdbulk_di*(2.0*T0_Vdi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vdbulk_di*d10_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdbulk_di)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vdi_bi*d10_sqrt0)*((2.0*T0_Vdbulk_di*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*d00_sqrt0)-(gam_Vdi_bi*((2.0*T0_Vsbulk_si*d10_sqrt0))+gam_Vsbulk_si*(2.0*T0_Vdi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vsbulk_si*d10_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsbulk_si)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vdi_bi*d10_sqrt0)*((2.0*T0_Vsbulk_si*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*d00_sqrt0)-(gam_Vdi_bi*((2.0*T0_Vgi_bi*d10_sqrt0))+gam_Vgi_bi*(2.0*T0_Vdi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vgi_bi*d10_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vgi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vdi_bi*d10_sqrt0)*((2.0*T0_Vgi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*d00_sqrt0)-(gam_Vdi_bi*((2.0*T0_Tempt_GND*d10_sqrt0))+gam_Tempt_GND*(2.0*T0_Vdi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Tempt_GND*d10_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Tempt_GND*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Tempt_GND)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vdi_bi*d10_sqrt0)*((2.0*T0_Tempt_GND*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*d00_sqrt0)-(gam_Vdi_bi*((2.0*T0_Vdi_bi*d10_sqrt0))+gam_Vdi_bi*(2.0*T0_Vdi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vdi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vdi_bi*d10_sqrt0)*((2.0*T0_Vdi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*d00_sqrt0)-(gam_Vdi_bi*((2.0*T0_Vsi_bi*d10_sqrt0))+gam_Vsi_bi*(2.0*T0_Vdi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vsi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vdi_bi*d10_sqrt0)*((2.0*T0_Vsi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
#endif
nq_Vsi_bi=((gam_Vsi_bi*(2.0*d00_sqrt0)-gam*(2.0*T0_Vsi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(2.0*d00_sqrt0)-(gam_Vsi_bi*((2.0*T0_Vgm_si*d10_sqrt0))+gam_Vgm_si*(2.0*T0_Vsi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vgm_si*d10_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vgm_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_si)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vsi_bi*d10_sqrt0)*((2.0*T0_Vgm_si*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vsi_bi_Vgm_di=(+0.0+(0.0/(2.0*d00_sqrt0)-(gam_Vsi_bi*((2.0*T0_Vgm_di*d10_sqrt0))+0.0*(2.0*T0_Vsi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vgm_di*d10_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vgm_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_di)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vsi_bi*d10_sqrt0)*((2.0*T0_Vgm_di*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*d00_sqrt0)-(gam_Vsi_bi*((2.0*T0_Vdbulk_di*d10_sqrt0))+gam_Vdbulk_di*(2.0*T0_Vsi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vdbulk_di*d10_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdbulk_di)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vsi_bi*d10_sqrt0)*((2.0*T0_Vdbulk_di*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*d00_sqrt0)-(gam_Vsi_bi*((2.0*T0_Vsbulk_si*d10_sqrt0))+gam_Vsbulk_si*(2.0*T0_Vsi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vsbulk_si*d10_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsbulk_si)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vsi_bi*d10_sqrt0)*((2.0*T0_Vsbulk_si*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*d00_sqrt0)-(gam_Vsi_bi*((2.0*T0_Vgi_bi*d10_sqrt0))+gam_Vgi_bi*(2.0*T0_Vsi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vgi_bi*d10_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vgi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vsi_bi*d10_sqrt0)*((2.0*T0_Vgi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*d00_sqrt0)-(gam_Vsi_bi*((2.0*T0_Tempt_GND*d10_sqrt0))+gam_Tempt_GND*(2.0*T0_Vsi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Tempt_GND*d10_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Tempt_GND*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Tempt_GND)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vsi_bi*d10_sqrt0)*((2.0*T0_Tempt_GND*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*d00_sqrt0)-(gam_Vsi_bi*((2.0*T0_Vdi_bi*d10_sqrt0))+gam_Vdi_bi*(2.0*T0_Vsi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vdi_bi*d10_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vdi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vsi_bi*d10_sqrt0)*((2.0*T0_Vdi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*d00_sqrt0)-(gam_Vsi_bi*((2.0*T0_Vsi_bi*d10_sqrt0))+gam_Vsi_bi*(2.0*T0_Vsi_bi*d10_sqrt0)+gam*(+0.0*d00_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+0.0*T0_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(T0)*T0_Vsi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam*(2.0*T0_Vsi_bi*d10_sqrt0)*((2.0*T0_Vsi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
#endif
#endif
nq=(1.0+(gam/(2.0*d00_sqrt0)));
EXIT_IF_ISNAN((1.0+(gam/(2.0*d00_sqrt0))))
}
{
double m00_sqrt(d00_sqrt0,T0)
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T0)
#endif
#if defined(_DERIVATE) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
psip_th_Vdi_bi=bsimbulk_d_hypsmooth((((((Vs*inv_Vt)+(2.0*phib))+bsimbulk_lln(q_vth))+(2.0*q_vth))+bsimbulk_lln((((2.0*nq)/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0))))),1.0e-3,((Vs_Vdi_bi*inv_Vt+bsimbulk_d_lln(q_vth,0.0))+bsimbulk_d_lln((((2.0*nq)/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0))),(((((2.0*nq_Vdi_bi)*gam-(2.0*nq)*gam_Vdi_bi)/gam/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0)))+(((2.0*nq)/gam)*(((((2.0*q_vth)*nq_Vdi_bi)*gam-((2.0*q_vth)*nq)*gam_Vdi_bi)/gam/gam)+(2.0*T0_Vdi_bi*d10_sqrt0)))))),0.0);
psip_th_Vsi_bi=bsimbulk_d_hypsmooth((((((Vs*inv_Vt)+(2.0*phib))+bsimbulk_lln(q_vth))+(2.0*q_vth))+bsimbulk_lln((((2.0*nq)/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0))))),1.0e-3,((Vs_Vsi_bi*inv_Vt+bsimbulk_d_lln(q_vth,0.0))+bsimbulk_d_lln((((2.0*nq)/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0))),(((((2.0*nq_Vsi_bi)*gam-(2.0*nq)*gam_Vsi_bi)/gam/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0)))+(((2.0*nq)/gam)*(((((2.0*q_vth)*nq_Vsi_bi)*gam-((2.0*q_vth)*nq)*gam_Vsi_bi)/gam/gam)+(2.0*T0_Vsi_bi*d10_sqrt0)))))),0.0);
psip_th_Tempt_GND=bsimbulk_d_hypsmooth((((((Vs*inv_Vt)+(2.0*phib))+bsimbulk_lln(q_vth))+(2.0*q_vth))+bsimbulk_lln((((2.0*nq)/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0))))),1.0e-3,((((Vs*inv_Vt_Tempt_GND)+(2.0*phib_Tempt_GND))+bsimbulk_d_lln(q_vth,0.0))+bsimbulk_d_lln((((2.0*nq)/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0))),(((((2.0*nq_Tempt_GND)*gam-(2.0*nq)*gam_Tempt_GND)/gam/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0)))+(((2.0*nq)/gam)*(((((2.0*q_vth)*nq_Tempt_GND)*gam-((2.0*q_vth)*nq)*gam_Tempt_GND)/gam/gam)+(2.0*T0_Tempt_GND*d10_sqrt0)))))),0.0);
#endif
psip_th=bsimbulk_hypsmooth((((((Vs*inv_Vt)+(2.0*phib))+bsimbulk_lln(q_vth))+(2.0*q_vth))+bsimbulk_lln((((2.0*nq)/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0))))),1.0e-3);
EXIT_IF_ISNAN(bsimbulk_hypsmooth((((((Vs*inv_Vt)+(2.0*phib))+bsimbulk_lln(q_vth))+(2.0*q_vth))+bsimbulk_lln((((2.0*nq)/gam)*((((2.0*q_vth)*nq)/gam)+(2.0*d00_sqrt0))))),1.0e-3))
}
{
double m00_sqrt(d00_sqrt0,psip_th)
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,psip_th)
#endif
#if defined(_DERIVATE) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
VTH_Vdi_bi=(devsign*(((psip_th_Vdi_bi-Vs_Vdi_bi*inv_Vt)*Vt+(((Vt*gam_Vdi_bi)*d00_sqrt0)+((Vt*gam)*psip_th_Vdi_bi*d10_sqrt0)))+Vth_shift_Vdi_bi));
VTH_Vsi_bi=(devsign*(((psip_th_Vsi_bi-Vs_Vsi_bi*inv_Vt)*Vt+(((Vt*gam_Vsi_bi)*d00_sqrt0)+((Vt*gam)*psip_th_Vsi_bi*d10_sqrt0)))+Vth_shift_Vsi_bi));
VTH_Tempt_GND=(devsign*(((((psip_th_Tempt_GND-(Vs*inv_Vt_Tempt_GND))*Vt)+((psip_th-(Vs*inv_Vt))*Vt_Tempt_GND))+((((Vt_Tempt_GND*gam)+(Vt*gam_Tempt_GND))*d00_sqrt0)+((Vt*gam)*psip_th_Tempt_GND*d10_sqrt0)))+Vth_shift_Tempt_GND));
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VTH]=(devsign*(((VFB_i+((psip_th-(Vs*inv_Vt))*Vt))+((Vt*gam)*d00_sqrt0))+Vth_shift));
EXIT_IF_ISNAN((devsign*(((VFB_i+((psip_th-(Vs*inv_Vt))*Vt))+((Vt*gam)*d00_sqrt0))+Vth_shift)))
}
{
double m00_sqrt(d00_sqrt0,((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gam_Vgm_si=0.0;
#if defined(_DERIVATE2)
  gam_Vgm_si_Vgm_si=0.0;
  gam_Vgm_si_Vdbulk_di=0.0;
  gam_Vgm_si_Vsbulk_si=0.0;
  gam_Vgm_si_Vgi_bi=0.0;
  gam_Vgm_si_Vdi_bi=0.0;
  gam_Vgm_si_Vsi_bi=0.0;
  gam_Vgm_si_Tempt_GND=0.0;
#endif
gam_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  gam_Vdbulk_di_Vgm_si=0.0;
  gam_Vdbulk_di_Vdbulk_di=0.0;
  gam_Vdbulk_di_Vsbulk_si=0.0;
  gam_Vdbulk_di_Vgi_bi=0.0;
  gam_Vdbulk_di_Vdi_bi=0.0;
  gam_Vdbulk_di_Vsi_bi=0.0;
  gam_Vdbulk_di_Tempt_GND=0.0;
#endif
gam_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  gam_Vsbulk_si_Vgm_si=0.0;
  gam_Vsbulk_si_Vdbulk_di=0.0;
  gam_Vsbulk_si_Vsbulk_si=0.0;
  gam_Vsbulk_si_Vgi_bi=0.0;
  gam_Vsbulk_si_Vdi_bi=0.0;
  gam_Vsbulk_si_Vsi_bi=0.0;
  gam_Vsbulk_si_Tempt_GND=0.0;
#endif
gam_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  gam_Vgi_bi_Vgm_si=0.0;
  gam_Vgi_bi_Vdbulk_di=0.0;
  gam_Vgi_bi_Vsbulk_si=0.0;
  gam_Vgi_bi_Vgi_bi=0.0;
  gam_Vgi_bi_Vdi_bi=0.0;
  gam_Vgi_bi_Vsi_bi=0.0;
  gam_Vgi_bi_Tempt_GND=0.0;
#endif
gam_Vdi_bi=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0/Cox);
#if defined(_DERIVATE2)
  gam_Vdi_bi_Vgm_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgm_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vgm_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vdbulk_di=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdbulk_di+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vdbulk_di))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vsbulk_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsbulk_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vsbulk_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vgi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vgi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vdi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vdi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vsi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vsi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Tempt_GND=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Tempt_GND+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Tempt_GND))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
#endif
gam_Vsi_bi=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0/Cox);
#if defined(_DERIVATE2)
  gam_Vsi_bi_Vgm_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgm_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vgm_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vdbulk_di=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdbulk_di+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vdbulk_di))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vsbulk_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsbulk_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vsbulk_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vgi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vgi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vdi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vdi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vsi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vsi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Tempt_GND=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Tempt_GND+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Tempt_GND))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
#endif
#if defined(_DERIVATE)
gam_Tempt_GND=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)*d10_sqrt0/Cox);
#endif
#endif
gam=(d00_sqrt0/Cox);
EXIT_IF_ISNAN((d00_sqrt0/Cox))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
inv_gam_Vgm_si=0.0;
#if defined(_DERIVATE2)
  inv_gam_Vgm_si_Vgm_si=0.0;
  inv_gam_Vgm_si_Vdbulk_di=0.0;
  inv_gam_Vgm_si_Vsbulk_si=0.0;
  inv_gam_Vgm_si_Vgi_bi=0.0;
  inv_gam_Vgm_si_Vdi_bi=0.0;
  inv_gam_Vgm_si_Vsi_bi=0.0;
  inv_gam_Vgm_si_Tempt_GND=0.0;
#endif
inv_gam_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  inv_gam_Vdbulk_di_Vgm_si=0.0;
  inv_gam_Vdbulk_di_Vdbulk_di=0.0;
  inv_gam_Vdbulk_di_Vsbulk_si=0.0;
  inv_gam_Vdbulk_di_Vgi_bi=0.0;
  inv_gam_Vdbulk_di_Vdi_bi=0.0;
  inv_gam_Vdbulk_di_Vsi_bi=0.0;
  inv_gam_Vdbulk_di_Tempt_GND=0.0;
#endif
inv_gam_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  inv_gam_Vsbulk_si_Vgm_si=0.0;
  inv_gam_Vsbulk_si_Vdbulk_di=0.0;
  inv_gam_Vsbulk_si_Vsbulk_si=0.0;
  inv_gam_Vsbulk_si_Vgi_bi=0.0;
  inv_gam_Vsbulk_si_Vdi_bi=0.0;
  inv_gam_Vsbulk_si_Vsi_bi=0.0;
  inv_gam_Vsbulk_si_Tempt_GND=0.0;
#endif
inv_gam_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  inv_gam_Vgi_bi_Vgm_si=0.0;
  inv_gam_Vgi_bi_Vdbulk_di=0.0;
  inv_gam_Vgi_bi_Vsbulk_si=0.0;
  inv_gam_Vgi_bi_Vgi_bi=0.0;
  inv_gam_Vgi_bi_Vdi_bi=0.0;
  inv_gam_Vgi_bi_Vsi_bi=0.0;
  inv_gam_Vgi_bi_Tempt_GND=0.0;
#endif
inv_gam_Vdi_bi=(-gam_Vdi_bi/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vdi_bi_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vgm_si)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vdi_bi_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vdbulk_di)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vdi_bi_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vsbulk_si)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vdi_bi_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vgi_bi)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vdi_bi_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vdi_bi)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vdi_bi_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vsi_bi)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vdi_bi_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Tempt_GND)/gam/gam+2*1.0*gam_Vdi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
inv_gam_Vsi_bi=(-gam_Vsi_bi/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vsi_bi_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vgm_si)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vsi_bi_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vdbulk_di)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vsi_bi_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vsbulk_si)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vsi_bi_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vgi_bi)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vsi_bi_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vdi_bi)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vsi_bi_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vsi_bi)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vsi_bi_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Tempt_GND)/gam/gam+2*1.0*gam_Vsi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
#if defined(_DERIVATE)
inv_gam_Tempt_GND=(-gam_Tempt_GND/gam/gam);
#endif
#endif
inv_gam=(1.0/gam);
EXIT_IF_ISNAN((1.0/gam))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
phib_n_Vgm_si=0.0;
#if defined(_DERIVATE2)
  phib_n_Vgm_si_Vgm_si=0.0;
  phib_n_Vgm_si_Vdbulk_di=0.0;
  phib_n_Vgm_si_Vsbulk_si=0.0;
  phib_n_Vgm_si_Vgi_bi=0.0;
  phib_n_Vgm_si_Tempt_GND=0.0;
  phib_n_Vgm_si_Vdi_bi=0.0;
  phib_n_Vgm_si_Vsi_bi=0.0;
#endif
phib_n_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  phib_n_Vdbulk_di_Vgm_si=0.0;
  phib_n_Vdbulk_di_Vdbulk_di=0.0;
  phib_n_Vdbulk_di_Vsbulk_si=0.0;
  phib_n_Vdbulk_di_Vgi_bi=0.0;
  phib_n_Vdbulk_di_Tempt_GND=0.0;
  phib_n_Vdbulk_di_Vdi_bi=0.0;
  phib_n_Vdbulk_di_Vsi_bi=0.0;
#endif
phib_n_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  phib_n_Vsbulk_si_Vgm_si=0.0;
  phib_n_Vsbulk_si_Vdbulk_di=0.0;
  phib_n_Vsbulk_si_Vsbulk_si=0.0;
  phib_n_Vsbulk_si_Vgi_bi=0.0;
  phib_n_Vsbulk_si_Tempt_GND=0.0;
  phib_n_Vsbulk_si_Vdi_bi=0.0;
  phib_n_Vsbulk_si_Vsi_bi=0.0;
#endif
phib_n_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  phib_n_Vgi_bi_Vgm_si=0.0;
  phib_n_Vgi_bi_Vdbulk_di=0.0;
  phib_n_Vgi_bi_Vsbulk_si=0.0;
  phib_n_Vgi_bi_Vgi_bi=0.0;
  phib_n_Vgi_bi_Tempt_GND=0.0;
  phib_n_Vgi_bi_Vdi_bi=0.0;
  phib_n_Vgi_bi_Vsi_bi=0.0;
#endif
#if defined(_DERIVATE)
phib_n_Tempt_GND=((phib_Tempt_GND*n-phib*n_Tempt_GND)/n/n);
#endif
phib_n_Vdi_bi=(-phib*n_Vdi_bi/n/n);
#if defined(_DERIVATE2)
  phib_n_Vdi_bi_Vgm_si=(0.0/n-(0.0*n_Vgm_si+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vgm_si)/n/n+2*phib*n_Vdi_bi*n_Vgm_si/n/n/n);
  phib_n_Vdi_bi_Vdbulk_di=(0.0/n-(0.0*n_Vdbulk_di+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vdbulk_di)/n/n+2*phib*n_Vdi_bi*n_Vdbulk_di/n/n/n);
  phib_n_Vdi_bi_Vsbulk_si=(0.0/n-(0.0*n_Vsbulk_si+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vsbulk_si)/n/n+2*phib*n_Vdi_bi*n_Vsbulk_si/n/n/n);
  phib_n_Vdi_bi_Vgi_bi=(0.0/n-(0.0*n_Vgi_bi+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vgi_bi)/n/n+2*phib*n_Vdi_bi*n_Vgi_bi/n/n/n);
  phib_n_Vdi_bi_Tempt_GND=(0.0/n-(0.0*n_Tempt_GND+phib_Tempt_GND*n_Vdi_bi+phib*n_Vdi_bi_Tempt_GND)/n/n+2*phib*n_Vdi_bi*n_Tempt_GND/n/n/n);
  phib_n_Vdi_bi_Vdi_bi=(0.0/n-(0.0*n_Vdi_bi+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vdi_bi)/n/n+2*phib*n_Vdi_bi*n_Vdi_bi/n/n/n);
  phib_n_Vdi_bi_Vsi_bi=(0.0/n-(0.0*n_Vsi_bi+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vsi_bi)/n/n+2*phib*n_Vdi_bi*n_Vsi_bi/n/n/n);
#endif
phib_n_Vsi_bi=(-phib*n_Vsi_bi/n/n);
#if defined(_DERIVATE2)
  phib_n_Vsi_bi_Vgm_si=(0.0/n-(0.0*n_Vgm_si+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vgm_si)/n/n+2*phib*n_Vsi_bi*n_Vgm_si/n/n/n);
  phib_n_Vsi_bi_Vdbulk_di=(0.0/n-(0.0*n_Vdbulk_di+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vdbulk_di)/n/n+2*phib*n_Vsi_bi*n_Vdbulk_di/n/n/n);
  phib_n_Vsi_bi_Vsbulk_si=(0.0/n-(0.0*n_Vsbulk_si+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vsbulk_si)/n/n+2*phib*n_Vsi_bi*n_Vsbulk_si/n/n/n);
  phib_n_Vsi_bi_Vgi_bi=(0.0/n-(0.0*n_Vgi_bi+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vgi_bi)/n/n+2*phib*n_Vsi_bi*n_Vgi_bi/n/n/n);
  phib_n_Vsi_bi_Tempt_GND=(0.0/n-(0.0*n_Tempt_GND+phib_Tempt_GND*n_Vsi_bi+phib*n_Vsi_bi_Tempt_GND)/n/n+2*phib*n_Vsi_bi*n_Tempt_GND/n/n/n);
  phib_n_Vsi_bi_Vdi_bi=(0.0/n-(0.0*n_Vdi_bi+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vdi_bi)/n/n+2*phib*n_Vsi_bi*n_Vdi_bi/n/n/n);
  phib_n_Vsi_bi_Vsi_bi=(0.0/n-(0.0*n_Vsi_bi+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vsi_bi)/n/n+2*phib*n_Vsi_bi*n_Vsi_bi/n/n/n);
#endif
#endif
phib_n=(phib/n);
EXIT_IF_ISNAN((phib/n))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vgfbPD_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vgfbPD_Vgm_si_Vgm_si=0.0;
  vgfbPD_Vgm_si_Vgm_di=0.0;
  vgfbPD_Vgm_si_Vdbulk_di=0.0;
  vgfbPD_Vgm_si_Vsbulk_si=0.0;
  vgfbPD_Vgm_si_Vgi_bi=0.0;
  vgfbPD_Vgm_si_Vdi_bi=0.0;
  vgfbPD_Vgm_si_Vsi_bi=0.0;
  vgfbPD_Vgm_si_Tempt_GND=0.0;
#endif
vgfbPD_Vgm_di=0.0;
#if defined(_DERIVATE2)
  vgfbPD_Vgm_di_Vgm_si=0.0;
  vgfbPD_Vgm_di_Vgm_di=0.0;
  vgfbPD_Vgm_di_Vdbulk_di=0.0;
  vgfbPD_Vgm_di_Vsbulk_si=0.0;
  vgfbPD_Vgm_di_Vgi_bi=0.0;
  vgfbPD_Vgm_di_Vdi_bi=0.0;
  vgfbPD_Vgm_di_Vsi_bi=0.0;
  vgfbPD_Vgm_di_Tempt_GND=0.0;
#endif
vgfbPD_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  vgfbPD_Vdbulk_di_Vgm_si=0.0;
  vgfbPD_Vdbulk_di_Vgm_di=0.0;
  vgfbPD_Vdbulk_di_Vdbulk_di=0.0;
  vgfbPD_Vdbulk_di_Vsbulk_si=0.0;
  vgfbPD_Vdbulk_di_Vgi_bi=0.0;
  vgfbPD_Vdbulk_di_Vdi_bi=0.0;
  vgfbPD_Vdbulk_di_Vsi_bi=0.0;
  vgfbPD_Vdbulk_di_Tempt_GND=0.0;
#endif
vgfbPD_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  vgfbPD_Vsbulk_si_Vgm_si=0.0;
  vgfbPD_Vsbulk_si_Vgm_di=0.0;
  vgfbPD_Vsbulk_si_Vdbulk_di=0.0;
  vgfbPD_Vsbulk_si_Vsbulk_si=0.0;
  vgfbPD_Vsbulk_si_Vgi_bi=0.0;
  vgfbPD_Vsbulk_si_Vdi_bi=0.0;
  vgfbPD_Vsbulk_si_Vsi_bi=0.0;
  vgfbPD_Vsbulk_si_Tempt_GND=0.0;
#endif
vgfbPD_Vgi_bi=((vgfb_Vgi_bi*T1-vgfb*T1_Vgi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vgi_bi_Vgm_si=(vgfb_Vgi_bi_Vgm_si/T1-(vgfb_Vgi_bi*T1_Vgm_si+vgfb_Vgm_si*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vgm_si)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vgi_bi_Vgm_di=(vgfb_Vgi_bi_Vgm_di/T1-(vgfb_Vgi_bi*T1_Vgm_di+vgfb_Vgm_di*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vgm_di)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vgi_bi_Vdbulk_di=(vgfb_Vgi_bi_Vdbulk_di/T1-(vgfb_Vgi_bi*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vgi_bi_Vsbulk_si=(vgfb_Vgi_bi_Vsbulk_si/T1-(vgfb_Vgi_bi*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vgi_bi_Vgi_bi=(vgfb_Vgi_bi_Vgi_bi/T1-(vgfb_Vgi_bi*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vgi_bi)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Vdi_bi=(vgfb_Vgi_bi_Vdi_bi/T1-(vgfb_Vgi_bi*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vdi_bi)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Vsi_bi=(vgfb_Vgi_bi_Vsi_bi/T1-(vgfb_Vgi_bi*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vsi_bi)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Tempt_GND=(vgfb_Vgi_bi_Tempt_GND/T1-(vgfb_Vgi_bi*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vgi_bi+vgfb*T1_Vgi_bi_Tempt_GND)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vdi_bi=((vgfb_Vdi_bi*T1-vgfb*T1_Vdi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vdi_bi_Vgm_si=(vgfb_Vdi_bi_Vgm_si/T1-(vgfb_Vdi_bi*T1_Vgm_si+vgfb_Vgm_si*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vgm_si)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vdi_bi_Vgm_di=(vgfb_Vdi_bi_Vgm_di/T1-(vgfb_Vdi_bi*T1_Vgm_di+vgfb_Vgm_di*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vgm_di)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vdi_bi_Vdbulk_di=(vgfb_Vdi_bi_Vdbulk_di/T1-(vgfb_Vdi_bi*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vdi_bi_Vsbulk_si=(vgfb_Vdi_bi_Vsbulk_si/T1-(vgfb_Vdi_bi*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vdi_bi_Vgi_bi=(vgfb_Vdi_bi_Vgi_bi/T1-(vgfb_Vdi_bi*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vgi_bi)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Vdi_bi=(vgfb_Vdi_bi_Vdi_bi/T1-(vgfb_Vdi_bi*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vdi_bi)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Vsi_bi=(vgfb_Vdi_bi_Vsi_bi/T1-(vgfb_Vdi_bi*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vsi_bi)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Tempt_GND=(vgfb_Vdi_bi_Tempt_GND/T1-(vgfb_Vdi_bi*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vdi_bi+vgfb*T1_Vdi_bi_Tempt_GND)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vsi_bi=((vgfb_Vsi_bi*T1-vgfb*T1_Vsi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vsi_bi_Vgm_si=(vgfb_Vsi_bi_Vgm_si/T1-(vgfb_Vsi_bi*T1_Vgm_si+vgfb_Vgm_si*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vgm_si)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vsi_bi_Vgm_di=(vgfb_Vsi_bi_Vgm_di/T1-(vgfb_Vsi_bi*T1_Vgm_di+vgfb_Vgm_di*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vgm_di)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vsi_bi_Vdbulk_di=(vgfb_Vsi_bi_Vdbulk_di/T1-(vgfb_Vsi_bi*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vsi_bi_Vsbulk_si=(vgfb_Vsi_bi_Vsbulk_si/T1-(vgfb_Vsi_bi*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vsi_bi_Vgi_bi=(vgfb_Vsi_bi_Vgi_bi/T1-(vgfb_Vsi_bi*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vgi_bi)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Vdi_bi=(vgfb_Vsi_bi_Vdi_bi/T1-(vgfb_Vsi_bi*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vdi_bi)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Vsi_bi=(vgfb_Vsi_bi_Vsi_bi/T1-(vgfb_Vsi_bi*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vsi_bi)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Tempt_GND=(vgfb_Vsi_bi_Tempt_GND/T1-(vgfb_Vsi_bi*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vsi_bi+vgfb*T1_Vsi_bi_Tempt_GND)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
#if defined(_DERIVATE)
vgfbPD_Tempt_GND=((vgfb_Tempt_GND*T1-vgfb*T1_Tempt_GND)/T1/T1);
#endif
#endif
vgfbPD=(vgfb/T1);
EXIT_IF_ISNAN((vgfb/T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gammaPD_Vgm_si=0.0;
#if defined(_DERIVATE2)
  gammaPD_Vgm_si_Vgm_si=0.0;
  gammaPD_Vgm_si_Vdbulk_di=0.0;
  gammaPD_Vgm_si_Vsbulk_si=0.0;
  gammaPD_Vgm_si_Vgi_bi=0.0;
  gammaPD_Vgm_si_Vdi_bi=0.0;
  gammaPD_Vgm_si_Vsi_bi=0.0;
  gammaPD_Vgm_si_Tempt_GND=0.0;
#endif
gammaPD_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  gammaPD_Vdbulk_di_Vgm_si=0.0;
  gammaPD_Vdbulk_di_Vdbulk_di=0.0;
  gammaPD_Vdbulk_di_Vsbulk_si=0.0;
  gammaPD_Vdbulk_di_Vgi_bi=0.0;
  gammaPD_Vdbulk_di_Vdi_bi=0.0;
  gammaPD_Vdbulk_di_Vsi_bi=0.0;
  gammaPD_Vdbulk_di_Tempt_GND=0.0;
#endif
gammaPD_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  gammaPD_Vsbulk_si_Vgm_si=0.0;
  gammaPD_Vsbulk_si_Vdbulk_di=0.0;
  gammaPD_Vsbulk_si_Vsbulk_si=0.0;
  gammaPD_Vsbulk_si_Vgi_bi=0.0;
  gammaPD_Vsbulk_si_Vdi_bi=0.0;
  gammaPD_Vsbulk_si_Vsi_bi=0.0;
  gammaPD_Vsbulk_si_Tempt_GND=0.0;
#endif
gammaPD_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  gammaPD_Vgi_bi_Vgm_si=0.0;
  gammaPD_Vgi_bi_Vdbulk_di=0.0;
  gammaPD_Vgi_bi_Vsbulk_si=0.0;
  gammaPD_Vgi_bi_Vgi_bi=0.0;
  gammaPD_Vgi_bi_Vdi_bi=0.0;
  gammaPD_Vgi_bi_Vsi_bi=0.0;
  gammaPD_Vgi_bi_Tempt_GND=0.0;
#endif
gammaPD_Vdi_bi=((gam_Vdi_bi*T1-gam*T1_Vdi_bi)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vdi_bi_Vgm_si=(gam_Vdi_bi_Vgm_si/T1-(gam_Vdi_bi*T1_Vgm_si+gam_Vgm_si*T1_Vdi_bi+gam*T1_Vdi_bi_Vgm_si)/T1/T1+2*gam*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vdi_bi_Vdbulk_di=(gam_Vdi_bi_Vdbulk_di/T1-(gam_Vdi_bi*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vdi_bi+gam*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*gam*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vdi_bi_Vsbulk_si=(gam_Vdi_bi_Vsbulk_si/T1-(gam_Vdi_bi*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vdi_bi+gam*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*gam*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vdi_bi_Vgi_bi=(gam_Vdi_bi_Vgi_bi/T1-(gam_Vdi_bi*T1_Vgi_bi+gam_Vgi_bi*T1_Vdi_bi+gam*T1_Vdi_bi_Vgi_bi)/T1/T1+2*gam*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Vdi_bi=(gam_Vdi_bi_Vdi_bi/T1-(gam_Vdi_bi*T1_Vdi_bi+gam_Vdi_bi*T1_Vdi_bi+gam*T1_Vdi_bi_Vdi_bi)/T1/T1+2*gam*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Vsi_bi=(gam_Vdi_bi_Vsi_bi/T1-(gam_Vdi_bi*T1_Vsi_bi+gam_Vsi_bi*T1_Vdi_bi+gam*T1_Vdi_bi_Vsi_bi)/T1/T1+2*gam*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Tempt_GND=(gam_Vdi_bi_Tempt_GND/T1-(gam_Vdi_bi*T1_Tempt_GND+gam_Tempt_GND*T1_Vdi_bi+gam*T1_Vdi_bi_Tempt_GND)/T1/T1+2*gam*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vsi_bi=((gam_Vsi_bi*T1-gam*T1_Vsi_bi)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vsi_bi_Vgm_si=(gam_Vsi_bi_Vgm_si/T1-(gam_Vsi_bi*T1_Vgm_si+gam_Vgm_si*T1_Vsi_bi+gam*T1_Vsi_bi_Vgm_si)/T1/T1+2*gam*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vsi_bi_Vdbulk_di=(gam_Vsi_bi_Vdbulk_di/T1-(gam_Vsi_bi*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vsi_bi+gam*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*gam*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vsi_bi_Vsbulk_si=(gam_Vsi_bi_Vsbulk_si/T1-(gam_Vsi_bi*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vsi_bi+gam*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*gam*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vsi_bi_Vgi_bi=(gam_Vsi_bi_Vgi_bi/T1-(gam_Vsi_bi*T1_Vgi_bi+gam_Vgi_bi*T1_Vsi_bi+gam*T1_Vsi_bi_Vgi_bi)/T1/T1+2*gam*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Vdi_bi=(gam_Vsi_bi_Vdi_bi/T1-(gam_Vsi_bi*T1_Vdi_bi+gam_Vdi_bi*T1_Vsi_bi+gam*T1_Vsi_bi_Vdi_bi)/T1/T1+2*gam*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Vsi_bi=(gam_Vsi_bi_Vsi_bi/T1-(gam_Vsi_bi*T1_Vsi_bi+gam_Vsi_bi*T1_Vsi_bi+gam*T1_Vsi_bi_Vsi_bi)/T1/T1+2*gam*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Tempt_GND=(gam_Vsi_bi_Tempt_GND/T1-(gam_Vsi_bi*T1_Tempt_GND+gam_Tempt_GND*T1_Vsi_bi+gam*T1_Vsi_bi_Tempt_GND)/T1/T1+2*gam*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
#if defined(_DERIVATE)
gammaPD_Tempt_GND=((gam_Tempt_GND*T1-gam*T1_Tempt_GND)/T1/T1);
#endif
#endif
gammaPD=(gam/T1);
EXIT_IF_ISNAN((gam/T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=((0.5*vgfbPD_Vgi_bi)-(3.0*(gammaPD_Vgi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vdi_bi=((0.5*vgfbPD_Vdi_bi)-(3.0*(gammaPD_Vdi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vsi_bi=((0.5*vgfbPD_Vsi_bi)-(3.0*(gammaPD_Vsi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((0.5*vgfbPD_Tempt_GND)-(3.0*(gammaPD_Tempt_GND/1.41421356237309504880)));
#endif
#endif
T1=((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
EXIT_IF_ISNAN(((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880)))))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+(6.0*vgfbPD)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+(6.0*vgfbPD)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(T1_Vgi_bi+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgm_di))));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgm_si))));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vdbulk_di))));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vsbulk_si))));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgi_bi))));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vdi_bi))));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vsi_bi))));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Tempt_GND))));
#endif
T2_Vdi_bi=(T1_Vdi_bi+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgm_di))));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgm_si))));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vdbulk_di))));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vsbulk_si))));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgi_bi))));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vdi_bi))));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vsi_bi))));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Tempt_GND))));
#endif
T2_Vsi_bi=(T1_Vsi_bi+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgm_di))));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgm_si))));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vdbulk_di))));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vsbulk_si))));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgi_bi))));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vdi_bi))));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vsi_bi))));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+(6.0*vgfbPD_Tempt_GND))*d10_sqrt0);
#endif
#endif
T2=(T1+d00_sqrt0);
EXIT_IF_ISNAN((T1+d00_sqrt0))
}
if
((vgfbPD<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vgi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=((+vgfbPD_Vgi_bi_Vgm_si-T2_Vgi_bi_Vgm_si)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vgm_di=((+vgfbPD_Vgi_bi_Vgm_di-T2_Vgi_bi_Vgm_di)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vgi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vdbulk_di=((+vgfbPD_Vgi_bi_Vdbulk_di-T2_Vgi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vsbulk_si=((+vgfbPD_Vgi_bi_Vsbulk_si-T2_Vgi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vgi_bi=((+vgfbPD_Vgi_bi_Vgi_bi-T2_Vgi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vdi_bi=((+vgfbPD_Vgi_bi_Vdi_bi-T2_Vgi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vsi_bi=((+vgfbPD_Vgi_bi_Vsi_bi-T2_Vgi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Tempt_GND=((+vgfbPD_Vgi_bi_Tempt_GND-T2_Vgi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vdi_bi=(((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vdi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=((+vgfbPD_Vdi_bi_Vgm_si-T2_Vdi_bi_Vgm_si)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vgm_di=((+vgfbPD_Vdi_bi_Vgm_di-T2_Vdi_bi_Vgm_di)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vdi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vdbulk_di=((+vgfbPD_Vdi_bi_Vdbulk_di-T2_Vdi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vsbulk_si=((+vgfbPD_Vdi_bi_Vsbulk_si-T2_Vdi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vgi_bi=((+vgfbPD_Vdi_bi_Vgi_bi-T2_Vdi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vdi_bi=((+vgfbPD_Vdi_bi_Vdi_bi-T2_Vdi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vsi_bi=((+vgfbPD_Vdi_bi_Vsi_bi-T2_Vdi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Tempt_GND=((+vgfbPD_Vdi_bi_Tempt_GND-T2_Vdi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vsi_bi=(((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vsi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=((+vgfbPD_Vsi_bi_Vgm_si-T2_Vsi_bi_Vgm_si)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vgm_di=((+vgfbPD_Vsi_bi_Vgm_di-T2_Vsi_bi_Vgm_di)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vsi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vdbulk_di=((+vgfbPD_Vsi_bi_Vdbulk_di-T2_Vsi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vsbulk_si=((+vgfbPD_Vsi_bi_Vsbulk_si-T2_Vsi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vgi_bi=((+vgfbPD_Vsi_bi_Vgi_bi-T2_Vsi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vdi_bi=((+vgfbPD_Vsi_bi_Vdi_bi-T2_Vsi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vsi_bi=((+vgfbPD_Vsi_bi_Vsi_bi-T2_Vsi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Tempt_GND=((+vgfbPD_Vsi_bi_Tempt_GND-T2_Vsi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(((vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD-(vgfbPD-T2)*gammaPD_Tempt_GND)/gammaPD/gammaPD);
#endif
#endif
T3=((vgfbPD-T2)/gammaPD);
EXIT_IF_ISNAN(((vgfbPD-T2)/gammaPD))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
psip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psip_Vgm_di_Vgm_di=0.0;
  psip_Vgm_di_Vgm_si=0.0;
  psip_Vgm_di_Vdbulk_di=0.0;
  psip_Vgm_di_Vsbulk_si=0.0;
  psip_Vgm_di_Vgi_bi=0.0;
  psip_Vgm_di_Vdi_bi=0.0;
  psip_Vgm_di_Vsi_bi=0.0;
  psip_Vgm_di_Tempt_GND=0.0;
#endif
psip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psip_Vgm_si_Vgm_di=0.0;
  psip_Vgm_si_Vgm_si=0.0;
  psip_Vgm_si_Vdbulk_di=0.0;
  psip_Vgm_si_Vsbulk_si=0.0;
  psip_Vgm_si_Vgi_bi=0.0;
  psip_Vgm_si_Vdi_bi=0.0;
  psip_Vgm_si_Vsi_bi=0.0;
  psip_Vgm_si_Tempt_GND=0.0;
#endif
psip_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  psip_Vdbulk_di_Vgm_di=0.0;
  psip_Vdbulk_di_Vgm_si=0.0;
  psip_Vdbulk_di_Vdbulk_di=0.0;
  psip_Vdbulk_di_Vsbulk_si=0.0;
  psip_Vdbulk_di_Vgi_bi=0.0;
  psip_Vdbulk_di_Vdi_bi=0.0;
  psip_Vdbulk_di_Vsi_bi=0.0;
  psip_Vdbulk_di_Tempt_GND=0.0;
#endif
psip_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  psip_Vsbulk_si_Vgm_di=0.0;
  psip_Vsbulk_si_Vgm_si=0.0;
  psip_Vsbulk_si_Vdbulk_di=0.0;
  psip_Vsbulk_si_Vsbulk_si=0.0;
  psip_Vsbulk_si_Vgi_bi=0.0;
  psip_Vsbulk_si_Vdi_bi=0.0;
  psip_Vsbulk_si_Vsi_bi=0.0;
  psip_Vsbulk_si_Tempt_GND=0.0;
#endif
psip_Vgi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vgi_bi)+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))));
#if defined(_DERIVATE2)
  psip_Vgi_bi_Vgm_di=0.0;
  psip_Vgi_bi_Vgm_si=0.0;
  psip_Vgi_bi_Vdbulk_di=0.0;
  psip_Vgi_bi_Vsbulk_si=0.0;
  psip_Vgi_bi_Vgi_bi=0.0;
  psip_Vgi_bi_Vdi_bi=0.0;
  psip_Vgi_bi_Vsi_bi=0.0;
  psip_Vgi_bi_Tempt_GND=0.0;
#endif
psip_Vdi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vdi_bi)+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))));
#if defined(_DERIVATE2)
  psip_Vdi_bi_Vgm_di=0.0;
  psip_Vdi_bi_Vgm_si=0.0;
  psip_Vdi_bi_Vdbulk_di=0.0;
  psip_Vdi_bi_Vsbulk_si=0.0;
  psip_Vdi_bi_Vgi_bi=0.0;
  psip_Vdi_bi_Vdi_bi=0.0;
  psip_Vdi_bi_Vsi_bi=0.0;
  psip_Vdi_bi_Tempt_GND=0.0;
#endif
psip_Vsi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vsi_bi)+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))));
#if defined(_DERIVATE2)
  psip_Vsi_bi_Vgm_di=0.0;
  psip_Vsi_bi_Vgm_si=0.0;
  psip_Vsi_bi_Vdbulk_di=0.0;
  psip_Vsi_bi_Vsbulk_si=0.0;
  psip_Vsi_bi_Vgi_bi=0.0;
  psip_Vsi_bi_Vdi_bi=0.0;
  psip_Vsi_bi_Vsi_bi=0.0;
  psip_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
psip_Tempt_GND=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Tempt_GND)+((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))));
#endif
#endif
psip=(-bsimbulk_lln(((1.0-T2)+(T3*T3))));
EXIT_IF_ISNAN((-bsimbulk_lln(((1.0-T2)+(T3*T3)))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp((-T2),(-T2_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=bsimbulk_d_lexp((-T2),(-T2_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=0.0;
  T3_Vdi_bi_Vgm_di=0.0;
  T3_Vdi_bi_Vdbulk_di=0.0;
  T3_Vdi_bi_Vsbulk_si=0.0;
  T3_Vdi_bi_Vgi_bi=0.0;
  T3_Vdi_bi_Vdi_bi=0.0;
  T3_Vdi_bi_Vsi_bi=0.0;
  T3_Vdi_bi_Tempt_GND=0.0;
#endif
T3_Vsi_bi=bsimbulk_d_lexp((-T2),(-T2_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=0.0;
  T3_Vsi_bi_Vgm_di=0.0;
  T3_Vsi_bi_Vdbulk_di=0.0;
  T3_Vsi_bi_Vsbulk_si=0.0;
  T3_Vsi_bi_Vgi_bi=0.0;
  T3_Vsi_bi_Vdi_bi=0.0;
  T3_Vsi_bi_Vsi_bi=0.0;
  T3_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((-T2),(-T2_Tempt_GND));
#endif
#endif
T3=bsimbulk_lexp((-T2));
EXIT_IF_ISNAN(bsimbulk_lexp((-T2)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=(0.5*gammaPD_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vdi_bi+0.5*0.0);
  T1_Vdi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=(0.5*gammaPD_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vsi_bi+0.5*0.0);
  T1_Vsi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(0.5*gammaPD_Tempt_GND);
#endif
#endif
T1=(0.5*gammaPD);
EXIT_IF_ISNAN((0.5*gammaPD))
{
double m00_sqrt(d00_sqrt0,(((vgfbPD-1.0)+T3)+(T1*T1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((vgfbPD-1.0)+T3)+(T1*T1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*d10_sqrt0-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgm_di-0.0)+T3_Vgi_bi_Vgm_di)+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)))-T1_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgm_si-0.0)+T3_Vgi_bi_Vgm_si)+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)))-T1_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vdbulk_di-0.0)+T3_Vgi_bi_Vdbulk_di)+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)))-T1_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vsbulk_si-0.0)+T3_Vgi_bi_Vsbulk_si)+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)))-T1_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgi_bi-0.0)+T3_Vgi_bi_Vgi_bi)+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)))-T1_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vdi_bi-0.0)+T3_Vgi_bi_Vdi_bi)+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)))-T1_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vsi_bi-0.0)+T3_Vgi_bi_Vsi_bi)+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)))-T1_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Tempt_GND-0.0)+T3_Vgi_bi_Tempt_GND)+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)))-T1_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=(((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*d10_sqrt0-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgm_di-0.0)+T3_Vdi_bi_Vgm_di)+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)))-T1_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgm_si-0.0)+T3_Vdi_bi_Vgm_si)+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)))-T1_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vdbulk_di-0.0)+T3_Vdi_bi_Vdbulk_di)+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)))-T1_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vsbulk_si-0.0)+T3_Vdi_bi_Vsbulk_si)+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)))-T1_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgi_bi-0.0)+T3_Vdi_bi_Vgi_bi)+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)))-T1_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vdi_bi-0.0)+T3_Vdi_bi_Vdi_bi)+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)))-T1_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vsi_bi-0.0)+T3_Vdi_bi_Vsi_bi)+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)))-T1_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Tempt_GND-0.0)+T3_Vdi_bi_Tempt_GND)+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)))-T1_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=(((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*d10_sqrt0-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgm_di-0.0)+T3_Vsi_bi_Vgm_di)+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)))-T1_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgm_si-0.0)+T3_Vsi_bi_Vgm_si)+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)))-T1_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vdbulk_di-0.0)+T3_Vsi_bi_Vdbulk_di)+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)))-T1_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vsbulk_si-0.0)+T3_Vsi_bi_Vsbulk_si)+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)))-T1_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgi_bi-0.0)+T3_Vsi_bi_Vgi_bi)+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)))-T1_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vdi_bi-0.0)+T3_Vsi_bi_Vdi_bi)+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)))-T1_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vsi_bi-0.0)+T3_Vsi_bi_Vsi_bi)+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)))-T1_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Tempt_GND-0.0)+T3_Vsi_bi_Tempt_GND)+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((vgfbPD_Tempt_GND+T3_Tempt_GND)+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0-T1_Tempt_GND);
#endif
#endif
T2=(d00_sqrt0-T1);
EXIT_IF_ISNAN((d00_sqrt0-T1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
psip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psip_Vgm_di_Vgm_di=0.0;
  psip_Vgm_di_Vgm_si=0.0;
  psip_Vgm_di_Vdbulk_di=0.0;
  psip_Vgm_di_Vsbulk_si=0.0;
  psip_Vgm_di_Vgi_bi=0.0;
  psip_Vgm_di_Vdi_bi=0.0;
  psip_Vgm_di_Vsi_bi=0.0;
  psip_Vgm_di_Tempt_GND=0.0;
#endif
psip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psip_Vgm_si_Vgm_di=0.0;
  psip_Vgm_si_Vgm_si=0.0;
  psip_Vgm_si_Vdbulk_di=0.0;
  psip_Vgm_si_Vsbulk_si=0.0;
  psip_Vgm_si_Vgi_bi=0.0;
  psip_Vgm_si_Vdi_bi=0.0;
  psip_Vgm_si_Vsi_bi=0.0;
  psip_Vgm_si_Tempt_GND=0.0;
#endif
psip_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  psip_Vdbulk_di_Vgm_di=0.0;
  psip_Vdbulk_di_Vgm_si=0.0;
  psip_Vdbulk_di_Vdbulk_di=0.0;
  psip_Vdbulk_di_Vsbulk_si=0.0;
  psip_Vdbulk_di_Vgi_bi=0.0;
  psip_Vdbulk_di_Vdi_bi=0.0;
  psip_Vdbulk_di_Vsi_bi=0.0;
  psip_Vdbulk_di_Tempt_GND=0.0;
#endif
psip_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  psip_Vsbulk_si_Vgm_di=0.0;
  psip_Vsbulk_si_Vgm_si=0.0;
  psip_Vsbulk_si_Vdbulk_di=0.0;
  psip_Vsbulk_si_Vsbulk_si=0.0;
  psip_Vsbulk_si_Vgi_bi=0.0;
  psip_Vsbulk_si_Vdi_bi=0.0;
  psip_Vsbulk_si_Vsi_bi=0.0;
  psip_Vsbulk_si_Tempt_GND=0.0;
#endif
psip_Vgi_bi=(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))-T3_Vgi_bi);
#if defined(_DERIVATE2)
  psip_Vgi_bi_Vgm_di=(+(+(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di)+0.0)-T3_Vgi_bi_Vgm_di);
  psip_Vgi_bi_Vgm_si=(+(+(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si)+0.0)-T3_Vgi_bi_Vgm_si);
  psip_Vgi_bi_Vdbulk_di=(+(+(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di)+0.0)-T3_Vgi_bi_Vdbulk_di);
  psip_Vgi_bi_Vsbulk_si=(+(+(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si)+0.0)-T3_Vgi_bi_Vsbulk_si);
  psip_Vgi_bi_Vgi_bi=(+(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0)-T3_Vgi_bi_Vgi_bi);
  psip_Vgi_bi_Vdi_bi=(+(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0)-T3_Vgi_bi_Vdi_bi);
  psip_Vgi_bi_Vsi_bi=(+(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0)-T3_Vgi_bi_Vsi_bi);
  psip_Vgi_bi_Tempt_GND=(+(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0)-T3_Vgi_bi_Tempt_GND);
#endif
psip_Vdi_bi=(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))-T3_Vdi_bi);
#if defined(_DERIVATE2)
  psip_Vdi_bi_Vgm_di=(+(+(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di)+0.0)-T3_Vdi_bi_Vgm_di);
  psip_Vdi_bi_Vgm_si=(+(+(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si)+0.0)-T3_Vdi_bi_Vgm_si);
  psip_Vdi_bi_Vdbulk_di=(+(+(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di)+0.0)-T3_Vdi_bi_Vdbulk_di);
  psip_Vdi_bi_Vsbulk_si=(+(+(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si)+0.0)-T3_Vdi_bi_Vsbulk_si);
  psip_Vdi_bi_Vgi_bi=(+(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0)-T3_Vdi_bi_Vgi_bi);
  psip_Vdi_bi_Vdi_bi=(+(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0)-T3_Vdi_bi_Vdi_bi);
  psip_Vdi_bi_Vsi_bi=(+(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0)-T3_Vdi_bi_Vsi_bi);
  psip_Vdi_bi_Tempt_GND=(+(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0)-T3_Vdi_bi_Tempt_GND);
#endif
psip_Vsi_bi=(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))-T3_Vsi_bi);
#if defined(_DERIVATE2)
  psip_Vsi_bi_Vgm_di=(+(+(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di)+0.0)-T3_Vsi_bi_Vgm_di);
  psip_Vsi_bi_Vgm_si=(+(+(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si)+0.0)-T3_Vsi_bi_Vgm_si);
  psip_Vsi_bi_Vdbulk_di=(+(+(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di)+0.0)-T3_Vsi_bi_Vdbulk_di);
  psip_Vsi_bi_Vsbulk_si=(+(+(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si)+0.0)-T3_Vsi_bi_Vsbulk_si);
  psip_Vsi_bi_Vgi_bi=(+(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0)-T3_Vsi_bi_Vgi_bi);
  psip_Vsi_bi_Vdi_bi=(+(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0)-T3_Vsi_bi_Vdi_bi);
  psip_Vsi_bi_Vsi_bi=(+(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0)-T3_Vsi_bi_Vsi_bi);
  psip_Vsi_bi_Tempt_GND=(+(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0)-T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
psip_Tempt_GND=(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))-T3_Tempt_GND);
#endif
#endif
psip=(((T2*T2)+1.0)-T3);
EXIT_IF_ISNAN((((T2*T2)+1.0)-T3))
}
{
double m00_sqrt(d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=0.0;
  T8_Vdbulk_di_Vgm_si=0.0;
  T8_Vdbulk_di_Vdbulk_di=0.0;
  T8_Vdbulk_di_Vsbulk_si=0.0;
  T8_Vdbulk_di_Vgi_bi=0.0;
  T8_Vdbulk_di_Vdi_bi=0.0;
  T8_Vdbulk_di_Vsi_bi=0.0;
  T8_Vdbulk_di_Tempt_GND=0.0;
#endif
T8_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=0.0;
  T8_Vsbulk_si_Vgm_si=0.0;
  T8_Vsbulk_si_Vdbulk_di=0.0;
  T8_Vsbulk_si_Vsbulk_si=0.0;
  T8_Vsbulk_si_Vgi_bi=0.0;
  T8_Vsbulk_si_Vdi_bi=0.0;
  T8_Vsbulk_si_Vsi_bi=0.0;
  T8_Vsbulk_si_Tempt_GND=0.0;
#endif
T8_Vgi_bi=(0.5*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vdi_bi=(0.5*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsi_bi=(0.5*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(psip_Tempt_GND+((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((psip+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psip+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T8)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T8)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=0.0;
  sqrtpsip_Vgm_di_Vgm_si=0.0;
  sqrtpsip_Vgm_di_Vdbulk_di=0.0;
  sqrtpsip_Vgm_di_Vsbulk_si=0.0;
  sqrtpsip_Vgm_di_Vgi_bi=0.0;
  sqrtpsip_Vgm_di_Vdi_bi=0.0;
  sqrtpsip_Vgm_di_Vsi_bi=0.0;
  sqrtpsip_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=0.0;
  sqrtpsip_Vgm_si_Vgm_si=0.0;
  sqrtpsip_Vgm_si_Vdbulk_di=0.0;
  sqrtpsip_Vgm_si_Vsbulk_si=0.0;
  sqrtpsip_Vgm_si_Vgi_bi=0.0;
  sqrtpsip_Vgm_si_Vdi_bi=0.0;
  sqrtpsip_Vgm_si_Vsi_bi=0.0;
  sqrtpsip_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=0.0;
  sqrtpsip_Vdbulk_di_Vgm_si=0.0;
  sqrtpsip_Vdbulk_di_Vdbulk_di=0.0;
  sqrtpsip_Vdbulk_di_Vsbulk_si=0.0;
  sqrtpsip_Vdbulk_di_Vgi_bi=0.0;
  sqrtpsip_Vdbulk_di_Vdi_bi=0.0;
  sqrtpsip_Vdbulk_di_Vsi_bi=0.0;
  sqrtpsip_Vdbulk_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=0.0;
  sqrtpsip_Vsbulk_si_Vgm_si=0.0;
  sqrtpsip_Vsbulk_si_Vdbulk_di=0.0;
  sqrtpsip_Vsbulk_si_Vsbulk_si=0.0;
  sqrtpsip_Vsbulk_si_Vgi_bi=0.0;
  sqrtpsip_Vsbulk_si_Vdi_bi=0.0;
  sqrtpsip_Vsbulk_si_Vsi_bi=0.0;
  sqrtpsip_Vsbulk_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vgi_bi=T8_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=T8_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=T8_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=T8_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=0.0;
  T9_Vdbulk_di_Vgm_di=0.0;
  T9_Vdbulk_di_Vdbulk_di=0.0;
  T9_Vdbulk_di_Vsbulk_si=0.0;
  T9_Vdbulk_di_Vdi_bi=0.0;
  T9_Vdbulk_di_Vsi_bi=0.0;
  T9_Vdbulk_di_Tempt_GND=0.0;
  T9_Vdbulk_di_Vgi_bi=0.0;
#endif
T9_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=0.0;
  T9_Vsbulk_si_Vgm_di=0.0;
  T9_Vsbulk_si_Vdbulk_di=0.0;
  T9_Vsbulk_si_Vsbulk_si=0.0;
  T9_Vsbulk_si_Vdi_bi=0.0;
  T9_Vsbulk_si_Vsi_bi=0.0;
  T9_Vsbulk_si_Tempt_GND=0.0;
  T9_Vsbulk_si_Vgi_bi=0.0;
#endif
T9_Vdi_bi=((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsi_bi=((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#endif
T9_Vgi_bi=((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#endif
T9=(1.0+(gam/(2.0*sqrtpsip)));
EXIT_IF_ISNAN((1.0+(gam/(2.0*sqrtpsip))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=((((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*0.0/gam/gam/gam);
  T0_Vgi_bi_Vgm_si=((+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vgi_bi_Vdbulk_di=((+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgi_bi_Vsbulk_si=((+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgi_bi_Vgi_bi=((+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vgi_bi_Vdi_bi=((+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vgi_bi_Vsi_bi=((+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vgi_bi_Tempt_GND=((+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vdi_bi=((((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*0.0/gam/gam/gam);
  T0_Vdi_bi_Vgm_si=((+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vdi_bi_Vdbulk_di=((+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdi_bi_Vsbulk_si=((+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdi_bi_Vgi_bi=((+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vdi_bi_Vdi_bi=((+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vdi_bi_Vsi_bi=((+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vdi_bi_Tempt_GND=((+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsi_bi=((((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*0.0/gam/gam/gam);
  T0_Vsi_bi_Vgm_si=((+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vsi_bi_Vdbulk_di=((+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsi_bi_Vsbulk_si=((+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsi_bi_Vgi_bi=((+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vsi_bi_Vdi_bi=((+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vsi_bi_Vsi_bi=((+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vsi_bi_Tempt_GND=((+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Tempt_GND)/gam/gam);
#endif
#endif
T0=((1.0+(gam/(2.0*sqrtpsip)))/gam);
EXIT_IF_ISNAN(((1.0+(gam/(2.0*sqrtpsip)))/gam))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=((psip_Vgi_bi-(2.0*phib_n_Vgi_bi))-vs_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+psip_Vgi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vgi_bi+2.0*0.0))-0.0);
  T1_Vgi_bi_Vgm_si=(+(+psip_Vgi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vgm_si))-vs_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+(+psip_Vgi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vdbulk_di))-vs_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+(+psip_Vgi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vsbulk_si))-vs_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+(+psip_Vgi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vgi_bi))-vs_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+(+psip_Vgi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vdi_bi))-vs_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+(+psip_Vgi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vsi_bi))-vs_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+(+psip_Vgi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Tempt_GND))-vs_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=((psip_Vdi_bi-(2.0*phib_n_Vdi_bi))-vs_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+psip_Vdi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vdi_bi+2.0*0.0))-0.0);
  T1_Vdi_bi_Vgm_si=(+(+psip_Vdi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vgm_si))-vs_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+(+psip_Vdi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vdbulk_di))-vs_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+(+psip_Vdi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vsbulk_si))-vs_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+(+psip_Vdi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vgi_bi))-vs_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+(+psip_Vdi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vdi_bi))-vs_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+(+psip_Vdi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vsi_bi))-vs_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+(+psip_Vdi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Tempt_GND))-vs_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=((psip_Vsi_bi-(2.0*phib_n_Vsi_bi))-vs_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+psip_Vsi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vsi_bi+2.0*0.0))-0.0);
  T1_Vsi_bi_Vgm_si=(+(+psip_Vsi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vgm_si))-vs_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+(+psip_Vsi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vdbulk_di))-vs_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+(+psip_Vsi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vsbulk_si))-vs_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+(+psip_Vsi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vgi_bi))-vs_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+(+psip_Vsi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vdi_bi))-vs_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+(+psip_Vsi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vsi_bi))-vs_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+(+psip_Vsi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Tempt_GND))-vs_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((psip_Tempt_GND-(2.0*phib_n_Tempt_GND))-vs_Tempt_GND);
#endif
#endif
T1=((psip-(2.0*phib_n))-vs);
EXIT_IF_ISNAN(((psip-(2.0*phib_n))-vs))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(T1_Vgi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgi_bi))));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_di));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_si));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdbulk_di));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsbulk_si));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(T1_Vdi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdi_bi))));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_di));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_si));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdbulk_di));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsbulk_si));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(T1_Vsi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsi_bi))));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_di));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_si));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdbulk_di));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsbulk_si));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Tempt_GND)*sqrtpsip)+((4.0*T0)*sqrtpsip_Tempt_GND))));
#endif
#endif
T2=(T1-bsimbulk_lln(((4.0*T0)*sqrtpsip)));
EXIT_IF_ISNAN((T1-bsimbulk_lln(((4.0*T0)*sqrtpsip))))
{
double m00_sqrt(d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=0.0;
  T8_Vdbulk_di_Vgm_si=0.0;
  T8_Vdbulk_di_Vdbulk_di=0.0;
  T8_Vdbulk_di_Vsbulk_si=0.0;
  T8_Vdbulk_di_Vgi_bi=0.0;
  T8_Vdbulk_di_Vdi_bi=0.0;
  T8_Vdbulk_di_Vsi_bi=0.0;
  T8_Vdbulk_di_Tempt_GND=0.0;
#endif
T8_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=0.0;
  T8_Vsbulk_si_Vgm_si=0.0;
  T8_Vsbulk_si_Vdbulk_di=0.0;
  T8_Vsbulk_si_Vsbulk_si=0.0;
  T8_Vsbulk_si_Vgi_bi=0.0;
  T8_Vsbulk_si_Vdi_bi=0.0;
  T8_Vsbulk_si_Vsi_bi=0.0;
  T8_Vsbulk_si_Tempt_GND=0.0;
#endif
T8_Vgi_bi=(0.5*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_di+0.0))+0.0))));
  T8_Vgi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_si+0.0))+0.0))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*(T2+0.402982)+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*(T2+0.402982)+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*(T2+0.402982)+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*(+T2_Vgi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vdi_bi=(0.5*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_di+0.0))+0.0))));
  T8_Vdi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_si+0.0))+0.0))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*(T2+0.402982)+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*(T2+0.402982)+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*(T2+0.402982)+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*(+T2_Vdi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsi_bi=(0.5*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_di+0.0))+0.0))));
  T8_Vsi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_si+0.0))+0.0))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*(T2+0.402982)+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*(T2+0.402982)+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*(T2+0.402982)+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*(+T2_Vsi_bi_Tempt_GND+0.0))+0.0))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(T2_Tempt_GND-((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((T2-0.201491)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T2-0.201491)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
sqrtpsisa_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_di_Vgm_di=0.0;
  sqrtpsisa_Vgm_di_Vgm_si=0.0;
  sqrtpsisa_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_di_Vgi_bi=0.0;
  sqrtpsisa_Vgm_di_Vdi_bi=0.0;
  sqrtpsisa_Vgm_di_Vsi_bi=0.0;
  sqrtpsisa_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisa_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_si_Vgm_di=0.0;
  sqrtpsisa_Vgm_si_Vgm_si=0.0;
  sqrtpsisa_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_si_Vgi_bi=0.0;
  sqrtpsisa_Vgm_si_Vdi_bi=0.0;
  sqrtpsisa_Vgm_si_Vsi_bi=0.0;
  sqrtpsisa_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisa_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdbulk_di_Vgm_di=0.0;
  sqrtpsisa_Vdbulk_di_Vgm_si=0.0;
  sqrtpsisa_Vdbulk_di_Vdbulk_di=0.0;
  sqrtpsisa_Vdbulk_di_Vsbulk_si=0.0;
  sqrtpsisa_Vdbulk_di_Vgi_bi=0.0;
  sqrtpsisa_Vdbulk_di_Vdi_bi=0.0;
  sqrtpsisa_Vdbulk_di_Vsi_bi=0.0;
  sqrtpsisa_Vdbulk_di_Tempt_GND=0.0;
#endif
sqrtpsisa_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsbulk_si_Vgm_di=0.0;
  sqrtpsisa_Vsbulk_si_Vgm_si=0.0;
  sqrtpsisa_Vsbulk_si_Vdbulk_di=0.0;
  sqrtpsisa_Vsbulk_si_Vsbulk_si=0.0;
  sqrtpsisa_Vsbulk_si_Vgi_bi=0.0;
  sqrtpsisa_Vsbulk_si_Vdi_bi=0.0;
  sqrtpsisa_Vsbulk_si_Vsi_bi=0.0;
  sqrtpsisa_Vsbulk_si_Tempt_GND=0.0;
#endif
sqrtpsisa_Vgi_bi=sqrtpsip_Vgi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgi_bi_Vgm_di=sqrtpsip_Vgi_bi_Vgm_di;
  sqrtpsisa_Vgi_bi_Vgm_si=sqrtpsip_Vgi_bi_Vgm_si;
  sqrtpsisa_Vgi_bi_Vdbulk_di=sqrtpsip_Vgi_bi_Vdbulk_di;
  sqrtpsisa_Vgi_bi_Vsbulk_si=sqrtpsip_Vgi_bi_Vsbulk_si;
  sqrtpsisa_Vgi_bi_Vgi_bi=sqrtpsip_Vgi_bi_Vgi_bi;
  sqrtpsisa_Vgi_bi_Vdi_bi=sqrtpsip_Vgi_bi_Vdi_bi;
  sqrtpsisa_Vgi_bi_Vsi_bi=sqrtpsip_Vgi_bi_Vsi_bi;
  sqrtpsisa_Vgi_bi_Tempt_GND=sqrtpsip_Vgi_bi_Tempt_GND;
#endif
sqrtpsisa_Vdi_bi=sqrtpsip_Vdi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdi_bi_Vgm_di=sqrtpsip_Vdi_bi_Vgm_di;
  sqrtpsisa_Vdi_bi_Vgm_si=sqrtpsip_Vdi_bi_Vgm_si;
  sqrtpsisa_Vdi_bi_Vdbulk_di=sqrtpsip_Vdi_bi_Vdbulk_di;
  sqrtpsisa_Vdi_bi_Vsbulk_si=sqrtpsip_Vdi_bi_Vsbulk_si;
  sqrtpsisa_Vdi_bi_Vgi_bi=sqrtpsip_Vdi_bi_Vgi_bi;
  sqrtpsisa_Vdi_bi_Vdi_bi=sqrtpsip_Vdi_bi_Vdi_bi;
  sqrtpsisa_Vdi_bi_Vsi_bi=sqrtpsip_Vdi_bi_Vsi_bi;
  sqrtpsisa_Vdi_bi_Tempt_GND=sqrtpsip_Vdi_bi_Tempt_GND;
#endif
sqrtpsisa_Vsi_bi=sqrtpsip_Vsi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsi_bi_Vgm_di=sqrtpsip_Vsi_bi_Vgm_di;
  sqrtpsisa_Vsi_bi_Vgm_si=sqrtpsip_Vsi_bi_Vgm_si;
  sqrtpsisa_Vsi_bi_Vdbulk_di=sqrtpsip_Vsi_bi_Vdbulk_di;
  sqrtpsisa_Vsi_bi_Vsbulk_si=sqrtpsip_Vsi_bi_Vsbulk_si;
  sqrtpsisa_Vsi_bi_Vgi_bi=sqrtpsip_Vsi_bi_Vgi_bi;
  sqrtpsisa_Vsi_bi_Vdi_bi=sqrtpsip_Vsi_bi_Vdi_bi;
  sqrtpsisa_Vsi_bi_Vsi_bi=sqrtpsip_Vsi_bi_Vsi_bi;
  sqrtpsisa_Vsi_bi_Tempt_GND=sqrtpsip_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
sqrtpsisa_Tempt_GND=sqrtpsip_Tempt_GND;
#endif
#endif
sqrtpsisa=sqrtpsip;
EXIT_IF_ISNAN(sqrtpsip)
if
((T8<=(-68.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=0.0;
#endif
#endif
T4=(-100.0);
EXIT_IF_ISNAN((-100.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=20.0;
EXIT_IF_ISNAN(20.0)
if
((T8<(T4-(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=0.0;
  T3_Vdi_bi_Vgm_di=0.0;
  T3_Vdi_bi_Vdbulk_di=0.0;
  T3_Vdi_bi_Vsbulk_si=0.0;
  T3_Vdi_bi_Vgi_bi=0.0;
  T3_Vdi_bi_Vdi_bi=0.0;
  T3_Vdi_bi_Vsi_bi=0.0;
  T3_Vdi_bi_Tempt_GND=0.0;
#endif
T3_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=0.0;
  T3_Vsi_bi_Vgm_di=0.0;
  T3_Vsi_bi_Vdbulk_di=0.0;
  T3_Vsi_bi_Vsbulk_si=0.0;
  T3_Vsi_bi_Vgi_bi=0.0;
  T3_Vsi_bi_Vdi_bi=0.0;
  T3_Vsi_bi_Vsi_bi=0.0;
  T3_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=0.0;
#endif
#endif
T3=bsimbulk_lexp(T4);
EXIT_IF_ISNAN(bsimbulk_lexp(T4))
}
else
{
if
((T8>(T4+(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(((T8_Vgi_bi-T4_Vgi_bi)*T5-(T8-T4)*T5_Vgi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=((+T8_Vgi_bi_Vgm_di-T4_Vgi_bi_Vgm_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vgi_bi_Vgm_si=((+T8_Vgi_bi_Vgm_si-T4_Vgi_bi_Vgm_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vgi_bi_Vdbulk_di=((+T8_Vgi_bi_Vdbulk_di-T4_Vgi_bi_Vdbulk_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgi_bi_Vsbulk_si=((+T8_Vgi_bi_Vsbulk_si-T4_Vgi_bi_Vsbulk_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgi_bi_Vgi_bi=((+T8_Vgi_bi_Vgi_bi-T4_Vgi_bi_Vgi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vgi_bi_Vdi_bi=((+T8_Vgi_bi_Vdi_bi-T4_Vgi_bi_Vdi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vgi_bi_Vsi_bi=((+T8_Vgi_bi_Vsi_bi-T4_Vgi_bi_Vsi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vgi_bi_Tempt_GND=((+T8_Vgi_bi_Tempt_GND-T4_Vgi_bi_Tempt_GND)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vdi_bi=(((T8_Vdi_bi-T4_Vdi_bi)*T5-(T8-T4)*T5_Vdi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=((+T8_Vdi_bi_Vgm_di-T4_Vdi_bi_Vgm_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vdi_bi_Vgm_si=((+T8_Vdi_bi_Vgm_si-T4_Vdi_bi_Vgm_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vdi_bi_Vdbulk_di=((+T8_Vdi_bi_Vdbulk_di-T4_Vdi_bi_Vdbulk_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdi_bi_Vsbulk_si=((+T8_Vdi_bi_Vsbulk_si-T4_Vdi_bi_Vsbulk_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdi_bi_Vgi_bi=((+T8_Vdi_bi_Vgi_bi-T4_Vdi_bi_Vgi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vdi_bi_Vdi_bi=((+T8_Vdi_bi_Vdi_bi-T4_Vdi_bi_Vdi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vdi_bi_Vsi_bi=((+T8_Vdi_bi_Vsi_bi-T4_Vdi_bi_Vsi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vdi_bi_Tempt_GND=((+T8_Vdi_bi_Tempt_GND-T4_Vdi_bi_Tempt_GND)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsi_bi=(((T8_Vsi_bi-T4_Vsi_bi)*T5-(T8-T4)*T5_Vsi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=((+T8_Vsi_bi_Vgm_di-T4_Vsi_bi_Vgm_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vsi_bi_Vgm_si=((+T8_Vsi_bi_Vgm_si-T4_Vsi_bi_Vgm_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vsi_bi_Vdbulk_di=((+T8_Vsi_bi_Vdbulk_di-T4_Vsi_bi_Vdbulk_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsi_bi_Vsbulk_si=((+T8_Vsi_bi_Vsbulk_si-T4_Vsi_bi_Vsbulk_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsi_bi_Vgi_bi=((+T8_Vsi_bi_Vgi_bi-T4_Vsi_bi_Vgi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vsi_bi_Vdi_bi=((+T8_Vsi_bi_Vdi_bi-T4_Vsi_bi_Vdi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vsi_bi_Vsi_bi=((+T8_Vsi_bi_Vsi_bi-T4_Vsi_bi_Vsi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vsi_bi_Tempt_GND=((+T8_Vsi_bi_Tempt_GND-T4_Vsi_bi_Tempt_GND)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((T8_Tempt_GND-T4_Tempt_GND)*T5-(T8-T4)*T5_Tempt_GND)/T5/T5);
#endif
#endif
T2=((T8-T4)/T5);
EXIT_IF_ISNAN(((T8-T4)/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND));
#endif
#endif
T6=(T2*T2);
EXIT_IF_ISNAN((T2*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgi_bi+((T5_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T4_Vgi_bi_Vgm_si+(+T5_Vgi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_si))+(+T6_Vgi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_si)))))));
  T3_Vgi_bi_Vgm_di=(+T4_Vgi_bi_Vgm_di+(+T5_Vgi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_di))+(+T6_Vgi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_di)))))));
  T3_Vgi_bi_Vdbulk_di=(+T4_Vgi_bi_Vdbulk_di+(+T5_Vgi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdbulk_di))+(+T6_Vgi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdbulk_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdbulk_di)))))));
  T3_Vgi_bi_Vsbulk_si=(+T4_Vgi_bi_Vsbulk_si+(+T5_Vgi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsbulk_si))+(+T6_Vgi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsbulk_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsbulk_si)))))));
  T3_Vgi_bi_Vgi_bi=(+T4_Vgi_bi_Vgi_bi+(+T5_Vgi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgi_bi))+(+T6_Vgi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgi_bi)))))));
  T3_Vgi_bi_Vdi_bi=(+T4_Vgi_bi_Vdi_bi+(+T5_Vgi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdi_bi))+(+T6_Vgi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdi_bi)))))));
  T3_Vgi_bi_Vsi_bi=(+T4_Vgi_bi_Vsi_bi+(+T5_Vgi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsi_bi))+(+T6_Vgi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsi_bi)))))));
  T3_Vgi_bi_Tempt_GND=(+T4_Vgi_bi_Tempt_GND+(+T5_Vgi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Tempt_GND))+(+T6_Vgi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Tempt_GND*(1.25-T6)+T6_Vgi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Tempt_GND)))))));
#endif
T3_Vdi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdi_bi+((T5_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T4_Vdi_bi_Vgm_si+(+T5_Vdi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_si))+(+T6_Vdi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_si)))))));
  T3_Vdi_bi_Vgm_di=(+T4_Vdi_bi_Vgm_di+(+T5_Vdi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_di))+(+T6_Vdi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_di)))))));
  T3_Vdi_bi_Vdbulk_di=(+T4_Vdi_bi_Vdbulk_di+(+T5_Vdi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdbulk_di))+(+T6_Vdi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdbulk_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdbulk_di)))))));
  T3_Vdi_bi_Vsbulk_si=(+T4_Vdi_bi_Vsbulk_si+(+T5_Vdi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsbulk_si))+(+T6_Vdi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsbulk_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsbulk_si)))))));
  T3_Vdi_bi_Vgi_bi=(+T4_Vdi_bi_Vgi_bi+(+T5_Vdi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgi_bi))+(+T6_Vdi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgi_bi)))))));
  T3_Vdi_bi_Vdi_bi=(+T4_Vdi_bi_Vdi_bi+(+T5_Vdi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdi_bi))+(+T6_Vdi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdi_bi)))))));
  T3_Vdi_bi_Vsi_bi=(+T4_Vdi_bi_Vsi_bi+(+T5_Vdi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsi_bi))+(+T6_Vdi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsi_bi)))))));
  T3_Vdi_bi_Tempt_GND=(+T4_Vdi_bi_Tempt_GND+(+T5_Vdi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Tempt_GND))+(+T6_Vdi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Tempt_GND*(1.25-T6)+T6_Vdi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Tempt_GND)))))));
#endif
T3_Vsi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsi_bi+((T5_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T4_Vsi_bi_Vgm_si+(+T5_Vsi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_si))+(+T6_Vsi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_si)))))));
  T3_Vsi_bi_Vgm_di=(+T4_Vsi_bi_Vgm_di+(+T5_Vsi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_di))+(+T6_Vsi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_di)))))));
  T3_Vsi_bi_Vdbulk_di=(+T4_Vsi_bi_Vdbulk_di+(+T5_Vsi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdbulk_di))+(+T6_Vsi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdbulk_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdbulk_di)))))));
  T3_Vsi_bi_Vsbulk_si=(+T4_Vsi_bi_Vsbulk_si+(+T5_Vsi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsbulk_si))+(+T6_Vsi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsbulk_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsbulk_si)))))));
  T3_Vsi_bi_Vgi_bi=(+T4_Vsi_bi_Vgi_bi+(+T5_Vsi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgi_bi))+(+T6_Vsi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgi_bi)))))));
  T3_Vsi_bi_Vdi_bi=(+T4_Vsi_bi_Vdi_bi+(+T5_Vsi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdi_bi))+(+T6_Vsi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdi_bi)))))));
  T3_Vsi_bi_Vsi_bi=(+T4_Vsi_bi_Vsi_bi+(+T5_Vsi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsi_bi))+(+T6_Vsi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsi_bi)))))));
  T3_Vsi_bi_Tempt_GND=(+T4_Vsi_bi_Tempt_GND+(+T5_Vsi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Tempt_GND))+(+T6_Vsi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Tempt_GND*(1.25-T6)+T6_Vsi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Tempt_GND)))))));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Tempt_GND+((T5_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Tempt_GND)+((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))));
#endif
#endif
T3=bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
EXIT_IF_ISNAN(bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qs_Vgm_si=0.0;
#if defined(_DERIVATE2)
  qs_Vgm_si_Vgm_si=0.0;
  qs_Vgm_si_Vgm_di=0.0;
  qs_Vgm_si_Vdbulk_di=0.0;
  qs_Vgm_si_Vsbulk_si=0.0;
  qs_Vgm_si_Vgi_bi=0.0;
  qs_Vgm_si_Vdi_bi=0.0;
  qs_Vgm_si_Vsi_bi=0.0;
  qs_Vgm_si_Tempt_GND=0.0;
#endif
qs_Vgm_di=0.0;
#if defined(_DERIVATE2)
  qs_Vgm_di_Vgm_si=0.0;
  qs_Vgm_di_Vgm_di=0.0;
  qs_Vgm_di_Vdbulk_di=0.0;
  qs_Vgm_di_Vsbulk_si=0.0;
  qs_Vgm_di_Vgi_bi=0.0;
  qs_Vgm_di_Vdi_bi=0.0;
  qs_Vgm_di_Vsi_bi=0.0;
  qs_Vgm_di_Tempt_GND=0.0;
#endif
qs_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  qs_Vdbulk_di_Vgm_si=0.0;
  qs_Vdbulk_di_Vgm_di=0.0;
  qs_Vdbulk_di_Vdbulk_di=0.0;
  qs_Vdbulk_di_Vsbulk_si=0.0;
  qs_Vdbulk_di_Vgi_bi=0.0;
  qs_Vdbulk_di_Vdi_bi=0.0;
  qs_Vdbulk_di_Vsi_bi=0.0;
  qs_Vdbulk_di_Tempt_GND=0.0;
#endif
qs_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  qs_Vsbulk_si_Vgm_si=0.0;
  qs_Vsbulk_si_Vgm_di=0.0;
  qs_Vsbulk_si_Vdbulk_di=0.0;
  qs_Vsbulk_si_Vsbulk_si=0.0;
  qs_Vsbulk_si_Vgi_bi=0.0;
  qs_Vsbulk_si_Vdi_bi=0.0;
  qs_Vsbulk_si_Vsi_bi=0.0;
  qs_Vsbulk_si_Tempt_GND=0.0;
#endif
qs_Vgi_bi=((T3_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))));
#if defined(_DERIVATE2)
  qs_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_si)-T8_Vgi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si)))));
  qs_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_di)-T8_Vgi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di)))));
  qs_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdbulk_di)-T8_Vgi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di)))));
  qs_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsbulk_si)-T8_Vgi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si)))));
  qs_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgi_bi)-T8_Vgi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi)))));
  qs_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdi_bi)-T8_Vgi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi)))));
  qs_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsi_bi)-T8_Vgi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi)))));
  qs_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Tempt_GND*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Tempt_GND)-T8_Vgi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND)))));
#endif
qs_Vdi_bi=((T3_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))));
#if defined(_DERIVATE2)
  qs_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_si)-T8_Vdi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si)))));
  qs_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_di)-T8_Vdi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di)))));
  qs_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdbulk_di)-T8_Vdi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di)))));
  qs_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsbulk_si)-T8_Vdi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si)))));
  qs_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgi_bi)-T8_Vdi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi)))));
  qs_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdi_bi)-T8_Vdi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi)))));
  qs_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsi_bi)-T8_Vdi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi)))));
  qs_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Tempt_GND*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Tempt_GND)-T8_Vdi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND)))));
#endif
qs_Vsi_bi=((T3_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))));
#if defined(_DERIVATE2)
  qs_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_si)-T8_Vsi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si)))));
  qs_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_di)-T8_Vsi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di)))));
  qs_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdbulk_di)-T8_Vsi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di)))));
  qs_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsbulk_si)-T8_Vsi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si)))));
  qs_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgi_bi)-T8_Vsi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi)))));
  qs_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdi_bi)-T8_Vsi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi)))));
  qs_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsi_bi)-T8_Vsi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi)))));
  qs_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Tempt_GND*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Tempt_GND)-T8_Vsi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND)))));
#endif
#if defined(_DERIVATE)
qs_Tempt_GND=((T3_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))));
#endif
#endif
qs=(T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
EXIT_IF_ISNAN((T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsisainv_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_di_Vgm_di=0.0;
  sqrtpsisainv_Vgm_di_Vgm_si=0.0;
  sqrtpsisainv_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_di_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_si_Vgm_di=0.0;
  sqrtpsisainv_Vgm_si_Vgm_si=0.0;
  sqrtpsisainv_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_si_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdbulk_di_Vgm_di=0.0;
  sqrtpsisainv_Vdbulk_di_Vgm_si=0.0;
  sqrtpsisainv_Vdbulk_di_Vdbulk_di=0.0;
  sqrtpsisainv_Vdbulk_di_Vsbulk_si=0.0;
  sqrtpsisainv_Vdbulk_di_Vgi_bi=0.0;
  sqrtpsisainv_Vdbulk_di_Vdi_bi=0.0;
  sqrtpsisainv_Vdbulk_di_Vsi_bi=0.0;
  sqrtpsisainv_Vdbulk_di_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsbulk_si_Vgm_di=0.0;
  sqrtpsisainv_Vsbulk_si_Vgm_si=0.0;
  sqrtpsisainv_Vsbulk_si_Vdbulk_di=0.0;
  sqrtpsisainv_Vsbulk_si_Vsbulk_si=0.0;
  sqrtpsisainv_Vsbulk_si_Vgi_bi=0.0;
  sqrtpsisainv_Vsbulk_si_Vdi_bi=0.0;
  sqrtpsisainv_Vsbulk_si_Vsi_bi=0.0;
  sqrtpsisainv_Vsbulk_si_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vgi_bi=(-sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vdi_bi=(-sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsi_bi=(-sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
#if defined(_DERIVATE)
sqrtpsisainv_Tempt_GND=(-sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa);
#endif
#endif
sqrtpsisainv=(1.0/sqrtpsisa);
EXIT_IF_ISNAN((1.0/sqrtpsisa))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T3_Vgi_bi-((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vdi_bi=(T3_Vdi_bi-((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsi_bi=(T3_Vsi_bi-((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T3_Tempt_GND-((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5));
#endif
#endif
T3=(T3-(T4/T5));
EXIT_IF_ISNAN((T3-(T4/T5)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=(((((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vdi_bi=(((((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsi_bi=(((((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#endif
#endif
T6=(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN((((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=0.0;
  T7_Vdbulk_di_Vgm_di=0.0;
  T7_Vdbulk_di_Vdbulk_di=0.0;
  T7_Vdbulk_di_Vsbulk_si=0.0;
  T7_Vdbulk_di_Vgi_bi=0.0;
  T7_Vdbulk_di_Vdi_bi=0.0;
  T7_Vdbulk_di_Vsi_bi=0.0;
  T7_Vdbulk_di_Tempt_GND=0.0;
#endif
T7_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=0.0;
  T7_Vsbulk_si_Vgm_di=0.0;
  T7_Vsbulk_si_Vdbulk_di=0.0;
  T7_Vsbulk_si_Vsbulk_si=0.0;
  T7_Vsbulk_si_Vgi_bi=0.0;
  T7_Vsbulk_si_Vdi_bi=0.0;
  T7_Vsbulk_si_Vsi_bi=0.0;
  T7_Vsbulk_si_Tempt_GND=0.0;
#endif
T7_Vgi_bi=(((-(((-T3_Vgi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgi_bi/T3/T3))))-(-((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi);
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_si);
  T7_Vgi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_di);
  T7_Vgi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdbulk_di);
  T7_Vgi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsbulk_si);
  T7_Vgi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgi_bi);
  T7_Vgi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdi_bi);
  T7_Vgi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsi_bi);
  T7_Vgi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Tempt_GND);
#endif
T7_Vdi_bi=(((-(((-T3_Vdi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdi_bi/T3/T3))))-(-((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi);
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_si);
  T7_Vdi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_di);
  T7_Vdi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdbulk_di);
  T7_Vdi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsbulk_si);
  T7_Vdi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgi_bi);
  T7_Vdi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdi_bi);
  T7_Vdi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsi_bi);
  T7_Vdi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Tempt_GND);
#endif
T7_Vsi_bi=(((-(((-T3_Vsi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsi_bi/T3/T3))))-(-((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi);
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_si);
  T7_Vsi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_di);
  T7_Vsi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdbulk_di);
  T7_Vsi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsbulk_si);
  T7_Vsi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgi_bi);
  T7_Vsi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdi_bi);
  T7_Vsi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsi_bi);
  T7_Vsi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(((-(((-T3_Tempt_GND/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Tempt_GND/T3/T3))))-(-((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Tempt_GND);
#endif
#endif
T7=(((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
EXIT_IF_ISNAN((((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qs_Vgm_si=0.0;
#if defined(_DERIVATE2)
  qs_Vgm_si_Vgm_si=0.0;
  qs_Vgm_si_Vgm_di=0.0;
  qs_Vgm_si_Vdbulk_di=0.0;
  qs_Vgm_si_Vsbulk_si=0.0;
  qs_Vgm_si_Vgi_bi=0.0;
  qs_Vgm_si_Vdi_bi=0.0;
  qs_Vgm_si_Vsi_bi=0.0;
  qs_Vgm_si_Tempt_GND=0.0;
#endif
qs_Vgm_di=0.0;
#if defined(_DERIVATE2)
  qs_Vgm_di_Vgm_si=0.0;
  qs_Vgm_di_Vgm_di=0.0;
  qs_Vgm_di_Vdbulk_di=0.0;
  qs_Vgm_di_Vsbulk_si=0.0;
  qs_Vgm_di_Vgi_bi=0.0;
  qs_Vgm_di_Vdi_bi=0.0;
  qs_Vgm_di_Vsi_bi=0.0;
  qs_Vgm_di_Tempt_GND=0.0;
#endif
qs_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  qs_Vdbulk_di_Vgm_si=0.0;
  qs_Vdbulk_di_Vgm_di=0.0;
  qs_Vdbulk_di_Vdbulk_di=0.0;
  qs_Vdbulk_di_Vsbulk_si=0.0;
  qs_Vdbulk_di_Vgi_bi=0.0;
  qs_Vdbulk_di_Vdi_bi=0.0;
  qs_Vdbulk_di_Vsi_bi=0.0;
  qs_Vdbulk_di_Tempt_GND=0.0;
#endif
qs_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  qs_Vsbulk_si_Vgm_si=0.0;
  qs_Vsbulk_si_Vgm_di=0.0;
  qs_Vsbulk_si_Vdbulk_di=0.0;
  qs_Vsbulk_si_Vsbulk_si=0.0;
  qs_Vsbulk_si_Vgi_bi=0.0;
  qs_Vsbulk_si_Vdi_bi=0.0;
  qs_Vsbulk_si_Vsi_bi=0.0;
  qs_Vsbulk_si_Tempt_GND=0.0;
#endif
qs_Vgi_bi=(T3_Vgi_bi-((((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(+(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_si*T7+T4_Vgi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_si)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(+(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_di*T7+T4_Vgi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_di)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(+(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdbulk_di*T7+T4_Vgi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdbulk_di)*T5+(2.0*T5_Vgi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(+(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsbulk_si*T7+T4_Vgi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsbulk_si)*T5+(2.0*T5_Vgi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(+(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgi_bi*T7+T4_Vgi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(+(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdi_bi*T7+T4_Vgi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(+(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsi_bi*T7+T4_Vgi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(+(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Tempt_GND*T7+T4_Vgi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vgi_bi+T4*T7_Vgi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Tempt_GND)*T5+(2.0*T5_Vgi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vdi_bi=(T3_Vdi_bi-((((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(+(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_si*T7+T4_Vdi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_si)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(+(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_di*T7+T4_Vdi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_di)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(+(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdbulk_di*T7+T4_Vdi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdbulk_di)*T5+(2.0*T5_Vdi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(+(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsbulk_si*T7+T4_Vdi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsbulk_si)*T5+(2.0*T5_Vdi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(+(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgi_bi*T7+T4_Vdi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(+(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdi_bi*T7+T4_Vdi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(+(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsi_bi*T7+T4_Vdi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(+(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Tempt_GND*T7+T4_Vdi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vdi_bi+T4*T7_Vdi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Tempt_GND)*T5+(2.0*T5_Vdi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vsi_bi=(T3_Vsi_bi-((((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(+(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_si*T7+T4_Vsi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_si)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(+(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_di*T7+T4_Vsi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_di)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(+(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdbulk_di*T7+T4_Vsi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdbulk_di)*T5+(2.0*T5_Vsi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(+(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsbulk_si*T7+T4_Vsi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsbulk_si)*T5+(2.0*T5_Vsi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(+(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgi_bi*T7+T4_Vsi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(+(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdi_bi*T7+T4_Vsi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(+(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsi_bi*T7+T4_Vsi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(+(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Tempt_GND*T7+T4_Vsi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vsi_bi+T4*T7_Vsi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Tempt_GND)*T5+(2.0*T5_Vsi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#if defined(_DERIVATE)
qs_Tempt_GND=(T3_Tempt_GND-((((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Tempt_GND)*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#endif
qs=(T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
EXIT_IF_ISNAN((T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))))
}
{
double m00_sqrt(d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
psipclamp_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psipclamp_Vgm_di_Vgm_di=0.0;
  psipclamp_Vgm_di_Vgm_si=0.0;
  psipclamp_Vgm_di_Vdbulk_di=0.0;
  psipclamp_Vgm_di_Vsbulk_si=0.0;
  psipclamp_Vgm_di_Vgi_bi=0.0;
  psipclamp_Vgm_di_Vdi_bi=0.0;
  psipclamp_Vgm_di_Vsi_bi=0.0;
  psipclamp_Vgm_di_Tempt_GND=0.0;
#endif
psipclamp_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psipclamp_Vgm_si_Vgm_di=0.0;
  psipclamp_Vgm_si_Vgm_si=0.0;
  psipclamp_Vgm_si_Vdbulk_di=0.0;
  psipclamp_Vgm_si_Vsbulk_si=0.0;
  psipclamp_Vgm_si_Vgi_bi=0.0;
  psipclamp_Vgm_si_Vdi_bi=0.0;
  psipclamp_Vgm_si_Vsi_bi=0.0;
  psipclamp_Vgm_si_Tempt_GND=0.0;
#endif
psipclamp_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  psipclamp_Vdbulk_di_Vgm_di=0.0;
  psipclamp_Vdbulk_di_Vgm_si=0.0;
  psipclamp_Vdbulk_di_Vdbulk_di=0.0;
  psipclamp_Vdbulk_di_Vsbulk_si=0.0;
  psipclamp_Vdbulk_di_Vgi_bi=0.0;
  psipclamp_Vdbulk_di_Vdi_bi=0.0;
  psipclamp_Vdbulk_di_Vsi_bi=0.0;
  psipclamp_Vdbulk_di_Tempt_GND=0.0;
#endif
psipclamp_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  psipclamp_Vsbulk_si_Vgm_di=0.0;
  psipclamp_Vsbulk_si_Vgm_si=0.0;
  psipclamp_Vsbulk_si_Vdbulk_di=0.0;
  psipclamp_Vsbulk_si_Vsbulk_si=0.0;
  psipclamp_Vsbulk_si_Vgi_bi=0.0;
  psipclamp_Vsbulk_si_Vdi_bi=0.0;
  psipclamp_Vsbulk_si_Vsi_bi=0.0;
  psipclamp_Vsbulk_si_Tempt_GND=0.0;
#endif
psipclamp_Vgi_bi=(0.5*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vgi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vdi_bi=(0.5*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vdi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vsi_bi=(0.5*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vsi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
psipclamp_Tempt_GND=(0.5*(psip_Tempt_GND+((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND))*d10_sqrt0));
#endif
#endif
psipclamp=(0.5*((psip+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psip+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,psipclamp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,psipclamp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=0.0;
  sqrtpsip_Vgm_di_Vgm_si=0.0;
  sqrtpsip_Vgm_di_Vdbulk_di=0.0;
  sqrtpsip_Vgm_di_Vsbulk_si=0.0;
  sqrtpsip_Vgm_di_Vgi_bi=0.0;
  sqrtpsip_Vgm_di_Vdi_bi=0.0;
  sqrtpsip_Vgm_di_Vsi_bi=0.0;
  sqrtpsip_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=0.0;
  sqrtpsip_Vgm_si_Vgm_si=0.0;
  sqrtpsip_Vgm_si_Vdbulk_di=0.0;
  sqrtpsip_Vgm_si_Vsbulk_si=0.0;
  sqrtpsip_Vgm_si_Vgi_bi=0.0;
  sqrtpsip_Vgm_si_Vdi_bi=0.0;
  sqrtpsip_Vgm_si_Vsi_bi=0.0;
  sqrtpsip_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=0.0;
  sqrtpsip_Vdbulk_di_Vgm_si=0.0;
  sqrtpsip_Vdbulk_di_Vdbulk_di=0.0;
  sqrtpsip_Vdbulk_di_Vsbulk_si=0.0;
  sqrtpsip_Vdbulk_di_Vgi_bi=0.0;
  sqrtpsip_Vdbulk_di_Vdi_bi=0.0;
  sqrtpsip_Vdbulk_di_Vsi_bi=0.0;
  sqrtpsip_Vdbulk_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=0.0;
  sqrtpsip_Vsbulk_si_Vgm_si=0.0;
  sqrtpsip_Vsbulk_si_Vdbulk_di=0.0;
  sqrtpsip_Vsbulk_si_Vsbulk_si=0.0;
  sqrtpsip_Vsbulk_si_Vgi_bi=0.0;
  sqrtpsip_Vsbulk_si_Vdi_bi=0.0;
  sqrtpsip_Vsbulk_si_Vsi_bi=0.0;
  sqrtpsip_Vsbulk_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vgi_bi=psipclamp_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=psipclamp_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=psipclamp_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=psipclamp_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
psiavg_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psiavg_Vgm_di_Vgm_di=0.0;
  psiavg_Vgm_di_Vgm_si=0.0;
  psiavg_Vgm_di_Vdbulk_di=0.0;
  psiavg_Vgm_di_Vsbulk_si=0.0;
  psiavg_Vgm_di_Vgi_bi=0.0;
  psiavg_Vgm_di_Vdi_bi=0.0;
  psiavg_Vgm_di_Vsi_bi=0.0;
  psiavg_Vgm_di_Tempt_GND=0.0;
#endif
psiavg_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psiavg_Vgm_si_Vgm_di=0.0;
  psiavg_Vgm_si_Vgm_si=0.0;
  psiavg_Vgm_si_Vdbulk_di=0.0;
  psiavg_Vgm_si_Vsbulk_si=0.0;
  psiavg_Vgm_si_Vgi_bi=0.0;
  psiavg_Vgm_si_Vdi_bi=0.0;
  psiavg_Vgm_si_Vsi_bi=0.0;
  psiavg_Vgm_si_Tempt_GND=0.0;
#endif
psiavg_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  psiavg_Vdbulk_di_Vgm_di=0.0;
  psiavg_Vdbulk_di_Vgm_si=0.0;
  psiavg_Vdbulk_di_Vdbulk_di=0.0;
  psiavg_Vdbulk_di_Vsbulk_si=0.0;
  psiavg_Vdbulk_di_Vgi_bi=0.0;
  psiavg_Vdbulk_di_Vdi_bi=0.0;
  psiavg_Vdbulk_di_Vsi_bi=0.0;
  psiavg_Vdbulk_di_Tempt_GND=0.0;
#endif
psiavg_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  psiavg_Vsbulk_si_Vgm_di=0.0;
  psiavg_Vsbulk_si_Vgm_si=0.0;
  psiavg_Vsbulk_si_Vdbulk_di=0.0;
  psiavg_Vsbulk_si_Vsbulk_si=0.0;
  psiavg_Vsbulk_si_Vgi_bi=0.0;
  psiavg_Vsbulk_si_Vdi_bi=0.0;
  psiavg_Vsbulk_si_Vsi_bi=0.0;
  psiavg_Vsbulk_si_Tempt_GND=0.0;
#endif
psiavg_Vgi_bi=(psip_Vgi_bi-(2.0*qs_Vgi_bi));
#if defined(_DERIVATE2)
  psiavg_Vgi_bi_Vgm_di=(+psip_Vgi_bi_Vgm_di-(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_di));
  psiavg_Vgi_bi_Vgm_si=(+psip_Vgi_bi_Vgm_si-(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_si));
  psiavg_Vgi_bi_Vdbulk_di=(+psip_Vgi_bi_Vdbulk_di-(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdbulk_di));
  psiavg_Vgi_bi_Vsbulk_si=(+psip_Vgi_bi_Vsbulk_si-(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsbulk_si));
  psiavg_Vgi_bi_Vgi_bi=(+psip_Vgi_bi_Vgi_bi-(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgi_bi));
  psiavg_Vgi_bi_Vdi_bi=(+psip_Vgi_bi_Vdi_bi-(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdi_bi));
  psiavg_Vgi_bi_Vsi_bi=(+psip_Vgi_bi_Vsi_bi-(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsi_bi));
  psiavg_Vgi_bi_Tempt_GND=(+psip_Vgi_bi_Tempt_GND-(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Tempt_GND));
#endif
psiavg_Vdi_bi=(psip_Vdi_bi-(2.0*qs_Vdi_bi));
#if defined(_DERIVATE2)
  psiavg_Vdi_bi_Vgm_di=(+psip_Vdi_bi_Vgm_di-(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_di));
  psiavg_Vdi_bi_Vgm_si=(+psip_Vdi_bi_Vgm_si-(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_si));
  psiavg_Vdi_bi_Vdbulk_di=(+psip_Vdi_bi_Vdbulk_di-(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdbulk_di));
  psiavg_Vdi_bi_Vsbulk_si=(+psip_Vdi_bi_Vsbulk_si-(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsbulk_si));
  psiavg_Vdi_bi_Vgi_bi=(+psip_Vdi_bi_Vgi_bi-(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgi_bi));
  psiavg_Vdi_bi_Vdi_bi=(+psip_Vdi_bi_Vdi_bi-(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdi_bi));
  psiavg_Vdi_bi_Vsi_bi=(+psip_Vdi_bi_Vsi_bi-(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsi_bi));
  psiavg_Vdi_bi_Tempt_GND=(+psip_Vdi_bi_Tempt_GND-(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Tempt_GND));
#endif
psiavg_Vsi_bi=(psip_Vsi_bi-(2.0*qs_Vsi_bi));
#if defined(_DERIVATE2)
  psiavg_Vsi_bi_Vgm_di=(+psip_Vsi_bi_Vgm_di-(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_di));
  psiavg_Vsi_bi_Vgm_si=(+psip_Vsi_bi_Vgm_si-(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_si));
  psiavg_Vsi_bi_Vdbulk_di=(+psip_Vsi_bi_Vdbulk_di-(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdbulk_di));
  psiavg_Vsi_bi_Vsbulk_si=(+psip_Vsi_bi_Vsbulk_si-(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsbulk_si));
  psiavg_Vsi_bi_Vgi_bi=(+psip_Vsi_bi_Vgi_bi-(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgi_bi));
  psiavg_Vsi_bi_Vdi_bi=(+psip_Vsi_bi_Vdi_bi-(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdi_bi));
  psiavg_Vsi_bi_Vsi_bi=(+psip_Vsi_bi_Vsi_bi-(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsi_bi));
  psiavg_Vsi_bi_Tempt_GND=(+psip_Vsi_bi_Tempt_GND-(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
psiavg_Tempt_GND=(psip_Tempt_GND-(2.0*qs_Tempt_GND));
#endif
#endif
psiavg=(psip-(2.0*qs));
EXIT_IF_ISNAN((psip-(2.0*qs)))
{
double m00_sqrt(d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(0.5*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vdi_bi=(0.5*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vsi_bi=(0.5*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(0.5*(psiavg_Tempt_GND+((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND))*d10_sqrt0));
#endif
#endif
T0=(0.5*((psiavg+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psiavg+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T0)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
nq_Vgm_si=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_si_Vgm_si=0.0;
  nq_Vgm_si_Vgm_di=0.0;
  nq_Vgm_si_Vdbulk_di=0.0;
  nq_Vgm_si_Vsbulk_si=0.0;
  nq_Vgm_si_Vgi_bi=0.0;
  nq_Vgm_si_Tempt_GND=0.0;
  nq_Vgm_si_Vdi_bi=0.0;
  nq_Vgm_si_Vsi_bi=0.0;
#endif
nq_Vgm_di=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_di_Vgm_si=0.0;
  nq_Vgm_di_Vgm_di=0.0;
  nq_Vgm_di_Vdbulk_di=0.0;
  nq_Vgm_di_Vsbulk_si=0.0;
  nq_Vgm_di_Vgi_bi=0.0;
  nq_Vgm_di_Tempt_GND=0.0;
  nq_Vgm_di_Vdi_bi=0.0;
  nq_Vgm_di_Vsi_bi=0.0;
#endif
nq_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  nq_Vdbulk_di_Vgm_si=0.0;
  nq_Vdbulk_di_Vgm_di=0.0;
  nq_Vdbulk_di_Vdbulk_di=0.0;
  nq_Vdbulk_di_Vsbulk_si=0.0;
  nq_Vdbulk_di_Vgi_bi=0.0;
  nq_Vdbulk_di_Tempt_GND=0.0;
  nq_Vdbulk_di_Vdi_bi=0.0;
  nq_Vdbulk_di_Vsi_bi=0.0;
#endif
nq_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  nq_Vsbulk_si_Vgm_si=0.0;
  nq_Vsbulk_si_Vgm_di=0.0;
  nq_Vsbulk_si_Vdbulk_di=0.0;
  nq_Vsbulk_si_Vsbulk_si=0.0;
  nq_Vsbulk_si_Vgi_bi=0.0;
  nq_Vsbulk_si_Tempt_GND=0.0;
  nq_Vsbulk_si_Vdi_bi=0.0;
  nq_Vsbulk_si_Vsi_bi=0.0;
#endif
nq_Vgi_bi=((gam_Vgi_bi*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)+gam_Vgm_si*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vgm_si+(m20_sqrt(T0)*T0_Vgm_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)+0.0*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vgm_di+(m20_sqrt(T0)*T0_Vgm_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam_Vdbulk_di*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vdbulk_di+(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdbulk_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam_Vsbulk_si*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vsbulk_si+(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsbulk_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam_Vgi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vgi_bi+(m20_sqrt(T0)*T0_Vgi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)+gam_Tempt_GND*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Tempt_GND+(m20_sqrt(T0)*T0_Tempt_GND*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Tempt_GND)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam_Vdi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vdi_bi+(m20_sqrt(T0)*T0_Vdi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam_Vsi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vsi_bi+(m20_sqrt(T0)*T0_Vsi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
#endif
#if defined(_DERIVATE)
nq_Tempt_GND=((gam_Tempt_GND*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#endif
nq_Vdi_bi=((gam_Vdi_bi*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)+gam_Vgm_si*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vgm_si+(m20_sqrt(T0)*T0_Vgm_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)+0.0*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vgm_di+(m20_sqrt(T0)*T0_Vgm_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam_Vdbulk_di*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vdbulk_di+(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdbulk_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam_Vsbulk_si*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vsbulk_si+(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsbulk_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam_Vgi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vgi_bi+(m20_sqrt(T0)*T0_Vgi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)+gam_Tempt_GND*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Tempt_GND+(m20_sqrt(T0)*T0_Tempt_GND*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Tempt_GND)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam_Vdi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vdi_bi+(m20_sqrt(T0)*T0_Vdi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam_Vsi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vsi_bi+(m20_sqrt(T0)*T0_Vsi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
#endif
nq_Vsi_bi=((gam_Vsi_bi*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)+gam_Vgm_si*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vgm_si+(m20_sqrt(T0)*T0_Vgm_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)+0.0*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vgm_di+(m20_sqrt(T0)*T0_Vgm_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam_Vdbulk_di*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vdbulk_di+(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdbulk_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam_Vsbulk_si*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vsbulk_si+(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsbulk_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam_Vgi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vgi_bi+(m20_sqrt(T0)*T0_Vgi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)+gam_Tempt_GND*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Tempt_GND+(m20_sqrt(T0)*T0_Tempt_GND*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Tempt_GND)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam_Vdi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vdi_bi+(m20_sqrt(T0)*T0_Vdi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam_Vsi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vsi_bi+(m20_sqrt(T0)*T0_Vsi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
#endif
#endif
nq=(1.0+(gam/(sqrtpsip+d00_sqrt0)));
EXIT_IF_ISNAN((1.0+(gam/(sqrtpsip+d00_sqrt0))))
}
EeffFactor=(1.0e-8/(epsratio*pModel->TOXE));
EXIT_IF_ISNAN((1.0e-8/(epsratio*pModel->TOXE)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=((nVt_Vgi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0))))+(nVt*((vgfb_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vgi_bi*((vgfb_Vgm_di-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((vgfb_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+nVt*(+(+vgfb_Vgi_bi_Vgm_di-psip_Vgi_bi_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_di)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vgm_di-0.0))));
  T0_Vgi_bi_Vgm_si=(+nVt_Vgi_bi_Vgm_si*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vgi_bi*((vgfb_Vgm_si-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+nVt_Vgm_si*((vgfb_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+nVt*(+(+vgfb_Vgi_bi_Vgm_si-psip_Vgi_bi_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_si)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vgm_si-0.0))));
  T0_Vgi_bi_Vdbulk_di=(+nVt_Vgi_bi_Vdbulk_di*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vgi_bi*((vgfb_Vdbulk_di-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+nVt_Vdbulk_di*((vgfb_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+nVt*(+(+vgfb_Vgi_bi_Vdbulk_di-psip_Vgi_bi_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vdbulk_di-0.0))));
  T0_Vgi_bi_Vsbulk_si=(+nVt_Vgi_bi_Vsbulk_si*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vgi_bi*((vgfb_Vsbulk_si-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+nVt_Vsbulk_si*((vgfb_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+nVt*(+(+vgfb_Vgi_bi_Vsbulk_si-psip_Vgi_bi_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vsbulk_si-0.0))));
  T0_Vgi_bi_Vgi_bi=(+nVt_Vgi_bi_Vgi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vgi_bi*((vgfb_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+nVt_Vgi_bi*((vgfb_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+nVt*(+(+vgfb_Vgi_bi_Vgi_bi-psip_Vgi_bi_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgi_bi)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vgi_bi-0.0))));
  T0_Vgi_bi_Vdi_bi=(+nVt_Vgi_bi_Vdi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vgi_bi*((vgfb_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+nVt_Vdi_bi*((vgfb_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+nVt*(+(+vgfb_Vgi_bi_Vdi_bi-psip_Vgi_bi_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdi_bi)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vdi_bi-0.0))));
  T0_Vgi_bi_Vsi_bi=(+nVt_Vgi_bi_Vsi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vgi_bi*((vgfb_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+nVt_Vsi_bi*((vgfb_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+nVt*(+(+vgfb_Vgi_bi_Vsi_bi-psip_Vgi_bi_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsi_bi)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vsi_bi-0.0))));
  T0_Vgi_bi_Tempt_GND=(+nVt_Vgi_bi_Tempt_GND*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vgi_bi*((vgfb_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+nVt_Tempt_GND*((vgfb_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+nVt*(+(+vgfb_Vgi_bi_Tempt_GND-psip_Vgi_bi_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Tempt_GND)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Tempt_GND-0.0))));
#endif
T0_Vdi_bi=((nVt_Vdi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0))))+(nVt*((vgfb_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vdi_bi*((vgfb_Vgm_di-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((vgfb_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+nVt*(+(+vgfb_Vdi_bi_Vgm_di-psip_Vdi_bi_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_di)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vgm_di-0.0))));
  T0_Vdi_bi_Vgm_si=(+nVt_Vdi_bi_Vgm_si*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vdi_bi*((vgfb_Vgm_si-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+nVt_Vgm_si*((vgfb_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+nVt*(+(+vgfb_Vdi_bi_Vgm_si-psip_Vdi_bi_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_si)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vgm_si-0.0))));
  T0_Vdi_bi_Vdbulk_di=(+nVt_Vdi_bi_Vdbulk_di*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vdi_bi*((vgfb_Vdbulk_di-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+nVt_Vdbulk_di*((vgfb_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+nVt*(+(+vgfb_Vdi_bi_Vdbulk_di-psip_Vdi_bi_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vdbulk_di-0.0))));
  T0_Vdi_bi_Vsbulk_si=(+nVt_Vdi_bi_Vsbulk_si*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vdi_bi*((vgfb_Vsbulk_si-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+nVt_Vsbulk_si*((vgfb_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+nVt*(+(+vgfb_Vdi_bi_Vsbulk_si-psip_Vdi_bi_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vsbulk_si-0.0))));
  T0_Vdi_bi_Vgi_bi=(+nVt_Vdi_bi_Vgi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vdi_bi*((vgfb_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+nVt_Vgi_bi*((vgfb_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+nVt*(+(+vgfb_Vdi_bi_Vgi_bi-psip_Vdi_bi_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgi_bi)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vgi_bi-0.0))));
  T0_Vdi_bi_Vdi_bi=(+nVt_Vdi_bi_Vdi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vdi_bi*((vgfb_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+nVt_Vdi_bi*((vgfb_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+nVt*(+(+vgfb_Vdi_bi_Vdi_bi-psip_Vdi_bi_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdi_bi)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vdi_bi-0.0))));
  T0_Vdi_bi_Vsi_bi=(+nVt_Vdi_bi_Vsi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vdi_bi*((vgfb_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+nVt_Vsi_bi*((vgfb_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+nVt*(+(+vgfb_Vdi_bi_Vsi_bi-psip_Vdi_bi_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsi_bi)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vsi_bi-0.0))));
  T0_Vdi_bi_Tempt_GND=(+nVt_Vdi_bi_Tempt_GND*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vdi_bi*((vgfb_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+nVt_Tempt_GND*((vgfb_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+nVt*(+(+vgfb_Vdi_bi_Tempt_GND-psip_Vdi_bi_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Tempt_GND)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Tempt_GND-0.0))));
#endif
T0_Vsi_bi=((nVt_Vsi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0))))+(nVt*((vgfb_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vsi_bi*((vgfb_Vgm_di-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((vgfb_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+nVt*(+(+vgfb_Vsi_bi_Vgm_di-psip_Vsi_bi_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_di)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vgm_di-0.0))));
  T0_Vsi_bi_Vgm_si=(+nVt_Vsi_bi_Vgm_si*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vsi_bi*((vgfb_Vgm_si-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+nVt_Vgm_si*((vgfb_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+nVt*(+(+vgfb_Vsi_bi_Vgm_si-psip_Vsi_bi_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_si)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vgm_si-0.0))));
  T0_Vsi_bi_Vdbulk_di=(+nVt_Vsi_bi_Vdbulk_di*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vsi_bi*((vgfb_Vdbulk_di-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+nVt_Vdbulk_di*((vgfb_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+nVt*(+(+vgfb_Vsi_bi_Vdbulk_di-psip_Vsi_bi_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vdbulk_di-0.0))));
  T0_Vsi_bi_Vsbulk_si=(+nVt_Vsi_bi_Vsbulk_si*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vsi_bi*((vgfb_Vsbulk_si-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+nVt_Vsbulk_si*((vgfb_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+nVt*(+(+vgfb_Vsi_bi_Vsbulk_si-psip_Vsi_bi_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vsbulk_si-0.0))));
  T0_Vsi_bi_Vgi_bi=(+nVt_Vsi_bi_Vgi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vsi_bi*((vgfb_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+nVt_Vgi_bi*((vgfb_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+nVt*(+(+vgfb_Vsi_bi_Vgi_bi-psip_Vsi_bi_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgi_bi)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vgi_bi-0.0))));
  T0_Vsi_bi_Vdi_bi=(+nVt_Vsi_bi_Vdi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vsi_bi*((vgfb_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+nVt_Vdi_bi*((vgfb_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+nVt*(+(+vgfb_Vsi_bi_Vdi_bi-psip_Vsi_bi_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdi_bi)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vdi_bi-0.0))));
  T0_Vsi_bi_Vsi_bi=(+nVt_Vsi_bi_Vsi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vsi_bi*((vgfb_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+nVt_Vsi_bi*((vgfb_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+nVt*(+(+vgfb_Vsi_bi_Vsi_bi-psip_Vsi_bi_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsi_bi)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vsi_bi-0.0))));
  T0_Vsi_bi_Tempt_GND=(+nVt_Vsi_bi_Tempt_GND*((vgfb-psip)-((2.0*qs)*(nq-1.0)))+nVt_Vsi_bi*((vgfb_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+nVt_Tempt_GND*((vgfb_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+nVt*(+(+vgfb_Vsi_bi_Tempt_GND-psip_Vsi_bi_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Tempt_GND)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Tempt_GND-0.0))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((nVt_Tempt_GND*((vgfb-psip)-((2.0*qs)*(nq-1.0))))+(nVt*((vgfb_Tempt_GND-psip_Tempt_GND)-(((2.0*qs_Tempt_GND)*(nq-1.0))+((2.0*qs)*nq_Tempt_GND)))));
#endif
#endif
T0=(nVt*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
EXIT_IF_ISNAN((nVt*((vgfb-psip)-((2.0*qs)*(nq-1.0)))))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+((0.25*0.1)*0.1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+((0.25*0.1)*0.1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
qbs_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  qbs_Vdbulk_di_Vdbulk_di=0.0;
  qbs_Vdbulk_di_Vsbulk_si=0.0;
  qbs_Vdbulk_di_Vgi_bi=0.0;
  qbs_Vdbulk_di_Vdi_bi=0.0;
  qbs_Vdbulk_di_Vsi_bi=0.0;
  qbs_Vdbulk_di_Tempt_GND=0.0;
#endif
qbs_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  qbs_Vsbulk_si_Vdbulk_di=0.0;
  qbs_Vsbulk_si_Vsbulk_si=0.0;
  qbs_Vsbulk_si_Vgi_bi=0.0;
  qbs_Vsbulk_si_Vdi_bi=0.0;
  qbs_Vsbulk_si_Vsi_bi=0.0;
  qbs_Vsbulk_si_Tempt_GND=0.0;
#endif
qbs_Vgi_bi=(0.5*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vgi_bi_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vdbulk_di-0.0)*T0+T0_Vgi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vsbulk_si-0.0)*T0+T0_Vgi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vgi_bi-0.0)*T0+T0_Vgi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vdi_bi-0.0)*T0+T0_Vgi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vsi_bi-0.0)*T0+T0_Vgi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Tempt_GND-0.0)*T0+T0_Vgi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vgi_bi+T0*(+T0_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vdi_bi=(0.5*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vdi_bi_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vdbulk_di-0.0)*T0+T0_Vdi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vsbulk_si-0.0)*T0+T0_Vdi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vgi_bi-0.0)*T0+T0_Vdi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vdi_bi-0.0)*T0+T0_Vdi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vsi_bi-0.0)*T0+T0_Vdi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Tempt_GND-0.0)*T0+T0_Vdi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_bi+T0*(+T0_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vsi_bi=(0.5*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vsi_bi_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vdbulk_di-0.0)*T0+T0_Vsi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vsbulk_si-0.0)*T0+T0_Vsi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vgi_bi-0.0)*T0+T0_Vsi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vdi_bi-0.0)*T0+T0_Vsi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vsi_bi-0.0)*T0+T0_Vsi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Tempt_GND-0.0)*T0+T0_Vsi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vsi_bi+T0*(+T0_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
#if defined(_DERIVATE)
qbs_Tempt_GND=(0.5*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0));
#endif
#endif
qbs=(0.5*(T0+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T0+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
qis_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  qis_Vdbulk_di_Vdbulk_di=0.0;
  qis_Vdbulk_di_Vsbulk_si=0.0;
  qis_Vdbulk_di_Vgi_bi=0.0;
  qis_Vdbulk_di_Tempt_GND=0.0;
  qis_Vdbulk_di_Vdi_bi=0.0;
  qis_Vdbulk_di_Vsi_bi=0.0;
#endif
qis_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  qis_Vsbulk_si_Vdbulk_di=0.0;
  qis_Vsbulk_si_Vsbulk_si=0.0;
  qis_Vsbulk_si_Vgi_bi=0.0;
  qis_Vsbulk_si_Tempt_GND=0.0;
  qis_Vsbulk_si_Vdi_bi=0.0;
  qis_Vsbulk_si_Vsi_bi=0.0;
#endif
qis_Vgi_bi=(((((2.0*nq_Vgi_bi)*nVt)+((2.0*nq)*nVt_Vgi_bi))*qs)+(((2.0*nq)*nVt)*qs_Vgi_bi));
#if defined(_DERIVATE2)
  qis_Vgi_bi_Vdbulk_di=(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdbulk_di)*nVt+(2.0*nq_Vgi_bi)*nVt_Vdbulk_di+((2.0*nq_Vdbulk_di))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Vdbulk_di)*qs+(((2.0*nq_Vgi_bi)*nVt)+((2.0*nq)*nVt_Vgi_bi))*qs_Vdbulk_di+(((((2.0*nq_Vdbulk_di))*nVt)+((2.0*nq)*nVt_Vdbulk_di)))*qs_Vgi_bi+((2.0*nq)*nVt)*qs_Vgi_bi_Vdbulk_di);
  qis_Vgi_bi_Vsbulk_si=(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsbulk_si)*nVt+(2.0*nq_Vgi_bi)*nVt_Vsbulk_si+((2.0*nq_Vsbulk_si))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Vsbulk_si)*qs+(((2.0*nq_Vgi_bi)*nVt)+((2.0*nq)*nVt_Vgi_bi))*qs_Vsbulk_si+(((((2.0*nq_Vsbulk_si))*nVt)+((2.0*nq)*nVt_Vsbulk_si)))*qs_Vgi_bi+((2.0*nq)*nVt)*qs_Vgi_bi_Vsbulk_si);
  qis_Vgi_bi_Vgi_bi=(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vgi_bi)*nVt+(2.0*nq_Vgi_bi)*nVt_Vgi_bi+((2.0*nq_Vgi_bi))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Vgi_bi)*qs+(((2.0*nq_Vgi_bi)*nVt)+((2.0*nq)*nVt_Vgi_bi))*qs_Vgi_bi+(((((2.0*nq_Vgi_bi))*nVt)+((2.0*nq)*nVt_Vgi_bi)))*qs_Vgi_bi+((2.0*nq)*nVt)*qs_Vgi_bi_Vgi_bi);
  qis_Vgi_bi_Tempt_GND=(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Tempt_GND)*nVt+(2.0*nq_Vgi_bi)*nVt_Tempt_GND+((2.0*nq_Tempt_GND))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Tempt_GND)*qs+(((2.0*nq_Vgi_bi)*nVt)+((2.0*nq)*nVt_Vgi_bi))*qs_Tempt_GND+(((((2.0*nq_Tempt_GND))*nVt)+((2.0*nq)*nVt_Tempt_GND)))*qs_Vgi_bi+((2.0*nq)*nVt)*qs_Vgi_bi_Tempt_GND);
  qis_Vgi_bi_Vdi_bi=(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdi_bi)*nVt+(2.0*nq_Vgi_bi)*nVt_Vdi_bi+((2.0*nq_Vdi_bi))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Vdi_bi)*qs+(((2.0*nq_Vgi_bi)*nVt)+((2.0*nq)*nVt_Vgi_bi))*qs_Vdi_bi+(((((2.0*nq_Vdi_bi))*nVt)+((2.0*nq)*nVt_Vdi_bi)))*qs_Vgi_bi+((2.0*nq)*nVt)*qs_Vgi_bi_Vdi_bi);
  qis_Vgi_bi_Vsi_bi=(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsi_bi)*nVt+(2.0*nq_Vgi_bi)*nVt_Vsi_bi+((2.0*nq_Vsi_bi))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Vsi_bi)*qs+(((2.0*nq_Vgi_bi)*nVt)+((2.0*nq)*nVt_Vgi_bi))*qs_Vsi_bi+(((((2.0*nq_Vsi_bi))*nVt)+((2.0*nq)*nVt_Vsi_bi)))*qs_Vgi_bi+((2.0*nq)*nVt)*qs_Vgi_bi_Vsi_bi);
#endif
#if defined(_DERIVATE)
qis_Tempt_GND=(((((2.0*nq_Tempt_GND)*nVt)+((2.0*nq)*nVt_Tempt_GND))*qs)+(((2.0*nq)*nVt)*qs_Tempt_GND));
#endif
qis_Vdi_bi=(((((2.0*nq_Vdi_bi)*nVt)+((2.0*nq)*nVt_Vdi_bi))*qs)+(((2.0*nq)*nVt)*qs_Vdi_bi));
#if defined(_DERIVATE2)
  qis_Vdi_bi_Vdbulk_di=(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdbulk_di)*nVt+(2.0*nq_Vdi_bi)*nVt_Vdbulk_di+((2.0*nq_Vdbulk_di))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Vdbulk_di)*qs+(((2.0*nq_Vdi_bi)*nVt)+((2.0*nq)*nVt_Vdi_bi))*qs_Vdbulk_di+(((((2.0*nq_Vdbulk_di))*nVt)+((2.0*nq)*nVt_Vdbulk_di)))*qs_Vdi_bi+((2.0*nq)*nVt)*qs_Vdi_bi_Vdbulk_di);
  qis_Vdi_bi_Vsbulk_si=(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsbulk_si)*nVt+(2.0*nq_Vdi_bi)*nVt_Vsbulk_si+((2.0*nq_Vsbulk_si))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Vsbulk_si)*qs+(((2.0*nq_Vdi_bi)*nVt)+((2.0*nq)*nVt_Vdi_bi))*qs_Vsbulk_si+(((((2.0*nq_Vsbulk_si))*nVt)+((2.0*nq)*nVt_Vsbulk_si)))*qs_Vdi_bi+((2.0*nq)*nVt)*qs_Vdi_bi_Vsbulk_si);
  qis_Vdi_bi_Vgi_bi=(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vgi_bi)*nVt+(2.0*nq_Vdi_bi)*nVt_Vgi_bi+((2.0*nq_Vgi_bi))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Vgi_bi)*qs+(((2.0*nq_Vdi_bi)*nVt)+((2.0*nq)*nVt_Vdi_bi))*qs_Vgi_bi+(((((2.0*nq_Vgi_bi))*nVt)+((2.0*nq)*nVt_Vgi_bi)))*qs_Vdi_bi+((2.0*nq)*nVt)*qs_Vdi_bi_Vgi_bi);
  qis_Vdi_bi_Tempt_GND=(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Tempt_GND)*nVt+(2.0*nq_Vdi_bi)*nVt_Tempt_GND+((2.0*nq_Tempt_GND))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Tempt_GND)*qs+(((2.0*nq_Vdi_bi)*nVt)+((2.0*nq)*nVt_Vdi_bi))*qs_Tempt_GND+(((((2.0*nq_Tempt_GND))*nVt)+((2.0*nq)*nVt_Tempt_GND)))*qs_Vdi_bi+((2.0*nq)*nVt)*qs_Vdi_bi_Tempt_GND);
  qis_Vdi_bi_Vdi_bi=(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdi_bi)*nVt+(2.0*nq_Vdi_bi)*nVt_Vdi_bi+((2.0*nq_Vdi_bi))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Vdi_bi)*qs+(((2.0*nq_Vdi_bi)*nVt)+((2.0*nq)*nVt_Vdi_bi))*qs_Vdi_bi+(((((2.0*nq_Vdi_bi))*nVt)+((2.0*nq)*nVt_Vdi_bi)))*qs_Vdi_bi+((2.0*nq)*nVt)*qs_Vdi_bi_Vdi_bi);
  qis_Vdi_bi_Vsi_bi=(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsi_bi)*nVt+(2.0*nq_Vdi_bi)*nVt_Vsi_bi+((2.0*nq_Vsi_bi))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Vsi_bi)*qs+(((2.0*nq_Vdi_bi)*nVt)+((2.0*nq)*nVt_Vdi_bi))*qs_Vsi_bi+(((((2.0*nq_Vsi_bi))*nVt)+((2.0*nq)*nVt_Vsi_bi)))*qs_Vdi_bi+((2.0*nq)*nVt)*qs_Vdi_bi_Vsi_bi);
#endif
qis_Vsi_bi=(((((2.0*nq_Vsi_bi)*nVt)+((2.0*nq)*nVt_Vsi_bi))*qs)+(((2.0*nq)*nVt)*qs_Vsi_bi));
#if defined(_DERIVATE2)
  qis_Vsi_bi_Vdbulk_di=(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdbulk_di)*nVt+(2.0*nq_Vsi_bi)*nVt_Vdbulk_di+((2.0*nq_Vdbulk_di))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Vdbulk_di)*qs+(((2.0*nq_Vsi_bi)*nVt)+((2.0*nq)*nVt_Vsi_bi))*qs_Vdbulk_di+(((((2.0*nq_Vdbulk_di))*nVt)+((2.0*nq)*nVt_Vdbulk_di)))*qs_Vsi_bi+((2.0*nq)*nVt)*qs_Vsi_bi_Vdbulk_di);
  qis_Vsi_bi_Vsbulk_si=(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsbulk_si)*nVt+(2.0*nq_Vsi_bi)*nVt_Vsbulk_si+((2.0*nq_Vsbulk_si))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Vsbulk_si)*qs+(((2.0*nq_Vsi_bi)*nVt)+((2.0*nq)*nVt_Vsi_bi))*qs_Vsbulk_si+(((((2.0*nq_Vsbulk_si))*nVt)+((2.0*nq)*nVt_Vsbulk_si)))*qs_Vsi_bi+((2.0*nq)*nVt)*qs_Vsi_bi_Vsbulk_si);
  qis_Vsi_bi_Vgi_bi=(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vgi_bi)*nVt+(2.0*nq_Vsi_bi)*nVt_Vgi_bi+((2.0*nq_Vgi_bi))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Vgi_bi)*qs+(((2.0*nq_Vsi_bi)*nVt)+((2.0*nq)*nVt_Vsi_bi))*qs_Vgi_bi+(((((2.0*nq_Vgi_bi))*nVt)+((2.0*nq)*nVt_Vgi_bi)))*qs_Vsi_bi+((2.0*nq)*nVt)*qs_Vsi_bi_Vgi_bi);
  qis_Vsi_bi_Tempt_GND=(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Tempt_GND)*nVt+(2.0*nq_Vsi_bi)*nVt_Tempt_GND+((2.0*nq_Tempt_GND))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Tempt_GND)*qs+(((2.0*nq_Vsi_bi)*nVt)+((2.0*nq)*nVt_Vsi_bi))*qs_Tempt_GND+(((((2.0*nq_Tempt_GND))*nVt)+((2.0*nq)*nVt_Tempt_GND)))*qs_Vsi_bi+((2.0*nq)*nVt)*qs_Vsi_bi_Tempt_GND);
  qis_Vsi_bi_Vdi_bi=(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdi_bi)*nVt+(2.0*nq_Vsi_bi)*nVt_Vdi_bi+((2.0*nq_Vdi_bi))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Vdi_bi)*qs+(((2.0*nq_Vsi_bi)*nVt)+((2.0*nq)*nVt_Vsi_bi))*qs_Vdi_bi+(((((2.0*nq_Vdi_bi))*nVt)+((2.0*nq)*nVt_Vdi_bi)))*qs_Vsi_bi+((2.0*nq)*nVt)*qs_Vsi_bi_Vdi_bi);
  qis_Vsi_bi_Vsi_bi=(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsi_bi)*nVt+(2.0*nq_Vsi_bi)*nVt_Vsi_bi+((2.0*nq_Vsi_bi))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Vsi_bi)*qs+(((2.0*nq_Vsi_bi)*nVt)+((2.0*nq)*nVt_Vsi_bi))*qs_Vsi_bi+(((((2.0*nq_Vsi_bi))*nVt)+((2.0*nq)*nVt_Vsi_bi)))*qs_Vsi_bi+((2.0*nq)*nVt)*qs_Vsi_bi_Vsi_bi);
#endif
#endif
qis=(((2.0*nq)*nVt)*qs);
EXIT_IF_ISNAN((((2.0*nq)*nVt)*qs))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
Eeffs_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Eeffs_Vdbulk_di_Vdbulk_di=0.0;
  Eeffs_Vdbulk_di_Vsbulk_si=0.0;
  Eeffs_Vdbulk_di_Vgi_bi=0.0;
  Eeffs_Vdbulk_di_Vdi_bi=0.0;
  Eeffs_Vdbulk_di_Vsi_bi=0.0;
  Eeffs_Vdbulk_di_Tempt_GND=0.0;
#endif
Eeffs_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Eeffs_Vsbulk_si_Vdbulk_di=0.0;
  Eeffs_Vsbulk_si_Vsbulk_si=0.0;
  Eeffs_Vsbulk_si_Vgi_bi=0.0;
  Eeffs_Vsbulk_si_Vdi_bi=0.0;
  Eeffs_Vsbulk_si_Vsi_bi=0.0;
  Eeffs_Vsbulk_si_Tempt_GND=0.0;
#endif
Eeffs_Vgi_bi=(EeffFactor*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi)));
#if defined(_DERIVATE2)
  Eeffs_Vgi_bi_Vdbulk_di=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdbulk_di+((eta_mu*qis_Vdbulk_di)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vdbulk_di+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vdbulk_di)));
  Eeffs_Vgi_bi_Vsbulk_si=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsbulk_si+((eta_mu*qis_Vsbulk_si)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vsbulk_si+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vsbulk_si)));
  Eeffs_Vgi_bi_Vgi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vgi_bi+((eta_mu*qis_Vgi_bi)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vgi_bi+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vgi_bi)));
  Eeffs_Vgi_bi_Vdi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdi_bi+((eta_mu*qis_Vdi_bi)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vdi_bi+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vdi_bi)));
  Eeffs_Vgi_bi_Vsi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsi_bi+((eta_mu*qis_Vsi_bi)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vsi_bi+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vsi_bi)));
  Eeffs_Vgi_bi_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Tempt_GND+((eta_mu*qis_Tempt_GND)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Tempt_GND+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Tempt_GND)));
#endif
Eeffs_Vdi_bi=(EeffFactor*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi)));
#if defined(_DERIVATE2)
  Eeffs_Vdi_bi_Vdbulk_di=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdbulk_di+((eta_mu*qis_Vdbulk_di)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vdbulk_di+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vdbulk_di)));
  Eeffs_Vdi_bi_Vsbulk_si=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsbulk_si+((eta_mu*qis_Vsbulk_si)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vsbulk_si+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vsbulk_si)));
  Eeffs_Vdi_bi_Vgi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vgi_bi+((eta_mu*qis_Vgi_bi)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vgi_bi+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vgi_bi)));
  Eeffs_Vdi_bi_Vdi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdi_bi+((eta_mu*qis_Vdi_bi)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vdi_bi+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vdi_bi)));
  Eeffs_Vdi_bi_Vsi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsi_bi+((eta_mu*qis_Vsi_bi)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vsi_bi+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vsi_bi)));
  Eeffs_Vdi_bi_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Tempt_GND+((eta_mu*qis_Tempt_GND)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Tempt_GND+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Tempt_GND)));
#endif
Eeffs_Vsi_bi=(EeffFactor*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi)));
#if defined(_DERIVATE2)
  Eeffs_Vsi_bi_Vdbulk_di=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdbulk_di+((eta_mu*qis_Vdbulk_di)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vdbulk_di+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vdbulk_di)));
  Eeffs_Vsi_bi_Vsbulk_si=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsbulk_si+((eta_mu*qis_Vsbulk_si)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vsbulk_si+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vsbulk_si)));
  Eeffs_Vsi_bi_Vgi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vgi_bi+((eta_mu*qis_Vgi_bi)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vgi_bi+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vgi_bi)));
  Eeffs_Vsi_bi_Vdi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdi_bi+((eta_mu*qis_Vdi_bi)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vdi_bi+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vdi_bi)));
  Eeffs_Vsi_bi_Vsi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsi_bi+((eta_mu*qis_Vsi_bi)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vsi_bi+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vsi_bi)));
  Eeffs_Vsi_bi_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Tempt_GND+((eta_mu*qis_Tempt_GND)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Tempt_GND+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
Eeffs_Tempt_GND=(EeffFactor*(qbs_Tempt_GND+(eta_mu*qis_Tempt_GND)));
#endif
#endif
Eeffs=(EeffFactor*(qbs+(eta_mu*qis)));
EXIT_IF_ISNAN((EeffFactor*(qbs+(eta_mu*qis))))
{
double m00_pow(d00_pow0,(0.5*(1.0+(qis/qbs))),UCS_a)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(0.5*(1.0+(qis/qbs))),UCS_a)
double m11_pow(d11_pow0,d00_pow0,(0.5*(1.0+(qis/qbs))),UCS_a)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(d10_pow0*(0.5*((qis_Vgi_bi*qbs-qis*qbs_Vgi_bi)/qbs/qbs)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=fixme;
  T2_Vgi_bi_Vgm_si=fixme;
  T2_Vgi_bi_Vdbulk_di=fixme;
  T2_Vgi_bi_Vsbulk_si=fixme;
  T2_Vgi_bi_Vgi_bi=fixme;
  T2_Vgi_bi_Vdi_bi=fixme;
  T2_Vgi_bi_Vsi_bi=fixme;
  T2_Vgi_bi_Tempt_GND=fixme;
#endif
T2_Vdi_bi=(d10_pow0*(0.5*((qis_Vdi_bi*qbs-qis*qbs_Vdi_bi)/qbs/qbs))+d11_pow0*UCS_a_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=fixme;
  T2_Vdi_bi_Vgm_si=fixme;
  T2_Vdi_bi_Vdbulk_di=fixme;
  T2_Vdi_bi_Vsbulk_si=fixme;
  T2_Vdi_bi_Vgi_bi=fixme;
  T2_Vdi_bi_Vdi_bi=fixme;
  T2_Vdi_bi_Vsi_bi=fixme;
  T2_Vdi_bi_Tempt_GND=fixme;
#endif
T2_Vsi_bi=(d10_pow0*(0.5*((qis_Vsi_bi*qbs-qis*qbs_Vsi_bi)/qbs/qbs))+d11_pow0*UCS_a_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=fixme;
  T2_Vsi_bi_Vgm_si=fixme;
  T2_Vsi_bi_Vdbulk_di=fixme;
  T2_Vsi_bi_Vsbulk_si=fixme;
  T2_Vsi_bi_Vgi_bi=fixme;
  T2_Vsi_bi_Vdi_bi=fixme;
  T2_Vsi_bi_Vsi_bi=fixme;
  T2_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(d10_pow0*(0.5*((qis_Tempt_GND*qbs-qis*qbs_Tempt_GND)/qbs/qbs))+d11_pow0*UCS_a_Tempt_GND);
#endif
#endif
T2=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,Eeffs,EU_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,Eeffs,EU_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Vgi_bi))+(-UD_a*T2_Vgi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vgm_si)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vgi_bi_Vgm_di=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vgm_di)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vgi_bi_Vdbulk_di=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vdbulk_di)+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vgi_bi_Vsbulk_si=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vsbulk_si)+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vgi_bi_Vgi_bi=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vgi_bi)+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vgi_bi)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vgi_bi_Vdi_bi=(+(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+UC_a_Vdi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vdi_bi+UD_a_Vdi_bi*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vdi_bi)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vgi_bi_Vsi_bi=(+(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+UC_a_Vsi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vsi_bi+UD_a_Vsi_bi*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vsi_bi)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vgi_bi_Tempt_GND=(+(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vgi_bi+UD_a*T2_Vgi_bi_Tempt_GND)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vdi_bi=((((UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Vdi_bi)))+((UD_a_Vdi_bi*T2-UD_a*T2_Vdi_bi)/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*0.0+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vgm_si+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vgm_si)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vdi_bi_Vgm_di=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*0.0+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vgm_di+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vgm_di)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vdi_bi_Vdbulk_di=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vdbulk_di)+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vdbulk_di+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vdi_bi_Vsbulk_si=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vsbulk_si)+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vsbulk_si+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vdi_bi_Vgi_bi=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vgi_bi)+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vgi_bi+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vgi_bi)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vdi_bi_Vdi_bi=(+(+(+UA_a_Vdi_bi_Vdi_bi+(+UC_a_Vdi_bi_Vdi_bi*Vbsx+UC_a_Vdi_bi*Vbsx_Vdi_bi+UC_a_Vdi_bi*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Vdi_bi))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vdi_bi_Vdi_bi/T2-(UD_a_Vdi_bi*T2_Vdi_bi+UD_a_Vdi_bi*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vdi_bi)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vdi_bi_Vsi_bi=(+(+(+UA_a_Vdi_bi_Vsi_bi+(+UC_a_Vdi_bi_Vsi_bi*Vbsx+UC_a_Vdi_bi*Vbsx_Vsi_bi+UC_a_Vsi_bi*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Vsi_bi))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vdi_bi_Vsi_bi/T2-(UD_a_Vdi_bi*T2_Vsi_bi+UD_a_Vsi_bi*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vsi_bi)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vdi_bi_Tempt_GND=(+(+(+UA_a_Vdi_bi_Tempt_GND+(+UC_a_Vdi_bi_Tempt_GND*Vbsx+UC_a_Vdi_bi*Vbsx_Tempt_GND+UC_a_Tempt_GND*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Tempt_GND))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vdi_bi_Tempt_GND/T2-(UD_a_Vdi_bi*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vdi_bi+UD_a*T2_Vdi_bi_Tempt_GND)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vsi_bi=((((UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Vsi_bi)))+((UD_a_Vsi_bi*T2-UD_a*T2_Vsi_bi)/T2/T2));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*0.0+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vgm_si+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vgm_si)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vsi_bi_Vgm_di=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*0.0+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vgm_di+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vgm_di)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vsi_bi_Vdbulk_di=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vdbulk_di)+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vdbulk_di+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vsi_bi_Vsbulk_si=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vsbulk_si)+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vsbulk_si+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vsi_bi_Vgi_bi=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vgi_bi)+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vgi_bi+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vgi_bi)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vsi_bi_Vdi_bi=(+(+(+UA_a_Vsi_bi_Vdi_bi+(+UC_a_Vsi_bi_Vdi_bi*Vbsx+UC_a_Vsi_bi*Vbsx_Vdi_bi+UC_a_Vdi_bi*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Vdi_bi))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vsi_bi_Vdi_bi/T2-(UD_a_Vsi_bi*T2_Vdi_bi+UD_a_Vdi_bi*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vdi_bi)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vsi_bi_Vsi_bi=(+(+(+UA_a_Vsi_bi_Vsi_bi+(+UC_a_Vsi_bi_Vsi_bi*Vbsx+UC_a_Vsi_bi*Vbsx_Vsi_bi+UC_a_Vsi_bi*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Vsi_bi))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vsi_bi_Vsi_bi/T2-(UD_a_Vsi_bi*T2_Vsi_bi+UD_a_Vsi_bi*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vsi_bi)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vsi_bi_Tempt_GND=(+(+(+UA_a_Vsi_bi_Tempt_GND+(+UC_a_Vsi_bi_Tempt_GND*Vbsx+UC_a_Vsi_bi*Vbsx_Tempt_GND+UC_a_Tempt_GND*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Tempt_GND))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vsi_bi_Tempt_GND/T2-(UD_a_Vsi_bi*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vsi_bi+UD_a*T2_Vsi_bi_Tempt_GND)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=((((UA_a_Tempt_GND+((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Tempt_GND)))+((UD_a_Tempt_GND*T2-UD_a*T2_Tempt_GND)/T2/T2));
#endif
#endif
T3=(((UA_a+(UC_a*Vbsx))*d00_pow0)+(UD_a/T2));
EXIT_IF_ISNAN((((UA_a+(UC_a*Vbsx))*d00_pow0)+(UD_a/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=T3_Vgi_bi;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+0.0+T3_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+0.0+T3_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+0.0+T3_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+0.0+T3_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+0.0+T3_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+0.0+T3_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+0.0+T3_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+0.0+T3_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=T3_Vdi_bi;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+0.0+T3_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+0.0+T3_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+0.0+T3_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+0.0+T3_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+0.0+T3_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+0.0+T3_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+0.0+T3_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+0.0+T3_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=T3_Vsi_bi;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+0.0+T3_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+0.0+T3_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+0.0+T3_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+0.0+T3_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+0.0+T3_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+0.0+T3_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+0.0+T3_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+0.0+T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=T3_Tempt_GND;
#endif
#endif
T4=(1.0+T3);
EXIT_IF_ISNAN((1.0+T3))
{
double m00_sqrt(d00_sqrt0,(((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Dmobs_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Dmobs_Vdbulk_di_Vdbulk_di=0.0;
  Dmobs_Vdbulk_di_Vsbulk_si=0.0;
  Dmobs_Vdbulk_di_Vgi_bi=0.0;
  Dmobs_Vdbulk_di_Vdi_bi=0.0;
  Dmobs_Vdbulk_di_Vsi_bi=0.0;
  Dmobs_Vdbulk_di_Tempt_GND=0.0;
#endif
Dmobs_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Dmobs_Vsbulk_si_Vdbulk_di=0.0;
  Dmobs_Vsbulk_si_Vsbulk_si=0.0;
  Dmobs_Vsbulk_si_Vgi_bi=0.0;
  Dmobs_Vsbulk_si_Vdi_bi=0.0;
  Dmobs_Vsbulk_si_Vsi_bi=0.0;
  Dmobs_Vsbulk_si_Tempt_GND=0.0;
#endif
Dmobs_Vgi_bi=(0.5*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmobs_Vgi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmobs_Vdi_bi=(0.5*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmobs_Vdi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmobs_Vsi_bi=(0.5*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmobs_Vsi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
#if defined(_DERIVATE)
Dmobs_Tempt_GND=(0.5*(T4_Tempt_GND+((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND))*d10_sqrt0));
#endif
#endif
Dmobs=(0.5*((T4+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T4+1.0)+d00_sqrt0)))
}
{
double m00_pow(d00_pow0,(Weff*1.0e6),WR_i)
WeffWRFactor=(1.0/(d00_pow0*pInst->NF));
EXIT_IF_ISNAN((1.0/(d00_pow0*pInst->NF)))
}
if
((pModel->RDSMOD==1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Rdss_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Rdss_Vgi_bi_Vgi_bi=0.0;
  Rdss_Vgi_bi_Vdi_bi=0.0;
  Rdss_Vgi_bi_Vsi_bi=0.0;
  Rdss_Vgi_bi_Tempt_GND=0.0;
#endif
Rdss_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Rdss_Vdi_bi_Vgi_bi=0.0;
  Rdss_Vdi_bi_Vdi_bi=0.0;
  Rdss_Vdi_bi_Vsi_bi=0.0;
  Rdss_Vdi_bi_Tempt_GND=0.0;
#endif
Rdss_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Rdss_Vsi_bi_Vgi_bi=0.0;
  Rdss_Vsi_bi_Vdi_bi=0.0;
  Rdss_Vsi_bi_Vsi_bi=0.0;
  Rdss_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
Rdss_Tempt_GND=0.0;
#endif
#endif
Rdss=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(PRWG_i*qis_Vgi_bi);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vgi_bi+PRWG_i*0.0));
  T0_Vgi_bi_Vgm_si=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vgi_bi+PRWG_i*0.0));
  T0_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vgi_bi+PRWG_i*qis_Vgi_bi_Vdbulk_di));
  T0_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vgi_bi+PRWG_i*qis_Vgi_bi_Vsbulk_si));
  T0_Vgi_bi_Vgi_bi=(+0.0+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vgi_bi+PRWG_i*qis_Vgi_bi_Vgi_bi));
  T0_Vgi_bi_Vdi_bi=(+0.0+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vgi_bi+PRWG_i*qis_Vgi_bi_Vdi_bi));
  T0_Vgi_bi_Vsi_bi=(+0.0+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vgi_bi+PRWG_i*qis_Vgi_bi_Vsi_bi));
  T0_Vgi_bi_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vgi_bi+PRWG_i*qis_Vgi_bi_Tempt_GND));
#endif
T0_Vdi_bi=(PRWG_i*qis_Vdi_bi);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vdi_bi+PRWG_i*0.0));
  T0_Vdi_bi_Vgm_si=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vdi_bi+PRWG_i*0.0));
  T0_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vdi_bi+PRWG_i*qis_Vdi_bi_Vdbulk_di));
  T0_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vdi_bi+PRWG_i*qis_Vdi_bi_Vsbulk_si));
  T0_Vdi_bi_Vgi_bi=(+0.0+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vdi_bi+PRWG_i*qis_Vdi_bi_Vgi_bi));
  T0_Vdi_bi_Vdi_bi=(+0.0+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vdi_bi+PRWG_i*qis_Vdi_bi_Vdi_bi));
  T0_Vdi_bi_Vsi_bi=(+0.0+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vdi_bi+PRWG_i*qis_Vdi_bi_Vsi_bi));
  T0_Vdi_bi_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vdi_bi+PRWG_i*qis_Vdi_bi_Tempt_GND));
#endif
T0_Vsi_bi=(PRWG_i*qis_Vsi_bi);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vsi_bi+PRWG_i*0.0));
  T0_Vsi_bi_Vgm_si=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vsi_bi+PRWG_i*0.0));
  T0_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vsi_bi+PRWG_i*qis_Vsi_bi_Vdbulk_di));
  T0_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vsi_bi+PRWG_i*qis_Vsi_bi_Vsbulk_si));
  T0_Vsi_bi_Vgi_bi=(+0.0+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vsi_bi+PRWG_i*qis_Vsi_bi_Vgi_bi));
  T0_Vsi_bi_Vdi_bi=(+0.0+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vsi_bi+PRWG_i*qis_Vsi_bi_Vdi_bi));
  T0_Vsi_bi_Vsi_bi=(+0.0+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vsi_bi+PRWG_i*qis_Vsi_bi_Vsi_bi));
  T0_Vsi_bi_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vsi_bi+PRWG_i*qis_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(PRWG_i*qis_Tempt_GND);
#endif
#endif
T0=(1.0+(PRWG_i*qis));
EXIT_IF_ISNAN((1.0+(PRWG_i*qis)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=(PRWB_i*sqrtPhistVbs_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vgm_si=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vdbulk_di=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vsbulk_si=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vgi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vdi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vdi_bi+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+sqrtPhistVbs_Vdi_bi_Vdi_bi-0.0));
  T1_Vdi_bi_Vsi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vsi_bi+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+sqrtPhistVbs_Vdi_bi_Vsi_bi-0.0));
  T1_Vdi_bi_Tempt_GND=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*(sqrtPhistVbs_Tempt_GND-sqrtPhist_Tempt_GND)+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+sqrtPhistVbs_Vdi_bi_Tempt_GND-0.0));
#endif
T1_Vsi_bi=(PRWB_i*sqrtPhistVbs_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vgm_si=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vdbulk_di=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vsbulk_si=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vgi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vdi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vdi_bi+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+sqrtPhistVbs_Vsi_bi_Vdi_bi-0.0));
  T1_Vsi_bi_Vsi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vsi_bi+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+sqrtPhistVbs_Vsi_bi_Vsi_bi-0.0));
  T1_Vsi_bi_Tempt_GND=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*(sqrtPhistVbs_Tempt_GND-sqrtPhist_Tempt_GND)+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+sqrtPhistVbs_Vsi_bi_Tempt_GND-0.0));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(PRWB_i*(sqrtPhistVbs_Tempt_GND-sqrtPhist_Tempt_GND));
#endif
#endif
T1=(PRWB_i*(sqrtPhistVbs-sqrtPhist));
EXIT_IF_ISNAN((PRWB_i*(sqrtPhistVbs-sqrtPhist)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((-T0_Vgi_bi/T0/T0)+T1_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(0.0/T0-(0.0*T0_Vgm_di+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vgm_di)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vgm_di/T0/T0/T0)+T1_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(+(0.0/T0-(0.0*T0_Vgm_si+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vgm_si)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vgm_si/T0/T0/T0)+T1_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vdbulk_di)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vdbulk_di/T0/T0/T0)+T1_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vsbulk_si)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vsbulk_si/T0/T0/T0)+T1_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vgi_bi)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vgi_bi/T0/T0/T0)+T1_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(+(0.0/T0-(0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vdi_bi)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vdi_bi/T0/T0/T0)+T1_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(+(0.0/T0-(0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vsi_bi)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vsi_bi/T0/T0/T0)+T1_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(+(0.0/T0-(0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Tempt_GND)/T0/T0+2*1.0*T0_Vgi_bi*T0_Tempt_GND/T0/T0/T0)+T1_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=((-T0_Vdi_bi/T0/T0)+T1_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(0.0/T0-(0.0*T0_Vgm_di+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vgm_di)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vgm_di/T0/T0/T0)+T1_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(+(0.0/T0-(0.0*T0_Vgm_si+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vgm_si)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vgm_si/T0/T0/T0)+T1_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vdbulk_di)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vdbulk_di/T0/T0/T0)+T1_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vsbulk_si)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vsbulk_si/T0/T0/T0)+T1_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vgi_bi)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vgi_bi/T0/T0/T0)+T1_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(+(0.0/T0-(0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vdi_bi)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vdi_bi/T0/T0/T0)+T1_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(+(0.0/T0-(0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vsi_bi)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vsi_bi/T0/T0/T0)+T1_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(+(0.0/T0-(0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Tempt_GND)/T0/T0+2*1.0*T0_Vdi_bi*T0_Tempt_GND/T0/T0/T0)+T1_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=((-T0_Vsi_bi/T0/T0)+T1_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(0.0/T0-(0.0*T0_Vgm_di+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vgm_di)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vgm_di/T0/T0/T0)+T1_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(+(0.0/T0-(0.0*T0_Vgm_si+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vgm_si)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vgm_si/T0/T0/T0)+T1_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vdbulk_di)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vdbulk_di/T0/T0/T0)+T1_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vsbulk_si)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vsbulk_si/T0/T0/T0)+T1_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vgi_bi)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vgi_bi/T0/T0/T0)+T1_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(+(0.0/T0-(0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vdi_bi)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vdi_bi/T0/T0/T0)+T1_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(+(0.0/T0-(0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vsi_bi)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vsi_bi/T0/T0/T0)+T1_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(+(0.0/T0-(0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Tempt_GND)/T0/T0+2*1.0*T0_Vsi_bi*T0_Tempt_GND/T0/T0/T0)+T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((-T0_Tempt_GND/T0/T0)+T1_Tempt_GND);
#endif
#endif
T2=((1.0/T0)+T1);
EXIT_IF_ISNAN(((1.0/T0)+T1))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si)+0.0)));
  T3_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di)+0.0)));
  T3_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di)+0.0)));
  T3_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si)+0.0)));
  T3_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0)));
  T3_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0)));
  T3_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0)));
  T3_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND+(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0)));
#endif
T3_Vdi_bi=(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si)+0.0)));
  T3_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di)+0.0)));
  T3_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di)+0.0)));
  T3_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si)+0.0)));
  T3_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0)));
  T3_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0)));
  T3_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0)));
  T3_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND+(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0)));
#endif
T3_Vsi_bi=(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si)+0.0)));
  T3_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di)+0.0)));
  T3_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di)+0.0)));
  T3_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si)+0.0)));
  T3_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0)));
  T3_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0)));
  T3_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0)));
  T3_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND+(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0)));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0);
#endif
#endif
T3=(T2+d00_sqrt0);
EXIT_IF_ISNAN((T2+d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Rdss_Vgi_bi=(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vgi_bi_Vgi_bi=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vgi_bi))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Vgi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
  Rdss_Vgi_bi_Vdi_bi=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vdi_bi))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Vdi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
  Rdss_Vgi_bi_Vsi_bi=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vsi_bi))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Vsi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
  Rdss_Vgi_bi_Tempt_GND=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Tempt_GND))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*rdstemp_Tempt_GND+((((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
#endif
Rdss_Vdi_bi=(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vdi_bi_Vgi_bi=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vgi_bi))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Vgi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
  Rdss_Vdi_bi_Vdi_bi=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vdi_bi))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Vdi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
  Rdss_Vdi_bi_Vsi_bi=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vsi_bi))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Vsi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
  Rdss_Vdi_bi_Tempt_GND=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Tempt_GND))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*rdstemp_Tempt_GND+((((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
#endif
Rdss_Vsi_bi=(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vsi_bi_Vgi_bi=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vgi_bi))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Vgi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
  Rdss_Vsi_bi_Vdi_bi=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vdi_bi))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Vdi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
  Rdss_Vsi_bi_Vsi_bi=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vsi_bi))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Vsi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
  Rdss_Vsi_bi_Tempt_GND=(+(+(+(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Tempt_GND))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*rdstemp_Tempt_GND+((((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*pInst->NF)*0.0+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*0.0);
#endif
#if defined(_DERIVATE)
Rdss_Tempt_GND=(((RDSW_i*T3_Tempt_GND)*WeffWRFactor*pInst->NF*rdstemp)+((((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*rdstemp_Tempt_GND));
#endif
#endif
Rdss=((((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*rdstemp);
EXIT_IF_ISNAN(((((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF)*rdstemp))
if
((pModel->RDSMOD==2))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Rdss_Vgi_bi=(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vgi_bi_Vgi_bi=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vgi_bi))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Vgi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
  Rdss_Vgi_bi_Vdi_bi=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vdi_bi))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Vdi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
  Rdss_Vgi_bi_Vsi_bi=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vsi_bi))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Vsi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
  Rdss_Vgi_bi_Tempt_GND=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Tempt_GND))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF*rdstemp_Tempt_GND+((((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
#endif
Rdss_Vdi_bi=(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vdi_bi_Vgi_bi=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vgi_bi))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Vgi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
  Rdss_Vdi_bi_Vdi_bi=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vdi_bi))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Vdi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
  Rdss_Vdi_bi_Vsi_bi=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vsi_bi))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Vsi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
  Rdss_Vdi_bi_Tempt_GND=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Tempt_GND))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF*rdstemp_Tempt_GND+((((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
#endif
Rdss_Vsi_bi=(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vsi_bi_Vgi_bi=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vgi_bi))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Vgi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
  Rdss_Vsi_bi_Vdi_bi=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vdi_bi))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Vdi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
  Rdss_Vsi_bi_Vsi_bi=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vsi_bi))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Vsi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*0.0+((((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
  Rdss_Vsi_bi_Tempt_GND=(+(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Tempt_GND))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0)*rdstemp+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF*rdstemp_Tempt_GND+((((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*pInst->NF)*0.0+((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*0.0);
#endif
#if defined(_DERIVATE)
Rdss_Tempt_GND=(((RDSW_i*T3_Tempt_GND)*WeffWRFactor*pInst->NF*rdstemp)+(((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*rdstemp_Tempt_GND));
#endif
#endif
Rdss=(((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*rdstemp);
EXIT_IF_ISNAN((((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)*rdstemp))
}
}
{
double m00_pow(d00_pow0,Dmobs,(1.0/PSAT_a))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,Dmobs,(1.0/PSAT_a))
double m11_pow(d11_pow0,d00_pow0,Dmobs,(1.0/PSAT_a))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(d10_pow0*Dmobs_Vgi_bi);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=fixme;
  T0_Vgi_bi_Vgm_si=fixme;
  T0_Vgi_bi_Vdbulk_di=fixme;
  T0_Vgi_bi_Vsbulk_si=fixme;
  T0_Vgi_bi_Vgi_bi=fixme;
  T0_Vgi_bi_Vdi_bi=fixme;
  T0_Vgi_bi_Vsi_bi=fixme;
  T0_Vgi_bi_Tempt_GND=fixme;
#endif
T0_Vdi_bi=(d10_pow0*Dmobs_Vdi_bi+d11_pow0*(-PSAT_a_Vdi_bi/PSAT_a/PSAT_a));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=fixme;
  T0_Vdi_bi_Vgm_si=fixme;
  T0_Vdi_bi_Vdbulk_di=fixme;
  T0_Vdi_bi_Vsbulk_si=fixme;
  T0_Vdi_bi_Vgi_bi=fixme;
  T0_Vdi_bi_Vdi_bi=fixme;
  T0_Vdi_bi_Vsi_bi=fixme;
  T0_Vdi_bi_Tempt_GND=fixme;
#endif
T0_Vsi_bi=(d10_pow0*Dmobs_Vsi_bi+d11_pow0*(-PSAT_a_Vsi_bi/PSAT_a/PSAT_a));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=fixme;
  T0_Vsi_bi_Vgm_si=fixme;
  T0_Vsi_bi_Vdbulk_di=fixme;
  T0_Vsi_bi_Vsbulk_si=fixme;
  T0_Vsi_bi_Vgi_bi=fixme;
  T0_Vsi_bi_Vdi_bi=fixme;
  T0_Vsi_bi_Vsi_bi=fixme;
  T0_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(d10_pow0*Dmobs_Tempt_GND+d11_pow0*(-PSAT_a_Tempt_GND/PSAT_a/PSAT_a));
#endif
#endif
T0=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
if
((PSATB_i<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=(-(PSATB_i*Vbsx_Vdi_bi)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vgm_si=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vdbulk_di=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vsbulk_si=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vgi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vdi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Vdi_bi))+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Vdi_bi)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*((PSATB_i*Vbsx_Vdi_bi))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vsi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Vsi_bi))+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Vsi_bi)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*((PSATB_i*Vbsx_Vsi_bi))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Tempt_GND=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Tempt_GND))+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Tempt_GND)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*((PSATB_i*Vbsx_Tempt_GND))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#endif
T1_Vsi_bi=(-(PSATB_i*Vbsx_Vsi_bi)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vgm_si=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vdbulk_di=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vsbulk_si=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vgi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vdi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Vdi_bi))+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Vdi_bi)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*((PSATB_i*Vbsx_Vdi_bi))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vsi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Vsi_bi))+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Vsi_bi)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*((PSATB_i*Vbsx_Vsi_bi))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Tempt_GND=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Tempt_GND))+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Tempt_GND)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*((PSATB_i*Vbsx_Tempt_GND))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-(PSATB_i*Vbsx_Tempt_GND)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#endif
#endif
T1=(1.0/(1.0+(PSATB_i*Vbsx)));
EXIT_IF_ISNAN((1.0/(1.0+(PSATB_i*Vbsx))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=(-(PSATB_i*Vbsx_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vgm_si=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vdbulk_di=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vsbulk_si=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vgi_bi=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vdi_bi=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(-(PSATB_i*Vbsx_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vgm_si=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vdbulk_di=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vsbulk_si=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vgi_bi=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vdi_bi=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-(PSATB_i*Vbsx_Tempt_GND));
#endif
#endif
T1=(1.0-(PSATB_i*Vbsx));
EXIT_IF_ISNAN((1.0-(PSATB_i*Vbsx)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((((((10.0*pModel->PSATX)*qs_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi))*((10.0*pModel->PSATX)+(qs*T1))-(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vgm_di+(0.0)*qs_Vgi_bi+(10.0*pModel->PSATX)*qs_Vgi_bi_Vgm_di)*T1+((10.0*pModel->PSATX)*qs_Vgi_bi)*T1_Vgm_di+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_di)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qs)*T1_Vgi_bi_Vgm_di)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi))*((0.0)+(((qs_Vgm_di*T1)+(qs*T1_Vgm_di))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_di)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgm_di)))*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vgi_bi_Vgm_di*T1+qs_Vgi_bi*T1_Vgm_di+qs_Vgm_di*T1_Vgi_bi+qs*T1_Vgi_bi_Vgm_di)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))*((0.0)+(((qs_Vgm_di*T1)+(qs*T1_Vgm_di))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vgi_bi_Vgm_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vgm_si+(0.0)*qs_Vgi_bi+(10.0*pModel->PSATX)*qs_Vgi_bi_Vgm_si)*T1+((10.0*pModel->PSATX)*qs_Vgi_bi)*T1_Vgm_si+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_si)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qs)*T1_Vgi_bi_Vgm_si)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi))*((0.0)+(((qs_Vgm_si*T1)+(qs*T1_Vgm_si))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_si)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgm_si)))*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vgi_bi_Vgm_si*T1+qs_Vgi_bi*T1_Vgm_si+qs_Vgm_si*T1_Vgi_bi+qs*T1_Vgi_bi_Vgm_si)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))*((0.0)+(((qs_Vgm_si*T1)+(qs*T1_Vgm_si))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vgi_bi_Vdbulk_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vdbulk_di+(0.0)*qs_Vgi_bi+(10.0*pModel->PSATX)*qs_Vgi_bi_Vdbulk_di)*T1+((10.0*pModel->PSATX)*qs_Vgi_bi)*T1_Vdbulk_di+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdbulk_di)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qs)*T1_Vgi_bi_Vdbulk_di)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi))*((0.0)+(((qs_Vdbulk_di*T1)+(qs*T1_Vdbulk_di))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdbulk_di)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdbulk_di)))*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vgi_bi_Vdbulk_di*T1+qs_Vgi_bi*T1_Vdbulk_di+qs_Vdbulk_di*T1_Vgi_bi+qs*T1_Vgi_bi_Vdbulk_di)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))*((0.0)+(((qs_Vdbulk_di*T1)+(qs*T1_Vdbulk_di))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vgi_bi_Vsbulk_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vsbulk_si+(0.0)*qs_Vgi_bi+(10.0*pModel->PSATX)*qs_Vgi_bi_Vsbulk_si)*T1+((10.0*pModel->PSATX)*qs_Vgi_bi)*T1_Vsbulk_si+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsbulk_si)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qs)*T1_Vgi_bi_Vsbulk_si)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi))*((0.0)+(((qs_Vsbulk_si*T1)+(qs*T1_Vsbulk_si))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsbulk_si)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsbulk_si)))*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vgi_bi_Vsbulk_si*T1+qs_Vgi_bi*T1_Vsbulk_si+qs_Vsbulk_si*T1_Vgi_bi+qs*T1_Vgi_bi_Vsbulk_si)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))*((0.0)+(((qs_Vsbulk_si*T1)+(qs*T1_Vsbulk_si))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vgi_bi_Vgi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vgi_bi+(0.0)*qs_Vgi_bi+(10.0*pModel->PSATX)*qs_Vgi_bi_Vgi_bi)*T1+((10.0*pModel->PSATX)*qs_Vgi_bi)*T1_Vgi_bi+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgi_bi)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qs)*T1_Vgi_bi_Vgi_bi)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi))*((0.0)+(((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgi_bi)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi)))*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vgi_bi_Vgi_bi*T1+qs_Vgi_bi*T1_Vgi_bi+qs_Vgi_bi*T1_Vgi_bi+qs*T1_Vgi_bi_Vgi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))*((0.0)+(((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vgi_bi_Vdi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vdi_bi+(0.0)*qs_Vgi_bi+(10.0*pModel->PSATX)*qs_Vgi_bi_Vdi_bi)*T1+((10.0*pModel->PSATX)*qs_Vgi_bi)*T1_Vdi_bi+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdi_bi)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qs)*T1_Vgi_bi_Vdi_bi)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi))*((0.0)+(((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdi_bi)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi)))*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vgi_bi_Vdi_bi*T1+qs_Vgi_bi*T1_Vdi_bi+qs_Vdi_bi*T1_Vgi_bi+qs*T1_Vgi_bi_Vdi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))*((0.0)+(((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vgi_bi_Vsi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vsi_bi+(0.0)*qs_Vgi_bi+(10.0*pModel->PSATX)*qs_Vgi_bi_Vsi_bi)*T1+((10.0*pModel->PSATX)*qs_Vgi_bi)*T1_Vsi_bi+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsi_bi)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qs)*T1_Vgi_bi_Vsi_bi)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi))*((0.0)+(((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsi_bi)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi)))*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vgi_bi_Vsi_bi*T1+qs_Vgi_bi*T1_Vsi_bi+qs_Vsi_bi*T1_Vgi_bi+qs*T1_Vgi_bi_Vsi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))*((0.0)+(((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vgi_bi_Tempt_GND=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Tempt_GND+(0.0)*qs_Vgi_bi+(10.0*pModel->PSATX)*qs_Vgi_bi_Tempt_GND)*T1+((10.0*pModel->PSATX)*qs_Vgi_bi)*T1_Tempt_GND+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Tempt_GND)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qs)*T1_Vgi_bi_Tempt_GND)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi))*((0.0)+(((qs_Tempt_GND*T1)+(qs*T1_Tempt_GND))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Tempt_GND)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Tempt_GND)))*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vgi_bi_Tempt_GND*T1+qs_Vgi_bi*T1_Tempt_GND+qs_Tempt_GND*T1_Vgi_bi+qs*T1_Vgi_bi_Tempt_GND)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))*((0.0)+(((qs_Tempt_GND*T1)+(qs*T1_Tempt_GND))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
#endif
T2_Vdi_bi=((((((10.0*pModel->PSATX)*qs_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi))*((10.0*pModel->PSATX)+(qs*T1))-(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vgm_di+(0.0)*qs_Vdi_bi+(10.0*pModel->PSATX)*qs_Vdi_bi_Vgm_di)*T1+((10.0*pModel->PSATX)*qs_Vdi_bi)*T1_Vgm_di+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_di)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qs)*T1_Vdi_bi_Vgm_di)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi))*((0.0)+(((qs_Vgm_di*T1)+(qs*T1_Vgm_di))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_di)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgm_di)))*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vdi_bi_Vgm_di*T1+qs_Vdi_bi*T1_Vgm_di+qs_Vgm_di*T1_Vdi_bi+qs*T1_Vdi_bi_Vgm_di)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))*((0.0)+(((qs_Vgm_di*T1)+(qs*T1_Vgm_di))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vdi_bi_Vgm_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vgm_si+(0.0)*qs_Vdi_bi+(10.0*pModel->PSATX)*qs_Vdi_bi_Vgm_si)*T1+((10.0*pModel->PSATX)*qs_Vdi_bi)*T1_Vgm_si+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_si)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qs)*T1_Vdi_bi_Vgm_si)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi))*((0.0)+(((qs_Vgm_si*T1)+(qs*T1_Vgm_si))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_si)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgm_si)))*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vdi_bi_Vgm_si*T1+qs_Vdi_bi*T1_Vgm_si+qs_Vgm_si*T1_Vdi_bi+qs*T1_Vdi_bi_Vgm_si)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))*((0.0)+(((qs_Vgm_si*T1)+(qs*T1_Vgm_si))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vdi_bi_Vdbulk_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vdbulk_di+(0.0)*qs_Vdi_bi+(10.0*pModel->PSATX)*qs_Vdi_bi_Vdbulk_di)*T1+((10.0*pModel->PSATX)*qs_Vdi_bi)*T1_Vdbulk_di+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdbulk_di)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qs)*T1_Vdi_bi_Vdbulk_di)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi))*((0.0)+(((qs_Vdbulk_di*T1)+(qs*T1_Vdbulk_di))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdbulk_di)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdbulk_di)))*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vdi_bi_Vdbulk_di*T1+qs_Vdi_bi*T1_Vdbulk_di+qs_Vdbulk_di*T1_Vdi_bi+qs*T1_Vdi_bi_Vdbulk_di)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))*((0.0)+(((qs_Vdbulk_di*T1)+(qs*T1_Vdbulk_di))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vdi_bi_Vsbulk_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vsbulk_si+(0.0)*qs_Vdi_bi+(10.0*pModel->PSATX)*qs_Vdi_bi_Vsbulk_si)*T1+((10.0*pModel->PSATX)*qs_Vdi_bi)*T1_Vsbulk_si+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsbulk_si)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qs)*T1_Vdi_bi_Vsbulk_si)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi))*((0.0)+(((qs_Vsbulk_si*T1)+(qs*T1_Vsbulk_si))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsbulk_si)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsbulk_si)))*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vdi_bi_Vsbulk_si*T1+qs_Vdi_bi*T1_Vsbulk_si+qs_Vsbulk_si*T1_Vdi_bi+qs*T1_Vdi_bi_Vsbulk_si)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))*((0.0)+(((qs_Vsbulk_si*T1)+(qs*T1_Vsbulk_si))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vdi_bi_Vgi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vgi_bi+(0.0)*qs_Vdi_bi+(10.0*pModel->PSATX)*qs_Vdi_bi_Vgi_bi)*T1+((10.0*pModel->PSATX)*qs_Vdi_bi)*T1_Vgi_bi+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgi_bi)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qs)*T1_Vdi_bi_Vgi_bi)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi))*((0.0)+(((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgi_bi)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi)))*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vdi_bi_Vgi_bi*T1+qs_Vdi_bi*T1_Vgi_bi+qs_Vgi_bi*T1_Vdi_bi+qs*T1_Vdi_bi_Vgi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))*((0.0)+(((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vdi_bi_Vdi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vdi_bi+(0.0)*qs_Vdi_bi+(10.0*pModel->PSATX)*qs_Vdi_bi_Vdi_bi)*T1+((10.0*pModel->PSATX)*qs_Vdi_bi)*T1_Vdi_bi+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdi_bi)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qs)*T1_Vdi_bi_Vdi_bi)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi))*((0.0)+(((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdi_bi)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi)))*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vdi_bi_Vdi_bi*T1+qs_Vdi_bi*T1_Vdi_bi+qs_Vdi_bi*T1_Vdi_bi+qs*T1_Vdi_bi_Vdi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))*((0.0)+(((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vdi_bi_Vsi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vsi_bi+(0.0)*qs_Vdi_bi+(10.0*pModel->PSATX)*qs_Vdi_bi_Vsi_bi)*T1+((10.0*pModel->PSATX)*qs_Vdi_bi)*T1_Vsi_bi+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsi_bi)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qs)*T1_Vdi_bi_Vsi_bi)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi))*((0.0)+(((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsi_bi)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi)))*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vdi_bi_Vsi_bi*T1+qs_Vdi_bi*T1_Vsi_bi+qs_Vsi_bi*T1_Vdi_bi+qs*T1_Vdi_bi_Vsi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))*((0.0)+(((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vdi_bi_Tempt_GND=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Tempt_GND+(0.0)*qs_Vdi_bi+(10.0*pModel->PSATX)*qs_Vdi_bi_Tempt_GND)*T1+((10.0*pModel->PSATX)*qs_Vdi_bi)*T1_Tempt_GND+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Tempt_GND)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qs)*T1_Vdi_bi_Tempt_GND)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi))*((0.0)+(((qs_Tempt_GND*T1)+(qs*T1_Tempt_GND))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Tempt_GND)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Tempt_GND)))*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vdi_bi_Tempt_GND*T1+qs_Vdi_bi*T1_Tempt_GND+qs_Tempt_GND*T1_Vdi_bi+qs*T1_Vdi_bi_Tempt_GND)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))*((0.0)+(((qs_Tempt_GND*T1)+(qs*T1_Tempt_GND))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
#endif
T2_Vsi_bi=((((((10.0*pModel->PSATX)*qs_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi))*((10.0*pModel->PSATX)+(qs*T1))-(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vgm_di+(0.0)*qs_Vsi_bi+(10.0*pModel->PSATX)*qs_Vsi_bi_Vgm_di)*T1+((10.0*pModel->PSATX)*qs_Vsi_bi)*T1_Vgm_di+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_di)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qs)*T1_Vsi_bi_Vgm_di)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi))*((0.0)+(((qs_Vgm_di*T1)+(qs*T1_Vgm_di))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_di)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgm_di)))*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vsi_bi_Vgm_di*T1+qs_Vsi_bi*T1_Vgm_di+qs_Vgm_di*T1_Vsi_bi+qs*T1_Vsi_bi_Vgm_di)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))*((0.0)+(((qs_Vgm_di*T1)+(qs*T1_Vgm_di))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vsi_bi_Vgm_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vgm_si+(0.0)*qs_Vsi_bi+(10.0*pModel->PSATX)*qs_Vsi_bi_Vgm_si)*T1+((10.0*pModel->PSATX)*qs_Vsi_bi)*T1_Vgm_si+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_si)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qs)*T1_Vsi_bi_Vgm_si)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi))*((0.0)+(((qs_Vgm_si*T1)+(qs*T1_Vgm_si))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgm_si)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgm_si)))*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vsi_bi_Vgm_si*T1+qs_Vsi_bi*T1_Vgm_si+qs_Vgm_si*T1_Vsi_bi+qs*T1_Vsi_bi_Vgm_si)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))*((0.0)+(((qs_Vgm_si*T1)+(qs*T1_Vgm_si))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vsi_bi_Vdbulk_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vdbulk_di+(0.0)*qs_Vsi_bi+(10.0*pModel->PSATX)*qs_Vsi_bi_Vdbulk_di)*T1+((10.0*pModel->PSATX)*qs_Vsi_bi)*T1_Vdbulk_di+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdbulk_di)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qs)*T1_Vsi_bi_Vdbulk_di)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi))*((0.0)+(((qs_Vdbulk_di*T1)+(qs*T1_Vdbulk_di))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdbulk_di)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdbulk_di)))*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vsi_bi_Vdbulk_di*T1+qs_Vsi_bi*T1_Vdbulk_di+qs_Vdbulk_di*T1_Vsi_bi+qs*T1_Vsi_bi_Vdbulk_di)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))*((0.0)+(((qs_Vdbulk_di*T1)+(qs*T1_Vdbulk_di))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vsi_bi_Vsbulk_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vsbulk_si+(0.0)*qs_Vsi_bi+(10.0*pModel->PSATX)*qs_Vsi_bi_Vsbulk_si)*T1+((10.0*pModel->PSATX)*qs_Vsi_bi)*T1_Vsbulk_si+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsbulk_si)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qs)*T1_Vsi_bi_Vsbulk_si)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi))*((0.0)+(((qs_Vsbulk_si*T1)+(qs*T1_Vsbulk_si))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsbulk_si)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsbulk_si)))*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vsi_bi_Vsbulk_si*T1+qs_Vsi_bi*T1_Vsbulk_si+qs_Vsbulk_si*T1_Vsi_bi+qs*T1_Vsi_bi_Vsbulk_si)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))*((0.0)+(((qs_Vsbulk_si*T1)+(qs*T1_Vsbulk_si))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vsi_bi_Vgi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vgi_bi+(0.0)*qs_Vsi_bi+(10.0*pModel->PSATX)*qs_Vsi_bi_Vgi_bi)*T1+((10.0*pModel->PSATX)*qs_Vsi_bi)*T1_Vgi_bi+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgi_bi)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qs)*T1_Vsi_bi_Vgi_bi)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi))*((0.0)+(((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vgi_bi)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vgi_bi)))*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vsi_bi_Vgi_bi*T1+qs_Vsi_bi*T1_Vgi_bi+qs_Vgi_bi*T1_Vsi_bi+qs*T1_Vsi_bi_Vgi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))*((0.0)+(((qs_Vgi_bi*T1)+(qs*T1_Vgi_bi))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vsi_bi_Vdi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vdi_bi+(0.0)*qs_Vsi_bi+(10.0*pModel->PSATX)*qs_Vsi_bi_Vdi_bi)*T1+((10.0*pModel->PSATX)*qs_Vsi_bi)*T1_Vdi_bi+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdi_bi)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qs)*T1_Vsi_bi_Vdi_bi)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi))*((0.0)+(((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vdi_bi)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vdi_bi)))*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vsi_bi_Vdi_bi*T1+qs_Vsi_bi*T1_Vdi_bi+qs_Vdi_bi*T1_Vsi_bi+qs*T1_Vsi_bi_Vdi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))*((0.0)+(((qs_Vdi_bi*T1)+(qs*T1_Vdi_bi))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vsi_bi_Vsi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Vsi_bi+(0.0)*qs_Vsi_bi+(10.0*pModel->PSATX)*qs_Vsi_bi_Vsi_bi)*T1+((10.0*pModel->PSATX)*qs_Vsi_bi)*T1_Vsi_bi+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsi_bi)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qs)*T1_Vsi_bi_Vsi_bi)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi))*((0.0)+(((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Vsi_bi)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi)))*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vsi_bi_Vsi_bi*T1+qs_Vsi_bi*T1_Vsi_bi+qs_Vsi_bi*T1_Vsi_bi+qs*T1_Vsi_bi_Vsi_bi)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))*((0.0)+(((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
  T2_Vsi_bi_Tempt_GND=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qs+0.0*qs_Tempt_GND+(0.0)*qs_Vsi_bi+(10.0*pModel->PSATX)*qs_Vsi_bi_Tempt_GND)*T1+((10.0*pModel->PSATX)*qs_Vsi_bi)*T1_Tempt_GND+((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Tempt_GND)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qs)*T1_Vsi_bi_Tempt_GND)/((10.0*pModel->PSATX)+(qs*T1))-(((((10.0*pModel->PSATX)*qs_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Vsi_bi))*((0.0)+(((qs_Tempt_GND*T1)+(qs*T1_Tempt_GND))))+(((((((0.0)*qs)+((10.0*pModel->PSATX)*qs_Tempt_GND)))*T1)+(((10.0*pModel->PSATX)*qs)*T1_Tempt_GND)))*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qs)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qs_Vsi_bi_Tempt_GND*T1+qs_Vsi_bi*T1_Tempt_GND+qs_Tempt_GND*T1_Vsi_bi+qs*T1_Vsi_bi_Tempt_GND)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))+2*(((10.0*pModel->PSATX)*qs)*T1)*((qs_Vsi_bi*T1)+(qs*T1_Vsi_bi))*((0.0)+(((qs_Tempt_GND*T1)+(qs*T1_Tempt_GND))))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((((((10.0*pModel->PSATX)*qs_Tempt_GND)*T1)+(((10.0*pModel->PSATX)*qs)*T1_Tempt_GND))*((10.0*pModel->PSATX)+(qs*T1))-(((10.0*pModel->PSATX)*qs)*T1)*((qs_Tempt_GND*T1)+(qs*T1_Tempt_GND)))/((10.0*pModel->PSATX)+(qs*T1))/((10.0*pModel->PSATX)+(qs*T1)));
#endif
#endif
T2=((((10.0*pModel->PSATX)*qs)*T1)/((10.0*pModel->PSATX)+(qs*T1)));
EXIT_IF_ISNAN(((((10.0*pModel->PSATX)*qs)*T1)/((10.0*pModel->PSATX)+(qs*T1))))
if
((PTWG_a<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
LambdaC_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  LambdaC_Vdbulk_di_Vdbulk_di=0.0;
  LambdaC_Vdbulk_di_Vsbulk_si=0.0;
  LambdaC_Vdbulk_di_Tempt_GND=0.0;
  LambdaC_Vdbulk_di_Vdi_bi=0.0;
  LambdaC_Vdbulk_di_Vsi_bi=0.0;
  LambdaC_Vdbulk_di_Vgi_bi=0.0;
#endif
LambdaC_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  LambdaC_Vsbulk_si_Vdbulk_di=0.0;
  LambdaC_Vsbulk_si_Vsbulk_si=0.0;
  LambdaC_Vsbulk_si_Tempt_GND=0.0;
  LambdaC_Vsbulk_si_Vdi_bi=0.0;
  LambdaC_Vsbulk_si_Vsi_bi=0.0;
  LambdaC_Vsbulk_si_Vgi_bi=0.0;
#endif
#if defined(_DERIVATE)
LambdaC_Tempt_GND=(((2.0*((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))));
#endif
LambdaC_Vdi_bi=(((2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))));
#if defined(_DERIVATE2)
  LambdaC_Vdi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vdbulk_di+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vdbulk_di)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vdbulk_di)))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vdi_bi*T2_Vdbulk_di+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vsbulk_si+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vsbulk_si)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vsbulk_si)))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vdi_bi*T2_Vsbulk_si+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Tempt_GND/T0-(U0_a_Vdi_bi*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vdi_bi+U0_a*T0_Vdi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Tempt_GND)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Tempt_GND*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+PTWG_a_Vdi_bi_Tempt_GND*T2+PTWG_a_Vdi_bi*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Tempt_GND)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Vdi_bi/T0-(U0_a_Vdi_bi*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vdi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Vdi_bi*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+PTWG_a_Vdi_bi_Vdi_bi*T2+PTWG_a_Vdi_bi*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Vsi_bi/T0-(U0_a_Vdi_bi*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vsi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Vsi_bi*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+PTWG_a_Vdi_bi_Vsi_bi*T2+PTWG_a_Vdi_bi*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vgi_bi+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vgi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vgi_bi)))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vdi_bi*T2_Vgi_bi+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
#endif
LambdaC_Vsi_bi=(((2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))));
#if defined(_DERIVATE2)
  LambdaC_Vsi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vdbulk_di+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vdbulk_di)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vdbulk_di)))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vsi_bi*T2_Vdbulk_di+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vsbulk_si+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vsbulk_si)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vsbulk_si)))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vsi_bi*T2_Vsbulk_si+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Tempt_GND/T0-(U0_a_Vsi_bi*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vsi_bi+U0_a*T0_Vsi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Tempt_GND)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Tempt_GND*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+PTWG_a_Vsi_bi_Tempt_GND*T2+PTWG_a_Vsi_bi*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Tempt_GND)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Vdi_bi/T0-(U0_a_Vsi_bi*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vdi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Vdi_bi*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+PTWG_a_Vsi_bi_Vdi_bi*T2+PTWG_a_Vsi_bi*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Vsi_bi/T0-(U0_a_Vsi_bi*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vsi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Vsi_bi*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+PTWG_a_Vsi_bi_Vsi_bi*T2+PTWG_a_Vsi_bi*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vgi_bi+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vgi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vgi_bi)))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vsi_bi*T2_Vgi_bi+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
#endif
LambdaC_Vgi_bi=(((2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))));
#if defined(_DERIVATE2)
  LambdaC_Vgi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vdbulk_di)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vdbulk_di)))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vsbulk_si)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vsbulk_si)))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vgi_bi+U0_a*T0_Vgi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Tempt_GND)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Tempt_GND)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vdi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vsi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vgi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vgi_bi)))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
#endif
#endif
LambdaC=((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))));
EXIT_IF_ISNAN(((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
LambdaC_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  LambdaC_Vdbulk_di_Vdbulk_di=0.0;
  LambdaC_Vdbulk_di_Vsbulk_si=0.0;
  LambdaC_Vdbulk_di_Tempt_GND=0.0;
  LambdaC_Vdbulk_di_Vdi_bi=0.0;
  LambdaC_Vdbulk_di_Vsi_bi=0.0;
  LambdaC_Vdbulk_di_Vgi_bi=0.0;
#endif
LambdaC_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  LambdaC_Vsbulk_si_Vdbulk_di=0.0;
  LambdaC_Vsbulk_si_Vsbulk_si=0.0;
  LambdaC_Vsbulk_si_Tempt_GND=0.0;
  LambdaC_Vsbulk_si_Vdi_bi=0.0;
  LambdaC_Vsbulk_si_Vsi_bi=0.0;
  LambdaC_Vsbulk_si_Vgi_bi=0.0;
#endif
#if defined(_DERIVATE)
LambdaC_Tempt_GND=(((2.0*((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))));
#endif
LambdaC_Vdi_bi=(((2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))));
#if defined(_DERIVATE2)
  LambdaC_Vdi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vdbulk_di+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vdbulk_di)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vdbulk_di))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vdi_bi*T2_Vdbulk_di+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vdbulk_di)));
  LambdaC_Vdi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vsbulk_si+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vsbulk_si)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vsbulk_si))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vdi_bi*T2_Vsbulk_si+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vsbulk_si)));
  LambdaC_Vdi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Tempt_GND/T0-(U0_a_Vdi_bi*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vdi_bi+U0_a*T0_Vdi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Tempt_GND)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Tempt_GND*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vdi_bi_Tempt_GND*T2+PTWG_a_Vdi_bi*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Tempt_GND)));
  LambdaC_Vdi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Vdi_bi/T0-(U0_a_Vdi_bi*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vdi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Vdi_bi*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vdi_bi_Vdi_bi*T2+PTWG_a_Vdi_bi*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vdi_bi)));
  LambdaC_Vdi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Vsi_bi/T0-(U0_a_Vdi_bi*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vsi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Vsi_bi*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vdi_bi_Vsi_bi*T2+PTWG_a_Vdi_bi*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vsi_bi)));
  LambdaC_Vdi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vgi_bi+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vgi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vgi_bi))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vdi_bi*T2_Vgi_bi+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vgi_bi)));
#endif
LambdaC_Vsi_bi=(((2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))));
#if defined(_DERIVATE2)
  LambdaC_Vsi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vdbulk_di+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vdbulk_di)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vdbulk_di))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vsi_bi*T2_Vdbulk_di+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vdbulk_di)));
  LambdaC_Vsi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vsbulk_si+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vsbulk_si)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vsbulk_si))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vsi_bi*T2_Vsbulk_si+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vsbulk_si)));
  LambdaC_Vsi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Tempt_GND/T0-(U0_a_Vsi_bi*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vsi_bi+U0_a*T0_Vsi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Tempt_GND)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Tempt_GND*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vsi_bi_Tempt_GND*T2+PTWG_a_Vsi_bi*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Tempt_GND)));
  LambdaC_Vsi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Vdi_bi/T0-(U0_a_Vsi_bi*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vdi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Vdi_bi*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vsi_bi_Vdi_bi*T2+PTWG_a_Vsi_bi*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vdi_bi)));
  LambdaC_Vsi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Vsi_bi/T0-(U0_a_Vsi_bi*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vsi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Vsi_bi*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vsi_bi_Vsi_bi*T2+PTWG_a_Vsi_bi*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vsi_bi)));
  LambdaC_Vsi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vgi_bi+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vgi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vgi_bi))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vsi_bi*T2_Vgi_bi+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vgi_bi)));
#endif
LambdaC_Vgi_bi=(((2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(PTWG_a*T2_Vgi_bi)));
#if defined(_DERIVATE2)
  LambdaC_Vgi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vdbulk_di)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*((PTWG_a*T2_Vdbulk_di))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vdbulk_di)));
  LambdaC_Vgi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vsbulk_si)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*((PTWG_a*T2_Vsbulk_si))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vsbulk_si)));
  LambdaC_Vgi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vgi_bi+U0_a*T0_Vgi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Tempt_GND)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Tempt_GND)));
  LambdaC_Vgi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vdi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vdi_bi)));
  LambdaC_Vgi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vsi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vsi_bi)));
  LambdaC_Vgi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vgi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*((PTWG_a*T2_Vgi_bi))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vgi_bi)));
#endif
#endif
LambdaC=((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)));
EXIT_IF_ISNAN(((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))))
}
if
((Rdss==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(1.0+((0.5*LambdaC)*(1.0+qs)))-((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)+(0.0)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vgm_di*qs+qs_Vgi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_di)+qs_Vgi_bi_Vgm_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vgm_di+(0.0)*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vgm_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)+(0.0)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vgm_si*qs+qs_Vgi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_si)+qs_Vgi_bi_Vgm_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vgm_si+(0.0)*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vgm_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vdbulk_di)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+((0.5*LambdaC_Vdbulk_di))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vdbulk_di*qs+qs_Vgi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vdbulk_di)+qs_Vgi_bi_Vdbulk_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))+(((((0.5*LambdaC_Vdbulk_di))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vdbulk_di)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vdbulk_di+((0.5*LambdaC_Vdbulk_di))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vdbulk_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vsbulk_si)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+((0.5*LambdaC_Vsbulk_si))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vsbulk_si*qs+qs_Vgi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vsbulk_si)+qs_Vgi_bi_Vsbulk_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))+(((((0.5*LambdaC_Vsbulk_si))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vsbulk_si)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vsbulk_si+((0.5*LambdaC_Vsbulk_si))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vsbulk_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vgi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+((0.5*LambdaC_Vgi_bi))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vgi_bi*qs+qs_Vgi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vgi_bi)+qs_Vgi_bi_Vgi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))+(((((0.5*LambdaC_Vgi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vgi_bi)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vgi_bi+((0.5*LambdaC_Vgi_bi))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vgi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vdi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+((0.5*LambdaC_Vdi_bi))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vdi_bi*qs+qs_Vgi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vdi_bi)+qs_Vgi_bi_Vdi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))+(((((0.5*LambdaC_Vdi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vdi_bi)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vdi_bi+((0.5*LambdaC_Vdi_bi))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vdi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vsi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+((0.5*LambdaC_Vsi_bi))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vsi_bi*qs+qs_Vgi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vsi_bi)+qs_Vgi_bi_Vsi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))+(((((0.5*LambdaC_Vsi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vsi_bi)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vsi_bi+((0.5*LambdaC_Vsi_bi))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vsi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Tempt_GND)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+((0.5*LambdaC_Tempt_GND))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Tempt_GND*qs+qs_Vgi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vgi_bi+qs*qs_Vgi_bi_Tempt_GND)+qs_Vgi_bi_Tempt_GND))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))+(((((0.5*LambdaC_Tempt_GND))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Tempt_GND)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Tempt_GND+((0.5*LambdaC_Tempt_GND))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Tempt_GND))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#endif
T0_Vdi_bi=(((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(1.0+((0.5*LambdaC)*(1.0+qs)))-((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)+(0.0)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vgm_di*qs+qs_Vdi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_di)+qs_Vdi_bi_Vgm_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vgm_di+(0.0)*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vgm_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)+(0.0)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vgm_si*qs+qs_Vdi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_si)+qs_Vdi_bi_Vgm_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vgm_si+(0.0)*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vgm_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vdbulk_di)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+((0.5*LambdaC_Vdbulk_di))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vdbulk_di*qs+qs_Vdi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vdbulk_di)+qs_Vdi_bi_Vdbulk_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))+(((((0.5*LambdaC_Vdbulk_di))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vdbulk_di)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vdbulk_di+((0.5*LambdaC_Vdbulk_di))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vdbulk_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vsbulk_si)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+((0.5*LambdaC_Vsbulk_si))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vsbulk_si*qs+qs_Vdi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vsbulk_si)+qs_Vdi_bi_Vsbulk_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))+(((((0.5*LambdaC_Vsbulk_si))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vsbulk_si)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vsbulk_si+((0.5*LambdaC_Vsbulk_si))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vsbulk_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vgi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+((0.5*LambdaC_Vgi_bi))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vgi_bi*qs+qs_Vdi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vgi_bi)+qs_Vdi_bi_Vgi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))+(((((0.5*LambdaC_Vgi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vgi_bi)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vgi_bi+((0.5*LambdaC_Vgi_bi))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vgi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vdi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+((0.5*LambdaC_Vdi_bi))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vdi_bi*qs+qs_Vdi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vdi_bi)+qs_Vdi_bi_Vdi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))+(((((0.5*LambdaC_Vdi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vdi_bi)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vdi_bi+((0.5*LambdaC_Vdi_bi))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vdi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vsi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+((0.5*LambdaC_Vsi_bi))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vsi_bi*qs+qs_Vdi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vsi_bi)+qs_Vdi_bi_Vsi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))+(((((0.5*LambdaC_Vsi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vsi_bi)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vsi_bi+((0.5*LambdaC_Vsi_bi))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vsi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Tempt_GND)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+((0.5*LambdaC_Tempt_GND))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Tempt_GND*qs+qs_Vdi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vdi_bi+qs*qs_Vdi_bi_Tempt_GND)+qs_Vdi_bi_Tempt_GND))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))+(((((0.5*LambdaC_Tempt_GND))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Tempt_GND)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Tempt_GND+((0.5*LambdaC_Tempt_GND))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Tempt_GND))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#endif
T0_Vsi_bi=(((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(1.0+((0.5*LambdaC)*(1.0+qs)))-((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)+(0.0)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vgm_di*qs+qs_Vsi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_di)+qs_Vsi_bi_Vgm_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vgm_di+(0.0)*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vgm_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)+(0.0)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vgm_si*qs+qs_Vsi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_si)+qs_Vsi_bi_Vgm_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vgm_si+(0.0)*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vgm_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vdbulk_di)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+((0.5*LambdaC_Vdbulk_di))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vdbulk_di*qs+qs_Vsi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vdbulk_di)+qs_Vsi_bi_Vdbulk_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))+(((((0.5*LambdaC_Vdbulk_di))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vdbulk_di)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vdbulk_di+((0.5*LambdaC_Vdbulk_di))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vdbulk_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vsbulk_si)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+((0.5*LambdaC_Vsbulk_si))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vsbulk_si*qs+qs_Vsi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vsbulk_si)+qs_Vsi_bi_Vsbulk_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))+(((((0.5*LambdaC_Vsbulk_si))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vsbulk_si)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vsbulk_si+((0.5*LambdaC_Vsbulk_si))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vsbulk_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vgi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+((0.5*LambdaC_Vgi_bi))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vgi_bi*qs+qs_Vsi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vgi_bi)+qs_Vsi_bi_Vgi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))+(((((0.5*LambdaC_Vgi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vgi_bi)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vgi_bi+((0.5*LambdaC_Vgi_bi))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vgi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vdi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+((0.5*LambdaC_Vdi_bi))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vdi_bi*qs+qs_Vsi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vdi_bi)+qs_Vsi_bi_Vdi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))+(((((0.5*LambdaC_Vdi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vdi_bi)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vdi_bi+((0.5*LambdaC_Vdi_bi))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vdi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vsi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+((0.5*LambdaC_Vsi_bi))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vsi_bi*qs+qs_Vsi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vsi_bi)+qs_Vsi_bi_Vsi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))+(((((0.5*LambdaC_Vsi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vsi_bi)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vsi_bi+((0.5*LambdaC_Vsi_bi))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vsi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Tempt_GND)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+((0.5*LambdaC_Tempt_GND))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Tempt_GND*qs+qs_Vsi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vsi_bi+qs*qs_Vsi_bi_Tempt_GND)+qs_Vsi_bi_Tempt_GND))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))+(((((0.5*LambdaC_Tempt_GND))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Tempt_GND)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Tempt_GND+((0.5*LambdaC_Tempt_GND))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Tempt_GND))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(((((0.5*LambdaC_Tempt_GND)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND))+qs_Tempt_GND)))*(1.0+((0.5*LambdaC)*(1.0+qs)))-((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Tempt_GND)*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#endif
#endif
T0=(((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));
EXIT_IF_ISNAN((((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs)))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(((2.0*LambdaC_Vgi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vgi_bi-T0_Vgi_bi)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_di-T0_Vgi_bi_Vgm_di));
  T1_Vgi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_si-T0_Vgi_bi_Vgm_si));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdbulk_di-T0_Vgi_bi_Vdbulk_di));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsbulk_si-T0_Vgi_bi_Vsbulk_si));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgi_bi-T0_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdi_bi-T0_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsi_bi-T0_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Tempt_GND-T0_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(((2.0*LambdaC_Vdi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vdi_bi-T0_Vdi_bi)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_di-T0_Vdi_bi_Vgm_di));
  T1_Vdi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_si-T0_Vdi_bi_Vgm_si));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdbulk_di-T0_Vdi_bi_Vdbulk_di));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsbulk_si-T0_Vdi_bi_Vsbulk_si));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgi_bi-T0_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdi_bi-T0_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsi_bi-T0_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Tempt_GND-T0_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(((2.0*LambdaC_Vsi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vsi_bi-T0_Vsi_bi)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_di-T0_Vsi_bi_Vgm_di));
  T1_Vsi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_si-T0_Vsi_bi_Vgm_si));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdbulk_di-T0_Vsi_bi_Vdbulk_di));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsbulk_si-T0_Vsi_bi_Vsbulk_si));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgi_bi-T0_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdi_bi-T0_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsi_bi-T0_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Tempt_GND-T0_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((2.0*LambdaC_Tempt_GND)*(qs-T0))+((2.0*LambdaC)*(qs_Tempt_GND-T0_Tempt_GND)));
#endif
#endif
T1=((2.0*LambdaC)*(qs-T0));
EXIT_IF_ISNAN(((2.0*LambdaC)*(qs-T0)))
{
double m00_sqrt(d00_sqrt0,(1.0+(T1*T1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(T1*T1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)));
  T2_Vgi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)));
  T2_Vgi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)));
  T2_Vgi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)));
  T2_Vgi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)));
  T2_Vgi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)));
  T2_Vgi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)));
  T2_Vgi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)));
#endif
T2_Vdi_bi=((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)));
  T2_Vdi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)));
  T2_Vdi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)));
  T2_Vdi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)));
  T2_Vdi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)));
  T2_Vdi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)));
  T2_Vdi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)));
  T2_Vdi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)));
#endif
T2_Vsi_bi=((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)));
  T2_Vsi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)));
  T2_Vsi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)));
  T2_Vsi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)));
  T2_Vsi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)));
  T2_Vsi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)));
  T2_Vsi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)));
  T2_Vsi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0;
#endif
#endif
T2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_asinh(d00_asinh0,T1)
#if defined(_DERIVATEFORDDX)
double m10_asinh(d10_asinh0,d00_asinh0,T1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
ln_T1_T2_Vgi_bi=T1_Vgi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vgi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vgi_bi);
  ln_T1_T2_Vgi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vdi_bi);
  ln_T1_T2_Vgi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vsi_bi);
  ln_T1_T2_Vgi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Tempt_GND);
#endif
ln_T1_T2_Vdi_bi=T1_Vdi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vdi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vgi_bi);
  ln_T1_T2_Vdi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vdi_bi);
  ln_T1_T2_Vdi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vsi_bi);
  ln_T1_T2_Vdi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Tempt_GND);
#endif
ln_T1_T2_Vsi_bi=T1_Vsi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vsi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vgi_bi);
  ln_T1_T2_Vsi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vdi_bi);
  ln_T1_T2_Vsi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vsi_bi);
  ln_T1_T2_Vsi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
ln_T1_T2_Tempt_GND=T1_Tempt_GND*d10_asinh0;
#endif
#endif
ln_T1_T2=d00_asinh0;
EXIT_IF_ISNAN(d00_asinh0)
}
if
((T1!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vgi_bi)));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vgi_bi));
  T3_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vdi_bi));
  T3_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vsi_bi));
  T3_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Tempt_GND));
#endif
T3_Vdi_bi=(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vdi_bi)));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vgi_bi));
  T3_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vdi_bi));
  T3_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vsi_bi));
  T3_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Tempt_GND));
#endif
T3_Vsi_bi=(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vsi_bi)));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vgi_bi));
  T3_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vdi_bi));
  T3_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vsi_bi));
  T3_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T2_Tempt_GND+(((-T1_Tempt_GND/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Tempt_GND)));
#endif
#endif
T3=(T2+((1.0/T1)*ln_T1_T2));
EXIT_IF_ISNAN((T2+((1.0/T1)*ln_T1_T2)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vdi_bi=(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vsi_bi=(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T2_Tempt_GND+(-T2_Tempt_GND/T2/T2));
#endif
#endif
T3=(T2+(1.0/T2));
EXIT_IF_ISNAN((T2+(1.0/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))-((LambdaC_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi)))));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgm_si*qs+qs_Vgi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_si)+qs_Vgi_bi_Vgm_si)-(+(+T0_Vgi_bi_Vgm_si*T0+T0_Vgi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_si)+T0_Vgi_bi_Vgm_si))));
  T4_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgm_di*qs+qs_Vgi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_di)+qs_Vgi_bi_Vgm_di)-(+(+T0_Vgi_bi_Vgm_di*T0+T0_Vgi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_di)+T0_Vgi_bi_Vgm_di))));
  T4_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)-(+LambdaC_Vgi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vdbulk_di*qs+qs_Vgi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vdbulk_di)+qs_Vgi_bi_Vdbulk_di)-(+(+T0_Vgi_bi_Vdbulk_di*T0+T0_Vgi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vdbulk_di)+T0_Vgi_bi_Vdbulk_di))));
  T4_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)-(+LambdaC_Vgi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vsbulk_si*qs+qs_Vgi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vsbulk_si)+qs_Vgi_bi_Vsbulk_si)-(+(+T0_Vgi_bi_Vsbulk_si*T0+T0_Vgi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vsbulk_si)+T0_Vgi_bi_Vsbulk_si))));
  T4_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)-(+LambdaC_Vgi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgi_bi*qs+qs_Vgi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vgi_bi)+qs_Vgi_bi_Vgi_bi)-(+(+T0_Vgi_bi_Vgi_bi*T0+T0_Vgi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vgi_bi)+T0_Vgi_bi_Vgi_bi))));
  T4_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)-(+LambdaC_Vgi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vdi_bi*qs+qs_Vgi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vdi_bi)+qs_Vgi_bi_Vdi_bi)-(+(+T0_Vgi_bi_Vdi_bi*T0+T0_Vgi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vdi_bi)+T0_Vgi_bi_Vdi_bi))));
  T4_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)-(+LambdaC_Vgi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vsi_bi*qs+qs_Vgi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vsi_bi)+qs_Vgi_bi_Vsi_bi)-(+(+T0_Vgi_bi_Vsi_bi*T0+T0_Vgi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vsi_bi)+T0_Vgi_bi_Vsi_bi))));
  T4_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)-(+LambdaC_Vgi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Tempt_GND*qs+qs_Vgi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vgi_bi+qs*qs_Vgi_bi_Tempt_GND)+qs_Vgi_bi_Tempt_GND)-(+(+T0_Vgi_bi_Tempt_GND*T0+T0_Vgi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vgi_bi+T0*T0_Vgi_bi_Tempt_GND)+T0_Vgi_bi_Tempt_GND))));
#endif
T4_Vdi_bi=(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))-((LambdaC_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi)))));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgm_si*qs+qs_Vdi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_si)+qs_Vdi_bi_Vgm_si)-(+(+T0_Vdi_bi_Vgm_si*T0+T0_Vdi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_si)+T0_Vdi_bi_Vgm_si))));
  T4_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgm_di*qs+qs_Vdi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_di)+qs_Vdi_bi_Vgm_di)-(+(+T0_Vdi_bi_Vgm_di*T0+T0_Vdi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_di)+T0_Vdi_bi_Vgm_di))));
  T4_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)-(+LambdaC_Vdi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vdbulk_di*qs+qs_Vdi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vdbulk_di)+qs_Vdi_bi_Vdbulk_di)-(+(+T0_Vdi_bi_Vdbulk_di*T0+T0_Vdi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vdbulk_di)+T0_Vdi_bi_Vdbulk_di))));
  T4_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)-(+LambdaC_Vdi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vsbulk_si*qs+qs_Vdi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vsbulk_si)+qs_Vdi_bi_Vsbulk_si)-(+(+T0_Vdi_bi_Vsbulk_si*T0+T0_Vdi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vsbulk_si)+T0_Vdi_bi_Vsbulk_si))));
  T4_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)-(+LambdaC_Vdi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgi_bi*qs+qs_Vdi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vgi_bi)+qs_Vdi_bi_Vgi_bi)-(+(+T0_Vdi_bi_Vgi_bi*T0+T0_Vdi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vgi_bi)+T0_Vdi_bi_Vgi_bi))));
  T4_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)-(+LambdaC_Vdi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vdi_bi*qs+qs_Vdi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vdi_bi)+qs_Vdi_bi_Vdi_bi)-(+(+T0_Vdi_bi_Vdi_bi*T0+T0_Vdi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vdi_bi)+T0_Vdi_bi_Vdi_bi))));
  T4_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)-(+LambdaC_Vdi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vsi_bi*qs+qs_Vdi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vsi_bi)+qs_Vdi_bi_Vsi_bi)-(+(+T0_Vdi_bi_Vsi_bi*T0+T0_Vdi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vsi_bi)+T0_Vdi_bi_Vsi_bi))));
  T4_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)-(+LambdaC_Vdi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Tempt_GND*qs+qs_Vdi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vdi_bi+qs*qs_Vdi_bi_Tempt_GND)+qs_Vdi_bi_Tempt_GND)-(+(+T0_Vdi_bi_Tempt_GND*T0+T0_Vdi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_bi+T0*T0_Vdi_bi_Tempt_GND)+T0_Vdi_bi_Tempt_GND))));
#endif
T4_Vsi_bi=(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))-((LambdaC_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi)))));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgm_si*qs+qs_Vsi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_si)+qs_Vsi_bi_Vgm_si)-(+(+T0_Vsi_bi_Vgm_si*T0+T0_Vsi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_si)+T0_Vsi_bi_Vgm_si))));
  T4_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgm_di*qs+qs_Vsi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_di)+qs_Vsi_bi_Vgm_di)-(+(+T0_Vsi_bi_Vgm_di*T0+T0_Vsi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_di)+T0_Vsi_bi_Vgm_di))));
  T4_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)-(+LambdaC_Vsi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vdbulk_di*qs+qs_Vsi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vdbulk_di)+qs_Vsi_bi_Vdbulk_di)-(+(+T0_Vsi_bi_Vdbulk_di*T0+T0_Vsi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vdbulk_di)+T0_Vsi_bi_Vdbulk_di))));
  T4_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)-(+LambdaC_Vsi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vsbulk_si*qs+qs_Vsi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vsbulk_si)+qs_Vsi_bi_Vsbulk_si)-(+(+T0_Vsi_bi_Vsbulk_si*T0+T0_Vsi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vsbulk_si)+T0_Vsi_bi_Vsbulk_si))));
  T4_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)-(+LambdaC_Vsi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgi_bi*qs+qs_Vsi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vgi_bi)+qs_Vsi_bi_Vgi_bi)-(+(+T0_Vsi_bi_Vgi_bi*T0+T0_Vsi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vgi_bi)+T0_Vsi_bi_Vgi_bi))));
  T4_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)-(+LambdaC_Vsi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vdi_bi*qs+qs_Vsi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vdi_bi)+qs_Vsi_bi_Vdi_bi)-(+(+T0_Vsi_bi_Vdi_bi*T0+T0_Vsi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vdi_bi)+T0_Vsi_bi_Vdi_bi))));
  T4_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)-(+LambdaC_Vsi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vsi_bi*qs+qs_Vsi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vsi_bi)+qs_Vsi_bi_Vsi_bi)-(+(+T0_Vsi_bi_Vsi_bi*T0+T0_Vsi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vsi_bi)+T0_Vsi_bi_Vsi_bi))));
  T4_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)-(+LambdaC_Vsi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Tempt_GND*qs+qs_Vsi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vsi_bi+qs*qs_Vsi_bi_Tempt_GND)+qs_Vsi_bi_Tempt_GND)-(+(+T0_Vsi_bi_Tempt_GND*T0+T0_Vsi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vsi_bi+T0*T0_Vsi_bi_Tempt_GND)+T0_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))-((LambdaC_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND))+qs_Tempt_GND)-(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+T0_Tempt_GND)))));
#endif
#endif
T4=((T0*T3)-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
EXIT_IF_ISNAN(((T0*T3)-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0)))))
if
((T1!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgm_si*T2+T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgm_di*T2+T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vdbulk_di*T2+T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vsbulk_si*T2+T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgi_bi*T2+T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)-ln_T1_T2_Vgi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vdi_bi*T2+T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)-ln_T1_T2_Vgi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vsi_bi*T2+T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)-ln_T1_T2_Vgi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Tempt_GND*T2+T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)-ln_T1_T2_Vgi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
T5_Vdi_bi=((((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgm_si*T2+T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgm_di*T2+T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vdbulk_di*T2+T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vsbulk_si*T2+T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgi_bi*T2+T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)-ln_T1_T2_Vdi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vdi_bi*T2+T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)-ln_T1_T2_Vdi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vsi_bi*T2+T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)-ln_T1_T2_Vdi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Tempt_GND*T2+T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)-ln_T1_T2_Vdi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
T5_Vsi_bi=((((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgm_si*T2+T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgm_di*T2+T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vdbulk_di*T2+T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vsbulk_si*T2+T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgi_bi*T2+T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)-ln_T1_T2_Vsi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vdi_bi*T2+T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)-ln_T1_T2_Vsi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vsi_bi*T2+T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)-ln_T1_T2_Vsi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Tempt_GND*T2+T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)-ln_T1_T2_Vsi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((((-2.0)*LambdaC_Tempt_GND)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))-ln_T1_T2_Tempt_GND)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1));
#endif
#endif
T5=((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
EXIT_IF_ISNAN(((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(0.0)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vgi_bi_Vgm_di=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(0.0)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vgi_bi_Vdbulk_di=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdbulk_di)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((-2.0)*LambdaC_Vdbulk_di))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vgi_bi_Vsbulk_si=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsbulk_si)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((-2.0)*LambdaC_Vsbulk_si))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vgi_bi_Vgi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vgi_bi)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC_Vgi_bi))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vgi_bi_Vdi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdi_bi)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC_Vdi_bi))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vgi_bi_Vsi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsi_bi)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC_Vsi_bi))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vgi_bi_Tempt_GND=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Tempt_GND)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((-2.0)*LambdaC_Tempt_GND))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T5_Vdi_bi=((((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(0.0)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vdi_bi_Vgm_di=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(0.0)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vdi_bi_Vdbulk_di=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdbulk_di)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((-2.0)*LambdaC_Vdbulk_di))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vdi_bi_Vsbulk_si=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsbulk_si)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((-2.0)*LambdaC_Vsbulk_si))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vdi_bi_Vgi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vgi_bi)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC_Vgi_bi))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vdi_bi_Vdi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdi_bi)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC_Vdi_bi))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vdi_bi_Vsi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsi_bi)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC_Vsi_bi))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vdi_bi_Tempt_GND=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Tempt_GND)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((-2.0)*LambdaC_Tempt_GND))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T5_Vsi_bi=((((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(0.0)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vsi_bi_Vgm_di=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(0.0)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vsi_bi_Vdbulk_di=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdbulk_di)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((-2.0)*LambdaC_Vdbulk_di))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vsi_bi_Vsbulk_si=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsbulk_si)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((-2.0)*LambdaC_Vsbulk_si))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vsi_bi_Vgi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vgi_bi)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC_Vgi_bi))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vsi_bi_Vdi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdi_bi)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC_Vdi_bi))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vsi_bi_Vsi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsi_bi)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC_Vsi_bi))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vsi_bi_Tempt_GND=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Tempt_GND)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((-2.0)*LambdaC_Tempt_GND))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((((((-2.0)*LambdaC_Tempt_GND)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)));
#endif
#endif
T5=(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2));
EXIT_IF_ISNAN((((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=((((T0_Vgi_bi*T5)+(T0*T5_Vgi_bi))+T3_Vgi_bi)+((LambdaC_Vgi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vgi_bi))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+(+(+T0_Vgi_bi_Vgm_di*T5+T0_Vgi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vgi_bi+T0*T5_Vgi_bi_Vgm_di)+T3_Vgi_bi_Vgm_di)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)+0.0)));
  T6_Vgi_bi_Vgm_si=(+(+(+T0_Vgi_bi_Vgm_si*T5+T0_Vgi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vgi_bi+T0*T5_Vgi_bi_Vgm_si)+T3_Vgi_bi_Vgm_si)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)+0.0)));
  T6_Vgi_bi_Vdbulk_di=(+(+(+T0_Vgi_bi_Vdbulk_di*T5+T0_Vgi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vgi_bi+T0*T5_Vgi_bi_Vdbulk_di)+T3_Vgi_bi_Vdbulk_di)+(+LambdaC_Vgi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)+0.0)));
  T6_Vgi_bi_Vsbulk_si=(+(+(+T0_Vgi_bi_Vsbulk_si*T5+T0_Vgi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vgi_bi+T0*T5_Vgi_bi_Vsbulk_si)+T3_Vgi_bi_Vsbulk_si)+(+LambdaC_Vgi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)+0.0)));
  T6_Vgi_bi_Vgi_bi=(+(+(+T0_Vgi_bi_Vgi_bi*T5+T0_Vgi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vgi_bi)+T3_Vgi_bi_Vgi_bi)+(+LambdaC_Vgi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)+0.0)));
  T6_Vgi_bi_Vdi_bi=(+(+(+T0_Vgi_bi_Vdi_bi*T5+T0_Vgi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vdi_bi)+T3_Vgi_bi_Vdi_bi)+(+LambdaC_Vgi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)+0.0)));
  T6_Vgi_bi_Vsi_bi=(+(+(+T0_Vgi_bi_Vsi_bi*T5+T0_Vgi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vsi_bi)+T3_Vgi_bi_Vsi_bi)+(+LambdaC_Vgi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)+0.0)));
  T6_Vgi_bi_Tempt_GND=(+(+(+T0_Vgi_bi_Tempt_GND*T5+T0_Vgi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vgi_bi+T0*T5_Vgi_bi_Tempt_GND)+T3_Vgi_bi_Tempt_GND)+(+LambdaC_Vgi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)+0.0)));
#endif
T6_Vdi_bi=((((T0_Vdi_bi*T5)+(T0*T5_Vdi_bi))+T3_Vdi_bi)+((LambdaC_Vdi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vdi_bi))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(+(+T0_Vdi_bi_Vgm_di*T5+T0_Vdi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vdi_bi+T0*T5_Vdi_bi_Vgm_di)+T3_Vdi_bi_Vgm_di)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)+0.0)));
  T6_Vdi_bi_Vgm_si=(+(+(+T0_Vdi_bi_Vgm_si*T5+T0_Vdi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vdi_bi+T0*T5_Vdi_bi_Vgm_si)+T3_Vdi_bi_Vgm_si)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)+0.0)));
  T6_Vdi_bi_Vdbulk_di=(+(+(+T0_Vdi_bi_Vdbulk_di*T5+T0_Vdi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vdi_bi+T0*T5_Vdi_bi_Vdbulk_di)+T3_Vdi_bi_Vdbulk_di)+(+LambdaC_Vdi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)+0.0)));
  T6_Vdi_bi_Vsbulk_si=(+(+(+T0_Vdi_bi_Vsbulk_si*T5+T0_Vdi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vdi_bi+T0*T5_Vdi_bi_Vsbulk_si)+T3_Vdi_bi_Vsbulk_si)+(+LambdaC_Vdi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)+0.0)));
  T6_Vdi_bi_Vgi_bi=(+(+(+T0_Vdi_bi_Vgi_bi*T5+T0_Vdi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vgi_bi)+T3_Vdi_bi_Vgi_bi)+(+LambdaC_Vdi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)+0.0)));
  T6_Vdi_bi_Vdi_bi=(+(+(+T0_Vdi_bi_Vdi_bi*T5+T0_Vdi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vdi_bi)+T3_Vdi_bi_Vdi_bi)+(+LambdaC_Vdi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)+0.0)));
  T6_Vdi_bi_Vsi_bi=(+(+(+T0_Vdi_bi_Vsi_bi*T5+T0_Vdi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vsi_bi)+T3_Vdi_bi_Vsi_bi)+(+LambdaC_Vdi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)+0.0)));
  T6_Vdi_bi_Tempt_GND=(+(+(+T0_Vdi_bi_Tempt_GND*T5+T0_Vdi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vdi_bi+T0*T5_Vdi_bi_Tempt_GND)+T3_Vdi_bi_Tempt_GND)+(+LambdaC_Vdi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)+0.0)));
#endif
T6_Vsi_bi=((((T0_Vsi_bi*T5)+(T0*T5_Vsi_bi))+T3_Vsi_bi)+((LambdaC_Vsi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vsi_bi))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(+(+T0_Vsi_bi_Vgm_di*T5+T0_Vsi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vsi_bi+T0*T5_Vsi_bi_Vgm_di)+T3_Vsi_bi_Vgm_di)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)+0.0)));
  T6_Vsi_bi_Vgm_si=(+(+(+T0_Vsi_bi_Vgm_si*T5+T0_Vsi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vsi_bi+T0*T5_Vsi_bi_Vgm_si)+T3_Vsi_bi_Vgm_si)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)+0.0)));
  T6_Vsi_bi_Vdbulk_di=(+(+(+T0_Vsi_bi_Vdbulk_di*T5+T0_Vsi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vsi_bi+T0*T5_Vsi_bi_Vdbulk_di)+T3_Vsi_bi_Vdbulk_di)+(+LambdaC_Vsi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)+0.0)));
  T6_Vsi_bi_Vsbulk_si=(+(+(+T0_Vsi_bi_Vsbulk_si*T5+T0_Vsi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vsi_bi+T0*T5_Vsi_bi_Vsbulk_si)+T3_Vsi_bi_Vsbulk_si)+(+LambdaC_Vsi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)+0.0)));
  T6_Vsi_bi_Vgi_bi=(+(+(+T0_Vsi_bi_Vgi_bi*T5+T0_Vsi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vgi_bi)+T3_Vsi_bi_Vgi_bi)+(+LambdaC_Vsi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)+0.0)));
  T6_Vsi_bi_Vdi_bi=(+(+(+T0_Vsi_bi_Vdi_bi*T5+T0_Vsi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vdi_bi)+T3_Vsi_bi_Vdi_bi)+(+LambdaC_Vsi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)+0.0)));
  T6_Vsi_bi_Vsi_bi=(+(+(+T0_Vsi_bi_Vsi_bi*T5+T0_Vsi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vsi_bi)+T3_Vsi_bi_Vsi_bi)+(+LambdaC_Vsi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)+0.0)));
  T6_Vsi_bi_Tempt_GND=(+(+(+T0_Vsi_bi_Tempt_GND*T5+T0_Vsi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vsi_bi+T0*T5_Vsi_bi_Tempt_GND)+T3_Vsi_bi_Tempt_GND)+(+LambdaC_Vsi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)+0.0)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((((T0_Tempt_GND*T5)+(T0*T5_Tempt_GND))+T3_Tempt_GND)+((LambdaC_Tempt_GND*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Tempt_GND))));
#endif
#endif
T6=(((T0*T5)+T3)+(LambdaC*((2.0*T0)+1.0)));
EXIT_IF_ISNAN((((T0*T5)+T3)+(LambdaC*((2.0*T0)+1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(T0_Vgi_bi-((T4_Vgi_bi*T6-T4*T6_Vgi_bi)/T6/T6));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+T0_Vgi_bi_Vgm_di-(T4_Vgi_bi_Vgm_di/T6-(T4_Vgi_bi*T6_Vgm_di+T4_Vgm_di*T6_Vgi_bi+T4*T6_Vgi_bi_Vgm_di)/T6/T6+2*T4*T6_Vgi_bi*T6_Vgm_di/T6/T6/T6));
  T0_Vgi_bi_Vgm_si=(+T0_Vgi_bi_Vgm_si-(T4_Vgi_bi_Vgm_si/T6-(T4_Vgi_bi*T6_Vgm_si+T4_Vgm_si*T6_Vgi_bi+T4*T6_Vgi_bi_Vgm_si)/T6/T6+2*T4*T6_Vgi_bi*T6_Vgm_si/T6/T6/T6));
  T0_Vgi_bi_Vdbulk_di=(+T0_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T6-(T4_Vgi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vgi_bi+T4*T6_Vgi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vgi_bi*T6_Vdbulk_di/T6/T6/T6));
  T0_Vgi_bi_Vsbulk_si=(+T0_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T6-(T4_Vgi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vgi_bi+T4*T6_Vgi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vgi_bi*T6_Vsbulk_si/T6/T6/T6));
  T0_Vgi_bi_Vgi_bi=(+T0_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T6-(T4_Vgi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vgi_bi/T6/T6/T6));
  T0_Vgi_bi_Vdi_bi=(+T0_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T6-(T4_Vgi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vdi_bi/T6/T6/T6));
  T0_Vgi_bi_Vsi_bi=(+T0_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T6-(T4_Vgi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vsi_bi/T6/T6/T6));
  T0_Vgi_bi_Tempt_GND=(+T0_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T6-(T4_Vgi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vgi_bi+T4*T6_Vgi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vgi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
T0_Vdi_bi=(T0_Vdi_bi-((T4_Vdi_bi*T6-T4*T6_Vdi_bi)/T6/T6));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+T0_Vdi_bi_Vgm_di-(T4_Vdi_bi_Vgm_di/T6-(T4_Vdi_bi*T6_Vgm_di+T4_Vgm_di*T6_Vdi_bi+T4*T6_Vdi_bi_Vgm_di)/T6/T6+2*T4*T6_Vdi_bi*T6_Vgm_di/T6/T6/T6));
  T0_Vdi_bi_Vgm_si=(+T0_Vdi_bi_Vgm_si-(T4_Vdi_bi_Vgm_si/T6-(T4_Vdi_bi*T6_Vgm_si+T4_Vgm_si*T6_Vdi_bi+T4*T6_Vdi_bi_Vgm_si)/T6/T6+2*T4*T6_Vdi_bi*T6_Vgm_si/T6/T6/T6));
  T0_Vdi_bi_Vdbulk_di=(+T0_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T6-(T4_Vdi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vdi_bi+T4*T6_Vdi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vdi_bi*T6_Vdbulk_di/T6/T6/T6));
  T0_Vdi_bi_Vsbulk_si=(+T0_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T6-(T4_Vdi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vdi_bi+T4*T6_Vdi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vdi_bi*T6_Vsbulk_si/T6/T6/T6));
  T0_Vdi_bi_Vgi_bi=(+T0_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T6-(T4_Vdi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vgi_bi/T6/T6/T6));
  T0_Vdi_bi_Vdi_bi=(+T0_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T6-(T4_Vdi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vdi_bi/T6/T6/T6));
  T0_Vdi_bi_Vsi_bi=(+T0_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T6-(T4_Vdi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vsi_bi/T6/T6/T6));
  T0_Vdi_bi_Tempt_GND=(+T0_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T6-(T4_Vdi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vdi_bi+T4*T6_Vdi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vdi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
T0_Vsi_bi=(T0_Vsi_bi-((T4_Vsi_bi*T6-T4*T6_Vsi_bi)/T6/T6));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+T0_Vsi_bi_Vgm_di-(T4_Vsi_bi_Vgm_di/T6-(T4_Vsi_bi*T6_Vgm_di+T4_Vgm_di*T6_Vsi_bi+T4*T6_Vsi_bi_Vgm_di)/T6/T6+2*T4*T6_Vsi_bi*T6_Vgm_di/T6/T6/T6));
  T0_Vsi_bi_Vgm_si=(+T0_Vsi_bi_Vgm_si-(T4_Vsi_bi_Vgm_si/T6-(T4_Vsi_bi*T6_Vgm_si+T4_Vgm_si*T6_Vsi_bi+T4*T6_Vsi_bi_Vgm_si)/T6/T6+2*T4*T6_Vsi_bi*T6_Vgm_si/T6/T6/T6));
  T0_Vsi_bi_Vdbulk_di=(+T0_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T6-(T4_Vsi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vsi_bi+T4*T6_Vsi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vsi_bi*T6_Vdbulk_di/T6/T6/T6));
  T0_Vsi_bi_Vsbulk_si=(+T0_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T6-(T4_Vsi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vsi_bi+T4*T6_Vsi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vsi_bi*T6_Vsbulk_si/T6/T6/T6));
  T0_Vsi_bi_Vgi_bi=(+T0_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T6-(T4_Vsi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vgi_bi/T6/T6/T6));
  T0_Vsi_bi_Vdi_bi=(+T0_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T6-(T4_Vsi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vdi_bi/T6/T6/T6));
  T0_Vsi_bi_Vsi_bi=(+T0_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T6-(T4_Vsi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vsi_bi/T6/T6/T6));
  T0_Vsi_bi_Tempt_GND=(+T0_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T6-(T4_Vsi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vsi_bi+T4*T6_Vsi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vsi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(T0_Tempt_GND-((T4_Tempt_GND*T6-T4*T6_Tempt_GND)/T6/T6));
#endif
#endif
T0=(T0-(T4/T6));
EXIT_IF_ISNAN((T0-(T4/T6)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(((2.0*LambdaC_Vgi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vgi_bi-T0_Vgi_bi)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_di-T0_Vgi_bi_Vgm_di));
  T1_Vgi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_si-T0_Vgi_bi_Vgm_si));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdbulk_di-T0_Vgi_bi_Vdbulk_di));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsbulk_si-T0_Vgi_bi_Vsbulk_si));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgi_bi-T0_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdi_bi-T0_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsi_bi-T0_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Tempt_GND-T0_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(((2.0*LambdaC_Vdi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vdi_bi-T0_Vdi_bi)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_di-T0_Vdi_bi_Vgm_di));
  T1_Vdi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_si-T0_Vdi_bi_Vgm_si));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdbulk_di-T0_Vdi_bi_Vdbulk_di));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsbulk_si-T0_Vdi_bi_Vsbulk_si));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgi_bi-T0_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdi_bi-T0_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsi_bi-T0_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Tempt_GND-T0_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(((2.0*LambdaC_Vsi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vsi_bi-T0_Vsi_bi)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_di-T0_Vsi_bi_Vgm_di));
  T1_Vsi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_si-T0_Vsi_bi_Vgm_si));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdbulk_di-T0_Vsi_bi_Vdbulk_di));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsbulk_si-T0_Vsi_bi_Vsbulk_si));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgi_bi-T0_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdi_bi-T0_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsi_bi-T0_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Tempt_GND-T0_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((2.0*LambdaC_Tempt_GND)*(qs-T0))+((2.0*LambdaC)*(qs_Tempt_GND-T0_Tempt_GND)));
#endif
#endif
T1=((2.0*LambdaC)*(qs-T0));
EXIT_IF_ISNAN(((2.0*LambdaC)*(qs-T0)))
{
double m00_sqrt(d00_sqrt0,(1.0+(T1*T1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(T1*T1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)));
  T2_Vgi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)));
  T2_Vgi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)));
  T2_Vgi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)));
  T2_Vgi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)));
  T2_Vgi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)));
  T2_Vgi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)));
  T2_Vgi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)));
#endif
T2_Vdi_bi=((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)));
  T2_Vdi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)));
  T2_Vdi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)));
  T2_Vdi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)));
  T2_Vdi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)));
  T2_Vdi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)));
  T2_Vdi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)));
  T2_Vdi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)));
#endif
T2_Vsi_bi=((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)));
  T2_Vsi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)));
  T2_Vsi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)));
  T2_Vsi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)));
  T2_Vsi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)));
  T2_Vsi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)));
  T2_Vsi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)));
  T2_Vsi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0;
#endif
#endif
T2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_asinh(d00_asinh0,T1)
#if defined(_DERIVATEFORDDX)
double m10_asinh(d10_asinh0,d00_asinh0,T1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
ln_T1_T2_Vgi_bi=T1_Vgi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vgi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vgi_bi);
  ln_T1_T2_Vgi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vdi_bi);
  ln_T1_T2_Vgi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vsi_bi);
  ln_T1_T2_Vgi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Tempt_GND);
#endif
ln_T1_T2_Vdi_bi=T1_Vdi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vdi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vgi_bi);
  ln_T1_T2_Vdi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vdi_bi);
  ln_T1_T2_Vdi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vsi_bi);
  ln_T1_T2_Vdi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Tempt_GND);
#endif
ln_T1_T2_Vsi_bi=T1_Vsi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vsi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vgi_bi);
  ln_T1_T2_Vsi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vdi_bi);
  ln_T1_T2_Vsi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vsi_bi);
  ln_T1_T2_Vsi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
ln_T1_T2_Tempt_GND=T1_Tempt_GND*d10_asinh0;
#endif
#endif
ln_T1_T2=d00_asinh0;
EXIT_IF_ISNAN(d00_asinh0)
}
if
((T1!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vgi_bi)));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vgi_bi));
  T3_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vdi_bi));
  T3_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vsi_bi));
  T3_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Tempt_GND));
#endif
T3_Vdi_bi=(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vdi_bi)));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vgi_bi));
  T3_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vdi_bi));
  T3_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vsi_bi));
  T3_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Tempt_GND));
#endif
T3_Vsi_bi=(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vsi_bi)));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vgi_bi));
  T3_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vdi_bi));
  T3_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vsi_bi));
  T3_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T2_Tempt_GND+(((-T1_Tempt_GND/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Tempt_GND)));
#endif
#endif
T3=(T2+((1.0/T1)*ln_T1_T2));
EXIT_IF_ISNAN((T2+((1.0/T1)*ln_T1_T2)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vdi_bi=(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vsi_bi=(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T2_Tempt_GND+(-T2_Tempt_GND/T2/T2));
#endif
#endif
T3=(T2+(1.0/T2));
EXIT_IF_ISNAN((T2+(1.0/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))-((LambdaC_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi)))));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgm_si*qs+qs_Vgi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_si)+qs_Vgi_bi_Vgm_si)-(+(+T0_Vgi_bi_Vgm_si*T0+T0_Vgi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_si)+T0_Vgi_bi_Vgm_si))));
  T4_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgm_di*qs+qs_Vgi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_di)+qs_Vgi_bi_Vgm_di)-(+(+T0_Vgi_bi_Vgm_di*T0+T0_Vgi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_di)+T0_Vgi_bi_Vgm_di))));
  T4_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)-(+LambdaC_Vgi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vdbulk_di*qs+qs_Vgi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vdbulk_di)+qs_Vgi_bi_Vdbulk_di)-(+(+T0_Vgi_bi_Vdbulk_di*T0+T0_Vgi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vdbulk_di)+T0_Vgi_bi_Vdbulk_di))));
  T4_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)-(+LambdaC_Vgi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vsbulk_si*qs+qs_Vgi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vsbulk_si)+qs_Vgi_bi_Vsbulk_si)-(+(+T0_Vgi_bi_Vsbulk_si*T0+T0_Vgi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vsbulk_si)+T0_Vgi_bi_Vsbulk_si))));
  T4_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)-(+LambdaC_Vgi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgi_bi*qs+qs_Vgi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vgi_bi)+qs_Vgi_bi_Vgi_bi)-(+(+T0_Vgi_bi_Vgi_bi*T0+T0_Vgi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vgi_bi)+T0_Vgi_bi_Vgi_bi))));
  T4_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)-(+LambdaC_Vgi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vdi_bi*qs+qs_Vgi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vdi_bi)+qs_Vgi_bi_Vdi_bi)-(+(+T0_Vgi_bi_Vdi_bi*T0+T0_Vgi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vdi_bi)+T0_Vgi_bi_Vdi_bi))));
  T4_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)-(+LambdaC_Vgi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vsi_bi*qs+qs_Vgi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vsi_bi)+qs_Vgi_bi_Vsi_bi)-(+(+T0_Vgi_bi_Vsi_bi*T0+T0_Vgi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vsi_bi)+T0_Vgi_bi_Vsi_bi))));
  T4_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)-(+LambdaC_Vgi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Tempt_GND*qs+qs_Vgi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vgi_bi+qs*qs_Vgi_bi_Tempt_GND)+qs_Vgi_bi_Tempt_GND)-(+(+T0_Vgi_bi_Tempt_GND*T0+T0_Vgi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vgi_bi+T0*T0_Vgi_bi_Tempt_GND)+T0_Vgi_bi_Tempt_GND))));
#endif
T4_Vdi_bi=(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))-((LambdaC_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi)))));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgm_si*qs+qs_Vdi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_si)+qs_Vdi_bi_Vgm_si)-(+(+T0_Vdi_bi_Vgm_si*T0+T0_Vdi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_si)+T0_Vdi_bi_Vgm_si))));
  T4_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgm_di*qs+qs_Vdi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_di)+qs_Vdi_bi_Vgm_di)-(+(+T0_Vdi_bi_Vgm_di*T0+T0_Vdi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_di)+T0_Vdi_bi_Vgm_di))));
  T4_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)-(+LambdaC_Vdi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vdbulk_di*qs+qs_Vdi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vdbulk_di)+qs_Vdi_bi_Vdbulk_di)-(+(+T0_Vdi_bi_Vdbulk_di*T0+T0_Vdi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vdbulk_di)+T0_Vdi_bi_Vdbulk_di))));
  T4_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)-(+LambdaC_Vdi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vsbulk_si*qs+qs_Vdi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vsbulk_si)+qs_Vdi_bi_Vsbulk_si)-(+(+T0_Vdi_bi_Vsbulk_si*T0+T0_Vdi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vsbulk_si)+T0_Vdi_bi_Vsbulk_si))));
  T4_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)-(+LambdaC_Vdi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgi_bi*qs+qs_Vdi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vgi_bi)+qs_Vdi_bi_Vgi_bi)-(+(+T0_Vdi_bi_Vgi_bi*T0+T0_Vdi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vgi_bi)+T0_Vdi_bi_Vgi_bi))));
  T4_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)-(+LambdaC_Vdi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vdi_bi*qs+qs_Vdi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vdi_bi)+qs_Vdi_bi_Vdi_bi)-(+(+T0_Vdi_bi_Vdi_bi*T0+T0_Vdi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vdi_bi)+T0_Vdi_bi_Vdi_bi))));
  T4_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)-(+LambdaC_Vdi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vsi_bi*qs+qs_Vdi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vsi_bi)+qs_Vdi_bi_Vsi_bi)-(+(+T0_Vdi_bi_Vsi_bi*T0+T0_Vdi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vsi_bi)+T0_Vdi_bi_Vsi_bi))));
  T4_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)-(+LambdaC_Vdi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Tempt_GND*qs+qs_Vdi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vdi_bi+qs*qs_Vdi_bi_Tempt_GND)+qs_Vdi_bi_Tempt_GND)-(+(+T0_Vdi_bi_Tempt_GND*T0+T0_Vdi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_bi+T0*T0_Vdi_bi_Tempt_GND)+T0_Vdi_bi_Tempt_GND))));
#endif
T4_Vsi_bi=(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))-((LambdaC_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi)))));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgm_si*qs+qs_Vsi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_si)+qs_Vsi_bi_Vgm_si)-(+(+T0_Vsi_bi_Vgm_si*T0+T0_Vsi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_si)+T0_Vsi_bi_Vgm_si))));
  T4_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgm_di*qs+qs_Vsi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_di)+qs_Vsi_bi_Vgm_di)-(+(+T0_Vsi_bi_Vgm_di*T0+T0_Vsi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_di)+T0_Vsi_bi_Vgm_di))));
  T4_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)-(+LambdaC_Vsi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vdbulk_di*qs+qs_Vsi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vdbulk_di)+qs_Vsi_bi_Vdbulk_di)-(+(+T0_Vsi_bi_Vdbulk_di*T0+T0_Vsi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vdbulk_di)+T0_Vsi_bi_Vdbulk_di))));
  T4_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)-(+LambdaC_Vsi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vsbulk_si*qs+qs_Vsi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vsbulk_si)+qs_Vsi_bi_Vsbulk_si)-(+(+T0_Vsi_bi_Vsbulk_si*T0+T0_Vsi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vsbulk_si)+T0_Vsi_bi_Vsbulk_si))));
  T4_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)-(+LambdaC_Vsi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgi_bi*qs+qs_Vsi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vgi_bi)+qs_Vsi_bi_Vgi_bi)-(+(+T0_Vsi_bi_Vgi_bi*T0+T0_Vsi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vgi_bi)+T0_Vsi_bi_Vgi_bi))));
  T4_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)-(+LambdaC_Vsi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vdi_bi*qs+qs_Vsi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vdi_bi)+qs_Vsi_bi_Vdi_bi)-(+(+T0_Vsi_bi_Vdi_bi*T0+T0_Vsi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vdi_bi)+T0_Vsi_bi_Vdi_bi))));
  T4_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)-(+LambdaC_Vsi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vsi_bi*qs+qs_Vsi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vsi_bi)+qs_Vsi_bi_Vsi_bi)-(+(+T0_Vsi_bi_Vsi_bi*T0+T0_Vsi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vsi_bi)+T0_Vsi_bi_Vsi_bi))));
  T4_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)-(+LambdaC_Vsi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Tempt_GND*qs+qs_Vsi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vsi_bi+qs*qs_Vsi_bi_Tempt_GND)+qs_Vsi_bi_Tempt_GND)-(+(+T0_Vsi_bi_Tempt_GND*T0+T0_Vsi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vsi_bi+T0*T0_Vsi_bi_Tempt_GND)+T0_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))-((LambdaC_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND))+qs_Tempt_GND)-(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+T0_Tempt_GND)))));
#endif
#endif
T4=((T0*T3)-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
EXIT_IF_ISNAN(((T0*T3)-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0)))))
if
((T1!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgm_si*T2+T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgm_di*T2+T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vdbulk_di*T2+T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vsbulk_si*T2+T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgi_bi*T2+T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)-ln_T1_T2_Vgi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vdi_bi*T2+T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)-ln_T1_T2_Vgi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vsi_bi*T2+T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)-ln_T1_T2_Vgi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Tempt_GND*T2+T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)-ln_T1_T2_Vgi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
T5_Vdi_bi=((((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgm_si*T2+T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgm_di*T2+T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vdbulk_di*T2+T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vsbulk_si*T2+T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgi_bi*T2+T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)-ln_T1_T2_Vdi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vdi_bi*T2+T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)-ln_T1_T2_Vdi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vsi_bi*T2+T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)-ln_T1_T2_Vdi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Tempt_GND*T2+T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)-ln_T1_T2_Vdi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
T5_Vsi_bi=((((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgm_si*T2+T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgm_di*T2+T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vdbulk_di*T2+T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vsbulk_si*T2+T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgi_bi*T2+T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)-ln_T1_T2_Vsi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vdi_bi*T2+T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)-ln_T1_T2_Vsi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vsi_bi*T2+T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)-ln_T1_T2_Vsi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Tempt_GND*T2+T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)-ln_T1_T2_Vsi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((((-2.0)*LambdaC_Tempt_GND)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))-ln_T1_T2_Tempt_GND)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1));
#endif
#endif
T5=((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
EXIT_IF_ISNAN(((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+(((T1/T2)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2)*(T1/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(T1/T2)*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vgi_bi_Vgm_di=(+(+(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2)*(T1/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(T1/T2)*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vgi_bi_Vdbulk_di=(+(+(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2)*(T1/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(T1/T2)*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vgi_bi_Vsbulk_si=(+(+(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2)*(T1/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(T1/T2)*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vgi_bi_Vgi_bi=(+(+(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2)*(T1/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(T1/T2)*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vgi_bi_Vdi_bi=(+(+(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2)*(T1/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(T1/T2)*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vgi_bi_Vsi_bi=(+(+(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2)*(T1/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(T1/T2)*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vgi_bi_Tempt_GND=(+(+(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2)*(T1/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(T1/T2)*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T5_Vdi_bi=((((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+(((T1/T2)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2)*(T1/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(T1/T2)*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vdi_bi_Vgm_di=(+(+(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2)*(T1/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(T1/T2)*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vdi_bi_Vdbulk_di=(+(+(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2)*(T1/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(T1/T2)*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vdi_bi_Vsbulk_si=(+(+(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2)*(T1/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(T1/T2)*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vdi_bi_Vgi_bi=(+(+(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2)*(T1/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(T1/T2)*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vdi_bi_Vdi_bi=(+(+(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2)*(T1/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(T1/T2)*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vdi_bi_Vsi_bi=(+(+(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2)*(T1/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(T1/T2)*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vdi_bi_Tempt_GND=(+(+(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2)*(T1/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(T1/T2)*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T5_Vsi_bi=((((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+(((T1/T2)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2)*(T1/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(T1/T2)*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vsi_bi_Vgm_di=(+(+(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2)*(T1/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(T1/T2)*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vsi_bi_Vdbulk_di=(+(+(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2)*(T1/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(T1/T2)*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vsi_bi_Vsbulk_si=(+(+(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2)*(T1/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(T1/T2)*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vsi_bi_Vgi_bi=(+(+(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2)*(T1/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(T1/T2)*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vsi_bi_Vdi_bi=(+(+(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2)*(T1/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(T1/T2)*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vsi_bi_Vsi_bi=(+(+(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2)*(T1/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(T1/T2)*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vsi_bi_Tempt_GND=(+(+(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2)*(T1/T2)+((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(T1/T2)*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((T1/T2)*(T1/T2))*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)*(T1/T2))+((T1/T2)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)))*(T1/T2))+(((T1/T2)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)));
#endif
#endif
T5=(((T1/T2)*(T1/T2))*(T1/T2));
EXIT_IF_ISNAN((((T1/T2)*(T1/T2))*(T1/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=((((T0_Vgi_bi*T5)+(T0*T5_Vgi_bi))+T3_Vgi_bi)+((LambdaC_Vgi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vgi_bi))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+(+(+T0_Vgi_bi_Vgm_di*T5+T0_Vgi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vgi_bi+T0*T5_Vgi_bi_Vgm_di)+T3_Vgi_bi_Vgm_di)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)+0.0)));
  T6_Vgi_bi_Vgm_si=(+(+(+T0_Vgi_bi_Vgm_si*T5+T0_Vgi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vgi_bi+T0*T5_Vgi_bi_Vgm_si)+T3_Vgi_bi_Vgm_si)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)+0.0)));
  T6_Vgi_bi_Vdbulk_di=(+(+(+T0_Vgi_bi_Vdbulk_di*T5+T0_Vgi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vgi_bi+T0*T5_Vgi_bi_Vdbulk_di)+T3_Vgi_bi_Vdbulk_di)+(+LambdaC_Vgi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)+0.0)));
  T6_Vgi_bi_Vsbulk_si=(+(+(+T0_Vgi_bi_Vsbulk_si*T5+T0_Vgi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vgi_bi+T0*T5_Vgi_bi_Vsbulk_si)+T3_Vgi_bi_Vsbulk_si)+(+LambdaC_Vgi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)+0.0)));
  T6_Vgi_bi_Vgi_bi=(+(+(+T0_Vgi_bi_Vgi_bi*T5+T0_Vgi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vgi_bi)+T3_Vgi_bi_Vgi_bi)+(+LambdaC_Vgi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)+0.0)));
  T6_Vgi_bi_Vdi_bi=(+(+(+T0_Vgi_bi_Vdi_bi*T5+T0_Vgi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vdi_bi)+T3_Vgi_bi_Vdi_bi)+(+LambdaC_Vgi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)+0.0)));
  T6_Vgi_bi_Vsi_bi=(+(+(+T0_Vgi_bi_Vsi_bi*T5+T0_Vgi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vsi_bi)+T3_Vgi_bi_Vsi_bi)+(+LambdaC_Vgi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)+0.0)));
  T6_Vgi_bi_Tempt_GND=(+(+(+T0_Vgi_bi_Tempt_GND*T5+T0_Vgi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vgi_bi+T0*T5_Vgi_bi_Tempt_GND)+T3_Vgi_bi_Tempt_GND)+(+LambdaC_Vgi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)+0.0)));
#endif
T6_Vdi_bi=((((T0_Vdi_bi*T5)+(T0*T5_Vdi_bi))+T3_Vdi_bi)+((LambdaC_Vdi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vdi_bi))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(+(+T0_Vdi_bi_Vgm_di*T5+T0_Vdi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vdi_bi+T0*T5_Vdi_bi_Vgm_di)+T3_Vdi_bi_Vgm_di)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)+0.0)));
  T6_Vdi_bi_Vgm_si=(+(+(+T0_Vdi_bi_Vgm_si*T5+T0_Vdi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vdi_bi+T0*T5_Vdi_bi_Vgm_si)+T3_Vdi_bi_Vgm_si)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)+0.0)));
  T6_Vdi_bi_Vdbulk_di=(+(+(+T0_Vdi_bi_Vdbulk_di*T5+T0_Vdi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vdi_bi+T0*T5_Vdi_bi_Vdbulk_di)+T3_Vdi_bi_Vdbulk_di)+(+LambdaC_Vdi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)+0.0)));
  T6_Vdi_bi_Vsbulk_si=(+(+(+T0_Vdi_bi_Vsbulk_si*T5+T0_Vdi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vdi_bi+T0*T5_Vdi_bi_Vsbulk_si)+T3_Vdi_bi_Vsbulk_si)+(+LambdaC_Vdi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)+0.0)));
  T6_Vdi_bi_Vgi_bi=(+(+(+T0_Vdi_bi_Vgi_bi*T5+T0_Vdi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vgi_bi)+T3_Vdi_bi_Vgi_bi)+(+LambdaC_Vdi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)+0.0)));
  T6_Vdi_bi_Vdi_bi=(+(+(+T0_Vdi_bi_Vdi_bi*T5+T0_Vdi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vdi_bi)+T3_Vdi_bi_Vdi_bi)+(+LambdaC_Vdi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)+0.0)));
  T6_Vdi_bi_Vsi_bi=(+(+(+T0_Vdi_bi_Vsi_bi*T5+T0_Vdi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vsi_bi)+T3_Vdi_bi_Vsi_bi)+(+LambdaC_Vdi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)+0.0)));
  T6_Vdi_bi_Tempt_GND=(+(+(+T0_Vdi_bi_Tempt_GND*T5+T0_Vdi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vdi_bi+T0*T5_Vdi_bi_Tempt_GND)+T3_Vdi_bi_Tempt_GND)+(+LambdaC_Vdi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)+0.0)));
#endif
T6_Vsi_bi=((((T0_Vsi_bi*T5)+(T0*T5_Vsi_bi))+T3_Vsi_bi)+((LambdaC_Vsi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vsi_bi))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(+(+T0_Vsi_bi_Vgm_di*T5+T0_Vsi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vsi_bi+T0*T5_Vsi_bi_Vgm_di)+T3_Vsi_bi_Vgm_di)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)+0.0)));
  T6_Vsi_bi_Vgm_si=(+(+(+T0_Vsi_bi_Vgm_si*T5+T0_Vsi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vsi_bi+T0*T5_Vsi_bi_Vgm_si)+T3_Vsi_bi_Vgm_si)+(+0.0*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)+0.0)));
  T6_Vsi_bi_Vdbulk_di=(+(+(+T0_Vsi_bi_Vdbulk_di*T5+T0_Vsi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vsi_bi+T0*T5_Vsi_bi_Vdbulk_di)+T3_Vsi_bi_Vdbulk_di)+(+LambdaC_Vsi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)+0.0)));
  T6_Vsi_bi_Vsbulk_si=(+(+(+T0_Vsi_bi_Vsbulk_si*T5+T0_Vsi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vsi_bi+T0*T5_Vsi_bi_Vsbulk_si)+T3_Vsi_bi_Vsbulk_si)+(+LambdaC_Vsi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)+0.0)));
  T6_Vsi_bi_Vgi_bi=(+(+(+T0_Vsi_bi_Vgi_bi*T5+T0_Vsi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vgi_bi)+T3_Vsi_bi_Vgi_bi)+(+LambdaC_Vsi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)+0.0)));
  T6_Vsi_bi_Vdi_bi=(+(+(+T0_Vsi_bi_Vdi_bi*T5+T0_Vsi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vdi_bi)+T3_Vsi_bi_Vdi_bi)+(+LambdaC_Vsi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)+0.0)));
  T6_Vsi_bi_Vsi_bi=(+(+(+T0_Vsi_bi_Vsi_bi*T5+T0_Vsi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vsi_bi)+T3_Vsi_bi_Vsi_bi)+(+LambdaC_Vsi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)+0.0)));
  T6_Vsi_bi_Tempt_GND=(+(+(+T0_Vsi_bi_Tempt_GND*T5+T0_Vsi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vsi_bi+T0*T5_Vsi_bi_Tempt_GND)+T3_Vsi_bi_Tempt_GND)+(+LambdaC_Vsi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)+0.0)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((((T0_Tempt_GND*T5)+(T0*T5_Tempt_GND))+T3_Tempt_GND)+((LambdaC_Tempt_GND*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Tempt_GND))));
#endif
#endif
T6=(((T0*T5)+T3)+(LambdaC*((2.0*T0)+1.0)));
EXIT_IF_ISNAN((((T0*T5)+T3)+(LambdaC*((2.0*T0)+1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
qdsat_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  qdsat_Vdbulk_di_Vdbulk_di=0.0;
  qdsat_Vdbulk_di_Vsbulk_si=0.0;
  qdsat_Vdbulk_di_Vgi_bi=0.0;
  qdsat_Vdbulk_di_Vdi_bi=0.0;
  qdsat_Vdbulk_di_Vsi_bi=0.0;
  qdsat_Vdbulk_di_Tempt_GND=0.0;
#endif
qdsat_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  qdsat_Vsbulk_si_Vdbulk_di=0.0;
  qdsat_Vsbulk_si_Vsbulk_si=0.0;
  qdsat_Vsbulk_si_Vgi_bi=0.0;
  qdsat_Vsbulk_si_Vdi_bi=0.0;
  qdsat_Vsbulk_si_Vsi_bi=0.0;
  qdsat_Vsbulk_si_Tempt_GND=0.0;
#endif
qdsat_Vgi_bi=(T0_Vgi_bi-((T4_Vgi_bi*T6-T4*T6_Vgi_bi)/T6/T6));
#if defined(_DERIVATE2)
  qdsat_Vgi_bi_Vdbulk_di=(+T0_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T6-(T4_Vgi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vgi_bi+T4*T6_Vgi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vgi_bi*T6_Vdbulk_di/T6/T6/T6));
  qdsat_Vgi_bi_Vsbulk_si=(+T0_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T6-(T4_Vgi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vgi_bi+T4*T6_Vgi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vgi_bi*T6_Vsbulk_si/T6/T6/T6));
  qdsat_Vgi_bi_Vgi_bi=(+T0_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T6-(T4_Vgi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vgi_bi/T6/T6/T6));
  qdsat_Vgi_bi_Vdi_bi=(+T0_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T6-(T4_Vgi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vdi_bi/T6/T6/T6));
  qdsat_Vgi_bi_Vsi_bi=(+T0_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T6-(T4_Vgi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vsi_bi/T6/T6/T6));
  qdsat_Vgi_bi_Tempt_GND=(+T0_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T6-(T4_Vgi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vgi_bi+T4*T6_Vgi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vgi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
qdsat_Vdi_bi=(T0_Vdi_bi-((T4_Vdi_bi*T6-T4*T6_Vdi_bi)/T6/T6));
#if defined(_DERIVATE2)
  qdsat_Vdi_bi_Vdbulk_di=(+T0_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T6-(T4_Vdi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vdi_bi+T4*T6_Vdi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vdi_bi*T6_Vdbulk_di/T6/T6/T6));
  qdsat_Vdi_bi_Vsbulk_si=(+T0_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T6-(T4_Vdi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vdi_bi+T4*T6_Vdi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vdi_bi*T6_Vsbulk_si/T6/T6/T6));
  qdsat_Vdi_bi_Vgi_bi=(+T0_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T6-(T4_Vdi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vgi_bi/T6/T6/T6));
  qdsat_Vdi_bi_Vdi_bi=(+T0_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T6-(T4_Vdi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vdi_bi/T6/T6/T6));
  qdsat_Vdi_bi_Vsi_bi=(+T0_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T6-(T4_Vdi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vsi_bi/T6/T6/T6));
  qdsat_Vdi_bi_Tempt_GND=(+T0_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T6-(T4_Vdi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vdi_bi+T4*T6_Vdi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vdi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
qdsat_Vsi_bi=(T0_Vsi_bi-((T4_Vsi_bi*T6-T4*T6_Vsi_bi)/T6/T6));
#if defined(_DERIVATE2)
  qdsat_Vsi_bi_Vdbulk_di=(+T0_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T6-(T4_Vsi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vsi_bi+T4*T6_Vsi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vsi_bi*T6_Vdbulk_di/T6/T6/T6));
  qdsat_Vsi_bi_Vsbulk_si=(+T0_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T6-(T4_Vsi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vsi_bi+T4*T6_Vsi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vsi_bi*T6_Vsbulk_si/T6/T6/T6));
  qdsat_Vsi_bi_Vgi_bi=(+T0_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T6-(T4_Vsi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vgi_bi/T6/T6/T6));
  qdsat_Vsi_bi_Vdi_bi=(+T0_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T6-(T4_Vsi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vdi_bi/T6/T6/T6));
  qdsat_Vsi_bi_Vsi_bi=(+T0_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T6-(T4_Vsi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vsi_bi/T6/T6/T6));
  qdsat_Vsi_bi_Tempt_GND=(+T0_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T6-(T4_Vsi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vsi_bi+T4*T6_Vsi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vsi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
#if defined(_DERIVATE)
qdsat_Tempt_GND=(T0_Tempt_GND-((T4_Tempt_GND*T6-T4*T6_Tempt_GND)/T6/T6));
#endif
#endif
qdsat=(T0-(T4/T6));
EXIT_IF_ISNAN((T0-(T4/T6)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T11_Vgi_bi=((((Weff*2.0)*nq_Vgi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi))*VSAT_a;
#if defined(_DERIVATE2)
  T11_Vgi_bi_Vgi_bi=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vgi_bi+(Weff*2.0)*nq_Vgi_bi_Vgi_bi)*Cox+((Weff*2.0)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Vgi_bi)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vgi_bi)*Cox*nVt_Vgi_bi+(((((0.0)*nq)+((Weff*2.0)*nq_Vgi_bi)))*Cox)*nVt_Vgi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi_Vgi_bi)*VSAT_a+((((Weff*2.0)*nq_Vgi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi))*0.0+((((((((0.0)*nq)+((Weff*2.0)*nq_Vgi_bi)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi)))*0.0+((((Weff*2.0)*nq)*Cox)*nVt)*0.0);
  T11_Vgi_bi_Tempt_GND=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vgi_bi+(Weff*2.0)*nq_Vgi_bi_Tempt_GND)*Cox+((Weff*2.0)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Tempt_GND)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vgi_bi)*Cox*nVt_Tempt_GND+(((((0.0)*nq)+((Weff*2.0)*nq_Tempt_GND)))*Cox)*nVt_Vgi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi_Tempt_GND)*VSAT_a+((((Weff*2.0)*nq_Vgi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi))*VSAT_a_Tempt_GND+((((((((0.0)*nq)+((Weff*2.0)*nq_Tempt_GND)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Tempt_GND)))*0.0+((((Weff*2.0)*nq)*Cox)*nVt)*0.0);
  T11_Vgi_bi_Vdi_bi=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vgi_bi+(Weff*2.0)*nq_Vgi_bi_Vdi_bi)*Cox+((Weff*2.0)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Vdi_bi)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vgi_bi)*Cox*nVt_Vdi_bi+(((((0.0)*nq)+((Weff*2.0)*nq_Vdi_bi)))*Cox)*nVt_Vgi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi_Vdi_bi)*VSAT_a+((((Weff*2.0)*nq_Vgi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi))*VSAT_a_Vdi_bi+((((((((0.0)*nq)+((Weff*2.0)*nq_Vdi_bi)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi)))*0.0+((((Weff*2.0)*nq)*Cox)*nVt)*0.0);
  T11_Vgi_bi_Vsi_bi=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vgi_bi+(Weff*2.0)*nq_Vgi_bi_Vsi_bi)*Cox+((Weff*2.0)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Vsi_bi)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vgi_bi)*Cox*nVt_Vsi_bi+(((((0.0)*nq)+((Weff*2.0)*nq_Vsi_bi)))*Cox)*nVt_Vgi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi_Vsi_bi)*VSAT_a+((((Weff*2.0)*nq_Vgi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi))*VSAT_a_Vsi_bi+((((((((0.0)*nq)+((Weff*2.0)*nq_Vsi_bi)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi)))*0.0+((((Weff*2.0)*nq)*Cox)*nVt)*0.0);
#endif
#if defined(_DERIVATE)
T11_Tempt_GND=((((((Weff*2.0)*nq_Tempt_GND)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Tempt_GND))*VSAT_a)+(((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a_Tempt_GND));
#endif
T11_Vdi_bi=((((((Weff*2.0)*nq_Vdi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi))*VSAT_a)+(((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a_Vdi_bi));
#if defined(_DERIVATE2)
  T11_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vdi_bi+(Weff*2.0)*nq_Vdi_bi_Vgi_bi)*Cox+((Weff*2.0)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Vgi_bi)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vdi_bi)*Cox*nVt_Vgi_bi+(((((0.0)*nq)+((Weff*2.0)*nq_Vgi_bi)))*Cox)*nVt_Vdi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi_Vgi_bi)*VSAT_a+((((Weff*2.0)*nq_Vdi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi))*0.0+((((((((0.0)*nq)+((Weff*2.0)*nq_Vgi_bi)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi)))*VSAT_a_Vdi_bi+((((Weff*2.0)*nq)*Cox)*nVt)*0.0);
  T11_Vdi_bi_Tempt_GND=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vdi_bi+(Weff*2.0)*nq_Vdi_bi_Tempt_GND)*Cox+((Weff*2.0)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Tempt_GND)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vdi_bi)*Cox*nVt_Tempt_GND+(((((0.0)*nq)+((Weff*2.0)*nq_Tempt_GND)))*Cox)*nVt_Vdi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi_Tempt_GND)*VSAT_a+((((Weff*2.0)*nq_Vdi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi))*VSAT_a_Tempt_GND+((((((((0.0)*nq)+((Weff*2.0)*nq_Tempt_GND)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Tempt_GND)))*VSAT_a_Vdi_bi+((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a_Vdi_bi_Tempt_GND);
  T11_Vdi_bi_Vdi_bi=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vdi_bi+(Weff*2.0)*nq_Vdi_bi_Vdi_bi)*Cox+((Weff*2.0)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Vdi_bi)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vdi_bi)*Cox*nVt_Vdi_bi+(((((0.0)*nq)+((Weff*2.0)*nq_Vdi_bi)))*Cox)*nVt_Vdi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi_Vdi_bi)*VSAT_a+((((Weff*2.0)*nq_Vdi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi))*VSAT_a_Vdi_bi+((((((((0.0)*nq)+((Weff*2.0)*nq_Vdi_bi)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi)))*VSAT_a_Vdi_bi+((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a_Vdi_bi_Vdi_bi);
  T11_Vdi_bi_Vsi_bi=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vdi_bi+(Weff*2.0)*nq_Vdi_bi_Vsi_bi)*Cox+((Weff*2.0)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Vsi_bi)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vdi_bi)*Cox*nVt_Vsi_bi+(((((0.0)*nq)+((Weff*2.0)*nq_Vsi_bi)))*Cox)*nVt_Vdi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi_Vsi_bi)*VSAT_a+((((Weff*2.0)*nq_Vdi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi))*VSAT_a_Vsi_bi+((((((((0.0)*nq)+((Weff*2.0)*nq_Vsi_bi)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi)))*VSAT_a_Vdi_bi+((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a_Vdi_bi_Vsi_bi);
#endif
T11_Vsi_bi=((((((Weff*2.0)*nq_Vsi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi))*VSAT_a)+(((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a_Vsi_bi));
#if defined(_DERIVATE2)
  T11_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vsi_bi+(Weff*2.0)*nq_Vsi_bi_Vgi_bi)*Cox+((Weff*2.0)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Vgi_bi)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vsi_bi)*Cox*nVt_Vgi_bi+(((((0.0)*nq)+((Weff*2.0)*nq_Vgi_bi)))*Cox)*nVt_Vsi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi_Vgi_bi)*VSAT_a+((((Weff*2.0)*nq_Vsi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi))*0.0+((((((((0.0)*nq)+((Weff*2.0)*nq_Vgi_bi)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vgi_bi)))*VSAT_a_Vsi_bi+((((Weff*2.0)*nq)*Cox)*nVt)*0.0);
  T11_Vsi_bi_Tempt_GND=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vsi_bi+(Weff*2.0)*nq_Vsi_bi_Tempt_GND)*Cox+((Weff*2.0)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Tempt_GND)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vsi_bi)*Cox*nVt_Tempt_GND+(((((0.0)*nq)+((Weff*2.0)*nq_Tempt_GND)))*Cox)*nVt_Vsi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi_Tempt_GND)*VSAT_a+((((Weff*2.0)*nq_Vsi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi))*VSAT_a_Tempt_GND+((((((((0.0)*nq)+((Weff*2.0)*nq_Tempt_GND)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Tempt_GND)))*VSAT_a_Vsi_bi+((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a_Vsi_bi_Tempt_GND);
  T11_Vsi_bi_Vdi_bi=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vsi_bi+(Weff*2.0)*nq_Vsi_bi_Vdi_bi)*Cox+((Weff*2.0)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Vdi_bi)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vsi_bi)*Cox*nVt_Vdi_bi+(((((0.0)*nq)+((Weff*2.0)*nq_Vdi_bi)))*Cox)*nVt_Vsi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi_Vdi_bi)*VSAT_a+((((Weff*2.0)*nq_Vsi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi))*VSAT_a_Vdi_bi+((((((((0.0)*nq)+((Weff*2.0)*nq_Vdi_bi)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vdi_bi)))*VSAT_a_Vsi_bi+((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a_Vsi_bi_Vdi_bi);
  T11_Vsi_bi_Vsi_bi=(+(+(+(+(+0.0*2.0+0.0*0.0+0.0*0.0+Weff*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vsi_bi+(Weff*2.0)*nq_Vsi_bi_Vsi_bi)*Cox+((Weff*2.0)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((Weff*2.0)*nq_Vsi_bi)))*0.0+((Weff*2.0)*nq)*0.0)*nVt+((Weff*2.0)*nq_Vsi_bi)*Cox*nVt_Vsi_bi+(((((0.0)*nq)+((Weff*2.0)*nq_Vsi_bi)))*Cox)*nVt_Vsi_bi+(((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi_Vsi_bi)*VSAT_a+((((Weff*2.0)*nq_Vsi_bi)*Cox*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi))*VSAT_a_Vsi_bi+((((((((0.0)*nq)+((Weff*2.0)*nq_Vsi_bi)))*Cox)*nVt)+((((Weff*2.0)*nq)*Cox)*nVt_Vsi_bi)))*VSAT_a_Vsi_bi+((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a_Vsi_bi_Vsi_bi);
#endif
#endif
T11=(((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a);
EXIT_IF_ISNAN((((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
T12_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T12_Vdbulk_di_Vdbulk_di=0.0;
  T12_Vdbulk_di_Vsbulk_si=0.0;
  T12_Vdbulk_di_Vgi_bi=0.0;
  T12_Vdbulk_di_Tempt_GND=0.0;
  T12_Vdbulk_di_Vdi_bi=0.0;
  T12_Vdbulk_di_Vsi_bi=0.0;
#endif
T12_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T12_Vsbulk_si_Vdbulk_di=0.0;
  T12_Vsbulk_si_Vsbulk_si=0.0;
  T12_Vsbulk_si_Vgi_bi=0.0;
  T12_Vsbulk_si_Tempt_GND=0.0;
  T12_Vsbulk_si_Vdi_bi=0.0;
  T12_Vsbulk_si_Vsi_bi=0.0;
#endif
T12_Vgi_bi=((((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi))*(2.0*nVt)-((T11*LambdaC)*Rdss)*(2.0*nVt_Vgi_bi))/(2.0*nVt)/(2.0*nVt));
#if defined(_DERIVATE2)
  T12_Vgi_bi_Vdbulk_di=((+(+0.0*LambdaC+T11_Vgi_bi*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+T11*LambdaC_Vgi_bi_Vdbulk_di)*Rdss+((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*0.0+((T11*LambdaC_Vdbulk_di))*Rdss_Vgi_bi+(T11*LambdaC)*0.0)/(2.0*nVt)-(((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi))*((2.0*nVt_Vdbulk_di))+(((T11*LambdaC_Vdbulk_di))*Rdss)*(2.0*nVt_Vgi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vdbulk_di))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vgi_bi)*((2.0*nVt_Vdbulk_di))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vgi_bi_Vsbulk_si=((+(+0.0*LambdaC+T11_Vgi_bi*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+T11*LambdaC_Vgi_bi_Vsbulk_si)*Rdss+((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*0.0+((T11*LambdaC_Vsbulk_si))*Rdss_Vgi_bi+(T11*LambdaC)*0.0)/(2.0*nVt)-(((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi))*((2.0*nVt_Vsbulk_si))+(((T11*LambdaC_Vsbulk_si))*Rdss)*(2.0*nVt_Vgi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vsbulk_si))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vgi_bi)*((2.0*nVt_Vsbulk_si))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vgi_bi_Vgi_bi=((+(+T11_Vgi_bi_Vgi_bi*LambdaC+T11_Vgi_bi*LambdaC_Vgi_bi+T11_Vgi_bi*LambdaC_Vgi_bi+T11*LambdaC_Vgi_bi_Vgi_bi)*Rdss+((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss_Vgi_bi+(((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi)))*Rdss_Vgi_bi+(T11*LambdaC)*Rdss_Vgi_bi_Vgi_bi)/(2.0*nVt)-(((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi))*((2.0*nVt_Vgi_bi))+((((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi)))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi)))*(2.0*nVt_Vgi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vgi_bi))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vgi_bi)*((2.0*nVt_Vgi_bi))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vgi_bi_Tempt_GND=((+(+T11_Vgi_bi_Tempt_GND*LambdaC+T11_Vgi_bi*LambdaC_Tempt_GND+T11_Tempt_GND*LambdaC_Vgi_bi+T11*LambdaC_Vgi_bi_Tempt_GND)*Rdss+((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss_Tempt_GND+(((T11_Tempt_GND*LambdaC)+(T11*LambdaC_Tempt_GND)))*Rdss_Vgi_bi+(T11*LambdaC)*Rdss_Vgi_bi_Tempt_GND)/(2.0*nVt)-(((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi))*((2.0*nVt_Tempt_GND))+((((((T11_Tempt_GND*LambdaC)+(T11*LambdaC_Tempt_GND)))*Rdss)+((T11*LambdaC)*Rdss_Tempt_GND)))*(2.0*nVt_Vgi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Tempt_GND))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vgi_bi)*((2.0*nVt_Tempt_GND))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vgi_bi_Vdi_bi=((+(+T11_Vgi_bi_Vdi_bi*LambdaC+T11_Vgi_bi*LambdaC_Vdi_bi+T11_Vdi_bi*LambdaC_Vgi_bi+T11*LambdaC_Vgi_bi_Vdi_bi)*Rdss+((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss_Vdi_bi+(((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi)))*Rdss_Vgi_bi+(T11*LambdaC)*Rdss_Vgi_bi_Vdi_bi)/(2.0*nVt)-(((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi))*((2.0*nVt_Vdi_bi))+((((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi)))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi)))*(2.0*nVt_Vgi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vdi_bi))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vgi_bi)*((2.0*nVt_Vdi_bi))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vgi_bi_Vsi_bi=((+(+T11_Vgi_bi_Vsi_bi*LambdaC+T11_Vgi_bi*LambdaC_Vsi_bi+T11_Vsi_bi*LambdaC_Vgi_bi+T11*LambdaC_Vgi_bi_Vsi_bi)*Rdss+((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss_Vsi_bi+(((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi)))*Rdss_Vgi_bi+(T11*LambdaC)*Rdss_Vgi_bi_Vsi_bi)/(2.0*nVt)-(((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi))*((2.0*nVt_Vsi_bi))+((((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi)))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi)))*(2.0*nVt_Vgi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vsi_bi))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vgi_bi)*((2.0*nVt_Vsi_bi))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
#endif
#if defined(_DERIVATE)
T12_Tempt_GND=((((((T11_Tempt_GND*LambdaC)+(T11*LambdaC_Tempt_GND))*Rdss)+((T11*LambdaC)*Rdss_Tempt_GND))*(2.0*nVt)-((T11*LambdaC)*Rdss)*(2.0*nVt_Tempt_GND))/(2.0*nVt)/(2.0*nVt));
#endif
T12_Vdi_bi=((((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi))*(2.0*nVt)-((T11*LambdaC)*Rdss)*(2.0*nVt_Vdi_bi))/(2.0*nVt)/(2.0*nVt));
#if defined(_DERIVATE2)
  T12_Vdi_bi_Vdbulk_di=((+(+0.0*LambdaC+T11_Vdi_bi*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+T11*LambdaC_Vdi_bi_Vdbulk_di)*Rdss+((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*0.0+((T11*LambdaC_Vdbulk_di))*Rdss_Vdi_bi+(T11*LambdaC)*0.0)/(2.0*nVt)-(((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi))*((2.0*nVt_Vdbulk_di))+(((T11*LambdaC_Vdbulk_di))*Rdss)*(2.0*nVt_Vdi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vdbulk_di))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vdi_bi)*((2.0*nVt_Vdbulk_di))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vdi_bi_Vsbulk_si=((+(+0.0*LambdaC+T11_Vdi_bi*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+T11*LambdaC_Vdi_bi_Vsbulk_si)*Rdss+((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*0.0+((T11*LambdaC_Vsbulk_si))*Rdss_Vdi_bi+(T11*LambdaC)*0.0)/(2.0*nVt)-(((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi))*((2.0*nVt_Vsbulk_si))+(((T11*LambdaC_Vsbulk_si))*Rdss)*(2.0*nVt_Vdi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vsbulk_si))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vdi_bi)*((2.0*nVt_Vsbulk_si))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vdi_bi_Vgi_bi=((+(+T11_Vdi_bi_Vgi_bi*LambdaC+T11_Vdi_bi*LambdaC_Vgi_bi+T11_Vgi_bi*LambdaC_Vdi_bi+T11*LambdaC_Vdi_bi_Vgi_bi)*Rdss+((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss_Vgi_bi+(((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi)))*Rdss_Vdi_bi+(T11*LambdaC)*Rdss_Vdi_bi_Vgi_bi)/(2.0*nVt)-(((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi))*((2.0*nVt_Vgi_bi))+((((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi)))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi)))*(2.0*nVt_Vdi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vgi_bi))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vdi_bi)*((2.0*nVt_Vgi_bi))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vdi_bi_Tempt_GND=((+(+T11_Vdi_bi_Tempt_GND*LambdaC+T11_Vdi_bi*LambdaC_Tempt_GND+T11_Tempt_GND*LambdaC_Vdi_bi+T11*LambdaC_Vdi_bi_Tempt_GND)*Rdss+((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss_Tempt_GND+(((T11_Tempt_GND*LambdaC)+(T11*LambdaC_Tempt_GND)))*Rdss_Vdi_bi+(T11*LambdaC)*Rdss_Vdi_bi_Tempt_GND)/(2.0*nVt)-(((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi))*((2.0*nVt_Tempt_GND))+((((((T11_Tempt_GND*LambdaC)+(T11*LambdaC_Tempt_GND)))*Rdss)+((T11*LambdaC)*Rdss_Tempt_GND)))*(2.0*nVt_Vdi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Tempt_GND))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vdi_bi)*((2.0*nVt_Tempt_GND))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vdi_bi_Vdi_bi=((+(+T11_Vdi_bi_Vdi_bi*LambdaC+T11_Vdi_bi*LambdaC_Vdi_bi+T11_Vdi_bi*LambdaC_Vdi_bi+T11*LambdaC_Vdi_bi_Vdi_bi)*Rdss+((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss_Vdi_bi+(((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi)))*Rdss_Vdi_bi+(T11*LambdaC)*Rdss_Vdi_bi_Vdi_bi)/(2.0*nVt)-(((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi))*((2.0*nVt_Vdi_bi))+((((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi)))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi)))*(2.0*nVt_Vdi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vdi_bi))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vdi_bi)*((2.0*nVt_Vdi_bi))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vdi_bi_Vsi_bi=((+(+T11_Vdi_bi_Vsi_bi*LambdaC+T11_Vdi_bi*LambdaC_Vsi_bi+T11_Vsi_bi*LambdaC_Vdi_bi+T11*LambdaC_Vdi_bi_Vsi_bi)*Rdss+((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss_Vsi_bi+(((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi)))*Rdss_Vdi_bi+(T11*LambdaC)*Rdss_Vdi_bi_Vsi_bi)/(2.0*nVt)-(((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi))*((2.0*nVt_Vsi_bi))+((((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi)))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi)))*(2.0*nVt_Vdi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vsi_bi))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vdi_bi)*((2.0*nVt_Vsi_bi))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
#endif
T12_Vsi_bi=((((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi))*(2.0*nVt)-((T11*LambdaC)*Rdss)*(2.0*nVt_Vsi_bi))/(2.0*nVt)/(2.0*nVt));
#if defined(_DERIVATE2)
  T12_Vsi_bi_Vdbulk_di=((+(+0.0*LambdaC+T11_Vsi_bi*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+T11*LambdaC_Vsi_bi_Vdbulk_di)*Rdss+((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*0.0+((T11*LambdaC_Vdbulk_di))*Rdss_Vsi_bi+(T11*LambdaC)*0.0)/(2.0*nVt)-(((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi))*((2.0*nVt_Vdbulk_di))+(((T11*LambdaC_Vdbulk_di))*Rdss)*(2.0*nVt_Vsi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vdbulk_di))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vsi_bi)*((2.0*nVt_Vdbulk_di))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vsi_bi_Vsbulk_si=((+(+0.0*LambdaC+T11_Vsi_bi*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+T11*LambdaC_Vsi_bi_Vsbulk_si)*Rdss+((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*0.0+((T11*LambdaC_Vsbulk_si))*Rdss_Vsi_bi+(T11*LambdaC)*0.0)/(2.0*nVt)-(((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi))*((2.0*nVt_Vsbulk_si))+(((T11*LambdaC_Vsbulk_si))*Rdss)*(2.0*nVt_Vsi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vsbulk_si))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vsi_bi)*((2.0*nVt_Vsbulk_si))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vsi_bi_Vgi_bi=((+(+T11_Vsi_bi_Vgi_bi*LambdaC+T11_Vsi_bi*LambdaC_Vgi_bi+T11_Vgi_bi*LambdaC_Vsi_bi+T11*LambdaC_Vsi_bi_Vgi_bi)*Rdss+((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss_Vgi_bi+(((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi)))*Rdss_Vsi_bi+(T11*LambdaC)*Rdss_Vsi_bi_Vgi_bi)/(2.0*nVt)-(((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi))*((2.0*nVt_Vgi_bi))+((((((T11_Vgi_bi*LambdaC)+(T11*LambdaC_Vgi_bi)))*Rdss)+((T11*LambdaC)*Rdss_Vgi_bi)))*(2.0*nVt_Vsi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vgi_bi))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vsi_bi)*((2.0*nVt_Vgi_bi))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vsi_bi_Tempt_GND=((+(+T11_Vsi_bi_Tempt_GND*LambdaC+T11_Vsi_bi*LambdaC_Tempt_GND+T11_Tempt_GND*LambdaC_Vsi_bi+T11*LambdaC_Vsi_bi_Tempt_GND)*Rdss+((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss_Tempt_GND+(((T11_Tempt_GND*LambdaC)+(T11*LambdaC_Tempt_GND)))*Rdss_Vsi_bi+(T11*LambdaC)*Rdss_Vsi_bi_Tempt_GND)/(2.0*nVt)-(((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi))*((2.0*nVt_Tempt_GND))+((((((T11_Tempt_GND*LambdaC)+(T11*LambdaC_Tempt_GND)))*Rdss)+((T11*LambdaC)*Rdss_Tempt_GND)))*(2.0*nVt_Vsi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Tempt_GND))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vsi_bi)*((2.0*nVt_Tempt_GND))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vsi_bi_Vdi_bi=((+(+T11_Vsi_bi_Vdi_bi*LambdaC+T11_Vsi_bi*LambdaC_Vdi_bi+T11_Vdi_bi*LambdaC_Vsi_bi+T11*LambdaC_Vsi_bi_Vdi_bi)*Rdss+((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss_Vdi_bi+(((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi)))*Rdss_Vsi_bi+(T11*LambdaC)*Rdss_Vsi_bi_Vdi_bi)/(2.0*nVt)-(((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi))*((2.0*nVt_Vdi_bi))+((((((T11_Vdi_bi*LambdaC)+(T11*LambdaC_Vdi_bi)))*Rdss)+((T11*LambdaC)*Rdss_Vdi_bi)))*(2.0*nVt_Vsi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vdi_bi))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vsi_bi)*((2.0*nVt_Vdi_bi))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
  T12_Vsi_bi_Vsi_bi=((+(+T11_Vsi_bi_Vsi_bi*LambdaC+T11_Vsi_bi*LambdaC_Vsi_bi+T11_Vsi_bi*LambdaC_Vsi_bi+T11*LambdaC_Vsi_bi_Vsi_bi)*Rdss+((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss_Vsi_bi+(((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi)))*Rdss_Vsi_bi+(T11*LambdaC)*Rdss_Vsi_bi_Vsi_bi)/(2.0*nVt)-(((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi))*((2.0*nVt_Vsi_bi))+((((((T11_Vsi_bi*LambdaC)+(T11*LambdaC_Vsi_bi)))*Rdss)+((T11*LambdaC)*Rdss_Vsi_bi)))*(2.0*nVt_Vsi_bi)+((T11*LambdaC)*Rdss)*(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vsi_bi))/(2.0*nVt)/(2.0*nVt)+2*((T11*LambdaC)*Rdss)*(2.0*nVt_Vsi_bi)*((2.0*nVt_Vsi_bi))/(2.0*nVt)/(2.0*nVt)/(2.0*nVt));
#endif
#endif
T12=(((T11*LambdaC)*Rdss)/(2.0*nVt));
EXIT_IF_ISNAN((((T11*LambdaC)*Rdss)/(2.0*nVt)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(1.0+((0.5*LambdaC)*(1.0+qs)))-((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)+(0.0)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vgm_di*qs+qs_Vgi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_di)+qs_Vgi_bi_Vgm_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vgm_di+(0.0)*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vgm_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)+(0.0)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vgm_si*qs+qs_Vgi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_si)+qs_Vgi_bi_Vgm_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vgm_si+(0.0)*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vgm_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vdbulk_di)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+((0.5*LambdaC_Vdbulk_di))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vdbulk_di*qs+qs_Vgi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vdbulk_di)+qs_Vgi_bi_Vdbulk_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))+(((((0.5*LambdaC_Vdbulk_di))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vdbulk_di)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vdbulk_di+((0.5*LambdaC_Vdbulk_di))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vdbulk_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vsbulk_si)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+((0.5*LambdaC_Vsbulk_si))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vsbulk_si*qs+qs_Vgi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vsbulk_si)+qs_Vgi_bi_Vsbulk_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))+(((((0.5*LambdaC_Vsbulk_si))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vsbulk_si)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vsbulk_si+((0.5*LambdaC_Vsbulk_si))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vsbulk_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vgi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+((0.5*LambdaC_Vgi_bi))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vgi_bi*qs+qs_Vgi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vgi_bi)+qs_Vgi_bi_Vgi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))+(((((0.5*LambdaC_Vgi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vgi_bi)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vgi_bi+((0.5*LambdaC_Vgi_bi))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vgi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vdi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+((0.5*LambdaC_Vdi_bi))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vdi_bi*qs+qs_Vgi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vdi_bi)+qs_Vgi_bi_Vdi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))+(((((0.5*LambdaC_Vdi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vdi_bi)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vdi_bi+((0.5*LambdaC_Vdi_bi))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vdi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vsi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+((0.5*LambdaC_Vsi_bi))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Vsi_bi*qs+qs_Vgi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vsi_bi)+qs_Vgi_bi_Vsi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))+(((((0.5*LambdaC_Vsi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Vsi_bi)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Vsi_bi+((0.5*LambdaC_Vsi_bi))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Vsi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vgi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Tempt_GND)*((qs*qs)+qs)+(0.5*LambdaC_Vgi_bi)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+((0.5*LambdaC_Tempt_GND))*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+(0.5*LambdaC)*(+(+qs_Vgi_bi_Tempt_GND*qs+qs_Vgi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vgi_bi+qs*qs_Vgi_bi_Tempt_GND)+qs_Vgi_bi_Tempt_GND))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vgi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))+(((((0.5*LambdaC_Tempt_GND))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+0.5*LambdaC_Vgi_bi_Tempt_GND)*(1.0+qs)+(0.5*LambdaC_Vgi_bi)*qs_Tempt_GND+((0.5*LambdaC_Tempt_GND))*qs_Vgi_bi+(0.5*LambdaC)*(+0.0+qs_Vgi_bi_Tempt_GND))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vgi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#endif
T0_Vdi_bi=(((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(1.0+((0.5*LambdaC)*(1.0+qs)))-((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)+(0.0)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vgm_di*qs+qs_Vdi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_di)+qs_Vdi_bi_Vgm_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vgm_di+(0.0)*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vgm_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)+(0.0)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vgm_si*qs+qs_Vdi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_si)+qs_Vdi_bi_Vgm_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vgm_si+(0.0)*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vgm_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vdbulk_di)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+((0.5*LambdaC_Vdbulk_di))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vdbulk_di*qs+qs_Vdi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vdbulk_di)+qs_Vdi_bi_Vdbulk_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))+(((((0.5*LambdaC_Vdbulk_di))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vdbulk_di)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vdbulk_di+((0.5*LambdaC_Vdbulk_di))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vdbulk_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vsbulk_si)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+((0.5*LambdaC_Vsbulk_si))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vsbulk_si*qs+qs_Vdi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vsbulk_si)+qs_Vdi_bi_Vsbulk_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))+(((((0.5*LambdaC_Vsbulk_si))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vsbulk_si)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vsbulk_si+((0.5*LambdaC_Vsbulk_si))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vsbulk_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vgi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+((0.5*LambdaC_Vgi_bi))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vgi_bi*qs+qs_Vdi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vgi_bi)+qs_Vdi_bi_Vgi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))+(((((0.5*LambdaC_Vgi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vgi_bi)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vgi_bi+((0.5*LambdaC_Vgi_bi))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vgi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vdi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+((0.5*LambdaC_Vdi_bi))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vdi_bi*qs+qs_Vdi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vdi_bi)+qs_Vdi_bi_Vdi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))+(((((0.5*LambdaC_Vdi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vdi_bi)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vdi_bi+((0.5*LambdaC_Vdi_bi))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vdi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vsi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+((0.5*LambdaC_Vsi_bi))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Vsi_bi*qs+qs_Vdi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vsi_bi)+qs_Vdi_bi_Vsi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))+(((((0.5*LambdaC_Vsi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Vsi_bi)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Vsi_bi+((0.5*LambdaC_Vsi_bi))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Vsi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vdi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Tempt_GND)*((qs*qs)+qs)+(0.5*LambdaC_Vdi_bi)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+((0.5*LambdaC_Tempt_GND))*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+(0.5*LambdaC)*(+(+qs_Vdi_bi_Tempt_GND*qs+qs_Vdi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vdi_bi+qs*qs_Vdi_bi_Tempt_GND)+qs_Vdi_bi_Tempt_GND))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vdi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))+(((((0.5*LambdaC_Tempt_GND))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+0.5*LambdaC_Vdi_bi_Tempt_GND)*(1.0+qs)+(0.5*LambdaC_Vdi_bi)*qs_Tempt_GND+((0.5*LambdaC_Tempt_GND))*qs_Vdi_bi+(0.5*LambdaC)*(+0.0+qs_Vdi_bi_Tempt_GND))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vdi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#endif
T0_Vsi_bi=(((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(1.0+((0.5*LambdaC)*(1.0+qs)))-((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)+(0.0)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vgm_di*qs+qs_Vsi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_di)+qs_Vsi_bi_Vgm_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vgm_di+(0.0)*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vgm_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+0.5*0.0)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)+(0.0)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vgm_si*qs+qs_Vsi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_si)+qs_Vsi_bi_Vgm_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))+((((0.0)*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+0.5*0.0)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vgm_si+(0.0)*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vgm_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*((((0.0)*(1.0+qs))+((0.5*LambdaC)*qs_Vgm_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vdbulk_di)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+((0.5*LambdaC_Vdbulk_di))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vdbulk_di*qs+qs_Vsi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vdbulk_di)+qs_Vsi_bi_Vdbulk_di))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))+(((((0.5*LambdaC_Vdbulk_di))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vdbulk_di)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vdbulk_di+((0.5*LambdaC_Vdbulk_di))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vdbulk_di))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vdbulk_di))*(1.0+qs))+((0.5*LambdaC)*qs_Vdbulk_di)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vsbulk_si)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+((0.5*LambdaC_Vsbulk_si))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vsbulk_si*qs+qs_Vsi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vsbulk_si)+qs_Vsi_bi_Vsbulk_si))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))+(((((0.5*LambdaC_Vsbulk_si))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vsbulk_si)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vsbulk_si+((0.5*LambdaC_Vsbulk_si))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vsbulk_si))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vsbulk_si))*(1.0+qs))+((0.5*LambdaC)*qs_Vsbulk_si)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vgi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+((0.5*LambdaC_Vgi_bi))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vgi_bi*qs+qs_Vsi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vgi_bi)+qs_Vsi_bi_Vgi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))+(((((0.5*LambdaC_Vgi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vgi_bi)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vgi_bi+((0.5*LambdaC_Vgi_bi))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vgi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vgi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vgi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vdi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+((0.5*LambdaC_Vdi_bi))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vdi_bi*qs+qs_Vsi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vdi_bi)+qs_Vsi_bi_Vdi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))+(((((0.5*LambdaC_Vdi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vdi_bi)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vdi_bi+((0.5*LambdaC_Vdi_bi))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vdi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vdi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vdi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vsi_bi)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+((0.5*LambdaC_Vsi_bi))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Vsi_bi*qs+qs_Vsi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vsi_bi)+qs_Vsi_bi_Vsi_bi))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))+(((((0.5*LambdaC_Vsi_bi))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Vsi_bi)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Vsi_bi+((0.5*LambdaC_Vsi_bi))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Vsi_bi))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Vsi_bi))*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
  T0_Vsi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Tempt_GND)*((qs*qs)+qs)+(0.5*LambdaC_Vsi_bi)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+((0.5*LambdaC_Tempt_GND))*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+(0.5*LambdaC)*(+(+qs_Vsi_bi_Tempt_GND*qs+qs_Vsi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vsi_bi+qs*qs_Vsi_bi_Tempt_GND)+qs_Vsi_bi_Tempt_GND))/(1.0+((0.5*LambdaC)*(1.0+qs)))-((((0.5*LambdaC_Vsi_bi)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))+(((((0.5*LambdaC_Tempt_GND))*((qs*qs)+qs))+((0.5*LambdaC)*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))+((0.5*LambdaC)*((qs*qs)+qs))*(+0.0+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+0.5*LambdaC_Vsi_bi_Tempt_GND)*(1.0+qs)+(0.5*LambdaC_Vsi_bi)*qs_Tempt_GND+((0.5*LambdaC_Tempt_GND))*qs_Vsi_bi+(0.5*LambdaC)*(+0.0+qs_Vsi_bi_Tempt_GND))))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))+2*((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Vsi_bi)*(1.0+qs))+((0.5*LambdaC)*qs_Vsi_bi))*(((((0.5*LambdaC_Tempt_GND))*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(((((0.5*LambdaC_Tempt_GND)*((qs*qs)+qs))+((0.5*LambdaC)*(((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND))+qs_Tempt_GND)))*(1.0+((0.5*LambdaC)*(1.0+qs)))-((0.5*LambdaC)*((qs*qs)+qs))*(((0.5*LambdaC_Tempt_GND)*(1.0+qs))+((0.5*LambdaC)*qs_Tempt_GND)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
#endif
#endif
T0=(((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));
EXIT_IF_ISNAN((((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs)))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(((2.0*LambdaC_Vgi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vgi_bi-T0_Vgi_bi)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_di-T0_Vgi_bi_Vgm_di));
  T1_Vgi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_si-T0_Vgi_bi_Vgm_si));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdbulk_di-T0_Vgi_bi_Vdbulk_di));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsbulk_si-T0_Vgi_bi_Vsbulk_si));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgi_bi-T0_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdi_bi-T0_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsi_bi-T0_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Tempt_GND-T0_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(((2.0*LambdaC_Vdi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vdi_bi-T0_Vdi_bi)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_di-T0_Vdi_bi_Vgm_di));
  T1_Vdi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_si-T0_Vdi_bi_Vgm_si));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdbulk_di-T0_Vdi_bi_Vdbulk_di));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsbulk_si-T0_Vdi_bi_Vsbulk_si));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgi_bi-T0_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdi_bi-T0_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsi_bi-T0_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Tempt_GND-T0_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(((2.0*LambdaC_Vsi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vsi_bi-T0_Vsi_bi)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_di-T0_Vsi_bi_Vgm_di));
  T1_Vsi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_si-T0_Vsi_bi_Vgm_si));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdbulk_di-T0_Vsi_bi_Vdbulk_di));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsbulk_si-T0_Vsi_bi_Vsbulk_si));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgi_bi-T0_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdi_bi-T0_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsi_bi-T0_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Tempt_GND-T0_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((2.0*LambdaC_Tempt_GND)*(qs-T0))+((2.0*LambdaC)*(qs_Tempt_GND-T0_Tempt_GND)));
#endif
#endif
T1=((2.0*LambdaC)*(qs-T0));
EXIT_IF_ISNAN(((2.0*LambdaC)*(qs-T0)))
{
double m00_sqrt(d00_sqrt0,(1.0+(T1*T1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(T1*T1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)));
  T2_Vgi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)));
  T2_Vgi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)));
  T2_Vgi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)));
  T2_Vgi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)));
  T2_Vgi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)));
  T2_Vgi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)));
  T2_Vgi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)));
#endif
T2_Vdi_bi=((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)));
  T2_Vdi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)));
  T2_Vdi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)));
  T2_Vdi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)));
  T2_Vdi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)));
  T2_Vdi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)));
  T2_Vdi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)));
  T2_Vdi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)));
#endif
T2_Vsi_bi=((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)));
  T2_Vsi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)));
  T2_Vsi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)));
  T2_Vsi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)));
  T2_Vsi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)));
  T2_Vsi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)));
  T2_Vsi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)));
  T2_Vsi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0;
#endif
#endif
T2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_asinh(d00_asinh0,T1)
#if defined(_DERIVATEFORDDX)
double m10_asinh(d10_asinh0,d00_asinh0,T1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
ln_T1_T2_Vgi_bi=T1_Vgi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vgi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vgi_bi);
  ln_T1_T2_Vgi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vdi_bi);
  ln_T1_T2_Vgi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vsi_bi);
  ln_T1_T2_Vgi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Tempt_GND);
#endif
ln_T1_T2_Vdi_bi=T1_Vdi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vdi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vgi_bi);
  ln_T1_T2_Vdi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vdi_bi);
  ln_T1_T2_Vdi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vsi_bi);
  ln_T1_T2_Vdi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Tempt_GND);
#endif
ln_T1_T2_Vsi_bi=T1_Vsi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vsi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vgi_bi);
  ln_T1_T2_Vsi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vdi_bi);
  ln_T1_T2_Vsi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vsi_bi);
  ln_T1_T2_Vsi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
ln_T1_T2_Tempt_GND=T1_Tempt_GND*d10_asinh0;
#endif
#endif
ln_T1_T2=d00_asinh0;
EXIT_IF_ISNAN(d00_asinh0)
}
if
((T1!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vgi_bi)));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vgi_bi));
  T3_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vdi_bi));
  T3_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vsi_bi));
  T3_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Tempt_GND));
#endif
T3_Vdi_bi=(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vdi_bi)));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vgi_bi));
  T3_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vdi_bi));
  T3_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vsi_bi));
  T3_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Tempt_GND));
#endif
T3_Vsi_bi=(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vsi_bi)));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vgi_bi));
  T3_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vdi_bi));
  T3_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vsi_bi));
  T3_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T2_Tempt_GND+(((-T1_Tempt_GND/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Tempt_GND)));
#endif
#endif
T3=(T2+((1.0/T1)*ln_T1_T2));
EXIT_IF_ISNAN((T2+((1.0/T1)*ln_T1_T2)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vdi_bi=(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vsi_bi=(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T2_Tempt_GND+(-T2_Tempt_GND/T2/T2));
#endif
#endif
T3=(T2+(1.0/T2));
EXIT_IF_ISNAN((T2+(1.0/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+((((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*((qs+T0)+1.0))+((T12*T0)*(qs_Vgi_bi+T0_Vgi_bi))))-((LambdaC_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi)))));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+(+(+0.0*T0+T12_Vgi_bi*T0_Vgm_si+0.0*T0_Vgi_bi+T12*T0_Vgi_bi_Vgm_si)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vgm_si+T0_Vgm_si)+((T12*T0_Vgm_si))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vgm_si+T0_Vgi_bi_Vgm_si)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgm_si*qs+qs_Vgi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_si)+qs_Vgi_bi_Vgm_si)-(+(+T0_Vgi_bi_Vgm_si*T0+T0_Vgi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_si)+T0_Vgi_bi_Vgm_si))));
  T4_Vgi_bi_Vgm_di=(+(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+(+(+0.0*T0+T12_Vgi_bi*T0_Vgm_di+0.0*T0_Vgi_bi+T12*T0_Vgi_bi_Vgm_di)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vgm_di+T0_Vgm_di)+((T12*T0_Vgm_di))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vgm_di+T0_Vgi_bi_Vgm_di)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgm_di*qs+qs_Vgi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_di)+qs_Vgi_bi_Vgm_di)-(+(+T0_Vgi_bi_Vgm_di*T0+T0_Vgi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_di)+T0_Vgi_bi_Vgm_di))));
  T4_Vgi_bi_Vdbulk_di=(+(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+(+(+T12_Vgi_bi_Vdbulk_di*T0+T12_Vgi_bi*T0_Vdbulk_di+T12_Vdbulk_di*T0_Vgi_bi+T12*T0_Vgi_bi_Vdbulk_di)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vdbulk_di+T0_Vdbulk_di)+(((T12_Vdbulk_di*T0)+(T12*T0_Vdbulk_di)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vdbulk_di+T0_Vgi_bi_Vdbulk_di)+0.0)))-(+LambdaC_Vgi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vdbulk_di*qs+qs_Vgi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vdbulk_di)+qs_Vgi_bi_Vdbulk_di)-(+(+T0_Vgi_bi_Vdbulk_di*T0+T0_Vgi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vdbulk_di)+T0_Vgi_bi_Vdbulk_di))));
  T4_Vgi_bi_Vsbulk_si=(+(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+(+(+T12_Vgi_bi_Vsbulk_si*T0+T12_Vgi_bi*T0_Vsbulk_si+T12_Vsbulk_si*T0_Vgi_bi+T12*T0_Vgi_bi_Vsbulk_si)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vsbulk_si+T0_Vsbulk_si)+(((T12_Vsbulk_si*T0)+(T12*T0_Vsbulk_si)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vsbulk_si+T0_Vgi_bi_Vsbulk_si)+0.0)))-(+LambdaC_Vgi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vsbulk_si*qs+qs_Vgi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vsbulk_si)+qs_Vgi_bi_Vsbulk_si)-(+(+T0_Vgi_bi_Vsbulk_si*T0+T0_Vgi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vsbulk_si)+T0_Vgi_bi_Vsbulk_si))));
  T4_Vgi_bi_Vgi_bi=(+(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+(+(+T12_Vgi_bi_Vgi_bi*T0+T12_Vgi_bi*T0_Vgi_bi+T12_Vgi_bi*T0_Vgi_bi+T12*T0_Vgi_bi_Vgi_bi)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vgi_bi+T0_Vgi_bi)+(((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vgi_bi+T0_Vgi_bi_Vgi_bi)+0.0)))-(+LambdaC_Vgi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgi_bi*qs+qs_Vgi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vgi_bi)+qs_Vgi_bi_Vgi_bi)-(+(+T0_Vgi_bi_Vgi_bi*T0+T0_Vgi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vgi_bi)+T0_Vgi_bi_Vgi_bi))));
  T4_Vgi_bi_Vdi_bi=(+(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+(+(+T12_Vgi_bi_Vdi_bi*T0+T12_Vgi_bi*T0_Vdi_bi+T12_Vdi_bi*T0_Vgi_bi+T12*T0_Vgi_bi_Vdi_bi)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vdi_bi+T0_Vdi_bi)+(((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vdi_bi+T0_Vgi_bi_Vdi_bi)+0.0)))-(+LambdaC_Vgi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vdi_bi*qs+qs_Vgi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vdi_bi)+qs_Vgi_bi_Vdi_bi)-(+(+T0_Vgi_bi_Vdi_bi*T0+T0_Vgi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vdi_bi)+T0_Vgi_bi_Vdi_bi))));
  T4_Vgi_bi_Vsi_bi=(+(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+(+(+T12_Vgi_bi_Vsi_bi*T0+T12_Vgi_bi*T0_Vsi_bi+T12_Vsi_bi*T0_Vgi_bi+T12*T0_Vgi_bi_Vsi_bi)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vsi_bi+T0_Vsi_bi)+(((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vsi_bi+T0_Vgi_bi_Vsi_bi)+0.0)))-(+LambdaC_Vgi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vsi_bi*qs+qs_Vgi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vsi_bi)+qs_Vgi_bi_Vsi_bi)-(+(+T0_Vgi_bi_Vsi_bi*T0+T0_Vgi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vsi_bi)+T0_Vgi_bi_Vsi_bi))));
  T4_Vgi_bi_Tempt_GND=(+(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+(+(+T12_Vgi_bi_Tempt_GND*T0+T12_Vgi_bi*T0_Tempt_GND+T12_Tempt_GND*T0_Vgi_bi+T12*T0_Vgi_bi_Tempt_GND)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Tempt_GND+T0_Tempt_GND)+(((T12_Tempt_GND*T0)+(T12*T0_Tempt_GND)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Tempt_GND+T0_Vgi_bi_Tempt_GND)+0.0)))-(+LambdaC_Vgi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Tempt_GND*qs+qs_Vgi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vgi_bi+qs*qs_Vgi_bi_Tempt_GND)+qs_Vgi_bi_Tempt_GND)-(+(+T0_Vgi_bi_Tempt_GND*T0+T0_Vgi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vgi_bi+T0*T0_Vgi_bi_Tempt_GND)+T0_Vgi_bi_Tempt_GND))));
#endif
T4_Vdi_bi=((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+((((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*((qs+T0)+1.0))+((T12*T0)*(qs_Vdi_bi+T0_Vdi_bi))))-((LambdaC_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi)))));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+(+(+0.0*T0+T12_Vdi_bi*T0_Vgm_si+0.0*T0_Vdi_bi+T12*T0_Vdi_bi_Vgm_si)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vgm_si+T0_Vgm_si)+((T12*T0_Vgm_si))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vgm_si+T0_Vdi_bi_Vgm_si)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgm_si*qs+qs_Vdi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_si)+qs_Vdi_bi_Vgm_si)-(+(+T0_Vdi_bi_Vgm_si*T0+T0_Vdi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_si)+T0_Vdi_bi_Vgm_si))));
  T4_Vdi_bi_Vgm_di=(+(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+(+(+0.0*T0+T12_Vdi_bi*T0_Vgm_di+0.0*T0_Vdi_bi+T12*T0_Vdi_bi_Vgm_di)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vgm_di+T0_Vgm_di)+((T12*T0_Vgm_di))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vgm_di+T0_Vdi_bi_Vgm_di)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgm_di*qs+qs_Vdi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_di)+qs_Vdi_bi_Vgm_di)-(+(+T0_Vdi_bi_Vgm_di*T0+T0_Vdi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_di)+T0_Vdi_bi_Vgm_di))));
  T4_Vdi_bi_Vdbulk_di=(+(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+(+(+T12_Vdi_bi_Vdbulk_di*T0+T12_Vdi_bi*T0_Vdbulk_di+T12_Vdbulk_di*T0_Vdi_bi+T12*T0_Vdi_bi_Vdbulk_di)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vdbulk_di+T0_Vdbulk_di)+(((T12_Vdbulk_di*T0)+(T12*T0_Vdbulk_di)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vdbulk_di+T0_Vdi_bi_Vdbulk_di)+0.0)))-(+LambdaC_Vdi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vdbulk_di*qs+qs_Vdi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vdbulk_di)+qs_Vdi_bi_Vdbulk_di)-(+(+T0_Vdi_bi_Vdbulk_di*T0+T0_Vdi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vdbulk_di)+T0_Vdi_bi_Vdbulk_di))));
  T4_Vdi_bi_Vsbulk_si=(+(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+(+(+T12_Vdi_bi_Vsbulk_si*T0+T12_Vdi_bi*T0_Vsbulk_si+T12_Vsbulk_si*T0_Vdi_bi+T12*T0_Vdi_bi_Vsbulk_si)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vsbulk_si+T0_Vsbulk_si)+(((T12_Vsbulk_si*T0)+(T12*T0_Vsbulk_si)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vsbulk_si+T0_Vdi_bi_Vsbulk_si)+0.0)))-(+LambdaC_Vdi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vsbulk_si*qs+qs_Vdi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vsbulk_si)+qs_Vdi_bi_Vsbulk_si)-(+(+T0_Vdi_bi_Vsbulk_si*T0+T0_Vdi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vsbulk_si)+T0_Vdi_bi_Vsbulk_si))));
  T4_Vdi_bi_Vgi_bi=(+(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+(+(+T12_Vdi_bi_Vgi_bi*T0+T12_Vdi_bi*T0_Vgi_bi+T12_Vgi_bi*T0_Vdi_bi+T12*T0_Vdi_bi_Vgi_bi)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vgi_bi+T0_Vgi_bi)+(((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vgi_bi+T0_Vdi_bi_Vgi_bi)+0.0)))-(+LambdaC_Vdi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgi_bi*qs+qs_Vdi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vgi_bi)+qs_Vdi_bi_Vgi_bi)-(+(+T0_Vdi_bi_Vgi_bi*T0+T0_Vdi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vgi_bi)+T0_Vdi_bi_Vgi_bi))));
  T4_Vdi_bi_Vdi_bi=(+(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+(+(+T12_Vdi_bi_Vdi_bi*T0+T12_Vdi_bi*T0_Vdi_bi+T12_Vdi_bi*T0_Vdi_bi+T12*T0_Vdi_bi_Vdi_bi)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vdi_bi+T0_Vdi_bi)+(((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vdi_bi+T0_Vdi_bi_Vdi_bi)+0.0)))-(+LambdaC_Vdi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vdi_bi*qs+qs_Vdi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vdi_bi)+qs_Vdi_bi_Vdi_bi)-(+(+T0_Vdi_bi_Vdi_bi*T0+T0_Vdi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vdi_bi)+T0_Vdi_bi_Vdi_bi))));
  T4_Vdi_bi_Vsi_bi=(+(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+(+(+T12_Vdi_bi_Vsi_bi*T0+T12_Vdi_bi*T0_Vsi_bi+T12_Vsi_bi*T0_Vdi_bi+T12*T0_Vdi_bi_Vsi_bi)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vsi_bi+T0_Vsi_bi)+(((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vsi_bi+T0_Vdi_bi_Vsi_bi)+0.0)))-(+LambdaC_Vdi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vsi_bi*qs+qs_Vdi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vsi_bi)+qs_Vdi_bi_Vsi_bi)-(+(+T0_Vdi_bi_Vsi_bi*T0+T0_Vdi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vsi_bi)+T0_Vdi_bi_Vsi_bi))));
  T4_Vdi_bi_Tempt_GND=(+(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+(+(+T12_Vdi_bi_Tempt_GND*T0+T12_Vdi_bi*T0_Tempt_GND+T12_Tempt_GND*T0_Vdi_bi+T12*T0_Vdi_bi_Tempt_GND)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Tempt_GND+T0_Tempt_GND)+(((T12_Tempt_GND*T0)+(T12*T0_Tempt_GND)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Tempt_GND+T0_Vdi_bi_Tempt_GND)+0.0)))-(+LambdaC_Vdi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Tempt_GND*qs+qs_Vdi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vdi_bi+qs*qs_Vdi_bi_Tempt_GND)+qs_Vdi_bi_Tempt_GND)-(+(+T0_Vdi_bi_Tempt_GND*T0+T0_Vdi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_bi+T0*T0_Vdi_bi_Tempt_GND)+T0_Vdi_bi_Tempt_GND))));
#endif
T4_Vsi_bi=((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+((((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*((qs+T0)+1.0))+((T12*T0)*(qs_Vsi_bi+T0_Vsi_bi))))-((LambdaC_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi)))));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+(+(+0.0*T0+T12_Vsi_bi*T0_Vgm_si+0.0*T0_Vsi_bi+T12*T0_Vsi_bi_Vgm_si)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vgm_si+T0_Vgm_si)+((T12*T0_Vgm_si))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vgm_si+T0_Vsi_bi_Vgm_si)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgm_si*qs+qs_Vsi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_si)+qs_Vsi_bi_Vgm_si)-(+(+T0_Vsi_bi_Vgm_si*T0+T0_Vsi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_si)+T0_Vsi_bi_Vgm_si))));
  T4_Vsi_bi_Vgm_di=(+(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+(+(+0.0*T0+T12_Vsi_bi*T0_Vgm_di+0.0*T0_Vsi_bi+T12*T0_Vsi_bi_Vgm_di)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vgm_di+T0_Vgm_di)+((T12*T0_Vgm_di))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vgm_di+T0_Vsi_bi_Vgm_di)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgm_di*qs+qs_Vsi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_di)+qs_Vsi_bi_Vgm_di)-(+(+T0_Vsi_bi_Vgm_di*T0+T0_Vsi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_di)+T0_Vsi_bi_Vgm_di))));
  T4_Vsi_bi_Vdbulk_di=(+(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+(+(+T12_Vsi_bi_Vdbulk_di*T0+T12_Vsi_bi*T0_Vdbulk_di+T12_Vdbulk_di*T0_Vsi_bi+T12*T0_Vsi_bi_Vdbulk_di)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vdbulk_di+T0_Vdbulk_di)+(((T12_Vdbulk_di*T0)+(T12*T0_Vdbulk_di)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vdbulk_di+T0_Vsi_bi_Vdbulk_di)+0.0)))-(+LambdaC_Vsi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vdbulk_di*qs+qs_Vsi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vdbulk_di)+qs_Vsi_bi_Vdbulk_di)-(+(+T0_Vsi_bi_Vdbulk_di*T0+T0_Vsi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vdbulk_di)+T0_Vsi_bi_Vdbulk_di))));
  T4_Vsi_bi_Vsbulk_si=(+(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+(+(+T12_Vsi_bi_Vsbulk_si*T0+T12_Vsi_bi*T0_Vsbulk_si+T12_Vsbulk_si*T0_Vsi_bi+T12*T0_Vsi_bi_Vsbulk_si)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vsbulk_si+T0_Vsbulk_si)+(((T12_Vsbulk_si*T0)+(T12*T0_Vsbulk_si)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vsbulk_si+T0_Vsi_bi_Vsbulk_si)+0.0)))-(+LambdaC_Vsi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vsbulk_si*qs+qs_Vsi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vsbulk_si)+qs_Vsi_bi_Vsbulk_si)-(+(+T0_Vsi_bi_Vsbulk_si*T0+T0_Vsi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vsbulk_si)+T0_Vsi_bi_Vsbulk_si))));
  T4_Vsi_bi_Vgi_bi=(+(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+(+(+T12_Vsi_bi_Vgi_bi*T0+T12_Vsi_bi*T0_Vgi_bi+T12_Vgi_bi*T0_Vsi_bi+T12*T0_Vsi_bi_Vgi_bi)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vgi_bi+T0_Vgi_bi)+(((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vgi_bi+T0_Vsi_bi_Vgi_bi)+0.0)))-(+LambdaC_Vsi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgi_bi*qs+qs_Vsi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vgi_bi)+qs_Vsi_bi_Vgi_bi)-(+(+T0_Vsi_bi_Vgi_bi*T0+T0_Vsi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vgi_bi)+T0_Vsi_bi_Vgi_bi))));
  T4_Vsi_bi_Vdi_bi=(+(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+(+(+T12_Vsi_bi_Vdi_bi*T0+T12_Vsi_bi*T0_Vdi_bi+T12_Vdi_bi*T0_Vsi_bi+T12*T0_Vsi_bi_Vdi_bi)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vdi_bi+T0_Vdi_bi)+(((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vdi_bi+T0_Vsi_bi_Vdi_bi)+0.0)))-(+LambdaC_Vsi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vdi_bi*qs+qs_Vsi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vdi_bi)+qs_Vsi_bi_Vdi_bi)-(+(+T0_Vsi_bi_Vdi_bi*T0+T0_Vsi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vdi_bi)+T0_Vsi_bi_Vdi_bi))));
  T4_Vsi_bi_Vsi_bi=(+(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+(+(+T12_Vsi_bi_Vsi_bi*T0+T12_Vsi_bi*T0_Vsi_bi+T12_Vsi_bi*T0_Vsi_bi+T12*T0_Vsi_bi_Vsi_bi)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vsi_bi+T0_Vsi_bi)+(((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vsi_bi+T0_Vsi_bi_Vsi_bi)+0.0)))-(+LambdaC_Vsi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vsi_bi*qs+qs_Vsi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vsi_bi)+qs_Vsi_bi_Vsi_bi)-(+(+T0_Vsi_bi_Vsi_bi*T0+T0_Vsi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vsi_bi)+T0_Vsi_bi_Vsi_bi))));
  T4_Vsi_bi_Tempt_GND=(+(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+(+(+T12_Vsi_bi_Tempt_GND*T0+T12_Vsi_bi*T0_Tempt_GND+T12_Tempt_GND*T0_Vsi_bi+T12*T0_Vsi_bi_Tempt_GND)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Tempt_GND+T0_Tempt_GND)+(((T12_Tempt_GND*T0)+(T12*T0_Tempt_GND)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Tempt_GND+T0_Vsi_bi_Tempt_GND)+0.0)))-(+LambdaC_Vsi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Tempt_GND*qs+qs_Vsi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vsi_bi+qs*qs_Vsi_bi_Tempt_GND)+qs_Vsi_bi_Tempt_GND)-(+(+T0_Vsi_bi_Tempt_GND*T0+T0_Vsi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vsi_bi+T0*T0_Vsi_bi_Tempt_GND)+T0_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+((((T12_Tempt_GND*T0)+(T12*T0_Tempt_GND))*((qs+T0)+1.0))+((T12*T0)*(qs_Tempt_GND+T0_Tempt_GND))))-((LambdaC_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND))+qs_Tempt_GND)-(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+T0_Tempt_GND)))));
#endif
#endif
T4=(((T0*T3)+((T12*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
EXIT_IF_ISNAN((((T0*T3)+((T12*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0)))))
if
((T1!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgm_si*T2+T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgm_di*T2+T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vdbulk_di*T2+T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vsbulk_si*T2+T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgi_bi*T2+T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)-ln_T1_T2_Vgi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vdi_bi*T2+T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)-ln_T1_T2_Vgi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vsi_bi*T2+T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)-ln_T1_T2_Vgi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Tempt_GND*T2+T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)-ln_T1_T2_Vgi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
T5_Vdi_bi=((((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgm_si*T2+T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgm_di*T2+T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vdbulk_di*T2+T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vsbulk_si*T2+T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgi_bi*T2+T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)-ln_T1_T2_Vdi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vdi_bi*T2+T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)-ln_T1_T2_Vdi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vsi_bi*T2+T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)-ln_T1_T2_Vdi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Tempt_GND*T2+T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)-ln_T1_T2_Vdi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
T5_Vsi_bi=((((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgm_si*T2+T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgm_di*T2+T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vdbulk_di*T2+T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vsbulk_si*T2+T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgi_bi*T2+T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)-ln_T1_T2_Vsi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vdi_bi*T2+T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)-ln_T1_T2_Vsi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vsi_bi*T2+T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)-ln_T1_T2_Vsi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Tempt_GND*T2+T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)-ln_T1_T2_Vsi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((((-2.0)*LambdaC_Tempt_GND)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))-ln_T1_T2_Tempt_GND)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1));
#endif
#endif
T5=((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
EXIT_IF_ISNAN(((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(0.0)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vgi_bi_Vgm_di=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(0.0)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vgi_bi_Vdbulk_di=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdbulk_di)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((-2.0)*LambdaC_Vdbulk_di))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vgi_bi_Vsbulk_si=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsbulk_si)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((-2.0)*LambdaC_Vsbulk_si))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vgi_bi_Vgi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vgi_bi)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC_Vgi_bi))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vgi_bi_Vdi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdi_bi)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC_Vdi_bi))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vgi_bi_Vsi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsi_bi)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC_Vsi_bi))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vgi_bi_Tempt_GND=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Tempt_GND)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((-2.0)*LambdaC_Tempt_GND))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T5_Vdi_bi=((((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(0.0)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vdi_bi_Vgm_di=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(0.0)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vdi_bi_Vdbulk_di=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdbulk_di)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((-2.0)*LambdaC_Vdbulk_di))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vdi_bi_Vsbulk_si=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsbulk_si)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((-2.0)*LambdaC_Vsbulk_si))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vdi_bi_Vgi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vgi_bi)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC_Vgi_bi))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vdi_bi_Vdi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdi_bi)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC_Vdi_bi))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vdi_bi_Vsi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsi_bi)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC_Vsi_bi))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vdi_bi_Tempt_GND=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Tempt_GND)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((-2.0)*LambdaC_Tempt_GND))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T5_Vsi_bi=((((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(0.0)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vsi_bi_Vgm_di=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(0.0)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vsi_bi_Vdbulk_di=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdbulk_di)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((-2.0)*LambdaC_Vdbulk_di))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vsi_bi_Vsbulk_si=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsbulk_si)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((-2.0)*LambdaC_Vsbulk_si))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vsi_bi_Vgi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vgi_bi)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC_Vgi_bi))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vsi_bi_Vdi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdi_bi)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC_Vdi_bi))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vsi_bi_Vsi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsi_bi)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC_Vsi_bi))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vsi_bi_Tempt_GND=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Tempt_GND)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((-2.0)*LambdaC_Tempt_GND))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((((((-2.0)*LambdaC_Tempt_GND)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)));
#endif
#endif
T5=(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2));
EXIT_IF_ISNAN((((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=(((((T0_Vgi_bi*T5)+(T0*T5_Vgi_bi))+T3_Vgi_bi)+((T12_Vgi_bi*((qs+(2.0*T0))+1.0))+(T12*(qs_Vgi_bi+(2.0*T0_Vgi_bi)))))+((LambdaC_Vgi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vgi_bi))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+(+(+(+T0_Vgi_bi_Vgm_di*T5+T0_Vgi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vgi_bi+T0*T5_Vgi_bi_Vgm_di)+T3_Vgi_bi_Vgm_di)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vgm_di+((2.0*T0_Vgm_di)))+0.0*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vgm_di+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)+0.0)));
  T6_Vgi_bi_Vgm_si=(+(+(+(+T0_Vgi_bi_Vgm_si*T5+T0_Vgi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vgi_bi+T0*T5_Vgi_bi_Vgm_si)+T3_Vgi_bi_Vgm_si)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vgm_si+((2.0*T0_Vgm_si)))+0.0*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vgm_si+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)+0.0)));
  T6_Vgi_bi_Vdbulk_di=(+(+(+(+T0_Vgi_bi_Vdbulk_di*T5+T0_Vgi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vgi_bi+T0*T5_Vgi_bi_Vdbulk_di)+T3_Vgi_bi_Vdbulk_di)+(+T12_Vgi_bi_Vdbulk_di*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vdbulk_di+((2.0*T0_Vdbulk_di)))+T12_Vdbulk_di*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vdbulk_di+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di))+0.0)))+(+LambdaC_Vgi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)+0.0)));
  T6_Vgi_bi_Vsbulk_si=(+(+(+(+T0_Vgi_bi_Vsbulk_si*T5+T0_Vgi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vgi_bi+T0*T5_Vgi_bi_Vsbulk_si)+T3_Vgi_bi_Vsbulk_si)+(+T12_Vgi_bi_Vsbulk_si*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vsbulk_si+((2.0*T0_Vsbulk_si)))+T12_Vsbulk_si*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vsbulk_si+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si))+0.0)))+(+LambdaC_Vgi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)+0.0)));
  T6_Vgi_bi_Vgi_bi=(+(+(+(+T0_Vgi_bi_Vgi_bi*T5+T0_Vgi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vgi_bi)+T3_Vgi_bi_Vgi_bi)+(+T12_Vgi_bi_Vgi_bi*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vgi_bi+((2.0*T0_Vgi_bi)))+T12_Vgi_bi*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vgi_bi+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi))+0.0)))+(+LambdaC_Vgi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)+0.0)));
  T6_Vgi_bi_Vdi_bi=(+(+(+(+T0_Vgi_bi_Vdi_bi*T5+T0_Vgi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vdi_bi)+T3_Vgi_bi_Vdi_bi)+(+T12_Vgi_bi_Vdi_bi*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vdi_bi+((2.0*T0_Vdi_bi)))+T12_Vdi_bi*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vdi_bi+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi))+0.0)))+(+LambdaC_Vgi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)+0.0)));
  T6_Vgi_bi_Vsi_bi=(+(+(+(+T0_Vgi_bi_Vsi_bi*T5+T0_Vgi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vsi_bi)+T3_Vgi_bi_Vsi_bi)+(+T12_Vgi_bi_Vsi_bi*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vsi_bi+((2.0*T0_Vsi_bi)))+T12_Vsi_bi*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vsi_bi+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi))+0.0)))+(+LambdaC_Vgi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)+0.0)));
  T6_Vgi_bi_Tempt_GND=(+(+(+(+T0_Vgi_bi_Tempt_GND*T5+T0_Vgi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vgi_bi+T0*T5_Vgi_bi_Tempt_GND)+T3_Vgi_bi_Tempt_GND)+(+T12_Vgi_bi_Tempt_GND*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Tempt_GND+((2.0*T0_Tempt_GND)))+T12_Tempt_GND*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Tempt_GND+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND))+0.0)))+(+LambdaC_Vgi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)+0.0)));
#endif
T6_Vdi_bi=(((((T0_Vdi_bi*T5)+(T0*T5_Vdi_bi))+T3_Vdi_bi)+((T12_Vdi_bi*((qs+(2.0*T0))+1.0))+(T12*(qs_Vdi_bi+(2.0*T0_Vdi_bi)))))+((LambdaC_Vdi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vdi_bi))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(+(+(+T0_Vdi_bi_Vgm_di*T5+T0_Vdi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vdi_bi+T0*T5_Vdi_bi_Vgm_di)+T3_Vdi_bi_Vgm_di)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vgm_di+((2.0*T0_Vgm_di)))+0.0*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vgm_di+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)+0.0)));
  T6_Vdi_bi_Vgm_si=(+(+(+(+T0_Vdi_bi_Vgm_si*T5+T0_Vdi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vdi_bi+T0*T5_Vdi_bi_Vgm_si)+T3_Vdi_bi_Vgm_si)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vgm_si+((2.0*T0_Vgm_si)))+0.0*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vgm_si+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)+0.0)));
  T6_Vdi_bi_Vdbulk_di=(+(+(+(+T0_Vdi_bi_Vdbulk_di*T5+T0_Vdi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vdi_bi+T0*T5_Vdi_bi_Vdbulk_di)+T3_Vdi_bi_Vdbulk_di)+(+T12_Vdi_bi_Vdbulk_di*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vdbulk_di+((2.0*T0_Vdbulk_di)))+T12_Vdbulk_di*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vdbulk_di+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di))+0.0)))+(+LambdaC_Vdi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)+0.0)));
  T6_Vdi_bi_Vsbulk_si=(+(+(+(+T0_Vdi_bi_Vsbulk_si*T5+T0_Vdi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vdi_bi+T0*T5_Vdi_bi_Vsbulk_si)+T3_Vdi_bi_Vsbulk_si)+(+T12_Vdi_bi_Vsbulk_si*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vsbulk_si+((2.0*T0_Vsbulk_si)))+T12_Vsbulk_si*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vsbulk_si+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si))+0.0)))+(+LambdaC_Vdi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)+0.0)));
  T6_Vdi_bi_Vgi_bi=(+(+(+(+T0_Vdi_bi_Vgi_bi*T5+T0_Vdi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vgi_bi)+T3_Vdi_bi_Vgi_bi)+(+T12_Vdi_bi_Vgi_bi*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vgi_bi+((2.0*T0_Vgi_bi)))+T12_Vgi_bi*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vgi_bi+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi))+0.0)))+(+LambdaC_Vdi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)+0.0)));
  T6_Vdi_bi_Vdi_bi=(+(+(+(+T0_Vdi_bi_Vdi_bi*T5+T0_Vdi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vdi_bi)+T3_Vdi_bi_Vdi_bi)+(+T12_Vdi_bi_Vdi_bi*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vdi_bi+((2.0*T0_Vdi_bi)))+T12_Vdi_bi*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vdi_bi+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi))+0.0)))+(+LambdaC_Vdi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)+0.0)));
  T6_Vdi_bi_Vsi_bi=(+(+(+(+T0_Vdi_bi_Vsi_bi*T5+T0_Vdi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vsi_bi)+T3_Vdi_bi_Vsi_bi)+(+T12_Vdi_bi_Vsi_bi*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vsi_bi+((2.0*T0_Vsi_bi)))+T12_Vsi_bi*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vsi_bi+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi))+0.0)))+(+LambdaC_Vdi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)+0.0)));
  T6_Vdi_bi_Tempt_GND=(+(+(+(+T0_Vdi_bi_Tempt_GND*T5+T0_Vdi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vdi_bi+T0*T5_Vdi_bi_Tempt_GND)+T3_Vdi_bi_Tempt_GND)+(+T12_Vdi_bi_Tempt_GND*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Tempt_GND+((2.0*T0_Tempt_GND)))+T12_Tempt_GND*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Tempt_GND+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND))+0.0)))+(+LambdaC_Vdi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)+0.0)));
#endif
T6_Vsi_bi=(((((T0_Vsi_bi*T5)+(T0*T5_Vsi_bi))+T3_Vsi_bi)+((T12_Vsi_bi*((qs+(2.0*T0))+1.0))+(T12*(qs_Vsi_bi+(2.0*T0_Vsi_bi)))))+((LambdaC_Vsi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vsi_bi))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(+(+(+T0_Vsi_bi_Vgm_di*T5+T0_Vsi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vsi_bi+T0*T5_Vsi_bi_Vgm_di)+T3_Vsi_bi_Vgm_di)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vgm_di+((2.0*T0_Vgm_di)))+0.0*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vgm_di+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)+0.0)));
  T6_Vsi_bi_Vgm_si=(+(+(+(+T0_Vsi_bi_Vgm_si*T5+T0_Vsi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vsi_bi+T0*T5_Vsi_bi_Vgm_si)+T3_Vsi_bi_Vgm_si)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vgm_si+((2.0*T0_Vgm_si)))+0.0*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vgm_si+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)+0.0)));
  T6_Vsi_bi_Vdbulk_di=(+(+(+(+T0_Vsi_bi_Vdbulk_di*T5+T0_Vsi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vsi_bi+T0*T5_Vsi_bi_Vdbulk_di)+T3_Vsi_bi_Vdbulk_di)+(+T12_Vsi_bi_Vdbulk_di*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vdbulk_di+((2.0*T0_Vdbulk_di)))+T12_Vdbulk_di*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vdbulk_di+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di))+0.0)))+(+LambdaC_Vsi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)+0.0)));
  T6_Vsi_bi_Vsbulk_si=(+(+(+(+T0_Vsi_bi_Vsbulk_si*T5+T0_Vsi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vsi_bi+T0*T5_Vsi_bi_Vsbulk_si)+T3_Vsi_bi_Vsbulk_si)+(+T12_Vsi_bi_Vsbulk_si*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vsbulk_si+((2.0*T0_Vsbulk_si)))+T12_Vsbulk_si*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vsbulk_si+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si))+0.0)))+(+LambdaC_Vsi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)+0.0)));
  T6_Vsi_bi_Vgi_bi=(+(+(+(+T0_Vsi_bi_Vgi_bi*T5+T0_Vsi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vgi_bi)+T3_Vsi_bi_Vgi_bi)+(+T12_Vsi_bi_Vgi_bi*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vgi_bi+((2.0*T0_Vgi_bi)))+T12_Vgi_bi*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vgi_bi+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi))+0.0)))+(+LambdaC_Vsi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)+0.0)));
  T6_Vsi_bi_Vdi_bi=(+(+(+(+T0_Vsi_bi_Vdi_bi*T5+T0_Vsi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vdi_bi)+T3_Vsi_bi_Vdi_bi)+(+T12_Vsi_bi_Vdi_bi*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vdi_bi+((2.0*T0_Vdi_bi)))+T12_Vdi_bi*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vdi_bi+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi))+0.0)))+(+LambdaC_Vsi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)+0.0)));
  T6_Vsi_bi_Vsi_bi=(+(+(+(+T0_Vsi_bi_Vsi_bi*T5+T0_Vsi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vsi_bi)+T3_Vsi_bi_Vsi_bi)+(+T12_Vsi_bi_Vsi_bi*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vsi_bi+((2.0*T0_Vsi_bi)))+T12_Vsi_bi*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vsi_bi+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi))+0.0)))+(+LambdaC_Vsi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)+0.0)));
  T6_Vsi_bi_Tempt_GND=(+(+(+(+T0_Vsi_bi_Tempt_GND*T5+T0_Vsi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vsi_bi+T0*T5_Vsi_bi_Tempt_GND)+T3_Vsi_bi_Tempt_GND)+(+T12_Vsi_bi_Tempt_GND*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Tempt_GND+((2.0*T0_Tempt_GND)))+T12_Tempt_GND*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Tempt_GND+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND))+0.0)))+(+LambdaC_Vsi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)+0.0)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((((T0_Tempt_GND*T5)+(T0*T5_Tempt_GND))+T3_Tempt_GND)+((T12_Tempt_GND*((qs+(2.0*T0))+1.0))+(T12*(qs_Tempt_GND+(2.0*T0_Tempt_GND)))))+((LambdaC_Tempt_GND*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Tempt_GND))));
#endif
#endif
T6=((((T0*T5)+T3)+(T12*((qs+(2.0*T0))+1.0)))+(LambdaC*((2.0*T0)+1.0)));
EXIT_IF_ISNAN(((((T0*T5)+T3)+(T12*((qs+(2.0*T0))+1.0)))+(LambdaC*((2.0*T0)+1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(T0_Vgi_bi-((T4_Vgi_bi*T6-T4*T6_Vgi_bi)/T6/T6));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+T0_Vgi_bi_Vgm_di-(T4_Vgi_bi_Vgm_di/T6-(T4_Vgi_bi*T6_Vgm_di+T4_Vgm_di*T6_Vgi_bi+T4*T6_Vgi_bi_Vgm_di)/T6/T6+2*T4*T6_Vgi_bi*T6_Vgm_di/T6/T6/T6));
  T0_Vgi_bi_Vgm_si=(+T0_Vgi_bi_Vgm_si-(T4_Vgi_bi_Vgm_si/T6-(T4_Vgi_bi*T6_Vgm_si+T4_Vgm_si*T6_Vgi_bi+T4*T6_Vgi_bi_Vgm_si)/T6/T6+2*T4*T6_Vgi_bi*T6_Vgm_si/T6/T6/T6));
  T0_Vgi_bi_Vdbulk_di=(+T0_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T6-(T4_Vgi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vgi_bi+T4*T6_Vgi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vgi_bi*T6_Vdbulk_di/T6/T6/T6));
  T0_Vgi_bi_Vsbulk_si=(+T0_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T6-(T4_Vgi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vgi_bi+T4*T6_Vgi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vgi_bi*T6_Vsbulk_si/T6/T6/T6));
  T0_Vgi_bi_Vgi_bi=(+T0_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T6-(T4_Vgi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vgi_bi/T6/T6/T6));
  T0_Vgi_bi_Vdi_bi=(+T0_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T6-(T4_Vgi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vdi_bi/T6/T6/T6));
  T0_Vgi_bi_Vsi_bi=(+T0_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T6-(T4_Vgi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vsi_bi/T6/T6/T6));
  T0_Vgi_bi_Tempt_GND=(+T0_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T6-(T4_Vgi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vgi_bi+T4*T6_Vgi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vgi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
T0_Vdi_bi=(T0_Vdi_bi-((T4_Vdi_bi*T6-T4*T6_Vdi_bi)/T6/T6));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+T0_Vdi_bi_Vgm_di-(T4_Vdi_bi_Vgm_di/T6-(T4_Vdi_bi*T6_Vgm_di+T4_Vgm_di*T6_Vdi_bi+T4*T6_Vdi_bi_Vgm_di)/T6/T6+2*T4*T6_Vdi_bi*T6_Vgm_di/T6/T6/T6));
  T0_Vdi_bi_Vgm_si=(+T0_Vdi_bi_Vgm_si-(T4_Vdi_bi_Vgm_si/T6-(T4_Vdi_bi*T6_Vgm_si+T4_Vgm_si*T6_Vdi_bi+T4*T6_Vdi_bi_Vgm_si)/T6/T6+2*T4*T6_Vdi_bi*T6_Vgm_si/T6/T6/T6));
  T0_Vdi_bi_Vdbulk_di=(+T0_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T6-(T4_Vdi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vdi_bi+T4*T6_Vdi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vdi_bi*T6_Vdbulk_di/T6/T6/T6));
  T0_Vdi_bi_Vsbulk_si=(+T0_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T6-(T4_Vdi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vdi_bi+T4*T6_Vdi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vdi_bi*T6_Vsbulk_si/T6/T6/T6));
  T0_Vdi_bi_Vgi_bi=(+T0_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T6-(T4_Vdi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vgi_bi/T6/T6/T6));
  T0_Vdi_bi_Vdi_bi=(+T0_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T6-(T4_Vdi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vdi_bi/T6/T6/T6));
  T0_Vdi_bi_Vsi_bi=(+T0_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T6-(T4_Vdi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vsi_bi/T6/T6/T6));
  T0_Vdi_bi_Tempt_GND=(+T0_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T6-(T4_Vdi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vdi_bi+T4*T6_Vdi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vdi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
T0_Vsi_bi=(T0_Vsi_bi-((T4_Vsi_bi*T6-T4*T6_Vsi_bi)/T6/T6));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+T0_Vsi_bi_Vgm_di-(T4_Vsi_bi_Vgm_di/T6-(T4_Vsi_bi*T6_Vgm_di+T4_Vgm_di*T6_Vsi_bi+T4*T6_Vsi_bi_Vgm_di)/T6/T6+2*T4*T6_Vsi_bi*T6_Vgm_di/T6/T6/T6));
  T0_Vsi_bi_Vgm_si=(+T0_Vsi_bi_Vgm_si-(T4_Vsi_bi_Vgm_si/T6-(T4_Vsi_bi*T6_Vgm_si+T4_Vgm_si*T6_Vsi_bi+T4*T6_Vsi_bi_Vgm_si)/T6/T6+2*T4*T6_Vsi_bi*T6_Vgm_si/T6/T6/T6));
  T0_Vsi_bi_Vdbulk_di=(+T0_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T6-(T4_Vsi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vsi_bi+T4*T6_Vsi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vsi_bi*T6_Vdbulk_di/T6/T6/T6));
  T0_Vsi_bi_Vsbulk_si=(+T0_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T6-(T4_Vsi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vsi_bi+T4*T6_Vsi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vsi_bi*T6_Vsbulk_si/T6/T6/T6));
  T0_Vsi_bi_Vgi_bi=(+T0_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T6-(T4_Vsi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vgi_bi/T6/T6/T6));
  T0_Vsi_bi_Vdi_bi=(+T0_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T6-(T4_Vsi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vdi_bi/T6/T6/T6));
  T0_Vsi_bi_Vsi_bi=(+T0_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T6-(T4_Vsi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vsi_bi/T6/T6/T6));
  T0_Vsi_bi_Tempt_GND=(+T0_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T6-(T4_Vsi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vsi_bi+T4*T6_Vsi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vsi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(T0_Tempt_GND-((T4_Tempt_GND*T6-T4*T6_Tempt_GND)/T6/T6));
#endif
#endif
T0=(T0-(T4/T6));
EXIT_IF_ISNAN((T0-(T4/T6)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(((2.0*LambdaC_Vgi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vgi_bi-T0_Vgi_bi)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_di-T0_Vgi_bi_Vgm_di));
  T1_Vgi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_si-T0_Vgi_bi_Vgm_si));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdbulk_di-T0_Vgi_bi_Vdbulk_di));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsbulk_si-T0_Vgi_bi_Vsbulk_si));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgi_bi-T0_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdi_bi-T0_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsi_bi-T0_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vgi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vgi_bi-T0_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Tempt_GND-T0_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(((2.0*LambdaC_Vdi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vdi_bi-T0_Vdi_bi)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_di-T0_Vdi_bi_Vgm_di));
  T1_Vdi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_si-T0_Vdi_bi_Vgm_si));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdbulk_di-T0_Vdi_bi_Vdbulk_di));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsbulk_si-T0_Vdi_bi_Vsbulk_si));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgi_bi-T0_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdi_bi-T0_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsi_bi-T0_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vdi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vdi_bi-T0_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Tempt_GND-T0_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(((2.0*LambdaC_Vsi_bi)*(qs-T0))+((2.0*LambdaC)*(qs_Vsi_bi-T0_Vsi_bi)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_di-T0_Vgm_di)+(0.0)*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_di-T0_Vsi_bi_Vgm_di));
  T1_Vsi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_si-T0_Vgm_si)+(0.0)*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_si-T0_Vsi_bi_Vgm_si));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdbulk_di)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vdbulk_di-T0_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdbulk_di-T0_Vsi_bi_Vdbulk_di));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsbulk_si)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vsbulk_si-T0_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsbulk_si-T0_Vsi_bi_Vsbulk_si));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vgi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vgi_bi-T0_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgi_bi-T0_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vdi_bi-T0_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdi_bi-T0_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsi_bi)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Vsi_bi-T0_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsi_bi-T0_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Tempt_GND)*(qs-T0)+(2.0*LambdaC_Vsi_bi)*(qs_Tempt_GND-T0_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vsi_bi-T0_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Tempt_GND-T0_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((2.0*LambdaC_Tempt_GND)*(qs-T0))+((2.0*LambdaC)*(qs_Tempt_GND-T0_Tempt_GND)));
#endif
#endif
T1=((2.0*LambdaC)*(qs-T0));
EXIT_IF_ISNAN(((2.0*LambdaC)*(qs-T0)))
{
double m00_sqrt(d00_sqrt0,(1.0+(T1*T1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(T1*T1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)));
  T2_Vgi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)));
  T2_Vgi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)));
  T2_Vgi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)));
  T2_Vgi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)));
  T2_Vgi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)));
  T2_Vgi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)));
  T2_Vgi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)));
#endif
T2_Vdi_bi=((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)));
  T2_Vdi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)));
  T2_Vdi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)));
  T2_Vdi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)));
  T2_Vdi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)));
  T2_Vdi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)));
  T2_Vdi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)));
  T2_Vdi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)));
#endif
T2_Vsi_bi=((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)));
  T2_Vsi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)));
  T2_Vsi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)));
  T2_Vsi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)));
  T2_Vsi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)));
  T2_Vsi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)));
  T2_Vsi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)));
  T2_Vsi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0;
#endif
#endif
T2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_asinh(d00_asinh0,T1)
#if defined(_DERIVATEFORDDX)
double m10_asinh(d10_asinh0,d00_asinh0,T1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
ln_T1_T2_Vgi_bi=T1_Vgi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vgi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vgi_bi);
  ln_T1_T2_Vgi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vdi_bi);
  ln_T1_T2_Vgi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vsi_bi);
  ln_T1_T2_Vgi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Tempt_GND);
#endif
ln_T1_T2_Vdi_bi=T1_Vdi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vdi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vgi_bi);
  ln_T1_T2_Vdi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vdi_bi);
  ln_T1_T2_Vdi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vsi_bi);
  ln_T1_T2_Vdi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Tempt_GND);
#endif
ln_T1_T2_Vsi_bi=T1_Vsi_bi*d10_asinh0;
#if defined(_DERIVATE2)
  ln_T1_T2_Vsi_bi_Vgi_bi=(m20_asinh(T1)*T1_Vgi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vgi_bi);
  ln_T1_T2_Vsi_bi_Vdi_bi=(m20_asinh(T1)*T1_Vdi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vdi_bi);
  ln_T1_T2_Vsi_bi_Vsi_bi=(m20_asinh(T1)*T1_Vsi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vsi_bi);
  ln_T1_T2_Vsi_bi_Tempt_GND=(m20_asinh(T1)*T1_Tempt_GND*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
ln_T1_T2_Tempt_GND=T1_Tempt_GND*d10_asinh0;
#endif
#endif
ln_T1_T2=d00_asinh0;
EXIT_IF_ISNAN(d00_asinh0)
}
if
((T1!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vgi_bi)));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*0.0));
  T3_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vgi_bi));
  T3_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vdi_bi));
  T3_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Vsi_bi));
  T3_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vgi_bi+(1.0/T1)*ln_T1_T2_Vgi_bi_Tempt_GND));
#endif
T3_Vdi_bi=(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vdi_bi)));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*0.0));
  T3_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vgi_bi));
  T3_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vdi_bi));
  T3_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Vsi_bi));
  T3_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vdi_bi+(1.0/T1)*ln_T1_T2_Vdi_bi_Tempt_GND));
#endif
T3_Vsi_bi=(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Vsi_bi)));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si+(+(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgm_si)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vgm_si/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di+(+(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgm_di)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgm_di/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vgm_di/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vdbulk_di/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*0.0+(-T1_Vsbulk_si/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*0.0));
  T3_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vgi_bi+(-T1_Vgi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vgi_bi));
  T3_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vdi_bi+(-T1_Vdi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vdi_bi));
  T3_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Vsi_bi));
  T3_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1)*ln_T1_T2+(-T1_Vsi_bi/T1/T1)*ln_T1_T2_Tempt_GND+(-T1_Tempt_GND/T1/T1)*ln_T1_T2_Vsi_bi+(1.0/T1)*ln_T1_T2_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T2_Tempt_GND+(((-T1_Tempt_GND/T1/T1)*ln_T1_T2)+((1.0/T1)*ln_T1_T2_Tempt_GND)));
#endif
#endif
T3=(T2+((1.0/T1)*ln_T1_T2));
EXIT_IF_ISNAN((T2+((1.0/T1)*ln_T1_T2)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vdi_bi=(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vsi_bi=(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgm_si)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgm_di)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T2_Tempt_GND+(-T2_Tempt_GND/T2/T2));
#endif
#endif
T3=(T2+(1.0/T2));
EXIT_IF_ISNAN((T2+(1.0/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+((((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*((qs+T0)+1.0))+((T12*T0)*(qs_Vgi_bi+T0_Vgi_bi))))-((LambdaC_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi)))));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+(+(+0.0*T0+T12_Vgi_bi*T0_Vgm_si+0.0*T0_Vgi_bi+T12*T0_Vgi_bi_Vgm_si)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vgm_si+T0_Vgm_si)+((T12*T0_Vgm_si))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vgm_si+T0_Vgi_bi_Vgm_si)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgm_si*qs+qs_Vgi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_si)+qs_Vgi_bi_Vgm_si)-(+(+T0_Vgi_bi_Vgm_si*T0+T0_Vgi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_si)+T0_Vgi_bi_Vgm_si))));
  T4_Vgi_bi_Vgm_di=(+(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+(+(+0.0*T0+T12_Vgi_bi*T0_Vgm_di+0.0*T0_Vgi_bi+T12*T0_Vgi_bi_Vgm_di)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vgm_di+T0_Vgm_di)+((T12*T0_Vgm_di))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vgm_di+T0_Vgi_bi_Vgm_di)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgm_di*qs+qs_Vgi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vgm_di)+qs_Vgi_bi_Vgm_di)-(+(+T0_Vgi_bi_Vgm_di*T0+T0_Vgi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_di)+T0_Vgi_bi_Vgm_di))));
  T4_Vgi_bi_Vdbulk_di=(+(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+(+(+T12_Vgi_bi_Vdbulk_di*T0+T12_Vgi_bi*T0_Vdbulk_di+T12_Vdbulk_di*T0_Vgi_bi+T12*T0_Vgi_bi_Vdbulk_di)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vdbulk_di+T0_Vdbulk_di)+(((T12_Vdbulk_di*T0)+(T12*T0_Vdbulk_di)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vdbulk_di+T0_Vgi_bi_Vdbulk_di)+0.0)))-(+LambdaC_Vgi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vdbulk_di*qs+qs_Vgi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vdbulk_di)+qs_Vgi_bi_Vdbulk_di)-(+(+T0_Vgi_bi_Vdbulk_di*T0+T0_Vgi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vdbulk_di)+T0_Vgi_bi_Vdbulk_di))));
  T4_Vgi_bi_Vsbulk_si=(+(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+(+(+T12_Vgi_bi_Vsbulk_si*T0+T12_Vgi_bi*T0_Vsbulk_si+T12_Vsbulk_si*T0_Vgi_bi+T12*T0_Vgi_bi_Vsbulk_si)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vsbulk_si+T0_Vsbulk_si)+(((T12_Vsbulk_si*T0)+(T12*T0_Vsbulk_si)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vsbulk_si+T0_Vgi_bi_Vsbulk_si)+0.0)))-(+LambdaC_Vgi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vsbulk_si*qs+qs_Vgi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vsbulk_si)+qs_Vgi_bi_Vsbulk_si)-(+(+T0_Vgi_bi_Vsbulk_si*T0+T0_Vgi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vsbulk_si)+T0_Vgi_bi_Vsbulk_si))));
  T4_Vgi_bi_Vgi_bi=(+(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+(+(+T12_Vgi_bi_Vgi_bi*T0+T12_Vgi_bi*T0_Vgi_bi+T12_Vgi_bi*T0_Vgi_bi+T12*T0_Vgi_bi_Vgi_bi)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vgi_bi+T0_Vgi_bi)+(((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vgi_bi+T0_Vgi_bi_Vgi_bi)+0.0)))-(+LambdaC_Vgi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vgi_bi*qs+qs_Vgi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vgi_bi)+qs_Vgi_bi_Vgi_bi)-(+(+T0_Vgi_bi_Vgi_bi*T0+T0_Vgi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vgi_bi)+T0_Vgi_bi_Vgi_bi))));
  T4_Vgi_bi_Vdi_bi=(+(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+(+(+T12_Vgi_bi_Vdi_bi*T0+T12_Vgi_bi*T0_Vdi_bi+T12_Vdi_bi*T0_Vgi_bi+T12*T0_Vgi_bi_Vdi_bi)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vdi_bi+T0_Vdi_bi)+(((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vdi_bi+T0_Vgi_bi_Vdi_bi)+0.0)))-(+LambdaC_Vgi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vdi_bi*qs+qs_Vgi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vdi_bi)+qs_Vgi_bi_Vdi_bi)-(+(+T0_Vgi_bi_Vdi_bi*T0+T0_Vgi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vdi_bi)+T0_Vgi_bi_Vdi_bi))));
  T4_Vgi_bi_Vsi_bi=(+(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+(+(+T12_Vgi_bi_Vsi_bi*T0+T12_Vgi_bi*T0_Vsi_bi+T12_Vsi_bi*T0_Vgi_bi+T12*T0_Vgi_bi_Vsi_bi)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Vsi_bi+T0_Vsi_bi)+(((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Vsi_bi+T0_Vgi_bi_Vsi_bi)+0.0)))-(+LambdaC_Vgi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Vsi_bi*qs+qs_Vgi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vsi_bi)+qs_Vgi_bi_Vsi_bi)-(+(+T0_Vgi_bi_Vsi_bi*T0+T0_Vgi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vsi_bi)+T0_Vgi_bi_Vsi_bi))));
  T4_Vgi_bi_Tempt_GND=(+(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+(+(+T12_Vgi_bi_Tempt_GND*T0+T12_Vgi_bi*T0_Tempt_GND+T12_Tempt_GND*T0_Vgi_bi+T12*T0_Vgi_bi_Tempt_GND)*((qs+T0)+1.0)+((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi))*(qs_Tempt_GND+T0_Tempt_GND)+(((T12_Tempt_GND*T0)+(T12*T0_Tempt_GND)))*(qs_Vgi_bi+T0_Vgi_bi)+(T12*T0)*(+(+qs_Vgi_bi_Tempt_GND+T0_Vgi_bi_Tempt_GND)+0.0)))-(+LambdaC_Vgi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vgi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)-(((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+T0_Vgi_bi))+LambdaC*(+(+(+qs_Vgi_bi_Tempt_GND*qs+qs_Vgi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vgi_bi+qs*qs_Vgi_bi_Tempt_GND)+qs_Vgi_bi_Tempt_GND)-(+(+T0_Vgi_bi_Tempt_GND*T0+T0_Vgi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vgi_bi+T0*T0_Vgi_bi_Tempt_GND)+T0_Vgi_bi_Tempt_GND))));
#endif
T4_Vdi_bi=((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+((((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*((qs+T0)+1.0))+((T12*T0)*(qs_Vdi_bi+T0_Vdi_bi))))-((LambdaC_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi)))));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+(+(+0.0*T0+T12_Vdi_bi*T0_Vgm_si+0.0*T0_Vdi_bi+T12*T0_Vdi_bi_Vgm_si)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vgm_si+T0_Vgm_si)+((T12*T0_Vgm_si))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vgm_si+T0_Vdi_bi_Vgm_si)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgm_si*qs+qs_Vdi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_si)+qs_Vdi_bi_Vgm_si)-(+(+T0_Vdi_bi_Vgm_si*T0+T0_Vdi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_si)+T0_Vdi_bi_Vgm_si))));
  T4_Vdi_bi_Vgm_di=(+(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+(+(+0.0*T0+T12_Vdi_bi*T0_Vgm_di+0.0*T0_Vdi_bi+T12*T0_Vdi_bi_Vgm_di)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vgm_di+T0_Vgm_di)+((T12*T0_Vgm_di))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vgm_di+T0_Vdi_bi_Vgm_di)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgm_di*qs+qs_Vdi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vgm_di)+qs_Vdi_bi_Vgm_di)-(+(+T0_Vdi_bi_Vgm_di*T0+T0_Vdi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_di)+T0_Vdi_bi_Vgm_di))));
  T4_Vdi_bi_Vdbulk_di=(+(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+(+(+T12_Vdi_bi_Vdbulk_di*T0+T12_Vdi_bi*T0_Vdbulk_di+T12_Vdbulk_di*T0_Vdi_bi+T12*T0_Vdi_bi_Vdbulk_di)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vdbulk_di+T0_Vdbulk_di)+(((T12_Vdbulk_di*T0)+(T12*T0_Vdbulk_di)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vdbulk_di+T0_Vdi_bi_Vdbulk_di)+0.0)))-(+LambdaC_Vdi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vdbulk_di*qs+qs_Vdi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vdbulk_di)+qs_Vdi_bi_Vdbulk_di)-(+(+T0_Vdi_bi_Vdbulk_di*T0+T0_Vdi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vdbulk_di)+T0_Vdi_bi_Vdbulk_di))));
  T4_Vdi_bi_Vsbulk_si=(+(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+(+(+T12_Vdi_bi_Vsbulk_si*T0+T12_Vdi_bi*T0_Vsbulk_si+T12_Vsbulk_si*T0_Vdi_bi+T12*T0_Vdi_bi_Vsbulk_si)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vsbulk_si+T0_Vsbulk_si)+(((T12_Vsbulk_si*T0)+(T12*T0_Vsbulk_si)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vsbulk_si+T0_Vdi_bi_Vsbulk_si)+0.0)))-(+LambdaC_Vdi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vsbulk_si*qs+qs_Vdi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vsbulk_si)+qs_Vdi_bi_Vsbulk_si)-(+(+T0_Vdi_bi_Vsbulk_si*T0+T0_Vdi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vsbulk_si)+T0_Vdi_bi_Vsbulk_si))));
  T4_Vdi_bi_Vgi_bi=(+(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+(+(+T12_Vdi_bi_Vgi_bi*T0+T12_Vdi_bi*T0_Vgi_bi+T12_Vgi_bi*T0_Vdi_bi+T12*T0_Vdi_bi_Vgi_bi)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vgi_bi+T0_Vgi_bi)+(((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vgi_bi+T0_Vdi_bi_Vgi_bi)+0.0)))-(+LambdaC_Vdi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vgi_bi*qs+qs_Vdi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vgi_bi)+qs_Vdi_bi_Vgi_bi)-(+(+T0_Vdi_bi_Vgi_bi*T0+T0_Vdi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vgi_bi)+T0_Vdi_bi_Vgi_bi))));
  T4_Vdi_bi_Vdi_bi=(+(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+(+(+T12_Vdi_bi_Vdi_bi*T0+T12_Vdi_bi*T0_Vdi_bi+T12_Vdi_bi*T0_Vdi_bi+T12*T0_Vdi_bi_Vdi_bi)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vdi_bi+T0_Vdi_bi)+(((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vdi_bi+T0_Vdi_bi_Vdi_bi)+0.0)))-(+LambdaC_Vdi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vdi_bi*qs+qs_Vdi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vdi_bi)+qs_Vdi_bi_Vdi_bi)-(+(+T0_Vdi_bi_Vdi_bi*T0+T0_Vdi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vdi_bi)+T0_Vdi_bi_Vdi_bi))));
  T4_Vdi_bi_Vsi_bi=(+(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+(+(+T12_Vdi_bi_Vsi_bi*T0+T12_Vdi_bi*T0_Vsi_bi+T12_Vsi_bi*T0_Vdi_bi+T12*T0_Vdi_bi_Vsi_bi)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Vsi_bi+T0_Vsi_bi)+(((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Vsi_bi+T0_Vdi_bi_Vsi_bi)+0.0)))-(+LambdaC_Vdi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Vsi_bi*qs+qs_Vdi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vsi_bi)+qs_Vdi_bi_Vsi_bi)-(+(+T0_Vdi_bi_Vsi_bi*T0+T0_Vdi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vsi_bi)+T0_Vdi_bi_Vsi_bi))));
  T4_Vdi_bi_Tempt_GND=(+(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+(+(+T12_Vdi_bi_Tempt_GND*T0+T12_Vdi_bi*T0_Tempt_GND+T12_Tempt_GND*T0_Vdi_bi+T12*T0_Vdi_bi_Tempt_GND)*((qs+T0)+1.0)+((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi))*(qs_Tempt_GND+T0_Tempt_GND)+(((T12_Tempt_GND*T0)+(T12*T0_Tempt_GND)))*(qs_Vdi_bi+T0_Vdi_bi)+(T12*T0)*(+(+qs_Vdi_bi_Tempt_GND+T0_Vdi_bi_Tempt_GND)+0.0)))-(+LambdaC_Vdi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vdi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)-(((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+T0_Vdi_bi))+LambdaC*(+(+(+qs_Vdi_bi_Tempt_GND*qs+qs_Vdi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vdi_bi+qs*qs_Vdi_bi_Tempt_GND)+qs_Vdi_bi_Tempt_GND)-(+(+T0_Vdi_bi_Tempt_GND*T0+T0_Vdi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_bi+T0*T0_Vdi_bi_Tempt_GND)+T0_Vdi_bi_Tempt_GND))));
#endif
T4_Vsi_bi=((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+((((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*((qs+T0)+1.0))+((T12*T0)*(qs_Vsi_bi+T0_Vsi_bi))))-((LambdaC_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi)))));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+(+(+0.0*T0+T12_Vsi_bi*T0_Vgm_si+0.0*T0_Vsi_bi+T12*T0_Vsi_bi_Vgm_si)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vgm_si+T0_Vgm_si)+((T12*T0_Vgm_si))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vgm_si+T0_Vsi_bi_Vgm_si)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgm_si*qs)+(qs*qs_Vgm_si)))+qs_Vgm_si)-((((T0_Vgm_si*T0)+(T0*T0_Vgm_si)))+T0_Vgm_si))+0.0*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgm_si*qs+qs_Vsi_bi*qs_Vgm_si+qs_Vgm_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_si)+qs_Vsi_bi_Vgm_si)-(+(+T0_Vsi_bi_Vgm_si*T0+T0_Vsi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_si)+T0_Vsi_bi_Vgm_si))));
  T4_Vsi_bi_Vgm_di=(+(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+(+(+0.0*T0+T12_Vsi_bi*T0_Vgm_di+0.0*T0_Vsi_bi+T12*T0_Vsi_bi_Vgm_di)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vgm_di+T0_Vgm_di)+((T12*T0_Vgm_di))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vgm_di+T0_Vsi_bi_Vgm_di)+0.0)))-(+0.0*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgm_di*qs)+(qs*qs_Vgm_di)))+qs_Vgm_di)-((((T0_Vgm_di*T0)+(T0*T0_Vgm_di)))+T0_Vgm_di))+0.0*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgm_di*qs+qs_Vsi_bi*qs_Vgm_di+qs_Vgm_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vgm_di)+qs_Vsi_bi_Vgm_di)-(+(+T0_Vsi_bi_Vgm_di*T0+T0_Vsi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_di)+T0_Vsi_bi_Vgm_di))));
  T4_Vsi_bi_Vdbulk_di=(+(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+(+(+T12_Vsi_bi_Vdbulk_di*T0+T12_Vsi_bi*T0_Vdbulk_di+T12_Vdbulk_di*T0_Vsi_bi+T12*T0_Vsi_bi_Vdbulk_di)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vdbulk_di+T0_Vdbulk_di)+(((T12_Vdbulk_di*T0)+(T12*T0_Vdbulk_di)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vdbulk_di+T0_Vsi_bi_Vdbulk_di)+0.0)))-(+LambdaC_Vsi_bi_Vdbulk_di*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)-((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+T0_Vdbulk_di))+LambdaC_Vdbulk_di*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vdbulk_di*qs+qs_Vsi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vdbulk_di)+qs_Vsi_bi_Vdbulk_di)-(+(+T0_Vsi_bi_Vdbulk_di*T0+T0_Vsi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vdbulk_di)+T0_Vsi_bi_Vdbulk_di))));
  T4_Vsi_bi_Vsbulk_si=(+(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+(+(+T12_Vsi_bi_Vsbulk_si*T0+T12_Vsi_bi*T0_Vsbulk_si+T12_Vsbulk_si*T0_Vsi_bi+T12*T0_Vsi_bi_Vsbulk_si)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vsbulk_si+T0_Vsbulk_si)+(((T12_Vsbulk_si*T0)+(T12*T0_Vsbulk_si)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vsbulk_si+T0_Vsi_bi_Vsbulk_si)+0.0)))-(+LambdaC_Vsi_bi_Vsbulk_si*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)-((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+T0_Vsbulk_si))+LambdaC_Vsbulk_si*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vsbulk_si*qs+qs_Vsi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vsbulk_si)+qs_Vsi_bi_Vsbulk_si)-(+(+T0_Vsi_bi_Vsbulk_si*T0+T0_Vsi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vsbulk_si)+T0_Vsi_bi_Vsbulk_si))));
  T4_Vsi_bi_Vgi_bi=(+(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+(+(+T12_Vsi_bi_Vgi_bi*T0+T12_Vsi_bi*T0_Vgi_bi+T12_Vgi_bi*T0_Vsi_bi+T12*T0_Vsi_bi_Vgi_bi)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vgi_bi+T0_Vgi_bi)+(((T12_Vgi_bi*T0)+(T12*T0_Vgi_bi)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vgi_bi+T0_Vsi_bi_Vgi_bi)+0.0)))-(+LambdaC_Vsi_bi_Vgi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)-((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+T0_Vgi_bi))+LambdaC_Vgi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vgi_bi*qs+qs_Vsi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vgi_bi)+qs_Vsi_bi_Vgi_bi)-(+(+T0_Vsi_bi_Vgi_bi*T0+T0_Vsi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vgi_bi)+T0_Vsi_bi_Vgi_bi))));
  T4_Vsi_bi_Vdi_bi=(+(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+(+(+T12_Vsi_bi_Vdi_bi*T0+T12_Vsi_bi*T0_Vdi_bi+T12_Vdi_bi*T0_Vsi_bi+T12*T0_Vsi_bi_Vdi_bi)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vdi_bi+T0_Vdi_bi)+(((T12_Vdi_bi*T0)+(T12*T0_Vdi_bi)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vdi_bi+T0_Vsi_bi_Vdi_bi)+0.0)))-(+LambdaC_Vsi_bi_Vdi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)-((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+T0_Vdi_bi))+LambdaC_Vdi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vdi_bi*qs+qs_Vsi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vdi_bi)+qs_Vsi_bi_Vdi_bi)-(+(+T0_Vsi_bi_Vdi_bi*T0+T0_Vsi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vdi_bi)+T0_Vsi_bi_Vdi_bi))));
  T4_Vsi_bi_Vsi_bi=(+(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+(+(+T12_Vsi_bi_Vsi_bi*T0+T12_Vsi_bi*T0_Vsi_bi+T12_Vsi_bi*T0_Vsi_bi+T12*T0_Vsi_bi_Vsi_bi)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Vsi_bi+T0_Vsi_bi)+(((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Vsi_bi+T0_Vsi_bi_Vsi_bi)+0.0)))-(+LambdaC_Vsi_bi_Vsi_bi*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)-((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+T0_Vsi_bi))+LambdaC_Vsi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Vsi_bi*qs+qs_Vsi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vsi_bi)+qs_Vsi_bi_Vsi_bi)-(+(+T0_Vsi_bi_Vsi_bi*T0+T0_Vsi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vsi_bi)+T0_Vsi_bi_Vsi_bi))));
  T4_Vsi_bi_Tempt_GND=(+(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+(+(+T12_Vsi_bi_Tempt_GND*T0+T12_Vsi_bi*T0_Tempt_GND+T12_Tempt_GND*T0_Vsi_bi+T12*T0_Vsi_bi_Tempt_GND)*((qs+T0)+1.0)+((T12_Vsi_bi*T0)+(T12*T0_Vsi_bi))*(qs_Tempt_GND+T0_Tempt_GND)+(((T12_Tempt_GND*T0)+(T12*T0_Tempt_GND)))*(qs_Vsi_bi+T0_Vsi_bi)+(T12*T0)*(+(+qs_Vsi_bi_Tempt_GND+T0_Vsi_bi_Tempt_GND)+0.0)))-(+LambdaC_Vsi_bi_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0))+LambdaC_Vsi_bi*(((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+T0_Tempt_GND))+LambdaC_Tempt_GND*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)-(((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+T0_Vsi_bi))+LambdaC*(+(+(+qs_Vsi_bi_Tempt_GND*qs+qs_Vsi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vsi_bi+qs*qs_Vsi_bi_Tempt_GND)+qs_Vsi_bi_Tempt_GND)-(+(+T0_Vsi_bi_Tempt_GND*T0+T0_Vsi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vsi_bi+T0*T0_Vsi_bi_Tempt_GND)+T0_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+((((T12_Tempt_GND*T0)+(T12*T0_Tempt_GND))*((qs+T0)+1.0))+((T12*T0)*(qs_Tempt_GND+T0_Tempt_GND))))-((LambdaC_Tempt_GND*(((qs*qs)+qs)-((T0*T0)+T0)))+(LambdaC*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND))+qs_Tempt_GND)-(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+T0_Tempt_GND)))));
#endif
#endif
T4=(((T0*T3)+((T12*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
EXIT_IF_ISNAN((((T0*T3)+((T12*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0)))))
if
((T1!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgm_si*T2+T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgm_di*T2+T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vdbulk_di*T2+T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vsbulk_si*T2+T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vgi_bi*T2+T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)-ln_T1_T2_Vgi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vdi_bi*T2+T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)-ln_T1_T2_Vgi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Vsi_bi*T2+T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)-ln_T1_T2_Vgi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vgi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vgi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)+((-2.0)*LambdaC)*(+(+T1_Vgi_bi_Tempt_GND*T2+T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)-ln_T1_T2_Vgi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vgi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi))-ln_T1_T2_Vgi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
T5_Vdi_bi=((((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgm_si*T2+T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgm_di*T2+T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vdbulk_di*T2+T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vsbulk_si*T2+T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vgi_bi*T2+T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)-ln_T1_T2_Vdi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vdi_bi*T2+T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)-ln_T1_T2_Vdi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Vsi_bi*T2+T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)-ln_T1_T2_Vdi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vdi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vdi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)+((-2.0)*LambdaC)*(+(+T1_Vdi_bi_Tempt_GND*T2+T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)-ln_T1_T2_Vdi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vdi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi))-ln_T1_T2_Vdi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
T5_Vsi_bi=((((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si)))+(0.0)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgm_si*T2+T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_si*T2)+(T1*T2_Vgm_si))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vgm_di=((+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di)))+(0.0)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgm_di*T2+T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((((0.0)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vgm_di*T2)+(T1*T2_Vgm_di))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vdbulk_di=((+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdbulk_di)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di)))+(((-2.0)*LambdaC_Vdbulk_di))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vdbulk_di*T2+T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((((((-2.0)*LambdaC_Vdbulk_di))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vsbulk_si=((+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsbulk_si)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si)))+(((-2.0)*LambdaC_Vsbulk_si))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vsbulk_si*T2+T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)-0.0))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((((((-2.0)*LambdaC_Vsbulk_si))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si))))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vgi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vgi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi)+(((-2.0)*LambdaC_Vgi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vgi_bi*T2+T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)-ln_T1_T2_Vsi_bi_Vgi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((((((-2.0)*LambdaC_Vgi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi)))-ln_T1_T2_Vgi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vdi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi)+(((-2.0)*LambdaC_Vdi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vdi_bi*T2+T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)-ln_T1_T2_Vsi_bi_Vdi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((((((-2.0)*LambdaC_Vdi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi)))-ln_T1_T2_Vdi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Vsi_bi=((+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsi_bi)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi)+(((-2.0)*LambdaC_Vsi_bi))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Vsi_bi*T2+T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)-ln_T1_T2_Vsi_bi_Vsi_bi))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((((((-2.0)*LambdaC_Vsi_bi))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi)))-ln_T1_T2_Vsi_bi))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))/(T1*T1)/(T1*T1)/(T1*T1));
  T5_Vsi_bi_Tempt_GND=((+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Tempt_GND)*((T1*T2)-ln_T1_T2)+((-2.0)*LambdaC_Vsi_bi)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND)+(((-2.0)*LambdaC_Tempt_GND))*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)+((-2.0)*LambdaC)*(+(+T1_Vsi_bi_Tempt_GND*T2+T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)-ln_T1_T2_Vsi_bi_Tempt_GND))/(T1*T1)-(((((-2.0)*LambdaC_Vsi_bi)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi))-ln_T1_T2_Vsi_bi)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((((((-2.0)*LambdaC_Tempt_GND))*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))-ln_T1_T2_Tempt_GND))))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND))/(T1*T1)/(T1*T1)+2*(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1)/(T1*T1));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((((-2.0)*LambdaC_Tempt_GND)*((T1*T2)-ln_T1_T2))+(((-2.0)*LambdaC)*(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))-ln_T1_T2_Tempt_GND)))*(T1*T1)-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))/(T1*T1)/(T1*T1));
#endif
#endif
T5=((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
EXIT_IF_ISNAN(((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(0.0)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vgm_si/T2-(T1_Vgi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vgi_bi_Vgm_di=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(0.0)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vgm_di/T2-(T1_Vgi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vgm_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vgi_bi_Vdbulk_di=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdbulk_di)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((-2.0)*LambdaC_Vdbulk_di))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vdbulk_di/T2-(T1_Vgi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vgi_bi+T1*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vgi_bi_Vsbulk_si=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsbulk_si)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((-2.0)*LambdaC_Vsbulk_si))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vsbulk_si/T2-(T1_Vgi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vgi_bi+T1*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vgi_bi_Vgi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vgi_bi)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC_Vgi_bi))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vgi_bi/T2-(T1_Vgi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vgi_bi_Vdi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vdi_bi)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC_Vdi_bi))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vdi_bi/T2-(T1_Vgi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vgi_bi_Vsi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Vsi_bi)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC_Vsi_bi))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Vsi_bi/T2-(T1_Vgi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vgi_bi+T1*T2_Vgi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vgi_bi_Tempt_GND=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+(-2.0)*LambdaC_Vgi_bi_Tempt_GND)*(T1/T2)+((-2.0)*LambdaC_Vgi_bi)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((-2.0)*LambdaC_Tempt_GND))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vgi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vgi_bi_Tempt_GND/T2-(T1_Vgi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vgi_bi+T1*T2_Vgi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T5_Vdi_bi=((((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(0.0)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vgm_si/T2-(T1_Vdi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vdi_bi_Vgm_di=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(0.0)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vgm_di/T2-(T1_Vdi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vgm_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vdi_bi_Vdbulk_di=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdbulk_di)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((-2.0)*LambdaC_Vdbulk_di))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vdbulk_di/T2-(T1_Vdi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vdi_bi+T1*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vdi_bi_Vsbulk_si=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsbulk_si)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((-2.0)*LambdaC_Vsbulk_si))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vsbulk_si/T2-(T1_Vdi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vdi_bi+T1*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vdi_bi_Vgi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vgi_bi)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC_Vgi_bi))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vgi_bi/T2-(T1_Vdi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vdi_bi_Vdi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vdi_bi)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC_Vdi_bi))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vdi_bi/T2-(T1_Vdi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vdi_bi_Vsi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Vsi_bi)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC_Vsi_bi))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Vsi_bi/T2-(T1_Vdi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vdi_bi+T1*T2_Vdi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vdi_bi_Tempt_GND=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+(-2.0)*LambdaC_Vdi_bi_Tempt_GND)*(T1/T2)+((-2.0)*LambdaC_Vdi_bi)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((-2.0)*LambdaC_Tempt_GND))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vdi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vdi_bi_Tempt_GND/T2-(T1_Vdi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_bi+T1*T2_Vdi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T5_Vsi_bi=((((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(0.0)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_si*T2-T1*T2_Vgm_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vgm_si/T2-(T1_Vsi_bi*T2_Vgm_si+T1_Vgm_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T5_Vsi_bi_Vgm_di=(+(+(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+(-2.0)*0.0)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(0.0)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2)+(((((((0.0)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgm_di*T2-T1*T2_Vgm_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vgm_di/T2-(T1_Vsi_bi*T2_Vgm_di+T1_Vgm_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vgm_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T5_Vsi_bi_Vdbulk_di=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdbulk_di)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((-2.0)*LambdaC_Vdbulk_di))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2)+(((((((((-2.0)*LambdaC_Vdbulk_di))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdbulk_di*T2-T1*T2_Vdbulk_di)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vdbulk_di/T2-(T1_Vsi_bi*T2_Vdbulk_di+T1_Vdbulk_di*T2_Vsi_bi+T1*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T5_Vsi_bi_Vsbulk_si=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsbulk_si)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((-2.0)*LambdaC_Vsbulk_si))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2)+(((((((((-2.0)*LambdaC_Vsbulk_si))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsbulk_si*T2-T1*T2_Vsbulk_si)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vsbulk_si/T2-(T1_Vsi_bi*T2_Vsbulk_si+T1_Vsbulk_si*T2_Vsi_bi+T1*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T5_Vsi_bi_Vgi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vgi_bi)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((-2.0)*LambdaC_Vgi_bi))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vgi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vgi_bi*T2-T1*T2_Vgi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vgi_bi/T2-(T1_Vsi_bi*T2_Vgi_bi+T1_Vgi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vgi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T5_Vsi_bi_Vdi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vdi_bi)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((-2.0)*LambdaC_Vdi_bi))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vdi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vdi_bi*T2-T1*T2_Vdi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vdi_bi/T2-(T1_Vsi_bi*T2_Vdi_bi+T1_Vdi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vdi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T5_Vsi_bi_Vsi_bi=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Vsi_bi)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC_Vsi_bi))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((((((((-2.0)*LambdaC_Vsi_bi))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Vsi_bi/T2-(T1_Vsi_bi*T2_Vsi_bi+T1_Vsi_bi*T2_Vsi_bi+T1*T2_Vsi_bi_Vsi_bi)/T2/T2+2*T1*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T5_Vsi_bi_Tempt_GND=(+(+(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+(-2.0)*LambdaC_Vsi_bi_Tempt_GND)*(T1/T2)+((-2.0)*LambdaC_Vsi_bi)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((-2.0)*LambdaC_Tempt_GND))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((-2.0)*LambdaC)*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+(((-2.0)*LambdaC)*(T1/T2))*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2))*(T1/T2)+((((((-2.0)*LambdaC_Vsi_bi)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)+(((((((((-2.0)*LambdaC_Tempt_GND))*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2))))*((T1_Vsi_bi*T2-T1*T2_Vsi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1_Vsi_bi_Tempt_GND/T2-(T1_Vsi_bi*T2_Tempt_GND+T1_Tempt_GND*T2_Vsi_bi+T1*T2_Vsi_bi_Tempt_GND)/T2/T2+2*T1*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((((((-2.0)*LambdaC_Tempt_GND)*(T1/T2))+(((-2.0)*LambdaC)*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)))*(T1/T2))+((((-2.0)*LambdaC)*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)))*(T1/T2))+(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)));
#endif
#endif
T5=(((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2));
EXIT_IF_ISNAN((((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=(((((T0_Vgi_bi*T5)+(T0*T5_Vgi_bi))+T3_Vgi_bi)+((T12_Vgi_bi*((qs+(2.0*T0))+1.0))+(T12*(qs_Vgi_bi+(2.0*T0_Vgi_bi)))))+((LambdaC_Vgi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vgi_bi))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+(+(+(+T0_Vgi_bi_Vgm_di*T5+T0_Vgi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vgi_bi+T0*T5_Vgi_bi_Vgm_di)+T3_Vgi_bi_Vgm_di)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vgm_di+((2.0*T0_Vgm_di)))+0.0*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vgm_di+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)+0.0)));
  T6_Vgi_bi_Vgm_si=(+(+(+(+T0_Vgi_bi_Vgm_si*T5+T0_Vgi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vgi_bi+T0*T5_Vgi_bi_Vgm_si)+T3_Vgi_bi_Vgm_si)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vgm_si+((2.0*T0_Vgm_si)))+0.0*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vgm_si+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)+0.0)));
  T6_Vgi_bi_Vdbulk_di=(+(+(+(+T0_Vgi_bi_Vdbulk_di*T5+T0_Vgi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vgi_bi+T0*T5_Vgi_bi_Vdbulk_di)+T3_Vgi_bi_Vdbulk_di)+(+T12_Vgi_bi_Vdbulk_di*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vdbulk_di+((2.0*T0_Vdbulk_di)))+T12_Vdbulk_di*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vdbulk_di+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di))+0.0)))+(+LambdaC_Vgi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)+0.0)));
  T6_Vgi_bi_Vsbulk_si=(+(+(+(+T0_Vgi_bi_Vsbulk_si*T5+T0_Vgi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vgi_bi+T0*T5_Vgi_bi_Vsbulk_si)+T3_Vgi_bi_Vsbulk_si)+(+T12_Vgi_bi_Vsbulk_si*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vsbulk_si+((2.0*T0_Vsbulk_si)))+T12_Vsbulk_si*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vsbulk_si+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si))+0.0)))+(+LambdaC_Vgi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)+0.0)));
  T6_Vgi_bi_Vgi_bi=(+(+(+(+T0_Vgi_bi_Vgi_bi*T5+T0_Vgi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vgi_bi)+T3_Vgi_bi_Vgi_bi)+(+T12_Vgi_bi_Vgi_bi*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vgi_bi+((2.0*T0_Vgi_bi)))+T12_Vgi_bi*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vgi_bi+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi))+0.0)))+(+LambdaC_Vgi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)+0.0)));
  T6_Vgi_bi_Vdi_bi=(+(+(+(+T0_Vgi_bi_Vdi_bi*T5+T0_Vgi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vdi_bi)+T3_Vgi_bi_Vdi_bi)+(+T12_Vgi_bi_Vdi_bi*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vdi_bi+((2.0*T0_Vdi_bi)))+T12_Vdi_bi*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vdi_bi+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi))+0.0)))+(+LambdaC_Vgi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)+0.0)));
  T6_Vgi_bi_Vsi_bi=(+(+(+(+T0_Vgi_bi_Vsi_bi*T5+T0_Vgi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vgi_bi+T0*T5_Vgi_bi_Vsi_bi)+T3_Vgi_bi_Vsi_bi)+(+T12_Vgi_bi_Vsi_bi*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Vsi_bi+((2.0*T0_Vsi_bi)))+T12_Vsi_bi*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Vsi_bi+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi))+0.0)))+(+LambdaC_Vgi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)+0.0)));
  T6_Vgi_bi_Tempt_GND=(+(+(+(+T0_Vgi_bi_Tempt_GND*T5+T0_Vgi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vgi_bi+T0*T5_Vgi_bi_Tempt_GND)+T3_Vgi_bi_Tempt_GND)+(+T12_Vgi_bi_Tempt_GND*((qs+(2.0*T0))+1.0)+T12_Vgi_bi*(qs_Tempt_GND+((2.0*T0_Tempt_GND)))+T12_Tempt_GND*(qs_Vgi_bi+(2.0*T0_Vgi_bi))+T12*(+(+qs_Vgi_bi_Tempt_GND+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND))+0.0)))+(+LambdaC_Vgi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vgi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vgi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)+0.0)));
#endif
T6_Vdi_bi=(((((T0_Vdi_bi*T5)+(T0*T5_Vdi_bi))+T3_Vdi_bi)+((T12_Vdi_bi*((qs+(2.0*T0))+1.0))+(T12*(qs_Vdi_bi+(2.0*T0_Vdi_bi)))))+((LambdaC_Vdi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vdi_bi))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(+(+(+T0_Vdi_bi_Vgm_di*T5+T0_Vdi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vdi_bi+T0*T5_Vdi_bi_Vgm_di)+T3_Vdi_bi_Vgm_di)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vgm_di+((2.0*T0_Vgm_di)))+0.0*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vgm_di+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)+0.0)));
  T6_Vdi_bi_Vgm_si=(+(+(+(+T0_Vdi_bi_Vgm_si*T5+T0_Vdi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vdi_bi+T0*T5_Vdi_bi_Vgm_si)+T3_Vdi_bi_Vgm_si)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vgm_si+((2.0*T0_Vgm_si)))+0.0*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vgm_si+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)+0.0)));
  T6_Vdi_bi_Vdbulk_di=(+(+(+(+T0_Vdi_bi_Vdbulk_di*T5+T0_Vdi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vdi_bi+T0*T5_Vdi_bi_Vdbulk_di)+T3_Vdi_bi_Vdbulk_di)+(+T12_Vdi_bi_Vdbulk_di*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vdbulk_di+((2.0*T0_Vdbulk_di)))+T12_Vdbulk_di*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vdbulk_di+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di))+0.0)))+(+LambdaC_Vdi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)+0.0)));
  T6_Vdi_bi_Vsbulk_si=(+(+(+(+T0_Vdi_bi_Vsbulk_si*T5+T0_Vdi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vdi_bi+T0*T5_Vdi_bi_Vsbulk_si)+T3_Vdi_bi_Vsbulk_si)+(+T12_Vdi_bi_Vsbulk_si*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vsbulk_si+((2.0*T0_Vsbulk_si)))+T12_Vsbulk_si*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vsbulk_si+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si))+0.0)))+(+LambdaC_Vdi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)+0.0)));
  T6_Vdi_bi_Vgi_bi=(+(+(+(+T0_Vdi_bi_Vgi_bi*T5+T0_Vdi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vgi_bi)+T3_Vdi_bi_Vgi_bi)+(+T12_Vdi_bi_Vgi_bi*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vgi_bi+((2.0*T0_Vgi_bi)))+T12_Vgi_bi*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vgi_bi+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi))+0.0)))+(+LambdaC_Vdi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)+0.0)));
  T6_Vdi_bi_Vdi_bi=(+(+(+(+T0_Vdi_bi_Vdi_bi*T5+T0_Vdi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vdi_bi)+T3_Vdi_bi_Vdi_bi)+(+T12_Vdi_bi_Vdi_bi*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vdi_bi+((2.0*T0_Vdi_bi)))+T12_Vdi_bi*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vdi_bi+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi))+0.0)))+(+LambdaC_Vdi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)+0.0)));
  T6_Vdi_bi_Vsi_bi=(+(+(+(+T0_Vdi_bi_Vsi_bi*T5+T0_Vdi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vdi_bi+T0*T5_Vdi_bi_Vsi_bi)+T3_Vdi_bi_Vsi_bi)+(+T12_Vdi_bi_Vsi_bi*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Vsi_bi+((2.0*T0_Vsi_bi)))+T12_Vsi_bi*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Vsi_bi+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi))+0.0)))+(+LambdaC_Vdi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)+0.0)));
  T6_Vdi_bi_Tempt_GND=(+(+(+(+T0_Vdi_bi_Tempt_GND*T5+T0_Vdi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vdi_bi+T0*T5_Vdi_bi_Tempt_GND)+T3_Vdi_bi_Tempt_GND)+(+T12_Vdi_bi_Tempt_GND*((qs+(2.0*T0))+1.0)+T12_Vdi_bi*(qs_Tempt_GND+((2.0*T0_Tempt_GND)))+T12_Tempt_GND*(qs_Vdi_bi+(2.0*T0_Vdi_bi))+T12*(+(+qs_Vdi_bi_Tempt_GND+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND))+0.0)))+(+LambdaC_Vdi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vdi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vdi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)+0.0)));
#endif
T6_Vsi_bi=(((((T0_Vsi_bi*T5)+(T0*T5_Vsi_bi))+T3_Vsi_bi)+((T12_Vsi_bi*((qs+(2.0*T0))+1.0))+(T12*(qs_Vsi_bi+(2.0*T0_Vsi_bi)))))+((LambdaC_Vsi_bi*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Vsi_bi))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(+(+(+T0_Vsi_bi_Vgm_di*T5+T0_Vsi_bi*T5_Vgm_di+T0_Vgm_di*T5_Vsi_bi+T0*T5_Vsi_bi_Vgm_di)+T3_Vsi_bi_Vgm_di)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vgm_di+((2.0*T0_Vgm_di)))+0.0*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vgm_di+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgm_di))+0.0*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)+0.0)));
  T6_Vsi_bi_Vgm_si=(+(+(+(+T0_Vsi_bi_Vgm_si*T5+T0_Vsi_bi*T5_Vgm_si+T0_Vgm_si*T5_Vsi_bi+T0*T5_Vsi_bi_Vgm_si)+T3_Vsi_bi_Vgm_si)+(+0.0*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vgm_si+((2.0*T0_Vgm_si)))+0.0*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vgm_si+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si))+0.0)))+(+0.0*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgm_si))+0.0*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)+0.0)));
  T6_Vsi_bi_Vdbulk_di=(+(+(+(+T0_Vsi_bi_Vdbulk_di*T5+T0_Vsi_bi*T5_Vdbulk_di+T0_Vdbulk_di*T5_Vsi_bi+T0*T5_Vsi_bi_Vdbulk_di)+T3_Vsi_bi_Vdbulk_di)+(+T12_Vsi_bi_Vdbulk_di*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vdbulk_di+((2.0*T0_Vdbulk_di)))+T12_Vdbulk_di*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vdbulk_di+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di))+0.0)))+(+LambdaC_Vsi_bi_Vdbulk_di*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vdbulk_di))+LambdaC_Vdbulk_di*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)+0.0)));
  T6_Vsi_bi_Vsbulk_si=(+(+(+(+T0_Vsi_bi_Vsbulk_si*T5+T0_Vsi_bi*T5_Vsbulk_si+T0_Vsbulk_si*T5_Vsi_bi+T0*T5_Vsi_bi_Vsbulk_si)+T3_Vsi_bi_Vsbulk_si)+(+T12_Vsi_bi_Vsbulk_si*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vsbulk_si+((2.0*T0_Vsbulk_si)))+T12_Vsbulk_si*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vsbulk_si+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si))+0.0)))+(+LambdaC_Vsi_bi_Vsbulk_si*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vsbulk_si))+LambdaC_Vsbulk_si*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)+0.0)));
  T6_Vsi_bi_Vgi_bi=(+(+(+(+T0_Vsi_bi_Vgi_bi*T5+T0_Vsi_bi*T5_Vgi_bi+T0_Vgi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vgi_bi)+T3_Vsi_bi_Vgi_bi)+(+T12_Vsi_bi_Vgi_bi*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vgi_bi+((2.0*T0_Vgi_bi)))+T12_Vgi_bi*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vgi_bi+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi))+0.0)))+(+LambdaC_Vsi_bi_Vgi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vgi_bi))+LambdaC_Vgi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)+0.0)));
  T6_Vsi_bi_Vdi_bi=(+(+(+(+T0_Vsi_bi_Vdi_bi*T5+T0_Vsi_bi*T5_Vdi_bi+T0_Vdi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vdi_bi)+T3_Vsi_bi_Vdi_bi)+(+T12_Vsi_bi_Vdi_bi*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vdi_bi+((2.0*T0_Vdi_bi)))+T12_Vdi_bi*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vdi_bi+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi))+0.0)))+(+LambdaC_Vsi_bi_Vdi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vdi_bi))+LambdaC_Vdi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)+0.0)));
  T6_Vsi_bi_Vsi_bi=(+(+(+(+T0_Vsi_bi_Vsi_bi*T5+T0_Vsi_bi*T5_Vsi_bi+T0_Vsi_bi*T5_Vsi_bi+T0*T5_Vsi_bi_Vsi_bi)+T3_Vsi_bi_Vsi_bi)+(+T12_Vsi_bi_Vsi_bi*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Vsi_bi+((2.0*T0_Vsi_bi)))+T12_Vsi_bi*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Vsi_bi+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi))+0.0)))+(+LambdaC_Vsi_bi_Vsi_bi*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Vsi_bi))+LambdaC_Vsi_bi*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)+0.0)));
  T6_Vsi_bi_Tempt_GND=(+(+(+(+T0_Vsi_bi_Tempt_GND*T5+T0_Vsi_bi*T5_Tempt_GND+T0_Tempt_GND*T5_Vsi_bi+T0*T5_Vsi_bi_Tempt_GND)+T3_Vsi_bi_Tempt_GND)+(+T12_Vsi_bi_Tempt_GND*((qs+(2.0*T0))+1.0)+T12_Vsi_bi*(qs_Tempt_GND+((2.0*T0_Tempt_GND)))+T12_Tempt_GND*(qs_Vsi_bi+(2.0*T0_Vsi_bi))+T12*(+(+qs_Vsi_bi_Tempt_GND+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND))+0.0)))+(+LambdaC_Vsi_bi_Tempt_GND*((2.0*T0)+1.0)+LambdaC_Vsi_bi*((2.0*T0_Tempt_GND))+LambdaC_Tempt_GND*(2.0*T0_Vsi_bi)+LambdaC*(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)+0.0)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((((T0_Tempt_GND*T5)+(T0*T5_Tempt_GND))+T3_Tempt_GND)+((T12_Tempt_GND*((qs+(2.0*T0))+1.0))+(T12*(qs_Tempt_GND+(2.0*T0_Tempt_GND)))))+((LambdaC_Tempt_GND*((2.0*T0)+1.0))+(LambdaC*(2.0*T0_Tempt_GND))));
#endif
#endif
T6=((((T0*T5)+T3)+(T12*((qs+(2.0*T0))+1.0)))+(LambdaC*((2.0*T0)+1.0)));
EXIT_IF_ISNAN(((((T0*T5)+T3)+(T12*((qs+(2.0*T0))+1.0)))+(LambdaC*((2.0*T0)+1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
qdsat_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  qdsat_Vdbulk_di_Vdbulk_di=0.0;
  qdsat_Vdbulk_di_Vsbulk_si=0.0;
  qdsat_Vdbulk_di_Vgi_bi=0.0;
  qdsat_Vdbulk_di_Vdi_bi=0.0;
  qdsat_Vdbulk_di_Vsi_bi=0.0;
  qdsat_Vdbulk_di_Tempt_GND=0.0;
#endif
qdsat_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  qdsat_Vsbulk_si_Vdbulk_di=0.0;
  qdsat_Vsbulk_si_Vsbulk_si=0.0;
  qdsat_Vsbulk_si_Vgi_bi=0.0;
  qdsat_Vsbulk_si_Vdi_bi=0.0;
  qdsat_Vsbulk_si_Vsi_bi=0.0;
  qdsat_Vsbulk_si_Tempt_GND=0.0;
#endif
qdsat_Vgi_bi=(T0_Vgi_bi-((T4_Vgi_bi*T6-T4*T6_Vgi_bi)/T6/T6));
#if defined(_DERIVATE2)
  qdsat_Vgi_bi_Vdbulk_di=(+T0_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T6-(T4_Vgi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vgi_bi+T4*T6_Vgi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vgi_bi*T6_Vdbulk_di/T6/T6/T6));
  qdsat_Vgi_bi_Vsbulk_si=(+T0_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T6-(T4_Vgi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vgi_bi+T4*T6_Vgi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vgi_bi*T6_Vsbulk_si/T6/T6/T6));
  qdsat_Vgi_bi_Vgi_bi=(+T0_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T6-(T4_Vgi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vgi_bi/T6/T6/T6));
  qdsat_Vgi_bi_Vdi_bi=(+T0_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T6-(T4_Vgi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vdi_bi/T6/T6/T6));
  qdsat_Vgi_bi_Vsi_bi=(+T0_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T6-(T4_Vgi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vgi_bi+T4*T6_Vgi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vgi_bi*T6_Vsi_bi/T6/T6/T6));
  qdsat_Vgi_bi_Tempt_GND=(+T0_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T6-(T4_Vgi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vgi_bi+T4*T6_Vgi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vgi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
qdsat_Vdi_bi=(T0_Vdi_bi-((T4_Vdi_bi*T6-T4*T6_Vdi_bi)/T6/T6));
#if defined(_DERIVATE2)
  qdsat_Vdi_bi_Vdbulk_di=(+T0_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T6-(T4_Vdi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vdi_bi+T4*T6_Vdi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vdi_bi*T6_Vdbulk_di/T6/T6/T6));
  qdsat_Vdi_bi_Vsbulk_si=(+T0_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T6-(T4_Vdi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vdi_bi+T4*T6_Vdi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vdi_bi*T6_Vsbulk_si/T6/T6/T6));
  qdsat_Vdi_bi_Vgi_bi=(+T0_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T6-(T4_Vdi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vgi_bi/T6/T6/T6));
  qdsat_Vdi_bi_Vdi_bi=(+T0_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T6-(T4_Vdi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vdi_bi/T6/T6/T6));
  qdsat_Vdi_bi_Vsi_bi=(+T0_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T6-(T4_Vdi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vdi_bi+T4*T6_Vdi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vdi_bi*T6_Vsi_bi/T6/T6/T6));
  qdsat_Vdi_bi_Tempt_GND=(+T0_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T6-(T4_Vdi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vdi_bi+T4*T6_Vdi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vdi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
qdsat_Vsi_bi=(T0_Vsi_bi-((T4_Vsi_bi*T6-T4*T6_Vsi_bi)/T6/T6));
#if defined(_DERIVATE2)
  qdsat_Vsi_bi_Vdbulk_di=(+T0_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T6-(T4_Vsi_bi*T6_Vdbulk_di+T4_Vdbulk_di*T6_Vsi_bi+T4*T6_Vsi_bi_Vdbulk_di)/T6/T6+2*T4*T6_Vsi_bi*T6_Vdbulk_di/T6/T6/T6));
  qdsat_Vsi_bi_Vsbulk_si=(+T0_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T6-(T4_Vsi_bi*T6_Vsbulk_si+T4_Vsbulk_si*T6_Vsi_bi+T4*T6_Vsi_bi_Vsbulk_si)/T6/T6+2*T4*T6_Vsi_bi*T6_Vsbulk_si/T6/T6/T6));
  qdsat_Vsi_bi_Vgi_bi=(+T0_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T6-(T4_Vsi_bi*T6_Vgi_bi+T4_Vgi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vgi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vgi_bi/T6/T6/T6));
  qdsat_Vsi_bi_Vdi_bi=(+T0_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T6-(T4_Vsi_bi*T6_Vdi_bi+T4_Vdi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vdi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vdi_bi/T6/T6/T6));
  qdsat_Vsi_bi_Vsi_bi=(+T0_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T6-(T4_Vsi_bi*T6_Vsi_bi+T4_Vsi_bi*T6_Vsi_bi+T4*T6_Vsi_bi_Vsi_bi)/T6/T6+2*T4*T6_Vsi_bi*T6_Vsi_bi/T6/T6/T6));
  qdsat_Vsi_bi_Tempt_GND=(+T0_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T6-(T4_Vsi_bi*T6_Tempt_GND+T4_Tempt_GND*T6_Vsi_bi+T4*T6_Vsi_bi_Tempt_GND)/T6/T6+2*T4*T6_Vsi_bi*T6_Tempt_GND/T6/T6/T6));
#endif
#if defined(_DERIVATE)
qdsat_Tempt_GND=(T0_Tempt_GND-((T4_Tempt_GND*T6-T4*T6_Tempt_GND)/T6/T6));
#endif
#endif
qdsat=(T0-(T4/T6));
EXIT_IF_ISNAN((T0-(T4/T6)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
vdsat_Vgi_bi=((psip_Vgi_bi-(2.0*phib_n_Vgi_bi))-((2.0*qdsat_Vgi_bi)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0))))))));
#if defined(_DERIVATE2)
  vdsat_Vgi_bi_Vgi_bi=(+(+psip_Vgi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vgi_bi))-(+(+0.0*qdsat+0.0*qdsat_Vgi_bi+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Vgi_bi)+(+(+(+(+qdsat_Vgi_bi_Vgi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vgi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vgi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Vgi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vgi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vgi_bi)+(gam_Vgi_bi_Vgi_bi/(nq-1.0)-(gam_Vgi_bi*nq_Vgi_bi+gam_Vgi_bi*nq_Vgi_bi+gam*(+nq_Vgi_bi_Vgi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Vgi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsat_Vgi_bi_Vdi_bi=(+(+psip_Vgi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vdi_bi))-(+(+0.0*qdsat+0.0*qdsat_Vdi_bi+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Vdi_bi)+(+(+(+(+qdsat_Vgi_bi_Vdi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vdi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vdi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Vdi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vdi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vdi_bi)+(gam_Vgi_bi_Vdi_bi/(nq-1.0)-(gam_Vgi_bi*nq_Vdi_bi+gam_Vdi_bi*nq_Vgi_bi+gam*(+nq_Vgi_bi_Vdi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Vdi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsat_Vgi_bi_Vsi_bi=(+(+psip_Vgi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vsi_bi))-(+(+0.0*qdsat+0.0*qdsat_Vsi_bi+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Vsi_bi)+(+(+(+(+qdsat_Vgi_bi_Vsi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vsi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vsi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Vsi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vsi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vsi_bi)+(gam_Vgi_bi_Vsi_bi/(nq-1.0)-(gam_Vgi_bi*nq_Vsi_bi+gam_Vsi_bi*nq_Vgi_bi+gam*(+nq_Vgi_bi_Vsi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Vsi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsat_Vgi_bi_Tempt_GND=(+(+psip_Vgi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Tempt_GND))-(+(+0.0*qdsat+0.0*qdsat_Tempt_GND+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Tempt_GND)+(+(+(+(+qdsat_Vgi_bi_Tempt_GND*2.0+qdsat_Vgi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Tempt_GND)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Tempt_GND)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Tempt_GND*2.0+qdsat_Vgi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Tempt_GND)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Tempt_GND)+(gam_Vgi_bi_Tempt_GND/(nq-1.0)-(gam_Vgi_bi*nq_Tempt_GND+gam_Tempt_GND*nq_Vgi_bi+gam*(+nq_Vgi_bi_Tempt_GND-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Tempt_GND/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
#endif
vdsat_Vdi_bi=((psip_Vdi_bi-(2.0*phib_n_Vdi_bi))-((2.0*qdsat_Vdi_bi)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0))))))));
#if defined(_DERIVATE2)
  vdsat_Vdi_bi_Vgi_bi=(+(+psip_Vdi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vgi_bi))-(+(+0.0*qdsat+0.0*qdsat_Vgi_bi+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Vgi_bi)+(+(+(+(+qdsat_Vdi_bi_Vgi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vgi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vgi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Vgi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vgi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vgi_bi)+(gam_Vdi_bi_Vgi_bi/(nq-1.0)-(gam_Vdi_bi*nq_Vgi_bi+gam_Vgi_bi*nq_Vdi_bi+gam*(+nq_Vdi_bi_Vgi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Vgi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsat_Vdi_bi_Vdi_bi=(+(+psip_Vdi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vdi_bi))-(+(+0.0*qdsat+0.0*qdsat_Vdi_bi+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Vdi_bi)+(+(+(+(+qdsat_Vdi_bi_Vdi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vdi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vdi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Vdi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vdi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vdi_bi)+(gam_Vdi_bi_Vdi_bi/(nq-1.0)-(gam_Vdi_bi*nq_Vdi_bi+gam_Vdi_bi*nq_Vdi_bi+gam*(+nq_Vdi_bi_Vdi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Vdi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsat_Vdi_bi_Vsi_bi=(+(+psip_Vdi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vsi_bi))-(+(+0.0*qdsat+0.0*qdsat_Vsi_bi+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Vsi_bi)+(+(+(+(+qdsat_Vdi_bi_Vsi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vsi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vsi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Vsi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vsi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vsi_bi)+(gam_Vdi_bi_Vsi_bi/(nq-1.0)-(gam_Vdi_bi*nq_Vsi_bi+gam_Vsi_bi*nq_Vdi_bi+gam*(+nq_Vdi_bi_Vsi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Vsi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsat_Vdi_bi_Tempt_GND=(+(+psip_Vdi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Tempt_GND))-(+(+0.0*qdsat+0.0*qdsat_Tempt_GND+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Tempt_GND)+(+(+(+(+qdsat_Vdi_bi_Tempt_GND*2.0+qdsat_Vdi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Tempt_GND)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Tempt_GND)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Tempt_GND*2.0+qdsat_Vdi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Tempt_GND)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Tempt_GND)+(gam_Vdi_bi_Tempt_GND/(nq-1.0)-(gam_Vdi_bi*nq_Tempt_GND+gam_Tempt_GND*nq_Vdi_bi+gam*(+nq_Vdi_bi_Tempt_GND-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Tempt_GND/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
#endif
vdsat_Vsi_bi=((psip_Vsi_bi-(2.0*phib_n_Vsi_bi))-((2.0*qdsat_Vsi_bi)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0))))))));
#if defined(_DERIVATE2)
  vdsat_Vsi_bi_Vgi_bi=(+(+psip_Vsi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vgi_bi))-(+(+0.0*qdsat+0.0*qdsat_Vgi_bi+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Vgi_bi)+(+(+(+(+qdsat_Vsi_bi_Vgi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vgi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vgi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Vgi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vgi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vgi_bi)+(gam_Vsi_bi_Vgi_bi/(nq-1.0)-(gam_Vsi_bi*nq_Vgi_bi+gam_Vgi_bi*nq_Vsi_bi+gam*(+nq_Vsi_bi_Vgi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Vgi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsat_Vsi_bi_Vdi_bi=(+(+psip_Vsi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vdi_bi))-(+(+0.0*qdsat+0.0*qdsat_Vdi_bi+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Vdi_bi)+(+(+(+(+qdsat_Vsi_bi_Vdi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vdi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vdi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Vdi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vdi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vdi_bi)+(gam_Vsi_bi_Vdi_bi/(nq-1.0)-(gam_Vsi_bi*nq_Vdi_bi+gam_Vdi_bi*nq_Vsi_bi+gam*(+nq_Vsi_bi_Vdi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Vdi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsat_Vsi_bi_Vsi_bi=(+(+psip_Vsi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vsi_bi))-(+(+0.0*qdsat+0.0*qdsat_Vsi_bi+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Vsi_bi)+(+(+(+(+qdsat_Vsi_bi_Vsi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vsi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vsi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Vsi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vsi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vsi_bi)+(gam_Vsi_bi_Vsi_bi/(nq-1.0)-(gam_Vsi_bi*nq_Vsi_bi+gam_Vsi_bi*nq_Vsi_bi+gam*(+nq_Vsi_bi_Vsi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Vsi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsat_Vsi_bi_Tempt_GND=(+(+psip_Vsi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Tempt_GND))-(+(+0.0*qdsat+0.0*qdsat_Tempt_GND+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Tempt_GND)+(+(+(+(+qdsat_Vsi_bi_Tempt_GND*2.0+qdsat_Vsi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Tempt_GND)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Tempt_GND)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Tempt_GND*2.0+qdsat_Vsi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Tempt_GND)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Tempt_GND)+(gam_Vsi_bi_Tempt_GND/(nq-1.0)-(gam_Vsi_bi*nq_Tempt_GND+gam_Tempt_GND*nq_Vsi_bi+gam*(+nq_Vsi_bi_Tempt_GND-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Tempt_GND/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
#endif
#if defined(_DERIVATE)
vdsat_Tempt_GND=((psip_Tempt_GND-(2.0*phib_n_Tempt_GND))-((2.0*qdsat_Tempt_GND)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Tempt_GND*2.0*nq)+((qdsat*2.0)*nq_Tempt_GND))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Tempt_GND*2.0*nq)+((qdsat*2.0)*nq_Tempt_GND))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0))))))));
#endif
#endif
vdsat=((psip-(2.0*phib_n))-((2.0*qdsat)+bsimbulk_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))))));
EXIT_IF_ISNAN(((psip-(2.0*phib_n))-((2.0*qdsat)+bsimbulk_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Vdsat_Vgi_bi=((vdsat_Vgi_bi*nVt)+(vdsat*nVt_Vgi_bi));
#if defined(_DERIVATE2)
  Vdsat_Vgi_bi_Vgi_bi=(+vdsat_Vgi_bi_Vgi_bi*nVt+vdsat_Vgi_bi*nVt_Vgi_bi+vdsat_Vgi_bi*nVt_Vgi_bi+vdsat*nVt_Vgi_bi_Vgi_bi);
  Vdsat_Vgi_bi_Vdi_bi=(+vdsat_Vgi_bi_Vdi_bi*nVt+vdsat_Vgi_bi*nVt_Vdi_bi+vdsat_Vdi_bi*nVt_Vgi_bi+vdsat*nVt_Vgi_bi_Vdi_bi);
  Vdsat_Vgi_bi_Vsi_bi=(+vdsat_Vgi_bi_Vsi_bi*nVt+vdsat_Vgi_bi*nVt_Vsi_bi+vdsat_Vsi_bi*nVt_Vgi_bi+vdsat*nVt_Vgi_bi_Vsi_bi);
  Vdsat_Vgi_bi_Tempt_GND=(+vdsat_Vgi_bi_Tempt_GND*nVt+vdsat_Vgi_bi*nVt_Tempt_GND+vdsat_Tempt_GND*nVt_Vgi_bi+vdsat*nVt_Vgi_bi_Tempt_GND);
#endif
Vdsat_Vdi_bi=((vdsat_Vdi_bi*nVt)+(vdsat*nVt_Vdi_bi));
#if defined(_DERIVATE2)
  Vdsat_Vdi_bi_Vgi_bi=(+vdsat_Vdi_bi_Vgi_bi*nVt+vdsat_Vdi_bi*nVt_Vgi_bi+vdsat_Vgi_bi*nVt_Vdi_bi+vdsat*nVt_Vdi_bi_Vgi_bi);
  Vdsat_Vdi_bi_Vdi_bi=(+vdsat_Vdi_bi_Vdi_bi*nVt+vdsat_Vdi_bi*nVt_Vdi_bi+vdsat_Vdi_bi*nVt_Vdi_bi+vdsat*nVt_Vdi_bi_Vdi_bi);
  Vdsat_Vdi_bi_Vsi_bi=(+vdsat_Vdi_bi_Vsi_bi*nVt+vdsat_Vdi_bi*nVt_Vsi_bi+vdsat_Vsi_bi*nVt_Vdi_bi+vdsat*nVt_Vdi_bi_Vsi_bi);
  Vdsat_Vdi_bi_Tempt_GND=(+vdsat_Vdi_bi_Tempt_GND*nVt+vdsat_Vdi_bi*nVt_Tempt_GND+vdsat_Tempt_GND*nVt_Vdi_bi+vdsat*nVt_Vdi_bi_Tempt_GND);
#endif
Vdsat_Vsi_bi=((vdsat_Vsi_bi*nVt)+(vdsat*nVt_Vsi_bi));
#if defined(_DERIVATE2)
  Vdsat_Vsi_bi_Vgi_bi=(+vdsat_Vsi_bi_Vgi_bi*nVt+vdsat_Vsi_bi*nVt_Vgi_bi+vdsat_Vgi_bi*nVt_Vsi_bi+vdsat*nVt_Vsi_bi_Vgi_bi);
  Vdsat_Vsi_bi_Vdi_bi=(+vdsat_Vsi_bi_Vdi_bi*nVt+vdsat_Vsi_bi*nVt_Vdi_bi+vdsat_Vdi_bi*nVt_Vsi_bi+vdsat*nVt_Vsi_bi_Vdi_bi);
  Vdsat_Vsi_bi_Vsi_bi=(+vdsat_Vsi_bi_Vsi_bi*nVt+vdsat_Vsi_bi*nVt_Vsi_bi+vdsat_Vsi_bi*nVt_Vsi_bi+vdsat*nVt_Vsi_bi_Vsi_bi);
  Vdsat_Vsi_bi_Tempt_GND=(+vdsat_Vsi_bi_Tempt_GND*nVt+vdsat_Vsi_bi*nVt_Tempt_GND+vdsat_Tempt_GND*nVt_Vsi_bi+vdsat*nVt_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Vdsat_Tempt_GND=((vdsat_Tempt_GND*nVt)+(vdsat*nVt_Tempt_GND));
#endif
#endif
Vdsat=(vdsat*nVt);
EXIT_IF_ISNAN((vdsat*nVt))
{
double m00_sqrt(d00_sqrt0,(((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
Vdssat_Vgi_bi=(0.5*(Vdsat_Vgi_bi+((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Vdssat_Vgi_bi_Vgi_bi=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*(Vdsat_Vgi_bi+((((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsat_Vgi_bi+((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vgi_bi_Vgi_bi-0.0)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi)))+((0.0)*1.0e-3))*((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsat_Vgi_bi_Vgi_bi-0.0)-0.0)*(Vdsat-Vs)+Vdsat_Vgi_bi*Vdsat_Vgi_bi+Vdsat_Vgi_bi*Vdsat_Vgi_bi+(Vdsat-Vs)*(+(+Vdsat_Vgi_bi_Vgi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssat_Vgi_bi_Vdi_bi=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*((Vdsat_Vdi_bi-Vs_Vdi_bi)+(((((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsat_Vgi_bi+((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vgi_bi_Vdi_bi-0.0)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsat_Vgi_bi_Vdi_bi-0.0)-0.0)*(Vdsat-Vs)+Vdsat_Vgi_bi*(Vdsat_Vdi_bi-Vs_Vdi_bi)+(Vdsat_Vdi_bi-Vs_Vdi_bi)*Vdsat_Vgi_bi+(Vdsat-Vs)*(+(+Vdsat_Vgi_bi_Vdi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssat_Vgi_bi_Vsi_bi=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*((Vdsat_Vsi_bi-Vs_Vsi_bi)+(((((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsat_Vgi_bi+((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vgi_bi_Vsi_bi-0.0)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsat_Vgi_bi_Vsi_bi-0.0)-0.0)*(Vdsat-Vs)+Vdsat_Vgi_bi*(Vdsat_Vsi_bi-Vs_Vsi_bi)+(Vdsat_Vsi_bi-Vs_Vsi_bi)*Vdsat_Vgi_bi+(Vdsat-Vs)*(+(+Vdsat_Vgi_bi_Vsi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssat_Vgi_bi_Tempt_GND=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*(Vdsat_Tempt_GND+((((Vdsat_Tempt_GND*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Tempt_GND)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsat_Vgi_bi+((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vgi_bi_Tempt_GND-0.0)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsat_Tempt_GND*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Tempt_GND)))+((0.0)*1.0e-3))*((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsat_Vgi_bi_Tempt_GND-0.0)-0.0)*(Vdsat-Vs)+Vdsat_Vgi_bi*Vdsat_Tempt_GND+Vdsat_Tempt_GND*Vdsat_Vgi_bi+(Vdsat-Vs)*(+(+Vdsat_Vgi_bi_Tempt_GND-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
#endif
Vdssat_Vdi_bi=(0.5*((Vdsat_Vdi_bi-Vs_Vdi_bi)+(((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  Vdssat_Vdi_bi_Vgi_bi=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*(Vdsat_Vgi_bi+((((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsat_Vdi_bi-Vs_Vdi_bi)+(((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vdi_bi_Vgi_bi-0.0)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi)))+((0.0)*1.0e-3))*(((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsat_Vdi_bi_Vgi_bi-0.0)-0.0)*(Vdsat-Vs)+(Vdsat_Vdi_bi-Vs_Vdi_bi)*Vdsat_Vgi_bi+Vdsat_Vgi_bi*(Vdsat_Vdi_bi-Vs_Vdi_bi)+(Vdsat-Vs)*(+(+Vdsat_Vdi_bi_Vgi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssat_Vdi_bi_Vdi_bi=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*((Vdsat_Vdi_bi-Vs_Vdi_bi)+(((((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsat_Vdi_bi-Vs_Vdi_bi)+(((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*(((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsat_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi)-0.0)*(Vdsat-Vs)+(Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat_Vdi_bi-Vs_Vdi_bi)+(Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat_Vdi_bi-Vs_Vdi_bi)+(Vdsat-Vs)*(+(+Vdsat_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssat_Vdi_bi_Vsi_bi=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*((Vdsat_Vsi_bi-Vs_Vsi_bi)+(((((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsat_Vdi_bi-Vs_Vdi_bi)+(((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*(((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsat_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi)-0.0)*(Vdsat-Vs)+(Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat_Vsi_bi-Vs_Vsi_bi)+(Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat_Vdi_bi-Vs_Vdi_bi)+(Vdsat-Vs)*(+(+Vdsat_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssat_Vdi_bi_Tempt_GND=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*(Vdsat_Tempt_GND+((((Vdsat_Tempt_GND*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Tempt_GND)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsat_Vdi_bi-Vs_Vdi_bi)+(((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vdi_bi_Tempt_GND-0.0)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsat_Tempt_GND*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Tempt_GND)))+((0.0)*1.0e-3))*(((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsat_Vdi_bi_Tempt_GND-0.0)-0.0)*(Vdsat-Vs)+(Vdsat_Vdi_bi-Vs_Vdi_bi)*Vdsat_Tempt_GND+Vdsat_Tempt_GND*(Vdsat_Vdi_bi-Vs_Vdi_bi)+(Vdsat-Vs)*(+(+Vdsat_Vdi_bi_Tempt_GND-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
#endif
Vdssat_Vsi_bi=(0.5*((Vdsat_Vsi_bi-Vs_Vsi_bi)+(((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  Vdssat_Vsi_bi_Vgi_bi=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*(Vdsat_Vgi_bi+((((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsat_Vsi_bi-Vs_Vsi_bi)+(((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vsi_bi_Vgi_bi-0.0)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsat_Vgi_bi*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Vgi_bi)))+((0.0)*1.0e-3))*(((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsat_Vsi_bi_Vgi_bi-0.0)-0.0)*(Vdsat-Vs)+(Vdsat_Vsi_bi-Vs_Vsi_bi)*Vdsat_Vgi_bi+Vdsat_Vgi_bi*(Vdsat_Vsi_bi-Vs_Vsi_bi)+(Vdsat-Vs)*(+(+Vdsat_Vsi_bi_Vgi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssat_Vsi_bi_Vdi_bi=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*((Vdsat_Vdi_bi-Vs_Vdi_bi)+(((((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsat_Vsi_bi-Vs_Vsi_bi)+(((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*(((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsat_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi)-0.0)*(Vdsat-Vs)+(Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat_Vdi_bi-Vs_Vdi_bi)+(Vdsat_Vdi_bi-Vs_Vdi_bi)*(Vdsat_Vsi_bi-Vs_Vsi_bi)+(Vdsat-Vs)*(+(+Vdsat_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssat_Vsi_bi_Vsi_bi=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*((Vdsat_Vsi_bi-Vs_Vsi_bi)+(((((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsat_Vsi_bi-Vs_Vsi_bi)+(((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*(((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsat_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi)-0.0)*(Vdsat-Vs)+(Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat_Vsi_bi-Vs_Vsi_bi)+(Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat_Vsi_bi-Vs_Vsi_bi)+(Vdsat-Vs)*(+(+Vdsat_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssat_Vsi_bi_Tempt_GND=(+0.0*((Vdsat-Vs)+d00_sqrt0)+0.0*(Vdsat_Tempt_GND+((((Vdsat_Tempt_GND*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Tempt_GND)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsat_Vsi_bi-Vs_Vsi_bi)+(((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsat_Vsi_bi_Tempt_GND-0.0)+0.0)+(m20_sqrt((((Vdsat-Vs)*(Vdsat-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsat_Tempt_GND*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Tempt_GND)))+((0.0)*1.0e-3))*(((Vdsat_Vsi_bi-Vs_Vsi_bi)*(Vdsat-Vs))+((Vdsat-Vs)*(Vdsat_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsat_Vsi_bi_Tempt_GND-0.0)-0.0)*(Vdsat-Vs)+(Vdsat_Vsi_bi-Vs_Vsi_bi)*Vdsat_Tempt_GND+Vdsat_Tempt_GND*(Vdsat_Vsi_bi-Vs_Vsi_bi)+(Vdsat-Vs)*(+(+Vdsat_Vsi_bi_Tempt_GND-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
#endif
#if defined(_DERIVATE)
Vdssat_Tempt_GND=(0.5*(Vdsat_Tempt_GND+((Vdsat_Tempt_GND*(Vdsat-Vs))+((Vdsat-Vs)*Vdsat_Tempt_GND))*d10_sqrt0));
#endif
#endif
Vdssat=(0.5*((Vdsat-Vs)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((Vdsat-Vs)+d00_sqrt0)))
}
{
double m00_pow(d00_pow0,(Vds/Vdssat),(1.0/DELTA_t))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(Vds/Vdssat),(1.0/DELTA_t))
double m11_pow(d11_pow0,d00_pow0,(Vds/Vdssat),(1.0/DELTA_t))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=0.0;
  T7_Vdbulk_di_Vgm_di=0.0;
  T7_Vdbulk_di_Vdbulk_di=0.0;
  T7_Vdbulk_di_Vsbulk_si=0.0;
  T7_Vdbulk_di_Vgi_bi=0.0;
  T7_Vdbulk_di_Vdi_bi=0.0;
  T7_Vdbulk_di_Vsi_bi=0.0;
  T7_Vdbulk_di_Tempt_GND=0.0;
#endif
T7_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=0.0;
  T7_Vsbulk_si_Vgm_di=0.0;
  T7_Vsbulk_si_Vdbulk_di=0.0;
  T7_Vsbulk_si_Vsbulk_si=0.0;
  T7_Vsbulk_si_Vgi_bi=0.0;
  T7_Vsbulk_si_Vdi_bi=0.0;
  T7_Vsbulk_si_Vsi_bi=0.0;
  T7_Vsbulk_si_Tempt_GND=0.0;
#endif
T7_Vgi_bi=(d10_pow0*(-Vds*Vdssat_Vgi_bi/Vdssat/Vdssat));
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=fixme;
  T7_Vgi_bi_Vgm_di=fixme;
  T7_Vgi_bi_Vdbulk_di=fixme;
  T7_Vgi_bi_Vsbulk_si=fixme;
  T7_Vgi_bi_Vgi_bi=fixme;
  T7_Vgi_bi_Vdi_bi=fixme;
  T7_Vgi_bi_Vsi_bi=fixme;
  T7_Vgi_bi_Tempt_GND=fixme;
#endif
T7_Vdi_bi=(d10_pow0*((Vds_Vdi_bi*Vdssat-Vds*Vdssat_Vdi_bi)/Vdssat/Vdssat));
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=fixme;
  T7_Vdi_bi_Vgm_di=fixme;
  T7_Vdi_bi_Vdbulk_di=fixme;
  T7_Vdi_bi_Vsbulk_si=fixme;
  T7_Vdi_bi_Vgi_bi=fixme;
  T7_Vdi_bi_Vdi_bi=fixme;
  T7_Vdi_bi_Vsi_bi=fixme;
  T7_Vdi_bi_Tempt_GND=fixme;
#endif
T7_Vsi_bi=(d10_pow0*((Vds_Vsi_bi*Vdssat-Vds*Vdssat_Vsi_bi)/Vdssat/Vdssat));
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=fixme;
  T7_Vsi_bi_Vgm_di=fixme;
  T7_Vsi_bi_Vdbulk_di=fixme;
  T7_Vsi_bi_Vsbulk_si=fixme;
  T7_Vsi_bi_Vgi_bi=fixme;
  T7_Vsi_bi_Vdi_bi=fixme;
  T7_Vsi_bi_Vsi_bi=fixme;
  T7_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(d10_pow0*(-Vds*Vdssat_Tempt_GND/Vdssat/Vdssat)+d11_pow0*(-DELTA_t_Tempt_GND/DELTA_t/DELTA_t));
#endif
#endif
T7=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(1.0+T7),(-DELTA_t))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0+T7),(-DELTA_t))
double m11_pow(d11_pow0,d00_pow0,(1.0+T7),(-DELTA_t))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=0.0;
  T8_Vdbulk_di_Vgm_si=0.0;
  T8_Vdbulk_di_Vdbulk_di=0.0;
  T8_Vdbulk_di_Vsbulk_si=0.0;
  T8_Vdbulk_di_Vgi_bi=0.0;
  T8_Vdbulk_di_Vdi_bi=0.0;
  T8_Vdbulk_di_Vsi_bi=0.0;
  T8_Vdbulk_di_Tempt_GND=0.0;
#endif
T8_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=0.0;
  T8_Vsbulk_si_Vgm_si=0.0;
  T8_Vsbulk_si_Vdbulk_di=0.0;
  T8_Vsbulk_si_Vsbulk_si=0.0;
  T8_Vsbulk_si_Vgi_bi=0.0;
  T8_Vsbulk_si_Vdi_bi=0.0;
  T8_Vsbulk_si_Vsi_bi=0.0;
  T8_Vsbulk_si_Tempt_GND=0.0;
#endif
T8_Vgi_bi=(d10_pow0*T7_Vgi_bi);
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=fixme;
  T8_Vgi_bi_Vgm_si=fixme;
  T8_Vgi_bi_Vdbulk_di=fixme;
  T8_Vgi_bi_Vsbulk_si=fixme;
  T8_Vgi_bi_Vgi_bi=fixme;
  T8_Vgi_bi_Vdi_bi=fixme;
  T8_Vgi_bi_Vsi_bi=fixme;
  T8_Vgi_bi_Tempt_GND=fixme;
#endif
T8_Vdi_bi=(d10_pow0*T7_Vdi_bi);
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=fixme;
  T8_Vdi_bi_Vgm_si=fixme;
  T8_Vdi_bi_Vdbulk_di=fixme;
  T8_Vdi_bi_Vsbulk_si=fixme;
  T8_Vdi_bi_Vgi_bi=fixme;
  T8_Vdi_bi_Vdi_bi=fixme;
  T8_Vdi_bi_Vsi_bi=fixme;
  T8_Vdi_bi_Tempt_GND=fixme;
#endif
T8_Vsi_bi=(d10_pow0*T7_Vsi_bi);
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=fixme;
  T8_Vsi_bi_Vgm_si=fixme;
  T8_Vsi_bi_Vdbulk_di=fixme;
  T8_Vsi_bi_Vsbulk_si=fixme;
  T8_Vsi_bi_Vgi_bi=fixme;
  T8_Vsi_bi_Vdi_bi=fixme;
  T8_Vsi_bi_Vsi_bi=fixme;
  T8_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(d10_pow0*T7_Tempt_GND+d11_pow0*(-DELTA_t_Tempt_GND));
#endif
#endif
T8=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Vdseff_Vgm_di=0.0;
#if defined(_DERIVATE2)
  Vdseff_Vgm_di_Vgm_di=0.0;
  Vdseff_Vgm_di_Vgm_si=0.0;
  Vdseff_Vgm_di_Vdbulk_di=0.0;
  Vdseff_Vgm_di_Vsbulk_si=0.0;
  Vdseff_Vgm_di_Vdi_bi=0.0;
  Vdseff_Vgm_di_Vsi_bi=0.0;
  Vdseff_Vgm_di_Vgi_bi=0.0;
  Vdseff_Vgm_di_Tempt_GND=0.0;
#endif
Vdseff_Vgm_si=0.0;
#if defined(_DERIVATE2)
  Vdseff_Vgm_si_Vgm_di=0.0;
  Vdseff_Vgm_si_Vgm_si=0.0;
  Vdseff_Vgm_si_Vdbulk_di=0.0;
  Vdseff_Vgm_si_Vsbulk_si=0.0;
  Vdseff_Vgm_si_Vdi_bi=0.0;
  Vdseff_Vgm_si_Vsi_bi=0.0;
  Vdseff_Vgm_si_Vgi_bi=0.0;
  Vdseff_Vgm_si_Tempt_GND=0.0;
#endif
Vdseff_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Vdseff_Vdbulk_di_Vgm_di=0.0;
  Vdseff_Vdbulk_di_Vgm_si=0.0;
  Vdseff_Vdbulk_di_Vdbulk_di=0.0;
  Vdseff_Vdbulk_di_Vsbulk_si=0.0;
  Vdseff_Vdbulk_di_Vdi_bi=0.0;
  Vdseff_Vdbulk_di_Vsi_bi=0.0;
  Vdseff_Vdbulk_di_Vgi_bi=0.0;
  Vdseff_Vdbulk_di_Tempt_GND=0.0;
#endif
Vdseff_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Vdseff_Vsbulk_si_Vgm_di=0.0;
  Vdseff_Vsbulk_si_Vgm_si=0.0;
  Vdseff_Vsbulk_si_Vdbulk_di=0.0;
  Vdseff_Vsbulk_si_Vsbulk_si=0.0;
  Vdseff_Vsbulk_si_Vdi_bi=0.0;
  Vdseff_Vsbulk_si_Vsi_bi=0.0;
  Vdseff_Vsbulk_si_Vgi_bi=0.0;
  Vdseff_Vsbulk_si_Tempt_GND=0.0;
#endif
Vdseff_Vdi_bi=((Vds_Vdi_bi*T8)+(Vds*T8_Vdi_bi));
#if defined(_DERIVATE2)
  Vdseff_Vdi_bi_Vgm_di=(+0.0*T8+Vds_Vdi_bi*T8_Vgm_di+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vgm_di);
  Vdseff_Vdi_bi_Vgm_si=(+0.0*T8+Vds_Vdi_bi*T8_Vgm_si+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vgm_si);
  Vdseff_Vdi_bi_Vdbulk_di=(+0.0*T8+Vds_Vdi_bi*T8_Vdbulk_di+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vdbulk_di);
  Vdseff_Vdi_bi_Vsbulk_si=(+0.0*T8+Vds_Vdi_bi*T8_Vsbulk_si+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vsbulk_si);
  Vdseff_Vdi_bi_Vdi_bi=(+Vds_Vdi_bi_Vdi_bi*T8+Vds_Vdi_bi*T8_Vdi_bi+Vds_Vdi_bi*T8_Vdi_bi+Vds*T8_Vdi_bi_Vdi_bi);
  Vdseff_Vdi_bi_Vsi_bi=(+Vds_Vdi_bi_Vsi_bi*T8+Vds_Vdi_bi*T8_Vsi_bi+Vds_Vsi_bi*T8_Vdi_bi+Vds*T8_Vdi_bi_Vsi_bi);
  Vdseff_Vdi_bi_Vgi_bi=(+0.0*T8+Vds_Vdi_bi*T8_Vgi_bi+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vgi_bi);
  Vdseff_Vdi_bi_Tempt_GND=(+0.0*T8+Vds_Vdi_bi*T8_Tempt_GND+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Tempt_GND);
#endif
Vdseff_Vsi_bi=((Vds_Vsi_bi*T8)+(Vds*T8_Vsi_bi));
#if defined(_DERIVATE2)
  Vdseff_Vsi_bi_Vgm_di=(+0.0*T8+Vds_Vsi_bi*T8_Vgm_di+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vgm_di);
  Vdseff_Vsi_bi_Vgm_si=(+0.0*T8+Vds_Vsi_bi*T8_Vgm_si+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vgm_si);
  Vdseff_Vsi_bi_Vdbulk_di=(+0.0*T8+Vds_Vsi_bi*T8_Vdbulk_di+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vdbulk_di);
  Vdseff_Vsi_bi_Vsbulk_si=(+0.0*T8+Vds_Vsi_bi*T8_Vsbulk_si+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vsbulk_si);
  Vdseff_Vsi_bi_Vdi_bi=(+Vds_Vsi_bi_Vdi_bi*T8+Vds_Vsi_bi*T8_Vdi_bi+Vds_Vdi_bi*T8_Vsi_bi+Vds*T8_Vsi_bi_Vdi_bi);
  Vdseff_Vsi_bi_Vsi_bi=(+Vds_Vsi_bi_Vsi_bi*T8+Vds_Vsi_bi*T8_Vsi_bi+Vds_Vsi_bi*T8_Vsi_bi+Vds*T8_Vsi_bi_Vsi_bi);
  Vdseff_Vsi_bi_Vgi_bi=(+0.0*T8+Vds_Vsi_bi*T8_Vgi_bi+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vgi_bi);
  Vdseff_Vsi_bi_Tempt_GND=(+0.0*T8+Vds_Vsi_bi*T8_Tempt_GND+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Tempt_GND);
#endif
Vdseff_Vgi_bi=(Vds*T8_Vgi_bi);
#if defined(_DERIVATE2)
  Vdseff_Vgi_bi_Vgm_di=(+0.0*T8+0.0*T8_Vgm_di+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vgm_di);
  Vdseff_Vgi_bi_Vgm_si=(+0.0*T8+0.0*T8_Vgm_si+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vgm_si);
  Vdseff_Vgi_bi_Vdbulk_di=(+0.0*T8+0.0*T8_Vdbulk_di+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vdbulk_di);
  Vdseff_Vgi_bi_Vsbulk_si=(+0.0*T8+0.0*T8_Vsbulk_si+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vsbulk_si);
  Vdseff_Vgi_bi_Vdi_bi=(+0.0*T8+0.0*T8_Vdi_bi+Vds_Vdi_bi*T8_Vgi_bi+Vds*T8_Vgi_bi_Vdi_bi);
  Vdseff_Vgi_bi_Vsi_bi=(+0.0*T8+0.0*T8_Vsi_bi+Vds_Vsi_bi*T8_Vgi_bi+Vds*T8_Vgi_bi_Vsi_bi);
  Vdseff_Vgi_bi_Vgi_bi=(+0.0*T8+0.0*T8_Vgi_bi+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vgi_bi);
  Vdseff_Vgi_bi_Tempt_GND=(+0.0*T8+0.0*T8_Tempt_GND+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Vdseff_Tempt_GND=(Vds*T8_Tempt_GND);
#endif
#endif
Vdseff=(Vds*T8);
EXIT_IF_ISNAN((Vds*T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
vdeff_Vgm_di=0.0;
#if defined(_DERIVATE2)
  vdeff_Vgm_di_Vgm_di=0.0;
  vdeff_Vgm_di_Vgm_si=0.0;
  vdeff_Vgm_di_Vdbulk_di=0.0;
  vdeff_Vgm_di_Vsbulk_si=0.0;
  vdeff_Vgm_di_Vdi_bi=0.0;
  vdeff_Vgm_di_Vsi_bi=0.0;
  vdeff_Vgm_di_Vgi_bi=0.0;
  vdeff_Vgm_di_Tempt_GND=0.0;
#endif
vdeff_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vdeff_Vgm_si_Vgm_di=0.0;
  vdeff_Vgm_si_Vgm_si=0.0;
  vdeff_Vgm_si_Vdbulk_di=0.0;
  vdeff_Vgm_si_Vsbulk_si=0.0;
  vdeff_Vgm_si_Vdi_bi=0.0;
  vdeff_Vgm_si_Vsi_bi=0.0;
  vdeff_Vgm_si_Vgi_bi=0.0;
  vdeff_Vgm_si_Tempt_GND=0.0;
#endif
vdeff_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  vdeff_Vdbulk_di_Vgm_di=0.0;
  vdeff_Vdbulk_di_Vgm_si=0.0;
  vdeff_Vdbulk_di_Vdbulk_di=0.0;
  vdeff_Vdbulk_di_Vsbulk_si=0.0;
  vdeff_Vdbulk_di_Vdi_bi=0.0;
  vdeff_Vdbulk_di_Vsi_bi=0.0;
  vdeff_Vdbulk_di_Vgi_bi=0.0;
  vdeff_Vdbulk_di_Tempt_GND=0.0;
#endif
vdeff_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  vdeff_Vsbulk_si_Vgm_di=0.0;
  vdeff_Vsbulk_si_Vgm_si=0.0;
  vdeff_Vsbulk_si_Vdbulk_di=0.0;
  vdeff_Vsbulk_si_Vsbulk_si=0.0;
  vdeff_Vsbulk_si_Vdi_bi=0.0;
  vdeff_Vsbulk_si_Vsi_bi=0.0;
  vdeff_Vsbulk_si_Vgi_bi=0.0;
  vdeff_Vsbulk_si_Tempt_GND=0.0;
#endif
vdeff_Vdi_bi=(((Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt)+((Vdseff+Vs)*inv_nVt_Vdi_bi));
#if defined(_DERIVATE2)
  vdeff_Vdi_bi_Vgm_di=(+(+Vdseff_Vdi_bi_Vgm_di+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+Vdseff_Vgm_di*inv_nVt_Vdi_bi+(Vdseff+Vs)*0.0);
  vdeff_Vdi_bi_Vgm_si=(+(+Vdseff_Vdi_bi_Vgm_si+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vgm_si+Vdseff_Vgm_si*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vgm_si);
  vdeff_Vdi_bi_Vdbulk_di=(+(+Vdseff_Vdi_bi_Vdbulk_di+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vdbulk_di);
  vdeff_Vdi_bi_Vsbulk_si=(+(+Vdseff_Vdi_bi_Vsbulk_si+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vsbulk_si);
  vdeff_Vdi_bi_Vdi_bi=(+(+Vdseff_Vdi_bi_Vdi_bi+Vs_Vdi_bi_Vdi_bi)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vdi_bi);
  vdeff_Vdi_bi_Vsi_bi=(+(+Vdseff_Vdi_bi_Vsi_bi+Vs_Vdi_bi_Vsi_bi)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vsi_bi);
  vdeff_Vdi_bi_Vgi_bi=(+(+Vdseff_Vdi_bi_Vgi_bi+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vgi_bi);
  vdeff_Vdi_bi_Tempt_GND=(+(+Vdseff_Vdi_bi_Tempt_GND+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Tempt_GND);
#endif
vdeff_Vsi_bi=(((Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt)+((Vdseff+Vs)*inv_nVt_Vsi_bi));
#if defined(_DERIVATE2)
  vdeff_Vsi_bi_Vgm_di=(+(+Vdseff_Vsi_bi_Vgm_di+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+Vdseff_Vgm_di*inv_nVt_Vsi_bi+(Vdseff+Vs)*0.0);
  vdeff_Vsi_bi_Vgm_si=(+(+Vdseff_Vsi_bi_Vgm_si+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vgm_si+Vdseff_Vgm_si*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vgm_si);
  vdeff_Vsi_bi_Vdbulk_di=(+(+Vdseff_Vsi_bi_Vdbulk_di+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vdbulk_di);
  vdeff_Vsi_bi_Vsbulk_si=(+(+Vdseff_Vsi_bi_Vsbulk_si+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vsbulk_si);
  vdeff_Vsi_bi_Vdi_bi=(+(+Vdseff_Vsi_bi_Vdi_bi+Vs_Vsi_bi_Vdi_bi)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vdi_bi);
  vdeff_Vsi_bi_Vsi_bi=(+(+Vdseff_Vsi_bi_Vsi_bi+Vs_Vsi_bi_Vsi_bi)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vsi_bi);
  vdeff_Vsi_bi_Vgi_bi=(+(+Vdseff_Vsi_bi_Vgi_bi+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vgi_bi);
  vdeff_Vsi_bi_Tempt_GND=(+(+Vdseff_Vsi_bi_Tempt_GND+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Tempt_GND);
#endif
vdeff_Vgi_bi=((Vdseff_Vgi_bi*inv_nVt)+((Vdseff+Vs)*inv_nVt_Vgi_bi));
#if defined(_DERIVATE2)
  vdeff_Vgi_bi_Vgm_di=(+(+Vdseff_Vgi_bi_Vgm_di+0.0)*inv_nVt+Vdseff_Vgi_bi*0.0+Vdseff_Vgm_di*inv_nVt_Vgi_bi+(Vdseff+Vs)*0.0);
  vdeff_Vgi_bi_Vgm_si=(+(+Vdseff_Vgi_bi_Vgm_si+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vgm_si+Vdseff_Vgm_si*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vgm_si);
  vdeff_Vgi_bi_Vdbulk_di=(+(+Vdseff_Vgi_bi_Vdbulk_di+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vdbulk_di);
  vdeff_Vgi_bi_Vsbulk_si=(+(+Vdseff_Vgi_bi_Vsbulk_si+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vsbulk_si);
  vdeff_Vgi_bi_Vdi_bi=(+(+Vdseff_Vgi_bi_Vdi_bi+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vdi_bi);
  vdeff_Vgi_bi_Vsi_bi=(+(+Vdseff_Vgi_bi_Vsi_bi+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vsi_bi);
  vdeff_Vgi_bi_Vgi_bi=(+(+Vdseff_Vgi_bi_Vgi_bi+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vgi_bi);
  vdeff_Vgi_bi_Tempt_GND=(+(+Vdseff_Vgi_bi_Tempt_GND+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
vdeff_Tempt_GND=((Vdseff_Tempt_GND*inv_nVt)+((Vdseff+Vs)*inv_nVt_Tempt_GND));
#endif
#endif
vdeff=((Vdseff+Vs)*inv_nVt);
EXIT_IF_ISNAN(((Vdseff+Vs)*inv_nVt))
{
double m00_sqrt(d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=0.0;
  T8_Vdbulk_di_Vgm_si=0.0;
  T8_Vdbulk_di_Vdbulk_di=0.0;
  T8_Vdbulk_di_Vsbulk_si=0.0;
  T8_Vdbulk_di_Vgi_bi=0.0;
  T8_Vdbulk_di_Vdi_bi=0.0;
  T8_Vdbulk_di_Vsi_bi=0.0;
  T8_Vdbulk_di_Tempt_GND=0.0;
#endif
T8_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=0.0;
  T8_Vsbulk_si_Vgm_si=0.0;
  T8_Vsbulk_si_Vdbulk_di=0.0;
  T8_Vsbulk_si_Vsbulk_si=0.0;
  T8_Vsbulk_si_Vgi_bi=0.0;
  T8_Vsbulk_si_Vdi_bi=0.0;
  T8_Vsbulk_si_Vsi_bi=0.0;
  T8_Vsbulk_si_Tempt_GND=0.0;
#endif
T8_Vgi_bi=(0.5*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vdi_bi=(0.5*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsi_bi=(0.5*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(psip_Tempt_GND+((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((psip+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psip+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T8)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T8)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=0.0;
  sqrtpsip_Vgm_di_Vgm_si=0.0;
  sqrtpsip_Vgm_di_Vdbulk_di=0.0;
  sqrtpsip_Vgm_di_Vsbulk_si=0.0;
  sqrtpsip_Vgm_di_Vgi_bi=0.0;
  sqrtpsip_Vgm_di_Vdi_bi=0.0;
  sqrtpsip_Vgm_di_Vsi_bi=0.0;
  sqrtpsip_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=0.0;
  sqrtpsip_Vgm_si_Vgm_si=0.0;
  sqrtpsip_Vgm_si_Vdbulk_di=0.0;
  sqrtpsip_Vgm_si_Vsbulk_si=0.0;
  sqrtpsip_Vgm_si_Vgi_bi=0.0;
  sqrtpsip_Vgm_si_Vdi_bi=0.0;
  sqrtpsip_Vgm_si_Vsi_bi=0.0;
  sqrtpsip_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=0.0;
  sqrtpsip_Vdbulk_di_Vgm_si=0.0;
  sqrtpsip_Vdbulk_di_Vdbulk_di=0.0;
  sqrtpsip_Vdbulk_di_Vsbulk_si=0.0;
  sqrtpsip_Vdbulk_di_Vgi_bi=0.0;
  sqrtpsip_Vdbulk_di_Vdi_bi=0.0;
  sqrtpsip_Vdbulk_di_Vsi_bi=0.0;
  sqrtpsip_Vdbulk_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=0.0;
  sqrtpsip_Vsbulk_si_Vgm_si=0.0;
  sqrtpsip_Vsbulk_si_Vdbulk_di=0.0;
  sqrtpsip_Vsbulk_si_Vsbulk_si=0.0;
  sqrtpsip_Vsbulk_si_Vgi_bi=0.0;
  sqrtpsip_Vsbulk_si_Vdi_bi=0.0;
  sqrtpsip_Vsbulk_si_Vsi_bi=0.0;
  sqrtpsip_Vsbulk_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vgi_bi=T8_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=T8_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=T8_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=T8_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=0.0;
  T9_Vdbulk_di_Vgm_di=0.0;
  T9_Vdbulk_di_Vdbulk_di=0.0;
  T9_Vdbulk_di_Vsbulk_si=0.0;
  T9_Vdbulk_di_Vdi_bi=0.0;
  T9_Vdbulk_di_Vsi_bi=0.0;
  T9_Vdbulk_di_Tempt_GND=0.0;
  T9_Vdbulk_di_Vgi_bi=0.0;
#endif
T9_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=0.0;
  T9_Vsbulk_si_Vgm_di=0.0;
  T9_Vsbulk_si_Vdbulk_di=0.0;
  T9_Vsbulk_si_Vsbulk_si=0.0;
  T9_Vsbulk_si_Vdi_bi=0.0;
  T9_Vsbulk_si_Vsi_bi=0.0;
  T9_Vsbulk_si_Tempt_GND=0.0;
  T9_Vsbulk_si_Vgi_bi=0.0;
#endif
T9_Vdi_bi=((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsi_bi=((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#endif
T9_Vgi_bi=((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#endif
T9=(1.0+(gam/(2.0*sqrtpsip)));
EXIT_IF_ISNAN((1.0+(gam/(2.0*sqrtpsip))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=((((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*0.0/gam/gam/gam);
  T0_Vgi_bi_Vgm_si=((+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vgi_bi_Vdbulk_di=((+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgi_bi_Vsbulk_si=((+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgi_bi_Vgi_bi=((+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vgi_bi_Vdi_bi=((+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vgi_bi_Vsi_bi=((+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vgi_bi_Tempt_GND=((+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vdi_bi=((((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*0.0/gam/gam/gam);
  T0_Vdi_bi_Vgm_si=((+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vdi_bi_Vdbulk_di=((+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdi_bi_Vsbulk_si=((+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdi_bi_Vgi_bi=((+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vdi_bi_Vdi_bi=((+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vdi_bi_Vsi_bi=((+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vdi_bi_Tempt_GND=((+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsi_bi=((((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*0.0/gam/gam/gam);
  T0_Vsi_bi_Vgm_si=((+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vsi_bi_Vdbulk_di=((+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsi_bi_Vsbulk_si=((+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsi_bi_Vgi_bi=((+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vsi_bi_Vdi_bi=((+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vsi_bi_Vsi_bi=((+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vsi_bi_Tempt_GND=((+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Tempt_GND)/gam/gam);
#endif
#endif
T0=((1.0+(gam/(2.0*sqrtpsip)))/gam);
EXIT_IF_ISNAN(((1.0+(gam/(2.0*sqrtpsip)))/gam))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=((psip_Vgi_bi-(2.0*phib_n_Vgi_bi))-vdeff_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+psip_Vgi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vgi_bi+2.0*0.0))-vdeff_Vgi_bi_Vgm_di);
  T1_Vgi_bi_Vgm_si=(+(+psip_Vgi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vgm_si))-vdeff_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+(+psip_Vgi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vdbulk_di))-vdeff_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+(+psip_Vgi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vsbulk_si))-vdeff_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+(+psip_Vgi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vgi_bi))-vdeff_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+(+psip_Vgi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vdi_bi))-vdeff_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+(+psip_Vgi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vsi_bi))-vdeff_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+(+psip_Vgi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Tempt_GND))-vdeff_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=((psip_Vdi_bi-(2.0*phib_n_Vdi_bi))-vdeff_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+psip_Vdi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vdi_bi+2.0*0.0))-vdeff_Vdi_bi_Vgm_di);
  T1_Vdi_bi_Vgm_si=(+(+psip_Vdi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vgm_si))-vdeff_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+(+psip_Vdi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vdbulk_di))-vdeff_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+(+psip_Vdi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vsbulk_si))-vdeff_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+(+psip_Vdi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vgi_bi))-vdeff_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+(+psip_Vdi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vdi_bi))-vdeff_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+(+psip_Vdi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vsi_bi))-vdeff_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+(+psip_Vdi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Tempt_GND))-vdeff_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=((psip_Vsi_bi-(2.0*phib_n_Vsi_bi))-vdeff_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+psip_Vsi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vsi_bi+2.0*0.0))-vdeff_Vsi_bi_Vgm_di);
  T1_Vsi_bi_Vgm_si=(+(+psip_Vsi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vgm_si))-vdeff_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+(+psip_Vsi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vdbulk_di))-vdeff_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+(+psip_Vsi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vsbulk_si))-vdeff_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+(+psip_Vsi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vgi_bi))-vdeff_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+(+psip_Vsi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vdi_bi))-vdeff_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+(+psip_Vsi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vsi_bi))-vdeff_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+(+psip_Vsi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Tempt_GND))-vdeff_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((psip_Tempt_GND-(2.0*phib_n_Tempt_GND))-vdeff_Tempt_GND);
#endif
#endif
T1=((psip-(2.0*phib_n))-vdeff);
EXIT_IF_ISNAN(((psip-(2.0*phib_n))-vdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(T1_Vgi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgi_bi))));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_di));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_si));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdbulk_di));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsbulk_si));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(T1_Vdi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdi_bi))));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_di));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_si));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdbulk_di));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsbulk_si));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(T1_Vsi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsi_bi))));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_di));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_si));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdbulk_di));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsbulk_si));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Tempt_GND)*sqrtpsip)+((4.0*T0)*sqrtpsip_Tempt_GND))));
#endif
#endif
T2=(T1-bsimbulk_lln(((4.0*T0)*sqrtpsip)));
EXIT_IF_ISNAN((T1-bsimbulk_lln(((4.0*T0)*sqrtpsip))))
{
double m00_sqrt(d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=0.0;
  T8_Vdbulk_di_Vgm_si=0.0;
  T8_Vdbulk_di_Vdbulk_di=0.0;
  T8_Vdbulk_di_Vsbulk_si=0.0;
  T8_Vdbulk_di_Vgi_bi=0.0;
  T8_Vdbulk_di_Vdi_bi=0.0;
  T8_Vdbulk_di_Vsi_bi=0.0;
  T8_Vdbulk_di_Tempt_GND=0.0;
#endif
T8_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=0.0;
  T8_Vsbulk_si_Vgm_si=0.0;
  T8_Vsbulk_si_Vdbulk_di=0.0;
  T8_Vsbulk_si_Vsbulk_si=0.0;
  T8_Vsbulk_si_Vgi_bi=0.0;
  T8_Vsbulk_si_Vdi_bi=0.0;
  T8_Vsbulk_si_Vsi_bi=0.0;
  T8_Vsbulk_si_Tempt_GND=0.0;
#endif
T8_Vgi_bi=(0.5*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_di+0.0))+0.0))));
  T8_Vgi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_si+0.0))+0.0))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*(T2+0.402982)+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*(T2+0.402982)+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*(T2+0.402982)+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*(+T2_Vgi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vdi_bi=(0.5*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_di+0.0))+0.0))));
  T8_Vdi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_si+0.0))+0.0))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*(T2+0.402982)+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*(T2+0.402982)+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*(T2+0.402982)+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*(+T2_Vdi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsi_bi=(0.5*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_di+0.0))+0.0))));
  T8_Vsi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_si+0.0))+0.0))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*(T2+0.402982)+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*(T2+0.402982)+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*(T2+0.402982)+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*(+T2_Vsi_bi_Tempt_GND+0.0))+0.0))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(T2_Tempt_GND-((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((T2-0.201491)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T2-0.201491)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
sqrtpsisa_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_di_Vgm_di=0.0;
  sqrtpsisa_Vgm_di_Vgm_si=0.0;
  sqrtpsisa_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_di_Vgi_bi=0.0;
  sqrtpsisa_Vgm_di_Vdi_bi=0.0;
  sqrtpsisa_Vgm_di_Vsi_bi=0.0;
  sqrtpsisa_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisa_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_si_Vgm_di=0.0;
  sqrtpsisa_Vgm_si_Vgm_si=0.0;
  sqrtpsisa_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_si_Vgi_bi=0.0;
  sqrtpsisa_Vgm_si_Vdi_bi=0.0;
  sqrtpsisa_Vgm_si_Vsi_bi=0.0;
  sqrtpsisa_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisa_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdbulk_di_Vgm_di=0.0;
  sqrtpsisa_Vdbulk_di_Vgm_si=0.0;
  sqrtpsisa_Vdbulk_di_Vdbulk_di=0.0;
  sqrtpsisa_Vdbulk_di_Vsbulk_si=0.0;
  sqrtpsisa_Vdbulk_di_Vgi_bi=0.0;
  sqrtpsisa_Vdbulk_di_Vdi_bi=0.0;
  sqrtpsisa_Vdbulk_di_Vsi_bi=0.0;
  sqrtpsisa_Vdbulk_di_Tempt_GND=0.0;
#endif
sqrtpsisa_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsbulk_si_Vgm_di=0.0;
  sqrtpsisa_Vsbulk_si_Vgm_si=0.0;
  sqrtpsisa_Vsbulk_si_Vdbulk_di=0.0;
  sqrtpsisa_Vsbulk_si_Vsbulk_si=0.0;
  sqrtpsisa_Vsbulk_si_Vgi_bi=0.0;
  sqrtpsisa_Vsbulk_si_Vdi_bi=0.0;
  sqrtpsisa_Vsbulk_si_Vsi_bi=0.0;
  sqrtpsisa_Vsbulk_si_Tempt_GND=0.0;
#endif
sqrtpsisa_Vgi_bi=sqrtpsip_Vgi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgi_bi_Vgm_di=sqrtpsip_Vgi_bi_Vgm_di;
  sqrtpsisa_Vgi_bi_Vgm_si=sqrtpsip_Vgi_bi_Vgm_si;
  sqrtpsisa_Vgi_bi_Vdbulk_di=sqrtpsip_Vgi_bi_Vdbulk_di;
  sqrtpsisa_Vgi_bi_Vsbulk_si=sqrtpsip_Vgi_bi_Vsbulk_si;
  sqrtpsisa_Vgi_bi_Vgi_bi=sqrtpsip_Vgi_bi_Vgi_bi;
  sqrtpsisa_Vgi_bi_Vdi_bi=sqrtpsip_Vgi_bi_Vdi_bi;
  sqrtpsisa_Vgi_bi_Vsi_bi=sqrtpsip_Vgi_bi_Vsi_bi;
  sqrtpsisa_Vgi_bi_Tempt_GND=sqrtpsip_Vgi_bi_Tempt_GND;
#endif
sqrtpsisa_Vdi_bi=sqrtpsip_Vdi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdi_bi_Vgm_di=sqrtpsip_Vdi_bi_Vgm_di;
  sqrtpsisa_Vdi_bi_Vgm_si=sqrtpsip_Vdi_bi_Vgm_si;
  sqrtpsisa_Vdi_bi_Vdbulk_di=sqrtpsip_Vdi_bi_Vdbulk_di;
  sqrtpsisa_Vdi_bi_Vsbulk_si=sqrtpsip_Vdi_bi_Vsbulk_si;
  sqrtpsisa_Vdi_bi_Vgi_bi=sqrtpsip_Vdi_bi_Vgi_bi;
  sqrtpsisa_Vdi_bi_Vdi_bi=sqrtpsip_Vdi_bi_Vdi_bi;
  sqrtpsisa_Vdi_bi_Vsi_bi=sqrtpsip_Vdi_bi_Vsi_bi;
  sqrtpsisa_Vdi_bi_Tempt_GND=sqrtpsip_Vdi_bi_Tempt_GND;
#endif
sqrtpsisa_Vsi_bi=sqrtpsip_Vsi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsi_bi_Vgm_di=sqrtpsip_Vsi_bi_Vgm_di;
  sqrtpsisa_Vsi_bi_Vgm_si=sqrtpsip_Vsi_bi_Vgm_si;
  sqrtpsisa_Vsi_bi_Vdbulk_di=sqrtpsip_Vsi_bi_Vdbulk_di;
  sqrtpsisa_Vsi_bi_Vsbulk_si=sqrtpsip_Vsi_bi_Vsbulk_si;
  sqrtpsisa_Vsi_bi_Vgi_bi=sqrtpsip_Vsi_bi_Vgi_bi;
  sqrtpsisa_Vsi_bi_Vdi_bi=sqrtpsip_Vsi_bi_Vdi_bi;
  sqrtpsisa_Vsi_bi_Vsi_bi=sqrtpsip_Vsi_bi_Vsi_bi;
  sqrtpsisa_Vsi_bi_Tempt_GND=sqrtpsip_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
sqrtpsisa_Tempt_GND=sqrtpsip_Tempt_GND;
#endif
#endif
sqrtpsisa=sqrtpsip;
EXIT_IF_ISNAN(sqrtpsip)
if
((T8<=(-68.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=0.0;
#endif
#endif
T4=(-100.0);
EXIT_IF_ISNAN((-100.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=20.0;
EXIT_IF_ISNAN(20.0)
if
((T8<(T4-(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T4,T4_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T4_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T4_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T4_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T4_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T4_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T4_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T4_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T4_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T4,T4_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T4_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T4_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T4_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T4_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T4_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T4_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T4_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T4_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T4,T4_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T4_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T4_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T4_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T4_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T4_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T4_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T4_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T4_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T4,T4_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T4);
EXIT_IF_ISNAN(bsimbulk_lexp(T4))
}
else
{
if
((T8>(T4+(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(((T8_Vgi_bi-T4_Vgi_bi)*T5-(T8-T4)*T5_Vgi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=((+T8_Vgi_bi_Vgm_di-T4_Vgi_bi_Vgm_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vgi_bi_Vgm_si=((+T8_Vgi_bi_Vgm_si-T4_Vgi_bi_Vgm_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vgi_bi_Vdbulk_di=((+T8_Vgi_bi_Vdbulk_di-T4_Vgi_bi_Vdbulk_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgi_bi_Vsbulk_si=((+T8_Vgi_bi_Vsbulk_si-T4_Vgi_bi_Vsbulk_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgi_bi_Vgi_bi=((+T8_Vgi_bi_Vgi_bi-T4_Vgi_bi_Vgi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vgi_bi_Vdi_bi=((+T8_Vgi_bi_Vdi_bi-T4_Vgi_bi_Vdi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vgi_bi_Vsi_bi=((+T8_Vgi_bi_Vsi_bi-T4_Vgi_bi_Vsi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vgi_bi_Tempt_GND=((+T8_Vgi_bi_Tempt_GND-T4_Vgi_bi_Tempt_GND)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vdi_bi=(((T8_Vdi_bi-T4_Vdi_bi)*T5-(T8-T4)*T5_Vdi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=((+T8_Vdi_bi_Vgm_di-T4_Vdi_bi_Vgm_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vdi_bi_Vgm_si=((+T8_Vdi_bi_Vgm_si-T4_Vdi_bi_Vgm_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vdi_bi_Vdbulk_di=((+T8_Vdi_bi_Vdbulk_di-T4_Vdi_bi_Vdbulk_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdi_bi_Vsbulk_si=((+T8_Vdi_bi_Vsbulk_si-T4_Vdi_bi_Vsbulk_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdi_bi_Vgi_bi=((+T8_Vdi_bi_Vgi_bi-T4_Vdi_bi_Vgi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vdi_bi_Vdi_bi=((+T8_Vdi_bi_Vdi_bi-T4_Vdi_bi_Vdi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vdi_bi_Vsi_bi=((+T8_Vdi_bi_Vsi_bi-T4_Vdi_bi_Vsi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vdi_bi_Tempt_GND=((+T8_Vdi_bi_Tempt_GND-T4_Vdi_bi_Tempt_GND)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsi_bi=(((T8_Vsi_bi-T4_Vsi_bi)*T5-(T8-T4)*T5_Vsi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=((+T8_Vsi_bi_Vgm_di-T4_Vsi_bi_Vgm_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vsi_bi_Vgm_si=((+T8_Vsi_bi_Vgm_si-T4_Vsi_bi_Vgm_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vsi_bi_Vdbulk_di=((+T8_Vsi_bi_Vdbulk_di-T4_Vsi_bi_Vdbulk_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsi_bi_Vsbulk_si=((+T8_Vsi_bi_Vsbulk_si-T4_Vsi_bi_Vsbulk_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsi_bi_Vgi_bi=((+T8_Vsi_bi_Vgi_bi-T4_Vsi_bi_Vgi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vsi_bi_Vdi_bi=((+T8_Vsi_bi_Vdi_bi-T4_Vsi_bi_Vdi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vsi_bi_Vsi_bi=((+T8_Vsi_bi_Vsi_bi-T4_Vsi_bi_Vsi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vsi_bi_Tempt_GND=((+T8_Vsi_bi_Tempt_GND-T4_Vsi_bi_Tempt_GND)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((T8_Tempt_GND-T4_Tempt_GND)*T5-(T8-T4)*T5_Tempt_GND)/T5/T5);
#endif
#endif
T2=((T8-T4)/T5);
EXIT_IF_ISNAN(((T8-T4)/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND));
#endif
#endif
T6=(T2*T2);
EXIT_IF_ISNAN((T2*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgi_bi+((T5_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T4_Vgi_bi_Vgm_si+(+T5_Vgi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_si))+(+T6_Vgi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_si)))))));
  T3_Vgi_bi_Vgm_di=(+T4_Vgi_bi_Vgm_di+(+T5_Vgi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_di))+(+T6_Vgi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_di)))))));
  T3_Vgi_bi_Vdbulk_di=(+T4_Vgi_bi_Vdbulk_di+(+T5_Vgi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdbulk_di))+(+T6_Vgi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdbulk_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdbulk_di)))))));
  T3_Vgi_bi_Vsbulk_si=(+T4_Vgi_bi_Vsbulk_si+(+T5_Vgi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsbulk_si))+(+T6_Vgi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsbulk_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsbulk_si)))))));
  T3_Vgi_bi_Vgi_bi=(+T4_Vgi_bi_Vgi_bi+(+T5_Vgi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgi_bi))+(+T6_Vgi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgi_bi)))))));
  T3_Vgi_bi_Vdi_bi=(+T4_Vgi_bi_Vdi_bi+(+T5_Vgi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdi_bi))+(+T6_Vgi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdi_bi)))))));
  T3_Vgi_bi_Vsi_bi=(+T4_Vgi_bi_Vsi_bi+(+T5_Vgi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsi_bi))+(+T6_Vgi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsi_bi)))))));
  T3_Vgi_bi_Tempt_GND=(+T4_Vgi_bi_Tempt_GND+(+T5_Vgi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Tempt_GND))+(+T6_Vgi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Tempt_GND*(1.25-T6)+T6_Vgi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Tempt_GND)))))));
#endif
T3_Vdi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdi_bi+((T5_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T4_Vdi_bi_Vgm_si+(+T5_Vdi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_si))+(+T6_Vdi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_si)))))));
  T3_Vdi_bi_Vgm_di=(+T4_Vdi_bi_Vgm_di+(+T5_Vdi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_di))+(+T6_Vdi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_di)))))));
  T3_Vdi_bi_Vdbulk_di=(+T4_Vdi_bi_Vdbulk_di+(+T5_Vdi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdbulk_di))+(+T6_Vdi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdbulk_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdbulk_di)))))));
  T3_Vdi_bi_Vsbulk_si=(+T4_Vdi_bi_Vsbulk_si+(+T5_Vdi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsbulk_si))+(+T6_Vdi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsbulk_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsbulk_si)))))));
  T3_Vdi_bi_Vgi_bi=(+T4_Vdi_bi_Vgi_bi+(+T5_Vdi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgi_bi))+(+T6_Vdi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgi_bi)))))));
  T3_Vdi_bi_Vdi_bi=(+T4_Vdi_bi_Vdi_bi+(+T5_Vdi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdi_bi))+(+T6_Vdi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdi_bi)))))));
  T3_Vdi_bi_Vsi_bi=(+T4_Vdi_bi_Vsi_bi+(+T5_Vdi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsi_bi))+(+T6_Vdi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsi_bi)))))));
  T3_Vdi_bi_Tempt_GND=(+T4_Vdi_bi_Tempt_GND+(+T5_Vdi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Tempt_GND))+(+T6_Vdi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Tempt_GND*(1.25-T6)+T6_Vdi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Tempt_GND)))))));
#endif
T3_Vsi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsi_bi+((T5_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T4_Vsi_bi_Vgm_si+(+T5_Vsi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_si))+(+T6_Vsi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_si)))))));
  T3_Vsi_bi_Vgm_di=(+T4_Vsi_bi_Vgm_di+(+T5_Vsi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_di))+(+T6_Vsi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_di)))))));
  T3_Vsi_bi_Vdbulk_di=(+T4_Vsi_bi_Vdbulk_di+(+T5_Vsi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdbulk_di))+(+T6_Vsi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdbulk_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdbulk_di)))))));
  T3_Vsi_bi_Vsbulk_si=(+T4_Vsi_bi_Vsbulk_si+(+T5_Vsi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsbulk_si))+(+T6_Vsi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsbulk_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsbulk_si)))))));
  T3_Vsi_bi_Vgi_bi=(+T4_Vsi_bi_Vgi_bi+(+T5_Vsi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgi_bi))+(+T6_Vsi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgi_bi)))))));
  T3_Vsi_bi_Vdi_bi=(+T4_Vsi_bi_Vdi_bi+(+T5_Vsi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdi_bi))+(+T6_Vsi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdi_bi)))))));
  T3_Vsi_bi_Vsi_bi=(+T4_Vsi_bi_Vsi_bi+(+T5_Vsi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsi_bi))+(+T6_Vsi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsi_bi)))))));
  T3_Vsi_bi_Tempt_GND=(+T4_Vsi_bi_Tempt_GND+(+T5_Vsi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Tempt_GND))+(+T6_Vsi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Tempt_GND*(1.25-T6)+T6_Vsi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Tempt_GND)))))));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Tempt_GND+((T5_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Tempt_GND)+((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))));
#endif
#endif
T3=bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
EXIT_IF_ISNAN(bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qdeff_Vgm_si=0.0;
#if defined(_DERIVATE2)
  qdeff_Vgm_si_Vgm_si=0.0;
  qdeff_Vgm_si_Vgm_di=0.0;
  qdeff_Vgm_si_Vdbulk_di=0.0;
  qdeff_Vgm_si_Vsbulk_si=0.0;
  qdeff_Vgm_si_Vgi_bi=0.0;
  qdeff_Vgm_si_Vdi_bi=0.0;
  qdeff_Vgm_si_Vsi_bi=0.0;
  qdeff_Vgm_si_Tempt_GND=0.0;
#endif
qdeff_Vgm_di=0.0;
#if defined(_DERIVATE2)
  qdeff_Vgm_di_Vgm_si=0.0;
  qdeff_Vgm_di_Vgm_di=0.0;
  qdeff_Vgm_di_Vdbulk_di=0.0;
  qdeff_Vgm_di_Vsbulk_si=0.0;
  qdeff_Vgm_di_Vgi_bi=0.0;
  qdeff_Vgm_di_Vdi_bi=0.0;
  qdeff_Vgm_di_Vsi_bi=0.0;
  qdeff_Vgm_di_Tempt_GND=0.0;
#endif
qdeff_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  qdeff_Vdbulk_di_Vgm_si=0.0;
  qdeff_Vdbulk_di_Vgm_di=0.0;
  qdeff_Vdbulk_di_Vdbulk_di=0.0;
  qdeff_Vdbulk_di_Vsbulk_si=0.0;
  qdeff_Vdbulk_di_Vgi_bi=0.0;
  qdeff_Vdbulk_di_Vdi_bi=0.0;
  qdeff_Vdbulk_di_Vsi_bi=0.0;
  qdeff_Vdbulk_di_Tempt_GND=0.0;
#endif
qdeff_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  qdeff_Vsbulk_si_Vgm_si=0.0;
  qdeff_Vsbulk_si_Vgm_di=0.0;
  qdeff_Vsbulk_si_Vdbulk_di=0.0;
  qdeff_Vsbulk_si_Vsbulk_si=0.0;
  qdeff_Vsbulk_si_Vgi_bi=0.0;
  qdeff_Vsbulk_si_Vdi_bi=0.0;
  qdeff_Vsbulk_si_Vsi_bi=0.0;
  qdeff_Vsbulk_si_Tempt_GND=0.0;
#endif
qdeff_Vgi_bi=((T3_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))));
#if defined(_DERIVATE2)
  qdeff_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_si)-T8_Vgi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si)))));
  qdeff_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_di)-T8_Vgi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di)))));
  qdeff_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdbulk_di)-T8_Vgi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di)))));
  qdeff_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsbulk_si)-T8_Vgi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si)))));
  qdeff_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgi_bi)-T8_Vgi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi)))));
  qdeff_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdi_bi)-T8_Vgi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi)))));
  qdeff_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsi_bi)-T8_Vgi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi)))));
  qdeff_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Tempt_GND*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Tempt_GND)-T8_Vgi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND)))));
#endif
qdeff_Vdi_bi=((T3_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))));
#if defined(_DERIVATE2)
  qdeff_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_si)-T8_Vdi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si)))));
  qdeff_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_di)-T8_Vdi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di)))));
  qdeff_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdbulk_di)-T8_Vdi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di)))));
  qdeff_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsbulk_si)-T8_Vdi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si)))));
  qdeff_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgi_bi)-T8_Vdi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi)))));
  qdeff_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdi_bi)-T8_Vdi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi)))));
  qdeff_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsi_bi)-T8_Vdi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi)))));
  qdeff_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Tempt_GND*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Tempt_GND)-T8_Vdi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND)))));
#endif
qdeff_Vsi_bi=((T3_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))));
#if defined(_DERIVATE2)
  qdeff_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_si)-T8_Vsi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si)))));
  qdeff_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_di)-T8_Vsi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di)))));
  qdeff_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdbulk_di)-T8_Vsi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di)))));
  qdeff_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsbulk_si)-T8_Vsi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si)))));
  qdeff_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgi_bi)-T8_Vsi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi)))));
  qdeff_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdi_bi)-T8_Vsi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi)))));
  qdeff_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsi_bi)-T8_Vsi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi)))));
  qdeff_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Tempt_GND*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Tempt_GND)-T8_Vsi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND)))));
#endif
#if defined(_DERIVATE)
qdeff_Tempt_GND=((T3_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))));
#endif
#endif
qdeff=(T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
EXIT_IF_ISNAN((T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsisainv_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_di_Vgm_di=0.0;
  sqrtpsisainv_Vgm_di_Vgm_si=0.0;
  sqrtpsisainv_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_di_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_si_Vgm_di=0.0;
  sqrtpsisainv_Vgm_si_Vgm_si=0.0;
  sqrtpsisainv_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_si_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdbulk_di_Vgm_di=0.0;
  sqrtpsisainv_Vdbulk_di_Vgm_si=0.0;
  sqrtpsisainv_Vdbulk_di_Vdbulk_di=0.0;
  sqrtpsisainv_Vdbulk_di_Vsbulk_si=0.0;
  sqrtpsisainv_Vdbulk_di_Vgi_bi=0.0;
  sqrtpsisainv_Vdbulk_di_Vdi_bi=0.0;
  sqrtpsisainv_Vdbulk_di_Vsi_bi=0.0;
  sqrtpsisainv_Vdbulk_di_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsbulk_si_Vgm_di=0.0;
  sqrtpsisainv_Vsbulk_si_Vgm_si=0.0;
  sqrtpsisainv_Vsbulk_si_Vdbulk_di=0.0;
  sqrtpsisainv_Vsbulk_si_Vsbulk_si=0.0;
  sqrtpsisainv_Vsbulk_si_Vgi_bi=0.0;
  sqrtpsisainv_Vsbulk_si_Vdi_bi=0.0;
  sqrtpsisainv_Vsbulk_si_Vsi_bi=0.0;
  sqrtpsisainv_Vsbulk_si_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vgi_bi=(-sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vdi_bi=(-sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsi_bi=(-sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
#if defined(_DERIVATE)
sqrtpsisainv_Tempt_GND=(-sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa);
#endif
#endif
sqrtpsisainv=(1.0/sqrtpsisa);
EXIT_IF_ISNAN((1.0/sqrtpsisa))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T3_Vgi_bi-((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vdi_bi=(T3_Vdi_bi-((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsi_bi=(T3_Vsi_bi-((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T3_Tempt_GND-((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5));
#endif
#endif
T3=(T3-(T4/T5));
EXIT_IF_ISNAN((T3-(T4/T5)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=(((((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vdi_bi=(((((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsi_bi=(((((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#endif
#endif
T6=(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN((((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=0.0;
  T7_Vdbulk_di_Vgm_di=0.0;
  T7_Vdbulk_di_Vdbulk_di=0.0;
  T7_Vdbulk_di_Vsbulk_si=0.0;
  T7_Vdbulk_di_Vgi_bi=0.0;
  T7_Vdbulk_di_Vdi_bi=0.0;
  T7_Vdbulk_di_Vsi_bi=0.0;
  T7_Vdbulk_di_Tempt_GND=0.0;
#endif
T7_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=0.0;
  T7_Vsbulk_si_Vgm_di=0.0;
  T7_Vsbulk_si_Vdbulk_di=0.0;
  T7_Vsbulk_si_Vsbulk_si=0.0;
  T7_Vsbulk_si_Vgi_bi=0.0;
  T7_Vsbulk_si_Vdi_bi=0.0;
  T7_Vsbulk_si_Vsi_bi=0.0;
  T7_Vsbulk_si_Tempt_GND=0.0;
#endif
T7_Vgi_bi=(((-(((-T3_Vgi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgi_bi/T3/T3))))-(-((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi);
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_si);
  T7_Vgi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_di);
  T7_Vgi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdbulk_di);
  T7_Vgi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsbulk_si);
  T7_Vgi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgi_bi);
  T7_Vgi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdi_bi);
  T7_Vgi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsi_bi);
  T7_Vgi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Tempt_GND);
#endif
T7_Vdi_bi=(((-(((-T3_Vdi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdi_bi/T3/T3))))-(-((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi);
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_si);
  T7_Vdi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_di);
  T7_Vdi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdbulk_di);
  T7_Vdi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsbulk_si);
  T7_Vdi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgi_bi);
  T7_Vdi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdi_bi);
  T7_Vdi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsi_bi);
  T7_Vdi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Tempt_GND);
#endif
T7_Vsi_bi=(((-(((-T3_Vsi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsi_bi/T3/T3))))-(-((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi);
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_si);
  T7_Vsi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_di);
  T7_Vsi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdbulk_di);
  T7_Vsi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsbulk_si);
  T7_Vsi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgi_bi);
  T7_Vsi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdi_bi);
  T7_Vsi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsi_bi);
  T7_Vsi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(((-(((-T3_Tempt_GND/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Tempt_GND/T3/T3))))-(-((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Tempt_GND);
#endif
#endif
T7=(((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
EXIT_IF_ISNAN((((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qdeff_Vgm_si=0.0;
#if defined(_DERIVATE2)
  qdeff_Vgm_si_Vgm_si=0.0;
  qdeff_Vgm_si_Vgm_di=0.0;
  qdeff_Vgm_si_Vdbulk_di=0.0;
  qdeff_Vgm_si_Vsbulk_si=0.0;
  qdeff_Vgm_si_Vgi_bi=0.0;
  qdeff_Vgm_si_Vdi_bi=0.0;
  qdeff_Vgm_si_Vsi_bi=0.0;
  qdeff_Vgm_si_Tempt_GND=0.0;
#endif
qdeff_Vgm_di=0.0;
#if defined(_DERIVATE2)
  qdeff_Vgm_di_Vgm_si=0.0;
  qdeff_Vgm_di_Vgm_di=0.0;
  qdeff_Vgm_di_Vdbulk_di=0.0;
  qdeff_Vgm_di_Vsbulk_si=0.0;
  qdeff_Vgm_di_Vgi_bi=0.0;
  qdeff_Vgm_di_Vdi_bi=0.0;
  qdeff_Vgm_di_Vsi_bi=0.0;
  qdeff_Vgm_di_Tempt_GND=0.0;
#endif
qdeff_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  qdeff_Vdbulk_di_Vgm_si=0.0;
  qdeff_Vdbulk_di_Vgm_di=0.0;
  qdeff_Vdbulk_di_Vdbulk_di=0.0;
  qdeff_Vdbulk_di_Vsbulk_si=0.0;
  qdeff_Vdbulk_di_Vgi_bi=0.0;
  qdeff_Vdbulk_di_Vdi_bi=0.0;
  qdeff_Vdbulk_di_Vsi_bi=0.0;
  qdeff_Vdbulk_di_Tempt_GND=0.0;
#endif
qdeff_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  qdeff_Vsbulk_si_Vgm_si=0.0;
  qdeff_Vsbulk_si_Vgm_di=0.0;
  qdeff_Vsbulk_si_Vdbulk_di=0.0;
  qdeff_Vsbulk_si_Vsbulk_si=0.0;
  qdeff_Vsbulk_si_Vgi_bi=0.0;
  qdeff_Vsbulk_si_Vdi_bi=0.0;
  qdeff_Vsbulk_si_Vsi_bi=0.0;
  qdeff_Vsbulk_si_Tempt_GND=0.0;
#endif
qdeff_Vgi_bi=(T3_Vgi_bi-((((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(+(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_si*T7+T4_Vgi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_si)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(+(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_di*T7+T4_Vgi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_di)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(+(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdbulk_di*T7+T4_Vgi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdbulk_di)*T5+(2.0*T5_Vgi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(+(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsbulk_si*T7+T4_Vgi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsbulk_si)*T5+(2.0*T5_Vgi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(+(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgi_bi*T7+T4_Vgi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(+(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdi_bi*T7+T4_Vgi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(+(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsi_bi*T7+T4_Vgi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(+(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Tempt_GND*T7+T4_Vgi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vgi_bi+T4*T7_Vgi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Tempt_GND)*T5+(2.0*T5_Vgi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vdi_bi=(T3_Vdi_bi-((((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(+(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_si*T7+T4_Vdi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_si)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(+(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_di*T7+T4_Vdi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_di)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(+(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdbulk_di*T7+T4_Vdi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdbulk_di)*T5+(2.0*T5_Vdi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(+(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsbulk_si*T7+T4_Vdi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsbulk_si)*T5+(2.0*T5_Vdi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(+(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgi_bi*T7+T4_Vdi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(+(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdi_bi*T7+T4_Vdi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(+(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsi_bi*T7+T4_Vdi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(+(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Tempt_GND*T7+T4_Vdi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vdi_bi+T4*T7_Vdi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Tempt_GND)*T5+(2.0*T5_Vdi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vsi_bi=(T3_Vsi_bi-((((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(+(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_si*T7+T4_Vsi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_si)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(+(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_di*T7+T4_Vsi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_di)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(+(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdbulk_di*T7+T4_Vsi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdbulk_di)*T5+(2.0*T5_Vsi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(+(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsbulk_si*T7+T4_Vsi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsbulk_si)*T5+(2.0*T5_Vsi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(+(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgi_bi*T7+T4_Vsi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(+(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdi_bi*T7+T4_Vsi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(+(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsi_bi*T7+T4_Vsi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(+(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Tempt_GND*T7+T4_Vsi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vsi_bi+T4*T7_Vsi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Tempt_GND)*T5+(2.0*T5_Vsi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#if defined(_DERIVATE)
qdeff_Tempt_GND=(T3_Tempt_GND-((((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Tempt_GND)*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#endif
qdeff=(T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
EXIT_IF_ISNAN((T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
psiavg_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psiavg_Vgm_di_Vgm_di=0.0;
  psiavg_Vgm_di_Vgm_si=0.0;
  psiavg_Vgm_di_Vdbulk_di=0.0;
  psiavg_Vgm_di_Vsbulk_si=0.0;
  psiavg_Vgm_di_Vgi_bi=0.0;
  psiavg_Vgm_di_Vdi_bi=0.0;
  psiavg_Vgm_di_Vsi_bi=0.0;
  psiavg_Vgm_di_Tempt_GND=0.0;
#endif
psiavg_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psiavg_Vgm_si_Vgm_di=0.0;
  psiavg_Vgm_si_Vgm_si=0.0;
  psiavg_Vgm_si_Vdbulk_di=0.0;
  psiavg_Vgm_si_Vsbulk_si=0.0;
  psiavg_Vgm_si_Vgi_bi=0.0;
  psiavg_Vgm_si_Vdi_bi=0.0;
  psiavg_Vgm_si_Vsi_bi=0.0;
  psiavg_Vgm_si_Tempt_GND=0.0;
#endif
psiavg_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  psiavg_Vdbulk_di_Vgm_di=0.0;
  psiavg_Vdbulk_di_Vgm_si=0.0;
  psiavg_Vdbulk_di_Vdbulk_di=0.0;
  psiavg_Vdbulk_di_Vsbulk_si=0.0;
  psiavg_Vdbulk_di_Vgi_bi=0.0;
  psiavg_Vdbulk_di_Vdi_bi=0.0;
  psiavg_Vdbulk_di_Vsi_bi=0.0;
  psiavg_Vdbulk_di_Tempt_GND=0.0;
#endif
psiavg_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  psiavg_Vsbulk_si_Vgm_di=0.0;
  psiavg_Vsbulk_si_Vgm_si=0.0;
  psiavg_Vsbulk_si_Vdbulk_di=0.0;
  psiavg_Vsbulk_si_Vsbulk_si=0.0;
  psiavg_Vsbulk_si_Vgi_bi=0.0;
  psiavg_Vsbulk_si_Vdi_bi=0.0;
  psiavg_Vsbulk_si_Vsi_bi=0.0;
  psiavg_Vsbulk_si_Tempt_GND=0.0;
#endif
psiavg_Vgi_bi=((psip_Vgi_bi-qs_Vgi_bi)-qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  psiavg_Vgi_bi_Vgm_di=(+(+(+psip_Vgi_bi_Vgm_di-qs_Vgi_bi_Vgm_di)-qdeff_Vgi_bi_Vgm_di)-0.0);
  psiavg_Vgi_bi_Vgm_si=(+(+(+psip_Vgi_bi_Vgm_si-qs_Vgi_bi_Vgm_si)-qdeff_Vgi_bi_Vgm_si)-0.0);
  psiavg_Vgi_bi_Vdbulk_di=(+(+(+psip_Vgi_bi_Vdbulk_di-qs_Vgi_bi_Vdbulk_di)-qdeff_Vgi_bi_Vdbulk_di)-0.0);
  psiavg_Vgi_bi_Vsbulk_si=(+(+(+psip_Vgi_bi_Vsbulk_si-qs_Vgi_bi_Vsbulk_si)-qdeff_Vgi_bi_Vsbulk_si)-0.0);
  psiavg_Vgi_bi_Vgi_bi=(+(+(+psip_Vgi_bi_Vgi_bi-qs_Vgi_bi_Vgi_bi)-qdeff_Vgi_bi_Vgi_bi)-0.0);
  psiavg_Vgi_bi_Vdi_bi=(+(+(+psip_Vgi_bi_Vdi_bi-qs_Vgi_bi_Vdi_bi)-qdeff_Vgi_bi_Vdi_bi)-0.0);
  psiavg_Vgi_bi_Vsi_bi=(+(+(+psip_Vgi_bi_Vsi_bi-qs_Vgi_bi_Vsi_bi)-qdeff_Vgi_bi_Vsi_bi)-0.0);
  psiavg_Vgi_bi_Tempt_GND=(+(+(+psip_Vgi_bi_Tempt_GND-qs_Vgi_bi_Tempt_GND)-qdeff_Vgi_bi_Tempt_GND)-0.0);
#endif
psiavg_Vdi_bi=((psip_Vdi_bi-qs_Vdi_bi)-qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  psiavg_Vdi_bi_Vgm_di=(+(+(+psip_Vdi_bi_Vgm_di-qs_Vdi_bi_Vgm_di)-qdeff_Vdi_bi_Vgm_di)-0.0);
  psiavg_Vdi_bi_Vgm_si=(+(+(+psip_Vdi_bi_Vgm_si-qs_Vdi_bi_Vgm_si)-qdeff_Vdi_bi_Vgm_si)-0.0);
  psiavg_Vdi_bi_Vdbulk_di=(+(+(+psip_Vdi_bi_Vdbulk_di-qs_Vdi_bi_Vdbulk_di)-qdeff_Vdi_bi_Vdbulk_di)-0.0);
  psiavg_Vdi_bi_Vsbulk_si=(+(+(+psip_Vdi_bi_Vsbulk_si-qs_Vdi_bi_Vsbulk_si)-qdeff_Vdi_bi_Vsbulk_si)-0.0);
  psiavg_Vdi_bi_Vgi_bi=(+(+(+psip_Vdi_bi_Vgi_bi-qs_Vdi_bi_Vgi_bi)-qdeff_Vdi_bi_Vgi_bi)-0.0);
  psiavg_Vdi_bi_Vdi_bi=(+(+(+psip_Vdi_bi_Vdi_bi-qs_Vdi_bi_Vdi_bi)-qdeff_Vdi_bi_Vdi_bi)-0.0);
  psiavg_Vdi_bi_Vsi_bi=(+(+(+psip_Vdi_bi_Vsi_bi-qs_Vdi_bi_Vsi_bi)-qdeff_Vdi_bi_Vsi_bi)-0.0);
  psiavg_Vdi_bi_Tempt_GND=(+(+(+psip_Vdi_bi_Tempt_GND-qs_Vdi_bi_Tempt_GND)-qdeff_Vdi_bi_Tempt_GND)-0.0);
#endif
psiavg_Vsi_bi=((psip_Vsi_bi-qs_Vsi_bi)-qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  psiavg_Vsi_bi_Vgm_di=(+(+(+psip_Vsi_bi_Vgm_di-qs_Vsi_bi_Vgm_di)-qdeff_Vsi_bi_Vgm_di)-0.0);
  psiavg_Vsi_bi_Vgm_si=(+(+(+psip_Vsi_bi_Vgm_si-qs_Vsi_bi_Vgm_si)-qdeff_Vsi_bi_Vgm_si)-0.0);
  psiavg_Vsi_bi_Vdbulk_di=(+(+(+psip_Vsi_bi_Vdbulk_di-qs_Vsi_bi_Vdbulk_di)-qdeff_Vsi_bi_Vdbulk_di)-0.0);
  psiavg_Vsi_bi_Vsbulk_si=(+(+(+psip_Vsi_bi_Vsbulk_si-qs_Vsi_bi_Vsbulk_si)-qdeff_Vsi_bi_Vsbulk_si)-0.0);
  psiavg_Vsi_bi_Vgi_bi=(+(+(+psip_Vsi_bi_Vgi_bi-qs_Vsi_bi_Vgi_bi)-qdeff_Vsi_bi_Vgi_bi)-0.0);
  psiavg_Vsi_bi_Vdi_bi=(+(+(+psip_Vsi_bi_Vdi_bi-qs_Vsi_bi_Vdi_bi)-qdeff_Vsi_bi_Vdi_bi)-0.0);
  psiavg_Vsi_bi_Vsi_bi=(+(+(+psip_Vsi_bi_Vsi_bi-qs_Vsi_bi_Vsi_bi)-qdeff_Vsi_bi_Vsi_bi)-0.0);
  psiavg_Vsi_bi_Tempt_GND=(+(+(+psip_Vsi_bi_Tempt_GND-qs_Vsi_bi_Tempt_GND)-qdeff_Vsi_bi_Tempt_GND)-0.0);
#endif
#if defined(_DERIVATE)
psiavg_Tempt_GND=((psip_Tempt_GND-qs_Tempt_GND)-qdeff_Tempt_GND);
#endif
#endif
psiavg=(((psip-qs)-qdeff)-1.0);
EXIT_IF_ISNAN((((psip-qs)-qdeff)-1.0))
{
double m00_sqrt(d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(0.5*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vdi_bi=(0.5*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vsi_bi=(0.5*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(0.5*(psiavg_Tempt_GND+((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND))*d10_sqrt0));
#endif
#endif
T0=(0.5*((psiavg+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psiavg+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T0)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=T0_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=T0_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=T0_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=T0_Tempt_GND*d10_sqrt0;
#endif
#endif
T2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
nq_Vgm_si=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_si_Vgm_si=0.0;
  nq_Vgm_si_Vgm_di=0.0;
  nq_Vgm_si_Vdbulk_di=0.0;
  nq_Vgm_si_Vsbulk_si=0.0;
  nq_Vgm_si_Vgi_bi=0.0;
  nq_Vgm_si_Tempt_GND=0.0;
  nq_Vgm_si_Vdi_bi=0.0;
  nq_Vgm_si_Vsi_bi=0.0;
#endif
nq_Vgm_di=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_di_Vgm_si=0.0;
  nq_Vgm_di_Vgm_di=0.0;
  nq_Vgm_di_Vdbulk_di=0.0;
  nq_Vgm_di_Vsbulk_si=0.0;
  nq_Vgm_di_Vgi_bi=0.0;
  nq_Vgm_di_Tempt_GND=0.0;
  nq_Vgm_di_Vdi_bi=0.0;
  nq_Vgm_di_Vsi_bi=0.0;
#endif
nq_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  nq_Vdbulk_di_Vgm_si=0.0;
  nq_Vdbulk_di_Vgm_di=0.0;
  nq_Vdbulk_di_Vdbulk_di=0.0;
  nq_Vdbulk_di_Vsbulk_si=0.0;
  nq_Vdbulk_di_Vgi_bi=0.0;
  nq_Vdbulk_di_Tempt_GND=0.0;
  nq_Vdbulk_di_Vdi_bi=0.0;
  nq_Vdbulk_di_Vsi_bi=0.0;
#endif
nq_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  nq_Vsbulk_si_Vgm_si=0.0;
  nq_Vsbulk_si_Vgm_di=0.0;
  nq_Vsbulk_si_Vdbulk_di=0.0;
  nq_Vsbulk_si_Vsbulk_si=0.0;
  nq_Vsbulk_si_Vgi_bi=0.0;
  nq_Vsbulk_si_Tempt_GND=0.0;
  nq_Vsbulk_si_Vdi_bi=0.0;
  nq_Vsbulk_si_Vsi_bi=0.0;
#endif
nq_Vgi_bi=((gam_Vgi_bi*(sqrtpsip+T2)-gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vgm_si+T2_Vgi_bi_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vgm_di+T2_Vgi_bi_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vdbulk_di+T2_Vgi_bi_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vsbulk_si+T2_Vgi_bi_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vgi_bi+T2_Vgi_bi_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Tempt_GND+T2_Vgi_bi_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vdi_bi+T2_Vgi_bi_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vsi_bi+T2_Vgi_bi_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
#if defined(_DERIVATE)
nq_Tempt_GND=((gam_Tempt_GND*(sqrtpsip+T2)-gam*(sqrtpsip_Tempt_GND+T2_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2));
#endif
nq_Vdi_bi=((gam_Vdi_bi*(sqrtpsip+T2)-gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vgm_si+T2_Vdi_bi_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vgm_di+T2_Vdi_bi_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vdbulk_di+T2_Vdi_bi_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vsbulk_si+T2_Vdi_bi_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vgi_bi+T2_Vdi_bi_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Tempt_GND+T2_Vdi_bi_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vdi_bi+T2_Vdi_bi_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vsi_bi+T2_Vdi_bi_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
nq_Vsi_bi=((gam_Vsi_bi*(sqrtpsip+T2)-gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vgm_si+T2_Vsi_bi_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vgm_di+T2_Vsi_bi_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vdbulk_di+T2_Vsi_bi_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vsbulk_si+T2_Vsi_bi_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vgi_bi+T2_Vsi_bi_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Tempt_GND+T2_Vsi_bi_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vdi_bi+T2_Vsi_bi_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vsi_bi+T2_Vsi_bi_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
#endif
nq=(1.0+(gam/(sqrtpsip+T2)));
EXIT_IF_ISNAN((1.0+(gam/(sqrtpsip+T2))))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
DQSD2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  DQSD2_Vdbulk_di_Vdbulk_di=0.0;
  DQSD2_Vdbulk_di_Vsbulk_si=0.0;
  DQSD2_Vdbulk_di_Vgi_bi=0.0;
  DQSD2_Vdbulk_di_Vdi_bi=0.0;
  DQSD2_Vdbulk_di_Vsi_bi=0.0;
  DQSD2_Vdbulk_di_Tempt_GND=0.0;
#endif
DQSD2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  DQSD2_Vsbulk_si_Vdbulk_di=0.0;
  DQSD2_Vsbulk_si_Vsbulk_si=0.0;
  DQSD2_Vsbulk_si_Vgi_bi=0.0;
  DQSD2_Vsbulk_si_Vdi_bi=0.0;
  DQSD2_Vsbulk_si_Vsi_bi=0.0;
  DQSD2_Vsbulk_si_Tempt_GND=0.0;
#endif
DQSD2_Vgi_bi=(((qs_Vgi_bi-qdeff_Vgi_bi)*(qs-qdeff))+((qs-qdeff)*(qs_Vgi_bi-qdeff_Vgi_bi)));
#if defined(_DERIVATE2)
  DQSD2_Vgi_bi_Vdbulk_di=(+(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di));
  DQSD2_Vgi_bi_Vsbulk_si=(+(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si));
  DQSD2_Vgi_bi_Vgi_bi=(+(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi));
  DQSD2_Vgi_bi_Vdi_bi=(+(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi));
  DQSD2_Vgi_bi_Vsi_bi=(+(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi));
  DQSD2_Vgi_bi_Tempt_GND=(+(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Tempt_GND-qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND));
#endif
DQSD2_Vdi_bi=(((qs_Vdi_bi-qdeff_Vdi_bi)*(qs-qdeff))+((qs-qdeff)*(qs_Vdi_bi-qdeff_Vdi_bi)));
#if defined(_DERIVATE2)
  DQSD2_Vdi_bi_Vdbulk_di=(+(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di));
  DQSD2_Vdi_bi_Vsbulk_si=(+(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si));
  DQSD2_Vdi_bi_Vgi_bi=(+(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi));
  DQSD2_Vdi_bi_Vdi_bi=(+(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi));
  DQSD2_Vdi_bi_Vsi_bi=(+(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi));
  DQSD2_Vdi_bi_Tempt_GND=(+(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Tempt_GND-qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND));
#endif
DQSD2_Vsi_bi=(((qs_Vsi_bi-qdeff_Vsi_bi)*(qs-qdeff))+((qs-qdeff)*(qs_Vsi_bi-qdeff_Vsi_bi)));
#if defined(_DERIVATE2)
  DQSD2_Vsi_bi_Vdbulk_di=(+(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di));
  DQSD2_Vsi_bi_Vsbulk_si=(+(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si));
  DQSD2_Vsi_bi_Vgi_bi=(+(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi));
  DQSD2_Vsi_bi_Vdi_bi=(+(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi));
  DQSD2_Vsi_bi_Vsi_bi=(+(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi));
  DQSD2_Vsi_bi_Tempt_GND=(+(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Tempt_GND-qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
DQSD2_Tempt_GND=(((qs_Tempt_GND-qdeff_Tempt_GND)*(qs-qdeff))+((qs-qdeff)*(qs_Tempt_GND-qdeff_Tempt_GND)));
#endif
#endif
DQSD2=((qs-qdeff)*(qs-qdeff));
EXIT_IF_ISNAN(((qs-qdeff)*(qs-qdeff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(-(qs_Vgi_bi+qdeff_Vgi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vgm_di+qdeff_Vgm_di)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+1.0*(+(+0.0+qs_Vgi_bi_Vgm_di)+qdeff_Vgi_bi_Vgm_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vgm_di+qdeff_Vgm_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vgi_bi_Vgm_si=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vgm_si+qdeff_Vgm_si)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+1.0*(+(+0.0+qs_Vgi_bi_Vgm_si)+qdeff_Vgi_bi_Vgm_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vgm_si+qdeff_Vgm_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vgi_bi_Vdbulk_di=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vdbulk_di+qdeff_Vdbulk_di)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+1.0*(+(+0.0+qs_Vgi_bi_Vdbulk_di)+qdeff_Vgi_bi_Vdbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vgi_bi_Vsbulk_si=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vsbulk_si+qdeff_Vsbulk_si)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+1.0*(+(+0.0+qs_Vgi_bi_Vsbulk_si)+qdeff_Vgi_bi_Vsbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vgi_bi_Vgi_bi=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+1.0*(+(+0.0+qs_Vgi_bi_Vgi_bi)+qdeff_Vgi_bi_Vgi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vgi_bi_Vdi_bi=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+1.0*(+(+0.0+qs_Vgi_bi_Vdi_bi)+qdeff_Vgi_bi_Vdi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vgi_bi_Vsi_bi=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+1.0*(+(+0.0+qs_Vgi_bi_Vsi_bi)+qdeff_Vgi_bi_Vsi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vgi_bi_Tempt_GND=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Tempt_GND+qdeff_Tempt_GND)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+1.0*(+(+0.0+qs_Vgi_bi_Tempt_GND)+qdeff_Vgi_bi_Tempt_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
T0_Vdi_bi=(-(qs_Vdi_bi+qdeff_Vdi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vgm_di+qdeff_Vgm_di)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+1.0*(+(+0.0+qs_Vdi_bi_Vgm_di)+qdeff_Vdi_bi_Vgm_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vgm_di+qdeff_Vgm_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vdi_bi_Vgm_si=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vgm_si+qdeff_Vgm_si)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+1.0*(+(+0.0+qs_Vdi_bi_Vgm_si)+qdeff_Vdi_bi_Vgm_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vgm_si+qdeff_Vgm_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vdi_bi_Vdbulk_di=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vdbulk_di+qdeff_Vdbulk_di)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+1.0*(+(+0.0+qs_Vdi_bi_Vdbulk_di)+qdeff_Vdi_bi_Vdbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vdi_bi_Vsbulk_si=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vsbulk_si+qdeff_Vsbulk_si)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+1.0*(+(+0.0+qs_Vdi_bi_Vsbulk_si)+qdeff_Vdi_bi_Vsbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vdi_bi_Vgi_bi=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+1.0*(+(+0.0+qs_Vdi_bi_Vgi_bi)+qdeff_Vdi_bi_Vgi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vdi_bi_Vdi_bi=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+1.0*(+(+0.0+qs_Vdi_bi_Vdi_bi)+qdeff_Vdi_bi_Vdi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vdi_bi_Vsi_bi=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+1.0*(+(+0.0+qs_Vdi_bi_Vsi_bi)+qdeff_Vdi_bi_Vsi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vdi_bi_Tempt_GND=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Tempt_GND+qdeff_Tempt_GND)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+1.0*(+(+0.0+qs_Vdi_bi_Tempt_GND)+qdeff_Vdi_bi_Tempt_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
T0_Vsi_bi=(-(qs_Vsi_bi+qdeff_Vsi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vgm_di+qdeff_Vgm_di)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+1.0*(+(+0.0+qs_Vsi_bi_Vgm_di)+qdeff_Vsi_bi_Vgm_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vgm_di+qdeff_Vgm_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vsi_bi_Vgm_si=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vgm_si+qdeff_Vgm_si)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+1.0*(+(+0.0+qs_Vsi_bi_Vgm_si)+qdeff_Vsi_bi_Vgm_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vgm_si+qdeff_Vgm_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vsi_bi_Vdbulk_di=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vdbulk_di+qdeff_Vdbulk_di)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+1.0*(+(+0.0+qs_Vsi_bi_Vdbulk_di)+qdeff_Vsi_bi_Vdbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vsi_bi_Vsbulk_si=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vsbulk_si+qdeff_Vsbulk_si)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+1.0*(+(+0.0+qs_Vsi_bi_Vsbulk_si)+qdeff_Vsi_bi_Vsbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vsi_bi_Vgi_bi=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+1.0*(+(+0.0+qs_Vsi_bi_Vgi_bi)+qdeff_Vsi_bi_Vgi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vsi_bi_Vdi_bi=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+1.0*(+(+0.0+qs_Vsi_bi_Vdi_bi)+qdeff_Vsi_bi_Vdi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vsi_bi_Vsi_bi=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+1.0*(+(+0.0+qs_Vsi_bi_Vsi_bi)+qdeff_Vsi_bi_Vsi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T0_Vsi_bi_Tempt_GND=(0.0/((1.0+qs)+qdeff)-(0.0*(qs_Tempt_GND+qdeff_Tempt_GND)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+1.0*(+(+0.0+qs_Vsi_bi_Tempt_GND)+qdeff_Vsi_bi_Tempt_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*1.0*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-(qs_Tempt_GND+qdeff_Tempt_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
#endif
T0=(1.0/((1.0+qs)+qdeff));
EXIT_IF_ISNAN((1.0/((1.0+qs)+qdeff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=((DQSD2_Vgi_bi*T0)+(DQSD2*T0_Vgi_bi));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0*T0+DQSD2_Vgi_bi*T0_Vgm_di+0.0*T0_Vgi_bi+DQSD2*T0_Vgi_bi_Vgm_di);
  T1_Vgi_bi_Vgm_si=(+0.0*T0+DQSD2_Vgi_bi*T0_Vgm_si+0.0*T0_Vgi_bi+DQSD2*T0_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+DQSD2_Vgi_bi_Vdbulk_di*T0+DQSD2_Vgi_bi*T0_Vdbulk_di+DQSD2_Vdbulk_di*T0_Vgi_bi+DQSD2*T0_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+DQSD2_Vgi_bi_Vsbulk_si*T0+DQSD2_Vgi_bi*T0_Vsbulk_si+DQSD2_Vsbulk_si*T0_Vgi_bi+DQSD2*T0_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+DQSD2_Vgi_bi_Vgi_bi*T0+DQSD2_Vgi_bi*T0_Vgi_bi+DQSD2_Vgi_bi*T0_Vgi_bi+DQSD2*T0_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+DQSD2_Vgi_bi_Vdi_bi*T0+DQSD2_Vgi_bi*T0_Vdi_bi+DQSD2_Vdi_bi*T0_Vgi_bi+DQSD2*T0_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+DQSD2_Vgi_bi_Vsi_bi*T0+DQSD2_Vgi_bi*T0_Vsi_bi+DQSD2_Vsi_bi*T0_Vgi_bi+DQSD2*T0_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+DQSD2_Vgi_bi_Tempt_GND*T0+DQSD2_Vgi_bi*T0_Tempt_GND+DQSD2_Tempt_GND*T0_Vgi_bi+DQSD2*T0_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=((DQSD2_Vdi_bi*T0)+(DQSD2*T0_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*T0+DQSD2_Vdi_bi*T0_Vgm_di+0.0*T0_Vdi_bi+DQSD2*T0_Vdi_bi_Vgm_di);
  T1_Vdi_bi_Vgm_si=(+0.0*T0+DQSD2_Vdi_bi*T0_Vgm_si+0.0*T0_Vdi_bi+DQSD2*T0_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+DQSD2_Vdi_bi_Vdbulk_di*T0+DQSD2_Vdi_bi*T0_Vdbulk_di+DQSD2_Vdbulk_di*T0_Vdi_bi+DQSD2*T0_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+DQSD2_Vdi_bi_Vsbulk_si*T0+DQSD2_Vdi_bi*T0_Vsbulk_si+DQSD2_Vsbulk_si*T0_Vdi_bi+DQSD2*T0_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+DQSD2_Vdi_bi_Vgi_bi*T0+DQSD2_Vdi_bi*T0_Vgi_bi+DQSD2_Vgi_bi*T0_Vdi_bi+DQSD2*T0_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+DQSD2_Vdi_bi_Vdi_bi*T0+DQSD2_Vdi_bi*T0_Vdi_bi+DQSD2_Vdi_bi*T0_Vdi_bi+DQSD2*T0_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+DQSD2_Vdi_bi_Vsi_bi*T0+DQSD2_Vdi_bi*T0_Vsi_bi+DQSD2_Vsi_bi*T0_Vdi_bi+DQSD2*T0_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+DQSD2_Vdi_bi_Tempt_GND*T0+DQSD2_Vdi_bi*T0_Tempt_GND+DQSD2_Tempt_GND*T0_Vdi_bi+DQSD2*T0_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=((DQSD2_Vsi_bi*T0)+(DQSD2*T0_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*T0+DQSD2_Vsi_bi*T0_Vgm_di+0.0*T0_Vsi_bi+DQSD2*T0_Vsi_bi_Vgm_di);
  T1_Vsi_bi_Vgm_si=(+0.0*T0+DQSD2_Vsi_bi*T0_Vgm_si+0.0*T0_Vsi_bi+DQSD2*T0_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+DQSD2_Vsi_bi_Vdbulk_di*T0+DQSD2_Vsi_bi*T0_Vdbulk_di+DQSD2_Vdbulk_di*T0_Vsi_bi+DQSD2*T0_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+DQSD2_Vsi_bi_Vsbulk_si*T0+DQSD2_Vsi_bi*T0_Vsbulk_si+DQSD2_Vsbulk_si*T0_Vsi_bi+DQSD2*T0_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+DQSD2_Vsi_bi_Vgi_bi*T0+DQSD2_Vsi_bi*T0_Vgi_bi+DQSD2_Vgi_bi*T0_Vsi_bi+DQSD2*T0_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+DQSD2_Vsi_bi_Vdi_bi*T0+DQSD2_Vsi_bi*T0_Vdi_bi+DQSD2_Vdi_bi*T0_Vsi_bi+DQSD2*T0_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+DQSD2_Vsi_bi_Vsi_bi*T0+DQSD2_Vsi_bi*T0_Vsi_bi+DQSD2_Vsi_bi*T0_Vsi_bi+DQSD2*T0_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+DQSD2_Vsi_bi_Tempt_GND*T0+DQSD2_Vsi_bi*T0_Tempt_GND+DQSD2_Tempt_GND*T0_Vsi_bi+DQSD2*T0_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((DQSD2_Tempt_GND*T0)+(DQSD2*T0_Tempt_GND));
#endif
#endif
T1=(DQSD2*T0);
EXIT_IF_ISNAN((DQSD2*T0))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(gm,GND) */
Qb_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qb_Vdbulk_di_Vdbulk_di=0.0;
  Qb_Vdbulk_di_Vsbulk_si=0.0;
  Qb_Vdbulk_di_Vgi_bi=0.0;
  Qb_Vdbulk_di_Vdi_bi=0.0;
  Qb_Vdbulk_di_Vsi_bi=0.0;
  Qb_Vdbulk_di_Tempt_GND=0.0;
#endif
Qb_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qb_Vsbulk_si_Vdbulk_di=0.0;
  Qb_Vsbulk_si_Vsbulk_si=0.0;
  Qb_Vsbulk_si_Vgi_bi=0.0;
  Qb_Vsbulk_si_Vdi_bi=0.0;
  Qb_Vsbulk_si_Vsi_bi=0.0;
  Qb_Vsbulk_si_Tempt_GND=0.0;
#endif
Qb_Vgi_bi=((vgfb_Vgi_bi-psip_Vgi_bi)-((nq_Vgi_bi*((qs+qdeff)+(0.33333333333333333*T1)))+((nq-1.0)*((qs_Vgi_bi+qdeff_Vgi_bi)+(0.33333333333333333*T1_Vgi_bi)))));
#if defined(_DERIVATE2)
  Qb_Vgi_bi_Vdbulk_di=(+(+vgfb_Vgi_bi_Vdbulk_di-psip_Vgi_bi_Vdbulk_di)-(+(+nq_Vgi_bi_Vdbulk_di-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vgi_bi*((qs_Vdbulk_di+qdeff_Vdbulk_di)+((0.33333333333333333*T1_Vdbulk_di)))+nq_Vdbulk_di*((qs_Vgi_bi+qdeff_Vgi_bi)+(0.33333333333333333*T1_Vgi_bi))+(nq-1.0)*(+(+qs_Vgi_bi_Vdbulk_di+qdeff_Vgi_bi_Vdbulk_di)+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+0.33333333333333333*T1_Vgi_bi_Vdbulk_di))));
  Qb_Vgi_bi_Vsbulk_si=(+(+vgfb_Vgi_bi_Vsbulk_si-psip_Vgi_bi_Vsbulk_si)-(+(+nq_Vgi_bi_Vsbulk_si-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vgi_bi*((qs_Vsbulk_si+qdeff_Vsbulk_si)+((0.33333333333333333*T1_Vsbulk_si)))+nq_Vsbulk_si*((qs_Vgi_bi+qdeff_Vgi_bi)+(0.33333333333333333*T1_Vgi_bi))+(nq-1.0)*(+(+qs_Vgi_bi_Vsbulk_si+qdeff_Vgi_bi_Vsbulk_si)+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+0.33333333333333333*T1_Vgi_bi_Vsbulk_si))));
  Qb_Vgi_bi_Vgi_bi=(+(+vgfb_Vgi_bi_Vgi_bi-psip_Vgi_bi_Vgi_bi)-(+(+nq_Vgi_bi_Vgi_bi-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vgi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+((0.33333333333333333*T1_Vgi_bi)))+nq_Vgi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+(0.33333333333333333*T1_Vgi_bi))+(nq-1.0)*(+(+qs_Vgi_bi_Vgi_bi+qdeff_Vgi_bi_Vgi_bi)+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+0.33333333333333333*T1_Vgi_bi_Vgi_bi))));
  Qb_Vgi_bi_Vdi_bi=(+(+vgfb_Vgi_bi_Vdi_bi-psip_Vgi_bi_Vdi_bi)-(+(+nq_Vgi_bi_Vdi_bi-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vgi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+((0.33333333333333333*T1_Vdi_bi)))+nq_Vdi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+(0.33333333333333333*T1_Vgi_bi))+(nq-1.0)*(+(+qs_Vgi_bi_Vdi_bi+qdeff_Vgi_bi_Vdi_bi)+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+0.33333333333333333*T1_Vgi_bi_Vdi_bi))));
  Qb_Vgi_bi_Vsi_bi=(+(+vgfb_Vgi_bi_Vsi_bi-psip_Vgi_bi_Vsi_bi)-(+(+nq_Vgi_bi_Vsi_bi-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vgi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+((0.33333333333333333*T1_Vsi_bi)))+nq_Vsi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+(0.33333333333333333*T1_Vgi_bi))+(nq-1.0)*(+(+qs_Vgi_bi_Vsi_bi+qdeff_Vgi_bi_Vsi_bi)+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+0.33333333333333333*T1_Vgi_bi_Vsi_bi))));
  Qb_Vgi_bi_Tempt_GND=(+(+vgfb_Vgi_bi_Tempt_GND-psip_Vgi_bi_Tempt_GND)-(+(+nq_Vgi_bi_Tempt_GND-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vgi_bi*((qs_Tempt_GND+qdeff_Tempt_GND)+((0.33333333333333333*T1_Tempt_GND)))+nq_Tempt_GND*((qs_Vgi_bi+qdeff_Vgi_bi)+(0.33333333333333333*T1_Vgi_bi))+(nq-1.0)*(+(+qs_Vgi_bi_Tempt_GND+qdeff_Vgi_bi_Tempt_GND)+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+0.33333333333333333*T1_Vgi_bi_Tempt_GND))));
#endif
Qb_Vdi_bi=((vgfb_Vdi_bi-psip_Vdi_bi)-((nq_Vdi_bi*((qs+qdeff)+(0.33333333333333333*T1)))+((nq-1.0)*((qs_Vdi_bi+qdeff_Vdi_bi)+(0.33333333333333333*T1_Vdi_bi)))));
#if defined(_DERIVATE2)
  Qb_Vdi_bi_Vdbulk_di=(+(+vgfb_Vdi_bi_Vdbulk_di-psip_Vdi_bi_Vdbulk_di)-(+(+nq_Vdi_bi_Vdbulk_di-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vdi_bi*((qs_Vdbulk_di+qdeff_Vdbulk_di)+((0.33333333333333333*T1_Vdbulk_di)))+nq_Vdbulk_di*((qs_Vdi_bi+qdeff_Vdi_bi)+(0.33333333333333333*T1_Vdi_bi))+(nq-1.0)*(+(+qs_Vdi_bi_Vdbulk_di+qdeff_Vdi_bi_Vdbulk_di)+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+0.33333333333333333*T1_Vdi_bi_Vdbulk_di))));
  Qb_Vdi_bi_Vsbulk_si=(+(+vgfb_Vdi_bi_Vsbulk_si-psip_Vdi_bi_Vsbulk_si)-(+(+nq_Vdi_bi_Vsbulk_si-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vdi_bi*((qs_Vsbulk_si+qdeff_Vsbulk_si)+((0.33333333333333333*T1_Vsbulk_si)))+nq_Vsbulk_si*((qs_Vdi_bi+qdeff_Vdi_bi)+(0.33333333333333333*T1_Vdi_bi))+(nq-1.0)*(+(+qs_Vdi_bi_Vsbulk_si+qdeff_Vdi_bi_Vsbulk_si)+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+0.33333333333333333*T1_Vdi_bi_Vsbulk_si))));
  Qb_Vdi_bi_Vgi_bi=(+(+vgfb_Vdi_bi_Vgi_bi-psip_Vdi_bi_Vgi_bi)-(+(+nq_Vdi_bi_Vgi_bi-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vdi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+((0.33333333333333333*T1_Vgi_bi)))+nq_Vgi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+(0.33333333333333333*T1_Vdi_bi))+(nq-1.0)*(+(+qs_Vdi_bi_Vgi_bi+qdeff_Vdi_bi_Vgi_bi)+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+0.33333333333333333*T1_Vdi_bi_Vgi_bi))));
  Qb_Vdi_bi_Vdi_bi=(+(+vgfb_Vdi_bi_Vdi_bi-psip_Vdi_bi_Vdi_bi)-(+(+nq_Vdi_bi_Vdi_bi-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vdi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+((0.33333333333333333*T1_Vdi_bi)))+nq_Vdi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+(0.33333333333333333*T1_Vdi_bi))+(nq-1.0)*(+(+qs_Vdi_bi_Vdi_bi+qdeff_Vdi_bi_Vdi_bi)+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+0.33333333333333333*T1_Vdi_bi_Vdi_bi))));
  Qb_Vdi_bi_Vsi_bi=(+(+vgfb_Vdi_bi_Vsi_bi-psip_Vdi_bi_Vsi_bi)-(+(+nq_Vdi_bi_Vsi_bi-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vdi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+((0.33333333333333333*T1_Vsi_bi)))+nq_Vsi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+(0.33333333333333333*T1_Vdi_bi))+(nq-1.0)*(+(+qs_Vdi_bi_Vsi_bi+qdeff_Vdi_bi_Vsi_bi)+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+0.33333333333333333*T1_Vdi_bi_Vsi_bi))));
  Qb_Vdi_bi_Tempt_GND=(+(+vgfb_Vdi_bi_Tempt_GND-psip_Vdi_bi_Tempt_GND)-(+(+nq_Vdi_bi_Tempt_GND-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vdi_bi*((qs_Tempt_GND+qdeff_Tempt_GND)+((0.33333333333333333*T1_Tempt_GND)))+nq_Tempt_GND*((qs_Vdi_bi+qdeff_Vdi_bi)+(0.33333333333333333*T1_Vdi_bi))+(nq-1.0)*(+(+qs_Vdi_bi_Tempt_GND+qdeff_Vdi_bi_Tempt_GND)+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+0.33333333333333333*T1_Vdi_bi_Tempt_GND))));
#endif
Qb_Vsi_bi=((vgfb_Vsi_bi-psip_Vsi_bi)-((nq_Vsi_bi*((qs+qdeff)+(0.33333333333333333*T1)))+((nq-1.0)*((qs_Vsi_bi+qdeff_Vsi_bi)+(0.33333333333333333*T1_Vsi_bi)))));
#if defined(_DERIVATE2)
  Qb_Vsi_bi_Vdbulk_di=(+(+vgfb_Vsi_bi_Vdbulk_di-psip_Vsi_bi_Vdbulk_di)-(+(+nq_Vsi_bi_Vdbulk_di-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vsi_bi*((qs_Vdbulk_di+qdeff_Vdbulk_di)+((0.33333333333333333*T1_Vdbulk_di)))+nq_Vdbulk_di*((qs_Vsi_bi+qdeff_Vsi_bi)+(0.33333333333333333*T1_Vsi_bi))+(nq-1.0)*(+(+qs_Vsi_bi_Vdbulk_di+qdeff_Vsi_bi_Vdbulk_di)+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+0.33333333333333333*T1_Vsi_bi_Vdbulk_di))));
  Qb_Vsi_bi_Vsbulk_si=(+(+vgfb_Vsi_bi_Vsbulk_si-psip_Vsi_bi_Vsbulk_si)-(+(+nq_Vsi_bi_Vsbulk_si-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vsi_bi*((qs_Vsbulk_si+qdeff_Vsbulk_si)+((0.33333333333333333*T1_Vsbulk_si)))+nq_Vsbulk_si*((qs_Vsi_bi+qdeff_Vsi_bi)+(0.33333333333333333*T1_Vsi_bi))+(nq-1.0)*(+(+qs_Vsi_bi_Vsbulk_si+qdeff_Vsi_bi_Vsbulk_si)+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+0.33333333333333333*T1_Vsi_bi_Vsbulk_si))));
  Qb_Vsi_bi_Vgi_bi=(+(+vgfb_Vsi_bi_Vgi_bi-psip_Vsi_bi_Vgi_bi)-(+(+nq_Vsi_bi_Vgi_bi-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vsi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+((0.33333333333333333*T1_Vgi_bi)))+nq_Vgi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+(0.33333333333333333*T1_Vsi_bi))+(nq-1.0)*(+(+qs_Vsi_bi_Vgi_bi+qdeff_Vsi_bi_Vgi_bi)+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+0.33333333333333333*T1_Vsi_bi_Vgi_bi))));
  Qb_Vsi_bi_Vdi_bi=(+(+vgfb_Vsi_bi_Vdi_bi-psip_Vsi_bi_Vdi_bi)-(+(+nq_Vsi_bi_Vdi_bi-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vsi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+((0.33333333333333333*T1_Vdi_bi)))+nq_Vdi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+(0.33333333333333333*T1_Vsi_bi))+(nq-1.0)*(+(+qs_Vsi_bi_Vdi_bi+qdeff_Vsi_bi_Vdi_bi)+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+0.33333333333333333*T1_Vsi_bi_Vdi_bi))));
  Qb_Vsi_bi_Vsi_bi=(+(+vgfb_Vsi_bi_Vsi_bi-psip_Vsi_bi_Vsi_bi)-(+(+nq_Vsi_bi_Vsi_bi-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vsi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+((0.33333333333333333*T1_Vsi_bi)))+nq_Vsi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+(0.33333333333333333*T1_Vsi_bi))+(nq-1.0)*(+(+qs_Vsi_bi_Vsi_bi+qdeff_Vsi_bi_Vsi_bi)+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+0.33333333333333333*T1_Vsi_bi_Vsi_bi))));
  Qb_Vsi_bi_Tempt_GND=(+(+vgfb_Vsi_bi_Tempt_GND-psip_Vsi_bi_Tempt_GND)-(+(+nq_Vsi_bi_Tempt_GND-0.0)*((qs+qdeff)+(0.33333333333333333*T1))+nq_Vsi_bi*((qs_Tempt_GND+qdeff_Tempt_GND)+((0.33333333333333333*T1_Tempt_GND)))+nq_Tempt_GND*((qs_Vsi_bi+qdeff_Vsi_bi)+(0.33333333333333333*T1_Vsi_bi))+(nq-1.0)*(+(+qs_Vsi_bi_Tempt_GND+qdeff_Vsi_bi_Tempt_GND)+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+0.33333333333333333*T1_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
Qb_Tempt_GND=((vgfb_Tempt_GND-psip_Tempt_GND)-((nq_Tempt_GND*((qs+qdeff)+(0.33333333333333333*T1)))+((nq-1.0)*((qs_Tempt_GND+qdeff_Tempt_GND)+(0.33333333333333333*T1_Tempt_GND)))));
#endif
#endif
Qb=((vgfb-psip)-((nq-1.0)*((qs+qdeff)+(0.33333333333333333*T1))));
EXIT_IF_ISNAN(((vgfb-psip)-((nq-1.0)*((qs+qdeff)+(0.33333333333333333*T1)))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(0.33333333333333333*nq_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0*nq+0.0*nq_Vgm_di+0.0*nq_Vgi_bi+0.33333333333333333*nq_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(+0.0*nq+0.0*nq_Vgm_si+0.0*nq_Vgi_bi+0.33333333333333333*nq_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vgi_bi+0.33333333333333333*nq_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vgi_bi+0.33333333333333333*nq_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+0.33333333333333333*nq_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+0.33333333333333333*nq_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+0.33333333333333333*nq_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+0.33333333333333333*nq_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=(0.33333333333333333*nq_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0*nq+0.0*nq_Vgm_di+0.0*nq_Vdi_bi+0.33333333333333333*nq_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(+0.0*nq+0.0*nq_Vgm_si+0.0*nq_Vdi_bi+0.33333333333333333*nq_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vdi_bi+0.33333333333333333*nq_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vdi_bi+0.33333333333333333*nq_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+0.33333333333333333*nq_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+0.33333333333333333*nq_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+0.33333333333333333*nq_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+0.33333333333333333*nq_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=(0.33333333333333333*nq_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0*nq+0.0*nq_Vgm_di+0.0*nq_Vsi_bi+0.33333333333333333*nq_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(+0.0*nq+0.0*nq_Vgm_si+0.0*nq_Vsi_bi+0.33333333333333333*nq_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vsi_bi+0.33333333333333333*nq_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vsi_bi+0.33333333333333333*nq_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+0.33333333333333333*nq_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+0.33333333333333333*nq_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+0.33333333333333333*nq_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+0.33333333333333333*nq_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(0.33333333333333333*nq_Tempt_GND);
#endif
#endif
T2=(0.33333333333333333*nq);
EXIT_IF_ISNAN((0.33333333333333333*nq))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=((T1_Vgi_bi*T0)+(T1*T0_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si*T0+T1_Vgi_bi*T0_Vgm_si+T1_Vgm_si*T0_Vgi_bi+T1*T0_Vgi_bi_Vgm_si);
  T3_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di*T0+T1_Vgi_bi*T0_Vgm_di+T1_Vgm_di*T0_Vgi_bi+T1*T0_Vgi_bi_Vgm_di);
  T3_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di*T0+T1_Vgi_bi*T0_Vdbulk_di+T1_Vdbulk_di*T0_Vgi_bi+T1*T0_Vgi_bi_Vdbulk_di);
  T3_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si*T0+T1_Vgi_bi*T0_Vsbulk_si+T1_Vsbulk_si*T0_Vgi_bi+T1*T0_Vgi_bi_Vsbulk_si);
  T3_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi*T0+T1_Vgi_bi*T0_Vgi_bi+T1_Vgi_bi*T0_Vgi_bi+T1*T0_Vgi_bi_Vgi_bi);
  T3_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi*T0+T1_Vgi_bi*T0_Vdi_bi+T1_Vdi_bi*T0_Vgi_bi+T1*T0_Vgi_bi_Vdi_bi);
  T3_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi*T0+T1_Vgi_bi*T0_Vsi_bi+T1_Vsi_bi*T0_Vgi_bi+T1*T0_Vgi_bi_Vsi_bi);
  T3_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND*T0+T1_Vgi_bi*T0_Tempt_GND+T1_Tempt_GND*T0_Vgi_bi+T1*T0_Vgi_bi_Tempt_GND);
#endif
T3_Vdi_bi=((T1_Vdi_bi*T0)+(T1*T0_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si*T0+T1_Vdi_bi*T0_Vgm_si+T1_Vgm_si*T0_Vdi_bi+T1*T0_Vdi_bi_Vgm_si);
  T3_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di*T0+T1_Vdi_bi*T0_Vgm_di+T1_Vgm_di*T0_Vdi_bi+T1*T0_Vdi_bi_Vgm_di);
  T3_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di*T0+T1_Vdi_bi*T0_Vdbulk_di+T1_Vdbulk_di*T0_Vdi_bi+T1*T0_Vdi_bi_Vdbulk_di);
  T3_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si*T0+T1_Vdi_bi*T0_Vsbulk_si+T1_Vsbulk_si*T0_Vdi_bi+T1*T0_Vdi_bi_Vsbulk_si);
  T3_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi*T0+T1_Vdi_bi*T0_Vgi_bi+T1_Vgi_bi*T0_Vdi_bi+T1*T0_Vdi_bi_Vgi_bi);
  T3_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi*T0+T1_Vdi_bi*T0_Vdi_bi+T1_Vdi_bi*T0_Vdi_bi+T1*T0_Vdi_bi_Vdi_bi);
  T3_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi*T0+T1_Vdi_bi*T0_Vsi_bi+T1_Vsi_bi*T0_Vdi_bi+T1*T0_Vdi_bi_Vsi_bi);
  T3_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND*T0+T1_Vdi_bi*T0_Tempt_GND+T1_Tempt_GND*T0_Vdi_bi+T1*T0_Vdi_bi_Tempt_GND);
#endif
T3_Vsi_bi=((T1_Vsi_bi*T0)+(T1*T0_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si*T0+T1_Vsi_bi*T0_Vgm_si+T1_Vgm_si*T0_Vsi_bi+T1*T0_Vsi_bi_Vgm_si);
  T3_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di*T0+T1_Vsi_bi*T0_Vgm_di+T1_Vgm_di*T0_Vsi_bi+T1*T0_Vsi_bi_Vgm_di);
  T3_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di*T0+T1_Vsi_bi*T0_Vdbulk_di+T1_Vdbulk_di*T0_Vsi_bi+T1*T0_Vsi_bi_Vdbulk_di);
  T3_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si*T0+T1_Vsi_bi*T0_Vsbulk_si+T1_Vsbulk_si*T0_Vsi_bi+T1*T0_Vsi_bi_Vsbulk_si);
  T3_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi*T0+T1_Vsi_bi*T0_Vgi_bi+T1_Vgi_bi*T0_Vsi_bi+T1*T0_Vsi_bi_Vgi_bi);
  T3_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi*T0+T1_Vsi_bi*T0_Vdi_bi+T1_Vdi_bi*T0_Vsi_bi+T1*T0_Vsi_bi_Vdi_bi);
  T3_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi*T0+T1_Vsi_bi*T0_Vsi_bi+T1_Vsi_bi*T0_Vsi_bi+T1*T0_Vsi_bi_Vsi_bi);
  T3_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND*T0+T1_Vsi_bi*T0_Tempt_GND+T1_Tempt_GND*T0_Vsi_bi+T1*T0_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=((T1_Tempt_GND*T0)+(T1*T0_Tempt_GND));
#endif
#endif
T3=(T1*T0);
EXIT_IF_ISNAN((T1*T0))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
Qs_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qs_Vdbulk_di_Vdbulk_di=0.0;
  Qs_Vdbulk_di_Vsbulk_si=0.0;
  Qs_Vdbulk_di_Vgi_bi=0.0;
  Qs_Vdbulk_di_Vdi_bi=0.0;
  Qs_Vdbulk_di_Vsi_bi=0.0;
  Qs_Vdbulk_di_Tempt_GND=0.0;
#endif
Qs_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qs_Vsbulk_si_Vdbulk_di=0.0;
  Qs_Vsbulk_si_Vsbulk_si=0.0;
  Qs_Vsbulk_si_Vgi_bi=0.0;
  Qs_Vsbulk_si_Vdi_bi=0.0;
  Qs_Vsbulk_si_Vsi_bi=0.0;
  Qs_Vsbulk_si_Tempt_GND=0.0;
#endif
Qs_Vgi_bi=((T2_Vgi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)))+(T2*(((2.0*qs_Vgi_bi)+qdeff_Vgi_bi)+(((0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi)))));
#if defined(_DERIVATE2)
  Qs_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vgi_bi*((((2.0*qs_Vdbulk_di))+qdeff_Vdbulk_di)+(((((0.5*(((0.8*qs_Vdbulk_di))+((1.2*qdeff_Vdbulk_di)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdbulk_di))))+T2_Vdbulk_di*(((2.0*qs_Vgi_bi)+qdeff_Vgi_bi)+(((0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdbulk_di)+qdeff_Vgi_bi_Vdbulk_di)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vdbulk_di))+((1.2*qdeff_Vdbulk_di)))+0.0*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vgi_bi+0.8*qs_Vgi_bi_Vdbulk_di))+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vgi_bi+1.2*qdeff_Vgi_bi_Vdbulk_di)))*T3+(0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3_Vdbulk_di+((0.5*(((0.8*qs_Vdbulk_di))+((1.2*qdeff_Vdbulk_di)))))*T3_Vgi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi_Vdbulk_di)));
  Qs_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vgi_bi*((((2.0*qs_Vsbulk_si))+qdeff_Vsbulk_si)+(((((0.5*(((0.8*qs_Vsbulk_si))+((1.2*qdeff_Vsbulk_si)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsbulk_si))))+T2_Vsbulk_si*(((2.0*qs_Vgi_bi)+qdeff_Vgi_bi)+(((0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsbulk_si)+qdeff_Vgi_bi_Vsbulk_si)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vsbulk_si))+((1.2*qdeff_Vsbulk_si)))+0.0*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vgi_bi+0.8*qs_Vgi_bi_Vsbulk_si))+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vgi_bi+1.2*qdeff_Vgi_bi_Vsbulk_si)))*T3+(0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3_Vsbulk_si+((0.5*(((0.8*qs_Vsbulk_si))+((1.2*qdeff_Vsbulk_si)))))*T3_Vgi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi_Vsbulk_si)));
  Qs_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vgi_bi*((((2.0*qs_Vgi_bi))+qdeff_Vgi_bi)+(((((0.5*(((0.8*qs_Vgi_bi))+((1.2*qdeff_Vgi_bi)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi))))+T2_Vgi_bi*(((2.0*qs_Vgi_bi)+qdeff_Vgi_bi)+(((0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgi_bi)+qdeff_Vgi_bi_Vgi_bi)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vgi_bi))+((1.2*qdeff_Vgi_bi)))+0.0*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vgi_bi+0.8*qs_Vgi_bi_Vgi_bi))+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vgi_bi+1.2*qdeff_Vgi_bi_Vgi_bi)))*T3+(0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3_Vgi_bi+((0.5*(((0.8*qs_Vgi_bi))+((1.2*qdeff_Vgi_bi)))))*T3_Vgi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi_Vgi_bi)));
  Qs_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vgi_bi*((((2.0*qs_Vdi_bi))+qdeff_Vdi_bi)+(((((0.5*(((0.8*qs_Vdi_bi))+((1.2*qdeff_Vdi_bi)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi))))+T2_Vdi_bi*(((2.0*qs_Vgi_bi)+qdeff_Vgi_bi)+(((0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdi_bi)+qdeff_Vgi_bi_Vdi_bi)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vdi_bi))+((1.2*qdeff_Vdi_bi)))+0.0*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vgi_bi+0.8*qs_Vgi_bi_Vdi_bi))+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vgi_bi+1.2*qdeff_Vgi_bi_Vdi_bi)))*T3+(0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3_Vdi_bi+((0.5*(((0.8*qs_Vdi_bi))+((1.2*qdeff_Vdi_bi)))))*T3_Vgi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi_Vdi_bi)));
  Qs_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vgi_bi*((((2.0*qs_Vsi_bi))+qdeff_Vsi_bi)+(((((0.5*(((0.8*qs_Vsi_bi))+((1.2*qdeff_Vsi_bi)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi))))+T2_Vsi_bi*(((2.0*qs_Vgi_bi)+qdeff_Vgi_bi)+(((0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsi_bi)+qdeff_Vgi_bi_Vsi_bi)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vsi_bi))+((1.2*qdeff_Vsi_bi)))+0.0*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vgi_bi+0.8*qs_Vgi_bi_Vsi_bi))+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vgi_bi+1.2*qdeff_Vgi_bi_Vsi_bi)))*T3+(0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3_Vsi_bi+((0.5*(((0.8*qs_Vsi_bi))+((1.2*qdeff_Vsi_bi)))))*T3_Vgi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi_Vsi_bi)));
  Qs_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vgi_bi*((((2.0*qs_Tempt_GND))+qdeff_Tempt_GND)+(((((0.5*(((0.8*qs_Tempt_GND))+((1.2*qdeff_Tempt_GND)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Tempt_GND))))+T2_Tempt_GND*(((2.0*qs_Vgi_bi)+qdeff_Vgi_bi)+(((0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Tempt_GND)+qdeff_Vgi_bi_Tempt_GND)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Tempt_GND))+((1.2*qdeff_Tempt_GND)))+0.0*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vgi_bi+0.8*qs_Vgi_bi_Tempt_GND))+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vgi_bi+1.2*qdeff_Vgi_bi_Tempt_GND)))*T3+(0.5*((0.8*qs_Vgi_bi)+(1.2*qdeff_Vgi_bi)))*T3_Tempt_GND+((0.5*(((0.8*qs_Tempt_GND))+((1.2*qdeff_Tempt_GND)))))*T3_Vgi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi_Tempt_GND)));
#endif
Qs_Vdi_bi=((T2_Vdi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)))+(T2*(((2.0*qs_Vdi_bi)+qdeff_Vdi_bi)+(((0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi)))));
#if defined(_DERIVATE2)
  Qs_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vdi_bi*((((2.0*qs_Vdbulk_di))+qdeff_Vdbulk_di)+(((((0.5*(((0.8*qs_Vdbulk_di))+((1.2*qdeff_Vdbulk_di)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdbulk_di))))+T2_Vdbulk_di*(((2.0*qs_Vdi_bi)+qdeff_Vdi_bi)+(((0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdbulk_di)+qdeff_Vdi_bi_Vdbulk_di)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vdbulk_di))+((1.2*qdeff_Vdbulk_di)))+0.0*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdi_bi+0.8*qs_Vdi_bi_Vdbulk_di))+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vdi_bi+1.2*qdeff_Vdi_bi_Vdbulk_di)))*T3+(0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3_Vdbulk_di+((0.5*(((0.8*qs_Vdbulk_di))+((1.2*qdeff_Vdbulk_di)))))*T3_Vdi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi_Vdbulk_di)));
  Qs_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vdi_bi*((((2.0*qs_Vsbulk_si))+qdeff_Vsbulk_si)+(((((0.5*(((0.8*qs_Vsbulk_si))+((1.2*qdeff_Vsbulk_si)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsbulk_si))))+T2_Vsbulk_si*(((2.0*qs_Vdi_bi)+qdeff_Vdi_bi)+(((0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsbulk_si)+qdeff_Vdi_bi_Vsbulk_si)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vsbulk_si))+((1.2*qdeff_Vsbulk_si)))+0.0*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdi_bi+0.8*qs_Vdi_bi_Vsbulk_si))+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vdi_bi+1.2*qdeff_Vdi_bi_Vsbulk_si)))*T3+(0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3_Vsbulk_si+((0.5*(((0.8*qs_Vsbulk_si))+((1.2*qdeff_Vsbulk_si)))))*T3_Vdi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi_Vsbulk_si)));
  Qs_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vdi_bi*((((2.0*qs_Vgi_bi))+qdeff_Vgi_bi)+(((((0.5*(((0.8*qs_Vgi_bi))+((1.2*qdeff_Vgi_bi)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi))))+T2_Vgi_bi*(((2.0*qs_Vdi_bi)+qdeff_Vdi_bi)+(((0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgi_bi)+qdeff_Vdi_bi_Vgi_bi)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vgi_bi))+((1.2*qdeff_Vgi_bi)))+0.0*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdi_bi+0.8*qs_Vdi_bi_Vgi_bi))+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vdi_bi+1.2*qdeff_Vdi_bi_Vgi_bi)))*T3+(0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3_Vgi_bi+((0.5*(((0.8*qs_Vgi_bi))+((1.2*qdeff_Vgi_bi)))))*T3_Vdi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi_Vgi_bi)));
  Qs_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vdi_bi*((((2.0*qs_Vdi_bi))+qdeff_Vdi_bi)+(((((0.5*(((0.8*qs_Vdi_bi))+((1.2*qdeff_Vdi_bi)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi))))+T2_Vdi_bi*(((2.0*qs_Vdi_bi)+qdeff_Vdi_bi)+(((0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdi_bi)+qdeff_Vdi_bi_Vdi_bi)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vdi_bi))+((1.2*qdeff_Vdi_bi)))+0.0*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdi_bi+0.8*qs_Vdi_bi_Vdi_bi))+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vdi_bi+1.2*qdeff_Vdi_bi_Vdi_bi)))*T3+(0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3_Vdi_bi+((0.5*(((0.8*qs_Vdi_bi))+((1.2*qdeff_Vdi_bi)))))*T3_Vdi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi_Vdi_bi)));
  Qs_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vdi_bi*((((2.0*qs_Vsi_bi))+qdeff_Vsi_bi)+(((((0.5*(((0.8*qs_Vsi_bi))+((1.2*qdeff_Vsi_bi)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi))))+T2_Vsi_bi*(((2.0*qs_Vdi_bi)+qdeff_Vdi_bi)+(((0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsi_bi)+qdeff_Vdi_bi_Vsi_bi)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vsi_bi))+((1.2*qdeff_Vsi_bi)))+0.0*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdi_bi+0.8*qs_Vdi_bi_Vsi_bi))+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vdi_bi+1.2*qdeff_Vdi_bi_Vsi_bi)))*T3+(0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3_Vsi_bi+((0.5*(((0.8*qs_Vsi_bi))+((1.2*qdeff_Vsi_bi)))))*T3_Vdi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi_Vsi_bi)));
  Qs_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vdi_bi*((((2.0*qs_Tempt_GND))+qdeff_Tempt_GND)+(((((0.5*(((0.8*qs_Tempt_GND))+((1.2*qdeff_Tempt_GND)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Tempt_GND))))+T2_Tempt_GND*(((2.0*qs_Vdi_bi)+qdeff_Vdi_bi)+(((0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Tempt_GND)+qdeff_Vdi_bi_Tempt_GND)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Tempt_GND))+((1.2*qdeff_Tempt_GND)))+0.0*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdi_bi+0.8*qs_Vdi_bi_Tempt_GND))+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vdi_bi+1.2*qdeff_Vdi_bi_Tempt_GND)))*T3+(0.5*((0.8*qs_Vdi_bi)+(1.2*qdeff_Vdi_bi)))*T3_Tempt_GND+((0.5*(((0.8*qs_Tempt_GND))+((1.2*qdeff_Tempt_GND)))))*T3_Vdi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi_Tempt_GND)));
#endif
Qs_Vsi_bi=((T2_Vsi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)))+(T2*(((2.0*qs_Vsi_bi)+qdeff_Vsi_bi)+(((0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi)))));
#if defined(_DERIVATE2)
  Qs_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vsi_bi*((((2.0*qs_Vdbulk_di))+qdeff_Vdbulk_di)+(((((0.5*(((0.8*qs_Vdbulk_di))+((1.2*qdeff_Vdbulk_di)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdbulk_di))))+T2_Vdbulk_di*(((2.0*qs_Vsi_bi)+qdeff_Vsi_bi)+(((0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdbulk_di)+qdeff_Vsi_bi_Vdbulk_di)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vdbulk_di))+((1.2*qdeff_Vdbulk_di)))+0.0*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsi_bi+0.8*qs_Vsi_bi_Vdbulk_di))+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vsi_bi+1.2*qdeff_Vsi_bi_Vdbulk_di)))*T3+(0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3_Vdbulk_di+((0.5*(((0.8*qs_Vdbulk_di))+((1.2*qdeff_Vdbulk_di)))))*T3_Vsi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi_Vdbulk_di)));
  Qs_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vsi_bi*((((2.0*qs_Vsbulk_si))+qdeff_Vsbulk_si)+(((((0.5*(((0.8*qs_Vsbulk_si))+((1.2*qdeff_Vsbulk_si)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsbulk_si))))+T2_Vsbulk_si*(((2.0*qs_Vsi_bi)+qdeff_Vsi_bi)+(((0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsbulk_si)+qdeff_Vsi_bi_Vsbulk_si)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vsbulk_si))+((1.2*qdeff_Vsbulk_si)))+0.0*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsi_bi+0.8*qs_Vsi_bi_Vsbulk_si))+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vsi_bi+1.2*qdeff_Vsi_bi_Vsbulk_si)))*T3+(0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3_Vsbulk_si+((0.5*(((0.8*qs_Vsbulk_si))+((1.2*qdeff_Vsbulk_si)))))*T3_Vsi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi_Vsbulk_si)));
  Qs_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vsi_bi*((((2.0*qs_Vgi_bi))+qdeff_Vgi_bi)+(((((0.5*(((0.8*qs_Vgi_bi))+((1.2*qdeff_Vgi_bi)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vgi_bi))))+T2_Vgi_bi*(((2.0*qs_Vsi_bi)+qdeff_Vsi_bi)+(((0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgi_bi)+qdeff_Vsi_bi_Vgi_bi)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vgi_bi))+((1.2*qdeff_Vgi_bi)))+0.0*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsi_bi+0.8*qs_Vsi_bi_Vgi_bi))+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vsi_bi+1.2*qdeff_Vsi_bi_Vgi_bi)))*T3+(0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3_Vgi_bi+((0.5*(((0.8*qs_Vgi_bi))+((1.2*qdeff_Vgi_bi)))))*T3_Vsi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi_Vgi_bi)));
  Qs_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vsi_bi*((((2.0*qs_Vdi_bi))+qdeff_Vdi_bi)+(((((0.5*(((0.8*qs_Vdi_bi))+((1.2*qdeff_Vdi_bi)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vdi_bi))))+T2_Vdi_bi*(((2.0*qs_Vsi_bi)+qdeff_Vsi_bi)+(((0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdi_bi)+qdeff_Vsi_bi_Vdi_bi)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vdi_bi))+((1.2*qdeff_Vdi_bi)))+0.0*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsi_bi+0.8*qs_Vsi_bi_Vdi_bi))+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vsi_bi+1.2*qdeff_Vsi_bi_Vdi_bi)))*T3+(0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3_Vdi_bi+((0.5*(((0.8*qs_Vdi_bi))+((1.2*qdeff_Vdi_bi)))))*T3_Vsi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi_Vdi_bi)));
  Qs_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vsi_bi*((((2.0*qs_Vsi_bi))+qdeff_Vsi_bi)+(((((0.5*(((0.8*qs_Vsi_bi))+((1.2*qdeff_Vsi_bi)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi))))+T2_Vsi_bi*(((2.0*qs_Vsi_bi)+qdeff_Vsi_bi)+(((0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsi_bi)+qdeff_Vsi_bi_Vsi_bi)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Vsi_bi))+((1.2*qdeff_Vsi_bi)))+0.0*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsi_bi+0.8*qs_Vsi_bi_Vsi_bi))+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vsi_bi+1.2*qdeff_Vsi_bi_Vsi_bi)))*T3+(0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3_Vsi_bi+((0.5*(((0.8*qs_Vsi_bi))+((1.2*qdeff_Vsi_bi)))))*T3_Vsi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi_Vsi_bi)));
  Qs_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))+T2_Vsi_bi*((((2.0*qs_Tempt_GND))+qdeff_Tempt_GND)+(((((0.5*(((0.8*qs_Tempt_GND))+((1.2*qdeff_Tempt_GND)))))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Tempt_GND))))+T2_Tempt_GND*(((2.0*qs_Vsi_bi)+qdeff_Vsi_bi)+(((0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi)))+T2*(+(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Tempt_GND)+qdeff_Vsi_bi_Tempt_GND)+(+(+0.0*((1.0+(0.8*qs))+(1.2*qdeff))+0.0*(((0.8*qs_Tempt_GND))+((1.2*qdeff_Tempt_GND)))+0.0*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsi_bi+0.8*qs_Vsi_bi_Tempt_GND))+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vsi_bi+1.2*qdeff_Vsi_bi_Tempt_GND)))*T3+(0.5*((0.8*qs_Vsi_bi)+(1.2*qdeff_Vsi_bi)))*T3_Tempt_GND+((0.5*(((0.8*qs_Tempt_GND))+((1.2*qdeff_Tempt_GND)))))*T3_Vsi_bi+(0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
Qs_Tempt_GND=((T2_Tempt_GND*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)))+(T2*(((2.0*qs_Tempt_GND)+qdeff_Tempt_GND)+(((0.5*((0.8*qs_Tempt_GND)+(1.2*qdeff_Tempt_GND)))*T3)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3_Tempt_GND)))));
#endif
#endif
Qs=(T2*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));
EXIT_IF_ISNAN((T2*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3))))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
Qd_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qd_Vdbulk_di_Vdbulk_di=0.0;
  Qd_Vdbulk_di_Vsbulk_si=0.0;
  Qd_Vdbulk_di_Vgi_bi=0.0;
  Qd_Vdbulk_di_Vdi_bi=0.0;
  Qd_Vdbulk_di_Vsi_bi=0.0;
  Qd_Vdbulk_di_Tempt_GND=0.0;
#endif
Qd_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qd_Vsbulk_si_Vdbulk_di=0.0;
  Qd_Vsbulk_si_Vsbulk_si=0.0;
  Qd_Vsbulk_si_Vgi_bi=0.0;
  Qd_Vsbulk_si_Vdi_bi=0.0;
  Qd_Vsbulk_si_Vsi_bi=0.0;
  Qd_Vsbulk_si_Tempt_GND=0.0;
#endif
Qd_Vgi_bi=((T2_Vgi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)))+(T2*((qs_Vgi_bi+(2.0*qdeff_Vgi_bi))+(((0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi)))));
#if defined(_DERIVATE2)
  Qd_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vgi_bi*((qs_Vdbulk_di+((2.0*qdeff_Vdbulk_di)))+(((((0.5*(((1.2*qs_Vdbulk_di))+((0.8*qdeff_Vdbulk_di)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdbulk_di))))+T2_Vdbulk_di*((qs_Vgi_bi+(2.0*qdeff_Vgi_bi))+(((0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi)))+T2*(+(+qs_Vgi_bi_Vdbulk_di+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vdbulk_di))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vdbulk_di))+((0.8*qdeff_Vdbulk_di)))+0.0*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vgi_bi+1.2*qs_Vgi_bi_Vdbulk_di))+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vgi_bi+0.8*qdeff_Vgi_bi_Vdbulk_di)))*T3+(0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3_Vdbulk_di+((0.5*(((1.2*qs_Vdbulk_di))+((0.8*qdeff_Vdbulk_di)))))*T3_Vgi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi_Vdbulk_di)));
  Qd_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vgi_bi*((qs_Vsbulk_si+((2.0*qdeff_Vsbulk_si)))+(((((0.5*(((1.2*qs_Vsbulk_si))+((0.8*qdeff_Vsbulk_si)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsbulk_si))))+T2_Vsbulk_si*((qs_Vgi_bi+(2.0*qdeff_Vgi_bi))+(((0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi)))+T2*(+(+qs_Vgi_bi_Vsbulk_si+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vsbulk_si))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vsbulk_si))+((0.8*qdeff_Vsbulk_si)))+0.0*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vgi_bi+1.2*qs_Vgi_bi_Vsbulk_si))+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vgi_bi+0.8*qdeff_Vgi_bi_Vsbulk_si)))*T3+(0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3_Vsbulk_si+((0.5*(((1.2*qs_Vsbulk_si))+((0.8*qdeff_Vsbulk_si)))))*T3_Vgi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi_Vsbulk_si)));
  Qd_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vgi_bi*((qs_Vgi_bi+((2.0*qdeff_Vgi_bi)))+(((((0.5*(((1.2*qs_Vgi_bi))+((0.8*qdeff_Vgi_bi)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi))))+T2_Vgi_bi*((qs_Vgi_bi+(2.0*qdeff_Vgi_bi))+(((0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi)))+T2*(+(+qs_Vgi_bi_Vgi_bi+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vgi_bi))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vgi_bi))+((0.8*qdeff_Vgi_bi)))+0.0*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vgi_bi+1.2*qs_Vgi_bi_Vgi_bi))+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vgi_bi+0.8*qdeff_Vgi_bi_Vgi_bi)))*T3+(0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3_Vgi_bi+((0.5*(((1.2*qs_Vgi_bi))+((0.8*qdeff_Vgi_bi)))))*T3_Vgi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi_Vgi_bi)));
  Qd_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vgi_bi*((qs_Vdi_bi+((2.0*qdeff_Vdi_bi)))+(((((0.5*(((1.2*qs_Vdi_bi))+((0.8*qdeff_Vdi_bi)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi))))+T2_Vdi_bi*((qs_Vgi_bi+(2.0*qdeff_Vgi_bi))+(((0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi)))+T2*(+(+qs_Vgi_bi_Vdi_bi+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vdi_bi))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vdi_bi))+((0.8*qdeff_Vdi_bi)))+0.0*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vgi_bi+1.2*qs_Vgi_bi_Vdi_bi))+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vgi_bi+0.8*qdeff_Vgi_bi_Vdi_bi)))*T3+(0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3_Vdi_bi+((0.5*(((1.2*qs_Vdi_bi))+((0.8*qdeff_Vdi_bi)))))*T3_Vgi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi_Vdi_bi)));
  Qd_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vgi_bi*((qs_Vsi_bi+((2.0*qdeff_Vsi_bi)))+(((((0.5*(((1.2*qs_Vsi_bi))+((0.8*qdeff_Vsi_bi)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi))))+T2_Vsi_bi*((qs_Vgi_bi+(2.0*qdeff_Vgi_bi))+(((0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi)))+T2*(+(+qs_Vgi_bi_Vsi_bi+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vsi_bi))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vsi_bi))+((0.8*qdeff_Vsi_bi)))+0.0*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vgi_bi+1.2*qs_Vgi_bi_Vsi_bi))+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vgi_bi+0.8*qdeff_Vgi_bi_Vsi_bi)))*T3+(0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3_Vsi_bi+((0.5*(((1.2*qs_Vsi_bi))+((0.8*qdeff_Vsi_bi)))))*T3_Vgi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi_Vsi_bi)));
  Qd_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vgi_bi*((qs_Tempt_GND+((2.0*qdeff_Tempt_GND)))+(((((0.5*(((1.2*qs_Tempt_GND))+((0.8*qdeff_Tempt_GND)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Tempt_GND))))+T2_Tempt_GND*((qs_Vgi_bi+(2.0*qdeff_Vgi_bi))+(((0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi)))+T2*(+(+qs_Vgi_bi_Tempt_GND+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Tempt_GND))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Tempt_GND))+((0.8*qdeff_Tempt_GND)))+0.0*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vgi_bi+1.2*qs_Vgi_bi_Tempt_GND))+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vgi_bi+0.8*qdeff_Vgi_bi_Tempt_GND)))*T3+(0.5*((1.2*qs_Vgi_bi)+(0.8*qdeff_Vgi_bi)))*T3_Tempt_GND+((0.5*(((1.2*qs_Tempt_GND))+((0.8*qdeff_Tempt_GND)))))*T3_Vgi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi_Tempt_GND)));
#endif
Qd_Vdi_bi=((T2_Vdi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)))+(T2*((qs_Vdi_bi+(2.0*qdeff_Vdi_bi))+(((0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi)))));
#if defined(_DERIVATE2)
  Qd_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vdi_bi*((qs_Vdbulk_di+((2.0*qdeff_Vdbulk_di)))+(((((0.5*(((1.2*qs_Vdbulk_di))+((0.8*qdeff_Vdbulk_di)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdbulk_di))))+T2_Vdbulk_di*((qs_Vdi_bi+(2.0*qdeff_Vdi_bi))+(((0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi)))+T2*(+(+qs_Vdi_bi_Vdbulk_di+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vdbulk_di))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vdbulk_di))+((0.8*qdeff_Vdbulk_di)))+0.0*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdi_bi+1.2*qs_Vdi_bi_Vdbulk_di))+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vdi_bi+0.8*qdeff_Vdi_bi_Vdbulk_di)))*T3+(0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3_Vdbulk_di+((0.5*(((1.2*qs_Vdbulk_di))+((0.8*qdeff_Vdbulk_di)))))*T3_Vdi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi_Vdbulk_di)));
  Qd_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vdi_bi*((qs_Vsbulk_si+((2.0*qdeff_Vsbulk_si)))+(((((0.5*(((1.2*qs_Vsbulk_si))+((0.8*qdeff_Vsbulk_si)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsbulk_si))))+T2_Vsbulk_si*((qs_Vdi_bi+(2.0*qdeff_Vdi_bi))+(((0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi)))+T2*(+(+qs_Vdi_bi_Vsbulk_si+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vsbulk_si))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vsbulk_si))+((0.8*qdeff_Vsbulk_si)))+0.0*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdi_bi+1.2*qs_Vdi_bi_Vsbulk_si))+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vdi_bi+0.8*qdeff_Vdi_bi_Vsbulk_si)))*T3+(0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3_Vsbulk_si+((0.5*(((1.2*qs_Vsbulk_si))+((0.8*qdeff_Vsbulk_si)))))*T3_Vdi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi_Vsbulk_si)));
  Qd_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vdi_bi*((qs_Vgi_bi+((2.0*qdeff_Vgi_bi)))+(((((0.5*(((1.2*qs_Vgi_bi))+((0.8*qdeff_Vgi_bi)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi))))+T2_Vgi_bi*((qs_Vdi_bi+(2.0*qdeff_Vdi_bi))+(((0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi)))+T2*(+(+qs_Vdi_bi_Vgi_bi+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vgi_bi))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vgi_bi))+((0.8*qdeff_Vgi_bi)))+0.0*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdi_bi+1.2*qs_Vdi_bi_Vgi_bi))+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vdi_bi+0.8*qdeff_Vdi_bi_Vgi_bi)))*T3+(0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3_Vgi_bi+((0.5*(((1.2*qs_Vgi_bi))+((0.8*qdeff_Vgi_bi)))))*T3_Vdi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi_Vgi_bi)));
  Qd_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vdi_bi*((qs_Vdi_bi+((2.0*qdeff_Vdi_bi)))+(((((0.5*(((1.2*qs_Vdi_bi))+((0.8*qdeff_Vdi_bi)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi))))+T2_Vdi_bi*((qs_Vdi_bi+(2.0*qdeff_Vdi_bi))+(((0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi)))+T2*(+(+qs_Vdi_bi_Vdi_bi+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vdi_bi))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vdi_bi))+((0.8*qdeff_Vdi_bi)))+0.0*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdi_bi+1.2*qs_Vdi_bi_Vdi_bi))+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vdi_bi+0.8*qdeff_Vdi_bi_Vdi_bi)))*T3+(0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3_Vdi_bi+((0.5*(((1.2*qs_Vdi_bi))+((0.8*qdeff_Vdi_bi)))))*T3_Vdi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi_Vdi_bi)));
  Qd_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vdi_bi*((qs_Vsi_bi+((2.0*qdeff_Vsi_bi)))+(((((0.5*(((1.2*qs_Vsi_bi))+((0.8*qdeff_Vsi_bi)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi))))+T2_Vsi_bi*((qs_Vdi_bi+(2.0*qdeff_Vdi_bi))+(((0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi)))+T2*(+(+qs_Vdi_bi_Vsi_bi+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vsi_bi))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vsi_bi))+((0.8*qdeff_Vsi_bi)))+0.0*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdi_bi+1.2*qs_Vdi_bi_Vsi_bi))+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vdi_bi+0.8*qdeff_Vdi_bi_Vsi_bi)))*T3+(0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3_Vsi_bi+((0.5*(((1.2*qs_Vsi_bi))+((0.8*qdeff_Vsi_bi)))))*T3_Vdi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi_Vsi_bi)));
  Qd_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vdi_bi*((qs_Tempt_GND+((2.0*qdeff_Tempt_GND)))+(((((0.5*(((1.2*qs_Tempt_GND))+((0.8*qdeff_Tempt_GND)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Tempt_GND))))+T2_Tempt_GND*((qs_Vdi_bi+(2.0*qdeff_Vdi_bi))+(((0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi)))+T2*(+(+qs_Vdi_bi_Tempt_GND+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Tempt_GND))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Tempt_GND))+((0.8*qdeff_Tempt_GND)))+0.0*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdi_bi+1.2*qs_Vdi_bi_Tempt_GND))+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vdi_bi+0.8*qdeff_Vdi_bi_Tempt_GND)))*T3+(0.5*((1.2*qs_Vdi_bi)+(0.8*qdeff_Vdi_bi)))*T3_Tempt_GND+((0.5*(((1.2*qs_Tempt_GND))+((0.8*qdeff_Tempt_GND)))))*T3_Vdi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi_Tempt_GND)));
#endif
Qd_Vsi_bi=((T2_Vsi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)))+(T2*((qs_Vsi_bi+(2.0*qdeff_Vsi_bi))+(((0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi)))));
#if defined(_DERIVATE2)
  Qd_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vsi_bi*((qs_Vdbulk_di+((2.0*qdeff_Vdbulk_di)))+(((((0.5*(((1.2*qs_Vdbulk_di))+((0.8*qdeff_Vdbulk_di)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdbulk_di))))+T2_Vdbulk_di*((qs_Vsi_bi+(2.0*qdeff_Vsi_bi))+(((0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi)))+T2*(+(+qs_Vsi_bi_Vdbulk_di+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vdbulk_di))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vdbulk_di))+((0.8*qdeff_Vdbulk_di)))+0.0*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsi_bi+1.2*qs_Vsi_bi_Vdbulk_di))+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vsi_bi+0.8*qdeff_Vsi_bi_Vdbulk_di)))*T3+(0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3_Vdbulk_di+((0.5*(((1.2*qs_Vdbulk_di))+((0.8*qdeff_Vdbulk_di)))))*T3_Vsi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi_Vdbulk_di)));
  Qd_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vsi_bi*((qs_Vsbulk_si+((2.0*qdeff_Vsbulk_si)))+(((((0.5*(((1.2*qs_Vsbulk_si))+((0.8*qdeff_Vsbulk_si)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsbulk_si))))+T2_Vsbulk_si*((qs_Vsi_bi+(2.0*qdeff_Vsi_bi))+(((0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi)))+T2*(+(+qs_Vsi_bi_Vsbulk_si+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vsbulk_si))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vsbulk_si))+((0.8*qdeff_Vsbulk_si)))+0.0*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsi_bi+1.2*qs_Vsi_bi_Vsbulk_si))+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vsi_bi+0.8*qdeff_Vsi_bi_Vsbulk_si)))*T3+(0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3_Vsbulk_si+((0.5*(((1.2*qs_Vsbulk_si))+((0.8*qdeff_Vsbulk_si)))))*T3_Vsi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi_Vsbulk_si)));
  Qd_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vsi_bi*((qs_Vgi_bi+((2.0*qdeff_Vgi_bi)))+(((((0.5*(((1.2*qs_Vgi_bi))+((0.8*qdeff_Vgi_bi)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vgi_bi))))+T2_Vgi_bi*((qs_Vsi_bi+(2.0*qdeff_Vsi_bi))+(((0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi)))+T2*(+(+qs_Vsi_bi_Vgi_bi+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vgi_bi))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vgi_bi))+((0.8*qdeff_Vgi_bi)))+0.0*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsi_bi+1.2*qs_Vsi_bi_Vgi_bi))+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vsi_bi+0.8*qdeff_Vsi_bi_Vgi_bi)))*T3+(0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3_Vgi_bi+((0.5*(((1.2*qs_Vgi_bi))+((0.8*qdeff_Vgi_bi)))))*T3_Vsi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi_Vgi_bi)));
  Qd_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vsi_bi*((qs_Vdi_bi+((2.0*qdeff_Vdi_bi)))+(((((0.5*(((1.2*qs_Vdi_bi))+((0.8*qdeff_Vdi_bi)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vdi_bi))))+T2_Vdi_bi*((qs_Vsi_bi+(2.0*qdeff_Vsi_bi))+(((0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi)))+T2*(+(+qs_Vsi_bi_Vdi_bi+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vdi_bi))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vdi_bi))+((0.8*qdeff_Vdi_bi)))+0.0*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsi_bi+1.2*qs_Vsi_bi_Vdi_bi))+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vsi_bi+0.8*qdeff_Vsi_bi_Vdi_bi)))*T3+(0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3_Vdi_bi+((0.5*(((1.2*qs_Vdi_bi))+((0.8*qdeff_Vdi_bi)))))*T3_Vsi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi_Vdi_bi)));
  Qd_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vsi_bi*((qs_Vsi_bi+((2.0*qdeff_Vsi_bi)))+(((((0.5*(((1.2*qs_Vsi_bi))+((0.8*qdeff_Vsi_bi)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi))))+T2_Vsi_bi*((qs_Vsi_bi+(2.0*qdeff_Vsi_bi))+(((0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi)))+T2*(+(+qs_Vsi_bi_Vsi_bi+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vsi_bi))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Vsi_bi))+((0.8*qdeff_Vsi_bi)))+0.0*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsi_bi+1.2*qs_Vsi_bi_Vsi_bi))+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vsi_bi+0.8*qdeff_Vsi_bi_Vsi_bi)))*T3+(0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3_Vsi_bi+((0.5*(((1.2*qs_Vsi_bi))+((0.8*qdeff_Vsi_bi)))))*T3_Vsi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi_Vsi_bi)));
  Qd_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))+T2_Vsi_bi*((qs_Tempt_GND+((2.0*qdeff_Tempt_GND)))+(((((0.5*(((1.2*qs_Tempt_GND))+((0.8*qdeff_Tempt_GND)))))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Tempt_GND))))+T2_Tempt_GND*((qs_Vsi_bi+(2.0*qdeff_Vsi_bi))+(((0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi)))+T2*(+(+qs_Vsi_bi_Tempt_GND+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Tempt_GND))+(+(+0.0*((1.0+(1.2*qs))+(0.8*qdeff))+0.0*(((1.2*qs_Tempt_GND))+((0.8*qdeff_Tempt_GND)))+0.0*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi))+0.5*(+(+0.0+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsi_bi+1.2*qs_Vsi_bi_Tempt_GND))+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vsi_bi+0.8*qdeff_Vsi_bi_Tempt_GND)))*T3+(0.5*((1.2*qs_Vsi_bi)+(0.8*qdeff_Vsi_bi)))*T3_Tempt_GND+((0.5*(((1.2*qs_Tempt_GND))+((0.8*qdeff_Tempt_GND)))))*T3_Vsi_bi+(0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
Qd_Tempt_GND=((T2_Tempt_GND*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)))+(T2*((qs_Tempt_GND+(2.0*qdeff_Tempt_GND))+(((0.5*((1.2*qs_Tempt_GND)+(0.8*qdeff_Tempt_GND)))*T3)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3_Tempt_GND)))));
#endif
#endif
Qd=(T2*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
EXIT_IF_ISNAN((T2*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3))))
{
double m00_sqrt(d00_sqrt0,(((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
qba_Vdi_bi=(0.5*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))+((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))*d10_sqrt0));
#if defined(_DERIVATE2)
  qba_Vdi_bi_Vdi_bi=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))+(((((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))+((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vdi_bi_Vdi_bi*Qb+nVt_Vdi_bi*Qb_Vdi_bi+nVt_Vdi_bi*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Vdi_bi)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))))+((0.0)*0.1))*((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vdi_bi_Vdi_bi*Qb+nVt_Vdi_bi*Qb_Vdi_bi+nVt_Vdi_bi*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Vdi_bi)-0.0)*(nVt*Qb)+((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))+(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))+(nVt*Qb)*(+(+nVt_Vdi_bi_Vdi_bi*Qb+nVt_Vdi_bi*Qb_Vdi_bi+nVt_Vdi_bi*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qba_Vdi_bi_Vsi_bi=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))+(((((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))+((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vdi_bi_Vsi_bi*Qb+nVt_Vdi_bi*Qb_Vsi_bi+nVt_Vsi_bi*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Vsi_bi)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))))+((0.0)*0.1))*((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vdi_bi_Vsi_bi*Qb+nVt_Vdi_bi*Qb_Vsi_bi+nVt_Vsi_bi*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Vsi_bi)-0.0)*(nVt*Qb)+((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))+(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))+(nVt*Qb)*(+(+nVt_Vdi_bi_Vsi_bi*Qb+nVt_Vdi_bi*Qb_Vsi_bi+nVt_Vsi_bi*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qba_Vdi_bi_Tempt_GND=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))+(((((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))+((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vdi_bi_Tempt_GND*Qb+nVt_Vdi_bi*Qb_Tempt_GND+nVt_Tempt_GND*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Tempt_GND)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND))))))+((0.0)*0.1))*((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vdi_bi_Tempt_GND*Qb+nVt_Vdi_bi*Qb_Tempt_GND+nVt_Tempt_GND*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Tempt_GND)-0.0)*(nVt*Qb)+((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))+(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))+(nVt*Qb)*(+(+nVt_Vdi_bi_Tempt_GND*Qb+nVt_Vdi_bi*Qb_Tempt_GND+nVt_Tempt_GND*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qba_Vdi_bi_Vgi_bi=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))+(((((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))+((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vdi_bi_Vgi_bi*Qb+nVt_Vdi_bi*Qb_Vgi_bi+nVt_Vgi_bi*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Vgi_bi)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))))+((0.0)*0.1))*((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vdi_bi_Vgi_bi*Qb+nVt_Vdi_bi*Qb_Vgi_bi+nVt_Vgi_bi*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Vgi_bi)-0.0)*(nVt*Qb)+((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))+(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))*((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))+(nVt*Qb)*(+(+nVt_Vdi_bi_Vgi_bi*Qb+nVt_Vdi_bi*Qb_Vgi_bi+nVt_Vgi_bi*Qb_Vdi_bi+nVt*Qb_Vdi_bi_Vgi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qba_Vsi_bi=(0.5*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))+((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))*d10_sqrt0));
#if defined(_DERIVATE2)
  qba_Vsi_bi_Vdi_bi=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))+(((((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))+((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vsi_bi_Vdi_bi*Qb+nVt_Vsi_bi*Qb_Vdi_bi+nVt_Vdi_bi*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Vdi_bi)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))))+((0.0)*0.1))*((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vsi_bi_Vdi_bi*Qb+nVt_Vsi_bi*Qb_Vdi_bi+nVt_Vdi_bi*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Vdi_bi)-0.0)*(nVt*Qb)+((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))+(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))+(nVt*Qb)*(+(+nVt_Vsi_bi_Vdi_bi*Qb+nVt_Vsi_bi*Qb_Vdi_bi+nVt_Vdi_bi*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qba_Vsi_bi_Vsi_bi=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))+(((((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))+((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vsi_bi_Vsi_bi*Qb+nVt_Vsi_bi*Qb_Vsi_bi+nVt_Vsi_bi*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Vsi_bi)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))))+((0.0)*0.1))*((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vsi_bi_Vsi_bi*Qb+nVt_Vsi_bi*Qb_Vsi_bi+nVt_Vsi_bi*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Vsi_bi)-0.0)*(nVt*Qb)+((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))+(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))+(nVt*Qb)*(+(+nVt_Vsi_bi_Vsi_bi*Qb+nVt_Vsi_bi*Qb_Vsi_bi+nVt_Vsi_bi*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qba_Vsi_bi_Tempt_GND=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))+(((((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))+((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vsi_bi_Tempt_GND*Qb+nVt_Vsi_bi*Qb_Tempt_GND+nVt_Tempt_GND*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Tempt_GND)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND))))))+((0.0)*0.1))*((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vsi_bi_Tempt_GND*Qb+nVt_Vsi_bi*Qb_Tempt_GND+nVt_Tempt_GND*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Tempt_GND)-0.0)*(nVt*Qb)+((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))+(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))+(nVt*Qb)*(+(+nVt_Vsi_bi_Tempt_GND*Qb+nVt_Vsi_bi*Qb_Tempt_GND+nVt_Tempt_GND*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qba_Vsi_bi_Vgi_bi=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))+(((((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))+((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vsi_bi_Vgi_bi*Qb+nVt_Vsi_bi*Qb_Vgi_bi+nVt_Vgi_bi*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Vgi_bi)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))))+((0.0)*0.1))*((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vsi_bi_Vgi_bi*Qb+nVt_Vsi_bi*Qb_Vgi_bi+nVt_Vgi_bi*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Vgi_bi)-0.0)*(nVt*Qb)+((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))+(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))*((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))+(nVt*Qb)*(+(+nVt_Vsi_bi_Vgi_bi*Qb+nVt_Vsi_bi*Qb_Vgi_bi+nVt_Vgi_bi*Qb_Vsi_bi+nVt*Qb_Vsi_bi_Vgi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
#if defined(_DERIVATE)
qba_Tempt_GND=(0.5*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND))+((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND))*(nVt*Qb))+((nVt*Qb)*((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND))))*d10_sqrt0));
#endif
qba_Vgi_bi=(0.5*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))+((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))*d10_sqrt0));
#if defined(_DERIVATE2)
  qba_Vgi_bi_Vdi_bi=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))+(((((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))+((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vgi_bi_Vdi_bi*Qb+nVt_Vgi_bi*Qb_Vdi_bi+nVt_Vdi_bi*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Vdi_bi)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi))))))+((0.0)*0.1))*((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vgi_bi_Vdi_bi*Qb+nVt_Vgi_bi*Qb_Vdi_bi+nVt_Vdi_bi*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Vdi_bi)-0.0)*(nVt*Qb)+((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))+(((nVt_Vdi_bi*Qb)+(nVt*Qb_Vdi_bi)))*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))+(nVt*Qb)*(+(+nVt_Vgi_bi_Vdi_bi*Qb+nVt_Vgi_bi*Qb_Vdi_bi+nVt_Vdi_bi*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qba_Vgi_bi_Vsi_bi=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))+(((((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))+((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vgi_bi_Vsi_bi*Qb+nVt_Vgi_bi*Qb_Vsi_bi+nVt_Vsi_bi*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Vsi_bi)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi))))))+((0.0)*0.1))*((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vgi_bi_Vsi_bi*Qb+nVt_Vgi_bi*Qb_Vsi_bi+nVt_Vsi_bi*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Vsi_bi)-0.0)*(nVt*Qb)+((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))+(((nVt_Vsi_bi*Qb)+(nVt*Qb_Vsi_bi)))*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))+(nVt*Qb)*(+(+nVt_Vgi_bi_Vsi_bi*Qb+nVt_Vgi_bi*Qb_Vsi_bi+nVt_Vsi_bi*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qba_Vgi_bi_Tempt_GND=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))+(((((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))+((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vgi_bi_Tempt_GND*Qb+nVt_Vgi_bi*Qb_Tempt_GND+nVt_Tempt_GND*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Tempt_GND)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND))))))+((0.0)*0.1))*((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vgi_bi_Tempt_GND*Qb+nVt_Vgi_bi*Qb_Tempt_GND+nVt_Tempt_GND*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Tempt_GND)-0.0)*(nVt*Qb)+((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))+(((nVt_Tempt_GND*Qb)+(nVt*Qb_Tempt_GND)))*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))+(nVt*Qb)*(+(+nVt_Vgi_bi_Tempt_GND*Qb+nVt_Vgi_bi*Qb_Tempt_GND+nVt_Tempt_GND*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qba_Vgi_bi_Vgi_bi=(+0.0*((nVt*Qb)+d00_sqrt0)+0.0*((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))+(((((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))))+((0.0)*0.1))*d10_sqrt0)+0.0*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))+((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))*d10_sqrt0)+0.5*(+(+(+nVt_Vgi_bi_Vgi_bi*Qb+nVt_Vgi_bi*Qb_Vgi_bi+nVt_Vgi_bi*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Vgi_bi)+0.0)+(m20_sqrt((((nVt*Qb)*(nVt*Qb))+((0.25*0.1)*0.1)))*(((((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))*(nVt*Qb))+((nVt*Qb)*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))))+((0.0)*0.1))*((((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(nVt*Qb))+((nVt*Qb)*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))))+d10_sqrt0*(+(+(+(+nVt_Vgi_bi_Vgi_bi*Qb+nVt_Vgi_bi*Qb_Vgi_bi+nVt_Vgi_bi*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Vgi_bi)-0.0)*(nVt*Qb)+((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))*(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))+(((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi)))*((nVt_Vgi_bi*Qb)+(nVt*Qb_Vgi_bi))+(nVt*Qb)*(+(+nVt_Vgi_bi_Vgi_bi*Qb+nVt_Vgi_bi*Qb_Vgi_bi+nVt_Vgi_bi*Qb_Vgi_bi+nVt*Qb_Vgi_bi_Vgi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
#endif
qba=(0.5*((nVt*Qb)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((nVt*Qb)+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
qia_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  qia_Vdbulk_di_Vdbulk_di=0.0;
  qia_Vdbulk_di_Vsbulk_si=0.0;
  qia_Vdbulk_di_Vdi_bi=0.0;
  qia_Vdbulk_di_Vsi_bi=0.0;
  qia_Vdbulk_di_Tempt_GND=0.0;
  qia_Vdbulk_di_Vgi_bi=0.0;
#endif
qia_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  qia_Vsbulk_si_Vdbulk_di=0.0;
  qia_Vsbulk_si_Vsbulk_si=0.0;
  qia_Vsbulk_si_Vdi_bi=0.0;
  qia_Vsbulk_si_Vsi_bi=0.0;
  qia_Vsbulk_si_Tempt_GND=0.0;
  qia_Vsbulk_si_Vgi_bi=0.0;
#endif
qia_Vdi_bi=((nVt_Vdi_bi*(Qs+Qd))+(nVt*(Qs_Vdi_bi+Qd_Vdi_bi)));
#if defined(_DERIVATE2)
  qia_Vdi_bi_Vdbulk_di=(+nVt_Vdi_bi_Vdbulk_di*(Qs+Qd)+nVt_Vdi_bi*(Qs_Vdbulk_di+Qd_Vdbulk_di)+nVt_Vdbulk_di*(Qs_Vdi_bi+Qd_Vdi_bi)+nVt*(+Qs_Vdi_bi_Vdbulk_di+Qd_Vdi_bi_Vdbulk_di));
  qia_Vdi_bi_Vsbulk_si=(+nVt_Vdi_bi_Vsbulk_si*(Qs+Qd)+nVt_Vdi_bi*(Qs_Vsbulk_si+Qd_Vsbulk_si)+nVt_Vsbulk_si*(Qs_Vdi_bi+Qd_Vdi_bi)+nVt*(+Qs_Vdi_bi_Vsbulk_si+Qd_Vdi_bi_Vsbulk_si));
  qia_Vdi_bi_Vdi_bi=(+nVt_Vdi_bi_Vdi_bi*(Qs+Qd)+nVt_Vdi_bi*(Qs_Vdi_bi+Qd_Vdi_bi)+nVt_Vdi_bi*(Qs_Vdi_bi+Qd_Vdi_bi)+nVt*(+Qs_Vdi_bi_Vdi_bi+Qd_Vdi_bi_Vdi_bi));
  qia_Vdi_bi_Vsi_bi=(+nVt_Vdi_bi_Vsi_bi*(Qs+Qd)+nVt_Vdi_bi*(Qs_Vsi_bi+Qd_Vsi_bi)+nVt_Vsi_bi*(Qs_Vdi_bi+Qd_Vdi_bi)+nVt*(+Qs_Vdi_bi_Vsi_bi+Qd_Vdi_bi_Vsi_bi));
  qia_Vdi_bi_Tempt_GND=(+nVt_Vdi_bi_Tempt_GND*(Qs+Qd)+nVt_Vdi_bi*(Qs_Tempt_GND+Qd_Tempt_GND)+nVt_Tempt_GND*(Qs_Vdi_bi+Qd_Vdi_bi)+nVt*(+Qs_Vdi_bi_Tempt_GND+Qd_Vdi_bi_Tempt_GND));
  qia_Vdi_bi_Vgi_bi=(+nVt_Vdi_bi_Vgi_bi*(Qs+Qd)+nVt_Vdi_bi*(Qs_Vgi_bi+Qd_Vgi_bi)+nVt_Vgi_bi*(Qs_Vdi_bi+Qd_Vdi_bi)+nVt*(+Qs_Vdi_bi_Vgi_bi+Qd_Vdi_bi_Vgi_bi));
#endif
qia_Vsi_bi=((nVt_Vsi_bi*(Qs+Qd))+(nVt*(Qs_Vsi_bi+Qd_Vsi_bi)));
#if defined(_DERIVATE2)
  qia_Vsi_bi_Vdbulk_di=(+nVt_Vsi_bi_Vdbulk_di*(Qs+Qd)+nVt_Vsi_bi*(Qs_Vdbulk_di+Qd_Vdbulk_di)+nVt_Vdbulk_di*(Qs_Vsi_bi+Qd_Vsi_bi)+nVt*(+Qs_Vsi_bi_Vdbulk_di+Qd_Vsi_bi_Vdbulk_di));
  qia_Vsi_bi_Vsbulk_si=(+nVt_Vsi_bi_Vsbulk_si*(Qs+Qd)+nVt_Vsi_bi*(Qs_Vsbulk_si+Qd_Vsbulk_si)+nVt_Vsbulk_si*(Qs_Vsi_bi+Qd_Vsi_bi)+nVt*(+Qs_Vsi_bi_Vsbulk_si+Qd_Vsi_bi_Vsbulk_si));
  qia_Vsi_bi_Vdi_bi=(+nVt_Vsi_bi_Vdi_bi*(Qs+Qd)+nVt_Vsi_bi*(Qs_Vdi_bi+Qd_Vdi_bi)+nVt_Vdi_bi*(Qs_Vsi_bi+Qd_Vsi_bi)+nVt*(+Qs_Vsi_bi_Vdi_bi+Qd_Vsi_bi_Vdi_bi));
  qia_Vsi_bi_Vsi_bi=(+nVt_Vsi_bi_Vsi_bi*(Qs+Qd)+nVt_Vsi_bi*(Qs_Vsi_bi+Qd_Vsi_bi)+nVt_Vsi_bi*(Qs_Vsi_bi+Qd_Vsi_bi)+nVt*(+Qs_Vsi_bi_Vsi_bi+Qd_Vsi_bi_Vsi_bi));
  qia_Vsi_bi_Tempt_GND=(+nVt_Vsi_bi_Tempt_GND*(Qs+Qd)+nVt_Vsi_bi*(Qs_Tempt_GND+Qd_Tempt_GND)+nVt_Tempt_GND*(Qs_Vsi_bi+Qd_Vsi_bi)+nVt*(+Qs_Vsi_bi_Tempt_GND+Qd_Vsi_bi_Tempt_GND));
  qia_Vsi_bi_Vgi_bi=(+nVt_Vsi_bi_Vgi_bi*(Qs+Qd)+nVt_Vsi_bi*(Qs_Vgi_bi+Qd_Vgi_bi)+nVt_Vgi_bi*(Qs_Vsi_bi+Qd_Vsi_bi)+nVt*(+Qs_Vsi_bi_Vgi_bi+Qd_Vsi_bi_Vgi_bi));
#endif
#if defined(_DERIVATE)
qia_Tempt_GND=((nVt_Tempt_GND*(Qs+Qd))+(nVt*(Qs_Tempt_GND+Qd_Tempt_GND)));
#endif
qia_Vgi_bi=((nVt_Vgi_bi*(Qs+Qd))+(nVt*(Qs_Vgi_bi+Qd_Vgi_bi)));
#if defined(_DERIVATE2)
  qia_Vgi_bi_Vdbulk_di=(+nVt_Vgi_bi_Vdbulk_di*(Qs+Qd)+nVt_Vgi_bi*(Qs_Vdbulk_di+Qd_Vdbulk_di)+nVt_Vdbulk_di*(Qs_Vgi_bi+Qd_Vgi_bi)+nVt*(+Qs_Vgi_bi_Vdbulk_di+Qd_Vgi_bi_Vdbulk_di));
  qia_Vgi_bi_Vsbulk_si=(+nVt_Vgi_bi_Vsbulk_si*(Qs+Qd)+nVt_Vgi_bi*(Qs_Vsbulk_si+Qd_Vsbulk_si)+nVt_Vsbulk_si*(Qs_Vgi_bi+Qd_Vgi_bi)+nVt*(+Qs_Vgi_bi_Vsbulk_si+Qd_Vgi_bi_Vsbulk_si));
  qia_Vgi_bi_Vdi_bi=(+nVt_Vgi_bi_Vdi_bi*(Qs+Qd)+nVt_Vgi_bi*(Qs_Vdi_bi+Qd_Vdi_bi)+nVt_Vdi_bi*(Qs_Vgi_bi+Qd_Vgi_bi)+nVt*(+Qs_Vgi_bi_Vdi_bi+Qd_Vgi_bi_Vdi_bi));
  qia_Vgi_bi_Vsi_bi=(+nVt_Vgi_bi_Vsi_bi*(Qs+Qd)+nVt_Vgi_bi*(Qs_Vsi_bi+Qd_Vsi_bi)+nVt_Vsi_bi*(Qs_Vgi_bi+Qd_Vgi_bi)+nVt*(+Qs_Vgi_bi_Vsi_bi+Qd_Vgi_bi_Vsi_bi));
  qia_Vgi_bi_Tempt_GND=(+nVt_Vgi_bi_Tempt_GND*(Qs+Qd)+nVt_Vgi_bi*(Qs_Tempt_GND+Qd_Tempt_GND)+nVt_Tempt_GND*(Qs_Vgi_bi+Qd_Vgi_bi)+nVt*(+Qs_Vgi_bi_Tempt_GND+Qd_Vgi_bi_Tempt_GND));
  qia_Vgi_bi_Vgi_bi=(+nVt_Vgi_bi_Vgi_bi*(Qs+Qd)+nVt_Vgi_bi*(Qs_Vgi_bi+Qd_Vgi_bi)+nVt_Vgi_bi*(Qs_Vgi_bi+Qd_Vgi_bi)+nVt*(+Qs_Vgi_bi_Vgi_bi+Qd_Vgi_bi_Vgi_bi));
#endif
#endif
qia=(nVt*(Qs+Qd));
EXIT_IF_ISNAN((nVt*(Qs+Qd)))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
Eeffm_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Eeffm_Vdbulk_di_Vdbulk_di=0.0;
  Eeffm_Vdbulk_di_Vsbulk_si=0.0;
  Eeffm_Vdbulk_di_Vdi_bi=0.0;
  Eeffm_Vdbulk_di_Vsi_bi=0.0;
  Eeffm_Vdbulk_di_Tempt_GND=0.0;
  Eeffm_Vdbulk_di_Vgi_bi=0.0;
#endif
Eeffm_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Eeffm_Vsbulk_si_Vdbulk_di=0.0;
  Eeffm_Vsbulk_si_Vsbulk_si=0.0;
  Eeffm_Vsbulk_si_Vdi_bi=0.0;
  Eeffm_Vsbulk_si_Vsi_bi=0.0;
  Eeffm_Vsbulk_si_Tempt_GND=0.0;
  Eeffm_Vsbulk_si_Vgi_bi=0.0;
#endif
Eeffm_Vdi_bi=(EeffFactor*(qba_Vdi_bi+(eta_mu*qia_Vdi_bi)));
#if defined(_DERIVATE2)
  Eeffm_Vdi_bi_Vdbulk_di=(+0.0*(qba+(eta_mu*qia))+0.0*((eta_mu*qia_Vdbulk_di))+0.0*(qba_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+0.0+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vdbulk_di)));
  Eeffm_Vdi_bi_Vsbulk_si=(+0.0*(qba+(eta_mu*qia))+0.0*((eta_mu*qia_Vsbulk_si))+0.0*(qba_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+0.0+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vsbulk_si)));
  Eeffm_Vdi_bi_Vdi_bi=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Vdi_bi+((eta_mu*qia_Vdi_bi)))+0.0*(qba_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qba_Vdi_bi_Vdi_bi+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vdi_bi)));
  Eeffm_Vdi_bi_Vsi_bi=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Vsi_bi+((eta_mu*qia_Vsi_bi)))+0.0*(qba_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qba_Vdi_bi_Vsi_bi+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vsi_bi)));
  Eeffm_Vdi_bi_Tempt_GND=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Tempt_GND+((eta_mu*qia_Tempt_GND)))+0.0*(qba_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qba_Vdi_bi_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Tempt_GND)));
  Eeffm_Vdi_bi_Vgi_bi=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Vgi_bi+((eta_mu*qia_Vgi_bi)))+0.0*(qba_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qba_Vdi_bi_Vgi_bi+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vgi_bi)));
#endif
Eeffm_Vsi_bi=(EeffFactor*(qba_Vsi_bi+(eta_mu*qia_Vsi_bi)));
#if defined(_DERIVATE2)
  Eeffm_Vsi_bi_Vdbulk_di=(+0.0*(qba+(eta_mu*qia))+0.0*((eta_mu*qia_Vdbulk_di))+0.0*(qba_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+0.0+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vdbulk_di)));
  Eeffm_Vsi_bi_Vsbulk_si=(+0.0*(qba+(eta_mu*qia))+0.0*((eta_mu*qia_Vsbulk_si))+0.0*(qba_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+0.0+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vsbulk_si)));
  Eeffm_Vsi_bi_Vdi_bi=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Vdi_bi+((eta_mu*qia_Vdi_bi)))+0.0*(qba_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qba_Vsi_bi_Vdi_bi+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vdi_bi)));
  Eeffm_Vsi_bi_Vsi_bi=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Vsi_bi+((eta_mu*qia_Vsi_bi)))+0.0*(qba_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qba_Vsi_bi_Vsi_bi+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vsi_bi)));
  Eeffm_Vsi_bi_Tempt_GND=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Tempt_GND+((eta_mu*qia_Tempt_GND)))+0.0*(qba_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qba_Vsi_bi_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Tempt_GND)));
  Eeffm_Vsi_bi_Vgi_bi=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Vgi_bi+((eta_mu*qia_Vgi_bi)))+0.0*(qba_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qba_Vsi_bi_Vgi_bi+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vgi_bi)));
#endif
#if defined(_DERIVATE)
Eeffm_Tempt_GND=(EeffFactor*(qba_Tempt_GND+(eta_mu*qia_Tempt_GND)));
#endif
Eeffm_Vgi_bi=(EeffFactor*(qba_Vgi_bi+(eta_mu*qia_Vgi_bi)));
#if defined(_DERIVATE2)
  Eeffm_Vgi_bi_Vdbulk_di=(+0.0*(qba+(eta_mu*qia))+0.0*((eta_mu*qia_Vdbulk_di))+0.0*(qba_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+0.0+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vdbulk_di)));
  Eeffm_Vgi_bi_Vsbulk_si=(+0.0*(qba+(eta_mu*qia))+0.0*((eta_mu*qia_Vsbulk_si))+0.0*(qba_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+0.0+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vsbulk_si)));
  Eeffm_Vgi_bi_Vdi_bi=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Vdi_bi+((eta_mu*qia_Vdi_bi)))+0.0*(qba_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qba_Vgi_bi_Vdi_bi+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vdi_bi)));
  Eeffm_Vgi_bi_Vsi_bi=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Vsi_bi+((eta_mu*qia_Vsi_bi)))+0.0*(qba_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qba_Vgi_bi_Vsi_bi+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vsi_bi)));
  Eeffm_Vgi_bi_Tempt_GND=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Tempt_GND+((eta_mu*qia_Tempt_GND)))+0.0*(qba_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qba_Vgi_bi_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Tempt_GND)));
  Eeffm_Vgi_bi_Vgi_bi=(+0.0*(qba+(eta_mu*qia))+0.0*(qba_Vgi_bi+((eta_mu*qia_Vgi_bi)))+0.0*(qba_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qba_Vgi_bi_Vgi_bi+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vgi_bi)));
#endif
#endif
Eeffm=(EeffFactor*(qba+(eta_mu*qia)));
EXIT_IF_ISNAN((EeffFactor*(qba+(eta_mu*qia))))
{
double m00_pow(d00_pow0,(0.5*(1.0+(qia/qba))),UCS_a)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(0.5*(1.0+(qia/qba))),UCS_a)
double m11_pow(d11_pow0,d00_pow0,(0.5*(1.0+(qia/qba))),UCS_a)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(d10_pow0*(0.5*((qia_Vgi_bi*qba-qia*qba_Vgi_bi)/qba/qba)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=fixme;
  T2_Vgi_bi_Vgm_si=fixme;
  T2_Vgi_bi_Vdbulk_di=fixme;
  T2_Vgi_bi_Vsbulk_si=fixme;
  T2_Vgi_bi_Vgi_bi=fixme;
  T2_Vgi_bi_Vdi_bi=fixme;
  T2_Vgi_bi_Vsi_bi=fixme;
  T2_Vgi_bi_Tempt_GND=fixme;
#endif
T2_Vdi_bi=(d10_pow0*(0.5*((qia_Vdi_bi*qba-qia*qba_Vdi_bi)/qba/qba))+d11_pow0*UCS_a_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=fixme;
  T2_Vdi_bi_Vgm_si=fixme;
  T2_Vdi_bi_Vdbulk_di=fixme;
  T2_Vdi_bi_Vsbulk_si=fixme;
  T2_Vdi_bi_Vgi_bi=fixme;
  T2_Vdi_bi_Vdi_bi=fixme;
  T2_Vdi_bi_Vsi_bi=fixme;
  T2_Vdi_bi_Tempt_GND=fixme;
#endif
T2_Vsi_bi=(d10_pow0*(0.5*((qia_Vsi_bi*qba-qia*qba_Vsi_bi)/qba/qba))+d11_pow0*UCS_a_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=fixme;
  T2_Vsi_bi_Vgm_si=fixme;
  T2_Vsi_bi_Vdbulk_di=fixme;
  T2_Vsi_bi_Vsbulk_si=fixme;
  T2_Vsi_bi_Vgi_bi=fixme;
  T2_Vsi_bi_Vdi_bi=fixme;
  T2_Vsi_bi_Vsi_bi=fixme;
  T2_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(d10_pow0*(0.5*((qia_Tempt_GND*qba-qia*qba_Tempt_GND)/qba/qba))+d11_pow0*UCS_a_Tempt_GND);
#endif
#endif
T2=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,Eeffm,EU_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,Eeffm,EU_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Vgi_bi))+(-UD_a*T2_Vgi_bi/T2/T2));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vgm_si+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vgm_si)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vgi_bi_Vgm_di=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vgm_di+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vgm_di)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vgi_bi_Vdbulk_di=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vdbulk_di)+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vgi_bi_Vsbulk_si=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vsbulk_si)+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vgi_bi_Vgi_bi=(+(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vgi_bi)+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vgi_bi)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vgi_bi_Vdi_bi=(+(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+UC_a_Vdi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vdi_bi+UD_a_Vdi_bi*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vdi_bi)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vgi_bi_Vsi_bi=(+(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+UC_a_Vsi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Vsi_bi+UD_a_Vsi_bi*T2_Vgi_bi+UD_a*T2_Vgi_bi_Vsi_bi)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vgi_bi_Tempt_GND=(+(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vgi_bi+UD_a*T2_Vgi_bi_Tempt_GND)/T2/T2+2*UD_a*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vdi_bi=((((UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Vdi_bi)))+((UD_a_Vdi_bi*T2-UD_a*T2_Vdi_bi)/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*0.0+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vgm_si+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vgm_si)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vdi_bi_Vgm_di=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*0.0+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vgm_di+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vgm_di)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vdi_bi_Vdbulk_di=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vdbulk_di)+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vdbulk_di+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vdi_bi_Vsbulk_si=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vsbulk_si)+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vsbulk_si+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vdi_bi_Vgi_bi=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vgi_bi)+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vdi_bi*T2_Vgi_bi+0.0*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vgi_bi)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vdi_bi_Vdi_bi=(+(+(+UA_a_Vdi_bi_Vdi_bi+(+UC_a_Vdi_bi_Vdi_bi*Vbsx+UC_a_Vdi_bi*Vbsx_Vdi_bi+UC_a_Vdi_bi*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Vdi_bi))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vdi_bi_Vdi_bi/T2-(UD_a_Vdi_bi*T2_Vdi_bi+UD_a_Vdi_bi*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vdi_bi)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vdi_bi_Vsi_bi=(+(+(+UA_a_Vdi_bi_Vsi_bi+(+UC_a_Vdi_bi_Vsi_bi*Vbsx+UC_a_Vdi_bi*Vbsx_Vsi_bi+UC_a_Vsi_bi*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Vsi_bi))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vdi_bi_Vsi_bi/T2-(UD_a_Vdi_bi*T2_Vsi_bi+UD_a_Vsi_bi*T2_Vdi_bi+UD_a*T2_Vdi_bi_Vsi_bi)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vdi_bi_Tempt_GND=(+(+(+UA_a_Vdi_bi_Tempt_GND+(+UC_a_Vdi_bi_Tempt_GND*Vbsx+UC_a_Vdi_bi*Vbsx_Tempt_GND+UC_a_Tempt_GND*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Tempt_GND))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vdi_bi_Tempt_GND/T2-(UD_a_Vdi_bi*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vdi_bi+UD_a*T2_Vdi_bi_Tempt_GND)/T2/T2+2*UD_a*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vsi_bi=((((UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Vsi_bi)))+((UD_a_Vsi_bi*T2-UD_a*T2_Vsi_bi)/T2/T2));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*0.0+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vgm_si+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vgm_si)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vgm_si/T2/T2/T2));
  T3_Vsi_bi_Vgm_di=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*0.0+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vgm_di+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vgm_di)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vgm_di/T2/T2/T2));
  T3_Vsi_bi_Vdbulk_di=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vdbulk_di)+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vdbulk_di+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2));
  T3_Vsi_bi_Vsbulk_si=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vsbulk_si)+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vsbulk_si+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2));
  T3_Vsi_bi_Vgi_bi=(+(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vgi_bi)+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(0.0/T2-(UD_a_Vsi_bi*T2_Vgi_bi+0.0*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vgi_bi)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2));
  T3_Vsi_bi_Vdi_bi=(+(+(+UA_a_Vsi_bi_Vdi_bi+(+UC_a_Vsi_bi_Vdi_bi*Vbsx+UC_a_Vsi_bi*Vbsx_Vdi_bi+UC_a_Vdi_bi*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Vdi_bi))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vsi_bi_Vdi_bi/T2-(UD_a_Vsi_bi*T2_Vdi_bi+UD_a_Vdi_bi*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vdi_bi)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2));
  T3_Vsi_bi_Vsi_bi=(+(+(+UA_a_Vsi_bi_Vsi_bi+(+UC_a_Vsi_bi_Vsi_bi*Vbsx+UC_a_Vsi_bi*Vbsx_Vsi_bi+UC_a_Vsi_bi*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Vsi_bi))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vsi_bi_Vsi_bi/T2-(UD_a_Vsi_bi*T2_Vsi_bi+UD_a_Vsi_bi*T2_Vsi_bi+UD_a*T2_Vsi_bi_Vsi_bi)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2));
  T3_Vsi_bi_Tempt_GND=(+(+(+UA_a_Vsi_bi_Tempt_GND+(+UC_a_Vsi_bi_Tempt_GND*Vbsx+UC_a_Vsi_bi*Vbsx_Tempt_GND+UC_a_Tempt_GND*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Tempt_GND))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme)+(UD_a_Vsi_bi_Tempt_GND/T2-(UD_a_Vsi_bi*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vsi_bi+UD_a*T2_Vsi_bi_Tempt_GND)/T2/T2+2*UD_a*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=((((UA_a_Tempt_GND+((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Tempt_GND)))+((UD_a_Tempt_GND*T2-UD_a*T2_Tempt_GND)/T2/T2));
#endif
#endif
T3=(((UA_a+(UC_a*Vbsx))*d00_pow0)+(UD_a/T2));
EXIT_IF_ISNAN((((UA_a+(UC_a*Vbsx))*d00_pow0)+(UD_a/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=T3_Vgi_bi;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+0.0+T3_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+0.0+T3_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+0.0+T3_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+0.0+T3_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+0.0+T3_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+0.0+T3_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+0.0+T3_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+0.0+T3_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=T3_Vdi_bi;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+0.0+T3_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+0.0+T3_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+0.0+T3_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+0.0+T3_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+0.0+T3_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+0.0+T3_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+0.0+T3_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+0.0+T3_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=T3_Vsi_bi;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+0.0+T3_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+0.0+T3_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+0.0+T3_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+0.0+T3_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+0.0+T3_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+0.0+T3_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+0.0+T3_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+0.0+T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=T3_Tempt_GND;
#endif
#endif
T4=(1.0+T3);
EXIT_IF_ISNAN((1.0+T3))
{
double m00_sqrt(d00_sqrt0,(((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
Dmob_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Dmob_Vdbulk_di_Vdbulk_di=0.0;
  Dmob_Vdbulk_di_Vsbulk_si=0.0;
  Dmob_Vdbulk_di_Vgi_bi=0.0;
  Dmob_Vdbulk_di_Vdi_bi=0.0;
  Dmob_Vdbulk_di_Vsi_bi=0.0;
  Dmob_Vdbulk_di_Tempt_GND=0.0;
#endif
Dmob_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Dmob_Vsbulk_si_Vdbulk_di=0.0;
  Dmob_Vsbulk_si_Vsbulk_si=0.0;
  Dmob_Vsbulk_si_Vgi_bi=0.0;
  Dmob_Vsbulk_si_Vdi_bi=0.0;
  Dmob_Vsbulk_si_Vsi_bi=0.0;
  Dmob_Vsbulk_si_Tempt_GND=0.0;
#endif
Dmob_Vgi_bi=(0.5*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmob_Vgi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmob_Vdi_bi=(0.5*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmob_Vdi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmob_Vsi_bi=(0.5*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmob_Vsi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
#if defined(_DERIVATE)
Dmob_Tempt_GND=(0.5*(T4_Tempt_GND+((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND))*d10_sqrt0));
#endif
#endif
Dmob=(0.5*((T4+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T4+1.0)+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Esat_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Esat_Vdbulk_di_Vdbulk_di=0.0;
  Esat_Vdbulk_di_Vsbulk_si=0.0;
  Esat_Vdbulk_di_Tempt_GND=0.0;
  Esat_Vdbulk_di_Vdi_bi=0.0;
  Esat_Vdbulk_di_Vsi_bi=0.0;
  Esat_Vdbulk_di_Vgi_bi=0.0;
#endif
Esat_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Esat_Vsbulk_si_Vdbulk_di=0.0;
  Esat_Vsbulk_si_Vsbulk_si=0.0;
  Esat_Vsbulk_si_Tempt_GND=0.0;
  Esat_Vsbulk_si_Vdi_bi=0.0;
  Esat_Vsbulk_si_Vsi_bi=0.0;
  Esat_Vsbulk_si_Vgi_bi=0.0;
#endif
#if defined(_DERIVATE)
Esat_Tempt_GND=(((2.0*VSAT_a_Tempt_GND)*(U0_a/Dmob)-(2.0*VSAT_a)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
#endif
Esat_Vdi_bi=(((2.0*VSAT_a_Vdi_bi)*(U0_a/Dmob)-(2.0*VSAT_a)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
#if defined(_DERIVATE2)
  Esat_Vdi_bi_Vdbulk_di=((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vdi_bi+2.0*0.0)/(U0_a/Dmob)-((2.0*VSAT_a_Vdi_bi)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(0.0)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(U0_a_Vdi_bi*Dmob_Vdbulk_di+0.0*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Vsbulk_si=((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vdi_bi+2.0*0.0)/(U0_a/Dmob)-((2.0*VSAT_a_Vdi_bi)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(0.0)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(U0_a_Vdi_bi*Dmob_Vsbulk_si+0.0*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Tempt_GND=((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*VSAT_a_Vdi_bi+2.0*VSAT_a_Vdi_bi_Tempt_GND)/(U0_a/Dmob)-((2.0*VSAT_a_Vdi_bi)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+((2.0*VSAT_a_Tempt_GND))*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(U0_a_Vdi_bi_Tempt_GND/Dmob-(U0_a_Vdi_bi*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Tempt_GND/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Vdi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vdi_bi+0.0*VSAT_a_Vdi_bi+2.0*VSAT_a_Vdi_bi_Vdi_bi)/(U0_a/Dmob)-((2.0*VSAT_a_Vdi_bi)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+((2.0*VSAT_a_Vdi_bi))*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(U0_a_Vdi_bi_Vdi_bi/Dmob-(U0_a_Vdi_bi*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vdi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Vsi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vsi_bi+0.0*VSAT_a_Vdi_bi+2.0*VSAT_a_Vdi_bi_Vsi_bi)/(U0_a/Dmob)-((2.0*VSAT_a_Vdi_bi)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+((2.0*VSAT_a_Vsi_bi))*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(U0_a_Vdi_bi_Vsi_bi/Dmob-(U0_a_Vdi_bi*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vsi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Vgi_bi=((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vdi_bi+2.0*0.0)/(U0_a/Dmob)-((2.0*VSAT_a_Vdi_bi)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(0.0)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(U0_a_Vdi_bi*Dmob_Vgi_bi+0.0*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vgi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#endif
Esat_Vsi_bi=(((2.0*VSAT_a_Vsi_bi)*(U0_a/Dmob)-(2.0*VSAT_a)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
#if defined(_DERIVATE2)
  Esat_Vsi_bi_Vdbulk_di=((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vsi_bi+2.0*0.0)/(U0_a/Dmob)-((2.0*VSAT_a_Vsi_bi)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(0.0)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(U0_a_Vsi_bi*Dmob_Vdbulk_di+0.0*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Vsbulk_si=((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vsi_bi+2.0*0.0)/(U0_a/Dmob)-((2.0*VSAT_a_Vsi_bi)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(0.0)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(U0_a_Vsi_bi*Dmob_Vsbulk_si+0.0*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Tempt_GND=((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*VSAT_a_Vsi_bi+2.0*VSAT_a_Vsi_bi_Tempt_GND)/(U0_a/Dmob)-((2.0*VSAT_a_Vsi_bi)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+((2.0*VSAT_a_Tempt_GND))*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(U0_a_Vsi_bi_Tempt_GND/Dmob-(U0_a_Vsi_bi*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Tempt_GND/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Vdi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vdi_bi+0.0*VSAT_a_Vsi_bi+2.0*VSAT_a_Vsi_bi_Vdi_bi)/(U0_a/Dmob)-((2.0*VSAT_a_Vsi_bi)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+((2.0*VSAT_a_Vdi_bi))*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(U0_a_Vsi_bi_Vdi_bi/Dmob-(U0_a_Vsi_bi*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vdi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Vsi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vsi_bi+0.0*VSAT_a_Vsi_bi+2.0*VSAT_a_Vsi_bi_Vsi_bi)/(U0_a/Dmob)-((2.0*VSAT_a_Vsi_bi)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+((2.0*VSAT_a_Vsi_bi))*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(U0_a_Vsi_bi_Vsi_bi/Dmob-(U0_a_Vsi_bi*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vsi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Vgi_bi=((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vsi_bi+2.0*0.0)/(U0_a/Dmob)-((2.0*VSAT_a_Vsi_bi)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(0.0)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(U0_a_Vsi_bi*Dmob_Vgi_bi+0.0*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vgi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#endif
Esat_Vgi_bi=(-(2.0*VSAT_a)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#if defined(_DERIVATE2)
  Esat_Vgi_bi_Vdbulk_di=((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(0.0*Dmob_Vdbulk_di+0.0*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Vsbulk_si=((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(0.0*Dmob_Vsbulk_si+0.0*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Tempt_GND=((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+((2.0*VSAT_a_Tempt_GND))*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(0.0*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Tempt_GND/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Vdi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vdi_bi+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+((2.0*VSAT_a_Vdi_bi))*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(0.0*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vdi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Vsi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vsi_bi+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+((2.0*VSAT_a_Vsi_bi))*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(0.0*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vsi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Vgi_bi=((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSAT_a)*(0.0/Dmob-(0.0*Dmob_Vgi_bi+0.0*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vgi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSAT_a)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#endif
#endif
Esat=((2.0*VSAT_a)/(U0_a/Dmob));
EXIT_IF_ISNAN(((2.0*VSAT_a)/(U0_a/Dmob)))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
EsatL_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  EsatL_Vdbulk_di_Vdbulk_di=0.0;
  EsatL_Vdbulk_di_Vsbulk_si=0.0;
  EsatL_Vdbulk_di_Tempt_GND=0.0;
  EsatL_Vdbulk_di_Vdi_bi=0.0;
  EsatL_Vdbulk_di_Vsi_bi=0.0;
  EsatL_Vdbulk_di_Vgi_bi=0.0;
#endif
EsatL_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  EsatL_Vsbulk_si_Vdbulk_di=0.0;
  EsatL_Vsbulk_si_Vsbulk_si=0.0;
  EsatL_Vsbulk_si_Tempt_GND=0.0;
  EsatL_Vsbulk_si_Vdi_bi=0.0;
  EsatL_Vsbulk_si_Vsi_bi=0.0;
  EsatL_Vsbulk_si_Vgi_bi=0.0;
#endif
#if defined(_DERIVATE)
EsatL_Tempt_GND=Esat_Tempt_GND*Leff;
#endif
EsatL_Vdi_bi=Esat_Vdi_bi*Leff;
#if defined(_DERIVATE2)
  EsatL_Vdi_bi_Vdbulk_di=(+Esat_Vdi_bi_Vdbulk_di*Leff+Esat_Vdi_bi*0.0+Esat_Vdbulk_di*0.0+Esat*0.0);
  EsatL_Vdi_bi_Vsbulk_si=(+Esat_Vdi_bi_Vsbulk_si*Leff+Esat_Vdi_bi*0.0+Esat_Vsbulk_si*0.0+Esat*0.0);
  EsatL_Vdi_bi_Tempt_GND=(+Esat_Vdi_bi_Tempt_GND*Leff+Esat_Vdi_bi*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vdi_bi_Vdi_bi=(+Esat_Vdi_bi_Vdi_bi*Leff+Esat_Vdi_bi*0.0+Esat_Vdi_bi*0.0+Esat*0.0);
  EsatL_Vdi_bi_Vsi_bi=(+Esat_Vdi_bi_Vsi_bi*Leff+Esat_Vdi_bi*0.0+Esat_Vsi_bi*0.0+Esat*0.0);
  EsatL_Vdi_bi_Vgi_bi=(+Esat_Vdi_bi_Vgi_bi*Leff+Esat_Vdi_bi*0.0+Esat_Vgi_bi*0.0+Esat*0.0);
#endif
EsatL_Vsi_bi=Esat_Vsi_bi*Leff;
#if defined(_DERIVATE2)
  EsatL_Vsi_bi_Vdbulk_di=(+Esat_Vsi_bi_Vdbulk_di*Leff+Esat_Vsi_bi*0.0+Esat_Vdbulk_di*0.0+Esat*0.0);
  EsatL_Vsi_bi_Vsbulk_si=(+Esat_Vsi_bi_Vsbulk_si*Leff+Esat_Vsi_bi*0.0+Esat_Vsbulk_si*0.0+Esat*0.0);
  EsatL_Vsi_bi_Tempt_GND=(+Esat_Vsi_bi_Tempt_GND*Leff+Esat_Vsi_bi*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vsi_bi_Vdi_bi=(+Esat_Vsi_bi_Vdi_bi*Leff+Esat_Vsi_bi*0.0+Esat_Vdi_bi*0.0+Esat*0.0);
  EsatL_Vsi_bi_Vsi_bi=(+Esat_Vsi_bi_Vsi_bi*Leff+Esat_Vsi_bi*0.0+Esat_Vsi_bi*0.0+Esat*0.0);
  EsatL_Vsi_bi_Vgi_bi=(+Esat_Vsi_bi_Vgi_bi*Leff+Esat_Vsi_bi*0.0+Esat_Vgi_bi*0.0+Esat*0.0);
#endif
EsatL_Vgi_bi=Esat_Vgi_bi*Leff;
#if defined(_DERIVATE2)
  EsatL_Vgi_bi_Vdbulk_di=(+Esat_Vgi_bi_Vdbulk_di*Leff+Esat_Vgi_bi*0.0+Esat_Vdbulk_di*0.0+Esat*0.0);
  EsatL_Vgi_bi_Vsbulk_si=(+Esat_Vgi_bi_Vsbulk_si*Leff+Esat_Vgi_bi*0.0+Esat_Vsbulk_si*0.0+Esat*0.0);
  EsatL_Vgi_bi_Tempt_GND=(+Esat_Vgi_bi_Tempt_GND*Leff+Esat_Vgi_bi*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vgi_bi_Vdi_bi=(+Esat_Vgi_bi_Vdi_bi*Leff+Esat_Vgi_bi*0.0+Esat_Vdi_bi*0.0+Esat*0.0);
  EsatL_Vgi_bi_Vsi_bi=(+Esat_Vgi_bi_Vsi_bi*Leff+Esat_Vgi_bi*0.0+Esat_Vsi_bi*0.0+Esat*0.0);
  EsatL_Vgi_bi_Vgi_bi=(+Esat_Vgi_bi_Vgi_bi*Leff+Esat_Vgi_bi*0.0+Esat_Vgi_bi*0.0+Esat*0.0);
#endif
#endif
EsatL=(Esat*Leff);
EXIT_IF_ISNAN((Esat*Leff))
if
((PVAG_i>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
PVAGfactor_Vdi_bi=(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL);
#if defined(_DERIVATE2)
  PVAGfactor_Vdi_bi_Vdi_bi=(+0.0+((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vdi_bi+PVAG_i*qia_Vdi_bi_Vdi_bi)/EsatL-((PVAG_i*qia_Vdi_bi)*EsatL_Vdi_bi+((PVAG_i*qia_Vdi_bi))*EsatL_Vdi_bi+(PVAG_i*qia)*EsatL_Vdi_bi_Vdi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL));
  PVAGfactor_Vdi_bi_Vsi_bi=(+0.0+((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vdi_bi+PVAG_i*qia_Vdi_bi_Vsi_bi)/EsatL-((PVAG_i*qia_Vdi_bi)*EsatL_Vsi_bi+((PVAG_i*qia_Vsi_bi))*EsatL_Vdi_bi+(PVAG_i*qia)*EsatL_Vdi_bi_Vsi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL));
  PVAGfactor_Vdi_bi_Tempt_GND=(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_bi+PVAG_i*qia_Vdi_bi_Tempt_GND)/EsatL-((PVAG_i*qia_Vdi_bi)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vdi_bi+(PVAG_i*qia)*EsatL_Vdi_bi_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL));
  PVAGfactor_Vdi_bi_Vgi_bi=(+0.0+((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vdi_bi+PVAG_i*qia_Vdi_bi_Vgi_bi)/EsatL-((PVAG_i*qia_Vdi_bi)*EsatL_Vgi_bi+((PVAG_i*qia_Vgi_bi))*EsatL_Vdi_bi+(PVAG_i*qia)*EsatL_Vdi_bi_Vgi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL));
#endif
PVAGfactor_Vsi_bi=(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL);
#if defined(_DERIVATE2)
  PVAGfactor_Vsi_bi_Vdi_bi=(+0.0+((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vsi_bi+PVAG_i*qia_Vsi_bi_Vdi_bi)/EsatL-((PVAG_i*qia_Vsi_bi)*EsatL_Vdi_bi+((PVAG_i*qia_Vdi_bi))*EsatL_Vsi_bi+(PVAG_i*qia)*EsatL_Vsi_bi_Vdi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vsi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL));
  PVAGfactor_Vsi_bi_Vsi_bi=(+0.0+((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vsi_bi+PVAG_i*qia_Vsi_bi_Vsi_bi)/EsatL-((PVAG_i*qia_Vsi_bi)*EsatL_Vsi_bi+((PVAG_i*qia_Vsi_bi))*EsatL_Vsi_bi+(PVAG_i*qia)*EsatL_Vsi_bi_Vsi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vsi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL));
  PVAGfactor_Vsi_bi_Tempt_GND=(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vsi_bi+PVAG_i*qia_Vsi_bi_Tempt_GND)/EsatL-((PVAG_i*qia_Vsi_bi)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vsi_bi+(PVAG_i*qia)*EsatL_Vsi_bi_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vsi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL));
  PVAGfactor_Vsi_bi_Vgi_bi=(+0.0+((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vsi_bi+PVAG_i*qia_Vsi_bi_Vgi_bi)/EsatL-((PVAG_i*qia_Vsi_bi)*EsatL_Vgi_bi+((PVAG_i*qia_Vgi_bi))*EsatL_Vsi_bi+(PVAG_i*qia)*EsatL_Vsi_bi_Vgi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vsi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL));
#endif
#if defined(_DERIVATE)
PVAGfactor_Tempt_GND=(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL);
#endif
PVAGfactor_Vgi_bi=(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL);
#if defined(_DERIVATE2)
  PVAGfactor_Vgi_bi_Vdi_bi=(+0.0+((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vgi_bi+PVAG_i*qia_Vgi_bi_Vdi_bi)/EsatL-((PVAG_i*qia_Vgi_bi)*EsatL_Vdi_bi+((PVAG_i*qia_Vdi_bi))*EsatL_Vgi_bi+(PVAG_i*qia)*EsatL_Vgi_bi_Vdi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vgi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL));
  PVAGfactor_Vgi_bi_Vsi_bi=(+0.0+((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vgi_bi+PVAG_i*qia_Vgi_bi_Vsi_bi)/EsatL-((PVAG_i*qia_Vgi_bi)*EsatL_Vsi_bi+((PVAG_i*qia_Vsi_bi))*EsatL_Vgi_bi+(PVAG_i*qia)*EsatL_Vgi_bi_Vsi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vgi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL));
  PVAGfactor_Vgi_bi_Tempt_GND=(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vgi_bi+PVAG_i*qia_Vgi_bi_Tempt_GND)/EsatL-((PVAG_i*qia_Vgi_bi)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vgi_bi+(PVAG_i*qia)*EsatL_Vgi_bi_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vgi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL));
  PVAGfactor_Vgi_bi_Vgi_bi=(+0.0+((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vgi_bi+PVAG_i*qia_Vgi_bi_Vgi_bi)/EsatL-((PVAG_i*qia_Vgi_bi)*EsatL_Vgi_bi+((PVAG_i*qia_Vgi_bi))*EsatL_Vgi_bi+(PVAG_i*qia)*EsatL_Vgi_bi_Vgi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vgi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL));
#endif
#endif
PVAGfactor=(1.0+((PVAG_i*qia)/EsatL));
EXIT_IF_ISNAN((1.0+((PVAG_i*qia)/EsatL)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
PVAGfactor_Vdi_bi=(-(-(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#if defined(_DERIVATE2)
  PVAGfactor_Vdi_bi_Vdi_bi=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vdi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vdi_bi+PVAG_i*qia_Vdi_bi_Vdi_bi)/EsatL-((PVAG_i*qia_Vdi_bi)*EsatL_Vdi_bi+((PVAG_i*qia_Vdi_bi))*EsatL_Vdi_bi+(PVAG_i*qia)*EsatL_Vdi_bi_Vdi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Vdi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vdi_bi_Vsi_bi=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vsi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vdi_bi+PVAG_i*qia_Vdi_bi_Vsi_bi)/EsatL-((PVAG_i*qia_Vdi_bi)*EsatL_Vsi_bi+((PVAG_i*qia_Vsi_bi))*EsatL_Vdi_bi+(PVAG_i*qia)*EsatL_Vdi_bi_Vsi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Vsi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vdi_bi_Tempt_GND=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_bi+PVAG_i*qia_Vdi_bi_Tempt_GND)/EsatL-((PVAG_i*qia_Vdi_bi)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vdi_bi+(PVAG_i*qia)*EsatL_Vdi_bi_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vdi_bi_Vgi_bi=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vgi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vdi_bi+PVAG_i*qia_Vdi_bi_Vgi_bi)/EsatL-((PVAG_i*qia_Vdi_bi)*EsatL_Vgi_bi+((PVAG_i*qia_Vgi_bi))*EsatL_Vdi_bi+(PVAG_i*qia)*EsatL_Vdi_bi_Vgi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vdi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Vgi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#endif
PVAGfactor_Vsi_bi=(-(-(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#if defined(_DERIVATE2)
  PVAGfactor_Vsi_bi_Vdi_bi=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vdi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vsi_bi+PVAG_i*qia_Vsi_bi_Vdi_bi)/EsatL-((PVAG_i*qia_Vsi_bi)*EsatL_Vdi_bi+((PVAG_i*qia_Vdi_bi))*EsatL_Vsi_bi+(PVAG_i*qia)*EsatL_Vsi_bi_Vdi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vsi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Vdi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vsi_bi_Vsi_bi=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vsi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vsi_bi+PVAG_i*qia_Vsi_bi_Vsi_bi)/EsatL-((PVAG_i*qia_Vsi_bi)*EsatL_Vsi_bi+((PVAG_i*qia_Vsi_bi))*EsatL_Vsi_bi+(PVAG_i*qia)*EsatL_Vsi_bi_Vsi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vsi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Vsi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vsi_bi_Tempt_GND=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vsi_bi+PVAG_i*qia_Vsi_bi_Tempt_GND)/EsatL-((PVAG_i*qia_Vsi_bi)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vsi_bi+(PVAG_i*qia)*EsatL_Vsi_bi_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vsi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vsi_bi_Vgi_bi=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vgi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vsi_bi+PVAG_i*qia_Vsi_bi_Vgi_bi)/EsatL-((PVAG_i*qia_Vsi_bi)*EsatL_Vgi_bi+((PVAG_i*qia_Vgi_bi))*EsatL_Vsi_bi+(PVAG_i*qia)*EsatL_Vsi_bi_Vgi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vsi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vsi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Vgi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#endif
#if defined(_DERIVATE)
PVAGfactor_Tempt_GND=(-(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#endif
PVAGfactor_Vgi_bi=(-(-(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#if defined(_DERIVATE2)
  PVAGfactor_Vgi_bi_Vdi_bi=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vdi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vgi_bi+PVAG_i*qia_Vgi_bi_Vdi_bi)/EsatL-((PVAG_i*qia_Vgi_bi)*EsatL_Vdi_bi+((PVAG_i*qia_Vdi_bi))*EsatL_Vgi_bi+(PVAG_i*qia)*EsatL_Vgi_bi_Vdi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vgi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Vdi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vdi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vgi_bi_Vsi_bi=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vsi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vgi_bi+PVAG_i*qia_Vgi_bi_Vsi_bi)/EsatL-((PVAG_i*qia_Vgi_bi)*EsatL_Vsi_bi+((PVAG_i*qia_Vsi_bi))*EsatL_Vgi_bi+(PVAG_i*qia)*EsatL_Vgi_bi_Vsi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vgi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Vsi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vsi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vgi_bi_Tempt_GND=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vgi_bi+PVAG_i*qia_Vgi_bi_Tempt_GND)/EsatL-((PVAG_i*qia_Vgi_bi)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vgi_bi+(PVAG_i*qia)*EsatL_Vgi_bi_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vgi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vgi_bi_Vgi_bi=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vgi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vgi_bi+PVAG_i*qia_Vgi_bi_Vgi_bi)/EsatL-((PVAG_i*qia_Vgi_bi)*EsatL_Vgi_bi+((PVAG_i*qia_Vgi_bi))*EsatL_Vgi_bi+(PVAG_i*qia)*EsatL_Vgi_bi_Vgi_bi)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vgi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vgi_bi)*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((PVAG_i*qia_Vgi_bi))*EsatL-(PVAG_i*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#endif
#endif
PVAGfactor=(1.0/(1.0-((PVAG_i*qia)/EsatL)));
EXIT_IF_ISNAN((1.0/(1.0-((PVAG_i*qia)/EsatL))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
DIBLfactor_Vdi_bi=PDIBLC_a_Vdi_bi;
#if defined(_DERIVATE2)
  DIBLfactor_Vdi_bi_Vdi_bi=PDIBLC_a_Vdi_bi_Vdi_bi;
  DIBLfactor_Vdi_bi_Vsi_bi=PDIBLC_a_Vdi_bi_Vsi_bi;
  DIBLfactor_Vdi_bi_Tempt_GND=PDIBLC_a_Vdi_bi_Tempt_GND;
#endif
DIBLfactor_Vsi_bi=PDIBLC_a_Vsi_bi;
#if defined(_DERIVATE2)
  DIBLfactor_Vsi_bi_Vdi_bi=PDIBLC_a_Vsi_bi_Vdi_bi;
  DIBLfactor_Vsi_bi_Vsi_bi=PDIBLC_a_Vsi_bi_Vsi_bi;
  DIBLfactor_Vsi_bi_Tempt_GND=PDIBLC_a_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
DIBLfactor_Tempt_GND=PDIBLC_a_Tempt_GND;
#endif
#endif
DIBLfactor=PDIBLC_a;
EXIT_IF_ISNAN(PDIBLC_a)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
diffVds_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  diffVds_Vdbulk_di_Vdbulk_di=0.0;
  diffVds_Vdbulk_di_Vsbulk_si=0.0;
  diffVds_Vdbulk_di_Vdi_bi=0.0;
  diffVds_Vdbulk_di_Vsi_bi=0.0;
  diffVds_Vdbulk_di_Vgi_bi=0.0;
  diffVds_Vdbulk_di_Tempt_GND=0.0;
#endif
diffVds_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  diffVds_Vsbulk_si_Vdbulk_di=0.0;
  diffVds_Vsbulk_si_Vsbulk_si=0.0;
  diffVds_Vsbulk_si_Vdi_bi=0.0;
  diffVds_Vsbulk_si_Vsi_bi=0.0;
  diffVds_Vsbulk_si_Vgi_bi=0.0;
  diffVds_Vsbulk_si_Tempt_GND=0.0;
#endif
diffVds_Vdi_bi=(Vds_Vdi_bi-Vdseff_Vdi_bi);
#if defined(_DERIVATE2)
  diffVds_Vdi_bi_Vdbulk_di=(+0.0-Vdseff_Vdi_bi_Vdbulk_di);
  diffVds_Vdi_bi_Vsbulk_si=(+0.0-Vdseff_Vdi_bi_Vsbulk_si);
  diffVds_Vdi_bi_Vdi_bi=(+Vds_Vdi_bi_Vdi_bi-Vdseff_Vdi_bi_Vdi_bi);
  diffVds_Vdi_bi_Vsi_bi=(+Vds_Vdi_bi_Vsi_bi-Vdseff_Vdi_bi_Vsi_bi);
  diffVds_Vdi_bi_Vgi_bi=(+0.0-Vdseff_Vdi_bi_Vgi_bi);
  diffVds_Vdi_bi_Tempt_GND=(+0.0-Vdseff_Vdi_bi_Tempt_GND);
#endif
diffVds_Vsi_bi=(Vds_Vsi_bi-Vdseff_Vsi_bi);
#if defined(_DERIVATE2)
  diffVds_Vsi_bi_Vdbulk_di=(+0.0-Vdseff_Vsi_bi_Vdbulk_di);
  diffVds_Vsi_bi_Vsbulk_si=(+0.0-Vdseff_Vsi_bi_Vsbulk_si);
  diffVds_Vsi_bi_Vdi_bi=(+Vds_Vsi_bi_Vdi_bi-Vdseff_Vsi_bi_Vdi_bi);
  diffVds_Vsi_bi_Vsi_bi=(+Vds_Vsi_bi_Vsi_bi-Vdseff_Vsi_bi_Vsi_bi);
  diffVds_Vsi_bi_Vgi_bi=(+0.0-Vdseff_Vsi_bi_Vgi_bi);
  diffVds_Vsi_bi_Tempt_GND=(+0.0-Vdseff_Vsi_bi_Tempt_GND);
#endif
diffVds_Vgi_bi=(-Vdseff_Vgi_bi);
#if defined(_DERIVATE2)
  diffVds_Vgi_bi_Vdbulk_di=(+0.0-Vdseff_Vgi_bi_Vdbulk_di);
  diffVds_Vgi_bi_Vsbulk_si=(+0.0-Vdseff_Vgi_bi_Vsbulk_si);
  diffVds_Vgi_bi_Vdi_bi=(+0.0-Vdseff_Vgi_bi_Vdi_bi);
  diffVds_Vgi_bi_Vsi_bi=(+0.0-Vdseff_Vgi_bi_Vsi_bi);
  diffVds_Vgi_bi_Vgi_bi=(+0.0-Vdseff_Vgi_bi_Vgi_bi);
  diffVds_Vgi_bi_Tempt_GND=(+0.0-Vdseff_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
diffVds_Tempt_GND=(-Vdseff_Tempt_GND);
#endif
#endif
diffVds=(Vds-Vdseff);
EXIT_IF_ISNAN((Vds-Vdseff))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Vgst2Vtm_Vdi_bi=(qia_Vdi_bi+(2.0*nVt_Vdi_bi));
#if defined(_DERIVATE2)
  Vgst2Vtm_Vdi_bi_Vdi_bi=(+qia_Vdi_bi_Vdi_bi+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vdi_bi));
  Vgst2Vtm_Vdi_bi_Vsi_bi=(+qia_Vdi_bi_Vsi_bi+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vsi_bi));
  Vgst2Vtm_Vdi_bi_Tempt_GND=(+qia_Vdi_bi_Tempt_GND+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Tempt_GND));
  Vgst2Vtm_Vdi_bi_Vgi_bi=(+qia_Vdi_bi_Vgi_bi+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vgi_bi));
#endif
Vgst2Vtm_Vsi_bi=(qia_Vsi_bi+(2.0*nVt_Vsi_bi));
#if defined(_DERIVATE2)
  Vgst2Vtm_Vsi_bi_Vdi_bi=(+qia_Vsi_bi_Vdi_bi+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vdi_bi));
  Vgst2Vtm_Vsi_bi_Vsi_bi=(+qia_Vsi_bi_Vsi_bi+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vsi_bi));
  Vgst2Vtm_Vsi_bi_Tempt_GND=(+qia_Vsi_bi_Tempt_GND+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Tempt_GND));
  Vgst2Vtm_Vsi_bi_Vgi_bi=(+qia_Vsi_bi_Vgi_bi+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vgi_bi));
#endif
#if defined(_DERIVATE)
Vgst2Vtm_Tempt_GND=(qia_Tempt_GND+(2.0*nVt_Tempt_GND));
#endif
Vgst2Vtm_Vgi_bi=(qia_Vgi_bi+(2.0*nVt_Vgi_bi));
#if defined(_DERIVATE2)
  Vgst2Vtm_Vgi_bi_Vdi_bi=(+qia_Vgi_bi_Vdi_bi+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vdi_bi));
  Vgst2Vtm_Vgi_bi_Vsi_bi=(+qia_Vgi_bi_Vsi_bi+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vsi_bi));
  Vgst2Vtm_Vgi_bi_Tempt_GND=(+qia_Vgi_bi_Tempt_GND+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Tempt_GND));
  Vgst2Vtm_Vgi_bi_Vgi_bi=(+qia_Vgi_bi_Vgi_bi+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vgi_bi));
#endif
#endif
Vgst2Vtm=(qia+(2.0*nVt));
EXIT_IF_ISNAN((qia+(2.0*nVt)))
if
((DIBLfactor>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=((Vgst2Vtm_Vgi_bi*(Vdssat+Vgst2Vtm)-Vgst2Vtm*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vgi_bi*0.0+0.0*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vgi_bi_Vgm_di=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vgi_bi*0.0+0.0*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vgi_bi_Vdbulk_di=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vgi_bi*0.0+0.0*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vgi_bi_Vsbulk_si=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vgi_bi*0.0+0.0*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vgi_bi_Vgi_bi=(Vgst2Vtm_Vgi_bi_Vgi_bi/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vgi_bi*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm_Vgi_bi*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm*(+Vdssat_Vgi_bi_Vgi_bi+Vgst2Vtm_Vgi_bi_Vgi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vgi_bi_Vdi_bi=(Vgst2Vtm_Vgi_bi_Vdi_bi/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vgi_bi*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm_Vdi_bi*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm*(+Vdssat_Vgi_bi_Vdi_bi+Vgst2Vtm_Vgi_bi_Vdi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vgi_bi_Vsi_bi=(Vgst2Vtm_Vgi_bi_Vsi_bi/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vgi_bi*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm_Vsi_bi*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm*(+Vdssat_Vgi_bi_Vsi_bi+Vgst2Vtm_Vgi_bi_Vsi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vgi_bi_Tempt_GND=(Vgst2Vtm_Vgi_bi_Tempt_GND/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vgi_bi*(Vdssat_Tempt_GND+Vgst2Vtm_Tempt_GND)+Vgst2Vtm_Tempt_GND*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm*(+Vdssat_Vgi_bi_Tempt_GND+Vgst2Vtm_Vgi_bi_Tempt_GND))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)*(Vdssat_Tempt_GND+Vgst2Vtm_Tempt_GND)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
#endif
T3_Vdi_bi=((Vgst2Vtm_Vdi_bi*(Vdssat+Vgst2Vtm)-Vgst2Vtm*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vdi_bi*0.0+0.0*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vdi_bi_Vgm_di=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vdi_bi*0.0+0.0*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vdi_bi_Vdbulk_di=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vdi_bi*0.0+0.0*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vdi_bi_Vsbulk_si=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vdi_bi*0.0+0.0*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vdi_bi_Vgi_bi=(Vgst2Vtm_Vdi_bi_Vgi_bi/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vdi_bi*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm_Vgi_bi*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm*(+Vdssat_Vdi_bi_Vgi_bi+Vgst2Vtm_Vdi_bi_Vgi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vdi_bi_Vdi_bi=(Vgst2Vtm_Vdi_bi_Vdi_bi/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vdi_bi*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm_Vdi_bi*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm*(+Vdssat_Vdi_bi_Vdi_bi+Vgst2Vtm_Vdi_bi_Vdi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vdi_bi_Vsi_bi=(Vgst2Vtm_Vdi_bi_Vsi_bi/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vdi_bi*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm_Vsi_bi*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm*(+Vdssat_Vdi_bi_Vsi_bi+Vgst2Vtm_Vdi_bi_Vsi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vdi_bi_Tempt_GND=(Vgst2Vtm_Vdi_bi_Tempt_GND/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vdi_bi*(Vdssat_Tempt_GND+Vgst2Vtm_Tempt_GND)+Vgst2Vtm_Tempt_GND*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm*(+Vdssat_Vdi_bi_Tempt_GND+Vgst2Vtm_Vdi_bi_Tempt_GND))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)*(Vdssat_Tempt_GND+Vgst2Vtm_Tempt_GND)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
#endif
T3_Vsi_bi=((Vgst2Vtm_Vsi_bi*(Vdssat+Vgst2Vtm)-Vgst2Vtm*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vsi_bi*0.0+0.0*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vsi_bi_Vgm_di=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vsi_bi*0.0+0.0*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vsi_bi_Vdbulk_di=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vsi_bi*0.0+0.0*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vsi_bi_Vsbulk_si=(0.0/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vsi_bi*0.0+0.0*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm*(+0.0+0.0))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)*0.0/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vsi_bi_Vgi_bi=(Vgst2Vtm_Vsi_bi_Vgi_bi/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vsi_bi*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)+Vgst2Vtm_Vgi_bi*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm*(+Vdssat_Vsi_bi_Vgi_bi+Vgst2Vtm_Vsi_bi_Vgi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)*(Vdssat_Vgi_bi+Vgst2Vtm_Vgi_bi)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vsi_bi_Vdi_bi=(Vgst2Vtm_Vsi_bi_Vdi_bi/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vsi_bi*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)+Vgst2Vtm_Vdi_bi*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm*(+Vdssat_Vsi_bi_Vdi_bi+Vgst2Vtm_Vsi_bi_Vdi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)*(Vdssat_Vdi_bi+Vgst2Vtm_Vdi_bi)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vsi_bi_Vsi_bi=(Vgst2Vtm_Vsi_bi_Vsi_bi/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vsi_bi*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm_Vsi_bi*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm*(+Vdssat_Vsi_bi_Vsi_bi+Vgst2Vtm_Vsi_bi_Vsi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
  T3_Vsi_bi_Tempt_GND=(Vgst2Vtm_Vsi_bi_Tempt_GND/(Vdssat+Vgst2Vtm)-(Vgst2Vtm_Vsi_bi*(Vdssat_Tempt_GND+Vgst2Vtm_Tempt_GND)+Vgst2Vtm_Tempt_GND*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)+Vgst2Vtm*(+Vdssat_Vsi_bi_Tempt_GND+Vgst2Vtm_Vsi_bi_Tempt_GND))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)+2*Vgst2Vtm*(Vdssat_Vsi_bi+Vgst2Vtm_Vsi_bi)*(Vdssat_Tempt_GND+Vgst2Vtm_Tempt_GND)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=((Vgst2Vtm_Tempt_GND*(Vdssat+Vgst2Vtm)-Vgst2Vtm*(Vdssat_Tempt_GND+Vgst2Vtm_Tempt_GND))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
#endif
#endif
T3=(Vgst2Vtm/(Vdssat+Vgst2Vtm));
EXIT_IF_ISNAN((Vgst2Vtm/(Vdssat+Vgst2Vtm)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=bsimbulk_d_hypsmooth((1.0+(PDIBLCB_i*Vbsx)),1.0e-3,(PDIBLCB_i*Vbsx_Vdi_bi),0.0);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=bsimbulk_d_hypsmooth((1.0+(PDIBLCB_i*Vbsx)),1.0e-3,(PDIBLCB_i*Vbsx_Vsi_bi),0.0);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=bsimbulk_d_hypsmooth((1.0+(PDIBLCB_i*Vbsx)),1.0e-3,(PDIBLCB_i*Vbsx_Tempt_GND),0.0);
#endif
#endif
T4=bsimbulk_hypsmooth((1.0+(PDIBLCB_i*Vbsx)),1.0e-3);
EXIT_IF_ISNAN(bsimbulk_hypsmooth((1.0+(PDIBLCB_i*Vbsx)),1.0e-3))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=(-T4_Vgi_bi/T4/T4);
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(0.0/T4-(0.0*T4_Vgm_si+0.0*T4_Vgi_bi+1.0*T4_Vgi_bi_Vgm_si)/T4/T4+2*1.0*T4_Vgi_bi*T4_Vgm_si/T4/T4/T4);
  T5_Vgi_bi_Vgm_di=(0.0/T4-(0.0*T4_Vgm_di+0.0*T4_Vgi_bi+1.0*T4_Vgi_bi_Vgm_di)/T4/T4+2*1.0*T4_Vgi_bi*T4_Vgm_di/T4/T4/T4);
  T5_Vgi_bi_Vdbulk_di=(0.0/T4-(0.0*T4_Vdbulk_di+0.0*T4_Vgi_bi+1.0*T4_Vgi_bi_Vdbulk_di)/T4/T4+2*1.0*T4_Vgi_bi*T4_Vdbulk_di/T4/T4/T4);
  T5_Vgi_bi_Vsbulk_si=(0.0/T4-(0.0*T4_Vsbulk_si+0.0*T4_Vgi_bi+1.0*T4_Vgi_bi_Vsbulk_si)/T4/T4+2*1.0*T4_Vgi_bi*T4_Vsbulk_si/T4/T4/T4);
  T5_Vgi_bi_Vgi_bi=(0.0/T4-(0.0*T4_Vgi_bi+0.0*T4_Vgi_bi+1.0*T4_Vgi_bi_Vgi_bi)/T4/T4+2*1.0*T4_Vgi_bi*T4_Vgi_bi/T4/T4/T4);
  T5_Vgi_bi_Vdi_bi=(0.0/T4-(0.0*T4_Vdi_bi+0.0*T4_Vgi_bi+1.0*T4_Vgi_bi_Vdi_bi)/T4/T4+2*1.0*T4_Vgi_bi*T4_Vdi_bi/T4/T4/T4);
  T5_Vgi_bi_Vsi_bi=(0.0/T4-(0.0*T4_Vsi_bi+0.0*T4_Vgi_bi+1.0*T4_Vgi_bi_Vsi_bi)/T4/T4+2*1.0*T4_Vgi_bi*T4_Vsi_bi/T4/T4/T4);
  T5_Vgi_bi_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vgi_bi+1.0*T4_Vgi_bi_Tempt_GND)/T4/T4+2*1.0*T4_Vgi_bi*T4_Tempt_GND/T4/T4/T4);
#endif
T5_Vdi_bi=(-T4_Vdi_bi/T4/T4);
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(0.0/T4-(0.0*T4_Vgm_si+0.0*T4_Vdi_bi+1.0*T4_Vdi_bi_Vgm_si)/T4/T4+2*1.0*T4_Vdi_bi*T4_Vgm_si/T4/T4/T4);
  T5_Vdi_bi_Vgm_di=(0.0/T4-(0.0*T4_Vgm_di+0.0*T4_Vdi_bi+1.0*T4_Vdi_bi_Vgm_di)/T4/T4+2*1.0*T4_Vdi_bi*T4_Vgm_di/T4/T4/T4);
  T5_Vdi_bi_Vdbulk_di=(0.0/T4-(0.0*T4_Vdbulk_di+0.0*T4_Vdi_bi+1.0*T4_Vdi_bi_Vdbulk_di)/T4/T4+2*1.0*T4_Vdi_bi*T4_Vdbulk_di/T4/T4/T4);
  T5_Vdi_bi_Vsbulk_si=(0.0/T4-(0.0*T4_Vsbulk_si+0.0*T4_Vdi_bi+1.0*T4_Vdi_bi_Vsbulk_si)/T4/T4+2*1.0*T4_Vdi_bi*T4_Vsbulk_si/T4/T4/T4);
  T5_Vdi_bi_Vgi_bi=(0.0/T4-(0.0*T4_Vgi_bi+0.0*T4_Vdi_bi+1.0*T4_Vdi_bi_Vgi_bi)/T4/T4+2*1.0*T4_Vdi_bi*T4_Vgi_bi/T4/T4/T4);
  T5_Vdi_bi_Vdi_bi=(0.0/T4-(0.0*T4_Vdi_bi+0.0*T4_Vdi_bi+1.0*T4_Vdi_bi_Vdi_bi)/T4/T4+2*1.0*T4_Vdi_bi*T4_Vdi_bi/T4/T4/T4);
  T5_Vdi_bi_Vsi_bi=(0.0/T4-(0.0*T4_Vsi_bi+0.0*T4_Vdi_bi+1.0*T4_Vdi_bi_Vsi_bi)/T4/T4+2*1.0*T4_Vdi_bi*T4_Vsi_bi/T4/T4/T4);
  T5_Vdi_bi_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vdi_bi+1.0*T4_Vdi_bi_Tempt_GND)/T4/T4+2*1.0*T4_Vdi_bi*T4_Tempt_GND/T4/T4/T4);
#endif
T5_Vsi_bi=(-T4_Vsi_bi/T4/T4);
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(0.0/T4-(0.0*T4_Vgm_si+0.0*T4_Vsi_bi+1.0*T4_Vsi_bi_Vgm_si)/T4/T4+2*1.0*T4_Vsi_bi*T4_Vgm_si/T4/T4/T4);
  T5_Vsi_bi_Vgm_di=(0.0/T4-(0.0*T4_Vgm_di+0.0*T4_Vsi_bi+1.0*T4_Vsi_bi_Vgm_di)/T4/T4+2*1.0*T4_Vsi_bi*T4_Vgm_di/T4/T4/T4);
  T5_Vsi_bi_Vdbulk_di=(0.0/T4-(0.0*T4_Vdbulk_di+0.0*T4_Vsi_bi+1.0*T4_Vsi_bi_Vdbulk_di)/T4/T4+2*1.0*T4_Vsi_bi*T4_Vdbulk_di/T4/T4/T4);
  T5_Vsi_bi_Vsbulk_si=(0.0/T4-(0.0*T4_Vsbulk_si+0.0*T4_Vsi_bi+1.0*T4_Vsi_bi_Vsbulk_si)/T4/T4+2*1.0*T4_Vsi_bi*T4_Vsbulk_si/T4/T4/T4);
  T5_Vsi_bi_Vgi_bi=(0.0/T4-(0.0*T4_Vgi_bi+0.0*T4_Vsi_bi+1.0*T4_Vsi_bi_Vgi_bi)/T4/T4+2*1.0*T4_Vsi_bi*T4_Vgi_bi/T4/T4/T4);
  T5_Vsi_bi_Vdi_bi=(0.0/T4-(0.0*T4_Vdi_bi+0.0*T4_Vsi_bi+1.0*T4_Vsi_bi_Vdi_bi)/T4/T4+2*1.0*T4_Vsi_bi*T4_Vdi_bi/T4/T4/T4);
  T5_Vsi_bi_Vsi_bi=(0.0/T4-(0.0*T4_Vsi_bi+0.0*T4_Vsi_bi+1.0*T4_Vsi_bi_Vsi_bi)/T4/T4+2*1.0*T4_Vsi_bi*T4_Vsi_bi/T4/T4/T4);
  T5_Vsi_bi_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vsi_bi+1.0*T4_Vsi_bi_Tempt_GND)/T4/T4+2*1.0*T4_Vsi_bi*T4_Tempt_GND/T4/T4/T4);
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=(-T4_Tempt_GND/T4/T4);
#endif
#endif
T5=(1.0/T4);
EXIT_IF_ISNAN((1.0/T4))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND) */
VaDIBL_Vdi_bi=((((((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi))*T5)+((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vdi_bi));
#if defined(_DERIVATE2)
  VaDIBL_Vdi_bi_Vdi_bi=(+(+(+(Vgst2Vtm_Vdi_bi_Vdi_bi/DIBLfactor-(Vgst2Vtm_Vdi_bi*DIBLfactor_Vdi_bi+Vgst2Vtm_Vdi_bi*DIBLfactor_Vdi_bi+Vgst2Vtm*DIBLfactor_Vdi_bi_Vdi_bi)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*DIBLfactor_Vdi_bi*DIBLfactor_Vdi_bi/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3_Vdi_bi+((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3_Vdi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vdi_bi_Vdi_bi)*PVAGfactor+((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi))*PVAGfactor_Vdi_bi+(((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi)))*PVAGfactor_Vdi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi_Vdi_bi)*T5+((((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi))*T5_Vdi_bi+((((((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi)))*T5_Vdi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vdi_bi_Vdi_bi);
  VaDIBL_Vdi_bi_Vsi_bi=(+(+(+(Vgst2Vtm_Vdi_bi_Vsi_bi/DIBLfactor-(Vgst2Vtm_Vdi_bi*DIBLfactor_Vsi_bi+Vgst2Vtm_Vsi_bi*DIBLfactor_Vdi_bi+Vgst2Vtm*DIBLfactor_Vdi_bi_Vsi_bi)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*DIBLfactor_Vdi_bi*DIBLfactor_Vsi_bi/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3_Vsi_bi+((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3_Vdi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vdi_bi_Vsi_bi)*PVAGfactor+((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi))*PVAGfactor_Vsi_bi+(((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi)))*PVAGfactor_Vdi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi_Vsi_bi)*T5+((((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi))*T5_Vsi_bi+((((((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi)))*T5_Vdi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vdi_bi_Vsi_bi);
  VaDIBL_Vdi_bi_Tempt_GND=(+(+(+(Vgst2Vtm_Vdi_bi_Tempt_GND/DIBLfactor-(Vgst2Vtm_Vdi_bi*DIBLfactor_Tempt_GND+Vgst2Vtm_Tempt_GND*DIBLfactor_Vdi_bi+Vgst2Vtm*DIBLfactor_Vdi_bi_Tempt_GND)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*DIBLfactor_Vdi_bi*DIBLfactor_Tempt_GND/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3_Tempt_GND+((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Vdi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vdi_bi_Tempt_GND)*PVAGfactor+((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi))*PVAGfactor_Tempt_GND+(((((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor_Vdi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi_Tempt_GND)*T5+((((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi))*T5_Tempt_GND+((((((((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Tempt_GND)))*T5_Vdi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vdi_bi_Tempt_GND);
  VaDIBL_Vdi_bi_Vgi_bi=(+(+(+(Vgst2Vtm_Vdi_bi_Vgi_bi/DIBLfactor-(Vgst2Vtm_Vdi_bi*0.0+Vgst2Vtm_Vgi_bi*DIBLfactor_Vdi_bi+Vgst2Vtm*0.0)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*DIBLfactor_Vdi_bi*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3_Vgi_bi+(Vgst2Vtm_Vgi_bi/DIBLfactor)*T3_Vdi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vdi_bi_Vgi_bi)*PVAGfactor+((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi))*PVAGfactor_Vgi_bi+((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi)))*PVAGfactor_Vdi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi_Vgi_bi)*T5+((((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi))*T5_Vgi_bi+(((((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi)))*T5_Vdi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vdi_bi_Vgi_bi);
#endif
VaDIBL_Vsi_bi=((((((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi))*T5)+((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vsi_bi));
#if defined(_DERIVATE2)
  VaDIBL_Vsi_bi_Vdi_bi=(+(+(+(Vgst2Vtm_Vsi_bi_Vdi_bi/DIBLfactor-(Vgst2Vtm_Vsi_bi*DIBLfactor_Vdi_bi+Vgst2Vtm_Vdi_bi*DIBLfactor_Vsi_bi+Vgst2Vtm*DIBLfactor_Vsi_bi_Vdi_bi)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*DIBLfactor_Vsi_bi*DIBLfactor_Vdi_bi/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3_Vdi_bi+((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3_Vsi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vsi_bi_Vdi_bi)*PVAGfactor+((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi))*PVAGfactor_Vdi_bi+(((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi)))*PVAGfactor_Vsi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi_Vdi_bi)*T5+((((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi))*T5_Vdi_bi+((((((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi)))*T5_Vsi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vsi_bi_Vdi_bi);
  VaDIBL_Vsi_bi_Vsi_bi=(+(+(+(Vgst2Vtm_Vsi_bi_Vsi_bi/DIBLfactor-(Vgst2Vtm_Vsi_bi*DIBLfactor_Vsi_bi+Vgst2Vtm_Vsi_bi*DIBLfactor_Vsi_bi+Vgst2Vtm*DIBLfactor_Vsi_bi_Vsi_bi)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*DIBLfactor_Vsi_bi*DIBLfactor_Vsi_bi/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3_Vsi_bi+((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3_Vsi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vsi_bi_Vsi_bi)*PVAGfactor+((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi))*PVAGfactor_Vsi_bi+(((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi)))*PVAGfactor_Vsi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi_Vsi_bi)*T5+((((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi))*T5_Vsi_bi+((((((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi)))*T5_Vsi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vsi_bi_Vsi_bi);
  VaDIBL_Vsi_bi_Tempt_GND=(+(+(+(Vgst2Vtm_Vsi_bi_Tempt_GND/DIBLfactor-(Vgst2Vtm_Vsi_bi*DIBLfactor_Tempt_GND+Vgst2Vtm_Tempt_GND*DIBLfactor_Vsi_bi+Vgst2Vtm*DIBLfactor_Vsi_bi_Tempt_GND)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*DIBLfactor_Vsi_bi*DIBLfactor_Tempt_GND/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3_Tempt_GND+((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Vsi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vsi_bi_Tempt_GND)*PVAGfactor+((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi))*PVAGfactor_Tempt_GND+(((((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor_Vsi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi_Tempt_GND)*T5+((((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi))*T5_Tempt_GND+((((((((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Tempt_GND)))*T5_Vsi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vsi_bi_Tempt_GND);
  VaDIBL_Vsi_bi_Vgi_bi=(+(+(+(Vgst2Vtm_Vsi_bi_Vgi_bi/DIBLfactor-(Vgst2Vtm_Vsi_bi*0.0+Vgst2Vtm_Vgi_bi*DIBLfactor_Vsi_bi+Vgst2Vtm*0.0)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*DIBLfactor_Vsi_bi*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3_Vgi_bi+(Vgst2Vtm_Vgi_bi/DIBLfactor)*T3_Vsi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vsi_bi_Vgi_bi)*PVAGfactor+((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi))*PVAGfactor_Vgi_bi+((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi)))*PVAGfactor_Vsi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi_Vgi_bi)*T5+((((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi))*T5_Vgi_bi+(((((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi)))*T5_Vsi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vsi_bi_Vgi_bi);
#endif
#if defined(_DERIVATE)
VaDIBL_Tempt_GND=((((((((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Tempt_GND))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Tempt_GND))*T5)+((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Tempt_GND));
#endif
VaDIBL_Vgi_bi=(((((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi))*T5)+((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vgi_bi));
#if defined(_DERIVATE2)
  VaDIBL_Vgi_bi_Vdi_bi=(+(+(+(Vgst2Vtm_Vgi_bi_Vdi_bi/DIBLfactor-(Vgst2Vtm_Vgi_bi*DIBLfactor_Vdi_bi+Vgst2Vtm_Vdi_bi*0.0+Vgst2Vtm*0.0)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*0.0*DIBLfactor_Vdi_bi/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(Vgst2Vtm_Vgi_bi/DIBLfactor)*T3_Vdi_bi+((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3_Vgi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vgi_bi_Vdi_bi)*PVAGfactor+(((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi))*PVAGfactor_Vdi_bi+(((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi)))*PVAGfactor_Vgi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi_Vdi_bi)*T5+(((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi))*T5_Vdi_bi+((((((((Vgst2Vtm_Vdi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vdi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vdi_bi)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vdi_bi)))*T5_Vgi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vgi_bi_Vdi_bi);
  VaDIBL_Vgi_bi_Vsi_bi=(+(+(+(Vgst2Vtm_Vgi_bi_Vsi_bi/DIBLfactor-(Vgst2Vtm_Vgi_bi*DIBLfactor_Vsi_bi+Vgst2Vtm_Vsi_bi*0.0+Vgst2Vtm*0.0)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*0.0*DIBLfactor_Vsi_bi/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(Vgst2Vtm_Vgi_bi/DIBLfactor)*T3_Vsi_bi+((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3_Vgi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vgi_bi_Vsi_bi)*PVAGfactor+(((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi))*PVAGfactor_Vsi_bi+(((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi)))*PVAGfactor_Vgi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi_Vsi_bi)*T5+(((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi))*T5_Vsi_bi+((((((((Vgst2Vtm_Vsi_bi*DIBLfactor-Vgst2Vtm*DIBLfactor_Vsi_bi)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vsi_bi)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vsi_bi)))*T5_Vgi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vgi_bi_Vsi_bi);
  VaDIBL_Vgi_bi_Tempt_GND=(+(+(+(Vgst2Vtm_Vgi_bi_Tempt_GND/DIBLfactor-(Vgst2Vtm_Vgi_bi*DIBLfactor_Tempt_GND+Vgst2Vtm_Tempt_GND*0.0+Vgst2Vtm*0.0)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*0.0*DIBLfactor_Tempt_GND/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(Vgst2Vtm_Vgi_bi/DIBLfactor)*T3_Tempt_GND+((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Vgi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vgi_bi_Tempt_GND)*PVAGfactor+(((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi))*PVAGfactor_Tempt_GND+(((((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor_Vgi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi_Tempt_GND)*T5+(((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi))*T5_Tempt_GND+((((((((Vgst2Vtm_Tempt_GND*DIBLfactor-Vgst2Vtm*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Tempt_GND)))*T5_Vgi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vgi_bi_Tempt_GND);
  VaDIBL_Vgi_bi_Vgi_bi=(+(+(+(Vgst2Vtm_Vgi_bi_Vgi_bi/DIBLfactor-(Vgst2Vtm_Vgi_bi*0.0+Vgst2Vtm_Vgi_bi*0.0+Vgst2Vtm*0.0)/DIBLfactor/DIBLfactor+2*Vgst2Vtm*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(Vgst2Vtm_Vgi_bi/DIBLfactor)*T3_Vgi_bi+(Vgst2Vtm_Vgi_bi/DIBLfactor)*T3_Vgi_bi+(Vgst2Vtm/DIBLfactor)*T3_Vgi_bi_Vgi_bi)*PVAGfactor+(((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi))*PVAGfactor_Vgi_bi+((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi)))*PVAGfactor_Vgi_bi+((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi_Vgi_bi)*T5+(((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi))*T5_Vgi_bi+(((((((Vgst2Vtm_Vgi_bi/DIBLfactor)*T3)+((Vgst2Vtm/DIBLfactor)*T3_Vgi_bi)))*PVAGfactor)+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor_Vgi_bi)))*T5_Vgi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5_Vgi_bi_Vgi_bi);
#endif
#endif
VaDIBL=((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5);
EXIT_IF_ISNAN(((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Moc_Vdi_bi=((diffVds_Vdi_bi*VaDIBL-diffVds*VaDIBL_Vdi_bi)/VaDIBL/VaDIBL);
#if defined(_DERIVATE2)
  Moc_Vdi_bi_Vdi_bi=(+0.0+(diffVds_Vdi_bi_Vdi_bi/VaDIBL-(diffVds_Vdi_bi*VaDIBL_Vdi_bi+diffVds_Vdi_bi*VaDIBL_Vdi_bi+diffVds*VaDIBL_Vdi_bi_Vdi_bi)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_bi*VaDIBL_Vdi_bi/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vdi_bi_Vsi_bi=(+0.0+(diffVds_Vdi_bi_Vsi_bi/VaDIBL-(diffVds_Vdi_bi*VaDIBL_Vsi_bi+diffVds_Vsi_bi*VaDIBL_Vdi_bi+diffVds*VaDIBL_Vdi_bi_Vsi_bi)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_bi*VaDIBL_Vsi_bi/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vdi_bi_Vgi_bi=(+0.0+(diffVds_Vdi_bi_Vgi_bi/VaDIBL-(diffVds_Vdi_bi*VaDIBL_Vgi_bi+diffVds_Vgi_bi*VaDIBL_Vdi_bi+diffVds*VaDIBL_Vdi_bi_Vgi_bi)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_bi*VaDIBL_Vgi_bi/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vdi_bi_Tempt_GND=(+0.0+(diffVds_Vdi_bi_Tempt_GND/VaDIBL-(diffVds_Vdi_bi*VaDIBL_Tempt_GND+diffVds_Tempt_GND*VaDIBL_Vdi_bi+diffVds*VaDIBL_Vdi_bi_Tempt_GND)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_bi*VaDIBL_Tempt_GND/VaDIBL/VaDIBL/VaDIBL));
#endif
Moc_Vsi_bi=((diffVds_Vsi_bi*VaDIBL-diffVds*VaDIBL_Vsi_bi)/VaDIBL/VaDIBL);
#if defined(_DERIVATE2)
  Moc_Vsi_bi_Vdi_bi=(+0.0+(diffVds_Vsi_bi_Vdi_bi/VaDIBL-(diffVds_Vsi_bi*VaDIBL_Vdi_bi+diffVds_Vdi_bi*VaDIBL_Vsi_bi+diffVds*VaDIBL_Vsi_bi_Vdi_bi)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vsi_bi*VaDIBL_Vdi_bi/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vsi_bi_Vsi_bi=(+0.0+(diffVds_Vsi_bi_Vsi_bi/VaDIBL-(diffVds_Vsi_bi*VaDIBL_Vsi_bi+diffVds_Vsi_bi*VaDIBL_Vsi_bi+diffVds*VaDIBL_Vsi_bi_Vsi_bi)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vsi_bi*VaDIBL_Vsi_bi/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vsi_bi_Vgi_bi=(+0.0+(diffVds_Vsi_bi_Vgi_bi/VaDIBL-(diffVds_Vsi_bi*VaDIBL_Vgi_bi+diffVds_Vgi_bi*VaDIBL_Vsi_bi+diffVds*VaDIBL_Vsi_bi_Vgi_bi)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vsi_bi*VaDIBL_Vgi_bi/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vsi_bi_Tempt_GND=(+0.0+(diffVds_Vsi_bi_Tempt_GND/VaDIBL-(diffVds_Vsi_bi*VaDIBL_Tempt_GND+diffVds_Tempt_GND*VaDIBL_Vsi_bi+diffVds*VaDIBL_Vsi_bi_Tempt_GND)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vsi_bi*VaDIBL_Tempt_GND/VaDIBL/VaDIBL/VaDIBL));
#endif
Moc_Vgi_bi=((diffVds_Vgi_bi*VaDIBL-diffVds*VaDIBL_Vgi_bi)/VaDIBL/VaDIBL);
#if defined(_DERIVATE2)
  Moc_Vgi_bi_Vdi_bi=(+0.0+(diffVds_Vgi_bi_Vdi_bi/VaDIBL-(diffVds_Vgi_bi*VaDIBL_Vdi_bi+diffVds_Vdi_bi*VaDIBL_Vgi_bi+diffVds*VaDIBL_Vgi_bi_Vdi_bi)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vgi_bi*VaDIBL_Vdi_bi/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vgi_bi_Vsi_bi=(+0.0+(diffVds_Vgi_bi_Vsi_bi/VaDIBL-(diffVds_Vgi_bi*VaDIBL_Vsi_bi+diffVds_Vsi_bi*VaDIBL_Vgi_bi+diffVds*VaDIBL_Vgi_bi_Vsi_bi)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vgi_bi*VaDIBL_Vsi_bi/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vgi_bi_Vgi_bi=(+0.0+(diffVds_Vgi_bi_Vgi_bi/VaDIBL-(diffVds_Vgi_bi*VaDIBL_Vgi_bi+diffVds_Vgi_bi*VaDIBL_Vgi_bi+diffVds*VaDIBL_Vgi_bi_Vgi_bi)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vgi_bi*VaDIBL_Vgi_bi/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vgi_bi_Tempt_GND=(+0.0+(diffVds_Vgi_bi_Tempt_GND/VaDIBL-(diffVds_Vgi_bi*VaDIBL_Tempt_GND+diffVds_Tempt_GND*VaDIBL_Vgi_bi+diffVds*VaDIBL_Vgi_bi_Tempt_GND)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vgi_bi*VaDIBL_Tempt_GND/VaDIBL/VaDIBL/VaDIBL));
#endif
#if defined(_DERIVATE)
Moc_Tempt_GND=((diffVds_Tempt_GND*VaDIBL-diffVds*VaDIBL_Tempt_GND)/VaDIBL/VaDIBL);
#endif
#endif
Moc=(1.0+(diffVds/VaDIBL));
EXIT_IF_ISNAN((1.0+(diffVds/VaDIBL)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Moc_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Moc_Vdi_bi_Vdi_bi=0.0;
  Moc_Vdi_bi_Vsi_bi=0.0;
  Moc_Vdi_bi_Vgi_bi=0.0;
  Moc_Vdi_bi_Tempt_GND=0.0;
#endif
Moc_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Moc_Vsi_bi_Vdi_bi=0.0;
  Moc_Vsi_bi_Vsi_bi=0.0;
  Moc_Vsi_bi_Vgi_bi=0.0;
  Moc_Vsi_bi_Tempt_GND=0.0;
#endif
Moc_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Moc_Vgi_bi_Vdi_bi=0.0;
  Moc_Vgi_bi_Vsi_bi=0.0;
  Moc_Vgi_bi_Vgi_bi=0.0;
  Moc_Vgi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
Moc_Tempt_GND=0.0;
#endif
#endif
Moc=1.0;
EXIT_IF_ISNAN(1.0)
}
if
((FPROUT_i<=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Fp_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Fp_Vdi_bi_Vdi_bi=0.0;
  Fp_Vdi_bi_Vsi_bi=0.0;
  Fp_Vdi_bi_Tempt_GND=0.0;
  Fp_Vdi_bi_Vgi_bi=0.0;
#endif
Fp_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Fp_Vsi_bi_Vdi_bi=0.0;
  Fp_Vsi_bi_Vsi_bi=0.0;
  Fp_Vsi_bi_Tempt_GND=0.0;
  Fp_Vsi_bi_Vgi_bi=0.0;
#endif
#if defined(_DERIVATE)
Fp_Tempt_GND=0.0;
#endif
Fp_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Fp_Vgi_bi_Vdi_bi=0.0;
  Fp_Vgi_bi_Vsi_bi=0.0;
  Fp_Vgi_bi_Tempt_GND=0.0;
  Fp_Vgi_bi_Vgi_bi=0.0;
#endif
#endif
Fp=1.0;
EXIT_IF_ISNAN(1.0)
}
else
{
{
double m00_sqrt(d00_sqrt0,Leff)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=0.0;
  T9_Vdbulk_di_Vgm_di=0.0;
  T9_Vdbulk_di_Vdbulk_di=0.0;
  T9_Vdbulk_di_Vsbulk_si=0.0;
  T9_Vdbulk_di_Vdi_bi=0.0;
  T9_Vdbulk_di_Vsi_bi=0.0;
  T9_Vdbulk_di_Tempt_GND=0.0;
  T9_Vdbulk_di_Vgi_bi=0.0;
#endif
T9_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=0.0;
  T9_Vsbulk_si_Vgm_di=0.0;
  T9_Vsbulk_si_Vdbulk_di=0.0;
  T9_Vsbulk_si_Vsbulk_si=0.0;
  T9_Vsbulk_si_Vdi_bi=0.0;
  T9_Vsbulk_si_Vsi_bi=0.0;
  T9_Vsbulk_si_Tempt_GND=0.0;
  T9_Vsbulk_si_Vgi_bi=0.0;
#endif
T9_Vdi_bi=(-(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi/Vgst2Vtm/Vgst2Vtm);
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vdi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vdi_bi_Vgm_di=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vdi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vdi_bi_Vdbulk_di=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vdi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vdi_bi_Vsbulk_si=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vdi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vdi_bi_Vdi_bi=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Vdi_bi+(0.0)*Vgst2Vtm_Vdi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi_Vdi_bi)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi*Vgst2Vtm_Vdi_bi/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vdi_bi_Vsi_bi=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Vsi_bi+(0.0)*Vgst2Vtm_Vdi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi_Vsi_bi)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi*Vgst2Vtm_Vsi_bi/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vdi_bi_Tempt_GND=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Tempt_GND+(0.0)*Vgst2Vtm_Vdi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi_Tempt_GND)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi*Vgst2Vtm_Tempt_GND/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vdi_bi_Vgi_bi=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Vgi_bi+(0.0)*Vgst2Vtm_Vdi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi_Vgi_bi)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vdi_bi*Vgst2Vtm_Vgi_bi/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
#endif
T9_Vsi_bi=(-(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi/Vgst2Vtm/Vgst2Vtm);
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vsi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vsi_bi_Vgm_di=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vsi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vsi_bi_Vdbulk_di=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vsi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vsi_bi_Vsbulk_si=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vsi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vsi_bi_Vdi_bi=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Vdi_bi+(0.0)*Vgst2Vtm_Vsi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi_Vdi_bi)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi*Vgst2Vtm_Vdi_bi/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vsi_bi_Vsi_bi=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Vsi_bi+(0.0)*Vgst2Vtm_Vsi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi_Vsi_bi)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi*Vgst2Vtm_Vsi_bi/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vsi_bi_Tempt_GND=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Tempt_GND+(0.0)*Vgst2Vtm_Vsi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi_Tempt_GND)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi*Vgst2Vtm_Tempt_GND/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vsi_bi_Vgi_bi=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Vgi_bi+(0.0)*Vgst2Vtm_Vsi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi_Vgi_bi)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vsi_bi*Vgst2Vtm_Vgi_bi/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=(-(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Tempt_GND/Vgst2Vtm/Vgst2Vtm);
#endif
T9_Vgi_bi=(-(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi/Vgst2Vtm/Vgst2Vtm);
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vgi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vgi_bi_Vgm_di=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vgi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vgi_bi_Vdbulk_di=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vgi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vgi_bi_Vsbulk_si=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*0.0+(0.0)*Vgst2Vtm_Vgi_bi+(FPROUT_i*d00_sqrt0)*0.0)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi*0.0/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vgi_bi_Vdi_bi=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Vdi_bi+(0.0)*Vgst2Vtm_Vgi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi_Vdi_bi)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi*Vgst2Vtm_Vdi_bi/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vgi_bi_Vsi_bi=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Vsi_bi+(0.0)*Vgst2Vtm_Vgi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi_Vsi_bi)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi*Vgst2Vtm_Vsi_bi/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vgi_bi_Tempt_GND=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Tempt_GND+(0.0)*Vgst2Vtm_Vgi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi_Tempt_GND)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi*Vgst2Vtm_Tempt_GND/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
  T9_Vgi_bi_Vgi_bi=((+0.0*d00_sqrt0+0.0*0.0+0.0*0.0+FPROUT_i*0.0)/Vgst2Vtm-(0.0*Vgst2Vtm_Vgi_bi+(0.0)*Vgst2Vtm_Vgi_bi+(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi_Vgi_bi)/Vgst2Vtm/Vgst2Vtm+2*(FPROUT_i*d00_sqrt0)*Vgst2Vtm_Vgi_bi*Vgst2Vtm_Vgi_bi/Vgst2Vtm/Vgst2Vtm/Vgst2Vtm);
#endif
#endif
T9=((FPROUT_i*d00_sqrt0)/Vgst2Vtm);
EXIT_IF_ISNAN(((FPROUT_i*d00_sqrt0)/Vgst2Vtm))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Fp_Vdi_bi=(-T9_Vdi_bi/(1.0+T9)/(1.0+T9));
#if defined(_DERIVATE2)
  Fp_Vdi_bi_Vdi_bi=(0.0/(1.0+T9)-(0.0*T9_Vdi_bi+0.0*T9_Vdi_bi+1.0*(+0.0+T9_Vdi_bi_Vdi_bi))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vdi_bi*T9_Vdi_bi/(1.0+T9)/(1.0+T9)/(1.0+T9));
  Fp_Vdi_bi_Vsi_bi=(0.0/(1.0+T9)-(0.0*T9_Vsi_bi+0.0*T9_Vdi_bi+1.0*(+0.0+T9_Vdi_bi_Vsi_bi))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vdi_bi*T9_Vsi_bi/(1.0+T9)/(1.0+T9)/(1.0+T9));
  Fp_Vdi_bi_Tempt_GND=(0.0/(1.0+T9)-(0.0*T9_Tempt_GND+0.0*T9_Vdi_bi+1.0*(+0.0+T9_Vdi_bi_Tempt_GND))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vdi_bi*T9_Tempt_GND/(1.0+T9)/(1.0+T9)/(1.0+T9));
  Fp_Vdi_bi_Vgi_bi=(0.0/(1.0+T9)-(0.0*T9_Vgi_bi+0.0*T9_Vdi_bi+1.0*(+0.0+T9_Vdi_bi_Vgi_bi))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vdi_bi*T9_Vgi_bi/(1.0+T9)/(1.0+T9)/(1.0+T9));
#endif
Fp_Vsi_bi=(-T9_Vsi_bi/(1.0+T9)/(1.0+T9));
#if defined(_DERIVATE2)
  Fp_Vsi_bi_Vdi_bi=(0.0/(1.0+T9)-(0.0*T9_Vdi_bi+0.0*T9_Vsi_bi+1.0*(+0.0+T9_Vsi_bi_Vdi_bi))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vsi_bi*T9_Vdi_bi/(1.0+T9)/(1.0+T9)/(1.0+T9));
  Fp_Vsi_bi_Vsi_bi=(0.0/(1.0+T9)-(0.0*T9_Vsi_bi+0.0*T9_Vsi_bi+1.0*(+0.0+T9_Vsi_bi_Vsi_bi))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vsi_bi*T9_Vsi_bi/(1.0+T9)/(1.0+T9)/(1.0+T9));
  Fp_Vsi_bi_Tempt_GND=(0.0/(1.0+T9)-(0.0*T9_Tempt_GND+0.0*T9_Vsi_bi+1.0*(+0.0+T9_Vsi_bi_Tempt_GND))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vsi_bi*T9_Tempt_GND/(1.0+T9)/(1.0+T9)/(1.0+T9));
  Fp_Vsi_bi_Vgi_bi=(0.0/(1.0+T9)-(0.0*T9_Vgi_bi+0.0*T9_Vsi_bi+1.0*(+0.0+T9_Vsi_bi_Vgi_bi))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vsi_bi*T9_Vgi_bi/(1.0+T9)/(1.0+T9)/(1.0+T9));
#endif
#if defined(_DERIVATE)
Fp_Tempt_GND=(-T9_Tempt_GND/(1.0+T9)/(1.0+T9));
#endif
Fp_Vgi_bi=(-T9_Vgi_bi/(1.0+T9)/(1.0+T9));
#if defined(_DERIVATE2)
  Fp_Vgi_bi_Vdi_bi=(0.0/(1.0+T9)-(0.0*T9_Vdi_bi+0.0*T9_Vgi_bi+1.0*(+0.0+T9_Vgi_bi_Vdi_bi))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vgi_bi*T9_Vdi_bi/(1.0+T9)/(1.0+T9)/(1.0+T9));
  Fp_Vgi_bi_Vsi_bi=(0.0/(1.0+T9)-(0.0*T9_Vsi_bi+0.0*T9_Vgi_bi+1.0*(+0.0+T9_Vgi_bi_Vsi_bi))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vgi_bi*T9_Vsi_bi/(1.0+T9)/(1.0+T9)/(1.0+T9));
  Fp_Vgi_bi_Tempt_GND=(0.0/(1.0+T9)-(0.0*T9_Tempt_GND+0.0*T9_Vgi_bi+1.0*(+0.0+T9_Vgi_bi_Tempt_GND))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vgi_bi*T9_Tempt_GND/(1.0+T9)/(1.0+T9)/(1.0+T9));
  Fp_Vgi_bi_Vgi_bi=(0.0/(1.0+T9)-(0.0*T9_Vgi_bi+0.0*T9_Vgi_bi+1.0*(+0.0+T9_Vgi_bi_Vgi_bi))/(1.0+T9)/(1.0+T9)+2*1.0*T9_Vgi_bi*T9_Vgi_bi/(1.0+T9)/(1.0+T9)/(1.0+T9));
#endif
#endif
Fp=(1.0/(1.0+T9));
EXIT_IF_ISNAN((1.0/(1.0+T9)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Vasat_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Vasat_Vdbulk_di_Vdbulk_di=0.0;
  Vasat_Vdbulk_di_Vsbulk_si=0.0;
  Vasat_Vdbulk_di_Vgi_bi=0.0;
  Vasat_Vdbulk_di_Vdi_bi=0.0;
  Vasat_Vdbulk_di_Vsi_bi=0.0;
  Vasat_Vdbulk_di_Tempt_GND=0.0;
#endif
Vasat_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Vasat_Vsbulk_si_Vdbulk_di=0.0;
  Vasat_Vsbulk_si_Vsbulk_si=0.0;
  Vasat_Vsbulk_si_Vgi_bi=0.0;
  Vasat_Vsbulk_si_Vdi_bi=0.0;
  Vasat_Vsbulk_si_Vsi_bi=0.0;
  Vasat_Vsbulk_si_Tempt_GND=0.0;
#endif
Vasat_Vgi_bi=(Vdssat_Vgi_bi+EsatL_Vgi_bi);
#if defined(_DERIVATE2)
  Vasat_Vgi_bi_Vdbulk_di=(+0.0+EsatL_Vgi_bi_Vdbulk_di);
  Vasat_Vgi_bi_Vsbulk_si=(+0.0+EsatL_Vgi_bi_Vsbulk_si);
  Vasat_Vgi_bi_Vgi_bi=(+Vdssat_Vgi_bi_Vgi_bi+EsatL_Vgi_bi_Vgi_bi);
  Vasat_Vgi_bi_Vdi_bi=(+Vdssat_Vgi_bi_Vdi_bi+EsatL_Vgi_bi_Vdi_bi);
  Vasat_Vgi_bi_Vsi_bi=(+Vdssat_Vgi_bi_Vsi_bi+EsatL_Vgi_bi_Vsi_bi);
  Vasat_Vgi_bi_Tempt_GND=(+Vdssat_Vgi_bi_Tempt_GND+EsatL_Vgi_bi_Tempt_GND);
#endif
Vasat_Vdi_bi=(Vdssat_Vdi_bi+EsatL_Vdi_bi);
#if defined(_DERIVATE2)
  Vasat_Vdi_bi_Vdbulk_di=(+0.0+EsatL_Vdi_bi_Vdbulk_di);
  Vasat_Vdi_bi_Vsbulk_si=(+0.0+EsatL_Vdi_bi_Vsbulk_si);
  Vasat_Vdi_bi_Vgi_bi=(+Vdssat_Vdi_bi_Vgi_bi+EsatL_Vdi_bi_Vgi_bi);
  Vasat_Vdi_bi_Vdi_bi=(+Vdssat_Vdi_bi_Vdi_bi+EsatL_Vdi_bi_Vdi_bi);
  Vasat_Vdi_bi_Vsi_bi=(+Vdssat_Vdi_bi_Vsi_bi+EsatL_Vdi_bi_Vsi_bi);
  Vasat_Vdi_bi_Tempt_GND=(+Vdssat_Vdi_bi_Tempt_GND+EsatL_Vdi_bi_Tempt_GND);
#endif
Vasat_Vsi_bi=(Vdssat_Vsi_bi+EsatL_Vsi_bi);
#if defined(_DERIVATE2)
  Vasat_Vsi_bi_Vdbulk_di=(+0.0+EsatL_Vsi_bi_Vdbulk_di);
  Vasat_Vsi_bi_Vsbulk_si=(+0.0+EsatL_Vsi_bi_Vsbulk_si);
  Vasat_Vsi_bi_Vgi_bi=(+Vdssat_Vsi_bi_Vgi_bi+EsatL_Vsi_bi_Vgi_bi);
  Vasat_Vsi_bi_Vdi_bi=(+Vdssat_Vsi_bi_Vdi_bi+EsatL_Vsi_bi_Vdi_bi);
  Vasat_Vsi_bi_Vsi_bi=(+Vdssat_Vsi_bi_Vsi_bi+EsatL_Vsi_bi_Vsi_bi);
  Vasat_Vsi_bi_Tempt_GND=(+Vdssat_Vsi_bi_Tempt_GND+EsatL_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Vasat_Tempt_GND=(Vdssat_Tempt_GND+EsatL_Tempt_GND);
#endif
#endif
Vasat=(Vdssat+EsatL);
EXIT_IF_ISNAN((Vdssat+EsatL))
if
((PCLM_a!=0.0))
{
if
((pModel->PCLMG<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(((-PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp-(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi)/Fp/Fp);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(0.0*(-((0.0)/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*0.0+0.0*qia_Vgi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*0.0+(0.0)*EsatL_Vgi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*0.0/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-((-PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*0.0/Fp/Fp/Fp);
  T1_Vgi_bi_Vgm_si=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(0.0*(-((0.0)/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*0.0+0.0*qia_Vgi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*0.0+(0.0)*EsatL_Vgi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*0.0/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-((-PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*0.0/Fp/Fp/Fp);
  T1_Vgi_bi_Vdbulk_di=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(0.0*(-((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vdbulk_di)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vdbulk_di+((pModel->PCLMG*qia_Vdbulk_di))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vdbulk_di)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vdbulk_di/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-((-PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*0.0/Fp/Fp/Fp);
  T1_Vgi_bi_Vsbulk_si=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(0.0*(-((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vsbulk_si)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vsbulk_si+((pModel->PCLMG*qia_Vsbulk_si))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vsbulk_si)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vsbulk_si/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-((-PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*0.0/Fp/Fp/Fp);
  T1_Vgi_bi_Vgi_bi=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(0.0*(-((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vgi_bi)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vgi_bi+((pModel->PCLMG*qia_Vgi_bi))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vgi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-((-PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(-PCLM_a*(-((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi_Vgi_bi)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*Fp_Vgi_bi/Fp/Fp/Fp);
  T1_Vgi_bi_Vdi_bi=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(0.0*(-((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a_Vdi_bi*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vdi_bi)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vdi_bi+((pModel->PCLMG*qia_Vdi_bi))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vdi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-((-PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi_Vdi_bi)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*Fp_Vdi_bi/Fp/Fp/Fp);
  T1_Vgi_bi_Vsi_bi=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(0.0*(-((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a_Vsi_bi*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vsi_bi)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vsi_bi+((pModel->PCLMG*qia_Vsi_bi))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vsi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-((-PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi_Vsi_bi)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*Fp_Vsi_bi/Fp/Fp/Fp);
  T1_Vgi_bi_Tempt_GND=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(0.0*(-((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+PCLM_a_Tempt_GND*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Tempt_GND)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Tempt_GND+((pModel->PCLMG*qia_Tempt_GND))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Tempt_GND)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-((-PCLM_a*(-(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Tempt_GND+((PCLM_a_Tempt_GND*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi_Tempt_GND)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*Fp_Tempt_GND/Fp/Fp/Fp);
#endif
T1_Vdi_bi=((((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp-(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi)/Fp/Fp);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vdi_bi*(-((0.0)/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*0.0+0.0*qia_Vdi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*0.0+(0.0)*EsatL_Vdi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*0.0/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*0.0/Fp/Fp/Fp);
  T1_Vdi_bi_Vgm_si=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vdi_bi*(-((0.0)/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*0.0+0.0*qia_Vdi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*0.0+(0.0)*EsatL_Vdi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*0.0/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*0.0/Fp/Fp/Fp);
  T1_Vdi_bi_Vdbulk_di=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vdi_bi*(-((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vdbulk_di)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vdbulk_di+((pModel->PCLMG*qia_Vdbulk_di))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vdbulk_di)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vdbulk_di/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*0.0/Fp/Fp/Fp);
  T1_Vdi_bi_Vsbulk_si=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vdi_bi*(-((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vsbulk_si)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vsbulk_si+((pModel->PCLMG*qia_Vsbulk_si))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vsbulk_si)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vsbulk_si/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*0.0/Fp/Fp/Fp);
  T1_Vdi_bi_Vgi_bi=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vdi_bi*(-((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vgi_bi)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vgi_bi+((pModel->PCLMG*qia_Vgi_bi))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vgi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(-PCLM_a*(-((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi_Vgi_bi)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*Fp_Vgi_bi/Fp/Fp/Fp);
  T1_Vdi_bi_Vdi_bi=((PCLM_a_Vdi_bi_Vdi_bi/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vdi_bi*(-((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a_Vdi_bi*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vdi_bi)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vdi_bi+((pModel->PCLMG*qia_Vdi_bi))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vdi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi_Vdi_bi)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*Fp_Vdi_bi/Fp/Fp/Fp);
  T1_Vdi_bi_Vsi_bi=((PCLM_a_Vdi_bi_Vsi_bi/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vdi_bi*(-((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a_Vsi_bi*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vsi_bi)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vsi_bi+((pModel->PCLMG*qia_Vsi_bi))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vsi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi_Vsi_bi)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*Fp_Vsi_bi/Fp/Fp/Fp);
  T1_Vdi_bi_Tempt_GND=((PCLM_a_Vdi_bi_Tempt_GND/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vdi_bi*(-((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+PCLM_a_Tempt_GND*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Tempt_GND)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Tempt_GND+((pModel->PCLMG*qia_Tempt_GND))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Tempt_GND)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Tempt_GND+((PCLM_a_Tempt_GND*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi_Tempt_GND)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*Fp_Tempt_GND/Fp/Fp/Fp);
#endif
T1_Vsi_bi=((((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp-(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi)/Fp/Fp);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vsi_bi*(-((0.0)/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*0.0+0.0*qia_Vsi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*0.0+(0.0)*EsatL_Vsi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*0.0/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*0.0/Fp/Fp/Fp);
  T1_Vsi_bi_Vgm_si=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vsi_bi*(-((0.0)/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*0.0+0.0*qia_Vsi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*0.0+(0.0)*EsatL_Vsi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*0.0/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((0.0)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*0.0/Fp/Fp/Fp);
  T1_Vsi_bi_Vdbulk_di=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vsi_bi*(-((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vdbulk_di)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vdbulk_di+((pModel->PCLMG*qia_Vdbulk_di))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vdbulk_di)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vdbulk_di/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*0.0/Fp/Fp/Fp);
  T1_Vsi_bi_Vsbulk_si=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vsi_bi*(-((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vsbulk_si)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vsbulk_si+((pModel->PCLMG*qia_Vsbulk_si))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vsbulk_si)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vsbulk_si/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0+(-PCLM_a*(-((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*0.0/Fp/Fp/Fp);
  T1_Vsi_bi_Vgi_bi=((0.0/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vsi_bi*(-((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))+0.0*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vgi_bi)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vgi_bi+((pModel->PCLMG*qia_Vgi_bi))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vgi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi+(-PCLM_a*(-((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi_Vgi_bi)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*Fp_Vgi_bi/Fp/Fp/Fp);
  T1_Vsi_bi_Vdi_bi=((PCLM_a_Vsi_bi_Vdi_bi/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vsi_bi*(-((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))+PCLM_a_Vdi_bi*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vdi_bi)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vdi_bi+((pModel->PCLMG*qia_Vdi_bi))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vdi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi+((PCLM_a_Vdi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi_Vdi_bi)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*Fp_Vdi_bi/Fp/Fp/Fp);
  T1_Vsi_bi_Vsi_bi=((PCLM_a_Vsi_bi_Vsi_bi/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vsi_bi*(-((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a_Vsi_bi*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vsi_bi)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vsi_bi+((pModel->PCLMG*qia_Vsi_bi))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vsi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi_Vsi_bi)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*Fp_Vsi_bi/Fp/Fp/Fp);
  T1_Vsi_bi_Tempt_GND=((PCLM_a_Vsi_bi_Tempt_GND/(1.0-((pModel->PCLMG*qia)/EsatL))-(PCLM_a_Vsi_bi*(-((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+PCLM_a_Tempt_GND*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))+PCLM_a*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Tempt_GND)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Tempt_GND+((pModel->PCLMG*qia_Tempt_GND))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Tempt_GND)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))+2*PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))*(-((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Tempt_GND+((PCLM_a_Tempt_GND*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi+(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi_Tempt_GND)/Fp/Fp+2*(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*Fp_Tempt_GND/Fp/Fp/Fp);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((((PCLM_a_Tempt_GND*(1.0-((pModel->PCLMG*qia)/EsatL))-PCLM_a*(-(((pModel->PCLMG*qia_Tempt_GND)*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL)))/(1.0-((pModel->PCLMG*qia)/EsatL))/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp-(PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))*Fp_Tempt_GND)/Fp/Fp);
#endif
#endif
T1=((PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp);
EXIT_IF_ISNAN(((PCLM_a/(1.0-((pModel->PCLMG*qia)/EsatL)))/Fp))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(((PCLM_a*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*Fp-(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi)/Fp/Fp);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+0.0*((0.0)/EsatL)+0.0*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*0.0+0.0*qia_Vgi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*0.0+(0.0)*EsatL_Vgi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*0.0/EsatL/EsatL/EsatL)))/Fp-((PCLM_a*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*0.0+((PCLM_a*((0.0)/EsatL)))*Fp_Vgi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*0.0/Fp/Fp/Fp);
  T1_Vgi_bi_Vgm_si=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+0.0*((0.0)/EsatL)+0.0*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*0.0+0.0*qia_Vgi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*0.0+(0.0)*EsatL_Vgi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*0.0/EsatL/EsatL/EsatL)))/Fp-((PCLM_a*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*0.0+((PCLM_a*((0.0)/EsatL)))*Fp_Vgi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*0.0/Fp/Fp/Fp);
  T1_Vgi_bi_Vdbulk_di=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+0.0*((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL)+0.0*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vdbulk_di)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vdbulk_di+((pModel->PCLMG*qia_Vdbulk_di))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vdbulk_di)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vdbulk_di/EsatL/EsatL/EsatL)))/Fp-((PCLM_a*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*0.0+((PCLM_a*((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL)))*Fp_Vgi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*0.0/Fp/Fp/Fp);
  T1_Vgi_bi_Vsbulk_si=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+0.0*((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL)+0.0*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vsbulk_si)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vsbulk_si+((pModel->PCLMG*qia_Vsbulk_si))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vsbulk_si)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vsbulk_si/EsatL/EsatL/EsatL)))/Fp-((PCLM_a*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*0.0+((PCLM_a*((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL)))*Fp_Vgi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*0.0/Fp/Fp/Fp);
  T1_Vgi_bi_Vgi_bi=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+0.0*((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+0.0*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vgi_bi)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vgi_bi+((pModel->PCLMG*qia_Vgi_bi))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vgi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL)))/Fp-((PCLM_a*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*Fp_Vgi_bi+((PCLM_a*((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)))*Fp_Vgi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi_Vgi_bi)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*Fp_Vgi_bi/Fp/Fp/Fp);
  T1_Vgi_bi_Vdi_bi=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+0.0*((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a_Vdi_bi*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vdi_bi)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vdi_bi+((pModel->PCLMG*qia_Vdi_bi))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vdi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL)))/Fp-((PCLM_a*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*Fp_Vdi_bi+(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))))*Fp_Vgi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi_Vdi_bi)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*Fp_Vdi_bi/Fp/Fp/Fp);
  T1_Vgi_bi_Vsi_bi=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+0.0*((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a_Vsi_bi*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Vsi_bi)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Vsi_bi+((pModel->PCLMG*qia_Vsi_bi))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Vsi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL)))/Fp-((PCLM_a*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*Fp_Vsi_bi+(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))))*Fp_Vgi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi_Vsi_bi)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*Fp_Vsi_bi/Fp/Fp/Fp);
  T1_Vgi_bi_Tempt_GND=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+0.0*((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL)+PCLM_a_Tempt_GND*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vgi_bi+pModel->PCLMG*qia_Vgi_bi_Tempt_GND)/EsatL-((pModel->PCLMG*qia_Vgi_bi)*EsatL_Tempt_GND+((pModel->PCLMG*qia_Tempt_GND))*EsatL_Vgi_bi+(pModel->PCLMG*qia)*EsatL_Vgi_bi_Tempt_GND)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vgi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/Fp-((PCLM_a*(((pModel->PCLMG*qia_Vgi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL))*Fp_Tempt_GND+(((PCLM_a_Tempt_GND*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL))))*Fp_Vgi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi_Tempt_GND)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vgi_bi*Fp_Tempt_GND/Fp/Fp/Fp);
#endif
T1_Vdi_bi=((((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))*Fp-(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi)/Fp/Fp);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vdi_bi*((0.0)/EsatL)+0.0*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*0.0+0.0*qia_Vdi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*0.0+(0.0)*EsatL_Vdi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*0.0/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))*0.0+((PCLM_a*((0.0)/EsatL)))*Fp_Vdi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*0.0/Fp/Fp/Fp);
  T1_Vdi_bi_Vgm_si=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vdi_bi*((0.0)/EsatL)+0.0*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*0.0+0.0*qia_Vdi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*0.0+(0.0)*EsatL_Vdi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*0.0/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))*0.0+((PCLM_a*((0.0)/EsatL)))*Fp_Vdi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*0.0/Fp/Fp/Fp);
  T1_Vdi_bi_Vdbulk_di=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vdi_bi*((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL)+0.0*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vdbulk_di)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vdbulk_di+((pModel->PCLMG*qia_Vdbulk_di))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vdbulk_di)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vdbulk_di/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))*0.0+((PCLM_a*((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL)))*Fp_Vdi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*0.0/Fp/Fp/Fp);
  T1_Vdi_bi_Vsbulk_si=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vdi_bi*((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL)+0.0*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vsbulk_si)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vsbulk_si+((pModel->PCLMG*qia_Vsbulk_si))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vsbulk_si)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vsbulk_si/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))*0.0+((PCLM_a*((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL)))*Fp_Vdi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*0.0/Fp/Fp/Fp);
  T1_Vdi_bi_Vgi_bi=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vdi_bi*((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+0.0*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vgi_bi)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vgi_bi+((pModel->PCLMG*qia_Vgi_bi))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vgi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))*Fp_Vgi_bi+((PCLM_a*((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)))*Fp_Vdi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi_Vgi_bi)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*Fp_Vgi_bi/Fp/Fp/Fp);
  T1_Vdi_bi_Vdi_bi=((+PCLM_a_Vdi_bi_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vdi_bi*((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a_Vdi_bi*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vdi_bi)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vdi_bi+((pModel->PCLMG*qia_Vdi_bi))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vdi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))*Fp_Vdi_bi+(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))))*Fp_Vdi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi_Vdi_bi)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*Fp_Vdi_bi/Fp/Fp/Fp);
  T1_Vdi_bi_Vsi_bi=((+PCLM_a_Vdi_bi_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vdi_bi*((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a_Vsi_bi*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Vsi_bi)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Vsi_bi+((pModel->PCLMG*qia_Vsi_bi))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Vsi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))*Fp_Vsi_bi+(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))))*Fp_Vdi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi_Vsi_bi)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*Fp_Vsi_bi/Fp/Fp/Fp);
  T1_Vdi_bi_Tempt_GND=((+PCLM_a_Vdi_bi_Tempt_GND*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vdi_bi*((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL)+PCLM_a_Tempt_GND*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_bi+pModel->PCLMG*qia_Vdi_bi_Tempt_GND)/EsatL-((pModel->PCLMG*qia_Vdi_bi)*EsatL_Tempt_GND+((pModel->PCLMG*qia_Tempt_GND))*EsatL_Vdi_bi+(pModel->PCLMG*qia)*EsatL_Vdi_bi_Tempt_GND)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vdi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vdi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)))*Fp_Tempt_GND+(((PCLM_a_Tempt_GND*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL))))*Fp_Vdi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi_Tempt_GND)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vdi_bi*Fp_Tempt_GND/Fp/Fp/Fp);
#endif
T1_Vsi_bi=((((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))*Fp-(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi)/Fp/Fp);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vsi_bi*((0.0)/EsatL)+0.0*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*0.0+0.0*qia_Vsi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*0.0+(0.0)*EsatL_Vsi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*0.0/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))*0.0+((PCLM_a*((0.0)/EsatL)))*Fp_Vsi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*0.0/Fp/Fp/Fp);
  T1_Vsi_bi_Vgm_si=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vsi_bi*((0.0)/EsatL)+0.0*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*0.0+0.0*qia_Vsi_bi+pModel->PCLMG*0.0)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*0.0+(0.0)*EsatL_Vsi_bi+(pModel->PCLMG*qia)*0.0)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*0.0/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))*0.0+((PCLM_a*((0.0)/EsatL)))*Fp_Vsi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*0.0/Fp/Fp/Fp);
  T1_Vsi_bi_Vdbulk_di=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vsi_bi*((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL)+0.0*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vdbulk_di)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vdbulk_di+((pModel->PCLMG*qia_Vdbulk_di))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vdbulk_di)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vdbulk_di/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))*0.0+((PCLM_a*((((pModel->PCLMG*qia_Vdbulk_di))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdbulk_di)/EsatL/EsatL)))*Fp_Vsi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*0.0/Fp/Fp/Fp);
  T1_Vsi_bi_Vsbulk_si=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vsi_bi*((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL)+0.0*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vsbulk_si)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vsbulk_si+((pModel->PCLMG*qia_Vsbulk_si))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vsbulk_si)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vsbulk_si/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))*0.0+((PCLM_a*((((pModel->PCLMG*qia_Vsbulk_si))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsbulk_si)/EsatL/EsatL)))*Fp_Vsi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*0.0)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*0.0/Fp/Fp/Fp);
  T1_Vsi_bi_Vgi_bi=((+0.0*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vsi_bi*((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)+0.0*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vgi_bi)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vgi_bi+((pModel->PCLMG*qia_Vgi_bi))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vgi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vgi_bi/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))*Fp_Vgi_bi+((PCLM_a*((((pModel->PCLMG*qia_Vgi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vgi_bi)/EsatL/EsatL)))*Fp_Vsi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi_Vgi_bi)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*Fp_Vgi_bi/Fp/Fp/Fp);
  T1_Vsi_bi_Vdi_bi=((+PCLM_a_Vsi_bi_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vsi_bi*((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL)+PCLM_a_Vdi_bi*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vdi_bi)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vdi_bi+((pModel->PCLMG*qia_Vdi_bi))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vdi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vdi_bi/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))*Fp_Vdi_bi+(((PCLM_a_Vdi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*((((pModel->PCLMG*qia_Vdi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vdi_bi)/EsatL/EsatL))))*Fp_Vsi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi_Vdi_bi)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*Fp_Vdi_bi/Fp/Fp/Fp);
  T1_Vsi_bi_Vsi_bi=((+PCLM_a_Vsi_bi_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vsi_bi*((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a_Vsi_bi*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Vsi_bi)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Vsi_bi+((pModel->PCLMG*qia_Vsi_bi))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Vsi_bi)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Vsi_bi/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))*Fp_Vsi_bi+(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*((((pModel->PCLMG*qia_Vsi_bi))*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL))))*Fp_Vsi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi_Vsi_bi)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*Fp_Vsi_bi/Fp/Fp/Fp);
  T1_Vsi_bi_Tempt_GND=((+PCLM_a_Vsi_bi_Tempt_GND*(1.0+((pModel->PCLMG*qia)/EsatL))+PCLM_a_Vsi_bi*((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL)+PCLM_a_Tempt_GND*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)+PCLM_a*(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vsi_bi+pModel->PCLMG*qia_Vsi_bi_Tempt_GND)/EsatL-((pModel->PCLMG*qia_Vsi_bi)*EsatL_Tempt_GND+((pModel->PCLMG*qia_Tempt_GND))*EsatL_Vsi_bi+(pModel->PCLMG*qia)*EsatL_Vsi_bi_Tempt_GND)/EsatL/EsatL+2*(pModel->PCLMG*qia)*EsatL_Vsi_bi*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/Fp-(((PCLM_a_Vsi_bi*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Vsi_bi)*EsatL-(pModel->PCLMG*qia)*EsatL_Vsi_bi)/EsatL/EsatL)))*Fp_Tempt_GND+(((PCLM_a_Tempt_GND*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*((((pModel->PCLMG*qia_Tempt_GND))*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL))))*Fp_Vsi_bi+(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi_Tempt_GND)/Fp/Fp+2*(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Vsi_bi*Fp_Tempt_GND/Fp/Fp/Fp);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((((PCLM_a_Tempt_GND*(1.0+((pModel->PCLMG*qia)/EsatL)))+(PCLM_a*(((pModel->PCLMG*qia_Tempt_GND)*EsatL-(pModel->PCLMG*qia)*EsatL_Tempt_GND)/EsatL/EsatL)))*Fp-(PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))*Fp_Tempt_GND)/Fp/Fp);
#endif
#endif
T1=((PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))/Fp);
EXIT_IF_ISNAN(((PCLM_a*(1.0+((pModel->PCLMG*qia)/EsatL)))/Fp))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
MdL_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  MdL_Vdbulk_di_Vdbulk_di=0.0;
  MdL_Vdbulk_di_Vsbulk_si=0.0;
  MdL_Vdbulk_di_Vgi_bi=0.0;
  MdL_Vdbulk_di_Vdi_bi=0.0;
  MdL_Vdbulk_di_Vsi_bi=0.0;
  MdL_Vdbulk_di_Tempt_GND=0.0;
#endif
MdL_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  MdL_Vsbulk_si_Vdbulk_di=0.0;
  MdL_Vsbulk_si_Vsbulk_si=0.0;
  MdL_Vsbulk_si_Vgi_bi=0.0;
  MdL_Vsbulk_si_Vdi_bi=0.0;
  MdL_Vsbulk_si_Vsi_bi=0.0;
  MdL_Vsbulk_si_Tempt_GND=0.0;
#endif
MdL_Vgi_bi=((T1_Vgi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat))))+(T1*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))));
#if defined(_DERIVATE2)
  MdL_Vgi_bi_Vdbulk_di=(+0.0+(+T1_Vgi_bi_Vdbulk_di*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vgi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1_Vdbulk_di*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vgi_bi_Vdbulk_di/T1-(diffVds_Vgi_bi*T1_Vdbulk_di+diffVds_Vdbulk_di*T1_Vgi_bi+diffVds*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*diffVds*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1)/Vasat-(((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat_Vdbulk_di+((diffVds_Vdbulk_di*T1-diffVds*T1_Vdbulk_di)/T1/T1)*Vasat_Vgi_bi+(diffVds/T1)*Vasat_Vgi_bi_Vdbulk_di)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vgi_bi*Vasat_Vdbulk_di/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Vsbulk_si=(+0.0+(+T1_Vgi_bi_Vsbulk_si*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vgi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1_Vsbulk_si*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vgi_bi_Vsbulk_si/T1-(diffVds_Vgi_bi*T1_Vsbulk_si+diffVds_Vsbulk_si*T1_Vgi_bi+diffVds*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*diffVds*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1)/Vasat-(((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat_Vsbulk_si+((diffVds_Vsbulk_si*T1-diffVds*T1_Vsbulk_si)/T1/T1)*Vasat_Vgi_bi+(diffVds/T1)*Vasat_Vgi_bi_Vsbulk_si)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vgi_bi*Vasat_Vsbulk_si/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Vgi_bi=(+0.0+(+T1_Vgi_bi_Vgi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vgi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1_Vgi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vgi_bi_Vgi_bi/T1-(diffVds_Vgi_bi*T1_Vgi_bi+diffVds_Vgi_bi*T1_Vgi_bi+diffVds*T1_Vgi_bi_Vgi_bi)/T1/T1+2*diffVds*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1)/Vasat-(((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat_Vgi_bi+((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat_Vgi_bi+(diffVds/T1)*Vasat_Vgi_bi_Vgi_bi)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vgi_bi*Vasat_Vgi_bi/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Vdi_bi=(+0.0+(+T1_Vgi_bi_Vdi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vgi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1_Vdi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vgi_bi_Vdi_bi/T1-(diffVds_Vgi_bi*T1_Vdi_bi+diffVds_Vdi_bi*T1_Vgi_bi+diffVds*T1_Vgi_bi_Vdi_bi)/T1/T1+2*diffVds*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1)/Vasat-(((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat_Vdi_bi+((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat_Vgi_bi+(diffVds/T1)*Vasat_Vgi_bi_Vdi_bi)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vgi_bi*Vasat_Vdi_bi/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Vsi_bi=(+0.0+(+T1_Vgi_bi_Vsi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vgi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1_Vsi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vgi_bi_Vsi_bi/T1-(diffVds_Vgi_bi*T1_Vsi_bi+diffVds_Vsi_bi*T1_Vgi_bi+diffVds*T1_Vgi_bi_Vsi_bi)/T1/T1+2*diffVds*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1)/Vasat-(((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat_Vsi_bi+((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat_Vgi_bi+(diffVds/T1)*Vasat_Vgi_bi_Vsi_bi)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vgi_bi*Vasat_Vsi_bi/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Tempt_GND=(+0.0+(+T1_Vgi_bi_Tempt_GND*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vgi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1_Tempt_GND*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vgi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vgi_bi_Tempt_GND/T1-(diffVds_Vgi_bi*T1_Tempt_GND+diffVds_Tempt_GND*T1_Vgi_bi+diffVds*T1_Vgi_bi_Tempt_GND)/T1/T1+2*diffVds*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1)/Vasat-(((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat_Tempt_GND+((diffVds_Tempt_GND*T1-diffVds*T1_Tempt_GND)/T1/T1)*Vasat_Vgi_bi+(diffVds/T1)*Vasat_Vgi_bi_Tempt_GND)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vgi_bi*Vasat_Tempt_GND/Vasat/Vasat/Vasat))));
#endif
MdL_Vdi_bi=((T1_Vdi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat))))+(T1*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))));
#if defined(_DERIVATE2)
  MdL_Vdi_bi_Vdbulk_di=(+0.0+(+T1_Vdi_bi_Vdbulk_di*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vdi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1_Vdbulk_di*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vdi_bi_Vdbulk_di/T1-(diffVds_Vdi_bi*T1_Vdbulk_di+diffVds_Vdbulk_di*T1_Vdi_bi+diffVds*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*diffVds*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1)/Vasat-(((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat_Vdbulk_di+((diffVds_Vdbulk_di*T1-diffVds*T1_Vdbulk_di)/T1/T1)*Vasat_Vdi_bi+(diffVds/T1)*Vasat_Vdi_bi_Vdbulk_di)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vdi_bi*Vasat_Vdbulk_di/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Vsbulk_si=(+0.0+(+T1_Vdi_bi_Vsbulk_si*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vdi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1_Vsbulk_si*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vdi_bi_Vsbulk_si/T1-(diffVds_Vdi_bi*T1_Vsbulk_si+diffVds_Vsbulk_si*T1_Vdi_bi+diffVds*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*diffVds*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1)/Vasat-(((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat_Vsbulk_si+((diffVds_Vsbulk_si*T1-diffVds*T1_Vsbulk_si)/T1/T1)*Vasat_Vdi_bi+(diffVds/T1)*Vasat_Vdi_bi_Vsbulk_si)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vdi_bi*Vasat_Vsbulk_si/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Vgi_bi=(+0.0+(+T1_Vdi_bi_Vgi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vdi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1_Vgi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vdi_bi_Vgi_bi/T1-(diffVds_Vdi_bi*T1_Vgi_bi+diffVds_Vgi_bi*T1_Vdi_bi+diffVds*T1_Vdi_bi_Vgi_bi)/T1/T1+2*diffVds*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1)/Vasat-(((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat_Vgi_bi+((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat_Vdi_bi+(diffVds/T1)*Vasat_Vdi_bi_Vgi_bi)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vdi_bi*Vasat_Vgi_bi/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Vdi_bi=(+0.0+(+T1_Vdi_bi_Vdi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vdi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1_Vdi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vdi_bi_Vdi_bi/T1-(diffVds_Vdi_bi*T1_Vdi_bi+diffVds_Vdi_bi*T1_Vdi_bi+diffVds*T1_Vdi_bi_Vdi_bi)/T1/T1+2*diffVds*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1)/Vasat-(((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat_Vdi_bi+((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat_Vdi_bi+(diffVds/T1)*Vasat_Vdi_bi_Vdi_bi)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vdi_bi*Vasat_Vdi_bi/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Vsi_bi=(+0.0+(+T1_Vdi_bi_Vsi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vdi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1_Vsi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vdi_bi_Vsi_bi/T1-(diffVds_Vdi_bi*T1_Vsi_bi+diffVds_Vsi_bi*T1_Vdi_bi+diffVds*T1_Vdi_bi_Vsi_bi)/T1/T1+2*diffVds*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1)/Vasat-(((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat_Vsi_bi+((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat_Vdi_bi+(diffVds/T1)*Vasat_Vdi_bi_Vsi_bi)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vdi_bi*Vasat_Vsi_bi/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Tempt_GND=(+0.0+(+T1_Vdi_bi_Tempt_GND*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vdi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1_Tempt_GND*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vdi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vdi_bi_Tempt_GND/T1-(diffVds_Vdi_bi*T1_Tempt_GND+diffVds_Tempt_GND*T1_Vdi_bi+diffVds*T1_Vdi_bi_Tempt_GND)/T1/T1+2*diffVds*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1)/Vasat-(((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat_Tempt_GND+((diffVds_Tempt_GND*T1-diffVds*T1_Tempt_GND)/T1/T1)*Vasat_Vdi_bi+(diffVds/T1)*Vasat_Vdi_bi_Tempt_GND)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vdi_bi*Vasat_Tempt_GND/Vasat/Vasat/Vasat))));
#endif
MdL_Vsi_bi=((T1_Vsi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat))))+(T1*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))));
#if defined(_DERIVATE2)
  MdL_Vsi_bi_Vdbulk_di=(+0.0+(+T1_Vsi_bi_Vdbulk_di*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vsi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1_Vdbulk_di*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vsi_bi_Vdbulk_di/T1-(diffVds_Vsi_bi*T1_Vdbulk_di+diffVds_Vdbulk_di*T1_Vsi_bi+diffVds*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*diffVds*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1)/Vasat-(((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat_Vdbulk_di+((diffVds_Vdbulk_di*T1-diffVds*T1_Vdbulk_di)/T1/T1)*Vasat_Vsi_bi+(diffVds/T1)*Vasat_Vsi_bi_Vdbulk_di)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vsi_bi*Vasat_Vdbulk_di/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Vsbulk_si=(+0.0+(+T1_Vsi_bi_Vsbulk_si*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vsi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1_Vsbulk_si*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vsi_bi_Vsbulk_si/T1-(diffVds_Vsi_bi*T1_Vsbulk_si+diffVds_Vsbulk_si*T1_Vsi_bi+diffVds*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*diffVds*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1)/Vasat-(((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat_Vsbulk_si+((diffVds_Vsbulk_si*T1-diffVds*T1_Vsbulk_si)/T1/T1)*Vasat_Vsi_bi+(diffVds/T1)*Vasat_Vsi_bi_Vsbulk_si)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vsi_bi*Vasat_Vsbulk_si/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Vgi_bi=(+0.0+(+T1_Vsi_bi_Vgi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vsi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1_Vgi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vsi_bi_Vgi_bi/T1-(diffVds_Vsi_bi*T1_Vgi_bi+diffVds_Vgi_bi*T1_Vsi_bi+diffVds*T1_Vsi_bi_Vgi_bi)/T1/T1+2*diffVds*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1)/Vasat-(((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat_Vgi_bi+((diffVds_Vgi_bi*T1-diffVds*T1_Vgi_bi)/T1/T1)*Vasat_Vsi_bi+(diffVds/T1)*Vasat_Vsi_bi_Vgi_bi)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vsi_bi*Vasat_Vgi_bi/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Vdi_bi=(+0.0+(+T1_Vsi_bi_Vdi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vsi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1_Vdi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vsi_bi_Vdi_bi/T1-(diffVds_Vsi_bi*T1_Vdi_bi+diffVds_Vdi_bi*T1_Vsi_bi+diffVds*T1_Vsi_bi_Vdi_bi)/T1/T1+2*diffVds*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1)/Vasat-(((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat_Vdi_bi+((diffVds_Vdi_bi*T1-diffVds*T1_Vdi_bi)/T1/T1)*Vasat_Vsi_bi+(diffVds/T1)*Vasat_Vsi_bi_Vdi_bi)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vsi_bi*Vasat_Vdi_bi/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Vsi_bi=(+0.0+(+T1_Vsi_bi_Vsi_bi*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vsi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1_Vsi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vsi_bi_Vsi_bi/T1-(diffVds_Vsi_bi*T1_Vsi_bi+diffVds_Vsi_bi*T1_Vsi_bi+diffVds*T1_Vsi_bi_Vsi_bi)/T1/T1+2*diffVds*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1)/Vasat-(((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat_Vsi_bi+((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat_Vsi_bi+(diffVds/T1)*Vasat_Vsi_bi_Vsi_bi)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vsi_bi*Vasat_Vsi_bi/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Tempt_GND=(+0.0+(+T1_Vsi_bi_Tempt_GND*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))+T1_Vsi_bi*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1_Tempt_GND*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Vsi_bi)/Vasat/Vasat))+T1*(+0.0+((diffVds_Vsi_bi_Tempt_GND/T1-(diffVds_Vsi_bi*T1_Tempt_GND+diffVds_Tempt_GND*T1_Vsi_bi+diffVds*T1_Vsi_bi_Tempt_GND)/T1/T1+2*diffVds*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1)/Vasat-(((diffVds_Vsi_bi*T1-diffVds*T1_Vsi_bi)/T1/T1)*Vasat_Tempt_GND+((diffVds_Tempt_GND*T1-diffVds*T1_Tempt_GND)/T1/T1)*Vasat_Vsi_bi+(diffVds/T1)*Vasat_Vsi_bi_Tempt_GND)/Vasat/Vasat+2*(diffVds/T1)*Vasat_Vsi_bi*Vasat_Tempt_GND/Vasat/Vasat/Vasat))));
#endif
#if defined(_DERIVATE)
MdL_Tempt_GND=((T1_Tempt_GND*bsimbulk_lln((1.0+((diffVds/T1)/Vasat))))+(T1*bsimbulk_d_lln((1.0+((diffVds/T1)/Vasat)),((((diffVds_Tempt_GND*T1-diffVds*T1_Tempt_GND)/T1/T1)*Vasat-(diffVds/T1)*Vasat_Tempt_GND)/Vasat/Vasat))));
#endif
#endif
MdL=(1.0+(T1*bsimbulk_lln((1.0+((diffVds/T1)/Vasat)))));
EXIT_IF_ISNAN((1.0+(T1*bsimbulk_lln((1.0+((diffVds/T1)/Vasat))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
MdL_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  MdL_Vdbulk_di_Vdbulk_di=0.0;
  MdL_Vdbulk_di_Vsbulk_si=0.0;
  MdL_Vdbulk_di_Vgi_bi=0.0;
  MdL_Vdbulk_di_Vdi_bi=0.0;
  MdL_Vdbulk_di_Vsi_bi=0.0;
  MdL_Vdbulk_di_Tempt_GND=0.0;
#endif
MdL_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  MdL_Vsbulk_si_Vdbulk_di=0.0;
  MdL_Vsbulk_si_Vsbulk_si=0.0;
  MdL_Vsbulk_si_Vgi_bi=0.0;
  MdL_Vsbulk_si_Vdi_bi=0.0;
  MdL_Vsbulk_si_Vsi_bi=0.0;
  MdL_Vsbulk_si_Tempt_GND=0.0;
#endif
MdL_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  MdL_Vgi_bi_Vdbulk_di=0.0;
  MdL_Vgi_bi_Vsbulk_si=0.0;
  MdL_Vgi_bi_Vgi_bi=0.0;
  MdL_Vgi_bi_Vdi_bi=0.0;
  MdL_Vgi_bi_Vsi_bi=0.0;
  MdL_Vgi_bi_Tempt_GND=0.0;
#endif
MdL_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  MdL_Vdi_bi_Vdbulk_di=0.0;
  MdL_Vdi_bi_Vsbulk_si=0.0;
  MdL_Vdi_bi_Vgi_bi=0.0;
  MdL_Vdi_bi_Vdi_bi=0.0;
  MdL_Vdi_bi_Vsi_bi=0.0;
  MdL_Vdi_bi_Tempt_GND=0.0;
#endif
MdL_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  MdL_Vsi_bi_Vdbulk_di=0.0;
  MdL_Vsi_bi_Vsbulk_si=0.0;
  MdL_Vsi_bi_Vgi_bi=0.0;
  MdL_Vsi_bi_Vdi_bi=0.0;
  MdL_Vsi_bi_Vsi_bi=0.0;
  MdL_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
MdL_Tempt_GND=0.0;
#endif
#endif
MdL=1.0;
EXIT_IF_ISNAN(1.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Moc_Vdi_bi=((Moc_Vdi_bi*MdL)+(Moc*MdL_Vdi_bi));
#if defined(_DERIVATE2)
  Moc_Vdi_bi_Vdi_bi=(+Moc_Vdi_bi_Vdi_bi*MdL+Moc_Vdi_bi*MdL_Vdi_bi+Moc_Vdi_bi*MdL_Vdi_bi+Moc*MdL_Vdi_bi_Vdi_bi);
  Moc_Vdi_bi_Vsi_bi=(+Moc_Vdi_bi_Vsi_bi*MdL+Moc_Vdi_bi*MdL_Vsi_bi+Moc_Vsi_bi*MdL_Vdi_bi+Moc*MdL_Vdi_bi_Vsi_bi);
  Moc_Vdi_bi_Vgi_bi=(+Moc_Vdi_bi_Vgi_bi*MdL+Moc_Vdi_bi*MdL_Vgi_bi+Moc_Vgi_bi*MdL_Vdi_bi+Moc*MdL_Vdi_bi_Vgi_bi);
  Moc_Vdi_bi_Tempt_GND=(+Moc_Vdi_bi_Tempt_GND*MdL+Moc_Vdi_bi*MdL_Tempt_GND+Moc_Tempt_GND*MdL_Vdi_bi+Moc*MdL_Vdi_bi_Tempt_GND);
#endif
Moc_Vsi_bi=((Moc_Vsi_bi*MdL)+(Moc*MdL_Vsi_bi));
#if defined(_DERIVATE2)
  Moc_Vsi_bi_Vdi_bi=(+Moc_Vsi_bi_Vdi_bi*MdL+Moc_Vsi_bi*MdL_Vdi_bi+Moc_Vdi_bi*MdL_Vsi_bi+Moc*MdL_Vsi_bi_Vdi_bi);
  Moc_Vsi_bi_Vsi_bi=(+Moc_Vsi_bi_Vsi_bi*MdL+Moc_Vsi_bi*MdL_Vsi_bi+Moc_Vsi_bi*MdL_Vsi_bi+Moc*MdL_Vsi_bi_Vsi_bi);
  Moc_Vsi_bi_Vgi_bi=(+Moc_Vsi_bi_Vgi_bi*MdL+Moc_Vsi_bi*MdL_Vgi_bi+Moc_Vgi_bi*MdL_Vsi_bi+Moc*MdL_Vsi_bi_Vgi_bi);
  Moc_Vsi_bi_Tempt_GND=(+Moc_Vsi_bi_Tempt_GND*MdL+Moc_Vsi_bi*MdL_Tempt_GND+Moc_Tempt_GND*MdL_Vsi_bi+Moc*MdL_Vsi_bi_Tempt_GND);
#endif
Moc_Vgi_bi=((Moc_Vgi_bi*MdL)+(Moc*MdL_Vgi_bi));
#if defined(_DERIVATE2)
  Moc_Vgi_bi_Vdi_bi=(+Moc_Vgi_bi_Vdi_bi*MdL+Moc_Vgi_bi*MdL_Vdi_bi+Moc_Vdi_bi*MdL_Vgi_bi+Moc*MdL_Vgi_bi_Vdi_bi);
  Moc_Vgi_bi_Vsi_bi=(+Moc_Vgi_bi_Vsi_bi*MdL+Moc_Vgi_bi*MdL_Vsi_bi+Moc_Vsi_bi*MdL_Vgi_bi+Moc*MdL_Vgi_bi_Vsi_bi);
  Moc_Vgi_bi_Vgi_bi=(+Moc_Vgi_bi_Vgi_bi*MdL+Moc_Vgi_bi*MdL_Vgi_bi+Moc_Vgi_bi*MdL_Vgi_bi+Moc*MdL_Vgi_bi_Vgi_bi);
  Moc_Vgi_bi_Tempt_GND=(+Moc_Vgi_bi_Tempt_GND*MdL+Moc_Vgi_bi*MdL_Tempt_GND+Moc_Tempt_GND*MdL_Vgi_bi+Moc*MdL_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Moc_Tempt_GND=((Moc_Tempt_GND*MdL)+(Moc*MdL_Tempt_GND));
#endif
#endif
Moc=(Moc*MdL);
EXIT_IF_ISNAN((Moc*MdL))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=bsimbulk_d_lexp((PDITSD_i*Vds),(PDITSD_i*Vds_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+PDITSD_i*0.0);
  T1_Vdi_bi_Vgm_si=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+PDITSD_i*0.0);
  T1_Vdi_bi_Vdbulk_di=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+PDITSD_i*0.0);
  T1_Vdi_bi_Vsbulk_si=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+PDITSD_i*0.0);
  T1_Vdi_bi_Vgi_bi=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+PDITSD_i*0.0);
  T1_Vdi_bi_Vdi_bi=(+0.0*Vds+0.0*Vds_Vdi_bi+0.0*Vds_Vdi_bi+PDITSD_i*Vds_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+0.0*Vds+0.0*Vds_Vsi_bi+0.0*Vds_Vdi_bi+PDITSD_i*Vds_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+0.0*Vds+0.0*0.0+0.0*Vds_Vdi_bi+PDITSD_i*0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp((PDITSD_i*Vds),(PDITSD_i*Vds_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+PDITSD_i*0.0);
  T1_Vsi_bi_Vgm_si=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+PDITSD_i*0.0);
  T1_Vsi_bi_Vdbulk_di=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+PDITSD_i*0.0);
  T1_Vsi_bi_Vsbulk_si=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+PDITSD_i*0.0);
  T1_Vsi_bi_Vgi_bi=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+PDITSD_i*0.0);
  T1_Vsi_bi_Vdi_bi=(+0.0*Vds+0.0*Vds_Vdi_bi+0.0*Vds_Vsi_bi+PDITSD_i*Vds_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+0.0*Vds+0.0*Vds_Vsi_bi+0.0*Vds_Vsi_bi+PDITSD_i*Vds_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+0.0*Vds+0.0*0.0+0.0*Vds_Vsi_bi+PDITSD_i*0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=bsimbulk_lexp((PDITSD_i*Vds));
EXIT_IF_ISNAN(bsimbulk_lexp((PDITSD_i*Vds)))
if
((PDITS_i>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=0.0;
#endif
#endif
T2=(1.0+(pModel->PDITSL*Leff));
EXIT_IF_ISNAN((1.0+(pModel->PDITSL*Leff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
VaDITS_Vgi_bi=(((T2_Vgi_bi*T1)+(T2*T1_Vgi_bi))/PDITS_i);
#if defined(_DERIVATE2)
  VaDITS_Vgi_bi_Vgi_bi=((+0.0+(+T2_Vgi_bi_Vgi_bi*T1+T2_Vgi_bi*T1_Vgi_bi+T2_Vgi_bi*T1_Vgi_bi+T2*T1_Vgi_bi_Vgi_bi))/PDITS_i-(((T2_Vgi_bi*T1)+(T2*T1_Vgi_bi))*0.0+(((T2_Vgi_bi*T1)+(T2*T1_Vgi_bi)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
  VaDITS_Vgi_bi_Vdi_bi=((+0.0+(+T2_Vgi_bi_Vdi_bi*T1+T2_Vgi_bi*T1_Vdi_bi+T2_Vdi_bi*T1_Vgi_bi+T2*T1_Vgi_bi_Vdi_bi))/PDITS_i-(((T2_Vgi_bi*T1)+(T2*T1_Vgi_bi))*0.0+(((T2_Vdi_bi*T1)+(T2*T1_Vdi_bi)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
  VaDITS_Vgi_bi_Vsi_bi=((+0.0+(+T2_Vgi_bi_Vsi_bi*T1+T2_Vgi_bi*T1_Vsi_bi+T2_Vsi_bi*T1_Vgi_bi+T2*T1_Vgi_bi_Vsi_bi))/PDITS_i-(((T2_Vgi_bi*T1)+(T2*T1_Vgi_bi))*0.0+(((T2_Vsi_bi*T1)+(T2*T1_Vsi_bi)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
  VaDITS_Vgi_bi_Tempt_GND=((+0.0+(+T2_Vgi_bi_Tempt_GND*T1+T2_Vgi_bi*T1_Tempt_GND+T2_Tempt_GND*T1_Vgi_bi+T2*T1_Vgi_bi_Tempt_GND))/PDITS_i-(((T2_Vgi_bi*T1)+(T2*T1_Vgi_bi))*0.0+(((T2_Tempt_GND*T1)+(T2*T1_Tempt_GND)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
#endif
VaDITS_Vdi_bi=(((T2_Vdi_bi*T1)+(T2*T1_Vdi_bi))/PDITS_i);
#if defined(_DERIVATE2)
  VaDITS_Vdi_bi_Vgi_bi=((+0.0+(+T2_Vdi_bi_Vgi_bi*T1+T2_Vdi_bi*T1_Vgi_bi+T2_Vgi_bi*T1_Vdi_bi+T2*T1_Vdi_bi_Vgi_bi))/PDITS_i-(((T2_Vdi_bi*T1)+(T2*T1_Vdi_bi))*0.0+(((T2_Vgi_bi*T1)+(T2*T1_Vgi_bi)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
  VaDITS_Vdi_bi_Vdi_bi=((+0.0+(+T2_Vdi_bi_Vdi_bi*T1+T2_Vdi_bi*T1_Vdi_bi+T2_Vdi_bi*T1_Vdi_bi+T2*T1_Vdi_bi_Vdi_bi))/PDITS_i-(((T2_Vdi_bi*T1)+(T2*T1_Vdi_bi))*0.0+(((T2_Vdi_bi*T1)+(T2*T1_Vdi_bi)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
  VaDITS_Vdi_bi_Vsi_bi=((+0.0+(+T2_Vdi_bi_Vsi_bi*T1+T2_Vdi_bi*T1_Vsi_bi+T2_Vsi_bi*T1_Vdi_bi+T2*T1_Vdi_bi_Vsi_bi))/PDITS_i-(((T2_Vdi_bi*T1)+(T2*T1_Vdi_bi))*0.0+(((T2_Vsi_bi*T1)+(T2*T1_Vsi_bi)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
  VaDITS_Vdi_bi_Tempt_GND=((+0.0+(+T2_Vdi_bi_Tempt_GND*T1+T2_Vdi_bi*T1_Tempt_GND+T2_Tempt_GND*T1_Vdi_bi+T2*T1_Vdi_bi_Tempt_GND))/PDITS_i-(((T2_Vdi_bi*T1)+(T2*T1_Vdi_bi))*0.0+(((T2_Tempt_GND*T1)+(T2*T1_Tempt_GND)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
#endif
VaDITS_Vsi_bi=(((T2_Vsi_bi*T1)+(T2*T1_Vsi_bi))/PDITS_i);
#if defined(_DERIVATE2)
  VaDITS_Vsi_bi_Vgi_bi=((+0.0+(+T2_Vsi_bi_Vgi_bi*T1+T2_Vsi_bi*T1_Vgi_bi+T2_Vgi_bi*T1_Vsi_bi+T2*T1_Vsi_bi_Vgi_bi))/PDITS_i-(((T2_Vsi_bi*T1)+(T2*T1_Vsi_bi))*0.0+(((T2_Vgi_bi*T1)+(T2*T1_Vgi_bi)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
  VaDITS_Vsi_bi_Vdi_bi=((+0.0+(+T2_Vsi_bi_Vdi_bi*T1+T2_Vsi_bi*T1_Vdi_bi+T2_Vdi_bi*T1_Vsi_bi+T2*T1_Vsi_bi_Vdi_bi))/PDITS_i-(((T2_Vsi_bi*T1)+(T2*T1_Vsi_bi))*0.0+(((T2_Vdi_bi*T1)+(T2*T1_Vdi_bi)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
  VaDITS_Vsi_bi_Vsi_bi=((+0.0+(+T2_Vsi_bi_Vsi_bi*T1+T2_Vsi_bi*T1_Vsi_bi+T2_Vsi_bi*T1_Vsi_bi+T2*T1_Vsi_bi_Vsi_bi))/PDITS_i-(((T2_Vsi_bi*T1)+(T2*T1_Vsi_bi))*0.0+(((T2_Vsi_bi*T1)+(T2*T1_Vsi_bi)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
  VaDITS_Vsi_bi_Tempt_GND=((+0.0+(+T2_Vsi_bi_Tempt_GND*T1+T2_Vsi_bi*T1_Tempt_GND+T2_Tempt_GND*T1_Vsi_bi+T2*T1_Vsi_bi_Tempt_GND))/PDITS_i-(((T2_Vsi_bi*T1)+(T2*T1_Vsi_bi))*0.0+(((T2_Tempt_GND*T1)+(T2*T1_Tempt_GND)))*0.0+(1.0+(T2*T1))*0.0)/PDITS_i/PDITS_i+2*(1.0+(T2*T1))*0.0*0.0/PDITS_i/PDITS_i/PDITS_i);
#endif
#if defined(_DERIVATE)
VaDITS_Tempt_GND=(((T2_Tempt_GND*T1)+(T2*T1_Tempt_GND))/PDITS_i);
#endif
#endif
VaDITS=((1.0+(T2*T1))/PDITS_i);
EXIT_IF_ISNAN(((1.0+(T2*T1))/PDITS_i))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
VaDITS_Vgi_bi=((VaDITS_Vgi_bi*Fp)+(VaDITS*Fp_Vgi_bi));
#if defined(_DERIVATE2)
  VaDITS_Vgi_bi_Vgi_bi=(+VaDITS_Vgi_bi_Vgi_bi*Fp+VaDITS_Vgi_bi*Fp_Vgi_bi+VaDITS_Vgi_bi*Fp_Vgi_bi+VaDITS*Fp_Vgi_bi_Vgi_bi);
  VaDITS_Vgi_bi_Vdi_bi=(+VaDITS_Vgi_bi_Vdi_bi*Fp+VaDITS_Vgi_bi*Fp_Vdi_bi+VaDITS_Vdi_bi*Fp_Vgi_bi+VaDITS*Fp_Vgi_bi_Vdi_bi);
  VaDITS_Vgi_bi_Vsi_bi=(+VaDITS_Vgi_bi_Vsi_bi*Fp+VaDITS_Vgi_bi*Fp_Vsi_bi+VaDITS_Vsi_bi*Fp_Vgi_bi+VaDITS*Fp_Vgi_bi_Vsi_bi);
  VaDITS_Vgi_bi_Tempt_GND=(+VaDITS_Vgi_bi_Tempt_GND*Fp+VaDITS_Vgi_bi*Fp_Tempt_GND+VaDITS_Tempt_GND*Fp_Vgi_bi+VaDITS*Fp_Vgi_bi_Tempt_GND);
#endif
VaDITS_Vdi_bi=((VaDITS_Vdi_bi*Fp)+(VaDITS*Fp_Vdi_bi));
#if defined(_DERIVATE2)
  VaDITS_Vdi_bi_Vgi_bi=(+VaDITS_Vdi_bi_Vgi_bi*Fp+VaDITS_Vdi_bi*Fp_Vgi_bi+VaDITS_Vgi_bi*Fp_Vdi_bi+VaDITS*Fp_Vdi_bi_Vgi_bi);
  VaDITS_Vdi_bi_Vdi_bi=(+VaDITS_Vdi_bi_Vdi_bi*Fp+VaDITS_Vdi_bi*Fp_Vdi_bi+VaDITS_Vdi_bi*Fp_Vdi_bi+VaDITS*Fp_Vdi_bi_Vdi_bi);
  VaDITS_Vdi_bi_Vsi_bi=(+VaDITS_Vdi_bi_Vsi_bi*Fp+VaDITS_Vdi_bi*Fp_Vsi_bi+VaDITS_Vsi_bi*Fp_Vdi_bi+VaDITS*Fp_Vdi_bi_Vsi_bi);
  VaDITS_Vdi_bi_Tempt_GND=(+VaDITS_Vdi_bi_Tempt_GND*Fp+VaDITS_Vdi_bi*Fp_Tempt_GND+VaDITS_Tempt_GND*Fp_Vdi_bi+VaDITS*Fp_Vdi_bi_Tempt_GND);
#endif
VaDITS_Vsi_bi=((VaDITS_Vsi_bi*Fp)+(VaDITS*Fp_Vsi_bi));
#if defined(_DERIVATE2)
  VaDITS_Vsi_bi_Vgi_bi=(+VaDITS_Vsi_bi_Vgi_bi*Fp+VaDITS_Vsi_bi*Fp_Vgi_bi+VaDITS_Vgi_bi*Fp_Vsi_bi+VaDITS*Fp_Vsi_bi_Vgi_bi);
  VaDITS_Vsi_bi_Vdi_bi=(+VaDITS_Vsi_bi_Vdi_bi*Fp+VaDITS_Vsi_bi*Fp_Vdi_bi+VaDITS_Vdi_bi*Fp_Vsi_bi+VaDITS*Fp_Vsi_bi_Vdi_bi);
  VaDITS_Vsi_bi_Vsi_bi=(+VaDITS_Vsi_bi_Vsi_bi*Fp+VaDITS_Vsi_bi*Fp_Vsi_bi+VaDITS_Vsi_bi*Fp_Vsi_bi+VaDITS*Fp_Vsi_bi_Vsi_bi);
  VaDITS_Vsi_bi_Tempt_GND=(+VaDITS_Vsi_bi_Tempt_GND*Fp+VaDITS_Vsi_bi*Fp_Tempt_GND+VaDITS_Tempt_GND*Fp_Vsi_bi+VaDITS*Fp_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
VaDITS_Tempt_GND=((VaDITS_Tempt_GND*Fp)+(VaDITS*Fp_Tempt_GND));
#endif
#endif
VaDITS=(VaDITS*Fp);
EXIT_IF_ISNAN((VaDITS*Fp))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
VaDITS_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  VaDITS_Vgi_bi_Vgi_bi=0.0;
  VaDITS_Vgi_bi_Vdi_bi=0.0;
  VaDITS_Vgi_bi_Vsi_bi=0.0;
  VaDITS_Vgi_bi_Tempt_GND=0.0;
#endif
VaDITS_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  VaDITS_Vdi_bi_Vgi_bi=0.0;
  VaDITS_Vdi_bi_Vdi_bi=0.0;
  VaDITS_Vdi_bi_Vsi_bi=0.0;
  VaDITS_Vdi_bi_Tempt_GND=0.0;
#endif
VaDITS_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  VaDITS_Vsi_bi_Vgi_bi=0.0;
  VaDITS_Vsi_bi_Vdi_bi=0.0;
  VaDITS_Vsi_bi_Vsi_bi=0.0;
  VaDITS_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
VaDITS_Tempt_GND=0.0;
#endif
#endif
VaDITS=5.540622384e34;
EXIT_IF_ISNAN(5.540622384e34)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=((diffVds_Vgi_bi*VaDITS-diffVds*VaDITS_Vgi_bi)/VaDITS/VaDITS);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(0.0/VaDITS-(diffVds_Vgi_bi*0.0+0.0*VaDITS_Vgi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vgi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vgi_bi_Vgm_di=(0.0/VaDITS-(diffVds_Vgi_bi*0.0+0.0*VaDITS_Vgi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vgi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vgi_bi_Vdbulk_di=(diffVds_Vgi_bi_Vdbulk_di/VaDITS-(diffVds_Vgi_bi*0.0+diffVds_Vdbulk_di*VaDITS_Vgi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vgi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vgi_bi_Vsbulk_si=(diffVds_Vgi_bi_Vsbulk_si/VaDITS-(diffVds_Vgi_bi*0.0+diffVds_Vsbulk_si*VaDITS_Vgi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vgi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vgi_bi_Vgi_bi=(diffVds_Vgi_bi_Vgi_bi/VaDITS-(diffVds_Vgi_bi*VaDITS_Vgi_bi+diffVds_Vgi_bi*VaDITS_Vgi_bi+diffVds*VaDITS_Vgi_bi_Vgi_bi)/VaDITS/VaDITS+2*diffVds*VaDITS_Vgi_bi*VaDITS_Vgi_bi/VaDITS/VaDITS/VaDITS);
  T4_Vgi_bi_Vdi_bi=(diffVds_Vgi_bi_Vdi_bi/VaDITS-(diffVds_Vgi_bi*VaDITS_Vdi_bi+diffVds_Vdi_bi*VaDITS_Vgi_bi+diffVds*VaDITS_Vgi_bi_Vdi_bi)/VaDITS/VaDITS+2*diffVds*VaDITS_Vgi_bi*VaDITS_Vdi_bi/VaDITS/VaDITS/VaDITS);
  T4_Vgi_bi_Vsi_bi=(diffVds_Vgi_bi_Vsi_bi/VaDITS-(diffVds_Vgi_bi*VaDITS_Vsi_bi+diffVds_Vsi_bi*VaDITS_Vgi_bi+diffVds*VaDITS_Vgi_bi_Vsi_bi)/VaDITS/VaDITS+2*diffVds*VaDITS_Vgi_bi*VaDITS_Vsi_bi/VaDITS/VaDITS/VaDITS);
  T4_Vgi_bi_Tempt_GND=(diffVds_Vgi_bi_Tempt_GND/VaDITS-(diffVds_Vgi_bi*VaDITS_Tempt_GND+diffVds_Tempt_GND*VaDITS_Vgi_bi+diffVds*VaDITS_Vgi_bi_Tempt_GND)/VaDITS/VaDITS+2*diffVds*VaDITS_Vgi_bi*VaDITS_Tempt_GND/VaDITS/VaDITS/VaDITS);
#endif
T4_Vdi_bi=((diffVds_Vdi_bi*VaDITS-diffVds*VaDITS_Vdi_bi)/VaDITS/VaDITS);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(0.0/VaDITS-(diffVds_Vdi_bi*0.0+0.0*VaDITS_Vdi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vdi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vdi_bi_Vgm_di=(0.0/VaDITS-(diffVds_Vdi_bi*0.0+0.0*VaDITS_Vdi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vdi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vdi_bi_Vdbulk_di=(diffVds_Vdi_bi_Vdbulk_di/VaDITS-(diffVds_Vdi_bi*0.0+diffVds_Vdbulk_di*VaDITS_Vdi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vdi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vdi_bi_Vsbulk_si=(diffVds_Vdi_bi_Vsbulk_si/VaDITS-(diffVds_Vdi_bi*0.0+diffVds_Vsbulk_si*VaDITS_Vdi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vdi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vdi_bi_Vgi_bi=(diffVds_Vdi_bi_Vgi_bi/VaDITS-(diffVds_Vdi_bi*VaDITS_Vgi_bi+diffVds_Vgi_bi*VaDITS_Vdi_bi+diffVds*VaDITS_Vdi_bi_Vgi_bi)/VaDITS/VaDITS+2*diffVds*VaDITS_Vdi_bi*VaDITS_Vgi_bi/VaDITS/VaDITS/VaDITS);
  T4_Vdi_bi_Vdi_bi=(diffVds_Vdi_bi_Vdi_bi/VaDITS-(diffVds_Vdi_bi*VaDITS_Vdi_bi+diffVds_Vdi_bi*VaDITS_Vdi_bi+diffVds*VaDITS_Vdi_bi_Vdi_bi)/VaDITS/VaDITS+2*diffVds*VaDITS_Vdi_bi*VaDITS_Vdi_bi/VaDITS/VaDITS/VaDITS);
  T4_Vdi_bi_Vsi_bi=(diffVds_Vdi_bi_Vsi_bi/VaDITS-(diffVds_Vdi_bi*VaDITS_Vsi_bi+diffVds_Vsi_bi*VaDITS_Vdi_bi+diffVds*VaDITS_Vdi_bi_Vsi_bi)/VaDITS/VaDITS+2*diffVds*VaDITS_Vdi_bi*VaDITS_Vsi_bi/VaDITS/VaDITS/VaDITS);
  T4_Vdi_bi_Tempt_GND=(diffVds_Vdi_bi_Tempt_GND/VaDITS-(diffVds_Vdi_bi*VaDITS_Tempt_GND+diffVds_Tempt_GND*VaDITS_Vdi_bi+diffVds*VaDITS_Vdi_bi_Tempt_GND)/VaDITS/VaDITS+2*diffVds*VaDITS_Vdi_bi*VaDITS_Tempt_GND/VaDITS/VaDITS/VaDITS);
#endif
T4_Vsi_bi=((diffVds_Vsi_bi*VaDITS-diffVds*VaDITS_Vsi_bi)/VaDITS/VaDITS);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(0.0/VaDITS-(diffVds_Vsi_bi*0.0+0.0*VaDITS_Vsi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vsi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vsi_bi_Vgm_di=(0.0/VaDITS-(diffVds_Vsi_bi*0.0+0.0*VaDITS_Vsi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vsi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vsi_bi_Vdbulk_di=(diffVds_Vsi_bi_Vdbulk_di/VaDITS-(diffVds_Vsi_bi*0.0+diffVds_Vdbulk_di*VaDITS_Vsi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vsi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vsi_bi_Vsbulk_si=(diffVds_Vsi_bi_Vsbulk_si/VaDITS-(diffVds_Vsi_bi*0.0+diffVds_Vsbulk_si*VaDITS_Vsi_bi+diffVds*0.0)/VaDITS/VaDITS+2*diffVds*VaDITS_Vsi_bi*0.0/VaDITS/VaDITS/VaDITS);
  T4_Vsi_bi_Vgi_bi=(diffVds_Vsi_bi_Vgi_bi/VaDITS-(diffVds_Vsi_bi*VaDITS_Vgi_bi+diffVds_Vgi_bi*VaDITS_Vsi_bi+diffVds*VaDITS_Vsi_bi_Vgi_bi)/VaDITS/VaDITS+2*diffVds*VaDITS_Vsi_bi*VaDITS_Vgi_bi/VaDITS/VaDITS/VaDITS);
  T4_Vsi_bi_Vdi_bi=(diffVds_Vsi_bi_Vdi_bi/VaDITS-(diffVds_Vsi_bi*VaDITS_Vdi_bi+diffVds_Vdi_bi*VaDITS_Vsi_bi+diffVds*VaDITS_Vsi_bi_Vdi_bi)/VaDITS/VaDITS+2*diffVds*VaDITS_Vsi_bi*VaDITS_Vdi_bi/VaDITS/VaDITS/VaDITS);
  T4_Vsi_bi_Vsi_bi=(diffVds_Vsi_bi_Vsi_bi/VaDITS-(diffVds_Vsi_bi*VaDITS_Vsi_bi+diffVds_Vsi_bi*VaDITS_Vsi_bi+diffVds*VaDITS_Vsi_bi_Vsi_bi)/VaDITS/VaDITS+2*diffVds*VaDITS_Vsi_bi*VaDITS_Vsi_bi/VaDITS/VaDITS/VaDITS);
  T4_Vsi_bi_Tempt_GND=(diffVds_Vsi_bi_Tempt_GND/VaDITS-(diffVds_Vsi_bi*VaDITS_Tempt_GND+diffVds_Tempt_GND*VaDITS_Vsi_bi+diffVds*VaDITS_Vsi_bi_Tempt_GND)/VaDITS/VaDITS+2*diffVds*VaDITS_Vsi_bi*VaDITS_Tempt_GND/VaDITS/VaDITS/VaDITS);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=((diffVds_Tempt_GND*VaDITS-diffVds*VaDITS_Tempt_GND)/VaDITS/VaDITS);
#endif
#endif
T4=(diffVds/VaDITS);
EXIT_IF_ISNAN((diffVds/VaDITS))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=T4_Vgi_bi;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0+T4_Vgi_bi_Vgm_di);
  T0_Vgi_bi_Vgm_si=(+0.0+T4_Vgi_bi_Vgm_si);
  T0_Vgi_bi_Vdbulk_di=(+0.0+T4_Vgi_bi_Vdbulk_di);
  T0_Vgi_bi_Vsbulk_si=(+0.0+T4_Vgi_bi_Vsbulk_si);
  T0_Vgi_bi_Vgi_bi=(+0.0+T4_Vgi_bi_Vgi_bi);
  T0_Vgi_bi_Vdi_bi=(+0.0+T4_Vgi_bi_Vdi_bi);
  T0_Vgi_bi_Vsi_bi=(+0.0+T4_Vgi_bi_Vsi_bi);
  T0_Vgi_bi_Tempt_GND=(+0.0+T4_Vgi_bi_Tempt_GND);
#endif
T0_Vdi_bi=T4_Vdi_bi;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0+T4_Vdi_bi_Vgm_di);
  T0_Vdi_bi_Vgm_si=(+0.0+T4_Vdi_bi_Vgm_si);
  T0_Vdi_bi_Vdbulk_di=(+0.0+T4_Vdi_bi_Vdbulk_di);
  T0_Vdi_bi_Vsbulk_si=(+0.0+T4_Vdi_bi_Vsbulk_si);
  T0_Vdi_bi_Vgi_bi=(+0.0+T4_Vdi_bi_Vgi_bi);
  T0_Vdi_bi_Vdi_bi=(+0.0+T4_Vdi_bi_Vdi_bi);
  T0_Vdi_bi_Vsi_bi=(+0.0+T4_Vdi_bi_Vsi_bi);
  T0_Vdi_bi_Tempt_GND=(+0.0+T4_Vdi_bi_Tempt_GND);
#endif
T0_Vsi_bi=T4_Vsi_bi;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0+T4_Vsi_bi_Vgm_di);
  T0_Vsi_bi_Vgm_si=(+0.0+T4_Vsi_bi_Vgm_si);
  T0_Vsi_bi_Vdbulk_di=(+0.0+T4_Vsi_bi_Vdbulk_di);
  T0_Vsi_bi_Vsbulk_si=(+0.0+T4_Vsi_bi_Vsbulk_si);
  T0_Vsi_bi_Vgi_bi=(+0.0+T4_Vsi_bi_Vgi_bi);
  T0_Vsi_bi_Vdi_bi=(+0.0+T4_Vsi_bi_Vdi_bi);
  T0_Vsi_bi_Vsi_bi=(+0.0+T4_Vsi_bi_Vsi_bi);
  T0_Vsi_bi_Tempt_GND=(+0.0+T4_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=T4_Tempt_GND;
#endif
#endif
T0=(1.0+T4);
EXIT_IF_ISNAN((1.0+T4))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Moc_Vdi_bi=((Moc_Vdi_bi*T0)+(Moc*T0_Vdi_bi));
#if defined(_DERIVATE2)
  Moc_Vdi_bi_Vdi_bi=(+Moc_Vdi_bi_Vdi_bi*T0+Moc_Vdi_bi*T0_Vdi_bi+Moc_Vdi_bi*T0_Vdi_bi+Moc*T0_Vdi_bi_Vdi_bi);
  Moc_Vdi_bi_Vsi_bi=(+Moc_Vdi_bi_Vsi_bi*T0+Moc_Vdi_bi*T0_Vsi_bi+Moc_Vsi_bi*T0_Vdi_bi+Moc*T0_Vdi_bi_Vsi_bi);
  Moc_Vdi_bi_Vgi_bi=(+Moc_Vdi_bi_Vgi_bi*T0+Moc_Vdi_bi*T0_Vgi_bi+Moc_Vgi_bi*T0_Vdi_bi+Moc*T0_Vdi_bi_Vgi_bi);
  Moc_Vdi_bi_Tempt_GND=(+Moc_Vdi_bi_Tempt_GND*T0+Moc_Vdi_bi*T0_Tempt_GND+Moc_Tempt_GND*T0_Vdi_bi+Moc*T0_Vdi_bi_Tempt_GND);
#endif
Moc_Vsi_bi=((Moc_Vsi_bi*T0)+(Moc*T0_Vsi_bi));
#if defined(_DERIVATE2)
  Moc_Vsi_bi_Vdi_bi=(+Moc_Vsi_bi_Vdi_bi*T0+Moc_Vsi_bi*T0_Vdi_bi+Moc_Vdi_bi*T0_Vsi_bi+Moc*T0_Vsi_bi_Vdi_bi);
  Moc_Vsi_bi_Vsi_bi=(+Moc_Vsi_bi_Vsi_bi*T0+Moc_Vsi_bi*T0_Vsi_bi+Moc_Vsi_bi*T0_Vsi_bi+Moc*T0_Vsi_bi_Vsi_bi);
  Moc_Vsi_bi_Vgi_bi=(+Moc_Vsi_bi_Vgi_bi*T0+Moc_Vsi_bi*T0_Vgi_bi+Moc_Vgi_bi*T0_Vsi_bi+Moc*T0_Vsi_bi_Vgi_bi);
  Moc_Vsi_bi_Tempt_GND=(+Moc_Vsi_bi_Tempt_GND*T0+Moc_Vsi_bi*T0_Tempt_GND+Moc_Tempt_GND*T0_Vsi_bi+Moc*T0_Vsi_bi_Tempt_GND);
#endif
Moc_Vgi_bi=((Moc_Vgi_bi*T0)+(Moc*T0_Vgi_bi));
#if defined(_DERIVATE2)
  Moc_Vgi_bi_Vdi_bi=(+Moc_Vgi_bi_Vdi_bi*T0+Moc_Vgi_bi*T0_Vdi_bi+Moc_Vdi_bi*T0_Vgi_bi+Moc*T0_Vgi_bi_Vdi_bi);
  Moc_Vgi_bi_Vsi_bi=(+Moc_Vgi_bi_Vsi_bi*T0+Moc_Vgi_bi*T0_Vsi_bi+Moc_Vsi_bi*T0_Vgi_bi+Moc*T0_Vgi_bi_Vsi_bi);
  Moc_Vgi_bi_Vgi_bi=(+Moc_Vgi_bi_Vgi_bi*T0+Moc_Vgi_bi*T0_Vgi_bi+Moc_Vgi_bi*T0_Vgi_bi+Moc*T0_Vgi_bi_Vgi_bi);
  Moc_Vgi_bi_Tempt_GND=(+Moc_Vgi_bi_Tempt_GND*T0+Moc_Vgi_bi*T0_Tempt_GND+Moc_Tempt_GND*T0_Vgi_bi+Moc*T0_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Moc_Tempt_GND=((Moc_Tempt_GND*T0)+(Moc*T0_Tempt_GND));
#endif
#endif
Moc=(Moc*T0);
EXIT_IF_ISNAN((Moc*T0))
if
((PSCBE2_i>0.0))
{
if
((diffVds>((PSCBE1_i*litl)/80.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(-(PSCBE1_i*litl)*diffVds_Vgi_bi/diffVds/diffVds);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*0.0+(0.0)*diffVds_Vgi_bi+(PSCBE1_i*litl)*0.0)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vgi_bi*0.0/diffVds/diffVds/diffVds);
  T0_Vgi_bi_Vgm_si=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*0.0+(0.0)*diffVds_Vgi_bi+(PSCBE1_i*litl)*0.0)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vgi_bi*0.0/diffVds/diffVds/diffVds);
  T0_Vgi_bi_Vdbulk_di=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vdbulk_di+(0.0)*diffVds_Vgi_bi+(PSCBE1_i*litl)*diffVds_Vgi_bi_Vdbulk_di)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vgi_bi*diffVds_Vdbulk_di/diffVds/diffVds/diffVds);
  T0_Vgi_bi_Vsbulk_si=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vsbulk_si+(0.0)*diffVds_Vgi_bi+(PSCBE1_i*litl)*diffVds_Vgi_bi_Vsbulk_si)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vgi_bi*diffVds_Vsbulk_si/diffVds/diffVds/diffVds);
  T0_Vgi_bi_Vgi_bi=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vgi_bi+(0.0)*diffVds_Vgi_bi+(PSCBE1_i*litl)*diffVds_Vgi_bi_Vgi_bi)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vgi_bi*diffVds_Vgi_bi/diffVds/diffVds/diffVds);
  T0_Vgi_bi_Vdi_bi=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vdi_bi+(0.0)*diffVds_Vgi_bi+(PSCBE1_i*litl)*diffVds_Vgi_bi_Vdi_bi)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vgi_bi*diffVds_Vdi_bi/diffVds/diffVds/diffVds);
  T0_Vgi_bi_Vsi_bi=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vsi_bi+(0.0)*diffVds_Vgi_bi+(PSCBE1_i*litl)*diffVds_Vgi_bi_Vsi_bi)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vgi_bi*diffVds_Vsi_bi/diffVds/diffVds/diffVds);
  T0_Vgi_bi_Tempt_GND=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Tempt_GND+(0.0)*diffVds_Vgi_bi+(PSCBE1_i*litl)*diffVds_Vgi_bi_Tempt_GND)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vgi_bi*diffVds_Tempt_GND/diffVds/diffVds/diffVds);
#endif
T0_Vdi_bi=(-(PSCBE1_i*litl)*diffVds_Vdi_bi/diffVds/diffVds);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*0.0+(0.0)*diffVds_Vdi_bi+(PSCBE1_i*litl)*0.0)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vdi_bi*0.0/diffVds/diffVds/diffVds);
  T0_Vdi_bi_Vgm_si=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*0.0+(0.0)*diffVds_Vdi_bi+(PSCBE1_i*litl)*0.0)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vdi_bi*0.0/diffVds/diffVds/diffVds);
  T0_Vdi_bi_Vdbulk_di=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vdbulk_di+(0.0)*diffVds_Vdi_bi+(PSCBE1_i*litl)*diffVds_Vdi_bi_Vdbulk_di)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vdi_bi*diffVds_Vdbulk_di/diffVds/diffVds/diffVds);
  T0_Vdi_bi_Vsbulk_si=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vsbulk_si+(0.0)*diffVds_Vdi_bi+(PSCBE1_i*litl)*diffVds_Vdi_bi_Vsbulk_si)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vdi_bi*diffVds_Vsbulk_si/diffVds/diffVds/diffVds);
  T0_Vdi_bi_Vgi_bi=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vgi_bi+(0.0)*diffVds_Vdi_bi+(PSCBE1_i*litl)*diffVds_Vdi_bi_Vgi_bi)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vdi_bi*diffVds_Vgi_bi/diffVds/diffVds/diffVds);
  T0_Vdi_bi_Vdi_bi=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vdi_bi+(0.0)*diffVds_Vdi_bi+(PSCBE1_i*litl)*diffVds_Vdi_bi_Vdi_bi)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vdi_bi*diffVds_Vdi_bi/diffVds/diffVds/diffVds);
  T0_Vdi_bi_Vsi_bi=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vsi_bi+(0.0)*diffVds_Vdi_bi+(PSCBE1_i*litl)*diffVds_Vdi_bi_Vsi_bi)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vdi_bi*diffVds_Vsi_bi/diffVds/diffVds/diffVds);
  T0_Vdi_bi_Tempt_GND=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Tempt_GND+(0.0)*diffVds_Vdi_bi+(PSCBE1_i*litl)*diffVds_Vdi_bi_Tempt_GND)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vdi_bi*diffVds_Tempt_GND/diffVds/diffVds/diffVds);
#endif
T0_Vsi_bi=(-(PSCBE1_i*litl)*diffVds_Vsi_bi/diffVds/diffVds);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*0.0+(0.0)*diffVds_Vsi_bi+(PSCBE1_i*litl)*0.0)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vsi_bi*0.0/diffVds/diffVds/diffVds);
  T0_Vsi_bi_Vgm_si=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*0.0+(0.0)*diffVds_Vsi_bi+(PSCBE1_i*litl)*0.0)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vsi_bi*0.0/diffVds/diffVds/diffVds);
  T0_Vsi_bi_Vdbulk_di=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vdbulk_di+(0.0)*diffVds_Vsi_bi+(PSCBE1_i*litl)*diffVds_Vsi_bi_Vdbulk_di)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vsi_bi*diffVds_Vdbulk_di/diffVds/diffVds/diffVds);
  T0_Vsi_bi_Vsbulk_si=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vsbulk_si+(0.0)*diffVds_Vsi_bi+(PSCBE1_i*litl)*diffVds_Vsi_bi_Vsbulk_si)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vsi_bi*diffVds_Vsbulk_si/diffVds/diffVds/diffVds);
  T0_Vsi_bi_Vgi_bi=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vgi_bi+(0.0)*diffVds_Vsi_bi+(PSCBE1_i*litl)*diffVds_Vsi_bi_Vgi_bi)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vsi_bi*diffVds_Vgi_bi/diffVds/diffVds/diffVds);
  T0_Vsi_bi_Vdi_bi=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vdi_bi+(0.0)*diffVds_Vsi_bi+(PSCBE1_i*litl)*diffVds_Vsi_bi_Vdi_bi)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vsi_bi*diffVds_Vdi_bi/diffVds/diffVds/diffVds);
  T0_Vsi_bi_Vsi_bi=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Vsi_bi+(0.0)*diffVds_Vsi_bi+(PSCBE1_i*litl)*diffVds_Vsi_bi_Vsi_bi)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vsi_bi*diffVds_Vsi_bi/diffVds/diffVds/diffVds);
  T0_Vsi_bi_Tempt_GND=((+0.0*litl+0.0*0.0+0.0*0.0+PSCBE1_i*0.0)/diffVds-(0.0*diffVds_Tempt_GND+(0.0)*diffVds_Vsi_bi+(PSCBE1_i*litl)*diffVds_Vsi_bi_Tempt_GND)/diffVds/diffVds+2*(PSCBE1_i*litl)*diffVds_Vsi_bi*diffVds_Tempt_GND/diffVds/diffVds/diffVds);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-(PSCBE1_i*litl)*diffVds_Tempt_GND/diffVds/diffVds);
#endif
#endif
T0=((PSCBE1_i*litl)/diffVds);
EXIT_IF_ISNAN(((PSCBE1_i*litl)/diffVds))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
VaSCBE_Vgi_bi=((Leff*bsimbulk_d_lexp(T0,T0_Vgi_bi))/PSCBE2_i);
#if defined(_DERIVATE2)
  VaSCBE_Vgi_bi_Vgi_bi=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vgi_bi)+Leff*T0_Vgi_bi_Vgi_bi)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vgi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vgi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
  VaSCBE_Vgi_bi_Vdi_bi=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vgi_bi)+Leff*T0_Vgi_bi_Vdi_bi)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vgi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vgi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
  VaSCBE_Vgi_bi_Vsi_bi=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vgi_bi)+Leff*T0_Vgi_bi_Vsi_bi)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vgi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vgi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
  VaSCBE_Vgi_bi_Tempt_GND=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vgi_bi)+Leff*T0_Vgi_bi_Tempt_GND)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vgi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vgi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
#endif
VaSCBE_Vdi_bi=((Leff*bsimbulk_d_lexp(T0,T0_Vdi_bi))/PSCBE2_i);
#if defined(_DERIVATE2)
  VaSCBE_Vdi_bi_Vgi_bi=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vdi_bi)+Leff*T0_Vdi_bi_Vgi_bi)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vdi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vdi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
  VaSCBE_Vdi_bi_Vdi_bi=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vdi_bi)+Leff*T0_Vdi_bi_Vdi_bi)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vdi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vdi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
  VaSCBE_Vdi_bi_Vsi_bi=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vdi_bi)+Leff*T0_Vdi_bi_Vsi_bi)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vdi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vdi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
  VaSCBE_Vdi_bi_Tempt_GND=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vdi_bi)+Leff*T0_Vdi_bi_Tempt_GND)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vdi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vdi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
#endif
VaSCBE_Vsi_bi=((Leff*bsimbulk_d_lexp(T0,T0_Vsi_bi))/PSCBE2_i);
#if defined(_DERIVATE2)
  VaSCBE_Vsi_bi_Vgi_bi=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vsi_bi)+Leff*T0_Vsi_bi_Vgi_bi)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vsi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vsi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
  VaSCBE_Vsi_bi_Vdi_bi=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vsi_bi)+Leff*T0_Vsi_bi_Vdi_bi)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vsi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vsi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
  VaSCBE_Vsi_bi_Vsi_bi=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vsi_bi)+Leff*T0_Vsi_bi_Vsi_bi)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vsi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vsi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
  VaSCBE_Vsi_bi_Tempt_GND=((+0.0*bsimbulk_lexp(T0)+0.0*bsimbulk_d_lexp(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lexp(T0,T0_Vsi_bi)+Leff*T0_Vsi_bi_Tempt_GND)/PSCBE2_i-((Leff*bsimbulk_d_lexp(T0,T0_Vsi_bi))*0.0+((Leff*bsimbulk_d_lexp(T0,T0_Vsi_bi)))*0.0+(Leff*bsimbulk_lexp(T0))*0.0)/PSCBE2_i/PSCBE2_i+2*(Leff*bsimbulk_lexp(T0))*0.0*0.0/PSCBE2_i/PSCBE2_i/PSCBE2_i);
#endif
#if defined(_DERIVATE)
VaSCBE_Tempt_GND=((Leff*bsimbulk_d_lexp(T0,T0_Tempt_GND))/PSCBE2_i);
#endif
#endif
VaSCBE=((Leff*bsimbulk_lexp(T0))/PSCBE2_i);
EXIT_IF_ISNAN(((Leff*bsimbulk_lexp(T0))/PSCBE2_i))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
VaSCBE_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  VaSCBE_Vgi_bi_Vgi_bi=0.0;
  VaSCBE_Vgi_bi_Vdi_bi=0.0;
  VaSCBE_Vgi_bi_Vsi_bi=0.0;
  VaSCBE_Vgi_bi_Tempt_GND=0.0;
#endif
VaSCBE_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  VaSCBE_Vdi_bi_Vgi_bi=0.0;
  VaSCBE_Vdi_bi_Vdi_bi=0.0;
  VaSCBE_Vdi_bi_Vsi_bi=0.0;
  VaSCBE_Vdi_bi_Tempt_GND=0.0;
#endif
VaSCBE_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  VaSCBE_Vsi_bi_Vgi_bi=0.0;
  VaSCBE_Vsi_bi_Vdi_bi=0.0;
  VaSCBE_Vsi_bi_Vsi_bi=0.0;
  VaSCBE_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
VaSCBE_Tempt_GND=0.0;
#endif
#endif
VaSCBE=((5.540622384e34*Leff)/PSCBE2_i);
EXIT_IF_ISNAN(((5.540622384e34*Leff)/PSCBE2_i))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
VaSCBE_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  VaSCBE_Vgi_bi_Vgi_bi=0.0;
  VaSCBE_Vgi_bi_Vdi_bi=0.0;
  VaSCBE_Vgi_bi_Vsi_bi=0.0;
  VaSCBE_Vgi_bi_Tempt_GND=0.0;
#endif
VaSCBE_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  VaSCBE_Vdi_bi_Vgi_bi=0.0;
  VaSCBE_Vdi_bi_Vdi_bi=0.0;
  VaSCBE_Vdi_bi_Vsi_bi=0.0;
  VaSCBE_Vdi_bi_Tempt_GND=0.0;
#endif
VaSCBE_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  VaSCBE_Vsi_bi_Vgi_bi=0.0;
  VaSCBE_Vsi_bi_Vdi_bi=0.0;
  VaSCBE_Vsi_bi_Vsi_bi=0.0;
  VaSCBE_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
VaSCBE_Tempt_GND=0.0;
#endif
#endif
VaSCBE=5.540622384e34;
EXIT_IF_ISNAN(5.540622384e34)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND) */
Mscbe_Vdi_bi=((diffVds_Vdi_bi*VaSCBE-diffVds*VaSCBE_Vdi_bi)/VaSCBE/VaSCBE);
#if defined(_DERIVATE2)
  Mscbe_Vdi_bi_Vdi_bi=(+0.0+(diffVds_Vdi_bi_Vdi_bi/VaSCBE-(diffVds_Vdi_bi*VaSCBE_Vdi_bi+diffVds_Vdi_bi*VaSCBE_Vdi_bi+diffVds*VaSCBE_Vdi_bi_Vdi_bi)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vdi_bi*VaSCBE_Vdi_bi/VaSCBE/VaSCBE/VaSCBE));
  Mscbe_Vdi_bi_Vsi_bi=(+0.0+(diffVds_Vdi_bi_Vsi_bi/VaSCBE-(diffVds_Vdi_bi*VaSCBE_Vsi_bi+diffVds_Vsi_bi*VaSCBE_Vdi_bi+diffVds*VaSCBE_Vdi_bi_Vsi_bi)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vdi_bi*VaSCBE_Vsi_bi/VaSCBE/VaSCBE/VaSCBE));
  Mscbe_Vdi_bi_Vgi_bi=(+0.0+(diffVds_Vdi_bi_Vgi_bi/VaSCBE-(diffVds_Vdi_bi*VaSCBE_Vgi_bi+diffVds_Vgi_bi*VaSCBE_Vdi_bi+diffVds*VaSCBE_Vdi_bi_Vgi_bi)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vdi_bi*VaSCBE_Vgi_bi/VaSCBE/VaSCBE/VaSCBE));
  Mscbe_Vdi_bi_Tempt_GND=(+0.0+(diffVds_Vdi_bi_Tempt_GND/VaSCBE-(diffVds_Vdi_bi*VaSCBE_Tempt_GND+diffVds_Tempt_GND*VaSCBE_Vdi_bi+diffVds*VaSCBE_Vdi_bi_Tempt_GND)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vdi_bi*VaSCBE_Tempt_GND/VaSCBE/VaSCBE/VaSCBE));
#endif
Mscbe_Vsi_bi=((diffVds_Vsi_bi*VaSCBE-diffVds*VaSCBE_Vsi_bi)/VaSCBE/VaSCBE);
#if defined(_DERIVATE2)
  Mscbe_Vsi_bi_Vdi_bi=(+0.0+(diffVds_Vsi_bi_Vdi_bi/VaSCBE-(diffVds_Vsi_bi*VaSCBE_Vdi_bi+diffVds_Vdi_bi*VaSCBE_Vsi_bi+diffVds*VaSCBE_Vsi_bi_Vdi_bi)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vsi_bi*VaSCBE_Vdi_bi/VaSCBE/VaSCBE/VaSCBE));
  Mscbe_Vsi_bi_Vsi_bi=(+0.0+(diffVds_Vsi_bi_Vsi_bi/VaSCBE-(diffVds_Vsi_bi*VaSCBE_Vsi_bi+diffVds_Vsi_bi*VaSCBE_Vsi_bi+diffVds*VaSCBE_Vsi_bi_Vsi_bi)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vsi_bi*VaSCBE_Vsi_bi/VaSCBE/VaSCBE/VaSCBE));
  Mscbe_Vsi_bi_Vgi_bi=(+0.0+(diffVds_Vsi_bi_Vgi_bi/VaSCBE-(diffVds_Vsi_bi*VaSCBE_Vgi_bi+diffVds_Vgi_bi*VaSCBE_Vsi_bi+diffVds*VaSCBE_Vsi_bi_Vgi_bi)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vsi_bi*VaSCBE_Vgi_bi/VaSCBE/VaSCBE/VaSCBE));
  Mscbe_Vsi_bi_Tempt_GND=(+0.0+(diffVds_Vsi_bi_Tempt_GND/VaSCBE-(diffVds_Vsi_bi*VaSCBE_Tempt_GND+diffVds_Tempt_GND*VaSCBE_Vsi_bi+diffVds*VaSCBE_Vsi_bi_Tempt_GND)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vsi_bi*VaSCBE_Tempt_GND/VaSCBE/VaSCBE/VaSCBE));
#endif
Mscbe_Vgi_bi=((diffVds_Vgi_bi*VaSCBE-diffVds*VaSCBE_Vgi_bi)/VaSCBE/VaSCBE);
#if defined(_DERIVATE2)
  Mscbe_Vgi_bi_Vdi_bi=(+0.0+(diffVds_Vgi_bi_Vdi_bi/VaSCBE-(diffVds_Vgi_bi*VaSCBE_Vdi_bi+diffVds_Vdi_bi*VaSCBE_Vgi_bi+diffVds*VaSCBE_Vgi_bi_Vdi_bi)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vgi_bi*VaSCBE_Vdi_bi/VaSCBE/VaSCBE/VaSCBE));
  Mscbe_Vgi_bi_Vsi_bi=(+0.0+(diffVds_Vgi_bi_Vsi_bi/VaSCBE-(diffVds_Vgi_bi*VaSCBE_Vsi_bi+diffVds_Vsi_bi*VaSCBE_Vgi_bi+diffVds*VaSCBE_Vgi_bi_Vsi_bi)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vgi_bi*VaSCBE_Vsi_bi/VaSCBE/VaSCBE/VaSCBE));
  Mscbe_Vgi_bi_Vgi_bi=(+0.0+(diffVds_Vgi_bi_Vgi_bi/VaSCBE-(diffVds_Vgi_bi*VaSCBE_Vgi_bi+diffVds_Vgi_bi*VaSCBE_Vgi_bi+diffVds*VaSCBE_Vgi_bi_Vgi_bi)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vgi_bi*VaSCBE_Vgi_bi/VaSCBE/VaSCBE/VaSCBE));
  Mscbe_Vgi_bi_Tempt_GND=(+0.0+(diffVds_Vgi_bi_Tempt_GND/VaSCBE-(diffVds_Vgi_bi*VaSCBE_Tempt_GND+diffVds_Tempt_GND*VaSCBE_Vgi_bi+diffVds*VaSCBE_Vgi_bi_Tempt_GND)/VaSCBE/VaSCBE+2*diffVds*VaSCBE_Vgi_bi*VaSCBE_Tempt_GND/VaSCBE/VaSCBE/VaSCBE));
#endif
#if defined(_DERIVATE)
Mscbe_Tempt_GND=((diffVds_Tempt_GND*VaSCBE-diffVds*VaSCBE_Tempt_GND)/VaSCBE/VaSCBE);
#endif
#endif
Mscbe=(1.0+(diffVds/VaSCBE));
EXIT_IF_ISNAN((1.0+(diffVds/VaSCBE)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Moc_Vdi_bi=((Moc_Vdi_bi*Mscbe)+(Moc*Mscbe_Vdi_bi));
#if defined(_DERIVATE2)
  Moc_Vdi_bi_Vdi_bi=(+Moc_Vdi_bi_Vdi_bi*Mscbe+Moc_Vdi_bi*Mscbe_Vdi_bi+Moc_Vdi_bi*Mscbe_Vdi_bi+Moc*Mscbe_Vdi_bi_Vdi_bi);
  Moc_Vdi_bi_Vsi_bi=(+Moc_Vdi_bi_Vsi_bi*Mscbe+Moc_Vdi_bi*Mscbe_Vsi_bi+Moc_Vsi_bi*Mscbe_Vdi_bi+Moc*Mscbe_Vdi_bi_Vsi_bi);
  Moc_Vdi_bi_Vgi_bi=(+Moc_Vdi_bi_Vgi_bi*Mscbe+Moc_Vdi_bi*Mscbe_Vgi_bi+Moc_Vgi_bi*Mscbe_Vdi_bi+Moc*Mscbe_Vdi_bi_Vgi_bi);
  Moc_Vdi_bi_Tempt_GND=(+Moc_Vdi_bi_Tempt_GND*Mscbe+Moc_Vdi_bi*Mscbe_Tempt_GND+Moc_Tempt_GND*Mscbe_Vdi_bi+Moc*Mscbe_Vdi_bi_Tempt_GND);
#endif
Moc_Vsi_bi=((Moc_Vsi_bi*Mscbe)+(Moc*Mscbe_Vsi_bi));
#if defined(_DERIVATE2)
  Moc_Vsi_bi_Vdi_bi=(+Moc_Vsi_bi_Vdi_bi*Mscbe+Moc_Vsi_bi*Mscbe_Vdi_bi+Moc_Vdi_bi*Mscbe_Vsi_bi+Moc*Mscbe_Vsi_bi_Vdi_bi);
  Moc_Vsi_bi_Vsi_bi=(+Moc_Vsi_bi_Vsi_bi*Mscbe+Moc_Vsi_bi*Mscbe_Vsi_bi+Moc_Vsi_bi*Mscbe_Vsi_bi+Moc*Mscbe_Vsi_bi_Vsi_bi);
  Moc_Vsi_bi_Vgi_bi=(+Moc_Vsi_bi_Vgi_bi*Mscbe+Moc_Vsi_bi*Mscbe_Vgi_bi+Moc_Vgi_bi*Mscbe_Vsi_bi+Moc*Mscbe_Vsi_bi_Vgi_bi);
  Moc_Vsi_bi_Tempt_GND=(+Moc_Vsi_bi_Tempt_GND*Mscbe+Moc_Vsi_bi*Mscbe_Tempt_GND+Moc_Tempt_GND*Mscbe_Vsi_bi+Moc*Mscbe_Vsi_bi_Tempt_GND);
#endif
Moc_Vgi_bi=((Moc_Vgi_bi*Mscbe)+(Moc*Mscbe_Vgi_bi));
#if defined(_DERIVATE2)
  Moc_Vgi_bi_Vdi_bi=(+Moc_Vgi_bi_Vdi_bi*Mscbe+Moc_Vgi_bi*Mscbe_Vdi_bi+Moc_Vdi_bi*Mscbe_Vgi_bi+Moc*Mscbe_Vgi_bi_Vdi_bi);
  Moc_Vgi_bi_Vsi_bi=(+Moc_Vgi_bi_Vsi_bi*Mscbe+Moc_Vgi_bi*Mscbe_Vsi_bi+Moc_Vsi_bi*Mscbe_Vgi_bi+Moc*Mscbe_Vgi_bi_Vsi_bi);
  Moc_Vgi_bi_Vgi_bi=(+Moc_Vgi_bi_Vgi_bi*Mscbe+Moc_Vgi_bi*Mscbe_Vgi_bi+Moc_Vgi_bi*Mscbe_Vgi_bi+Moc*Mscbe_Vgi_bi_Vgi_bi);
  Moc_Vgi_bi_Tempt_GND=(+Moc_Vgi_bi_Tempt_GND*Mscbe+Moc_Vgi_bi*Mscbe_Tempt_GND+Moc_Tempt_GND*Mscbe_Vgi_bi+Moc*Mscbe_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Moc_Tempt_GND=((Moc_Tempt_GND*Mscbe)+(Moc*Mscbe_Tempt_GND));
#endif
#endif
Moc=(Moc*Mscbe);
EXIT_IF_ISNAN((Moc*Mscbe))
{
double m00_pow(d00_pow0,Dmob,(1.0/PSAT_a))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,Dmob,(1.0/PSAT_a))
double m11_pow(d11_pow0,d00_pow0,Dmob,(1.0/PSAT_a))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(d10_pow0*Dmob_Vgi_bi);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=fixme;
  T0_Vgi_bi_Vgm_si=fixme;
  T0_Vgi_bi_Vdbulk_di=fixme;
  T0_Vgi_bi_Vsbulk_si=fixme;
  T0_Vgi_bi_Vgi_bi=fixme;
  T0_Vgi_bi_Vdi_bi=fixme;
  T0_Vgi_bi_Vsi_bi=fixme;
  T0_Vgi_bi_Tempt_GND=fixme;
#endif
T0_Vdi_bi=(d10_pow0*Dmob_Vdi_bi+d11_pow0*(-PSAT_a_Vdi_bi/PSAT_a/PSAT_a));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=fixme;
  T0_Vdi_bi_Vgm_si=fixme;
  T0_Vdi_bi_Vdbulk_di=fixme;
  T0_Vdi_bi_Vsbulk_si=fixme;
  T0_Vdi_bi_Vgi_bi=fixme;
  T0_Vdi_bi_Vdi_bi=fixme;
  T0_Vdi_bi_Vsi_bi=fixme;
  T0_Vdi_bi_Tempt_GND=fixme;
#endif
T0_Vsi_bi=(d10_pow0*Dmob_Vsi_bi+d11_pow0*(-PSAT_a_Vsi_bi/PSAT_a/PSAT_a));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=fixme;
  T0_Vsi_bi_Vgm_si=fixme;
  T0_Vsi_bi_Vdbulk_di=fixme;
  T0_Vsi_bi_Vsbulk_si=fixme;
  T0_Vsi_bi_Vgi_bi=fixme;
  T0_Vsi_bi_Vdi_bi=fixme;
  T0_Vsi_bi_Vsi_bi=fixme;
  T0_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(d10_pow0*Dmob_Tempt_GND+d11_pow0*(-PSAT_a_Tempt_GND/PSAT_a/PSAT_a));
#endif
#endif
T0=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
if
((PSATB_i<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=(-(PSATB_i*Vbsx_Vdi_bi)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vgm_si=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vdbulk_di=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vsbulk_si=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vgi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vdi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Vdi_bi))+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Vdi_bi)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*((PSATB_i*Vbsx_Vdi_bi))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Vsi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Vsi_bi))+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Vsi_bi)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*((PSATB_i*Vbsx_Vsi_bi))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vdi_bi_Tempt_GND=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Tempt_GND))+0.0*(PSATB_i*Vbsx_Vdi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Tempt_GND)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vdi_bi)*((PSATB_i*Vbsx_Tempt_GND))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#endif
T1_Vsi_bi=(-(PSATB_i*Vbsx_Vsi_bi)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vgm_si=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vdbulk_di=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vsbulk_si=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vgi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*(0.0)+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*(0.0)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vdi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Vdi_bi))+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Vdi_bi)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*((PSATB_i*Vbsx_Vdi_bi))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Vsi_bi=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Vsi_bi))+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Vsi_bi)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*((PSATB_i*Vbsx_Vsi_bi))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
  T1_Vsi_bi_Tempt_GND=(0.0/(1.0+(PSATB_i*Vbsx))-(0.0*((PSATB_i*Vbsx_Tempt_GND))+0.0*(PSATB_i*Vbsx_Vsi_bi)+1.0*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Tempt_GND)))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))+2*1.0*(PSATB_i*Vbsx_Vsi_bi)*((PSATB_i*Vbsx_Tempt_GND))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-(PSATB_i*Vbsx_Tempt_GND)/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
#endif
#endif
T1=(1.0/(1.0+(PSATB_i*Vbsx)));
EXIT_IF_ISNAN((1.0/(1.0+(PSATB_i*Vbsx))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=(-(PSATB_i*Vbsx_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vgm_si=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vdbulk_di=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vsbulk_si=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vgi_bi=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+PSATB_i*0.0));
  T1_Vdi_bi_Vdi_bi=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vdi_bi+PSATB_i*Vbsx_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(-(PSATB_i*Vbsx_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vgm_si=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vdbulk_di=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vsbulk_si=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vgi_bi=(+0.0-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+PSATB_i*0.0));
  T1_Vsi_bi_Vdi_bi=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+0.0-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vsi_bi+PSATB_i*Vbsx_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-(PSATB_i*Vbsx_Tempt_GND));
#endif
#endif
T1=(1.0-(PSATB_i*Vbsx));
EXIT_IF_ISNAN((1.0-(PSATB_i*Vbsx)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((((((10.0*pModel->PSATX)*qia_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi))*((10.0*pModel->PSATX)+(qia*T1))-(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*0.0+(0.0)*qia_Vgi_bi+(10.0*pModel->PSATX)*0.0)*T1+((10.0*pModel->PSATX)*qia_Vgi_bi)*T1_Vgm_di+((0.0)*qia)*T1_Vgi_bi+((10.0*pModel->PSATX)*qia)*T1_Vgi_bi_Vgm_di)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi))*((0.0)+((qia*T1_Vgm_di)))+(((((0.0)*qia)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgm_di)))*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+0.0*T1+qia_Vgi_bi*T1_Vgm_di+0.0*T1_Vgi_bi+qia*T1_Vgi_bi_Vgm_di)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))*((0.0)+((qia*T1_Vgm_di)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vgi_bi_Vgm_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*0.0+(0.0)*qia_Vgi_bi+(10.0*pModel->PSATX)*0.0)*T1+((10.0*pModel->PSATX)*qia_Vgi_bi)*T1_Vgm_si+((0.0)*qia)*T1_Vgi_bi+((10.0*pModel->PSATX)*qia)*T1_Vgi_bi_Vgm_si)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi))*((0.0)+((qia*T1_Vgm_si)))+(((((0.0)*qia)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgm_si)))*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+0.0*T1+qia_Vgi_bi*T1_Vgm_si+0.0*T1_Vgi_bi+qia*T1_Vgi_bi_Vgm_si)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))*((0.0)+((qia*T1_Vgm_si)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vgi_bi_Vdbulk_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vdbulk_di+(0.0)*qia_Vgi_bi+(10.0*pModel->PSATX)*qia_Vgi_bi_Vdbulk_di)*T1+((10.0*pModel->PSATX)*qia_Vgi_bi)*T1_Vdbulk_di+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdbulk_di)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qia)*T1_Vgi_bi_Vdbulk_di)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi))*((0.0)+(((qia_Vdbulk_di*T1)+(qia*T1_Vdbulk_di))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdbulk_di)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdbulk_di)))*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vgi_bi_Vdbulk_di*T1+qia_Vgi_bi*T1_Vdbulk_di+qia_Vdbulk_di*T1_Vgi_bi+qia*T1_Vgi_bi_Vdbulk_di)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))*((0.0)+(((qia_Vdbulk_di*T1)+(qia*T1_Vdbulk_di))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vgi_bi_Vsbulk_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vsbulk_si+(0.0)*qia_Vgi_bi+(10.0*pModel->PSATX)*qia_Vgi_bi_Vsbulk_si)*T1+((10.0*pModel->PSATX)*qia_Vgi_bi)*T1_Vsbulk_si+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsbulk_si)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qia)*T1_Vgi_bi_Vsbulk_si)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi))*((0.0)+(((qia_Vsbulk_si*T1)+(qia*T1_Vsbulk_si))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsbulk_si)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsbulk_si)))*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vgi_bi_Vsbulk_si*T1+qia_Vgi_bi*T1_Vsbulk_si+qia_Vsbulk_si*T1_Vgi_bi+qia*T1_Vgi_bi_Vsbulk_si)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))*((0.0)+(((qia_Vsbulk_si*T1)+(qia*T1_Vsbulk_si))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vgi_bi_Vgi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vgi_bi+(0.0)*qia_Vgi_bi+(10.0*pModel->PSATX)*qia_Vgi_bi_Vgi_bi)*T1+((10.0*pModel->PSATX)*qia_Vgi_bi)*T1_Vgi_bi+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vgi_bi)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qia)*T1_Vgi_bi_Vgi_bi)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi))*((0.0)+(((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vgi_bi)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi)))*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vgi_bi_Vgi_bi*T1+qia_Vgi_bi*T1_Vgi_bi+qia_Vgi_bi*T1_Vgi_bi+qia*T1_Vgi_bi_Vgi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))*((0.0)+(((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vgi_bi_Vdi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vdi_bi+(0.0)*qia_Vgi_bi+(10.0*pModel->PSATX)*qia_Vgi_bi_Vdi_bi)*T1+((10.0*pModel->PSATX)*qia_Vgi_bi)*T1_Vdi_bi+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdi_bi)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qia)*T1_Vgi_bi_Vdi_bi)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi))*((0.0)+(((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdi_bi)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi)))*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vgi_bi_Vdi_bi*T1+qia_Vgi_bi*T1_Vdi_bi+qia_Vdi_bi*T1_Vgi_bi+qia*T1_Vgi_bi_Vdi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))*((0.0)+(((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vgi_bi_Vsi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vsi_bi+(0.0)*qia_Vgi_bi+(10.0*pModel->PSATX)*qia_Vgi_bi_Vsi_bi)*T1+((10.0*pModel->PSATX)*qia_Vgi_bi)*T1_Vsi_bi+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsi_bi)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qia)*T1_Vgi_bi_Vsi_bi)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi))*((0.0)+(((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsi_bi)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi)))*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vgi_bi_Vsi_bi*T1+qia_Vgi_bi*T1_Vsi_bi+qia_Vsi_bi*T1_Vgi_bi+qia*T1_Vgi_bi_Vsi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))*((0.0)+(((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vgi_bi_Tempt_GND=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Tempt_GND+(0.0)*qia_Vgi_bi+(10.0*pModel->PSATX)*qia_Vgi_bi_Tempt_GND)*T1+((10.0*pModel->PSATX)*qia_Vgi_bi)*T1_Tempt_GND+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Tempt_GND)))*T1_Vgi_bi+((10.0*pModel->PSATX)*qia)*T1_Vgi_bi_Tempt_GND)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vgi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi))*((0.0)+(((qia_Tempt_GND*T1)+(qia*T1_Tempt_GND))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Tempt_GND)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Tempt_GND)))*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vgi_bi_Tempt_GND*T1+qia_Vgi_bi*T1_Tempt_GND+qia_Tempt_GND*T1_Vgi_bi+qia*T1_Vgi_bi_Tempt_GND)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))*((0.0)+(((qia_Tempt_GND*T1)+(qia*T1_Tempt_GND))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
#endif
T2_Vdi_bi=((((((10.0*pModel->PSATX)*qia_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi))*((10.0*pModel->PSATX)+(qia*T1))-(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*0.0+(0.0)*qia_Vdi_bi+(10.0*pModel->PSATX)*0.0)*T1+((10.0*pModel->PSATX)*qia_Vdi_bi)*T1_Vgm_di+((0.0)*qia)*T1_Vdi_bi+((10.0*pModel->PSATX)*qia)*T1_Vdi_bi_Vgm_di)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi))*((0.0)+((qia*T1_Vgm_di)))+(((((0.0)*qia)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgm_di)))*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+0.0*T1+qia_Vdi_bi*T1_Vgm_di+0.0*T1_Vdi_bi+qia*T1_Vdi_bi_Vgm_di)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))*((0.0)+((qia*T1_Vgm_di)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vdi_bi_Vgm_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*0.0+(0.0)*qia_Vdi_bi+(10.0*pModel->PSATX)*0.0)*T1+((10.0*pModel->PSATX)*qia_Vdi_bi)*T1_Vgm_si+((0.0)*qia)*T1_Vdi_bi+((10.0*pModel->PSATX)*qia)*T1_Vdi_bi_Vgm_si)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi))*((0.0)+((qia*T1_Vgm_si)))+(((((0.0)*qia)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgm_si)))*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+0.0*T1+qia_Vdi_bi*T1_Vgm_si+0.0*T1_Vdi_bi+qia*T1_Vdi_bi_Vgm_si)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))*((0.0)+((qia*T1_Vgm_si)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vdi_bi_Vdbulk_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vdbulk_di+(0.0)*qia_Vdi_bi+(10.0*pModel->PSATX)*qia_Vdi_bi_Vdbulk_di)*T1+((10.0*pModel->PSATX)*qia_Vdi_bi)*T1_Vdbulk_di+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdbulk_di)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qia)*T1_Vdi_bi_Vdbulk_di)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi))*((0.0)+(((qia_Vdbulk_di*T1)+(qia*T1_Vdbulk_di))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdbulk_di)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdbulk_di)))*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vdi_bi_Vdbulk_di*T1+qia_Vdi_bi*T1_Vdbulk_di+qia_Vdbulk_di*T1_Vdi_bi+qia*T1_Vdi_bi_Vdbulk_di)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))*((0.0)+(((qia_Vdbulk_di*T1)+(qia*T1_Vdbulk_di))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vdi_bi_Vsbulk_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vsbulk_si+(0.0)*qia_Vdi_bi+(10.0*pModel->PSATX)*qia_Vdi_bi_Vsbulk_si)*T1+((10.0*pModel->PSATX)*qia_Vdi_bi)*T1_Vsbulk_si+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsbulk_si)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qia)*T1_Vdi_bi_Vsbulk_si)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi))*((0.0)+(((qia_Vsbulk_si*T1)+(qia*T1_Vsbulk_si))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsbulk_si)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsbulk_si)))*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vdi_bi_Vsbulk_si*T1+qia_Vdi_bi*T1_Vsbulk_si+qia_Vsbulk_si*T1_Vdi_bi+qia*T1_Vdi_bi_Vsbulk_si)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))*((0.0)+(((qia_Vsbulk_si*T1)+(qia*T1_Vsbulk_si))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vdi_bi_Vgi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vgi_bi+(0.0)*qia_Vdi_bi+(10.0*pModel->PSATX)*qia_Vdi_bi_Vgi_bi)*T1+((10.0*pModel->PSATX)*qia_Vdi_bi)*T1_Vgi_bi+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vgi_bi)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qia)*T1_Vdi_bi_Vgi_bi)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi))*((0.0)+(((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vgi_bi)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi)))*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vdi_bi_Vgi_bi*T1+qia_Vdi_bi*T1_Vgi_bi+qia_Vgi_bi*T1_Vdi_bi+qia*T1_Vdi_bi_Vgi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))*((0.0)+(((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vdi_bi_Vdi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vdi_bi+(0.0)*qia_Vdi_bi+(10.0*pModel->PSATX)*qia_Vdi_bi_Vdi_bi)*T1+((10.0*pModel->PSATX)*qia_Vdi_bi)*T1_Vdi_bi+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdi_bi)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qia)*T1_Vdi_bi_Vdi_bi)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi))*((0.0)+(((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdi_bi)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi)))*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vdi_bi_Vdi_bi*T1+qia_Vdi_bi*T1_Vdi_bi+qia_Vdi_bi*T1_Vdi_bi+qia*T1_Vdi_bi_Vdi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))*((0.0)+(((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vdi_bi_Vsi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vsi_bi+(0.0)*qia_Vdi_bi+(10.0*pModel->PSATX)*qia_Vdi_bi_Vsi_bi)*T1+((10.0*pModel->PSATX)*qia_Vdi_bi)*T1_Vsi_bi+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsi_bi)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qia)*T1_Vdi_bi_Vsi_bi)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi))*((0.0)+(((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsi_bi)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi)))*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vdi_bi_Vsi_bi*T1+qia_Vdi_bi*T1_Vsi_bi+qia_Vsi_bi*T1_Vdi_bi+qia*T1_Vdi_bi_Vsi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))*((0.0)+(((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vdi_bi_Tempt_GND=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Tempt_GND+(0.0)*qia_Vdi_bi+(10.0*pModel->PSATX)*qia_Vdi_bi_Tempt_GND)*T1+((10.0*pModel->PSATX)*qia_Vdi_bi)*T1_Tempt_GND+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Tempt_GND)))*T1_Vdi_bi+((10.0*pModel->PSATX)*qia)*T1_Vdi_bi_Tempt_GND)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vdi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi))*((0.0)+(((qia_Tempt_GND*T1)+(qia*T1_Tempt_GND))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Tempt_GND)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Tempt_GND)))*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vdi_bi_Tempt_GND*T1+qia_Vdi_bi*T1_Tempt_GND+qia_Tempt_GND*T1_Vdi_bi+qia*T1_Vdi_bi_Tempt_GND)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))*((0.0)+(((qia_Tempt_GND*T1)+(qia*T1_Tempt_GND))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
#endif
T2_Vsi_bi=((((((10.0*pModel->PSATX)*qia_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi))*((10.0*pModel->PSATX)+(qia*T1))-(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*0.0+(0.0)*qia_Vsi_bi+(10.0*pModel->PSATX)*0.0)*T1+((10.0*pModel->PSATX)*qia_Vsi_bi)*T1_Vgm_di+((0.0)*qia)*T1_Vsi_bi+((10.0*pModel->PSATX)*qia)*T1_Vsi_bi_Vgm_di)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi))*((0.0)+((qia*T1_Vgm_di)))+(((((0.0)*qia)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgm_di)))*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+0.0*T1+qia_Vsi_bi*T1_Vgm_di+0.0*T1_Vsi_bi+qia*T1_Vsi_bi_Vgm_di)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))*((0.0)+((qia*T1_Vgm_di)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vsi_bi_Vgm_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*0.0+(0.0)*qia_Vsi_bi+(10.0*pModel->PSATX)*0.0)*T1+((10.0*pModel->PSATX)*qia_Vsi_bi)*T1_Vgm_si+((0.0)*qia)*T1_Vsi_bi+((10.0*pModel->PSATX)*qia)*T1_Vsi_bi_Vgm_si)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi))*((0.0)+((qia*T1_Vgm_si)))+(((((0.0)*qia)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgm_si)))*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+0.0*T1+qia_Vsi_bi*T1_Vgm_si+0.0*T1_Vsi_bi+qia*T1_Vsi_bi_Vgm_si)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))*((0.0)+((qia*T1_Vgm_si)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vsi_bi_Vdbulk_di=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vdbulk_di+(0.0)*qia_Vsi_bi+(10.0*pModel->PSATX)*qia_Vsi_bi_Vdbulk_di)*T1+((10.0*pModel->PSATX)*qia_Vsi_bi)*T1_Vdbulk_di+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdbulk_di)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qia)*T1_Vsi_bi_Vdbulk_di)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi))*((0.0)+(((qia_Vdbulk_di*T1)+(qia*T1_Vdbulk_di))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdbulk_di)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdbulk_di)))*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vsi_bi_Vdbulk_di*T1+qia_Vsi_bi*T1_Vdbulk_di+qia_Vdbulk_di*T1_Vsi_bi+qia*T1_Vsi_bi_Vdbulk_di)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))*((0.0)+(((qia_Vdbulk_di*T1)+(qia*T1_Vdbulk_di))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vsi_bi_Vsbulk_si=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vsbulk_si+(0.0)*qia_Vsi_bi+(10.0*pModel->PSATX)*qia_Vsi_bi_Vsbulk_si)*T1+((10.0*pModel->PSATX)*qia_Vsi_bi)*T1_Vsbulk_si+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsbulk_si)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qia)*T1_Vsi_bi_Vsbulk_si)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi))*((0.0)+(((qia_Vsbulk_si*T1)+(qia*T1_Vsbulk_si))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsbulk_si)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsbulk_si)))*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vsi_bi_Vsbulk_si*T1+qia_Vsi_bi*T1_Vsbulk_si+qia_Vsbulk_si*T1_Vsi_bi+qia*T1_Vsi_bi_Vsbulk_si)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))*((0.0)+(((qia_Vsbulk_si*T1)+(qia*T1_Vsbulk_si))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vsi_bi_Vgi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vgi_bi+(0.0)*qia_Vsi_bi+(10.0*pModel->PSATX)*qia_Vsi_bi_Vgi_bi)*T1+((10.0*pModel->PSATX)*qia_Vsi_bi)*T1_Vgi_bi+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vgi_bi)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qia)*T1_Vsi_bi_Vgi_bi)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi))*((0.0)+(((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vgi_bi)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vgi_bi)))*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vsi_bi_Vgi_bi*T1+qia_Vsi_bi*T1_Vgi_bi+qia_Vgi_bi*T1_Vsi_bi+qia*T1_Vsi_bi_Vgi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))*((0.0)+(((qia_Vgi_bi*T1)+(qia*T1_Vgi_bi))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vsi_bi_Vdi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vdi_bi+(0.0)*qia_Vsi_bi+(10.0*pModel->PSATX)*qia_Vsi_bi_Vdi_bi)*T1+((10.0*pModel->PSATX)*qia_Vsi_bi)*T1_Vdi_bi+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdi_bi)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qia)*T1_Vsi_bi_Vdi_bi)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi))*((0.0)+(((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vdi_bi)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vdi_bi)))*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vsi_bi_Vdi_bi*T1+qia_Vsi_bi*T1_Vdi_bi+qia_Vdi_bi*T1_Vsi_bi+qia*T1_Vsi_bi_Vdi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))*((0.0)+(((qia_Vdi_bi*T1)+(qia*T1_Vdi_bi))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vsi_bi_Vsi_bi=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Vsi_bi+(0.0)*qia_Vsi_bi+(10.0*pModel->PSATX)*qia_Vsi_bi_Vsi_bi)*T1+((10.0*pModel->PSATX)*qia_Vsi_bi)*T1_Vsi_bi+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsi_bi)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qia)*T1_Vsi_bi_Vsi_bi)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi))*((0.0)+(((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Vsi_bi)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi)))*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vsi_bi_Vsi_bi*T1+qia_Vsi_bi*T1_Vsi_bi+qia_Vsi_bi*T1_Vsi_bi+qia*T1_Vsi_bi_Vsi_bi)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))*((0.0)+(((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
  T2_Vsi_bi_Tempt_GND=((+(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)*qia+0.0*qia_Tempt_GND+(0.0)*qia_Vsi_bi+(10.0*pModel->PSATX)*qia_Vsi_bi_Tempt_GND)*T1+((10.0*pModel->PSATX)*qia_Vsi_bi)*T1_Tempt_GND+((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Tempt_GND)))*T1_Vsi_bi+((10.0*pModel->PSATX)*qia)*T1_Vsi_bi_Tempt_GND)/((10.0*pModel->PSATX)+(qia*T1))-(((((10.0*pModel->PSATX)*qia_Vsi_bi)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Vsi_bi))*((0.0)+(((qia_Tempt_GND*T1)+(qia*T1_Tempt_GND))))+(((((((0.0)*qia)+((10.0*pModel->PSATX)*qia_Tempt_GND)))*T1)+(((10.0*pModel->PSATX)*qia)*T1_Tempt_GND)))*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))+(((10.0*pModel->PSATX)*qia)*T1)*(+(+0.0*pModel->PSATX+0.0*0.0+0.0*0.0+10.0*0.0)+(+qia_Vsi_bi_Tempt_GND*T1+qia_Vsi_bi*T1_Tempt_GND+qia_Tempt_GND*T1_Vsi_bi+qia*T1_Vsi_bi_Tempt_GND)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))+2*(((10.0*pModel->PSATX)*qia)*T1)*((qia_Vsi_bi*T1)+(qia*T1_Vsi_bi))*((0.0)+(((qia_Tempt_GND*T1)+(qia*T1_Tempt_GND))))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((((((10.0*pModel->PSATX)*qia_Tempt_GND)*T1)+(((10.0*pModel->PSATX)*qia)*T1_Tempt_GND))*((10.0*pModel->PSATX)+(qia*T1))-(((10.0*pModel->PSATX)*qia)*T1)*((qia_Tempt_GND*T1)+(qia*T1_Tempt_GND)))/((10.0*pModel->PSATX)+(qia*T1))/((10.0*pModel->PSATX)+(qia*T1)));
#endif
#endif
T2=((((10.0*pModel->PSATX)*qia)*T1)/((10.0*pModel->PSATX)+(qia*T1)));
EXIT_IF_ISNAN(((((10.0*pModel->PSATX)*qia)*T1)/((10.0*pModel->PSATX)+(qia*T1))))
if
((PTWG_a<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
LambdaC_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  LambdaC_Vdbulk_di_Vdbulk_di=0.0;
  LambdaC_Vdbulk_di_Vsbulk_si=0.0;
  LambdaC_Vdbulk_di_Tempt_GND=0.0;
  LambdaC_Vdbulk_di_Vdi_bi=0.0;
  LambdaC_Vdbulk_di_Vsi_bi=0.0;
  LambdaC_Vdbulk_di_Vgi_bi=0.0;
#endif
LambdaC_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  LambdaC_Vsbulk_si_Vdbulk_di=0.0;
  LambdaC_Vsbulk_si_Vsbulk_si=0.0;
  LambdaC_Vsbulk_si_Tempt_GND=0.0;
  LambdaC_Vsbulk_si_Vdi_bi=0.0;
  LambdaC_Vsbulk_si_Vsi_bi=0.0;
  LambdaC_Vsbulk_si_Vgi_bi=0.0;
#endif
#if defined(_DERIVATE)
LambdaC_Tempt_GND=(((2.0*((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))));
#endif
LambdaC_Vdi_bi=(((2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))));
#if defined(_DERIVATE2)
  LambdaC_Vdi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vdbulk_di+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vdbulk_di)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vdbulk_di)))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vdi_bi*T2_Vdbulk_di+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vsbulk_si+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vsbulk_si)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vsbulk_si)))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vdi_bi*T2_Vsbulk_si+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Tempt_GND/T0-(U0_a_Vdi_bi*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vdi_bi+U0_a*T0_Vdi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Tempt_GND)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Tempt_GND*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+PTWG_a_Vdi_bi_Tempt_GND*T2+PTWG_a_Vdi_bi*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Tempt_GND)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Vdi_bi/T0-(U0_a_Vdi_bi*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vdi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Vdi_bi*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+PTWG_a_Vdi_bi_Vdi_bi*T2+PTWG_a_Vdi_bi*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Vsi_bi/T0-(U0_a_Vdi_bi*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vsi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Vsi_bi*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+PTWG_a_Vdi_bi_Vsi_bi*T2+PTWG_a_Vdi_bi*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vdi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vgi_bi+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vgi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vgi_bi)))+0.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vdi_bi*T2_Vgi_bi+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))*(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
#endif
LambdaC_Vsi_bi=(((2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))));
#if defined(_DERIVATE2)
  LambdaC_Vsi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vdbulk_di+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vdbulk_di)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vdbulk_di)))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vsi_bi*T2_Vdbulk_di+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vsbulk_si+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vsbulk_si)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vsbulk_si)))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vsi_bi*T2_Vsbulk_si+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Tempt_GND/T0-(U0_a_Vsi_bi*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vsi_bi+U0_a*T0_Vsi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Tempt_GND)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Tempt_GND*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+PTWG_a_Vsi_bi_Tempt_GND*T2+PTWG_a_Vsi_bi*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Tempt_GND)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Vdi_bi/T0-(U0_a_Vsi_bi*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vdi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Vdi_bi*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+PTWG_a_Vsi_bi_Vdi_bi*T2+PTWG_a_Vsi_bi*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Vsi_bi/T0-(U0_a_Vsi_bi*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vsi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Vsi_bi*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+PTWG_a_Vsi_bi_Vsi_bi*T2+PTWG_a_Vsi_bi*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vsi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vgi_bi+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vgi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vgi_bi)))+0.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+1.0*(+0.0-(+0.0*T2+PTWG_a_Vsi_bi*T2_Vgi_bi+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))*(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
#endif
LambdaC_Vgi_bi=(((2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))));
#if defined(_DERIVATE2)
  LambdaC_Vgi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vdbulk_di)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vdbulk_di)))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-((PTWG_a*T2_Vdbulk_di)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vsbulk_si)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vsbulk_si)))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-((PTWG_a*T2_Vsbulk_si)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vgi_bi+U0_a*T0_Vgi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Tempt_GND)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Tempt_GND)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vdi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vdi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vsi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vsi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
  LambdaC_Vgi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vgi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(-(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(-(-(PTWG_a*T2_Vgi_bi))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(0.0/(1.0-(PTWG_a*T2))-(0.0*(-((PTWG_a*T2_Vgi_bi)))+0.0*(-(PTWG_a*T2_Vgi_bi))+1.0*(+0.0-(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))+2*1.0*(-(PTWG_a*T2_Vgi_bi))*(-((PTWG_a*T2_Vgi_bi)))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2))));
#endif
#endif
LambdaC=((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))));
EXIT_IF_ISNAN(((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2)))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
LambdaC_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  LambdaC_Vdbulk_di_Vdbulk_di=0.0;
  LambdaC_Vdbulk_di_Vsbulk_si=0.0;
  LambdaC_Vdbulk_di_Tempt_GND=0.0;
  LambdaC_Vdbulk_di_Vdi_bi=0.0;
  LambdaC_Vdbulk_di_Vsi_bi=0.0;
  LambdaC_Vdbulk_di_Vgi_bi=0.0;
#endif
LambdaC_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  LambdaC_Vsbulk_si_Vdbulk_di=0.0;
  LambdaC_Vsbulk_si_Vsbulk_si=0.0;
  LambdaC_Vsbulk_si_Tempt_GND=0.0;
  LambdaC_Vsbulk_si_Vdi_bi=0.0;
  LambdaC_Vsbulk_si_Vsi_bi=0.0;
  LambdaC_Vsbulk_si_Vgi_bi=0.0;
#endif
#if defined(_DERIVATE)
LambdaC_Tempt_GND=(((2.0*((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND))));
#endif
LambdaC_Vdi_bi=(((2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))));
#if defined(_DERIVATE2)
  LambdaC_Vdi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vdbulk_di+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vdbulk_di)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vdbulk_di))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vdi_bi*T2_Vdbulk_di+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vdbulk_di)));
  LambdaC_Vdi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vsbulk_si+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vsbulk_si)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vsbulk_si))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vdi_bi*T2_Vsbulk_si+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vsbulk_si)));
  LambdaC_Vdi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Tempt_GND/T0-(U0_a_Vdi_bi*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vdi_bi+U0_a*T0_Vdi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Tempt_GND)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Tempt_GND*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vdi_bi_Tempt_GND*T2+PTWG_a_Vdi_bi*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Tempt_GND)));
  LambdaC_Vdi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Vdi_bi/T0-(U0_a_Vdi_bi*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vdi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Vdi_bi*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vdi_bi_Vdi_bi*T2+PTWG_a_Vdi_bi*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vdi_bi)));
  LambdaC_Vdi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vdi_bi_Vsi_bi/T0-(U0_a_Vdi_bi*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vsi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vdi_bi_Vsi_bi*Leff+VSAT_a_Vdi_bi*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vdi_bi_Vsi_bi*T2+PTWG_a_Vdi_bi*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vsi_bi)));
  LambdaC_Vdi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vdi_bi*T0_Vgi_bi+0.0*T0_Vdi_bi+U0_a*T0_Vdi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vdi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdi_bi+(U0_a/T0)*nVt_Vdi_bi_Vgi_bi)/(VSAT_a*Leff)-(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*VSAT_a_Vdi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vdi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vgi_bi))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vdi_bi*T2_Vgi_bi+0.0*T2_Vdi_bi+PTWG_a*T2_Vdi_bi_Vgi_bi)));
#endif
LambdaC_Vsi_bi=(((2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))));
#if defined(_DERIVATE2)
  LambdaC_Vsi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vdbulk_di+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vdbulk_di)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vdbulk_di))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vsi_bi*T2_Vdbulk_di+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vdbulk_di)));
  LambdaC_Vsi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vsbulk_si+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vsbulk_si)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vsbulk_si))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vsi_bi*T2_Vsbulk_si+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vsbulk_si)));
  LambdaC_Vsi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Tempt_GND/T0-(U0_a_Vsi_bi*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vsi_bi+U0_a*T0_Vsi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Tempt_GND)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Tempt_GND*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vsi_bi_Tempt_GND*T2+PTWG_a_Vsi_bi*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Tempt_GND)));
  LambdaC_Vsi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Vdi_bi/T0-(U0_a_Vsi_bi*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vdi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Vdi_bi*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vsi_bi_Vdi_bi*T2+PTWG_a_Vsi_bi*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vdi_bi)));
  LambdaC_Vsi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(U0_a_Vsi_bi_Vsi_bi/T0-(U0_a_Vsi_bi*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vsi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+VSAT_a_Vsi_bi_Vsi_bi*Leff+VSAT_a_Vsi_bi*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+PTWG_a_Vsi_bi_Vsi_bi*T2+PTWG_a_Vsi_bi*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vsi_bi)));
  LambdaC_Vsi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))+2.0*((+(0.0/T0-(U0_a_Vsi_bi*T0_Vgi_bi+0.0*T0_Vsi_bi+U0_a*T0_Vsi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vsi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsi_bi+(U0_a/T0)*nVt_Vsi_bi_Vgi_bi)/(VSAT_a*Leff)-(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*VSAT_a_Vsi_bi*Leff+((U0_a/T0)*nVt)*(+0.0*Leff+VSAT_a_Vsi_bi*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*((PTWG_a*T2_Vgi_bi))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi))+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+PTWG_a_Vsi_bi*T2_Vgi_bi+0.0*T2_Vsi_bi+PTWG_a*T2_Vsi_bi_Vgi_bi)));
#endif
LambdaC_Vgi_bi=(((2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)))+((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(PTWG_a*T2_Vgi_bi)));
#if defined(_DERIVATE2)
  LambdaC_Vgi_bi_Vdbulk_di=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vdbulk_di)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vdbulk_di/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdbulk_di+(-U0_a*T0_Vdbulk_di/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vdbulk_di)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*((PTWG_a*T2_Vdbulk_di))+((2.0*((((((-U0_a*T0_Vdbulk_di/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdbulk_di)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vdbulk_di)));
  LambdaC_Vgi_bi_Vsbulk_si=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vsbulk_si)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vsbulk_si/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsbulk_si+(-U0_a*T0_Vsbulk_si/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vsbulk_si)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*((PTWG_a*T2_Vsbulk_si))+((2.0*((((((-U0_a*T0_Vsbulk_si/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsbulk_si)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vsbulk_si)));
  LambdaC_Vgi_bi_Tempt_GND=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Tempt_GND+U0_a_Tempt_GND*T0_Vgi_bi+U0_a*T0_Vgi_bi_Tempt_GND)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Tempt_GND/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Tempt_GND+((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Tempt_GND)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Tempt_GND*Leff)+(((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Tempt_GND*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Tempt_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(((PTWG_a_Tempt_GND*T2)+(PTWG_a*T2_Tempt_GND)))+((2.0*(((((((U0_a_Tempt_GND*T0-U0_a*T0_Tempt_GND)/T0/T0)*nVt)+((U0_a/T0)*nVt_Tempt_GND)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Tempt_GND*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Tempt_GND+PTWG_a_Tempt_GND*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Tempt_GND)));
  LambdaC_Vgi_bi_Vdi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vdi_bi+U0_a_Vdi_bi*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vdi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vdi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vdi_bi+((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vdi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Vdi_bi*Leff)+(((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Vdi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Vdi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(((PTWG_a_Vdi_bi*T2)+(PTWG_a*T2_Vdi_bi)))+((2.0*(((((((U0_a_Vdi_bi*T0-U0_a*T0_Vdi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vdi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vdi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vdi_bi+PTWG_a_Vdi_bi*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vdi_bi)));
  LambdaC_Vgi_bi_Vsi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vsi_bi+U0_a_Vsi_bi*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vsi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vsi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vsi_bi+((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vsi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(VSAT_a_Vsi_bi*Leff)+(((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+VSAT_a_Vsi_bi*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(VSAT_a_Vsi_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*(((PTWG_a_Vsi_bi*T2)+(PTWG_a*T2_Vsi_bi)))+((2.0*(((((((U0_a_Vsi_bi*T0-U0_a*T0_Vsi_bi)/T0/T0)*nVt)+((U0_a/T0)*nVt_Vsi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(VSAT_a_Vsi_bi*Leff))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vsi_bi+PTWG_a_Vsi_bi*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vsi_bi)));
  LambdaC_Vgi_bi_Vgi_bi=(+(+0.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff))+0.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))+0.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff))+2.0*((+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+U0_a*T0_Vgi_bi_Vgi_bi)/T0/T0+2*U0_a*T0_Vgi_bi*T0_Vgi_bi/T0/T0/T0)*nVt+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vgi_bi+(-U0_a*T0_Vgi_bi/T0/T0)*nVt_Vgi_bi+(U0_a/T0)*nVt_Vgi_bi_Vgi_bi)/(VSAT_a*Leff)-((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))*(0.0)+((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*0.0+((U0_a/T0)*nVt)*(+0.0*Leff+0.0*0.0+0.0*0.0+VSAT_a*0.0))/(VSAT_a*Leff)/(VSAT_a*Leff)+2*((U0_a/T0)*nVt)*0.0*(0.0)/(VSAT_a*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))+(2.0*((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi))/(VSAT_a*Leff)))*((PTWG_a*T2_Vgi_bi))+((2.0*((((((-U0_a*T0_Vgi_bi/T0/T0)*nVt)+((U0_a/T0)*nVt_Vgi_bi)))*(VSAT_a*Leff)-((U0_a/T0)*nVt)*(0.0))/(VSAT_a*Leff)/(VSAT_a*Leff))))*(PTWG_a*T2_Vgi_bi)+(2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(+0.0+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+PTWG_a*T2_Vgi_bi_Vgi_bi)));
#endif
#endif
LambdaC=((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)));
EXIT_IF_ISNAN(((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(((2.0*LambdaC_Vgi_bi)*(qs-qdeff))+((2.0*LambdaC)*(qs_Vgi_bi-qdeff_Vgi_bi)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-qdeff)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_di-qdeff_Vgm_di)+(0.0)*(qs_Vgi_bi-qdeff_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_di-qdeff_Vgi_bi_Vgm_di));
  T1_Vgi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vgi_bi+2.0*0.0)*(qs-qdeff)+(2.0*LambdaC_Vgi_bi)*(qs_Vgm_si-qdeff_Vgm_si)+(0.0)*(qs_Vgi_bi-qdeff_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgm_si-qdeff_Vgi_bi_Vgm_si));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdbulk_di)*(qs-qdeff)+(2.0*LambdaC_Vgi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vgi_bi-qdeff_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsbulk_si)*(qs-qdeff)+(2.0*LambdaC_Vgi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vgi_bi-qdeff_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vgi_bi)*(qs-qdeff)+(2.0*LambdaC_Vgi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vgi_bi-qdeff_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vdi_bi)*(qs-qdeff)+(2.0*LambdaC_Vgi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vgi_bi-qdeff_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Vsi_bi)*(qs-qdeff)+(2.0*LambdaC_Vgi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vgi_bi-qdeff_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vgi_bi+2.0*LambdaC_Vgi_bi_Tempt_GND)*(qs-qdeff)+(2.0*LambdaC_Vgi_bi)*(qs_Tempt_GND-qdeff_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vgi_bi-qdeff_Vgi_bi)+(2.0*LambdaC)*(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(((2.0*LambdaC_Vdi_bi)*(qs-qdeff))+((2.0*LambdaC)*(qs_Vdi_bi-qdeff_Vdi_bi)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-qdeff)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_di-qdeff_Vgm_di)+(0.0)*(qs_Vdi_bi-qdeff_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_di-qdeff_Vdi_bi_Vgm_di));
  T1_Vdi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vdi_bi+2.0*0.0)*(qs-qdeff)+(2.0*LambdaC_Vdi_bi)*(qs_Vgm_si-qdeff_Vgm_si)+(0.0)*(qs_Vdi_bi-qdeff_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgm_si-qdeff_Vdi_bi_Vgm_si));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdbulk_di)*(qs-qdeff)+(2.0*LambdaC_Vdi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vdi_bi-qdeff_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsbulk_si)*(qs-qdeff)+(2.0*LambdaC_Vdi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vdi_bi-qdeff_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vgi_bi)*(qs-qdeff)+(2.0*LambdaC_Vdi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vdi_bi-qdeff_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vdi_bi)*(qs-qdeff)+(2.0*LambdaC_Vdi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vdi_bi-qdeff_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Vsi_bi)*(qs-qdeff)+(2.0*LambdaC_Vdi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vdi_bi-qdeff_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vdi_bi+2.0*LambdaC_Vdi_bi_Tempt_GND)*(qs-qdeff)+(2.0*LambdaC_Vdi_bi)*(qs_Tempt_GND-qdeff_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vdi_bi-qdeff_Vdi_bi)+(2.0*LambdaC)*(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(((2.0*LambdaC_Vsi_bi)*(qs-qdeff))+((2.0*LambdaC)*(qs_Vsi_bi-qdeff_Vsi_bi)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-qdeff)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_di-qdeff_Vgm_di)+(0.0)*(qs_Vsi_bi-qdeff_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_di-qdeff_Vsi_bi_Vgm_di));
  T1_Vsi_bi_Vgm_si=(+(+0.0*LambdaC+0.0*0.0+0.0*LambdaC_Vsi_bi+2.0*0.0)*(qs-qdeff)+(2.0*LambdaC_Vsi_bi)*(qs_Vgm_si-qdeff_Vgm_si)+(0.0)*(qs_Vsi_bi-qdeff_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgm_si-qdeff_Vsi_bi_Vgm_si));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*LambdaC+0.0*LambdaC_Vdbulk_di+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdbulk_di)*(qs-qdeff)+(2.0*LambdaC_Vsi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+((2.0*LambdaC_Vdbulk_di))*(qs_Vsi_bi-qdeff_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*LambdaC+0.0*LambdaC_Vsbulk_si+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsbulk_si)*(qs-qdeff)+(2.0*LambdaC_Vsi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+((2.0*LambdaC_Vsbulk_si))*(qs_Vsi_bi-qdeff_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vgi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vgi_bi)*(qs-qdeff)+(2.0*LambdaC_Vsi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+((2.0*LambdaC_Vgi_bi))*(qs_Vsi_bi-qdeff_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vdi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vdi_bi)*(qs-qdeff)+(2.0*LambdaC_Vsi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+((2.0*LambdaC_Vdi_bi))*(qs_Vsi_bi-qdeff_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*LambdaC+0.0*LambdaC_Vsi_bi+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Vsi_bi)*(qs-qdeff)+(2.0*LambdaC_Vsi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+((2.0*LambdaC_Vsi_bi))*(qs_Vsi_bi-qdeff_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*LambdaC+0.0*LambdaC_Tempt_GND+0.0*LambdaC_Vsi_bi+2.0*LambdaC_Vsi_bi_Tempt_GND)*(qs-qdeff)+(2.0*LambdaC_Vsi_bi)*(qs_Tempt_GND-qdeff_Tempt_GND)+((2.0*LambdaC_Tempt_GND))*(qs_Vsi_bi-qdeff_Vsi_bi)+(2.0*LambdaC)*(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((2.0*LambdaC_Tempt_GND)*(qs-qdeff))+((2.0*LambdaC)*(qs_Tempt_GND-qdeff_Tempt_GND)));
#endif
#endif
T1=((2.0*LambdaC)*(qs-qdeff));
EXIT_IF_ISNAN(((2.0*LambdaC)*(qs-qdeff)))
{
double m00_sqrt(d00_sqrt0,(1.0+(T1*T1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(T1*T1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)));
  T2_Vgi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)));
  T2_Vgi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)));
  T2_Vgi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)));
  T2_Vgi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)));
  T2_Vgi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)));
  T2_Vgi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)));
  T2_Vgi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)));
#endif
T2_Vdi_bi=((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)));
  T2_Vdi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)));
  T2_Vdi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)));
  T2_Vdi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)));
  T2_Vdi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)));
  T2_Vdi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)));
  T2_Vdi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)));
  T2_Vdi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)));
#endif
T2_Vsi_bi=((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)));
  T2_Vsi_bi_Vgm_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)));
  T2_Vsi_bi_Vdbulk_di=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)));
  T2_Vsi_bi_Vsbulk_si=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)));
  T2_Vsi_bi_Vgi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)));
  T2_Vsi_bi_Vdi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)));
  T2_Vsi_bi_Vsi_bi=(m20_sqrt((1.0+(T1*T1)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)));
  T2_Vsi_bi_Tempt_GND=(m20_sqrt((1.0+(T1*T1)))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0;
#endif
#endif
T2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((T1!=0.0))
{
{
double m00_asinh(d00_asinh0,T1)
#if defined(_DERIVATEFORDDX)
double m10_asinh(d10_asinh0,d00_asinh0,T1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
Dvsat_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Dvsat_Vdbulk_di_Vdbulk_di=0.0;
  Dvsat_Vdbulk_di_Vsbulk_si=0.0;
  Dvsat_Vdbulk_di_Vgi_bi=0.0;
  Dvsat_Vdbulk_di_Vdi_bi=0.0;
  Dvsat_Vdbulk_di_Vsi_bi=0.0;
  Dvsat_Vdbulk_di_Tempt_GND=0.0;
#endif
Dvsat_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Dvsat_Vsbulk_si_Vdbulk_di=0.0;
  Dvsat_Vsbulk_si_Vsbulk_si=0.0;
  Dvsat_Vsbulk_si_Vgi_bi=0.0;
  Dvsat_Vsbulk_si_Vdi_bi=0.0;
  Dvsat_Vsbulk_si_Vsi_bi=0.0;
  Dvsat_Vsbulk_si_Tempt_GND=0.0;
#endif
Dvsat_Vgi_bi=(0.5*(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0))));
#if defined(_DERIVATE2)
  Dvsat_Vgi_bi_Vdbulk_di=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vdbulk_di+((((-T1_Vdbulk_di/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdbulk_di*d10_asinh0))))+0.0*(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0)))+0.5*(+T2_Vgi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1)*d00_asinh0+(-T1_Vgi_bi/T1/T1)*T1_Vdbulk_di*d10_asinh0+(-T1_Vdbulk_di/T1/T1)*T1_Vgi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vdbulk_di*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vdbulk_di))));
  Dvsat_Vgi_bi_Vsbulk_si=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vsbulk_si+((((-T1_Vsbulk_si/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsbulk_si*d10_asinh0))))+0.0*(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0)))+0.5*(+T2_Vgi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1)*d00_asinh0+(-T1_Vgi_bi/T1/T1)*T1_Vsbulk_si*d10_asinh0+(-T1_Vsbulk_si/T1/T1)*T1_Vgi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vsbulk_si*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vsbulk_si))));
  Dvsat_Vgi_bi_Vgi_bi=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vgi_bi+((((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0))))+0.0*(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0)))+0.5*(+T2_Vgi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1)*d00_asinh0+(-T1_Vgi_bi/T1/T1)*T1_Vgi_bi*d10_asinh0+(-T1_Vgi_bi/T1/T1)*T1_Vgi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vgi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vgi_bi))));
  Dvsat_Vgi_bi_Vdi_bi=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vdi_bi+((((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0))))+0.0*(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0)))+0.5*(+T2_Vgi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1)*d00_asinh0+(-T1_Vgi_bi/T1/T1)*T1_Vdi_bi*d10_asinh0+(-T1_Vdi_bi/T1/T1)*T1_Vgi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vdi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vdi_bi))));
  Dvsat_Vgi_bi_Vsi_bi=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vsi_bi+((((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0))))+0.0*(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0)))+0.5*(+T2_Vgi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1)*d00_asinh0+(-T1_Vgi_bi/T1/T1)*T1_Vsi_bi*d10_asinh0+(-T1_Vsi_bi/T1/T1)*T1_Vgi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vsi_bi*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Vsi_bi))));
  Dvsat_Vgi_bi_Tempt_GND=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Tempt_GND+((((-T1_Tempt_GND/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Tempt_GND*d10_asinh0))))+0.0*(T2_Vgi_bi+(((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0)))+0.5*(+T2_Vgi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+1.0*T1_Vgi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1)*d00_asinh0+(-T1_Vgi_bi/T1/T1)*T1_Tempt_GND*d10_asinh0+(-T1_Tempt_GND/T1/T1)*T1_Vgi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Tempt_GND*T1_Vgi_bi+d10_asinh0*T1_Vgi_bi_Tempt_GND))));
#endif
Dvsat_Vdi_bi=(0.5*(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0))));
#if defined(_DERIVATE2)
  Dvsat_Vdi_bi_Vdbulk_di=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vdbulk_di+((((-T1_Vdbulk_di/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdbulk_di*d10_asinh0))))+0.0*(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0)))+0.5*(+T2_Vdi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1)*d00_asinh0+(-T1_Vdi_bi/T1/T1)*T1_Vdbulk_di*d10_asinh0+(-T1_Vdbulk_di/T1/T1)*T1_Vdi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vdbulk_di*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vdbulk_di))));
  Dvsat_Vdi_bi_Vsbulk_si=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vsbulk_si+((((-T1_Vsbulk_si/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsbulk_si*d10_asinh0))))+0.0*(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0)))+0.5*(+T2_Vdi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1)*d00_asinh0+(-T1_Vdi_bi/T1/T1)*T1_Vsbulk_si*d10_asinh0+(-T1_Vsbulk_si/T1/T1)*T1_Vdi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vsbulk_si*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vsbulk_si))));
  Dvsat_Vdi_bi_Vgi_bi=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vgi_bi+((((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0))))+0.0*(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0)))+0.5*(+T2_Vdi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1)*d00_asinh0+(-T1_Vdi_bi/T1/T1)*T1_Vgi_bi*d10_asinh0+(-T1_Vgi_bi/T1/T1)*T1_Vdi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vgi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vgi_bi))));
  Dvsat_Vdi_bi_Vdi_bi=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vdi_bi+((((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0))))+0.0*(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0)))+0.5*(+T2_Vdi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1)*d00_asinh0+(-T1_Vdi_bi/T1/T1)*T1_Vdi_bi*d10_asinh0+(-T1_Vdi_bi/T1/T1)*T1_Vdi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vdi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vdi_bi))));
  Dvsat_Vdi_bi_Vsi_bi=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vsi_bi+((((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0))))+0.0*(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0)))+0.5*(+T2_Vdi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1)*d00_asinh0+(-T1_Vdi_bi/T1/T1)*T1_Vsi_bi*d10_asinh0+(-T1_Vsi_bi/T1/T1)*T1_Vdi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vsi_bi*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Vsi_bi))));
  Dvsat_Vdi_bi_Tempt_GND=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Tempt_GND+((((-T1_Tempt_GND/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Tempt_GND*d10_asinh0))))+0.0*(T2_Vdi_bi+(((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0)))+0.5*(+T2_Vdi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+1.0*T1_Vdi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1)*d00_asinh0+(-T1_Vdi_bi/T1/T1)*T1_Tempt_GND*d10_asinh0+(-T1_Tempt_GND/T1/T1)*T1_Vdi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Tempt_GND*T1_Vdi_bi+d10_asinh0*T1_Vdi_bi_Tempt_GND))));
#endif
Dvsat_Vsi_bi=(0.5*(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0))));
#if defined(_DERIVATE2)
  Dvsat_Vsi_bi_Vdbulk_di=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vdbulk_di+((((-T1_Vdbulk_di/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdbulk_di*d10_asinh0))))+0.0*(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0)))+0.5*(+T2_Vsi_bi_Vdbulk_di+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1)*d00_asinh0+(-T1_Vsi_bi/T1/T1)*T1_Vdbulk_di*d10_asinh0+(-T1_Vdbulk_di/T1/T1)*T1_Vsi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vdbulk_di*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vdbulk_di))));
  Dvsat_Vsi_bi_Vsbulk_si=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vsbulk_si+((((-T1_Vsbulk_si/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsbulk_si*d10_asinh0))))+0.0*(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0)))+0.5*(+T2_Vsi_bi_Vsbulk_si+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1)*d00_asinh0+(-T1_Vsi_bi/T1/T1)*T1_Vsbulk_si*d10_asinh0+(-T1_Vsbulk_si/T1/T1)*T1_Vsi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vsbulk_si*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vsbulk_si))));
  Dvsat_Vsi_bi_Vgi_bi=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vgi_bi+((((-T1_Vgi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vgi_bi*d10_asinh0))))+0.0*(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0)))+0.5*(+T2_Vsi_bi_Vgi_bi+(+(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vgi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1)*d00_asinh0+(-T1_Vsi_bi/T1/T1)*T1_Vgi_bi*d10_asinh0+(-T1_Vgi_bi/T1/T1)*T1_Vsi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vgi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vgi_bi))));
  Dvsat_Vsi_bi_Vdi_bi=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vdi_bi+((((-T1_Vdi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vdi_bi*d10_asinh0))))+0.0*(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0)))+0.5*(+T2_Vsi_bi_Vdi_bi+(+(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vdi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1)*d00_asinh0+(-T1_Vsi_bi/T1/T1)*T1_Vdi_bi*d10_asinh0+(-T1_Vdi_bi/T1/T1)*T1_Vsi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vdi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vdi_bi))));
  Dvsat_Vsi_bi_Vsi_bi=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Vsi_bi+((((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0))))+0.0*(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0)))+0.5*(+T2_Vsi_bi_Vsi_bi+(+(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Vsi_bi)/T1/T1+2*1.0*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1)*d00_asinh0+(-T1_Vsi_bi/T1/T1)*T1_Vsi_bi*d10_asinh0+(-T1_Vsi_bi/T1/T1)*T1_Vsi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Vsi_bi*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Vsi_bi))));
  Dvsat_Vsi_bi_Tempt_GND=(+0.0*(T2+((1.0/T1)*d00_asinh0))+0.0*(T2_Tempt_GND+((((-T1_Tempt_GND/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Tempt_GND*d10_asinh0))))+0.0*(T2_Vsi_bi+(((-T1_Vsi_bi/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Vsi_bi*d10_asinh0)))+0.5*(+T2_Vsi_bi_Tempt_GND+(+(0.0/T1-(0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+1.0*T1_Vsi_bi_Tempt_GND)/T1/T1+2*1.0*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1)*d00_asinh0+(-T1_Vsi_bi/T1/T1)*T1_Tempt_GND*d10_asinh0+(-T1_Tempt_GND/T1/T1)*T1_Vsi_bi*d10_asinh0+(1.0/T1)*(m20_asinh(T1)*T1_Tempt_GND*T1_Vsi_bi+d10_asinh0*T1_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
Dvsat_Tempt_GND=(0.5*(T2_Tempt_GND+(((-T1_Tempt_GND/T1/T1)*d00_asinh0)+((1.0/T1)*T1_Tempt_GND*d10_asinh0))));
#endif
#endif
Dvsat=(0.5*(T2+((1.0/T1)*d00_asinh0)));
EXIT_IF_ISNAN((0.5*(T2+((1.0/T1)*d00_asinh0))))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
Dvsat_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Dvsat_Vdbulk_di_Vdbulk_di=0.0;
  Dvsat_Vdbulk_di_Vsbulk_si=0.0;
  Dvsat_Vdbulk_di_Vgi_bi=0.0;
  Dvsat_Vdbulk_di_Vdi_bi=0.0;
  Dvsat_Vdbulk_di_Vsi_bi=0.0;
  Dvsat_Vdbulk_di_Tempt_GND=0.0;
#endif
Dvsat_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Dvsat_Vsbulk_si_Vdbulk_di=0.0;
  Dvsat_Vsbulk_si_Vsbulk_si=0.0;
  Dvsat_Vsbulk_si_Vgi_bi=0.0;
  Dvsat_Vsbulk_si_Vdi_bi=0.0;
  Dvsat_Vsbulk_si_Vsi_bi=0.0;
  Dvsat_Vsbulk_si_Tempt_GND=0.0;
#endif
Dvsat_Vgi_bi=(0.5*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2)));
#if defined(_DERIVATE2)
  Dvsat_Vgi_bi_Vdbulk_di=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vdbulk_di+(-T2_Vdbulk_di/T2/T2))+0.0*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2))+0.5*(+T2_Vgi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdbulk_di/T2/T2/T2)));
  Dvsat_Vgi_bi_Vsbulk_si=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vsbulk_si+(-T2_Vsbulk_si/T2/T2))+0.0*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2))+0.5*(+T2_Vgi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsbulk_si/T2/T2/T2)));
  Dvsat_Vgi_bi_Vgi_bi=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2))+0.0*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2))+0.5*(+T2_Vgi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vgi_bi/T2/T2/T2)));
  Dvsat_Vgi_bi_Vdi_bi=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2))+0.0*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2))+0.5*(+T2_Vgi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vdi_bi/T2/T2/T2)));
  Dvsat_Vgi_bi_Vsi_bi=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2))+0.0*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2))+0.5*(+T2_Vgi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vgi_bi*T2_Vsi_bi/T2/T2/T2)));
  Dvsat_Vgi_bi_Tempt_GND=(+0.0*(T2+(1.0/T2))+0.0*(T2_Tempt_GND+(-T2_Tempt_GND/T2/T2))+0.0*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2))+0.5*(+T2_Vgi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+1.0*T2_Vgi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vgi_bi*T2_Tempt_GND/T2/T2/T2)));
#endif
Dvsat_Vdi_bi=(0.5*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2)));
#if defined(_DERIVATE2)
  Dvsat_Vdi_bi_Vdbulk_di=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vdbulk_di+(-T2_Vdbulk_di/T2/T2))+0.0*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2))+0.5*(+T2_Vdi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdbulk_di/T2/T2/T2)));
  Dvsat_Vdi_bi_Vsbulk_si=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vsbulk_si+(-T2_Vsbulk_si/T2/T2))+0.0*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2))+0.5*(+T2_Vdi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsbulk_si/T2/T2/T2)));
  Dvsat_Vdi_bi_Vgi_bi=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2))+0.0*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2))+0.5*(+T2_Vdi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vgi_bi/T2/T2/T2)));
  Dvsat_Vdi_bi_Vdi_bi=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2))+0.0*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2))+0.5*(+T2_Vdi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vdi_bi/T2/T2/T2)));
  Dvsat_Vdi_bi_Vsi_bi=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2))+0.0*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2))+0.5*(+T2_Vdi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vdi_bi*T2_Vsi_bi/T2/T2/T2)));
  Dvsat_Vdi_bi_Tempt_GND=(+0.0*(T2+(1.0/T2))+0.0*(T2_Tempt_GND+(-T2_Tempt_GND/T2/T2))+0.0*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2))+0.5*(+T2_Vdi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+1.0*T2_Vdi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vdi_bi*T2_Tempt_GND/T2/T2/T2)));
#endif
Dvsat_Vsi_bi=(0.5*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2)));
#if defined(_DERIVATE2)
  Dvsat_Vsi_bi_Vdbulk_di=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vdbulk_di+(-T2_Vdbulk_di/T2/T2))+0.0*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2))+0.5*(+T2_Vsi_bi_Vdbulk_di+(0.0/T2-(0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdbulk_di)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdbulk_di/T2/T2/T2)));
  Dvsat_Vsi_bi_Vsbulk_si=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vsbulk_si+(-T2_Vsbulk_si/T2/T2))+0.0*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2))+0.5*(+T2_Vsi_bi_Vsbulk_si+(0.0/T2-(0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsbulk_si)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsbulk_si/T2/T2/T2)));
  Dvsat_Vsi_bi_Vgi_bi=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vgi_bi+(-T2_Vgi_bi/T2/T2))+0.0*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2))+0.5*(+T2_Vsi_bi_Vgi_bi+(0.0/T2-(0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vgi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vgi_bi/T2/T2/T2)));
  Dvsat_Vsi_bi_Vdi_bi=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vdi_bi+(-T2_Vdi_bi/T2/T2))+0.0*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2))+0.5*(+T2_Vsi_bi_Vdi_bi+(0.0/T2-(0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vdi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vdi_bi/T2/T2/T2)));
  Dvsat_Vsi_bi_Vsi_bi=(+0.0*(T2+(1.0/T2))+0.0*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2))+0.0*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2))+0.5*(+T2_Vsi_bi_Vsi_bi+(0.0/T2-(0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Vsi_bi)/T2/T2+2*1.0*T2_Vsi_bi*T2_Vsi_bi/T2/T2/T2)));
  Dvsat_Vsi_bi_Tempt_GND=(+0.0*(T2+(1.0/T2))+0.0*(T2_Tempt_GND+(-T2_Tempt_GND/T2/T2))+0.0*(T2_Vsi_bi+(-T2_Vsi_bi/T2/T2))+0.5*(+T2_Vsi_bi_Tempt_GND+(0.0/T2-(0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+1.0*T2_Vsi_bi_Tempt_GND)/T2/T2+2*1.0*T2_Vsi_bi*T2_Tempt_GND/T2/T2/T2)));
#endif
#if defined(_DERIVATE)
Dvsat_Tempt_GND=(0.5*(T2_Tempt_GND+(-T2_Tempt_GND/T2/T2)));
#endif
#endif
Dvsat=(0.5*(T2+(1.0/T2)));
EXIT_IF_ISNAN((0.5*(T2+(1.0/T2))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
Dptwg_Vgi_bi=Dvsat_Vgi_bi;
#if defined(_DERIVATE2)
  Dptwg_Vgi_bi_Vgi_bi=Dvsat_Vgi_bi_Vgi_bi;
  Dptwg_Vgi_bi_Vdi_bi=Dvsat_Vgi_bi_Vdi_bi;
  Dptwg_Vgi_bi_Vsi_bi=Dvsat_Vgi_bi_Vsi_bi;
  Dptwg_Vgi_bi_Tempt_GND=Dvsat_Vgi_bi_Tempt_GND;
#endif
Dptwg_Vdi_bi=Dvsat_Vdi_bi;
#if defined(_DERIVATE2)
  Dptwg_Vdi_bi_Vgi_bi=Dvsat_Vdi_bi_Vgi_bi;
  Dptwg_Vdi_bi_Vdi_bi=Dvsat_Vdi_bi_Vdi_bi;
  Dptwg_Vdi_bi_Vsi_bi=Dvsat_Vdi_bi_Vsi_bi;
  Dptwg_Vdi_bi_Tempt_GND=Dvsat_Vdi_bi_Tempt_GND;
#endif
Dptwg_Vsi_bi=Dvsat_Vsi_bi;
#if defined(_DERIVATE2)
  Dptwg_Vsi_bi_Vgi_bi=Dvsat_Vsi_bi_Vgi_bi;
  Dptwg_Vsi_bi_Vdi_bi=Dvsat_Vsi_bi_Vdi_bi;
  Dptwg_Vsi_bi_Vsi_bi=Dvsat_Vsi_bi_Vsi_bi;
  Dptwg_Vsi_bi_Tempt_GND=Dvsat_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
Dptwg_Tempt_GND=Dvsat_Tempt_GND;
#endif
#endif
Dptwg=Dvsat;
EXIT_IF_ISNAN(Dvsat)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Rsource_Tempt_GND=0.0;
Rsource_Vgi_bi=0.0;
Rsource_Vdi_bi=0.0;
Rsource_Vsi_bi=0.0;
#endif
Rsource=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Rdrain_Tempt_GND=0.0;
Rdrain_Vgi_bi=0.0;
Rdrain_Vdi_bi=0.0;
Rdrain_Vsi_bi=0.0;
#endif
Rdrain=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->RDSMOD==1))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Rdsi_Tempt_GND=0.0;
#endif
Rdsi_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vgi_bi_Tempt_GND=0.0;
  Rdsi_Vgi_bi_Vgi_bi=0.0;
  Rdsi_Vgi_bi_Vdi_bi=0.0;
  Rdsi_Vgi_bi_Vsi_bi=0.0;
#endif
Rdsi_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vdi_bi_Tempt_GND=0.0;
  Rdsi_Vdi_bi_Vgi_bi=0.0;
  Rdsi_Vdi_bi_Vdi_bi=0.0;
  Rdsi_Vdi_bi_Vsi_bi=0.0;
#endif
Rdsi_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vsi_bi_Tempt_GND=0.0;
  Rdsi_Vsi_bi_Vgi_bi=0.0;
  Rdsi_Vsi_bi_Vdi_bi=0.0;
  Rdsi_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
Rdsi=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
Dr_Tempt_GND=0.0;
#endif
Dr_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Dr_Vdi_bi_Tempt_GND=0.0;
  Dr_Vdi_bi_Vdi_bi=0.0;
  Dr_Vdi_bi_Vsi_bi=0.0;
  Dr_Vdi_bi_Vgi_bi=0.0;
#endif
Dr_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Dr_Vsi_bi_Tempt_GND=0.0;
  Dr_Vsi_bi_Vdi_bi=0.0;
  Dr_Vsi_bi_Vsi_bi=0.0;
  Dr_Vsi_bi_Vgi_bi=0.0;
#endif
Dr_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Dr_Vgi_bi_Tempt_GND=0.0;
  Dr_Vgi_bi_Vdi_bi=0.0;
  Dr_Vgi_bi_Vsi_bi=0.0;
  Dr_Vgi_bi_Vgi_bi=0.0;
#endif
#endif
Dr=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=Vgs_noswap_Vgi_bi;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0-0.0);
  T2_Vgi_bi_Vgm_si=(+0.0-0.0);
  T2_Vgi_bi_Vdbulk_di=(+0.0-0.0);
  T2_Vgi_bi_Vsbulk_si=(+0.0-0.0);
  T2_Vgi_bi_Vgi_bi=(+Vgs_noswap_Vgi_bi_Vgi_bi-0.0);
  T2_Vgi_bi_Vdi_bi=(+0.0-0.0);
  T2_Vgi_bi_Vsi_bi=(+Vgs_noswap_Vgi_bi_Vsi_bi-0.0);
  T2_Vgi_bi_Tempt_GND=(+0.0-0.0);
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=Vgs_noswap_Vsi_bi;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0-0.0);
  T2_Vsi_bi_Vgm_si=(+0.0-0.0);
  T2_Vsi_bi_Vdbulk_di=(+0.0-0.0);
  T2_Vsi_bi_Vsbulk_si=(+0.0-0.0);
  T2_Vsi_bi_Vgi_bi=(+Vgs_noswap_Vsi_bi_Vgi_bi-0.0);
  T2_Vsi_bi_Vdi_bi=(+0.0-0.0);
  T2_Vsi_bi_Vsi_bi=(+Vgs_noswap_Vsi_bi_Vsi_bi-0.0);
  T2_Vsi_bi_Tempt_GND=(+0.0-0.0);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(-Vfbsdr_Tempt_GND);
#endif
#endif
T2=(Vgs_noswap-Vfbsdr);
EXIT_IF_ISNAN((Vgs_noswap-Vfbsdr))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si)+0.0));
  T3_Vgi_bi_Vgm_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di)+0.0));
  T3_Vgi_bi_Vdbulk_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di)+0.0));
  T3_Vgi_bi_Vsbulk_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si)+0.0));
  T3_Vgi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0));
  T3_Vgi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0));
  T3_Vgi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0));
  T3_Vgi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0));
#endif
T3_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si)+0.0));
  T3_Vdi_bi_Vgm_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di)+0.0));
  T3_Vdi_bi_Vdbulk_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di)+0.0));
  T3_Vdi_bi_Vsbulk_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si)+0.0));
  T3_Vdi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0));
  T3_Vdi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0));
  T3_Vdi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0));
  T3_Vdi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0));
#endif
T3_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si)+0.0));
  T3_Vsi_bi_Vgm_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di)+0.0));
  T3_Vsi_bi_Vdbulk_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di)+0.0));
  T3_Vsi_bi_Vsbulk_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si)+0.0));
  T3_Vsi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0));
  T3_Vsi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0));
  T3_Vsi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0));
  T3_Vsi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0;
#endif
#endif
T3=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
Vgs_eff_Vgi_bi=(0.5*(T2_Vgi_bi+T3_Vgi_bi));
#if defined(_DERIVATE2)
  Vgs_eff_Vgi_bi_Vgi_bi=(+0.0*(T2+T3)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.5*(+T2_Vgi_bi_Vgi_bi+T3_Vgi_bi_Vgi_bi));
  Vgs_eff_Vgi_bi_Vdi_bi=(+0.0*(T2+T3)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.5*(+T2_Vgi_bi_Vdi_bi+T3_Vgi_bi_Vdi_bi));
  Vgs_eff_Vgi_bi_Vsi_bi=(+0.0*(T2+T3)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.5*(+T2_Vgi_bi_Vsi_bi+T3_Vgi_bi_Vsi_bi));
  Vgs_eff_Vgi_bi_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.5*(+T2_Vgi_bi_Tempt_GND+T3_Vgi_bi_Tempt_GND));
#endif
Vgs_eff_Vdi_bi=(0.5*(T2_Vdi_bi+T3_Vdi_bi));
#if defined(_DERIVATE2)
  Vgs_eff_Vdi_bi_Vgi_bi=(+0.0*(T2+T3)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.5*(+T2_Vdi_bi_Vgi_bi+T3_Vdi_bi_Vgi_bi));
  Vgs_eff_Vdi_bi_Vdi_bi=(+0.0*(T2+T3)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.5*(+T2_Vdi_bi_Vdi_bi+T3_Vdi_bi_Vdi_bi));
  Vgs_eff_Vdi_bi_Vsi_bi=(+0.0*(T2+T3)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.5*(+T2_Vdi_bi_Vsi_bi+T3_Vdi_bi_Vsi_bi));
  Vgs_eff_Vdi_bi_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.5*(+T2_Vdi_bi_Tempt_GND+T3_Vdi_bi_Tempt_GND));
#endif
Vgs_eff_Vsi_bi=(0.5*(T2_Vsi_bi+T3_Vsi_bi));
#if defined(_DERIVATE2)
  Vgs_eff_Vsi_bi_Vgi_bi=(+0.0*(T2+T3)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.5*(+T2_Vsi_bi_Vgi_bi+T3_Vsi_bi_Vgi_bi));
  Vgs_eff_Vsi_bi_Vdi_bi=(+0.0*(T2+T3)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.5*(+T2_Vsi_bi_Vdi_bi+T3_Vsi_bi_Vdi_bi));
  Vgs_eff_Vsi_bi_Vsi_bi=(+0.0*(T2+T3)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.5*(+T2_Vsi_bi_Vsi_bi+T3_Vsi_bi_Vsi_bi));
  Vgs_eff_Vsi_bi_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.5*(+T2_Vsi_bi_Tempt_GND+T3_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
Vgs_eff_Tempt_GND=(0.5*(T2_Tempt_GND+T3_Tempt_GND));
#endif
#endif
Vgs_eff=(0.5*(T2+T3));
EXIT_IF_ISNAN((0.5*(T2+T3)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=(PRWG_i*Vgs_eff_Vgi_bi);
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+PRWG_i*0.0));
  T5_Vgi_bi_Vgm_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+PRWG_i*0.0));
  T5_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+PRWG_i*0.0));
  T5_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+PRWG_i*0.0));
  T5_Vgi_bi_Vgi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vgi_bi+0.0*Vgs_eff_Vgi_bi+PRWG_i*Vgs_eff_Vgi_bi_Vgi_bi));
  T5_Vgi_bi_Vdi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vdi_bi+0.0*Vgs_eff_Vgi_bi+PRWG_i*Vgs_eff_Vgi_bi_Vdi_bi));
  T5_Vgi_bi_Vsi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vsi_bi+0.0*Vgs_eff_Vgi_bi+PRWG_i*Vgs_eff_Vgi_bi_Vsi_bi));
  T5_Vgi_bi_Tempt_GND=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Tempt_GND+0.0*Vgs_eff_Vgi_bi+PRWG_i*Vgs_eff_Vgi_bi_Tempt_GND));
#endif
T5_Vdi_bi=(PRWG_i*Vgs_eff_Vdi_bi);
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+PRWG_i*0.0));
  T5_Vdi_bi_Vgm_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+PRWG_i*0.0));
  T5_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+PRWG_i*0.0));
  T5_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+PRWG_i*0.0));
  T5_Vdi_bi_Vgi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vgi_bi+0.0*Vgs_eff_Vdi_bi+PRWG_i*Vgs_eff_Vdi_bi_Vgi_bi));
  T5_Vdi_bi_Vdi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vdi_bi+0.0*Vgs_eff_Vdi_bi+PRWG_i*Vgs_eff_Vdi_bi_Vdi_bi));
  T5_Vdi_bi_Vsi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vsi_bi+0.0*Vgs_eff_Vdi_bi+PRWG_i*Vgs_eff_Vdi_bi_Vsi_bi));
  T5_Vdi_bi_Tempt_GND=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Tempt_GND+0.0*Vgs_eff_Vdi_bi+PRWG_i*Vgs_eff_Vdi_bi_Tempt_GND));
#endif
T5_Vsi_bi=(PRWG_i*Vgs_eff_Vsi_bi);
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+PRWG_i*0.0));
  T5_Vsi_bi_Vgm_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+PRWG_i*0.0));
  T5_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+PRWG_i*0.0));
  T5_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+PRWG_i*0.0));
  T5_Vsi_bi_Vgi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vgi_bi+0.0*Vgs_eff_Vsi_bi+PRWG_i*Vgs_eff_Vsi_bi_Vgi_bi));
  T5_Vsi_bi_Vdi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vdi_bi+0.0*Vgs_eff_Vsi_bi+PRWG_i*Vgs_eff_Vsi_bi_Vdi_bi));
  T5_Vsi_bi_Vsi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vsi_bi+0.0*Vgs_eff_Vsi_bi+PRWG_i*Vgs_eff_Vsi_bi_Vsi_bi));
  T5_Vsi_bi_Tempt_GND=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Tempt_GND+0.0*Vgs_eff_Vsi_bi+PRWG_i*Vgs_eff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=(PRWG_i*Vgs_eff_Tempt_GND);
#endif
#endif
T5=(1.0+(PRWG_i*Vgs_eff));
EXIT_IF_ISNAN((1.0+(PRWG_i*Vgs_eff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=(-T5_Vgi_bi/T5/T5);
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+(0.0/T5-(0.0*T5_Vgm_di+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vgm_di)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vgm_si=(+(0.0/T5-(0.0*T5_Vgm_si+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vgm_si)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vdbulk_di=(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vsbulk_si=(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vgi_bi=(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vgi_bi)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vdi_bi=(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vdi_bi)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vsi_bi=(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vsi_bi)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*Vsb_noswap_Vsi_bi+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Tempt_GND=(+(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Tempt_GND)/T5/T5+2*1.0*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
#endif
T6_Vdi_bi=(-T5_Vdi_bi/T5/T5);
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(0.0/T5-(0.0*T5_Vgm_di+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vgm_di)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vdi_bi_Vgm_si=(+(0.0/T5-(0.0*T5_Vgm_si+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vgm_si)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vdi_bi_Vdbulk_di=(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vdi_bi_Vsbulk_si=(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vdi_bi_Vgi_bi=(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vgi_bi)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vdi_bi_Vdi_bi=(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vdi_bi)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vdi_bi_Vsi_bi=(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vsi_bi)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*Vsb_noswap_Vsi_bi+0.0*0.0+PRWB_i*0.0));
  T6_Vdi_bi_Tempt_GND=(+(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Tempt_GND)/T5/T5+2*1.0*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
#endif
T6_Vsi_bi=((-T5_Vsi_bi/T5/T5)+(PRWB_i*Vsb_noswap_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(0.0/T5-(0.0*T5_Vgm_di+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vgm_di)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*Vsb_noswap_Vsi_bi+PRWB_i*0.0));
  T6_Vsi_bi_Vgm_si=(+(0.0/T5-(0.0*T5_Vgm_si+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vgm_si)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*Vsb_noswap_Vsi_bi+PRWB_i*0.0));
  T6_Vsi_bi_Vdbulk_di=(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*Vsb_noswap_Vsi_bi+PRWB_i*0.0));
  T6_Vsi_bi_Vsbulk_si=(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*Vsb_noswap_Vsi_bi+PRWB_i*0.0));
  T6_Vsi_bi_Vgi_bi=(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vgi_bi)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*Vsb_noswap_Vsi_bi+PRWB_i*0.0));
  T6_Vsi_bi_Vdi_bi=(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vdi_bi)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*Vsb_noswap_Vsi_bi+PRWB_i*0.0));
  T6_Vsi_bi_Vsi_bi=(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vsi_bi)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*Vsb_noswap_Vsi_bi+0.0*Vsb_noswap_Vsi_bi+PRWB_i*Vsb_noswap_Vsi_bi_Vsi_bi));
  T6_Vsi_bi_Tempt_GND=(+(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Tempt_GND)/T5/T5+2*1.0*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)+(+0.0*Vsb_noswap+0.0*0.0+0.0*Vsb_noswap_Vsi_bi+PRWB_i*0.0));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(-T5_Tempt_GND/T5/T5);
#endif
#endif
T6=((1.0/T5)+(PRWB_i*Vsb_noswap));
EXIT_IF_ISNAN(((1.0/T5)+(PRWB_i*Vsb_noswap)))
{
double m00_sqrt(d00_sqrt0,((T6*T6)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T6*T6)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(0.5*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_si+(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vgm_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vgm_si*T6+T6_Vgi_bi*T6_Vgm_si+T6_Vgm_si*T6_Vgi_bi+T6*T6_Vgi_bi_Vgm_si)+0.0))));
  T4_Vgi_bi_Vgm_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_di+(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vgm_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vgm_di*T6+T6_Vgi_bi*T6_Vgm_di+T6_Vgm_di*T6_Vgi_bi+T6*T6_Vgi_bi_Vgm_di)+0.0))));
  T4_Vgi_bi_Vdbulk_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdbulk_di+(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vdbulk_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vdbulk_di*T6+T6_Vgi_bi*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vgi_bi+T6*T6_Vgi_bi_Vdbulk_di)+0.0))));
  T4_Vgi_bi_Vsbulk_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsbulk_si+(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vsbulk_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vsbulk_si*T6+T6_Vgi_bi*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vgi_bi+T6*T6_Vgi_bi_Vsbulk_si)+0.0))));
  T4_Vgi_bi_Vgi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgi_bi+(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vgi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vgi_bi*T6+T6_Vgi_bi*T6_Vgi_bi+T6_Vgi_bi*T6_Vgi_bi+T6*T6_Vgi_bi_Vgi_bi)+0.0))));
  T4_Vgi_bi_Vdi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdi_bi+(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vdi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vdi_bi*T6+T6_Vgi_bi*T6_Vdi_bi+T6_Vdi_bi*T6_Vgi_bi+T6*T6_Vgi_bi_Vdi_bi)+0.0))));
  T4_Vgi_bi_Vsi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsi_bi+(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vsi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vsi_bi*T6+T6_Vgi_bi*T6_Vsi_bi+T6_Vsi_bi*T6_Vgi_bi+T6*T6_Vgi_bi_Vsi_bi)+0.0))));
  T4_Vgi_bi_Tempt_GND=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Tempt_GND+(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Tempt_GND+(m20_sqrt(((T6*T6)+0.01))*(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Tempt_GND*T6+T6_Vgi_bi*T6_Tempt_GND+T6_Tempt_GND*T6_Vgi_bi+T6*T6_Vgi_bi_Tempt_GND)+0.0))));
#endif
T4_Vdi_bi=(0.5*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_si+(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vgm_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vgm_si*T6+T6_Vdi_bi*T6_Vgm_si+T6_Vgm_si*T6_Vdi_bi+T6*T6_Vdi_bi_Vgm_si)+0.0))));
  T4_Vdi_bi_Vgm_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_di+(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vgm_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vgm_di*T6+T6_Vdi_bi*T6_Vgm_di+T6_Vgm_di*T6_Vdi_bi+T6*T6_Vdi_bi_Vgm_di)+0.0))));
  T4_Vdi_bi_Vdbulk_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdbulk_di+(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vdbulk_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vdbulk_di*T6+T6_Vdi_bi*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vdi_bi+T6*T6_Vdi_bi_Vdbulk_di)+0.0))));
  T4_Vdi_bi_Vsbulk_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsbulk_si+(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vsbulk_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vsbulk_si*T6+T6_Vdi_bi*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vdi_bi+T6*T6_Vdi_bi_Vsbulk_si)+0.0))));
  T4_Vdi_bi_Vgi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgi_bi+(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vgi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vgi_bi*T6+T6_Vdi_bi*T6_Vgi_bi+T6_Vgi_bi*T6_Vdi_bi+T6*T6_Vdi_bi_Vgi_bi)+0.0))));
  T4_Vdi_bi_Vdi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdi_bi+(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vdi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vdi_bi*T6+T6_Vdi_bi*T6_Vdi_bi+T6_Vdi_bi*T6_Vdi_bi+T6*T6_Vdi_bi_Vdi_bi)+0.0))));
  T4_Vdi_bi_Vsi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsi_bi+(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vsi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vsi_bi*T6+T6_Vdi_bi*T6_Vsi_bi+T6_Vsi_bi*T6_Vdi_bi+T6*T6_Vdi_bi_Vsi_bi)+0.0))));
  T4_Vdi_bi_Tempt_GND=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Tempt_GND+(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Tempt_GND+(m20_sqrt(((T6*T6)+0.01))*(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Tempt_GND*T6+T6_Vdi_bi*T6_Tempt_GND+T6_Tempt_GND*T6_Vdi_bi+T6*T6_Vdi_bi_Tempt_GND)+0.0))));
#endif
T4_Vsi_bi=(0.5*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_si+(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vgm_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vgm_si*T6+T6_Vsi_bi*T6_Vgm_si+T6_Vgm_si*T6_Vsi_bi+T6*T6_Vsi_bi_Vgm_si)+0.0))));
  T4_Vsi_bi_Vgm_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_di+(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vgm_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vgm_di*T6+T6_Vsi_bi*T6_Vgm_di+T6_Vgm_di*T6_Vsi_bi+T6*T6_Vsi_bi_Vgm_di)+0.0))));
  T4_Vsi_bi_Vdbulk_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdbulk_di+(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vdbulk_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vdbulk_di*T6+T6_Vsi_bi*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vsi_bi+T6*T6_Vsi_bi_Vdbulk_di)+0.0))));
  T4_Vsi_bi_Vsbulk_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsbulk_si+(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vsbulk_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vsbulk_si*T6+T6_Vsi_bi*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vsi_bi+T6*T6_Vsi_bi_Vsbulk_si)+0.0))));
  T4_Vsi_bi_Vgi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgi_bi+(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vgi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vgi_bi*T6+T6_Vsi_bi*T6_Vgi_bi+T6_Vgi_bi*T6_Vsi_bi+T6*T6_Vsi_bi_Vgi_bi)+0.0))));
  T4_Vsi_bi_Vdi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdi_bi+(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vdi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vdi_bi*T6+T6_Vsi_bi*T6_Vdi_bi+T6_Vdi_bi*T6_Vsi_bi+T6*T6_Vsi_bi_Vdi_bi)+0.0))));
  T4_Vsi_bi_Vsi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsi_bi+(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vsi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vsi_bi*T6+T6_Vsi_bi*T6_Vsi_bi+T6_Vsi_bi*T6_Vsi_bi+T6*T6_Vsi_bi_Vsi_bi)+0.0))));
  T4_Vsi_bi_Tempt_GND=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Tempt_GND+(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Tempt_GND+(m20_sqrt(((T6*T6)+0.01))*(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Tempt_GND*T6+T6_Vsi_bi*T6_Tempt_GND+T6_Tempt_GND*T6_Vsi_bi+T6*T6_Vsi_bi_Tempt_GND)+0.0))));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(0.5*(T6_Tempt_GND+((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND))*d10_sqrt0));
#endif
#endif
T4=(0.5*(T6+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T6+d00_sqrt0)))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Rsource_Tempt_GND=((rdstemp_Tempt_GND*(RSourceGeo+((RSWMIN_i+(RSW_i*T4))*WeffWRFactor)))+(rdstemp*(RSW_i*T4_Tempt_GND)*WeffWRFactor));
Rsource_Vgi_bi=(rdstemp*(RSW_i*T4_Vgi_bi)*WeffWRFactor);
Rsource_Vdi_bi=(rdstemp*(RSW_i*T4_Vdi_bi)*WeffWRFactor);
Rsource_Vsi_bi=(rdstemp*(RSW_i*T4_Vsi_bi)*WeffWRFactor);
#endif
Rsource=(rdstemp*(RSourceGeo+((RSWMIN_i+(RSW_i*T4))*WeffWRFactor)));
EXIT_IF_ISNAN((rdstemp*(RSourceGeo+((RSWMIN_i+(RSW_i*T4))*WeffWRFactor))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=Vgd_noswap_Vgi_bi;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0-0.0);
  T2_Vgi_bi_Vgm_si=(+0.0-0.0);
  T2_Vgi_bi_Vdbulk_di=(+0.0-0.0);
  T2_Vgi_bi_Vsbulk_si=(+0.0-0.0);
  T2_Vgi_bi_Vgi_bi=(+Vgd_noswap_Vgi_bi_Vgi_bi-0.0);
  T2_Vgi_bi_Vdi_bi=(+Vgd_noswap_Vgi_bi_Vdi_bi-0.0);
  T2_Vgi_bi_Vsi_bi=(+0.0-0.0);
  T2_Vgi_bi_Tempt_GND=(+0.0-0.0);
#endif
T2_Vdi_bi=Vgd_noswap_Vdi_bi;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0-0.0);
  T2_Vdi_bi_Vgm_si=(+0.0-0.0);
  T2_Vdi_bi_Vdbulk_di=(+0.0-0.0);
  T2_Vdi_bi_Vsbulk_si=(+0.0-0.0);
  T2_Vdi_bi_Vgi_bi=(+Vgd_noswap_Vdi_bi_Vgi_bi-0.0);
  T2_Vdi_bi_Vdi_bi=(+Vgd_noswap_Vdi_bi_Vdi_bi-0.0);
  T2_Vdi_bi_Vsi_bi=(+0.0-0.0);
  T2_Vdi_bi_Tempt_GND=(+0.0-0.0);
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(-Vfbsdr_Tempt_GND);
#endif
#endif
T2=(Vgd_noswap-Vfbsdr);
EXIT_IF_ISNAN((Vgd_noswap-Vfbsdr))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si)+0.0));
  T3_Vgi_bi_Vgm_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di)+0.0));
  T3_Vgi_bi_Vdbulk_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di)+0.0));
  T3_Vgi_bi_Vsbulk_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si)+0.0));
  T3_Vgi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0));
  T3_Vgi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0));
  T3_Vgi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0));
  T3_Vgi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0));
#endif
T3_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si)+0.0));
  T3_Vdi_bi_Vgm_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di)+0.0));
  T3_Vdi_bi_Vdbulk_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di)+0.0));
  T3_Vdi_bi_Vsbulk_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si)+0.0));
  T3_Vdi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0));
  T3_Vdi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0));
  T3_Vdi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0));
  T3_Vdi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0));
#endif
T3_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si)+0.0));
  T3_Vsi_bi_Vgm_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di)+0.0));
  T3_Vsi_bi_Vdbulk_di=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di)+0.0));
  T3_Vsi_bi_Vsbulk_si=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si)+0.0));
  T3_Vsi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0));
  T3_Vsi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0));
  T3_Vsi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0));
  T3_Vsi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0;
#endif
#endif
T3=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
Vgd_eff_Vgi_bi=(0.5*(T2_Vgi_bi+T3_Vgi_bi));
#if defined(_DERIVATE2)
  Vgd_eff_Vgi_bi_Vgi_bi=(+0.0*(T2+T3)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.5*(+T2_Vgi_bi_Vgi_bi+T3_Vgi_bi_Vgi_bi));
  Vgd_eff_Vgi_bi_Vdi_bi=(+0.0*(T2+T3)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.5*(+T2_Vgi_bi_Vdi_bi+T3_Vgi_bi_Vdi_bi));
  Vgd_eff_Vgi_bi_Vsi_bi=(+0.0*(T2+T3)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.5*(+T2_Vgi_bi_Vsi_bi+T3_Vgi_bi_Vsi_bi));
  Vgd_eff_Vgi_bi_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.5*(+T2_Vgi_bi_Tempt_GND+T3_Vgi_bi_Tempt_GND));
#endif
Vgd_eff_Vdi_bi=(0.5*(T2_Vdi_bi+T3_Vdi_bi));
#if defined(_DERIVATE2)
  Vgd_eff_Vdi_bi_Vgi_bi=(+0.0*(T2+T3)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.5*(+T2_Vdi_bi_Vgi_bi+T3_Vdi_bi_Vgi_bi));
  Vgd_eff_Vdi_bi_Vdi_bi=(+0.0*(T2+T3)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.5*(+T2_Vdi_bi_Vdi_bi+T3_Vdi_bi_Vdi_bi));
  Vgd_eff_Vdi_bi_Vsi_bi=(+0.0*(T2+T3)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.5*(+T2_Vdi_bi_Vsi_bi+T3_Vdi_bi_Vsi_bi));
  Vgd_eff_Vdi_bi_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.5*(+T2_Vdi_bi_Tempt_GND+T3_Vdi_bi_Tempt_GND));
#endif
Vgd_eff_Vsi_bi=(0.5*(T2_Vsi_bi+T3_Vsi_bi));
#if defined(_DERIVATE2)
  Vgd_eff_Vsi_bi_Vgi_bi=(+0.0*(T2+T3)+0.0*(T2_Vgi_bi+T3_Vgi_bi)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.5*(+T2_Vsi_bi_Vgi_bi+T3_Vsi_bi_Vgi_bi));
  Vgd_eff_Vsi_bi_Vdi_bi=(+0.0*(T2+T3)+0.0*(T2_Vdi_bi+T3_Vdi_bi)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.5*(+T2_Vsi_bi_Vdi_bi+T3_Vsi_bi_Vdi_bi));
  Vgd_eff_Vsi_bi_Vsi_bi=(+0.0*(T2+T3)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.5*(+T2_Vsi_bi_Vsi_bi+T3_Vsi_bi_Vsi_bi));
  Vgd_eff_Vsi_bi_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vsi_bi+T3_Vsi_bi)+0.5*(+T2_Vsi_bi_Tempt_GND+T3_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
Vgd_eff_Tempt_GND=(0.5*(T2_Tempt_GND+T3_Tempt_GND));
#endif
#endif
Vgd_eff=(0.5*(T2+T3));
EXIT_IF_ISNAN((0.5*(T2+T3)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=(PRWG_i*Vgd_eff_Vgi_bi);
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+PRWG_i*0.0));
  T5_Vgi_bi_Vgm_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+PRWG_i*0.0));
  T5_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+PRWG_i*0.0));
  T5_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+PRWG_i*0.0));
  T5_Vgi_bi_Vgi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vgi_bi+0.0*Vgd_eff_Vgi_bi+PRWG_i*Vgd_eff_Vgi_bi_Vgi_bi));
  T5_Vgi_bi_Vdi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vdi_bi+0.0*Vgd_eff_Vgi_bi+PRWG_i*Vgd_eff_Vgi_bi_Vdi_bi));
  T5_Vgi_bi_Vsi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vsi_bi+0.0*Vgd_eff_Vgi_bi+PRWG_i*Vgd_eff_Vgi_bi_Vsi_bi));
  T5_Vgi_bi_Tempt_GND=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Tempt_GND+0.0*Vgd_eff_Vgi_bi+PRWG_i*Vgd_eff_Vgi_bi_Tempt_GND));
#endif
T5_Vdi_bi=(PRWG_i*Vgd_eff_Vdi_bi);
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+PRWG_i*0.0));
  T5_Vdi_bi_Vgm_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+PRWG_i*0.0));
  T5_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+PRWG_i*0.0));
  T5_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+PRWG_i*0.0));
  T5_Vdi_bi_Vgi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vgi_bi+0.0*Vgd_eff_Vdi_bi+PRWG_i*Vgd_eff_Vdi_bi_Vgi_bi));
  T5_Vdi_bi_Vdi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vdi_bi+0.0*Vgd_eff_Vdi_bi+PRWG_i*Vgd_eff_Vdi_bi_Vdi_bi));
  T5_Vdi_bi_Vsi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vsi_bi+0.0*Vgd_eff_Vdi_bi+PRWG_i*Vgd_eff_Vdi_bi_Vsi_bi));
  T5_Vdi_bi_Tempt_GND=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Tempt_GND+0.0*Vgd_eff_Vdi_bi+PRWG_i*Vgd_eff_Vdi_bi_Tempt_GND));
#endif
T5_Vsi_bi=(PRWG_i*Vgd_eff_Vsi_bi);
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+PRWG_i*0.0));
  T5_Vsi_bi_Vgm_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+PRWG_i*0.0));
  T5_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+PRWG_i*0.0));
  T5_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+PRWG_i*0.0));
  T5_Vsi_bi_Vgi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vgi_bi+0.0*Vgd_eff_Vsi_bi+PRWG_i*Vgd_eff_Vsi_bi_Vgi_bi));
  T5_Vsi_bi_Vdi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vdi_bi+0.0*Vgd_eff_Vsi_bi+PRWG_i*Vgd_eff_Vsi_bi_Vdi_bi));
  T5_Vsi_bi_Vsi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vsi_bi+0.0*Vgd_eff_Vsi_bi+PRWG_i*Vgd_eff_Vsi_bi_Vsi_bi));
  T5_Vsi_bi_Tempt_GND=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Tempt_GND+0.0*Vgd_eff_Vsi_bi+PRWG_i*Vgd_eff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=(PRWG_i*Vgd_eff_Tempt_GND);
#endif
#endif
T5=(1.0+(PRWG_i*Vgd_eff));
EXIT_IF_ISNAN((1.0+(PRWG_i*Vgd_eff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=(-T5_Vgi_bi/T5/T5);
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+(0.0/T5-(0.0*T5_Vgm_di+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vgm_di)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vgm_si=(+(0.0/T5-(0.0*T5_Vgm_si+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vgm_si)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vdbulk_di=(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vsbulk_si=(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vgi_bi=(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vgi_bi)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vdi_bi=(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vdi_bi)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*Vdb_noswap_Vdi_bi+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Vsi_bi=(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Vsi_bi)/T5/T5+2*1.0*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vgi_bi_Tempt_GND=(+(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Vgi_bi+1.0*T5_Vgi_bi_Tempt_GND)/T5/T5+2*1.0*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
#endif
T6_Vdi_bi=((-T5_Vdi_bi/T5/T5)+(PRWB_i*Vdb_noswap_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(0.0/T5-(0.0*T5_Vgm_di+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vgm_di)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*Vdb_noswap_Vdi_bi+PRWB_i*0.0));
  T6_Vdi_bi_Vgm_si=(+(0.0/T5-(0.0*T5_Vgm_si+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vgm_si)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*Vdb_noswap_Vdi_bi+PRWB_i*0.0));
  T6_Vdi_bi_Vdbulk_di=(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*Vdb_noswap_Vdi_bi+PRWB_i*0.0));
  T6_Vdi_bi_Vsbulk_si=(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*Vdb_noswap_Vdi_bi+PRWB_i*0.0));
  T6_Vdi_bi_Vgi_bi=(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vgi_bi)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*Vdb_noswap_Vdi_bi+PRWB_i*0.0));
  T6_Vdi_bi_Vdi_bi=(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vdi_bi)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*Vdb_noswap_Vdi_bi+0.0*Vdb_noswap_Vdi_bi+PRWB_i*Vdb_noswap_Vdi_bi_Vdi_bi));
  T6_Vdi_bi_Vsi_bi=(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Vsi_bi)/T5/T5+2*1.0*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*Vdb_noswap_Vdi_bi+PRWB_i*0.0));
  T6_Vdi_bi_Tempt_GND=(+(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Vdi_bi+1.0*T5_Vdi_bi_Tempt_GND)/T5/T5+2*1.0*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*Vdb_noswap_Vdi_bi+PRWB_i*0.0));
#endif
T6_Vsi_bi=(-T5_Vsi_bi/T5/T5);
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(0.0/T5-(0.0*T5_Vgm_di+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vgm_di)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vsi_bi_Vgm_si=(+(0.0/T5-(0.0*T5_Vgm_si+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vgm_si)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vsi_bi_Vdbulk_di=(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vsi_bi_Vsbulk_si=(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vsi_bi_Vgi_bi=(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vgi_bi)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vsi_bi_Vdi_bi=(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vdi_bi)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*Vdb_noswap_Vdi_bi+0.0*0.0+PRWB_i*0.0));
  T6_Vsi_bi_Vsi_bi=(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Vsi_bi)/T5/T5+2*1.0*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
  T6_Vsi_bi_Tempt_GND=(+(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Vsi_bi+1.0*T5_Vsi_bi_Tempt_GND)/T5/T5+2*1.0*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)+(+0.0*Vdb_noswap+0.0*0.0+0.0*0.0+PRWB_i*0.0));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(-T5_Tempt_GND/T5/T5);
#endif
#endif
T6=((1.0/T5)+(PRWB_i*Vdb_noswap));
EXIT_IF_ISNAN(((1.0/T5)+(PRWB_i*Vdb_noswap)))
{
double m00_sqrt(d00_sqrt0,((T6*T6)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T6*T6)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(0.5*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_si+(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vgm_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vgm_si*T6+T6_Vgi_bi*T6_Vgm_si+T6_Vgm_si*T6_Vgi_bi+T6*T6_Vgi_bi_Vgm_si)+0.0))));
  T4_Vgi_bi_Vgm_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_di+(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vgm_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vgm_di*T6+T6_Vgi_bi*T6_Vgm_di+T6_Vgm_di*T6_Vgi_bi+T6*T6_Vgi_bi_Vgm_di)+0.0))));
  T4_Vgi_bi_Vdbulk_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdbulk_di+(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vdbulk_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vdbulk_di*T6+T6_Vgi_bi*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vgi_bi+T6*T6_Vgi_bi_Vdbulk_di)+0.0))));
  T4_Vgi_bi_Vsbulk_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsbulk_si+(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vsbulk_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vsbulk_si*T6+T6_Vgi_bi*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vgi_bi+T6*T6_Vgi_bi_Vsbulk_si)+0.0))));
  T4_Vgi_bi_Vgi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgi_bi+(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vgi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vgi_bi*T6+T6_Vgi_bi*T6_Vgi_bi+T6_Vgi_bi*T6_Vgi_bi+T6*T6_Vgi_bi_Vgi_bi)+0.0))));
  T4_Vgi_bi_Vdi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdi_bi+(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vdi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vdi_bi*T6+T6_Vgi_bi*T6_Vdi_bi+T6_Vdi_bi*T6_Vgi_bi+T6*T6_Vgi_bi_Vdi_bi)+0.0))));
  T4_Vgi_bi_Vsi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsi_bi+(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Vsi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Vsi_bi*T6+T6_Vgi_bi*T6_Vsi_bi+T6_Vsi_bi*T6_Vgi_bi+T6*T6_Vgi_bi_Vsi_bi)+0.0))));
  T4_Vgi_bi_Tempt_GND=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Tempt_GND+(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*d10_sqrt0)+0.0*(T6_Vgi_bi+((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))*d10_sqrt0)+0.5*(+T6_Vgi_bi_Tempt_GND+(m20_sqrt(((T6*T6)+0.01))*(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi))+d10_sqrt0*(+(+T6_Vgi_bi_Tempt_GND*T6+T6_Vgi_bi*T6_Tempt_GND+T6_Tempt_GND*T6_Vgi_bi+T6*T6_Vgi_bi_Tempt_GND)+0.0))));
#endif
T4_Vdi_bi=(0.5*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_si+(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vgm_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vgm_si*T6+T6_Vdi_bi*T6_Vgm_si+T6_Vgm_si*T6_Vdi_bi+T6*T6_Vdi_bi_Vgm_si)+0.0))));
  T4_Vdi_bi_Vgm_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_di+(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vgm_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vgm_di*T6+T6_Vdi_bi*T6_Vgm_di+T6_Vgm_di*T6_Vdi_bi+T6*T6_Vdi_bi_Vgm_di)+0.0))));
  T4_Vdi_bi_Vdbulk_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdbulk_di+(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vdbulk_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vdbulk_di*T6+T6_Vdi_bi*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vdi_bi+T6*T6_Vdi_bi_Vdbulk_di)+0.0))));
  T4_Vdi_bi_Vsbulk_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsbulk_si+(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vsbulk_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vsbulk_si*T6+T6_Vdi_bi*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vdi_bi+T6*T6_Vdi_bi_Vsbulk_si)+0.0))));
  T4_Vdi_bi_Vgi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgi_bi+(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vgi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vgi_bi*T6+T6_Vdi_bi*T6_Vgi_bi+T6_Vgi_bi*T6_Vdi_bi+T6*T6_Vdi_bi_Vgi_bi)+0.0))));
  T4_Vdi_bi_Vdi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdi_bi+(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vdi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vdi_bi*T6+T6_Vdi_bi*T6_Vdi_bi+T6_Vdi_bi*T6_Vdi_bi+T6*T6_Vdi_bi_Vdi_bi)+0.0))));
  T4_Vdi_bi_Vsi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsi_bi+(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Vsi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Vsi_bi*T6+T6_Vdi_bi*T6_Vsi_bi+T6_Vsi_bi*T6_Vdi_bi+T6*T6_Vdi_bi_Vsi_bi)+0.0))));
  T4_Vdi_bi_Tempt_GND=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Tempt_GND+(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*d10_sqrt0)+0.0*(T6_Vdi_bi+((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))*d10_sqrt0)+0.5*(+T6_Vdi_bi_Tempt_GND+(m20_sqrt(((T6*T6)+0.01))*(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi))+d10_sqrt0*(+(+T6_Vdi_bi_Tempt_GND*T6+T6_Vdi_bi*T6_Tempt_GND+T6_Tempt_GND*T6_Vdi_bi+T6*T6_Vdi_bi_Tempt_GND)+0.0))));
#endif
T4_Vsi_bi=(0.5*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_si+(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vgm_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_si*T6)+(T6*T6_Vgm_si)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vgm_si*T6+T6_Vsi_bi*T6_Vgm_si+T6_Vgm_si*T6_Vsi_bi+T6*T6_Vsi_bi_Vgm_si)+0.0))));
  T4_Vsi_bi_Vgm_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgm_di+(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vgm_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgm_di*T6)+(T6*T6_Vgm_di)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vgm_di*T6+T6_Vsi_bi*T6_Vgm_di+T6_Vgm_di*T6_Vsi_bi+T6*T6_Vsi_bi_Vgm_di)+0.0))));
  T4_Vsi_bi_Vdbulk_di=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdbulk_di+(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vdbulk_di+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vdbulk_di*T6+T6_Vsi_bi*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vsi_bi+T6*T6_Vsi_bi_Vdbulk_di)+0.0))));
  T4_Vsi_bi_Vsbulk_si=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsbulk_si+(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vsbulk_si+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vsbulk_si*T6+T6_Vsi_bi*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vsi_bi+T6*T6_Vsi_bi_Vsbulk_si)+0.0))));
  T4_Vsi_bi_Vgi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vgi_bi+(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vgi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vgi_bi*T6+T6_Vsi_bi*T6_Vgi_bi+T6_Vgi_bi*T6_Vsi_bi+T6*T6_Vsi_bi_Vgi_bi)+0.0))));
  T4_Vsi_bi_Vdi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vdi_bi+(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vdi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vdi_bi*T6+T6_Vsi_bi*T6_Vdi_bi+T6_Vdi_bi*T6_Vsi_bi+T6*T6_Vsi_bi_Vdi_bi)+0.0))));
  T4_Vsi_bi_Vsi_bi=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Vsi_bi+(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Vsi_bi+(m20_sqrt(((T6*T6)+0.01))*(((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Vsi_bi*T6+T6_Vsi_bi*T6_Vsi_bi+T6_Vsi_bi*T6_Vsi_bi+T6*T6_Vsi_bi_Vsi_bi)+0.0))));
  T4_Vsi_bi_Tempt_GND=(+0.0*(T6+d00_sqrt0)+0.0*(T6_Tempt_GND+(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*d10_sqrt0)+0.0*(T6_Vsi_bi+((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))*d10_sqrt0)+0.5*(+T6_Vsi_bi_Tempt_GND+(m20_sqrt(((T6*T6)+0.01))*(((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND)))*((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi))+d10_sqrt0*(+(+T6_Vsi_bi_Tempt_GND*T6+T6_Vsi_bi*T6_Tempt_GND+T6_Tempt_GND*T6_Vsi_bi+T6*T6_Vsi_bi_Tempt_GND)+0.0))));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(0.5*(T6_Tempt_GND+((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND))*d10_sqrt0));
#endif
#endif
T4=(0.5*(T6+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T6+d00_sqrt0)))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Rdrain_Tempt_GND=((rdstemp_Tempt_GND*(RDrainGeo+((RDWMIN_i+(RDW_i*T4))*WeffWRFactor)))+(rdstemp*(RDW_i*T4_Tempt_GND)*WeffWRFactor));
Rdrain_Vgi_bi=(rdstemp*(RDW_i*T4_Vgi_bi)*WeffWRFactor);
Rdrain_Vdi_bi=(rdstemp*(RDW_i*T4_Vdi_bi)*WeffWRFactor);
Rdrain_Vsi_bi=(rdstemp*(RDW_i*T4_Vsi_bi)*WeffWRFactor);
#endif
Rdrain=(rdstemp*(RDrainGeo+((RDWMIN_i+(RDW_i*T4))*WeffWRFactor)));
EXIT_IF_ISNAN((rdstemp*(RDrainGeo+((RDWMIN_i+(RDW_i*T4))*WeffWRFactor))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(PRWG_i*qia_Vgi_bi);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vgi_bi+PRWG_i*0.0));
  T0_Vgi_bi_Vgm_si=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vgi_bi+PRWG_i*0.0));
  T0_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vgi_bi+PRWG_i*qia_Vgi_bi_Vdbulk_di));
  T0_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vgi_bi+PRWG_i*qia_Vgi_bi_Vsbulk_si));
  T0_Vgi_bi_Vgi_bi=(+0.0+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vgi_bi+PRWG_i*qia_Vgi_bi_Vgi_bi));
  T0_Vgi_bi_Vdi_bi=(+0.0+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vgi_bi+PRWG_i*qia_Vgi_bi_Vdi_bi));
  T0_Vgi_bi_Vsi_bi=(+0.0+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vgi_bi+PRWG_i*qia_Vgi_bi_Vsi_bi));
  T0_Vgi_bi_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vgi_bi+PRWG_i*qia_Vgi_bi_Tempt_GND));
#endif
T0_Vdi_bi=(PRWG_i*qia_Vdi_bi);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_bi+PRWG_i*0.0));
  T0_Vdi_bi_Vgm_si=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_bi+PRWG_i*0.0));
  T0_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vdi_bi+PRWG_i*qia_Vdi_bi_Vdbulk_di));
  T0_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vdi_bi+PRWG_i*qia_Vdi_bi_Vsbulk_si));
  T0_Vdi_bi_Vgi_bi=(+0.0+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vdi_bi+PRWG_i*qia_Vdi_bi_Vgi_bi));
  T0_Vdi_bi_Vdi_bi=(+0.0+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vdi_bi+PRWG_i*qia_Vdi_bi_Vdi_bi));
  T0_Vdi_bi_Vsi_bi=(+0.0+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vdi_bi+PRWG_i*qia_Vdi_bi_Vsi_bi));
  T0_Vdi_bi_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_bi+PRWG_i*qia_Vdi_bi_Tempt_GND));
#endif
T0_Vsi_bi=(PRWG_i*qia_Vsi_bi);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vsi_bi+PRWG_i*0.0));
  T0_Vsi_bi_Vgm_si=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vsi_bi+PRWG_i*0.0));
  T0_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vsi_bi+PRWG_i*qia_Vsi_bi_Vdbulk_di));
  T0_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vsi_bi+PRWG_i*qia_Vsi_bi_Vsbulk_si));
  T0_Vsi_bi_Vgi_bi=(+0.0+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vsi_bi+PRWG_i*qia_Vsi_bi_Vgi_bi));
  T0_Vsi_bi_Vdi_bi=(+0.0+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vsi_bi+PRWG_i*qia_Vsi_bi_Vdi_bi));
  T0_Vsi_bi_Vsi_bi=(+0.0+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vsi_bi+PRWG_i*qia_Vsi_bi_Vsi_bi));
  T0_Vsi_bi_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vsi_bi+PRWG_i*qia_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(PRWG_i*qia_Tempt_GND);
#endif
#endif
T0=(1.0+(PRWG_i*qia));
EXIT_IF_ISNAN((1.0+(PRWG_i*qia)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=(PRWB_i*sqrtPhistVbs_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vgm_si=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vdbulk_di=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vsbulk_si=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vgi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+0.0-0.0));
  T1_Vdi_bi_Vdi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vdi_bi+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+sqrtPhistVbs_Vdi_bi_Vdi_bi-0.0));
  T1_Vdi_bi_Vsi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vsi_bi+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+sqrtPhistVbs_Vdi_bi_Vsi_bi-0.0));
  T1_Vdi_bi_Tempt_GND=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*(sqrtPhistVbs_Tempt_GND-sqrtPhist_Tempt_GND)+0.0*sqrtPhistVbs_Vdi_bi+PRWB_i*(+sqrtPhistVbs_Vdi_bi_Tempt_GND-0.0));
#endif
T1_Vsi_bi=(PRWB_i*sqrtPhistVbs_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vgm_si=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vdbulk_di=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vsbulk_si=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vgi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*0.0+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+0.0-0.0));
  T1_Vsi_bi_Vdi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vdi_bi+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+sqrtPhistVbs_Vsi_bi_Vdi_bi-0.0));
  T1_Vsi_bi_Vsi_bi=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*sqrtPhistVbs_Vsi_bi+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+sqrtPhistVbs_Vsi_bi_Vsi_bi-0.0));
  T1_Vsi_bi_Tempt_GND=(+0.0*(sqrtPhistVbs-sqrtPhist)+0.0*(sqrtPhistVbs_Tempt_GND-sqrtPhist_Tempt_GND)+0.0*sqrtPhistVbs_Vsi_bi+PRWB_i*(+sqrtPhistVbs_Vsi_bi_Tempt_GND-0.0));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(PRWB_i*(sqrtPhistVbs_Tempt_GND-sqrtPhist_Tempt_GND));
#endif
#endif
T1=(PRWB_i*(sqrtPhistVbs-sqrtPhist));
EXIT_IF_ISNAN((PRWB_i*(sqrtPhistVbs-sqrtPhist)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((-T0_Vgi_bi/T0/T0)+T1_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(0.0/T0-(0.0*T0_Vgm_di+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vgm_di)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vgm_di/T0/T0/T0)+T1_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(+(0.0/T0-(0.0*T0_Vgm_si+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vgm_si)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vgm_si/T0/T0/T0)+T1_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vdbulk_di)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vdbulk_di/T0/T0/T0)+T1_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vsbulk_si)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vsbulk_si/T0/T0/T0)+T1_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vgi_bi)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vgi_bi/T0/T0/T0)+T1_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(+(0.0/T0-(0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vdi_bi)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vdi_bi/T0/T0/T0)+T1_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(+(0.0/T0-(0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Vsi_bi)/T0/T0+2*1.0*T0_Vgi_bi*T0_Vsi_bi/T0/T0/T0)+T1_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(+(0.0/T0-(0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+1.0*T0_Vgi_bi_Tempt_GND)/T0/T0+2*1.0*T0_Vgi_bi*T0_Tempt_GND/T0/T0/T0)+T1_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=((-T0_Vdi_bi/T0/T0)+T1_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(0.0/T0-(0.0*T0_Vgm_di+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vgm_di)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vgm_di/T0/T0/T0)+T1_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(+(0.0/T0-(0.0*T0_Vgm_si+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vgm_si)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vgm_si/T0/T0/T0)+T1_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vdbulk_di)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vdbulk_di/T0/T0/T0)+T1_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vsbulk_si)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vsbulk_si/T0/T0/T0)+T1_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vgi_bi)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vgi_bi/T0/T0/T0)+T1_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(+(0.0/T0-(0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vdi_bi)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vdi_bi/T0/T0/T0)+T1_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(+(0.0/T0-(0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Vsi_bi)/T0/T0+2*1.0*T0_Vdi_bi*T0_Vsi_bi/T0/T0/T0)+T1_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(+(0.0/T0-(0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+1.0*T0_Vdi_bi_Tempt_GND)/T0/T0+2*1.0*T0_Vdi_bi*T0_Tempt_GND/T0/T0/T0)+T1_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=((-T0_Vsi_bi/T0/T0)+T1_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(0.0/T0-(0.0*T0_Vgm_di+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vgm_di)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vgm_di/T0/T0/T0)+T1_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(+(0.0/T0-(0.0*T0_Vgm_si+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vgm_si)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vgm_si/T0/T0/T0)+T1_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vdbulk_di)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vdbulk_di/T0/T0/T0)+T1_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vsbulk_si)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vsbulk_si/T0/T0/T0)+T1_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(+(0.0/T0-(0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vgi_bi)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vgi_bi/T0/T0/T0)+T1_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(+(0.0/T0-(0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vdi_bi)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vdi_bi/T0/T0/T0)+T1_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(+(0.0/T0-(0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Vsi_bi)/T0/T0+2*1.0*T0_Vsi_bi*T0_Vsi_bi/T0/T0/T0)+T1_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(+(0.0/T0-(0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+1.0*T0_Vsi_bi_Tempt_GND)/T0/T0+2*1.0*T0_Vsi_bi*T0_Tempt_GND/T0/T0/T0)+T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((-T0_Tempt_GND/T0/T0)+T1_Tempt_GND);
#endif
#endif
T2=((1.0/T0)+T1);
EXIT_IF_ISNAN(((1.0/T0)+T1))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(0.5*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_si+(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vgm_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si)+0.0))));
  T3_Vgi_bi_Vgm_di=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_di+(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vgm_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di)+0.0))));
  T3_Vgi_bi_Vdbulk_di=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdbulk_di+(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vdbulk_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di)+0.0))));
  T3_Vgi_bi_Vsbulk_si=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsbulk_si+(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vsbulk_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si)+0.0))));
  T3_Vgi_bi_Vgi_bi=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgi_bi+(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vgi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0))));
  T3_Vgi_bi_Vdi_bi=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_bi+(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vdi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0))));
  T3_Vgi_bi_Vsi_bi=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_bi+(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vsi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0))));
  T3_Vgi_bi_Tempt_GND=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Tempt_GND+(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0))));
#endif
T3_Vdi_bi=(0.5*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_si+(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vgm_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si)+0.0))));
  T3_Vdi_bi_Vgm_di=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_di+(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vgm_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di)+0.0))));
  T3_Vdi_bi_Vdbulk_di=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdbulk_di+(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vdbulk_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di)+0.0))));
  T3_Vdi_bi_Vsbulk_si=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsbulk_si+(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vsbulk_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si)+0.0))));
  T3_Vdi_bi_Vgi_bi=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgi_bi+(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vgi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0))));
  T3_Vdi_bi_Vdi_bi=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_bi+(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vdi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0))));
  T3_Vdi_bi_Vsi_bi=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_bi+(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vsi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0))));
  T3_Vdi_bi_Tempt_GND=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Tempt_GND+(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0))));
#endif
T3_Vsi_bi=(0.5*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_si+(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vgm_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si)+0.0))));
  T3_Vsi_bi_Vgm_di=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_di+(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vgm_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di)+0.0))));
  T3_Vsi_bi_Vdbulk_di=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdbulk_di+(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vdbulk_di+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di)+0.0))));
  T3_Vsi_bi_Vsbulk_si=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsbulk_si+(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vsbulk_si+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si)+0.0))));
  T3_Vsi_bi_Vgi_bi=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgi_bi+(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vgi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0))));
  T3_Vsi_bi_Vdi_bi=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_bi+(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vdi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0))));
  T3_Vsi_bi_Vsi_bi=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_bi+(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vsi_bi+(m20_sqrt(((T2*T2)+0.01))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0))));
  T3_Vsi_bi_Tempt_GND=(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Tempt_GND+(m20_sqrt(((T2*T2)+0.01))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0))));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(0.5*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0));
#endif
#endif
T3=(0.5*(T2+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T2+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Rdsi_Tempt_GND=((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T3)))+(rdstemp*(RDSW_i*T3_Tempt_GND)))*WeffWRFactor*pInst->NF;
#endif
Rdsi_Vgi_bi=(rdstemp*(RDSW_i*T3_Vgi_bi))*WeffWRFactor*pInst->NF;
#if defined(_DERIVATE2)
  Rdsi_Vgi_bi_Tempt_GND=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T3_Vgi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vgi_bi))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T3)))+(rdstemp*((RDSW_i*T3_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vgi_bi))*WeffWRFactor*0.0+((((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T3)))+(rdstemp*((RDSW_i*T3_Tempt_GND)))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
  Rdsi_Vgi_bi_Vgi_bi=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Vgi_bi))+0.0*(RDSW_i*T3_Vgi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vgi_bi)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vgi_bi))*0.0+((rdstemp*((RDSW_i*T3_Vgi_bi))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vgi_bi))*WeffWRFactor*0.0+(((rdstemp*((RDSW_i*T3_Vgi_bi))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
  Rdsi_Vgi_bi_Vdi_bi=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Vdi_bi))+0.0*(RDSW_i*T3_Vgi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vdi_bi)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vgi_bi))*0.0+((rdstemp*((RDSW_i*T3_Vdi_bi))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vgi_bi))*WeffWRFactor*0.0+(((rdstemp*((RDSW_i*T3_Vdi_bi))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
  Rdsi_Vgi_bi_Vsi_bi=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Vsi_bi))+0.0*(RDSW_i*T3_Vgi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vsi_bi)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vgi_bi))*0.0+((rdstemp*((RDSW_i*T3_Vsi_bi))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vgi_bi))*WeffWRFactor*0.0+(((rdstemp*((RDSW_i*T3_Vsi_bi))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
#endif
Rdsi_Vdi_bi=(rdstemp*(RDSW_i*T3_Vdi_bi))*WeffWRFactor*pInst->NF;
#if defined(_DERIVATE2)
  Rdsi_Vdi_bi_Tempt_GND=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T3_Vdi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vdi_bi))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T3)))+(rdstemp*((RDSW_i*T3_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vdi_bi))*WeffWRFactor*0.0+((((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T3)))+(rdstemp*((RDSW_i*T3_Tempt_GND)))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
  Rdsi_Vdi_bi_Vgi_bi=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Vgi_bi))+0.0*(RDSW_i*T3_Vdi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vgi_bi)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vdi_bi))*0.0+((rdstemp*((RDSW_i*T3_Vgi_bi))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vdi_bi))*WeffWRFactor*0.0+(((rdstemp*((RDSW_i*T3_Vgi_bi))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
  Rdsi_Vdi_bi_Vdi_bi=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Vdi_bi))+0.0*(RDSW_i*T3_Vdi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vdi_bi)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vdi_bi))*0.0+((rdstemp*((RDSW_i*T3_Vdi_bi))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vdi_bi))*WeffWRFactor*0.0+(((rdstemp*((RDSW_i*T3_Vdi_bi))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
  Rdsi_Vdi_bi_Vsi_bi=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Vsi_bi))+0.0*(RDSW_i*T3_Vdi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vsi_bi)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vdi_bi))*0.0+((rdstemp*((RDSW_i*T3_Vsi_bi))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vdi_bi))*WeffWRFactor*0.0+(((rdstemp*((RDSW_i*T3_Vsi_bi))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
#endif
Rdsi_Vsi_bi=(rdstemp*(RDSW_i*T3_Vsi_bi))*WeffWRFactor*pInst->NF;
#if defined(_DERIVATE2)
  Rdsi_Vsi_bi_Tempt_GND=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T3_Vsi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vsi_bi))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T3)))+(rdstemp*((RDSW_i*T3_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vsi_bi))*WeffWRFactor*0.0+((((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T3)))+(rdstemp*((RDSW_i*T3_Tempt_GND)))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
  Rdsi_Vsi_bi_Vgi_bi=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Vgi_bi))+0.0*(RDSW_i*T3_Vsi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vgi_bi)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vsi_bi))*0.0+((rdstemp*((RDSW_i*T3_Vgi_bi))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vsi_bi))*WeffWRFactor*0.0+(((rdstemp*((RDSW_i*T3_Vgi_bi))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
  Rdsi_Vsi_bi_Vdi_bi=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Vdi_bi))+0.0*(RDSW_i*T3_Vsi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vdi_bi)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vsi_bi))*0.0+((rdstemp*((RDSW_i*T3_Vdi_bi))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vsi_bi))*WeffWRFactor*0.0+(((rdstemp*((RDSW_i*T3_Vdi_bi))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
  Rdsi_Vsi_bi_Vsi_bi=(+(+(+0.0*(RDSWMIN_i+(RDSW_i*T3))+0.0*((RDSW_i*T3_Vsi_bi))+0.0*(RDSW_i*T3_Vsi_bi)+rdstemp*(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vsi_bi)))*WeffWRFactor+(rdstemp*(RDSW_i*T3_Vsi_bi))*0.0+((rdstemp*((RDSW_i*T3_Vsi_bi))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*0.0)*pInst->NF+(rdstemp*(RDSW_i*T3_Vsi_bi))*WeffWRFactor*0.0+(((rdstemp*((RDSW_i*T3_Vsi_bi))))*WeffWRFactor)*0.0+((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*0.0);
#endif
#endif
Rdsi=(((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*pInst->NF);
EXIT_IF_ISNAN((((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*pInst->NF))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Rdrain_Tempt_GND=0.0;
Rdrain_Vgi_bi=0.0;
Rdrain_Vdi_bi=0.0;
Rdrain_Vsi_bi=0.0;
#endif
Rdrain=RDrainGeo;
EXIT_IF_ISNAN(RDrainGeo)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Rsource_Tempt_GND=0.0;
Rsource_Vgi_bi=0.0;
Rsource_Vdi_bi=0.0;
Rsource_Vsi_bi=0.0;
#endif
Rsource=RSourceGeo;
EXIT_IF_ISNAN(RSourceGeo)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
Dr_Tempt_GND=(((((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Tempt_GND))*Rdsi)+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Tempt_GND));
#endif
Dr_Vdi_bi=(((((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi)+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi));
#if defined(_DERIVATE2)
  Dr_Vdi_bi_Tempt_GND=(+0.0+(+(+((+(+(U0_a_Vdi_bi_Tempt_GND/(Dvsat*Dmob)-(U0_a_Vdi_bi*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))+U0_a_Tempt_GND*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))+U0_a*(+Dvsat_Vdi_bi_Tempt_GND*Dmob+Dvsat_Vdi_bi*Dmob_Tempt_GND+Dvsat_Tempt_GND*Dmob_Vdi_bi+Dvsat*Dmob_Vdi_bi_Tempt_GND))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Tempt_GND+(((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi_Tempt_GND)*Rdsi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi_Tempt_GND+((((((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Tempt_GND)))*Rdsi_Vdi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi_Tempt_GND));
  Dr_Vdi_bi_Vdi_bi=(+0.0+(+(+((+(+(U0_a_Vdi_bi_Vdi_bi/(Dvsat*Dmob)-(U0_a_Vdi_bi*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))+U0_a_Vdi_bi*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))+U0_a*(+Dvsat_Vdi_bi_Vdi_bi*Dmob+Dvsat_Vdi_bi*Dmob_Vdi_bi+Dvsat_Vdi_bi*Dmob_Vdi_bi+Dvsat*Dmob_Vdi_bi_Vdi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vdi_bi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi_Vdi_bi)*Rdsi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi_Vdi_bi+((((((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi)))*Rdsi_Vdi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi_Vdi_bi));
  Dr_Vdi_bi_Vsi_bi=(+0.0+(+(+((+(+(U0_a_Vdi_bi_Vsi_bi/(Dvsat*Dmob)-(U0_a_Vdi_bi*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))+U0_a_Vsi_bi*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))+U0_a*(+Dvsat_Vdi_bi_Vsi_bi*Dmob+Dvsat_Vdi_bi*Dmob_Vsi_bi+Dvsat_Vsi_bi*Dmob_Vdi_bi+Dvsat*Dmob_Vdi_bi_Vsi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vsi_bi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi_Vsi_bi)*Rdsi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi_Vsi_bi+((((((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi)))*Rdsi_Vdi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi_Vsi_bi));
  Dr_Vdi_bi_Vgi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(U0_a_Vdi_bi*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))+0.0*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))+U0_a*(+Dvsat_Vdi_bi_Vgi_bi*Dmob+Dvsat_Vdi_bi*Dmob_Vgi_bi+Dvsat_Vgi_bi*Dmob_Vdi_bi+Dvsat*Dmob_Vdi_bi_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+(((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vgi_bi+((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi_Vgi_bi)*Rdsi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi_Vgi_bi+(((((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi)))*Rdsi_Vdi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi_Vgi_bi));
#endif
Dr_Vsi_bi=(((((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi)+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi));
#if defined(_DERIVATE2)
  Dr_Vsi_bi_Tempt_GND=(+0.0+(+(+((+(+(U0_a_Vsi_bi_Tempt_GND/(Dvsat*Dmob)-(U0_a_Vsi_bi*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))+U0_a_Tempt_GND*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))+U0_a*(+Dvsat_Vsi_bi_Tempt_GND*Dmob+Dvsat_Vsi_bi*Dmob_Tempt_GND+Dvsat_Tempt_GND*Dmob_Vsi_bi+Dvsat*Dmob_Vsi_bi_Tempt_GND))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Tempt_GND+(((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi_Tempt_GND)*Rdsi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi_Tempt_GND+((((((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Tempt_GND)))*Rdsi_Vsi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi_Tempt_GND));
  Dr_Vsi_bi_Vdi_bi=(+0.0+(+(+((+(+(U0_a_Vsi_bi_Vdi_bi/(Dvsat*Dmob)-(U0_a_Vsi_bi*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))+U0_a_Vdi_bi*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))+U0_a*(+Dvsat_Vsi_bi_Vdi_bi*Dmob+Dvsat_Vsi_bi*Dmob_Vdi_bi+Dvsat_Vdi_bi*Dmob_Vsi_bi+Dvsat*Dmob_Vsi_bi_Vdi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vdi_bi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi_Vdi_bi)*Rdsi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi_Vdi_bi+((((((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi)))*Rdsi_Vsi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi_Vdi_bi));
  Dr_Vsi_bi_Vsi_bi=(+0.0+(+(+((+(+(U0_a_Vsi_bi_Vsi_bi/(Dvsat*Dmob)-(U0_a_Vsi_bi*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))+U0_a_Vsi_bi*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))+U0_a*(+Dvsat_Vsi_bi_Vsi_bi*Dmob+Dvsat_Vsi_bi*Dmob_Vsi_bi+Dvsat_Vsi_bi*Dmob_Vsi_bi+Dvsat*Dmob_Vsi_bi_Vsi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vsi_bi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi_Vsi_bi)*Rdsi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi_Vsi_bi+((((((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi)))*Rdsi_Vsi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi_Vsi_bi));
  Dr_Vsi_bi_Vgi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(U0_a_Vsi_bi*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))+0.0*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))+U0_a*(+Dvsat_Vsi_bi_Vgi_bi*Dmob+Dvsat_Vsi_bi*Dmob_Vgi_bi+Dvsat_Vgi_bi*Dmob_Vsi_bi+Dvsat*Dmob_Vsi_bi_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+(((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vgi_bi+((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi_Vgi_bi)*Rdsi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi_Vgi_bi+(((((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi)))*Rdsi_Vsi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi_Vgi_bi));
#endif
Dr_Vgi_bi=((((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi)+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi));
#if defined(_DERIVATE2)
  Dr_Vgi_bi_Tempt_GND=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(0.0*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))+U0_a_Tempt_GND*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))+U0_a*(+Dvsat_Vgi_bi_Tempt_GND*Dmob+Dvsat_Vgi_bi*Dmob_Tempt_GND+Dvsat_Tempt_GND*Dmob_Vgi_bi+Dvsat*Dmob_Vgi_bi_Tempt_GND))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Tempt_GND+(((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi_Tempt_GND)*Rdsi+((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi_Tempt_GND+((((((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Tempt_GND)))*Rdsi_Vgi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi_Tempt_GND));
  Dr_Vgi_bi_Vdi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(0.0*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))+U0_a_Vdi_bi*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))+U0_a*(+Dvsat_Vgi_bi_Vdi_bi*Dmob+Dvsat_Vgi_bi*Dmob_Vdi_bi+Dvsat_Vdi_bi*Dmob_Vgi_bi+Dvsat*Dmob_Vgi_bi_Vdi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vdi_bi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi_Vdi_bi)*Rdsi+((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi_Vdi_bi+((((((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi)))*Rdsi_Vgi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi_Vdi_bi));
  Dr_Vgi_bi_Vsi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(0.0*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))+U0_a_Vsi_bi*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))+U0_a*(+Dvsat_Vgi_bi_Vsi_bi*Dmob+Dvsat_Vgi_bi*Dmob_Vsi_bi+Dvsat_Vsi_bi*Dmob_Vgi_bi+Dvsat*Dmob_Vgi_bi_Vsi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vsi_bi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi_Vsi_bi)*Rdsi+((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi_Vsi_bi+((((((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi)))*Rdsi_Vgi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi_Vsi_bi));
  Dr_Vgi_bi_Vgi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(0.0*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))+0.0*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))+U0_a*(+Dvsat_Vgi_bi_Vgi_bi*Dmob+Dvsat_Vgi_bi*Dmob_Vgi_bi+Dvsat_Vgi_bi*Dmob_Vgi_bi+Dvsat*Dmob_Vgi_bi_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+(((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vgi_bi+((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi_Vgi_bi)*Rdsi+((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi_Vgi_bi+(((((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi)))*Rdsi_Vgi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi_Vgi_bi));
#endif
#endif
Dr=(1.0+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi));
EXIT_IF_ISNAN((1.0+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi)))
if
((pModel->RDSMOD==2))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Rdsi_Tempt_GND=((rdstemp_Tempt_GND*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo))+(rdstemp*(RDSW_i*T3_Tempt_GND)*WeffWRFactor*pInst->NF));
#endif
Rdsi_Vgi_bi=(rdstemp*(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF);
#if defined(_DERIVATE2)
  Rdsi_Vgi_bi_Tempt_GND=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*pInst->NF)+rdstemp_Tempt_GND*(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Tempt_GND))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
  Rdsi_Vgi_bi_Vgi_bi=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*pInst->NF)+0.0*(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vgi_bi))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Vgi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
  Rdsi_Vgi_bi_Vdi_bi=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*pInst->NF)+0.0*(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vdi_bi))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Vdi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
  Rdsi_Vgi_bi_Vsi_bi=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*pInst->NF)+0.0*(RDSW_i*T3_Vgi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+RDSW_i*T3_Vgi_bi_Vsi_bi))*WeffWRFactor+(RDSW_i*T3_Vgi_bi)*0.0+((RDSW_i*T3_Vsi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vgi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
#endif
Rdsi_Vdi_bi=(rdstemp*(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF);
#if defined(_DERIVATE2)
  Rdsi_Vdi_bi_Tempt_GND=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*pInst->NF)+rdstemp_Tempt_GND*(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Tempt_GND))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
  Rdsi_Vdi_bi_Vgi_bi=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*pInst->NF)+0.0*(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vgi_bi))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Vgi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
  Rdsi_Vdi_bi_Vdi_bi=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*pInst->NF)+0.0*(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vdi_bi))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Vdi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
  Rdsi_Vdi_bi_Vsi_bi=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*pInst->NF)+0.0*(RDSW_i*T3_Vdi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+RDSW_i*T3_Vdi_bi_Vsi_bi))*WeffWRFactor+(RDSW_i*T3_Vdi_bi)*0.0+((RDSW_i*T3_Vsi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vdi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
#endif
Rdsi_Vsi_bi=(rdstemp*(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF);
#if defined(_DERIVATE2)
  Rdsi_Vsi_bi_Tempt_GND=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*pInst->NF)+rdstemp_Tempt_GND*(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Tempt_GND))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
  Rdsi_Vsi_bi_Vgi_bi=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*pInst->NF)+0.0*(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vgi_bi))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Vgi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vgi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
  Rdsi_Vsi_bi_Vdi_bi=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*pInst->NF)+0.0*(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vdi_bi))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Vdi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vdi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
  Rdsi_Vsi_bi_Vsi_bi=(+0.0*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)+0.0*((((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*pInst->NF)+0.0*(RDSW_i*T3_Vsi_bi)*WeffWRFactor*pInst->NF+rdstemp*(+(+0.0+(+(+(+0.0+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+RDSW_i*T3_Vsi_bi_Vsi_bi))*WeffWRFactor+(RDSW_i*T3_Vsi_bi)*0.0+((RDSW_i*T3_Vsi_bi))*0.0+(RDSWMIN_i+(RDSW_i*T3))*0.0)*pInst->NF+(RDSW_i*T3_Vsi_bi)*WeffWRFactor*0.0+(((RDSW_i*T3_Vsi_bi))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*0.0))+0.0));
#endif
#endif
Rdsi=(rdstemp*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo));
EXIT_IF_ISNAN((rdstemp*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*pInst->NF))+RDrainGeo)))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Rdrain_Tempt_GND=0.0;
Rdrain_Vgi_bi=0.0;
Rdrain_Vdi_bi=0.0;
Rdrain_Vsi_bi=0.0;
#endif
Rdrain=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Rsource_Tempt_GND=0.0;
Rsource_Vgi_bi=0.0;
Rsource_Vdi_bi=0.0;
Rsource_Vsi_bi=0.0;
#endif
Rsource=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
Dr_Tempt_GND=(((((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Tempt_GND))*Rdsi)+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Tempt_GND));
#endif
Dr_Vdi_bi=(((((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi)+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi));
#if defined(_DERIVATE2)
  Dr_Vdi_bi_Tempt_GND=(+0.0+(+(+((+(+(U0_a_Vdi_bi_Tempt_GND/(Dvsat*Dmob)-(U0_a_Vdi_bi*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))+U0_a_Tempt_GND*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))+U0_a*(+Dvsat_Vdi_bi_Tempt_GND*Dmob+Dvsat_Vdi_bi*Dmob_Tempt_GND+Dvsat_Tempt_GND*Dmob_Vdi_bi+Dvsat*Dmob_Vdi_bi_Tempt_GND))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Tempt_GND+(((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi_Tempt_GND)*Rdsi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi_Tempt_GND+((((((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Tempt_GND)))*Rdsi_Vdi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi_Tempt_GND));
  Dr_Vdi_bi_Vdi_bi=(+0.0+(+(+((+(+(U0_a_Vdi_bi_Vdi_bi/(Dvsat*Dmob)-(U0_a_Vdi_bi*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))+U0_a_Vdi_bi*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))+U0_a*(+Dvsat_Vdi_bi_Vdi_bi*Dmob+Dvsat_Vdi_bi*Dmob_Vdi_bi+Dvsat_Vdi_bi*Dmob_Vdi_bi+Dvsat*Dmob_Vdi_bi_Vdi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vdi_bi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi_Vdi_bi)*Rdsi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi_Vdi_bi+((((((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi)))*Rdsi_Vdi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi_Vdi_bi));
  Dr_Vdi_bi_Vsi_bi=(+0.0+(+(+((+(+(U0_a_Vdi_bi_Vsi_bi/(Dvsat*Dmob)-(U0_a_Vdi_bi*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))+U0_a_Vsi_bi*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))+U0_a*(+Dvsat_Vdi_bi_Vsi_bi*Dmob+Dvsat_Vdi_bi*Dmob_Vsi_bi+Dvsat_Vsi_bi*Dmob_Vdi_bi+Dvsat*Dmob_Vdi_bi_Vsi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vsi_bi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi_Vsi_bi)*Rdsi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi_Vsi_bi+((((((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi)))*Rdsi_Vdi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi_Vsi_bi));
  Dr_Vdi_bi_Vgi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(U0_a_Vdi_bi*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))+0.0*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))+U0_a*(+Dvsat_Vdi_bi_Vgi_bi*Dmob+Dvsat_Vdi_bi*Dmob_Vgi_bi+Dvsat_Vgi_bi*Dmob_Vdi_bi+Dvsat*Dmob_Vdi_bi_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+(((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vgi_bi+((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi_Vgi_bi)*Rdsi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi))*Rdsi_Vgi_bi+(((((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi)))*Rdsi_Vdi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vdi_bi_Vgi_bi));
#endif
Dr_Vsi_bi=(((((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi)+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi));
#if defined(_DERIVATE2)
  Dr_Vsi_bi_Tempt_GND=(+0.0+(+(+((+(+(U0_a_Vsi_bi_Tempt_GND/(Dvsat*Dmob)-(U0_a_Vsi_bi*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))+U0_a_Tempt_GND*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))+U0_a*(+Dvsat_Vsi_bi_Tempt_GND*Dmob+Dvsat_Vsi_bi*Dmob_Tempt_GND+Dvsat_Tempt_GND*Dmob_Vsi_bi+Dvsat*Dmob_Vsi_bi_Tempt_GND))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Tempt_GND+(((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi_Tempt_GND)*Rdsi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi_Tempt_GND+((((((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Tempt_GND)))*Rdsi_Vsi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi_Tempt_GND));
  Dr_Vsi_bi_Vdi_bi=(+0.0+(+(+((+(+(U0_a_Vsi_bi_Vdi_bi/(Dvsat*Dmob)-(U0_a_Vsi_bi*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))+U0_a_Vdi_bi*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))+U0_a*(+Dvsat_Vsi_bi_Vdi_bi*Dmob+Dvsat_Vsi_bi*Dmob_Vdi_bi+Dvsat_Vdi_bi*Dmob_Vsi_bi+Dvsat*Dmob_Vsi_bi_Vdi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vdi_bi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi_Vdi_bi)*Rdsi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi_Vdi_bi+((((((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi)))*Rdsi_Vsi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi_Vdi_bi));
  Dr_Vsi_bi_Vsi_bi=(+0.0+(+(+((+(+(U0_a_Vsi_bi_Vsi_bi/(Dvsat*Dmob)-(U0_a_Vsi_bi*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))+U0_a_Vsi_bi*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))+U0_a*(+Dvsat_Vsi_bi_Vsi_bi*Dmob+Dvsat_Vsi_bi*Dmob_Vsi_bi+Dvsat_Vsi_bi*Dmob_Vsi_bi+Dvsat*Dmob_Vsi_bi_Vsi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vsi_bi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi_Vsi_bi)*Rdsi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi_Vsi_bi+((((((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi)))*Rdsi_Vsi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi_Vsi_bi));
  Dr_Vsi_bi_Vgi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(U0_a_Vsi_bi*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))+0.0*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))+U0_a*(+Dvsat_Vsi_bi_Vgi_bi*Dmob+Dvsat_Vsi_bi*Dmob_Vgi_bi+Dvsat_Vgi_bi*Dmob_Vsi_bi+Dvsat*Dmob_Vsi_bi_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+(((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vgi_bi+((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi_Vgi_bi)*Rdsi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi))*Rdsi_Vgi_bi+(((((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi)))*Rdsi_Vsi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vsi_bi_Vgi_bi));
#endif
Dr_Vgi_bi=((((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi)+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi));
#if defined(_DERIVATE2)
  Dr_Vgi_bi_Tempt_GND=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(0.0*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))+U0_a_Tempt_GND*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))+U0_a*(+Dvsat_Vgi_bi_Tempt_GND*Dmob+Dvsat_Vgi_bi*Dmob_Tempt_GND+Dvsat_Tempt_GND*Dmob_Vgi_bi+Dvsat*Dmob_Vgi_bi_Tempt_GND))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Tempt_GND+(((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi_Tempt_GND)*Rdsi+((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi_Tempt_GND+((((((((U0_a_Tempt_GND*(Dvsat*Dmob)-U0_a*(((Dvsat_Tempt_GND*Dmob)+(Dvsat*Dmob_Tempt_GND))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Tempt_GND)))*Rdsi_Vgi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi_Tempt_GND));
  Dr_Vgi_bi_Vdi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(0.0*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))+U0_a_Vdi_bi*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))+U0_a*(+Dvsat_Vgi_bi_Vdi_bi*Dmob+Dvsat_Vgi_bi*Dmob_Vdi_bi+Dvsat_Vdi_bi*Dmob_Vgi_bi+Dvsat*Dmob_Vgi_bi_Vdi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vdi_bi+(((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi_Vdi_bi)*Rdsi+((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi_Vdi_bi+((((((((U0_a_Vdi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vdi_bi*Dmob)+(Dvsat*Dmob_Vdi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vdi_bi)))*Rdsi_Vgi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi_Vdi_bi));
  Dr_Vgi_bi_Vsi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(0.0*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))+U0_a_Vsi_bi*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))+U0_a*(+Dvsat_Vgi_bi_Vsi_bi*Dmob+Dvsat_Vgi_bi*Dmob_Vsi_bi+Dvsat_Vsi_bi*Dmob_Vgi_bi+Dvsat*Dmob_Vgi_bi_Vsi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+(((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vsi_bi+(((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi_Vsi_bi)*Rdsi+((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi_Vsi_bi+((((((((U0_a_Vsi_bi*(Dvsat*Dmob)-U0_a*(((Dvsat_Vsi_bi*Dmob)+(Dvsat*Dmob_Vsi_bi))))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vsi_bi)))*Rdsi_Vgi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi_Vsi_bi));
  Dr_Vgi_bi_Vgi_bi=(+0.0+(+(+((+(+(0.0/(Dvsat*Dmob)-(0.0*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))+0.0*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))+U0_a*(+Dvsat_Vgi_bi_Vgi_bi*Dmob+Dvsat_Vgi_bi*Dmob_Vgi_bi+Dvsat_Vgi_bi*Dmob_Vgi_bi+Dvsat*Dmob_Vgi_bi_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob)+2*U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*0.0+(U0_a/(Dvsat*Dmob))*0.0)*Weff+(-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*0.0+((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*0.0+((U0_a/(Dvsat*Dmob))*Cox)*0.0)/Leff-((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff*0.0+(((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)*0.0+(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0)/Leff/Leff+2*(((U0_a/(Dvsat*Dmob))*Cox)*Weff)*0.0*0.0/Leff/Leff/Leff)*qia+((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia_Vgi_bi+((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi+((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi_Vgi_bi)*Rdsi+((((-U0_a*((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi))*Rdsi_Vgi_bi+(((((((-U0_a*(((Dvsat_Vgi_bi*Dmob)+(Dvsat*Dmob_Vgi_bi)))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia_Vgi_bi)))*Rdsi_Vgi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi_Vgi_bi_Vgi_bi));
#endif
#endif
Dr=(1.0+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi));
EXIT_IF_ISNAN((1.0+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(-A2_t*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm)));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*((0.0)*Vtm)+0.0*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)+A2_t*(+0.0+(+(+0.0*n+0.0*0.0+0.0*n_Vgi_bi+2.0*0.0)*Vtm+(2.0*n_Vgi_bi)*0.0+(0.0)*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)*((0.0)*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vgi_bi_Vgm_si=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(((2.0*n_Vgm_si))*Vtm)+0.0*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)+A2_t*(+0.0+(+(+0.0*n+0.0*n_Vgm_si+0.0*n_Vgi_bi+2.0*n_Vgi_bi_Vgm_si)*Vtm+(2.0*n_Vgi_bi)*0.0+((2.0*n_Vgm_si))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)*(((2.0*n_Vgm_si))*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vgi_bi_Vdbulk_di=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vdbulk_di+(((2.0*n_Vdbulk_di))*Vtm))+0.0*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)+A2_t*(+qia_Vgi_bi_Vdbulk_di+(+(+0.0*n+0.0*n_Vdbulk_di+0.0*n_Vgi_bi+2.0*n_Vgi_bi_Vdbulk_di)*Vtm+(2.0*n_Vgi_bi)*0.0+((2.0*n_Vdbulk_di))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)*(qia_Vdbulk_di+(((2.0*n_Vdbulk_di))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vgi_bi_Vsbulk_si=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vsbulk_si+(((2.0*n_Vsbulk_si))*Vtm))+0.0*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)+A2_t*(+qia_Vgi_bi_Vsbulk_si+(+(+0.0*n+0.0*n_Vsbulk_si+0.0*n_Vgi_bi+2.0*n_Vgi_bi_Vsbulk_si)*Vtm+(2.0*n_Vgi_bi)*0.0+((2.0*n_Vsbulk_si))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)*(qia_Vsbulk_si+(((2.0*n_Vsbulk_si))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vgi_bi_Vgi_bi=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vgi_bi+(((2.0*n_Vgi_bi))*Vtm))+0.0*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)+A2_t*(+qia_Vgi_bi_Vgi_bi+(+(+0.0*n+0.0*n_Vgi_bi+0.0*n_Vgi_bi+2.0*n_Vgi_bi_Vgi_bi)*Vtm+(2.0*n_Vgi_bi)*0.0+((2.0*n_Vgi_bi))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)*(qia_Vgi_bi+(((2.0*n_Vgi_bi))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vgi_bi_Vdi_bi=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vdi_bi+(((2.0*n_Vdi_bi))*Vtm))+0.0*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)+A2_t*(+qia_Vgi_bi_Vdi_bi+(+(+0.0*n+0.0*n_Vdi_bi+0.0*n_Vgi_bi+2.0*n_Vgi_bi_Vdi_bi)*Vtm+(2.0*n_Vgi_bi)*0.0+((2.0*n_Vdi_bi))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)*(qia_Vdi_bi+(((2.0*n_Vdi_bi))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vgi_bi_Vsi_bi=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vsi_bi+(((2.0*n_Vsi_bi))*Vtm))+0.0*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)+A2_t*(+qia_Vgi_bi_Vsi_bi+(+(+0.0*n+0.0*n_Vsi_bi+0.0*n_Vgi_bi+2.0*n_Vgi_bi_Vsi_bi)*Vtm+(2.0*n_Vgi_bi)*0.0+((2.0*n_Vsi_bi))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)*(qia_Vsi_bi+(((2.0*n_Vsi_bi))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vgi_bi_Tempt_GND=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Tempt_GND+(((((2.0*n_Tempt_GND))*Vtm)+((2.0*n)*Vtm_Tempt_GND))))+A2_t_Tempt_GND*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)+A2_t*(+qia_Vgi_bi_Tempt_GND+(+(+0.0*n+0.0*n_Tempt_GND+0.0*n_Vgi_bi+2.0*n_Vgi_bi_Tempt_GND)*Vtm+(2.0*n_Vgi_bi)*Vtm_Tempt_GND+((2.0*n_Tempt_GND))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vgi_bi+(2.0*n_Vgi_bi)*Vtm)*(qia_Tempt_GND+(((((2.0*n_Tempt_GND))*Vtm)+((2.0*n)*Vtm_Tempt_GND))))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
#endif
T0_Vdi_bi=(-A2_t*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm)));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*((0.0)*Vtm)+0.0*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)+A2_t*(+0.0+(+(+0.0*n+0.0*0.0+0.0*n_Vdi_bi+2.0*0.0)*Vtm+(2.0*n_Vdi_bi)*0.0+(0.0)*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)*((0.0)*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vdi_bi_Vgm_si=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(((2.0*n_Vgm_si))*Vtm)+0.0*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)+A2_t*(+0.0+(+(+0.0*n+0.0*n_Vgm_si+0.0*n_Vdi_bi+2.0*n_Vdi_bi_Vgm_si)*Vtm+(2.0*n_Vdi_bi)*0.0+((2.0*n_Vgm_si))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)*(((2.0*n_Vgm_si))*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vdi_bi_Vdbulk_di=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vdbulk_di+(((2.0*n_Vdbulk_di))*Vtm))+0.0*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)+A2_t*(+qia_Vdi_bi_Vdbulk_di+(+(+0.0*n+0.0*n_Vdbulk_di+0.0*n_Vdi_bi+2.0*n_Vdi_bi_Vdbulk_di)*Vtm+(2.0*n_Vdi_bi)*0.0+((2.0*n_Vdbulk_di))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)*(qia_Vdbulk_di+(((2.0*n_Vdbulk_di))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vdi_bi_Vsbulk_si=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vsbulk_si+(((2.0*n_Vsbulk_si))*Vtm))+0.0*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)+A2_t*(+qia_Vdi_bi_Vsbulk_si+(+(+0.0*n+0.0*n_Vsbulk_si+0.0*n_Vdi_bi+2.0*n_Vdi_bi_Vsbulk_si)*Vtm+(2.0*n_Vdi_bi)*0.0+((2.0*n_Vsbulk_si))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)*(qia_Vsbulk_si+(((2.0*n_Vsbulk_si))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vdi_bi_Vgi_bi=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vgi_bi+(((2.0*n_Vgi_bi))*Vtm))+0.0*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)+A2_t*(+qia_Vdi_bi_Vgi_bi+(+(+0.0*n+0.0*n_Vgi_bi+0.0*n_Vdi_bi+2.0*n_Vdi_bi_Vgi_bi)*Vtm+(2.0*n_Vdi_bi)*0.0+((2.0*n_Vgi_bi))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)*(qia_Vgi_bi+(((2.0*n_Vgi_bi))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vdi_bi_Vdi_bi=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vdi_bi+(((2.0*n_Vdi_bi))*Vtm))+0.0*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)+A2_t*(+qia_Vdi_bi_Vdi_bi+(+(+0.0*n+0.0*n_Vdi_bi+0.0*n_Vdi_bi+2.0*n_Vdi_bi_Vdi_bi)*Vtm+(2.0*n_Vdi_bi)*0.0+((2.0*n_Vdi_bi))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)*(qia_Vdi_bi+(((2.0*n_Vdi_bi))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vdi_bi_Vsi_bi=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vsi_bi+(((2.0*n_Vsi_bi))*Vtm))+0.0*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)+A2_t*(+qia_Vdi_bi_Vsi_bi+(+(+0.0*n+0.0*n_Vsi_bi+0.0*n_Vdi_bi+2.0*n_Vdi_bi_Vsi_bi)*Vtm+(2.0*n_Vdi_bi)*0.0+((2.0*n_Vsi_bi))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)*(qia_Vsi_bi+(((2.0*n_Vsi_bi))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vdi_bi_Tempt_GND=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Tempt_GND+(((((2.0*n_Tempt_GND))*Vtm)+((2.0*n)*Vtm_Tempt_GND))))+A2_t_Tempt_GND*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)+A2_t*(+qia_Vdi_bi_Tempt_GND+(+(+0.0*n+0.0*n_Tempt_GND+0.0*n_Vdi_bi+2.0*n_Vdi_bi_Tempt_GND)*Vtm+(2.0*n_Vdi_bi)*Vtm_Tempt_GND+((2.0*n_Tempt_GND))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vdi_bi+(2.0*n_Vdi_bi)*Vtm)*(qia_Tempt_GND+(((((2.0*n_Tempt_GND))*Vtm)+((2.0*n)*Vtm_Tempt_GND))))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
#endif
T0_Vsi_bi=(-A2_t*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm)));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*((0.0)*Vtm)+0.0*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)+A2_t*(+0.0+(+(+0.0*n+0.0*0.0+0.0*n_Vsi_bi+2.0*0.0)*Vtm+(2.0*n_Vsi_bi)*0.0+(0.0)*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)*((0.0)*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vsi_bi_Vgm_si=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(((2.0*n_Vgm_si))*Vtm)+0.0*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)+A2_t*(+0.0+(+(+0.0*n+0.0*n_Vgm_si+0.0*n_Vsi_bi+2.0*n_Vsi_bi_Vgm_si)*Vtm+(2.0*n_Vsi_bi)*0.0+((2.0*n_Vgm_si))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)*(((2.0*n_Vgm_si))*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vsi_bi_Vdbulk_di=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vdbulk_di+(((2.0*n_Vdbulk_di))*Vtm))+0.0*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)+A2_t*(+qia_Vsi_bi_Vdbulk_di+(+(+0.0*n+0.0*n_Vdbulk_di+0.0*n_Vsi_bi+2.0*n_Vsi_bi_Vdbulk_di)*Vtm+(2.0*n_Vsi_bi)*0.0+((2.0*n_Vdbulk_di))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)*(qia_Vdbulk_di+(((2.0*n_Vdbulk_di))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vsi_bi_Vsbulk_si=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vsbulk_si+(((2.0*n_Vsbulk_si))*Vtm))+0.0*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)+A2_t*(+qia_Vsi_bi_Vsbulk_si+(+(+0.0*n+0.0*n_Vsbulk_si+0.0*n_Vsi_bi+2.0*n_Vsi_bi_Vsbulk_si)*Vtm+(2.0*n_Vsi_bi)*0.0+((2.0*n_Vsbulk_si))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)*(qia_Vsbulk_si+(((2.0*n_Vsbulk_si))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vsi_bi_Vgi_bi=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vgi_bi+(((2.0*n_Vgi_bi))*Vtm))+0.0*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)+A2_t*(+qia_Vsi_bi_Vgi_bi+(+(+0.0*n+0.0*n_Vgi_bi+0.0*n_Vsi_bi+2.0*n_Vsi_bi_Vgi_bi)*Vtm+(2.0*n_Vsi_bi)*0.0+((2.0*n_Vgi_bi))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)*(qia_Vgi_bi+(((2.0*n_Vgi_bi))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vsi_bi_Vdi_bi=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vdi_bi+(((2.0*n_Vdi_bi))*Vtm))+0.0*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)+A2_t*(+qia_Vsi_bi_Vdi_bi+(+(+0.0*n+0.0*n_Vdi_bi+0.0*n_Vsi_bi+2.0*n_Vsi_bi_Vdi_bi)*Vtm+(2.0*n_Vsi_bi)*0.0+((2.0*n_Vdi_bi))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)*(qia_Vdi_bi+(((2.0*n_Vdi_bi))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vsi_bi_Vsi_bi=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Vsi_bi+(((2.0*n_Vsi_bi))*Vtm))+0.0*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)+A2_t*(+qia_Vsi_bi_Vsi_bi+(+(+0.0*n+0.0*n_Vsi_bi+0.0*n_Vsi_bi+2.0*n_Vsi_bi_Vsi_bi)*Vtm+(2.0*n_Vsi_bi)*0.0+((2.0*n_Vsi_bi))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)*(qia_Vsi_bi+(((2.0*n_Vsi_bi))*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
  T0_Vsi_bi_Tempt_GND=(+0.0+(0.0/(qia+((2.0*n)*Vtm))-(0.0*(qia_Tempt_GND+(((((2.0*n_Tempt_GND))*Vtm)+((2.0*n)*Vtm_Tempt_GND))))+A2_t_Tempt_GND*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)+A2_t*(+qia_Vsi_bi_Tempt_GND+(+(+0.0*n+0.0*n_Tempt_GND+0.0*n_Vsi_bi+2.0*n_Vsi_bi_Tempt_GND)*Vtm+(2.0*n_Vsi_bi)*Vtm_Tempt_GND+((2.0*n_Tempt_GND))*0.0+(2.0*n)*0.0)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))+2*A2_t*(qia_Vsi_bi+(2.0*n_Vsi_bi)*Vtm)*(qia_Tempt_GND+(((((2.0*n_Tempt_GND))*Vtm)+((2.0*n)*Vtm_Tempt_GND))))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(A1_t_Tempt_GND+((A2_t_Tempt_GND*(qia+((2.0*n)*Vtm))-A2_t*(qia_Tempt_GND+(((2.0*n_Tempt_GND)*Vtm)+((2.0*n)*Vtm_Tempt_GND))))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
#endif
#endif
T0=(A1_t+(A2_t/(qia+((2.0*n)*Vtm))));
EXIT_IF_ISNAN((A1_t+(A2_t/(qia+((2.0*n)*Vtm)))))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
DQSD_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  DQSD_Vdbulk_di_Vdbulk_di=0.0;
  DQSD_Vdbulk_di_Vsbulk_si=0.0;
  DQSD_Vdbulk_di_Vgi_bi=0.0;
  DQSD_Vdbulk_di_Vdi_bi=0.0;
  DQSD_Vdbulk_di_Vsi_bi=0.0;
  DQSD_Vdbulk_di_Tempt_GND=0.0;
#endif
DQSD_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  DQSD_Vsbulk_si_Vdbulk_di=0.0;
  DQSD_Vsbulk_si_Vsbulk_si=0.0;
  DQSD_Vsbulk_si_Vgi_bi=0.0;
  DQSD_Vsbulk_si_Vdi_bi=0.0;
  DQSD_Vsbulk_si_Vsi_bi=0.0;
  DQSD_Vsbulk_si_Tempt_GND=0.0;
#endif
DQSD_Vgi_bi=(qs_Vgi_bi-qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  DQSD_Vgi_bi_Vdbulk_di=(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di);
  DQSD_Vgi_bi_Vsbulk_si=(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si);
  DQSD_Vgi_bi_Vgi_bi=(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi);
  DQSD_Vgi_bi_Vdi_bi=(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi);
  DQSD_Vgi_bi_Vsi_bi=(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi);
  DQSD_Vgi_bi_Tempt_GND=(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND);
#endif
DQSD_Vdi_bi=(qs_Vdi_bi-qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  DQSD_Vdi_bi_Vdbulk_di=(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di);
  DQSD_Vdi_bi_Vsbulk_si=(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si);
  DQSD_Vdi_bi_Vgi_bi=(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi);
  DQSD_Vdi_bi_Vdi_bi=(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi);
  DQSD_Vdi_bi_Vsi_bi=(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi);
  DQSD_Vdi_bi_Tempt_GND=(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND);
#endif
DQSD_Vsi_bi=(qs_Vsi_bi-qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  DQSD_Vsi_bi_Vdbulk_di=(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di);
  DQSD_Vsi_bi_Vsbulk_si=(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si);
  DQSD_Vsi_bi_Vgi_bi=(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi);
  DQSD_Vsi_bi_Vdi_bi=(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi);
  DQSD_Vsi_bi_Vsi_bi=(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi);
  DQSD_Vsi_bi_Tempt_GND=(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
DQSD_Tempt_GND=(qs_Tempt_GND-qdeff_Tempt_GND);
#endif
#endif
DQSD=(qs-qdeff);
EXIT_IF_ISNAN((qs-qdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=((((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi))*DQSD)+((T0*DQSD)*DQSD_Vgi_bi));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*DQSD+T0_Vgi_bi*0.0+T0_Vgm_di*DQSD_Vgi_bi+T0*0.0)*DQSD+((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi))*0.0+(T0_Vgm_di*DQSD)*DQSD_Vgi_bi+(T0*DQSD)*0.0);
  T1_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*DQSD+T0_Vgi_bi*0.0+T0_Vgm_si*DQSD_Vgi_bi+T0*0.0)*DQSD+((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi))*0.0+(T0_Vgm_si*DQSD)*DQSD_Vgi_bi+(T0*DQSD)*0.0);
  T1_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*DQSD+T0_Vgi_bi*DQSD_Vdbulk_di+T0_Vdbulk_di*DQSD_Vgi_bi+T0*DQSD_Vgi_bi_Vdbulk_di)*DQSD+((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi))*DQSD_Vdbulk_di+(((T0_Vdbulk_di*DQSD)+(T0*DQSD_Vdbulk_di)))*DQSD_Vgi_bi+(T0*DQSD)*DQSD_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*DQSD+T0_Vgi_bi*DQSD_Vsbulk_si+T0_Vsbulk_si*DQSD_Vgi_bi+T0*DQSD_Vgi_bi_Vsbulk_si)*DQSD+((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi))*DQSD_Vsbulk_si+(((T0_Vsbulk_si*DQSD)+(T0*DQSD_Vsbulk_si)))*DQSD_Vgi_bi+(T0*DQSD)*DQSD_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*DQSD+T0_Vgi_bi*DQSD_Vgi_bi+T0_Vgi_bi*DQSD_Vgi_bi+T0*DQSD_Vgi_bi_Vgi_bi)*DQSD+((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi))*DQSD_Vgi_bi+(((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi)))*DQSD_Vgi_bi+(T0*DQSD)*DQSD_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*DQSD+T0_Vgi_bi*DQSD_Vdi_bi+T0_Vdi_bi*DQSD_Vgi_bi+T0*DQSD_Vgi_bi_Vdi_bi)*DQSD+((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi))*DQSD_Vdi_bi+(((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi)))*DQSD_Vgi_bi+(T0*DQSD)*DQSD_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*DQSD+T0_Vgi_bi*DQSD_Vsi_bi+T0_Vsi_bi*DQSD_Vgi_bi+T0*DQSD_Vgi_bi_Vsi_bi)*DQSD+((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi))*DQSD_Vsi_bi+(((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi)))*DQSD_Vgi_bi+(T0*DQSD)*DQSD_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*DQSD+T0_Vgi_bi*DQSD_Tempt_GND+T0_Tempt_GND*DQSD_Vgi_bi+T0*DQSD_Vgi_bi_Tempt_GND)*DQSD+((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi))*DQSD_Tempt_GND+(((T0_Tempt_GND*DQSD)+(T0*DQSD_Tempt_GND)))*DQSD_Vgi_bi+(T0*DQSD)*DQSD_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=((((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi))*DQSD)+((T0*DQSD)*DQSD_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*DQSD+T0_Vdi_bi*0.0+T0_Vgm_di*DQSD_Vdi_bi+T0*0.0)*DQSD+((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi))*0.0+(T0_Vgm_di*DQSD)*DQSD_Vdi_bi+(T0*DQSD)*0.0);
  T1_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*DQSD+T0_Vdi_bi*0.0+T0_Vgm_si*DQSD_Vdi_bi+T0*0.0)*DQSD+((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi))*0.0+(T0_Vgm_si*DQSD)*DQSD_Vdi_bi+(T0*DQSD)*0.0);
  T1_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*DQSD+T0_Vdi_bi*DQSD_Vdbulk_di+T0_Vdbulk_di*DQSD_Vdi_bi+T0*DQSD_Vdi_bi_Vdbulk_di)*DQSD+((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi))*DQSD_Vdbulk_di+(((T0_Vdbulk_di*DQSD)+(T0*DQSD_Vdbulk_di)))*DQSD_Vdi_bi+(T0*DQSD)*DQSD_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*DQSD+T0_Vdi_bi*DQSD_Vsbulk_si+T0_Vsbulk_si*DQSD_Vdi_bi+T0*DQSD_Vdi_bi_Vsbulk_si)*DQSD+((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi))*DQSD_Vsbulk_si+(((T0_Vsbulk_si*DQSD)+(T0*DQSD_Vsbulk_si)))*DQSD_Vdi_bi+(T0*DQSD)*DQSD_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*DQSD+T0_Vdi_bi*DQSD_Vgi_bi+T0_Vgi_bi*DQSD_Vdi_bi+T0*DQSD_Vdi_bi_Vgi_bi)*DQSD+((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi))*DQSD_Vgi_bi+(((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi)))*DQSD_Vdi_bi+(T0*DQSD)*DQSD_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*DQSD+T0_Vdi_bi*DQSD_Vdi_bi+T0_Vdi_bi*DQSD_Vdi_bi+T0*DQSD_Vdi_bi_Vdi_bi)*DQSD+((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi))*DQSD_Vdi_bi+(((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi)))*DQSD_Vdi_bi+(T0*DQSD)*DQSD_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*DQSD+T0_Vdi_bi*DQSD_Vsi_bi+T0_Vsi_bi*DQSD_Vdi_bi+T0*DQSD_Vdi_bi_Vsi_bi)*DQSD+((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi))*DQSD_Vsi_bi+(((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi)))*DQSD_Vdi_bi+(T0*DQSD)*DQSD_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*DQSD+T0_Vdi_bi*DQSD_Tempt_GND+T0_Tempt_GND*DQSD_Vdi_bi+T0*DQSD_Vdi_bi_Tempt_GND)*DQSD+((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi))*DQSD_Tempt_GND+(((T0_Tempt_GND*DQSD)+(T0*DQSD_Tempt_GND)))*DQSD_Vdi_bi+(T0*DQSD)*DQSD_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=((((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi))*DQSD)+((T0*DQSD)*DQSD_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*DQSD+T0_Vsi_bi*0.0+T0_Vgm_di*DQSD_Vsi_bi+T0*0.0)*DQSD+((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi))*0.0+(T0_Vgm_di*DQSD)*DQSD_Vsi_bi+(T0*DQSD)*0.0);
  T1_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*DQSD+T0_Vsi_bi*0.0+T0_Vgm_si*DQSD_Vsi_bi+T0*0.0)*DQSD+((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi))*0.0+(T0_Vgm_si*DQSD)*DQSD_Vsi_bi+(T0*DQSD)*0.0);
  T1_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*DQSD+T0_Vsi_bi*DQSD_Vdbulk_di+T0_Vdbulk_di*DQSD_Vsi_bi+T0*DQSD_Vsi_bi_Vdbulk_di)*DQSD+((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi))*DQSD_Vdbulk_di+(((T0_Vdbulk_di*DQSD)+(T0*DQSD_Vdbulk_di)))*DQSD_Vsi_bi+(T0*DQSD)*DQSD_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*DQSD+T0_Vsi_bi*DQSD_Vsbulk_si+T0_Vsbulk_si*DQSD_Vsi_bi+T0*DQSD_Vsi_bi_Vsbulk_si)*DQSD+((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi))*DQSD_Vsbulk_si+(((T0_Vsbulk_si*DQSD)+(T0*DQSD_Vsbulk_si)))*DQSD_Vsi_bi+(T0*DQSD)*DQSD_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*DQSD+T0_Vsi_bi*DQSD_Vgi_bi+T0_Vgi_bi*DQSD_Vsi_bi+T0*DQSD_Vsi_bi_Vgi_bi)*DQSD+((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi))*DQSD_Vgi_bi+(((T0_Vgi_bi*DQSD)+(T0*DQSD_Vgi_bi)))*DQSD_Vsi_bi+(T0*DQSD)*DQSD_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*DQSD+T0_Vsi_bi*DQSD_Vdi_bi+T0_Vdi_bi*DQSD_Vsi_bi+T0*DQSD_Vsi_bi_Vdi_bi)*DQSD+((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi))*DQSD_Vdi_bi+(((T0_Vdi_bi*DQSD)+(T0*DQSD_Vdi_bi)))*DQSD_Vsi_bi+(T0*DQSD)*DQSD_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*DQSD+T0_Vsi_bi*DQSD_Vsi_bi+T0_Vsi_bi*DQSD_Vsi_bi+T0*DQSD_Vsi_bi_Vsi_bi)*DQSD+((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi))*DQSD_Vsi_bi+(((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi)))*DQSD_Vsi_bi+(T0*DQSD)*DQSD_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*DQSD+T0_Vsi_bi*DQSD_Tempt_GND+T0_Tempt_GND*DQSD_Vsi_bi+T0*DQSD_Vsi_bi_Tempt_GND)*DQSD+((T0_Vsi_bi*DQSD)+(T0*DQSD_Vsi_bi))*DQSD_Tempt_GND+(((T0_Tempt_GND*DQSD)+(T0*DQSD_Tempt_GND)))*DQSD_Vsi_bi+(T0*DQSD)*DQSD_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((((T0_Tempt_GND*DQSD)+(T0*DQSD_Tempt_GND))*DQSD)+((T0*DQSD)*DQSD_Tempt_GND));
#endif
#endif
T1=((T0*DQSD)*DQSD);
EXIT_IF_ISNAN(((T0*DQSD)*DQSD))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=T1_Vgi_bi;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(+T1_Vgi_bi_Vgm_di+0.0)-0.0);
  T2_Vgi_bi_Vgm_si=(+(+T1_Vgi_bi_Vgm_si+0.0)-0.0);
  T2_Vgi_bi_Vdbulk_di=(+(+T1_Vgi_bi_Vdbulk_di+0.0)-0.0);
  T2_Vgi_bi_Vsbulk_si=(+(+T1_Vgi_bi_Vsbulk_si+0.0)-0.0);
  T2_Vgi_bi_Vgi_bi=(+(+T1_Vgi_bi_Vgi_bi+0.0)-0.0);
  T2_Vgi_bi_Vdi_bi=(+(+T1_Vgi_bi_Vdi_bi+0.0)-0.0);
  T2_Vgi_bi_Vsi_bi=(+(+T1_Vgi_bi_Vsi_bi+0.0)-0.0);
  T2_Vgi_bi_Tempt_GND=(+(+T1_Vgi_bi_Tempt_GND+0.0)-0.0);
#endif
T2_Vdi_bi=T1_Vdi_bi;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(+T1_Vdi_bi_Vgm_di+0.0)-0.0);
  T2_Vdi_bi_Vgm_si=(+(+T1_Vdi_bi_Vgm_si+0.0)-0.0);
  T2_Vdi_bi_Vdbulk_di=(+(+T1_Vdi_bi_Vdbulk_di+0.0)-0.0);
  T2_Vdi_bi_Vsbulk_si=(+(+T1_Vdi_bi_Vsbulk_si+0.0)-0.0);
  T2_Vdi_bi_Vgi_bi=(+(+T1_Vdi_bi_Vgi_bi+0.0)-0.0);
  T2_Vdi_bi_Vdi_bi=(+(+T1_Vdi_bi_Vdi_bi+0.0)-0.0);
  T2_Vdi_bi_Vsi_bi=(+(+T1_Vdi_bi_Vsi_bi+0.0)-0.0);
  T2_Vdi_bi_Tempt_GND=(+(+T1_Vdi_bi_Tempt_GND+0.0)-0.0);
#endif
T2_Vsi_bi=T1_Vsi_bi;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(+T1_Vsi_bi_Vgm_di+0.0)-0.0);
  T2_Vsi_bi_Vgm_si=(+(+T1_Vsi_bi_Vgm_si+0.0)-0.0);
  T2_Vsi_bi_Vdbulk_di=(+(+T1_Vsi_bi_Vdbulk_di+0.0)-0.0);
  T2_Vsi_bi_Vsbulk_si=(+(+T1_Vsi_bi_Vsbulk_si+0.0)-0.0);
  T2_Vsi_bi_Vgi_bi=(+(+T1_Vsi_bi_Vgi_bi+0.0)-0.0);
  T2_Vsi_bi_Vdi_bi=(+(+T1_Vsi_bi_Vdi_bi+0.0)-0.0);
  T2_Vsi_bi_Vsi_bi=(+(+T1_Vsi_bi_Vsi_bi+0.0)-0.0);
  T2_Vsi_bi_Tempt_GND=(+(+T1_Vsi_bi_Tempt_GND+0.0)-0.0);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=T1_Tempt_GND;
#endif
#endif
T2=((T1+1.0)-0.001);
EXIT_IF_ISNAN(((T1+1.0)-0.001))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+0.004))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+0.004))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(0.5*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_si+(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vgm_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si)+0.0)))));
  T3_Vgi_bi_Vgm_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_di+(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vgm_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di)+0.0)))));
  T3_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdbulk_di+(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vdbulk_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di)+0.0)))));
  T3_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsbulk_si+(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vsbulk_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si)+0.0)))));
  T3_Vgi_bi_Vgi_bi=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgi_bi+(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vgi_bi+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0)))));
  T3_Vgi_bi_Vdi_bi=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_bi+(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vdi_bi+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0)))));
  T3_Vgi_bi_Vsi_bi=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_bi+(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Vsi_bi+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0)))));
  T3_Vgi_bi_Tempt_GND=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgi_bi+((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+T2_Vgi_bi_Tempt_GND+(m20_sqrt(((T2*T2)+0.004))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0)))));
#endif
T3_Vdi_bi=(0.5*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_si+(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vgm_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si)+0.0)))));
  T3_Vdi_bi_Vgm_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_di+(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vgm_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di)+0.0)))));
  T3_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdbulk_di+(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vdbulk_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di)+0.0)))));
  T3_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsbulk_si+(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vsbulk_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si)+0.0)))));
  T3_Vdi_bi_Vgi_bi=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgi_bi+(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vgi_bi+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0)))));
  T3_Vdi_bi_Vdi_bi=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_bi+(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vdi_bi+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0)))));
  T3_Vdi_bi_Vsi_bi=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_bi+(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Vsi_bi+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0)))));
  T3_Vdi_bi_Tempt_GND=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_bi+((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+T2_Vdi_bi_Tempt_GND+(m20_sqrt(((T2*T2)+0.004))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0)))));
#endif
T3_Vsi_bi=(0.5*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_si+(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vgm_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vgm_si*T2)+(T2*T2_Vgm_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si)+0.0)))));
  T3_Vsi_bi_Vgm_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgm_di+(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vgm_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vgm_di*T2)+(T2*T2_Vgm_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di)+0.0)))));
  T3_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdbulk_di+(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vdbulk_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di)+0.0)))));
  T3_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsbulk_si+(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vsbulk_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si)+0.0)))));
  T3_Vsi_bi_Vgi_bi=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vgi_bi+(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vgi_bi+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0)))));
  T3_Vsi_bi_Vdi_bi=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_bi+(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vdi_bi+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0)))));
  T3_Vsi_bi_Vsi_bi=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_bi+(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Vsi_bi+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0)))));
  T3_Vsi_bi_Tempt_GND=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsi_bi+((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+T2_Vsi_bi_Tempt_GND+(m20_sqrt(((T2*T2)+0.004))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0)))));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(0.5*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0));
#endif
#endif
T3=((-1.0)+(0.5*(T2+d00_sqrt0)));
EXIT_IF_ISNAN(((-1.0)+(0.5*(T2+d00_sqrt0))))
}
{
double m00_sqrt(d00_sqrt0,(1.0+T3))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+T3))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
Nsat_Vgi_bi=(0.5*T3_Vgi_bi*d10_sqrt0);
#if defined(_DERIVATE2)
  Nsat_Vgi_bi_Vgi_bi=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vgi_bi*d10_sqrt0+0.0*T3_Vgi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vgi_bi*T3_Vgi_bi+d10_sqrt0*(+0.0+T3_Vgi_bi_Vgi_bi))));
  Nsat_Vgi_bi_Vdi_bi=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vdi_bi*d10_sqrt0+0.0*T3_Vgi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vdi_bi*T3_Vgi_bi+d10_sqrt0*(+0.0+T3_Vgi_bi_Vdi_bi))));
  Nsat_Vgi_bi_Vsi_bi=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vsi_bi*d10_sqrt0+0.0*T3_Vgi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vsi_bi*T3_Vgi_bi+d10_sqrt0*(+0.0+T3_Vgi_bi_Vsi_bi))));
  Nsat_Vgi_bi_Tempt_GND=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Tempt_GND*d10_sqrt0+0.0*T3_Vgi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Tempt_GND*T3_Vgi_bi+d10_sqrt0*(+0.0+T3_Vgi_bi_Tempt_GND))));
#endif
Nsat_Vdi_bi=(0.5*T3_Vdi_bi*d10_sqrt0);
#if defined(_DERIVATE2)
  Nsat_Vdi_bi_Vgi_bi=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vgi_bi*d10_sqrt0+0.0*T3_Vdi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vgi_bi*T3_Vdi_bi+d10_sqrt0*(+0.0+T3_Vdi_bi_Vgi_bi))));
  Nsat_Vdi_bi_Vdi_bi=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vdi_bi*d10_sqrt0+0.0*T3_Vdi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vdi_bi*T3_Vdi_bi+d10_sqrt0*(+0.0+T3_Vdi_bi_Vdi_bi))));
  Nsat_Vdi_bi_Vsi_bi=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vsi_bi*d10_sqrt0+0.0*T3_Vdi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vsi_bi*T3_Vdi_bi+d10_sqrt0*(+0.0+T3_Vdi_bi_Vsi_bi))));
  Nsat_Vdi_bi_Tempt_GND=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Tempt_GND*d10_sqrt0+0.0*T3_Vdi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Tempt_GND*T3_Vdi_bi+d10_sqrt0*(+0.0+T3_Vdi_bi_Tempt_GND))));
#endif
Nsat_Vsi_bi=(0.5*T3_Vsi_bi*d10_sqrt0);
#if defined(_DERIVATE2)
  Nsat_Vsi_bi_Vgi_bi=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vgi_bi*d10_sqrt0+0.0*T3_Vsi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vgi_bi*T3_Vsi_bi+d10_sqrt0*(+0.0+T3_Vsi_bi_Vgi_bi))));
  Nsat_Vsi_bi_Vdi_bi=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vdi_bi*d10_sqrt0+0.0*T3_Vsi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vdi_bi*T3_Vsi_bi+d10_sqrt0*(+0.0+T3_Vsi_bi_Vdi_bi))));
  Nsat_Vsi_bi_Vsi_bi=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vsi_bi*d10_sqrt0+0.0*T3_Vsi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vsi_bi*T3_Vsi_bi+d10_sqrt0*(+0.0+T3_Vsi_bi_Vsi_bi))));
  Nsat_Vsi_bi_Tempt_GND=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Tempt_GND*d10_sqrt0+0.0*T3_Vsi_bi*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Tempt_GND*T3_Vsi_bi+d10_sqrt0*(+0.0+T3_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
Nsat_Tempt_GND=(0.5*T3_Tempt_GND*d10_sqrt0);
#endif
#endif
Nsat=(0.5*(1.0+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(1.0+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(qs_Vgi_bi+qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+qs_Vgi_bi_Vgm_di+qdeff_Vgi_bi_Vgm_di);
  T0_Vgi_bi_Vgm_si=(+qs_Vgi_bi_Vgm_si+qdeff_Vgi_bi_Vgm_si);
  T0_Vgi_bi_Vdbulk_di=(+qs_Vgi_bi_Vdbulk_di+qdeff_Vgi_bi_Vdbulk_di);
  T0_Vgi_bi_Vsbulk_si=(+qs_Vgi_bi_Vsbulk_si+qdeff_Vgi_bi_Vsbulk_si);
  T0_Vgi_bi_Vgi_bi=(+qs_Vgi_bi_Vgi_bi+qdeff_Vgi_bi_Vgi_bi);
  T0_Vgi_bi_Vdi_bi=(+qs_Vgi_bi_Vdi_bi+qdeff_Vgi_bi_Vdi_bi);
  T0_Vgi_bi_Vsi_bi=(+qs_Vgi_bi_Vsi_bi+qdeff_Vgi_bi_Vsi_bi);
  T0_Vgi_bi_Tempt_GND=(+qs_Vgi_bi_Tempt_GND+qdeff_Vgi_bi_Tempt_GND);
#endif
T0_Vdi_bi=(qs_Vdi_bi+qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+qs_Vdi_bi_Vgm_di+qdeff_Vdi_bi_Vgm_di);
  T0_Vdi_bi_Vgm_si=(+qs_Vdi_bi_Vgm_si+qdeff_Vdi_bi_Vgm_si);
  T0_Vdi_bi_Vdbulk_di=(+qs_Vdi_bi_Vdbulk_di+qdeff_Vdi_bi_Vdbulk_di);
  T0_Vdi_bi_Vsbulk_si=(+qs_Vdi_bi_Vsbulk_si+qdeff_Vdi_bi_Vsbulk_si);
  T0_Vdi_bi_Vgi_bi=(+qs_Vdi_bi_Vgi_bi+qdeff_Vdi_bi_Vgi_bi);
  T0_Vdi_bi_Vdi_bi=(+qs_Vdi_bi_Vdi_bi+qdeff_Vdi_bi_Vdi_bi);
  T0_Vdi_bi_Vsi_bi=(+qs_Vdi_bi_Vsi_bi+qdeff_Vdi_bi_Vsi_bi);
  T0_Vdi_bi_Tempt_GND=(+qs_Vdi_bi_Tempt_GND+qdeff_Vdi_bi_Tempt_GND);
#endif
T0_Vsi_bi=(qs_Vsi_bi+qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+qs_Vsi_bi_Vgm_di+qdeff_Vsi_bi_Vgm_di);
  T0_Vsi_bi_Vgm_si=(+qs_Vsi_bi_Vgm_si+qdeff_Vsi_bi_Vgm_si);
  T0_Vsi_bi_Vdbulk_di=(+qs_Vsi_bi_Vdbulk_di+qdeff_Vsi_bi_Vdbulk_di);
  T0_Vsi_bi_Vsbulk_si=(+qs_Vsi_bi_Vsbulk_si+qdeff_Vsi_bi_Vsbulk_si);
  T0_Vsi_bi_Vgi_bi=(+qs_Vsi_bi_Vgi_bi+qdeff_Vsi_bi_Vgi_bi);
  T0_Vsi_bi_Vdi_bi=(+qs_Vsi_bi_Vdi_bi+qdeff_Vsi_bi_Vdi_bi);
  T0_Vsi_bi_Vsi_bi=(+qs_Vsi_bi_Vsi_bi+qdeff_Vsi_bi_Vsi_bi);
  T0_Vsi_bi_Tempt_GND=(+qs_Vsi_bi_Tempt_GND+qdeff_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(qs_Tempt_GND+qdeff_Tempt_GND);
#endif
#endif
T0=(qs+qdeff);
EXIT_IF_ISNAN((qs+qdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(qs_Vgi_bi-qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+qs_Vgi_bi_Vgm_di-qdeff_Vgi_bi_Vgm_di);
  T1_Vgi_bi_Vgm_si=(+qs_Vgi_bi_Vgm_si-qdeff_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=(qs_Vdi_bi-qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+qs_Vdi_bi_Vgm_di-qdeff_Vdi_bi_Vgm_di);
  T1_Vdi_bi_Vgm_si=(+qs_Vdi_bi_Vgm_si-qdeff_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=(qs_Vsi_bi-qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+qs_Vsi_bi_Vgm_di-qdeff_Vsi_bi_Vgm_di);
  T1_Vsi_bi_Vgm_si=(+qs_Vsi_bi_Vgm_si-qdeff_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(qs_Tempt_GND-qdeff_Tempt_GND);
#endif
#endif
T1=(qs-qdeff);
EXIT_IF_ISNAN((qs-qdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=((T1_Vgi_bi*(T0+M0_t)-T1*T0_Vgi_bi)/(T0+M0_t)/(T0+M0_t));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(T1_Vgi_bi_Vgm_di/(T0+M0_t)-(T1_Vgi_bi*T0_Vgm_di+T1_Vgm_di*T0_Vgi_bi+T1*(+T0_Vgi_bi_Vgm_di+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vgi_bi*T0_Vgm_di/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vgi_bi_Vgm_si=(T1_Vgi_bi_Vgm_si/(T0+M0_t)-(T1_Vgi_bi*T0_Vgm_si+T1_Vgm_si*T0_Vgi_bi+T1*(+T0_Vgi_bi_Vgm_si+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vgi_bi*T0_Vgm_si/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vgi_bi_Vdbulk_di=(T1_Vgi_bi_Vdbulk_di/(T0+M0_t)-(T1_Vgi_bi*T0_Vdbulk_di+T1_Vdbulk_di*T0_Vgi_bi+T1*(+T0_Vgi_bi_Vdbulk_di+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vgi_bi*T0_Vdbulk_di/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vgi_bi_Vsbulk_si=(T1_Vgi_bi_Vsbulk_si/(T0+M0_t)-(T1_Vgi_bi*T0_Vsbulk_si+T1_Vsbulk_si*T0_Vgi_bi+T1*(+T0_Vgi_bi_Vsbulk_si+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vgi_bi*T0_Vsbulk_si/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vgi_bi_Vgi_bi=(T1_Vgi_bi_Vgi_bi/(T0+M0_t)-(T1_Vgi_bi*T0_Vgi_bi+T1_Vgi_bi*T0_Vgi_bi+T1*(+T0_Vgi_bi_Vgi_bi+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vgi_bi*T0_Vgi_bi/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vgi_bi_Vdi_bi=(T1_Vgi_bi_Vdi_bi/(T0+M0_t)-(T1_Vgi_bi*T0_Vdi_bi+T1_Vdi_bi*T0_Vgi_bi+T1*(+T0_Vgi_bi_Vdi_bi+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vgi_bi*T0_Vdi_bi/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vgi_bi_Vsi_bi=(T1_Vgi_bi_Vsi_bi/(T0+M0_t)-(T1_Vgi_bi*T0_Vsi_bi+T1_Vsi_bi*T0_Vgi_bi+T1*(+T0_Vgi_bi_Vsi_bi+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vgi_bi*T0_Vsi_bi/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vgi_bi_Tempt_GND=(T1_Vgi_bi_Tempt_GND/(T0+M0_t)-(T1_Vgi_bi*(T0_Tempt_GND+M0_t_Tempt_GND)+T1_Tempt_GND*T0_Vgi_bi+T1*(+T0_Vgi_bi_Tempt_GND+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vgi_bi*(T0_Tempt_GND+M0_t_Tempt_GND)/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
#endif
T2_Vdi_bi=((T1_Vdi_bi*(T0+M0_t)-T1*T0_Vdi_bi)/(T0+M0_t)/(T0+M0_t));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(T1_Vdi_bi_Vgm_di/(T0+M0_t)-(T1_Vdi_bi*T0_Vgm_di+T1_Vgm_di*T0_Vdi_bi+T1*(+T0_Vdi_bi_Vgm_di+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vdi_bi*T0_Vgm_di/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vdi_bi_Vgm_si=(T1_Vdi_bi_Vgm_si/(T0+M0_t)-(T1_Vdi_bi*T0_Vgm_si+T1_Vgm_si*T0_Vdi_bi+T1*(+T0_Vdi_bi_Vgm_si+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vdi_bi*T0_Vgm_si/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vdi_bi_Vdbulk_di=(T1_Vdi_bi_Vdbulk_di/(T0+M0_t)-(T1_Vdi_bi*T0_Vdbulk_di+T1_Vdbulk_di*T0_Vdi_bi+T1*(+T0_Vdi_bi_Vdbulk_di+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vdi_bi*T0_Vdbulk_di/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vdi_bi_Vsbulk_si=(T1_Vdi_bi_Vsbulk_si/(T0+M0_t)-(T1_Vdi_bi*T0_Vsbulk_si+T1_Vsbulk_si*T0_Vdi_bi+T1*(+T0_Vdi_bi_Vsbulk_si+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vdi_bi*T0_Vsbulk_si/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vdi_bi_Vgi_bi=(T1_Vdi_bi_Vgi_bi/(T0+M0_t)-(T1_Vdi_bi*T0_Vgi_bi+T1_Vgi_bi*T0_Vdi_bi+T1*(+T0_Vdi_bi_Vgi_bi+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vdi_bi*T0_Vgi_bi/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vdi_bi_Vdi_bi=(T1_Vdi_bi_Vdi_bi/(T0+M0_t)-(T1_Vdi_bi*T0_Vdi_bi+T1_Vdi_bi*T0_Vdi_bi+T1*(+T0_Vdi_bi_Vdi_bi+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vdi_bi*T0_Vdi_bi/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vdi_bi_Vsi_bi=(T1_Vdi_bi_Vsi_bi/(T0+M0_t)-(T1_Vdi_bi*T0_Vsi_bi+T1_Vsi_bi*T0_Vdi_bi+T1*(+T0_Vdi_bi_Vsi_bi+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vdi_bi*T0_Vsi_bi/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vdi_bi_Tempt_GND=(T1_Vdi_bi_Tempt_GND/(T0+M0_t)-(T1_Vdi_bi*(T0_Tempt_GND+M0_t_Tempt_GND)+T1_Tempt_GND*T0_Vdi_bi+T1*(+T0_Vdi_bi_Tempt_GND+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vdi_bi*(T0_Tempt_GND+M0_t_Tempt_GND)/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
#endif
T2_Vsi_bi=((T1_Vsi_bi*(T0+M0_t)-T1*T0_Vsi_bi)/(T0+M0_t)/(T0+M0_t));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(T1_Vsi_bi_Vgm_di/(T0+M0_t)-(T1_Vsi_bi*T0_Vgm_di+T1_Vgm_di*T0_Vsi_bi+T1*(+T0_Vsi_bi_Vgm_di+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vsi_bi*T0_Vgm_di/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vsi_bi_Vgm_si=(T1_Vsi_bi_Vgm_si/(T0+M0_t)-(T1_Vsi_bi*T0_Vgm_si+T1_Vgm_si*T0_Vsi_bi+T1*(+T0_Vsi_bi_Vgm_si+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vsi_bi*T0_Vgm_si/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vsi_bi_Vdbulk_di=(T1_Vsi_bi_Vdbulk_di/(T0+M0_t)-(T1_Vsi_bi*T0_Vdbulk_di+T1_Vdbulk_di*T0_Vsi_bi+T1*(+T0_Vsi_bi_Vdbulk_di+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vsi_bi*T0_Vdbulk_di/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vsi_bi_Vsbulk_si=(T1_Vsi_bi_Vsbulk_si/(T0+M0_t)-(T1_Vsi_bi*T0_Vsbulk_si+T1_Vsbulk_si*T0_Vsi_bi+T1*(+T0_Vsi_bi_Vsbulk_si+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vsi_bi*T0_Vsbulk_si/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vsi_bi_Vgi_bi=(T1_Vsi_bi_Vgi_bi/(T0+M0_t)-(T1_Vsi_bi*T0_Vgi_bi+T1_Vgi_bi*T0_Vsi_bi+T1*(+T0_Vsi_bi_Vgi_bi+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vsi_bi*T0_Vgi_bi/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vsi_bi_Vdi_bi=(T1_Vsi_bi_Vdi_bi/(T0+M0_t)-(T1_Vsi_bi*T0_Vdi_bi+T1_Vdi_bi*T0_Vsi_bi+T1*(+T0_Vsi_bi_Vdi_bi+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vsi_bi*T0_Vdi_bi/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vsi_bi_Vsi_bi=(T1_Vsi_bi_Vsi_bi/(T0+M0_t)-(T1_Vsi_bi*T0_Vsi_bi+T1_Vsi_bi*T0_Vsi_bi+T1*(+T0_Vsi_bi_Vsi_bi+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vsi_bi*T0_Vsi_bi/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
  T2_Vsi_bi_Tempt_GND=(T1_Vsi_bi_Tempt_GND/(T0+M0_t)-(T1_Vsi_bi*(T0_Tempt_GND+M0_t_Tempt_GND)+T1_Tempt_GND*T0_Vsi_bi+T1*(+T0_Vsi_bi_Tempt_GND+0.0))/(T0+M0_t)/(T0+M0_t)+2*T1*T0_Vsi_bi*(T0_Tempt_GND+M0_t_Tempt_GND)/(T0+M0_t)/(T0+M0_t)/(T0+M0_t));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((T1_Tempt_GND*(T0+M0_t)-T1*(T0_Tempt_GND+M0_t_Tempt_GND))/(T0+M0_t)/(T0+M0_t));
#endif
#endif
T2=(T1/(T0+M0_t));
EXIT_IF_ISNAN((T1/(T0+M0_t)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(((K0_t*T2_Vgi_bi)*T2)+((K0_t*T2)*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgi_bi+K0_t*T2_Vgi_bi_Vgm_si)*T2+(K0_t*T2_Vgi_bi)*T2_Vgm_si+((K0_t*T2_Vgm_si))*T2_Vgi_bi+(K0_t*T2)*T2_Vgi_bi_Vgm_si);
  T3_Vgi_bi_Vgm_di=(+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgi_bi+K0_t*T2_Vgi_bi_Vgm_di)*T2+(K0_t*T2_Vgi_bi)*T2_Vgm_di+((K0_t*T2_Vgm_di))*T2_Vgi_bi+(K0_t*T2)*T2_Vgi_bi_Vgm_di);
  T3_Vgi_bi_Vdbulk_di=(+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+K0_t*T2_Vgi_bi_Vdbulk_di)*T2+(K0_t*T2_Vgi_bi)*T2_Vdbulk_di+((K0_t*T2_Vdbulk_di))*T2_Vgi_bi+(K0_t*T2)*T2_Vgi_bi_Vdbulk_di);
  T3_Vgi_bi_Vsbulk_si=(+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+K0_t*T2_Vgi_bi_Vsbulk_si)*T2+(K0_t*T2_Vgi_bi)*T2_Vsbulk_si+((K0_t*T2_Vsbulk_si))*T2_Vgi_bi+(K0_t*T2)*T2_Vgi_bi_Vsbulk_si);
  T3_Vgi_bi_Vgi_bi=(+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+K0_t*T2_Vgi_bi_Vgi_bi)*T2+(K0_t*T2_Vgi_bi)*T2_Vgi_bi+((K0_t*T2_Vgi_bi))*T2_Vgi_bi+(K0_t*T2)*T2_Vgi_bi_Vgi_bi);
  T3_Vgi_bi_Vdi_bi=(+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+K0_t*T2_Vgi_bi_Vdi_bi)*T2+(K0_t*T2_Vgi_bi)*T2_Vdi_bi+((K0_t*T2_Vdi_bi))*T2_Vgi_bi+(K0_t*T2)*T2_Vgi_bi_Vdi_bi);
  T3_Vgi_bi_Vsi_bi=(+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+K0_t*T2_Vgi_bi_Vsi_bi)*T2+(K0_t*T2_Vgi_bi)*T2_Vsi_bi+((K0_t*T2_Vsi_bi))*T2_Vgi_bi+(K0_t*T2)*T2_Vgi_bi_Vsi_bi);
  T3_Vgi_bi_Tempt_GND=(+(+0.0*T2+0.0*T2_Tempt_GND+K0_t_Tempt_GND*T2_Vgi_bi+K0_t*T2_Vgi_bi_Tempt_GND)*T2+(K0_t*T2_Vgi_bi)*T2_Tempt_GND+(((K0_t_Tempt_GND*T2)+(K0_t*T2_Tempt_GND)))*T2_Vgi_bi+(K0_t*T2)*T2_Vgi_bi_Tempt_GND);
#endif
T3_Vdi_bi=(((K0_t*T2_Vdi_bi)*T2)+((K0_t*T2)*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+K0_t*T2_Vdi_bi_Vgm_si)*T2+(K0_t*T2_Vdi_bi)*T2_Vgm_si+((K0_t*T2_Vgm_si))*T2_Vdi_bi+(K0_t*T2)*T2_Vdi_bi_Vgm_si);
  T3_Vdi_bi_Vgm_di=(+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+K0_t*T2_Vdi_bi_Vgm_di)*T2+(K0_t*T2_Vdi_bi)*T2_Vgm_di+((K0_t*T2_Vgm_di))*T2_Vdi_bi+(K0_t*T2)*T2_Vdi_bi_Vgm_di);
  T3_Vdi_bi_Vdbulk_di=(+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+K0_t*T2_Vdi_bi_Vdbulk_di)*T2+(K0_t*T2_Vdi_bi)*T2_Vdbulk_di+((K0_t*T2_Vdbulk_di))*T2_Vdi_bi+(K0_t*T2)*T2_Vdi_bi_Vdbulk_di);
  T3_Vdi_bi_Vsbulk_si=(+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+K0_t*T2_Vdi_bi_Vsbulk_si)*T2+(K0_t*T2_Vdi_bi)*T2_Vsbulk_si+((K0_t*T2_Vsbulk_si))*T2_Vdi_bi+(K0_t*T2)*T2_Vdi_bi_Vsbulk_si);
  T3_Vdi_bi_Vgi_bi=(+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+K0_t*T2_Vdi_bi_Vgi_bi)*T2+(K0_t*T2_Vdi_bi)*T2_Vgi_bi+((K0_t*T2_Vgi_bi))*T2_Vdi_bi+(K0_t*T2)*T2_Vdi_bi_Vgi_bi);
  T3_Vdi_bi_Vdi_bi=(+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+K0_t*T2_Vdi_bi_Vdi_bi)*T2+(K0_t*T2_Vdi_bi)*T2_Vdi_bi+((K0_t*T2_Vdi_bi))*T2_Vdi_bi+(K0_t*T2)*T2_Vdi_bi_Vdi_bi);
  T3_Vdi_bi_Vsi_bi=(+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+K0_t*T2_Vdi_bi_Vsi_bi)*T2+(K0_t*T2_Vdi_bi)*T2_Vsi_bi+((K0_t*T2_Vsi_bi))*T2_Vdi_bi+(K0_t*T2)*T2_Vdi_bi_Vsi_bi);
  T3_Vdi_bi_Tempt_GND=(+(+0.0*T2+0.0*T2_Tempt_GND+K0_t_Tempt_GND*T2_Vdi_bi+K0_t*T2_Vdi_bi_Tempt_GND)*T2+(K0_t*T2_Vdi_bi)*T2_Tempt_GND+(((K0_t_Tempt_GND*T2)+(K0_t*T2_Tempt_GND)))*T2_Vdi_bi+(K0_t*T2)*T2_Vdi_bi_Tempt_GND);
#endif
T3_Vsi_bi=(((K0_t*T2_Vsi_bi)*T2)+((K0_t*T2)*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+K0_t*T2_Vsi_bi_Vgm_si)*T2+(K0_t*T2_Vsi_bi)*T2_Vgm_si+((K0_t*T2_Vgm_si))*T2_Vsi_bi+(K0_t*T2)*T2_Vsi_bi_Vgm_si);
  T3_Vsi_bi_Vgm_di=(+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+K0_t*T2_Vsi_bi_Vgm_di)*T2+(K0_t*T2_Vsi_bi)*T2_Vgm_di+((K0_t*T2_Vgm_di))*T2_Vsi_bi+(K0_t*T2)*T2_Vsi_bi_Vgm_di);
  T3_Vsi_bi_Vdbulk_di=(+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+K0_t*T2_Vsi_bi_Vdbulk_di)*T2+(K0_t*T2_Vsi_bi)*T2_Vdbulk_di+((K0_t*T2_Vdbulk_di))*T2_Vsi_bi+(K0_t*T2)*T2_Vsi_bi_Vdbulk_di);
  T3_Vsi_bi_Vsbulk_si=(+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+K0_t*T2_Vsi_bi_Vsbulk_si)*T2+(K0_t*T2_Vsi_bi)*T2_Vsbulk_si+((K0_t*T2_Vsbulk_si))*T2_Vsi_bi+(K0_t*T2)*T2_Vsi_bi_Vsbulk_si);
  T3_Vsi_bi_Vgi_bi=(+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+K0_t*T2_Vsi_bi_Vgi_bi)*T2+(K0_t*T2_Vsi_bi)*T2_Vgi_bi+((K0_t*T2_Vgi_bi))*T2_Vsi_bi+(K0_t*T2)*T2_Vsi_bi_Vgi_bi);
  T3_Vsi_bi_Vdi_bi=(+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+K0_t*T2_Vsi_bi_Vdi_bi)*T2+(K0_t*T2_Vsi_bi)*T2_Vdi_bi+((K0_t*T2_Vdi_bi))*T2_Vsi_bi+(K0_t*T2)*T2_Vsi_bi_Vdi_bi);
  T3_Vsi_bi_Vsi_bi=(+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+K0_t*T2_Vsi_bi_Vsi_bi)*T2+(K0_t*T2_Vsi_bi)*T2_Vsi_bi+((K0_t*T2_Vsi_bi))*T2_Vsi_bi+(K0_t*T2)*T2_Vsi_bi_Vsi_bi);
  T3_Vsi_bi_Tempt_GND=(+(+0.0*T2+0.0*T2_Tempt_GND+K0_t_Tempt_GND*T2_Vsi_bi+K0_t*T2_Vsi_bi_Tempt_GND)*T2+(K0_t*T2_Vsi_bi)*T2_Tempt_GND+(((K0_t_Tempt_GND*T2)+(K0_t*T2_Tempt_GND)))*T2_Vsi_bi+(K0_t*T2)*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=((((K0_t_Tempt_GND*T2)+(K0_t*T2_Tempt_GND))*T2)+((K0_t*T2)*T2_Tempt_GND));
#endif
#endif
T3=((K0_t*T2)*T2);
EXIT_IF_ISNAN(((K0_t*T2)*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
Mnud_Vgi_bi=T3_Vgi_bi;
#if defined(_DERIVATE2)
  Mnud_Vgi_bi_Vgi_bi=(+0.0+T3_Vgi_bi_Vgi_bi);
  Mnud_Vgi_bi_Vdi_bi=(+0.0+T3_Vgi_bi_Vdi_bi);
  Mnud_Vgi_bi_Vsi_bi=(+0.0+T3_Vgi_bi_Vsi_bi);
  Mnud_Vgi_bi_Tempt_GND=(+0.0+T3_Vgi_bi_Tempt_GND);
#endif
Mnud_Vdi_bi=T3_Vdi_bi;
#if defined(_DERIVATE2)
  Mnud_Vdi_bi_Vgi_bi=(+0.0+T3_Vdi_bi_Vgi_bi);
  Mnud_Vdi_bi_Vdi_bi=(+0.0+T3_Vdi_bi_Vdi_bi);
  Mnud_Vdi_bi_Vsi_bi=(+0.0+T3_Vdi_bi_Vsi_bi);
  Mnud_Vdi_bi_Tempt_GND=(+0.0+T3_Vdi_bi_Tempt_GND);
#endif
Mnud_Vsi_bi=T3_Vsi_bi;
#if defined(_DERIVATE2)
  Mnud_Vsi_bi_Vgi_bi=(+0.0+T3_Vsi_bi_Vgi_bi);
  Mnud_Vsi_bi_Vdi_bi=(+0.0+T3_Vsi_bi_Vdi_bi);
  Mnud_Vsi_bi_Vsi_bi=(+0.0+T3_Vsi_bi_Vsi_bi);
  Mnud_Vsi_bi_Tempt_GND=(+0.0+T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Mnud_Tempt_GND=T3_Tempt_GND;
#endif
#endif
Mnud=(1.0+T3);
EXIT_IF_ISNAN((1.0+T3))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND) */
Dtot_Vgi_bi=((((Dmob_Vgi_bi*Dvsat)+(Dmob*Dvsat_Vgi_bi))*Dr)+((Dmob*Dvsat)*Dr_Vgi_bi));
#if defined(_DERIVATE2)
  Dtot_Vgi_bi_Vgi_bi=(+(+Dmob_Vgi_bi_Vgi_bi*Dvsat+Dmob_Vgi_bi*Dvsat_Vgi_bi+Dmob_Vgi_bi*Dvsat_Vgi_bi+Dmob*Dvsat_Vgi_bi_Vgi_bi)*Dr+((Dmob_Vgi_bi*Dvsat)+(Dmob*Dvsat_Vgi_bi))*Dr_Vgi_bi+(((Dmob_Vgi_bi*Dvsat)+(Dmob*Dvsat_Vgi_bi)))*Dr_Vgi_bi+(Dmob*Dvsat)*Dr_Vgi_bi_Vgi_bi);
  Dtot_Vgi_bi_Vdi_bi=(+(+Dmob_Vgi_bi_Vdi_bi*Dvsat+Dmob_Vgi_bi*Dvsat_Vdi_bi+Dmob_Vdi_bi*Dvsat_Vgi_bi+Dmob*Dvsat_Vgi_bi_Vdi_bi)*Dr+((Dmob_Vgi_bi*Dvsat)+(Dmob*Dvsat_Vgi_bi))*Dr_Vdi_bi+(((Dmob_Vdi_bi*Dvsat)+(Dmob*Dvsat_Vdi_bi)))*Dr_Vgi_bi+(Dmob*Dvsat)*Dr_Vgi_bi_Vdi_bi);
  Dtot_Vgi_bi_Vsi_bi=(+(+Dmob_Vgi_bi_Vsi_bi*Dvsat+Dmob_Vgi_bi*Dvsat_Vsi_bi+Dmob_Vsi_bi*Dvsat_Vgi_bi+Dmob*Dvsat_Vgi_bi_Vsi_bi)*Dr+((Dmob_Vgi_bi*Dvsat)+(Dmob*Dvsat_Vgi_bi))*Dr_Vsi_bi+(((Dmob_Vsi_bi*Dvsat)+(Dmob*Dvsat_Vsi_bi)))*Dr_Vgi_bi+(Dmob*Dvsat)*Dr_Vgi_bi_Vsi_bi);
  Dtot_Vgi_bi_Tempt_GND=(+(+Dmob_Vgi_bi_Tempt_GND*Dvsat+Dmob_Vgi_bi*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vgi_bi+Dmob*Dvsat_Vgi_bi_Tempt_GND)*Dr+((Dmob_Vgi_bi*Dvsat)+(Dmob*Dvsat_Vgi_bi))*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Vgi_bi+(Dmob*Dvsat)*Dr_Vgi_bi_Tempt_GND);
#endif
Dtot_Vdi_bi=((((Dmob_Vdi_bi*Dvsat)+(Dmob*Dvsat_Vdi_bi))*Dr)+((Dmob*Dvsat)*Dr_Vdi_bi));
#if defined(_DERIVATE2)
  Dtot_Vdi_bi_Vgi_bi=(+(+Dmob_Vdi_bi_Vgi_bi*Dvsat+Dmob_Vdi_bi*Dvsat_Vgi_bi+Dmob_Vgi_bi*Dvsat_Vdi_bi+Dmob*Dvsat_Vdi_bi_Vgi_bi)*Dr+((Dmob_Vdi_bi*Dvsat)+(Dmob*Dvsat_Vdi_bi))*Dr_Vgi_bi+(((Dmob_Vgi_bi*Dvsat)+(Dmob*Dvsat_Vgi_bi)))*Dr_Vdi_bi+(Dmob*Dvsat)*Dr_Vdi_bi_Vgi_bi);
  Dtot_Vdi_bi_Vdi_bi=(+(+Dmob_Vdi_bi_Vdi_bi*Dvsat+Dmob_Vdi_bi*Dvsat_Vdi_bi+Dmob_Vdi_bi*Dvsat_Vdi_bi+Dmob*Dvsat_Vdi_bi_Vdi_bi)*Dr+((Dmob_Vdi_bi*Dvsat)+(Dmob*Dvsat_Vdi_bi))*Dr_Vdi_bi+(((Dmob_Vdi_bi*Dvsat)+(Dmob*Dvsat_Vdi_bi)))*Dr_Vdi_bi+(Dmob*Dvsat)*Dr_Vdi_bi_Vdi_bi);
  Dtot_Vdi_bi_Vsi_bi=(+(+Dmob_Vdi_bi_Vsi_bi*Dvsat+Dmob_Vdi_bi*Dvsat_Vsi_bi+Dmob_Vsi_bi*Dvsat_Vdi_bi+Dmob*Dvsat_Vdi_bi_Vsi_bi)*Dr+((Dmob_Vdi_bi*Dvsat)+(Dmob*Dvsat_Vdi_bi))*Dr_Vsi_bi+(((Dmob_Vsi_bi*Dvsat)+(Dmob*Dvsat_Vsi_bi)))*Dr_Vdi_bi+(Dmob*Dvsat)*Dr_Vdi_bi_Vsi_bi);
  Dtot_Vdi_bi_Tempt_GND=(+(+Dmob_Vdi_bi_Tempt_GND*Dvsat+Dmob_Vdi_bi*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vdi_bi+Dmob*Dvsat_Vdi_bi_Tempt_GND)*Dr+((Dmob_Vdi_bi*Dvsat)+(Dmob*Dvsat_Vdi_bi))*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Vdi_bi+(Dmob*Dvsat)*Dr_Vdi_bi_Tempt_GND);
#endif
Dtot_Vsi_bi=((((Dmob_Vsi_bi*Dvsat)+(Dmob*Dvsat_Vsi_bi))*Dr)+((Dmob*Dvsat)*Dr_Vsi_bi));
#if defined(_DERIVATE2)
  Dtot_Vsi_bi_Vgi_bi=(+(+Dmob_Vsi_bi_Vgi_bi*Dvsat+Dmob_Vsi_bi*Dvsat_Vgi_bi+Dmob_Vgi_bi*Dvsat_Vsi_bi+Dmob*Dvsat_Vsi_bi_Vgi_bi)*Dr+((Dmob_Vsi_bi*Dvsat)+(Dmob*Dvsat_Vsi_bi))*Dr_Vgi_bi+(((Dmob_Vgi_bi*Dvsat)+(Dmob*Dvsat_Vgi_bi)))*Dr_Vsi_bi+(Dmob*Dvsat)*Dr_Vsi_bi_Vgi_bi);
  Dtot_Vsi_bi_Vdi_bi=(+(+Dmob_Vsi_bi_Vdi_bi*Dvsat+Dmob_Vsi_bi*Dvsat_Vdi_bi+Dmob_Vdi_bi*Dvsat_Vsi_bi+Dmob*Dvsat_Vsi_bi_Vdi_bi)*Dr+((Dmob_Vsi_bi*Dvsat)+(Dmob*Dvsat_Vsi_bi))*Dr_Vdi_bi+(((Dmob_Vdi_bi*Dvsat)+(Dmob*Dvsat_Vdi_bi)))*Dr_Vsi_bi+(Dmob*Dvsat)*Dr_Vsi_bi_Vdi_bi);
  Dtot_Vsi_bi_Vsi_bi=(+(+Dmob_Vsi_bi_Vsi_bi*Dvsat+Dmob_Vsi_bi*Dvsat_Vsi_bi+Dmob_Vsi_bi*Dvsat_Vsi_bi+Dmob*Dvsat_Vsi_bi_Vsi_bi)*Dr+((Dmob_Vsi_bi*Dvsat)+(Dmob*Dvsat_Vsi_bi))*Dr_Vsi_bi+(((Dmob_Vsi_bi*Dvsat)+(Dmob*Dvsat_Vsi_bi)))*Dr_Vsi_bi+(Dmob*Dvsat)*Dr_Vsi_bi_Vsi_bi);
  Dtot_Vsi_bi_Tempt_GND=(+(+Dmob_Vsi_bi_Tempt_GND*Dvsat+Dmob_Vsi_bi*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vsi_bi+Dmob*Dvsat_Vsi_bi_Tempt_GND)*Dr+((Dmob_Vsi_bi*Dvsat)+(Dmob*Dvsat_Vsi_bi))*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Vsi_bi+(Dmob*Dvsat)*Dr_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Dtot_Tempt_GND=((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND));
#endif
#endif
Dtot=((Dmob*Dvsat)*Dr);
EXIT_IF_ISNAN(((Dmob*Dvsat)*Dr))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
ueff_Tempt_GND=((U0_a_Tempt_GND*Dtot-U0_a*Dtot_Tempt_GND)/Dtot/Dtot);
#endif
ueff_Vdi_bi=((U0_a_Vdi_bi*Dtot-U0_a*Dtot_Vdi_bi)/Dtot/Dtot);
#if defined(_DERIVATE2)
  ueff_Vdi_bi_Tempt_GND=(U0_a_Vdi_bi_Tempt_GND/Dtot-(U0_a_Vdi_bi*Dtot_Tempt_GND+U0_a_Tempt_GND*Dtot_Vdi_bi+U0_a*Dtot_Vdi_bi_Tempt_GND)/Dtot/Dtot+2*U0_a*Dtot_Vdi_bi*Dtot_Tempt_GND/Dtot/Dtot/Dtot);
  ueff_Vdi_bi_Vdi_bi=(U0_a_Vdi_bi_Vdi_bi/Dtot-(U0_a_Vdi_bi*Dtot_Vdi_bi+U0_a_Vdi_bi*Dtot_Vdi_bi+U0_a*Dtot_Vdi_bi_Vdi_bi)/Dtot/Dtot+2*U0_a*Dtot_Vdi_bi*Dtot_Vdi_bi/Dtot/Dtot/Dtot);
  ueff_Vdi_bi_Vsi_bi=(U0_a_Vdi_bi_Vsi_bi/Dtot-(U0_a_Vdi_bi*Dtot_Vsi_bi+U0_a_Vsi_bi*Dtot_Vdi_bi+U0_a*Dtot_Vdi_bi_Vsi_bi)/Dtot/Dtot+2*U0_a*Dtot_Vdi_bi*Dtot_Vsi_bi/Dtot/Dtot/Dtot);
  ueff_Vdi_bi_Vgi_bi=(0.0/Dtot-(U0_a_Vdi_bi*Dtot_Vgi_bi+0.0*Dtot_Vdi_bi+U0_a*Dtot_Vdi_bi_Vgi_bi)/Dtot/Dtot+2*U0_a*Dtot_Vdi_bi*Dtot_Vgi_bi/Dtot/Dtot/Dtot);
#endif
ueff_Vsi_bi=((U0_a_Vsi_bi*Dtot-U0_a*Dtot_Vsi_bi)/Dtot/Dtot);
#if defined(_DERIVATE2)
  ueff_Vsi_bi_Tempt_GND=(U0_a_Vsi_bi_Tempt_GND/Dtot-(U0_a_Vsi_bi*Dtot_Tempt_GND+U0_a_Tempt_GND*Dtot_Vsi_bi+U0_a*Dtot_Vsi_bi_Tempt_GND)/Dtot/Dtot+2*U0_a*Dtot_Vsi_bi*Dtot_Tempt_GND/Dtot/Dtot/Dtot);
  ueff_Vsi_bi_Vdi_bi=(U0_a_Vsi_bi_Vdi_bi/Dtot-(U0_a_Vsi_bi*Dtot_Vdi_bi+U0_a_Vdi_bi*Dtot_Vsi_bi+U0_a*Dtot_Vsi_bi_Vdi_bi)/Dtot/Dtot+2*U0_a*Dtot_Vsi_bi*Dtot_Vdi_bi/Dtot/Dtot/Dtot);
  ueff_Vsi_bi_Vsi_bi=(U0_a_Vsi_bi_Vsi_bi/Dtot-(U0_a_Vsi_bi*Dtot_Vsi_bi+U0_a_Vsi_bi*Dtot_Vsi_bi+U0_a*Dtot_Vsi_bi_Vsi_bi)/Dtot/Dtot+2*U0_a*Dtot_Vsi_bi*Dtot_Vsi_bi/Dtot/Dtot/Dtot);
  ueff_Vsi_bi_Vgi_bi=(0.0/Dtot-(U0_a_Vsi_bi*Dtot_Vgi_bi+0.0*Dtot_Vsi_bi+U0_a*Dtot_Vsi_bi_Vgi_bi)/Dtot/Dtot+2*U0_a*Dtot_Vsi_bi*Dtot_Vgi_bi/Dtot/Dtot/Dtot);
#endif
ueff_Vgi_bi=(-U0_a*Dtot_Vgi_bi/Dtot/Dtot);
#if defined(_DERIVATE2)
  ueff_Vgi_bi_Tempt_GND=(0.0/Dtot-(0.0*Dtot_Tempt_GND+U0_a_Tempt_GND*Dtot_Vgi_bi+U0_a*Dtot_Vgi_bi_Tempt_GND)/Dtot/Dtot+2*U0_a*Dtot_Vgi_bi*Dtot_Tempt_GND/Dtot/Dtot/Dtot);
  ueff_Vgi_bi_Vdi_bi=(0.0/Dtot-(0.0*Dtot_Vdi_bi+U0_a_Vdi_bi*Dtot_Vgi_bi+U0_a*Dtot_Vgi_bi_Vdi_bi)/Dtot/Dtot+2*U0_a*Dtot_Vgi_bi*Dtot_Vdi_bi/Dtot/Dtot/Dtot);
  ueff_Vgi_bi_Vsi_bi=(0.0/Dtot-(0.0*Dtot_Vsi_bi+U0_a_Vsi_bi*Dtot_Vgi_bi+U0_a*Dtot_Vgi_bi_Vsi_bi)/Dtot/Dtot+2*U0_a*Dtot_Vgi_bi*Dtot_Vsi_bi/Dtot/Dtot/Dtot);
  ueff_Vgi_bi_Vgi_bi=(0.0/Dtot-(0.0*Dtot_Vgi_bi+0.0*Dtot_Vgi_bi+U0_a*Dtot_Vgi_bi_Vgi_bi)/Dtot/Dtot+2*U0_a*Dtot_Vgi_bi*Dtot_Vgi_bi/Dtot/Dtot/Dtot);
#endif
#endif
ueff=(U0_a/Dtot);
EXIT_IF_ISNAN((U0_a/Dtot))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
ids_Vgm_si=0.0;
#if defined(_DERIVATE2)
  ids_Vgm_si_Vgm_si=0.0;
  ids_Vgm_si_Vgm_di=0.0;
  ids_Vgm_si_Vdbulk_di=0.0;
  ids_Vgm_si_Vsbulk_si=0.0;
  ids_Vgm_si_Vgi_bi=0.0;
  ids_Vgm_si_Tempt_GND=0.0;
  ids_Vgm_si_Vdi_bi=0.0;
  ids_Vgm_si_Vsi_bi=0.0;
#endif
ids_Vgm_di=0.0;
#if defined(_DERIVATE2)
  ids_Vgm_di_Vgm_si=0.0;
  ids_Vgm_di_Vgm_di=0.0;
  ids_Vgm_di_Vdbulk_di=0.0;
  ids_Vgm_di_Vsbulk_si=0.0;
  ids_Vgm_di_Vgi_bi=0.0;
  ids_Vgm_di_Tempt_GND=0.0;
  ids_Vgm_di_Vdi_bi=0.0;
  ids_Vgm_di_Vsi_bi=0.0;
#endif
ids_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  ids_Vdbulk_di_Vgm_si=0.0;
  ids_Vdbulk_di_Vgm_di=0.0;
  ids_Vdbulk_di_Vdbulk_di=0.0;
  ids_Vdbulk_di_Vsbulk_si=0.0;
  ids_Vdbulk_di_Vgi_bi=0.0;
  ids_Vdbulk_di_Tempt_GND=0.0;
  ids_Vdbulk_di_Vdi_bi=0.0;
  ids_Vdbulk_di_Vsi_bi=0.0;
#endif
ids_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  ids_Vsbulk_si_Vgm_si=0.0;
  ids_Vsbulk_si_Vgm_di=0.0;
  ids_Vsbulk_si_Vdbulk_di=0.0;
  ids_Vsbulk_si_Vsbulk_si=0.0;
  ids_Vsbulk_si_Vgi_bi=0.0;
  ids_Vsbulk_si_Tempt_GND=0.0;
  ids_Vsbulk_si_Vdi_bi=0.0;
  ids_Vsbulk_si_Vsi_bi=0.0;
#endif
ids_Vgi_bi=(((((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*Mnud)+((((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vgi_bi));
#if defined(_DERIVATE2)
  ids_Vgi_bi_Vgm_si=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_si+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vgm_si)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt_Vgm_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi_Vgm_si)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vgm_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vgm_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vgm_si-qdeff_Vgi_bi_Vgm_si)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgm_si+qdeff_Vgm_si)+(qs_Vgm_si-qdeff_Vgm_si)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vgm_si)+qdeff_Vgi_bi_Vgm_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*0.0+((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc)*Nsat_Vgi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*0.0+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc)/Nsat)*Mnud_Vgi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vgi_bi_Vgm_di=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_di+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vgm_di)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*0.0)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di))))+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vgm_di-qdeff_Vgi_bi_Vgm_di)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgm_di+qdeff_Vgm_di)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vgm_di)+qdeff_Vgi_bi_Vgm_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*0.0+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*0.0+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc)*Nsat_Vgi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*0.0+(((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc)/Nsat)*Mnud_Vgi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vgi_bi_Vdbulk_di=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdbulk_di+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vdbulk_di)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt_Vdbulk_di+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi_Vdbulk_di)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vdbulk_di+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vdbulk_di)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vdbulk_di)+qdeff_Vgi_bi_Vdbulk_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*0.0+((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc)*Nsat_Vgi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*0.0+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc)/Nsat)*Mnud_Vgi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vgi_bi_Vsbulk_si=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsbulk_si+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vsbulk_si)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt_Vsbulk_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi_Vsbulk_si)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vsbulk_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vsbulk_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vsbulk_si)+qdeff_Vgi_bi_Vsbulk_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*0.0+((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc)*Nsat_Vgi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*0.0+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc)/Nsat)*Mnud_Vgi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vgi_bi_Vgi_bi=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vgi_bi)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*ueff_Vgi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*ueff_Vgi_bi_Vgi_bi)*Weff+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt_Vgi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi_Vgi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vgi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vgi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vgi_bi)+qdeff_Vgi_bi_Vgi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc_Vgi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi_Vgi_bi)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat_Vgi_bi+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi)))*Nsat_Vgi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi_Vgi_bi)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi*Nsat_Vgi_bi/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*Mnud_Vgi_bi+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*Mnud_Vgi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vgi_bi_Vgi_bi);
  ids_Vgi_bi_Tempt_GND=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Tempt_GND)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*ueff_Tempt_GND+((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*ueff_Vgi_bi_Tempt_GND)*Weff+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt_Tempt_GND+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi_Tempt_GND)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Tempt_GND+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Tempt_GND)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Tempt_GND)+qdeff_Vgi_bi_Tempt_GND)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc_Tempt_GND+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi_Tempt_GND)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat_Tempt_GND+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Tempt_GND)))*Nsat_Vgi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi_Tempt_GND)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi*Nsat_Tempt_GND/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*Mnud_Tempt_GND+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Tempt_GND)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Tempt_GND)/Nsat/Nsat)*Mnud_Vgi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vgi_bi_Tempt_GND);
  ids_Vgi_bi_Vdi_bi=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vdi_bi)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*ueff_Vdi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*ueff_Vgi_bi_Vdi_bi)*Weff+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt_Vdi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi_Vdi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vdi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vdi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vdi_bi)+qdeff_Vgi_bi_Vdi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc_Vdi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi_Vdi_bi)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat_Vdi_bi+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi)))*Nsat_Vgi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi_Vdi_bi)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi*Nsat_Vdi_bi/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*Mnud_Vdi_bi+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*Mnud_Vgi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vgi_bi_Vdi_bi);
  ids_Vgi_bi_Vsi_bi=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vsi_bi)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*ueff_Vsi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*ueff_Vgi_bi_Vsi_bi)*Weff+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt_Vsi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi_Vsi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vsi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vsi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vsi_bi)+qdeff_Vgi_bi_Vsi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc_Vsi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi_Vsi_bi)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat_Vsi_bi+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi)))*Nsat_Vgi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi_Vsi_bi)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi*Nsat_Vsi_bi/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*Mnud_Vsi_bi+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*Mnud_Vgi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vgi_bi_Vsi_bi);
#endif
#if defined(_DERIVATE)
ids_Tempt_GND=(((((((((((((((((2.0*pInst->NF)*nq_Tempt_GND)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Tempt_GND))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Tempt_GND)/Nsat/Nsat)*Mnud)+((((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Tempt_GND));
#endif
ids_Vdi_bi=(((((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*Mnud)+((((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vdi_bi));
#if defined(_DERIVATE2)
  ids_Vdi_bi_Vgm_si=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_si+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vgm_si)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt_Vgm_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi_Vgm_si)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vgm_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vgm_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vgm_si-qdeff_Vdi_bi_Vgm_si)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgm_si+qdeff_Vgm_si)+(qs_Vgm_si-qdeff_Vgm_si)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vgm_si)+qdeff_Vdi_bi_Vgm_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*0.0+((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc)*Nsat_Vdi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*0.0+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc)/Nsat)*Mnud_Vdi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vdi_bi_Vgm_di=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_di+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vgm_di)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*0.0)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di))))+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vgm_di-qdeff_Vdi_bi_Vgm_di)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgm_di+qdeff_Vgm_di)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vgm_di)+qdeff_Vdi_bi_Vgm_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*0.0+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*0.0+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc)*Nsat_Vdi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*0.0+(((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc)/Nsat)*Mnud_Vdi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vdi_bi_Vdbulk_di=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdbulk_di+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vdbulk_di)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt_Vdbulk_di+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi_Vdbulk_di)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vdbulk_di+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vdbulk_di)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vdbulk_di)+qdeff_Vdi_bi_Vdbulk_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*0.0+((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc)*Nsat_Vdi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*0.0+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc)/Nsat)*Mnud_Vdi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vdi_bi_Vsbulk_si=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsbulk_si+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vsbulk_si)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt_Vsbulk_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi_Vsbulk_si)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vsbulk_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vsbulk_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vsbulk_si)+qdeff_Vdi_bi_Vsbulk_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*0.0+((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc)*Nsat_Vdi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*0.0+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc)/Nsat)*Mnud_Vdi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vdi_bi_Vgi_bi=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vgi_bi)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*ueff_Vgi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*ueff_Vdi_bi_Vgi_bi)*Weff+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt_Vgi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi_Vgi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vgi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vgi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vgi_bi)+qdeff_Vdi_bi_Vgi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc_Vgi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi_Vgi_bi)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat_Vgi_bi+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi)))*Nsat_Vdi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi_Vgi_bi)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi*Nsat_Vgi_bi/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*Mnud_Vgi_bi+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*Mnud_Vdi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vdi_bi_Vgi_bi);
  ids_Vdi_bi_Tempt_GND=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Tempt_GND)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*ueff_Tempt_GND+((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*ueff_Vdi_bi_Tempt_GND)*Weff+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt_Tempt_GND+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi_Tempt_GND)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Tempt_GND+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Tempt_GND)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Tempt_GND)+qdeff_Vdi_bi_Tempt_GND)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc_Tempt_GND+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi_Tempt_GND)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat_Tempt_GND+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Tempt_GND)))*Nsat_Vdi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi_Tempt_GND)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi*Nsat_Tempt_GND/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*Mnud_Tempt_GND+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Tempt_GND)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Tempt_GND)/Nsat/Nsat)*Mnud_Vdi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vdi_bi_Tempt_GND);
  ids_Vdi_bi_Vdi_bi=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vdi_bi)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*ueff_Vdi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*ueff_Vdi_bi_Vdi_bi)*Weff+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt_Vdi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi_Vdi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vdi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vdi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vdi_bi)+qdeff_Vdi_bi_Vdi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc_Vdi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi_Vdi_bi)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat_Vdi_bi+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi)))*Nsat_Vdi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi_Vdi_bi)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi*Nsat_Vdi_bi/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*Mnud_Vdi_bi+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*Mnud_Vdi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vdi_bi_Vdi_bi);
  ids_Vdi_bi_Vsi_bi=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vsi_bi)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*ueff_Vsi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*ueff_Vdi_bi_Vsi_bi)*Weff+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt_Vsi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi_Vsi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vsi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vsi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vsi_bi)+qdeff_Vdi_bi_Vsi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc_Vsi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi_Vsi_bi)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat_Vsi_bi+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi)))*Nsat_Vdi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi_Vsi_bi)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi*Nsat_Vsi_bi/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*Mnud_Vsi_bi+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*Mnud_Vdi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vdi_bi_Vsi_bi);
#endif
ids_Vsi_bi=(((((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*Mnud)+((((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vsi_bi));
#if defined(_DERIVATE2)
  ids_Vsi_bi_Vgm_si=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_si+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vgm_si)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt_Vgm_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi_Vgm_si)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vgm_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vgm_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vgm_si-qdeff_Vsi_bi_Vgm_si)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgm_si+qdeff_Vgm_si)+(qs_Vgm_si-qdeff_Vgm_si)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vgm_si)+qdeff_Vsi_bi_Vgm_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*0.0+((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc)*Nsat_Vsi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*0.0+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc)/Nsat)*Mnud_Vsi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vsi_bi_Vgm_di=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_di+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vgm_di)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*0.0)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di))))+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vgm_di-qdeff_Vsi_bi_Vgm_di)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgm_di+qdeff_Vgm_di)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vgm_di)+qdeff_Vsi_bi_Vgm_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*0.0+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*0.0+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc)*Nsat_Vsi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*0.0+(((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc)/Nsat)*Mnud_Vsi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vsi_bi_Vdbulk_di=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdbulk_di+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vdbulk_di)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt_Vdbulk_di+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi_Vdbulk_di)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vdbulk_di+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vdbulk_di)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vdbulk_di)+qdeff_Vsi_bi_Vdbulk_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*0.0+((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc)*Nsat_Vsi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*0.0+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc)/Nsat)*Mnud_Vsi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vsi_bi_Vsbulk_si=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsbulk_si+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vsbulk_si)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*0.0)*Weff+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt_Vsbulk_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi_Vsbulk_si)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vsbulk_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vsbulk_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vsbulk_si)+qdeff_Vsi_bi_Vsbulk_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*0.0+((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc)*Nsat_Vsi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*0.0)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi*0.0/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*0.0+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc)/Nsat)*Mnud_Vsi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*0.0);
  ids_Vsi_bi_Vgi_bi=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vgi_bi)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*ueff_Vgi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*ueff_Vsi_bi_Vgi_bi)*Weff+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt_Vgi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi_Vgi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vgi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vgi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vgi_bi)+qdeff_Vsi_bi_Vgi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc_Vgi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi_Vgi_bi)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat_Vgi_bi+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi)))*Nsat_Vsi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi_Vgi_bi)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi*Nsat_Vgi_bi/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*Mnud_Vgi_bi+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vgi_bi)/Nsat/Nsat)*Mnud_Vsi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vsi_bi_Vgi_bi);
  ids_Vsi_bi_Tempt_GND=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Tempt_GND)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*ueff_Tempt_GND+((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*ueff_Vsi_bi_Tempt_GND)*Weff+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt_Tempt_GND+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi_Tempt_GND)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Tempt_GND+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Tempt_GND)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Tempt_GND)+qdeff_Vsi_bi_Tempt_GND)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc_Tempt_GND+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi_Tempt_GND)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat_Tempt_GND+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Tempt_GND)))*Nsat_Vsi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi_Tempt_GND)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi*Nsat_Tempt_GND/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*Mnud_Tempt_GND+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Tempt_GND)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Tempt_GND)/Nsat/Nsat)*Mnud_Vsi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vsi_bi_Tempt_GND);
  ids_Vsi_bi_Vdi_bi=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vdi_bi)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*ueff_Vdi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*ueff_Vsi_bi_Vdi_bi)*Weff+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt_Vdi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi_Vdi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vdi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vdi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vdi_bi)+qdeff_Vsi_bi_Vdi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc_Vdi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi_Vdi_bi)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat_Vdi_bi+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi)))*Nsat_Vsi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi_Vdi_bi)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi*Nsat_Vdi_bi/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*Mnud_Vdi_bi+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vdi_bi)/Nsat/Nsat)*Mnud_Vsi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vsi_bi_Vdi_bi);
  ids_Vsi_bi_Vsi_bi=(+((+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vsi_bi)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*ueff_Vsi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*ueff_Vsi_bi_Vsi_bi)*Weff+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)*0.0+((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt_Vsi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi_Vsi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vsi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vsi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vsi_bi)+qdeff_Vsi_bi_Vsi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc_Vsi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi_Vsi_bi)/Nsat-((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat_Vsi_bi+((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi)))*Nsat_Vsi_bi+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi_Vsi_bi)/Nsat/Nsat+2*((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi*Nsat_Vsi_bi/Nsat/Nsat/Nsat)*Mnud+(((((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*Weff/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*Mnud_Vsi_bi+((((((((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*Weff)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi)))*Nsat-((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*Nsat_Vsi_bi)/Nsat/Nsat)*Mnud_Vsi_bi+(((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud_Vsi_bi_Vsi_bi);
#endif
#endif
ids=((((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud);
EXIT_IF_ISNAN(((((((((((((2.0*pInst->NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat)*Mnud))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
ids_Vgm_si=0.0;
#if defined(_DERIVATE2)
  ids_Vgm_si_Vgm_si=0.0;
  ids_Vgm_si_Vgm_di=0.0;
  ids_Vgm_si_Vdbulk_di=0.0;
  ids_Vgm_si_Vsbulk_si=0.0;
  ids_Vgm_si_Vgi_bi=0.0;
  ids_Vgm_si_Tempt_GND=0.0;
  ids_Vgm_si_Vdi_bi=0.0;
  ids_Vgm_si_Vsi_bi=0.0;
#endif
ids_Vgm_di=0.0;
#if defined(_DERIVATE2)
  ids_Vgm_di_Vgm_si=0.0;
  ids_Vgm_di_Vgm_di=0.0;
  ids_Vgm_di_Vdbulk_di=0.0;
  ids_Vgm_di_Vsbulk_si=0.0;
  ids_Vgm_di_Vgi_bi=0.0;
  ids_Vgm_di_Tempt_GND=0.0;
  ids_Vgm_di_Vdi_bi=0.0;
  ids_Vgm_di_Vsi_bi=0.0;
#endif
ids_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  ids_Vdbulk_di_Vgm_si=0.0;
  ids_Vdbulk_di_Vgm_di=0.0;
  ids_Vdbulk_di_Vdbulk_di=0.0;
  ids_Vdbulk_di_Vsbulk_si=0.0;
  ids_Vdbulk_di_Vgi_bi=0.0;
  ids_Vdbulk_di_Tempt_GND=0.0;
  ids_Vdbulk_di_Vdi_bi=0.0;
  ids_Vdbulk_di_Vsi_bi=0.0;
#endif
ids_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  ids_Vsbulk_si_Vgm_si=0.0;
  ids_Vsbulk_si_Vgm_di=0.0;
  ids_Vsbulk_si_Vdbulk_di=0.0;
  ids_Vsbulk_si_Vsbulk_si=0.0;
  ids_Vsbulk_si_Vgi_bi=0.0;
  ids_Vsbulk_si_Tempt_GND=0.0;
  ids_Vsbulk_si_Vdi_bi=0.0;
  ids_Vsbulk_si_Vsi_bi=0.0;
#endif
ids_Vgi_bi=ids_Vgi_bi*pInst->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Vgi_bi_Vgm_si=(+ids_Vgi_bi_Vgm_si*pInst->IDS0MULT+ids_Vgi_bi*0.0+ids_Vgm_si*0.0+ids*0.0);
  ids_Vgi_bi_Vgm_di=(+ids_Vgi_bi_Vgm_di*pInst->IDS0MULT+ids_Vgi_bi*0.0+ids_Vgm_di*0.0+ids*0.0);
  ids_Vgi_bi_Vdbulk_di=(+ids_Vgi_bi_Vdbulk_di*pInst->IDS0MULT+ids_Vgi_bi*0.0+ids_Vdbulk_di*0.0+ids*0.0);
  ids_Vgi_bi_Vsbulk_si=(+ids_Vgi_bi_Vsbulk_si*pInst->IDS0MULT+ids_Vgi_bi*0.0+ids_Vsbulk_si*0.0+ids*0.0);
  ids_Vgi_bi_Vgi_bi=(+ids_Vgi_bi_Vgi_bi*pInst->IDS0MULT+ids_Vgi_bi*0.0+ids_Vgi_bi*0.0+ids*0.0);
  ids_Vgi_bi_Tempt_GND=(+ids_Vgi_bi_Tempt_GND*pInst->IDS0MULT+ids_Vgi_bi*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Vgi_bi_Vdi_bi=(+ids_Vgi_bi_Vdi_bi*pInst->IDS0MULT+ids_Vgi_bi*0.0+ids_Vdi_bi*0.0+ids*0.0);
  ids_Vgi_bi_Vsi_bi=(+ids_Vgi_bi_Vsi_bi*pInst->IDS0MULT+ids_Vgi_bi*0.0+ids_Vsi_bi*0.0+ids*0.0);
#endif
#if defined(_DERIVATE)
ids_Tempt_GND=ids_Tempt_GND*pInst->IDS0MULT;
#endif
ids_Vdi_bi=ids_Vdi_bi*pInst->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Vdi_bi_Vgm_si=(+ids_Vdi_bi_Vgm_si*pInst->IDS0MULT+ids_Vdi_bi*0.0+ids_Vgm_si*0.0+ids*0.0);
  ids_Vdi_bi_Vgm_di=(+ids_Vdi_bi_Vgm_di*pInst->IDS0MULT+ids_Vdi_bi*0.0+ids_Vgm_di*0.0+ids*0.0);
  ids_Vdi_bi_Vdbulk_di=(+ids_Vdi_bi_Vdbulk_di*pInst->IDS0MULT+ids_Vdi_bi*0.0+ids_Vdbulk_di*0.0+ids*0.0);
  ids_Vdi_bi_Vsbulk_si=(+ids_Vdi_bi_Vsbulk_si*pInst->IDS0MULT+ids_Vdi_bi*0.0+ids_Vsbulk_si*0.0+ids*0.0);
  ids_Vdi_bi_Vgi_bi=(+ids_Vdi_bi_Vgi_bi*pInst->IDS0MULT+ids_Vdi_bi*0.0+ids_Vgi_bi*0.0+ids*0.0);
  ids_Vdi_bi_Tempt_GND=(+ids_Vdi_bi_Tempt_GND*pInst->IDS0MULT+ids_Vdi_bi*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Vdi_bi_Vdi_bi=(+ids_Vdi_bi_Vdi_bi*pInst->IDS0MULT+ids_Vdi_bi*0.0+ids_Vdi_bi*0.0+ids*0.0);
  ids_Vdi_bi_Vsi_bi=(+ids_Vdi_bi_Vsi_bi*pInst->IDS0MULT+ids_Vdi_bi*0.0+ids_Vsi_bi*0.0+ids*0.0);
#endif
ids_Vsi_bi=ids_Vsi_bi*pInst->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Vsi_bi_Vgm_si=(+ids_Vsi_bi_Vgm_si*pInst->IDS0MULT+ids_Vsi_bi*0.0+ids_Vgm_si*0.0+ids*0.0);
  ids_Vsi_bi_Vgm_di=(+ids_Vsi_bi_Vgm_di*pInst->IDS0MULT+ids_Vsi_bi*0.0+ids_Vgm_di*0.0+ids*0.0);
  ids_Vsi_bi_Vdbulk_di=(+ids_Vsi_bi_Vdbulk_di*pInst->IDS0MULT+ids_Vsi_bi*0.0+ids_Vdbulk_di*0.0+ids*0.0);
  ids_Vsi_bi_Vsbulk_si=(+ids_Vsi_bi_Vsbulk_si*pInst->IDS0MULT+ids_Vsi_bi*0.0+ids_Vsbulk_si*0.0+ids*0.0);
  ids_Vsi_bi_Vgi_bi=(+ids_Vsi_bi_Vgi_bi*pInst->IDS0MULT+ids_Vsi_bi*0.0+ids_Vgi_bi*0.0+ids*0.0);
  ids_Vsi_bi_Tempt_GND=(+ids_Vsi_bi_Tempt_GND*pInst->IDS0MULT+ids_Vsi_bi*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Vsi_bi_Vdi_bi=(+ids_Vsi_bi_Vdi_bi*pInst->IDS0MULT+ids_Vsi_bi*0.0+ids_Vdi_bi*0.0+ids*0.0);
  ids_Vsi_bi_Vsi_bi=(+ids_Vsi_bi_Vsi_bi*pInst->IDS0MULT+ids_Vsi_bi*0.0+ids_Vsi_bi*0.0+ids*0.0);
#endif
#endif
ids=(ids*pInst->IDS0MULT);
EXIT_IF_ISNAN((ids*pInst->IDS0MULT))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Gcrg_Vgi_bi=0.0;
Gcrg_Vdi_bi=0.0;
Gcrg_Vsi_bi=0.0;
Gcrg_Tempt_GND=0.0;
#endif
Gcrg=0.0;
EXIT_IF_ISNAN(0.0)
if
((pInst->RGATEMOD>1))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe= */
idsovvds_Tempt_GND=(((ueff_Tempt_GND*Weff/Leff)*Cox*qia)+((((ueff*Weff)/Leff)*Cox)*qia_Tempt_GND));
idsovvds_Vdi_bi=(((ueff_Vdi_bi*Weff/Leff)*Cox*qia)+((((ueff*Weff)/Leff)*Cox)*qia_Vdi_bi));
idsovvds_Vsi_bi=(((ueff_Vsi_bi*Weff/Leff)*Cox*qia)+((((ueff*Weff)/Leff)*Cox)*qia_Vsi_bi));
idsovvds_Vgi_bi=(((ueff_Vgi_bi*Weff/Leff)*Cox*qia)+((((ueff*Weff)/Leff)*Cox)*qia_Vgi_bi));
#endif
idsovvds=((((ueff*Weff)/Leff)*Cox)*qia);
EXIT_IF_ISNAN(((((ueff*Weff)/Leff)*Cox)*qia))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=0.0;
  T9_Vdbulk_di_Vgm_di=0.0;
  T9_Vdbulk_di_Vdbulk_di=0.0;
  T9_Vdbulk_di_Vsbulk_si=0.0;
  T9_Vdbulk_di_Vdi_bi=0.0;
  T9_Vdbulk_di_Vsi_bi=0.0;
  T9_Vdbulk_di_Tempt_GND=0.0;
  T9_Vdbulk_di_Vgi_bi=0.0;
#endif
T9_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=0.0;
  T9_Vsbulk_si_Vgm_di=0.0;
  T9_Vsbulk_si_Vdbulk_di=0.0;
  T9_Vsbulk_si_Vsbulk_si=0.0;
  T9_Vsbulk_si_Vdi_bi=0.0;
  T9_Vsbulk_si_Vsi_bi=0.0;
  T9_Vsbulk_si_Tempt_GND=0.0;
  T9_Vsbulk_si_Vgi_bi=0.0;
#endif
T9_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=0.0;
  T9_Vdi_bi_Vgm_di=0.0;
  T9_Vdi_bi_Vdbulk_di=0.0;
  T9_Vdi_bi_Vsbulk_si=0.0;
  T9_Vdi_bi_Vdi_bi=0.0;
  T9_Vdi_bi_Vsi_bi=0.0;
  T9_Vdi_bi_Tempt_GND=0.0;
  T9_Vdi_bi_Vgi_bi=0.0;
#endif
T9_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=0.0;
  T9_Vsi_bi_Vgm_di=0.0;
  T9_Vsi_bi_Vdbulk_di=0.0;
  T9_Vsi_bi_Vsbulk_si=0.0;
  T9_Vsi_bi_Vdi_bi=0.0;
  T9_Vsi_bi_Vsi_bi=0.0;
  T9_Vsi_bi_Tempt_GND=0.0;
  T9_Vsi_bi_Vgi_bi=0.0;
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=(pModel->XRCRG2*Vt_Tempt_GND);
#endif
T9_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=0.0;
  T9_Vgi_bi_Vgm_di=0.0;
  T9_Vgi_bi_Vdbulk_di=0.0;
  T9_Vgi_bi_Vsbulk_si=0.0;
  T9_Vgi_bi_Vdi_bi=0.0;
  T9_Vgi_bi_Vsi_bi=0.0;
  T9_Vgi_bi_Tempt_GND=0.0;
  T9_Vgi_bi_Vgi_bi=0.0;
#endif
#endif
T9=(pModel->XRCRG2*Vt);
EXIT_IF_ISNAN((pModel->XRCRG2*Vt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff/Leff)*Cox;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+((+(+T9_Vgi_bi_Vgm_di*ueff+T9_Vgi_bi*0.0+T9_Vgm_di*ueff_Vgi_bi+T9*0.0)*Weff+((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*0.0+(T9_Vgm_di*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff*0.0+((T9_Vgm_di*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff/Leff)*0.0+(((T9_Vgm_di*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vgi_bi_Vgm_si=(+((+(+T9_Vgi_bi_Vgm_si*ueff+T9_Vgi_bi*0.0+T9_Vgm_si*ueff_Vgi_bi+T9*0.0)*Weff+((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*0.0+(T9_Vgm_si*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff*0.0+((T9_Vgm_si*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff/Leff)*0.0+(((T9_Vgm_si*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vgi_bi_Vdbulk_di=(+((+(+T9_Vgi_bi_Vdbulk_di*ueff+T9_Vgi_bi*0.0+T9_Vdbulk_di*ueff_Vgi_bi+T9*0.0)*Weff+((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*0.0+(T9_Vdbulk_di*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff*0.0+((T9_Vdbulk_di*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff/Leff)*0.0+(((T9_Vdbulk_di*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vgi_bi_Vsbulk_si=(+((+(+T9_Vgi_bi_Vsbulk_si*ueff+T9_Vgi_bi*0.0+T9_Vsbulk_si*ueff_Vgi_bi+T9*0.0)*Weff+((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*0.0+(T9_Vsbulk_si*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff*0.0+((T9_Vsbulk_si*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff/Leff)*0.0+(((T9_Vsbulk_si*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vgi_bi_Vgi_bi=(+((+(+T9_Vgi_bi_Vgi_bi*ueff+T9_Vgi_bi*ueff_Vgi_bi+T9_Vgi_bi*ueff_Vgi_bi+T9*ueff_Vgi_bi_Vgi_bi)*Weff+((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*0.0+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff*0.0+((((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vgi_bi_Vdi_bi=(+((+(+T9_Vgi_bi_Vdi_bi*ueff+T9_Vgi_bi*ueff_Vdi_bi+T9_Vdi_bi*ueff_Vgi_bi+T9*ueff_Vgi_bi_Vdi_bi)*Weff+((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*0.0+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff*0.0+((((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vgi_bi_Vsi_bi=(+((+(+T9_Vgi_bi_Vsi_bi*ueff+T9_Vgi_bi*ueff_Vsi_bi+T9_Vsi_bi*ueff_Vgi_bi+T9*ueff_Vgi_bi_Vsi_bi)*Weff+((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*0.0+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff*0.0+((((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vgi_bi_Tempt_GND=(+((+(+T9_Vgi_bi_Tempt_GND*ueff+T9_Vgi_bi*ueff_Tempt_GND+T9_Tempt_GND*ueff_Vgi_bi+T9*ueff_Vgi_bi_Tempt_GND)*Weff+((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*0.0+(((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff*0.0+((((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi))*Weff/Leff)*0.0+(((((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
#endif
T0_Vdi_bi=(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff/Leff)*Cox;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+((+(+T9_Vdi_bi_Vgm_di*ueff+T9_Vdi_bi*0.0+T9_Vgm_di*ueff_Vdi_bi+T9*0.0)*Weff+((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*0.0+(T9_Vgm_di*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff*0.0+((T9_Vgm_di*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff/Leff)*0.0+(((T9_Vgm_di*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vdi_bi_Vgm_si=(+((+(+T9_Vdi_bi_Vgm_si*ueff+T9_Vdi_bi*0.0+T9_Vgm_si*ueff_Vdi_bi+T9*0.0)*Weff+((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*0.0+(T9_Vgm_si*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff*0.0+((T9_Vgm_si*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff/Leff)*0.0+(((T9_Vgm_si*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vdi_bi_Vdbulk_di=(+((+(+T9_Vdi_bi_Vdbulk_di*ueff+T9_Vdi_bi*0.0+T9_Vdbulk_di*ueff_Vdi_bi+T9*0.0)*Weff+((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*0.0+(T9_Vdbulk_di*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff*0.0+((T9_Vdbulk_di*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff/Leff)*0.0+(((T9_Vdbulk_di*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vdi_bi_Vsbulk_si=(+((+(+T9_Vdi_bi_Vsbulk_si*ueff+T9_Vdi_bi*0.0+T9_Vsbulk_si*ueff_Vdi_bi+T9*0.0)*Weff+((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*0.0+(T9_Vsbulk_si*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff*0.0+((T9_Vsbulk_si*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff/Leff)*0.0+(((T9_Vsbulk_si*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vdi_bi_Vgi_bi=(+((+(+T9_Vdi_bi_Vgi_bi*ueff+T9_Vdi_bi*ueff_Vgi_bi+T9_Vgi_bi*ueff_Vdi_bi+T9*ueff_Vdi_bi_Vgi_bi)*Weff+((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*0.0+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff*0.0+((((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vdi_bi_Vdi_bi=(+((+(+T9_Vdi_bi_Vdi_bi*ueff+T9_Vdi_bi*ueff_Vdi_bi+T9_Vdi_bi*ueff_Vdi_bi+T9*ueff_Vdi_bi_Vdi_bi)*Weff+((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*0.0+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff*0.0+((((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vdi_bi_Vsi_bi=(+((+(+T9_Vdi_bi_Vsi_bi*ueff+T9_Vdi_bi*ueff_Vsi_bi+T9_Vsi_bi*ueff_Vdi_bi+T9*ueff_Vdi_bi_Vsi_bi)*Weff+((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*0.0+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff*0.0+((((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vdi_bi_Tempt_GND=(+((+(+T9_Vdi_bi_Tempt_GND*ueff+T9_Vdi_bi*ueff_Tempt_GND+T9_Tempt_GND*ueff_Vdi_bi+T9*ueff_Vdi_bi_Tempt_GND)*Weff+((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*0.0+(((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff*0.0+((((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi))*Weff/Leff)*0.0+(((((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
#endif
T0_Vsi_bi=(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff/Leff)*Cox;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+((+(+T9_Vsi_bi_Vgm_di*ueff+T9_Vsi_bi*0.0+T9_Vgm_di*ueff_Vsi_bi+T9*0.0)*Weff+((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*0.0+(T9_Vgm_di*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff*0.0+((T9_Vgm_di*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff/Leff)*0.0+(((T9_Vgm_di*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vsi_bi_Vgm_si=(+((+(+T9_Vsi_bi_Vgm_si*ueff+T9_Vsi_bi*0.0+T9_Vgm_si*ueff_Vsi_bi+T9*0.0)*Weff+((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*0.0+(T9_Vgm_si*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff*0.0+((T9_Vgm_si*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff/Leff)*0.0+(((T9_Vgm_si*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vsi_bi_Vdbulk_di=(+((+(+T9_Vsi_bi_Vdbulk_di*ueff+T9_Vsi_bi*0.0+T9_Vdbulk_di*ueff_Vsi_bi+T9*0.0)*Weff+((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*0.0+(T9_Vdbulk_di*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff*0.0+((T9_Vdbulk_di*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff/Leff)*0.0+(((T9_Vdbulk_di*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vsi_bi_Vsbulk_si=(+((+(+T9_Vsi_bi_Vsbulk_si*ueff+T9_Vsi_bi*0.0+T9_Vsbulk_si*ueff_Vsi_bi+T9*0.0)*Weff+((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*0.0+(T9_Vsbulk_si*ueff)*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff*0.0+((T9_Vsbulk_si*ueff)*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff/Leff)*0.0+(((T9_Vsbulk_si*ueff)*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vsi_bi_Vgi_bi=(+((+(+T9_Vsi_bi_Vgi_bi*ueff+T9_Vsi_bi*ueff_Vgi_bi+T9_Vgi_bi*ueff_Vsi_bi+T9*ueff_Vsi_bi_Vgi_bi)*Weff+((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*0.0+(((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff*0.0+((((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((T9_Vgi_bi*ueff)+(T9*ueff_Vgi_bi)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vsi_bi_Vdi_bi=(+((+(+T9_Vsi_bi_Vdi_bi*ueff+T9_Vsi_bi*ueff_Vdi_bi+T9_Vdi_bi*ueff_Vsi_bi+T9*ueff_Vsi_bi_Vdi_bi)*Weff+((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*0.0+(((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff*0.0+((((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((T9_Vdi_bi*ueff)+(T9*ueff_Vdi_bi)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vsi_bi_Vsi_bi=(+((+(+T9_Vsi_bi_Vsi_bi*ueff+T9_Vsi_bi*ueff_Vsi_bi+T9_Vsi_bi*ueff_Vsi_bi+T9*ueff_Vsi_bi_Vsi_bi)*Weff+((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*0.0+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff*0.0+((((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
  T0_Vsi_bi_Tempt_GND=(+((+(+T9_Vsi_bi_Tempt_GND*ueff+T9_Vsi_bi*ueff_Tempt_GND+T9_Tempt_GND*ueff_Vsi_bi+T9*ueff_Vsi_bi_Tempt_GND)*Weff+((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*0.0+(((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND)))*0.0+(T9*ueff)*0.0)/Leff-(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff*0.0+((((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND)))*Weff)*0.0+((T9*ueff)*Weff)*0.0)/Leff/Leff+2*((T9*ueff)*Weff)*0.0*0.0/Leff/Leff/Leff)*Cox+(((T9_Vsi_bi*ueff)+(T9*ueff_Vsi_bi))*Weff/Leff)*0.0+(((((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND)))*Weff)/Leff)*0.0+(((T9*ueff)*Weff)/Leff)*0.0);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(((T9_Tempt_GND*ueff)+(T9*ueff_Tempt_GND))*Weff/Leff)*Cox;
#endif
#endif
T0=((((T9*ueff)*Weff)/Leff)*Cox);
EXIT_IF_ISNAN(((((T9*ueff)*Weff)/Leff)*Cox))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Gcrg_Vgi_bi=((pModel->XRCRG1*pInst->NF)*(T0_Vgi_bi+idsovvds_Vgi_bi));
Gcrg_Vdi_bi=((pModel->XRCRG1*pInst->NF)*(T0_Vdi_bi+idsovvds_Vdi_bi));
Gcrg_Vsi_bi=((pModel->XRCRG1*pInst->NF)*(T0_Vsi_bi+idsovvds_Vsi_bi));
Gcrg_Tempt_GND=((pModel->XRCRG1*pInst->NF)*(T0_Tempt_GND+idsovvds_Tempt_GND));
#endif
Gcrg=((pModel->XRCRG1*pInst->NF)*(T0+idsovvds));
EXIT_IF_ISNAN(((pModel->XRCRG1*pInst->NF)*(T0+idsovvds)))
if
((pInst->RGATEMOD==2))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T11_Vgi_bi=Gcrg_Vgi_bi;
#if defined(_DERIVATE2)
  T11_Vgi_bi_Vgi_bi=(+0.0+Gcrg_Vgi_bi_Vgi_bi);
  T11_Vgi_bi_Tempt_GND=(+0.0+Gcrg_Vgi_bi_Tempt_GND);
  T11_Vgi_bi_Vdi_bi=(+0.0+Gcrg_Vgi_bi_Vdi_bi);
  T11_Vgi_bi_Vsi_bi=(+0.0+Gcrg_Vgi_bi_Vsi_bi);
#endif
#if defined(_DERIVATE)
T11_Tempt_GND=Gcrg_Tempt_GND;
#endif
T11_Vdi_bi=Gcrg_Vdi_bi;
#if defined(_DERIVATE2)
  T11_Vdi_bi_Vgi_bi=(+0.0+Gcrg_Vdi_bi_Vgi_bi);
  T11_Vdi_bi_Tempt_GND=(+0.0+Gcrg_Vdi_bi_Tempt_GND);
  T11_Vdi_bi_Vdi_bi=(+0.0+Gcrg_Vdi_bi_Vdi_bi);
  T11_Vdi_bi_Vsi_bi=(+0.0+Gcrg_Vdi_bi_Vsi_bi);
#endif
T11_Vsi_bi=Gcrg_Vsi_bi;
#if defined(_DERIVATE2)
  T11_Vsi_bi_Vgi_bi=(+0.0+Gcrg_Vsi_bi_Vgi_bi);
  T11_Vsi_bi_Tempt_GND=(+0.0+Gcrg_Vsi_bi_Tempt_GND);
  T11_Vsi_bi_Vdi_bi=(+0.0+Gcrg_Vsi_bi_Vdi_bi);
  T11_Vsi_bi_Vsi_bi=(+0.0+Gcrg_Vsi_bi_Vsi_bi);
#endif
#endif
T11=(Grgeltd+Gcrg);
EXIT_IF_ISNAN((Grgeltd+Gcrg))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Gcrg_Vgi_bi=(((Grgeltd*Gcrg_Vgi_bi)*T11-(Grgeltd*Gcrg)*T11_Vgi_bi)/T11/T11);
Gcrg_Vdi_bi=(((Grgeltd*Gcrg_Vdi_bi)*T11-(Grgeltd*Gcrg)*T11_Vdi_bi)/T11/T11);
Gcrg_Vsi_bi=(((Grgeltd*Gcrg_Vsi_bi)*T11-(Grgeltd*Gcrg)*T11_Vsi_bi)/T11/T11);
Gcrg_Tempt_GND=(((Grgeltd*Gcrg_Tempt_GND)*T11-(Grgeltd*Gcrg)*T11_Tempt_GND)/T11/T11);
#endif
Gcrg=((Grgeltd*Gcrg)/T11);
EXIT_IF_ISNAN(((Grgeltd*Gcrg)/T11))
}
}
if
(((ALPHA0_i<=0.0)||(BETA0_t<=0.0)))
{
#if defined(_DERIVATE) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe= */
Iii_Vdi_bi=0.0;
Iii_Vsi_bi=0.0;
Iii_Vgi_bi=0.0;
Iii_Tempt_GND=0.0;
#endif
Iii=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
if
((diffVds>(BETA0_t/80.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(-(-BETA0_t)*diffVds_Vgi_bi/diffVds/diffVds);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(0.0/diffVds-(0.0*0.0+0.0*diffVds_Vgi_bi+(-BETA0_t)*0.0)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vgi_bi*0.0/diffVds/diffVds/diffVds);
  T1_Vgi_bi_Vgm_si=(0.0/diffVds-(0.0*0.0+0.0*diffVds_Vgi_bi+(-BETA0_t)*0.0)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vgi_bi*0.0/diffVds/diffVds/diffVds);
  T1_Vgi_bi_Vdbulk_di=(0.0/diffVds-(0.0*diffVds_Vdbulk_di+0.0*diffVds_Vgi_bi+(-BETA0_t)*diffVds_Vgi_bi_Vdbulk_di)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vgi_bi*diffVds_Vdbulk_di/diffVds/diffVds/diffVds);
  T1_Vgi_bi_Vsbulk_si=(0.0/diffVds-(0.0*diffVds_Vsbulk_si+0.0*diffVds_Vgi_bi+(-BETA0_t)*diffVds_Vgi_bi_Vsbulk_si)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vgi_bi*diffVds_Vsbulk_si/diffVds/diffVds/diffVds);
  T1_Vgi_bi_Vgi_bi=(0.0/diffVds-(0.0*diffVds_Vgi_bi+0.0*diffVds_Vgi_bi+(-BETA0_t)*diffVds_Vgi_bi_Vgi_bi)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vgi_bi*diffVds_Vgi_bi/diffVds/diffVds/diffVds);
  T1_Vgi_bi_Vdi_bi=(0.0/diffVds-(0.0*diffVds_Vdi_bi+0.0*diffVds_Vgi_bi+(-BETA0_t)*diffVds_Vgi_bi_Vdi_bi)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vgi_bi*diffVds_Vdi_bi/diffVds/diffVds/diffVds);
  T1_Vgi_bi_Vsi_bi=(0.0/diffVds-(0.0*diffVds_Vsi_bi+0.0*diffVds_Vgi_bi+(-BETA0_t)*diffVds_Vgi_bi_Vsi_bi)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vgi_bi*diffVds_Vsi_bi/diffVds/diffVds/diffVds);
  T1_Vgi_bi_Tempt_GND=(0.0/diffVds-(0.0*diffVds_Tempt_GND+(-BETA0_t_Tempt_GND)*diffVds_Vgi_bi+(-BETA0_t)*diffVds_Vgi_bi_Tempt_GND)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vgi_bi*diffVds_Tempt_GND/diffVds/diffVds/diffVds);
#endif
T1_Vdi_bi=(-(-BETA0_t)*diffVds_Vdi_bi/diffVds/diffVds);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(0.0/diffVds-(0.0*0.0+0.0*diffVds_Vdi_bi+(-BETA0_t)*0.0)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vdi_bi*0.0/diffVds/diffVds/diffVds);
  T1_Vdi_bi_Vgm_si=(0.0/diffVds-(0.0*0.0+0.0*diffVds_Vdi_bi+(-BETA0_t)*0.0)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vdi_bi*0.0/diffVds/diffVds/diffVds);
  T1_Vdi_bi_Vdbulk_di=(0.0/diffVds-(0.0*diffVds_Vdbulk_di+0.0*diffVds_Vdi_bi+(-BETA0_t)*diffVds_Vdi_bi_Vdbulk_di)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vdi_bi*diffVds_Vdbulk_di/diffVds/diffVds/diffVds);
  T1_Vdi_bi_Vsbulk_si=(0.0/diffVds-(0.0*diffVds_Vsbulk_si+0.0*diffVds_Vdi_bi+(-BETA0_t)*diffVds_Vdi_bi_Vsbulk_si)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vdi_bi*diffVds_Vsbulk_si/diffVds/diffVds/diffVds);
  T1_Vdi_bi_Vgi_bi=(0.0/diffVds-(0.0*diffVds_Vgi_bi+0.0*diffVds_Vdi_bi+(-BETA0_t)*diffVds_Vdi_bi_Vgi_bi)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vdi_bi*diffVds_Vgi_bi/diffVds/diffVds/diffVds);
  T1_Vdi_bi_Vdi_bi=(0.0/diffVds-(0.0*diffVds_Vdi_bi+0.0*diffVds_Vdi_bi+(-BETA0_t)*diffVds_Vdi_bi_Vdi_bi)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vdi_bi*diffVds_Vdi_bi/diffVds/diffVds/diffVds);
  T1_Vdi_bi_Vsi_bi=(0.0/diffVds-(0.0*diffVds_Vsi_bi+0.0*diffVds_Vdi_bi+(-BETA0_t)*diffVds_Vdi_bi_Vsi_bi)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vdi_bi*diffVds_Vsi_bi/diffVds/diffVds/diffVds);
  T1_Vdi_bi_Tempt_GND=(0.0/diffVds-(0.0*diffVds_Tempt_GND+(-BETA0_t_Tempt_GND)*diffVds_Vdi_bi+(-BETA0_t)*diffVds_Vdi_bi_Tempt_GND)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vdi_bi*diffVds_Tempt_GND/diffVds/diffVds/diffVds);
#endif
T1_Vsi_bi=(-(-BETA0_t)*diffVds_Vsi_bi/diffVds/diffVds);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(0.0/diffVds-(0.0*0.0+0.0*diffVds_Vsi_bi+(-BETA0_t)*0.0)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vsi_bi*0.0/diffVds/diffVds/diffVds);
  T1_Vsi_bi_Vgm_si=(0.0/diffVds-(0.0*0.0+0.0*diffVds_Vsi_bi+(-BETA0_t)*0.0)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vsi_bi*0.0/diffVds/diffVds/diffVds);
  T1_Vsi_bi_Vdbulk_di=(0.0/diffVds-(0.0*diffVds_Vdbulk_di+0.0*diffVds_Vsi_bi+(-BETA0_t)*diffVds_Vsi_bi_Vdbulk_di)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vsi_bi*diffVds_Vdbulk_di/diffVds/diffVds/diffVds);
  T1_Vsi_bi_Vsbulk_si=(0.0/diffVds-(0.0*diffVds_Vsbulk_si+0.0*diffVds_Vsi_bi+(-BETA0_t)*diffVds_Vsi_bi_Vsbulk_si)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vsi_bi*diffVds_Vsbulk_si/diffVds/diffVds/diffVds);
  T1_Vsi_bi_Vgi_bi=(0.0/diffVds-(0.0*diffVds_Vgi_bi+0.0*diffVds_Vsi_bi+(-BETA0_t)*diffVds_Vsi_bi_Vgi_bi)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vsi_bi*diffVds_Vgi_bi/diffVds/diffVds/diffVds);
  T1_Vsi_bi_Vdi_bi=(0.0/diffVds-(0.0*diffVds_Vdi_bi+0.0*diffVds_Vsi_bi+(-BETA0_t)*diffVds_Vsi_bi_Vdi_bi)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vsi_bi*diffVds_Vdi_bi/diffVds/diffVds/diffVds);
  T1_Vsi_bi_Vsi_bi=(0.0/diffVds-(0.0*diffVds_Vsi_bi+0.0*diffVds_Vsi_bi+(-BETA0_t)*diffVds_Vsi_bi_Vsi_bi)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vsi_bi*diffVds_Vsi_bi/diffVds/diffVds/diffVds);
  T1_Vsi_bi_Tempt_GND=(0.0/diffVds-(0.0*diffVds_Tempt_GND+(-BETA0_t_Tempt_GND)*diffVds_Vsi_bi+(-BETA0_t)*diffVds_Vsi_bi_Tempt_GND)/diffVds/diffVds+2*(-BETA0_t)*diffVds_Vsi_bi*diffVds_Tempt_GND/diffVds/diffVds/diffVds);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((-BETA0_t_Tempt_GND)*diffVds-(-BETA0_t)*diffVds_Tempt_GND)/diffVds/diffVds);
#endif
#endif
T1=((-BETA0_t)/diffVds);
EXIT_IF_ISNAN(((-BETA0_t)/diffVds))
#if defined(_DERIVATE) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe= */
Iii_Vdi_bi=(((((((ALPHA0_i*diffVds_Vdi_bi)*ids)+((ALPHA0_i*diffVds)*ids_Vdi_bi))*bsimbulk_lexp(T1))+(((ALPHA0_i*diffVds)*ids)*bsimbulk_d_lexp(T1,T1_Vdi_bi)))*Mscbe-(((ALPHA0_i*diffVds)*ids)*bsimbulk_lexp(T1))*Mscbe_Vdi_bi)/Mscbe/Mscbe);
Iii_Vsi_bi=(((((((ALPHA0_i*diffVds_Vsi_bi)*ids)+((ALPHA0_i*diffVds)*ids_Vsi_bi))*bsimbulk_lexp(T1))+(((ALPHA0_i*diffVds)*ids)*bsimbulk_d_lexp(T1,T1_Vsi_bi)))*Mscbe-(((ALPHA0_i*diffVds)*ids)*bsimbulk_lexp(T1))*Mscbe_Vsi_bi)/Mscbe/Mscbe);
Iii_Vgi_bi=(((((((ALPHA0_i*diffVds_Vgi_bi)*ids)+((ALPHA0_i*diffVds)*ids_Vgi_bi))*bsimbulk_lexp(T1))+(((ALPHA0_i*diffVds)*ids)*bsimbulk_d_lexp(T1,T1_Vgi_bi)))*Mscbe-(((ALPHA0_i*diffVds)*ids)*bsimbulk_lexp(T1))*Mscbe_Vgi_bi)/Mscbe/Mscbe);
Iii_Tempt_GND=(((((((ALPHA0_i*diffVds_Tempt_GND)*ids)+((ALPHA0_i*diffVds)*ids_Tempt_GND))*bsimbulk_lexp(T1))+(((ALPHA0_i*diffVds)*ids)*bsimbulk_d_lexp(T1,T1_Tempt_GND)))*Mscbe-(((ALPHA0_i*diffVds)*ids)*bsimbulk_lexp(T1))*Mscbe_Tempt_GND)/Mscbe/Mscbe);
#endif
Iii=((((ALPHA0_i*diffVds)*ids)*bsimbulk_lexp(T1))/Mscbe);
EXIT_IF_ISNAN(((((ALPHA0_i*diffVds)*ids)*bsimbulk_lexp(T1))/Mscbe))
}
else
{
#if defined(_DERIVATE) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe= */
Iii_Vdi_bi=(((((ALPHA0_i*diffVds_Vdi_bi)*ids)+((ALPHA0_i*diffVds)*ids_Vdi_bi))*1.804851387e-35*Mscbe-(((ALPHA0_i*diffVds)*ids)*1.804851387e-35)*Mscbe_Vdi_bi)/Mscbe/Mscbe);
Iii_Vsi_bi=(((((ALPHA0_i*diffVds_Vsi_bi)*ids)+((ALPHA0_i*diffVds)*ids_Vsi_bi))*1.804851387e-35*Mscbe-(((ALPHA0_i*diffVds)*ids)*1.804851387e-35)*Mscbe_Vsi_bi)/Mscbe/Mscbe);
Iii_Vgi_bi=(((((ALPHA0_i*diffVds_Vgi_bi)*ids)+((ALPHA0_i*diffVds)*ids_Vgi_bi))*1.804851387e-35*Mscbe-(((ALPHA0_i*diffVds)*ids)*1.804851387e-35)*Mscbe_Vgi_bi)/Mscbe/Mscbe);
Iii_Tempt_GND=(((((ALPHA0_i*diffVds_Tempt_GND)*ids)+((ALPHA0_i*diffVds)*ids_Tempt_GND))*1.804851387e-35*Mscbe-(((ALPHA0_i*diffVds)*ids)*1.804851387e-35)*Mscbe_Tempt_GND)/Mscbe/Mscbe);
#endif
Iii=((((ALPHA0_i*diffVds)*ids)*1.804851387e-35)/Mscbe);
EXIT_IF_ISNAN(((((ALPHA0_i*diffVds)*ids)*1.804851387e-35)/Mscbe))
}
}
#if defined(_DERIVATE) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe= */
ISUB_Vdi_bi=Iii_Vdi_bi*devsign;
ISUB_Vsi_bi=Iii_Vsi_bi*devsign;
ISUB_Vgi_bi=Iii_Vgi_bi*devsign;
ISUB_Tempt_GND=Iii_Tempt_GND*devsign;
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB]=(Iii*devsign);
EXIT_IF_ISNAN((Iii*devsign))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igbinv_Vgi_bi=0.0;
igbinv_Vdi_bi=0.0;
igbinv_Vsi_bi=0.0;
igbinv_Tempt_GND=0.0;
#endif
igbinv=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igbacc_Vgi_bi=0.0;
igbacc_Vdi_bi=0.0;
igbacc_Vsi_bi=0.0;
igbacc_Tempt_GND=0.0;
#endif
igbacc=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igb_Vgi_bi=0.0;
igb_Vdi_bi=0.0;
igb_Vsi_bi=0.0;
igb_Tempt_GND=0.0;
#endif
igb=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igcs_Vgi_bi=0.0;
igcs_Vdi_bi=0.0;
igcs_Vsi_bi=0.0;
igcs_Tempt_GND=0.0;
#endif
igcs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igcd_Vgi_bi=0.0;
igcd_Vdi_bi=0.0;
igcd_Vsi_bi=0.0;
igcd_Tempt_GND=0.0;
#endif
igcd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(si,bi)V(di,bi) ddxprobe= */
igs_Tempt_GND=0.0;
igs_Vgi_bi=0.0;
igs_Vsi_bi=0.0;
igs_Vdi_bi=0.0;
#endif
igs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
igd_Tempt_GND=0.0;
igd_Vgi_bi=0.0;
igd_Vdi_bi=0.0;
igd_Vsi_bi=0.0;
#endif
igd=0.0;
EXIT_IF_ISNAN(0.0)
if
(((pModel->IGCMOD!=0)||(pModel->IGBMOD!=0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
Voxm_Vdi_bi=((nVt_Vdi_bi*(((vgfb-psip)+qs)+qdeff))+(nVt*(((vgfb_Vdi_bi-psip_Vdi_bi)+qs_Vdi_bi)+qdeff_Vdi_bi)));
#if defined(_DERIVATE2)
  Voxm_Vdi_bi_Vdi_bi=(+nVt_Vdi_bi_Vdi_bi*(((vgfb-psip)+qs)+qdeff)+nVt_Vdi_bi*(((vgfb_Vdi_bi-psip_Vdi_bi)+qs_Vdi_bi)+qdeff_Vdi_bi)+nVt_Vdi_bi*(((vgfb_Vdi_bi-psip_Vdi_bi)+qs_Vdi_bi)+qdeff_Vdi_bi)+nVt*(+(+(+vgfb_Vdi_bi_Vdi_bi-psip_Vdi_bi_Vdi_bi)+qs_Vdi_bi_Vdi_bi)+qdeff_Vdi_bi_Vdi_bi));
  Voxm_Vdi_bi_Vsi_bi=(+nVt_Vdi_bi_Vsi_bi*(((vgfb-psip)+qs)+qdeff)+nVt_Vdi_bi*(((vgfb_Vsi_bi-psip_Vsi_bi)+qs_Vsi_bi)+qdeff_Vsi_bi)+nVt_Vsi_bi*(((vgfb_Vdi_bi-psip_Vdi_bi)+qs_Vdi_bi)+qdeff_Vdi_bi)+nVt*(+(+(+vgfb_Vdi_bi_Vsi_bi-psip_Vdi_bi_Vsi_bi)+qs_Vdi_bi_Vsi_bi)+qdeff_Vdi_bi_Vsi_bi));
  Voxm_Vdi_bi_Tempt_GND=(+nVt_Vdi_bi_Tempt_GND*(((vgfb-psip)+qs)+qdeff)+nVt_Vdi_bi*(((vgfb_Tempt_GND-psip_Tempt_GND)+qs_Tempt_GND)+qdeff_Tempt_GND)+nVt_Tempt_GND*(((vgfb_Vdi_bi-psip_Vdi_bi)+qs_Vdi_bi)+qdeff_Vdi_bi)+nVt*(+(+(+vgfb_Vdi_bi_Tempt_GND-psip_Vdi_bi_Tempt_GND)+qs_Vdi_bi_Tempt_GND)+qdeff_Vdi_bi_Tempt_GND));
  Voxm_Vdi_bi_Vgi_bi=(+nVt_Vdi_bi_Vgi_bi*(((vgfb-psip)+qs)+qdeff)+nVt_Vdi_bi*(((vgfb_Vgi_bi-psip_Vgi_bi)+qs_Vgi_bi)+qdeff_Vgi_bi)+nVt_Vgi_bi*(((vgfb_Vdi_bi-psip_Vdi_bi)+qs_Vdi_bi)+qdeff_Vdi_bi)+nVt*(+(+(+vgfb_Vdi_bi_Vgi_bi-psip_Vdi_bi_Vgi_bi)+qs_Vdi_bi_Vgi_bi)+qdeff_Vdi_bi_Vgi_bi));
#endif
Voxm_Vsi_bi=((nVt_Vsi_bi*(((vgfb-psip)+qs)+qdeff))+(nVt*(((vgfb_Vsi_bi-psip_Vsi_bi)+qs_Vsi_bi)+qdeff_Vsi_bi)));
#if defined(_DERIVATE2)
  Voxm_Vsi_bi_Vdi_bi=(+nVt_Vsi_bi_Vdi_bi*(((vgfb-psip)+qs)+qdeff)+nVt_Vsi_bi*(((vgfb_Vdi_bi-psip_Vdi_bi)+qs_Vdi_bi)+qdeff_Vdi_bi)+nVt_Vdi_bi*(((vgfb_Vsi_bi-psip_Vsi_bi)+qs_Vsi_bi)+qdeff_Vsi_bi)+nVt*(+(+(+vgfb_Vsi_bi_Vdi_bi-psip_Vsi_bi_Vdi_bi)+qs_Vsi_bi_Vdi_bi)+qdeff_Vsi_bi_Vdi_bi));
  Voxm_Vsi_bi_Vsi_bi=(+nVt_Vsi_bi_Vsi_bi*(((vgfb-psip)+qs)+qdeff)+nVt_Vsi_bi*(((vgfb_Vsi_bi-psip_Vsi_bi)+qs_Vsi_bi)+qdeff_Vsi_bi)+nVt_Vsi_bi*(((vgfb_Vsi_bi-psip_Vsi_bi)+qs_Vsi_bi)+qdeff_Vsi_bi)+nVt*(+(+(+vgfb_Vsi_bi_Vsi_bi-psip_Vsi_bi_Vsi_bi)+qs_Vsi_bi_Vsi_bi)+qdeff_Vsi_bi_Vsi_bi));
  Voxm_Vsi_bi_Tempt_GND=(+nVt_Vsi_bi_Tempt_GND*(((vgfb-psip)+qs)+qdeff)+nVt_Vsi_bi*(((vgfb_Tempt_GND-psip_Tempt_GND)+qs_Tempt_GND)+qdeff_Tempt_GND)+nVt_Tempt_GND*(((vgfb_Vsi_bi-psip_Vsi_bi)+qs_Vsi_bi)+qdeff_Vsi_bi)+nVt*(+(+(+vgfb_Vsi_bi_Tempt_GND-psip_Vsi_bi_Tempt_GND)+qs_Vsi_bi_Tempt_GND)+qdeff_Vsi_bi_Tempt_GND));
  Voxm_Vsi_bi_Vgi_bi=(+nVt_Vsi_bi_Vgi_bi*(((vgfb-psip)+qs)+qdeff)+nVt_Vsi_bi*(((vgfb_Vgi_bi-psip_Vgi_bi)+qs_Vgi_bi)+qdeff_Vgi_bi)+nVt_Vgi_bi*(((vgfb_Vsi_bi-psip_Vsi_bi)+qs_Vsi_bi)+qdeff_Vsi_bi)+nVt*(+(+(+vgfb_Vsi_bi_Vgi_bi-psip_Vsi_bi_Vgi_bi)+qs_Vsi_bi_Vgi_bi)+qdeff_Vsi_bi_Vgi_bi));
#endif
#if defined(_DERIVATE)
Voxm_Tempt_GND=((nVt_Tempt_GND*(((vgfb-psip)+qs)+qdeff))+(nVt*(((vgfb_Tempt_GND-psip_Tempt_GND)+qs_Tempt_GND)+qdeff_Tempt_GND)));
#endif
Voxm_Vgi_bi=((nVt_Vgi_bi*(((vgfb-psip)+qs)+qdeff))+(nVt*(((vgfb_Vgi_bi-psip_Vgi_bi)+qs_Vgi_bi)+qdeff_Vgi_bi)));
#if defined(_DERIVATE2)
  Voxm_Vgi_bi_Vdi_bi=(+nVt_Vgi_bi_Vdi_bi*(((vgfb-psip)+qs)+qdeff)+nVt_Vgi_bi*(((vgfb_Vdi_bi-psip_Vdi_bi)+qs_Vdi_bi)+qdeff_Vdi_bi)+nVt_Vdi_bi*(((vgfb_Vgi_bi-psip_Vgi_bi)+qs_Vgi_bi)+qdeff_Vgi_bi)+nVt*(+(+(+vgfb_Vgi_bi_Vdi_bi-psip_Vgi_bi_Vdi_bi)+qs_Vgi_bi_Vdi_bi)+qdeff_Vgi_bi_Vdi_bi));
  Voxm_Vgi_bi_Vsi_bi=(+nVt_Vgi_bi_Vsi_bi*(((vgfb-psip)+qs)+qdeff)+nVt_Vgi_bi*(((vgfb_Vsi_bi-psip_Vsi_bi)+qs_Vsi_bi)+qdeff_Vsi_bi)+nVt_Vsi_bi*(((vgfb_Vgi_bi-psip_Vgi_bi)+qs_Vgi_bi)+qdeff_Vgi_bi)+nVt*(+(+(+vgfb_Vgi_bi_Vsi_bi-psip_Vgi_bi_Vsi_bi)+qs_Vgi_bi_Vsi_bi)+qdeff_Vgi_bi_Vsi_bi));
  Voxm_Vgi_bi_Tempt_GND=(+nVt_Vgi_bi_Tempt_GND*(((vgfb-psip)+qs)+qdeff)+nVt_Vgi_bi*(((vgfb_Tempt_GND-psip_Tempt_GND)+qs_Tempt_GND)+qdeff_Tempt_GND)+nVt_Tempt_GND*(((vgfb_Vgi_bi-psip_Vgi_bi)+qs_Vgi_bi)+qdeff_Vgi_bi)+nVt*(+(+(+vgfb_Vgi_bi_Tempt_GND-psip_Vgi_bi_Tempt_GND)+qs_Vgi_bi_Tempt_GND)+qdeff_Vgi_bi_Tempt_GND));
  Voxm_Vgi_bi_Vgi_bi=(+nVt_Vgi_bi_Vgi_bi*(((vgfb-psip)+qs)+qdeff)+nVt_Vgi_bi*(((vgfb_Vgi_bi-psip_Vgi_bi)+qs_Vgi_bi)+qdeff_Vgi_bi)+nVt_Vgi_bi*(((vgfb_Vgi_bi-psip_Vgi_bi)+qs_Vgi_bi)+qdeff_Vgi_bi)+nVt*(+(+(+vgfb_Vgi_bi_Vgi_bi-psip_Vgi_bi_Vgi_bi)+qs_Vgi_bi_Vgi_bi)+qdeff_Vgi_bi_Vgi_bi));
#endif
#endif
Voxm=(nVt*(((vgfb-psip)+qs)+qdeff));
EXIT_IF_ISNAN((nVt*(((vgfb-psip)+qs)+qdeff)))
{
double m00_sqrt(d00_sqrt0,((Voxm*Voxm)+1.0e-4))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Voxm*Voxm)+1.0e-4))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vgi_bi*0.0+0.0*Voxm_Vgi_bi+Voxm*0.0)+0.0));
  T1_Vgi_bi_Vgm_si=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vgi_bi*0.0+0.0*Voxm_Vgi_bi+Voxm*0.0)+0.0));
  T1_Vgi_bi_Vdbulk_di=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vgi_bi*0.0+0.0*Voxm_Vgi_bi+Voxm*0.0)+0.0));
  T1_Vgi_bi_Vsbulk_si=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vgi_bi*0.0+0.0*Voxm_Vgi_bi+Voxm*0.0)+0.0));
  T1_Vgi_bi_Vgi_bi=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi)))*((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi))+d10_sqrt0*(+(+Voxm_Vgi_bi_Vgi_bi*Voxm+Voxm_Vgi_bi*Voxm_Vgi_bi+Voxm_Vgi_bi*Voxm_Vgi_bi+Voxm*Voxm_Vgi_bi_Vgi_bi)+0.0));
  T1_Vgi_bi_Vdi_bi=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi)))*((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi))+d10_sqrt0*(+(+Voxm_Vgi_bi_Vdi_bi*Voxm+Voxm_Vgi_bi*Voxm_Vdi_bi+Voxm_Vdi_bi*Voxm_Vgi_bi+Voxm*Voxm_Vgi_bi_Vdi_bi)+0.0));
  T1_Vgi_bi_Vsi_bi=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi)))*((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi))+d10_sqrt0*(+(+Voxm_Vgi_bi_Vsi_bi*Voxm+Voxm_Vgi_bi*Voxm_Vsi_bi+Voxm_Vsi_bi*Voxm_Vgi_bi+Voxm*Voxm_Vgi_bi_Vsi_bi)+0.0));
  T1_Vgi_bi_Tempt_GND=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Tempt_GND*Voxm)+(Voxm*Voxm_Tempt_GND)))*((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi))+d10_sqrt0*(+(+Voxm_Vgi_bi_Tempt_GND*Voxm+Voxm_Vgi_bi*Voxm_Tempt_GND+Voxm_Tempt_GND*Voxm_Vgi_bi+Voxm*Voxm_Vgi_bi_Tempt_GND)+0.0));
#endif
T1_Vdi_bi=((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vdi_bi*0.0+0.0*Voxm_Vdi_bi+Voxm*0.0)+0.0));
  T1_Vdi_bi_Vgm_si=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vdi_bi*0.0+0.0*Voxm_Vdi_bi+Voxm*0.0)+0.0));
  T1_Vdi_bi_Vdbulk_di=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vdi_bi*0.0+0.0*Voxm_Vdi_bi+Voxm*0.0)+0.0));
  T1_Vdi_bi_Vsbulk_si=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vdi_bi*0.0+0.0*Voxm_Vdi_bi+Voxm*0.0)+0.0));
  T1_Vdi_bi_Vgi_bi=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi)))*((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi))+d10_sqrt0*(+(+Voxm_Vdi_bi_Vgi_bi*Voxm+Voxm_Vdi_bi*Voxm_Vgi_bi+Voxm_Vgi_bi*Voxm_Vdi_bi+Voxm*Voxm_Vdi_bi_Vgi_bi)+0.0));
  T1_Vdi_bi_Vdi_bi=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi)))*((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi))+d10_sqrt0*(+(+Voxm_Vdi_bi_Vdi_bi*Voxm+Voxm_Vdi_bi*Voxm_Vdi_bi+Voxm_Vdi_bi*Voxm_Vdi_bi+Voxm*Voxm_Vdi_bi_Vdi_bi)+0.0));
  T1_Vdi_bi_Vsi_bi=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi)))*((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi))+d10_sqrt0*(+(+Voxm_Vdi_bi_Vsi_bi*Voxm+Voxm_Vdi_bi*Voxm_Vsi_bi+Voxm_Vsi_bi*Voxm_Vdi_bi+Voxm*Voxm_Vdi_bi_Vsi_bi)+0.0));
  T1_Vdi_bi_Tempt_GND=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Tempt_GND*Voxm)+(Voxm*Voxm_Tempt_GND)))*((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi))+d10_sqrt0*(+(+Voxm_Vdi_bi_Tempt_GND*Voxm+Voxm_Vdi_bi*Voxm_Tempt_GND+Voxm_Tempt_GND*Voxm_Vdi_bi+Voxm*Voxm_Vdi_bi_Tempt_GND)+0.0));
#endif
T1_Vsi_bi=((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vsi_bi*0.0+0.0*Voxm_Vsi_bi+Voxm*0.0)+0.0));
  T1_Vsi_bi_Vgm_si=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vsi_bi*0.0+0.0*Voxm_Vsi_bi+Voxm*0.0)+0.0));
  T1_Vsi_bi_Vdbulk_di=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vsi_bi*0.0+0.0*Voxm_Vsi_bi+Voxm*0.0)+0.0));
  T1_Vsi_bi_Vsbulk_si=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(0.0)*((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi))+d10_sqrt0*(+(+0.0*Voxm+Voxm_Vsi_bi*0.0+0.0*Voxm_Vsi_bi+Voxm*0.0)+0.0));
  T1_Vsi_bi_Vgi_bi=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Vgi_bi*Voxm)+(Voxm*Voxm_Vgi_bi)))*((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi))+d10_sqrt0*(+(+Voxm_Vsi_bi_Vgi_bi*Voxm+Voxm_Vsi_bi*Voxm_Vgi_bi+Voxm_Vgi_bi*Voxm_Vsi_bi+Voxm*Voxm_Vsi_bi_Vgi_bi)+0.0));
  T1_Vsi_bi_Vdi_bi=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Vdi_bi*Voxm)+(Voxm*Voxm_Vdi_bi)))*((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi))+d10_sqrt0*(+(+Voxm_Vsi_bi_Vdi_bi*Voxm+Voxm_Vsi_bi*Voxm_Vdi_bi+Voxm_Vdi_bi*Voxm_Vsi_bi+Voxm*Voxm_Vsi_bi_Vdi_bi)+0.0));
  T1_Vsi_bi_Vsi_bi=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi)))*((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi))+d10_sqrt0*(+(+Voxm_Vsi_bi_Vsi_bi*Voxm+Voxm_Vsi_bi*Voxm_Vsi_bi+Voxm_Vsi_bi*Voxm_Vsi_bi+Voxm*Voxm_Vsi_bi_Vsi_bi)+0.0));
  T1_Vsi_bi_Tempt_GND=(m20_sqrt(((Voxm*Voxm)+1.0e-4))*(((Voxm_Tempt_GND*Voxm)+(Voxm*Voxm_Tempt_GND)))*((Voxm_Vsi_bi*Voxm)+(Voxm*Voxm_Vsi_bi))+d10_sqrt0*(+(+Voxm_Vsi_bi_Tempt_GND*Voxm+Voxm_Vsi_bi*Voxm_Tempt_GND+Voxm_Tempt_GND*Voxm_Vsi_bi+Voxm*Voxm_Vsi_bi_Tempt_GND)+0.0));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((Voxm_Tempt_GND*Voxm)+(Voxm*Voxm_Tempt_GND))*d10_sqrt0;
#endif
#endif
T1=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
Voxmacc_Vdi_bi=(0.5*((-Voxm_Vdi_bi)+T1_Vdi_bi));
#if defined(_DERIVATE2)
  Voxmacc_Vdi_bi_Vdi_bi=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Vdi_bi)+T1_Vdi_bi)+0.0*((-Voxm_Vdi_bi)+T1_Vdi_bi)+0.5*(+0.0+T1_Vdi_bi_Vdi_bi));
  Voxmacc_Vdi_bi_Vsi_bi=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Vsi_bi)+T1_Vsi_bi)+0.0*((-Voxm_Vdi_bi)+T1_Vdi_bi)+0.5*(+0.0+T1_Vdi_bi_Vsi_bi));
  Voxmacc_Vdi_bi_Tempt_GND=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Tempt_GND)+T1_Tempt_GND)+0.0*((-Voxm_Vdi_bi)+T1_Vdi_bi)+0.5*(+0.0+T1_Vdi_bi_Tempt_GND));
  Voxmacc_Vdi_bi_Vgi_bi=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Vgi_bi)+T1_Vgi_bi)+0.0*((-Voxm_Vdi_bi)+T1_Vdi_bi)+0.5*(+0.0+T1_Vdi_bi_Vgi_bi));
#endif
Voxmacc_Vsi_bi=(0.5*((-Voxm_Vsi_bi)+T1_Vsi_bi));
#if defined(_DERIVATE2)
  Voxmacc_Vsi_bi_Vdi_bi=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Vdi_bi)+T1_Vdi_bi)+0.0*((-Voxm_Vsi_bi)+T1_Vsi_bi)+0.5*(+0.0+T1_Vsi_bi_Vdi_bi));
  Voxmacc_Vsi_bi_Vsi_bi=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Vsi_bi)+T1_Vsi_bi)+0.0*((-Voxm_Vsi_bi)+T1_Vsi_bi)+0.5*(+0.0+T1_Vsi_bi_Vsi_bi));
  Voxmacc_Vsi_bi_Tempt_GND=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Tempt_GND)+T1_Tempt_GND)+0.0*((-Voxm_Vsi_bi)+T1_Vsi_bi)+0.5*(+0.0+T1_Vsi_bi_Tempt_GND));
  Voxmacc_Vsi_bi_Vgi_bi=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Vgi_bi)+T1_Vgi_bi)+0.0*((-Voxm_Vsi_bi)+T1_Vsi_bi)+0.5*(+0.0+T1_Vsi_bi_Vgi_bi));
#endif
#if defined(_DERIVATE)
Voxmacc_Tempt_GND=(0.5*((-Voxm_Tempt_GND)+T1_Tempt_GND));
#endif
Voxmacc_Vgi_bi=(0.5*((-Voxm_Vgi_bi)+T1_Vgi_bi));
#if defined(_DERIVATE2)
  Voxmacc_Vgi_bi_Vdi_bi=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Vdi_bi)+T1_Vdi_bi)+0.0*((-Voxm_Vgi_bi)+T1_Vgi_bi)+0.5*(+0.0+T1_Vgi_bi_Vdi_bi));
  Voxmacc_Vgi_bi_Vsi_bi=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Vsi_bi)+T1_Vsi_bi)+0.0*((-Voxm_Vgi_bi)+T1_Vgi_bi)+0.5*(+0.0+T1_Vgi_bi_Vsi_bi));
  Voxmacc_Vgi_bi_Tempt_GND=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Tempt_GND)+T1_Tempt_GND)+0.0*((-Voxm_Vgi_bi)+T1_Vgi_bi)+0.5*(+0.0+T1_Vgi_bi_Tempt_GND));
  Voxmacc_Vgi_bi_Vgi_bi=(+0.0*((-Voxm)+T1)+0.0*((-Voxm_Vgi_bi)+T1_Vgi_bi)+0.0*((-Voxm_Vgi_bi)+T1_Vgi_bi)+0.5*(+0.0+T1_Vgi_bi_Vgi_bi));
#endif
#endif
Voxmacc=(0.5*((-Voxm)+T1));
EXIT_IF_ISNAN((0.5*((-Voxm)+T1)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
Voxminv_Vdi_bi=(0.5*(Voxm_Vdi_bi+T1_Vdi_bi));
#if defined(_DERIVATE2)
  Voxminv_Vdi_bi_Vdi_bi=(+0.0*(Voxm+T1)+0.0*(Voxm_Vdi_bi+T1_Vdi_bi)+0.0*(Voxm_Vdi_bi+T1_Vdi_bi)+0.5*(+Voxm_Vdi_bi_Vdi_bi+T1_Vdi_bi_Vdi_bi));
  Voxminv_Vdi_bi_Vsi_bi=(+0.0*(Voxm+T1)+0.0*(Voxm_Vsi_bi+T1_Vsi_bi)+0.0*(Voxm_Vdi_bi+T1_Vdi_bi)+0.5*(+Voxm_Vdi_bi_Vsi_bi+T1_Vdi_bi_Vsi_bi));
  Voxminv_Vdi_bi_Tempt_GND=(+0.0*(Voxm+T1)+0.0*(Voxm_Tempt_GND+T1_Tempt_GND)+0.0*(Voxm_Vdi_bi+T1_Vdi_bi)+0.5*(+Voxm_Vdi_bi_Tempt_GND+T1_Vdi_bi_Tempt_GND));
  Voxminv_Vdi_bi_Vgi_bi=(+0.0*(Voxm+T1)+0.0*(Voxm_Vgi_bi+T1_Vgi_bi)+0.0*(Voxm_Vdi_bi+T1_Vdi_bi)+0.5*(+Voxm_Vdi_bi_Vgi_bi+T1_Vdi_bi_Vgi_bi));
#endif
Voxminv_Vsi_bi=(0.5*(Voxm_Vsi_bi+T1_Vsi_bi));
#if defined(_DERIVATE2)
  Voxminv_Vsi_bi_Vdi_bi=(+0.0*(Voxm+T1)+0.0*(Voxm_Vdi_bi+T1_Vdi_bi)+0.0*(Voxm_Vsi_bi+T1_Vsi_bi)+0.5*(+Voxm_Vsi_bi_Vdi_bi+T1_Vsi_bi_Vdi_bi));
  Voxminv_Vsi_bi_Vsi_bi=(+0.0*(Voxm+T1)+0.0*(Voxm_Vsi_bi+T1_Vsi_bi)+0.0*(Voxm_Vsi_bi+T1_Vsi_bi)+0.5*(+Voxm_Vsi_bi_Vsi_bi+T1_Vsi_bi_Vsi_bi));
  Voxminv_Vsi_bi_Tempt_GND=(+0.0*(Voxm+T1)+0.0*(Voxm_Tempt_GND+T1_Tempt_GND)+0.0*(Voxm_Vsi_bi+T1_Vsi_bi)+0.5*(+Voxm_Vsi_bi_Tempt_GND+T1_Vsi_bi_Tempt_GND));
  Voxminv_Vsi_bi_Vgi_bi=(+0.0*(Voxm+T1)+0.0*(Voxm_Vgi_bi+T1_Vgi_bi)+0.0*(Voxm_Vsi_bi+T1_Vsi_bi)+0.5*(+Voxm_Vsi_bi_Vgi_bi+T1_Vsi_bi_Vgi_bi));
#endif
#if defined(_DERIVATE)
Voxminv_Tempt_GND=(0.5*(Voxm_Tempt_GND+T1_Tempt_GND));
#endif
Voxminv_Vgi_bi=(0.5*(Voxm_Vgi_bi+T1_Vgi_bi));
#if defined(_DERIVATE2)
  Voxminv_Vgi_bi_Vdi_bi=(+0.0*(Voxm+T1)+0.0*(Voxm_Vdi_bi+T1_Vdi_bi)+0.0*(Voxm_Vgi_bi+T1_Vgi_bi)+0.5*(+Voxm_Vgi_bi_Vdi_bi+T1_Vgi_bi_Vdi_bi));
  Voxminv_Vgi_bi_Vsi_bi=(+0.0*(Voxm+T1)+0.0*(Voxm_Vsi_bi+T1_Vsi_bi)+0.0*(Voxm_Vgi_bi+T1_Vgi_bi)+0.5*(+Voxm_Vgi_bi_Vsi_bi+T1_Vgi_bi_Vsi_bi));
  Voxminv_Vgi_bi_Tempt_GND=(+0.0*(Voxm+T1)+0.0*(Voxm_Tempt_GND+T1_Tempt_GND)+0.0*(Voxm_Vgi_bi+T1_Vgi_bi)+0.5*(+Voxm_Vgi_bi_Tempt_GND+T1_Vgi_bi_Tempt_GND));
  Voxminv_Vgi_bi_Vgi_bi=(+0.0*(Voxm+T1)+0.0*(Voxm_Vgi_bi+T1_Vgi_bi)+0.0*(Voxm_Vgi_bi+T1_Vgi_bi)+0.5*(+Voxm_Vgi_bi_Vgi_bi+T1_Vgi_bi_Vgi_bi));
#endif
#endif
Voxminv=(0.5*(Voxm+T1));
EXIT_IF_ISNAN((0.5*(Voxm+T1)))
if
((pModel->IGBMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=((Voxmacc_Vgi_bi/NIGBACC_i)/Vt);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=((0.0/NIGBACC_i-(Voxmacc_Vgi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vgi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vgm_si=((0.0/NIGBACC_i-(Voxmacc_Vgi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vgi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vdbulk_di=((0.0/NIGBACC_i-(Voxmacc_Vgi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vgi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vsbulk_si=((0.0/NIGBACC_i-(Voxmacc_Vgi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vgi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vgi_bi=((Voxmacc_Vgi_bi_Vgi_bi/NIGBACC_i-(Voxmacc_Vgi_bi*0.0+Voxmacc_Vgi_bi*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vgi_bi/NIGBACC_i)*0.0+(Voxmacc_Vgi_bi/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vdi_bi=((Voxmacc_Vgi_bi_Vdi_bi/NIGBACC_i-(Voxmacc_Vgi_bi*0.0+Voxmacc_Vdi_bi*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vgi_bi/NIGBACC_i)*0.0+(Voxmacc_Vdi_bi/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vsi_bi=((Voxmacc_Vgi_bi_Vsi_bi/NIGBACC_i-(Voxmacc_Vgi_bi*0.0+Voxmacc_Vsi_bi*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vgi_bi/NIGBACC_i)*0.0+(Voxmacc_Vsi_bi/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Tempt_GND=((Voxmacc_Vgi_bi_Tempt_GND/NIGBACC_i-(Voxmacc_Vgi_bi*0.0+Voxmacc_Tempt_GND*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vgi_bi/NIGBACC_i)*Vt_Tempt_GND+(Voxmacc_Tempt_GND/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*Vt_Tempt_GND/Vt/Vt/Vt);
#endif
T1_Vdi_bi=((Voxmacc_Vdi_bi/NIGBACC_i)/Vt);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=((0.0/NIGBACC_i-(Voxmacc_Vdi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vdi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vgm_si=((0.0/NIGBACC_i-(Voxmacc_Vdi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vdi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vdbulk_di=((0.0/NIGBACC_i-(Voxmacc_Vdi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vdi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vsbulk_si=((0.0/NIGBACC_i-(Voxmacc_Vdi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vdi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vgi_bi=((Voxmacc_Vdi_bi_Vgi_bi/NIGBACC_i-(Voxmacc_Vdi_bi*0.0+Voxmacc_Vgi_bi*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vdi_bi/NIGBACC_i)*0.0+(Voxmacc_Vgi_bi/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vdi_bi=((Voxmacc_Vdi_bi_Vdi_bi/NIGBACC_i-(Voxmacc_Vdi_bi*0.0+Voxmacc_Vdi_bi*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vdi_bi/NIGBACC_i)*0.0+(Voxmacc_Vdi_bi/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vsi_bi=((Voxmacc_Vdi_bi_Vsi_bi/NIGBACC_i-(Voxmacc_Vdi_bi*0.0+Voxmacc_Vsi_bi*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vdi_bi/NIGBACC_i)*0.0+(Voxmacc_Vsi_bi/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Tempt_GND=((Voxmacc_Vdi_bi_Tempt_GND/NIGBACC_i-(Voxmacc_Vdi_bi*0.0+Voxmacc_Tempt_GND*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vdi_bi/NIGBACC_i)*Vt_Tempt_GND+(Voxmacc_Tempt_GND/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*Vt_Tempt_GND/Vt/Vt/Vt);
#endif
T1_Vsi_bi=((Voxmacc_Vsi_bi/NIGBACC_i)/Vt);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=((0.0/NIGBACC_i-(Voxmacc_Vsi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vsi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vgm_si=((0.0/NIGBACC_i-(Voxmacc_Vsi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vsi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vdbulk_di=((0.0/NIGBACC_i-(Voxmacc_Vsi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vsi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vsbulk_si=((0.0/NIGBACC_i-(Voxmacc_Vsi_bi*0.0+0.0*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vsi_bi/NIGBACC_i)*0.0+0.0*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vgi_bi=((Voxmacc_Vsi_bi_Vgi_bi/NIGBACC_i-(Voxmacc_Vsi_bi*0.0+Voxmacc_Vgi_bi*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vsi_bi/NIGBACC_i)*0.0+(Voxmacc_Vgi_bi/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vdi_bi=((Voxmacc_Vsi_bi_Vdi_bi/NIGBACC_i-(Voxmacc_Vsi_bi*0.0+Voxmacc_Vdi_bi*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vsi_bi/NIGBACC_i)*0.0+(Voxmacc_Vdi_bi/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vsi_bi=((Voxmacc_Vsi_bi_Vsi_bi/NIGBACC_i-(Voxmacc_Vsi_bi*0.0+Voxmacc_Vsi_bi*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vsi_bi/NIGBACC_i)*0.0+(Voxmacc_Vsi_bi/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Tempt_GND=((Voxmacc_Vsi_bi_Tempt_GND/NIGBACC_i-(Voxmacc_Vsi_bi*0.0+Voxmacc_Tempt_GND*0.0+Voxmacc*0.0)/NIGBACC_i/NIGBACC_i+2*Voxmacc*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vt-((Voxmacc_Vsi_bi/NIGBACC_i)*Vt_Tempt_GND+(Voxmacc_Tempt_GND/NIGBACC_i)*0.0+(Voxmacc/NIGBACC_i)*0.0)/Vt/Vt+2*(Voxmacc/NIGBACC_i)*0.0*Vt_Tempt_GND/Vt/Vt/Vt);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((Voxmacc_Tempt_GND/NIGBACC_i)*Vt-(Voxmacc/NIGBACC_i)*Vt_Tempt_GND)/Vt/Vt);
#endif
#endif
T1=((Voxmacc/NIGBACC_i)/Vt);
EXIT_IF_ISNAN(((Voxmacc/NIGBACC_i)/Vt))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Vaux_Igbacc_Tempt_GND=(((NIGBACC_i*Vt_Tempt_GND)*bsimbulk_lln((1.0+bsimbulk_lexp((-T1)))))+((NIGBACC_i*Vt)*bsimbulk_d_lln((1.0+bsimbulk_lexp((-T1))),bsimbulk_d_lexp((-T1),(-T1_Tempt_GND)))));
Vaux_Igbacc_Vgi_bi=((NIGBACC_i*Vt)*bsimbulk_d_lln((1.0+bsimbulk_lexp((-T1))),bsimbulk_d_lexp((-T1),(-T1_Vgi_bi))));
Vaux_Igbacc_Vdi_bi=((NIGBACC_i*Vt)*bsimbulk_d_lln((1.0+bsimbulk_lexp((-T1))),bsimbulk_d_lexp((-T1),(-T1_Vdi_bi))));
Vaux_Igbacc_Vsi_bi=((NIGBACC_i*Vt)*bsimbulk_d_lln((1.0+bsimbulk_lexp((-T1))),bsimbulk_d_lexp((-T1),(-T1_Vsi_bi))));
#endif
Vaux_Igbacc=((NIGBACC_i*Vt)*bsimbulk_lln((1.0+bsimbulk_lexp((-T1)))));
EXIT_IF_ISNAN(((NIGBACC_i*Vt)*bsimbulk_lln((1.0+bsimbulk_lexp((-T1))))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(-(BIGBACC_i*Voxmacc_Vgi_bi));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vgi_bi+BIGBACC_i*0.0));
  T2_Vgi_bi_Vgm_si=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vgi_bi+BIGBACC_i*0.0));
  T2_Vgi_bi_Vdbulk_di=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vgi_bi+BIGBACC_i*0.0));
  T2_Vgi_bi_Vsbulk_si=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vgi_bi+BIGBACC_i*0.0));
  T2_Vgi_bi_Vgi_bi=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Vgi_bi+0.0*Voxmacc_Vgi_bi+BIGBACC_i*Voxmacc_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Vdi_bi+0.0*Voxmacc_Vgi_bi+BIGBACC_i*Voxmacc_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Vsi_bi+0.0*Voxmacc_Vgi_bi+BIGBACC_i*Voxmacc_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Tempt_GND+0.0*Voxmacc_Vgi_bi+BIGBACC_i*Voxmacc_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(-(BIGBACC_i*Voxmacc_Vdi_bi));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vdi_bi+BIGBACC_i*0.0));
  T2_Vdi_bi_Vgm_si=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vdi_bi+BIGBACC_i*0.0));
  T2_Vdi_bi_Vdbulk_di=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vdi_bi+BIGBACC_i*0.0));
  T2_Vdi_bi_Vsbulk_si=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vdi_bi+BIGBACC_i*0.0));
  T2_Vdi_bi_Vgi_bi=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Vgi_bi+0.0*Voxmacc_Vdi_bi+BIGBACC_i*Voxmacc_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Vdi_bi+0.0*Voxmacc_Vdi_bi+BIGBACC_i*Voxmacc_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Vsi_bi+0.0*Voxmacc_Vdi_bi+BIGBACC_i*Voxmacc_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Tempt_GND+0.0*Voxmacc_Vdi_bi+BIGBACC_i*Voxmacc_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(-(BIGBACC_i*Voxmacc_Vsi_bi));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vsi_bi+BIGBACC_i*0.0));
  T2_Vsi_bi_Vgm_si=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vsi_bi+BIGBACC_i*0.0));
  T2_Vsi_bi_Vdbulk_di=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vsi_bi+BIGBACC_i*0.0));
  T2_Vsi_bi_Vsbulk_si=(+0.0-(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vsi_bi+BIGBACC_i*0.0));
  T2_Vsi_bi_Vgi_bi=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Vgi_bi+0.0*Voxmacc_Vsi_bi+BIGBACC_i*Voxmacc_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Vdi_bi+0.0*Voxmacc_Vsi_bi+BIGBACC_i*Voxmacc_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Vsi_bi+0.0*Voxmacc_Vsi_bi+BIGBACC_i*Voxmacc_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+0.0-(+0.0*Voxmacc+0.0*Voxmacc_Tempt_GND+0.0*Voxmacc_Vsi_bi+BIGBACC_i*Voxmacc_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(-(BIGBACC_i*Voxmacc_Tempt_GND));
#endif
#endif
T2=(AIGBACC_i-(BIGBACC_i*Voxmacc));
EXIT_IF_ISNAN((AIGBACC_i-(BIGBACC_i*Voxmacc)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(CIGBACC_i*Voxmacc_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vgi_bi+CIGBACC_i*0.0));
  T3_Vgi_bi_Vgm_di=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vgi_bi+CIGBACC_i*0.0));
  T3_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vgi_bi+CIGBACC_i*0.0));
  T3_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vgi_bi+CIGBACC_i*0.0));
  T3_Vgi_bi_Vgi_bi=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Vgi_bi+0.0*Voxmacc_Vgi_bi+CIGBACC_i*Voxmacc_Vgi_bi_Vgi_bi));
  T3_Vgi_bi_Vdi_bi=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Vdi_bi+0.0*Voxmacc_Vgi_bi+CIGBACC_i*Voxmacc_Vgi_bi_Vdi_bi));
  T3_Vgi_bi_Vsi_bi=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Vsi_bi+0.0*Voxmacc_Vgi_bi+CIGBACC_i*Voxmacc_Vgi_bi_Vsi_bi));
  T3_Vgi_bi_Tempt_GND=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Tempt_GND+0.0*Voxmacc_Vgi_bi+CIGBACC_i*Voxmacc_Vgi_bi_Tempt_GND));
#endif
T3_Vdi_bi=(CIGBACC_i*Voxmacc_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vdi_bi+CIGBACC_i*0.0));
  T3_Vdi_bi_Vgm_di=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vdi_bi+CIGBACC_i*0.0));
  T3_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vdi_bi+CIGBACC_i*0.0));
  T3_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vdi_bi+CIGBACC_i*0.0));
  T3_Vdi_bi_Vgi_bi=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Vgi_bi+0.0*Voxmacc_Vdi_bi+CIGBACC_i*Voxmacc_Vdi_bi_Vgi_bi));
  T3_Vdi_bi_Vdi_bi=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Vdi_bi+0.0*Voxmacc_Vdi_bi+CIGBACC_i*Voxmacc_Vdi_bi_Vdi_bi));
  T3_Vdi_bi_Vsi_bi=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Vsi_bi+0.0*Voxmacc_Vdi_bi+CIGBACC_i*Voxmacc_Vdi_bi_Vsi_bi));
  T3_Vdi_bi_Tempt_GND=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Tempt_GND+0.0*Voxmacc_Vdi_bi+CIGBACC_i*Voxmacc_Vdi_bi_Tempt_GND));
#endif
T3_Vsi_bi=(CIGBACC_i*Voxmacc_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vsi_bi+CIGBACC_i*0.0));
  T3_Vsi_bi_Vgm_di=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vsi_bi+CIGBACC_i*0.0));
  T3_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vsi_bi+CIGBACC_i*0.0));
  T3_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*Voxmacc+0.0*0.0+0.0*Voxmacc_Vsi_bi+CIGBACC_i*0.0));
  T3_Vsi_bi_Vgi_bi=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Vgi_bi+0.0*Voxmacc_Vsi_bi+CIGBACC_i*Voxmacc_Vsi_bi_Vgi_bi));
  T3_Vsi_bi_Vdi_bi=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Vdi_bi+0.0*Voxmacc_Vsi_bi+CIGBACC_i*Voxmacc_Vsi_bi_Vdi_bi));
  T3_Vsi_bi_Vsi_bi=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Vsi_bi+0.0*Voxmacc_Vsi_bi+CIGBACC_i*Voxmacc_Vsi_bi_Vsi_bi));
  T3_Vsi_bi_Tempt_GND=(+0.0+(+0.0*Voxmacc+0.0*Voxmacc_Tempt_GND+0.0*Voxmacc_Vsi_bi+CIGBACC_i*Voxmacc_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(CIGBACC_i*Voxmacc_Tempt_GND);
#endif
#endif
T3=(1.0+(CIGBACC_i*Voxmacc));
EXIT_IF_ISNAN((1.0+(CIGBACC_i*Voxmacc)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(((((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)*T3)+((((-7.45669e11)*pModel->TOXE)*T2)*T3_Vgi_bi));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vgm_si+(0.0)*T2_Vgi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi_Vgm_si)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vgm_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vgm_si)))*T3_Vgi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vgm_di+(0.0)*T2_Vgi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi_Vgm_di)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vgm_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vgm_di)))*T3_Vgi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdbulk_di+(0.0)*T2_Vgi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi_Vdbulk_di)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vdbulk_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vdbulk_di)))*T3_Vgi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vsbulk_si+(0.0)*T2_Vgi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi_Vsbulk_si)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vsbulk_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vsbulk_si)))*T3_Vgi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vgi_bi+(0.0)*T2_Vgi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi_Vgi_bi)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vgi_bi+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)))*T3_Vgi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_bi+(0.0)*T2_Vgi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi_Vdi_bi)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vdi_bi+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)))*T3_Vgi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vsi_bi+(0.0)*T2_Vgi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi_Vsi_bi)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vsi_bi+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)))*T3_Vgi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vgi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Tempt_GND)))*T3_Vgi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)*T3)+((((-7.45669e11)*pModel->TOXE)*T2)*T3_Vdi_bi));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vgm_si+(0.0)*T2_Vdi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi_Vgm_si)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vgm_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vgm_si)))*T3_Vdi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vgm_di+(0.0)*T2_Vdi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi_Vgm_di)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vgm_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vgm_di)))*T3_Vdi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdbulk_di+(0.0)*T2_Vdi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi_Vdbulk_di)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vdbulk_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vdbulk_di)))*T3_Vdi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vsbulk_si+(0.0)*T2_Vdi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi_Vsbulk_si)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vsbulk_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vsbulk_si)))*T3_Vdi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vgi_bi+(0.0)*T2_Vdi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi_Vgi_bi)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vgi_bi+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)))*T3_Vdi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_bi+(0.0)*T2_Vdi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi_Vdi_bi)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vdi_bi+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)))*T3_Vdi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vsi_bi+(0.0)*T2_Vdi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi_Vsi_bi)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vsi_bi+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)))*T3_Vdi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vdi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Tempt_GND)))*T3_Vdi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)*T3)+((((-7.45669e11)*pModel->TOXE)*T2)*T3_Vsi_bi));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vgm_si+(0.0)*T2_Vsi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi_Vgm_si)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vgm_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vgm_si)))*T3_Vsi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vgm_di+(0.0)*T2_Vsi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi_Vgm_di)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vgm_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vgm_di)))*T3_Vsi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdbulk_di+(0.0)*T2_Vsi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi_Vdbulk_di)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vdbulk_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vdbulk_di)))*T3_Vsi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vsbulk_si+(0.0)*T2_Vsi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi_Vsbulk_si)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vsbulk_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vsbulk_si)))*T3_Vsi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vgi_bi+(0.0)*T2_Vsi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi_Vgi_bi)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vgi_bi+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vgi_bi)))*T3_Vsi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_bi+(0.0)*T2_Vsi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi_Vdi_bi)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vdi_bi+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vdi_bi)))*T3_Vsi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vsi_bi+(0.0)*T2_Vsi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi_Vsi_bi)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vsi_bi+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)))*T3_Vsi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vsi_bi+((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXE)*T2_Tempt_GND)))*T3_Vsi_bi+(((-7.45669e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((((-7.45669e11)*pModel->TOXE)*T2_Tempt_GND)*T3)+((((-7.45669e11)*pModel->TOXE)*T2)*T3_Tempt_GND));
#endif
#endif
T4=((((-7.45669e11)*pModel->TOXE)*T2)*T3);
EXIT_IF_ISNAN(((((-7.45669e11)*pModel->TOXE)*T2)*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=bsimbulk_d_lexp(T4,T4_Vgi_bi);
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=T4_Vgi_bi_Vgm_si;
  T5_Vgi_bi_Vgm_di=T4_Vgi_bi_Vgm_di;
  T5_Vgi_bi_Vdbulk_di=T4_Vgi_bi_Vdbulk_di;
  T5_Vgi_bi_Vsbulk_si=T4_Vgi_bi_Vsbulk_si;
  T5_Vgi_bi_Vgi_bi=T4_Vgi_bi_Vgi_bi;
  T5_Vgi_bi_Vdi_bi=T4_Vgi_bi_Vdi_bi;
  T5_Vgi_bi_Vsi_bi=T4_Vgi_bi_Vsi_bi;
  T5_Vgi_bi_Tempt_GND=T4_Vgi_bi_Tempt_GND;
#endif
T5_Vdi_bi=bsimbulk_d_lexp(T4,T4_Vdi_bi);
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=T4_Vdi_bi_Vgm_si;
  T5_Vdi_bi_Vgm_di=T4_Vdi_bi_Vgm_di;
  T5_Vdi_bi_Vdbulk_di=T4_Vdi_bi_Vdbulk_di;
  T5_Vdi_bi_Vsbulk_si=T4_Vdi_bi_Vsbulk_si;
  T5_Vdi_bi_Vgi_bi=T4_Vdi_bi_Vgi_bi;
  T5_Vdi_bi_Vdi_bi=T4_Vdi_bi_Vdi_bi;
  T5_Vdi_bi_Vsi_bi=T4_Vdi_bi_Vsi_bi;
  T5_Vdi_bi_Tempt_GND=T4_Vdi_bi_Tempt_GND;
#endif
T5_Vsi_bi=bsimbulk_d_lexp(T4,T4_Vsi_bi);
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=T4_Vsi_bi_Vgm_si;
  T5_Vsi_bi_Vgm_di=T4_Vsi_bi_Vgm_di;
  T5_Vsi_bi_Vdbulk_di=T4_Vsi_bi_Vdbulk_di;
  T5_Vsi_bi_Vsbulk_si=T4_Vsi_bi_Vsbulk_si;
  T5_Vsi_bi_Vgi_bi=T4_Vsi_bi_Vgi_bi;
  T5_Vsi_bi_Vdi_bi=T4_Vsi_bi_Vdi_bi;
  T5_Vsi_bi_Vsi_bi=T4_Vsi_bi_Vsi_bi;
  T5_Vsi_bi_Tempt_GND=T4_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=bsimbulk_d_lexp(T4,T4_Tempt_GND);
#endif
#endif
T5=bsimbulk_lexp(T4);
EXIT_IF_ISNAN(bsimbulk_lexp(T4))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=0.0;
  T6_Vgi_bi_Vgm_si=0.0;
  T6_Vgi_bi_Vdbulk_di=0.0;
  T6_Vgi_bi_Vsbulk_si=0.0;
  T6_Vgi_bi_Vgi_bi=0.0;
  T6_Vgi_bi_Vdi_bi=0.0;
  T6_Vgi_bi_Vsi_bi=0.0;
  T6_Vgi_bi_Tempt_GND=0.0;
#endif
T6_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=0.0;
  T6_Vdi_bi_Vgm_si=0.0;
  T6_Vdi_bi_Vdbulk_di=0.0;
  T6_Vdi_bi_Vsbulk_si=0.0;
  T6_Vdi_bi_Vgi_bi=0.0;
  T6_Vdi_bi_Vdi_bi=0.0;
  T6_Vdi_bi_Vsi_bi=0.0;
  T6_Vdi_bi_Tempt_GND=0.0;
#endif
T6_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=0.0;
  T6_Vsi_bi_Vgm_si=0.0;
  T6_Vsi_bi_Vdbulk_di=0.0;
  T6_Vsi_bi_Vsbulk_si=0.0;
  T6_Vsi_bi_Vgi_bi=0.0;
  T6_Vsi_bi_Vdi_bi=0.0;
  T6_Vsi_bi_Vsi_bi=0.0;
  T6_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=0.0;
#endif
#endif
T6=4.97232e-7;
EXIT_IF_ISNAN(4.97232e-7)
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igbacc_Vgi_bi=(((((((((pInst->NF*Weff)*Leff)*T6_Vgi_bi)*ToxRatio*Vg)+(((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg_Vgi_bi))*Vaux_Igbacc)+((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc_Vgi_bi))*T5)+(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*T5_Vgi_bi));
igbacc_Vdi_bi=(((((((pInst->NF*Weff)*Leff)*T6_Vdi_bi)*ToxRatio*Vg*Vaux_Igbacc)+((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc_Vdi_bi))*T5)+(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*T5_Vdi_bi));
igbacc_Vsi_bi=(((((((pInst->NF*Weff)*Leff)*T6_Vsi_bi)*ToxRatio*Vg*Vaux_Igbacc)+((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc_Vsi_bi))*T5)+(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*T5_Vsi_bi));
igbacc_Tempt_GND=(((((((pInst->NF*Weff)*Leff)*T6_Tempt_GND)*ToxRatio*Vg*Vaux_Igbacc)+((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc_Tempt_GND))*T5)+(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*T5_Tempt_GND));
#endif
igbacc=(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*T5);
EXIT_IF_ISNAN((((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*T5))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igbacc_Vgi_bi=igbacc_Vgi_bi*igtemp;
igbacc_Vdi_bi=igbacc_Vdi_bi*igtemp;
igbacc_Vsi_bi=igbacc_Vsi_bi*igtemp;
igbacc_Tempt_GND=((igbacc_Tempt_GND*igtemp)+(igbacc*igtemp_Tempt_GND));
#endif
igbacc=(igbacc*igtemp);
EXIT_IF_ISNAN((igbacc*igtemp))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=((Voxminv_Vgi_bi/NIGBINV_i)/Vt);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vgi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vgi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vgm_si=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vgi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vgi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vdbulk_di=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vgi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vgi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vsbulk_si=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vgi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vgi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vgi_bi=(((+Voxminv_Vgi_bi_Vgi_bi-0.0)/NIGBINV_i-(Voxminv_Vgi_bi*0.0+Voxminv_Vgi_bi*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vgi_bi/NIGBINV_i)*0.0+(Voxminv_Vgi_bi/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vdi_bi=(((+Voxminv_Vgi_bi_Vdi_bi-0.0)/NIGBINV_i-(Voxminv_Vgi_bi*0.0+Voxminv_Vdi_bi*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vgi_bi/NIGBINV_i)*0.0+(Voxminv_Vdi_bi/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Vsi_bi=(((+Voxminv_Vgi_bi_Vsi_bi-0.0)/NIGBINV_i-(Voxminv_Vgi_bi*0.0+Voxminv_Vsi_bi*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vgi_bi/NIGBINV_i)*0.0+(Voxminv_Vsi_bi/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vgi_bi_Tempt_GND=(((+Voxminv_Vgi_bi_Tempt_GND-0.0)/NIGBINV_i-(Voxminv_Vgi_bi*0.0+Voxminv_Tempt_GND*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vgi_bi/NIGBINV_i)*Vt_Tempt_GND+(Voxminv_Tempt_GND/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*Vt_Tempt_GND/Vt/Vt/Vt);
#endif
T1_Vdi_bi=((Voxminv_Vdi_bi/NIGBINV_i)/Vt);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vdi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vdi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vgm_si=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vdi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vdi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vdbulk_di=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vdi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vdi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vsbulk_si=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vdi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vdi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vgi_bi=(((+Voxminv_Vdi_bi_Vgi_bi-0.0)/NIGBINV_i-(Voxminv_Vdi_bi*0.0+Voxminv_Vgi_bi*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vdi_bi/NIGBINV_i)*0.0+(Voxminv_Vgi_bi/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vdi_bi=(((+Voxminv_Vdi_bi_Vdi_bi-0.0)/NIGBINV_i-(Voxminv_Vdi_bi*0.0+Voxminv_Vdi_bi*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vdi_bi/NIGBINV_i)*0.0+(Voxminv_Vdi_bi/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Vsi_bi=(((+Voxminv_Vdi_bi_Vsi_bi-0.0)/NIGBINV_i-(Voxminv_Vdi_bi*0.0+Voxminv_Vsi_bi*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vdi_bi/NIGBINV_i)*0.0+(Voxminv_Vsi_bi/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vdi_bi_Tempt_GND=(((+Voxminv_Vdi_bi_Tempt_GND-0.0)/NIGBINV_i-(Voxminv_Vdi_bi*0.0+Voxminv_Tempt_GND*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vdi_bi/NIGBINV_i)*Vt_Tempt_GND+(Voxminv_Tempt_GND/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*Vt_Tempt_GND/Vt/Vt/Vt);
#endif
T1_Vsi_bi=((Voxminv_Vsi_bi/NIGBINV_i)/Vt);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vsi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vsi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vgm_si=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vsi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vsi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vdbulk_di=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vsi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vsi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vsbulk_si=(((+0.0-0.0)/NIGBINV_i-(Voxminv_Vsi_bi*0.0+0.0*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vsi_bi/NIGBINV_i)*0.0+0.0*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vgi_bi=(((+Voxminv_Vsi_bi_Vgi_bi-0.0)/NIGBINV_i-(Voxminv_Vsi_bi*0.0+Voxminv_Vgi_bi*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vsi_bi/NIGBINV_i)*0.0+(Voxminv_Vgi_bi/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vdi_bi=(((+Voxminv_Vsi_bi_Vdi_bi-0.0)/NIGBINV_i-(Voxminv_Vsi_bi*0.0+Voxminv_Vdi_bi*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vsi_bi/NIGBINV_i)*0.0+(Voxminv_Vdi_bi/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Vsi_bi=(((+Voxminv_Vsi_bi_Vsi_bi-0.0)/NIGBINV_i-(Voxminv_Vsi_bi*0.0+Voxminv_Vsi_bi*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vsi_bi/NIGBINV_i)*0.0+(Voxminv_Vsi_bi/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vt/Vt/Vt);
  T1_Vsi_bi_Tempt_GND=(((+Voxminv_Vsi_bi_Tempt_GND-0.0)/NIGBINV_i-(Voxminv_Vsi_bi*0.0+Voxminv_Tempt_GND*0.0+(Voxminv-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(Voxminv-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vt-((Voxminv_Vsi_bi/NIGBINV_i)*Vt_Tempt_GND+(Voxminv_Tempt_GND/NIGBINV_i)*0.0+((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0)/Vt/Vt+2*((Voxminv-EIGBINV_i)/NIGBINV_i)*0.0*Vt_Tempt_GND/Vt/Vt/Vt);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((Voxminv_Tempt_GND/NIGBINV_i)*Vt-((Voxminv-EIGBINV_i)/NIGBINV_i)*Vt_Tempt_GND)/Vt/Vt);
#endif
#endif
T1=(((Voxminv-EIGBINV_i)/NIGBINV_i)/Vt);
EXIT_IF_ISNAN((((Voxminv-EIGBINV_i)/NIGBINV_i)/Vt))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
Vaux_Igbinv_Tempt_GND=(((NIGBINV_i*Vt_Tempt_GND)*bsimbulk_lln((1.0+bsimbulk_lexp(T1))))+((NIGBINV_i*Vt)*bsimbulk_d_lln((1.0+bsimbulk_lexp(T1)),bsimbulk_d_lexp(T1,T1_Tempt_GND))));
Vaux_Igbinv_Vgi_bi=((NIGBINV_i*Vt)*bsimbulk_d_lln((1.0+bsimbulk_lexp(T1)),bsimbulk_d_lexp(T1,T1_Vgi_bi)));
Vaux_Igbinv_Vdi_bi=((NIGBINV_i*Vt)*bsimbulk_d_lln((1.0+bsimbulk_lexp(T1)),bsimbulk_d_lexp(T1,T1_Vdi_bi)));
Vaux_Igbinv_Vsi_bi=((NIGBINV_i*Vt)*bsimbulk_d_lln((1.0+bsimbulk_lexp(T1)),bsimbulk_d_lexp(T1,T1_Vsi_bi)));
#endif
Vaux_Igbinv=((NIGBINV_i*Vt)*bsimbulk_lln((1.0+bsimbulk_lexp(T1))));
EXIT_IF_ISNAN(((NIGBINV_i*Vt)*bsimbulk_lln((1.0+bsimbulk_lexp(T1)))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(-(BIGBINV_i*Voxminv_Vgi_bi));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+BIGBINV_i*0.0));
  T2_Vgi_bi_Vgm_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+BIGBINV_i*0.0));
  T2_Vgi_bi_Vdbulk_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+BIGBINV_i*0.0));
  T2_Vgi_bi_Vsbulk_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+BIGBINV_i*0.0));
  T2_Vgi_bi_Vgi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vgi_bi+BIGBINV_i*Voxminv_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vgi_bi+BIGBINV_i*Voxminv_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vgi_bi+BIGBINV_i*Voxminv_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vgi_bi+BIGBINV_i*Voxminv_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(-(BIGBINV_i*Voxminv_Vdi_bi));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+BIGBINV_i*0.0));
  T2_Vdi_bi_Vgm_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+BIGBINV_i*0.0));
  T2_Vdi_bi_Vdbulk_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+BIGBINV_i*0.0));
  T2_Vdi_bi_Vsbulk_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+BIGBINV_i*0.0));
  T2_Vdi_bi_Vgi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vdi_bi+BIGBINV_i*Voxminv_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vdi_bi+BIGBINV_i*Voxminv_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vdi_bi+BIGBINV_i*Voxminv_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vdi_bi+BIGBINV_i*Voxminv_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(-(BIGBINV_i*Voxminv_Vsi_bi));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+BIGBINV_i*0.0));
  T2_Vsi_bi_Vgm_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+BIGBINV_i*0.0));
  T2_Vsi_bi_Vdbulk_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+BIGBINV_i*0.0));
  T2_Vsi_bi_Vsbulk_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+BIGBINV_i*0.0));
  T2_Vsi_bi_Vgi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vsi_bi+BIGBINV_i*Voxminv_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vsi_bi+BIGBINV_i*Voxminv_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vsi_bi+BIGBINV_i*Voxminv_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vsi_bi+BIGBINV_i*Voxminv_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(-(BIGBINV_i*Voxminv_Tempt_GND));
#endif
#endif
T2=(AIGBINV_i-(BIGBINV_i*Voxminv));
EXIT_IF_ISNAN((AIGBINV_i-(BIGBINV_i*Voxminv)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(CIGBINV_i*Voxminv_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+CIGBINV_i*0.0));
  T3_Vgi_bi_Vgm_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+CIGBINV_i*0.0));
  T3_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+CIGBINV_i*0.0));
  T3_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+CIGBINV_i*0.0));
  T3_Vgi_bi_Vgi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vgi_bi+CIGBINV_i*Voxminv_Vgi_bi_Vgi_bi));
  T3_Vgi_bi_Vdi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vgi_bi+CIGBINV_i*Voxminv_Vgi_bi_Vdi_bi));
  T3_Vgi_bi_Vsi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vgi_bi+CIGBINV_i*Voxminv_Vgi_bi_Vsi_bi));
  T3_Vgi_bi_Tempt_GND=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vgi_bi+CIGBINV_i*Voxminv_Vgi_bi_Tempt_GND));
#endif
T3_Vdi_bi=(CIGBINV_i*Voxminv_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+CIGBINV_i*0.0));
  T3_Vdi_bi_Vgm_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+CIGBINV_i*0.0));
  T3_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+CIGBINV_i*0.0));
  T3_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+CIGBINV_i*0.0));
  T3_Vdi_bi_Vgi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vdi_bi+CIGBINV_i*Voxminv_Vdi_bi_Vgi_bi));
  T3_Vdi_bi_Vdi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vdi_bi+CIGBINV_i*Voxminv_Vdi_bi_Vdi_bi));
  T3_Vdi_bi_Vsi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vdi_bi+CIGBINV_i*Voxminv_Vdi_bi_Vsi_bi));
  T3_Vdi_bi_Tempt_GND=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vdi_bi+CIGBINV_i*Voxminv_Vdi_bi_Tempt_GND));
#endif
T3_Vsi_bi=(CIGBINV_i*Voxminv_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+CIGBINV_i*0.0));
  T3_Vsi_bi_Vgm_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+CIGBINV_i*0.0));
  T3_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+CIGBINV_i*0.0));
  T3_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+CIGBINV_i*0.0));
  T3_Vsi_bi_Vgi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vsi_bi+CIGBINV_i*Voxminv_Vsi_bi_Vgi_bi));
  T3_Vsi_bi_Vdi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vsi_bi+CIGBINV_i*Voxminv_Vsi_bi_Vdi_bi));
  T3_Vsi_bi_Vsi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vsi_bi+CIGBINV_i*Voxminv_Vsi_bi_Vsi_bi));
  T3_Vsi_bi_Tempt_GND=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vsi_bi+CIGBINV_i*Voxminv_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(CIGBINV_i*Voxminv_Tempt_GND);
#endif
#endif
T3=(1.0+(CIGBINV_i*Voxminv));
EXIT_IF_ISNAN((1.0+(CIGBINV_i*Voxminv)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(((((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)*T3)+((((-9.82222e11)*pModel->TOXE)*T2)*T3_Vgi_bi));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vgm_si+(0.0)*T2_Vgi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi_Vgm_si)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vgm_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vgm_si)))*T3_Vgi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vgm_di+(0.0)*T2_Vgi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi_Vgm_di)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vgm_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vgm_di)))*T3_Vgi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdbulk_di+(0.0)*T2_Vgi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi_Vdbulk_di)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vdbulk_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vdbulk_di)))*T3_Vgi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vsbulk_si+(0.0)*T2_Vgi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi_Vsbulk_si)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vsbulk_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vsbulk_si)))*T3_Vgi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vgi_bi+(0.0)*T2_Vgi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi_Vgi_bi)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vgi_bi+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)))*T3_Vgi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_bi+(0.0)*T2_Vgi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi_Vdi_bi)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vdi_bi+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)))*T3_Vgi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vsi_bi+(0.0)*T2_Vgi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi_Vsi_bi)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Vsi_bi+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)))*T3_Vgi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vgi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Tempt_GND)))*T3_Vgi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)*T3)+((((-9.82222e11)*pModel->TOXE)*T2)*T3_Vdi_bi));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vgm_si+(0.0)*T2_Vdi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi_Vgm_si)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vgm_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vgm_si)))*T3_Vdi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vgm_di+(0.0)*T2_Vdi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi_Vgm_di)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vgm_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vgm_di)))*T3_Vdi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdbulk_di+(0.0)*T2_Vdi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi_Vdbulk_di)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vdbulk_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vdbulk_di)))*T3_Vdi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vsbulk_si+(0.0)*T2_Vdi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi_Vsbulk_si)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vsbulk_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vsbulk_si)))*T3_Vdi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vgi_bi+(0.0)*T2_Vdi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi_Vgi_bi)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vgi_bi+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)))*T3_Vdi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_bi+(0.0)*T2_Vdi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi_Vdi_bi)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vdi_bi+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)))*T3_Vdi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vsi_bi+(0.0)*T2_Vdi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi_Vsi_bi)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Vsi_bi+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)))*T3_Vdi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vdi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Tempt_GND)))*T3_Vdi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)*T3)+((((-9.82222e11)*pModel->TOXE)*T2)*T3_Vsi_bi));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vgm_si+(0.0)*T2_Vsi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi_Vgm_si)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vgm_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vgm_si)))*T3_Vsi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vgm_di+(0.0)*T2_Vsi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi_Vgm_di)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vgm_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vgm_di)))*T3_Vsi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdbulk_di+(0.0)*T2_Vsi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi_Vdbulk_di)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vdbulk_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vdbulk_di)))*T3_Vsi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vsbulk_si+(0.0)*T2_Vsi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi_Vsbulk_si)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vsbulk_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vsbulk_si)))*T3_Vsi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vgi_bi+(0.0)*T2_Vsi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi_Vgi_bi)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vgi_bi+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vgi_bi)))*T3_Vsi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_bi+(0.0)*T2_Vsi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi_Vdi_bi)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vdi_bi+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vdi_bi)))*T3_Vsi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vsi_bi+(0.0)*T2_Vsi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi_Vsi_bi)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Vsi_bi+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)))*T3_Vsi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*pModel->TOXE+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vsi_bi+((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXE)*T2_Vsi_bi)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXE)*T2_Tempt_GND)))*T3_Vsi_bi+(((-9.82222e11)*pModel->TOXE)*T2)*T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((((-9.82222e11)*pModel->TOXE)*T2_Tempt_GND)*T3)+((((-9.82222e11)*pModel->TOXE)*T2)*T3_Tempt_GND));
#endif
#endif
T4=((((-9.82222e11)*pModel->TOXE)*T2)*T3);
EXIT_IF_ISNAN(((((-9.82222e11)*pModel->TOXE)*T2)*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=bsimbulk_d_lexp(T4,T4_Vgi_bi);
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=T4_Vgi_bi_Vgm_si;
  T5_Vgi_bi_Vgm_di=T4_Vgi_bi_Vgm_di;
  T5_Vgi_bi_Vdbulk_di=T4_Vgi_bi_Vdbulk_di;
  T5_Vgi_bi_Vsbulk_si=T4_Vgi_bi_Vsbulk_si;
  T5_Vgi_bi_Vgi_bi=T4_Vgi_bi_Vgi_bi;
  T5_Vgi_bi_Vdi_bi=T4_Vgi_bi_Vdi_bi;
  T5_Vgi_bi_Vsi_bi=T4_Vgi_bi_Vsi_bi;
  T5_Vgi_bi_Tempt_GND=T4_Vgi_bi_Tempt_GND;
#endif
T5_Vdi_bi=bsimbulk_d_lexp(T4,T4_Vdi_bi);
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=T4_Vdi_bi_Vgm_si;
  T5_Vdi_bi_Vgm_di=T4_Vdi_bi_Vgm_di;
  T5_Vdi_bi_Vdbulk_di=T4_Vdi_bi_Vdbulk_di;
  T5_Vdi_bi_Vsbulk_si=T4_Vdi_bi_Vsbulk_si;
  T5_Vdi_bi_Vgi_bi=T4_Vdi_bi_Vgi_bi;
  T5_Vdi_bi_Vdi_bi=T4_Vdi_bi_Vdi_bi;
  T5_Vdi_bi_Vsi_bi=T4_Vdi_bi_Vsi_bi;
  T5_Vdi_bi_Tempt_GND=T4_Vdi_bi_Tempt_GND;
#endif
T5_Vsi_bi=bsimbulk_d_lexp(T4,T4_Vsi_bi);
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=T4_Vsi_bi_Vgm_si;
  T5_Vsi_bi_Vgm_di=T4_Vsi_bi_Vgm_di;
  T5_Vsi_bi_Vdbulk_di=T4_Vsi_bi_Vdbulk_di;
  T5_Vsi_bi_Vsbulk_si=T4_Vsi_bi_Vsbulk_si;
  T5_Vsi_bi_Vgi_bi=T4_Vsi_bi_Vgi_bi;
  T5_Vsi_bi_Vdi_bi=T4_Vsi_bi_Vdi_bi;
  T5_Vsi_bi_Vsi_bi=T4_Vsi_bi_Vsi_bi;
  T5_Vsi_bi_Tempt_GND=T4_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=bsimbulk_d_lexp(T4,T4_Tempt_GND);
#endif
#endif
T5=bsimbulk_lexp(T4);
EXIT_IF_ISNAN(bsimbulk_lexp(T4))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=0.0;
  T6_Vgi_bi_Vgm_si=0.0;
  T6_Vgi_bi_Vdbulk_di=0.0;
  T6_Vgi_bi_Vsbulk_si=0.0;
  T6_Vgi_bi_Vgi_bi=0.0;
  T6_Vgi_bi_Vdi_bi=0.0;
  T6_Vgi_bi_Vsi_bi=0.0;
  T6_Vgi_bi_Tempt_GND=0.0;
#endif
T6_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=0.0;
  T6_Vdi_bi_Vgm_si=0.0;
  T6_Vdi_bi_Vdbulk_di=0.0;
  T6_Vdi_bi_Vsbulk_si=0.0;
  T6_Vdi_bi_Vgi_bi=0.0;
  T6_Vdi_bi_Vdi_bi=0.0;
  T6_Vdi_bi_Vsi_bi=0.0;
  T6_Vdi_bi_Tempt_GND=0.0;
#endif
T6_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=0.0;
  T6_Vsi_bi_Vgm_si=0.0;
  T6_Vsi_bi_Vdbulk_di=0.0;
  T6_Vsi_bi_Vsbulk_si=0.0;
  T6_Vsi_bi_Vgi_bi=0.0;
  T6_Vsi_bi_Vdi_bi=0.0;
  T6_Vsi_bi_Vsi_bi=0.0;
  T6_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=0.0;
#endif
#endif
T6=3.75956e-7;
EXIT_IF_ISNAN(3.75956e-7)
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igbinv_Vgi_bi=(((((((((pInst->NF*Weff)*Leff)*T6_Vgi_bi)*ToxRatio*Vg)+(((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg_Vgi_bi))*Vaux_Igbinv)+((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv_Vgi_bi))*T5)+(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*T5_Vgi_bi));
igbinv_Vdi_bi=(((((((pInst->NF*Weff)*Leff)*T6_Vdi_bi)*ToxRatio*Vg*Vaux_Igbinv)+((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv_Vdi_bi))*T5)+(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*T5_Vdi_bi));
igbinv_Vsi_bi=(((((((pInst->NF*Weff)*Leff)*T6_Vsi_bi)*ToxRatio*Vg*Vaux_Igbinv)+((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv_Vsi_bi))*T5)+(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*T5_Vsi_bi));
igbinv_Tempt_GND=(((((((pInst->NF*Weff)*Leff)*T6_Tempt_GND)*ToxRatio*Vg*Vaux_Igbinv)+((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv_Tempt_GND))*T5)+(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*T5_Tempt_GND));
#endif
igbinv=(((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*T5);
EXIT_IF_ISNAN((((((((pInst->NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*T5))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igbinv_Vgi_bi=igbinv_Vgi_bi*igtemp;
igbinv_Vdi_bi=igbinv_Vdi_bi*igtemp;
igbinv_Vsi_bi=igbinv_Vsi_bi*igtemp;
igbinv_Tempt_GND=((igbinv_Tempt_GND*igtemp)+(igbinv*igtemp_Tempt_GND));
#endif
igbinv=(igbinv*igtemp);
EXIT_IF_ISNAN((igbinv*igtemp))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igb_Vgi_bi=(igbacc_Vgi_bi+igbinv_Vgi_bi);
igb_Vdi_bi=(igbacc_Vdi_bi+igbinv_Vdi_bi);
igb_Vsi_bi=(igbacc_Vsi_bi+igbinv_Vsi_bi);
igb_Tempt_GND=(igbacc_Tempt_GND+igbinv_Tempt_GND);
#endif
igb=(igbacc+igbinv);
EXIT_IF_ISNAN((igbacc+igbinv))
}
if
((pModel->IGCMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(-(BIGC_i*Voxminv_Vgi_bi));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+BIGC_i*0.0));
  T1_Vgi_bi_Vgm_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+BIGC_i*0.0));
  T1_Vgi_bi_Vdbulk_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+BIGC_i*0.0));
  T1_Vgi_bi_Vsbulk_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+BIGC_i*0.0));
  T1_Vgi_bi_Vgi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vgi_bi+BIGC_i*Voxminv_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vgi_bi+BIGC_i*Voxminv_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vgi_bi+BIGC_i*Voxminv_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vgi_bi+BIGC_i*Voxminv_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(-(BIGC_i*Voxminv_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+BIGC_i*0.0));
  T1_Vdi_bi_Vgm_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+BIGC_i*0.0));
  T1_Vdi_bi_Vdbulk_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+BIGC_i*0.0));
  T1_Vdi_bi_Vsbulk_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+BIGC_i*0.0));
  T1_Vdi_bi_Vgi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vdi_bi+BIGC_i*Voxminv_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vdi_bi+BIGC_i*Voxminv_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vdi_bi+BIGC_i*Voxminv_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vdi_bi+BIGC_i*Voxminv_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(-(BIGC_i*Voxminv_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+BIGC_i*0.0));
  T1_Vsi_bi_Vgm_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+BIGC_i*0.0));
  T1_Vsi_bi_Vdbulk_di=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+BIGC_i*0.0));
  T1_Vsi_bi_Vsbulk_si=(+0.0-(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+BIGC_i*0.0));
  T1_Vsi_bi_Vgi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vsi_bi+BIGC_i*Voxminv_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vsi_bi+BIGC_i*Voxminv_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vsi_bi+BIGC_i*Voxminv_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+0.0-(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vsi_bi+BIGC_i*Voxminv_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-(BIGC_i*Voxminv_Tempt_GND));
#endif
#endif
T1=(AIGC_i-(BIGC_i*Voxminv));
EXIT_IF_ISNAN((AIGC_i-(BIGC_i*Voxminv)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(CIGC_i*Voxminv_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+CIGC_i*0.0));
  T2_Vgi_bi_Vgm_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+CIGC_i*0.0));
  T2_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+CIGC_i*0.0));
  T2_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vgi_bi+CIGC_i*0.0));
  T2_Vgi_bi_Vgi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vgi_bi+CIGC_i*Voxminv_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vgi_bi+CIGC_i*Voxminv_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vgi_bi+CIGC_i*Voxminv_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vgi_bi+CIGC_i*Voxminv_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(CIGC_i*Voxminv_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+CIGC_i*0.0));
  T2_Vdi_bi_Vgm_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+CIGC_i*0.0));
  T2_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+CIGC_i*0.0));
  T2_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vdi_bi+CIGC_i*0.0));
  T2_Vdi_bi_Vgi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vdi_bi+CIGC_i*Voxminv_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vdi_bi+CIGC_i*Voxminv_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vdi_bi+CIGC_i*Voxminv_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vdi_bi+CIGC_i*Voxminv_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(CIGC_i*Voxminv_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+CIGC_i*0.0));
  T2_Vsi_bi_Vgm_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+CIGC_i*0.0));
  T2_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+CIGC_i*0.0));
  T2_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*Voxminv+0.0*0.0+0.0*Voxminv_Vsi_bi+CIGC_i*0.0));
  T2_Vsi_bi_Vgi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vgi_bi+0.0*Voxminv_Vsi_bi+CIGC_i*Voxminv_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vdi_bi+0.0*Voxminv_Vsi_bi+CIGC_i*Voxminv_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Vsi_bi+0.0*Voxminv_Vsi_bi+CIGC_i*Voxminv_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+0.0+(+0.0*Voxminv+0.0*Voxminv_Tempt_GND+0.0*Voxminv_Vsi_bi+CIGC_i*Voxminv_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(CIGC_i*Voxminv_Tempt_GND);
#endif
#endif
T2=(1.0+(CIGC_i*Voxminv));
EXIT_IF_ISNAN((1.0+(CIGC_i*Voxminv)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(((Bechvb*T1_Vgi_bi)*T2)+((Bechvb*T1)*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+Bechvb*T1_Vgi_bi_Vgm_si)*T2+(Bechvb*T1_Vgi_bi)*T2_Vgm_si+((Bechvb*T1_Vgm_si))*T2_Vgi_bi+(Bechvb*T1)*T2_Vgi_bi_Vgm_si);
  T3_Vgi_bi_Vgm_di=(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+Bechvb*T1_Vgi_bi_Vgm_di)*T2+(Bechvb*T1_Vgi_bi)*T2_Vgm_di+((Bechvb*T1_Vgm_di))*T2_Vgi_bi+(Bechvb*T1)*T2_Vgi_bi_Vgm_di);
  T3_Vgi_bi_Vdbulk_di=(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+Bechvb*T1_Vgi_bi_Vdbulk_di)*T2+(Bechvb*T1_Vgi_bi)*T2_Vdbulk_di+((Bechvb*T1_Vdbulk_di))*T2_Vgi_bi+(Bechvb*T1)*T2_Vgi_bi_Vdbulk_di);
  T3_Vgi_bi_Vsbulk_si=(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+Bechvb*T1_Vgi_bi_Vsbulk_si)*T2+(Bechvb*T1_Vgi_bi)*T2_Vsbulk_si+((Bechvb*T1_Vsbulk_si))*T2_Vgi_bi+(Bechvb*T1)*T2_Vgi_bi_Vsbulk_si);
  T3_Vgi_bi_Vgi_bi=(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+Bechvb*T1_Vgi_bi_Vgi_bi)*T2+(Bechvb*T1_Vgi_bi)*T2_Vgi_bi+((Bechvb*T1_Vgi_bi))*T2_Vgi_bi+(Bechvb*T1)*T2_Vgi_bi_Vgi_bi);
  T3_Vgi_bi_Vdi_bi=(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+Bechvb*T1_Vgi_bi_Vdi_bi)*T2+(Bechvb*T1_Vgi_bi)*T2_Vdi_bi+((Bechvb*T1_Vdi_bi))*T2_Vgi_bi+(Bechvb*T1)*T2_Vgi_bi_Vdi_bi);
  T3_Vgi_bi_Vsi_bi=(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+Bechvb*T1_Vgi_bi_Vsi_bi)*T2+(Bechvb*T1_Vgi_bi)*T2_Vsi_bi+((Bechvb*T1_Vsi_bi))*T2_Vgi_bi+(Bechvb*T1)*T2_Vgi_bi_Vsi_bi);
  T3_Vgi_bi_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+Bechvb*T1_Vgi_bi_Tempt_GND)*T2+(Bechvb*T1_Vgi_bi)*T2_Tempt_GND+((Bechvb*T1_Tempt_GND))*T2_Vgi_bi+(Bechvb*T1)*T2_Vgi_bi_Tempt_GND);
#endif
T3_Vdi_bi=(((Bechvb*T1_Vdi_bi)*T2)+((Bechvb*T1)*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+Bechvb*T1_Vdi_bi_Vgm_si)*T2+(Bechvb*T1_Vdi_bi)*T2_Vgm_si+((Bechvb*T1_Vgm_si))*T2_Vdi_bi+(Bechvb*T1)*T2_Vdi_bi_Vgm_si);
  T3_Vdi_bi_Vgm_di=(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+Bechvb*T1_Vdi_bi_Vgm_di)*T2+(Bechvb*T1_Vdi_bi)*T2_Vgm_di+((Bechvb*T1_Vgm_di))*T2_Vdi_bi+(Bechvb*T1)*T2_Vdi_bi_Vgm_di);
  T3_Vdi_bi_Vdbulk_di=(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+Bechvb*T1_Vdi_bi_Vdbulk_di)*T2+(Bechvb*T1_Vdi_bi)*T2_Vdbulk_di+((Bechvb*T1_Vdbulk_di))*T2_Vdi_bi+(Bechvb*T1)*T2_Vdi_bi_Vdbulk_di);
  T3_Vdi_bi_Vsbulk_si=(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+Bechvb*T1_Vdi_bi_Vsbulk_si)*T2+(Bechvb*T1_Vdi_bi)*T2_Vsbulk_si+((Bechvb*T1_Vsbulk_si))*T2_Vdi_bi+(Bechvb*T1)*T2_Vdi_bi_Vsbulk_si);
  T3_Vdi_bi_Vgi_bi=(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+Bechvb*T1_Vdi_bi_Vgi_bi)*T2+(Bechvb*T1_Vdi_bi)*T2_Vgi_bi+((Bechvb*T1_Vgi_bi))*T2_Vdi_bi+(Bechvb*T1)*T2_Vdi_bi_Vgi_bi);
  T3_Vdi_bi_Vdi_bi=(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+Bechvb*T1_Vdi_bi_Vdi_bi)*T2+(Bechvb*T1_Vdi_bi)*T2_Vdi_bi+((Bechvb*T1_Vdi_bi))*T2_Vdi_bi+(Bechvb*T1)*T2_Vdi_bi_Vdi_bi);
  T3_Vdi_bi_Vsi_bi=(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+Bechvb*T1_Vdi_bi_Vsi_bi)*T2+(Bechvb*T1_Vdi_bi)*T2_Vsi_bi+((Bechvb*T1_Vsi_bi))*T2_Vdi_bi+(Bechvb*T1)*T2_Vdi_bi_Vsi_bi);
  T3_Vdi_bi_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+Bechvb*T1_Vdi_bi_Tempt_GND)*T2+(Bechvb*T1_Vdi_bi)*T2_Tempt_GND+((Bechvb*T1_Tempt_GND))*T2_Vdi_bi+(Bechvb*T1)*T2_Vdi_bi_Tempt_GND);
#endif
T3_Vsi_bi=(((Bechvb*T1_Vsi_bi)*T2)+((Bechvb*T1)*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+Bechvb*T1_Vsi_bi_Vgm_si)*T2+(Bechvb*T1_Vsi_bi)*T2_Vgm_si+((Bechvb*T1_Vgm_si))*T2_Vsi_bi+(Bechvb*T1)*T2_Vsi_bi_Vgm_si);
  T3_Vsi_bi_Vgm_di=(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+Bechvb*T1_Vsi_bi_Vgm_di)*T2+(Bechvb*T1_Vsi_bi)*T2_Vgm_di+((Bechvb*T1_Vgm_di))*T2_Vsi_bi+(Bechvb*T1)*T2_Vsi_bi_Vgm_di);
  T3_Vsi_bi_Vdbulk_di=(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+Bechvb*T1_Vsi_bi_Vdbulk_di)*T2+(Bechvb*T1_Vsi_bi)*T2_Vdbulk_di+((Bechvb*T1_Vdbulk_di))*T2_Vsi_bi+(Bechvb*T1)*T2_Vsi_bi_Vdbulk_di);
  T3_Vsi_bi_Vsbulk_si=(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+Bechvb*T1_Vsi_bi_Vsbulk_si)*T2+(Bechvb*T1_Vsi_bi)*T2_Vsbulk_si+((Bechvb*T1_Vsbulk_si))*T2_Vsi_bi+(Bechvb*T1)*T2_Vsi_bi_Vsbulk_si);
  T3_Vsi_bi_Vgi_bi=(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+Bechvb*T1_Vsi_bi_Vgi_bi)*T2+(Bechvb*T1_Vsi_bi)*T2_Vgi_bi+((Bechvb*T1_Vgi_bi))*T2_Vsi_bi+(Bechvb*T1)*T2_Vsi_bi_Vgi_bi);
  T3_Vsi_bi_Vdi_bi=(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+Bechvb*T1_Vsi_bi_Vdi_bi)*T2+(Bechvb*T1_Vsi_bi)*T2_Vdi_bi+((Bechvb*T1_Vdi_bi))*T2_Vsi_bi+(Bechvb*T1)*T2_Vsi_bi_Vdi_bi);
  T3_Vsi_bi_Vsi_bi=(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+Bechvb*T1_Vsi_bi_Vsi_bi)*T2+(Bechvb*T1_Vsi_bi)*T2_Vsi_bi+((Bechvb*T1_Vsi_bi))*T2_Vsi_bi+(Bechvb*T1)*T2_Vsi_bi_Vsi_bi);
  T3_Vsi_bi_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+Bechvb*T1_Vsi_bi_Tempt_GND)*T2+(Bechvb*T1_Vsi_bi)*T2_Tempt_GND+((Bechvb*T1_Tempt_GND))*T2_Vsi_bi+(Bechvb*T1)*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(((Bechvb*T1_Tempt_GND)*T2)+((Bechvb*T1)*T2_Tempt_GND));
#endif
#endif
T3=((Bechvb*T1)*T2);
EXIT_IF_ISNAN(((Bechvb*T1)*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=((((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)))*bsimbulk_lexp(T3))+(((nq*nVt)*(qs+qdeff))*bsimbulk_d_lexp(T3,T3_Vgi_bi)));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+nq_Vgi_bi_Vgm_si*nVt+nq_Vgi_bi*nVt_Vgm_si+nq_Vgm_si*nVt_Vgi_bi+nq*nVt_Vgi_bi_Vgm_si)*(qs+qdeff)+((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs_Vgm_si+qdeff_Vgm_si)+(((nq_Vgm_si*nVt)+(nq*nVt_Vgm_si)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*nVt)*(+qs_Vgi_bi_Vgm_si+qdeff_Vgi_bi_Vgm_si))*bsimbulk_lexp(T3)+((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((((((nq_Vgm_si*nVt)+(nq*nVt_Vgm_si)))*(qs+qdeff))+((nq*nVt)*(qs_Vgm_si+qdeff_Vgm_si))))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+nq_Vgi_bi_Vgm_di*nVt+nq_Vgi_bi*0.0+nq_Vgm_di*nVt_Vgi_bi+nq*0.0)*(qs+qdeff)+((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs_Vgm_di+qdeff_Vgm_di)+(nq_Vgm_di*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*nVt)*(+qs_Vgi_bi_Vgm_di+qdeff_Vgi_bi_Vgm_di))*bsimbulk_lexp(T3)+((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((((nq_Vgm_di*nVt)*(qs+qdeff))+((nq*nVt)*(qs_Vgm_di+qdeff_Vgm_di))))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+nq_Vgi_bi_Vdbulk_di*nVt+nq_Vgi_bi*nVt_Vdbulk_di+nq_Vdbulk_di*nVt_Vgi_bi+nq*nVt_Vgi_bi_Vdbulk_di)*(qs+qdeff)+((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(((nq_Vdbulk_di*nVt)+(nq*nVt_Vdbulk_di)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*nVt)*(+qs_Vgi_bi_Vdbulk_di+qdeff_Vgi_bi_Vdbulk_di))*bsimbulk_lexp(T3)+((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((((((nq_Vdbulk_di*nVt)+(nq*nVt_Vdbulk_di)))*(qs+qdeff))+((nq*nVt)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+nq_Vgi_bi_Vsbulk_si*nVt+nq_Vgi_bi*nVt_Vsbulk_si+nq_Vsbulk_si*nVt_Vgi_bi+nq*nVt_Vgi_bi_Vsbulk_si)*(qs+qdeff)+((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(((nq_Vsbulk_si*nVt)+(nq*nVt_Vsbulk_si)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*nVt)*(+qs_Vgi_bi_Vsbulk_si+qdeff_Vgi_bi_Vsbulk_si))*bsimbulk_lexp(T3)+((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((((((nq_Vsbulk_si*nVt)+(nq*nVt_Vsbulk_si)))*(qs+qdeff))+((nq*nVt)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+nq_Vgi_bi_Vgi_bi*nVt+nq_Vgi_bi*nVt_Vgi_bi+nq_Vgi_bi*nVt_Vgi_bi+nq*nVt_Vgi_bi_Vgi_bi)*(qs+qdeff)+((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs_Vgi_bi+qdeff_Vgi_bi)+(((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*nVt)*(+qs_Vgi_bi_Vgi_bi+qdeff_Vgi_bi_Vgi_bi))*bsimbulk_lexp(T3)+((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi)))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi))))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+nq_Vgi_bi_Vdi_bi*nVt+nq_Vgi_bi*nVt_Vdi_bi+nq_Vdi_bi*nVt_Vgi_bi+nq*nVt_Vgi_bi_Vdi_bi)*(qs+qdeff)+((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs_Vdi_bi+qdeff_Vdi_bi)+(((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*nVt)*(+qs_Vgi_bi_Vdi_bi+qdeff_Vgi_bi_Vdi_bi))*bsimbulk_lexp(T3)+((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi)))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi))))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+nq_Vgi_bi_Vsi_bi*nVt+nq_Vgi_bi*nVt_Vsi_bi+nq_Vsi_bi*nVt_Vgi_bi+nq*nVt_Vgi_bi_Vsi_bi)*(qs+qdeff)+((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs_Vsi_bi+qdeff_Vsi_bi)+(((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*nVt)*(+qs_Vgi_bi_Vsi_bi+qdeff_Vgi_bi_Vsi_bi))*bsimbulk_lexp(T3)+((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi)))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi))))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+nq_Vgi_bi_Tempt_GND*nVt+nq_Vgi_bi*nVt_Tempt_GND+nq_Tempt_GND*nVt_Vgi_bi+nq*nVt_Vgi_bi_Tempt_GND)*(qs+qdeff)+((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs_Tempt_GND+qdeff_Tempt_GND)+(((nq_Tempt_GND*nVt)+(nq*nVt_Tempt_GND)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*nVt)*(+qs_Vgi_bi_Tempt_GND+qdeff_Vgi_bi_Tempt_GND))*bsimbulk_lexp(T3)+((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi)))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((((((nq_Tempt_GND*nVt)+(nq*nVt_Tempt_GND)))*(qs+qdeff))+((nq*nVt)*(qs_Tempt_GND+qdeff_Tempt_GND))))*bsimbulk_d_lexp(T3,T3_Vgi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=((((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)))*bsimbulk_lexp(T3))+(((nq*nVt)*(qs+qdeff))*bsimbulk_d_lexp(T3,T3_Vdi_bi)));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+nq_Vdi_bi_Vgm_si*nVt+nq_Vdi_bi*nVt_Vgm_si+nq_Vgm_si*nVt_Vdi_bi+nq*nVt_Vdi_bi_Vgm_si)*(qs+qdeff)+((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs_Vgm_si+qdeff_Vgm_si)+(((nq_Vgm_si*nVt)+(nq*nVt_Vgm_si)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*nVt)*(+qs_Vdi_bi_Vgm_si+qdeff_Vdi_bi_Vgm_si))*bsimbulk_lexp(T3)+((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((((((nq_Vgm_si*nVt)+(nq*nVt_Vgm_si)))*(qs+qdeff))+((nq*nVt)*(qs_Vgm_si+qdeff_Vgm_si))))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+nq_Vdi_bi_Vgm_di*nVt+nq_Vdi_bi*0.0+nq_Vgm_di*nVt_Vdi_bi+nq*0.0)*(qs+qdeff)+((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs_Vgm_di+qdeff_Vgm_di)+(nq_Vgm_di*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*nVt)*(+qs_Vdi_bi_Vgm_di+qdeff_Vdi_bi_Vgm_di))*bsimbulk_lexp(T3)+((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((((nq_Vgm_di*nVt)*(qs+qdeff))+((nq*nVt)*(qs_Vgm_di+qdeff_Vgm_di))))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+nq_Vdi_bi_Vdbulk_di*nVt+nq_Vdi_bi*nVt_Vdbulk_di+nq_Vdbulk_di*nVt_Vdi_bi+nq*nVt_Vdi_bi_Vdbulk_di)*(qs+qdeff)+((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(((nq_Vdbulk_di*nVt)+(nq*nVt_Vdbulk_di)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*nVt)*(+qs_Vdi_bi_Vdbulk_di+qdeff_Vdi_bi_Vdbulk_di))*bsimbulk_lexp(T3)+((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((((((nq_Vdbulk_di*nVt)+(nq*nVt_Vdbulk_di)))*(qs+qdeff))+((nq*nVt)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+nq_Vdi_bi_Vsbulk_si*nVt+nq_Vdi_bi*nVt_Vsbulk_si+nq_Vsbulk_si*nVt_Vdi_bi+nq*nVt_Vdi_bi_Vsbulk_si)*(qs+qdeff)+((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(((nq_Vsbulk_si*nVt)+(nq*nVt_Vsbulk_si)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*nVt)*(+qs_Vdi_bi_Vsbulk_si+qdeff_Vdi_bi_Vsbulk_si))*bsimbulk_lexp(T3)+((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((((((nq_Vsbulk_si*nVt)+(nq*nVt_Vsbulk_si)))*(qs+qdeff))+((nq*nVt)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+nq_Vdi_bi_Vgi_bi*nVt+nq_Vdi_bi*nVt_Vgi_bi+nq_Vgi_bi*nVt_Vdi_bi+nq*nVt_Vdi_bi_Vgi_bi)*(qs+qdeff)+((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs_Vgi_bi+qdeff_Vgi_bi)+(((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*nVt)*(+qs_Vdi_bi_Vgi_bi+qdeff_Vdi_bi_Vgi_bi))*bsimbulk_lexp(T3)+((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi)))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi))))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+nq_Vdi_bi_Vdi_bi*nVt+nq_Vdi_bi*nVt_Vdi_bi+nq_Vdi_bi*nVt_Vdi_bi+nq*nVt_Vdi_bi_Vdi_bi)*(qs+qdeff)+((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs_Vdi_bi+qdeff_Vdi_bi)+(((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*nVt)*(+qs_Vdi_bi_Vdi_bi+qdeff_Vdi_bi_Vdi_bi))*bsimbulk_lexp(T3)+((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi)))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi))))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+nq_Vdi_bi_Vsi_bi*nVt+nq_Vdi_bi*nVt_Vsi_bi+nq_Vsi_bi*nVt_Vdi_bi+nq*nVt_Vdi_bi_Vsi_bi)*(qs+qdeff)+((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs_Vsi_bi+qdeff_Vsi_bi)+(((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*nVt)*(+qs_Vdi_bi_Vsi_bi+qdeff_Vdi_bi_Vsi_bi))*bsimbulk_lexp(T3)+((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi)))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi))))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+nq_Vdi_bi_Tempt_GND*nVt+nq_Vdi_bi*nVt_Tempt_GND+nq_Tempt_GND*nVt_Vdi_bi+nq*nVt_Vdi_bi_Tempt_GND)*(qs+qdeff)+((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs_Tempt_GND+qdeff_Tempt_GND)+(((nq_Tempt_GND*nVt)+(nq*nVt_Tempt_GND)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*nVt)*(+qs_Vdi_bi_Tempt_GND+qdeff_Vdi_bi_Tempt_GND))*bsimbulk_lexp(T3)+((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi)))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((((((nq_Tempt_GND*nVt)+(nq*nVt_Tempt_GND)))*(qs+qdeff))+((nq*nVt)*(qs_Tempt_GND+qdeff_Tempt_GND))))*bsimbulk_d_lexp(T3,T3_Vdi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=((((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)))*bsimbulk_lexp(T3))+(((nq*nVt)*(qs+qdeff))*bsimbulk_d_lexp(T3,T3_Vsi_bi)));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+nq_Vsi_bi_Vgm_si*nVt+nq_Vsi_bi*nVt_Vgm_si+nq_Vgm_si*nVt_Vsi_bi+nq*nVt_Vsi_bi_Vgm_si)*(qs+qdeff)+((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs_Vgm_si+qdeff_Vgm_si)+(((nq_Vgm_si*nVt)+(nq*nVt_Vgm_si)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*nVt)*(+qs_Vsi_bi_Vgm_si+qdeff_Vsi_bi_Vgm_si))*bsimbulk_lexp(T3)+((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((((((nq_Vgm_si*nVt)+(nq*nVt_Vgm_si)))*(qs+qdeff))+((nq*nVt)*(qs_Vgm_si+qdeff_Vgm_si))))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+nq_Vsi_bi_Vgm_di*nVt+nq_Vsi_bi*0.0+nq_Vgm_di*nVt_Vsi_bi+nq*0.0)*(qs+qdeff)+((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs_Vgm_di+qdeff_Vgm_di)+(nq_Vgm_di*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*nVt)*(+qs_Vsi_bi_Vgm_di+qdeff_Vsi_bi_Vgm_di))*bsimbulk_lexp(T3)+((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((((nq_Vgm_di*nVt)*(qs+qdeff))+((nq*nVt)*(qs_Vgm_di+qdeff_Vgm_di))))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+nq_Vsi_bi_Vdbulk_di*nVt+nq_Vsi_bi*nVt_Vdbulk_di+nq_Vdbulk_di*nVt_Vsi_bi+nq*nVt_Vsi_bi_Vdbulk_di)*(qs+qdeff)+((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(((nq_Vdbulk_di*nVt)+(nq*nVt_Vdbulk_di)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*nVt)*(+qs_Vsi_bi_Vdbulk_di+qdeff_Vsi_bi_Vdbulk_di))*bsimbulk_lexp(T3)+((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((((((nq_Vdbulk_di*nVt)+(nq*nVt_Vdbulk_di)))*(qs+qdeff))+((nq*nVt)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+nq_Vsi_bi_Vsbulk_si*nVt+nq_Vsi_bi*nVt_Vsbulk_si+nq_Vsbulk_si*nVt_Vsi_bi+nq*nVt_Vsi_bi_Vsbulk_si)*(qs+qdeff)+((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(((nq_Vsbulk_si*nVt)+(nq*nVt_Vsbulk_si)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*nVt)*(+qs_Vsi_bi_Vsbulk_si+qdeff_Vsi_bi_Vsbulk_si))*bsimbulk_lexp(T3)+((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((((((nq_Vsbulk_si*nVt)+(nq*nVt_Vsbulk_si)))*(qs+qdeff))+((nq*nVt)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+nq_Vsi_bi_Vgi_bi*nVt+nq_Vsi_bi*nVt_Vgi_bi+nq_Vgi_bi*nVt_Vsi_bi+nq*nVt_Vsi_bi_Vgi_bi)*(qs+qdeff)+((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs_Vgi_bi+qdeff_Vgi_bi)+(((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*nVt)*(+qs_Vsi_bi_Vgi_bi+qdeff_Vsi_bi_Vgi_bi))*bsimbulk_lexp(T3)+((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((((((nq_Vgi_bi*nVt)+(nq*nVt_Vgi_bi)))*(qs+qdeff))+((nq*nVt)*(qs_Vgi_bi+qdeff_Vgi_bi))))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+nq_Vsi_bi_Vdi_bi*nVt+nq_Vsi_bi*nVt_Vdi_bi+nq_Vdi_bi*nVt_Vsi_bi+nq*nVt_Vsi_bi_Vdi_bi)*(qs+qdeff)+((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs_Vdi_bi+qdeff_Vdi_bi)+(((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*nVt)*(+qs_Vsi_bi_Vdi_bi+qdeff_Vsi_bi_Vdi_bi))*bsimbulk_lexp(T3)+((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((((((nq_Vdi_bi*nVt)+(nq*nVt_Vdi_bi)))*(qs+qdeff))+((nq*nVt)*(qs_Vdi_bi+qdeff_Vdi_bi))))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+nq_Vsi_bi_Vsi_bi*nVt+nq_Vsi_bi*nVt_Vsi_bi+nq_Vsi_bi*nVt_Vsi_bi+nq*nVt_Vsi_bi_Vsi_bi)*(qs+qdeff)+((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs_Vsi_bi+qdeff_Vsi_bi)+(((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*nVt)*(+qs_Vsi_bi_Vsi_bi+qdeff_Vsi_bi_Vsi_bi))*bsimbulk_lexp(T3)+((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi)))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi))))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+nq_Vsi_bi_Tempt_GND*nVt+nq_Vsi_bi*nVt_Tempt_GND+nq_Tempt_GND*nVt_Vsi_bi+nq*nVt_Vsi_bi_Tempt_GND)*(qs+qdeff)+((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs_Tempt_GND+qdeff_Tempt_GND)+(((nq_Tempt_GND*nVt)+(nq*nVt_Tempt_GND)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*nVt)*(+qs_Vsi_bi_Tempt_GND+qdeff_Vsi_bi_Tempt_GND))*bsimbulk_lexp(T3)+((((nq_Vsi_bi*nVt)+(nq*nVt_Vsi_bi))*(qs+qdeff))+((nq*nVt)*(qs_Vsi_bi+qdeff_Vsi_bi)))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((((((nq_Tempt_GND*nVt)+(nq*nVt_Tempt_GND)))*(qs+qdeff))+((nq*nVt)*(qs_Tempt_GND+qdeff_Tempt_GND))))*bsimbulk_d_lexp(T3,T3_Vsi_bi)+((nq*nVt)*(qs+qdeff))*T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=((((((nq_Tempt_GND*nVt)+(nq*nVt_Tempt_GND))*(qs+qdeff))+((nq*nVt)*(qs_Tempt_GND+qdeff_Tempt_GND)))*bsimbulk_lexp(T3))+(((nq*nVt)*(qs+qdeff))*bsimbulk_d_lexp(T3,T3_Tempt_GND)));
#endif
#endif
T4=(((nq*nVt)*(qs+qdeff))*bsimbulk_lexp(T3));
EXIT_IF_ISNAN((((nq*nVt)*(qs+qdeff))*bsimbulk_lexp(T3)))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igc0_Vgi_bi=((((pInst->NF*Aechvb)*T4_Vgi_bi)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))+(((pInst->NF*Aechvb)*T4)*Vg_Vgi_bi))*igtemp;
igc0_Vdi_bi=((((pInst->NF*Aechvb)*T4_Vdi_bi)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))+(((pInst->NF*Aechvb)*T4)*((0.5*Vdsx_Vdi_bi)-(0.5*(Vs_Vdi_bi+Vd_Vdi_bi)))))*igtemp;
igc0_Vsi_bi=((((pInst->NF*Aechvb)*T4_Vsi_bi)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))+(((pInst->NF*Aechvb)*T4)*((0.5*Vdsx_Vsi_bi)-(0.5*(Vs_Vsi_bi+Vd_Vsi_bi)))))*igtemp;
igc0_Tempt_GND=((((((pInst->NF*Aechvb)*T4_Tempt_GND)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))+(((pInst->NF*Aechvb)*T4)*(0.5*Vdsx_Tempt_GND)))*igtemp)+((((pInst->NF*Aechvb)*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp_Tempt_GND));
#endif
igc0=((((pInst->NF*Aechvb)*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp);
EXIT_IF_ISNAN(((((pInst->NF*Aechvb)*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp))
{
double m00_sqrt(d00_sqrt0,((Vdseff*Vdseff)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Vdseff*Vdseff)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
Vdseffx_Vdi_bi=((Vdseff_Vdi_bi*Vdseff)+(Vdseff*Vdseff_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vdseffx_Vdi_bi_Vdi_bi=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vdi_bi*Vdseff)+(Vdseff*Vdseff_Vdi_bi)))*((Vdseff_Vdi_bi*Vdseff)+(Vdseff*Vdseff_Vdi_bi))+d10_sqrt0*(+(+Vdseff_Vdi_bi_Vdi_bi*Vdseff+Vdseff_Vdi_bi*Vdseff_Vdi_bi+Vdseff_Vdi_bi*Vdseff_Vdi_bi+Vdseff*Vdseff_Vdi_bi_Vdi_bi)+0.0))-0.0);
  Vdseffx_Vdi_bi_Vsi_bi=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vsi_bi*Vdseff)+(Vdseff*Vdseff_Vsi_bi)))*((Vdseff_Vdi_bi*Vdseff)+(Vdseff*Vdseff_Vdi_bi))+d10_sqrt0*(+(+Vdseff_Vdi_bi_Vsi_bi*Vdseff+Vdseff_Vdi_bi*Vdseff_Vsi_bi+Vdseff_Vsi_bi*Vdseff_Vdi_bi+Vdseff*Vdseff_Vdi_bi_Vsi_bi)+0.0))-0.0);
  Vdseffx_Vdi_bi_Vgi_bi=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vgi_bi*Vdseff)+(Vdseff*Vdseff_Vgi_bi)))*((Vdseff_Vdi_bi*Vdseff)+(Vdseff*Vdseff_Vdi_bi))+d10_sqrt0*(+(+Vdseff_Vdi_bi_Vgi_bi*Vdseff+Vdseff_Vdi_bi*Vdseff_Vgi_bi+Vdseff_Vgi_bi*Vdseff_Vdi_bi+Vdseff*Vdseff_Vdi_bi_Vgi_bi)+0.0))-0.0);
  Vdseffx_Vdi_bi_Tempt_GND=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND)))*((Vdseff_Vdi_bi*Vdseff)+(Vdseff*Vdseff_Vdi_bi))+d10_sqrt0*(+(+Vdseff_Vdi_bi_Tempt_GND*Vdseff+Vdseff_Vdi_bi*Vdseff_Tempt_GND+Vdseff_Tempt_GND*Vdseff_Vdi_bi+Vdseff*Vdseff_Vdi_bi_Tempt_GND)+0.0))-0.0);
#endif
Vdseffx_Vsi_bi=((Vdseff_Vsi_bi*Vdseff)+(Vdseff*Vdseff_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vdseffx_Vsi_bi_Vdi_bi=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vdi_bi*Vdseff)+(Vdseff*Vdseff_Vdi_bi)))*((Vdseff_Vsi_bi*Vdseff)+(Vdseff*Vdseff_Vsi_bi))+d10_sqrt0*(+(+Vdseff_Vsi_bi_Vdi_bi*Vdseff+Vdseff_Vsi_bi*Vdseff_Vdi_bi+Vdseff_Vdi_bi*Vdseff_Vsi_bi+Vdseff*Vdseff_Vsi_bi_Vdi_bi)+0.0))-0.0);
  Vdseffx_Vsi_bi_Vsi_bi=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vsi_bi*Vdseff)+(Vdseff*Vdseff_Vsi_bi)))*((Vdseff_Vsi_bi*Vdseff)+(Vdseff*Vdseff_Vsi_bi))+d10_sqrt0*(+(+Vdseff_Vsi_bi_Vsi_bi*Vdseff+Vdseff_Vsi_bi*Vdseff_Vsi_bi+Vdseff_Vsi_bi*Vdseff_Vsi_bi+Vdseff*Vdseff_Vsi_bi_Vsi_bi)+0.0))-0.0);
  Vdseffx_Vsi_bi_Vgi_bi=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vgi_bi*Vdseff)+(Vdseff*Vdseff_Vgi_bi)))*((Vdseff_Vsi_bi*Vdseff)+(Vdseff*Vdseff_Vsi_bi))+d10_sqrt0*(+(+Vdseff_Vsi_bi_Vgi_bi*Vdseff+Vdseff_Vsi_bi*Vdseff_Vgi_bi+Vdseff_Vgi_bi*Vdseff_Vsi_bi+Vdseff*Vdseff_Vsi_bi_Vgi_bi)+0.0))-0.0);
  Vdseffx_Vsi_bi_Tempt_GND=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND)))*((Vdseff_Vsi_bi*Vdseff)+(Vdseff*Vdseff_Vsi_bi))+d10_sqrt0*(+(+Vdseff_Vsi_bi_Tempt_GND*Vdseff+Vdseff_Vsi_bi*Vdseff_Tempt_GND+Vdseff_Tempt_GND*Vdseff_Vsi_bi+Vdseff*Vdseff_Vsi_bi_Tempt_GND)+0.0))-0.0);
#endif
Vdseffx_Vgi_bi=((Vdseff_Vgi_bi*Vdseff)+(Vdseff*Vdseff_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vdseffx_Vgi_bi_Vdi_bi=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vdi_bi*Vdseff)+(Vdseff*Vdseff_Vdi_bi)))*((Vdseff_Vgi_bi*Vdseff)+(Vdseff*Vdseff_Vgi_bi))+d10_sqrt0*(+(+Vdseff_Vgi_bi_Vdi_bi*Vdseff+Vdseff_Vgi_bi*Vdseff_Vdi_bi+Vdseff_Vdi_bi*Vdseff_Vgi_bi+Vdseff*Vdseff_Vgi_bi_Vdi_bi)+0.0))-0.0);
  Vdseffx_Vgi_bi_Vsi_bi=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vsi_bi*Vdseff)+(Vdseff*Vdseff_Vsi_bi)))*((Vdseff_Vgi_bi*Vdseff)+(Vdseff*Vdseff_Vgi_bi))+d10_sqrt0*(+(+Vdseff_Vgi_bi_Vsi_bi*Vdseff+Vdseff_Vgi_bi*Vdseff_Vsi_bi+Vdseff_Vsi_bi*Vdseff_Vgi_bi+Vdseff*Vdseff_Vgi_bi_Vsi_bi)+0.0))-0.0);
  Vdseffx_Vgi_bi_Vgi_bi=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vgi_bi*Vdseff)+(Vdseff*Vdseff_Vgi_bi)))*((Vdseff_Vgi_bi*Vdseff)+(Vdseff*Vdseff_Vgi_bi))+d10_sqrt0*(+(+Vdseff_Vgi_bi_Vgi_bi*Vdseff+Vdseff_Vgi_bi*Vdseff_Vgi_bi+Vdseff_Vgi_bi*Vdseff_Vgi_bi+Vdseff*Vdseff_Vgi_bi_Vgi_bi)+0.0))-0.0);
  Vdseffx_Vgi_bi_Tempt_GND=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND)))*((Vdseff_Vgi_bi*Vdseff)+(Vdseff*Vdseff_Vgi_bi))+d10_sqrt0*(+(+Vdseff_Vgi_bi_Tempt_GND*Vdseff+Vdseff_Vgi_bi*Vdseff_Tempt_GND+Vdseff_Tempt_GND*Vdseff_Vgi_bi+Vdseff*Vdseff_Vgi_bi_Tempt_GND)+0.0))-0.0);
#endif
#if defined(_DERIVATE)
Vdseffx_Tempt_GND=((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND))*d10_sqrt0;
#endif
#endif
Vdseffx=(d00_sqrt0-0.1);
EXIT_IF_ISNAN((d00_sqrt0-0.1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(PIGCD_i*Vdseffx_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vgi_bi+PIGCD_i*0.0);
  T1_Vgi_bi_Vgm_si=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vgi_bi+PIGCD_i*0.0);
  T1_Vgi_bi_Vdbulk_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vgi_bi+PIGCD_i*0.0);
  T1_Vgi_bi_Vsbulk_si=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vgi_bi+PIGCD_i*0.0);
  T1_Vgi_bi_Vgi_bi=(+0.0*Vdseffx+0.0*Vdseffx_Vgi_bi+0.0*Vdseffx_Vgi_bi+PIGCD_i*Vdseffx_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+0.0*Vdseffx+0.0*Vdseffx_Vdi_bi+0.0*Vdseffx_Vgi_bi+PIGCD_i*Vdseffx_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+0.0*Vdseffx+0.0*Vdseffx_Vsi_bi+0.0*Vdseffx_Vgi_bi+PIGCD_i*Vdseffx_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+0.0*Vdseffx+0.0*Vdseffx_Tempt_GND+0.0*Vdseffx_Vgi_bi+PIGCD_i*Vdseffx_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=(PIGCD_i*Vdseffx_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vdi_bi+PIGCD_i*0.0);
  T1_Vdi_bi_Vgm_si=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vdi_bi+PIGCD_i*0.0);
  T1_Vdi_bi_Vdbulk_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vdi_bi+PIGCD_i*0.0);
  T1_Vdi_bi_Vsbulk_si=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vdi_bi+PIGCD_i*0.0);
  T1_Vdi_bi_Vgi_bi=(+0.0*Vdseffx+0.0*Vdseffx_Vgi_bi+0.0*Vdseffx_Vdi_bi+PIGCD_i*Vdseffx_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+0.0*Vdseffx+0.0*Vdseffx_Vdi_bi+0.0*Vdseffx_Vdi_bi+PIGCD_i*Vdseffx_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+0.0*Vdseffx+0.0*Vdseffx_Vsi_bi+0.0*Vdseffx_Vdi_bi+PIGCD_i*Vdseffx_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+0.0*Vdseffx+0.0*Vdseffx_Tempt_GND+0.0*Vdseffx_Vdi_bi+PIGCD_i*Vdseffx_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=(PIGCD_i*Vdseffx_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vsi_bi+PIGCD_i*0.0);
  T1_Vsi_bi_Vgm_si=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vsi_bi+PIGCD_i*0.0);
  T1_Vsi_bi_Vdbulk_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vsi_bi+PIGCD_i*0.0);
  T1_Vsi_bi_Vsbulk_si=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vsi_bi+PIGCD_i*0.0);
  T1_Vsi_bi_Vgi_bi=(+0.0*Vdseffx+0.0*Vdseffx_Vgi_bi+0.0*Vdseffx_Vsi_bi+PIGCD_i*Vdseffx_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+0.0*Vdseffx+0.0*Vdseffx_Vdi_bi+0.0*Vdseffx_Vsi_bi+PIGCD_i*Vdseffx_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+0.0*Vdseffx+0.0*Vdseffx_Vsi_bi+0.0*Vdseffx_Vsi_bi+PIGCD_i*Vdseffx_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+0.0*Vdseffx+0.0*Vdseffx_Tempt_GND+0.0*Vdseffx_Vsi_bi+PIGCD_i*Vdseffx_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(PIGCD_i*Vdseffx_Tempt_GND);
#endif
#endif
T1=(PIGCD_i*Vdseffx);
EXIT_IF_ISNAN((PIGCD_i*Vdseffx))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
T1_exp_Vgi_bi=bsimbulk_d_lexp((-T1),(-T1_Vgi_bi));
#if defined(_DERIVATE2)
  T1_exp_Vgi_bi_Vgi_bi=0.0;
  T1_exp_Vgi_bi_Vdi_bi=0.0;
  T1_exp_Vgi_bi_Vsi_bi=0.0;
  T1_exp_Vgi_bi_Tempt_GND=0.0;
#endif
T1_exp_Vdi_bi=bsimbulk_d_lexp((-T1),(-T1_Vdi_bi));
#if defined(_DERIVATE2)
  T1_exp_Vdi_bi_Vgi_bi=0.0;
  T1_exp_Vdi_bi_Vdi_bi=0.0;
  T1_exp_Vdi_bi_Vsi_bi=0.0;
  T1_exp_Vdi_bi_Tempt_GND=0.0;
#endif
T1_exp_Vsi_bi=bsimbulk_d_lexp((-T1),(-T1_Vsi_bi));
#if defined(_DERIVATE2)
  T1_exp_Vsi_bi_Vgi_bi=0.0;
  T1_exp_Vsi_bi_Vdi_bi=0.0;
  T1_exp_Vsi_bi_Vsi_bi=0.0;
  T1_exp_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_exp_Tempt_GND=bsimbulk_d_lexp((-T1),(-T1_Tempt_GND));
#endif
#endif
T1_exp=bsimbulk_lexp((-T1));
EXIT_IF_ISNAN(bsimbulk_lexp((-T1)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(T1_Vgi_bi+T1_exp_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+(+T1_Vgi_bi_Vgm_si+0.0)-0.0)+0.0);
  T3_Vgi_bi_Vgm_di=(+(+(+T1_Vgi_bi_Vgm_di+0.0)-0.0)+0.0);
  T3_Vgi_bi_Vdbulk_di=(+(+(+T1_Vgi_bi_Vdbulk_di+0.0)-0.0)+0.0);
  T3_Vgi_bi_Vsbulk_si=(+(+(+T1_Vgi_bi_Vsbulk_si+0.0)-0.0)+0.0);
  T3_Vgi_bi_Vgi_bi=(+(+(+T1_Vgi_bi_Vgi_bi+T1_exp_Vgi_bi_Vgi_bi)-0.0)+0.0);
  T3_Vgi_bi_Vdi_bi=(+(+(+T1_Vgi_bi_Vdi_bi+T1_exp_Vgi_bi_Vdi_bi)-0.0)+0.0);
  T3_Vgi_bi_Vsi_bi=(+(+(+T1_Vgi_bi_Vsi_bi+T1_exp_Vgi_bi_Vsi_bi)-0.0)+0.0);
  T3_Vgi_bi_Tempt_GND=(+(+(+T1_Vgi_bi_Tempt_GND+T1_exp_Vgi_bi_Tempt_GND)-0.0)+0.0);
#endif
T3_Vdi_bi=(T1_Vdi_bi+T1_exp_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+(+T1_Vdi_bi_Vgm_si+0.0)-0.0)+0.0);
  T3_Vdi_bi_Vgm_di=(+(+(+T1_Vdi_bi_Vgm_di+0.0)-0.0)+0.0);
  T3_Vdi_bi_Vdbulk_di=(+(+(+T1_Vdi_bi_Vdbulk_di+0.0)-0.0)+0.0);
  T3_Vdi_bi_Vsbulk_si=(+(+(+T1_Vdi_bi_Vsbulk_si+0.0)-0.0)+0.0);
  T3_Vdi_bi_Vgi_bi=(+(+(+T1_Vdi_bi_Vgi_bi+T1_exp_Vdi_bi_Vgi_bi)-0.0)+0.0);
  T3_Vdi_bi_Vdi_bi=(+(+(+T1_Vdi_bi_Vdi_bi+T1_exp_Vdi_bi_Vdi_bi)-0.0)+0.0);
  T3_Vdi_bi_Vsi_bi=(+(+(+T1_Vdi_bi_Vsi_bi+T1_exp_Vdi_bi_Vsi_bi)-0.0)+0.0);
  T3_Vdi_bi_Tempt_GND=(+(+(+T1_Vdi_bi_Tempt_GND+T1_exp_Vdi_bi_Tempt_GND)-0.0)+0.0);
#endif
T3_Vsi_bi=(T1_Vsi_bi+T1_exp_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+(+T1_Vsi_bi_Vgm_si+0.0)-0.0)+0.0);
  T3_Vsi_bi_Vgm_di=(+(+(+T1_Vsi_bi_Vgm_di+0.0)-0.0)+0.0);
  T3_Vsi_bi_Vdbulk_di=(+(+(+T1_Vsi_bi_Vdbulk_di+0.0)-0.0)+0.0);
  T3_Vsi_bi_Vsbulk_si=(+(+(+T1_Vsi_bi_Vsbulk_si+0.0)-0.0)+0.0);
  T3_Vsi_bi_Vgi_bi=(+(+(+T1_Vsi_bi_Vgi_bi+T1_exp_Vsi_bi_Vgi_bi)-0.0)+0.0);
  T3_Vsi_bi_Vdi_bi=(+(+(+T1_Vsi_bi_Vdi_bi+T1_exp_Vsi_bi_Vdi_bi)-0.0)+0.0);
  T3_Vsi_bi_Vsi_bi=(+(+(+T1_Vsi_bi_Vsi_bi+T1_exp_Vsi_bi_Vsi_bi)-0.0)+0.0);
  T3_Vsi_bi_Tempt_GND=(+(+(+T1_Vsi_bi_Tempt_GND+T1_exp_Vsi_bi_Tempt_GND)-0.0)+0.0);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T1_Tempt_GND+T1_exp_Tempt_GND);
#endif
#endif
T3=(((T1+T1_exp)-1.0)+1.0e-4);
EXIT_IF_ISNAN((((T1+T1_exp)-1.0)+1.0e-4))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=(-((T1_Vgi_bi*T1_exp)+((T1+1.0)*T1_exp_Vgi_bi)));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+0.0-(+(+T1_Vgi_bi_Vgm_si+0.0)*T1_exp+T1_Vgi_bi*0.0+T1_Vgm_si*T1_exp_Vgi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vgi_bi_Vgm_di=(+(+0.0-(+(+T1_Vgi_bi_Vgm_di+0.0)*T1_exp+T1_Vgi_bi*0.0+T1_Vgm_di*T1_exp_Vgi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vgi_bi_Vdbulk_di=(+(+0.0-(+(+T1_Vgi_bi_Vdbulk_di+0.0)*T1_exp+T1_Vgi_bi*0.0+T1_Vdbulk_di*T1_exp_Vgi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vgi_bi_Vsbulk_si=(+(+0.0-(+(+T1_Vgi_bi_Vsbulk_si+0.0)*T1_exp+T1_Vgi_bi*0.0+T1_Vsbulk_si*T1_exp_Vgi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vgi_bi_Vgi_bi=(+(+0.0-(+(+T1_Vgi_bi_Vgi_bi+0.0)*T1_exp+T1_Vgi_bi*T1_exp_Vgi_bi+T1_Vgi_bi*T1_exp_Vgi_bi+(T1+1.0)*T1_exp_Vgi_bi_Vgi_bi))+0.0);
  T4_Vgi_bi_Vdi_bi=(+(+0.0-(+(+T1_Vgi_bi_Vdi_bi+0.0)*T1_exp+T1_Vgi_bi*T1_exp_Vdi_bi+T1_Vdi_bi*T1_exp_Vgi_bi+(T1+1.0)*T1_exp_Vgi_bi_Vdi_bi))+0.0);
  T4_Vgi_bi_Vsi_bi=(+(+0.0-(+(+T1_Vgi_bi_Vsi_bi+0.0)*T1_exp+T1_Vgi_bi*T1_exp_Vsi_bi+T1_Vsi_bi*T1_exp_Vgi_bi+(T1+1.0)*T1_exp_Vgi_bi_Vsi_bi))+0.0);
  T4_Vgi_bi_Tempt_GND=(+(+0.0-(+(+T1_Vgi_bi_Tempt_GND+0.0)*T1_exp+T1_Vgi_bi*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Vgi_bi+(T1+1.0)*T1_exp_Vgi_bi_Tempt_GND))+0.0);
#endif
T4_Vdi_bi=(-((T1_Vdi_bi*T1_exp)+((T1+1.0)*T1_exp_Vdi_bi)));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+0.0-(+(+T1_Vdi_bi_Vgm_si+0.0)*T1_exp+T1_Vdi_bi*0.0+T1_Vgm_si*T1_exp_Vdi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vdi_bi_Vgm_di=(+(+0.0-(+(+T1_Vdi_bi_Vgm_di+0.0)*T1_exp+T1_Vdi_bi*0.0+T1_Vgm_di*T1_exp_Vdi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vdi_bi_Vdbulk_di=(+(+0.0-(+(+T1_Vdi_bi_Vdbulk_di+0.0)*T1_exp+T1_Vdi_bi*0.0+T1_Vdbulk_di*T1_exp_Vdi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vdi_bi_Vsbulk_si=(+(+0.0-(+(+T1_Vdi_bi_Vsbulk_si+0.0)*T1_exp+T1_Vdi_bi*0.0+T1_Vsbulk_si*T1_exp_Vdi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vdi_bi_Vgi_bi=(+(+0.0-(+(+T1_Vdi_bi_Vgi_bi+0.0)*T1_exp+T1_Vdi_bi*T1_exp_Vgi_bi+T1_Vgi_bi*T1_exp_Vdi_bi+(T1+1.0)*T1_exp_Vdi_bi_Vgi_bi))+0.0);
  T4_Vdi_bi_Vdi_bi=(+(+0.0-(+(+T1_Vdi_bi_Vdi_bi+0.0)*T1_exp+T1_Vdi_bi*T1_exp_Vdi_bi+T1_Vdi_bi*T1_exp_Vdi_bi+(T1+1.0)*T1_exp_Vdi_bi_Vdi_bi))+0.0);
  T4_Vdi_bi_Vsi_bi=(+(+0.0-(+(+T1_Vdi_bi_Vsi_bi+0.0)*T1_exp+T1_Vdi_bi*T1_exp_Vsi_bi+T1_Vsi_bi*T1_exp_Vdi_bi+(T1+1.0)*T1_exp_Vdi_bi_Vsi_bi))+0.0);
  T4_Vdi_bi_Tempt_GND=(+(+0.0-(+(+T1_Vdi_bi_Tempt_GND+0.0)*T1_exp+T1_Vdi_bi*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Vdi_bi+(T1+1.0)*T1_exp_Vdi_bi_Tempt_GND))+0.0);
#endif
T4_Vsi_bi=(-((T1_Vsi_bi*T1_exp)+((T1+1.0)*T1_exp_Vsi_bi)));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+0.0-(+(+T1_Vsi_bi_Vgm_si+0.0)*T1_exp+T1_Vsi_bi*0.0+T1_Vgm_si*T1_exp_Vsi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vsi_bi_Vgm_di=(+(+0.0-(+(+T1_Vsi_bi_Vgm_di+0.0)*T1_exp+T1_Vsi_bi*0.0+T1_Vgm_di*T1_exp_Vsi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vsi_bi_Vdbulk_di=(+(+0.0-(+(+T1_Vsi_bi_Vdbulk_di+0.0)*T1_exp+T1_Vsi_bi*0.0+T1_Vdbulk_di*T1_exp_Vsi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vsi_bi_Vsbulk_si=(+(+0.0-(+(+T1_Vsi_bi_Vsbulk_si+0.0)*T1_exp+T1_Vsi_bi*0.0+T1_Vsbulk_si*T1_exp_Vsi_bi+(T1+1.0)*0.0))+0.0);
  T4_Vsi_bi_Vgi_bi=(+(+0.0-(+(+T1_Vsi_bi_Vgi_bi+0.0)*T1_exp+T1_Vsi_bi*T1_exp_Vgi_bi+T1_Vgi_bi*T1_exp_Vsi_bi+(T1+1.0)*T1_exp_Vsi_bi_Vgi_bi))+0.0);
  T4_Vsi_bi_Vdi_bi=(+(+0.0-(+(+T1_Vsi_bi_Vdi_bi+0.0)*T1_exp+T1_Vsi_bi*T1_exp_Vdi_bi+T1_Vdi_bi*T1_exp_Vsi_bi+(T1+1.0)*T1_exp_Vsi_bi_Vdi_bi))+0.0);
  T4_Vsi_bi_Vsi_bi=(+(+0.0-(+(+T1_Vsi_bi_Vsi_bi+0.0)*T1_exp+T1_Vsi_bi*T1_exp_Vsi_bi+T1_Vsi_bi*T1_exp_Vsi_bi+(T1+1.0)*T1_exp_Vsi_bi_Vsi_bi))+0.0);
  T4_Vsi_bi_Tempt_GND=(+(+0.0-(+(+T1_Vsi_bi_Tempt_GND+0.0)*T1_exp+T1_Vsi_bi*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Vsi_bi+(T1+1.0)*T1_exp_Vsi_bi_Tempt_GND))+0.0);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(-((T1_Tempt_GND*T1_exp)+((T1+1.0)*T1_exp_Tempt_GND)));
#endif
#endif
T4=((1.0-((T1+1.0)*T1_exp))+1.0e-4);
EXIT_IF_ISNAN(((1.0-((T1+1.0)*T1_exp))+1.0e-4))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)+0.0);
  T5_Vgi_bi_Vgm_di=(+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)+0.0);
  T5_Vgi_bi_Vdbulk_di=(+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)+0.0);
  T5_Vgi_bi_Vsbulk_si=(+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)+0.0);
  T5_Vgi_bi_Vgi_bi=(+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)+0.0);
  T5_Vgi_bi_Vdi_bi=(+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)+0.0);
  T5_Vgi_bi_Vsi_bi=(+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)+0.0);
  T5_Vgi_bi_Tempt_GND=(+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)+0.0);
#endif
T5_Vdi_bi=((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)+0.0);
  T5_Vdi_bi_Vgm_di=(+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)+0.0);
  T5_Vdi_bi_Vdbulk_di=(+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)+0.0);
  T5_Vdi_bi_Vsbulk_si=(+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)+0.0);
  T5_Vdi_bi_Vgi_bi=(+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)+0.0);
  T5_Vdi_bi_Vdi_bi=(+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)+0.0);
  T5_Vdi_bi_Vsi_bi=(+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)+0.0);
  T5_Vdi_bi_Tempt_GND=(+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)+0.0);
#endif
T5_Vsi_bi=((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)+0.0);
  T5_Vsi_bi_Vgm_di=(+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)+0.0);
  T5_Vsi_bi_Vdbulk_di=(+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)+0.0);
  T5_Vsi_bi_Vsbulk_si=(+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)+0.0);
  T5_Vsi_bi_Vgi_bi=(+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)+0.0);
  T5_Vsi_bi_Vdi_bi=(+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)+0.0);
  T5_Vsi_bi_Vsi_bi=(+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)+0.0);
  T5_Vsi_bi_Tempt_GND=(+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)+0.0);
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND));
#endif
#endif
T5=((T1*T1)+2.0e-4);
EXIT_IF_ISNAN(((T1*T1)+2.0e-4))
if
((sigvds>0))
{
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igcd_Vgi_bi=((((igc0_Vgi_bi*T4)+(igc0*T4_Vgi_bi))*T5-(igc0*T4)*T5_Vgi_bi)/T5/T5);
igcd_Vdi_bi=((((igc0_Vdi_bi*T4)+(igc0*T4_Vdi_bi))*T5-(igc0*T4)*T5_Vdi_bi)/T5/T5);
igcd_Vsi_bi=((((igc0_Vsi_bi*T4)+(igc0*T4_Vsi_bi))*T5-(igc0*T4)*T5_Vsi_bi)/T5/T5);
igcd_Tempt_GND=((((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5-(igc0*T4)*T5_Tempt_GND)/T5/T5);
#endif
igcd=((igc0*T4)/T5);
EXIT_IF_ISNAN(((igc0*T4)/T5))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igcs_Vgi_bi=((((igc0_Vgi_bi*T3)+(igc0*T3_Vgi_bi))*T5-(igc0*T3)*T5_Vgi_bi)/T5/T5);
igcs_Vdi_bi=((((igc0_Vdi_bi*T3)+(igc0*T3_Vdi_bi))*T5-(igc0*T3)*T5_Vdi_bi)/T5/T5);
igcs_Vsi_bi=((((igc0_Vsi_bi*T3)+(igc0*T3_Vsi_bi))*T5-(igc0*T3)*T5_Vsi_bi)/T5/T5);
igcs_Tempt_GND=((((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5-(igc0*T3)*T5_Tempt_GND)/T5/T5);
#endif
igcs=((igc0*T3)/T5);
EXIT_IF_ISNAN(((igc0*T3)/T5))
}
else
{
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igcs_Vgi_bi=((((igc0_Vgi_bi*T4)+(igc0*T4_Vgi_bi))*T5-(igc0*T4)*T5_Vgi_bi)/T5/T5);
igcs_Vdi_bi=((((igc0_Vdi_bi*T4)+(igc0*T4_Vdi_bi))*T5-(igc0*T4)*T5_Vdi_bi)/T5/T5);
igcs_Vsi_bi=((((igc0_Vsi_bi*T4)+(igc0*T4_Vsi_bi))*T5-(igc0*T4)*T5_Vsi_bi)/T5/T5);
igcs_Tempt_GND=((((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5-(igc0*T4)*T5_Tempt_GND)/T5/T5);
#endif
igcs=((igc0*T4)/T5);
EXIT_IF_ISNAN(((igc0*T4)/T5))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igcd_Vgi_bi=((((igc0_Vgi_bi*T3)+(igc0*T3_Vgi_bi))*T5-(igc0*T3)*T5_Vgi_bi)/T5/T5);
igcd_Vdi_bi=((((igc0_Vdi_bi*T3)+(igc0*T3_Vdi_bi))*T5-(igc0*T3)*T5_Vdi_bi)/T5/T5);
igcd_Vsi_bi=((((igc0_Vsi_bi*T3)+(igc0*T3_Vsi_bi))*T5-(igc0*T3)*T5_Vsi_bi)/T5/T5);
igcd_Tempt_GND=((((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5-(igc0*T3)*T5_Tempt_GND)/T5/T5);
#endif
igcd=((igc0*T3)/T5);
EXIT_IF_ISNAN(((igc0*T3)/T5))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=Vgs_noswap_Vgi_bi;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0-0.0);
  T2_Vgi_bi_Vgm_si=(+0.0-0.0);
  T2_Vgi_bi_Vdbulk_di=(+0.0-0.0);
  T2_Vgi_bi_Vsbulk_si=(+0.0-0.0);
  T2_Vgi_bi_Vgi_bi=(+Vgs_noswap_Vgi_bi_Vgi_bi-0.0);
  T2_Vgi_bi_Vdi_bi=(+0.0-0.0);
  T2_Vgi_bi_Vsi_bi=(+Vgs_noswap_Vgi_bi_Vsi_bi-0.0);
  T2_Vgi_bi_Tempt_GND=(+0.0-0.0);
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=Vgs_noswap_Vsi_bi;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0-0.0);
  T2_Vsi_bi_Vgm_si=(+0.0-0.0);
  T2_Vsi_bi_Vdbulk_di=(+0.0-0.0);
  T2_Vsi_bi_Vsbulk_si=(+0.0-0.0);
  T2_Vsi_bi_Vgi_bi=(+Vgs_noswap_Vsi_bi_Vgi_bi-0.0);
  T2_Vsi_bi_Vdi_bi=(+0.0-0.0);
  T2_Vsi_bi_Vsi_bi=(+Vgs_noswap_Vsi_bi_Vsi_bi-0.0);
  T2_Vsi_bi_Tempt_GND=(+0.0-0.0);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(-Vfbsdr_Tempt_GND);
#endif
#endif
T2=(Vgs_noswap-Vfbsdr);
EXIT_IF_ISNAN((Vgs_noswap-Vfbsdr))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+1.0e-4))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+1.0e-4))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
Vgs_eff_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vgs_eff_Vgi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0));
  Vgs_eff_Vgi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0));
  Vgs_eff_Vgi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0));
  Vgs_eff_Vgi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0));
#endif
Vgs_eff_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vgs_eff_Vdi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0));
  Vgs_eff_Vdi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0));
  Vgs_eff_Vdi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0));
  Vgs_eff_Vdi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0));
#endif
Vgs_eff_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vgs_eff_Vsi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0));
  Vgs_eff_Vsi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0));
  Vgs_eff_Vsi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0));
  Vgs_eff_Vsi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0));
#endif
#if defined(_DERIVATE)
Vgs_eff_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0;
#endif
#endif
Vgs_eff=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((pModel->IGCLAMP==1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=bsimbulk_d_hypsmooth((AIGS_i-(BIGS_i*Vgs_eff)),1.0e-6,(-(BIGS_i*Vgs_eff_Vgi_bi)),0.0);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=bsimbulk_d_hypsmooth((AIGS_i-(BIGS_i*Vgs_eff)),1.0e-6,(-(BIGS_i*Vgs_eff_Vdi_bi)),0.0);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=bsimbulk_d_hypsmooth((AIGS_i-(BIGS_i*Vgs_eff)),1.0e-6,(-(BIGS_i*Vgs_eff_Vsi_bi)),0.0);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_hypsmooth((AIGS_i-(BIGS_i*Vgs_eff)),1.0e-6,(-(BIGS_i*Vgs_eff_Tempt_GND)),0.0);
#endif
#endif
T1=bsimbulk_hypsmooth((AIGS_i-(BIGS_i*Vgs_eff)),1.0e-6);
EXIT_IF_ISNAN(bsimbulk_hypsmooth((AIGS_i-(BIGS_i*Vgs_eff)),1.0e-6))
if
((CIGS_i<0.01))
{
CIGS_i=0.01;
EXIT_IF_ISNAN(0.01)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(-(BIGS_i*Vgs_eff_Vgi_bi));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+BIGS_i*0.0));
  T1_Vgi_bi_Vgm_si=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+BIGS_i*0.0));
  T1_Vgi_bi_Vdbulk_di=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+BIGS_i*0.0));
  T1_Vgi_bi_Vsbulk_si=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+BIGS_i*0.0));
  T1_Vgi_bi_Vgi_bi=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Vgi_bi+0.0*Vgs_eff_Vgi_bi+BIGS_i*Vgs_eff_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Vdi_bi+0.0*Vgs_eff_Vgi_bi+BIGS_i*Vgs_eff_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Vsi_bi+0.0*Vgs_eff_Vgi_bi+BIGS_i*Vgs_eff_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Tempt_GND+0.0*Vgs_eff_Vgi_bi+BIGS_i*Vgs_eff_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(-(BIGS_i*Vgs_eff_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+BIGS_i*0.0));
  T1_Vdi_bi_Vgm_si=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+BIGS_i*0.0));
  T1_Vdi_bi_Vdbulk_di=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+BIGS_i*0.0));
  T1_Vdi_bi_Vsbulk_si=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+BIGS_i*0.0));
  T1_Vdi_bi_Vgi_bi=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Vgi_bi+0.0*Vgs_eff_Vdi_bi+BIGS_i*Vgs_eff_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Vdi_bi+0.0*Vgs_eff_Vdi_bi+BIGS_i*Vgs_eff_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Vsi_bi+0.0*Vgs_eff_Vdi_bi+BIGS_i*Vgs_eff_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Tempt_GND+0.0*Vgs_eff_Vdi_bi+BIGS_i*Vgs_eff_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(-(BIGS_i*Vgs_eff_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+BIGS_i*0.0));
  T1_Vsi_bi_Vgm_si=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+BIGS_i*0.0));
  T1_Vsi_bi_Vdbulk_di=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+BIGS_i*0.0));
  T1_Vsi_bi_Vsbulk_si=(+0.0-(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+BIGS_i*0.0));
  T1_Vsi_bi_Vgi_bi=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Vgi_bi+0.0*Vgs_eff_Vsi_bi+BIGS_i*Vgs_eff_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Vdi_bi+0.0*Vgs_eff_Vsi_bi+BIGS_i*Vgs_eff_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Vsi_bi+0.0*Vgs_eff_Vsi_bi+BIGS_i*Vgs_eff_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+0.0-(+0.0*Vgs_eff+0.0*Vgs_eff_Tempt_GND+0.0*Vgs_eff_Vsi_bi+BIGS_i*Vgs_eff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-(BIGS_i*Vgs_eff_Tempt_GND));
#endif
#endif
T1=(AIGS_i-(BIGS_i*Vgs_eff));
EXIT_IF_ISNAN((AIGS_i-(BIGS_i*Vgs_eff)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(CIGS_i*Vgs_eff_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+CIGS_i*0.0));
  T2_Vgi_bi_Vgm_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+CIGS_i*0.0));
  T2_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+CIGS_i*0.0));
  T2_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vgi_bi+CIGS_i*0.0));
  T2_Vgi_bi_Vgi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vgi_bi+0.0*Vgs_eff_Vgi_bi+CIGS_i*Vgs_eff_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vdi_bi+0.0*Vgs_eff_Vgi_bi+CIGS_i*Vgs_eff_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vsi_bi+0.0*Vgs_eff_Vgi_bi+CIGS_i*Vgs_eff_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Tempt_GND+0.0*Vgs_eff_Vgi_bi+CIGS_i*Vgs_eff_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(CIGS_i*Vgs_eff_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+CIGS_i*0.0));
  T2_Vdi_bi_Vgm_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+CIGS_i*0.0));
  T2_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+CIGS_i*0.0));
  T2_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vdi_bi+CIGS_i*0.0));
  T2_Vdi_bi_Vgi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vgi_bi+0.0*Vgs_eff_Vdi_bi+CIGS_i*Vgs_eff_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vdi_bi+0.0*Vgs_eff_Vdi_bi+CIGS_i*Vgs_eff_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vsi_bi+0.0*Vgs_eff_Vdi_bi+CIGS_i*Vgs_eff_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Tempt_GND+0.0*Vgs_eff_Vdi_bi+CIGS_i*Vgs_eff_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(CIGS_i*Vgs_eff_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+CIGS_i*0.0));
  T2_Vsi_bi_Vgm_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+CIGS_i*0.0));
  T2_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+CIGS_i*0.0));
  T2_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*Vgs_eff+0.0*0.0+0.0*Vgs_eff_Vsi_bi+CIGS_i*0.0));
  T2_Vsi_bi_Vgi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vgi_bi+0.0*Vgs_eff_Vsi_bi+CIGS_i*Vgs_eff_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vdi_bi+0.0*Vgs_eff_Vsi_bi+CIGS_i*Vgs_eff_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Vsi_bi+0.0*Vgs_eff_Vsi_bi+CIGS_i*Vgs_eff_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+0.0+(+0.0*Vgs_eff+0.0*Vgs_eff_Tempt_GND+0.0*Vgs_eff_Vsi_bi+CIGS_i*Vgs_eff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(CIGS_i*Vgs_eff_Tempt_GND);
#endif
#endif
T2=(1.0+(CIGS_i*Vgs_eff));
EXIT_IF_ISNAN((1.0+(CIGS_i*Vgs_eff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(((BechvbEdge*T1_Vgi_bi)*T2)+((BechvbEdge*T1)*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vgm_si)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vgm_si+((BechvbEdge*T1_Vgm_si))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vgm_si);
  T3_Vgi_bi_Vgm_di=(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vgm_di)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vgm_di+((BechvbEdge*T1_Vgm_di))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vgm_di);
  T3_Vgi_bi_Vdbulk_di=(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vdbulk_di)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vdbulk_di+((BechvbEdge*T1_Vdbulk_di))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vdbulk_di);
  T3_Vgi_bi_Vsbulk_si=(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vsbulk_si)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vsbulk_si+((BechvbEdge*T1_Vsbulk_si))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vsbulk_si);
  T3_Vgi_bi_Vgi_bi=(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vgi_bi)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vgi_bi+((BechvbEdge*T1_Vgi_bi))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vgi_bi);
  T3_Vgi_bi_Vdi_bi=(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vdi_bi)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vdi_bi+((BechvbEdge*T1_Vdi_bi))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vdi_bi);
  T3_Vgi_bi_Vsi_bi=(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vsi_bi)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vsi_bi+((BechvbEdge*T1_Vsi_bi))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vsi_bi);
  T3_Vgi_bi_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Tempt_GND)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Tempt_GND+((BechvbEdge*T1_Tempt_GND))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Tempt_GND);
#endif
T3_Vdi_bi=(((BechvbEdge*T1_Vdi_bi)*T2)+((BechvbEdge*T1)*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vgm_si)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vgm_si+((BechvbEdge*T1_Vgm_si))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vgm_si);
  T3_Vdi_bi_Vgm_di=(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vgm_di)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vgm_di+((BechvbEdge*T1_Vgm_di))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vgm_di);
  T3_Vdi_bi_Vdbulk_di=(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vdbulk_di)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vdbulk_di+((BechvbEdge*T1_Vdbulk_di))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vdbulk_di);
  T3_Vdi_bi_Vsbulk_si=(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vsbulk_si)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vsbulk_si+((BechvbEdge*T1_Vsbulk_si))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vsbulk_si);
  T3_Vdi_bi_Vgi_bi=(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vgi_bi)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vgi_bi+((BechvbEdge*T1_Vgi_bi))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vgi_bi);
  T3_Vdi_bi_Vdi_bi=(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vdi_bi)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vdi_bi+((BechvbEdge*T1_Vdi_bi))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vdi_bi);
  T3_Vdi_bi_Vsi_bi=(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vsi_bi)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vsi_bi+((BechvbEdge*T1_Vsi_bi))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vsi_bi);
  T3_Vdi_bi_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Tempt_GND)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Tempt_GND+((BechvbEdge*T1_Tempt_GND))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Tempt_GND);
#endif
T3_Vsi_bi=(((BechvbEdge*T1_Vsi_bi)*T2)+((BechvbEdge*T1)*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vgm_si)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vgm_si+((BechvbEdge*T1_Vgm_si))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vgm_si);
  T3_Vsi_bi_Vgm_di=(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vgm_di)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vgm_di+((BechvbEdge*T1_Vgm_di))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vgm_di);
  T3_Vsi_bi_Vdbulk_di=(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vdbulk_di)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vdbulk_di+((BechvbEdge*T1_Vdbulk_di))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vdbulk_di);
  T3_Vsi_bi_Vsbulk_si=(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vsbulk_si)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vsbulk_si+((BechvbEdge*T1_Vsbulk_si))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vsbulk_si);
  T3_Vsi_bi_Vgi_bi=(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vgi_bi)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vgi_bi+((BechvbEdge*T1_Vgi_bi))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vgi_bi);
  T3_Vsi_bi_Vdi_bi=(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vdi_bi)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vdi_bi+((BechvbEdge*T1_Vdi_bi))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vdi_bi);
  T3_Vsi_bi_Vsi_bi=(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vsi_bi)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vsi_bi+((BechvbEdge*T1_Vsi_bi))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vsi_bi);
  T3_Vsi_bi_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Tempt_GND)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Tempt_GND+((BechvbEdge*T1_Tempt_GND))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(((BechvbEdge*T1_Tempt_GND)*T2)+((BechvbEdge*T1)*T2_Tempt_GND));
#endif
#endif
T3=((BechvbEdge*T1)*T2);
EXIT_IF_ISNAN(((BechvbEdge*T1)*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=bsimbulk_d_lexp(T3,T3_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=T3_Vgi_bi_Vgm_si;
  T4_Vgi_bi_Vgm_di=T3_Vgi_bi_Vgm_di;
  T4_Vgi_bi_Vdbulk_di=T3_Vgi_bi_Vdbulk_di;
  T4_Vgi_bi_Vsbulk_si=T3_Vgi_bi_Vsbulk_si;
  T4_Vgi_bi_Vgi_bi=T3_Vgi_bi_Vgi_bi;
  T4_Vgi_bi_Vdi_bi=T3_Vgi_bi_Vdi_bi;
  T4_Vgi_bi_Vsi_bi=T3_Vgi_bi_Vsi_bi;
  T4_Vgi_bi_Tempt_GND=T3_Vgi_bi_Tempt_GND;
#endif
T4_Vdi_bi=bsimbulk_d_lexp(T3,T3_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=T3_Vdi_bi_Vgm_si;
  T4_Vdi_bi_Vgm_di=T3_Vdi_bi_Vgm_di;
  T4_Vdi_bi_Vdbulk_di=T3_Vdi_bi_Vdbulk_di;
  T4_Vdi_bi_Vsbulk_si=T3_Vdi_bi_Vsbulk_si;
  T4_Vdi_bi_Vgi_bi=T3_Vdi_bi_Vgi_bi;
  T4_Vdi_bi_Vdi_bi=T3_Vdi_bi_Vdi_bi;
  T4_Vdi_bi_Vsi_bi=T3_Vdi_bi_Vsi_bi;
  T4_Vdi_bi_Tempt_GND=T3_Vdi_bi_Tempt_GND;
#endif
T4_Vsi_bi=bsimbulk_d_lexp(T3,T3_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=T3_Vsi_bi_Vgm_si;
  T4_Vsi_bi_Vgm_di=T3_Vsi_bi_Vgm_di;
  T4_Vsi_bi_Vdbulk_di=T3_Vsi_bi_Vdbulk_di;
  T4_Vsi_bi_Vsbulk_si=T3_Vsi_bi_Vsbulk_si;
  T4_Vsi_bi_Vgi_bi=T3_Vsi_bi_Vgi_bi;
  T4_Vsi_bi_Vdi_bi=T3_Vsi_bi_Vdi_bi;
  T4_Vsi_bi_Vsi_bi=T3_Vsi_bi_Vsi_bi;
  T4_Vsi_bi_Tempt_GND=T3_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=bsimbulk_d_lexp(T3,T3_Tempt_GND);
#endif
#endif
T4=bsimbulk_lexp(T3);
EXIT_IF_ISNAN(bsimbulk_lexp(T3))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
igs_mult_Tempt_GND=igtemp_Tempt_GND*pInst->NF*AechvbEdge*DLCIG_i;
#endif
igs_mult=(((igtemp*pInst->NF)*AechvbEdge)*DLCIG_i);
EXIT_IF_ISNAN((((igtemp*pInst->NF)*AechvbEdge)*DLCIG_i))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(si,bi)V(di,bi) ddxprobe= */
igs_Tempt_GND=((((igs_mult_Tempt_GND*Vgs_noswap*Vgs_eff)+((igs_mult*Vgs_noswap)*Vgs_eff_Tempt_GND))*T4)+(((igs_mult*Vgs_noswap)*Vgs_eff)*T4_Tempt_GND));
igs_Vgi_bi=(((((igs_mult*Vgs_noswap_Vgi_bi)*Vgs_eff)+((igs_mult*Vgs_noswap)*Vgs_eff_Vgi_bi))*T4)+(((igs_mult*Vgs_noswap)*Vgs_eff)*T4_Vgi_bi));
igs_Vsi_bi=(((((igs_mult*Vgs_noswap_Vsi_bi)*Vgs_eff)+((igs_mult*Vgs_noswap)*Vgs_eff_Vsi_bi))*T4)+(((igs_mult*Vgs_noswap)*Vgs_eff)*T4_Vsi_bi));
igs_Vdi_bi=((((igs_mult*Vgs_noswap)*Vgs_eff_Vdi_bi)*T4)+(((igs_mult*Vgs_noswap)*Vgs_eff)*T4_Vdi_bi));
#endif
igs=(((igs_mult*Vgs_noswap)*Vgs_eff)*T4);
EXIT_IF_ISNAN((((igs_mult*Vgs_noswap)*Vgs_eff)*T4))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=Vgd_noswap_Vgi_bi;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0-0.0);
  T2_Vgi_bi_Vgm_si=(+0.0-0.0);
  T2_Vgi_bi_Vdbulk_di=(+0.0-0.0);
  T2_Vgi_bi_Vsbulk_si=(+0.0-0.0);
  T2_Vgi_bi_Vgi_bi=(+Vgd_noswap_Vgi_bi_Vgi_bi-0.0);
  T2_Vgi_bi_Vdi_bi=(+Vgd_noswap_Vgi_bi_Vdi_bi-0.0);
  T2_Vgi_bi_Vsi_bi=(+0.0-0.0);
  T2_Vgi_bi_Tempt_GND=(+0.0-0.0);
#endif
T2_Vdi_bi=Vgd_noswap_Vdi_bi;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0-0.0);
  T2_Vdi_bi_Vgm_si=(+0.0-0.0);
  T2_Vdi_bi_Vdbulk_di=(+0.0-0.0);
  T2_Vdi_bi_Vsbulk_si=(+0.0-0.0);
  T2_Vdi_bi_Vgi_bi=(+Vgd_noswap_Vdi_bi_Vgi_bi-0.0);
  T2_Vdi_bi_Vdi_bi=(+Vgd_noswap_Vdi_bi_Vdi_bi-0.0);
  T2_Vdi_bi_Vsi_bi=(+0.0-0.0);
  T2_Vdi_bi_Tempt_GND=(+0.0-0.0);
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(-Vfbsdr_Tempt_GND);
#endif
#endif
T2=(Vgd_noswap-Vfbsdr);
EXIT_IF_ISNAN((Vgd_noswap-Vfbsdr))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+1.0e-4))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+1.0e-4))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND) */
Vgd_eff_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vgd_eff_Vgi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0));
  Vgd_eff_Vgi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0));
  Vgd_eff_Vgi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0));
  Vgd_eff_Vgi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0));
#endif
Vgd_eff_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vgd_eff_Vdi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0));
  Vgd_eff_Vdi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0));
  Vgd_eff_Vdi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0));
  Vgd_eff_Vdi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0));
#endif
Vgd_eff_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vgd_eff_Vsi_bi_Vgi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0));
  Vgd_eff_Vsi_bi_Vdi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0));
  Vgd_eff_Vsi_bi_Vsi_bi=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0));
  Vgd_eff_Vsi_bi_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-4))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0));
#endif
#if defined(_DERIVATE)
Vgd_eff_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0;
#endif
#endif
Vgd_eff=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((pModel->IGCLAMP==1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=bsimbulk_d_hypsmooth((AIGD_i-(BIGD_i*Vgd_eff)),1.0e-6,(-(BIGD_i*Vgd_eff_Vgi_bi)),0.0);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=bsimbulk_d_hypsmooth((AIGD_i-(BIGD_i*Vgd_eff)),1.0e-6,(-(BIGD_i*Vgd_eff_Vdi_bi)),0.0);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=bsimbulk_d_hypsmooth((AIGD_i-(BIGD_i*Vgd_eff)),1.0e-6,(-(BIGD_i*Vgd_eff_Vsi_bi)),0.0);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_hypsmooth((AIGD_i-(BIGD_i*Vgd_eff)),1.0e-6,(-(BIGD_i*Vgd_eff_Tempt_GND)),0.0);
#endif
#endif
T1=bsimbulk_hypsmooth((AIGD_i-(BIGD_i*Vgd_eff)),1.0e-6);
EXIT_IF_ISNAN(bsimbulk_hypsmooth((AIGD_i-(BIGD_i*Vgd_eff)),1.0e-6))
if
((CIGD_i<0.01))
{
CIGD_i=0.01;
EXIT_IF_ISNAN(0.01)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(-(BIGD_i*Vgd_eff_Vgi_bi));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+BIGD_i*0.0));
  T1_Vgi_bi_Vgm_si=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+BIGD_i*0.0));
  T1_Vgi_bi_Vdbulk_di=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+BIGD_i*0.0));
  T1_Vgi_bi_Vsbulk_si=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+BIGD_i*0.0));
  T1_Vgi_bi_Vgi_bi=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Vgi_bi+0.0*Vgd_eff_Vgi_bi+BIGD_i*Vgd_eff_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Vdi_bi+0.0*Vgd_eff_Vgi_bi+BIGD_i*Vgd_eff_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Vsi_bi+0.0*Vgd_eff_Vgi_bi+BIGD_i*Vgd_eff_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Tempt_GND+0.0*Vgd_eff_Vgi_bi+BIGD_i*Vgd_eff_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(-(BIGD_i*Vgd_eff_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+BIGD_i*0.0));
  T1_Vdi_bi_Vgm_si=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+BIGD_i*0.0));
  T1_Vdi_bi_Vdbulk_di=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+BIGD_i*0.0));
  T1_Vdi_bi_Vsbulk_si=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+BIGD_i*0.0));
  T1_Vdi_bi_Vgi_bi=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Vgi_bi+0.0*Vgd_eff_Vdi_bi+BIGD_i*Vgd_eff_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Vdi_bi+0.0*Vgd_eff_Vdi_bi+BIGD_i*Vgd_eff_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Vsi_bi+0.0*Vgd_eff_Vdi_bi+BIGD_i*Vgd_eff_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Tempt_GND+0.0*Vgd_eff_Vdi_bi+BIGD_i*Vgd_eff_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(-(BIGD_i*Vgd_eff_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+BIGD_i*0.0));
  T1_Vsi_bi_Vgm_si=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+BIGD_i*0.0));
  T1_Vsi_bi_Vdbulk_di=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+BIGD_i*0.0));
  T1_Vsi_bi_Vsbulk_si=(+0.0-(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+BIGD_i*0.0));
  T1_Vsi_bi_Vgi_bi=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Vgi_bi+0.0*Vgd_eff_Vsi_bi+BIGD_i*Vgd_eff_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Vdi_bi+0.0*Vgd_eff_Vsi_bi+BIGD_i*Vgd_eff_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Vsi_bi+0.0*Vgd_eff_Vsi_bi+BIGD_i*Vgd_eff_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+0.0-(+0.0*Vgd_eff+0.0*Vgd_eff_Tempt_GND+0.0*Vgd_eff_Vsi_bi+BIGD_i*Vgd_eff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-(BIGD_i*Vgd_eff_Tempt_GND));
#endif
#endif
T1=(AIGD_i-(BIGD_i*Vgd_eff));
EXIT_IF_ISNAN((AIGD_i-(BIGD_i*Vgd_eff)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(CIGD_i*Vgd_eff_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+CIGD_i*0.0));
  T2_Vgi_bi_Vgm_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+CIGD_i*0.0));
  T2_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+CIGD_i*0.0));
  T2_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vgi_bi+CIGD_i*0.0));
  T2_Vgi_bi_Vgi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vgi_bi+0.0*Vgd_eff_Vgi_bi+CIGD_i*Vgd_eff_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vdi_bi+0.0*Vgd_eff_Vgi_bi+CIGD_i*Vgd_eff_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vsi_bi+0.0*Vgd_eff_Vgi_bi+CIGD_i*Vgd_eff_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Tempt_GND+0.0*Vgd_eff_Vgi_bi+CIGD_i*Vgd_eff_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(CIGD_i*Vgd_eff_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+CIGD_i*0.0));
  T2_Vdi_bi_Vgm_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+CIGD_i*0.0));
  T2_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+CIGD_i*0.0));
  T2_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vdi_bi+CIGD_i*0.0));
  T2_Vdi_bi_Vgi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vgi_bi+0.0*Vgd_eff_Vdi_bi+CIGD_i*Vgd_eff_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vdi_bi+0.0*Vgd_eff_Vdi_bi+CIGD_i*Vgd_eff_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vsi_bi+0.0*Vgd_eff_Vdi_bi+CIGD_i*Vgd_eff_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Tempt_GND+0.0*Vgd_eff_Vdi_bi+CIGD_i*Vgd_eff_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(CIGD_i*Vgd_eff_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+CIGD_i*0.0));
  T2_Vsi_bi_Vgm_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+CIGD_i*0.0));
  T2_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+CIGD_i*0.0));
  T2_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*Vgd_eff+0.0*0.0+0.0*Vgd_eff_Vsi_bi+CIGD_i*0.0));
  T2_Vsi_bi_Vgi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vgi_bi+0.0*Vgd_eff_Vsi_bi+CIGD_i*Vgd_eff_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vdi_bi+0.0*Vgd_eff_Vsi_bi+CIGD_i*Vgd_eff_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Vsi_bi+0.0*Vgd_eff_Vsi_bi+CIGD_i*Vgd_eff_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+0.0+(+0.0*Vgd_eff+0.0*Vgd_eff_Tempt_GND+0.0*Vgd_eff_Vsi_bi+CIGD_i*Vgd_eff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(CIGD_i*Vgd_eff_Tempt_GND);
#endif
#endif
T2=(1.0+(CIGD_i*Vgd_eff));
EXIT_IF_ISNAN((1.0+(CIGD_i*Vgd_eff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(((BechvbEdge*T1_Vgi_bi)*T2)+((BechvbEdge*T1)*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vgm_si)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vgm_si+((BechvbEdge*T1_Vgm_si))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vgm_si);
  T3_Vgi_bi_Vgm_di=(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vgm_di)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vgm_di+((BechvbEdge*T1_Vgm_di))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vgm_di);
  T3_Vgi_bi_Vdbulk_di=(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vdbulk_di)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vdbulk_di+((BechvbEdge*T1_Vdbulk_di))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vdbulk_di);
  T3_Vgi_bi_Vsbulk_si=(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vsbulk_si)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vsbulk_si+((BechvbEdge*T1_Vsbulk_si))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vsbulk_si);
  T3_Vgi_bi_Vgi_bi=(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vgi_bi)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vgi_bi+((BechvbEdge*T1_Vgi_bi))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vgi_bi);
  T3_Vgi_bi_Vdi_bi=(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vdi_bi)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vdi_bi+((BechvbEdge*T1_Vdi_bi))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vdi_bi);
  T3_Vgi_bi_Vsi_bi=(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Vsi_bi)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Vsi_bi+((BechvbEdge*T1_Vsi_bi))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Vsi_bi);
  T3_Vgi_bi_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+BechvbEdge*T1_Vgi_bi_Tempt_GND)*T2+(BechvbEdge*T1_Vgi_bi)*T2_Tempt_GND+((BechvbEdge*T1_Tempt_GND))*T2_Vgi_bi+(BechvbEdge*T1)*T2_Vgi_bi_Tempt_GND);
#endif
T3_Vdi_bi=(((BechvbEdge*T1_Vdi_bi)*T2)+((BechvbEdge*T1)*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vgm_si)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vgm_si+((BechvbEdge*T1_Vgm_si))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vgm_si);
  T3_Vdi_bi_Vgm_di=(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vgm_di)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vgm_di+((BechvbEdge*T1_Vgm_di))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vgm_di);
  T3_Vdi_bi_Vdbulk_di=(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vdbulk_di)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vdbulk_di+((BechvbEdge*T1_Vdbulk_di))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vdbulk_di);
  T3_Vdi_bi_Vsbulk_si=(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vsbulk_si)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vsbulk_si+((BechvbEdge*T1_Vsbulk_si))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vsbulk_si);
  T3_Vdi_bi_Vgi_bi=(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vgi_bi)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vgi_bi+((BechvbEdge*T1_Vgi_bi))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vgi_bi);
  T3_Vdi_bi_Vdi_bi=(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vdi_bi)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vdi_bi+((BechvbEdge*T1_Vdi_bi))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vdi_bi);
  T3_Vdi_bi_Vsi_bi=(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Vsi_bi)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Vsi_bi+((BechvbEdge*T1_Vsi_bi))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Vsi_bi);
  T3_Vdi_bi_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+BechvbEdge*T1_Vdi_bi_Tempt_GND)*T2+(BechvbEdge*T1_Vdi_bi)*T2_Tempt_GND+((BechvbEdge*T1_Tempt_GND))*T2_Vdi_bi+(BechvbEdge*T1)*T2_Vdi_bi_Tempt_GND);
#endif
T3_Vsi_bi=(((BechvbEdge*T1_Vsi_bi)*T2)+((BechvbEdge*T1)*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vgm_si)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vgm_si+((BechvbEdge*T1_Vgm_si))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vgm_si);
  T3_Vsi_bi_Vgm_di=(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vgm_di)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vgm_di+((BechvbEdge*T1_Vgm_di))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vgm_di);
  T3_Vsi_bi_Vdbulk_di=(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vdbulk_di)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vdbulk_di+((BechvbEdge*T1_Vdbulk_di))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vdbulk_di);
  T3_Vsi_bi_Vsbulk_si=(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vsbulk_si)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vsbulk_si+((BechvbEdge*T1_Vsbulk_si))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vsbulk_si);
  T3_Vsi_bi_Vgi_bi=(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vgi_bi)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vgi_bi+((BechvbEdge*T1_Vgi_bi))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vgi_bi);
  T3_Vsi_bi_Vdi_bi=(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vdi_bi)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vdi_bi+((BechvbEdge*T1_Vdi_bi))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vdi_bi);
  T3_Vsi_bi_Vsi_bi=(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Vsi_bi)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Vsi_bi+((BechvbEdge*T1_Vsi_bi))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Vsi_bi);
  T3_Vsi_bi_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+BechvbEdge*T1_Vsi_bi_Tempt_GND)*T2+(BechvbEdge*T1_Vsi_bi)*T2_Tempt_GND+((BechvbEdge*T1_Tempt_GND))*T2_Vsi_bi+(BechvbEdge*T1)*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(((BechvbEdge*T1_Tempt_GND)*T2)+((BechvbEdge*T1)*T2_Tempt_GND));
#endif
#endif
T3=((BechvbEdge*T1)*T2);
EXIT_IF_ISNAN(((BechvbEdge*T1)*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=bsimbulk_d_lexp(T3,T3_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=T3_Vgi_bi_Vgm_si;
  T4_Vgi_bi_Vgm_di=T3_Vgi_bi_Vgm_di;
  T4_Vgi_bi_Vdbulk_di=T3_Vgi_bi_Vdbulk_di;
  T4_Vgi_bi_Vsbulk_si=T3_Vgi_bi_Vsbulk_si;
  T4_Vgi_bi_Vgi_bi=T3_Vgi_bi_Vgi_bi;
  T4_Vgi_bi_Vdi_bi=T3_Vgi_bi_Vdi_bi;
  T4_Vgi_bi_Vsi_bi=T3_Vgi_bi_Vsi_bi;
  T4_Vgi_bi_Tempt_GND=T3_Vgi_bi_Tempt_GND;
#endif
T4_Vdi_bi=bsimbulk_d_lexp(T3,T3_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=T3_Vdi_bi_Vgm_si;
  T4_Vdi_bi_Vgm_di=T3_Vdi_bi_Vgm_di;
  T4_Vdi_bi_Vdbulk_di=T3_Vdi_bi_Vdbulk_di;
  T4_Vdi_bi_Vsbulk_si=T3_Vdi_bi_Vsbulk_si;
  T4_Vdi_bi_Vgi_bi=T3_Vdi_bi_Vgi_bi;
  T4_Vdi_bi_Vdi_bi=T3_Vdi_bi_Vdi_bi;
  T4_Vdi_bi_Vsi_bi=T3_Vdi_bi_Vsi_bi;
  T4_Vdi_bi_Tempt_GND=T3_Vdi_bi_Tempt_GND;
#endif
T4_Vsi_bi=bsimbulk_d_lexp(T3,T3_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=T3_Vsi_bi_Vgm_si;
  T4_Vsi_bi_Vgm_di=T3_Vsi_bi_Vgm_di;
  T4_Vsi_bi_Vdbulk_di=T3_Vsi_bi_Vdbulk_di;
  T4_Vsi_bi_Vsbulk_si=T3_Vsi_bi_Vsbulk_si;
  T4_Vsi_bi_Vgi_bi=T3_Vsi_bi_Vgi_bi;
  T4_Vsi_bi_Vdi_bi=T3_Vsi_bi_Vdi_bi;
  T4_Vsi_bi_Vsi_bi=T3_Vsi_bi_Vsi_bi;
  T4_Vsi_bi_Tempt_GND=T3_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=bsimbulk_d_lexp(T3,T3_Tempt_GND);
#endif
#endif
T4=bsimbulk_lexp(T3);
EXIT_IF_ISNAN(bsimbulk_lexp(T3))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
igd_mult_Tempt_GND=igtemp_Tempt_GND*pInst->NF*AechvbEdge*DLCIGD_i;
#endif
igd_mult=(((igtemp*pInst->NF)*AechvbEdge)*DLCIGD_i);
EXIT_IF_ISNAN((((igtemp*pInst->NF)*AechvbEdge)*DLCIGD_i))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
igd_Tempt_GND=((((igd_mult_Tempt_GND*Vgd_noswap*Vgd_eff)+((igd_mult*Vgd_noswap)*Vgd_eff_Tempt_GND))*T4)+(((igd_mult*Vgd_noswap)*Vgd_eff)*T4_Tempt_GND));
igd_Vgi_bi=(((((igd_mult*Vgd_noswap_Vgi_bi)*Vgd_eff)+((igd_mult*Vgd_noswap)*Vgd_eff_Vgi_bi))*T4)+(((igd_mult*Vgd_noswap)*Vgd_eff)*T4_Vgi_bi));
igd_Vdi_bi=(((((igd_mult*Vgd_noswap_Vdi_bi)*Vgd_eff)+((igd_mult*Vgd_noswap)*Vgd_eff_Vdi_bi))*T4)+(((igd_mult*Vgd_noswap)*Vgd_eff)*T4_Vdi_bi));
igd_Vsi_bi=((((igd_mult*Vgd_noswap)*Vgd_eff_Vsi_bi)*T4)+(((igd_mult*Vgd_noswap)*Vgd_eff)*T4_Vsi_bi));
#endif
igd=(((igd_mult*Vgd_noswap)*Vgd_eff)*T4);
EXIT_IF_ISNAN((((igd_mult*Vgd_noswap)*Vgd_eff)*T4))
}
}
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(si,bi)V(di,bi) ddxprobe= */
IGS_Tempt_GND=(devsign*igs_Tempt_GND);
IGS_Vgi_bi=(devsign*igs_Vgi_bi);
IGS_Vsi_bi=(devsign*igs_Vsi_bi);
IGS_Vdi_bi=(devsign*igs_Vdi_bi);
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGS]=(devsign*igs);
EXIT_IF_ISNAN((devsign*igs))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
IGD_Tempt_GND=(devsign*igd_Tempt_GND);
IGD_Vgi_bi=(devsign*igd_Vgi_bi);
IGD_Vdi_bi=(devsign*igd_Vdi_bi);
IGD_Vsi_bi=(devsign*igd_Vsi_bi);
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGD]=(devsign*igd);
EXIT_IF_ISNAN((devsign*igd))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
IGB_Vgi_bi=(devsign*igb_Vgi_bi);
IGB_Vdi_bi=(devsign*igb_Vdi_bi);
IGB_Vsi_bi=(devsign*igb_Vsi_bi);
IGB_Tempt_GND=(devsign*igb_Tempt_GND);
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGB]=(devsign*igb);
EXIT_IF_ISNAN((devsign*igb))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
IGCS_Vgi_bi=(devsign*igcs_Vgi_bi);
IGCS_Vdi_bi=(devsign*igcs_Vdi_bi);
IGCS_Vsi_bi=(devsign*igcs_Vsi_bi);
IGCS_Tempt_GND=(devsign*igcs_Tempt_GND);
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCS]=(devsign*igcs);
EXIT_IF_ISNAN((devsign*igcs))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
IGCD_Vgi_bi=(devsign*igcd_Vgi_bi);
IGCD_Vdi_bi=(devsign*igcd_Vdi_bi);
IGCD_Vsi_bi=(devsign*igcd_Vsi_bi);
IGCD_Tempt_GND=(devsign*igcd_Tempt_GND);
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCD]=(devsign*igcd);
EXIT_IF_ISNAN((devsign*igcd))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igisl_Vgi_bi=0.0;
igisl_Vdi_bi=0.0;
igisl_Vsi_bi=0.0;
igisl_Tempt_GND=0.0;
#endif
igisl=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igidl_Vgi_bi=0.0;
igidl_Vdi_bi=0.0;
igidl_Vsi_bi=0.0;
igidl_Tempt_GND=0.0;
#endif
igidl=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->GIDLMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=0.0;
#endif
#endif
T0=(epsratio*pModel->TOXE);
EXIT_IF_ISNAN((epsratio*pModel->TOXE))
if
((((AGIDL_i<=0.0)||(BGIDL_t<=0.0))||(CGIDL_i<0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=0.0;
  T6_Vgi_bi_Vgm_si=0.0;
  T6_Vgi_bi_Vdbulk_di=0.0;
  T6_Vgi_bi_Vsbulk_si=0.0;
  T6_Vgi_bi_Vgi_bi=0.0;
  T6_Vgi_bi_Vdi_bi=0.0;
  T6_Vgi_bi_Vsi_bi=0.0;
  T6_Vgi_bi_Tempt_GND=0.0;
#endif
T6_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=0.0;
  T6_Vdi_bi_Vgm_si=0.0;
  T6_Vdi_bi_Vdbulk_di=0.0;
  T6_Vdi_bi_Vsbulk_si=0.0;
  T6_Vdi_bi_Vgi_bi=0.0;
  T6_Vdi_bi_Vdi_bi=0.0;
  T6_Vdi_bi_Vsi_bi=0.0;
  T6_Vdi_bi_Tempt_GND=0.0;
#endif
T6_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=0.0;
  T6_Vsi_bi_Vgm_si=0.0;
  T6_Vsi_bi_Vdbulk_di=0.0;
  T6_Vsi_bi_Vsbulk_si=0.0;
  T6_Vsi_bi_Vgi_bi=0.0;
  T6_Vsi_bi_Vdi_bi=0.0;
  T6_Vsi_bi_Vsi_bi=0.0;
  T6_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=0.0;
#endif
#endif
T6=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(((-Vgd_noswap_Vgi_bi)*T0-(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi)/T0/T0);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vgi_bi)*T0_Vgm_di+0.0*T0_Vgi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi_Vgm_di)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vgm_di/T0/T0/T0);
  T1_Vgi_bi_Vgm_si=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vgi_bi)*T0_Vgm_si+0.0*T0_Vgi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi_Vgm_si)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vgm_si/T0/T0/T0);
  T1_Vgi_bi_Vdbulk_di=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vgi_bi)*T0_Vdbulk_di+0.0*T0_Vgi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi_Vdbulk_di)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vdbulk_di/T0/T0/T0);
  T1_Vgi_bi_Vsbulk_si=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vgi_bi)*T0_Vsbulk_si+0.0*T0_Vgi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi_Vsbulk_si)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vsbulk_si/T0/T0/T0);
  T1_Vgi_bi_Vgi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vgi_bi)*T0_Vgi_bi+(-Vgd_noswap_Vgi_bi)*T0_Vgi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi_Vgi_bi)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vgi_bi/T0/T0/T0);
  T1_Vgi_bi_Vdi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vgi_bi)*T0_Vdi_bi+(-Vgd_noswap_Vdi_bi)*T0_Vgi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi_Vdi_bi)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vdi_bi/T0/T0/T0);
  T1_Vgi_bi_Vsi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vgi_bi)*T0_Vsi_bi+0.0*T0_Vgi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi_Vsi_bi)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vsi_bi/T0/T0/T0);
  T1_Vgi_bi_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vgi_bi)*T0_Tempt_GND+Vfbsdr_Tempt_GND*T0_Vgi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi_Tempt_GND)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vgi_bi*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vdi_bi=(((-Vgd_noswap_Vdi_bi)*T0-(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi)/T0/T0);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vdi_bi)*T0_Vgm_di+0.0*T0_Vdi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi_Vgm_di)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vgm_di/T0/T0/T0);
  T1_Vdi_bi_Vgm_si=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vdi_bi)*T0_Vgm_si+0.0*T0_Vdi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi_Vgm_si)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vgm_si/T0/T0/T0);
  T1_Vdi_bi_Vdbulk_di=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vdi_bi)*T0_Vdbulk_di+0.0*T0_Vdi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi_Vdbulk_di)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vdbulk_di/T0/T0/T0);
  T1_Vdi_bi_Vsbulk_si=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vdi_bi)*T0_Vsbulk_si+0.0*T0_Vdi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi_Vsbulk_si)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vsbulk_si/T0/T0/T0);
  T1_Vdi_bi_Vgi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vdi_bi)*T0_Vgi_bi+(-Vgd_noswap_Vgi_bi)*T0_Vdi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi_Vgi_bi)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vgi_bi/T0/T0/T0);
  T1_Vdi_bi_Vdi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vdi_bi)*T0_Vdi_bi+(-Vgd_noswap_Vdi_bi)*T0_Vdi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi_Vdi_bi)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vdi_bi/T0/T0/T0);
  T1_Vdi_bi_Vsi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vdi_bi)*T0_Vsi_bi+0.0*T0_Vdi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi_Vsi_bi)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vsi_bi/T0/T0/T0);
  T1_Vdi_bi_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-((-Vgd_noswap_Vdi_bi)*T0_Tempt_GND+Vfbsdr_Tempt_GND*T0_Vdi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi_Tempt_GND)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vdi_bi*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vsi_bi=(-(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi/T0/T0);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vgm_di+0.0*T0_Vsi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi_Vgm_di)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vgm_di/T0/T0/T0);
  T1_Vsi_bi_Vgm_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vgm_si+0.0*T0_Vsi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi_Vgm_si)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vgm_si/T0/T0/T0);
  T1_Vsi_bi_Vdbulk_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi_Vdbulk_di)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vdbulk_di/T0/T0/T0);
  T1_Vsi_bi_Vsbulk_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi_Vsbulk_si)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vsbulk_si/T0/T0/T0);
  T1_Vsi_bi_Vgi_bi=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vgi_bi+(-Vgd_noswap_Vgi_bi)*T0_Vsi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi_Vgi_bi)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vgi_bi/T0/T0/T0);
  T1_Vsi_bi_Vdi_bi=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_bi+(-Vgd_noswap_Vdi_bi)*T0_Vsi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi_Vdi_bi)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vdi_bi/T0/T0/T0);
  T1_Vsi_bi_Vsi_bi=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi_Vsi_bi)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vsi_bi/T0/T0/T0);
  T1_Vsi_bi_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+Vfbsdr_Tempt_GND*T0_Vsi_bi+(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi_Tempt_GND)/T0/T0+2*(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Vsi_bi*T0_Tempt_GND/T0/T0/T0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((Vfbsdr_Tempt_GND*T0-(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*T0_Tempt_GND)/T0/T0);
#endif
#endif
T1=((((-Vgd_noswap)-EGIDL_i)+Vfbsdr)/T0);
EXIT_IF_ISNAN(((((-Vgd_noswap)-EGIDL_i)+Vfbsdr)/T0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=bsimbulk_d_hypsmooth(T1,1.0e-2,T1_Vgi_bi,0.0);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=bsimbulk_d_hypsmooth(T1,1.0e-2,T1_Vdi_bi,0.0);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=bsimbulk_d_hypsmooth(T1,1.0e-2,T1_Vsi_bi,0.0);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_hypsmooth(T1,1.0e-2,T1_Tempt_GND,0.0);
#endif
#endif
T1=bsimbulk_hypsmooth(T1,1.0e-2);
EXIT_IF_ISNAN(bsimbulk_hypsmooth(T1,1.0e-2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(-BGIDL_t*T1_Vgi_bi/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_di+0.0*T1_Vgi_bi+BGIDL_t*(+T1_Vgi_bi_Vgm_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vgi_bi*T1_Vgm_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vgm_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_si+0.0*T1_Vgi_bi+BGIDL_t*(+T1_Vgi_bi_Vgm_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vgi_bi*T1_Vgm_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vdbulk_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+BGIDL_t*(+T1_Vgi_bi_Vdbulk_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vgi_bi*T1_Vdbulk_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vsbulk_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+BGIDL_t*(+T1_Vgi_bi_Vsbulk_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vgi_bi*T1_Vsbulk_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vgi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+BGIDL_t*(+T1_Vgi_bi_Vgi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vgi_bi*T1_Vgi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vdi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+BGIDL_t*(+T1_Vgi_bi_Vdi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vgi_bi*T1_Vdi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vsi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+BGIDL_t*(+T1_Vgi_bi_Vsi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vgi_bi*T1_Vsi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Vgi_bi+BGIDL_t*(+T1_Vgi_bi_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vgi_bi*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vdi_bi=(-BGIDL_t*T1_Vdi_bi/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_di+0.0*T1_Vdi_bi+BGIDL_t*(+T1_Vdi_bi_Vgm_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_bi*T1_Vgm_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vgm_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_si+0.0*T1_Vdi_bi+BGIDL_t*(+T1_Vdi_bi_Vgm_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_bi*T1_Vgm_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vdbulk_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+BGIDL_t*(+T1_Vdi_bi_Vdbulk_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_bi*T1_Vdbulk_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vsbulk_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+BGIDL_t*(+T1_Vdi_bi_Vsbulk_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_bi*T1_Vsbulk_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vgi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+BGIDL_t*(+T1_Vdi_bi_Vgi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_bi*T1_Vgi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vdi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+BGIDL_t*(+T1_Vdi_bi_Vdi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_bi*T1_Vdi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vsi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+BGIDL_t*(+T1_Vdi_bi_Vsi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_bi*T1_Vsi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Vdi_bi+BGIDL_t*(+T1_Vdi_bi_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_bi*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vsi_bi=(-BGIDL_t*T1_Vsi_bi/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_di+0.0*T1_Vsi_bi+BGIDL_t*(+T1_Vsi_bi_Vgm_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vsi_bi*T1_Vgm_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vgm_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_si+0.0*T1_Vsi_bi+BGIDL_t*(+T1_Vsi_bi_Vgm_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vsi_bi*T1_Vgm_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vdbulk_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+BGIDL_t*(+T1_Vsi_bi_Vdbulk_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vsi_bi*T1_Vdbulk_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vsbulk_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+BGIDL_t*(+T1_Vsi_bi_Vsbulk_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vsi_bi*T1_Vsbulk_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vgi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+BGIDL_t*(+T1_Vsi_bi_Vgi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vsi_bi*T1_Vgi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vdi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+BGIDL_t*(+T1_Vsi_bi_Vdi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vsi_bi*T1_Vdi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vsi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+BGIDL_t*(+T1_Vsi_bi_Vsi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vsi_bi*T1_Vsi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Vsi_bi+BGIDL_t*(+T1_Vsi_bi_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vsi_bi*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((BGIDL_t_Tempt_GND*(T1+1.0e-3)-BGIDL_t*T1_Tempt_GND)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
#endif
T2=(BGIDL_t/(T1+1.0e-3));
EXIT_IF_ISNAN((BGIDL_t/(T1+1.0e-3)))
if
((CGIDL_i!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=((((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi))*Vdb_noswap)+((Vdb_noswap*Vdb_noswap)*Vdb_noswap_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+0.0*Vdb_noswap+Vdb_noswap_Vdi_bi*0.0+0.0*Vdb_noswap_Vdi_bi+Vdb_noswap*0.0)*Vdb_noswap+((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi))*0.0+(0.0)*Vdb_noswap_Vdi_bi+(Vdb_noswap*Vdb_noswap)*0.0);
  T3_Vdi_bi_Vgm_di=(+(+0.0*Vdb_noswap+Vdb_noswap_Vdi_bi*0.0+0.0*Vdb_noswap_Vdi_bi+Vdb_noswap*0.0)*Vdb_noswap+((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi))*0.0+(0.0)*Vdb_noswap_Vdi_bi+(Vdb_noswap*Vdb_noswap)*0.0);
  T3_Vdi_bi_Vdbulk_di=(+(+0.0*Vdb_noswap+Vdb_noswap_Vdi_bi*0.0+0.0*Vdb_noswap_Vdi_bi+Vdb_noswap*0.0)*Vdb_noswap+((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi))*0.0+(0.0)*Vdb_noswap_Vdi_bi+(Vdb_noswap*Vdb_noswap)*0.0);
  T3_Vdi_bi_Vsbulk_si=(+(+0.0*Vdb_noswap+Vdb_noswap_Vdi_bi*0.0+0.0*Vdb_noswap_Vdi_bi+Vdb_noswap*0.0)*Vdb_noswap+((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi))*0.0+(0.0)*Vdb_noswap_Vdi_bi+(Vdb_noswap*Vdb_noswap)*0.0);
  T3_Vdi_bi_Vgi_bi=(+(+0.0*Vdb_noswap+Vdb_noswap_Vdi_bi*0.0+0.0*Vdb_noswap_Vdi_bi+Vdb_noswap*0.0)*Vdb_noswap+((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi))*0.0+(0.0)*Vdb_noswap_Vdi_bi+(Vdb_noswap*Vdb_noswap)*0.0);
  T3_Vdi_bi_Vdi_bi=(+(+Vdb_noswap_Vdi_bi_Vdi_bi*Vdb_noswap+Vdb_noswap_Vdi_bi*Vdb_noswap_Vdi_bi+Vdb_noswap_Vdi_bi*Vdb_noswap_Vdi_bi+Vdb_noswap*Vdb_noswap_Vdi_bi_Vdi_bi)*Vdb_noswap+((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi))*Vdb_noswap_Vdi_bi+(((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi)))*Vdb_noswap_Vdi_bi+(Vdb_noswap*Vdb_noswap)*Vdb_noswap_Vdi_bi_Vdi_bi);
  T3_Vdi_bi_Vsi_bi=(+(+0.0*Vdb_noswap+Vdb_noswap_Vdi_bi*0.0+0.0*Vdb_noswap_Vdi_bi+Vdb_noswap*0.0)*Vdb_noswap+((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi))*0.0+(0.0)*Vdb_noswap_Vdi_bi+(Vdb_noswap*Vdb_noswap)*0.0);
  T3_Vdi_bi_Tempt_GND=(+(+0.0*Vdb_noswap+Vdb_noswap_Vdi_bi*0.0+0.0*Vdb_noswap_Vdi_bi+Vdb_noswap*0.0)*Vdb_noswap+((Vdb_noswap_Vdi_bi*Vdb_noswap)+(Vdb_noswap*Vdb_noswap_Vdi_bi))*0.0+(0.0)*Vdb_noswap_Vdi_bi+(Vdb_noswap*Vdb_noswap)*0.0);
#endif
T3_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=0.0;
  T3_Vsi_bi_Vgm_di=0.0;
  T3_Vsi_bi_Vdbulk_di=0.0;
  T3_Vsi_bi_Vsbulk_si=0.0;
  T3_Vsi_bi_Vgi_bi=0.0;
  T3_Vsi_bi_Vdi_bi=0.0;
  T3_Vsi_bi_Vsi_bi=0.0;
  T3_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=0.0;
#endif
#endif
T3=((Vdb_noswap*Vdb_noswap)*Vdb_noswap);
EXIT_IF_ISNAN(((Vdb_noswap*Vdb_noswap)*Vdb_noswap))
{
double m00_fabs(d00_fabs0,T3)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,T3)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=T3_Vgi_bi*d10_fabs0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+0.0+(m20_fabs(T3)*T3_Vgm_si*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vgm_si))+0.0);
  T4_Vgi_bi_Vgm_di=(+(+0.0+(m20_fabs(T3)*T3_Vgm_di*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vgm_di))+0.0);
  T4_Vgi_bi_Vdbulk_di=(+(+0.0+(m20_fabs(T3)*T3_Vdbulk_di*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vdbulk_di))+0.0);
  T4_Vgi_bi_Vsbulk_si=(+(+0.0+(m20_fabs(T3)*T3_Vsbulk_si*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vsbulk_si))+0.0);
  T4_Vgi_bi_Vgi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vgi_bi*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vgi_bi))+0.0);
  T4_Vgi_bi_Vdi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vdi_bi*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vdi_bi))+0.0);
  T4_Vgi_bi_Vsi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vsi_bi*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vsi_bi))+0.0);
  T4_Vgi_bi_Tempt_GND=(+(+0.0+(m20_fabs(T3)*T3_Tempt_GND*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Tempt_GND))+0.0);
#endif
T4_Vdi_bi=T3_Vdi_bi*d10_fabs0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+0.0+(m20_fabs(T3)*T3_Vgm_si*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vgm_si))+0.0);
  T4_Vdi_bi_Vgm_di=(+(+0.0+(m20_fabs(T3)*T3_Vgm_di*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vgm_di))+0.0);
  T4_Vdi_bi_Vdbulk_di=(+(+0.0+(m20_fabs(T3)*T3_Vdbulk_di*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vdbulk_di))+0.0);
  T4_Vdi_bi_Vsbulk_si=(+(+0.0+(m20_fabs(T3)*T3_Vsbulk_si*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vsbulk_si))+0.0);
  T4_Vdi_bi_Vgi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vgi_bi*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vgi_bi))+0.0);
  T4_Vdi_bi_Vdi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vdi_bi*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vdi_bi))+0.0);
  T4_Vdi_bi_Vsi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vsi_bi*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vsi_bi))+0.0);
  T4_Vdi_bi_Tempt_GND=(+(+0.0+(m20_fabs(T3)*T3_Tempt_GND*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Tempt_GND))+0.0);
#endif
T4_Vsi_bi=T3_Vsi_bi*d10_fabs0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+0.0+(m20_fabs(T3)*T3_Vgm_si*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vgm_si))+0.0);
  T4_Vsi_bi_Vgm_di=(+(+0.0+(m20_fabs(T3)*T3_Vgm_di*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vgm_di))+0.0);
  T4_Vsi_bi_Vdbulk_di=(+(+0.0+(m20_fabs(T3)*T3_Vdbulk_di*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vdbulk_di))+0.0);
  T4_Vsi_bi_Vsbulk_si=(+(+0.0+(m20_fabs(T3)*T3_Vsbulk_si*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vsbulk_si))+0.0);
  T4_Vsi_bi_Vgi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vgi_bi*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vgi_bi))+0.0);
  T4_Vsi_bi_Vdi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vdi_bi*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vdi_bi))+0.0);
  T4_Vsi_bi_Vsi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vsi_bi*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vsi_bi))+0.0);
  T4_Vsi_bi_Tempt_GND=(+(+0.0+(m20_fabs(T3)*T3_Tempt_GND*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Tempt_GND))+0.0);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=T3_Tempt_GND*d10_fabs0;
#endif
#endif
T4=((CGIDL_i+d00_fabs0)+1.0e-4);
EXIT_IF_ISNAN(((CGIDL_i+d00_fabs0)+1.0e-4))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=bsimbulk_d_hypsmooth((T3/T4),1.0e-6,((T3_Vgi_bi*T4-T3*T4_Vgi_bi)/T4/T4),0.0);
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+0.0-0.0);
  T5_Vgi_bi_Vgm_di=(+0.0-0.0);
  T5_Vgi_bi_Vdbulk_di=(+0.0-0.0);
  T5_Vgi_bi_Vsbulk_si=(+0.0-0.0);
  T5_Vgi_bi_Vgi_bi=(+0.0-0.0);
  T5_Vgi_bi_Vdi_bi=(+0.0-0.0);
  T5_Vgi_bi_Vsi_bi=(+0.0-0.0);
  T5_Vgi_bi_Tempt_GND=(+0.0-0.0);
#endif
T5_Vdi_bi=bsimbulk_d_hypsmooth((T3/T4),1.0e-6,((T3_Vdi_bi*T4-T3*T4_Vdi_bi)/T4/T4),0.0);
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+0.0-0.0);
  T5_Vdi_bi_Vgm_di=(+0.0-0.0);
  T5_Vdi_bi_Vdbulk_di=(+0.0-0.0);
  T5_Vdi_bi_Vsbulk_si=(+0.0-0.0);
  T5_Vdi_bi_Vgi_bi=(+0.0-0.0);
  T5_Vdi_bi_Vdi_bi=(+0.0-0.0);
  T5_Vdi_bi_Vsi_bi=(+0.0-0.0);
  T5_Vdi_bi_Tempt_GND=(+0.0-0.0);
#endif
T5_Vsi_bi=bsimbulk_d_hypsmooth((T3/T4),1.0e-6,((T3_Vsi_bi*T4-T3*T4_Vsi_bi)/T4/T4),0.0);
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+0.0-0.0);
  T5_Vsi_bi_Vgm_di=(+0.0-0.0);
  T5_Vsi_bi_Vdbulk_di=(+0.0-0.0);
  T5_Vsi_bi_Vsbulk_si=(+0.0-0.0);
  T5_Vsi_bi_Vgi_bi=(+0.0-0.0);
  T5_Vsi_bi_Vdi_bi=(+0.0-0.0);
  T5_Vsi_bi_Vsi_bi=(+0.0-0.0);
  T5_Vsi_bi_Tempt_GND=(+0.0-0.0);
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=bsimbulk_d_hypsmooth((T3/T4),1.0e-6,((T3_Tempt_GND*T4-T3*T4_Tempt_GND)/T4/T4),0.0);
#endif
#endif
T5=(bsimbulk_hypsmooth((T3/T4),1.0e-6)-1.0e-6);
EXIT_IF_ISNAN((bsimbulk_hypsmooth((T3/T4),1.0e-6)-1.0e-6))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=1.0;
EXIT_IF_ISNAN(1.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=((((((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5)+((((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(AGIDL_i*Weff)*T1_Vgi_bi_Vgm_di)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_di)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vgm_di+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_di)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(AGIDL_i*Weff)*T1_Vgi_bi_Vgm_si)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_si)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vgm_si+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_si)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(AGIDL_i*Weff)*T1_Vgi_bi_Vdbulk_di)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vdbulk_di+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(AGIDL_i*Weff)*T1_Vgi_bi_Vsbulk_si)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vsbulk_si+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(AGIDL_i*Weff)*T1_Vgi_bi_Vgi_bi)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vgi_bi+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgi_bi)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(AGIDL_i*Weff)*T1_Vgi_bi_Vdi_bi)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vdi_bi+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdi_bi)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(AGIDL_i*Weff)*T1_Vgi_bi_Vsi_bi)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vsi_bi+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsi_bi)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(AGIDL_i*Weff)*T1_Vgi_bi_Tempt_GND)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Tempt_GND)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Tempt_GND+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Tempt_GND)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=((((((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5)+((((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(AGIDL_i*Weff)*T1_Vdi_bi_Vgm_di)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_di)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vgm_di+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_di)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(AGIDL_i*Weff)*T1_Vdi_bi_Vgm_si)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_si)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vgm_si+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_si)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(AGIDL_i*Weff)*T1_Vdi_bi_Vdbulk_di)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vdbulk_di+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(AGIDL_i*Weff)*T1_Vdi_bi_Vsbulk_si)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vsbulk_si+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(AGIDL_i*Weff)*T1_Vdi_bi_Vgi_bi)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vgi_bi+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgi_bi)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(AGIDL_i*Weff)*T1_Vdi_bi_Vdi_bi)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vdi_bi+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdi_bi)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(AGIDL_i*Weff)*T1_Vdi_bi_Vsi_bi)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vsi_bi+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsi_bi)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(AGIDL_i*Weff)*T1_Vdi_bi_Tempt_GND)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Tempt_GND)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Tempt_GND+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Tempt_GND)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((((((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5)+((((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(AGIDL_i*Weff)*T1_Vsi_bi_Vgm_di)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_di)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vgm_di+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_di)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(AGIDL_i*Weff)*T1_Vsi_bi_Vgm_si)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_si)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vgm_si+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgm_si)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(AGIDL_i*Weff)*T1_Vsi_bi_Vdbulk_di)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vdbulk_di+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(AGIDL_i*Weff)*T1_Vsi_bi_Vsbulk_si)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vsbulk_si+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(AGIDL_i*Weff)*T1_Vsi_bi_Vgi_bi)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vgi_bi+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vgi_bi)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(AGIDL_i*Weff)*T1_Vsi_bi_Vdi_bi)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vdi_bi+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vdi_bi)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(AGIDL_i*Weff)*T1_Vsi_bi_Vsi_bi)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vsi_bi+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Vsi_bi)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(AGIDL_i*Weff)*T1_Vsi_bi_Tempt_GND)*bsimbulk_lexp((-T2))+((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGIDL_i*Weff)*T1_Tempt_GND)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGIDL_i*Weff)*T1)*0.0)*T5+((((AGIDL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Tempt_GND+(((((((0.0)*T1)+((AGIDL_i*Weff)*T1_Tempt_GND)))*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((((((AGIDL_i*Weff)*T1_Tempt_GND)*bsimbulk_lexp((-T2)))+(((AGIDL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Tempt_GND))))*T5)+((((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Tempt_GND));
#endif
#endif
T6=((((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5);
EXIT_IF_ISNAN(((((AGIDL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5))
}
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igidl_Vgi_bi=T6_Vgi_bi;
igidl_Vdi_bi=T6_Vdi_bi;
igidl_Vsi_bi=T6_Vsi_bi;
igidl_Tempt_GND=T6_Tempt_GND;
#endif
igidl=T6;
EXIT_IF_ISNAN(T6)
if
((((AGISL_i<=0.0)||(BGISL_t<=0.0))||(CGISL_i<0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=0.0;
  T6_Vgi_bi_Vgm_si=0.0;
  T6_Vgi_bi_Vdbulk_di=0.0;
  T6_Vgi_bi_Vsbulk_si=0.0;
  T6_Vgi_bi_Vgi_bi=0.0;
  T6_Vgi_bi_Vdi_bi=0.0;
  T6_Vgi_bi_Vsi_bi=0.0;
  T6_Vgi_bi_Tempt_GND=0.0;
#endif
T6_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=0.0;
  T6_Vdi_bi_Vgm_si=0.0;
  T6_Vdi_bi_Vdbulk_di=0.0;
  T6_Vdi_bi_Vsbulk_si=0.0;
  T6_Vdi_bi_Vgi_bi=0.0;
  T6_Vdi_bi_Vdi_bi=0.0;
  T6_Vdi_bi_Vsi_bi=0.0;
  T6_Vdi_bi_Tempt_GND=0.0;
#endif
T6_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=0.0;
  T6_Vsi_bi_Vgm_si=0.0;
  T6_Vsi_bi_Vdbulk_di=0.0;
  T6_Vsi_bi_Vsbulk_si=0.0;
  T6_Vsi_bi_Vgi_bi=0.0;
  T6_Vsi_bi_Vdi_bi=0.0;
  T6_Vsi_bi_Vsi_bi=0.0;
  T6_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=0.0;
#endif
#endif
T6=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(((-Vgs_noswap_Vgi_bi)*T0-(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi)/T0/T0);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vgi_bi)*T0_Vgm_di+0.0*T0_Vgi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi_Vgm_di)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vgm_di/T0/T0/T0);
  T1_Vgi_bi_Vgm_si=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vgi_bi)*T0_Vgm_si+0.0*T0_Vgi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi_Vgm_si)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vgm_si/T0/T0/T0);
  T1_Vgi_bi_Vdbulk_di=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vgi_bi)*T0_Vdbulk_di+0.0*T0_Vgi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi_Vdbulk_di)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vdbulk_di/T0/T0/T0);
  T1_Vgi_bi_Vsbulk_si=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vgi_bi)*T0_Vsbulk_si+0.0*T0_Vgi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi_Vsbulk_si)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vsbulk_si/T0/T0/T0);
  T1_Vgi_bi_Vgi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vgi_bi)*T0_Vgi_bi+(-Vgs_noswap_Vgi_bi)*T0_Vgi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi_Vgi_bi)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vgi_bi/T0/T0/T0);
  T1_Vgi_bi_Vdi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vgi_bi)*T0_Vdi_bi+0.0*T0_Vgi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi_Vdi_bi)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vdi_bi/T0/T0/T0);
  T1_Vgi_bi_Vsi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vgi_bi)*T0_Vsi_bi+(-Vgs_noswap_Vsi_bi)*T0_Vgi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi_Vsi_bi)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi*T0_Vsi_bi/T0/T0/T0);
  T1_Vgi_bi_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vgi_bi)*T0_Tempt_GND+Vfbsdr_Tempt_GND*T0_Vgi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi_Tempt_GND)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vgi_bi*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vdi_bi=(-(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi/T0/T0);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vgm_di+0.0*T0_Vdi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi_Vgm_di)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vgm_di/T0/T0/T0);
  T1_Vdi_bi_Vgm_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vgm_si+0.0*T0_Vdi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi_Vgm_si)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vgm_si/T0/T0/T0);
  T1_Vdi_bi_Vdbulk_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi_Vdbulk_di)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vdbulk_di/T0/T0/T0);
  T1_Vdi_bi_Vsbulk_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi_Vsbulk_si)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vsbulk_si/T0/T0/T0);
  T1_Vdi_bi_Vgi_bi=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vgi_bi+(-Vgs_noswap_Vgi_bi)*T0_Vdi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi_Vgi_bi)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vgi_bi/T0/T0/T0);
  T1_Vdi_bi_Vdi_bi=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi_Vdi_bi)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vdi_bi/T0/T0/T0);
  T1_Vdi_bi_Vsi_bi=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vsi_bi+(-Vgs_noswap_Vsi_bi)*T0_Vdi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi_Vsi_bi)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi*T0_Vsi_bi/T0/T0/T0);
  T1_Vdi_bi_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+Vfbsdr_Tempt_GND*T0_Vdi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi_Tempt_GND)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vdi_bi*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vsi_bi=(((-Vgs_noswap_Vsi_bi)*T0-(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi)/T0/T0);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vsi_bi)*T0_Vgm_di+0.0*T0_Vsi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi_Vgm_di)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vgm_di/T0/T0/T0);
  T1_Vsi_bi_Vgm_si=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vsi_bi)*T0_Vgm_si+0.0*T0_Vsi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi_Vgm_si)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vgm_si/T0/T0/T0);
  T1_Vsi_bi_Vdbulk_di=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vsi_bi)*T0_Vdbulk_di+0.0*T0_Vsi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi_Vdbulk_di)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vdbulk_di/T0/T0/T0);
  T1_Vsi_bi_Vsbulk_si=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vsi_bi)*T0_Vsbulk_si+0.0*T0_Vsi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi_Vsbulk_si)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vsbulk_si/T0/T0/T0);
  T1_Vsi_bi_Vgi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vsi_bi)*T0_Vgi_bi+(-Vgs_noswap_Vgi_bi)*T0_Vsi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi_Vgi_bi)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vgi_bi/T0/T0/T0);
  T1_Vsi_bi_Vdi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vsi_bi)*T0_Vdi_bi+0.0*T0_Vsi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi_Vdi_bi)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vdi_bi/T0/T0/T0);
  T1_Vsi_bi_Vsi_bi=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vsi_bi)*T0_Vsi_bi+(-Vgs_noswap_Vsi_bi)*T0_Vsi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi_Vsi_bi)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi*T0_Vsi_bi/T0/T0/T0);
  T1_Vsi_bi_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-((-Vgs_noswap_Vsi_bi)*T0_Tempt_GND+Vfbsdr_Tempt_GND*T0_Vsi_bi+(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi_Tempt_GND)/T0/T0+2*(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Vsi_bi*T0_Tempt_GND/T0/T0/T0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((Vfbsdr_Tempt_GND*T0-(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*T0_Tempt_GND)/T0/T0);
#endif
#endif
T1=((((-Vgs_noswap)-EGISL_i)+Vfbsdr)/T0);
EXIT_IF_ISNAN(((((-Vgs_noswap)-EGISL_i)+Vfbsdr)/T0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=bsimbulk_d_hypsmooth(T1,1.0e-2,T1_Vgi_bi,0.0);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=bsimbulk_d_hypsmooth(T1,1.0e-2,T1_Vdi_bi,0.0);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=bsimbulk_d_hypsmooth(T1,1.0e-2,T1_Vsi_bi,0.0);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_hypsmooth(T1,1.0e-2,T1_Tempt_GND,0.0);
#endif
#endif
T1=bsimbulk_hypsmooth(T1,1.0e-2);
EXIT_IF_ISNAN(bsimbulk_hypsmooth(T1,1.0e-2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(-BGISL_t*T1_Vgi_bi/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_di+0.0*T1_Vgi_bi+BGISL_t*(+T1_Vgi_bi_Vgm_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vgi_bi*T1_Vgm_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vgm_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_si+0.0*T1_Vgi_bi+BGISL_t*(+T1_Vgi_bi_Vgm_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vgi_bi*T1_Vgm_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vdbulk_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+BGISL_t*(+T1_Vgi_bi_Vdbulk_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vgi_bi*T1_Vdbulk_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vsbulk_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+BGISL_t*(+T1_Vgi_bi_Vsbulk_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vgi_bi*T1_Vsbulk_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vgi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+BGISL_t*(+T1_Vgi_bi_Vgi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vgi_bi*T1_Vgi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vdi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+BGISL_t*(+T1_Vgi_bi_Vdi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vgi_bi*T1_Vdi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Vsi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+BGISL_t*(+T1_Vgi_bi_Vsi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vgi_bi*T1_Vsi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vgi_bi_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Vgi_bi+BGISL_t*(+T1_Vgi_bi_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vgi_bi*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vdi_bi=(-BGISL_t*T1_Vdi_bi/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_di+0.0*T1_Vdi_bi+BGISL_t*(+T1_Vdi_bi_Vgm_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_bi*T1_Vgm_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vgm_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_si+0.0*T1_Vdi_bi+BGISL_t*(+T1_Vdi_bi_Vgm_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_bi*T1_Vgm_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vdbulk_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+BGISL_t*(+T1_Vdi_bi_Vdbulk_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_bi*T1_Vdbulk_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vsbulk_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+BGISL_t*(+T1_Vdi_bi_Vsbulk_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_bi*T1_Vsbulk_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vgi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+BGISL_t*(+T1_Vdi_bi_Vgi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_bi*T1_Vgi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vdi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+BGISL_t*(+T1_Vdi_bi_Vdi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_bi*T1_Vdi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Vsi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+BGISL_t*(+T1_Vdi_bi_Vsi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_bi*T1_Vsi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_bi_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Vdi_bi+BGISL_t*(+T1_Vdi_bi_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_bi*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vsi_bi=(-BGISL_t*T1_Vsi_bi/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_di+0.0*T1_Vsi_bi+BGISL_t*(+T1_Vsi_bi_Vgm_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vsi_bi*T1_Vgm_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vgm_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vgm_si+0.0*T1_Vsi_bi+BGISL_t*(+T1_Vsi_bi_Vgm_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vsi_bi*T1_Vgm_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vdbulk_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+BGISL_t*(+T1_Vsi_bi_Vdbulk_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vsi_bi*T1_Vdbulk_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vsbulk_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+BGISL_t*(+T1_Vsi_bi_Vsbulk_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vsi_bi*T1_Vsbulk_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vgi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+BGISL_t*(+T1_Vsi_bi_Vgi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vsi_bi*T1_Vgi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vdi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+BGISL_t*(+T1_Vsi_bi_Vdi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vsi_bi*T1_Vdi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Vsi_bi=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+BGISL_t*(+T1_Vsi_bi_Vsi_bi+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vsi_bi*T1_Vsi_bi/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vsi_bi_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Vsi_bi+BGISL_t*(+T1_Vsi_bi_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vsi_bi*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((BGISL_t_Tempt_GND*(T1+1.0e-3)-BGISL_t*T1_Tempt_GND)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
#endif
T2=(BGISL_t/(T1+1.0e-3));
EXIT_IF_ISNAN((BGISL_t/(T1+1.0e-3)))
if
((CGISL_i!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=0.0;
  T3_Vdi_bi_Vgm_di=0.0;
  T3_Vdi_bi_Vdbulk_di=0.0;
  T3_Vdi_bi_Vsbulk_si=0.0;
  T3_Vdi_bi_Vgi_bi=0.0;
  T3_Vdi_bi_Vdi_bi=0.0;
  T3_Vdi_bi_Vsi_bi=0.0;
  T3_Vdi_bi_Tempt_GND=0.0;
#endif
T3_Vsi_bi=((((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi))*Vsb_noswap)+((Vsb_noswap*Vsb_noswap)*Vsb_noswap_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+0.0*Vsb_noswap+Vsb_noswap_Vsi_bi*0.0+0.0*Vsb_noswap_Vsi_bi+Vsb_noswap*0.0)*Vsb_noswap+((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi))*0.0+(0.0)*Vsb_noswap_Vsi_bi+(Vsb_noswap*Vsb_noswap)*0.0);
  T3_Vsi_bi_Vgm_di=(+(+0.0*Vsb_noswap+Vsb_noswap_Vsi_bi*0.0+0.0*Vsb_noswap_Vsi_bi+Vsb_noswap*0.0)*Vsb_noswap+((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi))*0.0+(0.0)*Vsb_noswap_Vsi_bi+(Vsb_noswap*Vsb_noswap)*0.0);
  T3_Vsi_bi_Vdbulk_di=(+(+0.0*Vsb_noswap+Vsb_noswap_Vsi_bi*0.0+0.0*Vsb_noswap_Vsi_bi+Vsb_noswap*0.0)*Vsb_noswap+((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi))*0.0+(0.0)*Vsb_noswap_Vsi_bi+(Vsb_noswap*Vsb_noswap)*0.0);
  T3_Vsi_bi_Vsbulk_si=(+(+0.0*Vsb_noswap+Vsb_noswap_Vsi_bi*0.0+0.0*Vsb_noswap_Vsi_bi+Vsb_noswap*0.0)*Vsb_noswap+((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi))*0.0+(0.0)*Vsb_noswap_Vsi_bi+(Vsb_noswap*Vsb_noswap)*0.0);
  T3_Vsi_bi_Vgi_bi=(+(+0.0*Vsb_noswap+Vsb_noswap_Vsi_bi*0.0+0.0*Vsb_noswap_Vsi_bi+Vsb_noswap*0.0)*Vsb_noswap+((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi))*0.0+(0.0)*Vsb_noswap_Vsi_bi+(Vsb_noswap*Vsb_noswap)*0.0);
  T3_Vsi_bi_Vdi_bi=(+(+0.0*Vsb_noswap+Vsb_noswap_Vsi_bi*0.0+0.0*Vsb_noswap_Vsi_bi+Vsb_noswap*0.0)*Vsb_noswap+((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi))*0.0+(0.0)*Vsb_noswap_Vsi_bi+(Vsb_noswap*Vsb_noswap)*0.0);
  T3_Vsi_bi_Vsi_bi=(+(+Vsb_noswap_Vsi_bi_Vsi_bi*Vsb_noswap+Vsb_noswap_Vsi_bi*Vsb_noswap_Vsi_bi+Vsb_noswap_Vsi_bi*Vsb_noswap_Vsi_bi+Vsb_noswap*Vsb_noswap_Vsi_bi_Vsi_bi)*Vsb_noswap+((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi))*Vsb_noswap_Vsi_bi+(((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi)))*Vsb_noswap_Vsi_bi+(Vsb_noswap*Vsb_noswap)*Vsb_noswap_Vsi_bi_Vsi_bi);
  T3_Vsi_bi_Tempt_GND=(+(+0.0*Vsb_noswap+Vsb_noswap_Vsi_bi*0.0+0.0*Vsb_noswap_Vsi_bi+Vsb_noswap*0.0)*Vsb_noswap+((Vsb_noswap_Vsi_bi*Vsb_noswap)+(Vsb_noswap*Vsb_noswap_Vsi_bi))*0.0+(0.0)*Vsb_noswap_Vsi_bi+(Vsb_noswap*Vsb_noswap)*0.0);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=0.0;
#endif
#endif
T3=((Vsb_noswap*Vsb_noswap)*Vsb_noswap);
EXIT_IF_ISNAN(((Vsb_noswap*Vsb_noswap)*Vsb_noswap))
{
double m00_fabs(d00_fabs0,T3)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,T3)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=T3_Vgi_bi*d10_fabs0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+0.0+(m20_fabs(T3)*T3_Vgm_si*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vgm_si))+0.0);
  T4_Vgi_bi_Vgm_di=(+(+0.0+(m20_fabs(T3)*T3_Vgm_di*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vgm_di))+0.0);
  T4_Vgi_bi_Vdbulk_di=(+(+0.0+(m20_fabs(T3)*T3_Vdbulk_di*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vdbulk_di))+0.0);
  T4_Vgi_bi_Vsbulk_si=(+(+0.0+(m20_fabs(T3)*T3_Vsbulk_si*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vsbulk_si))+0.0);
  T4_Vgi_bi_Vgi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vgi_bi*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vgi_bi))+0.0);
  T4_Vgi_bi_Vdi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vdi_bi*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vdi_bi))+0.0);
  T4_Vgi_bi_Vsi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vsi_bi*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Vsi_bi))+0.0);
  T4_Vgi_bi_Tempt_GND=(+(+0.0+(m20_fabs(T3)*T3_Tempt_GND*T3_Vgi_bi+d10_fabs0*T3_Vgi_bi_Tempt_GND))+0.0);
#endif
T4_Vdi_bi=T3_Vdi_bi*d10_fabs0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+0.0+(m20_fabs(T3)*T3_Vgm_si*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vgm_si))+0.0);
  T4_Vdi_bi_Vgm_di=(+(+0.0+(m20_fabs(T3)*T3_Vgm_di*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vgm_di))+0.0);
  T4_Vdi_bi_Vdbulk_di=(+(+0.0+(m20_fabs(T3)*T3_Vdbulk_di*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vdbulk_di))+0.0);
  T4_Vdi_bi_Vsbulk_si=(+(+0.0+(m20_fabs(T3)*T3_Vsbulk_si*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vsbulk_si))+0.0);
  T4_Vdi_bi_Vgi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vgi_bi*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vgi_bi))+0.0);
  T4_Vdi_bi_Vdi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vdi_bi*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vdi_bi))+0.0);
  T4_Vdi_bi_Vsi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vsi_bi*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Vsi_bi))+0.0);
  T4_Vdi_bi_Tempt_GND=(+(+0.0+(m20_fabs(T3)*T3_Tempt_GND*T3_Vdi_bi+d10_fabs0*T3_Vdi_bi_Tempt_GND))+0.0);
#endif
T4_Vsi_bi=T3_Vsi_bi*d10_fabs0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+0.0+(m20_fabs(T3)*T3_Vgm_si*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vgm_si))+0.0);
  T4_Vsi_bi_Vgm_di=(+(+0.0+(m20_fabs(T3)*T3_Vgm_di*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vgm_di))+0.0);
  T4_Vsi_bi_Vdbulk_di=(+(+0.0+(m20_fabs(T3)*T3_Vdbulk_di*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vdbulk_di))+0.0);
  T4_Vsi_bi_Vsbulk_si=(+(+0.0+(m20_fabs(T3)*T3_Vsbulk_si*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vsbulk_si))+0.0);
  T4_Vsi_bi_Vgi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vgi_bi*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vgi_bi))+0.0);
  T4_Vsi_bi_Vdi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vdi_bi*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vdi_bi))+0.0);
  T4_Vsi_bi_Vsi_bi=(+(+0.0+(m20_fabs(T3)*T3_Vsi_bi*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Vsi_bi))+0.0);
  T4_Vsi_bi_Tempt_GND=(+(+0.0+(m20_fabs(T3)*T3_Tempt_GND*T3_Vsi_bi+d10_fabs0*T3_Vsi_bi_Tempt_GND))+0.0);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=T3_Tempt_GND*d10_fabs0;
#endif
#endif
T4=((CGISL_i+d00_fabs0)+1.0e-4);
EXIT_IF_ISNAN(((CGISL_i+d00_fabs0)+1.0e-4))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=bsimbulk_d_hypsmooth((T3/T4),1.0e-6,((T3_Vgi_bi*T4-T3*T4_Vgi_bi)/T4/T4),0.0);
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+0.0-0.0);
  T5_Vgi_bi_Vgm_di=(+0.0-0.0);
  T5_Vgi_bi_Vdbulk_di=(+0.0-0.0);
  T5_Vgi_bi_Vsbulk_si=(+0.0-0.0);
  T5_Vgi_bi_Vgi_bi=(+0.0-0.0);
  T5_Vgi_bi_Vdi_bi=(+0.0-0.0);
  T5_Vgi_bi_Vsi_bi=(+0.0-0.0);
  T5_Vgi_bi_Tempt_GND=(+0.0-0.0);
#endif
T5_Vdi_bi=bsimbulk_d_hypsmooth((T3/T4),1.0e-6,((T3_Vdi_bi*T4-T3*T4_Vdi_bi)/T4/T4),0.0);
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+0.0-0.0);
  T5_Vdi_bi_Vgm_di=(+0.0-0.0);
  T5_Vdi_bi_Vdbulk_di=(+0.0-0.0);
  T5_Vdi_bi_Vsbulk_si=(+0.0-0.0);
  T5_Vdi_bi_Vgi_bi=(+0.0-0.0);
  T5_Vdi_bi_Vdi_bi=(+0.0-0.0);
  T5_Vdi_bi_Vsi_bi=(+0.0-0.0);
  T5_Vdi_bi_Tempt_GND=(+0.0-0.0);
#endif
T5_Vsi_bi=bsimbulk_d_hypsmooth((T3/T4),1.0e-6,((T3_Vsi_bi*T4-T3*T4_Vsi_bi)/T4/T4),0.0);
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+0.0-0.0);
  T5_Vsi_bi_Vgm_di=(+0.0-0.0);
  T5_Vsi_bi_Vdbulk_di=(+0.0-0.0);
  T5_Vsi_bi_Vsbulk_si=(+0.0-0.0);
  T5_Vsi_bi_Vgi_bi=(+0.0-0.0);
  T5_Vsi_bi_Vdi_bi=(+0.0-0.0);
  T5_Vsi_bi_Vsi_bi=(+0.0-0.0);
  T5_Vsi_bi_Tempt_GND=(+0.0-0.0);
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=bsimbulk_d_hypsmooth((T3/T4),1.0e-6,((T3_Tempt_GND*T4-T3*T4_Tempt_GND)/T4/T4),0.0);
#endif
#endif
T5=(bsimbulk_hypsmooth((T3/T4),1.0e-6)-1.0e-6);
EXIT_IF_ISNAN((bsimbulk_hypsmooth((T3/T4),1.0e-6)-1.0e-6))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=1.0;
EXIT_IF_ISNAN(1.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=((((((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5)+((((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(AGISL_i*Weff)*T1_Vgi_bi_Vgm_di)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_di)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vgm_di+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_di)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(AGISL_i*Weff)*T1_Vgi_bi_Vgm_si)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_si)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vgm_si+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_si)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(AGISL_i*Weff)*T1_Vgi_bi_Vdbulk_di)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vdbulk_di+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(AGISL_i*Weff)*T1_Vgi_bi_Vsbulk_si)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vsbulk_si+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(AGISL_i*Weff)*T1_Vgi_bi_Vgi_bi)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vgi_bi+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgi_bi)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(AGISL_i*Weff)*T1_Vgi_bi_Vdi_bi)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vdi_bi+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdi_bi)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(AGISL_i*Weff)*T1_Vgi_bi_Vsi_bi)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Vsi_bi+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsi_bi)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(AGISL_i*Weff)*T1_Vgi_bi_Tempt_GND)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Tempt_GND)))*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vgi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi))))*T5_Tempt_GND+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Tempt_GND)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vgi_bi)))))*T5_Vgi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=((((((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5)+((((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(AGISL_i*Weff)*T1_Vdi_bi_Vgm_di)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_di)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vgm_di+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_di)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(AGISL_i*Weff)*T1_Vdi_bi_Vgm_si)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_si)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vgm_si+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_si)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(AGISL_i*Weff)*T1_Vdi_bi_Vdbulk_di)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vdbulk_di+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(AGISL_i*Weff)*T1_Vdi_bi_Vsbulk_si)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vsbulk_si+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(AGISL_i*Weff)*T1_Vdi_bi_Vgi_bi)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vgi_bi+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgi_bi)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(AGISL_i*Weff)*T1_Vdi_bi_Vdi_bi)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vdi_bi+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdi_bi)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(AGISL_i*Weff)*T1_Vdi_bi_Vsi_bi)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Vsi_bi+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsi_bi)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(AGISL_i*Weff)*T1_Vdi_bi_Tempt_GND)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Tempt_GND)))*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vdi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi))))*T5_Tempt_GND+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Tempt_GND)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vdi_bi)))))*T5_Vdi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((((((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5)+((((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(AGISL_i*Weff)*T1_Vsi_bi_Vgm_di)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_di)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vgm_di+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_di)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(AGISL_i*Weff)*T1_Vsi_bi_Vgm_si)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_si)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vgm_si+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgm_si)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(AGISL_i*Weff)*T1_Vsi_bi_Vdbulk_di)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vdbulk_di+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdbulk_di)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(AGISL_i*Weff)*T1_Vsi_bi_Vsbulk_si)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vsbulk_si+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsbulk_si)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(AGISL_i*Weff)*T1_Vsi_bi_Vgi_bi)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vgi_bi+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vgi_bi)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(AGISL_i*Weff)*T1_Vsi_bi_Vdi_bi)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vdi_bi+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vdi_bi)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(AGISL_i*Weff)*T1_Vsi_bi_Vsi_bi)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsi_bi)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Vsi_bi+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Vsi_bi)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(AGISL_i*Weff)*T1_Vsi_bi_Tempt_GND)*bsimbulk_lexp((-T2))+((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((((0.0)*T1)+((AGISL_i*Weff)*T1_Tempt_GND)))*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))+((AGISL_i*Weff)*T1)*0.0)*T5+((((AGISL_i*Weff)*T1_Vsi_bi)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi))))*T5_Tempt_GND+(((((((0.0)*T1)+((AGISL_i*Weff)*T1_Tempt_GND)))*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Vsi_bi)))))*T5_Vsi_bi+(((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((((((AGISL_i*Weff)*T1_Tempt_GND)*bsimbulk_lexp((-T2)))+(((AGISL_i*Weff)*T1)*bsimbulk_d_lexp((-T2),(-T2_Tempt_GND))))*T5)+((((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5_Tempt_GND));
#endif
#endif
T6=((((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5);
EXIT_IF_ISNAN(((((AGISL_i*Weff)*T1)*bsimbulk_lexp((-T2)))*T5))
}
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
igisl_Vgi_bi=T6_Vgi_bi;
igisl_Vdi_bi=T6_Vdi_bi;
igisl_Vsi_bi=T6_Vsi_bi;
igisl_Tempt_GND=T6_Tempt_GND;
#endif
igisl=T6;
EXIT_IF_ISNAN(T6)
}
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
IGIDL_Vgi_bi=((devsign*pInst->NF)*igidl_Vgi_bi);
IGIDL_Vdi_bi=((devsign*pInst->NF)*igidl_Vdi_bi);
IGIDL_Vsi_bi=((devsign*pInst->NF)*igidl_Vsi_bi);
IGIDL_Tempt_GND=((devsign*pInst->NF)*igidl_Tempt_GND);
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL]=((devsign*pInst->NF)*igidl);
EXIT_IF_ISNAN(((devsign*pInst->NF)*igidl))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
IGISL_Vgi_bi=((devsign*pInst->NF)*igisl_Vgi_bi);
IGISL_Vdi_bi=((devsign*pInst->NF)*igisl_Vdi_bi);
IGISL_Vsi_bi=((devsign*pInst->NF)*igisl_Vsi_bi);
IGISL_Tempt_GND=((devsign*pInst->NF)*igisl_Tempt_GND);
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL]=((devsign*pInst->NF)*igisl);
EXIT_IF_ISNAN(((devsign*pInst->NF)*igisl))
if
((Isbs>0.0))
{
if
((Vbs_jct<VjsmRev))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=(Vbs_jct_Vsbulk_si/Nvtms);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vgm_si=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vdbulk_di=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vsbulk_si=(Vbs_jct_Vsbulk_si_Vsbulk_si/Nvtms-(Vbs_jct_Vsbulk_si*0.0+Vbs_jct_Vsbulk_si*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vgi_bi=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vdi_bi=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vsi_bi=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Tempt_GND=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*Nvtms_Tempt_GND+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-Vbs_jct*Nvtms_Tempt_GND/Nvtms/Nvtms);
#endif
#endif
T0=(Vbs_jct/Nvtms);
EXIT_IF_ISNAN((Vbs_jct/Nvtms))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=bsimbulk_d_lexp(T0,T0_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+T0_Vsbulk_si_Vgm_di-0.0);
  T1_Vsbulk_si_Vgm_si=(+T0_Vsbulk_si_Vgm_si-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+T0_Vsbulk_si_Vdbulk_di-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+T0_Vsbulk_si_Vsbulk_si-0.0);
  T1_Vsbulk_si_Vgi_bi=(+T0_Vsbulk_si_Vgi_bi-0.0);
  T1_Vsbulk_si_Vdi_bi=(+T0_Vsbulk_si_Vdi_bi-0.0);
  T1_Vsbulk_si_Vsi_bi=(+T0_Vsbulk_si_Vsi_bi-0.0);
  T1_Vsbulk_si_Tempt_GND=(+T0_Vsbulk_si_Tempt_GND-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp(T0,T0_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+T0_Vgi_bi_Vgm_di-0.0);
  T1_Vgi_bi_Vgm_si=(+T0_Vgi_bi_Vgm_si-0.0);
  T1_Vgi_bi_Vdbulk_di=(+T0_Vgi_bi_Vdbulk_di-0.0);
  T1_Vgi_bi_Vsbulk_si=(+T0_Vgi_bi_Vsbulk_si-0.0);
  T1_Vgi_bi_Vgi_bi=(+T0_Vgi_bi_Vgi_bi-0.0);
  T1_Vgi_bi_Vdi_bi=(+T0_Vgi_bi_Vdi_bi-0.0);
  T1_Vgi_bi_Vsi_bi=(+T0_Vgi_bi_Vsi_bi-0.0);
  T1_Vgi_bi_Tempt_GND=(+T0_Vgi_bi_Tempt_GND-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp(T0,T0_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+T0_Vdi_bi_Vgm_di-0.0);
  T1_Vdi_bi_Vgm_si=(+T0_Vdi_bi_Vgm_si-0.0);
  T1_Vdi_bi_Vdbulk_di=(+T0_Vdi_bi_Vdbulk_di-0.0);
  T1_Vdi_bi_Vsbulk_si=(+T0_Vdi_bi_Vsbulk_si-0.0);
  T1_Vdi_bi_Vgi_bi=(+T0_Vdi_bi_Vgi_bi-0.0);
  T1_Vdi_bi_Vdi_bi=(+T0_Vdi_bi_Vdi_bi-0.0);
  T1_Vdi_bi_Vsi_bi=(+T0_Vdi_bi_Vsi_bi-0.0);
  T1_Vdi_bi_Tempt_GND=(+T0_Vdi_bi_Tempt_GND-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp(T0,T0_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+T0_Vsi_bi_Vgm_di-0.0);
  T1_Vsi_bi_Vgm_si=(+T0_Vsi_bi_Vgm_si-0.0);
  T1_Vsi_bi_Vdbulk_di=(+T0_Vsi_bi_Vdbulk_di-0.0);
  T1_Vsi_bi_Vsbulk_si=(+T0_Vsi_bi_Vsbulk_si-0.0);
  T1_Vsi_bi_Vgi_bi=(+T0_Vsi_bi_Vgi_bi-0.0);
  T1_Vsi_bi_Vdi_bi=(+T0_Vsi_bi_Vdi_bi-0.0);
  T1_Vsi_bi_Vsi_bi=(+T0_Vsi_bi_Vsi_bi-0.0);
  T1_Vsi_bi_Tempt_GND=(+T0_Vsi_bi_Tempt_GND-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp(T0,T0_Tempt_GND);
#endif
#endif
T1=(bsimbulk_lexp(T0)-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp(T0)-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=(SslpRev*Vbs_jct_Vsbulk_si);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+0.0+(+0.0*(Vbs_jct-VjsmRev)+0.0*0.0+0.0*Vbs_jct_Vsbulk_si+SslpRev*(+0.0-0.0)));
  T2_Vsbulk_si_Vgm_si=(+0.0+(+0.0*(Vbs_jct-VjsmRev)+0.0*0.0+0.0*Vbs_jct_Vsbulk_si+SslpRev*(+0.0-0.0)));
  T2_Vsbulk_si_Vdbulk_di=(+0.0+(+0.0*(Vbs_jct-VjsmRev)+0.0*0.0+0.0*Vbs_jct_Vsbulk_si+SslpRev*(+0.0-0.0)));
  T2_Vsbulk_si_Vsbulk_si=(+0.0+(+0.0*(Vbs_jct-VjsmRev)+0.0*Vbs_jct_Vsbulk_si+0.0*Vbs_jct_Vsbulk_si+SslpRev*(+Vbs_jct_Vsbulk_si_Vsbulk_si-0.0)));
  T2_Vsbulk_si_Vgi_bi=(+0.0+(+0.0*(Vbs_jct-VjsmRev)+0.0*0.0+0.0*Vbs_jct_Vsbulk_si+SslpRev*(+0.0-0.0)));
  T2_Vsbulk_si_Vdi_bi=(+0.0+(+0.0*(Vbs_jct-VjsmRev)+0.0*0.0+0.0*Vbs_jct_Vsbulk_si+SslpRev*(+0.0-0.0)));
  T2_Vsbulk_si_Vsi_bi=(+0.0+(+0.0*(Vbs_jct-VjsmRev)+0.0*0.0+0.0*Vbs_jct_Vsbulk_si+SslpRev*(+0.0-0.0)));
  T2_Vsbulk_si_Tempt_GND=(+0.0+(+0.0*(Vbs_jct-VjsmRev)+0.0*(-VjsmRev_Tempt_GND)+SslpRev_Tempt_GND*Vbs_jct_Vsbulk_si+SslpRev*(+0.0-0.0)));
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(IVjsmRev_Tempt_GND+((SslpRev_Tempt_GND*(Vbs_jct-VjsmRev))+(SslpRev*(-VjsmRev_Tempt_GND))));
#endif
#endif
T2=(IVjsmRev+(SslpRev*(Vbs_jct-VjsmRev)));
EXIT_IF_ISNAN((IVjsmRev+(SslpRev*(Vbs_jct-VjsmRev))))
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si));
Ibs_Vgi_bi=((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi));
Ibs_Vdi_bi=((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi));
Ibs_Vsi_bi=((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi));
Ibs_Tempt_GND=((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND));
#endif
Ibs=(T1*T2);
EXIT_IF_ISNAN((T1*T2))
}
else
{
if
((Vbs_jct<=VjsmFwd))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=(Vbs_jct_Vsbulk_si/Nvtms);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vgm_si=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vdbulk_di=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vsbulk_si=(Vbs_jct_Vsbulk_si_Vsbulk_si/Nvtms-(Vbs_jct_Vsbulk_si*0.0+Vbs_jct_Vsbulk_si*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vgi_bi=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vdi_bi=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Vsi_bi=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Vsbulk_si_Tempt_GND=(0.0/Nvtms-(Vbs_jct_Vsbulk_si*Nvtms_Tempt_GND+0.0*0.0+Vbs_jct*0.0)/Nvtms/Nvtms+2*Vbs_jct*0.0*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-Vbs_jct*Nvtms_Tempt_GND/Nvtms/Nvtms);
#endif
#endif
T0=(Vbs_jct/Nvtms);
EXIT_IF_ISNAN((Vbs_jct/Nvtms))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=(Vbs_jct_Vsbulk_si/Nvtms);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=((+0.0+0.0)/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+(pModel->BVS+Vbs_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+Vbs_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Vsbulk_si_Vgm_si=((+0.0+0.0)/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+(pModel->BVS+Vbs_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+Vbs_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Vsbulk_si_Vdbulk_di=((+0.0+0.0)/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+(pModel->BVS+Vbs_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+Vbs_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Vsbulk_si_Vsbulk_si=((+0.0+Vbs_jct_Vsbulk_si_Vsbulk_si)/Nvtms-(Vbs_jct_Vsbulk_si*0.0+Vbs_jct_Vsbulk_si*0.0+(pModel->BVS+Vbs_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+Vbs_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Vsbulk_si_Vgi_bi=((+0.0+0.0)/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+(pModel->BVS+Vbs_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+Vbs_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Vsbulk_si_Vdi_bi=((+0.0+0.0)/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+(pModel->BVS+Vbs_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+Vbs_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Vsbulk_si_Vsi_bi=((+0.0+0.0)/Nvtms-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+(pModel->BVS+Vbs_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+Vbs_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Vsbulk_si_Tempt_GND=((+0.0+0.0)/Nvtms-(Vbs_jct_Vsbulk_si*Nvtms_Tempt_GND+0.0*0.0+(pModel->BVS+Vbs_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+Vbs_jct)*0.0*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-(pModel->BVS+Vbs_jct)*Nvtms_Tempt_GND/Nvtms/Nvtms);
#endif
#endif
T1=((pModel->BVS+Vbs_jct)/Nvtms);
EXIT_IF_ISNAN(((pModel->BVS+Vbs_jct)/Nvtms))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=bsimbulk_d_lexp((-T1),(-T1_Vsbulk_si));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=bsimbulk_d_lexp((-T1),(-T1_Vgi_bi));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=bsimbulk_d_lexp((-T1),(-T1_Vdi_bi));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=bsimbulk_d_lexp((-T1),(-T1_Vsi_bi));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=bsimbulk_d_lexp((-T1),(-T1_Tempt_GND));
#endif
#endif
T2=bsimbulk_lexp((-T1));
EXIT_IF_ISNAN(bsimbulk_lexp((-T1)))
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=(Isbs*(bsimbulk_d_lexp(T0,T0_Vsbulk_si)-(pModel->XJBVS*T2_Vsbulk_si)));
Ibs_Vgi_bi=(Isbs*(bsimbulk_d_lexp(T0,T0_Vgi_bi)-(pModel->XJBVS*T2_Vgi_bi)));
Ibs_Vdi_bi=(Isbs*(bsimbulk_d_lexp(T0,T0_Vdi_bi)-(pModel->XJBVS*T2_Vdi_bi)));
Ibs_Vsi_bi=(Isbs*(bsimbulk_d_lexp(T0,T0_Vsi_bi)-(pModel->XJBVS*T2_Vsi_bi)));
Ibs_Tempt_GND=((Isbs_Tempt_GND*(((bsimbulk_lexp(T0)+XExpBVS)-1.0)-(pModel->XJBVS*T2)))+(Isbs*((bsimbulk_d_lexp(T0,T0_Tempt_GND)+XExpBVS_Tempt_GND)-(pModel->XJBVS*T2_Tempt_GND))));
#endif
Ibs=(Isbs*(((bsimbulk_lexp(T0)+XExpBVS)-1.0)-(pModel->XJBVS*T2)));
EXIT_IF_ISNAN((Isbs*(((bsimbulk_lexp(T0)+XExpBVS)-1.0)-(pModel->XJBVS*T2))))
}
else
{
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=(SslpFwd*Vbs_jct_Vsbulk_si);
Ibs_Vgi_bi=0.0;
Ibs_Vdi_bi=0.0;
Ibs_Vsi_bi=0.0;
Ibs_Tempt_GND=(IVjsmFwd_Tempt_GND+((SslpFwd_Tempt_GND*(Vbs_jct-VjsmFwd))+(SslpFwd*(-VjsmFwd_Tempt_GND))));
#endif
Ibs=(IVjsmFwd+(SslpFwd*(Vbs_jct-VjsmFwd)));
EXIT_IF_ISNAN((IVjsmFwd+(SslpFwd*(Vbs_jct-VjsmFwd))))
}
}
}
else
{
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=0.0;
Ibs_Vgi_bi=0.0;
Ibs_Vdi_bi=0.0;
Ibs_Vsi_bi=0.0;
Ibs_Tempt_GND=0.0;
#endif
Ibs=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((JTSS_t>0.0))
{
if
(((pModel->VTSS-Vbs_jct)<(pModel->VTSS*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=(((-Vbs_jct_Vsbulk_si)/Vtm0)/NJTS_t);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vgm_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vdbulk_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vsbulk_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vgi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vdi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vsi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Tempt_GND=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*NJTS_t_Tempt_GND+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*NJTS_t_Tempt_GND/NJTS_t/NJTS_t/NJTS_t);
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbs_jct)/Vtm0)*NJTS_t_Tempt_GND/NJTS_t/NJTS_t);
#endif
#endif
T0=(((-Vbs_jct)/Vtm0)/NJTS_t);
EXIT_IF_ISNAN((((-Vbs_jct)/Vtm0)/NJTS_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=bsimbulk_d_lexp((T0*1.0e3),T0_Vsbulk_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+T0_Vsbulk_si_Vgm_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgm_si=(+(+T0_Vsbulk_si_Vgm_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+(+T0_Vsbulk_si_Vdbulk_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+(+T0_Vsbulk_si_Vsbulk_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgi_bi=(+(+T0_Vsbulk_si_Vgi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdi_bi=(+(+T0_Vsbulk_si_Vdi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsi_bi=(+(+T0_Vsbulk_si_Vsi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Tempt_GND=(+(+T0_Vsbulk_si_Tempt_GND*1.0e3+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vgi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*1.0e3+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*1.0e3+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*1.0e3+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vdi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*1.0e3+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*1.0e3+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*1.0e3+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vsi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*1.0e3+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*1.0e3+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*1.0e3+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#endif
#endif
T1=(bsimbulk_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=(Ibs_Vsbulk_si-((ASeff*JTSS_t)*T1_Vsbulk_si));
Ibs_Vgi_bi=(Ibs_Vgi_bi-((ASeff*JTSS_t)*T1_Vgi_bi));
Ibs_Vdi_bi=(Ibs_Vdi_bi-((ASeff*JTSS_t)*T1_Vdi_bi));
Ibs_Vsi_bi=(Ibs_Vsi_bi-((ASeff*JTSS_t)*T1_Vsi_bi));
Ibs_Tempt_GND=(Ibs_Tempt_GND-((((ASeff_Tempt_GND*JTSS_t)+(ASeff*JTSS_t_Tempt_GND))*T1)+((ASeff*JTSS_t)*T1_Tempt_GND)));
#endif
Ibs=(Ibs-((ASeff*JTSS_t)*T1));
EXIT_IF_ISNAN((Ibs-((ASeff*JTSS_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=(((-Vbs_jct_Vsbulk_si)/Vtm0)/NJTS_t);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vgm_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vdbulk_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vsbulk_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vgi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vdi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Vsi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Vsbulk_si_Tempt_GND=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*NJTS_t_Tempt_GND+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-Vbs_jct)/Vtm0)*0.0*NJTS_t_Tempt_GND/NJTS_t/NJTS_t/NJTS_t);
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbs_jct)/Vtm0)*NJTS_t_Tempt_GND/NJTS_t/NJTS_t);
#endif
#endif
T0=(((-Vbs_jct)/Vtm0)/NJTS_t);
EXIT_IF_ISNAN((((-Vbs_jct)/Vtm0)/NJTS_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=bsimbulk_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-Vbs_jct)),((T0_Vsbulk_si*pModel->VTSS*(pModel->VTSS-Vbs_jct)-(T0*pModel->VTSS)*(-Vbs_jct_Vsbulk_si))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di*pModel->VTSS+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSS*0.0+(T0_Vgm_di*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si*pModel->VTSS+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSS*0.0+(T0_Vgm_si*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di*pModel->VTSS+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSS*0.0+(T0_Vdbulk_di*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si*pModel->VTSS+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSS)*(+0.0-Vbs_jct_Vsbulk_si_Vsbulk_si))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)*(-Vbs_jct_Vsbulk_si)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi*pModel->VTSS+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSS*0.0+(T0_Vgi_bi*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi*pModel->VTSS+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSS*0.0+(T0_Vdi_bi*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi*pModel->VTSS+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSS*0.0+(T0_Vsi_bi*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND*pModel->VTSS+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-Vbs_jct)),(T0_Vgi_bi*pModel->VTSS/(pModel->VTSS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di*pModel->VTSS+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSS*0.0+(T0_Vgm_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si*pModel->VTSS+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSS*0.0+(T0_Vgm_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di*pModel->VTSS+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSS*0.0+(T0_Vdbulk_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si*pModel->VTSS+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*(-Vbs_jct_Vsbulk_si)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi*pModel->VTSS+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSS*0.0+(T0_Vgi_bi*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi*pModel->VTSS+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSS*0.0+(T0_Vdi_bi*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi*pModel->VTSS+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSS*0.0+(T0_Vsi_bi*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND*pModel->VTSS+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-Vbs_jct)),(T0_Vdi_bi*pModel->VTSS/(pModel->VTSS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di*pModel->VTSS+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSS*0.0+(T0_Vgm_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si*pModel->VTSS+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSS*0.0+(T0_Vgm_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di*pModel->VTSS+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSS*0.0+(T0_Vdbulk_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si*pModel->VTSS+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*(-Vbs_jct_Vsbulk_si)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi*pModel->VTSS+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSS*0.0+(T0_Vgi_bi*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi*pModel->VTSS+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSS*0.0+(T0_Vdi_bi*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi*pModel->VTSS+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSS*0.0+(T0_Vsi_bi*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND*pModel->VTSS+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-Vbs_jct)),(T0_Vsi_bi*pModel->VTSS/(pModel->VTSS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di*pModel->VTSS+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSS*0.0+(T0_Vgm_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si*pModel->VTSS+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSS*0.0+(T0_Vgm_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di*pModel->VTSS+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSS*0.0+(T0_Vdbulk_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si*pModel->VTSS+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*(-Vbs_jct_Vsbulk_si)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi*pModel->VTSS+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSS*0.0+(T0_Vgi_bi*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi*pModel->VTSS+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSS*0.0+(T0_Vdi_bi*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi*pModel->VTSS+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSS*0.0+(T0_Vsi_bi*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
  T1_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND*pModel->VTSS+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct)/(pModel->VTSS-Vbs_jct))-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-Vbs_jct)),(T0_Tempt_GND*pModel->VTSS/(pModel->VTSS-Vbs_jct)));
#endif
#endif
T1=(bsimbulk_lexp(((T0*pModel->VTSS)/(pModel->VTSS-Vbs_jct)))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp(((T0*pModel->VTSS)/(pModel->VTSS-Vbs_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=(Ibs_Vsbulk_si-((ASeff*JTSS_t)*T1_Vsbulk_si));
Ibs_Vgi_bi=(Ibs_Vgi_bi-((ASeff*JTSS_t)*T1_Vgi_bi));
Ibs_Vdi_bi=(Ibs_Vdi_bi-((ASeff*JTSS_t)*T1_Vdi_bi));
Ibs_Vsi_bi=(Ibs_Vsi_bi-((ASeff*JTSS_t)*T1_Vsi_bi));
Ibs_Tempt_GND=(Ibs_Tempt_GND-((((ASeff_Tempt_GND*JTSS_t)+(ASeff*JTSS_t_Tempt_GND))*T1)+((ASeff*JTSS_t)*T1_Tempt_GND)));
#endif
Ibs=(Ibs-((ASeff*JTSS_t)*T1));
EXIT_IF_ISNAN((Ibs-((ASeff*JTSS_t)*T1)))
}
}
if
((JTSSWS_t>0.0))
{
if
(((pModel->VTSSWS-Vbs_jct)<(pModel->VTSSWS*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=(((-Vbs_jct_Vsbulk_si)/Vtm0)/NJTSSW_t);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vgm_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vdbulk_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vsbulk_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vgi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vdi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vsi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Tempt_GND=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*NJTSSW_t_Tempt_GND+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t/NJTSSW_t);
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbs_jct)/Vtm0)*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t);
#endif
#endif
T0=(((-Vbs_jct)/Vtm0)/NJTSSW_t);
EXIT_IF_ISNAN((((-Vbs_jct)/Vtm0)/NJTSSW_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=bsimbulk_d_lexp((T0*1.0e3),T0_Vsbulk_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+T0_Vsbulk_si_Vgm_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgm_si=(+(+T0_Vsbulk_si_Vgm_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+(+T0_Vsbulk_si_Vdbulk_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+(+T0_Vsbulk_si_Vsbulk_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgi_bi=(+(+T0_Vsbulk_si_Vgi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdi_bi=(+(+T0_Vsbulk_si_Vdi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsi_bi=(+(+T0_Vsbulk_si_Vsi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Tempt_GND=(+(+T0_Vsbulk_si_Tempt_GND*1.0e3+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vgi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*1.0e3+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*1.0e3+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*1.0e3+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vdi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*1.0e3+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*1.0e3+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*1.0e3+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vsi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*1.0e3+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*1.0e3+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*1.0e3+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#endif
#endif
T1=(bsimbulk_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=(Ibs_Vsbulk_si-((PSeff*JTSSWS_t)*T1_Vsbulk_si));
Ibs_Vgi_bi=(Ibs_Vgi_bi-((PSeff*JTSSWS_t)*T1_Vgi_bi));
Ibs_Vdi_bi=(Ibs_Vdi_bi-((PSeff*JTSSWS_t)*T1_Vdi_bi));
Ibs_Vsi_bi=(Ibs_Vsi_bi-((PSeff*JTSSWS_t)*T1_Vsi_bi));
Ibs_Tempt_GND=(Ibs_Tempt_GND-((((PSeff_Tempt_GND*JTSSWS_t)+(PSeff*JTSSWS_t_Tempt_GND))*T1)+((PSeff*JTSSWS_t)*T1_Tempt_GND)));
#endif
Ibs=(Ibs-((PSeff*JTSSWS_t)*T1));
EXIT_IF_ISNAN((Ibs-((PSeff*JTSSWS_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=(((-Vbs_jct_Vsbulk_si)/Vtm0)/NJTSSW_t);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vgm_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vdbulk_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vsbulk_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vgi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vdi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Vsi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Vsbulk_si_Tempt_GND=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*NJTSSW_t_Tempt_GND+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-Vbs_jct)/Vtm0)*0.0*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t/NJTSSW_t);
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbs_jct)/Vtm0)*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t);
#endif
#endif
T0=(((-Vbs_jct)/Vtm0)/NJTSSW_t);
EXIT_IF_ISNAN((((-Vbs_jct)/Vtm0)/NJTSSW_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=bsimbulk_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-Vbs_jct)),((T0_Vsbulk_si*pModel->VTSSWS*(pModel->VTSSWS-Vbs_jct)-(T0*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di*pModel->VTSSWS+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWS*0.0+(T0_Vgm_di*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si*pModel->VTSSWS+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWS*0.0+(T0_Vgm_si*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di*pModel->VTSSWS+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWS*0.0+(T0_Vdbulk_di*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si*pModel->VTSSWS+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWS)*(+0.0-Vbs_jct_Vsbulk_si_Vsbulk_si))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)*(-Vbs_jct_Vsbulk_si)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi*pModel->VTSSWS+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWS*0.0+(T0_Vgi_bi*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi*pModel->VTSSWS+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWS*0.0+(T0_Vdi_bi*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi*pModel->VTSSWS+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWS*0.0+(T0_Vsi_bi*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND*pModel->VTSSWS+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-Vbs_jct)),(T0_Vgi_bi*pModel->VTSSWS/(pModel->VTSSWS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di*pModel->VTSSWS+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWS*0.0+(T0_Vgm_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si*pModel->VTSSWS+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWS*0.0+(T0_Vgm_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di*pModel->VTSSWS+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWS*0.0+(T0_Vdbulk_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si*pModel->VTSSWS+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*(-Vbs_jct_Vsbulk_si)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi*pModel->VTSSWS+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWS*0.0+(T0_Vgi_bi*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi*pModel->VTSSWS+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWS*0.0+(T0_Vdi_bi*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi*pModel->VTSSWS+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWS*0.0+(T0_Vsi_bi*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND*pModel->VTSSWS+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-Vbs_jct)),(T0_Vdi_bi*pModel->VTSSWS/(pModel->VTSSWS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di*pModel->VTSSWS+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWS*0.0+(T0_Vgm_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si*pModel->VTSSWS+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWS*0.0+(T0_Vgm_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di*pModel->VTSSWS+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWS*0.0+(T0_Vdbulk_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si*pModel->VTSSWS+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*(-Vbs_jct_Vsbulk_si)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi*pModel->VTSSWS+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWS*0.0+(T0_Vgi_bi*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi*pModel->VTSSWS+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWS*0.0+(T0_Vdi_bi*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi*pModel->VTSSWS+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWS*0.0+(T0_Vsi_bi*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND*pModel->VTSSWS+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-Vbs_jct)),(T0_Vsi_bi*pModel->VTSSWS/(pModel->VTSSWS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di*pModel->VTSSWS+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWS*0.0+(T0_Vgm_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si*pModel->VTSSWS+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWS*0.0+(T0_Vgm_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di*pModel->VTSSWS+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWS*0.0+(T0_Vdbulk_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si*pModel->VTSSWS+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*(-Vbs_jct_Vsbulk_si)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi*pModel->VTSSWS+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWS*0.0+(T0_Vgi_bi*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi*pModel->VTSSWS+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWS*0.0+(T0_Vdi_bi*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi*pModel->VTSSWS+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWS*0.0+(T0_Vsi_bi*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
  T1_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND*pModel->VTSSWS+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct)/(pModel->VTSSWS-Vbs_jct))-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-Vbs_jct)),(T0_Tempt_GND*pModel->VTSSWS/(pModel->VTSSWS-Vbs_jct)));
#endif
#endif
T1=(bsimbulk_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-Vbs_jct)))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-Vbs_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=(Ibs_Vsbulk_si-((PSeff*JTSSWS_t)*T1_Vsbulk_si));
Ibs_Vgi_bi=(Ibs_Vgi_bi-((PSeff*JTSSWS_t)*T1_Vgi_bi));
Ibs_Vdi_bi=(Ibs_Vdi_bi-((PSeff*JTSSWS_t)*T1_Vdi_bi));
Ibs_Vsi_bi=(Ibs_Vsi_bi-((PSeff*JTSSWS_t)*T1_Vsi_bi));
Ibs_Tempt_GND=(Ibs_Tempt_GND-((((PSeff_Tempt_GND*JTSSWS_t)+(PSeff*JTSSWS_t_Tempt_GND))*T1)+((PSeff*JTSSWS_t)*T1_Tempt_GND)));
#endif
Ibs=(Ibs-((PSeff*JTSSWS_t)*T1));
EXIT_IF_ISNAN((Ibs-((PSeff*JTSSWS_t)*T1)))
}
}
if
((JTSSWGS_t>0.0))
{
if
(((pModel->VTSSWGS-Vbs_jct)<(pModel->VTSSWGS*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=(((-Vbs_jct_Vsbulk_si)/Vtm0)/NJTSSWG_t);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vgm_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vdbulk_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vsbulk_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vgi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vdi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vsi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Tempt_GND=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*NJTSSWG_t_Tempt_GND+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbs_jct)/Vtm0)*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t);
#endif
#endif
T0=(((-Vbs_jct)/Vtm0)/NJTSSWG_t);
EXIT_IF_ISNAN((((-Vbs_jct)/Vtm0)/NJTSSWG_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=bsimbulk_d_lexp((T0*1.0e3),T0_Vsbulk_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+T0_Vsbulk_si_Vgm_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgm_si=(+(+T0_Vsbulk_si_Vgm_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+(+T0_Vsbulk_si_Vdbulk_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+(+T0_Vsbulk_si_Vsbulk_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgi_bi=(+(+T0_Vsbulk_si_Vgi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdi_bi=(+(+T0_Vsbulk_si_Vdi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsi_bi=(+(+T0_Vsbulk_si_Vsi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Tempt_GND=(+(+T0_Vsbulk_si_Tempt_GND*1.0e3+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vgi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*1.0e3+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*1.0e3+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*1.0e3+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vdi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*1.0e3+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*1.0e3+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*1.0e3+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vsi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*1.0e3+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*1.0e3+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*1.0e3+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#endif
#endif
T1=(bsimbulk_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=(Ibs_Vsbulk_si-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Vsbulk_si));
Ibs_Vgi_bi=(Ibs_Vgi_bi-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Vgi_bi));
Ibs_Vdi_bi=(Ibs_Vdi_bi-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Vdi_bi));
Ibs_Vsi_bi=(Ibs_Vsi_bi-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Vsi_bi));
Ibs_Tempt_GND=(Ibs_Tempt_GND-((((Weffcj*pInst->NF)*JTSSWGS_t_Tempt_GND)*T1)+(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Tempt_GND)));
#endif
Ibs=(Ibs-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1));
EXIT_IF_ISNAN((Ibs-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=(((-Vbs_jct_Vsbulk_si)/Vtm0)/NJTSSWG_t);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vgm_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vdbulk_di=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vsbulk_si=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct_Vsbulk_si)*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vgi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vdi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Vsi_bi=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*0.0+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Vsbulk_si_Tempt_GND=((0.0/Vtm0-((-Vbs_jct_Vsbulk_si)*0.0+0.0*0.0+(-Vbs_jct)*0.0)/Vtm0/Vtm0+2*(-Vbs_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-Vbs_jct_Vsbulk_si)/Vtm0)*NJTSSWG_t_Tempt_GND+0.0*0.0+((-Vbs_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-Vbs_jct)/Vtm0)*0.0*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbs_jct)/Vtm0)*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t);
#endif
#endif
T0=(((-Vbs_jct)/Vtm0)/NJTSSWG_t);
EXIT_IF_ISNAN((((-Vbs_jct)/Vtm0)/NJTSSWG_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=bsimbulk_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-Vbs_jct)),((T0_Vsbulk_si*pModel->VTSSWGS*(pModel->VTSSWGS-Vbs_jct)-(T0*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di*pModel->VTSSWGS+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWGS*0.0+(T0_Vgm_di*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si*pModel->VTSSWGS+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWGS*0.0+(T0_Vgm_si*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di*pModel->VTSSWGS+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWGS*0.0+(T0_Vdbulk_di*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si*pModel->VTSSWGS+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWGS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWGS)*(+0.0-Vbs_jct_Vsbulk_si_Vsbulk_si))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)*(-Vbs_jct_Vsbulk_si)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi*pModel->VTSSWGS+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWGS*0.0+(T0_Vgi_bi*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi*pModel->VTSSWGS+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWGS*0.0+(T0_Vdi_bi*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi*pModel->VTSSWGS+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWGS*0.0+(T0_Vsi_bi*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND*pModel->VTSSWGS+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsbulk_si*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*(-Vbs_jct_Vsbulk_si)*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-Vbs_jct)),(T0_Vgi_bi*pModel->VTSSWGS/(pModel->VTSSWGS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di*pModel->VTSSWGS+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWGS*0.0+(T0_Vgm_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si*pModel->VTSSWGS+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWGS*0.0+(T0_Vgm_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di*pModel->VTSSWGS+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWGS*0.0+(T0_Vdbulk_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si*pModel->VTSSWGS+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWGS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*(-Vbs_jct_Vsbulk_si)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi*pModel->VTSSWGS+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWGS*0.0+(T0_Vgi_bi*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi*pModel->VTSSWGS+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWGS*0.0+(T0_Vdi_bi*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi*pModel->VTSSWGS+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWGS*0.0+(T0_Vsi_bi*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND*pModel->VTSSWGS+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vgi_bi*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-Vbs_jct)),(T0_Vdi_bi*pModel->VTSSWGS/(pModel->VTSSWGS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di*pModel->VTSSWGS+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWGS*0.0+(T0_Vgm_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si*pModel->VTSSWGS+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWGS*0.0+(T0_Vgm_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di*pModel->VTSSWGS+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWGS*0.0+(T0_Vdbulk_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si*pModel->VTSSWGS+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWGS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*(-Vbs_jct_Vsbulk_si)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi*pModel->VTSSWGS+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWGS*0.0+(T0_Vgi_bi*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi*pModel->VTSSWGS+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWGS*0.0+(T0_Vdi_bi*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi*pModel->VTSSWGS+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWGS*0.0+(T0_Vsi_bi*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND*pModel->VTSSWGS+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vdi_bi*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-Vbs_jct)),(T0_Vsi_bi*pModel->VTSSWGS/(pModel->VTSSWGS-Vbs_jct)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di*pModel->VTSSWGS+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWGS*0.0+(T0_Vgm_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si*pModel->VTSSWGS+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWGS*0.0+(T0_Vgm_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di*pModel->VTSSWGS+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWGS*0.0+(T0_Vdbulk_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si*pModel->VTSSWGS+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWGS*(-Vbs_jct_Vsbulk_si)+(T0_Vsbulk_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*(-Vbs_jct_Vsbulk_si)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi*pModel->VTSSWGS+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWGS*0.0+(T0_Vgi_bi*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi*pModel->VTSSWGS+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWGS*0.0+(T0_Vdi_bi*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi*pModel->VTSSWGS+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWGS*0.0+(T0_Vsi_bi*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
  T1_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND*pModel->VTSSWGS+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-Vbs_jct)-(T0_Vsi_bi*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct)/(pModel->VTSSWGS-Vbs_jct))-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-Vbs_jct)),(T0_Tempt_GND*pModel->VTSSWGS/(pModel->VTSSWGS-Vbs_jct)));
#endif
#endif
T1=(bsimbulk_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-Vbs_jct)))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-Vbs_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibs_Vsbulk_si=(Ibs_Vsbulk_si-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Vsbulk_si));
Ibs_Vgi_bi=(Ibs_Vgi_bi-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Vgi_bi));
Ibs_Vdi_bi=(Ibs_Vdi_bi-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Vdi_bi));
Ibs_Vsi_bi=(Ibs_Vsi_bi-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Vsi_bi));
Ibs_Tempt_GND=(Ibs_Tempt_GND-((((Weffcj*pInst->NF)*JTSSWGS_t_Tempt_GND)*T1)+(((Weffcj*pInst->NF)*JTSSWGS_t)*T1_Tempt_GND)));
#endif
Ibs=(Ibs-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1));
EXIT_IF_ISNAN((Ibs-(((Weffcj*pInst->NF)*JTSSWGS_t)*T1)))
}
}
if
((Isbd>0.0))
{
if
((Vbd_jct<VjdmRev))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(Vbd_jct_Vdbulk_di/Nvtmd);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vgm_si=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vdbulk_di=(Vbd_jct_Vdbulk_di_Vdbulk_di/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+Vbd_jct_Vdbulk_di*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vsbulk_si=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vgi_bi=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vdi_bi=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vsi_bi=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Tempt_GND=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*Nvtmd_Tempt_GND+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-Vbd_jct*Nvtmd_Tempt_GND/Nvtmd/Nvtmd);
#endif
#endif
T0=(Vbd_jct/Nvtmd);
EXIT_IF_ISNAN((Vbd_jct/Nvtmd))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=bsimbulk_d_lexp(T0,T0_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+T0_Vdbulk_di_Vgm_di-0.0);
  T1_Vdbulk_di_Vgm_si=(+T0_Vdbulk_di_Vgm_si-0.0);
  T1_Vdbulk_di_Vdbulk_di=(+T0_Vdbulk_di_Vdbulk_di-0.0);
  T1_Vdbulk_di_Vsbulk_si=(+T0_Vdbulk_di_Vsbulk_si-0.0);
  T1_Vdbulk_di_Vgi_bi=(+T0_Vdbulk_di_Vgi_bi-0.0);
  T1_Vdbulk_di_Vdi_bi=(+T0_Vdbulk_di_Vdi_bi-0.0);
  T1_Vdbulk_di_Vsi_bi=(+T0_Vdbulk_di_Vsi_bi-0.0);
  T1_Vdbulk_di_Tempt_GND=(+T0_Vdbulk_di_Tempt_GND-0.0);
#endif
T1_Vsbulk_si=bsimbulk_d_lexp(T0,T0_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+T0_Vsbulk_si_Vgm_di-0.0);
  T1_Vsbulk_si_Vgm_si=(+T0_Vsbulk_si_Vgm_si-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+T0_Vsbulk_si_Vdbulk_di-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+T0_Vsbulk_si_Vsbulk_si-0.0);
  T1_Vsbulk_si_Vgi_bi=(+T0_Vsbulk_si_Vgi_bi-0.0);
  T1_Vsbulk_si_Vdi_bi=(+T0_Vsbulk_si_Vdi_bi-0.0);
  T1_Vsbulk_si_Vsi_bi=(+T0_Vsbulk_si_Vsi_bi-0.0);
  T1_Vsbulk_si_Tempt_GND=(+T0_Vsbulk_si_Tempt_GND-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp(T0,T0_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+T0_Vgi_bi_Vgm_di-0.0);
  T1_Vgi_bi_Vgm_si=(+T0_Vgi_bi_Vgm_si-0.0);
  T1_Vgi_bi_Vdbulk_di=(+T0_Vgi_bi_Vdbulk_di-0.0);
  T1_Vgi_bi_Vsbulk_si=(+T0_Vgi_bi_Vsbulk_si-0.0);
  T1_Vgi_bi_Vgi_bi=(+T0_Vgi_bi_Vgi_bi-0.0);
  T1_Vgi_bi_Vdi_bi=(+T0_Vgi_bi_Vdi_bi-0.0);
  T1_Vgi_bi_Vsi_bi=(+T0_Vgi_bi_Vsi_bi-0.0);
  T1_Vgi_bi_Tempt_GND=(+T0_Vgi_bi_Tempt_GND-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp(T0,T0_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+T0_Vdi_bi_Vgm_di-0.0);
  T1_Vdi_bi_Vgm_si=(+T0_Vdi_bi_Vgm_si-0.0);
  T1_Vdi_bi_Vdbulk_di=(+T0_Vdi_bi_Vdbulk_di-0.0);
  T1_Vdi_bi_Vsbulk_si=(+T0_Vdi_bi_Vsbulk_si-0.0);
  T1_Vdi_bi_Vgi_bi=(+T0_Vdi_bi_Vgi_bi-0.0);
  T1_Vdi_bi_Vdi_bi=(+T0_Vdi_bi_Vdi_bi-0.0);
  T1_Vdi_bi_Vsi_bi=(+T0_Vdi_bi_Vsi_bi-0.0);
  T1_Vdi_bi_Tempt_GND=(+T0_Vdi_bi_Tempt_GND-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp(T0,T0_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+T0_Vsi_bi_Vgm_di-0.0);
  T1_Vsi_bi_Vgm_si=(+T0_Vsi_bi_Vgm_si-0.0);
  T1_Vsi_bi_Vdbulk_di=(+T0_Vsi_bi_Vdbulk_di-0.0);
  T1_Vsi_bi_Vsbulk_si=(+T0_Vsi_bi_Vsbulk_si-0.0);
  T1_Vsi_bi_Vgi_bi=(+T0_Vsi_bi_Vgi_bi-0.0);
  T1_Vsi_bi_Vdi_bi=(+T0_Vsi_bi_Vdi_bi-0.0);
  T1_Vsi_bi_Vsi_bi=(+T0_Vsi_bi_Vsi_bi-0.0);
  T1_Vsi_bi_Tempt_GND=(+T0_Vsi_bi_Tempt_GND-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp(T0,T0_Tempt_GND);
#endif
#endif
T1=(bsimbulk_lexp(T0)-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp(T0)-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(DslpRev*Vbd_jct_Vdbulk_di);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+0.0+(+0.0*(Vbd_jct-VjdmRev)+0.0*0.0+0.0*Vbd_jct_Vdbulk_di+DslpRev*(+0.0-0.0)));
  T2_Vdbulk_di_Vgm_si=(+0.0+(+0.0*(Vbd_jct-VjdmRev)+0.0*0.0+0.0*Vbd_jct_Vdbulk_di+DslpRev*(+0.0-0.0)));
  T2_Vdbulk_di_Vdbulk_di=(+0.0+(+0.0*(Vbd_jct-VjdmRev)+0.0*Vbd_jct_Vdbulk_di+0.0*Vbd_jct_Vdbulk_di+DslpRev*(+Vbd_jct_Vdbulk_di_Vdbulk_di-0.0)));
  T2_Vdbulk_di_Vsbulk_si=(+0.0+(+0.0*(Vbd_jct-VjdmRev)+0.0*0.0+0.0*Vbd_jct_Vdbulk_di+DslpRev*(+0.0-0.0)));
  T2_Vdbulk_di_Vgi_bi=(+0.0+(+0.0*(Vbd_jct-VjdmRev)+0.0*0.0+0.0*Vbd_jct_Vdbulk_di+DslpRev*(+0.0-0.0)));
  T2_Vdbulk_di_Vdi_bi=(+0.0+(+0.0*(Vbd_jct-VjdmRev)+0.0*0.0+0.0*Vbd_jct_Vdbulk_di+DslpRev*(+0.0-0.0)));
  T2_Vdbulk_di_Vsi_bi=(+0.0+(+0.0*(Vbd_jct-VjdmRev)+0.0*0.0+0.0*Vbd_jct_Vdbulk_di+DslpRev*(+0.0-0.0)));
  T2_Vdbulk_di_Tempt_GND=(+0.0+(+0.0*(Vbd_jct-VjdmRev)+0.0*(-VjdmRev_Tempt_GND)+DslpRev_Tempt_GND*Vbd_jct_Vdbulk_di+DslpRev*(+0.0-0.0)));
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(IVjdmRev_Tempt_GND+((DslpRev_Tempt_GND*(Vbd_jct-VjdmRev))+(DslpRev*(-VjdmRev_Tempt_GND))));
#endif
#endif
T2=(IVjdmRev+(DslpRev*(Vbd_jct-VjdmRev)));
EXIT_IF_ISNAN((IVjdmRev+(DslpRev*(Vbd_jct-VjdmRev))))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=((T1_Vdbulk_di*T2)+(T1*T2_Vdbulk_di));
Ibd_Vsbulk_si=((T1_Vsbulk_si*T2)+(T1*T2_Vsbulk_si));
Ibd_Vgi_bi=((T1_Vgi_bi*T2)+(T1*T2_Vgi_bi));
Ibd_Vdi_bi=((T1_Vdi_bi*T2)+(T1*T2_Vdi_bi));
Ibd_Vsi_bi=((T1_Vsi_bi*T2)+(T1*T2_Vsi_bi));
Ibd_Tempt_GND=((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND));
#endif
Ibd=(T1*T2);
EXIT_IF_ISNAN((T1*T2))
}
else
{
if
((Vbd_jct<=VjdmFwd))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(Vbd_jct_Vdbulk_di/Nvtmd);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vgm_si=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vdbulk_di=(Vbd_jct_Vdbulk_di_Vdbulk_di/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+Vbd_jct_Vdbulk_di*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vsbulk_si=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vgi_bi=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vdi_bi=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Vsi_bi=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Vdbulk_di_Tempt_GND=(0.0/Nvtmd-(Vbd_jct_Vdbulk_di*Nvtmd_Tempt_GND+0.0*0.0+Vbd_jct*0.0)/Nvtmd/Nvtmd+2*Vbd_jct*0.0*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-Vbd_jct*Nvtmd_Tempt_GND/Nvtmd/Nvtmd);
#endif
#endif
T0=(Vbd_jct/Nvtmd);
EXIT_IF_ISNAN((Vbd_jct/Nvtmd))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(Vbd_jct_Vdbulk_di/Nvtmd);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=((+0.0+0.0)/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+(pModel->BVD+Vbd_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+Vbd_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Vdbulk_di_Vgm_si=((+0.0+0.0)/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+(pModel->BVD+Vbd_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+Vbd_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Vdbulk_di_Vdbulk_di=((+0.0+Vbd_jct_Vdbulk_di_Vdbulk_di)/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+Vbd_jct_Vdbulk_di*0.0+(pModel->BVD+Vbd_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+Vbd_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Vdbulk_di_Vsbulk_si=((+0.0+0.0)/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+(pModel->BVD+Vbd_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+Vbd_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Vdbulk_di_Vgi_bi=((+0.0+0.0)/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+(pModel->BVD+Vbd_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+Vbd_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Vdbulk_di_Vdi_bi=((+0.0+0.0)/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+(pModel->BVD+Vbd_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+Vbd_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Vdbulk_di_Vsi_bi=((+0.0+0.0)/Nvtmd-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+(pModel->BVD+Vbd_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+Vbd_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Vdbulk_di_Tempt_GND=((+0.0+0.0)/Nvtmd-(Vbd_jct_Vdbulk_di*Nvtmd_Tempt_GND+0.0*0.0+(pModel->BVD+Vbd_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+Vbd_jct)*0.0*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-(pModel->BVD+Vbd_jct)*Nvtmd_Tempt_GND/Nvtmd/Nvtmd);
#endif
#endif
T1=((pModel->BVD+Vbd_jct)/Nvtmd);
EXIT_IF_ISNAN(((pModel->BVD+Vbd_jct)/Nvtmd))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=bsimbulk_d_lexp((-T1),(-T1_Vdbulk_di));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=bsimbulk_d_lexp((-T1),(-T1_Vsbulk_si));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=bsimbulk_d_lexp((-T1),(-T1_Vgi_bi));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=bsimbulk_d_lexp((-T1),(-T1_Vdi_bi));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=bsimbulk_d_lexp((-T1),(-T1_Vsi_bi));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=bsimbulk_d_lexp((-T1),(-T1_Tempt_GND));
#endif
#endif
T2=bsimbulk_lexp((-T1));
EXIT_IF_ISNAN(bsimbulk_lexp((-T1)))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=(Isbd*(bsimbulk_d_lexp(T0,T0_Vdbulk_di)-(pModel->XJBVD*T2_Vdbulk_di)));
Ibd_Vsbulk_si=(Isbd*(bsimbulk_d_lexp(T0,T0_Vsbulk_si)-(pModel->XJBVD*T2_Vsbulk_si)));
Ibd_Vgi_bi=(Isbd*(bsimbulk_d_lexp(T0,T0_Vgi_bi)-(pModel->XJBVD*T2_Vgi_bi)));
Ibd_Vdi_bi=(Isbd*(bsimbulk_d_lexp(T0,T0_Vdi_bi)-(pModel->XJBVD*T2_Vdi_bi)));
Ibd_Vsi_bi=(Isbd*(bsimbulk_d_lexp(T0,T0_Vsi_bi)-(pModel->XJBVD*T2_Vsi_bi)));
Ibd_Tempt_GND=((Isbd_Tempt_GND*(((bsimbulk_lexp(T0)+XExpBVD)-1.0)-(pModel->XJBVD*T2)))+(Isbd*((bsimbulk_d_lexp(T0,T0_Tempt_GND)+XExpBVD_Tempt_GND)-(pModel->XJBVD*T2_Tempt_GND))));
#endif
Ibd=(Isbd*(((bsimbulk_lexp(T0)+XExpBVD)-1.0)-(pModel->XJBVD*T2)));
EXIT_IF_ISNAN((Isbd*(((bsimbulk_lexp(T0)+XExpBVD)-1.0)-(pModel->XJBVD*T2))))
}
else
{
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=(DslpFwd*Vbd_jct_Vdbulk_di);
Ibd_Vsbulk_si=0.0;
Ibd_Vgi_bi=0.0;
Ibd_Vdi_bi=0.0;
Ibd_Vsi_bi=0.0;
Ibd_Tempt_GND=(IVjdmFwd_Tempt_GND+((DslpFwd_Tempt_GND*(Vbd_jct-VjdmFwd))+(DslpFwd*(-VjdmFwd_Tempt_GND))));
#endif
Ibd=(IVjdmFwd+(DslpFwd*(Vbd_jct-VjdmFwd)));
EXIT_IF_ISNAN((IVjdmFwd+(DslpFwd*(Vbd_jct-VjdmFwd))))
}
}
}
else
{
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=0.0;
Ibd_Vsbulk_si=0.0;
Ibd_Vgi_bi=0.0;
Ibd_Vdi_bi=0.0;
Ibd_Vsi_bi=0.0;
Ibd_Tempt_GND=0.0;
#endif
Ibd=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((JTSD_t>0.0))
{
if
(((pModel->VTSD-Vbd_jct)<(pModel->VTSD*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(((-Vbd_jct_Vdbulk_di)/Vtm0)/NJTSD_t);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vgm_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vdbulk_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vsbulk_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vgi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vdi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vsi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Tempt_GND=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*NJTSD_t_Tempt_GND+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t/NJTSD_t);
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbd_jct)/Vtm0)*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t);
#endif
#endif
T0=(((-Vbd_jct)/Vtm0)/NJTSD_t);
EXIT_IF_ISNAN((((-Vbd_jct)/Vtm0)/NJTSD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=bsimbulk_d_lexp((T0*1.0e3),T0_Vdbulk_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+T0_Vdbulk_di_Vgm_di*1.0e3+T0_Vdbulk_di*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vgm_si=(+(+T0_Vdbulk_di_Vgm_si*1.0e3+T0_Vdbulk_di*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vdbulk_di=(+(+T0_Vdbulk_di_Vdbulk_di*1.0e3+T0_Vdbulk_di*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vsbulk_si=(+(+T0_Vdbulk_di_Vsbulk_si*1.0e3+T0_Vdbulk_di*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vgi_bi=(+(+T0_Vdbulk_di_Vgi_bi*1.0e3+T0_Vdbulk_di*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vdi_bi=(+(+T0_Vdbulk_di_Vdi_bi*1.0e3+T0_Vdbulk_di*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vsi_bi=(+(+T0_Vdbulk_di_Vsi_bi*1.0e3+T0_Vdbulk_di*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Tempt_GND=(+(+T0_Vdbulk_di_Tempt_GND*1.0e3+T0_Vdbulk_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vsbulk_si=bsimbulk_d_lexp((T0*1.0e3),T0_Vsbulk_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+T0_Vsbulk_si_Vgm_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgm_si=(+(+T0_Vsbulk_si_Vgm_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+(+T0_Vsbulk_si_Vdbulk_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+(+T0_Vsbulk_si_Vsbulk_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgi_bi=(+(+T0_Vsbulk_si_Vgi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdi_bi=(+(+T0_Vsbulk_si_Vdi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsi_bi=(+(+T0_Vsbulk_si_Vsi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Tempt_GND=(+(+T0_Vsbulk_si_Tempt_GND*1.0e3+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vgi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*1.0e3+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*1.0e3+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*1.0e3+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vdi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*1.0e3+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*1.0e3+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*1.0e3+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vsi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*1.0e3+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*1.0e3+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*1.0e3+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#endif
#endif
T1=(bsimbulk_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=(Ibd_Vdbulk_di-((ADeff*JTSD_t)*T1_Vdbulk_di));
Ibd_Vsbulk_si=(Ibd_Vsbulk_si-((ADeff*JTSD_t)*T1_Vsbulk_si));
Ibd_Vgi_bi=(Ibd_Vgi_bi-((ADeff*JTSD_t)*T1_Vgi_bi));
Ibd_Vdi_bi=(Ibd_Vdi_bi-((ADeff*JTSD_t)*T1_Vdi_bi));
Ibd_Vsi_bi=(Ibd_Vsi_bi-((ADeff*JTSD_t)*T1_Vsi_bi));
Ibd_Tempt_GND=(Ibd_Tempt_GND-((((ADeff_Tempt_GND*JTSD_t)+(ADeff*JTSD_t_Tempt_GND))*T1)+((ADeff*JTSD_t)*T1_Tempt_GND)));
#endif
Ibd=(Ibd-((ADeff*JTSD_t)*T1));
EXIT_IF_ISNAN((Ibd-((ADeff*JTSD_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(((-Vbd_jct_Vdbulk_di)/Vtm0)/NJTSD_t);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vgm_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vdbulk_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vsbulk_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vgi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vdi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Vsi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Vdbulk_di_Tempt_GND=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*NJTSD_t_Tempt_GND+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-Vbd_jct)/Vtm0)*0.0*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t/NJTSD_t);
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbd_jct)/Vtm0)*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t);
#endif
#endif
T0=(((-Vbd_jct)/Vtm0)/NJTSD_t);
EXIT_IF_ISNAN((((-Vbd_jct)/Vtm0)/NJTSD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=bsimbulk_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-Vbd_jct)),((T0_Vdbulk_di*pModel->VTSD*(pModel->VTSD-Vbd_jct)-(T0*pModel->VTSD)*(-Vbd_jct_Vdbulk_di))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+((+T0_Vdbulk_di_Vgm_di*pModel->VTSD+T0_Vdbulk_di*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSD*0.0+(T0_Vgm_di*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vgm_si=(+((+T0_Vdbulk_di_Vgm_si*pModel->VTSD+T0_Vdbulk_di*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSD*0.0+(T0_Vgm_si*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vdbulk_di=(+((+T0_Vdbulk_di_Vdbulk_di*pModel->VTSD+T0_Vdbulk_di*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSD)*(+0.0-Vbd_jct_Vdbulk_di_Vdbulk_di))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)*(-Vbd_jct_Vdbulk_di)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vsbulk_si=(+((+T0_Vdbulk_di_Vsbulk_si*pModel->VTSD+T0_Vdbulk_di*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSD*0.0+(T0_Vsbulk_si*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vgi_bi=(+((+T0_Vdbulk_di_Vgi_bi*pModel->VTSD+T0_Vdbulk_di*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSD*0.0+(T0_Vgi_bi*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vdi_bi=(+((+T0_Vdbulk_di_Vdi_bi*pModel->VTSD+T0_Vdbulk_di*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSD*0.0+(T0_Vdi_bi*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vsi_bi=(+((+T0_Vdbulk_di_Vsi_bi*pModel->VTSD+T0_Vdbulk_di*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSD*0.0+(T0_Vsi_bi*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Tempt_GND=(+((+T0_Vdbulk_di_Tempt_GND*pModel->VTSD+T0_Vdbulk_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
#endif
T1_Vsbulk_si=bsimbulk_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-Vbd_jct)),(T0_Vsbulk_si*pModel->VTSD/(pModel->VTSD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di*pModel->VTSD+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSD*0.0+(T0_Vgm_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si*pModel->VTSD+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSD*0.0+(T0_Vgm_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di*pModel->VTSD+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si*pModel->VTSD+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSD*0.0+(T0_Vsbulk_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi*pModel->VTSD+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSD*0.0+(T0_Vgi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi*pModel->VTSD+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSD*0.0+(T0_Vdi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi*pModel->VTSD+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSD*0.0+(T0_Vsi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND*pModel->VTSD+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-Vbd_jct)),(T0_Vgi_bi*pModel->VTSD/(pModel->VTSD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di*pModel->VTSD+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSD*0.0+(T0_Vgm_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si*pModel->VTSD+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSD*0.0+(T0_Vgm_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di*pModel->VTSD+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si*pModel->VTSD+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSD*0.0+(T0_Vsbulk_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi*pModel->VTSD+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSD*0.0+(T0_Vgi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi*pModel->VTSD+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSD*0.0+(T0_Vdi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi*pModel->VTSD+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSD*0.0+(T0_Vsi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND*pModel->VTSD+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-Vbd_jct)),(T0_Vdi_bi*pModel->VTSD/(pModel->VTSD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di*pModel->VTSD+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSD*0.0+(T0_Vgm_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si*pModel->VTSD+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSD*0.0+(T0_Vgm_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di*pModel->VTSD+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si*pModel->VTSD+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSD*0.0+(T0_Vsbulk_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi*pModel->VTSD+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSD*0.0+(T0_Vgi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi*pModel->VTSD+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSD*0.0+(T0_Vdi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi*pModel->VTSD+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSD*0.0+(T0_Vsi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND*pModel->VTSD+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-Vbd_jct)),(T0_Vsi_bi*pModel->VTSD/(pModel->VTSD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di*pModel->VTSD+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSD*0.0+(T0_Vgm_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si*pModel->VTSD+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSD*0.0+(T0_Vgm_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di*pModel->VTSD+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si*pModel->VTSD+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSD*0.0+(T0_Vsbulk_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi*pModel->VTSD+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSD*0.0+(T0_Vgi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi*pModel->VTSD+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSD*0.0+(T0_Vdi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi*pModel->VTSD+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSD*0.0+(T0_Vsi_bi*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
  T1_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND*pModel->VTSD+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct)/(pModel->VTSD-Vbd_jct))-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-Vbd_jct)),(T0_Tempt_GND*pModel->VTSD/(pModel->VTSD-Vbd_jct)));
#endif
#endif
T1=(bsimbulk_lexp(((T0*pModel->VTSD)/(pModel->VTSD-Vbd_jct)))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp(((T0*pModel->VTSD)/(pModel->VTSD-Vbd_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=(Ibd_Vdbulk_di-((ADeff*JTSD_t)*T1_Vdbulk_di));
Ibd_Vsbulk_si=(Ibd_Vsbulk_si-((ADeff*JTSD_t)*T1_Vsbulk_si));
Ibd_Vgi_bi=(Ibd_Vgi_bi-((ADeff*JTSD_t)*T1_Vgi_bi));
Ibd_Vdi_bi=(Ibd_Vdi_bi-((ADeff*JTSD_t)*T1_Vdi_bi));
Ibd_Vsi_bi=(Ibd_Vsi_bi-((ADeff*JTSD_t)*T1_Vsi_bi));
Ibd_Tempt_GND=(Ibd_Tempt_GND-((((ADeff_Tempt_GND*JTSD_t)+(ADeff*JTSD_t_Tempt_GND))*T1)+((ADeff*JTSD_t)*T1_Tempt_GND)));
#endif
Ibd=(Ibd-((ADeff*JTSD_t)*T1));
EXIT_IF_ISNAN((Ibd-((ADeff*JTSD_t)*T1)))
}
}
if
((JTSSWD_t>0.0))
{
if
(((pModel->VTSSWD-Vbd_jct)<(pModel->VTSSWD*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(((-Vbd_jct_Vdbulk_di)/Vtm0)/NJTSSWD_t);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vgm_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vdbulk_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vsbulk_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vgi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vdi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vsi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Tempt_GND=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*NJTSSWD_t_Tempt_GND+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbd_jct)/Vtm0)*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t);
#endif
#endif
T0=(((-Vbd_jct)/Vtm0)/NJTSSWD_t);
EXIT_IF_ISNAN((((-Vbd_jct)/Vtm0)/NJTSSWD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=bsimbulk_d_lexp((T0*1.0e3),T0_Vdbulk_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+T0_Vdbulk_di_Vgm_di*1.0e3+T0_Vdbulk_di*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vgm_si=(+(+T0_Vdbulk_di_Vgm_si*1.0e3+T0_Vdbulk_di*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vdbulk_di=(+(+T0_Vdbulk_di_Vdbulk_di*1.0e3+T0_Vdbulk_di*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vsbulk_si=(+(+T0_Vdbulk_di_Vsbulk_si*1.0e3+T0_Vdbulk_di*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vgi_bi=(+(+T0_Vdbulk_di_Vgi_bi*1.0e3+T0_Vdbulk_di*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vdi_bi=(+(+T0_Vdbulk_di_Vdi_bi*1.0e3+T0_Vdbulk_di*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vsi_bi=(+(+T0_Vdbulk_di_Vsi_bi*1.0e3+T0_Vdbulk_di*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Tempt_GND=(+(+T0_Vdbulk_di_Tempt_GND*1.0e3+T0_Vdbulk_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vsbulk_si=bsimbulk_d_lexp((T0*1.0e3),T0_Vsbulk_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+T0_Vsbulk_si_Vgm_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgm_si=(+(+T0_Vsbulk_si_Vgm_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+(+T0_Vsbulk_si_Vdbulk_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+(+T0_Vsbulk_si_Vsbulk_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgi_bi=(+(+T0_Vsbulk_si_Vgi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdi_bi=(+(+T0_Vsbulk_si_Vdi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsi_bi=(+(+T0_Vsbulk_si_Vsi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Tempt_GND=(+(+T0_Vsbulk_si_Tempt_GND*1.0e3+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vgi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*1.0e3+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*1.0e3+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*1.0e3+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vdi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*1.0e3+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*1.0e3+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*1.0e3+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vsi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*1.0e3+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*1.0e3+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*1.0e3+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#endif
#endif
T1=(bsimbulk_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=(Ibd_Vdbulk_di-((PDeff*JTSSWD_t)*T1_Vdbulk_di));
Ibd_Vsbulk_si=(Ibd_Vsbulk_si-((PDeff*JTSSWD_t)*T1_Vsbulk_si));
Ibd_Vgi_bi=(Ibd_Vgi_bi-((PDeff*JTSSWD_t)*T1_Vgi_bi));
Ibd_Vdi_bi=(Ibd_Vdi_bi-((PDeff*JTSSWD_t)*T1_Vdi_bi));
Ibd_Vsi_bi=(Ibd_Vsi_bi-((PDeff*JTSSWD_t)*T1_Vsi_bi));
Ibd_Tempt_GND=(Ibd_Tempt_GND-((((PDeff_Tempt_GND*JTSSWD_t)+(PDeff*JTSSWD_t_Tempt_GND))*T1)+((PDeff*JTSSWD_t)*T1_Tempt_GND)));
#endif
Ibd=(Ibd-((PDeff*JTSSWD_t)*T1));
EXIT_IF_ISNAN((Ibd-((PDeff*JTSSWD_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(((-Vbd_jct_Vdbulk_di)/Vtm0)/NJTSSWD_t);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vgm_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vdbulk_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vsbulk_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vgi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vdi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Vsi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Vdbulk_di_Tempt_GND=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*NJTSSWD_t_Tempt_GND+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-Vbd_jct)/Vtm0)*0.0*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbd_jct)/Vtm0)*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t);
#endif
#endif
T0=(((-Vbd_jct)/Vtm0)/NJTSSWD_t);
EXIT_IF_ISNAN((((-Vbd_jct)/Vtm0)/NJTSSWD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=bsimbulk_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-Vbd_jct)),((T0_Vdbulk_di*pModel->VTSSWD*(pModel->VTSSWD-Vbd_jct)-(T0*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+((+T0_Vdbulk_di_Vgm_di*pModel->VTSSWD+T0_Vdbulk_di*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWD*0.0+(T0_Vgm_di*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vgm_si=(+((+T0_Vdbulk_di_Vgm_si*pModel->VTSSWD+T0_Vdbulk_di*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWD*0.0+(T0_Vgm_si*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vdbulk_di=(+((+T0_Vdbulk_di_Vdbulk_di*pModel->VTSSWD+T0_Vdbulk_di*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWD)*(+0.0-Vbd_jct_Vdbulk_di_Vdbulk_di))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vsbulk_si=(+((+T0_Vdbulk_di_Vsbulk_si*pModel->VTSSWD+T0_Vdbulk_di*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWD*0.0+(T0_Vsbulk_si*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vgi_bi=(+((+T0_Vdbulk_di_Vgi_bi*pModel->VTSSWD+T0_Vdbulk_di*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWD*0.0+(T0_Vgi_bi*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vdi_bi=(+((+T0_Vdbulk_di_Vdi_bi*pModel->VTSSWD+T0_Vdbulk_di*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWD*0.0+(T0_Vdi_bi*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vsi_bi=(+((+T0_Vdbulk_di_Vsi_bi*pModel->VTSSWD+T0_Vdbulk_di*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWD*0.0+(T0_Vsi_bi*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Tempt_GND=(+((+T0_Vdbulk_di_Tempt_GND*pModel->VTSSWD+T0_Vdbulk_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
#endif
T1_Vsbulk_si=bsimbulk_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-Vbd_jct)),(T0_Vsbulk_si*pModel->VTSSWD/(pModel->VTSSWD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di*pModel->VTSSWD+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWD*0.0+(T0_Vgm_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si*pModel->VTSSWD+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWD*0.0+(T0_Vgm_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di*pModel->VTSSWD+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si*pModel->VTSSWD+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWD*0.0+(T0_Vsbulk_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi*pModel->VTSSWD+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWD*0.0+(T0_Vgi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi*pModel->VTSSWD+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWD*0.0+(T0_Vdi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi*pModel->VTSSWD+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWD*0.0+(T0_Vsi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND*pModel->VTSSWD+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-Vbd_jct)),(T0_Vgi_bi*pModel->VTSSWD/(pModel->VTSSWD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di*pModel->VTSSWD+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWD*0.0+(T0_Vgm_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si*pModel->VTSSWD+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWD*0.0+(T0_Vgm_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di*pModel->VTSSWD+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si*pModel->VTSSWD+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWD*0.0+(T0_Vsbulk_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi*pModel->VTSSWD+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWD*0.0+(T0_Vgi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi*pModel->VTSSWD+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWD*0.0+(T0_Vdi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi*pModel->VTSSWD+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWD*0.0+(T0_Vsi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND*pModel->VTSSWD+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-Vbd_jct)),(T0_Vdi_bi*pModel->VTSSWD/(pModel->VTSSWD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di*pModel->VTSSWD+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWD*0.0+(T0_Vgm_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si*pModel->VTSSWD+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWD*0.0+(T0_Vgm_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di*pModel->VTSSWD+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si*pModel->VTSSWD+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWD*0.0+(T0_Vsbulk_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi*pModel->VTSSWD+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWD*0.0+(T0_Vgi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi*pModel->VTSSWD+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWD*0.0+(T0_Vdi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi*pModel->VTSSWD+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWD*0.0+(T0_Vsi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND*pModel->VTSSWD+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-Vbd_jct)),(T0_Vsi_bi*pModel->VTSSWD/(pModel->VTSSWD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di*pModel->VTSSWD+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWD*0.0+(T0_Vgm_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si*pModel->VTSSWD+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWD*0.0+(T0_Vgm_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di*pModel->VTSSWD+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si*pModel->VTSSWD+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWD*0.0+(T0_Vsbulk_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi*pModel->VTSSWD+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWD*0.0+(T0_Vgi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi*pModel->VTSSWD+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWD*0.0+(T0_Vdi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi*pModel->VTSSWD+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWD*0.0+(T0_Vsi_bi*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
  T1_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND*pModel->VTSSWD+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct)/(pModel->VTSSWD-Vbd_jct))-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-Vbd_jct)),(T0_Tempt_GND*pModel->VTSSWD/(pModel->VTSSWD-Vbd_jct)));
#endif
#endif
T1=(bsimbulk_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-Vbd_jct)))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-Vbd_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=(Ibd_Vdbulk_di-((PDeff*JTSSWD_t)*T1_Vdbulk_di));
Ibd_Vsbulk_si=(Ibd_Vsbulk_si-((PDeff*JTSSWD_t)*T1_Vsbulk_si));
Ibd_Vgi_bi=(Ibd_Vgi_bi-((PDeff*JTSSWD_t)*T1_Vgi_bi));
Ibd_Vdi_bi=(Ibd_Vdi_bi-((PDeff*JTSSWD_t)*T1_Vdi_bi));
Ibd_Vsi_bi=(Ibd_Vsi_bi-((PDeff*JTSSWD_t)*T1_Vsi_bi));
Ibd_Tempt_GND=(Ibd_Tempt_GND-((((PDeff_Tempt_GND*JTSSWD_t)+(PDeff*JTSSWD_t_Tempt_GND))*T1)+((PDeff*JTSSWD_t)*T1_Tempt_GND)));
#endif
Ibd=(Ibd-((PDeff*JTSSWD_t)*T1));
EXIT_IF_ISNAN((Ibd-((PDeff*JTSSWD_t)*T1)))
}
}
if
((JTSSWGD_t>0.0))
{
if
(((pModel->VTSSWGD-Vbd_jct)<(pModel->VTSSWGD*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(((-Vbd_jct_Vdbulk_di)/Vtm0)/NJTSSWGD_t);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vgm_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vdbulk_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vsbulk_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vgi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vdi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vsi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Tempt_GND=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*NJTSSWGD_t_Tempt_GND+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbd_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t);
#endif
#endif
T0=(((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
EXIT_IF_ISNAN((((-Vbd_jct)/Vtm0)/NJTSSWGD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=bsimbulk_d_lexp((T0*1.0e3),T0_Vdbulk_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+T0_Vdbulk_di_Vgm_di*1.0e3+T0_Vdbulk_di*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vgm_si=(+(+T0_Vdbulk_di_Vgm_si*1.0e3+T0_Vdbulk_di*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vdbulk_di=(+(+T0_Vdbulk_di_Vdbulk_di*1.0e3+T0_Vdbulk_di*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vsbulk_si=(+(+T0_Vdbulk_di_Vsbulk_si*1.0e3+T0_Vdbulk_di*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vgi_bi=(+(+T0_Vdbulk_di_Vgi_bi*1.0e3+T0_Vdbulk_di*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vdi_bi=(+(+T0_Vdbulk_di_Vdi_bi*1.0e3+T0_Vdbulk_di*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Vsi_bi=(+(+T0_Vdbulk_di_Vsi_bi*1.0e3+T0_Vdbulk_di*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vdbulk_di_Tempt_GND=(+(+T0_Vdbulk_di_Tempt_GND*1.0e3+T0_Vdbulk_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vsbulk_si=bsimbulk_d_lexp((T0*1.0e3),T0_Vsbulk_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+T0_Vsbulk_si_Vgm_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgm_si=(+(+T0_Vsbulk_si_Vgm_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+(+T0_Vsbulk_si_Vdbulk_di*1.0e3+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+(+T0_Vsbulk_si_Vsbulk_si*1.0e3+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vgi_bi=(+(+T0_Vsbulk_si_Vgi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vdi_bi=(+(+T0_Vsbulk_si_Vdi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Vsi_bi=(+(+T0_Vsbulk_si_Vsi_bi*1.0e3+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsbulk_si_Tempt_GND=(+(+T0_Vsbulk_si_Tempt_GND*1.0e3+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vgi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*1.0e3+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*1.0e3+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*1.0e3+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*1.0e3+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*1.0e3+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vdi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*1.0e3+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*1.0e3+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*1.0e3+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*1.0e3+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*1.0e3+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp((T0*1.0e3),T0_Vsi_bi*1.0e3);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*1.0e3+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*1.0e3+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*1.0e3+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*1.0e3+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)-0.0);
  T1_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*1.0e3+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#endif
#endif
T1=(bsimbulk_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=(Ibd_Vdbulk_di-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vdbulk_di));
Ibd_Vsbulk_si=(Ibd_Vsbulk_si-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vsbulk_si));
Ibd_Vgi_bi=(Ibd_Vgi_bi-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vgi_bi));
Ibd_Vdi_bi=(Ibd_Vdi_bi-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vdi_bi));
Ibd_Vsi_bi=(Ibd_Vsi_bi-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vsi_bi));
Ibd_Tempt_GND=(Ibd_Tempt_GND-((((Weffcj*pInst->NF)*JTSSWGD_t_Tempt_GND)*T1)+(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Tempt_GND)));
#endif
Ibd=(Ibd-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1));
EXIT_IF_ISNAN((Ibd-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(((-Vbd_jct_Vdbulk_di)/Vtm0)/NJTSSWGD_t);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vgm_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vdbulk_di=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct_Vdbulk_di)*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vsbulk_si=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vgi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vdi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Vsi_bi=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*0.0+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Vdbulk_di_Tempt_GND=((0.0/Vtm0-((-Vbd_jct_Vdbulk_di)*0.0+0.0*0.0+(-Vbd_jct)*0.0)/Vtm0/Vtm0+2*(-Vbd_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-Vbd_jct_Vdbulk_di)/Vtm0)*NJTSSWGD_t_Tempt_GND+0.0*0.0+((-Vbd_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-Vbd_jct)/Vtm0)*0.0*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-((-Vbd_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t);
#endif
#endif
T0=(((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
EXIT_IF_ISNAN((((-Vbd_jct)/Vtm0)/NJTSSWGD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=bsimbulk_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-Vbd_jct)),((T0_Vdbulk_di*pModel->VTSSWGD*(pModel->VTSSWGD-Vbd_jct)-(T0*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+((+T0_Vdbulk_di_Vgm_di*pModel->VTSSWGD+T0_Vdbulk_di*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWGD*0.0+(T0_Vgm_di*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vgm_si=(+((+T0_Vdbulk_di_Vgm_si*pModel->VTSSWGD+T0_Vdbulk_di*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWGD*0.0+(T0_Vgm_si*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vdbulk_di=(+((+T0_Vdbulk_di_Vdbulk_di*pModel->VTSSWGD+T0_Vdbulk_di*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWGD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWGD)*(+0.0-Vbd_jct_Vdbulk_di_Vdbulk_di))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vsbulk_si=(+((+T0_Vdbulk_di_Vsbulk_si*pModel->VTSSWGD+T0_Vdbulk_di*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWGD*0.0+(T0_Vsbulk_si*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vgi_bi=(+((+T0_Vdbulk_di_Vgi_bi*pModel->VTSSWGD+T0_Vdbulk_di*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWGD*0.0+(T0_Vgi_bi*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vdi_bi=(+((+T0_Vdbulk_di_Vdi_bi*pModel->VTSSWGD+T0_Vdbulk_di*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWGD*0.0+(T0_Vdi_bi*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Vsi_bi=(+((+T0_Vdbulk_di_Vsi_bi*pModel->VTSSWGD+T0_Vdbulk_di*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWGD*0.0+(T0_Vsi_bi*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdbulk_di_Tempt_GND=(+((+T0_Vdbulk_di_Tempt_GND*pModel->VTSSWGD+T0_Vdbulk_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdbulk_di*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*(-Vbd_jct_Vdbulk_di)*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
#endif
T1_Vsbulk_si=bsimbulk_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-Vbd_jct)),(T0_Vsbulk_si*pModel->VTSSWGD/(pModel->VTSSWGD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di*pModel->VTSSWGD+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWGD*0.0+(T0_Vgm_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si*pModel->VTSSWGD+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWGD*0.0+(T0_Vgm_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di*pModel->VTSSWGD+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWGD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si*pModel->VTSSWGD+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWGD*0.0+(T0_Vsbulk_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi*pModel->VTSSWGD+T0_Vsbulk_si*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWGD*0.0+(T0_Vgi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi*pModel->VTSSWGD+T0_Vsbulk_si*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWGD*0.0+(T0_Vdi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi*pModel->VTSSWGD+T0_Vsbulk_si*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWGD*0.0+(T0_Vsi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND*pModel->VTSSWGD+T0_Vsbulk_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsbulk_si*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
#endif
T1_Vgi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-Vbd_jct)),(T0_Vgi_bi*pModel->VTSSWGD/(pModel->VTSSWGD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di*pModel->VTSSWGD+T0_Vgi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWGD*0.0+(T0_Vgm_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si*pModel->VTSSWGD+T0_Vgi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWGD*0.0+(T0_Vgm_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di*pModel->VTSSWGD+T0_Vgi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWGD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si*pModel->VTSSWGD+T0_Vgi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWGD*0.0+(T0_Vsbulk_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi*pModel->VTSSWGD+T0_Vgi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWGD*0.0+(T0_Vgi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi*pModel->VTSSWGD+T0_Vgi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWGD*0.0+(T0_Vdi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi*pModel->VTSSWGD+T0_Vgi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWGD*0.0+(T0_Vsi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND*pModel->VTSSWGD+T0_Vgi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vgi_bi*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
#endif
T1_Vdi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-Vbd_jct)),(T0_Vdi_bi*pModel->VTSSWGD/(pModel->VTSSWGD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di*pModel->VTSSWGD+T0_Vdi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWGD*0.0+(T0_Vgm_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si*pModel->VTSSWGD+T0_Vdi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWGD*0.0+(T0_Vgm_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di*pModel->VTSSWGD+T0_Vdi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWGD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si*pModel->VTSSWGD+T0_Vdi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWGD*0.0+(T0_Vsbulk_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi*pModel->VTSSWGD+T0_Vdi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWGD*0.0+(T0_Vgi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi*pModel->VTSSWGD+T0_Vdi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWGD*0.0+(T0_Vdi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi*pModel->VTSSWGD+T0_Vdi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWGD*0.0+(T0_Vsi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND*pModel->VTSSWGD+T0_Vdi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vdi_bi*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
#endif
T1_Vsi_bi=bsimbulk_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-Vbd_jct)),(T0_Vsi_bi*pModel->VTSSWGD/(pModel->VTSSWGD-Vbd_jct)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di*pModel->VTSSWGD+T0_Vsi_bi*0.0+T0_Vgm_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWGD*0.0+(T0_Vgm_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si*pModel->VTSSWGD+T0_Vsi_bi*0.0+T0_Vgm_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWGD*0.0+(T0_Vgm_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di*pModel->VTSSWGD+T0_Vsi_bi*0.0+T0_Vdbulk_di*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWGD*(-Vbd_jct_Vdbulk_di)+(T0_Vdbulk_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-Vbd_jct_Vdbulk_di)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si*pModel->VTSSWGD+T0_Vsi_bi*0.0+T0_Vsbulk_si*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWGD*0.0+(T0_Vsbulk_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi*pModel->VTSSWGD+T0_Vsi_bi*0.0+T0_Vgi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWGD*0.0+(T0_Vgi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi*pModel->VTSSWGD+T0_Vsi_bi*0.0+T0_Vdi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWGD*0.0+(T0_Vdi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi*pModel->VTSSWGD+T0_Vsi_bi*0.0+T0_Vsi_bi*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWGD*0.0+(T0_Vsi_bi*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
  T1_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND*pModel->VTSSWGD+T0_Vsi_bi*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-Vbd_jct)-(T0_Vsi_bi*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct)/(pModel->VTSSWGD-Vbd_jct))-0.0);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=bsimbulk_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-Vbd_jct)),(T0_Tempt_GND*pModel->VTSSWGD/(pModel->VTSSWGD-Vbd_jct)));
#endif
#endif
T1=(bsimbulk_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-Vbd_jct)))-1.0);
EXIT_IF_ISNAN((bsimbulk_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-Vbd_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ibd_Vdbulk_di=(Ibd_Vdbulk_di-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vdbulk_di));
Ibd_Vsbulk_si=(Ibd_Vsbulk_si-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vsbulk_si));
Ibd_Vgi_bi=(Ibd_Vgi_bi-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vgi_bi));
Ibd_Vdi_bi=(Ibd_Vdi_bi-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vdi_bi));
Ibd_Vsi_bi=(Ibd_Vsi_bi-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Vsi_bi));
Ibd_Tempt_GND=(Ibd_Tempt_GND-((((Weffcj*pInst->NF)*JTSSWGD_t_Tempt_GND)*T1)+(((Weffcj*pInst->NF)*JTSSWGD_t)*T1_Tempt_GND)));
#endif
Ibd=(Ibd-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1));
EXIT_IF_ISNAN((Ibd-(((Weffcj*pInst->NF)*JTSSWGD_t)*T1)))
}
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
Czbs_Tempt_GND=((CJS_t_Tempt_GND*ASeff)+(CJS_t*ASeff_Tempt_GND));
#endif
Czbs=(CJS_t*ASeff);
EXIT_IF_ISNAN((CJS_t*ASeff))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
Czbssw_Tempt_GND=((CJSWS_t_Tempt_GND*PSeff)+(CJSWS_t*PSeff_Tempt_GND));
#endif
Czbssw=(CJSWS_t*PSeff);
EXIT_IF_ISNAN((CJSWS_t*PSeff))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
Czbsswg_Tempt_GND=CJSWGS_t_Tempt_GND*Weffcj*pInst->NF;
#endif
Czbsswg=((CJSWGS_t*Weffcj)*pInst->NF);
EXIT_IF_ISNAN(((CJSWGS_t*Weffcj)*pInst->NF))
{
double m00_pow(d00_pow0,0.1,(-pModel->MJS))
czbs_p1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DYNAMIC)
czbs_p2=((1.0/(1.0-pModel->MJS))*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*czbs_p1)));
EXIT_IF_ISNAN(((1.0/(1.0-pModel->MJS))*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*czbs_p1))))
#endif
{
double m00_pow(d00_pow0,0.1,(-pModel->MJSWS))
czbssw_p1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DYNAMIC)
czbssw_p2=((1.0/(1.0-pModel->MJSWS))*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*czbssw_p1)));
EXIT_IF_ISNAN(((1.0/(1.0-pModel->MJSWS))*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*czbssw_p1))))
#endif
{
double m00_pow(d00_pow0,0.1,(-pModel->MJSWGS))
czbsswg_p1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DYNAMIC)
czbsswg_p2=((1.0/(1.0-pModel->MJSWGS))*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*czbsswg_p1)));
EXIT_IF_ISNAN(((1.0/(1.0-pModel->MJSWGS))*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*czbsswg_p1))))
#endif
if
((Czbs>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=(Vbs_jct_Vsbulk_si/PBS_t);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(0.0/PBS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBS_t/PBS_t+2*Vbs_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Vsbulk_si_Vgm_si=(0.0/PBS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBS_t/PBS_t+2*Vbs_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Vsbulk_si_Vdbulk_di=(0.0/PBS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBS_t/PBS_t+2*Vbs_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Vsbulk_si_Vsbulk_si=(Vbs_jct_Vsbulk_si_Vsbulk_si/PBS_t-(Vbs_jct_Vsbulk_si*0.0+Vbs_jct_Vsbulk_si*0.0+Vbs_jct*0.0)/PBS_t/PBS_t+2*Vbs_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Vsbulk_si_Vgi_bi=(0.0/PBS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBS_t/PBS_t+2*Vbs_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Vsbulk_si_Vdi_bi=(0.0/PBS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBS_t/PBS_t+2*Vbs_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Vsbulk_si_Vsi_bi=(0.0/PBS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBS_t/PBS_t+2*Vbs_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Vsbulk_si_Tempt_GND=(0.0/PBS_t-(Vbs_jct_Vsbulk_si*PBS_t_Tempt_GND+0.0*0.0+Vbs_jct*0.0)/PBS_t/PBS_t+2*Vbs_jct*0.0*PBS_t_Tempt_GND/PBS_t/PBS_t/PBS_t);
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-Vbs_jct*PBS_t_Tempt_GND/PBS_t/PBS_t);
#endif
#endif
T1=(Vbs_jct/PBS_t);
EXIT_IF_ISNAN((Vbs_jct/PBS_t))
if
((T1<0.9))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
arg_Vdbulk_di=(-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  arg_Vdbulk_di_Vdbulk_di=(+0.0-T1_Vdbulk_di_Vdbulk_di);
  arg_Vdbulk_di_Vsbulk_si=(+0.0-T1_Vdbulk_di_Vsbulk_si);
  arg_Vdbulk_di_Vgi_bi=(+0.0-T1_Vdbulk_di_Vgi_bi);
  arg_Vdbulk_di_Vdi_bi=(+0.0-T1_Vdbulk_di_Vdi_bi);
  arg_Vdbulk_di_Vsi_bi=(+0.0-T1_Vdbulk_di_Vsi_bi);
  arg_Vdbulk_di_Tempt_GND=(+0.0-T1_Vdbulk_di_Tempt_GND);
#endif
arg_Vsbulk_si=(-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  arg_Vsbulk_si_Vdbulk_di=(+0.0-T1_Vsbulk_si_Vdbulk_di);
  arg_Vsbulk_si_Vsbulk_si=(+0.0-T1_Vsbulk_si_Vsbulk_si);
  arg_Vsbulk_si_Vgi_bi=(+0.0-T1_Vsbulk_si_Vgi_bi);
  arg_Vsbulk_si_Vdi_bi=(+0.0-T1_Vsbulk_si_Vdi_bi);
  arg_Vsbulk_si_Vsi_bi=(+0.0-T1_Vsbulk_si_Vsi_bi);
  arg_Vsbulk_si_Tempt_GND=(+0.0-T1_Vsbulk_si_Tempt_GND);
#endif
arg_Vgi_bi=(-T1_Vgi_bi);
#if defined(_DERIVATE2)
  arg_Vgi_bi_Vdbulk_di=(+0.0-T1_Vgi_bi_Vdbulk_di);
  arg_Vgi_bi_Vsbulk_si=(+0.0-T1_Vgi_bi_Vsbulk_si);
  arg_Vgi_bi_Vgi_bi=(+0.0-T1_Vgi_bi_Vgi_bi);
  arg_Vgi_bi_Vdi_bi=(+0.0-T1_Vgi_bi_Vdi_bi);
  arg_Vgi_bi_Vsi_bi=(+0.0-T1_Vgi_bi_Vsi_bi);
  arg_Vgi_bi_Tempt_GND=(+0.0-T1_Vgi_bi_Tempt_GND);
#endif
arg_Vdi_bi=(-T1_Vdi_bi);
#if defined(_DERIVATE2)
  arg_Vdi_bi_Vdbulk_di=(+0.0-T1_Vdi_bi_Vdbulk_di);
  arg_Vdi_bi_Vsbulk_si=(+0.0-T1_Vdi_bi_Vsbulk_si);
  arg_Vdi_bi_Vgi_bi=(+0.0-T1_Vdi_bi_Vgi_bi);
  arg_Vdi_bi_Vdi_bi=(+0.0-T1_Vdi_bi_Vdi_bi);
  arg_Vdi_bi_Vsi_bi=(+0.0-T1_Vdi_bi_Vsi_bi);
  arg_Vdi_bi_Tempt_GND=(+0.0-T1_Vdi_bi_Tempt_GND);
#endif
arg_Vsi_bi=(-T1_Vsi_bi);
#if defined(_DERIVATE2)
  arg_Vsi_bi_Vdbulk_di=(+0.0-T1_Vsi_bi_Vdbulk_di);
  arg_Vsi_bi_Vsbulk_si=(+0.0-T1_Vsi_bi_Vsbulk_si);
  arg_Vsi_bi_Vgi_bi=(+0.0-T1_Vsi_bi_Vgi_bi);
  arg_Vsi_bi_Vdi_bi=(+0.0-T1_Vsi_bi_Vdi_bi);
  arg_Vsi_bi_Vsi_bi=(+0.0-T1_Vsi_bi_Vsi_bi);
  arg_Vsi_bi_Tempt_GND=(+0.0-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
arg_Tempt_GND=(-T1_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=(-arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsbulk_si=(-arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vgi_bi=(-arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_bi=(-arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsi_bi=(-arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=bsimbulk_d_lexp(((-pModel->MJS)*bsimbulk_lln(arg)),((-pModel->MJS)*bsimbulk_d_lln(arg,arg_Vdbulk_di)));
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJS)*arg_Vdbulk_di_Vdbulk_di);
  sarg_Vdbulk_di_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJS)*arg_Vdbulk_di_Vsbulk_si);
  sarg_Vdbulk_di_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJS)*arg_Vdbulk_di_Vgi_bi);
  sarg_Vdbulk_di_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJS)*arg_Vdbulk_di_Vdi_bi);
  sarg_Vdbulk_di_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJS)*arg_Vdbulk_di_Vsi_bi);
  sarg_Vdbulk_di_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJS)*arg_Vdbulk_di_Tempt_GND);
#endif
sarg_Vsbulk_si=bsimbulk_d_lexp(((-pModel->MJS)*bsimbulk_lln(arg)),((-pModel->MJS)*bsimbulk_d_lln(arg,arg_Vsbulk_si)));
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJS)*arg_Vsbulk_si_Vdbulk_di);
  sarg_Vsbulk_si_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJS)*arg_Vsbulk_si_Vsbulk_si);
  sarg_Vsbulk_si_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJS)*arg_Vsbulk_si_Vgi_bi);
  sarg_Vsbulk_si_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJS)*arg_Vsbulk_si_Vdi_bi);
  sarg_Vsbulk_si_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJS)*arg_Vsbulk_si_Vsi_bi);
  sarg_Vsbulk_si_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJS)*arg_Vsbulk_si_Tempt_GND);
#endif
sarg_Vgi_bi=bsimbulk_d_lexp(((-pModel->MJS)*bsimbulk_lln(arg)),((-pModel->MJS)*bsimbulk_d_lln(arg,arg_Vgi_bi)));
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJS)*arg_Vgi_bi_Vdbulk_di);
  sarg_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJS)*arg_Vgi_bi_Vsbulk_si);
  sarg_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJS)*arg_Vgi_bi_Vgi_bi);
  sarg_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJS)*arg_Vgi_bi_Vdi_bi);
  sarg_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJS)*arg_Vgi_bi_Vsi_bi);
  sarg_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJS)*arg_Vgi_bi_Tempt_GND);
#endif
sarg_Vdi_bi=bsimbulk_d_lexp(((-pModel->MJS)*bsimbulk_lln(arg)),((-pModel->MJS)*bsimbulk_d_lln(arg,arg_Vdi_bi)));
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJS)*arg_Vdi_bi_Vdbulk_di);
  sarg_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJS)*arg_Vdi_bi_Vsbulk_si);
  sarg_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJS)*arg_Vdi_bi_Vgi_bi);
  sarg_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJS)*arg_Vdi_bi_Vdi_bi);
  sarg_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJS)*arg_Vdi_bi_Vsi_bi);
  sarg_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJS)*arg_Vdi_bi_Tempt_GND);
#endif
sarg_Vsi_bi=bsimbulk_d_lexp(((-pModel->MJS)*bsimbulk_lln(arg)),((-pModel->MJS)*bsimbulk_d_lln(arg,arg_Vsi_bi)));
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJS)*arg_Vsi_bi_Vdbulk_di);
  sarg_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJS)*arg_Vsi_bi_Vsbulk_si);
  sarg_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJS)*arg_Vsi_bi_Vgi_bi);
  sarg_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJS)*arg_Vsi_bi_Vdi_bi);
  sarg_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJS)*arg_Vsi_bi_Vsi_bi);
  sarg_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJS)*arg_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=bsimbulk_d_lexp(((-pModel->MJS)*bsimbulk_lln(arg)),((-pModel->MJS)*bsimbulk_d_lln(arg,arg_Tempt_GND)));
#endif
#endif
sarg=bsimbulk_lexp(((-pModel->MJS)*bsimbulk_lln(arg)));
EXIT_IF_ISNAN(bsimbulk_lexp(((-pModel->MJS)*bsimbulk_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Qbsj1_Tempt_GND=(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJS));
#endif
Qbsj1_Vdbulk_di=(((PBS_t*Czbs)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qbsj1_Vdbulk_di_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdbulk_di_Tempt_GND*sarg+arg_Vdbulk_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdbulk_di_Vdbulk_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdbulk_di_Vdbulk_di*sarg+arg_Vdbulk_di*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdbulk_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdbulk_di_Vsbulk_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdbulk_di_Vsbulk_si*sarg+arg_Vdbulk_di*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsbulk_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdbulk_di_Vgi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdbulk_di_Vgi_bi*sarg+arg_Vdbulk_di*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vgi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdbulk_di_Vdi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdbulk_di_Vdi_bi*sarg+arg_Vdbulk_di*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdbulk_di_Vsi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdbulk_di_Vsi_bi*sarg+arg_Vdbulk_di*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qbsj1_Vsbulk_si=(((PBS_t*Czbs)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qbsj1_Vsbulk_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsbulk_si_Tempt_GND*sarg+arg_Vsbulk_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsbulk_si_Vdbulk_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsbulk_si_Vdbulk_di*sarg+arg_Vsbulk_si*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdbulk_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsbulk_si_Vsbulk_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsbulk_si_Vsbulk_si*sarg+arg_Vsbulk_si*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsbulk_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsbulk_si_Vgi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsbulk_si_Vgi_bi*sarg+arg_Vsbulk_si*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vgi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsbulk_si_Vdi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsbulk_si_Vdi_bi*sarg+arg_Vsbulk_si*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsbulk_si_Vsi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsbulk_si_Vsi_bi*sarg+arg_Vsbulk_si*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qbsj1_Vgi_bi=(((PBS_t*Czbs)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qbsj1_Vgi_bi_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vgi_bi_Tempt_GND*sarg+arg_Vgi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vgi_bi+arg*sarg_Vgi_bi_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vgi_bi_Vdbulk_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vgi_bi_Vdbulk_di*sarg+arg_Vgi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdbulk_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vgi_bi_Vsbulk_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vgi_bi_Vsbulk_si*sarg+arg_Vgi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsbulk_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vgi_bi_Vgi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vgi_bi_Vgi_bi*sarg+arg_Vgi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vgi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vgi_bi_Vdi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vgi_bi_Vdi_bi*sarg+arg_Vgi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vgi_bi_Vsi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vgi_bi_Vsi_bi*sarg+arg_Vgi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qbsj1_Vdi_bi=(((PBS_t*Czbs)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qbsj1_Vdi_bi_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_bi_Tempt_GND*sarg+arg_Vdi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_bi+arg*sarg_Vdi_bi_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdi_bi_Vdbulk_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_bi_Vdbulk_di*sarg+arg_Vdi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdbulk_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdi_bi_Vsbulk_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_bi_Vsbulk_si*sarg+arg_Vdi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsbulk_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdi_bi_Vgi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_bi_Vgi_bi*sarg+arg_Vdi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vgi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdi_bi_Vdi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_bi_Vdi_bi*sarg+arg_Vdi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vdi_bi_Vsi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_bi_Vsi_bi*sarg+arg_Vdi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qbsj1_Vsi_bi=(((PBS_t*Czbs)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qbsj1_Vsi_bi_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsi_bi_Tempt_GND*sarg+arg_Vsi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsi_bi+arg*sarg_Vsi_bi_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsi_bi_Vdbulk_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsi_bi_Vdbulk_di*sarg+arg_Vsi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdbulk_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsi_bi_Vsbulk_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsi_bi_Vsbulk_si*sarg+arg_Vsi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsbulk_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsi_bi_Vgi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsi_bi_Vgi_bi*sarg+arg_Vsi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vgi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsi_bi_Vdi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsi_bi_Vdi_bi*sarg+arg_Vsi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qbsj1_Vsi_bi_Vsi_bi=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBS_t*Czbs)*(+0.0-(+arg_Vsi_bi_Vsi_bi*sarg+arg_Vsi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsi_bi)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
#endif
Qbsj1=(((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS));
EXIT_IF_ISNAN((((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS)))
#endif
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((czbs_p1*T1_Vdbulk_di)*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((czbs_p1*(T1-1.0))*((5.0*pModel->MJS)*T1_Vdbulk_di)));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdbulk_di+czbs_p1*(+T1_Vdbulk_di_Vgm_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_di)))+((czbs_p1*T1_Vgm_di))*((5.0*pModel->MJS)*T1_Vdbulk_di)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJS)*(+T1_Vdbulk_di_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+czbs_p1*(+T1_Vdbulk_di_Vgm_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_si)))+((czbs_p1*T1_Vgm_si))*((5.0*pModel->MJS)*T1_Vdbulk_di)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJS)*(+T1_Vdbulk_di_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+czbs_p1*(+T1_Vdbulk_di_Vdbulk_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdbulk_di)))+((czbs_p1*T1_Vdbulk_di))*((5.0*pModel->MJS)*T1_Vdbulk_di)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJS)*(+T1_Vdbulk_di_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+czbs_p1*(+T1_Vdbulk_di_Vsbulk_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsbulk_si)))+((czbs_p1*T1_Vsbulk_si))*((5.0*pModel->MJS)*T1_Vdbulk_di)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJS)*(+T1_Vdbulk_di_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdbulk_di+czbs_p1*(+T1_Vdbulk_di_Vgi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgi_bi)))+((czbs_p1*T1_Vgi_bi))*((5.0*pModel->MJS)*T1_Vdbulk_di)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJS)*(+T1_Vdbulk_di_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdbulk_di+czbs_p1*(+T1_Vdbulk_di_Vdi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_bi)))+((czbs_p1*T1_Vdi_bi))*((5.0*pModel->MJS)*T1_Vdbulk_di)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJS)*(+T1_Vdbulk_di_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdbulk_di+czbs_p1*(+T1_Vdbulk_di_Vsi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsi_bi)))+((czbs_p1*T1_Vsi_bi))*((5.0*pModel->MJS)*T1_Vdbulk_di)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJS)*(+T1_Vdbulk_di_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdbulk_di+czbs_p1*(+T1_Vdbulk_di_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+((czbs_p1*T1_Tempt_GND))*((5.0*pModel->MJS)*T1_Vdbulk_di)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJS)*(+T1_Vdbulk_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsbulk_si=(((czbs_p1*T1_Vsbulk_si)*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((czbs_p1*(T1-1.0))*((5.0*pModel->MJS)*T1_Vsbulk_si)));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsbulk_si+czbs_p1*(+T1_Vsbulk_si_Vgm_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_di)))+((czbs_p1*T1_Vgm_di))*((5.0*pModel->MJS)*T1_Vsbulk_si)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJS)*(+T1_Vsbulk_si_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+czbs_p1*(+T1_Vsbulk_si_Vgm_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_si)))+((czbs_p1*T1_Vgm_si))*((5.0*pModel->MJS)*T1_Vsbulk_si)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJS)*(+T1_Vsbulk_si_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+czbs_p1*(+T1_Vsbulk_si_Vdbulk_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdbulk_di)))+((czbs_p1*T1_Vdbulk_di))*((5.0*pModel->MJS)*T1_Vsbulk_si)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJS)*(+T1_Vsbulk_si_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+czbs_p1*(+T1_Vsbulk_si_Vsbulk_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsbulk_si)))+((czbs_p1*T1_Vsbulk_si))*((5.0*pModel->MJS)*T1_Vsbulk_si)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJS)*(+T1_Vsbulk_si_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsbulk_si+czbs_p1*(+T1_Vsbulk_si_Vgi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgi_bi)))+((czbs_p1*T1_Vgi_bi))*((5.0*pModel->MJS)*T1_Vsbulk_si)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJS)*(+T1_Vsbulk_si_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsbulk_si+czbs_p1*(+T1_Vsbulk_si_Vdi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_bi)))+((czbs_p1*T1_Vdi_bi))*((5.0*pModel->MJS)*T1_Vsbulk_si)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJS)*(+T1_Vsbulk_si_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsbulk_si+czbs_p1*(+T1_Vsbulk_si_Vsi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsi_bi)))+((czbs_p1*T1_Vsi_bi))*((5.0*pModel->MJS)*T1_Vsbulk_si)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJS)*(+T1_Vsbulk_si_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsbulk_si+czbs_p1*(+T1_Vsbulk_si_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+((czbs_p1*T1_Tempt_GND))*((5.0*pModel->MJS)*T1_Vsbulk_si)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJS)*(+T1_Vsbulk_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vgi_bi=(((czbs_p1*T1_Vgi_bi)*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((czbs_p1*(T1-1.0))*((5.0*pModel->MJS)*T1_Vgi_bi)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+czbs_p1*(+T1_Vgi_bi_Vgm_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_di)))+((czbs_p1*T1_Vgm_di))*((5.0*pModel->MJS)*T1_Vgi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJS)*(+T1_Vgi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+czbs_p1*(+T1_Vgi_bi_Vgm_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_si)))+((czbs_p1*T1_Vgm_si))*((5.0*pModel->MJS)*T1_Vgi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJS)*(+T1_Vgi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+czbs_p1*(+T1_Vgi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdbulk_di)))+((czbs_p1*T1_Vdbulk_di))*((5.0*pModel->MJS)*T1_Vgi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJS)*(+T1_Vgi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+czbs_p1*(+T1_Vgi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsbulk_si)))+((czbs_p1*T1_Vsbulk_si))*((5.0*pModel->MJS)*T1_Vgi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJS)*(+T1_Vgi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+czbs_p1*(+T1_Vgi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgi_bi)))+((czbs_p1*T1_Vgi_bi))*((5.0*pModel->MJS)*T1_Vgi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJS)*(+T1_Vgi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+czbs_p1*(+T1_Vgi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_bi)))+((czbs_p1*T1_Vdi_bi))*((5.0*pModel->MJS)*T1_Vgi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJS)*(+T1_Vgi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+czbs_p1*(+T1_Vgi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsi_bi)))+((czbs_p1*T1_Vsi_bi))*((5.0*pModel->MJS)*T1_Vgi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJS)*(+T1_Vgi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+czbs_p1*(+T1_Vgi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+((czbs_p1*T1_Tempt_GND))*((5.0*pModel->MJS)*T1_Vgi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(5.0*pModel->MJS)*(+T1_Vgi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vdi_bi=(((czbs_p1*T1_Vdi_bi)*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((czbs_p1*(T1-1.0))*((5.0*pModel->MJS)*T1_Vdi_bi)));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+czbs_p1*(+T1_Vdi_bi_Vgm_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_di)))+((czbs_p1*T1_Vgm_di))*((5.0*pModel->MJS)*T1_Vdi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJS)*(+T1_Vdi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+czbs_p1*(+T1_Vdi_bi_Vgm_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_si)))+((czbs_p1*T1_Vgm_si))*((5.0*pModel->MJS)*T1_Vdi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJS)*(+T1_Vdi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+czbs_p1*(+T1_Vdi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdbulk_di)))+((czbs_p1*T1_Vdbulk_di))*((5.0*pModel->MJS)*T1_Vdi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJS)*(+T1_Vdi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+czbs_p1*(+T1_Vdi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsbulk_si)))+((czbs_p1*T1_Vsbulk_si))*((5.0*pModel->MJS)*T1_Vdi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJS)*(+T1_Vdi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+czbs_p1*(+T1_Vdi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgi_bi)))+((czbs_p1*T1_Vgi_bi))*((5.0*pModel->MJS)*T1_Vdi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJS)*(+T1_Vdi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+czbs_p1*(+T1_Vdi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_bi)))+((czbs_p1*T1_Vdi_bi))*((5.0*pModel->MJS)*T1_Vdi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJS)*(+T1_Vdi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+czbs_p1*(+T1_Vdi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsi_bi)))+((czbs_p1*T1_Vsi_bi))*((5.0*pModel->MJS)*T1_Vdi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJS)*(+T1_Vdi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+czbs_p1*(+T1_Vdi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+((czbs_p1*T1_Tempt_GND))*((5.0*pModel->MJS)*T1_Vdi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(5.0*pModel->MJS)*(+T1_Vdi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsi_bi=(((czbs_p1*T1_Vsi_bi)*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((czbs_p1*(T1-1.0))*((5.0*pModel->MJS)*T1_Vsi_bi)));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+czbs_p1*(+T1_Vsi_bi_Vgm_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_di)))+((czbs_p1*T1_Vgm_di))*((5.0*pModel->MJS)*T1_Vsi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJS)*(+T1_Vsi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+czbs_p1*(+T1_Vsi_bi_Vgm_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgm_si)))+((czbs_p1*T1_Vgm_si))*((5.0*pModel->MJS)*T1_Vsi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJS)*(+T1_Vsi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+czbs_p1*(+T1_Vsi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdbulk_di)))+((czbs_p1*T1_Vdbulk_di))*((5.0*pModel->MJS)*T1_Vsi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJS)*(+T1_Vsi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+czbs_p1*(+T1_Vsi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsbulk_si)))+((czbs_p1*T1_Vsbulk_si))*((5.0*pModel->MJS)*T1_Vsi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJS)*(+T1_Vsi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+czbs_p1*(+T1_Vsi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vgi_bi)))+((czbs_p1*T1_Vgi_bi))*((5.0*pModel->MJS)*T1_Vsi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJS)*(+T1_Vsi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+czbs_p1*(+T1_Vsi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_bi)))+((czbs_p1*T1_Vdi_bi))*((5.0*pModel->MJS)*T1_Vsi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJS)*(+T1_Vsi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+czbs_p1*(+T1_Vsi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vsi_bi)))+((czbs_p1*T1_Vsi_bi))*((5.0*pModel->MJS)*T1_Vsi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJS)*(+T1_Vsi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+czbs_p1*(+T1_Vsi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+(czbs_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+((czbs_p1*T1_Tempt_GND))*((5.0*pModel->MJS)*T1_Vsi_bi)+(czbs_p1*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(5.0*pModel->MJS)*(+T1_Vsi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((czbs_p1*T1_Tempt_GND)*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((czbs_p1*(T1-1.0))*((5.0*pModel->MJS)*T1_Tempt_GND)));
#endif
#endif
T2=((czbs_p1*(T1-1.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)));
EXIT_IF_ISNAN(((czbs_p1*(T1-1.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Qbsj1_Tempt_GND=((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(T2+czbs_p2))+((PBS_t*Czbs)*T2_Tempt_GND));
#endif
Qbsj1_Vdbulk_di=((PBS_t*Czbs)*T2_Vdbulk_di);
#if defined(_DERIVATE2)
  Qbsj1_Vdbulk_di_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Tempt_GND+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*T2_Vdbulk_di+(PBS_t*Czbs)*(+T2_Vdbulk_di_Tempt_GND+0.0));
  Qbsj1_Vdbulk_di_Vdbulk_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdbulk_di+(PBS_t*Czbs)*(+T2_Vdbulk_di_Vdbulk_di+0.0));
  Qbsj1_Vdbulk_di_Vsbulk_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdbulk_di+(PBS_t*Czbs)*(+T2_Vdbulk_di_Vsbulk_si+0.0));
  Qbsj1_Vdbulk_di_Vgi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdbulk_di+(PBS_t*Czbs)*(+T2_Vdbulk_di_Vgi_bi+0.0));
  Qbsj1_Vdbulk_di_Vdi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdbulk_di+(PBS_t*Czbs)*(+T2_Vdbulk_di_Vdi_bi+0.0));
  Qbsj1_Vdbulk_di_Vsi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdbulk_di+(PBS_t*Czbs)*(+T2_Vdbulk_di_Vsi_bi+0.0));
#endif
Qbsj1_Vsbulk_si=((PBS_t*Czbs)*T2_Vsbulk_si);
#if defined(_DERIVATE2)
  Qbsj1_Vsbulk_si_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Tempt_GND+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*T2_Vsbulk_si+(PBS_t*Czbs)*(+T2_Vsbulk_si_Tempt_GND+0.0));
  Qbsj1_Vsbulk_si_Vdbulk_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsbulk_si+(PBS_t*Czbs)*(+T2_Vsbulk_si_Vdbulk_di+0.0));
  Qbsj1_Vsbulk_si_Vsbulk_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsbulk_si+(PBS_t*Czbs)*(+T2_Vsbulk_si_Vsbulk_si+0.0));
  Qbsj1_Vsbulk_si_Vgi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsbulk_si+(PBS_t*Czbs)*(+T2_Vsbulk_si_Vgi_bi+0.0));
  Qbsj1_Vsbulk_si_Vdi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsbulk_si+(PBS_t*Czbs)*(+T2_Vsbulk_si_Vdi_bi+0.0));
  Qbsj1_Vsbulk_si_Vsi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsbulk_si+(PBS_t*Czbs)*(+T2_Vsbulk_si_Vsi_bi+0.0));
#endif
Qbsj1_Vgi_bi=((PBS_t*Czbs)*T2_Vgi_bi);
#if defined(_DERIVATE2)
  Qbsj1_Vgi_bi_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Tempt_GND+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*T2_Vgi_bi+(PBS_t*Czbs)*(+T2_Vgi_bi_Tempt_GND+0.0));
  Qbsj1_Vgi_bi_Vdbulk_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vgi_bi+(PBS_t*Czbs)*(+T2_Vgi_bi_Vdbulk_di+0.0));
  Qbsj1_Vgi_bi_Vsbulk_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vgi_bi+(PBS_t*Czbs)*(+T2_Vgi_bi_Vsbulk_si+0.0));
  Qbsj1_Vgi_bi_Vgi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vgi_bi+(PBS_t*Czbs)*(+T2_Vgi_bi_Vgi_bi+0.0));
  Qbsj1_Vgi_bi_Vdi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vgi_bi+(PBS_t*Czbs)*(+T2_Vgi_bi_Vdi_bi+0.0));
  Qbsj1_Vgi_bi_Vsi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vgi_bi+(PBS_t*Czbs)*(+T2_Vgi_bi_Vsi_bi+0.0));
#endif
Qbsj1_Vdi_bi=((PBS_t*Czbs)*T2_Vdi_bi);
#if defined(_DERIVATE2)
  Qbsj1_Vdi_bi_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Tempt_GND+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*T2_Vdi_bi+(PBS_t*Czbs)*(+T2_Vdi_bi_Tempt_GND+0.0));
  Qbsj1_Vdi_bi_Vdbulk_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdi_bi+(PBS_t*Czbs)*(+T2_Vdi_bi_Vdbulk_di+0.0));
  Qbsj1_Vdi_bi_Vsbulk_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdi_bi+(PBS_t*Czbs)*(+T2_Vdi_bi_Vsbulk_si+0.0));
  Qbsj1_Vdi_bi_Vgi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdi_bi+(PBS_t*Czbs)*(+T2_Vdi_bi_Vgi_bi+0.0));
  Qbsj1_Vdi_bi_Vdi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdi_bi+(PBS_t*Czbs)*(+T2_Vdi_bi_Vdi_bi+0.0));
  Qbsj1_Vdi_bi_Vsi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdi_bi+(PBS_t*Czbs)*(+T2_Vdi_bi_Vsi_bi+0.0));
#endif
Qbsj1_Vsi_bi=((PBS_t*Czbs)*T2_Vsi_bi);
#if defined(_DERIVATE2)
  Qbsj1_Vsi_bi_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Tempt_GND+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*T2_Vsi_bi+(PBS_t*Czbs)*(+T2_Vsi_bi_Tempt_GND+0.0));
  Qbsj1_Vsi_bi_Vdbulk_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsi_bi+(PBS_t*Czbs)*(+T2_Vsi_bi_Vdbulk_di+0.0));
  Qbsj1_Vsi_bi_Vsbulk_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsi_bi+(PBS_t*Czbs)*(+T2_Vsi_bi_Vsbulk_si+0.0));
  Qbsj1_Vsi_bi_Vgi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsi_bi+(PBS_t*Czbs)*(+T2_Vsi_bi_Vgi_bi+0.0));
  Qbsj1_Vsi_bi_Vdi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsi_bi+(PBS_t*Czbs)*(+T2_Vsi_bi_Vdi_bi+0.0));
  Qbsj1_Vsi_bi_Vsi_bi=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T2+czbs_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsi_bi+(PBS_t*Czbs)*(+T2_Vsi_bi_Vsi_bi+0.0));
#endif
#endif
Qbsj1=((PBS_t*Czbs)*(T2+czbs_p2));
EXIT_IF_ISNAN(((PBS_t*Czbs)*(T2+czbs_p2)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Qbsj1_Tempt_GND=0.0;
#endif
Qbsj1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qbsj1_Vdbulk_di_Tempt_GND=0.0;
  Qbsj1_Vdbulk_di_Vdbulk_di=0.0;
  Qbsj1_Vdbulk_di_Vsbulk_si=0.0;
  Qbsj1_Vdbulk_di_Vgi_bi=0.0;
  Qbsj1_Vdbulk_di_Vdi_bi=0.0;
  Qbsj1_Vdbulk_di_Vsi_bi=0.0;
#endif
Qbsj1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qbsj1_Vsbulk_si_Tempt_GND=0.0;
  Qbsj1_Vsbulk_si_Vdbulk_di=0.0;
  Qbsj1_Vsbulk_si_Vsbulk_si=0.0;
  Qbsj1_Vsbulk_si_Vgi_bi=0.0;
  Qbsj1_Vsbulk_si_Vdi_bi=0.0;
  Qbsj1_Vsbulk_si_Vsi_bi=0.0;
#endif
Qbsj1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Qbsj1_Vgi_bi_Tempt_GND=0.0;
  Qbsj1_Vgi_bi_Vdbulk_di=0.0;
  Qbsj1_Vgi_bi_Vsbulk_si=0.0;
  Qbsj1_Vgi_bi_Vgi_bi=0.0;
  Qbsj1_Vgi_bi_Vdi_bi=0.0;
  Qbsj1_Vgi_bi_Vsi_bi=0.0;
#endif
Qbsj1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Qbsj1_Vdi_bi_Tempt_GND=0.0;
  Qbsj1_Vdi_bi_Vdbulk_di=0.0;
  Qbsj1_Vdi_bi_Vsbulk_si=0.0;
  Qbsj1_Vdi_bi_Vgi_bi=0.0;
  Qbsj1_Vdi_bi_Vdi_bi=0.0;
  Qbsj1_Vdi_bi_Vsi_bi=0.0;
#endif
Qbsj1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Qbsj1_Vsi_bi_Tempt_GND=0.0;
  Qbsj1_Vsi_bi_Vdbulk_di=0.0;
  Qbsj1_Vsi_bi_Vsbulk_si=0.0;
  Qbsj1_Vsi_bi_Vgi_bi=0.0;
  Qbsj1_Vsi_bi_Vdi_bi=0.0;
  Qbsj1_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
Qbsj1=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
if
((Czbssw>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=(Vbs_jct_Vsbulk_si/PBSWS_t);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(0.0/PBSWS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWS_t/PBSWS_t+2*Vbs_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Vsbulk_si_Vgm_si=(0.0/PBSWS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWS_t/PBSWS_t+2*Vbs_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Vsbulk_si_Vdbulk_di=(0.0/PBSWS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWS_t/PBSWS_t+2*Vbs_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Vsbulk_si_Vsbulk_si=(Vbs_jct_Vsbulk_si_Vsbulk_si/PBSWS_t-(Vbs_jct_Vsbulk_si*0.0+Vbs_jct_Vsbulk_si*0.0+Vbs_jct*0.0)/PBSWS_t/PBSWS_t+2*Vbs_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Vsbulk_si_Vgi_bi=(0.0/PBSWS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWS_t/PBSWS_t+2*Vbs_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Vsbulk_si_Vdi_bi=(0.0/PBSWS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWS_t/PBSWS_t+2*Vbs_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Vsbulk_si_Vsi_bi=(0.0/PBSWS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWS_t/PBSWS_t+2*Vbs_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Vsbulk_si_Tempt_GND=(0.0/PBSWS_t-(Vbs_jct_Vsbulk_si*PBSWS_t_Tempt_GND+0.0*0.0+Vbs_jct*0.0)/PBSWS_t/PBSWS_t+2*Vbs_jct*0.0*PBSWS_t_Tempt_GND/PBSWS_t/PBSWS_t/PBSWS_t);
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-Vbs_jct*PBSWS_t_Tempt_GND/PBSWS_t/PBSWS_t);
#endif
#endif
T1=(Vbs_jct/PBSWS_t);
EXIT_IF_ISNAN((Vbs_jct/PBSWS_t))
if
((T1<0.9))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
arg_Vdbulk_di=(-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  arg_Vdbulk_di_Vdbulk_di=(+0.0-T1_Vdbulk_di_Vdbulk_di);
  arg_Vdbulk_di_Vsbulk_si=(+0.0-T1_Vdbulk_di_Vsbulk_si);
  arg_Vdbulk_di_Vgi_bi=(+0.0-T1_Vdbulk_di_Vgi_bi);
  arg_Vdbulk_di_Vdi_bi=(+0.0-T1_Vdbulk_di_Vdi_bi);
  arg_Vdbulk_di_Vsi_bi=(+0.0-T1_Vdbulk_di_Vsi_bi);
  arg_Vdbulk_di_Tempt_GND=(+0.0-T1_Vdbulk_di_Tempt_GND);
#endif
arg_Vsbulk_si=(-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  arg_Vsbulk_si_Vdbulk_di=(+0.0-T1_Vsbulk_si_Vdbulk_di);
  arg_Vsbulk_si_Vsbulk_si=(+0.0-T1_Vsbulk_si_Vsbulk_si);
  arg_Vsbulk_si_Vgi_bi=(+0.0-T1_Vsbulk_si_Vgi_bi);
  arg_Vsbulk_si_Vdi_bi=(+0.0-T1_Vsbulk_si_Vdi_bi);
  arg_Vsbulk_si_Vsi_bi=(+0.0-T1_Vsbulk_si_Vsi_bi);
  arg_Vsbulk_si_Tempt_GND=(+0.0-T1_Vsbulk_si_Tempt_GND);
#endif
arg_Vgi_bi=(-T1_Vgi_bi);
#if defined(_DERIVATE2)
  arg_Vgi_bi_Vdbulk_di=(+0.0-T1_Vgi_bi_Vdbulk_di);
  arg_Vgi_bi_Vsbulk_si=(+0.0-T1_Vgi_bi_Vsbulk_si);
  arg_Vgi_bi_Vgi_bi=(+0.0-T1_Vgi_bi_Vgi_bi);
  arg_Vgi_bi_Vdi_bi=(+0.0-T1_Vgi_bi_Vdi_bi);
  arg_Vgi_bi_Vsi_bi=(+0.0-T1_Vgi_bi_Vsi_bi);
  arg_Vgi_bi_Tempt_GND=(+0.0-T1_Vgi_bi_Tempt_GND);
#endif
arg_Vdi_bi=(-T1_Vdi_bi);
#if defined(_DERIVATE2)
  arg_Vdi_bi_Vdbulk_di=(+0.0-T1_Vdi_bi_Vdbulk_di);
  arg_Vdi_bi_Vsbulk_si=(+0.0-T1_Vdi_bi_Vsbulk_si);
  arg_Vdi_bi_Vgi_bi=(+0.0-T1_Vdi_bi_Vgi_bi);
  arg_Vdi_bi_Vdi_bi=(+0.0-T1_Vdi_bi_Vdi_bi);
  arg_Vdi_bi_Vsi_bi=(+0.0-T1_Vdi_bi_Vsi_bi);
  arg_Vdi_bi_Tempt_GND=(+0.0-T1_Vdi_bi_Tempt_GND);
#endif
arg_Vsi_bi=(-T1_Vsi_bi);
#if defined(_DERIVATE2)
  arg_Vsi_bi_Vdbulk_di=(+0.0-T1_Vsi_bi_Vdbulk_di);
  arg_Vsi_bi_Vsbulk_si=(+0.0-T1_Vsi_bi_Vsbulk_si);
  arg_Vsi_bi_Vgi_bi=(+0.0-T1_Vsi_bi_Vgi_bi);
  arg_Vsi_bi_Vdi_bi=(+0.0-T1_Vsi_bi_Vdi_bi);
  arg_Vsi_bi_Vsi_bi=(+0.0-T1_Vsi_bi_Vsi_bi);
  arg_Vsi_bi_Tempt_GND=(+0.0-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
arg_Tempt_GND=(-T1_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=(-arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsbulk_si=(-arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vgi_bi=(-arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_bi=(-arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsi_bi=(-arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=bsimbulk_d_lexp(((-pModel->MJSWS)*bsimbulk_lln(arg)),((-pModel->MJSWS)*bsimbulk_d_lln(arg,arg_Vdbulk_di)));
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWS)*arg_Vdbulk_di_Vdbulk_di);
  sarg_Vdbulk_di_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWS)*arg_Vdbulk_di_Vsbulk_si);
  sarg_Vdbulk_di_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWS)*arg_Vdbulk_di_Vgi_bi);
  sarg_Vdbulk_di_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWS)*arg_Vdbulk_di_Vdi_bi);
  sarg_Vdbulk_di_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWS)*arg_Vdbulk_di_Vsi_bi);
  sarg_Vdbulk_di_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWS)*arg_Vdbulk_di_Tempt_GND);
#endif
sarg_Vsbulk_si=bsimbulk_d_lexp(((-pModel->MJSWS)*bsimbulk_lln(arg)),((-pModel->MJSWS)*bsimbulk_d_lln(arg,arg_Vsbulk_si)));
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWS)*arg_Vsbulk_si_Vdbulk_di);
  sarg_Vsbulk_si_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWS)*arg_Vsbulk_si_Vsbulk_si);
  sarg_Vsbulk_si_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWS)*arg_Vsbulk_si_Vgi_bi);
  sarg_Vsbulk_si_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWS)*arg_Vsbulk_si_Vdi_bi);
  sarg_Vsbulk_si_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWS)*arg_Vsbulk_si_Vsi_bi);
  sarg_Vsbulk_si_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWS)*arg_Vsbulk_si_Tempt_GND);
#endif
sarg_Vgi_bi=bsimbulk_d_lexp(((-pModel->MJSWS)*bsimbulk_lln(arg)),((-pModel->MJSWS)*bsimbulk_d_lln(arg,arg_Vgi_bi)));
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWS)*arg_Vgi_bi_Vdbulk_di);
  sarg_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWS)*arg_Vgi_bi_Vsbulk_si);
  sarg_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWS)*arg_Vgi_bi_Vgi_bi);
  sarg_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWS)*arg_Vgi_bi_Vdi_bi);
  sarg_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWS)*arg_Vgi_bi_Vsi_bi);
  sarg_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWS)*arg_Vgi_bi_Tempt_GND);
#endif
sarg_Vdi_bi=bsimbulk_d_lexp(((-pModel->MJSWS)*bsimbulk_lln(arg)),((-pModel->MJSWS)*bsimbulk_d_lln(arg,arg_Vdi_bi)));
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWS)*arg_Vdi_bi_Vdbulk_di);
  sarg_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWS)*arg_Vdi_bi_Vsbulk_si);
  sarg_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWS)*arg_Vdi_bi_Vgi_bi);
  sarg_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWS)*arg_Vdi_bi_Vdi_bi);
  sarg_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWS)*arg_Vdi_bi_Vsi_bi);
  sarg_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWS)*arg_Vdi_bi_Tempt_GND);
#endif
sarg_Vsi_bi=bsimbulk_d_lexp(((-pModel->MJSWS)*bsimbulk_lln(arg)),((-pModel->MJSWS)*bsimbulk_d_lln(arg,arg_Vsi_bi)));
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWS)*arg_Vsi_bi_Vdbulk_di);
  sarg_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWS)*arg_Vsi_bi_Vsbulk_si);
  sarg_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWS)*arg_Vsi_bi_Vgi_bi);
  sarg_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWS)*arg_Vsi_bi_Vdi_bi);
  sarg_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWS)*arg_Vsi_bi_Vsi_bi);
  sarg_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWS)*arg_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=bsimbulk_d_lexp(((-pModel->MJSWS)*bsimbulk_lln(arg)),((-pModel->MJSWS)*bsimbulk_d_lln(arg,arg_Tempt_GND)));
#endif
#endif
sarg=bsimbulk_lexp(((-pModel->MJSWS)*bsimbulk_lln(arg)));
EXIT_IF_ISNAN(bsimbulk_lexp(((-pModel->MJSWS)*bsimbulk_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Qbsj2_Tempt_GND=(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWS));
#endif
Qbsj2_Vdbulk_di=(((PBSWS_t*Czbssw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qbsj2_Vdbulk_di_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdbulk_di_Tempt_GND*sarg+arg_Vdbulk_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdbulk_di_Vdbulk_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdbulk_di_Vdbulk_di*sarg+arg_Vdbulk_di*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdbulk_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdbulk_di_Vsbulk_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdbulk_di_Vsbulk_si*sarg+arg_Vdbulk_di*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsbulk_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdbulk_di_Vgi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdbulk_di_Vgi_bi*sarg+arg_Vdbulk_di*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vgi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdbulk_di_Vdi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdbulk_di_Vdi_bi*sarg+arg_Vdbulk_di*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdbulk_di_Vsi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdbulk_di_Vsi_bi*sarg+arg_Vdbulk_di*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qbsj2_Vsbulk_si=(((PBSWS_t*Czbssw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qbsj2_Vsbulk_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsbulk_si_Tempt_GND*sarg+arg_Vsbulk_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsbulk_si_Vdbulk_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsbulk_si_Vdbulk_di*sarg+arg_Vsbulk_si*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdbulk_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsbulk_si_Vsbulk_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsbulk_si_Vsbulk_si*sarg+arg_Vsbulk_si*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsbulk_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsbulk_si_Vgi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsbulk_si_Vgi_bi*sarg+arg_Vsbulk_si*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vgi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsbulk_si_Vdi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsbulk_si_Vdi_bi*sarg+arg_Vsbulk_si*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsbulk_si_Vsi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsbulk_si_Vsi_bi*sarg+arg_Vsbulk_si*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qbsj2_Vgi_bi=(((PBSWS_t*Czbssw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qbsj2_Vgi_bi_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vgi_bi_Tempt_GND*sarg+arg_Vgi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vgi_bi+arg*sarg_Vgi_bi_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vgi_bi_Vdbulk_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vgi_bi_Vdbulk_di*sarg+arg_Vgi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdbulk_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vgi_bi_Vsbulk_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vgi_bi_Vsbulk_si*sarg+arg_Vgi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsbulk_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vgi_bi_Vgi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vgi_bi_Vgi_bi*sarg+arg_Vgi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vgi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vgi_bi_Vdi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vgi_bi_Vdi_bi*sarg+arg_Vgi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vgi_bi_Vsi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vgi_bi_Vsi_bi*sarg+arg_Vgi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qbsj2_Vdi_bi=(((PBSWS_t*Czbssw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qbsj2_Vdi_bi_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_bi_Tempt_GND*sarg+arg_Vdi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_bi+arg*sarg_Vdi_bi_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdi_bi_Vdbulk_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_bi_Vdbulk_di*sarg+arg_Vdi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdbulk_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdi_bi_Vsbulk_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_bi_Vsbulk_si*sarg+arg_Vdi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsbulk_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdi_bi_Vgi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_bi_Vgi_bi*sarg+arg_Vdi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vgi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdi_bi_Vdi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_bi_Vdi_bi*sarg+arg_Vdi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vdi_bi_Vsi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_bi_Vsi_bi*sarg+arg_Vdi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qbsj2_Vsi_bi=(((PBSWS_t*Czbssw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qbsj2_Vsi_bi_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsi_bi_Tempt_GND*sarg+arg_Vsi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsi_bi+arg*sarg_Vsi_bi_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsi_bi_Vdbulk_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsi_bi_Vdbulk_di*sarg+arg_Vsi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdbulk_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsi_bi_Vsbulk_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsi_bi_Vsbulk_si*sarg+arg_Vsi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsbulk_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsi_bi_Vgi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsi_bi_Vgi_bi*sarg+arg_Vsi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vgi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsi_bi_Vdi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsi_bi_Vdi_bi*sarg+arg_Vsi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qbsj2_Vsi_bi_Vsi_bi=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vsi_bi_Vsi_bi*sarg+arg_Vsi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsi_bi)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
#endif
Qbsj2=(((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS));
EXIT_IF_ISNAN((((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS)))
#endif
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((czbssw_p1*T1_Vdbulk_di)*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((czbssw_p1*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Vdbulk_di)));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdbulk_di+czbssw_p1*(+T1_Vdbulk_di_Vgm_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_di)))+((czbssw_p1*T1_Vgm_di))*((5.0*pModel->MJSWS)*T1_Vdbulk_di)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWS)*(+T1_Vdbulk_di_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+czbssw_p1*(+T1_Vdbulk_di_Vgm_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_si)))+((czbssw_p1*T1_Vgm_si))*((5.0*pModel->MJSWS)*T1_Vdbulk_di)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWS)*(+T1_Vdbulk_di_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+czbssw_p1*(+T1_Vdbulk_di_Vdbulk_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdbulk_di)))+((czbssw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWS)*T1_Vdbulk_di)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWS)*(+T1_Vdbulk_di_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+czbssw_p1*(+T1_Vdbulk_di_Vsbulk_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsbulk_si)))+((czbssw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWS)*T1_Vdbulk_di)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWS)*(+T1_Vdbulk_di_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdbulk_di+czbssw_p1*(+T1_Vdbulk_di_Vgi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgi_bi)))+((czbssw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWS)*T1_Vdbulk_di)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWS)*(+T1_Vdbulk_di_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdbulk_di+czbssw_p1*(+T1_Vdbulk_di_Vdi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_bi)))+((czbssw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWS)*T1_Vdbulk_di)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWS)*(+T1_Vdbulk_di_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdbulk_di+czbssw_p1*(+T1_Vdbulk_di_Vsi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsi_bi)))+((czbssw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWS)*T1_Vdbulk_di)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWS)*(+T1_Vdbulk_di_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdbulk_di+czbssw_p1*(+T1_Vdbulk_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+((czbssw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWS)*T1_Vdbulk_di)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWS)*(+T1_Vdbulk_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsbulk_si=(((czbssw_p1*T1_Vsbulk_si)*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((czbssw_p1*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Vsbulk_si)));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsbulk_si+czbssw_p1*(+T1_Vsbulk_si_Vgm_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_di)))+((czbssw_p1*T1_Vgm_di))*((5.0*pModel->MJSWS)*T1_Vsbulk_si)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWS)*(+T1_Vsbulk_si_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+czbssw_p1*(+T1_Vsbulk_si_Vgm_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_si)))+((czbssw_p1*T1_Vgm_si))*((5.0*pModel->MJSWS)*T1_Vsbulk_si)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWS)*(+T1_Vsbulk_si_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+czbssw_p1*(+T1_Vsbulk_si_Vdbulk_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdbulk_di)))+((czbssw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWS)*T1_Vsbulk_si)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWS)*(+T1_Vsbulk_si_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+czbssw_p1*(+T1_Vsbulk_si_Vsbulk_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsbulk_si)))+((czbssw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWS)*T1_Vsbulk_si)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWS)*(+T1_Vsbulk_si_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsbulk_si+czbssw_p1*(+T1_Vsbulk_si_Vgi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgi_bi)))+((czbssw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWS)*T1_Vsbulk_si)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWS)*(+T1_Vsbulk_si_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsbulk_si+czbssw_p1*(+T1_Vsbulk_si_Vdi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_bi)))+((czbssw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWS)*T1_Vsbulk_si)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWS)*(+T1_Vsbulk_si_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsbulk_si+czbssw_p1*(+T1_Vsbulk_si_Vsi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsi_bi)))+((czbssw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWS)*T1_Vsbulk_si)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWS)*(+T1_Vsbulk_si_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsbulk_si+czbssw_p1*(+T1_Vsbulk_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+((czbssw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWS)*T1_Vsbulk_si)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWS)*(+T1_Vsbulk_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vgi_bi=(((czbssw_p1*T1_Vgi_bi)*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((czbssw_p1*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Vgi_bi)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+czbssw_p1*(+T1_Vgi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_di)))+((czbssw_p1*T1_Vgm_di))*((5.0*pModel->MJSWS)*T1_Vgi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWS)*(+T1_Vgi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+czbssw_p1*(+T1_Vgi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_si)))+((czbssw_p1*T1_Vgm_si))*((5.0*pModel->MJSWS)*T1_Vgi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWS)*(+T1_Vgi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+czbssw_p1*(+T1_Vgi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdbulk_di)))+((czbssw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWS)*T1_Vgi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWS)*(+T1_Vgi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+czbssw_p1*(+T1_Vgi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsbulk_si)))+((czbssw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWS)*T1_Vgi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWS)*(+T1_Vgi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+czbssw_p1*(+T1_Vgi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgi_bi)))+((czbssw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWS)*T1_Vgi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWS)*(+T1_Vgi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+czbssw_p1*(+T1_Vgi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_bi)))+((czbssw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWS)*T1_Vgi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWS)*(+T1_Vgi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+czbssw_p1*(+T1_Vgi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsi_bi)))+((czbssw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWS)*T1_Vgi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWS)*(+T1_Vgi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+czbssw_p1*(+T1_Vgi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+((czbssw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWS)*T1_Vgi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWS)*(+T1_Vgi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vdi_bi=(((czbssw_p1*T1_Vdi_bi)*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((czbssw_p1*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Vdi_bi)));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+czbssw_p1*(+T1_Vdi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_di)))+((czbssw_p1*T1_Vgm_di))*((5.0*pModel->MJSWS)*T1_Vdi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWS)*(+T1_Vdi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+czbssw_p1*(+T1_Vdi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_si)))+((czbssw_p1*T1_Vgm_si))*((5.0*pModel->MJSWS)*T1_Vdi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWS)*(+T1_Vdi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+czbssw_p1*(+T1_Vdi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdbulk_di)))+((czbssw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWS)*T1_Vdi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWS)*(+T1_Vdi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+czbssw_p1*(+T1_Vdi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsbulk_si)))+((czbssw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWS)*T1_Vdi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWS)*(+T1_Vdi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+czbssw_p1*(+T1_Vdi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgi_bi)))+((czbssw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWS)*T1_Vdi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWS)*(+T1_Vdi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+czbssw_p1*(+T1_Vdi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_bi)))+((czbssw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWS)*T1_Vdi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWS)*(+T1_Vdi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+czbssw_p1*(+T1_Vdi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsi_bi)))+((czbssw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWS)*T1_Vdi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWS)*(+T1_Vdi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+czbssw_p1*(+T1_Vdi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+((czbssw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWS)*T1_Vdi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWS)*(+T1_Vdi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsi_bi=(((czbssw_p1*T1_Vsi_bi)*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((czbssw_p1*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Vsi_bi)));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+czbssw_p1*(+T1_Vsi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_di)))+((czbssw_p1*T1_Vgm_di))*((5.0*pModel->MJSWS)*T1_Vsi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWS)*(+T1_Vsi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+czbssw_p1*(+T1_Vsi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgm_si)))+((czbssw_p1*T1_Vgm_si))*((5.0*pModel->MJSWS)*T1_Vsi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWS)*(+T1_Vsi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+czbssw_p1*(+T1_Vsi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdbulk_di)))+((czbssw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWS)*T1_Vsi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWS)*(+T1_Vsi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+czbssw_p1*(+T1_Vsi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsbulk_si)))+((czbssw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWS)*T1_Vsi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWS)*(+T1_Vsi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+czbssw_p1*(+T1_Vsi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vgi_bi)))+((czbssw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWS)*T1_Vsi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWS)*(+T1_Vsi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+czbssw_p1*(+T1_Vsi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_bi)))+((czbssw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWS)*T1_Vsi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWS)*(+T1_Vsi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+czbssw_p1*(+T1_Vsi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vsi_bi)))+((czbssw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWS)*T1_Vsi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWS)*(+T1_Vsi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+czbssw_p1*(+T1_Vsi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+(czbssw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+((czbssw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWS)*T1_Vsi_bi)+(czbssw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWS)*(+T1_Vsi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((czbssw_p1*T1_Tempt_GND)*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((czbssw_p1*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Tempt_GND)));
#endif
#endif
T2=((czbssw_p1*(T1-1.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)));
EXIT_IF_ISNAN(((czbssw_p1*(T1-1.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Qbsj2_Tempt_GND=((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(T2+czbssw_p2))+((PBSWS_t*Czbssw)*T2_Tempt_GND));
#endif
Qbsj2_Vdbulk_di=((PBSWS_t*Czbssw)*T2_Vdbulk_di);
#if defined(_DERIVATE2)
  Qbsj2_Vdbulk_di_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Tempt_GND+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*T2_Vdbulk_di+(PBSWS_t*Czbssw)*(+T2_Vdbulk_di_Tempt_GND+0.0));
  Qbsj2_Vdbulk_di_Vdbulk_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdbulk_di+(PBSWS_t*Czbssw)*(+T2_Vdbulk_di_Vdbulk_di+0.0));
  Qbsj2_Vdbulk_di_Vsbulk_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdbulk_di+(PBSWS_t*Czbssw)*(+T2_Vdbulk_di_Vsbulk_si+0.0));
  Qbsj2_Vdbulk_di_Vgi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdbulk_di+(PBSWS_t*Czbssw)*(+T2_Vdbulk_di_Vgi_bi+0.0));
  Qbsj2_Vdbulk_di_Vdi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdbulk_di+(PBSWS_t*Czbssw)*(+T2_Vdbulk_di_Vdi_bi+0.0));
  Qbsj2_Vdbulk_di_Vsi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdbulk_di+(PBSWS_t*Czbssw)*(+T2_Vdbulk_di_Vsi_bi+0.0));
#endif
Qbsj2_Vsbulk_si=((PBSWS_t*Czbssw)*T2_Vsbulk_si);
#if defined(_DERIVATE2)
  Qbsj2_Vsbulk_si_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Tempt_GND+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*T2_Vsbulk_si+(PBSWS_t*Czbssw)*(+T2_Vsbulk_si_Tempt_GND+0.0));
  Qbsj2_Vsbulk_si_Vdbulk_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsbulk_si+(PBSWS_t*Czbssw)*(+T2_Vsbulk_si_Vdbulk_di+0.0));
  Qbsj2_Vsbulk_si_Vsbulk_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsbulk_si+(PBSWS_t*Czbssw)*(+T2_Vsbulk_si_Vsbulk_si+0.0));
  Qbsj2_Vsbulk_si_Vgi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsbulk_si+(PBSWS_t*Czbssw)*(+T2_Vsbulk_si_Vgi_bi+0.0));
  Qbsj2_Vsbulk_si_Vdi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsbulk_si+(PBSWS_t*Czbssw)*(+T2_Vsbulk_si_Vdi_bi+0.0));
  Qbsj2_Vsbulk_si_Vsi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsbulk_si+(PBSWS_t*Czbssw)*(+T2_Vsbulk_si_Vsi_bi+0.0));
#endif
Qbsj2_Vgi_bi=((PBSWS_t*Czbssw)*T2_Vgi_bi);
#if defined(_DERIVATE2)
  Qbsj2_Vgi_bi_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Tempt_GND+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*T2_Vgi_bi+(PBSWS_t*Czbssw)*(+T2_Vgi_bi_Tempt_GND+0.0));
  Qbsj2_Vgi_bi_Vdbulk_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vgi_bi+(PBSWS_t*Czbssw)*(+T2_Vgi_bi_Vdbulk_di+0.0));
  Qbsj2_Vgi_bi_Vsbulk_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vgi_bi+(PBSWS_t*Czbssw)*(+T2_Vgi_bi_Vsbulk_si+0.0));
  Qbsj2_Vgi_bi_Vgi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vgi_bi+(PBSWS_t*Czbssw)*(+T2_Vgi_bi_Vgi_bi+0.0));
  Qbsj2_Vgi_bi_Vdi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vgi_bi+(PBSWS_t*Czbssw)*(+T2_Vgi_bi_Vdi_bi+0.0));
  Qbsj2_Vgi_bi_Vsi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vgi_bi+(PBSWS_t*Czbssw)*(+T2_Vgi_bi_Vsi_bi+0.0));
#endif
Qbsj2_Vdi_bi=((PBSWS_t*Czbssw)*T2_Vdi_bi);
#if defined(_DERIVATE2)
  Qbsj2_Vdi_bi_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Tempt_GND+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*T2_Vdi_bi+(PBSWS_t*Czbssw)*(+T2_Vdi_bi_Tempt_GND+0.0));
  Qbsj2_Vdi_bi_Vdbulk_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdi_bi+(PBSWS_t*Czbssw)*(+T2_Vdi_bi_Vdbulk_di+0.0));
  Qbsj2_Vdi_bi_Vsbulk_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdi_bi+(PBSWS_t*Czbssw)*(+T2_Vdi_bi_Vsbulk_si+0.0));
  Qbsj2_Vdi_bi_Vgi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdi_bi+(PBSWS_t*Czbssw)*(+T2_Vdi_bi_Vgi_bi+0.0));
  Qbsj2_Vdi_bi_Vdi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdi_bi+(PBSWS_t*Czbssw)*(+T2_Vdi_bi_Vdi_bi+0.0));
  Qbsj2_Vdi_bi_Vsi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdi_bi+(PBSWS_t*Czbssw)*(+T2_Vdi_bi_Vsi_bi+0.0));
#endif
Qbsj2_Vsi_bi=((PBSWS_t*Czbssw)*T2_Vsi_bi);
#if defined(_DERIVATE2)
  Qbsj2_Vsi_bi_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Tempt_GND+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*T2_Vsi_bi+(PBSWS_t*Czbssw)*(+T2_Vsi_bi_Tempt_GND+0.0));
  Qbsj2_Vsi_bi_Vdbulk_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsi_bi+(PBSWS_t*Czbssw)*(+T2_Vsi_bi_Vdbulk_di+0.0));
  Qbsj2_Vsi_bi_Vsbulk_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsi_bi+(PBSWS_t*Czbssw)*(+T2_Vsi_bi_Vsbulk_si+0.0));
  Qbsj2_Vsi_bi_Vgi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsi_bi+(PBSWS_t*Czbssw)*(+T2_Vsi_bi_Vgi_bi+0.0));
  Qbsj2_Vsi_bi_Vdi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsi_bi+(PBSWS_t*Czbssw)*(+T2_Vsi_bi_Vdi_bi+0.0));
  Qbsj2_Vsi_bi_Vsi_bi=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T2+czbssw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsi_bi+(PBSWS_t*Czbssw)*(+T2_Vsi_bi_Vsi_bi+0.0));
#endif
#endif
Qbsj2=((PBSWS_t*Czbssw)*(T2+czbssw_p2));
EXIT_IF_ISNAN(((PBSWS_t*Czbssw)*(T2+czbssw_p2)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Qbsj2_Tempt_GND=0.0;
#endif
Qbsj2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qbsj2_Vdbulk_di_Tempt_GND=0.0;
  Qbsj2_Vdbulk_di_Vdbulk_di=0.0;
  Qbsj2_Vdbulk_di_Vsbulk_si=0.0;
  Qbsj2_Vdbulk_di_Vgi_bi=0.0;
  Qbsj2_Vdbulk_di_Vdi_bi=0.0;
  Qbsj2_Vdbulk_di_Vsi_bi=0.0;
#endif
Qbsj2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qbsj2_Vsbulk_si_Tempt_GND=0.0;
  Qbsj2_Vsbulk_si_Vdbulk_di=0.0;
  Qbsj2_Vsbulk_si_Vsbulk_si=0.0;
  Qbsj2_Vsbulk_si_Vgi_bi=0.0;
  Qbsj2_Vsbulk_si_Vdi_bi=0.0;
  Qbsj2_Vsbulk_si_Vsi_bi=0.0;
#endif
Qbsj2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Qbsj2_Vgi_bi_Tempt_GND=0.0;
  Qbsj2_Vgi_bi_Vdbulk_di=0.0;
  Qbsj2_Vgi_bi_Vsbulk_si=0.0;
  Qbsj2_Vgi_bi_Vgi_bi=0.0;
  Qbsj2_Vgi_bi_Vdi_bi=0.0;
  Qbsj2_Vgi_bi_Vsi_bi=0.0;
#endif
Qbsj2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Qbsj2_Vdi_bi_Tempt_GND=0.0;
  Qbsj2_Vdi_bi_Vdbulk_di=0.0;
  Qbsj2_Vdi_bi_Vsbulk_si=0.0;
  Qbsj2_Vdi_bi_Vgi_bi=0.0;
  Qbsj2_Vdi_bi_Vdi_bi=0.0;
  Qbsj2_Vdi_bi_Vsi_bi=0.0;
#endif
Qbsj2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Qbsj2_Vsi_bi_Tempt_GND=0.0;
  Qbsj2_Vsi_bi_Vdbulk_di=0.0;
  Qbsj2_Vsi_bi_Vsbulk_si=0.0;
  Qbsj2_Vsi_bi_Vgi_bi=0.0;
  Qbsj2_Vsi_bi_Vdi_bi=0.0;
  Qbsj2_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
Qbsj2=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
if
((Czbsswg>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=(Vbs_jct_Vsbulk_si/PBSWGS_t);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(0.0/PBSWGS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWGS_t/PBSWGS_t+2*Vbs_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Vsbulk_si_Vgm_si=(0.0/PBSWGS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWGS_t/PBSWGS_t+2*Vbs_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Vsbulk_si_Vdbulk_di=(0.0/PBSWGS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWGS_t/PBSWGS_t+2*Vbs_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Vsbulk_si_Vsbulk_si=(Vbs_jct_Vsbulk_si_Vsbulk_si/PBSWGS_t-(Vbs_jct_Vsbulk_si*0.0+Vbs_jct_Vsbulk_si*0.0+Vbs_jct*0.0)/PBSWGS_t/PBSWGS_t+2*Vbs_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Vsbulk_si_Vgi_bi=(0.0/PBSWGS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWGS_t/PBSWGS_t+2*Vbs_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Vsbulk_si_Vdi_bi=(0.0/PBSWGS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWGS_t/PBSWGS_t+2*Vbs_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Vsbulk_si_Vsi_bi=(0.0/PBSWGS_t-(Vbs_jct_Vsbulk_si*0.0+0.0*0.0+Vbs_jct*0.0)/PBSWGS_t/PBSWGS_t+2*Vbs_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Vsbulk_si_Tempt_GND=(0.0/PBSWGS_t-(Vbs_jct_Vsbulk_si*PBSWGS_t_Tempt_GND+0.0*0.0+Vbs_jct*0.0)/PBSWGS_t/PBSWGS_t+2*Vbs_jct*0.0*PBSWGS_t_Tempt_GND/PBSWGS_t/PBSWGS_t/PBSWGS_t);
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-Vbs_jct*PBSWGS_t_Tempt_GND/PBSWGS_t/PBSWGS_t);
#endif
#endif
T1=(Vbs_jct/PBSWGS_t);
EXIT_IF_ISNAN((Vbs_jct/PBSWGS_t))
if
((T1<0.9))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
arg_Vdbulk_di=(-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  arg_Vdbulk_di_Vdbulk_di=(+0.0-T1_Vdbulk_di_Vdbulk_di);
  arg_Vdbulk_di_Vsbulk_si=(+0.0-T1_Vdbulk_di_Vsbulk_si);
  arg_Vdbulk_di_Vgi_bi=(+0.0-T1_Vdbulk_di_Vgi_bi);
  arg_Vdbulk_di_Vdi_bi=(+0.0-T1_Vdbulk_di_Vdi_bi);
  arg_Vdbulk_di_Vsi_bi=(+0.0-T1_Vdbulk_di_Vsi_bi);
  arg_Vdbulk_di_Tempt_GND=(+0.0-T1_Vdbulk_di_Tempt_GND);
#endif
arg_Vsbulk_si=(-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  arg_Vsbulk_si_Vdbulk_di=(+0.0-T1_Vsbulk_si_Vdbulk_di);
  arg_Vsbulk_si_Vsbulk_si=(+0.0-T1_Vsbulk_si_Vsbulk_si);
  arg_Vsbulk_si_Vgi_bi=(+0.0-T1_Vsbulk_si_Vgi_bi);
  arg_Vsbulk_si_Vdi_bi=(+0.0-T1_Vsbulk_si_Vdi_bi);
  arg_Vsbulk_si_Vsi_bi=(+0.0-T1_Vsbulk_si_Vsi_bi);
  arg_Vsbulk_si_Tempt_GND=(+0.0-T1_Vsbulk_si_Tempt_GND);
#endif
arg_Vgi_bi=(-T1_Vgi_bi);
#if defined(_DERIVATE2)
  arg_Vgi_bi_Vdbulk_di=(+0.0-T1_Vgi_bi_Vdbulk_di);
  arg_Vgi_bi_Vsbulk_si=(+0.0-T1_Vgi_bi_Vsbulk_si);
  arg_Vgi_bi_Vgi_bi=(+0.0-T1_Vgi_bi_Vgi_bi);
  arg_Vgi_bi_Vdi_bi=(+0.0-T1_Vgi_bi_Vdi_bi);
  arg_Vgi_bi_Vsi_bi=(+0.0-T1_Vgi_bi_Vsi_bi);
  arg_Vgi_bi_Tempt_GND=(+0.0-T1_Vgi_bi_Tempt_GND);
#endif
arg_Vdi_bi=(-T1_Vdi_bi);
#if defined(_DERIVATE2)
  arg_Vdi_bi_Vdbulk_di=(+0.0-T1_Vdi_bi_Vdbulk_di);
  arg_Vdi_bi_Vsbulk_si=(+0.0-T1_Vdi_bi_Vsbulk_si);
  arg_Vdi_bi_Vgi_bi=(+0.0-T1_Vdi_bi_Vgi_bi);
  arg_Vdi_bi_Vdi_bi=(+0.0-T1_Vdi_bi_Vdi_bi);
  arg_Vdi_bi_Vsi_bi=(+0.0-T1_Vdi_bi_Vsi_bi);
  arg_Vdi_bi_Tempt_GND=(+0.0-T1_Vdi_bi_Tempt_GND);
#endif
arg_Vsi_bi=(-T1_Vsi_bi);
#if defined(_DERIVATE2)
  arg_Vsi_bi_Vdbulk_di=(+0.0-T1_Vsi_bi_Vdbulk_di);
  arg_Vsi_bi_Vsbulk_si=(+0.0-T1_Vsi_bi_Vsbulk_si);
  arg_Vsi_bi_Vgi_bi=(+0.0-T1_Vsi_bi_Vgi_bi);
  arg_Vsi_bi_Vdi_bi=(+0.0-T1_Vsi_bi_Vdi_bi);
  arg_Vsi_bi_Vsi_bi=(+0.0-T1_Vsi_bi_Vsi_bi);
  arg_Vsi_bi_Tempt_GND=(+0.0-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
arg_Tempt_GND=(-T1_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=(-arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsbulk_si=(-arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vgi_bi=(-arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_bi=(-arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsi_bi=(-arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=bsimbulk_d_lexp(((-pModel->MJSWGS)*bsimbulk_lln(arg)),((-pModel->MJSWGS)*bsimbulk_d_lln(arg,arg_Vdbulk_di)));
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGS)*arg_Vdbulk_di_Vdbulk_di);
  sarg_Vdbulk_di_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGS)*arg_Vdbulk_di_Vsbulk_si);
  sarg_Vdbulk_di_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGS)*arg_Vdbulk_di_Vgi_bi);
  sarg_Vdbulk_di_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGS)*arg_Vdbulk_di_Vdi_bi);
  sarg_Vdbulk_di_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGS)*arg_Vdbulk_di_Vsi_bi);
  sarg_Vdbulk_di_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGS)*arg_Vdbulk_di_Tempt_GND);
#endif
sarg_Vsbulk_si=bsimbulk_d_lexp(((-pModel->MJSWGS)*bsimbulk_lln(arg)),((-pModel->MJSWGS)*bsimbulk_d_lln(arg,arg_Vsbulk_si)));
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGS)*arg_Vsbulk_si_Vdbulk_di);
  sarg_Vsbulk_si_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGS)*arg_Vsbulk_si_Vsbulk_si);
  sarg_Vsbulk_si_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGS)*arg_Vsbulk_si_Vgi_bi);
  sarg_Vsbulk_si_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGS)*arg_Vsbulk_si_Vdi_bi);
  sarg_Vsbulk_si_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGS)*arg_Vsbulk_si_Vsi_bi);
  sarg_Vsbulk_si_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGS)*arg_Vsbulk_si_Tempt_GND);
#endif
sarg_Vgi_bi=bsimbulk_d_lexp(((-pModel->MJSWGS)*bsimbulk_lln(arg)),((-pModel->MJSWGS)*bsimbulk_d_lln(arg,arg_Vgi_bi)));
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGS)*arg_Vgi_bi_Vdbulk_di);
  sarg_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGS)*arg_Vgi_bi_Vsbulk_si);
  sarg_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGS)*arg_Vgi_bi_Vgi_bi);
  sarg_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGS)*arg_Vgi_bi_Vdi_bi);
  sarg_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGS)*arg_Vgi_bi_Vsi_bi);
  sarg_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGS)*arg_Vgi_bi_Tempt_GND);
#endif
sarg_Vdi_bi=bsimbulk_d_lexp(((-pModel->MJSWGS)*bsimbulk_lln(arg)),((-pModel->MJSWGS)*bsimbulk_d_lln(arg,arg_Vdi_bi)));
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGS)*arg_Vdi_bi_Vdbulk_di);
  sarg_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGS)*arg_Vdi_bi_Vsbulk_si);
  sarg_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGS)*arg_Vdi_bi_Vgi_bi);
  sarg_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGS)*arg_Vdi_bi_Vdi_bi);
  sarg_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGS)*arg_Vdi_bi_Vsi_bi);
  sarg_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGS)*arg_Vdi_bi_Tempt_GND);
#endif
sarg_Vsi_bi=bsimbulk_d_lexp(((-pModel->MJSWGS)*bsimbulk_lln(arg)),((-pModel->MJSWGS)*bsimbulk_d_lln(arg,arg_Vsi_bi)));
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGS)*arg_Vsi_bi_Vdbulk_di);
  sarg_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGS)*arg_Vsi_bi_Vsbulk_si);
  sarg_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGS)*arg_Vsi_bi_Vgi_bi);
  sarg_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGS)*arg_Vsi_bi_Vdi_bi);
  sarg_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGS)*arg_Vsi_bi_Vsi_bi);
  sarg_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGS)*arg_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=bsimbulk_d_lexp(((-pModel->MJSWGS)*bsimbulk_lln(arg)),((-pModel->MJSWGS)*bsimbulk_d_lln(arg,arg_Tempt_GND)));
#endif
#endif
sarg=bsimbulk_lexp(((-pModel->MJSWGS)*bsimbulk_lln(arg)));
EXIT_IF_ISNAN(bsimbulk_lexp(((-pModel->MJSWGS)*bsimbulk_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Qbsj3_Tempt_GND=(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGS));
#endif
Qbsj3_Vdbulk_di=(((PBSWGS_t*Czbsswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qbsj3_Vdbulk_di_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdbulk_di_Tempt_GND*sarg+arg_Vdbulk_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdbulk_di_Vdbulk_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdbulk_di_Vdbulk_di*sarg+arg_Vdbulk_di*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdbulk_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdbulk_di_Vsbulk_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdbulk_di_Vsbulk_si*sarg+arg_Vdbulk_di*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsbulk_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdbulk_di_Vgi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdbulk_di_Vgi_bi*sarg+arg_Vdbulk_di*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vgi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdbulk_di_Vdi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdbulk_di_Vdi_bi*sarg+arg_Vdbulk_di*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdbulk_di_Vsi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdbulk_di_Vsi_bi*sarg+arg_Vdbulk_di*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qbsj3_Vsbulk_si=(((PBSWGS_t*Czbsswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qbsj3_Vsbulk_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsbulk_si_Tempt_GND*sarg+arg_Vsbulk_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsbulk_si_Vdbulk_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsbulk_si_Vdbulk_di*sarg+arg_Vsbulk_si*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdbulk_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsbulk_si_Vsbulk_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsbulk_si_Vsbulk_si*sarg+arg_Vsbulk_si*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsbulk_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsbulk_si_Vgi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsbulk_si_Vgi_bi*sarg+arg_Vsbulk_si*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vgi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsbulk_si_Vdi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsbulk_si_Vdi_bi*sarg+arg_Vsbulk_si*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsbulk_si_Vsi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsbulk_si_Vsi_bi*sarg+arg_Vsbulk_si*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qbsj3_Vgi_bi=(((PBSWGS_t*Czbsswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qbsj3_Vgi_bi_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vgi_bi_Tempt_GND*sarg+arg_Vgi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vgi_bi+arg*sarg_Vgi_bi_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vgi_bi_Vdbulk_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vgi_bi_Vdbulk_di*sarg+arg_Vgi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdbulk_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vgi_bi_Vsbulk_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vgi_bi_Vsbulk_si*sarg+arg_Vgi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsbulk_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vgi_bi_Vgi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vgi_bi_Vgi_bi*sarg+arg_Vgi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vgi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vgi_bi_Vdi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vgi_bi_Vdi_bi*sarg+arg_Vgi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vgi_bi_Vsi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vgi_bi_Vsi_bi*sarg+arg_Vgi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qbsj3_Vdi_bi=(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qbsj3_Vdi_bi_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_bi_Tempt_GND*sarg+arg_Vdi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_bi+arg*sarg_Vdi_bi_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdi_bi_Vdbulk_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_bi_Vdbulk_di*sarg+arg_Vdi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdbulk_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdi_bi_Vsbulk_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_bi_Vsbulk_si*sarg+arg_Vdi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsbulk_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdi_bi_Vgi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_bi_Vgi_bi*sarg+arg_Vdi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vgi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdi_bi_Vdi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_bi_Vdi_bi*sarg+arg_Vdi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vdi_bi_Vsi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_bi_Vsi_bi*sarg+arg_Vdi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qbsj3_Vsi_bi=(((PBSWGS_t*Czbsswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qbsj3_Vsi_bi_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsi_bi_Tempt_GND*sarg+arg_Vsi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsi_bi+arg*sarg_Vsi_bi_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsi_bi_Vdbulk_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsi_bi_Vdbulk_di*sarg+arg_Vsi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdbulk_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsi_bi_Vsbulk_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsi_bi_Vsbulk_si*sarg+arg_Vsi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsbulk_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsi_bi_Vgi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsi_bi_Vgi_bi*sarg+arg_Vsi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vgi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsi_bi_Vdi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsi_bi_Vdi_bi*sarg+arg_Vsi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qbsj3_Vsi_bi_Vsi_bi=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vsi_bi_Vsi_bi*sarg+arg_Vsi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsi_bi)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
#endif
Qbsj3=(((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS));
EXIT_IF_ISNAN((((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS)))
#endif
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((czbsswg_p1*T1_Vdbulk_di)*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((czbsswg_p1*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Vdbulk_di)));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdbulk_di+czbsswg_p1*(+T1_Vdbulk_di_Vgm_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_di)))+((czbsswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGS)*T1_Vdbulk_di)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGS)*(+T1_Vdbulk_di_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+czbsswg_p1*(+T1_Vdbulk_di_Vgm_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_si)))+((czbsswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGS)*T1_Vdbulk_di)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGS)*(+T1_Vdbulk_di_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+czbsswg_p1*(+T1_Vdbulk_di_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdbulk_di)))+((czbsswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGS)*T1_Vdbulk_di)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGS)*(+T1_Vdbulk_di_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+czbsswg_p1*(+T1_Vdbulk_di_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsbulk_si)))+((czbsswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGS)*T1_Vdbulk_di)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGS)*(+T1_Vdbulk_di_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdbulk_di+czbsswg_p1*(+T1_Vdbulk_di_Vgi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgi_bi)))+((czbsswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGS)*T1_Vdbulk_di)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGS)*(+T1_Vdbulk_di_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdbulk_di+czbsswg_p1*(+T1_Vdbulk_di_Vdi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_bi)))+((czbsswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGS)*T1_Vdbulk_di)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGS)*(+T1_Vdbulk_di_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdbulk_di+czbsswg_p1*(+T1_Vdbulk_di_Vsi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsi_bi)))+((czbsswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGS)*T1_Vdbulk_di)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGS)*(+T1_Vdbulk_di_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdbulk_di+czbsswg_p1*(+T1_Vdbulk_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+((czbsswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGS)*T1_Vdbulk_di)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGS)*(+T1_Vdbulk_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsbulk_si=(((czbsswg_p1*T1_Vsbulk_si)*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((czbsswg_p1*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Vsbulk_si)));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsbulk_si+czbsswg_p1*(+T1_Vsbulk_si_Vgm_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_di)))+((czbsswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGS)*T1_Vsbulk_si)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGS)*(+T1_Vsbulk_si_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+czbsswg_p1*(+T1_Vsbulk_si_Vgm_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_si)))+((czbsswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGS)*T1_Vsbulk_si)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGS)*(+T1_Vsbulk_si_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+czbsswg_p1*(+T1_Vsbulk_si_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdbulk_di)))+((czbsswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGS)*T1_Vsbulk_si)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGS)*(+T1_Vsbulk_si_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+czbsswg_p1*(+T1_Vsbulk_si_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsbulk_si)))+((czbsswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGS)*T1_Vsbulk_si)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGS)*(+T1_Vsbulk_si_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsbulk_si+czbsswg_p1*(+T1_Vsbulk_si_Vgi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgi_bi)))+((czbsswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGS)*T1_Vsbulk_si)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGS)*(+T1_Vsbulk_si_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsbulk_si+czbsswg_p1*(+T1_Vsbulk_si_Vdi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_bi)))+((czbsswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGS)*T1_Vsbulk_si)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGS)*(+T1_Vsbulk_si_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsbulk_si+czbsswg_p1*(+T1_Vsbulk_si_Vsi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsi_bi)))+((czbsswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGS)*T1_Vsbulk_si)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGS)*(+T1_Vsbulk_si_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsbulk_si+czbsswg_p1*(+T1_Vsbulk_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+((czbsswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGS)*T1_Vsbulk_si)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGS)*(+T1_Vsbulk_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vgi_bi=(((czbsswg_p1*T1_Vgi_bi)*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((czbsswg_p1*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Vgi_bi)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+czbsswg_p1*(+T1_Vgi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_di)))+((czbsswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGS)*T1_Vgi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGS)*(+T1_Vgi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+czbsswg_p1*(+T1_Vgi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_si)))+((czbsswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGS)*T1_Vgi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGS)*(+T1_Vgi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+czbsswg_p1*(+T1_Vgi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdbulk_di)))+((czbsswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGS)*T1_Vgi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGS)*(+T1_Vgi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+czbsswg_p1*(+T1_Vgi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsbulk_si)))+((czbsswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGS)*T1_Vgi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGS)*(+T1_Vgi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+czbsswg_p1*(+T1_Vgi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgi_bi)))+((czbsswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGS)*T1_Vgi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGS)*(+T1_Vgi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+czbsswg_p1*(+T1_Vgi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_bi)))+((czbsswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGS)*T1_Vgi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGS)*(+T1_Vgi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+czbsswg_p1*(+T1_Vgi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsi_bi)))+((czbsswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGS)*T1_Vgi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGS)*(+T1_Vgi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+czbsswg_p1*(+T1_Vgi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+((czbsswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGS)*T1_Vgi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGS)*(+T1_Vgi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vdi_bi=(((czbsswg_p1*T1_Vdi_bi)*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((czbsswg_p1*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Vdi_bi)));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+czbsswg_p1*(+T1_Vdi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_di)))+((czbsswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGS)*T1_Vdi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGS)*(+T1_Vdi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+czbsswg_p1*(+T1_Vdi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_si)))+((czbsswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGS)*T1_Vdi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGS)*(+T1_Vdi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+czbsswg_p1*(+T1_Vdi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdbulk_di)))+((czbsswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGS)*T1_Vdi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGS)*(+T1_Vdi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+czbsswg_p1*(+T1_Vdi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsbulk_si)))+((czbsswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGS)*T1_Vdi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGS)*(+T1_Vdi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+czbsswg_p1*(+T1_Vdi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgi_bi)))+((czbsswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGS)*T1_Vdi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGS)*(+T1_Vdi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+czbsswg_p1*(+T1_Vdi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_bi)))+((czbsswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGS)*T1_Vdi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGS)*(+T1_Vdi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+czbsswg_p1*(+T1_Vdi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsi_bi)))+((czbsswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGS)*T1_Vdi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGS)*(+T1_Vdi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+czbsswg_p1*(+T1_Vdi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+((czbsswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGS)*T1_Vdi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGS)*(+T1_Vdi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsi_bi=(((czbsswg_p1*T1_Vsi_bi)*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((czbsswg_p1*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Vsi_bi)));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+czbsswg_p1*(+T1_Vsi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_di)))+((czbsswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGS)*T1_Vsi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGS)*(+T1_Vsi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+czbsswg_p1*(+T1_Vsi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgm_si)))+((czbsswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGS)*T1_Vsi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGS)*(+T1_Vsi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+czbsswg_p1*(+T1_Vsi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdbulk_di)))+((czbsswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGS)*T1_Vsi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGS)*(+T1_Vsi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+czbsswg_p1*(+T1_Vsi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsbulk_si)))+((czbsswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGS)*T1_Vsi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGS)*(+T1_Vsi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+czbsswg_p1*(+T1_Vsi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vgi_bi)))+((czbsswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGS)*T1_Vsi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGS)*(+T1_Vsi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+czbsswg_p1*(+T1_Vsi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_bi)))+((czbsswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGS)*T1_Vsi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGS)*(+T1_Vsi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+czbsswg_p1*(+T1_Vsi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vsi_bi)))+((czbsswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGS)*T1_Vsi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGS)*(+T1_Vsi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+czbsswg_p1*(+T1_Vsi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+(czbsswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+((czbsswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGS)*T1_Vsi_bi)+(czbsswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGS)*(+T1_Vsi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((czbsswg_p1*T1_Tempt_GND)*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((czbsswg_p1*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Tempt_GND)));
#endif
#endif
T2=((czbsswg_p1*(T1-1.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)));
EXIT_IF_ISNAN(((czbsswg_p1*(T1-1.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Qbsj3_Tempt_GND=((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(T2+czbsswg_p2))+((PBSWGS_t*Czbsswg)*T2_Tempt_GND));
#endif
Qbsj3_Vdbulk_di=((PBSWGS_t*Czbsswg)*T2_Vdbulk_di);
#if defined(_DERIVATE2)
  Qbsj3_Vdbulk_di_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Tempt_GND+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*T2_Vdbulk_di+(PBSWGS_t*Czbsswg)*(+T2_Vdbulk_di_Tempt_GND+0.0));
  Qbsj3_Vdbulk_di_Vdbulk_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdbulk_di+(PBSWGS_t*Czbsswg)*(+T2_Vdbulk_di_Vdbulk_di+0.0));
  Qbsj3_Vdbulk_di_Vsbulk_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdbulk_di+(PBSWGS_t*Czbsswg)*(+T2_Vdbulk_di_Vsbulk_si+0.0));
  Qbsj3_Vdbulk_di_Vgi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdbulk_di+(PBSWGS_t*Czbsswg)*(+T2_Vdbulk_di_Vgi_bi+0.0));
  Qbsj3_Vdbulk_di_Vdi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdbulk_di+(PBSWGS_t*Czbsswg)*(+T2_Vdbulk_di_Vdi_bi+0.0));
  Qbsj3_Vdbulk_di_Vsi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdbulk_di+(PBSWGS_t*Czbsswg)*(+T2_Vdbulk_di_Vsi_bi+0.0));
#endif
Qbsj3_Vsbulk_si=((PBSWGS_t*Czbsswg)*T2_Vsbulk_si);
#if defined(_DERIVATE2)
  Qbsj3_Vsbulk_si_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Tempt_GND+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*T2_Vsbulk_si+(PBSWGS_t*Czbsswg)*(+T2_Vsbulk_si_Tempt_GND+0.0));
  Qbsj3_Vsbulk_si_Vdbulk_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsbulk_si+(PBSWGS_t*Czbsswg)*(+T2_Vsbulk_si_Vdbulk_di+0.0));
  Qbsj3_Vsbulk_si_Vsbulk_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsbulk_si+(PBSWGS_t*Czbsswg)*(+T2_Vsbulk_si_Vsbulk_si+0.0));
  Qbsj3_Vsbulk_si_Vgi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsbulk_si+(PBSWGS_t*Czbsswg)*(+T2_Vsbulk_si_Vgi_bi+0.0));
  Qbsj3_Vsbulk_si_Vdi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsbulk_si+(PBSWGS_t*Czbsswg)*(+T2_Vsbulk_si_Vdi_bi+0.0));
  Qbsj3_Vsbulk_si_Vsi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsbulk_si+(PBSWGS_t*Czbsswg)*(+T2_Vsbulk_si_Vsi_bi+0.0));
#endif
Qbsj3_Vgi_bi=((PBSWGS_t*Czbsswg)*T2_Vgi_bi);
#if defined(_DERIVATE2)
  Qbsj3_Vgi_bi_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Tempt_GND+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*T2_Vgi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vgi_bi_Tempt_GND+0.0));
  Qbsj3_Vgi_bi_Vdbulk_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vgi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vgi_bi_Vdbulk_di+0.0));
  Qbsj3_Vgi_bi_Vsbulk_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vgi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vgi_bi_Vsbulk_si+0.0));
  Qbsj3_Vgi_bi_Vgi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vgi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vgi_bi_Vgi_bi+0.0));
  Qbsj3_Vgi_bi_Vdi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vgi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vgi_bi_Vdi_bi+0.0));
  Qbsj3_Vgi_bi_Vsi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vgi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vgi_bi_Vsi_bi+0.0));
#endif
Qbsj3_Vdi_bi=((PBSWGS_t*Czbsswg)*T2_Vdi_bi);
#if defined(_DERIVATE2)
  Qbsj3_Vdi_bi_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Tempt_GND+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*T2_Vdi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vdi_bi_Tempt_GND+0.0));
  Qbsj3_Vdi_bi_Vdbulk_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vdi_bi_Vdbulk_di+0.0));
  Qbsj3_Vdi_bi_Vsbulk_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vdi_bi_Vsbulk_si+0.0));
  Qbsj3_Vdi_bi_Vgi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vdi_bi_Vgi_bi+0.0));
  Qbsj3_Vdi_bi_Vdi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vdi_bi_Vdi_bi+0.0));
  Qbsj3_Vdi_bi_Vsi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vdi_bi_Vsi_bi+0.0));
#endif
Qbsj3_Vsi_bi=((PBSWGS_t*Czbsswg)*T2_Vsi_bi);
#if defined(_DERIVATE2)
  Qbsj3_Vsi_bi_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Tempt_GND+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*T2_Vsi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vsi_bi_Tempt_GND+0.0));
  Qbsj3_Vsi_bi_Vdbulk_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vsi_bi_Vdbulk_di+0.0));
  Qbsj3_Vsi_bi_Vsbulk_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vsi_bi_Vsbulk_si+0.0));
  Qbsj3_Vsi_bi_Vgi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vsi_bi_Vgi_bi+0.0));
  Qbsj3_Vsi_bi_Vdi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vsi_bi_Vdi_bi+0.0));
  Qbsj3_Vsi_bi_Vsi_bi=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T2+czbsswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsi_bi+(PBSWGS_t*Czbsswg)*(+T2_Vsi_bi_Vsi_bi+0.0));
#endif
#endif
Qbsj3=((PBSWGS_t*Czbsswg)*(T2+czbsswg_p2));
EXIT_IF_ISNAN(((PBSWGS_t*Czbsswg)*(T2+czbsswg_p2)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
Qbsj3_Tempt_GND=0.0;
#endif
Qbsj3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qbsj3_Vdbulk_di_Tempt_GND=0.0;
  Qbsj3_Vdbulk_di_Vdbulk_di=0.0;
  Qbsj3_Vdbulk_di_Vsbulk_si=0.0;
  Qbsj3_Vdbulk_di_Vgi_bi=0.0;
  Qbsj3_Vdbulk_di_Vdi_bi=0.0;
  Qbsj3_Vdbulk_di_Vsi_bi=0.0;
#endif
Qbsj3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qbsj3_Vsbulk_si_Tempt_GND=0.0;
  Qbsj3_Vsbulk_si_Vdbulk_di=0.0;
  Qbsj3_Vsbulk_si_Vsbulk_si=0.0;
  Qbsj3_Vsbulk_si_Vgi_bi=0.0;
  Qbsj3_Vsbulk_si_Vdi_bi=0.0;
  Qbsj3_Vsbulk_si_Vsi_bi=0.0;
#endif
Qbsj3_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Qbsj3_Vgi_bi_Tempt_GND=0.0;
  Qbsj3_Vgi_bi_Vdbulk_di=0.0;
  Qbsj3_Vgi_bi_Vsbulk_si=0.0;
  Qbsj3_Vgi_bi_Vgi_bi=0.0;
  Qbsj3_Vgi_bi_Vdi_bi=0.0;
  Qbsj3_Vgi_bi_Vsi_bi=0.0;
#endif
Qbsj3_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Qbsj3_Vdi_bi_Tempt_GND=0.0;
  Qbsj3_Vdi_bi_Vdbulk_di=0.0;
  Qbsj3_Vdi_bi_Vsbulk_si=0.0;
  Qbsj3_Vdi_bi_Vgi_bi=0.0;
  Qbsj3_Vdi_bi_Vdi_bi=0.0;
  Qbsj3_Vdi_bi_Vsi_bi=0.0;
#endif
Qbsj3_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Qbsj3_Vsi_bi_Tempt_GND=0.0;
  Qbsj3_Vsi_bi_Vdbulk_di=0.0;
  Qbsj3_Vsi_bi_Vsbulk_si=0.0;
  Qbsj3_Vsi_bi_Vgi_bi=0.0;
  Qbsj3_Vsi_bi_Vdi_bi=0.0;
  Qbsj3_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
Qbsj3=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(di,GND)V(sbulk,GND)V(gm,GND)V(si,GND) */
#if defined(_DERIVATE)
Qbsj_Tempt_GND=((Qbsj1_Tempt_GND+Qbsj2_Tempt_GND)+Qbsj3_Tempt_GND);
#endif
Qbsj_Vdbulk_di=((Qbsj1_Vdbulk_di+Qbsj2_Vdbulk_di)+Qbsj3_Vdbulk_di);
#if defined(_DERIVATE2)
  Qbsj_Vdbulk_di_Tempt_GND=(+(+Qbsj1_Vdbulk_di_Tempt_GND+Qbsj2_Vdbulk_di_Tempt_GND)+Qbsj3_Vdbulk_di_Tempt_GND);
  Qbsj_Vdbulk_di_Vdbulk_di=(+(+Qbsj1_Vdbulk_di_Vdbulk_di+Qbsj2_Vdbulk_di_Vdbulk_di)+Qbsj3_Vdbulk_di_Vdbulk_di);
  Qbsj_Vdbulk_di_Vsbulk_si=(+(+Qbsj1_Vdbulk_di_Vsbulk_si+Qbsj2_Vdbulk_di_Vsbulk_si)+Qbsj3_Vdbulk_di_Vsbulk_si);
  Qbsj_Vdbulk_di_Vgi_bi=(+(+Qbsj1_Vdbulk_di_Vgi_bi+Qbsj2_Vdbulk_di_Vgi_bi)+Qbsj3_Vdbulk_di_Vgi_bi);
  Qbsj_Vdbulk_di_Vdi_bi=(+(+Qbsj1_Vdbulk_di_Vdi_bi+Qbsj2_Vdbulk_di_Vdi_bi)+Qbsj3_Vdbulk_di_Vdi_bi);
  Qbsj_Vdbulk_di_Vsi_bi=(+(+Qbsj1_Vdbulk_di_Vsi_bi+Qbsj2_Vdbulk_di_Vsi_bi)+Qbsj3_Vdbulk_di_Vsi_bi);
#endif
Qbsj_Vsbulk_si=((Qbsj1_Vsbulk_si+Qbsj2_Vsbulk_si)+Qbsj3_Vsbulk_si);
#if defined(_DERIVATE2)
  Qbsj_Vsbulk_si_Tempt_GND=(+(+Qbsj1_Vsbulk_si_Tempt_GND+Qbsj2_Vsbulk_si_Tempt_GND)+Qbsj3_Vsbulk_si_Tempt_GND);
  Qbsj_Vsbulk_si_Vdbulk_di=(+(+Qbsj1_Vsbulk_si_Vdbulk_di+Qbsj2_Vsbulk_si_Vdbulk_di)+Qbsj3_Vsbulk_si_Vdbulk_di);
  Qbsj_Vsbulk_si_Vsbulk_si=(+(+Qbsj1_Vsbulk_si_Vsbulk_si+Qbsj2_Vsbulk_si_Vsbulk_si)+Qbsj3_Vsbulk_si_Vsbulk_si);
  Qbsj_Vsbulk_si_Vgi_bi=(+(+Qbsj1_Vsbulk_si_Vgi_bi+Qbsj2_Vsbulk_si_Vgi_bi)+Qbsj3_Vsbulk_si_Vgi_bi);
  Qbsj_Vsbulk_si_Vdi_bi=(+(+Qbsj1_Vsbulk_si_Vdi_bi+Qbsj2_Vsbulk_si_Vdi_bi)+Qbsj3_Vsbulk_si_Vdi_bi);
  Qbsj_Vsbulk_si_Vsi_bi=(+(+Qbsj1_Vsbulk_si_Vsi_bi+Qbsj2_Vsbulk_si_Vsi_bi)+Qbsj3_Vsbulk_si_Vsi_bi);
#endif
Qbsj_Vgi_bi=((Qbsj1_Vgi_bi+Qbsj2_Vgi_bi)+Qbsj3_Vgi_bi);
#if defined(_DERIVATE2)
  Qbsj_Vgi_bi_Tempt_GND=(+(+Qbsj1_Vgi_bi_Tempt_GND+Qbsj2_Vgi_bi_Tempt_GND)+Qbsj3_Vgi_bi_Tempt_GND);
  Qbsj_Vgi_bi_Vdbulk_di=(+(+Qbsj1_Vgi_bi_Vdbulk_di+Qbsj2_Vgi_bi_Vdbulk_di)+Qbsj3_Vgi_bi_Vdbulk_di);
  Qbsj_Vgi_bi_Vsbulk_si=(+(+Qbsj1_Vgi_bi_Vsbulk_si+Qbsj2_Vgi_bi_Vsbulk_si)+Qbsj3_Vgi_bi_Vsbulk_si);
  Qbsj_Vgi_bi_Vgi_bi=(+(+Qbsj1_Vgi_bi_Vgi_bi+Qbsj2_Vgi_bi_Vgi_bi)+Qbsj3_Vgi_bi_Vgi_bi);
  Qbsj_Vgi_bi_Vdi_bi=(+(+Qbsj1_Vgi_bi_Vdi_bi+Qbsj2_Vgi_bi_Vdi_bi)+Qbsj3_Vgi_bi_Vdi_bi);
  Qbsj_Vgi_bi_Vsi_bi=(+(+Qbsj1_Vgi_bi_Vsi_bi+Qbsj2_Vgi_bi_Vsi_bi)+Qbsj3_Vgi_bi_Vsi_bi);
#endif
Qbsj_Vdi_bi=((Qbsj1_Vdi_bi+Qbsj2_Vdi_bi)+Qbsj3_Vdi_bi);
#if defined(_DERIVATE2)
  Qbsj_Vdi_bi_Tempt_GND=(+(+Qbsj1_Vdi_bi_Tempt_GND+Qbsj2_Vdi_bi_Tempt_GND)+Qbsj3_Vdi_bi_Tempt_GND);
  Qbsj_Vdi_bi_Vdbulk_di=(+(+Qbsj1_Vdi_bi_Vdbulk_di+Qbsj2_Vdi_bi_Vdbulk_di)+Qbsj3_Vdi_bi_Vdbulk_di);
  Qbsj_Vdi_bi_Vsbulk_si=(+(+Qbsj1_Vdi_bi_Vsbulk_si+Qbsj2_Vdi_bi_Vsbulk_si)+Qbsj3_Vdi_bi_Vsbulk_si);
  Qbsj_Vdi_bi_Vgi_bi=(+(+Qbsj1_Vdi_bi_Vgi_bi+Qbsj2_Vdi_bi_Vgi_bi)+Qbsj3_Vdi_bi_Vgi_bi);
  Qbsj_Vdi_bi_Vdi_bi=(+(+Qbsj1_Vdi_bi_Vdi_bi+Qbsj2_Vdi_bi_Vdi_bi)+Qbsj3_Vdi_bi_Vdi_bi);
  Qbsj_Vdi_bi_Vsi_bi=(+(+Qbsj1_Vdi_bi_Vsi_bi+Qbsj2_Vdi_bi_Vsi_bi)+Qbsj3_Vdi_bi_Vsi_bi);
#endif
Qbsj_Vsi_bi=((Qbsj1_Vsi_bi+Qbsj2_Vsi_bi)+Qbsj3_Vsi_bi);
#if defined(_DERIVATE2)
  Qbsj_Vsi_bi_Tempt_GND=(+(+Qbsj1_Vsi_bi_Tempt_GND+Qbsj2_Vsi_bi_Tempt_GND)+Qbsj3_Vsi_bi_Tempt_GND);
  Qbsj_Vsi_bi_Vdbulk_di=(+(+Qbsj1_Vsi_bi_Vdbulk_di+Qbsj2_Vsi_bi_Vdbulk_di)+Qbsj3_Vsi_bi_Vdbulk_di);
  Qbsj_Vsi_bi_Vsbulk_si=(+(+Qbsj1_Vsi_bi_Vsbulk_si+Qbsj2_Vsi_bi_Vsbulk_si)+Qbsj3_Vsi_bi_Vsbulk_si);
  Qbsj_Vsi_bi_Vgi_bi=(+(+Qbsj1_Vsi_bi_Vgi_bi+Qbsj2_Vsi_bi_Vgi_bi)+Qbsj3_Vsi_bi_Vgi_bi);
  Qbsj_Vsi_bi_Vdi_bi=(+(+Qbsj1_Vsi_bi_Vdi_bi+Qbsj2_Vsi_bi_Vdi_bi)+Qbsj3_Vsi_bi_Vdi_bi);
  Qbsj_Vsi_bi_Vsi_bi=(+(+Qbsj1_Vsi_bi_Vsi_bi+Qbsj2_Vsi_bi_Vsi_bi)+Qbsj3_Vsi_bi_Vsi_bi);
#endif
#endif
Qbsj=((Qbsj1+Qbsj2)+Qbsj3);
EXIT_IF_ISNAN(((Qbsj1+Qbsj2)+Qbsj3))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
Czbd_Tempt_GND=((CJD_t_Tempt_GND*ADeff)+(CJD_t*ADeff_Tempt_GND));
#endif
Czbd=(CJD_t*ADeff);
EXIT_IF_ISNAN((CJD_t*ADeff))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
Czbdsw_Tempt_GND=((CJSWD_t_Tempt_GND*PDeff)+(CJSWD_t*PDeff_Tempt_GND));
#endif
Czbdsw=(CJSWD_t*PDeff);
EXIT_IF_ISNAN((CJSWD_t*PDeff))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
Czbdswg_Tempt_GND=CJSWGD_t_Tempt_GND*Weffcj*pInst->NF;
#endif
Czbdswg=((CJSWGD_t*Weffcj)*pInst->NF);
EXIT_IF_ISNAN(((CJSWGD_t*Weffcj)*pInst->NF))
{
double m00_pow(d00_pow0,0.1,(-pModel->MJD))
czbd_p1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DYNAMIC)
czbd_p2=((1.0/(1.0-pModel->MJD))*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*czbd_p1)));
EXIT_IF_ISNAN(((1.0/(1.0-pModel->MJD))*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*czbd_p1))))
#endif
{
double m00_pow(d00_pow0,0.1,(-pModel->MJSWD))
czbdsw_p1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DYNAMIC)
czbdsw_p2=((1.0/(1.0-pModel->MJSWD))*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*czbdsw_p1)));
EXIT_IF_ISNAN(((1.0/(1.0-pModel->MJSWD))*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*czbdsw_p1))))
#endif
{
double m00_pow(d00_pow0,0.1,(-pModel->MJSWGD))
czbdswg_p1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DYNAMIC)
czbdswg_p2=((1.0/(1.0-pModel->MJSWGD))*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*czbdswg_p1)));
EXIT_IF_ISNAN(((1.0/(1.0-pModel->MJSWGD))*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*czbdswg_p1))))
#endif
if
((Czbd>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(Vbd_jct_Vdbulk_di/PBD_t);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(0.0/PBD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBD_t/PBD_t+2*Vbd_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Vdbulk_di_Vgm_si=(0.0/PBD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBD_t/PBD_t+2*Vbd_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Vdbulk_di_Vdbulk_di=(Vbd_jct_Vdbulk_di_Vdbulk_di/PBD_t-(Vbd_jct_Vdbulk_di*0.0+Vbd_jct_Vdbulk_di*0.0+Vbd_jct*0.0)/PBD_t/PBD_t+2*Vbd_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Vdbulk_di_Vsbulk_si=(0.0/PBD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBD_t/PBD_t+2*Vbd_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Vdbulk_di_Vgi_bi=(0.0/PBD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBD_t/PBD_t+2*Vbd_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Vdbulk_di_Vdi_bi=(0.0/PBD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBD_t/PBD_t+2*Vbd_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Vdbulk_di_Vsi_bi=(0.0/PBD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBD_t/PBD_t+2*Vbd_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Vdbulk_di_Tempt_GND=(0.0/PBD_t-(Vbd_jct_Vdbulk_di*PBD_t_Tempt_GND+0.0*0.0+Vbd_jct*0.0)/PBD_t/PBD_t+2*Vbd_jct*0.0*PBD_t_Tempt_GND/PBD_t/PBD_t/PBD_t);
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-Vbd_jct*PBD_t_Tempt_GND/PBD_t/PBD_t);
#endif
#endif
T1=(Vbd_jct/PBD_t);
EXIT_IF_ISNAN((Vbd_jct/PBD_t))
if
((T1<0.9))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
arg_Vdbulk_di=(-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  arg_Vdbulk_di_Vdbulk_di=(+0.0-T1_Vdbulk_di_Vdbulk_di);
  arg_Vdbulk_di_Vsbulk_si=(+0.0-T1_Vdbulk_di_Vsbulk_si);
  arg_Vdbulk_di_Vgi_bi=(+0.0-T1_Vdbulk_di_Vgi_bi);
  arg_Vdbulk_di_Vdi_bi=(+0.0-T1_Vdbulk_di_Vdi_bi);
  arg_Vdbulk_di_Vsi_bi=(+0.0-T1_Vdbulk_di_Vsi_bi);
  arg_Vdbulk_di_Tempt_GND=(+0.0-T1_Vdbulk_di_Tempt_GND);
#endif
arg_Vsbulk_si=(-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  arg_Vsbulk_si_Vdbulk_di=(+0.0-T1_Vsbulk_si_Vdbulk_di);
  arg_Vsbulk_si_Vsbulk_si=(+0.0-T1_Vsbulk_si_Vsbulk_si);
  arg_Vsbulk_si_Vgi_bi=(+0.0-T1_Vsbulk_si_Vgi_bi);
  arg_Vsbulk_si_Vdi_bi=(+0.0-T1_Vsbulk_si_Vdi_bi);
  arg_Vsbulk_si_Vsi_bi=(+0.0-T1_Vsbulk_si_Vsi_bi);
  arg_Vsbulk_si_Tempt_GND=(+0.0-T1_Vsbulk_si_Tempt_GND);
#endif
arg_Vgi_bi=(-T1_Vgi_bi);
#if defined(_DERIVATE2)
  arg_Vgi_bi_Vdbulk_di=(+0.0-T1_Vgi_bi_Vdbulk_di);
  arg_Vgi_bi_Vsbulk_si=(+0.0-T1_Vgi_bi_Vsbulk_si);
  arg_Vgi_bi_Vgi_bi=(+0.0-T1_Vgi_bi_Vgi_bi);
  arg_Vgi_bi_Vdi_bi=(+0.0-T1_Vgi_bi_Vdi_bi);
  arg_Vgi_bi_Vsi_bi=(+0.0-T1_Vgi_bi_Vsi_bi);
  arg_Vgi_bi_Tempt_GND=(+0.0-T1_Vgi_bi_Tempt_GND);
#endif
arg_Vdi_bi=(-T1_Vdi_bi);
#if defined(_DERIVATE2)
  arg_Vdi_bi_Vdbulk_di=(+0.0-T1_Vdi_bi_Vdbulk_di);
  arg_Vdi_bi_Vsbulk_si=(+0.0-T1_Vdi_bi_Vsbulk_si);
  arg_Vdi_bi_Vgi_bi=(+0.0-T1_Vdi_bi_Vgi_bi);
  arg_Vdi_bi_Vdi_bi=(+0.0-T1_Vdi_bi_Vdi_bi);
  arg_Vdi_bi_Vsi_bi=(+0.0-T1_Vdi_bi_Vsi_bi);
  arg_Vdi_bi_Tempt_GND=(+0.0-T1_Vdi_bi_Tempt_GND);
#endif
arg_Vsi_bi=(-T1_Vsi_bi);
#if defined(_DERIVATE2)
  arg_Vsi_bi_Vdbulk_di=(+0.0-T1_Vsi_bi_Vdbulk_di);
  arg_Vsi_bi_Vsbulk_si=(+0.0-T1_Vsi_bi_Vsbulk_si);
  arg_Vsi_bi_Vgi_bi=(+0.0-T1_Vsi_bi_Vgi_bi);
  arg_Vsi_bi_Vdi_bi=(+0.0-T1_Vsi_bi_Vdi_bi);
  arg_Vsi_bi_Vsi_bi=(+0.0-T1_Vsi_bi_Vsi_bi);
  arg_Vsi_bi_Tempt_GND=(+0.0-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
arg_Tempt_GND=(-T1_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=(-arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsbulk_si=(-arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vgi_bi=(-arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_bi=(-arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsi_bi=(-arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=bsimbulk_d_lexp(((-pModel->MJD)*bsimbulk_lln(arg)),((-pModel->MJD)*bsimbulk_d_lln(arg,arg_Vdbulk_di)));
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJD)*arg_Vdbulk_di_Vdbulk_di);
  sarg_Vdbulk_di_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJD)*arg_Vdbulk_di_Vsbulk_si);
  sarg_Vdbulk_di_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJD)*arg_Vdbulk_di_Vgi_bi);
  sarg_Vdbulk_di_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJD)*arg_Vdbulk_di_Vdi_bi);
  sarg_Vdbulk_di_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJD)*arg_Vdbulk_di_Vsi_bi);
  sarg_Vdbulk_di_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJD)*arg_Vdbulk_di_Tempt_GND);
#endif
sarg_Vsbulk_si=bsimbulk_d_lexp(((-pModel->MJD)*bsimbulk_lln(arg)),((-pModel->MJD)*bsimbulk_d_lln(arg,arg_Vsbulk_si)));
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJD)*arg_Vsbulk_si_Vdbulk_di);
  sarg_Vsbulk_si_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJD)*arg_Vsbulk_si_Vsbulk_si);
  sarg_Vsbulk_si_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJD)*arg_Vsbulk_si_Vgi_bi);
  sarg_Vsbulk_si_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJD)*arg_Vsbulk_si_Vdi_bi);
  sarg_Vsbulk_si_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJD)*arg_Vsbulk_si_Vsi_bi);
  sarg_Vsbulk_si_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJD)*arg_Vsbulk_si_Tempt_GND);
#endif
sarg_Vgi_bi=bsimbulk_d_lexp(((-pModel->MJD)*bsimbulk_lln(arg)),((-pModel->MJD)*bsimbulk_d_lln(arg,arg_Vgi_bi)));
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJD)*arg_Vgi_bi_Vdbulk_di);
  sarg_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJD)*arg_Vgi_bi_Vsbulk_si);
  sarg_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJD)*arg_Vgi_bi_Vgi_bi);
  sarg_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJD)*arg_Vgi_bi_Vdi_bi);
  sarg_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJD)*arg_Vgi_bi_Vsi_bi);
  sarg_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJD)*arg_Vgi_bi_Tempt_GND);
#endif
sarg_Vdi_bi=bsimbulk_d_lexp(((-pModel->MJD)*bsimbulk_lln(arg)),((-pModel->MJD)*bsimbulk_d_lln(arg,arg_Vdi_bi)));
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJD)*arg_Vdi_bi_Vdbulk_di);
  sarg_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJD)*arg_Vdi_bi_Vsbulk_si);
  sarg_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJD)*arg_Vdi_bi_Vgi_bi);
  sarg_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJD)*arg_Vdi_bi_Vdi_bi);
  sarg_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJD)*arg_Vdi_bi_Vsi_bi);
  sarg_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJD)*arg_Vdi_bi_Tempt_GND);
#endif
sarg_Vsi_bi=bsimbulk_d_lexp(((-pModel->MJD)*bsimbulk_lln(arg)),((-pModel->MJD)*bsimbulk_d_lln(arg,arg_Vsi_bi)));
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJD)*arg_Vsi_bi_Vdbulk_di);
  sarg_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJD)*arg_Vsi_bi_Vsbulk_si);
  sarg_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJD)*arg_Vsi_bi_Vgi_bi);
  sarg_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJD)*arg_Vsi_bi_Vdi_bi);
  sarg_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJD)*arg_Vsi_bi_Vsi_bi);
  sarg_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJD)*arg_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=bsimbulk_d_lexp(((-pModel->MJD)*bsimbulk_lln(arg)),((-pModel->MJD)*bsimbulk_d_lln(arg,arg_Tempt_GND)));
#endif
#endif
sarg=bsimbulk_lexp(((-pModel->MJD)*bsimbulk_lln(arg)));
EXIT_IF_ISNAN(bsimbulk_lexp(((-pModel->MJD)*bsimbulk_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Qbdj1_Tempt_GND=(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJD));
#endif
Qbdj1_Vdbulk_di=(((PBD_t*Czbd)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qbdj1_Vdbulk_di_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdbulk_di_Tempt_GND*sarg+arg_Vdbulk_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdbulk_di_Vdbulk_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdbulk_di_Vdbulk_di*sarg+arg_Vdbulk_di*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdbulk_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdbulk_di_Vsbulk_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdbulk_di_Vsbulk_si*sarg+arg_Vdbulk_di*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsbulk_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdbulk_di_Vgi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdbulk_di_Vgi_bi*sarg+arg_Vdbulk_di*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vgi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdbulk_di_Vdi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdbulk_di_Vdi_bi*sarg+arg_Vdbulk_di*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdbulk_di_Vsi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdbulk_di_Vsi_bi*sarg+arg_Vdbulk_di*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qbdj1_Vsbulk_si=(((PBD_t*Czbd)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qbdj1_Vsbulk_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsbulk_si_Tempt_GND*sarg+arg_Vsbulk_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsbulk_si_Vdbulk_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsbulk_si_Vdbulk_di*sarg+arg_Vsbulk_si*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdbulk_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsbulk_si_Vsbulk_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsbulk_si_Vsbulk_si*sarg+arg_Vsbulk_si*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsbulk_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsbulk_si_Vgi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsbulk_si_Vgi_bi*sarg+arg_Vsbulk_si*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vgi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsbulk_si_Vdi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsbulk_si_Vdi_bi*sarg+arg_Vsbulk_si*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsbulk_si_Vsi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsbulk_si_Vsi_bi*sarg+arg_Vsbulk_si*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qbdj1_Vgi_bi=(((PBD_t*Czbd)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qbdj1_Vgi_bi_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vgi_bi_Tempt_GND*sarg+arg_Vgi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vgi_bi+arg*sarg_Vgi_bi_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vgi_bi_Vdbulk_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vgi_bi_Vdbulk_di*sarg+arg_Vgi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdbulk_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vgi_bi_Vsbulk_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vgi_bi_Vsbulk_si*sarg+arg_Vgi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsbulk_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vgi_bi_Vgi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vgi_bi_Vgi_bi*sarg+arg_Vgi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vgi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vgi_bi_Vdi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vgi_bi_Vdi_bi*sarg+arg_Vgi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vgi_bi_Vsi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vgi_bi_Vsi_bi*sarg+arg_Vgi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qbdj1_Vdi_bi=(((PBD_t*Czbd)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qbdj1_Vdi_bi_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_bi_Tempt_GND*sarg+arg_Vdi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_bi+arg*sarg_Vdi_bi_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdi_bi_Vdbulk_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_bi_Vdbulk_di*sarg+arg_Vdi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdbulk_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdi_bi_Vsbulk_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_bi_Vsbulk_si*sarg+arg_Vdi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsbulk_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdi_bi_Vgi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_bi_Vgi_bi*sarg+arg_Vdi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vgi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdi_bi_Vdi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_bi_Vdi_bi*sarg+arg_Vdi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vdi_bi_Vsi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_bi_Vsi_bi*sarg+arg_Vdi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qbdj1_Vsi_bi=(((PBD_t*Czbd)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qbdj1_Vsi_bi_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsi_bi_Tempt_GND*sarg+arg_Vsi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsi_bi+arg*sarg_Vsi_bi_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsi_bi_Vdbulk_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsi_bi_Vdbulk_di*sarg+arg_Vsi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdbulk_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsi_bi_Vsbulk_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsi_bi_Vsbulk_si*sarg+arg_Vsi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsbulk_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsi_bi_Vgi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsi_bi_Vgi_bi*sarg+arg_Vsi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vgi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsi_bi_Vdi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsi_bi_Vdi_bi*sarg+arg_Vsi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qbdj1_Vsi_bi_Vsi_bi=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBD_t*Czbd)*(+0.0-(+arg_Vsi_bi_Vsi_bi*sarg+arg_Vsi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsi_bi)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
#endif
Qbdj1=(((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD));
EXIT_IF_ISNAN((((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD)))
#endif
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((czbd_p1*T1_Vdbulk_di)*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((czbd_p1*(T1-1.0))*((5.0*pModel->MJD)*T1_Vdbulk_di)));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdbulk_di+czbd_p1*(+T1_Vdbulk_di_Vgm_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_di)))+((czbd_p1*T1_Vgm_di))*((5.0*pModel->MJD)*T1_Vdbulk_di)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJD)*(+T1_Vdbulk_di_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+czbd_p1*(+T1_Vdbulk_di_Vgm_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_si)))+((czbd_p1*T1_Vgm_si))*((5.0*pModel->MJD)*T1_Vdbulk_di)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJD)*(+T1_Vdbulk_di_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+czbd_p1*(+T1_Vdbulk_di_Vdbulk_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdbulk_di)))+((czbd_p1*T1_Vdbulk_di))*((5.0*pModel->MJD)*T1_Vdbulk_di)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJD)*(+T1_Vdbulk_di_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+czbd_p1*(+T1_Vdbulk_di_Vsbulk_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsbulk_si)))+((czbd_p1*T1_Vsbulk_si))*((5.0*pModel->MJD)*T1_Vdbulk_di)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJD)*(+T1_Vdbulk_di_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdbulk_di+czbd_p1*(+T1_Vdbulk_di_Vgi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgi_bi)))+((czbd_p1*T1_Vgi_bi))*((5.0*pModel->MJD)*T1_Vdbulk_di)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJD)*(+T1_Vdbulk_di_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdbulk_di+czbd_p1*(+T1_Vdbulk_di_Vdi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_bi)))+((czbd_p1*T1_Vdi_bi))*((5.0*pModel->MJD)*T1_Vdbulk_di)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJD)*(+T1_Vdbulk_di_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdbulk_di+czbd_p1*(+T1_Vdbulk_di_Vsi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsi_bi)))+((czbd_p1*T1_Vsi_bi))*((5.0*pModel->MJD)*T1_Vdbulk_di)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJD)*(+T1_Vdbulk_di_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdbulk_di+czbd_p1*(+T1_Vdbulk_di_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+((czbd_p1*T1_Tempt_GND))*((5.0*pModel->MJD)*T1_Vdbulk_di)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJD)*(+T1_Vdbulk_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsbulk_si=(((czbd_p1*T1_Vsbulk_si)*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((czbd_p1*(T1-1.0))*((5.0*pModel->MJD)*T1_Vsbulk_si)));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsbulk_si+czbd_p1*(+T1_Vsbulk_si_Vgm_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_di)))+((czbd_p1*T1_Vgm_di))*((5.0*pModel->MJD)*T1_Vsbulk_si)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJD)*(+T1_Vsbulk_si_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+czbd_p1*(+T1_Vsbulk_si_Vgm_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_si)))+((czbd_p1*T1_Vgm_si))*((5.0*pModel->MJD)*T1_Vsbulk_si)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJD)*(+T1_Vsbulk_si_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+czbd_p1*(+T1_Vsbulk_si_Vdbulk_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdbulk_di)))+((czbd_p1*T1_Vdbulk_di))*((5.0*pModel->MJD)*T1_Vsbulk_si)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJD)*(+T1_Vsbulk_si_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+czbd_p1*(+T1_Vsbulk_si_Vsbulk_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsbulk_si)))+((czbd_p1*T1_Vsbulk_si))*((5.0*pModel->MJD)*T1_Vsbulk_si)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJD)*(+T1_Vsbulk_si_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsbulk_si+czbd_p1*(+T1_Vsbulk_si_Vgi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgi_bi)))+((czbd_p1*T1_Vgi_bi))*((5.0*pModel->MJD)*T1_Vsbulk_si)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJD)*(+T1_Vsbulk_si_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsbulk_si+czbd_p1*(+T1_Vsbulk_si_Vdi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_bi)))+((czbd_p1*T1_Vdi_bi))*((5.0*pModel->MJD)*T1_Vsbulk_si)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJD)*(+T1_Vsbulk_si_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsbulk_si+czbd_p1*(+T1_Vsbulk_si_Vsi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsi_bi)))+((czbd_p1*T1_Vsi_bi))*((5.0*pModel->MJD)*T1_Vsbulk_si)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJD)*(+T1_Vsbulk_si_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsbulk_si+czbd_p1*(+T1_Vsbulk_si_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+((czbd_p1*T1_Tempt_GND))*((5.0*pModel->MJD)*T1_Vsbulk_si)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJD)*(+T1_Vsbulk_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vgi_bi=(((czbd_p1*T1_Vgi_bi)*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((czbd_p1*(T1-1.0))*((5.0*pModel->MJD)*T1_Vgi_bi)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+czbd_p1*(+T1_Vgi_bi_Vgm_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_di)))+((czbd_p1*T1_Vgm_di))*((5.0*pModel->MJD)*T1_Vgi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJD)*(+T1_Vgi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+czbd_p1*(+T1_Vgi_bi_Vgm_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_si)))+((czbd_p1*T1_Vgm_si))*((5.0*pModel->MJD)*T1_Vgi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJD)*(+T1_Vgi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+czbd_p1*(+T1_Vgi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdbulk_di)))+((czbd_p1*T1_Vdbulk_di))*((5.0*pModel->MJD)*T1_Vgi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJD)*(+T1_Vgi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+czbd_p1*(+T1_Vgi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsbulk_si)))+((czbd_p1*T1_Vsbulk_si))*((5.0*pModel->MJD)*T1_Vgi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJD)*(+T1_Vgi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+czbd_p1*(+T1_Vgi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgi_bi)))+((czbd_p1*T1_Vgi_bi))*((5.0*pModel->MJD)*T1_Vgi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJD)*(+T1_Vgi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+czbd_p1*(+T1_Vgi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_bi)))+((czbd_p1*T1_Vdi_bi))*((5.0*pModel->MJD)*T1_Vgi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJD)*(+T1_Vgi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+czbd_p1*(+T1_Vgi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsi_bi)))+((czbd_p1*T1_Vsi_bi))*((5.0*pModel->MJD)*T1_Vgi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJD)*(+T1_Vgi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+czbd_p1*(+T1_Vgi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+((czbd_p1*T1_Tempt_GND))*((5.0*pModel->MJD)*T1_Vgi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(5.0*pModel->MJD)*(+T1_Vgi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vdi_bi=(((czbd_p1*T1_Vdi_bi)*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((czbd_p1*(T1-1.0))*((5.0*pModel->MJD)*T1_Vdi_bi)));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+czbd_p1*(+T1_Vdi_bi_Vgm_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_di)))+((czbd_p1*T1_Vgm_di))*((5.0*pModel->MJD)*T1_Vdi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJD)*(+T1_Vdi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+czbd_p1*(+T1_Vdi_bi_Vgm_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_si)))+((czbd_p1*T1_Vgm_si))*((5.0*pModel->MJD)*T1_Vdi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJD)*(+T1_Vdi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+czbd_p1*(+T1_Vdi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdbulk_di)))+((czbd_p1*T1_Vdbulk_di))*((5.0*pModel->MJD)*T1_Vdi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJD)*(+T1_Vdi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+czbd_p1*(+T1_Vdi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsbulk_si)))+((czbd_p1*T1_Vsbulk_si))*((5.0*pModel->MJD)*T1_Vdi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJD)*(+T1_Vdi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+czbd_p1*(+T1_Vdi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgi_bi)))+((czbd_p1*T1_Vgi_bi))*((5.0*pModel->MJD)*T1_Vdi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJD)*(+T1_Vdi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+czbd_p1*(+T1_Vdi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_bi)))+((czbd_p1*T1_Vdi_bi))*((5.0*pModel->MJD)*T1_Vdi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJD)*(+T1_Vdi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+czbd_p1*(+T1_Vdi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsi_bi)))+((czbd_p1*T1_Vsi_bi))*((5.0*pModel->MJD)*T1_Vdi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJD)*(+T1_Vdi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+czbd_p1*(+T1_Vdi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+((czbd_p1*T1_Tempt_GND))*((5.0*pModel->MJD)*T1_Vdi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(5.0*pModel->MJD)*(+T1_Vdi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsi_bi=(((czbd_p1*T1_Vsi_bi)*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((czbd_p1*(T1-1.0))*((5.0*pModel->MJD)*T1_Vsi_bi)));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+czbd_p1*(+T1_Vsi_bi_Vgm_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_di)))+((czbd_p1*T1_Vgm_di))*((5.0*pModel->MJD)*T1_Vsi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJD)*(+T1_Vsi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+czbd_p1*(+T1_Vsi_bi_Vgm_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgm_si)))+((czbd_p1*T1_Vgm_si))*((5.0*pModel->MJD)*T1_Vsi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJD)*(+T1_Vsi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+czbd_p1*(+T1_Vsi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdbulk_di)))+((czbd_p1*T1_Vdbulk_di))*((5.0*pModel->MJD)*T1_Vsi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJD)*(+T1_Vsi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+czbd_p1*(+T1_Vsi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsbulk_si)))+((czbd_p1*T1_Vsbulk_si))*((5.0*pModel->MJD)*T1_Vsi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJD)*(+T1_Vsi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+czbd_p1*(+T1_Vsi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vgi_bi)))+((czbd_p1*T1_Vgi_bi))*((5.0*pModel->MJD)*T1_Vsi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJD)*(+T1_Vsi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+czbd_p1*(+T1_Vsi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_bi)))+((czbd_p1*T1_Vdi_bi))*((5.0*pModel->MJD)*T1_Vsi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJD)*(+T1_Vsi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+czbd_p1*(+T1_Vsi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vsi_bi)))+((czbd_p1*T1_Vsi_bi))*((5.0*pModel->MJD)*T1_Vsi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJD)*(+T1_Vsi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+czbd_p1*(+T1_Vsi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+(czbd_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+((czbd_p1*T1_Tempt_GND))*((5.0*pModel->MJD)*T1_Vsi_bi)+(czbd_p1*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(5.0*pModel->MJD)*(+T1_Vsi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((czbd_p1*T1_Tempt_GND)*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((czbd_p1*(T1-1.0))*((5.0*pModel->MJD)*T1_Tempt_GND)));
#endif
#endif
T2=((czbd_p1*(T1-1.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)));
EXIT_IF_ISNAN(((czbd_p1*(T1-1.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Qbdj1_Tempt_GND=((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(T2+czbd_p2))+((PBD_t*Czbd)*T2_Tempt_GND));
#endif
Qbdj1_Vdbulk_di=((PBD_t*Czbd)*T2_Vdbulk_di);
#if defined(_DERIVATE2)
  Qbdj1_Vdbulk_di_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Tempt_GND+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*T2_Vdbulk_di+(PBD_t*Czbd)*(+T2_Vdbulk_di_Tempt_GND+0.0));
  Qbdj1_Vdbulk_di_Vdbulk_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdbulk_di+(PBD_t*Czbd)*(+T2_Vdbulk_di_Vdbulk_di+0.0));
  Qbdj1_Vdbulk_di_Vsbulk_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdbulk_di+(PBD_t*Czbd)*(+T2_Vdbulk_di_Vsbulk_si+0.0));
  Qbdj1_Vdbulk_di_Vgi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdbulk_di+(PBD_t*Czbd)*(+T2_Vdbulk_di_Vgi_bi+0.0));
  Qbdj1_Vdbulk_di_Vdi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdbulk_di+(PBD_t*Czbd)*(+T2_Vdbulk_di_Vdi_bi+0.0));
  Qbdj1_Vdbulk_di_Vsi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdbulk_di+(PBD_t*Czbd)*(+T2_Vdbulk_di_Vsi_bi+0.0));
#endif
Qbdj1_Vsbulk_si=((PBD_t*Czbd)*T2_Vsbulk_si);
#if defined(_DERIVATE2)
  Qbdj1_Vsbulk_si_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Tempt_GND+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*T2_Vsbulk_si+(PBD_t*Czbd)*(+T2_Vsbulk_si_Tempt_GND+0.0));
  Qbdj1_Vsbulk_si_Vdbulk_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsbulk_si+(PBD_t*Czbd)*(+T2_Vsbulk_si_Vdbulk_di+0.0));
  Qbdj1_Vsbulk_si_Vsbulk_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsbulk_si+(PBD_t*Czbd)*(+T2_Vsbulk_si_Vsbulk_si+0.0));
  Qbdj1_Vsbulk_si_Vgi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsbulk_si+(PBD_t*Czbd)*(+T2_Vsbulk_si_Vgi_bi+0.0));
  Qbdj1_Vsbulk_si_Vdi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsbulk_si+(PBD_t*Czbd)*(+T2_Vsbulk_si_Vdi_bi+0.0));
  Qbdj1_Vsbulk_si_Vsi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsbulk_si+(PBD_t*Czbd)*(+T2_Vsbulk_si_Vsi_bi+0.0));
#endif
Qbdj1_Vgi_bi=((PBD_t*Czbd)*T2_Vgi_bi);
#if defined(_DERIVATE2)
  Qbdj1_Vgi_bi_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Tempt_GND+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*T2_Vgi_bi+(PBD_t*Czbd)*(+T2_Vgi_bi_Tempt_GND+0.0));
  Qbdj1_Vgi_bi_Vdbulk_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vgi_bi+(PBD_t*Czbd)*(+T2_Vgi_bi_Vdbulk_di+0.0));
  Qbdj1_Vgi_bi_Vsbulk_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vgi_bi+(PBD_t*Czbd)*(+T2_Vgi_bi_Vsbulk_si+0.0));
  Qbdj1_Vgi_bi_Vgi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vgi_bi+(PBD_t*Czbd)*(+T2_Vgi_bi_Vgi_bi+0.0));
  Qbdj1_Vgi_bi_Vdi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vgi_bi+(PBD_t*Czbd)*(+T2_Vgi_bi_Vdi_bi+0.0));
  Qbdj1_Vgi_bi_Vsi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vgi_bi+(PBD_t*Czbd)*(+T2_Vgi_bi_Vsi_bi+0.0));
#endif
Qbdj1_Vdi_bi=((PBD_t*Czbd)*T2_Vdi_bi);
#if defined(_DERIVATE2)
  Qbdj1_Vdi_bi_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Tempt_GND+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*T2_Vdi_bi+(PBD_t*Czbd)*(+T2_Vdi_bi_Tempt_GND+0.0));
  Qbdj1_Vdi_bi_Vdbulk_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdi_bi+(PBD_t*Czbd)*(+T2_Vdi_bi_Vdbulk_di+0.0));
  Qbdj1_Vdi_bi_Vsbulk_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdi_bi+(PBD_t*Czbd)*(+T2_Vdi_bi_Vsbulk_si+0.0));
  Qbdj1_Vdi_bi_Vgi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdi_bi+(PBD_t*Czbd)*(+T2_Vdi_bi_Vgi_bi+0.0));
  Qbdj1_Vdi_bi_Vdi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdi_bi+(PBD_t*Czbd)*(+T2_Vdi_bi_Vdi_bi+0.0));
  Qbdj1_Vdi_bi_Vsi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdi_bi+(PBD_t*Czbd)*(+T2_Vdi_bi_Vsi_bi+0.0));
#endif
Qbdj1_Vsi_bi=((PBD_t*Czbd)*T2_Vsi_bi);
#if defined(_DERIVATE2)
  Qbdj1_Vsi_bi_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Tempt_GND+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*T2_Vsi_bi+(PBD_t*Czbd)*(+T2_Vsi_bi_Tempt_GND+0.0));
  Qbdj1_Vsi_bi_Vdbulk_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsi_bi+(PBD_t*Czbd)*(+T2_Vsi_bi_Vdbulk_di+0.0));
  Qbdj1_Vsi_bi_Vsbulk_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsi_bi+(PBD_t*Czbd)*(+T2_Vsi_bi_Vsbulk_si+0.0));
  Qbdj1_Vsi_bi_Vgi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsi_bi+(PBD_t*Czbd)*(+T2_Vsi_bi_Vgi_bi+0.0));
  Qbdj1_Vsi_bi_Vdi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsi_bi+(PBD_t*Czbd)*(+T2_Vsi_bi_Vdi_bi+0.0));
  Qbdj1_Vsi_bi_Vsi_bi=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T2+czbd_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsi_bi+(PBD_t*Czbd)*(+T2_Vsi_bi_Vsi_bi+0.0));
#endif
#endif
Qbdj1=((PBD_t*Czbd)*(T2+czbd_p2));
EXIT_IF_ISNAN(((PBD_t*Czbd)*(T2+czbd_p2)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Qbdj1_Tempt_GND=0.0;
#endif
Qbdj1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qbdj1_Vdbulk_di_Tempt_GND=0.0;
  Qbdj1_Vdbulk_di_Vdbulk_di=0.0;
  Qbdj1_Vdbulk_di_Vsbulk_si=0.0;
  Qbdj1_Vdbulk_di_Vgi_bi=0.0;
  Qbdj1_Vdbulk_di_Vdi_bi=0.0;
  Qbdj1_Vdbulk_di_Vsi_bi=0.0;
#endif
Qbdj1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qbdj1_Vsbulk_si_Tempt_GND=0.0;
  Qbdj1_Vsbulk_si_Vdbulk_di=0.0;
  Qbdj1_Vsbulk_si_Vsbulk_si=0.0;
  Qbdj1_Vsbulk_si_Vgi_bi=0.0;
  Qbdj1_Vsbulk_si_Vdi_bi=0.0;
  Qbdj1_Vsbulk_si_Vsi_bi=0.0;
#endif
Qbdj1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Qbdj1_Vgi_bi_Tempt_GND=0.0;
  Qbdj1_Vgi_bi_Vdbulk_di=0.0;
  Qbdj1_Vgi_bi_Vsbulk_si=0.0;
  Qbdj1_Vgi_bi_Vgi_bi=0.0;
  Qbdj1_Vgi_bi_Vdi_bi=0.0;
  Qbdj1_Vgi_bi_Vsi_bi=0.0;
#endif
Qbdj1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Qbdj1_Vdi_bi_Tempt_GND=0.0;
  Qbdj1_Vdi_bi_Vdbulk_di=0.0;
  Qbdj1_Vdi_bi_Vsbulk_si=0.0;
  Qbdj1_Vdi_bi_Vgi_bi=0.0;
  Qbdj1_Vdi_bi_Vdi_bi=0.0;
  Qbdj1_Vdi_bi_Vsi_bi=0.0;
#endif
Qbdj1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Qbdj1_Vsi_bi_Tempt_GND=0.0;
  Qbdj1_Vsi_bi_Vdbulk_di=0.0;
  Qbdj1_Vsi_bi_Vsbulk_si=0.0;
  Qbdj1_Vsi_bi_Vgi_bi=0.0;
  Qbdj1_Vsi_bi_Vdi_bi=0.0;
  Qbdj1_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
Qbdj1=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
if
((Czbdsw>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(Vbd_jct_Vdbulk_di/PBSWD_t);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(0.0/PBSWD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWD_t/PBSWD_t+2*Vbd_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Vdbulk_di_Vgm_si=(0.0/PBSWD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWD_t/PBSWD_t+2*Vbd_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Vdbulk_di_Vdbulk_di=(Vbd_jct_Vdbulk_di_Vdbulk_di/PBSWD_t-(Vbd_jct_Vdbulk_di*0.0+Vbd_jct_Vdbulk_di*0.0+Vbd_jct*0.0)/PBSWD_t/PBSWD_t+2*Vbd_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Vdbulk_di_Vsbulk_si=(0.0/PBSWD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWD_t/PBSWD_t+2*Vbd_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Vdbulk_di_Vgi_bi=(0.0/PBSWD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWD_t/PBSWD_t+2*Vbd_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Vdbulk_di_Vdi_bi=(0.0/PBSWD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWD_t/PBSWD_t+2*Vbd_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Vdbulk_di_Vsi_bi=(0.0/PBSWD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWD_t/PBSWD_t+2*Vbd_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Vdbulk_di_Tempt_GND=(0.0/PBSWD_t-(Vbd_jct_Vdbulk_di*PBSWD_t_Tempt_GND+0.0*0.0+Vbd_jct*0.0)/PBSWD_t/PBSWD_t+2*Vbd_jct*0.0*PBSWD_t_Tempt_GND/PBSWD_t/PBSWD_t/PBSWD_t);
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-Vbd_jct*PBSWD_t_Tempt_GND/PBSWD_t/PBSWD_t);
#endif
#endif
T1=(Vbd_jct/PBSWD_t);
EXIT_IF_ISNAN((Vbd_jct/PBSWD_t))
if
((T1<0.9))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
arg_Vdbulk_di=(-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  arg_Vdbulk_di_Vdbulk_di=(+0.0-T1_Vdbulk_di_Vdbulk_di);
  arg_Vdbulk_di_Vsbulk_si=(+0.0-T1_Vdbulk_di_Vsbulk_si);
  arg_Vdbulk_di_Vgi_bi=(+0.0-T1_Vdbulk_di_Vgi_bi);
  arg_Vdbulk_di_Vdi_bi=(+0.0-T1_Vdbulk_di_Vdi_bi);
  arg_Vdbulk_di_Vsi_bi=(+0.0-T1_Vdbulk_di_Vsi_bi);
  arg_Vdbulk_di_Tempt_GND=(+0.0-T1_Vdbulk_di_Tempt_GND);
#endif
arg_Vsbulk_si=(-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  arg_Vsbulk_si_Vdbulk_di=(+0.0-T1_Vsbulk_si_Vdbulk_di);
  arg_Vsbulk_si_Vsbulk_si=(+0.0-T1_Vsbulk_si_Vsbulk_si);
  arg_Vsbulk_si_Vgi_bi=(+0.0-T1_Vsbulk_si_Vgi_bi);
  arg_Vsbulk_si_Vdi_bi=(+0.0-T1_Vsbulk_si_Vdi_bi);
  arg_Vsbulk_si_Vsi_bi=(+0.0-T1_Vsbulk_si_Vsi_bi);
  arg_Vsbulk_si_Tempt_GND=(+0.0-T1_Vsbulk_si_Tempt_GND);
#endif
arg_Vgi_bi=(-T1_Vgi_bi);
#if defined(_DERIVATE2)
  arg_Vgi_bi_Vdbulk_di=(+0.0-T1_Vgi_bi_Vdbulk_di);
  arg_Vgi_bi_Vsbulk_si=(+0.0-T1_Vgi_bi_Vsbulk_si);
  arg_Vgi_bi_Vgi_bi=(+0.0-T1_Vgi_bi_Vgi_bi);
  arg_Vgi_bi_Vdi_bi=(+0.0-T1_Vgi_bi_Vdi_bi);
  arg_Vgi_bi_Vsi_bi=(+0.0-T1_Vgi_bi_Vsi_bi);
  arg_Vgi_bi_Tempt_GND=(+0.0-T1_Vgi_bi_Tempt_GND);
#endif
arg_Vdi_bi=(-T1_Vdi_bi);
#if defined(_DERIVATE2)
  arg_Vdi_bi_Vdbulk_di=(+0.0-T1_Vdi_bi_Vdbulk_di);
  arg_Vdi_bi_Vsbulk_si=(+0.0-T1_Vdi_bi_Vsbulk_si);
  arg_Vdi_bi_Vgi_bi=(+0.0-T1_Vdi_bi_Vgi_bi);
  arg_Vdi_bi_Vdi_bi=(+0.0-T1_Vdi_bi_Vdi_bi);
  arg_Vdi_bi_Vsi_bi=(+0.0-T1_Vdi_bi_Vsi_bi);
  arg_Vdi_bi_Tempt_GND=(+0.0-T1_Vdi_bi_Tempt_GND);
#endif
arg_Vsi_bi=(-T1_Vsi_bi);
#if defined(_DERIVATE2)
  arg_Vsi_bi_Vdbulk_di=(+0.0-T1_Vsi_bi_Vdbulk_di);
  arg_Vsi_bi_Vsbulk_si=(+0.0-T1_Vsi_bi_Vsbulk_si);
  arg_Vsi_bi_Vgi_bi=(+0.0-T1_Vsi_bi_Vgi_bi);
  arg_Vsi_bi_Vdi_bi=(+0.0-T1_Vsi_bi_Vdi_bi);
  arg_Vsi_bi_Vsi_bi=(+0.0-T1_Vsi_bi_Vsi_bi);
  arg_Vsi_bi_Tempt_GND=(+0.0-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
arg_Tempt_GND=(-T1_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=(-arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsbulk_si=(-arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vgi_bi=(-arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_bi=(-arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsi_bi=(-arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=bsimbulk_d_lexp(((-pModel->MJSWD)*bsimbulk_lln(arg)),((-pModel->MJSWD)*bsimbulk_d_lln(arg,arg_Vdbulk_di)));
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWD)*arg_Vdbulk_di_Vdbulk_di);
  sarg_Vdbulk_di_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWD)*arg_Vdbulk_di_Vsbulk_si);
  sarg_Vdbulk_di_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWD)*arg_Vdbulk_di_Vgi_bi);
  sarg_Vdbulk_di_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWD)*arg_Vdbulk_di_Vdi_bi);
  sarg_Vdbulk_di_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWD)*arg_Vdbulk_di_Vsi_bi);
  sarg_Vdbulk_di_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWD)*arg_Vdbulk_di_Tempt_GND);
#endif
sarg_Vsbulk_si=bsimbulk_d_lexp(((-pModel->MJSWD)*bsimbulk_lln(arg)),((-pModel->MJSWD)*bsimbulk_d_lln(arg,arg_Vsbulk_si)));
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWD)*arg_Vsbulk_si_Vdbulk_di);
  sarg_Vsbulk_si_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWD)*arg_Vsbulk_si_Vsbulk_si);
  sarg_Vsbulk_si_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWD)*arg_Vsbulk_si_Vgi_bi);
  sarg_Vsbulk_si_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWD)*arg_Vsbulk_si_Vdi_bi);
  sarg_Vsbulk_si_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWD)*arg_Vsbulk_si_Vsi_bi);
  sarg_Vsbulk_si_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWD)*arg_Vsbulk_si_Tempt_GND);
#endif
sarg_Vgi_bi=bsimbulk_d_lexp(((-pModel->MJSWD)*bsimbulk_lln(arg)),((-pModel->MJSWD)*bsimbulk_d_lln(arg,arg_Vgi_bi)));
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWD)*arg_Vgi_bi_Vdbulk_di);
  sarg_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWD)*arg_Vgi_bi_Vsbulk_si);
  sarg_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWD)*arg_Vgi_bi_Vgi_bi);
  sarg_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWD)*arg_Vgi_bi_Vdi_bi);
  sarg_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWD)*arg_Vgi_bi_Vsi_bi);
  sarg_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWD)*arg_Vgi_bi_Tempt_GND);
#endif
sarg_Vdi_bi=bsimbulk_d_lexp(((-pModel->MJSWD)*bsimbulk_lln(arg)),((-pModel->MJSWD)*bsimbulk_d_lln(arg,arg_Vdi_bi)));
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWD)*arg_Vdi_bi_Vdbulk_di);
  sarg_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWD)*arg_Vdi_bi_Vsbulk_si);
  sarg_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWD)*arg_Vdi_bi_Vgi_bi);
  sarg_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWD)*arg_Vdi_bi_Vdi_bi);
  sarg_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWD)*arg_Vdi_bi_Vsi_bi);
  sarg_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWD)*arg_Vdi_bi_Tempt_GND);
#endif
sarg_Vsi_bi=bsimbulk_d_lexp(((-pModel->MJSWD)*bsimbulk_lln(arg)),((-pModel->MJSWD)*bsimbulk_d_lln(arg,arg_Vsi_bi)));
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWD)*arg_Vsi_bi_Vdbulk_di);
  sarg_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWD)*arg_Vsi_bi_Vsbulk_si);
  sarg_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWD)*arg_Vsi_bi_Vgi_bi);
  sarg_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWD)*arg_Vsi_bi_Vdi_bi);
  sarg_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWD)*arg_Vsi_bi_Vsi_bi);
  sarg_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWD)*arg_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=bsimbulk_d_lexp(((-pModel->MJSWD)*bsimbulk_lln(arg)),((-pModel->MJSWD)*bsimbulk_d_lln(arg,arg_Tempt_GND)));
#endif
#endif
sarg=bsimbulk_lexp(((-pModel->MJSWD)*bsimbulk_lln(arg)));
EXIT_IF_ISNAN(bsimbulk_lexp(((-pModel->MJSWD)*bsimbulk_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Qbdj2_Tempt_GND=(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWD));
#endif
Qbdj2_Vdbulk_di=(((PBSWD_t*Czbdsw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qbdj2_Vdbulk_di_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdbulk_di_Tempt_GND*sarg+arg_Vdbulk_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdbulk_di_Vdbulk_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdbulk_di_Vdbulk_di*sarg+arg_Vdbulk_di*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdbulk_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdbulk_di_Vsbulk_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdbulk_di_Vsbulk_si*sarg+arg_Vdbulk_di*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsbulk_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdbulk_di_Vgi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdbulk_di_Vgi_bi*sarg+arg_Vdbulk_di*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vgi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdbulk_di_Vdi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdbulk_di_Vdi_bi*sarg+arg_Vdbulk_di*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdbulk_di_Vsi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdbulk_di_Vsi_bi*sarg+arg_Vdbulk_di*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qbdj2_Vsbulk_si=(((PBSWD_t*Czbdsw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qbdj2_Vsbulk_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsbulk_si_Tempt_GND*sarg+arg_Vsbulk_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsbulk_si_Vdbulk_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsbulk_si_Vdbulk_di*sarg+arg_Vsbulk_si*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdbulk_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsbulk_si_Vsbulk_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsbulk_si_Vsbulk_si*sarg+arg_Vsbulk_si*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsbulk_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsbulk_si_Vgi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsbulk_si_Vgi_bi*sarg+arg_Vsbulk_si*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vgi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsbulk_si_Vdi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsbulk_si_Vdi_bi*sarg+arg_Vsbulk_si*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsbulk_si_Vsi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsbulk_si_Vsi_bi*sarg+arg_Vsbulk_si*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qbdj2_Vgi_bi=(((PBSWD_t*Czbdsw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qbdj2_Vgi_bi_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vgi_bi_Tempt_GND*sarg+arg_Vgi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vgi_bi+arg*sarg_Vgi_bi_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vgi_bi_Vdbulk_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vgi_bi_Vdbulk_di*sarg+arg_Vgi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdbulk_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vgi_bi_Vsbulk_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vgi_bi_Vsbulk_si*sarg+arg_Vgi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsbulk_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vgi_bi_Vgi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vgi_bi_Vgi_bi*sarg+arg_Vgi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vgi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vgi_bi_Vdi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vgi_bi_Vdi_bi*sarg+arg_Vgi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vgi_bi_Vsi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vgi_bi_Vsi_bi*sarg+arg_Vgi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qbdj2_Vdi_bi=(((PBSWD_t*Czbdsw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qbdj2_Vdi_bi_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_bi_Tempt_GND*sarg+arg_Vdi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_bi+arg*sarg_Vdi_bi_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdi_bi_Vdbulk_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_bi_Vdbulk_di*sarg+arg_Vdi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdbulk_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdi_bi_Vsbulk_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_bi_Vsbulk_si*sarg+arg_Vdi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsbulk_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdi_bi_Vgi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_bi_Vgi_bi*sarg+arg_Vdi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vgi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdi_bi_Vdi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_bi_Vdi_bi*sarg+arg_Vdi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vdi_bi_Vsi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_bi_Vsi_bi*sarg+arg_Vdi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qbdj2_Vsi_bi=(((PBSWD_t*Czbdsw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qbdj2_Vsi_bi_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsi_bi_Tempt_GND*sarg+arg_Vsi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsi_bi+arg*sarg_Vsi_bi_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsi_bi_Vdbulk_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsi_bi_Vdbulk_di*sarg+arg_Vsi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdbulk_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsi_bi_Vsbulk_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsi_bi_Vsbulk_si*sarg+arg_Vsi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsbulk_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsi_bi_Vgi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsi_bi_Vgi_bi*sarg+arg_Vsi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vgi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsi_bi_Vdi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsi_bi_Vdi_bi*sarg+arg_Vsi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qbdj2_Vsi_bi_Vsi_bi=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vsi_bi_Vsi_bi*sarg+arg_Vsi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsi_bi)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
#endif
Qbdj2=(((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD));
EXIT_IF_ISNAN((((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD)))
#endif
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((czbdsw_p1*T1_Vdbulk_di)*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((czbdsw_p1*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Vdbulk_di)));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdbulk_di+czbdsw_p1*(+T1_Vdbulk_di_Vgm_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_di)))+((czbdsw_p1*T1_Vgm_di))*((5.0*pModel->MJSWD)*T1_Vdbulk_di)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWD)*(+T1_Vdbulk_di_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+czbdsw_p1*(+T1_Vdbulk_di_Vgm_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_si)))+((czbdsw_p1*T1_Vgm_si))*((5.0*pModel->MJSWD)*T1_Vdbulk_di)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWD)*(+T1_Vdbulk_di_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+czbdsw_p1*(+T1_Vdbulk_di_Vdbulk_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdbulk_di)))+((czbdsw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWD)*T1_Vdbulk_di)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWD)*(+T1_Vdbulk_di_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+czbdsw_p1*(+T1_Vdbulk_di_Vsbulk_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsbulk_si)))+((czbdsw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWD)*T1_Vdbulk_di)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWD)*(+T1_Vdbulk_di_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdbulk_di+czbdsw_p1*(+T1_Vdbulk_di_Vgi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgi_bi)))+((czbdsw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWD)*T1_Vdbulk_di)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWD)*(+T1_Vdbulk_di_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdbulk_di+czbdsw_p1*(+T1_Vdbulk_di_Vdi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_bi)))+((czbdsw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWD)*T1_Vdbulk_di)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWD)*(+T1_Vdbulk_di_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdbulk_di+czbdsw_p1*(+T1_Vdbulk_di_Vsi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsi_bi)))+((czbdsw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWD)*T1_Vdbulk_di)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWD)*(+T1_Vdbulk_di_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdbulk_di+czbdsw_p1*(+T1_Vdbulk_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+((czbdsw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWD)*T1_Vdbulk_di)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWD)*(+T1_Vdbulk_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsbulk_si=(((czbdsw_p1*T1_Vsbulk_si)*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((czbdsw_p1*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Vsbulk_si)));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsbulk_si+czbdsw_p1*(+T1_Vsbulk_si_Vgm_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_di)))+((czbdsw_p1*T1_Vgm_di))*((5.0*pModel->MJSWD)*T1_Vsbulk_si)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWD)*(+T1_Vsbulk_si_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+czbdsw_p1*(+T1_Vsbulk_si_Vgm_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_si)))+((czbdsw_p1*T1_Vgm_si))*((5.0*pModel->MJSWD)*T1_Vsbulk_si)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWD)*(+T1_Vsbulk_si_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+czbdsw_p1*(+T1_Vsbulk_si_Vdbulk_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdbulk_di)))+((czbdsw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWD)*T1_Vsbulk_si)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWD)*(+T1_Vsbulk_si_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+czbdsw_p1*(+T1_Vsbulk_si_Vsbulk_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsbulk_si)))+((czbdsw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWD)*T1_Vsbulk_si)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWD)*(+T1_Vsbulk_si_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsbulk_si+czbdsw_p1*(+T1_Vsbulk_si_Vgi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgi_bi)))+((czbdsw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWD)*T1_Vsbulk_si)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWD)*(+T1_Vsbulk_si_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsbulk_si+czbdsw_p1*(+T1_Vsbulk_si_Vdi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_bi)))+((czbdsw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWD)*T1_Vsbulk_si)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWD)*(+T1_Vsbulk_si_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsbulk_si+czbdsw_p1*(+T1_Vsbulk_si_Vsi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsi_bi)))+((czbdsw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWD)*T1_Vsbulk_si)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWD)*(+T1_Vsbulk_si_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsbulk_si+czbdsw_p1*(+T1_Vsbulk_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+((czbdsw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWD)*T1_Vsbulk_si)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWD)*(+T1_Vsbulk_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vgi_bi=(((czbdsw_p1*T1_Vgi_bi)*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((czbdsw_p1*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Vgi_bi)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+czbdsw_p1*(+T1_Vgi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_di)))+((czbdsw_p1*T1_Vgm_di))*((5.0*pModel->MJSWD)*T1_Vgi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWD)*(+T1_Vgi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+czbdsw_p1*(+T1_Vgi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_si)))+((czbdsw_p1*T1_Vgm_si))*((5.0*pModel->MJSWD)*T1_Vgi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWD)*(+T1_Vgi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+czbdsw_p1*(+T1_Vgi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdbulk_di)))+((czbdsw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWD)*T1_Vgi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWD)*(+T1_Vgi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+czbdsw_p1*(+T1_Vgi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsbulk_si)))+((czbdsw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWD)*T1_Vgi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWD)*(+T1_Vgi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+czbdsw_p1*(+T1_Vgi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgi_bi)))+((czbdsw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWD)*T1_Vgi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWD)*(+T1_Vgi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+czbdsw_p1*(+T1_Vgi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_bi)))+((czbdsw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWD)*T1_Vgi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWD)*(+T1_Vgi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+czbdsw_p1*(+T1_Vgi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsi_bi)))+((czbdsw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWD)*T1_Vgi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWD)*(+T1_Vgi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+czbdsw_p1*(+T1_Vgi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+((czbdsw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWD)*T1_Vgi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWD)*(+T1_Vgi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vdi_bi=(((czbdsw_p1*T1_Vdi_bi)*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((czbdsw_p1*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Vdi_bi)));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+czbdsw_p1*(+T1_Vdi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_di)))+((czbdsw_p1*T1_Vgm_di))*((5.0*pModel->MJSWD)*T1_Vdi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWD)*(+T1_Vdi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+czbdsw_p1*(+T1_Vdi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_si)))+((czbdsw_p1*T1_Vgm_si))*((5.0*pModel->MJSWD)*T1_Vdi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWD)*(+T1_Vdi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+czbdsw_p1*(+T1_Vdi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdbulk_di)))+((czbdsw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWD)*T1_Vdi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWD)*(+T1_Vdi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+czbdsw_p1*(+T1_Vdi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsbulk_si)))+((czbdsw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWD)*T1_Vdi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWD)*(+T1_Vdi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+czbdsw_p1*(+T1_Vdi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgi_bi)))+((czbdsw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWD)*T1_Vdi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWD)*(+T1_Vdi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+czbdsw_p1*(+T1_Vdi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_bi)))+((czbdsw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWD)*T1_Vdi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWD)*(+T1_Vdi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+czbdsw_p1*(+T1_Vdi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsi_bi)))+((czbdsw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWD)*T1_Vdi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWD)*(+T1_Vdi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+czbdsw_p1*(+T1_Vdi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+((czbdsw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWD)*T1_Vdi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWD)*(+T1_Vdi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsi_bi=(((czbdsw_p1*T1_Vsi_bi)*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((czbdsw_p1*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Vsi_bi)));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+czbdsw_p1*(+T1_Vsi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_di)))+((czbdsw_p1*T1_Vgm_di))*((5.0*pModel->MJSWD)*T1_Vsi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWD)*(+T1_Vsi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+czbdsw_p1*(+T1_Vsi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgm_si)))+((czbdsw_p1*T1_Vgm_si))*((5.0*pModel->MJSWD)*T1_Vsi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWD)*(+T1_Vsi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+czbdsw_p1*(+T1_Vsi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdbulk_di)))+((czbdsw_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWD)*T1_Vsi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWD)*(+T1_Vsi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+czbdsw_p1*(+T1_Vsi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsbulk_si)))+((czbdsw_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWD)*T1_Vsi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWD)*(+T1_Vsi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+czbdsw_p1*(+T1_Vsi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vgi_bi)))+((czbdsw_p1*T1_Vgi_bi))*((5.0*pModel->MJSWD)*T1_Vsi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWD)*(+T1_Vsi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+czbdsw_p1*(+T1_Vsi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_bi)))+((czbdsw_p1*T1_Vdi_bi))*((5.0*pModel->MJSWD)*T1_Vsi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWD)*(+T1_Vsi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+czbdsw_p1*(+T1_Vsi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vsi_bi)))+((czbdsw_p1*T1_Vsi_bi))*((5.0*pModel->MJSWD)*T1_Vsi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWD)*(+T1_Vsi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+czbdsw_p1*(+T1_Vsi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+(czbdsw_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+((czbdsw_p1*T1_Tempt_GND))*((5.0*pModel->MJSWD)*T1_Vsi_bi)+(czbdsw_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWD)*(+T1_Vsi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((czbdsw_p1*T1_Tempt_GND)*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((czbdsw_p1*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Tempt_GND)));
#endif
#endif
T2=((czbdsw_p1*(T1-1.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)));
EXIT_IF_ISNAN(((czbdsw_p1*(T1-1.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Qbdj2_Tempt_GND=((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(T2+czbdsw_p2))+((PBSWD_t*Czbdsw)*T2_Tempt_GND));
#endif
Qbdj2_Vdbulk_di=((PBSWD_t*Czbdsw)*T2_Vdbulk_di);
#if defined(_DERIVATE2)
  Qbdj2_Vdbulk_di_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Tempt_GND+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*T2_Vdbulk_di+(PBSWD_t*Czbdsw)*(+T2_Vdbulk_di_Tempt_GND+0.0));
  Qbdj2_Vdbulk_di_Vdbulk_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdbulk_di+(PBSWD_t*Czbdsw)*(+T2_Vdbulk_di_Vdbulk_di+0.0));
  Qbdj2_Vdbulk_di_Vsbulk_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdbulk_di+(PBSWD_t*Czbdsw)*(+T2_Vdbulk_di_Vsbulk_si+0.0));
  Qbdj2_Vdbulk_di_Vgi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdbulk_di+(PBSWD_t*Czbdsw)*(+T2_Vdbulk_di_Vgi_bi+0.0));
  Qbdj2_Vdbulk_di_Vdi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdbulk_di+(PBSWD_t*Czbdsw)*(+T2_Vdbulk_di_Vdi_bi+0.0));
  Qbdj2_Vdbulk_di_Vsi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdbulk_di+(PBSWD_t*Czbdsw)*(+T2_Vdbulk_di_Vsi_bi+0.0));
#endif
Qbdj2_Vsbulk_si=((PBSWD_t*Czbdsw)*T2_Vsbulk_si);
#if defined(_DERIVATE2)
  Qbdj2_Vsbulk_si_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Tempt_GND+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*T2_Vsbulk_si+(PBSWD_t*Czbdsw)*(+T2_Vsbulk_si_Tempt_GND+0.0));
  Qbdj2_Vsbulk_si_Vdbulk_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsbulk_si+(PBSWD_t*Czbdsw)*(+T2_Vsbulk_si_Vdbulk_di+0.0));
  Qbdj2_Vsbulk_si_Vsbulk_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsbulk_si+(PBSWD_t*Czbdsw)*(+T2_Vsbulk_si_Vsbulk_si+0.0));
  Qbdj2_Vsbulk_si_Vgi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsbulk_si+(PBSWD_t*Czbdsw)*(+T2_Vsbulk_si_Vgi_bi+0.0));
  Qbdj2_Vsbulk_si_Vdi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsbulk_si+(PBSWD_t*Czbdsw)*(+T2_Vsbulk_si_Vdi_bi+0.0));
  Qbdj2_Vsbulk_si_Vsi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsbulk_si+(PBSWD_t*Czbdsw)*(+T2_Vsbulk_si_Vsi_bi+0.0));
#endif
Qbdj2_Vgi_bi=((PBSWD_t*Czbdsw)*T2_Vgi_bi);
#if defined(_DERIVATE2)
  Qbdj2_Vgi_bi_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Tempt_GND+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*T2_Vgi_bi+(PBSWD_t*Czbdsw)*(+T2_Vgi_bi_Tempt_GND+0.0));
  Qbdj2_Vgi_bi_Vdbulk_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vgi_bi+(PBSWD_t*Czbdsw)*(+T2_Vgi_bi_Vdbulk_di+0.0));
  Qbdj2_Vgi_bi_Vsbulk_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vgi_bi+(PBSWD_t*Czbdsw)*(+T2_Vgi_bi_Vsbulk_si+0.0));
  Qbdj2_Vgi_bi_Vgi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vgi_bi+(PBSWD_t*Czbdsw)*(+T2_Vgi_bi_Vgi_bi+0.0));
  Qbdj2_Vgi_bi_Vdi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vgi_bi+(PBSWD_t*Czbdsw)*(+T2_Vgi_bi_Vdi_bi+0.0));
  Qbdj2_Vgi_bi_Vsi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vgi_bi+(PBSWD_t*Czbdsw)*(+T2_Vgi_bi_Vsi_bi+0.0));
#endif
Qbdj2_Vdi_bi=((PBSWD_t*Czbdsw)*T2_Vdi_bi);
#if defined(_DERIVATE2)
  Qbdj2_Vdi_bi_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Tempt_GND+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*T2_Vdi_bi+(PBSWD_t*Czbdsw)*(+T2_Vdi_bi_Tempt_GND+0.0));
  Qbdj2_Vdi_bi_Vdbulk_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdi_bi+(PBSWD_t*Czbdsw)*(+T2_Vdi_bi_Vdbulk_di+0.0));
  Qbdj2_Vdi_bi_Vsbulk_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdi_bi+(PBSWD_t*Czbdsw)*(+T2_Vdi_bi_Vsbulk_si+0.0));
  Qbdj2_Vdi_bi_Vgi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdi_bi+(PBSWD_t*Czbdsw)*(+T2_Vdi_bi_Vgi_bi+0.0));
  Qbdj2_Vdi_bi_Vdi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdi_bi+(PBSWD_t*Czbdsw)*(+T2_Vdi_bi_Vdi_bi+0.0));
  Qbdj2_Vdi_bi_Vsi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdi_bi+(PBSWD_t*Czbdsw)*(+T2_Vdi_bi_Vsi_bi+0.0));
#endif
Qbdj2_Vsi_bi=((PBSWD_t*Czbdsw)*T2_Vsi_bi);
#if defined(_DERIVATE2)
  Qbdj2_Vsi_bi_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Tempt_GND+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*T2_Vsi_bi+(PBSWD_t*Czbdsw)*(+T2_Vsi_bi_Tempt_GND+0.0));
  Qbdj2_Vsi_bi_Vdbulk_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsi_bi+(PBSWD_t*Czbdsw)*(+T2_Vsi_bi_Vdbulk_di+0.0));
  Qbdj2_Vsi_bi_Vsbulk_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsi_bi+(PBSWD_t*Czbdsw)*(+T2_Vsi_bi_Vsbulk_si+0.0));
  Qbdj2_Vsi_bi_Vgi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsi_bi+(PBSWD_t*Czbdsw)*(+T2_Vsi_bi_Vgi_bi+0.0));
  Qbdj2_Vsi_bi_Vdi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsi_bi+(PBSWD_t*Czbdsw)*(+T2_Vsi_bi_Vdi_bi+0.0));
  Qbdj2_Vsi_bi_Vsi_bi=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T2+czbdsw_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsi_bi+(PBSWD_t*Czbdsw)*(+T2_Vsi_bi_Vsi_bi+0.0));
#endif
#endif
Qbdj2=((PBSWD_t*Czbdsw)*(T2+czbdsw_p2));
EXIT_IF_ISNAN(((PBSWD_t*Czbdsw)*(T2+czbdsw_p2)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Qbdj2_Tempt_GND=0.0;
#endif
Qbdj2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qbdj2_Vdbulk_di_Tempt_GND=0.0;
  Qbdj2_Vdbulk_di_Vdbulk_di=0.0;
  Qbdj2_Vdbulk_di_Vsbulk_si=0.0;
  Qbdj2_Vdbulk_di_Vgi_bi=0.0;
  Qbdj2_Vdbulk_di_Vdi_bi=0.0;
  Qbdj2_Vdbulk_di_Vsi_bi=0.0;
#endif
Qbdj2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qbdj2_Vsbulk_si_Tempt_GND=0.0;
  Qbdj2_Vsbulk_si_Vdbulk_di=0.0;
  Qbdj2_Vsbulk_si_Vsbulk_si=0.0;
  Qbdj2_Vsbulk_si_Vgi_bi=0.0;
  Qbdj2_Vsbulk_si_Vdi_bi=0.0;
  Qbdj2_Vsbulk_si_Vsi_bi=0.0;
#endif
Qbdj2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Qbdj2_Vgi_bi_Tempt_GND=0.0;
  Qbdj2_Vgi_bi_Vdbulk_di=0.0;
  Qbdj2_Vgi_bi_Vsbulk_si=0.0;
  Qbdj2_Vgi_bi_Vgi_bi=0.0;
  Qbdj2_Vgi_bi_Vdi_bi=0.0;
  Qbdj2_Vgi_bi_Vsi_bi=0.0;
#endif
Qbdj2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Qbdj2_Vdi_bi_Tempt_GND=0.0;
  Qbdj2_Vdi_bi_Vdbulk_di=0.0;
  Qbdj2_Vdi_bi_Vsbulk_si=0.0;
  Qbdj2_Vdi_bi_Vgi_bi=0.0;
  Qbdj2_Vdi_bi_Vdi_bi=0.0;
  Qbdj2_Vdi_bi_Vsi_bi=0.0;
#endif
Qbdj2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Qbdj2_Vsi_bi_Tempt_GND=0.0;
  Qbdj2_Vsi_bi_Vdbulk_di=0.0;
  Qbdj2_Vsi_bi_Vsbulk_si=0.0;
  Qbdj2_Vsi_bi_Vgi_bi=0.0;
  Qbdj2_Vsi_bi_Vdi_bi=0.0;
  Qbdj2_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
Qbdj2=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
if
((Czbdswg>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(Vbd_jct_Vdbulk_di/PBSWGD_t);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(0.0/PBSWGD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWGD_t/PBSWGD_t+2*Vbd_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Vdbulk_di_Vgm_si=(0.0/PBSWGD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWGD_t/PBSWGD_t+2*Vbd_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Vdbulk_di_Vdbulk_di=(Vbd_jct_Vdbulk_di_Vdbulk_di/PBSWGD_t-(Vbd_jct_Vdbulk_di*0.0+Vbd_jct_Vdbulk_di*0.0+Vbd_jct*0.0)/PBSWGD_t/PBSWGD_t+2*Vbd_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Vdbulk_di_Vsbulk_si=(0.0/PBSWGD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWGD_t/PBSWGD_t+2*Vbd_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Vdbulk_di_Vgi_bi=(0.0/PBSWGD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWGD_t/PBSWGD_t+2*Vbd_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Vdbulk_di_Vdi_bi=(0.0/PBSWGD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWGD_t/PBSWGD_t+2*Vbd_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Vdbulk_di_Vsi_bi=(0.0/PBSWGD_t-(Vbd_jct_Vdbulk_di*0.0+0.0*0.0+Vbd_jct*0.0)/PBSWGD_t/PBSWGD_t+2*Vbd_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Vdbulk_di_Tempt_GND=(0.0/PBSWGD_t-(Vbd_jct_Vdbulk_di*PBSWGD_t_Tempt_GND+0.0*0.0+Vbd_jct*0.0)/PBSWGD_t/PBSWGD_t+2*Vbd_jct*0.0*PBSWGD_t_Tempt_GND/PBSWGD_t/PBSWGD_t/PBSWGD_t);
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-Vbd_jct*PBSWGD_t_Tempt_GND/PBSWGD_t/PBSWGD_t);
#endif
#endif
T1=(Vbd_jct/PBSWGD_t);
EXIT_IF_ISNAN((Vbd_jct/PBSWGD_t))
if
((T1<0.9))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
arg_Vdbulk_di=(-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  arg_Vdbulk_di_Vdbulk_di=(+0.0-T1_Vdbulk_di_Vdbulk_di);
  arg_Vdbulk_di_Vsbulk_si=(+0.0-T1_Vdbulk_di_Vsbulk_si);
  arg_Vdbulk_di_Vgi_bi=(+0.0-T1_Vdbulk_di_Vgi_bi);
  arg_Vdbulk_di_Vdi_bi=(+0.0-T1_Vdbulk_di_Vdi_bi);
  arg_Vdbulk_di_Vsi_bi=(+0.0-T1_Vdbulk_di_Vsi_bi);
  arg_Vdbulk_di_Tempt_GND=(+0.0-T1_Vdbulk_di_Tempt_GND);
#endif
arg_Vsbulk_si=(-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  arg_Vsbulk_si_Vdbulk_di=(+0.0-T1_Vsbulk_si_Vdbulk_di);
  arg_Vsbulk_si_Vsbulk_si=(+0.0-T1_Vsbulk_si_Vsbulk_si);
  arg_Vsbulk_si_Vgi_bi=(+0.0-T1_Vsbulk_si_Vgi_bi);
  arg_Vsbulk_si_Vdi_bi=(+0.0-T1_Vsbulk_si_Vdi_bi);
  arg_Vsbulk_si_Vsi_bi=(+0.0-T1_Vsbulk_si_Vsi_bi);
  arg_Vsbulk_si_Tempt_GND=(+0.0-T1_Vsbulk_si_Tempt_GND);
#endif
arg_Vgi_bi=(-T1_Vgi_bi);
#if defined(_DERIVATE2)
  arg_Vgi_bi_Vdbulk_di=(+0.0-T1_Vgi_bi_Vdbulk_di);
  arg_Vgi_bi_Vsbulk_si=(+0.0-T1_Vgi_bi_Vsbulk_si);
  arg_Vgi_bi_Vgi_bi=(+0.0-T1_Vgi_bi_Vgi_bi);
  arg_Vgi_bi_Vdi_bi=(+0.0-T1_Vgi_bi_Vdi_bi);
  arg_Vgi_bi_Vsi_bi=(+0.0-T1_Vgi_bi_Vsi_bi);
  arg_Vgi_bi_Tempt_GND=(+0.0-T1_Vgi_bi_Tempt_GND);
#endif
arg_Vdi_bi=(-T1_Vdi_bi);
#if defined(_DERIVATE2)
  arg_Vdi_bi_Vdbulk_di=(+0.0-T1_Vdi_bi_Vdbulk_di);
  arg_Vdi_bi_Vsbulk_si=(+0.0-T1_Vdi_bi_Vsbulk_si);
  arg_Vdi_bi_Vgi_bi=(+0.0-T1_Vdi_bi_Vgi_bi);
  arg_Vdi_bi_Vdi_bi=(+0.0-T1_Vdi_bi_Vdi_bi);
  arg_Vdi_bi_Vsi_bi=(+0.0-T1_Vdi_bi_Vsi_bi);
  arg_Vdi_bi_Tempt_GND=(+0.0-T1_Vdi_bi_Tempt_GND);
#endif
arg_Vsi_bi=(-T1_Vsi_bi);
#if defined(_DERIVATE2)
  arg_Vsi_bi_Vdbulk_di=(+0.0-T1_Vsi_bi_Vdbulk_di);
  arg_Vsi_bi_Vsbulk_si=(+0.0-T1_Vsi_bi_Vsbulk_si);
  arg_Vsi_bi_Vgi_bi=(+0.0-T1_Vsi_bi_Vgi_bi);
  arg_Vsi_bi_Vdi_bi=(+0.0-T1_Vsi_bi_Vdi_bi);
  arg_Vsi_bi_Vsi_bi=(+0.0-T1_Vsi_bi_Vsi_bi);
  arg_Vsi_bi_Tempt_GND=(+0.0-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
arg_Tempt_GND=(-T1_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=(-arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdbulk_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdbulk_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdbulk_di+d10_sqrt0*arg_Vdbulk_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdbulk_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsbulk_si=(-arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsbulk_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsbulk_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsbulk_si+d10_sqrt0*arg_Vsbulk_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsbulk_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vgi_bi=(-arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vgi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vgi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vgi_bi+d10_sqrt0*arg_Vgi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vgi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_bi=(-arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_bi+d10_sqrt0*arg_Vdi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vsi_bi=(-arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(0.0/d00_sqrt0-(0.0*arg_Vdbulk_di*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdbulk_di*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdbulk_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdbulk_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsbulk_si=(0.0/d00_sqrt0-(0.0*arg_Vsbulk_si*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsbulk_si*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsbulk_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsbulk_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vgi_bi=(0.0/d00_sqrt0-(0.0*arg_Vgi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vgi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vgi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vgi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vdi_bi=(0.0/d00_sqrt0-(0.0*arg_Vdi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vdi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vdi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Vsi_bi=(0.0/d00_sqrt0-(0.0*arg_Vsi_bi*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vsi_bi*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Vsi_bi))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Vsi_bi*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vsi_bi_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vsi_bi*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vsi_bi+d10_sqrt0*arg_Vsi_bi_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vsi_bi*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
sarg_Vdbulk_di=bsimbulk_d_lexp(((-pModel->MJSWGD)*bsimbulk_lln(arg)),((-pModel->MJSWGD)*bsimbulk_d_lln(arg,arg_Vdbulk_di)));
#if defined(_DERIVATE2)
  sarg_Vdbulk_di_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGD)*arg_Vdbulk_di_Vdbulk_di);
  sarg_Vdbulk_di_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGD)*arg_Vdbulk_di_Vsbulk_si);
  sarg_Vdbulk_di_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGD)*arg_Vdbulk_di_Vgi_bi);
  sarg_Vdbulk_di_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGD)*arg_Vdbulk_di_Vdi_bi);
  sarg_Vdbulk_di_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGD)*arg_Vdbulk_di_Vsi_bi);
  sarg_Vdbulk_di_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+0.0*bsimbulk_d_lln(arg,arg_Vdbulk_di)+(-pModel->MJSWGD)*arg_Vdbulk_di_Tempt_GND);
#endif
sarg_Vsbulk_si=bsimbulk_d_lexp(((-pModel->MJSWGD)*bsimbulk_lln(arg)),((-pModel->MJSWGD)*bsimbulk_d_lln(arg,arg_Vsbulk_si)));
#if defined(_DERIVATE2)
  sarg_Vsbulk_si_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGD)*arg_Vsbulk_si_Vdbulk_di);
  sarg_Vsbulk_si_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGD)*arg_Vsbulk_si_Vsbulk_si);
  sarg_Vsbulk_si_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGD)*arg_Vsbulk_si_Vgi_bi);
  sarg_Vsbulk_si_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGD)*arg_Vsbulk_si_Vdi_bi);
  sarg_Vsbulk_si_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGD)*arg_Vsbulk_si_Vsi_bi);
  sarg_Vsbulk_si_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+0.0*bsimbulk_d_lln(arg,arg_Vsbulk_si)+(-pModel->MJSWGD)*arg_Vsbulk_si_Tempt_GND);
#endif
sarg_Vgi_bi=bsimbulk_d_lexp(((-pModel->MJSWGD)*bsimbulk_lln(arg)),((-pModel->MJSWGD)*bsimbulk_d_lln(arg,arg_Vgi_bi)));
#if defined(_DERIVATE2)
  sarg_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGD)*arg_Vgi_bi_Vdbulk_di);
  sarg_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGD)*arg_Vgi_bi_Vsbulk_si);
  sarg_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGD)*arg_Vgi_bi_Vgi_bi);
  sarg_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGD)*arg_Vgi_bi_Vdi_bi);
  sarg_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGD)*arg_Vgi_bi_Vsi_bi);
  sarg_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vgi_bi)+(-pModel->MJSWGD)*arg_Vgi_bi_Tempt_GND);
#endif
sarg_Vdi_bi=bsimbulk_d_lexp(((-pModel->MJSWGD)*bsimbulk_lln(arg)),((-pModel->MJSWGD)*bsimbulk_d_lln(arg,arg_Vdi_bi)));
#if defined(_DERIVATE2)
  sarg_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGD)*arg_Vdi_bi_Vdbulk_di);
  sarg_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGD)*arg_Vdi_bi_Vsbulk_si);
  sarg_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGD)*arg_Vdi_bi_Vgi_bi);
  sarg_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGD)*arg_Vdi_bi_Vdi_bi);
  sarg_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGD)*arg_Vdi_bi_Vsi_bi);
  sarg_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vdi_bi)+(-pModel->MJSWGD)*arg_Vdi_bi_Tempt_GND);
#endif
sarg_Vsi_bi=bsimbulk_d_lexp(((-pModel->MJSWGD)*bsimbulk_lln(arg)),((-pModel->MJSWGD)*bsimbulk_d_lln(arg,arg_Vsi_bi)));
#if defined(_DERIVATE2)
  sarg_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGD)*arg_Vsi_bi_Vdbulk_di);
  sarg_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGD)*arg_Vsi_bi_Vsbulk_si);
  sarg_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGD)*arg_Vsi_bi_Vgi_bi);
  sarg_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGD)*arg_Vsi_bi_Vdi_bi);
  sarg_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGD)*arg_Vsi_bi_Vsi_bi);
  sarg_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln(arg)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+0.0*bsimbulk_d_lln(arg,arg_Vsi_bi)+(-pModel->MJSWGD)*arg_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sarg_Tempt_GND=bsimbulk_d_lexp(((-pModel->MJSWGD)*bsimbulk_lln(arg)),((-pModel->MJSWGD)*bsimbulk_d_lln(arg,arg_Tempt_GND)));
#endif
#endif
sarg=bsimbulk_lexp(((-pModel->MJSWGD)*bsimbulk_lln(arg)));
EXIT_IF_ISNAN(bsimbulk_lexp(((-pModel->MJSWGD)*bsimbulk_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Qbdj3_Tempt_GND=(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGD));
#endif
Qbdj3_Vdbulk_di=(((PBSWGD_t*Czbdswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qbdj3_Vdbulk_di_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdbulk_di_Tempt_GND*sarg+arg_Vdbulk_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdbulk_di_Vdbulk_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdbulk_di_Vdbulk_di*sarg+arg_Vdbulk_di*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdbulk_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdbulk_di_Vsbulk_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdbulk_di_Vsbulk_si*sarg+arg_Vdbulk_di*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsbulk_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdbulk_di_Vgi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdbulk_di_Vgi_bi*sarg+arg_Vdbulk_di*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vgi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdbulk_di_Vdi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdbulk_di_Vdi_bi*sarg+arg_Vdbulk_di*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vdi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdbulk_di_Vsi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdbulk_di_Vsi_bi*sarg+arg_Vdbulk_di*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdbulk_di+arg*sarg_Vdbulk_di_Vsi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qbdj3_Vsbulk_si=(((PBSWGD_t*Czbdswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qbdj3_Vsbulk_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsbulk_si_Tempt_GND*sarg+arg_Vsbulk_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsbulk_si_Vdbulk_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsbulk_si_Vdbulk_di*sarg+arg_Vsbulk_si*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdbulk_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsbulk_si_Vsbulk_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsbulk_si_Vsbulk_si*sarg+arg_Vsbulk_si*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsbulk_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsbulk_si_Vgi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsbulk_si_Vgi_bi*sarg+arg_Vsbulk_si*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vgi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsbulk_si_Vdi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsbulk_si_Vdi_bi*sarg+arg_Vsbulk_si*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vdi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsbulk_si_Vsi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsbulk_si_Vsi_bi*sarg+arg_Vsbulk_si*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsbulk_si+arg*sarg_Vsbulk_si_Vsi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qbdj3_Vgi_bi=(((PBSWGD_t*Czbdswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qbdj3_Vgi_bi_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vgi_bi_Tempt_GND*sarg+arg_Vgi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vgi_bi+arg*sarg_Vgi_bi_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vgi_bi_Vdbulk_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vgi_bi_Vdbulk_di*sarg+arg_Vgi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdbulk_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vgi_bi_Vsbulk_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vgi_bi_Vsbulk_si*sarg+arg_Vgi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsbulk_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vgi_bi_Vgi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vgi_bi_Vgi_bi*sarg+arg_Vgi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vgi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vgi_bi_Vdi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vgi_bi_Vdi_bi*sarg+arg_Vgi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vdi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vgi_bi_Vsi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vgi_bi_Vsi_bi*sarg+arg_Vgi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vgi_bi+arg*sarg_Vgi_bi_Vsi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qbdj3_Vdi_bi=(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qbdj3_Vdi_bi_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_bi_Tempt_GND*sarg+arg_Vdi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_bi+arg*sarg_Vdi_bi_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdi_bi_Vdbulk_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_bi_Vdbulk_di*sarg+arg_Vdi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdbulk_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdi_bi_Vsbulk_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_bi_Vsbulk_si*sarg+arg_Vdi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsbulk_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdi_bi_Vgi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_bi_Vgi_bi*sarg+arg_Vdi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vgi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdi_bi_Vdi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_bi_Vdi_bi*sarg+arg_Vdi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vdi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vdi_bi_Vsi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_bi_Vsi_bi*sarg+arg_Vdi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vdi_bi+arg*sarg_Vdi_bi_Vsi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qbdj3_Vsi_bi=(((PBSWGD_t*Czbdswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qbdj3_Vsi_bi_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsi_bi_Tempt_GND*sarg+arg_Vsi_bi*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vsi_bi+arg*sarg_Vsi_bi_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsi_bi_Vdbulk_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsi_bi_Vdbulk_di*sarg+arg_Vsi_bi*sarg_Vdbulk_di+arg_Vdbulk_di*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdbulk_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdbulk_di*sarg)+(arg*sarg_Vdbulk_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsi_bi_Vsbulk_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsi_bi_Vsbulk_si*sarg+arg_Vsi_bi*sarg_Vsbulk_si+arg_Vsbulk_si*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsbulk_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsbulk_si*sarg)+(arg*sarg_Vsbulk_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsi_bi_Vgi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsi_bi_Vgi_bi*sarg+arg_Vsi_bi*sarg_Vgi_bi+arg_Vgi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vgi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vgi_bi*sarg)+(arg*sarg_Vgi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsi_bi_Vdi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsi_bi_Vdi_bi*sarg+arg_Vsi_bi*sarg_Vdi_bi+arg_Vdi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vdi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_bi*sarg)+(arg*sarg_Vdi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qbdj3_Vsi_bi_Vsi_bi=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))+(0.0)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vsi_bi_Vsi_bi*sarg+arg_Vsi_bi*sarg_Vsi_bi+arg_Vsi_bi*sarg_Vsi_bi+arg*sarg_Vsi_bi_Vsi_bi)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vsi_bi*sarg)+(arg*sarg_Vsi_bi)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
#endif
Qbdj3=(((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD));
EXIT_IF_ISNAN((((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD)))
#endif
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((czbdswg_p1*T1_Vdbulk_di)*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((czbdswg_p1*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Vdbulk_di)));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdbulk_di+czbdswg_p1*(+T1_Vdbulk_di_Vgm_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_di)))+((czbdswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGD)*T1_Vdbulk_di)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGD)*(+T1_Vdbulk_di_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+czbdswg_p1*(+T1_Vdbulk_di_Vgm_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_si)))+((czbdswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGD)*T1_Vdbulk_di)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGD)*(+T1_Vdbulk_di_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+czbdswg_p1*(+T1_Vdbulk_di_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdbulk_di)))+((czbdswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGD)*T1_Vdbulk_di)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGD)*(+T1_Vdbulk_di_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+czbdswg_p1*(+T1_Vdbulk_di_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsbulk_si)))+((czbdswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGD)*T1_Vdbulk_di)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGD)*(+T1_Vdbulk_di_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdbulk_di+czbdswg_p1*(+T1_Vdbulk_di_Vgi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgi_bi)))+((czbdswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGD)*T1_Vdbulk_di)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGD)*(+T1_Vdbulk_di_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdbulk_di+czbdswg_p1*(+T1_Vdbulk_di_Vdi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_bi)))+((czbdswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGD)*T1_Vdbulk_di)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGD)*(+T1_Vdbulk_di_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdbulk_di+czbdswg_p1*(+T1_Vdbulk_di_Vsi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsi_bi)))+((czbdswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGD)*T1_Vdbulk_di)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGD)*(+T1_Vdbulk_di_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdbulk_di_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdbulk_di+czbdswg_p1*(+T1_Vdbulk_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdbulk_di)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+((czbdswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGD)*T1_Vdbulk_di)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(5.0*pModel->MJSWGD)*(+T1_Vdbulk_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsbulk_si=(((czbdswg_p1*T1_Vsbulk_si)*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((czbdswg_p1*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Vsbulk_si)));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsbulk_si+czbdswg_p1*(+T1_Vsbulk_si_Vgm_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_di)))+((czbdswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGD)*T1_Vsbulk_si)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGD)*(+T1_Vsbulk_si_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+czbdswg_p1*(+T1_Vsbulk_si_Vgm_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_si)))+((czbdswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGD)*T1_Vsbulk_si)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGD)*(+T1_Vsbulk_si_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+czbdswg_p1*(+T1_Vsbulk_si_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdbulk_di)))+((czbdswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGD)*T1_Vsbulk_si)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGD)*(+T1_Vsbulk_si_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+czbdswg_p1*(+T1_Vsbulk_si_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsbulk_si)))+((czbdswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGD)*T1_Vsbulk_si)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGD)*(+T1_Vsbulk_si_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsbulk_si+czbdswg_p1*(+T1_Vsbulk_si_Vgi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgi_bi)))+((czbdswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGD)*T1_Vsbulk_si)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGD)*(+T1_Vsbulk_si_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsbulk_si+czbdswg_p1*(+T1_Vsbulk_si_Vdi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_bi)))+((czbdswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGD)*T1_Vsbulk_si)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGD)*(+T1_Vsbulk_si_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsbulk_si+czbdswg_p1*(+T1_Vsbulk_si_Vsi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsi_bi)))+((czbdswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGD)*T1_Vsbulk_si)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGD)*(+T1_Vsbulk_si_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsbulk_si_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsbulk_si+czbdswg_p1*(+T1_Vsbulk_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsbulk_si)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+((czbdswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGD)*T1_Vsbulk_si)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(5.0*pModel->MJSWGD)*(+T1_Vsbulk_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vgi_bi=(((czbdswg_p1*T1_Vgi_bi)*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((czbdswg_p1*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Vgi_bi)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+czbdswg_p1*(+T1_Vgi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_di)))+((czbdswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGD)*T1_Vgi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGD)*(+T1_Vgi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+czbdswg_p1*(+T1_Vgi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_si)))+((czbdswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGD)*T1_Vgi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGD)*(+T1_Vgi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+czbdswg_p1*(+T1_Vgi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdbulk_di)))+((czbdswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGD)*T1_Vgi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGD)*(+T1_Vgi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+czbdswg_p1*(+T1_Vgi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsbulk_si)))+((czbdswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGD)*T1_Vgi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGD)*(+T1_Vgi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+czbdswg_p1*(+T1_Vgi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgi_bi)))+((czbdswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGD)*T1_Vgi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGD)*(+T1_Vgi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+czbdswg_p1*(+T1_Vgi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_bi)))+((czbdswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGD)*T1_Vgi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGD)*(+T1_Vgi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+czbdswg_p1*(+T1_Vgi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsi_bi)))+((czbdswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGD)*T1_Vgi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGD)*(+T1_Vgi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vgi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+czbdswg_p1*(+T1_Vgi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vgi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+((czbdswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGD)*T1_Vgi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(5.0*pModel->MJSWGD)*(+T1_Vgi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vdi_bi=(((czbdswg_p1*T1_Vdi_bi)*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((czbdswg_p1*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Vdi_bi)));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+czbdswg_p1*(+T1_Vdi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_di)))+((czbdswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGD)*T1_Vdi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGD)*(+T1_Vdi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+czbdswg_p1*(+T1_Vdi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_si)))+((czbdswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGD)*T1_Vdi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGD)*(+T1_Vdi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+czbdswg_p1*(+T1_Vdi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdbulk_di)))+((czbdswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGD)*T1_Vdi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGD)*(+T1_Vdi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+czbdswg_p1*(+T1_Vdi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsbulk_si)))+((czbdswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGD)*T1_Vdi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGD)*(+T1_Vdi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+czbdswg_p1*(+T1_Vdi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgi_bi)))+((czbdswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGD)*T1_Vdi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGD)*(+T1_Vdi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+czbdswg_p1*(+T1_Vdi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_bi)))+((czbdswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGD)*T1_Vdi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGD)*(+T1_Vdi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+czbdswg_p1*(+T1_Vdi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsi_bi)))+((czbdswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGD)*T1_Vdi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGD)*(+T1_Vdi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vdi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+czbdswg_p1*(+T1_Vdi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vdi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+((czbdswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGD)*T1_Vdi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(5.0*pModel->MJSWGD)*(+T1_Vdi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T2_Vsi_bi=(((czbdswg_p1*T1_Vsi_bi)*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((czbdswg_p1*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Vsi_bi)));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+czbdswg_p1*(+T1_Vsi_bi_Vgm_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_di)))+((czbdswg_p1*T1_Vgm_di))*((5.0*pModel->MJSWGD)*T1_Vsi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGD)*(+T1_Vsi_bi_Vgm_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgm_si=(+(+0.0*(T1-1.0)+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+czbdswg_p1*(+T1_Vsi_bi_Vgm_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgm_si)))+((czbdswg_p1*T1_Vgm_si))*((5.0*pModel->MJSWGD)*T1_Vsi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGD)*(+T1_Vsi_bi_Vgm_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdbulk_di=(+(+0.0*(T1-1.0)+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+czbdswg_p1*(+T1_Vsi_bi_Vdbulk_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdbulk_di)))+((czbdswg_p1*T1_Vdbulk_di))*((5.0*pModel->MJSWGD)*T1_Vsi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGD)*(+T1_Vsi_bi_Vdbulk_di-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsbulk_si=(+(+0.0*(T1-1.0)+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+czbdswg_p1*(+T1_Vsi_bi_Vsbulk_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsbulk_si)))+((czbdswg_p1*T1_Vsbulk_si))*((5.0*pModel->MJSWGD)*T1_Vsi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGD)*(+T1_Vsi_bi_Vsbulk_si-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vgi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+czbdswg_p1*(+T1_Vsi_bi_Vgi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vgi_bi)))+((czbdswg_p1*T1_Vgi_bi))*((5.0*pModel->MJSWGD)*T1_Vsi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGD)*(+T1_Vsi_bi_Vgi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vdi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+czbdswg_p1*(+T1_Vsi_bi_Vdi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_bi)))+((czbdswg_p1*T1_Vdi_bi))*((5.0*pModel->MJSWGD)*T1_Vsi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGD)*(+T1_Vsi_bi_Vdi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Vsi_bi=(+(+0.0*(T1-1.0)+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+czbdswg_p1*(+T1_Vsi_bi_Vsi_bi-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vsi_bi)))+((czbdswg_p1*T1_Vsi_bi))*((5.0*pModel->MJSWGD)*T1_Vsi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGD)*(+T1_Vsi_bi_Vsi_bi-0.0))+(+0.0+0.0)));
  T2_Vsi_bi_Tempt_GND=(+(+0.0*(T1-1.0)+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+czbdswg_p1*(+T1_Vsi_bi_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+(czbdswg_p1*T1_Vsi_bi)*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+((czbdswg_p1*T1_Tempt_GND))*((5.0*pModel->MJSWGD)*T1_Vsi_bi)+(czbdswg_p1*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(5.0*pModel->MJSWGD)*(+T1_Vsi_bi_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((czbdswg_p1*T1_Tempt_GND)*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((czbdswg_p1*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Tempt_GND)));
#endif
#endif
T2=((czbdswg_p1*(T1-1.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)));
EXIT_IF_ISNAN(((czbdswg_p1*(T1-1.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Qbdj3_Tempt_GND=((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(T2+czbdswg_p2))+((PBSWGD_t*Czbdswg)*T2_Tempt_GND));
#endif
Qbdj3_Vdbulk_di=((PBSWGD_t*Czbdswg)*T2_Vdbulk_di);
#if defined(_DERIVATE2)
  Qbdj3_Vdbulk_di_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Tempt_GND+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*T2_Vdbulk_di+(PBSWGD_t*Czbdswg)*(+T2_Vdbulk_di_Tempt_GND+0.0));
  Qbdj3_Vdbulk_di_Vdbulk_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdbulk_di+(PBSWGD_t*Czbdswg)*(+T2_Vdbulk_di_Vdbulk_di+0.0));
  Qbdj3_Vdbulk_di_Vsbulk_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdbulk_di+(PBSWGD_t*Czbdswg)*(+T2_Vdbulk_di_Vsbulk_si+0.0));
  Qbdj3_Vdbulk_di_Vgi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdbulk_di+(PBSWGD_t*Czbdswg)*(+T2_Vdbulk_di_Vgi_bi+0.0));
  Qbdj3_Vdbulk_di_Vdi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdbulk_di+(PBSWGD_t*Czbdswg)*(+T2_Vdbulk_di_Vdi_bi+0.0));
  Qbdj3_Vdbulk_di_Vsi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdbulk_di+(PBSWGD_t*Czbdswg)*(+T2_Vdbulk_di_Vsi_bi+0.0));
#endif
Qbdj3_Vsbulk_si=((PBSWGD_t*Czbdswg)*T2_Vsbulk_si);
#if defined(_DERIVATE2)
  Qbdj3_Vsbulk_si_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Tempt_GND+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*T2_Vsbulk_si+(PBSWGD_t*Czbdswg)*(+T2_Vsbulk_si_Tempt_GND+0.0));
  Qbdj3_Vsbulk_si_Vdbulk_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsbulk_si+(PBSWGD_t*Czbdswg)*(+T2_Vsbulk_si_Vdbulk_di+0.0));
  Qbdj3_Vsbulk_si_Vsbulk_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsbulk_si+(PBSWGD_t*Czbdswg)*(+T2_Vsbulk_si_Vsbulk_si+0.0));
  Qbdj3_Vsbulk_si_Vgi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsbulk_si+(PBSWGD_t*Czbdswg)*(+T2_Vsbulk_si_Vgi_bi+0.0));
  Qbdj3_Vsbulk_si_Vdi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsbulk_si+(PBSWGD_t*Czbdswg)*(+T2_Vsbulk_si_Vdi_bi+0.0));
  Qbdj3_Vsbulk_si_Vsi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsbulk_si+(PBSWGD_t*Czbdswg)*(+T2_Vsbulk_si_Vsi_bi+0.0));
#endif
Qbdj3_Vgi_bi=((PBSWGD_t*Czbdswg)*T2_Vgi_bi);
#if defined(_DERIVATE2)
  Qbdj3_Vgi_bi_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Tempt_GND+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*T2_Vgi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vgi_bi_Tempt_GND+0.0));
  Qbdj3_Vgi_bi_Vdbulk_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vgi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vgi_bi_Vdbulk_di+0.0));
  Qbdj3_Vgi_bi_Vsbulk_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vgi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vgi_bi_Vsbulk_si+0.0));
  Qbdj3_Vgi_bi_Vgi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vgi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vgi_bi_Vgi_bi+0.0));
  Qbdj3_Vgi_bi_Vdi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vgi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vgi_bi_Vdi_bi+0.0));
  Qbdj3_Vgi_bi_Vsi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vgi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vgi_bi_Vsi_bi+0.0));
#endif
Qbdj3_Vdi_bi=((PBSWGD_t*Czbdswg)*T2_Vdi_bi);
#if defined(_DERIVATE2)
  Qbdj3_Vdi_bi_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Tempt_GND+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*T2_Vdi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vdi_bi_Tempt_GND+0.0));
  Qbdj3_Vdi_bi_Vdbulk_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vdi_bi_Vdbulk_di+0.0));
  Qbdj3_Vdi_bi_Vsbulk_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vdi_bi_Vsbulk_si+0.0));
  Qbdj3_Vdi_bi_Vgi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vdi_bi_Vgi_bi+0.0));
  Qbdj3_Vdi_bi_Vdi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vdi_bi_Vdi_bi+0.0));
  Qbdj3_Vdi_bi_Vsi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vdi_bi_Vsi_bi+0.0));
#endif
Qbdj3_Vsi_bi=((PBSWGD_t*Czbdswg)*T2_Vsi_bi);
#if defined(_DERIVATE2)
  Qbdj3_Vsi_bi_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Tempt_GND+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*T2_Vsi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vsi_bi_Tempt_GND+0.0));
  Qbdj3_Vsi_bi_Vdbulk_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vsi_bi_Vdbulk_di+0.0));
  Qbdj3_Vsi_bi_Vsbulk_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vsi_bi_Vsbulk_si+0.0));
  Qbdj3_Vsi_bi_Vgi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vsi_bi_Vgi_bi+0.0));
  Qbdj3_Vsi_bi_Vdi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vsi_bi_Vdi_bi+0.0));
  Qbdj3_Vsi_bi_Vsi_bi=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T2+czbdswg_p2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsi_bi+(PBSWGD_t*Czbdswg)*(+T2_Vsi_bi_Vsi_bi+0.0));
#endif
#endif
Qbdj3=((PBSWGD_t*Czbdswg)*(T2+czbdswg_p2));
EXIT_IF_ISNAN(((PBSWGD_t*Czbdswg)*(T2+czbdswg_p2)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Qbdj3_Tempt_GND=0.0;
#endif
Qbdj3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qbdj3_Vdbulk_di_Tempt_GND=0.0;
  Qbdj3_Vdbulk_di_Vdbulk_di=0.0;
  Qbdj3_Vdbulk_di_Vsbulk_si=0.0;
  Qbdj3_Vdbulk_di_Vgi_bi=0.0;
  Qbdj3_Vdbulk_di_Vdi_bi=0.0;
  Qbdj3_Vdbulk_di_Vsi_bi=0.0;
#endif
Qbdj3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qbdj3_Vsbulk_si_Tempt_GND=0.0;
  Qbdj3_Vsbulk_si_Vdbulk_di=0.0;
  Qbdj3_Vsbulk_si_Vsbulk_si=0.0;
  Qbdj3_Vsbulk_si_Vgi_bi=0.0;
  Qbdj3_Vsbulk_si_Vdi_bi=0.0;
  Qbdj3_Vsbulk_si_Vsi_bi=0.0;
#endif
Qbdj3_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Qbdj3_Vgi_bi_Tempt_GND=0.0;
  Qbdj3_Vgi_bi_Vdbulk_di=0.0;
  Qbdj3_Vgi_bi_Vsbulk_si=0.0;
  Qbdj3_Vgi_bi_Vgi_bi=0.0;
  Qbdj3_Vgi_bi_Vdi_bi=0.0;
  Qbdj3_Vgi_bi_Vsi_bi=0.0;
#endif
Qbdj3_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Qbdj3_Vdi_bi_Tempt_GND=0.0;
  Qbdj3_Vdi_bi_Vdbulk_di=0.0;
  Qbdj3_Vdi_bi_Vsbulk_si=0.0;
  Qbdj3_Vdi_bi_Vgi_bi=0.0;
  Qbdj3_Vdi_bi_Vdi_bi=0.0;
  Qbdj3_Vdi_bi_Vsi_bi=0.0;
#endif
Qbdj3_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Qbdj3_Vsi_bi_Tempt_GND=0.0;
  Qbdj3_Vsi_bi_Vdbulk_di=0.0;
  Qbdj3_Vsi_bi_Vsbulk_si=0.0;
  Qbdj3_Vsi_bi_Vgi_bi=0.0;
  Qbdj3_Vsi_bi_Vdi_bi=0.0;
  Qbdj3_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
Qbdj3=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(di,GND) */
#if defined(_DERIVATE)
Qbdj_Tempt_GND=((Qbdj1_Tempt_GND+Qbdj2_Tempt_GND)+Qbdj3_Tempt_GND);
#endif
Qbdj_Vdbulk_di=((Qbdj1_Vdbulk_di+Qbdj2_Vdbulk_di)+Qbdj3_Vdbulk_di);
#if defined(_DERIVATE2)
  Qbdj_Vdbulk_di_Tempt_GND=(+(+Qbdj1_Vdbulk_di_Tempt_GND+Qbdj2_Vdbulk_di_Tempt_GND)+Qbdj3_Vdbulk_di_Tempt_GND);
  Qbdj_Vdbulk_di_Vdbulk_di=(+(+Qbdj1_Vdbulk_di_Vdbulk_di+Qbdj2_Vdbulk_di_Vdbulk_di)+Qbdj3_Vdbulk_di_Vdbulk_di);
  Qbdj_Vdbulk_di_Vsbulk_si=(+(+Qbdj1_Vdbulk_di_Vsbulk_si+Qbdj2_Vdbulk_di_Vsbulk_si)+Qbdj3_Vdbulk_di_Vsbulk_si);
  Qbdj_Vdbulk_di_Vgi_bi=(+(+Qbdj1_Vdbulk_di_Vgi_bi+Qbdj2_Vdbulk_di_Vgi_bi)+Qbdj3_Vdbulk_di_Vgi_bi);
  Qbdj_Vdbulk_di_Vdi_bi=(+(+Qbdj1_Vdbulk_di_Vdi_bi+Qbdj2_Vdbulk_di_Vdi_bi)+Qbdj3_Vdbulk_di_Vdi_bi);
  Qbdj_Vdbulk_di_Vsi_bi=(+(+Qbdj1_Vdbulk_di_Vsi_bi+Qbdj2_Vdbulk_di_Vsi_bi)+Qbdj3_Vdbulk_di_Vsi_bi);
#endif
Qbdj_Vsbulk_si=((Qbdj1_Vsbulk_si+Qbdj2_Vsbulk_si)+Qbdj3_Vsbulk_si);
#if defined(_DERIVATE2)
  Qbdj_Vsbulk_si_Tempt_GND=(+(+Qbdj1_Vsbulk_si_Tempt_GND+Qbdj2_Vsbulk_si_Tempt_GND)+Qbdj3_Vsbulk_si_Tempt_GND);
  Qbdj_Vsbulk_si_Vdbulk_di=(+(+Qbdj1_Vsbulk_si_Vdbulk_di+Qbdj2_Vsbulk_si_Vdbulk_di)+Qbdj3_Vsbulk_si_Vdbulk_di);
  Qbdj_Vsbulk_si_Vsbulk_si=(+(+Qbdj1_Vsbulk_si_Vsbulk_si+Qbdj2_Vsbulk_si_Vsbulk_si)+Qbdj3_Vsbulk_si_Vsbulk_si);
  Qbdj_Vsbulk_si_Vgi_bi=(+(+Qbdj1_Vsbulk_si_Vgi_bi+Qbdj2_Vsbulk_si_Vgi_bi)+Qbdj3_Vsbulk_si_Vgi_bi);
  Qbdj_Vsbulk_si_Vdi_bi=(+(+Qbdj1_Vsbulk_si_Vdi_bi+Qbdj2_Vsbulk_si_Vdi_bi)+Qbdj3_Vsbulk_si_Vdi_bi);
  Qbdj_Vsbulk_si_Vsi_bi=(+(+Qbdj1_Vsbulk_si_Vsi_bi+Qbdj2_Vsbulk_si_Vsi_bi)+Qbdj3_Vsbulk_si_Vsi_bi);
#endif
Qbdj_Vgi_bi=((Qbdj1_Vgi_bi+Qbdj2_Vgi_bi)+Qbdj3_Vgi_bi);
#if defined(_DERIVATE2)
  Qbdj_Vgi_bi_Tempt_GND=(+(+Qbdj1_Vgi_bi_Tempt_GND+Qbdj2_Vgi_bi_Tempt_GND)+Qbdj3_Vgi_bi_Tempt_GND);
  Qbdj_Vgi_bi_Vdbulk_di=(+(+Qbdj1_Vgi_bi_Vdbulk_di+Qbdj2_Vgi_bi_Vdbulk_di)+Qbdj3_Vgi_bi_Vdbulk_di);
  Qbdj_Vgi_bi_Vsbulk_si=(+(+Qbdj1_Vgi_bi_Vsbulk_si+Qbdj2_Vgi_bi_Vsbulk_si)+Qbdj3_Vgi_bi_Vsbulk_si);
  Qbdj_Vgi_bi_Vgi_bi=(+(+Qbdj1_Vgi_bi_Vgi_bi+Qbdj2_Vgi_bi_Vgi_bi)+Qbdj3_Vgi_bi_Vgi_bi);
  Qbdj_Vgi_bi_Vdi_bi=(+(+Qbdj1_Vgi_bi_Vdi_bi+Qbdj2_Vgi_bi_Vdi_bi)+Qbdj3_Vgi_bi_Vdi_bi);
  Qbdj_Vgi_bi_Vsi_bi=(+(+Qbdj1_Vgi_bi_Vsi_bi+Qbdj2_Vgi_bi_Vsi_bi)+Qbdj3_Vgi_bi_Vsi_bi);
#endif
Qbdj_Vdi_bi=((Qbdj1_Vdi_bi+Qbdj2_Vdi_bi)+Qbdj3_Vdi_bi);
#if defined(_DERIVATE2)
  Qbdj_Vdi_bi_Tempt_GND=(+(+Qbdj1_Vdi_bi_Tempt_GND+Qbdj2_Vdi_bi_Tempt_GND)+Qbdj3_Vdi_bi_Tempt_GND);
  Qbdj_Vdi_bi_Vdbulk_di=(+(+Qbdj1_Vdi_bi_Vdbulk_di+Qbdj2_Vdi_bi_Vdbulk_di)+Qbdj3_Vdi_bi_Vdbulk_di);
  Qbdj_Vdi_bi_Vsbulk_si=(+(+Qbdj1_Vdi_bi_Vsbulk_si+Qbdj2_Vdi_bi_Vsbulk_si)+Qbdj3_Vdi_bi_Vsbulk_si);
  Qbdj_Vdi_bi_Vgi_bi=(+(+Qbdj1_Vdi_bi_Vgi_bi+Qbdj2_Vdi_bi_Vgi_bi)+Qbdj3_Vdi_bi_Vgi_bi);
  Qbdj_Vdi_bi_Vdi_bi=(+(+Qbdj1_Vdi_bi_Vdi_bi+Qbdj2_Vdi_bi_Vdi_bi)+Qbdj3_Vdi_bi_Vdi_bi);
  Qbdj_Vdi_bi_Vsi_bi=(+(+Qbdj1_Vdi_bi_Vsi_bi+Qbdj2_Vdi_bi_Vsi_bi)+Qbdj3_Vdi_bi_Vsi_bi);
#endif
Qbdj_Vsi_bi=((Qbdj1_Vsi_bi+Qbdj2_Vsi_bi)+Qbdj3_Vsi_bi);
#if defined(_DERIVATE2)
  Qbdj_Vsi_bi_Tempt_GND=(+(+Qbdj1_Vsi_bi_Tempt_GND+Qbdj2_Vsi_bi_Tempt_GND)+Qbdj3_Vsi_bi_Tempt_GND);
  Qbdj_Vsi_bi_Vdbulk_di=(+(+Qbdj1_Vsi_bi_Vdbulk_di+Qbdj2_Vsi_bi_Vdbulk_di)+Qbdj3_Vsi_bi_Vdbulk_di);
  Qbdj_Vsi_bi_Vsbulk_si=(+(+Qbdj1_Vsi_bi_Vsbulk_si+Qbdj2_Vsi_bi_Vsbulk_si)+Qbdj3_Vsi_bi_Vsbulk_si);
  Qbdj_Vsi_bi_Vgi_bi=(+(+Qbdj1_Vsi_bi_Vgi_bi+Qbdj2_Vsi_bi_Vgi_bi)+Qbdj3_Vsi_bi_Vgi_bi);
  Qbdj_Vsi_bi_Vdi_bi=(+(+Qbdj1_Vsi_bi_Vdi_bi+Qbdj2_Vsi_bi_Vdi_bi)+Qbdj3_Vsi_bi_Vdi_bi);
  Qbdj_Vsi_bi_Vsi_bi=(+(+Qbdj1_Vsi_bi_Vsi_bi+Qbdj2_Vsi_bi_Vsi_bi)+Qbdj3_Vsi_bi_Vsi_bi);
#endif
#endif
Qbdj=((Qbdj1+Qbdj2)+Qbdj3);
EXIT_IF_ISNAN(((Qbdj1+Qbdj2)+Qbdj3))
#endif
if
((pInst->SSLMOD!=0))
{
{
double m00_pow(d00_pow0,(NDEP_i/1.0e23),pModel->SSLEXP1)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(300.0/DevTemp),pModel->SSLEXP2)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(300.0/DevTemp),pModel->SSLEXP2)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=0.0;
  T2_Vgi_bi_Vgm_si=0.0;
  T2_Vgi_bi_Vdbulk_di=0.0;
  T2_Vgi_bi_Vsbulk_si=0.0;
  T2_Vgi_bi_Vgi_bi=0.0;
  T2_Vgi_bi_Vdi_bi=0.0;
  T2_Vgi_bi_Vsi_bi=0.0;
  T2_Vgi_bi_Tempt_GND=0.0;
#endif
T2_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=0.0;
  T2_Vdi_bi_Vgm_si=0.0;
  T2_Vdi_bi_Vdbulk_di=0.0;
  T2_Vdi_bi_Vsbulk_si=0.0;
  T2_Vdi_bi_Vgi_bi=0.0;
  T2_Vdi_bi_Vdi_bi=0.0;
  T2_Vdi_bi_Vsi_bi=0.0;
  T2_Vdi_bi_Tempt_GND=0.0;
#endif
T2_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=0.0;
  T2_Vsi_bi_Vgm_si=0.0;
  T2_Vsi_bi_Vdbulk_di=0.0;
  T2_Vsi_bi_Vsbulk_si=0.0;
  T2_Vsi_bi_Vgi_bi=0.0;
  T2_Vsi_bi_Vdi_bi=0.0;
  T2_Vsi_bi_Vsi_bi=0.0;
  T2_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(d10_pow0*(-300.0*DevTemp_Tempt_GND/DevTemp/DevTemp));
#endif
#endif
T2=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
SSL0_NT_Vdbulk_di=(pModel->SSL0*bsimbulk_d_lexp(((-T1)*T2),(((-T1_Vdbulk_di)*T2)+((-T1)*T2_Vdbulk_di))));
SSL0_NT_Vsbulk_si=(pModel->SSL0*bsimbulk_d_lexp(((-T1)*T2),(((-T1_Vsbulk_si)*T2)+((-T1)*T2_Vsbulk_si))));
SSL0_NT_Vgi_bi=(pModel->SSL0*bsimbulk_d_lexp(((-T1)*T2),(((-T1_Vgi_bi)*T2)+((-T1)*T2_Vgi_bi))));
SSL0_NT_Vdi_bi=(pModel->SSL0*bsimbulk_d_lexp(((-T1)*T2),(((-T1_Vdi_bi)*T2)+((-T1)*T2_Vdi_bi))));
SSL0_NT_Vsi_bi=(pModel->SSL0*bsimbulk_d_lexp(((-T1)*T2),(((-T1_Vsi_bi)*T2)+((-T1)*T2_Vsi_bi))));
SSL0_NT_Tempt_GND=(pModel->SSL0*bsimbulk_d_lexp(((-T1)*T2),(((-T1_Tempt_GND)*T2)+((-T1)*T2_Tempt_GND))));
#endif
SSL0_NT=(pModel->SSL0*bsimbulk_lexp(((-T1)*T2)));
EXIT_IF_ISNAN((pModel->SSL0*bsimbulk_lexp(((-T1)*T2))))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
SSL1_NT_Vdbulk_di=(((pModel->SSL1*T2_Vdbulk_di)*T1)+((pModel->SSL1*T2)*T1_Vdbulk_di));
SSL1_NT_Vsbulk_si=(((pModel->SSL1*T2_Vsbulk_si)*T1)+((pModel->SSL1*T2)*T1_Vsbulk_si));
SSL1_NT_Vgi_bi=(((pModel->SSL1*T2_Vgi_bi)*T1)+((pModel->SSL1*T2)*T1_Vgi_bi));
SSL1_NT_Vdi_bi=(((pModel->SSL1*T2_Vdi_bi)*T1)+((pModel->SSL1*T2)*T1_Vdi_bi));
SSL1_NT_Vsi_bi=(((pModel->SSL1*T2_Vsi_bi)*T1)+((pModel->SSL1*T2)*T1_Vsi_bi));
SSL1_NT_Tempt_GND=(((pModel->SSL1*T2_Tempt_GND)*T1)+((pModel->SSL1*T2)*T1_Tempt_GND));
#endif
SSL1_NT=((pModel->SSL1*T2)*T1);
EXIT_IF_ISNAN(((pModel->SSL1*T2)*T1))
{
double m00_tanh(d00_tanh0,bsimbulk_lexp(((devsign*pModel->SSL4)*((NP(g)-NP(b))-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VTH]))))
#if defined(_DERIVATE)
double m10_tanh(d10_tanh0,d00_tanh0,bsimbulk_lexp(((devsign*pModel->SSL4)*((NP(g)-NP(b))-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VTH]))))
#endif
#if defined(_DERIVATE) /* probe=V(g,b)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
PHIB_SSL_Vg_b=(pModel->SSL3*bsimbulk_d_lexp(((devsign*pModel->SSL4)*((NP(g)-NP(b))-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VTH])),((devsign*pModel->SSL4)))*d10_tanh0);
PHIB_SSL_Vdi_bi=(pModel->SSL3*bsimbulk_d_lexp(((devsign*pModel->SSL4)*((NP(g)-NP(b))-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VTH])),((devsign*pModel->SSL4)*(-VTH_Vdi_bi)))*d10_tanh0);
PHIB_SSL_Vsi_bi=(pModel->SSL3*bsimbulk_d_lexp(((devsign*pModel->SSL4)*((NP(g)-NP(b))-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VTH])),((devsign*pModel->SSL4)*(-VTH_Vsi_bi)))*d10_tanh0);
PHIB_SSL_Tempt_GND=(pModel->SSL3*bsimbulk_d_lexp(((devsign*pModel->SSL4)*((NP(g)-NP(b))-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VTH])),((devsign*pModel->SSL4)*(-VTH_Tempt_GND)))*d10_tanh0);
#endif
PHIB_SSL=(pModel->SSL3*d00_tanh0);
EXIT_IF_ISNAN((pModel->SSL3*d00_tanh0))
}
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(g,b) ddxprobe= */
Issl_Vdbulk_di=(((((((((sigvds*pInst->NF)*Weff)*SSL0_NT_Vdbulk_di)*bsimbulk_lexp(((-SSL1_NT)*Leff)))+((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_d_lexp(((-SSL1_NT)*Leff),(-SSL1_NT_Vdbulk_di)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))+(((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_d_lexp((PHIB_SSL/Vt),0.0)))*(bsimbulk_lexp(((pModel->SSL2*Vdsx)/Vt))-1.0))+((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))*bsimbulk_d_lexp(((pModel->SSL2*Vdsx)/Vt),0.0)));
Issl_Vsbulk_si=(((((((((sigvds*pInst->NF)*Weff)*SSL0_NT_Vsbulk_si)*bsimbulk_lexp(((-SSL1_NT)*Leff)))+((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_d_lexp(((-SSL1_NT)*Leff),(-SSL1_NT_Vsbulk_si)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))+(((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_d_lexp((PHIB_SSL/Vt),0.0)))*(bsimbulk_lexp(((pModel->SSL2*Vdsx)/Vt))-1.0))+((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))*bsimbulk_d_lexp(((pModel->SSL2*Vdsx)/Vt),0.0)));
Issl_Vgi_bi=(((((((((sigvds*pInst->NF)*Weff)*SSL0_NT_Vgi_bi)*bsimbulk_lexp(((-SSL1_NT)*Leff)))+((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_d_lexp(((-SSL1_NT)*Leff),(-SSL1_NT_Vgi_bi)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))+(((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_d_lexp((PHIB_SSL/Vt),0.0)))*(bsimbulk_lexp(((pModel->SSL2*Vdsx)/Vt))-1.0))+((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))*bsimbulk_d_lexp(((pModel->SSL2*Vdsx)/Vt),0.0)));
Issl_Vdi_bi=(((((((((sigvds*pInst->NF)*Weff)*SSL0_NT_Vdi_bi)*bsimbulk_lexp(((-SSL1_NT)*Leff)))+((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_d_lexp(((-SSL1_NT)*Leff),(-SSL1_NT_Vdi_bi)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))+(((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_d_lexp((PHIB_SSL/Vt),(PHIB_SSL_Vdi_bi/Vt))))*(bsimbulk_lexp(((pModel->SSL2*Vdsx)/Vt))-1.0))+((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))*bsimbulk_d_lexp(((pModel->SSL2*Vdsx)/Vt),((pModel->SSL2*Vdsx_Vdi_bi)/Vt))));
Issl_Vsi_bi=(((((((((sigvds*pInst->NF)*Weff)*SSL0_NT_Vsi_bi)*bsimbulk_lexp(((-SSL1_NT)*Leff)))+((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_d_lexp(((-SSL1_NT)*Leff),(-SSL1_NT_Vsi_bi)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))+(((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_d_lexp((PHIB_SSL/Vt),(PHIB_SSL_Vsi_bi/Vt))))*(bsimbulk_lexp(((pModel->SSL2*Vdsx)/Vt))-1.0))+((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))*bsimbulk_d_lexp(((pModel->SSL2*Vdsx)/Vt),((pModel->SSL2*Vdsx_Vsi_bi)/Vt))));
Issl_Tempt_GND=(((((((((sigvds*pInst->NF)*Weff)*SSL0_NT_Tempt_GND)*bsimbulk_lexp(((-SSL1_NT)*Leff)))+((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_d_lexp(((-SSL1_NT)*Leff),(-SSL1_NT_Tempt_GND)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))+(((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_d_lexp((PHIB_SSL/Vt),((PHIB_SSL_Tempt_GND*Vt-PHIB_SSL*Vt_Tempt_GND)/Vt/Vt))))*(bsimbulk_lexp(((pModel->SSL2*Vdsx)/Vt))-1.0))+((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))*bsimbulk_d_lexp(((pModel->SSL2*Vdsx)/Vt),(((pModel->SSL2*Vdsx_Tempt_GND)*Vt-(pModel->SSL2*Vdsx)*Vt_Tempt_GND)/Vt/Vt))));
Issl_Vg_b=((((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_d_lexp(((-SSL1_NT)*Leff),0.0))*bsimbulk_lexp((PHIB_SSL/Vt)))+(((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_d_lexp((PHIB_SSL/Vt),(PHIB_SSL_Vg_b/Vt))))*(bsimbulk_lexp(((pModel->SSL2*Vdsx)/Vt))-1.0))+((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))*bsimbulk_d_lexp(((pModel->SSL2*Vdsx)/Vt),0.0)));
#endif
Issl=((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))*(bsimbulk_lexp(((pModel->SSL2*Vdsx)/Vt))-1.0));
EXIT_IF_ISNAN(((((((sigvds*pInst->NF)*Weff)*SSL0_NT)*bsimbulk_lexp(((-SSL1_NT)*Leff)))*bsimbulk_lexp((PHIB_SSL/Vt)))*(bsimbulk_lexp(((pModel->SSL2*Vdsx)/Vt))-1.0)))
  _load_static_residual2(di,si,Issl)
  _load_static_jacobian4(di,si,g,b,Issl_Vg_b)
  _load_static_jacobian2s(di,si,t,Issl_Tempt_GND)
  _load_static_jacobian4(di,si,si,bi,Issl_Vsi_bi)
  _load_static_jacobian4(di,si,di,bi,Issl_Vdi_bi)
  _load_static_jacobian4(di,si,gi,bi,Issl_Vgi_bi)
  _load_static_jacobian4(di,si,sbulk,si,Issl_Vsbulk_si)
  _load_static_jacobian4(di,si,dbulk,di,Issl_Vdbulk_di)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
Nt_Tempt_GND=(4.0*Vt_Tempt_GND)*1.60219e-19;
#endif
Nt=((4.0*Vt)*1.60219e-19);
EXIT_IF_ISNAN(((4.0*Vt)*1.60219e-19))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Esatnoi_Tempt_GND=(((2.0*VSAT_a_Tempt_GND)*ueff-(2.0*VSAT_a)*ueff_Tempt_GND)/ueff/ueff);
#endif
Esatnoi_Vdi_bi=(((2.0*VSAT_a_Vdi_bi)*ueff-(2.0*VSAT_a)*ueff_Vdi_bi)/ueff/ueff);
#if defined(_DERIVATE2)
  Esatnoi_Vdi_bi_Tempt_GND=((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*VSAT_a_Vdi_bi+2.0*VSAT_a_Vdi_bi_Tempt_GND)/ueff-((2.0*VSAT_a_Vdi_bi)*ueff_Tempt_GND+((2.0*VSAT_a_Tempt_GND))*ueff_Vdi_bi+(2.0*VSAT_a)*ueff_Vdi_bi_Tempt_GND)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vdi_bi*ueff_Tempt_GND/ueff/ueff/ueff);
  Esatnoi_Vdi_bi_Vdi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vdi_bi+0.0*VSAT_a_Vdi_bi+2.0*VSAT_a_Vdi_bi_Vdi_bi)/ueff-((2.0*VSAT_a_Vdi_bi)*ueff_Vdi_bi+((2.0*VSAT_a_Vdi_bi))*ueff_Vdi_bi+(2.0*VSAT_a)*ueff_Vdi_bi_Vdi_bi)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vdi_bi*ueff_Vdi_bi/ueff/ueff/ueff);
  Esatnoi_Vdi_bi_Vsi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vsi_bi+0.0*VSAT_a_Vdi_bi+2.0*VSAT_a_Vdi_bi_Vsi_bi)/ueff-((2.0*VSAT_a_Vdi_bi)*ueff_Vsi_bi+((2.0*VSAT_a_Vsi_bi))*ueff_Vdi_bi+(2.0*VSAT_a)*ueff_Vdi_bi_Vsi_bi)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vdi_bi*ueff_Vsi_bi/ueff/ueff/ueff);
  Esatnoi_Vdi_bi_Vgi_bi=((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vdi_bi+2.0*0.0)/ueff-((2.0*VSAT_a_Vdi_bi)*ueff_Vgi_bi+(0.0)*ueff_Vdi_bi+(2.0*VSAT_a)*ueff_Vdi_bi_Vgi_bi)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vdi_bi*ueff_Vgi_bi/ueff/ueff/ueff);
#endif
Esatnoi_Vsi_bi=(((2.0*VSAT_a_Vsi_bi)*ueff-(2.0*VSAT_a)*ueff_Vsi_bi)/ueff/ueff);
#if defined(_DERIVATE2)
  Esatnoi_Vsi_bi_Tempt_GND=((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*VSAT_a_Vsi_bi+2.0*VSAT_a_Vsi_bi_Tempt_GND)/ueff-((2.0*VSAT_a_Vsi_bi)*ueff_Tempt_GND+((2.0*VSAT_a_Tempt_GND))*ueff_Vsi_bi+(2.0*VSAT_a)*ueff_Vsi_bi_Tempt_GND)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vsi_bi*ueff_Tempt_GND/ueff/ueff/ueff);
  Esatnoi_Vsi_bi_Vdi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vdi_bi+0.0*VSAT_a_Vsi_bi+2.0*VSAT_a_Vsi_bi_Vdi_bi)/ueff-((2.0*VSAT_a_Vsi_bi)*ueff_Vdi_bi+((2.0*VSAT_a_Vdi_bi))*ueff_Vsi_bi+(2.0*VSAT_a)*ueff_Vsi_bi_Vdi_bi)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vsi_bi*ueff_Vdi_bi/ueff/ueff/ueff);
  Esatnoi_Vsi_bi_Vsi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vsi_bi+0.0*VSAT_a_Vsi_bi+2.0*VSAT_a_Vsi_bi_Vsi_bi)/ueff-((2.0*VSAT_a_Vsi_bi)*ueff_Vsi_bi+((2.0*VSAT_a_Vsi_bi))*ueff_Vsi_bi+(2.0*VSAT_a)*ueff_Vsi_bi_Vsi_bi)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vsi_bi*ueff_Vsi_bi/ueff/ueff/ueff);
  Esatnoi_Vsi_bi_Vgi_bi=((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vsi_bi+2.0*0.0)/ueff-((2.0*VSAT_a_Vsi_bi)*ueff_Vgi_bi+(0.0)*ueff_Vsi_bi+(2.0*VSAT_a)*ueff_Vsi_bi_Vgi_bi)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vsi_bi*ueff_Vgi_bi/ueff/ueff/ueff);
#endif
Esatnoi_Vgi_bi=(-(2.0*VSAT_a)*ueff_Vgi_bi/ueff/ueff);
#if defined(_DERIVATE2)
  Esatnoi_Vgi_bi_Tempt_GND=((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Tempt_GND+((2.0*VSAT_a_Tempt_GND))*ueff_Vgi_bi+(2.0*VSAT_a)*ueff_Vgi_bi_Tempt_GND)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vgi_bi*ueff_Tempt_GND/ueff/ueff/ueff);
  Esatnoi_Vgi_bi_Vdi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vdi_bi+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vdi_bi+((2.0*VSAT_a_Vdi_bi))*ueff_Vgi_bi+(2.0*VSAT_a)*ueff_Vgi_bi_Vdi_bi)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vgi_bi*ueff_Vdi_bi/ueff/ueff/ueff);
  Esatnoi_Vgi_bi_Vsi_bi=((+0.0*VSAT_a+0.0*VSAT_a_Vsi_bi+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vsi_bi+((2.0*VSAT_a_Vsi_bi))*ueff_Vgi_bi+(2.0*VSAT_a)*ueff_Vgi_bi_Vsi_bi)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vgi_bi*ueff_Vsi_bi/ueff/ueff/ueff);
  Esatnoi_Vgi_bi_Vgi_bi=((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vgi_bi+(0.0)*ueff_Vgi_bi+(2.0*VSAT_a)*ueff_Vgi_bi_Vgi_bi)/ueff/ueff+2*(2.0*VSAT_a)*ueff_Vgi_bi*ueff_Vgi_bi/ueff/ueff/ueff);
#endif
#endif
Esatnoi=((2.0*VSAT_a)/ueff);
EXIT_IF_ISNAN(((2.0*VSAT_a)/ueff))
if
((pModel->EM<=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
DelClm_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  DelClm_Vdbulk_di_Vdbulk_di=0.0;
  DelClm_Vdbulk_di_Vsbulk_si=0.0;
  DelClm_Vdbulk_di_Vgi_bi=0.0;
  DelClm_Vdbulk_di_Vdi_bi=0.0;
  DelClm_Vdbulk_di_Vsi_bi=0.0;
  DelClm_Vdbulk_di_Tempt_GND=0.0;
#endif
DelClm_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  DelClm_Vsbulk_si_Vdbulk_di=0.0;
  DelClm_Vsbulk_si_Vsbulk_si=0.0;
  DelClm_Vsbulk_si_Vgi_bi=0.0;
  DelClm_Vsbulk_si_Vdi_bi=0.0;
  DelClm_Vsbulk_si_Vsi_bi=0.0;
  DelClm_Vsbulk_si_Tempt_GND=0.0;
#endif
DelClm_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  DelClm_Vgi_bi_Vdbulk_di=0.0;
  DelClm_Vgi_bi_Vsbulk_si=0.0;
  DelClm_Vgi_bi_Vgi_bi=0.0;
  DelClm_Vgi_bi_Vdi_bi=0.0;
  DelClm_Vgi_bi_Vsi_bi=0.0;
  DelClm_Vgi_bi_Tempt_GND=0.0;
#endif
DelClm_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  DelClm_Vdi_bi_Vdbulk_di=0.0;
  DelClm_Vdi_bi_Vsbulk_si=0.0;
  DelClm_Vdi_bi_Vgi_bi=0.0;
  DelClm_Vdi_bi_Vdi_bi=0.0;
  DelClm_Vdi_bi_Vsi_bi=0.0;
  DelClm_Vdi_bi_Tempt_GND=0.0;
#endif
DelClm_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  DelClm_Vsi_bi_Vdbulk_di=0.0;
  DelClm_Vsi_bi_Vsbulk_si=0.0;
  DelClm_Vsi_bi_Vgi_bi=0.0;
  DelClm_Vsi_bi_Vdi_bi=0.0;
  DelClm_Vsi_bi_Vsi_bi=0.0;
  DelClm_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
DelClm_Tempt_GND=0.0;
#endif
#endif
DelClm=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(((diffVds_Vgi_bi/litl)*Esatnoi-((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+(0.0/litl-(diffVds_Vgi_bi*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vgi_bi/litl)*0.0+0.0*Esatnoi_Vgi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vgi_bi_Vgm_si=((+(0.0/litl-(diffVds_Vgi_bi*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vgi_bi/litl)*0.0+0.0*Esatnoi_Vgi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vgi_bi_Vdbulk_di=((+(diffVds_Vgi_bi_Vdbulk_di/litl-(diffVds_Vgi_bi*0.0+diffVds_Vdbulk_di*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vgi_bi/litl)*0.0+(diffVds_Vdbulk_di/litl)*Esatnoi_Vgi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vgi_bi_Vsbulk_si=((+(diffVds_Vgi_bi_Vsbulk_si/litl-(diffVds_Vgi_bi*0.0+diffVds_Vsbulk_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vgi_bi/litl)*0.0+(diffVds_Vsbulk_si/litl)*Esatnoi_Vgi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vgi_bi_Vgi_bi=((+(diffVds_Vgi_bi_Vgi_bi/litl-(diffVds_Vgi_bi*0.0+diffVds_Vgi_bi*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vgi_bi/litl)*Esatnoi_Vgi_bi+(diffVds_Vgi_bi/litl)*Esatnoi_Vgi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi_Vgi_bi)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi*Esatnoi_Vgi_bi/Esatnoi/Esatnoi/Esatnoi);
  T0_Vgi_bi_Vdi_bi=((+(diffVds_Vgi_bi_Vdi_bi/litl-(diffVds_Vgi_bi*0.0+diffVds_Vdi_bi*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vgi_bi/litl)*Esatnoi_Vdi_bi+(diffVds_Vdi_bi/litl)*Esatnoi_Vgi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi_Vdi_bi)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi*Esatnoi_Vdi_bi/Esatnoi/Esatnoi/Esatnoi);
  T0_Vgi_bi_Vsi_bi=((+(diffVds_Vgi_bi_Vsi_bi/litl-(diffVds_Vgi_bi*0.0+diffVds_Vsi_bi*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vgi_bi/litl)*Esatnoi_Vsi_bi+(diffVds_Vsi_bi/litl)*Esatnoi_Vgi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi_Vsi_bi)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi*Esatnoi_Vsi_bi/Esatnoi/Esatnoi/Esatnoi);
  T0_Vgi_bi_Tempt_GND=((+(diffVds_Vgi_bi_Tempt_GND/litl-(diffVds_Vgi_bi*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vgi_bi/litl)*Esatnoi_Tempt_GND+(diffVds_Tempt_GND/litl)*Esatnoi_Vgi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi_Tempt_GND)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vgi_bi*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi);
#endif
T0_Vdi_bi=(((diffVds_Vdi_bi/litl)*Esatnoi-((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+(0.0/litl-(diffVds_Vdi_bi*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_bi/litl)*0.0+0.0*Esatnoi_Vdi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_bi_Vgm_si=((+(0.0/litl-(diffVds_Vdi_bi*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_bi/litl)*0.0+0.0*Esatnoi_Vdi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_bi_Vdbulk_di=((+(diffVds_Vdi_bi_Vdbulk_di/litl-(diffVds_Vdi_bi*0.0+diffVds_Vdbulk_di*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_bi/litl)*0.0+(diffVds_Vdbulk_di/litl)*Esatnoi_Vdi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_bi_Vsbulk_si=((+(diffVds_Vdi_bi_Vsbulk_si/litl-(diffVds_Vdi_bi*0.0+diffVds_Vsbulk_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_bi/litl)*0.0+(diffVds_Vsbulk_si/litl)*Esatnoi_Vdi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_bi_Vgi_bi=((+(diffVds_Vdi_bi_Vgi_bi/litl-(diffVds_Vdi_bi*0.0+diffVds_Vgi_bi*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_bi/litl)*Esatnoi_Vgi_bi+(diffVds_Vgi_bi/litl)*Esatnoi_Vdi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi_Vgi_bi)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi*Esatnoi_Vgi_bi/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_bi_Vdi_bi=((+(diffVds_Vdi_bi_Vdi_bi/litl-(diffVds_Vdi_bi*0.0+diffVds_Vdi_bi*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_bi/litl)*Esatnoi_Vdi_bi+(diffVds_Vdi_bi/litl)*Esatnoi_Vdi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi_Vdi_bi)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi*Esatnoi_Vdi_bi/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_bi_Vsi_bi=((+(diffVds_Vdi_bi_Vsi_bi/litl-(diffVds_Vdi_bi*0.0+diffVds_Vsi_bi*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_bi/litl)*Esatnoi_Vsi_bi+(diffVds_Vsi_bi/litl)*Esatnoi_Vdi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi_Vsi_bi)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi*Esatnoi_Vsi_bi/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_bi_Tempt_GND=((+(diffVds_Vdi_bi_Tempt_GND/litl-(diffVds_Vdi_bi*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_bi/litl)*Esatnoi_Tempt_GND+(diffVds_Tempt_GND/litl)*Esatnoi_Vdi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi_Tempt_GND)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_bi*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi);
#endif
T0_Vsi_bi=(((diffVds_Vsi_bi/litl)*Esatnoi-((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+(0.0/litl-(diffVds_Vsi_bi*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vsi_bi/litl)*0.0+0.0*Esatnoi_Vsi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vsi_bi_Vgm_si=((+(0.0/litl-(diffVds_Vsi_bi*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vsi_bi/litl)*0.0+0.0*Esatnoi_Vsi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vsi_bi_Vdbulk_di=((+(diffVds_Vsi_bi_Vdbulk_di/litl-(diffVds_Vsi_bi*0.0+diffVds_Vdbulk_di*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vsi_bi/litl)*0.0+(diffVds_Vdbulk_di/litl)*Esatnoi_Vsi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vsi_bi_Vsbulk_si=((+(diffVds_Vsi_bi_Vsbulk_si/litl-(diffVds_Vsi_bi*0.0+diffVds_Vsbulk_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vsi_bi/litl)*0.0+(diffVds_Vsbulk_si/litl)*Esatnoi_Vsi_bi+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vsi_bi_Vgi_bi=((+(diffVds_Vsi_bi_Vgi_bi/litl-(diffVds_Vsi_bi*0.0+diffVds_Vgi_bi*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vsi_bi/litl)*Esatnoi_Vgi_bi+(diffVds_Vgi_bi/litl)*Esatnoi_Vsi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi_Vgi_bi)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi*Esatnoi_Vgi_bi/Esatnoi/Esatnoi/Esatnoi);
  T0_Vsi_bi_Vdi_bi=((+(diffVds_Vsi_bi_Vdi_bi/litl-(diffVds_Vsi_bi*0.0+diffVds_Vdi_bi*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vsi_bi/litl)*Esatnoi_Vdi_bi+(diffVds_Vdi_bi/litl)*Esatnoi_Vsi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi_Vdi_bi)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi*Esatnoi_Vdi_bi/Esatnoi/Esatnoi/Esatnoi);
  T0_Vsi_bi_Vsi_bi=((+(diffVds_Vsi_bi_Vsi_bi/litl-(diffVds_Vsi_bi*0.0+diffVds_Vsi_bi*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vsi_bi/litl)*Esatnoi_Vsi_bi+(diffVds_Vsi_bi/litl)*Esatnoi_Vsi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi_Vsi_bi)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi*Esatnoi_Vsi_bi/Esatnoi/Esatnoi/Esatnoi);
  T0_Vsi_bi_Tempt_GND=((+(diffVds_Vsi_bi_Tempt_GND/litl-(diffVds_Vsi_bi*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vsi_bi/litl)*Esatnoi_Tempt_GND+(diffVds_Tempt_GND/litl)*Esatnoi_Vsi_bi+((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi_Tempt_GND)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vsi_bi*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(((diffVds_Tempt_GND/litl)*Esatnoi-((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND)/Esatnoi/Esatnoi);
#endif
#endif
T0=(((diffVds/litl)+pModel->EM)/Esatnoi);
EXIT_IF_ISNAN((((diffVds/litl)+pModel->EM)/Esatnoi))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
DelClm_Vdbulk_di=(litl*bsimbulk_d_lln(T0,T0_Vdbulk_di));
#if defined(_DERIVATE2)
  DelClm_Vdbulk_di_Vdbulk_di=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+litl*T0_Vdbulk_di_Vdbulk_di);
  DelClm_Vdbulk_di_Vsbulk_si=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+litl*T0_Vdbulk_di_Vsbulk_si);
  DelClm_Vdbulk_di_Vgi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+litl*T0_Vdbulk_di_Vgi_bi);
  DelClm_Vdbulk_di_Vdi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+litl*T0_Vdbulk_di_Vdi_bi);
  DelClm_Vdbulk_di_Vsi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+litl*T0_Vdbulk_di_Vsi_bi);
  DelClm_Vdbulk_di_Tempt_GND=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+0.0*bsimbulk_d_lln(T0,T0_Vdbulk_di)+litl*T0_Vdbulk_di_Tempt_GND);
#endif
DelClm_Vsbulk_si=(litl*bsimbulk_d_lln(T0,T0_Vsbulk_si));
#if defined(_DERIVATE2)
  DelClm_Vsbulk_si_Vdbulk_di=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+litl*T0_Vsbulk_si_Vdbulk_di);
  DelClm_Vsbulk_si_Vsbulk_si=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+litl*T0_Vsbulk_si_Vsbulk_si);
  DelClm_Vsbulk_si_Vgi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+litl*T0_Vsbulk_si_Vgi_bi);
  DelClm_Vsbulk_si_Vdi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+litl*T0_Vsbulk_si_Vdi_bi);
  DelClm_Vsbulk_si_Vsi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+litl*T0_Vsbulk_si_Vsi_bi);
  DelClm_Vsbulk_si_Tempt_GND=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+0.0*bsimbulk_d_lln(T0,T0_Vsbulk_si)+litl*T0_Vsbulk_si_Tempt_GND);
#endif
DelClm_Vgi_bi=(litl*bsimbulk_d_lln(T0,T0_Vgi_bi));
#if defined(_DERIVATE2)
  DelClm_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+litl*T0_Vgi_bi_Vdbulk_di);
  DelClm_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+litl*T0_Vgi_bi_Vsbulk_si);
  DelClm_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+litl*T0_Vgi_bi_Vgi_bi);
  DelClm_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+litl*T0_Vgi_bi_Vdi_bi);
  DelClm_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+litl*T0_Vgi_bi_Vsi_bi);
  DelClm_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vgi_bi)+litl*T0_Vgi_bi_Tempt_GND);
#endif
DelClm_Vdi_bi=(litl*bsimbulk_d_lln(T0,T0_Vdi_bi));
#if defined(_DERIVATE2)
  DelClm_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+litl*T0_Vdi_bi_Vdbulk_di);
  DelClm_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+litl*T0_Vdi_bi_Vsbulk_si);
  DelClm_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+litl*T0_Vdi_bi_Vgi_bi);
  DelClm_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+litl*T0_Vdi_bi_Vdi_bi);
  DelClm_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+litl*T0_Vdi_bi_Vsi_bi);
  DelClm_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vdi_bi)+litl*T0_Vdi_bi_Tempt_GND);
#endif
DelClm_Vsi_bi=(litl*bsimbulk_d_lln(T0,T0_Vsi_bi));
#if defined(_DERIVATE2)
  DelClm_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+litl*T0_Vsi_bi_Vdbulk_di);
  DelClm_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+litl*T0_Vsi_bi_Vsbulk_si);
  DelClm_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+litl*T0_Vsi_bi_Vgi_bi);
  DelClm_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+litl*T0_Vsi_bi_Vdi_bi);
  DelClm_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+litl*T0_Vsi_bi_Vsi_bi);
  DelClm_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln(T0)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+0.0*bsimbulk_d_lln(T0,T0_Vsi_bi)+litl*T0_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
DelClm_Tempt_GND=(litl*bsimbulk_d_lln(T0,T0_Tempt_GND));
#endif
#endif
DelClm=(litl*bsimbulk_lln(T0));
EXIT_IF_ISNAN((litl*bsimbulk_lln(T0)))
if
((DelClm<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
DelClm_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  DelClm_Vdbulk_di_Vdbulk_di=0.0;
  DelClm_Vdbulk_di_Vsbulk_si=0.0;
  DelClm_Vdbulk_di_Vgi_bi=0.0;
  DelClm_Vdbulk_di_Vdi_bi=0.0;
  DelClm_Vdbulk_di_Vsi_bi=0.0;
  DelClm_Vdbulk_di_Tempt_GND=0.0;
#endif
DelClm_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  DelClm_Vsbulk_si_Vdbulk_di=0.0;
  DelClm_Vsbulk_si_Vsbulk_si=0.0;
  DelClm_Vsbulk_si_Vgi_bi=0.0;
  DelClm_Vsbulk_si_Vdi_bi=0.0;
  DelClm_Vsbulk_si_Vsi_bi=0.0;
  DelClm_Vsbulk_si_Tempt_GND=0.0;
#endif
DelClm_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  DelClm_Vgi_bi_Vdbulk_di=0.0;
  DelClm_Vgi_bi_Vsbulk_si=0.0;
  DelClm_Vgi_bi_Vgi_bi=0.0;
  DelClm_Vgi_bi_Vdi_bi=0.0;
  DelClm_Vgi_bi_Vsi_bi=0.0;
  DelClm_Vgi_bi_Tempt_GND=0.0;
#endif
DelClm_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  DelClm_Vdi_bi_Vdbulk_di=0.0;
  DelClm_Vdi_bi_Vsbulk_si=0.0;
  DelClm_Vdi_bi_Vgi_bi=0.0;
  DelClm_Vdi_bi_Vdi_bi=0.0;
  DelClm_Vdi_bi_Vsi_bi=0.0;
  DelClm_Vdi_bi_Tempt_GND=0.0;
#endif
DelClm_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  DelClm_Vsi_bi_Vdbulk_di=0.0;
  DelClm_Vsi_bi_Vsbulk_si=0.0;
  DelClm_Vsi_bi_Vgi_bi=0.0;
  DelClm_Vsi_bi_Vdi_bi=0.0;
  DelClm_Vsi_bi_Vsi_bi=0.0;
  DelClm_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
DelClm_Tempt_GND=0.0;
#endif
#endif
DelClm=0.0;
EXIT_IF_ISNAN(0.0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
#if defined(_DERIVATE)
Nstar_Tempt_GND=(((Vt_Tempt_GND/1.60219e-19)*((Cox+Cdep)+CIT_i))+((Vt/1.60219e-19)*Cdep_Tempt_GND));
#endif
Nstar_Vdi_bi=((Vt/1.60219e-19)*Cdep_Vdi_bi);
#if defined(_DERIVATE2)
  Nstar_Vdi_bi_Tempt_GND=(+(0.0/1.60219e-19-(0.0*0.0+Vt_Tempt_GND*0.0+Vt*0.0)/1.60219e-19/1.60219e-19+2*Vt*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19)*((Cox+Cdep)+CIT_i)+0.0*Cdep_Tempt_GND+(Vt_Tempt_GND/1.60219e-19)*Cdep_Vdi_bi+(Vt/1.60219e-19)*(+(+0.0+Cdep_Vdi_bi_Tempt_GND)+0.0));
  Nstar_Vdi_bi_Vdi_bi=(+(0.0/1.60219e-19-(0.0*0.0+0.0*0.0+Vt*0.0)/1.60219e-19/1.60219e-19+2*Vt*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19)*((Cox+Cdep)+CIT_i)+0.0*Cdep_Vdi_bi+0.0*Cdep_Vdi_bi+(Vt/1.60219e-19)*(+(+0.0+Cdep_Vdi_bi_Vdi_bi)+0.0));
  Nstar_Vdi_bi_Vsi_bi=(+(0.0/1.60219e-19-(0.0*0.0+0.0*0.0+Vt*0.0)/1.60219e-19/1.60219e-19+2*Vt*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19)*((Cox+Cdep)+CIT_i)+0.0*Cdep_Vsi_bi+0.0*Cdep_Vdi_bi+(Vt/1.60219e-19)*(+(+0.0+Cdep_Vdi_bi_Vsi_bi)+0.0));
#endif
Nstar_Vsi_bi=((Vt/1.60219e-19)*Cdep_Vsi_bi);
#if defined(_DERIVATE2)
  Nstar_Vsi_bi_Tempt_GND=(+(0.0/1.60219e-19-(0.0*0.0+Vt_Tempt_GND*0.0+Vt*0.0)/1.60219e-19/1.60219e-19+2*Vt*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19)*((Cox+Cdep)+CIT_i)+0.0*Cdep_Tempt_GND+(Vt_Tempt_GND/1.60219e-19)*Cdep_Vsi_bi+(Vt/1.60219e-19)*(+(+0.0+Cdep_Vsi_bi_Tempt_GND)+0.0));
  Nstar_Vsi_bi_Vdi_bi=(+(0.0/1.60219e-19-(0.0*0.0+0.0*0.0+Vt*0.0)/1.60219e-19/1.60219e-19+2*Vt*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19)*((Cox+Cdep)+CIT_i)+0.0*Cdep_Vdi_bi+0.0*Cdep_Vsi_bi+(Vt/1.60219e-19)*(+(+0.0+Cdep_Vsi_bi_Vdi_bi)+0.0));
  Nstar_Vsi_bi_Vsi_bi=(+(0.0/1.60219e-19-(0.0*0.0+0.0*0.0+Vt*0.0)/1.60219e-19/1.60219e-19+2*Vt*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19)*((Cox+Cdep)+CIT_i)+0.0*Cdep_Vsi_bi+0.0*Cdep_Vsi_bi+(Vt/1.60219e-19)*(+(+0.0+Cdep_Vsi_bi_Vsi_bi)+0.0));
#endif
#endif
Nstar=((Vt/1.60219e-19)*((Cox+Cdep)+CIT_i));
EXIT_IF_ISNAN(((Vt/1.60219e-19)*((Cox+Cdep)+CIT_i)))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
Nl_Vgi_bi=((((2.0*nq_Vgi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi))/1.60219e-19);
#if defined(_DERIVATE2)
  Nl_Vgi_bi_Vgi_bi=((+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vgi_bi)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*0.0+(((2.0*nq_Vgi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vgi_bi)*Cox*Vt*qdeff_Vgi_bi+((((2.0*nq_Vgi_bi))*Cox)*Vt)*qdeff_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi_Vgi_bi)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi))*0.0+(((((((2.0*nq_Vgi_bi))*Cox)*Vt)*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Nl_Vgi_bi_Tempt_GND=((+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Tempt_GND)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*Vt_Tempt_GND+(((2.0*nq_Tempt_GND))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vgi_bi)*Cox*Vt*qdeff_Tempt_GND+((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qdeff_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi_Tempt_GND)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi))*0.0+(((((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Tempt_GND)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Nl_Vgi_bi_Vdi_bi=((+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdi_bi)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*0.0+(((2.0*nq_Vdi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vgi_bi)*Cox*Vt*qdeff_Vdi_bi+((((2.0*nq_Vdi_bi))*Cox)*Vt)*qdeff_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi_Vdi_bi)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi))*0.0+(((((((2.0*nq_Vdi_bi))*Cox)*Vt)*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Nl_Vgi_bi_Vsi_bi=((+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsi_bi)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*0.0+(((2.0*nq_Vsi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vgi_bi)*Cox*Vt*qdeff_Vsi_bi+((((2.0*nq_Vsi_bi))*Cox)*Vt)*qdeff_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi_Vsi_bi)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi))*0.0+(((((((2.0*nq_Vsi_bi))*Cox)*Vt)*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
#endif
#if defined(_DERIVATE)
Nl_Tempt_GND=((((((2.0*nq_Tempt_GND)*Cox*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND))*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Tempt_GND))/1.60219e-19);
#endif
Nl_Vdi_bi=((((2.0*nq_Vdi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi))/1.60219e-19);
#if defined(_DERIVATE2)
  Nl_Vdi_bi_Vgi_bi=((+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vgi_bi)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*0.0+(((2.0*nq_Vgi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vdi_bi)*Cox*Vt*qdeff_Vgi_bi+((((2.0*nq_Vgi_bi))*Cox)*Vt)*qdeff_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi_Vgi_bi)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi))*0.0+(((((((2.0*nq_Vgi_bi))*Cox)*Vt)*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Nl_Vdi_bi_Tempt_GND=((+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Tempt_GND)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*Vt_Tempt_GND+(((2.0*nq_Tempt_GND))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vdi_bi)*Cox*Vt*qdeff_Tempt_GND+((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qdeff_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi_Tempt_GND)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi))*0.0+(((((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Tempt_GND)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Nl_Vdi_bi_Vdi_bi=((+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdi_bi)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*0.0+(((2.0*nq_Vdi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vdi_bi)*Cox*Vt*qdeff_Vdi_bi+((((2.0*nq_Vdi_bi))*Cox)*Vt)*qdeff_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi_Vdi_bi)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi))*0.0+(((((((2.0*nq_Vdi_bi))*Cox)*Vt)*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Nl_Vdi_bi_Vsi_bi=((+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsi_bi)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*0.0+(((2.0*nq_Vsi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vdi_bi)*Cox*Vt*qdeff_Vsi_bi+((((2.0*nq_Vsi_bi))*Cox)*Vt)*qdeff_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi_Vsi_bi)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi))*0.0+(((((((2.0*nq_Vsi_bi))*Cox)*Vt)*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
#endif
Nl_Vsi_bi=((((2.0*nq_Vsi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi))/1.60219e-19);
#if defined(_DERIVATE2)
  Nl_Vsi_bi_Vgi_bi=((+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vgi_bi)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*0.0+(((2.0*nq_Vgi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vsi_bi)*Cox*Vt*qdeff_Vgi_bi+((((2.0*nq_Vgi_bi))*Cox)*Vt)*qdeff_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi_Vgi_bi)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi))*0.0+(((((((2.0*nq_Vgi_bi))*Cox)*Vt)*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vgi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Nl_Vsi_bi_Tempt_GND=((+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Tempt_GND)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*Vt_Tempt_GND+(((2.0*nq_Tempt_GND))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vsi_bi)*Cox*Vt*qdeff_Tempt_GND+((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qdeff_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi_Tempt_GND)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi))*0.0+(((((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Tempt_GND)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Nl_Vsi_bi_Vdi_bi=((+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdi_bi)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*0.0+(((2.0*nq_Vdi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vsi_bi)*Cox*Vt*qdeff_Vdi_bi+((((2.0*nq_Vdi_bi))*Cox)*Vt)*qdeff_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi_Vdi_bi)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi))*0.0+(((((((2.0*nq_Vdi_bi))*Cox)*Vt)*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vdi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Nl_Vsi_bi_Vsi_bi=((+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsi_bi)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*0.0+(((2.0*nq_Vsi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qdeff+(2.0*nq_Vsi_bi)*Cox*Vt*qdeff_Vsi_bi+((((2.0*nq_Vsi_bi))*Cox)*Vt)*qdeff_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi_Vsi_bi)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi))*0.0+(((((((2.0*nq_Vsi_bi))*Cox)*Vt)*qdeff)+((((2.0*nq)*Cox)*Vt)*qdeff_Vsi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qdeff)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qdeff)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
#endif
#endif
Nl=(((((2.0*nq)*Cox)*Vt)*qdeff)/1.60219e-19);
EXIT_IF_ISNAN((((((2.0*nq)*Cox)*Vt)*qdeff)/1.60219e-19))
{
double m00_fabs(d00_fabs0,ids)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,ids)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
T0a_Tempt_GND=(((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Tempt_GND*d10_fabs0))*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Tempt_GND));
#endif
T0a_Vgi_bi=((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0)*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vgi_bi));
#if defined(_DERIVATE2)
  T0a_Vgi_bi_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*Vt_Tempt_GND+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vt)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt_Tempt_GND)))*ids_Vgi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Tempt_GND*ids_Vgi_bi+d10_fabs0*ids_Vgi_bi_Tempt_GND))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0)*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vt)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Tempt_GND*d10_fabs0)))*ueff_Vgi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vgi_bi_Tempt_GND);
  T0a_Vgi_bi_Vgi_bi=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vgi_bi*d10_fabs0+(((0.0)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Vgi_bi*ids_Vgi_bi+d10_fabs0*ids_Vgi_bi_Vgi_bi))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0)*ueff_Vgi_bi+((((((0.0)*1.60219e-19)*Vt)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0)))*ueff_Vgi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vgi_bi_Vgi_bi);
  T0a_Vgi_bi_Vdi_bi=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vdi_bi*d10_fabs0+(((0.0)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Vdi_bi*ids_Vgi_bi+d10_fabs0*ids_Vgi_bi_Vdi_bi))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0)*ueff_Vdi_bi+((((((0.0)*1.60219e-19)*Vt)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0)))*ueff_Vgi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vgi_bi_Vdi_bi);
  T0a_Vgi_bi_Vsi_bi=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vsi_bi*d10_fabs0+(((0.0)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Vsi_bi*ids_Vgi_bi+d10_fabs0*ids_Vgi_bi_Vsi_bi))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0)*ueff_Vsi_bi+((((((0.0)*1.60219e-19)*Vt)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0)))*ueff_Vgi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vgi_bi_Vsi_bi);
#endif
T0a_Vdi_bi=((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0)*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vdi_bi));
#if defined(_DERIVATE2)
  T0a_Vdi_bi_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*Vt_Tempt_GND+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vt)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt_Tempt_GND)))*ids_Vdi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Tempt_GND*ids_Vdi_bi+d10_fabs0*ids_Vdi_bi_Tempt_GND))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0)*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vt)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Tempt_GND*d10_fabs0)))*ueff_Vdi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vdi_bi_Tempt_GND);
  T0a_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vgi_bi*d10_fabs0+(((0.0)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Vgi_bi*ids_Vdi_bi+d10_fabs0*ids_Vdi_bi_Vgi_bi))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0)*ueff_Vgi_bi+((((((0.0)*1.60219e-19)*Vt)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0)))*ueff_Vdi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vdi_bi_Vgi_bi);
  T0a_Vdi_bi_Vdi_bi=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vdi_bi*d10_fabs0+(((0.0)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Vdi_bi*ids_Vdi_bi+d10_fabs0*ids_Vdi_bi_Vdi_bi))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0)*ueff_Vdi_bi+((((((0.0)*1.60219e-19)*Vt)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0)))*ueff_Vdi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vdi_bi_Vdi_bi);
  T0a_Vdi_bi_Vsi_bi=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vsi_bi*d10_fabs0+(((0.0)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Vsi_bi*ids_Vdi_bi+d10_fabs0*ids_Vdi_bi_Vsi_bi))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0)*ueff_Vsi_bi+((((((0.0)*1.60219e-19)*Vt)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0)))*ueff_Vdi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vdi_bi_Vsi_bi);
#endif
T0a_Vsi_bi=((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0)*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vsi_bi));
#if defined(_DERIVATE2)
  T0a_Vsi_bi_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*Vt_Tempt_GND+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vt)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt_Tempt_GND)))*ids_Vsi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Tempt_GND*ids_Vsi_bi+d10_fabs0*ids_Vsi_bi_Tempt_GND))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0)*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vt)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Tempt_GND*d10_fabs0)))*ueff_Vsi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vsi_bi_Tempt_GND);
  T0a_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vgi_bi*d10_fabs0+(((0.0)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Vgi_bi*ids_Vsi_bi+d10_fabs0*ids_Vsi_bi_Vgi_bi))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0)*ueff_Vgi_bi+((((((0.0)*1.60219e-19)*Vt)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vgi_bi*d10_fabs0)))*ueff_Vsi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vsi_bi_Vgi_bi);
  T0a_Vsi_bi_Vdi_bi=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vdi_bi*d10_fabs0+(((0.0)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Vdi_bi*ids_Vsi_bi+d10_fabs0*ids_Vsi_bi_Vdi_bi))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0)*ueff_Vdi_bi+((((((0.0)*1.60219e-19)*Vt)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vdi_bi*d10_fabs0)))*ueff_Vsi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vsi_bi_Vdi_bi);
  T0a_Vsi_bi_Vsi_bi=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vt+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vsi_bi*d10_fabs0+(((0.0)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(m20_fabs(ids)*ids_Vsi_bi*ids_Vsi_bi+d10_fabs0*ids_Vsi_bi_Vsi_bi))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0)*ueff_Vsi_bi+((((((0.0)*1.60219e-19)*Vt)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*ids_Vsi_bi*d10_fabs0)))*ueff_Vsi_bi+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff_Vsi_bi_Vsi_bi);
#endif
#endif
T0a=(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff);
EXIT_IF_ISNAN((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*d00_fabs0)*ueff))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
T0b_Tempt_GND=(((((1.60219e-19*Vt_Tempt_GND)*ids)+((1.60219e-19*Vt)*ids_Tempt_GND))*ids)+(((1.60219e-19*Vt)*ids)*ids_Tempt_GND));
#endif
T0b_Vgi_bi=((((1.60219e-19*Vt)*ids_Vgi_bi)*ids)+(((1.60219e-19*Vt)*ids)*ids_Vgi_bi));
#if defined(_DERIVATE2)
  T0b_Vgi_bi_Tempt_GND=(+(+(+0.0*Vt+0.0*Vt_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Tempt_GND+((1.60219e-19*Vt_Tempt_GND))*ids_Vgi_bi+(1.60219e-19*Vt)*ids_Vgi_bi_Tempt_GND)*ids+((1.60219e-19*Vt)*ids_Vgi_bi)*ids_Tempt_GND+(((((1.60219e-19*Vt_Tempt_GND))*ids)+((1.60219e-19*Vt)*ids_Tempt_GND)))*ids_Vgi_bi+((1.60219e-19*Vt)*ids)*ids_Vgi_bi_Tempt_GND);
  T0b_Vgi_bi_Vgi_bi=(+(+(+0.0*Vt+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vgi_bi+(0.0)*ids_Vgi_bi+(1.60219e-19*Vt)*ids_Vgi_bi_Vgi_bi)*ids+((1.60219e-19*Vt)*ids_Vgi_bi)*ids_Vgi_bi+((((0.0)*ids)+((1.60219e-19*Vt)*ids_Vgi_bi)))*ids_Vgi_bi+((1.60219e-19*Vt)*ids)*ids_Vgi_bi_Vgi_bi);
  T0b_Vgi_bi_Vdi_bi=(+(+(+0.0*Vt+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vdi_bi+(0.0)*ids_Vgi_bi+(1.60219e-19*Vt)*ids_Vgi_bi_Vdi_bi)*ids+((1.60219e-19*Vt)*ids_Vgi_bi)*ids_Vdi_bi+((((0.0)*ids)+((1.60219e-19*Vt)*ids_Vdi_bi)))*ids_Vgi_bi+((1.60219e-19*Vt)*ids)*ids_Vgi_bi_Vdi_bi);
  T0b_Vgi_bi_Vsi_bi=(+(+(+0.0*Vt+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vsi_bi+(0.0)*ids_Vgi_bi+(1.60219e-19*Vt)*ids_Vgi_bi_Vsi_bi)*ids+((1.60219e-19*Vt)*ids_Vgi_bi)*ids_Vsi_bi+((((0.0)*ids)+((1.60219e-19*Vt)*ids_Vsi_bi)))*ids_Vgi_bi+((1.60219e-19*Vt)*ids)*ids_Vgi_bi_Vsi_bi);
#endif
T0b_Vdi_bi=((((1.60219e-19*Vt)*ids_Vdi_bi)*ids)+(((1.60219e-19*Vt)*ids)*ids_Vdi_bi));
#if defined(_DERIVATE2)
  T0b_Vdi_bi_Tempt_GND=(+(+(+0.0*Vt+0.0*Vt_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Tempt_GND+((1.60219e-19*Vt_Tempt_GND))*ids_Vdi_bi+(1.60219e-19*Vt)*ids_Vdi_bi_Tempt_GND)*ids+((1.60219e-19*Vt)*ids_Vdi_bi)*ids_Tempt_GND+(((((1.60219e-19*Vt_Tempt_GND))*ids)+((1.60219e-19*Vt)*ids_Tempt_GND)))*ids_Vdi_bi+((1.60219e-19*Vt)*ids)*ids_Vdi_bi_Tempt_GND);
  T0b_Vdi_bi_Vgi_bi=(+(+(+0.0*Vt+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vgi_bi+(0.0)*ids_Vdi_bi+(1.60219e-19*Vt)*ids_Vdi_bi_Vgi_bi)*ids+((1.60219e-19*Vt)*ids_Vdi_bi)*ids_Vgi_bi+((((0.0)*ids)+((1.60219e-19*Vt)*ids_Vgi_bi)))*ids_Vdi_bi+((1.60219e-19*Vt)*ids)*ids_Vdi_bi_Vgi_bi);
  T0b_Vdi_bi_Vdi_bi=(+(+(+0.0*Vt+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vdi_bi+(0.0)*ids_Vdi_bi+(1.60219e-19*Vt)*ids_Vdi_bi_Vdi_bi)*ids+((1.60219e-19*Vt)*ids_Vdi_bi)*ids_Vdi_bi+((((0.0)*ids)+((1.60219e-19*Vt)*ids_Vdi_bi)))*ids_Vdi_bi+((1.60219e-19*Vt)*ids)*ids_Vdi_bi_Vdi_bi);
  T0b_Vdi_bi_Vsi_bi=(+(+(+0.0*Vt+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vsi_bi+(0.0)*ids_Vdi_bi+(1.60219e-19*Vt)*ids_Vdi_bi_Vsi_bi)*ids+((1.60219e-19*Vt)*ids_Vdi_bi)*ids_Vsi_bi+((((0.0)*ids)+((1.60219e-19*Vt)*ids_Vsi_bi)))*ids_Vdi_bi+((1.60219e-19*Vt)*ids)*ids_Vdi_bi_Vsi_bi);
#endif
T0b_Vsi_bi=((((1.60219e-19*Vt)*ids_Vsi_bi)*ids)+(((1.60219e-19*Vt)*ids)*ids_Vsi_bi));
#if defined(_DERIVATE2)
  T0b_Vsi_bi_Tempt_GND=(+(+(+0.0*Vt+0.0*Vt_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Tempt_GND+((1.60219e-19*Vt_Tempt_GND))*ids_Vsi_bi+(1.60219e-19*Vt)*ids_Vsi_bi_Tempt_GND)*ids+((1.60219e-19*Vt)*ids_Vsi_bi)*ids_Tempt_GND+(((((1.60219e-19*Vt_Tempt_GND))*ids)+((1.60219e-19*Vt)*ids_Tempt_GND)))*ids_Vsi_bi+((1.60219e-19*Vt)*ids)*ids_Vsi_bi_Tempt_GND);
  T0b_Vsi_bi_Vgi_bi=(+(+(+0.0*Vt+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vgi_bi+(0.0)*ids_Vsi_bi+(1.60219e-19*Vt)*ids_Vsi_bi_Vgi_bi)*ids+((1.60219e-19*Vt)*ids_Vsi_bi)*ids_Vgi_bi+((((0.0)*ids)+((1.60219e-19*Vt)*ids_Vgi_bi)))*ids_Vsi_bi+((1.60219e-19*Vt)*ids)*ids_Vsi_bi_Vgi_bi);
  T0b_Vsi_bi_Vdi_bi=(+(+(+0.0*Vt+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vdi_bi+(0.0)*ids_Vsi_bi+(1.60219e-19*Vt)*ids_Vsi_bi_Vdi_bi)*ids+((1.60219e-19*Vt)*ids_Vsi_bi)*ids_Vdi_bi+((((0.0)*ids)+((1.60219e-19*Vt)*ids_Vdi_bi)))*ids_Vsi_bi+((1.60219e-19*Vt)*ids)*ids_Vsi_bi_Vdi_bi);
  T0b_Vsi_bi_Vsi_bi=(+(+(+0.0*Vt+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vsi_bi+(0.0)*ids_Vsi_bi+(1.60219e-19*Vt)*ids_Vsi_bi_Vsi_bi)*ids+((1.60219e-19*Vt)*ids_Vsi_bi)*ids_Vsi_bi+((((0.0)*ids)+((1.60219e-19*Vt)*ids_Vsi_bi)))*ids_Vsi_bi+((1.60219e-19*Vt)*ids)*ids_Vsi_bi_Vsi_bi);
#endif
#endif
T0b=(((1.60219e-19*Vt)*ids)*ids);
EXIT_IF_ISNAN((((1.60219e-19*Vt)*ids)*ids))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0c_Vgi_bi=((pModel->NOIB*Nl_Vgi_bi)+(((pModel->NOIC*Nl_Vgi_bi)*Nl)+((pModel->NOIC*Nl)*Nl_Vgi_bi)));
#if defined(_DERIVATE2)
  T0c_Vgi_bi_Vgi_bi=(+(+0.0+(+0.0*Nl+0.0*Nl_Vgi_bi+0.0*Nl_Vgi_bi+pModel->NOIB*Nl_Vgi_bi_Vgi_bi))+(+(+0.0*Nl+0.0*Nl_Vgi_bi+0.0*Nl_Vgi_bi+pModel->NOIC*Nl_Vgi_bi_Vgi_bi)*Nl+(pModel->NOIC*Nl_Vgi_bi)*Nl_Vgi_bi+((pModel->NOIC*Nl_Vgi_bi))*Nl_Vgi_bi+(pModel->NOIC*Nl)*Nl_Vgi_bi_Vgi_bi));
  T0c_Vgi_bi_Tempt_GND=(+(+0.0+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vgi_bi+pModel->NOIB*Nl_Vgi_bi_Tempt_GND))+(+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vgi_bi+pModel->NOIC*Nl_Vgi_bi_Tempt_GND)*Nl+(pModel->NOIC*Nl_Vgi_bi)*Nl_Tempt_GND+((pModel->NOIC*Nl_Tempt_GND))*Nl_Vgi_bi+(pModel->NOIC*Nl)*Nl_Vgi_bi_Tempt_GND));
  T0c_Vgi_bi_Vdi_bi=(+(+0.0+(+0.0*Nl+0.0*Nl_Vdi_bi+0.0*Nl_Vgi_bi+pModel->NOIB*Nl_Vgi_bi_Vdi_bi))+(+(+0.0*Nl+0.0*Nl_Vdi_bi+0.0*Nl_Vgi_bi+pModel->NOIC*Nl_Vgi_bi_Vdi_bi)*Nl+(pModel->NOIC*Nl_Vgi_bi)*Nl_Vdi_bi+((pModel->NOIC*Nl_Vdi_bi))*Nl_Vgi_bi+(pModel->NOIC*Nl)*Nl_Vgi_bi_Vdi_bi));
  T0c_Vgi_bi_Vsi_bi=(+(+0.0+(+0.0*Nl+0.0*Nl_Vsi_bi+0.0*Nl_Vgi_bi+pModel->NOIB*Nl_Vgi_bi_Vsi_bi))+(+(+0.0*Nl+0.0*Nl_Vsi_bi+0.0*Nl_Vgi_bi+pModel->NOIC*Nl_Vgi_bi_Vsi_bi)*Nl+(pModel->NOIC*Nl_Vgi_bi)*Nl_Vsi_bi+((pModel->NOIC*Nl_Vsi_bi))*Nl_Vgi_bi+(pModel->NOIC*Nl)*Nl_Vgi_bi_Vsi_bi));
#endif
#if defined(_DERIVATE)
T0c_Tempt_GND=((pModel->NOIB*Nl_Tempt_GND)+(((pModel->NOIC*Nl_Tempt_GND)*Nl)+((pModel->NOIC*Nl)*Nl_Tempt_GND)));
#endif
T0c_Vdi_bi=((pModel->NOIB*Nl_Vdi_bi)+(((pModel->NOIC*Nl_Vdi_bi)*Nl)+((pModel->NOIC*Nl)*Nl_Vdi_bi)));
#if defined(_DERIVATE2)
  T0c_Vdi_bi_Vgi_bi=(+(+0.0+(+0.0*Nl+0.0*Nl_Vgi_bi+0.0*Nl_Vdi_bi+pModel->NOIB*Nl_Vdi_bi_Vgi_bi))+(+(+0.0*Nl+0.0*Nl_Vgi_bi+0.0*Nl_Vdi_bi+pModel->NOIC*Nl_Vdi_bi_Vgi_bi)*Nl+(pModel->NOIC*Nl_Vdi_bi)*Nl_Vgi_bi+((pModel->NOIC*Nl_Vgi_bi))*Nl_Vdi_bi+(pModel->NOIC*Nl)*Nl_Vdi_bi_Vgi_bi));
  T0c_Vdi_bi_Tempt_GND=(+(+0.0+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vdi_bi+pModel->NOIB*Nl_Vdi_bi_Tempt_GND))+(+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vdi_bi+pModel->NOIC*Nl_Vdi_bi_Tempt_GND)*Nl+(pModel->NOIC*Nl_Vdi_bi)*Nl_Tempt_GND+((pModel->NOIC*Nl_Tempt_GND))*Nl_Vdi_bi+(pModel->NOIC*Nl)*Nl_Vdi_bi_Tempt_GND));
  T0c_Vdi_bi_Vdi_bi=(+(+0.0+(+0.0*Nl+0.0*Nl_Vdi_bi+0.0*Nl_Vdi_bi+pModel->NOIB*Nl_Vdi_bi_Vdi_bi))+(+(+0.0*Nl+0.0*Nl_Vdi_bi+0.0*Nl_Vdi_bi+pModel->NOIC*Nl_Vdi_bi_Vdi_bi)*Nl+(pModel->NOIC*Nl_Vdi_bi)*Nl_Vdi_bi+((pModel->NOIC*Nl_Vdi_bi))*Nl_Vdi_bi+(pModel->NOIC*Nl)*Nl_Vdi_bi_Vdi_bi));
  T0c_Vdi_bi_Vsi_bi=(+(+0.0+(+0.0*Nl+0.0*Nl_Vsi_bi+0.0*Nl_Vdi_bi+pModel->NOIB*Nl_Vdi_bi_Vsi_bi))+(+(+0.0*Nl+0.0*Nl_Vsi_bi+0.0*Nl_Vdi_bi+pModel->NOIC*Nl_Vdi_bi_Vsi_bi)*Nl+(pModel->NOIC*Nl_Vdi_bi)*Nl_Vsi_bi+((pModel->NOIC*Nl_Vsi_bi))*Nl_Vdi_bi+(pModel->NOIC*Nl)*Nl_Vdi_bi_Vsi_bi));
#endif
T0c_Vsi_bi=((pModel->NOIB*Nl_Vsi_bi)+(((pModel->NOIC*Nl_Vsi_bi)*Nl)+((pModel->NOIC*Nl)*Nl_Vsi_bi)));
#if defined(_DERIVATE2)
  T0c_Vsi_bi_Vgi_bi=(+(+0.0+(+0.0*Nl+0.0*Nl_Vgi_bi+0.0*Nl_Vsi_bi+pModel->NOIB*Nl_Vsi_bi_Vgi_bi))+(+(+0.0*Nl+0.0*Nl_Vgi_bi+0.0*Nl_Vsi_bi+pModel->NOIC*Nl_Vsi_bi_Vgi_bi)*Nl+(pModel->NOIC*Nl_Vsi_bi)*Nl_Vgi_bi+((pModel->NOIC*Nl_Vgi_bi))*Nl_Vsi_bi+(pModel->NOIC*Nl)*Nl_Vsi_bi_Vgi_bi));
  T0c_Vsi_bi_Tempt_GND=(+(+0.0+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vsi_bi+pModel->NOIB*Nl_Vsi_bi_Tempt_GND))+(+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vsi_bi+pModel->NOIC*Nl_Vsi_bi_Tempt_GND)*Nl+(pModel->NOIC*Nl_Vsi_bi)*Nl_Tempt_GND+((pModel->NOIC*Nl_Tempt_GND))*Nl_Vsi_bi+(pModel->NOIC*Nl)*Nl_Vsi_bi_Tempt_GND));
  T0c_Vsi_bi_Vdi_bi=(+(+0.0+(+0.0*Nl+0.0*Nl_Vdi_bi+0.0*Nl_Vsi_bi+pModel->NOIB*Nl_Vsi_bi_Vdi_bi))+(+(+0.0*Nl+0.0*Nl_Vdi_bi+0.0*Nl_Vsi_bi+pModel->NOIC*Nl_Vsi_bi_Vdi_bi)*Nl+(pModel->NOIC*Nl_Vsi_bi)*Nl_Vdi_bi+((pModel->NOIC*Nl_Vdi_bi))*Nl_Vsi_bi+(pModel->NOIC*Nl)*Nl_Vsi_bi_Vdi_bi));
  T0c_Vsi_bi_Vsi_bi=(+(+0.0+(+0.0*Nl+0.0*Nl_Vsi_bi+0.0*Nl_Vsi_bi+pModel->NOIB*Nl_Vsi_bi_Vsi_bi))+(+(+0.0*Nl+0.0*Nl_Vsi_bi+0.0*Nl_Vsi_bi+pModel->NOIC*Nl_Vsi_bi_Vsi_bi)*Nl+(pModel->NOIC*Nl_Vsi_bi)*Nl_Vsi_bi+((pModel->NOIC*Nl_Vsi_bi))*Nl_Vsi_bi+(pModel->NOIC*Nl)*Nl_Vsi_bi_Vsi_bi));
#endif
#endif
T0c=((pModel->NOIA+(pModel->NOIB*Nl))+((pModel->NOIC*Nl)*Nl));
EXIT_IF_ISNAN(((pModel->NOIA+(pModel->NOIB*Nl))+((pModel->NOIC*Nl)*Nl)))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0d_Vgi_bi=((Nl_Vgi_bi*(Nl+Nstar))+((Nl+Nstar)*Nl_Vgi_bi));
#if defined(_DERIVATE2)
  T0d_Vgi_bi_Vgi_bi=(+(+Nl_Vgi_bi_Vgi_bi+0.0)*(Nl+Nstar)+Nl_Vgi_bi*Nl_Vgi_bi+Nl_Vgi_bi*Nl_Vgi_bi+(Nl+Nstar)*(+Nl_Vgi_bi_Vgi_bi+0.0));
  T0d_Vgi_bi_Tempt_GND=(+(+Nl_Vgi_bi_Tempt_GND+0.0)*(Nl+Nstar)+Nl_Vgi_bi*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl_Tempt_GND+Nstar_Tempt_GND)*Nl_Vgi_bi+(Nl+Nstar)*(+Nl_Vgi_bi_Tempt_GND+0.0));
  T0d_Vgi_bi_Vdi_bi=(+(+Nl_Vgi_bi_Vdi_bi+0.0)*(Nl+Nstar)+Nl_Vgi_bi*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Nl_Vdi_bi+Nstar_Vdi_bi)*Nl_Vgi_bi+(Nl+Nstar)*(+Nl_Vgi_bi_Vdi_bi+0.0));
  T0d_Vgi_bi_Vsi_bi=(+(+Nl_Vgi_bi_Vsi_bi+0.0)*(Nl+Nstar)+Nl_Vgi_bi*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Nl_Vsi_bi+Nstar_Vsi_bi)*Nl_Vgi_bi+(Nl+Nstar)*(+Nl_Vgi_bi_Vsi_bi+0.0));
#endif
#if defined(_DERIVATE)
T0d_Tempt_GND=(((Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar))+((Nl+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)));
#endif
T0d_Vdi_bi=(((Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar))+((Nl+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)));
#if defined(_DERIVATE2)
  T0d_Vdi_bi_Vgi_bi=(+(+Nl_Vdi_bi_Vgi_bi+0.0)*(Nl+Nstar)+(Nl_Vdi_bi+Nstar_Vdi_bi)*Nl_Vgi_bi+Nl_Vgi_bi*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Nl+Nstar)*(+Nl_Vdi_bi_Vgi_bi+0.0));
  T0d_Vdi_bi_Tempt_GND=(+(+Nl_Vdi_bi_Tempt_GND+Nstar_Vdi_bi_Tempt_GND)*(Nl+Nstar)+(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Nl+Nstar)*(+Nl_Vdi_bi_Tempt_GND+Nstar_Vdi_bi_Tempt_GND));
  T0d_Vdi_bi_Vdi_bi=(+(+Nl_Vdi_bi_Vdi_bi+Nstar_Vdi_bi_Vdi_bi)*(Nl+Nstar)+(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Nl+Nstar)*(+Nl_Vdi_bi_Vdi_bi+Nstar_Vdi_bi_Vdi_bi));
  T0d_Vdi_bi_Vsi_bi=(+(+Nl_Vdi_bi_Vsi_bi+Nstar_Vdi_bi_Vsi_bi)*(Nl+Nstar)+(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Nl+Nstar)*(+Nl_Vdi_bi_Vsi_bi+Nstar_Vdi_bi_Vsi_bi));
#endif
T0d_Vsi_bi=(((Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar))+((Nl+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)));
#if defined(_DERIVATE2)
  T0d_Vsi_bi_Vgi_bi=(+(+Nl_Vsi_bi_Vgi_bi+0.0)*(Nl+Nstar)+(Nl_Vsi_bi+Nstar_Vsi_bi)*Nl_Vgi_bi+Nl_Vgi_bi*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Nl+Nstar)*(+Nl_Vsi_bi_Vgi_bi+0.0));
  T0d_Vsi_bi_Tempt_GND=(+(+Nl_Vsi_bi_Tempt_GND+Nstar_Vsi_bi_Tempt_GND)*(Nl+Nstar)+(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Nl+Nstar)*(+Nl_Vsi_bi_Tempt_GND+Nstar_Vsi_bi_Tempt_GND));
  T0d_Vsi_bi_Vdi_bi=(+(+Nl_Vsi_bi_Vdi_bi+Nstar_Vsi_bi_Vdi_bi)*(Nl+Nstar)+(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Nl+Nstar)*(+Nl_Vsi_bi_Vdi_bi+Nstar_Vsi_bi_Vdi_bi));
  T0d_Vsi_bi_Vsi_bi=(+(+Nl_Vsi_bi_Vsi_bi+Nstar_Vsi_bi_Vsi_bi)*(Nl+Nstar)+(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Nl+Nstar)*(+Nl_Vsi_bi_Vsi_bi+Nstar_Vsi_bi_Vsi_bi));
#endif
#endif
T0d=((Nl+Nstar)*(Nl+Nstar));
EXIT_IF_ISNAN(((Nl+Nstar)*(Nl+Nstar)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0e_Tempt_GND=((pModel->NOIA*1.60219e-19)*Vt_Tempt_GND);
#endif
T0e=((pModel->NOIA*1.60219e-19)*Vt);
EXIT_IF_ISNAN(((pModel->NOIA*1.60219e-19)*Vt))
if
((pModel->FNOIMOD==1))
{
if
((pModel->LINTNOI>=((Leff-pModel->LH)/2.0)))
{
printf("Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0.",pModel->LINTNOI);
printf("\n");
LINTNOI_i=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
LINTNOI_i=pModel->LINTNOI;
EXIT_IF_ISNAN(pModel->LINTNOI)
}
LeffnoiH=Leff;
EXIT_IF_ISNAN(Leff)
if
((Leff<pModel->LH))
{
LeffnoiH=pModel->LH;
EXIT_IF_ISNAN(pModel->LH)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND) */
vgfbh_Vgi_bi=(Vg_Vgi_bi/Vt);
#if defined(_DERIVATE2)
  vgfbh_Vgi_bi_Vgi_bi=((+Vg_Vgi_bi_Vgi_bi-0.0)/Vt-(Vg_Vgi_bi*0.0+Vg_Vgi_bi*0.0+(Vg-VFB_i)*0.0)/Vt/Vt+2*(Vg-VFB_i)*0.0*0.0/Vt/Vt/Vt);
  vgfbh_Vgi_bi_Tempt_GND=((+0.0-0.0)/Vt-(Vg_Vgi_bi*Vt_Tempt_GND+0.0*0.0+(Vg-VFB_i)*0.0)/Vt/Vt+2*(Vg-VFB_i)*0.0*Vt_Tempt_GND/Vt/Vt/Vt);
#endif
#if defined(_DERIVATE)
vgfbh_Tempt_GND=(-(Vg-VFB_i)*Vt_Tempt_GND/Vt/Vt);
#endif
#endif
vgfbh=((Vg-VFB_i)/Vt);
EXIT_IF_ISNAN(((Vg-VFB_i)/Vt))
{
double m00_sqrt(d00_sqrt0,((((2.0*1.60219e-19)*epssi)*pModel->HNDEP)/Vt))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((((2.0*1.60219e-19)*epssi)*pModel->HNDEP)/Vt))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
gam_h_Tempt_GND=((-(((2.0*1.60219e-19)*epssi)*pModel->HNDEP)*Vt_Tempt_GND/Vt/Vt)*d10_sqrt0/Cox);
#endif
gam_h=(d00_sqrt0/Cox);
EXIT_IF_ISNAN((d00_sqrt0/Cox))
}
{
double m00_logE(d00_logE0,(pModel->HNDEP/ni))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(pModel->HNDEP/ni))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
phib_h_Tempt_GND=(-pModel->HNDEP*ni_Tempt_GND/ni/ni)*d10_logE0;
#endif
phib_h=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vgfbPD_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vgfbPD_Vgm_si_Vgm_si=0.0;
  vgfbPD_Vgm_si_Vgm_di=0.0;
  vgfbPD_Vgm_si_Vdbulk_di=0.0;
  vgfbPD_Vgm_si_Vsbulk_si=0.0;
  vgfbPD_Vgm_si_Vgi_bi=0.0;
  vgfbPD_Vgm_si_Vdi_bi=0.0;
  vgfbPD_Vgm_si_Vsi_bi=0.0;
  vgfbPD_Vgm_si_Tempt_GND=0.0;
#endif
vgfbPD_Vgm_di=0.0;
#if defined(_DERIVATE2)
  vgfbPD_Vgm_di_Vgm_si=0.0;
  vgfbPD_Vgm_di_Vgm_di=0.0;
  vgfbPD_Vgm_di_Vdbulk_di=0.0;
  vgfbPD_Vgm_di_Vsbulk_si=0.0;
  vgfbPD_Vgm_di_Vgi_bi=0.0;
  vgfbPD_Vgm_di_Vdi_bi=0.0;
  vgfbPD_Vgm_di_Vsi_bi=0.0;
  vgfbPD_Vgm_di_Tempt_GND=0.0;
#endif
vgfbPD_Vdbulk_di=(-vgfbh*T1_Vdbulk_di/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vdbulk_di_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+vgfbh*T1_Vdbulk_di_Vgm_si)/T1/T1+2*vgfbh*T1_Vdbulk_di*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vgm_di=(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vdbulk_di+vgfbh*T1_Vdbulk_di_Vgm_di)/T1/T1+2*vgfbh*T1_Vdbulk_di*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+vgfbh*T1_Vdbulk_di_Vdbulk_di)/T1/T1+2*vgfbh*T1_Vdbulk_di*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+vgfbh*T1_Vdbulk_di_Vsbulk_si)/T1/T1+2*vgfbh*T1_Vdbulk_di*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+vgfbh_Vgi_bi*T1_Vdbulk_di+vgfbh*T1_Vdbulk_di_Vgi_bi)/T1/T1+2*vgfbh*T1_Vdbulk_di*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vdbulk_di+vgfbh*T1_Vdbulk_di_Vdi_bi)/T1/T1+2*vgfbh*T1_Vdbulk_di*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vdbulk_di+vgfbh*T1_Vdbulk_di_Vsi_bi)/T1/T1+2*vgfbh*T1_Vdbulk_di*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vdbulk_di_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+vgfbh_Tempt_GND*T1_Vdbulk_di+vgfbh*T1_Vdbulk_di_Tempt_GND)/T1/T1+2*vgfbh*T1_Vdbulk_di*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vsbulk_si=(-vgfbh*T1_Vsbulk_si/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vsbulk_si_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+vgfbh*T1_Vsbulk_si_Vgm_si)/T1/T1+2*vgfbh*T1_Vsbulk_si*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vgm_di=(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vsbulk_si+vgfbh*T1_Vsbulk_si_Vgm_di)/T1/T1+2*vgfbh*T1_Vsbulk_si*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+vgfbh*T1_Vsbulk_si_Vdbulk_di)/T1/T1+2*vgfbh*T1_Vsbulk_si*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+vgfbh*T1_Vsbulk_si_Vsbulk_si)/T1/T1+2*vgfbh*T1_Vsbulk_si*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+vgfbh_Vgi_bi*T1_Vsbulk_si+vgfbh*T1_Vsbulk_si_Vgi_bi)/T1/T1+2*vgfbh*T1_Vsbulk_si*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vsbulk_si+vgfbh*T1_Vsbulk_si_Vdi_bi)/T1/T1+2*vgfbh*T1_Vsbulk_si*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vsbulk_si+vgfbh*T1_Vsbulk_si_Vsi_bi)/T1/T1+2*vgfbh*T1_Vsbulk_si*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vsbulk_si_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+vgfbh_Tempt_GND*T1_Vsbulk_si+vgfbh*T1_Vsbulk_si_Tempt_GND)/T1/T1+2*vgfbh*T1_Vsbulk_si*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vgi_bi=((vgfbh_Vgi_bi*T1-vgfbh*T1_Vgi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vgi_bi_Vgm_si=(0.0/T1-(vgfbh_Vgi_bi*T1_Vgm_si+0.0*T1_Vgi_bi+vgfbh*T1_Vgi_bi_Vgm_si)/T1/T1+2*vgfbh*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vgi_bi_Vgm_di=(0.0/T1-(vgfbh_Vgi_bi*T1_Vgm_di+0.0*T1_Vgi_bi+vgfbh*T1_Vgi_bi_Vgm_di)/T1/T1+2*vgfbh*T1_Vgi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vgi_bi_Vdbulk_di=(0.0/T1-(vgfbh_Vgi_bi*T1_Vdbulk_di+0.0*T1_Vgi_bi+vgfbh*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*vgfbh*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vgi_bi_Vsbulk_si=(0.0/T1-(vgfbh_Vgi_bi*T1_Vsbulk_si+0.0*T1_Vgi_bi+vgfbh*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*vgfbh*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vgi_bi_Vgi_bi=(vgfbh_Vgi_bi_Vgi_bi/T1-(vgfbh_Vgi_bi*T1_Vgi_bi+vgfbh_Vgi_bi*T1_Vgi_bi+vgfbh*T1_Vgi_bi_Vgi_bi)/T1/T1+2*vgfbh*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Vdi_bi=(0.0/T1-(vgfbh_Vgi_bi*T1_Vdi_bi+0.0*T1_Vgi_bi+vgfbh*T1_Vgi_bi_Vdi_bi)/T1/T1+2*vgfbh*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Vsi_bi=(0.0/T1-(vgfbh_Vgi_bi*T1_Vsi_bi+0.0*T1_Vgi_bi+vgfbh*T1_Vgi_bi_Vsi_bi)/T1/T1+2*vgfbh*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Tempt_GND=(vgfbh_Vgi_bi_Tempt_GND/T1-(vgfbh_Vgi_bi*T1_Tempt_GND+vgfbh_Tempt_GND*T1_Vgi_bi+vgfbh*T1_Vgi_bi_Tempt_GND)/T1/T1+2*vgfbh*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vdi_bi=(-vgfbh*T1_Vdi_bi/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vdi_bi_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vdi_bi+vgfbh*T1_Vdi_bi_Vgm_si)/T1/T1+2*vgfbh*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vdi_bi_Vgm_di=(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vdi_bi+vgfbh*T1_Vdi_bi_Vgm_di)/T1/T1+2*vgfbh*T1_Vdi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vdi_bi_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+vgfbh*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*vgfbh*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vdi_bi_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+vgfbh*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*vgfbh*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vdi_bi_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+vgfbh_Vgi_bi*T1_Vdi_bi+vgfbh*T1_Vdi_bi_Vgi_bi)/T1/T1+2*vgfbh*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+vgfbh*T1_Vdi_bi_Vdi_bi)/T1/T1+2*vgfbh*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+vgfbh*T1_Vdi_bi_Vsi_bi)/T1/T1+2*vgfbh*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+vgfbh_Tempt_GND*T1_Vdi_bi+vgfbh*T1_Vdi_bi_Tempt_GND)/T1/T1+2*vgfbh*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vsi_bi=(-vgfbh*T1_Vsi_bi/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vsi_bi_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vsi_bi+vgfbh*T1_Vsi_bi_Vgm_si)/T1/T1+2*vgfbh*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vsi_bi_Vgm_di=(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vsi_bi+vgfbh*T1_Vsi_bi_Vgm_di)/T1/T1+2*vgfbh*T1_Vsi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vsi_bi_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+vgfbh*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*vgfbh*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vsi_bi_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+vgfbh*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*vgfbh*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vsi_bi_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+vgfbh_Vgi_bi*T1_Vsi_bi+vgfbh*T1_Vsi_bi_Vgi_bi)/T1/T1+2*vgfbh*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+vgfbh*T1_Vsi_bi_Vdi_bi)/T1/T1+2*vgfbh*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+vgfbh*T1_Vsi_bi_Vsi_bi)/T1/T1+2*vgfbh*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+vgfbh_Tempt_GND*T1_Vsi_bi+vgfbh*T1_Vsi_bi_Tempt_GND)/T1/T1+2*vgfbh*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
#if defined(_DERIVATE)
vgfbPD_Tempt_GND=((vgfbh_Tempt_GND*T1-vgfbh*T1_Tempt_GND)/T1/T1);
#endif
#endif
vgfbPD=(vgfbh/T1);
EXIT_IF_ISNAN((vgfbh/T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gammaPD_Vgm_si=0.0;
#if defined(_DERIVATE2)
  gammaPD_Vgm_si_Vgm_si=0.0;
  gammaPD_Vgm_si_Vdbulk_di=0.0;
  gammaPD_Vgm_si_Vsbulk_si=0.0;
  gammaPD_Vgm_si_Vgi_bi=0.0;
  gammaPD_Vgm_si_Vdi_bi=0.0;
  gammaPD_Vgm_si_Vsi_bi=0.0;
  gammaPD_Vgm_si_Tempt_GND=0.0;
#endif
gammaPD_Vdbulk_di=(-gam_h*T1_Vdbulk_di/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vdbulk_di_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+gam_h*T1_Vdbulk_di_Vgm_si)/T1/T1+2*gam_h*T1_Vdbulk_di*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vdbulk_di_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+gam_h*T1_Vdbulk_di_Vdbulk_di)/T1/T1+2*gam_h*T1_Vdbulk_di*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vdbulk_di_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+gam_h*T1_Vdbulk_di_Vsbulk_si)/T1/T1+2*gam_h*T1_Vdbulk_di*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vdbulk_di_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vdbulk_di+gam_h*T1_Vdbulk_di_Vgi_bi)/T1/T1+2*gam_h*T1_Vdbulk_di*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vdbulk_di_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vdbulk_di+gam_h*T1_Vdbulk_di_Vdi_bi)/T1/T1+2*gam_h*T1_Vdbulk_di*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vdbulk_di_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vdbulk_di+gam_h*T1_Vdbulk_di_Vsi_bi)/T1/T1+2*gam_h*T1_Vdbulk_di*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vdbulk_di_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+gam_h_Tempt_GND*T1_Vdbulk_di+gam_h*T1_Vdbulk_di_Tempt_GND)/T1/T1+2*gam_h*T1_Vdbulk_di*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vsbulk_si=(-gam_h*T1_Vsbulk_si/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vsbulk_si_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+gam_h*T1_Vsbulk_si_Vgm_si)/T1/T1+2*gam_h*T1_Vsbulk_si*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vsbulk_si_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+gam_h*T1_Vsbulk_si_Vdbulk_di)/T1/T1+2*gam_h*T1_Vsbulk_si*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vsbulk_si_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+gam_h*T1_Vsbulk_si_Vsbulk_si)/T1/T1+2*gam_h*T1_Vsbulk_si*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vsbulk_si_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vsbulk_si+gam_h*T1_Vsbulk_si_Vgi_bi)/T1/T1+2*gam_h*T1_Vsbulk_si*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vsbulk_si_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vsbulk_si+gam_h*T1_Vsbulk_si_Vdi_bi)/T1/T1+2*gam_h*T1_Vsbulk_si*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vsbulk_si_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vsbulk_si+gam_h*T1_Vsbulk_si_Vsi_bi)/T1/T1+2*gam_h*T1_Vsbulk_si*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vsbulk_si_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+gam_h_Tempt_GND*T1_Vsbulk_si+gam_h*T1_Vsbulk_si_Tempt_GND)/T1/T1+2*gam_h*T1_Vsbulk_si*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vgi_bi=(-gam_h*T1_Vgi_bi/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vgi_bi_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vgi_bi+gam_h*T1_Vgi_bi_Vgm_si)/T1/T1+2*gam_h*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vgi_bi_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+gam_h*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*gam_h*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vgi_bi_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+gam_h*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*gam_h*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vgi_bi_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+gam_h*T1_Vgi_bi_Vgi_bi)/T1/T1+2*gam_h*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vgi_bi_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+gam_h*T1_Vgi_bi_Vdi_bi)/T1/T1+2*gam_h*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vgi_bi_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+gam_h*T1_Vgi_bi_Vsi_bi)/T1/T1+2*gam_h*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vgi_bi_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+gam_h_Tempt_GND*T1_Vgi_bi+gam_h*T1_Vgi_bi_Tempt_GND)/T1/T1+2*gam_h*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vdi_bi=(-gam_h*T1_Vdi_bi/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vdi_bi_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vdi_bi+gam_h*T1_Vdi_bi_Vgm_si)/T1/T1+2*gam_h*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vdi_bi_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+gam_h*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*gam_h*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vdi_bi_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+gam_h*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*gam_h*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vdi_bi_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+gam_h*T1_Vdi_bi_Vgi_bi)/T1/T1+2*gam_h*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+gam_h*T1_Vdi_bi_Vdi_bi)/T1/T1+2*gam_h*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+gam_h*T1_Vdi_bi_Vsi_bi)/T1/T1+2*gam_h*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+gam_h_Tempt_GND*T1_Vdi_bi+gam_h*T1_Vdi_bi_Tempt_GND)/T1/T1+2*gam_h*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vsi_bi=(-gam_h*T1_Vsi_bi/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vsi_bi_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vsi_bi+gam_h*T1_Vsi_bi_Vgm_si)/T1/T1+2*gam_h*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vsi_bi_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+gam_h*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*gam_h*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vsi_bi_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+gam_h*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*gam_h*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vsi_bi_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+gam_h*T1_Vsi_bi_Vgi_bi)/T1/T1+2*gam_h*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+gam_h*T1_Vsi_bi_Vdi_bi)/T1/T1+2*gam_h*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+gam_h*T1_Vsi_bi_Vsi_bi)/T1/T1+2*gam_h*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+gam_h_Tempt_GND*T1_Vsi_bi+gam_h*T1_Vsi_bi_Tempt_GND)/T1/T1+2*gam_h*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
#if defined(_DERIVATE)
gammaPD_Tempt_GND=((gam_h_Tempt_GND*T1-gam_h*T1_Tempt_GND)/T1/T1);
#endif
#endif
gammaPD=(gam_h/T1);
EXIT_IF_ISNAN((gam_h/T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=((0.5*vgfbPD_Vdbulk_di)-(3.0*(gammaPD_Vdbulk_di/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vgm_si/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vdbulk_di/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vsbulk_si/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vgi_bi/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vdi_bi/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vsi_bi/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Tempt_GND/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vsbulk_si=((0.5*vgfbPD_Vsbulk_si)-(3.0*(gammaPD_Vsbulk_si/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vgm_si/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vdbulk_di/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vsbulk_si/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vgi_bi/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vdi_bi/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vsi_bi/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Tempt_GND/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vgi_bi=((0.5*vgfbPD_Vgi_bi)-(3.0*(gammaPD_Vgi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vdi_bi=((0.5*vgfbPD_Vdi_bi)-(3.0*(gammaPD_Vdi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vsi_bi=((0.5*vgfbPD_Vsi_bi)-(3.0*(gammaPD_Vsi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((0.5*vgfbPD_Tempt_GND)-(3.0*(gammaPD_Tempt_GND/1.41421356237309504880)));
#endif
#endif
T1=((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
EXIT_IF_ISNAN(((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880)))))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+(6.0*vgfbPD)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+(6.0*vgfbPD)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(T1_Vdbulk_di+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+T1_Vdbulk_di_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vgm_di*T1+T1_Vdbulk_di*T1_Vgm_di+T1_Vgm_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vgm_di))));
  T2_Vdbulk_di_Vgm_si=(+T1_Vdbulk_di_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vgm_si*T1+T1_Vdbulk_di*T1_Vgm_si+T1_Vgm_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vgm_si))));
  T2_Vdbulk_di_Vdbulk_di=(+T1_Vdbulk_di_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vdbulk_di*T1+T1_Vdbulk_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vdbulk_di))));
  T2_Vdbulk_di_Vsbulk_si=(+T1_Vdbulk_di_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vsbulk_si*T1+T1_Vdbulk_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vsbulk_si))));
  T2_Vdbulk_di_Vgi_bi=(+T1_Vdbulk_di_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vgi_bi*T1+T1_Vdbulk_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vgi_bi))));
  T2_Vdbulk_di_Vdi_bi=(+T1_Vdbulk_di_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vdi_bi*T1+T1_Vdbulk_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vdi_bi))));
  T2_Vdbulk_di_Vsi_bi=(+T1_Vdbulk_di_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vsi_bi*T1+T1_Vdbulk_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vsi_bi))));
  T2_Vdbulk_di_Tempt_GND=(+T1_Vdbulk_di_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Tempt_GND*T1+T1_Vdbulk_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vdbulk_di+T1*T1_Vdbulk_di_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Tempt_GND))));
#endif
T2_Vsbulk_si=(T1_Vsbulk_si+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+T1_Vsbulk_si_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vgm_di*T1+T1_Vsbulk_si*T1_Vgm_di+T1_Vgm_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vgm_di))));
  T2_Vsbulk_si_Vgm_si=(+T1_Vsbulk_si_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vgm_si*T1+T1_Vsbulk_si*T1_Vgm_si+T1_Vgm_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vgm_si))));
  T2_Vsbulk_si_Vdbulk_di=(+T1_Vsbulk_si_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vdbulk_di*T1+T1_Vsbulk_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vdbulk_di))));
  T2_Vsbulk_si_Vsbulk_si=(+T1_Vsbulk_si_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vsbulk_si*T1+T1_Vsbulk_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vsbulk_si))));
  T2_Vsbulk_si_Vgi_bi=(+T1_Vsbulk_si_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vgi_bi*T1+T1_Vsbulk_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vgi_bi))));
  T2_Vsbulk_si_Vdi_bi=(+T1_Vsbulk_si_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vdi_bi*T1+T1_Vsbulk_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vdi_bi))));
  T2_Vsbulk_si_Vsi_bi=(+T1_Vsbulk_si_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vsi_bi*T1+T1_Vsbulk_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vsi_bi))));
  T2_Vsbulk_si_Tempt_GND=(+T1_Vsbulk_si_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Tempt_GND*T1+T1_Vsbulk_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vsbulk_si+T1*T1_Vsbulk_si_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Tempt_GND))));
#endif
T2_Vgi_bi=(T1_Vgi_bi+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgm_di))));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgm_si))));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vdbulk_di))));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vsbulk_si))));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgi_bi))));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vdi_bi))));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vsi_bi))));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Tempt_GND))));
#endif
T2_Vdi_bi=(T1_Vdi_bi+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgm_di))));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgm_si))));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vdbulk_di))));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vsbulk_si))));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgi_bi))));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vdi_bi))));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vsi_bi))));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Tempt_GND))));
#endif
T2_Vsi_bi=(T1_Vsi_bi+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgm_di))));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgm_si))));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vdbulk_di))));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vsbulk_si))));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgi_bi))));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vdi_bi))));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vsi_bi))));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+(6.0*vgfbPD_Tempt_GND))*d10_sqrt0);
#endif
#endif
T2=(T1+d00_sqrt0);
EXIT_IF_ISNAN((T1+d00_sqrt0))
}
if
((vgfbPD<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=(((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD-(vgfbPD-T2)*gammaPD_Vdbulk_di)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=((+vgfbPD_Vdbulk_di_Vgm_si-T2_Vdbulk_di_Vgm_si)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vgm_di=((+vgfbPD_Vdbulk_di_Vgm_di-T2_Vdbulk_di_Vgm_di)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vdbulk_di+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vdbulk_di=((+vgfbPD_Vdbulk_di_Vdbulk_di-T2_Vdbulk_di_Vdbulk_di)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vsbulk_si=((+vgfbPD_Vdbulk_di_Vsbulk_si-T2_Vdbulk_di_Vsbulk_si)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vgi_bi=((+vgfbPD_Vdbulk_di_Vgi_bi-T2_Vdbulk_di_Vgi_bi)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vdi_bi=((+vgfbPD_Vdbulk_di_Vdi_bi-T2_Vdbulk_di_Vdi_bi)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vsi_bi=((+vgfbPD_Vdbulk_di_Vsi_bi-T2_Vdbulk_di_Vsi_bi)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Tempt_GND=((+vgfbPD_Vdbulk_di_Tempt_GND-T2_Vdbulk_di_Tempt_GND)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vsbulk_si=(((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD-(vgfbPD-T2)*gammaPD_Vsbulk_si)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=((+vgfbPD_Vsbulk_si_Vgm_si-T2_Vsbulk_si_Vgm_si)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vgm_di=((+vgfbPD_Vsbulk_si_Vgm_di-T2_Vsbulk_si_Vgm_di)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vsbulk_si+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vdbulk_di=((+vgfbPD_Vsbulk_si_Vdbulk_di-T2_Vsbulk_si_Vdbulk_di)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vsbulk_si=((+vgfbPD_Vsbulk_si_Vsbulk_si-T2_Vsbulk_si_Vsbulk_si)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vgi_bi=((+vgfbPD_Vsbulk_si_Vgi_bi-T2_Vsbulk_si_Vgi_bi)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vdi_bi=((+vgfbPD_Vsbulk_si_Vdi_bi-T2_Vsbulk_si_Vdi_bi)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vsi_bi=((+vgfbPD_Vsbulk_si_Vsi_bi-T2_Vsbulk_si_Vsi_bi)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Tempt_GND=((+vgfbPD_Vsbulk_si_Tempt_GND-T2_Vsbulk_si_Tempt_GND)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vgi_bi=(((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vgi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=((+vgfbPD_Vgi_bi_Vgm_si-T2_Vgi_bi_Vgm_si)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vgm_di=((+vgfbPD_Vgi_bi_Vgm_di-T2_Vgi_bi_Vgm_di)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vgi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vdbulk_di=((+vgfbPD_Vgi_bi_Vdbulk_di-T2_Vgi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vsbulk_si=((+vgfbPD_Vgi_bi_Vsbulk_si-T2_Vgi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vgi_bi=((+vgfbPD_Vgi_bi_Vgi_bi-T2_Vgi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vdi_bi=((+vgfbPD_Vgi_bi_Vdi_bi-T2_Vgi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vsi_bi=((+vgfbPD_Vgi_bi_Vsi_bi-T2_Vgi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Tempt_GND=((+vgfbPD_Vgi_bi_Tempt_GND-T2_Vgi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vdi_bi=(((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vdi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=((+vgfbPD_Vdi_bi_Vgm_si-T2_Vdi_bi_Vgm_si)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vgm_di=((+vgfbPD_Vdi_bi_Vgm_di-T2_Vdi_bi_Vgm_di)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vdi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vdbulk_di=((+vgfbPD_Vdi_bi_Vdbulk_di-T2_Vdi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vsbulk_si=((+vgfbPD_Vdi_bi_Vsbulk_si-T2_Vdi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vgi_bi=((+vgfbPD_Vdi_bi_Vgi_bi-T2_Vdi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vdi_bi=((+vgfbPD_Vdi_bi_Vdi_bi-T2_Vdi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vsi_bi=((+vgfbPD_Vdi_bi_Vsi_bi-T2_Vdi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Tempt_GND=((+vgfbPD_Vdi_bi_Tempt_GND-T2_Vdi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vsi_bi=(((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vsi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=((+vgfbPD_Vsi_bi_Vgm_si-T2_Vsi_bi_Vgm_si)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vgm_di=((+vgfbPD_Vsi_bi_Vgm_di-T2_Vsi_bi_Vgm_di)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vsi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vdbulk_di=((+vgfbPD_Vsi_bi_Vdbulk_di-T2_Vsi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vsbulk_si=((+vgfbPD_Vsi_bi_Vsbulk_si-T2_Vsi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vgi_bi=((+vgfbPD_Vsi_bi_Vgi_bi-T2_Vsi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vdi_bi=((+vgfbPD_Vsi_bi_Vdi_bi-T2_Vsi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vsi_bi=((+vgfbPD_Vsi_bi_Vsi_bi-T2_Vsi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Tempt_GND=((+vgfbPD_Vsi_bi_Tempt_GND-T2_Vsi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(((vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD-(vgfbPD-T2)*gammaPD_Tempt_GND)/gammaPD/gammaPD);
#endif
#endif
T3=((vgfbPD-T2)/gammaPD);
EXIT_IF_ISNAN(((vgfbPD-T2)/gammaPD))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
psiph_Vdbulk_di=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vdbulk_di)+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))));
#if defined(_DERIVATE2)
  psiph_Vdbulk_di_Vdbulk_di=0.0;
  psiph_Vdbulk_di_Vsbulk_si=0.0;
  psiph_Vdbulk_di_Vgi_bi=0.0;
  psiph_Vdbulk_di_Vdi_bi=0.0;
  psiph_Vdbulk_di_Vsi_bi=0.0;
  psiph_Vdbulk_di_Tempt_GND=0.0;
#endif
psiph_Vsbulk_si=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vsbulk_si)+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))));
#if defined(_DERIVATE2)
  psiph_Vsbulk_si_Vdbulk_di=0.0;
  psiph_Vsbulk_si_Vsbulk_si=0.0;
  psiph_Vsbulk_si_Vgi_bi=0.0;
  psiph_Vsbulk_si_Vdi_bi=0.0;
  psiph_Vsbulk_si_Vsi_bi=0.0;
  psiph_Vsbulk_si_Tempt_GND=0.0;
#endif
psiph_Vgi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vgi_bi)+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))));
#if defined(_DERIVATE2)
  psiph_Vgi_bi_Vdbulk_di=0.0;
  psiph_Vgi_bi_Vsbulk_si=0.0;
  psiph_Vgi_bi_Vgi_bi=0.0;
  psiph_Vgi_bi_Vdi_bi=0.0;
  psiph_Vgi_bi_Vsi_bi=0.0;
  psiph_Vgi_bi_Tempt_GND=0.0;
#endif
psiph_Vdi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vdi_bi)+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))));
#if defined(_DERIVATE2)
  psiph_Vdi_bi_Vdbulk_di=0.0;
  psiph_Vdi_bi_Vsbulk_si=0.0;
  psiph_Vdi_bi_Vgi_bi=0.0;
  psiph_Vdi_bi_Vdi_bi=0.0;
  psiph_Vdi_bi_Vsi_bi=0.0;
  psiph_Vdi_bi_Tempt_GND=0.0;
#endif
psiph_Vsi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vsi_bi)+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))));
#if defined(_DERIVATE2)
  psiph_Vsi_bi_Vdbulk_di=0.0;
  psiph_Vsi_bi_Vsbulk_si=0.0;
  psiph_Vsi_bi_Vgi_bi=0.0;
  psiph_Vsi_bi_Vdi_bi=0.0;
  psiph_Vsi_bi_Vsi_bi=0.0;
  psiph_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
psiph_Tempt_GND=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Tempt_GND)+((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))));
#endif
#endif
psiph=(-bsimbulk_lln(((1.0-T2)+(T3*T3))));
EXIT_IF_ISNAN((-bsimbulk_lln(((1.0-T2)+(T3*T3)))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp((-T2),(-T2_Vdbulk_di));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp((-T2),(-T2_Vsbulk_si));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp((-T2),(-T2_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=bsimbulk_d_lexp((-T2),(-T2_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=0.0;
  T3_Vdi_bi_Vgm_di=0.0;
  T3_Vdi_bi_Vdbulk_di=0.0;
  T3_Vdi_bi_Vsbulk_si=0.0;
  T3_Vdi_bi_Vgi_bi=0.0;
  T3_Vdi_bi_Vdi_bi=0.0;
  T3_Vdi_bi_Vsi_bi=0.0;
  T3_Vdi_bi_Tempt_GND=0.0;
#endif
T3_Vsi_bi=bsimbulk_d_lexp((-T2),(-T2_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=0.0;
  T3_Vsi_bi_Vgm_di=0.0;
  T3_Vsi_bi_Vdbulk_di=0.0;
  T3_Vsi_bi_Vsbulk_si=0.0;
  T3_Vsi_bi_Vgi_bi=0.0;
  T3_Vsi_bi_Vdi_bi=0.0;
  T3_Vsi_bi_Vsi_bi=0.0;
  T3_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((-T2),(-T2_Tempt_GND));
#endif
#endif
T3=bsimbulk_lexp((-T2));
EXIT_IF_ISNAN(bsimbulk_lexp((-T2)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(0.5*gammaPD_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vdbulk_di+0.5*0.0);
  T1_Vdbulk_di_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vgm_si);
  T1_Vdbulk_di_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vdbulk_di);
  T1_Vdbulk_di_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vsbulk_si);
  T1_Vdbulk_di_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vgi_bi);
  T1_Vdbulk_di_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vdi_bi);
  T1_Vdbulk_di_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vsi_bi);
  T1_Vdbulk_di_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Tempt_GND);
#endif
T1_Vsbulk_si=(0.5*gammaPD_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vsbulk_si+0.5*0.0);
  T1_Vsbulk_si_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vgm_si);
  T1_Vsbulk_si_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vdbulk_di);
  T1_Vsbulk_si_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vsbulk_si);
  T1_Vsbulk_si_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vgi_bi);
  T1_Vsbulk_si_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vdi_bi);
  T1_Vsbulk_si_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vsi_bi);
  T1_Vsbulk_si_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Tempt_GND);
#endif
T1_Vgi_bi=(0.5*gammaPD_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vgi_bi+0.5*0.0);
  T1_Vgi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=(0.5*gammaPD_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vdi_bi+0.5*0.0);
  T1_Vdi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=(0.5*gammaPD_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vsi_bi+0.5*0.0);
  T1_Vsi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(0.5*gammaPD_Tempt_GND);
#endif
#endif
T1=(0.5*gammaPD);
EXIT_IF_ISNAN((0.5*gammaPD))
{
double m00_sqrt(d00_sqrt0,(((vgfbPD-1.0)+T3)+(T1*T1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((vgfbPD-1.0)+T3)+(T1*T1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*d10_sqrt0-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vgm_di-0.0)+T3_Vdbulk_di_Vgm_di)+(+T1_Vdbulk_di_Vgm_di*T1+T1_Vdbulk_di*T1_Vgm_di+T1_Vgm_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_di)))-T1_Vdbulk_di_Vgm_di);
  T2_Vdbulk_di_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vgm_si-0.0)+T3_Vdbulk_di_Vgm_si)+(+T1_Vdbulk_di_Vgm_si*T1+T1_Vdbulk_di*T1_Vgm_si+T1_Vgm_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_si)))-T1_Vdbulk_di_Vgm_si);
  T2_Vdbulk_di_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vdbulk_di-0.0)+T3_Vdbulk_di_Vdbulk_di)+(+T1_Vdbulk_di_Vdbulk_di*T1+T1_Vdbulk_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdbulk_di)))-T1_Vdbulk_di_Vdbulk_di);
  T2_Vdbulk_di_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vsbulk_si-0.0)+T3_Vdbulk_di_Vsbulk_si)+(+T1_Vdbulk_di_Vsbulk_si*T1+T1_Vdbulk_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsbulk_si)))-T1_Vdbulk_di_Vsbulk_si);
  T2_Vdbulk_di_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vgi_bi-0.0)+T3_Vdbulk_di_Vgi_bi)+(+T1_Vdbulk_di_Vgi_bi*T1+T1_Vdbulk_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgi_bi)))-T1_Vdbulk_di_Vgi_bi);
  T2_Vdbulk_di_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vdi_bi-0.0)+T3_Vdbulk_di_Vdi_bi)+(+T1_Vdbulk_di_Vdi_bi*T1+T1_Vdbulk_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdi_bi)))-T1_Vdbulk_di_Vdi_bi);
  T2_Vdbulk_di_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vsi_bi-0.0)+T3_Vdbulk_di_Vsi_bi)+(+T1_Vdbulk_di_Vsi_bi*T1+T1_Vdbulk_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsi_bi)))-T1_Vdbulk_di_Vsi_bi);
  T2_Vdbulk_di_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Tempt_GND-0.0)+T3_Vdbulk_di_Tempt_GND)+(+T1_Vdbulk_di_Tempt_GND*T1+T1_Vdbulk_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vdbulk_di+T1*T1_Vdbulk_di_Tempt_GND)))-T1_Vdbulk_di_Tempt_GND);
#endif
T2_Vsbulk_si=(((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*d10_sqrt0-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vgm_di-0.0)+T3_Vsbulk_si_Vgm_di)+(+T1_Vsbulk_si_Vgm_di*T1+T1_Vsbulk_si*T1_Vgm_di+T1_Vgm_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_di)))-T1_Vsbulk_si_Vgm_di);
  T2_Vsbulk_si_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vgm_si-0.0)+T3_Vsbulk_si_Vgm_si)+(+T1_Vsbulk_si_Vgm_si*T1+T1_Vsbulk_si*T1_Vgm_si+T1_Vgm_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_si)))-T1_Vsbulk_si_Vgm_si);
  T2_Vsbulk_si_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vdbulk_di-0.0)+T3_Vsbulk_si_Vdbulk_di)+(+T1_Vsbulk_si_Vdbulk_di*T1+T1_Vsbulk_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdbulk_di)))-T1_Vsbulk_si_Vdbulk_di);
  T2_Vsbulk_si_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vsbulk_si-0.0)+T3_Vsbulk_si_Vsbulk_si)+(+T1_Vsbulk_si_Vsbulk_si*T1+T1_Vsbulk_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsbulk_si)))-T1_Vsbulk_si_Vsbulk_si);
  T2_Vsbulk_si_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vgi_bi-0.0)+T3_Vsbulk_si_Vgi_bi)+(+T1_Vsbulk_si_Vgi_bi*T1+T1_Vsbulk_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgi_bi)))-T1_Vsbulk_si_Vgi_bi);
  T2_Vsbulk_si_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vdi_bi-0.0)+T3_Vsbulk_si_Vdi_bi)+(+T1_Vsbulk_si_Vdi_bi*T1+T1_Vsbulk_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdi_bi)))-T1_Vsbulk_si_Vdi_bi);
  T2_Vsbulk_si_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vsi_bi-0.0)+T3_Vsbulk_si_Vsi_bi)+(+T1_Vsbulk_si_Vsi_bi*T1+T1_Vsbulk_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsi_bi)))-T1_Vsbulk_si_Vsi_bi);
  T2_Vsbulk_si_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Tempt_GND-0.0)+T3_Vsbulk_si_Tempt_GND)+(+T1_Vsbulk_si_Tempt_GND*T1+T1_Vsbulk_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vsbulk_si+T1*T1_Vsbulk_si_Tempt_GND)))-T1_Vsbulk_si_Tempt_GND);
#endif
T2_Vgi_bi=(((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*d10_sqrt0-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgm_di-0.0)+T3_Vgi_bi_Vgm_di)+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)))-T1_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgm_si-0.0)+T3_Vgi_bi_Vgm_si)+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)))-T1_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vdbulk_di-0.0)+T3_Vgi_bi_Vdbulk_di)+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)))-T1_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vsbulk_si-0.0)+T3_Vgi_bi_Vsbulk_si)+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)))-T1_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgi_bi-0.0)+T3_Vgi_bi_Vgi_bi)+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)))-T1_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vdi_bi-0.0)+T3_Vgi_bi_Vdi_bi)+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)))-T1_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vsi_bi-0.0)+T3_Vgi_bi_Vsi_bi)+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)))-T1_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Tempt_GND-0.0)+T3_Vgi_bi_Tempt_GND)+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)))-T1_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=(((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*d10_sqrt0-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgm_di-0.0)+T3_Vdi_bi_Vgm_di)+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)))-T1_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgm_si-0.0)+T3_Vdi_bi_Vgm_si)+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)))-T1_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vdbulk_di-0.0)+T3_Vdi_bi_Vdbulk_di)+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)))-T1_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vsbulk_si-0.0)+T3_Vdi_bi_Vsbulk_si)+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)))-T1_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgi_bi-0.0)+T3_Vdi_bi_Vgi_bi)+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)))-T1_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vdi_bi-0.0)+T3_Vdi_bi_Vdi_bi)+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)))-T1_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vsi_bi-0.0)+T3_Vdi_bi_Vsi_bi)+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)))-T1_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Tempt_GND-0.0)+T3_Vdi_bi_Tempt_GND)+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)))-T1_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=(((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*d10_sqrt0-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgm_di-0.0)+T3_Vsi_bi_Vgm_di)+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)))-T1_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgm_si-0.0)+T3_Vsi_bi_Vgm_si)+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)))-T1_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vdbulk_di-0.0)+T3_Vsi_bi_Vdbulk_di)+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)))-T1_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vsbulk_si-0.0)+T3_Vsi_bi_Vsbulk_si)+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)))-T1_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgi_bi-0.0)+T3_Vsi_bi_Vgi_bi)+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)))-T1_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vdi_bi-0.0)+T3_Vsi_bi_Vdi_bi)+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)))-T1_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vsi_bi-0.0)+T3_Vsi_bi_Vsi_bi)+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)))-T1_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Tempt_GND-0.0)+T3_Vsi_bi_Tempt_GND)+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((vgfbPD_Tempt_GND+T3_Tempt_GND)+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0-T1_Tempt_GND);
#endif
#endif
T2=(d00_sqrt0-T1);
EXIT_IF_ISNAN((d00_sqrt0-T1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
psiph_Vdbulk_di=(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di))-T3_Vdbulk_di);
#if defined(_DERIVATE2)
  psiph_Vdbulk_di_Vdbulk_di=(+(+(+T2_Vdbulk_di_Vdbulk_di*T2+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdbulk_di)+0.0)-T3_Vdbulk_di_Vdbulk_di);
  psiph_Vdbulk_di_Vsbulk_si=(+(+(+T2_Vdbulk_di_Vsbulk_si*T2+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsbulk_si)+0.0)-T3_Vdbulk_di_Vsbulk_si);
  psiph_Vdbulk_di_Vgi_bi=(+(+(+T2_Vdbulk_di_Vgi_bi*T2+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgi_bi)+0.0)-T3_Vdbulk_di_Vgi_bi);
  psiph_Vdbulk_di_Vdi_bi=(+(+(+T2_Vdbulk_di_Vdi_bi*T2+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdi_bi)+0.0)-T3_Vdbulk_di_Vdi_bi);
  psiph_Vdbulk_di_Vsi_bi=(+(+(+T2_Vdbulk_di_Vsi_bi*T2+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsi_bi)+0.0)-T3_Vdbulk_di_Vsi_bi);
  psiph_Vdbulk_di_Tempt_GND=(+(+(+T2_Vdbulk_di_Tempt_GND*T2+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*T2_Vdbulk_di_Tempt_GND)+0.0)-T3_Vdbulk_di_Tempt_GND);
#endif
psiph_Vsbulk_si=(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si))-T3_Vsbulk_si);
#if defined(_DERIVATE2)
  psiph_Vsbulk_si_Vdbulk_di=(+(+(+T2_Vsbulk_si_Vdbulk_di*T2+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdbulk_di)+0.0)-T3_Vsbulk_si_Vdbulk_di);
  psiph_Vsbulk_si_Vsbulk_si=(+(+(+T2_Vsbulk_si_Vsbulk_si*T2+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsbulk_si)+0.0)-T3_Vsbulk_si_Vsbulk_si);
  psiph_Vsbulk_si_Vgi_bi=(+(+(+T2_Vsbulk_si_Vgi_bi*T2+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgi_bi)+0.0)-T3_Vsbulk_si_Vgi_bi);
  psiph_Vsbulk_si_Vdi_bi=(+(+(+T2_Vsbulk_si_Vdi_bi*T2+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdi_bi)+0.0)-T3_Vsbulk_si_Vdi_bi);
  psiph_Vsbulk_si_Vsi_bi=(+(+(+T2_Vsbulk_si_Vsi_bi*T2+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsi_bi)+0.0)-T3_Vsbulk_si_Vsi_bi);
  psiph_Vsbulk_si_Tempt_GND=(+(+(+T2_Vsbulk_si_Tempt_GND*T2+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*T2_Vsbulk_si_Tempt_GND)+0.0)-T3_Vsbulk_si_Tempt_GND);
#endif
psiph_Vgi_bi=(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))-T3_Vgi_bi);
#if defined(_DERIVATE2)
  psiph_Vgi_bi_Vdbulk_di=(+(+(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di)+0.0)-T3_Vgi_bi_Vdbulk_di);
  psiph_Vgi_bi_Vsbulk_si=(+(+(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si)+0.0)-T3_Vgi_bi_Vsbulk_si);
  psiph_Vgi_bi_Vgi_bi=(+(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0)-T3_Vgi_bi_Vgi_bi);
  psiph_Vgi_bi_Vdi_bi=(+(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0)-T3_Vgi_bi_Vdi_bi);
  psiph_Vgi_bi_Vsi_bi=(+(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0)-T3_Vgi_bi_Vsi_bi);
  psiph_Vgi_bi_Tempt_GND=(+(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0)-T3_Vgi_bi_Tempt_GND);
#endif
psiph_Vdi_bi=(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))-T3_Vdi_bi);
#if defined(_DERIVATE2)
  psiph_Vdi_bi_Vdbulk_di=(+(+(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di)+0.0)-T3_Vdi_bi_Vdbulk_di);
  psiph_Vdi_bi_Vsbulk_si=(+(+(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si)+0.0)-T3_Vdi_bi_Vsbulk_si);
  psiph_Vdi_bi_Vgi_bi=(+(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0)-T3_Vdi_bi_Vgi_bi);
  psiph_Vdi_bi_Vdi_bi=(+(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0)-T3_Vdi_bi_Vdi_bi);
  psiph_Vdi_bi_Vsi_bi=(+(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0)-T3_Vdi_bi_Vsi_bi);
  psiph_Vdi_bi_Tempt_GND=(+(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0)-T3_Vdi_bi_Tempt_GND);
#endif
psiph_Vsi_bi=(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))-T3_Vsi_bi);
#if defined(_DERIVATE2)
  psiph_Vsi_bi_Vdbulk_di=(+(+(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di)+0.0)-T3_Vsi_bi_Vdbulk_di);
  psiph_Vsi_bi_Vsbulk_si=(+(+(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si)+0.0)-T3_Vsi_bi_Vsbulk_si);
  psiph_Vsi_bi_Vgi_bi=(+(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0)-T3_Vsi_bi_Vgi_bi);
  psiph_Vsi_bi_Vdi_bi=(+(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0)-T3_Vsi_bi_Vdi_bi);
  psiph_Vsi_bi_Vsi_bi=(+(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0)-T3_Vsi_bi_Vsi_bi);
  psiph_Vsi_bi_Tempt_GND=(+(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0)-T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
psiph_Tempt_GND=(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))-T3_Tempt_GND);
#endif
#endif
psiph=(((T2*T2)+1.0)-T3);
EXIT_IF_ISNAN((((T2*T2)+1.0)-T3))
}
{
double m00_sqrt(d00_sqrt0,(((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=(0.5*(psiph_Vdbulk_di+((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vdbulk_di+((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vdbulk_di*0.0+0.0*psiph_Vdbulk_di+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vdbulk_di+((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vdbulk_di*0.0+0.0*psiph_Vdbulk_di+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdbulk_di+((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdbulk_di+((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiph_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))+d10_sqrt0*(+(+(+psiph_Vdbulk_di_Vdbulk_di-0.0)*(psiph-1.0)+psiph_Vdbulk_di*psiph_Vdbulk_di+psiph_Vdbulk_di*psiph_Vdbulk_di+(psiph-1.0)*(+psiph_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsbulk_si+((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdbulk_di+((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiph_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))+d10_sqrt0*(+(+(+psiph_Vdbulk_di_Vsbulk_si-0.0)*(psiph-1.0)+psiph_Vdbulk_di*psiph_Vsbulk_si+psiph_Vsbulk_si*psiph_Vdbulk_di+(psiph-1.0)*(+psiph_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vgi_bi+((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdbulk_di+((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiph_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))+d10_sqrt0*(+(+(+psiph_Vdbulk_di_Vgi_bi-0.0)*(psiph-1.0)+psiph_Vdbulk_di*psiph_Vgi_bi+psiph_Vgi_bi*psiph_Vdbulk_di+(psiph-1.0)*(+psiph_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdi_bi+((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdbulk_di+((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiph_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))+d10_sqrt0*(+(+(+psiph_Vdbulk_di_Vdi_bi-0.0)*(psiph-1.0)+psiph_Vdbulk_di*psiph_Vdi_bi+psiph_Vdi_bi*psiph_Vdbulk_di+(psiph-1.0)*(+psiph_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsi_bi+((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdbulk_di+((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiph_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))+d10_sqrt0*(+(+(+psiph_Vdbulk_di_Vsi_bi-0.0)*(psiph-1.0)+psiph_Vdbulk_di*psiph_Vsi_bi+psiph_Vsi_bi*psiph_Vdbulk_di+(psiph-1.0)*(+psiph_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Tempt_GND+((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdbulk_di+((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiph_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di))+d10_sqrt0*(+(+(+psiph_Vdbulk_di_Tempt_GND-0.0)*(psiph-1.0)+psiph_Vdbulk_di*psiph_Tempt_GND+psiph_Tempt_GND*psiph_Vdbulk_di+(psiph-1.0)*(+psiph_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsbulk_si=(0.5*(psiph_Vsbulk_si+((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vsbulk_si+((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vsbulk_si*0.0+0.0*psiph_Vsbulk_si+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vsbulk_si+((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vsbulk_si*0.0+0.0*psiph_Vsbulk_si+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdbulk_di+((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsbulk_si+((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiph_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))+d10_sqrt0*(+(+(+psiph_Vsbulk_si_Vdbulk_di-0.0)*(psiph-1.0)+psiph_Vsbulk_si*psiph_Vdbulk_di+psiph_Vdbulk_di*psiph_Vsbulk_si+(psiph-1.0)*(+psiph_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsbulk_si+((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsbulk_si+((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiph_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))+d10_sqrt0*(+(+(+psiph_Vsbulk_si_Vsbulk_si-0.0)*(psiph-1.0)+psiph_Vsbulk_si*psiph_Vsbulk_si+psiph_Vsbulk_si*psiph_Vsbulk_si+(psiph-1.0)*(+psiph_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vgi_bi+((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsbulk_si+((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiph_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))+d10_sqrt0*(+(+(+psiph_Vsbulk_si_Vgi_bi-0.0)*(psiph-1.0)+psiph_Vsbulk_si*psiph_Vgi_bi+psiph_Vgi_bi*psiph_Vsbulk_si+(psiph-1.0)*(+psiph_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdi_bi+((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsbulk_si+((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiph_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))+d10_sqrt0*(+(+(+psiph_Vsbulk_si_Vdi_bi-0.0)*(psiph-1.0)+psiph_Vsbulk_si*psiph_Vdi_bi+psiph_Vdi_bi*psiph_Vsbulk_si+(psiph-1.0)*(+psiph_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsi_bi+((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsbulk_si+((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiph_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))+d10_sqrt0*(+(+(+psiph_Vsbulk_si_Vsi_bi-0.0)*(psiph-1.0)+psiph_Vsbulk_si*psiph_Vsi_bi+psiph_Vsi_bi*psiph_Vsbulk_si+(psiph-1.0)*(+psiph_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Tempt_GND+((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsbulk_si+((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiph_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si))+d10_sqrt0*(+(+(+psiph_Vsbulk_si_Tempt_GND-0.0)*(psiph-1.0)+psiph_Vsbulk_si*psiph_Tempt_GND+psiph_Tempt_GND*psiph_Vsbulk_si+(psiph-1.0)*(+psiph_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vgi_bi=(0.5*(psiph_Vgi_bi+((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vgi_bi+((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vgi_bi*0.0+0.0*psiph_Vgi_bi+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgm_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vgi_bi+((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vgi_bi*0.0+0.0*psiph_Vgi_bi+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdbulk_di+((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vgi_bi+((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))+d10_sqrt0*(+(+(+psiph_Vgi_bi_Vdbulk_di-0.0)*(psiph-1.0)+psiph_Vgi_bi*psiph_Vdbulk_di+psiph_Vdbulk_di*psiph_Vgi_bi+(psiph-1.0)*(+psiph_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsbulk_si+((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vgi_bi+((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))+d10_sqrt0*(+(+(+psiph_Vgi_bi_Vsbulk_si-0.0)*(psiph-1.0)+psiph_Vgi_bi*psiph_Vsbulk_si+psiph_Vsbulk_si*psiph_Vgi_bi+(psiph-1.0)*(+psiph_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vgi_bi+((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vgi_bi+((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))+d10_sqrt0*(+(+(+psiph_Vgi_bi_Vgi_bi-0.0)*(psiph-1.0)+psiph_Vgi_bi*psiph_Vgi_bi+psiph_Vgi_bi*psiph_Vgi_bi+(psiph-1.0)*(+psiph_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdi_bi+((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vgi_bi+((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))+d10_sqrt0*(+(+(+psiph_Vgi_bi_Vdi_bi-0.0)*(psiph-1.0)+psiph_Vgi_bi*psiph_Vdi_bi+psiph_Vdi_bi*psiph_Vgi_bi+(psiph-1.0)*(+psiph_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsi_bi+((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vgi_bi+((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))+d10_sqrt0*(+(+(+psiph_Vgi_bi_Vsi_bi-0.0)*(psiph-1.0)+psiph_Vgi_bi*psiph_Vsi_bi+psiph_Vsi_bi*psiph_Vgi_bi+(psiph-1.0)*(+psiph_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Tempt_GND+((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vgi_bi+((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi))+d10_sqrt0*(+(+(+psiph_Vgi_bi_Tempt_GND-0.0)*(psiph-1.0)+psiph_Vgi_bi*psiph_Tempt_GND+psiph_Tempt_GND*psiph_Vgi_bi+(psiph-1.0)*(+psiph_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vdi_bi=(0.5*(psiph_Vdi_bi+((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vdi_bi+((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vdi_bi*0.0+0.0*psiph_Vdi_bi+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgm_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vdi_bi+((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vdi_bi*0.0+0.0*psiph_Vdi_bi+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdbulk_di+((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdi_bi+((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))+d10_sqrt0*(+(+(+psiph_Vdi_bi_Vdbulk_di-0.0)*(psiph-1.0)+psiph_Vdi_bi*psiph_Vdbulk_di+psiph_Vdbulk_di*psiph_Vdi_bi+(psiph-1.0)*(+psiph_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsbulk_si+((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdi_bi+((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))+d10_sqrt0*(+(+(+psiph_Vdi_bi_Vsbulk_si-0.0)*(psiph-1.0)+psiph_Vdi_bi*psiph_Vsbulk_si+psiph_Vsbulk_si*psiph_Vdi_bi+(psiph-1.0)*(+psiph_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vgi_bi+((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdi_bi+((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))+d10_sqrt0*(+(+(+psiph_Vdi_bi_Vgi_bi-0.0)*(psiph-1.0)+psiph_Vdi_bi*psiph_Vgi_bi+psiph_Vgi_bi*psiph_Vdi_bi+(psiph-1.0)*(+psiph_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdi_bi+((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdi_bi+((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))+d10_sqrt0*(+(+(+psiph_Vdi_bi_Vdi_bi-0.0)*(psiph-1.0)+psiph_Vdi_bi*psiph_Vdi_bi+psiph_Vdi_bi*psiph_Vdi_bi+(psiph-1.0)*(+psiph_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsi_bi+((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdi_bi+((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))+d10_sqrt0*(+(+(+psiph_Vdi_bi_Vsi_bi-0.0)*(psiph-1.0)+psiph_Vdi_bi*psiph_Vsi_bi+psiph_Vsi_bi*psiph_Vdi_bi+(psiph-1.0)*(+psiph_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Tempt_GND+((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vdi_bi+((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi))+d10_sqrt0*(+(+(+psiph_Vdi_bi_Tempt_GND-0.0)*(psiph-1.0)+psiph_Vdi_bi*psiph_Tempt_GND+psiph_Tempt_GND*psiph_Vdi_bi+(psiph-1.0)*(+psiph_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsi_bi=(0.5*(psiph_Vsi_bi+((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vsi_bi+((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vsi_bi*0.0+0.0*psiph_Vsi_bi+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgm_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*((0.0)+((0.0)*2.0))*d10_sqrt0+0.0*(psiph_Vsi_bi+((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((0.0)+((0.0)*2.0))*((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*(psiph-1.0)+psiph_Vsi_bi*0.0+0.0*psiph_Vsi_bi+(psiph-1.0)*(+0.0-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdbulk_di+((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsi_bi+((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdbulk_di*(psiph-1.0))+((psiph-1.0)*psiph_Vdbulk_di)))+((0.0)*2.0))*((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))+d10_sqrt0*(+(+(+psiph_Vsi_bi_Vdbulk_di-0.0)*(psiph-1.0)+psiph_Vsi_bi*psiph_Vdbulk_di+psiph_Vdbulk_di*psiph_Vsi_bi+(psiph-1.0)*(+psiph_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsbulk_si+((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsi_bi+((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsbulk_si*(psiph-1.0))+((psiph-1.0)*psiph_Vsbulk_si)))+((0.0)*2.0))*((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))+d10_sqrt0*(+(+(+psiph_Vsi_bi_Vsbulk_si-0.0)*(psiph-1.0)+psiph_Vsi_bi*psiph_Vsbulk_si+psiph_Vsbulk_si*psiph_Vsi_bi+(psiph-1.0)*(+psiph_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vgi_bi+((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsi_bi+((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vgi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vgi_bi)))+((0.0)*2.0))*((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))+d10_sqrt0*(+(+(+psiph_Vsi_bi_Vgi_bi-0.0)*(psiph-1.0)+psiph_Vsi_bi*psiph_Vgi_bi+psiph_Vgi_bi*psiph_Vsi_bi+(psiph-1.0)*(+psiph_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vdi_bi+((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsi_bi+((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vdi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vdi_bi)))+((0.0)*2.0))*((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))+d10_sqrt0*(+(+(+psiph_Vsi_bi_Vdi_bi-0.0)*(psiph-1.0)+psiph_Vsi_bi*psiph_Vdi_bi+psiph_Vdi_bi*psiph_Vsi_bi+(psiph-1.0)*(+psiph_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Vsi_bi+((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsi_bi+((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi)))+((0.0)*2.0))*((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))+d10_sqrt0*(+(+(+psiph_Vsi_bi_Vsi_bi-0.0)*(psiph-1.0)+psiph_Vsi_bi*psiph_Vsi_bi+psiph_Vsi_bi*psiph_Vsi_bi+(psiph-1.0)*(+psiph_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((psiph+1.0)+d00_sqrt0)+0.0*(psiph_Tempt_GND+((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiph_Vsi_bi+((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiph_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiph-1.0)*(psiph-1.0))+((0.25*2.0)*2.0)))*((((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND)))+((0.0)*2.0))*((psiph_Vsi_bi*(psiph-1.0))+((psiph-1.0)*psiph_Vsi_bi))+d10_sqrt0*(+(+(+psiph_Vsi_bi_Tempt_GND-0.0)*(psiph-1.0)+psiph_Vsi_bi*psiph_Tempt_GND+psiph_Tempt_GND*psiph_Vsi_bi+(psiph-1.0)*(+psiph_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(psiph_Tempt_GND+((psiph_Tempt_GND*(psiph-1.0))+((psiph-1.0)*psiph_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((psiph+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psiph+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T8)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T8)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=0.0;
  sqrtpsip_Vgm_di_Vgm_si=0.0;
  sqrtpsip_Vgm_di_Vdbulk_di=0.0;
  sqrtpsip_Vgm_di_Vsbulk_si=0.0;
  sqrtpsip_Vgm_di_Vgi_bi=0.0;
  sqrtpsip_Vgm_di_Vdi_bi=0.0;
  sqrtpsip_Vgm_di_Vsi_bi=0.0;
  sqrtpsip_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=0.0;
  sqrtpsip_Vgm_si_Vgm_si=0.0;
  sqrtpsip_Vgm_si_Vdbulk_di=0.0;
  sqrtpsip_Vgm_si_Vsbulk_si=0.0;
  sqrtpsip_Vgm_si_Vgi_bi=0.0;
  sqrtpsip_Vgm_si_Vdi_bi=0.0;
  sqrtpsip_Vgm_si_Vsi_bi=0.0;
  sqrtpsip_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vdbulk_di=T8_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_di);
  sqrtpsip_Vdbulk_di_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_si);
  sqrtpsip_Vdbulk_di_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdbulk_di);
  sqrtpsip_Vdbulk_di_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsbulk_si);
  sqrtpsip_Vdbulk_di_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgi_bi);
  sqrtpsip_Vdbulk_di_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdi_bi);
  sqrtpsip_Vdbulk_di_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsi_bi);
  sqrtpsip_Vdbulk_di_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Tempt_GND);
#endif
sqrtpsip_Vsbulk_si=T8_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_di);
  sqrtpsip_Vsbulk_si_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_si);
  sqrtpsip_Vsbulk_si_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdbulk_di);
  sqrtpsip_Vsbulk_si_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsbulk_si);
  sqrtpsip_Vsbulk_si_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgi_bi);
  sqrtpsip_Vsbulk_si_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdi_bi);
  sqrtpsip_Vsbulk_si_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsi_bi);
  sqrtpsip_Vsbulk_si_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Tempt_GND);
#endif
sqrtpsip_Vgi_bi=T8_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=T8_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=T8_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=T8_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=(-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdbulk_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsbulk_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Tempt_GND=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsbulk_si=(-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdbulk_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsbulk_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Tempt_GND=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vdi_bi=(-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdbulk_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsbulk_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Tempt_GND=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsi_bi=(-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdbulk_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsbulk_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Tempt_GND=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=((gam_h_Tempt_GND*(2.0*sqrtpsip)-gam_h*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#endif
T9_Vgi_bi=(-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdbulk_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsbulk_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Tempt_GND=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#endif
T9=(1.0+(gam_h/(2.0*sqrtpsip)));
EXIT_IF_ISNAN((1.0+(gam_h/(2.0*sqrtpsip))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=((-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))/gam_h);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdbulk_di_Vgm_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdbulk_di_Vdbulk_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdbulk_di_Vsbulk_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdbulk_di_Vgi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdbulk_di_Vdi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdbulk_di_Vsi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdbulk_di_Tempt_GND=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_h_Tempt_GND+((gam_h_Tempt_GND*(2.0*sqrtpsip)-gam_h*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*gam_h_Tempt_GND/gam_h/gam_h/gam_h);
#endif
T0_Vsbulk_si=((-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))/gam_h);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsbulk_si_Vgm_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsbulk_si_Vdbulk_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsbulk_si_Vsbulk_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsbulk_si_Vgi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsbulk_si_Vdi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsbulk_si_Vsi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsbulk_si_Tempt_GND=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_h_Tempt_GND+((gam_h_Tempt_GND*(2.0*sqrtpsip)-gam_h*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*gam_h_Tempt_GND/gam_h/gam_h/gam_h);
#endif
T0_Vgi_bi=((-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))/gam_h);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vgi_bi_Vgm_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vgi_bi_Vdbulk_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vgi_bi_Vsbulk_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vgi_bi_Vgi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vgi_bi_Vdi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vgi_bi_Vsi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vgi_bi_Tempt_GND=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vgi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_h_Tempt_GND+((gam_h_Tempt_GND*(2.0*sqrtpsip)-gam_h*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*gam_h_Tempt_GND/gam_h/gam_h/gam_h);
#endif
T0_Vdi_bi=((-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))/gam_h);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdi_bi_Vgm_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdi_bi_Vdbulk_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdi_bi_Vsbulk_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdi_bi_Vgi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdi_bi_Vdi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdi_bi_Vsi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vdi_bi_Tempt_GND=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vdi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_h_Tempt_GND+((gam_h_Tempt_GND*(2.0*sqrtpsip)-gam_h*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*gam_h_Tempt_GND/gam_h/gam_h/gam_h);
#endif
T0_Vsi_bi=((-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))/gam_h);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsi_bi_Vgm_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsi_bi_Vdbulk_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsi_bi_Vsbulk_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsi_bi_Vgi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsi_bi_Vdi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsi_bi_Vsi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam_h*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*0.0/gam_h/gam_h/gam_h);
  T0_Vsi_bi_Tempt_GND=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_h_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam_h*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam_h*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam_h-((-gam_h*(2.0*sqrtpsip_Vsi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_h_Tempt_GND+((gam_h_Tempt_GND*(2.0*sqrtpsip)-gam_h*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam_h/(2.0*sqrtpsip)))*0.0)/gam_h/gam_h+2*(1.0+(gam_h/(2.0*sqrtpsip)))*0.0*gam_h_Tempt_GND/gam_h/gam_h/gam_h);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((((gam_h_Tempt_GND*(2.0*sqrtpsip)-gam_h*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_h-(1.0+(gam_h/(2.0*sqrtpsip)))*gam_h_Tempt_GND)/gam_h/gam_h);
#endif
#endif
T0=((1.0+(gam_h/(2.0*sqrtpsip)))/gam_h);
EXIT_IF_ISNAN(((1.0+(gam_h/(2.0*sqrtpsip)))/gam_h))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(psiph_Vdbulk_di-vs_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vdbulk_di_Vgm_si=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vgm_si);
  T1_Vdbulk_di_Vdbulk_di=(+(+psiph_Vdbulk_di_Vdbulk_di-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vdbulk_di);
  T1_Vdbulk_di_Vsbulk_si=(+(+psiph_Vdbulk_di_Vsbulk_si-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vsbulk_si);
  T1_Vdbulk_di_Vgi_bi=(+(+psiph_Vdbulk_di_Vgi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vgi_bi);
  T1_Vdbulk_di_Vdi_bi=(+(+psiph_Vdbulk_di_Vdi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vdi_bi);
  T1_Vdbulk_di_Vsi_bi=(+(+psiph_Vdbulk_di_Vsi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vsi_bi);
  T1_Vdbulk_di_Tempt_GND=(+(+psiph_Vdbulk_di_Tempt_GND-(+0.0*phib_h+0.0*phib_h_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Tempt_GND);
#endif
T1_Vsbulk_si=(psiph_Vsbulk_si-vs_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vsbulk_si_Vgm_si=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vgm_si);
  T1_Vsbulk_si_Vdbulk_di=(+(+psiph_Vsbulk_si_Vdbulk_di-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vdbulk_di);
  T1_Vsbulk_si_Vsbulk_si=(+(+psiph_Vsbulk_si_Vsbulk_si-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vsbulk_si);
  T1_Vsbulk_si_Vgi_bi=(+(+psiph_Vsbulk_si_Vgi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vgi_bi);
  T1_Vsbulk_si_Vdi_bi=(+(+psiph_Vsbulk_si_Vdi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vdi_bi);
  T1_Vsbulk_si_Vsi_bi=(+(+psiph_Vsbulk_si_Vsi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vsi_bi);
  T1_Vsbulk_si_Tempt_GND=(+(+psiph_Vsbulk_si_Tempt_GND-(+0.0*phib_h+0.0*phib_h_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Tempt_GND);
#endif
T1_Vgi_bi=(psiph_Vgi_bi-vs_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vgi_bi_Vgm_si=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+(+psiph_Vgi_bi_Vdbulk_di-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+(+psiph_Vgi_bi_Vsbulk_si-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+(+psiph_Vgi_bi_Vgi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+(+psiph_Vgi_bi_Vdi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+(+psiph_Vgi_bi_Vsi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+(+psiph_Vgi_bi_Tempt_GND-(+0.0*phib_h+0.0*phib_h_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=(psiph_Vdi_bi-vs_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vdi_bi_Vgm_si=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+(+psiph_Vdi_bi_Vdbulk_di-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+(+psiph_Vdi_bi_Vsbulk_si-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+(+psiph_Vdi_bi_Vgi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+(+psiph_Vdi_bi_Vdi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+(+psiph_Vdi_bi_Vsi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+(+psiph_Vdi_bi_Tempt_GND-(+0.0*phib_h+0.0*phib_h_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=(psiph_Vsi_bi-vs_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vsi_bi_Vgm_si=(+(+0.0-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+(+psiph_Vsi_bi_Vdbulk_di-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+(+psiph_Vsi_bi_Vsbulk_si-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+(+psiph_Vsi_bi_Vgi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+(+psiph_Vsi_bi_Vdi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+(+psiph_Vsi_bi_Vsi_bi-(+0.0*phib_h+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+(+psiph_Vsi_bi_Tempt_GND-(+0.0*phib_h+0.0*phib_h_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((psiph_Tempt_GND-(2.0*phib_h_Tempt_GND))-vs_Tempt_GND);
#endif
#endif
T1=((psiph-(2.0*phib_h))-vs);
EXIT_IF_ISNAN(((psiph-(2.0*phib_h))-vs))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(T1_Vdbulk_di-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdbulk_di)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdbulk_di))));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+T1_Vdbulk_di_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_di));
  T2_Vdbulk_di_Vgm_si=(+T1_Vdbulk_di_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_si));
  T2_Vdbulk_di_Vdbulk_di=(+T1_Vdbulk_di_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdbulk_di));
  T2_Vdbulk_di_Vsbulk_si=(+T1_Vdbulk_di_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsbulk_si));
  T2_Vdbulk_di_Vgi_bi=(+T1_Vdbulk_di_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgi_bi));
  T2_Vdbulk_di_Vdi_bi=(+T1_Vdbulk_di_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdi_bi));
  T2_Vdbulk_di_Vsi_bi=(+T1_Vdbulk_di_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsi_bi));
  T2_Vdbulk_di_Tempt_GND=(+T1_Vdbulk_di_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Tempt_GND)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Tempt_GND));
#endif
T2_Vsbulk_si=(T1_Vsbulk_si-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsbulk_si)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsbulk_si))));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+T1_Vsbulk_si_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_di));
  T2_Vsbulk_si_Vgm_si=(+T1_Vsbulk_si_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_si));
  T2_Vsbulk_si_Vdbulk_di=(+T1_Vsbulk_si_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdbulk_di));
  T2_Vsbulk_si_Vsbulk_si=(+T1_Vsbulk_si_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsbulk_si));
  T2_Vsbulk_si_Vgi_bi=(+T1_Vsbulk_si_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgi_bi));
  T2_Vsbulk_si_Vdi_bi=(+T1_Vsbulk_si_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdi_bi));
  T2_Vsbulk_si_Vsi_bi=(+T1_Vsbulk_si_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsi_bi));
  T2_Vsbulk_si_Tempt_GND=(+T1_Vsbulk_si_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Tempt_GND)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Tempt_GND));
#endif
T2_Vgi_bi=(T1_Vgi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgi_bi))));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_di));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_si));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdbulk_di));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsbulk_si));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(T1_Vdi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdi_bi))));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_di));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_si));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdbulk_di));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsbulk_si));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(T1_Vsi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsi_bi))));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_di));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_si));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdbulk_di));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsbulk_si));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Tempt_GND)*sqrtpsip)+((4.0*T0)*sqrtpsip_Tempt_GND))));
#endif
#endif
T2=(T1-bsimbulk_lln(((4.0*T0)*sqrtpsip)));
EXIT_IF_ISNAN((T1-bsimbulk_lln(((4.0*T0)*sqrtpsip))))
{
double m00_sqrt(d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=(0.5*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_di+0.0))+0.0))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_si+0.0))+0.0))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdbulk_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdbulk_di+0.0))+0.0))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsbulk_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsbulk_si+0.0))+0.0))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Tempt_GND*(T2+0.402982)+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsbulk_si=(0.5*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_di+0.0))+0.0))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_si+0.0))+0.0))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdbulk_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdbulk_di+0.0))+0.0))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsbulk_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsbulk_si+0.0))+0.0))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Tempt_GND*(T2+0.402982)+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Tempt_GND+0.0))+0.0))));
#endif
T8_Vgi_bi=(0.5*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_di+0.0))+0.0))));
  T8_Vgi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_si+0.0))+0.0))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*(T2+0.402982)+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*(T2+0.402982)+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*(T2+0.402982)+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*(+T2_Vgi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vdi_bi=(0.5*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_di+0.0))+0.0))));
  T8_Vdi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_si+0.0))+0.0))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*(T2+0.402982)+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*(T2+0.402982)+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*(T2+0.402982)+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*(+T2_Vdi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsi_bi=(0.5*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_di+0.0))+0.0))));
  T8_Vsi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_si+0.0))+0.0))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*(T2+0.402982)+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*(T2+0.402982)+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*(T2+0.402982)+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*(+T2_Vsi_bi_Tempt_GND+0.0))+0.0))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(T2_Tempt_GND-((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((T2-0.201491)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T2-0.201491)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
sqrtpsisa_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_di_Vgm_di=0.0;
  sqrtpsisa_Vgm_di_Vgm_si=0.0;
  sqrtpsisa_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_di_Vgi_bi=0.0;
  sqrtpsisa_Vgm_di_Vdi_bi=0.0;
  sqrtpsisa_Vgm_di_Vsi_bi=0.0;
  sqrtpsisa_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisa_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_si_Vgm_di=0.0;
  sqrtpsisa_Vgm_si_Vgm_si=0.0;
  sqrtpsisa_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_si_Vgi_bi=0.0;
  sqrtpsisa_Vgm_si_Vdi_bi=0.0;
  sqrtpsisa_Vgm_si_Vsi_bi=0.0;
  sqrtpsisa_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisa_Vdbulk_di=sqrtpsip_Vdbulk_di;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdbulk_di_Vgm_di=sqrtpsip_Vdbulk_di_Vgm_di;
  sqrtpsisa_Vdbulk_di_Vgm_si=sqrtpsip_Vdbulk_di_Vgm_si;
  sqrtpsisa_Vdbulk_di_Vdbulk_di=sqrtpsip_Vdbulk_di_Vdbulk_di;
  sqrtpsisa_Vdbulk_di_Vsbulk_si=sqrtpsip_Vdbulk_di_Vsbulk_si;
  sqrtpsisa_Vdbulk_di_Vgi_bi=sqrtpsip_Vdbulk_di_Vgi_bi;
  sqrtpsisa_Vdbulk_di_Vdi_bi=sqrtpsip_Vdbulk_di_Vdi_bi;
  sqrtpsisa_Vdbulk_di_Vsi_bi=sqrtpsip_Vdbulk_di_Vsi_bi;
  sqrtpsisa_Vdbulk_di_Tempt_GND=sqrtpsip_Vdbulk_di_Tempt_GND;
#endif
sqrtpsisa_Vsbulk_si=sqrtpsip_Vsbulk_si;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsbulk_si_Vgm_di=sqrtpsip_Vsbulk_si_Vgm_di;
  sqrtpsisa_Vsbulk_si_Vgm_si=sqrtpsip_Vsbulk_si_Vgm_si;
  sqrtpsisa_Vsbulk_si_Vdbulk_di=sqrtpsip_Vsbulk_si_Vdbulk_di;
  sqrtpsisa_Vsbulk_si_Vsbulk_si=sqrtpsip_Vsbulk_si_Vsbulk_si;
  sqrtpsisa_Vsbulk_si_Vgi_bi=sqrtpsip_Vsbulk_si_Vgi_bi;
  sqrtpsisa_Vsbulk_si_Vdi_bi=sqrtpsip_Vsbulk_si_Vdi_bi;
  sqrtpsisa_Vsbulk_si_Vsi_bi=sqrtpsip_Vsbulk_si_Vsi_bi;
  sqrtpsisa_Vsbulk_si_Tempt_GND=sqrtpsip_Vsbulk_si_Tempt_GND;
#endif
sqrtpsisa_Vgi_bi=sqrtpsip_Vgi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgi_bi_Vgm_di=sqrtpsip_Vgi_bi_Vgm_di;
  sqrtpsisa_Vgi_bi_Vgm_si=sqrtpsip_Vgi_bi_Vgm_si;
  sqrtpsisa_Vgi_bi_Vdbulk_di=sqrtpsip_Vgi_bi_Vdbulk_di;
  sqrtpsisa_Vgi_bi_Vsbulk_si=sqrtpsip_Vgi_bi_Vsbulk_si;
  sqrtpsisa_Vgi_bi_Vgi_bi=sqrtpsip_Vgi_bi_Vgi_bi;
  sqrtpsisa_Vgi_bi_Vdi_bi=sqrtpsip_Vgi_bi_Vdi_bi;
  sqrtpsisa_Vgi_bi_Vsi_bi=sqrtpsip_Vgi_bi_Vsi_bi;
  sqrtpsisa_Vgi_bi_Tempt_GND=sqrtpsip_Vgi_bi_Tempt_GND;
#endif
sqrtpsisa_Vdi_bi=sqrtpsip_Vdi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdi_bi_Vgm_di=sqrtpsip_Vdi_bi_Vgm_di;
  sqrtpsisa_Vdi_bi_Vgm_si=sqrtpsip_Vdi_bi_Vgm_si;
  sqrtpsisa_Vdi_bi_Vdbulk_di=sqrtpsip_Vdi_bi_Vdbulk_di;
  sqrtpsisa_Vdi_bi_Vsbulk_si=sqrtpsip_Vdi_bi_Vsbulk_si;
  sqrtpsisa_Vdi_bi_Vgi_bi=sqrtpsip_Vdi_bi_Vgi_bi;
  sqrtpsisa_Vdi_bi_Vdi_bi=sqrtpsip_Vdi_bi_Vdi_bi;
  sqrtpsisa_Vdi_bi_Vsi_bi=sqrtpsip_Vdi_bi_Vsi_bi;
  sqrtpsisa_Vdi_bi_Tempt_GND=sqrtpsip_Vdi_bi_Tempt_GND;
#endif
sqrtpsisa_Vsi_bi=sqrtpsip_Vsi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsi_bi_Vgm_di=sqrtpsip_Vsi_bi_Vgm_di;
  sqrtpsisa_Vsi_bi_Vgm_si=sqrtpsip_Vsi_bi_Vgm_si;
  sqrtpsisa_Vsi_bi_Vdbulk_di=sqrtpsip_Vsi_bi_Vdbulk_di;
  sqrtpsisa_Vsi_bi_Vsbulk_si=sqrtpsip_Vsi_bi_Vsbulk_si;
  sqrtpsisa_Vsi_bi_Vgi_bi=sqrtpsip_Vsi_bi_Vgi_bi;
  sqrtpsisa_Vsi_bi_Vdi_bi=sqrtpsip_Vsi_bi_Vdi_bi;
  sqrtpsisa_Vsi_bi_Vsi_bi=sqrtpsip_Vsi_bi_Vsi_bi;
  sqrtpsisa_Vsi_bi_Tempt_GND=sqrtpsip_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
sqrtpsisa_Tempt_GND=sqrtpsip_Tempt_GND;
#endif
#endif
sqrtpsisa=sqrtpsip;
EXIT_IF_ISNAN(sqrtpsip)
if
((T8<=(-68.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=0.0;
#endif
#endif
T4=(-100.0);
EXIT_IF_ISNAN((-100.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=20.0;
EXIT_IF_ISNAN(20.0)
if
((T8<(T4-(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T4,T4_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T4_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T4_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T4_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T4_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T4_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T4_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T4_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T4_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T4,T4_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T4_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T4_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T4_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T4_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T4_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T4_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T4_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T4_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T4,T4_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T4_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T4_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T4_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T4_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T4_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T4_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T4_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T4_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T4,T4_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T4);
EXIT_IF_ISNAN(bsimbulk_lexp(T4))
}
else
{
if
((T8>(T4+(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((T8_Vdbulk_di-T4_Vdbulk_di)*T5-(T8-T4)*T5_Vdbulk_di)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=((+T8_Vdbulk_di_Vgm_di-T4_Vdbulk_di_Vgm_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5);
  T2_Vdbulk_di_Vgm_si=((+T8_Vdbulk_di_Vgm_si-T4_Vdbulk_di_Vgm_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5);
  T2_Vdbulk_di_Vdbulk_di=((+T8_Vdbulk_di_Vdbulk_di-T4_Vdbulk_di_Vdbulk_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdbulk_di_Vsbulk_si=((+T8_Vdbulk_di_Vsbulk_si-T4_Vdbulk_di_Vsbulk_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdbulk_di_Vgi_bi=((+T8_Vdbulk_di_Vgi_bi-T4_Vdbulk_di_Vgi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vdi_bi=((+T8_Vdbulk_di_Vdi_bi-T4_Vdbulk_di_Vdi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vsi_bi=((+T8_Vdbulk_di_Vsi_bi-T4_Vdbulk_di_Vsi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5);
  T2_Vdbulk_di_Tempt_GND=((+T8_Vdbulk_di_Tempt_GND-T4_Vdbulk_di_Tempt_GND)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsbulk_si=(((T8_Vsbulk_si-T4_Vsbulk_si)*T5-(T8-T4)*T5_Vsbulk_si)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=((+T8_Vsbulk_si_Vgm_di-T4_Vsbulk_si_Vgm_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5);
  T2_Vsbulk_si_Vgm_si=((+T8_Vsbulk_si_Vgm_si-T4_Vsbulk_si_Vgm_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5);
  T2_Vsbulk_si_Vdbulk_di=((+T8_Vsbulk_si_Vdbulk_di-T4_Vsbulk_si_Vdbulk_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsbulk_si_Vsbulk_si=((+T8_Vsbulk_si_Vsbulk_si-T4_Vsbulk_si_Vsbulk_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsbulk_si_Vgi_bi=((+T8_Vsbulk_si_Vgi_bi-T4_Vsbulk_si_Vgi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vdi_bi=((+T8_Vsbulk_si_Vdi_bi-T4_Vsbulk_si_Vdi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vsi_bi=((+T8_Vsbulk_si_Vsi_bi-T4_Vsbulk_si_Vsi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5);
  T2_Vsbulk_si_Tempt_GND=((+T8_Vsbulk_si_Tempt_GND-T4_Vsbulk_si_Tempt_GND)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vgi_bi=(((T8_Vgi_bi-T4_Vgi_bi)*T5-(T8-T4)*T5_Vgi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=((+T8_Vgi_bi_Vgm_di-T4_Vgi_bi_Vgm_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vgi_bi_Vgm_si=((+T8_Vgi_bi_Vgm_si-T4_Vgi_bi_Vgm_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vgi_bi_Vdbulk_di=((+T8_Vgi_bi_Vdbulk_di-T4_Vgi_bi_Vdbulk_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgi_bi_Vsbulk_si=((+T8_Vgi_bi_Vsbulk_si-T4_Vgi_bi_Vsbulk_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgi_bi_Vgi_bi=((+T8_Vgi_bi_Vgi_bi-T4_Vgi_bi_Vgi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vgi_bi_Vdi_bi=((+T8_Vgi_bi_Vdi_bi-T4_Vgi_bi_Vdi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vgi_bi_Vsi_bi=((+T8_Vgi_bi_Vsi_bi-T4_Vgi_bi_Vsi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vgi_bi_Tempt_GND=((+T8_Vgi_bi_Tempt_GND-T4_Vgi_bi_Tempt_GND)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vdi_bi=(((T8_Vdi_bi-T4_Vdi_bi)*T5-(T8-T4)*T5_Vdi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=((+T8_Vdi_bi_Vgm_di-T4_Vdi_bi_Vgm_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vdi_bi_Vgm_si=((+T8_Vdi_bi_Vgm_si-T4_Vdi_bi_Vgm_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vdi_bi_Vdbulk_di=((+T8_Vdi_bi_Vdbulk_di-T4_Vdi_bi_Vdbulk_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdi_bi_Vsbulk_si=((+T8_Vdi_bi_Vsbulk_si-T4_Vdi_bi_Vsbulk_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdi_bi_Vgi_bi=((+T8_Vdi_bi_Vgi_bi-T4_Vdi_bi_Vgi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vdi_bi_Vdi_bi=((+T8_Vdi_bi_Vdi_bi-T4_Vdi_bi_Vdi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vdi_bi_Vsi_bi=((+T8_Vdi_bi_Vsi_bi-T4_Vdi_bi_Vsi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vdi_bi_Tempt_GND=((+T8_Vdi_bi_Tempt_GND-T4_Vdi_bi_Tempt_GND)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsi_bi=(((T8_Vsi_bi-T4_Vsi_bi)*T5-(T8-T4)*T5_Vsi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=((+T8_Vsi_bi_Vgm_di-T4_Vsi_bi_Vgm_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vsi_bi_Vgm_si=((+T8_Vsi_bi_Vgm_si-T4_Vsi_bi_Vgm_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vsi_bi_Vdbulk_di=((+T8_Vsi_bi_Vdbulk_di-T4_Vsi_bi_Vdbulk_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsi_bi_Vsbulk_si=((+T8_Vsi_bi_Vsbulk_si-T4_Vsi_bi_Vsbulk_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsi_bi_Vgi_bi=((+T8_Vsi_bi_Vgi_bi-T4_Vsi_bi_Vgi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vsi_bi_Vdi_bi=((+T8_Vsi_bi_Vdi_bi-T4_Vsi_bi_Vdi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vsi_bi_Vsi_bi=((+T8_Vsi_bi_Vsi_bi-T4_Vsi_bi_Vsi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vsi_bi_Tempt_GND=((+T8_Vsi_bi_Tempt_GND-T4_Vsi_bi_Tempt_GND)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((T8_Tempt_GND-T4_Tempt_GND)*T5-(T8-T4)*T5_Tempt_GND)/T5/T5);
#endif
#endif
T2=((T8-T4)/T5);
EXIT_IF_ISNAN(((T8-T4)/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+T2_Vdbulk_di_Vgm_di*T2+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_di);
  T6_Vdbulk_di_Vgm_si=(+T2_Vdbulk_di_Vgm_si*T2+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_si);
  T6_Vdbulk_di_Vdbulk_di=(+T2_Vdbulk_di_Vdbulk_di*T2+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdbulk_di);
  T6_Vdbulk_di_Vsbulk_si=(+T2_Vdbulk_di_Vsbulk_si*T2+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsbulk_si);
  T6_Vdbulk_di_Vgi_bi=(+T2_Vdbulk_di_Vgi_bi*T2+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgi_bi);
  T6_Vdbulk_di_Vdi_bi=(+T2_Vdbulk_di_Vdi_bi*T2+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdi_bi);
  T6_Vdbulk_di_Vsi_bi=(+T2_Vdbulk_di_Vsi_bi*T2+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsi_bi);
  T6_Vdbulk_di_Tempt_GND=(+T2_Vdbulk_di_Tempt_GND*T2+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*T2_Vdbulk_di_Tempt_GND);
#endif
T6_Vsbulk_si=((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+T2_Vsbulk_si_Vgm_di*T2+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_di);
  T6_Vsbulk_si_Vgm_si=(+T2_Vsbulk_si_Vgm_si*T2+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_si);
  T6_Vsbulk_si_Vdbulk_di=(+T2_Vsbulk_si_Vdbulk_di*T2+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdbulk_di);
  T6_Vsbulk_si_Vsbulk_si=(+T2_Vsbulk_si_Vsbulk_si*T2+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsbulk_si);
  T6_Vsbulk_si_Vgi_bi=(+T2_Vsbulk_si_Vgi_bi*T2+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgi_bi);
  T6_Vsbulk_si_Vdi_bi=(+T2_Vsbulk_si_Vdi_bi*T2+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdi_bi);
  T6_Vsbulk_si_Vsi_bi=(+T2_Vsbulk_si_Vsi_bi*T2+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsi_bi);
  T6_Vsbulk_si_Tempt_GND=(+T2_Vsbulk_si_Tempt_GND*T2+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*T2_Vsbulk_si_Tempt_GND);
#endif
T6_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND));
#endif
#endif
T6=(T2*T2);
EXIT_IF_ISNAN((T2*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdbulk_di+((T5_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T4_Vdbulk_di_Vgm_si+(+T5_Vdbulk_di_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_si))+(+T6_Vdbulk_di_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_si)))))));
  T3_Vdbulk_di_Vgm_di=(+T4_Vdbulk_di_Vgm_di+(+T5_Vdbulk_di_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_di))+(+T6_Vdbulk_di_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_di)))))));
  T3_Vdbulk_di_Vdbulk_di=(+T4_Vdbulk_di_Vdbulk_di+(+T5_Vdbulk_di_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdbulk_di))+(+T6_Vdbulk_di_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdbulk_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdbulk_di)))))));
  T3_Vdbulk_di_Vsbulk_si=(+T4_Vdbulk_di_Vsbulk_si+(+T5_Vdbulk_di_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsbulk_si))+(+T6_Vdbulk_di_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsbulk_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsbulk_si)))))));
  T3_Vdbulk_di_Vgi_bi=(+T4_Vdbulk_di_Vgi_bi+(+T5_Vdbulk_di_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgi_bi))+(+T6_Vdbulk_di_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgi_bi)))))));
  T3_Vdbulk_di_Vdi_bi=(+T4_Vdbulk_di_Vdi_bi+(+T5_Vdbulk_di_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdi_bi))+(+T6_Vdbulk_di_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdi_bi)))))));
  T3_Vdbulk_di_Vsi_bi=(+T4_Vdbulk_di_Vsi_bi+(+T5_Vdbulk_di_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsi_bi))+(+T6_Vdbulk_di_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsi_bi)))))));
  T3_Vdbulk_di_Tempt_GND=(+T4_Vdbulk_di_Tempt_GND+(+T5_Vdbulk_di_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Tempt_GND))+(+T6_Vdbulk_di_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Tempt_GND*(1.25-T6)+T6_Vdbulk_di*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Tempt_GND)))))));
#endif
T3_Vsbulk_si=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsbulk_si+((T5_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T4_Vsbulk_si_Vgm_si+(+T5_Vsbulk_si_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_si))+(+T6_Vsbulk_si_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_si)))))));
  T3_Vsbulk_si_Vgm_di=(+T4_Vsbulk_si_Vgm_di+(+T5_Vsbulk_si_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_di))+(+T6_Vsbulk_si_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_di)))))));
  T3_Vsbulk_si_Vdbulk_di=(+T4_Vsbulk_si_Vdbulk_di+(+T5_Vsbulk_si_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdbulk_di))+(+T6_Vsbulk_si_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdbulk_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdbulk_di)))))));
  T3_Vsbulk_si_Vsbulk_si=(+T4_Vsbulk_si_Vsbulk_si+(+T5_Vsbulk_si_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsbulk_si))+(+T6_Vsbulk_si_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsbulk_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsbulk_si)))))));
  T3_Vsbulk_si_Vgi_bi=(+T4_Vsbulk_si_Vgi_bi+(+T5_Vsbulk_si_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgi_bi))+(+T6_Vsbulk_si_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgi_bi)))))));
  T3_Vsbulk_si_Vdi_bi=(+T4_Vsbulk_si_Vdi_bi+(+T5_Vsbulk_si_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdi_bi))+(+T6_Vsbulk_si_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdi_bi)))))));
  T3_Vsbulk_si_Vsi_bi=(+T4_Vsbulk_si_Vsi_bi+(+T5_Vsbulk_si_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsi_bi))+(+T6_Vsbulk_si_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsi_bi)))))));
  T3_Vsbulk_si_Tempt_GND=(+T4_Vsbulk_si_Tempt_GND+(+T5_Vsbulk_si_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Tempt_GND))+(+T6_Vsbulk_si_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Tempt_GND*(1.25-T6)+T6_Vsbulk_si*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Tempt_GND)))))));
#endif
T3_Vgi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgi_bi+((T5_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T4_Vgi_bi_Vgm_si+(+T5_Vgi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_si))+(+T6_Vgi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_si)))))));
  T3_Vgi_bi_Vgm_di=(+T4_Vgi_bi_Vgm_di+(+T5_Vgi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_di))+(+T6_Vgi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_di)))))));
  T3_Vgi_bi_Vdbulk_di=(+T4_Vgi_bi_Vdbulk_di+(+T5_Vgi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdbulk_di))+(+T6_Vgi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdbulk_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdbulk_di)))))));
  T3_Vgi_bi_Vsbulk_si=(+T4_Vgi_bi_Vsbulk_si+(+T5_Vgi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsbulk_si))+(+T6_Vgi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsbulk_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsbulk_si)))))));
  T3_Vgi_bi_Vgi_bi=(+T4_Vgi_bi_Vgi_bi+(+T5_Vgi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgi_bi))+(+T6_Vgi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgi_bi)))))));
  T3_Vgi_bi_Vdi_bi=(+T4_Vgi_bi_Vdi_bi+(+T5_Vgi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdi_bi))+(+T6_Vgi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdi_bi)))))));
  T3_Vgi_bi_Vsi_bi=(+T4_Vgi_bi_Vsi_bi+(+T5_Vgi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsi_bi))+(+T6_Vgi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsi_bi)))))));
  T3_Vgi_bi_Tempt_GND=(+T4_Vgi_bi_Tempt_GND+(+T5_Vgi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Tempt_GND))+(+T6_Vgi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Tempt_GND*(1.25-T6)+T6_Vgi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Tempt_GND)))))));
#endif
T3_Vdi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdi_bi+((T5_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T4_Vdi_bi_Vgm_si+(+T5_Vdi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_si))+(+T6_Vdi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_si)))))));
  T3_Vdi_bi_Vgm_di=(+T4_Vdi_bi_Vgm_di+(+T5_Vdi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_di))+(+T6_Vdi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_di)))))));
  T3_Vdi_bi_Vdbulk_di=(+T4_Vdi_bi_Vdbulk_di+(+T5_Vdi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdbulk_di))+(+T6_Vdi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdbulk_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdbulk_di)))))));
  T3_Vdi_bi_Vsbulk_si=(+T4_Vdi_bi_Vsbulk_si+(+T5_Vdi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsbulk_si))+(+T6_Vdi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsbulk_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsbulk_si)))))));
  T3_Vdi_bi_Vgi_bi=(+T4_Vdi_bi_Vgi_bi+(+T5_Vdi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgi_bi))+(+T6_Vdi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgi_bi)))))));
  T3_Vdi_bi_Vdi_bi=(+T4_Vdi_bi_Vdi_bi+(+T5_Vdi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdi_bi))+(+T6_Vdi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdi_bi)))))));
  T3_Vdi_bi_Vsi_bi=(+T4_Vdi_bi_Vsi_bi+(+T5_Vdi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsi_bi))+(+T6_Vdi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsi_bi)))))));
  T3_Vdi_bi_Tempt_GND=(+T4_Vdi_bi_Tempt_GND+(+T5_Vdi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Tempt_GND))+(+T6_Vdi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Tempt_GND*(1.25-T6)+T6_Vdi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Tempt_GND)))))));
#endif
T3_Vsi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsi_bi+((T5_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T4_Vsi_bi_Vgm_si+(+T5_Vsi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_si))+(+T6_Vsi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_si)))))));
  T3_Vsi_bi_Vgm_di=(+T4_Vsi_bi_Vgm_di+(+T5_Vsi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_di))+(+T6_Vsi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_di)))))));
  T3_Vsi_bi_Vdbulk_di=(+T4_Vsi_bi_Vdbulk_di+(+T5_Vsi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdbulk_di))+(+T6_Vsi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdbulk_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdbulk_di)))))));
  T3_Vsi_bi_Vsbulk_si=(+T4_Vsi_bi_Vsbulk_si+(+T5_Vsi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsbulk_si))+(+T6_Vsi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsbulk_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsbulk_si)))))));
  T3_Vsi_bi_Vgi_bi=(+T4_Vsi_bi_Vgi_bi+(+T5_Vsi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgi_bi))+(+T6_Vsi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgi_bi)))))));
  T3_Vsi_bi_Vdi_bi=(+T4_Vsi_bi_Vdi_bi+(+T5_Vsi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdi_bi))+(+T6_Vsi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdi_bi)))))));
  T3_Vsi_bi_Vsi_bi=(+T4_Vsi_bi_Vsi_bi+(+T5_Vsi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsi_bi))+(+T6_Vsi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsi_bi)))))));
  T3_Vsi_bi_Tempt_GND=(+T4_Vsi_bi_Tempt_GND+(+T5_Vsi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Tempt_GND))+(+T6_Vsi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Tempt_GND*(1.25-T6)+T6_Vsi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Tempt_GND)))))));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Tempt_GND+((T5_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Tempt_GND)+((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))));
#endif
#endif
T3=bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
EXIT_IF_ISNAN(bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
qsh_Vdbulk_di=((T3_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))));
#if defined(_DERIVATE2)
  qsh_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdbulk_di)-T8_Vdbulk_di_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)))));
  qsh_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsbulk_si)-T8_Vdbulk_di_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)))));
  qsh_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgi_bi)-T8_Vdbulk_di_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi)))));
  qsh_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdi_bi)-T8_Vdbulk_di_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi)))));
  qsh_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsi_bi)-T8_Vdbulk_di_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi)))));
  qsh_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Tempt_GND*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Tempt_GND)-T8_Vdbulk_di_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND)))));
#endif
qsh_Vsbulk_si=((T3_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))));
#if defined(_DERIVATE2)
  qsh_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdbulk_di)-T8_Vsbulk_si_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)))));
  qsh_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsbulk_si)-T8_Vsbulk_si_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)))));
  qsh_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgi_bi)-T8_Vsbulk_si_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi)))));
  qsh_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdi_bi)-T8_Vsbulk_si_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi)))));
  qsh_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsi_bi)-T8_Vsbulk_si_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi)))));
  qsh_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Tempt_GND*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Tempt_GND)-T8_Vsbulk_si_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND)))));
#endif
qsh_Vgi_bi=((T3_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))));
#if defined(_DERIVATE2)
  qsh_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdbulk_di)-T8_Vgi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di)))));
  qsh_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsbulk_si)-T8_Vgi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si)))));
  qsh_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgi_bi)-T8_Vgi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi)))));
  qsh_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdi_bi)-T8_Vgi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi)))));
  qsh_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsi_bi)-T8_Vgi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi)))));
  qsh_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Tempt_GND*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Tempt_GND)-T8_Vgi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND)))));
#endif
qsh_Vdi_bi=((T3_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))));
#if defined(_DERIVATE2)
  qsh_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdbulk_di)-T8_Vdi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di)))));
  qsh_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsbulk_si)-T8_Vdi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si)))));
  qsh_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgi_bi)-T8_Vdi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi)))));
  qsh_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdi_bi)-T8_Vdi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi)))));
  qsh_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsi_bi)-T8_Vdi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi)))));
  qsh_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Tempt_GND*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Tempt_GND)-T8_Vdi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND)))));
#endif
qsh_Vsi_bi=((T3_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))));
#if defined(_DERIVATE2)
  qsh_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdbulk_di)-T8_Vsi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di)))));
  qsh_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsbulk_si)-T8_Vsi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si)))));
  qsh_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgi_bi)-T8_Vsi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi)))));
  qsh_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdi_bi)-T8_Vsi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi)))));
  qsh_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsi_bi)-T8_Vsi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi)))));
  qsh_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Tempt_GND*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Tempt_GND)-T8_Vsi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND)))));
#endif
#if defined(_DERIVATE)
qsh_Tempt_GND=((T3_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))));
#endif
#endif
qsh=(T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
EXIT_IF_ISNAN((T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsisainv_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_di_Vgm_di=0.0;
  sqrtpsisainv_Vgm_di_Vgm_si=0.0;
  sqrtpsisainv_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_di_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_si_Vgm_di=0.0;
  sqrtpsisainv_Vgm_si_Vgm_si=0.0;
  sqrtpsisainv_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_si_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vdbulk_di=(-sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdbulk_di_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsbulk_si=(-sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsbulk_si_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vgi_bi=(-sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vdi_bi=(-sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsi_bi=(-sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
#if defined(_DERIVATE)
sqrtpsisainv_Tempt_GND=(-sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa);
#endif
#endif
sqrtpsisainv=(1.0/sqrtpsisa);
EXIT_IF_ISNAN((1.0/sqrtpsisa))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=(T3_Vdbulk_di-((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si-(T4_Vdbulk_di_Vgm_si/T5-(T4_Vdbulk_di*T5_Vgm_si+T4_Vgm_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5));
  T3_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di-(T4_Vdbulk_di_Vgm_di/T5-(T4_Vdbulk_di*T5_Vgm_di+T4_Vgm_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5));
  T3_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5));
  T3_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsbulk_si=(T3_Vsbulk_si-((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si-(T4_Vsbulk_si_Vgm_si/T5-(T4_Vsbulk_si*T5_Vgm_si+T4_Vgm_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5));
  T3_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di-(T4_Vsbulk_si_Vgm_di/T5-(T4_Vsbulk_si*T5_Vgm_di+T4_Vgm_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5));
  T3_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5));
  T3_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vgi_bi=(T3_Vgi_bi-((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vdi_bi=(T3_Vdi_bi-((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsi_bi=(T3_Vsi_bi-((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T3_Tempt_GND-((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5));
#endif
#endif
T3=(T3-(T4/T5));
EXIT_IF_ISNAN((T3-(T4/T5)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=(((((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgm_si=(+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdbulk_di=(+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsbulk_si=(+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgi_bi=(+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdi_bi=(+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsi_bi=(+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Tempt_GND=(+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsbulk_si=(((((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vgi_bi=(((((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vdi_bi=(((((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsi_bi=(((((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#endif
#endif
T6=(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN((((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=(((-(((-T3_Vdbulk_di/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdbulk_di/T3/T3))))-(-((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di);
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_si);
  T7_Vdbulk_di_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_di);
  T7_Vdbulk_di_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdbulk_di);
  T7_Vdbulk_di_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsbulk_si);
  T7_Vdbulk_di_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgi_bi);
  T7_Vdbulk_di_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdi_bi);
  T7_Vdbulk_di_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsi_bi);
  T7_Vdbulk_di_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Tempt_GND);
#endif
T7_Vsbulk_si=(((-(((-T3_Vsbulk_si/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsbulk_si/T3/T3))))-(-((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si);
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_si);
  T7_Vsbulk_si_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_di);
  T7_Vsbulk_si_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdbulk_di);
  T7_Vsbulk_si_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsbulk_si);
  T7_Vsbulk_si_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgi_bi);
  T7_Vsbulk_si_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdi_bi);
  T7_Vsbulk_si_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsi_bi);
  T7_Vsbulk_si_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Tempt_GND);
#endif
T7_Vgi_bi=(((-(((-T3_Vgi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgi_bi/T3/T3))))-(-((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi);
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_si);
  T7_Vgi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_di);
  T7_Vgi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdbulk_di);
  T7_Vgi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsbulk_si);
  T7_Vgi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgi_bi);
  T7_Vgi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdi_bi);
  T7_Vgi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsi_bi);
  T7_Vgi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Tempt_GND);
#endif
T7_Vdi_bi=(((-(((-T3_Vdi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdi_bi/T3/T3))))-(-((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi);
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_si);
  T7_Vdi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_di);
  T7_Vdi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdbulk_di);
  T7_Vdi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsbulk_si);
  T7_Vdi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgi_bi);
  T7_Vdi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdi_bi);
  T7_Vdi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsi_bi);
  T7_Vdi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Tempt_GND);
#endif
T7_Vsi_bi=(((-(((-T3_Vsi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsi_bi/T3/T3))))-(-((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi);
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_si);
  T7_Vsi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_di);
  T7_Vsi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdbulk_di);
  T7_Vsi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsbulk_si);
  T7_Vsi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgi_bi);
  T7_Vsi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdi_bi);
  T7_Vsi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsi_bi);
  T7_Vsi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(((-(((-T3_Tempt_GND/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Tempt_GND/T3/T3))))-(-((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Tempt_GND);
#endif
#endif
T7=(((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
EXIT_IF_ISNAN((((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
qsh_Vdbulk_di=(T3_Vdbulk_di-((((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qsh_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(+(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdbulk_di*T7+T4_Vdbulk_di*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdbulk_di)*T5+(2.0*T5_Vdbulk_di)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(+(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsbulk_si*T7+T4_Vdbulk_di*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsbulk_si)*T5+(2.0*T5_Vdbulk_di)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(+(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgi_bi*T7+T4_Vdbulk_di*T7_Vgi_bi+T4_Vgi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(+(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdi_bi*T7+T4_Vdbulk_di*T7_Vdi_bi+T4_Vdi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(+(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsi_bi*T7+T4_Vdbulk_di*T7_Vsi_bi+T4_Vsi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(+(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Tempt_GND*T7+T4_Vdbulk_di*T7_Tempt_GND+T4_Tempt_GND*T7_Vdbulk_di+T4*T7_Vdbulk_di_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Tempt_GND)*T5+(2.0*T5_Vdbulk_di)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qsh_Vsbulk_si=(T3_Vsbulk_si-((((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qsh_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(+(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdbulk_di*T7+T4_Vsbulk_si*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdbulk_di)*T5+(2.0*T5_Vsbulk_si)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(+(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsbulk_si*T7+T4_Vsbulk_si*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsbulk_si)*T5+(2.0*T5_Vsbulk_si)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(+(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgi_bi*T7+T4_Vsbulk_si*T7_Vgi_bi+T4_Vgi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(+(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdi_bi*T7+T4_Vsbulk_si*T7_Vdi_bi+T4_Vdi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(+(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsi_bi*T7+T4_Vsbulk_si*T7_Vsi_bi+T4_Vsi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(+(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Tempt_GND*T7+T4_Vsbulk_si*T7_Tempt_GND+T4_Tempt_GND*T7_Vsbulk_si+T4*T7_Vsbulk_si_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Tempt_GND)*T5+(2.0*T5_Vsbulk_si)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qsh_Vgi_bi=(T3_Vgi_bi-((((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qsh_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(+(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdbulk_di*T7+T4_Vgi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdbulk_di)*T5+(2.0*T5_Vgi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(+(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsbulk_si*T7+T4_Vgi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsbulk_si)*T5+(2.0*T5_Vgi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(+(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgi_bi*T7+T4_Vgi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(+(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdi_bi*T7+T4_Vgi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(+(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsi_bi*T7+T4_Vgi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(+(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Tempt_GND*T7+T4_Vgi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vgi_bi+T4*T7_Vgi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Tempt_GND)*T5+(2.0*T5_Vgi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qsh_Vdi_bi=(T3_Vdi_bi-((((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qsh_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(+(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdbulk_di*T7+T4_Vdi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdbulk_di)*T5+(2.0*T5_Vdi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(+(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsbulk_si*T7+T4_Vdi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsbulk_si)*T5+(2.0*T5_Vdi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(+(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgi_bi*T7+T4_Vdi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(+(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdi_bi*T7+T4_Vdi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(+(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsi_bi*T7+T4_Vdi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(+(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Tempt_GND*T7+T4_Vdi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vdi_bi+T4*T7_Vdi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Tempt_GND)*T5+(2.0*T5_Vdi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qsh_Vsi_bi=(T3_Vsi_bi-((((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qsh_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(+(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdbulk_di*T7+T4_Vsi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdbulk_di)*T5+(2.0*T5_Vsi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(+(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsbulk_si*T7+T4_Vsi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsbulk_si)*T5+(2.0*T5_Vsi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(+(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgi_bi*T7+T4_Vsi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(+(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdi_bi*T7+T4_Vsi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(+(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsi_bi*T7+T4_Vsi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qsh_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(+(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Tempt_GND*T7+T4_Vsi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vsi_bi+T4*T7_Vsi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Tempt_GND)*T5+(2.0*T5_Vsi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#if defined(_DERIVATE)
qsh_Tempt_GND=(T3_Tempt_GND-((((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Tempt_GND)*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#endif
qsh=(T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
EXIT_IF_ISNAN((T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))))
}
{
double m00_sqrt(d00_sqrt0,psiph)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,psiph)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
nq_h_Tempt_GND=((gam_h_Tempt_GND*(2.0*d00_sqrt0)-gam_h*(2.0*psiph_Tempt_GND*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0));
#endif
nq_h_Vdbulk_di=(-gam_h*(2.0*psiph_Vdbulk_di*d10_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0));
#if defined(_DERIVATE2)
  nq_h_Vdbulk_di_Tempt_GND=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Tempt_GND*d10_sqrt0))+gam_h_Tempt_GND*(2.0*psiph_Vdbulk_di*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Tempt_GND*d10_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Tempt_GND*psiph_Vdbulk_di+d10_sqrt0*psiph_Vdbulk_di_Tempt_GND)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdbulk_di*d10_sqrt0)*((2.0*psiph_Tempt_GND*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdbulk_di_Vdbulk_di=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdbulk_di*d10_sqrt0))+0.0*(2.0*psiph_Vdbulk_di*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdbulk_di*psiph_Vdbulk_di+d10_sqrt0*psiph_Vdbulk_di_Vdbulk_di)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdbulk_di*d10_sqrt0)*((2.0*psiph_Vdbulk_di*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdbulk_di_Vsbulk_si=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsbulk_si*d10_sqrt0))+0.0*(2.0*psiph_Vdbulk_di*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsbulk_si*psiph_Vdbulk_di+d10_sqrt0*psiph_Vdbulk_di_Vsbulk_si)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdbulk_di*d10_sqrt0)*((2.0*psiph_Vsbulk_si*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdbulk_di_Vgi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vgi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vdbulk_di*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vgi_bi*psiph_Vdbulk_di+d10_sqrt0*psiph_Vdbulk_di_Vgi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdbulk_di*d10_sqrt0)*((2.0*psiph_Vgi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdbulk_di_Vdi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vdbulk_di*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdi_bi*psiph_Vdbulk_di+d10_sqrt0*psiph_Vdbulk_di_Vdi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdbulk_di*d10_sqrt0)*((2.0*psiph_Vdi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdbulk_di_Vsi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vdbulk_di*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsi_bi*psiph_Vdbulk_di+d10_sqrt0*psiph_Vdbulk_di_Vsi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdbulk_di*d10_sqrt0)*((2.0*psiph_Vsi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
#endif
nq_h_Vsbulk_si=(-gam_h*(2.0*psiph_Vsbulk_si*d10_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0));
#if defined(_DERIVATE2)
  nq_h_Vsbulk_si_Tempt_GND=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Tempt_GND*d10_sqrt0))+gam_h_Tempt_GND*(2.0*psiph_Vsbulk_si*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Tempt_GND*d10_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Tempt_GND*psiph_Vsbulk_si+d10_sqrt0*psiph_Vsbulk_si_Tempt_GND)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsbulk_si*d10_sqrt0)*((2.0*psiph_Tempt_GND*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsbulk_si_Vdbulk_di=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdbulk_di*d10_sqrt0))+0.0*(2.0*psiph_Vsbulk_si*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdbulk_di*psiph_Vsbulk_si+d10_sqrt0*psiph_Vsbulk_si_Vdbulk_di)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsbulk_si*d10_sqrt0)*((2.0*psiph_Vdbulk_di*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsbulk_si_Vsbulk_si=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsbulk_si*d10_sqrt0))+0.0*(2.0*psiph_Vsbulk_si*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsbulk_si*psiph_Vsbulk_si+d10_sqrt0*psiph_Vsbulk_si_Vsbulk_si)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsbulk_si*d10_sqrt0)*((2.0*psiph_Vsbulk_si*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsbulk_si_Vgi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vgi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vsbulk_si*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vgi_bi*psiph_Vsbulk_si+d10_sqrt0*psiph_Vsbulk_si_Vgi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsbulk_si*d10_sqrt0)*((2.0*psiph_Vgi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsbulk_si_Vdi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vsbulk_si*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdi_bi*psiph_Vsbulk_si+d10_sqrt0*psiph_Vsbulk_si_Vdi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsbulk_si*d10_sqrt0)*((2.0*psiph_Vdi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsbulk_si_Vsi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vsbulk_si*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsi_bi*psiph_Vsbulk_si+d10_sqrt0*psiph_Vsbulk_si_Vsi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsbulk_si*d10_sqrt0)*((2.0*psiph_Vsi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
#endif
nq_h_Vgi_bi=(-gam_h*(2.0*psiph_Vgi_bi*d10_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0));
#if defined(_DERIVATE2)
  nq_h_Vgi_bi_Tempt_GND=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Tempt_GND*d10_sqrt0))+gam_h_Tempt_GND*(2.0*psiph_Vgi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Tempt_GND*d10_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Tempt_GND*psiph_Vgi_bi+d10_sqrt0*psiph_Vgi_bi_Tempt_GND)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vgi_bi*d10_sqrt0)*((2.0*psiph_Tempt_GND*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vgi_bi_Vdbulk_di=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdbulk_di*d10_sqrt0))+0.0*(2.0*psiph_Vgi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdbulk_di*psiph_Vgi_bi+d10_sqrt0*psiph_Vgi_bi_Vdbulk_di)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vgi_bi*d10_sqrt0)*((2.0*psiph_Vdbulk_di*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vgi_bi_Vsbulk_si=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsbulk_si*d10_sqrt0))+0.0*(2.0*psiph_Vgi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsbulk_si*psiph_Vgi_bi+d10_sqrt0*psiph_Vgi_bi_Vsbulk_si)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vgi_bi*d10_sqrt0)*((2.0*psiph_Vsbulk_si*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vgi_bi_Vgi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vgi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vgi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vgi_bi*psiph_Vgi_bi+d10_sqrt0*psiph_Vgi_bi_Vgi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vgi_bi*d10_sqrt0)*((2.0*psiph_Vgi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vgi_bi_Vdi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vgi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdi_bi*psiph_Vgi_bi+d10_sqrt0*psiph_Vgi_bi_Vdi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vgi_bi*d10_sqrt0)*((2.0*psiph_Vdi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vgi_bi_Vsi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vgi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsi_bi*psiph_Vgi_bi+d10_sqrt0*psiph_Vgi_bi_Vsi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vgi_bi*d10_sqrt0)*((2.0*psiph_Vsi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
#endif
nq_h_Vdi_bi=(-gam_h*(2.0*psiph_Vdi_bi*d10_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0));
#if defined(_DERIVATE2)
  nq_h_Vdi_bi_Tempt_GND=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Tempt_GND*d10_sqrt0))+gam_h_Tempt_GND*(2.0*psiph_Vdi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Tempt_GND*d10_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Tempt_GND*psiph_Vdi_bi+d10_sqrt0*psiph_Vdi_bi_Tempt_GND)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdi_bi*d10_sqrt0)*((2.0*psiph_Tempt_GND*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdi_bi_Vdbulk_di=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdbulk_di*d10_sqrt0))+0.0*(2.0*psiph_Vdi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdbulk_di*psiph_Vdi_bi+d10_sqrt0*psiph_Vdi_bi_Vdbulk_di)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdi_bi*d10_sqrt0)*((2.0*psiph_Vdbulk_di*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdi_bi_Vsbulk_si=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsbulk_si*d10_sqrt0))+0.0*(2.0*psiph_Vdi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsbulk_si*psiph_Vdi_bi+d10_sqrt0*psiph_Vdi_bi_Vsbulk_si)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdi_bi*d10_sqrt0)*((2.0*psiph_Vsbulk_si*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdi_bi_Vgi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vgi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vdi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vgi_bi*psiph_Vdi_bi+d10_sqrt0*psiph_Vdi_bi_Vgi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdi_bi*d10_sqrt0)*((2.0*psiph_Vgi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdi_bi_Vdi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vdi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdi_bi*psiph_Vdi_bi+d10_sqrt0*psiph_Vdi_bi_Vdi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdi_bi*d10_sqrt0)*((2.0*psiph_Vdi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vdi_bi_Vsi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vdi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsi_bi*psiph_Vdi_bi+d10_sqrt0*psiph_Vdi_bi_Vsi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vdi_bi*d10_sqrt0)*((2.0*psiph_Vsi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
#endif
nq_h_Vsi_bi=(-gam_h*(2.0*psiph_Vsi_bi*d10_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0));
#if defined(_DERIVATE2)
  nq_h_Vsi_bi_Tempt_GND=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Tempt_GND*d10_sqrt0))+gam_h_Tempt_GND*(2.0*psiph_Vsi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Tempt_GND*d10_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Tempt_GND*psiph_Vsi_bi+d10_sqrt0*psiph_Vsi_bi_Tempt_GND)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsi_bi*d10_sqrt0)*((2.0*psiph_Tempt_GND*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsi_bi_Vdbulk_di=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdbulk_di*d10_sqrt0))+0.0*(2.0*psiph_Vsi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdbulk_di*d10_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdbulk_di*psiph_Vsi_bi+d10_sqrt0*psiph_Vsi_bi_Vdbulk_di)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsi_bi*d10_sqrt0)*((2.0*psiph_Vdbulk_di*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsi_bi_Vsbulk_si=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsbulk_si*d10_sqrt0))+0.0*(2.0*psiph_Vsi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsbulk_si*d10_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsbulk_si*psiph_Vsi_bi+d10_sqrt0*psiph_Vsi_bi_Vsbulk_si)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsi_bi*d10_sqrt0)*((2.0*psiph_Vsbulk_si*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsi_bi_Vgi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vgi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vsi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vgi_bi*d10_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vgi_bi*psiph_Vsi_bi+d10_sqrt0*psiph_Vsi_bi_Vgi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsi_bi*d10_sqrt0)*((2.0*psiph_Vgi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsi_bi_Vdi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vdi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vsi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vdi_bi*d10_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vdi_bi*psiph_Vsi_bi+d10_sqrt0*psiph_Vsi_bi_Vdi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsi_bi*d10_sqrt0)*((2.0*psiph_Vdi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
  nq_h_Vsi_bi_Vsi_bi=(+0.0+(0.0/(2.0*d00_sqrt0)-(0.0*((2.0*psiph_Vsi_bi*d10_sqrt0))+0.0*(2.0*psiph_Vsi_bi*d10_sqrt0)+gam_h*(+0.0*d00_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+0.0*psiph_Vsi_bi*d10_sqrt0+2.0*(m20_sqrt(psiph)*psiph_Vsi_bi*psiph_Vsi_bi+d10_sqrt0*psiph_Vsi_bi_Vsi_bi)))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)+2*gam_h*(2.0*psiph_Vsi_bi*d10_sqrt0)*((2.0*psiph_Vsi_bi*d10_sqrt0))/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)/(2.0*d00_sqrt0)));
#endif
#endif
nq_h=(1.0+(gam_h/(2.0*d00_sqrt0)));
EXIT_IF_ISNAN((1.0+(gam_h/(2.0*d00_sqrt0))))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
U0_i_h_Tempt_GND=ueff_Tempt_GND;
#endif
U0_i_h_Vdi_bi=ueff_Vdi_bi;
#if defined(_DERIVATE2)
  U0_i_h_Vdi_bi_Tempt_GND=ueff_Vdi_bi_Tempt_GND;
  U0_i_h_Vdi_bi_Vdi_bi=ueff_Vdi_bi_Vdi_bi;
  U0_i_h_Vdi_bi_Vsi_bi=ueff_Vdi_bi_Vsi_bi;
  U0_i_h_Vdi_bi_Vgi_bi=ueff_Vdi_bi_Vgi_bi;
#endif
U0_i_h_Vsi_bi=ueff_Vsi_bi;
#if defined(_DERIVATE2)
  U0_i_h_Vsi_bi_Tempt_GND=ueff_Vsi_bi_Tempt_GND;
  U0_i_h_Vsi_bi_Vdi_bi=ueff_Vsi_bi_Vdi_bi;
  U0_i_h_Vsi_bi_Vsi_bi=ueff_Vsi_bi_Vsi_bi;
  U0_i_h_Vsi_bi_Vgi_bi=ueff_Vsi_bi_Vgi_bi;
#endif
U0_i_h_Vgi_bi=ueff_Vgi_bi;
#if defined(_DERIVATE2)
  U0_i_h_Vgi_bi_Tempt_GND=ueff_Vgi_bi_Tempt_GND;
  U0_i_h_Vgi_bi_Vdi_bi=ueff_Vgi_bi_Vdi_bi;
  U0_i_h_Vgi_bi_Vsi_bi=ueff_Vgi_bi_Vsi_bi;
  U0_i_h_Vgi_bi_Vgi_bi=ueff_Vgi_bi_Vgi_bi;
#endif
#endif
U0_i_h=ueff;
EXIT_IF_ISNAN(ueff)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
beta_h_Tempt_GND=U0_i_h_Tempt_GND*Cox*Weff;
#endif
beta_h_Vdi_bi=U0_i_h_Vdi_bi*Cox*Weff;
#if defined(_DERIVATE2)
  beta_h_Vdi_bi_Tempt_GND=(+(+U0_i_h_Vdi_bi_Tempt_GND*Cox+U0_i_h_Vdi_bi*0.0+U0_i_h_Tempt_GND*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vdi_bi*Cox*0.0+(U0_i_h_Tempt_GND*Cox)*0.0+(U0_i_h*Cox)*0.0);
  beta_h_Vdi_bi_Vdi_bi=(+(+U0_i_h_Vdi_bi_Vdi_bi*Cox+U0_i_h_Vdi_bi*0.0+U0_i_h_Vdi_bi*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vdi_bi*Cox*0.0+(U0_i_h_Vdi_bi*Cox)*0.0+(U0_i_h*Cox)*0.0);
  beta_h_Vdi_bi_Vsi_bi=(+(+U0_i_h_Vdi_bi_Vsi_bi*Cox+U0_i_h_Vdi_bi*0.0+U0_i_h_Vsi_bi*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vdi_bi*Cox*0.0+(U0_i_h_Vsi_bi*Cox)*0.0+(U0_i_h*Cox)*0.0);
  beta_h_Vdi_bi_Vgi_bi=(+(+U0_i_h_Vdi_bi_Vgi_bi*Cox+U0_i_h_Vdi_bi*0.0+U0_i_h_Vgi_bi*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vdi_bi*Cox*0.0+(U0_i_h_Vgi_bi*Cox)*0.0+(U0_i_h*Cox)*0.0);
#endif
beta_h_Vsi_bi=U0_i_h_Vsi_bi*Cox*Weff;
#if defined(_DERIVATE2)
  beta_h_Vsi_bi_Tempt_GND=(+(+U0_i_h_Vsi_bi_Tempt_GND*Cox+U0_i_h_Vsi_bi*0.0+U0_i_h_Tempt_GND*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vsi_bi*Cox*0.0+(U0_i_h_Tempt_GND*Cox)*0.0+(U0_i_h*Cox)*0.0);
  beta_h_Vsi_bi_Vdi_bi=(+(+U0_i_h_Vsi_bi_Vdi_bi*Cox+U0_i_h_Vsi_bi*0.0+U0_i_h_Vdi_bi*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vsi_bi*Cox*0.0+(U0_i_h_Vdi_bi*Cox)*0.0+(U0_i_h*Cox)*0.0);
  beta_h_Vsi_bi_Vsi_bi=(+(+U0_i_h_Vsi_bi_Vsi_bi*Cox+U0_i_h_Vsi_bi*0.0+U0_i_h_Vsi_bi*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vsi_bi*Cox*0.0+(U0_i_h_Vsi_bi*Cox)*0.0+(U0_i_h*Cox)*0.0);
  beta_h_Vsi_bi_Vgi_bi=(+(+U0_i_h_Vsi_bi_Vgi_bi*Cox+U0_i_h_Vsi_bi*0.0+U0_i_h_Vgi_bi*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vsi_bi*Cox*0.0+(U0_i_h_Vgi_bi*Cox)*0.0+(U0_i_h*Cox)*0.0);
#endif
beta_h_Vgi_bi=U0_i_h_Vgi_bi*Cox*Weff;
#if defined(_DERIVATE2)
  beta_h_Vgi_bi_Tempt_GND=(+(+U0_i_h_Vgi_bi_Tempt_GND*Cox+U0_i_h_Vgi_bi*0.0+U0_i_h_Tempt_GND*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vgi_bi*Cox*0.0+(U0_i_h_Tempt_GND*Cox)*0.0+(U0_i_h*Cox)*0.0);
  beta_h_Vgi_bi_Vdi_bi=(+(+U0_i_h_Vgi_bi_Vdi_bi*Cox+U0_i_h_Vgi_bi*0.0+U0_i_h_Vdi_bi*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vgi_bi*Cox*0.0+(U0_i_h_Vdi_bi*Cox)*0.0+(U0_i_h*Cox)*0.0);
  beta_h_Vgi_bi_Vsi_bi=(+(+U0_i_h_Vgi_bi_Vsi_bi*Cox+U0_i_h_Vgi_bi*0.0+U0_i_h_Vsi_bi*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vgi_bi*Cox*0.0+(U0_i_h_Vsi_bi*Cox)*0.0+(U0_i_h*Cox)*0.0);
  beta_h_Vgi_bi_Vgi_bi=(+(+U0_i_h_Vgi_bi_Vgi_bi*Cox+U0_i_h_Vgi_bi*0.0+U0_i_h_Vgi_bi*0.0+U0_i_h*0.0)*Weff+U0_i_h_Vgi_bi*Cox*0.0+(U0_i_h_Vgi_bi*Cox)*0.0+(U0_i_h*Cox)*0.0);
#endif
#endif
beta_h=((U0_i_h*Cox)*Weff);
EXIT_IF_ISNAN(((U0_i_h*Cox)*Weff))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
#if defined(_DERIVATE)
beta_ch_Tempt_GND=ueff_Tempt_GND*Cox*Weff;
#endif
beta_ch_Vdi_bi=ueff_Vdi_bi*Cox*Weff;
#if defined(_DERIVATE2)
  beta_ch_Vdi_bi_Tempt_GND=(+(+ueff_Vdi_bi_Tempt_GND*Cox+ueff_Vdi_bi*0.0+ueff_Tempt_GND*0.0+ueff*0.0)*Weff+ueff_Vdi_bi*Cox*0.0+(ueff_Tempt_GND*Cox)*0.0+(ueff*Cox)*0.0);
  beta_ch_Vdi_bi_Vdi_bi=(+(+ueff_Vdi_bi_Vdi_bi*Cox+ueff_Vdi_bi*0.0+ueff_Vdi_bi*0.0+ueff*0.0)*Weff+ueff_Vdi_bi*Cox*0.0+(ueff_Vdi_bi*Cox)*0.0+(ueff*Cox)*0.0);
  beta_ch_Vdi_bi_Vsi_bi=(+(+ueff_Vdi_bi_Vsi_bi*Cox+ueff_Vdi_bi*0.0+ueff_Vsi_bi*0.0+ueff*0.0)*Weff+ueff_Vdi_bi*Cox*0.0+(ueff_Vsi_bi*Cox)*0.0+(ueff*Cox)*0.0);
  beta_ch_Vdi_bi_Vgi_bi=(+(+ueff_Vdi_bi_Vgi_bi*Cox+ueff_Vdi_bi*0.0+ueff_Vgi_bi*0.0+ueff*0.0)*Weff+ueff_Vdi_bi*Cox*0.0+(ueff_Vgi_bi*Cox)*0.0+(ueff*Cox)*0.0);
#endif
beta_ch_Vsi_bi=ueff_Vsi_bi*Cox*Weff;
#if defined(_DERIVATE2)
  beta_ch_Vsi_bi_Tempt_GND=(+(+ueff_Vsi_bi_Tempt_GND*Cox+ueff_Vsi_bi*0.0+ueff_Tempt_GND*0.0+ueff*0.0)*Weff+ueff_Vsi_bi*Cox*0.0+(ueff_Tempt_GND*Cox)*0.0+(ueff*Cox)*0.0);
  beta_ch_Vsi_bi_Vdi_bi=(+(+ueff_Vsi_bi_Vdi_bi*Cox+ueff_Vsi_bi*0.0+ueff_Vdi_bi*0.0+ueff*0.0)*Weff+ueff_Vsi_bi*Cox*0.0+(ueff_Vdi_bi*Cox)*0.0+(ueff*Cox)*0.0);
  beta_ch_Vsi_bi_Vsi_bi=(+(+ueff_Vsi_bi_Vsi_bi*Cox+ueff_Vsi_bi*0.0+ueff_Vsi_bi*0.0+ueff*0.0)*Weff+ueff_Vsi_bi*Cox*0.0+(ueff_Vsi_bi*Cox)*0.0+(ueff*Cox)*0.0);
  beta_ch_Vsi_bi_Vgi_bi=(+(+ueff_Vsi_bi_Vgi_bi*Cox+ueff_Vsi_bi*0.0+ueff_Vgi_bi*0.0+ueff*0.0)*Weff+ueff_Vsi_bi*Cox*0.0+(ueff_Vgi_bi*Cox)*0.0+(ueff*Cox)*0.0);
#endif
beta_ch_Vgi_bi=ueff_Vgi_bi*Cox*Weff;
#if defined(_DERIVATE2)
  beta_ch_Vgi_bi_Tempt_GND=(+(+ueff_Vgi_bi_Tempt_GND*Cox+ueff_Vgi_bi*0.0+ueff_Tempt_GND*0.0+ueff*0.0)*Weff+ueff_Vgi_bi*Cox*0.0+(ueff_Tempt_GND*Cox)*0.0+(ueff*Cox)*0.0);
  beta_ch_Vgi_bi_Vdi_bi=(+(+ueff_Vgi_bi_Vdi_bi*Cox+ueff_Vgi_bi*0.0+ueff_Vdi_bi*0.0+ueff*0.0)*Weff+ueff_Vgi_bi*Cox*0.0+(ueff_Vdi_bi*Cox)*0.0+(ueff*Cox)*0.0);
  beta_ch_Vgi_bi_Vsi_bi=(+(+ueff_Vgi_bi_Vsi_bi*Cox+ueff_Vgi_bi*0.0+ueff_Vsi_bi*0.0+ueff*0.0)*Weff+ueff_Vgi_bi*Cox*0.0+(ueff_Vsi_bi*Cox)*0.0+(ueff*Cox)*0.0);
  beta_ch_Vgi_bi_Vgi_bi=(+(+ueff_Vgi_bi_Vgi_bi*Cox+ueff_Vgi_bi*0.0+ueff_Vgi_bi*0.0+ueff*0.0)*Weff+ueff_Vgi_bi*Cox*0.0+(ueff_Vgi_bi*Cox)*0.0+(ueff*Cox)*0.0);
#endif
#endif
beta_ch=((ueff*Cox)*Weff);
EXIT_IF_ISNAN(((ueff*Cox)*Weff))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
i1_Vgi_bi=((ids_Vgi_bi*pModel->LH*((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#if defined(_DERIVATE2)
  i1_Vgi_bi_Vgi_bi=((+ids_Vgi_bi_Vgi_bi*pModel->LH+ids_Vgi_bi*0.0+ids_Vgi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vgi_bi*pModel->LH*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)+(ids_Vgi_bi*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vgi_bi+0.0*nq_h_Vgi_bi+2.0*nq_h_Vgi_bi_Vgi_bi)*beta_h+(2.0*nq_h_Vgi_bi)*beta_h_Vgi_bi+((2.0*nq_h_Vgi_bi))*beta_h_Vgi_bi+(2.0*nq_h)*beta_h_Vgi_bi_Vgi_bi)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*0.0+(((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*0.0+((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vgi_bi_Tempt_GND=((+ids_Vgi_bi_Tempt_GND*pModel->LH+ids_Vgi_bi*0.0+ids_Tempt_GND*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vgi_bi*pModel->LH*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))+(ids_Tempt_GND*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Tempt_GND+0.0*nq_h_Vgi_bi+2.0*nq_h_Vgi_bi_Tempt_GND)*beta_h+(2.0*nq_h_Vgi_bi)*beta_h_Tempt_GND+((2.0*nq_h_Tempt_GND))*beta_h_Vgi_bi+(2.0*nq_h)*beta_h_Vgi_bi_Tempt_GND)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt_Tempt_GND+(((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt_Tempt_GND+((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vgi_bi_Vdi_bi=((+ids_Vgi_bi_Vdi_bi*pModel->LH+ids_Vgi_bi*0.0+ids_Vdi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vgi_bi*pModel->LH*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)+(ids_Vdi_bi*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdi_bi+0.0*nq_h_Vgi_bi+2.0*nq_h_Vgi_bi_Vdi_bi)*beta_h+(2.0*nq_h_Vgi_bi)*beta_h_Vdi_bi+((2.0*nq_h_Vdi_bi))*beta_h_Vgi_bi+(2.0*nq_h)*beta_h_Vgi_bi_Vdi_bi)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*0.0+(((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*0.0+((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vgi_bi_Vsi_bi=((+ids_Vgi_bi_Vsi_bi*pModel->LH+ids_Vgi_bi*0.0+ids_Vsi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vgi_bi*pModel->LH*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)+(ids_Vsi_bi*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsi_bi+0.0*nq_h_Vgi_bi+2.0*nq_h_Vgi_bi_Vsi_bi)*beta_h+(2.0*nq_h_Vgi_bi)*beta_h_Vsi_bi+((2.0*nq_h_Vsi_bi))*beta_h_Vgi_bi+(2.0*nq_h)*beta_h_Vgi_bi_Vsi_bi)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*0.0+(((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*0.0+((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vgi_bi_Vdbulk_di=((+ids_Vgi_bi_Vdbulk_di*pModel->LH+ids_Vgi_bi*0.0+ids_Vdbulk_di*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vgi_bi*pModel->LH*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)+(ids_Vdbulk_di*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdbulk_di+0.0*nq_h_Vgi_bi+2.0*nq_h_Vgi_bi_Vdbulk_di)*beta_h+(2.0*nq_h_Vgi_bi)*0.0+((2.0*nq_h_Vdbulk_di))*beta_h_Vgi_bi+(2.0*nq_h)*0.0)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*0.0+(((2.0*nq_h_Vdbulk_di))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*0.0+((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vgi_bi_Vsbulk_si=((+ids_Vgi_bi_Vsbulk_si*pModel->LH+ids_Vgi_bi*0.0+ids_Vsbulk_si*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vgi_bi*pModel->LH*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)+(ids_Vsbulk_si*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsbulk_si+0.0*nq_h_Vgi_bi+2.0*nq_h_Vgi_bi_Vsbulk_si)*beta_h+(2.0*nq_h_Vgi_bi)*0.0+((2.0*nq_h_Vsbulk_si))*beta_h_Vgi_bi+(2.0*nq_h)*0.0)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*0.0+(((2.0*nq_h_Vsbulk_si))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*0.0+((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*Vt*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#endif
#if defined(_DERIVATE)
i1_Tempt_GND=((ids_Tempt_GND*pModel->LH*((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids*pModel->LH)*(((((((2.0*nq_h_Tempt_GND)*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#endif
i1_Vdi_bi=((ids_Vdi_bi*pModel->LH*((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#if defined(_DERIVATE2)
  i1_Vdi_bi_Vgi_bi=((+ids_Vdi_bi_Vgi_bi*pModel->LH+ids_Vdi_bi*0.0+ids_Vgi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdi_bi*pModel->LH*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)+(ids_Vgi_bi*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vgi_bi+0.0*nq_h_Vdi_bi+2.0*nq_h_Vdi_bi_Vgi_bi)*beta_h+(2.0*nq_h_Vdi_bi)*beta_h_Vgi_bi+((2.0*nq_h_Vgi_bi))*beta_h_Vdi_bi+(2.0*nq_h)*beta_h_Vdi_bi_Vgi_bi)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*0.0+(((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*0.0+((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdi_bi_Tempt_GND=((+ids_Vdi_bi_Tempt_GND*pModel->LH+ids_Vdi_bi*0.0+ids_Tempt_GND*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdi_bi*pModel->LH*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))+(ids_Tempt_GND*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Tempt_GND+0.0*nq_h_Vdi_bi+2.0*nq_h_Vdi_bi_Tempt_GND)*beta_h+(2.0*nq_h_Vdi_bi)*beta_h_Tempt_GND+((2.0*nq_h_Tempt_GND))*beta_h_Vdi_bi+(2.0*nq_h)*beta_h_Vdi_bi_Tempt_GND)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt_Tempt_GND+(((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt_Tempt_GND+((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdi_bi_Vdi_bi=((+ids_Vdi_bi_Vdi_bi*pModel->LH+ids_Vdi_bi*0.0+ids_Vdi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdi_bi*pModel->LH*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)+(ids_Vdi_bi*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdi_bi+0.0*nq_h_Vdi_bi+2.0*nq_h_Vdi_bi_Vdi_bi)*beta_h+(2.0*nq_h_Vdi_bi)*beta_h_Vdi_bi+((2.0*nq_h_Vdi_bi))*beta_h_Vdi_bi+(2.0*nq_h)*beta_h_Vdi_bi_Vdi_bi)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*0.0+(((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*0.0+((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdi_bi_Vsi_bi=((+ids_Vdi_bi_Vsi_bi*pModel->LH+ids_Vdi_bi*0.0+ids_Vsi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdi_bi*pModel->LH*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)+(ids_Vsi_bi*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsi_bi+0.0*nq_h_Vdi_bi+2.0*nq_h_Vdi_bi_Vsi_bi)*beta_h+(2.0*nq_h_Vdi_bi)*beta_h_Vsi_bi+((2.0*nq_h_Vsi_bi))*beta_h_Vdi_bi+(2.0*nq_h)*beta_h_Vdi_bi_Vsi_bi)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*0.0+(((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*0.0+((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdi_bi_Vdbulk_di=((+ids_Vdi_bi_Vdbulk_di*pModel->LH+ids_Vdi_bi*0.0+ids_Vdbulk_di*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdi_bi*pModel->LH*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)+(ids_Vdbulk_di*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdbulk_di+0.0*nq_h_Vdi_bi+2.0*nq_h_Vdi_bi_Vdbulk_di)*beta_h+(2.0*nq_h_Vdi_bi)*0.0+((2.0*nq_h_Vdbulk_di))*beta_h_Vdi_bi+(2.0*nq_h)*0.0)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*0.0+(((2.0*nq_h_Vdbulk_di))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*0.0+((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdi_bi_Vsbulk_si=((+ids_Vdi_bi_Vsbulk_si*pModel->LH+ids_Vdi_bi*0.0+ids_Vsbulk_si*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdi_bi*pModel->LH*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)+(ids_Vsbulk_si*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsbulk_si+0.0*nq_h_Vdi_bi+2.0*nq_h_Vdi_bi_Vsbulk_si)*beta_h+(2.0*nq_h_Vdi_bi)*0.0+((2.0*nq_h_Vsbulk_si))*beta_h_Vdi_bi+(2.0*nq_h)*0.0)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*0.0+(((2.0*nq_h_Vsbulk_si))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*0.0+((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*Vt*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#endif
i1_Vsi_bi=((ids_Vsi_bi*pModel->LH*((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#if defined(_DERIVATE2)
  i1_Vsi_bi_Vgi_bi=((+ids_Vsi_bi_Vgi_bi*pModel->LH+ids_Vsi_bi*0.0+ids_Vgi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsi_bi*pModel->LH*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)+(ids_Vgi_bi*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vgi_bi+0.0*nq_h_Vsi_bi+2.0*nq_h_Vsi_bi_Vgi_bi)*beta_h+(2.0*nq_h_Vsi_bi)*beta_h_Vgi_bi+((2.0*nq_h_Vgi_bi))*beta_h_Vsi_bi+(2.0*nq_h)*beta_h_Vsi_bi_Vgi_bi)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*0.0+(((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*0.0+((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsi_bi_Tempt_GND=((+ids_Vsi_bi_Tempt_GND*pModel->LH+ids_Vsi_bi*0.0+ids_Tempt_GND*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsi_bi*pModel->LH*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))+(ids_Tempt_GND*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Tempt_GND+0.0*nq_h_Vsi_bi+2.0*nq_h_Vsi_bi_Tempt_GND)*beta_h+(2.0*nq_h_Vsi_bi)*beta_h_Tempt_GND+((2.0*nq_h_Tempt_GND))*beta_h_Vsi_bi+(2.0*nq_h)*beta_h_Vsi_bi_Tempt_GND)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt_Tempt_GND+(((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt_Tempt_GND+((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsi_bi_Vdi_bi=((+ids_Vsi_bi_Vdi_bi*pModel->LH+ids_Vsi_bi*0.0+ids_Vdi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsi_bi*pModel->LH*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)+(ids_Vdi_bi*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdi_bi+0.0*nq_h_Vsi_bi+2.0*nq_h_Vsi_bi_Vdi_bi)*beta_h+(2.0*nq_h_Vsi_bi)*beta_h_Vdi_bi+((2.0*nq_h_Vdi_bi))*beta_h_Vsi_bi+(2.0*nq_h)*beta_h_Vsi_bi_Vdi_bi)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*0.0+(((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*0.0+((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsi_bi_Vsi_bi=((+ids_Vsi_bi_Vsi_bi*pModel->LH+ids_Vsi_bi*0.0+ids_Vsi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsi_bi*pModel->LH*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)+(ids_Vsi_bi*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsi_bi+0.0*nq_h_Vsi_bi+2.0*nq_h_Vsi_bi_Vsi_bi)*beta_h+(2.0*nq_h_Vsi_bi)*beta_h_Vsi_bi+((2.0*nq_h_Vsi_bi))*beta_h_Vsi_bi+(2.0*nq_h)*beta_h_Vsi_bi_Vsi_bi)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*0.0+(((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*0.0+((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsi_bi_Vdbulk_di=((+ids_Vsi_bi_Vdbulk_di*pModel->LH+ids_Vsi_bi*0.0+ids_Vdbulk_di*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsi_bi*pModel->LH*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)+(ids_Vdbulk_di*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdbulk_di+0.0*nq_h_Vsi_bi+2.0*nq_h_Vsi_bi_Vdbulk_di)*beta_h+(2.0*nq_h_Vsi_bi)*0.0+((2.0*nq_h_Vdbulk_di))*beta_h_Vsi_bi+(2.0*nq_h)*0.0)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*0.0+(((2.0*nq_h_Vdbulk_di))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*0.0+((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsi_bi_Vsbulk_si=((+ids_Vsi_bi_Vsbulk_si*pModel->LH+ids_Vsi_bi*0.0+ids_Vsbulk_si*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsi_bi*pModel->LH*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)+(ids_Vsbulk_si*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsbulk_si+0.0*nq_h_Vsi_bi+2.0*nq_h_Vsi_bi_Vsbulk_si)*beta_h+(2.0*nq_h_Vsi_bi)*0.0+((2.0*nq_h_Vsbulk_si))*beta_h_Vsi_bi+(2.0*nq_h)*0.0)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*0.0+(((2.0*nq_h_Vsbulk_si))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*0.0+((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*Vt*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#endif
i1_Vdbulk_di=((ids_Vdbulk_di*pModel->LH*((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#if defined(_DERIVATE2)
  i1_Vdbulk_di_Vgi_bi=((+ids_Vdbulk_di_Vgi_bi*pModel->LH+ids_Vdbulk_di*0.0+ids_Vgi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdbulk_di*pModel->LH*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)+(ids_Vgi_bi*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vgi_bi+0.0*nq_h_Vdbulk_di+2.0*nq_h_Vdbulk_di_Vgi_bi)*beta_h+(2.0*nq_h_Vdbulk_di)*beta_h_Vgi_bi+((2.0*nq_h_Vgi_bi))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*0.0+(((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*Vt*0.0+((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdbulk_di_Tempt_GND=((+ids_Vdbulk_di_Tempt_GND*pModel->LH+ids_Vdbulk_di*0.0+ids_Tempt_GND*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdbulk_di*pModel->LH*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))+(ids_Tempt_GND*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Tempt_GND+0.0*nq_h_Vdbulk_di+2.0*nq_h_Vdbulk_di_Tempt_GND)*beta_h+(2.0*nq_h_Vdbulk_di)*beta_h_Tempt_GND+((2.0*nq_h_Tempt_GND))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*Vt_Tempt_GND+(((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt_Tempt_GND+((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdbulk_di_Vdi_bi=((+ids_Vdbulk_di_Vdi_bi*pModel->LH+ids_Vdbulk_di*0.0+ids_Vdi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdbulk_di*pModel->LH*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)+(ids_Vdi_bi*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdi_bi+0.0*nq_h_Vdbulk_di+2.0*nq_h_Vdbulk_di_Vdi_bi)*beta_h+(2.0*nq_h_Vdbulk_di)*beta_h_Vdi_bi+((2.0*nq_h_Vdi_bi))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*0.0+(((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*Vt*0.0+((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdbulk_di_Vsi_bi=((+ids_Vdbulk_di_Vsi_bi*pModel->LH+ids_Vdbulk_di*0.0+ids_Vsi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdbulk_di*pModel->LH*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)+(ids_Vsi_bi*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsi_bi+0.0*nq_h_Vdbulk_di+2.0*nq_h_Vdbulk_di_Vsi_bi)*beta_h+(2.0*nq_h_Vdbulk_di)*beta_h_Vsi_bi+((2.0*nq_h_Vsi_bi))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*0.0+(((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*Vt*0.0+((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdbulk_di_Vdbulk_di=((+ids_Vdbulk_di_Vdbulk_di*pModel->LH+ids_Vdbulk_di*0.0+ids_Vdbulk_di*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdbulk_di*pModel->LH*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)+(ids_Vdbulk_di*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdbulk_di+0.0*nq_h_Vdbulk_di+2.0*nq_h_Vdbulk_di_Vdbulk_di)*beta_h+(2.0*nq_h_Vdbulk_di)*0.0+((2.0*nq_h_Vdbulk_di))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*0.0+(((2.0*nq_h_Vdbulk_di))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*Vt*0.0+((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vdbulk_di_Vsbulk_si=((+ids_Vdbulk_di_Vsbulk_si*pModel->LH+ids_Vdbulk_di*0.0+ids_Vsbulk_si*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vdbulk_di*pModel->LH*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)+(ids_Vsbulk_si*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsbulk_si+0.0*nq_h_Vdbulk_di+2.0*nq_h_Vdbulk_di_Vsbulk_si)*beta_h+(2.0*nq_h_Vdbulk_di)*0.0+((2.0*nq_h_Vsbulk_si))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*0.0+(((2.0*nq_h_Vsbulk_si))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vdbulk_di)*beta_h*Vt*0.0+((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vdbulk_di)*beta_h*Vt*Vt*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#endif
i1_Vsbulk_si=((ids_Vsbulk_si*pModel->LH*((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#if defined(_DERIVATE2)
  i1_Vsbulk_si_Vgi_bi=((+ids_Vsbulk_si_Vgi_bi*pModel->LH+ids_Vsbulk_si*0.0+ids_Vgi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsbulk_si*pModel->LH*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)+(ids_Vgi_bi*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vgi_bi+0.0*nq_h_Vsbulk_si+2.0*nq_h_Vsbulk_si_Vgi_bi)*beta_h+(2.0*nq_h_Vsbulk_si)*beta_h_Vgi_bi+((2.0*nq_h_Vgi_bi))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*0.0+(((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*Vt*0.0+((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt*(((((((2.0*nq_h_Vgi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsbulk_si_Tempt_GND=((+ids_Vsbulk_si_Tempt_GND*pModel->LH+ids_Vsbulk_si*0.0+ids_Tempt_GND*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsbulk_si*pModel->LH*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))+(ids_Tempt_GND*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Tempt_GND+0.0*nq_h_Vsbulk_si+2.0*nq_h_Vsbulk_si_Tempt_GND)*beta_h+(2.0*nq_h_Vsbulk_si)*beta_h_Tempt_GND+((2.0*nq_h_Tempt_GND))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*Vt_Tempt_GND+(((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt_Tempt_GND+((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt*(((((((((((2.0*nq_h_Tempt_GND))*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND)))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND)))*Vt)+((((2.0*nq_h)*beta_h)*Vt)*Vt_Tempt_GND)))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsbulk_si_Vdi_bi=((+ids_Vsbulk_si_Vdi_bi*pModel->LH+ids_Vsbulk_si*0.0+ids_Vdi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsbulk_si*pModel->LH*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)+(ids_Vdi_bi*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdi_bi+0.0*nq_h_Vsbulk_si+2.0*nq_h_Vsbulk_si_Vdi_bi)*beta_h+(2.0*nq_h_Vsbulk_si)*beta_h_Vdi_bi+((2.0*nq_h_Vdi_bi))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*0.0+(((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*Vt*0.0+((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt*(((((((2.0*nq_h_Vdi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsbulk_si_Vsi_bi=((+ids_Vsbulk_si_Vsi_bi*pModel->LH+ids_Vsbulk_si*0.0+ids_Vsi_bi*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsbulk_si*pModel->LH*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)+(ids_Vsi_bi*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsi_bi+0.0*nq_h_Vsbulk_si+2.0*nq_h_Vsbulk_si_Vsi_bi)*beta_h+(2.0*nq_h_Vsbulk_si)*beta_h_Vsi_bi+((2.0*nq_h_Vsi_bi))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*0.0+(((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*Vt*0.0+((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt*(((((((2.0*nq_h_Vsi_bi))*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi)))*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsbulk_si_Vdbulk_di=((+ids_Vsbulk_si_Vdbulk_di*pModel->LH+ids_Vsbulk_si*0.0+ids_Vdbulk_di*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsbulk_si*pModel->LH*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)+(ids_Vdbulk_di*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vdbulk_di+0.0*nq_h_Vsbulk_si+2.0*nq_h_Vsbulk_si_Vdbulk_di)*beta_h+(2.0*nq_h_Vsbulk_si)*0.0+((2.0*nq_h_Vdbulk_di))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*0.0+(((2.0*nq_h_Vdbulk_di))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*Vt*0.0+((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt*(((((2.0*nq_h_Vdbulk_di))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
  i1_Vsbulk_si_Vsbulk_si=((+ids_Vsbulk_si_Vsbulk_si*pModel->LH+ids_Vsbulk_si*0.0+ids_Vsbulk_si*0.0+ids*0.0)/((((2.0*nq_h)*beta_h)*Vt)*Vt)-(ids_Vsbulk_si*pModel->LH*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)+(ids_Vsbulk_si*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt+(ids*pModel->LH)*(+(+(+(+0.0*nq_h+0.0*nq_h_Vsbulk_si+0.0*nq_h_Vsbulk_si+2.0*nq_h_Vsbulk_si_Vsbulk_si)*beta_h+(2.0*nq_h_Vsbulk_si)*0.0+((2.0*nq_h_Vsbulk_si))*0.0+(2.0*nq_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*0.0+(((2.0*nq_h_Vsbulk_si))*beta_h)*0.0+((2.0*nq_h)*beta_h)*0.0)*Vt+(2.0*nq_h_Vsbulk_si)*beta_h*Vt*0.0+((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*0.0+(((2.0*nq_h)*beta_h)*Vt)*0.0))/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)+2*(ids*pModel->LH)*(2.0*nq_h_Vsbulk_si)*beta_h*Vt*Vt*(((((2.0*nq_h_Vsbulk_si))*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
#endif
#endif
i1=((ids*pModel->LH)/((((2.0*nq_h)*beta_h)*Vt)*Vt));
EXIT_IF_ISNAN(((ids*pModel->LH)/((((2.0*nq_h)*beta_h)*Vt)*Vt)))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
i2_Vgi_bi=((ids_Vgi_bi*(LeffnoiH-pModel->LH)*((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
#if defined(_DERIVATE2)
  i2_Vgi_bi_Vgi_bi=((+ids_Vgi_bi_Vgi_bi*(LeffnoiH-pModel->LH)+ids_Vgi_bi*0.0+ids_Vgi_bi*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vgi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi)))+(ids_Vgi_bi*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vgi_bi)*beta_ch+(2.0*nq_Vgi_bi)*beta_ch_Vgi_bi+((2.0*nq_Vgi_bi))*beta_ch_Vgi_bi+(2.0*nq)*beta_ch_Vgi_bi_Vgi_bi)*nVt+(((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt_Vgi_bi+(((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt_Vgi_bi+((2.0*nq)*beta_ch)*nVt_Vgi_bi_Vgi_bi)*nVt+(((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt_Vgi_bi+((((((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi)))*nVt_Vgi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi_Vgi_bi))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi))*(((((((((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
  i2_Vgi_bi_Tempt_GND=((+ids_Vgi_bi_Tempt_GND*(LeffnoiH-pModel->LH)+ids_Vgi_bi*0.0+ids_Tempt_GND*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vgi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Tempt_GND)))+(ids_Tempt_GND*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Tempt_GND)*beta_ch+(2.0*nq_Vgi_bi)*beta_ch_Tempt_GND+((2.0*nq_Tempt_GND))*beta_ch_Vgi_bi+(2.0*nq)*beta_ch_Vgi_bi_Tempt_GND)*nVt+(((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt_Tempt_GND+(((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt_Vgi_bi+((2.0*nq)*beta_ch)*nVt_Vgi_bi_Tempt_GND)*nVt+(((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt_Tempt_GND+((((((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND)))*nVt_Vgi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi_Tempt_GND))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi))*(((((((((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Tempt_GND)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
  i2_Vgi_bi_Vdi_bi=((+ids_Vgi_bi_Vdi_bi*(LeffnoiH-pModel->LH)+ids_Vgi_bi*0.0+ids_Vdi_bi*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vgi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi)))+(ids_Vdi_bi*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdi_bi)*beta_ch+(2.0*nq_Vgi_bi)*beta_ch_Vdi_bi+((2.0*nq_Vdi_bi))*beta_ch_Vgi_bi+(2.0*nq)*beta_ch_Vgi_bi_Vdi_bi)*nVt+(((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt_Vdi_bi+(((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt_Vgi_bi+((2.0*nq)*beta_ch)*nVt_Vgi_bi_Vdi_bi)*nVt+(((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt_Vdi_bi+((((((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi)))*nVt_Vgi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi_Vdi_bi))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi))*(((((((((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
  i2_Vgi_bi_Vsi_bi=((+ids_Vgi_bi_Vsi_bi*(LeffnoiH-pModel->LH)+ids_Vgi_bi*0.0+ids_Vsi_bi*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vgi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi)))+(ids_Vsi_bi*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsi_bi)*beta_ch+(2.0*nq_Vgi_bi)*beta_ch_Vsi_bi+((2.0*nq_Vsi_bi))*beta_ch_Vgi_bi+(2.0*nq)*beta_ch_Vgi_bi_Vsi_bi)*nVt+(((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt_Vsi_bi+(((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt_Vgi_bi+((2.0*nq)*beta_ch)*nVt_Vgi_bi_Vsi_bi)*nVt+(((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt_Vsi_bi+((((((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi)))*nVt_Vgi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi_Vsi_bi))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi))*(((((((((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
#endif
#if defined(_DERIVATE)
i2_Tempt_GND=((ids_Tempt_GND*(LeffnoiH-pModel->LH)*((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Tempt_GND)*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Tempt_GND)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
#endif
i2_Vdi_bi=((ids_Vdi_bi*(LeffnoiH-pModel->LH)*((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
#if defined(_DERIVATE2)
  i2_Vdi_bi_Vgi_bi=((+ids_Vdi_bi_Vgi_bi*(LeffnoiH-pModel->LH)+ids_Vdi_bi*0.0+ids_Vgi_bi*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vdi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi)))+(ids_Vgi_bi*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vgi_bi)*beta_ch+(2.0*nq_Vdi_bi)*beta_ch_Vgi_bi+((2.0*nq_Vgi_bi))*beta_ch_Vdi_bi+(2.0*nq)*beta_ch_Vdi_bi_Vgi_bi)*nVt+(((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt_Vgi_bi+(((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt_Vdi_bi+((2.0*nq)*beta_ch)*nVt_Vdi_bi_Vgi_bi)*nVt+(((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt_Vgi_bi+((((((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi)))*nVt_Vdi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi_Vgi_bi))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi))*(((((((((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
  i2_Vdi_bi_Tempt_GND=((+ids_Vdi_bi_Tempt_GND*(LeffnoiH-pModel->LH)+ids_Vdi_bi*0.0+ids_Tempt_GND*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vdi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Tempt_GND)))+(ids_Tempt_GND*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Tempt_GND)*beta_ch+(2.0*nq_Vdi_bi)*beta_ch_Tempt_GND+((2.0*nq_Tempt_GND))*beta_ch_Vdi_bi+(2.0*nq)*beta_ch_Vdi_bi_Tempt_GND)*nVt+(((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt_Tempt_GND+(((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt_Vdi_bi+((2.0*nq)*beta_ch)*nVt_Vdi_bi_Tempt_GND)*nVt+(((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt_Tempt_GND+((((((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND)))*nVt_Vdi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi_Tempt_GND))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi))*(((((((((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Tempt_GND)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
  i2_Vdi_bi_Vdi_bi=((+ids_Vdi_bi_Vdi_bi*(LeffnoiH-pModel->LH)+ids_Vdi_bi*0.0+ids_Vdi_bi*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vdi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi)))+(ids_Vdi_bi*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdi_bi)*beta_ch+(2.0*nq_Vdi_bi)*beta_ch_Vdi_bi+((2.0*nq_Vdi_bi))*beta_ch_Vdi_bi+(2.0*nq)*beta_ch_Vdi_bi_Vdi_bi)*nVt+(((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt_Vdi_bi+(((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt_Vdi_bi+((2.0*nq)*beta_ch)*nVt_Vdi_bi_Vdi_bi)*nVt+(((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt_Vdi_bi+((((((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi)))*nVt_Vdi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi_Vdi_bi))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi))*(((((((((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
  i2_Vdi_bi_Vsi_bi=((+ids_Vdi_bi_Vsi_bi*(LeffnoiH-pModel->LH)+ids_Vdi_bi*0.0+ids_Vsi_bi*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vdi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi)))+(ids_Vsi_bi*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsi_bi)*beta_ch+(2.0*nq_Vdi_bi)*beta_ch_Vsi_bi+((2.0*nq_Vsi_bi))*beta_ch_Vdi_bi+(2.0*nq)*beta_ch_Vdi_bi_Vsi_bi)*nVt+(((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt_Vsi_bi+(((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt_Vdi_bi+((2.0*nq)*beta_ch)*nVt_Vdi_bi_Vsi_bi)*nVt+(((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt_Vsi_bi+((((((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi)))*nVt_Vdi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi_Vsi_bi))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi))*(((((((((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
#endif
i2_Vsi_bi=((ids_Vsi_bi*(LeffnoiH-pModel->LH)*((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
#if defined(_DERIVATE2)
  i2_Vsi_bi_Vgi_bi=((+ids_Vsi_bi_Vgi_bi*(LeffnoiH-pModel->LH)+ids_Vsi_bi*0.0+ids_Vgi_bi*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vsi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi)))+(ids_Vgi_bi*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vgi_bi)*beta_ch+(2.0*nq_Vsi_bi)*beta_ch_Vgi_bi+((2.0*nq_Vgi_bi))*beta_ch_Vsi_bi+(2.0*nq)*beta_ch_Vsi_bi_Vgi_bi)*nVt+(((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt_Vgi_bi+(((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt_Vsi_bi+((2.0*nq)*beta_ch)*nVt_Vsi_bi_Vgi_bi)*nVt+(((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt_Vgi_bi+((((((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi)))*nVt_Vsi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi_Vgi_bi))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi))*(((((((((((2.0*nq_Vgi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vgi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vgi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
  i2_Vsi_bi_Tempt_GND=((+ids_Vsi_bi_Tempt_GND*(LeffnoiH-pModel->LH)+ids_Vsi_bi*0.0+ids_Tempt_GND*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vsi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Tempt_GND)))+(ids_Tempt_GND*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Tempt_GND)*beta_ch+(2.0*nq_Vsi_bi)*beta_ch_Tempt_GND+((2.0*nq_Tempt_GND))*beta_ch_Vsi_bi+(2.0*nq)*beta_ch_Vsi_bi_Tempt_GND)*nVt+(((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt_Tempt_GND+(((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt_Vsi_bi+((2.0*nq)*beta_ch)*nVt_Vsi_bi_Tempt_GND)*nVt+(((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt_Tempt_GND+((((((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND)))*nVt_Vsi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi_Tempt_GND))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi))*(((((((((((2.0*nq_Tempt_GND))*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Tempt_GND)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Tempt_GND)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
  i2_Vsi_bi_Vdi_bi=((+ids_Vsi_bi_Vdi_bi*(LeffnoiH-pModel->LH)+ids_Vsi_bi*0.0+ids_Vdi_bi*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vsi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi)))+(ids_Vdi_bi*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdi_bi)*beta_ch+(2.0*nq_Vsi_bi)*beta_ch_Vdi_bi+((2.0*nq_Vdi_bi))*beta_ch_Vsi_bi+(2.0*nq)*beta_ch_Vsi_bi_Vdi_bi)*nVt+(((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt_Vdi_bi+(((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt_Vsi_bi+((2.0*nq)*beta_ch)*nVt_Vsi_bi_Vdi_bi)*nVt+(((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt_Vdi_bi+((((((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi)))*nVt_Vsi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi_Vdi_bi))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi))*(((((((((((2.0*nq_Vdi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vdi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vdi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
  i2_Vsi_bi_Vsi_bi=((+ids_Vsi_bi_Vsi_bi*(LeffnoiH-pModel->LH)+ids_Vsi_bi*0.0+ids_Vsi_bi*0.0+ids*(+0.0-0.0))/((((2.0*nq)*beta_ch)*nVt)*nVt)-(ids_Vsi_bi*(LeffnoiH-pModel->LH)*(((((((((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi)))+(ids_Vsi_bi*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi))+(ids*(LeffnoiH-pModel->LH))*(+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsi_bi)*beta_ch+(2.0*nq_Vsi_bi)*beta_ch_Vsi_bi+((2.0*nq_Vsi_bi))*beta_ch_Vsi_bi+(2.0*nq)*beta_ch_Vsi_bi_Vsi_bi)*nVt+(((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt_Vsi_bi+(((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt_Vsi_bi+((2.0*nq)*beta_ch)*nVt_Vsi_bi_Vsi_bi)*nVt+(((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt_Vsi_bi+((((((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi)))*nVt_Vsi_bi+(((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi_Vsi_bi))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)+2*(ids*(LeffnoiH-pModel->LH))*(((((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi))*(((((((((((2.0*nq_Vsi_bi))*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi)))*nVt)+(((2.0*nq)*beta_ch)*nVt_Vsi_bi)))*nVt)+((((2.0*nq)*beta_ch)*nVt)*nVt_Vsi_bi)))/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt)/((((2.0*nq)*beta_ch)*nVt)*nVt));
#endif
#endif
i2=((ids*(LeffnoiH-pModel->LH))/((((2.0*nq)*beta_ch)*nVt)*nVt));
EXIT_IF_ISNAN(((ids*(LeffnoiH-pModel->LH))/((((2.0*nq)*beta_ch)*nVt)*nVt)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(4.0*((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di))+qsh_Vdbulk_di)-i1_Vdbulk_di));
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di))+qsh_Vdbulk_di)-i1_Vdbulk_di)+4.0*(+(+(+0.0*qsh+qsh_Vdbulk_di*0.0+0.0*qsh_Vdbulk_di+qsh*0.0)+0.0)-0.0)));
  T0_Vdbulk_di_Vgm_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di))+qsh_Vdbulk_di)-i1_Vdbulk_di)+4.0*(+(+(+0.0*qsh+qsh_Vdbulk_di*0.0+0.0*qsh_Vdbulk_di+qsh*0.0)+0.0)-0.0)));
  T0_Vdbulk_di_Vdbulk_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di)))+qsh_Vdbulk_di)-i1_Vdbulk_di)+0.0*((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di))+qsh_Vdbulk_di)-i1_Vdbulk_di)+4.0*(+(+(+qsh_Vdbulk_di_Vdbulk_di*qsh+qsh_Vdbulk_di*qsh_Vdbulk_di+qsh_Vdbulk_di*qsh_Vdbulk_di+qsh*qsh_Vdbulk_di_Vdbulk_di)+qsh_Vdbulk_di_Vdbulk_di)-i1_Vdbulk_di_Vdbulk_di)));
  T0_Vdbulk_di_Vsbulk_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si)))+qsh_Vsbulk_si)-i1_Vsbulk_si)+0.0*((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di))+qsh_Vdbulk_di)-i1_Vdbulk_di)+4.0*(+(+(+qsh_Vdbulk_di_Vsbulk_si*qsh+qsh_Vdbulk_di*qsh_Vsbulk_si+qsh_Vsbulk_si*qsh_Vdbulk_di+qsh*qsh_Vdbulk_di_Vsbulk_si)+qsh_Vdbulk_di_Vsbulk_si)-i1_Vdbulk_di_Vsbulk_si)));
  T0_Vdbulk_di_Vgi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi)))+qsh_Vgi_bi)-i1_Vgi_bi)+0.0*((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di))+qsh_Vdbulk_di)-i1_Vdbulk_di)+4.0*(+(+(+qsh_Vdbulk_di_Vgi_bi*qsh+qsh_Vdbulk_di*qsh_Vgi_bi+qsh_Vgi_bi*qsh_Vdbulk_di+qsh*qsh_Vdbulk_di_Vgi_bi)+qsh_Vdbulk_di_Vgi_bi)-i1_Vdbulk_di_Vgi_bi)));
  T0_Vdbulk_di_Vdi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi)))+qsh_Vdi_bi)-i1_Vdi_bi)+0.0*((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di))+qsh_Vdbulk_di)-i1_Vdbulk_di)+4.0*(+(+(+qsh_Vdbulk_di_Vdi_bi*qsh+qsh_Vdbulk_di*qsh_Vdi_bi+qsh_Vdi_bi*qsh_Vdbulk_di+qsh*qsh_Vdbulk_di_Vdi_bi)+qsh_Vdbulk_di_Vdi_bi)-i1_Vdbulk_di_Vdi_bi)));
  T0_Vdbulk_di_Vsi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi)))+qsh_Vsi_bi)-i1_Vsi_bi)+0.0*((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di))+qsh_Vdbulk_di)-i1_Vdbulk_di)+4.0*(+(+(+qsh_Vdbulk_di_Vsi_bi*qsh+qsh_Vdbulk_di*qsh_Vsi_bi+qsh_Vsi_bi*qsh_Vdbulk_di+qsh*qsh_Vdbulk_di_Vsi_bi)+qsh_Vdbulk_di_Vsi_bi)-i1_Vdbulk_di_Vsi_bi)));
  T0_Vdbulk_di_Tempt_GND=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Tempt_GND*qsh)+(qsh*qsh_Tempt_GND)))+qsh_Tempt_GND)-i1_Tempt_GND)+0.0*((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di))+qsh_Vdbulk_di)-i1_Vdbulk_di)+4.0*(+(+(+qsh_Vdbulk_di_Tempt_GND*qsh+qsh_Vdbulk_di*qsh_Tempt_GND+qsh_Tempt_GND*qsh_Vdbulk_di+qsh*qsh_Vdbulk_di_Tempt_GND)+qsh_Vdbulk_di_Tempt_GND)-i1_Vdbulk_di_Tempt_GND)));
#endif
T0_Vsbulk_si=(4.0*((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si))+qsh_Vsbulk_si)-i1_Vsbulk_si));
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si))+qsh_Vsbulk_si)-i1_Vsbulk_si)+4.0*(+(+(+0.0*qsh+qsh_Vsbulk_si*0.0+0.0*qsh_Vsbulk_si+qsh*0.0)+0.0)-0.0)));
  T0_Vsbulk_si_Vgm_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si))+qsh_Vsbulk_si)-i1_Vsbulk_si)+4.0*(+(+(+0.0*qsh+qsh_Vsbulk_si*0.0+0.0*qsh_Vsbulk_si+qsh*0.0)+0.0)-0.0)));
  T0_Vsbulk_si_Vdbulk_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di)))+qsh_Vdbulk_di)-i1_Vdbulk_di)+0.0*((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si))+qsh_Vsbulk_si)-i1_Vsbulk_si)+4.0*(+(+(+qsh_Vsbulk_si_Vdbulk_di*qsh+qsh_Vsbulk_si*qsh_Vdbulk_di+qsh_Vdbulk_di*qsh_Vsbulk_si+qsh*qsh_Vsbulk_si_Vdbulk_di)+qsh_Vsbulk_si_Vdbulk_di)-i1_Vsbulk_si_Vdbulk_di)));
  T0_Vsbulk_si_Vsbulk_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si)))+qsh_Vsbulk_si)-i1_Vsbulk_si)+0.0*((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si))+qsh_Vsbulk_si)-i1_Vsbulk_si)+4.0*(+(+(+qsh_Vsbulk_si_Vsbulk_si*qsh+qsh_Vsbulk_si*qsh_Vsbulk_si+qsh_Vsbulk_si*qsh_Vsbulk_si+qsh*qsh_Vsbulk_si_Vsbulk_si)+qsh_Vsbulk_si_Vsbulk_si)-i1_Vsbulk_si_Vsbulk_si)));
  T0_Vsbulk_si_Vgi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi)))+qsh_Vgi_bi)-i1_Vgi_bi)+0.0*((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si))+qsh_Vsbulk_si)-i1_Vsbulk_si)+4.0*(+(+(+qsh_Vsbulk_si_Vgi_bi*qsh+qsh_Vsbulk_si*qsh_Vgi_bi+qsh_Vgi_bi*qsh_Vsbulk_si+qsh*qsh_Vsbulk_si_Vgi_bi)+qsh_Vsbulk_si_Vgi_bi)-i1_Vsbulk_si_Vgi_bi)));
  T0_Vsbulk_si_Vdi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi)))+qsh_Vdi_bi)-i1_Vdi_bi)+0.0*((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si))+qsh_Vsbulk_si)-i1_Vsbulk_si)+4.0*(+(+(+qsh_Vsbulk_si_Vdi_bi*qsh+qsh_Vsbulk_si*qsh_Vdi_bi+qsh_Vdi_bi*qsh_Vsbulk_si+qsh*qsh_Vsbulk_si_Vdi_bi)+qsh_Vsbulk_si_Vdi_bi)-i1_Vsbulk_si_Vdi_bi)));
  T0_Vsbulk_si_Vsi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi)))+qsh_Vsi_bi)-i1_Vsi_bi)+0.0*((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si))+qsh_Vsbulk_si)-i1_Vsbulk_si)+4.0*(+(+(+qsh_Vsbulk_si_Vsi_bi*qsh+qsh_Vsbulk_si*qsh_Vsi_bi+qsh_Vsi_bi*qsh_Vsbulk_si+qsh*qsh_Vsbulk_si_Vsi_bi)+qsh_Vsbulk_si_Vsi_bi)-i1_Vsbulk_si_Vsi_bi)));
  T0_Vsbulk_si_Tempt_GND=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Tempt_GND*qsh)+(qsh*qsh_Tempt_GND)))+qsh_Tempt_GND)-i1_Tempt_GND)+0.0*((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si))+qsh_Vsbulk_si)-i1_Vsbulk_si)+4.0*(+(+(+qsh_Vsbulk_si_Tempt_GND*qsh+qsh_Vsbulk_si*qsh_Tempt_GND+qsh_Tempt_GND*qsh_Vsbulk_si+qsh*qsh_Vsbulk_si_Tempt_GND)+qsh_Vsbulk_si_Tempt_GND)-i1_Vsbulk_si_Tempt_GND)));
#endif
T0_Vgi_bi=(4.0*((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi))+qsh_Vgi_bi)-i1_Vgi_bi));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi))+qsh_Vgi_bi)-i1_Vgi_bi)+4.0*(+(+(+0.0*qsh+qsh_Vgi_bi*0.0+0.0*qsh_Vgi_bi+qsh*0.0)+0.0)-0.0)));
  T0_Vgi_bi_Vgm_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi))+qsh_Vgi_bi)-i1_Vgi_bi)+4.0*(+(+(+0.0*qsh+qsh_Vgi_bi*0.0+0.0*qsh_Vgi_bi+qsh*0.0)+0.0)-0.0)));
  T0_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di)))+qsh_Vdbulk_di)-i1_Vdbulk_di)+0.0*((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi))+qsh_Vgi_bi)-i1_Vgi_bi)+4.0*(+(+(+qsh_Vgi_bi_Vdbulk_di*qsh+qsh_Vgi_bi*qsh_Vdbulk_di+qsh_Vdbulk_di*qsh_Vgi_bi+qsh*qsh_Vgi_bi_Vdbulk_di)+qsh_Vgi_bi_Vdbulk_di)-i1_Vgi_bi_Vdbulk_di)));
  T0_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si)))+qsh_Vsbulk_si)-i1_Vsbulk_si)+0.0*((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi))+qsh_Vgi_bi)-i1_Vgi_bi)+4.0*(+(+(+qsh_Vgi_bi_Vsbulk_si*qsh+qsh_Vgi_bi*qsh_Vsbulk_si+qsh_Vsbulk_si*qsh_Vgi_bi+qsh*qsh_Vgi_bi_Vsbulk_si)+qsh_Vgi_bi_Vsbulk_si)-i1_Vgi_bi_Vsbulk_si)));
  T0_Vgi_bi_Vgi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi)))+qsh_Vgi_bi)-i1_Vgi_bi)+0.0*((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi))+qsh_Vgi_bi)-i1_Vgi_bi)+4.0*(+(+(+qsh_Vgi_bi_Vgi_bi*qsh+qsh_Vgi_bi*qsh_Vgi_bi+qsh_Vgi_bi*qsh_Vgi_bi+qsh*qsh_Vgi_bi_Vgi_bi)+qsh_Vgi_bi_Vgi_bi)-i1_Vgi_bi_Vgi_bi)));
  T0_Vgi_bi_Vdi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi)))+qsh_Vdi_bi)-i1_Vdi_bi)+0.0*((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi))+qsh_Vgi_bi)-i1_Vgi_bi)+4.0*(+(+(+qsh_Vgi_bi_Vdi_bi*qsh+qsh_Vgi_bi*qsh_Vdi_bi+qsh_Vdi_bi*qsh_Vgi_bi+qsh*qsh_Vgi_bi_Vdi_bi)+qsh_Vgi_bi_Vdi_bi)-i1_Vgi_bi_Vdi_bi)));
  T0_Vgi_bi_Vsi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi)))+qsh_Vsi_bi)-i1_Vsi_bi)+0.0*((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi))+qsh_Vgi_bi)-i1_Vgi_bi)+4.0*(+(+(+qsh_Vgi_bi_Vsi_bi*qsh+qsh_Vgi_bi*qsh_Vsi_bi+qsh_Vsi_bi*qsh_Vgi_bi+qsh*qsh_Vgi_bi_Vsi_bi)+qsh_Vgi_bi_Vsi_bi)-i1_Vgi_bi_Vsi_bi)));
  T0_Vgi_bi_Tempt_GND=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Tempt_GND*qsh)+(qsh*qsh_Tempt_GND)))+qsh_Tempt_GND)-i1_Tempt_GND)+0.0*((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi))+qsh_Vgi_bi)-i1_Vgi_bi)+4.0*(+(+(+qsh_Vgi_bi_Tempt_GND*qsh+qsh_Vgi_bi*qsh_Tempt_GND+qsh_Tempt_GND*qsh_Vgi_bi+qsh*qsh_Vgi_bi_Tempt_GND)+qsh_Vgi_bi_Tempt_GND)-i1_Vgi_bi_Tempt_GND)));
#endif
T0_Vdi_bi=(4.0*((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi))+qsh_Vdi_bi)-i1_Vdi_bi));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi))+qsh_Vdi_bi)-i1_Vdi_bi)+4.0*(+(+(+0.0*qsh+qsh_Vdi_bi*0.0+0.0*qsh_Vdi_bi+qsh*0.0)+0.0)-0.0)));
  T0_Vdi_bi_Vgm_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi))+qsh_Vdi_bi)-i1_Vdi_bi)+4.0*(+(+(+0.0*qsh+qsh_Vdi_bi*0.0+0.0*qsh_Vdi_bi+qsh*0.0)+0.0)-0.0)));
  T0_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di)))+qsh_Vdbulk_di)-i1_Vdbulk_di)+0.0*((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi))+qsh_Vdi_bi)-i1_Vdi_bi)+4.0*(+(+(+qsh_Vdi_bi_Vdbulk_di*qsh+qsh_Vdi_bi*qsh_Vdbulk_di+qsh_Vdbulk_di*qsh_Vdi_bi+qsh*qsh_Vdi_bi_Vdbulk_di)+qsh_Vdi_bi_Vdbulk_di)-i1_Vdi_bi_Vdbulk_di)));
  T0_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si)))+qsh_Vsbulk_si)-i1_Vsbulk_si)+0.0*((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi))+qsh_Vdi_bi)-i1_Vdi_bi)+4.0*(+(+(+qsh_Vdi_bi_Vsbulk_si*qsh+qsh_Vdi_bi*qsh_Vsbulk_si+qsh_Vsbulk_si*qsh_Vdi_bi+qsh*qsh_Vdi_bi_Vsbulk_si)+qsh_Vdi_bi_Vsbulk_si)-i1_Vdi_bi_Vsbulk_si)));
  T0_Vdi_bi_Vgi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi)))+qsh_Vgi_bi)-i1_Vgi_bi)+0.0*((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi))+qsh_Vdi_bi)-i1_Vdi_bi)+4.0*(+(+(+qsh_Vdi_bi_Vgi_bi*qsh+qsh_Vdi_bi*qsh_Vgi_bi+qsh_Vgi_bi*qsh_Vdi_bi+qsh*qsh_Vdi_bi_Vgi_bi)+qsh_Vdi_bi_Vgi_bi)-i1_Vdi_bi_Vgi_bi)));
  T0_Vdi_bi_Vdi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi)))+qsh_Vdi_bi)-i1_Vdi_bi)+0.0*((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi))+qsh_Vdi_bi)-i1_Vdi_bi)+4.0*(+(+(+qsh_Vdi_bi_Vdi_bi*qsh+qsh_Vdi_bi*qsh_Vdi_bi+qsh_Vdi_bi*qsh_Vdi_bi+qsh*qsh_Vdi_bi_Vdi_bi)+qsh_Vdi_bi_Vdi_bi)-i1_Vdi_bi_Vdi_bi)));
  T0_Vdi_bi_Vsi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi)))+qsh_Vsi_bi)-i1_Vsi_bi)+0.0*((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi))+qsh_Vdi_bi)-i1_Vdi_bi)+4.0*(+(+(+qsh_Vdi_bi_Vsi_bi*qsh+qsh_Vdi_bi*qsh_Vsi_bi+qsh_Vsi_bi*qsh_Vdi_bi+qsh*qsh_Vdi_bi_Vsi_bi)+qsh_Vdi_bi_Vsi_bi)-i1_Vdi_bi_Vsi_bi)));
  T0_Vdi_bi_Tempt_GND=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Tempt_GND*qsh)+(qsh*qsh_Tempt_GND)))+qsh_Tempt_GND)-i1_Tempt_GND)+0.0*((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi))+qsh_Vdi_bi)-i1_Vdi_bi)+4.0*(+(+(+qsh_Vdi_bi_Tempt_GND*qsh+qsh_Vdi_bi*qsh_Tempt_GND+qsh_Tempt_GND*qsh_Vdi_bi+qsh*qsh_Vdi_bi_Tempt_GND)+qsh_Vdi_bi_Tempt_GND)-i1_Vdi_bi_Tempt_GND)));
#endif
T0_Vsi_bi=(4.0*((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi))+qsh_Vsi_bi)-i1_Vsi_bi));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi))+qsh_Vsi_bi)-i1_Vsi_bi)+4.0*(+(+(+0.0*qsh+qsh_Vsi_bi*0.0+0.0*qsh_Vsi_bi+qsh*0.0)+0.0)-0.0)));
  T0_Vsi_bi_Vgm_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(0.0)+0.0*((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi))+qsh_Vsi_bi)-i1_Vsi_bi)+4.0*(+(+(+0.0*qsh+qsh_Vsi_bi*0.0+0.0*qsh_Vsi_bi+qsh*0.0)+0.0)-0.0)));
  T0_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdbulk_di*qsh)+(qsh*qsh_Vdbulk_di)))+qsh_Vdbulk_di)-i1_Vdbulk_di)+0.0*((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi))+qsh_Vsi_bi)-i1_Vsi_bi)+4.0*(+(+(+qsh_Vsi_bi_Vdbulk_di*qsh+qsh_Vsi_bi*qsh_Vdbulk_di+qsh_Vdbulk_di*qsh_Vsi_bi+qsh*qsh_Vsi_bi_Vdbulk_di)+qsh_Vsi_bi_Vdbulk_di)-i1_Vsi_bi_Vdbulk_di)));
  T0_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsbulk_si*qsh)+(qsh*qsh_Vsbulk_si)))+qsh_Vsbulk_si)-i1_Vsbulk_si)+0.0*((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi))+qsh_Vsi_bi)-i1_Vsi_bi)+4.0*(+(+(+qsh_Vsi_bi_Vsbulk_si*qsh+qsh_Vsi_bi*qsh_Vsbulk_si+qsh_Vsbulk_si*qsh_Vsi_bi+qsh*qsh_Vsi_bi_Vsbulk_si)+qsh_Vsi_bi_Vsbulk_si)-i1_Vsi_bi_Vsbulk_si)));
  T0_Vsi_bi_Vgi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vgi_bi*qsh)+(qsh*qsh_Vgi_bi)))+qsh_Vgi_bi)-i1_Vgi_bi)+0.0*((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi))+qsh_Vsi_bi)-i1_Vsi_bi)+4.0*(+(+(+qsh_Vsi_bi_Vgi_bi*qsh+qsh_Vsi_bi*qsh_Vgi_bi+qsh_Vgi_bi*qsh_Vsi_bi+qsh*qsh_Vsi_bi_Vgi_bi)+qsh_Vsi_bi_Vgi_bi)-i1_Vsi_bi_Vgi_bi)));
  T0_Vsi_bi_Vdi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vdi_bi*qsh)+(qsh*qsh_Vdi_bi)))+qsh_Vdi_bi)-i1_Vdi_bi)+0.0*((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi))+qsh_Vsi_bi)-i1_Vsi_bi)+4.0*(+(+(+qsh_Vsi_bi_Vdi_bi*qsh+qsh_Vsi_bi*qsh_Vdi_bi+qsh_Vdi_bi*qsh_Vsi_bi+qsh*qsh_Vsi_bi_Vdi_bi)+qsh_Vsi_bi_Vdi_bi)-i1_Vsi_bi_Vdi_bi)));
  T0_Vsi_bi_Vsi_bi=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi)))+qsh_Vsi_bi)-i1_Vsi_bi)+0.0*((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi))+qsh_Vsi_bi)-i1_Vsi_bi)+4.0*(+(+(+qsh_Vsi_bi_Vsi_bi*qsh+qsh_Vsi_bi*qsh_Vsi_bi+qsh_Vsi_bi*qsh_Vsi_bi+qsh*qsh_Vsi_bi_Vsi_bi)+qsh_Vsi_bi_Vsi_bi)-i1_Vsi_bi_Vsi_bi)));
  T0_Vsi_bi_Tempt_GND=(+0.0+(+0.0*(((qsh*qsh)+qsh)-i1)+0.0*(((((qsh_Tempt_GND*qsh)+(qsh*qsh_Tempt_GND)))+qsh_Tempt_GND)-i1_Tempt_GND)+0.0*((((qsh_Vsi_bi*qsh)+(qsh*qsh_Vsi_bi))+qsh_Vsi_bi)-i1_Vsi_bi)+4.0*(+(+(+qsh_Vsi_bi_Tempt_GND*qsh+qsh_Vsi_bi*qsh_Tempt_GND+qsh_Tempt_GND*qsh_Vsi_bi+qsh*qsh_Vsi_bi_Tempt_GND)+qsh_Vsi_bi_Tempt_GND)-i1_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(4.0*((((qsh_Tempt_GND*qsh)+(qsh*qsh_Tempt_GND))+qsh_Tempt_GND)-i1_Tempt_GND));
#endif
#endif
T0=(1.0+(4.0*(((qsh*qsh)+qsh)-i1)));
EXIT_IF_ISNAN((1.0+(4.0*(((qsh*qsh)+qsh)-i1))))
if
((T0<1.0))
{
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
qdh_Vdbulk_di=0.0;
qdh_Vsbulk_si=0.0;
qdh_Vgi_bi=0.0;
qdh_Vdi_bi=0.0;
qdh_Vsi_bi=0.0;
qdh_Tempt_GND=0.0;
#endif
qdh=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
{
double m00_sqrt(d00_sqrt0,T0)
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T0)
#endif
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
qdh_Vdbulk_di=(0.5*T0_Vdbulk_di*d10_sqrt0);
qdh_Vsbulk_si=(0.5*T0_Vsbulk_si*d10_sqrt0);
qdh_Vgi_bi=(0.5*T0_Vgi_bi*d10_sqrt0);
qdh_Vdi_bi=(0.5*T0_Vdi_bi*d10_sqrt0);
qdh_Vsi_bi=(0.5*T0_Vsi_bi*d10_sqrt0);
qdh_Tempt_GND=(0.5*T0_Tempt_GND*d10_sqrt0);
#endif
qdh=((-0.5)+(0.5*d00_sqrt0));
EXIT_IF_ISNAN(((-0.5)+(0.5*d00_sqrt0)))
}
}
{
double m00_sqrt(d00_sqrt0,(1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
qsch_Vgi_bi=(0.5*(4.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  qsch_Vgi_bi_Vgi_bi=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi)))+qdeff_Vgi_bi)+i2_Vgi_bi)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi)))+qdeff_Vgi_bi)+i2_Vgi_bi)))*(4.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi)))+qdeff_Vgi_bi)+i2_Vgi_bi)+0.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi)+4.0*(+(+(+qdeff_Vgi_bi_Vgi_bi*qdeff+qdeff_Vgi_bi*qdeff_Vgi_bi+qdeff_Vgi_bi*qdeff_Vgi_bi+qdeff*qdeff_Vgi_bi_Vgi_bi)+qdeff_Vgi_bi_Vgi_bi)+i2_Vgi_bi_Vgi_bi))))));
  qsch_Vgi_bi_Vdi_bi=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi)))+qdeff_Vdi_bi)+i2_Vdi_bi)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi)))+qdeff_Vdi_bi)+i2_Vdi_bi)))*(4.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi)))+qdeff_Vdi_bi)+i2_Vdi_bi)+0.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi)+4.0*(+(+(+qdeff_Vgi_bi_Vdi_bi*qdeff+qdeff_Vgi_bi*qdeff_Vdi_bi+qdeff_Vdi_bi*qdeff_Vgi_bi+qdeff*qdeff_Vgi_bi_Vdi_bi)+qdeff_Vgi_bi_Vdi_bi)+i2_Vgi_bi_Vdi_bi))))));
  qsch_Vgi_bi_Vsi_bi=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi)))+qdeff_Vsi_bi)+i2_Vsi_bi)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi)))+qdeff_Vsi_bi)+i2_Vsi_bi)))*(4.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi)))+qdeff_Vsi_bi)+i2_Vsi_bi)+0.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi)+4.0*(+(+(+qdeff_Vgi_bi_Vsi_bi*qdeff+qdeff_Vgi_bi*qdeff_Vsi_bi+qdeff_Vsi_bi*qdeff_Vgi_bi+qdeff*qdeff_Vgi_bi_Vsi_bi)+qdeff_Vgi_bi_Vsi_bi)+i2_Vgi_bi_Vsi_bi))))));
  qsch_Vgi_bi_Tempt_GND=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND)))+qdeff_Tempt_GND)+i2_Tempt_GND)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND)))+qdeff_Tempt_GND)+i2_Tempt_GND)))*(4.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND)))+qdeff_Tempt_GND)+i2_Tempt_GND)+0.0*((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi))+qdeff_Vgi_bi)+i2_Vgi_bi)+4.0*(+(+(+qdeff_Vgi_bi_Tempt_GND*qdeff+qdeff_Vgi_bi*qdeff_Tempt_GND+qdeff_Tempt_GND*qdeff_Vgi_bi+qdeff*qdeff_Vgi_bi_Tempt_GND)+qdeff_Vgi_bi_Tempt_GND)+i2_Vgi_bi_Tempt_GND))))));
#endif
qsch_Vdi_bi=(0.5*(4.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  qsch_Vdi_bi_Vgi_bi=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi)))+qdeff_Vgi_bi)+i2_Vgi_bi)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi)))+qdeff_Vgi_bi)+i2_Vgi_bi)))*(4.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi)))+qdeff_Vgi_bi)+i2_Vgi_bi)+0.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi)+4.0*(+(+(+qdeff_Vdi_bi_Vgi_bi*qdeff+qdeff_Vdi_bi*qdeff_Vgi_bi+qdeff_Vgi_bi*qdeff_Vdi_bi+qdeff*qdeff_Vdi_bi_Vgi_bi)+qdeff_Vdi_bi_Vgi_bi)+i2_Vdi_bi_Vgi_bi))))));
  qsch_Vdi_bi_Vdi_bi=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi)))+qdeff_Vdi_bi)+i2_Vdi_bi)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi)))+qdeff_Vdi_bi)+i2_Vdi_bi)))*(4.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi)))+qdeff_Vdi_bi)+i2_Vdi_bi)+0.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi)+4.0*(+(+(+qdeff_Vdi_bi_Vdi_bi*qdeff+qdeff_Vdi_bi*qdeff_Vdi_bi+qdeff_Vdi_bi*qdeff_Vdi_bi+qdeff*qdeff_Vdi_bi_Vdi_bi)+qdeff_Vdi_bi_Vdi_bi)+i2_Vdi_bi_Vdi_bi))))));
  qsch_Vdi_bi_Vsi_bi=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi)))+qdeff_Vsi_bi)+i2_Vsi_bi)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi)))+qdeff_Vsi_bi)+i2_Vsi_bi)))*(4.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi)))+qdeff_Vsi_bi)+i2_Vsi_bi)+0.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi)+4.0*(+(+(+qdeff_Vdi_bi_Vsi_bi*qdeff+qdeff_Vdi_bi*qdeff_Vsi_bi+qdeff_Vsi_bi*qdeff_Vdi_bi+qdeff*qdeff_Vdi_bi_Vsi_bi)+qdeff_Vdi_bi_Vsi_bi)+i2_Vdi_bi_Vsi_bi))))));
  qsch_Vdi_bi_Tempt_GND=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND)))+qdeff_Tempt_GND)+i2_Tempt_GND)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND)))+qdeff_Tempt_GND)+i2_Tempt_GND)))*(4.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND)))+qdeff_Tempt_GND)+i2_Tempt_GND)+0.0*((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi))+qdeff_Vdi_bi)+i2_Vdi_bi)+4.0*(+(+(+qdeff_Vdi_bi_Tempt_GND*qdeff+qdeff_Vdi_bi*qdeff_Tempt_GND+qdeff_Tempt_GND*qdeff_Vdi_bi+qdeff*qdeff_Vdi_bi_Tempt_GND)+qdeff_Vdi_bi_Tempt_GND)+i2_Vdi_bi_Tempt_GND))))));
#endif
qsch_Vsi_bi=(0.5*(4.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  qsch_Vsi_bi_Vgi_bi=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi)))+qdeff_Vgi_bi)+i2_Vgi_bi)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi)))+qdeff_Vgi_bi)+i2_Vgi_bi)))*(4.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Vgi_bi*qdeff)+(qdeff*qdeff_Vgi_bi)))+qdeff_Vgi_bi)+i2_Vgi_bi)+0.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi)+4.0*(+(+(+qdeff_Vsi_bi_Vgi_bi*qdeff+qdeff_Vsi_bi*qdeff_Vgi_bi+qdeff_Vgi_bi*qdeff_Vsi_bi+qdeff*qdeff_Vsi_bi_Vgi_bi)+qdeff_Vsi_bi_Vgi_bi)+i2_Vsi_bi_Vgi_bi))))));
  qsch_Vsi_bi_Vdi_bi=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi)))+qdeff_Vdi_bi)+i2_Vdi_bi)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi)))+qdeff_Vdi_bi)+i2_Vdi_bi)))*(4.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Vdi_bi*qdeff)+(qdeff*qdeff_Vdi_bi)))+qdeff_Vdi_bi)+i2_Vdi_bi)+0.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi)+4.0*(+(+(+qdeff_Vsi_bi_Vdi_bi*qdeff+qdeff_Vsi_bi*qdeff_Vdi_bi+qdeff_Vdi_bi*qdeff_Vsi_bi+qdeff*qdeff_Vsi_bi_Vdi_bi)+qdeff_Vsi_bi_Vdi_bi)+i2_Vsi_bi_Vdi_bi))))));
  qsch_Vsi_bi_Vsi_bi=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi)))+qdeff_Vsi_bi)+i2_Vsi_bi)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi)))+qdeff_Vsi_bi)+i2_Vsi_bi)))*(4.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi)))+qdeff_Vsi_bi)+i2_Vsi_bi)+0.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi)+4.0*(+(+(+qdeff_Vsi_bi_Vsi_bi*qdeff+qdeff_Vsi_bi*qdeff_Vsi_bi+qdeff_Vsi_bi*qdeff_Vsi_bi+qdeff*qdeff_Vsi_bi_Vsi_bi)+qdeff_Vsi_bi_Vsi_bi)+i2_Vsi_bi_Vsi_bi))))));
  qsch_Vsi_bi_Tempt_GND=(+0.0+(+0.0*d00_sqrt0+0.0*((4.0*(((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND)))+qdeff_Tempt_GND)+i2_Tempt_GND)))*d10_sqrt0+0.0*(4.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi))*d10_sqrt0+0.5*(m20_sqrt((1.0+(4.0*(((qdeff*qdeff)+qdeff)+i2))))*((4.0*(((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND)))+qdeff_Tempt_GND)+i2_Tempt_GND)))*(4.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi))+d10_sqrt0*(+0.0+(+0.0*(((qdeff*qdeff)+qdeff)+i2)+0.0*(((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND)))+qdeff_Tempt_GND)+i2_Tempt_GND)+0.0*((((qdeff_Vsi_bi*qdeff)+(qdeff*qdeff_Vsi_bi))+qdeff_Vsi_bi)+i2_Vsi_bi)+4.0*(+(+(+qdeff_Vsi_bi_Tempt_GND*qdeff+qdeff_Vsi_bi*qdeff_Tempt_GND+qdeff_Tempt_GND*qdeff_Vsi_bi+qdeff*qdeff_Vsi_bi_Tempt_GND)+qdeff_Vsi_bi_Tempt_GND)+i2_Vsi_bi_Tempt_GND))))));
#endif
#if defined(_DERIVATE)
qsch_Tempt_GND=(0.5*(4.0*((((qdeff_Tempt_GND*qdeff)+(qdeff*qdeff_Tempt_GND))+qdeff_Tempt_GND)+i2_Tempt_GND))*d10_sqrt0);
#endif
#endif
qsch=((-0.5)+(0.5*d00_sqrt0));
EXIT_IF_ISNAN(((-0.5)+(0.5*d00_sqrt0)))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
gds_h_Tempt_GND=(((((((2.0*nq_h_Tempt_GND)*beta_h)+((2.0*nq_h)*beta_h_Tempt_GND))*Vt)+(((2.0*nq_h)*beta_h)*Vt_Tempt_GND))*qdh)+((((2.0*nq_h)*beta_h)*Vt)*qdh_Tempt_GND));
gds_h_Vdbulk_di=(((2.0*nq_h_Vdbulk_di)*beta_h*Vt*qdh)+((((2.0*nq_h)*beta_h)*Vt)*qdh_Vdbulk_di));
gds_h_Vsbulk_si=(((2.0*nq_h_Vsbulk_si)*beta_h*Vt*qdh)+((((2.0*nq_h)*beta_h)*Vt)*qdh_Vsbulk_si));
gds_h_Vgi_bi=(((((2.0*nq_h_Vgi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vgi_bi))*Vt*qdh)+((((2.0*nq_h)*beta_h)*Vt)*qdh_Vgi_bi));
gds_h_Vdi_bi=(((((2.0*nq_h_Vdi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vdi_bi))*Vt*qdh)+((((2.0*nq_h)*beta_h)*Vt)*qdh_Vdi_bi));
gds_h_Vsi_bi=(((((2.0*nq_h_Vsi_bi)*beta_h)+((2.0*nq_h)*beta_h_Vsi_bi))*Vt*qdh)+((((2.0*nq_h)*beta_h)*Vt)*qdh_Vsi_bi));
#endif
gds_h=((((2.0*nq_h)*beta_h)*Vt)*qdh);
EXIT_IF_ISNAN(((((2.0*nq_h)*beta_h)*Vt)*qdh))
#if defined(_DERIVATE) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe= */
gds_ch_Vgi_bi=(((((2.0*nq_Vgi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vgi_bi))*Vt*qdeff)+((((2.0*nq)*beta_ch)*Vt)*qdeff_Vgi_bi));
gds_ch_Tempt_GND=(((((((2.0*nq_Tempt_GND)*beta_ch)+((2.0*nq)*beta_ch_Tempt_GND))*Vt)+(((2.0*nq)*beta_ch)*Vt_Tempt_GND))*qdeff)+((((2.0*nq)*beta_ch)*Vt)*qdeff_Tempt_GND));
gds_ch_Vdi_bi=(((((2.0*nq_Vdi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vdi_bi))*Vt*qdeff)+((((2.0*nq)*beta_ch)*Vt)*qdeff_Vdi_bi));
gds_ch_Vsi_bi=(((((2.0*nq_Vsi_bi)*beta_ch)+((2.0*nq)*beta_ch_Vsi_bi))*Vt*qdeff)+((((2.0*nq)*beta_ch)*Vt)*qdeff_Vsi_bi));
#endif
gds_ch=((((2.0*nq)*beta_ch)*Vt)*qdeff);
EXIT_IF_ISNAN(((((2.0*nq)*beta_ch)*Vt)*qdeff))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe= */
gm_ch_Tempt_GND=(((((2.0*beta_ch_Tempt_GND)*Vt)+((2.0*beta_ch)*Vt_Tempt_GND))*(qsch-qdeff))+(((2.0*beta_ch)*Vt)*(qsch_Tempt_GND-qdeff_Tempt_GND)));
gm_ch_Vdi_bi=(((2.0*beta_ch_Vdi_bi)*Vt*(qsch-qdeff))+(((2.0*beta_ch)*Vt)*(qsch_Vdi_bi-qdeff_Vdi_bi)));
gm_ch_Vsi_bi=(((2.0*beta_ch_Vsi_bi)*Vt*(qsch-qdeff))+(((2.0*beta_ch)*Vt)*(qsch_Vsi_bi-qdeff_Vsi_bi)));
gm_ch_Vgi_bi=(((2.0*beta_ch_Vgi_bi)*Vt*(qsch-qdeff))+(((2.0*beta_ch)*Vt)*(qsch_Vgi_bi-qdeff_Vgi_bi)));
#endif
gm_ch=(((2.0*beta_ch)*Vt)*(qsch-qdeff));
EXIT_IF_ISNAN((((2.0*beta_ch)*Vt)*(qsch-qdeff)))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
R_ch_Tempt_GND=gds_h_Tempt_GND*(LeffnoiH-pModel->LH);
R_ch_Vdbulk_di=gds_h_Vdbulk_di*(LeffnoiH-pModel->LH);
R_ch_Vsbulk_si=gds_h_Vsbulk_si*(LeffnoiH-pModel->LH);
R_ch_Vgi_bi=gds_h_Vgi_bi*(LeffnoiH-pModel->LH);
R_ch_Vdi_bi=gds_h_Vdi_bi*(LeffnoiH-pModel->LH);
R_ch_Vsi_bi=gds_h_Vsi_bi*(LeffnoiH-pModel->LH);
#endif
R_ch=(gds_h*(LeffnoiH-pModel->LH));
EXIT_IF_ISNAN((gds_h*(LeffnoiH-pModel->LH)))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe= */
R_h_Tempt_GND=(gm_ch_Tempt_GND*pModel->LH+gds_ch_Tempt_GND*pModel->LH);
R_h_Vdi_bi=(gm_ch_Vdi_bi*pModel->LH+gds_ch_Vdi_bi*pModel->LH);
R_h_Vsi_bi=(gm_ch_Vsi_bi*pModel->LH+gds_ch_Vsi_bi*pModel->LH);
R_h_Vgi_bi=(gm_ch_Vgi_bi*pModel->LH+gds_ch_Vgi_bi*pModel->LH);
#endif
R_h=((gm_ch*pModel->LH)+(gds_ch*pModel->LH));
EXIT_IF_ISNAN(((gm_ch*pModel->LH)+(gds_ch*pModel->LH)))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
t_tot_Tempt_GND=(((-(R_ch_Tempt_GND+R_h_Tempt_GND)/(R_ch+R_h)/(R_ch+R_h))*(R_ch+R_h)-(1.0/(R_ch+R_h))*(R_ch_Tempt_GND+R_h_Tempt_GND))/(R_ch+R_h)/(R_ch+R_h));
t_tot_Vdbulk_di=(((-R_ch_Vdbulk_di/(R_ch+R_h)/(R_ch+R_h))*(R_ch+R_h)-(1.0/(R_ch+R_h))*R_ch_Vdbulk_di)/(R_ch+R_h)/(R_ch+R_h));
t_tot_Vsbulk_si=(((-R_ch_Vsbulk_si/(R_ch+R_h)/(R_ch+R_h))*(R_ch+R_h)-(1.0/(R_ch+R_h))*R_ch_Vsbulk_si)/(R_ch+R_h)/(R_ch+R_h));
t_tot_Vgi_bi=(((-(R_ch_Vgi_bi+R_h_Vgi_bi)/(R_ch+R_h)/(R_ch+R_h))*(R_ch+R_h)-(1.0/(R_ch+R_h))*(R_ch_Vgi_bi+R_h_Vgi_bi))/(R_ch+R_h)/(R_ch+R_h));
t_tot_Vdi_bi=(((-(R_ch_Vdi_bi+R_h_Vdi_bi)/(R_ch+R_h)/(R_ch+R_h))*(R_ch+R_h)-(1.0/(R_ch+R_h))*(R_ch_Vdi_bi+R_h_Vdi_bi))/(R_ch+R_h)/(R_ch+R_h));
t_tot_Vsi_bi=(((-(R_ch_Vsi_bi+R_h_Vsi_bi)/(R_ch+R_h)/(R_ch+R_h))*(R_ch+R_h)-(1.0/(R_ch+R_h))*(R_ch_Vsi_bi+R_h_Vsi_bi))/(R_ch+R_h)/(R_ch+R_h));
#endif
t_tot=((1.0/(R_ch+R_h))/(R_ch+R_h));
EXIT_IF_ISNAN(((1.0/(R_ch+R_h))/(R_ch+R_h)))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
CF_ch_Tempt_GND=((((R_ch_Tempt_GND*R_ch)+(R_ch*R_ch_Tempt_GND))*t_tot)+((R_ch*R_ch)*t_tot_Tempt_GND));
CF_ch_Vdbulk_di=((((R_ch_Vdbulk_di*R_ch)+(R_ch*R_ch_Vdbulk_di))*t_tot)+((R_ch*R_ch)*t_tot_Vdbulk_di));
CF_ch_Vsbulk_si=((((R_ch_Vsbulk_si*R_ch)+(R_ch*R_ch_Vsbulk_si))*t_tot)+((R_ch*R_ch)*t_tot_Vsbulk_si));
CF_ch_Vgi_bi=((((R_ch_Vgi_bi*R_ch)+(R_ch*R_ch_Vgi_bi))*t_tot)+((R_ch*R_ch)*t_tot_Vgi_bi));
CF_ch_Vdi_bi=((((R_ch_Vdi_bi*R_ch)+(R_ch*R_ch_Vdi_bi))*t_tot)+((R_ch*R_ch)*t_tot_Vdi_bi));
CF_ch_Vsi_bi=((((R_ch_Vsi_bi*R_ch)+(R_ch*R_ch_Vsi_bi))*t_tot)+((R_ch*R_ch)*t_tot_Vsi_bi));
#endif
CF_ch=((R_ch*R_ch)*t_tot);
EXIT_IF_ISNAN(((R_ch*R_ch)*t_tot))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
CF_h_Tempt_GND=((((R_h_Tempt_GND*R_h)+(R_h*R_h_Tempt_GND))*t_tot)+((R_h*R_h)*t_tot_Tempt_GND));
CF_h_Vdi_bi=((((R_h_Vdi_bi*R_h)+(R_h*R_h_Vdi_bi))*t_tot)+((R_h*R_h)*t_tot_Vdi_bi));
CF_h_Vsi_bi=((((R_h_Vsi_bi*R_h)+(R_h*R_h_Vsi_bi))*t_tot)+((R_h*R_h)*t_tot_Vsi_bi));
CF_h_Vgi_bi=((((R_h_Vgi_bi*R_h)+(R_h*R_h_Vgi_bi))*t_tot)+((R_h*R_h)*t_tot_Vgi_bi));
CF_h_Vdbulk_di=((R_h*R_h)*t_tot_Vdbulk_di);
CF_h_Vsbulk_si=((R_h*R_h)*t_tot_Vsbulk_si);
#endif
CF_h=((R_h*R_h)*t_tot);
EXIT_IF_ISNAN(((R_h*R_h)*t_tot))
if
((Leff!=pModel->LH))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
Np2_Vgi_bi=((((2.0*nq_Vgi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi))/1.60219e-19);
#if defined(_DERIVATE2)
  Np2_Vgi_bi_Vgi_bi=((+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vgi_bi)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*0.0+(((2.0*nq_Vgi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vgi_bi)*Cox*Vt*qsch_Vgi_bi+((((2.0*nq_Vgi_bi))*Cox)*Vt)*qsch_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi_Vgi_bi)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi))*0.0+(((((((2.0*nq_Vgi_bi))*Cox)*Vt)*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Np2_Vgi_bi_Tempt_GND=((+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Tempt_GND)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*Vt_Tempt_GND+(((2.0*nq_Tempt_GND))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vgi_bi)*Cox*Vt*qsch_Tempt_GND+((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qsch_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi_Tempt_GND)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi))*0.0+(((((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Tempt_GND)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Np2_Vgi_bi_Vdi_bi=((+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdi_bi)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*0.0+(((2.0*nq_Vdi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vgi_bi)*Cox*Vt*qsch_Vdi_bi+((((2.0*nq_Vdi_bi))*Cox)*Vt)*qsch_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi_Vdi_bi)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi))*0.0+(((((((2.0*nq_Vdi_bi))*Cox)*Vt)*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Np2_Vgi_bi_Vsi_bi=((+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsi_bi)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*0.0+(((2.0*nq_Vsi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vgi_bi)*Cox*Vt*qsch_Vsi_bi+((((2.0*nq_Vsi_bi))*Cox)*Vt)*qsch_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi_Vsi_bi)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi))*0.0+(((((((2.0*nq_Vsi_bi))*Cox)*Vt)*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
#endif
#if defined(_DERIVATE)
Np2_Tempt_GND=((((((2.0*nq_Tempt_GND)*Cox*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND))*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Tempt_GND))/1.60219e-19);
#endif
Np2_Vdi_bi=((((2.0*nq_Vdi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi))/1.60219e-19);
#if defined(_DERIVATE2)
  Np2_Vdi_bi_Vgi_bi=((+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vgi_bi)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*0.0+(((2.0*nq_Vgi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vdi_bi)*Cox*Vt*qsch_Vgi_bi+((((2.0*nq_Vgi_bi))*Cox)*Vt)*qsch_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi_Vgi_bi)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi))*0.0+(((((((2.0*nq_Vgi_bi))*Cox)*Vt)*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Np2_Vdi_bi_Tempt_GND=((+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Tempt_GND)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*Vt_Tempt_GND+(((2.0*nq_Tempt_GND))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vdi_bi)*Cox*Vt*qsch_Tempt_GND+((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qsch_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi_Tempt_GND)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi))*0.0+(((((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Tempt_GND)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Np2_Vdi_bi_Vdi_bi=((+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdi_bi)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*0.0+(((2.0*nq_Vdi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vdi_bi)*Cox*Vt*qsch_Vdi_bi+((((2.0*nq_Vdi_bi))*Cox)*Vt)*qsch_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi_Vdi_bi)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi))*0.0+(((((((2.0*nq_Vdi_bi))*Cox)*Vt)*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Np2_Vdi_bi_Vsi_bi=((+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsi_bi)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*0.0+(((2.0*nq_Vsi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vdi_bi)*Cox*Vt*qsch_Vsi_bi+((((2.0*nq_Vsi_bi))*Cox)*Vt)*qsch_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi_Vsi_bi)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi))*0.0+(((((((2.0*nq_Vsi_bi))*Cox)*Vt)*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
#endif
Np2_Vsi_bi=((((2.0*nq_Vsi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi))/1.60219e-19);
#if defined(_DERIVATE2)
  Np2_Vsi_bi_Vgi_bi=((+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vgi_bi)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*0.0+(((2.0*nq_Vgi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vsi_bi)*Cox*Vt*qsch_Vgi_bi+((((2.0*nq_Vgi_bi))*Cox)*Vt)*qsch_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi_Vgi_bi)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi))*0.0+(((((((2.0*nq_Vgi_bi))*Cox)*Vt)*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vgi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Np2_Vsi_bi_Tempt_GND=((+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Tempt_GND)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*Vt_Tempt_GND+(((2.0*nq_Tempt_GND))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vsi_bi)*Cox*Vt*qsch_Tempt_GND+((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qsch_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi_Tempt_GND)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi))*0.0+(((((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Tempt_GND)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Np2_Vsi_bi_Vdi_bi=((+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdi_bi)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*0.0+(((2.0*nq_Vdi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vsi_bi)*Cox*Vt*qsch_Vdi_bi+((((2.0*nq_Vdi_bi))*Cox)*Vt)*qsch_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi_Vdi_bi)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi))*0.0+(((((((2.0*nq_Vdi_bi))*Cox)*Vt)*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vdi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  Np2_Vsi_bi_Vsi_bi=((+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsi_bi)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*0.0+(((2.0*nq_Vsi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qsch+(2.0*nq_Vsi_bi)*Cox*Vt*qsch_Vsi_bi+((((2.0*nq_Vsi_bi))*Cox)*Vt)*qsch_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi_Vsi_bi)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi))*0.0+(((((((2.0*nq_Vsi_bi))*Cox)*Vt)*qsch)+((((2.0*nq)*Cox)*Vt)*qsch_Vsi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qsch)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qsch)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
#endif
#endif
Np2=(((((2.0*nq)*Cox)*Vt)*qsch)/1.60219e-19);
EXIT_IF_ISNAN((((((2.0*nq)*Cox)*Vt)*qsch)/1.60219e-19))
Leffnoi=((LeffnoiH-(2.0*LINTNOI_i))-pModel->LH);
EXIT_IF_ISNAN(((LeffnoiH-(2.0*LINTNOI_i))-pModel->LH))
Leffnoisq=(Leffnoi*Leffnoi);
EXIT_IF_ISNAN((Leffnoi*Leffnoi))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=((1.0e10*Cox)*Leffnoisq);
EXIT_IF_ISNAN(((1.0e10*Cox)*Leffnoisq))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(pModel->NOIA*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-(Np2_Vgi_bi*0.0+0.0*Nl_Vgi_bi+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*Nl_Vgi_bi*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vgi_bi_Vgm_si=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-(Np2_Vgi_bi*0.0+0.0*Nl_Vgi_bi+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*Nl_Vgi_bi*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-(Np2_Vgi_bi*0.0+0.0*Nl_Vgi_bi+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*Nl_Vgi_bi*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-(Np2_Vgi_bi*0.0+0.0*Nl_Vgi_bi+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*Nl_Vgi_bi*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vgi_bi_Vgi_bi+0.0)/(Nl+Nstar)-(Np2_Vgi_bi*Nl_Vgi_bi+Np2_Vgi_bi*Nl_Vgi_bi+(Np2+Nstar)*(+Nl_Vgi_bi_Vgi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*Nl_Vgi_bi*Nl_Vgi_bi/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vgi_bi_Vdi_bi+0.0)/(Nl+Nstar)-(Np2_Vgi_bi*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2_Vdi_bi+Nstar_Vdi_bi)*Nl_Vgi_bi+(Np2+Nstar)*(+Nl_Vgi_bi_Vdi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*Nl_Vgi_bi*(Nl_Vdi_bi+Nstar_Vdi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vgi_bi_Vsi_bi+0.0)/(Nl+Nstar)-(Np2_Vgi_bi*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2_Vsi_bi+Nstar_Vsi_bi)*Nl_Vgi_bi+(Np2+Nstar)*(+Nl_Vgi_bi_Vsi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*Nl_Vgi_bi*(Nl_Vsi_bi+Nstar_Vsi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),((Np2_Vgi_bi*(Nl+Nstar)-(Np2+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vgi_bi_Tempt_GND+0.0)/(Nl+Nstar)-(Np2_Vgi_bi*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Np2_Tempt_GND+Nstar_Tempt_GND)*Nl_Vgi_bi+(Np2+Nstar)*(+Nl_Vgi_bi_Tempt_GND+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*Nl_Vgi_bi*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
T2_Vdi_bi=(pModel->NOIA*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((Np2_Vdi_bi+Nstar_Vdi_bi)*0.0+0.0*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vdi_bi_Vgm_si=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((Np2_Vdi_bi+Nstar_Vdi_bi)*0.0+0.0*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((Np2_Vdi_bi+Nstar_Vdi_bi)*0.0+0.0*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((Np2_Vdi_bi+Nstar_Vdi_bi)*0.0+0.0*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vdi_bi_Vgi_bi+0.0)/(Nl+Nstar)-((Np2_Vdi_bi+Nstar_Vdi_bi)*Nl_Vgi_bi+Np2_Vgi_bi*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2+Nstar)*(+Nl_Vdi_bi_Vgi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*Nl_Vgi_bi/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vdi_bi_Vdi_bi+Nstar_Vdi_bi_Vdi_bi)/(Nl+Nstar)-((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2+Nstar)*(+Nl_Vdi_bi_Vdi_bi+Nstar_Vdi_bi_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vdi_bi_Vsi_bi+Nstar_Vdi_bi_Vsi_bi)/(Nl+Nstar)-((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2+Nstar)*(+Nl_Vdi_bi_Vsi_bi+Nstar_Vdi_bi_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vdi_bi_Tempt_GND+Nstar_Vdi_bi_Tempt_GND)/(Nl+Nstar)-((Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Np2_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2+Nstar)*(+Nl_Vdi_bi_Tempt_GND+Nstar_Vdi_bi_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
T2_Vsi_bi=(pModel->NOIA*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((Np2_Vsi_bi+Nstar_Vsi_bi)*0.0+0.0*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vsi_bi_Vgm_si=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((Np2_Vsi_bi+Nstar_Vsi_bi)*0.0+0.0*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((Np2_Vsi_bi+Nstar_Vsi_bi)*0.0+0.0*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((Np2_Vsi_bi+Nstar_Vsi_bi)*0.0+0.0*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vsi_bi_Vgi_bi+0.0)/(Nl+Nstar)-((Np2_Vsi_bi+Nstar_Vsi_bi)*Nl_Vgi_bi+Np2_Vgi_bi*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2+Nstar)*(+Nl_Vsi_bi_Vgi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*Nl_Vgi_bi/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vsi_bi_Vdi_bi+Nstar_Vsi_bi_Vdi_bi)/(Nl+Nstar)-((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(Np2_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2+Nstar)*(+Nl_Vsi_bi_Vdi_bi+Nstar_Vsi_bi_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vsi_bi_Vsi_bi+Nstar_Vsi_bi_Vsi_bi)/(Nl+Nstar)-((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2+Nstar)*(+Nl_Vsi_bi_Vsi_bi+Nstar_Vsi_bi_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T2_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+Np2_Vsi_bi_Tempt_GND+Nstar_Vsi_bi_Tempt_GND)/(Nl+Nstar)-((Np2_Vsi_bi+Nstar_Vsi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Np2_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(Np2+Nstar)*(+Nl_Vsi_bi_Tempt_GND+Nstar_Vsi_bi_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(Np2+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(pModel->NOIA*bsimbulk_d_lln(((Np2+Nstar)/(Nl+Nstar)),(((Np2_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(Np2+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar))));
#endif
#endif
T2=(pModel->NOIA*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar))));
EXIT_IF_ISNAN((pModel->NOIA*bsimbulk_lln(((Np2+Nstar)/(Nl+Nstar)))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=(pModel->NOIB*(Np2_Vgi_bi-Nl_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vgi_bi_Vgm_di=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vgi_bi_Vdbulk_di=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vgi_bi_Vsbulk_si=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vgi_bi_Vgi_bi=(+0.0*(Np2-Nl)+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+Np2_Vgi_bi_Vgi_bi-Nl_Vgi_bi_Vgi_bi));
  T3_Vgi_bi_Vdi_bi=(+0.0*(Np2-Nl)+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+Np2_Vgi_bi_Vdi_bi-Nl_Vgi_bi_Vdi_bi));
  T3_Vgi_bi_Vsi_bi=(+0.0*(Np2-Nl)+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+Np2_Vgi_bi_Vsi_bi-Nl_Vgi_bi_Vsi_bi));
  T3_Vgi_bi_Tempt_GND=(+0.0*(Np2-Nl)+0.0*(Np2_Tempt_GND-Nl_Tempt_GND)+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+Np2_Vgi_bi_Tempt_GND-Nl_Vgi_bi_Tempt_GND));
#endif
T3_Vdi_bi=(pModel->NOIB*(Np2_Vdi_bi-Nl_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vdi_bi_Vgm_di=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vdi_bi_Vdbulk_di=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vdi_bi_Vsbulk_si=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vdi_bi_Vgi_bi=(+0.0*(Np2-Nl)+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+Np2_Vdi_bi_Vgi_bi-Nl_Vdi_bi_Vgi_bi));
  T3_Vdi_bi_Vdi_bi=(+0.0*(Np2-Nl)+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+Np2_Vdi_bi_Vdi_bi-Nl_Vdi_bi_Vdi_bi));
  T3_Vdi_bi_Vsi_bi=(+0.0*(Np2-Nl)+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+Np2_Vdi_bi_Vsi_bi-Nl_Vdi_bi_Vsi_bi));
  T3_Vdi_bi_Tempt_GND=(+0.0*(Np2-Nl)+0.0*(Np2_Tempt_GND-Nl_Tempt_GND)+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+Np2_Vdi_bi_Tempt_GND-Nl_Vdi_bi_Tempt_GND));
#endif
T3_Vsi_bi=(pModel->NOIB*(Np2_Vsi_bi-Nl_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vsi_bi_Vgm_di=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vsi_bi_Vdbulk_di=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vsi_bi_Vsbulk_si=(+0.0*(Np2-Nl)+0.0*0.0+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+0.0-0.0));
  T3_Vsi_bi_Vgi_bi=(+0.0*(Np2-Nl)+0.0*(Np2_Vgi_bi-Nl_Vgi_bi)+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+Np2_Vsi_bi_Vgi_bi-Nl_Vsi_bi_Vgi_bi));
  T3_Vsi_bi_Vdi_bi=(+0.0*(Np2-Nl)+0.0*(Np2_Vdi_bi-Nl_Vdi_bi)+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+Np2_Vsi_bi_Vdi_bi-Nl_Vsi_bi_Vdi_bi));
  T3_Vsi_bi_Vsi_bi=(+0.0*(Np2-Nl)+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+Np2_Vsi_bi_Vsi_bi-Nl_Vsi_bi_Vsi_bi));
  T3_Vsi_bi_Tempt_GND=(+0.0*(Np2-Nl)+0.0*(Np2_Tempt_GND-Nl_Tempt_GND)+0.0*(Np2_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+Np2_Vsi_bi_Tempt_GND-Nl_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(pModel->NOIB*(Np2_Tempt_GND-Nl_Tempt_GND));
#endif
#endif
T3=(pModel->NOIB*(Np2-Nl));
EXIT_IF_ISNAN((pModel->NOIB*(Np2-Nl)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=((0.5*pModel->NOIC)*(((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi))));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vgi_bi*0.0+0.0*Np2_Vgi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vgi_bi*0.0+0.0*Nl_Vgi_bi+Nl*0.0)));
  T4_Vgi_bi_Vgm_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vgi_bi*0.0+0.0*Np2_Vgi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vgi_bi*0.0+0.0*Nl_Vgi_bi+Nl*0.0)));
  T4_Vgi_bi_Vdbulk_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vgi_bi*0.0+0.0*Np2_Vgi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vgi_bi*0.0+0.0*Nl_Vgi_bi+Nl*0.0)));
  T4_Vgi_bi_Vsbulk_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vgi_bi*0.0+0.0*Np2_Vgi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vgi_bi*0.0+0.0*Nl_Vgi_bi+Nl*0.0)));
  T4_Vgi_bi_Vgi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi)))-(((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi))))+(0.0)*(((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vgi_bi_Vgi_bi*Np2+Np2_Vgi_bi*Np2_Vgi_bi+Np2_Vgi_bi*Np2_Vgi_bi+Np2*Np2_Vgi_bi_Vgi_bi)-(+Nl_Vgi_bi_Vgi_bi*Nl+Nl_Vgi_bi*Nl_Vgi_bi+Nl_Vgi_bi*Nl_Vgi_bi+Nl*Nl_Vgi_bi_Vgi_bi)));
  T4_Vgi_bi_Vdi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi)))-(((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi))))+(0.0)*(((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vgi_bi_Vdi_bi*Np2+Np2_Vgi_bi*Np2_Vdi_bi+Np2_Vdi_bi*Np2_Vgi_bi+Np2*Np2_Vgi_bi_Vdi_bi)-(+Nl_Vgi_bi_Vdi_bi*Nl+Nl_Vgi_bi*Nl_Vdi_bi+Nl_Vdi_bi*Nl_Vgi_bi+Nl*Nl_Vgi_bi_Vdi_bi)));
  T4_Vgi_bi_Vsi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi)))-(((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi))))+(0.0)*(((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vgi_bi_Vsi_bi*Np2+Np2_Vgi_bi*Np2_Vsi_bi+Np2_Vsi_bi*Np2_Vgi_bi+Np2*Np2_Vgi_bi_Vsi_bi)-(+Nl_Vgi_bi_Vsi_bi*Nl+Nl_Vgi_bi*Nl_Vsi_bi+Nl_Vsi_bi*Nl_Vgi_bi+Nl*Nl_Vgi_bi_Vsi_bi)));
  T4_Vgi_bi_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Tempt_GND*Np2)+(Np2*Np2_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vgi_bi_Tempt_GND*Np2+Np2_Vgi_bi*Np2_Tempt_GND+Np2_Tempt_GND*Np2_Vgi_bi+Np2*Np2_Vgi_bi_Tempt_GND)-(+Nl_Vgi_bi_Tempt_GND*Nl+Nl_Vgi_bi*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Vgi_bi+Nl*Nl_Vgi_bi_Tempt_GND)));
#endif
T4_Vdi_bi=((0.5*pModel->NOIC)*(((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi))));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vdi_bi*0.0+0.0*Np2_Vdi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vdi_bi*0.0+0.0*Nl_Vdi_bi+Nl*0.0)));
  T4_Vdi_bi_Vgm_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vdi_bi*0.0+0.0*Np2_Vdi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vdi_bi*0.0+0.0*Nl_Vdi_bi+Nl*0.0)));
  T4_Vdi_bi_Vdbulk_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vdi_bi*0.0+0.0*Np2_Vdi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vdi_bi*0.0+0.0*Nl_Vdi_bi+Nl*0.0)));
  T4_Vdi_bi_Vsbulk_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vdi_bi*0.0+0.0*Np2_Vdi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vdi_bi*0.0+0.0*Nl_Vdi_bi+Nl*0.0)));
  T4_Vdi_bi_Vgi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi)))-(((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi))))+(0.0)*(((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vdi_bi_Vgi_bi*Np2+Np2_Vdi_bi*Np2_Vgi_bi+Np2_Vgi_bi*Np2_Vdi_bi+Np2*Np2_Vdi_bi_Vgi_bi)-(+Nl_Vdi_bi_Vgi_bi*Nl+Nl_Vdi_bi*Nl_Vgi_bi+Nl_Vgi_bi*Nl_Vdi_bi+Nl*Nl_Vdi_bi_Vgi_bi)));
  T4_Vdi_bi_Vdi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi)))-(((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi))))+(0.0)*(((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vdi_bi_Vdi_bi*Np2+Np2_Vdi_bi*Np2_Vdi_bi+Np2_Vdi_bi*Np2_Vdi_bi+Np2*Np2_Vdi_bi_Vdi_bi)-(+Nl_Vdi_bi_Vdi_bi*Nl+Nl_Vdi_bi*Nl_Vdi_bi+Nl_Vdi_bi*Nl_Vdi_bi+Nl*Nl_Vdi_bi_Vdi_bi)));
  T4_Vdi_bi_Vsi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi)))-(((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi))))+(0.0)*(((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vdi_bi_Vsi_bi*Np2+Np2_Vdi_bi*Np2_Vsi_bi+Np2_Vsi_bi*Np2_Vdi_bi+Np2*Np2_Vdi_bi_Vsi_bi)-(+Nl_Vdi_bi_Vsi_bi*Nl+Nl_Vdi_bi*Nl_Vsi_bi+Nl_Vsi_bi*Nl_Vdi_bi+Nl*Nl_Vdi_bi_Vsi_bi)));
  T4_Vdi_bi_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Tempt_GND*Np2)+(Np2*Np2_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vdi_bi_Tempt_GND*Np2+Np2_Vdi_bi*Np2_Tempt_GND+Np2_Tempt_GND*Np2_Vdi_bi+Np2*Np2_Vdi_bi_Tempt_GND)-(+Nl_Vdi_bi_Tempt_GND*Nl+Nl_Vdi_bi*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Vdi_bi+Nl*Nl_Vdi_bi_Tempt_GND)));
#endif
T4_Vsi_bi=((0.5*pModel->NOIC)*(((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi))));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vsi_bi*0.0+0.0*Np2_Vsi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vsi_bi*0.0+0.0*Nl_Vsi_bi+Nl*0.0)));
  T4_Vsi_bi_Vgm_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vsi_bi*0.0+0.0*Np2_Vsi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vsi_bi*0.0+0.0*Nl_Vsi_bi+Nl*0.0)));
  T4_Vsi_bi_Vdbulk_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vsi_bi*0.0+0.0*Np2_Vsi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vsi_bi*0.0+0.0*Nl_Vsi_bi+Nl*0.0)));
  T4_Vsi_bi_Vsbulk_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*Np2+Np2_Vsi_bi*0.0+0.0*Np2_Vsi_bi+Np2*0.0)-(+0.0*Nl+Nl_Vsi_bi*0.0+0.0*Nl_Vsi_bi+Nl*0.0)));
  T4_Vsi_bi_Vgi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Vgi_bi*Np2)+(Np2*Np2_Vgi_bi)))-(((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi))))+(0.0)*(((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vsi_bi_Vgi_bi*Np2+Np2_Vsi_bi*Np2_Vgi_bi+Np2_Vgi_bi*Np2_Vsi_bi+Np2*Np2_Vsi_bi_Vgi_bi)-(+Nl_Vsi_bi_Vgi_bi*Nl+Nl_Vsi_bi*Nl_Vgi_bi+Nl_Vgi_bi*Nl_Vsi_bi+Nl*Nl_Vsi_bi_Vgi_bi)));
  T4_Vsi_bi_Vdi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Vdi_bi*Np2)+(Np2*Np2_Vdi_bi)))-(((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi))))+(0.0)*(((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vsi_bi_Vdi_bi*Np2+Np2_Vsi_bi*Np2_Vdi_bi+Np2_Vdi_bi*Np2_Vsi_bi+Np2*Np2_Vsi_bi_Vdi_bi)-(+Nl_Vsi_bi_Vdi_bi*Nl+Nl_Vsi_bi*Nl_Vdi_bi+Nl_Vdi_bi*Nl_Vsi_bi+Nl*Nl_Vsi_bi_Vdi_bi)));
  T4_Vsi_bi_Vsi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi)))-(((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi))))+(0.0)*(((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vsi_bi_Vsi_bi*Np2+Np2_Vsi_bi*Np2_Vsi_bi+Np2_Vsi_bi*Np2_Vsi_bi+Np2*Np2_Vsi_bi_Vsi_bi)-(+Nl_Vsi_bi_Vsi_bi*Nl+Nl_Vsi_bi*Nl_Vsi_bi+Nl_Vsi_bi*Nl_Vsi_bi+Nl*Nl_Vsi_bi_Vsi_bi)));
  T4_Vsi_bi_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((Np2*Np2)-(Nl*Nl))+0.0*((((Np2_Tempt_GND*Np2)+(Np2*Np2_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((Np2_Vsi_bi*Np2)+(Np2*Np2_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+Np2_Vsi_bi_Tempt_GND*Np2+Np2_Vsi_bi*Np2_Tempt_GND+Np2_Tempt_GND*Np2_Vsi_bi+Np2*Np2_Vsi_bi_Tempt_GND)-(+Nl_Vsi_bi_Tempt_GND*Nl+Nl_Vsi_bi*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Vsi_bi+Nl*Nl_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=((0.5*pModel->NOIC)*(((Np2_Tempt_GND*Np2)+(Np2*Np2_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))));
#endif
#endif
T4=((0.5*pModel->NOIC)*((Np2*Np2)-(Nl*Nl)));
EXIT_IF_ISNAN(((0.5*pModel->NOIC)*((Np2*Np2)-(Nl*Nl))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=(((1.0e10*Leffnoisq)*Weff)*pInst->NF);
EXIT_IF_ISNAN((((1.0e10*Leffnoisq)*Weff)*pInst->NF))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
Ssi_ch_Tempt_GND=(((((T0a_Tempt_GND*T1-T0a*T1_Tempt_GND)/T1/T1)*((T2+T3)+T4))+((T0a/T1)*((T2_Tempt_GND+T3_Tempt_GND)+T4_Tempt_GND)))+((((((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND))*T0c)+(((T0b/T5)*DelClm)*T0c_Tempt_GND))*T0d-(((T0b/T5)*DelClm)*T0c)*T0d_Tempt_GND)/T0d/T0d));
#endif
Ssi_ch_Vgi_bi=(((((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2+T3)+T4))+((T0a/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)))+((((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi))*T0d-(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi)/T0d/T0d));
#if defined(_DERIVATE2)
  Ssi_ch_Vgi_bi_Tempt_GND=(+(+(T0a_Vgi_bi_Tempt_GND/T1-(T0a_Vgi_bi*T1_Tempt_GND+T0a_Tempt_GND*T1_Vgi_bi+T0a*T1_Vgi_bi_Tempt_GND)/T1/T1+2*T0a*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Tempt_GND+T3_Tempt_GND)+T4_Tempt_GND)+((T0a_Tempt_GND*T1-T0a*T1_Tempt_GND)/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+(T0a/T1)*(+(+T2_Vgi_bi_Tempt_GND+T3_Vgi_bi_Tempt_GND)+T4_Vgi_bi_Tempt_GND))+((+(+(T0b_Vgi_bi_Tempt_GND/T5-(T0b_Vgi_bi*T5_Tempt_GND+T0b_Tempt_GND*T5_Vgi_bi+T0b*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T0b*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)*DelClm+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Tempt_GND+((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm_Vgi_bi+(T0b/T5)*DelClm_Vgi_bi_Tempt_GND)*T0c+((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*T0c_Vgi_bi+((T0b/T5)*DelClm)*T0c_Vgi_bi_Tempt_GND)/T0d-(((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi))*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*T0c)+(((T0b/T5)*DelClm)*T0c_Tempt_GND)))*T0d_Vgi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi_Tempt_GND)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_ch_Vgi_bi_Vgi_bi=(+(+(T0a_Vgi_bi_Vgi_bi/T1-(T0a_Vgi_bi*T1_Vgi_bi+T0a_Vgi_bi*T1_Vgi_bi+T0a*T1_Vgi_bi_Vgi_bi)/T1/T1+2*T0a*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+(T0a/T1)*(+(+T2_Vgi_bi_Vgi_bi+T3_Vgi_bi_Vgi_bi)+T4_Vgi_bi_Vgi_bi))+((+(+(T0b_Vgi_bi_Vgi_bi/T5-(T0b_Vgi_bi*T5_Vgi_bi+T0b_Vgi_bi*T5_Vgi_bi+T0b*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T0b*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)*DelClm+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vgi_bi+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vgi_bi+(T0b/T5)*DelClm_Vgi_bi_Vgi_bi)*T0c+((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*T0c_Vgi_bi+((T0b/T5)*DelClm)*T0c_Vgi_bi_Vgi_bi)/T0d-(((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi))*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi)))*T0d_Vgi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi_Vgi_bi)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_ch_Vgi_bi_Vdi_bi=(+(+(T0a_Vgi_bi_Vdi_bi/T1-(T0a_Vgi_bi*T1_Vdi_bi+T0a_Vdi_bi*T1_Vgi_bi+T0a*T1_Vgi_bi_Vdi_bi)/T1/T1+2*T0a*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+(T0a/T1)*(+(+T2_Vgi_bi_Vdi_bi+T3_Vgi_bi_Vdi_bi)+T4_Vgi_bi_Vdi_bi))+((+(+(T0b_Vgi_bi_Vdi_bi/T5-(T0b_Vgi_bi*T5_Vdi_bi+T0b_Vdi_bi*T5_Vgi_bi+T0b*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T0b*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)*DelClm+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vdi_bi+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vgi_bi+(T0b/T5)*DelClm_Vgi_bi_Vdi_bi)*T0c+((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*T0c_Vgi_bi+((T0b/T5)*DelClm)*T0c_Vgi_bi_Vdi_bi)/T0d-(((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi))*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi)))*T0d_Vgi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi_Vdi_bi)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_ch_Vgi_bi_Vsi_bi=(+(+(T0a_Vgi_bi_Vsi_bi/T1-(T0a_Vgi_bi*T1_Vsi_bi+T0a_Vsi_bi*T1_Vgi_bi+T0a*T1_Vgi_bi_Vsi_bi)/T1/T1+2*T0a*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+(T0a/T1)*(+(+T2_Vgi_bi_Vsi_bi+T3_Vgi_bi_Vsi_bi)+T4_Vgi_bi_Vsi_bi))+((+(+(T0b_Vgi_bi_Vsi_bi/T5-(T0b_Vgi_bi*T5_Vsi_bi+T0b_Vsi_bi*T5_Vgi_bi+T0b*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T0b*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)*DelClm+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vsi_bi+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vgi_bi+(T0b/T5)*DelClm_Vgi_bi_Vsi_bi)*T0c+((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*T0c_Vgi_bi+((T0b/T5)*DelClm)*T0c_Vgi_bi_Vsi_bi)/T0d-(((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi))*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi)))*T0d_Vgi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi_Vsi_bi)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_ch_Vgi_bi_Vdbulk_di=(+(+(0.0/T1-(T0a_Vgi_bi*T1_Vdbulk_di+0.0*T1_Vgi_bi+T0a*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*T0a*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+(T0a/T1)*(+(+T2_Vgi_bi_Vdbulk_di+T3_Vgi_bi_Vdbulk_di)+T4_Vgi_bi_Vdbulk_di))+((+(+(0.0/T5-(T0b_Vgi_bi*T5_Vdbulk_di+0.0*T5_Vgi_bi+T0b*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T0b*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)*DelClm+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vdbulk_di+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vgi_bi+(T0b/T5)*DelClm_Vgi_bi_Vdbulk_di)*T0c+((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*0.0+((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*T0c_Vgi_bi+((T0b/T5)*DelClm)*0.0)/T0d-(((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi))*0.0+(((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*T0c)*T0d_Vgi_bi+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi*0.0/T0d/T0d/T0d));
  Ssi_ch_Vgi_bi_Vsbulk_si=(+(+(0.0/T1-(T0a_Vgi_bi*T1_Vsbulk_si+0.0*T1_Vgi_bi+T0a*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*T0a*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+(T0a/T1)*(+(+T2_Vgi_bi_Vsbulk_si+T3_Vgi_bi_Vsbulk_si)+T4_Vgi_bi_Vsbulk_si))+((+(+(0.0/T5-(T0b_Vgi_bi*T5_Vsbulk_si+0.0*T5_Vgi_bi+T0b*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T0b*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)*DelClm+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vsbulk_si+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vgi_bi+(T0b/T5)*DelClm_Vgi_bi_Vsbulk_si)*T0c+((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*0.0+((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*T0c_Vgi_bi+((T0b/T5)*DelClm)*0.0)/T0d-(((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi))*0.0+(((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*T0c)*T0d_Vgi_bi+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vgi_bi*0.0/T0d/T0d/T0d));
#endif
Ssi_ch_Vdi_bi=(((((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2+T3)+T4))+((T0a/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)))+((((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi))*T0d-(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi)/T0d/T0d));
#if defined(_DERIVATE2)
  Ssi_ch_Vdi_bi_Tempt_GND=(+(+(T0a_Vdi_bi_Tempt_GND/T1-(T0a_Vdi_bi*T1_Tempt_GND+T0a_Tempt_GND*T1_Vdi_bi+T0a*T1_Vdi_bi_Tempt_GND)/T1/T1+2*T0a*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Tempt_GND+T3_Tempt_GND)+T4_Tempt_GND)+((T0a_Tempt_GND*T1-T0a*T1_Tempt_GND)/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+(T0a/T1)*(+(+T2_Vdi_bi_Tempt_GND+T3_Vdi_bi_Tempt_GND)+T4_Vdi_bi_Tempt_GND))+((+(+(T0b_Vdi_bi_Tempt_GND/T5-(T0b_Vdi_bi*T5_Tempt_GND+T0b_Tempt_GND*T5_Vdi_bi+T0b*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T0b*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)*DelClm+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Tempt_GND+((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm_Vdi_bi+(T0b/T5)*DelClm_Vdi_bi_Tempt_GND)*T0c+((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*T0c_Vdi_bi+((T0b/T5)*DelClm)*T0c_Vdi_bi_Tempt_GND)/T0d-(((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi))*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*T0c)+(((T0b/T5)*DelClm)*T0c_Tempt_GND)))*T0d_Vdi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi_Tempt_GND)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_ch_Vdi_bi_Vgi_bi=(+(+(T0a_Vdi_bi_Vgi_bi/T1-(T0a_Vdi_bi*T1_Vgi_bi+T0a_Vgi_bi*T1_Vdi_bi+T0a*T1_Vdi_bi_Vgi_bi)/T1/T1+2*T0a*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+(T0a/T1)*(+(+T2_Vdi_bi_Vgi_bi+T3_Vdi_bi_Vgi_bi)+T4_Vdi_bi_Vgi_bi))+((+(+(T0b_Vdi_bi_Vgi_bi/T5-(T0b_Vdi_bi*T5_Vgi_bi+T0b_Vgi_bi*T5_Vdi_bi+T0b*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T0b*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)*DelClm+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vgi_bi+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vdi_bi+(T0b/T5)*DelClm_Vdi_bi_Vgi_bi)*T0c+((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*T0c_Vdi_bi+((T0b/T5)*DelClm)*T0c_Vdi_bi_Vgi_bi)/T0d-(((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi))*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi)))*T0d_Vdi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi_Vgi_bi)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_ch_Vdi_bi_Vdi_bi=(+(+(T0a_Vdi_bi_Vdi_bi/T1-(T0a_Vdi_bi*T1_Vdi_bi+T0a_Vdi_bi*T1_Vdi_bi+T0a*T1_Vdi_bi_Vdi_bi)/T1/T1+2*T0a*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+(T0a/T1)*(+(+T2_Vdi_bi_Vdi_bi+T3_Vdi_bi_Vdi_bi)+T4_Vdi_bi_Vdi_bi))+((+(+(T0b_Vdi_bi_Vdi_bi/T5-(T0b_Vdi_bi*T5_Vdi_bi+T0b_Vdi_bi*T5_Vdi_bi+T0b*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T0b*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)*DelClm+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vdi_bi+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vdi_bi+(T0b/T5)*DelClm_Vdi_bi_Vdi_bi)*T0c+((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*T0c_Vdi_bi+((T0b/T5)*DelClm)*T0c_Vdi_bi_Vdi_bi)/T0d-(((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi))*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi)))*T0d_Vdi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi_Vdi_bi)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_ch_Vdi_bi_Vsi_bi=(+(+(T0a_Vdi_bi_Vsi_bi/T1-(T0a_Vdi_bi*T1_Vsi_bi+T0a_Vsi_bi*T1_Vdi_bi+T0a*T1_Vdi_bi_Vsi_bi)/T1/T1+2*T0a*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+(T0a/T1)*(+(+T2_Vdi_bi_Vsi_bi+T3_Vdi_bi_Vsi_bi)+T4_Vdi_bi_Vsi_bi))+((+(+(T0b_Vdi_bi_Vsi_bi/T5-(T0b_Vdi_bi*T5_Vsi_bi+T0b_Vsi_bi*T5_Vdi_bi+T0b*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T0b*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)*DelClm+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vsi_bi+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vdi_bi+(T0b/T5)*DelClm_Vdi_bi_Vsi_bi)*T0c+((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*T0c_Vdi_bi+((T0b/T5)*DelClm)*T0c_Vdi_bi_Vsi_bi)/T0d-(((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi))*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi)))*T0d_Vdi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi_Vsi_bi)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_ch_Vdi_bi_Vdbulk_di=(+(+(0.0/T1-(T0a_Vdi_bi*T1_Vdbulk_di+0.0*T1_Vdi_bi+T0a*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*T0a*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+(T0a/T1)*(+(+T2_Vdi_bi_Vdbulk_di+T3_Vdi_bi_Vdbulk_di)+T4_Vdi_bi_Vdbulk_di))+((+(+(0.0/T5-(T0b_Vdi_bi*T5_Vdbulk_di+0.0*T5_Vdi_bi+T0b*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T0b*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)*DelClm+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vdbulk_di+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vdi_bi+(T0b/T5)*DelClm_Vdi_bi_Vdbulk_di)*T0c+((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*0.0+((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*T0c_Vdi_bi+((T0b/T5)*DelClm)*0.0)/T0d-(((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi))*0.0+(((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*T0c)*T0d_Vdi_bi+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi*0.0/T0d/T0d/T0d));
  Ssi_ch_Vdi_bi_Vsbulk_si=(+(+(0.0/T1-(T0a_Vdi_bi*T1_Vsbulk_si+0.0*T1_Vdi_bi+T0a*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*T0a*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+(T0a/T1)*(+(+T2_Vdi_bi_Vsbulk_si+T3_Vdi_bi_Vsbulk_si)+T4_Vdi_bi_Vsbulk_si))+((+(+(0.0/T5-(T0b_Vdi_bi*T5_Vsbulk_si+0.0*T5_Vdi_bi+T0b*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T0b*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)*DelClm+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vsbulk_si+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vdi_bi+(T0b/T5)*DelClm_Vdi_bi_Vsbulk_si)*T0c+((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*0.0+((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*T0c_Vdi_bi+((T0b/T5)*DelClm)*0.0)/T0d-(((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi))*0.0+(((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*T0c)*T0d_Vdi_bi+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vdi_bi*0.0/T0d/T0d/T0d));
#endif
Ssi_ch_Vsi_bi=(((((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2+T3)+T4))+((T0a/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)))+((((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi))*T0d-(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi)/T0d/T0d));
#if defined(_DERIVATE2)
  Ssi_ch_Vsi_bi_Tempt_GND=(+(+(T0a_Vsi_bi_Tempt_GND/T1-(T0a_Vsi_bi*T1_Tempt_GND+T0a_Tempt_GND*T1_Vsi_bi+T0a*T1_Vsi_bi_Tempt_GND)/T1/T1+2*T0a*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Tempt_GND+T3_Tempt_GND)+T4_Tempt_GND)+((T0a_Tempt_GND*T1-T0a*T1_Tempt_GND)/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+(T0a/T1)*(+(+T2_Vsi_bi_Tempt_GND+T3_Vsi_bi_Tempt_GND)+T4_Vsi_bi_Tempt_GND))+((+(+(T0b_Vsi_bi_Tempt_GND/T5-(T0b_Vsi_bi*T5_Tempt_GND+T0b_Tempt_GND*T5_Vsi_bi+T0b*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T0b*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)*DelClm+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Tempt_GND+((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm_Vsi_bi+(T0b/T5)*DelClm_Vsi_bi_Tempt_GND)*T0c+((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*T0c_Vsi_bi+((T0b/T5)*DelClm)*T0c_Vsi_bi_Tempt_GND)/T0d-(((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi))*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*T0c)+(((T0b/T5)*DelClm)*T0c_Tempt_GND)))*T0d_Vsi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi_Tempt_GND)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_ch_Vsi_bi_Vgi_bi=(+(+(T0a_Vsi_bi_Vgi_bi/T1-(T0a_Vsi_bi*T1_Vgi_bi+T0a_Vgi_bi*T1_Vsi_bi+T0a*T1_Vsi_bi_Vgi_bi)/T1/T1+2*T0a*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+(T0a/T1)*(+(+T2_Vsi_bi_Vgi_bi+T3_Vsi_bi_Vgi_bi)+T4_Vsi_bi_Vgi_bi))+((+(+(T0b_Vsi_bi_Vgi_bi/T5-(T0b_Vsi_bi*T5_Vgi_bi+T0b_Vgi_bi*T5_Vsi_bi+T0b*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T0b*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)*DelClm+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vgi_bi+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vsi_bi+(T0b/T5)*DelClm_Vsi_bi_Vgi_bi)*T0c+((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*T0c_Vsi_bi+((T0b/T5)*DelClm)*T0c_Vsi_bi_Vgi_bi)/T0d-(((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi))*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi)))*T0d_Vsi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi_Vgi_bi)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_ch_Vsi_bi_Vdi_bi=(+(+(T0a_Vsi_bi_Vdi_bi/T1-(T0a_Vsi_bi*T1_Vdi_bi+T0a_Vdi_bi*T1_Vsi_bi+T0a*T1_Vsi_bi_Vdi_bi)/T1/T1+2*T0a*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+(T0a/T1)*(+(+T2_Vsi_bi_Vdi_bi+T3_Vsi_bi_Vdi_bi)+T4_Vsi_bi_Vdi_bi))+((+(+(T0b_Vsi_bi_Vdi_bi/T5-(T0b_Vsi_bi*T5_Vdi_bi+T0b_Vdi_bi*T5_Vsi_bi+T0b*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T0b*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)*DelClm+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vdi_bi+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vsi_bi+(T0b/T5)*DelClm_Vsi_bi_Vdi_bi)*T0c+((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*T0c_Vsi_bi+((T0b/T5)*DelClm)*T0c_Vsi_bi_Vdi_bi)/T0d-(((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi))*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi)))*T0d_Vsi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi_Vdi_bi)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_ch_Vsi_bi_Vsi_bi=(+(+(T0a_Vsi_bi_Vsi_bi/T1-(T0a_Vsi_bi*T1_Vsi_bi+T0a_Vsi_bi*T1_Vsi_bi+T0a*T1_Vsi_bi_Vsi_bi)/T1/T1+2*T0a*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+(T0a/T1)*(+(+T2_Vsi_bi_Vsi_bi+T3_Vsi_bi_Vsi_bi)+T4_Vsi_bi_Vsi_bi))+((+(+(T0b_Vsi_bi_Vsi_bi/T5-(T0b_Vsi_bi*T5_Vsi_bi+T0b_Vsi_bi*T5_Vsi_bi+T0b*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T0b*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)*DelClm+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vsi_bi+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vsi_bi+(T0b/T5)*DelClm_Vsi_bi_Vsi_bi)*T0c+((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*T0c_Vsi_bi+((T0b/T5)*DelClm)*T0c_Vsi_bi_Vsi_bi)/T0d-(((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi))*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi)))*T0d_Vsi_bi+(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi_Vsi_bi)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_ch_Vsi_bi_Vdbulk_di=(+(+(0.0/T1-(T0a_Vsi_bi*T1_Vdbulk_di+0.0*T1_Vsi_bi+T0a*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*T0a*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+(T0a/T1)*(+(+T2_Vsi_bi_Vdbulk_di+T3_Vsi_bi_Vdbulk_di)+T4_Vsi_bi_Vdbulk_di))+((+(+(0.0/T5-(T0b_Vsi_bi*T5_Vdbulk_di+0.0*T5_Vsi_bi+T0b*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T0b*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)*DelClm+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vdbulk_di+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vsi_bi+(T0b/T5)*DelClm_Vsi_bi_Vdbulk_di)*T0c+((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*0.0+((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*T0c_Vsi_bi+((T0b/T5)*DelClm)*0.0)/T0d-(((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi))*0.0+(((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*T0c)*T0d_Vsi_bi+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi*0.0/T0d/T0d/T0d));
  Ssi_ch_Vsi_bi_Vsbulk_si=(+(+(0.0/T1-(T0a_Vsi_bi*T1_Vsbulk_si+0.0*T1_Vsi_bi+T0a*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*T0a*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1)*((T2+T3)+T4)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+(T0a/T1)*(+(+T2_Vsi_bi_Vsbulk_si+T3_Vsi_bi_Vsbulk_si)+T4_Vsi_bi_Vsbulk_si))+((+(+(0.0/T5-(T0b_Vsi_bi*T5_Vsbulk_si+0.0*T5_Vsi_bi+T0b*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T0b*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)*DelClm+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vsbulk_si+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vsi_bi+(T0b/T5)*DelClm_Vsi_bi_Vsbulk_si)*T0c+((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*0.0+((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*T0c_Vsi_bi+((T0b/T5)*DelClm)*0.0)/T0d-(((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi))*0.0+(((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*T0c)*T0d_Vsi_bi+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*T0d_Vsi_bi*0.0/T0d/T0d/T0d));
#endif
Ssi_ch_Vdbulk_di=((((-T0a*T1_Vdbulk_di/T1/T1)*((T2+T3)+T4))+((T0a/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)))+((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c/T0d));
#if defined(_DERIVATE2)
  Ssi_ch_Vdbulk_di_Tempt_GND=(+(+(0.0/T1-(0.0*T1_Tempt_GND+T0a_Tempt_GND*T1_Vdbulk_di+T0a*T1_Vdbulk_di_Tempt_GND)/T1/T1+2*T0a*T1_Vdbulk_di*T1_Tempt_GND/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Tempt_GND+T3_Tempt_GND)+T4_Tempt_GND)+((T0a_Tempt_GND*T1-T0a*T1_Tempt_GND)/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(T0a/T1)*(+(+T2_Vdbulk_di_Tempt_GND+T3_Vdbulk_di_Tempt_GND)+T4_Vdbulk_di_Tempt_GND))+((+(+(0.0/T5-(0.0*T5_Tempt_GND+T0b_Tempt_GND*T5_Vdbulk_di+T0b*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T0b*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5)*DelClm+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Tempt_GND+((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm_Vdbulk_di+(T0b/T5)*DelClm_Vdbulk_di_Tempt_GND)*T0c+(((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*T0c)+(((T0b/T5)*DelClm)*T0c_Tempt_GND)))*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_ch_Vdbulk_di_Vgi_bi=(+(+(0.0/T1-(0.0*T1_Vgi_bi+T0a_Vgi_bi*T1_Vdbulk_di+T0a*T1_Vdbulk_di_Vgi_bi)/T1/T1+2*T0a*T1_Vdbulk_di*T1_Vgi_bi/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(T0a/T1)*(+(+T2_Vdbulk_di_Vgi_bi+T3_Vdbulk_di_Vgi_bi)+T4_Vdbulk_di_Vgi_bi))+((+(+(0.0/T5-(0.0*T5_Vgi_bi+T0b_Vgi_bi*T5_Vdbulk_di+T0b*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T0b*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5)*DelClm+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vgi_bi+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vdbulk_di+(T0b/T5)*DelClm_Vdbulk_di_Vgi_bi)*T0c+(((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi)))*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_ch_Vdbulk_di_Vdi_bi=(+(+(0.0/T1-(0.0*T1_Vdi_bi+T0a_Vdi_bi*T1_Vdbulk_di+T0a*T1_Vdbulk_di_Vdi_bi)/T1/T1+2*T0a*T1_Vdbulk_di*T1_Vdi_bi/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(T0a/T1)*(+(+T2_Vdbulk_di_Vdi_bi+T3_Vdbulk_di_Vdi_bi)+T4_Vdbulk_di_Vdi_bi))+((+(+(0.0/T5-(0.0*T5_Vdi_bi+T0b_Vdi_bi*T5_Vdbulk_di+T0b*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T0b*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5)*DelClm+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vdi_bi+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vdbulk_di+(T0b/T5)*DelClm_Vdbulk_di_Vdi_bi)*T0c+(((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi)))*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_ch_Vdbulk_di_Vsi_bi=(+(+(0.0/T1-(0.0*T1_Vsi_bi+T0a_Vsi_bi*T1_Vdbulk_di+T0a*T1_Vdbulk_di_Vsi_bi)/T1/T1+2*T0a*T1_Vdbulk_di*T1_Vsi_bi/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(T0a/T1)*(+(+T2_Vdbulk_di_Vsi_bi+T3_Vdbulk_di_Vsi_bi)+T4_Vdbulk_di_Vsi_bi))+((+(+(0.0/T5-(0.0*T5_Vsi_bi+T0b_Vsi_bi*T5_Vdbulk_di+T0b*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T0b*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5)*DelClm+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vsi_bi+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vdbulk_di+(T0b/T5)*DelClm_Vdbulk_di_Vsi_bi)*T0c+(((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi)))*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_ch_Vdbulk_di_Vdbulk_di=(+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+T0a*T1_Vdbulk_di_Vdbulk_di)/T1/T1+2*T0a*T1_Vdbulk_di*T1_Vdbulk_di/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(T0a/T1)*(+(+T2_Vdbulk_di_Vdbulk_di+T3_Vdbulk_di_Vdbulk_di)+T4_Vdbulk_di_Vdbulk_di))+((+(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vdbulk_di+T0b*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T0b*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5)*DelClm+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vdbulk_di+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vdbulk_di+(T0b/T5)*DelClm_Vdbulk_di_Vdbulk_di)*T0c+(((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*0.0+((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c*0.0+(((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*T0c)*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*0.0/T0d/T0d/T0d));
  Ssi_ch_Vdbulk_di_Vsbulk_si=(+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+T0a*T1_Vdbulk_di_Vsbulk_si)/T1/T1+2*T0a*T1_Vdbulk_di*T1_Vsbulk_si/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(T0a/T1)*(+(+T2_Vdbulk_di_Vsbulk_si+T3_Vdbulk_di_Vsbulk_si)+T4_Vdbulk_di_Vsbulk_si))+((+(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vdbulk_di+T0b*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T0b*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5)*DelClm+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vsbulk_si+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vdbulk_di+(T0b/T5)*DelClm_Vdbulk_di_Vsbulk_si)*T0c+(((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*0.0+((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di))*T0c*0.0+(((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*T0c)*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*0.0/T0d/T0d/T0d));
#endif
Ssi_ch_Vsbulk_si=((((-T0a*T1_Vsbulk_si/T1/T1)*((T2+T3)+T4))+((T0a/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)))+((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c/T0d));
#if defined(_DERIVATE2)
  Ssi_ch_Vsbulk_si_Tempt_GND=(+(+(0.0/T1-(0.0*T1_Tempt_GND+T0a_Tempt_GND*T1_Vsbulk_si+T0a*T1_Vsbulk_si_Tempt_GND)/T1/T1+2*T0a*T1_Vsbulk_si*T1_Tempt_GND/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Tempt_GND+T3_Tempt_GND)+T4_Tempt_GND)+((T0a_Tempt_GND*T1-T0a*T1_Tempt_GND)/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(T0a/T1)*(+(+T2_Vsbulk_si_Tempt_GND+T3_Vsbulk_si_Tempt_GND)+T4_Vsbulk_si_Tempt_GND))+((+(+(0.0/T5-(0.0*T5_Tempt_GND+T0b_Tempt_GND*T5_Vsbulk_si+T0b*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T0b*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5)*DelClm+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Tempt_GND+((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm_Vsbulk_si+(T0b/T5)*DelClm_Vsbulk_si_Tempt_GND)*T0c+(((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T5-T0b*T5_Tempt_GND)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Tempt_GND)))*T0c)+(((T0b/T5)*DelClm)*T0c_Tempt_GND)))*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_ch_Vsbulk_si_Vgi_bi=(+(+(0.0/T1-(0.0*T1_Vgi_bi+T0a_Vgi_bi*T1_Vsbulk_si+T0a*T1_Vsbulk_si_Vgi_bi)/T1/T1+2*T0a*T1_Vsbulk_si*T1_Vgi_bi/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vgi_bi+T3_Vgi_bi)+T4_Vgi_bi)+((T0a_Vgi_bi*T1-T0a*T1_Vgi_bi)/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(T0a/T1)*(+(+T2_Vsbulk_si_Vgi_bi+T3_Vsbulk_si_Vgi_bi)+T4_Vsbulk_si_Vgi_bi))+((+(+(0.0/T5-(0.0*T5_Vgi_bi+T0b_Vgi_bi*T5_Vsbulk_si+T0b*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T0b*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5)*DelClm+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vgi_bi+((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm_Vsbulk_si+(T0b/T5)*DelClm_Vsbulk_si_Vgi_bi)*T0c+(((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T5-T0b*T5_Vgi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vgi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vgi_bi)))*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_ch_Vsbulk_si_Vdi_bi=(+(+(0.0/T1-(0.0*T1_Vdi_bi+T0a_Vdi_bi*T1_Vsbulk_si+T0a*T1_Vsbulk_si_Vdi_bi)/T1/T1+2*T0a*T1_Vsbulk_si*T1_Vdi_bi/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vdi_bi+T3_Vdi_bi)+T4_Vdi_bi)+((T0a_Vdi_bi*T1-T0a*T1_Vdi_bi)/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(T0a/T1)*(+(+T2_Vsbulk_si_Vdi_bi+T3_Vsbulk_si_Vdi_bi)+T4_Vsbulk_si_Vdi_bi))+((+(+(0.0/T5-(0.0*T5_Vdi_bi+T0b_Vdi_bi*T5_Vsbulk_si+T0b*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T0b*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5)*DelClm+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vdi_bi+((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm_Vsbulk_si+(T0b/T5)*DelClm_Vsbulk_si_Vdi_bi)*T0c+(((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T5-T0b*T5_Vdi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vdi_bi)))*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_ch_Vsbulk_si_Vsi_bi=(+(+(0.0/T1-(0.0*T1_Vsi_bi+T0a_Vsi_bi*T1_Vsbulk_si+T0a*T1_Vsbulk_si_Vsi_bi)/T1/T1+2*T0a*T1_Vsbulk_si*T1_Vsi_bi/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vsi_bi+T3_Vsi_bi)+T4_Vsi_bi)+((T0a_Vsi_bi*T1-T0a*T1_Vsi_bi)/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(T0a/T1)*(+(+T2_Vsbulk_si_Vsi_bi+T3_Vsbulk_si_Vsi_bi)+T4_Vsbulk_si_Vsi_bi))+((+(+(0.0/T5-(0.0*T5_Vsi_bi+T0b_Vsi_bi*T5_Vsbulk_si+T0b*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T0b*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5)*DelClm+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vsi_bi+((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm_Vsbulk_si+(T0b/T5)*DelClm_Vsbulk_si_Vsi_bi)*T0c+(((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T5-T0b*T5_Vsi_bi)/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsi_bi)))*T0c)+(((T0b/T5)*DelClm)*T0c_Vsi_bi)))*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_ch_Vsbulk_si_Vdbulk_di=(+(+(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+T0a*T1_Vsbulk_si_Vdbulk_di)/T1/T1+2*T0a*T1_Vsbulk_si*T1_Vdbulk_di/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vdbulk_di+T3_Vdbulk_di)+T4_Vdbulk_di)+(-T0a*T1_Vdbulk_di/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(T0a/T1)*(+(+T2_Vsbulk_si_Vdbulk_di+T3_Vsbulk_si_Vdbulk_di)+T4_Vsbulk_si_Vdbulk_di))+((+(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vsbulk_si+T0b*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T0b*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5)*DelClm+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vdbulk_di+(-T0b*T5_Vdbulk_di/T5/T5)*DelClm_Vsbulk_si+(T0b/T5)*DelClm_Vsbulk_si_Vdbulk_di)*T0c+(((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*0.0+((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c*0.0+(((((-T0b*T5_Vdbulk_di/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vdbulk_di)))*T0c)*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*0.0/T0d/T0d/T0d));
  Ssi_ch_Vsbulk_si_Vsbulk_si=(+(+(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+T0a*T1_Vsbulk_si_Vsbulk_si)/T1/T1+2*T0a*T1_Vsbulk_si*T1_Vsbulk_si/T1/T1/T1)*((T2+T3)+T4)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(-T0a*T1_Vsbulk_si/T1/T1)*((T2_Vsbulk_si+T3_Vsbulk_si)+T4_Vsbulk_si)+(T0a/T1)*(+(+T2_Vsbulk_si_Vsbulk_si+T3_Vsbulk_si_Vsbulk_si)+T4_Vsbulk_si_Vsbulk_si))+((+(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vsbulk_si+T0b*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T0b*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5)*DelClm+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vsbulk_si+(-T0b*T5_Vsbulk_si/T5/T5)*DelClm_Vsbulk_si+(T0b/T5)*DelClm_Vsbulk_si_Vsbulk_si)*T0c+(((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*0.0+((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*0.0+((T0b/T5)*DelClm)*0.0)/T0d-((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si))*T0c*0.0+(((((-T0b*T5_Vsbulk_si/T5/T5)*DelClm)+((T0b/T5)*DelClm_Vsbulk_si)))*T0c)*0.0+(((T0b/T5)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T5)*DelClm)*T0c)*0.0*0.0/T0d/T0d/T0d));
#endif
#endif
Ssi_ch=(((T0a/T1)*((T2+T3)+T4))+((((T0b/T5)*DelClm)*T0c)/T0d));
EXIT_IF_ISNAN((((T0a/T1)*((T2+T3)+T4))+((((T0b/T5)*DelClm)*T0c)/T0d)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=0.0;
  T6_Vgi_bi_Vgm_si=0.0;
  T6_Vgi_bi_Vdbulk_di=0.0;
  T6_Vgi_bi_Vsbulk_si=0.0;
  T6_Vgi_bi_Vgi_bi=0.0;
  T6_Vgi_bi_Vdi_bi=0.0;
  T6_Vgi_bi_Vsi_bi=0.0;
  T6_Vgi_bi_Tempt_GND=0.0;
#endif
T6_Vdi_bi=((((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*Nstar)+(((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vdi_bi_Vgm_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vdi_bi_Vdbulk_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vdi_bi_Vsbulk_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vdi_bi_Vdi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_bi+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi_Vdi_bi)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*Nstar_Vdi_bi+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)))*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vsi_bi+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi_Vsi_bi)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*Nstar_Vsi_bi+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)))*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi_Tempt_GND)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*Nstar)+(((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vsi_bi_Vgm_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vsi_bi_Vdbulk_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vsi_bi_Vsbulk_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T6_Vsi_bi_Vdi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_bi+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi_Vdi_bi)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*Nstar_Vdi_bi+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)))*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vsi_bi+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi_Vsi_bi)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*Nstar_Vsi_bi+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)))*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi_Tempt_GND)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)*Nstar)+(((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Tempt_GND));
#endif
#endif
T6=(((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar);
EXIT_IF_ISNAN((((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
#if defined(_DERIVATE)
Swi_ch_Tempt_GND=((((((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids)+((T0e/T6)*ids_Tempt_GND))*ids)+(((T0e/T6)*ids)*ids_Tempt_GND));
#endif
Swi_ch_Vdbulk_di=(((((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di))*ids)+(((T0e/T6)*ids)*ids_Vdbulk_di));
#if defined(_DERIVATE2)
  Swi_ch_Vdbulk_di_Tempt_GND=(+(+(0.0/T6-(0.0*T6_Tempt_GND+T0e_Tempt_GND*T6_Vdbulk_di+T0e*T6_Vdbulk_di_Tempt_GND)/T6/T6+2*T0e*T6_Vdbulk_di*T6_Tempt_GND/T6/T6/T6)*ids+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Tempt_GND+((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids_Vdbulk_di+(T0e/T6)*ids_Vdbulk_di_Tempt_GND)*ids+(((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di))*ids_Tempt_GND+(((((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids)+((T0e/T6)*ids_Tempt_GND)))*ids_Vdbulk_di+((T0e/T6)*ids)*ids_Vdbulk_di_Tempt_GND);
  Swi_ch_Vdbulk_di_Vdbulk_di=(+(+(0.0/T6-(0.0*T6_Vdbulk_di+0.0*T6_Vdbulk_di+T0e*T6_Vdbulk_di_Vdbulk_di)/T6/T6+2*T0e*T6_Vdbulk_di*T6_Vdbulk_di/T6/T6/T6)*ids+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vdbulk_di+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vdbulk_di+(T0e/T6)*ids_Vdbulk_di_Vdbulk_di)*ids+(((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di))*ids_Vdbulk_di+((((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di)))*ids_Vdbulk_di+((T0e/T6)*ids)*ids_Vdbulk_di_Vdbulk_di);
  Swi_ch_Vdbulk_di_Vsbulk_si=(+(+(0.0/T6-(0.0*T6_Vsbulk_si+0.0*T6_Vdbulk_di+T0e*T6_Vdbulk_di_Vsbulk_si)/T6/T6+2*T0e*T6_Vdbulk_di*T6_Vsbulk_si/T6/T6/T6)*ids+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vsbulk_si+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vdbulk_di+(T0e/T6)*ids_Vdbulk_di_Vsbulk_si)*ids+(((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di))*ids_Vsbulk_si+((((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si)))*ids_Vdbulk_di+((T0e/T6)*ids)*ids_Vdbulk_di_Vsbulk_si);
  Swi_ch_Vdbulk_di_Vgi_bi=(+(+(0.0/T6-(0.0*T6_Vgi_bi+0.0*T6_Vdbulk_di+T0e*T6_Vdbulk_di_Vgi_bi)/T6/T6+2*T0e*T6_Vdbulk_di*T6_Vgi_bi/T6/T6/T6)*ids+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vgi_bi+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vdbulk_di+(T0e/T6)*ids_Vdbulk_di_Vgi_bi)*ids+(((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di))*ids_Vgi_bi+((((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi)))*ids_Vdbulk_di+((T0e/T6)*ids)*ids_Vdbulk_di_Vgi_bi);
  Swi_ch_Vdbulk_di_Vdi_bi=(+(+(0.0/T6-(0.0*T6_Vdi_bi+0.0*T6_Vdbulk_di+T0e*T6_Vdbulk_di_Vdi_bi)/T6/T6+2*T0e*T6_Vdbulk_di*T6_Vdi_bi/T6/T6/T6)*ids+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vdi_bi+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vdbulk_di+(T0e/T6)*ids_Vdbulk_di_Vdi_bi)*ids+(((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di))*ids_Vdi_bi+((((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi)))*ids_Vdbulk_di+((T0e/T6)*ids)*ids_Vdbulk_di_Vdi_bi);
  Swi_ch_Vdbulk_di_Vsi_bi=(+(+(0.0/T6-(0.0*T6_Vsi_bi+0.0*T6_Vdbulk_di+T0e*T6_Vdbulk_di_Vsi_bi)/T6/T6+2*T0e*T6_Vdbulk_di*T6_Vsi_bi/T6/T6/T6)*ids+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vsi_bi+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vdbulk_di+(T0e/T6)*ids_Vdbulk_di_Vsi_bi)*ids+(((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di))*ids_Vsi_bi+((((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi)))*ids_Vdbulk_di+((T0e/T6)*ids)*ids_Vdbulk_di_Vsi_bi);
#endif
Swi_ch_Vsbulk_si=(((((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si))*ids)+(((T0e/T6)*ids)*ids_Vsbulk_si));
#if defined(_DERIVATE2)
  Swi_ch_Vsbulk_si_Tempt_GND=(+(+(0.0/T6-(0.0*T6_Tempt_GND+T0e_Tempt_GND*T6_Vsbulk_si+T0e*T6_Vsbulk_si_Tempt_GND)/T6/T6+2*T0e*T6_Vsbulk_si*T6_Tempt_GND/T6/T6/T6)*ids+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Tempt_GND+((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids_Vsbulk_si+(T0e/T6)*ids_Vsbulk_si_Tempt_GND)*ids+(((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si))*ids_Tempt_GND+(((((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids)+((T0e/T6)*ids_Tempt_GND)))*ids_Vsbulk_si+((T0e/T6)*ids)*ids_Vsbulk_si_Tempt_GND);
  Swi_ch_Vsbulk_si_Vdbulk_di=(+(+(0.0/T6-(0.0*T6_Vdbulk_di+0.0*T6_Vsbulk_si+T0e*T6_Vsbulk_si_Vdbulk_di)/T6/T6+2*T0e*T6_Vsbulk_si*T6_Vdbulk_di/T6/T6/T6)*ids+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vdbulk_di+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vsbulk_si+(T0e/T6)*ids_Vsbulk_si_Vdbulk_di)*ids+(((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si))*ids_Vdbulk_di+((((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di)))*ids_Vsbulk_si+((T0e/T6)*ids)*ids_Vsbulk_si_Vdbulk_di);
  Swi_ch_Vsbulk_si_Vsbulk_si=(+(+(0.0/T6-(0.0*T6_Vsbulk_si+0.0*T6_Vsbulk_si+T0e*T6_Vsbulk_si_Vsbulk_si)/T6/T6+2*T0e*T6_Vsbulk_si*T6_Vsbulk_si/T6/T6/T6)*ids+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vsbulk_si+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vsbulk_si+(T0e/T6)*ids_Vsbulk_si_Vsbulk_si)*ids+(((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si))*ids_Vsbulk_si+((((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si)))*ids_Vsbulk_si+((T0e/T6)*ids)*ids_Vsbulk_si_Vsbulk_si);
  Swi_ch_Vsbulk_si_Vgi_bi=(+(+(0.0/T6-(0.0*T6_Vgi_bi+0.0*T6_Vsbulk_si+T0e*T6_Vsbulk_si_Vgi_bi)/T6/T6+2*T0e*T6_Vsbulk_si*T6_Vgi_bi/T6/T6/T6)*ids+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vgi_bi+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vsbulk_si+(T0e/T6)*ids_Vsbulk_si_Vgi_bi)*ids+(((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si))*ids_Vgi_bi+((((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi)))*ids_Vsbulk_si+((T0e/T6)*ids)*ids_Vsbulk_si_Vgi_bi);
  Swi_ch_Vsbulk_si_Vdi_bi=(+(+(0.0/T6-(0.0*T6_Vdi_bi+0.0*T6_Vsbulk_si+T0e*T6_Vsbulk_si_Vdi_bi)/T6/T6+2*T0e*T6_Vsbulk_si*T6_Vdi_bi/T6/T6/T6)*ids+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vdi_bi+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vsbulk_si+(T0e/T6)*ids_Vsbulk_si_Vdi_bi)*ids+(((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si))*ids_Vdi_bi+((((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi)))*ids_Vsbulk_si+((T0e/T6)*ids)*ids_Vsbulk_si_Vdi_bi);
  Swi_ch_Vsbulk_si_Vsi_bi=(+(+(0.0/T6-(0.0*T6_Vsi_bi+0.0*T6_Vsbulk_si+T0e*T6_Vsbulk_si_Vsi_bi)/T6/T6+2*T0e*T6_Vsbulk_si*T6_Vsi_bi/T6/T6/T6)*ids+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vsi_bi+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vsbulk_si+(T0e/T6)*ids_Vsbulk_si_Vsi_bi)*ids+(((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si))*ids_Vsi_bi+((((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi)))*ids_Vsbulk_si+((T0e/T6)*ids)*ids_Vsbulk_si_Vsi_bi);
#endif
Swi_ch_Vgi_bi=(((((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi))*ids)+(((T0e/T6)*ids)*ids_Vgi_bi));
#if defined(_DERIVATE2)
  Swi_ch_Vgi_bi_Tempt_GND=(+(+(0.0/T6-(0.0*T6_Tempt_GND+T0e_Tempt_GND*T6_Vgi_bi+T0e*T6_Vgi_bi_Tempt_GND)/T6/T6+2*T0e*T6_Vgi_bi*T6_Tempt_GND/T6/T6/T6)*ids+(-T0e*T6_Vgi_bi/T6/T6)*ids_Tempt_GND+((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids_Vgi_bi+(T0e/T6)*ids_Vgi_bi_Tempt_GND)*ids+(((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi))*ids_Tempt_GND+(((((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids)+((T0e/T6)*ids_Tempt_GND)))*ids_Vgi_bi+((T0e/T6)*ids)*ids_Vgi_bi_Tempt_GND);
  Swi_ch_Vgi_bi_Vdbulk_di=(+(+(0.0/T6-(0.0*T6_Vdbulk_di+0.0*T6_Vgi_bi+T0e*T6_Vgi_bi_Vdbulk_di)/T6/T6+2*T0e*T6_Vgi_bi*T6_Vdbulk_di/T6/T6/T6)*ids+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vdbulk_di+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vgi_bi+(T0e/T6)*ids_Vgi_bi_Vdbulk_di)*ids+(((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi))*ids_Vdbulk_di+((((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di)))*ids_Vgi_bi+((T0e/T6)*ids)*ids_Vgi_bi_Vdbulk_di);
  Swi_ch_Vgi_bi_Vsbulk_si=(+(+(0.0/T6-(0.0*T6_Vsbulk_si+0.0*T6_Vgi_bi+T0e*T6_Vgi_bi_Vsbulk_si)/T6/T6+2*T0e*T6_Vgi_bi*T6_Vsbulk_si/T6/T6/T6)*ids+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vsbulk_si+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vgi_bi+(T0e/T6)*ids_Vgi_bi_Vsbulk_si)*ids+(((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi))*ids_Vsbulk_si+((((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si)))*ids_Vgi_bi+((T0e/T6)*ids)*ids_Vgi_bi_Vsbulk_si);
  Swi_ch_Vgi_bi_Vgi_bi=(+(+(0.0/T6-(0.0*T6_Vgi_bi+0.0*T6_Vgi_bi+T0e*T6_Vgi_bi_Vgi_bi)/T6/T6+2*T0e*T6_Vgi_bi*T6_Vgi_bi/T6/T6/T6)*ids+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vgi_bi+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vgi_bi+(T0e/T6)*ids_Vgi_bi_Vgi_bi)*ids+(((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi))*ids_Vgi_bi+((((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi)))*ids_Vgi_bi+((T0e/T6)*ids)*ids_Vgi_bi_Vgi_bi);
  Swi_ch_Vgi_bi_Vdi_bi=(+(+(0.0/T6-(0.0*T6_Vdi_bi+0.0*T6_Vgi_bi+T0e*T6_Vgi_bi_Vdi_bi)/T6/T6+2*T0e*T6_Vgi_bi*T6_Vdi_bi/T6/T6/T6)*ids+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vdi_bi+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vgi_bi+(T0e/T6)*ids_Vgi_bi_Vdi_bi)*ids+(((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi))*ids_Vdi_bi+((((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi)))*ids_Vgi_bi+((T0e/T6)*ids)*ids_Vgi_bi_Vdi_bi);
  Swi_ch_Vgi_bi_Vsi_bi=(+(+(0.0/T6-(0.0*T6_Vsi_bi+0.0*T6_Vgi_bi+T0e*T6_Vgi_bi_Vsi_bi)/T6/T6+2*T0e*T6_Vgi_bi*T6_Vsi_bi/T6/T6/T6)*ids+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vsi_bi+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vgi_bi+(T0e/T6)*ids_Vgi_bi_Vsi_bi)*ids+(((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi))*ids_Vsi_bi+((((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi)))*ids_Vgi_bi+((T0e/T6)*ids)*ids_Vgi_bi_Vsi_bi);
#endif
Swi_ch_Vdi_bi=(((((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi))*ids)+(((T0e/T6)*ids)*ids_Vdi_bi));
#if defined(_DERIVATE2)
  Swi_ch_Vdi_bi_Tempt_GND=(+(+(0.0/T6-(0.0*T6_Tempt_GND+T0e_Tempt_GND*T6_Vdi_bi+T0e*T6_Vdi_bi_Tempt_GND)/T6/T6+2*T0e*T6_Vdi_bi*T6_Tempt_GND/T6/T6/T6)*ids+(-T0e*T6_Vdi_bi/T6/T6)*ids_Tempt_GND+((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids_Vdi_bi+(T0e/T6)*ids_Vdi_bi_Tempt_GND)*ids+(((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi))*ids_Tempt_GND+(((((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids)+((T0e/T6)*ids_Tempt_GND)))*ids_Vdi_bi+((T0e/T6)*ids)*ids_Vdi_bi_Tempt_GND);
  Swi_ch_Vdi_bi_Vdbulk_di=(+(+(0.0/T6-(0.0*T6_Vdbulk_di+0.0*T6_Vdi_bi+T0e*T6_Vdi_bi_Vdbulk_di)/T6/T6+2*T0e*T6_Vdi_bi*T6_Vdbulk_di/T6/T6/T6)*ids+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vdbulk_di+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vdi_bi+(T0e/T6)*ids_Vdi_bi_Vdbulk_di)*ids+(((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi))*ids_Vdbulk_di+((((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di)))*ids_Vdi_bi+((T0e/T6)*ids)*ids_Vdi_bi_Vdbulk_di);
  Swi_ch_Vdi_bi_Vsbulk_si=(+(+(0.0/T6-(0.0*T6_Vsbulk_si+0.0*T6_Vdi_bi+T0e*T6_Vdi_bi_Vsbulk_si)/T6/T6+2*T0e*T6_Vdi_bi*T6_Vsbulk_si/T6/T6/T6)*ids+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vsbulk_si+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vdi_bi+(T0e/T6)*ids_Vdi_bi_Vsbulk_si)*ids+(((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi))*ids_Vsbulk_si+((((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si)))*ids_Vdi_bi+((T0e/T6)*ids)*ids_Vdi_bi_Vsbulk_si);
  Swi_ch_Vdi_bi_Vgi_bi=(+(+(0.0/T6-(0.0*T6_Vgi_bi+0.0*T6_Vdi_bi+T0e*T6_Vdi_bi_Vgi_bi)/T6/T6+2*T0e*T6_Vdi_bi*T6_Vgi_bi/T6/T6/T6)*ids+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vgi_bi+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vdi_bi+(T0e/T6)*ids_Vdi_bi_Vgi_bi)*ids+(((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi))*ids_Vgi_bi+((((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi)))*ids_Vdi_bi+((T0e/T6)*ids)*ids_Vdi_bi_Vgi_bi);
  Swi_ch_Vdi_bi_Vdi_bi=(+(+(0.0/T6-(0.0*T6_Vdi_bi+0.0*T6_Vdi_bi+T0e*T6_Vdi_bi_Vdi_bi)/T6/T6+2*T0e*T6_Vdi_bi*T6_Vdi_bi/T6/T6/T6)*ids+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vdi_bi+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vdi_bi+(T0e/T6)*ids_Vdi_bi_Vdi_bi)*ids+(((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi))*ids_Vdi_bi+((((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi)))*ids_Vdi_bi+((T0e/T6)*ids)*ids_Vdi_bi_Vdi_bi);
  Swi_ch_Vdi_bi_Vsi_bi=(+(+(0.0/T6-(0.0*T6_Vsi_bi+0.0*T6_Vdi_bi+T0e*T6_Vdi_bi_Vsi_bi)/T6/T6+2*T0e*T6_Vdi_bi*T6_Vsi_bi/T6/T6/T6)*ids+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vsi_bi+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vdi_bi+(T0e/T6)*ids_Vdi_bi_Vsi_bi)*ids+(((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi))*ids_Vsi_bi+((((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi)))*ids_Vdi_bi+((T0e/T6)*ids)*ids_Vdi_bi_Vsi_bi);
#endif
Swi_ch_Vsi_bi=(((((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi))*ids)+(((T0e/T6)*ids)*ids_Vsi_bi));
#if defined(_DERIVATE2)
  Swi_ch_Vsi_bi_Tempt_GND=(+(+(0.0/T6-(0.0*T6_Tempt_GND+T0e_Tempt_GND*T6_Vsi_bi+T0e*T6_Vsi_bi_Tempt_GND)/T6/T6+2*T0e*T6_Vsi_bi*T6_Tempt_GND/T6/T6/T6)*ids+(-T0e*T6_Vsi_bi/T6/T6)*ids_Tempt_GND+((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids_Vsi_bi+(T0e/T6)*ids_Vsi_bi_Tempt_GND)*ids+(((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi))*ids_Tempt_GND+(((((T0e_Tempt_GND*T6-T0e*T6_Tempt_GND)/T6/T6)*ids)+((T0e/T6)*ids_Tempt_GND)))*ids_Vsi_bi+((T0e/T6)*ids)*ids_Vsi_bi_Tempt_GND);
  Swi_ch_Vsi_bi_Vdbulk_di=(+(+(0.0/T6-(0.0*T6_Vdbulk_di+0.0*T6_Vsi_bi+T0e*T6_Vsi_bi_Vdbulk_di)/T6/T6+2*T0e*T6_Vsi_bi*T6_Vdbulk_di/T6/T6/T6)*ids+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vdbulk_di+(-T0e*T6_Vdbulk_di/T6/T6)*ids_Vsi_bi+(T0e/T6)*ids_Vsi_bi_Vdbulk_di)*ids+(((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi))*ids_Vdbulk_di+((((-T0e*T6_Vdbulk_di/T6/T6)*ids)+((T0e/T6)*ids_Vdbulk_di)))*ids_Vsi_bi+((T0e/T6)*ids)*ids_Vsi_bi_Vdbulk_di);
  Swi_ch_Vsi_bi_Vsbulk_si=(+(+(0.0/T6-(0.0*T6_Vsbulk_si+0.0*T6_Vsi_bi+T0e*T6_Vsi_bi_Vsbulk_si)/T6/T6+2*T0e*T6_Vsi_bi*T6_Vsbulk_si/T6/T6/T6)*ids+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vsbulk_si+(-T0e*T6_Vsbulk_si/T6/T6)*ids_Vsi_bi+(T0e/T6)*ids_Vsi_bi_Vsbulk_si)*ids+(((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi))*ids_Vsbulk_si+((((-T0e*T6_Vsbulk_si/T6/T6)*ids)+((T0e/T6)*ids_Vsbulk_si)))*ids_Vsi_bi+((T0e/T6)*ids)*ids_Vsi_bi_Vsbulk_si);
  Swi_ch_Vsi_bi_Vgi_bi=(+(+(0.0/T6-(0.0*T6_Vgi_bi+0.0*T6_Vsi_bi+T0e*T6_Vsi_bi_Vgi_bi)/T6/T6+2*T0e*T6_Vsi_bi*T6_Vgi_bi/T6/T6/T6)*ids+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vgi_bi+(-T0e*T6_Vgi_bi/T6/T6)*ids_Vsi_bi+(T0e/T6)*ids_Vsi_bi_Vgi_bi)*ids+(((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi))*ids_Vgi_bi+((((-T0e*T6_Vgi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vgi_bi)))*ids_Vsi_bi+((T0e/T6)*ids)*ids_Vsi_bi_Vgi_bi);
  Swi_ch_Vsi_bi_Vdi_bi=(+(+(0.0/T6-(0.0*T6_Vdi_bi+0.0*T6_Vsi_bi+T0e*T6_Vsi_bi_Vdi_bi)/T6/T6+2*T0e*T6_Vsi_bi*T6_Vdi_bi/T6/T6/T6)*ids+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vdi_bi+(-T0e*T6_Vdi_bi/T6/T6)*ids_Vsi_bi+(T0e/T6)*ids_Vsi_bi_Vdi_bi)*ids+(((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi))*ids_Vdi_bi+((((-T0e*T6_Vdi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vdi_bi)))*ids_Vsi_bi+((T0e/T6)*ids)*ids_Vsi_bi_Vdi_bi);
  Swi_ch_Vsi_bi_Vsi_bi=(+(+(0.0/T6-(0.0*T6_Vsi_bi+0.0*T6_Vsi_bi+T0e*T6_Vsi_bi_Vsi_bi)/T6/T6+2*T0e*T6_Vsi_bi*T6_Vsi_bi/T6/T6/T6)*ids+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vsi_bi+(-T0e*T6_Vsi_bi/T6/T6)*ids_Vsi_bi+(T0e/T6)*ids_Vsi_bi_Vsi_bi)*ids+(((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi))*ids_Vsi_bi+((((-T0e*T6_Vsi_bi/T6/T6)*ids)+((T0e/T6)*ids_Vsi_bi)))*ids_Vsi_bi+((T0e/T6)*ids)*ids_Vsi_bi_Vsi_bi);
#endif
#endif
Swi_ch=(((T0e/T6)*ids)*ids);
EXIT_IF_ISNAN((((T0e/T6)*ids)*ids))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=(Swi_ch_Vdbulk_di+Ssi_ch_Vdbulk_di);
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=(+0.0+0.0);
  T7_Vdbulk_di_Vgm_di=(+0.0+0.0);
  T7_Vdbulk_di_Vdbulk_di=(+Swi_ch_Vdbulk_di_Vdbulk_di+Ssi_ch_Vdbulk_di_Vdbulk_di);
  T7_Vdbulk_di_Vsbulk_si=(+Swi_ch_Vdbulk_di_Vsbulk_si+Ssi_ch_Vdbulk_di_Vsbulk_si);
  T7_Vdbulk_di_Vgi_bi=(+Swi_ch_Vdbulk_di_Vgi_bi+Ssi_ch_Vdbulk_di_Vgi_bi);
  T7_Vdbulk_di_Vdi_bi=(+Swi_ch_Vdbulk_di_Vdi_bi+Ssi_ch_Vdbulk_di_Vdi_bi);
  T7_Vdbulk_di_Vsi_bi=(+Swi_ch_Vdbulk_di_Vsi_bi+Ssi_ch_Vdbulk_di_Vsi_bi);
  T7_Vdbulk_di_Tempt_GND=(+Swi_ch_Vdbulk_di_Tempt_GND+Ssi_ch_Vdbulk_di_Tempt_GND);
#endif
T7_Vsbulk_si=(Swi_ch_Vsbulk_si+Ssi_ch_Vsbulk_si);
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=(+0.0+0.0);
  T7_Vsbulk_si_Vgm_di=(+0.0+0.0);
  T7_Vsbulk_si_Vdbulk_di=(+Swi_ch_Vsbulk_si_Vdbulk_di+Ssi_ch_Vsbulk_si_Vdbulk_di);
  T7_Vsbulk_si_Vsbulk_si=(+Swi_ch_Vsbulk_si_Vsbulk_si+Ssi_ch_Vsbulk_si_Vsbulk_si);
  T7_Vsbulk_si_Vgi_bi=(+Swi_ch_Vsbulk_si_Vgi_bi+Ssi_ch_Vsbulk_si_Vgi_bi);
  T7_Vsbulk_si_Vdi_bi=(+Swi_ch_Vsbulk_si_Vdi_bi+Ssi_ch_Vsbulk_si_Vdi_bi);
  T7_Vsbulk_si_Vsi_bi=(+Swi_ch_Vsbulk_si_Vsi_bi+Ssi_ch_Vsbulk_si_Vsi_bi);
  T7_Vsbulk_si_Tempt_GND=(+Swi_ch_Vsbulk_si_Tempt_GND+Ssi_ch_Vsbulk_si_Tempt_GND);
#endif
T7_Vgi_bi=(Swi_ch_Vgi_bi+Ssi_ch_Vgi_bi);
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+0.0+0.0);
  T7_Vgi_bi_Vgm_di=(+0.0+0.0);
  T7_Vgi_bi_Vdbulk_di=(+Swi_ch_Vgi_bi_Vdbulk_di+Ssi_ch_Vgi_bi_Vdbulk_di);
  T7_Vgi_bi_Vsbulk_si=(+Swi_ch_Vgi_bi_Vsbulk_si+Ssi_ch_Vgi_bi_Vsbulk_si);
  T7_Vgi_bi_Vgi_bi=(+Swi_ch_Vgi_bi_Vgi_bi+Ssi_ch_Vgi_bi_Vgi_bi);
  T7_Vgi_bi_Vdi_bi=(+Swi_ch_Vgi_bi_Vdi_bi+Ssi_ch_Vgi_bi_Vdi_bi);
  T7_Vgi_bi_Vsi_bi=(+Swi_ch_Vgi_bi_Vsi_bi+Ssi_ch_Vgi_bi_Vsi_bi);
  T7_Vgi_bi_Tempt_GND=(+Swi_ch_Vgi_bi_Tempt_GND+Ssi_ch_Vgi_bi_Tempt_GND);
#endif
T7_Vdi_bi=(Swi_ch_Vdi_bi+Ssi_ch_Vdi_bi);
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+0.0+0.0);
  T7_Vdi_bi_Vgm_di=(+0.0+0.0);
  T7_Vdi_bi_Vdbulk_di=(+Swi_ch_Vdi_bi_Vdbulk_di+Ssi_ch_Vdi_bi_Vdbulk_di);
  T7_Vdi_bi_Vsbulk_si=(+Swi_ch_Vdi_bi_Vsbulk_si+Ssi_ch_Vdi_bi_Vsbulk_si);
  T7_Vdi_bi_Vgi_bi=(+Swi_ch_Vdi_bi_Vgi_bi+Ssi_ch_Vdi_bi_Vgi_bi);
  T7_Vdi_bi_Vdi_bi=(+Swi_ch_Vdi_bi_Vdi_bi+Ssi_ch_Vdi_bi_Vdi_bi);
  T7_Vdi_bi_Vsi_bi=(+Swi_ch_Vdi_bi_Vsi_bi+Ssi_ch_Vdi_bi_Vsi_bi);
  T7_Vdi_bi_Tempt_GND=(+Swi_ch_Vdi_bi_Tempt_GND+Ssi_ch_Vdi_bi_Tempt_GND);
#endif
T7_Vsi_bi=(Swi_ch_Vsi_bi+Ssi_ch_Vsi_bi);
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+0.0+0.0);
  T7_Vsi_bi_Vgm_di=(+0.0+0.0);
  T7_Vsi_bi_Vdbulk_di=(+Swi_ch_Vsi_bi_Vdbulk_di+Ssi_ch_Vsi_bi_Vdbulk_di);
  T7_Vsi_bi_Vsbulk_si=(+Swi_ch_Vsi_bi_Vsbulk_si+Ssi_ch_Vsi_bi_Vsbulk_si);
  T7_Vsi_bi_Vgi_bi=(+Swi_ch_Vsi_bi_Vgi_bi+Ssi_ch_Vsi_bi_Vgi_bi);
  T7_Vsi_bi_Vdi_bi=(+Swi_ch_Vsi_bi_Vdi_bi+Ssi_ch_Vsi_bi_Vdi_bi);
  T7_Vsi_bi_Vsi_bi=(+Swi_ch_Vsi_bi_Vsi_bi+Ssi_ch_Vsi_bi_Vsi_bi);
  T7_Vsi_bi_Tempt_GND=(+Swi_ch_Vsi_bi_Tempt_GND+Ssi_ch_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(Swi_ch_Tempt_GND+Ssi_ch_Tempt_GND);
#endif
#endif
T7=(Swi_ch+Ssi_ch);
EXIT_IF_ISNAN((Swi_ch+Ssi_ch))
if
((T7>0.0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
FNPowerAt1Hz_ch_Tempt_GND=((((Ssi_ch_Tempt_GND*Swi_ch)+(Ssi_ch*Swi_ch_Tempt_GND))*T7-(Ssi_ch*Swi_ch)*T7_Tempt_GND)/T7/T7);
FNPowerAt1Hz_ch_Vgi_bi=((((Ssi_ch_Vgi_bi*Swi_ch)+(Ssi_ch*Swi_ch_Vgi_bi))*T7-(Ssi_ch*Swi_ch)*T7_Vgi_bi)/T7/T7);
FNPowerAt1Hz_ch_Vdi_bi=((((Ssi_ch_Vdi_bi*Swi_ch)+(Ssi_ch*Swi_ch_Vdi_bi))*T7-(Ssi_ch*Swi_ch)*T7_Vdi_bi)/T7/T7);
FNPowerAt1Hz_ch_Vsi_bi=((((Ssi_ch_Vsi_bi*Swi_ch)+(Ssi_ch*Swi_ch_Vsi_bi))*T7-(Ssi_ch*Swi_ch)*T7_Vsi_bi)/T7/T7);
FNPowerAt1Hz_ch_Vdbulk_di=((((Ssi_ch_Vdbulk_di*Swi_ch)+(Ssi_ch*Swi_ch_Vdbulk_di))*T7-(Ssi_ch*Swi_ch)*T7_Vdbulk_di)/T7/T7);
FNPowerAt1Hz_ch_Vsbulk_si=((((Ssi_ch_Vsbulk_si*Swi_ch)+(Ssi_ch*Swi_ch_Vsbulk_si))*T7-(Ssi_ch*Swi_ch)*T7_Vsbulk_si)/T7/T7);
#endif
FNPowerAt1Hz_ch=((Ssi_ch*Swi_ch)/T7);
EXIT_IF_ISNAN(((Ssi_ch*Swi_ch)/T7))
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
FNPowerAt1Hz_ch_Tempt_GND=0.0;
FNPowerAt1Hz_ch_Vgi_bi=0.0;
FNPowerAt1Hz_ch_Vdi_bi=0.0;
FNPowerAt1Hz_ch_Vsi_bi=0.0;
FNPowerAt1Hz_ch_Vdbulk_di=0.0;
FNPowerAt1Hz_ch_Vsbulk_si=0.0;
#endif
FNPowerAt1Hz_ch=0.0;
EXIT_IF_ISNAN(0.0)
}
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
FNPowerAt1Hz_ch_Tempt_GND=0.0;
FNPowerAt1Hz_ch_Vgi_bi=0.0;
FNPowerAt1Hz_ch_Vdi_bi=0.0;
FNPowerAt1Hz_ch_Vsi_bi=0.0;
FNPowerAt1Hz_ch_Vdbulk_di=0.0;
FNPowerAt1Hz_ch_Vsbulk_si=0.0;
#endif
FNPowerAt1Hz_ch=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=0.0;
  T8_Vdbulk_di_Vgm_si=0.0;
  T8_Vdbulk_di_Vdbulk_di=0.0;
  T8_Vdbulk_di_Vsbulk_si=0.0;
  T8_Vdbulk_di_Vgi_bi=0.0;
  T8_Vdbulk_di_Vdi_bi=0.0;
  T8_Vdbulk_di_Vsi_bi=0.0;
  T8_Vdbulk_di_Tempt_GND=0.0;
#endif
T8_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=0.0;
  T8_Vsbulk_si_Vgm_si=0.0;
  T8_Vsbulk_si_Vdbulk_di=0.0;
  T8_Vsbulk_si_Vsbulk_si=0.0;
  T8_Vsbulk_si_Vgi_bi=0.0;
  T8_Vsbulk_si_Vdi_bi=0.0;
  T8_Vsbulk_si_Vsi_bi=0.0;
  T8_Vsbulk_si_Tempt_GND=0.0;
#endif
T8_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=0.0;
  T8_Vgi_bi_Vgm_si=0.0;
  T8_Vgi_bi_Vdbulk_di=0.0;
  T8_Vgi_bi_Vsbulk_si=0.0;
  T8_Vgi_bi_Vgi_bi=0.0;
  T8_Vgi_bi_Vdi_bi=0.0;
  T8_Vgi_bi_Vsi_bi=0.0;
  T8_Vgi_bi_Tempt_GND=0.0;
#endif
T8_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=0.0;
  T8_Vdi_bi_Vgm_si=0.0;
  T8_Vdi_bi_Vdbulk_di=0.0;
  T8_Vdi_bi_Vsbulk_si=0.0;
  T8_Vdi_bi_Vgi_bi=0.0;
  T8_Vdi_bi_Vdi_bi=0.0;
  T8_Vdi_bi_Vsi_bi=0.0;
  T8_Vdi_bi_Tempt_GND=0.0;
#endif
T8_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=0.0;
  T8_Vsi_bi_Vgm_si=0.0;
  T8_Vsi_bi_Vdbulk_di=0.0;
  T8_Vsi_bi_Vsbulk_si=0.0;
  T8_Vsi_bi_Vgi_bi=0.0;
  T8_Vsi_bi_Vdi_bi=0.0;
  T8_Vsi_bi_Vsi_bi=0.0;
  T8_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=((pModel->NOIA2*1.60219e-19)*Vt_Tempt_GND);
#endif
#endif
T8=((pModel->NOIA2*1.60219e-19)*Vt);
EXIT_IF_ISNAN(((pModel->NOIA2*1.60219e-19)*Vt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=0.0;
  T9_Vdbulk_di_Vgm_di=0.0;
  T9_Vdbulk_di_Vdbulk_di=0.0;
  T9_Vdbulk_di_Vsbulk_si=0.0;
  T9_Vdbulk_di_Vdi_bi=0.0;
  T9_Vdbulk_di_Vsi_bi=0.0;
  T9_Vdbulk_di_Tempt_GND=0.0;
  T9_Vdbulk_di_Vgi_bi=0.0;
#endif
T9_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=0.0;
  T9_Vsbulk_si_Vgm_di=0.0;
  T9_Vsbulk_si_Vdbulk_di=0.0;
  T9_Vsbulk_si_Vsbulk_si=0.0;
  T9_Vsbulk_si_Vdi_bi=0.0;
  T9_Vsbulk_si_Vsi_bi=0.0;
  T9_Vsbulk_si_Tempt_GND=0.0;
  T9_Vsbulk_si_Vgi_bi=0.0;
#endif
T9_Vdi_bi=((((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)*Nstar)+(((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vdi_bi));
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
  T9_Vdi_bi_Vgm_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
  T9_Vdi_bi_Vdbulk_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
  T9_Vdi_bi_Vsbulk_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
  T9_Vdi_bi_Vdi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*Nstar_Vdi_bi+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi_Vdi_bi)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)*Nstar_Vdi_bi+((((((0.0)*pModel->LH)*1.0e10)*Nstar)+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)))*Nstar_Vdi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vdi_bi_Vdi_bi);
  T9_Vdi_bi_Vsi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*Nstar_Vsi_bi+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi_Vsi_bi)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)*Nstar_Vsi_bi+((((((0.0)*pModel->LH)*1.0e10)*Nstar)+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)))*Nstar_Vdi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vdi_bi_Vsi_bi);
  T9_Vdi_bi_Tempt_GND=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi_Tempt_GND)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)*Nstar_Tempt_GND+((((((0.0)*pModel->LH)*1.0e10)*Nstar)+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Vdi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vdi_bi_Tempt_GND);
  T9_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
#endif
T9_Vsi_bi=((((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)*Nstar)+(((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vsi_bi));
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
  T9_Vsi_bi_Vgm_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
  T9_Vsi_bi_Vdbulk_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
  T9_Vsi_bi_Vsbulk_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
  T9_Vsi_bi_Vdi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*Nstar_Vdi_bi+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi_Vdi_bi)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)*Nstar_Vdi_bi+((((((0.0)*pModel->LH)*1.0e10)*Nstar)+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vdi_bi)))*Nstar_Vsi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vsi_bi_Vdi_bi);
  T9_Vsi_bi_Vsi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*Nstar_Vsi_bi+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi_Vsi_bi)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)*Nstar_Vsi_bi+((((((0.0)*pModel->LH)*1.0e10)*Nstar)+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)))*Nstar_Vsi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vsi_bi_Vsi_bi);
  T9_Vsi_bi_Tempt_GND=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi_Tempt_GND)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)*Nstar_Tempt_GND+((((((0.0)*pModel->LH)*1.0e10)*Nstar)+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Vsi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vsi_bi_Tempt_GND);
  T9_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*pModel->LH+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*pModel->LH)*0.0+((Weff*pInst->NF)*pModel->LH)*0.0)*Nstar+0.0*0.0+(((0.0)*pModel->LH)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*pModel->LH)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*pModel->LH)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*0.0);
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=((((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar_Tempt_GND)*Nstar)+(((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar_Tempt_GND));
#endif
T9_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=0.0;
  T9_Vgi_bi_Vgm_di=0.0;
  T9_Vgi_bi_Vdbulk_di=0.0;
  T9_Vgi_bi_Vsbulk_si=0.0;
  T9_Vgi_bi_Vdi_bi=0.0;
  T9_Vgi_bi_Vsi_bi=0.0;
  T9_Vgi_bi_Tempt_GND=0.0;
  T9_Vgi_bi_Vgi_bi=0.0;
#endif
#endif
T9=(((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar);
EXIT_IF_ISNAN((((((Weff*pInst->NF)*pModel->LH)*1.0e10)*Nstar)*Nstar))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Swi_h_Vdbulk_di=((((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di))*ids)+(((T8/T9)*ids)*ids_Vdbulk_di));
#if defined(_DERIVATE2)
  Swi_h_Vdbulk_di_Vdbulk_di=(+(+(T8_Vdbulk_di_Vdbulk_di/T9-(T8_Vdbulk_di*T9_Vdbulk_di+T8_Vdbulk_di*T9_Vdbulk_di+T8*T9_Vdbulk_di_Vdbulk_di)/T9/T9+2*T8*T9_Vdbulk_di*T9_Vdbulk_di/T9/T9/T9)*ids+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vdbulk_di+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vdbulk_di+(T8/T9)*ids_Vdbulk_di_Vdbulk_di)*ids+((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di))*ids_Vdbulk_di+(((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di)))*ids_Vdbulk_di+((T8/T9)*ids)*ids_Vdbulk_di_Vdbulk_di);
  Swi_h_Vdbulk_di_Vsbulk_si=(+(+(T8_Vdbulk_di_Vsbulk_si/T9-(T8_Vdbulk_di*T9_Vsbulk_si+T8_Vsbulk_si*T9_Vdbulk_di+T8*T9_Vdbulk_di_Vsbulk_si)/T9/T9+2*T8*T9_Vdbulk_di*T9_Vsbulk_si/T9/T9/T9)*ids+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vsbulk_si+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vdbulk_di+(T8/T9)*ids_Vdbulk_di_Vsbulk_si)*ids+((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di))*ids_Vsbulk_si+(((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si)))*ids_Vdbulk_di+((T8/T9)*ids)*ids_Vdbulk_di_Vsbulk_si);
  Swi_h_Vdbulk_di_Vgi_bi=(+(+(T8_Vdbulk_di_Vgi_bi/T9-(T8_Vdbulk_di*T9_Vgi_bi+T8_Vgi_bi*T9_Vdbulk_di+T8*T9_Vdbulk_di_Vgi_bi)/T9/T9+2*T8*T9_Vdbulk_di*T9_Vgi_bi/T9/T9/T9)*ids+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vgi_bi+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vdbulk_di+(T8/T9)*ids_Vdbulk_di_Vgi_bi)*ids+((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di))*ids_Vgi_bi+(((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi)))*ids_Vdbulk_di+((T8/T9)*ids)*ids_Vdbulk_di_Vgi_bi);
  Swi_h_Vdbulk_di_Vdi_bi=(+(+(T8_Vdbulk_di_Vdi_bi/T9-(T8_Vdbulk_di*T9_Vdi_bi+T8_Vdi_bi*T9_Vdbulk_di+T8*T9_Vdbulk_di_Vdi_bi)/T9/T9+2*T8*T9_Vdbulk_di*T9_Vdi_bi/T9/T9/T9)*ids+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vdi_bi+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vdbulk_di+(T8/T9)*ids_Vdbulk_di_Vdi_bi)*ids+((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di))*ids_Vdi_bi+(((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi)))*ids_Vdbulk_di+((T8/T9)*ids)*ids_Vdbulk_di_Vdi_bi);
  Swi_h_Vdbulk_di_Vsi_bi=(+(+(T8_Vdbulk_di_Vsi_bi/T9-(T8_Vdbulk_di*T9_Vsi_bi+T8_Vsi_bi*T9_Vdbulk_di+T8*T9_Vdbulk_di_Vsi_bi)/T9/T9+2*T8*T9_Vdbulk_di*T9_Vsi_bi/T9/T9/T9)*ids+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vsi_bi+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vdbulk_di+(T8/T9)*ids_Vdbulk_di_Vsi_bi)*ids+((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di))*ids_Vsi_bi+(((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi)))*ids_Vdbulk_di+((T8/T9)*ids)*ids_Vdbulk_di_Vsi_bi);
  Swi_h_Vdbulk_di_Tempt_GND=(+(+(T8_Vdbulk_di_Tempt_GND/T9-(T8_Vdbulk_di*T9_Tempt_GND+T8_Tempt_GND*T9_Vdbulk_di+T8*T9_Vdbulk_di_Tempt_GND)/T9/T9+2*T8*T9_Vdbulk_di*T9_Tempt_GND/T9/T9/T9)*ids+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Tempt_GND+((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids_Vdbulk_di+(T8/T9)*ids_Vdbulk_di_Tempt_GND)*ids+((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di))*ids_Tempt_GND+(((((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids)+((T8/T9)*ids_Tempt_GND)))*ids_Vdbulk_di+((T8/T9)*ids)*ids_Vdbulk_di_Tempt_GND);
#endif
Swi_h_Vsbulk_si=((((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si))*ids)+(((T8/T9)*ids)*ids_Vsbulk_si));
#if defined(_DERIVATE2)
  Swi_h_Vsbulk_si_Vdbulk_di=(+(+(T8_Vsbulk_si_Vdbulk_di/T9-(T8_Vsbulk_si*T9_Vdbulk_di+T8_Vdbulk_di*T9_Vsbulk_si+T8*T9_Vsbulk_si_Vdbulk_di)/T9/T9+2*T8*T9_Vsbulk_si*T9_Vdbulk_di/T9/T9/T9)*ids+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vdbulk_di+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vsbulk_si+(T8/T9)*ids_Vsbulk_si_Vdbulk_di)*ids+((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si))*ids_Vdbulk_di+(((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di)))*ids_Vsbulk_si+((T8/T9)*ids)*ids_Vsbulk_si_Vdbulk_di);
  Swi_h_Vsbulk_si_Vsbulk_si=(+(+(T8_Vsbulk_si_Vsbulk_si/T9-(T8_Vsbulk_si*T9_Vsbulk_si+T8_Vsbulk_si*T9_Vsbulk_si+T8*T9_Vsbulk_si_Vsbulk_si)/T9/T9+2*T8*T9_Vsbulk_si*T9_Vsbulk_si/T9/T9/T9)*ids+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vsbulk_si+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vsbulk_si+(T8/T9)*ids_Vsbulk_si_Vsbulk_si)*ids+((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si))*ids_Vsbulk_si+(((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si)))*ids_Vsbulk_si+((T8/T9)*ids)*ids_Vsbulk_si_Vsbulk_si);
  Swi_h_Vsbulk_si_Vgi_bi=(+(+(T8_Vsbulk_si_Vgi_bi/T9-(T8_Vsbulk_si*T9_Vgi_bi+T8_Vgi_bi*T9_Vsbulk_si+T8*T9_Vsbulk_si_Vgi_bi)/T9/T9+2*T8*T9_Vsbulk_si*T9_Vgi_bi/T9/T9/T9)*ids+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vgi_bi+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vsbulk_si+(T8/T9)*ids_Vsbulk_si_Vgi_bi)*ids+((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si))*ids_Vgi_bi+(((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi)))*ids_Vsbulk_si+((T8/T9)*ids)*ids_Vsbulk_si_Vgi_bi);
  Swi_h_Vsbulk_si_Vdi_bi=(+(+(T8_Vsbulk_si_Vdi_bi/T9-(T8_Vsbulk_si*T9_Vdi_bi+T8_Vdi_bi*T9_Vsbulk_si+T8*T9_Vsbulk_si_Vdi_bi)/T9/T9+2*T8*T9_Vsbulk_si*T9_Vdi_bi/T9/T9/T9)*ids+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vdi_bi+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vsbulk_si+(T8/T9)*ids_Vsbulk_si_Vdi_bi)*ids+((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si))*ids_Vdi_bi+(((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi)))*ids_Vsbulk_si+((T8/T9)*ids)*ids_Vsbulk_si_Vdi_bi);
  Swi_h_Vsbulk_si_Vsi_bi=(+(+(T8_Vsbulk_si_Vsi_bi/T9-(T8_Vsbulk_si*T9_Vsi_bi+T8_Vsi_bi*T9_Vsbulk_si+T8*T9_Vsbulk_si_Vsi_bi)/T9/T9+2*T8*T9_Vsbulk_si*T9_Vsi_bi/T9/T9/T9)*ids+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vsi_bi+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vsbulk_si+(T8/T9)*ids_Vsbulk_si_Vsi_bi)*ids+((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si))*ids_Vsi_bi+(((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi)))*ids_Vsbulk_si+((T8/T9)*ids)*ids_Vsbulk_si_Vsi_bi);
  Swi_h_Vsbulk_si_Tempt_GND=(+(+(T8_Vsbulk_si_Tempt_GND/T9-(T8_Vsbulk_si*T9_Tempt_GND+T8_Tempt_GND*T9_Vsbulk_si+T8*T9_Vsbulk_si_Tempt_GND)/T9/T9+2*T8*T9_Vsbulk_si*T9_Tempt_GND/T9/T9/T9)*ids+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Tempt_GND+((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids_Vsbulk_si+(T8/T9)*ids_Vsbulk_si_Tempt_GND)*ids+((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si))*ids_Tempt_GND+(((((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids)+((T8/T9)*ids_Tempt_GND)))*ids_Vsbulk_si+((T8/T9)*ids)*ids_Vsbulk_si_Tempt_GND);
#endif
Swi_h_Vgi_bi=((((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi))*ids)+(((T8/T9)*ids)*ids_Vgi_bi));
#if defined(_DERIVATE2)
  Swi_h_Vgi_bi_Vdbulk_di=(+(+(T8_Vgi_bi_Vdbulk_di/T9-(T8_Vgi_bi*T9_Vdbulk_di+T8_Vdbulk_di*T9_Vgi_bi+T8*T9_Vgi_bi_Vdbulk_di)/T9/T9+2*T8*T9_Vgi_bi*T9_Vdbulk_di/T9/T9/T9)*ids+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vdbulk_di+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vgi_bi+(T8/T9)*ids_Vgi_bi_Vdbulk_di)*ids+((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi))*ids_Vdbulk_di+(((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di)))*ids_Vgi_bi+((T8/T9)*ids)*ids_Vgi_bi_Vdbulk_di);
  Swi_h_Vgi_bi_Vsbulk_si=(+(+(T8_Vgi_bi_Vsbulk_si/T9-(T8_Vgi_bi*T9_Vsbulk_si+T8_Vsbulk_si*T9_Vgi_bi+T8*T9_Vgi_bi_Vsbulk_si)/T9/T9+2*T8*T9_Vgi_bi*T9_Vsbulk_si/T9/T9/T9)*ids+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vsbulk_si+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vgi_bi+(T8/T9)*ids_Vgi_bi_Vsbulk_si)*ids+((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi))*ids_Vsbulk_si+(((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si)))*ids_Vgi_bi+((T8/T9)*ids)*ids_Vgi_bi_Vsbulk_si);
  Swi_h_Vgi_bi_Vgi_bi=(+(+(T8_Vgi_bi_Vgi_bi/T9-(T8_Vgi_bi*T9_Vgi_bi+T8_Vgi_bi*T9_Vgi_bi+T8*T9_Vgi_bi_Vgi_bi)/T9/T9+2*T8*T9_Vgi_bi*T9_Vgi_bi/T9/T9/T9)*ids+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vgi_bi+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vgi_bi+(T8/T9)*ids_Vgi_bi_Vgi_bi)*ids+((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi))*ids_Vgi_bi+(((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi)))*ids_Vgi_bi+((T8/T9)*ids)*ids_Vgi_bi_Vgi_bi);
  Swi_h_Vgi_bi_Vdi_bi=(+(+(T8_Vgi_bi_Vdi_bi/T9-(T8_Vgi_bi*T9_Vdi_bi+T8_Vdi_bi*T9_Vgi_bi+T8*T9_Vgi_bi_Vdi_bi)/T9/T9+2*T8*T9_Vgi_bi*T9_Vdi_bi/T9/T9/T9)*ids+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vdi_bi+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vgi_bi+(T8/T9)*ids_Vgi_bi_Vdi_bi)*ids+((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi))*ids_Vdi_bi+(((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi)))*ids_Vgi_bi+((T8/T9)*ids)*ids_Vgi_bi_Vdi_bi);
  Swi_h_Vgi_bi_Vsi_bi=(+(+(T8_Vgi_bi_Vsi_bi/T9-(T8_Vgi_bi*T9_Vsi_bi+T8_Vsi_bi*T9_Vgi_bi+T8*T9_Vgi_bi_Vsi_bi)/T9/T9+2*T8*T9_Vgi_bi*T9_Vsi_bi/T9/T9/T9)*ids+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vsi_bi+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vgi_bi+(T8/T9)*ids_Vgi_bi_Vsi_bi)*ids+((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi))*ids_Vsi_bi+(((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi)))*ids_Vgi_bi+((T8/T9)*ids)*ids_Vgi_bi_Vsi_bi);
  Swi_h_Vgi_bi_Tempt_GND=(+(+(T8_Vgi_bi_Tempt_GND/T9-(T8_Vgi_bi*T9_Tempt_GND+T8_Tempt_GND*T9_Vgi_bi+T8*T9_Vgi_bi_Tempt_GND)/T9/T9+2*T8*T9_Vgi_bi*T9_Tempt_GND/T9/T9/T9)*ids+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Tempt_GND+((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids_Vgi_bi+(T8/T9)*ids_Vgi_bi_Tempt_GND)*ids+((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi))*ids_Tempt_GND+(((((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids)+((T8/T9)*ids_Tempt_GND)))*ids_Vgi_bi+((T8/T9)*ids)*ids_Vgi_bi_Tempt_GND);
#endif
Swi_h_Vdi_bi=((((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi))*ids)+(((T8/T9)*ids)*ids_Vdi_bi));
#if defined(_DERIVATE2)
  Swi_h_Vdi_bi_Vdbulk_di=(+(+(T8_Vdi_bi_Vdbulk_di/T9-(T8_Vdi_bi*T9_Vdbulk_di+T8_Vdbulk_di*T9_Vdi_bi+T8*T9_Vdi_bi_Vdbulk_di)/T9/T9+2*T8*T9_Vdi_bi*T9_Vdbulk_di/T9/T9/T9)*ids+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vdbulk_di+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vdi_bi+(T8/T9)*ids_Vdi_bi_Vdbulk_di)*ids+((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi))*ids_Vdbulk_di+(((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di)))*ids_Vdi_bi+((T8/T9)*ids)*ids_Vdi_bi_Vdbulk_di);
  Swi_h_Vdi_bi_Vsbulk_si=(+(+(T8_Vdi_bi_Vsbulk_si/T9-(T8_Vdi_bi*T9_Vsbulk_si+T8_Vsbulk_si*T9_Vdi_bi+T8*T9_Vdi_bi_Vsbulk_si)/T9/T9+2*T8*T9_Vdi_bi*T9_Vsbulk_si/T9/T9/T9)*ids+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vsbulk_si+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vdi_bi+(T8/T9)*ids_Vdi_bi_Vsbulk_si)*ids+((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi))*ids_Vsbulk_si+(((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si)))*ids_Vdi_bi+((T8/T9)*ids)*ids_Vdi_bi_Vsbulk_si);
  Swi_h_Vdi_bi_Vgi_bi=(+(+(T8_Vdi_bi_Vgi_bi/T9-(T8_Vdi_bi*T9_Vgi_bi+T8_Vgi_bi*T9_Vdi_bi+T8*T9_Vdi_bi_Vgi_bi)/T9/T9+2*T8*T9_Vdi_bi*T9_Vgi_bi/T9/T9/T9)*ids+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vgi_bi+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vdi_bi+(T8/T9)*ids_Vdi_bi_Vgi_bi)*ids+((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi))*ids_Vgi_bi+(((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi)))*ids_Vdi_bi+((T8/T9)*ids)*ids_Vdi_bi_Vgi_bi);
  Swi_h_Vdi_bi_Vdi_bi=(+(+(T8_Vdi_bi_Vdi_bi/T9-(T8_Vdi_bi*T9_Vdi_bi+T8_Vdi_bi*T9_Vdi_bi+T8*T9_Vdi_bi_Vdi_bi)/T9/T9+2*T8*T9_Vdi_bi*T9_Vdi_bi/T9/T9/T9)*ids+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vdi_bi+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vdi_bi+(T8/T9)*ids_Vdi_bi_Vdi_bi)*ids+((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi))*ids_Vdi_bi+(((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi)))*ids_Vdi_bi+((T8/T9)*ids)*ids_Vdi_bi_Vdi_bi);
  Swi_h_Vdi_bi_Vsi_bi=(+(+(T8_Vdi_bi_Vsi_bi/T9-(T8_Vdi_bi*T9_Vsi_bi+T8_Vsi_bi*T9_Vdi_bi+T8*T9_Vdi_bi_Vsi_bi)/T9/T9+2*T8*T9_Vdi_bi*T9_Vsi_bi/T9/T9/T9)*ids+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vsi_bi+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vdi_bi+(T8/T9)*ids_Vdi_bi_Vsi_bi)*ids+((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi))*ids_Vsi_bi+(((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi)))*ids_Vdi_bi+((T8/T9)*ids)*ids_Vdi_bi_Vsi_bi);
  Swi_h_Vdi_bi_Tempt_GND=(+(+(T8_Vdi_bi_Tempt_GND/T9-(T8_Vdi_bi*T9_Tempt_GND+T8_Tempt_GND*T9_Vdi_bi+T8*T9_Vdi_bi_Tempt_GND)/T9/T9+2*T8*T9_Vdi_bi*T9_Tempt_GND/T9/T9/T9)*ids+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Tempt_GND+((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids_Vdi_bi+(T8/T9)*ids_Vdi_bi_Tempt_GND)*ids+((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi))*ids_Tempt_GND+(((((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids)+((T8/T9)*ids_Tempt_GND)))*ids_Vdi_bi+((T8/T9)*ids)*ids_Vdi_bi_Tempt_GND);
#endif
Swi_h_Vsi_bi=((((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi))*ids)+(((T8/T9)*ids)*ids_Vsi_bi));
#if defined(_DERIVATE2)
  Swi_h_Vsi_bi_Vdbulk_di=(+(+(T8_Vsi_bi_Vdbulk_di/T9-(T8_Vsi_bi*T9_Vdbulk_di+T8_Vdbulk_di*T9_Vsi_bi+T8*T9_Vsi_bi_Vdbulk_di)/T9/T9+2*T8*T9_Vsi_bi*T9_Vdbulk_di/T9/T9/T9)*ids+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vdbulk_di+((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids_Vsi_bi+(T8/T9)*ids_Vsi_bi_Vdbulk_di)*ids+((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi))*ids_Vdbulk_di+(((((T8_Vdbulk_di*T9-T8*T9_Vdbulk_di)/T9/T9)*ids)+((T8/T9)*ids_Vdbulk_di)))*ids_Vsi_bi+((T8/T9)*ids)*ids_Vsi_bi_Vdbulk_di);
  Swi_h_Vsi_bi_Vsbulk_si=(+(+(T8_Vsi_bi_Vsbulk_si/T9-(T8_Vsi_bi*T9_Vsbulk_si+T8_Vsbulk_si*T9_Vsi_bi+T8*T9_Vsi_bi_Vsbulk_si)/T9/T9+2*T8*T9_Vsi_bi*T9_Vsbulk_si/T9/T9/T9)*ids+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vsbulk_si+((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids_Vsi_bi+(T8/T9)*ids_Vsi_bi_Vsbulk_si)*ids+((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi))*ids_Vsbulk_si+(((((T8_Vsbulk_si*T9-T8*T9_Vsbulk_si)/T9/T9)*ids)+((T8/T9)*ids_Vsbulk_si)))*ids_Vsi_bi+((T8/T9)*ids)*ids_Vsi_bi_Vsbulk_si);
  Swi_h_Vsi_bi_Vgi_bi=(+(+(T8_Vsi_bi_Vgi_bi/T9-(T8_Vsi_bi*T9_Vgi_bi+T8_Vgi_bi*T9_Vsi_bi+T8*T9_Vsi_bi_Vgi_bi)/T9/T9+2*T8*T9_Vsi_bi*T9_Vgi_bi/T9/T9/T9)*ids+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vgi_bi+((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids_Vsi_bi+(T8/T9)*ids_Vsi_bi_Vgi_bi)*ids+((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi))*ids_Vgi_bi+(((((T8_Vgi_bi*T9-T8*T9_Vgi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vgi_bi)))*ids_Vsi_bi+((T8/T9)*ids)*ids_Vsi_bi_Vgi_bi);
  Swi_h_Vsi_bi_Vdi_bi=(+(+(T8_Vsi_bi_Vdi_bi/T9-(T8_Vsi_bi*T9_Vdi_bi+T8_Vdi_bi*T9_Vsi_bi+T8*T9_Vsi_bi_Vdi_bi)/T9/T9+2*T8*T9_Vsi_bi*T9_Vdi_bi/T9/T9/T9)*ids+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vdi_bi+((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids_Vsi_bi+(T8/T9)*ids_Vsi_bi_Vdi_bi)*ids+((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi))*ids_Vdi_bi+(((((T8_Vdi_bi*T9-T8*T9_Vdi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vdi_bi)))*ids_Vsi_bi+((T8/T9)*ids)*ids_Vsi_bi_Vdi_bi);
  Swi_h_Vsi_bi_Vsi_bi=(+(+(T8_Vsi_bi_Vsi_bi/T9-(T8_Vsi_bi*T9_Vsi_bi+T8_Vsi_bi*T9_Vsi_bi+T8*T9_Vsi_bi_Vsi_bi)/T9/T9+2*T8*T9_Vsi_bi*T9_Vsi_bi/T9/T9/T9)*ids+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vsi_bi+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Vsi_bi+(T8/T9)*ids_Vsi_bi_Vsi_bi)*ids+((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi))*ids_Vsi_bi+(((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi)))*ids_Vsi_bi+((T8/T9)*ids)*ids_Vsi_bi_Vsi_bi);
  Swi_h_Vsi_bi_Tempt_GND=(+(+(T8_Vsi_bi_Tempt_GND/T9-(T8_Vsi_bi*T9_Tempt_GND+T8_Tempt_GND*T9_Vsi_bi+T8*T9_Vsi_bi_Tempt_GND)/T9/T9+2*T8*T9_Vsi_bi*T9_Tempt_GND/T9/T9/T9)*ids+((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids_Tempt_GND+((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids_Vsi_bi+(T8/T9)*ids_Vsi_bi_Tempt_GND)*ids+((((T8_Vsi_bi*T9-T8*T9_Vsi_bi)/T9/T9)*ids)+((T8/T9)*ids_Vsi_bi))*ids_Tempt_GND+(((((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids)+((T8/T9)*ids_Tempt_GND)))*ids_Vsi_bi+((T8/T9)*ids)*ids_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Swi_h_Tempt_GND=((((((T8_Tempt_GND*T9-T8*T9_Tempt_GND)/T9/T9)*ids)+((T8/T9)*ids_Tempt_GND))*ids)+(((T8/T9)*ids)*ids_Tempt_GND));
#endif
#endif
Swi_h=(((T8/T9)*ids)*ids);
EXIT_IF_ISNAN((((T8/T9)*ids)*ids))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T10_Vdbulk_di=Swi_h_Vdbulk_di;
#if defined(_DERIVATE2)
  T10_Vdbulk_di_Vdbulk_di=Swi_h_Vdbulk_di_Vdbulk_di;
  T10_Vdbulk_di_Vsbulk_si=Swi_h_Vdbulk_di_Vsbulk_si;
  T10_Vdbulk_di_Vgi_bi=Swi_h_Vdbulk_di_Vgi_bi;
  T10_Vdbulk_di_Vdi_bi=Swi_h_Vdbulk_di_Vdi_bi;
  T10_Vdbulk_di_Vsi_bi=Swi_h_Vdbulk_di_Vsi_bi;
  T10_Vdbulk_di_Tempt_GND=Swi_h_Vdbulk_di_Tempt_GND;
#endif
T10_Vsbulk_si=Swi_h_Vsbulk_si;
#if defined(_DERIVATE2)
  T10_Vsbulk_si_Vdbulk_di=Swi_h_Vsbulk_si_Vdbulk_di;
  T10_Vsbulk_si_Vsbulk_si=Swi_h_Vsbulk_si_Vsbulk_si;
  T10_Vsbulk_si_Vgi_bi=Swi_h_Vsbulk_si_Vgi_bi;
  T10_Vsbulk_si_Vdi_bi=Swi_h_Vsbulk_si_Vdi_bi;
  T10_Vsbulk_si_Vsi_bi=Swi_h_Vsbulk_si_Vsi_bi;
  T10_Vsbulk_si_Tempt_GND=Swi_h_Vsbulk_si_Tempt_GND;
#endif
T10_Vgi_bi=Swi_h_Vgi_bi;
#if defined(_DERIVATE2)
  T10_Vgi_bi_Vdbulk_di=Swi_h_Vgi_bi_Vdbulk_di;
  T10_Vgi_bi_Vsbulk_si=Swi_h_Vgi_bi_Vsbulk_si;
  T10_Vgi_bi_Vgi_bi=Swi_h_Vgi_bi_Vgi_bi;
  T10_Vgi_bi_Vdi_bi=Swi_h_Vgi_bi_Vdi_bi;
  T10_Vgi_bi_Vsi_bi=Swi_h_Vgi_bi_Vsi_bi;
  T10_Vgi_bi_Tempt_GND=Swi_h_Vgi_bi_Tempt_GND;
#endif
T10_Vdi_bi=Swi_h_Vdi_bi;
#if defined(_DERIVATE2)
  T10_Vdi_bi_Vdbulk_di=Swi_h_Vdi_bi_Vdbulk_di;
  T10_Vdi_bi_Vsbulk_si=Swi_h_Vdi_bi_Vsbulk_si;
  T10_Vdi_bi_Vgi_bi=Swi_h_Vdi_bi_Vgi_bi;
  T10_Vdi_bi_Vdi_bi=Swi_h_Vdi_bi_Vdi_bi;
  T10_Vdi_bi_Vsi_bi=Swi_h_Vdi_bi_Vsi_bi;
  T10_Vdi_bi_Tempt_GND=Swi_h_Vdi_bi_Tempt_GND;
#endif
T10_Vsi_bi=Swi_h_Vsi_bi;
#if defined(_DERIVATE2)
  T10_Vsi_bi_Vdbulk_di=Swi_h_Vsi_bi_Vdbulk_di;
  T10_Vsi_bi_Vsbulk_si=Swi_h_Vsi_bi_Vsbulk_si;
  T10_Vsi_bi_Vgi_bi=Swi_h_Vsi_bi_Vgi_bi;
  T10_Vsi_bi_Vdi_bi=Swi_h_Vsi_bi_Vdi_bi;
  T10_Vsi_bi_Vsi_bi=Swi_h_Vsi_bi_Vsi_bi;
  T10_Vsi_bi_Tempt_GND=Swi_h_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T10_Tempt_GND=Swi_h_Tempt_GND;
#endif
#endif
T10=Swi_h;
EXIT_IF_ISNAN(Swi_h)
if
((T10>0.0))
{
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
FNPowerAt1Hz_h_Vdbulk_di=Swi_h_Vdbulk_di;
FNPowerAt1Hz_h_Vsbulk_si=Swi_h_Vsbulk_si;
FNPowerAt1Hz_h_Vgi_bi=Swi_h_Vgi_bi;
FNPowerAt1Hz_h_Vdi_bi=Swi_h_Vdi_bi;
FNPowerAt1Hz_h_Vsi_bi=Swi_h_Vsi_bi;
FNPowerAt1Hz_h_Tempt_GND=Swi_h_Tempt_GND;
#endif
FNPowerAt1Hz_h=Swi_h;
EXIT_IF_ISNAN(Swi_h)
}
else
{
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
FNPowerAt1Hz_h_Vdbulk_di=0.0;
FNPowerAt1Hz_h_Vsbulk_si=0.0;
FNPowerAt1Hz_h_Vgi_bi=0.0;
FNPowerAt1Hz_h_Vdi_bi=0.0;
FNPowerAt1Hz_h_Vsi_bi=0.0;
FNPowerAt1Hz_h_Tempt_GND=0.0;
#endif
FNPowerAt1Hz_h=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
FNPowerAt1Hz_Tempt_GND=(((FNPowerAt1Hz_ch_Tempt_GND*CF_ch)+(FNPowerAt1Hz_ch*CF_ch_Tempt_GND))+((FNPowerAt1Hz_h_Tempt_GND*CF_h)+(FNPowerAt1Hz_h*CF_h_Tempt_GND)));
FNPowerAt1Hz_Vgi_bi=(((FNPowerAt1Hz_ch_Vgi_bi*CF_ch)+(FNPowerAt1Hz_ch*CF_ch_Vgi_bi))+((FNPowerAt1Hz_h_Vgi_bi*CF_h)+(FNPowerAt1Hz_h*CF_h_Vgi_bi)));
FNPowerAt1Hz_Vdi_bi=(((FNPowerAt1Hz_ch_Vdi_bi*CF_ch)+(FNPowerAt1Hz_ch*CF_ch_Vdi_bi))+((FNPowerAt1Hz_h_Vdi_bi*CF_h)+(FNPowerAt1Hz_h*CF_h_Vdi_bi)));
FNPowerAt1Hz_Vsi_bi=(((FNPowerAt1Hz_ch_Vsi_bi*CF_ch)+(FNPowerAt1Hz_ch*CF_ch_Vsi_bi))+((FNPowerAt1Hz_h_Vsi_bi*CF_h)+(FNPowerAt1Hz_h*CF_h_Vsi_bi)));
FNPowerAt1Hz_Vdbulk_di=(((FNPowerAt1Hz_ch_Vdbulk_di*CF_ch)+(FNPowerAt1Hz_ch*CF_ch_Vdbulk_di))+((FNPowerAt1Hz_h_Vdbulk_di*CF_h)+(FNPowerAt1Hz_h*CF_h_Vdbulk_di)));
FNPowerAt1Hz_Vsbulk_si=(((FNPowerAt1Hz_ch_Vsbulk_si*CF_ch)+(FNPowerAt1Hz_ch*CF_ch_Vsbulk_si))+((FNPowerAt1Hz_h_Vsbulk_si*CF_h)+(FNPowerAt1Hz_h*CF_h_Vsbulk_si)));
#endif
FNPowerAt1Hz=((FNPowerAt1Hz_ch*CF_ch)+(FNPowerAt1Hz_h*CF_h));
EXIT_IF_ISNAN(((FNPowerAt1Hz_ch*CF_ch)+(FNPowerAt1Hz_h*CF_h)))
pInst->fpnoise1=FNPowerAt1Hz;
pInst->fenoise1=pModel->EF;
}
else
{
if
((pModel->LINTNOI>=(Leff/2.0)))
{
printf("Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0.",pModel->LINTNOI);
printf("\n");
LINTNOI_i=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
LINTNOI_i=pModel->LINTNOI;
EXIT_IF_ISNAN(pModel->LINTNOI)
}
if
((((pModel->NOIA>0)||(pModel->NOIB>0))||(pModel->NOIC>0)))
{
Leffnoi=(Leff-(2.0*LINTNOI_i));
EXIT_IF_ISNAN((Leff-(2.0*LINTNOI_i)))
Leffnoisq=(Leffnoi*Leffnoi);
EXIT_IF_ISNAN((Leffnoi*Leffnoi))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=0.0;
#endif
#endif
T0=((1.0e10*Cox)*Leffnoisq);
EXIT_IF_ISNAN(((1.0e10*Cox)*Leffnoisq))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
N0_Vgi_bi=((((2.0*nq_Vgi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vgi_bi))/1.60219e-19);
#if defined(_DERIVATE2)
  N0_Vgi_bi_Vgi_bi=((+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vgi_bi)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*0.0+(((2.0*nq_Vgi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vgi_bi)*Cox*Vt*qs_Vgi_bi+((((2.0*nq_Vgi_bi))*Cox)*Vt)*qs_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vgi_bi_Vgi_bi)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vgi_bi))*0.0+(((((((2.0*nq_Vgi_bi))*Cox)*Vt)*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vgi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  N0_Vgi_bi_Tempt_GND=((+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Tempt_GND)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*Vt_Tempt_GND+(((2.0*nq_Tempt_GND))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vgi_bi)*Cox*Vt*qs_Tempt_GND+((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qs_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vgi_bi_Tempt_GND)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vgi_bi))*0.0+(((((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qs)+((((2.0*nq)*Cox)*Vt)*qs_Tempt_GND)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  N0_Vgi_bi_Vdi_bi=((+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdi_bi)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*0.0+(((2.0*nq_Vdi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vgi_bi)*Cox*Vt*qs_Vdi_bi+((((2.0*nq_Vdi_bi))*Cox)*Vt)*qs_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vgi_bi_Vdi_bi)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vgi_bi))*0.0+(((((((2.0*nq_Vdi_bi))*Cox)*Vt)*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vdi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  N0_Vgi_bi_Vsi_bi=((+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsi_bi)*Cox+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vgi_bi)*Cox*0.0+(((2.0*nq_Vsi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vgi_bi)*Cox*Vt*qs_Vsi_bi+((((2.0*nq_Vsi_bi))*Cox)*Vt)*qs_Vgi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vgi_bi_Vsi_bi)/1.60219e-19-((((2.0*nq_Vgi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vgi_bi))*0.0+(((((((2.0*nq_Vsi_bi))*Cox)*Vt)*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vsi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
#endif
#if defined(_DERIVATE)
N0_Tempt_GND=((((((2.0*nq_Tempt_GND)*Cox*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND))*qs)+((((2.0*nq)*Cox)*Vt)*qs_Tempt_GND))/1.60219e-19);
#endif
N0_Vdi_bi=((((2.0*nq_Vdi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vdi_bi))/1.60219e-19);
#if defined(_DERIVATE2)
  N0_Vdi_bi_Vgi_bi=((+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vgi_bi)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*0.0+(((2.0*nq_Vgi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vdi_bi)*Cox*Vt*qs_Vgi_bi+((((2.0*nq_Vgi_bi))*Cox)*Vt)*qs_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vdi_bi_Vgi_bi)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vdi_bi))*0.0+(((((((2.0*nq_Vgi_bi))*Cox)*Vt)*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vgi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  N0_Vdi_bi_Tempt_GND=((+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Tempt_GND)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*Vt_Tempt_GND+(((2.0*nq_Tempt_GND))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vdi_bi)*Cox*Vt*qs_Tempt_GND+((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qs_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vdi_bi_Tempt_GND)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vdi_bi))*0.0+(((((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qs)+((((2.0*nq)*Cox)*Vt)*qs_Tempt_GND)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  N0_Vdi_bi_Vdi_bi=((+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdi_bi)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*0.0+(((2.0*nq_Vdi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vdi_bi)*Cox*Vt*qs_Vdi_bi+((((2.0*nq_Vdi_bi))*Cox)*Vt)*qs_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vdi_bi_Vdi_bi)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vdi_bi))*0.0+(((((((2.0*nq_Vdi_bi))*Cox)*Vt)*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vdi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  N0_Vdi_bi_Vsi_bi=((+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsi_bi)*Cox+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vdi_bi)*Cox*0.0+(((2.0*nq_Vsi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vdi_bi)*Cox*Vt*qs_Vsi_bi+((((2.0*nq_Vsi_bi))*Cox)*Vt)*qs_Vdi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vdi_bi_Vsi_bi)/1.60219e-19-((((2.0*nq_Vdi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vdi_bi))*0.0+(((((((2.0*nq_Vsi_bi))*Cox)*Vt)*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vsi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
#endif
N0_Vsi_bi=((((2.0*nq_Vsi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vsi_bi))/1.60219e-19);
#if defined(_DERIVATE2)
  N0_Vsi_bi_Vgi_bi=((+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vgi_bi)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*0.0+(((2.0*nq_Vgi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vsi_bi)*Cox*Vt*qs_Vgi_bi+((((2.0*nq_Vgi_bi))*Cox)*Vt)*qs_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vsi_bi_Vgi_bi)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vsi_bi))*0.0+(((((((2.0*nq_Vgi_bi))*Cox)*Vt)*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vgi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  N0_Vsi_bi_Tempt_GND=((+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Tempt_GND)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*Vt_Tempt_GND+(((2.0*nq_Tempt_GND))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vsi_bi)*Cox*Vt*qs_Tempt_GND+((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qs_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vsi_bi_Tempt_GND)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vsi_bi))*0.0+(((((((((2.0*nq_Tempt_GND))*Cox)*Vt)+(((2.0*nq)*Cox)*Vt_Tempt_GND)))*qs)+((((2.0*nq)*Cox)*Vt)*qs_Tempt_GND)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  N0_Vsi_bi_Vdi_bi=((+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdi_bi)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*0.0+(((2.0*nq_Vdi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vsi_bi)*Cox*Vt*qs_Vdi_bi+((((2.0*nq_Vdi_bi))*Cox)*Vt)*qs_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vsi_bi_Vdi_bi)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vsi_bi))*0.0+(((((((2.0*nq_Vdi_bi))*Cox)*Vt)*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vdi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
  N0_Vsi_bi_Vsi_bi=((+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsi_bi)*Cox+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*Vt+(2.0*nq_Vsi_bi)*Cox*0.0+(((2.0*nq_Vsi_bi))*Cox)*0.0+((2.0*nq)*Cox)*0.0)*qs+(2.0*nq_Vsi_bi)*Cox*Vt*qs_Vsi_bi+((((2.0*nq_Vsi_bi))*Cox)*Vt)*qs_Vsi_bi+(((2.0*nq)*Cox)*Vt)*qs_Vsi_bi_Vsi_bi)/1.60219e-19-((((2.0*nq_Vsi_bi)*Cox*Vt*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vsi_bi))*0.0+(((((((2.0*nq_Vsi_bi))*Cox)*Vt)*qs)+((((2.0*nq)*Cox)*Vt)*qs_Vsi_bi)))*0.0+((((2.0*nq)*Cox)*Vt)*qs)*0.0)/1.60219e-19/1.60219e-19+2*((((2.0*nq)*Cox)*Vt)*qs)*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19);
#endif
#endif
N0=(((((2.0*nq)*Cox)*Vt)*qs)/1.60219e-19);
EXIT_IF_ISNAN((((((2.0*nq)*Cox)*Vt)*qs)/1.60219e-19))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(pModel->NOIA*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-(N0_Vgi_bi*0.0+0.0*Nl_Vgi_bi+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*Nl_Vgi_bi*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vgi_bi_Vgm_si=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-(N0_Vgi_bi*0.0+0.0*Nl_Vgi_bi+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*Nl_Vgi_bi*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-(N0_Vgi_bi*0.0+0.0*Nl_Vgi_bi+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*Nl_Vgi_bi*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-(N0_Vgi_bi*0.0+0.0*Nl_Vgi_bi+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*Nl_Vgi_bi*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vgi_bi_Vgi_bi+0.0)/(Nl+Nstar)-(N0_Vgi_bi*Nl_Vgi_bi+N0_Vgi_bi*Nl_Vgi_bi+(N0+Nstar)*(+Nl_Vgi_bi_Vgi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*Nl_Vgi_bi*Nl_Vgi_bi/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vgi_bi_Vdi_bi+0.0)/(Nl+Nstar)-(N0_Vgi_bi*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0_Vdi_bi+Nstar_Vdi_bi)*Nl_Vgi_bi+(N0+Nstar)*(+Nl_Vgi_bi_Vdi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*Nl_Vgi_bi*(Nl_Vdi_bi+Nstar_Vdi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vgi_bi_Vsi_bi+0.0)/(Nl+Nstar)-(N0_Vgi_bi*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0_Vsi_bi+Nstar_Vsi_bi)*Nl_Vgi_bi+(N0+Nstar)*(+Nl_Vgi_bi_Vsi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*Nl_Vgi_bi*(Nl_Vsi_bi+Nstar_Vsi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),((N0_Vgi_bi*(Nl+Nstar)-(N0+Nstar)*Nl_Vgi_bi)/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vgi_bi_Tempt_GND+0.0)/(Nl+Nstar)-(N0_Vgi_bi*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0_Tempt_GND+Nstar_Tempt_GND)*Nl_Vgi_bi+(N0+Nstar)*(+Nl_Vgi_bi_Tempt_GND+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*Nl_Vgi_bi*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
T1_Vdi_bi=(pModel->NOIA*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vdi_bi+Nstar_Vdi_bi)*0.0+0.0*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vdi_bi_Vgm_si=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vdi_bi+Nstar_Vdi_bi)*0.0+0.0*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vdi_bi+Nstar_Vdi_bi)*0.0+0.0*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vdi_bi+Nstar_Vdi_bi)*0.0+0.0*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_bi_Vgi_bi+0.0)/(Nl+Nstar)-((N0_Vdi_bi+Nstar_Vdi_bi)*Nl_Vgi_bi+N0_Vgi_bi*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0+Nstar)*(+Nl_Vdi_bi_Vgi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*Nl_Vgi_bi/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_bi_Vdi_bi+Nstar_Vdi_bi_Vdi_bi)/(Nl+Nstar)-((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0+Nstar)*(+Nl_Vdi_bi_Vdi_bi+Nstar_Vdi_bi_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_bi_Vsi_bi+Nstar_Vdi_bi_Vsi_bi)/(Nl+Nstar)-((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0+Nstar)*(+Nl_Vdi_bi_Vsi_bi+Nstar_Vdi_bi_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_bi_Tempt_GND+Nstar_Vdi_bi_Tempt_GND)/(Nl+Nstar)-((N0_Vdi_bi+Nstar_Vdi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0+Nstar)*(+Nl_Vdi_bi_Tempt_GND+Nstar_Vdi_bi_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_bi+Nstar_Vdi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
T1_Vsi_bi=(pModel->NOIA*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vsi_bi+Nstar_Vsi_bi)*0.0+0.0*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vsi_bi_Vgm_si=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vsi_bi+Nstar_Vsi_bi)*0.0+0.0*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vsi_bi+Nstar_Vsi_bi)*0.0+0.0*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vsi_bi+Nstar_Vsi_bi)*0.0+0.0*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vsi_bi_Vgi_bi+0.0)/(Nl+Nstar)-((N0_Vsi_bi+Nstar_Vsi_bi)*Nl_Vgi_bi+N0_Vgi_bi*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0+Nstar)*(+Nl_Vsi_bi_Vgi_bi+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*Nl_Vgi_bi/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vsi_bi_Vdi_bi+Nstar_Vsi_bi_Vdi_bi)/(Nl+Nstar)-((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)+(N0_Vdi_bi+Nstar_Vdi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0+Nstar)*(+Nl_Vsi_bi_Vdi_bi+Nstar_Vsi_bi_Vdi_bi))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vdi_bi+Nstar_Vdi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vsi_bi_Vsi_bi+Nstar_Vsi_bi_Vsi_bi)/(Nl+Nstar)-((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0+Nstar)*(+Nl_Vsi_bi_Vsi_bi+Nstar_Vsi_bi_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Vsi_bi+Nstar_Vsi_bi)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T1_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vsi_bi_Tempt_GND+Nstar_Vsi_bi_Tempt_GND)/(Nl+Nstar)-((N0_Vsi_bi+Nstar_Vsi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vsi_bi+Nstar_Vsi_bi)+(N0+Nstar)*(+Nl_Vsi_bi_Tempt_GND+Nstar_Vsi_bi_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vsi_bi+Nstar_Vsi_bi)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(pModel->NOIA*bsimbulk_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar))));
#endif
#endif
T1=(pModel->NOIA*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar))));
EXIT_IF_ISNAN((pModel->NOIA*bsimbulk_lln(((N0+Nstar)/(Nl+Nstar)))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=0.0;
  T2_Vdbulk_di_Vgm_si=0.0;
  T2_Vdbulk_di_Vdbulk_di=0.0;
  T2_Vdbulk_di_Vsbulk_si=0.0;
  T2_Vdbulk_di_Vgi_bi=0.0;
  T2_Vdbulk_di_Vdi_bi=0.0;
  T2_Vdbulk_di_Vsi_bi=0.0;
  T2_Vdbulk_di_Tempt_GND=0.0;
#endif
T2_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=0.0;
  T2_Vsbulk_si_Vgm_si=0.0;
  T2_Vsbulk_si_Vdbulk_di=0.0;
  T2_Vsbulk_si_Vsbulk_si=0.0;
  T2_Vsbulk_si_Vgi_bi=0.0;
  T2_Vsbulk_si_Vdi_bi=0.0;
  T2_Vsbulk_si_Vsi_bi=0.0;
  T2_Vsbulk_si_Tempt_GND=0.0;
#endif
T2_Vgi_bi=(pModel->NOIB*(N0_Vgi_bi-Nl_Vgi_bi));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vgi_bi_Vgm_si=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vgi_bi_Vdbulk_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vgi_bi_Vsbulk_si=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vgi_bi_Vgi_bi=(+0.0*(N0-Nl)+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+N0_Vgi_bi_Vgi_bi-Nl_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+0.0*(N0-Nl)+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+N0_Vgi_bi_Vdi_bi-Nl_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+0.0*(N0-Nl)+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+N0_Vgi_bi_Vsi_bi-Nl_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+0.0*(N0-Nl)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+pModel->NOIB*(+N0_Vgi_bi_Tempt_GND-Nl_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(pModel->NOIB*(N0_Vdi_bi-Nl_Vdi_bi));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vdi_bi_Vgm_si=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vdi_bi_Vdbulk_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vdi_bi_Vsbulk_si=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vdi_bi_Vgi_bi=(+0.0*(N0-Nl)+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+N0_Vdi_bi_Vgi_bi-Nl_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+0.0*(N0-Nl)+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+N0_Vdi_bi_Vdi_bi-Nl_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+0.0*(N0-Nl)+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+N0_Vdi_bi_Vsi_bi-Nl_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+0.0*(N0-Nl)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+pModel->NOIB*(+N0_Vdi_bi_Tempt_GND-Nl_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(pModel->NOIB*(N0_Vsi_bi-Nl_Vsi_bi));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vsi_bi_Vgm_si=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vsi_bi_Vdbulk_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vsi_bi_Vsbulk_si=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+0.0-0.0));
  T2_Vsi_bi_Vgi_bi=(+0.0*(N0-Nl)+0.0*(N0_Vgi_bi-Nl_Vgi_bi)+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+N0_Vsi_bi_Vgi_bi-Nl_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+0.0*(N0-Nl)+0.0*(N0_Vdi_bi-Nl_Vdi_bi)+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+N0_Vsi_bi_Vdi_bi-Nl_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+0.0*(N0-Nl)+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+N0_Vsi_bi_Vsi_bi-Nl_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+0.0*(N0-Nl)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+0.0*(N0_Vsi_bi-Nl_Vsi_bi)+pModel->NOIB*(+N0_Vsi_bi_Tempt_GND-Nl_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(pModel->NOIB*(N0_Tempt_GND-Nl_Tempt_GND));
#endif
#endif
T2=(pModel->NOIB*(N0-Nl));
EXIT_IF_ISNAN((pModel->NOIB*(N0-Nl)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=((0.5*pModel->NOIC)*(((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi))));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vgi_bi*0.0+0.0*N0_Vgi_bi+N0*0.0)-(+0.0*Nl+Nl_Vgi_bi*0.0+0.0*Nl_Vgi_bi+Nl*0.0)));
  T3_Vgi_bi_Vgm_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vgi_bi*0.0+0.0*N0_Vgi_bi+N0*0.0)-(+0.0*Nl+Nl_Vgi_bi*0.0+0.0*Nl_Vgi_bi+Nl*0.0)));
  T3_Vgi_bi_Vdbulk_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vgi_bi*0.0+0.0*N0_Vgi_bi+N0*0.0)-(+0.0*Nl+Nl_Vgi_bi*0.0+0.0*Nl_Vgi_bi+Nl*0.0)));
  T3_Vgi_bi_Vsbulk_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vgi_bi*0.0+0.0*N0_Vgi_bi+N0*0.0)-(+0.0*Nl+Nl_Vgi_bi*0.0+0.0*Nl_Vgi_bi+Nl*0.0)));
  T3_Vgi_bi_Vgi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi)))-(((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi))))+(0.0)*(((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vgi_bi_Vgi_bi*N0+N0_Vgi_bi*N0_Vgi_bi+N0_Vgi_bi*N0_Vgi_bi+N0*N0_Vgi_bi_Vgi_bi)-(+Nl_Vgi_bi_Vgi_bi*Nl+Nl_Vgi_bi*Nl_Vgi_bi+Nl_Vgi_bi*Nl_Vgi_bi+Nl*Nl_Vgi_bi_Vgi_bi)));
  T3_Vgi_bi_Vdi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi)))-(((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi))))+(0.0)*(((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vgi_bi_Vdi_bi*N0+N0_Vgi_bi*N0_Vdi_bi+N0_Vdi_bi*N0_Vgi_bi+N0*N0_Vgi_bi_Vdi_bi)-(+Nl_Vgi_bi_Vdi_bi*Nl+Nl_Vgi_bi*Nl_Vdi_bi+Nl_Vdi_bi*Nl_Vgi_bi+Nl*Nl_Vgi_bi_Vdi_bi)));
  T3_Vgi_bi_Vsi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi)))-(((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi))))+(0.0)*(((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vgi_bi_Vsi_bi*N0+N0_Vgi_bi*N0_Vsi_bi+N0_Vsi_bi*N0_Vgi_bi+N0*N0_Vgi_bi_Vsi_bi)-(+Nl_Vgi_bi_Vsi_bi*Nl+Nl_Vgi_bi*Nl_Vsi_bi+Nl_Vsi_bi*Nl_Vgi_bi+Nl*Nl_Vgi_bi_Vsi_bi)));
  T3_Vgi_bi_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi))-((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vgi_bi_Tempt_GND*N0+N0_Vgi_bi*N0_Tempt_GND+N0_Tempt_GND*N0_Vgi_bi+N0*N0_Vgi_bi_Tempt_GND)-(+Nl_Vgi_bi_Tempt_GND*Nl+Nl_Vgi_bi*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Vgi_bi+Nl*Nl_Vgi_bi_Tempt_GND)));
#endif
T3_Vdi_bi=((0.5*pModel->NOIC)*(((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi))));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vdi_bi*0.0+0.0*N0_Vdi_bi+N0*0.0)-(+0.0*Nl+Nl_Vdi_bi*0.0+0.0*Nl_Vdi_bi+Nl*0.0)));
  T3_Vdi_bi_Vgm_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vdi_bi*0.0+0.0*N0_Vdi_bi+N0*0.0)-(+0.0*Nl+Nl_Vdi_bi*0.0+0.0*Nl_Vdi_bi+Nl*0.0)));
  T3_Vdi_bi_Vdbulk_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vdi_bi*0.0+0.0*N0_Vdi_bi+N0*0.0)-(+0.0*Nl+Nl_Vdi_bi*0.0+0.0*Nl_Vdi_bi+Nl*0.0)));
  T3_Vdi_bi_Vsbulk_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vdi_bi*0.0+0.0*N0_Vdi_bi+N0*0.0)-(+0.0*Nl+Nl_Vdi_bi*0.0+0.0*Nl_Vdi_bi+Nl*0.0)));
  T3_Vdi_bi_Vgi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi)))-(((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi))))+(0.0)*(((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_bi_Vgi_bi*N0+N0_Vdi_bi*N0_Vgi_bi+N0_Vgi_bi*N0_Vdi_bi+N0*N0_Vdi_bi_Vgi_bi)-(+Nl_Vdi_bi_Vgi_bi*Nl+Nl_Vdi_bi*Nl_Vgi_bi+Nl_Vgi_bi*Nl_Vdi_bi+Nl*Nl_Vdi_bi_Vgi_bi)));
  T3_Vdi_bi_Vdi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi)))-(((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi))))+(0.0)*(((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_bi_Vdi_bi*N0+N0_Vdi_bi*N0_Vdi_bi+N0_Vdi_bi*N0_Vdi_bi+N0*N0_Vdi_bi_Vdi_bi)-(+Nl_Vdi_bi_Vdi_bi*Nl+Nl_Vdi_bi*Nl_Vdi_bi+Nl_Vdi_bi*Nl_Vdi_bi+Nl*Nl_Vdi_bi_Vdi_bi)));
  T3_Vdi_bi_Vsi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi)))-(((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi))))+(0.0)*(((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_bi_Vsi_bi*N0+N0_Vdi_bi*N0_Vsi_bi+N0_Vsi_bi*N0_Vdi_bi+N0*N0_Vdi_bi_Vsi_bi)-(+Nl_Vdi_bi_Vsi_bi*Nl+Nl_Vdi_bi*Nl_Vsi_bi+Nl_Vsi_bi*Nl_Vdi_bi+Nl*Nl_Vdi_bi_Vsi_bi)));
  T3_Vdi_bi_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi))-((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_bi_Tempt_GND*N0+N0_Vdi_bi*N0_Tempt_GND+N0_Tempt_GND*N0_Vdi_bi+N0*N0_Vdi_bi_Tempt_GND)-(+Nl_Vdi_bi_Tempt_GND*Nl+Nl_Vdi_bi*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Vdi_bi+Nl*Nl_Vdi_bi_Tempt_GND)));
#endif
T3_Vsi_bi=((0.5*pModel->NOIC)*(((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi))));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vsi_bi*0.0+0.0*N0_Vsi_bi+N0*0.0)-(+0.0*Nl+Nl_Vsi_bi*0.0+0.0*Nl_Vsi_bi+Nl*0.0)));
  T3_Vsi_bi_Vgm_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vsi_bi*0.0+0.0*N0_Vsi_bi+N0*0.0)-(+0.0*Nl+Nl_Vsi_bi*0.0+0.0*Nl_Vsi_bi+Nl*0.0)));
  T3_Vsi_bi_Vdbulk_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vsi_bi*0.0+0.0*N0_Vsi_bi+N0*0.0)-(+0.0*Nl+Nl_Vsi_bi*0.0+0.0*Nl_Vsi_bi+Nl*0.0)));
  T3_Vsi_bi_Vsbulk_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vsi_bi*0.0+0.0*N0_Vsi_bi+N0*0.0)-(+0.0*Nl+Nl_Vsi_bi*0.0+0.0*Nl_Vsi_bi+Nl*0.0)));
  T3_Vsi_bi_Vgi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vgi_bi*N0)+(N0*N0_Vgi_bi)))-(((Nl_Vgi_bi*Nl)+(Nl*Nl_Vgi_bi))))+(0.0)*(((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vsi_bi_Vgi_bi*N0+N0_Vsi_bi*N0_Vgi_bi+N0_Vgi_bi*N0_Vsi_bi+N0*N0_Vsi_bi_Vgi_bi)-(+Nl_Vsi_bi_Vgi_bi*Nl+Nl_Vsi_bi*Nl_Vgi_bi+Nl_Vgi_bi*Nl_Vsi_bi+Nl*Nl_Vsi_bi_Vgi_bi)));
  T3_Vsi_bi_Vdi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vdi_bi*N0)+(N0*N0_Vdi_bi)))-(((Nl_Vdi_bi*Nl)+(Nl*Nl_Vdi_bi))))+(0.0)*(((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vsi_bi_Vdi_bi*N0+N0_Vsi_bi*N0_Vdi_bi+N0_Vdi_bi*N0_Vsi_bi+N0*N0_Vsi_bi_Vdi_bi)-(+Nl_Vsi_bi_Vdi_bi*Nl+Nl_Vsi_bi*Nl_Vdi_bi+Nl_Vdi_bi*Nl_Vsi_bi+Nl*Nl_Vsi_bi_Vdi_bi)));
  T3_Vsi_bi_Vsi_bi=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi)))-(((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi))))+(0.0)*(((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vsi_bi_Vsi_bi*N0+N0_Vsi_bi*N0_Vsi_bi+N0_Vsi_bi*N0_Vsi_bi+N0*N0_Vsi_bi_Vsi_bi)-(+Nl_Vsi_bi_Vsi_bi*Nl+Nl_Vsi_bi*Nl_Vsi_bi+Nl_Vsi_bi*Nl_Vsi_bi+Nl*Nl_Vsi_bi_Vsi_bi)));
  T3_Vsi_bi_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((N0_Vsi_bi*N0)+(N0*N0_Vsi_bi))-((Nl_Vsi_bi*Nl)+(Nl*Nl_Vsi_bi)))+(0.5*pModel->NOIC)*(+(+N0_Vsi_bi_Tempt_GND*N0+N0_Vsi_bi*N0_Tempt_GND+N0_Tempt_GND*N0_Vsi_bi+N0*N0_Vsi_bi_Tempt_GND)-(+Nl_Vsi_bi_Tempt_GND*Nl+Nl_Vsi_bi*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Vsi_bi+Nl*Nl_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=((0.5*pModel->NOIC)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))));
#endif
#endif
T3=((0.5*pModel->NOIC)*((N0*N0)-(Nl*Nl)));
EXIT_IF_ISNAN(((0.5*pModel->NOIC)*((N0*N0)-(Nl*Nl))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=0.0;
#endif
#endif
T4=(((1.0e10*Leffnoisq)*Weff)*pInst->NF);
EXIT_IF_ISNAN((((1.0e10*Leffnoisq)*Weff)*pInst->NF))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Ssi_Tempt_GND=(((((T0a_Tempt_GND*T0-T0a*T0_Tempt_GND)/T0/T0)*((T1+T2)+T3))+((T0a/T0)*((T1_Tempt_GND+T2_Tempt_GND)+T3_Tempt_GND)))+((((((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND))*T0c)+(((T0b/T4)*DelClm)*T0c_Tempt_GND))*T0d-(((T0b/T4)*DelClm)*T0c)*T0d_Tempt_GND)/T0d/T0d));
#endif
Ssi_Vgi_bi=(((((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1+T2)+T3))+((T0a/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)))+((((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi))*T0d-(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi)/T0d/T0d));
#if defined(_DERIVATE2)
  Ssi_Vgi_bi_Tempt_GND=(+(+(T0a_Vgi_bi_Tempt_GND/T0-(T0a_Vgi_bi*T0_Tempt_GND+T0a_Tempt_GND*T0_Vgi_bi+T0a*T0_Vgi_bi_Tempt_GND)/T0/T0+2*T0a*T0_Vgi_bi*T0_Tempt_GND/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Tempt_GND+T2_Tempt_GND)+T3_Tempt_GND)+((T0a_Tempt_GND*T0-T0a*T0_Tempt_GND)/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+(T0a/T0)*(+(+T1_Vgi_bi_Tempt_GND+T2_Vgi_bi_Tempt_GND)+T3_Vgi_bi_Tempt_GND))+((+(+(T0b_Vgi_bi_Tempt_GND/T4-(T0b_Vgi_bi*T4_Tempt_GND+T0b_Tempt_GND*T4_Vgi_bi+T0b*T4_Vgi_bi_Tempt_GND)/T4/T4+2*T0b*T4_Vgi_bi*T4_Tempt_GND/T4/T4/T4)*DelClm+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Tempt_GND+((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm_Vgi_bi+(T0b/T4)*DelClm_Vgi_bi_Tempt_GND)*T0c+((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*T0c_Vgi_bi+((T0b/T4)*DelClm)*T0c_Vgi_bi_Tempt_GND)/T0d-(((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi))*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*T0c)+(((T0b/T4)*DelClm)*T0c_Tempt_GND)))*T0d_Vgi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi_Tempt_GND)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_Vgi_bi_Vgi_bi=(+(+(T0a_Vgi_bi_Vgi_bi/T0-(T0a_Vgi_bi*T0_Vgi_bi+T0a_Vgi_bi*T0_Vgi_bi+T0a*T0_Vgi_bi_Vgi_bi)/T0/T0+2*T0a*T0_Vgi_bi*T0_Vgi_bi/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+(T0a/T0)*(+(+T1_Vgi_bi_Vgi_bi+T2_Vgi_bi_Vgi_bi)+T3_Vgi_bi_Vgi_bi))+((+(+(T0b_Vgi_bi_Vgi_bi/T4-(T0b_Vgi_bi*T4_Vgi_bi+T0b_Vgi_bi*T4_Vgi_bi+T0b*T4_Vgi_bi_Vgi_bi)/T4/T4+2*T0b*T4_Vgi_bi*T4_Vgi_bi/T4/T4/T4)*DelClm+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vgi_bi+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vgi_bi+(T0b/T4)*DelClm_Vgi_bi_Vgi_bi)*T0c+((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*T0c_Vgi_bi+((T0b/T4)*DelClm)*T0c_Vgi_bi_Vgi_bi)/T0d-(((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi))*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi)))*T0d_Vgi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi_Vgi_bi)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_Vgi_bi_Vdi_bi=(+(+(T0a_Vgi_bi_Vdi_bi/T0-(T0a_Vgi_bi*T0_Vdi_bi+T0a_Vdi_bi*T0_Vgi_bi+T0a*T0_Vgi_bi_Vdi_bi)/T0/T0+2*T0a*T0_Vgi_bi*T0_Vdi_bi/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+(T0a/T0)*(+(+T1_Vgi_bi_Vdi_bi+T2_Vgi_bi_Vdi_bi)+T3_Vgi_bi_Vdi_bi))+((+(+(T0b_Vgi_bi_Vdi_bi/T4-(T0b_Vgi_bi*T4_Vdi_bi+T0b_Vdi_bi*T4_Vgi_bi+T0b*T4_Vgi_bi_Vdi_bi)/T4/T4+2*T0b*T4_Vgi_bi*T4_Vdi_bi/T4/T4/T4)*DelClm+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vdi_bi+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vgi_bi+(T0b/T4)*DelClm_Vgi_bi_Vdi_bi)*T0c+((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*T0c_Vgi_bi+((T0b/T4)*DelClm)*T0c_Vgi_bi_Vdi_bi)/T0d-(((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi))*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi)))*T0d_Vgi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi_Vdi_bi)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_Vgi_bi_Vsi_bi=(+(+(T0a_Vgi_bi_Vsi_bi/T0-(T0a_Vgi_bi*T0_Vsi_bi+T0a_Vsi_bi*T0_Vgi_bi+T0a*T0_Vgi_bi_Vsi_bi)/T0/T0+2*T0a*T0_Vgi_bi*T0_Vsi_bi/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+(T0a/T0)*(+(+T1_Vgi_bi_Vsi_bi+T2_Vgi_bi_Vsi_bi)+T3_Vgi_bi_Vsi_bi))+((+(+(T0b_Vgi_bi_Vsi_bi/T4-(T0b_Vgi_bi*T4_Vsi_bi+T0b_Vsi_bi*T4_Vgi_bi+T0b*T4_Vgi_bi_Vsi_bi)/T4/T4+2*T0b*T4_Vgi_bi*T4_Vsi_bi/T4/T4/T4)*DelClm+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vsi_bi+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vgi_bi+(T0b/T4)*DelClm_Vgi_bi_Vsi_bi)*T0c+((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*T0c_Vgi_bi+((T0b/T4)*DelClm)*T0c_Vgi_bi_Vsi_bi)/T0d-(((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi))*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi)))*T0d_Vgi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi_Vsi_bi)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_Vgi_bi_Vdbulk_di=(+(+(0.0/T0-(T0a_Vgi_bi*T0_Vdbulk_di+0.0*T0_Vgi_bi+T0a*T0_Vgi_bi_Vdbulk_di)/T0/T0+2*T0a*T0_Vgi_bi*T0_Vdbulk_di/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+(T0a/T0)*(+(+T1_Vgi_bi_Vdbulk_di+T2_Vgi_bi_Vdbulk_di)+T3_Vgi_bi_Vdbulk_di))+((+(+(0.0/T4-(T0b_Vgi_bi*T4_Vdbulk_di+0.0*T4_Vgi_bi+T0b*T4_Vgi_bi_Vdbulk_di)/T4/T4+2*T0b*T4_Vgi_bi*T4_Vdbulk_di/T4/T4/T4)*DelClm+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vdbulk_di+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vgi_bi+(T0b/T4)*DelClm_Vgi_bi_Vdbulk_di)*T0c+((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*0.0+((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*T0c_Vgi_bi+((T0b/T4)*DelClm)*0.0)/T0d-(((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi))*0.0+(((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*T0c)*T0d_Vgi_bi+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi*0.0/T0d/T0d/T0d));
  Ssi_Vgi_bi_Vsbulk_si=(+(+(0.0/T0-(T0a_Vgi_bi*T0_Vsbulk_si+0.0*T0_Vgi_bi+T0a*T0_Vgi_bi_Vsbulk_si)/T0/T0+2*T0a*T0_Vgi_bi*T0_Vsbulk_si/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+(T0a/T0)*(+(+T1_Vgi_bi_Vsbulk_si+T2_Vgi_bi_Vsbulk_si)+T3_Vgi_bi_Vsbulk_si))+((+(+(0.0/T4-(T0b_Vgi_bi*T4_Vsbulk_si+0.0*T4_Vgi_bi+T0b*T4_Vgi_bi_Vsbulk_si)/T4/T4+2*T0b*T4_Vgi_bi*T4_Vsbulk_si/T4/T4/T4)*DelClm+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vsbulk_si+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vgi_bi+(T0b/T4)*DelClm_Vgi_bi_Vsbulk_si)*T0c+((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*0.0+((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*T0c_Vgi_bi+((T0b/T4)*DelClm)*0.0)/T0d-(((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi))*0.0+(((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*T0c)*T0d_Vgi_bi+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vgi_bi*0.0/T0d/T0d/T0d));
#endif
Ssi_Vdi_bi=(((((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1+T2)+T3))+((T0a/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)))+((((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi))*T0d-(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi)/T0d/T0d));
#if defined(_DERIVATE2)
  Ssi_Vdi_bi_Tempt_GND=(+(+(T0a_Vdi_bi_Tempt_GND/T0-(T0a_Vdi_bi*T0_Tempt_GND+T0a_Tempt_GND*T0_Vdi_bi+T0a*T0_Vdi_bi_Tempt_GND)/T0/T0+2*T0a*T0_Vdi_bi*T0_Tempt_GND/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Tempt_GND+T2_Tempt_GND)+T3_Tempt_GND)+((T0a_Tempt_GND*T0-T0a*T0_Tempt_GND)/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+(T0a/T0)*(+(+T1_Vdi_bi_Tempt_GND+T2_Vdi_bi_Tempt_GND)+T3_Vdi_bi_Tempt_GND))+((+(+(T0b_Vdi_bi_Tempt_GND/T4-(T0b_Vdi_bi*T4_Tempt_GND+T0b_Tempt_GND*T4_Vdi_bi+T0b*T4_Vdi_bi_Tempt_GND)/T4/T4+2*T0b*T4_Vdi_bi*T4_Tempt_GND/T4/T4/T4)*DelClm+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Tempt_GND+((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm_Vdi_bi+(T0b/T4)*DelClm_Vdi_bi_Tempt_GND)*T0c+((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*T0c_Vdi_bi+((T0b/T4)*DelClm)*T0c_Vdi_bi_Tempt_GND)/T0d-(((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi))*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*T0c)+(((T0b/T4)*DelClm)*T0c_Tempt_GND)))*T0d_Vdi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi_Tempt_GND)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_Vdi_bi_Vgi_bi=(+(+(T0a_Vdi_bi_Vgi_bi/T0-(T0a_Vdi_bi*T0_Vgi_bi+T0a_Vgi_bi*T0_Vdi_bi+T0a*T0_Vdi_bi_Vgi_bi)/T0/T0+2*T0a*T0_Vdi_bi*T0_Vgi_bi/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+(T0a/T0)*(+(+T1_Vdi_bi_Vgi_bi+T2_Vdi_bi_Vgi_bi)+T3_Vdi_bi_Vgi_bi))+((+(+(T0b_Vdi_bi_Vgi_bi/T4-(T0b_Vdi_bi*T4_Vgi_bi+T0b_Vgi_bi*T4_Vdi_bi+T0b*T4_Vdi_bi_Vgi_bi)/T4/T4+2*T0b*T4_Vdi_bi*T4_Vgi_bi/T4/T4/T4)*DelClm+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vgi_bi+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vdi_bi+(T0b/T4)*DelClm_Vdi_bi_Vgi_bi)*T0c+((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*T0c_Vdi_bi+((T0b/T4)*DelClm)*T0c_Vdi_bi_Vgi_bi)/T0d-(((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi))*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi)))*T0d_Vdi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi_Vgi_bi)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_Vdi_bi_Vdi_bi=(+(+(T0a_Vdi_bi_Vdi_bi/T0-(T0a_Vdi_bi*T0_Vdi_bi+T0a_Vdi_bi*T0_Vdi_bi+T0a*T0_Vdi_bi_Vdi_bi)/T0/T0+2*T0a*T0_Vdi_bi*T0_Vdi_bi/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+(T0a/T0)*(+(+T1_Vdi_bi_Vdi_bi+T2_Vdi_bi_Vdi_bi)+T3_Vdi_bi_Vdi_bi))+((+(+(T0b_Vdi_bi_Vdi_bi/T4-(T0b_Vdi_bi*T4_Vdi_bi+T0b_Vdi_bi*T4_Vdi_bi+T0b*T4_Vdi_bi_Vdi_bi)/T4/T4+2*T0b*T4_Vdi_bi*T4_Vdi_bi/T4/T4/T4)*DelClm+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vdi_bi+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vdi_bi+(T0b/T4)*DelClm_Vdi_bi_Vdi_bi)*T0c+((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*T0c_Vdi_bi+((T0b/T4)*DelClm)*T0c_Vdi_bi_Vdi_bi)/T0d-(((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi))*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi)))*T0d_Vdi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi_Vdi_bi)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_Vdi_bi_Vsi_bi=(+(+(T0a_Vdi_bi_Vsi_bi/T0-(T0a_Vdi_bi*T0_Vsi_bi+T0a_Vsi_bi*T0_Vdi_bi+T0a*T0_Vdi_bi_Vsi_bi)/T0/T0+2*T0a*T0_Vdi_bi*T0_Vsi_bi/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+(T0a/T0)*(+(+T1_Vdi_bi_Vsi_bi+T2_Vdi_bi_Vsi_bi)+T3_Vdi_bi_Vsi_bi))+((+(+(T0b_Vdi_bi_Vsi_bi/T4-(T0b_Vdi_bi*T4_Vsi_bi+T0b_Vsi_bi*T4_Vdi_bi+T0b*T4_Vdi_bi_Vsi_bi)/T4/T4+2*T0b*T4_Vdi_bi*T4_Vsi_bi/T4/T4/T4)*DelClm+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vsi_bi+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vdi_bi+(T0b/T4)*DelClm_Vdi_bi_Vsi_bi)*T0c+((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*T0c_Vdi_bi+((T0b/T4)*DelClm)*T0c_Vdi_bi_Vsi_bi)/T0d-(((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi))*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi)))*T0d_Vdi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi_Vsi_bi)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_Vdi_bi_Vdbulk_di=(+(+(0.0/T0-(T0a_Vdi_bi*T0_Vdbulk_di+0.0*T0_Vdi_bi+T0a*T0_Vdi_bi_Vdbulk_di)/T0/T0+2*T0a*T0_Vdi_bi*T0_Vdbulk_di/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+(T0a/T0)*(+(+T1_Vdi_bi_Vdbulk_di+T2_Vdi_bi_Vdbulk_di)+T3_Vdi_bi_Vdbulk_di))+((+(+(0.0/T4-(T0b_Vdi_bi*T4_Vdbulk_di+0.0*T4_Vdi_bi+T0b*T4_Vdi_bi_Vdbulk_di)/T4/T4+2*T0b*T4_Vdi_bi*T4_Vdbulk_di/T4/T4/T4)*DelClm+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vdbulk_di+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vdi_bi+(T0b/T4)*DelClm_Vdi_bi_Vdbulk_di)*T0c+((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*0.0+((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*T0c_Vdi_bi+((T0b/T4)*DelClm)*0.0)/T0d-(((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi))*0.0+(((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*T0c)*T0d_Vdi_bi+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi*0.0/T0d/T0d/T0d));
  Ssi_Vdi_bi_Vsbulk_si=(+(+(0.0/T0-(T0a_Vdi_bi*T0_Vsbulk_si+0.0*T0_Vdi_bi+T0a*T0_Vdi_bi_Vsbulk_si)/T0/T0+2*T0a*T0_Vdi_bi*T0_Vsbulk_si/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+(T0a/T0)*(+(+T1_Vdi_bi_Vsbulk_si+T2_Vdi_bi_Vsbulk_si)+T3_Vdi_bi_Vsbulk_si))+((+(+(0.0/T4-(T0b_Vdi_bi*T4_Vsbulk_si+0.0*T4_Vdi_bi+T0b*T4_Vdi_bi_Vsbulk_si)/T4/T4+2*T0b*T4_Vdi_bi*T4_Vsbulk_si/T4/T4/T4)*DelClm+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vsbulk_si+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vdi_bi+(T0b/T4)*DelClm_Vdi_bi_Vsbulk_si)*T0c+((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*0.0+((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*T0c_Vdi_bi+((T0b/T4)*DelClm)*0.0)/T0d-(((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi))*0.0+(((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*T0c)*T0d_Vdi_bi+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vdi_bi*0.0/T0d/T0d/T0d));
#endif
Ssi_Vsi_bi=(((((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1+T2)+T3))+((T0a/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)))+((((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi))*T0d-(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi)/T0d/T0d));
#if defined(_DERIVATE2)
  Ssi_Vsi_bi_Tempt_GND=(+(+(T0a_Vsi_bi_Tempt_GND/T0-(T0a_Vsi_bi*T0_Tempt_GND+T0a_Tempt_GND*T0_Vsi_bi+T0a*T0_Vsi_bi_Tempt_GND)/T0/T0+2*T0a*T0_Vsi_bi*T0_Tempt_GND/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Tempt_GND+T2_Tempt_GND)+T3_Tempt_GND)+((T0a_Tempt_GND*T0-T0a*T0_Tempt_GND)/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+(T0a/T0)*(+(+T1_Vsi_bi_Tempt_GND+T2_Vsi_bi_Tempt_GND)+T3_Vsi_bi_Tempt_GND))+((+(+(T0b_Vsi_bi_Tempt_GND/T4-(T0b_Vsi_bi*T4_Tempt_GND+T0b_Tempt_GND*T4_Vsi_bi+T0b*T4_Vsi_bi_Tempt_GND)/T4/T4+2*T0b*T4_Vsi_bi*T4_Tempt_GND/T4/T4/T4)*DelClm+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Tempt_GND+((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm_Vsi_bi+(T0b/T4)*DelClm_Vsi_bi_Tempt_GND)*T0c+((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*T0c_Vsi_bi+((T0b/T4)*DelClm)*T0c_Vsi_bi_Tempt_GND)/T0d-(((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi))*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*T0c)+(((T0b/T4)*DelClm)*T0c_Tempt_GND)))*T0d_Vsi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi_Tempt_GND)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_Vsi_bi_Vgi_bi=(+(+(T0a_Vsi_bi_Vgi_bi/T0-(T0a_Vsi_bi*T0_Vgi_bi+T0a_Vgi_bi*T0_Vsi_bi+T0a*T0_Vsi_bi_Vgi_bi)/T0/T0+2*T0a*T0_Vsi_bi*T0_Vgi_bi/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+(T0a/T0)*(+(+T1_Vsi_bi_Vgi_bi+T2_Vsi_bi_Vgi_bi)+T3_Vsi_bi_Vgi_bi))+((+(+(T0b_Vsi_bi_Vgi_bi/T4-(T0b_Vsi_bi*T4_Vgi_bi+T0b_Vgi_bi*T4_Vsi_bi+T0b*T4_Vsi_bi_Vgi_bi)/T4/T4+2*T0b*T4_Vsi_bi*T4_Vgi_bi/T4/T4/T4)*DelClm+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vgi_bi+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vsi_bi+(T0b/T4)*DelClm_Vsi_bi_Vgi_bi)*T0c+((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*T0c_Vsi_bi+((T0b/T4)*DelClm)*T0c_Vsi_bi_Vgi_bi)/T0d-(((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi))*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi)))*T0d_Vsi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi_Vgi_bi)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_Vsi_bi_Vdi_bi=(+(+(T0a_Vsi_bi_Vdi_bi/T0-(T0a_Vsi_bi*T0_Vdi_bi+T0a_Vdi_bi*T0_Vsi_bi+T0a*T0_Vsi_bi_Vdi_bi)/T0/T0+2*T0a*T0_Vsi_bi*T0_Vdi_bi/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+(T0a/T0)*(+(+T1_Vsi_bi_Vdi_bi+T2_Vsi_bi_Vdi_bi)+T3_Vsi_bi_Vdi_bi))+((+(+(T0b_Vsi_bi_Vdi_bi/T4-(T0b_Vsi_bi*T4_Vdi_bi+T0b_Vdi_bi*T4_Vsi_bi+T0b*T4_Vsi_bi_Vdi_bi)/T4/T4+2*T0b*T4_Vsi_bi*T4_Vdi_bi/T4/T4/T4)*DelClm+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vdi_bi+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vsi_bi+(T0b/T4)*DelClm_Vsi_bi_Vdi_bi)*T0c+((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*T0c_Vsi_bi+((T0b/T4)*DelClm)*T0c_Vsi_bi_Vdi_bi)/T0d-(((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi))*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi)))*T0d_Vsi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi_Vdi_bi)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_Vsi_bi_Vsi_bi=(+(+(T0a_Vsi_bi_Vsi_bi/T0-(T0a_Vsi_bi*T0_Vsi_bi+T0a_Vsi_bi*T0_Vsi_bi+T0a*T0_Vsi_bi_Vsi_bi)/T0/T0+2*T0a*T0_Vsi_bi*T0_Vsi_bi/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+(T0a/T0)*(+(+T1_Vsi_bi_Vsi_bi+T2_Vsi_bi_Vsi_bi)+T3_Vsi_bi_Vsi_bi))+((+(+(T0b_Vsi_bi_Vsi_bi/T4-(T0b_Vsi_bi*T4_Vsi_bi+T0b_Vsi_bi*T4_Vsi_bi+T0b*T4_Vsi_bi_Vsi_bi)/T4/T4+2*T0b*T4_Vsi_bi*T4_Vsi_bi/T4/T4/T4)*DelClm+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vsi_bi+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vsi_bi+(T0b/T4)*DelClm_Vsi_bi_Vsi_bi)*T0c+((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*T0c_Vsi_bi+((T0b/T4)*DelClm)*T0c_Vsi_bi_Vsi_bi)/T0d-(((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi))*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi)))*T0d_Vsi_bi+(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi_Vsi_bi)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_Vsi_bi_Vdbulk_di=(+(+(0.0/T0-(T0a_Vsi_bi*T0_Vdbulk_di+0.0*T0_Vsi_bi+T0a*T0_Vsi_bi_Vdbulk_di)/T0/T0+2*T0a*T0_Vsi_bi*T0_Vdbulk_di/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+(T0a/T0)*(+(+T1_Vsi_bi_Vdbulk_di+T2_Vsi_bi_Vdbulk_di)+T3_Vsi_bi_Vdbulk_di))+((+(+(0.0/T4-(T0b_Vsi_bi*T4_Vdbulk_di+0.0*T4_Vsi_bi+T0b*T4_Vsi_bi_Vdbulk_di)/T4/T4+2*T0b*T4_Vsi_bi*T4_Vdbulk_di/T4/T4/T4)*DelClm+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vdbulk_di+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vsi_bi+(T0b/T4)*DelClm_Vsi_bi_Vdbulk_di)*T0c+((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*0.0+((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*T0c_Vsi_bi+((T0b/T4)*DelClm)*0.0)/T0d-(((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi))*0.0+(((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*T0c)*T0d_Vsi_bi+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi*0.0/T0d/T0d/T0d));
  Ssi_Vsi_bi_Vsbulk_si=(+(+(0.0/T0-(T0a_Vsi_bi*T0_Vsbulk_si+0.0*T0_Vsi_bi+T0a*T0_Vsi_bi_Vsbulk_si)/T0/T0+2*T0a*T0_Vsi_bi*T0_Vsbulk_si/T0/T0/T0)*((T1+T2)+T3)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+(T0a/T0)*(+(+T1_Vsi_bi_Vsbulk_si+T2_Vsi_bi_Vsbulk_si)+T3_Vsi_bi_Vsbulk_si))+((+(+(0.0/T4-(T0b_Vsi_bi*T4_Vsbulk_si+0.0*T4_Vsi_bi+T0b*T4_Vsi_bi_Vsbulk_si)/T4/T4+2*T0b*T4_Vsi_bi*T4_Vsbulk_si/T4/T4/T4)*DelClm+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vsbulk_si+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vsi_bi+(T0b/T4)*DelClm_Vsi_bi_Vsbulk_si)*T0c+((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*0.0+((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*T0c_Vsi_bi+((T0b/T4)*DelClm)*0.0)/T0d-(((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi))*0.0+(((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*T0c)*T0d_Vsi_bi+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*T0d_Vsi_bi*0.0/T0d/T0d/T0d));
#endif
Ssi_Vdbulk_di=((((-T0a*T0_Vdbulk_di/T0/T0)*((T1+T2)+T3))+((T0a/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)))+((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c/T0d));
#if defined(_DERIVATE2)
  Ssi_Vdbulk_di_Tempt_GND=(+(+(0.0/T0-(0.0*T0_Tempt_GND+T0a_Tempt_GND*T0_Vdbulk_di+T0a*T0_Vdbulk_di_Tempt_GND)/T0/T0+2*T0a*T0_Vdbulk_di*T0_Tempt_GND/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Tempt_GND+T2_Tempt_GND)+T3_Tempt_GND)+((T0a_Tempt_GND*T0-T0a*T0_Tempt_GND)/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(T0a/T0)*(+(+T1_Vdbulk_di_Tempt_GND+T2_Vdbulk_di_Tempt_GND)+T3_Vdbulk_di_Tempt_GND))+((+(+(0.0/T4-(0.0*T4_Tempt_GND+T0b_Tempt_GND*T4_Vdbulk_di+T0b*T4_Vdbulk_di_Tempt_GND)/T4/T4+2*T0b*T4_Vdbulk_di*T4_Tempt_GND/T4/T4/T4)*DelClm+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Tempt_GND+((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm_Vdbulk_di+(T0b/T4)*DelClm_Vdbulk_di_Tempt_GND)*T0c+(((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*T0c)+(((T0b/T4)*DelClm)*T0c_Tempt_GND)))*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_Vdbulk_di_Vgi_bi=(+(+(0.0/T0-(0.0*T0_Vgi_bi+T0a_Vgi_bi*T0_Vdbulk_di+T0a*T0_Vdbulk_di_Vgi_bi)/T0/T0+2*T0a*T0_Vdbulk_di*T0_Vgi_bi/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(T0a/T0)*(+(+T1_Vdbulk_di_Vgi_bi+T2_Vdbulk_di_Vgi_bi)+T3_Vdbulk_di_Vgi_bi))+((+(+(0.0/T4-(0.0*T4_Vgi_bi+T0b_Vgi_bi*T4_Vdbulk_di+T0b*T4_Vdbulk_di_Vgi_bi)/T4/T4+2*T0b*T4_Vdbulk_di*T4_Vgi_bi/T4/T4/T4)*DelClm+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vgi_bi+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vdbulk_di+(T0b/T4)*DelClm_Vdbulk_di_Vgi_bi)*T0c+(((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi)))*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_Vdbulk_di_Vdi_bi=(+(+(0.0/T0-(0.0*T0_Vdi_bi+T0a_Vdi_bi*T0_Vdbulk_di+T0a*T0_Vdbulk_di_Vdi_bi)/T0/T0+2*T0a*T0_Vdbulk_di*T0_Vdi_bi/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(T0a/T0)*(+(+T1_Vdbulk_di_Vdi_bi+T2_Vdbulk_di_Vdi_bi)+T3_Vdbulk_di_Vdi_bi))+((+(+(0.0/T4-(0.0*T4_Vdi_bi+T0b_Vdi_bi*T4_Vdbulk_di+T0b*T4_Vdbulk_di_Vdi_bi)/T4/T4+2*T0b*T4_Vdbulk_di*T4_Vdi_bi/T4/T4/T4)*DelClm+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vdi_bi+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vdbulk_di+(T0b/T4)*DelClm_Vdbulk_di_Vdi_bi)*T0c+(((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi)))*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_Vdbulk_di_Vsi_bi=(+(+(0.0/T0-(0.0*T0_Vsi_bi+T0a_Vsi_bi*T0_Vdbulk_di+T0a*T0_Vdbulk_di_Vsi_bi)/T0/T0+2*T0a*T0_Vdbulk_di*T0_Vsi_bi/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(T0a/T0)*(+(+T1_Vdbulk_di_Vsi_bi+T2_Vdbulk_di_Vsi_bi)+T3_Vdbulk_di_Vsi_bi))+((+(+(0.0/T4-(0.0*T4_Vsi_bi+T0b_Vsi_bi*T4_Vdbulk_di+T0b*T4_Vdbulk_di_Vsi_bi)/T4/T4+2*T0b*T4_Vdbulk_di*T4_Vsi_bi/T4/T4/T4)*DelClm+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vsi_bi+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vdbulk_di+(T0b/T4)*DelClm_Vdbulk_di_Vsi_bi)*T0c+(((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi)))*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_Vdbulk_di_Vdbulk_di=(+(+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+T0a*T0_Vdbulk_di_Vdbulk_di)/T0/T0+2*T0a*T0_Vdbulk_di*T0_Vdbulk_di/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(T0a/T0)*(+(+T1_Vdbulk_di_Vdbulk_di+T2_Vdbulk_di_Vdbulk_di)+T3_Vdbulk_di_Vdbulk_di))+((+(+(0.0/T4-(0.0*T4_Vdbulk_di+0.0*T4_Vdbulk_di+T0b*T4_Vdbulk_di_Vdbulk_di)/T4/T4+2*T0b*T4_Vdbulk_di*T4_Vdbulk_di/T4/T4/T4)*DelClm+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vdbulk_di+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vdbulk_di+(T0b/T4)*DelClm_Vdbulk_di_Vdbulk_di)*T0c+(((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*0.0+((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c*0.0+(((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*T0c)*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*0.0/T0d/T0d/T0d));
  Ssi_Vdbulk_di_Vsbulk_si=(+(+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+T0a*T0_Vdbulk_di_Vsbulk_si)/T0/T0+2*T0a*T0_Vdbulk_di*T0_Vsbulk_si/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(T0a/T0)*(+(+T1_Vdbulk_di_Vsbulk_si+T2_Vdbulk_di_Vsbulk_si)+T3_Vdbulk_di_Vsbulk_si))+((+(+(0.0/T4-(0.0*T4_Vsbulk_si+0.0*T4_Vdbulk_di+T0b*T4_Vdbulk_di_Vsbulk_si)/T4/T4+2*T0b*T4_Vdbulk_di*T4_Vsbulk_si/T4/T4/T4)*DelClm+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vsbulk_si+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vdbulk_di+(T0b/T4)*DelClm_Vdbulk_di_Vsbulk_si)*T0c+(((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*0.0+((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di))*T0c*0.0+(((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*T0c)*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*0.0/T0d/T0d/T0d));
#endif
Ssi_Vsbulk_si=((((-T0a*T0_Vsbulk_si/T0/T0)*((T1+T2)+T3))+((T0a/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)))+((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c/T0d));
#if defined(_DERIVATE2)
  Ssi_Vsbulk_si_Tempt_GND=(+(+(0.0/T0-(0.0*T0_Tempt_GND+T0a_Tempt_GND*T0_Vsbulk_si+T0a*T0_Vsbulk_si_Tempt_GND)/T0/T0+2*T0a*T0_Vsbulk_si*T0_Tempt_GND/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Tempt_GND+T2_Tempt_GND)+T3_Tempt_GND)+((T0a_Tempt_GND*T0-T0a*T0_Tempt_GND)/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(T0a/T0)*(+(+T1_Vsbulk_si_Tempt_GND+T2_Vsbulk_si_Tempt_GND)+T3_Vsbulk_si_Tempt_GND))+((+(+(0.0/T4-(0.0*T4_Tempt_GND+T0b_Tempt_GND*T4_Vsbulk_si+T0b*T4_Vsbulk_si_Tempt_GND)/T4/T4+2*T0b*T4_Vsbulk_si*T4_Tempt_GND/T4/T4/T4)*DelClm+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Tempt_GND+((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm_Vsbulk_si+(T0b/T4)*DelClm_Vsbulk_si_Tempt_GND)*T0c+(((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c_Tempt_GND+(((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c*T0d_Tempt_GND+((((((((T0b_Tempt_GND*T4-T0b*T4_Tempt_GND)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Tempt_GND)))*T0c)+(((T0b/T4)*DelClm)*T0c_Tempt_GND)))*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*T0d_Tempt_GND/T0d/T0d/T0d));
  Ssi_Vsbulk_si_Vgi_bi=(+(+(0.0/T0-(0.0*T0_Vgi_bi+T0a_Vgi_bi*T0_Vsbulk_si+T0a*T0_Vsbulk_si_Vgi_bi)/T0/T0+2*T0a*T0_Vsbulk_si*T0_Vgi_bi/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vgi_bi+T2_Vgi_bi)+T3_Vgi_bi)+((T0a_Vgi_bi*T0-T0a*T0_Vgi_bi)/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(T0a/T0)*(+(+T1_Vsbulk_si_Vgi_bi+T2_Vsbulk_si_Vgi_bi)+T3_Vsbulk_si_Vgi_bi))+((+(+(0.0/T4-(0.0*T4_Vgi_bi+T0b_Vgi_bi*T4_Vsbulk_si+T0b*T4_Vsbulk_si_Vgi_bi)/T4/T4+2*T0b*T4_Vsbulk_si*T4_Vgi_bi/T4/T4/T4)*DelClm+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vgi_bi+((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm_Vsbulk_si+(T0b/T4)*DelClm_Vsbulk_si_Vgi_bi)*T0c+(((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c_Vgi_bi+(((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c*T0d_Vgi_bi+((((((((T0b_Vgi_bi*T4-T0b*T4_Vgi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vgi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vgi_bi)))*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*T0d_Vgi_bi/T0d/T0d/T0d));
  Ssi_Vsbulk_si_Vdi_bi=(+(+(0.0/T0-(0.0*T0_Vdi_bi+T0a_Vdi_bi*T0_Vsbulk_si+T0a*T0_Vsbulk_si_Vdi_bi)/T0/T0+2*T0a*T0_Vsbulk_si*T0_Vdi_bi/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vdi_bi+T2_Vdi_bi)+T3_Vdi_bi)+((T0a_Vdi_bi*T0-T0a*T0_Vdi_bi)/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(T0a/T0)*(+(+T1_Vsbulk_si_Vdi_bi+T2_Vsbulk_si_Vdi_bi)+T3_Vsbulk_si_Vdi_bi))+((+(+(0.0/T4-(0.0*T4_Vdi_bi+T0b_Vdi_bi*T4_Vsbulk_si+T0b*T4_Vsbulk_si_Vdi_bi)/T4/T4+2*T0b*T4_Vsbulk_si*T4_Vdi_bi/T4/T4/T4)*DelClm+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vdi_bi+((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm_Vsbulk_si+(T0b/T4)*DelClm_Vsbulk_si_Vdi_bi)*T0c+(((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c_Vdi_bi+(((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c*T0d_Vdi_bi+((((((((T0b_Vdi_bi*T4-T0b*T4_Vdi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vdi_bi)))*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*T0d_Vdi_bi/T0d/T0d/T0d));
  Ssi_Vsbulk_si_Vsi_bi=(+(+(0.0/T0-(0.0*T0_Vsi_bi+T0a_Vsi_bi*T0_Vsbulk_si+T0a*T0_Vsbulk_si_Vsi_bi)/T0/T0+2*T0a*T0_Vsbulk_si*T0_Vsi_bi/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vsi_bi+T2_Vsi_bi)+T3_Vsi_bi)+((T0a_Vsi_bi*T0-T0a*T0_Vsi_bi)/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(T0a/T0)*(+(+T1_Vsbulk_si_Vsi_bi+T2_Vsbulk_si_Vsi_bi)+T3_Vsbulk_si_Vsi_bi))+((+(+(0.0/T4-(0.0*T4_Vsi_bi+T0b_Vsi_bi*T4_Vsbulk_si+T0b*T4_Vsbulk_si_Vsi_bi)/T4/T4+2*T0b*T4_Vsbulk_si*T4_Vsi_bi/T4/T4/T4)*DelClm+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vsi_bi+((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm_Vsbulk_si+(T0b/T4)*DelClm_Vsbulk_si_Vsi_bi)*T0c+(((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c_Vsi_bi+(((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c*T0d_Vsi_bi+((((((((T0b_Vsi_bi*T4-T0b*T4_Vsi_bi)/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsi_bi)))*T0c)+(((T0b/T4)*DelClm)*T0c_Vsi_bi)))*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*T0d_Vsi_bi/T0d/T0d/T0d));
  Ssi_Vsbulk_si_Vdbulk_di=(+(+(0.0/T0-(0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+T0a*T0_Vsbulk_si_Vdbulk_di)/T0/T0+2*T0a*T0_Vsbulk_si*T0_Vdbulk_di/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vdbulk_di+T2_Vdbulk_di)+T3_Vdbulk_di)+(-T0a*T0_Vdbulk_di/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(T0a/T0)*(+(+T1_Vsbulk_si_Vdbulk_di+T2_Vsbulk_si_Vdbulk_di)+T3_Vsbulk_si_Vdbulk_di))+((+(+(0.0/T4-(0.0*T4_Vdbulk_di+0.0*T4_Vsbulk_si+T0b*T4_Vsbulk_si_Vdbulk_di)/T4/T4+2*T0b*T4_Vsbulk_si*T4_Vdbulk_di/T4/T4/T4)*DelClm+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vdbulk_di+(-T0b*T4_Vdbulk_di/T4/T4)*DelClm_Vsbulk_si+(T0b/T4)*DelClm_Vsbulk_si_Vdbulk_di)*T0c+(((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*0.0+((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c*0.0+(((((-T0b*T4_Vdbulk_di/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vdbulk_di)))*T0c)*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*0.0/T0d/T0d/T0d));
  Ssi_Vsbulk_si_Vsbulk_si=(+(+(0.0/T0-(0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+T0a*T0_Vsbulk_si_Vsbulk_si)/T0/T0+2*T0a*T0_Vsbulk_si*T0_Vsbulk_si/T0/T0/T0)*((T1+T2)+T3)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(-T0a*T0_Vsbulk_si/T0/T0)*((T1_Vsbulk_si+T2_Vsbulk_si)+T3_Vsbulk_si)+(T0a/T0)*(+(+T1_Vsbulk_si_Vsbulk_si+T2_Vsbulk_si_Vsbulk_si)+T3_Vsbulk_si_Vsbulk_si))+((+(+(0.0/T4-(0.0*T4_Vsbulk_si+0.0*T4_Vsbulk_si+T0b*T4_Vsbulk_si_Vsbulk_si)/T4/T4+2*T0b*T4_Vsbulk_si*T4_Vsbulk_si/T4/T4/T4)*DelClm+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vsbulk_si+(-T0b*T4_Vsbulk_si/T4/T4)*DelClm_Vsbulk_si+(T0b/T4)*DelClm_Vsbulk_si_Vsbulk_si)*T0c+(((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*0.0+((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*0.0+((T0b/T4)*DelClm)*0.0)/T0d-((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si))*T0c*0.0+(((((-T0b*T4_Vsbulk_si/T4/T4)*DelClm)+((T0b/T4)*DelClm_Vsbulk_si)))*T0c)*0.0+(((T0b/T4)*DelClm)*T0c)*0.0)/T0d/T0d+2*(((T0b/T4)*DelClm)*T0c)*0.0*0.0/T0d/T0d/T0d));
#endif
#endif
Ssi=(((T0a/T0)*((T1+T2)+T3))+((((T0b/T4)*DelClm)*T0c)/T0d));
EXIT_IF_ISNAN((((T0a/T0)*((T1+T2)+T3))+((((T0b/T4)*DelClm)*T0c)/T0d)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=((((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*Nstar)+(((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vdi_bi_Vgm_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vdi_bi_Vdbulk_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vdi_bi_Vsbulk_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vdi_bi_Vdi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_bi+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi_Vdi_bi)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*Nstar_Vdi_bi+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)))*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi_Vdi_bi);
  T5_Vdi_bi_Vsi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vsi_bi+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi_Vsi_bi)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*Nstar_Vsi_bi+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)))*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi_Vsi_bi);
  T5_Vdi_bi_Tempt_GND=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi_Tempt_GND)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Vdi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_bi_Tempt_GND);
#endif
T5_Vsi_bi=((((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*Nstar)+(((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vsi_bi_Vgm_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vsi_bi_Vdbulk_di=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vsi_bi_Vsbulk_si=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*0.0+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*0.0)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*0.0+((((0.0)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*0.0);
  T5_Vsi_bi_Vdi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_bi+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi_Vdi_bi)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*Nstar_Vdi_bi+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vdi_bi)))*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi_Vdi_bi);
  T5_Vsi_bi_Vsi_bi=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vsi_bi+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi_Vsi_bi)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*Nstar_Vsi_bi+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)))*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi_Vsi_bi);
  T5_Vsi_bi_Tempt_GND=(+(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+Weff*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff*pInst->NF)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff*pInst->NF)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vsi_bi+(((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi_Tempt_GND)*Nstar+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Vsi_bi)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Vsi_bi+((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)*Nstar)+(((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar_Tempt_GND));
#endif
#endif
T5=(((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar);
EXIT_IF_ISNAN((((((Weff*pInst->NF)*Leffnoi)*1.0e10)*Nstar)*Nstar))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
Swi_Tempt_GND=((((((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids)+((T0e/T5)*ids_Tempt_GND))*ids)+(((T0e/T5)*ids)*ids_Tempt_GND));
#endif
Swi_Vdbulk_di=(((((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di))*ids)+(((T0e/T5)*ids)*ids_Vdbulk_di));
#if defined(_DERIVATE2)
  Swi_Vdbulk_di_Tempt_GND=(+(+(0.0/T5-(0.0*T5_Tempt_GND+T0e_Tempt_GND*T5_Vdbulk_di+T0e*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T0e*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5)*ids+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Tempt_GND+((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids_Vdbulk_di+(T0e/T5)*ids_Vdbulk_di_Tempt_GND)*ids+(((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di))*ids_Tempt_GND+(((((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids)+((T0e/T5)*ids_Tempt_GND)))*ids_Vdbulk_di+((T0e/T5)*ids)*ids_Vdbulk_di_Tempt_GND);
  Swi_Vdbulk_di_Vdbulk_di=(+(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vdbulk_di+T0e*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T0e*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5)*ids+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vdbulk_di+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vdbulk_di+(T0e/T5)*ids_Vdbulk_di_Vdbulk_di)*ids+(((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di))*ids_Vdbulk_di+((((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di)))*ids_Vdbulk_di+((T0e/T5)*ids)*ids_Vdbulk_di_Vdbulk_di);
  Swi_Vdbulk_di_Vsbulk_si=(+(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vdbulk_di+T0e*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T0e*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5)*ids+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vsbulk_si+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vdbulk_di+(T0e/T5)*ids_Vdbulk_di_Vsbulk_si)*ids+(((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di))*ids_Vsbulk_si+((((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si)))*ids_Vdbulk_di+((T0e/T5)*ids)*ids_Vdbulk_di_Vsbulk_si);
  Swi_Vdbulk_di_Vgi_bi=(+(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vdbulk_di+T0e*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T0e*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5)*ids+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vgi_bi+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vdbulk_di+(T0e/T5)*ids_Vdbulk_di_Vgi_bi)*ids+(((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di))*ids_Vgi_bi+((((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi)))*ids_Vdbulk_di+((T0e/T5)*ids)*ids_Vdbulk_di_Vgi_bi);
  Swi_Vdbulk_di_Vdi_bi=(+(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vdbulk_di+T0e*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T0e*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5)*ids+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vdi_bi+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vdbulk_di+(T0e/T5)*ids_Vdbulk_di_Vdi_bi)*ids+(((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di))*ids_Vdi_bi+((((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi)))*ids_Vdbulk_di+((T0e/T5)*ids)*ids_Vdbulk_di_Vdi_bi);
  Swi_Vdbulk_di_Vsi_bi=(+(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vdbulk_di+T0e*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T0e*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5)*ids+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vsi_bi+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vdbulk_di+(T0e/T5)*ids_Vdbulk_di_Vsi_bi)*ids+(((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di))*ids_Vsi_bi+((((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi)))*ids_Vdbulk_di+((T0e/T5)*ids)*ids_Vdbulk_di_Vsi_bi);
#endif
Swi_Vsbulk_si=(((((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si))*ids)+(((T0e/T5)*ids)*ids_Vsbulk_si));
#if defined(_DERIVATE2)
  Swi_Vsbulk_si_Tempt_GND=(+(+(0.0/T5-(0.0*T5_Tempt_GND+T0e_Tempt_GND*T5_Vsbulk_si+T0e*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T0e*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5)*ids+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Tempt_GND+((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids_Vsbulk_si+(T0e/T5)*ids_Vsbulk_si_Tempt_GND)*ids+(((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si))*ids_Tempt_GND+(((((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids)+((T0e/T5)*ids_Tempt_GND)))*ids_Vsbulk_si+((T0e/T5)*ids)*ids_Vsbulk_si_Tempt_GND);
  Swi_Vsbulk_si_Vdbulk_di=(+(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vsbulk_si+T0e*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T0e*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5)*ids+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vdbulk_di+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vsbulk_si+(T0e/T5)*ids_Vsbulk_si_Vdbulk_di)*ids+(((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si))*ids_Vdbulk_di+((((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di)))*ids_Vsbulk_si+((T0e/T5)*ids)*ids_Vsbulk_si_Vdbulk_di);
  Swi_Vsbulk_si_Vsbulk_si=(+(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vsbulk_si+T0e*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T0e*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5)*ids+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vsbulk_si+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vsbulk_si+(T0e/T5)*ids_Vsbulk_si_Vsbulk_si)*ids+(((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si))*ids_Vsbulk_si+((((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si)))*ids_Vsbulk_si+((T0e/T5)*ids)*ids_Vsbulk_si_Vsbulk_si);
  Swi_Vsbulk_si_Vgi_bi=(+(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vsbulk_si+T0e*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T0e*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5)*ids+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vgi_bi+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vsbulk_si+(T0e/T5)*ids_Vsbulk_si_Vgi_bi)*ids+(((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si))*ids_Vgi_bi+((((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi)))*ids_Vsbulk_si+((T0e/T5)*ids)*ids_Vsbulk_si_Vgi_bi);
  Swi_Vsbulk_si_Vdi_bi=(+(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vsbulk_si+T0e*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T0e*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5)*ids+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vdi_bi+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vsbulk_si+(T0e/T5)*ids_Vsbulk_si_Vdi_bi)*ids+(((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si))*ids_Vdi_bi+((((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi)))*ids_Vsbulk_si+((T0e/T5)*ids)*ids_Vsbulk_si_Vdi_bi);
  Swi_Vsbulk_si_Vsi_bi=(+(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vsbulk_si+T0e*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T0e*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5)*ids+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vsi_bi+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vsbulk_si+(T0e/T5)*ids_Vsbulk_si_Vsi_bi)*ids+(((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si))*ids_Vsi_bi+((((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi)))*ids_Vsbulk_si+((T0e/T5)*ids)*ids_Vsbulk_si_Vsi_bi);
#endif
Swi_Vgi_bi=(((((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi))*ids)+(((T0e/T5)*ids)*ids_Vgi_bi));
#if defined(_DERIVATE2)
  Swi_Vgi_bi_Tempt_GND=(+(+(0.0/T5-(0.0*T5_Tempt_GND+T0e_Tempt_GND*T5_Vgi_bi+T0e*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T0e*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)*ids+(-T0e*T5_Vgi_bi/T5/T5)*ids_Tempt_GND+((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids_Vgi_bi+(T0e/T5)*ids_Vgi_bi_Tempt_GND)*ids+(((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi))*ids_Tempt_GND+(((((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids)+((T0e/T5)*ids_Tempt_GND)))*ids_Vgi_bi+((T0e/T5)*ids)*ids_Vgi_bi_Tempt_GND);
  Swi_Vgi_bi_Vdbulk_di=(+(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+T0e*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T0e*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)*ids+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vdbulk_di+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vgi_bi+(T0e/T5)*ids_Vgi_bi_Vdbulk_di)*ids+(((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi))*ids_Vdbulk_di+((((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di)))*ids_Vgi_bi+((T0e/T5)*ids)*ids_Vgi_bi_Vdbulk_di);
  Swi_Vgi_bi_Vsbulk_si=(+(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+T0e*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T0e*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)*ids+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vsbulk_si+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vgi_bi+(T0e/T5)*ids_Vgi_bi_Vsbulk_si)*ids+(((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi))*ids_Vsbulk_si+((((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si)))*ids_Vgi_bi+((T0e/T5)*ids)*ids_Vgi_bi_Vsbulk_si);
  Swi_Vgi_bi_Vgi_bi=(+(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+T0e*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T0e*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)*ids+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vgi_bi+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vgi_bi+(T0e/T5)*ids_Vgi_bi_Vgi_bi)*ids+(((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi))*ids_Vgi_bi+((((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi)))*ids_Vgi_bi+((T0e/T5)*ids)*ids_Vgi_bi_Vgi_bi);
  Swi_Vgi_bi_Vdi_bi=(+(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+T0e*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T0e*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)*ids+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vdi_bi+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vgi_bi+(T0e/T5)*ids_Vgi_bi_Vdi_bi)*ids+(((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi))*ids_Vdi_bi+((((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi)))*ids_Vgi_bi+((T0e/T5)*ids)*ids_Vgi_bi_Vdi_bi);
  Swi_Vgi_bi_Vsi_bi=(+(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+T0e*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T0e*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)*ids+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vsi_bi+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vgi_bi+(T0e/T5)*ids_Vgi_bi_Vsi_bi)*ids+(((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi))*ids_Vsi_bi+((((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi)))*ids_Vgi_bi+((T0e/T5)*ids)*ids_Vgi_bi_Vsi_bi);
#endif
Swi_Vdi_bi=(((((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi))*ids)+(((T0e/T5)*ids)*ids_Vdi_bi));
#if defined(_DERIVATE2)
  Swi_Vdi_bi_Tempt_GND=(+(+(0.0/T5-(0.0*T5_Tempt_GND+T0e_Tempt_GND*T5_Vdi_bi+T0e*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T0e*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)*ids+(-T0e*T5_Vdi_bi/T5/T5)*ids_Tempt_GND+((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids_Vdi_bi+(T0e/T5)*ids_Vdi_bi_Tempt_GND)*ids+(((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi))*ids_Tempt_GND+(((((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids)+((T0e/T5)*ids_Tempt_GND)))*ids_Vdi_bi+((T0e/T5)*ids)*ids_Vdi_bi_Tempt_GND);
  Swi_Vdi_bi_Vdbulk_di=(+(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+T0e*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T0e*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)*ids+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vdbulk_di+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vdi_bi+(T0e/T5)*ids_Vdi_bi_Vdbulk_di)*ids+(((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi))*ids_Vdbulk_di+((((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di)))*ids_Vdi_bi+((T0e/T5)*ids)*ids_Vdi_bi_Vdbulk_di);
  Swi_Vdi_bi_Vsbulk_si=(+(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+T0e*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T0e*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)*ids+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vsbulk_si+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vdi_bi+(T0e/T5)*ids_Vdi_bi_Vsbulk_si)*ids+(((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi))*ids_Vsbulk_si+((((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si)))*ids_Vdi_bi+((T0e/T5)*ids)*ids_Vdi_bi_Vsbulk_si);
  Swi_Vdi_bi_Vgi_bi=(+(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+T0e*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T0e*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)*ids+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vgi_bi+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vdi_bi+(T0e/T5)*ids_Vdi_bi_Vgi_bi)*ids+(((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi))*ids_Vgi_bi+((((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi)))*ids_Vdi_bi+((T0e/T5)*ids)*ids_Vdi_bi_Vgi_bi);
  Swi_Vdi_bi_Vdi_bi=(+(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+T0e*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T0e*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)*ids+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vdi_bi+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vdi_bi+(T0e/T5)*ids_Vdi_bi_Vdi_bi)*ids+(((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi))*ids_Vdi_bi+((((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi)))*ids_Vdi_bi+((T0e/T5)*ids)*ids_Vdi_bi_Vdi_bi);
  Swi_Vdi_bi_Vsi_bi=(+(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+T0e*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T0e*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)*ids+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vsi_bi+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vdi_bi+(T0e/T5)*ids_Vdi_bi_Vsi_bi)*ids+(((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi))*ids_Vsi_bi+((((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi)))*ids_Vdi_bi+((T0e/T5)*ids)*ids_Vdi_bi_Vsi_bi);
#endif
Swi_Vsi_bi=(((((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi))*ids)+(((T0e/T5)*ids)*ids_Vsi_bi));
#if defined(_DERIVATE2)
  Swi_Vsi_bi_Tempt_GND=(+(+(0.0/T5-(0.0*T5_Tempt_GND+T0e_Tempt_GND*T5_Vsi_bi+T0e*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T0e*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)*ids+(-T0e*T5_Vsi_bi/T5/T5)*ids_Tempt_GND+((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids_Vsi_bi+(T0e/T5)*ids_Vsi_bi_Tempt_GND)*ids+(((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi))*ids_Tempt_GND+(((((T0e_Tempt_GND*T5-T0e*T5_Tempt_GND)/T5/T5)*ids)+((T0e/T5)*ids_Tempt_GND)))*ids_Vsi_bi+((T0e/T5)*ids)*ids_Vsi_bi_Tempt_GND);
  Swi_Vsi_bi_Vdbulk_di=(+(+(0.0/T5-(0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+T0e*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T0e*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)*ids+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vdbulk_di+(-T0e*T5_Vdbulk_di/T5/T5)*ids_Vsi_bi+(T0e/T5)*ids_Vsi_bi_Vdbulk_di)*ids+(((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi))*ids_Vdbulk_di+((((-T0e*T5_Vdbulk_di/T5/T5)*ids)+((T0e/T5)*ids_Vdbulk_di)))*ids_Vsi_bi+((T0e/T5)*ids)*ids_Vsi_bi_Vdbulk_di);
  Swi_Vsi_bi_Vsbulk_si=(+(+(0.0/T5-(0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+T0e*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T0e*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)*ids+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vsbulk_si+(-T0e*T5_Vsbulk_si/T5/T5)*ids_Vsi_bi+(T0e/T5)*ids_Vsi_bi_Vsbulk_si)*ids+(((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi))*ids_Vsbulk_si+((((-T0e*T5_Vsbulk_si/T5/T5)*ids)+((T0e/T5)*ids_Vsbulk_si)))*ids_Vsi_bi+((T0e/T5)*ids)*ids_Vsi_bi_Vsbulk_si);
  Swi_Vsi_bi_Vgi_bi=(+(+(0.0/T5-(0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+T0e*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T0e*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)*ids+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vgi_bi+(-T0e*T5_Vgi_bi/T5/T5)*ids_Vsi_bi+(T0e/T5)*ids_Vsi_bi_Vgi_bi)*ids+(((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi))*ids_Vgi_bi+((((-T0e*T5_Vgi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vgi_bi)))*ids_Vsi_bi+((T0e/T5)*ids)*ids_Vsi_bi_Vgi_bi);
  Swi_Vsi_bi_Vdi_bi=(+(+(0.0/T5-(0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+T0e*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T0e*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)*ids+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vdi_bi+(-T0e*T5_Vdi_bi/T5/T5)*ids_Vsi_bi+(T0e/T5)*ids_Vsi_bi_Vdi_bi)*ids+(((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi))*ids_Vdi_bi+((((-T0e*T5_Vdi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vdi_bi)))*ids_Vsi_bi+((T0e/T5)*ids)*ids_Vsi_bi_Vdi_bi);
  Swi_Vsi_bi_Vsi_bi=(+(+(0.0/T5-(0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+T0e*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T0e*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)*ids+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vsi_bi+(-T0e*T5_Vsi_bi/T5/T5)*ids_Vsi_bi+(T0e/T5)*ids_Vsi_bi_Vsi_bi)*ids+(((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi))*ids_Vsi_bi+((((-T0e*T5_Vsi_bi/T5/T5)*ids)+((T0e/T5)*ids_Vsi_bi)))*ids_Vsi_bi+((T0e/T5)*ids)*ids_Vsi_bi_Vsi_bi);
#endif
#endif
Swi=(((T0e/T5)*ids)*ids);
EXIT_IF_ISNAN((((T0e/T5)*ids)*ids))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=(Swi_Vdbulk_di+Ssi_Vdbulk_di);
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+0.0+0.0);
  T6_Vdbulk_di_Vgm_si=(+0.0+0.0);
  T6_Vdbulk_di_Vdbulk_di=(+Swi_Vdbulk_di_Vdbulk_di+Ssi_Vdbulk_di_Vdbulk_di);
  T6_Vdbulk_di_Vsbulk_si=(+Swi_Vdbulk_di_Vsbulk_si+Ssi_Vdbulk_di_Vsbulk_si);
  T6_Vdbulk_di_Vgi_bi=(+Swi_Vdbulk_di_Vgi_bi+Ssi_Vdbulk_di_Vgi_bi);
  T6_Vdbulk_di_Vdi_bi=(+Swi_Vdbulk_di_Vdi_bi+Ssi_Vdbulk_di_Vdi_bi);
  T6_Vdbulk_di_Vsi_bi=(+Swi_Vdbulk_di_Vsi_bi+Ssi_Vdbulk_di_Vsi_bi);
  T6_Vdbulk_di_Tempt_GND=(+Swi_Vdbulk_di_Tempt_GND+Ssi_Vdbulk_di_Tempt_GND);
#endif
T6_Vsbulk_si=(Swi_Vsbulk_si+Ssi_Vsbulk_si);
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+0.0+0.0);
  T6_Vsbulk_si_Vgm_si=(+0.0+0.0);
  T6_Vsbulk_si_Vdbulk_di=(+Swi_Vsbulk_si_Vdbulk_di+Ssi_Vsbulk_si_Vdbulk_di);
  T6_Vsbulk_si_Vsbulk_si=(+Swi_Vsbulk_si_Vsbulk_si+Ssi_Vsbulk_si_Vsbulk_si);
  T6_Vsbulk_si_Vgi_bi=(+Swi_Vsbulk_si_Vgi_bi+Ssi_Vsbulk_si_Vgi_bi);
  T6_Vsbulk_si_Vdi_bi=(+Swi_Vsbulk_si_Vdi_bi+Ssi_Vsbulk_si_Vdi_bi);
  T6_Vsbulk_si_Vsi_bi=(+Swi_Vsbulk_si_Vsi_bi+Ssi_Vsbulk_si_Vsi_bi);
  T6_Vsbulk_si_Tempt_GND=(+Swi_Vsbulk_si_Tempt_GND+Ssi_Vsbulk_si_Tempt_GND);
#endif
T6_Vgi_bi=(Swi_Vgi_bi+Ssi_Vgi_bi);
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+0.0+0.0);
  T6_Vgi_bi_Vgm_si=(+0.0+0.0);
  T6_Vgi_bi_Vdbulk_di=(+Swi_Vgi_bi_Vdbulk_di+Ssi_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+Swi_Vgi_bi_Vsbulk_si+Ssi_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+Swi_Vgi_bi_Vgi_bi+Ssi_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+Swi_Vgi_bi_Vdi_bi+Ssi_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+Swi_Vgi_bi_Vsi_bi+Ssi_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+Swi_Vgi_bi_Tempt_GND+Ssi_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=(Swi_Vdi_bi+Ssi_Vdi_bi);
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+0.0+0.0);
  T6_Vdi_bi_Vgm_si=(+0.0+0.0);
  T6_Vdi_bi_Vdbulk_di=(+Swi_Vdi_bi_Vdbulk_di+Ssi_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+Swi_Vdi_bi_Vsbulk_si+Ssi_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+Swi_Vdi_bi_Vgi_bi+Ssi_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+Swi_Vdi_bi_Vdi_bi+Ssi_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+Swi_Vdi_bi_Vsi_bi+Ssi_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+Swi_Vdi_bi_Tempt_GND+Ssi_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=(Swi_Vsi_bi+Ssi_Vsi_bi);
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+0.0+0.0);
  T6_Vsi_bi_Vgm_si=(+0.0+0.0);
  T6_Vsi_bi_Vdbulk_di=(+Swi_Vsi_bi_Vdbulk_di+Ssi_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+Swi_Vsi_bi_Vsbulk_si+Ssi_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+Swi_Vsi_bi_Vgi_bi+Ssi_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+Swi_Vsi_bi_Vdi_bi+Ssi_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+Swi_Vsi_bi_Vsi_bi+Ssi_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+Swi_Vsi_bi_Tempt_GND+Ssi_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(Swi_Tempt_GND+Ssi_Tempt_GND);
#endif
#endif
T6=(Swi+Ssi);
EXIT_IF_ISNAN((Swi+Ssi))
if
((T6>0.0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
FNPowerAt1Hz_Tempt_GND=((((Ssi_Tempt_GND*Swi)+(Ssi*Swi_Tempt_GND))*T6-(Ssi*Swi)*T6_Tempt_GND)/T6/T6);
FNPowerAt1Hz_Vgi_bi=((((Ssi_Vgi_bi*Swi)+(Ssi*Swi_Vgi_bi))*T6-(Ssi*Swi)*T6_Vgi_bi)/T6/T6);
FNPowerAt1Hz_Vdi_bi=((((Ssi_Vdi_bi*Swi)+(Ssi*Swi_Vdi_bi))*T6-(Ssi*Swi)*T6_Vdi_bi)/T6/T6);
FNPowerAt1Hz_Vsi_bi=((((Ssi_Vsi_bi*Swi)+(Ssi*Swi_Vsi_bi))*T6-(Ssi*Swi)*T6_Vsi_bi)/T6/T6);
FNPowerAt1Hz_Vdbulk_di=((((Ssi_Vdbulk_di*Swi)+(Ssi*Swi_Vdbulk_di))*T6-(Ssi*Swi)*T6_Vdbulk_di)/T6/T6);
FNPowerAt1Hz_Vsbulk_si=((((Ssi_Vsbulk_si*Swi)+(Ssi*Swi_Vsbulk_si))*T6-(Ssi*Swi)*T6_Vsbulk_si)/T6/T6);
#endif
FNPowerAt1Hz=((Ssi*Swi)/T6);
EXIT_IF_ISNAN(((Ssi*Swi)/T6))
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
FNPowerAt1Hz_Tempt_GND=0.0;
FNPowerAt1Hz_Vgi_bi=0.0;
FNPowerAt1Hz_Vdi_bi=0.0;
FNPowerAt1Hz_Vsi_bi=0.0;
FNPowerAt1Hz_Vdbulk_di=0.0;
FNPowerAt1Hz_Vsbulk_si=0.0;
#endif
FNPowerAt1Hz=0.0;
EXIT_IF_ISNAN(0.0)
}
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
FNPowerAt1Hz_Tempt_GND=0.0;
FNPowerAt1Hz_Vgi_bi=0.0;
FNPowerAt1Hz_Vdi_bi=0.0;
FNPowerAt1Hz_Vsi_bi=0.0;
FNPowerAt1Hz_Vdbulk_di=0.0;
FNPowerAt1Hz_Vsbulk_si=0.0;
#endif
FNPowerAt1Hz=0.0;
EXIT_IF_ISNAN(0.0)
}
pInst->fpnoise0=FNPowerAt1Hz;
pInst->fenoise0=pModel->EF;
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=(((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)/Leff);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((0.0/Esatnoi-(qia_Vgi_bi*0.0+0.0*Esatnoi_Vgi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vgi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+0.0*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vgi_bi_Vgm_si=((0.0/Esatnoi-(qia_Vgi_bi*0.0+0.0*Esatnoi_Vgi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vgi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+0.0*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vgi_bi_Vdbulk_di=((qia_Vgi_bi_Vdbulk_di/Esatnoi-(qia_Vgi_bi*0.0+qia_Vdbulk_di*Esatnoi_Vgi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vgi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+(qia_Vdbulk_di/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vgi_bi_Vsbulk_si=((qia_Vgi_bi_Vsbulk_si/Esatnoi-(qia_Vgi_bi*0.0+qia_Vsbulk_si*Esatnoi_Vgi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vgi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+(qia_Vsbulk_si/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vgi_bi_Vgi_bi=((qia_Vgi_bi_Vgi_bi/Esatnoi-(qia_Vgi_bi*Esatnoi_Vgi_bi+qia_Vgi_bi*Esatnoi_Vgi_bi+qia*Esatnoi_Vgi_bi_Vgi_bi)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vgi_bi*Esatnoi_Vgi_bi/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vgi_bi_Vdi_bi=((qia_Vgi_bi_Vdi_bi/Esatnoi-(qia_Vgi_bi*Esatnoi_Vdi_bi+qia_Vdi_bi*Esatnoi_Vgi_bi+qia*Esatnoi_Vgi_bi_Vdi_bi)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vgi_bi*Esatnoi_Vdi_bi/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vgi_bi_Vsi_bi=((qia_Vgi_bi_Vsi_bi/Esatnoi-(qia_Vgi_bi*Esatnoi_Vsi_bi+qia_Vsi_bi*Esatnoi_Vgi_bi+qia*Esatnoi_Vgi_bi_Vsi_bi)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vgi_bi*Esatnoi_Vsi_bi/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vgi_bi_Tempt_GND=((qia_Vgi_bi_Tempt_GND/Esatnoi-(qia_Vgi_bi*Esatnoi_Tempt_GND+qia_Tempt_GND*Esatnoi_Vgi_bi+qia*Esatnoi_Vgi_bi_Tempt_GND)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vgi_bi*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Tempt_GND*Esatnoi-qia*Esatnoi_Tempt_GND)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
#endif
T0_Vdi_bi=(((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)/Leff);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((0.0/Esatnoi-(qia_Vdi_bi*0.0+0.0*Esatnoi_Vdi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vdi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+0.0*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_bi_Vgm_si=((0.0/Esatnoi-(qia_Vdi_bi*0.0+0.0*Esatnoi_Vdi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vdi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+0.0*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_bi_Vdbulk_di=((qia_Vdi_bi_Vdbulk_di/Esatnoi-(qia_Vdi_bi*0.0+qia_Vdbulk_di*Esatnoi_Vdi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vdi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+(qia_Vdbulk_di/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_bi_Vsbulk_si=((qia_Vdi_bi_Vsbulk_si/Esatnoi-(qia_Vdi_bi*0.0+qia_Vsbulk_si*Esatnoi_Vdi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vdi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+(qia_Vsbulk_si/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_bi_Vgi_bi=((qia_Vdi_bi_Vgi_bi/Esatnoi-(qia_Vdi_bi*Esatnoi_Vgi_bi+qia_Vgi_bi*Esatnoi_Vdi_bi+qia*Esatnoi_Vdi_bi_Vgi_bi)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vdi_bi*Esatnoi_Vgi_bi/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_bi_Vdi_bi=((qia_Vdi_bi_Vdi_bi/Esatnoi-(qia_Vdi_bi*Esatnoi_Vdi_bi+qia_Vdi_bi*Esatnoi_Vdi_bi+qia*Esatnoi_Vdi_bi_Vdi_bi)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vdi_bi*Esatnoi_Vdi_bi/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_bi_Vsi_bi=((qia_Vdi_bi_Vsi_bi/Esatnoi-(qia_Vdi_bi*Esatnoi_Vsi_bi+qia_Vsi_bi*Esatnoi_Vdi_bi+qia*Esatnoi_Vdi_bi_Vsi_bi)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vdi_bi*Esatnoi_Vsi_bi/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_bi_Tempt_GND=((qia_Vdi_bi_Tempt_GND/Esatnoi-(qia_Vdi_bi*Esatnoi_Tempt_GND+qia_Tempt_GND*Esatnoi_Vdi_bi+qia*Esatnoi_Vdi_bi_Tempt_GND)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vdi_bi*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Tempt_GND*Esatnoi-qia*Esatnoi_Tempt_GND)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
#endif
T0_Vsi_bi=(((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)/Leff);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((0.0/Esatnoi-(qia_Vsi_bi*0.0+0.0*Esatnoi_Vsi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vsi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+0.0*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vsi_bi_Vgm_si=((0.0/Esatnoi-(qia_Vsi_bi*0.0+0.0*Esatnoi_Vsi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vsi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+0.0*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vsi_bi_Vdbulk_di=((qia_Vsi_bi_Vdbulk_di/Esatnoi-(qia_Vsi_bi*0.0+qia_Vdbulk_di*Esatnoi_Vsi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vsi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+(qia_Vdbulk_di/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vsi_bi_Vsbulk_si=((qia_Vsi_bi_Vsbulk_si/Esatnoi-(qia_Vsi_bi*0.0+qia_Vsbulk_si*Esatnoi_Vsi_bi+qia*0.0)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vsi_bi*0.0/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+(qia_Vsbulk_si/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vsi_bi_Vgi_bi=((qia_Vsi_bi_Vgi_bi/Esatnoi-(qia_Vsi_bi*Esatnoi_Vgi_bi+qia_Vgi_bi*Esatnoi_Vsi_bi+qia*Esatnoi_Vsi_bi_Vgi_bi)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vsi_bi*Esatnoi_Vgi_bi/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Vgi_bi*Esatnoi-qia*Esatnoi_Vgi_bi)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vsi_bi_Vdi_bi=((qia_Vsi_bi_Vdi_bi/Esatnoi-(qia_Vsi_bi*Esatnoi_Vdi_bi+qia_Vdi_bi*Esatnoi_Vsi_bi+qia*Esatnoi_Vsi_bi_Vdi_bi)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vsi_bi*Esatnoi_Vdi_bi/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Vdi_bi*Esatnoi-qia*Esatnoi_Vdi_bi)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vsi_bi_Vsi_bi=((qia_Vsi_bi_Vsi_bi/Esatnoi-(qia_Vsi_bi*Esatnoi_Vsi_bi+qia_Vsi_bi*Esatnoi_Vsi_bi+qia*Esatnoi_Vsi_bi_Vsi_bi)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vsi_bi*Esatnoi_Vsi_bi/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
  T0_Vsi_bi_Tempt_GND=((qia_Vsi_bi_Tempt_GND/Esatnoi-(qia_Vsi_bi*Esatnoi_Tempt_GND+qia_Tempt_GND*Esatnoi_Vsi_bi+qia*Esatnoi_Vsi_bi_Tempt_GND)/Esatnoi/Esatnoi+2*qia*Esatnoi_Vsi_bi*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi)/Leff-(((qia_Vsi_bi*Esatnoi-qia*Esatnoi_Vsi_bi)/Esatnoi/Esatnoi)*0.0+((qia_Tempt_GND*Esatnoi-qia*Esatnoi_Tempt_GND)/Esatnoi/Esatnoi)*0.0+(qia/Esatnoi)*0.0)/Leff/Leff+2*(qia/Esatnoi)*0.0*0.0/Leff/Leff/Leff);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(((qia_Tempt_GND*Esatnoi-qia*Esatnoi_Tempt_GND)/Esatnoi/Esatnoi)/Leff);
#endif
#endif
T0=((qia/Esatnoi)/Leff);
EXIT_IF_ISNAN(((qia/Esatnoi)/Leff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+T0_Vdbulk_di_Vgm_di*T0+T0_Vdbulk_di*T0_Vgm_di+T0_Vgm_di*T0_Vdbulk_di+T0*T0_Vdbulk_di_Vgm_di);
  T1_Vdbulk_di_Vgm_si=(+T0_Vdbulk_di_Vgm_si*T0+T0_Vdbulk_di*T0_Vgm_si+T0_Vgm_si*T0_Vdbulk_di+T0*T0_Vdbulk_di_Vgm_si);
  T1_Vdbulk_di_Vdbulk_di=(+T0_Vdbulk_di_Vdbulk_di*T0+T0_Vdbulk_di*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdbulk_di+T0*T0_Vdbulk_di_Vdbulk_di);
  T1_Vdbulk_di_Vsbulk_si=(+T0_Vdbulk_di_Vsbulk_si*T0+T0_Vdbulk_di*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdbulk_di+T0*T0_Vdbulk_di_Vsbulk_si);
  T1_Vdbulk_di_Vgi_bi=(+T0_Vdbulk_di_Vgi_bi*T0+T0_Vdbulk_di*T0_Vgi_bi+T0_Vgi_bi*T0_Vdbulk_di+T0*T0_Vdbulk_di_Vgi_bi);
  T1_Vdbulk_di_Vdi_bi=(+T0_Vdbulk_di_Vdi_bi*T0+T0_Vdbulk_di*T0_Vdi_bi+T0_Vdi_bi*T0_Vdbulk_di+T0*T0_Vdbulk_di_Vdi_bi);
  T1_Vdbulk_di_Vsi_bi=(+T0_Vdbulk_di_Vsi_bi*T0+T0_Vdbulk_di*T0_Vsi_bi+T0_Vsi_bi*T0_Vdbulk_di+T0*T0_Vdbulk_di_Vsi_bi);
  T1_Vdbulk_di_Tempt_GND=(+T0_Vdbulk_di_Tempt_GND*T0+T0_Vdbulk_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vdbulk_di+T0*T0_Vdbulk_di_Tempt_GND);
#endif
T1_Vsbulk_si=((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+T0_Vsbulk_si_Vgm_di*T0+T0_Vsbulk_si*T0_Vgm_di+T0_Vgm_di*T0_Vsbulk_si+T0*T0_Vsbulk_si_Vgm_di);
  T1_Vsbulk_si_Vgm_si=(+T0_Vsbulk_si_Vgm_si*T0+T0_Vsbulk_si*T0_Vgm_si+T0_Vgm_si*T0_Vsbulk_si+T0*T0_Vsbulk_si_Vgm_si);
  T1_Vsbulk_si_Vdbulk_di=(+T0_Vsbulk_si_Vdbulk_di*T0+T0_Vsbulk_si*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsbulk_si+T0*T0_Vsbulk_si_Vdbulk_di);
  T1_Vsbulk_si_Vsbulk_si=(+T0_Vsbulk_si_Vsbulk_si*T0+T0_Vsbulk_si*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsbulk_si+T0*T0_Vsbulk_si_Vsbulk_si);
  T1_Vsbulk_si_Vgi_bi=(+T0_Vsbulk_si_Vgi_bi*T0+T0_Vsbulk_si*T0_Vgi_bi+T0_Vgi_bi*T0_Vsbulk_si+T0*T0_Vsbulk_si_Vgi_bi);
  T1_Vsbulk_si_Vdi_bi=(+T0_Vsbulk_si_Vdi_bi*T0+T0_Vsbulk_si*T0_Vdi_bi+T0_Vdi_bi*T0_Vsbulk_si+T0*T0_Vsbulk_si_Vdi_bi);
  T1_Vsbulk_si_Vsi_bi=(+T0_Vsbulk_si_Vsi_bi*T0+T0_Vsbulk_si*T0_Vsi_bi+T0_Vsi_bi*T0_Vsbulk_si+T0*T0_Vsbulk_si_Vsi_bi);
  T1_Vsbulk_si_Tempt_GND=(+T0_Vsbulk_si_Tempt_GND*T0+T0_Vsbulk_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vsbulk_si+T0*T0_Vsbulk_si_Tempt_GND);
#endif
T1_Vgi_bi=((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+T0_Vgi_bi_Vgm_di*T0+T0_Vgi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_di);
  T1_Vgi_bi_Vgm_si=(+T0_Vgi_bi_Vgm_si*T0+T0_Vgi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+T0_Vgi_bi_Vdbulk_di*T0+T0_Vgi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vgi_bi+T0*T0_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+T0_Vgi_bi_Vsbulk_si*T0+T0_Vgi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vgi_bi+T0*T0_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+T0_Vgi_bi_Vgi_bi*T0+T0_Vgi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+T0_Vgi_bi_Vdi_bi*T0+T0_Vgi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+T0_Vgi_bi_Vsi_bi*T0+T0_Vgi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vgi_bi+T0*T0_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+T0_Vgi_bi_Tempt_GND*T0+T0_Vgi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vgi_bi+T0*T0_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+T0_Vdi_bi_Vgm_di*T0+T0_Vdi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_di);
  T1_Vdi_bi_Vgm_si=(+T0_Vdi_bi_Vgm_si*T0+T0_Vdi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+T0_Vdi_bi_Vdbulk_di*T0+T0_Vdi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdi_bi+T0*T0_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+T0_Vdi_bi_Vsbulk_si*T0+T0_Vdi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdi_bi+T0*T0_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+T0_Vdi_bi_Vgi_bi*T0+T0_Vdi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+T0_Vdi_bi_Vdi_bi*T0+T0_Vdi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+T0_Vdi_bi_Vsi_bi*T0+T0_Vdi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vdi_bi+T0*T0_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+T0_Vdi_bi_Tempt_GND*T0+T0_Vdi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_bi+T0*T0_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+T0_Vsi_bi_Vgm_di*T0+T0_Vsi_bi*T0_Vgm_di+T0_Vgm_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_di);
  T1_Vsi_bi_Vgm_si=(+T0_Vsi_bi_Vgm_si*T0+T0_Vsi_bi*T0_Vgm_si+T0_Vgm_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+T0_Vsi_bi_Vdbulk_di*T0+T0_Vsi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsi_bi+T0*T0_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+T0_Vsi_bi_Vsbulk_si*T0+T0_Vsi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsi_bi+T0*T0_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+T0_Vsi_bi_Vgi_bi*T0+T0_Vsi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+T0_Vsi_bi_Vdi_bi*T0+T0_Vsi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+T0_Vsi_bi_Vsi_bi*T0+T0_Vsi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vsi_bi+T0*T0_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+T0_Vsi_bi_Tempt_GND*T0+T0_Vsi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vsi_bi+T0*T0_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND));
#endif
#endif
T1=(T0*T0);
EXIT_IF_ISNAN((T0*T0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=(pModel->RNOIA*((pModel->TNOIA*Leff)*T1_Vdbulk_di));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vdbulk_di)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(pModel->TNOIA*Leff)*T1_Vdbulk_di_Vgm_si)));
  T3_Vdbulk_di_Vgm_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vdbulk_di)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vdbulk_di+(pModel->TNOIA*Leff)*T1_Vdbulk_di_Vgm_di)));
  T3_Vdbulk_di_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vdbulk_di)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(pModel->TNOIA*Leff)*T1_Vdbulk_di_Vdbulk_di)));
  T3_Vdbulk_di_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vdbulk_di)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(pModel->TNOIA*Leff)*T1_Vdbulk_di_Vsbulk_si)));
  T3_Vdbulk_di_Vgi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vdbulk_di)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(pModel->TNOIA*Leff)*T1_Vdbulk_di_Vgi_bi)));
  T3_Vdbulk_di_Vdi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vdbulk_di)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(pModel->TNOIA*Leff)*T1_Vdbulk_di_Vdi_bi)));
  T3_Vdbulk_di_Vsi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vdbulk_di)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(pModel->TNOIA*Leff)*T1_Vdbulk_di_Vsi_bi)));
  T3_Vdbulk_di_Tempt_GND=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIA*Leff)*T1_Vdbulk_di)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(pModel->TNOIA*Leff)*T1_Vdbulk_di_Tempt_GND)));
#endif
T3_Vsbulk_si=(pModel->RNOIA*((pModel->TNOIA*Leff)*T1_Vsbulk_si));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vsbulk_si)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(pModel->TNOIA*Leff)*T1_Vsbulk_si_Vgm_si)));
  T3_Vsbulk_si_Vgm_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vsbulk_si)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vsbulk_si+(pModel->TNOIA*Leff)*T1_Vsbulk_si_Vgm_di)));
  T3_Vsbulk_si_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vsbulk_si)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(pModel->TNOIA*Leff)*T1_Vsbulk_si_Vdbulk_di)));
  T3_Vsbulk_si_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vsbulk_si)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(pModel->TNOIA*Leff)*T1_Vsbulk_si_Vsbulk_si)));
  T3_Vsbulk_si_Vgi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vsbulk_si)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(pModel->TNOIA*Leff)*T1_Vsbulk_si_Vgi_bi)));
  T3_Vsbulk_si_Vdi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vsbulk_si)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(pModel->TNOIA*Leff)*T1_Vsbulk_si_Vdi_bi)));
  T3_Vsbulk_si_Vsi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vsbulk_si)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(pModel->TNOIA*Leff)*T1_Vsbulk_si_Vsi_bi)));
  T3_Vsbulk_si_Tempt_GND=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIA*Leff)*T1_Vsbulk_si)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(pModel->TNOIA*Leff)*T1_Vsbulk_si_Tempt_GND)));
#endif
T3_Vgi_bi=(pModel->RNOIA*((pModel->TNOIA*Leff)*T1_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vgi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(pModel->TNOIA*Leff)*T1_Vgi_bi_Vgm_si)));
  T3_Vgi_bi_Vgm_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vgi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(pModel->TNOIA*Leff)*T1_Vgi_bi_Vgm_di)));
  T3_Vgi_bi_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vgi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(pModel->TNOIA*Leff)*T1_Vgi_bi_Vdbulk_di)));
  T3_Vgi_bi_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vgi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(pModel->TNOIA*Leff)*T1_Vgi_bi_Vsbulk_si)));
  T3_Vgi_bi_Vgi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vgi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(pModel->TNOIA*Leff)*T1_Vgi_bi_Vgi_bi)));
  T3_Vgi_bi_Vdi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vgi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(pModel->TNOIA*Leff)*T1_Vgi_bi_Vdi_bi)));
  T3_Vgi_bi_Vsi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vgi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(pModel->TNOIA*Leff)*T1_Vgi_bi_Vsi_bi)));
  T3_Vgi_bi_Tempt_GND=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIA*Leff)*T1_Vgi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(pModel->TNOIA*Leff)*T1_Vgi_bi_Tempt_GND)));
#endif
T3_Vdi_bi=(pModel->RNOIA*((pModel->TNOIA*Leff)*T1_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vdi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(pModel->TNOIA*Leff)*T1_Vdi_bi_Vgm_si)));
  T3_Vdi_bi_Vgm_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vdi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(pModel->TNOIA*Leff)*T1_Vdi_bi_Vgm_di)));
  T3_Vdi_bi_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vdi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(pModel->TNOIA*Leff)*T1_Vdi_bi_Vdbulk_di)));
  T3_Vdi_bi_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vdi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(pModel->TNOIA*Leff)*T1_Vdi_bi_Vsbulk_si)));
  T3_Vdi_bi_Vgi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vdi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(pModel->TNOIA*Leff)*T1_Vdi_bi_Vgi_bi)));
  T3_Vdi_bi_Vdi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vdi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(pModel->TNOIA*Leff)*T1_Vdi_bi_Vdi_bi)));
  T3_Vdi_bi_Vsi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vdi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(pModel->TNOIA*Leff)*T1_Vdi_bi_Vsi_bi)));
  T3_Vdi_bi_Tempt_GND=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIA*Leff)*T1_Vdi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(pModel->TNOIA*Leff)*T1_Vdi_bi_Tempt_GND)));
#endif
T3_Vsi_bi=(pModel->RNOIA*((pModel->TNOIA*Leff)*T1_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vsi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(pModel->TNOIA*Leff)*T1_Vsi_bi_Vgm_si)));
  T3_Vsi_bi_Vgm_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vsi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(pModel->TNOIA*Leff)*T1_Vsi_bi_Vgm_di)));
  T3_Vsi_bi_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIA*Leff)*T1_Vsi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(pModel->TNOIA*Leff)*T1_Vsi_bi_Vdbulk_di)));
  T3_Vsi_bi_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIA*Leff)*T1_Vsi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(pModel->TNOIA*Leff)*T1_Vsi_bi_Vsbulk_si)));
  T3_Vsi_bi_Vgi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vsi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(pModel->TNOIA*Leff)*T1_Vsi_bi_Vgi_bi)));
  T3_Vsi_bi_Vdi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vsi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(pModel->TNOIA*Leff)*T1_Vsi_bi_Vdi_bi)));
  T3_Vsi_bi_Vsi_bi=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIA*Leff)*T1_Vsi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(pModel->TNOIA*Leff)*T1_Vsi_bi_Vsi_bi)));
  T3_Vsi_bi_Tempt_GND=(+0.0*(1.0+((pModel->TNOIA*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIA*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIA*Leff)*T1_Vsi_bi)+pModel->RNOIA*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIA*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(pModel->TNOIA*Leff)*T1_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(pModel->RNOIA*((pModel->TNOIA*Leff)*T1_Tempt_GND));
#endif
#endif
T3=(pModel->RNOIA*(1.0+((pModel->TNOIA*Leff)*T1)));
EXIT_IF_ISNAN((pModel->RNOIA*(1.0+((pModel->TNOIA*Leff)*T1))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=(pModel->RNOIB*((pModel->TNOIB*Leff)*T1_Vdbulk_di));
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vdbulk_di)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(pModel->TNOIB*Leff)*T1_Vdbulk_di_Vgm_si)));
  T4_Vdbulk_di_Vgm_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vdbulk_di)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vdbulk_di+(pModel->TNOIB*Leff)*T1_Vdbulk_di_Vgm_di)));
  T4_Vdbulk_di_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vdbulk_di)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(pModel->TNOIB*Leff)*T1_Vdbulk_di_Vdbulk_di)));
  T4_Vdbulk_di_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vdbulk_di)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(pModel->TNOIB*Leff)*T1_Vdbulk_di_Vsbulk_si)));
  T4_Vdbulk_di_Vgi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vdbulk_di)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(pModel->TNOIB*Leff)*T1_Vdbulk_di_Vgi_bi)));
  T4_Vdbulk_di_Vdi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vdbulk_di)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(pModel->TNOIB*Leff)*T1_Vdbulk_di_Vdi_bi)));
  T4_Vdbulk_di_Vsi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vdbulk_di)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(pModel->TNOIB*Leff)*T1_Vdbulk_di_Vsi_bi)));
  T4_Vdbulk_di_Tempt_GND=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIB*Leff)*T1_Vdbulk_di)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(pModel->TNOIB*Leff)*T1_Vdbulk_di_Tempt_GND)));
#endif
T4_Vsbulk_si=(pModel->RNOIB*((pModel->TNOIB*Leff)*T1_Vsbulk_si));
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vsbulk_si)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(pModel->TNOIB*Leff)*T1_Vsbulk_si_Vgm_si)));
  T4_Vsbulk_si_Vgm_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vsbulk_si)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vsbulk_si+(pModel->TNOIB*Leff)*T1_Vsbulk_si_Vgm_di)));
  T4_Vsbulk_si_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vsbulk_si)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(pModel->TNOIB*Leff)*T1_Vsbulk_si_Vdbulk_di)));
  T4_Vsbulk_si_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vsbulk_si)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(pModel->TNOIB*Leff)*T1_Vsbulk_si_Vsbulk_si)));
  T4_Vsbulk_si_Vgi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vsbulk_si)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(pModel->TNOIB*Leff)*T1_Vsbulk_si_Vgi_bi)));
  T4_Vsbulk_si_Vdi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vsbulk_si)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(pModel->TNOIB*Leff)*T1_Vsbulk_si_Vdi_bi)));
  T4_Vsbulk_si_Vsi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vsbulk_si)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(pModel->TNOIB*Leff)*T1_Vsbulk_si_Vsi_bi)));
  T4_Vsbulk_si_Tempt_GND=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIB*Leff)*T1_Vsbulk_si)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(pModel->TNOIB*Leff)*T1_Vsbulk_si_Tempt_GND)));
#endif
T4_Vgi_bi=(pModel->RNOIB*((pModel->TNOIB*Leff)*T1_Vgi_bi));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vgi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(pModel->TNOIB*Leff)*T1_Vgi_bi_Vgm_si)));
  T4_Vgi_bi_Vgm_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vgi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(pModel->TNOIB*Leff)*T1_Vgi_bi_Vgm_di)));
  T4_Vgi_bi_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vgi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(pModel->TNOIB*Leff)*T1_Vgi_bi_Vdbulk_di)));
  T4_Vgi_bi_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vgi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(pModel->TNOIB*Leff)*T1_Vgi_bi_Vsbulk_si)));
  T4_Vgi_bi_Vgi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vgi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(pModel->TNOIB*Leff)*T1_Vgi_bi_Vgi_bi)));
  T4_Vgi_bi_Vdi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vgi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(pModel->TNOIB*Leff)*T1_Vgi_bi_Vdi_bi)));
  T4_Vgi_bi_Vsi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vgi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(pModel->TNOIB*Leff)*T1_Vgi_bi_Vsi_bi)));
  T4_Vgi_bi_Tempt_GND=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIB*Leff)*T1_Vgi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(pModel->TNOIB*Leff)*T1_Vgi_bi_Tempt_GND)));
#endif
T4_Vdi_bi=(pModel->RNOIB*((pModel->TNOIB*Leff)*T1_Vdi_bi));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vdi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(pModel->TNOIB*Leff)*T1_Vdi_bi_Vgm_si)));
  T4_Vdi_bi_Vgm_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vdi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(pModel->TNOIB*Leff)*T1_Vdi_bi_Vgm_di)));
  T4_Vdi_bi_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vdi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(pModel->TNOIB*Leff)*T1_Vdi_bi_Vdbulk_di)));
  T4_Vdi_bi_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vdi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(pModel->TNOIB*Leff)*T1_Vdi_bi_Vsbulk_si)));
  T4_Vdi_bi_Vgi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vdi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(pModel->TNOIB*Leff)*T1_Vdi_bi_Vgi_bi)));
  T4_Vdi_bi_Vdi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vdi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(pModel->TNOIB*Leff)*T1_Vdi_bi_Vdi_bi)));
  T4_Vdi_bi_Vsi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vdi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(pModel->TNOIB*Leff)*T1_Vdi_bi_Vsi_bi)));
  T4_Vdi_bi_Tempt_GND=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIB*Leff)*T1_Vdi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(pModel->TNOIB*Leff)*T1_Vdi_bi_Tempt_GND)));
#endif
T4_Vsi_bi=(pModel->RNOIB*((pModel->TNOIB*Leff)*T1_Vsi_bi));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vsi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(pModel->TNOIB*Leff)*T1_Vsi_bi_Vgm_si)));
  T4_Vsi_bi_Vgm_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vsi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(pModel->TNOIB*Leff)*T1_Vsi_bi_Vgm_di)));
  T4_Vsi_bi_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIB*Leff)*T1_Vsi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(pModel->TNOIB*Leff)*T1_Vsi_bi_Vdbulk_di)));
  T4_Vsi_bi_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIB*Leff)*T1_Vsi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(pModel->TNOIB*Leff)*T1_Vsi_bi_Vsbulk_si)));
  T4_Vsi_bi_Vgi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vsi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(pModel->TNOIB*Leff)*T1_Vsi_bi_Vgi_bi)));
  T4_Vsi_bi_Vdi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vsi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(pModel->TNOIB*Leff)*T1_Vsi_bi_Vdi_bi)));
  T4_Vsi_bi_Vsi_bi=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIB*Leff)*T1_Vsi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(pModel->TNOIB*Leff)*T1_Vsi_bi_Vsi_bi)));
  T4_Vsi_bi_Tempt_GND=(+0.0*(1.0+((pModel->TNOIB*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIB*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIB*Leff)*T1_Vsi_bi)+pModel->RNOIB*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIB*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(pModel->TNOIB*Leff)*T1_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(pModel->RNOIB*((pModel->TNOIB*Leff)*T1_Tempt_GND));
#endif
#endif
T4=(pModel->RNOIB*(1.0+((pModel->TNOIB*Leff)*T1)));
EXIT_IF_ISNAN((pModel->RNOIB*(1.0+((pModel->TNOIB*Leff)*T1))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=(pModel->RNOIK*((pModel->TNOIK*Leff)*T1_Vdbulk_di));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vdbulk_di)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(pModel->TNOIK*Leff)*T1_Vdbulk_di_Vgm_si)));
  T5_Vdbulk_di_Vgm_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vdbulk_di)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vdbulk_di+(pModel->TNOIK*Leff)*T1_Vdbulk_di_Vgm_di)));
  T5_Vdbulk_di_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vdbulk_di)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(pModel->TNOIK*Leff)*T1_Vdbulk_di_Vdbulk_di)));
  T5_Vdbulk_di_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vdbulk_di)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(pModel->TNOIK*Leff)*T1_Vdbulk_di_Vsbulk_si)));
  T5_Vdbulk_di_Vgi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vdbulk_di)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(pModel->TNOIK*Leff)*T1_Vdbulk_di_Vgi_bi)));
  T5_Vdbulk_di_Vdi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vdbulk_di)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(pModel->TNOIK*Leff)*T1_Vdbulk_di_Vdi_bi)));
  T5_Vdbulk_di_Vsi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vdbulk_di)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(pModel->TNOIK*Leff)*T1_Vdbulk_di_Vsi_bi)));
  T5_Vdbulk_di_Tempt_GND=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIK*Leff)*T1_Vdbulk_di)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(pModel->TNOIK*Leff)*T1_Vdbulk_di_Tempt_GND)));
#endif
T5_Vsbulk_si=(pModel->RNOIK*((pModel->TNOIK*Leff)*T1_Vsbulk_si));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vsbulk_si)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(pModel->TNOIK*Leff)*T1_Vsbulk_si_Vgm_si)));
  T5_Vsbulk_si_Vgm_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vsbulk_si)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vsbulk_si+(pModel->TNOIK*Leff)*T1_Vsbulk_si_Vgm_di)));
  T5_Vsbulk_si_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vsbulk_si)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(pModel->TNOIK*Leff)*T1_Vsbulk_si_Vdbulk_di)));
  T5_Vsbulk_si_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vsbulk_si)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(pModel->TNOIK*Leff)*T1_Vsbulk_si_Vsbulk_si)));
  T5_Vsbulk_si_Vgi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vsbulk_si)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(pModel->TNOIK*Leff)*T1_Vsbulk_si_Vgi_bi)));
  T5_Vsbulk_si_Vdi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vsbulk_si)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(pModel->TNOIK*Leff)*T1_Vsbulk_si_Vdi_bi)));
  T5_Vsbulk_si_Vsi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vsbulk_si)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(pModel->TNOIK*Leff)*T1_Vsbulk_si_Vsi_bi)));
  T5_Vsbulk_si_Tempt_GND=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIK*Leff)*T1_Vsbulk_si)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(pModel->TNOIK*Leff)*T1_Vsbulk_si_Tempt_GND)));
#endif
T5_Vgi_bi=(pModel->RNOIK*((pModel->TNOIK*Leff)*T1_Vgi_bi));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vgi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(pModel->TNOIK*Leff)*T1_Vgi_bi_Vgm_si)));
  T5_Vgi_bi_Vgm_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vgi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vgi_bi+(pModel->TNOIK*Leff)*T1_Vgi_bi_Vgm_di)));
  T5_Vgi_bi_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vgi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(pModel->TNOIK*Leff)*T1_Vgi_bi_Vdbulk_di)));
  T5_Vgi_bi_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vgi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(pModel->TNOIK*Leff)*T1_Vgi_bi_Vsbulk_si)));
  T5_Vgi_bi_Vgi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vgi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(pModel->TNOIK*Leff)*T1_Vgi_bi_Vgi_bi)));
  T5_Vgi_bi_Vdi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vgi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(pModel->TNOIK*Leff)*T1_Vgi_bi_Vdi_bi)));
  T5_Vgi_bi_Vsi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vgi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(pModel->TNOIK*Leff)*T1_Vgi_bi_Vsi_bi)));
  T5_Vgi_bi_Tempt_GND=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIK*Leff)*T1_Vgi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(pModel->TNOIK*Leff)*T1_Vgi_bi_Tempt_GND)));
#endif
T5_Vdi_bi=(pModel->RNOIK*((pModel->TNOIK*Leff)*T1_Vdi_bi));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vdi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(pModel->TNOIK*Leff)*T1_Vdi_bi_Vgm_si)));
  T5_Vdi_bi_Vgm_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vdi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vdi_bi+(pModel->TNOIK*Leff)*T1_Vdi_bi_Vgm_di)));
  T5_Vdi_bi_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vdi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(pModel->TNOIK*Leff)*T1_Vdi_bi_Vdbulk_di)));
  T5_Vdi_bi_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vdi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(pModel->TNOIK*Leff)*T1_Vdi_bi_Vsbulk_si)));
  T5_Vdi_bi_Vgi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vdi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(pModel->TNOIK*Leff)*T1_Vdi_bi_Vgi_bi)));
  T5_Vdi_bi_Vdi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vdi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(pModel->TNOIK*Leff)*T1_Vdi_bi_Vdi_bi)));
  T5_Vdi_bi_Vsi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vdi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(pModel->TNOIK*Leff)*T1_Vdi_bi_Vsi_bi)));
  T5_Vdi_bi_Tempt_GND=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIK*Leff)*T1_Vdi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(pModel->TNOIK*Leff)*T1_Vdi_bi_Tempt_GND)));
#endif
T5_Vsi_bi=(pModel->RNOIK*((pModel->TNOIK*Leff)*T1_Vsi_bi));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vsi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(pModel->TNOIK*Leff)*T1_Vsi_bi_Vgm_si)));
  T5_Vsi_bi_Vgm_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgm_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vsi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgm_di+(0.0)*T1_Vsi_bi+(pModel->TNOIK*Leff)*T1_Vsi_bi_Vgm_di)));
  T5_Vsi_bi_Vdbulk_di=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdbulk_di)))+0.0*((pModel->TNOIK*Leff)*T1_Vsi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(pModel->TNOIK*Leff)*T1_Vsi_bi_Vdbulk_di)));
  T5_Vsi_bi_Vsbulk_si=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsbulk_si)))+0.0*((pModel->TNOIK*Leff)*T1_Vsi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(pModel->TNOIK*Leff)*T1_Vsi_bi_Vsbulk_si)));
  T5_Vsi_bi_Vgi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vgi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vsi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(pModel->TNOIK*Leff)*T1_Vsi_bi_Vgi_bi)));
  T5_Vsi_bi_Vdi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vdi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vsi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(pModel->TNOIK*Leff)*T1_Vsi_bi_Vdi_bi)));
  T5_Vsi_bi_Vsi_bi=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Vsi_bi)))+0.0*((pModel->TNOIK*Leff)*T1_Vsi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(pModel->TNOIK*Leff)*T1_Vsi_bi_Vsi_bi)));
  T5_Vsi_bi_Tempt_GND=(+0.0*(1.0+((pModel->TNOIK*Leff)*T1))+0.0*((((0.0)*T1)+((pModel->TNOIK*Leff)*T1_Tempt_GND)))+0.0*((pModel->TNOIK*Leff)*T1_Vsi_bi)+pModel->RNOIK*(+0.0+(+(+0.0*Leff+0.0*0.0+0.0*0.0+pModel->TNOIK*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(pModel->TNOIK*Leff)*T1_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=(pModel->RNOIK*((pModel->TNOIK*Leff)*T1_Tempt_GND));
#endif
#endif
T5=(pModel->RNOIK*(1.0+((pModel->TNOIK*Leff)*T1)));
EXIT_IF_ISNAN((pModel->RNOIK*(1.0+((pModel->TNOIK*Leff)*T1))))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
ctnoi_Vdbulk_di=(pModel->RNOIC*((pModel->TNOIC*Leff)*T1_Vdbulk_di));
ctnoi_Vsbulk_si=(pModel->RNOIC*((pModel->TNOIC*Leff)*T1_Vsbulk_si));
ctnoi_Vgi_bi=(pModel->RNOIC*((pModel->TNOIC*Leff)*T1_Vgi_bi));
ctnoi_Vdi_bi=(pModel->RNOIC*((pModel->TNOIC*Leff)*T1_Vdi_bi));
ctnoi_Vsi_bi=(pModel->RNOIC*((pModel->TNOIC*Leff)*T1_Vsi_bi));
ctnoi_Tempt_GND=(pModel->RNOIC*((pModel->TNOIC*Leff)*T1_Tempt_GND));
#endif
ctnoi=(pModel->RNOIC*(1.0+((pModel->TNOIC*Leff)*T1)));
EXIT_IF_ISNAN((pModel->RNOIC*(1.0+((pModel->TNOIC*Leff)*T1))))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
betanoisq_Vdbulk_di=(((3.0*T3_Vdbulk_di)*T3)+((3.0*T3)*T3_Vdbulk_di));
betanoisq_Vsbulk_si=(((3.0*T3_Vsbulk_si)*T3)+((3.0*T3)*T3_Vsbulk_si));
betanoisq_Vgi_bi=(((3.0*T3_Vgi_bi)*T3)+((3.0*T3)*T3_Vgi_bi));
betanoisq_Vdi_bi=(((3.0*T3_Vdi_bi)*T3)+((3.0*T3)*T3_Vdi_bi));
betanoisq_Vsi_bi=(((3.0*T3_Vsi_bi)*T3)+((3.0*T3)*T3_Vsi_bi));
betanoisq_Tempt_GND=(((3.0*T3_Tempt_GND)*T3)+((3.0*T3)*T3_Tempt_GND));
#endif
betanoisq=((3.0*T3)*T3);
EXIT_IF_ISNAN(((3.0*T3)*T3))
{
double m00_exp(d00_exp0,((-Leff)/pModel->LP))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
betanoisq_Vdbulk_di=betanoisq_Vdbulk_di*d00_exp0;
betanoisq_Vsbulk_si=betanoisq_Vsbulk_si*d00_exp0;
betanoisq_Vgi_bi=betanoisq_Vgi_bi*d00_exp0;
betanoisq_Vdi_bi=betanoisq_Vdi_bi*d00_exp0;
betanoisq_Vsi_bi=betanoisq_Vsi_bi*d00_exp0;
betanoisq_Tempt_GND=betanoisq_Tempt_GND*d00_exp0;
#endif
betanoisq=(((betanoisq-1.0)*d00_exp0)+1.0);
EXIT_IF_ISNAN((((betanoisq-1.0)*d00_exp0)+1.0))
}
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
betaLowId_Vdbulk_di=((T5_Vdbulk_di*T5)+(T5*T5_Vdbulk_di));
betaLowId_Vsbulk_si=((T5_Vsbulk_si*T5)+(T5*T5_Vsbulk_si));
betaLowId_Vgi_bi=((T5_Vgi_bi*T5)+(T5*T5_Vgi_bi));
betaLowId_Vdi_bi=((T5_Vdi_bi*T5)+(T5*T5_Vdi_bi));
betaLowId_Vsi_bi=((T5_Vsi_bi*T5)+(T5*T5_Vsi_bi));
betaLowId_Tempt_GND=((T5_Tempt_GND*T5)+(T5*T5_Tempt_GND));
#endif
betaLowId=(T5*T5);
EXIT_IF_ISNAN((T5*T5))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
thetanoisq_Vdbulk_di=((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di));
thetanoisq_Vsbulk_si=((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si));
thetanoisq_Vgi_bi=((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi));
thetanoisq_Vdi_bi=((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi));
thetanoisq_Vsi_bi=((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi));
thetanoisq_Tempt_GND=((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND));
#endif
thetanoisq=(T4*T4);
EXIT_IF_ISNAN((T4*T4))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
cm_igid_Vdbulk_di=0.0;
cm_igid_Vsbulk_si=0.0;
cm_igid_Vgi_bi=0.0;
cm_igid_Vdi_bi=0.0;
cm_igid_Vsi_bi=0.0;
cm_igid_Tempt_GND=0.0;
#endif
cm_igid=0.0;
EXIT_IF_ISNAN(0.0)
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pModel->TNOIMOD)==(0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(dbulk,GND)V(gm,GND) */
QSi_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  QSi_Vdbulk_di_Vdbulk_di=0.0;
  QSi_Vdbulk_di_Vsbulk_si=0.0;
  QSi_Vdbulk_di_Tempt_GND=0.0;
  QSi_Vdbulk_di_Vgi_bi=0.0;
  QSi_Vdbulk_di_Vdi_bi=0.0;
  QSi_Vdbulk_di_Vsi_bi=0.0;
#endif
QSi_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  QSi_Vsbulk_si_Vdbulk_di=0.0;
  QSi_Vsbulk_si_Vsbulk_si=0.0;
  QSi_Vsbulk_si_Tempt_GND=0.0;
  QSi_Vsbulk_si_Vgi_bi=0.0;
  QSi_Vsbulk_si_Vdi_bi=0.0;
  QSi_Vsbulk_si_Vsi_bi=0.0;
#endif
#if defined(_DERIVATE)
QSi_Tempt_GND=(((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt_Tempt_GND)*Qs)+((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Tempt_GND));
#endif
QSi_Vgi_bi=((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vgi_bi);
#if defined(_DERIVATE2)
  QSi_Vgi_bi_Vdbulk_di=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vdbulk_di+((((0.0)*Leff)*Cox)*Vt)*Qs_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vgi_bi_Vdbulk_di);
  QSi_Vgi_bi_Vsbulk_si=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vsbulk_si+((((0.0)*Leff)*Cox)*Vt)*Qs_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vgi_bi_Vsbulk_si);
  QSi_Vgi_bi_Tempt_GND=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*Vt_Tempt_GND+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Tempt_GND+((((((0.0)*Leff)*Cox)*Vt)+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt_Tempt_GND)))*Qs_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vgi_bi_Tempt_GND);
  QSi_Vgi_bi_Vgi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vgi_bi+((((0.0)*Leff)*Cox)*Vt)*Qs_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vgi_bi_Vgi_bi);
  QSi_Vgi_bi_Vdi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vdi_bi+((((0.0)*Leff)*Cox)*Vt)*Qs_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vgi_bi_Vdi_bi);
  QSi_Vgi_bi_Vsi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vsi_bi+((((0.0)*Leff)*Cox)*Vt)*Qs_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vgi_bi_Vsi_bi);
#endif
QSi_Vdi_bi=((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vdi_bi);
#if defined(_DERIVATE2)
  QSi_Vdi_bi_Vdbulk_di=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vdbulk_di+((((0.0)*Leff)*Cox)*Vt)*Qs_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vdi_bi_Vdbulk_di);
  QSi_Vdi_bi_Vsbulk_si=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vsbulk_si+((((0.0)*Leff)*Cox)*Vt)*Qs_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vdi_bi_Vsbulk_si);
  QSi_Vdi_bi_Tempt_GND=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*Vt_Tempt_GND+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Tempt_GND+((((((0.0)*Leff)*Cox)*Vt)+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt_Tempt_GND)))*Qs_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vdi_bi_Tempt_GND);
  QSi_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vgi_bi+((((0.0)*Leff)*Cox)*Vt)*Qs_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vdi_bi_Vgi_bi);
  QSi_Vdi_bi_Vdi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vdi_bi+((((0.0)*Leff)*Cox)*Vt)*Qs_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vdi_bi_Vdi_bi);
  QSi_Vdi_bi_Vsi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vsi_bi+((((0.0)*Leff)*Cox)*Vt)*Qs_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vdi_bi_Vsi_bi);
#endif
QSi_Vsi_bi=((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vsi_bi);
#if defined(_DERIVATE2)
  QSi_Vsi_bi_Vdbulk_di=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vdbulk_di+((((0.0)*Leff)*Cox)*Vt)*Qs_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vsi_bi_Vdbulk_di);
  QSi_Vsi_bi_Vsbulk_si=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vsbulk_si+((((0.0)*Leff)*Cox)*Vt)*Qs_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vsi_bi_Vsbulk_si);
  QSi_Vsi_bi_Tempt_GND=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*Vt_Tempt_GND+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Tempt_GND+((((((0.0)*Leff)*Cox)*Vt)+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt_Tempt_GND)))*Qs_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vsi_bi_Tempt_GND);
  QSi_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vgi_bi+((((0.0)*Leff)*Cox)*Vt)*Qs_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vsi_bi_Vgi_bi);
  QSi_Vsi_bi_Vdi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vdi_bi+((((0.0)*Leff)*Cox)*Vt)*Qs_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vsi_bi_Vdi_bi);
  QSi_Vsi_bi_Vsi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qs+0.0*Qs_Vsi_bi+((((0.0)*Leff)*Cox)*Vt)*Qs_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs_Vsi_bi_Vsi_bi);
#endif
#endif
QSi=((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs);
EXIT_IF_ISNAN(((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qs))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
QDi_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  QDi_Vdbulk_di_Vdbulk_di=0.0;
  QDi_Vdbulk_di_Vsbulk_si=0.0;
  QDi_Vdbulk_di_Tempt_GND=0.0;
  QDi_Vdbulk_di_Vgi_bi=0.0;
  QDi_Vdbulk_di_Vdi_bi=0.0;
  QDi_Vdbulk_di_Vsi_bi=0.0;
#endif
QDi_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  QDi_Vsbulk_si_Vdbulk_di=0.0;
  QDi_Vsbulk_si_Vsbulk_si=0.0;
  QDi_Vsbulk_si_Tempt_GND=0.0;
  QDi_Vsbulk_si_Vgi_bi=0.0;
  QDi_Vsbulk_si_Vdi_bi=0.0;
  QDi_Vsbulk_si_Vsi_bi=0.0;
#endif
#if defined(_DERIVATE)
QDi_Tempt_GND=(((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt_Tempt_GND)*Qd)+((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Tempt_GND));
#endif
QDi_Vgi_bi=((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vgi_bi);
#if defined(_DERIVATE2)
  QDi_Vgi_bi_Vdbulk_di=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vdbulk_di+((((0.0)*Leff)*Cox)*Vt)*Qd_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vgi_bi_Vdbulk_di);
  QDi_Vgi_bi_Vsbulk_si=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vsbulk_si+((((0.0)*Leff)*Cox)*Vt)*Qd_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vgi_bi_Vsbulk_si);
  QDi_Vgi_bi_Tempt_GND=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*Vt_Tempt_GND+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Tempt_GND+((((((0.0)*Leff)*Cox)*Vt)+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt_Tempt_GND)))*Qd_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vgi_bi_Tempt_GND);
  QDi_Vgi_bi_Vgi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vgi_bi+((((0.0)*Leff)*Cox)*Vt)*Qd_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vgi_bi_Vgi_bi);
  QDi_Vgi_bi_Vdi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vdi_bi+((((0.0)*Leff)*Cox)*Vt)*Qd_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vgi_bi_Vdi_bi);
  QDi_Vgi_bi_Vsi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vsi_bi+((((0.0)*Leff)*Cox)*Vt)*Qd_Vgi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vgi_bi_Vsi_bi);
#endif
QDi_Vdi_bi=((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vdi_bi);
#if defined(_DERIVATE2)
  QDi_Vdi_bi_Vdbulk_di=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vdbulk_di+((((0.0)*Leff)*Cox)*Vt)*Qd_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vdi_bi_Vdbulk_di);
  QDi_Vdi_bi_Vsbulk_si=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vsbulk_si+((((0.0)*Leff)*Cox)*Vt)*Qd_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vdi_bi_Vsbulk_si);
  QDi_Vdi_bi_Tempt_GND=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*Vt_Tempt_GND+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Tempt_GND+((((((0.0)*Leff)*Cox)*Vt)+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt_Tempt_GND)))*Qd_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vdi_bi_Tempt_GND);
  QDi_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vgi_bi+((((0.0)*Leff)*Cox)*Vt)*Qd_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vdi_bi_Vgi_bi);
  QDi_Vdi_bi_Vdi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vdi_bi+((((0.0)*Leff)*Cox)*Vt)*Qd_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vdi_bi_Vdi_bi);
  QDi_Vdi_bi_Vsi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vsi_bi+((((0.0)*Leff)*Cox)*Vt)*Qd_Vdi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vdi_bi_Vsi_bi);
#endif
QDi_Vsi_bi=((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vsi_bi);
#if defined(_DERIVATE2)
  QDi_Vsi_bi_Vdbulk_di=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vdbulk_di+((((0.0)*Leff)*Cox)*Vt)*Qd_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vsi_bi_Vdbulk_di);
  QDi_Vsi_bi_Vsbulk_si=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vsbulk_si+((((0.0)*Leff)*Cox)*Vt)*Qd_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vsi_bi_Vsbulk_si);
  QDi_Vsi_bi_Tempt_GND=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*Vt_Tempt_GND+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Tempt_GND+((((((0.0)*Leff)*Cox)*Vt)+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt_Tempt_GND)))*Qd_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vsi_bi_Tempt_GND);
  QDi_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vgi_bi+((((0.0)*Leff)*Cox)*Vt)*Qd_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vsi_bi_Vgi_bi);
  QDi_Vsi_bi_Vdi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vdi_bi+((((0.0)*Leff)*Cox)*Vt)*Qd_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vsi_bi_Vdi_bi);
  QDi_Vsi_bi_Vsi_bi=(+(+(+(+(+0.0*Weff+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Leff+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Weff)*0.0)*Cox+0.0*0.0+((0.0)*Leff)*0.0+(((-pInst->NF)*Weff)*Leff)*0.0)*Vt+0.0*0.0+(((0.0)*Leff)*Cox)*0.0+((((-pInst->NF)*Weff)*Leff)*Cox)*0.0)*Qd+0.0*Qd_Vsi_bi+((((0.0)*Leff)*Cox)*Vt)*Qd_Vsi_bi+(((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd_Vsi_bi_Vsi_bi);
#endif
#endif
QDi=((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd);
EXIT_IF_ISNAN(((((((-pInst->NF)*Weff)*Leff)*Cox)*Vt)*Qd))
{
double m00_fabs(d00_fabs0,(QSi+QDi))
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(QSi+QDi))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=((ueff_Vgi_bi*d00_fabs0)+(ueff*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0*d00_fabs0+ueff_Vgi_bi*0.0+0.0*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff*0.0);
  T0_Vgi_bi_Vgm_si=(+0.0*d00_fabs0+ueff_Vgi_bi*0.0+0.0*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff*0.0);
  T0_Vgi_bi_Vdbulk_di=(+0.0*d00_fabs0+ueff_Vgi_bi*(QSi_Vdbulk_di+QDi_Vdbulk_di)*d10_fabs0+0.0*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vdbulk_di+QDi_Vdbulk_di)*(QSi_Vgi_bi+QDi_Vgi_bi)+d10_fabs0*(+QSi_Vgi_bi_Vdbulk_di+QDi_Vgi_bi_Vdbulk_di)));
  T0_Vgi_bi_Vsbulk_si=(+0.0*d00_fabs0+ueff_Vgi_bi*(QSi_Vsbulk_si+QDi_Vsbulk_si)*d10_fabs0+0.0*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vsbulk_si+QDi_Vsbulk_si)*(QSi_Vgi_bi+QDi_Vgi_bi)+d10_fabs0*(+QSi_Vgi_bi_Vsbulk_si+QDi_Vgi_bi_Vsbulk_si)));
  T0_Vgi_bi_Vgi_bi=(+ueff_Vgi_bi_Vgi_bi*d00_fabs0+ueff_Vgi_bi*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff_Vgi_bi*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vgi_bi+QDi_Vgi_bi)*(QSi_Vgi_bi+QDi_Vgi_bi)+d10_fabs0*(+QSi_Vgi_bi_Vgi_bi+QDi_Vgi_bi_Vgi_bi)));
  T0_Vgi_bi_Vdi_bi=(+ueff_Vgi_bi_Vdi_bi*d00_fabs0+ueff_Vgi_bi*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff_Vdi_bi*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vdi_bi+QDi_Vdi_bi)*(QSi_Vgi_bi+QDi_Vgi_bi)+d10_fabs0*(+QSi_Vgi_bi_Vdi_bi+QDi_Vgi_bi_Vdi_bi)));
  T0_Vgi_bi_Vsi_bi=(+ueff_Vgi_bi_Vsi_bi*d00_fabs0+ueff_Vgi_bi*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff_Vsi_bi*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vsi_bi+QDi_Vsi_bi)*(QSi_Vgi_bi+QDi_Vgi_bi)+d10_fabs0*(+QSi_Vgi_bi_Vsi_bi+QDi_Vgi_bi_Vsi_bi)));
  T0_Vgi_bi_Tempt_GND=(+ueff_Vgi_bi_Tempt_GND*d00_fabs0+ueff_Vgi_bi*(QSi_Tempt_GND+QDi_Tempt_GND)*d10_fabs0+ueff_Tempt_GND*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Tempt_GND+QDi_Tempt_GND)*(QSi_Vgi_bi+QDi_Vgi_bi)+d10_fabs0*(+QSi_Vgi_bi_Tempt_GND+QDi_Vgi_bi_Tempt_GND)));
#endif
T0_Vdi_bi=((ueff_Vdi_bi*d00_fabs0)+(ueff*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*d00_fabs0+ueff_Vdi_bi*0.0+0.0*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff*0.0);
  T0_Vdi_bi_Vgm_si=(+0.0*d00_fabs0+ueff_Vdi_bi*0.0+0.0*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff*0.0);
  T0_Vdi_bi_Vdbulk_di=(+0.0*d00_fabs0+ueff_Vdi_bi*(QSi_Vdbulk_di+QDi_Vdbulk_di)*d10_fabs0+0.0*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vdbulk_di+QDi_Vdbulk_di)*(QSi_Vdi_bi+QDi_Vdi_bi)+d10_fabs0*(+QSi_Vdi_bi_Vdbulk_di+QDi_Vdi_bi_Vdbulk_di)));
  T0_Vdi_bi_Vsbulk_si=(+0.0*d00_fabs0+ueff_Vdi_bi*(QSi_Vsbulk_si+QDi_Vsbulk_si)*d10_fabs0+0.0*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vsbulk_si+QDi_Vsbulk_si)*(QSi_Vdi_bi+QDi_Vdi_bi)+d10_fabs0*(+QSi_Vdi_bi_Vsbulk_si+QDi_Vdi_bi_Vsbulk_si)));
  T0_Vdi_bi_Vgi_bi=(+ueff_Vdi_bi_Vgi_bi*d00_fabs0+ueff_Vdi_bi*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff_Vgi_bi*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vgi_bi+QDi_Vgi_bi)*(QSi_Vdi_bi+QDi_Vdi_bi)+d10_fabs0*(+QSi_Vdi_bi_Vgi_bi+QDi_Vdi_bi_Vgi_bi)));
  T0_Vdi_bi_Vdi_bi=(+ueff_Vdi_bi_Vdi_bi*d00_fabs0+ueff_Vdi_bi*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff_Vdi_bi*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vdi_bi+QDi_Vdi_bi)*(QSi_Vdi_bi+QDi_Vdi_bi)+d10_fabs0*(+QSi_Vdi_bi_Vdi_bi+QDi_Vdi_bi_Vdi_bi)));
  T0_Vdi_bi_Vsi_bi=(+ueff_Vdi_bi_Vsi_bi*d00_fabs0+ueff_Vdi_bi*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff_Vsi_bi*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vsi_bi+QDi_Vsi_bi)*(QSi_Vdi_bi+QDi_Vdi_bi)+d10_fabs0*(+QSi_Vdi_bi_Vsi_bi+QDi_Vdi_bi_Vsi_bi)));
  T0_Vdi_bi_Tempt_GND=(+ueff_Vdi_bi_Tempt_GND*d00_fabs0+ueff_Vdi_bi*(QSi_Tempt_GND+QDi_Tempt_GND)*d10_fabs0+ueff_Tempt_GND*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Tempt_GND+QDi_Tempt_GND)*(QSi_Vdi_bi+QDi_Vdi_bi)+d10_fabs0*(+QSi_Vdi_bi_Tempt_GND+QDi_Vdi_bi_Tempt_GND)));
#endif
T0_Vsi_bi=((ueff_Vsi_bi*d00_fabs0)+(ueff*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*d00_fabs0+ueff_Vsi_bi*0.0+0.0*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff*0.0);
  T0_Vsi_bi_Vgm_si=(+0.0*d00_fabs0+ueff_Vsi_bi*0.0+0.0*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff*0.0);
  T0_Vsi_bi_Vdbulk_di=(+0.0*d00_fabs0+ueff_Vsi_bi*(QSi_Vdbulk_di+QDi_Vdbulk_di)*d10_fabs0+0.0*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vdbulk_di+QDi_Vdbulk_di)*(QSi_Vsi_bi+QDi_Vsi_bi)+d10_fabs0*(+QSi_Vsi_bi_Vdbulk_di+QDi_Vsi_bi_Vdbulk_di)));
  T0_Vsi_bi_Vsbulk_si=(+0.0*d00_fabs0+ueff_Vsi_bi*(QSi_Vsbulk_si+QDi_Vsbulk_si)*d10_fabs0+0.0*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vsbulk_si+QDi_Vsbulk_si)*(QSi_Vsi_bi+QDi_Vsi_bi)+d10_fabs0*(+QSi_Vsi_bi_Vsbulk_si+QDi_Vsi_bi_Vsbulk_si)));
  T0_Vsi_bi_Vgi_bi=(+ueff_Vsi_bi_Vgi_bi*d00_fabs0+ueff_Vsi_bi*(QSi_Vgi_bi+QDi_Vgi_bi)*d10_fabs0+ueff_Vgi_bi*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vgi_bi+QDi_Vgi_bi)*(QSi_Vsi_bi+QDi_Vsi_bi)+d10_fabs0*(+QSi_Vsi_bi_Vgi_bi+QDi_Vsi_bi_Vgi_bi)));
  T0_Vsi_bi_Vdi_bi=(+ueff_Vsi_bi_Vdi_bi*d00_fabs0+ueff_Vsi_bi*(QSi_Vdi_bi+QDi_Vdi_bi)*d10_fabs0+ueff_Vdi_bi*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vdi_bi+QDi_Vdi_bi)*(QSi_Vsi_bi+QDi_Vsi_bi)+d10_fabs0*(+QSi_Vsi_bi_Vdi_bi+QDi_Vsi_bi_Vdi_bi)));
  T0_Vsi_bi_Vsi_bi=(+ueff_Vsi_bi_Vsi_bi*d00_fabs0+ueff_Vsi_bi*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff_Vsi_bi*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Vsi_bi+QDi_Vsi_bi)*(QSi_Vsi_bi+QDi_Vsi_bi)+d10_fabs0*(+QSi_Vsi_bi_Vsi_bi+QDi_Vsi_bi_Vsi_bi)));
  T0_Vsi_bi_Tempt_GND=(+ueff_Vsi_bi_Tempt_GND*d00_fabs0+ueff_Vsi_bi*(QSi_Tempt_GND+QDi_Tempt_GND)*d10_fabs0+ueff_Tempt_GND*(QSi_Vsi_bi+QDi_Vsi_bi)*d10_fabs0+ueff*(m20_fabs((QSi+QDi))*(QSi_Tempt_GND+QDi_Tempt_GND)*(QSi_Vsi_bi+QDi_Vsi_bi)+d10_fabs0*(+QSi_Vsi_bi_Tempt_GND+QDi_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((ueff_Tempt_GND*d00_fabs0)+(ueff*(QSi_Tempt_GND+QDi_Tempt_GND)*d10_fabs0));
#endif
#endif
T0=(ueff*d00_fabs0);
EXIT_IF_ISNAN((ueff*d00_fabs0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=T0_Vdbulk_di*Rdsi;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+T0_Vdbulk_di_Vgm_di*Rdsi+T0_Vdbulk_di*0.0+T0_Vgm_di*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdbulk_di_Vgm_si=(+(+T0_Vdbulk_di_Vgm_si*Rdsi+T0_Vdbulk_di*0.0+T0_Vgm_si*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdbulk_di_Vdbulk_di=(+(+T0_Vdbulk_di_Vdbulk_di*Rdsi+T0_Vdbulk_di*0.0+T0_Vdbulk_di*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdbulk_di_Vsbulk_si=(+(+T0_Vdbulk_di_Vsbulk_si*Rdsi+T0_Vdbulk_di*0.0+T0_Vsbulk_si*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdbulk_di_Vgi_bi=(+(+T0_Vdbulk_di_Vgi_bi*Rdsi+T0_Vdbulk_di*Rdsi_Vgi_bi+T0_Vgi_bi*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdbulk_di_Vdi_bi=(+(+T0_Vdbulk_di_Vdi_bi*Rdsi+T0_Vdbulk_di*Rdsi_Vdi_bi+T0_Vdi_bi*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdbulk_di_Vsi_bi=(+(+T0_Vdbulk_di_Vsi_bi*Rdsi+T0_Vdbulk_di*Rdsi_Vsi_bi+T0_Vsi_bi*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdbulk_di_Tempt_GND=(+(+T0_Vdbulk_di_Tempt_GND*Rdsi+T0_Vdbulk_di*Rdsi_Tempt_GND+T0_Tempt_GND*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Vsbulk_si=T0_Vsbulk_si*Rdsi;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+T0_Vsbulk_si_Vgm_di*Rdsi+T0_Vsbulk_si*0.0+T0_Vgm_di*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsbulk_si_Vgm_si=(+(+T0_Vsbulk_si_Vgm_si*Rdsi+T0_Vsbulk_si*0.0+T0_Vgm_si*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsbulk_si_Vdbulk_di=(+(+T0_Vsbulk_si_Vdbulk_di*Rdsi+T0_Vsbulk_si*0.0+T0_Vdbulk_di*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsbulk_si_Vsbulk_si=(+(+T0_Vsbulk_si_Vsbulk_si*Rdsi+T0_Vsbulk_si*0.0+T0_Vsbulk_si*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsbulk_si_Vgi_bi=(+(+T0_Vsbulk_si_Vgi_bi*Rdsi+T0_Vsbulk_si*Rdsi_Vgi_bi+T0_Vgi_bi*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsbulk_si_Vdi_bi=(+(+T0_Vsbulk_si_Vdi_bi*Rdsi+T0_Vsbulk_si*Rdsi_Vdi_bi+T0_Vdi_bi*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsbulk_si_Vsi_bi=(+(+T0_Vsbulk_si_Vsi_bi*Rdsi+T0_Vsbulk_si*Rdsi_Vsi_bi+T0_Vsi_bi*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsbulk_si_Tempt_GND=(+(+T0_Vsbulk_si_Tempt_GND*Rdsi+T0_Vsbulk_si*Rdsi_Tempt_GND+T0_Tempt_GND*0.0+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Vgi_bi=((T0_Vgi_bi*Rdsi)+(T0*Rdsi_Vgi_bi));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+T0_Vgi_bi_Vgm_di*Rdsi+T0_Vgi_bi*0.0+T0_Vgm_di*Rdsi_Vgi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vgi_bi_Vgm_si=(+(+T0_Vgi_bi_Vgm_si*Rdsi+T0_Vgi_bi*0.0+T0_Vgm_si*Rdsi_Vgi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vgi_bi_Vdbulk_di=(+(+T0_Vgi_bi_Vdbulk_di*Rdsi+T0_Vgi_bi*0.0+T0_Vdbulk_di*Rdsi_Vgi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vgi_bi_Vsbulk_si=(+(+T0_Vgi_bi_Vsbulk_si*Rdsi+T0_Vgi_bi*0.0+T0_Vsbulk_si*Rdsi_Vgi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vgi_bi_Vgi_bi=(+(+T0_Vgi_bi_Vgi_bi*Rdsi+T0_Vgi_bi*Rdsi_Vgi_bi+T0_Vgi_bi*Rdsi_Vgi_bi+T0*Rdsi_Vgi_bi_Vgi_bi)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vgi_bi_Vdi_bi=(+(+T0_Vgi_bi_Vdi_bi*Rdsi+T0_Vgi_bi*Rdsi_Vdi_bi+T0_Vdi_bi*Rdsi_Vgi_bi+T0*Rdsi_Vgi_bi_Vdi_bi)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vgi_bi_Vsi_bi=(+(+T0_Vgi_bi_Vsi_bi*Rdsi+T0_Vgi_bi*Rdsi_Vsi_bi+T0_Vsi_bi*Rdsi_Vgi_bi+T0*Rdsi_Vgi_bi_Vsi_bi)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vgi_bi_Tempt_GND=(+(+T0_Vgi_bi_Tempt_GND*Rdsi+T0_Vgi_bi*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Vgi_bi+T0*Rdsi_Vgi_bi_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Vdi_bi=((T0_Vdi_bi*Rdsi)+(T0*Rdsi_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+T0_Vdi_bi_Vgm_di*Rdsi+T0_Vdi_bi*0.0+T0_Vgm_di*Rdsi_Vdi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_bi_Vgm_si=(+(+T0_Vdi_bi_Vgm_si*Rdsi+T0_Vdi_bi*0.0+T0_Vgm_si*Rdsi_Vdi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_bi_Vdbulk_di=(+(+T0_Vdi_bi_Vdbulk_di*Rdsi+T0_Vdi_bi*0.0+T0_Vdbulk_di*Rdsi_Vdi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_bi_Vsbulk_si=(+(+T0_Vdi_bi_Vsbulk_si*Rdsi+T0_Vdi_bi*0.0+T0_Vsbulk_si*Rdsi_Vdi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_bi_Vgi_bi=(+(+T0_Vdi_bi_Vgi_bi*Rdsi+T0_Vdi_bi*Rdsi_Vgi_bi+T0_Vgi_bi*Rdsi_Vdi_bi+T0*Rdsi_Vdi_bi_Vgi_bi)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_bi_Vdi_bi=(+(+T0_Vdi_bi_Vdi_bi*Rdsi+T0_Vdi_bi*Rdsi_Vdi_bi+T0_Vdi_bi*Rdsi_Vdi_bi+T0*Rdsi_Vdi_bi_Vdi_bi)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_bi_Vsi_bi=(+(+T0_Vdi_bi_Vsi_bi*Rdsi+T0_Vdi_bi*Rdsi_Vsi_bi+T0_Vsi_bi*Rdsi_Vdi_bi+T0*Rdsi_Vdi_bi_Vsi_bi)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_bi_Tempt_GND=(+(+T0_Vdi_bi_Tempt_GND*Rdsi+T0_Vdi_bi*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Vdi_bi+T0*Rdsi_Vdi_bi_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Vsi_bi=((T0_Vsi_bi*Rdsi)+(T0*Rdsi_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+T0_Vsi_bi_Vgm_di*Rdsi+T0_Vsi_bi*0.0+T0_Vgm_di*Rdsi_Vsi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsi_bi_Vgm_si=(+(+T0_Vsi_bi_Vgm_si*Rdsi+T0_Vsi_bi*0.0+T0_Vgm_si*Rdsi_Vsi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsi_bi_Vdbulk_di=(+(+T0_Vsi_bi_Vdbulk_di*Rdsi+T0_Vsi_bi*0.0+T0_Vdbulk_di*Rdsi_Vsi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsi_bi_Vsbulk_si=(+(+T0_Vsi_bi_Vsbulk_si*Rdsi+T0_Vsi_bi*0.0+T0_Vsbulk_si*Rdsi_Vsi_bi+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsi_bi_Vgi_bi=(+(+T0_Vsi_bi_Vgi_bi*Rdsi+T0_Vsi_bi*Rdsi_Vgi_bi+T0_Vgi_bi*Rdsi_Vsi_bi+T0*Rdsi_Vsi_bi_Vgi_bi)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsi_bi_Vdi_bi=(+(+T0_Vsi_bi_Vdi_bi*Rdsi+T0_Vsi_bi*Rdsi_Vdi_bi+T0_Vdi_bi*Rdsi_Vsi_bi+T0*Rdsi_Vsi_bi_Vdi_bi)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsi_bi_Vsi_bi=(+(+T0_Vsi_bi_Vsi_bi*Rdsi+T0_Vsi_bi*Rdsi_Vsi_bi+T0_Vsi_bi*Rdsi_Vsi_bi+T0*Rdsi_Vsi_bi_Vsi_bi)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vsi_bi_Tempt_GND=(+(+T0_Vsi_bi_Tempt_GND*Rdsi+T0_Vsi_bi*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Vsi_bi+T0*Rdsi_Vsi_bi_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((T0_Tempt_GND*Rdsi)+(T0*Rdsi_Tempt_GND));
#endif
#endif
T1=((T0*Rdsi)+(Leff*Leff));
EXIT_IF_ISNAN(((T0*Rdsi)+(Leff*Leff)))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Gtnoi_Vdbulk_di=((T0_Vdbulk_di*T1-T0*T1_Vdbulk_di)/T1/T1)*pModel->NTNOI;
Gtnoi_Vsbulk_si=((T0_Vsbulk_si*T1-T0*T1_Vsbulk_si)/T1/T1)*pModel->NTNOI;
Gtnoi_Vgi_bi=((T0_Vgi_bi*T1-T0*T1_Vgi_bi)/T1/T1)*pModel->NTNOI;
Gtnoi_Vdi_bi=((T0_Vdi_bi*T1-T0*T1_Vdi_bi)/T1/T1)*pModel->NTNOI;
Gtnoi_Vsi_bi=((T0_Vsi_bi*T1-T0*T1_Vsi_bi)/T1/T1)*pModel->NTNOI;
Gtnoi_Tempt_GND=((T0_Tempt_GND*T1-T0*T1_Tempt_GND)/T1/T1)*pModel->NTNOI;
#endif
Gtnoi=((T0/T1)*pModel->NTNOI);
EXIT_IF_ISNAN(((T0/T1)*pModel->NTNOI))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
sidn_Tempt_GND=((Nt_Tempt_GND*Gtnoi)+(Nt*Gtnoi_Tempt_GND));
sidn_Vdbulk_di=(Nt*Gtnoi_Vdbulk_di);
sidn_Vsbulk_si=(Nt*Gtnoi_Vsbulk_si);
sidn_Vgi_bi=(Nt*Gtnoi_Vgi_bi);
sidn_Vdi_bi=(Nt*Gtnoi_Vdi_bi);
sidn_Vsi_bi=(Nt*Gtnoi_Vsi_bi);
#endif
sidn=(Nt*Gtnoi);
EXIT_IF_ISNAN((Nt*Gtnoi))
pInst->wnoise14=sidn;
  _load_static_residual1(N1,0.0)
}
else
/* CASE ITEM */
if
(((pModel->TNOIMOD)==(1)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
Vtn_Vgi_bi=(((2.0*nq_Vgi_bi)*nVt)+((2.0*nq)*nVt_Vgi_bi));
#if defined(_DERIVATE2)
  Vtn_Vgi_bi_Vgi_bi=(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vgi_bi)*nVt+(2.0*nq_Vgi_bi)*nVt_Vgi_bi+((2.0*nq_Vgi_bi))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Vgi_bi);
  Vtn_Vgi_bi_Tempt_GND=(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Tempt_GND)*nVt+(2.0*nq_Vgi_bi)*nVt_Tempt_GND+((2.0*nq_Tempt_GND))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Tempt_GND);
  Vtn_Vgi_bi_Vdi_bi=(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdi_bi)*nVt+(2.0*nq_Vgi_bi)*nVt_Vdi_bi+((2.0*nq_Vdi_bi))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Vdi_bi);
  Vtn_Vgi_bi_Vsi_bi=(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsi_bi)*nVt+(2.0*nq_Vgi_bi)*nVt_Vsi_bi+((2.0*nq_Vsi_bi))*nVt_Vgi_bi+(2.0*nq)*nVt_Vgi_bi_Vsi_bi);
#endif
#if defined(_DERIVATE)
Vtn_Tempt_GND=(((2.0*nq_Tempt_GND)*nVt)+((2.0*nq)*nVt_Tempt_GND));
#endif
Vtn_Vdi_bi=(((2.0*nq_Vdi_bi)*nVt)+((2.0*nq)*nVt_Vdi_bi));
#if defined(_DERIVATE2)
  Vtn_Vdi_bi_Vgi_bi=(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vgi_bi)*nVt+(2.0*nq_Vdi_bi)*nVt_Vgi_bi+((2.0*nq_Vgi_bi))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Vgi_bi);
  Vtn_Vdi_bi_Tempt_GND=(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Tempt_GND)*nVt+(2.0*nq_Vdi_bi)*nVt_Tempt_GND+((2.0*nq_Tempt_GND))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Tempt_GND);
  Vtn_Vdi_bi_Vdi_bi=(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdi_bi)*nVt+(2.0*nq_Vdi_bi)*nVt_Vdi_bi+((2.0*nq_Vdi_bi))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Vdi_bi);
  Vtn_Vdi_bi_Vsi_bi=(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsi_bi)*nVt+(2.0*nq_Vdi_bi)*nVt_Vsi_bi+((2.0*nq_Vsi_bi))*nVt_Vdi_bi+(2.0*nq)*nVt_Vdi_bi_Vsi_bi);
#endif
Vtn_Vsi_bi=(((2.0*nq_Vsi_bi)*nVt)+((2.0*nq)*nVt_Vsi_bi));
#if defined(_DERIVATE2)
  Vtn_Vsi_bi_Vgi_bi=(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vgi_bi)*nVt+(2.0*nq_Vsi_bi)*nVt_Vgi_bi+((2.0*nq_Vgi_bi))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Vgi_bi);
  Vtn_Vsi_bi_Tempt_GND=(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Tempt_GND)*nVt+(2.0*nq_Vsi_bi)*nVt_Tempt_GND+((2.0*nq_Tempt_GND))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Tempt_GND);
  Vtn_Vsi_bi_Vdi_bi=(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdi_bi)*nVt+(2.0*nq_Vsi_bi)*nVt_Vdi_bi+((2.0*nq_Vdi_bi))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Vdi_bi);
  Vtn_Vsi_bi_Vsi_bi=(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsi_bi)*nVt+(2.0*nq_Vsi_bi)*nVt_Vsi_bi+((2.0*nq_Vsi_bi))*nVt_Vsi_bi+(2.0*nq)*nVt_Vsi_bi_Vsi_bi);
#endif
#endif
Vtn=((2.0*nq)*nVt);
EXIT_IF_ISNAN(((2.0*nq)*nVt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=((((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*Cox*Vtn)+((((ueff*Dptwg)*Moc)*Cox)*Vtn_Vgi_bi));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+(+(+(+0.0*Dptwg+ueff_Vgi_bi*0.0+0.0*Dptwg_Vgi_bi+ueff*0.0)*Moc+((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*0.0+(0.0)*Moc_Vgi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vgi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vgi_bi_Vgm_si=(+(+(+(+0.0*Dptwg+ueff_Vgi_bi*0.0+0.0*Dptwg_Vgi_bi+ueff*0.0)*Moc+((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*0.0+(0.0)*Moc_Vgi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vgi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vgi_bi_Vdbulk_di=(+(+(+(+0.0*Dptwg+ueff_Vgi_bi*0.0+0.0*Dptwg_Vgi_bi+ueff*0.0)*Moc+((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*0.0+(0.0)*Moc_Vgi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vgi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vgi_bi_Vsbulk_si=(+(+(+(+0.0*Dptwg+ueff_Vgi_bi*0.0+0.0*Dptwg_Vgi_bi+ueff*0.0)*Moc+((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*0.0+(0.0)*Moc_Vgi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vgi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vgi_bi_Vgi_bi=(+(+(+(+ueff_Vgi_bi_Vgi_bi*Dptwg+ueff_Vgi_bi*Dptwg_Vgi_bi+ueff_Vgi_bi*Dptwg_Vgi_bi+ueff*Dptwg_Vgi_bi_Vgi_bi)*Moc+((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc_Vgi_bi+(((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi)))*Moc_Vgi_bi+(ueff*Dptwg)*Moc_Vgi_bi_Vgi_bi)*Cox+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*0.0+((((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*Cox*Vtn_Vgi_bi+(((((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi)))*Cox)*Vtn_Vgi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vgi_bi_Vgi_bi);
  T0_Vgi_bi_Vdi_bi=(+(+(+(+ueff_Vgi_bi_Vdi_bi*Dptwg+ueff_Vgi_bi*Dptwg_Vdi_bi+ueff_Vdi_bi*Dptwg_Vgi_bi+ueff*Dptwg_Vgi_bi_Vdi_bi)*Moc+((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc_Vdi_bi+(((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi)))*Moc_Vgi_bi+(ueff*Dptwg)*Moc_Vgi_bi_Vdi_bi)*Cox+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*0.0+((((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*Cox*Vtn_Vdi_bi+(((((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi)))*Cox)*Vtn_Vgi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vgi_bi_Vdi_bi);
  T0_Vgi_bi_Vsi_bi=(+(+(+(+ueff_Vgi_bi_Vsi_bi*Dptwg+ueff_Vgi_bi*Dptwg_Vsi_bi+ueff_Vsi_bi*Dptwg_Vgi_bi+ueff*Dptwg_Vgi_bi_Vsi_bi)*Moc+((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc_Vsi_bi+(((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi)))*Moc_Vgi_bi+(ueff*Dptwg)*Moc_Vgi_bi_Vsi_bi)*Cox+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*0.0+((((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*Cox*Vtn_Vsi_bi+(((((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi)))*Cox)*Vtn_Vgi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vgi_bi_Vsi_bi);
  T0_Vgi_bi_Tempt_GND=(+(+(+(+ueff_Vgi_bi_Tempt_GND*Dptwg+ueff_Vgi_bi*Dptwg_Tempt_GND+ueff_Tempt_GND*Dptwg_Vgi_bi+ueff*Dptwg_Vgi_bi_Tempt_GND)*Moc+((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc_Tempt_GND+(((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND)))*Moc_Vgi_bi+(ueff*Dptwg)*Moc_Vgi_bi_Tempt_GND)*Cox+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*0.0+((((((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND)))*Moc)+((ueff*Dptwg)*Moc_Tempt_GND)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi))*Cox*Vtn_Tempt_GND+(((((((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND)))*Moc)+((ueff*Dptwg)*Moc_Tempt_GND)))*Cox)*Vtn_Vgi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vgi_bi_Tempt_GND);
#endif
T0_Vdi_bi=((((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*Cox*Vtn)+((((ueff*Dptwg)*Moc)*Cox)*Vtn_Vdi_bi));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+(+(+(+0.0*Dptwg+ueff_Vdi_bi*0.0+0.0*Dptwg_Vdi_bi+ueff*0.0)*Moc+((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*0.0+(0.0)*Moc_Vdi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vdi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vdi_bi_Vgm_si=(+(+(+(+0.0*Dptwg+ueff_Vdi_bi*0.0+0.0*Dptwg_Vdi_bi+ueff*0.0)*Moc+((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*0.0+(0.0)*Moc_Vdi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vdi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vdi_bi_Vdbulk_di=(+(+(+(+0.0*Dptwg+ueff_Vdi_bi*0.0+0.0*Dptwg_Vdi_bi+ueff*0.0)*Moc+((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*0.0+(0.0)*Moc_Vdi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vdi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vdi_bi_Vsbulk_si=(+(+(+(+0.0*Dptwg+ueff_Vdi_bi*0.0+0.0*Dptwg_Vdi_bi+ueff*0.0)*Moc+((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*0.0+(0.0)*Moc_Vdi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vdi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vdi_bi_Vgi_bi=(+(+(+(+ueff_Vdi_bi_Vgi_bi*Dptwg+ueff_Vdi_bi*Dptwg_Vgi_bi+ueff_Vgi_bi*Dptwg_Vdi_bi+ueff*Dptwg_Vdi_bi_Vgi_bi)*Moc+((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc_Vgi_bi+(((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi)))*Moc_Vdi_bi+(ueff*Dptwg)*Moc_Vdi_bi_Vgi_bi)*Cox+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*0.0+((((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*Cox*Vtn_Vgi_bi+(((((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi)))*Cox)*Vtn_Vdi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vdi_bi_Vgi_bi);
  T0_Vdi_bi_Vdi_bi=(+(+(+(+ueff_Vdi_bi_Vdi_bi*Dptwg+ueff_Vdi_bi*Dptwg_Vdi_bi+ueff_Vdi_bi*Dptwg_Vdi_bi+ueff*Dptwg_Vdi_bi_Vdi_bi)*Moc+((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc_Vdi_bi+(((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi)))*Moc_Vdi_bi+(ueff*Dptwg)*Moc_Vdi_bi_Vdi_bi)*Cox+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*0.0+((((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*Cox*Vtn_Vdi_bi+(((((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi)))*Cox)*Vtn_Vdi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vdi_bi_Vdi_bi);
  T0_Vdi_bi_Vsi_bi=(+(+(+(+ueff_Vdi_bi_Vsi_bi*Dptwg+ueff_Vdi_bi*Dptwg_Vsi_bi+ueff_Vsi_bi*Dptwg_Vdi_bi+ueff*Dptwg_Vdi_bi_Vsi_bi)*Moc+((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc_Vsi_bi+(((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi)))*Moc_Vdi_bi+(ueff*Dptwg)*Moc_Vdi_bi_Vsi_bi)*Cox+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*0.0+((((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*Cox*Vtn_Vsi_bi+(((((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi)))*Cox)*Vtn_Vdi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vdi_bi_Vsi_bi);
  T0_Vdi_bi_Tempt_GND=(+(+(+(+ueff_Vdi_bi_Tempt_GND*Dptwg+ueff_Vdi_bi*Dptwg_Tempt_GND+ueff_Tempt_GND*Dptwg_Vdi_bi+ueff*Dptwg_Vdi_bi_Tempt_GND)*Moc+((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc_Tempt_GND+(((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND)))*Moc_Vdi_bi+(ueff*Dptwg)*Moc_Vdi_bi_Tempt_GND)*Cox+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*0.0+((((((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND)))*Moc)+((ueff*Dptwg)*Moc_Tempt_GND)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi))*Cox*Vtn_Tempt_GND+(((((((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND)))*Moc)+((ueff*Dptwg)*Moc_Tempt_GND)))*Cox)*Vtn_Vdi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vdi_bi_Tempt_GND);
#endif
T0_Vsi_bi=((((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*Cox*Vtn)+((((ueff*Dptwg)*Moc)*Cox)*Vtn_Vsi_bi));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+(+(+(+0.0*Dptwg+ueff_Vsi_bi*0.0+0.0*Dptwg_Vsi_bi+ueff*0.0)*Moc+((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*0.0+(0.0)*Moc_Vsi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vsi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vsi_bi_Vgm_si=(+(+(+(+0.0*Dptwg+ueff_Vsi_bi*0.0+0.0*Dptwg_Vsi_bi+ueff*0.0)*Moc+((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*0.0+(0.0)*Moc_Vsi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vsi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vsi_bi_Vdbulk_di=(+(+(+(+0.0*Dptwg+ueff_Vsi_bi*0.0+0.0*Dptwg_Vsi_bi+ueff*0.0)*Moc+((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*0.0+(0.0)*Moc_Vsi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vsi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vsi_bi_Vsbulk_si=(+(+(+(+0.0*Dptwg+ueff_Vsi_bi*0.0+0.0*Dptwg_Vsi_bi+ueff*0.0)*Moc+((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*0.0+(0.0)*Moc_Vsi_bi+(ueff*Dptwg)*0.0)*Cox+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*0.0+((0.0)*Moc)*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*Cox*0.0+(((0.0)*Moc)*Cox)*Vtn_Vsi_bi+(((ueff*Dptwg)*Moc)*Cox)*0.0);
  T0_Vsi_bi_Vgi_bi=(+(+(+(+ueff_Vsi_bi_Vgi_bi*Dptwg+ueff_Vsi_bi*Dptwg_Vgi_bi+ueff_Vgi_bi*Dptwg_Vsi_bi+ueff*Dptwg_Vsi_bi_Vgi_bi)*Moc+((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc_Vgi_bi+(((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi)))*Moc_Vsi_bi+(ueff*Dptwg)*Moc_Vsi_bi_Vgi_bi)*Cox+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*0.0+((((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*Cox*Vtn_Vgi_bi+(((((((ueff_Vgi_bi*Dptwg)+(ueff*Dptwg_Vgi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vgi_bi)))*Cox)*Vtn_Vsi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vsi_bi_Vgi_bi);
  T0_Vsi_bi_Vdi_bi=(+(+(+(+ueff_Vsi_bi_Vdi_bi*Dptwg+ueff_Vsi_bi*Dptwg_Vdi_bi+ueff_Vdi_bi*Dptwg_Vsi_bi+ueff*Dptwg_Vsi_bi_Vdi_bi)*Moc+((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc_Vdi_bi+(((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi)))*Moc_Vsi_bi+(ueff*Dptwg)*Moc_Vsi_bi_Vdi_bi)*Cox+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*0.0+((((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*Cox*Vtn_Vdi_bi+(((((((ueff_Vdi_bi*Dptwg)+(ueff*Dptwg_Vdi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vdi_bi)))*Cox)*Vtn_Vsi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vsi_bi_Vdi_bi);
  T0_Vsi_bi_Vsi_bi=(+(+(+(+ueff_Vsi_bi_Vsi_bi*Dptwg+ueff_Vsi_bi*Dptwg_Vsi_bi+ueff_Vsi_bi*Dptwg_Vsi_bi+ueff*Dptwg_Vsi_bi_Vsi_bi)*Moc+((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc_Vsi_bi+(((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi)))*Moc_Vsi_bi+(ueff*Dptwg)*Moc_Vsi_bi_Vsi_bi)*Cox+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*0.0+((((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*Cox*Vtn_Vsi_bi+(((((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi)))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi)))*Cox)*Vtn_Vsi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vsi_bi_Vsi_bi);
  T0_Vsi_bi_Tempt_GND=(+(+(+(+ueff_Vsi_bi_Tempt_GND*Dptwg+ueff_Vsi_bi*Dptwg_Tempt_GND+ueff_Tempt_GND*Dptwg_Vsi_bi+ueff*Dptwg_Vsi_bi_Tempt_GND)*Moc+((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc_Tempt_GND+(((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND)))*Moc_Vsi_bi+(ueff*Dptwg)*Moc_Vsi_bi_Tempt_GND)*Cox+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*0.0+((((((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND)))*Moc)+((ueff*Dptwg)*Moc_Tempt_GND)))*0.0+((ueff*Dptwg)*Moc)*0.0)*Vtn+((((ueff_Vsi_bi*Dptwg)+(ueff*Dptwg_Vsi_bi))*Moc)+((ueff*Dptwg)*Moc_Vsi_bi))*Cox*Vtn_Tempt_GND+(((((((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND)))*Moc)+((ueff*Dptwg)*Moc_Tempt_GND)))*Cox)*Vtn_Vsi_bi+(((ueff*Dptwg)*Moc)*Cox)*Vtn_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((((((ueff_Tempt_GND*Dptwg)+(ueff*Dptwg_Tempt_GND))*Moc)+((ueff*Dptwg)*Moc_Tempt_GND))*Cox*Vtn)+((((ueff*Dptwg)*Moc)*Cox)*Vtn_Tempt_GND));
#endif
#endif
T0=((((ueff*Dptwg)*Moc)*Cox)*Vtn);
EXIT_IF_ISNAN(((((ueff*Dptwg)*Moc)*Cox)*Vtn))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=(0.5*(qs_Vgi_bi+qdeff_Vgi_bi));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0*(qs+qdeff)+0.0*(qs_Vgm_di+qdeff_Vgm_di)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.5*(+qs_Vgi_bi_Vgm_di+qdeff_Vgi_bi_Vgm_di));
  T1_Vgi_bi_Vgm_si=(+0.0*(qs+qdeff)+0.0*(qs_Vgm_si+qdeff_Vgm_si)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.5*(+qs_Vgi_bi_Vgm_si+qdeff_Vgi_bi_Vgm_si));
  T1_Vgi_bi_Vdbulk_di=(+0.0*(qs+qdeff)+0.0*(qs_Vdbulk_di+qdeff_Vdbulk_di)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.5*(+qs_Vgi_bi_Vdbulk_di+qdeff_Vgi_bi_Vdbulk_di));
  T1_Vgi_bi_Vsbulk_si=(+0.0*(qs+qdeff)+0.0*(qs_Vsbulk_si+qdeff_Vsbulk_si)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.5*(+qs_Vgi_bi_Vsbulk_si+qdeff_Vgi_bi_Vsbulk_si));
  T1_Vgi_bi_Vgi_bi=(+0.0*(qs+qdeff)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.5*(+qs_Vgi_bi_Vgi_bi+qdeff_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+0.0*(qs+qdeff)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.5*(+qs_Vgi_bi_Vdi_bi+qdeff_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+0.0*(qs+qdeff)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.5*(+qs_Vgi_bi_Vsi_bi+qdeff_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+0.0*(qs+qdeff)+0.0*(qs_Tempt_GND+qdeff_Tempt_GND)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.5*(+qs_Vgi_bi_Tempt_GND+qdeff_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(0.5*(qs_Vdi_bi+qdeff_Vdi_bi));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*(qs+qdeff)+0.0*(qs_Vgm_di+qdeff_Vgm_di)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.5*(+qs_Vdi_bi_Vgm_di+qdeff_Vdi_bi_Vgm_di));
  T1_Vdi_bi_Vgm_si=(+0.0*(qs+qdeff)+0.0*(qs_Vgm_si+qdeff_Vgm_si)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.5*(+qs_Vdi_bi_Vgm_si+qdeff_Vdi_bi_Vgm_si));
  T1_Vdi_bi_Vdbulk_di=(+0.0*(qs+qdeff)+0.0*(qs_Vdbulk_di+qdeff_Vdbulk_di)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.5*(+qs_Vdi_bi_Vdbulk_di+qdeff_Vdi_bi_Vdbulk_di));
  T1_Vdi_bi_Vsbulk_si=(+0.0*(qs+qdeff)+0.0*(qs_Vsbulk_si+qdeff_Vsbulk_si)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.5*(+qs_Vdi_bi_Vsbulk_si+qdeff_Vdi_bi_Vsbulk_si));
  T1_Vdi_bi_Vgi_bi=(+0.0*(qs+qdeff)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.5*(+qs_Vdi_bi_Vgi_bi+qdeff_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+0.0*(qs+qdeff)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.5*(+qs_Vdi_bi_Vdi_bi+qdeff_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+0.0*(qs+qdeff)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.5*(+qs_Vdi_bi_Vsi_bi+qdeff_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+0.0*(qs+qdeff)+0.0*(qs_Tempt_GND+qdeff_Tempt_GND)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.5*(+qs_Vdi_bi_Tempt_GND+qdeff_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(0.5*(qs_Vsi_bi+qdeff_Vsi_bi));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*(qs+qdeff)+0.0*(qs_Vgm_di+qdeff_Vgm_di)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.5*(+qs_Vsi_bi_Vgm_di+qdeff_Vsi_bi_Vgm_di));
  T1_Vsi_bi_Vgm_si=(+0.0*(qs+qdeff)+0.0*(qs_Vgm_si+qdeff_Vgm_si)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.5*(+qs_Vsi_bi_Vgm_si+qdeff_Vsi_bi_Vgm_si));
  T1_Vsi_bi_Vdbulk_di=(+0.0*(qs+qdeff)+0.0*(qs_Vdbulk_di+qdeff_Vdbulk_di)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.5*(+qs_Vsi_bi_Vdbulk_di+qdeff_Vsi_bi_Vdbulk_di));
  T1_Vsi_bi_Vsbulk_si=(+0.0*(qs+qdeff)+0.0*(qs_Vsbulk_si+qdeff_Vsbulk_si)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.5*(+qs_Vsi_bi_Vsbulk_si+qdeff_Vsi_bi_Vsbulk_si));
  T1_Vsi_bi_Vgi_bi=(+0.0*(qs+qdeff)+0.0*(qs_Vgi_bi+qdeff_Vgi_bi)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.5*(+qs_Vsi_bi_Vgi_bi+qdeff_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+0.0*(qs+qdeff)+0.0*(qs_Vdi_bi+qdeff_Vdi_bi)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.5*(+qs_Vsi_bi_Vdi_bi+qdeff_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+0.0*(qs+qdeff)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.5*(+qs_Vsi_bi_Vsi_bi+qdeff_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+0.0*(qs+qdeff)+0.0*(qs_Tempt_GND+qdeff_Tempt_GND)+0.0*(qs_Vsi_bi+qdeff_Vsi_bi)+0.5*(+qs_Vsi_bi_Tempt_GND+qdeff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(0.5*(qs_Tempt_GND+qdeff_Tempt_GND));
#endif
#endif
T1=(0.5*(qs+qdeff));
EXIT_IF_ISNAN((0.5*(qs+qdeff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=T1_Vdbulk_di;
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T1_Vdbulk_di_Vgm_si+0.0);
  T3_Vdbulk_di_Vgm_di=(+T1_Vdbulk_di_Vgm_di+0.0);
  T3_Vdbulk_di_Vdbulk_di=(+T1_Vdbulk_di_Vdbulk_di+0.0);
  T3_Vdbulk_di_Vsbulk_si=(+T1_Vdbulk_di_Vsbulk_si+0.0);
  T3_Vdbulk_di_Vgi_bi=(+T1_Vdbulk_di_Vgi_bi+0.0);
  T3_Vdbulk_di_Vdi_bi=(+T1_Vdbulk_di_Vdi_bi+0.0);
  T3_Vdbulk_di_Vsi_bi=(+T1_Vdbulk_di_Vsi_bi+0.0);
  T3_Vdbulk_di_Tempt_GND=(+T1_Vdbulk_di_Tempt_GND+0.0);
#endif
T3_Vsbulk_si=T1_Vsbulk_si;
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T1_Vsbulk_si_Vgm_si+0.0);
  T3_Vsbulk_si_Vgm_di=(+T1_Vsbulk_si_Vgm_di+0.0);
  T3_Vsbulk_si_Vdbulk_di=(+T1_Vsbulk_si_Vdbulk_di+0.0);
  T3_Vsbulk_si_Vsbulk_si=(+T1_Vsbulk_si_Vsbulk_si+0.0);
  T3_Vsbulk_si_Vgi_bi=(+T1_Vsbulk_si_Vgi_bi+0.0);
  T3_Vsbulk_si_Vdi_bi=(+T1_Vsbulk_si_Vdi_bi+0.0);
  T3_Vsbulk_si_Vsi_bi=(+T1_Vsbulk_si_Vsi_bi+0.0);
  T3_Vsbulk_si_Tempt_GND=(+T1_Vsbulk_si_Tempt_GND+0.0);
#endif
T3_Vgi_bi=T1_Vgi_bi;
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si+0.0);
  T3_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di+0.0);
  T3_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di+0.0);
  T3_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si+0.0);
  T3_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi+0.0);
  T3_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi+0.0);
  T3_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi+0.0);
  T3_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND+0.0);
#endif
T3_Vdi_bi=T1_Vdi_bi;
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si+0.0);
  T3_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di+0.0);
  T3_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di+0.0);
  T3_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si+0.0);
  T3_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi+0.0);
  T3_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi+0.0);
  T3_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi+0.0);
  T3_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND+0.0);
#endif
T3_Vsi_bi=T1_Vsi_bi;
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si+0.0);
  T3_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di+0.0);
  T3_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di+0.0);
  T3_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si+0.0);
  T3_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi+0.0);
  T3_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi+0.0);
  T3_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi+0.0);
  T3_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND+0.0);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=T1_Tempt_GND;
#endif
#endif
T3=(T1+0.5);
EXIT_IF_ISNAN((T1+0.5))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di));
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si*T3+T3_Vdbulk_di*T3_Vgm_si+T3_Vgm_si*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di*T3+T3_Vdbulk_di*T3_Vgm_di+T3_Vgm_di*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di*T3+T3_Vdbulk_di*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si*T3+T3_Vdbulk_di*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi*T3+T3_Vdbulk_di*T3_Vgi_bi+T3_Vgi_bi*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi*T3+T3_Vdbulk_di*T3_Vdi_bi+T3_Vdi_bi*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi*T3+T3_Vdbulk_di*T3_Vsi_bi+T3_Vsi_bi*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND*T3+T3_Vdbulk_di*T3_Tempt_GND+T3_Tempt_GND*T3_Vdbulk_di+T3*T3_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si));
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si*T3+T3_Vsbulk_si*T3_Vgm_si+T3_Vgm_si*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di*T3+T3_Vsbulk_si*T3_Vgm_di+T3_Vgm_di*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di*T3+T3_Vsbulk_si*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si*T3+T3_Vsbulk_si*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi*T3+T3_Vsbulk_si*T3_Vgi_bi+T3_Vgi_bi*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi*T3+T3_Vsbulk_si*T3_Vdi_bi+T3_Vdi_bi*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi*T3+T3_Vsbulk_si*T3_Vsi_bi+T3_Vsi_bi*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND*T3+T3_Vsbulk_si*T3_Tempt_GND+T3_Tempt_GND*T3_Vsbulk_si+T3*T3_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si*T3+T3_Vgi_bi*T3_Vgm_si+T3_Vgm_si*T3_Vgi_bi+T3*T3_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di*T3+T3_Vgi_bi*T3_Vgm_di+T3_Vgm_di*T3_Vgi_bi+T3*T3_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di*T3+T3_Vgi_bi*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vgi_bi+T3*T3_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si*T3+T3_Vgi_bi*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vgi_bi+T3*T3_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi*T3+T3_Vgi_bi*T3_Vgi_bi+T3_Vgi_bi*T3_Vgi_bi+T3*T3_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi*T3+T3_Vgi_bi*T3_Vdi_bi+T3_Vdi_bi*T3_Vgi_bi+T3*T3_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi*T3+T3_Vgi_bi*T3_Vsi_bi+T3_Vsi_bi*T3_Vgi_bi+T3*T3_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND*T3+T3_Vgi_bi*T3_Tempt_GND+T3_Tempt_GND*T3_Vgi_bi+T3*T3_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si*T3+T3_Vdi_bi*T3_Vgm_si+T3_Vgm_si*T3_Vdi_bi+T3*T3_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di*T3+T3_Vdi_bi*T3_Vgm_di+T3_Vgm_di*T3_Vdi_bi+T3*T3_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di*T3+T3_Vdi_bi*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vdi_bi+T3*T3_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si*T3+T3_Vdi_bi*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vdi_bi+T3*T3_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi*T3+T3_Vdi_bi*T3_Vgi_bi+T3_Vgi_bi*T3_Vdi_bi+T3*T3_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi*T3+T3_Vdi_bi*T3_Vdi_bi+T3_Vdi_bi*T3_Vdi_bi+T3*T3_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi*T3+T3_Vdi_bi*T3_Vsi_bi+T3_Vsi_bi*T3_Vdi_bi+T3*T3_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND*T3+T3_Vdi_bi*T3_Tempt_GND+T3_Tempt_GND*T3_Vdi_bi+T3*T3_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si*T3+T3_Vsi_bi*T3_Vgm_si+T3_Vgm_si*T3_Vsi_bi+T3*T3_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di*T3+T3_Vsi_bi*T3_Vgm_di+T3_Vgm_di*T3_Vsi_bi+T3*T3_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di*T3+T3_Vsi_bi*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vsi_bi+T3*T3_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si*T3+T3_Vsi_bi*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vsi_bi+T3*T3_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi*T3+T3_Vsi_bi*T3_Vgi_bi+T3_Vgi_bi*T3_Vsi_bi+T3*T3_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi*T3+T3_Vsi_bi*T3_Vdi_bi+T3_Vdi_bi*T3_Vsi_bi+T3*T3_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi*T3+T3_Vsi_bi*T3_Vsi_bi+T3_Vsi_bi*T3_Vsi_bi+T3*T3_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND*T3+T3_Vsi_bi*T3_Tempt_GND+T3_Tempt_GND*T3_Vsi_bi+T3*T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND));
#endif
#endif
T4=(T3*T3);
EXIT_IF_ISNAN((T3*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=((T4_Vdbulk_di*T3)+(T4*T3_Vdbulk_di));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+T4_Vdbulk_di_Vgm_si*T3+T4_Vdbulk_di*T3_Vgm_si+T4_Vgm_si*T3_Vdbulk_di+T4*T3_Vdbulk_di_Vgm_si);
  T5_Vdbulk_di_Vgm_di=(+T4_Vdbulk_di_Vgm_di*T3+T4_Vdbulk_di*T3_Vgm_di+T4_Vgm_di*T3_Vdbulk_di+T4*T3_Vdbulk_di_Vgm_di);
  T5_Vdbulk_di_Vdbulk_di=(+T4_Vdbulk_di_Vdbulk_di*T3+T4_Vdbulk_di*T3_Vdbulk_di+T4_Vdbulk_di*T3_Vdbulk_di+T4*T3_Vdbulk_di_Vdbulk_di);
  T5_Vdbulk_di_Vsbulk_si=(+T4_Vdbulk_di_Vsbulk_si*T3+T4_Vdbulk_di*T3_Vsbulk_si+T4_Vsbulk_si*T3_Vdbulk_di+T4*T3_Vdbulk_di_Vsbulk_si);
  T5_Vdbulk_di_Vgi_bi=(+T4_Vdbulk_di_Vgi_bi*T3+T4_Vdbulk_di*T3_Vgi_bi+T4_Vgi_bi*T3_Vdbulk_di+T4*T3_Vdbulk_di_Vgi_bi);
  T5_Vdbulk_di_Vdi_bi=(+T4_Vdbulk_di_Vdi_bi*T3+T4_Vdbulk_di*T3_Vdi_bi+T4_Vdi_bi*T3_Vdbulk_di+T4*T3_Vdbulk_di_Vdi_bi);
  T5_Vdbulk_di_Vsi_bi=(+T4_Vdbulk_di_Vsi_bi*T3+T4_Vdbulk_di*T3_Vsi_bi+T4_Vsi_bi*T3_Vdbulk_di+T4*T3_Vdbulk_di_Vsi_bi);
  T5_Vdbulk_di_Tempt_GND=(+T4_Vdbulk_di_Tempt_GND*T3+T4_Vdbulk_di*T3_Tempt_GND+T4_Tempt_GND*T3_Vdbulk_di+T4*T3_Vdbulk_di_Tempt_GND);
#endif
T5_Vsbulk_si=((T4_Vsbulk_si*T3)+(T4*T3_Vsbulk_si));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+T4_Vsbulk_si_Vgm_si*T3+T4_Vsbulk_si*T3_Vgm_si+T4_Vgm_si*T3_Vsbulk_si+T4*T3_Vsbulk_si_Vgm_si);
  T5_Vsbulk_si_Vgm_di=(+T4_Vsbulk_si_Vgm_di*T3+T4_Vsbulk_si*T3_Vgm_di+T4_Vgm_di*T3_Vsbulk_si+T4*T3_Vsbulk_si_Vgm_di);
  T5_Vsbulk_si_Vdbulk_di=(+T4_Vsbulk_si_Vdbulk_di*T3+T4_Vsbulk_si*T3_Vdbulk_di+T4_Vdbulk_di*T3_Vsbulk_si+T4*T3_Vsbulk_si_Vdbulk_di);
  T5_Vsbulk_si_Vsbulk_si=(+T4_Vsbulk_si_Vsbulk_si*T3+T4_Vsbulk_si*T3_Vsbulk_si+T4_Vsbulk_si*T3_Vsbulk_si+T4*T3_Vsbulk_si_Vsbulk_si);
  T5_Vsbulk_si_Vgi_bi=(+T4_Vsbulk_si_Vgi_bi*T3+T4_Vsbulk_si*T3_Vgi_bi+T4_Vgi_bi*T3_Vsbulk_si+T4*T3_Vsbulk_si_Vgi_bi);
  T5_Vsbulk_si_Vdi_bi=(+T4_Vsbulk_si_Vdi_bi*T3+T4_Vsbulk_si*T3_Vdi_bi+T4_Vdi_bi*T3_Vsbulk_si+T4*T3_Vsbulk_si_Vdi_bi);
  T5_Vsbulk_si_Vsi_bi=(+T4_Vsbulk_si_Vsi_bi*T3+T4_Vsbulk_si*T3_Vsi_bi+T4_Vsi_bi*T3_Vsbulk_si+T4*T3_Vsbulk_si_Vsi_bi);
  T5_Vsbulk_si_Tempt_GND=(+T4_Vsbulk_si_Tempt_GND*T3+T4_Vsbulk_si*T3_Tempt_GND+T4_Tempt_GND*T3_Vsbulk_si+T4*T3_Vsbulk_si_Tempt_GND);
#endif
T5_Vgi_bi=((T4_Vgi_bi*T3)+(T4*T3_Vgi_bi));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+T4_Vgi_bi_Vgm_si*T3+T4_Vgi_bi*T3_Vgm_si+T4_Vgm_si*T3_Vgi_bi+T4*T3_Vgi_bi_Vgm_si);
  T5_Vgi_bi_Vgm_di=(+T4_Vgi_bi_Vgm_di*T3+T4_Vgi_bi*T3_Vgm_di+T4_Vgm_di*T3_Vgi_bi+T4*T3_Vgi_bi_Vgm_di);
  T5_Vgi_bi_Vdbulk_di=(+T4_Vgi_bi_Vdbulk_di*T3+T4_Vgi_bi*T3_Vdbulk_di+T4_Vdbulk_di*T3_Vgi_bi+T4*T3_Vgi_bi_Vdbulk_di);
  T5_Vgi_bi_Vsbulk_si=(+T4_Vgi_bi_Vsbulk_si*T3+T4_Vgi_bi*T3_Vsbulk_si+T4_Vsbulk_si*T3_Vgi_bi+T4*T3_Vgi_bi_Vsbulk_si);
  T5_Vgi_bi_Vgi_bi=(+T4_Vgi_bi_Vgi_bi*T3+T4_Vgi_bi*T3_Vgi_bi+T4_Vgi_bi*T3_Vgi_bi+T4*T3_Vgi_bi_Vgi_bi);
  T5_Vgi_bi_Vdi_bi=(+T4_Vgi_bi_Vdi_bi*T3+T4_Vgi_bi*T3_Vdi_bi+T4_Vdi_bi*T3_Vgi_bi+T4*T3_Vgi_bi_Vdi_bi);
  T5_Vgi_bi_Vsi_bi=(+T4_Vgi_bi_Vsi_bi*T3+T4_Vgi_bi*T3_Vsi_bi+T4_Vsi_bi*T3_Vgi_bi+T4*T3_Vgi_bi_Vsi_bi);
  T5_Vgi_bi_Tempt_GND=(+T4_Vgi_bi_Tempt_GND*T3+T4_Vgi_bi*T3_Tempt_GND+T4_Tempt_GND*T3_Vgi_bi+T4*T3_Vgi_bi_Tempt_GND);
#endif
T5_Vdi_bi=((T4_Vdi_bi*T3)+(T4*T3_Vdi_bi));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+T4_Vdi_bi_Vgm_si*T3+T4_Vdi_bi*T3_Vgm_si+T4_Vgm_si*T3_Vdi_bi+T4*T3_Vdi_bi_Vgm_si);
  T5_Vdi_bi_Vgm_di=(+T4_Vdi_bi_Vgm_di*T3+T4_Vdi_bi*T3_Vgm_di+T4_Vgm_di*T3_Vdi_bi+T4*T3_Vdi_bi_Vgm_di);
  T5_Vdi_bi_Vdbulk_di=(+T4_Vdi_bi_Vdbulk_di*T3+T4_Vdi_bi*T3_Vdbulk_di+T4_Vdbulk_di*T3_Vdi_bi+T4*T3_Vdi_bi_Vdbulk_di);
  T5_Vdi_bi_Vsbulk_si=(+T4_Vdi_bi_Vsbulk_si*T3+T4_Vdi_bi*T3_Vsbulk_si+T4_Vsbulk_si*T3_Vdi_bi+T4*T3_Vdi_bi_Vsbulk_si);
  T5_Vdi_bi_Vgi_bi=(+T4_Vdi_bi_Vgi_bi*T3+T4_Vdi_bi*T3_Vgi_bi+T4_Vgi_bi*T3_Vdi_bi+T4*T3_Vdi_bi_Vgi_bi);
  T5_Vdi_bi_Vdi_bi=(+T4_Vdi_bi_Vdi_bi*T3+T4_Vdi_bi*T3_Vdi_bi+T4_Vdi_bi*T3_Vdi_bi+T4*T3_Vdi_bi_Vdi_bi);
  T5_Vdi_bi_Vsi_bi=(+T4_Vdi_bi_Vsi_bi*T3+T4_Vdi_bi*T3_Vsi_bi+T4_Vsi_bi*T3_Vdi_bi+T4*T3_Vdi_bi_Vsi_bi);
  T5_Vdi_bi_Tempt_GND=(+T4_Vdi_bi_Tempt_GND*T3+T4_Vdi_bi*T3_Tempt_GND+T4_Tempt_GND*T3_Vdi_bi+T4*T3_Vdi_bi_Tempt_GND);
#endif
T5_Vsi_bi=((T4_Vsi_bi*T3)+(T4*T3_Vsi_bi));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+T4_Vsi_bi_Vgm_si*T3+T4_Vsi_bi*T3_Vgm_si+T4_Vgm_si*T3_Vsi_bi+T4*T3_Vsi_bi_Vgm_si);
  T5_Vsi_bi_Vgm_di=(+T4_Vsi_bi_Vgm_di*T3+T4_Vsi_bi*T3_Vgm_di+T4_Vgm_di*T3_Vsi_bi+T4*T3_Vsi_bi_Vgm_di);
  T5_Vsi_bi_Vdbulk_di=(+T4_Vsi_bi_Vdbulk_di*T3+T4_Vsi_bi*T3_Vdbulk_di+T4_Vdbulk_di*T3_Vsi_bi+T4*T3_Vsi_bi_Vdbulk_di);
  T5_Vsi_bi_Vsbulk_si=(+T4_Vsi_bi_Vsbulk_si*T3+T4_Vsi_bi*T3_Vsbulk_si+T4_Vsbulk_si*T3_Vsi_bi+T4*T3_Vsi_bi_Vsbulk_si);
  T5_Vsi_bi_Vgi_bi=(+T4_Vsi_bi_Vgi_bi*T3+T4_Vsi_bi*T3_Vgi_bi+T4_Vgi_bi*T3_Vsi_bi+T4*T3_Vsi_bi_Vgi_bi);
  T5_Vsi_bi_Vdi_bi=(+T4_Vsi_bi_Vdi_bi*T3+T4_Vsi_bi*T3_Vdi_bi+T4_Vdi_bi*T3_Vsi_bi+T4*T3_Vsi_bi_Vdi_bi);
  T5_Vsi_bi_Vsi_bi=(+T4_Vsi_bi_Vsi_bi*T3+T4_Vsi_bi*T3_Vsi_bi+T4_Vsi_bi*T3_Vsi_bi+T4*T3_Vsi_bi_Vsi_bi);
  T5_Vsi_bi_Tempt_GND=(+T4_Vsi_bi_Tempt_GND*T3+T4_Vsi_bi*T3_Tempt_GND+T4_Tempt_GND*T3_Vsi_bi+T4*T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((T4_Tempt_GND*T3)+(T4*T3_Tempt_GND));
#endif
#endif
T5=(T4*T3);
EXIT_IF_ISNAN((T4*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=0.0;
  T6_Vdbulk_di_Vgm_si=0.0;
  T6_Vdbulk_di_Vdbulk_di=0.0;
  T6_Vdbulk_di_Vsbulk_si=0.0;
  T6_Vdbulk_di_Vgi_bi=0.0;
  T6_Vdbulk_di_Vdi_bi=0.0;
  T6_Vdbulk_di_Vsi_bi=0.0;
  T6_Vdbulk_di_Tempt_GND=0.0;
#endif
T6_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=0.0;
  T6_Vsbulk_si_Vgm_si=0.0;
  T6_Vsbulk_si_Vdbulk_di=0.0;
  T6_Vsbulk_si_Vsbulk_si=0.0;
  T6_Vsbulk_si_Vgi_bi=0.0;
  T6_Vsbulk_si_Vdi_bi=0.0;
  T6_Vsbulk_si_Vsi_bi=0.0;
  T6_Vsbulk_si_Tempt_GND=0.0;
#endif
T6_Vgi_bi=(qs_Vgi_bi-qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+qs_Vgi_bi_Vgm_di-qdeff_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+qs_Vgi_bi_Vgm_si-qdeff_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=(qs_Vdi_bi-qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+qs_Vdi_bi_Vgm_di-qdeff_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+qs_Vdi_bi_Vgm_si-qdeff_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=(qs_Vsi_bi-qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+qs_Vsi_bi_Vgm_di-qdeff_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+qs_Vsi_bi_Vgm_si-qdeff_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(qs_Tempt_GND-qdeff_Tempt_GND);
#endif
#endif
T6=(qs-qdeff);
EXIT_IF_ISNAN((qs-qdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=((T6_Vdbulk_di*T6)+(T6*T6_Vdbulk_di));
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=(+T6_Vdbulk_di_Vgm_si*T6+T6_Vdbulk_di*T6_Vgm_si+T6_Vgm_si*T6_Vdbulk_di+T6*T6_Vdbulk_di_Vgm_si);
  T7_Vdbulk_di_Vgm_di=(+T6_Vdbulk_di_Vgm_di*T6+T6_Vdbulk_di*T6_Vgm_di+T6_Vgm_di*T6_Vdbulk_di+T6*T6_Vdbulk_di_Vgm_di);
  T7_Vdbulk_di_Vdbulk_di=(+T6_Vdbulk_di_Vdbulk_di*T6+T6_Vdbulk_di*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vdbulk_di+T6*T6_Vdbulk_di_Vdbulk_di);
  T7_Vdbulk_di_Vsbulk_si=(+T6_Vdbulk_di_Vsbulk_si*T6+T6_Vdbulk_di*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vdbulk_di+T6*T6_Vdbulk_di_Vsbulk_si);
  T7_Vdbulk_di_Vgi_bi=(+T6_Vdbulk_di_Vgi_bi*T6+T6_Vdbulk_di*T6_Vgi_bi+T6_Vgi_bi*T6_Vdbulk_di+T6*T6_Vdbulk_di_Vgi_bi);
  T7_Vdbulk_di_Vdi_bi=(+T6_Vdbulk_di_Vdi_bi*T6+T6_Vdbulk_di*T6_Vdi_bi+T6_Vdi_bi*T6_Vdbulk_di+T6*T6_Vdbulk_di_Vdi_bi);
  T7_Vdbulk_di_Vsi_bi=(+T6_Vdbulk_di_Vsi_bi*T6+T6_Vdbulk_di*T6_Vsi_bi+T6_Vsi_bi*T6_Vdbulk_di+T6*T6_Vdbulk_di_Vsi_bi);
  T7_Vdbulk_di_Tempt_GND=(+T6_Vdbulk_di_Tempt_GND*T6+T6_Vdbulk_di*T6_Tempt_GND+T6_Tempt_GND*T6_Vdbulk_di+T6*T6_Vdbulk_di_Tempt_GND);
#endif
T7_Vsbulk_si=((T6_Vsbulk_si*T6)+(T6*T6_Vsbulk_si));
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=(+T6_Vsbulk_si_Vgm_si*T6+T6_Vsbulk_si*T6_Vgm_si+T6_Vgm_si*T6_Vsbulk_si+T6*T6_Vsbulk_si_Vgm_si);
  T7_Vsbulk_si_Vgm_di=(+T6_Vsbulk_si_Vgm_di*T6+T6_Vsbulk_si*T6_Vgm_di+T6_Vgm_di*T6_Vsbulk_si+T6*T6_Vsbulk_si_Vgm_di);
  T7_Vsbulk_si_Vdbulk_di=(+T6_Vsbulk_si_Vdbulk_di*T6+T6_Vsbulk_si*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vsbulk_si+T6*T6_Vsbulk_si_Vdbulk_di);
  T7_Vsbulk_si_Vsbulk_si=(+T6_Vsbulk_si_Vsbulk_si*T6+T6_Vsbulk_si*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vsbulk_si+T6*T6_Vsbulk_si_Vsbulk_si);
  T7_Vsbulk_si_Vgi_bi=(+T6_Vsbulk_si_Vgi_bi*T6+T6_Vsbulk_si*T6_Vgi_bi+T6_Vgi_bi*T6_Vsbulk_si+T6*T6_Vsbulk_si_Vgi_bi);
  T7_Vsbulk_si_Vdi_bi=(+T6_Vsbulk_si_Vdi_bi*T6+T6_Vsbulk_si*T6_Vdi_bi+T6_Vdi_bi*T6_Vsbulk_si+T6*T6_Vsbulk_si_Vdi_bi);
  T7_Vsbulk_si_Vsi_bi=(+T6_Vsbulk_si_Vsi_bi*T6+T6_Vsbulk_si*T6_Vsi_bi+T6_Vsi_bi*T6_Vsbulk_si+T6*T6_Vsbulk_si_Vsi_bi);
  T7_Vsbulk_si_Tempt_GND=(+T6_Vsbulk_si_Tempt_GND*T6+T6_Vsbulk_si*T6_Tempt_GND+T6_Tempt_GND*T6_Vsbulk_si+T6*T6_Vsbulk_si_Tempt_GND);
#endif
T7_Vgi_bi=((T6_Vgi_bi*T6)+(T6*T6_Vgi_bi));
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+T6_Vgi_bi_Vgm_si*T6+T6_Vgi_bi*T6_Vgm_si+T6_Vgm_si*T6_Vgi_bi+T6*T6_Vgi_bi_Vgm_si);
  T7_Vgi_bi_Vgm_di=(+T6_Vgi_bi_Vgm_di*T6+T6_Vgi_bi*T6_Vgm_di+T6_Vgm_di*T6_Vgi_bi+T6*T6_Vgi_bi_Vgm_di);
  T7_Vgi_bi_Vdbulk_di=(+T6_Vgi_bi_Vdbulk_di*T6+T6_Vgi_bi*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vgi_bi+T6*T6_Vgi_bi_Vdbulk_di);
  T7_Vgi_bi_Vsbulk_si=(+T6_Vgi_bi_Vsbulk_si*T6+T6_Vgi_bi*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vgi_bi+T6*T6_Vgi_bi_Vsbulk_si);
  T7_Vgi_bi_Vgi_bi=(+T6_Vgi_bi_Vgi_bi*T6+T6_Vgi_bi*T6_Vgi_bi+T6_Vgi_bi*T6_Vgi_bi+T6*T6_Vgi_bi_Vgi_bi);
  T7_Vgi_bi_Vdi_bi=(+T6_Vgi_bi_Vdi_bi*T6+T6_Vgi_bi*T6_Vdi_bi+T6_Vdi_bi*T6_Vgi_bi+T6*T6_Vgi_bi_Vdi_bi);
  T7_Vgi_bi_Vsi_bi=(+T6_Vgi_bi_Vsi_bi*T6+T6_Vgi_bi*T6_Vsi_bi+T6_Vsi_bi*T6_Vgi_bi+T6*T6_Vgi_bi_Vsi_bi);
  T7_Vgi_bi_Tempt_GND=(+T6_Vgi_bi_Tempt_GND*T6+T6_Vgi_bi*T6_Tempt_GND+T6_Tempt_GND*T6_Vgi_bi+T6*T6_Vgi_bi_Tempt_GND);
#endif
T7_Vdi_bi=((T6_Vdi_bi*T6)+(T6*T6_Vdi_bi));
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+T6_Vdi_bi_Vgm_si*T6+T6_Vdi_bi*T6_Vgm_si+T6_Vgm_si*T6_Vdi_bi+T6*T6_Vdi_bi_Vgm_si);
  T7_Vdi_bi_Vgm_di=(+T6_Vdi_bi_Vgm_di*T6+T6_Vdi_bi*T6_Vgm_di+T6_Vgm_di*T6_Vdi_bi+T6*T6_Vdi_bi_Vgm_di);
  T7_Vdi_bi_Vdbulk_di=(+T6_Vdi_bi_Vdbulk_di*T6+T6_Vdi_bi*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vdi_bi+T6*T6_Vdi_bi_Vdbulk_di);
  T7_Vdi_bi_Vsbulk_si=(+T6_Vdi_bi_Vsbulk_si*T6+T6_Vdi_bi*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vdi_bi+T6*T6_Vdi_bi_Vsbulk_si);
  T7_Vdi_bi_Vgi_bi=(+T6_Vdi_bi_Vgi_bi*T6+T6_Vdi_bi*T6_Vgi_bi+T6_Vgi_bi*T6_Vdi_bi+T6*T6_Vdi_bi_Vgi_bi);
  T7_Vdi_bi_Vdi_bi=(+T6_Vdi_bi_Vdi_bi*T6+T6_Vdi_bi*T6_Vdi_bi+T6_Vdi_bi*T6_Vdi_bi+T6*T6_Vdi_bi_Vdi_bi);
  T7_Vdi_bi_Vsi_bi=(+T6_Vdi_bi_Vsi_bi*T6+T6_Vdi_bi*T6_Vsi_bi+T6_Vsi_bi*T6_Vdi_bi+T6*T6_Vdi_bi_Vsi_bi);
  T7_Vdi_bi_Tempt_GND=(+T6_Vdi_bi_Tempt_GND*T6+T6_Vdi_bi*T6_Tempt_GND+T6_Tempt_GND*T6_Vdi_bi+T6*T6_Vdi_bi_Tempt_GND);
#endif
T7_Vsi_bi=((T6_Vsi_bi*T6)+(T6*T6_Vsi_bi));
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+T6_Vsi_bi_Vgm_si*T6+T6_Vsi_bi*T6_Vgm_si+T6_Vgm_si*T6_Vsi_bi+T6*T6_Vsi_bi_Vgm_si);
  T7_Vsi_bi_Vgm_di=(+T6_Vsi_bi_Vgm_di*T6+T6_Vsi_bi*T6_Vgm_di+T6_Vgm_di*T6_Vsi_bi+T6*T6_Vsi_bi_Vgm_di);
  T7_Vsi_bi_Vdbulk_di=(+T6_Vsi_bi_Vdbulk_di*T6+T6_Vsi_bi*T6_Vdbulk_di+T6_Vdbulk_di*T6_Vsi_bi+T6*T6_Vsi_bi_Vdbulk_di);
  T7_Vsi_bi_Vsbulk_si=(+T6_Vsi_bi_Vsbulk_si*T6+T6_Vsi_bi*T6_Vsbulk_si+T6_Vsbulk_si*T6_Vsi_bi+T6*T6_Vsi_bi_Vsbulk_si);
  T7_Vsi_bi_Vgi_bi=(+T6_Vsi_bi_Vgi_bi*T6+T6_Vsi_bi*T6_Vgi_bi+T6_Vgi_bi*T6_Vsi_bi+T6*T6_Vsi_bi_Vgi_bi);
  T7_Vsi_bi_Vdi_bi=(+T6_Vsi_bi_Vdi_bi*T6+T6_Vsi_bi*T6_Vdi_bi+T6_Vdi_bi*T6_Vsi_bi+T6*T6_Vsi_bi_Vdi_bi);
  T7_Vsi_bi_Vsi_bi=(+T6_Vsi_bi_Vsi_bi*T6+T6_Vsi_bi*T6_Vsi_bi+T6_Vsi_bi*T6_Vsi_bi+T6*T6_Vsi_bi_Vsi_bi);
  T7_Vsi_bi_Tempt_GND=(+T6_Vsi_bi_Tempt_GND*T6+T6_Vsi_bi*T6_Tempt_GND+T6_Tempt_GND*T6_Vsi_bi+T6*T6_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=((T6_Tempt_GND*T6)+(T6*T6_Tempt_GND));
#endif
#endif
T7=(T6*T6);
EXIT_IF_ISNAN((T6*T6))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=((T7_Vdbulk_di*T6)+(T7*T6_Vdbulk_di));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+T7_Vdbulk_di_Vgm_di*T6+T7_Vdbulk_di*T6_Vgm_di+T7_Vgm_di*T6_Vdbulk_di+T7*T6_Vdbulk_di_Vgm_di);
  T8_Vdbulk_di_Vgm_si=(+T7_Vdbulk_di_Vgm_si*T6+T7_Vdbulk_di*T6_Vgm_si+T7_Vgm_si*T6_Vdbulk_di+T7*T6_Vdbulk_di_Vgm_si);
  T8_Vdbulk_di_Vdbulk_di=(+T7_Vdbulk_di_Vdbulk_di*T6+T7_Vdbulk_di*T6_Vdbulk_di+T7_Vdbulk_di*T6_Vdbulk_di+T7*T6_Vdbulk_di_Vdbulk_di);
  T8_Vdbulk_di_Vsbulk_si=(+T7_Vdbulk_di_Vsbulk_si*T6+T7_Vdbulk_di*T6_Vsbulk_si+T7_Vsbulk_si*T6_Vdbulk_di+T7*T6_Vdbulk_di_Vsbulk_si);
  T8_Vdbulk_di_Vgi_bi=(+T7_Vdbulk_di_Vgi_bi*T6+T7_Vdbulk_di*T6_Vgi_bi+T7_Vgi_bi*T6_Vdbulk_di+T7*T6_Vdbulk_di_Vgi_bi);
  T8_Vdbulk_di_Vdi_bi=(+T7_Vdbulk_di_Vdi_bi*T6+T7_Vdbulk_di*T6_Vdi_bi+T7_Vdi_bi*T6_Vdbulk_di+T7*T6_Vdbulk_di_Vdi_bi);
  T8_Vdbulk_di_Vsi_bi=(+T7_Vdbulk_di_Vsi_bi*T6+T7_Vdbulk_di*T6_Vsi_bi+T7_Vsi_bi*T6_Vdbulk_di+T7*T6_Vdbulk_di_Vsi_bi);
  T8_Vdbulk_di_Tempt_GND=(+T7_Vdbulk_di_Tempt_GND*T6+T7_Vdbulk_di*T6_Tempt_GND+T7_Tempt_GND*T6_Vdbulk_di+T7*T6_Vdbulk_di_Tempt_GND);
#endif
T8_Vsbulk_si=((T7_Vsbulk_si*T6)+(T7*T6_Vsbulk_si));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+T7_Vsbulk_si_Vgm_di*T6+T7_Vsbulk_si*T6_Vgm_di+T7_Vgm_di*T6_Vsbulk_si+T7*T6_Vsbulk_si_Vgm_di);
  T8_Vsbulk_si_Vgm_si=(+T7_Vsbulk_si_Vgm_si*T6+T7_Vsbulk_si*T6_Vgm_si+T7_Vgm_si*T6_Vsbulk_si+T7*T6_Vsbulk_si_Vgm_si);
  T8_Vsbulk_si_Vdbulk_di=(+T7_Vsbulk_si_Vdbulk_di*T6+T7_Vsbulk_si*T6_Vdbulk_di+T7_Vdbulk_di*T6_Vsbulk_si+T7*T6_Vsbulk_si_Vdbulk_di);
  T8_Vsbulk_si_Vsbulk_si=(+T7_Vsbulk_si_Vsbulk_si*T6+T7_Vsbulk_si*T6_Vsbulk_si+T7_Vsbulk_si*T6_Vsbulk_si+T7*T6_Vsbulk_si_Vsbulk_si);
  T8_Vsbulk_si_Vgi_bi=(+T7_Vsbulk_si_Vgi_bi*T6+T7_Vsbulk_si*T6_Vgi_bi+T7_Vgi_bi*T6_Vsbulk_si+T7*T6_Vsbulk_si_Vgi_bi);
  T8_Vsbulk_si_Vdi_bi=(+T7_Vsbulk_si_Vdi_bi*T6+T7_Vsbulk_si*T6_Vdi_bi+T7_Vdi_bi*T6_Vsbulk_si+T7*T6_Vsbulk_si_Vdi_bi);
  T8_Vsbulk_si_Vsi_bi=(+T7_Vsbulk_si_Vsi_bi*T6+T7_Vsbulk_si*T6_Vsi_bi+T7_Vsi_bi*T6_Vsbulk_si+T7*T6_Vsbulk_si_Vsi_bi);
  T8_Vsbulk_si_Tempt_GND=(+T7_Vsbulk_si_Tempt_GND*T6+T7_Vsbulk_si*T6_Tempt_GND+T7_Tempt_GND*T6_Vsbulk_si+T7*T6_Vsbulk_si_Tempt_GND);
#endif
T8_Vgi_bi=((T7_Vgi_bi*T6)+(T7*T6_Vgi_bi));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+T7_Vgi_bi_Vgm_di*T6+T7_Vgi_bi*T6_Vgm_di+T7_Vgm_di*T6_Vgi_bi+T7*T6_Vgi_bi_Vgm_di);
  T8_Vgi_bi_Vgm_si=(+T7_Vgi_bi_Vgm_si*T6+T7_Vgi_bi*T6_Vgm_si+T7_Vgm_si*T6_Vgi_bi+T7*T6_Vgi_bi_Vgm_si);
  T8_Vgi_bi_Vdbulk_di=(+T7_Vgi_bi_Vdbulk_di*T6+T7_Vgi_bi*T6_Vdbulk_di+T7_Vdbulk_di*T6_Vgi_bi+T7*T6_Vgi_bi_Vdbulk_di);
  T8_Vgi_bi_Vsbulk_si=(+T7_Vgi_bi_Vsbulk_si*T6+T7_Vgi_bi*T6_Vsbulk_si+T7_Vsbulk_si*T6_Vgi_bi+T7*T6_Vgi_bi_Vsbulk_si);
  T8_Vgi_bi_Vgi_bi=(+T7_Vgi_bi_Vgi_bi*T6+T7_Vgi_bi*T6_Vgi_bi+T7_Vgi_bi*T6_Vgi_bi+T7*T6_Vgi_bi_Vgi_bi);
  T8_Vgi_bi_Vdi_bi=(+T7_Vgi_bi_Vdi_bi*T6+T7_Vgi_bi*T6_Vdi_bi+T7_Vdi_bi*T6_Vgi_bi+T7*T6_Vgi_bi_Vdi_bi);
  T8_Vgi_bi_Vsi_bi=(+T7_Vgi_bi_Vsi_bi*T6+T7_Vgi_bi*T6_Vsi_bi+T7_Vsi_bi*T6_Vgi_bi+T7*T6_Vgi_bi_Vsi_bi);
  T8_Vgi_bi_Tempt_GND=(+T7_Vgi_bi_Tempt_GND*T6+T7_Vgi_bi*T6_Tempt_GND+T7_Tempt_GND*T6_Vgi_bi+T7*T6_Vgi_bi_Tempt_GND);
#endif
T8_Vdi_bi=((T7_Vdi_bi*T6)+(T7*T6_Vdi_bi));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+T7_Vdi_bi_Vgm_di*T6+T7_Vdi_bi*T6_Vgm_di+T7_Vgm_di*T6_Vdi_bi+T7*T6_Vdi_bi_Vgm_di);
  T8_Vdi_bi_Vgm_si=(+T7_Vdi_bi_Vgm_si*T6+T7_Vdi_bi*T6_Vgm_si+T7_Vgm_si*T6_Vdi_bi+T7*T6_Vdi_bi_Vgm_si);
  T8_Vdi_bi_Vdbulk_di=(+T7_Vdi_bi_Vdbulk_di*T6+T7_Vdi_bi*T6_Vdbulk_di+T7_Vdbulk_di*T6_Vdi_bi+T7*T6_Vdi_bi_Vdbulk_di);
  T8_Vdi_bi_Vsbulk_si=(+T7_Vdi_bi_Vsbulk_si*T6+T7_Vdi_bi*T6_Vsbulk_si+T7_Vsbulk_si*T6_Vdi_bi+T7*T6_Vdi_bi_Vsbulk_si);
  T8_Vdi_bi_Vgi_bi=(+T7_Vdi_bi_Vgi_bi*T6+T7_Vdi_bi*T6_Vgi_bi+T7_Vgi_bi*T6_Vdi_bi+T7*T6_Vdi_bi_Vgi_bi);
  T8_Vdi_bi_Vdi_bi=(+T7_Vdi_bi_Vdi_bi*T6+T7_Vdi_bi*T6_Vdi_bi+T7_Vdi_bi*T6_Vdi_bi+T7*T6_Vdi_bi_Vdi_bi);
  T8_Vdi_bi_Vsi_bi=(+T7_Vdi_bi_Vsi_bi*T6+T7_Vdi_bi*T6_Vsi_bi+T7_Vsi_bi*T6_Vdi_bi+T7*T6_Vdi_bi_Vsi_bi);
  T8_Vdi_bi_Tempt_GND=(+T7_Vdi_bi_Tempt_GND*T6+T7_Vdi_bi*T6_Tempt_GND+T7_Tempt_GND*T6_Vdi_bi+T7*T6_Vdi_bi_Tempt_GND);
#endif
T8_Vsi_bi=((T7_Vsi_bi*T6)+(T7*T6_Vsi_bi));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+T7_Vsi_bi_Vgm_di*T6+T7_Vsi_bi*T6_Vgm_di+T7_Vgm_di*T6_Vsi_bi+T7*T6_Vsi_bi_Vgm_di);
  T8_Vsi_bi_Vgm_si=(+T7_Vsi_bi_Vgm_si*T6+T7_Vsi_bi*T6_Vgm_si+T7_Vgm_si*T6_Vsi_bi+T7*T6_Vsi_bi_Vgm_si);
  T8_Vsi_bi_Vdbulk_di=(+T7_Vsi_bi_Vdbulk_di*T6+T7_Vsi_bi*T6_Vdbulk_di+T7_Vdbulk_di*T6_Vsi_bi+T7*T6_Vsi_bi_Vdbulk_di);
  T8_Vsi_bi_Vsbulk_si=(+T7_Vsi_bi_Vsbulk_si*T6+T7_Vsi_bi*T6_Vsbulk_si+T7_Vsbulk_si*T6_Vsi_bi+T7*T6_Vsi_bi_Vsbulk_si);
  T8_Vsi_bi_Vgi_bi=(+T7_Vsi_bi_Vgi_bi*T6+T7_Vsi_bi*T6_Vgi_bi+T7_Vgi_bi*T6_Vsi_bi+T7*T6_Vsi_bi_Vgi_bi);
  T8_Vsi_bi_Vdi_bi=(+T7_Vsi_bi_Vdi_bi*T6+T7_Vsi_bi*T6_Vdi_bi+T7_Vdi_bi*T6_Vsi_bi+T7*T6_Vsi_bi_Vdi_bi);
  T8_Vsi_bi_Vsi_bi=(+T7_Vsi_bi_Vsi_bi*T6+T7_Vsi_bi*T6_Vsi_bi+T7_Vsi_bi*T6_Vsi_bi+T7*T6_Vsi_bi_Vsi_bi);
  T8_Vsi_bi_Tempt_GND=(+T7_Vsi_bi_Tempt_GND*T6+T7_Vsi_bi*T6_Tempt_GND+T7_Tempt_GND*T6_Vsi_bi+T7*T6_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=((T7_Tempt_GND*T6)+(T7*T6_Tempt_GND));
#endif
#endif
T8=(T7*T6);
EXIT_IF_ISNAN((T7*T6))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=(((6.0*T1_Vdbulk_di)*T7)+(((6.0*T1)+0.5)*T7_Vdbulk_di));
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=(+(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+6.0*T1_Vdbulk_di_Vgm_si)+0.0)*T7+(6.0*T1_Vdbulk_di)*T7_Vgm_si+((6.0*T1_Vgm_si))*T7_Vdbulk_di+((6.0*T1)+0.5)*T7_Vdbulk_di_Vgm_si);
  T9_Vdbulk_di_Vgm_di=(+(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vdbulk_di+6.0*T1_Vdbulk_di_Vgm_di)+0.0)*T7+(6.0*T1_Vdbulk_di)*T7_Vgm_di+((6.0*T1_Vgm_di))*T7_Vdbulk_di+((6.0*T1)+0.5)*T7_Vdbulk_di_Vgm_di);
  T9_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+6.0*T1_Vdbulk_di_Vdbulk_di)+0.0)*T7+(6.0*T1_Vdbulk_di)*T7_Vdbulk_di+((6.0*T1_Vdbulk_di))*T7_Vdbulk_di+((6.0*T1)+0.5)*T7_Vdbulk_di_Vdbulk_di);
  T9_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+6.0*T1_Vdbulk_di_Vsbulk_si)+0.0)*T7+(6.0*T1_Vdbulk_di)*T7_Vsbulk_si+((6.0*T1_Vsbulk_si))*T7_Vdbulk_di+((6.0*T1)+0.5)*T7_Vdbulk_di_Vsbulk_si);
  T9_Vdbulk_di_Vdi_bi=(+(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vdbulk_di+6.0*T1_Vdbulk_di_Vdi_bi)+0.0)*T7+(6.0*T1_Vdbulk_di)*T7_Vdi_bi+((6.0*T1_Vdi_bi))*T7_Vdbulk_di+((6.0*T1)+0.5)*T7_Vdbulk_di_Vdi_bi);
  T9_Vdbulk_di_Vsi_bi=(+(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vdbulk_di+6.0*T1_Vdbulk_di_Vsi_bi)+0.0)*T7+(6.0*T1_Vdbulk_di)*T7_Vsi_bi+((6.0*T1_Vsi_bi))*T7_Vdbulk_di+((6.0*T1)+0.5)*T7_Vdbulk_di_Vsi_bi);
  T9_Vdbulk_di_Tempt_GND=(+(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vdbulk_di+6.0*T1_Vdbulk_di_Tempt_GND)+0.0)*T7+(6.0*T1_Vdbulk_di)*T7_Tempt_GND+((6.0*T1_Tempt_GND))*T7_Vdbulk_di+((6.0*T1)+0.5)*T7_Vdbulk_di_Tempt_GND);
  T9_Vdbulk_di_Vgi_bi=(+(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vdbulk_di+6.0*T1_Vdbulk_di_Vgi_bi)+0.0)*T7+(6.0*T1_Vdbulk_di)*T7_Vgi_bi+((6.0*T1_Vgi_bi))*T7_Vdbulk_di+((6.0*T1)+0.5)*T7_Vdbulk_di_Vgi_bi);
#endif
T9_Vsbulk_si=(((6.0*T1_Vsbulk_si)*T7)+(((6.0*T1)+0.5)*T7_Vsbulk_si));
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=(+(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+6.0*T1_Vsbulk_si_Vgm_si)+0.0)*T7+(6.0*T1_Vsbulk_si)*T7_Vgm_si+((6.0*T1_Vgm_si))*T7_Vsbulk_si+((6.0*T1)+0.5)*T7_Vsbulk_si_Vgm_si);
  T9_Vsbulk_si_Vgm_di=(+(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vsbulk_si+6.0*T1_Vsbulk_si_Vgm_di)+0.0)*T7+(6.0*T1_Vsbulk_si)*T7_Vgm_di+((6.0*T1_Vgm_di))*T7_Vsbulk_si+((6.0*T1)+0.5)*T7_Vsbulk_si_Vgm_di);
  T9_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+6.0*T1_Vsbulk_si_Vdbulk_di)+0.0)*T7+(6.0*T1_Vsbulk_si)*T7_Vdbulk_di+((6.0*T1_Vdbulk_di))*T7_Vsbulk_si+((6.0*T1)+0.5)*T7_Vsbulk_si_Vdbulk_di);
  T9_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+6.0*T1_Vsbulk_si_Vsbulk_si)+0.0)*T7+(6.0*T1_Vsbulk_si)*T7_Vsbulk_si+((6.0*T1_Vsbulk_si))*T7_Vsbulk_si+((6.0*T1)+0.5)*T7_Vsbulk_si_Vsbulk_si);
  T9_Vsbulk_si_Vdi_bi=(+(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vsbulk_si+6.0*T1_Vsbulk_si_Vdi_bi)+0.0)*T7+(6.0*T1_Vsbulk_si)*T7_Vdi_bi+((6.0*T1_Vdi_bi))*T7_Vsbulk_si+((6.0*T1)+0.5)*T7_Vsbulk_si_Vdi_bi);
  T9_Vsbulk_si_Vsi_bi=(+(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vsbulk_si+6.0*T1_Vsbulk_si_Vsi_bi)+0.0)*T7+(6.0*T1_Vsbulk_si)*T7_Vsi_bi+((6.0*T1_Vsi_bi))*T7_Vsbulk_si+((6.0*T1)+0.5)*T7_Vsbulk_si_Vsi_bi);
  T9_Vsbulk_si_Tempt_GND=(+(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vsbulk_si+6.0*T1_Vsbulk_si_Tempt_GND)+0.0)*T7+(6.0*T1_Vsbulk_si)*T7_Tempt_GND+((6.0*T1_Tempt_GND))*T7_Vsbulk_si+((6.0*T1)+0.5)*T7_Vsbulk_si_Tempt_GND);
  T9_Vsbulk_si_Vgi_bi=(+(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vsbulk_si+6.0*T1_Vsbulk_si_Vgi_bi)+0.0)*T7+(6.0*T1_Vsbulk_si)*T7_Vgi_bi+((6.0*T1_Vgi_bi))*T7_Vsbulk_si+((6.0*T1)+0.5)*T7_Vsbulk_si_Vgi_bi);
#endif
T9_Vdi_bi=(((6.0*T1_Vdi_bi)*T7)+(((6.0*T1)+0.5)*T7_Vdi_bi));
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vdi_bi+6.0*T1_Vdi_bi_Vgm_si)+0.0)*T7+(6.0*T1_Vdi_bi)*T7_Vgm_si+((6.0*T1_Vgm_si))*T7_Vdi_bi+((6.0*T1)+0.5)*T7_Vdi_bi_Vgm_si);
  T9_Vdi_bi_Vgm_di=(+(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vdi_bi+6.0*T1_Vdi_bi_Vgm_di)+0.0)*T7+(6.0*T1_Vdi_bi)*T7_Vgm_di+((6.0*T1_Vgm_di))*T7_Vdi_bi+((6.0*T1)+0.5)*T7_Vdi_bi_Vgm_di);
  T9_Vdi_bi_Vdbulk_di=(+(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vdi_bi+6.0*T1_Vdi_bi_Vdbulk_di)+0.0)*T7+(6.0*T1_Vdi_bi)*T7_Vdbulk_di+((6.0*T1_Vdbulk_di))*T7_Vdi_bi+((6.0*T1)+0.5)*T7_Vdi_bi_Vdbulk_di);
  T9_Vdi_bi_Vsbulk_si=(+(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vdi_bi+6.0*T1_Vdi_bi_Vsbulk_si)+0.0)*T7+(6.0*T1_Vdi_bi)*T7_Vsbulk_si+((6.0*T1_Vsbulk_si))*T7_Vdi_bi+((6.0*T1)+0.5)*T7_Vdi_bi_Vsbulk_si);
  T9_Vdi_bi_Vdi_bi=(+(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vdi_bi+6.0*T1_Vdi_bi_Vdi_bi)+0.0)*T7+(6.0*T1_Vdi_bi)*T7_Vdi_bi+((6.0*T1_Vdi_bi))*T7_Vdi_bi+((6.0*T1)+0.5)*T7_Vdi_bi_Vdi_bi);
  T9_Vdi_bi_Vsi_bi=(+(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vdi_bi+6.0*T1_Vdi_bi_Vsi_bi)+0.0)*T7+(6.0*T1_Vdi_bi)*T7_Vsi_bi+((6.0*T1_Vsi_bi))*T7_Vdi_bi+((6.0*T1)+0.5)*T7_Vdi_bi_Vsi_bi);
  T9_Vdi_bi_Tempt_GND=(+(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vdi_bi+6.0*T1_Vdi_bi_Tempt_GND)+0.0)*T7+(6.0*T1_Vdi_bi)*T7_Tempt_GND+((6.0*T1_Tempt_GND))*T7_Vdi_bi+((6.0*T1)+0.5)*T7_Vdi_bi_Tempt_GND);
  T9_Vdi_bi_Vgi_bi=(+(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vdi_bi+6.0*T1_Vdi_bi_Vgi_bi)+0.0)*T7+(6.0*T1_Vdi_bi)*T7_Vgi_bi+((6.0*T1_Vgi_bi))*T7_Vdi_bi+((6.0*T1)+0.5)*T7_Vdi_bi_Vgi_bi);
#endif
T9_Vsi_bi=(((6.0*T1_Vsi_bi)*T7)+(((6.0*T1)+0.5)*T7_Vsi_bi));
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vsi_bi+6.0*T1_Vsi_bi_Vgm_si)+0.0)*T7+(6.0*T1_Vsi_bi)*T7_Vgm_si+((6.0*T1_Vgm_si))*T7_Vsi_bi+((6.0*T1)+0.5)*T7_Vsi_bi_Vgm_si);
  T9_Vsi_bi_Vgm_di=(+(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vsi_bi+6.0*T1_Vsi_bi_Vgm_di)+0.0)*T7+(6.0*T1_Vsi_bi)*T7_Vgm_di+((6.0*T1_Vgm_di))*T7_Vsi_bi+((6.0*T1)+0.5)*T7_Vsi_bi_Vgm_di);
  T9_Vsi_bi_Vdbulk_di=(+(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vsi_bi+6.0*T1_Vsi_bi_Vdbulk_di)+0.0)*T7+(6.0*T1_Vsi_bi)*T7_Vdbulk_di+((6.0*T1_Vdbulk_di))*T7_Vsi_bi+((6.0*T1)+0.5)*T7_Vsi_bi_Vdbulk_di);
  T9_Vsi_bi_Vsbulk_si=(+(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vsi_bi+6.0*T1_Vsi_bi_Vsbulk_si)+0.0)*T7+(6.0*T1_Vsi_bi)*T7_Vsbulk_si+((6.0*T1_Vsbulk_si))*T7_Vsi_bi+((6.0*T1)+0.5)*T7_Vsi_bi_Vsbulk_si);
  T9_Vsi_bi_Vdi_bi=(+(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vsi_bi+6.0*T1_Vsi_bi_Vdi_bi)+0.0)*T7+(6.0*T1_Vsi_bi)*T7_Vdi_bi+((6.0*T1_Vdi_bi))*T7_Vsi_bi+((6.0*T1)+0.5)*T7_Vsi_bi_Vdi_bi);
  T9_Vsi_bi_Vsi_bi=(+(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vsi_bi+6.0*T1_Vsi_bi_Vsi_bi)+0.0)*T7+(6.0*T1_Vsi_bi)*T7_Vsi_bi+((6.0*T1_Vsi_bi))*T7_Vsi_bi+((6.0*T1)+0.5)*T7_Vsi_bi_Vsi_bi);
  T9_Vsi_bi_Tempt_GND=(+(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vsi_bi+6.0*T1_Vsi_bi_Tempt_GND)+0.0)*T7+(6.0*T1_Vsi_bi)*T7_Tempt_GND+((6.0*T1_Tempt_GND))*T7_Vsi_bi+((6.0*T1)+0.5)*T7_Vsi_bi_Tempt_GND);
  T9_Vsi_bi_Vgi_bi=(+(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vsi_bi+6.0*T1_Vsi_bi_Vgi_bi)+0.0)*T7+(6.0*T1_Vsi_bi)*T7_Vgi_bi+((6.0*T1_Vgi_bi))*T7_Vsi_bi+((6.0*T1)+0.5)*T7_Vsi_bi_Vgi_bi);
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=(((6.0*T1_Tempt_GND)*T7)+(((6.0*T1)+0.5)*T7_Tempt_GND));
#endif
T9_Vgi_bi=(((6.0*T1_Vgi_bi)*T7)+(((6.0*T1)+0.5)*T7_Vgi_bi));
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=(+(+(+0.0*T1+0.0*T1_Vgm_si+0.0*T1_Vgi_bi+6.0*T1_Vgi_bi_Vgm_si)+0.0)*T7+(6.0*T1_Vgi_bi)*T7_Vgm_si+((6.0*T1_Vgm_si))*T7_Vgi_bi+((6.0*T1)+0.5)*T7_Vgi_bi_Vgm_si);
  T9_Vgi_bi_Vgm_di=(+(+(+0.0*T1+0.0*T1_Vgm_di+0.0*T1_Vgi_bi+6.0*T1_Vgi_bi_Vgm_di)+0.0)*T7+(6.0*T1_Vgi_bi)*T7_Vgm_di+((6.0*T1_Vgm_di))*T7_Vgi_bi+((6.0*T1)+0.5)*T7_Vgi_bi_Vgm_di);
  T9_Vgi_bi_Vdbulk_di=(+(+(+0.0*T1+0.0*T1_Vdbulk_di+0.0*T1_Vgi_bi+6.0*T1_Vgi_bi_Vdbulk_di)+0.0)*T7+(6.0*T1_Vgi_bi)*T7_Vdbulk_di+((6.0*T1_Vdbulk_di))*T7_Vgi_bi+((6.0*T1)+0.5)*T7_Vgi_bi_Vdbulk_di);
  T9_Vgi_bi_Vsbulk_si=(+(+(+0.0*T1+0.0*T1_Vsbulk_si+0.0*T1_Vgi_bi+6.0*T1_Vgi_bi_Vsbulk_si)+0.0)*T7+(6.0*T1_Vgi_bi)*T7_Vsbulk_si+((6.0*T1_Vsbulk_si))*T7_Vgi_bi+((6.0*T1)+0.5)*T7_Vgi_bi_Vsbulk_si);
  T9_Vgi_bi_Vdi_bi=(+(+(+0.0*T1+0.0*T1_Vdi_bi+0.0*T1_Vgi_bi+6.0*T1_Vgi_bi_Vdi_bi)+0.0)*T7+(6.0*T1_Vgi_bi)*T7_Vdi_bi+((6.0*T1_Vdi_bi))*T7_Vgi_bi+((6.0*T1)+0.5)*T7_Vgi_bi_Vdi_bi);
  T9_Vgi_bi_Vsi_bi=(+(+(+0.0*T1+0.0*T1_Vsi_bi+0.0*T1_Vgi_bi+6.0*T1_Vgi_bi_Vsi_bi)+0.0)*T7+(6.0*T1_Vgi_bi)*T7_Vsi_bi+((6.0*T1_Vsi_bi))*T7_Vgi_bi+((6.0*T1)+0.5)*T7_Vgi_bi_Vsi_bi);
  T9_Vgi_bi_Tempt_GND=(+(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Vgi_bi+6.0*T1_Vgi_bi_Tempt_GND)+0.0)*T7+(6.0*T1_Vgi_bi)*T7_Tempt_GND+((6.0*T1_Tempt_GND))*T7_Vgi_bi+((6.0*T1)+0.5)*T7_Vgi_bi_Tempt_GND);
  T9_Vgi_bi_Vgi_bi=(+(+(+0.0*T1+0.0*T1_Vgi_bi+0.0*T1_Vgi_bi+6.0*T1_Vgi_bi_Vgi_bi)+0.0)*T7+(6.0*T1_Vgi_bi)*T7_Vgi_bi+((6.0*T1_Vgi_bi))*T7_Vgi_bi+((6.0*T1)+0.5)*T7_Vgi_bi_Vgi_bi);
#endif
#endif
T9=(((6.0*T1)+0.5)*T7);
EXIT_IF_ISNAN((((6.0*T1)+0.5)*T7))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Lvsat_Vgi_bi=(Leff*Dptwg_Vgi_bi);
#if defined(_DERIVATE2)
  Lvsat_Vgi_bi_Vgi_bi=(+0.0*Dptwg+0.0*Dptwg_Vgi_bi+0.0*Dptwg_Vgi_bi+Leff*Dptwg_Vgi_bi_Vgi_bi);
  Lvsat_Vgi_bi_Vdi_bi=(+0.0*Dptwg+0.0*Dptwg_Vdi_bi+0.0*Dptwg_Vgi_bi+Leff*Dptwg_Vgi_bi_Vdi_bi);
  Lvsat_Vgi_bi_Vsi_bi=(+0.0*Dptwg+0.0*Dptwg_Vsi_bi+0.0*Dptwg_Vgi_bi+Leff*Dptwg_Vgi_bi_Vsi_bi);
  Lvsat_Vgi_bi_Tempt_GND=(+0.0*Dptwg+0.0*Dptwg_Tempt_GND+0.0*Dptwg_Vgi_bi+Leff*Dptwg_Vgi_bi_Tempt_GND);
#endif
Lvsat_Vdi_bi=(Leff*Dptwg_Vdi_bi);
#if defined(_DERIVATE2)
  Lvsat_Vdi_bi_Vgi_bi=(+0.0*Dptwg+0.0*Dptwg_Vgi_bi+0.0*Dptwg_Vdi_bi+Leff*Dptwg_Vdi_bi_Vgi_bi);
  Lvsat_Vdi_bi_Vdi_bi=(+0.0*Dptwg+0.0*Dptwg_Vdi_bi+0.0*Dptwg_Vdi_bi+Leff*Dptwg_Vdi_bi_Vdi_bi);
  Lvsat_Vdi_bi_Vsi_bi=(+0.0*Dptwg+0.0*Dptwg_Vsi_bi+0.0*Dptwg_Vdi_bi+Leff*Dptwg_Vdi_bi_Vsi_bi);
  Lvsat_Vdi_bi_Tempt_GND=(+0.0*Dptwg+0.0*Dptwg_Tempt_GND+0.0*Dptwg_Vdi_bi+Leff*Dptwg_Vdi_bi_Tempt_GND);
#endif
Lvsat_Vsi_bi=(Leff*Dptwg_Vsi_bi);
#if defined(_DERIVATE2)
  Lvsat_Vsi_bi_Vgi_bi=(+0.0*Dptwg+0.0*Dptwg_Vgi_bi+0.0*Dptwg_Vsi_bi+Leff*Dptwg_Vsi_bi_Vgi_bi);
  Lvsat_Vsi_bi_Vdi_bi=(+0.0*Dptwg+0.0*Dptwg_Vdi_bi+0.0*Dptwg_Vsi_bi+Leff*Dptwg_Vsi_bi_Vdi_bi);
  Lvsat_Vsi_bi_Vsi_bi=(+0.0*Dptwg+0.0*Dptwg_Vsi_bi+0.0*Dptwg_Vsi_bi+Leff*Dptwg_Vsi_bi_Vsi_bi);
  Lvsat_Vsi_bi_Tempt_GND=(+0.0*Dptwg+0.0*Dptwg_Tempt_GND+0.0*Dptwg_Vsi_bi+Leff*Dptwg_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Lvsat_Tempt_GND=(Leff*Dptwg_Tempt_GND);
#endif
#endif
Lvsat=(Leff*Dptwg);
EXIT_IF_ISNAN((Leff*Dptwg))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T10_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T10_Vdbulk_di_Vdbulk_di=0.0;
  T10_Vdbulk_di_Vsbulk_si=0.0;
  T10_Vdbulk_di_Vgi_bi=0.0;
  T10_Vdbulk_di_Vdi_bi=0.0;
  T10_Vdbulk_di_Vsi_bi=0.0;
  T10_Vdbulk_di_Tempt_GND=0.0;
#endif
T10_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T10_Vsbulk_si_Vdbulk_di=0.0;
  T10_Vsbulk_si_Vsbulk_si=0.0;
  T10_Vsbulk_si_Vgi_bi=0.0;
  T10_Vsbulk_si_Vdi_bi=0.0;
  T10_Vsbulk_si_Vsi_bi=0.0;
  T10_Vsbulk_si_Tempt_GND=0.0;
#endif
T10_Vgi_bi=(Lvsat_Vgi_bi/Leff);
#if defined(_DERIVATE2)
  T10_Vgi_bi_Vdbulk_di=(0.0/Leff-(Lvsat_Vgi_bi*0.0+0.0*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vgi_bi_Vsbulk_si=(0.0/Leff-(Lvsat_Vgi_bi*0.0+0.0*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vgi_bi_Vgi_bi=(Lvsat_Vgi_bi_Vgi_bi/Leff-(Lvsat_Vgi_bi*0.0+Lvsat_Vgi_bi*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vgi_bi_Vdi_bi=(Lvsat_Vgi_bi_Vdi_bi/Leff-(Lvsat_Vgi_bi*0.0+Lvsat_Vdi_bi*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vgi_bi_Vsi_bi=(Lvsat_Vgi_bi_Vsi_bi/Leff-(Lvsat_Vgi_bi*0.0+Lvsat_Vsi_bi*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vgi_bi_Tempt_GND=(Lvsat_Vgi_bi_Tempt_GND/Leff-(Lvsat_Vgi_bi*0.0+Lvsat_Tempt_GND*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
#endif
T10_Vdi_bi=(Lvsat_Vdi_bi/Leff);
#if defined(_DERIVATE2)
  T10_Vdi_bi_Vdbulk_di=(0.0/Leff-(Lvsat_Vdi_bi*0.0+0.0*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vdi_bi_Vsbulk_si=(0.0/Leff-(Lvsat_Vdi_bi*0.0+0.0*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vdi_bi_Vgi_bi=(Lvsat_Vdi_bi_Vgi_bi/Leff-(Lvsat_Vdi_bi*0.0+Lvsat_Vgi_bi*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vdi_bi_Vdi_bi=(Lvsat_Vdi_bi_Vdi_bi/Leff-(Lvsat_Vdi_bi*0.0+Lvsat_Vdi_bi*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vdi_bi_Vsi_bi=(Lvsat_Vdi_bi_Vsi_bi/Leff-(Lvsat_Vdi_bi*0.0+Lvsat_Vsi_bi*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vdi_bi_Tempt_GND=(Lvsat_Vdi_bi_Tempt_GND/Leff-(Lvsat_Vdi_bi*0.0+Lvsat_Tempt_GND*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
#endif
T10_Vsi_bi=(Lvsat_Vsi_bi/Leff);
#if defined(_DERIVATE2)
  T10_Vsi_bi_Vdbulk_di=(0.0/Leff-(Lvsat_Vsi_bi*0.0+0.0*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vsi_bi_Vsbulk_si=(0.0/Leff-(Lvsat_Vsi_bi*0.0+0.0*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vsi_bi_Vgi_bi=(Lvsat_Vsi_bi_Vgi_bi/Leff-(Lvsat_Vsi_bi*0.0+Lvsat_Vgi_bi*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vsi_bi_Vdi_bi=(Lvsat_Vsi_bi_Vdi_bi/Leff-(Lvsat_Vsi_bi*0.0+Lvsat_Vdi_bi*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vsi_bi_Vsi_bi=(Lvsat_Vsi_bi_Vsi_bi/Leff-(Lvsat_Vsi_bi*0.0+Lvsat_Vsi_bi*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
  T10_Vsi_bi_Tempt_GND=(Lvsat_Vsi_bi_Tempt_GND/Leff-(Lvsat_Vsi_bi*0.0+Lvsat_Tempt_GND*0.0+Lvsat*0.0)/Leff/Leff+2*Lvsat*0.0*0.0/Leff/Leff/Leff);
#endif
#if defined(_DERIVATE)
T10_Tempt_GND=(Lvsat_Tempt_GND/Leff);
#endif
#endif
T10=(Lvsat/Leff);
EXIT_IF_ISNAN((Lvsat/Leff))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
T12_Vdbulk_di=((((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat)))*(pModel->TNOIK2+qia)-(betaLowId*(Vdseff/Vdssat))*qia_Vdbulk_di)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia));
#if defined(_DERIVATE2)
  T12_Vdbulk_di_Vdbulk_di=(+0.0+((+betaLowId_Vdbulk_di_Vdbulk_di*(Vdseff/Vdssat)+betaLowId_Vdbulk_di*(Vdseff_Vdbulk_di/Vdssat)+betaLowId_Vdbulk_di*(Vdseff_Vdbulk_di/Vdssat)+betaLowId*(Vdseff_Vdbulk_di_Vdbulk_di/Vdssat-(Vdseff_Vdbulk_di*0.0+Vdseff_Vdbulk_di*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat)))*qia_Vdbulk_di+(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat))))*qia_Vdbulk_di+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdbulk_di_Vdbulk_di))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdbulk_di*qia_Vdbulk_di/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdbulk_di_Vsbulk_si=(+0.0+((+betaLowId_Vdbulk_di_Vsbulk_si*(Vdseff/Vdssat)+betaLowId_Vdbulk_di*(Vdseff_Vsbulk_si/Vdssat)+betaLowId_Vsbulk_si*(Vdseff_Vdbulk_di/Vdssat)+betaLowId*(Vdseff_Vdbulk_di_Vsbulk_si/Vdssat-(Vdseff_Vdbulk_di*0.0+Vdseff_Vsbulk_si*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat)))*qia_Vsbulk_si+(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat))))*qia_Vdbulk_di+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdbulk_di_Vsbulk_si))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdbulk_di*qia_Vsbulk_si/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdbulk_di_Vgi_bi=(+0.0+((+betaLowId_Vdbulk_di_Vgi_bi*(Vdseff/Vdssat)+betaLowId_Vdbulk_di*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId_Vgi_bi*(Vdseff_Vdbulk_di/Vdssat)+betaLowId*(Vdseff_Vdbulk_di_Vgi_bi/Vdssat-(Vdseff_Vdbulk_di*Vdssat_Vgi_bi+Vdseff_Vgi_bi*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*Vdssat_Vgi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat)))*qia_Vgi_bi+(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat))))*qia_Vdbulk_di+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdbulk_di_Vgi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdbulk_di*qia_Vgi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdbulk_di_Tempt_GND=(+0.0+((+betaLowId_Vdbulk_di_Tempt_GND*(Vdseff/Vdssat)+betaLowId_Vdbulk_di*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat)+betaLowId_Tempt_GND*(Vdseff_Vdbulk_di/Vdssat)+betaLowId*(Vdseff_Vdbulk_di_Tempt_GND/Vdssat-(Vdseff_Vdbulk_di*Vdssat_Tempt_GND+Vdseff_Tempt_GND*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*Vdssat_Tempt_GND/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat)))*qia_Tempt_GND+(((betaLowId_Tempt_GND*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat))))*qia_Vdbulk_di+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdbulk_di_Tempt_GND))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdbulk_di*qia_Tempt_GND/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdbulk_di_Vdi_bi=(+0.0+((+betaLowId_Vdbulk_di_Vdi_bi*(Vdseff/Vdssat)+betaLowId_Vdbulk_di*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId_Vdi_bi*(Vdseff_Vdbulk_di/Vdssat)+betaLowId*(Vdseff_Vdbulk_di_Vdi_bi/Vdssat-(Vdseff_Vdbulk_di*Vdssat_Vdi_bi+Vdseff_Vdi_bi*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*Vdssat_Vdi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat)))*qia_Vdi_bi+(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat))))*qia_Vdbulk_di+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdbulk_di_Vdi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdbulk_di*qia_Vdi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdbulk_di_Vsi_bi=(+0.0+((+betaLowId_Vdbulk_di_Vsi_bi*(Vdseff/Vdssat)+betaLowId_Vdbulk_di*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId_Vsi_bi*(Vdseff_Vdbulk_di/Vdssat)+betaLowId*(Vdseff_Vdbulk_di_Vsi_bi/Vdssat-(Vdseff_Vdbulk_di*Vdssat_Vsi_bi+Vdseff_Vsi_bi*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*Vdssat_Vsi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat)))*qia_Vsi_bi+(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat))))*qia_Vdbulk_di+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdbulk_di_Vsi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdbulk_di*qia_Vsi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
#endif
T12_Vsbulk_si=((((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat)))*(pModel->TNOIK2+qia)-(betaLowId*(Vdseff/Vdssat))*qia_Vsbulk_si)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia));
#if defined(_DERIVATE2)
  T12_Vsbulk_si_Vdbulk_di=(+0.0+((+betaLowId_Vsbulk_si_Vdbulk_di*(Vdseff/Vdssat)+betaLowId_Vsbulk_si*(Vdseff_Vdbulk_di/Vdssat)+betaLowId_Vdbulk_di*(Vdseff_Vsbulk_si/Vdssat)+betaLowId*(Vdseff_Vsbulk_si_Vdbulk_di/Vdssat-(Vdseff_Vsbulk_si*0.0+Vdseff_Vdbulk_di*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat)))*qia_Vdbulk_di+(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat))))*qia_Vsbulk_si+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsbulk_si_Vdbulk_di))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsbulk_si*qia_Vdbulk_di/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsbulk_si_Vsbulk_si=(+0.0+((+betaLowId_Vsbulk_si_Vsbulk_si*(Vdseff/Vdssat)+betaLowId_Vsbulk_si*(Vdseff_Vsbulk_si/Vdssat)+betaLowId_Vsbulk_si*(Vdseff_Vsbulk_si/Vdssat)+betaLowId*(Vdseff_Vsbulk_si_Vsbulk_si/Vdssat-(Vdseff_Vsbulk_si*0.0+Vdseff_Vsbulk_si*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat)))*qia_Vsbulk_si+(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat))))*qia_Vsbulk_si+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsbulk_si_Vsbulk_si))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsbulk_si*qia_Vsbulk_si/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsbulk_si_Vgi_bi=(+0.0+((+betaLowId_Vsbulk_si_Vgi_bi*(Vdseff/Vdssat)+betaLowId_Vsbulk_si*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId_Vgi_bi*(Vdseff_Vsbulk_si/Vdssat)+betaLowId*(Vdseff_Vsbulk_si_Vgi_bi/Vdssat-(Vdseff_Vsbulk_si*Vdssat_Vgi_bi+Vdseff_Vgi_bi*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*Vdssat_Vgi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat)))*qia_Vgi_bi+(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat))))*qia_Vsbulk_si+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsbulk_si_Vgi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsbulk_si*qia_Vgi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsbulk_si_Tempt_GND=(+0.0+((+betaLowId_Vsbulk_si_Tempt_GND*(Vdseff/Vdssat)+betaLowId_Vsbulk_si*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat)+betaLowId_Tempt_GND*(Vdseff_Vsbulk_si/Vdssat)+betaLowId*(Vdseff_Vsbulk_si_Tempt_GND/Vdssat-(Vdseff_Vsbulk_si*Vdssat_Tempt_GND+Vdseff_Tempt_GND*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*Vdssat_Tempt_GND/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat)))*qia_Tempt_GND+(((betaLowId_Tempt_GND*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat))))*qia_Vsbulk_si+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsbulk_si_Tempt_GND))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsbulk_si*qia_Tempt_GND/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsbulk_si_Vdi_bi=(+0.0+((+betaLowId_Vsbulk_si_Vdi_bi*(Vdseff/Vdssat)+betaLowId_Vsbulk_si*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId_Vdi_bi*(Vdseff_Vsbulk_si/Vdssat)+betaLowId*(Vdseff_Vsbulk_si_Vdi_bi/Vdssat-(Vdseff_Vsbulk_si*Vdssat_Vdi_bi+Vdseff_Vdi_bi*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*Vdssat_Vdi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat)))*qia_Vdi_bi+(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat))))*qia_Vsbulk_si+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsbulk_si_Vdi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsbulk_si*qia_Vdi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsbulk_si_Vsi_bi=(+0.0+((+betaLowId_Vsbulk_si_Vsi_bi*(Vdseff/Vdssat)+betaLowId_Vsbulk_si*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId_Vsi_bi*(Vdseff_Vsbulk_si/Vdssat)+betaLowId*(Vdseff_Vsbulk_si_Vsi_bi/Vdssat-(Vdseff_Vsbulk_si*Vdssat_Vsi_bi+Vdseff_Vsi_bi*0.0+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*0.0*Vdssat_Vsi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat)))*qia_Vsi_bi+(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat))))*qia_Vsbulk_si+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsbulk_si_Vsi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsbulk_si*qia_Vsi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
#endif
T12_Vgi_bi=((((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)))*(pModel->TNOIK2+qia)-(betaLowId*(Vdseff/Vdssat))*qia_Vgi_bi)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia));
#if defined(_DERIVATE2)
  T12_Vgi_bi_Vdbulk_di=(+0.0+((+betaLowId_Vgi_bi_Vdbulk_di*(Vdseff/Vdssat)+betaLowId_Vgi_bi*(Vdseff_Vdbulk_di/Vdssat)+betaLowId_Vdbulk_di*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vgi_bi_Vdbulk_di/Vdssat-(Vdseff_Vgi_bi*0.0+Vdseff_Vdbulk_di*Vdssat_Vgi_bi+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vgi_bi*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)))*qia_Vdbulk_di+(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat))))*qia_Vgi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vgi_bi_Vdbulk_di))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vgi_bi*qia_Vdbulk_di/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vgi_bi_Vsbulk_si=(+0.0+((+betaLowId_Vgi_bi_Vsbulk_si*(Vdseff/Vdssat)+betaLowId_Vgi_bi*(Vdseff_Vsbulk_si/Vdssat)+betaLowId_Vsbulk_si*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vgi_bi_Vsbulk_si/Vdssat-(Vdseff_Vgi_bi*0.0+Vdseff_Vsbulk_si*Vdssat_Vgi_bi+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vgi_bi*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)))*qia_Vsbulk_si+(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat))))*qia_Vgi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vgi_bi_Vsbulk_si))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vgi_bi*qia_Vsbulk_si/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vgi_bi_Vgi_bi=(+0.0+((+betaLowId_Vgi_bi_Vgi_bi*(Vdseff/Vdssat)+betaLowId_Vgi_bi*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId_Vgi_bi*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vgi_bi_Vgi_bi/Vdssat-(Vdseff_Vgi_bi*Vdssat_Vgi_bi+Vdseff_Vgi_bi*Vdssat_Vgi_bi+Vdseff*Vdssat_Vgi_bi_Vgi_bi)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vgi_bi*Vdssat_Vgi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)))*qia_Vgi_bi+(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat))))*qia_Vgi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vgi_bi_Vgi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vgi_bi*qia_Vgi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vgi_bi_Tempt_GND=(+0.0+((+betaLowId_Vgi_bi_Tempt_GND*(Vdseff/Vdssat)+betaLowId_Vgi_bi*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat)+betaLowId_Tempt_GND*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vgi_bi_Tempt_GND/Vdssat-(Vdseff_Vgi_bi*Vdssat_Tempt_GND+Vdseff_Tempt_GND*Vdssat_Vgi_bi+Vdseff*Vdssat_Vgi_bi_Tempt_GND)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vgi_bi*Vdssat_Tempt_GND/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)))*qia_Tempt_GND+(((betaLowId_Tempt_GND*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat))))*qia_Vgi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vgi_bi_Tempt_GND))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vgi_bi*qia_Tempt_GND/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vgi_bi_Vdi_bi=(+0.0+((+betaLowId_Vgi_bi_Vdi_bi*(Vdseff/Vdssat)+betaLowId_Vgi_bi*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId_Vdi_bi*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vgi_bi_Vdi_bi/Vdssat-(Vdseff_Vgi_bi*Vdssat_Vdi_bi+Vdseff_Vdi_bi*Vdssat_Vgi_bi+Vdseff*Vdssat_Vgi_bi_Vdi_bi)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vgi_bi*Vdssat_Vdi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)))*qia_Vdi_bi+(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat))))*qia_Vgi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vgi_bi_Vdi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vgi_bi*qia_Vdi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vgi_bi_Vsi_bi=(+0.0+((+betaLowId_Vgi_bi_Vsi_bi*(Vdseff/Vdssat)+betaLowId_Vgi_bi*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId_Vsi_bi*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vgi_bi_Vsi_bi/Vdssat-(Vdseff_Vgi_bi*Vdssat_Vsi_bi+Vdseff_Vsi_bi*Vdssat_Vgi_bi+Vdseff*Vdssat_Vgi_bi_Vsi_bi)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vgi_bi*Vdssat_Vsi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)))*qia_Vsi_bi+(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat))))*qia_Vgi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vgi_bi_Vsi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vgi_bi*qia_Vsi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
#endif
#if defined(_DERIVATE)
T12_Tempt_GND=((((betaLowId_Tempt_GND*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat)))*(pModel->TNOIK2+qia)-(betaLowId*(Vdseff/Vdssat))*qia_Tempt_GND)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia));
#endif
T12_Vdi_bi=((((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)))*(pModel->TNOIK2+qia)-(betaLowId*(Vdseff/Vdssat))*qia_Vdi_bi)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia));
#if defined(_DERIVATE2)
  T12_Vdi_bi_Vdbulk_di=(+0.0+((+betaLowId_Vdi_bi_Vdbulk_di*(Vdseff/Vdssat)+betaLowId_Vdi_bi*(Vdseff_Vdbulk_di/Vdssat)+betaLowId_Vdbulk_di*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vdi_bi_Vdbulk_di/Vdssat-(Vdseff_Vdi_bi*0.0+Vdseff_Vdbulk_di*Vdssat_Vdi_bi+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vdi_bi*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)))*qia_Vdbulk_di+(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat))))*qia_Vdi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdi_bi_Vdbulk_di))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdi_bi*qia_Vdbulk_di/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdi_bi_Vsbulk_si=(+0.0+((+betaLowId_Vdi_bi_Vsbulk_si*(Vdseff/Vdssat)+betaLowId_Vdi_bi*(Vdseff_Vsbulk_si/Vdssat)+betaLowId_Vsbulk_si*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vdi_bi_Vsbulk_si/Vdssat-(Vdseff_Vdi_bi*0.0+Vdseff_Vsbulk_si*Vdssat_Vdi_bi+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vdi_bi*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)))*qia_Vsbulk_si+(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat))))*qia_Vdi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdi_bi_Vsbulk_si))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdi_bi*qia_Vsbulk_si/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdi_bi_Vgi_bi=(+0.0+((+betaLowId_Vdi_bi_Vgi_bi*(Vdseff/Vdssat)+betaLowId_Vdi_bi*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId_Vgi_bi*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vdi_bi_Vgi_bi/Vdssat-(Vdseff_Vdi_bi*Vdssat_Vgi_bi+Vdseff_Vgi_bi*Vdssat_Vdi_bi+Vdseff*Vdssat_Vdi_bi_Vgi_bi)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vdi_bi*Vdssat_Vgi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)))*qia_Vgi_bi+(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat))))*qia_Vdi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdi_bi_Vgi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdi_bi*qia_Vgi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdi_bi_Tempt_GND=(+0.0+((+betaLowId_Vdi_bi_Tempt_GND*(Vdseff/Vdssat)+betaLowId_Vdi_bi*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat)+betaLowId_Tempt_GND*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vdi_bi_Tempt_GND/Vdssat-(Vdseff_Vdi_bi*Vdssat_Tempt_GND+Vdseff_Tempt_GND*Vdssat_Vdi_bi+Vdseff*Vdssat_Vdi_bi_Tempt_GND)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vdi_bi*Vdssat_Tempt_GND/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)))*qia_Tempt_GND+(((betaLowId_Tempt_GND*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat))))*qia_Vdi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdi_bi_Tempt_GND))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdi_bi*qia_Tempt_GND/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdi_bi_Vdi_bi=(+0.0+((+betaLowId_Vdi_bi_Vdi_bi*(Vdseff/Vdssat)+betaLowId_Vdi_bi*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId_Vdi_bi*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vdi_bi_Vdi_bi/Vdssat-(Vdseff_Vdi_bi*Vdssat_Vdi_bi+Vdseff_Vdi_bi*Vdssat_Vdi_bi+Vdseff*Vdssat_Vdi_bi_Vdi_bi)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vdi_bi*Vdssat_Vdi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)))*qia_Vdi_bi+(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat))))*qia_Vdi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdi_bi_Vdi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdi_bi*qia_Vdi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vdi_bi_Vsi_bi=(+0.0+((+betaLowId_Vdi_bi_Vsi_bi*(Vdseff/Vdssat)+betaLowId_Vdi_bi*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId_Vsi_bi*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vdi_bi_Vsi_bi/Vdssat-(Vdseff_Vdi_bi*Vdssat_Vsi_bi+Vdseff_Vsi_bi*Vdssat_Vdi_bi+Vdseff*Vdssat_Vdi_bi_Vsi_bi)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vdi_bi*Vdssat_Vsi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)))*qia_Vsi_bi+(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat))))*qia_Vdi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vdi_bi_Vsi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vdi_bi*qia_Vsi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
#endif
T12_Vsi_bi=((((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)))*(pModel->TNOIK2+qia)-(betaLowId*(Vdseff/Vdssat))*qia_Vsi_bi)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia));
#if defined(_DERIVATE2)
  T12_Vsi_bi_Vdbulk_di=(+0.0+((+betaLowId_Vsi_bi_Vdbulk_di*(Vdseff/Vdssat)+betaLowId_Vsi_bi*(Vdseff_Vdbulk_di/Vdssat)+betaLowId_Vdbulk_di*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vsi_bi_Vdbulk_di/Vdssat-(Vdseff_Vsi_bi*0.0+Vdseff_Vdbulk_di*Vdssat_Vsi_bi+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vsi_bi*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)))*qia_Vdbulk_di+(((betaLowId_Vdbulk_di*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vdbulk_di/Vdssat))))*qia_Vsi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsi_bi_Vdbulk_di))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsi_bi*qia_Vdbulk_di/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsi_bi_Vsbulk_si=(+0.0+((+betaLowId_Vsi_bi_Vsbulk_si*(Vdseff/Vdssat)+betaLowId_Vsi_bi*(Vdseff_Vsbulk_si/Vdssat)+betaLowId_Vsbulk_si*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vsi_bi_Vsbulk_si/Vdssat-(Vdseff_Vsi_bi*0.0+Vdseff_Vsbulk_si*Vdssat_Vsi_bi+Vdseff*0.0)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vsi_bi*0.0/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)))*qia_Vsbulk_si+(((betaLowId_Vsbulk_si*(Vdseff/Vdssat))+(betaLowId*(Vdseff_Vsbulk_si/Vdssat))))*qia_Vsi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsi_bi_Vsbulk_si))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsi_bi*qia_Vsbulk_si/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsi_bi_Vgi_bi=(+0.0+((+betaLowId_Vsi_bi_Vgi_bi*(Vdseff/Vdssat)+betaLowId_Vsi_bi*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat)+betaLowId_Vgi_bi*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vsi_bi_Vgi_bi/Vdssat-(Vdseff_Vsi_bi*Vdssat_Vgi_bi+Vdseff_Vgi_bi*Vdssat_Vsi_bi+Vdseff*Vdssat_Vsi_bi_Vgi_bi)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vsi_bi*Vdssat_Vgi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)))*qia_Vgi_bi+(((betaLowId_Vgi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vgi_bi*Vdssat-Vdseff*Vdssat_Vgi_bi)/Vdssat/Vdssat))))*qia_Vsi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsi_bi_Vgi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsi_bi*qia_Vgi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsi_bi_Tempt_GND=(+0.0+((+betaLowId_Vsi_bi_Tempt_GND*(Vdseff/Vdssat)+betaLowId_Vsi_bi*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat)+betaLowId_Tempt_GND*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vsi_bi_Tempt_GND/Vdssat-(Vdseff_Vsi_bi*Vdssat_Tempt_GND+Vdseff_Tempt_GND*Vdssat_Vsi_bi+Vdseff*Vdssat_Vsi_bi_Tempt_GND)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vsi_bi*Vdssat_Tempt_GND/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)))*qia_Tempt_GND+(((betaLowId_Tempt_GND*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Tempt_GND*Vdssat-Vdseff*Vdssat_Tempt_GND)/Vdssat/Vdssat))))*qia_Vsi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsi_bi_Tempt_GND))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsi_bi*qia_Tempt_GND/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsi_bi_Vdi_bi=(+0.0+((+betaLowId_Vsi_bi_Vdi_bi*(Vdseff/Vdssat)+betaLowId_Vsi_bi*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat)+betaLowId_Vdi_bi*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vsi_bi_Vdi_bi/Vdssat-(Vdseff_Vsi_bi*Vdssat_Vdi_bi+Vdseff_Vdi_bi*Vdssat_Vsi_bi+Vdseff*Vdssat_Vsi_bi_Vdi_bi)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vsi_bi*Vdssat_Vdi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)))*qia_Vdi_bi+(((betaLowId_Vdi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vdi_bi*Vdssat-Vdseff*Vdssat_Vdi_bi)/Vdssat/Vdssat))))*qia_Vsi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsi_bi_Vdi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsi_bi*qia_Vdi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
  T12_Vsi_bi_Vsi_bi=(+0.0+((+betaLowId_Vsi_bi_Vsi_bi*(Vdseff/Vdssat)+betaLowId_Vsi_bi*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId_Vsi_bi*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)+betaLowId*(Vdseff_Vsi_bi_Vsi_bi/Vdssat-(Vdseff_Vsi_bi*Vdssat_Vsi_bi+Vdseff_Vsi_bi*Vdssat_Vsi_bi+Vdseff*Vdssat_Vsi_bi_Vsi_bi)/Vdssat/Vdssat+2*Vdseff*Vdssat_Vsi_bi*Vdssat_Vsi_bi/Vdssat/Vdssat/Vdssat))/(pModel->TNOIK2+qia)-(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat)))*qia_Vsi_bi+(((betaLowId_Vsi_bi*(Vdseff/Vdssat))+(betaLowId*((Vdseff_Vsi_bi*Vdssat-Vdseff*Vdssat_Vsi_bi)/Vdssat/Vdssat))))*qia_Vsi_bi+(betaLowId*(Vdseff/Vdssat))*(+0.0+qia_Vsi_bi_Vsi_bi))/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)+2*(betaLowId*(Vdseff/Vdssat))*qia_Vsi_bi*qia_Vsi_bi/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)/(pModel->TNOIK2+qia)));
#endif
#endif
T12=(1.0+((betaLowId*(Vdseff/Vdssat))/(pModel->TNOIK2+qia)));
EXIT_IF_ISNAN((1.0+((betaLowId*(Vdseff/Vdssat))/(pModel->TNOIK2+qia))))
{
double m00_exp(d00_exp0,((-Leff)/pModel->LP))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
T12_Vdbulk_di=T12_Vdbulk_di*d00_exp0;
#if defined(_DERIVATE2)
  T12_Vdbulk_di_Vdbulk_di=(+(+(+T12_Vdbulk_di_Vdbulk_di-0.0)*d00_exp0+T12_Vdbulk_di*0.0+T12_Vdbulk_di*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdbulk_di_Vsbulk_si=(+(+(+T12_Vdbulk_di_Vsbulk_si-0.0)*d00_exp0+T12_Vdbulk_di*0.0+T12_Vsbulk_si*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdbulk_di_Vgi_bi=(+(+(+T12_Vdbulk_di_Vgi_bi-0.0)*d00_exp0+T12_Vdbulk_di*0.0+T12_Vgi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdbulk_di_Tempt_GND=(+(+(+T12_Vdbulk_di_Tempt_GND-0.0)*d00_exp0+T12_Vdbulk_di*0.0+T12_Tempt_GND*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdbulk_di_Vdi_bi=(+(+(+T12_Vdbulk_di_Vdi_bi-0.0)*d00_exp0+T12_Vdbulk_di*0.0+T12_Vdi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdbulk_di_Vsi_bi=(+(+(+T12_Vdbulk_di_Vsi_bi-0.0)*d00_exp0+T12_Vdbulk_di*0.0+T12_Vsi_bi*0.0+(T12-1.0)*0.0)+0.0);
#endif
T12_Vsbulk_si=T12_Vsbulk_si*d00_exp0;
#if defined(_DERIVATE2)
  T12_Vsbulk_si_Vdbulk_di=(+(+(+T12_Vsbulk_si_Vdbulk_di-0.0)*d00_exp0+T12_Vsbulk_si*0.0+T12_Vdbulk_di*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsbulk_si_Vsbulk_si=(+(+(+T12_Vsbulk_si_Vsbulk_si-0.0)*d00_exp0+T12_Vsbulk_si*0.0+T12_Vsbulk_si*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsbulk_si_Vgi_bi=(+(+(+T12_Vsbulk_si_Vgi_bi-0.0)*d00_exp0+T12_Vsbulk_si*0.0+T12_Vgi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsbulk_si_Tempt_GND=(+(+(+T12_Vsbulk_si_Tempt_GND-0.0)*d00_exp0+T12_Vsbulk_si*0.0+T12_Tempt_GND*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsbulk_si_Vdi_bi=(+(+(+T12_Vsbulk_si_Vdi_bi-0.0)*d00_exp0+T12_Vsbulk_si*0.0+T12_Vdi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsbulk_si_Vsi_bi=(+(+(+T12_Vsbulk_si_Vsi_bi-0.0)*d00_exp0+T12_Vsbulk_si*0.0+T12_Vsi_bi*0.0+(T12-1.0)*0.0)+0.0);
#endif
T12_Vgi_bi=T12_Vgi_bi*d00_exp0;
#if defined(_DERIVATE2)
  T12_Vgi_bi_Vdbulk_di=(+(+(+T12_Vgi_bi_Vdbulk_di-0.0)*d00_exp0+T12_Vgi_bi*0.0+T12_Vdbulk_di*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vgi_bi_Vsbulk_si=(+(+(+T12_Vgi_bi_Vsbulk_si-0.0)*d00_exp0+T12_Vgi_bi*0.0+T12_Vsbulk_si*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vgi_bi_Vgi_bi=(+(+(+T12_Vgi_bi_Vgi_bi-0.0)*d00_exp0+T12_Vgi_bi*0.0+T12_Vgi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vgi_bi_Tempt_GND=(+(+(+T12_Vgi_bi_Tempt_GND-0.0)*d00_exp0+T12_Vgi_bi*0.0+T12_Tempt_GND*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vgi_bi_Vdi_bi=(+(+(+T12_Vgi_bi_Vdi_bi-0.0)*d00_exp0+T12_Vgi_bi*0.0+T12_Vdi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vgi_bi_Vsi_bi=(+(+(+T12_Vgi_bi_Vsi_bi-0.0)*d00_exp0+T12_Vgi_bi*0.0+T12_Vsi_bi*0.0+(T12-1.0)*0.0)+0.0);
#endif
#if defined(_DERIVATE)
T12_Tempt_GND=T12_Tempt_GND*d00_exp0;
#endif
T12_Vdi_bi=T12_Vdi_bi*d00_exp0;
#if defined(_DERIVATE2)
  T12_Vdi_bi_Vdbulk_di=(+(+(+T12_Vdi_bi_Vdbulk_di-0.0)*d00_exp0+T12_Vdi_bi*0.0+T12_Vdbulk_di*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdi_bi_Vsbulk_si=(+(+(+T12_Vdi_bi_Vsbulk_si-0.0)*d00_exp0+T12_Vdi_bi*0.0+T12_Vsbulk_si*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdi_bi_Vgi_bi=(+(+(+T12_Vdi_bi_Vgi_bi-0.0)*d00_exp0+T12_Vdi_bi*0.0+T12_Vgi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdi_bi_Tempt_GND=(+(+(+T12_Vdi_bi_Tempt_GND-0.0)*d00_exp0+T12_Vdi_bi*0.0+T12_Tempt_GND*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdi_bi_Vdi_bi=(+(+(+T12_Vdi_bi_Vdi_bi-0.0)*d00_exp0+T12_Vdi_bi*0.0+T12_Vdi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vdi_bi_Vsi_bi=(+(+(+T12_Vdi_bi_Vsi_bi-0.0)*d00_exp0+T12_Vdi_bi*0.0+T12_Vsi_bi*0.0+(T12-1.0)*0.0)+0.0);
#endif
T12_Vsi_bi=T12_Vsi_bi*d00_exp0;
#if defined(_DERIVATE2)
  T12_Vsi_bi_Vdbulk_di=(+(+(+T12_Vsi_bi_Vdbulk_di-0.0)*d00_exp0+T12_Vsi_bi*0.0+T12_Vdbulk_di*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsi_bi_Vsbulk_si=(+(+(+T12_Vsi_bi_Vsbulk_si-0.0)*d00_exp0+T12_Vsi_bi*0.0+T12_Vsbulk_si*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsi_bi_Vgi_bi=(+(+(+T12_Vsi_bi_Vgi_bi-0.0)*d00_exp0+T12_Vsi_bi*0.0+T12_Vgi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsi_bi_Tempt_GND=(+(+(+T12_Vsi_bi_Tempt_GND-0.0)*d00_exp0+T12_Vsi_bi*0.0+T12_Tempt_GND*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsi_bi_Vdi_bi=(+(+(+T12_Vsi_bi_Vdi_bi-0.0)*d00_exp0+T12_Vsi_bi*0.0+T12_Vdi_bi*0.0+(T12-1.0)*0.0)+0.0);
  T12_Vsi_bi_Vsi_bi=(+(+(+T12_Vsi_bi_Vsi_bi-0.0)*d00_exp0+T12_Vsi_bi*0.0+T12_Vsi_bi*0.0+(T12-1.0)*0.0)+0.0);
#endif
#endif
T12=(((T12-1.0)*d00_exp0)+1.0);
EXIT_IF_ISNAN((((T12-1.0)*d00_exp0)+1.0))
}
{
double m00_sqrt(d00_sqrt0,((T12*T12)+((0.25*1.0e-1)*1.0e-1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T12*T12)+((0.25*1.0e-1)*1.0e-1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
T12_Vdbulk_di=(0.5*(T12_Vdbulk_di+((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T12_Vdbulk_di_Vdbulk_di=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdbulk_di+((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdbulk_di+((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T12_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))+d10_sqrt0*(+(+(+T12_Vdbulk_di_Vdbulk_di-0.0)*T12+T12_Vdbulk_di*T12_Vdbulk_di+T12_Vdbulk_di*T12_Vdbulk_di+T12*(+T12_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdbulk_di_Vsbulk_si=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsbulk_si+((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdbulk_di+((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T12_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))+d10_sqrt0*(+(+(+T12_Vdbulk_di_Vsbulk_si-0.0)*T12+T12_Vdbulk_di*T12_Vsbulk_si+T12_Vsbulk_si*T12_Vdbulk_di+T12*(+T12_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdbulk_di_Vgi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vgi_bi+((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdbulk_di+((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T12_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))+d10_sqrt0*(+(+(+T12_Vdbulk_di_Vgi_bi-0.0)*T12+T12_Vdbulk_di*T12_Vgi_bi+T12_Vgi_bi*T12_Vdbulk_di+T12*(+T12_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdbulk_di_Tempt_GND=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Tempt_GND+((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdbulk_di+((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T12_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))+d10_sqrt0*(+(+(+T12_Vdbulk_di_Tempt_GND-0.0)*T12+T12_Vdbulk_di*T12_Tempt_GND+T12_Tempt_GND*T12_Vdbulk_di+T12*(+T12_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdbulk_di_Vdi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdi_bi+((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdbulk_di+((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T12_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))+d10_sqrt0*(+(+(+T12_Vdbulk_di_Vdi_bi-0.0)*T12+T12_Vdbulk_di*T12_Vdi_bi+T12_Vdi_bi*T12_Vdbulk_di+T12*(+T12_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdbulk_di_Vsi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsi_bi+((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdbulk_di+((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T12_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di))+d10_sqrt0*(+(+(+T12_Vdbulk_di_Vsi_bi-0.0)*T12+T12_Vdbulk_di*T12_Vsi_bi+T12_Vsi_bi*T12_Vdbulk_di+T12*(+T12_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
#endif
T12_Vsbulk_si=(0.5*(T12_Vsbulk_si+((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T12_Vsbulk_si_Vdbulk_di=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdbulk_di+((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsbulk_si+((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T12_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))+d10_sqrt0*(+(+(+T12_Vsbulk_si_Vdbulk_di-0.0)*T12+T12_Vsbulk_si*T12_Vdbulk_di+T12_Vdbulk_di*T12_Vsbulk_si+T12*(+T12_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsbulk_si_Vsbulk_si=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsbulk_si+((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsbulk_si+((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T12_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))+d10_sqrt0*(+(+(+T12_Vsbulk_si_Vsbulk_si-0.0)*T12+T12_Vsbulk_si*T12_Vsbulk_si+T12_Vsbulk_si*T12_Vsbulk_si+T12*(+T12_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsbulk_si_Vgi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vgi_bi+((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsbulk_si+((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T12_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))+d10_sqrt0*(+(+(+T12_Vsbulk_si_Vgi_bi-0.0)*T12+T12_Vsbulk_si*T12_Vgi_bi+T12_Vgi_bi*T12_Vsbulk_si+T12*(+T12_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsbulk_si_Tempt_GND=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Tempt_GND+((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsbulk_si+((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T12_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))+d10_sqrt0*(+(+(+T12_Vsbulk_si_Tempt_GND-0.0)*T12+T12_Vsbulk_si*T12_Tempt_GND+T12_Tempt_GND*T12_Vsbulk_si+T12*(+T12_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsbulk_si_Vdi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdi_bi+((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsbulk_si+((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T12_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))+d10_sqrt0*(+(+(+T12_Vsbulk_si_Vdi_bi-0.0)*T12+T12_Vsbulk_si*T12_Vdi_bi+T12_Vdi_bi*T12_Vsbulk_si+T12*(+T12_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsbulk_si_Vsi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsi_bi+((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsbulk_si+((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T12_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si))+d10_sqrt0*(+(+(+T12_Vsbulk_si_Vsi_bi-0.0)*T12+T12_Vsbulk_si*T12_Vsi_bi+T12_Vsi_bi*T12_Vsbulk_si+T12*(+T12_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
#endif
T12_Vgi_bi=(0.5*(T12_Vgi_bi+((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T12_Vgi_bi_Vdbulk_di=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdbulk_di+((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vgi_bi+((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))*d10_sqrt0)+0.5*(+(+T12_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))+d10_sqrt0*(+(+(+T12_Vgi_bi_Vdbulk_di-0.0)*T12+T12_Vgi_bi*T12_Vdbulk_di+T12_Vdbulk_di*T12_Vgi_bi+T12*(+T12_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vgi_bi_Vsbulk_si=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsbulk_si+((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vgi_bi+((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))*d10_sqrt0)+0.5*(+(+T12_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))+d10_sqrt0*(+(+(+T12_Vgi_bi_Vsbulk_si-0.0)*T12+T12_Vgi_bi*T12_Vsbulk_si+T12_Vsbulk_si*T12_Vgi_bi+T12*(+T12_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vgi_bi_Vgi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vgi_bi+((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vgi_bi+((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))*d10_sqrt0)+0.5*(+(+T12_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))+d10_sqrt0*(+(+(+T12_Vgi_bi_Vgi_bi-0.0)*T12+T12_Vgi_bi*T12_Vgi_bi+T12_Vgi_bi*T12_Vgi_bi+T12*(+T12_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vgi_bi_Tempt_GND=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Tempt_GND+((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vgi_bi+((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))*d10_sqrt0)+0.5*(+(+T12_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))+d10_sqrt0*(+(+(+T12_Vgi_bi_Tempt_GND-0.0)*T12+T12_Vgi_bi*T12_Tempt_GND+T12_Tempt_GND*T12_Vgi_bi+T12*(+T12_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vgi_bi_Vdi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdi_bi+((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vgi_bi+((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))*d10_sqrt0)+0.5*(+(+T12_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))+d10_sqrt0*(+(+(+T12_Vgi_bi_Vdi_bi-0.0)*T12+T12_Vgi_bi*T12_Vdi_bi+T12_Vdi_bi*T12_Vgi_bi+T12*(+T12_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vgi_bi_Vsi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsi_bi+((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vgi_bi+((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))*d10_sqrt0)+0.5*(+(+T12_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi))+d10_sqrt0*(+(+(+T12_Vgi_bi_Vsi_bi-0.0)*T12+T12_Vgi_bi*T12_Vsi_bi+T12_Vsi_bi*T12_Vgi_bi+T12*(+T12_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
#endif
#if defined(_DERIVATE)
T12_Tempt_GND=(0.5*(T12_Tempt_GND+((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND))*d10_sqrt0));
#endif
T12_Vdi_bi=(0.5*(T12_Vdi_bi+((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T12_Vdi_bi_Vdbulk_di=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdbulk_di+((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdi_bi+((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))*d10_sqrt0)+0.5*(+(+T12_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))+d10_sqrt0*(+(+(+T12_Vdi_bi_Vdbulk_di-0.0)*T12+T12_Vdi_bi*T12_Vdbulk_di+T12_Vdbulk_di*T12_Vdi_bi+T12*(+T12_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdi_bi_Vsbulk_si=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsbulk_si+((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdi_bi+((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))*d10_sqrt0)+0.5*(+(+T12_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))+d10_sqrt0*(+(+(+T12_Vdi_bi_Vsbulk_si-0.0)*T12+T12_Vdi_bi*T12_Vsbulk_si+T12_Vsbulk_si*T12_Vdi_bi+T12*(+T12_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdi_bi_Vgi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vgi_bi+((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdi_bi+((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))*d10_sqrt0)+0.5*(+(+T12_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))+d10_sqrt0*(+(+(+T12_Vdi_bi_Vgi_bi-0.0)*T12+T12_Vdi_bi*T12_Vgi_bi+T12_Vgi_bi*T12_Vdi_bi+T12*(+T12_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdi_bi_Tempt_GND=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Tempt_GND+((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdi_bi+((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))*d10_sqrt0)+0.5*(+(+T12_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))+d10_sqrt0*(+(+(+T12_Vdi_bi_Tempt_GND-0.0)*T12+T12_Vdi_bi*T12_Tempt_GND+T12_Tempt_GND*T12_Vdi_bi+T12*(+T12_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdi_bi_Vdi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdi_bi+((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdi_bi+((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))*d10_sqrt0)+0.5*(+(+T12_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))+d10_sqrt0*(+(+(+T12_Vdi_bi_Vdi_bi-0.0)*T12+T12_Vdi_bi*T12_Vdi_bi+T12_Vdi_bi*T12_Vdi_bi+T12*(+T12_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vdi_bi_Vsi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsi_bi+((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vdi_bi+((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))*d10_sqrt0)+0.5*(+(+T12_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi))+d10_sqrt0*(+(+(+T12_Vdi_bi_Vsi_bi-0.0)*T12+T12_Vdi_bi*T12_Vsi_bi+T12_Vsi_bi*T12_Vdi_bi+T12*(+T12_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
#endif
T12_Vsi_bi=(0.5*(T12_Vsi_bi+((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T12_Vsi_bi_Vdbulk_di=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdbulk_di+((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsi_bi+((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))*d10_sqrt0)+0.5*(+(+T12_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdbulk_di*T12)+(T12*T12_Vdbulk_di)))+((0.0)*1.0e-1))*((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))+d10_sqrt0*(+(+(+T12_Vsi_bi_Vdbulk_di-0.0)*T12+T12_Vsi_bi*T12_Vdbulk_di+T12_Vdbulk_di*T12_Vsi_bi+T12*(+T12_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsi_bi_Vsbulk_si=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsbulk_si+((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsi_bi+((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))*d10_sqrt0)+0.5*(+(+T12_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsbulk_si*T12)+(T12*T12_Vsbulk_si)))+((0.0)*1.0e-1))*((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))+d10_sqrt0*(+(+(+T12_Vsi_bi_Vsbulk_si-0.0)*T12+T12_Vsi_bi*T12_Vsbulk_si+T12_Vsbulk_si*T12_Vsi_bi+T12*(+T12_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsi_bi_Vgi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vgi_bi+((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsi_bi+((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))*d10_sqrt0)+0.5*(+(+T12_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vgi_bi*T12)+(T12*T12_Vgi_bi)))+((0.0)*1.0e-1))*((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))+d10_sqrt0*(+(+(+T12_Vsi_bi_Vgi_bi-0.0)*T12+T12_Vsi_bi*T12_Vgi_bi+T12_Vgi_bi*T12_Vsi_bi+T12*(+T12_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsi_bi_Tempt_GND=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Tempt_GND+((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsi_bi+((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))*d10_sqrt0)+0.5*(+(+T12_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Tempt_GND*T12)+(T12*T12_Tempt_GND)))+((0.0)*1.0e-1))*((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))+d10_sqrt0*(+(+(+T12_Vsi_bi_Tempt_GND-0.0)*T12+T12_Vsi_bi*T12_Tempt_GND+T12_Tempt_GND*T12_Vsi_bi+T12*(+T12_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsi_bi_Vdi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vdi_bi+((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsi_bi+((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))*d10_sqrt0)+0.5*(+(+T12_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vdi_bi*T12)+(T12*T12_Vdi_bi)))+((0.0)*1.0e-1))*((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))+d10_sqrt0*(+(+(+T12_Vsi_bi_Vdi_bi-0.0)*T12+T12_Vsi_bi*T12_Vdi_bi+T12_Vdi_bi*T12_Vsi_bi+T12*(+T12_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
  T12_Vsi_bi_Vsi_bi=(+0.0*(T12+d00_sqrt0)+0.0*(T12_Vsi_bi+((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*d10_sqrt0)+0.0*(T12_Vsi_bi+((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))*d10_sqrt0)+0.5*(+(+T12_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt(((T12*T12)+((0.25*1.0e-1)*1.0e-1)))*((((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi)))+((0.0)*1.0e-1))*((T12_Vsi_bi*T12)+(T12*T12_Vsi_bi))+d10_sqrt0*(+(+(+T12_Vsi_bi_Vsi_bi-0.0)*T12+T12_Vsi_bi*T12_Vsi_bi+T12_Vsi_bi*T12_Vsi_bi+T12*(+T12_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*1.0e-1+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-1+0.0*0.0+(0.0)*0.0+(0.25*1.0e-1)*0.0)))));
#endif
#endif
T12=(0.5*(T12+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T12+d00_sqrt0)))
}
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
mid_Vdbulk_di=(((T0_Vdbulk_di*pInst->NF*Weff/Lvsat)*((T1*T12)+((T7*betanoisq)/(12.0*T3))))+((((T0*pInst->NF)*Weff)/Lvsat)*(((T1_Vdbulk_di*T12)+(T1*T12_Vdbulk_di))+((((T7_Vdbulk_di*betanoisq)+(T7*betanoisq_Vdbulk_di))*(12.0*T3)-(T7*betanoisq)*(12.0*T3_Vdbulk_di))/(12.0*T3)/(12.0*T3)))));
mid_Vsbulk_si=(((T0_Vsbulk_si*pInst->NF*Weff/Lvsat)*((T1*T12)+((T7*betanoisq)/(12.0*T3))))+((((T0*pInst->NF)*Weff)/Lvsat)*(((T1_Vsbulk_si*T12)+(T1*T12_Vsbulk_si))+((((T7_Vsbulk_si*betanoisq)+(T7*betanoisq_Vsbulk_si))*(12.0*T3)-(T7*betanoisq)*(12.0*T3_Vsbulk_si))/(12.0*T3)/(12.0*T3)))));
mid_Vgi_bi=((((T0_Vgi_bi*pInst->NF*Weff*Lvsat-((T0*pInst->NF)*Weff)*Lvsat_Vgi_bi)/Lvsat/Lvsat)*((T1*T12)+((T7*betanoisq)/(12.0*T3))))+((((T0*pInst->NF)*Weff)/Lvsat)*(((T1_Vgi_bi*T12)+(T1*T12_Vgi_bi))+((((T7_Vgi_bi*betanoisq)+(T7*betanoisq_Vgi_bi))*(12.0*T3)-(T7*betanoisq)*(12.0*T3_Vgi_bi))/(12.0*T3)/(12.0*T3)))));
mid_Vdi_bi=((((T0_Vdi_bi*pInst->NF*Weff*Lvsat-((T0*pInst->NF)*Weff)*Lvsat_Vdi_bi)/Lvsat/Lvsat)*((T1*T12)+((T7*betanoisq)/(12.0*T3))))+((((T0*pInst->NF)*Weff)/Lvsat)*(((T1_Vdi_bi*T12)+(T1*T12_Vdi_bi))+((((T7_Vdi_bi*betanoisq)+(T7*betanoisq_Vdi_bi))*(12.0*T3)-(T7*betanoisq)*(12.0*T3_Vdi_bi))/(12.0*T3)/(12.0*T3)))));
mid_Vsi_bi=((((T0_Vsi_bi*pInst->NF*Weff*Lvsat-((T0*pInst->NF)*Weff)*Lvsat_Vsi_bi)/Lvsat/Lvsat)*((T1*T12)+((T7*betanoisq)/(12.0*T3))))+((((T0*pInst->NF)*Weff)/Lvsat)*(((T1_Vsi_bi*T12)+(T1*T12_Vsi_bi))+((((T7_Vsi_bi*betanoisq)+(T7*betanoisq_Vsi_bi))*(12.0*T3)-(T7*betanoisq)*(12.0*T3_Vsi_bi))/(12.0*T3)/(12.0*T3)))));
mid_Tempt_GND=((((T0_Tempt_GND*pInst->NF*Weff*Lvsat-((T0*pInst->NF)*Weff)*Lvsat_Tempt_GND)/Lvsat/Lvsat)*((T1*T12)+((T7*betanoisq)/(12.0*T3))))+((((T0*pInst->NF)*Weff)/Lvsat)*(((T1_Tempt_GND*T12)+(T1*T12_Tempt_GND))+((((T7_Tempt_GND*betanoisq)+(T7*betanoisq_Tempt_GND))*(12.0*T3)-(T7*betanoisq)*(12.0*T3_Tempt_GND))/(12.0*T3)/(12.0*T3)))));
#endif
mid=((((T0*pInst->NF)*Weff)/Lvsat)*((T1*T12)+((T7*betanoisq)/(12.0*T3))));
EXIT_IF_ISNAN(((((T0*pInst->NF)*Weff)/Lvsat)*((T1*T12)+((T7*betanoisq)/(12.0*T3)))))
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(dbulk,di)V(sbulk,si) ddxprobe= */
mig_Vgi_bi=(((((((((((Lvsat_Vgi_bi*T10)+(Lvsat*T10_Vgi_bi))*T10)+((Lvsat*T10)*T10_Vgi_bi))*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))+(((Lvsat*T10)*T10)*((((T1_Vgi_bi*T4-T1*T4_Vgi_bi)/T4/T4)-((T9_Vgi_bi*((60.0*T4)*T4)-T9*(((60.0*T4_Vgi_bi)*T4)+((60.0*T4)*T4_Vgi_bi)))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((T7_Vgi_bi*T7)+(T7*T7_Vgi_bi))*((144.0*T4)*T5)-(T7*T7)*(((144.0*T4_Vgi_bi)*T5)+((144.0*T4)*T5_Vgi_bi)))/((144.0*T4)*T5)/((144.0*T4)*T5)))))*15.0/4.0)*thetanoisq)+((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq_Vgi_bi))*(((pInst->NF*Weff)*12.0)*T0)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*(((pInst->NF*Weff)*12.0)*T0_Vgi_bi))/(((pInst->NF*Weff)*12.0)*T0)/(((pInst->NF*Weff)*12.0)*T0));
mig_Vdi_bi=(((((((((((Lvsat_Vdi_bi*T10)+(Lvsat*T10_Vdi_bi))*T10)+((Lvsat*T10)*T10_Vdi_bi))*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))+(((Lvsat*T10)*T10)*((((T1_Vdi_bi*T4-T1*T4_Vdi_bi)/T4/T4)-((T9_Vdi_bi*((60.0*T4)*T4)-T9*(((60.0*T4_Vdi_bi)*T4)+((60.0*T4)*T4_Vdi_bi)))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((T7_Vdi_bi*T7)+(T7*T7_Vdi_bi))*((144.0*T4)*T5)-(T7*T7)*(((144.0*T4_Vdi_bi)*T5)+((144.0*T4)*T5_Vdi_bi)))/((144.0*T4)*T5)/((144.0*T4)*T5)))))*15.0/4.0)*thetanoisq)+((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq_Vdi_bi))*(((pInst->NF*Weff)*12.0)*T0)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*(((pInst->NF*Weff)*12.0)*T0_Vdi_bi))/(((pInst->NF*Weff)*12.0)*T0)/(((pInst->NF*Weff)*12.0)*T0));
mig_Vsi_bi=(((((((((((Lvsat_Vsi_bi*T10)+(Lvsat*T10_Vsi_bi))*T10)+((Lvsat*T10)*T10_Vsi_bi))*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))+(((Lvsat*T10)*T10)*((((T1_Vsi_bi*T4-T1*T4_Vsi_bi)/T4/T4)-((T9_Vsi_bi*((60.0*T4)*T4)-T9*(((60.0*T4_Vsi_bi)*T4)+((60.0*T4)*T4_Vsi_bi)))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((T7_Vsi_bi*T7)+(T7*T7_Vsi_bi))*((144.0*T4)*T5)-(T7*T7)*(((144.0*T4_Vsi_bi)*T5)+((144.0*T4)*T5_Vsi_bi)))/((144.0*T4)*T5)/((144.0*T4)*T5)))))*15.0/4.0)*thetanoisq)+((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq_Vsi_bi))*(((pInst->NF*Weff)*12.0)*T0)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*(((pInst->NF*Weff)*12.0)*T0_Vsi_bi))/(((pInst->NF*Weff)*12.0)*T0)/(((pInst->NF*Weff)*12.0)*T0));
mig_Tempt_GND=(((((((((((Lvsat_Tempt_GND*T10)+(Lvsat*T10_Tempt_GND))*T10)+((Lvsat*T10)*T10_Tempt_GND))*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))+(((Lvsat*T10)*T10)*((((T1_Tempt_GND*T4-T1*T4_Tempt_GND)/T4/T4)-((T9_Tempt_GND*((60.0*T4)*T4)-T9*(((60.0*T4_Tempt_GND)*T4)+((60.0*T4)*T4_Tempt_GND)))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*((144.0*T4)*T5)-(T7*T7)*(((144.0*T4_Tempt_GND)*T5)+((144.0*T4)*T5_Tempt_GND)))/((144.0*T4)*T5)/((144.0*T4)*T5)))))*15.0/4.0)*thetanoisq)+((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq_Tempt_GND))*(((pInst->NF*Weff)*12.0)*T0)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*(((pInst->NF*Weff)*12.0)*T0_Tempt_GND))/(((pInst->NF*Weff)*12.0)*T0)/(((pInst->NF*Weff)*12.0)*T0));
mig_Vdbulk_di=((((((((((Lvsat*T10_Vdbulk_di)*T10)+((Lvsat*T10)*T10_Vdbulk_di))*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))+(((Lvsat*T10)*T10)*((((T1_Vdbulk_di*T4-T1*T4_Vdbulk_di)/T4/T4)-((T9_Vdbulk_di*((60.0*T4)*T4)-T9*(((60.0*T4_Vdbulk_di)*T4)+((60.0*T4)*T4_Vdbulk_di)))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((T7_Vdbulk_di*T7)+(T7*T7_Vdbulk_di))*((144.0*T4)*T5)-(T7*T7)*(((144.0*T4_Vdbulk_di)*T5)+((144.0*T4)*T5_Vdbulk_di)))/((144.0*T4)*T5)/((144.0*T4)*T5)))))*15.0/4.0)*thetanoisq)+((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq_Vdbulk_di))*(((pInst->NF*Weff)*12.0)*T0)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*(((pInst->NF*Weff)*12.0)*T0_Vdbulk_di))/(((pInst->NF*Weff)*12.0)*T0)/(((pInst->NF*Weff)*12.0)*T0));
mig_Vsbulk_si=((((((((((Lvsat*T10_Vsbulk_si)*T10)+((Lvsat*T10)*T10_Vsbulk_si))*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))+(((Lvsat*T10)*T10)*((((T1_Vsbulk_si*T4-T1*T4_Vsbulk_si)/T4/T4)-((T9_Vsbulk_si*((60.0*T4)*T4)-T9*(((60.0*T4_Vsbulk_si)*T4)+((60.0*T4)*T4_Vsbulk_si)))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((T7_Vsbulk_si*T7)+(T7*T7_Vsbulk_si))*((144.0*T4)*T5)-(T7*T7)*(((144.0*T4_Vsbulk_si)*T5)+((144.0*T4)*T5_Vsbulk_si)))/((144.0*T4)*T5)/((144.0*T4)*T5)))))*15.0/4.0)*thetanoisq)+((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq_Vsbulk_si))*(((pInst->NF*Weff)*12.0)*T0)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*(((pInst->NF*Weff)*12.0)*T0_Vsbulk_si))/(((pInst->NF*Weff)*12.0)*T0)/(((pInst->NF*Weff)*12.0)*T0));
#endif
mig=(((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)/(((pInst->NF*Weff)*12.0)*T0));
EXIT_IF_ISNAN((((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)/(((pInst->NF*Weff)*12.0)*T0)))
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
migid_Vdbulk_di=(((((T10_Vdbulk_di*((T6/(12.0*T3))-(T8/(144.0*T5))))+(T10*(((T6_Vdbulk_di*(12.0*T3)-T6*(12.0*T3_Vdbulk_di))/(12.0*T3)/(12.0*T3))-((T8_Vdbulk_di*(144.0*T5)-T8*(144.0*T5_Vdbulk_di))/(144.0*T5)/(144.0*T5)))))*ctnoi)+((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi_Vdbulk_di))/0.395);
migid_Vsbulk_si=(((((T10_Vsbulk_si*((T6/(12.0*T3))-(T8/(144.0*T5))))+(T10*(((T6_Vsbulk_si*(12.0*T3)-T6*(12.0*T3_Vsbulk_si))/(12.0*T3)/(12.0*T3))-((T8_Vsbulk_si*(144.0*T5)-T8*(144.0*T5_Vsbulk_si))/(144.0*T5)/(144.0*T5)))))*ctnoi)+((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi_Vsbulk_si))/0.395);
migid_Vgi_bi=(((((T10_Vgi_bi*((T6/(12.0*T3))-(T8/(144.0*T5))))+(T10*(((T6_Vgi_bi*(12.0*T3)-T6*(12.0*T3_Vgi_bi))/(12.0*T3)/(12.0*T3))-((T8_Vgi_bi*(144.0*T5)-T8*(144.0*T5_Vgi_bi))/(144.0*T5)/(144.0*T5)))))*ctnoi)+((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi_Vgi_bi))/0.395);
migid_Vdi_bi=(((((T10_Vdi_bi*((T6/(12.0*T3))-(T8/(144.0*T5))))+(T10*(((T6_Vdi_bi*(12.0*T3)-T6*(12.0*T3_Vdi_bi))/(12.0*T3)/(12.0*T3))-((T8_Vdi_bi*(144.0*T5)-T8*(144.0*T5_Vdi_bi))/(144.0*T5)/(144.0*T5)))))*ctnoi)+((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi_Vdi_bi))/0.395);
migid_Vsi_bi=(((((T10_Vsi_bi*((T6/(12.0*T3))-(T8/(144.0*T5))))+(T10*(((T6_Vsi_bi*(12.0*T3)-T6*(12.0*T3_Vsi_bi))/(12.0*T3)/(12.0*T3))-((T8_Vsi_bi*(144.0*T5)-T8*(144.0*T5_Vsi_bi))/(144.0*T5)/(144.0*T5)))))*ctnoi)+((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi_Vsi_bi))/0.395);
migid_Tempt_GND=(((((T10_Tempt_GND*((T6/(12.0*T3))-(T8/(144.0*T5))))+(T10*(((T6_Tempt_GND*(12.0*T3)-T6*(12.0*T3_Tempt_GND))/(12.0*T3)/(12.0*T3))-((T8_Tempt_GND*(144.0*T5)-T8*(144.0*T5_Tempt_GND))/(144.0*T5)/(144.0*T5)))))*ctnoi)+((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi_Tempt_GND))/0.395);
#endif
migid=(((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi)/0.395);
EXIT_IF_ISNAN((((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi)/0.395))
{
double m00_sqrt(d00_sqrt0,(Nt*mid))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(Nt*mid))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
sqid_Tempt_GND=((Nt_Tempt_GND*mid)+(Nt*mid_Tempt_GND))*d10_sqrt0;
sqid_Vdbulk_di=(Nt*mid_Vdbulk_di)*d10_sqrt0;
sqid_Vsbulk_si=(Nt*mid_Vsbulk_si)*d10_sqrt0;
sqid_Vgi_bi=(Nt*mid_Vgi_bi)*d10_sqrt0;
sqid_Vdi_bi=(Nt*mid_Vdi_bi)*d10_sqrt0;
sqid_Vsi_bi=(Nt*mid_Vsi_bi)*d10_sqrt0;
#endif
sqid=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((mig==0.0))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
sqig_Tempt_GND=0.0;
sqig_Vgi_bi=0.0;
sqig_Vdi_bi=0.0;
sqig_Vsi_bi=0.0;
sqig_Vdbulk_di=0.0;
sqig_Vsbulk_si=0.0;
#endif
sqig=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
cm_igid_Vdbulk_di=0.0;
cm_igid_Vsbulk_si=0.0;
cm_igid_Vgi_bi=0.0;
cm_igid_Vdi_bi=0.0;
cm_igid_Vsi_bi=0.0;
cm_igid_Tempt_GND=0.0;
#endif
cm_igid=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
{
double m00_sqrt(d00_sqrt0,(Nt/mig))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(Nt/mig))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si) ddxprobe= */
sqig_Tempt_GND=((Nt_Tempt_GND*mig-Nt*mig_Tempt_GND)/mig/mig)*d10_sqrt0;
sqig_Vgi_bi=(-Nt*mig_Vgi_bi/mig/mig)*d10_sqrt0;
sqig_Vdi_bi=(-Nt*mig_Vdi_bi/mig/mig)*d10_sqrt0;
sqig_Vsi_bi=(-Nt*mig_Vsi_bi/mig/mig)*d10_sqrt0;
sqig_Vdbulk_di=(-Nt*mig_Vdbulk_di/mig/mig)*d10_sqrt0;
sqig_Vsbulk_si=(-Nt*mig_Vsbulk_si/mig/mig)*d10_sqrt0;
#endif
sqig=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((sqid==0.0))
{
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
cm_igid_Vdbulk_di=0.0;
cm_igid_Vsbulk_si=0.0;
cm_igid_Vgi_bi=0.0;
cm_igid_Vdi_bi=0.0;
cm_igid_Vsi_bi=0.0;
cm_igid_Tempt_GND=0.0;
#endif
cm_igid=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATE) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
cm_igid_Vdbulk_di=((((migid_Vdbulk_di*sqig)+(migid*sqig_Vdbulk_di))*sqid-(migid*sqig)*sqid_Vdbulk_di)/sqid/sqid);
cm_igid_Vsbulk_si=((((migid_Vsbulk_si*sqig)+(migid*sqig_Vsbulk_si))*sqid-(migid*sqig)*sqid_Vsbulk_si)/sqid/sqid);
cm_igid_Vgi_bi=((((migid_Vgi_bi*sqig)+(migid*sqig_Vgi_bi))*sqid-(migid*sqig)*sqid_Vgi_bi)/sqid/sqid);
cm_igid_Vdi_bi=((((migid_Vdi_bi*sqig)+(migid*sqig_Vdi_bi))*sqid-(migid*sqig)*sqid_Vdi_bi)/sqid/sqid);
cm_igid_Vsi_bi=((((migid_Vsi_bi*sqig)+(migid*sqig_Vsi_bi))*sqid-(migid*sqig)*sqid_Vsi_bi)/sqid/sqid);
cm_igid_Tempt_GND=((((migid_Tempt_GND*sqig)+(migid*sqig_Tempt_GND))*sqid-(migid*sqig)*sqid_Tempt_GND)/sqid/sqid);
#endif
cm_igid=((migid*sqig)/sqid);
EXIT_IF_ISNAN(((migid*sqig)/sqid))
}
}
pInst->wnoise13=cm_igid;
pInst->wnoise12=((sqig*sqig)*(1.0-cm_igid));
  _load_static_residual1(N1,((-sqig)*NP(N2)))
  _load_static_jacobian1(N1,N2,((-sqig)))
  _load_static_jacobian2p(N1,sbulk,si,(-sqig_Vsbulk_si)*NP(N2))
  _load_static_jacobian2p(N1,dbulk,di,(-sqig_Vdbulk_di)*NP(N2))
  _load_static_jacobian2p(N1,si,bi,(-sqig_Vsi_bi)*NP(N2))
  _load_static_jacobian2p(N1,di,bi,(-sqig_Vdi_bi)*NP(N2))
  _load_static_jacobian2p(N1,gi,bi,(-sqig_Vgi_bi)*NP(N2))
  _load_static_jacobian1(N1,t,(-sqig_Tempt_GND)*NP(N2))
  _load_dynamic_residual1(N1,_DDT((((((mig*Cox)*Weff)*pInst->NF)*Leff)*NP(N1))))
  _load_dynamic_jacobian1(N1,N1,(((((mig*Cox)*Weff)*pInst->NF)*Leff)))
  _load_dynamic_jacobian2p(N1,sbulk,si,mig_Vsbulk_si*Cox*Weff*pInst->NF*Leff*NP(N1))
  _load_dynamic_jacobian2p(N1,dbulk,di,mig_Vdbulk_di*Cox*Weff*pInst->NF*Leff*NP(N1))
  _load_dynamic_jacobian1(N1,t,mig_Tempt_GND*Cox*Weff*pInst->NF*Leff*NP(N1))
  _load_dynamic_jacobian2p(N1,si,bi,mig_Vsi_bi*Cox*Weff*pInst->NF*Leff*NP(N1))
  _load_dynamic_jacobian2p(N1,di,bi,mig_Vdi_bi*Cox*Weff*pInst->NF*Leff*NP(N1))
  _load_dynamic_jacobian2p(N1,gi,bi,mig_Vgi_bi*Cox*Weff*pInst->NF*Leff*NP(N1))
pInst->wnoise11=((sqid*sqid)*(1.0-cm_igid));
  _load_static_residual2(di,si,(sqid*NP(N2)))
  _load_static_jacobian2s(di,si,N2,(sqid))
  _load_static_jacobian4(di,si,si,bi,sqid_Vsi_bi*NP(N2))
  _load_static_jacobian4(di,si,di,bi,sqid_Vdi_bi*NP(N2))
  _load_static_jacobian4(di,si,gi,bi,sqid_Vgi_bi*NP(N2))
  _load_static_jacobian4(di,si,sbulk,si,sqid_Vsbulk_si*NP(N2))
  _load_static_jacobian4(di,si,dbulk,di,sqid_Vdbulk_di*NP(N2))
  _load_static_jacobian2s(di,si,t,sqid_Tempt_GND*NP(N2))
  _load_dynamic_residual2(gi,si,_DDT((0.5*(((((((1.0+sigvds)*mig)*Cox)*Weff)*pInst->NF)*Leff)*NP(N1)))))
  _load_dynamic_jacobian2s(gi,si,N1,(0.5*(((((((1.0+sigvds)*mig)*Cox)*Weff)*pInst->NF)*Leff))))
  _load_dynamic_jacobian4(gi,si,sbulk,si,(0.5*((1.0+sigvds)*mig_Vsbulk_si)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian4(gi,si,dbulk,di,(0.5*((1.0+sigvds)*mig_Vdbulk_di)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian2s(gi,si,t,(0.5*((1.0+sigvds)*mig_Tempt_GND)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian4(gi,si,si,bi,(0.5*((1.0+sigvds)*mig_Vsi_bi)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian4(gi,si,di,bi,(0.5*((1.0+sigvds)*mig_Vdi_bi)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian4(gi,si,gi,bi,(0.5*((1.0+sigvds)*mig_Vgi_bi)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_residual2(gi,di,_DDT((0.5*(((((((1.0-sigvds)*mig)*Cox)*Weff)*pInst->NF)*Leff)*NP(N1)))))
  _load_dynamic_jacobian2s(gi,di,N1,(0.5*(((((((1.0-sigvds)*mig)*Cox)*Weff)*pInst->NF)*Leff))))
  _load_dynamic_jacobian4(gi,di,sbulk,si,(0.5*((1.0-sigvds)*mig_Vsbulk_si)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian4(gi,di,dbulk,di,(0.5*((1.0-sigvds)*mig_Vdbulk_di)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian2s(gi,di,t,(0.5*((1.0-sigvds)*mig_Tempt_GND)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian4(gi,di,si,bi,(0.5*((1.0-sigvds)*mig_Vsi_bi)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian4(gi,di,di,bi,(0.5*((1.0-sigvds)*mig_Vdi_bi)*Cox*Weff*pInst->NF*Leff*NP(N1)))
  _load_dynamic_jacobian4(gi,di,gi,bi,(0.5*((1.0-sigvds)*mig_Vgi_bi)*Cox*Weff*pInst->NF*Leff*NP(N1)))
}
else
{ /* no default */ }
/* -- CASE END -- */;
  _load_static_residual1(N2,NP(N2))
  _load_static_jacobian1(N2,N2,1.0)
  _load_static_residual1(N1,NP(N1))
  _load_static_jacobian1(N1,N1,1.0)
if
((pModel->IGCMOD!=0))
{
pInst->wnoise10=((2.0*1.60219e-19)*fabs((igcs+igs)));
pInst->wnoise9=((2.0*1.60219e-19)*fabs((igcd+igd)));
}
if
((pModel->IGBMOD!=0))
{
pInst->wnoise8=((2.0*1.60219e-19)*fabs(igb));
}
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND)V(dbulk,GND)V(sbulk,GND) */
vgfbCV_Vgi_bi=vgfb_Vgi_bi;
#if defined(_DERIVATE2)
  vgfbCV_Vgi_bi_Vgi_bi=vgfb_Vgi_bi_Vgi_bi;
  vgfbCV_Vgi_bi_Vdi_bi=vgfb_Vgi_bi_Vdi_bi;
  vgfbCV_Vgi_bi_Vsi_bi=vgfb_Vgi_bi_Vsi_bi;
  vgfbCV_Vgi_bi_Tempt_GND=vgfb_Vgi_bi_Tempt_GND;
#endif
vgfbCV_Vdi_bi=vgfb_Vdi_bi;
#if defined(_DERIVATE2)
  vgfbCV_Vdi_bi_Vgi_bi=vgfb_Vdi_bi_Vgi_bi;
  vgfbCV_Vdi_bi_Vdi_bi=vgfb_Vdi_bi_Vdi_bi;
  vgfbCV_Vdi_bi_Vsi_bi=vgfb_Vdi_bi_Vsi_bi;
  vgfbCV_Vdi_bi_Tempt_GND=vgfb_Vdi_bi_Tempt_GND;
#endif
vgfbCV_Vsi_bi=vgfb_Vsi_bi;
#if defined(_DERIVATE2)
  vgfbCV_Vsi_bi_Vgi_bi=vgfb_Vsi_bi_Vgi_bi;
  vgfbCV_Vsi_bi_Vdi_bi=vgfb_Vsi_bi_Vdi_bi;
  vgfbCV_Vsi_bi_Vsi_bi=vgfb_Vsi_bi_Vsi_bi;
  vgfbCV_Vsi_bi_Tempt_GND=vgfb_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
vgfbCV_Tempt_GND=vgfb_Tempt_GND;
#endif
#endif
vgfbCV=vgfb;
EXIT_IF_ISNAN(vgfb)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gamg2_Tempt_GND=(-(((2.0*1.60219e-19)*epssi)*NGATE_i)*((Cox*Cox)*Vt_Tempt_GND)/((Cox*Cox)*Vt)/((Cox*Cox)*Vt));
#endif
gamg2=((((2.0*1.60219e-19)*epssi)*NGATE_i)/((Cox*Cox)*Vt));
EXIT_IF_ISNAN(((((2.0*1.60219e-19)*epssi)*NGATE_i)/((Cox*Cox)*Vt)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
invgamg2_Tempt_GND=((NGATE_i>0.0)?(-gamg2_Tempt_GND/gamg2/gamg2):0.0);
#endif
invgamg2=((NGATE_i>0.0)?(1.0/gamg2):0.0);
EXIT_IF_ISNAN(((NGATE_i>0.0)?(1.0/gamg2):0.0))
if
((pModel->CVMOD==1))
{
VFBCV_i=(VFBCV_i+pInst->DELVTO);
EXIT_IF_ISNAN((VFBCV_i+pInst->DELVTO))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vg_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vg_Vgm_si_Vgm_si=0.0;
  vg_Vgm_si_Vdbulk_di=0.0;
  vg_Vgm_si_Vsbulk_si=0.0;
  vg_Vgm_si_Vgi_bi=0.0;
  vg_Vgm_si_Vdi_bi=0.0;
  vg_Vgm_si_Vsi_bi=0.0;
  vg_Vgm_si_Tempt_GND=0.0;
#endif
vg_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  vg_Vdbulk_di_Vgm_si=0.0;
  vg_Vdbulk_di_Vdbulk_di=0.0;
  vg_Vdbulk_di_Vsbulk_si=0.0;
  vg_Vdbulk_di_Vgi_bi=0.0;
  vg_Vdbulk_di_Vdi_bi=0.0;
  vg_Vdbulk_di_Vsi_bi=0.0;
  vg_Vdbulk_di_Tempt_GND=0.0;
#endif
vg_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  vg_Vsbulk_si_Vgm_si=0.0;
  vg_Vsbulk_si_Vdbulk_di=0.0;
  vg_Vsbulk_si_Vsbulk_si=0.0;
  vg_Vsbulk_si_Vgi_bi=0.0;
  vg_Vsbulk_si_Vdi_bi=0.0;
  vg_Vsbulk_si_Vsi_bi=0.0;
  vg_Vsbulk_si_Tempt_GND=0.0;
#endif
vg_Vgi_bi=Vg_Vgi_bi*inv_Vt;
#if defined(_DERIVATE2)
  vg_Vgi_bi_Vgm_si=(+0.0*inv_Vt+Vg_Vgi_bi*0.0+0.0*0.0+Vg*0.0);
  vg_Vgi_bi_Vdbulk_di=(+0.0*inv_Vt+Vg_Vgi_bi*0.0+0.0*0.0+Vg*0.0);
  vg_Vgi_bi_Vsbulk_si=(+0.0*inv_Vt+Vg_Vgi_bi*0.0+0.0*0.0+Vg*0.0);
  vg_Vgi_bi_Vgi_bi=(+Vg_Vgi_bi_Vgi_bi*inv_Vt+Vg_Vgi_bi*0.0+Vg_Vgi_bi*0.0+Vg*0.0);
  vg_Vgi_bi_Vdi_bi=(+0.0*inv_Vt+Vg_Vgi_bi*0.0+0.0*0.0+Vg*0.0);
  vg_Vgi_bi_Vsi_bi=(+0.0*inv_Vt+Vg_Vgi_bi*0.0+0.0*0.0+Vg*0.0);
  vg_Vgi_bi_Tempt_GND=(+0.0*inv_Vt+Vg_Vgi_bi*inv_Vt_Tempt_GND+0.0*0.0+Vg*0.0);
#endif
vg_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  vg_Vdi_bi_Vgm_si=0.0;
  vg_Vdi_bi_Vdbulk_di=0.0;
  vg_Vdi_bi_Vsbulk_si=0.0;
  vg_Vdi_bi_Vgi_bi=0.0;
  vg_Vdi_bi_Vdi_bi=0.0;
  vg_Vdi_bi_Vsi_bi=0.0;
  vg_Vdi_bi_Tempt_GND=0.0;
#endif
vg_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  vg_Vsi_bi_Vgm_si=0.0;
  vg_Vsi_bi_Vdbulk_di=0.0;
  vg_Vsi_bi_Vsbulk_si=0.0;
  vg_Vsi_bi_Vgi_bi=0.0;
  vg_Vsi_bi_Vdi_bi=0.0;
  vg_Vsi_bi_Vsi_bi=0.0;
  vg_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
vg_Tempt_GND=(Vg*inv_Vt_Tempt_GND);
#endif
#endif
vg=(Vg*inv_Vt);
EXIT_IF_ISNAN((Vg*inv_Vt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
vs_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vs_Vgm_si_Vgm_si=0.0;
  vs_Vgm_si_Vdbulk_di=0.0;
  vs_Vgm_si_Vsbulk_si=0.0;
  vs_Vgm_si_Vgi_bi=0.0;
  vs_Vgm_si_Vdi_bi=0.0;
  vs_Vgm_si_Vsi_bi=0.0;
  vs_Vgm_si_Tempt_GND=0.0;
#endif
vs_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  vs_Vdbulk_di_Vgm_si=0.0;
  vs_Vdbulk_di_Vdbulk_di=0.0;
  vs_Vdbulk_di_Vsbulk_si=0.0;
  vs_Vdbulk_di_Vgi_bi=0.0;
  vs_Vdbulk_di_Vdi_bi=0.0;
  vs_Vdbulk_di_Vsi_bi=0.0;
  vs_Vdbulk_di_Tempt_GND=0.0;
#endif
vs_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  vs_Vsbulk_si_Vgm_si=0.0;
  vs_Vsbulk_si_Vdbulk_di=0.0;
  vs_Vsbulk_si_Vsbulk_si=0.0;
  vs_Vsbulk_si_Vgi_bi=0.0;
  vs_Vsbulk_si_Vdi_bi=0.0;
  vs_Vsbulk_si_Vsi_bi=0.0;
  vs_Vsbulk_si_Tempt_GND=0.0;
#endif
vs_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  vs_Vgi_bi_Vgm_si=0.0;
  vs_Vgi_bi_Vdbulk_di=0.0;
  vs_Vgi_bi_Vsbulk_si=0.0;
  vs_Vgi_bi_Vgi_bi=0.0;
  vs_Vgi_bi_Vdi_bi=0.0;
  vs_Vgi_bi_Vsi_bi=0.0;
  vs_Vgi_bi_Tempt_GND=0.0;
#endif
vs_Vdi_bi=Vs_Vdi_bi*inv_Vt;
#if defined(_DERIVATE2)
  vs_Vdi_bi_Vgm_si=(+0.0*inv_Vt+Vs_Vdi_bi*0.0+0.0*0.0+Vs*0.0);
  vs_Vdi_bi_Vdbulk_di=(+0.0*inv_Vt+Vs_Vdi_bi*0.0+0.0*0.0+Vs*0.0);
  vs_Vdi_bi_Vsbulk_si=(+0.0*inv_Vt+Vs_Vdi_bi*0.0+0.0*0.0+Vs*0.0);
  vs_Vdi_bi_Vgi_bi=(+0.0*inv_Vt+Vs_Vdi_bi*0.0+0.0*0.0+Vs*0.0);
  vs_Vdi_bi_Vdi_bi=(+Vs_Vdi_bi_Vdi_bi*inv_Vt+Vs_Vdi_bi*0.0+Vs_Vdi_bi*0.0+Vs*0.0);
  vs_Vdi_bi_Vsi_bi=(+Vs_Vdi_bi_Vsi_bi*inv_Vt+Vs_Vdi_bi*0.0+Vs_Vsi_bi*0.0+Vs*0.0);
  vs_Vdi_bi_Tempt_GND=(+0.0*inv_Vt+Vs_Vdi_bi*inv_Vt_Tempt_GND+0.0*0.0+Vs*0.0);
#endif
vs_Vsi_bi=Vs_Vsi_bi*inv_Vt;
#if defined(_DERIVATE2)
  vs_Vsi_bi_Vgm_si=(+0.0*inv_Vt+Vs_Vsi_bi*0.0+0.0*0.0+Vs*0.0);
  vs_Vsi_bi_Vdbulk_di=(+0.0*inv_Vt+Vs_Vsi_bi*0.0+0.0*0.0+Vs*0.0);
  vs_Vsi_bi_Vsbulk_si=(+0.0*inv_Vt+Vs_Vsi_bi*0.0+0.0*0.0+Vs*0.0);
  vs_Vsi_bi_Vgi_bi=(+0.0*inv_Vt+Vs_Vsi_bi*0.0+0.0*0.0+Vs*0.0);
  vs_Vsi_bi_Vdi_bi=(+Vs_Vsi_bi_Vdi_bi*inv_Vt+Vs_Vsi_bi*0.0+Vs_Vdi_bi*0.0+Vs*0.0);
  vs_Vsi_bi_Vsi_bi=(+Vs_Vsi_bi_Vsi_bi*inv_Vt+Vs_Vsi_bi*0.0+Vs_Vsi_bi*0.0+Vs*0.0);
  vs_Vsi_bi_Tempt_GND=(+0.0*inv_Vt+Vs_Vsi_bi*inv_Vt_Tempt_GND+0.0*0.0+Vs*0.0);
#endif
#if defined(_DERIVATE)
vs_Tempt_GND=(Vs*inv_Vt_Tempt_GND);
#endif
#endif
vs=(Vs*inv_Vt);
EXIT_IF_ISNAN((Vs*inv_Vt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vfb_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vfb_Vgm_si_Vgm_si=0.0;
  vfb_Vgm_si_Vdbulk_di=0.0;
  vfb_Vgm_si_Vsbulk_si=0.0;
  vfb_Vgm_si_Vgi_bi=0.0;
  vfb_Vgm_si_Vdi_bi=0.0;
  vfb_Vgm_si_Vsi_bi=0.0;
  vfb_Vgm_si_Tempt_GND=0.0;
#endif
vfb_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  vfb_Vdbulk_di_Vgm_si=0.0;
  vfb_Vdbulk_di_Vdbulk_di=0.0;
  vfb_Vdbulk_di_Vsbulk_si=0.0;
  vfb_Vdbulk_di_Vgi_bi=0.0;
  vfb_Vdbulk_di_Vdi_bi=0.0;
  vfb_Vdbulk_di_Vsi_bi=0.0;
  vfb_Vdbulk_di_Tempt_GND=0.0;
#endif
vfb_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  vfb_Vsbulk_si_Vgm_si=0.0;
  vfb_Vsbulk_si_Vdbulk_di=0.0;
  vfb_Vsbulk_si_Vsbulk_si=0.0;
  vfb_Vsbulk_si_Vgi_bi=0.0;
  vfb_Vsbulk_si_Vdi_bi=0.0;
  vfb_Vsbulk_si_Vsi_bi=0.0;
  vfb_Vsbulk_si_Tempt_GND=0.0;
#endif
vfb_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  vfb_Vgi_bi_Vgm_si=0.0;
  vfb_Vgi_bi_Vdbulk_di=0.0;
  vfb_Vgi_bi_Vsbulk_si=0.0;
  vfb_Vgi_bi_Vgi_bi=0.0;
  vfb_Vgi_bi_Vdi_bi=0.0;
  vfb_Vgi_bi_Vsi_bi=0.0;
  vfb_Vgi_bi_Tempt_GND=0.0;
#endif
vfb_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  vfb_Vdi_bi_Vgm_si=0.0;
  vfb_Vdi_bi_Vdbulk_di=0.0;
  vfb_Vdi_bi_Vsbulk_si=0.0;
  vfb_Vdi_bi_Vgi_bi=0.0;
  vfb_Vdi_bi_Vdi_bi=0.0;
  vfb_Vdi_bi_Vsi_bi=0.0;
  vfb_Vdi_bi_Tempt_GND=0.0;
#endif
vfb_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  vfb_Vsi_bi_Vgm_si=0.0;
  vfb_Vsi_bi_Vdbulk_di=0.0;
  vfb_Vsi_bi_Vsbulk_si=0.0;
  vfb_Vsi_bi_Vgi_bi=0.0;
  vfb_Vsi_bi_Vdi_bi=0.0;
  vfb_Vsi_bi_Vsi_bi=0.0;
  vfb_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
vfb_Tempt_GND=(VFBCV_i*inv_Vt_Tempt_GND);
#endif
#endif
vfb=(VFBCV_i*inv_Vt);
EXIT_IF_ISNAN((VFBCV_i*inv_Vt))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND)V(dbulk,GND)V(sbulk,GND) */
vgfbCV_Vgi_bi=(vg_Vgi_bi-vfb_Vgi_bi);
#if defined(_DERIVATE2)
  vgfbCV_Vgi_bi_Vgi_bi=(+vg_Vgi_bi_Vgi_bi-vfb_Vgi_bi_Vgi_bi);
  vgfbCV_Vgi_bi_Vdi_bi=(+vg_Vgi_bi_Vdi_bi-vfb_Vgi_bi_Vdi_bi);
  vgfbCV_Vgi_bi_Vsi_bi=(+vg_Vgi_bi_Vsi_bi-vfb_Vgi_bi_Vsi_bi);
  vgfbCV_Vgi_bi_Tempt_GND=(+vg_Vgi_bi_Tempt_GND-vfb_Vgi_bi_Tempt_GND);
#endif
vgfbCV_Vdi_bi=(vg_Vdi_bi-vfb_Vdi_bi);
#if defined(_DERIVATE2)
  vgfbCV_Vdi_bi_Vgi_bi=(+vg_Vdi_bi_Vgi_bi-vfb_Vdi_bi_Vgi_bi);
  vgfbCV_Vdi_bi_Vdi_bi=(+vg_Vdi_bi_Vdi_bi-vfb_Vdi_bi_Vdi_bi);
  vgfbCV_Vdi_bi_Vsi_bi=(+vg_Vdi_bi_Vsi_bi-vfb_Vdi_bi_Vsi_bi);
  vgfbCV_Vdi_bi_Tempt_GND=(+vg_Vdi_bi_Tempt_GND-vfb_Vdi_bi_Tempt_GND);
#endif
vgfbCV_Vsi_bi=(vg_Vsi_bi-vfb_Vsi_bi);
#if defined(_DERIVATE2)
  vgfbCV_Vsi_bi_Vgi_bi=(+vg_Vsi_bi_Vgi_bi-vfb_Vsi_bi_Vgi_bi);
  vgfbCV_Vsi_bi_Vdi_bi=(+vg_Vsi_bi_Vdi_bi-vfb_Vsi_bi_Vdi_bi);
  vgfbCV_Vsi_bi_Vsi_bi=(+vg_Vsi_bi_Vsi_bi-vfb_Vsi_bi_Vsi_bi);
  vgfbCV_Vsi_bi_Tempt_GND=(+vg_Vsi_bi_Tempt_GND-vfb_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
vgfbCV_Tempt_GND=(vg_Tempt_GND-vfb_Tempt_GND);
#endif
#endif
vgfbCV=(vg-vfb);
EXIT_IF_ISNAN((vg-vfb))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
phib_Tempt_GND=bsimbulk_d_lln((NDEPCV_i/ni),(-NDEPCV_i*ni_Tempt_GND/ni/ni));
#endif
phib=bsimbulk_lln((NDEPCV_i/ni));
EXIT_IF_ISNAN(bsimbulk_lln((NDEPCV_i/ni)))
{
double m00_sqrt(d00_sqrt0,((((2.0*1.60219e-19)*epssi)*NDEPCV_i)*inv_Vt))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((((2.0*1.60219e-19)*epssi)*NDEPCV_i)*inv_Vt))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gam_Vgm_si=0.0;
#if defined(_DERIVATE2)
  gam_Vgm_si_Vgm_si=0.0;
  gam_Vgm_si_Vdbulk_di=0.0;
  gam_Vgm_si_Vsbulk_si=0.0;
  gam_Vgm_si_Vgi_bi=0.0;
  gam_Vgm_si_Vdi_bi=0.0;
  gam_Vgm_si_Vsi_bi=0.0;
  gam_Vgm_si_Tempt_GND=0.0;
#endif
gam_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  gam_Vdbulk_di_Vgm_si=0.0;
  gam_Vdbulk_di_Vdbulk_di=0.0;
  gam_Vdbulk_di_Vsbulk_si=0.0;
  gam_Vdbulk_di_Vgi_bi=0.0;
  gam_Vdbulk_di_Vdi_bi=0.0;
  gam_Vdbulk_di_Vsi_bi=0.0;
  gam_Vdbulk_di_Tempt_GND=0.0;
#endif
gam_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  gam_Vsbulk_si_Vgm_si=0.0;
  gam_Vsbulk_si_Vdbulk_di=0.0;
  gam_Vsbulk_si_Vsbulk_si=0.0;
  gam_Vsbulk_si_Vgi_bi=0.0;
  gam_Vsbulk_si_Vdi_bi=0.0;
  gam_Vsbulk_si_Vsi_bi=0.0;
  gam_Vsbulk_si_Tempt_GND=0.0;
#endif
gam_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  gam_Vgi_bi_Vgm_si=0.0;
  gam_Vgi_bi_Vdbulk_di=0.0;
  gam_Vgi_bi_Vsbulk_si=0.0;
  gam_Vgi_bi_Vgi_bi=0.0;
  gam_Vgi_bi_Vdi_bi=0.0;
  gam_Vgi_bi_Vsi_bi=0.0;
  gam_Vgi_bi_Tempt_GND=0.0;
#endif
gam_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  gam_Vdi_bi_Vgm_si=0.0;
  gam_Vdi_bi_Vdbulk_di=0.0;
  gam_Vdi_bi_Vsbulk_si=0.0;
  gam_Vdi_bi_Vgi_bi=0.0;
  gam_Vdi_bi_Vdi_bi=0.0;
  gam_Vdi_bi_Vsi_bi=0.0;
  gam_Vdi_bi_Tempt_GND=0.0;
#endif
gam_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  gam_Vsi_bi_Vgm_si=0.0;
  gam_Vsi_bi_Vdbulk_di=0.0;
  gam_Vsi_bi_Vsbulk_si=0.0;
  gam_Vsi_bi_Vgi_bi=0.0;
  gam_Vsi_bi_Vdi_bi=0.0;
  gam_Vsi_bi_Vsi_bi=0.0;
  gam_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
gam_Tempt_GND=(((((2.0*1.60219e-19)*epssi)*NDEPCV_i)*inv_Vt_Tempt_GND)*d10_sqrt0/Cox);
#endif
#endif
gam=(d00_sqrt0/Cox);
EXIT_IF_ISNAN((d00_sqrt0/Cox))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
inv_gam_Vgm_si=0.0;
#if defined(_DERIVATE2)
  inv_gam_Vgm_si_Vgm_si=0.0;
  inv_gam_Vgm_si_Vdbulk_di=0.0;
  inv_gam_Vgm_si_Vsbulk_si=0.0;
  inv_gam_Vgm_si_Vgi_bi=0.0;
  inv_gam_Vgm_si_Vdi_bi=0.0;
  inv_gam_Vgm_si_Vsi_bi=0.0;
  inv_gam_Vgm_si_Tempt_GND=0.0;
#endif
inv_gam_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  inv_gam_Vdbulk_di_Vgm_si=0.0;
  inv_gam_Vdbulk_di_Vdbulk_di=0.0;
  inv_gam_Vdbulk_di_Vsbulk_si=0.0;
  inv_gam_Vdbulk_di_Vgi_bi=0.0;
  inv_gam_Vdbulk_di_Vdi_bi=0.0;
  inv_gam_Vdbulk_di_Vsi_bi=0.0;
  inv_gam_Vdbulk_di_Tempt_GND=0.0;
#endif
inv_gam_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  inv_gam_Vsbulk_si_Vgm_si=0.0;
  inv_gam_Vsbulk_si_Vdbulk_di=0.0;
  inv_gam_Vsbulk_si_Vsbulk_si=0.0;
  inv_gam_Vsbulk_si_Vgi_bi=0.0;
  inv_gam_Vsbulk_si_Vdi_bi=0.0;
  inv_gam_Vsbulk_si_Vsi_bi=0.0;
  inv_gam_Vsbulk_si_Tempt_GND=0.0;
#endif
inv_gam_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  inv_gam_Vgi_bi_Vgm_si=0.0;
  inv_gam_Vgi_bi_Vdbulk_di=0.0;
  inv_gam_Vgi_bi_Vsbulk_si=0.0;
  inv_gam_Vgi_bi_Vgi_bi=0.0;
  inv_gam_Vgi_bi_Vdi_bi=0.0;
  inv_gam_Vgi_bi_Vsi_bi=0.0;
  inv_gam_Vgi_bi_Tempt_GND=0.0;
#endif
inv_gam_Vdi_bi=(-gam_Vdi_bi/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vdi_bi_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vgm_si)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vdi_bi_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vdbulk_di)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vdi_bi_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vsbulk_si)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vdi_bi_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vgi_bi)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vdi_bi_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vdi_bi)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vdi_bi_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vsi_bi)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vdi_bi_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Tempt_GND)/gam/gam+2*1.0*gam_Vdi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
inv_gam_Vsi_bi=(-gam_Vsi_bi/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vsi_bi_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vgm_si)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vsi_bi_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vdbulk_di)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vsi_bi_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vsbulk_si)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vsi_bi_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vgi_bi)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vsi_bi_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vdi_bi)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vsi_bi_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vsi_bi)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vsi_bi_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Tempt_GND)/gam/gam+2*1.0*gam_Vsi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
#if defined(_DERIVATE)
inv_gam_Tempt_GND=(-gam_Tempt_GND/gam/gam);
#endif
#endif
inv_gam=(1.0/gam);
EXIT_IF_ISNAN((1.0/gam))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gamg2_Tempt_GND=(-(((2.0*1.60219e-19)*epssi)*NGATE_i)*((Cox*Cox)*Vt_Tempt_GND)/((Cox*Cox)*Vt)/((Cox*Cox)*Vt));
#endif
gamg2=((((2.0*1.60219e-19)*epssi)*NGATE_i)/((Cox*Cox)*Vt));
EXIT_IF_ISNAN(((((2.0*1.60219e-19)*epssi)*NGATE_i)/((Cox*Cox)*Vt)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
invgamg2_Tempt_GND=((NGATE_i>0.0)?(-gamg2_Tempt_GND/gamg2/gamg2):0.0);
#endif
invgamg2=((NGATE_i>0.0)?(1.0/gamg2):0.0);
EXIT_IF_ISNAN(((NGATE_i>0.0)?(1.0/gamg2):0.0))
DPD=((NGATE_i>0.0)?(NDEPCV_i/NGATE_i):0.0);
EXIT_IF_ISNAN(((NGATE_i>0.0)?(NDEPCV_i/NGATE_i):0.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=(1.0+DPD);
EXIT_IF_ISNAN((1.0+DPD))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vgfbPD_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vgfbPD_Vgm_si_Vgm_si=0.0;
  vgfbPD_Vgm_si_Vgm_di=0.0;
  vgfbPD_Vgm_si_Vdbulk_di=0.0;
  vgfbPD_Vgm_si_Vsbulk_si=0.0;
  vgfbPD_Vgm_si_Vgi_bi=0.0;
  vgfbPD_Vgm_si_Vdi_bi=0.0;
  vgfbPD_Vgm_si_Vsi_bi=0.0;
  vgfbPD_Vgm_si_Tempt_GND=0.0;
#endif
vgfbPD_Vgm_di=0.0;
#if defined(_DERIVATE2)
  vgfbPD_Vgm_di_Vgm_si=0.0;
  vgfbPD_Vgm_di_Vgm_di=0.0;
  vgfbPD_Vgm_di_Vdbulk_di=0.0;
  vgfbPD_Vgm_di_Vsbulk_si=0.0;
  vgfbPD_Vgm_di_Vgi_bi=0.0;
  vgfbPD_Vgm_di_Vdi_bi=0.0;
  vgfbPD_Vgm_di_Vsi_bi=0.0;
  vgfbPD_Vgm_di_Tempt_GND=0.0;
#endif
vgfbPD_Vdbulk_di=(-vgfbCV*T1_Vdbulk_di/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vdbulk_di_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vdbulk_di+vgfbCV*T1_Vdbulk_di_Vgm_si)/T1/T1+2*vgfbCV*T1_Vdbulk_di*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vgm_di=(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vdbulk_di+vgfbCV*T1_Vdbulk_di_Vgm_di)/T1/T1+2*vgfbCV*T1_Vdbulk_di*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vdbulk_di+vgfbCV*T1_Vdbulk_di_Vdbulk_di)/T1/T1+2*vgfbCV*T1_Vdbulk_di*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vdbulk_di+vgfbCV*T1_Vdbulk_di_Vsbulk_si)/T1/T1+2*vgfbCV*T1_Vdbulk_di*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+vgfbCV_Vgi_bi*T1_Vdbulk_di+vgfbCV*T1_Vdbulk_di_Vgi_bi)/T1/T1+2*vgfbCV*T1_Vdbulk_di*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+vgfbCV_Vdi_bi*T1_Vdbulk_di+vgfbCV*T1_Vdbulk_di_Vdi_bi)/T1/T1+2*vgfbCV*T1_Vdbulk_di*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+vgfbCV_Vsi_bi*T1_Vdbulk_di+vgfbCV*T1_Vdbulk_di_Vsi_bi)/T1/T1+2*vgfbCV*T1_Vdbulk_di*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vdbulk_di_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+vgfbCV_Tempt_GND*T1_Vdbulk_di+vgfbCV*T1_Vdbulk_di_Tempt_GND)/T1/T1+2*vgfbCV*T1_Vdbulk_di*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vsbulk_si=(-vgfbCV*T1_Vsbulk_si/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vsbulk_si_Vgm_si=(0.0/T1-(0.0*T1_Vgm_si+0.0*T1_Vsbulk_si+vgfbCV*T1_Vsbulk_si_Vgm_si)/T1/T1+2*vgfbCV*T1_Vsbulk_si*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vgm_di=(0.0/T1-(0.0*T1_Vgm_di+0.0*T1_Vsbulk_si+vgfbCV*T1_Vsbulk_si_Vgm_di)/T1/T1+2*vgfbCV*T1_Vsbulk_si*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vdbulk_di=(0.0/T1-(0.0*T1_Vdbulk_di+0.0*T1_Vsbulk_si+vgfbCV*T1_Vsbulk_si_Vdbulk_di)/T1/T1+2*vgfbCV*T1_Vsbulk_si*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vsbulk_si=(0.0/T1-(0.0*T1_Vsbulk_si+0.0*T1_Vsbulk_si+vgfbCV*T1_Vsbulk_si_Vsbulk_si)/T1/T1+2*vgfbCV*T1_Vsbulk_si*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vgi_bi=(0.0/T1-(0.0*T1_Vgi_bi+vgfbCV_Vgi_bi*T1_Vsbulk_si+vgfbCV*T1_Vsbulk_si_Vgi_bi)/T1/T1+2*vgfbCV*T1_Vsbulk_si*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vdi_bi=(0.0/T1-(0.0*T1_Vdi_bi+vgfbCV_Vdi_bi*T1_Vsbulk_si+vgfbCV*T1_Vsbulk_si_Vdi_bi)/T1/T1+2*vgfbCV*T1_Vsbulk_si*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vsi_bi=(0.0/T1-(0.0*T1_Vsi_bi+vgfbCV_Vsi_bi*T1_Vsbulk_si+vgfbCV*T1_Vsbulk_si_Vsi_bi)/T1/T1+2*vgfbCV*T1_Vsbulk_si*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vsbulk_si_Tempt_GND=(0.0/T1-(0.0*T1_Tempt_GND+vgfbCV_Tempt_GND*T1_Vsbulk_si+vgfbCV*T1_Vsbulk_si_Tempt_GND)/T1/T1+2*vgfbCV*T1_Vsbulk_si*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vgi_bi=((vgfbCV_Vgi_bi*T1-vgfbCV*T1_Vgi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vgi_bi_Vgm_si=(0.0/T1-(vgfbCV_Vgi_bi*T1_Vgm_si+0.0*T1_Vgi_bi+vgfbCV*T1_Vgi_bi_Vgm_si)/T1/T1+2*vgfbCV*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vgi_bi_Vgm_di=(0.0/T1-(vgfbCV_Vgi_bi*T1_Vgm_di+0.0*T1_Vgi_bi+vgfbCV*T1_Vgi_bi_Vgm_di)/T1/T1+2*vgfbCV*T1_Vgi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vgi_bi_Vdbulk_di=(0.0/T1-(vgfbCV_Vgi_bi*T1_Vdbulk_di+0.0*T1_Vgi_bi+vgfbCV*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*vgfbCV*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vgi_bi_Vsbulk_si=(0.0/T1-(vgfbCV_Vgi_bi*T1_Vsbulk_si+0.0*T1_Vgi_bi+vgfbCV*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*vgfbCV*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vgi_bi_Vgi_bi=(vgfbCV_Vgi_bi_Vgi_bi/T1-(vgfbCV_Vgi_bi*T1_Vgi_bi+vgfbCV_Vgi_bi*T1_Vgi_bi+vgfbCV*T1_Vgi_bi_Vgi_bi)/T1/T1+2*vgfbCV*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Vdi_bi=(vgfbCV_Vgi_bi_Vdi_bi/T1-(vgfbCV_Vgi_bi*T1_Vdi_bi+vgfbCV_Vdi_bi*T1_Vgi_bi+vgfbCV*T1_Vgi_bi_Vdi_bi)/T1/T1+2*vgfbCV*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Vsi_bi=(vgfbCV_Vgi_bi_Vsi_bi/T1-(vgfbCV_Vgi_bi*T1_Vsi_bi+vgfbCV_Vsi_bi*T1_Vgi_bi+vgfbCV*T1_Vgi_bi_Vsi_bi)/T1/T1+2*vgfbCV*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Tempt_GND=(vgfbCV_Vgi_bi_Tempt_GND/T1-(vgfbCV_Vgi_bi*T1_Tempt_GND+vgfbCV_Tempt_GND*T1_Vgi_bi+vgfbCV*T1_Vgi_bi_Tempt_GND)/T1/T1+2*vgfbCV*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vdi_bi=((vgfbCV_Vdi_bi*T1-vgfbCV*T1_Vdi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vdi_bi_Vgm_si=(0.0/T1-(vgfbCV_Vdi_bi*T1_Vgm_si+0.0*T1_Vdi_bi+vgfbCV*T1_Vdi_bi_Vgm_si)/T1/T1+2*vgfbCV*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vdi_bi_Vgm_di=(0.0/T1-(vgfbCV_Vdi_bi*T1_Vgm_di+0.0*T1_Vdi_bi+vgfbCV*T1_Vdi_bi_Vgm_di)/T1/T1+2*vgfbCV*T1_Vdi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vdi_bi_Vdbulk_di=(0.0/T1-(vgfbCV_Vdi_bi*T1_Vdbulk_di+0.0*T1_Vdi_bi+vgfbCV*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*vgfbCV*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vdi_bi_Vsbulk_si=(0.0/T1-(vgfbCV_Vdi_bi*T1_Vsbulk_si+0.0*T1_Vdi_bi+vgfbCV*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*vgfbCV*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vdi_bi_Vgi_bi=(vgfbCV_Vdi_bi_Vgi_bi/T1-(vgfbCV_Vdi_bi*T1_Vgi_bi+vgfbCV_Vgi_bi*T1_Vdi_bi+vgfbCV*T1_Vdi_bi_Vgi_bi)/T1/T1+2*vgfbCV*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Vdi_bi=(vgfbCV_Vdi_bi_Vdi_bi/T1-(vgfbCV_Vdi_bi*T1_Vdi_bi+vgfbCV_Vdi_bi*T1_Vdi_bi+vgfbCV*T1_Vdi_bi_Vdi_bi)/T1/T1+2*vgfbCV*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Vsi_bi=(vgfbCV_Vdi_bi_Vsi_bi/T1-(vgfbCV_Vdi_bi*T1_Vsi_bi+vgfbCV_Vsi_bi*T1_Vdi_bi+vgfbCV*T1_Vdi_bi_Vsi_bi)/T1/T1+2*vgfbCV*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Tempt_GND=(vgfbCV_Vdi_bi_Tempt_GND/T1-(vgfbCV_Vdi_bi*T1_Tempt_GND+vgfbCV_Tempt_GND*T1_Vdi_bi+vgfbCV*T1_Vdi_bi_Tempt_GND)/T1/T1+2*vgfbCV*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vsi_bi=((vgfbCV_Vsi_bi*T1-vgfbCV*T1_Vsi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vsi_bi_Vgm_si=(0.0/T1-(vgfbCV_Vsi_bi*T1_Vgm_si+0.0*T1_Vsi_bi+vgfbCV*T1_Vsi_bi_Vgm_si)/T1/T1+2*vgfbCV*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vsi_bi_Vgm_di=(0.0/T1-(vgfbCV_Vsi_bi*T1_Vgm_di+0.0*T1_Vsi_bi+vgfbCV*T1_Vsi_bi_Vgm_di)/T1/T1+2*vgfbCV*T1_Vsi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vsi_bi_Vdbulk_di=(0.0/T1-(vgfbCV_Vsi_bi*T1_Vdbulk_di+0.0*T1_Vsi_bi+vgfbCV*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*vgfbCV*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vsi_bi_Vsbulk_si=(0.0/T1-(vgfbCV_Vsi_bi*T1_Vsbulk_si+0.0*T1_Vsi_bi+vgfbCV*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*vgfbCV*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vsi_bi_Vgi_bi=(vgfbCV_Vsi_bi_Vgi_bi/T1-(vgfbCV_Vsi_bi*T1_Vgi_bi+vgfbCV_Vgi_bi*T1_Vsi_bi+vgfbCV*T1_Vsi_bi_Vgi_bi)/T1/T1+2*vgfbCV*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Vdi_bi=(vgfbCV_Vsi_bi_Vdi_bi/T1-(vgfbCV_Vsi_bi*T1_Vdi_bi+vgfbCV_Vdi_bi*T1_Vsi_bi+vgfbCV*T1_Vsi_bi_Vdi_bi)/T1/T1+2*vgfbCV*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Vsi_bi=(vgfbCV_Vsi_bi_Vsi_bi/T1-(vgfbCV_Vsi_bi*T1_Vsi_bi+vgfbCV_Vsi_bi*T1_Vsi_bi+vgfbCV*T1_Vsi_bi_Vsi_bi)/T1/T1+2*vgfbCV*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Tempt_GND=(vgfbCV_Vsi_bi_Tempt_GND/T1-(vgfbCV_Vsi_bi*T1_Tempt_GND+vgfbCV_Tempt_GND*T1_Vsi_bi+vgfbCV*T1_Vsi_bi_Tempt_GND)/T1/T1+2*vgfbCV*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
#if defined(_DERIVATE)
vgfbPD_Tempt_GND=((vgfbCV_Tempt_GND*T1-vgfbCV*T1_Tempt_GND)/T1/T1);
#endif
#endif
vgfbPD=(vgfbCV/T1);
EXIT_IF_ISNAN((vgfbCV/T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gammaPD_Vgm_si=0.0;
#if defined(_DERIVATE2)
  gammaPD_Vgm_si_Vgm_si=0.0;
  gammaPD_Vgm_si_Vdbulk_di=0.0;
  gammaPD_Vgm_si_Vsbulk_si=0.0;
  gammaPD_Vgm_si_Vgi_bi=0.0;
  gammaPD_Vgm_si_Vdi_bi=0.0;
  gammaPD_Vgm_si_Vsi_bi=0.0;
  gammaPD_Vgm_si_Tempt_GND=0.0;
#endif
gammaPD_Vdbulk_di=((gam_Vdbulk_di*T1-gam*T1_Vdbulk_di)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vdbulk_di_Vgm_si=(gam_Vdbulk_di_Vgm_si/T1-(gam_Vdbulk_di*T1_Vgm_si+gam_Vgm_si*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vgm_si)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vdbulk_di_Vdbulk_di=(gam_Vdbulk_di_Vdbulk_di/T1-(gam_Vdbulk_di*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vdbulk_di)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vdbulk_di_Vsbulk_si=(gam_Vdbulk_di_Vsbulk_si/T1-(gam_Vdbulk_di*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vsbulk_si)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vdbulk_di_Vgi_bi=(gam_Vdbulk_di_Vgi_bi/T1-(gam_Vdbulk_di*T1_Vgi_bi+gam_Vgi_bi*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vgi_bi)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vdbulk_di_Vdi_bi=(gam_Vdbulk_di_Vdi_bi/T1-(gam_Vdbulk_di*T1_Vdi_bi+gam_Vdi_bi*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vdi_bi)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vdbulk_di_Vsi_bi=(gam_Vdbulk_di_Vsi_bi/T1-(gam_Vdbulk_di*T1_Vsi_bi+gam_Vsi_bi*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vsi_bi)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vdbulk_di_Tempt_GND=(gam_Vdbulk_di_Tempt_GND/T1-(gam_Vdbulk_di*T1_Tempt_GND+gam_Tempt_GND*T1_Vdbulk_di+gam*T1_Vdbulk_di_Tempt_GND)/T1/T1+2*gam*T1_Vdbulk_di*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vsbulk_si=((gam_Vsbulk_si*T1-gam*T1_Vsbulk_si)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vsbulk_si_Vgm_si=(gam_Vsbulk_si_Vgm_si/T1-(gam_Vsbulk_si*T1_Vgm_si+gam_Vgm_si*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vgm_si)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vsbulk_si_Vdbulk_di=(gam_Vsbulk_si_Vdbulk_di/T1-(gam_Vsbulk_si*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vdbulk_di)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vsbulk_si_Vsbulk_si=(gam_Vsbulk_si_Vsbulk_si/T1-(gam_Vsbulk_si*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vsbulk_si)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vsbulk_si_Vgi_bi=(gam_Vsbulk_si_Vgi_bi/T1-(gam_Vsbulk_si*T1_Vgi_bi+gam_Vgi_bi*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vgi_bi)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vsbulk_si_Vdi_bi=(gam_Vsbulk_si_Vdi_bi/T1-(gam_Vsbulk_si*T1_Vdi_bi+gam_Vdi_bi*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vdi_bi)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vsbulk_si_Vsi_bi=(gam_Vsbulk_si_Vsi_bi/T1-(gam_Vsbulk_si*T1_Vsi_bi+gam_Vsi_bi*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vsi_bi)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vsbulk_si_Tempt_GND=(gam_Vsbulk_si_Tempt_GND/T1-(gam_Vsbulk_si*T1_Tempt_GND+gam_Tempt_GND*T1_Vsbulk_si+gam*T1_Vsbulk_si_Tempt_GND)/T1/T1+2*gam*T1_Vsbulk_si*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vgi_bi=((gam_Vgi_bi*T1-gam*T1_Vgi_bi)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vgi_bi_Vgm_si=(gam_Vgi_bi_Vgm_si/T1-(gam_Vgi_bi*T1_Vgm_si+gam_Vgm_si*T1_Vgi_bi+gam*T1_Vgi_bi_Vgm_si)/T1/T1+2*gam*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vgi_bi_Vdbulk_di=(gam_Vgi_bi_Vdbulk_di/T1-(gam_Vgi_bi*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vgi_bi+gam*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*gam*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vgi_bi_Vsbulk_si=(gam_Vgi_bi_Vsbulk_si/T1-(gam_Vgi_bi*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vgi_bi+gam*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*gam*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vgi_bi_Vgi_bi=(gam_Vgi_bi_Vgi_bi/T1-(gam_Vgi_bi*T1_Vgi_bi+gam_Vgi_bi*T1_Vgi_bi+gam*T1_Vgi_bi_Vgi_bi)/T1/T1+2*gam*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vgi_bi_Vdi_bi=(gam_Vgi_bi_Vdi_bi/T1-(gam_Vgi_bi*T1_Vdi_bi+gam_Vdi_bi*T1_Vgi_bi+gam*T1_Vgi_bi_Vdi_bi)/T1/T1+2*gam*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vgi_bi_Vsi_bi=(gam_Vgi_bi_Vsi_bi/T1-(gam_Vgi_bi*T1_Vsi_bi+gam_Vsi_bi*T1_Vgi_bi+gam*T1_Vgi_bi_Vsi_bi)/T1/T1+2*gam*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vgi_bi_Tempt_GND=(gam_Vgi_bi_Tempt_GND/T1-(gam_Vgi_bi*T1_Tempt_GND+gam_Tempt_GND*T1_Vgi_bi+gam*T1_Vgi_bi_Tempt_GND)/T1/T1+2*gam*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vdi_bi=((gam_Vdi_bi*T1-gam*T1_Vdi_bi)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vdi_bi_Vgm_si=(gam_Vdi_bi_Vgm_si/T1-(gam_Vdi_bi*T1_Vgm_si+gam_Vgm_si*T1_Vdi_bi+gam*T1_Vdi_bi_Vgm_si)/T1/T1+2*gam*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vdi_bi_Vdbulk_di=(gam_Vdi_bi_Vdbulk_di/T1-(gam_Vdi_bi*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vdi_bi+gam*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*gam*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vdi_bi_Vsbulk_si=(gam_Vdi_bi_Vsbulk_si/T1-(gam_Vdi_bi*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vdi_bi+gam*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*gam*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vdi_bi_Vgi_bi=(gam_Vdi_bi_Vgi_bi/T1-(gam_Vdi_bi*T1_Vgi_bi+gam_Vgi_bi*T1_Vdi_bi+gam*T1_Vdi_bi_Vgi_bi)/T1/T1+2*gam*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Vdi_bi=(gam_Vdi_bi_Vdi_bi/T1-(gam_Vdi_bi*T1_Vdi_bi+gam_Vdi_bi*T1_Vdi_bi+gam*T1_Vdi_bi_Vdi_bi)/T1/T1+2*gam*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Vsi_bi=(gam_Vdi_bi_Vsi_bi/T1-(gam_Vdi_bi*T1_Vsi_bi+gam_Vsi_bi*T1_Vdi_bi+gam*T1_Vdi_bi_Vsi_bi)/T1/T1+2*gam*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Tempt_GND=(gam_Vdi_bi_Tempt_GND/T1-(gam_Vdi_bi*T1_Tempt_GND+gam_Tempt_GND*T1_Vdi_bi+gam*T1_Vdi_bi_Tempt_GND)/T1/T1+2*gam*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vsi_bi=((gam_Vsi_bi*T1-gam*T1_Vsi_bi)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vsi_bi_Vgm_si=(gam_Vsi_bi_Vgm_si/T1-(gam_Vsi_bi*T1_Vgm_si+gam_Vgm_si*T1_Vsi_bi+gam*T1_Vsi_bi_Vgm_si)/T1/T1+2*gam*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vsi_bi_Vdbulk_di=(gam_Vsi_bi_Vdbulk_di/T1-(gam_Vsi_bi*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vsi_bi+gam*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*gam*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vsi_bi_Vsbulk_si=(gam_Vsi_bi_Vsbulk_si/T1-(gam_Vsi_bi*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vsi_bi+gam*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*gam*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vsi_bi_Vgi_bi=(gam_Vsi_bi_Vgi_bi/T1-(gam_Vsi_bi*T1_Vgi_bi+gam_Vgi_bi*T1_Vsi_bi+gam*T1_Vsi_bi_Vgi_bi)/T1/T1+2*gam*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Vdi_bi=(gam_Vsi_bi_Vdi_bi/T1-(gam_Vsi_bi*T1_Vdi_bi+gam_Vdi_bi*T1_Vsi_bi+gam*T1_Vsi_bi_Vdi_bi)/T1/T1+2*gam*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Vsi_bi=(gam_Vsi_bi_Vsi_bi/T1-(gam_Vsi_bi*T1_Vsi_bi+gam_Vsi_bi*T1_Vsi_bi+gam*T1_Vsi_bi_Vsi_bi)/T1/T1+2*gam*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Tempt_GND=(gam_Vsi_bi_Tempt_GND/T1-(gam_Vsi_bi*T1_Tempt_GND+gam_Tempt_GND*T1_Vsi_bi+gam*T1_Vsi_bi_Tempt_GND)/T1/T1+2*gam*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
#if defined(_DERIVATE)
gammaPD_Tempt_GND=((gam_Tempt_GND*T1-gam*T1_Tempt_GND)/T1/T1);
#endif
#endif
gammaPD=(gam/T1);
EXIT_IF_ISNAN((gam/T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=((0.5*vgfbPD_Vdbulk_di)-(3.0*(gammaPD_Vdbulk_di/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vgm_si/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vdbulk_di/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vsbulk_si/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vgi_bi/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vdi_bi/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vsi_bi/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Tempt_GND/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vsbulk_si=((0.5*vgfbPD_Vsbulk_si)-(3.0*(gammaPD_Vsbulk_si/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vgm_si/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vdbulk_di/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vsbulk_si/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vgi_bi/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vdi_bi/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vsi_bi/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Tempt_GND/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vgi_bi=((0.5*vgfbPD_Vgi_bi)-(3.0*(gammaPD_Vgi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vdi_bi=((0.5*vgfbPD_Vdi_bi)-(3.0*(gammaPD_Vdi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vsi_bi=((0.5*vgfbPD_Vsi_bi)-(3.0*(gammaPD_Vsi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((0.5*vgfbPD_Tempt_GND)-(3.0*(gammaPD_Tempt_GND/1.41421356237309504880)));
#endif
#endif
T1=((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
EXIT_IF_ISNAN(((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880)))))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+(6.0*vgfbPD)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+(6.0*vgfbPD)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(T1_Vdbulk_di+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+T1_Vdbulk_di_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vgm_di*T1+T1_Vdbulk_di*T1_Vgm_di+T1_Vgm_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vgm_di))));
  T2_Vdbulk_di_Vgm_si=(+T1_Vdbulk_di_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vgm_si*T1+T1_Vdbulk_di*T1_Vgm_si+T1_Vgm_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vgm_si))));
  T2_Vdbulk_di_Vdbulk_di=(+T1_Vdbulk_di_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vdbulk_di*T1+T1_Vdbulk_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vdbulk_di))));
  T2_Vdbulk_di_Vsbulk_si=(+T1_Vdbulk_di_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vsbulk_si*T1+T1_Vdbulk_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vsbulk_si))));
  T2_Vdbulk_di_Vgi_bi=(+T1_Vdbulk_di_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vgi_bi*T1+T1_Vdbulk_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vgi_bi))));
  T2_Vdbulk_di_Vdi_bi=(+T1_Vdbulk_di_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vdi_bi*T1+T1_Vdbulk_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vdi_bi))));
  T2_Vdbulk_di_Vsi_bi=(+T1_Vdbulk_di_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vsi_bi*T1+T1_Vdbulk_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vsi_bi))));
  T2_Vdbulk_di_Tempt_GND=(+T1_Vdbulk_di_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Tempt_GND*T1+T1_Vdbulk_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vdbulk_di+T1*T1_Vdbulk_di_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Tempt_GND))));
#endif
T2_Vsbulk_si=(T1_Vsbulk_si+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+T1_Vsbulk_si_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vgm_di*T1+T1_Vsbulk_si*T1_Vgm_di+T1_Vgm_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vgm_di))));
  T2_Vsbulk_si_Vgm_si=(+T1_Vsbulk_si_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vgm_si*T1+T1_Vsbulk_si*T1_Vgm_si+T1_Vgm_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vgm_si))));
  T2_Vsbulk_si_Vdbulk_di=(+T1_Vsbulk_si_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vdbulk_di*T1+T1_Vsbulk_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vdbulk_di))));
  T2_Vsbulk_si_Vsbulk_si=(+T1_Vsbulk_si_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vsbulk_si*T1+T1_Vsbulk_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vsbulk_si))));
  T2_Vsbulk_si_Vgi_bi=(+T1_Vsbulk_si_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vgi_bi*T1+T1_Vsbulk_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vgi_bi))));
  T2_Vsbulk_si_Vdi_bi=(+T1_Vsbulk_si_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vdi_bi*T1+T1_Vsbulk_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vdi_bi))));
  T2_Vsbulk_si_Vsi_bi=(+T1_Vsbulk_si_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vsi_bi*T1+T1_Vsbulk_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vsi_bi))));
  T2_Vsbulk_si_Tempt_GND=(+T1_Vsbulk_si_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Tempt_GND*T1+T1_Vsbulk_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vsbulk_si+T1*T1_Vsbulk_si_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Tempt_GND))));
#endif
T2_Vgi_bi=(T1_Vgi_bi+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgm_di))));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgm_si))));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vdbulk_di))));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vsbulk_si))));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgi_bi))));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vdi_bi))));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vsi_bi))));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Tempt_GND))));
#endif
T2_Vdi_bi=(T1_Vdi_bi+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgm_di))));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgm_si))));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vdbulk_di))));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vsbulk_si))));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgi_bi))));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vdi_bi))));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vsi_bi))));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Tempt_GND))));
#endif
T2_Vsi_bi=(T1_Vsi_bi+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgm_di))));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgm_si))));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vdbulk_di))));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vsbulk_si))));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgi_bi))));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vdi_bi))));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vsi_bi))));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+(6.0*vgfbPD_Tempt_GND))*d10_sqrt0);
#endif
#endif
T2=(T1+d00_sqrt0);
EXIT_IF_ISNAN((T1+d00_sqrt0))
}
if
((vgfbPD<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=(((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD-(vgfbPD-T2)*gammaPD_Vdbulk_di)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=((+vgfbPD_Vdbulk_di_Vgm_si-T2_Vdbulk_di_Vgm_si)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vgm_di=((+vgfbPD_Vdbulk_di_Vgm_di-T2_Vdbulk_di_Vgm_di)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vdbulk_di+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vdbulk_di=((+vgfbPD_Vdbulk_di_Vdbulk_di-T2_Vdbulk_di_Vdbulk_di)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vsbulk_si=((+vgfbPD_Vdbulk_di_Vsbulk_si-T2_Vdbulk_di_Vsbulk_si)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vgi_bi=((+vgfbPD_Vdbulk_di_Vgi_bi-T2_Vdbulk_di_Vgi_bi)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vdi_bi=((+vgfbPD_Vdbulk_di_Vdi_bi-T2_Vdbulk_di_Vdi_bi)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vsi_bi=((+vgfbPD_Vdbulk_di_Vsi_bi-T2_Vdbulk_di_Vsi_bi)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Tempt_GND=((+vgfbPD_Vdbulk_di_Tempt_GND-T2_Vdbulk_di_Tempt_GND)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vsbulk_si=(((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD-(vgfbPD-T2)*gammaPD_Vsbulk_si)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=((+vgfbPD_Vsbulk_si_Vgm_si-T2_Vsbulk_si_Vgm_si)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vgm_di=((+vgfbPD_Vsbulk_si_Vgm_di-T2_Vsbulk_si_Vgm_di)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vsbulk_si+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vdbulk_di=((+vgfbPD_Vsbulk_si_Vdbulk_di-T2_Vsbulk_si_Vdbulk_di)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vsbulk_si=((+vgfbPD_Vsbulk_si_Vsbulk_si-T2_Vsbulk_si_Vsbulk_si)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vgi_bi=((+vgfbPD_Vsbulk_si_Vgi_bi-T2_Vsbulk_si_Vgi_bi)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vdi_bi=((+vgfbPD_Vsbulk_si_Vdi_bi-T2_Vsbulk_si_Vdi_bi)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vsi_bi=((+vgfbPD_Vsbulk_si_Vsi_bi-T2_Vsbulk_si_Vsi_bi)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Tempt_GND=((+vgfbPD_Vsbulk_si_Tempt_GND-T2_Vsbulk_si_Tempt_GND)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vgi_bi=(((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vgi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=((+vgfbPD_Vgi_bi_Vgm_si-T2_Vgi_bi_Vgm_si)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vgm_di=((+vgfbPD_Vgi_bi_Vgm_di-T2_Vgi_bi_Vgm_di)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vgi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vdbulk_di=((+vgfbPD_Vgi_bi_Vdbulk_di-T2_Vgi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vsbulk_si=((+vgfbPD_Vgi_bi_Vsbulk_si-T2_Vgi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vgi_bi=((+vgfbPD_Vgi_bi_Vgi_bi-T2_Vgi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vdi_bi=((+vgfbPD_Vgi_bi_Vdi_bi-T2_Vgi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vsi_bi=((+vgfbPD_Vgi_bi_Vsi_bi-T2_Vgi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Tempt_GND=((+vgfbPD_Vgi_bi_Tempt_GND-T2_Vgi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vdi_bi=(((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vdi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=((+vgfbPD_Vdi_bi_Vgm_si-T2_Vdi_bi_Vgm_si)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vgm_di=((+vgfbPD_Vdi_bi_Vgm_di-T2_Vdi_bi_Vgm_di)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vdi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vdbulk_di=((+vgfbPD_Vdi_bi_Vdbulk_di-T2_Vdi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vsbulk_si=((+vgfbPD_Vdi_bi_Vsbulk_si-T2_Vdi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vgi_bi=((+vgfbPD_Vdi_bi_Vgi_bi-T2_Vdi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vdi_bi=((+vgfbPD_Vdi_bi_Vdi_bi-T2_Vdi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vsi_bi=((+vgfbPD_Vdi_bi_Vsi_bi-T2_Vdi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Tempt_GND=((+vgfbPD_Vdi_bi_Tempt_GND-T2_Vdi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vsi_bi=(((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vsi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=((+vgfbPD_Vsi_bi_Vgm_si-T2_Vsi_bi_Vgm_si)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vgm_di=((+vgfbPD_Vsi_bi_Vgm_di-T2_Vsi_bi_Vgm_di)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vsi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vdbulk_di=((+vgfbPD_Vsi_bi_Vdbulk_di-T2_Vsi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vsbulk_si=((+vgfbPD_Vsi_bi_Vsbulk_si-T2_Vsi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vgi_bi=((+vgfbPD_Vsi_bi_Vgi_bi-T2_Vsi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vdi_bi=((+vgfbPD_Vsi_bi_Vdi_bi-T2_Vsi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vsi_bi=((+vgfbPD_Vsi_bi_Vsi_bi-T2_Vsi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Tempt_GND=((+vgfbPD_Vsi_bi_Tempt_GND-T2_Vsi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(((vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD-(vgfbPD-T2)*gammaPD_Tempt_GND)/gammaPD/gammaPD);
#endif
#endif
T3=((vgfbPD-T2)/gammaPD);
EXIT_IF_ISNAN(((vgfbPD-T2)/gammaPD))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
psip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psip_Vgm_di_Vgm_di=0.0;
  psip_Vgm_di_Vgm_si=0.0;
  psip_Vgm_di_Vdbulk_di=0.0;
  psip_Vgm_di_Vsbulk_si=0.0;
  psip_Vgm_di_Vgi_bi=0.0;
  psip_Vgm_di_Vdi_bi=0.0;
  psip_Vgm_di_Vsi_bi=0.0;
  psip_Vgm_di_Tempt_GND=0.0;
#endif
psip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psip_Vgm_si_Vgm_di=0.0;
  psip_Vgm_si_Vgm_si=0.0;
  psip_Vgm_si_Vdbulk_di=0.0;
  psip_Vgm_si_Vsbulk_si=0.0;
  psip_Vgm_si_Vgi_bi=0.0;
  psip_Vgm_si_Vdi_bi=0.0;
  psip_Vgm_si_Vsi_bi=0.0;
  psip_Vgm_si_Tempt_GND=0.0;
#endif
psip_Vdbulk_di=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vdbulk_di)+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))));
#if defined(_DERIVATE2)
  psip_Vdbulk_di_Vgm_di=0.0;
  psip_Vdbulk_di_Vgm_si=0.0;
  psip_Vdbulk_di_Vdbulk_di=0.0;
  psip_Vdbulk_di_Vsbulk_si=0.0;
  psip_Vdbulk_di_Vgi_bi=0.0;
  psip_Vdbulk_di_Vdi_bi=0.0;
  psip_Vdbulk_di_Vsi_bi=0.0;
  psip_Vdbulk_di_Tempt_GND=0.0;
#endif
psip_Vsbulk_si=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vsbulk_si)+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))));
#if defined(_DERIVATE2)
  psip_Vsbulk_si_Vgm_di=0.0;
  psip_Vsbulk_si_Vgm_si=0.0;
  psip_Vsbulk_si_Vdbulk_di=0.0;
  psip_Vsbulk_si_Vsbulk_si=0.0;
  psip_Vsbulk_si_Vgi_bi=0.0;
  psip_Vsbulk_si_Vdi_bi=0.0;
  psip_Vsbulk_si_Vsi_bi=0.0;
  psip_Vsbulk_si_Tempt_GND=0.0;
#endif
psip_Vgi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vgi_bi)+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))));
#if defined(_DERIVATE2)
  psip_Vgi_bi_Vgm_di=0.0;
  psip_Vgi_bi_Vgm_si=0.0;
  psip_Vgi_bi_Vdbulk_di=0.0;
  psip_Vgi_bi_Vsbulk_si=0.0;
  psip_Vgi_bi_Vgi_bi=0.0;
  psip_Vgi_bi_Vdi_bi=0.0;
  psip_Vgi_bi_Vsi_bi=0.0;
  psip_Vgi_bi_Tempt_GND=0.0;
#endif
psip_Vdi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vdi_bi)+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))));
#if defined(_DERIVATE2)
  psip_Vdi_bi_Vgm_di=0.0;
  psip_Vdi_bi_Vgm_si=0.0;
  psip_Vdi_bi_Vdbulk_di=0.0;
  psip_Vdi_bi_Vsbulk_si=0.0;
  psip_Vdi_bi_Vgi_bi=0.0;
  psip_Vdi_bi_Vdi_bi=0.0;
  psip_Vdi_bi_Vsi_bi=0.0;
  psip_Vdi_bi_Tempt_GND=0.0;
#endif
psip_Vsi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vsi_bi)+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))));
#if defined(_DERIVATE2)
  psip_Vsi_bi_Vgm_di=0.0;
  psip_Vsi_bi_Vgm_si=0.0;
  psip_Vsi_bi_Vdbulk_di=0.0;
  psip_Vsi_bi_Vsbulk_si=0.0;
  psip_Vsi_bi_Vgi_bi=0.0;
  psip_Vsi_bi_Vdi_bi=0.0;
  psip_Vsi_bi_Vsi_bi=0.0;
  psip_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
psip_Tempt_GND=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Tempt_GND)+((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))));
#endif
#endif
psip=(-bsimbulk_lln(((1.0-T2)+(T3*T3))));
EXIT_IF_ISNAN((-bsimbulk_lln(((1.0-T2)+(T3*T3)))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp((-T2),(-T2_Vdbulk_di));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp((-T2),(-T2_Vsbulk_si));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp((-T2),(-T2_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=bsimbulk_d_lexp((-T2),(-T2_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=0.0;
  T3_Vdi_bi_Vgm_di=0.0;
  T3_Vdi_bi_Vdbulk_di=0.0;
  T3_Vdi_bi_Vsbulk_si=0.0;
  T3_Vdi_bi_Vgi_bi=0.0;
  T3_Vdi_bi_Vdi_bi=0.0;
  T3_Vdi_bi_Vsi_bi=0.0;
  T3_Vdi_bi_Tempt_GND=0.0;
#endif
T3_Vsi_bi=bsimbulk_d_lexp((-T2),(-T2_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=0.0;
  T3_Vsi_bi_Vgm_di=0.0;
  T3_Vsi_bi_Vdbulk_di=0.0;
  T3_Vsi_bi_Vsbulk_si=0.0;
  T3_Vsi_bi_Vgi_bi=0.0;
  T3_Vsi_bi_Vdi_bi=0.0;
  T3_Vsi_bi_Vsi_bi=0.0;
  T3_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((-T2),(-T2_Tempt_GND));
#endif
#endif
T3=bsimbulk_lexp((-T2));
EXIT_IF_ISNAN(bsimbulk_lexp((-T2)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(0.5*gammaPD_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vdbulk_di+0.5*0.0);
  T1_Vdbulk_di_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vgm_si);
  T1_Vdbulk_di_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vdbulk_di);
  T1_Vdbulk_di_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vsbulk_si);
  T1_Vdbulk_di_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vgi_bi);
  T1_Vdbulk_di_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vdi_bi);
  T1_Vdbulk_di_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vsi_bi);
  T1_Vdbulk_di_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Tempt_GND);
#endif
T1_Vsbulk_si=(0.5*gammaPD_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vsbulk_si+0.5*0.0);
  T1_Vsbulk_si_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vgm_si);
  T1_Vsbulk_si_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vdbulk_di);
  T1_Vsbulk_si_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vsbulk_si);
  T1_Vsbulk_si_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vgi_bi);
  T1_Vsbulk_si_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vdi_bi);
  T1_Vsbulk_si_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vsi_bi);
  T1_Vsbulk_si_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Tempt_GND);
#endif
T1_Vgi_bi=(0.5*gammaPD_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vgi_bi+0.5*0.0);
  T1_Vgi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=(0.5*gammaPD_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vdi_bi+0.5*0.0);
  T1_Vdi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=(0.5*gammaPD_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vsi_bi+0.5*0.0);
  T1_Vsi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(0.5*gammaPD_Tempt_GND);
#endif
#endif
T1=(0.5*gammaPD);
EXIT_IF_ISNAN((0.5*gammaPD))
{
double m00_sqrt(d00_sqrt0,(((vgfbPD-1.0)+T3)+(T1*T1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((vgfbPD-1.0)+T3)+(T1*T1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*d10_sqrt0-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vgm_di-0.0)+T3_Vdbulk_di_Vgm_di)+(+T1_Vdbulk_di_Vgm_di*T1+T1_Vdbulk_di*T1_Vgm_di+T1_Vgm_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_di)))-T1_Vdbulk_di_Vgm_di);
  T2_Vdbulk_di_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vgm_si-0.0)+T3_Vdbulk_di_Vgm_si)+(+T1_Vdbulk_di_Vgm_si*T1+T1_Vdbulk_di*T1_Vgm_si+T1_Vgm_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_si)))-T1_Vdbulk_di_Vgm_si);
  T2_Vdbulk_di_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vdbulk_di-0.0)+T3_Vdbulk_di_Vdbulk_di)+(+T1_Vdbulk_di_Vdbulk_di*T1+T1_Vdbulk_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdbulk_di)))-T1_Vdbulk_di_Vdbulk_di);
  T2_Vdbulk_di_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vsbulk_si-0.0)+T3_Vdbulk_di_Vsbulk_si)+(+T1_Vdbulk_di_Vsbulk_si*T1+T1_Vdbulk_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsbulk_si)))-T1_Vdbulk_di_Vsbulk_si);
  T2_Vdbulk_di_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vgi_bi-0.0)+T3_Vdbulk_di_Vgi_bi)+(+T1_Vdbulk_di_Vgi_bi*T1+T1_Vdbulk_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgi_bi)))-T1_Vdbulk_di_Vgi_bi);
  T2_Vdbulk_di_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vdi_bi-0.0)+T3_Vdbulk_di_Vdi_bi)+(+T1_Vdbulk_di_Vdi_bi*T1+T1_Vdbulk_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdi_bi)))-T1_Vdbulk_di_Vdi_bi);
  T2_Vdbulk_di_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vsi_bi-0.0)+T3_Vdbulk_di_Vsi_bi)+(+T1_Vdbulk_di_Vsi_bi*T1+T1_Vdbulk_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsi_bi)))-T1_Vdbulk_di_Vsi_bi);
  T2_Vdbulk_di_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Tempt_GND-0.0)+T3_Vdbulk_di_Tempt_GND)+(+T1_Vdbulk_di_Tempt_GND*T1+T1_Vdbulk_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vdbulk_di+T1*T1_Vdbulk_di_Tempt_GND)))-T1_Vdbulk_di_Tempt_GND);
#endif
T2_Vsbulk_si=(((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*d10_sqrt0-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vgm_di-0.0)+T3_Vsbulk_si_Vgm_di)+(+T1_Vsbulk_si_Vgm_di*T1+T1_Vsbulk_si*T1_Vgm_di+T1_Vgm_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_di)))-T1_Vsbulk_si_Vgm_di);
  T2_Vsbulk_si_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vgm_si-0.0)+T3_Vsbulk_si_Vgm_si)+(+T1_Vsbulk_si_Vgm_si*T1+T1_Vsbulk_si*T1_Vgm_si+T1_Vgm_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_si)))-T1_Vsbulk_si_Vgm_si);
  T2_Vsbulk_si_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vdbulk_di-0.0)+T3_Vsbulk_si_Vdbulk_di)+(+T1_Vsbulk_si_Vdbulk_di*T1+T1_Vsbulk_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdbulk_di)))-T1_Vsbulk_si_Vdbulk_di);
  T2_Vsbulk_si_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vsbulk_si-0.0)+T3_Vsbulk_si_Vsbulk_si)+(+T1_Vsbulk_si_Vsbulk_si*T1+T1_Vsbulk_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsbulk_si)))-T1_Vsbulk_si_Vsbulk_si);
  T2_Vsbulk_si_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vgi_bi-0.0)+T3_Vsbulk_si_Vgi_bi)+(+T1_Vsbulk_si_Vgi_bi*T1+T1_Vsbulk_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgi_bi)))-T1_Vsbulk_si_Vgi_bi);
  T2_Vsbulk_si_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vdi_bi-0.0)+T3_Vsbulk_si_Vdi_bi)+(+T1_Vsbulk_si_Vdi_bi*T1+T1_Vsbulk_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdi_bi)))-T1_Vsbulk_si_Vdi_bi);
  T2_Vsbulk_si_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vsi_bi-0.0)+T3_Vsbulk_si_Vsi_bi)+(+T1_Vsbulk_si_Vsi_bi*T1+T1_Vsbulk_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsi_bi)))-T1_Vsbulk_si_Vsi_bi);
  T2_Vsbulk_si_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Tempt_GND-0.0)+T3_Vsbulk_si_Tempt_GND)+(+T1_Vsbulk_si_Tempt_GND*T1+T1_Vsbulk_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vsbulk_si+T1*T1_Vsbulk_si_Tempt_GND)))-T1_Vsbulk_si_Tempt_GND);
#endif
T2_Vgi_bi=(((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*d10_sqrt0-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgm_di-0.0)+T3_Vgi_bi_Vgm_di)+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)))-T1_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgm_si-0.0)+T3_Vgi_bi_Vgm_si)+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)))-T1_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vdbulk_di-0.0)+T3_Vgi_bi_Vdbulk_di)+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)))-T1_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vsbulk_si-0.0)+T3_Vgi_bi_Vsbulk_si)+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)))-T1_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgi_bi-0.0)+T3_Vgi_bi_Vgi_bi)+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)))-T1_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vdi_bi-0.0)+T3_Vgi_bi_Vdi_bi)+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)))-T1_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vsi_bi-0.0)+T3_Vgi_bi_Vsi_bi)+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)))-T1_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Tempt_GND-0.0)+T3_Vgi_bi_Tempt_GND)+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)))-T1_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=(((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*d10_sqrt0-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgm_di-0.0)+T3_Vdi_bi_Vgm_di)+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)))-T1_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgm_si-0.0)+T3_Vdi_bi_Vgm_si)+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)))-T1_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vdbulk_di-0.0)+T3_Vdi_bi_Vdbulk_di)+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)))-T1_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vsbulk_si-0.0)+T3_Vdi_bi_Vsbulk_si)+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)))-T1_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgi_bi-0.0)+T3_Vdi_bi_Vgi_bi)+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)))-T1_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vdi_bi-0.0)+T3_Vdi_bi_Vdi_bi)+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)))-T1_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vsi_bi-0.0)+T3_Vdi_bi_Vsi_bi)+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)))-T1_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Tempt_GND-0.0)+T3_Vdi_bi_Tempt_GND)+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)))-T1_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=(((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*d10_sqrt0-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgm_di-0.0)+T3_Vsi_bi_Vgm_di)+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)))-T1_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgm_si-0.0)+T3_Vsi_bi_Vgm_si)+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)))-T1_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vdbulk_di-0.0)+T3_Vsi_bi_Vdbulk_di)+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)))-T1_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vsbulk_si-0.0)+T3_Vsi_bi_Vsbulk_si)+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)))-T1_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgi_bi-0.0)+T3_Vsi_bi_Vgi_bi)+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)))-T1_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vdi_bi-0.0)+T3_Vsi_bi_Vdi_bi)+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)))-T1_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vsi_bi-0.0)+T3_Vsi_bi_Vsi_bi)+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)))-T1_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Tempt_GND-0.0)+T3_Vsi_bi_Tempt_GND)+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((vgfbPD_Tempt_GND+T3_Tempt_GND)+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0-T1_Tempt_GND);
#endif
#endif
T2=(d00_sqrt0-T1);
EXIT_IF_ISNAN((d00_sqrt0-T1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
psip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psip_Vgm_di_Vgm_di=0.0;
  psip_Vgm_di_Vgm_si=0.0;
  psip_Vgm_di_Vdbulk_di=0.0;
  psip_Vgm_di_Vsbulk_si=0.0;
  psip_Vgm_di_Vgi_bi=0.0;
  psip_Vgm_di_Vdi_bi=0.0;
  psip_Vgm_di_Vsi_bi=0.0;
  psip_Vgm_di_Tempt_GND=0.0;
#endif
psip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psip_Vgm_si_Vgm_di=0.0;
  psip_Vgm_si_Vgm_si=0.0;
  psip_Vgm_si_Vdbulk_di=0.0;
  psip_Vgm_si_Vsbulk_si=0.0;
  psip_Vgm_si_Vgi_bi=0.0;
  psip_Vgm_si_Vdi_bi=0.0;
  psip_Vgm_si_Vsi_bi=0.0;
  psip_Vgm_si_Tempt_GND=0.0;
#endif
psip_Vdbulk_di=(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di))-T3_Vdbulk_di);
#if defined(_DERIVATE2)
  psip_Vdbulk_di_Vgm_di=(+(+(+T2_Vdbulk_di_Vgm_di*T2+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_di)+0.0)-T3_Vdbulk_di_Vgm_di);
  psip_Vdbulk_di_Vgm_si=(+(+(+T2_Vdbulk_di_Vgm_si*T2+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_si)+0.0)-T3_Vdbulk_di_Vgm_si);
  psip_Vdbulk_di_Vdbulk_di=(+(+(+T2_Vdbulk_di_Vdbulk_di*T2+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdbulk_di)+0.0)-T3_Vdbulk_di_Vdbulk_di);
  psip_Vdbulk_di_Vsbulk_si=(+(+(+T2_Vdbulk_di_Vsbulk_si*T2+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsbulk_si)+0.0)-T3_Vdbulk_di_Vsbulk_si);
  psip_Vdbulk_di_Vgi_bi=(+(+(+T2_Vdbulk_di_Vgi_bi*T2+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgi_bi)+0.0)-T3_Vdbulk_di_Vgi_bi);
  psip_Vdbulk_di_Vdi_bi=(+(+(+T2_Vdbulk_di_Vdi_bi*T2+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdi_bi)+0.0)-T3_Vdbulk_di_Vdi_bi);
  psip_Vdbulk_di_Vsi_bi=(+(+(+T2_Vdbulk_di_Vsi_bi*T2+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsi_bi)+0.0)-T3_Vdbulk_di_Vsi_bi);
  psip_Vdbulk_di_Tempt_GND=(+(+(+T2_Vdbulk_di_Tempt_GND*T2+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*T2_Vdbulk_di_Tempt_GND)+0.0)-T3_Vdbulk_di_Tempt_GND);
#endif
psip_Vsbulk_si=(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si))-T3_Vsbulk_si);
#if defined(_DERIVATE2)
  psip_Vsbulk_si_Vgm_di=(+(+(+T2_Vsbulk_si_Vgm_di*T2+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_di)+0.0)-T3_Vsbulk_si_Vgm_di);
  psip_Vsbulk_si_Vgm_si=(+(+(+T2_Vsbulk_si_Vgm_si*T2+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_si)+0.0)-T3_Vsbulk_si_Vgm_si);
  psip_Vsbulk_si_Vdbulk_di=(+(+(+T2_Vsbulk_si_Vdbulk_di*T2+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdbulk_di)+0.0)-T3_Vsbulk_si_Vdbulk_di);
  psip_Vsbulk_si_Vsbulk_si=(+(+(+T2_Vsbulk_si_Vsbulk_si*T2+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsbulk_si)+0.0)-T3_Vsbulk_si_Vsbulk_si);
  psip_Vsbulk_si_Vgi_bi=(+(+(+T2_Vsbulk_si_Vgi_bi*T2+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgi_bi)+0.0)-T3_Vsbulk_si_Vgi_bi);
  psip_Vsbulk_si_Vdi_bi=(+(+(+T2_Vsbulk_si_Vdi_bi*T2+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdi_bi)+0.0)-T3_Vsbulk_si_Vdi_bi);
  psip_Vsbulk_si_Vsi_bi=(+(+(+T2_Vsbulk_si_Vsi_bi*T2+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsi_bi)+0.0)-T3_Vsbulk_si_Vsi_bi);
  psip_Vsbulk_si_Tempt_GND=(+(+(+T2_Vsbulk_si_Tempt_GND*T2+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*T2_Vsbulk_si_Tempt_GND)+0.0)-T3_Vsbulk_si_Tempt_GND);
#endif
psip_Vgi_bi=(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))-T3_Vgi_bi);
#if defined(_DERIVATE2)
  psip_Vgi_bi_Vgm_di=(+(+(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di)+0.0)-T3_Vgi_bi_Vgm_di);
  psip_Vgi_bi_Vgm_si=(+(+(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si)+0.0)-T3_Vgi_bi_Vgm_si);
  psip_Vgi_bi_Vdbulk_di=(+(+(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di)+0.0)-T3_Vgi_bi_Vdbulk_di);
  psip_Vgi_bi_Vsbulk_si=(+(+(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si)+0.0)-T3_Vgi_bi_Vsbulk_si);
  psip_Vgi_bi_Vgi_bi=(+(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0)-T3_Vgi_bi_Vgi_bi);
  psip_Vgi_bi_Vdi_bi=(+(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0)-T3_Vgi_bi_Vdi_bi);
  psip_Vgi_bi_Vsi_bi=(+(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0)-T3_Vgi_bi_Vsi_bi);
  psip_Vgi_bi_Tempt_GND=(+(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0)-T3_Vgi_bi_Tempt_GND);
#endif
psip_Vdi_bi=(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))-T3_Vdi_bi);
#if defined(_DERIVATE2)
  psip_Vdi_bi_Vgm_di=(+(+(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di)+0.0)-T3_Vdi_bi_Vgm_di);
  psip_Vdi_bi_Vgm_si=(+(+(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si)+0.0)-T3_Vdi_bi_Vgm_si);
  psip_Vdi_bi_Vdbulk_di=(+(+(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di)+0.0)-T3_Vdi_bi_Vdbulk_di);
  psip_Vdi_bi_Vsbulk_si=(+(+(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si)+0.0)-T3_Vdi_bi_Vsbulk_si);
  psip_Vdi_bi_Vgi_bi=(+(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0)-T3_Vdi_bi_Vgi_bi);
  psip_Vdi_bi_Vdi_bi=(+(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0)-T3_Vdi_bi_Vdi_bi);
  psip_Vdi_bi_Vsi_bi=(+(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0)-T3_Vdi_bi_Vsi_bi);
  psip_Vdi_bi_Tempt_GND=(+(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0)-T3_Vdi_bi_Tempt_GND);
#endif
psip_Vsi_bi=(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))-T3_Vsi_bi);
#if defined(_DERIVATE2)
  psip_Vsi_bi_Vgm_di=(+(+(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di)+0.0)-T3_Vsi_bi_Vgm_di);
  psip_Vsi_bi_Vgm_si=(+(+(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si)+0.0)-T3_Vsi_bi_Vgm_si);
  psip_Vsi_bi_Vdbulk_di=(+(+(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di)+0.0)-T3_Vsi_bi_Vdbulk_di);
  psip_Vsi_bi_Vsbulk_si=(+(+(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si)+0.0)-T3_Vsi_bi_Vsbulk_si);
  psip_Vsi_bi_Vgi_bi=(+(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0)-T3_Vsi_bi_Vgi_bi);
  psip_Vsi_bi_Vdi_bi=(+(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0)-T3_Vsi_bi_Vdi_bi);
  psip_Vsi_bi_Vsi_bi=(+(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0)-T3_Vsi_bi_Vsi_bi);
  psip_Vsi_bi_Tempt_GND=(+(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0)-T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
psip_Tempt_GND=(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))-T3_Tempt_GND);
#endif
#endif
psip=(((T2*T2)+1.0)-T3);
EXIT_IF_ISNAN((((T2*T2)+1.0)-T3))
}
{
double m00_sqrt(d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=(0.5*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_di+psip_Vgm_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_si+psip_Vgm_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgi_bi+psip_Vgi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdi_bi+psip_Vdi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsi_bi+psip_Vsi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Tempt_GND-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Tempt_GND+psip_Tempt_GND*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsbulk_si=(0.5*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_di+psip_Vgm_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_si+psip_Vgm_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgi_bi+psip_Vgi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdi_bi+psip_Vdi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsi_bi+psip_Vsi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Tempt_GND-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Tempt_GND+psip_Tempt_GND*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vgi_bi=(0.5*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vdi_bi=(0.5*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsi_bi=(0.5*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(psip_Tempt_GND+((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((psip+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psip+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T8)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T8)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=0.0;
  sqrtpsip_Vgm_di_Vgm_si=0.0;
  sqrtpsip_Vgm_di_Vdbulk_di=0.0;
  sqrtpsip_Vgm_di_Vsbulk_si=0.0;
  sqrtpsip_Vgm_di_Vgi_bi=0.0;
  sqrtpsip_Vgm_di_Vdi_bi=0.0;
  sqrtpsip_Vgm_di_Vsi_bi=0.0;
  sqrtpsip_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=0.0;
  sqrtpsip_Vgm_si_Vgm_si=0.0;
  sqrtpsip_Vgm_si_Vdbulk_di=0.0;
  sqrtpsip_Vgm_si_Vsbulk_si=0.0;
  sqrtpsip_Vgm_si_Vgi_bi=0.0;
  sqrtpsip_Vgm_si_Vdi_bi=0.0;
  sqrtpsip_Vgm_si_Vsi_bi=0.0;
  sqrtpsip_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vdbulk_di=T8_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_di);
  sqrtpsip_Vdbulk_di_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_si);
  sqrtpsip_Vdbulk_di_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdbulk_di);
  sqrtpsip_Vdbulk_di_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsbulk_si);
  sqrtpsip_Vdbulk_di_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgi_bi);
  sqrtpsip_Vdbulk_di_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdi_bi);
  sqrtpsip_Vdbulk_di_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsi_bi);
  sqrtpsip_Vdbulk_di_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Tempt_GND);
#endif
sqrtpsip_Vsbulk_si=T8_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_di);
  sqrtpsip_Vsbulk_si_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_si);
  sqrtpsip_Vsbulk_si_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdbulk_di);
  sqrtpsip_Vsbulk_si_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsbulk_si);
  sqrtpsip_Vsbulk_si_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgi_bi);
  sqrtpsip_Vsbulk_si_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdi_bi);
  sqrtpsip_Vsbulk_si_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsi_bi);
  sqrtpsip_Vsbulk_si_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Tempt_GND);
#endif
sqrtpsip_Vgi_bi=T8_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=T8_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=T8_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=T8_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=(+0.0+(gam_Vdbulk_di_Vgm_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdbulk_di=(+0.0+(gam_Vdbulk_di_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsbulk_si=(+0.0+(gam_Vdbulk_di_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdi_bi=(+0.0+(gam_Vdbulk_di_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsi_bi=(+0.0+(gam_Vdbulk_di_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Tempt_GND=(+0.0+(gam_Vdbulk_di_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgi_bi=(+0.0+(gam_Vdbulk_di_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsbulk_si=((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=(+0.0+(gam_Vsbulk_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdbulk_di=(+0.0+(gam_Vsbulk_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsbulk_si=(+0.0+(gam_Vsbulk_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdi_bi=(+0.0+(gam_Vsbulk_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsi_bi=(+0.0+(gam_Vsbulk_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Tempt_GND=(+0.0+(gam_Vsbulk_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgi_bi=(+0.0+(gam_Vsbulk_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vdi_bi=((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsi_bi=((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#endif
T9_Vgi_bi=((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#endif
T9=(1.0+(gam/(2.0*sqrtpsip)));
EXIT_IF_ISNAN((1.0+(gam/(2.0*sqrtpsip))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=((((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*0.0/gam/gam/gam);
  T0_Vdbulk_di_Vgm_si=((+0.0+(gam_Vdbulk_di_Vgm_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vgm_si/gam/gam/gam);
  T0_Vdbulk_di_Vdbulk_di=((+0.0+(gam_Vdbulk_di_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdbulk_di_Vsbulk_si=((+0.0+(gam_Vdbulk_di_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdbulk_di_Vgi_bi=((+0.0+(gam_Vdbulk_di_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vgi_bi/gam/gam/gam);
  T0_Vdbulk_di_Vdi_bi=((+0.0+(gam_Vdbulk_di_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vdi_bi/gam/gam/gam);
  T0_Vdbulk_di_Vsi_bi=((+0.0+(gam_Vdbulk_di_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vsi_bi/gam/gam/gam);
  T0_Vdbulk_di_Tempt_GND=((+0.0+(gam_Vdbulk_di_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsbulk_si=((((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*0.0/gam/gam/gam);
  T0_Vsbulk_si_Vgm_si=((+0.0+(gam_Vsbulk_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vgm_si/gam/gam/gam);
  T0_Vsbulk_si_Vdbulk_di=((+0.0+(gam_Vsbulk_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsbulk_si_Vsbulk_si=((+0.0+(gam_Vsbulk_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsbulk_si_Vgi_bi=((+0.0+(gam_Vsbulk_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vgi_bi/gam/gam/gam);
  T0_Vsbulk_si_Vdi_bi=((+0.0+(gam_Vsbulk_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vdi_bi/gam/gam/gam);
  T0_Vsbulk_si_Vsi_bi=((+0.0+(gam_Vsbulk_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vsi_bi/gam/gam/gam);
  T0_Vsbulk_si_Tempt_GND=((+0.0+(gam_Vsbulk_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vgi_bi=((((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*0.0/gam/gam/gam);
  T0_Vgi_bi_Vgm_si=((+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vgi_bi_Vdbulk_di=((+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgi_bi_Vsbulk_si=((+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgi_bi_Vgi_bi=((+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vgi_bi_Vdi_bi=((+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vgi_bi_Vsi_bi=((+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vgi_bi_Tempt_GND=((+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vdi_bi=((((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*0.0/gam/gam/gam);
  T0_Vdi_bi_Vgm_si=((+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vdi_bi_Vdbulk_di=((+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdi_bi_Vsbulk_si=((+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdi_bi_Vgi_bi=((+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vdi_bi_Vdi_bi=((+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vdi_bi_Vsi_bi=((+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vdi_bi_Tempt_GND=((+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsi_bi=((((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*0.0/gam/gam/gam);
  T0_Vsi_bi_Vgm_si=((+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vsi_bi_Vdbulk_di=((+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsi_bi_Vsbulk_si=((+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsi_bi_Vgi_bi=((+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vsi_bi_Vdi_bi=((+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vsi_bi_Vsi_bi=((+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vsi_bi_Tempt_GND=((+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Tempt_GND)/gam/gam);
#endif
#endif
T0=((1.0+(gam/(2.0*sqrtpsip)))/gam);
EXIT_IF_ISNAN(((1.0+(gam/(2.0*sqrtpsip)))/gam))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(psip_Vdbulk_di-vs_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+psip_Vdbulk_di_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vdbulk_di_Vgm_si=(+(+psip_Vdbulk_di_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vgm_si);
  T1_Vdbulk_di_Vdbulk_di=(+(+psip_Vdbulk_di_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vdbulk_di);
  T1_Vdbulk_di_Vsbulk_si=(+(+psip_Vdbulk_di_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vsbulk_si);
  T1_Vdbulk_di_Vgi_bi=(+(+psip_Vdbulk_di_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vgi_bi);
  T1_Vdbulk_di_Vdi_bi=(+(+psip_Vdbulk_di_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vdi_bi);
  T1_Vdbulk_di_Vsi_bi=(+(+psip_Vdbulk_di_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Vsi_bi);
  T1_Vdbulk_di_Tempt_GND=(+(+psip_Vdbulk_di_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vdbulk_di_Tempt_GND);
#endif
T1_Vsbulk_si=(psip_Vsbulk_si-vs_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+psip_Vsbulk_si_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vsbulk_si_Vgm_si=(+(+psip_Vsbulk_si_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vgm_si);
  T1_Vsbulk_si_Vdbulk_di=(+(+psip_Vsbulk_si_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vdbulk_di);
  T1_Vsbulk_si_Vsbulk_si=(+(+psip_Vsbulk_si_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vsbulk_si);
  T1_Vsbulk_si_Vgi_bi=(+(+psip_Vsbulk_si_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vgi_bi);
  T1_Vsbulk_si_Vdi_bi=(+(+psip_Vsbulk_si_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vdi_bi);
  T1_Vsbulk_si_Vsi_bi=(+(+psip_Vsbulk_si_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Vsi_bi);
  T1_Vsbulk_si_Tempt_GND=(+(+psip_Vsbulk_si_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vsbulk_si_Tempt_GND);
#endif
T1_Vgi_bi=(psip_Vgi_bi-vs_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+psip_Vgi_bi_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vgi_bi_Vgm_si=(+(+psip_Vgi_bi_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+(+psip_Vgi_bi_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+(+psip_Vgi_bi_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+(+psip_Vgi_bi_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+(+psip_Vgi_bi_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+(+psip_Vgi_bi_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+(+psip_Vgi_bi_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=(psip_Vdi_bi-vs_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+psip_Vdi_bi_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vdi_bi_Vgm_si=(+(+psip_Vdi_bi_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+(+psip_Vdi_bi_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+(+psip_Vdi_bi_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+(+psip_Vdi_bi_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+(+psip_Vdi_bi_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+(+psip_Vdi_bi_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+(+psip_Vdi_bi_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=(psip_Vsi_bi-vs_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+psip_Vsi_bi_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vsi_bi_Vgm_si=(+(+psip_Vsi_bi_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+(+psip_Vsi_bi_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+(+psip_Vsi_bi_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+(+psip_Vsi_bi_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+(+psip_Vsi_bi_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+(+psip_Vsi_bi_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+(+psip_Vsi_bi_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vs_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((psip_Tempt_GND-(2.0*phib_Tempt_GND))-vs_Tempt_GND);
#endif
#endif
T1=((psip-(2.0*phib))-vs);
EXIT_IF_ISNAN(((psip-(2.0*phib))-vs))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(T1_Vdbulk_di-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdbulk_di)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdbulk_di))));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+T1_Vdbulk_di_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_di));
  T2_Vdbulk_di_Vgm_si=(+T1_Vdbulk_di_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_si));
  T2_Vdbulk_di_Vdbulk_di=(+T1_Vdbulk_di_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdbulk_di));
  T2_Vdbulk_di_Vsbulk_si=(+T1_Vdbulk_di_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsbulk_si));
  T2_Vdbulk_di_Vgi_bi=(+T1_Vdbulk_di_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgi_bi));
  T2_Vdbulk_di_Vdi_bi=(+T1_Vdbulk_di_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdi_bi));
  T2_Vdbulk_di_Vsi_bi=(+T1_Vdbulk_di_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsi_bi));
  T2_Vdbulk_di_Tempt_GND=(+T1_Vdbulk_di_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Tempt_GND)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Tempt_GND));
#endif
T2_Vsbulk_si=(T1_Vsbulk_si-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsbulk_si)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsbulk_si))));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+T1_Vsbulk_si_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_di));
  T2_Vsbulk_si_Vgm_si=(+T1_Vsbulk_si_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_si));
  T2_Vsbulk_si_Vdbulk_di=(+T1_Vsbulk_si_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdbulk_di));
  T2_Vsbulk_si_Vsbulk_si=(+T1_Vsbulk_si_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsbulk_si));
  T2_Vsbulk_si_Vgi_bi=(+T1_Vsbulk_si_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgi_bi));
  T2_Vsbulk_si_Vdi_bi=(+T1_Vsbulk_si_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdi_bi));
  T2_Vsbulk_si_Vsi_bi=(+T1_Vsbulk_si_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsi_bi));
  T2_Vsbulk_si_Tempt_GND=(+T1_Vsbulk_si_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Tempt_GND)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Tempt_GND));
#endif
T2_Vgi_bi=(T1_Vgi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgi_bi))));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_di));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_si));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdbulk_di));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsbulk_si));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(T1_Vdi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdi_bi))));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_di));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_si));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdbulk_di));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsbulk_si));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(T1_Vsi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsi_bi))));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_di));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_si));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdbulk_di));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsbulk_si));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Tempt_GND)*sqrtpsip)+((4.0*T0)*sqrtpsip_Tempt_GND))));
#endif
#endif
T2=(T1-bsimbulk_lln(((4.0*T0)*sqrtpsip)));
EXIT_IF_ISNAN((T1-bsimbulk_lln(((4.0*T0)*sqrtpsip))))
{
double m00_sqrt(d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=(0.5*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_di+0.0))+0.0))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_si+0.0))+0.0))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdbulk_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdbulk_di+0.0))+0.0))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsbulk_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsbulk_si+0.0))+0.0))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Tempt_GND*(T2+0.402982)+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsbulk_si=(0.5*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_di+0.0))+0.0))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_si+0.0))+0.0))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdbulk_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdbulk_di+0.0))+0.0))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsbulk_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsbulk_si+0.0))+0.0))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Tempt_GND*(T2+0.402982)+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Tempt_GND+0.0))+0.0))));
#endif
T8_Vgi_bi=(0.5*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_di+0.0))+0.0))));
  T8_Vgi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_si+0.0))+0.0))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*(T2+0.402982)+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*(T2+0.402982)+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*(T2+0.402982)+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*(+T2_Vgi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vdi_bi=(0.5*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_di+0.0))+0.0))));
  T8_Vdi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_si+0.0))+0.0))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*(T2+0.402982)+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*(T2+0.402982)+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*(T2+0.402982)+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*(+T2_Vdi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsi_bi=(0.5*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_di+0.0))+0.0))));
  T8_Vsi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_si+0.0))+0.0))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*(T2+0.402982)+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*(T2+0.402982)+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*(T2+0.402982)+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*(+T2_Vsi_bi_Tempt_GND+0.0))+0.0))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(T2_Tempt_GND-((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((T2-0.201491)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T2-0.201491)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
sqrtpsisa_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_di_Vgm_di=0.0;
  sqrtpsisa_Vgm_di_Vgm_si=0.0;
  sqrtpsisa_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_di_Vgi_bi=0.0;
  sqrtpsisa_Vgm_di_Vdi_bi=0.0;
  sqrtpsisa_Vgm_di_Vsi_bi=0.0;
  sqrtpsisa_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisa_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_si_Vgm_di=0.0;
  sqrtpsisa_Vgm_si_Vgm_si=0.0;
  sqrtpsisa_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_si_Vgi_bi=0.0;
  sqrtpsisa_Vgm_si_Vdi_bi=0.0;
  sqrtpsisa_Vgm_si_Vsi_bi=0.0;
  sqrtpsisa_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisa_Vdbulk_di=sqrtpsip_Vdbulk_di;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdbulk_di_Vgm_di=sqrtpsip_Vdbulk_di_Vgm_di;
  sqrtpsisa_Vdbulk_di_Vgm_si=sqrtpsip_Vdbulk_di_Vgm_si;
  sqrtpsisa_Vdbulk_di_Vdbulk_di=sqrtpsip_Vdbulk_di_Vdbulk_di;
  sqrtpsisa_Vdbulk_di_Vsbulk_si=sqrtpsip_Vdbulk_di_Vsbulk_si;
  sqrtpsisa_Vdbulk_di_Vgi_bi=sqrtpsip_Vdbulk_di_Vgi_bi;
  sqrtpsisa_Vdbulk_di_Vdi_bi=sqrtpsip_Vdbulk_di_Vdi_bi;
  sqrtpsisa_Vdbulk_di_Vsi_bi=sqrtpsip_Vdbulk_di_Vsi_bi;
  sqrtpsisa_Vdbulk_di_Tempt_GND=sqrtpsip_Vdbulk_di_Tempt_GND;
#endif
sqrtpsisa_Vsbulk_si=sqrtpsip_Vsbulk_si;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsbulk_si_Vgm_di=sqrtpsip_Vsbulk_si_Vgm_di;
  sqrtpsisa_Vsbulk_si_Vgm_si=sqrtpsip_Vsbulk_si_Vgm_si;
  sqrtpsisa_Vsbulk_si_Vdbulk_di=sqrtpsip_Vsbulk_si_Vdbulk_di;
  sqrtpsisa_Vsbulk_si_Vsbulk_si=sqrtpsip_Vsbulk_si_Vsbulk_si;
  sqrtpsisa_Vsbulk_si_Vgi_bi=sqrtpsip_Vsbulk_si_Vgi_bi;
  sqrtpsisa_Vsbulk_si_Vdi_bi=sqrtpsip_Vsbulk_si_Vdi_bi;
  sqrtpsisa_Vsbulk_si_Vsi_bi=sqrtpsip_Vsbulk_si_Vsi_bi;
  sqrtpsisa_Vsbulk_si_Tempt_GND=sqrtpsip_Vsbulk_si_Tempt_GND;
#endif
sqrtpsisa_Vgi_bi=sqrtpsip_Vgi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgi_bi_Vgm_di=sqrtpsip_Vgi_bi_Vgm_di;
  sqrtpsisa_Vgi_bi_Vgm_si=sqrtpsip_Vgi_bi_Vgm_si;
  sqrtpsisa_Vgi_bi_Vdbulk_di=sqrtpsip_Vgi_bi_Vdbulk_di;
  sqrtpsisa_Vgi_bi_Vsbulk_si=sqrtpsip_Vgi_bi_Vsbulk_si;
  sqrtpsisa_Vgi_bi_Vgi_bi=sqrtpsip_Vgi_bi_Vgi_bi;
  sqrtpsisa_Vgi_bi_Vdi_bi=sqrtpsip_Vgi_bi_Vdi_bi;
  sqrtpsisa_Vgi_bi_Vsi_bi=sqrtpsip_Vgi_bi_Vsi_bi;
  sqrtpsisa_Vgi_bi_Tempt_GND=sqrtpsip_Vgi_bi_Tempt_GND;
#endif
sqrtpsisa_Vdi_bi=sqrtpsip_Vdi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdi_bi_Vgm_di=sqrtpsip_Vdi_bi_Vgm_di;
  sqrtpsisa_Vdi_bi_Vgm_si=sqrtpsip_Vdi_bi_Vgm_si;
  sqrtpsisa_Vdi_bi_Vdbulk_di=sqrtpsip_Vdi_bi_Vdbulk_di;
  sqrtpsisa_Vdi_bi_Vsbulk_si=sqrtpsip_Vdi_bi_Vsbulk_si;
  sqrtpsisa_Vdi_bi_Vgi_bi=sqrtpsip_Vdi_bi_Vgi_bi;
  sqrtpsisa_Vdi_bi_Vdi_bi=sqrtpsip_Vdi_bi_Vdi_bi;
  sqrtpsisa_Vdi_bi_Vsi_bi=sqrtpsip_Vdi_bi_Vsi_bi;
  sqrtpsisa_Vdi_bi_Tempt_GND=sqrtpsip_Vdi_bi_Tempt_GND;
#endif
sqrtpsisa_Vsi_bi=sqrtpsip_Vsi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsi_bi_Vgm_di=sqrtpsip_Vsi_bi_Vgm_di;
  sqrtpsisa_Vsi_bi_Vgm_si=sqrtpsip_Vsi_bi_Vgm_si;
  sqrtpsisa_Vsi_bi_Vdbulk_di=sqrtpsip_Vsi_bi_Vdbulk_di;
  sqrtpsisa_Vsi_bi_Vsbulk_si=sqrtpsip_Vsi_bi_Vsbulk_si;
  sqrtpsisa_Vsi_bi_Vgi_bi=sqrtpsip_Vsi_bi_Vgi_bi;
  sqrtpsisa_Vsi_bi_Vdi_bi=sqrtpsip_Vsi_bi_Vdi_bi;
  sqrtpsisa_Vsi_bi_Vsi_bi=sqrtpsip_Vsi_bi_Vsi_bi;
  sqrtpsisa_Vsi_bi_Tempt_GND=sqrtpsip_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
sqrtpsisa_Tempt_GND=sqrtpsip_Tempt_GND;
#endif
#endif
sqrtpsisa=sqrtpsip;
EXIT_IF_ISNAN(sqrtpsip)
if
((T8<=(-68.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=0.0;
#endif
#endif
T4=(-100.0);
EXIT_IF_ISNAN((-100.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=20.0;
EXIT_IF_ISNAN(20.0)
if
((T8<(T4-(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T4,T4_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T4_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T4_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T4_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T4_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T4_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T4_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T4_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T4_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T4,T4_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T4_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T4_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T4_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T4_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T4_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T4_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T4_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T4_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T4,T4_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T4_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T4_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T4_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T4_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T4_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T4_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T4_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T4_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T4,T4_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T4_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T4_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T4_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T4_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T4_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T4_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T4_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T4_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T4,T4_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T4_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T4_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T4_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T4_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T4_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T4_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T4_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T4_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T4,T4_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T4);
EXIT_IF_ISNAN(bsimbulk_lexp(T4))
}
else
{
if
((T8>(T4+(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((T8_Vdbulk_di-T4_Vdbulk_di)*T5-(T8-T4)*T5_Vdbulk_di)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=((+T8_Vdbulk_di_Vgm_di-T4_Vdbulk_di_Vgm_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5);
  T2_Vdbulk_di_Vgm_si=((+T8_Vdbulk_di_Vgm_si-T4_Vdbulk_di_Vgm_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5);
  T2_Vdbulk_di_Vdbulk_di=((+T8_Vdbulk_di_Vdbulk_di-T4_Vdbulk_di_Vdbulk_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdbulk_di_Vsbulk_si=((+T8_Vdbulk_di_Vsbulk_si-T4_Vdbulk_di_Vsbulk_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdbulk_di_Vgi_bi=((+T8_Vdbulk_di_Vgi_bi-T4_Vdbulk_di_Vgi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vdi_bi=((+T8_Vdbulk_di_Vdi_bi-T4_Vdbulk_di_Vdi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vsi_bi=((+T8_Vdbulk_di_Vsi_bi-T4_Vdbulk_di_Vsi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5);
  T2_Vdbulk_di_Tempt_GND=((+T8_Vdbulk_di_Tempt_GND-T4_Vdbulk_di_Tempt_GND)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsbulk_si=(((T8_Vsbulk_si-T4_Vsbulk_si)*T5-(T8-T4)*T5_Vsbulk_si)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=((+T8_Vsbulk_si_Vgm_di-T4_Vsbulk_si_Vgm_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5);
  T2_Vsbulk_si_Vgm_si=((+T8_Vsbulk_si_Vgm_si-T4_Vsbulk_si_Vgm_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5);
  T2_Vsbulk_si_Vdbulk_di=((+T8_Vsbulk_si_Vdbulk_di-T4_Vsbulk_si_Vdbulk_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsbulk_si_Vsbulk_si=((+T8_Vsbulk_si_Vsbulk_si-T4_Vsbulk_si_Vsbulk_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsbulk_si_Vgi_bi=((+T8_Vsbulk_si_Vgi_bi-T4_Vsbulk_si_Vgi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vdi_bi=((+T8_Vsbulk_si_Vdi_bi-T4_Vsbulk_si_Vdi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vsi_bi=((+T8_Vsbulk_si_Vsi_bi-T4_Vsbulk_si_Vsi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5);
  T2_Vsbulk_si_Tempt_GND=((+T8_Vsbulk_si_Tempt_GND-T4_Vsbulk_si_Tempt_GND)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vgi_bi=(((T8_Vgi_bi-T4_Vgi_bi)*T5-(T8-T4)*T5_Vgi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=((+T8_Vgi_bi_Vgm_di-T4_Vgi_bi_Vgm_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vgi_bi_Vgm_si=((+T8_Vgi_bi_Vgm_si-T4_Vgi_bi_Vgm_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vgi_bi_Vdbulk_di=((+T8_Vgi_bi_Vdbulk_di-T4_Vgi_bi_Vdbulk_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgi_bi_Vsbulk_si=((+T8_Vgi_bi_Vsbulk_si-T4_Vgi_bi_Vsbulk_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgi_bi_Vgi_bi=((+T8_Vgi_bi_Vgi_bi-T4_Vgi_bi_Vgi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vgi_bi_Vdi_bi=((+T8_Vgi_bi_Vdi_bi-T4_Vgi_bi_Vdi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vgi_bi_Vsi_bi=((+T8_Vgi_bi_Vsi_bi-T4_Vgi_bi_Vsi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vgi_bi_Tempt_GND=((+T8_Vgi_bi_Tempt_GND-T4_Vgi_bi_Tempt_GND)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vdi_bi=(((T8_Vdi_bi-T4_Vdi_bi)*T5-(T8-T4)*T5_Vdi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=((+T8_Vdi_bi_Vgm_di-T4_Vdi_bi_Vgm_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vdi_bi_Vgm_si=((+T8_Vdi_bi_Vgm_si-T4_Vdi_bi_Vgm_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vdi_bi_Vdbulk_di=((+T8_Vdi_bi_Vdbulk_di-T4_Vdi_bi_Vdbulk_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdi_bi_Vsbulk_si=((+T8_Vdi_bi_Vsbulk_si-T4_Vdi_bi_Vsbulk_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdi_bi_Vgi_bi=((+T8_Vdi_bi_Vgi_bi-T4_Vdi_bi_Vgi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vdi_bi_Vdi_bi=((+T8_Vdi_bi_Vdi_bi-T4_Vdi_bi_Vdi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vdi_bi_Vsi_bi=((+T8_Vdi_bi_Vsi_bi-T4_Vdi_bi_Vsi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vdi_bi_Tempt_GND=((+T8_Vdi_bi_Tempt_GND-T4_Vdi_bi_Tempt_GND)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsi_bi=(((T8_Vsi_bi-T4_Vsi_bi)*T5-(T8-T4)*T5_Vsi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=((+T8_Vsi_bi_Vgm_di-T4_Vsi_bi_Vgm_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vsi_bi_Vgm_si=((+T8_Vsi_bi_Vgm_si-T4_Vsi_bi_Vgm_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vsi_bi_Vdbulk_di=((+T8_Vsi_bi_Vdbulk_di-T4_Vsi_bi_Vdbulk_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsi_bi_Vsbulk_si=((+T8_Vsi_bi_Vsbulk_si-T4_Vsi_bi_Vsbulk_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsi_bi_Vgi_bi=((+T8_Vsi_bi_Vgi_bi-T4_Vsi_bi_Vgi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vsi_bi_Vdi_bi=((+T8_Vsi_bi_Vdi_bi-T4_Vsi_bi_Vdi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vsi_bi_Vsi_bi=((+T8_Vsi_bi_Vsi_bi-T4_Vsi_bi_Vsi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vsi_bi_Tempt_GND=((+T8_Vsi_bi_Tempt_GND-T4_Vsi_bi_Tempt_GND)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((T8_Tempt_GND-T4_Tempt_GND)*T5-(T8-T4)*T5_Tempt_GND)/T5/T5);
#endif
#endif
T2=((T8-T4)/T5);
EXIT_IF_ISNAN(((T8-T4)/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+T2_Vdbulk_di_Vgm_di*T2+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_di);
  T6_Vdbulk_di_Vgm_si=(+T2_Vdbulk_di_Vgm_si*T2+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_si);
  T6_Vdbulk_di_Vdbulk_di=(+T2_Vdbulk_di_Vdbulk_di*T2+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdbulk_di);
  T6_Vdbulk_di_Vsbulk_si=(+T2_Vdbulk_di_Vsbulk_si*T2+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsbulk_si);
  T6_Vdbulk_di_Vgi_bi=(+T2_Vdbulk_di_Vgi_bi*T2+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgi_bi);
  T6_Vdbulk_di_Vdi_bi=(+T2_Vdbulk_di_Vdi_bi*T2+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdi_bi);
  T6_Vdbulk_di_Vsi_bi=(+T2_Vdbulk_di_Vsi_bi*T2+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsi_bi);
  T6_Vdbulk_di_Tempt_GND=(+T2_Vdbulk_di_Tempt_GND*T2+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*T2_Vdbulk_di_Tempt_GND);
#endif
T6_Vsbulk_si=((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+T2_Vsbulk_si_Vgm_di*T2+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_di);
  T6_Vsbulk_si_Vgm_si=(+T2_Vsbulk_si_Vgm_si*T2+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_si);
  T6_Vsbulk_si_Vdbulk_di=(+T2_Vsbulk_si_Vdbulk_di*T2+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdbulk_di);
  T6_Vsbulk_si_Vsbulk_si=(+T2_Vsbulk_si_Vsbulk_si*T2+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsbulk_si);
  T6_Vsbulk_si_Vgi_bi=(+T2_Vsbulk_si_Vgi_bi*T2+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgi_bi);
  T6_Vsbulk_si_Vdi_bi=(+T2_Vsbulk_si_Vdi_bi*T2+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdi_bi);
  T6_Vsbulk_si_Vsi_bi=(+T2_Vsbulk_si_Vsi_bi*T2+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsi_bi);
  T6_Vsbulk_si_Tempt_GND=(+T2_Vsbulk_si_Tempt_GND*T2+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*T2_Vsbulk_si_Tempt_GND);
#endif
T6_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND));
#endif
#endif
T6=(T2*T2);
EXIT_IF_ISNAN((T2*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdbulk_di+((T5_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T4_Vdbulk_di_Vgm_si+(+T5_Vdbulk_di_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_si))+(+T6_Vdbulk_di_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_si)))))));
  T3_Vdbulk_di_Vgm_di=(+T4_Vdbulk_di_Vgm_di+(+T5_Vdbulk_di_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_di))+(+T6_Vdbulk_di_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_di)))))));
  T3_Vdbulk_di_Vdbulk_di=(+T4_Vdbulk_di_Vdbulk_di+(+T5_Vdbulk_di_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdbulk_di))+(+T6_Vdbulk_di_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdbulk_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdbulk_di)))))));
  T3_Vdbulk_di_Vsbulk_si=(+T4_Vdbulk_di_Vsbulk_si+(+T5_Vdbulk_di_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsbulk_si))+(+T6_Vdbulk_di_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsbulk_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsbulk_si)))))));
  T3_Vdbulk_di_Vgi_bi=(+T4_Vdbulk_di_Vgi_bi+(+T5_Vdbulk_di_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgi_bi))+(+T6_Vdbulk_di_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgi_bi)))))));
  T3_Vdbulk_di_Vdi_bi=(+T4_Vdbulk_di_Vdi_bi+(+T5_Vdbulk_di_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdi_bi))+(+T6_Vdbulk_di_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdi_bi)))))));
  T3_Vdbulk_di_Vsi_bi=(+T4_Vdbulk_di_Vsi_bi+(+T5_Vdbulk_di_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsi_bi))+(+T6_Vdbulk_di_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsi_bi)))))));
  T3_Vdbulk_di_Tempt_GND=(+T4_Vdbulk_di_Tempt_GND+(+T5_Vdbulk_di_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Tempt_GND))+(+T6_Vdbulk_di_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Tempt_GND*(1.25-T6)+T6_Vdbulk_di*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Tempt_GND)))))));
#endif
T3_Vsbulk_si=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsbulk_si+((T5_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T4_Vsbulk_si_Vgm_si+(+T5_Vsbulk_si_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_si))+(+T6_Vsbulk_si_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_si)))))));
  T3_Vsbulk_si_Vgm_di=(+T4_Vsbulk_si_Vgm_di+(+T5_Vsbulk_si_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_di))+(+T6_Vsbulk_si_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_di)))))));
  T3_Vsbulk_si_Vdbulk_di=(+T4_Vsbulk_si_Vdbulk_di+(+T5_Vsbulk_si_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdbulk_di))+(+T6_Vsbulk_si_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdbulk_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdbulk_di)))))));
  T3_Vsbulk_si_Vsbulk_si=(+T4_Vsbulk_si_Vsbulk_si+(+T5_Vsbulk_si_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsbulk_si))+(+T6_Vsbulk_si_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsbulk_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsbulk_si)))))));
  T3_Vsbulk_si_Vgi_bi=(+T4_Vsbulk_si_Vgi_bi+(+T5_Vsbulk_si_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgi_bi))+(+T6_Vsbulk_si_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgi_bi)))))));
  T3_Vsbulk_si_Vdi_bi=(+T4_Vsbulk_si_Vdi_bi+(+T5_Vsbulk_si_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdi_bi))+(+T6_Vsbulk_si_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdi_bi)))))));
  T3_Vsbulk_si_Vsi_bi=(+T4_Vsbulk_si_Vsi_bi+(+T5_Vsbulk_si_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsi_bi))+(+T6_Vsbulk_si_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsi_bi)))))));
  T3_Vsbulk_si_Tempt_GND=(+T4_Vsbulk_si_Tempt_GND+(+T5_Vsbulk_si_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Tempt_GND))+(+T6_Vsbulk_si_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Tempt_GND*(1.25-T6)+T6_Vsbulk_si*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Tempt_GND)))))));
#endif
T3_Vgi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgi_bi+((T5_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T4_Vgi_bi_Vgm_si+(+T5_Vgi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_si))+(+T6_Vgi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_si)))))));
  T3_Vgi_bi_Vgm_di=(+T4_Vgi_bi_Vgm_di+(+T5_Vgi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_di))+(+T6_Vgi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_di)))))));
  T3_Vgi_bi_Vdbulk_di=(+T4_Vgi_bi_Vdbulk_di+(+T5_Vgi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdbulk_di))+(+T6_Vgi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdbulk_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdbulk_di)))))));
  T3_Vgi_bi_Vsbulk_si=(+T4_Vgi_bi_Vsbulk_si+(+T5_Vgi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsbulk_si))+(+T6_Vgi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsbulk_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsbulk_si)))))));
  T3_Vgi_bi_Vgi_bi=(+T4_Vgi_bi_Vgi_bi+(+T5_Vgi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgi_bi))+(+T6_Vgi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgi_bi)))))));
  T3_Vgi_bi_Vdi_bi=(+T4_Vgi_bi_Vdi_bi+(+T5_Vgi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdi_bi))+(+T6_Vgi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdi_bi)))))));
  T3_Vgi_bi_Vsi_bi=(+T4_Vgi_bi_Vsi_bi+(+T5_Vgi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsi_bi))+(+T6_Vgi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsi_bi)))))));
  T3_Vgi_bi_Tempt_GND=(+T4_Vgi_bi_Tempt_GND+(+T5_Vgi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Tempt_GND))+(+T6_Vgi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Tempt_GND*(1.25-T6)+T6_Vgi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Tempt_GND)))))));
#endif
T3_Vdi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdi_bi+((T5_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T4_Vdi_bi_Vgm_si+(+T5_Vdi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_si))+(+T6_Vdi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_si)))))));
  T3_Vdi_bi_Vgm_di=(+T4_Vdi_bi_Vgm_di+(+T5_Vdi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_di))+(+T6_Vdi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_di)))))));
  T3_Vdi_bi_Vdbulk_di=(+T4_Vdi_bi_Vdbulk_di+(+T5_Vdi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdbulk_di))+(+T6_Vdi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdbulk_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdbulk_di)))))));
  T3_Vdi_bi_Vsbulk_si=(+T4_Vdi_bi_Vsbulk_si+(+T5_Vdi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsbulk_si))+(+T6_Vdi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsbulk_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsbulk_si)))))));
  T3_Vdi_bi_Vgi_bi=(+T4_Vdi_bi_Vgi_bi+(+T5_Vdi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgi_bi))+(+T6_Vdi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgi_bi)))))));
  T3_Vdi_bi_Vdi_bi=(+T4_Vdi_bi_Vdi_bi+(+T5_Vdi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdi_bi))+(+T6_Vdi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdi_bi)))))));
  T3_Vdi_bi_Vsi_bi=(+T4_Vdi_bi_Vsi_bi+(+T5_Vdi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsi_bi))+(+T6_Vdi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsi_bi)))))));
  T3_Vdi_bi_Tempt_GND=(+T4_Vdi_bi_Tempt_GND+(+T5_Vdi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Tempt_GND))+(+T6_Vdi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Tempt_GND*(1.25-T6)+T6_Vdi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Tempt_GND)))))));
#endif
T3_Vsi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsi_bi+((T5_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T4_Vsi_bi_Vgm_si+(+T5_Vsi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_si))+(+T6_Vsi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_si)))))));
  T3_Vsi_bi_Vgm_di=(+T4_Vsi_bi_Vgm_di+(+T5_Vsi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_di))+(+T6_Vsi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_di)))))));
  T3_Vsi_bi_Vdbulk_di=(+T4_Vsi_bi_Vdbulk_di+(+T5_Vsi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdbulk_di))+(+T6_Vsi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdbulk_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdbulk_di)))))));
  T3_Vsi_bi_Vsbulk_si=(+T4_Vsi_bi_Vsbulk_si+(+T5_Vsi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsbulk_si))+(+T6_Vsi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsbulk_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsbulk_si)))))));
  T3_Vsi_bi_Vgi_bi=(+T4_Vsi_bi_Vgi_bi+(+T5_Vsi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgi_bi))+(+T6_Vsi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgi_bi)))))));
  T3_Vsi_bi_Vdi_bi=(+T4_Vsi_bi_Vdi_bi+(+T5_Vsi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdi_bi))+(+T6_Vsi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdi_bi)))))));
  T3_Vsi_bi_Vsi_bi=(+T4_Vsi_bi_Vsi_bi+(+T5_Vsi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsi_bi))+(+T6_Vsi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsi_bi)))))));
  T3_Vsi_bi_Tempt_GND=(+T4_Vsi_bi_Tempt_GND+(+T5_Vsi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Tempt_GND))+(+T6_Vsi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Tempt_GND*(1.25-T6)+T6_Vsi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Tempt_GND)))))));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Tempt_GND+((T5_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Tempt_GND)+((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))));
#endif
#endif
T3=bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
EXIT_IF_ISNAN(bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qs_Vgm_si=0.0;
#if defined(_DERIVATE2)
  qs_Vgm_si_Vgm_si=0.0;
  qs_Vgm_si_Vgm_di=0.0;
  qs_Vgm_si_Vdbulk_di=0.0;
  qs_Vgm_si_Vsbulk_si=0.0;
  qs_Vgm_si_Vgi_bi=0.0;
  qs_Vgm_si_Vdi_bi=0.0;
  qs_Vgm_si_Vsi_bi=0.0;
  qs_Vgm_si_Tempt_GND=0.0;
#endif
qs_Vgm_di=0.0;
#if defined(_DERIVATE2)
  qs_Vgm_di_Vgm_si=0.0;
  qs_Vgm_di_Vgm_di=0.0;
  qs_Vgm_di_Vdbulk_di=0.0;
  qs_Vgm_di_Vsbulk_si=0.0;
  qs_Vgm_di_Vgi_bi=0.0;
  qs_Vgm_di_Vdi_bi=0.0;
  qs_Vgm_di_Vsi_bi=0.0;
  qs_Vgm_di_Tempt_GND=0.0;
#endif
qs_Vdbulk_di=((T3_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))));
#if defined(_DERIVATE2)
  qs_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgm_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgm_si)-T8_Vdbulk_di_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si)))));
  qs_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgm_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgm_di)-T8_Vdbulk_di_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di)))));
  qs_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdbulk_di)-T8_Vdbulk_di_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)))));
  qs_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsbulk_si)-T8_Vdbulk_di_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)))));
  qs_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgi_bi)-T8_Vdbulk_di_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi)))));
  qs_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdi_bi)-T8_Vdbulk_di_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi)))));
  qs_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsi_bi)-T8_Vdbulk_di_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi)))));
  qs_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Tempt_GND*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Tempt_GND)-T8_Vdbulk_di_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND)))));
#endif
qs_Vsbulk_si=((T3_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))));
#if defined(_DERIVATE2)
  qs_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgm_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgm_si)-T8_Vsbulk_si_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si)))));
  qs_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgm_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgm_di)-T8_Vsbulk_si_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di)))));
  qs_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdbulk_di)-T8_Vsbulk_si_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)))));
  qs_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsbulk_si)-T8_Vsbulk_si_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)))));
  qs_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgi_bi)-T8_Vsbulk_si_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi)))));
  qs_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdi_bi)-T8_Vsbulk_si_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi)))));
  qs_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsi_bi)-T8_Vsbulk_si_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi)))));
  qs_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Tempt_GND*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Tempt_GND)-T8_Vsbulk_si_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND)))));
#endif
qs_Vgi_bi=((T3_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))));
#if defined(_DERIVATE2)
  qs_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_si)-T8_Vgi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si)))));
  qs_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_di)-T8_Vgi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di)))));
  qs_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdbulk_di)-T8_Vgi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di)))));
  qs_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsbulk_si)-T8_Vgi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si)))));
  qs_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgi_bi)-T8_Vgi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi)))));
  qs_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdi_bi)-T8_Vgi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi)))));
  qs_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsi_bi)-T8_Vgi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi)))));
  qs_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Tempt_GND*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Tempt_GND)-T8_Vgi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND)))));
#endif
qs_Vdi_bi=((T3_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))));
#if defined(_DERIVATE2)
  qs_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_si)-T8_Vdi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si)))));
  qs_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_di)-T8_Vdi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di)))));
  qs_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdbulk_di)-T8_Vdi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di)))));
  qs_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsbulk_si)-T8_Vdi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si)))));
  qs_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgi_bi)-T8_Vdi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi)))));
  qs_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdi_bi)-T8_Vdi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi)))));
  qs_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsi_bi)-T8_Vdi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi)))));
  qs_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Tempt_GND*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Tempt_GND)-T8_Vdi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND)))));
#endif
qs_Vsi_bi=((T3_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))));
#if defined(_DERIVATE2)
  qs_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_si)-T8_Vsi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si)))));
  qs_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_di)-T8_Vsi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di)))));
  qs_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdbulk_di)-T8_Vsi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di)))));
  qs_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsbulk_si)-T8_Vsi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si)))));
  qs_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgi_bi)-T8_Vsi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi)))));
  qs_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdi_bi)-T8_Vsi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi)))));
  qs_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsi_bi)-T8_Vsi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi)))));
  qs_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Tempt_GND*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Tempt_GND)-T8_Vsi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND)))));
#endif
#if defined(_DERIVATE)
qs_Tempt_GND=((T3_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))));
#endif
#endif
qs=(T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
EXIT_IF_ISNAN((T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsisainv_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_di_Vgm_di=0.0;
  sqrtpsisainv_Vgm_di_Vgm_si=0.0;
  sqrtpsisainv_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_di_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_si_Vgm_di=0.0;
  sqrtpsisainv_Vgm_si_Vgm_si=0.0;
  sqrtpsisainv_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_si_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vdbulk_di=(-sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdbulk_di_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsbulk_si=(-sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsbulk_si_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vgi_bi=(-sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vdi_bi=(-sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsi_bi=(-sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
#if defined(_DERIVATE)
sqrtpsisainv_Tempt_GND=(-sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa);
#endif
#endif
sqrtpsisainv=(1.0/sqrtpsisa);
EXIT_IF_ISNAN((1.0/sqrtpsisa))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=(T3_Vdbulk_di-((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si-(T4_Vdbulk_di_Vgm_si/T5-(T4_Vdbulk_di*T5_Vgm_si+T4_Vgm_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5));
  T3_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di-(T4_Vdbulk_di_Vgm_di/T5-(T4_Vdbulk_di*T5_Vgm_di+T4_Vgm_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5));
  T3_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5));
  T3_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsbulk_si=(T3_Vsbulk_si-((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si-(T4_Vsbulk_si_Vgm_si/T5-(T4_Vsbulk_si*T5_Vgm_si+T4_Vgm_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5));
  T3_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di-(T4_Vsbulk_si_Vgm_di/T5-(T4_Vsbulk_si*T5_Vgm_di+T4_Vgm_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5));
  T3_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5));
  T3_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vgi_bi=(T3_Vgi_bi-((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vdi_bi=(T3_Vdi_bi-((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsi_bi=(T3_Vsi_bi-((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T3_Tempt_GND-((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5));
#endif
#endif
T3=(T3-(T4/T5));
EXIT_IF_ISNAN((T3-(T4/T5)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=(((((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgm_si=(+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdbulk_di=(+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsbulk_si=(+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgi_bi=(+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdi_bi=(+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsi_bi=(+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Tempt_GND=(+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsbulk_si=(((((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vgi_bi=(((((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vdi_bi=(((((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsi_bi=(((((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#endif
#endif
T6=(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN((((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=(((-(((-T3_Vdbulk_di/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdbulk_di/T3/T3))))-(-((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di);
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_si);
  T7_Vdbulk_di_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_di);
  T7_Vdbulk_di_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdbulk_di);
  T7_Vdbulk_di_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsbulk_si);
  T7_Vdbulk_di_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgi_bi);
  T7_Vdbulk_di_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdi_bi);
  T7_Vdbulk_di_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsi_bi);
  T7_Vdbulk_di_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Tempt_GND);
#endif
T7_Vsbulk_si=(((-(((-T3_Vsbulk_si/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsbulk_si/T3/T3))))-(-((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si);
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_si);
  T7_Vsbulk_si_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_di);
  T7_Vsbulk_si_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdbulk_di);
  T7_Vsbulk_si_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsbulk_si);
  T7_Vsbulk_si_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgi_bi);
  T7_Vsbulk_si_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdi_bi);
  T7_Vsbulk_si_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsi_bi);
  T7_Vsbulk_si_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Tempt_GND);
#endif
T7_Vgi_bi=(((-(((-T3_Vgi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgi_bi/T3/T3))))-(-((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi);
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_si);
  T7_Vgi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_di);
  T7_Vgi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdbulk_di);
  T7_Vgi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsbulk_si);
  T7_Vgi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgi_bi);
  T7_Vgi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdi_bi);
  T7_Vgi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsi_bi);
  T7_Vgi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Tempt_GND);
#endif
T7_Vdi_bi=(((-(((-T3_Vdi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdi_bi/T3/T3))))-(-((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi);
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_si);
  T7_Vdi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_di);
  T7_Vdi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdbulk_di);
  T7_Vdi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsbulk_si);
  T7_Vdi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgi_bi);
  T7_Vdi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdi_bi);
  T7_Vdi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsi_bi);
  T7_Vdi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Tempt_GND);
#endif
T7_Vsi_bi=(((-(((-T3_Vsi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsi_bi/T3/T3))))-(-((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi);
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_si);
  T7_Vsi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_di);
  T7_Vsi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdbulk_di);
  T7_Vsi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsbulk_si);
  T7_Vsi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgi_bi);
  T7_Vsi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdi_bi);
  T7_Vsi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsi_bi);
  T7_Vsi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(((-(((-T3_Tempt_GND/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Tempt_GND/T3/T3))))-(-((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Tempt_GND);
#endif
#endif
T7=(((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
EXIT_IF_ISNAN((((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qs_Vgm_si=0.0;
#if defined(_DERIVATE2)
  qs_Vgm_si_Vgm_si=0.0;
  qs_Vgm_si_Vgm_di=0.0;
  qs_Vgm_si_Vdbulk_di=0.0;
  qs_Vgm_si_Vsbulk_si=0.0;
  qs_Vgm_si_Vgi_bi=0.0;
  qs_Vgm_si_Vdi_bi=0.0;
  qs_Vgm_si_Vsi_bi=0.0;
  qs_Vgm_si_Tempt_GND=0.0;
#endif
qs_Vgm_di=0.0;
#if defined(_DERIVATE2)
  qs_Vgm_di_Vgm_si=0.0;
  qs_Vgm_di_Vgm_di=0.0;
  qs_Vgm_di_Vdbulk_di=0.0;
  qs_Vgm_di_Vsbulk_si=0.0;
  qs_Vgm_di_Vgi_bi=0.0;
  qs_Vgm_di_Vdi_bi=0.0;
  qs_Vgm_di_Vsi_bi=0.0;
  qs_Vgm_di_Tempt_GND=0.0;
#endif
qs_Vdbulk_di=(T3_Vdbulk_di-((((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si-(+(T4_Vdbulk_di_Vgm_si/T5-(T4_Vdbulk_di*T5_Vgm_si+T4_Vgm_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgm_si*T7+T4_Vdbulk_di*T7_Vgm_si+T4_Vgm_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgm_si)*T5+(2.0*T5_Vdbulk_di)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di-(+(T4_Vdbulk_di_Vgm_di/T5-(T4_Vdbulk_di*T5_Vgm_di+T4_Vgm_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgm_di*T7+T4_Vdbulk_di*T7_Vgm_di+T4_Vgm_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgm_di)*T5+(2.0*T5_Vdbulk_di)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(+(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdbulk_di*T7+T4_Vdbulk_di*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdbulk_di)*T5+(2.0*T5_Vdbulk_di)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(+(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsbulk_si*T7+T4_Vdbulk_di*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsbulk_si)*T5+(2.0*T5_Vdbulk_di)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(+(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgi_bi*T7+T4_Vdbulk_di*T7_Vgi_bi+T4_Vgi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(+(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdi_bi*T7+T4_Vdbulk_di*T7_Vdi_bi+T4_Vdi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(+(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsi_bi*T7+T4_Vdbulk_di*T7_Vsi_bi+T4_Vsi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(+(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Tempt_GND*T7+T4_Vdbulk_di*T7_Tempt_GND+T4_Tempt_GND*T7_Vdbulk_di+T4*T7_Vdbulk_di_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Tempt_GND)*T5+(2.0*T5_Vdbulk_di)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vsbulk_si=(T3_Vsbulk_si-((((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si-(+(T4_Vsbulk_si_Vgm_si/T5-(T4_Vsbulk_si*T5_Vgm_si+T4_Vgm_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgm_si*T7+T4_Vsbulk_si*T7_Vgm_si+T4_Vgm_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgm_si)*T5+(2.0*T5_Vsbulk_si)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di-(+(T4_Vsbulk_si_Vgm_di/T5-(T4_Vsbulk_si*T5_Vgm_di+T4_Vgm_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgm_di*T7+T4_Vsbulk_si*T7_Vgm_di+T4_Vgm_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgm_di)*T5+(2.0*T5_Vsbulk_si)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(+(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdbulk_di*T7+T4_Vsbulk_si*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdbulk_di)*T5+(2.0*T5_Vsbulk_si)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(+(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsbulk_si*T7+T4_Vsbulk_si*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsbulk_si)*T5+(2.0*T5_Vsbulk_si)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(+(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgi_bi*T7+T4_Vsbulk_si*T7_Vgi_bi+T4_Vgi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(+(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdi_bi*T7+T4_Vsbulk_si*T7_Vdi_bi+T4_Vdi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(+(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsi_bi*T7+T4_Vsbulk_si*T7_Vsi_bi+T4_Vsi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(+(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Tempt_GND*T7+T4_Vsbulk_si*T7_Tempt_GND+T4_Tempt_GND*T7_Vsbulk_si+T4*T7_Vsbulk_si_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Tempt_GND)*T5+(2.0*T5_Vsbulk_si)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vgi_bi=(T3_Vgi_bi-((((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(+(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_si*T7+T4_Vgi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_si)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(+(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_di*T7+T4_Vgi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_di)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(+(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdbulk_di*T7+T4_Vgi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdbulk_di)*T5+(2.0*T5_Vgi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(+(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsbulk_si*T7+T4_Vgi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsbulk_si)*T5+(2.0*T5_Vgi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(+(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgi_bi*T7+T4_Vgi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(+(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdi_bi*T7+T4_Vgi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(+(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsi_bi*T7+T4_Vgi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(+(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Tempt_GND*T7+T4_Vgi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vgi_bi+T4*T7_Vgi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Tempt_GND)*T5+(2.0*T5_Vgi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vdi_bi=(T3_Vdi_bi-((((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(+(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_si*T7+T4_Vdi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_si)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(+(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_di*T7+T4_Vdi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_di)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(+(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdbulk_di*T7+T4_Vdi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdbulk_di)*T5+(2.0*T5_Vdi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(+(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsbulk_si*T7+T4_Vdi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsbulk_si)*T5+(2.0*T5_Vdi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(+(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgi_bi*T7+T4_Vdi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(+(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdi_bi*T7+T4_Vdi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(+(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsi_bi*T7+T4_Vdi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(+(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Tempt_GND*T7+T4_Vdi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vdi_bi+T4*T7_Vdi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Tempt_GND)*T5+(2.0*T5_Vdi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vsi_bi=(T3_Vsi_bi-((((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(+(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_si*T7+T4_Vsi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_si)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(+(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_di*T7+T4_Vsi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_di)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(+(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdbulk_di*T7+T4_Vsi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdbulk_di)*T5+(2.0*T5_Vsi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(+(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsbulk_si*T7+T4_Vsi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsbulk_si)*T5+(2.0*T5_Vsi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(+(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgi_bi*T7+T4_Vsi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(+(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdi_bi*T7+T4_Vsi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(+(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsi_bi*T7+T4_Vsi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(+(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Tempt_GND*T7+T4_Vsi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vsi_bi+T4*T7_Vsi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Tempt_GND)*T5+(2.0*T5_Vsi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#if defined(_DERIVATE)
qs_Tempt_GND=(T3_Tempt_GND-((((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Tempt_GND)*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#endif
qs=(T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
EXIT_IF_ISNAN((T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))))
}
{
double m00_sqrt(d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
psipclamp_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psipclamp_Vgm_di_Vgm_di=0.0;
  psipclamp_Vgm_di_Vgm_si=0.0;
  psipclamp_Vgm_di_Vdbulk_di=0.0;
  psipclamp_Vgm_di_Vsbulk_si=0.0;
  psipclamp_Vgm_di_Vgi_bi=0.0;
  psipclamp_Vgm_di_Vdi_bi=0.0;
  psipclamp_Vgm_di_Vsi_bi=0.0;
  psipclamp_Vgm_di_Tempt_GND=0.0;
#endif
psipclamp_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psipclamp_Vgm_si_Vgm_di=0.0;
  psipclamp_Vgm_si_Vgm_si=0.0;
  psipclamp_Vgm_si_Vdbulk_di=0.0;
  psipclamp_Vgm_si_Vsbulk_si=0.0;
  psipclamp_Vgm_si_Vgi_bi=0.0;
  psipclamp_Vgm_si_Vdi_bi=0.0;
  psipclamp_Vgm_si_Vsi_bi=0.0;
  psipclamp_Vgm_si_Tempt_GND=0.0;
#endif
psipclamp_Vdbulk_di=(0.5*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vdbulk_di_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_di+psip_Vgm_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_si+psip_Vgm_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgi_bi+psip_Vgi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdi_bi+psip_Vdi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsi_bi+psip_Vsi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Tempt_GND-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Tempt_GND+psip_Tempt_GND*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vsbulk_si=(0.5*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vsbulk_si_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_di+psip_Vgm_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_si+psip_Vgm_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgi_bi+psip_Vgi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdi_bi+psip_Vdi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsi_bi+psip_Vsi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Tempt_GND-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Tempt_GND+psip_Tempt_GND*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vgi_bi=(0.5*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vgi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vdi_bi=(0.5*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vdi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vsi_bi=(0.5*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vsi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
psipclamp_Tempt_GND=(0.5*(psip_Tempt_GND+((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND))*d10_sqrt0));
#endif
#endif
psipclamp=(0.5*((psip+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psip+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,psipclamp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,psipclamp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=0.0;
  sqrtpsip_Vgm_di_Vgm_si=0.0;
  sqrtpsip_Vgm_di_Vdbulk_di=0.0;
  sqrtpsip_Vgm_di_Vsbulk_si=0.0;
  sqrtpsip_Vgm_di_Vgi_bi=0.0;
  sqrtpsip_Vgm_di_Vdi_bi=0.0;
  sqrtpsip_Vgm_di_Vsi_bi=0.0;
  sqrtpsip_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=0.0;
  sqrtpsip_Vgm_si_Vgm_si=0.0;
  sqrtpsip_Vgm_si_Vdbulk_di=0.0;
  sqrtpsip_Vgm_si_Vsbulk_si=0.0;
  sqrtpsip_Vgm_si_Vgi_bi=0.0;
  sqrtpsip_Vgm_si_Vdi_bi=0.0;
  sqrtpsip_Vgm_si_Vsi_bi=0.0;
  sqrtpsip_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vdbulk_di=psipclamp_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vgm_di);
  sqrtpsip_Vdbulk_di_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vgm_si);
  sqrtpsip_Vdbulk_di_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vdbulk_di);
  sqrtpsip_Vdbulk_di_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vsbulk_si);
  sqrtpsip_Vdbulk_di_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vgi_bi);
  sqrtpsip_Vdbulk_di_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vdi_bi);
  sqrtpsip_Vdbulk_di_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vsi_bi);
  sqrtpsip_Vdbulk_di_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Tempt_GND);
#endif
sqrtpsip_Vsbulk_si=psipclamp_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vgm_di);
  sqrtpsip_Vsbulk_si_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vgm_si);
  sqrtpsip_Vsbulk_si_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vdbulk_di);
  sqrtpsip_Vsbulk_si_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vsbulk_si);
  sqrtpsip_Vsbulk_si_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vgi_bi);
  sqrtpsip_Vsbulk_si_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vdi_bi);
  sqrtpsip_Vsbulk_si_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vsi_bi);
  sqrtpsip_Vsbulk_si_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Tempt_GND);
#endif
sqrtpsip_Vgi_bi=psipclamp_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=psipclamp_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=psipclamp_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=psipclamp_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
psiavg_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psiavg_Vgm_di_Vgm_di=0.0;
  psiavg_Vgm_di_Vgm_si=0.0;
  psiavg_Vgm_di_Vdbulk_di=0.0;
  psiavg_Vgm_di_Vsbulk_si=0.0;
  psiavg_Vgm_di_Vgi_bi=0.0;
  psiavg_Vgm_di_Vdi_bi=0.0;
  psiavg_Vgm_di_Vsi_bi=0.0;
  psiavg_Vgm_di_Tempt_GND=0.0;
#endif
psiavg_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psiavg_Vgm_si_Vgm_di=0.0;
  psiavg_Vgm_si_Vgm_si=0.0;
  psiavg_Vgm_si_Vdbulk_di=0.0;
  psiavg_Vgm_si_Vsbulk_si=0.0;
  psiavg_Vgm_si_Vgi_bi=0.0;
  psiavg_Vgm_si_Vdi_bi=0.0;
  psiavg_Vgm_si_Vsi_bi=0.0;
  psiavg_Vgm_si_Tempt_GND=0.0;
#endif
psiavg_Vdbulk_di=(psip_Vdbulk_di-(2.0*qs_Vdbulk_di));
#if defined(_DERIVATE2)
  psiavg_Vdbulk_di_Vgm_di=(+psip_Vdbulk_di_Vgm_di-(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgm_di));
  psiavg_Vdbulk_di_Vgm_si=(+psip_Vdbulk_di_Vgm_si-(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgm_si));
  psiavg_Vdbulk_di_Vdbulk_di=(+psip_Vdbulk_di_Vdbulk_di-(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vdbulk_di));
  psiavg_Vdbulk_di_Vsbulk_si=(+psip_Vdbulk_di_Vsbulk_si-(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vsbulk_si));
  psiavg_Vdbulk_di_Vgi_bi=(+psip_Vdbulk_di_Vgi_bi-(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgi_bi));
  psiavg_Vdbulk_di_Vdi_bi=(+psip_Vdbulk_di_Vdi_bi-(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vdi_bi));
  psiavg_Vdbulk_di_Vsi_bi=(+psip_Vdbulk_di_Vsi_bi-(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vsi_bi));
  psiavg_Vdbulk_di_Tempt_GND=(+psip_Vdbulk_di_Tempt_GND-(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Tempt_GND));
#endif
psiavg_Vsbulk_si=(psip_Vsbulk_si-(2.0*qs_Vsbulk_si));
#if defined(_DERIVATE2)
  psiavg_Vsbulk_si_Vgm_di=(+psip_Vsbulk_si_Vgm_di-(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgm_di));
  psiavg_Vsbulk_si_Vgm_si=(+psip_Vsbulk_si_Vgm_si-(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgm_si));
  psiavg_Vsbulk_si_Vdbulk_di=(+psip_Vsbulk_si_Vdbulk_di-(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vdbulk_di));
  psiavg_Vsbulk_si_Vsbulk_si=(+psip_Vsbulk_si_Vsbulk_si-(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vsbulk_si));
  psiavg_Vsbulk_si_Vgi_bi=(+psip_Vsbulk_si_Vgi_bi-(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgi_bi));
  psiavg_Vsbulk_si_Vdi_bi=(+psip_Vsbulk_si_Vdi_bi-(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vdi_bi));
  psiavg_Vsbulk_si_Vsi_bi=(+psip_Vsbulk_si_Vsi_bi-(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vsi_bi));
  psiavg_Vsbulk_si_Tempt_GND=(+psip_Vsbulk_si_Tempt_GND-(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Tempt_GND));
#endif
psiavg_Vgi_bi=(psip_Vgi_bi-(2.0*qs_Vgi_bi));
#if defined(_DERIVATE2)
  psiavg_Vgi_bi_Vgm_di=(+psip_Vgi_bi_Vgm_di-(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_di));
  psiavg_Vgi_bi_Vgm_si=(+psip_Vgi_bi_Vgm_si-(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_si));
  psiavg_Vgi_bi_Vdbulk_di=(+psip_Vgi_bi_Vdbulk_di-(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdbulk_di));
  psiavg_Vgi_bi_Vsbulk_si=(+psip_Vgi_bi_Vsbulk_si-(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsbulk_si));
  psiavg_Vgi_bi_Vgi_bi=(+psip_Vgi_bi_Vgi_bi-(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgi_bi));
  psiavg_Vgi_bi_Vdi_bi=(+psip_Vgi_bi_Vdi_bi-(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdi_bi));
  psiavg_Vgi_bi_Vsi_bi=(+psip_Vgi_bi_Vsi_bi-(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsi_bi));
  psiavg_Vgi_bi_Tempt_GND=(+psip_Vgi_bi_Tempt_GND-(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Tempt_GND));
#endif
psiavg_Vdi_bi=(psip_Vdi_bi-(2.0*qs_Vdi_bi));
#if defined(_DERIVATE2)
  psiavg_Vdi_bi_Vgm_di=(+psip_Vdi_bi_Vgm_di-(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_di));
  psiavg_Vdi_bi_Vgm_si=(+psip_Vdi_bi_Vgm_si-(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_si));
  psiavg_Vdi_bi_Vdbulk_di=(+psip_Vdi_bi_Vdbulk_di-(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdbulk_di));
  psiavg_Vdi_bi_Vsbulk_si=(+psip_Vdi_bi_Vsbulk_si-(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsbulk_si));
  psiavg_Vdi_bi_Vgi_bi=(+psip_Vdi_bi_Vgi_bi-(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgi_bi));
  psiavg_Vdi_bi_Vdi_bi=(+psip_Vdi_bi_Vdi_bi-(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdi_bi));
  psiavg_Vdi_bi_Vsi_bi=(+psip_Vdi_bi_Vsi_bi-(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsi_bi));
  psiavg_Vdi_bi_Tempt_GND=(+psip_Vdi_bi_Tempt_GND-(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Tempt_GND));
#endif
psiavg_Vsi_bi=(psip_Vsi_bi-(2.0*qs_Vsi_bi));
#if defined(_DERIVATE2)
  psiavg_Vsi_bi_Vgm_di=(+psip_Vsi_bi_Vgm_di-(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_di));
  psiavg_Vsi_bi_Vgm_si=(+psip_Vsi_bi_Vgm_si-(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_si));
  psiavg_Vsi_bi_Vdbulk_di=(+psip_Vsi_bi_Vdbulk_di-(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdbulk_di));
  psiavg_Vsi_bi_Vsbulk_si=(+psip_Vsi_bi_Vsbulk_si-(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsbulk_si));
  psiavg_Vsi_bi_Vgi_bi=(+psip_Vsi_bi_Vgi_bi-(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgi_bi));
  psiavg_Vsi_bi_Vdi_bi=(+psip_Vsi_bi_Vdi_bi-(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdi_bi));
  psiavg_Vsi_bi_Vsi_bi=(+psip_Vsi_bi_Vsi_bi-(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsi_bi));
  psiavg_Vsi_bi_Tempt_GND=(+psip_Vsi_bi_Tempt_GND-(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
psiavg_Tempt_GND=(psip_Tempt_GND-(2.0*qs_Tempt_GND));
#endif
#endif
psiavg=(psip-(2.0*qs));
EXIT_IF_ISNAN((psip-(2.0*qs)))
{
double m00_sqrt(d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(0.5*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vsbulk_si=(0.5*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vgi_bi=(0.5*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vdi_bi=(0.5*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vsi_bi=(0.5*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(0.5*(psiavg_Tempt_GND+((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND))*d10_sqrt0));
#endif
#endif
T0=(0.5*((psiavg+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psiavg+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T0)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
nq_Vgm_si=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_si_Vgm_si=0.0;
  nq_Vgm_si_Vgm_di=0.0;
  nq_Vgm_si_Vdbulk_di=0.0;
  nq_Vgm_si_Vsbulk_si=0.0;
  nq_Vgm_si_Vgi_bi=0.0;
  nq_Vgm_si_Tempt_GND=0.0;
  nq_Vgm_si_Vdi_bi=0.0;
  nq_Vgm_si_Vsi_bi=0.0;
#endif
nq_Vgm_di=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_di_Vgm_si=0.0;
  nq_Vgm_di_Vgm_di=0.0;
  nq_Vgm_di_Vdbulk_di=0.0;
  nq_Vgm_di_Vsbulk_si=0.0;
  nq_Vgm_di_Vgi_bi=0.0;
  nq_Vgm_di_Tempt_GND=0.0;
  nq_Vgm_di_Vdi_bi=0.0;
  nq_Vgm_di_Vsi_bi=0.0;
#endif
nq_Vdbulk_di=((gam_Vdbulk_di*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vdbulk_di_Vgm_si=(+0.0+(gam_Vdbulk_di_Vgm_si/(sqrtpsip+d00_sqrt0)-(gam_Vdbulk_di*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)+gam_Vgm_si*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam*(+sqrtpsip_Vdbulk_di_Vgm_si+(m20_sqrt(T0)*T0_Vgm_si*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vgm_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdbulk_di_Vgm_di=(+0.0+(0.0/(sqrtpsip+d00_sqrt0)-(gam_Vdbulk_di*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)+0.0*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam*(+sqrtpsip_Vdbulk_di_Vgm_di+(m20_sqrt(T0)*T0_Vgm_di*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vgm_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdbulk_di_Vdbulk_di=(+0.0+(gam_Vdbulk_di_Vdbulk_di/(sqrtpsip+d00_sqrt0)-(gam_Vdbulk_di*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam_Vdbulk_di*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam*(+sqrtpsip_Vdbulk_di_Vdbulk_di+(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vdbulk_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdbulk_di_Vsbulk_si=(+0.0+(gam_Vdbulk_di_Vsbulk_si/(sqrtpsip+d00_sqrt0)-(gam_Vdbulk_di*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam_Vsbulk_si*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam*(+sqrtpsip_Vdbulk_di_Vsbulk_si+(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vsbulk_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdbulk_di_Vgi_bi=(+0.0+(gam_Vdbulk_di_Vgi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vdbulk_di*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam_Vgi_bi*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam*(+sqrtpsip_Vdbulk_di_Vgi_bi+(m20_sqrt(T0)*T0_Vgi_bi*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vgi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdbulk_di_Tempt_GND=(+0.0+(gam_Vdbulk_di_Tempt_GND/(sqrtpsip+d00_sqrt0)-(gam_Vdbulk_di*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)+gam_Tempt_GND*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam*(+sqrtpsip_Vdbulk_di_Tempt_GND+(m20_sqrt(T0)*T0_Tempt_GND*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Tempt_GND)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdbulk_di_Vdi_bi=(+0.0+(gam_Vdbulk_di_Vdi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vdbulk_di*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam_Vdi_bi*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam*(+sqrtpsip_Vdbulk_di_Vdi_bi+(m20_sqrt(T0)*T0_Vdi_bi*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vdi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdbulk_di_Vsi_bi=(+0.0+(gam_Vdbulk_di_Vsi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vdbulk_di*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam_Vsi_bi*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam*(+sqrtpsip_Vdbulk_di_Vsi_bi+(m20_sqrt(T0)*T0_Vsi_bi*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vsi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
#endif
nq_Vsbulk_si=((gam_Vsbulk_si*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vsbulk_si_Vgm_si=(+0.0+(gam_Vsbulk_si_Vgm_si/(sqrtpsip+d00_sqrt0)-(gam_Vsbulk_si*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)+gam_Vgm_si*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam*(+sqrtpsip_Vsbulk_si_Vgm_si+(m20_sqrt(T0)*T0_Vgm_si*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vgm_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsbulk_si_Vgm_di=(+0.0+(0.0/(sqrtpsip+d00_sqrt0)-(gam_Vsbulk_si*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)+0.0*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam*(+sqrtpsip_Vsbulk_si_Vgm_di+(m20_sqrt(T0)*T0_Vgm_di*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vgm_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsbulk_si_Vdbulk_di=(+0.0+(gam_Vsbulk_si_Vdbulk_di/(sqrtpsip+d00_sqrt0)-(gam_Vsbulk_si*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam_Vdbulk_di*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam*(+sqrtpsip_Vsbulk_si_Vdbulk_di+(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vdbulk_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsbulk_si_Vsbulk_si=(+0.0+(gam_Vsbulk_si_Vsbulk_si/(sqrtpsip+d00_sqrt0)-(gam_Vsbulk_si*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam_Vsbulk_si*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam*(+sqrtpsip_Vsbulk_si_Vsbulk_si+(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vsbulk_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsbulk_si_Vgi_bi=(+0.0+(gam_Vsbulk_si_Vgi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vsbulk_si*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam_Vgi_bi*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam*(+sqrtpsip_Vsbulk_si_Vgi_bi+(m20_sqrt(T0)*T0_Vgi_bi*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vgi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsbulk_si_Tempt_GND=(+0.0+(gam_Vsbulk_si_Tempt_GND/(sqrtpsip+d00_sqrt0)-(gam_Vsbulk_si*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)+gam_Tempt_GND*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam*(+sqrtpsip_Vsbulk_si_Tempt_GND+(m20_sqrt(T0)*T0_Tempt_GND*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Tempt_GND)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsbulk_si_Vdi_bi=(+0.0+(gam_Vsbulk_si_Vdi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vsbulk_si*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam_Vdi_bi*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam*(+sqrtpsip_Vsbulk_si_Vdi_bi+(m20_sqrt(T0)*T0_Vdi_bi*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vdi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsbulk_si_Vsi_bi=(+0.0+(gam_Vsbulk_si_Vsi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vsbulk_si*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam_Vsi_bi*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam*(+sqrtpsip_Vsbulk_si_Vsi_bi+(m20_sqrt(T0)*T0_Vsi_bi*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vsi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
#endif
nq_Vgi_bi=((gam_Vgi_bi*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)+gam_Vgm_si*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vgm_si+(m20_sqrt(T0)*T0_Vgm_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)+0.0*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vgm_di+(m20_sqrt(T0)*T0_Vgm_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam_Vdbulk_di*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vdbulk_di+(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdbulk_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam_Vsbulk_si*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vsbulk_si+(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsbulk_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam_Vgi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vgi_bi+(m20_sqrt(T0)*T0_Vgi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)+gam_Tempt_GND*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Tempt_GND+(m20_sqrt(T0)*T0_Tempt_GND*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Tempt_GND)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam_Vdi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vdi_bi+(m20_sqrt(T0)*T0_Vdi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vgi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam_Vsi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vgi_bi_Vsi_bi+(m20_sqrt(T0)*T0_Vsi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
#endif
#if defined(_DERIVATE)
nq_Tempt_GND=((gam_Tempt_GND*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#endif
nq_Vdi_bi=((gam_Vdi_bi*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)+gam_Vgm_si*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vgm_si+(m20_sqrt(T0)*T0_Vgm_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)+0.0*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vgm_di+(m20_sqrt(T0)*T0_Vgm_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam_Vdbulk_di*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vdbulk_di+(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdbulk_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam_Vsbulk_si*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vsbulk_si+(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsbulk_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam_Vgi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vgi_bi+(m20_sqrt(T0)*T0_Vgi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)+gam_Tempt_GND*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Tempt_GND+(m20_sqrt(T0)*T0_Tempt_GND*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Tempt_GND)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam_Vdi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vdi_bi+(m20_sqrt(T0)*T0_Vdi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vdi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam_Vsi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vdi_bi_Vsi_bi+(m20_sqrt(T0)*T0_Vsi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
#endif
nq_Vsi_bi=((gam_Vsi_bi*(sqrtpsip+d00_sqrt0)-gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0));
#if defined(_DERIVATE2)
  nq_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)+gam_Vgm_si*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vgm_si+(m20_sqrt(T0)*T0_Vgm_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vgm_si+T0_Vgm_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)+0.0*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vgm_di+(m20_sqrt(T0)*T0_Vgm_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vgm_di+T0_Vgm_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)+gam_Vdbulk_di*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vdbulk_di+(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdbulk_di)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vdbulk_di+T0_Vdbulk_di*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)+gam_Vsbulk_si*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vsbulk_si+(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsbulk_si)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vsbulk_si+T0_Vsbulk_si*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)+gam_Vgi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vgi_bi+(m20_sqrt(T0)*T0_Vgi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vgi_bi+T0_Vgi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)+gam_Tempt_GND*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Tempt_GND+(m20_sqrt(T0)*T0_Tempt_GND*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Tempt_GND)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Tempt_GND+T0_Tempt_GND*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)+gam_Vdi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vdi_bi+(m20_sqrt(T0)*T0_Vdi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vdi_bi+T0_Vdi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
  nq_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(sqrtpsip+d00_sqrt0)-(gam_Vsi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam_Vsi_bi*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)+gam*(+sqrtpsip_Vsi_bi_Vsi_bi+(m20_sqrt(T0)*T0_Vsi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsi_bi)))/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)+2*gam*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)*(sqrtpsip_Vsi_bi+T0_Vsi_bi*d10_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)/(sqrtpsip+d00_sqrt0)));
#endif
#endif
nq=(1.0+(gam/(sqrtpsip+d00_sqrt0)));
EXIT_IF_ISNAN((1.0+(gam/(sqrtpsip+d00_sqrt0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(Vt*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))));
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgm_di)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vgm_di-0.0))));
  T0_Vdbulk_di_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgm_si)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vgm_si-0.0))));
  T0_Vdbulk_di_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vdbulk_di-0.0))));
  T0_Vdbulk_di_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vsbulk_si-0.0))));
  T0_Vdbulk_di_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgi_bi)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vgi_bi-0.0))));
  T0_Vdbulk_di_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vdi_bi)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vdi_bi-0.0))));
  T0_Vdbulk_di_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vsi_bi)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vsi_bi-0.0))));
  T0_Vdbulk_di_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Tempt_GND)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Tempt_GND-0.0))));
#endif
T0_Vsbulk_si=(Vt*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))));
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgm_di)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vgm_di-0.0))));
  T0_Vsbulk_si_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgm_si)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vgm_si-0.0))));
  T0_Vsbulk_si_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vdbulk_di-0.0))));
  T0_Vsbulk_si_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vsbulk_si-0.0))));
  T0_Vsbulk_si_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgi_bi)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vgi_bi-0.0))));
  T0_Vsbulk_si_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vdi_bi)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vdi_bi-0.0))));
  T0_Vsbulk_si_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vsi_bi)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vsi_bi-0.0))));
  T0_Vsbulk_si_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Tempt_GND)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Tempt_GND-0.0))));
#endif
T0_Vgi_bi=(Vt*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_di)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vgm_di-0.0))));
  T0_Vgi_bi_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_si)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vgm_si-0.0))));
  T0_Vgi_bi_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vdbulk_di-0.0))));
  T0_Vgi_bi_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vsbulk_si-0.0))));
  T0_Vgi_bi_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Vgi_bi-psip_Vgi_bi_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgi_bi)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vgi_bi-0.0))));
  T0_Vgi_bi_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Vdi_bi-psip_Vgi_bi_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdi_bi)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vdi_bi-0.0))));
  T0_Vgi_bi_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Vsi_bi-psip_Vgi_bi_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsi_bi)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vsi_bi-0.0))));
  T0_Vgi_bi_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Tempt_GND-psip_Vgi_bi_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Tempt_GND)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Tempt_GND-0.0))));
#endif
T0_Vdi_bi=(Vt*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_di)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vgm_di-0.0))));
  T0_Vdi_bi_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_si)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vgm_si-0.0))));
  T0_Vdi_bi_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vdbulk_di-0.0))));
  T0_Vdi_bi_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vsbulk_si-0.0))));
  T0_Vdi_bi_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Vgi_bi-psip_Vdi_bi_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgi_bi)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vgi_bi-0.0))));
  T0_Vdi_bi_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Vdi_bi-psip_Vdi_bi_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdi_bi)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vdi_bi-0.0))));
  T0_Vdi_bi_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Vsi_bi-psip_Vdi_bi_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsi_bi)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vsi_bi-0.0))));
  T0_Vdi_bi_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Tempt_GND-psip_Vdi_bi_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Tempt_GND)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Tempt_GND-0.0))));
#endif
T0_Vsi_bi=(Vt*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_di)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vgm_di-0.0))));
  T0_Vsi_bi_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_si)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vgm_si-0.0))));
  T0_Vsi_bi_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vdbulk_di-0.0))));
  T0_Vsi_bi_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vsbulk_si-0.0))));
  T0_Vsi_bi_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Vgi_bi-psip_Vsi_bi_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgi_bi)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vgi_bi-0.0))));
  T0_Vsi_bi_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Vdi_bi-psip_Vsi_bi_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdi_bi)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vdi_bi-0.0))));
  T0_Vsi_bi_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Vsi_bi-psip_Vsi_bi_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsi_bi)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vsi_bi-0.0))));
  T0_Vsi_bi_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Tempt_GND-psip_Vsi_bi_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Tempt_GND)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Tempt_GND-0.0))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((Vt_Tempt_GND*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))))+(Vt*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((2.0*qs_Tempt_GND)*(nq-1.0))+((2.0*qs)*nq_Tempt_GND)))));
#endif
#endif
T0=(Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
EXIT_IF_ISNAN((Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+((0.25*0.1)*0.1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+((0.25*0.1)*0.1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
qbs_Vdbulk_di=(0.5*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vdbulk_di_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vdbulk_di-0.0)*T0+T0_Vdbulk_di*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vsbulk_si-0.0)*T0+T0_Vdbulk_di*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vgi_bi-0.0)*T0+T0_Vdbulk_di*T0_Vgi_bi+T0_Vgi_bi*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vdi_bi-0.0)*T0+T0_Vdbulk_di*T0_Vdi_bi+T0_Vdi_bi*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vsi_bi-0.0)*T0+T0_Vdbulk_di*T0_Vsi_bi+T0_Vsi_bi*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Tempt_GND-0.0)*T0+T0_Vdbulk_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vsbulk_si=(0.5*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vsbulk_si_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vdbulk_di-0.0)*T0+T0_Vsbulk_si*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vsbulk_si-0.0)*T0+T0_Vsbulk_si*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vgi_bi-0.0)*T0+T0_Vsbulk_si*T0_Vgi_bi+T0_Vgi_bi*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vdi_bi-0.0)*T0+T0_Vsbulk_si*T0_Vdi_bi+T0_Vdi_bi*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vsi_bi-0.0)*T0+T0_Vsbulk_si*T0_Vsi_bi+T0_Vsi_bi*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Tempt_GND-0.0)*T0+T0_Vsbulk_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vgi_bi=(0.5*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vgi_bi_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vdbulk_di-0.0)*T0+T0_Vgi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vsbulk_si-0.0)*T0+T0_Vgi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vgi_bi-0.0)*T0+T0_Vgi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vdi_bi-0.0)*T0+T0_Vgi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vsi_bi-0.0)*T0+T0_Vgi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Tempt_GND-0.0)*T0+T0_Vgi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vgi_bi+T0*(+T0_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vdi_bi=(0.5*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vdi_bi_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vdbulk_di-0.0)*T0+T0_Vdi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vsbulk_si-0.0)*T0+T0_Vdi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vgi_bi-0.0)*T0+T0_Vdi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vdi_bi-0.0)*T0+T0_Vdi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vsi_bi-0.0)*T0+T0_Vdi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Tempt_GND-0.0)*T0+T0_Vdi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_bi+T0*(+T0_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vsi_bi=(0.5*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vsi_bi_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vdbulk_di-0.0)*T0+T0_Vsi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vsbulk_si-0.0)*T0+T0_Vsi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vgi_bi-0.0)*T0+T0_Vsi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vdi_bi-0.0)*T0+T0_Vsi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vsi_bi-0.0)*T0+T0_Vsi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Tempt_GND-0.0)*T0+T0_Vsi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vsi_bi+T0*(+T0_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
#if defined(_DERIVATE)
qbs_Tempt_GND=(0.5*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0));
#endif
#endif
qbs=(0.5*(T0+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T0+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
qis_Vdbulk_di=(((2.0*nq_Vdbulk_di)*Vt*qs)+(((2.0*nq)*Vt)*qs_Vdbulk_di));
#if defined(_DERIVATE2)
  qis_Vdbulk_di_Vdbulk_di=(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vdbulk_di)*Vt+(2.0*nq_Vdbulk_di)*0.0+((2.0*nq_Vdbulk_di))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdbulk_di)*Vt*qs_Vdbulk_di+(((2.0*nq_Vdbulk_di))*Vt)*qs_Vdbulk_di+((2.0*nq)*Vt)*qs_Vdbulk_di_Vdbulk_di);
  qis_Vdbulk_di_Vsbulk_si=(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vsbulk_si)*Vt+(2.0*nq_Vdbulk_di)*0.0+((2.0*nq_Vsbulk_si))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdbulk_di)*Vt*qs_Vsbulk_si+(((2.0*nq_Vsbulk_si))*Vt)*qs_Vdbulk_di+((2.0*nq)*Vt)*qs_Vdbulk_di_Vsbulk_si);
  qis_Vdbulk_di_Vgi_bi=(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vgi_bi)*Vt+(2.0*nq_Vdbulk_di)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdbulk_di)*Vt*qs_Vgi_bi+(((2.0*nq_Vgi_bi))*Vt)*qs_Vdbulk_di+((2.0*nq)*Vt)*qs_Vdbulk_di_Vgi_bi);
  qis_Vdbulk_di_Tempt_GND=(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Tempt_GND)*Vt+(2.0*nq_Vdbulk_di)*Vt_Tempt_GND+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdbulk_di)*Vt*qs_Tempt_GND+(((((2.0*nq_Tempt_GND))*Vt)+((2.0*nq)*Vt_Tempt_GND)))*qs_Vdbulk_di+((2.0*nq)*Vt)*qs_Vdbulk_di_Tempt_GND);
  qis_Vdbulk_di_Vdi_bi=(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vdi_bi)*Vt+(2.0*nq_Vdbulk_di)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdbulk_di)*Vt*qs_Vdi_bi+(((2.0*nq_Vdi_bi))*Vt)*qs_Vdbulk_di+((2.0*nq)*Vt)*qs_Vdbulk_di_Vdi_bi);
  qis_Vdbulk_di_Vsi_bi=(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vsi_bi)*Vt+(2.0*nq_Vdbulk_di)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdbulk_di)*Vt*qs_Vsi_bi+(((2.0*nq_Vsi_bi))*Vt)*qs_Vdbulk_di+((2.0*nq)*Vt)*qs_Vdbulk_di_Vsi_bi);
#endif
qis_Vsbulk_si=(((2.0*nq_Vsbulk_si)*Vt*qs)+(((2.0*nq)*Vt)*qs_Vsbulk_si));
#if defined(_DERIVATE2)
  qis_Vsbulk_si_Vdbulk_di=(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vdbulk_di)*Vt+(2.0*nq_Vsbulk_si)*0.0+((2.0*nq_Vdbulk_di))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsbulk_si)*Vt*qs_Vdbulk_di+(((2.0*nq_Vdbulk_di))*Vt)*qs_Vsbulk_si+((2.0*nq)*Vt)*qs_Vsbulk_si_Vdbulk_di);
  qis_Vsbulk_si_Vsbulk_si=(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vsbulk_si)*Vt+(2.0*nq_Vsbulk_si)*0.0+((2.0*nq_Vsbulk_si))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsbulk_si)*Vt*qs_Vsbulk_si+(((2.0*nq_Vsbulk_si))*Vt)*qs_Vsbulk_si+((2.0*nq)*Vt)*qs_Vsbulk_si_Vsbulk_si);
  qis_Vsbulk_si_Vgi_bi=(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vgi_bi)*Vt+(2.0*nq_Vsbulk_si)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsbulk_si)*Vt*qs_Vgi_bi+(((2.0*nq_Vgi_bi))*Vt)*qs_Vsbulk_si+((2.0*nq)*Vt)*qs_Vsbulk_si_Vgi_bi);
  qis_Vsbulk_si_Tempt_GND=(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Tempt_GND)*Vt+(2.0*nq_Vsbulk_si)*Vt_Tempt_GND+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsbulk_si)*Vt*qs_Tempt_GND+(((((2.0*nq_Tempt_GND))*Vt)+((2.0*nq)*Vt_Tempt_GND)))*qs_Vsbulk_si+((2.0*nq)*Vt)*qs_Vsbulk_si_Tempt_GND);
  qis_Vsbulk_si_Vdi_bi=(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vdi_bi)*Vt+(2.0*nq_Vsbulk_si)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsbulk_si)*Vt*qs_Vdi_bi+(((2.0*nq_Vdi_bi))*Vt)*qs_Vsbulk_si+((2.0*nq)*Vt)*qs_Vsbulk_si_Vdi_bi);
  qis_Vsbulk_si_Vsi_bi=(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vsi_bi)*Vt+(2.0*nq_Vsbulk_si)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsbulk_si)*Vt*qs_Vsi_bi+(((2.0*nq_Vsi_bi))*Vt)*qs_Vsbulk_si+((2.0*nq)*Vt)*qs_Vsbulk_si_Vsi_bi);
#endif
qis_Vgi_bi=(((2.0*nq_Vgi_bi)*Vt*qs)+(((2.0*nq)*Vt)*qs_Vgi_bi));
#if defined(_DERIVATE2)
  qis_Vgi_bi_Vdbulk_di=(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdbulk_di)*Vt+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vdbulk_di))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vgi_bi)*Vt*qs_Vdbulk_di+(((2.0*nq_Vdbulk_di))*Vt)*qs_Vgi_bi+((2.0*nq)*Vt)*qs_Vgi_bi_Vdbulk_di);
  qis_Vgi_bi_Vsbulk_si=(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsbulk_si)*Vt+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vsbulk_si))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vgi_bi)*Vt*qs_Vsbulk_si+(((2.0*nq_Vsbulk_si))*Vt)*qs_Vgi_bi+((2.0*nq)*Vt)*qs_Vgi_bi_Vsbulk_si);
  qis_Vgi_bi_Vgi_bi=(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vgi_bi)*Vt+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vgi_bi)*Vt*qs_Vgi_bi+(((2.0*nq_Vgi_bi))*Vt)*qs_Vgi_bi+((2.0*nq)*Vt)*qs_Vgi_bi_Vgi_bi);
  qis_Vgi_bi_Tempt_GND=(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Tempt_GND)*Vt+(2.0*nq_Vgi_bi)*Vt_Tempt_GND+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vgi_bi)*Vt*qs_Tempt_GND+(((((2.0*nq_Tempt_GND))*Vt)+((2.0*nq)*Vt_Tempt_GND)))*qs_Vgi_bi+((2.0*nq)*Vt)*qs_Vgi_bi_Tempt_GND);
  qis_Vgi_bi_Vdi_bi=(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdi_bi)*Vt+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vgi_bi)*Vt*qs_Vdi_bi+(((2.0*nq_Vdi_bi))*Vt)*qs_Vgi_bi+((2.0*nq)*Vt)*qs_Vgi_bi_Vdi_bi);
  qis_Vgi_bi_Vsi_bi=(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsi_bi)*Vt+(2.0*nq_Vgi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vgi_bi)*Vt*qs_Vsi_bi+(((2.0*nq_Vsi_bi))*Vt)*qs_Vgi_bi+((2.0*nq)*Vt)*qs_Vgi_bi_Vsi_bi);
#endif
#if defined(_DERIVATE)
qis_Tempt_GND=(((((2.0*nq_Tempt_GND)*Vt)+((2.0*nq)*Vt_Tempt_GND))*qs)+(((2.0*nq)*Vt)*qs_Tempt_GND));
#endif
qis_Vdi_bi=(((2.0*nq_Vdi_bi)*Vt*qs)+(((2.0*nq)*Vt)*qs_Vdi_bi));
#if defined(_DERIVATE2)
  qis_Vdi_bi_Vdbulk_di=(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdbulk_di)*Vt+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vdbulk_di))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdi_bi)*Vt*qs_Vdbulk_di+(((2.0*nq_Vdbulk_di))*Vt)*qs_Vdi_bi+((2.0*nq)*Vt)*qs_Vdi_bi_Vdbulk_di);
  qis_Vdi_bi_Vsbulk_si=(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsbulk_si)*Vt+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vsbulk_si))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdi_bi)*Vt*qs_Vsbulk_si+(((2.0*nq_Vsbulk_si))*Vt)*qs_Vdi_bi+((2.0*nq)*Vt)*qs_Vdi_bi_Vsbulk_si);
  qis_Vdi_bi_Vgi_bi=(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vgi_bi)*Vt+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdi_bi)*Vt*qs_Vgi_bi+(((2.0*nq_Vgi_bi))*Vt)*qs_Vdi_bi+((2.0*nq)*Vt)*qs_Vdi_bi_Vgi_bi);
  qis_Vdi_bi_Tempt_GND=(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Tempt_GND)*Vt+(2.0*nq_Vdi_bi)*Vt_Tempt_GND+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdi_bi)*Vt*qs_Tempt_GND+(((((2.0*nq_Tempt_GND))*Vt)+((2.0*nq)*Vt_Tempt_GND)))*qs_Vdi_bi+((2.0*nq)*Vt)*qs_Vdi_bi_Tempt_GND);
  qis_Vdi_bi_Vdi_bi=(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdi_bi)*Vt+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdi_bi)*Vt*qs_Vdi_bi+(((2.0*nq_Vdi_bi))*Vt)*qs_Vdi_bi+((2.0*nq)*Vt)*qs_Vdi_bi_Vdi_bi);
  qis_Vdi_bi_Vsi_bi=(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsi_bi)*Vt+(2.0*nq_Vdi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vdi_bi)*Vt*qs_Vsi_bi+(((2.0*nq_Vsi_bi))*Vt)*qs_Vdi_bi+((2.0*nq)*Vt)*qs_Vdi_bi_Vsi_bi);
#endif
qis_Vsi_bi=(((2.0*nq_Vsi_bi)*Vt*qs)+(((2.0*nq)*Vt)*qs_Vsi_bi));
#if defined(_DERIVATE2)
  qis_Vsi_bi_Vdbulk_di=(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdbulk_di)*Vt+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vdbulk_di))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsi_bi)*Vt*qs_Vdbulk_di+(((2.0*nq_Vdbulk_di))*Vt)*qs_Vsi_bi+((2.0*nq)*Vt)*qs_Vsi_bi_Vdbulk_di);
  qis_Vsi_bi_Vsbulk_si=(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsbulk_si)*Vt+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vsbulk_si))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsi_bi)*Vt*qs_Vsbulk_si+(((2.0*nq_Vsbulk_si))*Vt)*qs_Vsi_bi+((2.0*nq)*Vt)*qs_Vsi_bi_Vsbulk_si);
  qis_Vsi_bi_Vgi_bi=(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vgi_bi)*Vt+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vgi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsi_bi)*Vt*qs_Vgi_bi+(((2.0*nq_Vgi_bi))*Vt)*qs_Vsi_bi+((2.0*nq)*Vt)*qs_Vsi_bi_Vgi_bi);
  qis_Vsi_bi_Tempt_GND=(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Tempt_GND)*Vt+(2.0*nq_Vsi_bi)*Vt_Tempt_GND+((2.0*nq_Tempt_GND))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsi_bi)*Vt*qs_Tempt_GND+(((((2.0*nq_Tempt_GND))*Vt)+((2.0*nq)*Vt_Tempt_GND)))*qs_Vsi_bi+((2.0*nq)*Vt)*qs_Vsi_bi_Tempt_GND);
  qis_Vsi_bi_Vdi_bi=(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdi_bi)*Vt+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vdi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsi_bi)*Vt*qs_Vdi_bi+(((2.0*nq_Vdi_bi))*Vt)*qs_Vsi_bi+((2.0*nq)*Vt)*qs_Vsi_bi_Vdi_bi);
  qis_Vsi_bi_Vsi_bi=(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsi_bi)*Vt+(2.0*nq_Vsi_bi)*0.0+((2.0*nq_Vsi_bi))*0.0+(2.0*nq)*0.0)*qs+(2.0*nq_Vsi_bi)*Vt*qs_Vsi_bi+(((2.0*nq_Vsi_bi))*Vt)*qs_Vsi_bi+((2.0*nq)*Vt)*qs_Vsi_bi_Vsi_bi);
#endif
#endif
qis=(((2.0*nq)*Vt)*qs);
EXIT_IF_ISNAN((((2.0*nq)*Vt)*qs))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
Eeffs_Vdbulk_di=(EeffFactor*(qbs_Vdbulk_di+(eta_mu*qis_Vdbulk_di)));
#if defined(_DERIVATE2)
  Eeffs_Vdbulk_di_Vdbulk_di=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdbulk_di+((eta_mu*qis_Vdbulk_di)))+0.0*(qbs_Vdbulk_di+(eta_mu*qis_Vdbulk_di))+EeffFactor*(+qbs_Vdbulk_di_Vdbulk_di+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vdbulk_di+eta_mu*qis_Vdbulk_di_Vdbulk_di)));
  Eeffs_Vdbulk_di_Vsbulk_si=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsbulk_si+((eta_mu*qis_Vsbulk_si)))+0.0*(qbs_Vdbulk_di+(eta_mu*qis_Vdbulk_di))+EeffFactor*(+qbs_Vdbulk_di_Vsbulk_si+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vdbulk_di+eta_mu*qis_Vdbulk_di_Vsbulk_si)));
  Eeffs_Vdbulk_di_Vgi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vgi_bi+((eta_mu*qis_Vgi_bi)))+0.0*(qbs_Vdbulk_di+(eta_mu*qis_Vdbulk_di))+EeffFactor*(+qbs_Vdbulk_di_Vgi_bi+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vdbulk_di+eta_mu*qis_Vdbulk_di_Vgi_bi)));
  Eeffs_Vdbulk_di_Vdi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdi_bi+((eta_mu*qis_Vdi_bi)))+0.0*(qbs_Vdbulk_di+(eta_mu*qis_Vdbulk_di))+EeffFactor*(+qbs_Vdbulk_di_Vdi_bi+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vdbulk_di+eta_mu*qis_Vdbulk_di_Vdi_bi)));
  Eeffs_Vdbulk_di_Vsi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsi_bi+((eta_mu*qis_Vsi_bi)))+0.0*(qbs_Vdbulk_di+(eta_mu*qis_Vdbulk_di))+EeffFactor*(+qbs_Vdbulk_di_Vsi_bi+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vdbulk_di+eta_mu*qis_Vdbulk_di_Vsi_bi)));
  Eeffs_Vdbulk_di_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Tempt_GND+((eta_mu*qis_Tempt_GND)))+0.0*(qbs_Vdbulk_di+(eta_mu*qis_Vdbulk_di))+EeffFactor*(+qbs_Vdbulk_di_Tempt_GND+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vdbulk_di+eta_mu*qis_Vdbulk_di_Tempt_GND)));
#endif
Eeffs_Vsbulk_si=(EeffFactor*(qbs_Vsbulk_si+(eta_mu*qis_Vsbulk_si)));
#if defined(_DERIVATE2)
  Eeffs_Vsbulk_si_Vdbulk_di=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdbulk_di+((eta_mu*qis_Vdbulk_di)))+0.0*(qbs_Vsbulk_si+(eta_mu*qis_Vsbulk_si))+EeffFactor*(+qbs_Vsbulk_si_Vdbulk_di+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vsbulk_si+eta_mu*qis_Vsbulk_si_Vdbulk_di)));
  Eeffs_Vsbulk_si_Vsbulk_si=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsbulk_si+((eta_mu*qis_Vsbulk_si)))+0.0*(qbs_Vsbulk_si+(eta_mu*qis_Vsbulk_si))+EeffFactor*(+qbs_Vsbulk_si_Vsbulk_si+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vsbulk_si+eta_mu*qis_Vsbulk_si_Vsbulk_si)));
  Eeffs_Vsbulk_si_Vgi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vgi_bi+((eta_mu*qis_Vgi_bi)))+0.0*(qbs_Vsbulk_si+(eta_mu*qis_Vsbulk_si))+EeffFactor*(+qbs_Vsbulk_si_Vgi_bi+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vsbulk_si+eta_mu*qis_Vsbulk_si_Vgi_bi)));
  Eeffs_Vsbulk_si_Vdi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdi_bi+((eta_mu*qis_Vdi_bi)))+0.0*(qbs_Vsbulk_si+(eta_mu*qis_Vsbulk_si))+EeffFactor*(+qbs_Vsbulk_si_Vdi_bi+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vsbulk_si+eta_mu*qis_Vsbulk_si_Vdi_bi)));
  Eeffs_Vsbulk_si_Vsi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsi_bi+((eta_mu*qis_Vsi_bi)))+0.0*(qbs_Vsbulk_si+(eta_mu*qis_Vsbulk_si))+EeffFactor*(+qbs_Vsbulk_si_Vsi_bi+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vsbulk_si+eta_mu*qis_Vsbulk_si_Vsi_bi)));
  Eeffs_Vsbulk_si_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Tempt_GND+((eta_mu*qis_Tempt_GND)))+0.0*(qbs_Vsbulk_si+(eta_mu*qis_Vsbulk_si))+EeffFactor*(+qbs_Vsbulk_si_Tempt_GND+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vsbulk_si+eta_mu*qis_Vsbulk_si_Tempt_GND)));
#endif
Eeffs_Vgi_bi=(EeffFactor*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi)));
#if defined(_DERIVATE2)
  Eeffs_Vgi_bi_Vdbulk_di=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdbulk_di+((eta_mu*qis_Vdbulk_di)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vdbulk_di+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vdbulk_di)));
  Eeffs_Vgi_bi_Vsbulk_si=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsbulk_si+((eta_mu*qis_Vsbulk_si)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vsbulk_si+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vsbulk_si)));
  Eeffs_Vgi_bi_Vgi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vgi_bi+((eta_mu*qis_Vgi_bi)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vgi_bi+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vgi_bi)));
  Eeffs_Vgi_bi_Vdi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdi_bi+((eta_mu*qis_Vdi_bi)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vdi_bi+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vdi_bi)));
  Eeffs_Vgi_bi_Vsi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsi_bi+((eta_mu*qis_Vsi_bi)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Vsi_bi+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Vsi_bi)));
  Eeffs_Vgi_bi_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Tempt_GND+((eta_mu*qis_Tempt_GND)))+0.0*(qbs_Vgi_bi+(eta_mu*qis_Vgi_bi))+EeffFactor*(+qbs_Vgi_bi_Tempt_GND+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vgi_bi+eta_mu*qis_Vgi_bi_Tempt_GND)));
#endif
Eeffs_Vdi_bi=(EeffFactor*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi)));
#if defined(_DERIVATE2)
  Eeffs_Vdi_bi_Vdbulk_di=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdbulk_di+((eta_mu*qis_Vdbulk_di)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vdbulk_di+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vdbulk_di)));
  Eeffs_Vdi_bi_Vsbulk_si=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsbulk_si+((eta_mu*qis_Vsbulk_si)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vsbulk_si+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vsbulk_si)));
  Eeffs_Vdi_bi_Vgi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vgi_bi+((eta_mu*qis_Vgi_bi)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vgi_bi+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vgi_bi)));
  Eeffs_Vdi_bi_Vdi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdi_bi+((eta_mu*qis_Vdi_bi)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vdi_bi+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vdi_bi)));
  Eeffs_Vdi_bi_Vsi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsi_bi+((eta_mu*qis_Vsi_bi)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Vsi_bi+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Vsi_bi)));
  Eeffs_Vdi_bi_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Tempt_GND+((eta_mu*qis_Tempt_GND)))+0.0*(qbs_Vdi_bi+(eta_mu*qis_Vdi_bi))+EeffFactor*(+qbs_Vdi_bi_Tempt_GND+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vdi_bi+eta_mu*qis_Vdi_bi_Tempt_GND)));
#endif
Eeffs_Vsi_bi=(EeffFactor*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi)));
#if defined(_DERIVATE2)
  Eeffs_Vsi_bi_Vdbulk_di=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdbulk_di+((eta_mu*qis_Vdbulk_di)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vdbulk_di+(+0.0*qis+0.0*qis_Vdbulk_di+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vdbulk_di)));
  Eeffs_Vsi_bi_Vsbulk_si=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsbulk_si+((eta_mu*qis_Vsbulk_si)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vsbulk_si+(+0.0*qis+0.0*qis_Vsbulk_si+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vsbulk_si)));
  Eeffs_Vsi_bi_Vgi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vgi_bi+((eta_mu*qis_Vgi_bi)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vgi_bi+(+0.0*qis+0.0*qis_Vgi_bi+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vgi_bi)));
  Eeffs_Vsi_bi_Vdi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vdi_bi+((eta_mu*qis_Vdi_bi)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vdi_bi+(+0.0*qis+0.0*qis_Vdi_bi+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vdi_bi)));
  Eeffs_Vsi_bi_Vsi_bi=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Vsi_bi+((eta_mu*qis_Vsi_bi)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Vsi_bi+(+0.0*qis+0.0*qis_Vsi_bi+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Vsi_bi)));
  Eeffs_Vsi_bi_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(qbs_Tempt_GND+((eta_mu*qis_Tempt_GND)))+0.0*(qbs_Vsi_bi+(eta_mu*qis_Vsi_bi))+EeffFactor*(+qbs_Vsi_bi_Tempt_GND+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vsi_bi+eta_mu*qis_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
Eeffs_Tempt_GND=(EeffFactor*(qbs_Tempt_GND+(eta_mu*qis_Tempt_GND)));
#endif
#endif
Eeffs=(EeffFactor*(qbs+(eta_mu*qis)));
EXIT_IF_ISNAN((EeffFactor*(qbs+(eta_mu*qis))))
{
double m00_pow(d00_pow0,Eeffs,EU_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,Eeffs,EU_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Vdbulk_di));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffs_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vgm_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffs_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vdbulk_di)+(0.0)*(d10_pow0*Eeffs_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vsbulk_si)+(0.0)*(d10_pow0*Eeffs_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vgi_bi=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vgi_bi)+(0.0)*(d10_pow0*Eeffs_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vdi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+UC_a_Vdi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffs_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vsi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+UC_a_Vsi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffs_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Tempt_GND=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffs_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
T3_Vsbulk_si=((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Vsbulk_si));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffs_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vgm_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffs_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vdbulk_di)+(0.0)*(d10_pow0*Eeffs_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vsbulk_si)+(0.0)*(d10_pow0*Eeffs_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vgi_bi=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vgi_bi)+(0.0)*(d10_pow0*Eeffs_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vdi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+UC_a_Vdi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffs_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vsi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+UC_a_Vsi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffs_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Tempt_GND=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffs_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
T3_Vgi_bi=((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vgm_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vdbulk_di)+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vsbulk_si)+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vgi_bi=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vgi_bi)+(0.0)*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vdi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+UC_a_Vdi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vsi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+UC_a_Vsi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Tempt_GND=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffs_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffs_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
T3_Vdi_bi=(((UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Vdi_bi)));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*0.0+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vgm_di=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*0.0+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vdbulk_di)+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vsbulk_si)+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vgi_bi=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vgi_bi)+(0.0)*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vdi_bi=(+(+UA_a_Vdi_bi_Vdi_bi+(+UC_a_Vdi_bi_Vdi_bi*Vbsx+UC_a_Vdi_bi*Vbsx_Vdi_bi+UC_a_Vdi_bi*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Vdi_bi))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vsi_bi=(+(+UA_a_Vdi_bi_Vsi_bi+(+UC_a_Vdi_bi_Vsi_bi*Vbsx+UC_a_Vdi_bi*Vbsx_Vsi_bi+UC_a_Vsi_bi*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Vsi_bi))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Tempt_GND=(+(+UA_a_Vdi_bi_Tempt_GND+(+UC_a_Vdi_bi_Tempt_GND*Vbsx+UC_a_Vdi_bi*Vbsx_Tempt_GND+UC_a_Tempt_GND*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Tempt_GND))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffs_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
T3_Vsi_bi=(((UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Vsi_bi)));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*0.0+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vgm_di=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*0.0+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vdbulk_di)+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vsbulk_si)+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vgi_bi=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vgi_bi)+(0.0)*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vdi_bi=(+(+UA_a_Vsi_bi_Vdi_bi+(+UC_a_Vsi_bi_Vdi_bi*Vbsx+UC_a_Vsi_bi*Vbsx_Vdi_bi+UC_a_Vdi_bi*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Vdi_bi))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vsi_bi=(+(+UA_a_Vsi_bi_Vsi_bi+(+UC_a_Vsi_bi_Vsi_bi*Vbsx+UC_a_Vsi_bi*Vbsx_Vsi_bi+UC_a_Vsi_bi*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Vsi_bi))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Tempt_GND=(+(+UA_a_Vsi_bi_Tempt_GND+(+UC_a_Vsi_bi_Tempt_GND*Vbsx+UC_a_Vsi_bi*Vbsx_Tempt_GND+UC_a_Tempt_GND*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Tempt_GND))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffs_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffs_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(((UA_a_Tempt_GND+((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffs_Tempt_GND)));
#endif
#endif
T3=((UA_a+(UC_a*Vbsx))*d00_pow0);
EXIT_IF_ISNAN(((UA_a+(UC_a*Vbsx))*d00_pow0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=T3_Vdbulk_di;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+0.0+T3_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+0.0+T3_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+0.0+T3_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+0.0+T3_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+0.0+T3_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+0.0+T3_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+0.0+T3_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+0.0+T3_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=T3_Vsbulk_si;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+0.0+T3_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+0.0+T3_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+0.0+T3_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+0.0+T3_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+0.0+T3_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+0.0+T3_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+0.0+T3_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+0.0+T3_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=T3_Vgi_bi;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+0.0+T3_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+0.0+T3_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+0.0+T3_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+0.0+T3_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+0.0+T3_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+0.0+T3_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+0.0+T3_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+0.0+T3_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=T3_Vdi_bi;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+0.0+T3_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+0.0+T3_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+0.0+T3_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+0.0+T3_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+0.0+T3_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+0.0+T3_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+0.0+T3_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+0.0+T3_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=T3_Vsi_bi;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+0.0+T3_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+0.0+T3_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+0.0+T3_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+0.0+T3_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+0.0+T3_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+0.0+T3_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+0.0+T3_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+0.0+T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=T3_Tempt_GND;
#endif
#endif
T4=(1.0+T3);
EXIT_IF_ISNAN((1.0+T3))
{
double m00_sqrt(d00_sqrt0,(((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Dmobs_Vdbulk_di=(0.5*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmobs_Vdbulk_di_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vdbulk_di-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdbulk_di_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vsbulk_si-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdbulk_di_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vgi_bi-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vgi_bi+T4_Vgi_bi*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdbulk_di_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vdi_bi-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vdi_bi+T4_Vdi_bi*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdbulk_di_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vsi_bi-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vsi_bi+T4_Vsi_bi*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdbulk_di_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Tempt_GND-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Tempt_GND+T4_Tempt_GND*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmobs_Vsbulk_si=(0.5*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmobs_Vsbulk_si_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vdbulk_di-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsbulk_si_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vsbulk_si-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsbulk_si_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vgi_bi-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vgi_bi+T4_Vgi_bi*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsbulk_si_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vdi_bi-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vdi_bi+T4_Vdi_bi*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsbulk_si_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vsi_bi-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vsi_bi+T4_Vsi_bi*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsbulk_si_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Tempt_GND-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Tempt_GND+T4_Tempt_GND*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmobs_Vgi_bi=(0.5*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmobs_Vgi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vgi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmobs_Vdi_bi=(0.5*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmobs_Vdi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vdi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmobs_Vsi_bi=(0.5*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmobs_Vsi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmobs_Vsi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
#if defined(_DERIVATE)
Dmobs_Tempt_GND=(0.5*(T4_Tempt_GND+((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND))*d10_sqrt0));
#endif
#endif
Dmobs=(0.5*((T4+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T4+1.0)+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi)V(dbulk,di)V(sbulk,si)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
#if defined(_DERIVATE)
LambdaC_by2_Tempt_GND=((((((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*Vt)+((U0_a/Dmobs)*Vt_Tempt_GND))*(VSATCV_t*Lact)-((U0_a/Dmobs)*Vt)*VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
LambdaC_by2_Vdi_bi=(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_by2_Vdi_bi_Tempt_GND=((+(U0_a_Vdi_bi_Tempt_GND/Dmobs-(U0_a_Vdi_bi*Dmobs_Tempt_GND+U0_a_Tempt_GND*Dmobs_Vdi_bi+U0_a*Dmobs_Vdi_bi_Tempt_GND)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdi_bi*Dmobs_Tempt_GND/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt_Tempt_GND+((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*Vt)+((U0_a/Dmobs)*Vt_Tempt_GND)))*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdi_bi_Vdi_bi=((+(U0_a_Vdi_bi_Vdi_bi/Dmobs-(U0_a_Vdi_bi*Dmobs_Vdi_bi+U0_a_Vdi_bi*Dmobs_Vdi_bi+U0_a*Dmobs_Vdi_bi_Vdi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdi_bi*Dmobs_Vdi_bi/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdi_bi_Vsi_bi=((+(U0_a_Vdi_bi_Vsi_bi/Dmobs-(U0_a_Vdi_bi*Dmobs_Vsi_bi+U0_a_Vsi_bi*Dmobs_Vdi_bi+U0_a*Dmobs_Vdi_bi_Vsi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdi_bi*Dmobs_Vsi_bi/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdi_bi_Vdbulk_di=((+(0.0/Dmobs-(U0_a_Vdi_bi*Dmobs_Vdbulk_di+0.0*Dmobs_Vdi_bi+U0_a*Dmobs_Vdi_bi_Vdbulk_di)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdi_bi*Dmobs_Vdbulk_di/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdi_bi_Vsbulk_si=((+(0.0/Dmobs-(U0_a_Vdi_bi*Dmobs_Vsbulk_si+0.0*Dmobs_Vdi_bi+U0_a*Dmobs_Vdi_bi_Vsbulk_si)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdi_bi*Dmobs_Vsbulk_si/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdi_bi_Vgi_bi=((+(0.0/Dmobs-(U0_a_Vdi_bi*Dmobs_Vgi_bi+0.0*Dmobs_Vdi_bi+U0_a*Dmobs_Vdi_bi_Vgi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdi_bi*Dmobs_Vgi_bi/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
LambdaC_by2_Vsi_bi=(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_by2_Vsi_bi_Tempt_GND=((+(U0_a_Vsi_bi_Tempt_GND/Dmobs-(U0_a_Vsi_bi*Dmobs_Tempt_GND+U0_a_Tempt_GND*Dmobs_Vsi_bi+U0_a*Dmobs_Vsi_bi_Tempt_GND)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsi_bi*Dmobs_Tempt_GND/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt_Tempt_GND+((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*Vt)+((U0_a/Dmobs)*Vt_Tempt_GND)))*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsi_bi_Vdi_bi=((+(U0_a_Vsi_bi_Vdi_bi/Dmobs-(U0_a_Vsi_bi*Dmobs_Vdi_bi+U0_a_Vdi_bi*Dmobs_Vsi_bi+U0_a*Dmobs_Vsi_bi_Vdi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsi_bi*Dmobs_Vdi_bi/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsi_bi_Vsi_bi=((+(U0_a_Vsi_bi_Vsi_bi/Dmobs-(U0_a_Vsi_bi*Dmobs_Vsi_bi+U0_a_Vsi_bi*Dmobs_Vsi_bi+U0_a*Dmobs_Vsi_bi_Vsi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsi_bi*Dmobs_Vsi_bi/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsi_bi_Vdbulk_di=((+(0.0/Dmobs-(U0_a_Vsi_bi*Dmobs_Vdbulk_di+0.0*Dmobs_Vsi_bi+U0_a*Dmobs_Vsi_bi_Vdbulk_di)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsi_bi*Dmobs_Vdbulk_di/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsi_bi_Vsbulk_si=((+(0.0/Dmobs-(U0_a_Vsi_bi*Dmobs_Vsbulk_si+0.0*Dmobs_Vsi_bi+U0_a*Dmobs_Vsi_bi_Vsbulk_si)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsi_bi*Dmobs_Vsbulk_si/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsi_bi_Vgi_bi=((+(0.0/Dmobs-(U0_a_Vsi_bi*Dmobs_Vgi_bi+0.0*Dmobs_Vsi_bi+U0_a*Dmobs_Vsi_bi_Vgi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsi_bi*Dmobs_Vgi_bi/Dmobs/Dmobs/Dmobs)*Vt+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
LambdaC_by2_Vdbulk_di=((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_by2_Vdbulk_di_Tempt_GND=((+(0.0/Dmobs-(0.0*Dmobs_Tempt_GND+U0_a_Tempt_GND*Dmobs_Vdbulk_di+U0_a*Dmobs_Vdbulk_di_Tempt_GND)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdbulk_di*Dmobs_Tempt_GND/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt_Tempt_GND+((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*Vt)+((U0_a/Dmobs)*Vt_Tempt_GND)))*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdbulk_di_Vdi_bi=((+(0.0/Dmobs-(0.0*Dmobs_Vdi_bi+U0_a_Vdi_bi*Dmobs_Vdbulk_di+U0_a*Dmobs_Vdbulk_di_Vdi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdbulk_di*Dmobs_Vdi_bi/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdbulk_di_Vsi_bi=((+(0.0/Dmobs-(0.0*Dmobs_Vsi_bi+U0_a_Vsi_bi*Dmobs_Vdbulk_di+U0_a*Dmobs_Vdbulk_di_Vsi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdbulk_di*Dmobs_Vsi_bi/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdbulk_di_Vdbulk_di=((+(0.0/Dmobs-(0.0*Dmobs_Vdbulk_di+0.0*Dmobs_Vdbulk_di+U0_a*Dmobs_Vdbulk_di_Vdbulk_di)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdbulk_di*Dmobs_Vdbulk_di/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdbulk_di_Vsbulk_si=((+(0.0/Dmobs-(0.0*Dmobs_Vsbulk_si+0.0*Dmobs_Vdbulk_di+U0_a*Dmobs_Vdbulk_di_Vsbulk_si)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdbulk_di*Dmobs_Vsbulk_si/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vdbulk_di_Vgi_bi=((+(0.0/Dmobs-(0.0*Dmobs_Vgi_bi+0.0*Dmobs_Vdbulk_di+U0_a*Dmobs_Vdbulk_di_Vgi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vdbulk_di*Dmobs_Vgi_bi/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
LambdaC_by2_Vsbulk_si=((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_by2_Vsbulk_si_Tempt_GND=((+(0.0/Dmobs-(0.0*Dmobs_Tempt_GND+U0_a_Tempt_GND*Dmobs_Vsbulk_si+U0_a*Dmobs_Vsbulk_si_Tempt_GND)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsbulk_si*Dmobs_Tempt_GND/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt_Tempt_GND+((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*Vt)+((U0_a/Dmobs)*Vt_Tempt_GND)))*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsbulk_si_Vdi_bi=((+(0.0/Dmobs-(0.0*Dmobs_Vdi_bi+U0_a_Vdi_bi*Dmobs_Vsbulk_si+U0_a*Dmobs_Vsbulk_si_Vdi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsbulk_si*Dmobs_Vdi_bi/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsbulk_si_Vsi_bi=((+(0.0/Dmobs-(0.0*Dmobs_Vsi_bi+U0_a_Vsi_bi*Dmobs_Vsbulk_si+U0_a*Dmobs_Vsbulk_si_Vsi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsbulk_si*Dmobs_Vsi_bi/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsbulk_si_Vdbulk_di=((+(0.0/Dmobs-(0.0*Dmobs_Vdbulk_di+0.0*Dmobs_Vsbulk_si+U0_a*Dmobs_Vsbulk_si_Vdbulk_di)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsbulk_si*Dmobs_Vdbulk_di/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsbulk_si_Vsbulk_si=((+(0.0/Dmobs-(0.0*Dmobs_Vsbulk_si+0.0*Dmobs_Vsbulk_si+U0_a*Dmobs_Vsbulk_si_Vsbulk_si)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsbulk_si*Dmobs_Vsbulk_si/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vsbulk_si_Vgi_bi=((+(0.0/Dmobs-(0.0*Dmobs_Vgi_bi+0.0*Dmobs_Vsbulk_si+U0_a*Dmobs_Vsbulk_si_Vgi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vsbulk_si*Dmobs_Vgi_bi/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
LambdaC_by2_Vgi_bi=((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_by2_Vgi_bi_Tempt_GND=((+(0.0/Dmobs-(0.0*Dmobs_Tempt_GND+U0_a_Tempt_GND*Dmobs_Vgi_bi+U0_a*Dmobs_Vgi_bi_Tempt_GND)/Dmobs/Dmobs+2*U0_a*Dmobs_Vgi_bi*Dmobs_Tempt_GND/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt_Tempt_GND+((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((U0_a_Tempt_GND*Dmobs-U0_a*Dmobs_Tempt_GND)/Dmobs/Dmobs)*Vt)+((U0_a/Dmobs)*Vt_Tempt_GND)))*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vgi_bi_Vdi_bi=((+(0.0/Dmobs-(0.0*Dmobs_Vdi_bi+U0_a_Vdi_bi*Dmobs_Vgi_bi+U0_a*Dmobs_Vgi_bi_Vdi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vgi_bi*Dmobs_Vdi_bi/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vdi_bi*Dmobs-U0_a*Dmobs_Vdi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vgi_bi_Vsi_bi=((+(0.0/Dmobs-(0.0*Dmobs_Vsi_bi+U0_a_Vsi_bi*Dmobs_Vgi_bi+U0_a*Dmobs_Vgi_bi_Vsi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vgi_bi*Dmobs_Vsi_bi/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt*(0.0)+(((U0_a_Vsi_bi*Dmobs-U0_a*Dmobs_Vsi_bi)/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vgi_bi_Vdbulk_di=((+(0.0/Dmobs-(0.0*Dmobs_Vdbulk_di+0.0*Dmobs_Vgi_bi+U0_a*Dmobs_Vgi_bi_Vdbulk_di)/Dmobs/Dmobs+2*U0_a*Dmobs_Vgi_bi*Dmobs_Vdbulk_di/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vdbulk_di/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vgi_bi_Vsbulk_si=((+(0.0/Dmobs-(0.0*Dmobs_Vsbulk_si+0.0*Dmobs_Vgi_bi+U0_a*Dmobs_Vgi_bi_Vsbulk_si)/Dmobs/Dmobs+2*U0_a*Dmobs_Vgi_bi*Dmobs_Vsbulk_si/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vsbulk_si/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_by2_Vgi_bi_Vgi_bi=((+(0.0/Dmobs-(0.0*Dmobs_Vgi_bi+0.0*Dmobs_Vgi_bi+U0_a*Dmobs_Vgi_bi_Vgi_bi)/Dmobs/Dmobs+2*U0_a*Dmobs_Vgi_bi*Dmobs_Vgi_bi/Dmobs/Dmobs/Dmobs)*Vt+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+(-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*0.0+(U0_a/Dmobs)*0.0)/(VSATCV_t*Lact)-((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt*(0.0)+((-U0_a*Dmobs_Vgi_bi/Dmobs/Dmobs)*Vt)*0.0+((U0_a/Dmobs)*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((U0_a/Dmobs)*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
#endif
LambdaC_by2=(((U0_a/Dmobs)*Vt)/(VSATCV_t*Lact));
EXIT_IF_ISNAN((((U0_a/Dmobs)*Vt)/(VSATCV_t*Lact)))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
qdsat_Vdbulk_di=((((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)))*(1.0+(LambdaC_by2*(1.0+qs)))-(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#if defined(_DERIVATE2)
  qdsat_Vdbulk_di_Vdbulk_di=((+LambdaC_by2_Vdbulk_di_Vdbulk_di*((qs*qs)+qs)+LambdaC_by2_Vdbulk_di*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+LambdaC_by2_Vdbulk_di*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)+LambdaC_by2*(+(+qs_Vdbulk_di_Vdbulk_di*qs+qs_Vdbulk_di*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vdbulk_di+qs*qs_Vdbulk_di_Vdbulk_di)+qs_Vdbulk_di_Vdbulk_di))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))+(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdbulk_di_Vdbulk_di*(1.0+qs)+LambdaC_by2_Vdbulk_di*qs_Vdbulk_di+LambdaC_by2_Vdbulk_di*qs_Vdbulk_di+LambdaC_by2*(+0.0+qs_Vdbulk_di_Vdbulk_di))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdbulk_di_Vsbulk_si=((+LambdaC_by2_Vdbulk_di_Vsbulk_si*((qs*qs)+qs)+LambdaC_by2_Vdbulk_di*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+LambdaC_by2_Vsbulk_si*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)+LambdaC_by2*(+(+qs_Vdbulk_di_Vsbulk_si*qs+qs_Vdbulk_di*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vdbulk_di+qs*qs_Vdbulk_di_Vsbulk_si)+qs_Vdbulk_di_Vsbulk_si))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))+(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdbulk_di_Vsbulk_si*(1.0+qs)+LambdaC_by2_Vdbulk_di*qs_Vsbulk_si+LambdaC_by2_Vsbulk_si*qs_Vdbulk_di+LambdaC_by2*(+0.0+qs_Vdbulk_di_Vsbulk_si))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdbulk_di_Vgi_bi=((+LambdaC_by2_Vdbulk_di_Vgi_bi*((qs*qs)+qs)+LambdaC_by2_Vdbulk_di*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+LambdaC_by2_Vgi_bi*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)+LambdaC_by2*(+(+qs_Vdbulk_di_Vgi_bi*qs+qs_Vdbulk_di*qs_Vgi_bi+qs_Vgi_bi*qs_Vdbulk_di+qs*qs_Vdbulk_di_Vgi_bi)+qs_Vdbulk_di_Vgi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))+(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdbulk_di_Vgi_bi*(1.0+qs)+LambdaC_by2_Vdbulk_di*qs_Vgi_bi+LambdaC_by2_Vgi_bi*qs_Vdbulk_di+LambdaC_by2*(+0.0+qs_Vdbulk_di_Vgi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdbulk_di_Vdi_bi=((+LambdaC_by2_Vdbulk_di_Vdi_bi*((qs*qs)+qs)+LambdaC_by2_Vdbulk_di*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+LambdaC_by2_Vdi_bi*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)+LambdaC_by2*(+(+qs_Vdbulk_di_Vdi_bi*qs+qs_Vdbulk_di*qs_Vdi_bi+qs_Vdi_bi*qs_Vdbulk_di+qs*qs_Vdbulk_di_Vdi_bi)+qs_Vdbulk_di_Vdi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))+(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdbulk_di_Vdi_bi*(1.0+qs)+LambdaC_by2_Vdbulk_di*qs_Vdi_bi+LambdaC_by2_Vdi_bi*qs_Vdbulk_di+LambdaC_by2*(+0.0+qs_Vdbulk_di_Vdi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdbulk_di_Vsi_bi=((+LambdaC_by2_Vdbulk_di_Vsi_bi*((qs*qs)+qs)+LambdaC_by2_Vdbulk_di*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+LambdaC_by2_Vsi_bi*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)+LambdaC_by2*(+(+qs_Vdbulk_di_Vsi_bi*qs+qs_Vdbulk_di*qs_Vsi_bi+qs_Vsi_bi*qs_Vdbulk_di+qs*qs_Vdbulk_di_Vsi_bi)+qs_Vdbulk_di_Vsi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))+(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdbulk_di_Vsi_bi*(1.0+qs)+LambdaC_by2_Vdbulk_di*qs_Vsi_bi+LambdaC_by2_Vsi_bi*qs_Vdbulk_di+LambdaC_by2*(+0.0+qs_Vdbulk_di_Vsi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdbulk_di_Tempt_GND=((+LambdaC_by2_Vdbulk_di_Tempt_GND*((qs*qs)+qs)+LambdaC_by2_Vdbulk_di*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+LambdaC_by2_Tempt_GND*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)+LambdaC_by2*(+(+qs_Vdbulk_di_Tempt_GND*qs+qs_Vdbulk_di*qs_Tempt_GND+qs_Tempt_GND*qs_Vdbulk_di+qs*qs_Vdbulk_di_Tempt_GND)+qs_Vdbulk_di_Tempt_GND))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di))+qs_Vdbulk_di)))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))+(((LambdaC_by2_Tempt_GND*((qs*qs)+qs))+(LambdaC_by2*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdbulk_di_Tempt_GND*(1.0+qs)+LambdaC_by2_Vdbulk_di*qs_Tempt_GND+LambdaC_by2_Tempt_GND*qs_Vdbulk_di+LambdaC_by2*(+0.0+qs_Vdbulk_di_Tempt_GND))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#endif
qdsat_Vsbulk_si=((((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)))*(1.0+(LambdaC_by2*(1.0+qs)))-(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#if defined(_DERIVATE2)
  qdsat_Vsbulk_si_Vdbulk_di=((+LambdaC_by2_Vsbulk_si_Vdbulk_di*((qs*qs)+qs)+LambdaC_by2_Vsbulk_si*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+LambdaC_by2_Vdbulk_di*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)+LambdaC_by2*(+(+qs_Vsbulk_si_Vdbulk_di*qs+qs_Vsbulk_si*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vsbulk_si+qs*qs_Vsbulk_si_Vdbulk_di)+qs_Vsbulk_si_Vdbulk_di))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))+(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsbulk_si_Vdbulk_di*(1.0+qs)+LambdaC_by2_Vsbulk_si*qs_Vdbulk_di+LambdaC_by2_Vdbulk_di*qs_Vsbulk_si+LambdaC_by2*(+0.0+qs_Vsbulk_si_Vdbulk_di))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsbulk_si_Vsbulk_si=((+LambdaC_by2_Vsbulk_si_Vsbulk_si*((qs*qs)+qs)+LambdaC_by2_Vsbulk_si*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+LambdaC_by2_Vsbulk_si*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)+LambdaC_by2*(+(+qs_Vsbulk_si_Vsbulk_si*qs+qs_Vsbulk_si*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vsbulk_si+qs*qs_Vsbulk_si_Vsbulk_si)+qs_Vsbulk_si_Vsbulk_si))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))+(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsbulk_si_Vsbulk_si*(1.0+qs)+LambdaC_by2_Vsbulk_si*qs_Vsbulk_si+LambdaC_by2_Vsbulk_si*qs_Vsbulk_si+LambdaC_by2*(+0.0+qs_Vsbulk_si_Vsbulk_si))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsbulk_si_Vgi_bi=((+LambdaC_by2_Vsbulk_si_Vgi_bi*((qs*qs)+qs)+LambdaC_by2_Vsbulk_si*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+LambdaC_by2_Vgi_bi*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)+LambdaC_by2*(+(+qs_Vsbulk_si_Vgi_bi*qs+qs_Vsbulk_si*qs_Vgi_bi+qs_Vgi_bi*qs_Vsbulk_si+qs*qs_Vsbulk_si_Vgi_bi)+qs_Vsbulk_si_Vgi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))+(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsbulk_si_Vgi_bi*(1.0+qs)+LambdaC_by2_Vsbulk_si*qs_Vgi_bi+LambdaC_by2_Vgi_bi*qs_Vsbulk_si+LambdaC_by2*(+0.0+qs_Vsbulk_si_Vgi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsbulk_si_Vdi_bi=((+LambdaC_by2_Vsbulk_si_Vdi_bi*((qs*qs)+qs)+LambdaC_by2_Vsbulk_si*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+LambdaC_by2_Vdi_bi*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)+LambdaC_by2*(+(+qs_Vsbulk_si_Vdi_bi*qs+qs_Vsbulk_si*qs_Vdi_bi+qs_Vdi_bi*qs_Vsbulk_si+qs*qs_Vsbulk_si_Vdi_bi)+qs_Vsbulk_si_Vdi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))+(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsbulk_si_Vdi_bi*(1.0+qs)+LambdaC_by2_Vsbulk_si*qs_Vdi_bi+LambdaC_by2_Vdi_bi*qs_Vsbulk_si+LambdaC_by2*(+0.0+qs_Vsbulk_si_Vdi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsbulk_si_Vsi_bi=((+LambdaC_by2_Vsbulk_si_Vsi_bi*((qs*qs)+qs)+LambdaC_by2_Vsbulk_si*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+LambdaC_by2_Vsi_bi*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)+LambdaC_by2*(+(+qs_Vsbulk_si_Vsi_bi*qs+qs_Vsbulk_si*qs_Vsi_bi+qs_Vsi_bi*qs_Vsbulk_si+qs*qs_Vsbulk_si_Vsi_bi)+qs_Vsbulk_si_Vsi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))+(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsbulk_si_Vsi_bi*(1.0+qs)+LambdaC_by2_Vsbulk_si*qs_Vsi_bi+LambdaC_by2_Vsi_bi*qs_Vsbulk_si+LambdaC_by2*(+0.0+qs_Vsbulk_si_Vsi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsbulk_si_Tempt_GND=((+LambdaC_by2_Vsbulk_si_Tempt_GND*((qs*qs)+qs)+LambdaC_by2_Vsbulk_si*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+LambdaC_by2_Tempt_GND*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)+LambdaC_by2*(+(+qs_Vsbulk_si_Tempt_GND*qs+qs_Vsbulk_si*qs_Tempt_GND+qs_Tempt_GND*qs_Vsbulk_si+qs*qs_Vsbulk_si_Tempt_GND)+qs_Vsbulk_si_Tempt_GND))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si))+qs_Vsbulk_si)))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))+(((LambdaC_by2_Tempt_GND*((qs*qs)+qs))+(LambdaC_by2*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsbulk_si_Tempt_GND*(1.0+qs)+LambdaC_by2_Vsbulk_si*qs_Tempt_GND+LambdaC_by2_Tempt_GND*qs_Vsbulk_si+LambdaC_by2*(+0.0+qs_Vsbulk_si_Tempt_GND))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#endif
qdsat_Vgi_bi=((((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(1.0+(LambdaC_by2*(1.0+qs)))-(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#if defined(_DERIVATE2)
  qdsat_Vgi_bi_Vdbulk_di=((+LambdaC_by2_Vgi_bi_Vdbulk_di*((qs*qs)+qs)+LambdaC_by2_Vgi_bi*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+LambdaC_by2_Vdbulk_di*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+LambdaC_by2*(+(+qs_Vgi_bi_Vdbulk_di*qs+qs_Vgi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vgi_bi+qs*qs_Vgi_bi_Vdbulk_di)+qs_Vgi_bi_Vdbulk_di))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))+(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vgi_bi_Vdbulk_di*(1.0+qs)+LambdaC_by2_Vgi_bi*qs_Vdbulk_di+LambdaC_by2_Vdbulk_di*qs_Vgi_bi+LambdaC_by2*(+0.0+qs_Vgi_bi_Vdbulk_di))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vgi_bi_Vsbulk_si=((+LambdaC_by2_Vgi_bi_Vsbulk_si*((qs*qs)+qs)+LambdaC_by2_Vgi_bi*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+LambdaC_by2_Vsbulk_si*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+LambdaC_by2*(+(+qs_Vgi_bi_Vsbulk_si*qs+qs_Vgi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vgi_bi+qs*qs_Vgi_bi_Vsbulk_si)+qs_Vgi_bi_Vsbulk_si))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))+(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vgi_bi_Vsbulk_si*(1.0+qs)+LambdaC_by2_Vgi_bi*qs_Vsbulk_si+LambdaC_by2_Vsbulk_si*qs_Vgi_bi+LambdaC_by2*(+0.0+qs_Vgi_bi_Vsbulk_si))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vgi_bi_Vgi_bi=((+LambdaC_by2_Vgi_bi_Vgi_bi*((qs*qs)+qs)+LambdaC_by2_Vgi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+LambdaC_by2_Vgi_bi*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+LambdaC_by2*(+(+qs_Vgi_bi_Vgi_bi*qs+qs_Vgi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vgi_bi)+qs_Vgi_bi_Vgi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))+(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vgi_bi_Vgi_bi*(1.0+qs)+LambdaC_by2_Vgi_bi*qs_Vgi_bi+LambdaC_by2_Vgi_bi*qs_Vgi_bi+LambdaC_by2*(+0.0+qs_Vgi_bi_Vgi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vgi_bi_Vdi_bi=((+LambdaC_by2_Vgi_bi_Vdi_bi*((qs*qs)+qs)+LambdaC_by2_Vgi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+LambdaC_by2_Vdi_bi*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+LambdaC_by2*(+(+qs_Vgi_bi_Vdi_bi*qs+qs_Vgi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vdi_bi)+qs_Vgi_bi_Vdi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))+(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vgi_bi_Vdi_bi*(1.0+qs)+LambdaC_by2_Vgi_bi*qs_Vdi_bi+LambdaC_by2_Vdi_bi*qs_Vgi_bi+LambdaC_by2*(+0.0+qs_Vgi_bi_Vdi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vgi_bi_Vsi_bi=((+LambdaC_by2_Vgi_bi_Vsi_bi*((qs*qs)+qs)+LambdaC_by2_Vgi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+LambdaC_by2_Vsi_bi*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+LambdaC_by2*(+(+qs_Vgi_bi_Vsi_bi*qs+qs_Vgi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vgi_bi+qs*qs_Vgi_bi_Vsi_bi)+qs_Vgi_bi_Vsi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))+(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vgi_bi_Vsi_bi*(1.0+qs)+LambdaC_by2_Vgi_bi*qs_Vsi_bi+LambdaC_by2_Vsi_bi*qs_Vgi_bi+LambdaC_by2*(+0.0+qs_Vgi_bi_Vsi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vgi_bi_Tempt_GND=((+LambdaC_by2_Vgi_bi_Tempt_GND*((qs*qs)+qs)+LambdaC_by2_Vgi_bi*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+LambdaC_by2_Tempt_GND*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)+LambdaC_by2*(+(+qs_Vgi_bi_Tempt_GND*qs+qs_Vgi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vgi_bi+qs*qs_Vgi_bi_Tempt_GND)+qs_Vgi_bi_Tempt_GND))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi))+qs_Vgi_bi)))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))+(((LambdaC_by2_Tempt_GND*((qs*qs)+qs))+(LambdaC_by2*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vgi_bi_Tempt_GND*(1.0+qs)+LambdaC_by2_Vgi_bi*qs_Tempt_GND+LambdaC_by2_Tempt_GND*qs_Vgi_bi+LambdaC_by2*(+0.0+qs_Vgi_bi_Tempt_GND))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#endif
qdsat_Vdi_bi=((((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(1.0+(LambdaC_by2*(1.0+qs)))-(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#if defined(_DERIVATE2)
  qdsat_Vdi_bi_Vdbulk_di=((+LambdaC_by2_Vdi_bi_Vdbulk_di*((qs*qs)+qs)+LambdaC_by2_Vdi_bi*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+LambdaC_by2_Vdbulk_di*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+LambdaC_by2*(+(+qs_Vdi_bi_Vdbulk_di*qs+qs_Vdi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vdi_bi+qs*qs_Vdi_bi_Vdbulk_di)+qs_Vdi_bi_Vdbulk_di))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))+(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdi_bi_Vdbulk_di*(1.0+qs)+LambdaC_by2_Vdi_bi*qs_Vdbulk_di+LambdaC_by2_Vdbulk_di*qs_Vdi_bi+LambdaC_by2*(+0.0+qs_Vdi_bi_Vdbulk_di))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdi_bi_Vsbulk_si=((+LambdaC_by2_Vdi_bi_Vsbulk_si*((qs*qs)+qs)+LambdaC_by2_Vdi_bi*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+LambdaC_by2_Vsbulk_si*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+LambdaC_by2*(+(+qs_Vdi_bi_Vsbulk_si*qs+qs_Vdi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vdi_bi+qs*qs_Vdi_bi_Vsbulk_si)+qs_Vdi_bi_Vsbulk_si))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))+(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdi_bi_Vsbulk_si*(1.0+qs)+LambdaC_by2_Vdi_bi*qs_Vsbulk_si+LambdaC_by2_Vsbulk_si*qs_Vdi_bi+LambdaC_by2*(+0.0+qs_Vdi_bi_Vsbulk_si))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdi_bi_Vgi_bi=((+LambdaC_by2_Vdi_bi_Vgi_bi*((qs*qs)+qs)+LambdaC_by2_Vdi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+LambdaC_by2_Vgi_bi*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+LambdaC_by2*(+(+qs_Vdi_bi_Vgi_bi*qs+qs_Vdi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vgi_bi)+qs_Vdi_bi_Vgi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))+(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdi_bi_Vgi_bi*(1.0+qs)+LambdaC_by2_Vdi_bi*qs_Vgi_bi+LambdaC_by2_Vgi_bi*qs_Vdi_bi+LambdaC_by2*(+0.0+qs_Vdi_bi_Vgi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdi_bi_Vdi_bi=((+LambdaC_by2_Vdi_bi_Vdi_bi*((qs*qs)+qs)+LambdaC_by2_Vdi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+LambdaC_by2_Vdi_bi*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+LambdaC_by2*(+(+qs_Vdi_bi_Vdi_bi*qs+qs_Vdi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vdi_bi)+qs_Vdi_bi_Vdi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))+(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdi_bi_Vdi_bi*(1.0+qs)+LambdaC_by2_Vdi_bi*qs_Vdi_bi+LambdaC_by2_Vdi_bi*qs_Vdi_bi+LambdaC_by2*(+0.0+qs_Vdi_bi_Vdi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdi_bi_Vsi_bi=((+LambdaC_by2_Vdi_bi_Vsi_bi*((qs*qs)+qs)+LambdaC_by2_Vdi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+LambdaC_by2_Vsi_bi*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+LambdaC_by2*(+(+qs_Vdi_bi_Vsi_bi*qs+qs_Vdi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vdi_bi+qs*qs_Vdi_bi_Vsi_bi)+qs_Vdi_bi_Vsi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))+(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdi_bi_Vsi_bi*(1.0+qs)+LambdaC_by2_Vdi_bi*qs_Vsi_bi+LambdaC_by2_Vsi_bi*qs_Vdi_bi+LambdaC_by2*(+0.0+qs_Vdi_bi_Vsi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vdi_bi_Tempt_GND=((+LambdaC_by2_Vdi_bi_Tempt_GND*((qs*qs)+qs)+LambdaC_by2_Vdi_bi*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+LambdaC_by2_Tempt_GND*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)+LambdaC_by2*(+(+qs_Vdi_bi_Tempt_GND*qs+qs_Vdi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vdi_bi+qs*qs_Vdi_bi_Tempt_GND)+qs_Vdi_bi_Tempt_GND))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi))+qs_Vdi_bi)))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))+(((LambdaC_by2_Tempt_GND*((qs*qs)+qs))+(LambdaC_by2*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vdi_bi_Tempt_GND*(1.0+qs)+LambdaC_by2_Vdi_bi*qs_Tempt_GND+LambdaC_by2_Tempt_GND*qs_Vdi_bi+LambdaC_by2*(+0.0+qs_Vdi_bi_Tempt_GND))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#endif
qdsat_Vsi_bi=((((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(1.0+(LambdaC_by2*(1.0+qs)))-(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#if defined(_DERIVATE2)
  qdsat_Vsi_bi_Vdbulk_di=((+LambdaC_by2_Vsi_bi_Vdbulk_di*((qs*qs)+qs)+LambdaC_by2_Vsi_bi*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di)+LambdaC_by2_Vdbulk_di*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+LambdaC_by2*(+(+qs_Vsi_bi_Vdbulk_di*qs+qs_Vsi_bi*qs_Vdbulk_di+qs_Vdbulk_di*qs_Vsi_bi+qs*qs_Vsi_bi_Vdbulk_di)+qs_Vsi_bi_Vdbulk_di))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))+(((LambdaC_by2_Vdbulk_di*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdbulk_di*qs)+(qs*qs_Vdbulk_di)))+qs_Vdbulk_di))))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsi_bi_Vdbulk_di*(1.0+qs)+LambdaC_by2_Vsi_bi*qs_Vdbulk_di+LambdaC_by2_Vdbulk_di*qs_Vsi_bi+LambdaC_by2*(+0.0+qs_Vsi_bi_Vdbulk_di))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))*(((LambdaC_by2_Vdbulk_di*(1.0+qs))+(LambdaC_by2*qs_Vdbulk_di)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsi_bi_Vsbulk_si=((+LambdaC_by2_Vsi_bi_Vsbulk_si*((qs*qs)+qs)+LambdaC_by2_Vsi_bi*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si)+LambdaC_by2_Vsbulk_si*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+LambdaC_by2*(+(+qs_Vsi_bi_Vsbulk_si*qs+qs_Vsi_bi*qs_Vsbulk_si+qs_Vsbulk_si*qs_Vsi_bi+qs*qs_Vsi_bi_Vsbulk_si)+qs_Vsi_bi_Vsbulk_si))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))+(((LambdaC_by2_Vsbulk_si*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsbulk_si*qs)+(qs*qs_Vsbulk_si)))+qs_Vsbulk_si))))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsi_bi_Vsbulk_si*(1.0+qs)+LambdaC_by2_Vsi_bi*qs_Vsbulk_si+LambdaC_by2_Vsbulk_si*qs_Vsi_bi+LambdaC_by2*(+0.0+qs_Vsi_bi_Vsbulk_si))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))*(((LambdaC_by2_Vsbulk_si*(1.0+qs))+(LambdaC_by2*qs_Vsbulk_si)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsi_bi_Vgi_bi=((+LambdaC_by2_Vsi_bi_Vgi_bi*((qs*qs)+qs)+LambdaC_by2_Vsi_bi*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi)+LambdaC_by2_Vgi_bi*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+LambdaC_by2*(+(+qs_Vsi_bi_Vgi_bi*qs+qs_Vsi_bi*qs_Vgi_bi+qs_Vgi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vgi_bi)+qs_Vsi_bi_Vgi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))+(((LambdaC_by2_Vgi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vgi_bi*qs)+(qs*qs_Vgi_bi)))+qs_Vgi_bi))))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsi_bi_Vgi_bi*(1.0+qs)+LambdaC_by2_Vsi_bi*qs_Vgi_bi+LambdaC_by2_Vgi_bi*qs_Vsi_bi+LambdaC_by2*(+0.0+qs_Vsi_bi_Vgi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))*(((LambdaC_by2_Vgi_bi*(1.0+qs))+(LambdaC_by2*qs_Vgi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsi_bi_Vdi_bi=((+LambdaC_by2_Vsi_bi_Vdi_bi*((qs*qs)+qs)+LambdaC_by2_Vsi_bi*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi)+LambdaC_by2_Vdi_bi*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+LambdaC_by2*(+(+qs_Vsi_bi_Vdi_bi*qs+qs_Vsi_bi*qs_Vdi_bi+qs_Vdi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vdi_bi)+qs_Vsi_bi_Vdi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))+(((LambdaC_by2_Vdi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vdi_bi*qs)+(qs*qs_Vdi_bi)))+qs_Vdi_bi))))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsi_bi_Vdi_bi*(1.0+qs)+LambdaC_by2_Vsi_bi*qs_Vdi_bi+LambdaC_by2_Vdi_bi*qs_Vsi_bi+LambdaC_by2*(+0.0+qs_Vsi_bi_Vdi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))*(((LambdaC_by2_Vdi_bi*(1.0+qs))+(LambdaC_by2*qs_Vdi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsi_bi_Vsi_bi=((+LambdaC_by2_Vsi_bi_Vsi_bi*((qs*qs)+qs)+LambdaC_by2_Vsi_bi*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi)+LambdaC_by2_Vsi_bi*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+LambdaC_by2*(+(+qs_Vsi_bi_Vsi_bi*qs+qs_Vsi_bi*qs_Vsi_bi+qs_Vsi_bi*qs_Vsi_bi+qs*qs_Vsi_bi_Vsi_bi)+qs_Vsi_bi_Vsi_bi))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))+(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*((((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi)))+qs_Vsi_bi))))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsi_bi_Vsi_bi*(1.0+qs)+LambdaC_by2_Vsi_bi*qs_Vsi_bi+LambdaC_by2_Vsi_bi*qs_Vsi_bi+LambdaC_by2*(+0.0+qs_Vsi_bi_Vsi_bi))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))*(((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
  qdsat_Vsi_bi_Tempt_GND=((+LambdaC_by2_Vsi_bi_Tempt_GND*((qs*qs)+qs)+LambdaC_by2_Vsi_bi*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND)+LambdaC_by2_Tempt_GND*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)+LambdaC_by2*(+(+qs_Vsi_bi_Tempt_GND*qs+qs_Vsi_bi*qs_Tempt_GND+qs_Tempt_GND*qs_Vsi_bi+qs*qs_Vsi_bi_Tempt_GND)+qs_Vsi_bi_Tempt_GND))/(1.0+(LambdaC_by2*(1.0+qs)))-(((LambdaC_by2_Vsi_bi*((qs*qs)+qs))+(LambdaC_by2*(((qs_Vsi_bi*qs)+(qs*qs_Vsi_bi))+qs_Vsi_bi)))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))+(((LambdaC_by2_Tempt_GND*((qs*qs)+qs))+(LambdaC_by2*((((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND)))+qs_Tempt_GND))))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))+(LambdaC_by2*((qs*qs)+qs))*(+0.0+(+LambdaC_by2_Vsi_bi_Tempt_GND*(1.0+qs)+LambdaC_by2_Vsi_bi*qs_Tempt_GND+LambdaC_by2_Tempt_GND*qs_Vsi_bi+LambdaC_by2*(+0.0+qs_Vsi_bi_Tempt_GND))))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))+2*(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Vsi_bi*(1.0+qs))+(LambdaC_by2*qs_Vsi_bi))*(((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#endif
#if defined(_DERIVATE)
qdsat_Tempt_GND=((((LambdaC_by2_Tempt_GND*((qs*qs)+qs))+(LambdaC_by2*(((qs_Tempt_GND*qs)+(qs*qs_Tempt_GND))+qs_Tempt_GND)))*(1.0+(LambdaC_by2*(1.0+qs)))-(LambdaC_by2*((qs*qs)+qs))*((LambdaC_by2_Tempt_GND*(1.0+qs))+(LambdaC_by2*qs_Tempt_GND)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
#endif
#endif
qdsat=((LambdaC_by2*((qs*qs)+qs))/(1.0+(LambdaC_by2*(1.0+qs))));
EXIT_IF_ISNAN(((LambdaC_by2*((qs*qs)+qs))/(1.0+(LambdaC_by2*(1.0+qs)))))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
vdsatcv_Vdbulk_di=(psip_Vdbulk_di-((2.0*qdsat_Vdbulk_di)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0))))))));
#if defined(_DERIVATE2)
  vdsatcv_Vdbulk_di_Vdbulk_di=(+(+psip_Vdbulk_di_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdbulk_di+0.0*qdsat_Vdbulk_di+2.0*qdsat_Vdbulk_di_Vdbulk_di)+(+(+(+(+qdsat_Vdbulk_di_Vdbulk_di*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vdbulk_di)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vdbulk_di)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))*((((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))*(((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdbulk_di_Vdbulk_di*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vdbulk_di)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vdbulk_di)+(gam_Vdbulk_di_Vdbulk_di/(nq-1.0)-(gam_Vdbulk_di*nq_Vdbulk_di+gam_Vdbulk_di*nq_Vdbulk_di+gam*(+nq_Vdbulk_di_Vdbulk_di-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdbulk_di*nq_Vdbulk_di/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdbulk_di_Vsbulk_si=(+(+psip_Vdbulk_di_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsbulk_si+0.0*qdsat_Vdbulk_di+2.0*qdsat_Vdbulk_di_Vsbulk_si)+(+(+(+(+qdsat_Vdbulk_di_Vsbulk_si*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vsbulk_si)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vsbulk_si)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))*((((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))*(((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdbulk_di_Vsbulk_si*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vsbulk_si)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vsbulk_si)+(gam_Vdbulk_di_Vsbulk_si/(nq-1.0)-(gam_Vdbulk_di*nq_Vsbulk_si+gam_Vsbulk_si*nq_Vdbulk_di+gam*(+nq_Vdbulk_di_Vsbulk_si-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdbulk_di*nq_Vsbulk_si/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdbulk_di_Vgi_bi=(+(+psip_Vdbulk_di_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vgi_bi+0.0*qdsat_Vdbulk_di+2.0*qdsat_Vdbulk_di_Vgi_bi)+(+(+(+(+qdsat_Vdbulk_di_Vgi_bi*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vgi_bi)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vgi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))*((((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))*(((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdbulk_di_Vgi_bi*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vgi_bi)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vgi_bi)+(gam_Vdbulk_di_Vgi_bi/(nq-1.0)-(gam_Vdbulk_di*nq_Vgi_bi+gam_Vgi_bi*nq_Vdbulk_di+gam*(+nq_Vdbulk_di_Vgi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdbulk_di*nq_Vgi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdbulk_di_Vdi_bi=(+(+psip_Vdbulk_di_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdi_bi+0.0*qdsat_Vdbulk_di+2.0*qdsat_Vdbulk_di_Vdi_bi)+(+(+(+(+qdsat_Vdbulk_di_Vdi_bi*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vdi_bi)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vdi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))*((((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))*(((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdbulk_di_Vdi_bi*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vdi_bi)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vdi_bi)+(gam_Vdbulk_di_Vdi_bi/(nq-1.0)-(gam_Vdbulk_di*nq_Vdi_bi+gam_Vdi_bi*nq_Vdbulk_di+gam*(+nq_Vdbulk_di_Vdi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdbulk_di*nq_Vdi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdbulk_di_Vsi_bi=(+(+psip_Vdbulk_di_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsi_bi+0.0*qdsat_Vdbulk_di+2.0*qdsat_Vdbulk_di_Vsi_bi)+(+(+(+(+qdsat_Vdbulk_di_Vsi_bi*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vsi_bi)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vsi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))*((((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))*(((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdbulk_di_Vsi_bi*2.0+qdsat_Vdbulk_di*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Vsi_bi)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Vsi_bi)+(gam_Vdbulk_di_Vsi_bi/(nq-1.0)-(gam_Vdbulk_di*nq_Vsi_bi+gam_Vsi_bi*nq_Vdbulk_di+gam*(+nq_Vdbulk_di_Vsi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdbulk_di*nq_Vsi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdbulk_di_Tempt_GND=(+(+psip_Vdbulk_di_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Tempt_GND+0.0*qdsat_Vdbulk_di+2.0*qdsat_Vdbulk_di_Tempt_GND)+(+(+(+(+qdsat_Vdbulk_di_Tempt_GND*2.0+qdsat_Vdbulk_di*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Tempt_GND)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Tempt_GND)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))*((((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))*(((((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdbulk_di_Tempt_GND*2.0+qdsat_Vdbulk_di*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vdbulk_di*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vdbulk_di+(qdsat*2.0)*nq_Vdbulk_di_Tempt_GND)*inv_gam+((qdsat_Vdbulk_di*2.0*nq)+((qdsat*2.0)*nq_Vdbulk_di))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vdbulk_di+((qdsat*2.0)*nq)*inv_gam_Vdbulk_di_Tempt_GND)+(gam_Vdbulk_di_Tempt_GND/(nq-1.0)-(gam_Vdbulk_di*nq_Tempt_GND+gam_Tempt_GND*nq_Vdbulk_di+gam*(+nq_Vdbulk_di_Tempt_GND-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdbulk_di*nq_Tempt_GND/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
#endif
vdsatcv_Vsbulk_si=(psip_Vsbulk_si-((2.0*qdsat_Vsbulk_si)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0))))))));
#if defined(_DERIVATE2)
  vdsatcv_Vsbulk_si_Vdbulk_di=(+(+psip_Vsbulk_si_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdbulk_di+0.0*qdsat_Vsbulk_si+2.0*qdsat_Vsbulk_si_Vdbulk_di)+(+(+(+(+qdsat_Vsbulk_si_Vdbulk_di*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vdbulk_di)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vdbulk_di)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))*((((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))*(((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsbulk_si_Vdbulk_di*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vdbulk_di)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vdbulk_di)+(gam_Vsbulk_si_Vdbulk_di/(nq-1.0)-(gam_Vsbulk_si*nq_Vdbulk_di+gam_Vdbulk_di*nq_Vsbulk_si+gam*(+nq_Vsbulk_si_Vdbulk_di-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsbulk_si*nq_Vdbulk_di/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsbulk_si_Vsbulk_si=(+(+psip_Vsbulk_si_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsbulk_si+0.0*qdsat_Vsbulk_si+2.0*qdsat_Vsbulk_si_Vsbulk_si)+(+(+(+(+qdsat_Vsbulk_si_Vsbulk_si*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vsbulk_si)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vsbulk_si)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))*((((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))*(((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsbulk_si_Vsbulk_si*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vsbulk_si)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vsbulk_si)+(gam_Vsbulk_si_Vsbulk_si/(nq-1.0)-(gam_Vsbulk_si*nq_Vsbulk_si+gam_Vsbulk_si*nq_Vsbulk_si+gam*(+nq_Vsbulk_si_Vsbulk_si-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsbulk_si*nq_Vsbulk_si/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsbulk_si_Vgi_bi=(+(+psip_Vsbulk_si_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vgi_bi+0.0*qdsat_Vsbulk_si+2.0*qdsat_Vsbulk_si_Vgi_bi)+(+(+(+(+qdsat_Vsbulk_si_Vgi_bi*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vgi_bi)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vgi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))*((((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))*(((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsbulk_si_Vgi_bi*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vgi_bi)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vgi_bi)+(gam_Vsbulk_si_Vgi_bi/(nq-1.0)-(gam_Vsbulk_si*nq_Vgi_bi+gam_Vgi_bi*nq_Vsbulk_si+gam*(+nq_Vsbulk_si_Vgi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsbulk_si*nq_Vgi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsbulk_si_Vdi_bi=(+(+psip_Vsbulk_si_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdi_bi+0.0*qdsat_Vsbulk_si+2.0*qdsat_Vsbulk_si_Vdi_bi)+(+(+(+(+qdsat_Vsbulk_si_Vdi_bi*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vdi_bi)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vdi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))*((((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))*(((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsbulk_si_Vdi_bi*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vdi_bi)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vdi_bi)+(gam_Vsbulk_si_Vdi_bi/(nq-1.0)-(gam_Vsbulk_si*nq_Vdi_bi+gam_Vdi_bi*nq_Vsbulk_si+gam*(+nq_Vsbulk_si_Vdi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsbulk_si*nq_Vdi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsbulk_si_Vsi_bi=(+(+psip_Vsbulk_si_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsi_bi+0.0*qdsat_Vsbulk_si+2.0*qdsat_Vsbulk_si_Vsi_bi)+(+(+(+(+qdsat_Vsbulk_si_Vsi_bi*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vsi_bi)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vsi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))*((((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))*(((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsbulk_si_Vsi_bi*2.0+qdsat_Vsbulk_si*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Vsi_bi)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Vsi_bi)+(gam_Vsbulk_si_Vsi_bi/(nq-1.0)-(gam_Vsbulk_si*nq_Vsi_bi+gam_Vsi_bi*nq_Vsbulk_si+gam*(+nq_Vsbulk_si_Vsi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsbulk_si*nq_Vsi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsbulk_si_Tempt_GND=(+(+psip_Vsbulk_si_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Tempt_GND+0.0*qdsat_Vsbulk_si+2.0*qdsat_Vsbulk_si_Tempt_GND)+(+(+(+(+qdsat_Vsbulk_si_Tempt_GND*2.0+qdsat_Vsbulk_si*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Tempt_GND)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Tempt_GND)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))*((((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))*(((((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsbulk_si_Tempt_GND*2.0+qdsat_Vsbulk_si*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vsbulk_si*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vsbulk_si+(qdsat*2.0)*nq_Vsbulk_si_Tempt_GND)*inv_gam+((qdsat_Vsbulk_si*2.0*nq)+((qdsat*2.0)*nq_Vsbulk_si))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vsbulk_si+((qdsat*2.0)*nq)*inv_gam_Vsbulk_si_Tempt_GND)+(gam_Vsbulk_si_Tempt_GND/(nq-1.0)-(gam_Vsbulk_si*nq_Tempt_GND+gam_Tempt_GND*nq_Vsbulk_si+gam*(+nq_Vsbulk_si_Tempt_GND-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsbulk_si*nq_Tempt_GND/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
#endif
vdsatcv_Vgi_bi=(psip_Vgi_bi-((2.0*qdsat_Vgi_bi)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0))))))));
#if defined(_DERIVATE2)
  vdsatcv_Vgi_bi_Vdbulk_di=(+(+psip_Vgi_bi_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdbulk_di+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Vdbulk_di)+(+(+(+(+qdsat_Vgi_bi_Vdbulk_di*2.0+qdsat_Vgi_bi*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vdbulk_di)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vdbulk_di)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Vdbulk_di*2.0+qdsat_Vgi_bi*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vdbulk_di)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vdbulk_di)+(gam_Vgi_bi_Vdbulk_di/(nq-1.0)-(gam_Vgi_bi*nq_Vdbulk_di+gam_Vdbulk_di*nq_Vgi_bi+gam*(+nq_Vgi_bi_Vdbulk_di-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Vdbulk_di/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vgi_bi_Vsbulk_si=(+(+psip_Vgi_bi_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsbulk_si+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Vsbulk_si)+(+(+(+(+qdsat_Vgi_bi_Vsbulk_si*2.0+qdsat_Vgi_bi*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vsbulk_si)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vsbulk_si)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Vsbulk_si*2.0+qdsat_Vgi_bi*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vsbulk_si)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vsbulk_si)+(gam_Vgi_bi_Vsbulk_si/(nq-1.0)-(gam_Vgi_bi*nq_Vsbulk_si+gam_Vsbulk_si*nq_Vgi_bi+gam*(+nq_Vgi_bi_Vsbulk_si-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Vsbulk_si/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vgi_bi_Vgi_bi=(+(+psip_Vgi_bi_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vgi_bi+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Vgi_bi)+(+(+(+(+qdsat_Vgi_bi_Vgi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vgi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vgi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Vgi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vgi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vgi_bi)+(gam_Vgi_bi_Vgi_bi/(nq-1.0)-(gam_Vgi_bi*nq_Vgi_bi+gam_Vgi_bi*nq_Vgi_bi+gam*(+nq_Vgi_bi_Vgi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Vgi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vgi_bi_Vdi_bi=(+(+psip_Vgi_bi_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdi_bi+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Vdi_bi)+(+(+(+(+qdsat_Vgi_bi_Vdi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vdi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vdi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Vdi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vdi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vdi_bi)+(gam_Vgi_bi_Vdi_bi/(nq-1.0)-(gam_Vgi_bi*nq_Vdi_bi+gam_Vdi_bi*nq_Vgi_bi+gam*(+nq_Vgi_bi_Vdi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Vdi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vgi_bi_Vsi_bi=(+(+psip_Vgi_bi_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsi_bi+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Vsi_bi)+(+(+(+(+qdsat_Vgi_bi_Vsi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vsi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vsi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Vsi_bi*2.0+qdsat_Vgi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Vsi_bi)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Vsi_bi)+(gam_Vgi_bi_Vsi_bi/(nq-1.0)-(gam_Vgi_bi*nq_Vsi_bi+gam_Vsi_bi*nq_Vgi_bi+gam*(+nq_Vgi_bi_Vsi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Vsi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vgi_bi_Tempt_GND=(+(+psip_Vgi_bi_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Tempt_GND+0.0*qdsat_Vgi_bi+2.0*qdsat_Vgi_bi_Tempt_GND)+(+(+(+(+qdsat_Vgi_bi_Tempt_GND*2.0+qdsat_Vgi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Tempt_GND)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Tempt_GND)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))*((((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))*(((((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vgi_bi_Tempt_GND*2.0+qdsat_Vgi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vgi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vgi_bi+(qdsat*2.0)*nq_Vgi_bi_Tempt_GND)*inv_gam+((qdsat_Vgi_bi*2.0*nq)+((qdsat*2.0)*nq_Vgi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vgi_bi+((qdsat*2.0)*nq)*inv_gam_Vgi_bi_Tempt_GND)+(gam_Vgi_bi_Tempt_GND/(nq-1.0)-(gam_Vgi_bi*nq_Tempt_GND+gam_Tempt_GND*nq_Vgi_bi+gam*(+nq_Vgi_bi_Tempt_GND-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vgi_bi*nq_Tempt_GND/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
#endif
vdsatcv_Vdi_bi=(psip_Vdi_bi-((2.0*qdsat_Vdi_bi)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0))))))));
#if defined(_DERIVATE2)
  vdsatcv_Vdi_bi_Vdbulk_di=(+(+psip_Vdi_bi_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdbulk_di+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Vdbulk_di)+(+(+(+(+qdsat_Vdi_bi_Vdbulk_di*2.0+qdsat_Vdi_bi*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vdbulk_di)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vdbulk_di)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Vdbulk_di*2.0+qdsat_Vdi_bi*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vdbulk_di)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vdbulk_di)+(gam_Vdi_bi_Vdbulk_di/(nq-1.0)-(gam_Vdi_bi*nq_Vdbulk_di+gam_Vdbulk_di*nq_Vdi_bi+gam*(+nq_Vdi_bi_Vdbulk_di-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Vdbulk_di/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdi_bi_Vsbulk_si=(+(+psip_Vdi_bi_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsbulk_si+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Vsbulk_si)+(+(+(+(+qdsat_Vdi_bi_Vsbulk_si*2.0+qdsat_Vdi_bi*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vsbulk_si)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vsbulk_si)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Vsbulk_si*2.0+qdsat_Vdi_bi*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vsbulk_si)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vsbulk_si)+(gam_Vdi_bi_Vsbulk_si/(nq-1.0)-(gam_Vdi_bi*nq_Vsbulk_si+gam_Vsbulk_si*nq_Vdi_bi+gam*(+nq_Vdi_bi_Vsbulk_si-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Vsbulk_si/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdi_bi_Vgi_bi=(+(+psip_Vdi_bi_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vgi_bi+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Vgi_bi)+(+(+(+(+qdsat_Vdi_bi_Vgi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vgi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vgi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Vgi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vgi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vgi_bi)+(gam_Vdi_bi_Vgi_bi/(nq-1.0)-(gam_Vdi_bi*nq_Vgi_bi+gam_Vgi_bi*nq_Vdi_bi+gam*(+nq_Vdi_bi_Vgi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Vgi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdi_bi_Vdi_bi=(+(+psip_Vdi_bi_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdi_bi+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Vdi_bi)+(+(+(+(+qdsat_Vdi_bi_Vdi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vdi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vdi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Vdi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vdi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vdi_bi)+(gam_Vdi_bi_Vdi_bi/(nq-1.0)-(gam_Vdi_bi*nq_Vdi_bi+gam_Vdi_bi*nq_Vdi_bi+gam*(+nq_Vdi_bi_Vdi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Vdi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdi_bi_Vsi_bi=(+(+psip_Vdi_bi_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsi_bi+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Vsi_bi)+(+(+(+(+qdsat_Vdi_bi_Vsi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vsi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vsi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Vsi_bi*2.0+qdsat_Vdi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Vsi_bi)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Vsi_bi)+(gam_Vdi_bi_Vsi_bi/(nq-1.0)-(gam_Vdi_bi*nq_Vsi_bi+gam_Vsi_bi*nq_Vdi_bi+gam*(+nq_Vdi_bi_Vsi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Vsi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vdi_bi_Tempt_GND=(+(+psip_Vdi_bi_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Tempt_GND+0.0*qdsat_Vdi_bi+2.0*qdsat_Vdi_bi_Tempt_GND)+(+(+(+(+qdsat_Vdi_bi_Tempt_GND*2.0+qdsat_Vdi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Tempt_GND)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Tempt_GND)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))*((((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))*(((((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vdi_bi_Tempt_GND*2.0+qdsat_Vdi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vdi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vdi_bi+(qdsat*2.0)*nq_Vdi_bi_Tempt_GND)*inv_gam+((qdsat_Vdi_bi*2.0*nq)+((qdsat*2.0)*nq_Vdi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vdi_bi+((qdsat*2.0)*nq)*inv_gam_Vdi_bi_Tempt_GND)+(gam_Vdi_bi_Tempt_GND/(nq-1.0)-(gam_Vdi_bi*nq_Tempt_GND+gam_Tempt_GND*nq_Vdi_bi+gam*(+nq_Vdi_bi_Tempt_GND-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vdi_bi*nq_Tempt_GND/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
#endif
vdsatcv_Vsi_bi=(psip_Vsi_bi-((2.0*qdsat_Vsi_bi)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0))))))));
#if defined(_DERIVATE2)
  vdsatcv_Vsi_bi_Vdbulk_di=(+(+psip_Vsi_bi_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdbulk_di+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Vdbulk_di)+(+(+(+(+qdsat_Vsi_bi_Vdbulk_di*2.0+qdsat_Vsi_bi*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vdbulk_di)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vdbulk_di)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))+((gam_Vdbulk_di*(nq-1.0)-gam*nq_Vdbulk_di)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdbulk_di)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Vdbulk_di*2.0+qdsat_Vsi_bi*0.0+qdsat_Vdbulk_di*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vdbulk_di+(qdsat_Vdbulk_di*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vdbulk_di)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vdbulk_di+((((qdsat_Vdbulk_di*2.0)*nq)+((qdsat*2.0)*nq_Vdbulk_di)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vdbulk_di)+(gam_Vsi_bi_Vdbulk_di/(nq-1.0)-(gam_Vsi_bi*nq_Vdbulk_di+gam_Vdbulk_di*nq_Vsi_bi+gam*(+nq_Vsi_bi_Vdbulk_di-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Vdbulk_di/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsi_bi_Vsbulk_si=(+(+psip_Vsi_bi_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsbulk_si+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Vsbulk_si)+(+(+(+(+qdsat_Vsi_bi_Vsbulk_si*2.0+qdsat_Vsi_bi*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vsbulk_si)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vsbulk_si)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))+((gam_Vsbulk_si*(nq-1.0)-gam*nq_Vsbulk_si)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsbulk_si)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Vsbulk_si*2.0+qdsat_Vsi_bi*0.0+qdsat_Vsbulk_si*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vsbulk_si+(qdsat_Vsbulk_si*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vsbulk_si)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vsbulk_si+((((qdsat_Vsbulk_si*2.0)*nq)+((qdsat*2.0)*nq_Vsbulk_si)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vsbulk_si)+(gam_Vsi_bi_Vsbulk_si/(nq-1.0)-(gam_Vsi_bi*nq_Vsbulk_si+gam_Vsbulk_si*nq_Vsi_bi+gam*(+nq_Vsi_bi_Vsbulk_si-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Vsbulk_si/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsi_bi_Vgi_bi=(+(+psip_Vsi_bi_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vgi_bi+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Vgi_bi)+(+(+(+(+qdsat_Vsi_bi_Vgi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vgi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vgi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))+((gam_Vgi_bi*(nq-1.0)-gam*nq_Vgi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vgi_bi)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Vgi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vgi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vgi_bi+(qdsat_Vgi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vgi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vgi_bi+((((qdsat_Vgi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vgi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vgi_bi)+(gam_Vsi_bi_Vgi_bi/(nq-1.0)-(gam_Vsi_bi*nq_Vgi_bi+gam_Vgi_bi*nq_Vsi_bi+gam*(+nq_Vsi_bi_Vgi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Vgi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsi_bi_Vdi_bi=(+(+psip_Vsi_bi_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vdi_bi+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Vdi_bi)+(+(+(+(+qdsat_Vsi_bi_Vdi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vdi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vdi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))+((gam_Vdi_bi*(nq-1.0)-gam*nq_Vdi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vdi_bi)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Vdi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vdi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vdi_bi+(qdsat_Vdi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vdi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vdi_bi+((((qdsat_Vdi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vdi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vdi_bi)+(gam_Vsi_bi_Vdi_bi/(nq-1.0)-(gam_Vsi_bi*nq_Vdi_bi+gam_Vdi_bi*nq_Vsi_bi+gam*(+nq_Vsi_bi_Vdi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Vdi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsi_bi_Vsi_bi=(+(+psip_Vsi_bi_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Vsi_bi+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Vsi_bi)+(+(+(+(+qdsat_Vsi_bi_Vsi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vsi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vsi_bi)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Vsi_bi*2.0+qdsat_Vsi_bi*0.0+qdsat_Vsi_bi*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Vsi_bi+(qdsat_Vsi_bi*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Vsi_bi)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Vsi_bi+((((qdsat_Vsi_bi*2.0)*nq)+((qdsat*2.0)*nq_Vsi_bi)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Vsi_bi)+(gam_Vsi_bi_Vsi_bi/(nq-1.0)-(gam_Vsi_bi*nq_Vsi_bi+gam_Vsi_bi*nq_Vsi_bi+gam*(+nq_Vsi_bi_Vsi_bi-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Vsi_bi/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
  vdsatcv_Vsi_bi_Tempt_GND=(+(+psip_Vsi_bi_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-(+(+0.0*qdsat+0.0*qdsat_Tempt_GND+0.0*qdsat_Vsi_bi+2.0*qdsat_Vsi_bi_Tempt_GND)+(+(+(+(+qdsat_Vsi_bi_Tempt_GND*2.0+qdsat_Vsi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Tempt_GND)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Tempt_GND)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))+((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))*((((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0)))+(((((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND)))*(((((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Vsi_bi))+((gam_Vsi_bi*(nq-1.0)-gam*nq_Vsi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*inv_gam)*(+(+(+(+qdsat_Vsi_bi_Tempt_GND*2.0+qdsat_Vsi_bi*0.0+qdsat_Tempt_GND*0.0+qdsat*0.0)*nq+qdsat_Vsi_bi*2.0*nq_Tempt_GND+(qdsat_Tempt_GND*2.0)*nq_Vsi_bi+(qdsat*2.0)*nq_Vsi_bi_Tempt_GND)*inv_gam+((qdsat_Vsi_bi*2.0*nq)+((qdsat*2.0)*nq_Vsi_bi))*inv_gam_Tempt_GND+((((qdsat_Tempt_GND*2.0)*nq)+((qdsat*2.0)*nq_Tempt_GND)))*inv_gam_Vsi_bi+((qdsat*2.0)*nq)*inv_gam_Vsi_bi_Tempt_GND)+(gam_Vsi_bi_Tempt_GND/(nq-1.0)-(gam_Vsi_bi*nq_Tempt_GND+gam_Tempt_GND*nq_Vsi_bi+gam*(+nq_Vsi_bi_Tempt_GND-0.0))/(nq-1.0)/(nq-1.0)+2*gam*nq_Vsi_bi*nq_Tempt_GND/(nq-1.0)/(nq-1.0)/(nq-1.0))))));
#endif
#if defined(_DERIVATE)
vdsatcv_Tempt_GND=((psip_Tempt_GND-(2.0*phib_Tempt_GND))-((2.0*qdsat_Tempt_GND)+bsimbulk_d_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))),((((((qdsat_Tempt_GND*2.0*nq)+((qdsat*2.0)*nq_Tempt_GND))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND))*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))+((((qdsat*2.0)*nq)*inv_gam)*(((((qdsat_Tempt_GND*2.0*nq)+((qdsat*2.0)*nq_Tempt_GND))*inv_gam)+(((qdsat*2.0)*nq)*inv_gam_Tempt_GND))+((gam_Tempt_GND*(nq-1.0)-gam*nq_Tempt_GND)/(nq-1.0)/(nq-1.0))))))));
#endif
#endif
vdsatcv=((psip-(2.0*phib))-((2.0*qdsat)+bsimbulk_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))))));
EXIT_IF_ISNAN(((psip-(2.0*phib))-((2.0*qdsat)+bsimbulk_lln(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
VdsatCV_Vdbulk_di=vdsatcv_Vdbulk_di*Vt;
#if defined(_DERIVATE2)
  VdsatCV_Vdbulk_di_Vdbulk_di=(+vdsatcv_Vdbulk_di_Vdbulk_di*Vt+vdsatcv_Vdbulk_di*0.0+vdsatcv_Vdbulk_di*0.0+vdsatcv*0.0);
  VdsatCV_Vdbulk_di_Vsbulk_si=(+vdsatcv_Vdbulk_di_Vsbulk_si*Vt+vdsatcv_Vdbulk_di*0.0+vdsatcv_Vsbulk_si*0.0+vdsatcv*0.0);
  VdsatCV_Vdbulk_di_Vgi_bi=(+vdsatcv_Vdbulk_di_Vgi_bi*Vt+vdsatcv_Vdbulk_di*0.0+vdsatcv_Vgi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vdbulk_di_Vdi_bi=(+vdsatcv_Vdbulk_di_Vdi_bi*Vt+vdsatcv_Vdbulk_di*0.0+vdsatcv_Vdi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vdbulk_di_Vsi_bi=(+vdsatcv_Vdbulk_di_Vsi_bi*Vt+vdsatcv_Vdbulk_di*0.0+vdsatcv_Vsi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vdbulk_di_Tempt_GND=(+vdsatcv_Vdbulk_di_Tempt_GND*Vt+vdsatcv_Vdbulk_di*Vt_Tempt_GND+vdsatcv_Tempt_GND*0.0+vdsatcv*0.0);
#endif
VdsatCV_Vsbulk_si=vdsatcv_Vsbulk_si*Vt;
#if defined(_DERIVATE2)
  VdsatCV_Vsbulk_si_Vdbulk_di=(+vdsatcv_Vsbulk_si_Vdbulk_di*Vt+vdsatcv_Vsbulk_si*0.0+vdsatcv_Vdbulk_di*0.0+vdsatcv*0.0);
  VdsatCV_Vsbulk_si_Vsbulk_si=(+vdsatcv_Vsbulk_si_Vsbulk_si*Vt+vdsatcv_Vsbulk_si*0.0+vdsatcv_Vsbulk_si*0.0+vdsatcv*0.0);
  VdsatCV_Vsbulk_si_Vgi_bi=(+vdsatcv_Vsbulk_si_Vgi_bi*Vt+vdsatcv_Vsbulk_si*0.0+vdsatcv_Vgi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vsbulk_si_Vdi_bi=(+vdsatcv_Vsbulk_si_Vdi_bi*Vt+vdsatcv_Vsbulk_si*0.0+vdsatcv_Vdi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vsbulk_si_Vsi_bi=(+vdsatcv_Vsbulk_si_Vsi_bi*Vt+vdsatcv_Vsbulk_si*0.0+vdsatcv_Vsi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vsbulk_si_Tempt_GND=(+vdsatcv_Vsbulk_si_Tempt_GND*Vt+vdsatcv_Vsbulk_si*Vt_Tempt_GND+vdsatcv_Tempt_GND*0.0+vdsatcv*0.0);
#endif
VdsatCV_Vgi_bi=vdsatcv_Vgi_bi*Vt;
#if defined(_DERIVATE2)
  VdsatCV_Vgi_bi_Vdbulk_di=(+vdsatcv_Vgi_bi_Vdbulk_di*Vt+vdsatcv_Vgi_bi*0.0+vdsatcv_Vdbulk_di*0.0+vdsatcv*0.0);
  VdsatCV_Vgi_bi_Vsbulk_si=(+vdsatcv_Vgi_bi_Vsbulk_si*Vt+vdsatcv_Vgi_bi*0.0+vdsatcv_Vsbulk_si*0.0+vdsatcv*0.0);
  VdsatCV_Vgi_bi_Vgi_bi=(+vdsatcv_Vgi_bi_Vgi_bi*Vt+vdsatcv_Vgi_bi*0.0+vdsatcv_Vgi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vgi_bi_Vdi_bi=(+vdsatcv_Vgi_bi_Vdi_bi*Vt+vdsatcv_Vgi_bi*0.0+vdsatcv_Vdi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vgi_bi_Vsi_bi=(+vdsatcv_Vgi_bi_Vsi_bi*Vt+vdsatcv_Vgi_bi*0.0+vdsatcv_Vsi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vgi_bi_Tempt_GND=(+vdsatcv_Vgi_bi_Tempt_GND*Vt+vdsatcv_Vgi_bi*Vt_Tempt_GND+vdsatcv_Tempt_GND*0.0+vdsatcv*0.0);
#endif
VdsatCV_Vdi_bi=vdsatcv_Vdi_bi*Vt;
#if defined(_DERIVATE2)
  VdsatCV_Vdi_bi_Vdbulk_di=(+vdsatcv_Vdi_bi_Vdbulk_di*Vt+vdsatcv_Vdi_bi*0.0+vdsatcv_Vdbulk_di*0.0+vdsatcv*0.0);
  VdsatCV_Vdi_bi_Vsbulk_si=(+vdsatcv_Vdi_bi_Vsbulk_si*Vt+vdsatcv_Vdi_bi*0.0+vdsatcv_Vsbulk_si*0.0+vdsatcv*0.0);
  VdsatCV_Vdi_bi_Vgi_bi=(+vdsatcv_Vdi_bi_Vgi_bi*Vt+vdsatcv_Vdi_bi*0.0+vdsatcv_Vgi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vdi_bi_Vdi_bi=(+vdsatcv_Vdi_bi_Vdi_bi*Vt+vdsatcv_Vdi_bi*0.0+vdsatcv_Vdi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vdi_bi_Vsi_bi=(+vdsatcv_Vdi_bi_Vsi_bi*Vt+vdsatcv_Vdi_bi*0.0+vdsatcv_Vsi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vdi_bi_Tempt_GND=(+vdsatcv_Vdi_bi_Tempt_GND*Vt+vdsatcv_Vdi_bi*Vt_Tempt_GND+vdsatcv_Tempt_GND*0.0+vdsatcv*0.0);
#endif
VdsatCV_Vsi_bi=vdsatcv_Vsi_bi*Vt;
#if defined(_DERIVATE2)
  VdsatCV_Vsi_bi_Vdbulk_di=(+vdsatcv_Vsi_bi_Vdbulk_di*Vt+vdsatcv_Vsi_bi*0.0+vdsatcv_Vdbulk_di*0.0+vdsatcv*0.0);
  VdsatCV_Vsi_bi_Vsbulk_si=(+vdsatcv_Vsi_bi_Vsbulk_si*Vt+vdsatcv_Vsi_bi*0.0+vdsatcv_Vsbulk_si*0.0+vdsatcv*0.0);
  VdsatCV_Vsi_bi_Vgi_bi=(+vdsatcv_Vsi_bi_Vgi_bi*Vt+vdsatcv_Vsi_bi*0.0+vdsatcv_Vgi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vsi_bi_Vdi_bi=(+vdsatcv_Vsi_bi_Vdi_bi*Vt+vdsatcv_Vsi_bi*0.0+vdsatcv_Vdi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vsi_bi_Vsi_bi=(+vdsatcv_Vsi_bi_Vsi_bi*Vt+vdsatcv_Vsi_bi*0.0+vdsatcv_Vsi_bi*0.0+vdsatcv*0.0);
  VdsatCV_Vsi_bi_Tempt_GND=(+vdsatcv_Vsi_bi_Tempt_GND*Vt+vdsatcv_Vsi_bi*Vt_Tempt_GND+vdsatcv_Tempt_GND*0.0+vdsatcv*0.0);
#endif
#if defined(_DERIVATE)
VdsatCV_Tempt_GND=((vdsatcv_Tempt_GND*Vt)+(vdsatcv*Vt_Tempt_GND));
#endif
#endif
VdsatCV=(vdsatcv*Vt);
EXIT_IF_ISNAN((vdsatcv*Vt))
{
double m00_sqrt(d00_sqrt0,(((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
VdssatCV_Vdbulk_di=(0.5*(VdsatCV_Vdbulk_di+((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  VdssatCV_Vdbulk_di_Vdbulk_di=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdbulk_di_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))+d10_sqrt0*(+(+(+(+VdsatCV_Vdbulk_di_Vdbulk_di-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vdbulk_di*VdsatCV_Vdbulk_di+VdsatCV_Vdbulk_di*VdsatCV_Vdbulk_di+(VdsatCV-Vs)*(+(+VdsatCV_Vdbulk_di_Vdbulk_di-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdbulk_di_Vsbulk_si=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdbulk_di_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))+d10_sqrt0*(+(+(+(+VdsatCV_Vdbulk_di_Vsbulk_si-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vdbulk_di*VdsatCV_Vsbulk_si+VdsatCV_Vsbulk_si*VdsatCV_Vdbulk_di+(VdsatCV-Vs)*(+(+VdsatCV_Vdbulk_di_Vsbulk_si-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdbulk_di_Vgi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vgi_bi+((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdbulk_di_Vgi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))+d10_sqrt0*(+(+(+(+VdsatCV_Vdbulk_di_Vgi_bi-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vdbulk_di*VdsatCV_Vgi_bi+VdsatCV_Vgi_bi*VdsatCV_Vdbulk_di+(VdsatCV-Vs)*(+(+VdsatCV_Vdbulk_di_Vgi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdbulk_di_Vdi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdbulk_di_Vdi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))+d10_sqrt0*(+(+(+(+VdsatCV_Vdbulk_di_Vdi_bi-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vdbulk_di*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*VdsatCV_Vdbulk_di+(VdsatCV-Vs)*(+(+VdsatCV_Vdbulk_di_Vdi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdbulk_di_Vsi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdbulk_di_Vsi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))+d10_sqrt0*(+(+(+(+VdsatCV_Vdbulk_di_Vsi_bi-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vdbulk_di*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*VdsatCV_Vdbulk_di+(VdsatCV-Vs)*(+(+VdsatCV_Vdbulk_di_Vsi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdbulk_di_Tempt_GND=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Tempt_GND+((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdbulk_di_Tempt_GND-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di))+d10_sqrt0*(+(+(+(+VdsatCV_Vdbulk_di_Tempt_GND-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vdbulk_di*VdsatCV_Tempt_GND+VdsatCV_Tempt_GND*VdsatCV_Vdbulk_di+(VdsatCV-Vs)*(+(+VdsatCV_Vdbulk_di_Tempt_GND-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
#endif
VdssatCV_Vsbulk_si=(0.5*(VdsatCV_Vsbulk_si+((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  VdssatCV_Vsbulk_si_Vdbulk_di=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsbulk_si_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))+d10_sqrt0*(+(+(+(+VdsatCV_Vsbulk_si_Vdbulk_di-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vsbulk_si*VdsatCV_Vdbulk_di+VdsatCV_Vdbulk_di*VdsatCV_Vsbulk_si+(VdsatCV-Vs)*(+(+VdsatCV_Vsbulk_si_Vdbulk_di-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsbulk_si_Vsbulk_si=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsbulk_si_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))+d10_sqrt0*(+(+(+(+VdsatCV_Vsbulk_si_Vsbulk_si-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vsbulk_si*VdsatCV_Vsbulk_si+VdsatCV_Vsbulk_si*VdsatCV_Vsbulk_si+(VdsatCV-Vs)*(+(+VdsatCV_Vsbulk_si_Vsbulk_si-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsbulk_si_Vgi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vgi_bi+((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsbulk_si_Vgi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))+d10_sqrt0*(+(+(+(+VdsatCV_Vsbulk_si_Vgi_bi-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vsbulk_si*VdsatCV_Vgi_bi+VdsatCV_Vgi_bi*VdsatCV_Vsbulk_si+(VdsatCV-Vs)*(+(+VdsatCV_Vsbulk_si_Vgi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsbulk_si_Vdi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsbulk_si_Vdi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))+d10_sqrt0*(+(+(+(+VdsatCV_Vsbulk_si_Vdi_bi-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vsbulk_si*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*VdsatCV_Vsbulk_si+(VdsatCV-Vs)*(+(+VdsatCV_Vsbulk_si_Vdi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsbulk_si_Vsi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsbulk_si_Vsi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))+d10_sqrt0*(+(+(+(+VdsatCV_Vsbulk_si_Vsi_bi-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vsbulk_si*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*VdsatCV_Vsbulk_si+(VdsatCV-Vs)*(+(+VdsatCV_Vsbulk_si_Vsi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsbulk_si_Tempt_GND=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Tempt_GND+((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsbulk_si_Tempt_GND-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si))+d10_sqrt0*(+(+(+(+VdsatCV_Vsbulk_si_Tempt_GND-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vsbulk_si*VdsatCV_Tempt_GND+VdsatCV_Tempt_GND*VdsatCV_Vsbulk_si+(VdsatCV-Vs)*(+(+VdsatCV_Vsbulk_si_Tempt_GND-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
#endif
VdssatCV_Vgi_bi=(0.5*(VdsatCV_Vgi_bi+((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  VdssatCV_Vgi_bi_Vdbulk_di=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vgi_bi+((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vgi_bi_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))+d10_sqrt0*(+(+(+(+VdsatCV_Vgi_bi_Vdbulk_di-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vgi_bi*VdsatCV_Vdbulk_di+VdsatCV_Vdbulk_di*VdsatCV_Vgi_bi+(VdsatCV-Vs)*(+(+VdsatCV_Vgi_bi_Vdbulk_di-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vgi_bi_Vsbulk_si=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vgi_bi+((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vgi_bi_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))+d10_sqrt0*(+(+(+(+VdsatCV_Vgi_bi_Vsbulk_si-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vgi_bi*VdsatCV_Vsbulk_si+VdsatCV_Vsbulk_si*VdsatCV_Vgi_bi+(VdsatCV-Vs)*(+(+VdsatCV_Vgi_bi_Vsbulk_si-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vgi_bi_Vgi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vgi_bi+((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vgi_bi+((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vgi_bi_Vgi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))+d10_sqrt0*(+(+(+(+VdsatCV_Vgi_bi_Vgi_bi-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vgi_bi*VdsatCV_Vgi_bi+VdsatCV_Vgi_bi*VdsatCV_Vgi_bi+(VdsatCV-Vs)*(+(+VdsatCV_Vgi_bi_Vgi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vgi_bi_Vdi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vgi_bi+((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vgi_bi_Vdi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))+d10_sqrt0*(+(+(+(+VdsatCV_Vgi_bi_Vdi_bi-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vgi_bi*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*VdsatCV_Vgi_bi+(VdsatCV-Vs)*(+(+VdsatCV_Vgi_bi_Vdi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vgi_bi_Vsi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vgi_bi+((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vgi_bi_Vsi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))+d10_sqrt0*(+(+(+(+VdsatCV_Vgi_bi_Vsi_bi-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vgi_bi*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*VdsatCV_Vgi_bi+(VdsatCV-Vs)*(+(+VdsatCV_Vgi_bi_Vsi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vgi_bi_Tempt_GND=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Tempt_GND+((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*d10_sqrt0)+0.0*(VdsatCV_Vgi_bi+((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vgi_bi_Tempt_GND-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi))+d10_sqrt0*(+(+(+(+VdsatCV_Vgi_bi_Tempt_GND-0.0)-0.0)*(VdsatCV-Vs)+VdsatCV_Vgi_bi*VdsatCV_Tempt_GND+VdsatCV_Tempt_GND*VdsatCV_Vgi_bi+(VdsatCV-Vs)*(+(+VdsatCV_Vgi_bi_Tempt_GND-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
#endif
VdssatCV_Vdi_bi=(0.5*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  VdssatCV_Vdi_bi_Vdbulk_di=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdi_bi_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vdi_bi_Vdbulk_di-0.0)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*VdsatCV_Vdbulk_di+VdsatCV_Vdbulk_di*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vdi_bi_Vdbulk_di-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdi_bi_Vsbulk_si=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdi_bi_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vdi_bi_Vsbulk_si-0.0)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*VdsatCV_Vsbulk_si+VdsatCV_Vsbulk_si*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vdi_bi_Vsbulk_si-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdi_bi_Vgi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vgi_bi+((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdi_bi_Vgi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vdi_bi_Vgi_bi-0.0)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*VdsatCV_Vgi_bi+VdsatCV_Vgi_bi*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vdi_bi_Vgi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdi_bi_Vdi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdi_bi_Vsi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vdi_bi_Tempt_GND=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Tempt_GND+((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vdi_bi_Tempt_GND-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*(((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vdi_bi_Tempt_GND-0.0)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*VdsatCV_Tempt_GND+VdsatCV_Tempt_GND*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vdi_bi_Tempt_GND-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
#endif
VdssatCV_Vsi_bi=(0.5*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  VdssatCV_Vsi_bi_Vdbulk_di=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vdbulk_di+((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsi_bi_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vdbulk_di*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vdbulk_di)))+((0.0)*1e-3))*(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vsi_bi_Vdbulk_di-0.0)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*VdsatCV_Vdbulk_di+VdsatCV_Vdbulk_di*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vsi_bi_Vdbulk_di-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsi_bi_Vsbulk_si=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vsbulk_si+((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsi_bi_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vsbulk_si*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vsbulk_si)))+((0.0)*1e-3))*(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vsi_bi_Vsbulk_si-0.0)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*VdsatCV_Vsbulk_si+VdsatCV_Vsbulk_si*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vsi_bi_Vsbulk_si-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsi_bi_Vgi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Vgi_bi+((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsi_bi_Vgi_bi-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Vgi_bi*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Vgi_bi)))+((0.0)*1e-3))*(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vsi_bi_Vgi_bi-0.0)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*VdsatCV_Vgi_bi+VdsatCV_Vgi_bi*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vsi_bi_Vgi_bi-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsi_bi_Vdi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vdi_bi-Vs_Vdi_bi)+(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1e-3))*(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV_Vdi_bi-Vs_Vdi_bi)+(VdsatCV_Vdi_bi-Vs_Vdi_bi)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsi_bi_Vsi_bi=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*(((((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1e-3))*(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
  VdssatCV_Vsi_bi_Tempt_GND=(+0.0*((VdsatCV-Vs)+d00_sqrt0)+0.0*(VdsatCV_Tempt_GND+((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*d10_sqrt0)+0.0*((VdsatCV_Vsi_bi-Vs_Vsi_bi)+(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+VdsatCV_Vsi_bi_Tempt_GND-0.0)+0.0)+(m20_sqrt((((VdsatCV-Vs)*(VdsatCV-Vs))+((0.25*1e-3)*1e-3)))*((((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND)))+((0.0)*1e-3))*(((VdsatCV_Vsi_bi-Vs_Vsi_bi)*(VdsatCV-Vs))+((VdsatCV-Vs)*(VdsatCV_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+VdsatCV_Vsi_bi_Tempt_GND-0.0)-0.0)*(VdsatCV-Vs)+(VdsatCV_Vsi_bi-Vs_Vsi_bi)*VdsatCV_Tempt_GND+VdsatCV_Tempt_GND*(VdsatCV_Vsi_bi-Vs_Vsi_bi)+(VdsatCV-Vs)*(+(+VdsatCV_Vsi_bi_Tempt_GND-0.0)-0.0))+(+(+0.0*1e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1e-3+0.0*0.0+(0.0)*0.0+(0.25*1e-3)*0.0)))));
#endif
#if defined(_DERIVATE)
VdssatCV_Tempt_GND=(0.5*(VdsatCV_Tempt_GND+((VdsatCV_Tempt_GND*(VdsatCV-Vs))+((VdsatCV-Vs)*VdsatCV_Tempt_GND))*d10_sqrt0));
#endif
#endif
VdssatCV=(0.5*((VdsatCV-Vs)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((VdsatCV-Vs)+d00_sqrt0)))
}
{
double m00_pow(d00_pow0,(Vds/VdssatCV),(1.0/DELTA_t))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(Vds/VdssatCV),(1.0/DELTA_t))
double m11_pow(d11_pow0,d00_pow0,(Vds/VdssatCV),(1.0/DELTA_t))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=(d10_pow0*(-Vds*VdssatCV_Vdbulk_di/VdssatCV/VdssatCV));
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=fixme;
  T7_Vdbulk_di_Vgm_di=fixme;
  T7_Vdbulk_di_Vdbulk_di=fixme;
  T7_Vdbulk_di_Vsbulk_si=fixme;
  T7_Vdbulk_di_Vgi_bi=fixme;
  T7_Vdbulk_di_Vdi_bi=fixme;
  T7_Vdbulk_di_Vsi_bi=fixme;
  T7_Vdbulk_di_Tempt_GND=fixme;
#endif
T7_Vsbulk_si=(d10_pow0*(-Vds*VdssatCV_Vsbulk_si/VdssatCV/VdssatCV));
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=fixme;
  T7_Vsbulk_si_Vgm_di=fixme;
  T7_Vsbulk_si_Vdbulk_di=fixme;
  T7_Vsbulk_si_Vsbulk_si=fixme;
  T7_Vsbulk_si_Vgi_bi=fixme;
  T7_Vsbulk_si_Vdi_bi=fixme;
  T7_Vsbulk_si_Vsi_bi=fixme;
  T7_Vsbulk_si_Tempt_GND=fixme;
#endif
T7_Vgi_bi=(d10_pow0*(-Vds*VdssatCV_Vgi_bi/VdssatCV/VdssatCV));
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=fixme;
  T7_Vgi_bi_Vgm_di=fixme;
  T7_Vgi_bi_Vdbulk_di=fixme;
  T7_Vgi_bi_Vsbulk_si=fixme;
  T7_Vgi_bi_Vgi_bi=fixme;
  T7_Vgi_bi_Vdi_bi=fixme;
  T7_Vgi_bi_Vsi_bi=fixme;
  T7_Vgi_bi_Tempt_GND=fixme;
#endif
T7_Vdi_bi=(d10_pow0*((Vds_Vdi_bi*VdssatCV-Vds*VdssatCV_Vdi_bi)/VdssatCV/VdssatCV));
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=fixme;
  T7_Vdi_bi_Vgm_di=fixme;
  T7_Vdi_bi_Vdbulk_di=fixme;
  T7_Vdi_bi_Vsbulk_si=fixme;
  T7_Vdi_bi_Vgi_bi=fixme;
  T7_Vdi_bi_Vdi_bi=fixme;
  T7_Vdi_bi_Vsi_bi=fixme;
  T7_Vdi_bi_Tempt_GND=fixme;
#endif
T7_Vsi_bi=(d10_pow0*((Vds_Vsi_bi*VdssatCV-Vds*VdssatCV_Vsi_bi)/VdssatCV/VdssatCV));
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=fixme;
  T7_Vsi_bi_Vgm_di=fixme;
  T7_Vsi_bi_Vdbulk_di=fixme;
  T7_Vsi_bi_Vsbulk_si=fixme;
  T7_Vsi_bi_Vgi_bi=fixme;
  T7_Vsi_bi_Vdi_bi=fixme;
  T7_Vsi_bi_Vsi_bi=fixme;
  T7_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(d10_pow0*(-Vds*VdssatCV_Tempt_GND/VdssatCV/VdssatCV)+d11_pow0*(-DELTA_t_Tempt_GND/DELTA_t/DELTA_t));
#endif
#endif
T7=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(1.0+T7),(-DELTA_t))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0+T7),(-DELTA_t))
double m11_pow(d11_pow0,d00_pow0,(1.0+T7),(-DELTA_t))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=(d10_pow0*T7_Vdbulk_di);
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=fixme;
  T8_Vdbulk_di_Vgm_si=fixme;
  T8_Vdbulk_di_Vdbulk_di=fixme;
  T8_Vdbulk_di_Vsbulk_si=fixme;
  T8_Vdbulk_di_Vgi_bi=fixme;
  T8_Vdbulk_di_Vdi_bi=fixme;
  T8_Vdbulk_di_Vsi_bi=fixme;
  T8_Vdbulk_di_Tempt_GND=fixme;
#endif
T8_Vsbulk_si=(d10_pow0*T7_Vsbulk_si);
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=fixme;
  T8_Vsbulk_si_Vgm_si=fixme;
  T8_Vsbulk_si_Vdbulk_di=fixme;
  T8_Vsbulk_si_Vsbulk_si=fixme;
  T8_Vsbulk_si_Vgi_bi=fixme;
  T8_Vsbulk_si_Vdi_bi=fixme;
  T8_Vsbulk_si_Vsi_bi=fixme;
  T8_Vsbulk_si_Tempt_GND=fixme;
#endif
T8_Vgi_bi=(d10_pow0*T7_Vgi_bi);
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=fixme;
  T8_Vgi_bi_Vgm_si=fixme;
  T8_Vgi_bi_Vdbulk_di=fixme;
  T8_Vgi_bi_Vsbulk_si=fixme;
  T8_Vgi_bi_Vgi_bi=fixme;
  T8_Vgi_bi_Vdi_bi=fixme;
  T8_Vgi_bi_Vsi_bi=fixme;
  T8_Vgi_bi_Tempt_GND=fixme;
#endif
T8_Vdi_bi=(d10_pow0*T7_Vdi_bi);
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=fixme;
  T8_Vdi_bi_Vgm_si=fixme;
  T8_Vdi_bi_Vdbulk_di=fixme;
  T8_Vdi_bi_Vsbulk_si=fixme;
  T8_Vdi_bi_Vgi_bi=fixme;
  T8_Vdi_bi_Vdi_bi=fixme;
  T8_Vdi_bi_Vsi_bi=fixme;
  T8_Vdi_bi_Tempt_GND=fixme;
#endif
T8_Vsi_bi=(d10_pow0*T7_Vsi_bi);
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=fixme;
  T8_Vsi_bi_Vgm_si=fixme;
  T8_Vsi_bi_Vdbulk_di=fixme;
  T8_Vsi_bi_Vsbulk_si=fixme;
  T8_Vsi_bi_Vgi_bi=fixme;
  T8_Vsi_bi_Vdi_bi=fixme;
  T8_Vsi_bi_Vsi_bi=fixme;
  T8_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(d10_pow0*T7_Tempt_GND+d11_pow0*(-DELTA_t_Tempt_GND));
#endif
#endif
T8=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Vdseff_Vgm_di=0.0;
#if defined(_DERIVATE2)
  Vdseff_Vgm_di_Vgm_di=0.0;
  Vdseff_Vgm_di_Vgm_si=0.0;
  Vdseff_Vgm_di_Vdbulk_di=0.0;
  Vdseff_Vgm_di_Vsbulk_si=0.0;
  Vdseff_Vgm_di_Vdi_bi=0.0;
  Vdseff_Vgm_di_Vsi_bi=0.0;
  Vdseff_Vgm_di_Vgi_bi=0.0;
  Vdseff_Vgm_di_Tempt_GND=0.0;
#endif
Vdseff_Vgm_si=0.0;
#if defined(_DERIVATE2)
  Vdseff_Vgm_si_Vgm_di=0.0;
  Vdseff_Vgm_si_Vgm_si=0.0;
  Vdseff_Vgm_si_Vdbulk_di=0.0;
  Vdseff_Vgm_si_Vsbulk_si=0.0;
  Vdseff_Vgm_si_Vdi_bi=0.0;
  Vdseff_Vgm_si_Vsi_bi=0.0;
  Vdseff_Vgm_si_Vgi_bi=0.0;
  Vdseff_Vgm_si_Tempt_GND=0.0;
#endif
Vdseff_Vdbulk_di=(Vds*T8_Vdbulk_di);
#if defined(_DERIVATE2)
  Vdseff_Vdbulk_di_Vgm_di=(+0.0*T8+0.0*T8_Vgm_di+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vgm_di);
  Vdseff_Vdbulk_di_Vgm_si=(+0.0*T8+0.0*T8_Vgm_si+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vgm_si);
  Vdseff_Vdbulk_di_Vdbulk_di=(+0.0*T8+0.0*T8_Vdbulk_di+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vdbulk_di);
  Vdseff_Vdbulk_di_Vsbulk_si=(+0.0*T8+0.0*T8_Vsbulk_si+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vsbulk_si);
  Vdseff_Vdbulk_di_Vdi_bi=(+0.0*T8+0.0*T8_Vdi_bi+Vds_Vdi_bi*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vdi_bi);
  Vdseff_Vdbulk_di_Vsi_bi=(+0.0*T8+0.0*T8_Vsi_bi+Vds_Vsi_bi*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vsi_bi);
  Vdseff_Vdbulk_di_Vgi_bi=(+0.0*T8+0.0*T8_Vgi_bi+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vgi_bi);
  Vdseff_Vdbulk_di_Tempt_GND=(+0.0*T8+0.0*T8_Tempt_GND+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Tempt_GND);
#endif
Vdseff_Vsbulk_si=(Vds*T8_Vsbulk_si);
#if defined(_DERIVATE2)
  Vdseff_Vsbulk_si_Vgm_di=(+0.0*T8+0.0*T8_Vgm_di+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vgm_di);
  Vdseff_Vsbulk_si_Vgm_si=(+0.0*T8+0.0*T8_Vgm_si+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vgm_si);
  Vdseff_Vsbulk_si_Vdbulk_di=(+0.0*T8+0.0*T8_Vdbulk_di+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vdbulk_di);
  Vdseff_Vsbulk_si_Vsbulk_si=(+0.0*T8+0.0*T8_Vsbulk_si+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vsbulk_si);
  Vdseff_Vsbulk_si_Vdi_bi=(+0.0*T8+0.0*T8_Vdi_bi+Vds_Vdi_bi*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vdi_bi);
  Vdseff_Vsbulk_si_Vsi_bi=(+0.0*T8+0.0*T8_Vsi_bi+Vds_Vsi_bi*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vsi_bi);
  Vdseff_Vsbulk_si_Vgi_bi=(+0.0*T8+0.0*T8_Vgi_bi+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vgi_bi);
  Vdseff_Vsbulk_si_Tempt_GND=(+0.0*T8+0.0*T8_Tempt_GND+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Tempt_GND);
#endif
Vdseff_Vdi_bi=((Vds_Vdi_bi*T8)+(Vds*T8_Vdi_bi));
#if defined(_DERIVATE2)
  Vdseff_Vdi_bi_Vgm_di=(+0.0*T8+Vds_Vdi_bi*T8_Vgm_di+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vgm_di);
  Vdseff_Vdi_bi_Vgm_si=(+0.0*T8+Vds_Vdi_bi*T8_Vgm_si+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vgm_si);
  Vdseff_Vdi_bi_Vdbulk_di=(+0.0*T8+Vds_Vdi_bi*T8_Vdbulk_di+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vdbulk_di);
  Vdseff_Vdi_bi_Vsbulk_si=(+0.0*T8+Vds_Vdi_bi*T8_Vsbulk_si+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vsbulk_si);
  Vdseff_Vdi_bi_Vdi_bi=(+Vds_Vdi_bi_Vdi_bi*T8+Vds_Vdi_bi*T8_Vdi_bi+Vds_Vdi_bi*T8_Vdi_bi+Vds*T8_Vdi_bi_Vdi_bi);
  Vdseff_Vdi_bi_Vsi_bi=(+Vds_Vdi_bi_Vsi_bi*T8+Vds_Vdi_bi*T8_Vsi_bi+Vds_Vsi_bi*T8_Vdi_bi+Vds*T8_Vdi_bi_Vsi_bi);
  Vdseff_Vdi_bi_Vgi_bi=(+0.0*T8+Vds_Vdi_bi*T8_Vgi_bi+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vgi_bi);
  Vdseff_Vdi_bi_Tempt_GND=(+0.0*T8+Vds_Vdi_bi*T8_Tempt_GND+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Tempt_GND);
#endif
Vdseff_Vsi_bi=((Vds_Vsi_bi*T8)+(Vds*T8_Vsi_bi));
#if defined(_DERIVATE2)
  Vdseff_Vsi_bi_Vgm_di=(+0.0*T8+Vds_Vsi_bi*T8_Vgm_di+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vgm_di);
  Vdseff_Vsi_bi_Vgm_si=(+0.0*T8+Vds_Vsi_bi*T8_Vgm_si+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vgm_si);
  Vdseff_Vsi_bi_Vdbulk_di=(+0.0*T8+Vds_Vsi_bi*T8_Vdbulk_di+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vdbulk_di);
  Vdseff_Vsi_bi_Vsbulk_si=(+0.0*T8+Vds_Vsi_bi*T8_Vsbulk_si+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vsbulk_si);
  Vdseff_Vsi_bi_Vdi_bi=(+Vds_Vsi_bi_Vdi_bi*T8+Vds_Vsi_bi*T8_Vdi_bi+Vds_Vdi_bi*T8_Vsi_bi+Vds*T8_Vsi_bi_Vdi_bi);
  Vdseff_Vsi_bi_Vsi_bi=(+Vds_Vsi_bi_Vsi_bi*T8+Vds_Vsi_bi*T8_Vsi_bi+Vds_Vsi_bi*T8_Vsi_bi+Vds*T8_Vsi_bi_Vsi_bi);
  Vdseff_Vsi_bi_Vgi_bi=(+0.0*T8+Vds_Vsi_bi*T8_Vgi_bi+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vgi_bi);
  Vdseff_Vsi_bi_Tempt_GND=(+0.0*T8+Vds_Vsi_bi*T8_Tempt_GND+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Tempt_GND);
#endif
Vdseff_Vgi_bi=(Vds*T8_Vgi_bi);
#if defined(_DERIVATE2)
  Vdseff_Vgi_bi_Vgm_di=(+0.0*T8+0.0*T8_Vgm_di+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vgm_di);
  Vdseff_Vgi_bi_Vgm_si=(+0.0*T8+0.0*T8_Vgm_si+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vgm_si);
  Vdseff_Vgi_bi_Vdbulk_di=(+0.0*T8+0.0*T8_Vdbulk_di+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vdbulk_di);
  Vdseff_Vgi_bi_Vsbulk_si=(+0.0*T8+0.0*T8_Vsbulk_si+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vsbulk_si);
  Vdseff_Vgi_bi_Vdi_bi=(+0.0*T8+0.0*T8_Vdi_bi+Vds_Vdi_bi*T8_Vgi_bi+Vds*T8_Vgi_bi_Vdi_bi);
  Vdseff_Vgi_bi_Vsi_bi=(+0.0*T8+0.0*T8_Vsi_bi+Vds_Vsi_bi*T8_Vgi_bi+Vds*T8_Vgi_bi_Vsi_bi);
  Vdseff_Vgi_bi_Vgi_bi=(+0.0*T8+0.0*T8_Vgi_bi+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vgi_bi);
  Vdseff_Vgi_bi_Tempt_GND=(+0.0*T8+0.0*T8_Tempt_GND+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Vdseff_Tempt_GND=(Vds*T8_Tempt_GND);
#endif
#endif
Vdseff=(Vds*T8);
EXIT_IF_ISNAN((Vds*T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
vdeff_Vgm_di=0.0;
#if defined(_DERIVATE2)
  vdeff_Vgm_di_Vgm_di=0.0;
  vdeff_Vgm_di_Vgm_si=0.0;
  vdeff_Vgm_di_Vdbulk_di=0.0;
  vdeff_Vgm_di_Vsbulk_si=0.0;
  vdeff_Vgm_di_Vdi_bi=0.0;
  vdeff_Vgm_di_Vsi_bi=0.0;
  vdeff_Vgm_di_Vgi_bi=0.0;
  vdeff_Vgm_di_Tempt_GND=0.0;
#endif
vdeff_Vgm_si=0.0;
#if defined(_DERIVATE2)
  vdeff_Vgm_si_Vgm_di=0.0;
  vdeff_Vgm_si_Vgm_si=0.0;
  vdeff_Vgm_si_Vdbulk_di=0.0;
  vdeff_Vgm_si_Vsbulk_si=0.0;
  vdeff_Vgm_si_Vdi_bi=0.0;
  vdeff_Vgm_si_Vsi_bi=0.0;
  vdeff_Vgm_si_Vgi_bi=0.0;
  vdeff_Vgm_si_Tempt_GND=0.0;
#endif
vdeff_Vdbulk_di=Vdseff_Vdbulk_di*inv_Vt;
#if defined(_DERIVATE2)
  vdeff_Vdbulk_di_Vgm_di=(+(+Vdseff_Vdbulk_di_Vgm_di+0.0)*inv_Vt+Vdseff_Vdbulk_di*0.0+Vdseff_Vgm_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdbulk_di_Vgm_si=(+(+Vdseff_Vdbulk_di_Vgm_si+0.0)*inv_Vt+Vdseff_Vdbulk_di*0.0+Vdseff_Vgm_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdbulk_di_Vdbulk_di=(+(+Vdseff_Vdbulk_di_Vdbulk_di+0.0)*inv_Vt+Vdseff_Vdbulk_di*0.0+Vdseff_Vdbulk_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdbulk_di_Vsbulk_si=(+(+Vdseff_Vdbulk_di_Vsbulk_si+0.0)*inv_Vt+Vdseff_Vdbulk_di*0.0+Vdseff_Vsbulk_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdbulk_di_Vdi_bi=(+(+Vdseff_Vdbulk_di_Vdi_bi+0.0)*inv_Vt+Vdseff_Vdbulk_di*0.0+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdbulk_di_Vsi_bi=(+(+Vdseff_Vdbulk_di_Vsi_bi+0.0)*inv_Vt+Vdseff_Vdbulk_di*0.0+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdbulk_di_Vgi_bi=(+(+Vdseff_Vdbulk_di_Vgi_bi+0.0)*inv_Vt+Vdseff_Vdbulk_di*0.0+Vdseff_Vgi_bi*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdbulk_di_Tempt_GND=(+(+Vdseff_Vdbulk_di_Tempt_GND+0.0)*inv_Vt+Vdseff_Vdbulk_di*inv_Vt_Tempt_GND+Vdseff_Tempt_GND*0.0+(Vdseff+Vs)*0.0);
#endif
vdeff_Vsbulk_si=Vdseff_Vsbulk_si*inv_Vt;
#if defined(_DERIVATE2)
  vdeff_Vsbulk_si_Vgm_di=(+(+Vdseff_Vsbulk_si_Vgm_di+0.0)*inv_Vt+Vdseff_Vsbulk_si*0.0+Vdseff_Vgm_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsbulk_si_Vgm_si=(+(+Vdseff_Vsbulk_si_Vgm_si+0.0)*inv_Vt+Vdseff_Vsbulk_si*0.0+Vdseff_Vgm_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsbulk_si_Vdbulk_di=(+(+Vdseff_Vsbulk_si_Vdbulk_di+0.0)*inv_Vt+Vdseff_Vsbulk_si*0.0+Vdseff_Vdbulk_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsbulk_si_Vsbulk_si=(+(+Vdseff_Vsbulk_si_Vsbulk_si+0.0)*inv_Vt+Vdseff_Vsbulk_si*0.0+Vdseff_Vsbulk_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsbulk_si_Vdi_bi=(+(+Vdseff_Vsbulk_si_Vdi_bi+0.0)*inv_Vt+Vdseff_Vsbulk_si*0.0+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsbulk_si_Vsi_bi=(+(+Vdseff_Vsbulk_si_Vsi_bi+0.0)*inv_Vt+Vdseff_Vsbulk_si*0.0+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsbulk_si_Vgi_bi=(+(+Vdseff_Vsbulk_si_Vgi_bi+0.0)*inv_Vt+Vdseff_Vsbulk_si*0.0+Vdseff_Vgi_bi*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsbulk_si_Tempt_GND=(+(+Vdseff_Vsbulk_si_Tempt_GND+0.0)*inv_Vt+Vdseff_Vsbulk_si*inv_Vt_Tempt_GND+Vdseff_Tempt_GND*0.0+(Vdseff+Vs)*0.0);
#endif
vdeff_Vdi_bi=(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_Vt;
#if defined(_DERIVATE2)
  vdeff_Vdi_bi_Vgm_di=(+(+Vdseff_Vdi_bi_Vgm_di+0.0)*inv_Vt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+Vdseff_Vgm_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdi_bi_Vgm_si=(+(+Vdseff_Vdi_bi_Vgm_si+0.0)*inv_Vt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+Vdseff_Vgm_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdi_bi_Vdbulk_di=(+(+Vdseff_Vdi_bi_Vdbulk_di+0.0)*inv_Vt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+Vdseff_Vdbulk_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdi_bi_Vsbulk_si=(+(+Vdseff_Vdi_bi_Vsbulk_si+0.0)*inv_Vt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+Vdseff_Vsbulk_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdi_bi_Vdi_bi=(+(+Vdseff_Vdi_bi_Vdi_bi+Vs_Vdi_bi_Vdi_bi)*inv_Vt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdi_bi_Vsi_bi=(+(+Vdseff_Vdi_bi_Vsi_bi+Vs_Vdi_bi_Vsi_bi)*inv_Vt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdi_bi_Vgi_bi=(+(+Vdseff_Vdi_bi_Vgi_bi+0.0)*inv_Vt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+Vdseff_Vgi_bi*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vdi_bi_Tempt_GND=(+(+Vdseff_Vdi_bi_Tempt_GND+0.0)*inv_Vt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_Vt_Tempt_GND+Vdseff_Tempt_GND*0.0+(Vdseff+Vs)*0.0);
#endif
vdeff_Vsi_bi=(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_Vt;
#if defined(_DERIVATE2)
  vdeff_Vsi_bi_Vgm_di=(+(+Vdseff_Vsi_bi_Vgm_di+0.0)*inv_Vt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+Vdseff_Vgm_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsi_bi_Vgm_si=(+(+Vdseff_Vsi_bi_Vgm_si+0.0)*inv_Vt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+Vdseff_Vgm_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsi_bi_Vdbulk_di=(+(+Vdseff_Vsi_bi_Vdbulk_di+0.0)*inv_Vt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+Vdseff_Vdbulk_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsi_bi_Vsbulk_si=(+(+Vdseff_Vsi_bi_Vsbulk_si+0.0)*inv_Vt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+Vdseff_Vsbulk_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsi_bi_Vdi_bi=(+(+Vdseff_Vsi_bi_Vdi_bi+Vs_Vsi_bi_Vdi_bi)*inv_Vt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsi_bi_Vsi_bi=(+(+Vdseff_Vsi_bi_Vsi_bi+Vs_Vsi_bi_Vsi_bi)*inv_Vt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsi_bi_Vgi_bi=(+(+Vdseff_Vsi_bi_Vgi_bi+0.0)*inv_Vt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+Vdseff_Vgi_bi*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vsi_bi_Tempt_GND=(+(+Vdseff_Vsi_bi_Tempt_GND+0.0)*inv_Vt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_Vt_Tempt_GND+Vdseff_Tempt_GND*0.0+(Vdseff+Vs)*0.0);
#endif
vdeff_Vgi_bi=Vdseff_Vgi_bi*inv_Vt;
#if defined(_DERIVATE2)
  vdeff_Vgi_bi_Vgm_di=(+(+Vdseff_Vgi_bi_Vgm_di+0.0)*inv_Vt+Vdseff_Vgi_bi*0.0+Vdseff_Vgm_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgi_bi_Vgm_si=(+(+Vdseff_Vgi_bi_Vgm_si+0.0)*inv_Vt+Vdseff_Vgi_bi*0.0+Vdseff_Vgm_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgi_bi_Vdbulk_di=(+(+Vdseff_Vgi_bi_Vdbulk_di+0.0)*inv_Vt+Vdseff_Vgi_bi*0.0+Vdseff_Vdbulk_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgi_bi_Vsbulk_si=(+(+Vdseff_Vgi_bi_Vsbulk_si+0.0)*inv_Vt+Vdseff_Vgi_bi*0.0+Vdseff_Vsbulk_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgi_bi_Vdi_bi=(+(+Vdseff_Vgi_bi_Vdi_bi+0.0)*inv_Vt+Vdseff_Vgi_bi*0.0+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgi_bi_Vsi_bi=(+(+Vdseff_Vgi_bi_Vsi_bi+0.0)*inv_Vt+Vdseff_Vgi_bi*0.0+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgi_bi_Vgi_bi=(+(+Vdseff_Vgi_bi_Vgi_bi+0.0)*inv_Vt+Vdseff_Vgi_bi*0.0+Vdseff_Vgi_bi*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgi_bi_Tempt_GND=(+(+Vdseff_Vgi_bi_Tempt_GND+0.0)*inv_Vt+Vdseff_Vgi_bi*inv_Vt_Tempt_GND+Vdseff_Tempt_GND*0.0+(Vdseff+Vs)*0.0);
#endif
#if defined(_DERIVATE)
vdeff_Tempt_GND=((Vdseff_Tempt_GND*inv_Vt)+((Vdseff+Vs)*inv_Vt_Tempt_GND));
#endif
#endif
vdeff=((Vdseff+Vs)*inv_Vt);
EXIT_IF_ISNAN(((Vdseff+Vs)*inv_Vt))
{
double m00_sqrt(d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=(0.5*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_di+psip_Vgm_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_si+psip_Vgm_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgi_bi+psip_Vgi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdi_bi+psip_Vdi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsi_bi+psip_Vsi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Tempt_GND-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Tempt_GND+psip_Tempt_GND*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsbulk_si=(0.5*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_di+psip_Vgm_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_si+psip_Vgm_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgi_bi+psip_Vgi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdi_bi+psip_Vdi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsi_bi+psip_Vsi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Tempt_GND-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Tempt_GND+psip_Tempt_GND*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vgi_bi=(0.5*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vdi_bi=(0.5*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsi_bi=(0.5*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(psip_Tempt_GND+((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((psip+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psip+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T8)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T8)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=0.0;
  sqrtpsip_Vgm_di_Vgm_si=0.0;
  sqrtpsip_Vgm_di_Vdbulk_di=0.0;
  sqrtpsip_Vgm_di_Vsbulk_si=0.0;
  sqrtpsip_Vgm_di_Vgi_bi=0.0;
  sqrtpsip_Vgm_di_Vdi_bi=0.0;
  sqrtpsip_Vgm_di_Vsi_bi=0.0;
  sqrtpsip_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=0.0;
  sqrtpsip_Vgm_si_Vgm_si=0.0;
  sqrtpsip_Vgm_si_Vdbulk_di=0.0;
  sqrtpsip_Vgm_si_Vsbulk_si=0.0;
  sqrtpsip_Vgm_si_Vgi_bi=0.0;
  sqrtpsip_Vgm_si_Vdi_bi=0.0;
  sqrtpsip_Vgm_si_Vsi_bi=0.0;
  sqrtpsip_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsip_Vdbulk_di=T8_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_di);
  sqrtpsip_Vdbulk_di_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_si);
  sqrtpsip_Vdbulk_di_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdbulk_di);
  sqrtpsip_Vdbulk_di_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsbulk_si);
  sqrtpsip_Vdbulk_di_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgi_bi);
  sqrtpsip_Vdbulk_di_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdi_bi);
  sqrtpsip_Vdbulk_di_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsi_bi);
  sqrtpsip_Vdbulk_di_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Tempt_GND);
#endif
sqrtpsip_Vsbulk_si=T8_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_di);
  sqrtpsip_Vsbulk_si_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_si);
  sqrtpsip_Vsbulk_si_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdbulk_di);
  sqrtpsip_Vsbulk_si_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsbulk_si);
  sqrtpsip_Vsbulk_si_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgi_bi);
  sqrtpsip_Vsbulk_si_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdi_bi);
  sqrtpsip_Vsbulk_si_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsi_bi);
  sqrtpsip_Vsbulk_si_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Tempt_GND);
#endif
sqrtpsip_Vgi_bi=T8_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=T8_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=T8_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=T8_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=(+0.0+(gam_Vdbulk_di_Vgm_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdbulk_di=(+0.0+(gam_Vdbulk_di_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsbulk_si=(+0.0+(gam_Vdbulk_di_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdi_bi=(+0.0+(gam_Vdbulk_di_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsi_bi=(+0.0+(gam_Vdbulk_di_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Tempt_GND=(+0.0+(gam_Vdbulk_di_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgi_bi=(+0.0+(gam_Vdbulk_di_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsbulk_si=((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=(+0.0+(gam_Vsbulk_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdbulk_di=(+0.0+(gam_Vsbulk_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsbulk_si=(+0.0+(gam_Vsbulk_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdi_bi=(+0.0+(gam_Vsbulk_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsi_bi=(+0.0+(gam_Vsbulk_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Tempt_GND=(+0.0+(gam_Vsbulk_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgi_bi=(+0.0+(gam_Vsbulk_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vdi_bi=((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsi_bi=((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#endif
T9_Vgi_bi=((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#endif
T9=(1.0+(gam/(2.0*sqrtpsip)));
EXIT_IF_ISNAN((1.0+(gam/(2.0*sqrtpsip))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=((((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*0.0/gam/gam/gam);
  T0_Vdbulk_di_Vgm_si=((+0.0+(gam_Vdbulk_di_Vgm_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vgm_si/gam/gam/gam);
  T0_Vdbulk_di_Vdbulk_di=((+0.0+(gam_Vdbulk_di_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdbulk_di_Vsbulk_si=((+0.0+(gam_Vdbulk_di_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdbulk_di_Vgi_bi=((+0.0+(gam_Vdbulk_di_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vgi_bi/gam/gam/gam);
  T0_Vdbulk_di_Vdi_bi=((+0.0+(gam_Vdbulk_di_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vdi_bi/gam/gam/gam);
  T0_Vdbulk_di_Vsi_bi=((+0.0+(gam_Vdbulk_di_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vsi_bi/gam/gam/gam);
  T0_Vdbulk_di_Tempt_GND=((+0.0+(gam_Vdbulk_di_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsbulk_si=((((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*0.0/gam/gam/gam);
  T0_Vsbulk_si_Vgm_si=((+0.0+(gam_Vsbulk_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vgm_si/gam/gam/gam);
  T0_Vsbulk_si_Vdbulk_di=((+0.0+(gam_Vsbulk_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsbulk_si_Vsbulk_si=((+0.0+(gam_Vsbulk_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsbulk_si_Vgi_bi=((+0.0+(gam_Vsbulk_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vgi_bi/gam/gam/gam);
  T0_Vsbulk_si_Vdi_bi=((+0.0+(gam_Vsbulk_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vdi_bi/gam/gam/gam);
  T0_Vsbulk_si_Vsi_bi=((+0.0+(gam_Vsbulk_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vsi_bi/gam/gam/gam);
  T0_Vsbulk_si_Tempt_GND=((+0.0+(gam_Vsbulk_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vgi_bi=((((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*0.0/gam/gam/gam);
  T0_Vgi_bi_Vgm_si=((+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vgi_bi_Vdbulk_di=((+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgi_bi_Vsbulk_si=((+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgi_bi_Vgi_bi=((+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vgi_bi_Vdi_bi=((+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vgi_bi_Vsi_bi=((+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vgi_bi_Tempt_GND=((+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vdi_bi=((((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*0.0/gam/gam/gam);
  T0_Vdi_bi_Vgm_si=((+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vdi_bi_Vdbulk_di=((+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdi_bi_Vsbulk_si=((+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdi_bi_Vgi_bi=((+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vdi_bi_Vdi_bi=((+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vdi_bi_Vsi_bi=((+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vdi_bi_Tempt_GND=((+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsi_bi=((((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*0.0/gam/gam/gam);
  T0_Vsi_bi_Vgm_si=((+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vsi_bi_Vdbulk_di=((+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsi_bi_Vsbulk_si=((+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsi_bi_Vgi_bi=((+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vsi_bi_Vdi_bi=((+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vsi_bi_Vsi_bi=((+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vsi_bi_Tempt_GND=((+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Tempt_GND)/gam/gam);
#endif
#endif
T0=((1.0+(gam/(2.0*sqrtpsip)))/gam);
EXIT_IF_ISNAN(((1.0+(gam/(2.0*sqrtpsip)))/gam))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(psip_Vdbulk_di-vdeff_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+psip_Vdbulk_di_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdbulk_di_Vgm_di);
  T1_Vdbulk_di_Vgm_si=(+(+psip_Vdbulk_di_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdbulk_di_Vgm_si);
  T1_Vdbulk_di_Vdbulk_di=(+(+psip_Vdbulk_di_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdbulk_di_Vdbulk_di);
  T1_Vdbulk_di_Vsbulk_si=(+(+psip_Vdbulk_di_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdbulk_di_Vsbulk_si);
  T1_Vdbulk_di_Vgi_bi=(+(+psip_Vdbulk_di_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdbulk_di_Vgi_bi);
  T1_Vdbulk_di_Vdi_bi=(+(+psip_Vdbulk_di_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdbulk_di_Vdi_bi);
  T1_Vdbulk_di_Vsi_bi=(+(+psip_Vdbulk_di_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdbulk_di_Vsi_bi);
  T1_Vdbulk_di_Tempt_GND=(+(+psip_Vdbulk_di_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vdeff_Vdbulk_di_Tempt_GND);
#endif
T1_Vsbulk_si=(psip_Vsbulk_si-vdeff_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+psip_Vsbulk_si_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsbulk_si_Vgm_di);
  T1_Vsbulk_si_Vgm_si=(+(+psip_Vsbulk_si_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsbulk_si_Vgm_si);
  T1_Vsbulk_si_Vdbulk_di=(+(+psip_Vsbulk_si_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsbulk_si_Vdbulk_di);
  T1_Vsbulk_si_Vsbulk_si=(+(+psip_Vsbulk_si_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsbulk_si_Vsbulk_si);
  T1_Vsbulk_si_Vgi_bi=(+(+psip_Vsbulk_si_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsbulk_si_Vgi_bi);
  T1_Vsbulk_si_Vdi_bi=(+(+psip_Vsbulk_si_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsbulk_si_Vdi_bi);
  T1_Vsbulk_si_Vsi_bi=(+(+psip_Vsbulk_si_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsbulk_si_Vsi_bi);
  T1_Vsbulk_si_Tempt_GND=(+(+psip_Vsbulk_si_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vdeff_Vsbulk_si_Tempt_GND);
#endif
T1_Vgi_bi=(psip_Vgi_bi-vdeff_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+psip_Vgi_bi_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vgi_bi_Vgm_di);
  T1_Vgi_bi_Vgm_si=(+(+psip_Vgi_bi_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+(+psip_Vgi_bi_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+(+psip_Vgi_bi_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+(+psip_Vgi_bi_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+(+psip_Vgi_bi_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+(+psip_Vgi_bi_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+(+psip_Vgi_bi_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vdeff_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=(psip_Vdi_bi-vdeff_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+psip_Vdi_bi_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdi_bi_Vgm_di);
  T1_Vdi_bi_Vgm_si=(+(+psip_Vdi_bi_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+(+psip_Vdi_bi_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+(+psip_Vdi_bi_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+(+psip_Vdi_bi_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+(+psip_Vdi_bi_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+(+psip_Vdi_bi_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+(+psip_Vdi_bi_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vdeff_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=(psip_Vsi_bi-vdeff_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+psip_Vsi_bi_Vgm_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsi_bi_Vgm_di);
  T1_Vsi_bi_Vgm_si=(+(+psip_Vsi_bi_Vgm_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+(+psip_Vsi_bi_Vdbulk_di-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+(+psip_Vsi_bi_Vsbulk_si-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+(+psip_Vsi_bi_Vgi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+(+psip_Vsi_bi_Vdi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+(+psip_Vsi_bi_Vsi_bi-(+0.0*phib+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+(+psip_Vsi_bi_Tempt_GND-(+0.0*phib+0.0*phib_Tempt_GND+0.0*0.0+2.0*0.0))-vdeff_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((psip_Tempt_GND-(2.0*phib_Tempt_GND))-vdeff_Tempt_GND);
#endif
#endif
T1=((psip-(2.0*phib))-vdeff);
EXIT_IF_ISNAN(((psip-(2.0*phib))-vdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(T1_Vdbulk_di-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdbulk_di)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdbulk_di))));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+T1_Vdbulk_di_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_di));
  T2_Vdbulk_di_Vgm_si=(+T1_Vdbulk_di_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_si));
  T2_Vdbulk_di_Vdbulk_di=(+T1_Vdbulk_di_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdbulk_di));
  T2_Vdbulk_di_Vsbulk_si=(+T1_Vdbulk_di_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsbulk_si));
  T2_Vdbulk_di_Vgi_bi=(+T1_Vdbulk_di_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgi_bi));
  T2_Vdbulk_di_Vdi_bi=(+T1_Vdbulk_di_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdi_bi));
  T2_Vdbulk_di_Vsi_bi=(+T1_Vdbulk_di_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsi_bi));
  T2_Vdbulk_di_Tempt_GND=(+T1_Vdbulk_di_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Tempt_GND)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Tempt_GND));
#endif
T2_Vsbulk_si=(T1_Vsbulk_si-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsbulk_si)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsbulk_si))));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+T1_Vsbulk_si_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_di));
  T2_Vsbulk_si_Vgm_si=(+T1_Vsbulk_si_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_si));
  T2_Vsbulk_si_Vdbulk_di=(+T1_Vsbulk_si_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdbulk_di));
  T2_Vsbulk_si_Vsbulk_si=(+T1_Vsbulk_si_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsbulk_si));
  T2_Vsbulk_si_Vgi_bi=(+T1_Vsbulk_si_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgi_bi));
  T2_Vsbulk_si_Vdi_bi=(+T1_Vsbulk_si_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdi_bi));
  T2_Vsbulk_si_Vsi_bi=(+T1_Vsbulk_si_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsi_bi));
  T2_Vsbulk_si_Tempt_GND=(+T1_Vsbulk_si_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Tempt_GND)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Tempt_GND));
#endif
T2_Vgi_bi=(T1_Vgi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgi_bi))));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_di));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_si));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdbulk_di));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsbulk_si));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(T1_Vdi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdi_bi))));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_di));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_si));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdbulk_di));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsbulk_si));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(T1_Vsi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsi_bi))));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_di));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_si));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdbulk_di));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsbulk_si));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Tempt_GND)*sqrtpsip)+((4.0*T0)*sqrtpsip_Tempt_GND))));
#endif
#endif
T2=(T1-bsimbulk_lln(((4.0*T0)*sqrtpsip)));
EXIT_IF_ISNAN((T1-bsimbulk_lln(((4.0*T0)*sqrtpsip))))
{
double m00_sqrt(d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=(0.5*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_di+0.0))+0.0))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_si+0.0))+0.0))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdbulk_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdbulk_di+0.0))+0.0))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsbulk_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsbulk_si+0.0))+0.0))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Tempt_GND*(T2+0.402982)+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsbulk_si=(0.5*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_di+0.0))+0.0))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_si+0.0))+0.0))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdbulk_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdbulk_di+0.0))+0.0))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsbulk_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsbulk_si+0.0))+0.0))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Tempt_GND*(T2+0.402982)+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Tempt_GND+0.0))+0.0))));
#endif
T8_Vgi_bi=(0.5*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_di+0.0))+0.0))));
  T8_Vgi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_si+0.0))+0.0))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*(T2+0.402982)+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*(T2+0.402982)+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*(T2+0.402982)+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*(+T2_Vgi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vdi_bi=(0.5*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_di+0.0))+0.0))));
  T8_Vdi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_si+0.0))+0.0))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*(T2+0.402982)+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*(T2+0.402982)+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*(T2+0.402982)+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*(+T2_Vdi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsi_bi=(0.5*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_di+0.0))+0.0))));
  T8_Vsi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_si+0.0))+0.0))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*(T2+0.402982)+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*(T2+0.402982)+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*(T2+0.402982)+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*(+T2_Vsi_bi_Tempt_GND+0.0))+0.0))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(T2_Tempt_GND-((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((T2-0.201491)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T2-0.201491)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
sqrtpsisa_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_di_Vgm_di=0.0;
  sqrtpsisa_Vgm_di_Vgm_si=0.0;
  sqrtpsisa_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_di_Vgi_bi=0.0;
  sqrtpsisa_Vgm_di_Vdi_bi=0.0;
  sqrtpsisa_Vgm_di_Vsi_bi=0.0;
  sqrtpsisa_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisa_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_si_Vgm_di=0.0;
  sqrtpsisa_Vgm_si_Vgm_si=0.0;
  sqrtpsisa_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisa_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisa_Vgm_si_Vgi_bi=0.0;
  sqrtpsisa_Vgm_si_Vdi_bi=0.0;
  sqrtpsisa_Vgm_si_Vsi_bi=0.0;
  sqrtpsisa_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisa_Vdbulk_di=sqrtpsip_Vdbulk_di;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdbulk_di_Vgm_di=sqrtpsip_Vdbulk_di_Vgm_di;
  sqrtpsisa_Vdbulk_di_Vgm_si=sqrtpsip_Vdbulk_di_Vgm_si;
  sqrtpsisa_Vdbulk_di_Vdbulk_di=sqrtpsip_Vdbulk_di_Vdbulk_di;
  sqrtpsisa_Vdbulk_di_Vsbulk_si=sqrtpsip_Vdbulk_di_Vsbulk_si;
  sqrtpsisa_Vdbulk_di_Vgi_bi=sqrtpsip_Vdbulk_di_Vgi_bi;
  sqrtpsisa_Vdbulk_di_Vdi_bi=sqrtpsip_Vdbulk_di_Vdi_bi;
  sqrtpsisa_Vdbulk_di_Vsi_bi=sqrtpsip_Vdbulk_di_Vsi_bi;
  sqrtpsisa_Vdbulk_di_Tempt_GND=sqrtpsip_Vdbulk_di_Tempt_GND;
#endif
sqrtpsisa_Vsbulk_si=sqrtpsip_Vsbulk_si;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsbulk_si_Vgm_di=sqrtpsip_Vsbulk_si_Vgm_di;
  sqrtpsisa_Vsbulk_si_Vgm_si=sqrtpsip_Vsbulk_si_Vgm_si;
  sqrtpsisa_Vsbulk_si_Vdbulk_di=sqrtpsip_Vsbulk_si_Vdbulk_di;
  sqrtpsisa_Vsbulk_si_Vsbulk_si=sqrtpsip_Vsbulk_si_Vsbulk_si;
  sqrtpsisa_Vsbulk_si_Vgi_bi=sqrtpsip_Vsbulk_si_Vgi_bi;
  sqrtpsisa_Vsbulk_si_Vdi_bi=sqrtpsip_Vsbulk_si_Vdi_bi;
  sqrtpsisa_Vsbulk_si_Vsi_bi=sqrtpsip_Vsbulk_si_Vsi_bi;
  sqrtpsisa_Vsbulk_si_Tempt_GND=sqrtpsip_Vsbulk_si_Tempt_GND;
#endif
sqrtpsisa_Vgi_bi=sqrtpsip_Vgi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgi_bi_Vgm_di=sqrtpsip_Vgi_bi_Vgm_di;
  sqrtpsisa_Vgi_bi_Vgm_si=sqrtpsip_Vgi_bi_Vgm_si;
  sqrtpsisa_Vgi_bi_Vdbulk_di=sqrtpsip_Vgi_bi_Vdbulk_di;
  sqrtpsisa_Vgi_bi_Vsbulk_si=sqrtpsip_Vgi_bi_Vsbulk_si;
  sqrtpsisa_Vgi_bi_Vgi_bi=sqrtpsip_Vgi_bi_Vgi_bi;
  sqrtpsisa_Vgi_bi_Vdi_bi=sqrtpsip_Vgi_bi_Vdi_bi;
  sqrtpsisa_Vgi_bi_Vsi_bi=sqrtpsip_Vgi_bi_Vsi_bi;
  sqrtpsisa_Vgi_bi_Tempt_GND=sqrtpsip_Vgi_bi_Tempt_GND;
#endif
sqrtpsisa_Vdi_bi=sqrtpsip_Vdi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdi_bi_Vgm_di=sqrtpsip_Vdi_bi_Vgm_di;
  sqrtpsisa_Vdi_bi_Vgm_si=sqrtpsip_Vdi_bi_Vgm_si;
  sqrtpsisa_Vdi_bi_Vdbulk_di=sqrtpsip_Vdi_bi_Vdbulk_di;
  sqrtpsisa_Vdi_bi_Vsbulk_si=sqrtpsip_Vdi_bi_Vsbulk_si;
  sqrtpsisa_Vdi_bi_Vgi_bi=sqrtpsip_Vdi_bi_Vgi_bi;
  sqrtpsisa_Vdi_bi_Vdi_bi=sqrtpsip_Vdi_bi_Vdi_bi;
  sqrtpsisa_Vdi_bi_Vsi_bi=sqrtpsip_Vdi_bi_Vsi_bi;
  sqrtpsisa_Vdi_bi_Tempt_GND=sqrtpsip_Vdi_bi_Tempt_GND;
#endif
sqrtpsisa_Vsi_bi=sqrtpsip_Vsi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsi_bi_Vgm_di=sqrtpsip_Vsi_bi_Vgm_di;
  sqrtpsisa_Vsi_bi_Vgm_si=sqrtpsip_Vsi_bi_Vgm_si;
  sqrtpsisa_Vsi_bi_Vdbulk_di=sqrtpsip_Vsi_bi_Vdbulk_di;
  sqrtpsisa_Vsi_bi_Vsbulk_si=sqrtpsip_Vsi_bi_Vsbulk_si;
  sqrtpsisa_Vsi_bi_Vgi_bi=sqrtpsip_Vsi_bi_Vgi_bi;
  sqrtpsisa_Vsi_bi_Vdi_bi=sqrtpsip_Vsi_bi_Vdi_bi;
  sqrtpsisa_Vsi_bi_Vsi_bi=sqrtpsip_Vsi_bi_Vsi_bi;
  sqrtpsisa_Vsi_bi_Tempt_GND=sqrtpsip_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
sqrtpsisa_Tempt_GND=sqrtpsip_Tempt_GND;
#endif
#endif
sqrtpsisa=sqrtpsip;
EXIT_IF_ISNAN(sqrtpsip)
if
((T8<=(-68.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=0.0;
#endif
#endif
T4=(-100.0);
EXIT_IF_ISNAN((-100.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=20.0;
EXIT_IF_ISNAN(20.0)
if
((T8<(T4-(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T4,T4_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T4_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T4_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T4_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T4_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T4_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T4_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T4_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T4_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T4,T4_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T4_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T4_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T4_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T4_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T4_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T4_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T4_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T4_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T4,T4_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T4_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T4_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T4_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T4_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T4_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T4_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T4_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T4_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T4,T4_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T4_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T4_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T4_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T4_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T4_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T4_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T4_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T4_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T4,T4_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T4_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T4_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T4_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T4_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T4_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T4_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T4_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T4_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T4,T4_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T4);
EXIT_IF_ISNAN(bsimbulk_lexp(T4))
}
else
{
if
((T8>(T4+(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(((T8_Vdbulk_di-T4_Vdbulk_di)*T5-(T8-T4)*T5_Vdbulk_di)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=((+T8_Vdbulk_di_Vgm_di-T4_Vdbulk_di_Vgm_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5);
  T2_Vdbulk_di_Vgm_si=((+T8_Vdbulk_di_Vgm_si-T4_Vdbulk_di_Vgm_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5);
  T2_Vdbulk_di_Vdbulk_di=((+T8_Vdbulk_di_Vdbulk_di-T4_Vdbulk_di_Vdbulk_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdbulk_di_Vsbulk_si=((+T8_Vdbulk_di_Vsbulk_si-T4_Vdbulk_di_Vsbulk_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdbulk_di_Vgi_bi=((+T8_Vdbulk_di_Vgi_bi-T4_Vdbulk_di_Vgi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vdi_bi=((+T8_Vdbulk_di_Vdi_bi-T4_Vdbulk_di_Vdi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vsi_bi=((+T8_Vdbulk_di_Vsi_bi-T4_Vdbulk_di_Vsi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5);
  T2_Vdbulk_di_Tempt_GND=((+T8_Vdbulk_di_Tempt_GND-T4_Vdbulk_di_Tempt_GND)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsbulk_si=(((T8_Vsbulk_si-T4_Vsbulk_si)*T5-(T8-T4)*T5_Vsbulk_si)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=((+T8_Vsbulk_si_Vgm_di-T4_Vsbulk_si_Vgm_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5);
  T2_Vsbulk_si_Vgm_si=((+T8_Vsbulk_si_Vgm_si-T4_Vsbulk_si_Vgm_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5);
  T2_Vsbulk_si_Vdbulk_di=((+T8_Vsbulk_si_Vdbulk_di-T4_Vsbulk_si_Vdbulk_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsbulk_si_Vsbulk_si=((+T8_Vsbulk_si_Vsbulk_si-T4_Vsbulk_si_Vsbulk_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsbulk_si_Vgi_bi=((+T8_Vsbulk_si_Vgi_bi-T4_Vsbulk_si_Vgi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vdi_bi=((+T8_Vsbulk_si_Vdi_bi-T4_Vsbulk_si_Vdi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vsi_bi=((+T8_Vsbulk_si_Vsi_bi-T4_Vsbulk_si_Vsi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5);
  T2_Vsbulk_si_Tempt_GND=((+T8_Vsbulk_si_Tempt_GND-T4_Vsbulk_si_Tempt_GND)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vgi_bi=(((T8_Vgi_bi-T4_Vgi_bi)*T5-(T8-T4)*T5_Vgi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=((+T8_Vgi_bi_Vgm_di-T4_Vgi_bi_Vgm_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vgi_bi_Vgm_si=((+T8_Vgi_bi_Vgm_si-T4_Vgi_bi_Vgm_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vgi_bi_Vdbulk_di=((+T8_Vgi_bi_Vdbulk_di-T4_Vgi_bi_Vdbulk_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgi_bi_Vsbulk_si=((+T8_Vgi_bi_Vsbulk_si-T4_Vgi_bi_Vsbulk_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgi_bi_Vgi_bi=((+T8_Vgi_bi_Vgi_bi-T4_Vgi_bi_Vgi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vgi_bi_Vdi_bi=((+T8_Vgi_bi_Vdi_bi-T4_Vgi_bi_Vdi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vgi_bi_Vsi_bi=((+T8_Vgi_bi_Vsi_bi-T4_Vgi_bi_Vsi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vgi_bi_Tempt_GND=((+T8_Vgi_bi_Tempt_GND-T4_Vgi_bi_Tempt_GND)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vdi_bi=(((T8_Vdi_bi-T4_Vdi_bi)*T5-(T8-T4)*T5_Vdi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=((+T8_Vdi_bi_Vgm_di-T4_Vdi_bi_Vgm_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vdi_bi_Vgm_si=((+T8_Vdi_bi_Vgm_si-T4_Vdi_bi_Vgm_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vdi_bi_Vdbulk_di=((+T8_Vdi_bi_Vdbulk_di-T4_Vdi_bi_Vdbulk_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdi_bi_Vsbulk_si=((+T8_Vdi_bi_Vsbulk_si-T4_Vdi_bi_Vsbulk_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdi_bi_Vgi_bi=((+T8_Vdi_bi_Vgi_bi-T4_Vdi_bi_Vgi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vdi_bi_Vdi_bi=((+T8_Vdi_bi_Vdi_bi-T4_Vdi_bi_Vdi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vdi_bi_Vsi_bi=((+T8_Vdi_bi_Vsi_bi-T4_Vdi_bi_Vsi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vdi_bi_Tempt_GND=((+T8_Vdi_bi_Tempt_GND-T4_Vdi_bi_Tempt_GND)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsi_bi=(((T8_Vsi_bi-T4_Vsi_bi)*T5-(T8-T4)*T5_Vsi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=((+T8_Vsi_bi_Vgm_di-T4_Vsi_bi_Vgm_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vsi_bi_Vgm_si=((+T8_Vsi_bi_Vgm_si-T4_Vsi_bi_Vgm_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vsi_bi_Vdbulk_di=((+T8_Vsi_bi_Vdbulk_di-T4_Vsi_bi_Vdbulk_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsi_bi_Vsbulk_si=((+T8_Vsi_bi_Vsbulk_si-T4_Vsi_bi_Vsbulk_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsi_bi_Vgi_bi=((+T8_Vsi_bi_Vgi_bi-T4_Vsi_bi_Vgi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vsi_bi_Vdi_bi=((+T8_Vsi_bi_Vdi_bi-T4_Vsi_bi_Vdi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vsi_bi_Vsi_bi=((+T8_Vsi_bi_Vsi_bi-T4_Vsi_bi_Vsi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vsi_bi_Tempt_GND=((+T8_Vsi_bi_Tempt_GND-T4_Vsi_bi_Tempt_GND)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((T8_Tempt_GND-T4_Tempt_GND)*T5-(T8-T4)*T5_Tempt_GND)/T5/T5);
#endif
#endif
T2=((T8-T4)/T5);
EXIT_IF_ISNAN(((T8-T4)/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+T2_Vdbulk_di_Vgm_di*T2+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_di);
  T6_Vdbulk_di_Vgm_si=(+T2_Vdbulk_di_Vgm_si*T2+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_si);
  T6_Vdbulk_di_Vdbulk_di=(+T2_Vdbulk_di_Vdbulk_di*T2+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdbulk_di);
  T6_Vdbulk_di_Vsbulk_si=(+T2_Vdbulk_di_Vsbulk_si*T2+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsbulk_si);
  T6_Vdbulk_di_Vgi_bi=(+T2_Vdbulk_di_Vgi_bi*T2+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgi_bi);
  T6_Vdbulk_di_Vdi_bi=(+T2_Vdbulk_di_Vdi_bi*T2+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdi_bi);
  T6_Vdbulk_di_Vsi_bi=(+T2_Vdbulk_di_Vsi_bi*T2+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsi_bi);
  T6_Vdbulk_di_Tempt_GND=(+T2_Vdbulk_di_Tempt_GND*T2+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*T2_Vdbulk_di_Tempt_GND);
#endif
T6_Vsbulk_si=((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+T2_Vsbulk_si_Vgm_di*T2+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_di);
  T6_Vsbulk_si_Vgm_si=(+T2_Vsbulk_si_Vgm_si*T2+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_si);
  T6_Vsbulk_si_Vdbulk_di=(+T2_Vsbulk_si_Vdbulk_di*T2+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdbulk_di);
  T6_Vsbulk_si_Vsbulk_si=(+T2_Vsbulk_si_Vsbulk_si*T2+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsbulk_si);
  T6_Vsbulk_si_Vgi_bi=(+T2_Vsbulk_si_Vgi_bi*T2+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgi_bi);
  T6_Vsbulk_si_Vdi_bi=(+T2_Vsbulk_si_Vdi_bi*T2+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdi_bi);
  T6_Vsbulk_si_Vsi_bi=(+T2_Vsbulk_si_Vsi_bi*T2+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsi_bi);
  T6_Vsbulk_si_Tempt_GND=(+T2_Vsbulk_si_Tempt_GND*T2+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*T2_Vsbulk_si_Tempt_GND);
#endif
T6_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND));
#endif
#endif
T6=(T2*T2);
EXIT_IF_ISNAN((T2*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdbulk_di+((T5_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T4_Vdbulk_di_Vgm_si+(+T5_Vdbulk_di_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_si))+(+T6_Vdbulk_di_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_si)))))));
  T3_Vdbulk_di_Vgm_di=(+T4_Vdbulk_di_Vgm_di+(+T5_Vdbulk_di_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_di))+(+T6_Vdbulk_di_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_di)))))));
  T3_Vdbulk_di_Vdbulk_di=(+T4_Vdbulk_di_Vdbulk_di+(+T5_Vdbulk_di_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdbulk_di))+(+T6_Vdbulk_di_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdbulk_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdbulk_di)))))));
  T3_Vdbulk_di_Vsbulk_si=(+T4_Vdbulk_di_Vsbulk_si+(+T5_Vdbulk_di_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsbulk_si))+(+T6_Vdbulk_di_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsbulk_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsbulk_si)))))));
  T3_Vdbulk_di_Vgi_bi=(+T4_Vdbulk_di_Vgi_bi+(+T5_Vdbulk_di_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgi_bi))+(+T6_Vdbulk_di_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgi_bi)))))));
  T3_Vdbulk_di_Vdi_bi=(+T4_Vdbulk_di_Vdi_bi+(+T5_Vdbulk_di_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdi_bi))+(+T6_Vdbulk_di_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdi_bi)))))));
  T3_Vdbulk_di_Vsi_bi=(+T4_Vdbulk_di_Vsi_bi+(+T5_Vdbulk_di_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsi_bi))+(+T6_Vdbulk_di_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsi_bi)))))));
  T3_Vdbulk_di_Tempt_GND=(+T4_Vdbulk_di_Tempt_GND+(+T5_Vdbulk_di_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Tempt_GND))+(+T6_Vdbulk_di_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Tempt_GND*(1.25-T6)+T6_Vdbulk_di*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Tempt_GND)))))));
#endif
T3_Vsbulk_si=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsbulk_si+((T5_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T4_Vsbulk_si_Vgm_si+(+T5_Vsbulk_si_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_si))+(+T6_Vsbulk_si_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_si)))))));
  T3_Vsbulk_si_Vgm_di=(+T4_Vsbulk_si_Vgm_di+(+T5_Vsbulk_si_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_di))+(+T6_Vsbulk_si_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_di)))))));
  T3_Vsbulk_si_Vdbulk_di=(+T4_Vsbulk_si_Vdbulk_di+(+T5_Vsbulk_si_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdbulk_di))+(+T6_Vsbulk_si_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdbulk_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdbulk_di)))))));
  T3_Vsbulk_si_Vsbulk_si=(+T4_Vsbulk_si_Vsbulk_si+(+T5_Vsbulk_si_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsbulk_si))+(+T6_Vsbulk_si_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsbulk_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsbulk_si)))))));
  T3_Vsbulk_si_Vgi_bi=(+T4_Vsbulk_si_Vgi_bi+(+T5_Vsbulk_si_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgi_bi))+(+T6_Vsbulk_si_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgi_bi)))))));
  T3_Vsbulk_si_Vdi_bi=(+T4_Vsbulk_si_Vdi_bi+(+T5_Vsbulk_si_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdi_bi))+(+T6_Vsbulk_si_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdi_bi)))))));
  T3_Vsbulk_si_Vsi_bi=(+T4_Vsbulk_si_Vsi_bi+(+T5_Vsbulk_si_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsi_bi))+(+T6_Vsbulk_si_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsi_bi)))))));
  T3_Vsbulk_si_Tempt_GND=(+T4_Vsbulk_si_Tempt_GND+(+T5_Vsbulk_si_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Tempt_GND))+(+T6_Vsbulk_si_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Tempt_GND*(1.25-T6)+T6_Vsbulk_si*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Tempt_GND)))))));
#endif
T3_Vgi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgi_bi+((T5_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T4_Vgi_bi_Vgm_si+(+T5_Vgi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_si))+(+T6_Vgi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_si)))))));
  T3_Vgi_bi_Vgm_di=(+T4_Vgi_bi_Vgm_di+(+T5_Vgi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_di))+(+T6_Vgi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_di)))))));
  T3_Vgi_bi_Vdbulk_di=(+T4_Vgi_bi_Vdbulk_di+(+T5_Vgi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdbulk_di))+(+T6_Vgi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdbulk_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdbulk_di)))))));
  T3_Vgi_bi_Vsbulk_si=(+T4_Vgi_bi_Vsbulk_si+(+T5_Vgi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsbulk_si))+(+T6_Vgi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsbulk_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsbulk_si)))))));
  T3_Vgi_bi_Vgi_bi=(+T4_Vgi_bi_Vgi_bi+(+T5_Vgi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgi_bi))+(+T6_Vgi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgi_bi)))))));
  T3_Vgi_bi_Vdi_bi=(+T4_Vgi_bi_Vdi_bi+(+T5_Vgi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdi_bi))+(+T6_Vgi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdi_bi)))))));
  T3_Vgi_bi_Vsi_bi=(+T4_Vgi_bi_Vsi_bi+(+T5_Vgi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsi_bi))+(+T6_Vgi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsi_bi)))))));
  T3_Vgi_bi_Tempt_GND=(+T4_Vgi_bi_Tempt_GND+(+T5_Vgi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Tempt_GND))+(+T6_Vgi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Tempt_GND*(1.25-T6)+T6_Vgi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Tempt_GND)))))));
#endif
T3_Vdi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdi_bi+((T5_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T4_Vdi_bi_Vgm_si+(+T5_Vdi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_si))+(+T6_Vdi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_si)))))));
  T3_Vdi_bi_Vgm_di=(+T4_Vdi_bi_Vgm_di+(+T5_Vdi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_di))+(+T6_Vdi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_di)))))));
  T3_Vdi_bi_Vdbulk_di=(+T4_Vdi_bi_Vdbulk_di+(+T5_Vdi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdbulk_di))+(+T6_Vdi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdbulk_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdbulk_di)))))));
  T3_Vdi_bi_Vsbulk_si=(+T4_Vdi_bi_Vsbulk_si+(+T5_Vdi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsbulk_si))+(+T6_Vdi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsbulk_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsbulk_si)))))));
  T3_Vdi_bi_Vgi_bi=(+T4_Vdi_bi_Vgi_bi+(+T5_Vdi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgi_bi))+(+T6_Vdi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgi_bi)))))));
  T3_Vdi_bi_Vdi_bi=(+T4_Vdi_bi_Vdi_bi+(+T5_Vdi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdi_bi))+(+T6_Vdi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdi_bi)))))));
  T3_Vdi_bi_Vsi_bi=(+T4_Vdi_bi_Vsi_bi+(+T5_Vdi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsi_bi))+(+T6_Vdi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsi_bi)))))));
  T3_Vdi_bi_Tempt_GND=(+T4_Vdi_bi_Tempt_GND+(+T5_Vdi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Tempt_GND))+(+T6_Vdi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Tempt_GND*(1.25-T6)+T6_Vdi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Tempt_GND)))))));
#endif
T3_Vsi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsi_bi+((T5_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T4_Vsi_bi_Vgm_si+(+T5_Vsi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_si))+(+T6_Vsi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_si)))))));
  T3_Vsi_bi_Vgm_di=(+T4_Vsi_bi_Vgm_di+(+T5_Vsi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_di))+(+T6_Vsi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_di)))))));
  T3_Vsi_bi_Vdbulk_di=(+T4_Vsi_bi_Vdbulk_di+(+T5_Vsi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdbulk_di))+(+T6_Vsi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdbulk_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdbulk_di)))))));
  T3_Vsi_bi_Vsbulk_si=(+T4_Vsi_bi_Vsbulk_si+(+T5_Vsi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsbulk_si))+(+T6_Vsi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsbulk_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsbulk_si)))))));
  T3_Vsi_bi_Vgi_bi=(+T4_Vsi_bi_Vgi_bi+(+T5_Vsi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgi_bi))+(+T6_Vsi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgi_bi)))))));
  T3_Vsi_bi_Vdi_bi=(+T4_Vsi_bi_Vdi_bi+(+T5_Vsi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdi_bi))+(+T6_Vsi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdi_bi)))))));
  T3_Vsi_bi_Vsi_bi=(+T4_Vsi_bi_Vsi_bi+(+T5_Vsi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsi_bi))+(+T6_Vsi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsi_bi)))))));
  T3_Vsi_bi_Tempt_GND=(+T4_Vsi_bi_Tempt_GND+(+T5_Vsi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Tempt_GND))+(+T6_Vsi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Tempt_GND*(1.25-T6)+T6_Vsi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Tempt_GND)))))));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Tempt_GND+((T5_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Tempt_GND)+((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))));
#endif
#endif
T3=bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
EXIT_IF_ISNAN(bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qdeff_Vgm_si=0.0;
#if defined(_DERIVATE2)
  qdeff_Vgm_si_Vgm_si=0.0;
  qdeff_Vgm_si_Vgm_di=0.0;
  qdeff_Vgm_si_Vdbulk_di=0.0;
  qdeff_Vgm_si_Vsbulk_si=0.0;
  qdeff_Vgm_si_Vgi_bi=0.0;
  qdeff_Vgm_si_Vdi_bi=0.0;
  qdeff_Vgm_si_Vsi_bi=0.0;
  qdeff_Vgm_si_Tempt_GND=0.0;
#endif
qdeff_Vgm_di=0.0;
#if defined(_DERIVATE2)
  qdeff_Vgm_di_Vgm_si=0.0;
  qdeff_Vgm_di_Vgm_di=0.0;
  qdeff_Vgm_di_Vdbulk_di=0.0;
  qdeff_Vgm_di_Vsbulk_si=0.0;
  qdeff_Vgm_di_Vgi_bi=0.0;
  qdeff_Vgm_di_Vdi_bi=0.0;
  qdeff_Vgm_di_Vsi_bi=0.0;
  qdeff_Vgm_di_Tempt_GND=0.0;
#endif
qdeff_Vdbulk_di=((T3_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))));
#if defined(_DERIVATE2)
  qdeff_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgm_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgm_si)-T8_Vdbulk_di_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si)))));
  qdeff_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgm_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgm_di)-T8_Vdbulk_di_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di)))));
  qdeff_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdbulk_di)-T8_Vdbulk_di_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)))));
  qdeff_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsbulk_si)-T8_Vdbulk_di_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)))));
  qdeff_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgi_bi)-T8_Vdbulk_di_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi)))));
  qdeff_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdi_bi)-T8_Vdbulk_di_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi)))));
  qdeff_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsi_bi)-T8_Vdbulk_di_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi)))));
  qdeff_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Tempt_GND*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Tempt_GND)-T8_Vdbulk_di_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND)))));
#endif
qdeff_Vsbulk_si=((T3_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))));
#if defined(_DERIVATE2)
  qdeff_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgm_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgm_si)-T8_Vsbulk_si_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si)))));
  qdeff_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgm_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgm_di)-T8_Vsbulk_si_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di)))));
  qdeff_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdbulk_di)-T8_Vsbulk_si_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)))));
  qdeff_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsbulk_si)-T8_Vsbulk_si_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)))));
  qdeff_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgi_bi)-T8_Vsbulk_si_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi)))));
  qdeff_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdi_bi)-T8_Vsbulk_si_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi)))));
  qdeff_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsi_bi)-T8_Vsbulk_si_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi)))));
  qdeff_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Tempt_GND*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Tempt_GND)-T8_Vsbulk_si_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND)))));
#endif
qdeff_Vgi_bi=((T3_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))));
#if defined(_DERIVATE2)
  qdeff_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_si)-T8_Vgi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si)))));
  qdeff_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_di)-T8_Vgi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di)))));
  qdeff_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdbulk_di)-T8_Vgi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di)))));
  qdeff_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsbulk_si)-T8_Vgi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si)))));
  qdeff_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgi_bi)-T8_Vgi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi)))));
  qdeff_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdi_bi)-T8_Vgi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi)))));
  qdeff_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsi_bi)-T8_Vgi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi)))));
  qdeff_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Tempt_GND*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Tempt_GND)-T8_Vgi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND)))));
#endif
qdeff_Vdi_bi=((T3_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))));
#if defined(_DERIVATE2)
  qdeff_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_si)-T8_Vdi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si)))));
  qdeff_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_di)-T8_Vdi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di)))));
  qdeff_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdbulk_di)-T8_Vdi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di)))));
  qdeff_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsbulk_si)-T8_Vdi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si)))));
  qdeff_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgi_bi)-T8_Vdi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi)))));
  qdeff_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdi_bi)-T8_Vdi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi)))));
  qdeff_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsi_bi)-T8_Vdi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi)))));
  qdeff_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Tempt_GND*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Tempt_GND)-T8_Vdi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND)))));
#endif
qdeff_Vsi_bi=((T3_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))));
#if defined(_DERIVATE2)
  qdeff_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_si)-T8_Vsi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si)))));
  qdeff_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_di)-T8_Vsi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di)))));
  qdeff_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdbulk_di)-T8_Vsi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di)))));
  qdeff_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsbulk_si)-T8_Vsi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si)))));
  qdeff_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgi_bi)-T8_Vsi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi)))));
  qdeff_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdi_bi)-T8_Vsi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi)))));
  qdeff_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsi_bi)-T8_Vsi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi)))));
  qdeff_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Tempt_GND*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Tempt_GND)-T8_Vsi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND)))));
#endif
#if defined(_DERIVATE)
qdeff_Tempt_GND=((T3_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))));
#endif
#endif
qdeff=(T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
EXIT_IF_ISNAN((T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsisainv_Vgm_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_di_Vgm_di=0.0;
  sqrtpsisainv_Vgm_di_Vgm_si=0.0;
  sqrtpsisainv_Vgm_di_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_di_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_di_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_di_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_di_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vgm_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_si_Vgm_di=0.0;
  sqrtpsisainv_Vgm_si_Vgm_si=0.0;
  sqrtpsisainv_Vgm_si_Vdbulk_di=0.0;
  sqrtpsisainv_Vgm_si_Vsbulk_si=0.0;
  sqrtpsisainv_Vgm_si_Vgi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vdi_bi=0.0;
  sqrtpsisainv_Vgm_si_Vsi_bi=0.0;
  sqrtpsisainv_Vgm_si_Tempt_GND=0.0;
#endif
sqrtpsisainv_Vdbulk_di=(-sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdbulk_di_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsbulk_si=(-sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsbulk_si_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vgi_bi=(-sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vdi_bi=(-sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsi_bi=(-sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
#if defined(_DERIVATE)
sqrtpsisainv_Tempt_GND=(-sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa);
#endif
#endif
sqrtpsisainv=(1.0/sqrtpsisa);
EXIT_IF_ISNAN((1.0/sqrtpsisa))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=(T3_Vdbulk_di-((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si-(T4_Vdbulk_di_Vgm_si/T5-(T4_Vdbulk_di*T5_Vgm_si+T4_Vgm_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5));
  T3_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di-(T4_Vdbulk_di_Vgm_di/T5-(T4_Vdbulk_di*T5_Vgm_di+T4_Vgm_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5));
  T3_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5));
  T3_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsbulk_si=(T3_Vsbulk_si-((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si-(T4_Vsbulk_si_Vgm_si/T5-(T4_Vsbulk_si*T5_Vgm_si+T4_Vgm_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5));
  T3_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di-(T4_Vsbulk_si_Vgm_di/T5-(T4_Vsbulk_si*T5_Vgm_di+T4_Vgm_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5));
  T3_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5));
  T3_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vgi_bi=(T3_Vgi_bi-((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vdi_bi=(T3_Vdi_bi-((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsi_bi=(T3_Vsi_bi-((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T3_Tempt_GND-((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5));
#endif
#endif
T3=(T3-(T4/T5));
EXIT_IF_ISNAN((T3-(T4/T5)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=(((((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgm_si=(+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdbulk_di=(+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsbulk_si=(+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgi_bi=(+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdi_bi=(+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsi_bi=(+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Tempt_GND=(+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsbulk_si=(((((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vgi_bi=(((((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vdi_bi=(((((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsi_bi=(((((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#endif
#endif
T6=(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN((((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=(((-(((-T3_Vdbulk_di/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdbulk_di/T3/T3))))-(-((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di);
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_si);
  T7_Vdbulk_di_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_di);
  T7_Vdbulk_di_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdbulk_di);
  T7_Vdbulk_di_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsbulk_si);
  T7_Vdbulk_di_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgi_bi);
  T7_Vdbulk_di_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdi_bi);
  T7_Vdbulk_di_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsi_bi);
  T7_Vdbulk_di_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Tempt_GND);
#endif
T7_Vsbulk_si=(((-(((-T3_Vsbulk_si/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsbulk_si/T3/T3))))-(-((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si);
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_si);
  T7_Vsbulk_si_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_di);
  T7_Vsbulk_si_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdbulk_di);
  T7_Vsbulk_si_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsbulk_si);
  T7_Vsbulk_si_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgi_bi);
  T7_Vsbulk_si_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdi_bi);
  T7_Vsbulk_si_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsi_bi);
  T7_Vsbulk_si_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Tempt_GND);
#endif
T7_Vgi_bi=(((-(((-T3_Vgi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgi_bi/T3/T3))))-(-((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi);
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_si);
  T7_Vgi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_di);
  T7_Vgi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdbulk_di);
  T7_Vgi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsbulk_si);
  T7_Vgi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgi_bi);
  T7_Vgi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdi_bi);
  T7_Vgi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsi_bi);
  T7_Vgi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Tempt_GND);
#endif
T7_Vdi_bi=(((-(((-T3_Vdi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdi_bi/T3/T3))))-(-((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi);
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_si);
  T7_Vdi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_di);
  T7_Vdi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdbulk_di);
  T7_Vdi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsbulk_si);
  T7_Vdi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgi_bi);
  T7_Vdi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdi_bi);
  T7_Vdi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsi_bi);
  T7_Vdi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Tempt_GND);
#endif
T7_Vsi_bi=(((-(((-T3_Vsi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsi_bi/T3/T3))))-(-((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi);
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_si);
  T7_Vsi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_di);
  T7_Vsi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdbulk_di);
  T7_Vsi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsbulk_si);
  T7_Vsi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgi_bi);
  T7_Vsi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdi_bi);
  T7_Vsi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsi_bi);
  T7_Vsi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(((-(((-T3_Tempt_GND/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Tempt_GND/T3/T3))))-(-((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Tempt_GND);
#endif
#endif
T7=(((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
EXIT_IF_ISNAN((((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qdeff_Vgm_si=0.0;
#if defined(_DERIVATE2)
  qdeff_Vgm_si_Vgm_si=0.0;
  qdeff_Vgm_si_Vgm_di=0.0;
  qdeff_Vgm_si_Vdbulk_di=0.0;
  qdeff_Vgm_si_Vsbulk_si=0.0;
  qdeff_Vgm_si_Vgi_bi=0.0;
  qdeff_Vgm_si_Vdi_bi=0.0;
  qdeff_Vgm_si_Vsi_bi=0.0;
  qdeff_Vgm_si_Tempt_GND=0.0;
#endif
qdeff_Vgm_di=0.0;
#if defined(_DERIVATE2)
  qdeff_Vgm_di_Vgm_si=0.0;
  qdeff_Vgm_di_Vgm_di=0.0;
  qdeff_Vgm_di_Vdbulk_di=0.0;
  qdeff_Vgm_di_Vsbulk_si=0.0;
  qdeff_Vgm_di_Vgi_bi=0.0;
  qdeff_Vgm_di_Vdi_bi=0.0;
  qdeff_Vgm_di_Vsi_bi=0.0;
  qdeff_Vgm_di_Tempt_GND=0.0;
#endif
qdeff_Vdbulk_di=(T3_Vdbulk_di-((((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si-(+(T4_Vdbulk_di_Vgm_si/T5-(T4_Vdbulk_di*T5_Vgm_si+T4_Vgm_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgm_si*T7+T4_Vdbulk_di*T7_Vgm_si+T4_Vgm_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgm_si)*T5+(2.0*T5_Vdbulk_di)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di-(+(T4_Vdbulk_di_Vgm_di/T5-(T4_Vdbulk_di*T5_Vgm_di+T4_Vgm_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgm_di*T7+T4_Vdbulk_di*T7_Vgm_di+T4_Vgm_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgm_di)*T5+(2.0*T5_Vdbulk_di)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(+(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdbulk_di*T7+T4_Vdbulk_di*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdbulk_di)*T5+(2.0*T5_Vdbulk_di)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(+(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsbulk_si*T7+T4_Vdbulk_di*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsbulk_si)*T5+(2.0*T5_Vdbulk_di)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(+(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgi_bi*T7+T4_Vdbulk_di*T7_Vgi_bi+T4_Vgi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(+(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdi_bi*T7+T4_Vdbulk_di*T7_Vdi_bi+T4_Vdi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(+(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsi_bi*T7+T4_Vdbulk_di*T7_Vsi_bi+T4_Vsi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(+(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Tempt_GND*T7+T4_Vdbulk_di*T7_Tempt_GND+T4_Tempt_GND*T7_Vdbulk_di+T4*T7_Vdbulk_di_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Tempt_GND)*T5+(2.0*T5_Vdbulk_di)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vsbulk_si=(T3_Vsbulk_si-((((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si-(+(T4_Vsbulk_si_Vgm_si/T5-(T4_Vsbulk_si*T5_Vgm_si+T4_Vgm_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgm_si*T7+T4_Vsbulk_si*T7_Vgm_si+T4_Vgm_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgm_si)*T5+(2.0*T5_Vsbulk_si)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di-(+(T4_Vsbulk_si_Vgm_di/T5-(T4_Vsbulk_si*T5_Vgm_di+T4_Vgm_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgm_di*T7+T4_Vsbulk_si*T7_Vgm_di+T4_Vgm_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgm_di)*T5+(2.0*T5_Vsbulk_si)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(+(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdbulk_di*T7+T4_Vsbulk_si*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdbulk_di)*T5+(2.0*T5_Vsbulk_si)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(+(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsbulk_si*T7+T4_Vsbulk_si*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsbulk_si)*T5+(2.0*T5_Vsbulk_si)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(+(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgi_bi*T7+T4_Vsbulk_si*T7_Vgi_bi+T4_Vgi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(+(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdi_bi*T7+T4_Vsbulk_si*T7_Vdi_bi+T4_Vdi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(+(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsi_bi*T7+T4_Vsbulk_si*T7_Vsi_bi+T4_Vsi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(+(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Tempt_GND*T7+T4_Vsbulk_si*T7_Tempt_GND+T4_Tempt_GND*T7_Vsbulk_si+T4*T7_Vsbulk_si_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Tempt_GND)*T5+(2.0*T5_Vsbulk_si)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vgi_bi=(T3_Vgi_bi-((((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(+(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_si*T7+T4_Vgi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_si)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(+(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_di*T7+T4_Vgi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_di)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(+(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdbulk_di*T7+T4_Vgi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdbulk_di)*T5+(2.0*T5_Vgi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(+(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsbulk_si*T7+T4_Vgi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsbulk_si)*T5+(2.0*T5_Vgi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(+(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgi_bi*T7+T4_Vgi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(+(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdi_bi*T7+T4_Vgi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(+(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsi_bi*T7+T4_Vgi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(+(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Tempt_GND*T7+T4_Vgi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vgi_bi+T4*T7_Vgi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Tempt_GND)*T5+(2.0*T5_Vgi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vdi_bi=(T3_Vdi_bi-((((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(+(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_si*T7+T4_Vdi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_si)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(+(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_di*T7+T4_Vdi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_di)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(+(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdbulk_di*T7+T4_Vdi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdbulk_di)*T5+(2.0*T5_Vdi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(+(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsbulk_si*T7+T4_Vdi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsbulk_si)*T5+(2.0*T5_Vdi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(+(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgi_bi*T7+T4_Vdi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(+(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdi_bi*T7+T4_Vdi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(+(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsi_bi*T7+T4_Vdi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(+(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Tempt_GND*T7+T4_Vdi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vdi_bi+T4*T7_Vdi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Tempt_GND)*T5+(2.0*T5_Vdi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vsi_bi=(T3_Vsi_bi-((((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(+(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_si*T7+T4_Vsi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_si)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(+(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_di*T7+T4_Vsi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_di)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(+(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdbulk_di*T7+T4_Vsi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdbulk_di)*T5+(2.0*T5_Vsi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(+(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsbulk_si*T7+T4_Vsi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsbulk_si)*T5+(2.0*T5_Vsi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(+(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgi_bi*T7+T4_Vsi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(+(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdi_bi*T7+T4_Vsi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(+(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsi_bi*T7+T4_Vsi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(+(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Tempt_GND*T7+T4_Vsi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vsi_bi+T4*T7_Vsi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Tempt_GND)*T5+(2.0*T5_Vsi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#if defined(_DERIVATE)
qdeff_Tempt_GND=(T3_Tempt_GND-((((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Tempt_GND)*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#endif
qdeff=(T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
EXIT_IF_ISNAN((T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
psiavg_Vgm_di=0.0;
#if defined(_DERIVATE2)
  psiavg_Vgm_di_Vgm_di=0.0;
  psiavg_Vgm_di_Vgm_si=0.0;
  psiavg_Vgm_di_Vdbulk_di=0.0;
  psiavg_Vgm_di_Vsbulk_si=0.0;
  psiavg_Vgm_di_Vgi_bi=0.0;
  psiavg_Vgm_di_Vdi_bi=0.0;
  psiavg_Vgm_di_Vsi_bi=0.0;
  psiavg_Vgm_di_Tempt_GND=0.0;
#endif
psiavg_Vgm_si=0.0;
#if defined(_DERIVATE2)
  psiavg_Vgm_si_Vgm_di=0.0;
  psiavg_Vgm_si_Vgm_si=0.0;
  psiavg_Vgm_si_Vdbulk_di=0.0;
  psiavg_Vgm_si_Vsbulk_si=0.0;
  psiavg_Vgm_si_Vgi_bi=0.0;
  psiavg_Vgm_si_Vdi_bi=0.0;
  psiavg_Vgm_si_Vsi_bi=0.0;
  psiavg_Vgm_si_Tempt_GND=0.0;
#endif
psiavg_Vdbulk_di=((psip_Vdbulk_di-qs_Vdbulk_di)-qdeff_Vdbulk_di);
#if defined(_DERIVATE2)
  psiavg_Vdbulk_di_Vgm_di=(+(+(+psip_Vdbulk_di_Vgm_di-qs_Vdbulk_di_Vgm_di)-qdeff_Vdbulk_di_Vgm_di)-0.0);
  psiavg_Vdbulk_di_Vgm_si=(+(+(+psip_Vdbulk_di_Vgm_si-qs_Vdbulk_di_Vgm_si)-qdeff_Vdbulk_di_Vgm_si)-0.0);
  psiavg_Vdbulk_di_Vdbulk_di=(+(+(+psip_Vdbulk_di_Vdbulk_di-qs_Vdbulk_di_Vdbulk_di)-qdeff_Vdbulk_di_Vdbulk_di)-0.0);
  psiavg_Vdbulk_di_Vsbulk_si=(+(+(+psip_Vdbulk_di_Vsbulk_si-qs_Vdbulk_di_Vsbulk_si)-qdeff_Vdbulk_di_Vsbulk_si)-0.0);
  psiavg_Vdbulk_di_Vgi_bi=(+(+(+psip_Vdbulk_di_Vgi_bi-qs_Vdbulk_di_Vgi_bi)-qdeff_Vdbulk_di_Vgi_bi)-0.0);
  psiavg_Vdbulk_di_Vdi_bi=(+(+(+psip_Vdbulk_di_Vdi_bi-qs_Vdbulk_di_Vdi_bi)-qdeff_Vdbulk_di_Vdi_bi)-0.0);
  psiavg_Vdbulk_di_Vsi_bi=(+(+(+psip_Vdbulk_di_Vsi_bi-qs_Vdbulk_di_Vsi_bi)-qdeff_Vdbulk_di_Vsi_bi)-0.0);
  psiavg_Vdbulk_di_Tempt_GND=(+(+(+psip_Vdbulk_di_Tempt_GND-qs_Vdbulk_di_Tempt_GND)-qdeff_Vdbulk_di_Tempt_GND)-0.0);
#endif
psiavg_Vsbulk_si=((psip_Vsbulk_si-qs_Vsbulk_si)-qdeff_Vsbulk_si);
#if defined(_DERIVATE2)
  psiavg_Vsbulk_si_Vgm_di=(+(+(+psip_Vsbulk_si_Vgm_di-qs_Vsbulk_si_Vgm_di)-qdeff_Vsbulk_si_Vgm_di)-0.0);
  psiavg_Vsbulk_si_Vgm_si=(+(+(+psip_Vsbulk_si_Vgm_si-qs_Vsbulk_si_Vgm_si)-qdeff_Vsbulk_si_Vgm_si)-0.0);
  psiavg_Vsbulk_si_Vdbulk_di=(+(+(+psip_Vsbulk_si_Vdbulk_di-qs_Vsbulk_si_Vdbulk_di)-qdeff_Vsbulk_si_Vdbulk_di)-0.0);
  psiavg_Vsbulk_si_Vsbulk_si=(+(+(+psip_Vsbulk_si_Vsbulk_si-qs_Vsbulk_si_Vsbulk_si)-qdeff_Vsbulk_si_Vsbulk_si)-0.0);
  psiavg_Vsbulk_si_Vgi_bi=(+(+(+psip_Vsbulk_si_Vgi_bi-qs_Vsbulk_si_Vgi_bi)-qdeff_Vsbulk_si_Vgi_bi)-0.0);
  psiavg_Vsbulk_si_Vdi_bi=(+(+(+psip_Vsbulk_si_Vdi_bi-qs_Vsbulk_si_Vdi_bi)-qdeff_Vsbulk_si_Vdi_bi)-0.0);
  psiavg_Vsbulk_si_Vsi_bi=(+(+(+psip_Vsbulk_si_Vsi_bi-qs_Vsbulk_si_Vsi_bi)-qdeff_Vsbulk_si_Vsi_bi)-0.0);
  psiavg_Vsbulk_si_Tempt_GND=(+(+(+psip_Vsbulk_si_Tempt_GND-qs_Vsbulk_si_Tempt_GND)-qdeff_Vsbulk_si_Tempt_GND)-0.0);
#endif
psiavg_Vgi_bi=((psip_Vgi_bi-qs_Vgi_bi)-qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  psiavg_Vgi_bi_Vgm_di=(+(+(+psip_Vgi_bi_Vgm_di-qs_Vgi_bi_Vgm_di)-qdeff_Vgi_bi_Vgm_di)-0.0);
  psiavg_Vgi_bi_Vgm_si=(+(+(+psip_Vgi_bi_Vgm_si-qs_Vgi_bi_Vgm_si)-qdeff_Vgi_bi_Vgm_si)-0.0);
  psiavg_Vgi_bi_Vdbulk_di=(+(+(+psip_Vgi_bi_Vdbulk_di-qs_Vgi_bi_Vdbulk_di)-qdeff_Vgi_bi_Vdbulk_di)-0.0);
  psiavg_Vgi_bi_Vsbulk_si=(+(+(+psip_Vgi_bi_Vsbulk_si-qs_Vgi_bi_Vsbulk_si)-qdeff_Vgi_bi_Vsbulk_si)-0.0);
  psiavg_Vgi_bi_Vgi_bi=(+(+(+psip_Vgi_bi_Vgi_bi-qs_Vgi_bi_Vgi_bi)-qdeff_Vgi_bi_Vgi_bi)-0.0);
  psiavg_Vgi_bi_Vdi_bi=(+(+(+psip_Vgi_bi_Vdi_bi-qs_Vgi_bi_Vdi_bi)-qdeff_Vgi_bi_Vdi_bi)-0.0);
  psiavg_Vgi_bi_Vsi_bi=(+(+(+psip_Vgi_bi_Vsi_bi-qs_Vgi_bi_Vsi_bi)-qdeff_Vgi_bi_Vsi_bi)-0.0);
  psiavg_Vgi_bi_Tempt_GND=(+(+(+psip_Vgi_bi_Tempt_GND-qs_Vgi_bi_Tempt_GND)-qdeff_Vgi_bi_Tempt_GND)-0.0);
#endif
psiavg_Vdi_bi=((psip_Vdi_bi-qs_Vdi_bi)-qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  psiavg_Vdi_bi_Vgm_di=(+(+(+psip_Vdi_bi_Vgm_di-qs_Vdi_bi_Vgm_di)-qdeff_Vdi_bi_Vgm_di)-0.0);
  psiavg_Vdi_bi_Vgm_si=(+(+(+psip_Vdi_bi_Vgm_si-qs_Vdi_bi_Vgm_si)-qdeff_Vdi_bi_Vgm_si)-0.0);
  psiavg_Vdi_bi_Vdbulk_di=(+(+(+psip_Vdi_bi_Vdbulk_di-qs_Vdi_bi_Vdbulk_di)-qdeff_Vdi_bi_Vdbulk_di)-0.0);
  psiavg_Vdi_bi_Vsbulk_si=(+(+(+psip_Vdi_bi_Vsbulk_si-qs_Vdi_bi_Vsbulk_si)-qdeff_Vdi_bi_Vsbulk_si)-0.0);
  psiavg_Vdi_bi_Vgi_bi=(+(+(+psip_Vdi_bi_Vgi_bi-qs_Vdi_bi_Vgi_bi)-qdeff_Vdi_bi_Vgi_bi)-0.0);
  psiavg_Vdi_bi_Vdi_bi=(+(+(+psip_Vdi_bi_Vdi_bi-qs_Vdi_bi_Vdi_bi)-qdeff_Vdi_bi_Vdi_bi)-0.0);
  psiavg_Vdi_bi_Vsi_bi=(+(+(+psip_Vdi_bi_Vsi_bi-qs_Vdi_bi_Vsi_bi)-qdeff_Vdi_bi_Vsi_bi)-0.0);
  psiavg_Vdi_bi_Tempt_GND=(+(+(+psip_Vdi_bi_Tempt_GND-qs_Vdi_bi_Tempt_GND)-qdeff_Vdi_bi_Tempt_GND)-0.0);
#endif
psiavg_Vsi_bi=((psip_Vsi_bi-qs_Vsi_bi)-qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  psiavg_Vsi_bi_Vgm_di=(+(+(+psip_Vsi_bi_Vgm_di-qs_Vsi_bi_Vgm_di)-qdeff_Vsi_bi_Vgm_di)-0.0);
  psiavg_Vsi_bi_Vgm_si=(+(+(+psip_Vsi_bi_Vgm_si-qs_Vsi_bi_Vgm_si)-qdeff_Vsi_bi_Vgm_si)-0.0);
  psiavg_Vsi_bi_Vdbulk_di=(+(+(+psip_Vsi_bi_Vdbulk_di-qs_Vsi_bi_Vdbulk_di)-qdeff_Vsi_bi_Vdbulk_di)-0.0);
  psiavg_Vsi_bi_Vsbulk_si=(+(+(+psip_Vsi_bi_Vsbulk_si-qs_Vsi_bi_Vsbulk_si)-qdeff_Vsi_bi_Vsbulk_si)-0.0);
  psiavg_Vsi_bi_Vgi_bi=(+(+(+psip_Vsi_bi_Vgi_bi-qs_Vsi_bi_Vgi_bi)-qdeff_Vsi_bi_Vgi_bi)-0.0);
  psiavg_Vsi_bi_Vdi_bi=(+(+(+psip_Vsi_bi_Vdi_bi-qs_Vsi_bi_Vdi_bi)-qdeff_Vsi_bi_Vdi_bi)-0.0);
  psiavg_Vsi_bi_Vsi_bi=(+(+(+psip_Vsi_bi_Vsi_bi-qs_Vsi_bi_Vsi_bi)-qdeff_Vsi_bi_Vsi_bi)-0.0);
  psiavg_Vsi_bi_Tempt_GND=(+(+(+psip_Vsi_bi_Tempt_GND-qs_Vsi_bi_Tempt_GND)-qdeff_Vsi_bi_Tempt_GND)-0.0);
#endif
#if defined(_DERIVATE)
psiavg_Tempt_GND=((psip_Tempt_GND-qs_Tempt_GND)-qdeff_Tempt_GND);
#endif
#endif
psiavg=(((psip-qs)-qdeff)-1.0);
EXIT_IF_ISNAN((((psip-qs)-qdeff)-1.0))
{
double m00_sqrt(d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(0.5*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vsbulk_si=(0.5*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vgi_bi=(0.5*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vdi_bi=(0.5*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vsi_bi=(0.5*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(0.5*(psiavg_Tempt_GND+((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND))*d10_sqrt0));
#endif
#endif
T0=(0.5*((psiavg+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psiavg+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T0)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=T0_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vgm_di);
  T2_Vdbulk_di_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vgm_si);
  T2_Vdbulk_di_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vdbulk_di);
  T2_Vdbulk_di_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vsbulk_si);
  T2_Vdbulk_di_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vgi_bi);
  T2_Vdbulk_di_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vdi_bi);
  T2_Vdbulk_di_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vsi_bi);
  T2_Vdbulk_di_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Tempt_GND);
#endif
T2_Vsbulk_si=T0_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vgm_di);
  T2_Vsbulk_si_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vgm_si);
  T2_Vsbulk_si_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vdbulk_di);
  T2_Vsbulk_si_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vsbulk_si);
  T2_Vsbulk_si_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vgi_bi);
  T2_Vsbulk_si_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vdi_bi);
  T2_Vsbulk_si_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vsi_bi);
  T2_Vsbulk_si_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Tempt_GND);
#endif
T2_Vgi_bi=T0_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=T0_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=T0_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=T0_Tempt_GND*d10_sqrt0;
#endif
#endif
T2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=((gam_Vdbulk_di*(sqrtpsip+T2)-gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+(+0.0+0.0)+(gam_Vdbulk_di_Vgm_si/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vgm_si+T2_Vdbulk_di_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdbulk_di_Vgm_di=(+(+0.0+0.0)+(0.0/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vgm_di+T2_Vdbulk_di_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdbulk_di_Vdbulk_di=(+(+0.0+0.0)+(gam_Vdbulk_di_Vdbulk_di/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vdbulk_di+T2_Vdbulk_di_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdbulk_di_Vsbulk_si=(+(+0.0+0.0)+(gam_Vdbulk_di_Vsbulk_si/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vsbulk_si+T2_Vdbulk_di_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdbulk_di_Vgi_bi=(+(+0.0+0.0)+(gam_Vdbulk_di_Vgi_bi/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vgi_bi+T2_Vdbulk_di_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdbulk_di_Vdi_bi=(+(+0.0+0.0)+(gam_Vdbulk_di_Vdi_bi/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vdi_bi+T2_Vdbulk_di_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdbulk_di_Vsi_bi=(+(+0.0+0.0)+(gam_Vdbulk_di_Vsi_bi/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vsi_bi+T2_Vdbulk_di_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdbulk_di_Tempt_GND=(+(+0.0+0.0)+(gam_Vdbulk_di_Tempt_GND/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Tempt_GND+T2_Vdbulk_di_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
T3_Vsbulk_si=((gam_Vsbulk_si*(sqrtpsip+T2)-gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+(+0.0+0.0)+(gam_Vsbulk_si_Vgm_si/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vgm_si+T2_Vsbulk_si_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsbulk_si_Vgm_di=(+(+0.0+0.0)+(0.0/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vgm_di+T2_Vsbulk_si_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsbulk_si_Vdbulk_di=(+(+0.0+0.0)+(gam_Vsbulk_si_Vdbulk_di/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vdbulk_di+T2_Vsbulk_si_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsbulk_si_Vsbulk_si=(+(+0.0+0.0)+(gam_Vsbulk_si_Vsbulk_si/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vsbulk_si+T2_Vsbulk_si_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsbulk_si_Vgi_bi=(+(+0.0+0.0)+(gam_Vsbulk_si_Vgi_bi/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vgi_bi+T2_Vsbulk_si_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsbulk_si_Vdi_bi=(+(+0.0+0.0)+(gam_Vsbulk_si_Vdi_bi/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vdi_bi+T2_Vsbulk_si_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsbulk_si_Vsi_bi=(+(+0.0+0.0)+(gam_Vsbulk_si_Vsi_bi/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vsi_bi+T2_Vsbulk_si_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsbulk_si_Tempt_GND=(+(+0.0+0.0)+(gam_Vsbulk_si_Tempt_GND/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Tempt_GND+T2_Vsbulk_si_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
T3_Vgi_bi=((gam_Vgi_bi*(sqrtpsip+T2)-gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+0.0+0.0)+(gam_Vgi_bi_Vgm_si/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vgm_si+T2_Vgi_bi_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vgi_bi_Vgm_di=(+(+0.0+0.0)+(0.0/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vgm_di+T2_Vgi_bi_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vgi_bi_Vdbulk_di=(+(+0.0+0.0)+(gam_Vgi_bi_Vdbulk_di/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vdbulk_di+T2_Vgi_bi_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vgi_bi_Vsbulk_si=(+(+0.0+0.0)+(gam_Vgi_bi_Vsbulk_si/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vsbulk_si+T2_Vgi_bi_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vgi_bi_Vgi_bi=(+(+0.0+0.0)+(gam_Vgi_bi_Vgi_bi/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vgi_bi+T2_Vgi_bi_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vgi_bi_Vdi_bi=(+(+0.0+0.0)+(gam_Vgi_bi_Vdi_bi/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vdi_bi+T2_Vgi_bi_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vgi_bi_Vsi_bi=(+(+0.0+0.0)+(gam_Vgi_bi_Vsi_bi/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vsi_bi+T2_Vgi_bi_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vgi_bi_Tempt_GND=(+(+0.0+0.0)+(gam_Vgi_bi_Tempt_GND/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Tempt_GND+T2_Vgi_bi_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
T3_Vdi_bi=((gam_Vdi_bi*(sqrtpsip+T2)-gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+0.0+0.0)+(gam_Vdi_bi_Vgm_si/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vgm_si+T2_Vdi_bi_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdi_bi_Vgm_di=(+(+0.0+0.0)+(0.0/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vgm_di+T2_Vdi_bi_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdi_bi_Vdbulk_di=(+(+0.0+0.0)+(gam_Vdi_bi_Vdbulk_di/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vdbulk_di+T2_Vdi_bi_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdi_bi_Vsbulk_si=(+(+0.0+0.0)+(gam_Vdi_bi_Vsbulk_si/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vsbulk_si+T2_Vdi_bi_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdi_bi_Vgi_bi=(+(+0.0+0.0)+(gam_Vdi_bi_Vgi_bi/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vgi_bi+T2_Vdi_bi_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdi_bi_Vdi_bi=(+(+0.0+0.0)+(gam_Vdi_bi_Vdi_bi/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vdi_bi+T2_Vdi_bi_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdi_bi_Vsi_bi=(+(+0.0+0.0)+(gam_Vdi_bi_Vsi_bi/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vsi_bi+T2_Vdi_bi_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vdi_bi_Tempt_GND=(+(+0.0+0.0)+(gam_Vdi_bi_Tempt_GND/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Tempt_GND+T2_Vdi_bi_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
T3_Vsi_bi=((gam_Vsi_bi*(sqrtpsip+T2)-gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+0.0+0.0)+(gam_Vsi_bi_Vgm_si/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vgm_si+T2_Vsi_bi_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsi_bi_Vgm_di=(+(+0.0+0.0)+(0.0/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vgm_di+T2_Vsi_bi_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsi_bi_Vdbulk_di=(+(+0.0+0.0)+(gam_Vsi_bi_Vdbulk_di/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vdbulk_di+T2_Vsi_bi_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsi_bi_Vsbulk_si=(+(+0.0+0.0)+(gam_Vsi_bi_Vsbulk_si/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vsbulk_si+T2_Vsi_bi_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsi_bi_Vgi_bi=(+(+0.0+0.0)+(gam_Vsi_bi_Vgi_bi/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vgi_bi+T2_Vsi_bi_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsi_bi_Vdi_bi=(+(+0.0+0.0)+(gam_Vsi_bi_Vdi_bi/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vdi_bi+T2_Vsi_bi_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsi_bi_Vsi_bi=(+(+0.0+0.0)+(gam_Vsi_bi_Vsi_bi/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vsi_bi+T2_Vsi_bi_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  T3_Vsi_bi_Tempt_GND=(+(+0.0+0.0)+(gam_Vsi_bi_Tempt_GND/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Tempt_GND+T2_Vsi_bi_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=((gam_Tempt_GND*(sqrtpsip+T2)-gam*(sqrtpsip_Tempt_GND+T2_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2));
#endif
#endif
T3=((1.0+DPD)+(gam/(sqrtpsip+T2)));
EXIT_IF_ISNAN(((1.0+DPD)+(gam/(sqrtpsip+T2))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=(((DPD*T2_Vdbulk_di)*inv_gam)+((DPD*T2)*inv_gam_Vdbulk_di));
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdbulk_di+DPD*T2_Vdbulk_di_Vgm_si)*inv_gam+(DPD*T2_Vdbulk_di)*inv_gam_Vgm_si+((DPD*T2_Vgm_si))*inv_gam_Vdbulk_di+(DPD*T2)*inv_gam_Vdbulk_di_Vgm_si));
  T4_Vdbulk_di_Vgm_di=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdbulk_di+DPD*T2_Vdbulk_di_Vgm_di)*inv_gam+(DPD*T2_Vdbulk_di)*0.0+((DPD*T2_Vgm_di))*inv_gam_Vdbulk_di+(DPD*T2)*0.0));
  T4_Vdbulk_di_Vdbulk_di=(+0.0+(+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdbulk_di+DPD*T2_Vdbulk_di_Vdbulk_di)*inv_gam+(DPD*T2_Vdbulk_di)*inv_gam_Vdbulk_di+((DPD*T2_Vdbulk_di))*inv_gam_Vdbulk_di+(DPD*T2)*inv_gam_Vdbulk_di_Vdbulk_di));
  T4_Vdbulk_di_Vsbulk_si=(+0.0+(+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdbulk_di+DPD*T2_Vdbulk_di_Vsbulk_si)*inv_gam+(DPD*T2_Vdbulk_di)*inv_gam_Vsbulk_si+((DPD*T2_Vsbulk_si))*inv_gam_Vdbulk_di+(DPD*T2)*inv_gam_Vdbulk_di_Vsbulk_si));
  T4_Vdbulk_di_Vgi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdbulk_di+DPD*T2_Vdbulk_di_Vgi_bi)*inv_gam+(DPD*T2_Vdbulk_di)*inv_gam_Vgi_bi+((DPD*T2_Vgi_bi))*inv_gam_Vdbulk_di+(DPD*T2)*inv_gam_Vdbulk_di_Vgi_bi));
  T4_Vdbulk_di_Vdi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdbulk_di+DPD*T2_Vdbulk_di_Vdi_bi)*inv_gam+(DPD*T2_Vdbulk_di)*inv_gam_Vdi_bi+((DPD*T2_Vdi_bi))*inv_gam_Vdbulk_di+(DPD*T2)*inv_gam_Vdbulk_di_Vdi_bi));
  T4_Vdbulk_di_Vsi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdbulk_di+DPD*T2_Vdbulk_di_Vsi_bi)*inv_gam+(DPD*T2_Vdbulk_di)*inv_gam_Vsi_bi+((DPD*T2_Vsi_bi))*inv_gam_Vdbulk_di+(DPD*T2)*inv_gam_Vdbulk_di_Vsi_bi));
  T4_Vdbulk_di_Tempt_GND=(+0.0+(+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdbulk_di+DPD*T2_Vdbulk_di_Tempt_GND)*inv_gam+(DPD*T2_Vdbulk_di)*inv_gam_Tempt_GND+((DPD*T2_Tempt_GND))*inv_gam_Vdbulk_di+(DPD*T2)*inv_gam_Vdbulk_di_Tempt_GND));
#endif
T4_Vsbulk_si=(((DPD*T2_Vsbulk_si)*inv_gam)+((DPD*T2)*inv_gam_Vsbulk_si));
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsbulk_si+DPD*T2_Vsbulk_si_Vgm_si)*inv_gam+(DPD*T2_Vsbulk_si)*inv_gam_Vgm_si+((DPD*T2_Vgm_si))*inv_gam_Vsbulk_si+(DPD*T2)*inv_gam_Vsbulk_si_Vgm_si));
  T4_Vsbulk_si_Vgm_di=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsbulk_si+DPD*T2_Vsbulk_si_Vgm_di)*inv_gam+(DPD*T2_Vsbulk_si)*0.0+((DPD*T2_Vgm_di))*inv_gam_Vsbulk_si+(DPD*T2)*0.0));
  T4_Vsbulk_si_Vdbulk_di=(+0.0+(+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsbulk_si+DPD*T2_Vsbulk_si_Vdbulk_di)*inv_gam+(DPD*T2_Vsbulk_si)*inv_gam_Vdbulk_di+((DPD*T2_Vdbulk_di))*inv_gam_Vsbulk_si+(DPD*T2)*inv_gam_Vsbulk_si_Vdbulk_di));
  T4_Vsbulk_si_Vsbulk_si=(+0.0+(+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsbulk_si+DPD*T2_Vsbulk_si_Vsbulk_si)*inv_gam+(DPD*T2_Vsbulk_si)*inv_gam_Vsbulk_si+((DPD*T2_Vsbulk_si))*inv_gam_Vsbulk_si+(DPD*T2)*inv_gam_Vsbulk_si_Vsbulk_si));
  T4_Vsbulk_si_Vgi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsbulk_si+DPD*T2_Vsbulk_si_Vgi_bi)*inv_gam+(DPD*T2_Vsbulk_si)*inv_gam_Vgi_bi+((DPD*T2_Vgi_bi))*inv_gam_Vsbulk_si+(DPD*T2)*inv_gam_Vsbulk_si_Vgi_bi));
  T4_Vsbulk_si_Vdi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsbulk_si+DPD*T2_Vsbulk_si_Vdi_bi)*inv_gam+(DPD*T2_Vsbulk_si)*inv_gam_Vdi_bi+((DPD*T2_Vdi_bi))*inv_gam_Vsbulk_si+(DPD*T2)*inv_gam_Vsbulk_si_Vdi_bi));
  T4_Vsbulk_si_Vsi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsbulk_si+DPD*T2_Vsbulk_si_Vsi_bi)*inv_gam+(DPD*T2_Vsbulk_si)*inv_gam_Vsi_bi+((DPD*T2_Vsi_bi))*inv_gam_Vsbulk_si+(DPD*T2)*inv_gam_Vsbulk_si_Vsi_bi));
  T4_Vsbulk_si_Tempt_GND=(+0.0+(+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsbulk_si+DPD*T2_Vsbulk_si_Tempt_GND)*inv_gam+(DPD*T2_Vsbulk_si)*inv_gam_Tempt_GND+((DPD*T2_Tempt_GND))*inv_gam_Vsbulk_si+(DPD*T2)*inv_gam_Vsbulk_si_Tempt_GND));
#endif
T4_Vgi_bi=(((DPD*T2_Vgi_bi)*inv_gam)+((DPD*T2)*inv_gam_Vgi_bi));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgi_bi+DPD*T2_Vgi_bi_Vgm_si)*inv_gam+(DPD*T2_Vgi_bi)*inv_gam_Vgm_si+((DPD*T2_Vgm_si))*inv_gam_Vgi_bi+(DPD*T2)*inv_gam_Vgi_bi_Vgm_si));
  T4_Vgi_bi_Vgm_di=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgi_bi+DPD*T2_Vgi_bi_Vgm_di)*inv_gam+(DPD*T2_Vgi_bi)*0.0+((DPD*T2_Vgm_di))*inv_gam_Vgi_bi+(DPD*T2)*0.0));
  T4_Vgi_bi_Vdbulk_di=(+0.0+(+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+DPD*T2_Vgi_bi_Vdbulk_di)*inv_gam+(DPD*T2_Vgi_bi)*inv_gam_Vdbulk_di+((DPD*T2_Vdbulk_di))*inv_gam_Vgi_bi+(DPD*T2)*inv_gam_Vgi_bi_Vdbulk_di));
  T4_Vgi_bi_Vsbulk_si=(+0.0+(+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+DPD*T2_Vgi_bi_Vsbulk_si)*inv_gam+(DPD*T2_Vgi_bi)*inv_gam_Vsbulk_si+((DPD*T2_Vsbulk_si))*inv_gam_Vgi_bi+(DPD*T2)*inv_gam_Vgi_bi_Vsbulk_si));
  T4_Vgi_bi_Vgi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+DPD*T2_Vgi_bi_Vgi_bi)*inv_gam+(DPD*T2_Vgi_bi)*inv_gam_Vgi_bi+((DPD*T2_Vgi_bi))*inv_gam_Vgi_bi+(DPD*T2)*inv_gam_Vgi_bi_Vgi_bi));
  T4_Vgi_bi_Vdi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+DPD*T2_Vgi_bi_Vdi_bi)*inv_gam+(DPD*T2_Vgi_bi)*inv_gam_Vdi_bi+((DPD*T2_Vdi_bi))*inv_gam_Vgi_bi+(DPD*T2)*inv_gam_Vgi_bi_Vdi_bi));
  T4_Vgi_bi_Vsi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+DPD*T2_Vgi_bi_Vsi_bi)*inv_gam+(DPD*T2_Vgi_bi)*inv_gam_Vsi_bi+((DPD*T2_Vsi_bi))*inv_gam_Vgi_bi+(DPD*T2)*inv_gam_Vgi_bi_Vsi_bi));
  T4_Vgi_bi_Tempt_GND=(+0.0+(+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+DPD*T2_Vgi_bi_Tempt_GND)*inv_gam+(DPD*T2_Vgi_bi)*inv_gam_Tempt_GND+((DPD*T2_Tempt_GND))*inv_gam_Vgi_bi+(DPD*T2)*inv_gam_Vgi_bi_Tempt_GND));
#endif
T4_Vdi_bi=(((DPD*T2_Vdi_bi)*inv_gam)+((DPD*T2)*inv_gam_Vdi_bi));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+DPD*T2_Vdi_bi_Vgm_si)*inv_gam+(DPD*T2_Vdi_bi)*inv_gam_Vgm_si+((DPD*T2_Vgm_si))*inv_gam_Vdi_bi+(DPD*T2)*inv_gam_Vdi_bi_Vgm_si));
  T4_Vdi_bi_Vgm_di=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+DPD*T2_Vdi_bi_Vgm_di)*inv_gam+(DPD*T2_Vdi_bi)*0.0+((DPD*T2_Vgm_di))*inv_gam_Vdi_bi+(DPD*T2)*0.0));
  T4_Vdi_bi_Vdbulk_di=(+0.0+(+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+DPD*T2_Vdi_bi_Vdbulk_di)*inv_gam+(DPD*T2_Vdi_bi)*inv_gam_Vdbulk_di+((DPD*T2_Vdbulk_di))*inv_gam_Vdi_bi+(DPD*T2)*inv_gam_Vdi_bi_Vdbulk_di));
  T4_Vdi_bi_Vsbulk_si=(+0.0+(+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+DPD*T2_Vdi_bi_Vsbulk_si)*inv_gam+(DPD*T2_Vdi_bi)*inv_gam_Vsbulk_si+((DPD*T2_Vsbulk_si))*inv_gam_Vdi_bi+(DPD*T2)*inv_gam_Vdi_bi_Vsbulk_si));
  T4_Vdi_bi_Vgi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+DPD*T2_Vdi_bi_Vgi_bi)*inv_gam+(DPD*T2_Vdi_bi)*inv_gam_Vgi_bi+((DPD*T2_Vgi_bi))*inv_gam_Vdi_bi+(DPD*T2)*inv_gam_Vdi_bi_Vgi_bi));
  T4_Vdi_bi_Vdi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+DPD*T2_Vdi_bi_Vdi_bi)*inv_gam+(DPD*T2_Vdi_bi)*inv_gam_Vdi_bi+((DPD*T2_Vdi_bi))*inv_gam_Vdi_bi+(DPD*T2)*inv_gam_Vdi_bi_Vdi_bi));
  T4_Vdi_bi_Vsi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+DPD*T2_Vdi_bi_Vsi_bi)*inv_gam+(DPD*T2_Vdi_bi)*inv_gam_Vsi_bi+((DPD*T2_Vsi_bi))*inv_gam_Vdi_bi+(DPD*T2)*inv_gam_Vdi_bi_Vsi_bi));
  T4_Vdi_bi_Tempt_GND=(+0.0+(+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+DPD*T2_Vdi_bi_Tempt_GND)*inv_gam+(DPD*T2_Vdi_bi)*inv_gam_Tempt_GND+((DPD*T2_Tempt_GND))*inv_gam_Vdi_bi+(DPD*T2)*inv_gam_Vdi_bi_Tempt_GND));
#endif
T4_Vsi_bi=(((DPD*T2_Vsi_bi)*inv_gam)+((DPD*T2)*inv_gam_Vsi_bi));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+DPD*T2_Vsi_bi_Vgm_si)*inv_gam+(DPD*T2_Vsi_bi)*inv_gam_Vgm_si+((DPD*T2_Vgm_si))*inv_gam_Vsi_bi+(DPD*T2)*inv_gam_Vsi_bi_Vgm_si));
  T4_Vsi_bi_Vgm_di=(+0.0+(+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+DPD*T2_Vsi_bi_Vgm_di)*inv_gam+(DPD*T2_Vsi_bi)*0.0+((DPD*T2_Vgm_di))*inv_gam_Vsi_bi+(DPD*T2)*0.0));
  T4_Vsi_bi_Vdbulk_di=(+0.0+(+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+DPD*T2_Vsi_bi_Vdbulk_di)*inv_gam+(DPD*T2_Vsi_bi)*inv_gam_Vdbulk_di+((DPD*T2_Vdbulk_di))*inv_gam_Vsi_bi+(DPD*T2)*inv_gam_Vsi_bi_Vdbulk_di));
  T4_Vsi_bi_Vsbulk_si=(+0.0+(+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+DPD*T2_Vsi_bi_Vsbulk_si)*inv_gam+(DPD*T2_Vsi_bi)*inv_gam_Vsbulk_si+((DPD*T2_Vsbulk_si))*inv_gam_Vsi_bi+(DPD*T2)*inv_gam_Vsi_bi_Vsbulk_si));
  T4_Vsi_bi_Vgi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+DPD*T2_Vsi_bi_Vgi_bi)*inv_gam+(DPD*T2_Vsi_bi)*inv_gam_Vgi_bi+((DPD*T2_Vgi_bi))*inv_gam_Vsi_bi+(DPD*T2)*inv_gam_Vsi_bi_Vgi_bi));
  T4_Vsi_bi_Vdi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+DPD*T2_Vsi_bi_Vdi_bi)*inv_gam+(DPD*T2_Vsi_bi)*inv_gam_Vdi_bi+((DPD*T2_Vdi_bi))*inv_gam_Vsi_bi+(DPD*T2)*inv_gam_Vsi_bi_Vdi_bi));
  T4_Vsi_bi_Vsi_bi=(+0.0+(+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+DPD*T2_Vsi_bi_Vsi_bi)*inv_gam+(DPD*T2_Vsi_bi)*inv_gam_Vsi_bi+((DPD*T2_Vsi_bi))*inv_gam_Vsi_bi+(DPD*T2)*inv_gam_Vsi_bi_Vsi_bi));
  T4_Vsi_bi_Tempt_GND=(+0.0+(+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+DPD*T2_Vsi_bi_Tempt_GND)*inv_gam+(DPD*T2_Vsi_bi)*inv_gam_Tempt_GND+((DPD*T2_Tempt_GND))*inv_gam_Vsi_bi+(DPD*T2)*inv_gam_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((DPD*T2_Tempt_GND)*inv_gam)+((DPD*T2)*inv_gam_Tempt_GND));
#endif
#endif
T4=(0.5+((DPD*T2)*inv_gam));
EXIT_IF_ISNAN((0.5+((DPD*T2)*inv_gam)))
{
double m00_sqrt(d00_sqrt0,((T4*T4)+((T3*(qs+qdeff))*invgamg2)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T4*T4)+((T3*(qs+qdeff))*invgamg2)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=(((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di))+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2)*d10_sqrt0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_si*T4)+(T4*T4_Vgm_si)))+((((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*invgamg2))*(((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di))+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2)+d10_sqrt0*(+(+T4_Vdbulk_di_Vgm_si*T4+T4_Vdbulk_di*T4_Vgm_si+T4_Vgm_si*T4_Vdbulk_di+T4*T4_Vdbulk_di_Vgm_si)+(+(+T3_Vdbulk_di_Vgm_si*(qs+qdeff)+T3_Vdbulk_di*(qs_Vgm_si+qdeff_Vgm_si)+T3_Vgm_si*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3*(+qs_Vdbulk_di_Vgm_si+qdeff_Vdbulk_di_Vgm_si))*invgamg2+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*0.0+(((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdbulk_di_Vgm_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_di*T4)+(T4*T4_Vgm_di)))+((((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*invgamg2))*(((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di))+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2)+d10_sqrt0*(+(+T4_Vdbulk_di_Vgm_di*T4+T4_Vdbulk_di*T4_Vgm_di+T4_Vgm_di*T4_Vdbulk_di+T4*T4_Vdbulk_di_Vgm_di)+(+(+T3_Vdbulk_di_Vgm_di*(qs+qdeff)+T3_Vdbulk_di*(qs_Vgm_di+qdeff_Vgm_di)+T3_Vgm_di*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3*(+qs_Vdbulk_di_Vgm_di+qdeff_Vdbulk_di_Vgm_di))*invgamg2+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*0.0+(((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdbulk_di_Vdbulk_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di)))+((((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*invgamg2))*(((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di))+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2)+d10_sqrt0*(+(+T4_Vdbulk_di_Vdbulk_di*T4+T4_Vdbulk_di*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vdbulk_di+T4*T4_Vdbulk_di_Vdbulk_di)+(+(+T3_Vdbulk_di_Vdbulk_di*(qs+qdeff)+T3_Vdbulk_di*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3_Vdbulk_di*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3*(+qs_Vdbulk_di_Vdbulk_di+qdeff_Vdbulk_di_Vdbulk_di))*invgamg2+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*0.0+(((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdbulk_di_Vsbulk_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si)))+((((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*invgamg2))*(((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di))+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2)+d10_sqrt0*(+(+T4_Vdbulk_di_Vsbulk_si*T4+T4_Vdbulk_di*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vdbulk_di+T4*T4_Vdbulk_di_Vsbulk_si)+(+(+T3_Vdbulk_di_Vsbulk_si*(qs+qdeff)+T3_Vdbulk_di*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3_Vsbulk_si*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3*(+qs_Vdbulk_di_Vsbulk_si+qdeff_Vdbulk_di_Vsbulk_si))*invgamg2+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*0.0+(((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdbulk_di_Vgi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi)))+((((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*invgamg2))*(((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di))+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2)+d10_sqrt0*(+(+T4_Vdbulk_di_Vgi_bi*T4+T4_Vdbulk_di*T4_Vgi_bi+T4_Vgi_bi*T4_Vdbulk_di+T4*T4_Vdbulk_di_Vgi_bi)+(+(+T3_Vdbulk_di_Vgi_bi*(qs+qdeff)+T3_Vdbulk_di*(qs_Vgi_bi+qdeff_Vgi_bi)+T3_Vgi_bi*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3*(+qs_Vdbulk_di_Vgi_bi+qdeff_Vdbulk_di_Vgi_bi))*invgamg2+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*0.0+(((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdbulk_di_Vdi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi)))+((((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*invgamg2))*(((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di))+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2)+d10_sqrt0*(+(+T4_Vdbulk_di_Vdi_bi*T4+T4_Vdbulk_di*T4_Vdi_bi+T4_Vdi_bi*T4_Vdbulk_di+T4*T4_Vdbulk_di_Vdi_bi)+(+(+T3_Vdbulk_di_Vdi_bi*(qs+qdeff)+T3_Vdbulk_di*(qs_Vdi_bi+qdeff_Vdi_bi)+T3_Vdi_bi*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3*(+qs_Vdbulk_di_Vdi_bi+qdeff_Vdbulk_di_Vdi_bi))*invgamg2+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*0.0+(((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdbulk_di_Vsi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi)))+((((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*invgamg2))*(((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di))+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2)+d10_sqrt0*(+(+T4_Vdbulk_di_Vsi_bi*T4+T4_Vdbulk_di*T4_Vsi_bi+T4_Vsi_bi*T4_Vdbulk_di+T4*T4_Vdbulk_di_Vsi_bi)+(+(+T3_Vdbulk_di_Vsi_bi*(qs+qdeff)+T3_Vdbulk_di*(qs_Vsi_bi+qdeff_Vsi_bi)+T3_Vsi_bi*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3*(+qs_Vdbulk_di_Vsi_bi+qdeff_Vdbulk_di_Vsi_bi))*invgamg2+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*0.0+(((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdbulk_di_Tempt_GND=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND)))+((((((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*invgamg2)+((T3*(qs+qdeff))*invgamg2_Tempt_GND))))*(((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di))+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2)+d10_sqrt0*(+(+T4_Vdbulk_di_Tempt_GND*T4+T4_Vdbulk_di*T4_Tempt_GND+T4_Tempt_GND*T4_Vdbulk_di+T4*T4_Vdbulk_di_Tempt_GND)+(+(+T3_Vdbulk_di_Tempt_GND*(qs+qdeff)+T3_Vdbulk_di*(qs_Tempt_GND+qdeff_Tempt_GND)+T3_Tempt_GND*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3*(+qs_Vdbulk_di_Tempt_GND+qdeff_Vdbulk_di_Tempt_GND))*invgamg2+((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di)))*invgamg2_Tempt_GND+(((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*0.0+(T3*(qs+qdeff))*0.0)));
#endif
T5_Vsbulk_si=(((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si))+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2)*d10_sqrt0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_si*T4)+(T4*T4_Vgm_si)))+((((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*invgamg2))*(((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si))+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2)+d10_sqrt0*(+(+T4_Vsbulk_si_Vgm_si*T4+T4_Vsbulk_si*T4_Vgm_si+T4_Vgm_si*T4_Vsbulk_si+T4*T4_Vsbulk_si_Vgm_si)+(+(+T3_Vsbulk_si_Vgm_si*(qs+qdeff)+T3_Vsbulk_si*(qs_Vgm_si+qdeff_Vgm_si)+T3_Vgm_si*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3*(+qs_Vsbulk_si_Vgm_si+qdeff_Vsbulk_si_Vgm_si))*invgamg2+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*0.0+(((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsbulk_si_Vgm_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_di*T4)+(T4*T4_Vgm_di)))+((((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*invgamg2))*(((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si))+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2)+d10_sqrt0*(+(+T4_Vsbulk_si_Vgm_di*T4+T4_Vsbulk_si*T4_Vgm_di+T4_Vgm_di*T4_Vsbulk_si+T4*T4_Vsbulk_si_Vgm_di)+(+(+T3_Vsbulk_si_Vgm_di*(qs+qdeff)+T3_Vsbulk_si*(qs_Vgm_di+qdeff_Vgm_di)+T3_Vgm_di*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3*(+qs_Vsbulk_si_Vgm_di+qdeff_Vsbulk_si_Vgm_di))*invgamg2+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*0.0+(((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsbulk_si_Vdbulk_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di)))+((((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*invgamg2))*(((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si))+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2)+d10_sqrt0*(+(+T4_Vsbulk_si_Vdbulk_di*T4+T4_Vsbulk_si*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vsbulk_si+T4*T4_Vsbulk_si_Vdbulk_di)+(+(+T3_Vsbulk_si_Vdbulk_di*(qs+qdeff)+T3_Vsbulk_si*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3_Vdbulk_di*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3*(+qs_Vsbulk_si_Vdbulk_di+qdeff_Vsbulk_si_Vdbulk_di))*invgamg2+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*0.0+(((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsbulk_si_Vsbulk_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si)))+((((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*invgamg2))*(((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si))+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2)+d10_sqrt0*(+(+T4_Vsbulk_si_Vsbulk_si*T4+T4_Vsbulk_si*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vsbulk_si+T4*T4_Vsbulk_si_Vsbulk_si)+(+(+T3_Vsbulk_si_Vsbulk_si*(qs+qdeff)+T3_Vsbulk_si*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3_Vsbulk_si*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3*(+qs_Vsbulk_si_Vsbulk_si+qdeff_Vsbulk_si_Vsbulk_si))*invgamg2+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*0.0+(((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsbulk_si_Vgi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi)))+((((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*invgamg2))*(((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si))+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2)+d10_sqrt0*(+(+T4_Vsbulk_si_Vgi_bi*T4+T4_Vsbulk_si*T4_Vgi_bi+T4_Vgi_bi*T4_Vsbulk_si+T4*T4_Vsbulk_si_Vgi_bi)+(+(+T3_Vsbulk_si_Vgi_bi*(qs+qdeff)+T3_Vsbulk_si*(qs_Vgi_bi+qdeff_Vgi_bi)+T3_Vgi_bi*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3*(+qs_Vsbulk_si_Vgi_bi+qdeff_Vsbulk_si_Vgi_bi))*invgamg2+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*0.0+(((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsbulk_si_Vdi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi)))+((((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*invgamg2))*(((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si))+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2)+d10_sqrt0*(+(+T4_Vsbulk_si_Vdi_bi*T4+T4_Vsbulk_si*T4_Vdi_bi+T4_Vdi_bi*T4_Vsbulk_si+T4*T4_Vsbulk_si_Vdi_bi)+(+(+T3_Vsbulk_si_Vdi_bi*(qs+qdeff)+T3_Vsbulk_si*(qs_Vdi_bi+qdeff_Vdi_bi)+T3_Vdi_bi*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3*(+qs_Vsbulk_si_Vdi_bi+qdeff_Vsbulk_si_Vdi_bi))*invgamg2+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*0.0+(((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsbulk_si_Vsi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi)))+((((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*invgamg2))*(((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si))+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2)+d10_sqrt0*(+(+T4_Vsbulk_si_Vsi_bi*T4+T4_Vsbulk_si*T4_Vsi_bi+T4_Vsi_bi*T4_Vsbulk_si+T4*T4_Vsbulk_si_Vsi_bi)+(+(+T3_Vsbulk_si_Vsi_bi*(qs+qdeff)+T3_Vsbulk_si*(qs_Vsi_bi+qdeff_Vsi_bi)+T3_Vsi_bi*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3*(+qs_Vsbulk_si_Vsi_bi+qdeff_Vsbulk_si_Vsi_bi))*invgamg2+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*0.0+(((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsbulk_si_Tempt_GND=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND)))+((((((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*invgamg2)+((T3*(qs+qdeff))*invgamg2_Tempt_GND))))*(((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si))+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2)+d10_sqrt0*(+(+T4_Vsbulk_si_Tempt_GND*T4+T4_Vsbulk_si*T4_Tempt_GND+T4_Tempt_GND*T4_Vsbulk_si+T4*T4_Vsbulk_si_Tempt_GND)+(+(+T3_Vsbulk_si_Tempt_GND*(qs+qdeff)+T3_Vsbulk_si*(qs_Tempt_GND+qdeff_Tempt_GND)+T3_Tempt_GND*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3*(+qs_Vsbulk_si_Tempt_GND+qdeff_Vsbulk_si_Tempt_GND))*invgamg2+((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si)))*invgamg2_Tempt_GND+(((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*0.0+(T3*(qs+qdeff))*0.0)));
#endif
T5_Vgi_bi=(((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi))+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2)*d10_sqrt0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_si*T4)+(T4*T4_Vgm_si)))+((((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*invgamg2))*(((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi))+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vgi_bi_Vgm_si*T4+T4_Vgi_bi*T4_Vgm_si+T4_Vgm_si*T4_Vgi_bi+T4*T4_Vgi_bi_Vgm_si)+(+(+T3_Vgi_bi_Vgm_si*(qs+qdeff)+T3_Vgi_bi*(qs_Vgm_si+qdeff_Vgm_si)+T3_Vgm_si*(qs_Vgi_bi+qdeff_Vgi_bi)+T3*(+qs_Vgi_bi_Vgm_si+qdeff_Vgi_bi_Vgm_si))*invgamg2+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*0.0+(((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vgi_bi_Vgm_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_di*T4)+(T4*T4_Vgm_di)))+((((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*invgamg2))*(((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi))+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vgi_bi_Vgm_di*T4+T4_Vgi_bi*T4_Vgm_di+T4_Vgm_di*T4_Vgi_bi+T4*T4_Vgi_bi_Vgm_di)+(+(+T3_Vgi_bi_Vgm_di*(qs+qdeff)+T3_Vgi_bi*(qs_Vgm_di+qdeff_Vgm_di)+T3_Vgm_di*(qs_Vgi_bi+qdeff_Vgi_bi)+T3*(+qs_Vgi_bi_Vgm_di+qdeff_Vgi_bi_Vgm_di))*invgamg2+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*0.0+(((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vgi_bi_Vdbulk_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di)))+((((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*invgamg2))*(((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi))+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vgi_bi_Vdbulk_di*T4+T4_Vgi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vgi_bi+T4*T4_Vgi_bi_Vdbulk_di)+(+(+T3_Vgi_bi_Vdbulk_di*(qs+qdeff)+T3_Vgi_bi*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3_Vdbulk_di*(qs_Vgi_bi+qdeff_Vgi_bi)+T3*(+qs_Vgi_bi_Vdbulk_di+qdeff_Vgi_bi_Vdbulk_di))*invgamg2+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*0.0+(((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vgi_bi_Vsbulk_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si)))+((((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*invgamg2))*(((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi))+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vgi_bi_Vsbulk_si*T4+T4_Vgi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vgi_bi+T4*T4_Vgi_bi_Vsbulk_si)+(+(+T3_Vgi_bi_Vsbulk_si*(qs+qdeff)+T3_Vgi_bi*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3_Vsbulk_si*(qs_Vgi_bi+qdeff_Vgi_bi)+T3*(+qs_Vgi_bi_Vsbulk_si+qdeff_Vgi_bi_Vsbulk_si))*invgamg2+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*0.0+(((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vgi_bi_Vgi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi)))+((((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*invgamg2))*(((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi))+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vgi_bi_Vgi_bi*T4+T4_Vgi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vgi_bi+T4*T4_Vgi_bi_Vgi_bi)+(+(+T3_Vgi_bi_Vgi_bi*(qs+qdeff)+T3_Vgi_bi*(qs_Vgi_bi+qdeff_Vgi_bi)+T3_Vgi_bi*(qs_Vgi_bi+qdeff_Vgi_bi)+T3*(+qs_Vgi_bi_Vgi_bi+qdeff_Vgi_bi_Vgi_bi))*invgamg2+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*0.0+(((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vgi_bi_Vdi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi)))+((((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*invgamg2))*(((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi))+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vgi_bi_Vdi_bi*T4+T4_Vgi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vgi_bi+T4*T4_Vgi_bi_Vdi_bi)+(+(+T3_Vgi_bi_Vdi_bi*(qs+qdeff)+T3_Vgi_bi*(qs_Vdi_bi+qdeff_Vdi_bi)+T3_Vdi_bi*(qs_Vgi_bi+qdeff_Vgi_bi)+T3*(+qs_Vgi_bi_Vdi_bi+qdeff_Vgi_bi_Vdi_bi))*invgamg2+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*0.0+(((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vgi_bi_Vsi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi)))+((((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*invgamg2))*(((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi))+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vgi_bi_Vsi_bi*T4+T4_Vgi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vgi_bi+T4*T4_Vgi_bi_Vsi_bi)+(+(+T3_Vgi_bi_Vsi_bi*(qs+qdeff)+T3_Vgi_bi*(qs_Vsi_bi+qdeff_Vsi_bi)+T3_Vsi_bi*(qs_Vgi_bi+qdeff_Vgi_bi)+T3*(+qs_Vgi_bi_Vsi_bi+qdeff_Vgi_bi_Vsi_bi))*invgamg2+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*0.0+(((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vgi_bi_Tempt_GND=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND)))+((((((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*invgamg2)+((T3*(qs+qdeff))*invgamg2_Tempt_GND))))*(((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi))+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vgi_bi_Tempt_GND*T4+T4_Vgi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vgi_bi+T4*T4_Vgi_bi_Tempt_GND)+(+(+T3_Vgi_bi_Tempt_GND*(qs+qdeff)+T3_Vgi_bi*(qs_Tempt_GND+qdeff_Tempt_GND)+T3_Tempt_GND*(qs_Vgi_bi+qdeff_Vgi_bi)+T3*(+qs_Vgi_bi_Tempt_GND+qdeff_Vgi_bi_Tempt_GND))*invgamg2+((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi)))*invgamg2_Tempt_GND+(((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*0.0+(T3*(qs+qdeff))*0.0)));
#endif
T5_Vdi_bi=(((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi))+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2)*d10_sqrt0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_si*T4)+(T4*T4_Vgm_si)))+((((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*invgamg2))*(((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi))+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vdi_bi_Vgm_si*T4+T4_Vdi_bi*T4_Vgm_si+T4_Vgm_si*T4_Vdi_bi+T4*T4_Vdi_bi_Vgm_si)+(+(+T3_Vdi_bi_Vgm_si*(qs+qdeff)+T3_Vdi_bi*(qs_Vgm_si+qdeff_Vgm_si)+T3_Vgm_si*(qs_Vdi_bi+qdeff_Vdi_bi)+T3*(+qs_Vdi_bi_Vgm_si+qdeff_Vdi_bi_Vgm_si))*invgamg2+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*0.0+(((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdi_bi_Vgm_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_di*T4)+(T4*T4_Vgm_di)))+((((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*invgamg2))*(((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi))+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vdi_bi_Vgm_di*T4+T4_Vdi_bi*T4_Vgm_di+T4_Vgm_di*T4_Vdi_bi+T4*T4_Vdi_bi_Vgm_di)+(+(+T3_Vdi_bi_Vgm_di*(qs+qdeff)+T3_Vdi_bi*(qs_Vgm_di+qdeff_Vgm_di)+T3_Vgm_di*(qs_Vdi_bi+qdeff_Vdi_bi)+T3*(+qs_Vdi_bi_Vgm_di+qdeff_Vdi_bi_Vgm_di))*invgamg2+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*0.0+(((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdi_bi_Vdbulk_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di)))+((((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*invgamg2))*(((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi))+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vdi_bi_Vdbulk_di*T4+T4_Vdi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vdi_bi+T4*T4_Vdi_bi_Vdbulk_di)+(+(+T3_Vdi_bi_Vdbulk_di*(qs+qdeff)+T3_Vdi_bi*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3_Vdbulk_di*(qs_Vdi_bi+qdeff_Vdi_bi)+T3*(+qs_Vdi_bi_Vdbulk_di+qdeff_Vdi_bi_Vdbulk_di))*invgamg2+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*0.0+(((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdi_bi_Vsbulk_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si)))+((((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*invgamg2))*(((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi))+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vdi_bi_Vsbulk_si*T4+T4_Vdi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vdi_bi+T4*T4_Vdi_bi_Vsbulk_si)+(+(+T3_Vdi_bi_Vsbulk_si*(qs+qdeff)+T3_Vdi_bi*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3_Vsbulk_si*(qs_Vdi_bi+qdeff_Vdi_bi)+T3*(+qs_Vdi_bi_Vsbulk_si+qdeff_Vdi_bi_Vsbulk_si))*invgamg2+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*0.0+(((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdi_bi_Vgi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi)))+((((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*invgamg2))*(((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi))+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vdi_bi_Vgi_bi*T4+T4_Vdi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vdi_bi+T4*T4_Vdi_bi_Vgi_bi)+(+(+T3_Vdi_bi_Vgi_bi*(qs+qdeff)+T3_Vdi_bi*(qs_Vgi_bi+qdeff_Vgi_bi)+T3_Vgi_bi*(qs_Vdi_bi+qdeff_Vdi_bi)+T3*(+qs_Vdi_bi_Vgi_bi+qdeff_Vdi_bi_Vgi_bi))*invgamg2+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*0.0+(((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdi_bi_Vdi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi)))+((((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*invgamg2))*(((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi))+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vdi_bi_Vdi_bi*T4+T4_Vdi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vdi_bi+T4*T4_Vdi_bi_Vdi_bi)+(+(+T3_Vdi_bi_Vdi_bi*(qs+qdeff)+T3_Vdi_bi*(qs_Vdi_bi+qdeff_Vdi_bi)+T3_Vdi_bi*(qs_Vdi_bi+qdeff_Vdi_bi)+T3*(+qs_Vdi_bi_Vdi_bi+qdeff_Vdi_bi_Vdi_bi))*invgamg2+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*0.0+(((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdi_bi_Vsi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi)))+((((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*invgamg2))*(((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi))+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vdi_bi_Vsi_bi*T4+T4_Vdi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vdi_bi+T4*T4_Vdi_bi_Vsi_bi)+(+(+T3_Vdi_bi_Vsi_bi*(qs+qdeff)+T3_Vdi_bi*(qs_Vsi_bi+qdeff_Vsi_bi)+T3_Vsi_bi*(qs_Vdi_bi+qdeff_Vdi_bi)+T3*(+qs_Vdi_bi_Vsi_bi+qdeff_Vdi_bi_Vsi_bi))*invgamg2+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*0.0+(((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vdi_bi_Tempt_GND=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND)))+((((((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*invgamg2)+((T3*(qs+qdeff))*invgamg2_Tempt_GND))))*(((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi))+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vdi_bi_Tempt_GND*T4+T4_Vdi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vdi_bi+T4*T4_Vdi_bi_Tempt_GND)+(+(+T3_Vdi_bi_Tempt_GND*(qs+qdeff)+T3_Vdi_bi*(qs_Tempt_GND+qdeff_Tempt_GND)+T3_Tempt_GND*(qs_Vdi_bi+qdeff_Vdi_bi)+T3*(+qs_Vdi_bi_Tempt_GND+qdeff_Vdi_bi_Tempt_GND))*invgamg2+((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi)))*invgamg2_Tempt_GND+(((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*0.0+(T3*(qs+qdeff))*0.0)));
#endif
T5_Vsi_bi=(((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi))+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2)*d10_sqrt0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_si*T4)+(T4*T4_Vgm_si)))+((((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*invgamg2))*(((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi))+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vsi_bi_Vgm_si*T4+T4_Vsi_bi*T4_Vgm_si+T4_Vgm_si*T4_Vsi_bi+T4*T4_Vsi_bi_Vgm_si)+(+(+T3_Vsi_bi_Vgm_si*(qs+qdeff)+T3_Vsi_bi*(qs_Vgm_si+qdeff_Vgm_si)+T3_Vgm_si*(qs_Vsi_bi+qdeff_Vsi_bi)+T3*(+qs_Vsi_bi_Vgm_si+qdeff_Vsi_bi_Vgm_si))*invgamg2+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*0.0+(((T3_Vgm_si*(qs+qdeff))+(T3*(qs_Vgm_si+qdeff_Vgm_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsi_bi_Vgm_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgm_di*T4)+(T4*T4_Vgm_di)))+((((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*invgamg2))*(((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi))+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vsi_bi_Vgm_di*T4+T4_Vsi_bi*T4_Vgm_di+T4_Vgm_di*T4_Vsi_bi+T4*T4_Vsi_bi_Vgm_di)+(+(+T3_Vsi_bi_Vgm_di*(qs+qdeff)+T3_Vsi_bi*(qs_Vgm_di+qdeff_Vgm_di)+T3_Vgm_di*(qs_Vsi_bi+qdeff_Vsi_bi)+T3*(+qs_Vsi_bi_Vgm_di+qdeff_Vsi_bi_Vgm_di))*invgamg2+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*0.0+(((T3_Vgm_di*(qs+qdeff))+(T3*(qs_Vgm_di+qdeff_Vgm_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsi_bi_Vdbulk_di=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdbulk_di*T4)+(T4*T4_Vdbulk_di)))+((((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*invgamg2))*(((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi))+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vsi_bi_Vdbulk_di*T4+T4_Vsi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vsi_bi+T4*T4_Vsi_bi_Vdbulk_di)+(+(+T3_Vsi_bi_Vdbulk_di*(qs+qdeff)+T3_Vsi_bi*(qs_Vdbulk_di+qdeff_Vdbulk_di)+T3_Vdbulk_di*(qs_Vsi_bi+qdeff_Vsi_bi)+T3*(+qs_Vsi_bi_Vdbulk_di+qdeff_Vsi_bi_Vdbulk_di))*invgamg2+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*0.0+(((T3_Vdbulk_di*(qs+qdeff))+(T3*(qs_Vdbulk_di+qdeff_Vdbulk_di))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsi_bi_Vsbulk_si=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsbulk_si*T4)+(T4*T4_Vsbulk_si)))+((((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*invgamg2))*(((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi))+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vsi_bi_Vsbulk_si*T4+T4_Vsi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vsi_bi+T4*T4_Vsi_bi_Vsbulk_si)+(+(+T3_Vsi_bi_Vsbulk_si*(qs+qdeff)+T3_Vsi_bi*(qs_Vsbulk_si+qdeff_Vsbulk_si)+T3_Vsbulk_si*(qs_Vsi_bi+qdeff_Vsi_bi)+T3*(+qs_Vsi_bi_Vsbulk_si+qdeff_Vsi_bi_Vsbulk_si))*invgamg2+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*0.0+(((T3_Vsbulk_si*(qs+qdeff))+(T3*(qs_Vsbulk_si+qdeff_Vsbulk_si))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsi_bi_Vgi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vgi_bi*T4)+(T4*T4_Vgi_bi)))+((((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*invgamg2))*(((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi))+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vsi_bi_Vgi_bi*T4+T4_Vsi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vsi_bi+T4*T4_Vsi_bi_Vgi_bi)+(+(+T3_Vsi_bi_Vgi_bi*(qs+qdeff)+T3_Vsi_bi*(qs_Vgi_bi+qdeff_Vgi_bi)+T3_Vgi_bi*(qs_Vsi_bi+qdeff_Vsi_bi)+T3*(+qs_Vsi_bi_Vgi_bi+qdeff_Vsi_bi_Vgi_bi))*invgamg2+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*0.0+(((T3_Vgi_bi*(qs+qdeff))+(T3*(qs_Vgi_bi+qdeff_Vgi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsi_bi_Vdi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vdi_bi*T4)+(T4*T4_Vdi_bi)))+((((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*invgamg2))*(((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi))+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vsi_bi_Vdi_bi*T4+T4_Vsi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vsi_bi+T4*T4_Vsi_bi_Vdi_bi)+(+(+T3_Vsi_bi_Vdi_bi*(qs+qdeff)+T3_Vsi_bi*(qs_Vdi_bi+qdeff_Vdi_bi)+T3_Vdi_bi*(qs_Vsi_bi+qdeff_Vsi_bi)+T3*(+qs_Vsi_bi_Vdi_bi+qdeff_Vsi_bi_Vdi_bi))*invgamg2+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*0.0+(((T3_Vdi_bi*(qs+qdeff))+(T3*(qs_Vdi_bi+qdeff_Vdi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsi_bi_Vsi_bi=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi)))+((((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*invgamg2))*(((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi))+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vsi_bi_Vsi_bi*T4+T4_Vsi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vsi_bi+T4*T4_Vsi_bi_Vsi_bi)+(+(+T3_Vsi_bi_Vsi_bi*(qs+qdeff)+T3_Vsi_bi*(qs_Vsi_bi+qdeff_Vsi_bi)+T3_Vsi_bi*(qs_Vsi_bi+qdeff_Vsi_bi)+T3*(+qs_Vsi_bi_Vsi_bi+qdeff_Vsi_bi_Vsi_bi))*invgamg2+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*0.0+(((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi))))*0.0+(T3*(qs+qdeff))*0.0)));
  T5_Vsi_bi_Tempt_GND=(m20_sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)))*((((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND)))+((((((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*invgamg2)+((T3*(qs+qdeff))*invgamg2_Tempt_GND))))*(((T4_Vsi_bi*T4)+(T4*T4_Vsi_bi))+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2)+d10_sqrt0*(+(+T4_Vsi_bi_Tempt_GND*T4+T4_Vsi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vsi_bi+T4*T4_Vsi_bi_Tempt_GND)+(+(+T3_Vsi_bi_Tempt_GND*(qs+qdeff)+T3_Vsi_bi*(qs_Tempt_GND+qdeff_Tempt_GND)+T3_Tempt_GND*(qs_Vsi_bi+qdeff_Vsi_bi)+T3*(+qs_Vsi_bi_Tempt_GND+qdeff_Vsi_bi_Tempt_GND))*invgamg2+((T3_Vsi_bi*(qs+qdeff))+(T3*(qs_Vsi_bi+qdeff_Vsi_bi)))*invgamg2_Tempt_GND+(((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND))))*0.0+(T3*(qs+qdeff))*0.0)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=(((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND))+((((T3_Tempt_GND*(qs+qdeff))+(T3*(qs_Tempt_GND+qdeff_Tempt_GND)))*invgamg2)+((T3*(qs+qdeff))*invgamg2_Tempt_GND)))*d10_sqrt0;
#endif
#endif
T5=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
nq_Vgm_si=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_si_Vgm_si=0.0;
  nq_Vgm_si_Vgm_di=0.0;
  nq_Vgm_si_Vdbulk_di=0.0;
  nq_Vgm_si_Vsbulk_si=0.0;
  nq_Vgm_si_Vgi_bi=0.0;
  nq_Vgm_si_Tempt_GND=0.0;
  nq_Vgm_si_Vdi_bi=0.0;
  nq_Vgm_si_Vsi_bi=0.0;
#endif
nq_Vgm_di=0.0;
#if defined(_DERIVATE2)
  nq_Vgm_di_Vgm_si=0.0;
  nq_Vgm_di_Vgm_di=0.0;
  nq_Vgm_di_Vdbulk_di=0.0;
  nq_Vgm_di_Vsbulk_si=0.0;
  nq_Vgm_di_Vgi_bi=0.0;
  nq_Vgm_di_Tempt_GND=0.0;
  nq_Vgm_di_Vdi_bi=0.0;
  nq_Vgm_di_Vsi_bi=0.0;
#endif
nq_Vdbulk_di=((T3_Vdbulk_di*(T4+T5)-T3*(T4_Vdbulk_di+T5_Vdbulk_di))/(T4+T5)/(T4+T5));
#if defined(_DERIVATE2)
  nq_Vdbulk_di_Vgm_si=(T3_Vdbulk_di_Vgm_si/(T4+T5)-(T3_Vdbulk_di*(T4_Vgm_si+T5_Vgm_si)+T3_Vgm_si*(T4_Vdbulk_di+T5_Vdbulk_di)+T3*(+T4_Vdbulk_di_Vgm_si+T5_Vdbulk_di_Vgm_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdbulk_di+T5_Vdbulk_di)*(T4_Vgm_si+T5_Vgm_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdbulk_di_Vgm_di=(T3_Vdbulk_di_Vgm_di/(T4+T5)-(T3_Vdbulk_di*(T4_Vgm_di+T5_Vgm_di)+T3_Vgm_di*(T4_Vdbulk_di+T5_Vdbulk_di)+T3*(+T4_Vdbulk_di_Vgm_di+T5_Vdbulk_di_Vgm_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdbulk_di+T5_Vdbulk_di)*(T4_Vgm_di+T5_Vgm_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdbulk_di_Vdbulk_di=(T3_Vdbulk_di_Vdbulk_di/(T4+T5)-(T3_Vdbulk_di*(T4_Vdbulk_di+T5_Vdbulk_di)+T3_Vdbulk_di*(T4_Vdbulk_di+T5_Vdbulk_di)+T3*(+T4_Vdbulk_di_Vdbulk_di+T5_Vdbulk_di_Vdbulk_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdbulk_di+T5_Vdbulk_di)*(T4_Vdbulk_di+T5_Vdbulk_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdbulk_di_Vsbulk_si=(T3_Vdbulk_di_Vsbulk_si/(T4+T5)-(T3_Vdbulk_di*(T4_Vsbulk_si+T5_Vsbulk_si)+T3_Vsbulk_si*(T4_Vdbulk_di+T5_Vdbulk_di)+T3*(+T4_Vdbulk_di_Vsbulk_si+T5_Vdbulk_di_Vsbulk_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdbulk_di+T5_Vdbulk_di)*(T4_Vsbulk_si+T5_Vsbulk_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdbulk_di_Vgi_bi=(T3_Vdbulk_di_Vgi_bi/(T4+T5)-(T3_Vdbulk_di*(T4_Vgi_bi+T5_Vgi_bi)+T3_Vgi_bi*(T4_Vdbulk_di+T5_Vdbulk_di)+T3*(+T4_Vdbulk_di_Vgi_bi+T5_Vdbulk_di_Vgi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdbulk_di+T5_Vdbulk_di)*(T4_Vgi_bi+T5_Vgi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdbulk_di_Tempt_GND=(T3_Vdbulk_di_Tempt_GND/(T4+T5)-(T3_Vdbulk_di*(T4_Tempt_GND+T5_Tempt_GND)+T3_Tempt_GND*(T4_Vdbulk_di+T5_Vdbulk_di)+T3*(+T4_Vdbulk_di_Tempt_GND+T5_Vdbulk_di_Tempt_GND))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdbulk_di+T5_Vdbulk_di)*(T4_Tempt_GND+T5_Tempt_GND)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdbulk_di_Vdi_bi=(T3_Vdbulk_di_Vdi_bi/(T4+T5)-(T3_Vdbulk_di*(T4_Vdi_bi+T5_Vdi_bi)+T3_Vdi_bi*(T4_Vdbulk_di+T5_Vdbulk_di)+T3*(+T4_Vdbulk_di_Vdi_bi+T5_Vdbulk_di_Vdi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdbulk_di+T5_Vdbulk_di)*(T4_Vdi_bi+T5_Vdi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdbulk_di_Vsi_bi=(T3_Vdbulk_di_Vsi_bi/(T4+T5)-(T3_Vdbulk_di*(T4_Vsi_bi+T5_Vsi_bi)+T3_Vsi_bi*(T4_Vdbulk_di+T5_Vdbulk_di)+T3*(+T4_Vdbulk_di_Vsi_bi+T5_Vdbulk_di_Vsi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdbulk_di+T5_Vdbulk_di)*(T4_Vsi_bi+T5_Vsi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
#endif
nq_Vsbulk_si=((T3_Vsbulk_si*(T4+T5)-T3*(T4_Vsbulk_si+T5_Vsbulk_si))/(T4+T5)/(T4+T5));
#if defined(_DERIVATE2)
  nq_Vsbulk_si_Vgm_si=(T3_Vsbulk_si_Vgm_si/(T4+T5)-(T3_Vsbulk_si*(T4_Vgm_si+T5_Vgm_si)+T3_Vgm_si*(T4_Vsbulk_si+T5_Vsbulk_si)+T3*(+T4_Vsbulk_si_Vgm_si+T5_Vsbulk_si_Vgm_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsbulk_si+T5_Vsbulk_si)*(T4_Vgm_si+T5_Vgm_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsbulk_si_Vgm_di=(T3_Vsbulk_si_Vgm_di/(T4+T5)-(T3_Vsbulk_si*(T4_Vgm_di+T5_Vgm_di)+T3_Vgm_di*(T4_Vsbulk_si+T5_Vsbulk_si)+T3*(+T4_Vsbulk_si_Vgm_di+T5_Vsbulk_si_Vgm_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsbulk_si+T5_Vsbulk_si)*(T4_Vgm_di+T5_Vgm_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsbulk_si_Vdbulk_di=(T3_Vsbulk_si_Vdbulk_di/(T4+T5)-(T3_Vsbulk_si*(T4_Vdbulk_di+T5_Vdbulk_di)+T3_Vdbulk_di*(T4_Vsbulk_si+T5_Vsbulk_si)+T3*(+T4_Vsbulk_si_Vdbulk_di+T5_Vsbulk_si_Vdbulk_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsbulk_si+T5_Vsbulk_si)*(T4_Vdbulk_di+T5_Vdbulk_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsbulk_si_Vsbulk_si=(T3_Vsbulk_si_Vsbulk_si/(T4+T5)-(T3_Vsbulk_si*(T4_Vsbulk_si+T5_Vsbulk_si)+T3_Vsbulk_si*(T4_Vsbulk_si+T5_Vsbulk_si)+T3*(+T4_Vsbulk_si_Vsbulk_si+T5_Vsbulk_si_Vsbulk_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsbulk_si+T5_Vsbulk_si)*(T4_Vsbulk_si+T5_Vsbulk_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsbulk_si_Vgi_bi=(T3_Vsbulk_si_Vgi_bi/(T4+T5)-(T3_Vsbulk_si*(T4_Vgi_bi+T5_Vgi_bi)+T3_Vgi_bi*(T4_Vsbulk_si+T5_Vsbulk_si)+T3*(+T4_Vsbulk_si_Vgi_bi+T5_Vsbulk_si_Vgi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsbulk_si+T5_Vsbulk_si)*(T4_Vgi_bi+T5_Vgi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsbulk_si_Tempt_GND=(T3_Vsbulk_si_Tempt_GND/(T4+T5)-(T3_Vsbulk_si*(T4_Tempt_GND+T5_Tempt_GND)+T3_Tempt_GND*(T4_Vsbulk_si+T5_Vsbulk_si)+T3*(+T4_Vsbulk_si_Tempt_GND+T5_Vsbulk_si_Tempt_GND))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsbulk_si+T5_Vsbulk_si)*(T4_Tempt_GND+T5_Tempt_GND)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsbulk_si_Vdi_bi=(T3_Vsbulk_si_Vdi_bi/(T4+T5)-(T3_Vsbulk_si*(T4_Vdi_bi+T5_Vdi_bi)+T3_Vdi_bi*(T4_Vsbulk_si+T5_Vsbulk_si)+T3*(+T4_Vsbulk_si_Vdi_bi+T5_Vsbulk_si_Vdi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsbulk_si+T5_Vsbulk_si)*(T4_Vdi_bi+T5_Vdi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsbulk_si_Vsi_bi=(T3_Vsbulk_si_Vsi_bi/(T4+T5)-(T3_Vsbulk_si*(T4_Vsi_bi+T5_Vsi_bi)+T3_Vsi_bi*(T4_Vsbulk_si+T5_Vsbulk_si)+T3*(+T4_Vsbulk_si_Vsi_bi+T5_Vsbulk_si_Vsi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsbulk_si+T5_Vsbulk_si)*(T4_Vsi_bi+T5_Vsi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
#endif
nq_Vgi_bi=((T3_Vgi_bi*(T4+T5)-T3*(T4_Vgi_bi+T5_Vgi_bi))/(T4+T5)/(T4+T5));
#if defined(_DERIVATE2)
  nq_Vgi_bi_Vgm_si=(T3_Vgi_bi_Vgm_si/(T4+T5)-(T3_Vgi_bi*(T4_Vgm_si+T5_Vgm_si)+T3_Vgm_si*(T4_Vgi_bi+T5_Vgi_bi)+T3*(+T4_Vgi_bi_Vgm_si+T5_Vgi_bi_Vgm_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vgi_bi+T5_Vgi_bi)*(T4_Vgm_si+T5_Vgm_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vgi_bi_Vgm_di=(T3_Vgi_bi_Vgm_di/(T4+T5)-(T3_Vgi_bi*(T4_Vgm_di+T5_Vgm_di)+T3_Vgm_di*(T4_Vgi_bi+T5_Vgi_bi)+T3*(+T4_Vgi_bi_Vgm_di+T5_Vgi_bi_Vgm_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vgi_bi+T5_Vgi_bi)*(T4_Vgm_di+T5_Vgm_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vgi_bi_Vdbulk_di=(T3_Vgi_bi_Vdbulk_di/(T4+T5)-(T3_Vgi_bi*(T4_Vdbulk_di+T5_Vdbulk_di)+T3_Vdbulk_di*(T4_Vgi_bi+T5_Vgi_bi)+T3*(+T4_Vgi_bi_Vdbulk_di+T5_Vgi_bi_Vdbulk_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vgi_bi+T5_Vgi_bi)*(T4_Vdbulk_di+T5_Vdbulk_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vgi_bi_Vsbulk_si=(T3_Vgi_bi_Vsbulk_si/(T4+T5)-(T3_Vgi_bi*(T4_Vsbulk_si+T5_Vsbulk_si)+T3_Vsbulk_si*(T4_Vgi_bi+T5_Vgi_bi)+T3*(+T4_Vgi_bi_Vsbulk_si+T5_Vgi_bi_Vsbulk_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vgi_bi+T5_Vgi_bi)*(T4_Vsbulk_si+T5_Vsbulk_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vgi_bi_Vgi_bi=(T3_Vgi_bi_Vgi_bi/(T4+T5)-(T3_Vgi_bi*(T4_Vgi_bi+T5_Vgi_bi)+T3_Vgi_bi*(T4_Vgi_bi+T5_Vgi_bi)+T3*(+T4_Vgi_bi_Vgi_bi+T5_Vgi_bi_Vgi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vgi_bi+T5_Vgi_bi)*(T4_Vgi_bi+T5_Vgi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vgi_bi_Tempt_GND=(T3_Vgi_bi_Tempt_GND/(T4+T5)-(T3_Vgi_bi*(T4_Tempt_GND+T5_Tempt_GND)+T3_Tempt_GND*(T4_Vgi_bi+T5_Vgi_bi)+T3*(+T4_Vgi_bi_Tempt_GND+T5_Vgi_bi_Tempt_GND))/(T4+T5)/(T4+T5)+2*T3*(T4_Vgi_bi+T5_Vgi_bi)*(T4_Tempt_GND+T5_Tempt_GND)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vgi_bi_Vdi_bi=(T3_Vgi_bi_Vdi_bi/(T4+T5)-(T3_Vgi_bi*(T4_Vdi_bi+T5_Vdi_bi)+T3_Vdi_bi*(T4_Vgi_bi+T5_Vgi_bi)+T3*(+T4_Vgi_bi_Vdi_bi+T5_Vgi_bi_Vdi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vgi_bi+T5_Vgi_bi)*(T4_Vdi_bi+T5_Vdi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vgi_bi_Vsi_bi=(T3_Vgi_bi_Vsi_bi/(T4+T5)-(T3_Vgi_bi*(T4_Vsi_bi+T5_Vsi_bi)+T3_Vsi_bi*(T4_Vgi_bi+T5_Vgi_bi)+T3*(+T4_Vgi_bi_Vsi_bi+T5_Vgi_bi_Vsi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vgi_bi+T5_Vgi_bi)*(T4_Vsi_bi+T5_Vsi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
#endif
#if defined(_DERIVATE)
nq_Tempt_GND=((T3_Tempt_GND*(T4+T5)-T3*(T4_Tempt_GND+T5_Tempt_GND))/(T4+T5)/(T4+T5));
#endif
nq_Vdi_bi=((T3_Vdi_bi*(T4+T5)-T3*(T4_Vdi_bi+T5_Vdi_bi))/(T4+T5)/(T4+T5));
#if defined(_DERIVATE2)
  nq_Vdi_bi_Vgm_si=(T3_Vdi_bi_Vgm_si/(T4+T5)-(T3_Vdi_bi*(T4_Vgm_si+T5_Vgm_si)+T3_Vgm_si*(T4_Vdi_bi+T5_Vdi_bi)+T3*(+T4_Vdi_bi_Vgm_si+T5_Vdi_bi_Vgm_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdi_bi+T5_Vdi_bi)*(T4_Vgm_si+T5_Vgm_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdi_bi_Vgm_di=(T3_Vdi_bi_Vgm_di/(T4+T5)-(T3_Vdi_bi*(T4_Vgm_di+T5_Vgm_di)+T3_Vgm_di*(T4_Vdi_bi+T5_Vdi_bi)+T3*(+T4_Vdi_bi_Vgm_di+T5_Vdi_bi_Vgm_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdi_bi+T5_Vdi_bi)*(T4_Vgm_di+T5_Vgm_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdi_bi_Vdbulk_di=(T3_Vdi_bi_Vdbulk_di/(T4+T5)-(T3_Vdi_bi*(T4_Vdbulk_di+T5_Vdbulk_di)+T3_Vdbulk_di*(T4_Vdi_bi+T5_Vdi_bi)+T3*(+T4_Vdi_bi_Vdbulk_di+T5_Vdi_bi_Vdbulk_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdi_bi+T5_Vdi_bi)*(T4_Vdbulk_di+T5_Vdbulk_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdi_bi_Vsbulk_si=(T3_Vdi_bi_Vsbulk_si/(T4+T5)-(T3_Vdi_bi*(T4_Vsbulk_si+T5_Vsbulk_si)+T3_Vsbulk_si*(T4_Vdi_bi+T5_Vdi_bi)+T3*(+T4_Vdi_bi_Vsbulk_si+T5_Vdi_bi_Vsbulk_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdi_bi+T5_Vdi_bi)*(T4_Vsbulk_si+T5_Vsbulk_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdi_bi_Vgi_bi=(T3_Vdi_bi_Vgi_bi/(T4+T5)-(T3_Vdi_bi*(T4_Vgi_bi+T5_Vgi_bi)+T3_Vgi_bi*(T4_Vdi_bi+T5_Vdi_bi)+T3*(+T4_Vdi_bi_Vgi_bi+T5_Vdi_bi_Vgi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdi_bi+T5_Vdi_bi)*(T4_Vgi_bi+T5_Vgi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdi_bi_Tempt_GND=(T3_Vdi_bi_Tempt_GND/(T4+T5)-(T3_Vdi_bi*(T4_Tempt_GND+T5_Tempt_GND)+T3_Tempt_GND*(T4_Vdi_bi+T5_Vdi_bi)+T3*(+T4_Vdi_bi_Tempt_GND+T5_Vdi_bi_Tempt_GND))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdi_bi+T5_Vdi_bi)*(T4_Tempt_GND+T5_Tempt_GND)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdi_bi_Vdi_bi=(T3_Vdi_bi_Vdi_bi/(T4+T5)-(T3_Vdi_bi*(T4_Vdi_bi+T5_Vdi_bi)+T3_Vdi_bi*(T4_Vdi_bi+T5_Vdi_bi)+T3*(+T4_Vdi_bi_Vdi_bi+T5_Vdi_bi_Vdi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdi_bi+T5_Vdi_bi)*(T4_Vdi_bi+T5_Vdi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vdi_bi_Vsi_bi=(T3_Vdi_bi_Vsi_bi/(T4+T5)-(T3_Vdi_bi*(T4_Vsi_bi+T5_Vsi_bi)+T3_Vsi_bi*(T4_Vdi_bi+T5_Vdi_bi)+T3*(+T4_Vdi_bi_Vsi_bi+T5_Vdi_bi_Vsi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vdi_bi+T5_Vdi_bi)*(T4_Vsi_bi+T5_Vsi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
#endif
nq_Vsi_bi=((T3_Vsi_bi*(T4+T5)-T3*(T4_Vsi_bi+T5_Vsi_bi))/(T4+T5)/(T4+T5));
#if defined(_DERIVATE2)
  nq_Vsi_bi_Vgm_si=(T3_Vsi_bi_Vgm_si/(T4+T5)-(T3_Vsi_bi*(T4_Vgm_si+T5_Vgm_si)+T3_Vgm_si*(T4_Vsi_bi+T5_Vsi_bi)+T3*(+T4_Vsi_bi_Vgm_si+T5_Vsi_bi_Vgm_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsi_bi+T5_Vsi_bi)*(T4_Vgm_si+T5_Vgm_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsi_bi_Vgm_di=(T3_Vsi_bi_Vgm_di/(T4+T5)-(T3_Vsi_bi*(T4_Vgm_di+T5_Vgm_di)+T3_Vgm_di*(T4_Vsi_bi+T5_Vsi_bi)+T3*(+T4_Vsi_bi_Vgm_di+T5_Vsi_bi_Vgm_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsi_bi+T5_Vsi_bi)*(T4_Vgm_di+T5_Vgm_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsi_bi_Vdbulk_di=(T3_Vsi_bi_Vdbulk_di/(T4+T5)-(T3_Vsi_bi*(T4_Vdbulk_di+T5_Vdbulk_di)+T3_Vdbulk_di*(T4_Vsi_bi+T5_Vsi_bi)+T3*(+T4_Vsi_bi_Vdbulk_di+T5_Vsi_bi_Vdbulk_di))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsi_bi+T5_Vsi_bi)*(T4_Vdbulk_di+T5_Vdbulk_di)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsi_bi_Vsbulk_si=(T3_Vsi_bi_Vsbulk_si/(T4+T5)-(T3_Vsi_bi*(T4_Vsbulk_si+T5_Vsbulk_si)+T3_Vsbulk_si*(T4_Vsi_bi+T5_Vsi_bi)+T3*(+T4_Vsi_bi_Vsbulk_si+T5_Vsi_bi_Vsbulk_si))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsi_bi+T5_Vsi_bi)*(T4_Vsbulk_si+T5_Vsbulk_si)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsi_bi_Vgi_bi=(T3_Vsi_bi_Vgi_bi/(T4+T5)-(T3_Vsi_bi*(T4_Vgi_bi+T5_Vgi_bi)+T3_Vgi_bi*(T4_Vsi_bi+T5_Vsi_bi)+T3*(+T4_Vsi_bi_Vgi_bi+T5_Vsi_bi_Vgi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsi_bi+T5_Vsi_bi)*(T4_Vgi_bi+T5_Vgi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsi_bi_Tempt_GND=(T3_Vsi_bi_Tempt_GND/(T4+T5)-(T3_Vsi_bi*(T4_Tempt_GND+T5_Tempt_GND)+T3_Tempt_GND*(T4_Vsi_bi+T5_Vsi_bi)+T3*(+T4_Vsi_bi_Tempt_GND+T5_Vsi_bi_Tempt_GND))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsi_bi+T5_Vsi_bi)*(T4_Tempt_GND+T5_Tempt_GND)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsi_bi_Vdi_bi=(T3_Vsi_bi_Vdi_bi/(T4+T5)-(T3_Vsi_bi*(T4_Vdi_bi+T5_Vdi_bi)+T3_Vdi_bi*(T4_Vsi_bi+T5_Vsi_bi)+T3*(+T4_Vsi_bi_Vdi_bi+T5_Vsi_bi_Vdi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsi_bi+T5_Vsi_bi)*(T4_Vdi_bi+T5_Vdi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
  nq_Vsi_bi_Vsi_bi=(T3_Vsi_bi_Vsi_bi/(T4+T5)-(T3_Vsi_bi*(T4_Vsi_bi+T5_Vsi_bi)+T3_Vsi_bi*(T4_Vsi_bi+T5_Vsi_bi)+T3*(+T4_Vsi_bi_Vsi_bi+T5_Vsi_bi_Vsi_bi))/(T4+T5)/(T4+T5)+2*T3*(T4_Vsi_bi+T5_Vsi_bi)*(T4_Vsi_bi+T5_Vsi_bi)/(T4+T5)/(T4+T5)/(T4+T5));
#endif
#endif
nq=(T3/(T4+T5));
EXIT_IF_ISNAN((T3/(T4+T5)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=(Vt*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))));
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgm_di)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vgm_di-0.0))));
  T0_Vdbulk_di_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgm_si)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vgm_si-0.0))));
  T0_Vdbulk_di_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vdbulk_di-0.0))));
  T0_Vdbulk_di_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vsbulk_si-0.0))));
  T0_Vdbulk_di_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgi_bi)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vgi_bi-0.0))));
  T0_Vdbulk_di_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vdi_bi)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vdi_bi-0.0))));
  T0_Vdbulk_di_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vsi_bi)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Vsi_bi-0.0))));
  T0_Vdbulk_di_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((-psip_Vdbulk_di)-(((2.0*qs_Vdbulk_di)*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Tempt_GND)*(nq-1.0)+(2.0*qs_Vdbulk_di)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vdbulk_di+(2.0*qs)*(+nq_Vdbulk_di_Tempt_GND-0.0))));
#endif
T0_Vsbulk_si=(Vt*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))));
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgm_di)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vgm_di-0.0))));
  T0_Vsbulk_si_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgm_si)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vgm_si-0.0))));
  T0_Vsbulk_si_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vdbulk_di-0.0))));
  T0_Vsbulk_si_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vsbulk_si-0.0))));
  T0_Vsbulk_si_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgi_bi)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vgi_bi-0.0))));
  T0_Vsbulk_si_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vdi_bi)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vdi_bi-0.0))));
  T0_Vsbulk_si_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vsi_bi)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Vsi_bi-0.0))));
  T0_Vsbulk_si_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((-psip_Vsbulk_si)-(((2.0*qs_Vsbulk_si)*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Tempt_GND)*(nq-1.0)+(2.0*qs_Vsbulk_si)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vsbulk_si+(2.0*qs)*(+nq_Vsbulk_si_Tempt_GND-0.0))));
#endif
T0_Vgi_bi=(Vt*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_di)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vgm_di-0.0))));
  T0_Vgi_bi_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgm_si)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vgm_si-0.0))));
  T0_Vgi_bi_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vdbulk_di-0.0))));
  T0_Vgi_bi_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vsbulk_si-0.0))));
  T0_Vgi_bi_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Vgi_bi-psip_Vgi_bi_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgi_bi)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vgi_bi-0.0))));
  T0_Vgi_bi_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Vdi_bi-psip_Vgi_bi_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdi_bi)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vdi_bi-0.0))));
  T0_Vgi_bi_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Vsi_bi-psip_Vgi_bi_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsi_bi)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Vsi_bi-0.0))));
  T0_Vgi_bi_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qs_Vgi_bi)*(nq-1.0))+((2.0*qs)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Tempt_GND-psip_Vgi_bi_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Tempt_GND)*(nq-1.0)+(2.0*qs_Vgi_bi)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vgi_bi+(2.0*qs)*(+nq_Vgi_bi_Tempt_GND-0.0))));
#endif
T0_Vdi_bi=(Vt*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_di)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vgm_di-0.0))));
  T0_Vdi_bi_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgm_si)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vgm_si-0.0))));
  T0_Vdi_bi_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vdbulk_di-0.0))));
  T0_Vdi_bi_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vsbulk_si-0.0))));
  T0_Vdi_bi_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Vgi_bi-psip_Vdi_bi_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgi_bi)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vgi_bi-0.0))));
  T0_Vdi_bi_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Vdi_bi-psip_Vdi_bi_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdi_bi)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vdi_bi-0.0))));
  T0_Vdi_bi_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Vsi_bi-psip_Vdi_bi_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsi_bi)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Vsi_bi-0.0))));
  T0_Vdi_bi_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qs_Vdi_bi)*(nq-1.0))+((2.0*qs)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Tempt_GND-psip_Vdi_bi_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Tempt_GND)*(nq-1.0)+(2.0*qs_Vdi_bi)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vdi_bi+(2.0*qs)*(+nq_Vdi_bi_Tempt_GND-0.0))));
#endif
T0_Vsi_bi=(Vt*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qs_Vgm_di))*(nq-1.0))+((2.0*qs)*nq_Vgm_di))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vgm_di)-(+(+0.0*qs+0.0*qs_Vgm_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_di)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vgm_di+((2.0*qs_Vgm_di))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vgm_di-0.0))));
  T0_Vsi_bi_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qs_Vgm_si))*(nq-1.0))+((2.0*qs)*nq_Vgm_si))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vgm_si)-(+(+0.0*qs+0.0*qs_Vgm_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgm_si)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vgm_si+((2.0*qs_Vgm_si))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vgm_si-0.0))));
  T0_Vsi_bi_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qs_Vdbulk_di))*(nq-1.0))+((2.0*qs)*nq_Vdbulk_di))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vdbulk_di)-(+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vdbulk_di+((2.0*qs_Vdbulk_di))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vdbulk_di-0.0))));
  T0_Vsi_bi_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qs_Vsbulk_si))*(nq-1.0))+((2.0*qs)*nq_Vsbulk_si))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vsbulk_si)-(+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vsbulk_si+((2.0*qs_Vsbulk_si))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vsbulk_si-0.0))));
  T0_Vsi_bi_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qs_Vgi_bi))*(nq-1.0))+((2.0*qs)*nq_Vgi_bi))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Vgi_bi-psip_Vsi_bi_Vgi_bi)-(+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgi_bi)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vgi_bi+((2.0*qs_Vgi_bi))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vgi_bi-0.0))));
  T0_Vsi_bi_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qs_Vdi_bi))*(nq-1.0))+((2.0*qs)*nq_Vdi_bi))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Vdi_bi-psip_Vsi_bi_Vdi_bi)-(+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdi_bi)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vdi_bi+((2.0*qs_Vdi_bi))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vdi_bi-0.0))));
  T0_Vsi_bi_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qs_Vsi_bi))*(nq-1.0))+((2.0*qs)*nq_Vsi_bi))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Vsi_bi-psip_Vsi_bi_Vsi_bi)-(+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsi_bi)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Vsi_bi+((2.0*qs_Vsi_bi))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Vsi_bi-0.0))));
  T0_Vsi_bi_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qs_Tempt_GND))*(nq-1.0))+((2.0*qs)*nq_Tempt_GND))))+Vt_Tempt_GND*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qs_Vsi_bi)*(nq-1.0))+((2.0*qs)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Tempt_GND-psip_Vsi_bi_Tempt_GND)-(+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Tempt_GND)*(nq-1.0)+(2.0*qs_Vsi_bi)*nq_Tempt_GND+((2.0*qs_Tempt_GND))*nq_Vsi_bi+(2.0*qs)*(+nq_Vsi_bi_Tempt_GND-0.0))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((Vt_Tempt_GND*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))))+(Vt*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((2.0*qs_Tempt_GND)*(nq-1.0))+((2.0*qs)*nq_Tempt_GND)))));
#endif
#endif
T0=(Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
EXIT_IF_ISNAN((Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0)))))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+((0.25*0.1)*0.1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+((0.25*0.1)*0.1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
qbs_Vdbulk_di=(0.5*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vdbulk_di_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vdbulk_di-0.0)*T0+T0_Vdbulk_di*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vsbulk_si-0.0)*T0+T0_Vdbulk_di*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vgi_bi-0.0)*T0+T0_Vdbulk_di*T0_Vgi_bi+T0_Vgi_bi*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vdi_bi-0.0)*T0+T0_Vdbulk_di*T0_Vdi_bi+T0_Vdi_bi*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Vsi_bi-0.0)*T0+T0_Vdbulk_di*T0_Vsi_bi+T0_Vsi_bi*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdbulk_di_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdbulk_di+((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T0_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di))+d10_sqrt0*(+(+(+T0_Vdbulk_di_Tempt_GND-0.0)*T0+T0_Vdbulk_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vdbulk_di+T0*(+T0_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vsbulk_si=(0.5*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vsbulk_si_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vdbulk_di-0.0)*T0+T0_Vsbulk_si*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vsbulk_si-0.0)*T0+T0_Vsbulk_si*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vgi_bi-0.0)*T0+T0_Vsbulk_si*T0_Vgi_bi+T0_Vgi_bi*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vdi_bi-0.0)*T0+T0_Vsbulk_si*T0_Vdi_bi+T0_Vdi_bi*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Vsi_bi-0.0)*T0+T0_Vsbulk_si*T0_Vsi_bi+T0_Vsi_bi*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsbulk_si_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsbulk_si+((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T0_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si))+d10_sqrt0*(+(+(+T0_Vsbulk_si_Tempt_GND-0.0)*T0+T0_Vsbulk_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vsbulk_si+T0*(+T0_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vgi_bi=(0.5*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vgi_bi_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vdbulk_di-0.0)*T0+T0_Vgi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vsbulk_si-0.0)*T0+T0_Vgi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vgi_bi-0.0)*T0+T0_Vgi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vdi_bi-0.0)*T0+T0_Vgi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Vsi_bi-0.0)*T0+T0_Vgi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vgi_bi+T0*(+T0_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vgi_bi_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vgi_bi+((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))*d10_sqrt0)+0.5*(+(+T0_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi))+d10_sqrt0*(+(+(+T0_Vgi_bi_Tempt_GND-0.0)*T0+T0_Vgi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vgi_bi+T0*(+T0_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vdi_bi=(0.5*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vdi_bi_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vdbulk_di-0.0)*T0+T0_Vdi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vsbulk_si-0.0)*T0+T0_Vdi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vgi_bi-0.0)*T0+T0_Vdi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vdi_bi-0.0)*T0+T0_Vdi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Vsi_bi-0.0)*T0+T0_Vdi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vdi_bi+T0*(+T0_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vdi_bi_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vdi_bi+((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))*d10_sqrt0)+0.5*(+(+T0_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi))+d10_sqrt0*(+(+(+T0_Vdi_bi_Tempt_GND-0.0)*T0+T0_Vdi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_bi+T0*(+T0_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbs_Vsi_bi=(0.5*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbs_Vsi_bi_Vdbulk_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdbulk_di+((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdbulk_di*T0)+(T0*T0_Vdbulk_di)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vdbulk_di-0.0)*T0+T0_Vsi_bi*T0_Vdbulk_di+T0_Vdbulk_di*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vsbulk_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsbulk_si+((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsbulk_si*T0)+(T0*T0_Vsbulk_si)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vsbulk_si-0.0)*T0+T0_Vsi_bi*T0_Vsbulk_si+T0_Vsbulk_si*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vgi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vgi_bi+((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vgi_bi*T0)+(T0*T0_Vgi_bi)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vgi_bi-0.0)*T0+T0_Vsi_bi*T0_Vgi_bi+T0_Vgi_bi*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vdi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_bi+((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vdi_bi*T0)+(T0*T0_Vdi_bi)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vdi_bi-0.0)*T0+T0_Vsi_bi*T0_Vdi_bi+T0_Vdi_bi*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Vsi_bi=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vsi_bi+((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Vsi_bi-0.0)*T0+T0_Vsi_bi*T0_Vsi_bi+T0_Vsi_bi*T0_Vsi_bi+T0*(+T0_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbs_Vsi_bi_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T0_Vsi_bi+((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))*d10_sqrt0)+0.5*(+(+T0_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt(((T0*T0)+((0.25*0.1)*0.1)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+((0.0)*0.1))*((T0_Vsi_bi*T0)+(T0*T0_Vsi_bi))+d10_sqrt0*(+(+(+T0_Vsi_bi_Tempt_GND-0.0)*T0+T0_Vsi_bi*T0_Tempt_GND+T0_Tempt_GND*T0_Vsi_bi+T0*(+T0_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
#if defined(_DERIVATE)
qbs_Tempt_GND=(0.5*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0));
#endif
#endif
qbs=(0.5*(T0+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T0+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(Vt*((-psip_Vdbulk_di)-(((2.0*qdeff_Vdbulk_di)*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di))));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qdeff_Vgm_di))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_di))))+0.0*((-psip_Vdbulk_di)-(((2.0*qdeff_Vdbulk_di)*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vgm_di)-(+(+0.0*qdeff+0.0*qdeff_Vgm_di+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vgm_di)*(nq-1.0)+(2.0*qdeff_Vdbulk_di)*nq_Vgm_di+((2.0*qdeff_Vgm_di))*nq_Vdbulk_di+(2.0*qdeff)*(+nq_Vdbulk_di_Vgm_di-0.0))));
  T1_Vdbulk_di_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qdeff_Vgm_si))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_si))))+0.0*((-psip_Vdbulk_di)-(((2.0*qdeff_Vdbulk_di)*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vgm_si)-(+(+0.0*qdeff+0.0*qdeff_Vgm_si+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vgm_si)*(nq-1.0)+(2.0*qdeff_Vdbulk_di)*nq_Vgm_si+((2.0*qdeff_Vgm_si))*nq_Vdbulk_di+(2.0*qdeff)*(+nq_Vdbulk_di_Vgm_si-0.0))));
  T1_Vdbulk_di_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qdeff_Vdbulk_di))*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di))))+0.0*((-psip_Vdbulk_di)-(((2.0*qdeff_Vdbulk_di)*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vdbulk_di)-(+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vdbulk_di)*(nq-1.0)+(2.0*qdeff_Vdbulk_di)*nq_Vdbulk_di+((2.0*qdeff_Vdbulk_di))*nq_Vdbulk_di+(2.0*qdeff)*(+nq_Vdbulk_di_Vdbulk_di-0.0))));
  T1_Vdbulk_di_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qdeff_Vsbulk_si))*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si))))+0.0*((-psip_Vdbulk_di)-(((2.0*qdeff_Vdbulk_di)*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vsbulk_si)-(+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vsbulk_si)*(nq-1.0)+(2.0*qdeff_Vdbulk_di)*nq_Vsbulk_si+((2.0*qdeff_Vsbulk_si))*nq_Vdbulk_di+(2.0*qdeff)*(+nq_Vdbulk_di_Vsbulk_si-0.0))));
  T1_Vdbulk_di_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qdeff_Vgi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi))))+0.0*((-psip_Vdbulk_di)-(((2.0*qdeff_Vdbulk_di)*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vgi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vgi_bi)*(nq-1.0)+(2.0*qdeff_Vdbulk_di)*nq_Vgi_bi+((2.0*qdeff_Vgi_bi))*nq_Vdbulk_di+(2.0*qdeff)*(+nq_Vdbulk_di_Vgi_bi-0.0))));
  T1_Vdbulk_di_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qdeff_Vdi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi))))+0.0*((-psip_Vdbulk_di)-(((2.0*qdeff_Vdbulk_di)*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vdi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vdi_bi)*(nq-1.0)+(2.0*qdeff_Vdbulk_di)*nq_Vdi_bi+((2.0*qdeff_Vdi_bi))*nq_Vdbulk_di+(2.0*qdeff)*(+nq_Vdbulk_di_Vdi_bi-0.0))));
  T1_Vdbulk_di_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qdeff_Vsi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi))))+0.0*((-psip_Vdbulk_di)-(((2.0*qdeff_Vdbulk_di)*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Vsi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vsi_bi)*(nq-1.0)+(2.0*qdeff_Vdbulk_di)*nq_Vsi_bi+((2.0*qdeff_Vsi_bi))*nq_Vdbulk_di+(2.0*qdeff)*(+nq_Vdbulk_di_Vsi_bi-0.0))));
  T1_Vdbulk_di_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qdeff_Tempt_GND))*(nq-1.0))+((2.0*qdeff)*nq_Tempt_GND))))+Vt_Tempt_GND*((-psip_Vdbulk_di)-(((2.0*qdeff_Vdbulk_di)*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di)))+Vt*(+(+0.0-psip_Vdbulk_di_Tempt_GND)-(+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Tempt_GND)*(nq-1.0)+(2.0*qdeff_Vdbulk_di)*nq_Tempt_GND+((2.0*qdeff_Tempt_GND))*nq_Vdbulk_di+(2.0*qdeff)*(+nq_Vdbulk_di_Tempt_GND-0.0))));
#endif
T1_Vsbulk_si=(Vt*((-psip_Vsbulk_si)-(((2.0*qdeff_Vsbulk_si)*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si))));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qdeff_Vgm_di))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_di))))+0.0*((-psip_Vsbulk_si)-(((2.0*qdeff_Vsbulk_si)*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vgm_di)-(+(+0.0*qdeff+0.0*qdeff_Vgm_di+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vgm_di)*(nq-1.0)+(2.0*qdeff_Vsbulk_si)*nq_Vgm_di+((2.0*qdeff_Vgm_di))*nq_Vsbulk_si+(2.0*qdeff)*(+nq_Vsbulk_si_Vgm_di-0.0))));
  T1_Vsbulk_si_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qdeff_Vgm_si))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_si))))+0.0*((-psip_Vsbulk_si)-(((2.0*qdeff_Vsbulk_si)*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vgm_si)-(+(+0.0*qdeff+0.0*qdeff_Vgm_si+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vgm_si)*(nq-1.0)+(2.0*qdeff_Vsbulk_si)*nq_Vgm_si+((2.0*qdeff_Vgm_si))*nq_Vsbulk_si+(2.0*qdeff)*(+nq_Vsbulk_si_Vgm_si-0.0))));
  T1_Vsbulk_si_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qdeff_Vdbulk_di))*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di))))+0.0*((-psip_Vsbulk_si)-(((2.0*qdeff_Vsbulk_si)*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vdbulk_di)-(+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vdbulk_di)*(nq-1.0)+(2.0*qdeff_Vsbulk_si)*nq_Vdbulk_di+((2.0*qdeff_Vdbulk_di))*nq_Vsbulk_si+(2.0*qdeff)*(+nq_Vsbulk_si_Vdbulk_di-0.0))));
  T1_Vsbulk_si_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qdeff_Vsbulk_si))*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si))))+0.0*((-psip_Vsbulk_si)-(((2.0*qdeff_Vsbulk_si)*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vsbulk_si)-(+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vsbulk_si)*(nq-1.0)+(2.0*qdeff_Vsbulk_si)*nq_Vsbulk_si+((2.0*qdeff_Vsbulk_si))*nq_Vsbulk_si+(2.0*qdeff)*(+nq_Vsbulk_si_Vsbulk_si-0.0))));
  T1_Vsbulk_si_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qdeff_Vgi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi))))+0.0*((-psip_Vsbulk_si)-(((2.0*qdeff_Vsbulk_si)*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vgi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vgi_bi)*(nq-1.0)+(2.0*qdeff_Vsbulk_si)*nq_Vgi_bi+((2.0*qdeff_Vgi_bi))*nq_Vsbulk_si+(2.0*qdeff)*(+nq_Vsbulk_si_Vgi_bi-0.0))));
  T1_Vsbulk_si_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qdeff_Vdi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi))))+0.0*((-psip_Vsbulk_si)-(((2.0*qdeff_Vsbulk_si)*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vdi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vdi_bi)*(nq-1.0)+(2.0*qdeff_Vsbulk_si)*nq_Vdi_bi+((2.0*qdeff_Vdi_bi))*nq_Vsbulk_si+(2.0*qdeff)*(+nq_Vsbulk_si_Vdi_bi-0.0))));
  T1_Vsbulk_si_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qdeff_Vsi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi))))+0.0*((-psip_Vsbulk_si)-(((2.0*qdeff_Vsbulk_si)*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Vsi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vsi_bi)*(nq-1.0)+(2.0*qdeff_Vsbulk_si)*nq_Vsi_bi+((2.0*qdeff_Vsi_bi))*nq_Vsbulk_si+(2.0*qdeff)*(+nq_Vsbulk_si_Vsi_bi-0.0))));
  T1_Vsbulk_si_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qdeff_Tempt_GND))*(nq-1.0))+((2.0*qdeff)*nq_Tempt_GND))))+Vt_Tempt_GND*((-psip_Vsbulk_si)-(((2.0*qdeff_Vsbulk_si)*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si)))+Vt*(+(+0.0-psip_Vsbulk_si_Tempt_GND)-(+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Tempt_GND)*(nq-1.0)+(2.0*qdeff_Vsbulk_si)*nq_Tempt_GND+((2.0*qdeff_Tempt_GND))*nq_Vsbulk_si+(2.0*qdeff)*(+nq_Vsbulk_si_Tempt_GND-0.0))));
#endif
T1_Vgi_bi=(Vt*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qdeff_Vgi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi))));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qdeff_Vgm_di))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_di))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qdeff_Vgi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vgm_di)-(+(+0.0*qdeff+0.0*qdeff_Vgm_di+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vgm_di)*(nq-1.0)+(2.0*qdeff_Vgi_bi)*nq_Vgm_di+((2.0*qdeff_Vgm_di))*nq_Vgi_bi+(2.0*qdeff)*(+nq_Vgi_bi_Vgm_di-0.0))));
  T1_Vgi_bi_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qdeff_Vgm_si))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_si))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qdeff_Vgi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vgm_si)-(+(+0.0*qdeff+0.0*qdeff_Vgm_si+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vgm_si)*(nq-1.0)+(2.0*qdeff_Vgi_bi)*nq_Vgm_si+((2.0*qdeff_Vgm_si))*nq_Vgi_bi+(2.0*qdeff)*(+nq_Vgi_bi_Vgm_si-0.0))));
  T1_Vgi_bi_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qdeff_Vdbulk_di))*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qdeff_Vgi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vdbulk_di)-(+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qdeff_Vgi_bi)*nq_Vdbulk_di+((2.0*qdeff_Vdbulk_di))*nq_Vgi_bi+(2.0*qdeff)*(+nq_Vgi_bi_Vdbulk_di-0.0))));
  T1_Vgi_bi_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qdeff_Vsbulk_si))*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qdeff_Vgi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi)))+Vt*(+(+0.0-psip_Vgi_bi_Vsbulk_si)-(+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qdeff_Vgi_bi)*nq_Vsbulk_si+((2.0*qdeff_Vsbulk_si))*nq_Vgi_bi+(2.0*qdeff)*(+nq_Vgi_bi_Vsbulk_si-0.0))));
  T1_Vgi_bi_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qdeff_Vgi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qdeff_Vgi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Vgi_bi-psip_Vgi_bi_Vgi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vgi_bi)*(nq-1.0)+(2.0*qdeff_Vgi_bi)*nq_Vgi_bi+((2.0*qdeff_Vgi_bi))*nq_Vgi_bi+(2.0*qdeff)*(+nq_Vgi_bi_Vgi_bi-0.0))));
  T1_Vgi_bi_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qdeff_Vdi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qdeff_Vgi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Vdi_bi-psip_Vgi_bi_Vdi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vdi_bi)*(nq-1.0)+(2.0*qdeff_Vgi_bi)*nq_Vdi_bi+((2.0*qdeff_Vdi_bi))*nq_Vgi_bi+(2.0*qdeff)*(+nq_Vgi_bi_Vdi_bi-0.0))));
  T1_Vgi_bi_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qdeff_Vsi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi))))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qdeff_Vgi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Vsi_bi-psip_Vgi_bi_Vsi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vsi_bi)*(nq-1.0)+(2.0*qdeff_Vgi_bi)*nq_Vsi_bi+((2.0*qdeff_Vsi_bi))*nq_Vgi_bi+(2.0*qdeff)*(+nq_Vgi_bi_Vsi_bi-0.0))));
  T1_Vgi_bi_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qdeff_Tempt_GND))*(nq-1.0))+((2.0*qdeff)*nq_Tempt_GND))))+Vt_Tempt_GND*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((2.0*qdeff_Vgi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi)))+Vt*(+(+vgfbCV_Vgi_bi_Tempt_GND-psip_Vgi_bi_Tempt_GND)-(+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Tempt_GND)*(nq-1.0)+(2.0*qdeff_Vgi_bi)*nq_Tempt_GND+((2.0*qdeff_Tempt_GND))*nq_Vgi_bi+(2.0*qdeff)*(+nq_Vgi_bi_Tempt_GND-0.0))));
#endif
T1_Vdi_bi=(Vt*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qdeff_Vdi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi))));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qdeff_Vgm_di))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_di))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qdeff_Vdi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vgm_di)-(+(+0.0*qdeff+0.0*qdeff_Vgm_di+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vgm_di)*(nq-1.0)+(2.0*qdeff_Vdi_bi)*nq_Vgm_di+((2.0*qdeff_Vgm_di))*nq_Vdi_bi+(2.0*qdeff)*(+nq_Vdi_bi_Vgm_di-0.0))));
  T1_Vdi_bi_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qdeff_Vgm_si))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_si))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qdeff_Vdi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vgm_si)-(+(+0.0*qdeff+0.0*qdeff_Vgm_si+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vgm_si)*(nq-1.0)+(2.0*qdeff_Vdi_bi)*nq_Vgm_si+((2.0*qdeff_Vgm_si))*nq_Vdi_bi+(2.0*qdeff)*(+nq_Vdi_bi_Vgm_si-0.0))));
  T1_Vdi_bi_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qdeff_Vdbulk_di))*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qdeff_Vdi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vdbulk_di)-(+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qdeff_Vdi_bi)*nq_Vdbulk_di+((2.0*qdeff_Vdbulk_di))*nq_Vdi_bi+(2.0*qdeff)*(+nq_Vdi_bi_Vdbulk_di-0.0))));
  T1_Vdi_bi_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qdeff_Vsbulk_si))*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qdeff_Vdi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi)))+Vt*(+(+0.0-psip_Vdi_bi_Vsbulk_si)-(+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qdeff_Vdi_bi)*nq_Vsbulk_si+((2.0*qdeff_Vsbulk_si))*nq_Vdi_bi+(2.0*qdeff)*(+nq_Vdi_bi_Vsbulk_si-0.0))));
  T1_Vdi_bi_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qdeff_Vgi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qdeff_Vdi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Vgi_bi-psip_Vdi_bi_Vgi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vgi_bi)*(nq-1.0)+(2.0*qdeff_Vdi_bi)*nq_Vgi_bi+((2.0*qdeff_Vgi_bi))*nq_Vdi_bi+(2.0*qdeff)*(+nq_Vdi_bi_Vgi_bi-0.0))));
  T1_Vdi_bi_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qdeff_Vdi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qdeff_Vdi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Vdi_bi-psip_Vdi_bi_Vdi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vdi_bi)*(nq-1.0)+(2.0*qdeff_Vdi_bi)*nq_Vdi_bi+((2.0*qdeff_Vdi_bi))*nq_Vdi_bi+(2.0*qdeff)*(+nq_Vdi_bi_Vdi_bi-0.0))));
  T1_Vdi_bi_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qdeff_Vsi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi))))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qdeff_Vdi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Vsi_bi-psip_Vdi_bi_Vsi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vsi_bi)*(nq-1.0)+(2.0*qdeff_Vdi_bi)*nq_Vsi_bi+((2.0*qdeff_Vsi_bi))*nq_Vdi_bi+(2.0*qdeff)*(+nq_Vdi_bi_Vsi_bi-0.0))));
  T1_Vdi_bi_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qdeff_Tempt_GND))*(nq-1.0))+((2.0*qdeff)*nq_Tempt_GND))))+Vt_Tempt_GND*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((2.0*qdeff_Vdi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi)))+Vt*(+(+vgfbCV_Vdi_bi_Tempt_GND-psip_Vdi_bi_Tempt_GND)-(+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Tempt_GND)*(nq-1.0)+(2.0*qdeff_Vdi_bi)*nq_Tempt_GND+((2.0*qdeff_Tempt_GND))*nq_Vdi_bi+(2.0*qdeff)*(+nq_Vdi_bi_Tempt_GND-0.0))));
#endif
T1_Vsi_bi=(Vt*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qdeff_Vsi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi))));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_di)-(((((2.0*qdeff_Vgm_di))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_di))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qdeff_Vsi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vgm_di)-(+(+0.0*qdeff+0.0*qdeff_Vgm_di+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vgm_di)*(nq-1.0)+(2.0*qdeff_Vsi_bi)*nq_Vgm_di+((2.0*qdeff_Vgm_di))*nq_Vsi_bi+(2.0*qdeff)*(+nq_Vsi_bi_Vgm_di-0.0))));
  T1_Vsi_bi_Vgm_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vgm_si)-(((((2.0*qdeff_Vgm_si))*(nq-1.0))+((2.0*qdeff)*nq_Vgm_si))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qdeff_Vsi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vgm_si)-(+(+0.0*qdeff+0.0*qdeff_Vgm_si+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vgm_si)*(nq-1.0)+(2.0*qdeff_Vsi_bi)*nq_Vgm_si+((2.0*qdeff_Vgm_si))*nq_Vsi_bi+(2.0*qdeff)*(+nq_Vsi_bi_Vgm_si-0.0))));
  T1_Vsi_bi_Vdbulk_di=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vdbulk_di)-(((((2.0*qdeff_Vdbulk_di))*(nq-1.0))+((2.0*qdeff)*nq_Vdbulk_di))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qdeff_Vsi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vdbulk_di)-(+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vdbulk_di)*(nq-1.0)+(2.0*qdeff_Vsi_bi)*nq_Vdbulk_di+((2.0*qdeff_Vdbulk_di))*nq_Vsi_bi+(2.0*qdeff)*(+nq_Vsi_bi_Vdbulk_di-0.0))));
  T1_Vsi_bi_Vsbulk_si=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((-psip_Vsbulk_si)-(((((2.0*qdeff_Vsbulk_si))*(nq-1.0))+((2.0*qdeff)*nq_Vsbulk_si))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qdeff_Vsi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi)))+Vt*(+(+0.0-psip_Vsi_bi_Vsbulk_si)-(+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vsbulk_si)*(nq-1.0)+(2.0*qdeff_Vsi_bi)*nq_Vsbulk_si+((2.0*qdeff_Vsbulk_si))*nq_Vsi_bi+(2.0*qdeff)*(+nq_Vsi_bi_Vsbulk_si-0.0))));
  T1_Vsi_bi_Vgi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vgi_bi-psip_Vgi_bi)-(((((2.0*qdeff_Vgi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vgi_bi))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qdeff_Vsi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Vgi_bi-psip_Vsi_bi_Vgi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vgi_bi)*(nq-1.0)+(2.0*qdeff_Vsi_bi)*nq_Vgi_bi+((2.0*qdeff_Vgi_bi))*nq_Vsi_bi+(2.0*qdeff)*(+nq_Vsi_bi_Vgi_bi-0.0))));
  T1_Vsi_bi_Vdi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vdi_bi-psip_Vdi_bi)-(((((2.0*qdeff_Vdi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vdi_bi))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qdeff_Vsi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Vdi_bi-psip_Vsi_bi_Vdi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vdi_bi)*(nq-1.0)+(2.0*qdeff_Vsi_bi)*nq_Vdi_bi+((2.0*qdeff_Vdi_bi))*nq_Vsi_bi+(2.0*qdeff)*(+nq_Vsi_bi_Vdi_bi-0.0))));
  T1_Vsi_bi_Vsi_bi=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((((2.0*qdeff_Vsi_bi))*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi))))+0.0*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qdeff_Vsi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Vsi_bi-psip_Vsi_bi_Vsi_bi)-(+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vsi_bi)*(nq-1.0)+(2.0*qdeff_Vsi_bi)*nq_Vsi_bi+((2.0*qdeff_Vsi_bi))*nq_Vsi_bi+(2.0*qdeff)*(+nq_Vsi_bi_Vsi_bi-0.0))));
  T1_Vsi_bi_Tempt_GND=(+0.0*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))+0.0*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((((2.0*qdeff_Tempt_GND))*(nq-1.0))+((2.0*qdeff)*nq_Tempt_GND))))+Vt_Tempt_GND*((vgfbCV_Vsi_bi-psip_Vsi_bi)-(((2.0*qdeff_Vsi_bi)*(nq-1.0))+((2.0*qdeff)*nq_Vsi_bi)))+Vt*(+(+vgfbCV_Vsi_bi_Tempt_GND-psip_Vsi_bi_Tempt_GND)-(+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Tempt_GND)*(nq-1.0)+(2.0*qdeff_Vsi_bi)*nq_Tempt_GND+((2.0*qdeff_Tempt_GND))*nq_Vsi_bi+(2.0*qdeff)*(+nq_Vsi_bi_Tempt_GND-0.0))));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((Vt_Tempt_GND*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0))))+(Vt*((vgfbCV_Tempt_GND-psip_Tempt_GND)-(((2.0*qdeff_Tempt_GND)*(nq-1.0))+((2.0*qdeff)*nq_Tempt_GND)))));
#endif
#endif
T1=(Vt*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0))));
EXIT_IF_ISNAN((Vt*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0)))))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+((0.25*0.1)*0.1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+((0.25*0.1)*0.1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
qbd_Vdbulk_di=(0.5*(T1_Vdbulk_di+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbd_Vdbulk_di_Vdbulk_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vdbulk_di-0.0)*T1+T1_Vdbulk_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdbulk_di+T1*(+T1_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdbulk_di_Vsbulk_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vsbulk_si-0.0)*T1+T1_Vdbulk_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdbulk_di+T1*(+T1_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdbulk_di_Vgi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vgi_bi-0.0)*T1+T1_Vdbulk_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vdbulk_di+T1*(+T1_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdbulk_di_Vdi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vdi_bi-0.0)*T1+T1_Vdbulk_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vdbulk_di+T1*(+T1_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdbulk_di_Vsi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vsi_bi-0.0)*T1+T1_Vdbulk_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vdbulk_di+T1*(+T1_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdbulk_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Tempt_GND-0.0)*T1+T1_Vdbulk_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vdbulk_di+T1*(+T1_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbd_Vsbulk_si=(0.5*(T1_Vsbulk_si+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbd_Vsbulk_si_Vdbulk_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vdbulk_di-0.0)*T1+T1_Vsbulk_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsbulk_si+T1*(+T1_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsbulk_si_Vsbulk_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vsbulk_si-0.0)*T1+T1_Vsbulk_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsbulk_si+T1*(+T1_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsbulk_si_Vgi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vgi_bi-0.0)*T1+T1_Vsbulk_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vsbulk_si+T1*(+T1_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsbulk_si_Vdi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vdi_bi-0.0)*T1+T1_Vsbulk_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vsbulk_si+T1*(+T1_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsbulk_si_Vsi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vsi_bi-0.0)*T1+T1_Vsbulk_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vsbulk_si+T1*(+T1_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsbulk_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Tempt_GND-0.0)*T1+T1_Vsbulk_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vsbulk_si+T1*(+T1_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbd_Vgi_bi=(0.5*(T1_Vgi_bi+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbd_Vgi_bi_Vdbulk_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vdbulk_di-0.0)*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*(+T1_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vgi_bi_Vsbulk_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vsbulk_si-0.0)*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*(+T1_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vgi_bi_Vgi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vgi_bi-0.0)*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*(+T1_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vgi_bi_Vdi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vdi_bi-0.0)*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*(+T1_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vgi_bi_Vsi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vsi_bi-0.0)*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*(+T1_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vgi_bi_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Tempt_GND-0.0)*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*(+T1_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbd_Vdi_bi=(0.5*(T1_Vdi_bi+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbd_Vdi_bi_Vdbulk_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vdbulk_di-0.0)*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*(+T1_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdi_bi_Vsbulk_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vsbulk_si-0.0)*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*(+T1_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdi_bi_Vgi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vgi_bi-0.0)*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*(+T1_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdi_bi_Vdi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vdi_bi-0.0)*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*(+T1_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdi_bi_Vsi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vsi_bi-0.0)*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*(+T1_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vdi_bi_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Tempt_GND-0.0)*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*(+T1_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbd_Vsi_bi=(0.5*(T1_Vsi_bi+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbd_Vsi_bi_Vdbulk_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((0.0)*0.1))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vdbulk_di-0.0)*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*(+T1_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsi_bi_Vsbulk_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((0.0)*0.1))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vsbulk_si-0.0)*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*(+T1_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsi_bi_Vgi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((0.0)*0.1))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vgi_bi-0.0)*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*(+T1_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsi_bi_Vdi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((0.0)*0.1))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vdi_bi-0.0)*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*(+T1_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsi_bi_Vsi_bi=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((0.0)*0.1))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vsi_bi-0.0)*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*(+T1_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbd_Vsi_bi_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt(((T1*T1)+((0.25*0.1)*0.1)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((0.0)*0.1))*((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Tempt_GND-0.0)*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*(+T1_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
#if defined(_DERIVATE)
qbd_Tempt_GND=(0.5*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0));
#endif
#endif
qbd=(0.5*(T1+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T1+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
qb_Vdbulk_di=(0.5*(qbs_Vdbulk_di+qbd_Vdbulk_di));
#if defined(_DERIVATE2)
  qb_Vdbulk_di_Vdbulk_di=(+0.0*(qbs+qbd)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.5*(+qbs_Vdbulk_di_Vdbulk_di+qbd_Vdbulk_di_Vdbulk_di));
  qb_Vdbulk_di_Vsbulk_si=(+0.0*(qbs+qbd)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.5*(+qbs_Vdbulk_di_Vsbulk_si+qbd_Vdbulk_di_Vsbulk_si));
  qb_Vdbulk_di_Vgi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.5*(+qbs_Vdbulk_di_Vgi_bi+qbd_Vdbulk_di_Vgi_bi));
  qb_Vdbulk_di_Vdi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.5*(+qbs_Vdbulk_di_Vdi_bi+qbd_Vdbulk_di_Vdi_bi));
  qb_Vdbulk_di_Vsi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.5*(+qbs_Vdbulk_di_Vsi_bi+qbd_Vdbulk_di_Vsi_bi));
  qb_Vdbulk_di_Tempt_GND=(+0.0*(qbs+qbd)+0.0*(qbs_Tempt_GND+qbd_Tempt_GND)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.5*(+qbs_Vdbulk_di_Tempt_GND+qbd_Vdbulk_di_Tempt_GND));
#endif
qb_Vsbulk_si=(0.5*(qbs_Vsbulk_si+qbd_Vsbulk_si));
#if defined(_DERIVATE2)
  qb_Vsbulk_si_Vdbulk_di=(+0.0*(qbs+qbd)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.5*(+qbs_Vsbulk_si_Vdbulk_di+qbd_Vsbulk_si_Vdbulk_di));
  qb_Vsbulk_si_Vsbulk_si=(+0.0*(qbs+qbd)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.5*(+qbs_Vsbulk_si_Vsbulk_si+qbd_Vsbulk_si_Vsbulk_si));
  qb_Vsbulk_si_Vgi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.5*(+qbs_Vsbulk_si_Vgi_bi+qbd_Vsbulk_si_Vgi_bi));
  qb_Vsbulk_si_Vdi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.5*(+qbs_Vsbulk_si_Vdi_bi+qbd_Vsbulk_si_Vdi_bi));
  qb_Vsbulk_si_Vsi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.5*(+qbs_Vsbulk_si_Vsi_bi+qbd_Vsbulk_si_Vsi_bi));
  qb_Vsbulk_si_Tempt_GND=(+0.0*(qbs+qbd)+0.0*(qbs_Tempt_GND+qbd_Tempt_GND)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.5*(+qbs_Vsbulk_si_Tempt_GND+qbd_Vsbulk_si_Tempt_GND));
#endif
qb_Vgi_bi=(0.5*(qbs_Vgi_bi+qbd_Vgi_bi));
#if defined(_DERIVATE2)
  qb_Vgi_bi_Vdbulk_di=(+0.0*(qbs+qbd)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.5*(+qbs_Vgi_bi_Vdbulk_di+qbd_Vgi_bi_Vdbulk_di));
  qb_Vgi_bi_Vsbulk_si=(+0.0*(qbs+qbd)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.5*(+qbs_Vgi_bi_Vsbulk_si+qbd_Vgi_bi_Vsbulk_si));
  qb_Vgi_bi_Vgi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.5*(+qbs_Vgi_bi_Vgi_bi+qbd_Vgi_bi_Vgi_bi));
  qb_Vgi_bi_Vdi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.5*(+qbs_Vgi_bi_Vdi_bi+qbd_Vgi_bi_Vdi_bi));
  qb_Vgi_bi_Vsi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.5*(+qbs_Vgi_bi_Vsi_bi+qbd_Vgi_bi_Vsi_bi));
  qb_Vgi_bi_Tempt_GND=(+0.0*(qbs+qbd)+0.0*(qbs_Tempt_GND+qbd_Tempt_GND)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.5*(+qbs_Vgi_bi_Tempt_GND+qbd_Vgi_bi_Tempt_GND));
#endif
qb_Vdi_bi=(0.5*(qbs_Vdi_bi+qbd_Vdi_bi));
#if defined(_DERIVATE2)
  qb_Vdi_bi_Vdbulk_di=(+0.0*(qbs+qbd)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.5*(+qbs_Vdi_bi_Vdbulk_di+qbd_Vdi_bi_Vdbulk_di));
  qb_Vdi_bi_Vsbulk_si=(+0.0*(qbs+qbd)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.5*(+qbs_Vdi_bi_Vsbulk_si+qbd_Vdi_bi_Vsbulk_si));
  qb_Vdi_bi_Vgi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.5*(+qbs_Vdi_bi_Vgi_bi+qbd_Vdi_bi_Vgi_bi));
  qb_Vdi_bi_Vdi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.5*(+qbs_Vdi_bi_Vdi_bi+qbd_Vdi_bi_Vdi_bi));
  qb_Vdi_bi_Vsi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.5*(+qbs_Vdi_bi_Vsi_bi+qbd_Vdi_bi_Vsi_bi));
  qb_Vdi_bi_Tempt_GND=(+0.0*(qbs+qbd)+0.0*(qbs_Tempt_GND+qbd_Tempt_GND)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.5*(+qbs_Vdi_bi_Tempt_GND+qbd_Vdi_bi_Tempt_GND));
#endif
qb_Vsi_bi=(0.5*(qbs_Vsi_bi+qbd_Vsi_bi));
#if defined(_DERIVATE2)
  qb_Vsi_bi_Vdbulk_di=(+0.0*(qbs+qbd)+0.0*(qbs_Vdbulk_di+qbd_Vdbulk_di)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.5*(+qbs_Vsi_bi_Vdbulk_di+qbd_Vsi_bi_Vdbulk_di));
  qb_Vsi_bi_Vsbulk_si=(+0.0*(qbs+qbd)+0.0*(qbs_Vsbulk_si+qbd_Vsbulk_si)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.5*(+qbs_Vsi_bi_Vsbulk_si+qbd_Vsi_bi_Vsbulk_si));
  qb_Vsi_bi_Vgi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vgi_bi+qbd_Vgi_bi)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.5*(+qbs_Vsi_bi_Vgi_bi+qbd_Vsi_bi_Vgi_bi));
  qb_Vsi_bi_Vdi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vdi_bi+qbd_Vdi_bi)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.5*(+qbs_Vsi_bi_Vdi_bi+qbd_Vsi_bi_Vdi_bi));
  qb_Vsi_bi_Vsi_bi=(+0.0*(qbs+qbd)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.5*(+qbs_Vsi_bi_Vsi_bi+qbd_Vsi_bi_Vsi_bi));
  qb_Vsi_bi_Tempt_GND=(+0.0*(qbs+qbd)+0.0*(qbs_Tempt_GND+qbd_Tempt_GND)+0.0*(qbs_Vsi_bi+qbd_Vsi_bi)+0.5*(+qbs_Vsi_bi_Tempt_GND+qbd_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
qb_Tempt_GND=(0.5*(qbs_Tempt_GND+qbd_Tempt_GND));
#endif
#endif
qb=(0.5*(qbs+qbd));
EXIT_IF_ISNAN((0.5*(qbs+qbd)))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
qia_Vdbulk_di=((nq_Vdbulk_di*Vt*(qs+qdeff))+((nq*Vt)*(qs_Vdbulk_di+qdeff_Vdbulk_di)));
#if defined(_DERIVATE2)
  qia_Vdbulk_di_Vdbulk_di=(+(+nq_Vdbulk_di_Vdbulk_di*Vt+nq_Vdbulk_di*0.0+nq_Vdbulk_di*0.0+nq*0.0)*(qs+qdeff)+nq_Vdbulk_di*Vt*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq_Vdbulk_di*Vt)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq*Vt)*(+qs_Vdbulk_di_Vdbulk_di+qdeff_Vdbulk_di_Vdbulk_di));
  qia_Vdbulk_di_Vsbulk_si=(+(+nq_Vdbulk_di_Vsbulk_si*Vt+nq_Vdbulk_di*0.0+nq_Vsbulk_si*0.0+nq*0.0)*(qs+qdeff)+nq_Vdbulk_di*Vt*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq_Vsbulk_si*Vt)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq*Vt)*(+qs_Vdbulk_di_Vsbulk_si+qdeff_Vdbulk_di_Vsbulk_si));
  qia_Vdbulk_di_Vdi_bi=(+(+nq_Vdbulk_di_Vdi_bi*Vt+nq_Vdbulk_di*0.0+nq_Vdi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vdbulk_di*Vt*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq_Vdi_bi*Vt)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq*Vt)*(+qs_Vdbulk_di_Vdi_bi+qdeff_Vdbulk_di_Vdi_bi));
  qia_Vdbulk_di_Vsi_bi=(+(+nq_Vdbulk_di_Vsi_bi*Vt+nq_Vdbulk_di*0.0+nq_Vsi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vdbulk_di*Vt*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq_Vsi_bi*Vt)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq*Vt)*(+qs_Vdbulk_di_Vsi_bi+qdeff_Vdbulk_di_Vsi_bi));
  qia_Vdbulk_di_Tempt_GND=(+(+nq_Vdbulk_di_Tempt_GND*Vt+nq_Vdbulk_di*Vt_Tempt_GND+nq_Tempt_GND*0.0+nq*0.0)*(qs+qdeff)+nq_Vdbulk_di*Vt*(qs_Tempt_GND+qdeff_Tempt_GND)+(((nq_Tempt_GND*Vt)+(nq*Vt_Tempt_GND)))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq*Vt)*(+qs_Vdbulk_di_Tempt_GND+qdeff_Vdbulk_di_Tempt_GND));
  qia_Vdbulk_di_Vgi_bi=(+(+nq_Vdbulk_di_Vgi_bi*Vt+nq_Vdbulk_di*0.0+nq_Vgi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vdbulk_di*Vt*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq_Vgi_bi*Vt)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq*Vt)*(+qs_Vdbulk_di_Vgi_bi+qdeff_Vdbulk_di_Vgi_bi));
#endif
qia_Vsbulk_si=((nq_Vsbulk_si*Vt*(qs+qdeff))+((nq*Vt)*(qs_Vsbulk_si+qdeff_Vsbulk_si)));
#if defined(_DERIVATE2)
  qia_Vsbulk_si_Vdbulk_di=(+(+nq_Vsbulk_si_Vdbulk_di*Vt+nq_Vsbulk_si*0.0+nq_Vdbulk_di*0.0+nq*0.0)*(qs+qdeff)+nq_Vsbulk_si*Vt*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq_Vdbulk_di*Vt)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq*Vt)*(+qs_Vsbulk_si_Vdbulk_di+qdeff_Vsbulk_si_Vdbulk_di));
  qia_Vsbulk_si_Vsbulk_si=(+(+nq_Vsbulk_si_Vsbulk_si*Vt+nq_Vsbulk_si*0.0+nq_Vsbulk_si*0.0+nq*0.0)*(qs+qdeff)+nq_Vsbulk_si*Vt*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq_Vsbulk_si*Vt)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq*Vt)*(+qs_Vsbulk_si_Vsbulk_si+qdeff_Vsbulk_si_Vsbulk_si));
  qia_Vsbulk_si_Vdi_bi=(+(+nq_Vsbulk_si_Vdi_bi*Vt+nq_Vsbulk_si*0.0+nq_Vdi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vsbulk_si*Vt*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq_Vdi_bi*Vt)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq*Vt)*(+qs_Vsbulk_si_Vdi_bi+qdeff_Vsbulk_si_Vdi_bi));
  qia_Vsbulk_si_Vsi_bi=(+(+nq_Vsbulk_si_Vsi_bi*Vt+nq_Vsbulk_si*0.0+nq_Vsi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vsbulk_si*Vt*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq_Vsi_bi*Vt)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq*Vt)*(+qs_Vsbulk_si_Vsi_bi+qdeff_Vsbulk_si_Vsi_bi));
  qia_Vsbulk_si_Tempt_GND=(+(+nq_Vsbulk_si_Tempt_GND*Vt+nq_Vsbulk_si*Vt_Tempt_GND+nq_Tempt_GND*0.0+nq*0.0)*(qs+qdeff)+nq_Vsbulk_si*Vt*(qs_Tempt_GND+qdeff_Tempt_GND)+(((nq_Tempt_GND*Vt)+(nq*Vt_Tempt_GND)))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq*Vt)*(+qs_Vsbulk_si_Tempt_GND+qdeff_Vsbulk_si_Tempt_GND));
  qia_Vsbulk_si_Vgi_bi=(+(+nq_Vsbulk_si_Vgi_bi*Vt+nq_Vsbulk_si*0.0+nq_Vgi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vsbulk_si*Vt*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq_Vgi_bi*Vt)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq*Vt)*(+qs_Vsbulk_si_Vgi_bi+qdeff_Vsbulk_si_Vgi_bi));
#endif
qia_Vdi_bi=((nq_Vdi_bi*Vt*(qs+qdeff))+((nq*Vt)*(qs_Vdi_bi+qdeff_Vdi_bi)));
#if defined(_DERIVATE2)
  qia_Vdi_bi_Vdbulk_di=(+(+nq_Vdi_bi_Vdbulk_di*Vt+nq_Vdi_bi*0.0+nq_Vdbulk_di*0.0+nq*0.0)*(qs+qdeff)+nq_Vdi_bi*Vt*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq_Vdbulk_di*Vt)*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*Vt)*(+qs_Vdi_bi_Vdbulk_di+qdeff_Vdi_bi_Vdbulk_di));
  qia_Vdi_bi_Vsbulk_si=(+(+nq_Vdi_bi_Vsbulk_si*Vt+nq_Vdi_bi*0.0+nq_Vsbulk_si*0.0+nq*0.0)*(qs+qdeff)+nq_Vdi_bi*Vt*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq_Vsbulk_si*Vt)*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*Vt)*(+qs_Vdi_bi_Vsbulk_si+qdeff_Vdi_bi_Vsbulk_si));
  qia_Vdi_bi_Vdi_bi=(+(+nq_Vdi_bi_Vdi_bi*Vt+nq_Vdi_bi*0.0+nq_Vdi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vdi_bi*Vt*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq_Vdi_bi*Vt)*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*Vt)*(+qs_Vdi_bi_Vdi_bi+qdeff_Vdi_bi_Vdi_bi));
  qia_Vdi_bi_Vsi_bi=(+(+nq_Vdi_bi_Vsi_bi*Vt+nq_Vdi_bi*0.0+nq_Vsi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vdi_bi*Vt*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq_Vsi_bi*Vt)*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*Vt)*(+qs_Vdi_bi_Vsi_bi+qdeff_Vdi_bi_Vsi_bi));
  qia_Vdi_bi_Tempt_GND=(+(+nq_Vdi_bi_Tempt_GND*Vt+nq_Vdi_bi*Vt_Tempt_GND+nq_Tempt_GND*0.0+nq*0.0)*(qs+qdeff)+nq_Vdi_bi*Vt*(qs_Tempt_GND+qdeff_Tempt_GND)+(((nq_Tempt_GND*Vt)+(nq*Vt_Tempt_GND)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*Vt)*(+qs_Vdi_bi_Tempt_GND+qdeff_Vdi_bi_Tempt_GND));
  qia_Vdi_bi_Vgi_bi=(+(+nq_Vdi_bi_Vgi_bi*Vt+nq_Vdi_bi*0.0+nq_Vgi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vdi_bi*Vt*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq_Vgi_bi*Vt)*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq*Vt)*(+qs_Vdi_bi_Vgi_bi+qdeff_Vdi_bi_Vgi_bi));
#endif
qia_Vsi_bi=((nq_Vsi_bi*Vt*(qs+qdeff))+((nq*Vt)*(qs_Vsi_bi+qdeff_Vsi_bi)));
#if defined(_DERIVATE2)
  qia_Vsi_bi_Vdbulk_di=(+(+nq_Vsi_bi_Vdbulk_di*Vt+nq_Vsi_bi*0.0+nq_Vdbulk_di*0.0+nq*0.0)*(qs+qdeff)+nq_Vsi_bi*Vt*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq_Vdbulk_di*Vt)*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*Vt)*(+qs_Vsi_bi_Vdbulk_di+qdeff_Vsi_bi_Vdbulk_di));
  qia_Vsi_bi_Vsbulk_si=(+(+nq_Vsi_bi_Vsbulk_si*Vt+nq_Vsi_bi*0.0+nq_Vsbulk_si*0.0+nq*0.0)*(qs+qdeff)+nq_Vsi_bi*Vt*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq_Vsbulk_si*Vt)*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*Vt)*(+qs_Vsi_bi_Vsbulk_si+qdeff_Vsi_bi_Vsbulk_si));
  qia_Vsi_bi_Vdi_bi=(+(+nq_Vsi_bi_Vdi_bi*Vt+nq_Vsi_bi*0.0+nq_Vdi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vsi_bi*Vt*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq_Vdi_bi*Vt)*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*Vt)*(+qs_Vsi_bi_Vdi_bi+qdeff_Vsi_bi_Vdi_bi));
  qia_Vsi_bi_Vsi_bi=(+(+nq_Vsi_bi_Vsi_bi*Vt+nq_Vsi_bi*0.0+nq_Vsi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vsi_bi*Vt*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq_Vsi_bi*Vt)*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*Vt)*(+qs_Vsi_bi_Vsi_bi+qdeff_Vsi_bi_Vsi_bi));
  qia_Vsi_bi_Tempt_GND=(+(+nq_Vsi_bi_Tempt_GND*Vt+nq_Vsi_bi*Vt_Tempt_GND+nq_Tempt_GND*0.0+nq*0.0)*(qs+qdeff)+nq_Vsi_bi*Vt*(qs_Tempt_GND+qdeff_Tempt_GND)+(((nq_Tempt_GND*Vt)+(nq*Vt_Tempt_GND)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*Vt)*(+qs_Vsi_bi_Tempt_GND+qdeff_Vsi_bi_Tempt_GND));
  qia_Vsi_bi_Vgi_bi=(+(+nq_Vsi_bi_Vgi_bi*Vt+nq_Vsi_bi*0.0+nq_Vgi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vsi_bi*Vt*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq_Vgi_bi*Vt)*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq*Vt)*(+qs_Vsi_bi_Vgi_bi+qdeff_Vsi_bi_Vgi_bi));
#endif
#if defined(_DERIVATE)
qia_Tempt_GND=((((nq_Tempt_GND*Vt)+(nq*Vt_Tempt_GND))*(qs+qdeff))+((nq*Vt)*(qs_Tempt_GND+qdeff_Tempt_GND)));
#endif
qia_Vgi_bi=((nq_Vgi_bi*Vt*(qs+qdeff))+((nq*Vt)*(qs_Vgi_bi+qdeff_Vgi_bi)));
#if defined(_DERIVATE2)
  qia_Vgi_bi_Vdbulk_di=(+(+nq_Vgi_bi_Vdbulk_di*Vt+nq_Vgi_bi*0.0+nq_Vdbulk_di*0.0+nq*0.0)*(qs+qdeff)+nq_Vgi_bi*Vt*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(nq_Vdbulk_di*Vt)*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*Vt)*(+qs_Vgi_bi_Vdbulk_di+qdeff_Vgi_bi_Vdbulk_di));
  qia_Vgi_bi_Vsbulk_si=(+(+nq_Vgi_bi_Vsbulk_si*Vt+nq_Vgi_bi*0.0+nq_Vsbulk_si*0.0+nq*0.0)*(qs+qdeff)+nq_Vgi_bi*Vt*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(nq_Vsbulk_si*Vt)*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*Vt)*(+qs_Vgi_bi_Vsbulk_si+qdeff_Vgi_bi_Vsbulk_si));
  qia_Vgi_bi_Vdi_bi=(+(+nq_Vgi_bi_Vdi_bi*Vt+nq_Vgi_bi*0.0+nq_Vdi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vgi_bi*Vt*(qs_Vdi_bi+qdeff_Vdi_bi)+(nq_Vdi_bi*Vt)*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*Vt)*(+qs_Vgi_bi_Vdi_bi+qdeff_Vgi_bi_Vdi_bi));
  qia_Vgi_bi_Vsi_bi=(+(+nq_Vgi_bi_Vsi_bi*Vt+nq_Vgi_bi*0.0+nq_Vsi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vgi_bi*Vt*(qs_Vsi_bi+qdeff_Vsi_bi)+(nq_Vsi_bi*Vt)*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*Vt)*(+qs_Vgi_bi_Vsi_bi+qdeff_Vgi_bi_Vsi_bi));
  qia_Vgi_bi_Tempt_GND=(+(+nq_Vgi_bi_Tempt_GND*Vt+nq_Vgi_bi*Vt_Tempt_GND+nq_Tempt_GND*0.0+nq*0.0)*(qs+qdeff)+nq_Vgi_bi*Vt*(qs_Tempt_GND+qdeff_Tempt_GND)+(((nq_Tempt_GND*Vt)+(nq*Vt_Tempt_GND)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*Vt)*(+qs_Vgi_bi_Tempt_GND+qdeff_Vgi_bi_Tempt_GND));
  qia_Vgi_bi_Vgi_bi=(+(+nq_Vgi_bi_Vgi_bi*Vt+nq_Vgi_bi*0.0+nq_Vgi_bi*0.0+nq*0.0)*(qs+qdeff)+nq_Vgi_bi*Vt*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq_Vgi_bi*Vt)*(qs_Vgi_bi+qdeff_Vgi_bi)+(nq*Vt)*(+qs_Vgi_bi_Vgi_bi+qdeff_Vgi_bi_Vgi_bi));
#endif
#endif
qia=((nq*Vt)*(qs+qdeff));
EXIT_IF_ISNAN(((nq*Vt)*(qs+qdeff)))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
Eeffm_Vdbulk_di=(EeffFactor*(qb_Vdbulk_di+(eta_mu*qia_Vdbulk_di)));
#if defined(_DERIVATE2)
  Eeffm_Vdbulk_di_Vdbulk_di=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdbulk_di+((eta_mu*qia_Vdbulk_di)))+0.0*(qb_Vdbulk_di+(eta_mu*qia_Vdbulk_di))+EeffFactor*(+qb_Vdbulk_di_Vdbulk_di+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vdbulk_di+eta_mu*qia_Vdbulk_di_Vdbulk_di)));
  Eeffm_Vdbulk_di_Vsbulk_si=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsbulk_si+((eta_mu*qia_Vsbulk_si)))+0.0*(qb_Vdbulk_di+(eta_mu*qia_Vdbulk_di))+EeffFactor*(+qb_Vdbulk_di_Vsbulk_si+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vdbulk_di+eta_mu*qia_Vdbulk_di_Vsbulk_si)));
  Eeffm_Vdbulk_di_Vdi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdi_bi+((eta_mu*qia_Vdi_bi)))+0.0*(qb_Vdbulk_di+(eta_mu*qia_Vdbulk_di))+EeffFactor*(+qb_Vdbulk_di_Vdi_bi+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vdbulk_di+eta_mu*qia_Vdbulk_di_Vdi_bi)));
  Eeffm_Vdbulk_di_Vsi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsi_bi+((eta_mu*qia_Vsi_bi)))+0.0*(qb_Vdbulk_di+(eta_mu*qia_Vdbulk_di))+EeffFactor*(+qb_Vdbulk_di_Vsi_bi+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vdbulk_di+eta_mu*qia_Vdbulk_di_Vsi_bi)));
  Eeffm_Vdbulk_di_Tempt_GND=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Tempt_GND+((eta_mu*qia_Tempt_GND)))+0.0*(qb_Vdbulk_di+(eta_mu*qia_Vdbulk_di))+EeffFactor*(+qb_Vdbulk_di_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdbulk_di+eta_mu*qia_Vdbulk_di_Tempt_GND)));
  Eeffm_Vdbulk_di_Vgi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vgi_bi+((eta_mu*qia_Vgi_bi)))+0.0*(qb_Vdbulk_di+(eta_mu*qia_Vdbulk_di))+EeffFactor*(+qb_Vdbulk_di_Vgi_bi+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vdbulk_di+eta_mu*qia_Vdbulk_di_Vgi_bi)));
#endif
Eeffm_Vsbulk_si=(EeffFactor*(qb_Vsbulk_si+(eta_mu*qia_Vsbulk_si)));
#if defined(_DERIVATE2)
  Eeffm_Vsbulk_si_Vdbulk_di=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdbulk_di+((eta_mu*qia_Vdbulk_di)))+0.0*(qb_Vsbulk_si+(eta_mu*qia_Vsbulk_si))+EeffFactor*(+qb_Vsbulk_si_Vdbulk_di+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vsbulk_si+eta_mu*qia_Vsbulk_si_Vdbulk_di)));
  Eeffm_Vsbulk_si_Vsbulk_si=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsbulk_si+((eta_mu*qia_Vsbulk_si)))+0.0*(qb_Vsbulk_si+(eta_mu*qia_Vsbulk_si))+EeffFactor*(+qb_Vsbulk_si_Vsbulk_si+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vsbulk_si+eta_mu*qia_Vsbulk_si_Vsbulk_si)));
  Eeffm_Vsbulk_si_Vdi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdi_bi+((eta_mu*qia_Vdi_bi)))+0.0*(qb_Vsbulk_si+(eta_mu*qia_Vsbulk_si))+EeffFactor*(+qb_Vsbulk_si_Vdi_bi+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vsbulk_si+eta_mu*qia_Vsbulk_si_Vdi_bi)));
  Eeffm_Vsbulk_si_Vsi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsi_bi+((eta_mu*qia_Vsi_bi)))+0.0*(qb_Vsbulk_si+(eta_mu*qia_Vsbulk_si))+EeffFactor*(+qb_Vsbulk_si_Vsi_bi+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vsbulk_si+eta_mu*qia_Vsbulk_si_Vsi_bi)));
  Eeffm_Vsbulk_si_Tempt_GND=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Tempt_GND+((eta_mu*qia_Tempt_GND)))+0.0*(qb_Vsbulk_si+(eta_mu*qia_Vsbulk_si))+EeffFactor*(+qb_Vsbulk_si_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vsbulk_si+eta_mu*qia_Vsbulk_si_Tempt_GND)));
  Eeffm_Vsbulk_si_Vgi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vgi_bi+((eta_mu*qia_Vgi_bi)))+0.0*(qb_Vsbulk_si+(eta_mu*qia_Vsbulk_si))+EeffFactor*(+qb_Vsbulk_si_Vgi_bi+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vsbulk_si+eta_mu*qia_Vsbulk_si_Vgi_bi)));
#endif
Eeffm_Vdi_bi=(EeffFactor*(qb_Vdi_bi+(eta_mu*qia_Vdi_bi)));
#if defined(_DERIVATE2)
  Eeffm_Vdi_bi_Vdbulk_di=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdbulk_di+((eta_mu*qia_Vdbulk_di)))+0.0*(qb_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qb_Vdi_bi_Vdbulk_di+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vdbulk_di)));
  Eeffm_Vdi_bi_Vsbulk_si=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsbulk_si+((eta_mu*qia_Vsbulk_si)))+0.0*(qb_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qb_Vdi_bi_Vsbulk_si+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vsbulk_si)));
  Eeffm_Vdi_bi_Vdi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdi_bi+((eta_mu*qia_Vdi_bi)))+0.0*(qb_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qb_Vdi_bi_Vdi_bi+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vdi_bi)));
  Eeffm_Vdi_bi_Vsi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsi_bi+((eta_mu*qia_Vsi_bi)))+0.0*(qb_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qb_Vdi_bi_Vsi_bi+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vsi_bi)));
  Eeffm_Vdi_bi_Tempt_GND=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Tempt_GND+((eta_mu*qia_Tempt_GND)))+0.0*(qb_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qb_Vdi_bi_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Tempt_GND)));
  Eeffm_Vdi_bi_Vgi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vgi_bi+((eta_mu*qia_Vgi_bi)))+0.0*(qb_Vdi_bi+(eta_mu*qia_Vdi_bi))+EeffFactor*(+qb_Vdi_bi_Vgi_bi+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vdi_bi+eta_mu*qia_Vdi_bi_Vgi_bi)));
#endif
Eeffm_Vsi_bi=(EeffFactor*(qb_Vsi_bi+(eta_mu*qia_Vsi_bi)));
#if defined(_DERIVATE2)
  Eeffm_Vsi_bi_Vdbulk_di=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdbulk_di+((eta_mu*qia_Vdbulk_di)))+0.0*(qb_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qb_Vsi_bi_Vdbulk_di+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vdbulk_di)));
  Eeffm_Vsi_bi_Vsbulk_si=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsbulk_si+((eta_mu*qia_Vsbulk_si)))+0.0*(qb_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qb_Vsi_bi_Vsbulk_si+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vsbulk_si)));
  Eeffm_Vsi_bi_Vdi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdi_bi+((eta_mu*qia_Vdi_bi)))+0.0*(qb_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qb_Vsi_bi_Vdi_bi+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vdi_bi)));
  Eeffm_Vsi_bi_Vsi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsi_bi+((eta_mu*qia_Vsi_bi)))+0.0*(qb_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qb_Vsi_bi_Vsi_bi+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vsi_bi)));
  Eeffm_Vsi_bi_Tempt_GND=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Tempt_GND+((eta_mu*qia_Tempt_GND)))+0.0*(qb_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qb_Vsi_bi_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Tempt_GND)));
  Eeffm_Vsi_bi_Vgi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vgi_bi+((eta_mu*qia_Vgi_bi)))+0.0*(qb_Vsi_bi+(eta_mu*qia_Vsi_bi))+EeffFactor*(+qb_Vsi_bi_Vgi_bi+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vsi_bi+eta_mu*qia_Vsi_bi_Vgi_bi)));
#endif
#if defined(_DERIVATE)
Eeffm_Tempt_GND=(EeffFactor*(qb_Tempt_GND+(eta_mu*qia_Tempt_GND)));
#endif
Eeffm_Vgi_bi=(EeffFactor*(qb_Vgi_bi+(eta_mu*qia_Vgi_bi)));
#if defined(_DERIVATE2)
  Eeffm_Vgi_bi_Vdbulk_di=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdbulk_di+((eta_mu*qia_Vdbulk_di)))+0.0*(qb_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qb_Vgi_bi_Vdbulk_di+(+0.0*qia+0.0*qia_Vdbulk_di+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vdbulk_di)));
  Eeffm_Vgi_bi_Vsbulk_si=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsbulk_si+((eta_mu*qia_Vsbulk_si)))+0.0*(qb_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qb_Vgi_bi_Vsbulk_si+(+0.0*qia+0.0*qia_Vsbulk_si+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vsbulk_si)));
  Eeffm_Vgi_bi_Vdi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vdi_bi+((eta_mu*qia_Vdi_bi)))+0.0*(qb_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qb_Vgi_bi_Vdi_bi+(+0.0*qia+0.0*qia_Vdi_bi+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vdi_bi)));
  Eeffm_Vgi_bi_Vsi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vsi_bi+((eta_mu*qia_Vsi_bi)))+0.0*(qb_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qb_Vgi_bi_Vsi_bi+(+0.0*qia+0.0*qia_Vsi_bi+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vsi_bi)));
  Eeffm_Vgi_bi_Tempt_GND=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Tempt_GND+((eta_mu*qia_Tempt_GND)))+0.0*(qb_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qb_Vgi_bi_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Tempt_GND)));
  Eeffm_Vgi_bi_Vgi_bi=(+0.0*(qb+(eta_mu*qia))+0.0*(qb_Vgi_bi+((eta_mu*qia_Vgi_bi)))+0.0*(qb_Vgi_bi+(eta_mu*qia_Vgi_bi))+EeffFactor*(+qb_Vgi_bi_Vgi_bi+(+0.0*qia+0.0*qia_Vgi_bi+0.0*qia_Vgi_bi+eta_mu*qia_Vgi_bi_Vgi_bi)));
#endif
#endif
Eeffm=(EeffFactor*(qb+(eta_mu*qia)));
EXIT_IF_ISNAN((EeffFactor*(qb+(eta_mu*qia))))
{
double m00_pow(d00_pow0,Eeffm,EU_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,Eeffm,EU_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Vdbulk_di));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffm_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vgm_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffm_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vdbulk_di)+(0.0)*(d10_pow0*Eeffm_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vsbulk_si)+(0.0)*(d10_pow0*Eeffm_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vgi_bi=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vgi_bi)+(0.0)*(d10_pow0*Eeffm_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vdi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+UC_a_Vdi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffm_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Vsi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+UC_a_Vsi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffm_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdbulk_di_Tempt_GND=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffm_Vdbulk_di)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
T3_Vsbulk_si=((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Vsbulk_si));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffm_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vgm_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffm_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vdbulk_di)+(0.0)*(d10_pow0*Eeffm_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vsbulk_si)+(0.0)*(d10_pow0*Eeffm_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vgi_bi=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vgi_bi)+(0.0)*(d10_pow0*Eeffm_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vdi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+UC_a_Vdi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffm_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Vsi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+UC_a_Vsi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffm_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsbulk_si_Tempt_GND=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffm_Vsbulk_si)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
T3_Vgi_bi=((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vgm_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vdbulk_di)+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vsbulk_si)+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vgi_bi=(+(+0.0+(+0.0*Vbsx+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vgi_bi)+(0.0)*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vdi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+UC_a_Vdi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Vsi_bi=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+UC_a_Vsi_bi*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vgi_bi_Tempt_GND=(+(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow0+0.0*(d10_pow0*Eeffm_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffm_Vgi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
T3_Vdi_bi=(((UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Vdi_bi)));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*0.0+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vgm_di=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*0.0+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vdbulk_di)+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vsbulk_si)+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vgi_bi=(+(+0.0+(+0.0*Vbsx+UC_a_Vdi_bi*0.0+0.0*Vbsx_Vdi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vgi_bi)+(0.0)*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vdi_bi=(+(+UA_a_Vdi_bi_Vdi_bi+(+UC_a_Vdi_bi_Vdi_bi*Vbsx+UC_a_Vdi_bi*Vbsx_Vdi_bi+UC_a_Vdi_bi*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Vdi_bi))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Vsi_bi=(+(+UA_a_Vdi_bi_Vsi_bi+(+UC_a_Vdi_bi_Vsi_bi*Vbsx+UC_a_Vdi_bi*Vbsx_Vsi_bi+UC_a_Vsi_bi*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Vsi_bi))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vdi_bi_Tempt_GND=(+(+UA_a_Vdi_bi_Tempt_GND+(+UC_a_Vdi_bi_Tempt_GND*Vbsx+UC_a_Vdi_bi*Vbsx_Tempt_GND+UC_a_Tempt_GND*Vbsx_Vdi_bi+UC_a*Vbsx_Vdi_bi_Tempt_GND))*d00_pow0+(UA_a_Vdi_bi+((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi)))*(d10_pow0*Eeffm_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
T3_Vsi_bi=(((UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Vsi_bi)));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*0.0+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vgm_di=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*0.0+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vdbulk_di=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vdbulk_di)+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vsbulk_si=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vsbulk_si)+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vgi_bi=(+(+0.0+(+0.0*Vbsx+UC_a_Vsi_bi*0.0+0.0*Vbsx_Vsi_bi+UC_a*0.0))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vgi_bi)+(0.0)*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vdi_bi=(+(+UA_a_Vsi_bi_Vdi_bi+(+UC_a_Vsi_bi_Vdi_bi*Vbsx+UC_a_Vsi_bi*Vbsx_Vdi_bi+UC_a_Vdi_bi*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Vdi_bi))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vdi_bi)+(UA_a_Vdi_bi+(((UC_a_Vdi_bi*Vbsx)+(UC_a*Vbsx_Vdi_bi))))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Vsi_bi=(+(+UA_a_Vsi_bi_Vsi_bi+(+UC_a_Vsi_bi_Vsi_bi*Vbsx+UC_a_Vsi_bi*Vbsx_Vsi_bi+UC_a_Vsi_bi*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Vsi_bi))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a_Vsi_bi+(((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi))))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
  T3_Vsi_bi_Tempt_GND=(+(+UA_a_Vsi_bi_Tempt_GND+(+UC_a_Vsi_bi_Tempt_GND*Vbsx+UC_a_Vsi_bi*Vbsx_Tempt_GND+UC_a_Tempt_GND*Vbsx_Vsi_bi+UC_a*Vbsx_Vsi_bi_Tempt_GND))*d00_pow0+(UA_a_Vsi_bi+((UC_a_Vsi_bi*Vbsx)+(UC_a*Vbsx_Vsi_bi)))*(d10_pow0*Eeffm_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND))))*(d10_pow0*Eeffm_Vsi_bi)+(UA_a+(UC_a*Vbsx))*fixme);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(((UA_a_Tempt_GND+((UC_a_Tempt_GND*Vbsx)+(UC_a*Vbsx_Tempt_GND)))*d00_pow0)+((UA_a+(UC_a*Vbsx))*(d10_pow0*Eeffm_Tempt_GND)));
#endif
#endif
T3=((UA_a+(UC_a*Vbsx))*d00_pow0);
EXIT_IF_ISNAN(((UA_a+(UC_a*Vbsx))*d00_pow0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=T3_Vdbulk_di;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+0.0+T3_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+0.0+T3_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+0.0+T3_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+0.0+T3_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+0.0+T3_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+0.0+T3_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+0.0+T3_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+0.0+T3_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=T3_Vsbulk_si;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+0.0+T3_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+0.0+T3_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+0.0+T3_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+0.0+T3_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+0.0+T3_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+0.0+T3_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+0.0+T3_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+0.0+T3_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=T3_Vgi_bi;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+0.0+T3_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+0.0+T3_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+0.0+T3_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+0.0+T3_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+0.0+T3_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+0.0+T3_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+0.0+T3_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+0.0+T3_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=T3_Vdi_bi;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+0.0+T3_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+0.0+T3_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+0.0+T3_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+0.0+T3_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+0.0+T3_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+0.0+T3_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+0.0+T3_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+0.0+T3_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=T3_Vsi_bi;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+0.0+T3_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+0.0+T3_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+0.0+T3_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+0.0+T3_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+0.0+T3_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+0.0+T3_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+0.0+T3_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+0.0+T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=T3_Tempt_GND;
#endif
#endif
T4=(1.0+T3);
EXIT_IF_ISNAN((1.0+T3))
{
double m00_sqrt(d00_sqrt0,(((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
Dmob_Vdbulk_di=(0.5*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmob_Vdbulk_di_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vdbulk_di-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdbulk_di_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vsbulk_si-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdbulk_di_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vgi_bi-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vgi_bi+T4_Vgi_bi*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdbulk_di_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vdi_bi-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vdi_bi+T4_Vdi_bi*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdbulk_di_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Vsi_bi-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Vsi_bi+T4_Vsi_bi*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdbulk_di_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdbulk_di+((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T4_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di))+d10_sqrt0*(+(+(+T4_Vdbulk_di_Tempt_GND-0.0)*(T4-1.0)+T4_Vdbulk_di*T4_Tempt_GND+T4_Tempt_GND*T4_Vdbulk_di+(T4-1.0)*(+T4_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmob_Vsbulk_si=(0.5*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmob_Vsbulk_si_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vdbulk_di-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsbulk_si_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vsbulk_si-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsbulk_si_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vgi_bi-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vgi_bi+T4_Vgi_bi*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsbulk_si_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vdi_bi-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vdi_bi+T4_Vdi_bi*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsbulk_si_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Vsi_bi-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Vsi_bi+T4_Vsi_bi*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsbulk_si_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsbulk_si+((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T4_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si))+d10_sqrt0*(+(+(+T4_Vsbulk_si_Tempt_GND-0.0)*(T4-1.0)+T4_Vsbulk_si*T4_Tempt_GND+T4_Tempt_GND*T4_Vsbulk_si+(T4-1.0)*(+T4_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmob_Vgi_bi=(0.5*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmob_Vgi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vgi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vgi_bi+((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))*d10_sqrt0)+0.5*(+(+T4_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi))+d10_sqrt0*(+(+(+T4_Vgi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vgi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vgi_bi+(T4-1.0)*(+T4_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmob_Vdi_bi=(0.5*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmob_Vdi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vdi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vdi_bi+((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))*d10_sqrt0)+0.5*(+(+T4_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi))+d10_sqrt0*(+(+(+T4_Vdi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vdi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vdi_bi+(T4-1.0)*(+T4_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
Dmob_Vsi_bi=(0.5*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dmob_Vsi_bi_Vdbulk_di=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdbulk_di+((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdbulk_di*(T4-1.0))+((T4-1.0)*T4_Vdbulk_di)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vdbulk_di-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vdbulk_di+T4_Vdbulk_di*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Vsbulk_si=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsbulk_si+((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsbulk_si*(T4-1.0))+((T4-1.0)*T4_Vsbulk_si)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vsbulk_si-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vsbulk_si+T4_Vsbulk_si*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Vgi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vgi_bi+((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vgi_bi*(T4-1.0))+((T4-1.0)*T4_Vgi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vgi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vgi_bi+T4_Vgi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Vdi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vdi_bi+((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vdi_bi*(T4-1.0))+((T4-1.0)*T4_Vdi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vdi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vdi_bi+T4_Vdi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Vsi_bi=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Vsi_bi+((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Vsi_bi-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Vsi_bi+T4_Vsi_bi*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
  Dmob_Vsi_bi_Tempt_GND=(+0.0*((T4+1.0)+d00_sqrt0)+0.0*(T4_Tempt_GND+((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*d10_sqrt0)+0.0*(T4_Vsi_bi+((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))*d10_sqrt0)+0.5*(+(+T4_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))*((((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND)))+((0.0)*0.0015))*((T4_Vsi_bi*(T4-1.0))+((T4-1.0)*T4_Vsi_bi))+d10_sqrt0*(+(+(+T4_Vsi_bi_Tempt_GND-0.0)*(T4-1.0)+T4_Vsi_bi*T4_Tempt_GND+T4_Tempt_GND*T4_Vsi_bi+(T4-1.0)*(+T4_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.0015+0.0*0.0+0.0*0.0+0.25*0.0)*0.0015+0.0*0.0+(0.0)*0.0+(0.25*0.0015)*0.0)))));
#endif
#if defined(_DERIVATE)
Dmob_Tempt_GND=(0.5*(T4_Tempt_GND+((T4_Tempt_GND*(T4-1.0))+((T4-1.0)*T4_Tempt_GND))*d10_sqrt0));
#endif
#endif
Dmob=(0.5*((T4+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T4+1.0)+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
LambdaC_Vdbulk_di=((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_Vdbulk_di_Vdbulk_di=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vdbulk_di+0.0*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdbulk_di_Vsbulk_si=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vsbulk_si+0.0*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdbulk_di_Tempt_GND=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Tempt_GND/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*Vt_Tempt_GND+((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*Vt)+((2.0*(U0_a/Dmob))*Vt_Tempt_GND)))*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdbulk_di_Vdi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vdi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*0.0+((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdbulk_di_Vsi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vsi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*0.0+((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdbulk_di_Vgi_bi=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vgi_bi+0.0*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vgi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
LambdaC_Vsbulk_si=((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_Vsbulk_si_Vdbulk_di=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vdbulk_di+0.0*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsbulk_si_Vsbulk_si=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vsbulk_si+0.0*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsbulk_si_Tempt_GND=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Tempt_GND/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*Vt_Tempt_GND+((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*Vt)+((2.0*(U0_a/Dmob))*Vt_Tempt_GND)))*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsbulk_si_Vdi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vdi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*0.0+((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsbulk_si_Vsi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vsi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*0.0+((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsbulk_si_Vgi_bi=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vgi_bi+0.0*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vgi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
#if defined(_DERIVATE)
LambdaC_Tempt_GND=(((((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob))*Vt)+((2.0*(U0_a/Dmob))*Vt_Tempt_GND))*(VSATCV_t*Lact)-((2.0*(U0_a/Dmob))*Vt)*VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
LambdaC_Vdi_bi=((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_Vdi_bi_Vdbulk_di=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+2.0*(0.0/Dmob-(U0_a_Vdi_bi*Dmob_Vdbulk_di+0.0*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdi_bi_Vsbulk_si=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+2.0*(0.0/Dmob-(U0_a_Vdi_bi*Dmob_Vsbulk_si+0.0*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdi_bi_Tempt_GND=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+2.0*(U0_a_Vdi_bi_Tempt_GND/Dmob-(U0_a_Vdi_bi*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Tempt_GND/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*Vt_Tempt_GND+((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*Vt)+((2.0*(U0_a/Dmob))*Vt_Tempt_GND)))*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdi_bi_Vdi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+2.0*(U0_a_Vdi_bi_Vdi_bi/Dmob-(U0_a_Vdi_bi*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vdi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*0.0+((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdi_bi_Vsi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+2.0*(U0_a_Vdi_bi_Vsi_bi/Dmob-(U0_a_Vdi_bi*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vsi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*0.0+((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vdi_bi_Vgi_bi=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+2.0*(0.0/Dmob-(U0_a_Vdi_bi*Dmob_Vgi_bi+0.0*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vgi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
LambdaC_Vsi_bi=((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_Vsi_bi_Vdbulk_di=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+2.0*(0.0/Dmob-(U0_a_Vsi_bi*Dmob_Vdbulk_di+0.0*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsi_bi_Vsbulk_si=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+2.0*(0.0/Dmob-(U0_a_Vsi_bi*Dmob_Vsbulk_si+0.0*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsi_bi_Tempt_GND=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+2.0*(U0_a_Vsi_bi_Tempt_GND/Dmob-(U0_a_Vsi_bi*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Tempt_GND/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*Vt_Tempt_GND+((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*Vt)+((2.0*(U0_a/Dmob))*Vt_Tempt_GND)))*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsi_bi_Vdi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+2.0*(U0_a_Vsi_bi_Vdi_bi/Dmob-(U0_a_Vsi_bi*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vdi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*0.0+((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsi_bi_Vsi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+2.0*(U0_a_Vsi_bi_Vsi_bi/Dmob-(U0_a_Vsi_bi*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vsi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*0.0+((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vsi_bi_Vgi_bi=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+2.0*(0.0/Dmob-(U0_a_Vsi_bi*Dmob_Vgi_bi+0.0*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vgi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
LambdaC_Vgi_bi=((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*Vt/(VSATCV_t*Lact));
#if defined(_DERIVATE2)
  LambdaC_Vgi_bi_Vdbulk_di=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vdbulk_di+0.0*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vgi_bi_Vsbulk_si=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vsbulk_si+0.0*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vgi_bi_Tempt_GND=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Tempt_GND/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*Vt_Tempt_GND+((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*Vt*(VSATCV_t_Tempt_GND*Lact)+(((((2.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)))*Vt)+((2.0*(U0_a/Dmob))*Vt_Tempt_GND)))*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+VSATCV_t_Tempt_GND*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(VSATCV_t_Tempt_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vgi_bi_Vdi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vdi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*0.0+((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vgi_bi_Vsi_bi=((+(+0.0*(U0_a/Dmob)+0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vsi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*0.0+((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*Vt*(0.0)+(((2.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
  LambdaC_Vgi_bi_Vgi_bi=((+(+0.0*(U0_a/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+2.0*(0.0/Dmob-(0.0*Dmob_Vgi_bi+0.0*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vgi_bi/Dmob/Dmob/Dmob))*Vt+(2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*0.0+((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*0.0+(2.0*(U0_a/Dmob))*0.0)/(VSATCV_t*Lact)-((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob))*Vt*(0.0)+(((2.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)))*Vt)*0.0+((2.0*(U0_a/Dmob))*Vt)*(+0.0*Lact+0.0*0.0+0.0*0.0+VSATCV_t*0.0))/(VSATCV_t*Lact)/(VSATCV_t*Lact)+2*((2.0*(U0_a/Dmob))*Vt)*0.0*(0.0)/(VSATCV_t*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
#endif
#endif
LambdaC=(((2.0*(U0_a/Dmob))*Vt)/(VSATCV_t*Lact));
EXIT_IF_ISNAN((((2.0*(U0_a/Dmob))*Vt)/(VSATCV_t*Lact)))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
dps_Vdbulk_di=(qs_Vdbulk_di-qdeff_Vdbulk_di);
#if defined(_DERIVATE2)
  dps_Vdbulk_di_Vdbulk_di=(+qs_Vdbulk_di_Vdbulk_di-qdeff_Vdbulk_di_Vdbulk_di);
  dps_Vdbulk_di_Vsbulk_si=(+qs_Vdbulk_di_Vsbulk_si-qdeff_Vdbulk_di_Vsbulk_si);
  dps_Vdbulk_di_Vgi_bi=(+qs_Vdbulk_di_Vgi_bi-qdeff_Vdbulk_di_Vgi_bi);
  dps_Vdbulk_di_Vdi_bi=(+qs_Vdbulk_di_Vdi_bi-qdeff_Vdbulk_di_Vdi_bi);
  dps_Vdbulk_di_Vsi_bi=(+qs_Vdbulk_di_Vsi_bi-qdeff_Vdbulk_di_Vsi_bi);
  dps_Vdbulk_di_Tempt_GND=(+qs_Vdbulk_di_Tempt_GND-qdeff_Vdbulk_di_Tempt_GND);
#endif
dps_Vsbulk_si=(qs_Vsbulk_si-qdeff_Vsbulk_si);
#if defined(_DERIVATE2)
  dps_Vsbulk_si_Vdbulk_di=(+qs_Vsbulk_si_Vdbulk_di-qdeff_Vsbulk_si_Vdbulk_di);
  dps_Vsbulk_si_Vsbulk_si=(+qs_Vsbulk_si_Vsbulk_si-qdeff_Vsbulk_si_Vsbulk_si);
  dps_Vsbulk_si_Vgi_bi=(+qs_Vsbulk_si_Vgi_bi-qdeff_Vsbulk_si_Vgi_bi);
  dps_Vsbulk_si_Vdi_bi=(+qs_Vsbulk_si_Vdi_bi-qdeff_Vsbulk_si_Vdi_bi);
  dps_Vsbulk_si_Vsi_bi=(+qs_Vsbulk_si_Vsi_bi-qdeff_Vsbulk_si_Vsi_bi);
  dps_Vsbulk_si_Tempt_GND=(+qs_Vsbulk_si_Tempt_GND-qdeff_Vsbulk_si_Tempt_GND);
#endif
dps_Vgi_bi=(qs_Vgi_bi-qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  dps_Vgi_bi_Vdbulk_di=(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di);
  dps_Vgi_bi_Vsbulk_si=(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si);
  dps_Vgi_bi_Vgi_bi=(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi);
  dps_Vgi_bi_Vdi_bi=(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi);
  dps_Vgi_bi_Vsi_bi=(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi);
  dps_Vgi_bi_Tempt_GND=(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND);
#endif
dps_Vdi_bi=(qs_Vdi_bi-qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  dps_Vdi_bi_Vdbulk_di=(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di);
  dps_Vdi_bi_Vsbulk_si=(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si);
  dps_Vdi_bi_Vgi_bi=(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi);
  dps_Vdi_bi_Vdi_bi=(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi);
  dps_Vdi_bi_Vsi_bi=(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi);
  dps_Vdi_bi_Tempt_GND=(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND);
#endif
dps_Vsi_bi=(qs_Vsi_bi-qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  dps_Vsi_bi_Vdbulk_di=(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di);
  dps_Vsi_bi_Vsbulk_si=(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si);
  dps_Vsi_bi_Vgi_bi=(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi);
  dps_Vsi_bi_Vdi_bi=(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi);
  dps_Vsi_bi_Vsi_bi=(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi);
  dps_Vsi_bi_Tempt_GND=(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
dps_Tempt_GND=(qs_Tempt_GND-qdeff_Tempt_GND);
#endif
#endif
dps=(qs-qdeff);
EXIT_IF_ISNAN((qs-qdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(((2.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))*(LambdaC*dps))+((2.0*(LambdaC*dps))*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+2.0*(+0.0*dps+LambdaC_Vdbulk_di*0.0+0.0*dps_Vdbulk_di+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vdbulk_di*0.0+0.0*dps_Vdbulk_di+LambdaC*0.0));
  T1_Vdbulk_di_Vgm_si=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+2.0*(+0.0*dps+LambdaC_Vdbulk_di*0.0+0.0*dps_Vdbulk_di+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vdbulk_di*0.0+0.0*dps_Vdbulk_di+LambdaC*0.0));
  T1_Vdbulk_di_Vdbulk_di=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+0.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+2.0*(+LambdaC_Vdbulk_di_Vdbulk_di*dps+LambdaC_Vdbulk_di*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vdbulk_di))*(LambdaC*dps)+(2.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+((2.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))))*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+(2.0*(LambdaC*dps))*(+LambdaC_Vdbulk_di_Vdbulk_di*dps+LambdaC_Vdbulk_di*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vdbulk_di));
  T1_Vdbulk_di_Vsbulk_si=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+0.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+2.0*(+LambdaC_Vdbulk_di_Vsbulk_si*dps+LambdaC_Vdbulk_di*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vsbulk_si))*(LambdaC*dps)+(2.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+((2.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))))*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+(2.0*(LambdaC*dps))*(+LambdaC_Vdbulk_di_Vsbulk_si*dps+LambdaC_Vdbulk_di*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vsbulk_si));
  T1_Vdbulk_di_Vgi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+0.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+2.0*(+LambdaC_Vdbulk_di_Vgi_bi*dps+LambdaC_Vdbulk_di*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vgi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+((2.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))))*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+(2.0*(LambdaC*dps))*(+LambdaC_Vdbulk_di_Vgi_bi*dps+LambdaC_Vdbulk_di*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vgi_bi));
  T1_Vdbulk_di_Vdi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+0.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+2.0*(+LambdaC_Vdbulk_di_Vdi_bi*dps+LambdaC_Vdbulk_di*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vdi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+((2.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))))*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+(2.0*(LambdaC*dps))*(+LambdaC_Vdbulk_di_Vdi_bi*dps+LambdaC_Vdbulk_di*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vdi_bi));
  T1_Vdbulk_di_Vsi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+0.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+2.0*(+LambdaC_Vdbulk_di_Vsi_bi*dps+LambdaC_Vdbulk_di*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vsi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+((2.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))))*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+(2.0*(LambdaC*dps))*(+LambdaC_Vdbulk_di_Vsi_bi*dps+LambdaC_Vdbulk_di*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Vsi_bi));
  T1_Vdbulk_di_Tempt_GND=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+0.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+2.0*(+LambdaC_Vdbulk_di_Tempt_GND*dps+LambdaC_Vdbulk_di*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Tempt_GND))*(LambdaC*dps)+(2.0*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+((2.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))))*((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di))+(2.0*(LambdaC*dps))*(+LambdaC_Vdbulk_di_Tempt_GND*dps+LambdaC_Vdbulk_di*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vdbulk_di+LambdaC*dps_Vdbulk_di_Tempt_GND));
#endif
T1_Vsbulk_si=(((2.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))*(LambdaC*dps))+((2.0*(LambdaC*dps))*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+2.0*(+0.0*dps+LambdaC_Vsbulk_si*0.0+0.0*dps_Vsbulk_si+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vsbulk_si*0.0+0.0*dps_Vsbulk_si+LambdaC*0.0));
  T1_Vsbulk_si_Vgm_si=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+2.0*(+0.0*dps+LambdaC_Vsbulk_si*0.0+0.0*dps_Vsbulk_si+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vsbulk_si*0.0+0.0*dps_Vsbulk_si+LambdaC*0.0));
  T1_Vsbulk_si_Vdbulk_di=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+0.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+2.0*(+LambdaC_Vsbulk_si_Vdbulk_di*dps+LambdaC_Vsbulk_si*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vdbulk_di))*(LambdaC*dps)+(2.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+((2.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))))*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+(2.0*(LambdaC*dps))*(+LambdaC_Vsbulk_si_Vdbulk_di*dps+LambdaC_Vsbulk_si*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vdbulk_di));
  T1_Vsbulk_si_Vsbulk_si=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+0.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+2.0*(+LambdaC_Vsbulk_si_Vsbulk_si*dps+LambdaC_Vsbulk_si*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vsbulk_si))*(LambdaC*dps)+(2.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+((2.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))))*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+(2.0*(LambdaC*dps))*(+LambdaC_Vsbulk_si_Vsbulk_si*dps+LambdaC_Vsbulk_si*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vsbulk_si));
  T1_Vsbulk_si_Vgi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+0.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+2.0*(+LambdaC_Vsbulk_si_Vgi_bi*dps+LambdaC_Vsbulk_si*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vgi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+((2.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))))*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+(2.0*(LambdaC*dps))*(+LambdaC_Vsbulk_si_Vgi_bi*dps+LambdaC_Vsbulk_si*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vgi_bi));
  T1_Vsbulk_si_Vdi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+0.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+2.0*(+LambdaC_Vsbulk_si_Vdi_bi*dps+LambdaC_Vsbulk_si*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vdi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+((2.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))))*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+(2.0*(LambdaC*dps))*(+LambdaC_Vsbulk_si_Vdi_bi*dps+LambdaC_Vsbulk_si*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vdi_bi));
  T1_Vsbulk_si_Vsi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+0.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+2.0*(+LambdaC_Vsbulk_si_Vsi_bi*dps+LambdaC_Vsbulk_si*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vsi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+((2.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))))*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+(2.0*(LambdaC*dps))*(+LambdaC_Vsbulk_si_Vsi_bi*dps+LambdaC_Vsbulk_si*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Vsi_bi));
  T1_Vsbulk_si_Tempt_GND=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+0.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+2.0*(+LambdaC_Vsbulk_si_Tempt_GND*dps+LambdaC_Vsbulk_si*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Tempt_GND))*(LambdaC*dps)+(2.0*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+((2.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))))*((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si))+(2.0*(LambdaC*dps))*(+LambdaC_Vsbulk_si_Tempt_GND*dps+LambdaC_Vsbulk_si*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vsbulk_si+LambdaC*dps_Vsbulk_si_Tempt_GND));
#endif
T1_Vgi_bi=(((2.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))*(LambdaC*dps))+((2.0*(LambdaC*dps))*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+2.0*(+0.0*dps+LambdaC_Vgi_bi*0.0+0.0*dps_Vgi_bi+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vgi_bi*0.0+0.0*dps_Vgi_bi+LambdaC*0.0));
  T1_Vgi_bi_Vgm_si=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+2.0*(+0.0*dps+LambdaC_Vgi_bi*0.0+0.0*dps_Vgi_bi+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vgi_bi*0.0+0.0*dps_Vgi_bi+LambdaC*0.0));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+0.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+2.0*(+LambdaC_Vgi_bi_Vdbulk_di*dps+LambdaC_Vgi_bi*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vdbulk_di))*(LambdaC*dps)+(2.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+((2.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))))*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vgi_bi_Vdbulk_di*dps+LambdaC_Vgi_bi*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vdbulk_di));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+0.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+2.0*(+LambdaC_Vgi_bi_Vsbulk_si*dps+LambdaC_Vgi_bi*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vsbulk_si))*(LambdaC*dps)+(2.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+((2.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))))*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vgi_bi_Vsbulk_si*dps+LambdaC_Vgi_bi*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vsbulk_si));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+0.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+2.0*(+LambdaC_Vgi_bi_Vgi_bi*dps+LambdaC_Vgi_bi*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vgi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+((2.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))))*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vgi_bi_Vgi_bi*dps+LambdaC_Vgi_bi*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vgi_bi));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+0.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+2.0*(+LambdaC_Vgi_bi_Vdi_bi*dps+LambdaC_Vgi_bi*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vdi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+((2.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))))*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vgi_bi_Vdi_bi*dps+LambdaC_Vgi_bi*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vdi_bi));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+0.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+2.0*(+LambdaC_Vgi_bi_Vsi_bi*dps+LambdaC_Vgi_bi*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vsi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+((2.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))))*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vgi_bi_Vsi_bi*dps+LambdaC_Vgi_bi*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Vsi_bi));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+0.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+2.0*(+LambdaC_Vgi_bi_Tempt_GND*dps+LambdaC_Vgi_bi*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Tempt_GND))*(LambdaC*dps)+(2.0*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+((2.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))))*((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vgi_bi_Tempt_GND*dps+LambdaC_Vgi_bi*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vgi_bi+LambdaC*dps_Vgi_bi_Tempt_GND));
#endif
T1_Vdi_bi=(((2.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))*(LambdaC*dps))+((2.0*(LambdaC*dps))*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+2.0*(+0.0*dps+LambdaC_Vdi_bi*0.0+0.0*dps_Vdi_bi+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vdi_bi*0.0+0.0*dps_Vdi_bi+LambdaC*0.0));
  T1_Vdi_bi_Vgm_si=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+2.0*(+0.0*dps+LambdaC_Vdi_bi*0.0+0.0*dps_Vdi_bi+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vdi_bi*0.0+0.0*dps_Vdi_bi+LambdaC*0.0));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+0.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+2.0*(+LambdaC_Vdi_bi_Vdbulk_di*dps+LambdaC_Vdi_bi*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vdbulk_di))*(LambdaC*dps)+(2.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+((2.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))))*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vdi_bi_Vdbulk_di*dps+LambdaC_Vdi_bi*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vdbulk_di));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+0.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+2.0*(+LambdaC_Vdi_bi_Vsbulk_si*dps+LambdaC_Vdi_bi*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vsbulk_si))*(LambdaC*dps)+(2.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+((2.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))))*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vdi_bi_Vsbulk_si*dps+LambdaC_Vdi_bi*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vsbulk_si));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+0.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+2.0*(+LambdaC_Vdi_bi_Vgi_bi*dps+LambdaC_Vdi_bi*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vgi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+((2.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))))*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vdi_bi_Vgi_bi*dps+LambdaC_Vdi_bi*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vgi_bi));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+0.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+2.0*(+LambdaC_Vdi_bi_Vdi_bi*dps+LambdaC_Vdi_bi*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vdi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+((2.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))))*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vdi_bi_Vdi_bi*dps+LambdaC_Vdi_bi*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vdi_bi));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+0.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+2.0*(+LambdaC_Vdi_bi_Vsi_bi*dps+LambdaC_Vdi_bi*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vsi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+((2.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))))*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vdi_bi_Vsi_bi*dps+LambdaC_Vdi_bi*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Vsi_bi));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+0.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+2.0*(+LambdaC_Vdi_bi_Tempt_GND*dps+LambdaC_Vdi_bi*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Tempt_GND))*(LambdaC*dps)+(2.0*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+((2.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))))*((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vdi_bi_Tempt_GND*dps+LambdaC_Vdi_bi*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vdi_bi+LambdaC*dps_Vdi_bi_Tempt_GND));
#endif
T1_Vsi_bi=(((2.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))*(LambdaC*dps))+((2.0*(LambdaC*dps))*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+2.0*(+0.0*dps+LambdaC_Vsi_bi*0.0+0.0*dps_Vsi_bi+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vsi_bi*0.0+0.0*dps_Vsi_bi+LambdaC*0.0));
  T1_Vsi_bi_Vgm_si=(+(+0.0*(LambdaC*dps)+0.0*(0.0)+0.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+2.0*(+0.0*dps+LambdaC_Vsi_bi*0.0+0.0*dps_Vsi_bi+LambdaC*0.0))*(LambdaC*dps)+(2.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))*(0.0)+((2.0*(0.0)))*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+(2.0*(LambdaC*dps))*(+0.0*dps+LambdaC_Vsi_bi*0.0+0.0*dps_Vsi_bi+LambdaC*0.0));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+0.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+2.0*(+LambdaC_Vsi_bi_Vdbulk_di*dps+LambdaC_Vsi_bi*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vdbulk_di))*(LambdaC*dps)+(2.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))+((2.0*(((LambdaC_Vdbulk_di*dps)+(LambdaC*dps_Vdbulk_di)))))*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vsi_bi_Vdbulk_di*dps+LambdaC_Vsi_bi*dps_Vdbulk_di+LambdaC_Vdbulk_di*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vdbulk_di));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+0.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+2.0*(+LambdaC_Vsi_bi_Vsbulk_si*dps+LambdaC_Vsi_bi*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vsbulk_si))*(LambdaC*dps)+(2.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))+((2.0*(((LambdaC_Vsbulk_si*dps)+(LambdaC*dps_Vsbulk_si)))))*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vsi_bi_Vsbulk_si*dps+LambdaC_Vsi_bi*dps_Vsbulk_si+LambdaC_Vsbulk_si*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vsbulk_si));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+0.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+2.0*(+LambdaC_Vsi_bi_Vgi_bi*dps+LambdaC_Vsi_bi*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vgi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))+((2.0*(((LambdaC_Vgi_bi*dps)+(LambdaC*dps_Vgi_bi)))))*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vsi_bi_Vgi_bi*dps+LambdaC_Vsi_bi*dps_Vgi_bi+LambdaC_Vgi_bi*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vgi_bi));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+0.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+2.0*(+LambdaC_Vsi_bi_Vdi_bi*dps+LambdaC_Vsi_bi*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vdi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))+((2.0*(((LambdaC_Vdi_bi*dps)+(LambdaC*dps_Vdi_bi)))))*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vsi_bi_Vdi_bi*dps+LambdaC_Vsi_bi*dps_Vdi_bi+LambdaC_Vdi_bi*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vdi_bi));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+0.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+2.0*(+LambdaC_Vsi_bi_Vsi_bi*dps+LambdaC_Vsi_bi*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vsi_bi))*(LambdaC*dps)+(2.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))+((2.0*(((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))))*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vsi_bi_Vsi_bi*dps+LambdaC_Vsi_bi*dps_Vsi_bi+LambdaC_Vsi_bi*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Vsi_bi));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*(LambdaC*dps)+0.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+0.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+2.0*(+LambdaC_Vsi_bi_Tempt_GND*dps+LambdaC_Vsi_bi*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Tempt_GND))*(LambdaC*dps)+(2.0*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi)))*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))+((2.0*(((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))))*((LambdaC_Vsi_bi*dps)+(LambdaC*dps_Vsi_bi))+(2.0*(LambdaC*dps))*(+LambdaC_Vsi_bi_Tempt_GND*dps+LambdaC_Vsi_bi*dps_Tempt_GND+LambdaC_Tempt_GND*dps_Vsi_bi+LambdaC*dps_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(((2.0*((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND)))*(LambdaC*dps))+((2.0*(LambdaC*dps))*((LambdaC_Tempt_GND*dps)+(LambdaC*dps_Tempt_GND))));
#endif
#endif
T1=((2.0*(LambdaC*dps))*(LambdaC*dps));
EXIT_IF_ISNAN(((2.0*(LambdaC*dps))*(LambdaC*dps)))
{
double m00_sqrt(d00_sqrt0,(1.0+T1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+T1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
zsat_Vdbulk_di=T1_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  zsat_Vdbulk_di_Vdbulk_di=(m20_sqrt((1.0+T1))*T1_Vdbulk_di*T1_Vdbulk_di+d10_sqrt0*(+0.0+T1_Vdbulk_di_Vdbulk_di));
  zsat_Vdbulk_di_Vsbulk_si=(m20_sqrt((1.0+T1))*T1_Vsbulk_si*T1_Vdbulk_di+d10_sqrt0*(+0.0+T1_Vdbulk_di_Vsbulk_si));
  zsat_Vdbulk_di_Vgi_bi=(m20_sqrt((1.0+T1))*T1_Vgi_bi*T1_Vdbulk_di+d10_sqrt0*(+0.0+T1_Vdbulk_di_Vgi_bi));
  zsat_Vdbulk_di_Vdi_bi=(m20_sqrt((1.0+T1))*T1_Vdi_bi*T1_Vdbulk_di+d10_sqrt0*(+0.0+T1_Vdbulk_di_Vdi_bi));
  zsat_Vdbulk_di_Vsi_bi=(m20_sqrt((1.0+T1))*T1_Vsi_bi*T1_Vdbulk_di+d10_sqrt0*(+0.0+T1_Vdbulk_di_Vsi_bi));
  zsat_Vdbulk_di_Tempt_GND=(m20_sqrt((1.0+T1))*T1_Tempt_GND*T1_Vdbulk_di+d10_sqrt0*(+0.0+T1_Vdbulk_di_Tempt_GND));
#endif
zsat_Vsbulk_si=T1_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  zsat_Vsbulk_si_Vdbulk_di=(m20_sqrt((1.0+T1))*T1_Vdbulk_di*T1_Vsbulk_si+d10_sqrt0*(+0.0+T1_Vsbulk_si_Vdbulk_di));
  zsat_Vsbulk_si_Vsbulk_si=(m20_sqrt((1.0+T1))*T1_Vsbulk_si*T1_Vsbulk_si+d10_sqrt0*(+0.0+T1_Vsbulk_si_Vsbulk_si));
  zsat_Vsbulk_si_Vgi_bi=(m20_sqrt((1.0+T1))*T1_Vgi_bi*T1_Vsbulk_si+d10_sqrt0*(+0.0+T1_Vsbulk_si_Vgi_bi));
  zsat_Vsbulk_si_Vdi_bi=(m20_sqrt((1.0+T1))*T1_Vdi_bi*T1_Vsbulk_si+d10_sqrt0*(+0.0+T1_Vsbulk_si_Vdi_bi));
  zsat_Vsbulk_si_Vsi_bi=(m20_sqrt((1.0+T1))*T1_Vsi_bi*T1_Vsbulk_si+d10_sqrt0*(+0.0+T1_Vsbulk_si_Vsi_bi));
  zsat_Vsbulk_si_Tempt_GND=(m20_sqrt((1.0+T1))*T1_Tempt_GND*T1_Vsbulk_si+d10_sqrt0*(+0.0+T1_Vsbulk_si_Tempt_GND));
#endif
zsat_Vgi_bi=T1_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  zsat_Vgi_bi_Vdbulk_di=(m20_sqrt((1.0+T1))*T1_Vdbulk_di*T1_Vgi_bi+d10_sqrt0*(+0.0+T1_Vgi_bi_Vdbulk_di));
  zsat_Vgi_bi_Vsbulk_si=(m20_sqrt((1.0+T1))*T1_Vsbulk_si*T1_Vgi_bi+d10_sqrt0*(+0.0+T1_Vgi_bi_Vsbulk_si));
  zsat_Vgi_bi_Vgi_bi=(m20_sqrt((1.0+T1))*T1_Vgi_bi*T1_Vgi_bi+d10_sqrt0*(+0.0+T1_Vgi_bi_Vgi_bi));
  zsat_Vgi_bi_Vdi_bi=(m20_sqrt((1.0+T1))*T1_Vdi_bi*T1_Vgi_bi+d10_sqrt0*(+0.0+T1_Vgi_bi_Vdi_bi));
  zsat_Vgi_bi_Vsi_bi=(m20_sqrt((1.0+T1))*T1_Vsi_bi*T1_Vgi_bi+d10_sqrt0*(+0.0+T1_Vgi_bi_Vsi_bi));
  zsat_Vgi_bi_Tempt_GND=(m20_sqrt((1.0+T1))*T1_Tempt_GND*T1_Vgi_bi+d10_sqrt0*(+0.0+T1_Vgi_bi_Tempt_GND));
#endif
zsat_Vdi_bi=T1_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  zsat_Vdi_bi_Vdbulk_di=(m20_sqrt((1.0+T1))*T1_Vdbulk_di*T1_Vdi_bi+d10_sqrt0*(+0.0+T1_Vdi_bi_Vdbulk_di));
  zsat_Vdi_bi_Vsbulk_si=(m20_sqrt((1.0+T1))*T1_Vsbulk_si*T1_Vdi_bi+d10_sqrt0*(+0.0+T1_Vdi_bi_Vsbulk_si));
  zsat_Vdi_bi_Vgi_bi=(m20_sqrt((1.0+T1))*T1_Vgi_bi*T1_Vdi_bi+d10_sqrt0*(+0.0+T1_Vdi_bi_Vgi_bi));
  zsat_Vdi_bi_Vdi_bi=(m20_sqrt((1.0+T1))*T1_Vdi_bi*T1_Vdi_bi+d10_sqrt0*(+0.0+T1_Vdi_bi_Vdi_bi));
  zsat_Vdi_bi_Vsi_bi=(m20_sqrt((1.0+T1))*T1_Vsi_bi*T1_Vdi_bi+d10_sqrt0*(+0.0+T1_Vdi_bi_Vsi_bi));
  zsat_Vdi_bi_Tempt_GND=(m20_sqrt((1.0+T1))*T1_Tempt_GND*T1_Vdi_bi+d10_sqrt0*(+0.0+T1_Vdi_bi_Tempt_GND));
#endif
zsat_Vsi_bi=T1_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  zsat_Vsi_bi_Vdbulk_di=(m20_sqrt((1.0+T1))*T1_Vdbulk_di*T1_Vsi_bi+d10_sqrt0*(+0.0+T1_Vsi_bi_Vdbulk_di));
  zsat_Vsi_bi_Vsbulk_si=(m20_sqrt((1.0+T1))*T1_Vsbulk_si*T1_Vsi_bi+d10_sqrt0*(+0.0+T1_Vsi_bi_Vsbulk_si));
  zsat_Vsi_bi_Vgi_bi=(m20_sqrt((1.0+T1))*T1_Vgi_bi*T1_Vsi_bi+d10_sqrt0*(+0.0+T1_Vsi_bi_Vgi_bi));
  zsat_Vsi_bi_Vdi_bi=(m20_sqrt((1.0+T1))*T1_Vdi_bi*T1_Vsi_bi+d10_sqrt0*(+0.0+T1_Vsi_bi_Vdi_bi));
  zsat_Vsi_bi_Vsi_bi=(m20_sqrt((1.0+T1))*T1_Vsi_bi*T1_Vsi_bi+d10_sqrt0*(+0.0+T1_Vsi_bi_Vsi_bi));
  zsat_Vsi_bi_Tempt_GND=(m20_sqrt((1.0+T1))*T1_Tempt_GND*T1_Vsi_bi+d10_sqrt0*(+0.0+T1_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
zsat_Tempt_GND=T1_Tempt_GND*d10_sqrt0;
#endif
#endif
zsat=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND) */
Dvsat_Vdbulk_di=(0.5*zsat_Vdbulk_di);
#if defined(_DERIVATE2)
  Dvsat_Vdbulk_di_Vdbulk_di=(+0.0*(1.0+zsat)+0.0*zsat_Vdbulk_di+0.0*zsat_Vdbulk_di+0.5*(+0.0+zsat_Vdbulk_di_Vdbulk_di));
  Dvsat_Vdbulk_di_Vsbulk_si=(+0.0*(1.0+zsat)+0.0*zsat_Vsbulk_si+0.0*zsat_Vdbulk_di+0.5*(+0.0+zsat_Vdbulk_di_Vsbulk_si));
  Dvsat_Vdbulk_di_Vgi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vgi_bi+0.0*zsat_Vdbulk_di+0.5*(+0.0+zsat_Vdbulk_di_Vgi_bi));
  Dvsat_Vdbulk_di_Vdi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vdi_bi+0.0*zsat_Vdbulk_di+0.5*(+0.0+zsat_Vdbulk_di_Vdi_bi));
  Dvsat_Vdbulk_di_Vsi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vsi_bi+0.0*zsat_Vdbulk_di+0.5*(+0.0+zsat_Vdbulk_di_Vsi_bi));
  Dvsat_Vdbulk_di_Tempt_GND=(+0.0*(1.0+zsat)+0.0*zsat_Tempt_GND+0.0*zsat_Vdbulk_di+0.5*(+0.0+zsat_Vdbulk_di_Tempt_GND));
#endif
Dvsat_Vsbulk_si=(0.5*zsat_Vsbulk_si);
#if defined(_DERIVATE2)
  Dvsat_Vsbulk_si_Vdbulk_di=(+0.0*(1.0+zsat)+0.0*zsat_Vdbulk_di+0.0*zsat_Vsbulk_si+0.5*(+0.0+zsat_Vsbulk_si_Vdbulk_di));
  Dvsat_Vsbulk_si_Vsbulk_si=(+0.0*(1.0+zsat)+0.0*zsat_Vsbulk_si+0.0*zsat_Vsbulk_si+0.5*(+0.0+zsat_Vsbulk_si_Vsbulk_si));
  Dvsat_Vsbulk_si_Vgi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vgi_bi+0.0*zsat_Vsbulk_si+0.5*(+0.0+zsat_Vsbulk_si_Vgi_bi));
  Dvsat_Vsbulk_si_Vdi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vdi_bi+0.0*zsat_Vsbulk_si+0.5*(+0.0+zsat_Vsbulk_si_Vdi_bi));
  Dvsat_Vsbulk_si_Vsi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vsi_bi+0.0*zsat_Vsbulk_si+0.5*(+0.0+zsat_Vsbulk_si_Vsi_bi));
  Dvsat_Vsbulk_si_Tempt_GND=(+0.0*(1.0+zsat)+0.0*zsat_Tempt_GND+0.0*zsat_Vsbulk_si+0.5*(+0.0+zsat_Vsbulk_si_Tempt_GND));
#endif
Dvsat_Vgi_bi=(0.5*zsat_Vgi_bi);
#if defined(_DERIVATE2)
  Dvsat_Vgi_bi_Vdbulk_di=(+0.0*(1.0+zsat)+0.0*zsat_Vdbulk_di+0.0*zsat_Vgi_bi+0.5*(+0.0+zsat_Vgi_bi_Vdbulk_di));
  Dvsat_Vgi_bi_Vsbulk_si=(+0.0*(1.0+zsat)+0.0*zsat_Vsbulk_si+0.0*zsat_Vgi_bi+0.5*(+0.0+zsat_Vgi_bi_Vsbulk_si));
  Dvsat_Vgi_bi_Vgi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vgi_bi+0.0*zsat_Vgi_bi+0.5*(+0.0+zsat_Vgi_bi_Vgi_bi));
  Dvsat_Vgi_bi_Vdi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vdi_bi+0.0*zsat_Vgi_bi+0.5*(+0.0+zsat_Vgi_bi_Vdi_bi));
  Dvsat_Vgi_bi_Vsi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vsi_bi+0.0*zsat_Vgi_bi+0.5*(+0.0+zsat_Vgi_bi_Vsi_bi));
  Dvsat_Vgi_bi_Tempt_GND=(+0.0*(1.0+zsat)+0.0*zsat_Tempt_GND+0.0*zsat_Vgi_bi+0.5*(+0.0+zsat_Vgi_bi_Tempt_GND));
#endif
Dvsat_Vdi_bi=(0.5*zsat_Vdi_bi);
#if defined(_DERIVATE2)
  Dvsat_Vdi_bi_Vdbulk_di=(+0.0*(1.0+zsat)+0.0*zsat_Vdbulk_di+0.0*zsat_Vdi_bi+0.5*(+0.0+zsat_Vdi_bi_Vdbulk_di));
  Dvsat_Vdi_bi_Vsbulk_si=(+0.0*(1.0+zsat)+0.0*zsat_Vsbulk_si+0.0*zsat_Vdi_bi+0.5*(+0.0+zsat_Vdi_bi_Vsbulk_si));
  Dvsat_Vdi_bi_Vgi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vgi_bi+0.0*zsat_Vdi_bi+0.5*(+0.0+zsat_Vdi_bi_Vgi_bi));
  Dvsat_Vdi_bi_Vdi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vdi_bi+0.0*zsat_Vdi_bi+0.5*(+0.0+zsat_Vdi_bi_Vdi_bi));
  Dvsat_Vdi_bi_Vsi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vsi_bi+0.0*zsat_Vdi_bi+0.5*(+0.0+zsat_Vdi_bi_Vsi_bi));
  Dvsat_Vdi_bi_Tempt_GND=(+0.0*(1.0+zsat)+0.0*zsat_Tempt_GND+0.0*zsat_Vdi_bi+0.5*(+0.0+zsat_Vdi_bi_Tempt_GND));
#endif
Dvsat_Vsi_bi=(0.5*zsat_Vsi_bi);
#if defined(_DERIVATE2)
  Dvsat_Vsi_bi_Vdbulk_di=(+0.0*(1.0+zsat)+0.0*zsat_Vdbulk_di+0.0*zsat_Vsi_bi+0.5*(+0.0+zsat_Vsi_bi_Vdbulk_di));
  Dvsat_Vsi_bi_Vsbulk_si=(+0.0*(1.0+zsat)+0.0*zsat_Vsbulk_si+0.0*zsat_Vsi_bi+0.5*(+0.0+zsat_Vsi_bi_Vsbulk_si));
  Dvsat_Vsi_bi_Vgi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vgi_bi+0.0*zsat_Vsi_bi+0.5*(+0.0+zsat_Vsi_bi_Vgi_bi));
  Dvsat_Vsi_bi_Vdi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vdi_bi+0.0*zsat_Vsi_bi+0.5*(+0.0+zsat_Vsi_bi_Vdi_bi));
  Dvsat_Vsi_bi_Vsi_bi=(+0.0*(1.0+zsat)+0.0*zsat_Vsi_bi+0.0*zsat_Vsi_bi+0.5*(+0.0+zsat_Vsi_bi_Vsi_bi));
  Dvsat_Vsi_bi_Tempt_GND=(+0.0*(1.0+zsat)+0.0*zsat_Tempt_GND+0.0*zsat_Vsi_bi+0.5*(+0.0+zsat_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
Dvsat_Tempt_GND=(0.5*zsat_Tempt_GND);
#endif
#endif
Dvsat=(0.5*(1.0+zsat));
EXIT_IF_ISNAN((0.5*(1.0+zsat)))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Esat_Vdbulk_di=(-(2.0*VSATCV_t)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#if defined(_DERIVATE2)
  Esat_Vdbulk_di_Vdbulk_di=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vdbulk_di+0.0*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdbulk_di_Vsbulk_si=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vsbulk_si+0.0*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdbulk_di_Tempt_GND=((+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+((2.0*VSATCV_t_Tempt_GND))*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Tempt_GND/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdbulk_di_Vdi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vdi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdbulk_di_Vsi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vsi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdbulk_di_Vgi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vgi_bi+0.0*Dmob_Vdbulk_di+U0_a*Dmob_Vdbulk_di_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdbulk_di*Dmob_Vgi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#endif
Esat_Vsbulk_si=(-(2.0*VSATCV_t)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#if defined(_DERIVATE2)
  Esat_Vsbulk_si_Vdbulk_di=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vdbulk_di+0.0*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsbulk_si_Vsbulk_si=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vsbulk_si+0.0*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsbulk_si_Tempt_GND=((+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+((2.0*VSATCV_t_Tempt_GND))*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Tempt_GND/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsbulk_si_Vdi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vdi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsbulk_si_Vsi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vsi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsbulk_si_Vgi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vgi_bi+0.0*Dmob_Vsbulk_si+U0_a*Dmob_Vsbulk_si_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsbulk_si*Dmob_Vgi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#endif
#if defined(_DERIVATE)
Esat_Tempt_GND=(((2.0*VSATCV_t_Tempt_GND)*(U0_a/Dmob)-(2.0*VSATCV_t)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
#endif
Esat_Vdi_bi=(-(2.0*VSATCV_t)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#if defined(_DERIVATE2)
  Esat_Vdi_bi_Vdbulk_di=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(0.0)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(U0_a_Vdi_bi*Dmob_Vdbulk_di+0.0*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Vsbulk_si=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(0.0)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(U0_a_Vdi_bi*Dmob_Vsbulk_si+0.0*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Tempt_GND=((+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+((2.0*VSATCV_t_Tempt_GND))*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(U0_a_Vdi_bi_Tempt_GND/Dmob-(U0_a_Vdi_bi*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Tempt_GND/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Vdi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(0.0)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(U0_a_Vdi_bi_Vdi_bi/Dmob-(U0_a_Vdi_bi*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vdi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Vsi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(0.0)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(U0_a_Vdi_bi_Vsi_bi/Dmob-(U0_a_Vdi_bi*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vsi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vdi_bi_Vgi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(0.0)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(U0_a_Vdi_bi*Dmob_Vgi_bi+0.0*Dmob_Vdi_bi+U0_a*Dmob_Vdi_bi_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vdi_bi*Dmob_Vgi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#endif
Esat_Vsi_bi=(-(2.0*VSATCV_t)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#if defined(_DERIVATE2)
  Esat_Vsi_bi_Vdbulk_di=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(0.0)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(U0_a_Vsi_bi*Dmob_Vdbulk_di+0.0*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Vsbulk_si=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(0.0)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(U0_a_Vsi_bi*Dmob_Vsbulk_si+0.0*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Tempt_GND=((+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+((2.0*VSATCV_t_Tempt_GND))*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(U0_a_Vsi_bi_Tempt_GND/Dmob-(U0_a_Vsi_bi*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Tempt_GND/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Vdi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(0.0)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(U0_a_Vsi_bi_Vdi_bi/Dmob-(U0_a_Vsi_bi*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vdi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Vsi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(0.0)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(U0_a_Vsi_bi_Vsi_bi/Dmob-(U0_a_Vsi_bi*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vsi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vsi_bi_Vgi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(0.0)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(U0_a_Vsi_bi*Dmob_Vgi_bi+0.0*Dmob_Vsi_bi+U0_a*Dmob_Vsi_bi_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vsi_bi*Dmob_Vgi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#endif
Esat_Vgi_bi=(-(2.0*VSATCV_t)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#if defined(_DERIVATE2)
  Esat_Vgi_bi_Vdbulk_di=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vdbulk_di+0.0*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vdbulk_di)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vdbulk_di/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*(-U0_a*Dmob_Vdbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Vsbulk_si=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vsbulk_si+0.0*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vsbulk_si)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vsbulk_si/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*(-U0_a*Dmob_Vsbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Tempt_GND=((+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)+((2.0*VSATCV_t_Tempt_GND))*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Tempt_GND+U0_a_Tempt_GND*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Tempt_GND)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Tempt_GND/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*((U0_a_Tempt_GND*Dmob-U0_a*Dmob_Tempt_GND)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Vdi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vdi_bi+U0_a_Vdi_bi*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vdi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vdi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*((U0_a_Vdi_bi*Dmob-U0_a*Dmob_Vdi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Vsi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vsi_bi+U0_a_Vsi_bi*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vsi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vsi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*((U0_a_Vsi_bi*Dmob-U0_a*Dmob_Vsi_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
  Esat_Vgi_bi_Vgi_bi=((+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)/(U0_a/Dmob)-(0.0*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(0.0)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)+(2.0*VSATCV_t)*(0.0/Dmob-(0.0*Dmob_Vgi_bi+0.0*Dmob_Vgi_bi+U0_a*Dmob_Vgi_bi_Vgi_bi)/Dmob/Dmob+2*U0_a*Dmob_Vgi_bi*Dmob_Vgi_bi/Dmob/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob)+2*(2.0*VSATCV_t)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)*(-U0_a*Dmob_Vgi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
#endif
#endif
Esat=((2.0*VSATCV_t)/(U0_a/Dmob));
EXIT_IF_ISNAN(((2.0*VSATCV_t)/(U0_a/Dmob)))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(di,bi)V(si,bi)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
EsatL_Vdbulk_di=Esat_Vdbulk_di*Lact;
#if defined(_DERIVATE2)
  EsatL_Vdbulk_di_Vdbulk_di=(+Esat_Vdbulk_di_Vdbulk_di*Lact+Esat_Vdbulk_di*0.0+Esat_Vdbulk_di*0.0+Esat*0.0);
  EsatL_Vdbulk_di_Vsbulk_si=(+Esat_Vdbulk_di_Vsbulk_si*Lact+Esat_Vdbulk_di*0.0+Esat_Vsbulk_si*0.0+Esat*0.0);
  EsatL_Vdbulk_di_Tempt_GND=(+Esat_Vdbulk_di_Tempt_GND*Lact+Esat_Vdbulk_di*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vdbulk_di_Vdi_bi=(+Esat_Vdbulk_di_Vdi_bi*Lact+Esat_Vdbulk_di*0.0+Esat_Vdi_bi*0.0+Esat*0.0);
  EsatL_Vdbulk_di_Vsi_bi=(+Esat_Vdbulk_di_Vsi_bi*Lact+Esat_Vdbulk_di*0.0+Esat_Vsi_bi*0.0+Esat*0.0);
  EsatL_Vdbulk_di_Vgi_bi=(+Esat_Vdbulk_di_Vgi_bi*Lact+Esat_Vdbulk_di*0.0+Esat_Vgi_bi*0.0+Esat*0.0);
#endif
EsatL_Vsbulk_si=Esat_Vsbulk_si*Lact;
#if defined(_DERIVATE2)
  EsatL_Vsbulk_si_Vdbulk_di=(+Esat_Vsbulk_si_Vdbulk_di*Lact+Esat_Vsbulk_si*0.0+Esat_Vdbulk_di*0.0+Esat*0.0);
  EsatL_Vsbulk_si_Vsbulk_si=(+Esat_Vsbulk_si_Vsbulk_si*Lact+Esat_Vsbulk_si*0.0+Esat_Vsbulk_si*0.0+Esat*0.0);
  EsatL_Vsbulk_si_Tempt_GND=(+Esat_Vsbulk_si_Tempt_GND*Lact+Esat_Vsbulk_si*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vsbulk_si_Vdi_bi=(+Esat_Vsbulk_si_Vdi_bi*Lact+Esat_Vsbulk_si*0.0+Esat_Vdi_bi*0.0+Esat*0.0);
  EsatL_Vsbulk_si_Vsi_bi=(+Esat_Vsbulk_si_Vsi_bi*Lact+Esat_Vsbulk_si*0.0+Esat_Vsi_bi*0.0+Esat*0.0);
  EsatL_Vsbulk_si_Vgi_bi=(+Esat_Vsbulk_si_Vgi_bi*Lact+Esat_Vsbulk_si*0.0+Esat_Vgi_bi*0.0+Esat*0.0);
#endif
#if defined(_DERIVATE)
EsatL_Tempt_GND=Esat_Tempt_GND*Lact;
#endif
EsatL_Vdi_bi=Esat_Vdi_bi*Lact;
#if defined(_DERIVATE2)
  EsatL_Vdi_bi_Vdbulk_di=(+Esat_Vdi_bi_Vdbulk_di*Lact+Esat_Vdi_bi*0.0+Esat_Vdbulk_di*0.0+Esat*0.0);
  EsatL_Vdi_bi_Vsbulk_si=(+Esat_Vdi_bi_Vsbulk_si*Lact+Esat_Vdi_bi*0.0+Esat_Vsbulk_si*0.0+Esat*0.0);
  EsatL_Vdi_bi_Tempt_GND=(+Esat_Vdi_bi_Tempt_GND*Lact+Esat_Vdi_bi*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vdi_bi_Vdi_bi=(+Esat_Vdi_bi_Vdi_bi*Lact+Esat_Vdi_bi*0.0+Esat_Vdi_bi*0.0+Esat*0.0);
  EsatL_Vdi_bi_Vsi_bi=(+Esat_Vdi_bi_Vsi_bi*Lact+Esat_Vdi_bi*0.0+Esat_Vsi_bi*0.0+Esat*0.0);
  EsatL_Vdi_bi_Vgi_bi=(+Esat_Vdi_bi_Vgi_bi*Lact+Esat_Vdi_bi*0.0+Esat_Vgi_bi*0.0+Esat*0.0);
#endif
EsatL_Vsi_bi=Esat_Vsi_bi*Lact;
#if defined(_DERIVATE2)
  EsatL_Vsi_bi_Vdbulk_di=(+Esat_Vsi_bi_Vdbulk_di*Lact+Esat_Vsi_bi*0.0+Esat_Vdbulk_di*0.0+Esat*0.0);
  EsatL_Vsi_bi_Vsbulk_si=(+Esat_Vsi_bi_Vsbulk_si*Lact+Esat_Vsi_bi*0.0+Esat_Vsbulk_si*0.0+Esat*0.0);
  EsatL_Vsi_bi_Tempt_GND=(+Esat_Vsi_bi_Tempt_GND*Lact+Esat_Vsi_bi*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vsi_bi_Vdi_bi=(+Esat_Vsi_bi_Vdi_bi*Lact+Esat_Vsi_bi*0.0+Esat_Vdi_bi*0.0+Esat*0.0);
  EsatL_Vsi_bi_Vsi_bi=(+Esat_Vsi_bi_Vsi_bi*Lact+Esat_Vsi_bi*0.0+Esat_Vsi_bi*0.0+Esat*0.0);
  EsatL_Vsi_bi_Vgi_bi=(+Esat_Vsi_bi_Vgi_bi*Lact+Esat_Vsi_bi*0.0+Esat_Vgi_bi*0.0+Esat*0.0);
#endif
EsatL_Vgi_bi=Esat_Vgi_bi*Lact;
#if defined(_DERIVATE2)
  EsatL_Vgi_bi_Vdbulk_di=(+Esat_Vgi_bi_Vdbulk_di*Lact+Esat_Vgi_bi*0.0+Esat_Vdbulk_di*0.0+Esat*0.0);
  EsatL_Vgi_bi_Vsbulk_si=(+Esat_Vgi_bi_Vsbulk_si*Lact+Esat_Vgi_bi*0.0+Esat_Vsbulk_si*0.0+Esat*0.0);
  EsatL_Vgi_bi_Tempt_GND=(+Esat_Vgi_bi_Tempt_GND*Lact+Esat_Vgi_bi*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vgi_bi_Vdi_bi=(+Esat_Vgi_bi_Vdi_bi*Lact+Esat_Vgi_bi*0.0+Esat_Vdi_bi*0.0+Esat*0.0);
  EsatL_Vgi_bi_Vsi_bi=(+Esat_Vgi_bi_Vsi_bi*Lact+Esat_Vgi_bi*0.0+Esat_Vsi_bi*0.0+Esat*0.0);
  EsatL_Vgi_bi_Vgi_bi=(+Esat_Vgi_bi_Vgi_bi*Lact+Esat_Vgi_bi*0.0+Esat_Vgi_bi*0.0+Esat*0.0);
#endif
#endif
EsatL=(Esat*Lact);
EXIT_IF_ISNAN((Esat*Lact))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Vasat_Vdbulk_di=(VdssatCV_Vdbulk_di+EsatL_Vdbulk_di);
#if defined(_DERIVATE2)
  Vasat_Vdbulk_di_Vdbulk_di=(+VdssatCV_Vdbulk_di_Vdbulk_di+EsatL_Vdbulk_di_Vdbulk_di);
  Vasat_Vdbulk_di_Vsbulk_si=(+VdssatCV_Vdbulk_di_Vsbulk_si+EsatL_Vdbulk_di_Vsbulk_si);
  Vasat_Vdbulk_di_Vgi_bi=(+VdssatCV_Vdbulk_di_Vgi_bi+EsatL_Vdbulk_di_Vgi_bi);
  Vasat_Vdbulk_di_Vdi_bi=(+VdssatCV_Vdbulk_di_Vdi_bi+EsatL_Vdbulk_di_Vdi_bi);
  Vasat_Vdbulk_di_Vsi_bi=(+VdssatCV_Vdbulk_di_Vsi_bi+EsatL_Vdbulk_di_Vsi_bi);
  Vasat_Vdbulk_di_Tempt_GND=(+VdssatCV_Vdbulk_di_Tempt_GND+EsatL_Vdbulk_di_Tempt_GND);
#endif
Vasat_Vsbulk_si=(VdssatCV_Vsbulk_si+EsatL_Vsbulk_si);
#if defined(_DERIVATE2)
  Vasat_Vsbulk_si_Vdbulk_di=(+VdssatCV_Vsbulk_si_Vdbulk_di+EsatL_Vsbulk_si_Vdbulk_di);
  Vasat_Vsbulk_si_Vsbulk_si=(+VdssatCV_Vsbulk_si_Vsbulk_si+EsatL_Vsbulk_si_Vsbulk_si);
  Vasat_Vsbulk_si_Vgi_bi=(+VdssatCV_Vsbulk_si_Vgi_bi+EsatL_Vsbulk_si_Vgi_bi);
  Vasat_Vsbulk_si_Vdi_bi=(+VdssatCV_Vsbulk_si_Vdi_bi+EsatL_Vsbulk_si_Vdi_bi);
  Vasat_Vsbulk_si_Vsi_bi=(+VdssatCV_Vsbulk_si_Vsi_bi+EsatL_Vsbulk_si_Vsi_bi);
  Vasat_Vsbulk_si_Tempt_GND=(+VdssatCV_Vsbulk_si_Tempt_GND+EsatL_Vsbulk_si_Tempt_GND);
#endif
Vasat_Vgi_bi=(VdssatCV_Vgi_bi+EsatL_Vgi_bi);
#if defined(_DERIVATE2)
  Vasat_Vgi_bi_Vdbulk_di=(+VdssatCV_Vgi_bi_Vdbulk_di+EsatL_Vgi_bi_Vdbulk_di);
  Vasat_Vgi_bi_Vsbulk_si=(+VdssatCV_Vgi_bi_Vsbulk_si+EsatL_Vgi_bi_Vsbulk_si);
  Vasat_Vgi_bi_Vgi_bi=(+VdssatCV_Vgi_bi_Vgi_bi+EsatL_Vgi_bi_Vgi_bi);
  Vasat_Vgi_bi_Vdi_bi=(+VdssatCV_Vgi_bi_Vdi_bi+EsatL_Vgi_bi_Vdi_bi);
  Vasat_Vgi_bi_Vsi_bi=(+VdssatCV_Vgi_bi_Vsi_bi+EsatL_Vgi_bi_Vsi_bi);
  Vasat_Vgi_bi_Tempt_GND=(+VdssatCV_Vgi_bi_Tempt_GND+EsatL_Vgi_bi_Tempt_GND);
#endif
Vasat_Vdi_bi=(VdssatCV_Vdi_bi+EsatL_Vdi_bi);
#if defined(_DERIVATE2)
  Vasat_Vdi_bi_Vdbulk_di=(+VdssatCV_Vdi_bi_Vdbulk_di+EsatL_Vdi_bi_Vdbulk_di);
  Vasat_Vdi_bi_Vsbulk_si=(+VdssatCV_Vdi_bi_Vsbulk_si+EsatL_Vdi_bi_Vsbulk_si);
  Vasat_Vdi_bi_Vgi_bi=(+VdssatCV_Vdi_bi_Vgi_bi+EsatL_Vdi_bi_Vgi_bi);
  Vasat_Vdi_bi_Vdi_bi=(+VdssatCV_Vdi_bi_Vdi_bi+EsatL_Vdi_bi_Vdi_bi);
  Vasat_Vdi_bi_Vsi_bi=(+VdssatCV_Vdi_bi_Vsi_bi+EsatL_Vdi_bi_Vsi_bi);
  Vasat_Vdi_bi_Tempt_GND=(+VdssatCV_Vdi_bi_Tempt_GND+EsatL_Vdi_bi_Tempt_GND);
#endif
Vasat_Vsi_bi=(VdssatCV_Vsi_bi+EsatL_Vsi_bi);
#if defined(_DERIVATE2)
  Vasat_Vsi_bi_Vdbulk_di=(+VdssatCV_Vsi_bi_Vdbulk_di+EsatL_Vsi_bi_Vdbulk_di);
  Vasat_Vsi_bi_Vsbulk_si=(+VdssatCV_Vsi_bi_Vsbulk_si+EsatL_Vsi_bi_Vsbulk_si);
  Vasat_Vsi_bi_Vgi_bi=(+VdssatCV_Vsi_bi_Vgi_bi+EsatL_Vsi_bi_Vgi_bi);
  Vasat_Vsi_bi_Vdi_bi=(+VdssatCV_Vsi_bi_Vdi_bi+EsatL_Vsi_bi_Vdi_bi);
  Vasat_Vsi_bi_Vsi_bi=(+VdssatCV_Vsi_bi_Vsi_bi+EsatL_Vsi_bi_Vsi_bi);
  Vasat_Vsi_bi_Tempt_GND=(+VdssatCV_Vsi_bi_Tempt_GND+EsatL_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Vasat_Tempt_GND=(VdssatCV_Tempt_GND+EsatL_Tempt_GND);
#endif
#endif
Vasat=(VdssatCV+EsatL);
EXIT_IF_ISNAN((VdssatCV+EsatL))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
diffVds_Vdbulk_di=(-Vdseff_Vdbulk_di);
#if defined(_DERIVATE2)
  diffVds_Vdbulk_di_Vdbulk_di=(+0.0-Vdseff_Vdbulk_di_Vdbulk_di);
  diffVds_Vdbulk_di_Vsbulk_si=(+0.0-Vdseff_Vdbulk_di_Vsbulk_si);
  diffVds_Vdbulk_di_Vdi_bi=(+0.0-Vdseff_Vdbulk_di_Vdi_bi);
  diffVds_Vdbulk_di_Vsi_bi=(+0.0-Vdseff_Vdbulk_di_Vsi_bi);
  diffVds_Vdbulk_di_Vgi_bi=(+0.0-Vdseff_Vdbulk_di_Vgi_bi);
  diffVds_Vdbulk_di_Tempt_GND=(+0.0-Vdseff_Vdbulk_di_Tempt_GND);
#endif
diffVds_Vsbulk_si=(-Vdseff_Vsbulk_si);
#if defined(_DERIVATE2)
  diffVds_Vsbulk_si_Vdbulk_di=(+0.0-Vdseff_Vsbulk_si_Vdbulk_di);
  diffVds_Vsbulk_si_Vsbulk_si=(+0.0-Vdseff_Vsbulk_si_Vsbulk_si);
  diffVds_Vsbulk_si_Vdi_bi=(+0.0-Vdseff_Vsbulk_si_Vdi_bi);
  diffVds_Vsbulk_si_Vsi_bi=(+0.0-Vdseff_Vsbulk_si_Vsi_bi);
  diffVds_Vsbulk_si_Vgi_bi=(+0.0-Vdseff_Vsbulk_si_Vgi_bi);
  diffVds_Vsbulk_si_Tempt_GND=(+0.0-Vdseff_Vsbulk_si_Tempt_GND);
#endif
diffVds_Vdi_bi=(Vds_Vdi_bi-Vdseff_Vdi_bi);
#if defined(_DERIVATE2)
  diffVds_Vdi_bi_Vdbulk_di=(+0.0-Vdseff_Vdi_bi_Vdbulk_di);
  diffVds_Vdi_bi_Vsbulk_si=(+0.0-Vdseff_Vdi_bi_Vsbulk_si);
  diffVds_Vdi_bi_Vdi_bi=(+Vds_Vdi_bi_Vdi_bi-Vdseff_Vdi_bi_Vdi_bi);
  diffVds_Vdi_bi_Vsi_bi=(+Vds_Vdi_bi_Vsi_bi-Vdseff_Vdi_bi_Vsi_bi);
  diffVds_Vdi_bi_Vgi_bi=(+0.0-Vdseff_Vdi_bi_Vgi_bi);
  diffVds_Vdi_bi_Tempt_GND=(+0.0-Vdseff_Vdi_bi_Tempt_GND);
#endif
diffVds_Vsi_bi=(Vds_Vsi_bi-Vdseff_Vsi_bi);
#if defined(_DERIVATE2)
  diffVds_Vsi_bi_Vdbulk_di=(+0.0-Vdseff_Vsi_bi_Vdbulk_di);
  diffVds_Vsi_bi_Vsbulk_si=(+0.0-Vdseff_Vsi_bi_Vsbulk_si);
  diffVds_Vsi_bi_Vdi_bi=(+Vds_Vsi_bi_Vdi_bi-Vdseff_Vsi_bi_Vdi_bi);
  diffVds_Vsi_bi_Vsi_bi=(+Vds_Vsi_bi_Vsi_bi-Vdseff_Vsi_bi_Vsi_bi);
  diffVds_Vsi_bi_Vgi_bi=(+0.0-Vdseff_Vsi_bi_Vgi_bi);
  diffVds_Vsi_bi_Tempt_GND=(+0.0-Vdseff_Vsi_bi_Tempt_GND);
#endif
diffVds_Vgi_bi=(-Vdseff_Vgi_bi);
#if defined(_DERIVATE2)
  diffVds_Vgi_bi_Vdbulk_di=(+0.0-Vdseff_Vgi_bi_Vdbulk_di);
  diffVds_Vgi_bi_Vsbulk_si=(+0.0-Vdseff_Vgi_bi_Vsbulk_si);
  diffVds_Vgi_bi_Vdi_bi=(+0.0-Vdseff_Vgi_bi_Vdi_bi);
  diffVds_Vgi_bi_Vsi_bi=(+0.0-Vdseff_Vgi_bi_Vsi_bi);
  diffVds_Vgi_bi_Vgi_bi=(+0.0-Vdseff_Vgi_bi_Vgi_bi);
  diffVds_Vgi_bi_Tempt_GND=(+0.0-Vdseff_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
diffVds_Tempt_GND=(-Vdseff_Tempt_GND);
#endif
#endif
diffVds=(Vds-Vdseff);
EXIT_IF_ISNAN((Vds-Vdseff))
}
if
((PCLMCV_i!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
MdL_Vdbulk_di=(PCLMCV_i*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat)));
#if defined(_DERIVATE2)
  MdL_Vdbulk_di_Vdbulk_di=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdbulk_di_Vdbulk_di/PCLMCV_i-(diffVds_Vdbulk_di*0.0+diffVds_Vdbulk_di*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds/PCLMCV_i)*Vasat_Vdbulk_di_Vdbulk_di)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdbulk_di*Vasat_Vdbulk_di/Vasat/Vasat/Vasat))));
  MdL_Vdbulk_di_Vsbulk_si=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdbulk_di_Vsbulk_si/PCLMCV_i-(diffVds_Vdbulk_di*0.0+diffVds_Vsbulk_si*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds/PCLMCV_i)*Vasat_Vdbulk_di_Vsbulk_si)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdbulk_di*Vasat_Vsbulk_si/Vasat/Vasat/Vasat))));
  MdL_Vdbulk_di_Vgi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdbulk_di_Vgi_bi/PCLMCV_i-(diffVds_Vdbulk_di*0.0+diffVds_Vgi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vgi_bi+(diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds/PCLMCV_i)*Vasat_Vdbulk_di_Vgi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdbulk_di*Vasat_Vgi_bi/Vasat/Vasat/Vasat))));
  MdL_Vdbulk_di_Vdi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdbulk_di_Vdi_bi/PCLMCV_i-(diffVds_Vdbulk_di*0.0+diffVds_Vdi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vdi_bi+(diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds/PCLMCV_i)*Vasat_Vdbulk_di_Vdi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdbulk_di*Vasat_Vdi_bi/Vasat/Vasat/Vasat))));
  MdL_Vdbulk_di_Vsi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdbulk_di_Vsi_bi/PCLMCV_i-(diffVds_Vdbulk_di*0.0+diffVds_Vsi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vsi_bi+(diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds/PCLMCV_i)*Vasat_Vdbulk_di_Vsi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdbulk_di*Vasat_Vsi_bi/Vasat/Vasat/Vasat))));
  MdL_Vdbulk_di_Tempt_GND=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdbulk_di/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdbulk_di)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdbulk_di_Tempt_GND/PCLMCV_i-(diffVds_Vdbulk_di*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Tempt_GND+(diffVds_Tempt_GND/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds/PCLMCV_i)*Vasat_Vdbulk_di_Tempt_GND)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdbulk_di*Vasat_Tempt_GND/Vasat/Vasat/Vasat))));
#endif
MdL_Vsbulk_si=(PCLMCV_i*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat)));
#if defined(_DERIVATE2)
  MdL_Vsbulk_si_Vdbulk_di=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsbulk_si_Vdbulk_di/PCLMCV_i-(diffVds_Vsbulk_si*0.0+diffVds_Vdbulk_di*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds/PCLMCV_i)*Vasat_Vsbulk_si_Vdbulk_di)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsbulk_si*Vasat_Vdbulk_di/Vasat/Vasat/Vasat))));
  MdL_Vsbulk_si_Vsbulk_si=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsbulk_si_Vsbulk_si/PCLMCV_i-(diffVds_Vsbulk_si*0.0+diffVds_Vsbulk_si*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds/PCLMCV_i)*Vasat_Vsbulk_si_Vsbulk_si)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsbulk_si*Vasat_Vsbulk_si/Vasat/Vasat/Vasat))));
  MdL_Vsbulk_si_Vgi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsbulk_si_Vgi_bi/PCLMCV_i-(diffVds_Vsbulk_si*0.0+diffVds_Vgi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vgi_bi+(diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds/PCLMCV_i)*Vasat_Vsbulk_si_Vgi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsbulk_si*Vasat_Vgi_bi/Vasat/Vasat/Vasat))));
  MdL_Vsbulk_si_Vdi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsbulk_si_Vdi_bi/PCLMCV_i-(diffVds_Vsbulk_si*0.0+diffVds_Vdi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vdi_bi+(diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds/PCLMCV_i)*Vasat_Vsbulk_si_Vdi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsbulk_si*Vasat_Vdi_bi/Vasat/Vasat/Vasat))));
  MdL_Vsbulk_si_Vsi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsbulk_si_Vsi_bi/PCLMCV_i-(diffVds_Vsbulk_si*0.0+diffVds_Vsi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vsi_bi+(diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds/PCLMCV_i)*Vasat_Vsbulk_si_Vsi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsbulk_si*Vasat_Vsi_bi/Vasat/Vasat/Vasat))));
  MdL_Vsbulk_si_Tempt_GND=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsbulk_si/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsbulk_si)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsbulk_si_Tempt_GND/PCLMCV_i-(diffVds_Vsbulk_si*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Tempt_GND+(diffVds_Tempt_GND/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds/PCLMCV_i)*Vasat_Vsbulk_si_Tempt_GND)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsbulk_si*Vasat_Tempt_GND/Vasat/Vasat/Vasat))));
#endif
MdL_Vgi_bi=(PCLMCV_i*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat)));
#if defined(_DERIVATE2)
  MdL_Vgi_bi_Vdbulk_di=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vgi_bi_Vdbulk_di/PCLMCV_i-(diffVds_Vgi_bi*0.0+diffVds_Vdbulk_di*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vgi_bi+(diffVds/PCLMCV_i)*Vasat_Vgi_bi_Vdbulk_di)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vgi_bi*Vasat_Vdbulk_di/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Vsbulk_si=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vgi_bi_Vsbulk_si/PCLMCV_i-(diffVds_Vgi_bi*0.0+diffVds_Vsbulk_si*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vgi_bi+(diffVds/PCLMCV_i)*Vasat_Vgi_bi_Vsbulk_si)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vgi_bi*Vasat_Vsbulk_si/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Vgi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vgi_bi_Vgi_bi/PCLMCV_i-(diffVds_Vgi_bi*0.0+diffVds_Vgi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vgi_bi+(diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vgi_bi+(diffVds/PCLMCV_i)*Vasat_Vgi_bi_Vgi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vgi_bi*Vasat_Vgi_bi/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Vdi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vgi_bi_Vdi_bi/PCLMCV_i-(diffVds_Vgi_bi*0.0+diffVds_Vdi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vdi_bi+(diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vgi_bi+(diffVds/PCLMCV_i)*Vasat_Vgi_bi_Vdi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vgi_bi*Vasat_Vdi_bi/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Vsi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vgi_bi_Vsi_bi/PCLMCV_i-(diffVds_Vgi_bi*0.0+diffVds_Vsi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vsi_bi+(diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vgi_bi+(diffVds/PCLMCV_i)*Vasat_Vgi_bi_Vsi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vgi_bi*Vasat_Vsi_bi/Vasat/Vasat/Vasat))));
  MdL_Vgi_bi_Tempt_GND=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vgi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vgi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vgi_bi_Tempt_GND/PCLMCV_i-(diffVds_Vgi_bi*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vgi_bi/PCLMCV_i)*Vasat_Tempt_GND+(diffVds_Tempt_GND/PCLMCV_i)*Vasat_Vgi_bi+(diffVds/PCLMCV_i)*Vasat_Vgi_bi_Tempt_GND)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vgi_bi*Vasat_Tempt_GND/Vasat/Vasat/Vasat))));
#endif
MdL_Vdi_bi=(PCLMCV_i*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat)));
#if defined(_DERIVATE2)
  MdL_Vdi_bi_Vdbulk_di=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdi_bi_Vdbulk_di/PCLMCV_i-(diffVds_Vdi_bi*0.0+diffVds_Vdbulk_di*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vdi_bi+(diffVds/PCLMCV_i)*Vasat_Vdi_bi_Vdbulk_di)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdi_bi*Vasat_Vdbulk_di/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Vsbulk_si=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdi_bi_Vsbulk_si/PCLMCV_i-(diffVds_Vdi_bi*0.0+diffVds_Vsbulk_si*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vdi_bi+(diffVds/PCLMCV_i)*Vasat_Vdi_bi_Vsbulk_si)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdi_bi*Vasat_Vsbulk_si/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Vgi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdi_bi_Vgi_bi/PCLMCV_i-(diffVds_Vdi_bi*0.0+diffVds_Vgi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vgi_bi+(diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vdi_bi+(diffVds/PCLMCV_i)*Vasat_Vdi_bi_Vgi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdi_bi*Vasat_Vgi_bi/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Vdi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdi_bi_Vdi_bi/PCLMCV_i-(diffVds_Vdi_bi*0.0+diffVds_Vdi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vdi_bi+(diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vdi_bi+(diffVds/PCLMCV_i)*Vasat_Vdi_bi_Vdi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdi_bi*Vasat_Vdi_bi/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Vsi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdi_bi_Vsi_bi/PCLMCV_i-(diffVds_Vdi_bi*0.0+diffVds_Vsi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vsi_bi+(diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vdi_bi+(diffVds/PCLMCV_i)*Vasat_Vdi_bi_Vsi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdi_bi*Vasat_Vsi_bi/Vasat/Vasat/Vasat))));
  MdL_Vdi_bi_Tempt_GND=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vdi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vdi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vdi_bi_Tempt_GND/PCLMCV_i-(diffVds_Vdi_bi*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vdi_bi/PCLMCV_i)*Vasat_Tempt_GND+(diffVds_Tempt_GND/PCLMCV_i)*Vasat_Vdi_bi+(diffVds/PCLMCV_i)*Vasat_Vdi_bi_Tempt_GND)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vdi_bi*Vasat_Tempt_GND/Vasat/Vasat/Vasat))));
#endif
MdL_Vsi_bi=(PCLMCV_i*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat)));
#if defined(_DERIVATE2)
  MdL_Vsi_bi_Vdbulk_di=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsi_bi_Vdbulk_di/PCLMCV_i-(diffVds_Vsi_bi*0.0+diffVds_Vdbulk_di*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vdbulk_di+(diffVds_Vdbulk_di/PCLMCV_i)*Vasat_Vsi_bi+(diffVds/PCLMCV_i)*Vasat_Vsi_bi_Vdbulk_di)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsi_bi*Vasat_Vdbulk_di/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Vsbulk_si=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsi_bi_Vsbulk_si/PCLMCV_i-(diffVds_Vsi_bi*0.0+diffVds_Vsbulk_si*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vsbulk_si+(diffVds_Vsbulk_si/PCLMCV_i)*Vasat_Vsi_bi+(diffVds/PCLMCV_i)*Vasat_Vsi_bi_Vsbulk_si)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsi_bi*Vasat_Vsbulk_si/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Vgi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsi_bi_Vgi_bi/PCLMCV_i-(diffVds_Vsi_bi*0.0+diffVds_Vgi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vgi_bi+(diffVds_Vgi_bi/PCLMCV_i)*Vasat_Vsi_bi+(diffVds/PCLMCV_i)*Vasat_Vsi_bi_Vgi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsi_bi*Vasat_Vgi_bi/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Vdi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsi_bi_Vdi_bi/PCLMCV_i-(diffVds_Vsi_bi*0.0+diffVds_Vdi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vdi_bi+(diffVds_Vdi_bi/PCLMCV_i)*Vasat_Vsi_bi+(diffVds/PCLMCV_i)*Vasat_Vsi_bi_Vdi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsi_bi*Vasat_Vdi_bi/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Vsi_bi=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsi_bi_Vsi_bi/PCLMCV_i-(diffVds_Vsi_bi*0.0+diffVds_Vsi_bi*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vsi_bi+(diffVds_Vsi_bi/PCLMCV_i)*Vasat_Vsi_bi+(diffVds/PCLMCV_i)*Vasat_Vsi_bi_Vsi_bi)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsi_bi*Vasat_Vsi_bi/Vasat/Vasat/Vasat))));
  MdL_Vsi_bi_Tempt_GND=(+0.0+(+0.0*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+0.0*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Vsi_bi/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Vsi_bi)/Vasat/Vasat))+PCLMCV_i*(+0.0+((diffVds_Vsi_bi_Tempt_GND/PCLMCV_i-(diffVds_Vsi_bi*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/PCLMCV_i/PCLMCV_i+2*diffVds*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/Vasat-((diffVds_Vsi_bi/PCLMCV_i)*Vasat_Tempt_GND+(diffVds_Tempt_GND/PCLMCV_i)*Vasat_Vsi_bi+(diffVds/PCLMCV_i)*Vasat_Vsi_bi_Tempt_GND)/Vasat/Vasat+2*(diffVds/PCLMCV_i)*Vasat_Vsi_bi*Vasat_Tempt_GND/Vasat/Vasat/Vasat))));
#endif
#if defined(_DERIVATE)
MdL_Tempt_GND=(PCLMCV_i*bsimbulk_d_lln((1.0+((diffVds/PCLMCV_i)/Vasat)),(((diffVds_Tempt_GND/PCLMCV_i)*Vasat-(diffVds/PCLMCV_i)*Vasat_Tempt_GND)/Vasat/Vasat)));
#endif
#endif
MdL=(1.0+(PCLMCV_i*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat)))));
EXIT_IF_ISNAN((1.0+(PCLMCV_i*bsimbulk_lln((1.0+((diffVds/PCLMCV_i)/Vasat))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
MdL_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  MdL_Vdbulk_di_Vdbulk_di=0.0;
  MdL_Vdbulk_di_Vsbulk_si=0.0;
  MdL_Vdbulk_di_Vgi_bi=0.0;
  MdL_Vdbulk_di_Vdi_bi=0.0;
  MdL_Vdbulk_di_Vsi_bi=0.0;
  MdL_Vdbulk_di_Tempt_GND=0.0;
#endif
MdL_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  MdL_Vsbulk_si_Vdbulk_di=0.0;
  MdL_Vsbulk_si_Vsbulk_si=0.0;
  MdL_Vsbulk_si_Vgi_bi=0.0;
  MdL_Vsbulk_si_Vdi_bi=0.0;
  MdL_Vsbulk_si_Vsi_bi=0.0;
  MdL_Vsbulk_si_Tempt_GND=0.0;
#endif
MdL_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  MdL_Vgi_bi_Vdbulk_di=0.0;
  MdL_Vgi_bi_Vsbulk_si=0.0;
  MdL_Vgi_bi_Vgi_bi=0.0;
  MdL_Vgi_bi_Vdi_bi=0.0;
  MdL_Vgi_bi_Vsi_bi=0.0;
  MdL_Vgi_bi_Tempt_GND=0.0;
#endif
MdL_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  MdL_Vdi_bi_Vdbulk_di=0.0;
  MdL_Vdi_bi_Vsbulk_si=0.0;
  MdL_Vdi_bi_Vgi_bi=0.0;
  MdL_Vdi_bi_Vdi_bi=0.0;
  MdL_Vdi_bi_Vsi_bi=0.0;
  MdL_Vdi_bi_Tempt_GND=0.0;
#endif
MdL_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  MdL_Vsi_bi_Vdbulk_di=0.0;
  MdL_Vsi_bi_Vsbulk_si=0.0;
  MdL_Vsi_bi_Vgi_bi=0.0;
  MdL_Vsi_bi_Vdi_bi=0.0;
  MdL_Vsi_bi_Vsi_bi=0.0;
  MdL_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
MdL_Tempt_GND=0.0;
#endif
#endif
MdL=1.0;
EXIT_IF_ISNAN(1.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
MdL_2_Vdbulk_di=((MdL_Vdbulk_di*MdL)+(MdL*MdL_Vdbulk_di));
#if defined(_DERIVATE2)
  MdL_2_Vdbulk_di_Vdbulk_di=(+MdL_Vdbulk_di_Vdbulk_di*MdL+MdL_Vdbulk_di*MdL_Vdbulk_di+MdL_Vdbulk_di*MdL_Vdbulk_di+MdL*MdL_Vdbulk_di_Vdbulk_di);
  MdL_2_Vdbulk_di_Vsbulk_si=(+MdL_Vdbulk_di_Vsbulk_si*MdL+MdL_Vdbulk_di*MdL_Vsbulk_si+MdL_Vsbulk_si*MdL_Vdbulk_di+MdL*MdL_Vdbulk_di_Vsbulk_si);
  MdL_2_Vdbulk_di_Vgi_bi=(+MdL_Vdbulk_di_Vgi_bi*MdL+MdL_Vdbulk_di*MdL_Vgi_bi+MdL_Vgi_bi*MdL_Vdbulk_di+MdL*MdL_Vdbulk_di_Vgi_bi);
  MdL_2_Vdbulk_di_Vdi_bi=(+MdL_Vdbulk_di_Vdi_bi*MdL+MdL_Vdbulk_di*MdL_Vdi_bi+MdL_Vdi_bi*MdL_Vdbulk_di+MdL*MdL_Vdbulk_di_Vdi_bi);
  MdL_2_Vdbulk_di_Vsi_bi=(+MdL_Vdbulk_di_Vsi_bi*MdL+MdL_Vdbulk_di*MdL_Vsi_bi+MdL_Vsi_bi*MdL_Vdbulk_di+MdL*MdL_Vdbulk_di_Vsi_bi);
  MdL_2_Vdbulk_di_Tempt_GND=(+MdL_Vdbulk_di_Tempt_GND*MdL+MdL_Vdbulk_di*MdL_Tempt_GND+MdL_Tempt_GND*MdL_Vdbulk_di+MdL*MdL_Vdbulk_di_Tempt_GND);
#endif
MdL_2_Vsbulk_si=((MdL_Vsbulk_si*MdL)+(MdL*MdL_Vsbulk_si));
#if defined(_DERIVATE2)
  MdL_2_Vsbulk_si_Vdbulk_di=(+MdL_Vsbulk_si_Vdbulk_di*MdL+MdL_Vsbulk_si*MdL_Vdbulk_di+MdL_Vdbulk_di*MdL_Vsbulk_si+MdL*MdL_Vsbulk_si_Vdbulk_di);
  MdL_2_Vsbulk_si_Vsbulk_si=(+MdL_Vsbulk_si_Vsbulk_si*MdL+MdL_Vsbulk_si*MdL_Vsbulk_si+MdL_Vsbulk_si*MdL_Vsbulk_si+MdL*MdL_Vsbulk_si_Vsbulk_si);
  MdL_2_Vsbulk_si_Vgi_bi=(+MdL_Vsbulk_si_Vgi_bi*MdL+MdL_Vsbulk_si*MdL_Vgi_bi+MdL_Vgi_bi*MdL_Vsbulk_si+MdL*MdL_Vsbulk_si_Vgi_bi);
  MdL_2_Vsbulk_si_Vdi_bi=(+MdL_Vsbulk_si_Vdi_bi*MdL+MdL_Vsbulk_si*MdL_Vdi_bi+MdL_Vdi_bi*MdL_Vsbulk_si+MdL*MdL_Vsbulk_si_Vdi_bi);
  MdL_2_Vsbulk_si_Vsi_bi=(+MdL_Vsbulk_si_Vsi_bi*MdL+MdL_Vsbulk_si*MdL_Vsi_bi+MdL_Vsi_bi*MdL_Vsbulk_si+MdL*MdL_Vsbulk_si_Vsi_bi);
  MdL_2_Vsbulk_si_Tempt_GND=(+MdL_Vsbulk_si_Tempt_GND*MdL+MdL_Vsbulk_si*MdL_Tempt_GND+MdL_Tempt_GND*MdL_Vsbulk_si+MdL*MdL_Vsbulk_si_Tempt_GND);
#endif
MdL_2_Vgi_bi=((MdL_Vgi_bi*MdL)+(MdL*MdL_Vgi_bi));
#if defined(_DERIVATE2)
  MdL_2_Vgi_bi_Vdbulk_di=(+MdL_Vgi_bi_Vdbulk_di*MdL+MdL_Vgi_bi*MdL_Vdbulk_di+MdL_Vdbulk_di*MdL_Vgi_bi+MdL*MdL_Vgi_bi_Vdbulk_di);
  MdL_2_Vgi_bi_Vsbulk_si=(+MdL_Vgi_bi_Vsbulk_si*MdL+MdL_Vgi_bi*MdL_Vsbulk_si+MdL_Vsbulk_si*MdL_Vgi_bi+MdL*MdL_Vgi_bi_Vsbulk_si);
  MdL_2_Vgi_bi_Vgi_bi=(+MdL_Vgi_bi_Vgi_bi*MdL+MdL_Vgi_bi*MdL_Vgi_bi+MdL_Vgi_bi*MdL_Vgi_bi+MdL*MdL_Vgi_bi_Vgi_bi);
  MdL_2_Vgi_bi_Vdi_bi=(+MdL_Vgi_bi_Vdi_bi*MdL+MdL_Vgi_bi*MdL_Vdi_bi+MdL_Vdi_bi*MdL_Vgi_bi+MdL*MdL_Vgi_bi_Vdi_bi);
  MdL_2_Vgi_bi_Vsi_bi=(+MdL_Vgi_bi_Vsi_bi*MdL+MdL_Vgi_bi*MdL_Vsi_bi+MdL_Vsi_bi*MdL_Vgi_bi+MdL*MdL_Vgi_bi_Vsi_bi);
  MdL_2_Vgi_bi_Tempt_GND=(+MdL_Vgi_bi_Tempt_GND*MdL+MdL_Vgi_bi*MdL_Tempt_GND+MdL_Tempt_GND*MdL_Vgi_bi+MdL*MdL_Vgi_bi_Tempt_GND);
#endif
MdL_2_Vdi_bi=((MdL_Vdi_bi*MdL)+(MdL*MdL_Vdi_bi));
#if defined(_DERIVATE2)
  MdL_2_Vdi_bi_Vdbulk_di=(+MdL_Vdi_bi_Vdbulk_di*MdL+MdL_Vdi_bi*MdL_Vdbulk_di+MdL_Vdbulk_di*MdL_Vdi_bi+MdL*MdL_Vdi_bi_Vdbulk_di);
  MdL_2_Vdi_bi_Vsbulk_si=(+MdL_Vdi_bi_Vsbulk_si*MdL+MdL_Vdi_bi*MdL_Vsbulk_si+MdL_Vsbulk_si*MdL_Vdi_bi+MdL*MdL_Vdi_bi_Vsbulk_si);
  MdL_2_Vdi_bi_Vgi_bi=(+MdL_Vdi_bi_Vgi_bi*MdL+MdL_Vdi_bi*MdL_Vgi_bi+MdL_Vgi_bi*MdL_Vdi_bi+MdL*MdL_Vdi_bi_Vgi_bi);
  MdL_2_Vdi_bi_Vdi_bi=(+MdL_Vdi_bi_Vdi_bi*MdL+MdL_Vdi_bi*MdL_Vdi_bi+MdL_Vdi_bi*MdL_Vdi_bi+MdL*MdL_Vdi_bi_Vdi_bi);
  MdL_2_Vdi_bi_Vsi_bi=(+MdL_Vdi_bi_Vsi_bi*MdL+MdL_Vdi_bi*MdL_Vsi_bi+MdL_Vsi_bi*MdL_Vdi_bi+MdL*MdL_Vdi_bi_Vsi_bi);
  MdL_2_Vdi_bi_Tempt_GND=(+MdL_Vdi_bi_Tempt_GND*MdL+MdL_Vdi_bi*MdL_Tempt_GND+MdL_Tempt_GND*MdL_Vdi_bi+MdL*MdL_Vdi_bi_Tempt_GND);
#endif
MdL_2_Vsi_bi=((MdL_Vsi_bi*MdL)+(MdL*MdL_Vsi_bi));
#if defined(_DERIVATE2)
  MdL_2_Vsi_bi_Vdbulk_di=(+MdL_Vsi_bi_Vdbulk_di*MdL+MdL_Vsi_bi*MdL_Vdbulk_di+MdL_Vdbulk_di*MdL_Vsi_bi+MdL*MdL_Vsi_bi_Vdbulk_di);
  MdL_2_Vsi_bi_Vsbulk_si=(+MdL_Vsi_bi_Vsbulk_si*MdL+MdL_Vsi_bi*MdL_Vsbulk_si+MdL_Vsbulk_si*MdL_Vsi_bi+MdL*MdL_Vsi_bi_Vsbulk_si);
  MdL_2_Vsi_bi_Vgi_bi=(+MdL_Vsi_bi_Vgi_bi*MdL+MdL_Vsi_bi*MdL_Vgi_bi+MdL_Vgi_bi*MdL_Vsi_bi+MdL*MdL_Vsi_bi_Vgi_bi);
  MdL_2_Vsi_bi_Vdi_bi=(+MdL_Vsi_bi_Vdi_bi*MdL+MdL_Vsi_bi*MdL_Vdi_bi+MdL_Vdi_bi*MdL_Vsi_bi+MdL*MdL_Vsi_bi_Vdi_bi);
  MdL_2_Vsi_bi_Vsi_bi=(+MdL_Vsi_bi_Vsi_bi*MdL+MdL_Vsi_bi*MdL_Vsi_bi+MdL_Vsi_bi*MdL_Vsi_bi+MdL*MdL_Vsi_bi_Vsi_bi);
  MdL_2_Vsi_bi_Tempt_GND=(+MdL_Vsi_bi_Tempt_GND*MdL+MdL_Vsi_bi*MdL_Tempt_GND+MdL_Tempt_GND*MdL_Vsi_bi+MdL*MdL_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
MdL_2_Tempt_GND=((MdL_Tempt_GND*MdL)+(MdL*MdL_Tempt_GND));
#endif
#endif
MdL_2=(MdL*MdL);
EXIT_IF_ISNAN((MdL*MdL))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
inv_MdL_Vdbulk_di=(-MdL_Vdbulk_di/MdL/MdL);
#if defined(_DERIVATE2)
  inv_MdL_Vdbulk_di_Vdbulk_di=(0.0/MdL-(0.0*MdL_Vdbulk_di+0.0*MdL_Vdbulk_di+1.0*MdL_Vdbulk_di_Vdbulk_di)/MdL/MdL+2*1.0*MdL_Vdbulk_di*MdL_Vdbulk_di/MdL/MdL/MdL);
  inv_MdL_Vdbulk_di_Vsbulk_si=(0.0/MdL-(0.0*MdL_Vsbulk_si+0.0*MdL_Vdbulk_di+1.0*MdL_Vdbulk_di_Vsbulk_si)/MdL/MdL+2*1.0*MdL_Vdbulk_di*MdL_Vsbulk_si/MdL/MdL/MdL);
  inv_MdL_Vdbulk_di_Vgi_bi=(0.0/MdL-(0.0*MdL_Vgi_bi+0.0*MdL_Vdbulk_di+1.0*MdL_Vdbulk_di_Vgi_bi)/MdL/MdL+2*1.0*MdL_Vdbulk_di*MdL_Vgi_bi/MdL/MdL/MdL);
  inv_MdL_Vdbulk_di_Vdi_bi=(0.0/MdL-(0.0*MdL_Vdi_bi+0.0*MdL_Vdbulk_di+1.0*MdL_Vdbulk_di_Vdi_bi)/MdL/MdL+2*1.0*MdL_Vdbulk_di*MdL_Vdi_bi/MdL/MdL/MdL);
  inv_MdL_Vdbulk_di_Vsi_bi=(0.0/MdL-(0.0*MdL_Vsi_bi+0.0*MdL_Vdbulk_di+1.0*MdL_Vdbulk_di_Vsi_bi)/MdL/MdL+2*1.0*MdL_Vdbulk_di*MdL_Vsi_bi/MdL/MdL/MdL);
  inv_MdL_Vdbulk_di_Tempt_GND=(0.0/MdL-(0.0*MdL_Tempt_GND+0.0*MdL_Vdbulk_di+1.0*MdL_Vdbulk_di_Tempt_GND)/MdL/MdL+2*1.0*MdL_Vdbulk_di*MdL_Tempt_GND/MdL/MdL/MdL);
#endif
inv_MdL_Vsbulk_si=(-MdL_Vsbulk_si/MdL/MdL);
#if defined(_DERIVATE2)
  inv_MdL_Vsbulk_si_Vdbulk_di=(0.0/MdL-(0.0*MdL_Vdbulk_di+0.0*MdL_Vsbulk_si+1.0*MdL_Vsbulk_si_Vdbulk_di)/MdL/MdL+2*1.0*MdL_Vsbulk_si*MdL_Vdbulk_di/MdL/MdL/MdL);
  inv_MdL_Vsbulk_si_Vsbulk_si=(0.0/MdL-(0.0*MdL_Vsbulk_si+0.0*MdL_Vsbulk_si+1.0*MdL_Vsbulk_si_Vsbulk_si)/MdL/MdL+2*1.0*MdL_Vsbulk_si*MdL_Vsbulk_si/MdL/MdL/MdL);
  inv_MdL_Vsbulk_si_Vgi_bi=(0.0/MdL-(0.0*MdL_Vgi_bi+0.0*MdL_Vsbulk_si+1.0*MdL_Vsbulk_si_Vgi_bi)/MdL/MdL+2*1.0*MdL_Vsbulk_si*MdL_Vgi_bi/MdL/MdL/MdL);
  inv_MdL_Vsbulk_si_Vdi_bi=(0.0/MdL-(0.0*MdL_Vdi_bi+0.0*MdL_Vsbulk_si+1.0*MdL_Vsbulk_si_Vdi_bi)/MdL/MdL+2*1.0*MdL_Vsbulk_si*MdL_Vdi_bi/MdL/MdL/MdL);
  inv_MdL_Vsbulk_si_Vsi_bi=(0.0/MdL-(0.0*MdL_Vsi_bi+0.0*MdL_Vsbulk_si+1.0*MdL_Vsbulk_si_Vsi_bi)/MdL/MdL+2*1.0*MdL_Vsbulk_si*MdL_Vsi_bi/MdL/MdL/MdL);
  inv_MdL_Vsbulk_si_Tempt_GND=(0.0/MdL-(0.0*MdL_Tempt_GND+0.0*MdL_Vsbulk_si+1.0*MdL_Vsbulk_si_Tempt_GND)/MdL/MdL+2*1.0*MdL_Vsbulk_si*MdL_Tempt_GND/MdL/MdL/MdL);
#endif
inv_MdL_Vgi_bi=(-MdL_Vgi_bi/MdL/MdL);
#if defined(_DERIVATE2)
  inv_MdL_Vgi_bi_Vdbulk_di=(0.0/MdL-(0.0*MdL_Vdbulk_di+0.0*MdL_Vgi_bi+1.0*MdL_Vgi_bi_Vdbulk_di)/MdL/MdL+2*1.0*MdL_Vgi_bi*MdL_Vdbulk_di/MdL/MdL/MdL);
  inv_MdL_Vgi_bi_Vsbulk_si=(0.0/MdL-(0.0*MdL_Vsbulk_si+0.0*MdL_Vgi_bi+1.0*MdL_Vgi_bi_Vsbulk_si)/MdL/MdL+2*1.0*MdL_Vgi_bi*MdL_Vsbulk_si/MdL/MdL/MdL);
  inv_MdL_Vgi_bi_Vgi_bi=(0.0/MdL-(0.0*MdL_Vgi_bi+0.0*MdL_Vgi_bi+1.0*MdL_Vgi_bi_Vgi_bi)/MdL/MdL+2*1.0*MdL_Vgi_bi*MdL_Vgi_bi/MdL/MdL/MdL);
  inv_MdL_Vgi_bi_Vdi_bi=(0.0/MdL-(0.0*MdL_Vdi_bi+0.0*MdL_Vgi_bi+1.0*MdL_Vgi_bi_Vdi_bi)/MdL/MdL+2*1.0*MdL_Vgi_bi*MdL_Vdi_bi/MdL/MdL/MdL);
  inv_MdL_Vgi_bi_Vsi_bi=(0.0/MdL-(0.0*MdL_Vsi_bi+0.0*MdL_Vgi_bi+1.0*MdL_Vgi_bi_Vsi_bi)/MdL/MdL+2*1.0*MdL_Vgi_bi*MdL_Vsi_bi/MdL/MdL/MdL);
  inv_MdL_Vgi_bi_Tempt_GND=(0.0/MdL-(0.0*MdL_Tempt_GND+0.0*MdL_Vgi_bi+1.0*MdL_Vgi_bi_Tempt_GND)/MdL/MdL+2*1.0*MdL_Vgi_bi*MdL_Tempt_GND/MdL/MdL/MdL);
#endif
inv_MdL_Vdi_bi=(-MdL_Vdi_bi/MdL/MdL);
#if defined(_DERIVATE2)
  inv_MdL_Vdi_bi_Vdbulk_di=(0.0/MdL-(0.0*MdL_Vdbulk_di+0.0*MdL_Vdi_bi+1.0*MdL_Vdi_bi_Vdbulk_di)/MdL/MdL+2*1.0*MdL_Vdi_bi*MdL_Vdbulk_di/MdL/MdL/MdL);
  inv_MdL_Vdi_bi_Vsbulk_si=(0.0/MdL-(0.0*MdL_Vsbulk_si+0.0*MdL_Vdi_bi+1.0*MdL_Vdi_bi_Vsbulk_si)/MdL/MdL+2*1.0*MdL_Vdi_bi*MdL_Vsbulk_si/MdL/MdL/MdL);
  inv_MdL_Vdi_bi_Vgi_bi=(0.0/MdL-(0.0*MdL_Vgi_bi+0.0*MdL_Vdi_bi+1.0*MdL_Vdi_bi_Vgi_bi)/MdL/MdL+2*1.0*MdL_Vdi_bi*MdL_Vgi_bi/MdL/MdL/MdL);
  inv_MdL_Vdi_bi_Vdi_bi=(0.0/MdL-(0.0*MdL_Vdi_bi+0.0*MdL_Vdi_bi+1.0*MdL_Vdi_bi_Vdi_bi)/MdL/MdL+2*1.0*MdL_Vdi_bi*MdL_Vdi_bi/MdL/MdL/MdL);
  inv_MdL_Vdi_bi_Vsi_bi=(0.0/MdL-(0.0*MdL_Vsi_bi+0.0*MdL_Vdi_bi+1.0*MdL_Vdi_bi_Vsi_bi)/MdL/MdL+2*1.0*MdL_Vdi_bi*MdL_Vsi_bi/MdL/MdL/MdL);
  inv_MdL_Vdi_bi_Tempt_GND=(0.0/MdL-(0.0*MdL_Tempt_GND+0.0*MdL_Vdi_bi+1.0*MdL_Vdi_bi_Tempt_GND)/MdL/MdL+2*1.0*MdL_Vdi_bi*MdL_Tempt_GND/MdL/MdL/MdL);
#endif
inv_MdL_Vsi_bi=(-MdL_Vsi_bi/MdL/MdL);
#if defined(_DERIVATE2)
  inv_MdL_Vsi_bi_Vdbulk_di=(0.0/MdL-(0.0*MdL_Vdbulk_di+0.0*MdL_Vsi_bi+1.0*MdL_Vsi_bi_Vdbulk_di)/MdL/MdL+2*1.0*MdL_Vsi_bi*MdL_Vdbulk_di/MdL/MdL/MdL);
  inv_MdL_Vsi_bi_Vsbulk_si=(0.0/MdL-(0.0*MdL_Vsbulk_si+0.0*MdL_Vsi_bi+1.0*MdL_Vsi_bi_Vsbulk_si)/MdL/MdL+2*1.0*MdL_Vsi_bi*MdL_Vsbulk_si/MdL/MdL/MdL);
  inv_MdL_Vsi_bi_Vgi_bi=(0.0/MdL-(0.0*MdL_Vgi_bi+0.0*MdL_Vsi_bi+1.0*MdL_Vsi_bi_Vgi_bi)/MdL/MdL+2*1.0*MdL_Vsi_bi*MdL_Vgi_bi/MdL/MdL/MdL);
  inv_MdL_Vsi_bi_Vdi_bi=(0.0/MdL-(0.0*MdL_Vdi_bi+0.0*MdL_Vsi_bi+1.0*MdL_Vsi_bi_Vdi_bi)/MdL/MdL+2*1.0*MdL_Vsi_bi*MdL_Vdi_bi/MdL/MdL/MdL);
  inv_MdL_Vsi_bi_Vsi_bi=(0.0/MdL-(0.0*MdL_Vsi_bi+0.0*MdL_Vsi_bi+1.0*MdL_Vsi_bi_Vsi_bi)/MdL/MdL+2*1.0*MdL_Vsi_bi*MdL_Vsi_bi/MdL/MdL/MdL);
  inv_MdL_Vsi_bi_Tempt_GND=(0.0/MdL-(0.0*MdL_Tempt_GND+0.0*MdL_Vsi_bi+1.0*MdL_Vsi_bi_Tempt_GND)/MdL/MdL+2*1.0*MdL_Vsi_bi*MdL_Tempt_GND/MdL/MdL/MdL);
#endif
#if defined(_DERIVATE)
inv_MdL_Tempt_GND=(-MdL_Tempt_GND/MdL/MdL);
#endif
#endif
inv_MdL=(1.0/MdL);
EXIT_IF_ISNAN((1.0/MdL))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
inv_MdL_2_Vdbulk_di=(-MdL_2_Vdbulk_di/MdL_2/MdL_2);
#if defined(_DERIVATE2)
  inv_MdL_2_Vdbulk_di_Vdbulk_di=(0.0/MdL_2-(0.0*MdL_2_Vdbulk_di+0.0*MdL_2_Vdbulk_di+1.0*MdL_2_Vdbulk_di_Vdbulk_di)/MdL_2/MdL_2+2*1.0*MdL_2_Vdbulk_di*MdL_2_Vdbulk_di/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdbulk_di_Vsbulk_si=(0.0/MdL_2-(0.0*MdL_2_Vsbulk_si+0.0*MdL_2_Vdbulk_di+1.0*MdL_2_Vdbulk_di_Vsbulk_si)/MdL_2/MdL_2+2*1.0*MdL_2_Vdbulk_di*MdL_2_Vsbulk_si/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdbulk_di_Vgi_bi=(0.0/MdL_2-(0.0*MdL_2_Vgi_bi+0.0*MdL_2_Vdbulk_di+1.0*MdL_2_Vdbulk_di_Vgi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vdbulk_di*MdL_2_Vgi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdbulk_di_Vdi_bi=(0.0/MdL_2-(0.0*MdL_2_Vdi_bi+0.0*MdL_2_Vdbulk_di+1.0*MdL_2_Vdbulk_di_Vdi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vdbulk_di*MdL_2_Vdi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdbulk_di_Vsi_bi=(0.0/MdL_2-(0.0*MdL_2_Vsi_bi+0.0*MdL_2_Vdbulk_di+1.0*MdL_2_Vdbulk_di_Vsi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vdbulk_di*MdL_2_Vsi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdbulk_di_Tempt_GND=(0.0/MdL_2-(0.0*MdL_2_Tempt_GND+0.0*MdL_2_Vdbulk_di+1.0*MdL_2_Vdbulk_di_Tempt_GND)/MdL_2/MdL_2+2*1.0*MdL_2_Vdbulk_di*MdL_2_Tempt_GND/MdL_2/MdL_2/MdL_2);
#endif
inv_MdL_2_Vsbulk_si=(-MdL_2_Vsbulk_si/MdL_2/MdL_2);
#if defined(_DERIVATE2)
  inv_MdL_2_Vsbulk_si_Vdbulk_di=(0.0/MdL_2-(0.0*MdL_2_Vdbulk_di+0.0*MdL_2_Vsbulk_si+1.0*MdL_2_Vsbulk_si_Vdbulk_di)/MdL_2/MdL_2+2*1.0*MdL_2_Vsbulk_si*MdL_2_Vdbulk_di/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsbulk_si_Vsbulk_si=(0.0/MdL_2-(0.0*MdL_2_Vsbulk_si+0.0*MdL_2_Vsbulk_si+1.0*MdL_2_Vsbulk_si_Vsbulk_si)/MdL_2/MdL_2+2*1.0*MdL_2_Vsbulk_si*MdL_2_Vsbulk_si/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsbulk_si_Vgi_bi=(0.0/MdL_2-(0.0*MdL_2_Vgi_bi+0.0*MdL_2_Vsbulk_si+1.0*MdL_2_Vsbulk_si_Vgi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vsbulk_si*MdL_2_Vgi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsbulk_si_Vdi_bi=(0.0/MdL_2-(0.0*MdL_2_Vdi_bi+0.0*MdL_2_Vsbulk_si+1.0*MdL_2_Vsbulk_si_Vdi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vsbulk_si*MdL_2_Vdi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsbulk_si_Vsi_bi=(0.0/MdL_2-(0.0*MdL_2_Vsi_bi+0.0*MdL_2_Vsbulk_si+1.0*MdL_2_Vsbulk_si_Vsi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vsbulk_si*MdL_2_Vsi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsbulk_si_Tempt_GND=(0.0/MdL_2-(0.0*MdL_2_Tempt_GND+0.0*MdL_2_Vsbulk_si+1.0*MdL_2_Vsbulk_si_Tempt_GND)/MdL_2/MdL_2+2*1.0*MdL_2_Vsbulk_si*MdL_2_Tempt_GND/MdL_2/MdL_2/MdL_2);
#endif
inv_MdL_2_Vgi_bi=(-MdL_2_Vgi_bi/MdL_2/MdL_2);
#if defined(_DERIVATE2)
  inv_MdL_2_Vgi_bi_Vdbulk_di=(0.0/MdL_2-(0.0*MdL_2_Vdbulk_di+0.0*MdL_2_Vgi_bi+1.0*MdL_2_Vgi_bi_Vdbulk_di)/MdL_2/MdL_2+2*1.0*MdL_2_Vgi_bi*MdL_2_Vdbulk_di/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vgi_bi_Vsbulk_si=(0.0/MdL_2-(0.0*MdL_2_Vsbulk_si+0.0*MdL_2_Vgi_bi+1.0*MdL_2_Vgi_bi_Vsbulk_si)/MdL_2/MdL_2+2*1.0*MdL_2_Vgi_bi*MdL_2_Vsbulk_si/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vgi_bi_Vgi_bi=(0.0/MdL_2-(0.0*MdL_2_Vgi_bi+0.0*MdL_2_Vgi_bi+1.0*MdL_2_Vgi_bi_Vgi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vgi_bi*MdL_2_Vgi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vgi_bi_Vdi_bi=(0.0/MdL_2-(0.0*MdL_2_Vdi_bi+0.0*MdL_2_Vgi_bi+1.0*MdL_2_Vgi_bi_Vdi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vgi_bi*MdL_2_Vdi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vgi_bi_Vsi_bi=(0.0/MdL_2-(0.0*MdL_2_Vsi_bi+0.0*MdL_2_Vgi_bi+1.0*MdL_2_Vgi_bi_Vsi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vgi_bi*MdL_2_Vsi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vgi_bi_Tempt_GND=(0.0/MdL_2-(0.0*MdL_2_Tempt_GND+0.0*MdL_2_Vgi_bi+1.0*MdL_2_Vgi_bi_Tempt_GND)/MdL_2/MdL_2+2*1.0*MdL_2_Vgi_bi*MdL_2_Tempt_GND/MdL_2/MdL_2/MdL_2);
#endif
inv_MdL_2_Vdi_bi=(-MdL_2_Vdi_bi/MdL_2/MdL_2);
#if defined(_DERIVATE2)
  inv_MdL_2_Vdi_bi_Vdbulk_di=(0.0/MdL_2-(0.0*MdL_2_Vdbulk_di+0.0*MdL_2_Vdi_bi+1.0*MdL_2_Vdi_bi_Vdbulk_di)/MdL_2/MdL_2+2*1.0*MdL_2_Vdi_bi*MdL_2_Vdbulk_di/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdi_bi_Vsbulk_si=(0.0/MdL_2-(0.0*MdL_2_Vsbulk_si+0.0*MdL_2_Vdi_bi+1.0*MdL_2_Vdi_bi_Vsbulk_si)/MdL_2/MdL_2+2*1.0*MdL_2_Vdi_bi*MdL_2_Vsbulk_si/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdi_bi_Vgi_bi=(0.0/MdL_2-(0.0*MdL_2_Vgi_bi+0.0*MdL_2_Vdi_bi+1.0*MdL_2_Vdi_bi_Vgi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vdi_bi*MdL_2_Vgi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdi_bi_Vdi_bi=(0.0/MdL_2-(0.0*MdL_2_Vdi_bi+0.0*MdL_2_Vdi_bi+1.0*MdL_2_Vdi_bi_Vdi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vdi_bi*MdL_2_Vdi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdi_bi_Vsi_bi=(0.0/MdL_2-(0.0*MdL_2_Vsi_bi+0.0*MdL_2_Vdi_bi+1.0*MdL_2_Vdi_bi_Vsi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vdi_bi*MdL_2_Vsi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vdi_bi_Tempt_GND=(0.0/MdL_2-(0.0*MdL_2_Tempt_GND+0.0*MdL_2_Vdi_bi+1.0*MdL_2_Vdi_bi_Tempt_GND)/MdL_2/MdL_2+2*1.0*MdL_2_Vdi_bi*MdL_2_Tempt_GND/MdL_2/MdL_2/MdL_2);
#endif
inv_MdL_2_Vsi_bi=(-MdL_2_Vsi_bi/MdL_2/MdL_2);
#if defined(_DERIVATE2)
  inv_MdL_2_Vsi_bi_Vdbulk_di=(0.0/MdL_2-(0.0*MdL_2_Vdbulk_di+0.0*MdL_2_Vsi_bi+1.0*MdL_2_Vsi_bi_Vdbulk_di)/MdL_2/MdL_2+2*1.0*MdL_2_Vsi_bi*MdL_2_Vdbulk_di/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsi_bi_Vsbulk_si=(0.0/MdL_2-(0.0*MdL_2_Vsbulk_si+0.0*MdL_2_Vsi_bi+1.0*MdL_2_Vsi_bi_Vsbulk_si)/MdL_2/MdL_2+2*1.0*MdL_2_Vsi_bi*MdL_2_Vsbulk_si/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsi_bi_Vgi_bi=(0.0/MdL_2-(0.0*MdL_2_Vgi_bi+0.0*MdL_2_Vsi_bi+1.0*MdL_2_Vsi_bi_Vgi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vsi_bi*MdL_2_Vgi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsi_bi_Vdi_bi=(0.0/MdL_2-(0.0*MdL_2_Vdi_bi+0.0*MdL_2_Vsi_bi+1.0*MdL_2_Vsi_bi_Vdi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vsi_bi*MdL_2_Vdi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsi_bi_Vsi_bi=(0.0/MdL_2-(0.0*MdL_2_Vsi_bi+0.0*MdL_2_Vsi_bi+1.0*MdL_2_Vsi_bi_Vsi_bi)/MdL_2/MdL_2+2*1.0*MdL_2_Vsi_bi*MdL_2_Vsi_bi/MdL_2/MdL_2/MdL_2);
  inv_MdL_2_Vsi_bi_Tempt_GND=(0.0/MdL_2-(0.0*MdL_2_Tempt_GND+0.0*MdL_2_Vsi_bi+1.0*MdL_2_Vsi_bi_Tempt_GND)/MdL_2/MdL_2+2*1.0*MdL_2_Vsi_bi*MdL_2_Tempt_GND/MdL_2/MdL_2/MdL_2);
#endif
#if defined(_DERIVATE)
inv_MdL_2_Tempt_GND=(-MdL_2_Tempt_GND/MdL_2/MdL_2);
#endif
#endif
inv_MdL_2=(1.0/MdL_2);
EXIT_IF_ISNAN((1.0/MdL_2))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
MdL_less_1_Vdbulk_di=MdL_Vdbulk_di;
#if defined(_DERIVATE2)
  MdL_less_1_Vdbulk_di_Vdbulk_di=(+MdL_Vdbulk_di_Vdbulk_di-0.0);
  MdL_less_1_Vdbulk_di_Vsbulk_si=(+MdL_Vdbulk_di_Vsbulk_si-0.0);
  MdL_less_1_Vdbulk_di_Vgi_bi=(+MdL_Vdbulk_di_Vgi_bi-0.0);
  MdL_less_1_Vdbulk_di_Vdi_bi=(+MdL_Vdbulk_di_Vdi_bi-0.0);
  MdL_less_1_Vdbulk_di_Vsi_bi=(+MdL_Vdbulk_di_Vsi_bi-0.0);
  MdL_less_1_Vdbulk_di_Tempt_GND=(+MdL_Vdbulk_di_Tempt_GND-0.0);
#endif
MdL_less_1_Vsbulk_si=MdL_Vsbulk_si;
#if defined(_DERIVATE2)
  MdL_less_1_Vsbulk_si_Vdbulk_di=(+MdL_Vsbulk_si_Vdbulk_di-0.0);
  MdL_less_1_Vsbulk_si_Vsbulk_si=(+MdL_Vsbulk_si_Vsbulk_si-0.0);
  MdL_less_1_Vsbulk_si_Vgi_bi=(+MdL_Vsbulk_si_Vgi_bi-0.0);
  MdL_less_1_Vsbulk_si_Vdi_bi=(+MdL_Vsbulk_si_Vdi_bi-0.0);
  MdL_less_1_Vsbulk_si_Vsi_bi=(+MdL_Vsbulk_si_Vsi_bi-0.0);
  MdL_less_1_Vsbulk_si_Tempt_GND=(+MdL_Vsbulk_si_Tempt_GND-0.0);
#endif
MdL_less_1_Vgi_bi=MdL_Vgi_bi;
#if defined(_DERIVATE2)
  MdL_less_1_Vgi_bi_Vdbulk_di=(+MdL_Vgi_bi_Vdbulk_di-0.0);
  MdL_less_1_Vgi_bi_Vsbulk_si=(+MdL_Vgi_bi_Vsbulk_si-0.0);
  MdL_less_1_Vgi_bi_Vgi_bi=(+MdL_Vgi_bi_Vgi_bi-0.0);
  MdL_less_1_Vgi_bi_Vdi_bi=(+MdL_Vgi_bi_Vdi_bi-0.0);
  MdL_less_1_Vgi_bi_Vsi_bi=(+MdL_Vgi_bi_Vsi_bi-0.0);
  MdL_less_1_Vgi_bi_Tempt_GND=(+MdL_Vgi_bi_Tempt_GND-0.0);
#endif
MdL_less_1_Vdi_bi=MdL_Vdi_bi;
#if defined(_DERIVATE2)
  MdL_less_1_Vdi_bi_Vdbulk_di=(+MdL_Vdi_bi_Vdbulk_di-0.0);
  MdL_less_1_Vdi_bi_Vsbulk_si=(+MdL_Vdi_bi_Vsbulk_si-0.0);
  MdL_less_1_Vdi_bi_Vgi_bi=(+MdL_Vdi_bi_Vgi_bi-0.0);
  MdL_less_1_Vdi_bi_Vdi_bi=(+MdL_Vdi_bi_Vdi_bi-0.0);
  MdL_less_1_Vdi_bi_Vsi_bi=(+MdL_Vdi_bi_Vsi_bi-0.0);
  MdL_less_1_Vdi_bi_Tempt_GND=(+MdL_Vdi_bi_Tempt_GND-0.0);
#endif
MdL_less_1_Vsi_bi=MdL_Vsi_bi;
#if defined(_DERIVATE2)
  MdL_less_1_Vsi_bi_Vdbulk_di=(+MdL_Vsi_bi_Vdbulk_di-0.0);
  MdL_less_1_Vsi_bi_Vsbulk_si=(+MdL_Vsi_bi_Vsbulk_si-0.0);
  MdL_less_1_Vsi_bi_Vgi_bi=(+MdL_Vsi_bi_Vgi_bi-0.0);
  MdL_less_1_Vsi_bi_Vdi_bi=(+MdL_Vsi_bi_Vdi_bi-0.0);
  MdL_less_1_Vsi_bi_Vsi_bi=(+MdL_Vsi_bi_Vsi_bi-0.0);
  MdL_less_1_Vsi_bi_Tempt_GND=(+MdL_Vsi_bi_Tempt_GND-0.0);
#endif
#if defined(_DERIVATE)
MdL_less_1_Tempt_GND=MdL_Tempt_GND;
#endif
#endif
MdL_less_1=(MdL-1.0);
EXIT_IF_ISNAN((MdL-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(dbulk,di)V(sbulk,si) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(gm,GND) */
vgpqm_Vgi_bi=(vgfbCV_Vgi_bi-psip_Vgi_bi);
#if defined(_DERIVATE2)
  vgpqm_Vgi_bi_Vgi_bi=(+vgfbCV_Vgi_bi_Vgi_bi-psip_Vgi_bi_Vgi_bi);
  vgpqm_Vgi_bi_Vdi_bi=(+vgfbCV_Vgi_bi_Vdi_bi-psip_Vgi_bi_Vdi_bi);
  vgpqm_Vgi_bi_Vsi_bi=(+vgfbCV_Vgi_bi_Vsi_bi-psip_Vgi_bi_Vsi_bi);
  vgpqm_Vgi_bi_Tempt_GND=(+vgfbCV_Vgi_bi_Tempt_GND-psip_Vgi_bi_Tempt_GND);
  vgpqm_Vgi_bi_Vdbulk_di=(+0.0-psip_Vgi_bi_Vdbulk_di);
  vgpqm_Vgi_bi_Vsbulk_si=(+0.0-psip_Vgi_bi_Vsbulk_si);
#endif
vgpqm_Vdi_bi=(vgfbCV_Vdi_bi-psip_Vdi_bi);
#if defined(_DERIVATE2)
  vgpqm_Vdi_bi_Vgi_bi=(+vgfbCV_Vdi_bi_Vgi_bi-psip_Vdi_bi_Vgi_bi);
  vgpqm_Vdi_bi_Vdi_bi=(+vgfbCV_Vdi_bi_Vdi_bi-psip_Vdi_bi_Vdi_bi);
  vgpqm_Vdi_bi_Vsi_bi=(+vgfbCV_Vdi_bi_Vsi_bi-psip_Vdi_bi_Vsi_bi);
  vgpqm_Vdi_bi_Tempt_GND=(+vgfbCV_Vdi_bi_Tempt_GND-psip_Vdi_bi_Tempt_GND);
  vgpqm_Vdi_bi_Vdbulk_di=(+0.0-psip_Vdi_bi_Vdbulk_di);
  vgpqm_Vdi_bi_Vsbulk_si=(+0.0-psip_Vdi_bi_Vsbulk_si);
#endif
vgpqm_Vsi_bi=(vgfbCV_Vsi_bi-psip_Vsi_bi);
#if defined(_DERIVATE2)
  vgpqm_Vsi_bi_Vgi_bi=(+vgfbCV_Vsi_bi_Vgi_bi-psip_Vsi_bi_Vgi_bi);
  vgpqm_Vsi_bi_Vdi_bi=(+vgfbCV_Vsi_bi_Vdi_bi-psip_Vsi_bi_Vdi_bi);
  vgpqm_Vsi_bi_Vsi_bi=(+vgfbCV_Vsi_bi_Vsi_bi-psip_Vsi_bi_Vsi_bi);
  vgpqm_Vsi_bi_Tempt_GND=(+vgfbCV_Vsi_bi_Tempt_GND-psip_Vsi_bi_Tempt_GND);
  vgpqm_Vsi_bi_Vdbulk_di=(+0.0-psip_Vsi_bi_Vdbulk_di);
  vgpqm_Vsi_bi_Vsbulk_si=(+0.0-psip_Vsi_bi_Vsbulk_si);
#endif
#if defined(_DERIVATE)
vgpqm_Tempt_GND=(vgfbCV_Tempt_GND-psip_Tempt_GND);
#endif
vgpqm_Vdbulk_di=(-psip_Vdbulk_di);
#if defined(_DERIVATE2)
  vgpqm_Vdbulk_di_Vgi_bi=(+0.0-psip_Vdbulk_di_Vgi_bi);
  vgpqm_Vdbulk_di_Vdi_bi=(+0.0-psip_Vdbulk_di_Vdi_bi);
  vgpqm_Vdbulk_di_Vsi_bi=(+0.0-psip_Vdbulk_di_Vsi_bi);
  vgpqm_Vdbulk_di_Tempt_GND=(+0.0-psip_Vdbulk_di_Tempt_GND);
  vgpqm_Vdbulk_di_Vdbulk_di=(+0.0-psip_Vdbulk_di_Vdbulk_di);
  vgpqm_Vdbulk_di_Vsbulk_si=(+0.0-psip_Vdbulk_di_Vsbulk_si);
#endif
vgpqm_Vsbulk_si=(-psip_Vsbulk_si);
#if defined(_DERIVATE2)
  vgpqm_Vsbulk_si_Vgi_bi=(+0.0-psip_Vsbulk_si_Vgi_bi);
  vgpqm_Vsbulk_si_Vdi_bi=(+0.0-psip_Vsbulk_si_Vdi_bi);
  vgpqm_Vsbulk_si_Vsi_bi=(+0.0-psip_Vsbulk_si_Vsi_bi);
  vgpqm_Vsbulk_si_Tempt_GND=(+0.0-psip_Vsbulk_si_Tempt_GND);
  vgpqm_Vsbulk_si_Vdbulk_di=(+0.0-psip_Vsbulk_si_Vdbulk_di);
  vgpqm_Vsbulk_si_Vsbulk_si=(+0.0-psip_Vsbulk_si_Vsbulk_si);
#endif
#endif
vgpqm=(vgfbCV-psip);
EXIT_IF_ISNAN((vgfbCV-psip))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
DQSD_Vdbulk_di=(qs_Vdbulk_di-qdeff_Vdbulk_di);
#if defined(_DERIVATE2)
  DQSD_Vdbulk_di_Vdbulk_di=(+qs_Vdbulk_di_Vdbulk_di-qdeff_Vdbulk_di_Vdbulk_di);
  DQSD_Vdbulk_di_Vsbulk_si=(+qs_Vdbulk_di_Vsbulk_si-qdeff_Vdbulk_di_Vsbulk_si);
  DQSD_Vdbulk_di_Vgi_bi=(+qs_Vdbulk_di_Vgi_bi-qdeff_Vdbulk_di_Vgi_bi);
  DQSD_Vdbulk_di_Vdi_bi=(+qs_Vdbulk_di_Vdi_bi-qdeff_Vdbulk_di_Vdi_bi);
  DQSD_Vdbulk_di_Vsi_bi=(+qs_Vdbulk_di_Vsi_bi-qdeff_Vdbulk_di_Vsi_bi);
  DQSD_Vdbulk_di_Tempt_GND=(+qs_Vdbulk_di_Tempt_GND-qdeff_Vdbulk_di_Tempt_GND);
#endif
DQSD_Vsbulk_si=(qs_Vsbulk_si-qdeff_Vsbulk_si);
#if defined(_DERIVATE2)
  DQSD_Vsbulk_si_Vdbulk_di=(+qs_Vsbulk_si_Vdbulk_di-qdeff_Vsbulk_si_Vdbulk_di);
  DQSD_Vsbulk_si_Vsbulk_si=(+qs_Vsbulk_si_Vsbulk_si-qdeff_Vsbulk_si_Vsbulk_si);
  DQSD_Vsbulk_si_Vgi_bi=(+qs_Vsbulk_si_Vgi_bi-qdeff_Vsbulk_si_Vgi_bi);
  DQSD_Vsbulk_si_Vdi_bi=(+qs_Vsbulk_si_Vdi_bi-qdeff_Vsbulk_si_Vdi_bi);
  DQSD_Vsbulk_si_Vsi_bi=(+qs_Vsbulk_si_Vsi_bi-qdeff_Vsbulk_si_Vsi_bi);
  DQSD_Vsbulk_si_Tempt_GND=(+qs_Vsbulk_si_Tempt_GND-qdeff_Vsbulk_si_Tempt_GND);
#endif
DQSD_Vgi_bi=(qs_Vgi_bi-qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  DQSD_Vgi_bi_Vdbulk_di=(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di);
  DQSD_Vgi_bi_Vsbulk_si=(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si);
  DQSD_Vgi_bi_Vgi_bi=(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi);
  DQSD_Vgi_bi_Vdi_bi=(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi);
  DQSD_Vgi_bi_Vsi_bi=(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi);
  DQSD_Vgi_bi_Tempt_GND=(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND);
#endif
DQSD_Vdi_bi=(qs_Vdi_bi-qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  DQSD_Vdi_bi_Vdbulk_di=(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di);
  DQSD_Vdi_bi_Vsbulk_si=(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si);
  DQSD_Vdi_bi_Vgi_bi=(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi);
  DQSD_Vdi_bi_Vdi_bi=(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi);
  DQSD_Vdi_bi_Vsi_bi=(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi);
  DQSD_Vdi_bi_Tempt_GND=(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND);
#endif
DQSD_Vsi_bi=(qs_Vsi_bi-qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  DQSD_Vsi_bi_Vdbulk_di=(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di);
  DQSD_Vsi_bi_Vsbulk_si=(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si);
  DQSD_Vsi_bi_Vgi_bi=(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi);
  DQSD_Vsi_bi_Vdi_bi=(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi);
  DQSD_Vsi_bi_Vsi_bi=(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi);
  DQSD_Vsi_bi_Tempt_GND=(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
DQSD_Tempt_GND=(qs_Tempt_GND-qdeff_Tempt_GND);
#endif
#endif
DQSD=(qs-qdeff);
EXIT_IF_ISNAN((qs-qdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
DQSD2_Vdbulk_di=(((qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs-qdeff))+((qs-qdeff)*(qs_Vdbulk_di-qdeff_Vdbulk_di)));
#if defined(_DERIVATE2)
  DQSD2_Vdbulk_di_Vdbulk_di=(+(+qs_Vdbulk_di_Vdbulk_di-qdeff_Vdbulk_di_Vdbulk_di)*(qs-qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs-qdeff)*(+qs_Vdbulk_di_Vdbulk_di-qdeff_Vdbulk_di_Vdbulk_di));
  DQSD2_Vdbulk_di_Vsbulk_si=(+(+qs_Vdbulk_di_Vsbulk_si-qdeff_Vdbulk_di_Vsbulk_si)*(qs-qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs-qdeff)*(+qs_Vdbulk_di_Vsbulk_si-qdeff_Vdbulk_di_Vsbulk_si));
  DQSD2_Vdbulk_di_Vgi_bi=(+(+qs_Vdbulk_di_Vgi_bi-qdeff_Vdbulk_di_Vgi_bi)*(qs-qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs-qdeff)*(+qs_Vdbulk_di_Vgi_bi-qdeff_Vdbulk_di_Vgi_bi));
  DQSD2_Vdbulk_di_Vdi_bi=(+(+qs_Vdbulk_di_Vdi_bi-qdeff_Vdbulk_di_Vdi_bi)*(qs-qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs-qdeff)*(+qs_Vdbulk_di_Vdi_bi-qdeff_Vdbulk_di_Vdi_bi));
  DQSD2_Vdbulk_di_Vsi_bi=(+(+qs_Vdbulk_di_Vsi_bi-qdeff_Vdbulk_di_Vsi_bi)*(qs-qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs-qdeff)*(+qs_Vdbulk_di_Vsi_bi-qdeff_Vdbulk_di_Vsi_bi));
  DQSD2_Vdbulk_di_Tempt_GND=(+(+qs_Vdbulk_di_Tempt_GND-qdeff_Vdbulk_di_Tempt_GND)*(qs-qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Tempt_GND-qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs-qdeff)*(+qs_Vdbulk_di_Tempt_GND-qdeff_Vdbulk_di_Tempt_GND));
#endif
DQSD2_Vsbulk_si=(((qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs-qdeff))+((qs-qdeff)*(qs_Vsbulk_si-qdeff_Vsbulk_si)));
#if defined(_DERIVATE2)
  DQSD2_Vsbulk_si_Vdbulk_di=(+(+qs_Vsbulk_si_Vdbulk_di-qdeff_Vsbulk_si_Vdbulk_di)*(qs-qdeff)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs-qdeff)*(+qs_Vsbulk_si_Vdbulk_di-qdeff_Vsbulk_si_Vdbulk_di));
  DQSD2_Vsbulk_si_Vsbulk_si=(+(+qs_Vsbulk_si_Vsbulk_si-qdeff_Vsbulk_si_Vsbulk_si)*(qs-qdeff)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs-qdeff)*(+qs_Vsbulk_si_Vsbulk_si-qdeff_Vsbulk_si_Vsbulk_si));
  DQSD2_Vsbulk_si_Vgi_bi=(+(+qs_Vsbulk_si_Vgi_bi-qdeff_Vsbulk_si_Vgi_bi)*(qs-qdeff)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs-qdeff)*(+qs_Vsbulk_si_Vgi_bi-qdeff_Vsbulk_si_Vgi_bi));
  DQSD2_Vsbulk_si_Vdi_bi=(+(+qs_Vsbulk_si_Vdi_bi-qdeff_Vsbulk_si_Vdi_bi)*(qs-qdeff)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs-qdeff)*(+qs_Vsbulk_si_Vdi_bi-qdeff_Vsbulk_si_Vdi_bi));
  DQSD2_Vsbulk_si_Vsi_bi=(+(+qs_Vsbulk_si_Vsi_bi-qdeff_Vsbulk_si_Vsi_bi)*(qs-qdeff)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs-qdeff)*(+qs_Vsbulk_si_Vsi_bi-qdeff_Vsbulk_si_Vsi_bi));
  DQSD2_Vsbulk_si_Tempt_GND=(+(+qs_Vsbulk_si_Tempt_GND-qdeff_Vsbulk_si_Tempt_GND)*(qs-qdeff)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Tempt_GND-qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs-qdeff)*(+qs_Vsbulk_si_Tempt_GND-qdeff_Vsbulk_si_Tempt_GND));
#endif
DQSD2_Vgi_bi=(((qs_Vgi_bi-qdeff_Vgi_bi)*(qs-qdeff))+((qs-qdeff)*(qs_Vgi_bi-qdeff_Vgi_bi)));
#if defined(_DERIVATE2)
  DQSD2_Vgi_bi_Vdbulk_di=(+(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di));
  DQSD2_Vgi_bi_Vsbulk_si=(+(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si));
  DQSD2_Vgi_bi_Vgi_bi=(+(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi));
  DQSD2_Vgi_bi_Vdi_bi=(+(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi));
  DQSD2_Vgi_bi_Vsi_bi=(+(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi));
  DQSD2_Vgi_bi_Tempt_GND=(+(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND)*(qs-qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Tempt_GND-qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs-qdeff)*(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND));
#endif
DQSD2_Vdi_bi=(((qs_Vdi_bi-qdeff_Vdi_bi)*(qs-qdeff))+((qs-qdeff)*(qs_Vdi_bi-qdeff_Vdi_bi)));
#if defined(_DERIVATE2)
  DQSD2_Vdi_bi_Vdbulk_di=(+(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di));
  DQSD2_Vdi_bi_Vsbulk_si=(+(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si));
  DQSD2_Vdi_bi_Vgi_bi=(+(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi));
  DQSD2_Vdi_bi_Vdi_bi=(+(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi));
  DQSD2_Vdi_bi_Vsi_bi=(+(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi));
  DQSD2_Vdi_bi_Tempt_GND=(+(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND)*(qs-qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Tempt_GND-qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs-qdeff)*(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND));
#endif
DQSD2_Vsi_bi=(((qs_Vsi_bi-qdeff_Vsi_bi)*(qs-qdeff))+((qs-qdeff)*(qs_Vsi_bi-qdeff_Vsi_bi)));
#if defined(_DERIVATE2)
  DQSD2_Vsi_bi_Vdbulk_di=(+(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdbulk_di-qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di));
  DQSD2_Vsi_bi_Vsbulk_si=(+(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsbulk_si-qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si));
  DQSD2_Vsi_bi_Vgi_bi=(+(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgi_bi-qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi));
  DQSD2_Vsi_bi_Vdi_bi=(+(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdi_bi-qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi));
  DQSD2_Vsi_bi_Vsi_bi=(+(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi));
  DQSD2_Vsi_bi_Tempt_GND=(+(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND)*(qs-qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Tempt_GND-qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vsi_bi-qdeff_Vsi_bi)+(qs-qdeff)*(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
DQSD2_Tempt_GND=(((qs_Tempt_GND-qdeff_Tempt_GND)*(qs-qdeff))+((qs-qdeff)*(qs_Tempt_GND-qdeff_Tempt_GND)));
#endif
#endif
DQSD2=((qs-qdeff)*(qs-qdeff));
EXIT_IF_ISNAN(((qs-qdeff)*(qs-qdeff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(dbulk,di)V(sbulk,si) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND) */
sis_Vgi_bi=(vgpqm_Vgi_bi+(2.0*qs_Vgi_bi));
#if defined(_DERIVATE2)
  sis_Vgi_bi_Vgi_bi=(+vgpqm_Vgi_bi_Vgi_bi+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vgi_bi));
  sis_Vgi_bi_Vdi_bi=(+vgpqm_Vgi_bi_Vdi_bi+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdi_bi));
  sis_Vgi_bi_Vsi_bi=(+vgpqm_Vgi_bi_Vsi_bi+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsi_bi));
  sis_Vgi_bi_Tempt_GND=(+vgpqm_Vgi_bi_Tempt_GND+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Tempt_GND));
  sis_Vgi_bi_Vdbulk_di=(+vgpqm_Vgi_bi_Vdbulk_di+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vdbulk_di));
  sis_Vgi_bi_Vsbulk_si=(+vgpqm_Vgi_bi_Vsbulk_si+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vgi_bi+2.0*qs_Vgi_bi_Vsbulk_si));
#endif
sis_Vdi_bi=(vgpqm_Vdi_bi+(2.0*qs_Vdi_bi));
#if defined(_DERIVATE2)
  sis_Vdi_bi_Vgi_bi=(+vgpqm_Vdi_bi_Vgi_bi+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vgi_bi));
  sis_Vdi_bi_Vdi_bi=(+vgpqm_Vdi_bi_Vdi_bi+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdi_bi));
  sis_Vdi_bi_Vsi_bi=(+vgpqm_Vdi_bi_Vsi_bi+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsi_bi));
  sis_Vdi_bi_Tempt_GND=(+vgpqm_Vdi_bi_Tempt_GND+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Tempt_GND));
  sis_Vdi_bi_Vdbulk_di=(+vgpqm_Vdi_bi_Vdbulk_di+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vdbulk_di));
  sis_Vdi_bi_Vsbulk_si=(+vgpqm_Vdi_bi_Vsbulk_si+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdi_bi+2.0*qs_Vdi_bi_Vsbulk_si));
#endif
sis_Vsi_bi=(vgpqm_Vsi_bi+(2.0*qs_Vsi_bi));
#if defined(_DERIVATE2)
  sis_Vsi_bi_Vgi_bi=(+vgpqm_Vsi_bi_Vgi_bi+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vgi_bi));
  sis_Vsi_bi_Vdi_bi=(+vgpqm_Vsi_bi_Vdi_bi+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdi_bi));
  sis_Vsi_bi_Vsi_bi=(+vgpqm_Vsi_bi_Vsi_bi+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsi_bi));
  sis_Vsi_bi_Tempt_GND=(+vgpqm_Vsi_bi_Tempt_GND+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Tempt_GND));
  sis_Vsi_bi_Vdbulk_di=(+vgpqm_Vsi_bi_Vdbulk_di+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vdbulk_di));
  sis_Vsi_bi_Vsbulk_si=(+vgpqm_Vsi_bi_Vsbulk_si+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsi_bi+2.0*qs_Vsi_bi_Vsbulk_si));
#endif
#if defined(_DERIVATE)
sis_Tempt_GND=(vgpqm_Tempt_GND+(2.0*qs_Tempt_GND));
#endif
sis_Vdbulk_di=(vgpqm_Vdbulk_di+(2.0*qs_Vdbulk_di));
#if defined(_DERIVATE2)
  sis_Vdbulk_di_Vgi_bi=(+vgpqm_Vdbulk_di_Vgi_bi+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vgi_bi));
  sis_Vdbulk_di_Vdi_bi=(+vgpqm_Vdbulk_di_Vdi_bi+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vdi_bi));
  sis_Vdbulk_di_Vsi_bi=(+vgpqm_Vdbulk_di_Vsi_bi+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vsi_bi));
  sis_Vdbulk_di_Tempt_GND=(+vgpqm_Vdbulk_di_Tempt_GND+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Tempt_GND));
  sis_Vdbulk_di_Vdbulk_di=(+vgpqm_Vdbulk_di_Vdbulk_di+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vdbulk_di));
  sis_Vdbulk_di_Vsbulk_si=(+vgpqm_Vdbulk_di_Vsbulk_si+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vdbulk_di+2.0*qs_Vdbulk_di_Vsbulk_si));
#endif
sis_Vsbulk_si=(vgpqm_Vsbulk_si+(2.0*qs_Vsbulk_si));
#if defined(_DERIVATE2)
  sis_Vsbulk_si_Vgi_bi=(+vgpqm_Vsbulk_si_Vgi_bi+(+0.0*qs+0.0*qs_Vgi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vgi_bi));
  sis_Vsbulk_si_Vdi_bi=(+vgpqm_Vsbulk_si_Vdi_bi+(+0.0*qs+0.0*qs_Vdi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vdi_bi));
  sis_Vsbulk_si_Vsi_bi=(+vgpqm_Vsbulk_si_Vsi_bi+(+0.0*qs+0.0*qs_Vsi_bi+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vsi_bi));
  sis_Vsbulk_si_Tempt_GND=(+vgpqm_Vsbulk_si_Tempt_GND+(+0.0*qs+0.0*qs_Tempt_GND+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Tempt_GND));
  sis_Vsbulk_si_Vdbulk_di=(+vgpqm_Vsbulk_si_Vdbulk_di+(+0.0*qs+0.0*qs_Vdbulk_di+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vdbulk_di));
  sis_Vsbulk_si_Vsbulk_si=(+vgpqm_Vsbulk_si_Vsbulk_si+(+0.0*qs+0.0*qs_Vsbulk_si+0.0*qs_Vsbulk_si+2.0*qs_Vsbulk_si_Vsbulk_si));
#endif
#endif
sis=(vgpqm+(2.0*qs));
EXIT_IF_ISNAN((vgpqm+(2.0*qs)))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(dbulk,di)V(sbulk,si) ddxprobe=V(gm,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND)V(dbulk,GND)V(sbulk,GND) */
sid_Vgi_bi=(vgpqm_Vgi_bi+(2.0*qdeff_Vgi_bi));
#if defined(_DERIVATE2)
  sid_Vgi_bi_Vgi_bi=(+vgpqm_Vgi_bi_Vgi_bi+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vgi_bi));
  sid_Vgi_bi_Vdi_bi=(+vgpqm_Vgi_bi_Vdi_bi+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vdi_bi));
  sid_Vgi_bi_Vsi_bi=(+vgpqm_Vgi_bi_Vsi_bi+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vsi_bi));
  sid_Vgi_bi_Tempt_GND=(+vgpqm_Vgi_bi_Tempt_GND+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Tempt_GND));
  sid_Vgi_bi_Vdbulk_di=(+vgpqm_Vgi_bi_Vdbulk_di+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vdbulk_di));
  sid_Vgi_bi_Vsbulk_si=(+vgpqm_Vgi_bi_Vsbulk_si+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vgi_bi+2.0*qdeff_Vgi_bi_Vsbulk_si));
#endif
sid_Vdi_bi=(vgpqm_Vdi_bi+(2.0*qdeff_Vdi_bi));
#if defined(_DERIVATE2)
  sid_Vdi_bi_Vgi_bi=(+vgpqm_Vdi_bi_Vgi_bi+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vgi_bi));
  sid_Vdi_bi_Vdi_bi=(+vgpqm_Vdi_bi_Vdi_bi+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vdi_bi));
  sid_Vdi_bi_Vsi_bi=(+vgpqm_Vdi_bi_Vsi_bi+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vsi_bi));
  sid_Vdi_bi_Tempt_GND=(+vgpqm_Vdi_bi_Tempt_GND+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Tempt_GND));
  sid_Vdi_bi_Vdbulk_di=(+vgpqm_Vdi_bi_Vdbulk_di+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vdbulk_di));
  sid_Vdi_bi_Vsbulk_si=(+vgpqm_Vdi_bi_Vsbulk_si+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vdi_bi+2.0*qdeff_Vdi_bi_Vsbulk_si));
#endif
sid_Vsi_bi=(vgpqm_Vsi_bi+(2.0*qdeff_Vsi_bi));
#if defined(_DERIVATE2)
  sid_Vsi_bi_Vgi_bi=(+vgpqm_Vsi_bi_Vgi_bi+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vgi_bi));
  sid_Vsi_bi_Vdi_bi=(+vgpqm_Vsi_bi_Vdi_bi+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vdi_bi));
  sid_Vsi_bi_Vsi_bi=(+vgpqm_Vsi_bi_Vsi_bi+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vsi_bi));
  sid_Vsi_bi_Tempt_GND=(+vgpqm_Vsi_bi_Tempt_GND+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Tempt_GND));
  sid_Vsi_bi_Vdbulk_di=(+vgpqm_Vsi_bi_Vdbulk_di+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vdbulk_di));
  sid_Vsi_bi_Vsbulk_si=(+vgpqm_Vsi_bi_Vsbulk_si+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vsi_bi+2.0*qdeff_Vsi_bi_Vsbulk_si));
#endif
#if defined(_DERIVATE)
sid_Tempt_GND=(vgpqm_Tempt_GND+(2.0*qdeff_Tempt_GND));
#endif
sid_Vdbulk_di=(vgpqm_Vdbulk_di+(2.0*qdeff_Vdbulk_di));
#if defined(_DERIVATE2)
  sid_Vdbulk_di_Vgi_bi=(+vgpqm_Vdbulk_di_Vgi_bi+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vgi_bi));
  sid_Vdbulk_di_Vdi_bi=(+vgpqm_Vdbulk_di_Vdi_bi+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vdi_bi));
  sid_Vdbulk_di_Vsi_bi=(+vgpqm_Vdbulk_di_Vsi_bi+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vsi_bi));
  sid_Vdbulk_di_Tempt_GND=(+vgpqm_Vdbulk_di_Tempt_GND+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Tempt_GND));
  sid_Vdbulk_di_Vdbulk_di=(+vgpqm_Vdbulk_di_Vdbulk_di+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vdbulk_di));
  sid_Vdbulk_di_Vsbulk_si=(+vgpqm_Vdbulk_di_Vsbulk_si+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vdbulk_di+2.0*qdeff_Vdbulk_di_Vsbulk_si));
#endif
sid_Vsbulk_si=(vgpqm_Vsbulk_si+(2.0*qdeff_Vsbulk_si));
#if defined(_DERIVATE2)
  sid_Vsbulk_si_Vgi_bi=(+vgpqm_Vsbulk_si_Vgi_bi+(+0.0*qdeff+0.0*qdeff_Vgi_bi+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vgi_bi));
  sid_Vsbulk_si_Vdi_bi=(+vgpqm_Vsbulk_si_Vdi_bi+(+0.0*qdeff+0.0*qdeff_Vdi_bi+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vdi_bi));
  sid_Vsbulk_si_Vsi_bi=(+vgpqm_Vsbulk_si_Vsi_bi+(+0.0*qdeff+0.0*qdeff_Vsi_bi+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vsi_bi));
  sid_Vsbulk_si_Tempt_GND=(+vgpqm_Vsbulk_si_Tempt_GND+(+0.0*qdeff+0.0*qdeff_Tempt_GND+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Tempt_GND));
  sid_Vsbulk_si_Vdbulk_di=(+vgpqm_Vsbulk_si_Vdbulk_di+(+0.0*qdeff+0.0*qdeff_Vdbulk_di+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vdbulk_di));
  sid_Vsbulk_si_Vsbulk_si=(+vgpqm_Vsbulk_si_Vsbulk_si+(+0.0*qdeff+0.0*qdeff_Vsbulk_si+0.0*qdeff_Vsbulk_si+2.0*qdeff_Vsbulk_si_Vsbulk_si));
#endif
#endif
sid=(vgpqm+(2.0*qdeff));
EXIT_IF_ISNAN((vgpqm+(2.0*qdeff)))
{
double m00_sqrt(d00_sqrt0,((sis*sis)+((0.25*0.5)*0.5)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((sis*sis)+((0.25*0.5)*0.5)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(0.5*(sis_Vdbulk_di+((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vdbulk_di+((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vdbulk_di*0.0+0.0*sis_Vdbulk_di+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdbulk_di_Vgm_si=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vdbulk_di+((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vdbulk_di*0.0+0.0*sis_Vdbulk_di+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdbulk_di_Vdbulk_di=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdbulk_di+((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdbulk_di+((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sis_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))+d10_sqrt0*(+(+(+sis_Vdbulk_di_Vdbulk_di-0.0)*sis+sis_Vdbulk_di*sis_Vdbulk_di+sis_Vdbulk_di*sis_Vdbulk_di+sis*(+sis_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdbulk_di_Vsbulk_si=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsbulk_si+((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdbulk_di+((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sis_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))+d10_sqrt0*(+(+(+sis_Vdbulk_di_Vsbulk_si-0.0)*sis+sis_Vdbulk_di*sis_Vsbulk_si+sis_Vsbulk_si*sis_Vdbulk_di+sis*(+sis_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdbulk_di_Vgi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vgi_bi+((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdbulk_di+((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sis_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))+d10_sqrt0*(+(+(+sis_Vdbulk_di_Vgi_bi-0.0)*sis+sis_Vdbulk_di*sis_Vgi_bi+sis_Vgi_bi*sis_Vdbulk_di+sis*(+sis_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdbulk_di_Vdi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdi_bi+((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdbulk_di+((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sis_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))+d10_sqrt0*(+(+(+sis_Vdbulk_di_Vdi_bi-0.0)*sis+sis_Vdbulk_di*sis_Vdi_bi+sis_Vdi_bi*sis_Vdbulk_di+sis*(+sis_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdbulk_di_Vsi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsi_bi+((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdbulk_di+((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sis_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))+d10_sqrt0*(+(+(+sis_Vdbulk_di_Vsi_bi-0.0)*sis+sis_Vdbulk_di*sis_Vsi_bi+sis_Vsi_bi*sis_Vdbulk_di+sis*(+sis_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdbulk_di_Tempt_GND=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Tempt_GND+((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdbulk_di+((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sis_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di))+d10_sqrt0*(+(+(+sis_Vdbulk_di_Tempt_GND-0.0)*sis+sis_Vdbulk_di*sis_Tempt_GND+sis_Tempt_GND*sis_Vdbulk_di+sis*(+sis_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
T1_Vsbulk_si=(0.5*(sis_Vsbulk_si+((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vsbulk_si+((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vsbulk_si*0.0+0.0*sis_Vsbulk_si+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsbulk_si_Vgm_si=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vsbulk_si+((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vsbulk_si*0.0+0.0*sis_Vsbulk_si+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsbulk_si_Vdbulk_di=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdbulk_di+((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsbulk_si+((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sis_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))+d10_sqrt0*(+(+(+sis_Vsbulk_si_Vdbulk_di-0.0)*sis+sis_Vsbulk_si*sis_Vdbulk_di+sis_Vdbulk_di*sis_Vsbulk_si+sis*(+sis_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsbulk_si_Vsbulk_si=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsbulk_si+((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsbulk_si+((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sis_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))+d10_sqrt0*(+(+(+sis_Vsbulk_si_Vsbulk_si-0.0)*sis+sis_Vsbulk_si*sis_Vsbulk_si+sis_Vsbulk_si*sis_Vsbulk_si+sis*(+sis_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsbulk_si_Vgi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vgi_bi+((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsbulk_si+((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sis_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))+d10_sqrt0*(+(+(+sis_Vsbulk_si_Vgi_bi-0.0)*sis+sis_Vsbulk_si*sis_Vgi_bi+sis_Vgi_bi*sis_Vsbulk_si+sis*(+sis_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsbulk_si_Vdi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdi_bi+((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsbulk_si+((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sis_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))+d10_sqrt0*(+(+(+sis_Vsbulk_si_Vdi_bi-0.0)*sis+sis_Vsbulk_si*sis_Vdi_bi+sis_Vdi_bi*sis_Vsbulk_si+sis*(+sis_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsbulk_si_Vsi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsi_bi+((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsbulk_si+((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sis_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))+d10_sqrt0*(+(+(+sis_Vsbulk_si_Vsi_bi-0.0)*sis+sis_Vsbulk_si*sis_Vsi_bi+sis_Vsi_bi*sis_Vsbulk_si+sis*(+sis_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsbulk_si_Tempt_GND=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Tempt_GND+((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsbulk_si+((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sis_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si))+d10_sqrt0*(+(+(+sis_Vsbulk_si_Tempt_GND-0.0)*sis+sis_Vsbulk_si*sis_Tempt_GND+sis_Tempt_GND*sis_Vsbulk_si+sis*(+sis_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
T1_Vgi_bi=(0.5*(sis_Vgi_bi+((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vgi_bi+((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vgi_bi*0.0+0.0*sis_Vgi_bi+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vgi_bi_Vgm_si=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vgi_bi+((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vgi_bi*0.0+0.0*sis_Vgi_bi+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vgi_bi_Vdbulk_di=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdbulk_di+((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vgi_bi+((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))*d10_sqrt0)+0.5*(+(+sis_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))+d10_sqrt0*(+(+(+sis_Vgi_bi_Vdbulk_di-0.0)*sis+sis_Vgi_bi*sis_Vdbulk_di+sis_Vdbulk_di*sis_Vgi_bi+sis*(+sis_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vgi_bi_Vsbulk_si=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsbulk_si+((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vgi_bi+((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))*d10_sqrt0)+0.5*(+(+sis_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))+d10_sqrt0*(+(+(+sis_Vgi_bi_Vsbulk_si-0.0)*sis+sis_Vgi_bi*sis_Vsbulk_si+sis_Vsbulk_si*sis_Vgi_bi+sis*(+sis_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vgi_bi_Vgi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vgi_bi+((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vgi_bi+((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))*d10_sqrt0)+0.5*(+(+sis_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))+d10_sqrt0*(+(+(+sis_Vgi_bi_Vgi_bi-0.0)*sis+sis_Vgi_bi*sis_Vgi_bi+sis_Vgi_bi*sis_Vgi_bi+sis*(+sis_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vgi_bi_Vdi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdi_bi+((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vgi_bi+((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))*d10_sqrt0)+0.5*(+(+sis_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))+d10_sqrt0*(+(+(+sis_Vgi_bi_Vdi_bi-0.0)*sis+sis_Vgi_bi*sis_Vdi_bi+sis_Vdi_bi*sis_Vgi_bi+sis*(+sis_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vgi_bi_Vsi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsi_bi+((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vgi_bi+((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))*d10_sqrt0)+0.5*(+(+sis_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))+d10_sqrt0*(+(+(+sis_Vgi_bi_Vsi_bi-0.0)*sis+sis_Vgi_bi*sis_Vsi_bi+sis_Vsi_bi*sis_Vgi_bi+sis*(+sis_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vgi_bi_Tempt_GND=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Tempt_GND+((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vgi_bi+((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))*d10_sqrt0)+0.5*(+(+sis_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi))+d10_sqrt0*(+(+(+sis_Vgi_bi_Tempt_GND-0.0)*sis+sis_Vgi_bi*sis_Tempt_GND+sis_Tempt_GND*sis_Vgi_bi+sis*(+sis_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
T1_Vdi_bi=(0.5*(sis_Vdi_bi+((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vdi_bi+((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vdi_bi*0.0+0.0*sis_Vdi_bi+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdi_bi_Vgm_si=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vdi_bi+((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vdi_bi*0.0+0.0*sis_Vdi_bi+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdi_bi_Vdbulk_di=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdbulk_di+((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdi_bi+((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))*d10_sqrt0)+0.5*(+(+sis_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))+d10_sqrt0*(+(+(+sis_Vdi_bi_Vdbulk_di-0.0)*sis+sis_Vdi_bi*sis_Vdbulk_di+sis_Vdbulk_di*sis_Vdi_bi+sis*(+sis_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdi_bi_Vsbulk_si=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsbulk_si+((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdi_bi+((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))*d10_sqrt0)+0.5*(+(+sis_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))+d10_sqrt0*(+(+(+sis_Vdi_bi_Vsbulk_si-0.0)*sis+sis_Vdi_bi*sis_Vsbulk_si+sis_Vsbulk_si*sis_Vdi_bi+sis*(+sis_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdi_bi_Vgi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vgi_bi+((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdi_bi+((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))*d10_sqrt0)+0.5*(+(+sis_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))+d10_sqrt0*(+(+(+sis_Vdi_bi_Vgi_bi-0.0)*sis+sis_Vdi_bi*sis_Vgi_bi+sis_Vgi_bi*sis_Vdi_bi+sis*(+sis_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdi_bi_Vdi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdi_bi+((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdi_bi+((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))*d10_sqrt0)+0.5*(+(+sis_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))+d10_sqrt0*(+(+(+sis_Vdi_bi_Vdi_bi-0.0)*sis+sis_Vdi_bi*sis_Vdi_bi+sis_Vdi_bi*sis_Vdi_bi+sis*(+sis_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdi_bi_Vsi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsi_bi+((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdi_bi+((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))*d10_sqrt0)+0.5*(+(+sis_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))+d10_sqrt0*(+(+(+sis_Vdi_bi_Vsi_bi-0.0)*sis+sis_Vdi_bi*sis_Vsi_bi+sis_Vsi_bi*sis_Vdi_bi+sis*(+sis_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vdi_bi_Tempt_GND=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Tempt_GND+((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vdi_bi+((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))*d10_sqrt0)+0.5*(+(+sis_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi))+d10_sqrt0*(+(+(+sis_Vdi_bi_Tempt_GND-0.0)*sis+sis_Vdi_bi*sis_Tempt_GND+sis_Tempt_GND*sis_Vdi_bi+sis*(+sis_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
T1_Vsi_bi=(0.5*(sis_Vsi_bi+((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vsi_bi+((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vsi_bi*0.0+0.0*sis_Vsi_bi+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsi_bi_Vgm_si=(+0.0*(sis+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sis_Vsi_bi+((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sis+sis_Vsi_bi*0.0+0.0*sis_Vsi_bi+sis*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsi_bi_Vdbulk_di=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdbulk_di+((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsi_bi+((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))*d10_sqrt0)+0.5*(+(+sis_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdbulk_di*sis)+(sis*sis_Vdbulk_di)))+((0.0)*0.5))*((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))+d10_sqrt0*(+(+(+sis_Vsi_bi_Vdbulk_di-0.0)*sis+sis_Vsi_bi*sis_Vdbulk_di+sis_Vdbulk_di*sis_Vsi_bi+sis*(+sis_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsi_bi_Vsbulk_si=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsbulk_si+((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsi_bi+((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))*d10_sqrt0)+0.5*(+(+sis_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsbulk_si*sis)+(sis*sis_Vsbulk_si)))+((0.0)*0.5))*((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))+d10_sqrt0*(+(+(+sis_Vsi_bi_Vsbulk_si-0.0)*sis+sis_Vsi_bi*sis_Vsbulk_si+sis_Vsbulk_si*sis_Vsi_bi+sis*(+sis_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsi_bi_Vgi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vgi_bi+((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsi_bi+((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))*d10_sqrt0)+0.5*(+(+sis_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vgi_bi*sis)+(sis*sis_Vgi_bi)))+((0.0)*0.5))*((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))+d10_sqrt0*(+(+(+sis_Vsi_bi_Vgi_bi-0.0)*sis+sis_Vsi_bi*sis_Vgi_bi+sis_Vgi_bi*sis_Vsi_bi+sis*(+sis_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsi_bi_Vdi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vdi_bi+((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsi_bi+((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))*d10_sqrt0)+0.5*(+(+sis_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vdi_bi*sis)+(sis*sis_Vdi_bi)))+((0.0)*0.5))*((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))+d10_sqrt0*(+(+(+sis_Vsi_bi_Vdi_bi-0.0)*sis+sis_Vsi_bi*sis_Vdi_bi+sis_Vdi_bi*sis_Vsi_bi+sis*(+sis_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsi_bi_Vsi_bi=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Vsi_bi+((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsi_bi+((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))*d10_sqrt0)+0.5*(+(+sis_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi)))+((0.0)*0.5))*((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))+d10_sqrt0*(+(+(+sis_Vsi_bi_Vsi_bi-0.0)*sis+sis_Vsi_bi*sis_Vsi_bi+sis_Vsi_bi*sis_Vsi_bi+sis*(+sis_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T1_Vsi_bi_Tempt_GND=(+0.0*(sis+d00_sqrt0)+0.0*(sis_Tempt_GND+((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sis_Vsi_bi+((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))*d10_sqrt0)+0.5*(+(+sis_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt(((sis*sis)+((0.25*0.5)*0.5)))*((((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND)))+((0.0)*0.5))*((sis_Vsi_bi*sis)+(sis*sis_Vsi_bi))+d10_sqrt0*(+(+(+sis_Vsi_bi_Tempt_GND-0.0)*sis+sis_Vsi_bi*sis_Tempt_GND+sis_Tempt_GND*sis_Vsi_bi+sis*(+sis_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(0.5*(sis_Tempt_GND+((sis_Tempt_GND*sis)+(sis*sis_Tempt_GND))*d10_sqrt0));
#endif
#endif
T1=(0.5*(sis+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(sis+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,((sid*sid)+((0.25*0.5)*0.5)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((sid*sid)+((0.25*0.5)*0.5)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=(0.5*(sid_Vdbulk_di+((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vdbulk_di+((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vdbulk_di*0.0+0.0*sid_Vdbulk_di+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdbulk_di_Vgm_si=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vdbulk_di+((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vdbulk_di*0.0+0.0*sid_Vdbulk_di+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdbulk_di_Vdbulk_di=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdbulk_di+((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdbulk_di+((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sid_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))+d10_sqrt0*(+(+(+sid_Vdbulk_di_Vdbulk_di-0.0)*sid+sid_Vdbulk_di*sid_Vdbulk_di+sid_Vdbulk_di*sid_Vdbulk_di+sid*(+sid_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdbulk_di_Vsbulk_si=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsbulk_si+((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdbulk_di+((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sid_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))+d10_sqrt0*(+(+(+sid_Vdbulk_di_Vsbulk_si-0.0)*sid+sid_Vdbulk_di*sid_Vsbulk_si+sid_Vsbulk_si*sid_Vdbulk_di+sid*(+sid_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdbulk_di_Vgi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vgi_bi+((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdbulk_di+((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sid_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))+d10_sqrt0*(+(+(+sid_Vdbulk_di_Vgi_bi-0.0)*sid+sid_Vdbulk_di*sid_Vgi_bi+sid_Vgi_bi*sid_Vdbulk_di+sid*(+sid_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdbulk_di_Vdi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdi_bi+((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdbulk_di+((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sid_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))+d10_sqrt0*(+(+(+sid_Vdbulk_di_Vdi_bi-0.0)*sid+sid_Vdbulk_di*sid_Vdi_bi+sid_Vdi_bi*sid_Vdbulk_di+sid*(+sid_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdbulk_di_Vsi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsi_bi+((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdbulk_di+((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sid_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))+d10_sqrt0*(+(+(+sid_Vdbulk_di_Vsi_bi-0.0)*sid+sid_Vdbulk_di*sid_Vsi_bi+sid_Vsi_bi*sid_Vdbulk_di+sid*(+sid_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdbulk_di_Tempt_GND=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Tempt_GND+((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdbulk_di+((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))*d10_sqrt0)+0.5*(+(+sid_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di))+d10_sqrt0*(+(+(+sid_Vdbulk_di_Tempt_GND-0.0)*sid+sid_Vdbulk_di*sid_Tempt_GND+sid_Tempt_GND*sid_Vdbulk_di+sid*(+sid_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
T2_Vsbulk_si=(0.5*(sid_Vsbulk_si+((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vsbulk_si+((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vsbulk_si*0.0+0.0*sid_Vsbulk_si+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsbulk_si_Vgm_si=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vsbulk_si+((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vsbulk_si*0.0+0.0*sid_Vsbulk_si+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsbulk_si_Vdbulk_di=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdbulk_di+((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsbulk_si+((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sid_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))+d10_sqrt0*(+(+(+sid_Vsbulk_si_Vdbulk_di-0.0)*sid+sid_Vsbulk_si*sid_Vdbulk_di+sid_Vdbulk_di*sid_Vsbulk_si+sid*(+sid_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsbulk_si_Vsbulk_si=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsbulk_si+((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsbulk_si+((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sid_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))+d10_sqrt0*(+(+(+sid_Vsbulk_si_Vsbulk_si-0.0)*sid+sid_Vsbulk_si*sid_Vsbulk_si+sid_Vsbulk_si*sid_Vsbulk_si+sid*(+sid_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsbulk_si_Vgi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vgi_bi+((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsbulk_si+((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sid_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))+d10_sqrt0*(+(+(+sid_Vsbulk_si_Vgi_bi-0.0)*sid+sid_Vsbulk_si*sid_Vgi_bi+sid_Vgi_bi*sid_Vsbulk_si+sid*(+sid_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsbulk_si_Vdi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdi_bi+((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsbulk_si+((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sid_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))+d10_sqrt0*(+(+(+sid_Vsbulk_si_Vdi_bi-0.0)*sid+sid_Vsbulk_si*sid_Vdi_bi+sid_Vdi_bi*sid_Vsbulk_si+sid*(+sid_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsbulk_si_Vsi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsi_bi+((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsbulk_si+((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sid_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))+d10_sqrt0*(+(+(+sid_Vsbulk_si_Vsi_bi-0.0)*sid+sid_Vsbulk_si*sid_Vsi_bi+sid_Vsi_bi*sid_Vsbulk_si+sid*(+sid_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsbulk_si_Tempt_GND=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Tempt_GND+((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsbulk_si+((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))*d10_sqrt0)+0.5*(+(+sid_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si))+d10_sqrt0*(+(+(+sid_Vsbulk_si_Tempt_GND-0.0)*sid+sid_Vsbulk_si*sid_Tempt_GND+sid_Tempt_GND*sid_Vsbulk_si+sid*(+sid_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
T2_Vgi_bi=(0.5*(sid_Vgi_bi+((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vgi_bi+((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vgi_bi*0.0+0.0*sid_Vgi_bi+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vgi_bi_Vgm_si=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vgi_bi+((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vgi_bi*0.0+0.0*sid_Vgi_bi+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vgi_bi_Vdbulk_di=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdbulk_di+((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vgi_bi+((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))*d10_sqrt0)+0.5*(+(+sid_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))+d10_sqrt0*(+(+(+sid_Vgi_bi_Vdbulk_di-0.0)*sid+sid_Vgi_bi*sid_Vdbulk_di+sid_Vdbulk_di*sid_Vgi_bi+sid*(+sid_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vgi_bi_Vsbulk_si=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsbulk_si+((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vgi_bi+((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))*d10_sqrt0)+0.5*(+(+sid_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))+d10_sqrt0*(+(+(+sid_Vgi_bi_Vsbulk_si-0.0)*sid+sid_Vgi_bi*sid_Vsbulk_si+sid_Vsbulk_si*sid_Vgi_bi+sid*(+sid_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vgi_bi_Vgi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vgi_bi+((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vgi_bi+((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))*d10_sqrt0)+0.5*(+(+sid_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))+d10_sqrt0*(+(+(+sid_Vgi_bi_Vgi_bi-0.0)*sid+sid_Vgi_bi*sid_Vgi_bi+sid_Vgi_bi*sid_Vgi_bi+sid*(+sid_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vgi_bi_Vdi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdi_bi+((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vgi_bi+((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))*d10_sqrt0)+0.5*(+(+sid_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))+d10_sqrt0*(+(+(+sid_Vgi_bi_Vdi_bi-0.0)*sid+sid_Vgi_bi*sid_Vdi_bi+sid_Vdi_bi*sid_Vgi_bi+sid*(+sid_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vgi_bi_Vsi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsi_bi+((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vgi_bi+((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))*d10_sqrt0)+0.5*(+(+sid_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))+d10_sqrt0*(+(+(+sid_Vgi_bi_Vsi_bi-0.0)*sid+sid_Vgi_bi*sid_Vsi_bi+sid_Vsi_bi*sid_Vgi_bi+sid*(+sid_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vgi_bi_Tempt_GND=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Tempt_GND+((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vgi_bi+((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))*d10_sqrt0)+0.5*(+(+sid_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi))+d10_sqrt0*(+(+(+sid_Vgi_bi_Tempt_GND-0.0)*sid+sid_Vgi_bi*sid_Tempt_GND+sid_Tempt_GND*sid_Vgi_bi+sid*(+sid_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
T2_Vdi_bi=(0.5*(sid_Vdi_bi+((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vdi_bi+((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vdi_bi*0.0+0.0*sid_Vdi_bi+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdi_bi_Vgm_si=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vdi_bi+((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vdi_bi*0.0+0.0*sid_Vdi_bi+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdi_bi_Vdbulk_di=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdbulk_di+((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdi_bi+((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))*d10_sqrt0)+0.5*(+(+sid_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))+d10_sqrt0*(+(+(+sid_Vdi_bi_Vdbulk_di-0.0)*sid+sid_Vdi_bi*sid_Vdbulk_di+sid_Vdbulk_di*sid_Vdi_bi+sid*(+sid_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdi_bi_Vsbulk_si=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsbulk_si+((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdi_bi+((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))*d10_sqrt0)+0.5*(+(+sid_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))+d10_sqrt0*(+(+(+sid_Vdi_bi_Vsbulk_si-0.0)*sid+sid_Vdi_bi*sid_Vsbulk_si+sid_Vsbulk_si*sid_Vdi_bi+sid*(+sid_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdi_bi_Vgi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vgi_bi+((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdi_bi+((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))*d10_sqrt0)+0.5*(+(+sid_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))+d10_sqrt0*(+(+(+sid_Vdi_bi_Vgi_bi-0.0)*sid+sid_Vdi_bi*sid_Vgi_bi+sid_Vgi_bi*sid_Vdi_bi+sid*(+sid_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdi_bi_Vdi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdi_bi+((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdi_bi+((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))*d10_sqrt0)+0.5*(+(+sid_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))+d10_sqrt0*(+(+(+sid_Vdi_bi_Vdi_bi-0.0)*sid+sid_Vdi_bi*sid_Vdi_bi+sid_Vdi_bi*sid_Vdi_bi+sid*(+sid_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdi_bi_Vsi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsi_bi+((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdi_bi+((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))*d10_sqrt0)+0.5*(+(+sid_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))+d10_sqrt0*(+(+(+sid_Vdi_bi_Vsi_bi-0.0)*sid+sid_Vdi_bi*sid_Vsi_bi+sid_Vsi_bi*sid_Vdi_bi+sid*(+sid_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vdi_bi_Tempt_GND=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Tempt_GND+((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vdi_bi+((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))*d10_sqrt0)+0.5*(+(+sid_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi))+d10_sqrt0*(+(+(+sid_Vdi_bi_Tempt_GND-0.0)*sid+sid_Vdi_bi*sid_Tempt_GND+sid_Tempt_GND*sid_Vdi_bi+sid*(+sid_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
T2_Vsi_bi=(0.5*(sid_Vsi_bi+((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vsi_bi+((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vsi_bi*0.0+0.0*sid_Vsi_bi+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsi_bi_Vgm_si=(+0.0*(sid+d00_sqrt0)+0.0*((0.0)+((0.0)*0.5))*d10_sqrt0+0.0*(sid_Vsi_bi+((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))*d10_sqrt0)+0.5*(+(+0.0+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((0.0)+((0.0)*0.5))*((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))+d10_sqrt0*(+(+(+0.0-0.0)*sid+sid_Vsi_bi*0.0+0.0*sid_Vsi_bi+sid*(+0.0-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsi_bi_Vdbulk_di=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdbulk_di+((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsi_bi+((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))*d10_sqrt0)+0.5*(+(+sid_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdbulk_di*sid)+(sid*sid_Vdbulk_di)))+((0.0)*0.5))*((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))+d10_sqrt0*(+(+(+sid_Vsi_bi_Vdbulk_di-0.0)*sid+sid_Vsi_bi*sid_Vdbulk_di+sid_Vdbulk_di*sid_Vsi_bi+sid*(+sid_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsi_bi_Vsbulk_si=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsbulk_si+((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsi_bi+((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))*d10_sqrt0)+0.5*(+(+sid_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsbulk_si*sid)+(sid*sid_Vsbulk_si)))+((0.0)*0.5))*((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))+d10_sqrt0*(+(+(+sid_Vsi_bi_Vsbulk_si-0.0)*sid+sid_Vsi_bi*sid_Vsbulk_si+sid_Vsbulk_si*sid_Vsi_bi+sid*(+sid_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsi_bi_Vgi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vgi_bi+((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsi_bi+((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))*d10_sqrt0)+0.5*(+(+sid_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vgi_bi*sid)+(sid*sid_Vgi_bi)))+((0.0)*0.5))*((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))+d10_sqrt0*(+(+(+sid_Vsi_bi_Vgi_bi-0.0)*sid+sid_Vsi_bi*sid_Vgi_bi+sid_Vgi_bi*sid_Vsi_bi+sid*(+sid_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsi_bi_Vdi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vdi_bi+((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsi_bi+((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))*d10_sqrt0)+0.5*(+(+sid_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vdi_bi*sid)+(sid*sid_Vdi_bi)))+((0.0)*0.5))*((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))+d10_sqrt0*(+(+(+sid_Vsi_bi_Vdi_bi-0.0)*sid+sid_Vsi_bi*sid_Vdi_bi+sid_Vdi_bi*sid_Vsi_bi+sid*(+sid_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsi_bi_Vsi_bi=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Vsi_bi+((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsi_bi+((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))*d10_sqrt0)+0.5*(+(+sid_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi)))+((0.0)*0.5))*((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))+d10_sqrt0*(+(+(+sid_Vsi_bi_Vsi_bi-0.0)*sid+sid_Vsi_bi*sid_Vsi_bi+sid_Vsi_bi*sid_Vsi_bi+sid*(+sid_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
  T2_Vsi_bi_Tempt_GND=(+0.0*(sid+d00_sqrt0)+0.0*(sid_Tempt_GND+((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*d10_sqrt0)+0.0*(sid_Vsi_bi+((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))*d10_sqrt0)+0.5*(+(+sid_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt(((sid*sid)+((0.25*0.5)*0.5)))*((((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND)))+((0.0)*0.5))*((sid_Vsi_bi*sid)+(sid*sid_Vsi_bi))+d10_sqrt0*(+(+(+sid_Vsi_bi_Tempt_GND-0.0)*sid+sid_Vsi_bi*sid_Tempt_GND+sid_Tempt_GND*sid_Vsi_bi+sid*(+sid_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.5+0.0*0.0+0.0*0.0+0.25*0.0)*0.5+0.0*0.0+(0.0)*0.0+(0.25*0.5)*0.0)))));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(0.5*(sid_Tempt_GND+((sid_Tempt_GND*sid)+(sid*sid_Tempt_GND))*d10_sqrt0));
#endif
#endif
T2=(0.5*(sid+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(sid+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,(0.25+(T1*invgamg2)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(0.25+(T1*invgamg2)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND) */
Temps_Vdbulk_di=T1_Vdbulk_di*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Temps_Vdbulk_di_Vdbulk_di=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdbulk_di*invgamg2)*T1_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdbulk_di_Vdbulk_di*invgamg2+T1_Vdbulk_di*0.0+T1_Vdbulk_di*0.0+T1*0.0)));
  Temps_Vdbulk_di_Vsbulk_si=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsbulk_si*invgamg2)*T1_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdbulk_di_Vsbulk_si*invgamg2+T1_Vdbulk_di*0.0+T1_Vsbulk_si*0.0+T1*0.0)));
  Temps_Vdbulk_di_Vgi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vgi_bi*invgamg2)*T1_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdbulk_di_Vgi_bi*invgamg2+T1_Vdbulk_di*0.0+T1_Vgi_bi*0.0+T1*0.0)));
  Temps_Vdbulk_di_Vdi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdi_bi*invgamg2)*T1_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdbulk_di_Vdi_bi*invgamg2+T1_Vdbulk_di*0.0+T1_Vdi_bi*0.0+T1*0.0)));
  Temps_Vdbulk_di_Vsi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsi_bi*invgamg2)*T1_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdbulk_di_Vsi_bi*invgamg2+T1_Vdbulk_di*0.0+T1_Vsi_bi*0.0+T1*0.0)));
  Temps_Vdbulk_di_Tempt_GND=(m20_sqrt((0.25+(T1*invgamg2)))*(((T1_Tempt_GND*invgamg2)+(T1*invgamg2_Tempt_GND)))*T1_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdbulk_di_Tempt_GND*invgamg2+T1_Vdbulk_di*invgamg2_Tempt_GND+T1_Tempt_GND*0.0+T1*0.0)));
#endif
Temps_Vsbulk_si=T1_Vsbulk_si*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Temps_Vsbulk_si_Vdbulk_di=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdbulk_di*invgamg2)*T1_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsbulk_si_Vdbulk_di*invgamg2+T1_Vsbulk_si*0.0+T1_Vdbulk_di*0.0+T1*0.0)));
  Temps_Vsbulk_si_Vsbulk_si=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsbulk_si*invgamg2)*T1_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsbulk_si_Vsbulk_si*invgamg2+T1_Vsbulk_si*0.0+T1_Vsbulk_si*0.0+T1*0.0)));
  Temps_Vsbulk_si_Vgi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vgi_bi*invgamg2)*T1_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsbulk_si_Vgi_bi*invgamg2+T1_Vsbulk_si*0.0+T1_Vgi_bi*0.0+T1*0.0)));
  Temps_Vsbulk_si_Vdi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdi_bi*invgamg2)*T1_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsbulk_si_Vdi_bi*invgamg2+T1_Vsbulk_si*0.0+T1_Vdi_bi*0.0+T1*0.0)));
  Temps_Vsbulk_si_Vsi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsi_bi*invgamg2)*T1_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsbulk_si_Vsi_bi*invgamg2+T1_Vsbulk_si*0.0+T1_Vsi_bi*0.0+T1*0.0)));
  Temps_Vsbulk_si_Tempt_GND=(m20_sqrt((0.25+(T1*invgamg2)))*(((T1_Tempt_GND*invgamg2)+(T1*invgamg2_Tempt_GND)))*T1_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsbulk_si_Tempt_GND*invgamg2+T1_Vsbulk_si*invgamg2_Tempt_GND+T1_Tempt_GND*0.0+T1*0.0)));
#endif
Temps_Vgi_bi=T1_Vgi_bi*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Temps_Vgi_bi_Vdbulk_di=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdbulk_di*invgamg2)*T1_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdbulk_di*invgamg2+T1_Vgi_bi*0.0+T1_Vdbulk_di*0.0+T1*0.0)));
  Temps_Vgi_bi_Vsbulk_si=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsbulk_si*invgamg2)*T1_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsbulk_si*invgamg2+T1_Vgi_bi*0.0+T1_Vsbulk_si*0.0+T1*0.0)));
  Temps_Vgi_bi_Vgi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vgi_bi*invgamg2)*T1_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vgi_bi*invgamg2+T1_Vgi_bi*0.0+T1_Vgi_bi*0.0+T1*0.0)));
  Temps_Vgi_bi_Vdi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdi_bi*invgamg2)*T1_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vdi_bi*invgamg2+T1_Vgi_bi*0.0+T1_Vdi_bi*0.0+T1*0.0)));
  Temps_Vgi_bi_Vsi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsi_bi*invgamg2)*T1_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Vsi_bi*invgamg2+T1_Vgi_bi*0.0+T1_Vsi_bi*0.0+T1*0.0)));
  Temps_Vgi_bi_Tempt_GND=(m20_sqrt((0.25+(T1*invgamg2)))*(((T1_Tempt_GND*invgamg2)+(T1*invgamg2_Tempt_GND)))*T1_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vgi_bi_Tempt_GND*invgamg2+T1_Vgi_bi*invgamg2_Tempt_GND+T1_Tempt_GND*0.0+T1*0.0)));
#endif
Temps_Vdi_bi=T1_Vdi_bi*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Temps_Vdi_bi_Vdbulk_di=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdbulk_di*invgamg2)*T1_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdbulk_di*invgamg2+T1_Vdi_bi*0.0+T1_Vdbulk_di*0.0+T1*0.0)));
  Temps_Vdi_bi_Vsbulk_si=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsbulk_si*invgamg2)*T1_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsbulk_si*invgamg2+T1_Vdi_bi*0.0+T1_Vsbulk_si*0.0+T1*0.0)));
  Temps_Vdi_bi_Vgi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vgi_bi*invgamg2)*T1_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vgi_bi*invgamg2+T1_Vdi_bi*0.0+T1_Vgi_bi*0.0+T1*0.0)));
  Temps_Vdi_bi_Vdi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdi_bi*invgamg2)*T1_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vdi_bi*invgamg2+T1_Vdi_bi*0.0+T1_Vdi_bi*0.0+T1*0.0)));
  Temps_Vdi_bi_Vsi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsi_bi*invgamg2)*T1_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Vsi_bi*invgamg2+T1_Vdi_bi*0.0+T1_Vsi_bi*0.0+T1*0.0)));
  Temps_Vdi_bi_Tempt_GND=(m20_sqrt((0.25+(T1*invgamg2)))*(((T1_Tempt_GND*invgamg2)+(T1*invgamg2_Tempt_GND)))*T1_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vdi_bi_Tempt_GND*invgamg2+T1_Vdi_bi*invgamg2_Tempt_GND+T1_Tempt_GND*0.0+T1*0.0)));
#endif
Temps_Vsi_bi=T1_Vsi_bi*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Temps_Vsi_bi_Vdbulk_di=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdbulk_di*invgamg2)*T1_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdbulk_di*invgamg2+T1_Vsi_bi*0.0+T1_Vdbulk_di*0.0+T1*0.0)));
  Temps_Vsi_bi_Vsbulk_si=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsbulk_si*invgamg2)*T1_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsbulk_si*invgamg2+T1_Vsi_bi*0.0+T1_Vsbulk_si*0.0+T1*0.0)));
  Temps_Vsi_bi_Vgi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vgi_bi*invgamg2)*T1_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vgi_bi*invgamg2+T1_Vsi_bi*0.0+T1_Vgi_bi*0.0+T1*0.0)));
  Temps_Vsi_bi_Vdi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vdi_bi*invgamg2)*T1_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vdi_bi*invgamg2+T1_Vsi_bi*0.0+T1_Vdi_bi*0.0+T1*0.0)));
  Temps_Vsi_bi_Vsi_bi=(m20_sqrt((0.25+(T1*invgamg2)))*(T1_Vsi_bi*invgamg2)*T1_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Vsi_bi*invgamg2+T1_Vsi_bi*0.0+T1_Vsi_bi*0.0+T1*0.0)));
  Temps_Vsi_bi_Tempt_GND=(m20_sqrt((0.25+(T1*invgamg2)))*(((T1_Tempt_GND*invgamg2)+(T1*invgamg2_Tempt_GND)))*T1_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T1_Vsi_bi_Tempt_GND*invgamg2+T1_Vsi_bi*invgamg2_Tempt_GND+T1_Tempt_GND*0.0+T1*0.0)));
#endif
#if defined(_DERIVATE)
Temps_Tempt_GND=((T1_Tempt_GND*invgamg2)+(T1*invgamg2_Tempt_GND))*d10_sqrt0;
#endif
#endif
Temps=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_sqrt(d00_sqrt0,(0.25+(T2*invgamg2)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(0.25+(T2*invgamg2)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND)V(dbulk,GND)V(sbulk,GND) */
Tempd_Vdbulk_di=T2_Vdbulk_di*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Tempd_Vdbulk_di_Vdbulk_di=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdbulk_di*invgamg2)*T2_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdbulk_di_Vdbulk_di*invgamg2+T2_Vdbulk_di*0.0+T2_Vdbulk_di*0.0+T2*0.0)));
  Tempd_Vdbulk_di_Vsbulk_si=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsbulk_si*invgamg2)*T2_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdbulk_di_Vsbulk_si*invgamg2+T2_Vdbulk_di*0.0+T2_Vsbulk_si*0.0+T2*0.0)));
  Tempd_Vdbulk_di_Vgi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vgi_bi*invgamg2)*T2_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdbulk_di_Vgi_bi*invgamg2+T2_Vdbulk_di*0.0+T2_Vgi_bi*0.0+T2*0.0)));
  Tempd_Vdbulk_di_Vdi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdi_bi*invgamg2)*T2_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdbulk_di_Vdi_bi*invgamg2+T2_Vdbulk_di*0.0+T2_Vdi_bi*0.0+T2*0.0)));
  Tempd_Vdbulk_di_Vsi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsi_bi*invgamg2)*T2_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdbulk_di_Vsi_bi*invgamg2+T2_Vdbulk_di*0.0+T2_Vsi_bi*0.0+T2*0.0)));
  Tempd_Vdbulk_di_Tempt_GND=(m20_sqrt((0.25+(T2*invgamg2)))*(((T2_Tempt_GND*invgamg2)+(T2*invgamg2_Tempt_GND)))*T2_Vdbulk_di*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdbulk_di_Tempt_GND*invgamg2+T2_Vdbulk_di*invgamg2_Tempt_GND+T2_Tempt_GND*0.0+T2*0.0)));
#endif
Tempd_Vsbulk_si=T2_Vsbulk_si*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Tempd_Vsbulk_si_Vdbulk_di=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdbulk_di*invgamg2)*T2_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsbulk_si_Vdbulk_di*invgamg2+T2_Vsbulk_si*0.0+T2_Vdbulk_di*0.0+T2*0.0)));
  Tempd_Vsbulk_si_Vsbulk_si=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsbulk_si*invgamg2)*T2_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsbulk_si_Vsbulk_si*invgamg2+T2_Vsbulk_si*0.0+T2_Vsbulk_si*0.0+T2*0.0)));
  Tempd_Vsbulk_si_Vgi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vgi_bi*invgamg2)*T2_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsbulk_si_Vgi_bi*invgamg2+T2_Vsbulk_si*0.0+T2_Vgi_bi*0.0+T2*0.0)));
  Tempd_Vsbulk_si_Vdi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdi_bi*invgamg2)*T2_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsbulk_si_Vdi_bi*invgamg2+T2_Vsbulk_si*0.0+T2_Vdi_bi*0.0+T2*0.0)));
  Tempd_Vsbulk_si_Vsi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsi_bi*invgamg2)*T2_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsbulk_si_Vsi_bi*invgamg2+T2_Vsbulk_si*0.0+T2_Vsi_bi*0.0+T2*0.0)));
  Tempd_Vsbulk_si_Tempt_GND=(m20_sqrt((0.25+(T2*invgamg2)))*(((T2_Tempt_GND*invgamg2)+(T2*invgamg2_Tempt_GND)))*T2_Vsbulk_si*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsbulk_si_Tempt_GND*invgamg2+T2_Vsbulk_si*invgamg2_Tempt_GND+T2_Tempt_GND*0.0+T2*0.0)));
#endif
Tempd_Vgi_bi=T2_Vgi_bi*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Tempd_Vgi_bi_Vdbulk_di=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdbulk_di*invgamg2)*T2_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vgi_bi_Vdbulk_di*invgamg2+T2_Vgi_bi*0.0+T2_Vdbulk_di*0.0+T2*0.0)));
  Tempd_Vgi_bi_Vsbulk_si=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsbulk_si*invgamg2)*T2_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vgi_bi_Vsbulk_si*invgamg2+T2_Vgi_bi*0.0+T2_Vsbulk_si*0.0+T2*0.0)));
  Tempd_Vgi_bi_Vgi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vgi_bi*invgamg2)*T2_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vgi_bi_Vgi_bi*invgamg2+T2_Vgi_bi*0.0+T2_Vgi_bi*0.0+T2*0.0)));
  Tempd_Vgi_bi_Vdi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdi_bi*invgamg2)*T2_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vgi_bi_Vdi_bi*invgamg2+T2_Vgi_bi*0.0+T2_Vdi_bi*0.0+T2*0.0)));
  Tempd_Vgi_bi_Vsi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsi_bi*invgamg2)*T2_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vgi_bi_Vsi_bi*invgamg2+T2_Vgi_bi*0.0+T2_Vsi_bi*0.0+T2*0.0)));
  Tempd_Vgi_bi_Tempt_GND=(m20_sqrt((0.25+(T2*invgamg2)))*(((T2_Tempt_GND*invgamg2)+(T2*invgamg2_Tempt_GND)))*T2_Vgi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vgi_bi_Tempt_GND*invgamg2+T2_Vgi_bi*invgamg2_Tempt_GND+T2_Tempt_GND*0.0+T2*0.0)));
#endif
Tempd_Vdi_bi=T2_Vdi_bi*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Tempd_Vdi_bi_Vdbulk_di=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdbulk_di*invgamg2)*T2_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdi_bi_Vdbulk_di*invgamg2+T2_Vdi_bi*0.0+T2_Vdbulk_di*0.0+T2*0.0)));
  Tempd_Vdi_bi_Vsbulk_si=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsbulk_si*invgamg2)*T2_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdi_bi_Vsbulk_si*invgamg2+T2_Vdi_bi*0.0+T2_Vsbulk_si*0.0+T2*0.0)));
  Tempd_Vdi_bi_Vgi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vgi_bi*invgamg2)*T2_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdi_bi_Vgi_bi*invgamg2+T2_Vdi_bi*0.0+T2_Vgi_bi*0.0+T2*0.0)));
  Tempd_Vdi_bi_Vdi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdi_bi*invgamg2)*T2_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdi_bi_Vdi_bi*invgamg2+T2_Vdi_bi*0.0+T2_Vdi_bi*0.0+T2*0.0)));
  Tempd_Vdi_bi_Vsi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsi_bi*invgamg2)*T2_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdi_bi_Vsi_bi*invgamg2+T2_Vdi_bi*0.0+T2_Vsi_bi*0.0+T2*0.0)));
  Tempd_Vdi_bi_Tempt_GND=(m20_sqrt((0.25+(T2*invgamg2)))*(((T2_Tempt_GND*invgamg2)+(T2*invgamg2_Tempt_GND)))*T2_Vdi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vdi_bi_Tempt_GND*invgamg2+T2_Vdi_bi*invgamg2_Tempt_GND+T2_Tempt_GND*0.0+T2*0.0)));
#endif
Tempd_Vsi_bi=T2_Vsi_bi*invgamg2*d10_sqrt0;
#if defined(_DERIVATE2)
  Tempd_Vsi_bi_Vdbulk_di=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdbulk_di*invgamg2)*T2_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsi_bi_Vdbulk_di*invgamg2+T2_Vsi_bi*0.0+T2_Vdbulk_di*0.0+T2*0.0)));
  Tempd_Vsi_bi_Vsbulk_si=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsbulk_si*invgamg2)*T2_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsi_bi_Vsbulk_si*invgamg2+T2_Vsi_bi*0.0+T2_Vsbulk_si*0.0+T2*0.0)));
  Tempd_Vsi_bi_Vgi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vgi_bi*invgamg2)*T2_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsi_bi_Vgi_bi*invgamg2+T2_Vsi_bi*0.0+T2_Vgi_bi*0.0+T2*0.0)));
  Tempd_Vsi_bi_Vdi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vdi_bi*invgamg2)*T2_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsi_bi_Vdi_bi*invgamg2+T2_Vsi_bi*0.0+T2_Vdi_bi*0.0+T2*0.0)));
  Tempd_Vsi_bi_Vsi_bi=(m20_sqrt((0.25+(T2*invgamg2)))*(T2_Vsi_bi*invgamg2)*T2_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsi_bi_Vsi_bi*invgamg2+T2_Vsi_bi*0.0+T2_Vsi_bi*0.0+T2*0.0)));
  Tempd_Vsi_bi_Tempt_GND=(m20_sqrt((0.25+(T2*invgamg2)))*(((T2_Tempt_GND*invgamg2)+(T2*invgamg2_Tempt_GND)))*T2_Vsi_bi*invgamg2+d10_sqrt0*(+0.0+(+T2_Vsi_bi_Tempt_GND*invgamg2+T2_Vsi_bi*invgamg2_Tempt_GND+T2_Tempt_GND*0.0+T2*0.0)));
#endif
#if defined(_DERIVATE)
Tempd_Tempt_GND=((T2_Tempt_GND*invgamg2)+(T2*invgamg2_Tempt_GND))*d10_sqrt0;
#endif
#endif
Tempd=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=((sis_Vdbulk_di*(1.0+(2.0*Temps))-sis*(2.0*Temps_Vdbulk_di))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(0.0/(1.0+(2.0*Temps))-(sis_Vdbulk_di*(0.0)+0.0*(2.0*Temps_Vdbulk_di)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vdbulk_di+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdbulk_di)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdbulk_di_Vgm_si=(0.0/(1.0+(2.0*Temps))-(sis_Vdbulk_di*(0.0)+0.0*(2.0*Temps_Vdbulk_di)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vdbulk_di+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdbulk_di)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdbulk_di_Vdbulk_di=(sis_Vdbulk_di_Vdbulk_di/(1.0+(2.0*Temps))-(sis_Vdbulk_di*((2.0*Temps_Vdbulk_di))+sis_Vdbulk_di*(2.0*Temps_Vdbulk_di)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdbulk_di+0.0*Temps_Vdbulk_di+2.0*Temps_Vdbulk_di_Vdbulk_di)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdbulk_di)*((2.0*Temps_Vdbulk_di))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdbulk_di_Vsbulk_si=(sis_Vdbulk_di_Vsbulk_si/(1.0+(2.0*Temps))-(sis_Vdbulk_di*((2.0*Temps_Vsbulk_si))+sis_Vsbulk_si*(2.0*Temps_Vdbulk_di)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsbulk_si+0.0*Temps_Vdbulk_di+2.0*Temps_Vdbulk_di_Vsbulk_si)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdbulk_di)*((2.0*Temps_Vsbulk_si))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdbulk_di_Vgi_bi=(sis_Vdbulk_di_Vgi_bi/(1.0+(2.0*Temps))-(sis_Vdbulk_di*((2.0*Temps_Vgi_bi))+sis_Vgi_bi*(2.0*Temps_Vdbulk_di)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vgi_bi+0.0*Temps_Vdbulk_di+2.0*Temps_Vdbulk_di_Vgi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdbulk_di)*((2.0*Temps_Vgi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdbulk_di_Vdi_bi=(sis_Vdbulk_di_Vdi_bi/(1.0+(2.0*Temps))-(sis_Vdbulk_di*((2.0*Temps_Vdi_bi))+sis_Vdi_bi*(2.0*Temps_Vdbulk_di)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdi_bi+0.0*Temps_Vdbulk_di+2.0*Temps_Vdbulk_di_Vdi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdbulk_di)*((2.0*Temps_Vdi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdbulk_di_Vsi_bi=(sis_Vdbulk_di_Vsi_bi/(1.0+(2.0*Temps))-(sis_Vdbulk_di*((2.0*Temps_Vsi_bi))+sis_Vsi_bi*(2.0*Temps_Vdbulk_di)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsi_bi+0.0*Temps_Vdbulk_di+2.0*Temps_Vdbulk_di_Vsi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdbulk_di)*((2.0*Temps_Vsi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdbulk_di_Tempt_GND=(sis_Vdbulk_di_Tempt_GND/(1.0+(2.0*Temps))-(sis_Vdbulk_di*((2.0*Temps_Tempt_GND))+sis_Tempt_GND*(2.0*Temps_Vdbulk_di)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Tempt_GND+0.0*Temps_Vdbulk_di+2.0*Temps_Vdbulk_di_Tempt_GND)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdbulk_di)*((2.0*Temps_Tempt_GND))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#endif
T1_Vsbulk_si=((sis_Vsbulk_si*(1.0+(2.0*Temps))-sis*(2.0*Temps_Vsbulk_si))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(0.0/(1.0+(2.0*Temps))-(sis_Vsbulk_si*(0.0)+0.0*(2.0*Temps_Vsbulk_si)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vsbulk_si+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsbulk_si)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsbulk_si_Vgm_si=(0.0/(1.0+(2.0*Temps))-(sis_Vsbulk_si*(0.0)+0.0*(2.0*Temps_Vsbulk_si)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vsbulk_si+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsbulk_si)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsbulk_si_Vdbulk_di=(sis_Vsbulk_si_Vdbulk_di/(1.0+(2.0*Temps))-(sis_Vsbulk_si*((2.0*Temps_Vdbulk_di))+sis_Vdbulk_di*(2.0*Temps_Vsbulk_si)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdbulk_di+0.0*Temps_Vsbulk_si+2.0*Temps_Vsbulk_si_Vdbulk_di)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsbulk_si)*((2.0*Temps_Vdbulk_di))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsbulk_si_Vsbulk_si=(sis_Vsbulk_si_Vsbulk_si/(1.0+(2.0*Temps))-(sis_Vsbulk_si*((2.0*Temps_Vsbulk_si))+sis_Vsbulk_si*(2.0*Temps_Vsbulk_si)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsbulk_si+0.0*Temps_Vsbulk_si+2.0*Temps_Vsbulk_si_Vsbulk_si)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsbulk_si)*((2.0*Temps_Vsbulk_si))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsbulk_si_Vgi_bi=(sis_Vsbulk_si_Vgi_bi/(1.0+(2.0*Temps))-(sis_Vsbulk_si*((2.0*Temps_Vgi_bi))+sis_Vgi_bi*(2.0*Temps_Vsbulk_si)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vgi_bi+0.0*Temps_Vsbulk_si+2.0*Temps_Vsbulk_si_Vgi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsbulk_si)*((2.0*Temps_Vgi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsbulk_si_Vdi_bi=(sis_Vsbulk_si_Vdi_bi/(1.0+(2.0*Temps))-(sis_Vsbulk_si*((2.0*Temps_Vdi_bi))+sis_Vdi_bi*(2.0*Temps_Vsbulk_si)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdi_bi+0.0*Temps_Vsbulk_si+2.0*Temps_Vsbulk_si_Vdi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsbulk_si)*((2.0*Temps_Vdi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsbulk_si_Vsi_bi=(sis_Vsbulk_si_Vsi_bi/(1.0+(2.0*Temps))-(sis_Vsbulk_si*((2.0*Temps_Vsi_bi))+sis_Vsi_bi*(2.0*Temps_Vsbulk_si)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsi_bi+0.0*Temps_Vsbulk_si+2.0*Temps_Vsbulk_si_Vsi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsbulk_si)*((2.0*Temps_Vsi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsbulk_si_Tempt_GND=(sis_Vsbulk_si_Tempt_GND/(1.0+(2.0*Temps))-(sis_Vsbulk_si*((2.0*Temps_Tempt_GND))+sis_Tempt_GND*(2.0*Temps_Vsbulk_si)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Tempt_GND+0.0*Temps_Vsbulk_si+2.0*Temps_Vsbulk_si_Tempt_GND)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsbulk_si)*((2.0*Temps_Tempt_GND))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#endif
T1_Vgi_bi=((sis_Vgi_bi*(1.0+(2.0*Temps))-sis*(2.0*Temps_Vgi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(0.0/(1.0+(2.0*Temps))-(sis_Vgi_bi*(0.0)+0.0*(2.0*Temps_Vgi_bi)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vgi_bi+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vgi_bi)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vgi_bi_Vgm_si=(0.0/(1.0+(2.0*Temps))-(sis_Vgi_bi*(0.0)+0.0*(2.0*Temps_Vgi_bi)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vgi_bi+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vgi_bi)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vgi_bi_Vdbulk_di=(sis_Vgi_bi_Vdbulk_di/(1.0+(2.0*Temps))-(sis_Vgi_bi*((2.0*Temps_Vdbulk_di))+sis_Vdbulk_di*(2.0*Temps_Vgi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdbulk_di+0.0*Temps_Vgi_bi+2.0*Temps_Vgi_bi_Vdbulk_di)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vgi_bi)*((2.0*Temps_Vdbulk_di))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vgi_bi_Vsbulk_si=(sis_Vgi_bi_Vsbulk_si/(1.0+(2.0*Temps))-(sis_Vgi_bi*((2.0*Temps_Vsbulk_si))+sis_Vsbulk_si*(2.0*Temps_Vgi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsbulk_si+0.0*Temps_Vgi_bi+2.0*Temps_Vgi_bi_Vsbulk_si)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vgi_bi)*((2.0*Temps_Vsbulk_si))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vgi_bi_Vgi_bi=(sis_Vgi_bi_Vgi_bi/(1.0+(2.0*Temps))-(sis_Vgi_bi*((2.0*Temps_Vgi_bi))+sis_Vgi_bi*(2.0*Temps_Vgi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vgi_bi+0.0*Temps_Vgi_bi+2.0*Temps_Vgi_bi_Vgi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vgi_bi)*((2.0*Temps_Vgi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vgi_bi_Vdi_bi=(sis_Vgi_bi_Vdi_bi/(1.0+(2.0*Temps))-(sis_Vgi_bi*((2.0*Temps_Vdi_bi))+sis_Vdi_bi*(2.0*Temps_Vgi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdi_bi+0.0*Temps_Vgi_bi+2.0*Temps_Vgi_bi_Vdi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vgi_bi)*((2.0*Temps_Vdi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vgi_bi_Vsi_bi=(sis_Vgi_bi_Vsi_bi/(1.0+(2.0*Temps))-(sis_Vgi_bi*((2.0*Temps_Vsi_bi))+sis_Vsi_bi*(2.0*Temps_Vgi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsi_bi+0.0*Temps_Vgi_bi+2.0*Temps_Vgi_bi_Vsi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vgi_bi)*((2.0*Temps_Vsi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vgi_bi_Tempt_GND=(sis_Vgi_bi_Tempt_GND/(1.0+(2.0*Temps))-(sis_Vgi_bi*((2.0*Temps_Tempt_GND))+sis_Tempt_GND*(2.0*Temps_Vgi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Tempt_GND+0.0*Temps_Vgi_bi+2.0*Temps_Vgi_bi_Tempt_GND)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vgi_bi)*((2.0*Temps_Tempt_GND))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#endif
T1_Vdi_bi=((sis_Vdi_bi*(1.0+(2.0*Temps))-sis*(2.0*Temps_Vdi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(0.0/(1.0+(2.0*Temps))-(sis_Vdi_bi*(0.0)+0.0*(2.0*Temps_Vdi_bi)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vdi_bi+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdi_bi)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdi_bi_Vgm_si=(0.0/(1.0+(2.0*Temps))-(sis_Vdi_bi*(0.0)+0.0*(2.0*Temps_Vdi_bi)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vdi_bi+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdi_bi)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdi_bi_Vdbulk_di=(sis_Vdi_bi_Vdbulk_di/(1.0+(2.0*Temps))-(sis_Vdi_bi*((2.0*Temps_Vdbulk_di))+sis_Vdbulk_di*(2.0*Temps_Vdi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdbulk_di+0.0*Temps_Vdi_bi+2.0*Temps_Vdi_bi_Vdbulk_di)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdi_bi)*((2.0*Temps_Vdbulk_di))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdi_bi_Vsbulk_si=(sis_Vdi_bi_Vsbulk_si/(1.0+(2.0*Temps))-(sis_Vdi_bi*((2.0*Temps_Vsbulk_si))+sis_Vsbulk_si*(2.0*Temps_Vdi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsbulk_si+0.0*Temps_Vdi_bi+2.0*Temps_Vdi_bi_Vsbulk_si)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdi_bi)*((2.0*Temps_Vsbulk_si))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdi_bi_Vgi_bi=(sis_Vdi_bi_Vgi_bi/(1.0+(2.0*Temps))-(sis_Vdi_bi*((2.0*Temps_Vgi_bi))+sis_Vgi_bi*(2.0*Temps_Vdi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vgi_bi+0.0*Temps_Vdi_bi+2.0*Temps_Vdi_bi_Vgi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdi_bi)*((2.0*Temps_Vgi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdi_bi_Vdi_bi=(sis_Vdi_bi_Vdi_bi/(1.0+(2.0*Temps))-(sis_Vdi_bi*((2.0*Temps_Vdi_bi))+sis_Vdi_bi*(2.0*Temps_Vdi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdi_bi+0.0*Temps_Vdi_bi+2.0*Temps_Vdi_bi_Vdi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdi_bi)*((2.0*Temps_Vdi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdi_bi_Vsi_bi=(sis_Vdi_bi_Vsi_bi/(1.0+(2.0*Temps))-(sis_Vdi_bi*((2.0*Temps_Vsi_bi))+sis_Vsi_bi*(2.0*Temps_Vdi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsi_bi+0.0*Temps_Vdi_bi+2.0*Temps_Vdi_bi_Vsi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdi_bi)*((2.0*Temps_Vsi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vdi_bi_Tempt_GND=(sis_Vdi_bi_Tempt_GND/(1.0+(2.0*Temps))-(sis_Vdi_bi*((2.0*Temps_Tempt_GND))+sis_Tempt_GND*(2.0*Temps_Vdi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Tempt_GND+0.0*Temps_Vdi_bi+2.0*Temps_Vdi_bi_Tempt_GND)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vdi_bi)*((2.0*Temps_Tempt_GND))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#endif
T1_Vsi_bi=((sis_Vsi_bi*(1.0+(2.0*Temps))-sis*(2.0*Temps_Vsi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(0.0/(1.0+(2.0*Temps))-(sis_Vsi_bi*(0.0)+0.0*(2.0*Temps_Vsi_bi)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vsi_bi+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsi_bi)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsi_bi_Vgm_si=(0.0/(1.0+(2.0*Temps))-(sis_Vsi_bi*(0.0)+0.0*(2.0*Temps_Vsi_bi)+sis*(+0.0+(+0.0*Temps+0.0*0.0+0.0*Temps_Vsi_bi+2.0*0.0)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsi_bi)*(0.0)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsi_bi_Vdbulk_di=(sis_Vsi_bi_Vdbulk_di/(1.0+(2.0*Temps))-(sis_Vsi_bi*((2.0*Temps_Vdbulk_di))+sis_Vdbulk_di*(2.0*Temps_Vsi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdbulk_di+0.0*Temps_Vsi_bi+2.0*Temps_Vsi_bi_Vdbulk_di)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsi_bi)*((2.0*Temps_Vdbulk_di))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsi_bi_Vsbulk_si=(sis_Vsi_bi_Vsbulk_si/(1.0+(2.0*Temps))-(sis_Vsi_bi*((2.0*Temps_Vsbulk_si))+sis_Vsbulk_si*(2.0*Temps_Vsi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsbulk_si+0.0*Temps_Vsi_bi+2.0*Temps_Vsi_bi_Vsbulk_si)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsi_bi)*((2.0*Temps_Vsbulk_si))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsi_bi_Vgi_bi=(sis_Vsi_bi_Vgi_bi/(1.0+(2.0*Temps))-(sis_Vsi_bi*((2.0*Temps_Vgi_bi))+sis_Vgi_bi*(2.0*Temps_Vsi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vgi_bi+0.0*Temps_Vsi_bi+2.0*Temps_Vsi_bi_Vgi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsi_bi)*((2.0*Temps_Vgi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsi_bi_Vdi_bi=(sis_Vsi_bi_Vdi_bi/(1.0+(2.0*Temps))-(sis_Vsi_bi*((2.0*Temps_Vdi_bi))+sis_Vdi_bi*(2.0*Temps_Vsi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vdi_bi+0.0*Temps_Vsi_bi+2.0*Temps_Vsi_bi_Vdi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsi_bi)*((2.0*Temps_Vdi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsi_bi_Vsi_bi=(sis_Vsi_bi_Vsi_bi/(1.0+(2.0*Temps))-(sis_Vsi_bi*((2.0*Temps_Vsi_bi))+sis_Vsi_bi*(2.0*Temps_Vsi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Vsi_bi+0.0*Temps_Vsi_bi+2.0*Temps_Vsi_bi_Vsi_bi)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsi_bi)*((2.0*Temps_Vsi_bi))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
  T1_Vsi_bi_Tempt_GND=(sis_Vsi_bi_Tempt_GND/(1.0+(2.0*Temps))-(sis_Vsi_bi*((2.0*Temps_Tempt_GND))+sis_Tempt_GND*(2.0*Temps_Vsi_bi)+sis*(+0.0+(+0.0*Temps+0.0*Temps_Tempt_GND+0.0*Temps_Vsi_bi+2.0*Temps_Vsi_bi_Tempt_GND)))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))+2*sis*(2.0*Temps_Vsi_bi)*((2.0*Temps_Tempt_GND))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((sis_Tempt_GND*(1.0+(2.0*Temps))-sis*(2.0*Temps_Tempt_GND))/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
#endif
#endif
T1=(sis/(1.0+(2.0*Temps)));
EXIT_IF_ISNAN((sis/(1.0+(2.0*Temps))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=0.0;
  T2_Vgm_di_Vgm_si=0.0;
  T2_Vgm_di_Vdbulk_di=0.0;
  T2_Vgm_di_Vsbulk_si=0.0;
  T2_Vgm_di_Vgi_bi=0.0;
  T2_Vgm_di_Vdi_bi=0.0;
  T2_Vgm_di_Vsi_bi=0.0;
  T2_Vgm_di_Tempt_GND=0.0;
#endif
T2_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=0.0;
  T2_Vgm_si_Vgm_si=0.0;
  T2_Vgm_si_Vdbulk_di=0.0;
  T2_Vgm_si_Vsbulk_si=0.0;
  T2_Vgm_si_Vgi_bi=0.0;
  T2_Vgm_si_Vdi_bi=0.0;
  T2_Vgm_si_Vsi_bi=0.0;
  T2_Vgm_si_Tempt_GND=0.0;
#endif
T2_Vdbulk_di=((sid_Vdbulk_di*(1.0+(2.0*Tempd))-sid*(2.0*Tempd_Vdbulk_di))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(0.0/(1.0+(2.0*Tempd))-(sid_Vdbulk_di*(0.0)+0.0*(2.0*Tempd_Vdbulk_di)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vdbulk_di+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdbulk_di)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdbulk_di_Vgm_si=(0.0/(1.0+(2.0*Tempd))-(sid_Vdbulk_di*(0.0)+0.0*(2.0*Tempd_Vdbulk_di)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vdbulk_di+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdbulk_di)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdbulk_di_Vdbulk_di=(sid_Vdbulk_di_Vdbulk_di/(1.0+(2.0*Tempd))-(sid_Vdbulk_di*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vdbulk_di)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vdbulk_di)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vdbulk_di))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdbulk_di_Vsbulk_si=(sid_Vdbulk_di_Vsbulk_si/(1.0+(2.0*Tempd))-(sid_Vdbulk_di*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vdbulk_di)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vsbulk_si)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vsbulk_si))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdbulk_di_Vgi_bi=(sid_Vdbulk_di_Vgi_bi/(1.0+(2.0*Tempd))-(sid_Vdbulk_di*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vdbulk_di)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vgi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vgi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdbulk_di_Vdi_bi=(sid_Vdbulk_di_Vdi_bi/(1.0+(2.0*Tempd))-(sid_Vdbulk_di*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vdbulk_di)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vdi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vdi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdbulk_di_Vsi_bi=(sid_Vdbulk_di_Vsi_bi/(1.0+(2.0*Tempd))-(sid_Vdbulk_di*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vdbulk_di)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vsi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vsi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdbulk_di_Tempt_GND=(sid_Vdbulk_di_Tempt_GND/(1.0+(2.0*Tempd))-(sid_Vdbulk_di*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vdbulk_di)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Tempt_GND)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Tempt_GND))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#endif
T2_Vsbulk_si=((sid_Vsbulk_si*(1.0+(2.0*Tempd))-sid*(2.0*Tempd_Vsbulk_si))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(0.0/(1.0+(2.0*Tempd))-(sid_Vsbulk_si*(0.0)+0.0*(2.0*Tempd_Vsbulk_si)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vsbulk_si+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsbulk_si)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsbulk_si_Vgm_si=(0.0/(1.0+(2.0*Tempd))-(sid_Vsbulk_si*(0.0)+0.0*(2.0*Tempd_Vsbulk_si)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vsbulk_si+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsbulk_si)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsbulk_si_Vdbulk_di=(sid_Vsbulk_si_Vdbulk_di/(1.0+(2.0*Tempd))-(sid_Vsbulk_si*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vsbulk_si)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vdbulk_di)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vdbulk_di))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsbulk_si_Vsbulk_si=(sid_Vsbulk_si_Vsbulk_si/(1.0+(2.0*Tempd))-(sid_Vsbulk_si*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vsbulk_si)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vsbulk_si)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vsbulk_si))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsbulk_si_Vgi_bi=(sid_Vsbulk_si_Vgi_bi/(1.0+(2.0*Tempd))-(sid_Vsbulk_si*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vsbulk_si)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vgi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vgi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsbulk_si_Vdi_bi=(sid_Vsbulk_si_Vdi_bi/(1.0+(2.0*Tempd))-(sid_Vsbulk_si*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vsbulk_si)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vdi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vdi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsbulk_si_Vsi_bi=(sid_Vsbulk_si_Vsi_bi/(1.0+(2.0*Tempd))-(sid_Vsbulk_si*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vsbulk_si)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vsi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vsi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsbulk_si_Tempt_GND=(sid_Vsbulk_si_Tempt_GND/(1.0+(2.0*Tempd))-(sid_Vsbulk_si*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vsbulk_si)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Tempt_GND)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Tempt_GND))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#endif
T2_Vgi_bi=((sid_Vgi_bi*(1.0+(2.0*Tempd))-sid*(2.0*Tempd_Vgi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(0.0/(1.0+(2.0*Tempd))-(sid_Vgi_bi*(0.0)+0.0*(2.0*Tempd_Vgi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vgi_bi+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vgi_bi)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vgi_bi_Vgm_si=(0.0/(1.0+(2.0*Tempd))-(sid_Vgi_bi*(0.0)+0.0*(2.0*Tempd_Vgi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vgi_bi+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vgi_bi)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vgi_bi_Vdbulk_di=(sid_Vgi_bi_Vdbulk_di/(1.0+(2.0*Tempd))-(sid_Vgi_bi*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vgi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vdbulk_di)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vdbulk_di))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vgi_bi_Vsbulk_si=(sid_Vgi_bi_Vsbulk_si/(1.0+(2.0*Tempd))-(sid_Vgi_bi*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vgi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vsbulk_si)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vsbulk_si))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vgi_bi_Vgi_bi=(sid_Vgi_bi_Vgi_bi/(1.0+(2.0*Tempd))-(sid_Vgi_bi*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vgi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vgi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vgi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vgi_bi_Vdi_bi=(sid_Vgi_bi_Vdi_bi/(1.0+(2.0*Tempd))-(sid_Vgi_bi*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vgi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vdi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vdi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vgi_bi_Vsi_bi=(sid_Vgi_bi_Vsi_bi/(1.0+(2.0*Tempd))-(sid_Vgi_bi*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vgi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vsi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vsi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vgi_bi_Tempt_GND=(sid_Vgi_bi_Tempt_GND/(1.0+(2.0*Tempd))-(sid_Vgi_bi*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vgi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Tempt_GND)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Tempt_GND))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#endif
T2_Vdi_bi=((sid_Vdi_bi*(1.0+(2.0*Tempd))-sid*(2.0*Tempd_Vdi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(0.0/(1.0+(2.0*Tempd))-(sid_Vdi_bi*(0.0)+0.0*(2.0*Tempd_Vdi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vdi_bi+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdi_bi)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdi_bi_Vgm_si=(0.0/(1.0+(2.0*Tempd))-(sid_Vdi_bi*(0.0)+0.0*(2.0*Tempd_Vdi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vdi_bi+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdi_bi)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdi_bi_Vdbulk_di=(sid_Vdi_bi_Vdbulk_di/(1.0+(2.0*Tempd))-(sid_Vdi_bi*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vdi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vdbulk_di)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vdbulk_di))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdi_bi_Vsbulk_si=(sid_Vdi_bi_Vsbulk_si/(1.0+(2.0*Tempd))-(sid_Vdi_bi*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vdi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vsbulk_si)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vsbulk_si))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdi_bi_Vgi_bi=(sid_Vdi_bi_Vgi_bi/(1.0+(2.0*Tempd))-(sid_Vdi_bi*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vdi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vgi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vgi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdi_bi_Vdi_bi=(sid_Vdi_bi_Vdi_bi/(1.0+(2.0*Tempd))-(sid_Vdi_bi*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vdi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vdi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vdi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdi_bi_Vsi_bi=(sid_Vdi_bi_Vsi_bi/(1.0+(2.0*Tempd))-(sid_Vdi_bi*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vdi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vsi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vsi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vdi_bi_Tempt_GND=(sid_Vdi_bi_Tempt_GND/(1.0+(2.0*Tempd))-(sid_Vdi_bi*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vdi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Tempt_GND)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Tempt_GND))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#endif
T2_Vsi_bi=((sid_Vsi_bi*(1.0+(2.0*Tempd))-sid*(2.0*Tempd_Vsi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(0.0/(1.0+(2.0*Tempd))-(sid_Vsi_bi*(0.0)+0.0*(2.0*Tempd_Vsi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vsi_bi+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsi_bi)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsi_bi_Vgm_si=(0.0/(1.0+(2.0*Tempd))-(sid_Vsi_bi*(0.0)+0.0*(2.0*Tempd_Vsi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*0.0+0.0*Tempd_Vsi_bi+2.0*0.0)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsi_bi)*(0.0)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsi_bi_Vdbulk_di=(sid_Vsi_bi_Vdbulk_di/(1.0+(2.0*Tempd))-(sid_Vsi_bi*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vsi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vdbulk_di)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vdbulk_di))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsi_bi_Vsbulk_si=(sid_Vsi_bi_Vsbulk_si/(1.0+(2.0*Tempd))-(sid_Vsi_bi*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vsi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vsbulk_si)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vsbulk_si))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsi_bi_Vgi_bi=(sid_Vsi_bi_Vgi_bi/(1.0+(2.0*Tempd))-(sid_Vsi_bi*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vsi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vgi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vgi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsi_bi_Vdi_bi=(sid_Vsi_bi_Vdi_bi/(1.0+(2.0*Tempd))-(sid_Vsi_bi*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vsi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vdi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vdi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsi_bi_Vsi_bi=(sid_Vsi_bi_Vsi_bi/(1.0+(2.0*Tempd))-(sid_Vsi_bi*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vsi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vsi_bi)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vsi_bi))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
  T2_Vsi_bi_Tempt_GND=(sid_Vsi_bi_Tempt_GND/(1.0+(2.0*Tempd))-(sid_Vsi_bi*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vsi_bi)+sid*(+0.0+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Tempt_GND)))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))+2*sid*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Tempt_GND))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=((sid_Tempt_GND*(1.0+(2.0*Tempd))-sid*(2.0*Tempd_Tempt_GND))/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
#endif
#endif
T2=(sid/(1.0+(2.0*Tempd)));
EXIT_IF_ISNAN((sid/(1.0+(2.0*Tempd))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=(Temps_Vdbulk_di+Tempd_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+0.0+0.0);
  T3_Vdbulk_di_Vgm_di=(+0.0+0.0);
  T3_Vdbulk_di_Vdbulk_di=(+Temps_Vdbulk_di_Vdbulk_di+Tempd_Vdbulk_di_Vdbulk_di);
  T3_Vdbulk_di_Vsbulk_si=(+Temps_Vdbulk_di_Vsbulk_si+Tempd_Vdbulk_di_Vsbulk_si);
  T3_Vdbulk_di_Vgi_bi=(+Temps_Vdbulk_di_Vgi_bi+Tempd_Vdbulk_di_Vgi_bi);
  T3_Vdbulk_di_Vdi_bi=(+Temps_Vdbulk_di_Vdi_bi+Tempd_Vdbulk_di_Vdi_bi);
  T3_Vdbulk_di_Vsi_bi=(+Temps_Vdbulk_di_Vsi_bi+Tempd_Vdbulk_di_Vsi_bi);
  T3_Vdbulk_di_Tempt_GND=(+Temps_Vdbulk_di_Tempt_GND+Tempd_Vdbulk_di_Tempt_GND);
#endif
T3_Vsbulk_si=(Temps_Vsbulk_si+Tempd_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+0.0+0.0);
  T3_Vsbulk_si_Vgm_di=(+0.0+0.0);
  T3_Vsbulk_si_Vdbulk_di=(+Temps_Vsbulk_si_Vdbulk_di+Tempd_Vsbulk_si_Vdbulk_di);
  T3_Vsbulk_si_Vsbulk_si=(+Temps_Vsbulk_si_Vsbulk_si+Tempd_Vsbulk_si_Vsbulk_si);
  T3_Vsbulk_si_Vgi_bi=(+Temps_Vsbulk_si_Vgi_bi+Tempd_Vsbulk_si_Vgi_bi);
  T3_Vsbulk_si_Vdi_bi=(+Temps_Vsbulk_si_Vdi_bi+Tempd_Vsbulk_si_Vdi_bi);
  T3_Vsbulk_si_Vsi_bi=(+Temps_Vsbulk_si_Vsi_bi+Tempd_Vsbulk_si_Vsi_bi);
  T3_Vsbulk_si_Tempt_GND=(+Temps_Vsbulk_si_Tempt_GND+Tempd_Vsbulk_si_Tempt_GND);
#endif
T3_Vgi_bi=(Temps_Vgi_bi+Tempd_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+0.0+0.0);
  T3_Vgi_bi_Vgm_di=(+0.0+0.0);
  T3_Vgi_bi_Vdbulk_di=(+Temps_Vgi_bi_Vdbulk_di+Tempd_Vgi_bi_Vdbulk_di);
  T3_Vgi_bi_Vsbulk_si=(+Temps_Vgi_bi_Vsbulk_si+Tempd_Vgi_bi_Vsbulk_si);
  T3_Vgi_bi_Vgi_bi=(+Temps_Vgi_bi_Vgi_bi+Tempd_Vgi_bi_Vgi_bi);
  T3_Vgi_bi_Vdi_bi=(+Temps_Vgi_bi_Vdi_bi+Tempd_Vgi_bi_Vdi_bi);
  T3_Vgi_bi_Vsi_bi=(+Temps_Vgi_bi_Vsi_bi+Tempd_Vgi_bi_Vsi_bi);
  T3_Vgi_bi_Tempt_GND=(+Temps_Vgi_bi_Tempt_GND+Tempd_Vgi_bi_Tempt_GND);
#endif
T3_Vdi_bi=(Temps_Vdi_bi+Tempd_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+0.0+0.0);
  T3_Vdi_bi_Vgm_di=(+0.0+0.0);
  T3_Vdi_bi_Vdbulk_di=(+Temps_Vdi_bi_Vdbulk_di+Tempd_Vdi_bi_Vdbulk_di);
  T3_Vdi_bi_Vsbulk_si=(+Temps_Vdi_bi_Vsbulk_si+Tempd_Vdi_bi_Vsbulk_si);
  T3_Vdi_bi_Vgi_bi=(+Temps_Vdi_bi_Vgi_bi+Tempd_Vdi_bi_Vgi_bi);
  T3_Vdi_bi_Vdi_bi=(+Temps_Vdi_bi_Vdi_bi+Tempd_Vdi_bi_Vdi_bi);
  T3_Vdi_bi_Vsi_bi=(+Temps_Vdi_bi_Vsi_bi+Tempd_Vdi_bi_Vsi_bi);
  T3_Vdi_bi_Tempt_GND=(+Temps_Vdi_bi_Tempt_GND+Tempd_Vdi_bi_Tempt_GND);
#endif
T3_Vsi_bi=(Temps_Vsi_bi+Tempd_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+0.0+0.0);
  T3_Vsi_bi_Vgm_di=(+0.0+0.0);
  T3_Vsi_bi_Vdbulk_di=(+Temps_Vsi_bi_Vdbulk_di+Tempd_Vsi_bi_Vdbulk_di);
  T3_Vsi_bi_Vsbulk_si=(+Temps_Vsi_bi_Vsbulk_si+Tempd_Vsi_bi_Vsbulk_si);
  T3_Vsi_bi_Vgi_bi=(+Temps_Vsi_bi_Vgi_bi+Tempd_Vsi_bi_Vgi_bi);
  T3_Vsi_bi_Vdi_bi=(+Temps_Vsi_bi_Vdi_bi+Tempd_Vsi_bi_Vdi_bi);
  T3_Vsi_bi_Vsi_bi=(+Temps_Vsi_bi_Vsi_bi+Tempd_Vsi_bi_Vsi_bi);
  T3_Vsi_bi_Tempt_GND=(+Temps_Vsi_bi_Tempt_GND+Tempd_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(Temps_Tempt_GND+Tempd_Tempt_GND);
#endif
#endif
T3=(Temps+Tempd);
EXIT_IF_ISNAN((Temps+Tempd))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=(0.33333333333333333*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3)));
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vdbulk_di*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))+0.0*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))+DQSD2*(+(+T3_Vdbulk_di_Vgm_si*T3+T3_Vdbulk_di*T3_Vgm_si+T3_Vgm_si*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vgm_si)*T3+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3_Vgm_si+(((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3_Vdbulk_di+(T3*T3)*T3_Vdbulk_di_Vgm_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdbulk_di_Vgm_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vdbulk_di*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))+0.0*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))+DQSD2*(+(+T3_Vdbulk_di_Vgm_di*T3+T3_Vdbulk_di*T3_Vgm_di+T3_Vgm_di*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vgm_di)*T3+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3_Vgm_di+(((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3_Vdbulk_di+(T3*T3)*T3_Vdbulk_di_Vgm_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdbulk_di_Vdbulk_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdbulk_di_Vdbulk_di/((T3*T3)*T3)-(DQSD2_Vdbulk_di*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))+DQSD2_Vdbulk_di*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))+DQSD2*(+(+T3_Vdbulk_di_Vdbulk_di*T3+T3_Vdbulk_di*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vdbulk_di)*T3+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3_Vdbulk_di+(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3_Vdbulk_di+(T3*T3)*T3_Vdbulk_di_Vdbulk_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdbulk_di_Vsbulk_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdbulk_di_Vsbulk_si/((T3*T3)*T3)-(DQSD2_Vdbulk_di*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))+DQSD2_Vsbulk_si*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))+DQSD2*(+(+T3_Vdbulk_di_Vsbulk_si*T3+T3_Vdbulk_di*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vsbulk_si)*T3+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3_Vsbulk_si+(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3_Vdbulk_di+(T3*T3)*T3_Vdbulk_di_Vsbulk_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdbulk_di_Vgi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdbulk_di_Vgi_bi/((T3*T3)*T3)-(DQSD2_Vdbulk_di*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))+DQSD2_Vgi_bi*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))+DQSD2*(+(+T3_Vdbulk_di_Vgi_bi*T3+T3_Vdbulk_di*T3_Vgi_bi+T3_Vgi_bi*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vgi_bi)*T3+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3_Vgi_bi+(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3_Vdbulk_di+(T3*T3)*T3_Vdbulk_di_Vgi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdbulk_di_Vdi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdbulk_di_Vdi_bi/((T3*T3)*T3)-(DQSD2_Vdbulk_di*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))+DQSD2_Vdi_bi*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))+DQSD2*(+(+T3_Vdbulk_di_Vdi_bi*T3+T3_Vdbulk_di*T3_Vdi_bi+T3_Vdi_bi*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vdi_bi)*T3+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3_Vdi_bi+(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3_Vdbulk_di+(T3*T3)*T3_Vdbulk_di_Vdi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdbulk_di_Vsi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdbulk_di_Vsi_bi/((T3*T3)*T3)-(DQSD2_Vdbulk_di*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))+DQSD2_Vsi_bi*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))+DQSD2*(+(+T3_Vdbulk_di_Vsi_bi*T3+T3_Vdbulk_di*T3_Vsi_bi+T3_Vsi_bi*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vsi_bi)*T3+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3_Vsi_bi+(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3_Vdbulk_di+(T3*T3)*T3_Vdbulk_di_Vsi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdbulk_di_Tempt_GND=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Tempt_GND*((T3*T3)*T3)-DQSD2*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdbulk_di_Tempt_GND/((T3*T3)*T3)-(DQSD2_Vdbulk_di*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))+DQSD2_Tempt_GND*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))+DQSD2*(+(+T3_Vdbulk_di_Tempt_GND*T3+T3_Vdbulk_di*T3_Tempt_GND+T3_Tempt_GND*T3_Vdbulk_di+T3*T3_Vdbulk_di_Tempt_GND)*T3+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3_Tempt_GND+(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3_Vdbulk_di+(T3*T3)*T3_Vdbulk_di_Tempt_GND))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))*T3)+((T3*T3)*T3_Vdbulk_di))*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
#endif
T4_Vsbulk_si=(0.33333333333333333*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3)));
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vsbulk_si*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))+0.0*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))+DQSD2*(+(+T3_Vsbulk_si_Vgm_si*T3+T3_Vsbulk_si*T3_Vgm_si+T3_Vgm_si*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vgm_si)*T3+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3_Vgm_si+(((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3_Vsbulk_si+(T3*T3)*T3_Vsbulk_si_Vgm_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsbulk_si_Vgm_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vsbulk_si*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))+0.0*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))+DQSD2*(+(+T3_Vsbulk_si_Vgm_di*T3+T3_Vsbulk_si*T3_Vgm_di+T3_Vgm_di*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vgm_di)*T3+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3_Vgm_di+(((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3_Vsbulk_si+(T3*T3)*T3_Vsbulk_si_Vgm_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsbulk_si_Vdbulk_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsbulk_si_Vdbulk_di/((T3*T3)*T3)-(DQSD2_Vsbulk_si*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))+DQSD2_Vdbulk_di*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))+DQSD2*(+(+T3_Vsbulk_si_Vdbulk_di*T3+T3_Vsbulk_si*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vdbulk_di)*T3+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3_Vdbulk_di+(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3_Vsbulk_si+(T3*T3)*T3_Vsbulk_si_Vdbulk_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsbulk_si_Vsbulk_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsbulk_si_Vsbulk_si/((T3*T3)*T3)-(DQSD2_Vsbulk_si*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))+DQSD2_Vsbulk_si*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))+DQSD2*(+(+T3_Vsbulk_si_Vsbulk_si*T3+T3_Vsbulk_si*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vsbulk_si)*T3+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3_Vsbulk_si+(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3_Vsbulk_si+(T3*T3)*T3_Vsbulk_si_Vsbulk_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsbulk_si_Vgi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsbulk_si_Vgi_bi/((T3*T3)*T3)-(DQSD2_Vsbulk_si*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))+DQSD2_Vgi_bi*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))+DQSD2*(+(+T3_Vsbulk_si_Vgi_bi*T3+T3_Vsbulk_si*T3_Vgi_bi+T3_Vgi_bi*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vgi_bi)*T3+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3_Vgi_bi+(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3_Vsbulk_si+(T3*T3)*T3_Vsbulk_si_Vgi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsbulk_si_Vdi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsbulk_si_Vdi_bi/((T3*T3)*T3)-(DQSD2_Vsbulk_si*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))+DQSD2_Vdi_bi*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))+DQSD2*(+(+T3_Vsbulk_si_Vdi_bi*T3+T3_Vsbulk_si*T3_Vdi_bi+T3_Vdi_bi*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vdi_bi)*T3+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3_Vdi_bi+(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3_Vsbulk_si+(T3*T3)*T3_Vsbulk_si_Vdi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsbulk_si_Vsi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsbulk_si_Vsi_bi/((T3*T3)*T3)-(DQSD2_Vsbulk_si*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))+DQSD2_Vsi_bi*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))+DQSD2*(+(+T3_Vsbulk_si_Vsi_bi*T3+T3_Vsbulk_si*T3_Vsi_bi+T3_Vsi_bi*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vsi_bi)*T3+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3_Vsi_bi+(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3_Vsbulk_si+(T3*T3)*T3_Vsbulk_si_Vsi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsbulk_si_Tempt_GND=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Tempt_GND*((T3*T3)*T3)-DQSD2*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsbulk_si_Tempt_GND/((T3*T3)*T3)-(DQSD2_Vsbulk_si*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))+DQSD2_Tempt_GND*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))+DQSD2*(+(+T3_Vsbulk_si_Tempt_GND*T3+T3_Vsbulk_si*T3_Tempt_GND+T3_Tempt_GND*T3_Vsbulk_si+T3*T3_Vsbulk_si_Tempt_GND)*T3+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3_Tempt_GND+(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3_Vsbulk_si+(T3*T3)*T3_Vsbulk_si_Tempt_GND))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))*T3)+((T3*T3)*T3_Vsbulk_si))*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
#endif
T4_Vgi_bi=(0.33333333333333333*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)));
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vgi_bi*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))+0.0*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))+DQSD2*(+(+T3_Vgi_bi_Vgm_si*T3+T3_Vgi_bi*T3_Vgm_si+T3_Vgm_si*T3_Vgi_bi+T3*T3_Vgi_bi_Vgm_si)*T3+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3_Vgm_si+(((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3_Vgi_bi+(T3*T3)*T3_Vgi_bi_Vgm_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vgi_bi_Vgm_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vgi_bi*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))+0.0*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))+DQSD2*(+(+T3_Vgi_bi_Vgm_di*T3+T3_Vgi_bi*T3_Vgm_di+T3_Vgm_di*T3_Vgi_bi+T3*T3_Vgi_bi_Vgm_di)*T3+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3_Vgm_di+(((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3_Vgi_bi+(T3*T3)*T3_Vgi_bi_Vgm_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vgi_bi_Vdbulk_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vgi_bi_Vdbulk_di/((T3*T3)*T3)-(DQSD2_Vgi_bi*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))+DQSD2_Vdbulk_di*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))+DQSD2*(+(+T3_Vgi_bi_Vdbulk_di*T3+T3_Vgi_bi*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vgi_bi+T3*T3_Vgi_bi_Vdbulk_di)*T3+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3_Vdbulk_di+(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3_Vgi_bi+(T3*T3)*T3_Vgi_bi_Vdbulk_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vgi_bi_Vsbulk_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vgi_bi_Vsbulk_si/((T3*T3)*T3)-(DQSD2_Vgi_bi*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))+DQSD2_Vsbulk_si*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))+DQSD2*(+(+T3_Vgi_bi_Vsbulk_si*T3+T3_Vgi_bi*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vgi_bi+T3*T3_Vgi_bi_Vsbulk_si)*T3+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3_Vsbulk_si+(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3_Vgi_bi+(T3*T3)*T3_Vgi_bi_Vsbulk_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vgi_bi_Vgi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vgi_bi_Vgi_bi/((T3*T3)*T3)-(DQSD2_Vgi_bi*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))+DQSD2_Vgi_bi*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))+DQSD2*(+(+T3_Vgi_bi_Vgi_bi*T3+T3_Vgi_bi*T3_Vgi_bi+T3_Vgi_bi*T3_Vgi_bi+T3*T3_Vgi_bi_Vgi_bi)*T3+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3_Vgi_bi+(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3_Vgi_bi+(T3*T3)*T3_Vgi_bi_Vgi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vgi_bi_Vdi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vgi_bi_Vdi_bi/((T3*T3)*T3)-(DQSD2_Vgi_bi*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))+DQSD2_Vdi_bi*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))+DQSD2*(+(+T3_Vgi_bi_Vdi_bi*T3+T3_Vgi_bi*T3_Vdi_bi+T3_Vdi_bi*T3_Vgi_bi+T3*T3_Vgi_bi_Vdi_bi)*T3+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3_Vdi_bi+(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3_Vgi_bi+(T3*T3)*T3_Vgi_bi_Vdi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vgi_bi_Vsi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vgi_bi_Vsi_bi/((T3*T3)*T3)-(DQSD2_Vgi_bi*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))+DQSD2_Vsi_bi*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))+DQSD2*(+(+T3_Vgi_bi_Vsi_bi*T3+T3_Vgi_bi*T3_Vsi_bi+T3_Vsi_bi*T3_Vgi_bi+T3*T3_Vgi_bi_Vsi_bi)*T3+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3_Vsi_bi+(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3_Vgi_bi+(T3*T3)*T3_Vgi_bi_Vsi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vgi_bi_Tempt_GND=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Tempt_GND*((T3*T3)*T3)-DQSD2*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vgi_bi_Tempt_GND/((T3*T3)*T3)-(DQSD2_Vgi_bi*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))+DQSD2_Tempt_GND*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))+DQSD2*(+(+T3_Vgi_bi_Tempt_GND*T3+T3_Vgi_bi*T3_Tempt_GND+T3_Tempt_GND*T3_Vgi_bi+T3*T3_Vgi_bi_Tempt_GND)*T3+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3_Tempt_GND+(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3_Vgi_bi+(T3*T3)*T3_Vgi_bi_Tempt_GND))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))*T3)+((T3*T3)*T3_Vgi_bi))*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
#endif
T4_Vdi_bi=(0.33333333333333333*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)));
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vdi_bi*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))+0.0*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))+DQSD2*(+(+T3_Vdi_bi_Vgm_si*T3+T3_Vdi_bi*T3_Vgm_si+T3_Vgm_si*T3_Vdi_bi+T3*T3_Vdi_bi_Vgm_si)*T3+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3_Vgm_si+(((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3_Vdi_bi+(T3*T3)*T3_Vdi_bi_Vgm_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdi_bi_Vgm_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vdi_bi*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))+0.0*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))+DQSD2*(+(+T3_Vdi_bi_Vgm_di*T3+T3_Vdi_bi*T3_Vgm_di+T3_Vgm_di*T3_Vdi_bi+T3*T3_Vdi_bi_Vgm_di)*T3+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3_Vgm_di+(((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3_Vdi_bi+(T3*T3)*T3_Vdi_bi_Vgm_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdi_bi_Vdbulk_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdi_bi_Vdbulk_di/((T3*T3)*T3)-(DQSD2_Vdi_bi*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))+DQSD2_Vdbulk_di*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))+DQSD2*(+(+T3_Vdi_bi_Vdbulk_di*T3+T3_Vdi_bi*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vdi_bi+T3*T3_Vdi_bi_Vdbulk_di)*T3+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3_Vdbulk_di+(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3_Vdi_bi+(T3*T3)*T3_Vdi_bi_Vdbulk_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdi_bi_Vsbulk_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdi_bi_Vsbulk_si/((T3*T3)*T3)-(DQSD2_Vdi_bi*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))+DQSD2_Vsbulk_si*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))+DQSD2*(+(+T3_Vdi_bi_Vsbulk_si*T3+T3_Vdi_bi*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vdi_bi+T3*T3_Vdi_bi_Vsbulk_si)*T3+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3_Vsbulk_si+(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3_Vdi_bi+(T3*T3)*T3_Vdi_bi_Vsbulk_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdi_bi_Vgi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdi_bi_Vgi_bi/((T3*T3)*T3)-(DQSD2_Vdi_bi*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))+DQSD2_Vgi_bi*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))+DQSD2*(+(+T3_Vdi_bi_Vgi_bi*T3+T3_Vdi_bi*T3_Vgi_bi+T3_Vgi_bi*T3_Vdi_bi+T3*T3_Vdi_bi_Vgi_bi)*T3+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3_Vgi_bi+(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3_Vdi_bi+(T3*T3)*T3_Vdi_bi_Vgi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdi_bi_Vdi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdi_bi_Vdi_bi/((T3*T3)*T3)-(DQSD2_Vdi_bi*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))+DQSD2_Vdi_bi*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))+DQSD2*(+(+T3_Vdi_bi_Vdi_bi*T3+T3_Vdi_bi*T3_Vdi_bi+T3_Vdi_bi*T3_Vdi_bi+T3*T3_Vdi_bi_Vdi_bi)*T3+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3_Vdi_bi+(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3_Vdi_bi+(T3*T3)*T3_Vdi_bi_Vdi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdi_bi_Vsi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdi_bi_Vsi_bi/((T3*T3)*T3)-(DQSD2_Vdi_bi*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))+DQSD2_Vsi_bi*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))+DQSD2*(+(+T3_Vdi_bi_Vsi_bi*T3+T3_Vdi_bi*T3_Vsi_bi+T3_Vsi_bi*T3_Vdi_bi+T3*T3_Vdi_bi_Vsi_bi)*T3+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3_Vsi_bi+(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3_Vdi_bi+(T3*T3)*T3_Vdi_bi_Vsi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vdi_bi_Tempt_GND=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Tempt_GND*((T3*T3)*T3)-DQSD2*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vdi_bi_Tempt_GND/((T3*T3)*T3)-(DQSD2_Vdi_bi*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))+DQSD2_Tempt_GND*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))+DQSD2*(+(+T3_Vdi_bi_Tempt_GND*T3+T3_Vdi_bi*T3_Tempt_GND+T3_Tempt_GND*T3_Vdi_bi+T3*T3_Vdi_bi_Tempt_GND)*T3+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3_Tempt_GND+(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3_Vdi_bi+(T3*T3)*T3_Vdi_bi_Tempt_GND))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))*T3)+((T3*T3)*T3_Vdi_bi))*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
#endif
T4_Vsi_bi=(0.33333333333333333*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)));
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vsi_bi*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))+0.0*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))+DQSD2*(+(+T3_Vsi_bi_Vgm_si*T3+T3_Vsi_bi*T3_Vgm_si+T3_Vgm_si*T3_Vsi_bi+T3*T3_Vsi_bi_Vgm_si)*T3+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3_Vgm_si+(((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3_Vsi_bi+(T3*T3)*T3_Vsi_bi_Vgm_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))*((((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))*T3)+((T3*T3)*T3_Vgm_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsi_bi_Vgm_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*(-DQSD2*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(0.0/((T3*T3)*T3)-(DQSD2_Vsi_bi*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))+0.0*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))+DQSD2*(+(+T3_Vsi_bi_Vgm_di*T3+T3_Vsi_bi*T3_Vgm_di+T3_Vgm_di*T3_Vsi_bi+T3*T3_Vsi_bi_Vgm_di)*T3+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3_Vgm_di+(((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3_Vsi_bi+(T3*T3)*T3_Vsi_bi_Vgm_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))*((((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))*T3)+((T3*T3)*T3_Vgm_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsi_bi_Vdbulk_di=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdbulk_di*((T3*T3)*T3)-DQSD2*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsi_bi_Vdbulk_di/((T3*T3)*T3)-(DQSD2_Vsi_bi*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))+DQSD2_Vdbulk_di*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))+DQSD2*(+(+T3_Vsi_bi_Vdbulk_di*T3+T3_Vsi_bi*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vsi_bi+T3*T3_Vsi_bi_Vdbulk_di)*T3+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3_Vdbulk_di+(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3_Vsi_bi+(T3*T3)*T3_Vsi_bi_Vdbulk_di))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))*((((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))*T3)+((T3*T3)*T3_Vdbulk_di)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsi_bi_Vsbulk_si=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsbulk_si*((T3*T3)*T3)-DQSD2*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsi_bi_Vsbulk_si/((T3*T3)*T3)-(DQSD2_Vsi_bi*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))+DQSD2_Vsbulk_si*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))+DQSD2*(+(+T3_Vsi_bi_Vsbulk_si*T3+T3_Vsi_bi*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vsi_bi+T3*T3_Vsi_bi_Vsbulk_si)*T3+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3_Vsbulk_si+(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3_Vsi_bi+(T3*T3)*T3_Vsi_bi_Vsbulk_si))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))*((((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))*T3)+((T3*T3)*T3_Vsbulk_si)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsi_bi_Vgi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vgi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsi_bi_Vgi_bi/((T3*T3)*T3)-(DQSD2_Vsi_bi*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))+DQSD2_Vgi_bi*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))+DQSD2*(+(+T3_Vsi_bi_Vgi_bi*T3+T3_Vsi_bi*T3_Vgi_bi+T3_Vgi_bi*T3_Vsi_bi+T3*T3_Vsi_bi_Vgi_bi)*T3+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3_Vgi_bi+(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3_Vsi_bi+(T3*T3)*T3_Vsi_bi_Vgi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))*((((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))*T3)+((T3*T3)*T3_Vgi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsi_bi_Vdi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vdi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsi_bi_Vdi_bi/((T3*T3)*T3)-(DQSD2_Vsi_bi*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))+DQSD2_Vdi_bi*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))+DQSD2*(+(+T3_Vsi_bi_Vdi_bi*T3+T3_Vsi_bi*T3_Vdi_bi+T3_Vdi_bi*T3_Vsi_bi+T3*T3_Vsi_bi_Vdi_bi)*T3+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3_Vdi_bi+(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3_Vsi_bi+(T3*T3)*T3_Vsi_bi_Vdi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))*((((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))*T3)+((T3*T3)*T3_Vdi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsi_bi_Vsi_bi=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsi_bi_Vsi_bi/((T3*T3)*T3)-(DQSD2_Vsi_bi*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))+DQSD2_Vsi_bi*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))+DQSD2*(+(+T3_Vsi_bi_Vsi_bi*T3+T3_Vsi_bi*T3_Vsi_bi+T3_Vsi_bi*T3_Vsi_bi+T3*T3_Vsi_bi_Vsi_bi)*T3+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3_Vsi_bi+(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3_Vsi_bi+(T3*T3)*T3_Vsi_bi_Vsi_bi))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))*((((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
  T4_Vsi_bi_Tempt_GND=(+0.0*(DQSD2/((T3*T3)*T3))+0.0*((DQSD2_Tempt_GND*((T3*T3)*T3)-DQSD2*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND))))/((T3*T3)*T3)/((T3*T3)*T3))+0.0*((DQSD2_Vsi_bi*((T3*T3)*T3)-DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi)))/((T3*T3)*T3)/((T3*T3)*T3))+0.33333333333333333*(DQSD2_Vsi_bi_Tempt_GND/((T3*T3)*T3)-(DQSD2_Vsi_bi*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))+DQSD2_Tempt_GND*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))+DQSD2*(+(+T3_Vsi_bi_Tempt_GND*T3+T3_Vsi_bi*T3_Tempt_GND+T3_Tempt_GND*T3_Vsi_bi+T3*T3_Vsi_bi_Tempt_GND)*T3+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3_Tempt_GND+(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3_Vsi_bi+(T3*T3)*T3_Vsi_bi_Tempt_GND))/((T3*T3)*T3)/((T3*T3)*T3)+2*DQSD2*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))*T3)+((T3*T3)*T3_Vsi_bi))*((((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))*T3)+((T3*T3)*T3_Tempt_GND)))/((T3*T3)*T3)/((T3*T3)*T3)/((T3*T3)*T3)));
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(0.33333333333333333*((DQSD2_Tempt_GND*((T3*T3)*T3)-DQSD2*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))*T3)+((T3*T3)*T3_Tempt_GND)))/((T3*T3)*T3)/((T3*T3)*T3)));
#endif
#endif
T4=(0.33333333333333333*(DQSD2/((T3*T3)*T3)));
EXIT_IF_ISNAN((0.33333333333333333*(DQSD2/((T3*T3)*T3))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=((((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di))*((1.0+qs)+qdeff)-(Dvsat*inv_MdL)*(qs_Vdbulk_di+qdeff_Vdbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=((+0.0*inv_MdL+Dvsat_Vdbulk_di*0.0+0.0*inv_MdL_Vdbulk_di+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di))*(qs_Vgm_si+qdeff_Vgm_si)+(0.0)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdbulk_di_Vgm_si)+qdeff_Vdbulk_di_Vgm_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdbulk_di+qdeff_Vdbulk_di)*(qs_Vgm_si+qdeff_Vgm_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdbulk_di_Vgm_di=((+0.0*inv_MdL+Dvsat_Vdbulk_di*0.0+0.0*inv_MdL_Vdbulk_di+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di))*(qs_Vgm_di+qdeff_Vgm_di)+(0.0)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdbulk_di_Vgm_di)+qdeff_Vdbulk_di_Vgm_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdbulk_di+qdeff_Vdbulk_di)*(qs_Vgm_di+qdeff_Vgm_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdbulk_di_Vdbulk_di=((+Dvsat_Vdbulk_di_Vdbulk_di*inv_MdL+Dvsat_Vdbulk_di*inv_MdL_Vdbulk_di+Dvsat_Vdbulk_di*inv_MdL_Vdbulk_di+Dvsat*inv_MdL_Vdbulk_di_Vdbulk_di)/((1.0+qs)+qdeff)-(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di)))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdbulk_di_Vdbulk_di)+qdeff_Vdbulk_di_Vdbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdbulk_di+qdeff_Vdbulk_di)*(qs_Vdbulk_di+qdeff_Vdbulk_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdbulk_di_Vsbulk_si=((+Dvsat_Vdbulk_di_Vsbulk_si*inv_MdL+Dvsat_Vdbulk_di*inv_MdL_Vsbulk_si+Dvsat_Vsbulk_si*inv_MdL_Vdbulk_di+Dvsat*inv_MdL_Vdbulk_di_Vsbulk_si)/((1.0+qs)+qdeff)-(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si)))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdbulk_di_Vsbulk_si)+qdeff_Vdbulk_di_Vsbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdbulk_di+qdeff_Vdbulk_di)*(qs_Vsbulk_si+qdeff_Vsbulk_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdbulk_di_Vgi_bi=((+Dvsat_Vdbulk_di_Vgi_bi*inv_MdL+Dvsat_Vdbulk_di*inv_MdL_Vgi_bi+Dvsat_Vgi_bi*inv_MdL_Vdbulk_di+Dvsat*inv_MdL_Vdbulk_di_Vgi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di))*(qs_Vgi_bi+qdeff_Vgi_bi)+(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi)))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdbulk_di_Vgi_bi)+qdeff_Vdbulk_di_Vgi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdbulk_di+qdeff_Vdbulk_di)*(qs_Vgi_bi+qdeff_Vgi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdbulk_di_Vdi_bi=((+Dvsat_Vdbulk_di_Vdi_bi*inv_MdL+Dvsat_Vdbulk_di*inv_MdL_Vdi_bi+Dvsat_Vdi_bi*inv_MdL_Vdbulk_di+Dvsat*inv_MdL_Vdbulk_di_Vdi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di))*(qs_Vdi_bi+qdeff_Vdi_bi)+(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi)))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdbulk_di_Vdi_bi)+qdeff_Vdbulk_di_Vdi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdbulk_di+qdeff_Vdbulk_di)*(qs_Vdi_bi+qdeff_Vdi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdbulk_di_Vsi_bi=((+Dvsat_Vdbulk_di_Vsi_bi*inv_MdL+Dvsat_Vdbulk_di*inv_MdL_Vsi_bi+Dvsat_Vsi_bi*inv_MdL_Vdbulk_di+Dvsat*inv_MdL_Vdbulk_di_Vsi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di))*(qs_Vsi_bi+qdeff_Vsi_bi)+(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi)))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdbulk_di_Vsi_bi)+qdeff_Vdbulk_di_Vsi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdbulk_di+qdeff_Vdbulk_di)*(qs_Vsi_bi+qdeff_Vsi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdbulk_di_Tempt_GND=((+Dvsat_Vdbulk_di_Tempt_GND*inv_MdL+Dvsat_Vdbulk_di*inv_MdL_Tempt_GND+Dvsat_Tempt_GND*inv_MdL_Vdbulk_di+Dvsat*inv_MdL_Vdbulk_di_Tempt_GND)/((1.0+qs)+qdeff)-(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di))*(qs_Tempt_GND+qdeff_Tempt_GND)+(((Dvsat_Tempt_GND*inv_MdL)+(Dvsat*inv_MdL_Tempt_GND)))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdbulk_di_Tempt_GND)+qdeff_Vdbulk_di_Tempt_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdbulk_di+qdeff_Vdbulk_di)*(qs_Tempt_GND+qdeff_Tempt_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
T5_Vsbulk_si=((((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si))*((1.0+qs)+qdeff)-(Dvsat*inv_MdL)*(qs_Vsbulk_si+qdeff_Vsbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=((+0.0*inv_MdL+Dvsat_Vsbulk_si*0.0+0.0*inv_MdL_Vsbulk_si+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si))*(qs_Vgm_si+qdeff_Vgm_si)+(0.0)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsbulk_si_Vgm_si)+qdeff_Vsbulk_si_Vgm_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsbulk_si+qdeff_Vsbulk_si)*(qs_Vgm_si+qdeff_Vgm_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsbulk_si_Vgm_di=((+0.0*inv_MdL+Dvsat_Vsbulk_si*0.0+0.0*inv_MdL_Vsbulk_si+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si))*(qs_Vgm_di+qdeff_Vgm_di)+(0.0)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsbulk_si_Vgm_di)+qdeff_Vsbulk_si_Vgm_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsbulk_si+qdeff_Vsbulk_si)*(qs_Vgm_di+qdeff_Vgm_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsbulk_si_Vdbulk_di=((+Dvsat_Vsbulk_si_Vdbulk_di*inv_MdL+Dvsat_Vsbulk_si*inv_MdL_Vdbulk_di+Dvsat_Vdbulk_di*inv_MdL_Vsbulk_si+Dvsat*inv_MdL_Vsbulk_si_Vdbulk_di)/((1.0+qs)+qdeff)-(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di)))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsbulk_si_Vdbulk_di)+qdeff_Vsbulk_si_Vdbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsbulk_si+qdeff_Vsbulk_si)*(qs_Vdbulk_di+qdeff_Vdbulk_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsbulk_si_Vsbulk_si=((+Dvsat_Vsbulk_si_Vsbulk_si*inv_MdL+Dvsat_Vsbulk_si*inv_MdL_Vsbulk_si+Dvsat_Vsbulk_si*inv_MdL_Vsbulk_si+Dvsat*inv_MdL_Vsbulk_si_Vsbulk_si)/((1.0+qs)+qdeff)-(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si)))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsbulk_si_Vsbulk_si)+qdeff_Vsbulk_si_Vsbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsbulk_si+qdeff_Vsbulk_si)*(qs_Vsbulk_si+qdeff_Vsbulk_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsbulk_si_Vgi_bi=((+Dvsat_Vsbulk_si_Vgi_bi*inv_MdL+Dvsat_Vsbulk_si*inv_MdL_Vgi_bi+Dvsat_Vgi_bi*inv_MdL_Vsbulk_si+Dvsat*inv_MdL_Vsbulk_si_Vgi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si))*(qs_Vgi_bi+qdeff_Vgi_bi)+(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi)))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsbulk_si_Vgi_bi)+qdeff_Vsbulk_si_Vgi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsbulk_si+qdeff_Vsbulk_si)*(qs_Vgi_bi+qdeff_Vgi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsbulk_si_Vdi_bi=((+Dvsat_Vsbulk_si_Vdi_bi*inv_MdL+Dvsat_Vsbulk_si*inv_MdL_Vdi_bi+Dvsat_Vdi_bi*inv_MdL_Vsbulk_si+Dvsat*inv_MdL_Vsbulk_si_Vdi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si))*(qs_Vdi_bi+qdeff_Vdi_bi)+(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi)))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsbulk_si_Vdi_bi)+qdeff_Vsbulk_si_Vdi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsbulk_si+qdeff_Vsbulk_si)*(qs_Vdi_bi+qdeff_Vdi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsbulk_si_Vsi_bi=((+Dvsat_Vsbulk_si_Vsi_bi*inv_MdL+Dvsat_Vsbulk_si*inv_MdL_Vsi_bi+Dvsat_Vsi_bi*inv_MdL_Vsbulk_si+Dvsat*inv_MdL_Vsbulk_si_Vsi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si))*(qs_Vsi_bi+qdeff_Vsi_bi)+(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi)))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsbulk_si_Vsi_bi)+qdeff_Vsbulk_si_Vsi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsbulk_si+qdeff_Vsbulk_si)*(qs_Vsi_bi+qdeff_Vsi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsbulk_si_Tempt_GND=((+Dvsat_Vsbulk_si_Tempt_GND*inv_MdL+Dvsat_Vsbulk_si*inv_MdL_Tempt_GND+Dvsat_Tempt_GND*inv_MdL_Vsbulk_si+Dvsat*inv_MdL_Vsbulk_si_Tempt_GND)/((1.0+qs)+qdeff)-(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si))*(qs_Tempt_GND+qdeff_Tempt_GND)+(((Dvsat_Tempt_GND*inv_MdL)+(Dvsat*inv_MdL_Tempt_GND)))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsbulk_si_Tempt_GND)+qdeff_Vsbulk_si_Tempt_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsbulk_si+qdeff_Vsbulk_si)*(qs_Tempt_GND+qdeff_Tempt_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
T5_Vgi_bi=((((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi))*((1.0+qs)+qdeff)-(Dvsat*inv_MdL)*(qs_Vgi_bi+qdeff_Vgi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=((+0.0*inv_MdL+Dvsat_Vgi_bi*0.0+0.0*inv_MdL_Vgi_bi+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi))*(qs_Vgm_si+qdeff_Vgm_si)+(0.0)*(qs_Vgi_bi+qdeff_Vgi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vgi_bi_Vgm_si)+qdeff_Vgi_bi_Vgm_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vgm_si+qdeff_Vgm_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vgi_bi_Vgm_di=((+0.0*inv_MdL+Dvsat_Vgi_bi*0.0+0.0*inv_MdL_Vgi_bi+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi))*(qs_Vgm_di+qdeff_Vgm_di)+(0.0)*(qs_Vgi_bi+qdeff_Vgi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vgi_bi_Vgm_di)+qdeff_Vgi_bi_Vgm_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vgm_di+qdeff_Vgm_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vgi_bi_Vdbulk_di=((+Dvsat_Vgi_bi_Vdbulk_di*inv_MdL+Dvsat_Vgi_bi*inv_MdL_Vdbulk_di+Dvsat_Vdbulk_di*inv_MdL_Vgi_bi+Dvsat*inv_MdL_Vgi_bi_Vdbulk_di)/((1.0+qs)+qdeff)-(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vgi_bi_Vdbulk_di)+qdeff_Vgi_bi_Vdbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vgi_bi_Vsbulk_si=((+Dvsat_Vgi_bi_Vsbulk_si*inv_MdL+Dvsat_Vgi_bi*inv_MdL_Vsbulk_si+Dvsat_Vsbulk_si*inv_MdL_Vgi_bi+Dvsat*inv_MdL_Vgi_bi_Vsbulk_si)/((1.0+qs)+qdeff)-(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vgi_bi_Vsbulk_si)+qdeff_Vgi_bi_Vsbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vgi_bi_Vgi_bi=((+Dvsat_Vgi_bi_Vgi_bi*inv_MdL+Dvsat_Vgi_bi*inv_MdL_Vgi_bi+Dvsat_Vgi_bi*inv_MdL_Vgi_bi+Dvsat*inv_MdL_Vgi_bi_Vgi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi))*(qs_Vgi_bi+qdeff_Vgi_bi)+(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vgi_bi_Vgi_bi)+qdeff_Vgi_bi_Vgi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vgi_bi_Vdi_bi=((+Dvsat_Vgi_bi_Vdi_bi*inv_MdL+Dvsat_Vgi_bi*inv_MdL_Vdi_bi+Dvsat_Vdi_bi*inv_MdL_Vgi_bi+Dvsat*inv_MdL_Vgi_bi_Vdi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi))*(qs_Vdi_bi+qdeff_Vdi_bi)+(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vgi_bi_Vdi_bi)+qdeff_Vgi_bi_Vdi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vgi_bi_Vsi_bi=((+Dvsat_Vgi_bi_Vsi_bi*inv_MdL+Dvsat_Vgi_bi*inv_MdL_Vsi_bi+Dvsat_Vsi_bi*inv_MdL_Vgi_bi+Dvsat*inv_MdL_Vgi_bi_Vsi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi))*(qs_Vsi_bi+qdeff_Vsi_bi)+(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vgi_bi_Vsi_bi)+qdeff_Vgi_bi_Vsi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vgi_bi_Tempt_GND=((+Dvsat_Vgi_bi_Tempt_GND*inv_MdL+Dvsat_Vgi_bi*inv_MdL_Tempt_GND+Dvsat_Tempt_GND*inv_MdL_Vgi_bi+Dvsat*inv_MdL_Vgi_bi_Tempt_GND)/((1.0+qs)+qdeff)-(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi))*(qs_Tempt_GND+qdeff_Tempt_GND)+(((Dvsat_Tempt_GND*inv_MdL)+(Dvsat*inv_MdL_Tempt_GND)))*(qs_Vgi_bi+qdeff_Vgi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vgi_bi_Tempt_GND)+qdeff_Vgi_bi_Tempt_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vgi_bi+qdeff_Vgi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
T5_Vdi_bi=((((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi))*((1.0+qs)+qdeff)-(Dvsat*inv_MdL)*(qs_Vdi_bi+qdeff_Vdi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=((+0.0*inv_MdL+Dvsat_Vdi_bi*0.0+0.0*inv_MdL_Vdi_bi+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi))*(qs_Vgm_si+qdeff_Vgm_si)+(0.0)*(qs_Vdi_bi+qdeff_Vdi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdi_bi_Vgm_si)+qdeff_Vdi_bi_Vgm_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vgm_si+qdeff_Vgm_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdi_bi_Vgm_di=((+0.0*inv_MdL+Dvsat_Vdi_bi*0.0+0.0*inv_MdL_Vdi_bi+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi))*(qs_Vgm_di+qdeff_Vgm_di)+(0.0)*(qs_Vdi_bi+qdeff_Vdi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdi_bi_Vgm_di)+qdeff_Vdi_bi_Vgm_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vgm_di+qdeff_Vgm_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdi_bi_Vdbulk_di=((+Dvsat_Vdi_bi_Vdbulk_di*inv_MdL+Dvsat_Vdi_bi*inv_MdL_Vdbulk_di+Dvsat_Vdbulk_di*inv_MdL_Vdi_bi+Dvsat*inv_MdL_Vdi_bi_Vdbulk_di)/((1.0+qs)+qdeff)-(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdi_bi_Vdbulk_di)+qdeff_Vdi_bi_Vdbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdi_bi_Vsbulk_si=((+Dvsat_Vdi_bi_Vsbulk_si*inv_MdL+Dvsat_Vdi_bi*inv_MdL_Vsbulk_si+Dvsat_Vsbulk_si*inv_MdL_Vdi_bi+Dvsat*inv_MdL_Vdi_bi_Vsbulk_si)/((1.0+qs)+qdeff)-(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdi_bi_Vsbulk_si)+qdeff_Vdi_bi_Vsbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdi_bi_Vgi_bi=((+Dvsat_Vdi_bi_Vgi_bi*inv_MdL+Dvsat_Vdi_bi*inv_MdL_Vgi_bi+Dvsat_Vgi_bi*inv_MdL_Vdi_bi+Dvsat*inv_MdL_Vdi_bi_Vgi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi))*(qs_Vgi_bi+qdeff_Vgi_bi)+(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdi_bi_Vgi_bi)+qdeff_Vdi_bi_Vgi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdi_bi_Vdi_bi=((+Dvsat_Vdi_bi_Vdi_bi*inv_MdL+Dvsat_Vdi_bi*inv_MdL_Vdi_bi+Dvsat_Vdi_bi*inv_MdL_Vdi_bi+Dvsat*inv_MdL_Vdi_bi_Vdi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi))*(qs_Vdi_bi+qdeff_Vdi_bi)+(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdi_bi_Vdi_bi)+qdeff_Vdi_bi_Vdi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdi_bi_Vsi_bi=((+Dvsat_Vdi_bi_Vsi_bi*inv_MdL+Dvsat_Vdi_bi*inv_MdL_Vsi_bi+Dvsat_Vsi_bi*inv_MdL_Vdi_bi+Dvsat*inv_MdL_Vdi_bi_Vsi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi))*(qs_Vsi_bi+qdeff_Vsi_bi)+(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdi_bi_Vsi_bi)+qdeff_Vdi_bi_Vsi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vdi_bi_Tempt_GND=((+Dvsat_Vdi_bi_Tempt_GND*inv_MdL+Dvsat_Vdi_bi*inv_MdL_Tempt_GND+Dvsat_Tempt_GND*inv_MdL_Vdi_bi+Dvsat*inv_MdL_Vdi_bi_Tempt_GND)/((1.0+qs)+qdeff)-(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi))*(qs_Tempt_GND+qdeff_Tempt_GND)+(((Dvsat_Tempt_GND*inv_MdL)+(Dvsat*inv_MdL_Tempt_GND)))*(qs_Vdi_bi+qdeff_Vdi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vdi_bi_Tempt_GND)+qdeff_Vdi_bi_Tempt_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vdi_bi+qdeff_Vdi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
T5_Vsi_bi=((((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi))*((1.0+qs)+qdeff)-(Dvsat*inv_MdL)*(qs_Vsi_bi+qdeff_Vsi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=((+0.0*inv_MdL+Dvsat_Vsi_bi*0.0+0.0*inv_MdL_Vsi_bi+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi))*(qs_Vgm_si+qdeff_Vgm_si)+(0.0)*(qs_Vsi_bi+qdeff_Vsi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsi_bi_Vgm_si)+qdeff_Vsi_bi_Vgm_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vgm_si+qdeff_Vgm_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsi_bi_Vgm_di=((+0.0*inv_MdL+Dvsat_Vsi_bi*0.0+0.0*inv_MdL_Vsi_bi+Dvsat*0.0)/((1.0+qs)+qdeff)-(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi))*(qs_Vgm_di+qdeff_Vgm_di)+(0.0)*(qs_Vsi_bi+qdeff_Vsi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsi_bi_Vgm_di)+qdeff_Vsi_bi_Vgm_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vgm_di+qdeff_Vgm_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsi_bi_Vdbulk_di=((+Dvsat_Vsi_bi_Vdbulk_di*inv_MdL+Dvsat_Vsi_bi*inv_MdL_Vdbulk_di+Dvsat_Vdbulk_di*inv_MdL_Vsi_bi+Dvsat*inv_MdL_Vsi_bi_Vdbulk_di)/((1.0+qs)+qdeff)-(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi))*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(((Dvsat_Vdbulk_di*inv_MdL)+(Dvsat*inv_MdL_Vdbulk_di)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsi_bi_Vdbulk_di)+qdeff_Vsi_bi_Vdbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsi_bi_Vsbulk_si=((+Dvsat_Vsi_bi_Vsbulk_si*inv_MdL+Dvsat_Vsi_bi*inv_MdL_Vsbulk_si+Dvsat_Vsbulk_si*inv_MdL_Vsi_bi+Dvsat*inv_MdL_Vsi_bi_Vsbulk_si)/((1.0+qs)+qdeff)-(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi))*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(((Dvsat_Vsbulk_si*inv_MdL)+(Dvsat*inv_MdL_Vsbulk_si)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsi_bi_Vsbulk_si)+qdeff_Vsi_bi_Vsbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsi_bi_Vgi_bi=((+Dvsat_Vsi_bi_Vgi_bi*inv_MdL+Dvsat_Vsi_bi*inv_MdL_Vgi_bi+Dvsat_Vgi_bi*inv_MdL_Vsi_bi+Dvsat*inv_MdL_Vsi_bi_Vgi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi))*(qs_Vgi_bi+qdeff_Vgi_bi)+(((Dvsat_Vgi_bi*inv_MdL)+(Dvsat*inv_MdL_Vgi_bi)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsi_bi_Vgi_bi)+qdeff_Vsi_bi_Vgi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsi_bi_Vdi_bi=((+Dvsat_Vsi_bi_Vdi_bi*inv_MdL+Dvsat_Vsi_bi*inv_MdL_Vdi_bi+Dvsat_Vdi_bi*inv_MdL_Vsi_bi+Dvsat*inv_MdL_Vsi_bi_Vdi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi))*(qs_Vdi_bi+qdeff_Vdi_bi)+(((Dvsat_Vdi_bi*inv_MdL)+(Dvsat*inv_MdL_Vdi_bi)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsi_bi_Vdi_bi)+qdeff_Vsi_bi_Vdi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsi_bi_Vsi_bi=((+Dvsat_Vsi_bi_Vsi_bi*inv_MdL+Dvsat_Vsi_bi*inv_MdL_Vsi_bi+Dvsat_Vsi_bi*inv_MdL_Vsi_bi+Dvsat*inv_MdL_Vsi_bi_Vsi_bi)/((1.0+qs)+qdeff)-(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi))*(qs_Vsi_bi+qdeff_Vsi_bi)+(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsi_bi_Vsi_bi)+qdeff_Vsi_bi_Vsi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
  T5_Vsi_bi_Tempt_GND=((+Dvsat_Vsi_bi_Tempt_GND*inv_MdL+Dvsat_Vsi_bi*inv_MdL_Tempt_GND+Dvsat_Tempt_GND*inv_MdL_Vsi_bi+Dvsat*inv_MdL_Vsi_bi_Tempt_GND)/((1.0+qs)+qdeff)-(((Dvsat_Vsi_bi*inv_MdL)+(Dvsat*inv_MdL_Vsi_bi))*(qs_Tempt_GND+qdeff_Tempt_GND)+(((Dvsat_Tempt_GND*inv_MdL)+(Dvsat*inv_MdL_Tempt_GND)))*(qs_Vsi_bi+qdeff_Vsi_bi)+(Dvsat*inv_MdL)*(+(+0.0+qs_Vsi_bi_Tempt_GND)+qdeff_Vsi_bi_Tempt_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)+2*(Dvsat*inv_MdL)*(qs_Vsi_bi+qdeff_Vsi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((((Dvsat_Tempt_GND*inv_MdL)+(Dvsat*inv_MdL_Tempt_GND))*((1.0+qs)+qdeff)-(Dvsat*inv_MdL)*(qs_Tempt_GND+qdeff_Tempt_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
#endif
#endif
T5=((Dvsat*inv_MdL)/((1.0+qs)+qdeff));
EXIT_IF_ISNAN(((Dvsat*inv_MdL)/((1.0+qs)+qdeff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=0.0;
  T6_Vgm_di_Vgm_si=0.0;
  T6_Vgm_di_Vdbulk_di=0.0;
  T6_Vgm_di_Vsbulk_si=0.0;
  T6_Vgm_di_Vgi_bi=0.0;
  T6_Vgm_di_Vdi_bi=0.0;
  T6_Vgm_di_Vsi_bi=0.0;
  T6_Vgm_di_Tempt_GND=0.0;
#endif
T6_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=0.0;
  T6_Vgm_si_Vgm_si=0.0;
  T6_Vgm_si_Vdbulk_di=0.0;
  T6_Vgm_si_Vsbulk_si=0.0;
  T6_Vgm_si_Vgi_bi=0.0;
  T6_Vgm_si_Vdi_bi=0.0;
  T6_Vgm_si_Vsi_bi=0.0;
  T6_Vgm_si_Tempt_GND=0.0;
#endif
T6_Vdbulk_di=(((0.8*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))*T5)+((0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdbulk_di));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))+0.0*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di)))+0.8*(+(+T3_Vdbulk_di_Vgm_di*T3+T3_Vdbulk_di*T3_Vgm_di+T3_Vgm_di*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vgm_di)+(+0.0*Tempd+Temps_Vdbulk_di*0.0+0.0*Tempd_Vdbulk_di+Temps*0.0)))*T5+(0.8*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))*T5_Vgm_di+((0.8*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))))*T5_Vdbulk_di+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdbulk_di_Vgm_di);
  T6_Vdbulk_di_Vgm_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))+0.0*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di)))+0.8*(+(+T3_Vdbulk_di_Vgm_si*T3+T3_Vdbulk_di*T3_Vgm_si+T3_Vgm_si*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vgm_si)+(+0.0*Tempd+Temps_Vdbulk_di*0.0+0.0*Tempd_Vdbulk_di+Temps*0.0)))*T5+(0.8*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))*T5_Vgm_si+((0.8*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))))*T5_Vdbulk_di+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdbulk_di_Vgm_si);
  T6_Vdbulk_di_Vdbulk_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))+0.0*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di)))+0.8*(+(+T3_Vdbulk_di_Vdbulk_di*T3+T3_Vdbulk_di*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vdbulk_di)+(+Temps_Vdbulk_di_Vdbulk_di*Tempd+Temps_Vdbulk_di*Tempd_Vdbulk_di+Temps_Vdbulk_di*Tempd_Vdbulk_di+Temps*Tempd_Vdbulk_di_Vdbulk_di)))*T5+(0.8*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))*T5_Vdbulk_di+((0.8*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))))*T5_Vdbulk_di+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdbulk_di_Vdbulk_di);
  T6_Vdbulk_di_Vsbulk_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))+0.0*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di)))+0.8*(+(+T3_Vdbulk_di_Vsbulk_si*T3+T3_Vdbulk_di*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vsbulk_si)+(+Temps_Vdbulk_di_Vsbulk_si*Tempd+Temps_Vdbulk_di*Tempd_Vsbulk_si+Temps_Vsbulk_si*Tempd_Vdbulk_di+Temps*Tempd_Vdbulk_di_Vsbulk_si)))*T5+(0.8*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))*T5_Vsbulk_si+((0.8*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))))*T5_Vdbulk_di+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdbulk_di_Vsbulk_si);
  T6_Vdbulk_di_Vgi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))+0.0*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di)))+0.8*(+(+T3_Vdbulk_di_Vgi_bi*T3+T3_Vdbulk_di*T3_Vgi_bi+T3_Vgi_bi*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vgi_bi)+(+Temps_Vdbulk_di_Vgi_bi*Tempd+Temps_Vdbulk_di*Tempd_Vgi_bi+Temps_Vgi_bi*Tempd_Vdbulk_di+Temps*Tempd_Vdbulk_di_Vgi_bi)))*T5+(0.8*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))*T5_Vgi_bi+((0.8*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))))*T5_Vdbulk_di+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdbulk_di_Vgi_bi);
  T6_Vdbulk_di_Vdi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))+0.0*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di)))+0.8*(+(+T3_Vdbulk_di_Vdi_bi*T3+T3_Vdbulk_di*T3_Vdi_bi+T3_Vdi_bi*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vdi_bi)+(+Temps_Vdbulk_di_Vdi_bi*Tempd+Temps_Vdbulk_di*Tempd_Vdi_bi+Temps_Vdi_bi*Tempd_Vdbulk_di+Temps*Tempd_Vdbulk_di_Vdi_bi)))*T5+(0.8*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))*T5_Vdi_bi+((0.8*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))))*T5_Vdbulk_di+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdbulk_di_Vdi_bi);
  T6_Vdbulk_di_Vsi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))+0.0*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di)))+0.8*(+(+T3_Vdbulk_di_Vsi_bi*T3+T3_Vdbulk_di*T3_Vsi_bi+T3_Vsi_bi*T3_Vdbulk_di+T3*T3_Vdbulk_di_Vsi_bi)+(+Temps_Vdbulk_di_Vsi_bi*Tempd+Temps_Vdbulk_di*Tempd_Vsi_bi+Temps_Vsi_bi*Tempd_Vdbulk_di+Temps*Tempd_Vdbulk_di_Vsi_bi)))*T5+(0.8*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))*T5_Vsi_bi+((0.8*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))))*T5_Vdbulk_di+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdbulk_di_Vsi_bi);
  T6_Vdbulk_di_Tempt_GND=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))+0.0*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di)))+0.8*(+(+T3_Vdbulk_di_Tempt_GND*T3+T3_Vdbulk_di*T3_Tempt_GND+T3_Tempt_GND*T3_Vdbulk_di+T3*T3_Vdbulk_di_Tempt_GND)+(+Temps_Vdbulk_di_Tempt_GND*Tempd+Temps_Vdbulk_di*Tempd_Tempt_GND+Temps_Tempt_GND*Tempd_Vdbulk_di+Temps*Tempd_Vdbulk_di_Tempt_GND)))*T5+(0.8*(((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di))+((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))*T5_Tempt_GND+((0.8*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))))*T5_Vdbulk_di+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdbulk_di_Tempt_GND);
#endif
T6_Vsbulk_si=(((0.8*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))*T5)+((0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsbulk_si));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))+0.0*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si)))+0.8*(+(+T3_Vsbulk_si_Vgm_di*T3+T3_Vsbulk_si*T3_Vgm_di+T3_Vgm_di*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vgm_di)+(+0.0*Tempd+Temps_Vsbulk_si*0.0+0.0*Tempd_Vsbulk_si+Temps*0.0)))*T5+(0.8*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))*T5_Vgm_di+((0.8*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))))*T5_Vsbulk_si+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsbulk_si_Vgm_di);
  T6_Vsbulk_si_Vgm_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))+0.0*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si)))+0.8*(+(+T3_Vsbulk_si_Vgm_si*T3+T3_Vsbulk_si*T3_Vgm_si+T3_Vgm_si*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vgm_si)+(+0.0*Tempd+Temps_Vsbulk_si*0.0+0.0*Tempd_Vsbulk_si+Temps*0.0)))*T5+(0.8*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))*T5_Vgm_si+((0.8*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))))*T5_Vsbulk_si+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsbulk_si_Vgm_si);
  T6_Vsbulk_si_Vdbulk_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))+0.0*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si)))+0.8*(+(+T3_Vsbulk_si_Vdbulk_di*T3+T3_Vsbulk_si*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vdbulk_di)+(+Temps_Vsbulk_si_Vdbulk_di*Tempd+Temps_Vsbulk_si*Tempd_Vdbulk_di+Temps_Vdbulk_di*Tempd_Vsbulk_si+Temps*Tempd_Vsbulk_si_Vdbulk_di)))*T5+(0.8*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))*T5_Vdbulk_di+((0.8*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))))*T5_Vsbulk_si+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsbulk_si_Vdbulk_di);
  T6_Vsbulk_si_Vsbulk_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))+0.0*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si)))+0.8*(+(+T3_Vsbulk_si_Vsbulk_si*T3+T3_Vsbulk_si*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vsbulk_si)+(+Temps_Vsbulk_si_Vsbulk_si*Tempd+Temps_Vsbulk_si*Tempd_Vsbulk_si+Temps_Vsbulk_si*Tempd_Vsbulk_si+Temps*Tempd_Vsbulk_si_Vsbulk_si)))*T5+(0.8*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))*T5_Vsbulk_si+((0.8*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))))*T5_Vsbulk_si+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsbulk_si_Vsbulk_si);
  T6_Vsbulk_si_Vgi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))+0.0*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si)))+0.8*(+(+T3_Vsbulk_si_Vgi_bi*T3+T3_Vsbulk_si*T3_Vgi_bi+T3_Vgi_bi*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vgi_bi)+(+Temps_Vsbulk_si_Vgi_bi*Tempd+Temps_Vsbulk_si*Tempd_Vgi_bi+Temps_Vgi_bi*Tempd_Vsbulk_si+Temps*Tempd_Vsbulk_si_Vgi_bi)))*T5+(0.8*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))*T5_Vgi_bi+((0.8*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))))*T5_Vsbulk_si+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsbulk_si_Vgi_bi);
  T6_Vsbulk_si_Vdi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))+0.0*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si)))+0.8*(+(+T3_Vsbulk_si_Vdi_bi*T3+T3_Vsbulk_si*T3_Vdi_bi+T3_Vdi_bi*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vdi_bi)+(+Temps_Vsbulk_si_Vdi_bi*Tempd+Temps_Vsbulk_si*Tempd_Vdi_bi+Temps_Vdi_bi*Tempd_Vsbulk_si+Temps*Tempd_Vsbulk_si_Vdi_bi)))*T5+(0.8*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))*T5_Vdi_bi+((0.8*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))))*T5_Vsbulk_si+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsbulk_si_Vdi_bi);
  T6_Vsbulk_si_Vsi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))+0.0*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si)))+0.8*(+(+T3_Vsbulk_si_Vsi_bi*T3+T3_Vsbulk_si*T3_Vsi_bi+T3_Vsi_bi*T3_Vsbulk_si+T3*T3_Vsbulk_si_Vsi_bi)+(+Temps_Vsbulk_si_Vsi_bi*Tempd+Temps_Vsbulk_si*Tempd_Vsi_bi+Temps_Vsi_bi*Tempd_Vsbulk_si+Temps*Tempd_Vsbulk_si_Vsi_bi)))*T5+(0.8*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))*T5_Vsi_bi+((0.8*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))))*T5_Vsbulk_si+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsbulk_si_Vsi_bi);
  T6_Vsbulk_si_Tempt_GND=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))+0.0*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si)))+0.8*(+(+T3_Vsbulk_si_Tempt_GND*T3+T3_Vsbulk_si*T3_Tempt_GND+T3_Tempt_GND*T3_Vsbulk_si+T3*T3_Vsbulk_si_Tempt_GND)+(+Temps_Vsbulk_si_Tempt_GND*Tempd+Temps_Vsbulk_si*Tempd_Tempt_GND+Temps_Tempt_GND*Tempd_Vsbulk_si+Temps*Tempd_Vsbulk_si_Tempt_GND)))*T5+(0.8*(((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si))+((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))*T5_Tempt_GND+((0.8*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))))*T5_Vsbulk_si+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsbulk_si_Tempt_GND);
#endif
T6_Vgi_bi=(((0.8*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))*T5)+((0.8*((T3*T3)+(Temps*Tempd)))*T5_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))+0.0*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi)))+0.8*(+(+T3_Vgi_bi_Vgm_di*T3+T3_Vgi_bi*T3_Vgm_di+T3_Vgm_di*T3_Vgi_bi+T3*T3_Vgi_bi_Vgm_di)+(+0.0*Tempd+Temps_Vgi_bi*0.0+0.0*Tempd_Vgi_bi+Temps*0.0)))*T5+(0.8*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))*T5_Vgm_di+((0.8*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))))*T5_Vgi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))+0.0*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi)))+0.8*(+(+T3_Vgi_bi_Vgm_si*T3+T3_Vgi_bi*T3_Vgm_si+T3_Vgm_si*T3_Vgi_bi+T3*T3_Vgi_bi_Vgm_si)+(+0.0*Tempd+Temps_Vgi_bi*0.0+0.0*Tempd_Vgi_bi+Temps*0.0)))*T5+(0.8*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))*T5_Vgm_si+((0.8*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))))*T5_Vgi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))+0.0*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi)))+0.8*(+(+T3_Vgi_bi_Vdbulk_di*T3+T3_Vgi_bi*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vgi_bi+T3*T3_Vgi_bi_Vdbulk_di)+(+Temps_Vgi_bi_Vdbulk_di*Tempd+Temps_Vgi_bi*Tempd_Vdbulk_di+Temps_Vdbulk_di*Tempd_Vgi_bi+Temps*Tempd_Vgi_bi_Vdbulk_di)))*T5+(0.8*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))*T5_Vdbulk_di+((0.8*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))))*T5_Vgi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))+0.0*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi)))+0.8*(+(+T3_Vgi_bi_Vsbulk_si*T3+T3_Vgi_bi*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vgi_bi+T3*T3_Vgi_bi_Vsbulk_si)+(+Temps_Vgi_bi_Vsbulk_si*Tempd+Temps_Vgi_bi*Tempd_Vsbulk_si+Temps_Vsbulk_si*Tempd_Vgi_bi+Temps*Tempd_Vgi_bi_Vsbulk_si)))*T5+(0.8*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))*T5_Vsbulk_si+((0.8*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))))*T5_Vgi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))+0.0*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi)))+0.8*(+(+T3_Vgi_bi_Vgi_bi*T3+T3_Vgi_bi*T3_Vgi_bi+T3_Vgi_bi*T3_Vgi_bi+T3*T3_Vgi_bi_Vgi_bi)+(+Temps_Vgi_bi_Vgi_bi*Tempd+Temps_Vgi_bi*Tempd_Vgi_bi+Temps_Vgi_bi*Tempd_Vgi_bi+Temps*Tempd_Vgi_bi_Vgi_bi)))*T5+(0.8*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))*T5_Vgi_bi+((0.8*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))))*T5_Vgi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))+0.0*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi)))+0.8*(+(+T3_Vgi_bi_Vdi_bi*T3+T3_Vgi_bi*T3_Vdi_bi+T3_Vdi_bi*T3_Vgi_bi+T3*T3_Vgi_bi_Vdi_bi)+(+Temps_Vgi_bi_Vdi_bi*Tempd+Temps_Vgi_bi*Tempd_Vdi_bi+Temps_Vdi_bi*Tempd_Vgi_bi+Temps*Tempd_Vgi_bi_Vdi_bi)))*T5+(0.8*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))*T5_Vdi_bi+((0.8*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))))*T5_Vgi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))+0.0*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi)))+0.8*(+(+T3_Vgi_bi_Vsi_bi*T3+T3_Vgi_bi*T3_Vsi_bi+T3_Vsi_bi*T3_Vgi_bi+T3*T3_Vgi_bi_Vsi_bi)+(+Temps_Vgi_bi_Vsi_bi*Tempd+Temps_Vgi_bi*Tempd_Vsi_bi+Temps_Vsi_bi*Tempd_Vgi_bi+Temps*Tempd_Vgi_bi_Vsi_bi)))*T5+(0.8*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))*T5_Vsi_bi+((0.8*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))))*T5_Vgi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))+0.0*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi)))+0.8*(+(+T3_Vgi_bi_Tempt_GND*T3+T3_Vgi_bi*T3_Tempt_GND+T3_Tempt_GND*T3_Vgi_bi+T3*T3_Vgi_bi_Tempt_GND)+(+Temps_Vgi_bi_Tempt_GND*Tempd+Temps_Vgi_bi*Tempd_Tempt_GND+Temps_Tempt_GND*Tempd_Vgi_bi+Temps*Tempd_Vgi_bi_Tempt_GND)))*T5+(0.8*(((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi))+((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))*T5_Tempt_GND+((0.8*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))))*T5_Vgi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=(((0.8*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))*T5)+((0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))+0.0*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi)))+0.8*(+(+T3_Vdi_bi_Vgm_di*T3+T3_Vdi_bi*T3_Vgm_di+T3_Vgm_di*T3_Vdi_bi+T3*T3_Vdi_bi_Vgm_di)+(+0.0*Tempd+Temps_Vdi_bi*0.0+0.0*Tempd_Vdi_bi+Temps*0.0)))*T5+(0.8*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))*T5_Vgm_di+((0.8*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))))*T5_Vdi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))+0.0*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi)))+0.8*(+(+T3_Vdi_bi_Vgm_si*T3+T3_Vdi_bi*T3_Vgm_si+T3_Vgm_si*T3_Vdi_bi+T3*T3_Vdi_bi_Vgm_si)+(+0.0*Tempd+Temps_Vdi_bi*0.0+0.0*Tempd_Vdi_bi+Temps*0.0)))*T5+(0.8*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))*T5_Vgm_si+((0.8*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))))*T5_Vdi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))+0.0*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi)))+0.8*(+(+T3_Vdi_bi_Vdbulk_di*T3+T3_Vdi_bi*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vdi_bi+T3*T3_Vdi_bi_Vdbulk_di)+(+Temps_Vdi_bi_Vdbulk_di*Tempd+Temps_Vdi_bi*Tempd_Vdbulk_di+Temps_Vdbulk_di*Tempd_Vdi_bi+Temps*Tempd_Vdi_bi_Vdbulk_di)))*T5+(0.8*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))*T5_Vdbulk_di+((0.8*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))))*T5_Vdi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))+0.0*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi)))+0.8*(+(+T3_Vdi_bi_Vsbulk_si*T3+T3_Vdi_bi*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vdi_bi+T3*T3_Vdi_bi_Vsbulk_si)+(+Temps_Vdi_bi_Vsbulk_si*Tempd+Temps_Vdi_bi*Tempd_Vsbulk_si+Temps_Vsbulk_si*Tempd_Vdi_bi+Temps*Tempd_Vdi_bi_Vsbulk_si)))*T5+(0.8*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))*T5_Vsbulk_si+((0.8*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))))*T5_Vdi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))+0.0*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi)))+0.8*(+(+T3_Vdi_bi_Vgi_bi*T3+T3_Vdi_bi*T3_Vgi_bi+T3_Vgi_bi*T3_Vdi_bi+T3*T3_Vdi_bi_Vgi_bi)+(+Temps_Vdi_bi_Vgi_bi*Tempd+Temps_Vdi_bi*Tempd_Vgi_bi+Temps_Vgi_bi*Tempd_Vdi_bi+Temps*Tempd_Vdi_bi_Vgi_bi)))*T5+(0.8*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))*T5_Vgi_bi+((0.8*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))))*T5_Vdi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))+0.0*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi)))+0.8*(+(+T3_Vdi_bi_Vdi_bi*T3+T3_Vdi_bi*T3_Vdi_bi+T3_Vdi_bi*T3_Vdi_bi+T3*T3_Vdi_bi_Vdi_bi)+(+Temps_Vdi_bi_Vdi_bi*Tempd+Temps_Vdi_bi*Tempd_Vdi_bi+Temps_Vdi_bi*Tempd_Vdi_bi+Temps*Tempd_Vdi_bi_Vdi_bi)))*T5+(0.8*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))*T5_Vdi_bi+((0.8*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))))*T5_Vdi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))+0.0*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi)))+0.8*(+(+T3_Vdi_bi_Vsi_bi*T3+T3_Vdi_bi*T3_Vsi_bi+T3_Vsi_bi*T3_Vdi_bi+T3*T3_Vdi_bi_Vsi_bi)+(+Temps_Vdi_bi_Vsi_bi*Tempd+Temps_Vdi_bi*Tempd_Vsi_bi+Temps_Vsi_bi*Tempd_Vdi_bi+Temps*Tempd_Vdi_bi_Vsi_bi)))*T5+(0.8*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))*T5_Vsi_bi+((0.8*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))))*T5_Vdi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))+0.0*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi)))+0.8*(+(+T3_Vdi_bi_Tempt_GND*T3+T3_Vdi_bi*T3_Tempt_GND+T3_Tempt_GND*T3_Vdi_bi+T3*T3_Vdi_bi_Tempt_GND)+(+Temps_Vdi_bi_Tempt_GND*Tempd+Temps_Vdi_bi*Tempd_Tempt_GND+Temps_Tempt_GND*Tempd_Vdi_bi+Temps*Tempd_Vdi_bi_Tempt_GND)))*T5+(0.8*(((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi))+((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))*T5_Tempt_GND+((0.8*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))))*T5_Vdi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=(((0.8*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))*T5)+((0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))+0.0*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi)))+0.8*(+(+T3_Vsi_bi_Vgm_di*T3+T3_Vsi_bi*T3_Vgm_di+T3_Vgm_di*T3_Vsi_bi+T3*T3_Vsi_bi_Vgm_di)+(+0.0*Tempd+Temps_Vsi_bi*0.0+0.0*Tempd_Vsi_bi+Temps*0.0)))*T5+(0.8*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))*T5_Vgm_di+((0.8*((((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))+(0.0))))*T5_Vsi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))+0.0*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi)))+0.8*(+(+T3_Vsi_bi_Vgm_si*T3+T3_Vsi_bi*T3_Vgm_si+T3_Vgm_si*T3_Vsi_bi+T3*T3_Vsi_bi_Vgm_si)+(+0.0*Tempd+Temps_Vsi_bi*0.0+0.0*Tempd_Vsi_bi+Temps*0.0)))*T5+(0.8*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))*T5_Vgm_si+((0.8*((((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))+(0.0))))*T5_Vsi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))+0.0*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi)))+0.8*(+(+T3_Vsi_bi_Vdbulk_di*T3+T3_Vsi_bi*T3_Vdbulk_di+T3_Vdbulk_di*T3_Vsi_bi+T3*T3_Vsi_bi_Vdbulk_di)+(+Temps_Vsi_bi_Vdbulk_di*Tempd+Temps_Vsi_bi*Tempd_Vdbulk_di+Temps_Vdbulk_di*Tempd_Vsi_bi+Temps*Tempd_Vsi_bi_Vdbulk_di)))*T5+(0.8*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))*T5_Vdbulk_di+((0.8*((((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))+(((Temps_Vdbulk_di*Tempd)+(Temps*Tempd_Vdbulk_di))))))*T5_Vsi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))+0.0*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi)))+0.8*(+(+T3_Vsi_bi_Vsbulk_si*T3+T3_Vsi_bi*T3_Vsbulk_si+T3_Vsbulk_si*T3_Vsi_bi+T3*T3_Vsi_bi_Vsbulk_si)+(+Temps_Vsi_bi_Vsbulk_si*Tempd+Temps_Vsi_bi*Tempd_Vsbulk_si+Temps_Vsbulk_si*Tempd_Vsi_bi+Temps*Tempd_Vsi_bi_Vsbulk_si)))*T5+(0.8*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))*T5_Vsbulk_si+((0.8*((((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))+(((Temps_Vsbulk_si*Tempd)+(Temps*Tempd_Vsbulk_si))))))*T5_Vsi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))+0.0*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi)))+0.8*(+(+T3_Vsi_bi_Vgi_bi*T3+T3_Vsi_bi*T3_Vgi_bi+T3_Vgi_bi*T3_Vsi_bi+T3*T3_Vsi_bi_Vgi_bi)+(+Temps_Vsi_bi_Vgi_bi*Tempd+Temps_Vsi_bi*Tempd_Vgi_bi+Temps_Vgi_bi*Tempd_Vsi_bi+Temps*Tempd_Vsi_bi_Vgi_bi)))*T5+(0.8*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))*T5_Vgi_bi+((0.8*((((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))+(((Temps_Vgi_bi*Tempd)+(Temps*Tempd_Vgi_bi))))))*T5_Vsi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))+0.0*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi)))+0.8*(+(+T3_Vsi_bi_Vdi_bi*T3+T3_Vsi_bi*T3_Vdi_bi+T3_Vdi_bi*T3_Vsi_bi+T3*T3_Vsi_bi_Vdi_bi)+(+Temps_Vsi_bi_Vdi_bi*Tempd+Temps_Vsi_bi*Tempd_Vdi_bi+Temps_Vdi_bi*Tempd_Vsi_bi+Temps*Tempd_Vsi_bi_Vdi_bi)))*T5+(0.8*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))*T5_Vdi_bi+((0.8*((((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))+(((Temps_Vdi_bi*Tempd)+(Temps*Tempd_Vdi_bi))))))*T5_Vsi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))+0.0*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi)))+0.8*(+(+T3_Vsi_bi_Vsi_bi*T3+T3_Vsi_bi*T3_Vsi_bi+T3_Vsi_bi*T3_Vsi_bi+T3*T3_Vsi_bi_Vsi_bi)+(+Temps_Vsi_bi_Vsi_bi*Tempd+Temps_Vsi_bi*Tempd_Vsi_bi+Temps_Vsi_bi*Tempd_Vsi_bi+Temps*Tempd_Vsi_bi_Vsi_bi)))*T5+(0.8*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))*T5_Vsi_bi+((0.8*((((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))+(((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))))*T5_Vsi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+(+0.0*((T3*T3)+(Temps*Tempd))+0.0*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))+0.0*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi)))+0.8*(+(+T3_Vsi_bi_Tempt_GND*T3+T3_Vsi_bi*T3_Tempt_GND+T3_Tempt_GND*T3_Vsi_bi+T3*T3_Vsi_bi_Tempt_GND)+(+Temps_Vsi_bi_Tempt_GND*Tempd+Temps_Vsi_bi*Tempd_Tempt_GND+Temps_Tempt_GND*Tempd_Vsi_bi+Temps*Tempd_Vsi_bi_Tempt_GND)))*T5+(0.8*(((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi))+((Temps_Vsi_bi*Tempd)+(Temps*Tempd_Vsi_bi))))*T5_Tempt_GND+((0.8*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+(((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))))*T5_Vsi_bi+(0.8*((T3*T3)+(Temps*Tempd)))*T5_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((0.8*(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))+((Temps_Tempt_GND*Tempd)+(Temps*Tempd_Tempt_GND))))*T5)+((0.8*((T3*T3)+(Temps*Tempd)))*T5_Tempt_GND));
#endif
#endif
T6=((0.8*((T3*T3)+(Temps*Tempd)))*T5);
EXIT_IF_ISNAN(((0.8*((T3*T3)+(Temps*Tempd)))*T5))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=0.0;
  T7_Vgm_si_Vgm_di=0.0;
  T7_Vgm_si_Vdbulk_di=0.0;
  T7_Vgm_si_Vsbulk_si=0.0;
  T7_Vgm_si_Vgi_bi=0.0;
  T7_Vgm_si_Vdi_bi=0.0;
  T7_Vgm_si_Vsi_bi=0.0;
  T7_Vgm_si_Tempt_GND=0.0;
#endif
T7_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=0.0;
  T7_Vgm_di_Vgm_di=0.0;
  T7_Vgm_di_Vdbulk_di=0.0;
  T7_Vgm_di_Vsbulk_si=0.0;
  T7_Vgm_di_Vgi_bi=0.0;
  T7_Vgm_di_Vdi_bi=0.0;
  T7_Vgm_di_Vsi_bi=0.0;
  T7_Vgm_di_Tempt_GND=0.0;
#endif
T7_Vdbulk_di=T6_Vdbulk_di;
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=(+T6_Vdbulk_di_Vgm_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdbulk_di_Vgm_di=(+T6_Vdbulk_di_Vgm_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdbulk_di_Vdbulk_di=(+T6_Vdbulk_di_Vdbulk_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdbulk_di_Vsbulk_si=(+T6_Vdbulk_di_Vsbulk_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdbulk_di_Vgi_bi=(+T6_Vdbulk_di_Vgi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdbulk_di_Vdi_bi=(+T6_Vdbulk_di_Vdi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdbulk_di_Vsi_bi=(+T6_Vdbulk_di_Vsi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdbulk_di_Tempt_GND=(+T6_Vdbulk_di_Tempt_GND+(+0.0*invgamg2+0.0*invgamg2_Tempt_GND+0.0*0.0+2.0*0.0));
#endif
T7_Vsbulk_si=T6_Vsbulk_si;
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=(+T6_Vsbulk_si_Vgm_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsbulk_si_Vgm_di=(+T6_Vsbulk_si_Vgm_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsbulk_si_Vdbulk_di=(+T6_Vsbulk_si_Vdbulk_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsbulk_si_Vsbulk_si=(+T6_Vsbulk_si_Vsbulk_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsbulk_si_Vgi_bi=(+T6_Vsbulk_si_Vgi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsbulk_si_Vdi_bi=(+T6_Vsbulk_si_Vdi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsbulk_si_Vsi_bi=(+T6_Vsbulk_si_Vsi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsbulk_si_Tempt_GND=(+T6_Vsbulk_si_Tempt_GND+(+0.0*invgamg2+0.0*invgamg2_Tempt_GND+0.0*0.0+2.0*0.0));
#endif
T7_Vgi_bi=T6_Vgi_bi;
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+T6_Vgi_bi_Vgm_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vgi_bi_Vgm_di=(+T6_Vgi_bi_Vgm_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vgi_bi_Vdbulk_di=(+T6_Vgi_bi_Vdbulk_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vgi_bi_Vsbulk_si=(+T6_Vgi_bi_Vsbulk_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vgi_bi_Vgi_bi=(+T6_Vgi_bi_Vgi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vgi_bi_Vdi_bi=(+T6_Vgi_bi_Vdi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vgi_bi_Vsi_bi=(+T6_Vgi_bi_Vsi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vgi_bi_Tempt_GND=(+T6_Vgi_bi_Tempt_GND+(+0.0*invgamg2+0.0*invgamg2_Tempt_GND+0.0*0.0+2.0*0.0));
#endif
T7_Vdi_bi=T6_Vdi_bi;
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+T6_Vdi_bi_Vgm_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdi_bi_Vgm_di=(+T6_Vdi_bi_Vgm_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdi_bi_Vdbulk_di=(+T6_Vdi_bi_Vdbulk_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdi_bi_Vsbulk_si=(+T6_Vdi_bi_Vsbulk_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdi_bi_Vgi_bi=(+T6_Vdi_bi_Vgi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdi_bi_Vdi_bi=(+T6_Vdi_bi_Vdi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdi_bi_Vsi_bi=(+T6_Vdi_bi_Vsi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vdi_bi_Tempt_GND=(+T6_Vdi_bi_Tempt_GND+(+0.0*invgamg2+0.0*invgamg2_Tempt_GND+0.0*0.0+2.0*0.0));
#endif
T7_Vsi_bi=T6_Vsi_bi;
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+T6_Vsi_bi_Vgm_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsi_bi_Vgm_di=(+T6_Vsi_bi_Vgm_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsi_bi_Vdbulk_di=(+T6_Vsi_bi_Vdbulk_di+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsi_bi_Vsbulk_si=(+T6_Vsi_bi_Vsbulk_si+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsi_bi_Vgi_bi=(+T6_Vsi_bi_Vgi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsi_bi_Vdi_bi=(+T6_Vsi_bi_Vdi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsi_bi_Vsi_bi=(+T6_Vsi_bi_Vsi_bi+(+0.0*invgamg2+0.0*0.0+0.0*0.0+2.0*0.0));
  T7_Vsi_bi_Tempt_GND=(+T6_Vsi_bi_Tempt_GND+(+0.0*invgamg2+0.0*invgamg2_Tempt_GND+0.0*0.0+2.0*0.0));
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(T6_Tempt_GND+(2.0*invgamg2_Tempt_GND));
#endif
#endif
T7=(T6+(2.0*invgamg2));
EXIT_IF_ISNAN((T6+(2.0*invgamg2)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=0.0;
  T8_Vgm_di_Vgm_si=0.0;
  T8_Vgm_di_Vdbulk_di=0.0;
  T8_Vgm_di_Vsbulk_si=0.0;
  T8_Vgm_di_Vgi_bi=0.0;
  T8_Vgm_di_Vdi_bi=0.0;
  T8_Vgm_di_Vsi_bi=0.0;
  T8_Vgm_di_Tempt_GND=0.0;
#endif
T8_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=0.0;
  T8_Vgm_si_Vgm_si=0.0;
  T8_Vgm_si_Vdbulk_di=0.0;
  T8_Vgm_si_Vsbulk_si=0.0;
  T8_Vgm_si_Vgi_bi=0.0;
  T8_Vgm_si_Vdi_bi=0.0;
  T8_Vgm_si_Vsi_bi=0.0;
  T8_Vgm_si_Tempt_GND=0.0;
#endif
T8_Vdbulk_di=(((0.33333333333333333*DQSD2_Vdbulk_di)*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vdbulk_di+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vgm_di+(0.0)*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vgm_di);
  T8_Vdbulk_di_Vgm_si=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vdbulk_di+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vgm_si+(0.0)*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vgm_si);
  T8_Vdbulk_di_Vdbulk_di=(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vdbulk_di);
  T8_Vdbulk_di_Vsbulk_si=(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vsbulk_si);
  T8_Vdbulk_di_Vgi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vgi_bi);
  T8_Vdbulk_di_Vdi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vdi_bi);
  T8_Vdbulk_di_Vsi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vsi_bi);
  T8_Vdbulk_di_Tempt_GND=(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Tempt_GND);
#endif
T8_Vsbulk_si=(((0.33333333333333333*DQSD2_Vsbulk_si)*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vsbulk_si+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vgm_di+(0.0)*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vgm_di);
  T8_Vsbulk_si_Vgm_si=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vsbulk_si+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vgm_si+(0.0)*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vgm_si);
  T8_Vsbulk_si_Vdbulk_di=(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vdbulk_di);
  T8_Vsbulk_si_Vsbulk_si=(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vsbulk_si);
  T8_Vsbulk_si_Vgi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vgi_bi);
  T8_Vsbulk_si_Vdi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vdi_bi);
  T8_Vsbulk_si_Vsi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vsi_bi);
  T8_Vsbulk_si_Tempt_GND=(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Tempt_GND);
#endif
T8_Vgi_bi=(((0.33333333333333333*DQSD2_Vgi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vgi_bi+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vgm_di+(0.0)*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vgm_di);
  T8_Vgi_bi_Vgm_si=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vgi_bi+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vgm_si+(0.0)*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vgm_si);
  T8_Vgi_bi_Vdbulk_di=(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vdbulk_di);
  T8_Vgi_bi_Vsbulk_si=(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vsbulk_si);
  T8_Vgi_bi_Vgi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vgi_bi);
  T8_Vgi_bi_Vdi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vdi_bi);
  T8_Vgi_bi_Vsi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vsi_bi);
  T8_Vgi_bi_Tempt_GND=(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Tempt_GND);
#endif
T8_Vdi_bi=(((0.33333333333333333*DQSD2_Vdi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vdi_bi+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vgm_di+(0.0)*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vgm_di);
  T8_Vdi_bi_Vgm_si=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vdi_bi+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vgm_si+(0.0)*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vgm_si);
  T8_Vdi_bi_Vdbulk_di=(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vdbulk_di);
  T8_Vdi_bi_Vsbulk_si=(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vsbulk_si);
  T8_Vdi_bi_Vgi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vgi_bi);
  T8_Vdi_bi_Vdi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vdi_bi);
  T8_Vdi_bi_Vsi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vsi_bi);
  T8_Vdi_bi_Tempt_GND=(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Tempt_GND);
#endif
T8_Vsi_bi=(((0.33333333333333333*DQSD2_Vsi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vsi_bi+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vgm_di+(0.0)*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vgm_di);
  T8_Vsi_bi_Vgm_si=(+(+0.0*DQSD2+0.0*0.0+0.0*DQSD2_Vsi_bi+0.33333333333333333*0.0)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vgm_si+(0.0)*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vgm_si);
  T8_Vsi_bi_Vdbulk_di=(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vdbulk_di);
  T8_Vsi_bi_Vsbulk_si=(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vsbulk_si);
  T8_Vsi_bi_Vgi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vgi_bi);
  T8_Vsi_bi_Vdi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vdi_bi);
  T8_Vsi_bi_Vsi_bi=(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vsi_bi);
  T8_Vsi_bi_Tempt_GND=(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(((0.33333333333333333*DQSD2_Tempt_GND)*T5)+((0.33333333333333333*DQSD2)*T5_Tempt_GND));
#endif
#endif
T8=((0.33333333333333333*DQSD2)*T5);
EXIT_IF_ISNAN(((0.33333333333333333*DQSD2)*T5))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(dbulk,di)V(sbulk,si) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(gm,GND) */
dqgeff_Vgi_bi=((((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vgi_bi)))*((2.0*Tempd)+1.0)-(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vgi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#if defined(_DERIVATE2)
  dqgeff_Vgi_bi_Vgi_bi=((+sid_Vgi_bi_Vgi_bi*((2.0*Tempd)-1.0)+sid_Vgi_bi*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vgi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vgi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vgi_bi)))*((2.0*Tempd_Vgi_bi))+(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vgi_bi)))))*(2.0*Tempd_Vgi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vgi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vgi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vgi_bi_Vdi_bi=((+sid_Vgi_bi_Vdi_bi*((2.0*Tempd)-1.0)+sid_Vgi_bi*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vgi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vdi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vgi_bi)))*((2.0*Tempd_Vdi_bi))+(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdi_bi)))))*(2.0*Tempd_Vgi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vdi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vdi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vgi_bi_Vsi_bi=((+sid_Vgi_bi_Vsi_bi*((2.0*Tempd)-1.0)+sid_Vgi_bi*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vgi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vsi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vgi_bi)))*((2.0*Tempd_Vsi_bi))+(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsi_bi)))))*(2.0*Tempd_Vgi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vsi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vsi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vgi_bi_Tempt_GND=((+sid_Vgi_bi_Tempt_GND*((2.0*Tempd)-1.0)+sid_Vgi_bi*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vgi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Tempt_GND)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vgi_bi)))*((2.0*Tempd_Tempt_GND))+(((sid_Tempt_GND*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Tempt_GND)))))*(2.0*Tempd_Vgi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Tempt_GND)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Tempt_GND))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vgi_bi_Vdbulk_di=((+sid_Vgi_bi_Vdbulk_di*((2.0*Tempd)-1.0)+sid_Vgi_bi*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vgi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vdbulk_di)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vgi_bi)))*((2.0*Tempd_Vdbulk_di))+(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdbulk_di)))))*(2.0*Tempd_Vgi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vdbulk_di)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vdbulk_di))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vgi_bi_Vsbulk_si=((+sid_Vgi_bi_Vsbulk_si*((2.0*Tempd)-1.0)+sid_Vgi_bi*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vgi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vsbulk_si)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vgi_bi)))*((2.0*Tempd_Vsbulk_si))+(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsbulk_si)))))*(2.0*Tempd_Vgi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vgi_bi+2.0*Tempd_Vgi_bi_Vsbulk_si)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vgi_bi)*((2.0*Tempd_Vsbulk_si))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#endif
dqgeff_Vdi_bi=((((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdi_bi)))*((2.0*Tempd)+1.0)-(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#if defined(_DERIVATE2)
  dqgeff_Vdi_bi_Vgi_bi=((+sid_Vdi_bi_Vgi_bi*((2.0*Tempd)-1.0)+sid_Vdi_bi*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vdi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vgi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdi_bi)))*((2.0*Tempd_Vgi_bi))+(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vgi_bi)))))*(2.0*Tempd_Vdi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vgi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vgi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdi_bi_Vdi_bi=((+sid_Vdi_bi_Vdi_bi*((2.0*Tempd)-1.0)+sid_Vdi_bi*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vdi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vdi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdi_bi)))*((2.0*Tempd_Vdi_bi))+(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdi_bi)))))*(2.0*Tempd_Vdi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vdi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vdi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdi_bi_Vsi_bi=((+sid_Vdi_bi_Vsi_bi*((2.0*Tempd)-1.0)+sid_Vdi_bi*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vdi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vsi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdi_bi)))*((2.0*Tempd_Vsi_bi))+(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsi_bi)))))*(2.0*Tempd_Vdi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vsi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vsi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdi_bi_Tempt_GND=((+sid_Vdi_bi_Tempt_GND*((2.0*Tempd)-1.0)+sid_Vdi_bi*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vdi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Tempt_GND)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdi_bi)))*((2.0*Tempd_Tempt_GND))+(((sid_Tempt_GND*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Tempt_GND)))))*(2.0*Tempd_Vdi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Tempt_GND)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Tempt_GND))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdi_bi_Vdbulk_di=((+sid_Vdi_bi_Vdbulk_di*((2.0*Tempd)-1.0)+sid_Vdi_bi*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vdi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vdbulk_di)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdi_bi)))*((2.0*Tempd_Vdbulk_di))+(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdbulk_di)))))*(2.0*Tempd_Vdi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vdbulk_di)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vdbulk_di))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdi_bi_Vsbulk_si=((+sid_Vdi_bi_Vsbulk_si*((2.0*Tempd)-1.0)+sid_Vdi_bi*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vdi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vsbulk_si)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdi_bi)))*((2.0*Tempd_Vsbulk_si))+(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsbulk_si)))))*(2.0*Tempd_Vdi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vdi_bi+2.0*Tempd_Vdi_bi_Vsbulk_si)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdi_bi)*((2.0*Tempd_Vsbulk_si))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#endif
dqgeff_Vsi_bi=((((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsi_bi)))*((2.0*Tempd)+1.0)-(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#if defined(_DERIVATE2)
  dqgeff_Vsi_bi_Vgi_bi=((+sid_Vsi_bi_Vgi_bi*((2.0*Tempd)-1.0)+sid_Vsi_bi*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vsi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vgi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsi_bi)))*((2.0*Tempd_Vgi_bi))+(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vgi_bi)))))*(2.0*Tempd_Vsi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vgi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vgi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsi_bi_Vdi_bi=((+sid_Vsi_bi_Vdi_bi*((2.0*Tempd)-1.0)+sid_Vsi_bi*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vsi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vdi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsi_bi)))*((2.0*Tempd_Vdi_bi))+(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdi_bi)))))*(2.0*Tempd_Vsi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vdi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vdi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsi_bi_Vsi_bi=((+sid_Vsi_bi_Vsi_bi*((2.0*Tempd)-1.0)+sid_Vsi_bi*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vsi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vsi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsi_bi)))*((2.0*Tempd_Vsi_bi))+(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsi_bi)))))*(2.0*Tempd_Vsi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vsi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vsi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsi_bi_Tempt_GND=((+sid_Vsi_bi_Tempt_GND*((2.0*Tempd)-1.0)+sid_Vsi_bi*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vsi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Tempt_GND)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsi_bi)))*((2.0*Tempd_Tempt_GND))+(((sid_Tempt_GND*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Tempt_GND)))))*(2.0*Tempd_Vsi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Tempt_GND)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Tempt_GND))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsi_bi_Vdbulk_di=((+sid_Vsi_bi_Vdbulk_di*((2.0*Tempd)-1.0)+sid_Vsi_bi*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vsi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vdbulk_di)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsi_bi)))*((2.0*Tempd_Vdbulk_di))+(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdbulk_di)))))*(2.0*Tempd_Vsi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vdbulk_di)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vdbulk_di))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsi_bi_Vsbulk_si=((+sid_Vsi_bi_Vsbulk_si*((2.0*Tempd)-1.0)+sid_Vsi_bi*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vsi_bi)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vsbulk_si)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsi_bi)))*((2.0*Tempd_Vsbulk_si))+(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsbulk_si)))))*(2.0*Tempd_Vsi_bi)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vsi_bi+2.0*Tempd_Vsi_bi_Vsbulk_si)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsi_bi)*((2.0*Tempd_Vsbulk_si))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#endif
#if defined(_DERIVATE)
dqgeff_Tempt_GND=((((sid_Tempt_GND*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Tempt_GND)))*((2.0*Tempd)+1.0)-(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Tempt_GND))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#endif
dqgeff_Vdbulk_di=((((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdbulk_di)))*((2.0*Tempd)+1.0)-(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdbulk_di))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#if defined(_DERIVATE2)
  dqgeff_Vdbulk_di_Vgi_bi=((+sid_Vdbulk_di_Vgi_bi*((2.0*Tempd)-1.0)+sid_Vdbulk_di*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vdbulk_di)+sid*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vgi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdbulk_di)))*((2.0*Tempd_Vgi_bi))+(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vgi_bi)))))*(2.0*Tempd_Vdbulk_di)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vgi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vgi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdbulk_di_Vdi_bi=((+sid_Vdbulk_di_Vdi_bi*((2.0*Tempd)-1.0)+sid_Vdbulk_di*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vdbulk_di)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vdi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdbulk_di)))*((2.0*Tempd_Vdi_bi))+(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdi_bi)))))*(2.0*Tempd_Vdbulk_di)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vdi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vdi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdbulk_di_Vsi_bi=((+sid_Vdbulk_di_Vsi_bi*((2.0*Tempd)-1.0)+sid_Vdbulk_di*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vdbulk_di)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vsi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdbulk_di)))*((2.0*Tempd_Vsi_bi))+(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsi_bi)))))*(2.0*Tempd_Vdbulk_di)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vsi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vsi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdbulk_di_Tempt_GND=((+sid_Vdbulk_di_Tempt_GND*((2.0*Tempd)-1.0)+sid_Vdbulk_di*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vdbulk_di)+sid*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Tempt_GND)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdbulk_di)))*((2.0*Tempd_Tempt_GND))+(((sid_Tempt_GND*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Tempt_GND)))))*(2.0*Tempd_Vdbulk_di)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Tempt_GND)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Tempt_GND))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdbulk_di_Vdbulk_di=((+sid_Vdbulk_di_Vdbulk_di*((2.0*Tempd)-1.0)+sid_Vdbulk_di*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vdbulk_di)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vdbulk_di)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdbulk_di)))*((2.0*Tempd_Vdbulk_di))+(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdbulk_di)))))*(2.0*Tempd_Vdbulk_di)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vdbulk_di)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vdbulk_di))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vdbulk_di_Vsbulk_si=((+sid_Vdbulk_di_Vsbulk_si*((2.0*Tempd)-1.0)+sid_Vdbulk_di*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vdbulk_di)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vsbulk_si)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vdbulk_di)))*((2.0*Tempd_Vsbulk_si))+(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsbulk_si)))))*(2.0*Tempd_Vdbulk_di)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vdbulk_di+2.0*Tempd_Vdbulk_di_Vsbulk_si)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vdbulk_di)*((2.0*Tempd_Vsbulk_si))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#endif
dqgeff_Vsbulk_si=((((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsbulk_si)))*((2.0*Tempd)+1.0)-(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsbulk_si))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#if defined(_DERIVATE2)
  dqgeff_Vsbulk_si_Vgi_bi=((+sid_Vsbulk_si_Vgi_bi*((2.0*Tempd)-1.0)+sid_Vsbulk_si*((2.0*Tempd_Vgi_bi))+sid_Vgi_bi*(2.0*Tempd_Vsbulk_si)+sid*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vgi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsbulk_si)))*((2.0*Tempd_Vgi_bi))+(((sid_Vgi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vgi_bi)))))*(2.0*Tempd_Vsbulk_si)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vgi_bi+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vgi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vgi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsbulk_si_Vdi_bi=((+sid_Vsbulk_si_Vdi_bi*((2.0*Tempd)-1.0)+sid_Vsbulk_si*((2.0*Tempd_Vdi_bi))+sid_Vdi_bi*(2.0*Tempd_Vsbulk_si)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vdi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsbulk_si)))*((2.0*Tempd_Vdi_bi))+(((sid_Vdi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdi_bi)))))*(2.0*Tempd_Vsbulk_si)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdi_bi+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vdi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vdi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsbulk_si_Vsi_bi=((+sid_Vsbulk_si_Vsi_bi*((2.0*Tempd)-1.0)+sid_Vsbulk_si*((2.0*Tempd_Vsi_bi))+sid_Vsi_bi*(2.0*Tempd_Vsbulk_si)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vsi_bi)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsbulk_si)))*((2.0*Tempd_Vsi_bi))+(((sid_Vsi_bi*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsi_bi)))))*(2.0*Tempd_Vsbulk_si)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsi_bi+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vsi_bi)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vsi_bi))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsbulk_si_Tempt_GND=((+sid_Vsbulk_si_Tempt_GND*((2.0*Tempd)-1.0)+sid_Vsbulk_si*((2.0*Tempd_Tempt_GND))+sid_Tempt_GND*(2.0*Tempd_Vsbulk_si)+sid*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Tempt_GND)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsbulk_si)))*((2.0*Tempd_Tempt_GND))+(((sid_Tempt_GND*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Tempt_GND)))))*(2.0*Tempd_Vsbulk_si)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Tempt_GND+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Tempt_GND)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Tempt_GND))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsbulk_si_Vdbulk_di=((+sid_Vsbulk_si_Vdbulk_di*((2.0*Tempd)-1.0)+sid_Vsbulk_si*((2.0*Tempd_Vdbulk_di))+sid_Vdbulk_di*(2.0*Tempd_Vsbulk_si)+sid*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vdbulk_di)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsbulk_si)))*((2.0*Tempd_Vdbulk_di))+(((sid_Vdbulk_di*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vdbulk_di)))))*(2.0*Tempd_Vsbulk_si)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vdbulk_di+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vdbulk_di)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vdbulk_di))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
  dqgeff_Vsbulk_si_Vsbulk_si=((+sid_Vsbulk_si_Vsbulk_si*((2.0*Tempd)-1.0)+sid_Vsbulk_si*((2.0*Tempd_Vsbulk_si))+sid_Vsbulk_si*(2.0*Tempd_Vsbulk_si)+sid*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vsbulk_si)-0.0))/((2.0*Tempd)+1.0)-(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*(2.0*Tempd_Vsbulk_si)))*((2.0*Tempd_Vsbulk_si))+(((sid_Vsbulk_si*((2.0*Tempd)-1.0))+(sid*((2.0*Tempd_Vsbulk_si)))))*(2.0*Tempd_Vsbulk_si)+(sid*((2.0*Tempd)-1.0))*(+(+0.0*Tempd+0.0*Tempd_Vsbulk_si+0.0*Tempd_Vsbulk_si+2.0*Tempd_Vsbulk_si_Vsbulk_si)+0.0))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)+2*(sid*((2.0*Tempd)-1.0))*(2.0*Tempd_Vsbulk_si)*((2.0*Tempd_Vsbulk_si))/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
#endif
#endif
dqgeff=((sid*((2.0*Tempd)-1.0))/((2.0*Tempd)+1.0));
EXIT_IF_ISNAN(((sid*((2.0*Tempd)-1.0))/((2.0*Tempd)+1.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(dbulk,di)V(sbulk,si) ddxprobe=V(gm,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND)V(dbulk,GND)V(sbulk,GND) */
qbeff_Vgi_bi=((vgpqm_Vgi_bi-(((2.0*nq_Vgi_bi)*qdeff)+((2.0*(nq-1.0))*qdeff_Vgi_bi)))+dqgeff_Vgi_bi);
#if defined(_DERIVATE2)
  qbeff_Vgi_bi_Vgi_bi=(+(+vgpqm_Vgi_bi_Vgi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+2.0*(+nq_Vgi_bi_Vgi_bi-0.0))*qdeff+(2.0*nq_Vgi_bi)*qdeff_Vgi_bi+((2.0*nq_Vgi_bi))*qdeff_Vgi_bi+(2.0*(nq-1.0))*qdeff_Vgi_bi_Vgi_bi))+dqgeff_Vgi_bi_Vgi_bi);
  qbeff_Vgi_bi_Vdi_bi=(+(+vgpqm_Vgi_bi_Vdi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+2.0*(+nq_Vgi_bi_Vdi_bi-0.0))*qdeff+(2.0*nq_Vgi_bi)*qdeff_Vdi_bi+((2.0*nq_Vdi_bi))*qdeff_Vgi_bi+(2.0*(nq-1.0))*qdeff_Vgi_bi_Vdi_bi))+dqgeff_Vgi_bi_Vdi_bi);
  qbeff_Vgi_bi_Vsi_bi=(+(+vgpqm_Vgi_bi_Vsi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+2.0*(+nq_Vgi_bi_Vsi_bi-0.0))*qdeff+(2.0*nq_Vgi_bi)*qdeff_Vsi_bi+((2.0*nq_Vsi_bi))*qdeff_Vgi_bi+(2.0*(nq-1.0))*qdeff_Vgi_bi_Vsi_bi))+dqgeff_Vgi_bi_Vsi_bi);
  qbeff_Vgi_bi_Tempt_GND=(+(+vgpqm_Vgi_bi_Tempt_GND-(+(+0.0*(nq-1.0)+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+2.0*(+nq_Vgi_bi_Tempt_GND-0.0))*qdeff+(2.0*nq_Vgi_bi)*qdeff_Tempt_GND+((2.0*nq_Tempt_GND))*qdeff_Vgi_bi+(2.0*(nq-1.0))*qdeff_Vgi_bi_Tempt_GND))+dqgeff_Vgi_bi_Tempt_GND);
  qbeff_Vgi_bi_Vdbulk_di=(+(+vgpqm_Vgi_bi_Vdbulk_di-(+(+0.0*(nq-1.0)+0.0*nq_Vdbulk_di+0.0*nq_Vgi_bi+2.0*(+nq_Vgi_bi_Vdbulk_di-0.0))*qdeff+(2.0*nq_Vgi_bi)*qdeff_Vdbulk_di+((2.0*nq_Vdbulk_di))*qdeff_Vgi_bi+(2.0*(nq-1.0))*qdeff_Vgi_bi_Vdbulk_di))+dqgeff_Vgi_bi_Vdbulk_di);
  qbeff_Vgi_bi_Vsbulk_si=(+(+vgpqm_Vgi_bi_Vsbulk_si-(+(+0.0*(nq-1.0)+0.0*nq_Vsbulk_si+0.0*nq_Vgi_bi+2.0*(+nq_Vgi_bi_Vsbulk_si-0.0))*qdeff+(2.0*nq_Vgi_bi)*qdeff_Vsbulk_si+((2.0*nq_Vsbulk_si))*qdeff_Vgi_bi+(2.0*(nq-1.0))*qdeff_Vgi_bi_Vsbulk_si))+dqgeff_Vgi_bi_Vsbulk_si);
#endif
qbeff_Vdi_bi=((vgpqm_Vdi_bi-(((2.0*nq_Vdi_bi)*qdeff)+((2.0*(nq-1.0))*qdeff_Vdi_bi)))+dqgeff_Vdi_bi);
#if defined(_DERIVATE2)
  qbeff_Vdi_bi_Vgi_bi=(+(+vgpqm_Vdi_bi_Vgi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+2.0*(+nq_Vdi_bi_Vgi_bi-0.0))*qdeff+(2.0*nq_Vdi_bi)*qdeff_Vgi_bi+((2.0*nq_Vgi_bi))*qdeff_Vdi_bi+(2.0*(nq-1.0))*qdeff_Vdi_bi_Vgi_bi))+dqgeff_Vdi_bi_Vgi_bi);
  qbeff_Vdi_bi_Vdi_bi=(+(+vgpqm_Vdi_bi_Vdi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+2.0*(+nq_Vdi_bi_Vdi_bi-0.0))*qdeff+(2.0*nq_Vdi_bi)*qdeff_Vdi_bi+((2.0*nq_Vdi_bi))*qdeff_Vdi_bi+(2.0*(nq-1.0))*qdeff_Vdi_bi_Vdi_bi))+dqgeff_Vdi_bi_Vdi_bi);
  qbeff_Vdi_bi_Vsi_bi=(+(+vgpqm_Vdi_bi_Vsi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+2.0*(+nq_Vdi_bi_Vsi_bi-0.0))*qdeff+(2.0*nq_Vdi_bi)*qdeff_Vsi_bi+((2.0*nq_Vsi_bi))*qdeff_Vdi_bi+(2.0*(nq-1.0))*qdeff_Vdi_bi_Vsi_bi))+dqgeff_Vdi_bi_Vsi_bi);
  qbeff_Vdi_bi_Tempt_GND=(+(+vgpqm_Vdi_bi_Tempt_GND-(+(+0.0*(nq-1.0)+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+2.0*(+nq_Vdi_bi_Tempt_GND-0.0))*qdeff+(2.0*nq_Vdi_bi)*qdeff_Tempt_GND+((2.0*nq_Tempt_GND))*qdeff_Vdi_bi+(2.0*(nq-1.0))*qdeff_Vdi_bi_Tempt_GND))+dqgeff_Vdi_bi_Tempt_GND);
  qbeff_Vdi_bi_Vdbulk_di=(+(+vgpqm_Vdi_bi_Vdbulk_di-(+(+0.0*(nq-1.0)+0.0*nq_Vdbulk_di+0.0*nq_Vdi_bi+2.0*(+nq_Vdi_bi_Vdbulk_di-0.0))*qdeff+(2.0*nq_Vdi_bi)*qdeff_Vdbulk_di+((2.0*nq_Vdbulk_di))*qdeff_Vdi_bi+(2.0*(nq-1.0))*qdeff_Vdi_bi_Vdbulk_di))+dqgeff_Vdi_bi_Vdbulk_di);
  qbeff_Vdi_bi_Vsbulk_si=(+(+vgpqm_Vdi_bi_Vsbulk_si-(+(+0.0*(nq-1.0)+0.0*nq_Vsbulk_si+0.0*nq_Vdi_bi+2.0*(+nq_Vdi_bi_Vsbulk_si-0.0))*qdeff+(2.0*nq_Vdi_bi)*qdeff_Vsbulk_si+((2.0*nq_Vsbulk_si))*qdeff_Vdi_bi+(2.0*(nq-1.0))*qdeff_Vdi_bi_Vsbulk_si))+dqgeff_Vdi_bi_Vsbulk_si);
#endif
qbeff_Vsi_bi=((vgpqm_Vsi_bi-(((2.0*nq_Vsi_bi)*qdeff)+((2.0*(nq-1.0))*qdeff_Vsi_bi)))+dqgeff_Vsi_bi);
#if defined(_DERIVATE2)
  qbeff_Vsi_bi_Vgi_bi=(+(+vgpqm_Vsi_bi_Vgi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+2.0*(+nq_Vsi_bi_Vgi_bi-0.0))*qdeff+(2.0*nq_Vsi_bi)*qdeff_Vgi_bi+((2.0*nq_Vgi_bi))*qdeff_Vsi_bi+(2.0*(nq-1.0))*qdeff_Vsi_bi_Vgi_bi))+dqgeff_Vsi_bi_Vgi_bi);
  qbeff_Vsi_bi_Vdi_bi=(+(+vgpqm_Vsi_bi_Vdi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+2.0*(+nq_Vsi_bi_Vdi_bi-0.0))*qdeff+(2.0*nq_Vsi_bi)*qdeff_Vdi_bi+((2.0*nq_Vdi_bi))*qdeff_Vsi_bi+(2.0*(nq-1.0))*qdeff_Vsi_bi_Vdi_bi))+dqgeff_Vsi_bi_Vdi_bi);
  qbeff_Vsi_bi_Vsi_bi=(+(+vgpqm_Vsi_bi_Vsi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+2.0*(+nq_Vsi_bi_Vsi_bi-0.0))*qdeff+(2.0*nq_Vsi_bi)*qdeff_Vsi_bi+((2.0*nq_Vsi_bi))*qdeff_Vsi_bi+(2.0*(nq-1.0))*qdeff_Vsi_bi_Vsi_bi))+dqgeff_Vsi_bi_Vsi_bi);
  qbeff_Vsi_bi_Tempt_GND=(+(+vgpqm_Vsi_bi_Tempt_GND-(+(+0.0*(nq-1.0)+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+2.0*(+nq_Vsi_bi_Tempt_GND-0.0))*qdeff+(2.0*nq_Vsi_bi)*qdeff_Tempt_GND+((2.0*nq_Tempt_GND))*qdeff_Vsi_bi+(2.0*(nq-1.0))*qdeff_Vsi_bi_Tempt_GND))+dqgeff_Vsi_bi_Tempt_GND);
  qbeff_Vsi_bi_Vdbulk_di=(+(+vgpqm_Vsi_bi_Vdbulk_di-(+(+0.0*(nq-1.0)+0.0*nq_Vdbulk_di+0.0*nq_Vsi_bi+2.0*(+nq_Vsi_bi_Vdbulk_di-0.0))*qdeff+(2.0*nq_Vsi_bi)*qdeff_Vdbulk_di+((2.0*nq_Vdbulk_di))*qdeff_Vsi_bi+(2.0*(nq-1.0))*qdeff_Vsi_bi_Vdbulk_di))+dqgeff_Vsi_bi_Vdbulk_di);
  qbeff_Vsi_bi_Vsbulk_si=(+(+vgpqm_Vsi_bi_Vsbulk_si-(+(+0.0*(nq-1.0)+0.0*nq_Vsbulk_si+0.0*nq_Vsi_bi+2.0*(+nq_Vsi_bi_Vsbulk_si-0.0))*qdeff+(2.0*nq_Vsi_bi)*qdeff_Vsbulk_si+((2.0*nq_Vsbulk_si))*qdeff_Vsi_bi+(2.0*(nq-1.0))*qdeff_Vsi_bi_Vsbulk_si))+dqgeff_Vsi_bi_Vsbulk_si);
#endif
#if defined(_DERIVATE)
qbeff_Tempt_GND=((vgpqm_Tempt_GND-(((2.0*nq_Tempt_GND)*qdeff)+((2.0*(nq-1.0))*qdeff_Tempt_GND)))+dqgeff_Tempt_GND);
#endif
qbeff_Vdbulk_di=((vgpqm_Vdbulk_di-(((2.0*nq_Vdbulk_di)*qdeff)+((2.0*(nq-1.0))*qdeff_Vdbulk_di)))+dqgeff_Vdbulk_di);
#if defined(_DERIVATE2)
  qbeff_Vdbulk_di_Vgi_bi=(+(+vgpqm_Vdbulk_di_Vgi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vgi_bi+0.0*nq_Vdbulk_di+2.0*(+nq_Vdbulk_di_Vgi_bi-0.0))*qdeff+(2.0*nq_Vdbulk_di)*qdeff_Vgi_bi+((2.0*nq_Vgi_bi))*qdeff_Vdbulk_di+(2.0*(nq-1.0))*qdeff_Vdbulk_di_Vgi_bi))+dqgeff_Vdbulk_di_Vgi_bi);
  qbeff_Vdbulk_di_Vdi_bi=(+(+vgpqm_Vdbulk_di_Vdi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vdi_bi+0.0*nq_Vdbulk_di+2.0*(+nq_Vdbulk_di_Vdi_bi-0.0))*qdeff+(2.0*nq_Vdbulk_di)*qdeff_Vdi_bi+((2.0*nq_Vdi_bi))*qdeff_Vdbulk_di+(2.0*(nq-1.0))*qdeff_Vdbulk_di_Vdi_bi))+dqgeff_Vdbulk_di_Vdi_bi);
  qbeff_Vdbulk_di_Vsi_bi=(+(+vgpqm_Vdbulk_di_Vsi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vsi_bi+0.0*nq_Vdbulk_di+2.0*(+nq_Vdbulk_di_Vsi_bi-0.0))*qdeff+(2.0*nq_Vdbulk_di)*qdeff_Vsi_bi+((2.0*nq_Vsi_bi))*qdeff_Vdbulk_di+(2.0*(nq-1.0))*qdeff_Vdbulk_di_Vsi_bi))+dqgeff_Vdbulk_di_Vsi_bi);
  qbeff_Vdbulk_di_Tempt_GND=(+(+vgpqm_Vdbulk_di_Tempt_GND-(+(+0.0*(nq-1.0)+0.0*nq_Tempt_GND+0.0*nq_Vdbulk_di+2.0*(+nq_Vdbulk_di_Tempt_GND-0.0))*qdeff+(2.0*nq_Vdbulk_di)*qdeff_Tempt_GND+((2.0*nq_Tempt_GND))*qdeff_Vdbulk_di+(2.0*(nq-1.0))*qdeff_Vdbulk_di_Tempt_GND))+dqgeff_Vdbulk_di_Tempt_GND);
  qbeff_Vdbulk_di_Vdbulk_di=(+(+vgpqm_Vdbulk_di_Vdbulk_di-(+(+0.0*(nq-1.0)+0.0*nq_Vdbulk_di+0.0*nq_Vdbulk_di+2.0*(+nq_Vdbulk_di_Vdbulk_di-0.0))*qdeff+(2.0*nq_Vdbulk_di)*qdeff_Vdbulk_di+((2.0*nq_Vdbulk_di))*qdeff_Vdbulk_di+(2.0*(nq-1.0))*qdeff_Vdbulk_di_Vdbulk_di))+dqgeff_Vdbulk_di_Vdbulk_di);
  qbeff_Vdbulk_di_Vsbulk_si=(+(+vgpqm_Vdbulk_di_Vsbulk_si-(+(+0.0*(nq-1.0)+0.0*nq_Vsbulk_si+0.0*nq_Vdbulk_di+2.0*(+nq_Vdbulk_di_Vsbulk_si-0.0))*qdeff+(2.0*nq_Vdbulk_di)*qdeff_Vsbulk_si+((2.0*nq_Vsbulk_si))*qdeff_Vdbulk_di+(2.0*(nq-1.0))*qdeff_Vdbulk_di_Vsbulk_si))+dqgeff_Vdbulk_di_Vsbulk_si);
#endif
qbeff_Vsbulk_si=((vgpqm_Vsbulk_si-(((2.0*nq_Vsbulk_si)*qdeff)+((2.0*(nq-1.0))*qdeff_Vsbulk_si)))+dqgeff_Vsbulk_si);
#if defined(_DERIVATE2)
  qbeff_Vsbulk_si_Vgi_bi=(+(+vgpqm_Vsbulk_si_Vgi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vgi_bi+0.0*nq_Vsbulk_si+2.0*(+nq_Vsbulk_si_Vgi_bi-0.0))*qdeff+(2.0*nq_Vsbulk_si)*qdeff_Vgi_bi+((2.0*nq_Vgi_bi))*qdeff_Vsbulk_si+(2.0*(nq-1.0))*qdeff_Vsbulk_si_Vgi_bi))+dqgeff_Vsbulk_si_Vgi_bi);
  qbeff_Vsbulk_si_Vdi_bi=(+(+vgpqm_Vsbulk_si_Vdi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vdi_bi+0.0*nq_Vsbulk_si+2.0*(+nq_Vsbulk_si_Vdi_bi-0.0))*qdeff+(2.0*nq_Vsbulk_si)*qdeff_Vdi_bi+((2.0*nq_Vdi_bi))*qdeff_Vsbulk_si+(2.0*(nq-1.0))*qdeff_Vsbulk_si_Vdi_bi))+dqgeff_Vsbulk_si_Vdi_bi);
  qbeff_Vsbulk_si_Vsi_bi=(+(+vgpqm_Vsbulk_si_Vsi_bi-(+(+0.0*(nq-1.0)+0.0*nq_Vsi_bi+0.0*nq_Vsbulk_si+2.0*(+nq_Vsbulk_si_Vsi_bi-0.0))*qdeff+(2.0*nq_Vsbulk_si)*qdeff_Vsi_bi+((2.0*nq_Vsi_bi))*qdeff_Vsbulk_si+(2.0*(nq-1.0))*qdeff_Vsbulk_si_Vsi_bi))+dqgeff_Vsbulk_si_Vsi_bi);
  qbeff_Vsbulk_si_Tempt_GND=(+(+vgpqm_Vsbulk_si_Tempt_GND-(+(+0.0*(nq-1.0)+0.0*nq_Tempt_GND+0.0*nq_Vsbulk_si+2.0*(+nq_Vsbulk_si_Tempt_GND-0.0))*qdeff+(2.0*nq_Vsbulk_si)*qdeff_Tempt_GND+((2.0*nq_Tempt_GND))*qdeff_Vsbulk_si+(2.0*(nq-1.0))*qdeff_Vsbulk_si_Tempt_GND))+dqgeff_Vsbulk_si_Tempt_GND);
  qbeff_Vsbulk_si_Vdbulk_di=(+(+vgpqm_Vsbulk_si_Vdbulk_di-(+(+0.0*(nq-1.0)+0.0*nq_Vdbulk_di+0.0*nq_Vsbulk_si+2.0*(+nq_Vsbulk_si_Vdbulk_di-0.0))*qdeff+(2.0*nq_Vsbulk_si)*qdeff_Vdbulk_di+((2.0*nq_Vdbulk_di))*qdeff_Vsbulk_si+(2.0*(nq-1.0))*qdeff_Vsbulk_si_Vdbulk_di))+dqgeff_Vsbulk_si_Vdbulk_di);
  qbeff_Vsbulk_si_Vsbulk_si=(+(+vgpqm_Vsbulk_si_Vsbulk_si-(+(+0.0*(nq-1.0)+0.0*nq_Vsbulk_si+0.0*nq_Vsbulk_si+2.0*(+nq_Vsbulk_si_Vsbulk_si-0.0))*qdeff+(2.0*nq_Vsbulk_si)*qdeff_Vsbulk_si+((2.0*nq_Vsbulk_si))*qdeff_Vsbulk_si+(2.0*(nq-1.0))*qdeff_Vsbulk_si_Vsbulk_si))+dqgeff_Vsbulk_si_Vsbulk_si);
#endif
#endif
qbeff=((vgpqm-((2.0*(nq-1.0))*qdeff))+dqgeff);
EXIT_IF_ISNAN(((vgpqm-((2.0*(nq-1.0))*qdeff))+dqgeff))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND)V(si,GND)V(gm,GND) */
Qb_Vdbulk_di=(((inv_MdL_Vdbulk_di*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(inv_MdL*((T1_Vdbulk_di+T2_Vdbulk_di)+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))-((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)))))))+((MdL_less_1_Vdbulk_di*qbeff)+(MdL_less_1*qbeff_Vdbulk_di)));
#if defined(_DERIVATE2)
  Qb_Vdbulk_di_Vdbulk_di=(+(+inv_MdL_Vdbulk_di_Vdbulk_di*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdbulk_di*((T1_Vdbulk_di+T2_Vdbulk_di)+((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))-(((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di))))))+inv_MdL_Vdbulk_di*((T1_Vdbulk_di+T2_Vdbulk_di)+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))-((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)))))+inv_MdL*(+(+T1_Vdbulk_di_Vdbulk_di+T2_Vdbulk_di_Vdbulk_di)+(+(+T4_Vdbulk_di_Vdbulk_di*T7+T4_Vdbulk_di*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdbulk_di)-(+nq_Vdbulk_di_Vdbulk_di*((qs+qdeff)+T8)+nq_Vdbulk_di*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq_Vdbulk_di*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq*(+(+qs_Vdbulk_di_Vdbulk_di+qdeff_Vdbulk_di_Vdbulk_di)+T8_Vdbulk_di_Vdbulk_di)))))+(+MdL_less_1_Vdbulk_di_Vdbulk_di*qbeff+MdL_less_1_Vdbulk_di*qbeff_Vdbulk_di+MdL_less_1_Vdbulk_di*qbeff_Vdbulk_di+MdL_less_1*qbeff_Vdbulk_di_Vdbulk_di));
  Qb_Vdbulk_di_Vsbulk_si=(+(+inv_MdL_Vdbulk_di_Vsbulk_si*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdbulk_di*((T1_Vsbulk_si+T2_Vsbulk_si)+((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))-(((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si))))))+inv_MdL_Vsbulk_si*((T1_Vdbulk_di+T2_Vdbulk_di)+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))-((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)))))+inv_MdL*(+(+T1_Vdbulk_di_Vsbulk_si+T2_Vdbulk_di_Vsbulk_si)+(+(+T4_Vdbulk_di_Vsbulk_si*T7+T4_Vdbulk_di*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsbulk_si)-(+nq_Vdbulk_di_Vsbulk_si*((qs+qdeff)+T8)+nq_Vdbulk_di*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq_Vsbulk_si*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq*(+(+qs_Vdbulk_di_Vsbulk_si+qdeff_Vdbulk_di_Vsbulk_si)+T8_Vdbulk_di_Vsbulk_si)))))+(+MdL_less_1_Vdbulk_di_Vsbulk_si*qbeff+MdL_less_1_Vdbulk_di*qbeff_Vsbulk_si+MdL_less_1_Vsbulk_si*qbeff_Vdbulk_di+MdL_less_1*qbeff_Vdbulk_di_Vsbulk_si));
  Qb_Vdbulk_di_Vgi_bi=(+(+inv_MdL_Vdbulk_di_Vgi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdbulk_di*((T1_Vgi_bi+T2_Vgi_bi)+((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))-(((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi))))))+inv_MdL_Vgi_bi*((T1_Vdbulk_di+T2_Vdbulk_di)+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))-((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)))))+inv_MdL*(+(+T1_Vdbulk_di_Vgi_bi+T2_Vdbulk_di_Vgi_bi)+(+(+T4_Vdbulk_di_Vgi_bi*T7+T4_Vdbulk_di*T7_Vgi_bi+T4_Vgi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgi_bi)-(+nq_Vdbulk_di_Vgi_bi*((qs+qdeff)+T8)+nq_Vdbulk_di*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq_Vgi_bi*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq*(+(+qs_Vdbulk_di_Vgi_bi+qdeff_Vdbulk_di_Vgi_bi)+T8_Vdbulk_di_Vgi_bi)))))+(+MdL_less_1_Vdbulk_di_Vgi_bi*qbeff+MdL_less_1_Vdbulk_di*qbeff_Vgi_bi+MdL_less_1_Vgi_bi*qbeff_Vdbulk_di+MdL_less_1*qbeff_Vdbulk_di_Vgi_bi));
  Qb_Vdbulk_di_Vdi_bi=(+(+inv_MdL_Vdbulk_di_Vdi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdbulk_di*((T1_Vdi_bi+T2_Vdi_bi)+((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))-(((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi))))))+inv_MdL_Vdi_bi*((T1_Vdbulk_di+T2_Vdbulk_di)+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))-((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)))))+inv_MdL*(+(+T1_Vdbulk_di_Vdi_bi+T2_Vdbulk_di_Vdi_bi)+(+(+T4_Vdbulk_di_Vdi_bi*T7+T4_Vdbulk_di*T7_Vdi_bi+T4_Vdi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdi_bi)-(+nq_Vdbulk_di_Vdi_bi*((qs+qdeff)+T8)+nq_Vdbulk_di*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq_Vdi_bi*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq*(+(+qs_Vdbulk_di_Vdi_bi+qdeff_Vdbulk_di_Vdi_bi)+T8_Vdbulk_di_Vdi_bi)))))+(+MdL_less_1_Vdbulk_di_Vdi_bi*qbeff+MdL_less_1_Vdbulk_di*qbeff_Vdi_bi+MdL_less_1_Vdi_bi*qbeff_Vdbulk_di+MdL_less_1*qbeff_Vdbulk_di_Vdi_bi));
  Qb_Vdbulk_di_Vsi_bi=(+(+inv_MdL_Vdbulk_di_Vsi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdbulk_di*((T1_Vsi_bi+T2_Vsi_bi)+((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))-(((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi))))))+inv_MdL_Vsi_bi*((T1_Vdbulk_di+T2_Vdbulk_di)+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))-((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)))))+inv_MdL*(+(+T1_Vdbulk_di_Vsi_bi+T2_Vdbulk_di_Vsi_bi)+(+(+T4_Vdbulk_di_Vsi_bi*T7+T4_Vdbulk_di*T7_Vsi_bi+T4_Vsi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsi_bi)-(+nq_Vdbulk_di_Vsi_bi*((qs+qdeff)+T8)+nq_Vdbulk_di*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq_Vsi_bi*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq*(+(+qs_Vdbulk_di_Vsi_bi+qdeff_Vdbulk_di_Vsi_bi)+T8_Vdbulk_di_Vsi_bi)))))+(+MdL_less_1_Vdbulk_di_Vsi_bi*qbeff+MdL_less_1_Vdbulk_di*qbeff_Vsi_bi+MdL_less_1_Vsi_bi*qbeff_Vdbulk_di+MdL_less_1*qbeff_Vdbulk_di_Vsi_bi));
  Qb_Vdbulk_di_Tempt_GND=(+(+inv_MdL_Vdbulk_di_Tempt_GND*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdbulk_di*((T1_Tempt_GND+T2_Tempt_GND)+((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))-(((nq_Tempt_GND*((qs+qdeff)+T8))+(nq*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND))))))+inv_MdL_Tempt_GND*((T1_Vdbulk_di+T2_Vdbulk_di)+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))-((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)))))+inv_MdL*(+(+T1_Vdbulk_di_Tempt_GND+T2_Vdbulk_di_Tempt_GND)+(+(+T4_Vdbulk_di_Tempt_GND*T7+T4_Vdbulk_di*T7_Tempt_GND+T4_Tempt_GND*T7_Vdbulk_di+T4*T7_Vdbulk_di_Tempt_GND)-(+nq_Vdbulk_di_Tempt_GND*((qs+qdeff)+T8)+nq_Vdbulk_di*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND)+nq_Tempt_GND*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq*(+(+qs_Vdbulk_di_Tempt_GND+qdeff_Vdbulk_di_Tempt_GND)+T8_Vdbulk_di_Tempt_GND)))))+(+MdL_less_1_Vdbulk_di_Tempt_GND*qbeff+MdL_less_1_Vdbulk_di*qbeff_Tempt_GND+MdL_less_1_Tempt_GND*qbeff_Vdbulk_di+MdL_less_1*qbeff_Vdbulk_di_Tempt_GND));
#endif
Qb_Vsbulk_si=(((inv_MdL_Vsbulk_si*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(inv_MdL*((T1_Vsbulk_si+T2_Vsbulk_si)+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))-((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)))))))+((MdL_less_1_Vsbulk_si*qbeff)+(MdL_less_1*qbeff_Vsbulk_si)));
#if defined(_DERIVATE2)
  Qb_Vsbulk_si_Vdbulk_di=(+(+inv_MdL_Vsbulk_si_Vdbulk_di*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsbulk_si*((T1_Vdbulk_di+T2_Vdbulk_di)+((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))-(((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di))))))+inv_MdL_Vdbulk_di*((T1_Vsbulk_si+T2_Vsbulk_si)+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))-((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)))))+inv_MdL*(+(+T1_Vsbulk_si_Vdbulk_di+T2_Vsbulk_si_Vdbulk_di)+(+(+T4_Vsbulk_si_Vdbulk_di*T7+T4_Vsbulk_si*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdbulk_di)-(+nq_Vsbulk_si_Vdbulk_di*((qs+qdeff)+T8)+nq_Vsbulk_si*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq_Vdbulk_di*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq*(+(+qs_Vsbulk_si_Vdbulk_di+qdeff_Vsbulk_si_Vdbulk_di)+T8_Vsbulk_si_Vdbulk_di)))))+(+MdL_less_1_Vsbulk_si_Vdbulk_di*qbeff+MdL_less_1_Vsbulk_si*qbeff_Vdbulk_di+MdL_less_1_Vdbulk_di*qbeff_Vsbulk_si+MdL_less_1*qbeff_Vsbulk_si_Vdbulk_di));
  Qb_Vsbulk_si_Vsbulk_si=(+(+inv_MdL_Vsbulk_si_Vsbulk_si*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsbulk_si*((T1_Vsbulk_si+T2_Vsbulk_si)+((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))-(((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si))))))+inv_MdL_Vsbulk_si*((T1_Vsbulk_si+T2_Vsbulk_si)+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))-((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)))))+inv_MdL*(+(+T1_Vsbulk_si_Vsbulk_si+T2_Vsbulk_si_Vsbulk_si)+(+(+T4_Vsbulk_si_Vsbulk_si*T7+T4_Vsbulk_si*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsbulk_si)-(+nq_Vsbulk_si_Vsbulk_si*((qs+qdeff)+T8)+nq_Vsbulk_si*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq_Vsbulk_si*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq*(+(+qs_Vsbulk_si_Vsbulk_si+qdeff_Vsbulk_si_Vsbulk_si)+T8_Vsbulk_si_Vsbulk_si)))))+(+MdL_less_1_Vsbulk_si_Vsbulk_si*qbeff+MdL_less_1_Vsbulk_si*qbeff_Vsbulk_si+MdL_less_1_Vsbulk_si*qbeff_Vsbulk_si+MdL_less_1*qbeff_Vsbulk_si_Vsbulk_si));
  Qb_Vsbulk_si_Vgi_bi=(+(+inv_MdL_Vsbulk_si_Vgi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsbulk_si*((T1_Vgi_bi+T2_Vgi_bi)+((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))-(((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi))))))+inv_MdL_Vgi_bi*((T1_Vsbulk_si+T2_Vsbulk_si)+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))-((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)))))+inv_MdL*(+(+T1_Vsbulk_si_Vgi_bi+T2_Vsbulk_si_Vgi_bi)+(+(+T4_Vsbulk_si_Vgi_bi*T7+T4_Vsbulk_si*T7_Vgi_bi+T4_Vgi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgi_bi)-(+nq_Vsbulk_si_Vgi_bi*((qs+qdeff)+T8)+nq_Vsbulk_si*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq_Vgi_bi*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq*(+(+qs_Vsbulk_si_Vgi_bi+qdeff_Vsbulk_si_Vgi_bi)+T8_Vsbulk_si_Vgi_bi)))))+(+MdL_less_1_Vsbulk_si_Vgi_bi*qbeff+MdL_less_1_Vsbulk_si*qbeff_Vgi_bi+MdL_less_1_Vgi_bi*qbeff_Vsbulk_si+MdL_less_1*qbeff_Vsbulk_si_Vgi_bi));
  Qb_Vsbulk_si_Vdi_bi=(+(+inv_MdL_Vsbulk_si_Vdi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsbulk_si*((T1_Vdi_bi+T2_Vdi_bi)+((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))-(((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi))))))+inv_MdL_Vdi_bi*((T1_Vsbulk_si+T2_Vsbulk_si)+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))-((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)))))+inv_MdL*(+(+T1_Vsbulk_si_Vdi_bi+T2_Vsbulk_si_Vdi_bi)+(+(+T4_Vsbulk_si_Vdi_bi*T7+T4_Vsbulk_si*T7_Vdi_bi+T4_Vdi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdi_bi)-(+nq_Vsbulk_si_Vdi_bi*((qs+qdeff)+T8)+nq_Vsbulk_si*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq_Vdi_bi*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq*(+(+qs_Vsbulk_si_Vdi_bi+qdeff_Vsbulk_si_Vdi_bi)+T8_Vsbulk_si_Vdi_bi)))))+(+MdL_less_1_Vsbulk_si_Vdi_bi*qbeff+MdL_less_1_Vsbulk_si*qbeff_Vdi_bi+MdL_less_1_Vdi_bi*qbeff_Vsbulk_si+MdL_less_1*qbeff_Vsbulk_si_Vdi_bi));
  Qb_Vsbulk_si_Vsi_bi=(+(+inv_MdL_Vsbulk_si_Vsi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsbulk_si*((T1_Vsi_bi+T2_Vsi_bi)+((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))-(((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi))))))+inv_MdL_Vsi_bi*((T1_Vsbulk_si+T2_Vsbulk_si)+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))-((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)))))+inv_MdL*(+(+T1_Vsbulk_si_Vsi_bi+T2_Vsbulk_si_Vsi_bi)+(+(+T4_Vsbulk_si_Vsi_bi*T7+T4_Vsbulk_si*T7_Vsi_bi+T4_Vsi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsi_bi)-(+nq_Vsbulk_si_Vsi_bi*((qs+qdeff)+T8)+nq_Vsbulk_si*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq_Vsi_bi*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq*(+(+qs_Vsbulk_si_Vsi_bi+qdeff_Vsbulk_si_Vsi_bi)+T8_Vsbulk_si_Vsi_bi)))))+(+MdL_less_1_Vsbulk_si_Vsi_bi*qbeff+MdL_less_1_Vsbulk_si*qbeff_Vsi_bi+MdL_less_1_Vsi_bi*qbeff_Vsbulk_si+MdL_less_1*qbeff_Vsbulk_si_Vsi_bi));
  Qb_Vsbulk_si_Tempt_GND=(+(+inv_MdL_Vsbulk_si_Tempt_GND*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsbulk_si*((T1_Tempt_GND+T2_Tempt_GND)+((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))-(((nq_Tempt_GND*((qs+qdeff)+T8))+(nq*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND))))))+inv_MdL_Tempt_GND*((T1_Vsbulk_si+T2_Vsbulk_si)+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))-((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)))))+inv_MdL*(+(+T1_Vsbulk_si_Tempt_GND+T2_Vsbulk_si_Tempt_GND)+(+(+T4_Vsbulk_si_Tempt_GND*T7+T4_Vsbulk_si*T7_Tempt_GND+T4_Tempt_GND*T7_Vsbulk_si+T4*T7_Vsbulk_si_Tempt_GND)-(+nq_Vsbulk_si_Tempt_GND*((qs+qdeff)+T8)+nq_Vsbulk_si*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND)+nq_Tempt_GND*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq*(+(+qs_Vsbulk_si_Tempt_GND+qdeff_Vsbulk_si_Tempt_GND)+T8_Vsbulk_si_Tempt_GND)))))+(+MdL_less_1_Vsbulk_si_Tempt_GND*qbeff+MdL_less_1_Vsbulk_si*qbeff_Tempt_GND+MdL_less_1_Tempt_GND*qbeff_Vsbulk_si+MdL_less_1*qbeff_Vsbulk_si_Tempt_GND));
#endif
Qb_Vgi_bi=(((inv_MdL_Vgi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(inv_MdL*((T1_Vgi_bi+T2_Vgi_bi)+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))-((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)))))))+((MdL_less_1_Vgi_bi*qbeff)+(MdL_less_1*qbeff_Vgi_bi)));
#if defined(_DERIVATE2)
  Qb_Vgi_bi_Vdbulk_di=(+(+inv_MdL_Vgi_bi_Vdbulk_di*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vgi_bi*((T1_Vdbulk_di+T2_Vdbulk_di)+((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))-(((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di))))))+inv_MdL_Vdbulk_di*((T1_Vgi_bi+T2_Vgi_bi)+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))-((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)))))+inv_MdL*(+(+T1_Vgi_bi_Vdbulk_di+T2_Vgi_bi_Vdbulk_di)+(+(+T4_Vgi_bi_Vdbulk_di*T7+T4_Vgi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vdbulk_di)-(+nq_Vgi_bi_Vdbulk_di*((qs+qdeff)+T8)+nq_Vgi_bi*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq_Vdbulk_di*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq*(+(+qs_Vgi_bi_Vdbulk_di+qdeff_Vgi_bi_Vdbulk_di)+T8_Vgi_bi_Vdbulk_di)))))+(+MdL_less_1_Vgi_bi_Vdbulk_di*qbeff+MdL_less_1_Vgi_bi*qbeff_Vdbulk_di+MdL_less_1_Vdbulk_di*qbeff_Vgi_bi+MdL_less_1*qbeff_Vgi_bi_Vdbulk_di));
  Qb_Vgi_bi_Vsbulk_si=(+(+inv_MdL_Vgi_bi_Vsbulk_si*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vgi_bi*((T1_Vsbulk_si+T2_Vsbulk_si)+((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))-(((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si))))))+inv_MdL_Vsbulk_si*((T1_Vgi_bi+T2_Vgi_bi)+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))-((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)))))+inv_MdL*(+(+T1_Vgi_bi_Vsbulk_si+T2_Vgi_bi_Vsbulk_si)+(+(+T4_Vgi_bi_Vsbulk_si*T7+T4_Vgi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vsbulk_si)-(+nq_Vgi_bi_Vsbulk_si*((qs+qdeff)+T8)+nq_Vgi_bi*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq_Vsbulk_si*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq*(+(+qs_Vgi_bi_Vsbulk_si+qdeff_Vgi_bi_Vsbulk_si)+T8_Vgi_bi_Vsbulk_si)))))+(+MdL_less_1_Vgi_bi_Vsbulk_si*qbeff+MdL_less_1_Vgi_bi*qbeff_Vsbulk_si+MdL_less_1_Vsbulk_si*qbeff_Vgi_bi+MdL_less_1*qbeff_Vgi_bi_Vsbulk_si));
  Qb_Vgi_bi_Vgi_bi=(+(+inv_MdL_Vgi_bi_Vgi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vgi_bi*((T1_Vgi_bi+T2_Vgi_bi)+((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))-(((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi))))))+inv_MdL_Vgi_bi*((T1_Vgi_bi+T2_Vgi_bi)+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))-((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)))))+inv_MdL*(+(+T1_Vgi_bi_Vgi_bi+T2_Vgi_bi_Vgi_bi)+(+(+T4_Vgi_bi_Vgi_bi*T7+T4_Vgi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vgi_bi)-(+nq_Vgi_bi_Vgi_bi*((qs+qdeff)+T8)+nq_Vgi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq_Vgi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq*(+(+qs_Vgi_bi_Vgi_bi+qdeff_Vgi_bi_Vgi_bi)+T8_Vgi_bi_Vgi_bi)))))+(+MdL_less_1_Vgi_bi_Vgi_bi*qbeff+MdL_less_1_Vgi_bi*qbeff_Vgi_bi+MdL_less_1_Vgi_bi*qbeff_Vgi_bi+MdL_less_1*qbeff_Vgi_bi_Vgi_bi));
  Qb_Vgi_bi_Vdi_bi=(+(+inv_MdL_Vgi_bi_Vdi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vgi_bi*((T1_Vdi_bi+T2_Vdi_bi)+((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))-(((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi))))))+inv_MdL_Vdi_bi*((T1_Vgi_bi+T2_Vgi_bi)+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))-((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)))))+inv_MdL*(+(+T1_Vgi_bi_Vdi_bi+T2_Vgi_bi_Vdi_bi)+(+(+T4_Vgi_bi_Vdi_bi*T7+T4_Vgi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vdi_bi)-(+nq_Vgi_bi_Vdi_bi*((qs+qdeff)+T8)+nq_Vgi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq_Vdi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq*(+(+qs_Vgi_bi_Vdi_bi+qdeff_Vgi_bi_Vdi_bi)+T8_Vgi_bi_Vdi_bi)))))+(+MdL_less_1_Vgi_bi_Vdi_bi*qbeff+MdL_less_1_Vgi_bi*qbeff_Vdi_bi+MdL_less_1_Vdi_bi*qbeff_Vgi_bi+MdL_less_1*qbeff_Vgi_bi_Vdi_bi));
  Qb_Vgi_bi_Vsi_bi=(+(+inv_MdL_Vgi_bi_Vsi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vgi_bi*((T1_Vsi_bi+T2_Vsi_bi)+((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))-(((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi))))))+inv_MdL_Vsi_bi*((T1_Vgi_bi+T2_Vgi_bi)+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))-((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)))))+inv_MdL*(+(+T1_Vgi_bi_Vsi_bi+T2_Vgi_bi_Vsi_bi)+(+(+T4_Vgi_bi_Vsi_bi*T7+T4_Vgi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vsi_bi)-(+nq_Vgi_bi_Vsi_bi*((qs+qdeff)+T8)+nq_Vgi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq_Vsi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq*(+(+qs_Vgi_bi_Vsi_bi+qdeff_Vgi_bi_Vsi_bi)+T8_Vgi_bi_Vsi_bi)))))+(+MdL_less_1_Vgi_bi_Vsi_bi*qbeff+MdL_less_1_Vgi_bi*qbeff_Vsi_bi+MdL_less_1_Vsi_bi*qbeff_Vgi_bi+MdL_less_1*qbeff_Vgi_bi_Vsi_bi));
  Qb_Vgi_bi_Tempt_GND=(+(+inv_MdL_Vgi_bi_Tempt_GND*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vgi_bi*((T1_Tempt_GND+T2_Tempt_GND)+((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))-(((nq_Tempt_GND*((qs+qdeff)+T8))+(nq*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND))))))+inv_MdL_Tempt_GND*((T1_Vgi_bi+T2_Vgi_bi)+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))-((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)))))+inv_MdL*(+(+T1_Vgi_bi_Tempt_GND+T2_Vgi_bi_Tempt_GND)+(+(+T4_Vgi_bi_Tempt_GND*T7+T4_Vgi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vgi_bi+T4*T7_Vgi_bi_Tempt_GND)-(+nq_Vgi_bi_Tempt_GND*((qs+qdeff)+T8)+nq_Vgi_bi*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND)+nq_Tempt_GND*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq*(+(+qs_Vgi_bi_Tempt_GND+qdeff_Vgi_bi_Tempt_GND)+T8_Vgi_bi_Tempt_GND)))))+(+MdL_less_1_Vgi_bi_Tempt_GND*qbeff+MdL_less_1_Vgi_bi*qbeff_Tempt_GND+MdL_less_1_Tempt_GND*qbeff_Vgi_bi+MdL_less_1*qbeff_Vgi_bi_Tempt_GND));
#endif
Qb_Vdi_bi=(((inv_MdL_Vdi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(inv_MdL*((T1_Vdi_bi+T2_Vdi_bi)+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))-((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)))))))+((MdL_less_1_Vdi_bi*qbeff)+(MdL_less_1*qbeff_Vdi_bi)));
#if defined(_DERIVATE2)
  Qb_Vdi_bi_Vdbulk_di=(+(+inv_MdL_Vdi_bi_Vdbulk_di*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdi_bi*((T1_Vdbulk_di+T2_Vdbulk_di)+((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))-(((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di))))))+inv_MdL_Vdbulk_di*((T1_Vdi_bi+T2_Vdi_bi)+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))-((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)))))+inv_MdL*(+(+T1_Vdi_bi_Vdbulk_di+T2_Vdi_bi_Vdbulk_di)+(+(+T4_Vdi_bi_Vdbulk_di*T7+T4_Vdi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vdbulk_di)-(+nq_Vdi_bi_Vdbulk_di*((qs+qdeff)+T8)+nq_Vdi_bi*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq_Vdbulk_di*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq*(+(+qs_Vdi_bi_Vdbulk_di+qdeff_Vdi_bi_Vdbulk_di)+T8_Vdi_bi_Vdbulk_di)))))+(+MdL_less_1_Vdi_bi_Vdbulk_di*qbeff+MdL_less_1_Vdi_bi*qbeff_Vdbulk_di+MdL_less_1_Vdbulk_di*qbeff_Vdi_bi+MdL_less_1*qbeff_Vdi_bi_Vdbulk_di));
  Qb_Vdi_bi_Vsbulk_si=(+(+inv_MdL_Vdi_bi_Vsbulk_si*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdi_bi*((T1_Vsbulk_si+T2_Vsbulk_si)+((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))-(((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si))))))+inv_MdL_Vsbulk_si*((T1_Vdi_bi+T2_Vdi_bi)+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))-((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)))))+inv_MdL*(+(+T1_Vdi_bi_Vsbulk_si+T2_Vdi_bi_Vsbulk_si)+(+(+T4_Vdi_bi_Vsbulk_si*T7+T4_Vdi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vsbulk_si)-(+nq_Vdi_bi_Vsbulk_si*((qs+qdeff)+T8)+nq_Vdi_bi*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq_Vsbulk_si*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq*(+(+qs_Vdi_bi_Vsbulk_si+qdeff_Vdi_bi_Vsbulk_si)+T8_Vdi_bi_Vsbulk_si)))))+(+MdL_less_1_Vdi_bi_Vsbulk_si*qbeff+MdL_less_1_Vdi_bi*qbeff_Vsbulk_si+MdL_less_1_Vsbulk_si*qbeff_Vdi_bi+MdL_less_1*qbeff_Vdi_bi_Vsbulk_si));
  Qb_Vdi_bi_Vgi_bi=(+(+inv_MdL_Vdi_bi_Vgi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdi_bi*((T1_Vgi_bi+T2_Vgi_bi)+((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))-(((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi))))))+inv_MdL_Vgi_bi*((T1_Vdi_bi+T2_Vdi_bi)+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))-((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)))))+inv_MdL*(+(+T1_Vdi_bi_Vgi_bi+T2_Vdi_bi_Vgi_bi)+(+(+T4_Vdi_bi_Vgi_bi*T7+T4_Vdi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vgi_bi)-(+nq_Vdi_bi_Vgi_bi*((qs+qdeff)+T8)+nq_Vdi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq_Vgi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq*(+(+qs_Vdi_bi_Vgi_bi+qdeff_Vdi_bi_Vgi_bi)+T8_Vdi_bi_Vgi_bi)))))+(+MdL_less_1_Vdi_bi_Vgi_bi*qbeff+MdL_less_1_Vdi_bi*qbeff_Vgi_bi+MdL_less_1_Vgi_bi*qbeff_Vdi_bi+MdL_less_1*qbeff_Vdi_bi_Vgi_bi));
  Qb_Vdi_bi_Vdi_bi=(+(+inv_MdL_Vdi_bi_Vdi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdi_bi*((T1_Vdi_bi+T2_Vdi_bi)+((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))-(((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi))))))+inv_MdL_Vdi_bi*((T1_Vdi_bi+T2_Vdi_bi)+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))-((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)))))+inv_MdL*(+(+T1_Vdi_bi_Vdi_bi+T2_Vdi_bi_Vdi_bi)+(+(+T4_Vdi_bi_Vdi_bi*T7+T4_Vdi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vdi_bi)-(+nq_Vdi_bi_Vdi_bi*((qs+qdeff)+T8)+nq_Vdi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq_Vdi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq*(+(+qs_Vdi_bi_Vdi_bi+qdeff_Vdi_bi_Vdi_bi)+T8_Vdi_bi_Vdi_bi)))))+(+MdL_less_1_Vdi_bi_Vdi_bi*qbeff+MdL_less_1_Vdi_bi*qbeff_Vdi_bi+MdL_less_1_Vdi_bi*qbeff_Vdi_bi+MdL_less_1*qbeff_Vdi_bi_Vdi_bi));
  Qb_Vdi_bi_Vsi_bi=(+(+inv_MdL_Vdi_bi_Vsi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdi_bi*((T1_Vsi_bi+T2_Vsi_bi)+((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))-(((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi))))))+inv_MdL_Vsi_bi*((T1_Vdi_bi+T2_Vdi_bi)+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))-((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)))))+inv_MdL*(+(+T1_Vdi_bi_Vsi_bi+T2_Vdi_bi_Vsi_bi)+(+(+T4_Vdi_bi_Vsi_bi*T7+T4_Vdi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vsi_bi)-(+nq_Vdi_bi_Vsi_bi*((qs+qdeff)+T8)+nq_Vdi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq_Vsi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq*(+(+qs_Vdi_bi_Vsi_bi+qdeff_Vdi_bi_Vsi_bi)+T8_Vdi_bi_Vsi_bi)))))+(+MdL_less_1_Vdi_bi_Vsi_bi*qbeff+MdL_less_1_Vdi_bi*qbeff_Vsi_bi+MdL_less_1_Vsi_bi*qbeff_Vdi_bi+MdL_less_1*qbeff_Vdi_bi_Vsi_bi));
  Qb_Vdi_bi_Tempt_GND=(+(+inv_MdL_Vdi_bi_Tempt_GND*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vdi_bi*((T1_Tempt_GND+T2_Tempt_GND)+((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))-(((nq_Tempt_GND*((qs+qdeff)+T8))+(nq*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND))))))+inv_MdL_Tempt_GND*((T1_Vdi_bi+T2_Vdi_bi)+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))-((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)))))+inv_MdL*(+(+T1_Vdi_bi_Tempt_GND+T2_Vdi_bi_Tempt_GND)+(+(+T4_Vdi_bi_Tempt_GND*T7+T4_Vdi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vdi_bi+T4*T7_Vdi_bi_Tempt_GND)-(+nq_Vdi_bi_Tempt_GND*((qs+qdeff)+T8)+nq_Vdi_bi*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND)+nq_Tempt_GND*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq*(+(+qs_Vdi_bi_Tempt_GND+qdeff_Vdi_bi_Tempt_GND)+T8_Vdi_bi_Tempt_GND)))))+(+MdL_less_1_Vdi_bi_Tempt_GND*qbeff+MdL_less_1_Vdi_bi*qbeff_Tempt_GND+MdL_less_1_Tempt_GND*qbeff_Vdi_bi+MdL_less_1*qbeff_Vdi_bi_Tempt_GND));
#endif
Qb_Vsi_bi=(((inv_MdL_Vsi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(inv_MdL*((T1_Vsi_bi+T2_Vsi_bi)+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))-((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)))))))+((MdL_less_1_Vsi_bi*qbeff)+(MdL_less_1*qbeff_Vsi_bi)));
#if defined(_DERIVATE2)
  Qb_Vsi_bi_Vdbulk_di=(+(+inv_MdL_Vsi_bi_Vdbulk_di*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsi_bi*((T1_Vdbulk_di+T2_Vdbulk_di)+((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))-(((nq_Vdbulk_di*((qs+qdeff)+T8))+(nq*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di))))))+inv_MdL_Vdbulk_di*((T1_Vsi_bi+T2_Vsi_bi)+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))-((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)))))+inv_MdL*(+(+T1_Vsi_bi_Vdbulk_di+T2_Vsi_bi_Vdbulk_di)+(+(+T4_Vsi_bi_Vdbulk_di*T7+T4_Vsi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vdbulk_di)-(+nq_Vsi_bi_Vdbulk_di*((qs+qdeff)+T8)+nq_Vsi_bi*((qs_Vdbulk_di+qdeff_Vdbulk_di)+T8_Vdbulk_di)+nq_Vdbulk_di*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq*(+(+qs_Vsi_bi_Vdbulk_di+qdeff_Vsi_bi_Vdbulk_di)+T8_Vsi_bi_Vdbulk_di)))))+(+MdL_less_1_Vsi_bi_Vdbulk_di*qbeff+MdL_less_1_Vsi_bi*qbeff_Vdbulk_di+MdL_less_1_Vdbulk_di*qbeff_Vsi_bi+MdL_less_1*qbeff_Vsi_bi_Vdbulk_di));
  Qb_Vsi_bi_Vsbulk_si=(+(+inv_MdL_Vsi_bi_Vsbulk_si*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsi_bi*((T1_Vsbulk_si+T2_Vsbulk_si)+((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))-(((nq_Vsbulk_si*((qs+qdeff)+T8))+(nq*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si))))))+inv_MdL_Vsbulk_si*((T1_Vsi_bi+T2_Vsi_bi)+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))-((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)))))+inv_MdL*(+(+T1_Vsi_bi_Vsbulk_si+T2_Vsi_bi_Vsbulk_si)+(+(+T4_Vsi_bi_Vsbulk_si*T7+T4_Vsi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vsbulk_si)-(+nq_Vsi_bi_Vsbulk_si*((qs+qdeff)+T8)+nq_Vsi_bi*((qs_Vsbulk_si+qdeff_Vsbulk_si)+T8_Vsbulk_si)+nq_Vsbulk_si*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq*(+(+qs_Vsi_bi_Vsbulk_si+qdeff_Vsi_bi_Vsbulk_si)+T8_Vsi_bi_Vsbulk_si)))))+(+MdL_less_1_Vsi_bi_Vsbulk_si*qbeff+MdL_less_1_Vsi_bi*qbeff_Vsbulk_si+MdL_less_1_Vsbulk_si*qbeff_Vsi_bi+MdL_less_1*qbeff_Vsi_bi_Vsbulk_si));
  Qb_Vsi_bi_Vgi_bi=(+(+inv_MdL_Vsi_bi_Vgi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsi_bi*((T1_Vgi_bi+T2_Vgi_bi)+((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))-(((nq_Vgi_bi*((qs+qdeff)+T8))+(nq*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi))))))+inv_MdL_Vgi_bi*((T1_Vsi_bi+T2_Vsi_bi)+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))-((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)))))+inv_MdL*(+(+T1_Vsi_bi_Vgi_bi+T2_Vsi_bi_Vgi_bi)+(+(+T4_Vsi_bi_Vgi_bi*T7+T4_Vsi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vgi_bi)-(+nq_Vsi_bi_Vgi_bi*((qs+qdeff)+T8)+nq_Vsi_bi*((qs_Vgi_bi+qdeff_Vgi_bi)+T8_Vgi_bi)+nq_Vgi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq*(+(+qs_Vsi_bi_Vgi_bi+qdeff_Vsi_bi_Vgi_bi)+T8_Vsi_bi_Vgi_bi)))))+(+MdL_less_1_Vsi_bi_Vgi_bi*qbeff+MdL_less_1_Vsi_bi*qbeff_Vgi_bi+MdL_less_1_Vgi_bi*qbeff_Vsi_bi+MdL_less_1*qbeff_Vsi_bi_Vgi_bi));
  Qb_Vsi_bi_Vdi_bi=(+(+inv_MdL_Vsi_bi_Vdi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsi_bi*((T1_Vdi_bi+T2_Vdi_bi)+((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))-(((nq_Vdi_bi*((qs+qdeff)+T8))+(nq*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi))))))+inv_MdL_Vdi_bi*((T1_Vsi_bi+T2_Vsi_bi)+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))-((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)))))+inv_MdL*(+(+T1_Vsi_bi_Vdi_bi+T2_Vsi_bi_Vdi_bi)+(+(+T4_Vsi_bi_Vdi_bi*T7+T4_Vsi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vdi_bi)-(+nq_Vsi_bi_Vdi_bi*((qs+qdeff)+T8)+nq_Vsi_bi*((qs_Vdi_bi+qdeff_Vdi_bi)+T8_Vdi_bi)+nq_Vdi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq*(+(+qs_Vsi_bi_Vdi_bi+qdeff_Vsi_bi_Vdi_bi)+T8_Vsi_bi_Vdi_bi)))))+(+MdL_less_1_Vsi_bi_Vdi_bi*qbeff+MdL_less_1_Vsi_bi*qbeff_Vdi_bi+MdL_less_1_Vdi_bi*qbeff_Vsi_bi+MdL_less_1*qbeff_Vsi_bi_Vdi_bi));
  Qb_Vsi_bi_Vsi_bi=(+(+inv_MdL_Vsi_bi_Vsi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsi_bi*((T1_Vsi_bi+T2_Vsi_bi)+((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))-(((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi))))))+inv_MdL_Vsi_bi*((T1_Vsi_bi+T2_Vsi_bi)+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))-((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)))))+inv_MdL*(+(+T1_Vsi_bi_Vsi_bi+T2_Vsi_bi_Vsi_bi)+(+(+T4_Vsi_bi_Vsi_bi*T7+T4_Vsi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vsi_bi)-(+nq_Vsi_bi_Vsi_bi*((qs+qdeff)+T8)+nq_Vsi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq_Vsi_bi*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq*(+(+qs_Vsi_bi_Vsi_bi+qdeff_Vsi_bi_Vsi_bi)+T8_Vsi_bi_Vsi_bi)))))+(+MdL_less_1_Vsi_bi_Vsi_bi*qbeff+MdL_less_1_Vsi_bi*qbeff_Vsi_bi+MdL_less_1_Vsi_bi*qbeff_Vsi_bi+MdL_less_1*qbeff_Vsi_bi_Vsi_bi));
  Qb_Vsi_bi_Tempt_GND=(+(+inv_MdL_Vsi_bi_Tempt_GND*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8))))+inv_MdL_Vsi_bi*((T1_Tempt_GND+T2_Tempt_GND)+((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))-(((nq_Tempt_GND*((qs+qdeff)+T8))+(nq*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND))))))+inv_MdL_Tempt_GND*((T1_Vsi_bi+T2_Vsi_bi)+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))-((nq_Vsi_bi*((qs+qdeff)+T8))+(nq*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)))))+inv_MdL*(+(+T1_Vsi_bi_Tempt_GND+T2_Vsi_bi_Tempt_GND)+(+(+T4_Vsi_bi_Tempt_GND*T7+T4_Vsi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vsi_bi+T4*T7_Vsi_bi_Tempt_GND)-(+nq_Vsi_bi_Tempt_GND*((qs+qdeff)+T8)+nq_Vsi_bi*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND)+nq_Tempt_GND*((qs_Vsi_bi+qdeff_Vsi_bi)+T8_Vsi_bi)+nq*(+(+qs_Vsi_bi_Tempt_GND+qdeff_Vsi_bi_Tempt_GND)+T8_Vsi_bi_Tempt_GND)))))+(+MdL_less_1_Vsi_bi_Tempt_GND*qbeff+MdL_less_1_Vsi_bi*qbeff_Tempt_GND+MdL_less_1_Tempt_GND*qbeff_Vsi_bi+MdL_less_1*qbeff_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
Qb_Tempt_GND=(((inv_MdL_Tempt_GND*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(inv_MdL*((T1_Tempt_GND+T2_Tempt_GND)+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND))-((nq_Tempt_GND*((qs+qdeff)+T8))+(nq*((qs_Tempt_GND+qdeff_Tempt_GND)+T8_Tempt_GND)))))))+((MdL_less_1_Tempt_GND*qbeff)+(MdL_less_1*qbeff_Tempt_GND)));
#endif
#endif
Qb=((inv_MdL*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*qbeff));
EXIT_IF_ISNAN(((inv_MdL*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*qbeff)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=0.0;
  T9_Vgm_si_Vgm_di=0.0;
  T9_Vgm_si_Vdbulk_di=0.0;
  T9_Vgm_si_Vsbulk_si=0.0;
  T9_Vgm_si_Vdi_bi=0.0;
  T9_Vgm_si_Vsi_bi=0.0;
  T9_Vgm_si_Tempt_GND=0.0;
  T9_Vgm_si_Vgi_bi=0.0;
#endif
T9_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=0.0;
  T9_Vgm_di_Vgm_di=0.0;
  T9_Vgm_di_Vdbulk_di=0.0;
  T9_Vgm_di_Vsbulk_si=0.0;
  T9_Vgm_di_Vdi_bi=0.0;
  T9_Vgm_di_Vsi_bi=0.0;
  T9_Vgm_di_Tempt_GND=0.0;
  T9_Vgm_di_Vgi_bi=0.0;
#endif
T9_Vdbulk_di=(qs_Vdbulk_di+qdeff_Vdbulk_di);
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=(+qs_Vdbulk_di_Vgm_si+qdeff_Vdbulk_di_Vgm_si);
  T9_Vdbulk_di_Vgm_di=(+qs_Vdbulk_di_Vgm_di+qdeff_Vdbulk_di_Vgm_di);
  T9_Vdbulk_di_Vdbulk_di=(+qs_Vdbulk_di_Vdbulk_di+qdeff_Vdbulk_di_Vdbulk_di);
  T9_Vdbulk_di_Vsbulk_si=(+qs_Vdbulk_di_Vsbulk_si+qdeff_Vdbulk_di_Vsbulk_si);
  T9_Vdbulk_di_Vdi_bi=(+qs_Vdbulk_di_Vdi_bi+qdeff_Vdbulk_di_Vdi_bi);
  T9_Vdbulk_di_Vsi_bi=(+qs_Vdbulk_di_Vsi_bi+qdeff_Vdbulk_di_Vsi_bi);
  T9_Vdbulk_di_Tempt_GND=(+qs_Vdbulk_di_Tempt_GND+qdeff_Vdbulk_di_Tempt_GND);
  T9_Vdbulk_di_Vgi_bi=(+qs_Vdbulk_di_Vgi_bi+qdeff_Vdbulk_di_Vgi_bi);
#endif
T9_Vsbulk_si=(qs_Vsbulk_si+qdeff_Vsbulk_si);
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=(+qs_Vsbulk_si_Vgm_si+qdeff_Vsbulk_si_Vgm_si);
  T9_Vsbulk_si_Vgm_di=(+qs_Vsbulk_si_Vgm_di+qdeff_Vsbulk_si_Vgm_di);
  T9_Vsbulk_si_Vdbulk_di=(+qs_Vsbulk_si_Vdbulk_di+qdeff_Vsbulk_si_Vdbulk_di);
  T9_Vsbulk_si_Vsbulk_si=(+qs_Vsbulk_si_Vsbulk_si+qdeff_Vsbulk_si_Vsbulk_si);
  T9_Vsbulk_si_Vdi_bi=(+qs_Vsbulk_si_Vdi_bi+qdeff_Vsbulk_si_Vdi_bi);
  T9_Vsbulk_si_Vsi_bi=(+qs_Vsbulk_si_Vsi_bi+qdeff_Vsbulk_si_Vsi_bi);
  T9_Vsbulk_si_Tempt_GND=(+qs_Vsbulk_si_Tempt_GND+qdeff_Vsbulk_si_Tempt_GND);
  T9_Vsbulk_si_Vgi_bi=(+qs_Vsbulk_si_Vgi_bi+qdeff_Vsbulk_si_Vgi_bi);
#endif
T9_Vdi_bi=(qs_Vdi_bi+qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+qs_Vdi_bi_Vgm_si+qdeff_Vdi_bi_Vgm_si);
  T9_Vdi_bi_Vgm_di=(+qs_Vdi_bi_Vgm_di+qdeff_Vdi_bi_Vgm_di);
  T9_Vdi_bi_Vdbulk_di=(+qs_Vdi_bi_Vdbulk_di+qdeff_Vdi_bi_Vdbulk_di);
  T9_Vdi_bi_Vsbulk_si=(+qs_Vdi_bi_Vsbulk_si+qdeff_Vdi_bi_Vsbulk_si);
  T9_Vdi_bi_Vdi_bi=(+qs_Vdi_bi_Vdi_bi+qdeff_Vdi_bi_Vdi_bi);
  T9_Vdi_bi_Vsi_bi=(+qs_Vdi_bi_Vsi_bi+qdeff_Vdi_bi_Vsi_bi);
  T9_Vdi_bi_Tempt_GND=(+qs_Vdi_bi_Tempt_GND+qdeff_Vdi_bi_Tempt_GND);
  T9_Vdi_bi_Vgi_bi=(+qs_Vdi_bi_Vgi_bi+qdeff_Vdi_bi_Vgi_bi);
#endif
T9_Vsi_bi=(qs_Vsi_bi+qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+qs_Vsi_bi_Vgm_si+qdeff_Vsi_bi_Vgm_si);
  T9_Vsi_bi_Vgm_di=(+qs_Vsi_bi_Vgm_di+qdeff_Vsi_bi_Vgm_di);
  T9_Vsi_bi_Vdbulk_di=(+qs_Vsi_bi_Vdbulk_di+qdeff_Vsi_bi_Vdbulk_di);
  T9_Vsi_bi_Vsbulk_si=(+qs_Vsi_bi_Vsbulk_si+qdeff_Vsi_bi_Vsbulk_si);
  T9_Vsi_bi_Vdi_bi=(+qs_Vsi_bi_Vdi_bi+qdeff_Vsi_bi_Vdi_bi);
  T9_Vsi_bi_Vsi_bi=(+qs_Vsi_bi_Vsi_bi+qdeff_Vsi_bi_Vsi_bi);
  T9_Vsi_bi_Tempt_GND=(+qs_Vsi_bi_Tempt_GND+qdeff_Vsi_bi_Tempt_GND);
  T9_Vsi_bi_Vgi_bi=(+qs_Vsi_bi_Vgi_bi+qdeff_Vsi_bi_Vgi_bi);
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=(qs_Tempt_GND+qdeff_Tempt_GND);
#endif
T9_Vgi_bi=(qs_Vgi_bi+qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=(+qs_Vgi_bi_Vgm_si+qdeff_Vgi_bi_Vgm_si);
  T9_Vgi_bi_Vgm_di=(+qs_Vgi_bi_Vgm_di+qdeff_Vgi_bi_Vgm_di);
  T9_Vgi_bi_Vdbulk_di=(+qs_Vgi_bi_Vdbulk_di+qdeff_Vgi_bi_Vdbulk_di);
  T9_Vgi_bi_Vsbulk_si=(+qs_Vgi_bi_Vsbulk_si+qdeff_Vgi_bi_Vsbulk_si);
  T9_Vgi_bi_Vdi_bi=(+qs_Vgi_bi_Vdi_bi+qdeff_Vgi_bi_Vdi_bi);
  T9_Vgi_bi_Vsi_bi=(+qs_Vgi_bi_Vsi_bi+qdeff_Vgi_bi_Vsi_bi);
  T9_Vgi_bi_Tempt_GND=(+qs_Vgi_bi_Tempt_GND+qdeff_Vgi_bi_Tempt_GND);
  T9_Vgi_bi_Vgi_bi=(+qs_Vgi_bi_Vgi_bi+qdeff_Vgi_bi_Vgi_bi);
#endif
#endif
T9=(qs+qdeff);
EXIT_IF_ISNAN((qs+qdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T10_Vdbulk_di=((((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di))*T5)+((DQSD2*T5)*T5_Vdbulk_di));
#if defined(_DERIVATE2)
  T10_Vdbulk_di_Vdbulk_di=(+(+DQSD2_Vdbulk_di_Vdbulk_di*T5+DQSD2_Vdbulk_di*T5_Vdbulk_di+DQSD2_Vdbulk_di*T5_Vdbulk_di+DQSD2*T5_Vdbulk_di_Vdbulk_di)*T5+((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di))*T5_Vdbulk_di+(((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di)))*T5_Vdbulk_di+(DQSD2*T5)*T5_Vdbulk_di_Vdbulk_di);
  T10_Vdbulk_di_Vsbulk_si=(+(+DQSD2_Vdbulk_di_Vsbulk_si*T5+DQSD2_Vdbulk_di*T5_Vsbulk_si+DQSD2_Vsbulk_si*T5_Vdbulk_di+DQSD2*T5_Vdbulk_di_Vsbulk_si)*T5+((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di))*T5_Vsbulk_si+(((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si)))*T5_Vdbulk_di+(DQSD2*T5)*T5_Vdbulk_di_Vsbulk_si);
  T10_Vdbulk_di_Vgi_bi=(+(+DQSD2_Vdbulk_di_Vgi_bi*T5+DQSD2_Vdbulk_di*T5_Vgi_bi+DQSD2_Vgi_bi*T5_Vdbulk_di+DQSD2*T5_Vdbulk_di_Vgi_bi)*T5+((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di))*T5_Vgi_bi+(((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi)))*T5_Vdbulk_di+(DQSD2*T5)*T5_Vdbulk_di_Vgi_bi);
  T10_Vdbulk_di_Vdi_bi=(+(+DQSD2_Vdbulk_di_Vdi_bi*T5+DQSD2_Vdbulk_di*T5_Vdi_bi+DQSD2_Vdi_bi*T5_Vdbulk_di+DQSD2*T5_Vdbulk_di_Vdi_bi)*T5+((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di))*T5_Vdi_bi+(((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi)))*T5_Vdbulk_di+(DQSD2*T5)*T5_Vdbulk_di_Vdi_bi);
  T10_Vdbulk_di_Vsi_bi=(+(+DQSD2_Vdbulk_di_Vsi_bi*T5+DQSD2_Vdbulk_di*T5_Vsi_bi+DQSD2_Vsi_bi*T5_Vdbulk_di+DQSD2*T5_Vdbulk_di_Vsi_bi)*T5+((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di))*T5_Vsi_bi+(((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi)))*T5_Vdbulk_di+(DQSD2*T5)*T5_Vdbulk_di_Vsi_bi);
  T10_Vdbulk_di_Tempt_GND=(+(+DQSD2_Vdbulk_di_Tempt_GND*T5+DQSD2_Vdbulk_di*T5_Tempt_GND+DQSD2_Tempt_GND*T5_Vdbulk_di+DQSD2*T5_Vdbulk_di_Tempt_GND)*T5+((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di))*T5_Tempt_GND+(((DQSD2_Tempt_GND*T5)+(DQSD2*T5_Tempt_GND)))*T5_Vdbulk_di+(DQSD2*T5)*T5_Vdbulk_di_Tempt_GND);
#endif
T10_Vsbulk_si=((((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si))*T5)+((DQSD2*T5)*T5_Vsbulk_si));
#if defined(_DERIVATE2)
  T10_Vsbulk_si_Vdbulk_di=(+(+DQSD2_Vsbulk_si_Vdbulk_di*T5+DQSD2_Vsbulk_si*T5_Vdbulk_di+DQSD2_Vdbulk_di*T5_Vsbulk_si+DQSD2*T5_Vsbulk_si_Vdbulk_di)*T5+((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si))*T5_Vdbulk_di+(((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di)))*T5_Vsbulk_si+(DQSD2*T5)*T5_Vsbulk_si_Vdbulk_di);
  T10_Vsbulk_si_Vsbulk_si=(+(+DQSD2_Vsbulk_si_Vsbulk_si*T5+DQSD2_Vsbulk_si*T5_Vsbulk_si+DQSD2_Vsbulk_si*T5_Vsbulk_si+DQSD2*T5_Vsbulk_si_Vsbulk_si)*T5+((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si))*T5_Vsbulk_si+(((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si)))*T5_Vsbulk_si+(DQSD2*T5)*T5_Vsbulk_si_Vsbulk_si);
  T10_Vsbulk_si_Vgi_bi=(+(+DQSD2_Vsbulk_si_Vgi_bi*T5+DQSD2_Vsbulk_si*T5_Vgi_bi+DQSD2_Vgi_bi*T5_Vsbulk_si+DQSD2*T5_Vsbulk_si_Vgi_bi)*T5+((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si))*T5_Vgi_bi+(((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi)))*T5_Vsbulk_si+(DQSD2*T5)*T5_Vsbulk_si_Vgi_bi);
  T10_Vsbulk_si_Vdi_bi=(+(+DQSD2_Vsbulk_si_Vdi_bi*T5+DQSD2_Vsbulk_si*T5_Vdi_bi+DQSD2_Vdi_bi*T5_Vsbulk_si+DQSD2*T5_Vsbulk_si_Vdi_bi)*T5+((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si))*T5_Vdi_bi+(((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi)))*T5_Vsbulk_si+(DQSD2*T5)*T5_Vsbulk_si_Vdi_bi);
  T10_Vsbulk_si_Vsi_bi=(+(+DQSD2_Vsbulk_si_Vsi_bi*T5+DQSD2_Vsbulk_si*T5_Vsi_bi+DQSD2_Vsi_bi*T5_Vsbulk_si+DQSD2*T5_Vsbulk_si_Vsi_bi)*T5+((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si))*T5_Vsi_bi+(((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi)))*T5_Vsbulk_si+(DQSD2*T5)*T5_Vsbulk_si_Vsi_bi);
  T10_Vsbulk_si_Tempt_GND=(+(+DQSD2_Vsbulk_si_Tempt_GND*T5+DQSD2_Vsbulk_si*T5_Tempt_GND+DQSD2_Tempt_GND*T5_Vsbulk_si+DQSD2*T5_Vsbulk_si_Tempt_GND)*T5+((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si))*T5_Tempt_GND+(((DQSD2_Tempt_GND*T5)+(DQSD2*T5_Tempt_GND)))*T5_Vsbulk_si+(DQSD2*T5)*T5_Vsbulk_si_Tempt_GND);
#endif
T10_Vgi_bi=((((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi))*T5)+((DQSD2*T5)*T5_Vgi_bi));
#if defined(_DERIVATE2)
  T10_Vgi_bi_Vdbulk_di=(+(+DQSD2_Vgi_bi_Vdbulk_di*T5+DQSD2_Vgi_bi*T5_Vdbulk_di+DQSD2_Vdbulk_di*T5_Vgi_bi+DQSD2*T5_Vgi_bi_Vdbulk_di)*T5+((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi))*T5_Vdbulk_di+(((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di)))*T5_Vgi_bi+(DQSD2*T5)*T5_Vgi_bi_Vdbulk_di);
  T10_Vgi_bi_Vsbulk_si=(+(+DQSD2_Vgi_bi_Vsbulk_si*T5+DQSD2_Vgi_bi*T5_Vsbulk_si+DQSD2_Vsbulk_si*T5_Vgi_bi+DQSD2*T5_Vgi_bi_Vsbulk_si)*T5+((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi))*T5_Vsbulk_si+(((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si)))*T5_Vgi_bi+(DQSD2*T5)*T5_Vgi_bi_Vsbulk_si);
  T10_Vgi_bi_Vgi_bi=(+(+DQSD2_Vgi_bi_Vgi_bi*T5+DQSD2_Vgi_bi*T5_Vgi_bi+DQSD2_Vgi_bi*T5_Vgi_bi+DQSD2*T5_Vgi_bi_Vgi_bi)*T5+((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi))*T5_Vgi_bi+(((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi)))*T5_Vgi_bi+(DQSD2*T5)*T5_Vgi_bi_Vgi_bi);
  T10_Vgi_bi_Vdi_bi=(+(+DQSD2_Vgi_bi_Vdi_bi*T5+DQSD2_Vgi_bi*T5_Vdi_bi+DQSD2_Vdi_bi*T5_Vgi_bi+DQSD2*T5_Vgi_bi_Vdi_bi)*T5+((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi))*T5_Vdi_bi+(((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi)))*T5_Vgi_bi+(DQSD2*T5)*T5_Vgi_bi_Vdi_bi);
  T10_Vgi_bi_Vsi_bi=(+(+DQSD2_Vgi_bi_Vsi_bi*T5+DQSD2_Vgi_bi*T5_Vsi_bi+DQSD2_Vsi_bi*T5_Vgi_bi+DQSD2*T5_Vgi_bi_Vsi_bi)*T5+((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi))*T5_Vsi_bi+(((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi)))*T5_Vgi_bi+(DQSD2*T5)*T5_Vgi_bi_Vsi_bi);
  T10_Vgi_bi_Tempt_GND=(+(+DQSD2_Vgi_bi_Tempt_GND*T5+DQSD2_Vgi_bi*T5_Tempt_GND+DQSD2_Tempt_GND*T5_Vgi_bi+DQSD2*T5_Vgi_bi_Tempt_GND)*T5+((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi))*T5_Tempt_GND+(((DQSD2_Tempt_GND*T5)+(DQSD2*T5_Tempt_GND)))*T5_Vgi_bi+(DQSD2*T5)*T5_Vgi_bi_Tempt_GND);
#endif
T10_Vdi_bi=((((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi))*T5)+((DQSD2*T5)*T5_Vdi_bi));
#if defined(_DERIVATE2)
  T10_Vdi_bi_Vdbulk_di=(+(+DQSD2_Vdi_bi_Vdbulk_di*T5+DQSD2_Vdi_bi*T5_Vdbulk_di+DQSD2_Vdbulk_di*T5_Vdi_bi+DQSD2*T5_Vdi_bi_Vdbulk_di)*T5+((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi))*T5_Vdbulk_di+(((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di)))*T5_Vdi_bi+(DQSD2*T5)*T5_Vdi_bi_Vdbulk_di);
  T10_Vdi_bi_Vsbulk_si=(+(+DQSD2_Vdi_bi_Vsbulk_si*T5+DQSD2_Vdi_bi*T5_Vsbulk_si+DQSD2_Vsbulk_si*T5_Vdi_bi+DQSD2*T5_Vdi_bi_Vsbulk_si)*T5+((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi))*T5_Vsbulk_si+(((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si)))*T5_Vdi_bi+(DQSD2*T5)*T5_Vdi_bi_Vsbulk_si);
  T10_Vdi_bi_Vgi_bi=(+(+DQSD2_Vdi_bi_Vgi_bi*T5+DQSD2_Vdi_bi*T5_Vgi_bi+DQSD2_Vgi_bi*T5_Vdi_bi+DQSD2*T5_Vdi_bi_Vgi_bi)*T5+((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi))*T5_Vgi_bi+(((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi)))*T5_Vdi_bi+(DQSD2*T5)*T5_Vdi_bi_Vgi_bi);
  T10_Vdi_bi_Vdi_bi=(+(+DQSD2_Vdi_bi_Vdi_bi*T5+DQSD2_Vdi_bi*T5_Vdi_bi+DQSD2_Vdi_bi*T5_Vdi_bi+DQSD2*T5_Vdi_bi_Vdi_bi)*T5+((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi))*T5_Vdi_bi+(((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi)))*T5_Vdi_bi+(DQSD2*T5)*T5_Vdi_bi_Vdi_bi);
  T10_Vdi_bi_Vsi_bi=(+(+DQSD2_Vdi_bi_Vsi_bi*T5+DQSD2_Vdi_bi*T5_Vsi_bi+DQSD2_Vsi_bi*T5_Vdi_bi+DQSD2*T5_Vdi_bi_Vsi_bi)*T5+((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi))*T5_Vsi_bi+(((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi)))*T5_Vdi_bi+(DQSD2*T5)*T5_Vdi_bi_Vsi_bi);
  T10_Vdi_bi_Tempt_GND=(+(+DQSD2_Vdi_bi_Tempt_GND*T5+DQSD2_Vdi_bi*T5_Tempt_GND+DQSD2_Tempt_GND*T5_Vdi_bi+DQSD2*T5_Vdi_bi_Tempt_GND)*T5+((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi))*T5_Tempt_GND+(((DQSD2_Tempt_GND*T5)+(DQSD2*T5_Tempt_GND)))*T5_Vdi_bi+(DQSD2*T5)*T5_Vdi_bi_Tempt_GND);
#endif
T10_Vsi_bi=((((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi))*T5)+((DQSD2*T5)*T5_Vsi_bi));
#if defined(_DERIVATE2)
  T10_Vsi_bi_Vdbulk_di=(+(+DQSD2_Vsi_bi_Vdbulk_di*T5+DQSD2_Vsi_bi*T5_Vdbulk_di+DQSD2_Vdbulk_di*T5_Vsi_bi+DQSD2*T5_Vsi_bi_Vdbulk_di)*T5+((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi))*T5_Vdbulk_di+(((DQSD2_Vdbulk_di*T5)+(DQSD2*T5_Vdbulk_di)))*T5_Vsi_bi+(DQSD2*T5)*T5_Vsi_bi_Vdbulk_di);
  T10_Vsi_bi_Vsbulk_si=(+(+DQSD2_Vsi_bi_Vsbulk_si*T5+DQSD2_Vsi_bi*T5_Vsbulk_si+DQSD2_Vsbulk_si*T5_Vsi_bi+DQSD2*T5_Vsi_bi_Vsbulk_si)*T5+((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi))*T5_Vsbulk_si+(((DQSD2_Vsbulk_si*T5)+(DQSD2*T5_Vsbulk_si)))*T5_Vsi_bi+(DQSD2*T5)*T5_Vsi_bi_Vsbulk_si);
  T10_Vsi_bi_Vgi_bi=(+(+DQSD2_Vsi_bi_Vgi_bi*T5+DQSD2_Vsi_bi*T5_Vgi_bi+DQSD2_Vgi_bi*T5_Vsi_bi+DQSD2*T5_Vsi_bi_Vgi_bi)*T5+((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi))*T5_Vgi_bi+(((DQSD2_Vgi_bi*T5)+(DQSD2*T5_Vgi_bi)))*T5_Vsi_bi+(DQSD2*T5)*T5_Vsi_bi_Vgi_bi);
  T10_Vsi_bi_Vdi_bi=(+(+DQSD2_Vsi_bi_Vdi_bi*T5+DQSD2_Vsi_bi*T5_Vdi_bi+DQSD2_Vdi_bi*T5_Vsi_bi+DQSD2*T5_Vsi_bi_Vdi_bi)*T5+((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi))*T5_Vdi_bi+(((DQSD2_Vdi_bi*T5)+(DQSD2*T5_Vdi_bi)))*T5_Vsi_bi+(DQSD2*T5)*T5_Vsi_bi_Vdi_bi);
  T10_Vsi_bi_Vsi_bi=(+(+DQSD2_Vsi_bi_Vsi_bi*T5+DQSD2_Vsi_bi*T5_Vsi_bi+DQSD2_Vsi_bi*T5_Vsi_bi+DQSD2*T5_Vsi_bi_Vsi_bi)*T5+((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi))*T5_Vsi_bi+(((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi)))*T5_Vsi_bi+(DQSD2*T5)*T5_Vsi_bi_Vsi_bi);
  T10_Vsi_bi_Tempt_GND=(+(+DQSD2_Vsi_bi_Tempt_GND*T5+DQSD2_Vsi_bi*T5_Tempt_GND+DQSD2_Tempt_GND*T5_Vsi_bi+DQSD2*T5_Vsi_bi_Tempt_GND)*T5+((DQSD2_Vsi_bi*T5)+(DQSD2*T5_Vsi_bi))*T5_Tempt_GND+(((DQSD2_Tempt_GND*T5)+(DQSD2*T5_Tempt_GND)))*T5_Vsi_bi+(DQSD2*T5)*T5_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T10_Tempt_GND=((((DQSD2_Tempt_GND*T5)+(DQSD2*T5_Tempt_GND))*T5)+((DQSD2*T5)*T5_Tempt_GND));
#endif
#endif
T10=((DQSD2*T5)*T5);
EXIT_IF_ISNAN(((DQSD2*T5)*T5))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(dbulk,GND)V(gm,GND) */
Qi_Vdbulk_di=(((((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di))*(T9+((0.33333333333333333*DQSD2)*T5)))+((nq*inv_MdL)*(T9_Vdbulk_di+(((0.33333333333333333*DQSD2_Vdbulk_di)*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di)))))+(((((2.0*nq_Vdbulk_di)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di))*qdeff)+(((2.0*nq)*MdL_less_1)*qdeff_Vdbulk_di)));
#if defined(_DERIVATE2)
  Qi_Vdbulk_di_Vdbulk_di=(+(+(+nq_Vdbulk_di_Vdbulk_di*inv_MdL+nq_Vdbulk_di*inv_MdL_Vdbulk_di+nq_Vdbulk_di*inv_MdL_Vdbulk_di+nq*inv_MdL_Vdbulk_di_Vdbulk_di)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di))*(T9_Vdbulk_di+(((((0.33333333333333333*DQSD2_Vdbulk_di))*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di))))+(((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di)))*(T9_Vdbulk_di+(((0.33333333333333333*DQSD2_Vdbulk_di)*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di)))+(nq*inv_MdL)*(+T9_Vdbulk_di_Vdbulk_di+(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vdbulk_di)))+(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vdbulk_di)*MdL_less_1+(2.0*nq_Vdbulk_di)*MdL_less_1_Vdbulk_di+((2.0*nq_Vdbulk_di))*MdL_less_1_Vdbulk_di+(2.0*nq)*MdL_less_1_Vdbulk_di_Vdbulk_di)*qdeff+(((2.0*nq_Vdbulk_di)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di))*qdeff_Vdbulk_di+(((((2.0*nq_Vdbulk_di))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di)))*qdeff_Vdbulk_di+((2.0*nq)*MdL_less_1)*qdeff_Vdbulk_di_Vdbulk_di));
  Qi_Vdbulk_di_Vsbulk_si=(+(+(+nq_Vdbulk_di_Vsbulk_si*inv_MdL+nq_Vdbulk_di*inv_MdL_Vsbulk_si+nq_Vsbulk_si*inv_MdL_Vdbulk_di+nq*inv_MdL_Vdbulk_di_Vsbulk_si)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di))*(T9_Vsbulk_si+(((((0.33333333333333333*DQSD2_Vsbulk_si))*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si))))+(((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si)))*(T9_Vdbulk_di+(((0.33333333333333333*DQSD2_Vdbulk_di)*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di)))+(nq*inv_MdL)*(+T9_Vdbulk_di_Vsbulk_si+(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vsbulk_si)))+(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vsbulk_si)*MdL_less_1+(2.0*nq_Vdbulk_di)*MdL_less_1_Vsbulk_si+((2.0*nq_Vsbulk_si))*MdL_less_1_Vdbulk_di+(2.0*nq)*MdL_less_1_Vdbulk_di_Vsbulk_si)*qdeff+(((2.0*nq_Vdbulk_di)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di))*qdeff_Vsbulk_si+(((((2.0*nq_Vsbulk_si))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si)))*qdeff_Vdbulk_di+((2.0*nq)*MdL_less_1)*qdeff_Vdbulk_di_Vsbulk_si));
  Qi_Vdbulk_di_Vgi_bi=(+(+(+nq_Vdbulk_di_Vgi_bi*inv_MdL+nq_Vdbulk_di*inv_MdL_Vgi_bi+nq_Vgi_bi*inv_MdL_Vdbulk_di+nq*inv_MdL_Vdbulk_di_Vgi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di))*(T9_Vgi_bi+(((((0.33333333333333333*DQSD2_Vgi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi))))+(((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi)))*(T9_Vdbulk_di+(((0.33333333333333333*DQSD2_Vdbulk_di)*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di)))+(nq*inv_MdL)*(+T9_Vdbulk_di_Vgi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vgi_bi)))+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vgi_bi)*MdL_less_1+(2.0*nq_Vdbulk_di)*MdL_less_1_Vgi_bi+((2.0*nq_Vgi_bi))*MdL_less_1_Vdbulk_di+(2.0*nq)*MdL_less_1_Vdbulk_di_Vgi_bi)*qdeff+(((2.0*nq_Vdbulk_di)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di))*qdeff_Vgi_bi+(((((2.0*nq_Vgi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi)))*qdeff_Vdbulk_di+((2.0*nq)*MdL_less_1)*qdeff_Vdbulk_di_Vgi_bi));
  Qi_Vdbulk_di_Tempt_GND=(+(+(+nq_Vdbulk_di_Tempt_GND*inv_MdL+nq_Vdbulk_di*inv_MdL_Tempt_GND+nq_Tempt_GND*inv_MdL_Vdbulk_di+nq*inv_MdL_Vdbulk_di_Tempt_GND)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di))*(T9_Tempt_GND+(((((0.33333333333333333*DQSD2_Tempt_GND))*T5)+((0.33333333333333333*DQSD2)*T5_Tempt_GND))))+(((nq_Tempt_GND*inv_MdL)+(nq*inv_MdL_Tempt_GND)))*(T9_Vdbulk_di+(((0.33333333333333333*DQSD2_Vdbulk_di)*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di)))+(nq*inv_MdL)*(+T9_Vdbulk_di_Tempt_GND+(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Tempt_GND)))+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Tempt_GND)*MdL_less_1+(2.0*nq_Vdbulk_di)*MdL_less_1_Tempt_GND+((2.0*nq_Tempt_GND))*MdL_less_1_Vdbulk_di+(2.0*nq)*MdL_less_1_Vdbulk_di_Tempt_GND)*qdeff+(((2.0*nq_Vdbulk_di)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di))*qdeff_Tempt_GND+(((((2.0*nq_Tempt_GND))*MdL_less_1)+((2.0*nq)*MdL_less_1_Tempt_GND)))*qdeff_Vdbulk_di+((2.0*nq)*MdL_less_1)*qdeff_Vdbulk_di_Tempt_GND));
  Qi_Vdbulk_di_Vdi_bi=(+(+(+nq_Vdbulk_di_Vdi_bi*inv_MdL+nq_Vdbulk_di*inv_MdL_Vdi_bi+nq_Vdi_bi*inv_MdL_Vdbulk_di+nq*inv_MdL_Vdbulk_di_Vdi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di))*(T9_Vdi_bi+(((((0.33333333333333333*DQSD2_Vdi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi))))+(((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi)))*(T9_Vdbulk_di+(((0.33333333333333333*DQSD2_Vdbulk_di)*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di)))+(nq*inv_MdL)*(+T9_Vdbulk_di_Vdi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vdi_bi)))+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vdi_bi)*MdL_less_1+(2.0*nq_Vdbulk_di)*MdL_less_1_Vdi_bi+((2.0*nq_Vdi_bi))*MdL_less_1_Vdbulk_di+(2.0*nq)*MdL_less_1_Vdbulk_di_Vdi_bi)*qdeff+(((2.0*nq_Vdbulk_di)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di))*qdeff_Vdi_bi+(((((2.0*nq_Vdi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi)))*qdeff_Vdbulk_di+((2.0*nq)*MdL_less_1)*qdeff_Vdbulk_di_Vdi_bi));
  Qi_Vdbulk_di_Vsi_bi=(+(+(+nq_Vdbulk_di_Vsi_bi*inv_MdL+nq_Vdbulk_di*inv_MdL_Vsi_bi+nq_Vsi_bi*inv_MdL_Vdbulk_di+nq*inv_MdL_Vdbulk_di_Vsi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di))*(T9_Vsi_bi+(((((0.33333333333333333*DQSD2_Vsi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi))))+(((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi)))*(T9_Vdbulk_di+(((0.33333333333333333*DQSD2_Vdbulk_di)*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di)))+(nq*inv_MdL)*(+T9_Vdbulk_di_Vsi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vdbulk_di+0.33333333333333333*DQSD2_Vdbulk_di_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vdbulk_di)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vdbulk_di+(0.33333333333333333*DQSD2)*T5_Vdbulk_di_Vsi_bi)))+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdbulk_di+2.0*nq_Vdbulk_di_Vsi_bi)*MdL_less_1+(2.0*nq_Vdbulk_di)*MdL_less_1_Vsi_bi+((2.0*nq_Vsi_bi))*MdL_less_1_Vdbulk_di+(2.0*nq)*MdL_less_1_Vdbulk_di_Vsi_bi)*qdeff+(((2.0*nq_Vdbulk_di)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di))*qdeff_Vsi_bi+(((((2.0*nq_Vsi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi)))*qdeff_Vdbulk_di+((2.0*nq)*MdL_less_1)*qdeff_Vdbulk_di_Vsi_bi));
#endif
Qi_Vsbulk_si=(((((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si))*(T9+((0.33333333333333333*DQSD2)*T5)))+((nq*inv_MdL)*(T9_Vsbulk_si+(((0.33333333333333333*DQSD2_Vsbulk_si)*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si)))))+(((((2.0*nq_Vsbulk_si)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si))*qdeff)+(((2.0*nq)*MdL_less_1)*qdeff_Vsbulk_si)));
#if defined(_DERIVATE2)
  Qi_Vsbulk_si_Vdbulk_di=(+(+(+nq_Vsbulk_si_Vdbulk_di*inv_MdL+nq_Vsbulk_si*inv_MdL_Vdbulk_di+nq_Vdbulk_di*inv_MdL_Vsbulk_si+nq*inv_MdL_Vsbulk_si_Vdbulk_di)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si))*(T9_Vdbulk_di+(((((0.33333333333333333*DQSD2_Vdbulk_di))*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di))))+(((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di)))*(T9_Vsbulk_si+(((0.33333333333333333*DQSD2_Vsbulk_si)*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si)))+(nq*inv_MdL)*(+T9_Vsbulk_si_Vdbulk_di+(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vdbulk_di)))+(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vdbulk_di)*MdL_less_1+(2.0*nq_Vsbulk_si)*MdL_less_1_Vdbulk_di+((2.0*nq_Vdbulk_di))*MdL_less_1_Vsbulk_si+(2.0*nq)*MdL_less_1_Vsbulk_si_Vdbulk_di)*qdeff+(((2.0*nq_Vsbulk_si)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si))*qdeff_Vdbulk_di+(((((2.0*nq_Vdbulk_di))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di)))*qdeff_Vsbulk_si+((2.0*nq)*MdL_less_1)*qdeff_Vsbulk_si_Vdbulk_di));
  Qi_Vsbulk_si_Vsbulk_si=(+(+(+nq_Vsbulk_si_Vsbulk_si*inv_MdL+nq_Vsbulk_si*inv_MdL_Vsbulk_si+nq_Vsbulk_si*inv_MdL_Vsbulk_si+nq*inv_MdL_Vsbulk_si_Vsbulk_si)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si))*(T9_Vsbulk_si+(((((0.33333333333333333*DQSD2_Vsbulk_si))*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si))))+(((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si)))*(T9_Vsbulk_si+(((0.33333333333333333*DQSD2_Vsbulk_si)*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si)))+(nq*inv_MdL)*(+T9_Vsbulk_si_Vsbulk_si+(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vsbulk_si)))+(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vsbulk_si)*MdL_less_1+(2.0*nq_Vsbulk_si)*MdL_less_1_Vsbulk_si+((2.0*nq_Vsbulk_si))*MdL_less_1_Vsbulk_si+(2.0*nq)*MdL_less_1_Vsbulk_si_Vsbulk_si)*qdeff+(((2.0*nq_Vsbulk_si)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si))*qdeff_Vsbulk_si+(((((2.0*nq_Vsbulk_si))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si)))*qdeff_Vsbulk_si+((2.0*nq)*MdL_less_1)*qdeff_Vsbulk_si_Vsbulk_si));
  Qi_Vsbulk_si_Vgi_bi=(+(+(+nq_Vsbulk_si_Vgi_bi*inv_MdL+nq_Vsbulk_si*inv_MdL_Vgi_bi+nq_Vgi_bi*inv_MdL_Vsbulk_si+nq*inv_MdL_Vsbulk_si_Vgi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si))*(T9_Vgi_bi+(((((0.33333333333333333*DQSD2_Vgi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi))))+(((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi)))*(T9_Vsbulk_si+(((0.33333333333333333*DQSD2_Vsbulk_si)*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si)))+(nq*inv_MdL)*(+T9_Vsbulk_si_Vgi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vgi_bi)))+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vgi_bi)*MdL_less_1+(2.0*nq_Vsbulk_si)*MdL_less_1_Vgi_bi+((2.0*nq_Vgi_bi))*MdL_less_1_Vsbulk_si+(2.0*nq)*MdL_less_1_Vsbulk_si_Vgi_bi)*qdeff+(((2.0*nq_Vsbulk_si)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si))*qdeff_Vgi_bi+(((((2.0*nq_Vgi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi)))*qdeff_Vsbulk_si+((2.0*nq)*MdL_less_1)*qdeff_Vsbulk_si_Vgi_bi));
  Qi_Vsbulk_si_Tempt_GND=(+(+(+nq_Vsbulk_si_Tempt_GND*inv_MdL+nq_Vsbulk_si*inv_MdL_Tempt_GND+nq_Tempt_GND*inv_MdL_Vsbulk_si+nq*inv_MdL_Vsbulk_si_Tempt_GND)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si))*(T9_Tempt_GND+(((((0.33333333333333333*DQSD2_Tempt_GND))*T5)+((0.33333333333333333*DQSD2)*T5_Tempt_GND))))+(((nq_Tempt_GND*inv_MdL)+(nq*inv_MdL_Tempt_GND)))*(T9_Vsbulk_si+(((0.33333333333333333*DQSD2_Vsbulk_si)*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si)))+(nq*inv_MdL)*(+T9_Vsbulk_si_Tempt_GND+(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Tempt_GND)))+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Tempt_GND)*MdL_less_1+(2.0*nq_Vsbulk_si)*MdL_less_1_Tempt_GND+((2.0*nq_Tempt_GND))*MdL_less_1_Vsbulk_si+(2.0*nq)*MdL_less_1_Vsbulk_si_Tempt_GND)*qdeff+(((2.0*nq_Vsbulk_si)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si))*qdeff_Tempt_GND+(((((2.0*nq_Tempt_GND))*MdL_less_1)+((2.0*nq)*MdL_less_1_Tempt_GND)))*qdeff_Vsbulk_si+((2.0*nq)*MdL_less_1)*qdeff_Vsbulk_si_Tempt_GND));
  Qi_Vsbulk_si_Vdi_bi=(+(+(+nq_Vsbulk_si_Vdi_bi*inv_MdL+nq_Vsbulk_si*inv_MdL_Vdi_bi+nq_Vdi_bi*inv_MdL_Vsbulk_si+nq*inv_MdL_Vsbulk_si_Vdi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si))*(T9_Vdi_bi+(((((0.33333333333333333*DQSD2_Vdi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi))))+(((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi)))*(T9_Vsbulk_si+(((0.33333333333333333*DQSD2_Vsbulk_si)*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si)))+(nq*inv_MdL)*(+T9_Vsbulk_si_Vdi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vdi_bi)))+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vdi_bi)*MdL_less_1+(2.0*nq_Vsbulk_si)*MdL_less_1_Vdi_bi+((2.0*nq_Vdi_bi))*MdL_less_1_Vsbulk_si+(2.0*nq)*MdL_less_1_Vsbulk_si_Vdi_bi)*qdeff+(((2.0*nq_Vsbulk_si)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si))*qdeff_Vdi_bi+(((((2.0*nq_Vdi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi)))*qdeff_Vsbulk_si+((2.0*nq)*MdL_less_1)*qdeff_Vsbulk_si_Vdi_bi));
  Qi_Vsbulk_si_Vsi_bi=(+(+(+nq_Vsbulk_si_Vsi_bi*inv_MdL+nq_Vsbulk_si*inv_MdL_Vsi_bi+nq_Vsi_bi*inv_MdL_Vsbulk_si+nq*inv_MdL_Vsbulk_si_Vsi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si))*(T9_Vsi_bi+(((((0.33333333333333333*DQSD2_Vsi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi))))+(((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi)))*(T9_Vsbulk_si+(((0.33333333333333333*DQSD2_Vsbulk_si)*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si)))+(nq*inv_MdL)*(+T9_Vsbulk_si_Vsi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vsbulk_si+0.33333333333333333*DQSD2_Vsbulk_si_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vsbulk_si)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vsbulk_si+(0.33333333333333333*DQSD2)*T5_Vsbulk_si_Vsi_bi)))+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsbulk_si+2.0*nq_Vsbulk_si_Vsi_bi)*MdL_less_1+(2.0*nq_Vsbulk_si)*MdL_less_1_Vsi_bi+((2.0*nq_Vsi_bi))*MdL_less_1_Vsbulk_si+(2.0*nq)*MdL_less_1_Vsbulk_si_Vsi_bi)*qdeff+(((2.0*nq_Vsbulk_si)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si))*qdeff_Vsi_bi+(((((2.0*nq_Vsi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi)))*qdeff_Vsbulk_si+((2.0*nq)*MdL_less_1)*qdeff_Vsbulk_si_Vsi_bi));
#endif
Qi_Vgi_bi=(((((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi))*(T9+((0.33333333333333333*DQSD2)*T5)))+((nq*inv_MdL)*(T9_Vgi_bi+(((0.33333333333333333*DQSD2_Vgi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi)))))+(((((2.0*nq_Vgi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi))*qdeff)+(((2.0*nq)*MdL_less_1)*qdeff_Vgi_bi)));
#if defined(_DERIVATE2)
  Qi_Vgi_bi_Vdbulk_di=(+(+(+nq_Vgi_bi_Vdbulk_di*inv_MdL+nq_Vgi_bi*inv_MdL_Vdbulk_di+nq_Vdbulk_di*inv_MdL_Vgi_bi+nq*inv_MdL_Vgi_bi_Vdbulk_di)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi))*(T9_Vdbulk_di+(((((0.33333333333333333*DQSD2_Vdbulk_di))*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di))))+(((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di)))*(T9_Vgi_bi+(((0.33333333333333333*DQSD2_Vgi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi)))+(nq*inv_MdL)*(+T9_Vgi_bi_Vdbulk_di+(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vdbulk_di)))+(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdbulk_di)*MdL_less_1+(2.0*nq_Vgi_bi)*MdL_less_1_Vdbulk_di+((2.0*nq_Vdbulk_di))*MdL_less_1_Vgi_bi+(2.0*nq)*MdL_less_1_Vgi_bi_Vdbulk_di)*qdeff+(((2.0*nq_Vgi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi))*qdeff_Vdbulk_di+(((((2.0*nq_Vdbulk_di))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di)))*qdeff_Vgi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vgi_bi_Vdbulk_di));
  Qi_Vgi_bi_Vsbulk_si=(+(+(+nq_Vgi_bi_Vsbulk_si*inv_MdL+nq_Vgi_bi*inv_MdL_Vsbulk_si+nq_Vsbulk_si*inv_MdL_Vgi_bi+nq*inv_MdL_Vgi_bi_Vsbulk_si)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi))*(T9_Vsbulk_si+(((((0.33333333333333333*DQSD2_Vsbulk_si))*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si))))+(((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si)))*(T9_Vgi_bi+(((0.33333333333333333*DQSD2_Vgi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi)))+(nq*inv_MdL)*(+T9_Vgi_bi_Vsbulk_si+(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vsbulk_si)))+(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsbulk_si)*MdL_less_1+(2.0*nq_Vgi_bi)*MdL_less_1_Vsbulk_si+((2.0*nq_Vsbulk_si))*MdL_less_1_Vgi_bi+(2.0*nq)*MdL_less_1_Vgi_bi_Vsbulk_si)*qdeff+(((2.0*nq_Vgi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi))*qdeff_Vsbulk_si+(((((2.0*nq_Vsbulk_si))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si)))*qdeff_Vgi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vgi_bi_Vsbulk_si));
  Qi_Vgi_bi_Vgi_bi=(+(+(+nq_Vgi_bi_Vgi_bi*inv_MdL+nq_Vgi_bi*inv_MdL_Vgi_bi+nq_Vgi_bi*inv_MdL_Vgi_bi+nq*inv_MdL_Vgi_bi_Vgi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi))*(T9_Vgi_bi+(((((0.33333333333333333*DQSD2_Vgi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi))))+(((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi)))*(T9_Vgi_bi+(((0.33333333333333333*DQSD2_Vgi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi)))+(nq*inv_MdL)*(+T9_Vgi_bi_Vgi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vgi_bi)))+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vgi_bi)*MdL_less_1+(2.0*nq_Vgi_bi)*MdL_less_1_Vgi_bi+((2.0*nq_Vgi_bi))*MdL_less_1_Vgi_bi+(2.0*nq)*MdL_less_1_Vgi_bi_Vgi_bi)*qdeff+(((2.0*nq_Vgi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi))*qdeff_Vgi_bi+(((((2.0*nq_Vgi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi)))*qdeff_Vgi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vgi_bi_Vgi_bi));
  Qi_Vgi_bi_Tempt_GND=(+(+(+nq_Vgi_bi_Tempt_GND*inv_MdL+nq_Vgi_bi*inv_MdL_Tempt_GND+nq_Tempt_GND*inv_MdL_Vgi_bi+nq*inv_MdL_Vgi_bi_Tempt_GND)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi))*(T9_Tempt_GND+(((((0.33333333333333333*DQSD2_Tempt_GND))*T5)+((0.33333333333333333*DQSD2)*T5_Tempt_GND))))+(((nq_Tempt_GND*inv_MdL)+(nq*inv_MdL_Tempt_GND)))*(T9_Vgi_bi+(((0.33333333333333333*DQSD2_Vgi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi)))+(nq*inv_MdL)*(+T9_Vgi_bi_Tempt_GND+(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Tempt_GND)))+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Tempt_GND)*MdL_less_1+(2.0*nq_Vgi_bi)*MdL_less_1_Tempt_GND+((2.0*nq_Tempt_GND))*MdL_less_1_Vgi_bi+(2.0*nq)*MdL_less_1_Vgi_bi_Tempt_GND)*qdeff+(((2.0*nq_Vgi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi))*qdeff_Tempt_GND+(((((2.0*nq_Tempt_GND))*MdL_less_1)+((2.0*nq)*MdL_less_1_Tempt_GND)))*qdeff_Vgi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vgi_bi_Tempt_GND));
  Qi_Vgi_bi_Vdi_bi=(+(+(+nq_Vgi_bi_Vdi_bi*inv_MdL+nq_Vgi_bi*inv_MdL_Vdi_bi+nq_Vdi_bi*inv_MdL_Vgi_bi+nq*inv_MdL_Vgi_bi_Vdi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi))*(T9_Vdi_bi+(((((0.33333333333333333*DQSD2_Vdi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi))))+(((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi)))*(T9_Vgi_bi+(((0.33333333333333333*DQSD2_Vgi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi)))+(nq*inv_MdL)*(+T9_Vgi_bi_Vdi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vdi_bi)))+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vdi_bi)*MdL_less_1+(2.0*nq_Vgi_bi)*MdL_less_1_Vdi_bi+((2.0*nq_Vdi_bi))*MdL_less_1_Vgi_bi+(2.0*nq)*MdL_less_1_Vgi_bi_Vdi_bi)*qdeff+(((2.0*nq_Vgi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi))*qdeff_Vdi_bi+(((((2.0*nq_Vdi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi)))*qdeff_Vgi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vgi_bi_Vdi_bi));
  Qi_Vgi_bi_Vsi_bi=(+(+(+nq_Vgi_bi_Vsi_bi*inv_MdL+nq_Vgi_bi*inv_MdL_Vsi_bi+nq_Vsi_bi*inv_MdL_Vgi_bi+nq*inv_MdL_Vgi_bi_Vsi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi))*(T9_Vsi_bi+(((((0.33333333333333333*DQSD2_Vsi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi))))+(((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi)))*(T9_Vgi_bi+(((0.33333333333333333*DQSD2_Vgi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi)))+(nq*inv_MdL)*(+T9_Vgi_bi_Vsi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vgi_bi+0.33333333333333333*DQSD2_Vgi_bi_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vgi_bi)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vgi_bi+(0.33333333333333333*DQSD2)*T5_Vgi_bi_Vsi_bi)))+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vgi_bi+2.0*nq_Vgi_bi_Vsi_bi)*MdL_less_1+(2.0*nq_Vgi_bi)*MdL_less_1_Vsi_bi+((2.0*nq_Vsi_bi))*MdL_less_1_Vgi_bi+(2.0*nq)*MdL_less_1_Vgi_bi_Vsi_bi)*qdeff+(((2.0*nq_Vgi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi))*qdeff_Vsi_bi+(((((2.0*nq_Vsi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi)))*qdeff_Vgi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vgi_bi_Vsi_bi));
#endif
#if defined(_DERIVATE)
Qi_Tempt_GND=(((((nq_Tempt_GND*inv_MdL)+(nq*inv_MdL_Tempt_GND))*(T9+((0.33333333333333333*DQSD2)*T5)))+((nq*inv_MdL)*(T9_Tempt_GND+(((0.33333333333333333*DQSD2_Tempt_GND)*T5)+((0.33333333333333333*DQSD2)*T5_Tempt_GND)))))+(((((2.0*nq_Tempt_GND)*MdL_less_1)+((2.0*nq)*MdL_less_1_Tempt_GND))*qdeff)+(((2.0*nq)*MdL_less_1)*qdeff_Tempt_GND)));
#endif
Qi_Vdi_bi=(((((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi))*(T9+((0.33333333333333333*DQSD2)*T5)))+((nq*inv_MdL)*(T9_Vdi_bi+(((0.33333333333333333*DQSD2_Vdi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi)))))+(((((2.0*nq_Vdi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi))*qdeff)+(((2.0*nq)*MdL_less_1)*qdeff_Vdi_bi)));
#if defined(_DERIVATE2)
  Qi_Vdi_bi_Vdbulk_di=(+(+(+nq_Vdi_bi_Vdbulk_di*inv_MdL+nq_Vdi_bi*inv_MdL_Vdbulk_di+nq_Vdbulk_di*inv_MdL_Vdi_bi+nq*inv_MdL_Vdi_bi_Vdbulk_di)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi))*(T9_Vdbulk_di+(((((0.33333333333333333*DQSD2_Vdbulk_di))*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di))))+(((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di)))*(T9_Vdi_bi+(((0.33333333333333333*DQSD2_Vdi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi)))+(nq*inv_MdL)*(+T9_Vdi_bi_Vdbulk_di+(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vdbulk_di)))+(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdbulk_di)*MdL_less_1+(2.0*nq_Vdi_bi)*MdL_less_1_Vdbulk_di+((2.0*nq_Vdbulk_di))*MdL_less_1_Vdi_bi+(2.0*nq)*MdL_less_1_Vdi_bi_Vdbulk_di)*qdeff+(((2.0*nq_Vdi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi))*qdeff_Vdbulk_di+(((((2.0*nq_Vdbulk_di))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di)))*qdeff_Vdi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vdi_bi_Vdbulk_di));
  Qi_Vdi_bi_Vsbulk_si=(+(+(+nq_Vdi_bi_Vsbulk_si*inv_MdL+nq_Vdi_bi*inv_MdL_Vsbulk_si+nq_Vsbulk_si*inv_MdL_Vdi_bi+nq*inv_MdL_Vdi_bi_Vsbulk_si)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi))*(T9_Vsbulk_si+(((((0.33333333333333333*DQSD2_Vsbulk_si))*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si))))+(((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si)))*(T9_Vdi_bi+(((0.33333333333333333*DQSD2_Vdi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi)))+(nq*inv_MdL)*(+T9_Vdi_bi_Vsbulk_si+(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vsbulk_si)))+(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsbulk_si)*MdL_less_1+(2.0*nq_Vdi_bi)*MdL_less_1_Vsbulk_si+((2.0*nq_Vsbulk_si))*MdL_less_1_Vdi_bi+(2.0*nq)*MdL_less_1_Vdi_bi_Vsbulk_si)*qdeff+(((2.0*nq_Vdi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi))*qdeff_Vsbulk_si+(((((2.0*nq_Vsbulk_si))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si)))*qdeff_Vdi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vdi_bi_Vsbulk_si));
  Qi_Vdi_bi_Vgi_bi=(+(+(+nq_Vdi_bi_Vgi_bi*inv_MdL+nq_Vdi_bi*inv_MdL_Vgi_bi+nq_Vgi_bi*inv_MdL_Vdi_bi+nq*inv_MdL_Vdi_bi_Vgi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi))*(T9_Vgi_bi+(((((0.33333333333333333*DQSD2_Vgi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi))))+(((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi)))*(T9_Vdi_bi+(((0.33333333333333333*DQSD2_Vdi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi)))+(nq*inv_MdL)*(+T9_Vdi_bi_Vgi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vgi_bi)))+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vgi_bi)*MdL_less_1+(2.0*nq_Vdi_bi)*MdL_less_1_Vgi_bi+((2.0*nq_Vgi_bi))*MdL_less_1_Vdi_bi+(2.0*nq)*MdL_less_1_Vdi_bi_Vgi_bi)*qdeff+(((2.0*nq_Vdi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi))*qdeff_Vgi_bi+(((((2.0*nq_Vgi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi)))*qdeff_Vdi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vdi_bi_Vgi_bi));
  Qi_Vdi_bi_Tempt_GND=(+(+(+nq_Vdi_bi_Tempt_GND*inv_MdL+nq_Vdi_bi*inv_MdL_Tempt_GND+nq_Tempt_GND*inv_MdL_Vdi_bi+nq*inv_MdL_Vdi_bi_Tempt_GND)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi))*(T9_Tempt_GND+(((((0.33333333333333333*DQSD2_Tempt_GND))*T5)+((0.33333333333333333*DQSD2)*T5_Tempt_GND))))+(((nq_Tempt_GND*inv_MdL)+(nq*inv_MdL_Tempt_GND)))*(T9_Vdi_bi+(((0.33333333333333333*DQSD2_Vdi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi)))+(nq*inv_MdL)*(+T9_Vdi_bi_Tempt_GND+(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Tempt_GND)))+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Tempt_GND)*MdL_less_1+(2.0*nq_Vdi_bi)*MdL_less_1_Tempt_GND+((2.0*nq_Tempt_GND))*MdL_less_1_Vdi_bi+(2.0*nq)*MdL_less_1_Vdi_bi_Tempt_GND)*qdeff+(((2.0*nq_Vdi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi))*qdeff_Tempt_GND+(((((2.0*nq_Tempt_GND))*MdL_less_1)+((2.0*nq)*MdL_less_1_Tempt_GND)))*qdeff_Vdi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vdi_bi_Tempt_GND));
  Qi_Vdi_bi_Vdi_bi=(+(+(+nq_Vdi_bi_Vdi_bi*inv_MdL+nq_Vdi_bi*inv_MdL_Vdi_bi+nq_Vdi_bi*inv_MdL_Vdi_bi+nq*inv_MdL_Vdi_bi_Vdi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi))*(T9_Vdi_bi+(((((0.33333333333333333*DQSD2_Vdi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi))))+(((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi)))*(T9_Vdi_bi+(((0.33333333333333333*DQSD2_Vdi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi)))+(nq*inv_MdL)*(+T9_Vdi_bi_Vdi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vdi_bi)))+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vdi_bi)*MdL_less_1+(2.0*nq_Vdi_bi)*MdL_less_1_Vdi_bi+((2.0*nq_Vdi_bi))*MdL_less_1_Vdi_bi+(2.0*nq)*MdL_less_1_Vdi_bi_Vdi_bi)*qdeff+(((2.0*nq_Vdi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi))*qdeff_Vdi_bi+(((((2.0*nq_Vdi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi)))*qdeff_Vdi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vdi_bi_Vdi_bi));
  Qi_Vdi_bi_Vsi_bi=(+(+(+nq_Vdi_bi_Vsi_bi*inv_MdL+nq_Vdi_bi*inv_MdL_Vsi_bi+nq_Vsi_bi*inv_MdL_Vdi_bi+nq*inv_MdL_Vdi_bi_Vsi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi))*(T9_Vsi_bi+(((((0.33333333333333333*DQSD2_Vsi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi))))+(((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi)))*(T9_Vdi_bi+(((0.33333333333333333*DQSD2_Vdi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi)))+(nq*inv_MdL)*(+T9_Vdi_bi_Vsi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vdi_bi+0.33333333333333333*DQSD2_Vdi_bi_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vdi_bi)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vdi_bi+(0.33333333333333333*DQSD2)*T5_Vdi_bi_Vsi_bi)))+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vdi_bi+2.0*nq_Vdi_bi_Vsi_bi)*MdL_less_1+(2.0*nq_Vdi_bi)*MdL_less_1_Vsi_bi+((2.0*nq_Vsi_bi))*MdL_less_1_Vdi_bi+(2.0*nq)*MdL_less_1_Vdi_bi_Vsi_bi)*qdeff+(((2.0*nq_Vdi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi))*qdeff_Vsi_bi+(((((2.0*nq_Vsi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi)))*qdeff_Vdi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vdi_bi_Vsi_bi));
#endif
Qi_Vsi_bi=(((((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi))*(T9+((0.33333333333333333*DQSD2)*T5)))+((nq*inv_MdL)*(T9_Vsi_bi+(((0.33333333333333333*DQSD2_Vsi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi)))))+(((((2.0*nq_Vsi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi))*qdeff)+(((2.0*nq)*MdL_less_1)*qdeff_Vsi_bi)));
#if defined(_DERIVATE2)
  Qi_Vsi_bi_Vdbulk_di=(+(+(+nq_Vsi_bi_Vdbulk_di*inv_MdL+nq_Vsi_bi*inv_MdL_Vdbulk_di+nq_Vdbulk_di*inv_MdL_Vsi_bi+nq*inv_MdL_Vsi_bi_Vdbulk_di)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi))*(T9_Vdbulk_di+(((((0.33333333333333333*DQSD2_Vdbulk_di))*T5)+((0.33333333333333333*DQSD2)*T5_Vdbulk_di))))+(((nq_Vdbulk_di*inv_MdL)+(nq*inv_MdL_Vdbulk_di)))*(T9_Vsi_bi+(((0.33333333333333333*DQSD2_Vsi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi)))+(nq*inv_MdL)*(+T9_Vsi_bi_Vdbulk_di+(+(+0.0*DQSD2+0.0*DQSD2_Vdbulk_di+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vdbulk_di)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vdbulk_di+((0.33333333333333333*DQSD2_Vdbulk_di))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vdbulk_di)))+(+(+(+0.0*nq+0.0*nq_Vdbulk_di+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdbulk_di)*MdL_less_1+(2.0*nq_Vsi_bi)*MdL_less_1_Vdbulk_di+((2.0*nq_Vdbulk_di))*MdL_less_1_Vsi_bi+(2.0*nq)*MdL_less_1_Vsi_bi_Vdbulk_di)*qdeff+(((2.0*nq_Vsi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi))*qdeff_Vdbulk_di+(((((2.0*nq_Vdbulk_di))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdbulk_di)))*qdeff_Vsi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vsi_bi_Vdbulk_di));
  Qi_Vsi_bi_Vsbulk_si=(+(+(+nq_Vsi_bi_Vsbulk_si*inv_MdL+nq_Vsi_bi*inv_MdL_Vsbulk_si+nq_Vsbulk_si*inv_MdL_Vsi_bi+nq*inv_MdL_Vsi_bi_Vsbulk_si)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi))*(T9_Vsbulk_si+(((((0.33333333333333333*DQSD2_Vsbulk_si))*T5)+((0.33333333333333333*DQSD2)*T5_Vsbulk_si))))+(((nq_Vsbulk_si*inv_MdL)+(nq*inv_MdL_Vsbulk_si)))*(T9_Vsi_bi+(((0.33333333333333333*DQSD2_Vsi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi)))+(nq*inv_MdL)*(+T9_Vsi_bi_Vsbulk_si+(+(+0.0*DQSD2+0.0*DQSD2_Vsbulk_si+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vsbulk_si)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vsbulk_si+((0.33333333333333333*DQSD2_Vsbulk_si))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vsbulk_si)))+(+(+(+0.0*nq+0.0*nq_Vsbulk_si+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsbulk_si)*MdL_less_1+(2.0*nq_Vsi_bi)*MdL_less_1_Vsbulk_si+((2.0*nq_Vsbulk_si))*MdL_less_1_Vsi_bi+(2.0*nq)*MdL_less_1_Vsi_bi_Vsbulk_si)*qdeff+(((2.0*nq_Vsi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi))*qdeff_Vsbulk_si+(((((2.0*nq_Vsbulk_si))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsbulk_si)))*qdeff_Vsi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vsi_bi_Vsbulk_si));
  Qi_Vsi_bi_Vgi_bi=(+(+(+nq_Vsi_bi_Vgi_bi*inv_MdL+nq_Vsi_bi*inv_MdL_Vgi_bi+nq_Vgi_bi*inv_MdL_Vsi_bi+nq*inv_MdL_Vsi_bi_Vgi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi))*(T9_Vgi_bi+(((((0.33333333333333333*DQSD2_Vgi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vgi_bi))))+(((nq_Vgi_bi*inv_MdL)+(nq*inv_MdL_Vgi_bi)))*(T9_Vsi_bi+(((0.33333333333333333*DQSD2_Vsi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi)))+(nq*inv_MdL)*(+T9_Vsi_bi_Vgi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vgi_bi+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vgi_bi)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vgi_bi+((0.33333333333333333*DQSD2_Vgi_bi))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vgi_bi)))+(+(+(+0.0*nq+0.0*nq_Vgi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vgi_bi)*MdL_less_1+(2.0*nq_Vsi_bi)*MdL_less_1_Vgi_bi+((2.0*nq_Vgi_bi))*MdL_less_1_Vsi_bi+(2.0*nq)*MdL_less_1_Vsi_bi_Vgi_bi)*qdeff+(((2.0*nq_Vsi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi))*qdeff_Vgi_bi+(((((2.0*nq_Vgi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vgi_bi)))*qdeff_Vsi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vsi_bi_Vgi_bi));
  Qi_Vsi_bi_Tempt_GND=(+(+(+nq_Vsi_bi_Tempt_GND*inv_MdL+nq_Vsi_bi*inv_MdL_Tempt_GND+nq_Tempt_GND*inv_MdL_Vsi_bi+nq*inv_MdL_Vsi_bi_Tempt_GND)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi))*(T9_Tempt_GND+(((((0.33333333333333333*DQSD2_Tempt_GND))*T5)+((0.33333333333333333*DQSD2)*T5_Tempt_GND))))+(((nq_Tempt_GND*inv_MdL)+(nq*inv_MdL_Tempt_GND)))*(T9_Vsi_bi+(((0.33333333333333333*DQSD2_Vsi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi)))+(nq*inv_MdL)*(+T9_Vsi_bi_Tempt_GND+(+(+0.0*DQSD2+0.0*DQSD2_Tempt_GND+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Tempt_GND)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Tempt_GND+((0.33333333333333333*DQSD2_Tempt_GND))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Tempt_GND)))+(+(+(+0.0*nq+0.0*nq_Tempt_GND+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Tempt_GND)*MdL_less_1+(2.0*nq_Vsi_bi)*MdL_less_1_Tempt_GND+((2.0*nq_Tempt_GND))*MdL_less_1_Vsi_bi+(2.0*nq)*MdL_less_1_Vsi_bi_Tempt_GND)*qdeff+(((2.0*nq_Vsi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi))*qdeff_Tempt_GND+(((((2.0*nq_Tempt_GND))*MdL_less_1)+((2.0*nq)*MdL_less_1_Tempt_GND)))*qdeff_Vsi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vsi_bi_Tempt_GND));
  Qi_Vsi_bi_Vdi_bi=(+(+(+nq_Vsi_bi_Vdi_bi*inv_MdL+nq_Vsi_bi*inv_MdL_Vdi_bi+nq_Vdi_bi*inv_MdL_Vsi_bi+nq*inv_MdL_Vsi_bi_Vdi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi))*(T9_Vdi_bi+(((((0.33333333333333333*DQSD2_Vdi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vdi_bi))))+(((nq_Vdi_bi*inv_MdL)+(nq*inv_MdL_Vdi_bi)))*(T9_Vsi_bi+(((0.33333333333333333*DQSD2_Vsi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi)))+(nq*inv_MdL)*(+T9_Vsi_bi_Vdi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vdi_bi+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vdi_bi)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vdi_bi+((0.33333333333333333*DQSD2_Vdi_bi))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vdi_bi)))+(+(+(+0.0*nq+0.0*nq_Vdi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vdi_bi)*MdL_less_1+(2.0*nq_Vsi_bi)*MdL_less_1_Vdi_bi+((2.0*nq_Vdi_bi))*MdL_less_1_Vsi_bi+(2.0*nq)*MdL_less_1_Vsi_bi_Vdi_bi)*qdeff+(((2.0*nq_Vsi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi))*qdeff_Vdi_bi+(((((2.0*nq_Vdi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vdi_bi)))*qdeff_Vsi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vsi_bi_Vdi_bi));
  Qi_Vsi_bi_Vsi_bi=(+(+(+nq_Vsi_bi_Vsi_bi*inv_MdL+nq_Vsi_bi*inv_MdL_Vsi_bi+nq_Vsi_bi*inv_MdL_Vsi_bi+nq*inv_MdL_Vsi_bi_Vsi_bi)*(T9+((0.33333333333333333*DQSD2)*T5))+((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi))*(T9_Vsi_bi+(((((0.33333333333333333*DQSD2_Vsi_bi))*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi))))+(((nq_Vsi_bi*inv_MdL)+(nq*inv_MdL_Vsi_bi)))*(T9_Vsi_bi+(((0.33333333333333333*DQSD2_Vsi_bi)*T5)+((0.33333333333333333*DQSD2)*T5_Vsi_bi)))+(nq*inv_MdL)*(+T9_Vsi_bi_Vsi_bi+(+(+0.0*DQSD2+0.0*DQSD2_Vsi_bi+0.0*DQSD2_Vsi_bi+0.33333333333333333*DQSD2_Vsi_bi_Vsi_bi)*T5+(0.33333333333333333*DQSD2_Vsi_bi)*T5_Vsi_bi+((0.33333333333333333*DQSD2_Vsi_bi))*T5_Vsi_bi+(0.33333333333333333*DQSD2)*T5_Vsi_bi_Vsi_bi)))+(+(+(+0.0*nq+0.0*nq_Vsi_bi+0.0*nq_Vsi_bi+2.0*nq_Vsi_bi_Vsi_bi)*MdL_less_1+(2.0*nq_Vsi_bi)*MdL_less_1_Vsi_bi+((2.0*nq_Vsi_bi))*MdL_less_1_Vsi_bi+(2.0*nq)*MdL_less_1_Vsi_bi_Vsi_bi)*qdeff+(((2.0*nq_Vsi_bi)*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi))*qdeff_Vsi_bi+(((((2.0*nq_Vsi_bi))*MdL_less_1)+((2.0*nq)*MdL_less_1_Vsi_bi)))*qdeff_Vsi_bi+((2.0*nq)*MdL_less_1)*qdeff_Vsi_bi_Vsi_bi));
#endif
#endif
Qi=(((nq*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*qdeff));
EXIT_IF_ISNAN((((nq*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*qdeff)))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Qd1_Vdbulk_di=((((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di))*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))))+((nq*inv_MdL_2)*((0.5*T9_Vdbulk_di)-(((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di)))))));
#if defined(_DERIVATE2)
  Qd1_Vdbulk_di_Vdbulk_di=(+(+nq_Vdbulk_di_Vdbulk_di*inv_MdL_2+nq_Vdbulk_di*inv_MdL_2_Vdbulk_di+nq_Vdbulk_di*inv_MdL_2_Vdbulk_di+nq*inv_MdL_2_Vdbulk_di_Vdbulk_di)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di))*(((0.5*T9_Vdbulk_di))-((((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))))))+(((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di)))*((0.5*T9_Vdbulk_di)-(((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdbulk_di+0.0*T9_Vdbulk_di+0.5*T9_Vdbulk_di_Vdbulk_di)-(+(DQSD_Vdbulk_di_Vdbulk_di/6.0-(DQSD_Vdbulk_di*0.0+DQSD_Vdbulk_di*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdbulk_di/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))+(DQSD_Vdbulk_di/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdbulk_di_Vdbulk_di*T5+DQSD_Vdbulk_di*T5_Vdbulk_di+DQSD_Vdbulk_di*T5_Vdbulk_di+DQSD*T5_Vdbulk_di_Vdbulk_di))-(+0.0*T10+0.0*T10_Vdbulk_di+0.0*T10_Vdbulk_di+0.2*T10_Vdbulk_di_Vdbulk_di)))));
  Qd1_Vdbulk_di_Vsbulk_si=(+(+nq_Vdbulk_di_Vsbulk_si*inv_MdL_2+nq_Vdbulk_di*inv_MdL_2_Vsbulk_si+nq_Vsbulk_si*inv_MdL_2_Vdbulk_di+nq*inv_MdL_2_Vdbulk_di_Vsbulk_si)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di))*(((0.5*T9_Vsbulk_si))-((((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))))))+(((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si)))*((0.5*T9_Vdbulk_di)-(((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsbulk_si+0.0*T9_Vdbulk_di+0.5*T9_Vdbulk_di_Vsbulk_si)-(+(DQSD_Vdbulk_di_Vsbulk_si/6.0-(DQSD_Vdbulk_di*0.0+DQSD_Vsbulk_si*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdbulk_di/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))+(DQSD_Vsbulk_si/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdbulk_di_Vsbulk_si*T5+DQSD_Vdbulk_di*T5_Vsbulk_si+DQSD_Vsbulk_si*T5_Vdbulk_di+DQSD*T5_Vdbulk_di_Vsbulk_si))-(+0.0*T10+0.0*T10_Vsbulk_si+0.0*T10_Vdbulk_di+0.2*T10_Vdbulk_di_Vsbulk_si)))));
  Qd1_Vdbulk_di_Vgi_bi=(+(+nq_Vdbulk_di_Vgi_bi*inv_MdL_2+nq_Vdbulk_di*inv_MdL_2_Vgi_bi+nq_Vgi_bi*inv_MdL_2_Vdbulk_di+nq*inv_MdL_2_Vdbulk_di_Vgi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di))*(((0.5*T9_Vgi_bi))-((((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))))))+(((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi)))*((0.5*T9_Vdbulk_di)-(((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vgi_bi+0.0*T9_Vdbulk_di+0.5*T9_Vdbulk_di_Vgi_bi)-(+(DQSD_Vdbulk_di_Vgi_bi/6.0-(DQSD_Vdbulk_di*0.0+DQSD_Vgi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdbulk_di/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))+(DQSD_Vgi_bi/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdbulk_di_Vgi_bi*T5+DQSD_Vdbulk_di*T5_Vgi_bi+DQSD_Vgi_bi*T5_Vdbulk_di+DQSD*T5_Vdbulk_di_Vgi_bi))-(+0.0*T10+0.0*T10_Vgi_bi+0.0*T10_Vdbulk_di+0.2*T10_Vdbulk_di_Vgi_bi)))));
  Qd1_Vdbulk_di_Tempt_GND=(+(+nq_Vdbulk_di_Tempt_GND*inv_MdL_2+nq_Vdbulk_di*inv_MdL_2_Tempt_GND+nq_Tempt_GND*inv_MdL_2_Vdbulk_di+nq*inv_MdL_2_Vdbulk_di_Tempt_GND)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di))*(((0.5*T9_Tempt_GND))-((((DQSD_Tempt_GND/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))))))+(((nq_Tempt_GND*inv_MdL_2)+(nq*inv_MdL_2_Tempt_GND)))*((0.5*T9_Vdbulk_di)-(((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Tempt_GND+0.0*T9_Vdbulk_di+0.5*T9_Vdbulk_di_Tempt_GND)-(+(DQSD_Vdbulk_di_Tempt_GND/6.0-(DQSD_Vdbulk_di*0.0+DQSD_Tempt_GND*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdbulk_di/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))+(DQSD_Tempt_GND/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdbulk_di_Tempt_GND*T5+DQSD_Vdbulk_di*T5_Tempt_GND+DQSD_Tempt_GND*T5_Vdbulk_di+DQSD*T5_Vdbulk_di_Tempt_GND))-(+0.0*T10+0.0*T10_Tempt_GND+0.0*T10_Vdbulk_di+0.2*T10_Vdbulk_di_Tempt_GND)))));
  Qd1_Vdbulk_di_Vdi_bi=(+(+nq_Vdbulk_di_Vdi_bi*inv_MdL_2+nq_Vdbulk_di*inv_MdL_2_Vdi_bi+nq_Vdi_bi*inv_MdL_2_Vdbulk_di+nq*inv_MdL_2_Vdbulk_di_Vdi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di))*(((0.5*T9_Vdi_bi))-((((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))))))+(((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi)))*((0.5*T9_Vdbulk_di)-(((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdi_bi+0.0*T9_Vdbulk_di+0.5*T9_Vdbulk_di_Vdi_bi)-(+(DQSD_Vdbulk_di_Vdi_bi/6.0-(DQSD_Vdbulk_di*0.0+DQSD_Vdi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdbulk_di/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))+(DQSD_Vdi_bi/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdbulk_di_Vdi_bi*T5+DQSD_Vdbulk_di*T5_Vdi_bi+DQSD_Vdi_bi*T5_Vdbulk_di+DQSD*T5_Vdbulk_di_Vdi_bi))-(+0.0*T10+0.0*T10_Vdi_bi+0.0*T10_Vdbulk_di+0.2*T10_Vdbulk_di_Vdi_bi)))));
  Qd1_Vdbulk_di_Vsi_bi=(+(+nq_Vdbulk_di_Vsi_bi*inv_MdL_2+nq_Vdbulk_di*inv_MdL_2_Vsi_bi+nq_Vsi_bi*inv_MdL_2_Vdbulk_di+nq*inv_MdL_2_Vdbulk_di_Vsi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di))*(((0.5*T9_Vsi_bi))-((((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))))))+(((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi)))*((0.5*T9_Vdbulk_di)-(((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsi_bi+0.0*T9_Vdbulk_di+0.5*T9_Vdbulk_di_Vsi_bi)-(+(DQSD_Vdbulk_di_Vsi_bi/6.0-(DQSD_Vdbulk_di*0.0+DQSD_Vsi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdbulk_di/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))+(DQSD_Vsi_bi/6.0)*((-((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di)))-(0.2*T10_Vdbulk_di))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdbulk_di_Vsi_bi*T5+DQSD_Vdbulk_di*T5_Vsi_bi+DQSD_Vsi_bi*T5_Vdbulk_di+DQSD*T5_Vdbulk_di_Vsi_bi))-(+0.0*T10+0.0*T10_Vsi_bi+0.0*T10_Vdbulk_di+0.2*T10_Vdbulk_di_Vsi_bi)))));
#endif
Qd1_Vsbulk_si=((((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si))*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))))+((nq*inv_MdL_2)*((0.5*T9_Vsbulk_si)-(((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si)))))));
#if defined(_DERIVATE2)
  Qd1_Vsbulk_si_Vdbulk_di=(+(+nq_Vsbulk_si_Vdbulk_di*inv_MdL_2+nq_Vsbulk_si*inv_MdL_2_Vdbulk_di+nq_Vdbulk_di*inv_MdL_2_Vsbulk_si+nq*inv_MdL_2_Vsbulk_si_Vdbulk_di)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si))*(((0.5*T9_Vdbulk_di))-((((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))))))+(((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di)))*((0.5*T9_Vsbulk_si)-(((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdbulk_di+0.0*T9_Vsbulk_si+0.5*T9_Vsbulk_si_Vdbulk_di)-(+(DQSD_Vsbulk_si_Vdbulk_di/6.0-(DQSD_Vsbulk_si*0.0+DQSD_Vdbulk_di*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsbulk_si/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))+(DQSD_Vdbulk_di/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsbulk_si_Vdbulk_di*T5+DQSD_Vsbulk_si*T5_Vdbulk_di+DQSD_Vdbulk_di*T5_Vsbulk_si+DQSD*T5_Vsbulk_si_Vdbulk_di))-(+0.0*T10+0.0*T10_Vdbulk_di+0.0*T10_Vsbulk_si+0.2*T10_Vsbulk_si_Vdbulk_di)))));
  Qd1_Vsbulk_si_Vsbulk_si=(+(+nq_Vsbulk_si_Vsbulk_si*inv_MdL_2+nq_Vsbulk_si*inv_MdL_2_Vsbulk_si+nq_Vsbulk_si*inv_MdL_2_Vsbulk_si+nq*inv_MdL_2_Vsbulk_si_Vsbulk_si)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si))*(((0.5*T9_Vsbulk_si))-((((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))))))+(((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si)))*((0.5*T9_Vsbulk_si)-(((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsbulk_si+0.0*T9_Vsbulk_si+0.5*T9_Vsbulk_si_Vsbulk_si)-(+(DQSD_Vsbulk_si_Vsbulk_si/6.0-(DQSD_Vsbulk_si*0.0+DQSD_Vsbulk_si*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsbulk_si/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))+(DQSD_Vsbulk_si/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsbulk_si_Vsbulk_si*T5+DQSD_Vsbulk_si*T5_Vsbulk_si+DQSD_Vsbulk_si*T5_Vsbulk_si+DQSD*T5_Vsbulk_si_Vsbulk_si))-(+0.0*T10+0.0*T10_Vsbulk_si+0.0*T10_Vsbulk_si+0.2*T10_Vsbulk_si_Vsbulk_si)))));
  Qd1_Vsbulk_si_Vgi_bi=(+(+nq_Vsbulk_si_Vgi_bi*inv_MdL_2+nq_Vsbulk_si*inv_MdL_2_Vgi_bi+nq_Vgi_bi*inv_MdL_2_Vsbulk_si+nq*inv_MdL_2_Vsbulk_si_Vgi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si))*(((0.5*T9_Vgi_bi))-((((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))))))+(((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi)))*((0.5*T9_Vsbulk_si)-(((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vgi_bi+0.0*T9_Vsbulk_si+0.5*T9_Vsbulk_si_Vgi_bi)-(+(DQSD_Vsbulk_si_Vgi_bi/6.0-(DQSD_Vsbulk_si*0.0+DQSD_Vgi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsbulk_si/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))+(DQSD_Vgi_bi/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsbulk_si_Vgi_bi*T5+DQSD_Vsbulk_si*T5_Vgi_bi+DQSD_Vgi_bi*T5_Vsbulk_si+DQSD*T5_Vsbulk_si_Vgi_bi))-(+0.0*T10+0.0*T10_Vgi_bi+0.0*T10_Vsbulk_si+0.2*T10_Vsbulk_si_Vgi_bi)))));
  Qd1_Vsbulk_si_Tempt_GND=(+(+nq_Vsbulk_si_Tempt_GND*inv_MdL_2+nq_Vsbulk_si*inv_MdL_2_Tempt_GND+nq_Tempt_GND*inv_MdL_2_Vsbulk_si+nq*inv_MdL_2_Vsbulk_si_Tempt_GND)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si))*(((0.5*T9_Tempt_GND))-((((DQSD_Tempt_GND/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))))))+(((nq_Tempt_GND*inv_MdL_2)+(nq*inv_MdL_2_Tempt_GND)))*((0.5*T9_Vsbulk_si)-(((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Tempt_GND+0.0*T9_Vsbulk_si+0.5*T9_Vsbulk_si_Tempt_GND)-(+(DQSD_Vsbulk_si_Tempt_GND/6.0-(DQSD_Vsbulk_si*0.0+DQSD_Tempt_GND*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsbulk_si/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))+(DQSD_Tempt_GND/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsbulk_si_Tempt_GND*T5+DQSD_Vsbulk_si*T5_Tempt_GND+DQSD_Tempt_GND*T5_Vsbulk_si+DQSD*T5_Vsbulk_si_Tempt_GND))-(+0.0*T10+0.0*T10_Tempt_GND+0.0*T10_Vsbulk_si+0.2*T10_Vsbulk_si_Tempt_GND)))));
  Qd1_Vsbulk_si_Vdi_bi=(+(+nq_Vsbulk_si_Vdi_bi*inv_MdL_2+nq_Vsbulk_si*inv_MdL_2_Vdi_bi+nq_Vdi_bi*inv_MdL_2_Vsbulk_si+nq*inv_MdL_2_Vsbulk_si_Vdi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si))*(((0.5*T9_Vdi_bi))-((((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))))))+(((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi)))*((0.5*T9_Vsbulk_si)-(((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdi_bi+0.0*T9_Vsbulk_si+0.5*T9_Vsbulk_si_Vdi_bi)-(+(DQSD_Vsbulk_si_Vdi_bi/6.0-(DQSD_Vsbulk_si*0.0+DQSD_Vdi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsbulk_si/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))+(DQSD_Vdi_bi/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsbulk_si_Vdi_bi*T5+DQSD_Vsbulk_si*T5_Vdi_bi+DQSD_Vdi_bi*T5_Vsbulk_si+DQSD*T5_Vsbulk_si_Vdi_bi))-(+0.0*T10+0.0*T10_Vdi_bi+0.0*T10_Vsbulk_si+0.2*T10_Vsbulk_si_Vdi_bi)))));
  Qd1_Vsbulk_si_Vsi_bi=(+(+nq_Vsbulk_si_Vsi_bi*inv_MdL_2+nq_Vsbulk_si*inv_MdL_2_Vsi_bi+nq_Vsi_bi*inv_MdL_2_Vsbulk_si+nq*inv_MdL_2_Vsbulk_si_Vsi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si))*(((0.5*T9_Vsi_bi))-((((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))))))+(((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi)))*((0.5*T9_Vsbulk_si)-(((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsi_bi+0.0*T9_Vsbulk_si+0.5*T9_Vsbulk_si_Vsi_bi)-(+(DQSD_Vsbulk_si_Vsi_bi/6.0-(DQSD_Vsbulk_si*0.0+DQSD_Vsi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsbulk_si/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))+(DQSD_Vsi_bi/6.0)*((-((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si)))-(0.2*T10_Vsbulk_si))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsbulk_si_Vsi_bi*T5+DQSD_Vsbulk_si*T5_Vsi_bi+DQSD_Vsi_bi*T5_Vsbulk_si+DQSD*T5_Vsbulk_si_Vsi_bi))-(+0.0*T10+0.0*T10_Vsi_bi+0.0*T10_Vsbulk_si+0.2*T10_Vsbulk_si_Vsi_bi)))));
#endif
Qd1_Vgi_bi=((((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi))*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))))+((nq*inv_MdL_2)*((0.5*T9_Vgi_bi)-(((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi)))))));
#if defined(_DERIVATE2)
  Qd1_Vgi_bi_Vdbulk_di=(+(+nq_Vgi_bi_Vdbulk_di*inv_MdL_2+nq_Vgi_bi*inv_MdL_2_Vdbulk_di+nq_Vdbulk_di*inv_MdL_2_Vgi_bi+nq*inv_MdL_2_Vgi_bi_Vdbulk_di)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi))*(((0.5*T9_Vdbulk_di))-((((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))))))+(((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di)))*((0.5*T9_Vgi_bi)-(((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdbulk_di+0.0*T9_Vgi_bi+0.5*T9_Vgi_bi_Vdbulk_di)-(+(DQSD_Vgi_bi_Vdbulk_di/6.0-(DQSD_Vgi_bi*0.0+DQSD_Vdbulk_di*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vgi_bi/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))+(DQSD_Vdbulk_di/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vgi_bi_Vdbulk_di*T5+DQSD_Vgi_bi*T5_Vdbulk_di+DQSD_Vdbulk_di*T5_Vgi_bi+DQSD*T5_Vgi_bi_Vdbulk_di))-(+0.0*T10+0.0*T10_Vdbulk_di+0.0*T10_Vgi_bi+0.2*T10_Vgi_bi_Vdbulk_di)))));
  Qd1_Vgi_bi_Vsbulk_si=(+(+nq_Vgi_bi_Vsbulk_si*inv_MdL_2+nq_Vgi_bi*inv_MdL_2_Vsbulk_si+nq_Vsbulk_si*inv_MdL_2_Vgi_bi+nq*inv_MdL_2_Vgi_bi_Vsbulk_si)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi))*(((0.5*T9_Vsbulk_si))-((((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))))))+(((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si)))*((0.5*T9_Vgi_bi)-(((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsbulk_si+0.0*T9_Vgi_bi+0.5*T9_Vgi_bi_Vsbulk_si)-(+(DQSD_Vgi_bi_Vsbulk_si/6.0-(DQSD_Vgi_bi*0.0+DQSD_Vsbulk_si*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vgi_bi/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))+(DQSD_Vsbulk_si/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vgi_bi_Vsbulk_si*T5+DQSD_Vgi_bi*T5_Vsbulk_si+DQSD_Vsbulk_si*T5_Vgi_bi+DQSD*T5_Vgi_bi_Vsbulk_si))-(+0.0*T10+0.0*T10_Vsbulk_si+0.0*T10_Vgi_bi+0.2*T10_Vgi_bi_Vsbulk_si)))));
  Qd1_Vgi_bi_Vgi_bi=(+(+nq_Vgi_bi_Vgi_bi*inv_MdL_2+nq_Vgi_bi*inv_MdL_2_Vgi_bi+nq_Vgi_bi*inv_MdL_2_Vgi_bi+nq*inv_MdL_2_Vgi_bi_Vgi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi))*(((0.5*T9_Vgi_bi))-((((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))))))+(((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi)))*((0.5*T9_Vgi_bi)-(((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vgi_bi+0.0*T9_Vgi_bi+0.5*T9_Vgi_bi_Vgi_bi)-(+(DQSD_Vgi_bi_Vgi_bi/6.0-(DQSD_Vgi_bi*0.0+DQSD_Vgi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vgi_bi/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))+(DQSD_Vgi_bi/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vgi_bi_Vgi_bi*T5+DQSD_Vgi_bi*T5_Vgi_bi+DQSD_Vgi_bi*T5_Vgi_bi+DQSD*T5_Vgi_bi_Vgi_bi))-(+0.0*T10+0.0*T10_Vgi_bi+0.0*T10_Vgi_bi+0.2*T10_Vgi_bi_Vgi_bi)))));
  Qd1_Vgi_bi_Tempt_GND=(+(+nq_Vgi_bi_Tempt_GND*inv_MdL_2+nq_Vgi_bi*inv_MdL_2_Tempt_GND+nq_Tempt_GND*inv_MdL_2_Vgi_bi+nq*inv_MdL_2_Vgi_bi_Tempt_GND)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi))*(((0.5*T9_Tempt_GND))-((((DQSD_Tempt_GND/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))))))+(((nq_Tempt_GND*inv_MdL_2)+(nq*inv_MdL_2_Tempt_GND)))*((0.5*T9_Vgi_bi)-(((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Tempt_GND+0.0*T9_Vgi_bi+0.5*T9_Vgi_bi_Tempt_GND)-(+(DQSD_Vgi_bi_Tempt_GND/6.0-(DQSD_Vgi_bi*0.0+DQSD_Tempt_GND*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vgi_bi/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))+(DQSD_Tempt_GND/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vgi_bi_Tempt_GND*T5+DQSD_Vgi_bi*T5_Tempt_GND+DQSD_Tempt_GND*T5_Vgi_bi+DQSD*T5_Vgi_bi_Tempt_GND))-(+0.0*T10+0.0*T10_Tempt_GND+0.0*T10_Vgi_bi+0.2*T10_Vgi_bi_Tempt_GND)))));
  Qd1_Vgi_bi_Vdi_bi=(+(+nq_Vgi_bi_Vdi_bi*inv_MdL_2+nq_Vgi_bi*inv_MdL_2_Vdi_bi+nq_Vdi_bi*inv_MdL_2_Vgi_bi+nq*inv_MdL_2_Vgi_bi_Vdi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi))*(((0.5*T9_Vdi_bi))-((((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))))))+(((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi)))*((0.5*T9_Vgi_bi)-(((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdi_bi+0.0*T9_Vgi_bi+0.5*T9_Vgi_bi_Vdi_bi)-(+(DQSD_Vgi_bi_Vdi_bi/6.0-(DQSD_Vgi_bi*0.0+DQSD_Vdi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vgi_bi/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))+(DQSD_Vdi_bi/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vgi_bi_Vdi_bi*T5+DQSD_Vgi_bi*T5_Vdi_bi+DQSD_Vdi_bi*T5_Vgi_bi+DQSD*T5_Vgi_bi_Vdi_bi))-(+0.0*T10+0.0*T10_Vdi_bi+0.0*T10_Vgi_bi+0.2*T10_Vgi_bi_Vdi_bi)))));
  Qd1_Vgi_bi_Vsi_bi=(+(+nq_Vgi_bi_Vsi_bi*inv_MdL_2+nq_Vgi_bi*inv_MdL_2_Vsi_bi+nq_Vsi_bi*inv_MdL_2_Vgi_bi+nq*inv_MdL_2_Vgi_bi_Vsi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi))*(((0.5*T9_Vsi_bi))-((((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))))))+(((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi)))*((0.5*T9_Vgi_bi)-(((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsi_bi+0.0*T9_Vgi_bi+0.5*T9_Vgi_bi_Vsi_bi)-(+(DQSD_Vgi_bi_Vsi_bi/6.0-(DQSD_Vgi_bi*0.0+DQSD_Vsi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vgi_bi/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))+(DQSD_Vsi_bi/6.0)*((-((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi)))-(0.2*T10_Vgi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vgi_bi_Vsi_bi*T5+DQSD_Vgi_bi*T5_Vsi_bi+DQSD_Vsi_bi*T5_Vgi_bi+DQSD*T5_Vgi_bi_Vsi_bi))-(+0.0*T10+0.0*T10_Vsi_bi+0.0*T10_Vgi_bi+0.2*T10_Vgi_bi_Vsi_bi)))));
#endif
#if defined(_DERIVATE)
Qd1_Tempt_GND=((((nq_Tempt_GND*inv_MdL_2)+(nq*inv_MdL_2_Tempt_GND))*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))))+((nq*inv_MdL_2)*((0.5*T9_Tempt_GND)-(((DQSD_Tempt_GND/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND)))-(0.2*T10_Tempt_GND)))))));
#endif
Qd1_Vdi_bi=((((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi))*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))))+((nq*inv_MdL_2)*((0.5*T9_Vdi_bi)-(((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi)))))));
#if defined(_DERIVATE2)
  Qd1_Vdi_bi_Vdbulk_di=(+(+nq_Vdi_bi_Vdbulk_di*inv_MdL_2+nq_Vdi_bi*inv_MdL_2_Vdbulk_di+nq_Vdbulk_di*inv_MdL_2_Vdi_bi+nq*inv_MdL_2_Vdi_bi_Vdbulk_di)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi))*(((0.5*T9_Vdbulk_di))-((((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))))))+(((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di)))*((0.5*T9_Vdi_bi)-(((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdbulk_di+0.0*T9_Vdi_bi+0.5*T9_Vdi_bi_Vdbulk_di)-(+(DQSD_Vdi_bi_Vdbulk_di/6.0-(DQSD_Vdi_bi*0.0+DQSD_Vdbulk_di*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdi_bi/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))+(DQSD_Vdbulk_di/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdi_bi_Vdbulk_di*T5+DQSD_Vdi_bi*T5_Vdbulk_di+DQSD_Vdbulk_di*T5_Vdi_bi+DQSD*T5_Vdi_bi_Vdbulk_di))-(+0.0*T10+0.0*T10_Vdbulk_di+0.0*T10_Vdi_bi+0.2*T10_Vdi_bi_Vdbulk_di)))));
  Qd1_Vdi_bi_Vsbulk_si=(+(+nq_Vdi_bi_Vsbulk_si*inv_MdL_2+nq_Vdi_bi*inv_MdL_2_Vsbulk_si+nq_Vsbulk_si*inv_MdL_2_Vdi_bi+nq*inv_MdL_2_Vdi_bi_Vsbulk_si)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi))*(((0.5*T9_Vsbulk_si))-((((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))))))+(((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si)))*((0.5*T9_Vdi_bi)-(((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsbulk_si+0.0*T9_Vdi_bi+0.5*T9_Vdi_bi_Vsbulk_si)-(+(DQSD_Vdi_bi_Vsbulk_si/6.0-(DQSD_Vdi_bi*0.0+DQSD_Vsbulk_si*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdi_bi/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))+(DQSD_Vsbulk_si/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdi_bi_Vsbulk_si*T5+DQSD_Vdi_bi*T5_Vsbulk_si+DQSD_Vsbulk_si*T5_Vdi_bi+DQSD*T5_Vdi_bi_Vsbulk_si))-(+0.0*T10+0.0*T10_Vsbulk_si+0.0*T10_Vdi_bi+0.2*T10_Vdi_bi_Vsbulk_si)))));
  Qd1_Vdi_bi_Vgi_bi=(+(+nq_Vdi_bi_Vgi_bi*inv_MdL_2+nq_Vdi_bi*inv_MdL_2_Vgi_bi+nq_Vgi_bi*inv_MdL_2_Vdi_bi+nq*inv_MdL_2_Vdi_bi_Vgi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi))*(((0.5*T9_Vgi_bi))-((((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))))))+(((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi)))*((0.5*T9_Vdi_bi)-(((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vgi_bi+0.0*T9_Vdi_bi+0.5*T9_Vdi_bi_Vgi_bi)-(+(DQSD_Vdi_bi_Vgi_bi/6.0-(DQSD_Vdi_bi*0.0+DQSD_Vgi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdi_bi/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))+(DQSD_Vgi_bi/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdi_bi_Vgi_bi*T5+DQSD_Vdi_bi*T5_Vgi_bi+DQSD_Vgi_bi*T5_Vdi_bi+DQSD*T5_Vdi_bi_Vgi_bi))-(+0.0*T10+0.0*T10_Vgi_bi+0.0*T10_Vdi_bi+0.2*T10_Vdi_bi_Vgi_bi)))));
  Qd1_Vdi_bi_Tempt_GND=(+(+nq_Vdi_bi_Tempt_GND*inv_MdL_2+nq_Vdi_bi*inv_MdL_2_Tempt_GND+nq_Tempt_GND*inv_MdL_2_Vdi_bi+nq*inv_MdL_2_Vdi_bi_Tempt_GND)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi))*(((0.5*T9_Tempt_GND))-((((DQSD_Tempt_GND/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))))))+(((nq_Tempt_GND*inv_MdL_2)+(nq*inv_MdL_2_Tempt_GND)))*((0.5*T9_Vdi_bi)-(((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Tempt_GND+0.0*T9_Vdi_bi+0.5*T9_Vdi_bi_Tempt_GND)-(+(DQSD_Vdi_bi_Tempt_GND/6.0-(DQSD_Vdi_bi*0.0+DQSD_Tempt_GND*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdi_bi/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))+(DQSD_Tempt_GND/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdi_bi_Tempt_GND*T5+DQSD_Vdi_bi*T5_Tempt_GND+DQSD_Tempt_GND*T5_Vdi_bi+DQSD*T5_Vdi_bi_Tempt_GND))-(+0.0*T10+0.0*T10_Tempt_GND+0.0*T10_Vdi_bi+0.2*T10_Vdi_bi_Tempt_GND)))));
  Qd1_Vdi_bi_Vdi_bi=(+(+nq_Vdi_bi_Vdi_bi*inv_MdL_2+nq_Vdi_bi*inv_MdL_2_Vdi_bi+nq_Vdi_bi*inv_MdL_2_Vdi_bi+nq*inv_MdL_2_Vdi_bi_Vdi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi))*(((0.5*T9_Vdi_bi))-((((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))))))+(((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi)))*((0.5*T9_Vdi_bi)-(((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdi_bi+0.0*T9_Vdi_bi+0.5*T9_Vdi_bi_Vdi_bi)-(+(DQSD_Vdi_bi_Vdi_bi/6.0-(DQSD_Vdi_bi*0.0+DQSD_Vdi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdi_bi/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))+(DQSD_Vdi_bi/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdi_bi_Vdi_bi*T5+DQSD_Vdi_bi*T5_Vdi_bi+DQSD_Vdi_bi*T5_Vdi_bi+DQSD*T5_Vdi_bi_Vdi_bi))-(+0.0*T10+0.0*T10_Vdi_bi+0.0*T10_Vdi_bi+0.2*T10_Vdi_bi_Vdi_bi)))));
  Qd1_Vdi_bi_Vsi_bi=(+(+nq_Vdi_bi_Vsi_bi*inv_MdL_2+nq_Vdi_bi*inv_MdL_2_Vsi_bi+nq_Vsi_bi*inv_MdL_2_Vdi_bi+nq*inv_MdL_2_Vdi_bi_Vsi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi))*(((0.5*T9_Vsi_bi))-((((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))))))+(((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi)))*((0.5*T9_Vdi_bi)-(((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsi_bi+0.0*T9_Vdi_bi+0.5*T9_Vdi_bi_Vsi_bi)-(+(DQSD_Vdi_bi_Vsi_bi/6.0-(DQSD_Vdi_bi*0.0+DQSD_Vsi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vdi_bi/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))+(DQSD_Vsi_bi/6.0)*((-((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi)))-(0.2*T10_Vdi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vdi_bi_Vsi_bi*T5+DQSD_Vdi_bi*T5_Vsi_bi+DQSD_Vsi_bi*T5_Vdi_bi+DQSD*T5_Vdi_bi_Vsi_bi))-(+0.0*T10+0.0*T10_Vsi_bi+0.0*T10_Vdi_bi+0.2*T10_Vdi_bi_Vsi_bi)))));
#endif
Qd1_Vsi_bi=((((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi))*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))))+((nq*inv_MdL_2)*((0.5*T9_Vsi_bi)-(((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi)))))));
#if defined(_DERIVATE2)
  Qd1_Vsi_bi_Vdbulk_di=(+(+nq_Vsi_bi_Vdbulk_di*inv_MdL_2+nq_Vsi_bi*inv_MdL_2_Vdbulk_di+nq_Vdbulk_di*inv_MdL_2_Vsi_bi+nq*inv_MdL_2_Vsi_bi_Vdbulk_di)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi))*(((0.5*T9_Vdbulk_di))-((((DQSD_Vdbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))))))+(((nq_Vdbulk_di*inv_MdL_2)+(nq*inv_MdL_2_Vdbulk_di)))*((0.5*T9_Vsi_bi)-(((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdbulk_di+0.0*T9_Vsi_bi+0.5*T9_Vsi_bi_Vdbulk_di)-(+(DQSD_Vsi_bi_Vdbulk_di/6.0-(DQSD_Vsi_bi*0.0+DQSD_Vdbulk_di*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsi_bi/6.0)*((-(((DQSD_Vdbulk_di*T5)+(DQSD*T5_Vdbulk_di))))-((0.2*T10_Vdbulk_di)))+(DQSD_Vdbulk_di/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsi_bi_Vdbulk_di*T5+DQSD_Vsi_bi*T5_Vdbulk_di+DQSD_Vdbulk_di*T5_Vsi_bi+DQSD*T5_Vsi_bi_Vdbulk_di))-(+0.0*T10+0.0*T10_Vdbulk_di+0.0*T10_Vsi_bi+0.2*T10_Vsi_bi_Vdbulk_di)))));
  Qd1_Vsi_bi_Vsbulk_si=(+(+nq_Vsi_bi_Vsbulk_si*inv_MdL_2+nq_Vsi_bi*inv_MdL_2_Vsbulk_si+nq_Vsbulk_si*inv_MdL_2_Vsi_bi+nq*inv_MdL_2_Vsi_bi_Vsbulk_si)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi))*(((0.5*T9_Vsbulk_si))-((((DQSD_Vsbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))))))+(((nq_Vsbulk_si*inv_MdL_2)+(nq*inv_MdL_2_Vsbulk_si)))*((0.5*T9_Vsi_bi)-(((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsbulk_si+0.0*T9_Vsi_bi+0.5*T9_Vsi_bi_Vsbulk_si)-(+(DQSD_Vsi_bi_Vsbulk_si/6.0-(DQSD_Vsi_bi*0.0+DQSD_Vsbulk_si*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsi_bi/6.0)*((-(((DQSD_Vsbulk_si*T5)+(DQSD*T5_Vsbulk_si))))-((0.2*T10_Vsbulk_si)))+(DQSD_Vsbulk_si/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsi_bi_Vsbulk_si*T5+DQSD_Vsi_bi*T5_Vsbulk_si+DQSD_Vsbulk_si*T5_Vsi_bi+DQSD*T5_Vsi_bi_Vsbulk_si))-(+0.0*T10+0.0*T10_Vsbulk_si+0.0*T10_Vsi_bi+0.2*T10_Vsi_bi_Vsbulk_si)))));
  Qd1_Vsi_bi_Vgi_bi=(+(+nq_Vsi_bi_Vgi_bi*inv_MdL_2+nq_Vsi_bi*inv_MdL_2_Vgi_bi+nq_Vgi_bi*inv_MdL_2_Vsi_bi+nq*inv_MdL_2_Vsi_bi_Vgi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi))*(((0.5*T9_Vgi_bi))-((((DQSD_Vgi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))))))+(((nq_Vgi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vgi_bi)))*((0.5*T9_Vsi_bi)-(((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vgi_bi+0.0*T9_Vsi_bi+0.5*T9_Vsi_bi_Vgi_bi)-(+(DQSD_Vsi_bi_Vgi_bi/6.0-(DQSD_Vsi_bi*0.0+DQSD_Vgi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsi_bi/6.0)*((-(((DQSD_Vgi_bi*T5)+(DQSD*T5_Vgi_bi))))-((0.2*T10_Vgi_bi)))+(DQSD_Vgi_bi/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsi_bi_Vgi_bi*T5+DQSD_Vsi_bi*T5_Vgi_bi+DQSD_Vgi_bi*T5_Vsi_bi+DQSD*T5_Vsi_bi_Vgi_bi))-(+0.0*T10+0.0*T10_Vgi_bi+0.0*T10_Vsi_bi+0.2*T10_Vsi_bi_Vgi_bi)))));
  Qd1_Vsi_bi_Tempt_GND=(+(+nq_Vsi_bi_Tempt_GND*inv_MdL_2+nq_Vsi_bi*inv_MdL_2_Tempt_GND+nq_Tempt_GND*inv_MdL_2_Vsi_bi+nq*inv_MdL_2_Vsi_bi_Tempt_GND)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi))*(((0.5*T9_Tempt_GND))-((((DQSD_Tempt_GND/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))))))+(((nq_Tempt_GND*inv_MdL_2)+(nq*inv_MdL_2_Tempt_GND)))*((0.5*T9_Vsi_bi)-(((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Tempt_GND+0.0*T9_Vsi_bi+0.5*T9_Vsi_bi_Tempt_GND)-(+(DQSD_Vsi_bi_Tempt_GND/6.0-(DQSD_Vsi_bi*0.0+DQSD_Tempt_GND*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsi_bi/6.0)*((-(((DQSD_Tempt_GND*T5)+(DQSD*T5_Tempt_GND))))-((0.2*T10_Tempt_GND)))+(DQSD_Tempt_GND/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsi_bi_Tempt_GND*T5+DQSD_Vsi_bi*T5_Tempt_GND+DQSD_Tempt_GND*T5_Vsi_bi+DQSD*T5_Vsi_bi_Tempt_GND))-(+0.0*T10+0.0*T10_Tempt_GND+0.0*T10_Vsi_bi+0.2*T10_Vsi_bi_Tempt_GND)))));
  Qd1_Vsi_bi_Vdi_bi=(+(+nq_Vsi_bi_Vdi_bi*inv_MdL_2+nq_Vsi_bi*inv_MdL_2_Vdi_bi+nq_Vdi_bi*inv_MdL_2_Vsi_bi+nq*inv_MdL_2_Vsi_bi_Vdi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi))*(((0.5*T9_Vdi_bi))-((((DQSD_Vdi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))))))+(((nq_Vdi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vdi_bi)))*((0.5*T9_Vsi_bi)-(((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vdi_bi+0.0*T9_Vsi_bi+0.5*T9_Vsi_bi_Vdi_bi)-(+(DQSD_Vsi_bi_Vdi_bi/6.0-(DQSD_Vsi_bi*0.0+DQSD_Vdi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsi_bi/6.0)*((-(((DQSD_Vdi_bi*T5)+(DQSD*T5_Vdi_bi))))-((0.2*T10_Vdi_bi)))+(DQSD_Vdi_bi/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsi_bi_Vdi_bi*T5+DQSD_Vsi_bi*T5_Vdi_bi+DQSD_Vdi_bi*T5_Vsi_bi+DQSD*T5_Vsi_bi_Vdi_bi))-(+0.0*T10+0.0*T10_Vdi_bi+0.0*T10_Vsi_bi+0.2*T10_Vsi_bi_Vdi_bi)))));
  Qd1_Vsi_bi_Vsi_bi=(+(+nq_Vsi_bi_Vsi_bi*inv_MdL_2+nq_Vsi_bi*inv_MdL_2_Vsi_bi+nq_Vsi_bi*inv_MdL_2_Vsi_bi+nq*inv_MdL_2_Vsi_bi_Vsi_bi)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi))*(((0.5*T9_Vsi_bi))-((((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))))))+(((nq_Vsi_bi*inv_MdL_2)+(nq*inv_MdL_2_Vsi_bi)))*((0.5*T9_Vsi_bi)-(((DQSD_Vsi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))+((DQSD/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi)))))+(nq*inv_MdL_2)*(+(+0.0*T9+0.0*T9_Vsi_bi+0.0*T9_Vsi_bi+0.5*T9_Vsi_bi_Vsi_bi)-(+(DQSD_Vsi_bi_Vsi_bi/6.0-(DQSD_Vsi_bi*0.0+DQSD_Vsi_bi*0.0+DQSD*0.0)/6.0/6.0+2*DQSD*0.0*0.0/6.0/6.0/6.0)*((1.0-(DQSD*T5))-(0.2*T10))+(DQSD_Vsi_bi/6.0)*((-(((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi))))-((0.2*T10_Vsi_bi)))+(DQSD_Vsi_bi/6.0)*((-((DQSD_Vsi_bi*T5)+(DQSD*T5_Vsi_bi)))-(0.2*T10_Vsi_bi))+(DQSD/6.0)*(+(+0.0-(+DQSD_Vsi_bi_Vsi_bi*T5+DQSD_Vsi_bi*T5_Vsi_bi+DQSD_Vsi_bi*T5_Vsi_bi+DQSD*T5_Vsi_bi_Vsi_bi))-(+0.0*T10+0.0*T10_Vsi_bi+0.0*T10_Vsi_bi+0.2*T10_Vsi_bi_Vsi_bi)))));
#endif
#endif
Qd1=((nq*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
EXIT_IF_ISNAN(((nq*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Qd2_Vdbulk_di=((((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)))*qdeff)+((nq*(MdL-inv_MdL))*qdeff_Vdbulk_di));
#if defined(_DERIVATE2)
  Qd2_Vdbulk_di_Vdbulk_di=(+(+nq_Vdbulk_di_Vdbulk_di*(MdL-inv_MdL)+nq_Vdbulk_di*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq_Vdbulk_di*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq*(+MdL_Vdbulk_di_Vdbulk_di-inv_MdL_Vdbulk_di_Vdbulk_di))*qdeff+((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)))*qdeff_Vdbulk_di+(((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di))))*qdeff_Vdbulk_di+(nq*(MdL-inv_MdL))*qdeff_Vdbulk_di_Vdbulk_di);
  Qd2_Vdbulk_di_Vsbulk_si=(+(+nq_Vdbulk_di_Vsbulk_si*(MdL-inv_MdL)+nq_Vdbulk_di*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq_Vsbulk_si*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq*(+MdL_Vdbulk_di_Vsbulk_si-inv_MdL_Vdbulk_di_Vsbulk_si))*qdeff+((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)))*qdeff_Vsbulk_si+(((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si))))*qdeff_Vdbulk_di+(nq*(MdL-inv_MdL))*qdeff_Vdbulk_di_Vsbulk_si);
  Qd2_Vdbulk_di_Vgi_bi=(+(+nq_Vdbulk_di_Vgi_bi*(MdL-inv_MdL)+nq_Vdbulk_di*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq_Vgi_bi*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq*(+MdL_Vdbulk_di_Vgi_bi-inv_MdL_Vdbulk_di_Vgi_bi))*qdeff+((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)))*qdeff_Vgi_bi+(((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi))))*qdeff_Vdbulk_di+(nq*(MdL-inv_MdL))*qdeff_Vdbulk_di_Vgi_bi);
  Qd2_Vdbulk_di_Tempt_GND=(+(+nq_Vdbulk_di_Tempt_GND*(MdL-inv_MdL)+nq_Vdbulk_di*(MdL_Tempt_GND-inv_MdL_Tempt_GND)+nq_Tempt_GND*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq*(+MdL_Vdbulk_di_Tempt_GND-inv_MdL_Vdbulk_di_Tempt_GND))*qdeff+((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)))*qdeff_Tempt_GND+(((nq_Tempt_GND*(MdL-inv_MdL))+(nq*(MdL_Tempt_GND-inv_MdL_Tempt_GND))))*qdeff_Vdbulk_di+(nq*(MdL-inv_MdL))*qdeff_Vdbulk_di_Tempt_GND);
  Qd2_Vdbulk_di_Vdi_bi=(+(+nq_Vdbulk_di_Vdi_bi*(MdL-inv_MdL)+nq_Vdbulk_di*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq_Vdi_bi*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq*(+MdL_Vdbulk_di_Vdi_bi-inv_MdL_Vdbulk_di_Vdi_bi))*qdeff+((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)))*qdeff_Vdi_bi+(((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi))))*qdeff_Vdbulk_di+(nq*(MdL-inv_MdL))*qdeff_Vdbulk_di_Vdi_bi);
  Qd2_Vdbulk_di_Vsi_bi=(+(+nq_Vdbulk_di_Vsi_bi*(MdL-inv_MdL)+nq_Vdbulk_di*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq_Vsi_bi*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq*(+MdL_Vdbulk_di_Vsi_bi-inv_MdL_Vdbulk_di_Vsi_bi))*qdeff+((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)))*qdeff_Vsi_bi+(((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi))))*qdeff_Vdbulk_di+(nq*(MdL-inv_MdL))*qdeff_Vdbulk_di_Vsi_bi);
#endif
Qd2_Vsbulk_si=((((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)))*qdeff)+((nq*(MdL-inv_MdL))*qdeff_Vsbulk_si));
#if defined(_DERIVATE2)
  Qd2_Vsbulk_si_Vdbulk_di=(+(+nq_Vsbulk_si_Vdbulk_di*(MdL-inv_MdL)+nq_Vsbulk_si*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq_Vdbulk_di*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq*(+MdL_Vsbulk_si_Vdbulk_di-inv_MdL_Vsbulk_si_Vdbulk_di))*qdeff+((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)))*qdeff_Vdbulk_di+(((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di))))*qdeff_Vsbulk_si+(nq*(MdL-inv_MdL))*qdeff_Vsbulk_si_Vdbulk_di);
  Qd2_Vsbulk_si_Vsbulk_si=(+(+nq_Vsbulk_si_Vsbulk_si*(MdL-inv_MdL)+nq_Vsbulk_si*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq_Vsbulk_si*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq*(+MdL_Vsbulk_si_Vsbulk_si-inv_MdL_Vsbulk_si_Vsbulk_si))*qdeff+((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)))*qdeff_Vsbulk_si+(((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si))))*qdeff_Vsbulk_si+(nq*(MdL-inv_MdL))*qdeff_Vsbulk_si_Vsbulk_si);
  Qd2_Vsbulk_si_Vgi_bi=(+(+nq_Vsbulk_si_Vgi_bi*(MdL-inv_MdL)+nq_Vsbulk_si*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq_Vgi_bi*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq*(+MdL_Vsbulk_si_Vgi_bi-inv_MdL_Vsbulk_si_Vgi_bi))*qdeff+((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)))*qdeff_Vgi_bi+(((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi))))*qdeff_Vsbulk_si+(nq*(MdL-inv_MdL))*qdeff_Vsbulk_si_Vgi_bi);
  Qd2_Vsbulk_si_Tempt_GND=(+(+nq_Vsbulk_si_Tempt_GND*(MdL-inv_MdL)+nq_Vsbulk_si*(MdL_Tempt_GND-inv_MdL_Tempt_GND)+nq_Tempt_GND*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq*(+MdL_Vsbulk_si_Tempt_GND-inv_MdL_Vsbulk_si_Tempt_GND))*qdeff+((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)))*qdeff_Tempt_GND+(((nq_Tempt_GND*(MdL-inv_MdL))+(nq*(MdL_Tempt_GND-inv_MdL_Tempt_GND))))*qdeff_Vsbulk_si+(nq*(MdL-inv_MdL))*qdeff_Vsbulk_si_Tempt_GND);
  Qd2_Vsbulk_si_Vdi_bi=(+(+nq_Vsbulk_si_Vdi_bi*(MdL-inv_MdL)+nq_Vsbulk_si*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq_Vdi_bi*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq*(+MdL_Vsbulk_si_Vdi_bi-inv_MdL_Vsbulk_si_Vdi_bi))*qdeff+((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)))*qdeff_Vdi_bi+(((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi))))*qdeff_Vsbulk_si+(nq*(MdL-inv_MdL))*qdeff_Vsbulk_si_Vdi_bi);
  Qd2_Vsbulk_si_Vsi_bi=(+(+nq_Vsbulk_si_Vsi_bi*(MdL-inv_MdL)+nq_Vsbulk_si*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq_Vsi_bi*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq*(+MdL_Vsbulk_si_Vsi_bi-inv_MdL_Vsbulk_si_Vsi_bi))*qdeff+((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)))*qdeff_Vsi_bi+(((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi))))*qdeff_Vsbulk_si+(nq*(MdL-inv_MdL))*qdeff_Vsbulk_si_Vsi_bi);
#endif
Qd2_Vgi_bi=((((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi)))*qdeff)+((nq*(MdL-inv_MdL))*qdeff_Vgi_bi));
#if defined(_DERIVATE2)
  Qd2_Vgi_bi_Vdbulk_di=(+(+nq_Vgi_bi_Vdbulk_di*(MdL-inv_MdL)+nq_Vgi_bi*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq_Vdbulk_di*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq*(+MdL_Vgi_bi_Vdbulk_di-inv_MdL_Vgi_bi_Vdbulk_di))*qdeff+((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi)))*qdeff_Vdbulk_di+(((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di))))*qdeff_Vgi_bi+(nq*(MdL-inv_MdL))*qdeff_Vgi_bi_Vdbulk_di);
  Qd2_Vgi_bi_Vsbulk_si=(+(+nq_Vgi_bi_Vsbulk_si*(MdL-inv_MdL)+nq_Vgi_bi*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq_Vsbulk_si*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq*(+MdL_Vgi_bi_Vsbulk_si-inv_MdL_Vgi_bi_Vsbulk_si))*qdeff+((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi)))*qdeff_Vsbulk_si+(((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si))))*qdeff_Vgi_bi+(nq*(MdL-inv_MdL))*qdeff_Vgi_bi_Vsbulk_si);
  Qd2_Vgi_bi_Vgi_bi=(+(+nq_Vgi_bi_Vgi_bi*(MdL-inv_MdL)+nq_Vgi_bi*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq_Vgi_bi*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq*(+MdL_Vgi_bi_Vgi_bi-inv_MdL_Vgi_bi_Vgi_bi))*qdeff+((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi)))*qdeff_Vgi_bi+(((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi))))*qdeff_Vgi_bi+(nq*(MdL-inv_MdL))*qdeff_Vgi_bi_Vgi_bi);
  Qd2_Vgi_bi_Tempt_GND=(+(+nq_Vgi_bi_Tempt_GND*(MdL-inv_MdL)+nq_Vgi_bi*(MdL_Tempt_GND-inv_MdL_Tempt_GND)+nq_Tempt_GND*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq*(+MdL_Vgi_bi_Tempt_GND-inv_MdL_Vgi_bi_Tempt_GND))*qdeff+((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi)))*qdeff_Tempt_GND+(((nq_Tempt_GND*(MdL-inv_MdL))+(nq*(MdL_Tempt_GND-inv_MdL_Tempt_GND))))*qdeff_Vgi_bi+(nq*(MdL-inv_MdL))*qdeff_Vgi_bi_Tempt_GND);
  Qd2_Vgi_bi_Vdi_bi=(+(+nq_Vgi_bi_Vdi_bi*(MdL-inv_MdL)+nq_Vgi_bi*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq_Vdi_bi*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq*(+MdL_Vgi_bi_Vdi_bi-inv_MdL_Vgi_bi_Vdi_bi))*qdeff+((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi)))*qdeff_Vdi_bi+(((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi))))*qdeff_Vgi_bi+(nq*(MdL-inv_MdL))*qdeff_Vgi_bi_Vdi_bi);
  Qd2_Vgi_bi_Vsi_bi=(+(+nq_Vgi_bi_Vsi_bi*(MdL-inv_MdL)+nq_Vgi_bi*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq_Vsi_bi*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq*(+MdL_Vgi_bi_Vsi_bi-inv_MdL_Vgi_bi_Vsi_bi))*qdeff+((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi)))*qdeff_Vsi_bi+(((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi))))*qdeff_Vgi_bi+(nq*(MdL-inv_MdL))*qdeff_Vgi_bi_Vsi_bi);
#endif
#if defined(_DERIVATE)
Qd2_Tempt_GND=((((nq_Tempt_GND*(MdL-inv_MdL))+(nq*(MdL_Tempt_GND-inv_MdL_Tempt_GND)))*qdeff)+((nq*(MdL-inv_MdL))*qdeff_Tempt_GND));
#endif
Qd2_Vdi_bi=((((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi)))*qdeff)+((nq*(MdL-inv_MdL))*qdeff_Vdi_bi));
#if defined(_DERIVATE2)
  Qd2_Vdi_bi_Vdbulk_di=(+(+nq_Vdi_bi_Vdbulk_di*(MdL-inv_MdL)+nq_Vdi_bi*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq_Vdbulk_di*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq*(+MdL_Vdi_bi_Vdbulk_di-inv_MdL_Vdi_bi_Vdbulk_di))*qdeff+((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi)))*qdeff_Vdbulk_di+(((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di))))*qdeff_Vdi_bi+(nq*(MdL-inv_MdL))*qdeff_Vdi_bi_Vdbulk_di);
  Qd2_Vdi_bi_Vsbulk_si=(+(+nq_Vdi_bi_Vsbulk_si*(MdL-inv_MdL)+nq_Vdi_bi*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq_Vsbulk_si*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq*(+MdL_Vdi_bi_Vsbulk_si-inv_MdL_Vdi_bi_Vsbulk_si))*qdeff+((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi)))*qdeff_Vsbulk_si+(((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si))))*qdeff_Vdi_bi+(nq*(MdL-inv_MdL))*qdeff_Vdi_bi_Vsbulk_si);
  Qd2_Vdi_bi_Vgi_bi=(+(+nq_Vdi_bi_Vgi_bi*(MdL-inv_MdL)+nq_Vdi_bi*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq_Vgi_bi*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq*(+MdL_Vdi_bi_Vgi_bi-inv_MdL_Vdi_bi_Vgi_bi))*qdeff+((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi)))*qdeff_Vgi_bi+(((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi))))*qdeff_Vdi_bi+(nq*(MdL-inv_MdL))*qdeff_Vdi_bi_Vgi_bi);
  Qd2_Vdi_bi_Tempt_GND=(+(+nq_Vdi_bi_Tempt_GND*(MdL-inv_MdL)+nq_Vdi_bi*(MdL_Tempt_GND-inv_MdL_Tempt_GND)+nq_Tempt_GND*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq*(+MdL_Vdi_bi_Tempt_GND-inv_MdL_Vdi_bi_Tempt_GND))*qdeff+((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi)))*qdeff_Tempt_GND+(((nq_Tempt_GND*(MdL-inv_MdL))+(nq*(MdL_Tempt_GND-inv_MdL_Tempt_GND))))*qdeff_Vdi_bi+(nq*(MdL-inv_MdL))*qdeff_Vdi_bi_Tempt_GND);
  Qd2_Vdi_bi_Vdi_bi=(+(+nq_Vdi_bi_Vdi_bi*(MdL-inv_MdL)+nq_Vdi_bi*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq_Vdi_bi*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq*(+MdL_Vdi_bi_Vdi_bi-inv_MdL_Vdi_bi_Vdi_bi))*qdeff+((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi)))*qdeff_Vdi_bi+(((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi))))*qdeff_Vdi_bi+(nq*(MdL-inv_MdL))*qdeff_Vdi_bi_Vdi_bi);
  Qd2_Vdi_bi_Vsi_bi=(+(+nq_Vdi_bi_Vsi_bi*(MdL-inv_MdL)+nq_Vdi_bi*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq_Vsi_bi*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq*(+MdL_Vdi_bi_Vsi_bi-inv_MdL_Vdi_bi_Vsi_bi))*qdeff+((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi)))*qdeff_Vsi_bi+(((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi))))*qdeff_Vdi_bi+(nq*(MdL-inv_MdL))*qdeff_Vdi_bi_Vsi_bi);
#endif
Qd2_Vsi_bi=((((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi)))*qdeff)+((nq*(MdL-inv_MdL))*qdeff_Vsi_bi));
#if defined(_DERIVATE2)
  Qd2_Vsi_bi_Vdbulk_di=(+(+nq_Vsi_bi_Vdbulk_di*(MdL-inv_MdL)+nq_Vsi_bi*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di)+nq_Vdbulk_di*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq*(+MdL_Vsi_bi_Vdbulk_di-inv_MdL_Vsi_bi_Vdbulk_di))*qdeff+((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi)))*qdeff_Vdbulk_di+(((nq_Vdbulk_di*(MdL-inv_MdL))+(nq*(MdL_Vdbulk_di-inv_MdL_Vdbulk_di))))*qdeff_Vsi_bi+(nq*(MdL-inv_MdL))*qdeff_Vsi_bi_Vdbulk_di);
  Qd2_Vsi_bi_Vsbulk_si=(+(+nq_Vsi_bi_Vsbulk_si*(MdL-inv_MdL)+nq_Vsi_bi*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si)+nq_Vsbulk_si*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq*(+MdL_Vsi_bi_Vsbulk_si-inv_MdL_Vsi_bi_Vsbulk_si))*qdeff+((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi)))*qdeff_Vsbulk_si+(((nq_Vsbulk_si*(MdL-inv_MdL))+(nq*(MdL_Vsbulk_si-inv_MdL_Vsbulk_si))))*qdeff_Vsi_bi+(nq*(MdL-inv_MdL))*qdeff_Vsi_bi_Vsbulk_si);
  Qd2_Vsi_bi_Vgi_bi=(+(+nq_Vsi_bi_Vgi_bi*(MdL-inv_MdL)+nq_Vsi_bi*(MdL_Vgi_bi-inv_MdL_Vgi_bi)+nq_Vgi_bi*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq*(+MdL_Vsi_bi_Vgi_bi-inv_MdL_Vsi_bi_Vgi_bi))*qdeff+((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi)))*qdeff_Vgi_bi+(((nq_Vgi_bi*(MdL-inv_MdL))+(nq*(MdL_Vgi_bi-inv_MdL_Vgi_bi))))*qdeff_Vsi_bi+(nq*(MdL-inv_MdL))*qdeff_Vsi_bi_Vgi_bi);
  Qd2_Vsi_bi_Tempt_GND=(+(+nq_Vsi_bi_Tempt_GND*(MdL-inv_MdL)+nq_Vsi_bi*(MdL_Tempt_GND-inv_MdL_Tempt_GND)+nq_Tempt_GND*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq*(+MdL_Vsi_bi_Tempt_GND-inv_MdL_Vsi_bi_Tempt_GND))*qdeff+((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi)))*qdeff_Tempt_GND+(((nq_Tempt_GND*(MdL-inv_MdL))+(nq*(MdL_Tempt_GND-inv_MdL_Tempt_GND))))*qdeff_Vsi_bi+(nq*(MdL-inv_MdL))*qdeff_Vsi_bi_Tempt_GND);
  Qd2_Vsi_bi_Vdi_bi=(+(+nq_Vsi_bi_Vdi_bi*(MdL-inv_MdL)+nq_Vsi_bi*(MdL_Vdi_bi-inv_MdL_Vdi_bi)+nq_Vdi_bi*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq*(+MdL_Vsi_bi_Vdi_bi-inv_MdL_Vsi_bi_Vdi_bi))*qdeff+((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi)))*qdeff_Vdi_bi+(((nq_Vdi_bi*(MdL-inv_MdL))+(nq*(MdL_Vdi_bi-inv_MdL_Vdi_bi))))*qdeff_Vsi_bi+(nq*(MdL-inv_MdL))*qdeff_Vsi_bi_Vdi_bi);
  Qd2_Vsi_bi_Vsi_bi=(+(+nq_Vsi_bi_Vsi_bi*(MdL-inv_MdL)+nq_Vsi_bi*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq_Vsi_bi*(MdL_Vsi_bi-inv_MdL_Vsi_bi)+nq*(+MdL_Vsi_bi_Vsi_bi-inv_MdL_Vsi_bi_Vsi_bi))*qdeff+((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi)))*qdeff_Vsi_bi+(((nq_Vsi_bi*(MdL-inv_MdL))+(nq*(MdL_Vsi_bi-inv_MdL_Vsi_bi))))*qdeff_Vsi_bi+(nq*(MdL-inv_MdL))*qdeff_Vsi_bi_Vsi_bi);
#endif
#endif
Qd2=((nq*(MdL-inv_MdL))*qdeff);
EXIT_IF_ISNAN(((nq*(MdL-inv_MdL))*qdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
Qd_Vdbulk_di=(Qd1_Vdbulk_di+Qd2_Vdbulk_di);
#if defined(_DERIVATE2)
  Qd_Vdbulk_di_Vdbulk_di=(+Qd1_Vdbulk_di_Vdbulk_di+Qd2_Vdbulk_di_Vdbulk_di);
  Qd_Vdbulk_di_Vsbulk_si=(+Qd1_Vdbulk_di_Vsbulk_si+Qd2_Vdbulk_di_Vsbulk_si);
  Qd_Vdbulk_di_Vgi_bi=(+Qd1_Vdbulk_di_Vgi_bi+Qd2_Vdbulk_di_Vgi_bi);
  Qd_Vdbulk_di_Vdi_bi=(+Qd1_Vdbulk_di_Vdi_bi+Qd2_Vdbulk_di_Vdi_bi);
  Qd_Vdbulk_di_Vsi_bi=(+Qd1_Vdbulk_di_Vsi_bi+Qd2_Vdbulk_di_Vsi_bi);
  Qd_Vdbulk_di_Tempt_GND=(+Qd1_Vdbulk_di_Tempt_GND+Qd2_Vdbulk_di_Tempt_GND);
#endif
Qd_Vsbulk_si=(Qd1_Vsbulk_si+Qd2_Vsbulk_si);
#if defined(_DERIVATE2)
  Qd_Vsbulk_si_Vdbulk_di=(+Qd1_Vsbulk_si_Vdbulk_di+Qd2_Vsbulk_si_Vdbulk_di);
  Qd_Vsbulk_si_Vsbulk_si=(+Qd1_Vsbulk_si_Vsbulk_si+Qd2_Vsbulk_si_Vsbulk_si);
  Qd_Vsbulk_si_Vgi_bi=(+Qd1_Vsbulk_si_Vgi_bi+Qd2_Vsbulk_si_Vgi_bi);
  Qd_Vsbulk_si_Vdi_bi=(+Qd1_Vsbulk_si_Vdi_bi+Qd2_Vsbulk_si_Vdi_bi);
  Qd_Vsbulk_si_Vsi_bi=(+Qd1_Vsbulk_si_Vsi_bi+Qd2_Vsbulk_si_Vsi_bi);
  Qd_Vsbulk_si_Tempt_GND=(+Qd1_Vsbulk_si_Tempt_GND+Qd2_Vsbulk_si_Tempt_GND);
#endif
Qd_Vgi_bi=(Qd1_Vgi_bi+Qd2_Vgi_bi);
#if defined(_DERIVATE2)
  Qd_Vgi_bi_Vdbulk_di=(+Qd1_Vgi_bi_Vdbulk_di+Qd2_Vgi_bi_Vdbulk_di);
  Qd_Vgi_bi_Vsbulk_si=(+Qd1_Vgi_bi_Vsbulk_si+Qd2_Vgi_bi_Vsbulk_si);
  Qd_Vgi_bi_Vgi_bi=(+Qd1_Vgi_bi_Vgi_bi+Qd2_Vgi_bi_Vgi_bi);
  Qd_Vgi_bi_Vdi_bi=(+Qd1_Vgi_bi_Vdi_bi+Qd2_Vgi_bi_Vdi_bi);
  Qd_Vgi_bi_Vsi_bi=(+Qd1_Vgi_bi_Vsi_bi+Qd2_Vgi_bi_Vsi_bi);
  Qd_Vgi_bi_Tempt_GND=(+Qd1_Vgi_bi_Tempt_GND+Qd2_Vgi_bi_Tempt_GND);
#endif
Qd_Vdi_bi=(Qd1_Vdi_bi+Qd2_Vdi_bi);
#if defined(_DERIVATE2)
  Qd_Vdi_bi_Vdbulk_di=(+Qd1_Vdi_bi_Vdbulk_di+Qd2_Vdi_bi_Vdbulk_di);
  Qd_Vdi_bi_Vsbulk_si=(+Qd1_Vdi_bi_Vsbulk_si+Qd2_Vdi_bi_Vsbulk_si);
  Qd_Vdi_bi_Vgi_bi=(+Qd1_Vdi_bi_Vgi_bi+Qd2_Vdi_bi_Vgi_bi);
  Qd_Vdi_bi_Vdi_bi=(+Qd1_Vdi_bi_Vdi_bi+Qd2_Vdi_bi_Vdi_bi);
  Qd_Vdi_bi_Vsi_bi=(+Qd1_Vdi_bi_Vsi_bi+Qd2_Vdi_bi_Vsi_bi);
  Qd_Vdi_bi_Tempt_GND=(+Qd1_Vdi_bi_Tempt_GND+Qd2_Vdi_bi_Tempt_GND);
#endif
Qd_Vsi_bi=(Qd1_Vsi_bi+Qd2_Vsi_bi);
#if defined(_DERIVATE2)
  Qd_Vsi_bi_Vdbulk_di=(+Qd1_Vsi_bi_Vdbulk_di+Qd2_Vsi_bi_Vdbulk_di);
  Qd_Vsi_bi_Vsbulk_si=(+Qd1_Vsi_bi_Vsbulk_si+Qd2_Vsi_bi_Vsbulk_si);
  Qd_Vsi_bi_Vgi_bi=(+Qd1_Vsi_bi_Vgi_bi+Qd2_Vsi_bi_Vgi_bi);
  Qd_Vsi_bi_Vdi_bi=(+Qd1_Vsi_bi_Vdi_bi+Qd2_Vsi_bi_Vdi_bi);
  Qd_Vsi_bi_Vsi_bi=(+Qd1_Vsi_bi_Vsi_bi+Qd2_Vsi_bi_Vsi_bi);
  Qd_Vsi_bi_Tempt_GND=(+Qd1_Vsi_bi_Tempt_GND+Qd2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Qd_Tempt_GND=(Qd1_Tempt_GND+Qd2_Tempt_GND);
#endif
#endif
Qd=(Qd1+Qd2);
EXIT_IF_ISNAN((Qd1+Qd2))
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(sbulk,GND) */
Qs_Vdbulk_di=(Qi_Vdbulk_di-Qd_Vdbulk_di);
#if defined(_DERIVATE2)
  Qs_Vdbulk_di_Vdbulk_di=(+Qi_Vdbulk_di_Vdbulk_di-Qd_Vdbulk_di_Vdbulk_di);
  Qs_Vdbulk_di_Vsbulk_si=(+Qi_Vdbulk_di_Vsbulk_si-Qd_Vdbulk_di_Vsbulk_si);
  Qs_Vdbulk_di_Vgi_bi=(+Qi_Vdbulk_di_Vgi_bi-Qd_Vdbulk_di_Vgi_bi);
  Qs_Vdbulk_di_Vdi_bi=(+Qi_Vdbulk_di_Vdi_bi-Qd_Vdbulk_di_Vdi_bi);
  Qs_Vdbulk_di_Vsi_bi=(+Qi_Vdbulk_di_Vsi_bi-Qd_Vdbulk_di_Vsi_bi);
  Qs_Vdbulk_di_Tempt_GND=(+Qi_Vdbulk_di_Tempt_GND-Qd_Vdbulk_di_Tempt_GND);
#endif
Qs_Vsbulk_si=(Qi_Vsbulk_si-Qd_Vsbulk_si);
#if defined(_DERIVATE2)
  Qs_Vsbulk_si_Vdbulk_di=(+Qi_Vsbulk_si_Vdbulk_di-Qd_Vsbulk_si_Vdbulk_di);
  Qs_Vsbulk_si_Vsbulk_si=(+Qi_Vsbulk_si_Vsbulk_si-Qd_Vsbulk_si_Vsbulk_si);
  Qs_Vsbulk_si_Vgi_bi=(+Qi_Vsbulk_si_Vgi_bi-Qd_Vsbulk_si_Vgi_bi);
  Qs_Vsbulk_si_Vdi_bi=(+Qi_Vsbulk_si_Vdi_bi-Qd_Vsbulk_si_Vdi_bi);
  Qs_Vsbulk_si_Vsi_bi=(+Qi_Vsbulk_si_Vsi_bi-Qd_Vsbulk_si_Vsi_bi);
  Qs_Vsbulk_si_Tempt_GND=(+Qi_Vsbulk_si_Tempt_GND-Qd_Vsbulk_si_Tempt_GND);
#endif
Qs_Vgi_bi=(Qi_Vgi_bi-Qd_Vgi_bi);
#if defined(_DERIVATE2)
  Qs_Vgi_bi_Vdbulk_di=(+Qi_Vgi_bi_Vdbulk_di-Qd_Vgi_bi_Vdbulk_di);
  Qs_Vgi_bi_Vsbulk_si=(+Qi_Vgi_bi_Vsbulk_si-Qd_Vgi_bi_Vsbulk_si);
  Qs_Vgi_bi_Vgi_bi=(+Qi_Vgi_bi_Vgi_bi-Qd_Vgi_bi_Vgi_bi);
  Qs_Vgi_bi_Vdi_bi=(+Qi_Vgi_bi_Vdi_bi-Qd_Vgi_bi_Vdi_bi);
  Qs_Vgi_bi_Vsi_bi=(+Qi_Vgi_bi_Vsi_bi-Qd_Vgi_bi_Vsi_bi);
  Qs_Vgi_bi_Tempt_GND=(+Qi_Vgi_bi_Tempt_GND-Qd_Vgi_bi_Tempt_GND);
#endif
Qs_Vdi_bi=(Qi_Vdi_bi-Qd_Vdi_bi);
#if defined(_DERIVATE2)
  Qs_Vdi_bi_Vdbulk_di=(+Qi_Vdi_bi_Vdbulk_di-Qd_Vdi_bi_Vdbulk_di);
  Qs_Vdi_bi_Vsbulk_si=(+Qi_Vdi_bi_Vsbulk_si-Qd_Vdi_bi_Vsbulk_si);
  Qs_Vdi_bi_Vgi_bi=(+Qi_Vdi_bi_Vgi_bi-Qd_Vdi_bi_Vgi_bi);
  Qs_Vdi_bi_Vdi_bi=(+Qi_Vdi_bi_Vdi_bi-Qd_Vdi_bi_Vdi_bi);
  Qs_Vdi_bi_Vsi_bi=(+Qi_Vdi_bi_Vsi_bi-Qd_Vdi_bi_Vsi_bi);
  Qs_Vdi_bi_Tempt_GND=(+Qi_Vdi_bi_Tempt_GND-Qd_Vdi_bi_Tempt_GND);
#endif
Qs_Vsi_bi=(Qi_Vsi_bi-Qd_Vsi_bi);
#if defined(_DERIVATE2)
  Qs_Vsi_bi_Vdbulk_di=(+Qi_Vsi_bi_Vdbulk_di-Qd_Vsi_bi_Vdbulk_di);
  Qs_Vsi_bi_Vsbulk_si=(+Qi_Vsi_bi_Vsbulk_si-Qd_Vsi_bi_Vsbulk_si);
  Qs_Vsi_bi_Vgi_bi=(+Qi_Vsi_bi_Vgi_bi-Qd_Vsi_bi_Vgi_bi);
  Qs_Vsi_bi_Vdi_bi=(+Qi_Vsi_bi_Vdi_bi-Qd_Vsi_bi_Vdi_bi);
  Qs_Vsi_bi_Vsi_bi=(+Qi_Vsi_bi_Vsi_bi-Qd_Vsi_bi_Vsi_bi);
  Qs_Vsi_bi_Tempt_GND=(+Qi_Vsi_bi_Tempt_GND-Qd_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Qs_Tempt_GND=(Qi_Tempt_GND-Qd_Tempt_GND);
#endif
#endif
Qs=(Qi-Qd);
EXIT_IF_ISNAN((Qi-Qd))
{
double m00_sqrt(d00_sqrt0,(((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
qbaCV_Tempt_GND=(0.5*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))+((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))*(Vt*Qb))+((Vt*Qb)*((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))*d10_sqrt0));
#endif
qbaCV_Vdbulk_di=(0.5*((Vt*Qb_Vdbulk_di)+(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbaCV_Vdbulk_di_Tempt_GND=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdbulk_di)+(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Tempt_GND)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Tempt_GND)-0.0)*(Vt*Qb)+(Vt*Qb_Vdbulk_di)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb_Vdbulk_di)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdbulk_di_Vdbulk_di=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdbulk_di))+((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdbulk_di)+(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vdbulk_di)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vdbulk_di)-0.0)*(Vt*Qb)+(Vt*Qb_Vdbulk_di)*((Vt*Qb_Vdbulk_di))+((Vt*Qb_Vdbulk_di))*(Vt*Qb_Vdbulk_di)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vdbulk_di)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdbulk_di_Vsbulk_si=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsbulk_si))+((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdbulk_di)+(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vsbulk_si)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vsbulk_si)-0.0)*(Vt*Qb)+(Vt*Qb_Vdbulk_di)*((Vt*Qb_Vsbulk_si))+((Vt*Qb_Vsbulk_si))*(Vt*Qb_Vdbulk_di)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vsbulk_si)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdbulk_di_Vgi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vgi_bi))+((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdbulk_di)+(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vgi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vgi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vdbulk_di)*((Vt*Qb_Vgi_bi))+((Vt*Qb_Vgi_bi))*(Vt*Qb_Vdbulk_di)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vgi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdbulk_di_Vdi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdi_bi))+((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdbulk_di)+(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vdi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vdi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vdbulk_di)*((Vt*Qb_Vdi_bi))+((Vt*Qb_Vdi_bi))*(Vt*Qb_Vdbulk_di)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdbulk_di_Vsi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsi_bi))+((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdbulk_di)+(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vsi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vdbulk_di)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdbulk_di)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vsi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vdbulk_di)*((Vt*Qb_Vsi_bi))+((Vt*Qb_Vsi_bi))*(Vt*Qb_Vdbulk_di)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vdbulk_di+Vt*Qb_Vdbulk_di_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbaCV_Vsbulk_si=(0.5*((Vt*Qb_Vsbulk_si)+(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbaCV_Vsbulk_si_Tempt_GND=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsbulk_si)+(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Tempt_GND)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Tempt_GND)-0.0)*(Vt*Qb)+(Vt*Qb_Vsbulk_si)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb_Vsbulk_si)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsbulk_si_Vdbulk_di=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdbulk_di))+((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsbulk_si)+(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vdbulk_di)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vdbulk_di)-0.0)*(Vt*Qb)+(Vt*Qb_Vsbulk_si)*((Vt*Qb_Vdbulk_di))+((Vt*Qb_Vdbulk_di))*(Vt*Qb_Vsbulk_si)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vdbulk_di)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsbulk_si_Vsbulk_si=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsbulk_si))+((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsbulk_si)+(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vsbulk_si)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vsbulk_si)-0.0)*(Vt*Qb)+(Vt*Qb_Vsbulk_si)*((Vt*Qb_Vsbulk_si))+((Vt*Qb_Vsbulk_si))*(Vt*Qb_Vsbulk_si)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vsbulk_si)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsbulk_si_Vgi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vgi_bi))+((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsbulk_si)+(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vgi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vgi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vsbulk_si)*((Vt*Qb_Vgi_bi))+((Vt*Qb_Vgi_bi))*(Vt*Qb_Vsbulk_si)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vgi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsbulk_si_Vdi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdi_bi))+((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsbulk_si)+(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vdi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vdi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vsbulk_si)*((Vt*Qb_Vdi_bi))+((Vt*Qb_Vdi_bi))*(Vt*Qb_Vsbulk_si)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsbulk_si_Vsi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsi_bi))+((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsbulk_si)+(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vsi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vsbulk_si)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsbulk_si)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vsi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vsbulk_si)*((Vt*Qb_Vsi_bi))+((Vt*Qb_Vsi_bi))*(Vt*Qb_Vsbulk_si)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vsbulk_si+Vt*Qb_Vsbulk_si_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbaCV_Vgi_bi=(0.5*((Vt*Qb_Vgi_bi)+(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbaCV_Vgi_bi_Tempt_GND=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vgi_bi)+(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Tempt_GND)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Tempt_GND)-0.0)*(Vt*Qb)+(Vt*Qb_Vgi_bi)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb_Vgi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vgi_bi_Vdbulk_di=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdbulk_di))+((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vgi_bi)+(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vdbulk_di)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vdbulk_di)-0.0)*(Vt*Qb)+(Vt*Qb_Vgi_bi)*((Vt*Qb_Vdbulk_di))+((Vt*Qb_Vdbulk_di))*(Vt*Qb_Vgi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vdbulk_di)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vgi_bi_Vsbulk_si=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsbulk_si))+((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vgi_bi)+(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vsbulk_si)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vsbulk_si)-0.0)*(Vt*Qb)+(Vt*Qb_Vgi_bi)*((Vt*Qb_Vsbulk_si))+((Vt*Qb_Vsbulk_si))*(Vt*Qb_Vgi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vsbulk_si)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vgi_bi_Vgi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vgi_bi))+((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vgi_bi)+(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vgi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vgi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vgi_bi)*((Vt*Qb_Vgi_bi))+((Vt*Qb_Vgi_bi))*(Vt*Qb_Vgi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vgi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vgi_bi_Vdi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdi_bi))+((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vgi_bi)+(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vdi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vdi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vgi_bi)*((Vt*Qb_Vdi_bi))+((Vt*Qb_Vdi_bi))*(Vt*Qb_Vgi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vgi_bi_Vsi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsi_bi))+((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vgi_bi)+(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vsi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vgi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vgi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vsi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vgi_bi)*((Vt*Qb_Vsi_bi))+((Vt*Qb_Vsi_bi))*(Vt*Qb_Vgi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vgi_bi+Vt*Qb_Vgi_bi_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbaCV_Vdi_bi=(0.5*((Vt*Qb_Vdi_bi)+(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbaCV_Vdi_bi_Tempt_GND=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdi_bi)+(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Tempt_GND)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Tempt_GND)-0.0)*(Vt*Qb)+(Vt*Qb_Vdi_bi)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb_Vdi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdi_bi_Vdbulk_di=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdbulk_di))+((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdi_bi)+(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vdbulk_di)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vdbulk_di)-0.0)*(Vt*Qb)+(Vt*Qb_Vdi_bi)*((Vt*Qb_Vdbulk_di))+((Vt*Qb_Vdbulk_di))*(Vt*Qb_Vdi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vdbulk_di)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdi_bi_Vsbulk_si=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsbulk_si))+((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdi_bi)+(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vsbulk_si)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vsbulk_si)-0.0)*(Vt*Qb)+(Vt*Qb_Vdi_bi)*((Vt*Qb_Vsbulk_si))+((Vt*Qb_Vsbulk_si))*(Vt*Qb_Vdi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vsbulk_si)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdi_bi_Vgi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vgi_bi))+((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdi_bi)+(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vgi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vgi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vdi_bi)*((Vt*Qb_Vgi_bi))+((Vt*Qb_Vgi_bi))*(Vt*Qb_Vdi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vgi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdi_bi_Vdi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdi_bi))+((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdi_bi)+(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vdi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vdi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vdi_bi)*((Vt*Qb_Vdi_bi))+((Vt*Qb_Vdi_bi))*(Vt*Qb_Vdi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vdi_bi_Vsi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsi_bi))+((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vdi_bi)+(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vsi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vdi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vdi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vsi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vdi_bi)*((Vt*Qb_Vsi_bi))+((Vt*Qb_Vsi_bi))*(Vt*Qb_Vdi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vdi_bi+Vt*Qb_Vdi_bi_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
qbaCV_Vsi_bi=(0.5*((Vt*Qb_Vsi_bi)+(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  qbaCV_Vsi_bi_Tempt_GND=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsi_bi)+(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Tempt_GND)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*(((((((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb))+((Vt*Qb)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND))))))+((0.0)*0.1))*(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Tempt_GND)-0.0)*(Vt*Qb)+(Vt*Qb_Vsi_bi)*(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))+(((Vt_Tempt_GND*Qb)+(Vt*Qb_Tempt_GND)))*(Vt*Qb_Vsi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Tempt_GND+Vt_Tempt_GND*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Tempt_GND)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsi_bi_Vdbulk_di=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdbulk_di))+((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsi_bi)+(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vdbulk_di)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdbulk_di))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdbulk_di)))))+((0.0)*0.1))*(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vdbulk_di)-0.0)*(Vt*Qb)+(Vt*Qb_Vsi_bi)*((Vt*Qb_Vdbulk_di))+((Vt*Qb_Vdbulk_di))*(Vt*Qb_Vsi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdbulk_di+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vdbulk_di)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsi_bi_Vsbulk_si=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsbulk_si))+((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsi_bi)+(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vsbulk_si)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsbulk_si))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsbulk_si)))))+((0.0)*0.1))*(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vsbulk_si)-0.0)*(Vt*Qb)+(Vt*Qb_Vsi_bi)*((Vt*Qb_Vsbulk_si))+((Vt*Qb_Vsbulk_si))*(Vt*Qb_Vsi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsbulk_si+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vsbulk_si)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsi_bi_Vgi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vgi_bi))+((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsi_bi)+(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vgi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vgi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vgi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vgi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vsi_bi)*((Vt*Qb_Vgi_bi))+((Vt*Qb_Vgi_bi))*(Vt*Qb_Vsi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vgi_bi+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vgi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsi_bi_Vdi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vdi_bi))+((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsi_bi)+(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vdi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vdi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vdi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vdi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vsi_bi)*((Vt*Qb_Vdi_bi))+((Vt*Qb_Vdi_bi))*(Vt*Qb_Vsi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vdi_bi+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vdi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
  qbaCV_Vsi_bi_Vsi_bi=(+0.0*((Vt*Qb)+d00_sqrt0)+0.0*(((Vt*Qb_Vsi_bi))+((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*d10_sqrt0)+0.0*((Vt*Qb_Vsi_bi)+(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vsi_bi)+0.0)+(m20_sqrt((((Vt*Qb)*(Vt*Qb))+((0.25*0.1)*0.1)))*((((((Vt*Qb_Vsi_bi))*(Vt*Qb))+((Vt*Qb)*((Vt*Qb_Vsi_bi)))))+((0.0)*0.1))*(((Vt*Qb_Vsi_bi)*(Vt*Qb))+((Vt*Qb)*(Vt*Qb_Vsi_bi)))+d10_sqrt0*(+(+(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vsi_bi)-0.0)*(Vt*Qb)+(Vt*Qb_Vsi_bi)*((Vt*Qb_Vsi_bi))+((Vt*Qb_Vsi_bi))*(Vt*Qb_Vsi_bi)+(Vt*Qb)*(+(+0.0*Qb+0.0*Qb_Vsi_bi+0.0*Qb_Vsi_bi+Vt*Qb_Vsi_bi_Vsi_bi)-0.0))+(+(+0.0*0.1+0.0*0.0+0.0*0.0+0.25*0.0)*0.1+0.0*0.0+(0.0)*0.0+(0.25*0.1)*0.0)))));
#endif
#endif
qbaCV=(0.5*((Vt*Qb)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((Vt*Qb)+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
qiaCV_Tempt_GND=((Vt_Tempt_GND*(Qs+Qd))+(Vt*(Qs_Tempt_GND+Qd_Tempt_GND)));
#endif
qiaCV_Vdbulk_di=(Vt*(Qs_Vdbulk_di+Qd_Vdbulk_di));
#if defined(_DERIVATE2)
  qiaCV_Vdbulk_di_Tempt_GND=(+0.0*(Qs+Qd)+0.0*(Qs_Tempt_GND+Qd_Tempt_GND)+Vt_Tempt_GND*(Qs_Vdbulk_di+Qd_Vdbulk_di)+Vt*(+Qs_Vdbulk_di_Tempt_GND+Qd_Vdbulk_di_Tempt_GND));
  qiaCV_Vdbulk_di_Vdbulk_di=(+0.0*(Qs+Qd)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+Vt*(+Qs_Vdbulk_di_Vdbulk_di+Qd_Vdbulk_di_Vdbulk_di));
  qiaCV_Vdbulk_di_Vsbulk_si=(+0.0*(Qs+Qd)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+Vt*(+Qs_Vdbulk_di_Vsbulk_si+Qd_Vdbulk_di_Vsbulk_si));
  qiaCV_Vdbulk_di_Vgi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+Vt*(+Qs_Vdbulk_di_Vgi_bi+Qd_Vdbulk_di_Vgi_bi));
  qiaCV_Vdbulk_di_Vdi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+Vt*(+Qs_Vdbulk_di_Vdi_bi+Qd_Vdbulk_di_Vdi_bi));
  qiaCV_Vdbulk_di_Vsi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+Vt*(+Qs_Vdbulk_di_Vsi_bi+Qd_Vdbulk_di_Vsi_bi));
#endif
qiaCV_Vsbulk_si=(Vt*(Qs_Vsbulk_si+Qd_Vsbulk_si));
#if defined(_DERIVATE2)
  qiaCV_Vsbulk_si_Tempt_GND=(+0.0*(Qs+Qd)+0.0*(Qs_Tempt_GND+Qd_Tempt_GND)+Vt_Tempt_GND*(Qs_Vsbulk_si+Qd_Vsbulk_si)+Vt*(+Qs_Vsbulk_si_Tempt_GND+Qd_Vsbulk_si_Tempt_GND));
  qiaCV_Vsbulk_si_Vdbulk_di=(+0.0*(Qs+Qd)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+Vt*(+Qs_Vsbulk_si_Vdbulk_di+Qd_Vsbulk_si_Vdbulk_di));
  qiaCV_Vsbulk_si_Vsbulk_si=(+0.0*(Qs+Qd)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+Vt*(+Qs_Vsbulk_si_Vsbulk_si+Qd_Vsbulk_si_Vsbulk_si));
  qiaCV_Vsbulk_si_Vgi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+Vt*(+Qs_Vsbulk_si_Vgi_bi+Qd_Vsbulk_si_Vgi_bi));
  qiaCV_Vsbulk_si_Vdi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+Vt*(+Qs_Vsbulk_si_Vdi_bi+Qd_Vsbulk_si_Vdi_bi));
  qiaCV_Vsbulk_si_Vsi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+Vt*(+Qs_Vsbulk_si_Vsi_bi+Qd_Vsbulk_si_Vsi_bi));
#endif
qiaCV_Vgi_bi=(Vt*(Qs_Vgi_bi+Qd_Vgi_bi));
#if defined(_DERIVATE2)
  qiaCV_Vgi_bi_Tempt_GND=(+0.0*(Qs+Qd)+0.0*(Qs_Tempt_GND+Qd_Tempt_GND)+Vt_Tempt_GND*(Qs_Vgi_bi+Qd_Vgi_bi)+Vt*(+Qs_Vgi_bi_Tempt_GND+Qd_Vgi_bi_Tempt_GND));
  qiaCV_Vgi_bi_Vdbulk_di=(+0.0*(Qs+Qd)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+Vt*(+Qs_Vgi_bi_Vdbulk_di+Qd_Vgi_bi_Vdbulk_di));
  qiaCV_Vgi_bi_Vsbulk_si=(+0.0*(Qs+Qd)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+Vt*(+Qs_Vgi_bi_Vsbulk_si+Qd_Vgi_bi_Vsbulk_si));
  qiaCV_Vgi_bi_Vgi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+Vt*(+Qs_Vgi_bi_Vgi_bi+Qd_Vgi_bi_Vgi_bi));
  qiaCV_Vgi_bi_Vdi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+Vt*(+Qs_Vgi_bi_Vdi_bi+Qd_Vgi_bi_Vdi_bi));
  qiaCV_Vgi_bi_Vsi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+Vt*(+Qs_Vgi_bi_Vsi_bi+Qd_Vgi_bi_Vsi_bi));
#endif
qiaCV_Vdi_bi=(Vt*(Qs_Vdi_bi+Qd_Vdi_bi));
#if defined(_DERIVATE2)
  qiaCV_Vdi_bi_Tempt_GND=(+0.0*(Qs+Qd)+0.0*(Qs_Tempt_GND+Qd_Tempt_GND)+Vt_Tempt_GND*(Qs_Vdi_bi+Qd_Vdi_bi)+Vt*(+Qs_Vdi_bi_Tempt_GND+Qd_Vdi_bi_Tempt_GND));
  qiaCV_Vdi_bi_Vdbulk_di=(+0.0*(Qs+Qd)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+Vt*(+Qs_Vdi_bi_Vdbulk_di+Qd_Vdi_bi_Vdbulk_di));
  qiaCV_Vdi_bi_Vsbulk_si=(+0.0*(Qs+Qd)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+Vt*(+Qs_Vdi_bi_Vsbulk_si+Qd_Vdi_bi_Vsbulk_si));
  qiaCV_Vdi_bi_Vgi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+Vt*(+Qs_Vdi_bi_Vgi_bi+Qd_Vdi_bi_Vgi_bi));
  qiaCV_Vdi_bi_Vdi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+Vt*(+Qs_Vdi_bi_Vdi_bi+Qd_Vdi_bi_Vdi_bi));
  qiaCV_Vdi_bi_Vsi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+Vt*(+Qs_Vdi_bi_Vsi_bi+Qd_Vdi_bi_Vsi_bi));
#endif
qiaCV_Vsi_bi=(Vt*(Qs_Vsi_bi+Qd_Vsi_bi));
#if defined(_DERIVATE2)
  qiaCV_Vsi_bi_Tempt_GND=(+0.0*(Qs+Qd)+0.0*(Qs_Tempt_GND+Qd_Tempt_GND)+Vt_Tempt_GND*(Qs_Vsi_bi+Qd_Vsi_bi)+Vt*(+Qs_Vsi_bi_Tempt_GND+Qd_Vsi_bi_Tempt_GND));
  qiaCV_Vsi_bi_Vdbulk_di=(+0.0*(Qs+Qd)+0.0*(Qs_Vdbulk_di+Qd_Vdbulk_di)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+Vt*(+Qs_Vsi_bi_Vdbulk_di+Qd_Vsi_bi_Vdbulk_di));
  qiaCV_Vsi_bi_Vsbulk_si=(+0.0*(Qs+Qd)+0.0*(Qs_Vsbulk_si+Qd_Vsbulk_si)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+Vt*(+Qs_Vsi_bi_Vsbulk_si+Qd_Vsi_bi_Vsbulk_si));
  qiaCV_Vsi_bi_Vgi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vgi_bi+Qd_Vgi_bi)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+Vt*(+Qs_Vsi_bi_Vgi_bi+Qd_Vsi_bi_Vgi_bi));
  qiaCV_Vsi_bi_Vdi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vdi_bi+Qd_Vdi_bi)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+Vt*(+Qs_Vsi_bi_Vdi_bi+Qd_Vsi_bi_Vdi_bi));
  qiaCV_Vsi_bi_Vsi_bi=(+0.0*(Qs+Qd)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+0.0*(Qs_Vsi_bi+Qd_Vsi_bi)+Vt*(+Qs_Vsi_bi_Vsi_bi+Qd_Vsi_bi_Vsi_bi));
#endif
#endif
qiaCV=(Vt*(Qs+Qd));
EXIT_IF_ISNAN((Vt*(Qs+Qd)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=((qiaCV_Vdbulk_di+(pModel->ETAQM*qbaCV_Vdbulk_di))/pModel->QM0);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vdbulk_di+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vdbulk_di+(pModel->ETAQM*qbaCV_Vdbulk_di))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdbulk_di_Vgm_si=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vdbulk_di+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vdbulk_di+(pModel->ETAQM*qbaCV_Vdbulk_di))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdbulk_di_Vdbulk_di=((+qiaCV_Vdbulk_di_Vdbulk_di+(+0.0*qbaCV+0.0*qbaCV_Vdbulk_di+0.0*qbaCV_Vdbulk_di+pModel->ETAQM*qbaCV_Vdbulk_di_Vdbulk_di))/pModel->QM0-((qiaCV_Vdbulk_di+(pModel->ETAQM*qbaCV_Vdbulk_di))*0.0+(qiaCV_Vdbulk_di+((pModel->ETAQM*qbaCV_Vdbulk_di)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdbulk_di_Vsbulk_si=((+qiaCV_Vdbulk_di_Vsbulk_si+(+0.0*qbaCV+0.0*qbaCV_Vsbulk_si+0.0*qbaCV_Vdbulk_di+pModel->ETAQM*qbaCV_Vdbulk_di_Vsbulk_si))/pModel->QM0-((qiaCV_Vdbulk_di+(pModel->ETAQM*qbaCV_Vdbulk_di))*0.0+(qiaCV_Vsbulk_si+((pModel->ETAQM*qbaCV_Vsbulk_si)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdbulk_di_Vgi_bi=((+qiaCV_Vdbulk_di_Vgi_bi+(+0.0*qbaCV+0.0*qbaCV_Vgi_bi+0.0*qbaCV_Vdbulk_di+pModel->ETAQM*qbaCV_Vdbulk_di_Vgi_bi))/pModel->QM0-((qiaCV_Vdbulk_di+(pModel->ETAQM*qbaCV_Vdbulk_di))*0.0+(qiaCV_Vgi_bi+((pModel->ETAQM*qbaCV_Vgi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdbulk_di_Vdi_bi=((+qiaCV_Vdbulk_di_Vdi_bi+(+0.0*qbaCV+0.0*qbaCV_Vdi_bi+0.0*qbaCV_Vdbulk_di+pModel->ETAQM*qbaCV_Vdbulk_di_Vdi_bi))/pModel->QM0-((qiaCV_Vdbulk_di+(pModel->ETAQM*qbaCV_Vdbulk_di))*0.0+(qiaCV_Vdi_bi+((pModel->ETAQM*qbaCV_Vdi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdbulk_di_Vsi_bi=((+qiaCV_Vdbulk_di_Vsi_bi+(+0.0*qbaCV+0.0*qbaCV_Vsi_bi+0.0*qbaCV_Vdbulk_di+pModel->ETAQM*qbaCV_Vdbulk_di_Vsi_bi))/pModel->QM0-((qiaCV_Vdbulk_di+(pModel->ETAQM*qbaCV_Vdbulk_di))*0.0+(qiaCV_Vsi_bi+((pModel->ETAQM*qbaCV_Vsi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdbulk_di_Tempt_GND=((+qiaCV_Vdbulk_di_Tempt_GND+(+0.0*qbaCV+0.0*qbaCV_Tempt_GND+0.0*qbaCV_Vdbulk_di+pModel->ETAQM*qbaCV_Vdbulk_di_Tempt_GND))/pModel->QM0-((qiaCV_Vdbulk_di+(pModel->ETAQM*qbaCV_Vdbulk_di))*0.0+(qiaCV_Tempt_GND+((pModel->ETAQM*qbaCV_Tempt_GND)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
T0_Vsbulk_si=((qiaCV_Vsbulk_si+(pModel->ETAQM*qbaCV_Vsbulk_si))/pModel->QM0);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vsbulk_si+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vsbulk_si+(pModel->ETAQM*qbaCV_Vsbulk_si))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsbulk_si_Vgm_si=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vsbulk_si+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vsbulk_si+(pModel->ETAQM*qbaCV_Vsbulk_si))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsbulk_si_Vdbulk_di=((+qiaCV_Vsbulk_si_Vdbulk_di+(+0.0*qbaCV+0.0*qbaCV_Vdbulk_di+0.0*qbaCV_Vsbulk_si+pModel->ETAQM*qbaCV_Vsbulk_si_Vdbulk_di))/pModel->QM0-((qiaCV_Vsbulk_si+(pModel->ETAQM*qbaCV_Vsbulk_si))*0.0+(qiaCV_Vdbulk_di+((pModel->ETAQM*qbaCV_Vdbulk_di)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsbulk_si_Vsbulk_si=((+qiaCV_Vsbulk_si_Vsbulk_si+(+0.0*qbaCV+0.0*qbaCV_Vsbulk_si+0.0*qbaCV_Vsbulk_si+pModel->ETAQM*qbaCV_Vsbulk_si_Vsbulk_si))/pModel->QM0-((qiaCV_Vsbulk_si+(pModel->ETAQM*qbaCV_Vsbulk_si))*0.0+(qiaCV_Vsbulk_si+((pModel->ETAQM*qbaCV_Vsbulk_si)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsbulk_si_Vgi_bi=((+qiaCV_Vsbulk_si_Vgi_bi+(+0.0*qbaCV+0.0*qbaCV_Vgi_bi+0.0*qbaCV_Vsbulk_si+pModel->ETAQM*qbaCV_Vsbulk_si_Vgi_bi))/pModel->QM0-((qiaCV_Vsbulk_si+(pModel->ETAQM*qbaCV_Vsbulk_si))*0.0+(qiaCV_Vgi_bi+((pModel->ETAQM*qbaCV_Vgi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsbulk_si_Vdi_bi=((+qiaCV_Vsbulk_si_Vdi_bi+(+0.0*qbaCV+0.0*qbaCV_Vdi_bi+0.0*qbaCV_Vsbulk_si+pModel->ETAQM*qbaCV_Vsbulk_si_Vdi_bi))/pModel->QM0-((qiaCV_Vsbulk_si+(pModel->ETAQM*qbaCV_Vsbulk_si))*0.0+(qiaCV_Vdi_bi+((pModel->ETAQM*qbaCV_Vdi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsbulk_si_Vsi_bi=((+qiaCV_Vsbulk_si_Vsi_bi+(+0.0*qbaCV+0.0*qbaCV_Vsi_bi+0.0*qbaCV_Vsbulk_si+pModel->ETAQM*qbaCV_Vsbulk_si_Vsi_bi))/pModel->QM0-((qiaCV_Vsbulk_si+(pModel->ETAQM*qbaCV_Vsbulk_si))*0.0+(qiaCV_Vsi_bi+((pModel->ETAQM*qbaCV_Vsi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsbulk_si_Tempt_GND=((+qiaCV_Vsbulk_si_Tempt_GND+(+0.0*qbaCV+0.0*qbaCV_Tempt_GND+0.0*qbaCV_Vsbulk_si+pModel->ETAQM*qbaCV_Vsbulk_si_Tempt_GND))/pModel->QM0-((qiaCV_Vsbulk_si+(pModel->ETAQM*qbaCV_Vsbulk_si))*0.0+(qiaCV_Tempt_GND+((pModel->ETAQM*qbaCV_Tempt_GND)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
T0_Vgi_bi=((qiaCV_Vgi_bi+(pModel->ETAQM*qbaCV_Vgi_bi))/pModel->QM0);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vgi_bi+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vgi_bi+(pModel->ETAQM*qbaCV_Vgi_bi))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vgi_bi_Vgm_si=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vgi_bi+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vgi_bi+(pModel->ETAQM*qbaCV_Vgi_bi))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vgi_bi_Vdbulk_di=((+qiaCV_Vgi_bi_Vdbulk_di+(+0.0*qbaCV+0.0*qbaCV_Vdbulk_di+0.0*qbaCV_Vgi_bi+pModel->ETAQM*qbaCV_Vgi_bi_Vdbulk_di))/pModel->QM0-((qiaCV_Vgi_bi+(pModel->ETAQM*qbaCV_Vgi_bi))*0.0+(qiaCV_Vdbulk_di+((pModel->ETAQM*qbaCV_Vdbulk_di)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vgi_bi_Vsbulk_si=((+qiaCV_Vgi_bi_Vsbulk_si+(+0.0*qbaCV+0.0*qbaCV_Vsbulk_si+0.0*qbaCV_Vgi_bi+pModel->ETAQM*qbaCV_Vgi_bi_Vsbulk_si))/pModel->QM0-((qiaCV_Vgi_bi+(pModel->ETAQM*qbaCV_Vgi_bi))*0.0+(qiaCV_Vsbulk_si+((pModel->ETAQM*qbaCV_Vsbulk_si)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vgi_bi_Vgi_bi=((+qiaCV_Vgi_bi_Vgi_bi+(+0.0*qbaCV+0.0*qbaCV_Vgi_bi+0.0*qbaCV_Vgi_bi+pModel->ETAQM*qbaCV_Vgi_bi_Vgi_bi))/pModel->QM0-((qiaCV_Vgi_bi+(pModel->ETAQM*qbaCV_Vgi_bi))*0.0+(qiaCV_Vgi_bi+((pModel->ETAQM*qbaCV_Vgi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vgi_bi_Vdi_bi=((+qiaCV_Vgi_bi_Vdi_bi+(+0.0*qbaCV+0.0*qbaCV_Vdi_bi+0.0*qbaCV_Vgi_bi+pModel->ETAQM*qbaCV_Vgi_bi_Vdi_bi))/pModel->QM0-((qiaCV_Vgi_bi+(pModel->ETAQM*qbaCV_Vgi_bi))*0.0+(qiaCV_Vdi_bi+((pModel->ETAQM*qbaCV_Vdi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vgi_bi_Vsi_bi=((+qiaCV_Vgi_bi_Vsi_bi+(+0.0*qbaCV+0.0*qbaCV_Vsi_bi+0.0*qbaCV_Vgi_bi+pModel->ETAQM*qbaCV_Vgi_bi_Vsi_bi))/pModel->QM0-((qiaCV_Vgi_bi+(pModel->ETAQM*qbaCV_Vgi_bi))*0.0+(qiaCV_Vsi_bi+((pModel->ETAQM*qbaCV_Vsi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vgi_bi_Tempt_GND=((+qiaCV_Vgi_bi_Tempt_GND+(+0.0*qbaCV+0.0*qbaCV_Tempt_GND+0.0*qbaCV_Vgi_bi+pModel->ETAQM*qbaCV_Vgi_bi_Tempt_GND))/pModel->QM0-((qiaCV_Vgi_bi+(pModel->ETAQM*qbaCV_Vgi_bi))*0.0+(qiaCV_Tempt_GND+((pModel->ETAQM*qbaCV_Tempt_GND)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
T0_Vdi_bi=((qiaCV_Vdi_bi+(pModel->ETAQM*qbaCV_Vdi_bi))/pModel->QM0);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vdi_bi+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vdi_bi+(pModel->ETAQM*qbaCV_Vdi_bi))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdi_bi_Vgm_si=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vdi_bi+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vdi_bi+(pModel->ETAQM*qbaCV_Vdi_bi))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdi_bi_Vdbulk_di=((+qiaCV_Vdi_bi_Vdbulk_di+(+0.0*qbaCV+0.0*qbaCV_Vdbulk_di+0.0*qbaCV_Vdi_bi+pModel->ETAQM*qbaCV_Vdi_bi_Vdbulk_di))/pModel->QM0-((qiaCV_Vdi_bi+(pModel->ETAQM*qbaCV_Vdi_bi))*0.0+(qiaCV_Vdbulk_di+((pModel->ETAQM*qbaCV_Vdbulk_di)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdi_bi_Vsbulk_si=((+qiaCV_Vdi_bi_Vsbulk_si+(+0.0*qbaCV+0.0*qbaCV_Vsbulk_si+0.0*qbaCV_Vdi_bi+pModel->ETAQM*qbaCV_Vdi_bi_Vsbulk_si))/pModel->QM0-((qiaCV_Vdi_bi+(pModel->ETAQM*qbaCV_Vdi_bi))*0.0+(qiaCV_Vsbulk_si+((pModel->ETAQM*qbaCV_Vsbulk_si)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdi_bi_Vgi_bi=((+qiaCV_Vdi_bi_Vgi_bi+(+0.0*qbaCV+0.0*qbaCV_Vgi_bi+0.0*qbaCV_Vdi_bi+pModel->ETAQM*qbaCV_Vdi_bi_Vgi_bi))/pModel->QM0-((qiaCV_Vdi_bi+(pModel->ETAQM*qbaCV_Vdi_bi))*0.0+(qiaCV_Vgi_bi+((pModel->ETAQM*qbaCV_Vgi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdi_bi_Vdi_bi=((+qiaCV_Vdi_bi_Vdi_bi+(+0.0*qbaCV+0.0*qbaCV_Vdi_bi+0.0*qbaCV_Vdi_bi+pModel->ETAQM*qbaCV_Vdi_bi_Vdi_bi))/pModel->QM0-((qiaCV_Vdi_bi+(pModel->ETAQM*qbaCV_Vdi_bi))*0.0+(qiaCV_Vdi_bi+((pModel->ETAQM*qbaCV_Vdi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdi_bi_Vsi_bi=((+qiaCV_Vdi_bi_Vsi_bi+(+0.0*qbaCV+0.0*qbaCV_Vsi_bi+0.0*qbaCV_Vdi_bi+pModel->ETAQM*qbaCV_Vdi_bi_Vsi_bi))/pModel->QM0-((qiaCV_Vdi_bi+(pModel->ETAQM*qbaCV_Vdi_bi))*0.0+(qiaCV_Vsi_bi+((pModel->ETAQM*qbaCV_Vsi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vdi_bi_Tempt_GND=((+qiaCV_Vdi_bi_Tempt_GND+(+0.0*qbaCV+0.0*qbaCV_Tempt_GND+0.0*qbaCV_Vdi_bi+pModel->ETAQM*qbaCV_Vdi_bi_Tempt_GND))/pModel->QM0-((qiaCV_Vdi_bi+(pModel->ETAQM*qbaCV_Vdi_bi))*0.0+(qiaCV_Tempt_GND+((pModel->ETAQM*qbaCV_Tempt_GND)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
T0_Vsi_bi=((qiaCV_Vsi_bi+(pModel->ETAQM*qbaCV_Vsi_bi))/pModel->QM0);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vsi_bi+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vsi_bi+(pModel->ETAQM*qbaCV_Vsi_bi))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsi_bi_Vgm_si=((+0.0+(+0.0*qbaCV+0.0*0.0+0.0*qbaCV_Vsi_bi+pModel->ETAQM*0.0))/pModel->QM0-((qiaCV_Vsi_bi+(pModel->ETAQM*qbaCV_Vsi_bi))*0.0+(0.0)*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsi_bi_Vdbulk_di=((+qiaCV_Vsi_bi_Vdbulk_di+(+0.0*qbaCV+0.0*qbaCV_Vdbulk_di+0.0*qbaCV_Vsi_bi+pModel->ETAQM*qbaCV_Vsi_bi_Vdbulk_di))/pModel->QM0-((qiaCV_Vsi_bi+(pModel->ETAQM*qbaCV_Vsi_bi))*0.0+(qiaCV_Vdbulk_di+((pModel->ETAQM*qbaCV_Vdbulk_di)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsi_bi_Vsbulk_si=((+qiaCV_Vsi_bi_Vsbulk_si+(+0.0*qbaCV+0.0*qbaCV_Vsbulk_si+0.0*qbaCV_Vsi_bi+pModel->ETAQM*qbaCV_Vsi_bi_Vsbulk_si))/pModel->QM0-((qiaCV_Vsi_bi+(pModel->ETAQM*qbaCV_Vsi_bi))*0.0+(qiaCV_Vsbulk_si+((pModel->ETAQM*qbaCV_Vsbulk_si)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsi_bi_Vgi_bi=((+qiaCV_Vsi_bi_Vgi_bi+(+0.0*qbaCV+0.0*qbaCV_Vgi_bi+0.0*qbaCV_Vsi_bi+pModel->ETAQM*qbaCV_Vsi_bi_Vgi_bi))/pModel->QM0-((qiaCV_Vsi_bi+(pModel->ETAQM*qbaCV_Vsi_bi))*0.0+(qiaCV_Vgi_bi+((pModel->ETAQM*qbaCV_Vgi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsi_bi_Vdi_bi=((+qiaCV_Vsi_bi_Vdi_bi+(+0.0*qbaCV+0.0*qbaCV_Vdi_bi+0.0*qbaCV_Vsi_bi+pModel->ETAQM*qbaCV_Vsi_bi_Vdi_bi))/pModel->QM0-((qiaCV_Vsi_bi+(pModel->ETAQM*qbaCV_Vsi_bi))*0.0+(qiaCV_Vdi_bi+((pModel->ETAQM*qbaCV_Vdi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsi_bi_Vsi_bi=((+qiaCV_Vsi_bi_Vsi_bi+(+0.0*qbaCV+0.0*qbaCV_Vsi_bi+0.0*qbaCV_Vsi_bi+pModel->ETAQM*qbaCV_Vsi_bi_Vsi_bi))/pModel->QM0-((qiaCV_Vsi_bi+(pModel->ETAQM*qbaCV_Vsi_bi))*0.0+(qiaCV_Vsi_bi+((pModel->ETAQM*qbaCV_Vsi_bi)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T0_Vsi_bi_Tempt_GND=((+qiaCV_Vsi_bi_Tempt_GND+(+0.0*qbaCV+0.0*qbaCV_Tempt_GND+0.0*qbaCV_Vsi_bi+pModel->ETAQM*qbaCV_Vsi_bi_Tempt_GND))/pModel->QM0-((qiaCV_Vsi_bi+(pModel->ETAQM*qbaCV_Vsi_bi))*0.0+(qiaCV_Tempt_GND+((pModel->ETAQM*qbaCV_Tempt_GND)))*0.0+(qiaCV+(pModel->ETAQM*qbaCV))*0.0)/pModel->QM0/pModel->QM0+2*(qiaCV+(pModel->ETAQM*qbaCV))*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((qiaCV_Tempt_GND+(pModel->ETAQM*qbaCV_Tempt_GND))/pModel->QM0);
#endif
#endif
T0=((qiaCV+(pModel->ETAQM*qbaCV))/pModel->QM0);
EXIT_IF_ISNAN(((qiaCV+(pModel->ETAQM*qbaCV))/pModel->QM0))
{
double m00_pow(d00_pow0,T0,(0.7*pModel->BDOS))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,T0,(0.7*pModel->BDOS))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=(d10_pow0*T0_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+0.0+fixme);
  T1_Vdbulk_di_Vgm_si=(+0.0+fixme);
  T1_Vdbulk_di_Vdbulk_di=(+0.0+fixme);
  T1_Vdbulk_di_Vsbulk_si=(+0.0+fixme);
  T1_Vdbulk_di_Vgi_bi=(+0.0+fixme);
  T1_Vdbulk_di_Vdi_bi=(+0.0+fixme);
  T1_Vdbulk_di_Vsi_bi=(+0.0+fixme);
  T1_Vdbulk_di_Tempt_GND=(+0.0+fixme);
#endif
T1_Vsbulk_si=(d10_pow0*T0_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+0.0+fixme);
  T1_Vsbulk_si_Vgm_si=(+0.0+fixme);
  T1_Vsbulk_si_Vdbulk_di=(+0.0+fixme);
  T1_Vsbulk_si_Vsbulk_si=(+0.0+fixme);
  T1_Vsbulk_si_Vgi_bi=(+0.0+fixme);
  T1_Vsbulk_si_Vdi_bi=(+0.0+fixme);
  T1_Vsbulk_si_Vsi_bi=(+0.0+fixme);
  T1_Vsbulk_si_Tempt_GND=(+0.0+fixme);
#endif
T1_Vgi_bi=(d10_pow0*T0_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0+fixme);
  T1_Vgi_bi_Vgm_si=(+0.0+fixme);
  T1_Vgi_bi_Vdbulk_di=(+0.0+fixme);
  T1_Vgi_bi_Vsbulk_si=(+0.0+fixme);
  T1_Vgi_bi_Vgi_bi=(+0.0+fixme);
  T1_Vgi_bi_Vdi_bi=(+0.0+fixme);
  T1_Vgi_bi_Vsi_bi=(+0.0+fixme);
  T1_Vgi_bi_Tempt_GND=(+0.0+fixme);
#endif
T1_Vdi_bi=(d10_pow0*T0_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0+fixme);
  T1_Vdi_bi_Vgm_si=(+0.0+fixme);
  T1_Vdi_bi_Vdbulk_di=(+0.0+fixme);
  T1_Vdi_bi_Vsbulk_si=(+0.0+fixme);
  T1_Vdi_bi_Vgi_bi=(+0.0+fixme);
  T1_Vdi_bi_Vdi_bi=(+0.0+fixme);
  T1_Vdi_bi_Vsi_bi=(+0.0+fixme);
  T1_Vdi_bi_Tempt_GND=(+0.0+fixme);
#endif
T1_Vsi_bi=(d10_pow0*T0_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0+fixme);
  T1_Vsi_bi_Vgm_si=(+0.0+fixme);
  T1_Vsi_bi_Vdbulk_di=(+0.0+fixme);
  T1_Vsi_bi_Vsbulk_si=(+0.0+fixme);
  T1_Vsi_bi_Vgi_bi=(+0.0+fixme);
  T1_Vsi_bi_Vdi_bi=(+0.0+fixme);
  T1_Vsi_bi_Vsi_bi=(+0.0+fixme);
  T1_Vsi_bi_Tempt_GND=(+0.0+fixme);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(d10_pow0*T0_Tempt_GND);
#endif
#endif
T1=(1.0+d00_pow0);
EXIT_IF_ISNAN((1.0+d00_pow0))
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
XDCinv_Vdbulk_di=(-(pModel->ADOS*1.9e-9)*T1_Vdbulk_di/T1/T1);
#if defined(_DERIVATE2)
  XDCinv_Vdbulk_di_Vdbulk_di=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(pModel->ADOS*1.9e-9)*T1_Vdbulk_di_Vdbulk_di)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdbulk_di*T1_Vdbulk_di/T1/T1/T1);
  XDCinv_Vdbulk_di_Vsbulk_si=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(pModel->ADOS*1.9e-9)*T1_Vdbulk_di_Vsbulk_si)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdbulk_di*T1_Vsbulk_si/T1/T1/T1);
  XDCinv_Vdbulk_di_Vgi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(pModel->ADOS*1.9e-9)*T1_Vdbulk_di_Vgi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdbulk_di*T1_Vgi_bi/T1/T1/T1);
  XDCinv_Vdbulk_di_Vdi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(pModel->ADOS*1.9e-9)*T1_Vdbulk_di_Vdi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdbulk_di*T1_Vdi_bi/T1/T1/T1);
  XDCinv_Vdbulk_di_Vsi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(pModel->ADOS*1.9e-9)*T1_Vdbulk_di_Vsi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdbulk_di*T1_Vsi_bi/T1/T1/T1);
  XDCinv_Vdbulk_di_Tempt_GND=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(pModel->ADOS*1.9e-9)*T1_Vdbulk_di_Tempt_GND)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdbulk_di*T1_Tempt_GND/T1/T1/T1);
#endif
XDCinv_Vsbulk_si=(-(pModel->ADOS*1.9e-9)*T1_Vsbulk_si/T1/T1);
#if defined(_DERIVATE2)
  XDCinv_Vsbulk_si_Vdbulk_di=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(pModel->ADOS*1.9e-9)*T1_Vsbulk_si_Vdbulk_di)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsbulk_si*T1_Vdbulk_di/T1/T1/T1);
  XDCinv_Vsbulk_si_Vsbulk_si=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(pModel->ADOS*1.9e-9)*T1_Vsbulk_si_Vsbulk_si)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsbulk_si*T1_Vsbulk_si/T1/T1/T1);
  XDCinv_Vsbulk_si_Vgi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(pModel->ADOS*1.9e-9)*T1_Vsbulk_si_Vgi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsbulk_si*T1_Vgi_bi/T1/T1/T1);
  XDCinv_Vsbulk_si_Vdi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(pModel->ADOS*1.9e-9)*T1_Vsbulk_si_Vdi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsbulk_si*T1_Vdi_bi/T1/T1/T1);
  XDCinv_Vsbulk_si_Vsi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(pModel->ADOS*1.9e-9)*T1_Vsbulk_si_Vsi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsbulk_si*T1_Vsi_bi/T1/T1/T1);
  XDCinv_Vsbulk_si_Tempt_GND=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(pModel->ADOS*1.9e-9)*T1_Vsbulk_si_Tempt_GND)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsbulk_si*T1_Tempt_GND/T1/T1/T1);
#endif
XDCinv_Vgi_bi=(-(pModel->ADOS*1.9e-9)*T1_Vgi_bi/T1/T1);
#if defined(_DERIVATE2)
  XDCinv_Vgi_bi_Vdbulk_di=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(pModel->ADOS*1.9e-9)*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1);
  XDCinv_Vgi_bi_Vsbulk_si=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(pModel->ADOS*1.9e-9)*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1);
  XDCinv_Vgi_bi_Vgi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(pModel->ADOS*1.9e-9)*T1_Vgi_bi_Vgi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1);
  XDCinv_Vgi_bi_Vdi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(pModel->ADOS*1.9e-9)*T1_Vgi_bi_Vdi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1);
  XDCinv_Vgi_bi_Vsi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(pModel->ADOS*1.9e-9)*T1_Vgi_bi_Vsi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1);
  XDCinv_Vgi_bi_Tempt_GND=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(pModel->ADOS*1.9e-9)*T1_Vgi_bi_Tempt_GND)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
XDCinv_Vdi_bi=(-(pModel->ADOS*1.9e-9)*T1_Vdi_bi/T1/T1);
#if defined(_DERIVATE2)
  XDCinv_Vdi_bi_Vdbulk_di=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(pModel->ADOS*1.9e-9)*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1);
  XDCinv_Vdi_bi_Vsbulk_si=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(pModel->ADOS*1.9e-9)*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1);
  XDCinv_Vdi_bi_Vgi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(pModel->ADOS*1.9e-9)*T1_Vdi_bi_Vgi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1);
  XDCinv_Vdi_bi_Vdi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(pModel->ADOS*1.9e-9)*T1_Vdi_bi_Vdi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1);
  XDCinv_Vdi_bi_Vsi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(pModel->ADOS*1.9e-9)*T1_Vdi_bi_Vsi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1);
  XDCinv_Vdi_bi_Tempt_GND=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(pModel->ADOS*1.9e-9)*T1_Vdi_bi_Tempt_GND)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
XDCinv_Vsi_bi=(-(pModel->ADOS*1.9e-9)*T1_Vsi_bi/T1/T1);
#if defined(_DERIVATE2)
  XDCinv_Vsi_bi_Vdbulk_di=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(pModel->ADOS*1.9e-9)*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1);
  XDCinv_Vsi_bi_Vsbulk_si=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(pModel->ADOS*1.9e-9)*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1);
  XDCinv_Vsi_bi_Vgi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(pModel->ADOS*1.9e-9)*T1_Vsi_bi_Vgi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1);
  XDCinv_Vsi_bi_Vdi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(pModel->ADOS*1.9e-9)*T1_Vsi_bi_Vdi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1);
  XDCinv_Vsi_bi_Vsi_bi=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(pModel->ADOS*1.9e-9)*T1_Vsi_bi_Vsi_bi)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1);
  XDCinv_Vsi_bi_Tempt_GND=((+0.0*1.9e-9+0.0*0.0+0.0*0.0+pModel->ADOS*0.0)/T1-(0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(pModel->ADOS*1.9e-9)*T1_Vsi_bi_Tempt_GND)/T1/T1+2*(pModel->ADOS*1.9e-9)*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
#if defined(_DERIVATE)
XDCinv_Tempt_GND=(-(pModel->ADOS*1.9e-9)*T1_Tempt_GND/T1/T1);
#endif
#endif
XDCinv=((pModel->ADOS*1.9e-9)/T1);
EXIT_IF_ISNAN(((pModel->ADOS*1.9e-9)/T1))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
Coxeffinv_Vdbulk_di=(-(3.9*8.85418e-12)*(XDCinv_Vdbulk_di/epsratio)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#if defined(_DERIVATE2)
  Coxeffinv_Vdbulk_di_Vdbulk_di=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))+(0.0)*(XDCinv_Vdbulk_di/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdbulk_di_Vdbulk_di/epsratio-(XDCinv_Vdbulk_di*0.0+XDCinv_Vdbulk_di*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdbulk_di/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdbulk_di_Vsbulk_si=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))+(0.0)*(XDCinv_Vdbulk_di/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdbulk_di_Vsbulk_si/epsratio-(XDCinv_Vdbulk_di*0.0+XDCinv_Vsbulk_si*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdbulk_di/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdbulk_di_Vgi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))+(0.0)*(XDCinv_Vdbulk_di/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdbulk_di_Vgi_bi/epsratio-(XDCinv_Vdbulk_di*0.0+XDCinv_Vgi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdbulk_di/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdbulk_di_Vdi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))+(0.0)*(XDCinv_Vdbulk_di/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdbulk_di_Vdi_bi/epsratio-(XDCinv_Vdbulk_di*0.0+XDCinv_Vdi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdbulk_di/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdbulk_di_Vsi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))+(0.0)*(XDCinv_Vdbulk_di/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdbulk_di_Vsi_bi/epsratio-(XDCinv_Vdbulk_di*0.0+XDCinv_Vsi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdbulk_di/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdbulk_di_Tempt_GND=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))+(0.0)*(XDCinv_Vdbulk_di/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdbulk_di_Tempt_GND/epsratio-(XDCinv_Vdbulk_di*0.0+XDCinv_Tempt_GND*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdbulk_di/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#endif
Coxeffinv_Vsbulk_si=(-(3.9*8.85418e-12)*(XDCinv_Vsbulk_si/epsratio)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#if defined(_DERIVATE2)
  Coxeffinv_Vsbulk_si_Vdbulk_di=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))+(0.0)*(XDCinv_Vsbulk_si/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsbulk_si_Vdbulk_di/epsratio-(XDCinv_Vsbulk_si*0.0+XDCinv_Vdbulk_di*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsbulk_si/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsbulk_si_Vsbulk_si=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))+(0.0)*(XDCinv_Vsbulk_si/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsbulk_si_Vsbulk_si/epsratio-(XDCinv_Vsbulk_si*0.0+XDCinv_Vsbulk_si*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsbulk_si/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsbulk_si_Vgi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))+(0.0)*(XDCinv_Vsbulk_si/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsbulk_si_Vgi_bi/epsratio-(XDCinv_Vsbulk_si*0.0+XDCinv_Vgi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsbulk_si/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsbulk_si_Vdi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))+(0.0)*(XDCinv_Vsbulk_si/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsbulk_si_Vdi_bi/epsratio-(XDCinv_Vsbulk_si*0.0+XDCinv_Vdi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsbulk_si/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsbulk_si_Vsi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))+(0.0)*(XDCinv_Vsbulk_si/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsbulk_si_Vsi_bi/epsratio-(XDCinv_Vsbulk_si*0.0+XDCinv_Vsi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsbulk_si/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsbulk_si_Tempt_GND=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))+(0.0)*(XDCinv_Vsbulk_si/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsbulk_si_Tempt_GND/epsratio-(XDCinv_Vsbulk_si*0.0+XDCinv_Tempt_GND*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsbulk_si/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#endif
Coxeffinv_Vgi_bi=(-(3.9*8.85418e-12)*(XDCinv_Vgi_bi/epsratio)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#if defined(_DERIVATE2)
  Coxeffinv_Vgi_bi_Vdbulk_di=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))+(0.0)*(XDCinv_Vgi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vgi_bi_Vdbulk_di/epsratio-(XDCinv_Vgi_bi*0.0+XDCinv_Vdbulk_di*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vgi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vgi_bi_Vsbulk_si=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))+(0.0)*(XDCinv_Vgi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vgi_bi_Vsbulk_si/epsratio-(XDCinv_Vgi_bi*0.0+XDCinv_Vsbulk_si*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vgi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vgi_bi_Vgi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))+(0.0)*(XDCinv_Vgi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vgi_bi_Vgi_bi/epsratio-(XDCinv_Vgi_bi*0.0+XDCinv_Vgi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vgi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vgi_bi_Vdi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))+(0.0)*(XDCinv_Vgi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vgi_bi_Vdi_bi/epsratio-(XDCinv_Vgi_bi*0.0+XDCinv_Vdi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vgi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vgi_bi_Vsi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))+(0.0)*(XDCinv_Vgi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vgi_bi_Vsi_bi/epsratio-(XDCinv_Vgi_bi*0.0+XDCinv_Vsi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vgi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vgi_bi_Tempt_GND=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))+(0.0)*(XDCinv_Vgi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vgi_bi_Tempt_GND/epsratio-(XDCinv_Vgi_bi*0.0+XDCinv_Tempt_GND*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vgi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#endif
Coxeffinv_Vdi_bi=(-(3.9*8.85418e-12)*(XDCinv_Vdi_bi/epsratio)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#if defined(_DERIVATE2)
  Coxeffinv_Vdi_bi_Vdbulk_di=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))+(0.0)*(XDCinv_Vdi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdi_bi_Vdbulk_di/epsratio-(XDCinv_Vdi_bi*0.0+XDCinv_Vdbulk_di*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdi_bi_Vsbulk_si=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))+(0.0)*(XDCinv_Vdi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdi_bi_Vsbulk_si/epsratio-(XDCinv_Vdi_bi*0.0+XDCinv_Vsbulk_si*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdi_bi_Vgi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))+(0.0)*(XDCinv_Vdi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdi_bi_Vgi_bi/epsratio-(XDCinv_Vdi_bi*0.0+XDCinv_Vgi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdi_bi_Vdi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))+(0.0)*(XDCinv_Vdi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdi_bi_Vdi_bi/epsratio-(XDCinv_Vdi_bi*0.0+XDCinv_Vdi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdi_bi_Vsi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))+(0.0)*(XDCinv_Vdi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdi_bi_Vsi_bi/epsratio-(XDCinv_Vdi_bi*0.0+XDCinv_Vsi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vdi_bi_Tempt_GND=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))+(0.0)*(XDCinv_Vdi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vdi_bi_Tempt_GND/epsratio-(XDCinv_Vdi_bi*0.0+XDCinv_Tempt_GND*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vdi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#endif
Coxeffinv_Vsi_bi=(-(3.9*8.85418e-12)*(XDCinv_Vsi_bi/epsratio)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#if defined(_DERIVATE2)
  Coxeffinv_Vsi_bi_Vdbulk_di=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))+(0.0)*(XDCinv_Vsi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsi_bi_Vdbulk_di/epsratio-(XDCinv_Vsi_bi*0.0+XDCinv_Vdbulk_di*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdbulk_di/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsi_bi_Vsbulk_si=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))+(0.0)*(XDCinv_Vsi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsi_bi_Vsbulk_si/epsratio-(XDCinv_Vsi_bi*0.0+XDCinv_Vsbulk_si*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsbulk_si/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsi_bi_Vgi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))+(0.0)*(XDCinv_Vsi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsi_bi_Vgi_bi/epsratio-(XDCinv_Vsi_bi*0.0+XDCinv_Vgi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vgi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsi_bi_Vdi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))+(0.0)*(XDCinv_Vsi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsi_bi_Vdi_bi/epsratio-(XDCinv_Vsi_bi*0.0+XDCinv_Vdi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vdi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsi_bi_Vsi_bi=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))+(0.0)*(XDCinv_Vsi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsi_bi_Vsi_bi/epsratio-(XDCinv_Vsi_bi*0.0+XDCinv_Vsi_bi*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Vsi_bi/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
  Coxeffinv_Vsi_bi_Tempt_GND=((+0.0*8.85418e-12+0.0*0.0+0.0*0.0+3.9*0.0)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))-(0.0*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))+(0.0)*(XDCinv_Vsi_bi/epsratio)+(3.9*8.85418e-12)*(+((+0.0*3.9+0.0*0.0+0.0*0.0+BSIMBULKTOXP*0.0)/pModel->EPSROX-(0.0*0.0+(0.0)*0.0+(BSIMBULKTOXP*3.9)*0.0)/pModel->EPSROX/pModel->EPSROX+2*(BSIMBULKTOXP*3.9)*0.0*0.0/pModel->EPSROX/pModel->EPSROX/pModel->EPSROX)+(XDCinv_Vsi_bi_Tempt_GND/epsratio-(XDCinv_Vsi_bi*0.0+XDCinv_Tempt_GND*0.0+XDCinv*0.0)/epsratio/epsratio+2*XDCinv*0.0*0.0/epsratio/epsratio/epsratio)))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))+2*(3.9*8.85418e-12)*(XDCinv_Vsi_bi/epsratio)*(((0.0)/pModel->EPSROX)+(XDCinv_Tempt_GND/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#endif
#if defined(_DERIVATE)
Coxeffinv_Tempt_GND=(-(3.9*8.85418e-12)*(XDCinv_Tempt_GND/epsratio)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
#endif
#endif
Coxeffinv=((3.9*8.85418e-12)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio)));
EXIT_IF_ISNAN(((3.9*8.85418e-12)/(((BSIMBULKTOXP*3.9)/pModel->EPSROX)+(XDCinv/epsratio))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND)V(dbulk,GND)V(sbulk,GND) */
#if defined(_DERIVATE)
QBi_Tempt_GND=(((((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt_Tempt_GND)*Qb)+((((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Tempt_GND));
#endif
QBi_Vdbulk_di=((((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdbulk_di);
#if defined(_DERIVATE2)
  QBi_Vdbulk_di_Tempt_GND=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*Vt_Tempt_GND+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Tempt_GND+((((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt_Tempt_GND)))*Qb_Vdbulk_di+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdbulk_di_Tempt_GND);
  QBi_Vdbulk_di_Vdbulk_di=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdbulk_di+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdbulk_di+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdbulk_di_Vdbulk_di);
  QBi_Vdbulk_di_Vsbulk_si=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsbulk_si+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdbulk_di+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdbulk_di_Vsbulk_si);
  QBi_Vdbulk_di_Vgi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vgi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdbulk_di+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdbulk_di_Vgi_bi);
  QBi_Vdbulk_di_Vdi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdbulk_di+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdbulk_di_Vdi_bi);
  QBi_Vdbulk_di_Vsi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdbulk_di+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdbulk_di_Vsi_bi);
#endif
QBi_Vsbulk_si=((((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsbulk_si);
#if defined(_DERIVATE2)
  QBi_Vsbulk_si_Tempt_GND=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*Vt_Tempt_GND+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Tempt_GND+((((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt_Tempt_GND)))*Qb_Vsbulk_si+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsbulk_si_Tempt_GND);
  QBi_Vsbulk_si_Vdbulk_di=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdbulk_di+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsbulk_si+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsbulk_si_Vdbulk_di);
  QBi_Vsbulk_si_Vsbulk_si=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsbulk_si+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsbulk_si+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsbulk_si_Vsbulk_si);
  QBi_Vsbulk_si_Vgi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vgi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsbulk_si+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsbulk_si_Vgi_bi);
  QBi_Vsbulk_si_Vdi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsbulk_si+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsbulk_si_Vdi_bi);
  QBi_Vsbulk_si_Vsi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsbulk_si+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsbulk_si_Vsi_bi);
#endif
QBi_Vgi_bi=((((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vgi_bi);
#if defined(_DERIVATE2)
  QBi_Vgi_bi_Tempt_GND=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*Vt_Tempt_GND+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Tempt_GND+((((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt_Tempt_GND)))*Qb_Vgi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vgi_bi_Tempt_GND);
  QBi_Vgi_bi_Vdbulk_di=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdbulk_di+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vgi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vgi_bi_Vdbulk_di);
  QBi_Vgi_bi_Vsbulk_si=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsbulk_si+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vgi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vgi_bi_Vsbulk_si);
  QBi_Vgi_bi_Vgi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vgi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vgi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vgi_bi_Vgi_bi);
  QBi_Vgi_bi_Vdi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vgi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vgi_bi_Vdi_bi);
  QBi_Vgi_bi_Vsi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vgi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vgi_bi_Vsi_bi);
#endif
QBi_Vdi_bi=((((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdi_bi);
#if defined(_DERIVATE2)
  QBi_Vdi_bi_Tempt_GND=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*Vt_Tempt_GND+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Tempt_GND+((((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt_Tempt_GND)))*Qb_Vdi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdi_bi_Tempt_GND);
  QBi_Vdi_bi_Vdbulk_di=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdbulk_di+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdi_bi_Vdbulk_di);
  QBi_Vdi_bi_Vsbulk_si=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsbulk_si+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdi_bi_Vsbulk_si);
  QBi_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vgi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdi_bi_Vgi_bi);
  QBi_Vdi_bi_Vdi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdi_bi_Vdi_bi);
  QBi_Vdi_bi_Vsi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vdi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vdi_bi_Vsi_bi);
#endif
QBi_Vsi_bi=((((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsi_bi);
#if defined(_DERIVATE2)
  QBi_Vsi_bi_Tempt_GND=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*Vt_Tempt_GND+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Tempt_GND+((((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt_Tempt_GND)))*Qb_Vsi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsi_bi_Tempt_GND);
  QBi_Vsi_bi_Vdbulk_di=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdbulk_di+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsi_bi_Vdbulk_di);
  QBi_Vsi_bi_Vsbulk_si=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsbulk_si+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsi_bi_Vsbulk_si);
  QBi_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vgi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsi_bi_Vgi_bi);
  QBi_Vsi_bi_Vdi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vdi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsi_bi_Vdi_bi);
  QBi_Vsi_bi_Vsi_bi=(+(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+(-pInst->NF)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-pInst->NF)*Wact)*0.0)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP)+0.0*((0.0)/BSIMBULKTOXP)+((0.0)*Lact)*0.0+(((-pInst->NF)*Wact)*Lact)*((+0.0*pModel->EPSROX+0.0*0.0+0.0*0.0+8.85418e-12*0.0)/BSIMBULKTOXP-(0.0*0.0+(0.0)*0.0+(8.85418e-12*pModel->EPSROX)*0.0)/BSIMBULKTOXP/BSIMBULKTOXP+2*(8.85418e-12*pModel->EPSROX)*0.0*0.0/BSIMBULKTOXP/BSIMBULKTOXP/BSIMBULKTOXP))*Vt+0.0*0.0+(((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*0.0+((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*0.0)*Qb+0.0*Qb_Vsi_bi+((((((0.0)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))+((((-pInst->NF)*Wact)*Lact)*((0.0)/BSIMBULKTOXP))))*Vt)*Qb_Vsi_bi+(((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb_Vsi_bi_Vsi_bi);
#endif
#endif
QBi=((((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb);
EXIT_IF_ISNAN(((((((-pInst->NF)*Wact)*Lact)*((8.85418e-12*pModel->EPSROX)/BSIMBULKTOXP))*Vt)*Qb))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
WLCOXVtinv_Vdbulk_di=(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)*Vt;
#if defined(_DERIVATE2)
  WLCOXVtinv_Vdbulk_di_Vdbulk_di=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdbulk_di+((0.0)*Lact)*Coxeffinv_Vdbulk_di+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di_Vdbulk_di)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdbulk_di_Vsbulk_si=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsbulk_si+((0.0)*Lact)*Coxeffinv_Vdbulk_di+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di_Vsbulk_si)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdbulk_di_Vgi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vgi_bi+((0.0)*Lact)*Coxeffinv_Vdbulk_di+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di_Vgi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdbulk_di_Vdi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdi_bi+((0.0)*Lact)*Coxeffinv_Vdbulk_di+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di_Vdi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdbulk_di_Vsi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsi_bi+((0.0)*Lact)*Coxeffinv_Vdbulk_di+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di_Vsi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdbulk_di_Tempt_GND=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Tempt_GND+((0.0)*Lact)*Coxeffinv_Vdbulk_di+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di_Tempt_GND)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)*Vt_Tempt_GND+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Tempt_GND)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
#endif
WLCOXVtinv_Vsbulk_si=(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)*Vt;
#if defined(_DERIVATE2)
  WLCOXVtinv_Vsbulk_si_Vdbulk_di=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdbulk_di+((0.0)*Lact)*Coxeffinv_Vsbulk_si+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si_Vdbulk_di)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsbulk_si_Vsbulk_si=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsbulk_si+((0.0)*Lact)*Coxeffinv_Vsbulk_si+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si_Vsbulk_si)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsbulk_si_Vgi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vgi_bi+((0.0)*Lact)*Coxeffinv_Vsbulk_si+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si_Vgi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsbulk_si_Vdi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdi_bi+((0.0)*Lact)*Coxeffinv_Vsbulk_si+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si_Vdi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsbulk_si_Vsi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsi_bi+((0.0)*Lact)*Coxeffinv_Vsbulk_si+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si_Vsi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsbulk_si_Tempt_GND=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Tempt_GND+((0.0)*Lact)*Coxeffinv_Vsbulk_si+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si_Tempt_GND)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)*Vt_Tempt_GND+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Tempt_GND)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
#endif
WLCOXVtinv_Vgi_bi=(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)*Vt;
#if defined(_DERIVATE2)
  WLCOXVtinv_Vgi_bi_Vdbulk_di=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdbulk_di+((0.0)*Lact)*Coxeffinv_Vgi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi_Vdbulk_di)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vgi_bi_Vsbulk_si=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsbulk_si+((0.0)*Lact)*Coxeffinv_Vgi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi_Vsbulk_si)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vgi_bi_Vgi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vgi_bi+((0.0)*Lact)*Coxeffinv_Vgi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi_Vgi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vgi_bi_Vdi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdi_bi+((0.0)*Lact)*Coxeffinv_Vgi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi_Vdi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vgi_bi_Vsi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsi_bi+((0.0)*Lact)*Coxeffinv_Vgi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi_Vsi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vgi_bi_Tempt_GND=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Tempt_GND+((0.0)*Lact)*Coxeffinv_Vgi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi_Tempt_GND)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)*Vt_Tempt_GND+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Tempt_GND)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
#endif
WLCOXVtinv_Vdi_bi=(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)*Vt;
#if defined(_DERIVATE2)
  WLCOXVtinv_Vdi_bi_Vdbulk_di=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdbulk_di+((0.0)*Lact)*Coxeffinv_Vdi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi_Vdbulk_di)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdi_bi_Vsbulk_si=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsbulk_si+((0.0)*Lact)*Coxeffinv_Vdi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi_Vsbulk_si)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdi_bi_Vgi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vgi_bi+((0.0)*Lact)*Coxeffinv_Vdi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi_Vgi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdi_bi_Vdi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdi_bi+((0.0)*Lact)*Coxeffinv_Vdi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi_Vdi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdi_bi_Vsi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsi_bi+((0.0)*Lact)*Coxeffinv_Vdi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi_Vsi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vdi_bi_Tempt_GND=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Tempt_GND+((0.0)*Lact)*Coxeffinv_Vdi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi_Tempt_GND)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)*Vt_Tempt_GND+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Tempt_GND)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
#endif
WLCOXVtinv_Vsi_bi=(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)*Vt;
#if defined(_DERIVATE2)
  WLCOXVtinv_Vsi_bi_Vdbulk_di=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdbulk_di+((0.0)*Lact)*Coxeffinv_Vsi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi_Vdbulk_di)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdbulk_di)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsi_bi_Vsbulk_si=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsbulk_si+((0.0)*Lact)*Coxeffinv_Vsi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi_Vsbulk_si)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsbulk_si)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsi_bi_Vgi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vgi_bi+((0.0)*Lact)*Coxeffinv_Vsi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi_Vgi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vgi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsi_bi_Vdi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vdi_bi+((0.0)*Lact)*Coxeffinv_Vsi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi_Vdi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vdi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsi_bi_Vsi_bi=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Vsi_bi+((0.0)*Lact)*Coxeffinv_Vsi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi_Vsi_bi)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)*0.0+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
  WLCOXVtinv_Vsi_bi_Tempt_GND=(+(+(+(+0.0*Wact+0.0*0.0+0.0*0.0+pInst->NF*0.0)*Lact+0.0*0.0+(0.0)*0.0+(pInst->NF*Wact)*0.0)*Coxeffinv+0.0*Coxeffinv_Tempt_GND+((0.0)*Lact)*Coxeffinv_Vsi_bi+((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi_Tempt_GND)*Vt+(((pInst->NF*Wact)*Lact)*Coxeffinv_Vsi_bi)*Vt_Tempt_GND+(((((0.0)*Lact)*Coxeffinv)+(((pInst->NF*Wact)*Lact)*Coxeffinv_Tempt_GND)))*0.0+(((pInst->NF*Wact)*Lact)*Coxeffinv)*0.0);
#endif
#if defined(_DERIVATE)
WLCOXVtinv_Tempt_GND=(((((pInst->NF*Wact)*Lact)*Coxeffinv_Tempt_GND)*Vt)+((((pInst->NF*Wact)*Lact)*Coxeffinv)*Vt_Tempt_GND));
#endif
#endif
WLCOXVtinv=((((pInst->NF*Wact)*Lact)*Coxeffinv)*Vt);
EXIT_IF_ISNAN(((((pInst->NF*Wact)*Lact)*Coxeffinv)*Vt))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(dbulk,GND)V(gm,GND) */
QSi_Vdbulk_di=(((-WLCOXVtinv_Vdbulk_di)*Qs)+((-WLCOXVtinv)*Qs_Vdbulk_di));
#if defined(_DERIVATE2)
  QSi_Vdbulk_di_Vdbulk_di=(+0.0*Qs+(-WLCOXVtinv_Vdbulk_di)*Qs_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qs_Vdbulk_di+(-WLCOXVtinv)*Qs_Vdbulk_di_Vdbulk_di);
  QSi_Vdbulk_di_Vsbulk_si=(+0.0*Qs+(-WLCOXVtinv_Vdbulk_di)*Qs_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qs_Vdbulk_di+(-WLCOXVtinv)*Qs_Vdbulk_di_Vsbulk_si);
  QSi_Vdbulk_di_Tempt_GND=(+0.0*Qs+(-WLCOXVtinv_Vdbulk_di)*Qs_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qs_Vdbulk_di+(-WLCOXVtinv)*Qs_Vdbulk_di_Tempt_GND);
  QSi_Vdbulk_di_Vgi_bi=(+0.0*Qs+(-WLCOXVtinv_Vdbulk_di)*Qs_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qs_Vdbulk_di+(-WLCOXVtinv)*Qs_Vdbulk_di_Vgi_bi);
  QSi_Vdbulk_di_Vdi_bi=(+0.0*Qs+(-WLCOXVtinv_Vdbulk_di)*Qs_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qs_Vdbulk_di+(-WLCOXVtinv)*Qs_Vdbulk_di_Vdi_bi);
  QSi_Vdbulk_di_Vsi_bi=(+0.0*Qs+(-WLCOXVtinv_Vdbulk_di)*Qs_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qs_Vdbulk_di+(-WLCOXVtinv)*Qs_Vdbulk_di_Vsi_bi);
#endif
QSi_Vsbulk_si=(((-WLCOXVtinv_Vsbulk_si)*Qs)+((-WLCOXVtinv)*Qs_Vsbulk_si));
#if defined(_DERIVATE2)
  QSi_Vsbulk_si_Vdbulk_di=(+0.0*Qs+(-WLCOXVtinv_Vsbulk_si)*Qs_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qs_Vsbulk_si+(-WLCOXVtinv)*Qs_Vsbulk_si_Vdbulk_di);
  QSi_Vsbulk_si_Vsbulk_si=(+0.0*Qs+(-WLCOXVtinv_Vsbulk_si)*Qs_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qs_Vsbulk_si+(-WLCOXVtinv)*Qs_Vsbulk_si_Vsbulk_si);
  QSi_Vsbulk_si_Tempt_GND=(+0.0*Qs+(-WLCOXVtinv_Vsbulk_si)*Qs_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qs_Vsbulk_si+(-WLCOXVtinv)*Qs_Vsbulk_si_Tempt_GND);
  QSi_Vsbulk_si_Vgi_bi=(+0.0*Qs+(-WLCOXVtinv_Vsbulk_si)*Qs_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qs_Vsbulk_si+(-WLCOXVtinv)*Qs_Vsbulk_si_Vgi_bi);
  QSi_Vsbulk_si_Vdi_bi=(+0.0*Qs+(-WLCOXVtinv_Vsbulk_si)*Qs_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qs_Vsbulk_si+(-WLCOXVtinv)*Qs_Vsbulk_si_Vdi_bi);
  QSi_Vsbulk_si_Vsi_bi=(+0.0*Qs+(-WLCOXVtinv_Vsbulk_si)*Qs_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qs_Vsbulk_si+(-WLCOXVtinv)*Qs_Vsbulk_si_Vsi_bi);
#endif
#if defined(_DERIVATE)
QSi_Tempt_GND=(((-WLCOXVtinv_Tempt_GND)*Qs)+((-WLCOXVtinv)*Qs_Tempt_GND));
#endif
QSi_Vgi_bi=(((-WLCOXVtinv_Vgi_bi)*Qs)+((-WLCOXVtinv)*Qs_Vgi_bi));
#if defined(_DERIVATE2)
  QSi_Vgi_bi_Vdbulk_di=(+0.0*Qs+(-WLCOXVtinv_Vgi_bi)*Qs_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qs_Vgi_bi+(-WLCOXVtinv)*Qs_Vgi_bi_Vdbulk_di);
  QSi_Vgi_bi_Vsbulk_si=(+0.0*Qs+(-WLCOXVtinv_Vgi_bi)*Qs_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qs_Vgi_bi+(-WLCOXVtinv)*Qs_Vgi_bi_Vsbulk_si);
  QSi_Vgi_bi_Tempt_GND=(+0.0*Qs+(-WLCOXVtinv_Vgi_bi)*Qs_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qs_Vgi_bi+(-WLCOXVtinv)*Qs_Vgi_bi_Tempt_GND);
  QSi_Vgi_bi_Vgi_bi=(+0.0*Qs+(-WLCOXVtinv_Vgi_bi)*Qs_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qs_Vgi_bi+(-WLCOXVtinv)*Qs_Vgi_bi_Vgi_bi);
  QSi_Vgi_bi_Vdi_bi=(+0.0*Qs+(-WLCOXVtinv_Vgi_bi)*Qs_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qs_Vgi_bi+(-WLCOXVtinv)*Qs_Vgi_bi_Vdi_bi);
  QSi_Vgi_bi_Vsi_bi=(+0.0*Qs+(-WLCOXVtinv_Vgi_bi)*Qs_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qs_Vgi_bi+(-WLCOXVtinv)*Qs_Vgi_bi_Vsi_bi);
#endif
QSi_Vdi_bi=(((-WLCOXVtinv_Vdi_bi)*Qs)+((-WLCOXVtinv)*Qs_Vdi_bi));
#if defined(_DERIVATE2)
  QSi_Vdi_bi_Vdbulk_di=(+0.0*Qs+(-WLCOXVtinv_Vdi_bi)*Qs_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qs_Vdi_bi+(-WLCOXVtinv)*Qs_Vdi_bi_Vdbulk_di);
  QSi_Vdi_bi_Vsbulk_si=(+0.0*Qs+(-WLCOXVtinv_Vdi_bi)*Qs_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qs_Vdi_bi+(-WLCOXVtinv)*Qs_Vdi_bi_Vsbulk_si);
  QSi_Vdi_bi_Tempt_GND=(+0.0*Qs+(-WLCOXVtinv_Vdi_bi)*Qs_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qs_Vdi_bi+(-WLCOXVtinv)*Qs_Vdi_bi_Tempt_GND);
  QSi_Vdi_bi_Vgi_bi=(+0.0*Qs+(-WLCOXVtinv_Vdi_bi)*Qs_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qs_Vdi_bi+(-WLCOXVtinv)*Qs_Vdi_bi_Vgi_bi);
  QSi_Vdi_bi_Vdi_bi=(+0.0*Qs+(-WLCOXVtinv_Vdi_bi)*Qs_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qs_Vdi_bi+(-WLCOXVtinv)*Qs_Vdi_bi_Vdi_bi);
  QSi_Vdi_bi_Vsi_bi=(+0.0*Qs+(-WLCOXVtinv_Vdi_bi)*Qs_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qs_Vdi_bi+(-WLCOXVtinv)*Qs_Vdi_bi_Vsi_bi);
#endif
QSi_Vsi_bi=(((-WLCOXVtinv_Vsi_bi)*Qs)+((-WLCOXVtinv)*Qs_Vsi_bi));
#if defined(_DERIVATE2)
  QSi_Vsi_bi_Vdbulk_di=(+0.0*Qs+(-WLCOXVtinv_Vsi_bi)*Qs_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qs_Vsi_bi+(-WLCOXVtinv)*Qs_Vsi_bi_Vdbulk_di);
  QSi_Vsi_bi_Vsbulk_si=(+0.0*Qs+(-WLCOXVtinv_Vsi_bi)*Qs_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qs_Vsi_bi+(-WLCOXVtinv)*Qs_Vsi_bi_Vsbulk_si);
  QSi_Vsi_bi_Tempt_GND=(+0.0*Qs+(-WLCOXVtinv_Vsi_bi)*Qs_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qs_Vsi_bi+(-WLCOXVtinv)*Qs_Vsi_bi_Tempt_GND);
  QSi_Vsi_bi_Vgi_bi=(+0.0*Qs+(-WLCOXVtinv_Vsi_bi)*Qs_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qs_Vsi_bi+(-WLCOXVtinv)*Qs_Vsi_bi_Vgi_bi);
  QSi_Vsi_bi_Vdi_bi=(+0.0*Qs+(-WLCOXVtinv_Vsi_bi)*Qs_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qs_Vsi_bi+(-WLCOXVtinv)*Qs_Vsi_bi_Vdi_bi);
  QSi_Vsi_bi_Vsi_bi=(+0.0*Qs+(-WLCOXVtinv_Vsi_bi)*Qs_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qs_Vsi_bi+(-WLCOXVtinv)*Qs_Vsi_bi_Vsi_bi);
#endif
#endif
QSi=((-WLCOXVtinv)*Qs);
EXIT_IF_ISNAN(((-WLCOXVtinv)*Qs))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(dbulk,GND)V(bi,GND)V(gi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
QDi_Vdbulk_di=(((-WLCOXVtinv_Vdbulk_di)*Qd)+((-WLCOXVtinv)*Qd_Vdbulk_di));
#if defined(_DERIVATE2)
  QDi_Vdbulk_di_Vdbulk_di=(+0.0*Qd+(-WLCOXVtinv_Vdbulk_di)*Qd_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qd_Vdbulk_di+(-WLCOXVtinv)*Qd_Vdbulk_di_Vdbulk_di);
  QDi_Vdbulk_di_Vsbulk_si=(+0.0*Qd+(-WLCOXVtinv_Vdbulk_di)*Qd_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qd_Vdbulk_di+(-WLCOXVtinv)*Qd_Vdbulk_di_Vsbulk_si);
  QDi_Vdbulk_di_Tempt_GND=(+0.0*Qd+(-WLCOXVtinv_Vdbulk_di)*Qd_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qd_Vdbulk_di+(-WLCOXVtinv)*Qd_Vdbulk_di_Tempt_GND);
  QDi_Vdbulk_di_Vgi_bi=(+0.0*Qd+(-WLCOXVtinv_Vdbulk_di)*Qd_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qd_Vdbulk_di+(-WLCOXVtinv)*Qd_Vdbulk_di_Vgi_bi);
  QDi_Vdbulk_di_Vdi_bi=(+0.0*Qd+(-WLCOXVtinv_Vdbulk_di)*Qd_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qd_Vdbulk_di+(-WLCOXVtinv)*Qd_Vdbulk_di_Vdi_bi);
  QDi_Vdbulk_di_Vsi_bi=(+0.0*Qd+(-WLCOXVtinv_Vdbulk_di)*Qd_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qd_Vdbulk_di+(-WLCOXVtinv)*Qd_Vdbulk_di_Vsi_bi);
#endif
QDi_Vsbulk_si=(((-WLCOXVtinv_Vsbulk_si)*Qd)+((-WLCOXVtinv)*Qd_Vsbulk_si));
#if defined(_DERIVATE2)
  QDi_Vsbulk_si_Vdbulk_di=(+0.0*Qd+(-WLCOXVtinv_Vsbulk_si)*Qd_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qd_Vsbulk_si+(-WLCOXVtinv)*Qd_Vsbulk_si_Vdbulk_di);
  QDi_Vsbulk_si_Vsbulk_si=(+0.0*Qd+(-WLCOXVtinv_Vsbulk_si)*Qd_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qd_Vsbulk_si+(-WLCOXVtinv)*Qd_Vsbulk_si_Vsbulk_si);
  QDi_Vsbulk_si_Tempt_GND=(+0.0*Qd+(-WLCOXVtinv_Vsbulk_si)*Qd_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qd_Vsbulk_si+(-WLCOXVtinv)*Qd_Vsbulk_si_Tempt_GND);
  QDi_Vsbulk_si_Vgi_bi=(+0.0*Qd+(-WLCOXVtinv_Vsbulk_si)*Qd_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qd_Vsbulk_si+(-WLCOXVtinv)*Qd_Vsbulk_si_Vgi_bi);
  QDi_Vsbulk_si_Vdi_bi=(+0.0*Qd+(-WLCOXVtinv_Vsbulk_si)*Qd_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qd_Vsbulk_si+(-WLCOXVtinv)*Qd_Vsbulk_si_Vdi_bi);
  QDi_Vsbulk_si_Vsi_bi=(+0.0*Qd+(-WLCOXVtinv_Vsbulk_si)*Qd_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qd_Vsbulk_si+(-WLCOXVtinv)*Qd_Vsbulk_si_Vsi_bi);
#endif
#if defined(_DERIVATE)
QDi_Tempt_GND=(((-WLCOXVtinv_Tempt_GND)*Qd)+((-WLCOXVtinv)*Qd_Tempt_GND));
#endif
QDi_Vgi_bi=(((-WLCOXVtinv_Vgi_bi)*Qd)+((-WLCOXVtinv)*Qd_Vgi_bi));
#if defined(_DERIVATE2)
  QDi_Vgi_bi_Vdbulk_di=(+0.0*Qd+(-WLCOXVtinv_Vgi_bi)*Qd_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qd_Vgi_bi+(-WLCOXVtinv)*Qd_Vgi_bi_Vdbulk_di);
  QDi_Vgi_bi_Vsbulk_si=(+0.0*Qd+(-WLCOXVtinv_Vgi_bi)*Qd_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qd_Vgi_bi+(-WLCOXVtinv)*Qd_Vgi_bi_Vsbulk_si);
  QDi_Vgi_bi_Tempt_GND=(+0.0*Qd+(-WLCOXVtinv_Vgi_bi)*Qd_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qd_Vgi_bi+(-WLCOXVtinv)*Qd_Vgi_bi_Tempt_GND);
  QDi_Vgi_bi_Vgi_bi=(+0.0*Qd+(-WLCOXVtinv_Vgi_bi)*Qd_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qd_Vgi_bi+(-WLCOXVtinv)*Qd_Vgi_bi_Vgi_bi);
  QDi_Vgi_bi_Vdi_bi=(+0.0*Qd+(-WLCOXVtinv_Vgi_bi)*Qd_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qd_Vgi_bi+(-WLCOXVtinv)*Qd_Vgi_bi_Vdi_bi);
  QDi_Vgi_bi_Vsi_bi=(+0.0*Qd+(-WLCOXVtinv_Vgi_bi)*Qd_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qd_Vgi_bi+(-WLCOXVtinv)*Qd_Vgi_bi_Vsi_bi);
#endif
QDi_Vdi_bi=(((-WLCOXVtinv_Vdi_bi)*Qd)+((-WLCOXVtinv)*Qd_Vdi_bi));
#if defined(_DERIVATE2)
  QDi_Vdi_bi_Vdbulk_di=(+0.0*Qd+(-WLCOXVtinv_Vdi_bi)*Qd_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qd_Vdi_bi+(-WLCOXVtinv)*Qd_Vdi_bi_Vdbulk_di);
  QDi_Vdi_bi_Vsbulk_si=(+0.0*Qd+(-WLCOXVtinv_Vdi_bi)*Qd_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qd_Vdi_bi+(-WLCOXVtinv)*Qd_Vdi_bi_Vsbulk_si);
  QDi_Vdi_bi_Tempt_GND=(+0.0*Qd+(-WLCOXVtinv_Vdi_bi)*Qd_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qd_Vdi_bi+(-WLCOXVtinv)*Qd_Vdi_bi_Tempt_GND);
  QDi_Vdi_bi_Vgi_bi=(+0.0*Qd+(-WLCOXVtinv_Vdi_bi)*Qd_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qd_Vdi_bi+(-WLCOXVtinv)*Qd_Vdi_bi_Vgi_bi);
  QDi_Vdi_bi_Vdi_bi=(+0.0*Qd+(-WLCOXVtinv_Vdi_bi)*Qd_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qd_Vdi_bi+(-WLCOXVtinv)*Qd_Vdi_bi_Vdi_bi);
  QDi_Vdi_bi_Vsi_bi=(+0.0*Qd+(-WLCOXVtinv_Vdi_bi)*Qd_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qd_Vdi_bi+(-WLCOXVtinv)*Qd_Vdi_bi_Vsi_bi);
#endif
QDi_Vsi_bi=(((-WLCOXVtinv_Vsi_bi)*Qd)+((-WLCOXVtinv)*Qd_Vsi_bi));
#if defined(_DERIVATE2)
  QDi_Vsi_bi_Vdbulk_di=(+0.0*Qd+(-WLCOXVtinv_Vsi_bi)*Qd_Vdbulk_di+(-WLCOXVtinv_Vdbulk_di)*Qd_Vsi_bi+(-WLCOXVtinv)*Qd_Vsi_bi_Vdbulk_di);
  QDi_Vsi_bi_Vsbulk_si=(+0.0*Qd+(-WLCOXVtinv_Vsi_bi)*Qd_Vsbulk_si+(-WLCOXVtinv_Vsbulk_si)*Qd_Vsi_bi+(-WLCOXVtinv)*Qd_Vsi_bi_Vsbulk_si);
  QDi_Vsi_bi_Tempt_GND=(+0.0*Qd+(-WLCOXVtinv_Vsi_bi)*Qd_Tempt_GND+(-WLCOXVtinv_Tempt_GND)*Qd_Vsi_bi+(-WLCOXVtinv)*Qd_Vsi_bi_Tempt_GND);
  QDi_Vsi_bi_Vgi_bi=(+0.0*Qd+(-WLCOXVtinv_Vsi_bi)*Qd_Vgi_bi+(-WLCOXVtinv_Vgi_bi)*Qd_Vsi_bi+(-WLCOXVtinv)*Qd_Vsi_bi_Vgi_bi);
  QDi_Vsi_bi_Vdi_bi=(+0.0*Qd+(-WLCOXVtinv_Vsi_bi)*Qd_Vdi_bi+(-WLCOXVtinv_Vdi_bi)*Qd_Vsi_bi+(-WLCOXVtinv)*Qd_Vsi_bi_Vdi_bi);
  QDi_Vsi_bi_Vsi_bi=(+0.0*Qd+(-WLCOXVtinv_Vsi_bi)*Qd_Vsi_bi+(-WLCOXVtinv_Vsi_bi)*Qd_Vsi_bi+(-WLCOXVtinv)*Qd_Vsi_bi_Vsi_bi);
#endif
#endif
QDi=((-WLCOXVtinv)*Qd);
EXIT_IF_ISNAN(((-WLCOXVtinv)*Qd))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(di,GND)V(bi,GND)V(gi,GND)V(gm,GND) */
#if defined(_DERIVATE)
QGi_Tempt_GND=(-((QBi_Tempt_GND+QSi_Tempt_GND)+QDi_Tempt_GND));
#endif
QGi_Vdbulk_di=(-((QBi_Vdbulk_di+QSi_Vdbulk_di)+QDi_Vdbulk_di));
#if defined(_DERIVATE2)
  QGi_Vdbulk_di_Tempt_GND=0.0;
  QGi_Vdbulk_di_Vdbulk_di=0.0;
  QGi_Vdbulk_di_Vsbulk_si=0.0;
  QGi_Vdbulk_di_Vgi_bi=0.0;
  QGi_Vdbulk_di_Vdi_bi=0.0;
  QGi_Vdbulk_di_Vsi_bi=0.0;
#endif
QGi_Vsbulk_si=(-((QBi_Vsbulk_si+QSi_Vsbulk_si)+QDi_Vsbulk_si));
#if defined(_DERIVATE2)
  QGi_Vsbulk_si_Tempt_GND=0.0;
  QGi_Vsbulk_si_Vdbulk_di=0.0;
  QGi_Vsbulk_si_Vsbulk_si=0.0;
  QGi_Vsbulk_si_Vgi_bi=0.0;
  QGi_Vsbulk_si_Vdi_bi=0.0;
  QGi_Vsbulk_si_Vsi_bi=0.0;
#endif
QGi_Vgi_bi=(-((QBi_Vgi_bi+QSi_Vgi_bi)+QDi_Vgi_bi));
#if defined(_DERIVATE2)
  QGi_Vgi_bi_Tempt_GND=0.0;
  QGi_Vgi_bi_Vdbulk_di=0.0;
  QGi_Vgi_bi_Vsbulk_si=0.0;
  QGi_Vgi_bi_Vgi_bi=0.0;
  QGi_Vgi_bi_Vdi_bi=0.0;
  QGi_Vgi_bi_Vsi_bi=0.0;
#endif
QGi_Vdi_bi=(-((QBi_Vdi_bi+QSi_Vdi_bi)+QDi_Vdi_bi));
#if defined(_DERIVATE2)
  QGi_Vdi_bi_Tempt_GND=0.0;
  QGi_Vdi_bi_Vdbulk_di=0.0;
  QGi_Vdi_bi_Vsbulk_si=0.0;
  QGi_Vdi_bi_Vgi_bi=0.0;
  QGi_Vdi_bi_Vdi_bi=0.0;
  QGi_Vdi_bi_Vsi_bi=0.0;
#endif
QGi_Vsi_bi=(-((QBi_Vsi_bi+QSi_Vsi_bi)+QDi_Vsi_bi));
#if defined(_DERIVATE2)
  QGi_Vsi_bi_Tempt_GND=0.0;
  QGi_Vsi_bi_Vdbulk_di=0.0;
  QGi_Vsi_bi_Vsbulk_si=0.0;
  QGi_Vsi_bi_Vgi_bi=0.0;
  QGi_Vsi_bi_Vdi_bi=0.0;
  QGi_Vsi_bi_Vsi_bi=0.0;
#endif
#endif
QGi=(-((QBi+QSi)+QDi));
EXIT_IF_ISNAN((-((QBi+QSi)+QDi)))
#endif
#ifdef _DYNAMIC
if
((!(model->CF_Given)))
{
#if defined(_DYNAMIC)
CF_i=((((2.0*pModel->EPSROX)*8.85418e-12)/3.14159265358979323846)*bsimbulk_lln((pModel->CFRCOEFF*(1.0+(0.4e-6/pModel->TOXE)))));
EXIT_IF_ISNAN(((((2.0*pModel->EPSROX)*8.85418e-12)/3.14159265358979323846)*bsimbulk_lln((pModel->CFRCOEFF*(1.0+(0.4e-6/pModel->TOXE))))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
Cgsof=(pModel->CGSO+CF_i);
EXIT_IF_ISNAN((pModel->CGSO+CF_i))
#endif
#if defined(_DYNAMIC)
Cgdof=(pModel->CGDO+CF_i);
EXIT_IF_ISNAN((pModel->CGDO+CF_i))
#endif
if
((pModel->COVMOD==0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)V(gm,si) ddxprobe=V(bi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
#if defined(_DERIVATE)
Qovs_Tempt_GND=0.0;
#endif
Qovs_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qovs_Vdbulk_di_Tempt_GND=0.0;
  Qovs_Vdbulk_di_Vdbulk_di=0.0;
  Qovs_Vdbulk_di_Vsbulk_si=0.0;
  Qovs_Vdbulk_di_Vgi_bi=0.0;
  Qovs_Vdbulk_di_Vdi_bi=0.0;
  Qovs_Vdbulk_di_Vsi_bi=0.0;
  Qovs_Vdbulk_di_Vgm_si=0.0;
#endif
Qovs_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qovs_Vsbulk_si_Tempt_GND=0.0;
  Qovs_Vsbulk_si_Vdbulk_di=0.0;
  Qovs_Vsbulk_si_Vsbulk_si=0.0;
  Qovs_Vsbulk_si_Vgi_bi=0.0;
  Qovs_Vsbulk_si_Vdi_bi=0.0;
  Qovs_Vsbulk_si_Vsi_bi=0.0;
  Qovs_Vsbulk_si_Vgm_si=0.0;
#endif
Qovs_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Qovs_Vgi_bi_Tempt_GND=0.0;
  Qovs_Vgi_bi_Vdbulk_di=0.0;
  Qovs_Vgi_bi_Vsbulk_si=0.0;
  Qovs_Vgi_bi_Vgi_bi=0.0;
  Qovs_Vgi_bi_Vdi_bi=0.0;
  Qovs_Vgi_bi_Vsi_bi=0.0;
  Qovs_Vgi_bi_Vgm_si=0.0;
#endif
Qovs_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Qovs_Vdi_bi_Tempt_GND=0.0;
  Qovs_Vdi_bi_Vdbulk_di=0.0;
  Qovs_Vdi_bi_Vsbulk_si=0.0;
  Qovs_Vdi_bi_Vgi_bi=0.0;
  Qovs_Vdi_bi_Vdi_bi=0.0;
  Qovs_Vdi_bi_Vsi_bi=0.0;
  Qovs_Vdi_bi_Vgm_si=0.0;
#endif
Qovs_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Qovs_Vsi_bi_Tempt_GND=0.0;
  Qovs_Vsi_bi_Vdbulk_di=0.0;
  Qovs_Vsi_bi_Vsbulk_si=0.0;
  Qovs_Vsi_bi_Vgi_bi=0.0;
  Qovs_Vsi_bi_Vdi_bi=0.0;
  Qovs_Vsi_bi_Vsi_bi=0.0;
  Qovs_Vsi_bi_Vgm_si=0.0;
#endif
Qovs_Vgm_si=((((-Wact)*pInst->NF)*Cgsof)*Vgs_ov_noswap_Vgm_si);
#if defined(_DERIVATE2)
  Qovs_Vgm_si_Tempt_GND=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgsof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgs_ov_noswap+0.0*0.0+((0.0)*Cgsof)*Vgs_ov_noswap_Vgm_si+(((-Wact)*pInst->NF)*Cgsof)*0.0);
  Qovs_Vgm_si_Vdbulk_di=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgsof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgs_ov_noswap+0.0*0.0+((0.0)*Cgsof)*Vgs_ov_noswap_Vgm_si+(((-Wact)*pInst->NF)*Cgsof)*0.0);
  Qovs_Vgm_si_Vsbulk_si=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgsof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgs_ov_noswap+0.0*0.0+((0.0)*Cgsof)*Vgs_ov_noswap_Vgm_si+(((-Wact)*pInst->NF)*Cgsof)*0.0);
  Qovs_Vgm_si_Vgi_bi=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgsof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgs_ov_noswap+0.0*0.0+((0.0)*Cgsof)*Vgs_ov_noswap_Vgm_si+(((-Wact)*pInst->NF)*Cgsof)*0.0);
  Qovs_Vgm_si_Vdi_bi=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgsof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgs_ov_noswap+0.0*0.0+((0.0)*Cgsof)*Vgs_ov_noswap_Vgm_si+(((-Wact)*pInst->NF)*Cgsof)*0.0);
  Qovs_Vgm_si_Vsi_bi=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgsof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgs_ov_noswap+0.0*0.0+((0.0)*Cgsof)*Vgs_ov_noswap_Vgm_si+(((-Wact)*pInst->NF)*Cgsof)*0.0);
  Qovs_Vgm_si_Vgm_si=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgsof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgs_ov_noswap+0.0*Vgs_ov_noswap_Vgm_si+((0.0)*Cgsof)*Vgs_ov_noswap_Vgm_si+(((-Wact)*pInst->NF)*Cgsof)*Vgs_ov_noswap_Vgm_si_Vgm_si);
#endif
#endif
Qovs=((((-Wact)*pInst->NF)*Cgsof)*Vgs_ov_noswap);
EXIT_IF_ISNAN(((((-Wact)*pInst->NF)*Cgsof)*Vgs_ov_noswap))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)V(gm,di) ddxprobe=V(bi,GND)V(si,GND)V(di,GND)V(dbulk,GND)V(gm,GND) */
#if defined(_DERIVATE)
Qovd_Tempt_GND=0.0;
#endif
Qovd_Vgm_si=0.0;
#if defined(_DERIVATE2)
  Qovd_Vgm_si_Tempt_GND=0.0;
  Qovd_Vgm_si_Vgm_si=0.0;
  Qovd_Vgm_si_Vdbulk_di=0.0;
  Qovd_Vgm_si_Vsbulk_si=0.0;
  Qovd_Vgm_si_Vgi_bi=0.0;
  Qovd_Vgm_si_Vdi_bi=0.0;
  Qovd_Vgm_si_Vsi_bi=0.0;
  Qovd_Vgm_si_Vgm_di=0.0;
#endif
Qovd_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  Qovd_Vdbulk_di_Tempt_GND=0.0;
  Qovd_Vdbulk_di_Vgm_si=0.0;
  Qovd_Vdbulk_di_Vdbulk_di=0.0;
  Qovd_Vdbulk_di_Vsbulk_si=0.0;
  Qovd_Vdbulk_di_Vgi_bi=0.0;
  Qovd_Vdbulk_di_Vdi_bi=0.0;
  Qovd_Vdbulk_di_Vsi_bi=0.0;
  Qovd_Vdbulk_di_Vgm_di=0.0;
#endif
Qovd_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  Qovd_Vsbulk_si_Tempt_GND=0.0;
  Qovd_Vsbulk_si_Vgm_si=0.0;
  Qovd_Vsbulk_si_Vdbulk_di=0.0;
  Qovd_Vsbulk_si_Vsbulk_si=0.0;
  Qovd_Vsbulk_si_Vgi_bi=0.0;
  Qovd_Vsbulk_si_Vdi_bi=0.0;
  Qovd_Vsbulk_si_Vsi_bi=0.0;
  Qovd_Vsbulk_si_Vgm_di=0.0;
#endif
Qovd_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  Qovd_Vgi_bi_Tempt_GND=0.0;
  Qovd_Vgi_bi_Vgm_si=0.0;
  Qovd_Vgi_bi_Vdbulk_di=0.0;
  Qovd_Vgi_bi_Vsbulk_si=0.0;
  Qovd_Vgi_bi_Vgi_bi=0.0;
  Qovd_Vgi_bi_Vdi_bi=0.0;
  Qovd_Vgi_bi_Vsi_bi=0.0;
  Qovd_Vgi_bi_Vgm_di=0.0;
#endif
Qovd_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  Qovd_Vdi_bi_Tempt_GND=0.0;
  Qovd_Vdi_bi_Vgm_si=0.0;
  Qovd_Vdi_bi_Vdbulk_di=0.0;
  Qovd_Vdi_bi_Vsbulk_si=0.0;
  Qovd_Vdi_bi_Vgi_bi=0.0;
  Qovd_Vdi_bi_Vdi_bi=0.0;
  Qovd_Vdi_bi_Vsi_bi=0.0;
  Qovd_Vdi_bi_Vgm_di=0.0;
#endif
Qovd_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  Qovd_Vsi_bi_Tempt_GND=0.0;
  Qovd_Vsi_bi_Vgm_si=0.0;
  Qovd_Vsi_bi_Vdbulk_di=0.0;
  Qovd_Vsi_bi_Vsbulk_si=0.0;
  Qovd_Vsi_bi_Vgi_bi=0.0;
  Qovd_Vsi_bi_Vdi_bi=0.0;
  Qovd_Vsi_bi_Vsi_bi=0.0;
  Qovd_Vsi_bi_Vgm_di=0.0;
#endif
Qovd_Vgm_di=((((-Wact)*pInst->NF)*Cgdof)*Vgd_ov_noswap_Vgm_di);
#if defined(_DERIVATE2)
  Qovd_Vgm_di_Tempt_GND=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgdof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgd_ov_noswap+0.0*0.0+((0.0)*Cgdof)*Vgd_ov_noswap_Vgm_di+(((-Wact)*pInst->NF)*Cgdof)*0.0);
  Qovd_Vgm_di_Vgm_si=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgdof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgd_ov_noswap+0.0*0.0+((0.0)*Cgdof)*Vgd_ov_noswap_Vgm_di+(((-Wact)*pInst->NF)*Cgdof)*0.0);
  Qovd_Vgm_di_Vdbulk_di=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgdof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgd_ov_noswap+0.0*0.0+((0.0)*Cgdof)*Vgd_ov_noswap_Vgm_di+(((-Wact)*pInst->NF)*Cgdof)*0.0);
  Qovd_Vgm_di_Vsbulk_si=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgdof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgd_ov_noswap+0.0*0.0+((0.0)*Cgdof)*Vgd_ov_noswap_Vgm_di+(((-Wact)*pInst->NF)*Cgdof)*0.0);
  Qovd_Vgm_di_Vgi_bi=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgdof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgd_ov_noswap+0.0*0.0+((0.0)*Cgdof)*Vgd_ov_noswap_Vgm_di+(((-Wact)*pInst->NF)*Cgdof)*0.0);
  Qovd_Vgm_di_Vdi_bi=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgdof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgd_ov_noswap+0.0*0.0+((0.0)*Cgdof)*Vgd_ov_noswap_Vgm_di+(((-Wact)*pInst->NF)*Cgdof)*0.0);
  Qovd_Vgm_di_Vsi_bi=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgdof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgd_ov_noswap+0.0*0.0+((0.0)*Cgdof)*Vgd_ov_noswap_Vgm_di+(((-Wact)*pInst->NF)*Cgdof)*0.0);
  Qovd_Vgm_di_Vgm_di=(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*Cgdof+0.0*0.0+(0.0)*0.0+((-Wact)*pInst->NF)*0.0)*Vgd_ov_noswap+0.0*Vgd_ov_noswap_Vgm_di+((0.0)*Cgdof)*Vgd_ov_noswap_Vgm_di+(((-Wact)*pInst->NF)*Cgdof)*Vgd_ov_noswap_Vgm_di_Vgm_di);
#endif
#endif
Qovd=((((-Wact)*pInst->NF)*Cgdof)*Vgd_ov_noswap);
EXIT_IF_ISNAN(((((-Wact)*pInst->NF)*Cgdof)*Vgd_ov_noswap))
#endif
}
else
{
{
double m00_sqrt(d00_sqrt0,((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=(m20_sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgs_ov_noswap-Vfbsdr)+0.02)+Vgs_ov_noswap_Vgm_si*0.0+0.0*Vgs_ov_noswap_Vgm_si+((Vgs_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_si_Vgm_si=(m20_sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si)))+(0.0))*((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si))+d10_sqrt0*(+(+(+(+Vgs_ov_noswap_Vgm_si_Vgm_si-0.0)+0.0)*((Vgs_ov_noswap-Vfbsdr)+0.02)+Vgs_ov_noswap_Vgm_si*Vgs_ov_noswap_Vgm_si+Vgs_ov_noswap_Vgm_si*Vgs_ov_noswap_Vgm_si+((Vgs_ov_noswap-Vfbsdr)+0.02)*(+(+Vgs_ov_noswap_Vgm_si_Vgm_si-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_si_Vdbulk_di=(m20_sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgs_ov_noswap-Vfbsdr)+0.02)+Vgs_ov_noswap_Vgm_si*0.0+0.0*Vgs_ov_noswap_Vgm_si+((Vgs_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_si_Vsbulk_si=(m20_sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgs_ov_noswap-Vfbsdr)+0.02)+Vgs_ov_noswap_Vgm_si*0.0+0.0*Vgs_ov_noswap_Vgm_si+((Vgs_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_si_Vgi_bi=(m20_sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgs_ov_noswap-Vfbsdr)+0.02)+Vgs_ov_noswap_Vgm_si*0.0+0.0*Vgs_ov_noswap_Vgm_si+((Vgs_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_si_Vdi_bi=(m20_sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgs_ov_noswap-Vfbsdr)+0.02)+Vgs_ov_noswap_Vgm_si*0.0+0.0*Vgs_ov_noswap_Vgm_si+((Vgs_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_si_Vsi_bi=(m20_sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgs_ov_noswap-Vfbsdr)+0.02)+Vgs_ov_noswap_Vgm_si*0.0+0.0*Vgs_ov_noswap_Vgm_si+((Vgs_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_si_Tempt_GND=(m20_sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*(((((-Vfbsdr_Tempt_GND)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*(-Vfbsdr_Tempt_GND))))+(0.0))*((Vgs_ov_noswap_Vgm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*Vgs_ov_noswap_Vgm_si))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgs_ov_noswap-Vfbsdr)+0.02)+Vgs_ov_noswap_Vgm_si*(-Vfbsdr_Tempt_GND)+(-Vfbsdr_Tempt_GND)*Vgs_ov_noswap_Vgm_si+((Vgs_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(((-Vfbsdr_Tempt_GND)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(((Vgs_ov_noswap-Vfbsdr)+0.02)*(-Vfbsdr_Tempt_GND)))*d10_sqrt0;
#endif
#endif
T0=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(bi,GND) */
Vgsov_Vgm_si=(0.5*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si));
#if defined(_DERIVATE2)
  Vgsov_Vgm_si_Vgm_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.5*(+(+(+Vgs_ov_noswap_Vgm_si_Vgm_si-0.0)+0.0)-T0_Vgm_si_Vgm_si));
  Vgsov_Vgm_si_Tempt_GND=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Tempt_GND));
  Vgsov_Vgm_si_Vdbulk_di=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vdbulk_di));
  Vgsov_Vgm_si_Vsbulk_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vsbulk_si));
  Vgsov_Vgm_si_Vgi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vgi_bi));
  Vgsov_Vgm_si_Vdi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vdi_bi));
  Vgsov_Vgm_si_Vsi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vsi_bi));
#endif
#if defined(_DERIVATE)
Vgsov_Tempt_GND=(0.5*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND));
#endif
Vgsov_Vdbulk_di=(0.5*(-T0_Vdbulk_di));
#if defined(_DERIVATE2)
  Vgsov_Vdbulk_di_Vgm_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vgm_si));
  Vgsov_Vdbulk_di_Tempt_GND=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Tempt_GND));
  Vgsov_Vdbulk_di_Vdbulk_di=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vdbulk_di));
  Vgsov_Vdbulk_di_Vsbulk_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vsbulk_si));
  Vgsov_Vdbulk_di_Vgi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vgi_bi));
  Vgsov_Vdbulk_di_Vdi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vdi_bi));
  Vgsov_Vdbulk_di_Vsi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vsi_bi));
#endif
Vgsov_Vsbulk_si=(0.5*(-T0_Vsbulk_si));
#if defined(_DERIVATE2)
  Vgsov_Vsbulk_si_Vgm_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vgm_si));
  Vgsov_Vsbulk_si_Tempt_GND=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Tempt_GND));
  Vgsov_Vsbulk_si_Vdbulk_di=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vdbulk_di));
  Vgsov_Vsbulk_si_Vsbulk_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vsbulk_si));
  Vgsov_Vsbulk_si_Vgi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vgi_bi));
  Vgsov_Vsbulk_si_Vdi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vdi_bi));
  Vgsov_Vsbulk_si_Vsi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vsi_bi));
#endif
Vgsov_Vgi_bi=(0.5*(-T0_Vgi_bi));
#if defined(_DERIVATE2)
  Vgsov_Vgi_bi_Vgm_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vgm_si));
  Vgsov_Vgi_bi_Tempt_GND=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Tempt_GND));
  Vgsov_Vgi_bi_Vdbulk_di=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vdbulk_di));
  Vgsov_Vgi_bi_Vsbulk_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vsbulk_si));
  Vgsov_Vgi_bi_Vgi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vgi_bi));
  Vgsov_Vgi_bi_Vdi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vdi_bi));
  Vgsov_Vgi_bi_Vsi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vsi_bi));
#endif
Vgsov_Vdi_bi=(0.5*(-T0_Vdi_bi));
#if defined(_DERIVATE2)
  Vgsov_Vdi_bi_Vgm_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vgm_si));
  Vgsov_Vdi_bi_Tempt_GND=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Tempt_GND));
  Vgsov_Vdi_bi_Vdbulk_di=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vdbulk_di));
  Vgsov_Vdi_bi_Vsbulk_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vsbulk_si));
  Vgsov_Vdi_bi_Vgi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vgi_bi));
  Vgsov_Vdi_bi_Vdi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vdi_bi));
  Vgsov_Vdi_bi_Vsi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vsi_bi));
#endif
Vgsov_Vsi_bi=(0.5*(-T0_Vsi_bi));
#if defined(_DERIVATE2)
  Vgsov_Vsi_bi_Vgm_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgs_ov_noswap_Vgm_si-T0_Vgm_si)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vgm_si));
  Vgsov_Vsi_bi_Tempt_GND=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Tempt_GND));
  Vgsov_Vsi_bi_Vdbulk_di=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vdbulk_di));
  Vgsov_Vsi_bi_Vsbulk_si=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vsbulk_si));
  Vgsov_Vsi_bi_Vgi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vgi_bi));
  Vgsov_Vsi_bi_Vdi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vdi_bi));
  Vgsov_Vsi_bi_Vsi_bi=(+0.0*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vsi_bi));
#endif
#endif
Vgsov=(0.5*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0));
EXIT_IF_ISNAN((0.5*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0)))
{
double m00_sqrt(d00_sqrt0,(1.0-((4.0*Vgsov)/CKAPPAS_i)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0-((4.0*Vgsov)/CKAPPAS_i)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=(-((4.0*Vgsov_Vgm_si)/CKAPPAS_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-((0.0)/CKAPPAS_i))*(-((4.0*Vgsov_Vgm_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*0.0+0.0*Vgsov_Vgm_si+4.0*0.0)/CKAPPAS_i-((4.0*Vgsov_Vgm_si)*0.0+(0.0)*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgm_si_Vgm_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgm_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vgm_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgm_si+0.0*Vgsov_Vgm_si+4.0*Vgsov_Vgm_si_Vgm_si)/CKAPPAS_i-((4.0*Vgsov_Vgm_si)*0.0+((4.0*Vgsov_Vgm_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgm_si_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdbulk_di))/CKAPPAS_i))*(-((4.0*Vgsov_Vgm_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdbulk_di+0.0*Vgsov_Vgm_si+4.0*Vgsov_Vgm_si_Vdbulk_di)/CKAPPAS_i-((4.0*Vgsov_Vgm_si)*0.0+((4.0*Vgsov_Vdbulk_di))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgm_si_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsbulk_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vgm_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsbulk_si+0.0*Vgsov_Vgm_si+4.0*Vgsov_Vgm_si_Vsbulk_si)/CKAPPAS_i-((4.0*Vgsov_Vgm_si)*0.0+((4.0*Vgsov_Vsbulk_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgm_si_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vgm_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgi_bi+0.0*Vgsov_Vgm_si+4.0*Vgsov_Vgm_si_Vgi_bi)/CKAPPAS_i-((4.0*Vgsov_Vgm_si)*0.0+((4.0*Vgsov_Vgi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgm_si_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vgm_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdi_bi+0.0*Vgsov_Vgm_si+4.0*Vgsov_Vgm_si_Vdi_bi)/CKAPPAS_i-((4.0*Vgsov_Vgm_si)*0.0+((4.0*Vgsov_Vdi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgm_si_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vgm_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsi_bi+0.0*Vgsov_Vgm_si+4.0*Vgsov_Vgm_si_Vsi_bi)/CKAPPAS_i-((4.0*Vgsov_Vgm_si)*0.0+((4.0*Vgsov_Vsi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgm_si_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Tempt_GND))/CKAPPAS_i))*(-((4.0*Vgsov_Vgm_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Tempt_GND+0.0*Vgsov_Vgm_si+4.0*Vgsov_Vgm_si_Tempt_GND)/CKAPPAS_i-((4.0*Vgsov_Vgm_si)*0.0+((4.0*Vgsov_Tempt_GND))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
#endif
T1_Vdbulk_di=(-((4.0*Vgsov_Vdbulk_di)/CKAPPAS_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-((0.0)/CKAPPAS_i))*(-((4.0*Vgsov_Vdbulk_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*0.0+0.0*Vgsov_Vdbulk_di+4.0*0.0)/CKAPPAS_i-((4.0*Vgsov_Vdbulk_di)*0.0+(0.0)*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdbulk_di_Vgm_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgm_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vdbulk_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgm_si+0.0*Vgsov_Vdbulk_di+4.0*Vgsov_Vdbulk_di_Vgm_si)/CKAPPAS_i-((4.0*Vgsov_Vdbulk_di)*0.0+((4.0*Vgsov_Vgm_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdbulk_di_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdbulk_di))/CKAPPAS_i))*(-((4.0*Vgsov_Vdbulk_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdbulk_di+0.0*Vgsov_Vdbulk_di+4.0*Vgsov_Vdbulk_di_Vdbulk_di)/CKAPPAS_i-((4.0*Vgsov_Vdbulk_di)*0.0+((4.0*Vgsov_Vdbulk_di))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdbulk_di_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsbulk_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vdbulk_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsbulk_si+0.0*Vgsov_Vdbulk_di+4.0*Vgsov_Vdbulk_di_Vsbulk_si)/CKAPPAS_i-((4.0*Vgsov_Vdbulk_di)*0.0+((4.0*Vgsov_Vsbulk_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdbulk_di_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vdbulk_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgi_bi+0.0*Vgsov_Vdbulk_di+4.0*Vgsov_Vdbulk_di_Vgi_bi)/CKAPPAS_i-((4.0*Vgsov_Vdbulk_di)*0.0+((4.0*Vgsov_Vgi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdbulk_di_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vdbulk_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdi_bi+0.0*Vgsov_Vdbulk_di+4.0*Vgsov_Vdbulk_di_Vdi_bi)/CKAPPAS_i-((4.0*Vgsov_Vdbulk_di)*0.0+((4.0*Vgsov_Vdi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdbulk_di_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vdbulk_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsi_bi+0.0*Vgsov_Vdbulk_di+4.0*Vgsov_Vdbulk_di_Vsi_bi)/CKAPPAS_i-((4.0*Vgsov_Vdbulk_di)*0.0+((4.0*Vgsov_Vsi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdbulk_di_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Tempt_GND))/CKAPPAS_i))*(-((4.0*Vgsov_Vdbulk_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Tempt_GND+0.0*Vgsov_Vdbulk_di+4.0*Vgsov_Vdbulk_di_Tempt_GND)/CKAPPAS_i-((4.0*Vgsov_Vdbulk_di)*0.0+((4.0*Vgsov_Tempt_GND))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
#endif
T1_Vsbulk_si=(-((4.0*Vgsov_Vsbulk_si)/CKAPPAS_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-((0.0)/CKAPPAS_i))*(-((4.0*Vgsov_Vsbulk_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*0.0+0.0*Vgsov_Vsbulk_si+4.0*0.0)/CKAPPAS_i-((4.0*Vgsov_Vsbulk_si)*0.0+(0.0)*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsbulk_si_Vgm_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgm_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vsbulk_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgm_si+0.0*Vgsov_Vsbulk_si+4.0*Vgsov_Vsbulk_si_Vgm_si)/CKAPPAS_i-((4.0*Vgsov_Vsbulk_si)*0.0+((4.0*Vgsov_Vgm_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsbulk_si_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdbulk_di))/CKAPPAS_i))*(-((4.0*Vgsov_Vsbulk_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdbulk_di+0.0*Vgsov_Vsbulk_si+4.0*Vgsov_Vsbulk_si_Vdbulk_di)/CKAPPAS_i-((4.0*Vgsov_Vsbulk_si)*0.0+((4.0*Vgsov_Vdbulk_di))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsbulk_si_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsbulk_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vsbulk_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsbulk_si+0.0*Vgsov_Vsbulk_si+4.0*Vgsov_Vsbulk_si_Vsbulk_si)/CKAPPAS_i-((4.0*Vgsov_Vsbulk_si)*0.0+((4.0*Vgsov_Vsbulk_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsbulk_si_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vsbulk_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgi_bi+0.0*Vgsov_Vsbulk_si+4.0*Vgsov_Vsbulk_si_Vgi_bi)/CKAPPAS_i-((4.0*Vgsov_Vsbulk_si)*0.0+((4.0*Vgsov_Vgi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsbulk_si_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vsbulk_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdi_bi+0.0*Vgsov_Vsbulk_si+4.0*Vgsov_Vsbulk_si_Vdi_bi)/CKAPPAS_i-((4.0*Vgsov_Vsbulk_si)*0.0+((4.0*Vgsov_Vdi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsbulk_si_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vsbulk_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsi_bi+0.0*Vgsov_Vsbulk_si+4.0*Vgsov_Vsbulk_si_Vsi_bi)/CKAPPAS_i-((4.0*Vgsov_Vsbulk_si)*0.0+((4.0*Vgsov_Vsi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsbulk_si_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Tempt_GND))/CKAPPAS_i))*(-((4.0*Vgsov_Vsbulk_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Tempt_GND+0.0*Vgsov_Vsbulk_si+4.0*Vgsov_Vsbulk_si_Tempt_GND)/CKAPPAS_i-((4.0*Vgsov_Vsbulk_si)*0.0+((4.0*Vgsov_Tempt_GND))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
#endif
T1_Vgi_bi=(-((4.0*Vgsov_Vgi_bi)/CKAPPAS_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-((0.0)/CKAPPAS_i))*(-((4.0*Vgsov_Vgi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*0.0+0.0*Vgsov_Vgi_bi+4.0*0.0)/CKAPPAS_i-((4.0*Vgsov_Vgi_bi)*0.0+(0.0)*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgi_bi_Vgm_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgm_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vgi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgm_si+0.0*Vgsov_Vgi_bi+4.0*Vgsov_Vgi_bi_Vgm_si)/CKAPPAS_i-((4.0*Vgsov_Vgi_bi)*0.0+((4.0*Vgsov_Vgm_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgi_bi_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdbulk_di))/CKAPPAS_i))*(-((4.0*Vgsov_Vgi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdbulk_di+0.0*Vgsov_Vgi_bi+4.0*Vgsov_Vgi_bi_Vdbulk_di)/CKAPPAS_i-((4.0*Vgsov_Vgi_bi)*0.0+((4.0*Vgsov_Vdbulk_di))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgi_bi_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsbulk_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vgi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsbulk_si+0.0*Vgsov_Vgi_bi+4.0*Vgsov_Vgi_bi_Vsbulk_si)/CKAPPAS_i-((4.0*Vgsov_Vgi_bi)*0.0+((4.0*Vgsov_Vsbulk_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgi_bi_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vgi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgi_bi+0.0*Vgsov_Vgi_bi+4.0*Vgsov_Vgi_bi_Vgi_bi)/CKAPPAS_i-((4.0*Vgsov_Vgi_bi)*0.0+((4.0*Vgsov_Vgi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgi_bi_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vgi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdi_bi+0.0*Vgsov_Vgi_bi+4.0*Vgsov_Vgi_bi_Vdi_bi)/CKAPPAS_i-((4.0*Vgsov_Vgi_bi)*0.0+((4.0*Vgsov_Vdi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgi_bi_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vgi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsi_bi+0.0*Vgsov_Vgi_bi+4.0*Vgsov_Vgi_bi_Vsi_bi)/CKAPPAS_i-((4.0*Vgsov_Vgi_bi)*0.0+((4.0*Vgsov_Vsi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vgi_bi_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Tempt_GND))/CKAPPAS_i))*(-((4.0*Vgsov_Vgi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Tempt_GND+0.0*Vgsov_Vgi_bi+4.0*Vgsov_Vgi_bi_Tempt_GND)/CKAPPAS_i-((4.0*Vgsov_Vgi_bi)*0.0+((4.0*Vgsov_Tempt_GND))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
#endif
T1_Vdi_bi=(-((4.0*Vgsov_Vdi_bi)/CKAPPAS_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-((0.0)/CKAPPAS_i))*(-((4.0*Vgsov_Vdi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*0.0+0.0*Vgsov_Vdi_bi+4.0*0.0)/CKAPPAS_i-((4.0*Vgsov_Vdi_bi)*0.0+(0.0)*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdi_bi_Vgm_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgm_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vdi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgm_si+0.0*Vgsov_Vdi_bi+4.0*Vgsov_Vdi_bi_Vgm_si)/CKAPPAS_i-((4.0*Vgsov_Vdi_bi)*0.0+((4.0*Vgsov_Vgm_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdi_bi_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdbulk_di))/CKAPPAS_i))*(-((4.0*Vgsov_Vdi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdbulk_di+0.0*Vgsov_Vdi_bi+4.0*Vgsov_Vdi_bi_Vdbulk_di)/CKAPPAS_i-((4.0*Vgsov_Vdi_bi)*0.0+((4.0*Vgsov_Vdbulk_di))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdi_bi_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsbulk_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vdi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsbulk_si+0.0*Vgsov_Vdi_bi+4.0*Vgsov_Vdi_bi_Vsbulk_si)/CKAPPAS_i-((4.0*Vgsov_Vdi_bi)*0.0+((4.0*Vgsov_Vsbulk_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdi_bi_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vdi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgi_bi+0.0*Vgsov_Vdi_bi+4.0*Vgsov_Vdi_bi_Vgi_bi)/CKAPPAS_i-((4.0*Vgsov_Vdi_bi)*0.0+((4.0*Vgsov_Vgi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdi_bi_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vdi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdi_bi+0.0*Vgsov_Vdi_bi+4.0*Vgsov_Vdi_bi_Vdi_bi)/CKAPPAS_i-((4.0*Vgsov_Vdi_bi)*0.0+((4.0*Vgsov_Vdi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdi_bi_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vdi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsi_bi+0.0*Vgsov_Vdi_bi+4.0*Vgsov_Vdi_bi_Vsi_bi)/CKAPPAS_i-((4.0*Vgsov_Vdi_bi)*0.0+((4.0*Vgsov_Vsi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vdi_bi_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Tempt_GND))/CKAPPAS_i))*(-((4.0*Vgsov_Vdi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Tempt_GND+0.0*Vgsov_Vdi_bi+4.0*Vgsov_Vdi_bi_Tempt_GND)/CKAPPAS_i-((4.0*Vgsov_Vdi_bi)*0.0+((4.0*Vgsov_Tempt_GND))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
#endif
T1_Vsi_bi=(-((4.0*Vgsov_Vsi_bi)/CKAPPAS_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-((0.0)/CKAPPAS_i))*(-((4.0*Vgsov_Vsi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*0.0+0.0*Vgsov_Vsi_bi+4.0*0.0)/CKAPPAS_i-((4.0*Vgsov_Vsi_bi)*0.0+(0.0)*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsi_bi_Vgm_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgm_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vsi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgm_si+0.0*Vgsov_Vsi_bi+4.0*Vgsov_Vsi_bi_Vgm_si)/CKAPPAS_i-((4.0*Vgsov_Vsi_bi)*0.0+((4.0*Vgsov_Vgm_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsi_bi_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdbulk_di))/CKAPPAS_i))*(-((4.0*Vgsov_Vsi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdbulk_di+0.0*Vgsov_Vsi_bi+4.0*Vgsov_Vsi_bi_Vdbulk_di)/CKAPPAS_i-((4.0*Vgsov_Vsi_bi)*0.0+((4.0*Vgsov_Vdbulk_di))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsi_bi_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsbulk_si))/CKAPPAS_i))*(-((4.0*Vgsov_Vsi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsbulk_si+0.0*Vgsov_Vsi_bi+4.0*Vgsov_Vsi_bi_Vsbulk_si)/CKAPPAS_i-((4.0*Vgsov_Vsi_bi)*0.0+((4.0*Vgsov_Vsbulk_si))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsi_bi_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vgi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vsi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vgi_bi+0.0*Vgsov_Vsi_bi+4.0*Vgsov_Vsi_bi_Vgi_bi)/CKAPPAS_i-((4.0*Vgsov_Vsi_bi)*0.0+((4.0*Vgsov_Vgi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsi_bi_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vdi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vsi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vdi_bi+0.0*Vgsov_Vsi_bi+4.0*Vgsov_Vsi_bi_Vdi_bi)/CKAPPAS_i-((4.0*Vgsov_Vsi_bi)*0.0+((4.0*Vgsov_Vdi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsi_bi_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Vsi_bi))/CKAPPAS_i))*(-((4.0*Vgsov_Vsi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Vsi_bi+0.0*Vgsov_Vsi_bi+4.0*Vgsov_Vsi_bi_Vsi_bi)/CKAPPAS_i-((4.0*Vgsov_Vsi_bi)*0.0+((4.0*Vgsov_Vsi_bi))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
  T1_Vsi_bi_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)))*(-(((4.0*Vgsov_Tempt_GND))/CKAPPAS_i))*(-((4.0*Vgsov_Vsi_bi)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*Vgsov+0.0*Vgsov_Tempt_GND+0.0*Vgsov_Vsi_bi+4.0*Vgsov_Vsi_bi_Tempt_GND)/CKAPPAS_i-((4.0*Vgsov_Vsi_bi)*0.0+((4.0*Vgsov_Tempt_GND))*0.0+(4.0*Vgsov)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*Vgsov)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(-((4.0*Vgsov_Tempt_GND)/CKAPPAS_i))*d10_sqrt0;
#endif
#endif
T1=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)V(gm,si) ddxprobe=V(bi,GND)V(si,GND)V(di,GND)V(sbulk,GND)V(gm,GND) */
#if defined(_DERIVATE)
Qovs_Tempt_GND=(((-Wact)*pInst->NF)*(CGSL_i*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((0.5*CKAPPAS_i)*T1_Tempt_GND))));
#endif
Qovs_Vdbulk_di=(((-Wact)*pInst->NF)*(CGSL_i*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di))));
#if defined(_DERIVATE2)
  Qovs_Vdbulk_di_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND))))+0.0*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdbulk_di_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Tempt_GND+(0.0)*T1_Vdbulk_di+(0.5*CKAPPAS_i)*(+0.0+T1_Vdbulk_di_Tempt_GND))))));
  Qovs_Vdbulk_di_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di))))+0.0*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdbulk_di_Vdbulk_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdbulk_di+(0.5*CKAPPAS_i)*(+0.0+T1_Vdbulk_di_Vdbulk_di))))));
  Qovs_Vdbulk_di_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si))))+0.0*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdbulk_di_Vsbulk_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdbulk_di+(0.5*CKAPPAS_i)*(+0.0+T1_Vdbulk_di_Vsbulk_si))))));
  Qovs_Vdbulk_di_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi))))+0.0*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdbulk_di_Vgi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgi_bi+(0.0)*T1_Vdbulk_di+(0.5*CKAPPAS_i)*(+0.0+T1_Vdbulk_di_Vgi_bi))))));
  Qovs_Vdbulk_di_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi))))+0.0*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdbulk_di_Vdi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdi_bi+(0.0)*T1_Vdbulk_di+(0.5*CKAPPAS_i)*(+0.0+T1_Vdbulk_di_Vdi_bi))))));
  Qovs_Vdbulk_di_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi))))+0.0*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdbulk_di_Vsi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsi_bi+(0.0)*T1_Vdbulk_di+(0.5*CKAPPAS_i)*(+0.0+T1_Vdbulk_di_Vsi_bi))))));
  Qovs_Vdbulk_di_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*(((Cgsof*Vgs_ov_noswap_Vgm_si))+((CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*Vgs_ov_noswap_Vgm_si+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si))))+0.0*((-Vgsov_Vdbulk_di)-((0.5*CKAPPAS_i)*T1_Vdbulk_di))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdbulk_di_Vgm_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgm_si+(0.0)*T1_Vdbulk_di+(0.5*CKAPPAS_i)*(+0.0+T1_Vdbulk_di_Vgm_si))))));
#endif
Qovs_Vsbulk_si=(((-Wact)*pInst->NF)*(CGSL_i*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si))));
#if defined(_DERIVATE2)
  Qovs_Vsbulk_si_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND))))+0.0*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsbulk_si_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Tempt_GND+(0.0)*T1_Vsbulk_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vsbulk_si_Tempt_GND))))));
  Qovs_Vsbulk_si_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di))))+0.0*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsbulk_si_Vdbulk_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsbulk_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vsbulk_si_Vdbulk_di))))));
  Qovs_Vsbulk_si_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si))))+0.0*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsbulk_si_Vsbulk_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsbulk_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vsbulk_si_Vsbulk_si))))));
  Qovs_Vsbulk_si_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi))))+0.0*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsbulk_si_Vgi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgi_bi+(0.0)*T1_Vsbulk_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vsbulk_si_Vgi_bi))))));
  Qovs_Vsbulk_si_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi))))+0.0*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsbulk_si_Vdi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdi_bi+(0.0)*T1_Vsbulk_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vsbulk_si_Vdi_bi))))));
  Qovs_Vsbulk_si_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi))))+0.0*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsbulk_si_Vsi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsi_bi+(0.0)*T1_Vsbulk_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vsbulk_si_Vsi_bi))))));
  Qovs_Vsbulk_si_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*(((Cgsof*Vgs_ov_noswap_Vgm_si))+((CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*Vgs_ov_noswap_Vgm_si+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si))))+0.0*((-Vgsov_Vsbulk_si)-((0.5*CKAPPAS_i)*T1_Vsbulk_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsbulk_si_Vgm_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgm_si+(0.0)*T1_Vsbulk_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vsbulk_si_Vgm_si))))));
#endif
Qovs_Vgi_bi=(((-Wact)*pInst->NF)*(CGSL_i*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi))));
#if defined(_DERIVATE2)
  Qovs_Vgi_bi_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND)))))))+(0.0)*(CGSL_i*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND))))+0.0*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgi_bi_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Tempt_GND+(0.0)*T1_Vgi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vgi_bi_Tempt_GND))))));
  Qovs_Vgi_bi_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di)))))))+(0.0)*(CGSL_i*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di))))+0.0*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgi_bi_Vdbulk_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdbulk_di+(0.0)*T1_Vgi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vgi_bi_Vdbulk_di))))));
  Qovs_Vgi_bi_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si))))+0.0*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgi_bi_Vsbulk_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsbulk_si+(0.0)*T1_Vgi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vgi_bi_Vsbulk_si))))));
  Qovs_Vgi_bi_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi))))+0.0*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgi_bi_Vgi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgi_bi+(0.0)*T1_Vgi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vgi_bi_Vgi_bi))))));
  Qovs_Vgi_bi_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi))))+0.0*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgi_bi_Vdi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdi_bi+(0.0)*T1_Vgi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vgi_bi_Vdi_bi))))));
  Qovs_Vgi_bi_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi))))+0.0*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgi_bi_Vsi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsi_bi+(0.0)*T1_Vgi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vgi_bi_Vsi_bi))))));
  Qovs_Vgi_bi_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*(((Cgsof*Vgs_ov_noswap_Vgm_si))+((CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*Vgs_ov_noswap_Vgm_si+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si))))+0.0*((-Vgsov_Vgi_bi)-((0.5*CKAPPAS_i)*T1_Vgi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgi_bi_Vgm_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgm_si+(0.0)*T1_Vgi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vgi_bi_Vgm_si))))));
#endif
Qovs_Vdi_bi=(((-Wact)*pInst->NF)*(CGSL_i*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi))));
#if defined(_DERIVATE2)
  Qovs_Vdi_bi_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND))))+0.0*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdi_bi_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vdi_bi_Tempt_GND))))));
  Qovs_Vdi_bi_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di))))+0.0*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdi_bi_Vdbulk_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdbulk_di+(0.0)*T1_Vdi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vdi_bi_Vdbulk_di))))));
  Qovs_Vdi_bi_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si))))+0.0*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdi_bi_Vsbulk_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsbulk_si+(0.0)*T1_Vdi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vdi_bi_Vsbulk_si))))));
  Qovs_Vdi_bi_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi))))+0.0*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdi_bi_Vgi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgi_bi+(0.0)*T1_Vdi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vdi_bi_Vgi_bi))))));
  Qovs_Vdi_bi_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi))))+0.0*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdi_bi_Vdi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdi_bi+(0.0)*T1_Vdi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vdi_bi_Vdi_bi))))));
  Qovs_Vdi_bi_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi))))+0.0*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdi_bi_Vsi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsi_bi+(0.0)*T1_Vdi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vdi_bi_Vsi_bi))))));
  Qovs_Vdi_bi_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*(((Cgsof*Vgs_ov_noswap_Vgm_si))+((CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*Vgs_ov_noswap_Vgm_si+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si))))+0.0*((-Vgsov_Vdi_bi)-((0.5*CKAPPAS_i)*T1_Vdi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vdi_bi_Vgm_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgm_si+(0.0)*T1_Vdi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vdi_bi_Vgm_si))))));
#endif
Qovs_Vsi_bi=(((-Wact)*pInst->NF)*(CGSL_i*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi))));
#if defined(_DERIVATE2)
  Qovs_Vsi_bi_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND))))+0.0*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsi_bi_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vsi_bi_Tempt_GND))))));
  Qovs_Vsi_bi_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di))))+0.0*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsi_bi_Vdbulk_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdbulk_di+(0.0)*T1_Vsi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vsi_bi_Vdbulk_di))))));
  Qovs_Vsi_bi_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si))))+0.0*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsi_bi_Vsbulk_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsbulk_si+(0.0)*T1_Vsi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vsi_bi_Vsbulk_si))))));
  Qovs_Vsi_bi_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi))))+0.0*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsi_bi_Vgi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgi_bi+(0.0)*T1_Vsi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vsi_bi_Vgi_bi))))));
  Qovs_Vsi_bi_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi))))+0.0*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsi_bi_Vdi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdi_bi+(0.0)*T1_Vsi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vsi_bi_Vdi_bi))))));
  Qovs_Vsi_bi_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi))))+0.0*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsi_bi_Vsi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsi_bi+(0.0)*T1_Vsi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vsi_bi_Vsi_bi))))));
  Qovs_Vsi_bi_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*(((Cgsof*Vgs_ov_noswap_Vgm_si))+((CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si)))))))+(0.0)*(CGSL_i*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*Vgs_ov_noswap_Vgm_si+0.0*0.0+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si))))+0.0*((-Vgsov_Vsi_bi)-((0.5*CKAPPAS_i)*T1_Vsi_bi))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vsi_bi_Vgm_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgm_si+(0.0)*T1_Vsi_bi+(0.5*CKAPPAS_i)*(+0.0+T1_Vsi_bi_Vgm_si))))));
#endif
Qovs_Vgm_si=(((-Wact)*pInst->NF)*((Cgsof*Vgs_ov_noswap_Vgm_si)+(CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si)))));
#if defined(_DERIVATE2)
  Qovs_Vgm_si_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND)))))))+(0.0)*((Cgsof*Vgs_ov_noswap_Vgm_si)+(CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*Vgs_ov_noswap_Vgm_si+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgsov_Tempt_GND)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Tempt_GND))))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgm_si_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Tempt_GND+(0.0)*T1_Vgm_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vgm_si_Tempt_GND))))));
  Qovs_Vgm_si_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di)))))))+(0.0)*((Cgsof*Vgs_ov_noswap_Vgm_si)+(CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*Vgs_ov_noswap_Vgm_si+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdbulk_di)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdbulk_di))))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgm_si_Vdbulk_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdbulk_di+(0.0)*T1_Vgm_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vgm_si_Vdbulk_di))))));
  Qovs_Vgm_si_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si)))))))+(0.0)*((Cgsof*Vgs_ov_noswap_Vgm_si)+(CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*Vgs_ov_noswap_Vgm_si+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsbulk_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsbulk_si))))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgm_si_Vsbulk_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsbulk_si+(0.0)*T1_Vgm_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vgm_si_Vsbulk_si))))));
  Qovs_Vgm_si_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi)))))))+(0.0)*((Cgsof*Vgs_ov_noswap_Vgm_si)+(CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*Vgs_ov_noswap_Vgm_si+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vgi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgi_bi))))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgm_si_Vgi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgi_bi+(0.0)*T1_Vgm_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vgm_si_Vgi_bi))))));
  Qovs_Vgm_si_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi)))))))+(0.0)*((Cgsof*Vgs_ov_noswap_Vgm_si)+(CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*Vgs_ov_noswap_Vgm_si+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vdi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vdi_bi))))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgm_si_Vdi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vdi_bi+(0.0)*T1_Vgm_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vgm_si_Vdi_bi))))));
  Qovs_Vgm_si_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*((0.0)+((CGSL_i*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi)))))))+(0.0)*((Cgsof*Vgs_ov_noswap_Vgm_si)+(CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*0.0+0.0*Vgs_ov_noswap_Vgm_si+Cgsof*0.0)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((-Vgsov_Vsi_bi)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vsi_bi))))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))+CGSL_i*(+(+(+0.0-0.0)-Vgsov_Vgm_si_Vsi_bi)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vsi_bi+(0.0)*T1_Vgm_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vgm_si_Vsi_bi))))));
  Qovs_Vgm_si_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))+0.0*(((Cgsof*Vgs_ov_noswap_Vgm_si))+((CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si)))))))+(0.0)*((Cgsof*Vgs_ov_noswap_Vgm_si)+(CGSL_i*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))))+((-Wact)*pInst->NF)*(+(+0.0*Vgs_ov_noswap+0.0*Vgs_ov_noswap_Vgm_si+0.0*Vgs_ov_noswap_Vgm_si+Cgsof*Vgs_ov_noswap_Vgm_si_Vgm_si)+(+0.0*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((((0.0)*((-1.0)+T1))+((0.5*CKAPPAS_i)*T1_Vgm_si))))+0.0*((Vgs_ov_noswap_Vgm_si-Vgsov_Vgm_si)-((0.5*CKAPPAS_i)*T1_Vgm_si))+CGSL_i*(+(+(+Vgs_ov_noswap_Vgm_si_Vgm_si-0.0)-Vgsov_Vgm_si_Vgm_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T1)+0.0*T1_Vgm_si+(0.0)*T1_Vgm_si+(0.5*CKAPPAS_i)*(+0.0+T1_Vgm_si_Vgm_si))))));
#endif
#endif
Qovs=(((-Wact)*pInst->NF)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1))))));
EXIT_IF_ISNAN((((-Wact)*pInst->NF)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1)))))))
#endif
{
double m00_sqrt(d00_sqrt0,((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=(m20_sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di)))+(0.0))*((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di))+d10_sqrt0*(+(+(+(+Vgd_ov_noswap_Vgm_di_Vgm_di-0.0)+0.0)*((Vgd_ov_noswap-Vfbsdr)+0.02)+Vgd_ov_noswap_Vgm_di*Vgd_ov_noswap_Vgm_di+Vgd_ov_noswap_Vgm_di*Vgd_ov_noswap_Vgm_di+((Vgd_ov_noswap-Vfbsdr)+0.02)*(+(+Vgd_ov_noswap_Vgm_di_Vgm_di-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_di_Vgm_si=(m20_sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgd_ov_noswap-Vfbsdr)+0.02)+Vgd_ov_noswap_Vgm_di*0.0+0.0*Vgd_ov_noswap_Vgm_di+((Vgd_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_di_Vdbulk_di=(m20_sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgd_ov_noswap-Vfbsdr)+0.02)+Vgd_ov_noswap_Vgm_di*0.0+0.0*Vgd_ov_noswap_Vgm_di+((Vgd_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_di_Vsbulk_si=(m20_sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgd_ov_noswap-Vfbsdr)+0.02)+Vgd_ov_noswap_Vgm_di*0.0+0.0*Vgd_ov_noswap_Vgm_di+((Vgd_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_di_Vgi_bi=(m20_sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgd_ov_noswap-Vfbsdr)+0.02)+Vgd_ov_noswap_Vgm_di*0.0+0.0*Vgd_ov_noswap_Vgm_di+((Vgd_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_di_Vdi_bi=(m20_sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgd_ov_noswap-Vfbsdr)+0.02)+Vgd_ov_noswap_Vgm_di*0.0+0.0*Vgd_ov_noswap_Vgm_di+((Vgd_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_di_Vsi_bi=(m20_sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*((0.0)+(0.0))*((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgd_ov_noswap-Vfbsdr)+0.02)+Vgd_ov_noswap_Vgm_di*0.0+0.0*Vgd_ov_noswap_Vgm_di+((Vgd_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
  T0_Vgm_di_Tempt_GND=(m20_sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)))*(((((-Vfbsdr_Tempt_GND)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*(-Vfbsdr_Tempt_GND))))+(0.0))*((Vgd_ov_noswap_Vgm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*Vgd_ov_noswap_Vgm_di))+d10_sqrt0*(+(+(+(+0.0-0.0)+0.0)*((Vgd_ov_noswap-Vfbsdr)+0.02)+Vgd_ov_noswap_Vgm_di*(-Vfbsdr_Tempt_GND)+(-Vfbsdr_Tempt_GND)*Vgd_ov_noswap_Vgm_di+((Vgd_ov_noswap-Vfbsdr)+0.02)*(+(+0.0-0.0)+0.0))+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)));
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=0.0;
  T0_Vdi_bi_Vgm_si=0.0;
  T0_Vdi_bi_Vdbulk_di=0.0;
  T0_Vdi_bi_Vsbulk_si=0.0;
  T0_Vdi_bi_Vgi_bi=0.0;
  T0_Vdi_bi_Vdi_bi=0.0;
  T0_Vdi_bi_Vsi_bi=0.0;
  T0_Vdi_bi_Tempt_GND=0.0;
#endif
T0_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=0.0;
  T0_Vsi_bi_Vgm_si=0.0;
  T0_Vsi_bi_Vdbulk_di=0.0;
  T0_Vsi_bi_Vsbulk_si=0.0;
  T0_Vsi_bi_Vgi_bi=0.0;
  T0_Vsi_bi_Vdi_bi=0.0;
  T0_Vsi_bi_Vsi_bi=0.0;
  T0_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(((-Vfbsdr_Tempt_GND)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(((Vgd_ov_noswap-Vfbsdr)+0.02)*(-Vfbsdr_Tempt_GND)))*d10_sqrt0;
#endif
#endif
T0=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)Temp(t,GND)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(gi,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(si,GND)V(bi,GND) */
Vgdov_Vgm_di=(0.5*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di));
#if defined(_DERIVATE2)
  Vgdov_Vgm_di_Vgm_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.5*(+(+(+Vgd_ov_noswap_Vgm_di_Vgm_di-0.0)+0.0)-T0_Vgm_di_Vgm_di));
  Vgdov_Vgm_di_Tempt_GND=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_di_Tempt_GND));
  Vgdov_Vgm_di_Vgm_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgm_si)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_di_Vgm_si));
  Vgdov_Vgm_di_Vdbulk_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_di_Vdbulk_di));
  Vgdov_Vgm_di_Vsbulk_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_di_Vsbulk_si));
  Vgdov_Vgm_di_Vgi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_di_Vgi_bi));
  Vgdov_Vgm_di_Vdi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_di_Vdi_bi));
  Vgdov_Vgm_di_Vsi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_di_Vsi_bi));
#endif
#if defined(_DERIVATE)
Vgdov_Tempt_GND=(0.5*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND));
#endif
Vgdov_Vgm_si=(0.5*(-T0_Vgm_si));
#if defined(_DERIVATE2)
  Vgdov_Vgm_si_Vgm_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.0*(-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vgm_di));
  Vgdov_Vgm_si_Tempt_GND=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Tempt_GND));
  Vgdov_Vgm_si_Vgm_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgm_si)+0.0*(-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vgm_si));
  Vgdov_Vgm_si_Vdbulk_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vdbulk_di));
  Vgdov_Vgm_si_Vsbulk_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vsbulk_si));
  Vgdov_Vgm_si_Vgi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vgi_bi));
  Vgdov_Vgm_si_Vdi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vdi_bi));
  Vgdov_Vgm_si_Vsi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vgm_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgm_si_Vsi_bi));
#endif
Vgdov_Vdbulk_di=(0.5*(-T0_Vdbulk_di));
#if defined(_DERIVATE2)
  Vgdov_Vdbulk_di_Vgm_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vgm_di));
  Vgdov_Vdbulk_di_Tempt_GND=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Tempt_GND));
  Vgdov_Vdbulk_di_Vgm_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgm_si)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vgm_si));
  Vgdov_Vdbulk_di_Vdbulk_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vdbulk_di));
  Vgdov_Vdbulk_di_Vsbulk_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vsbulk_si));
  Vgdov_Vdbulk_di_Vgi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vgi_bi));
  Vgdov_Vdbulk_di_Vdi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vdi_bi));
  Vgdov_Vdbulk_di_Vsi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vdbulk_di)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdbulk_di_Vsi_bi));
#endif
Vgdov_Vsbulk_si=(0.5*(-T0_Vsbulk_si));
#if defined(_DERIVATE2)
  Vgdov_Vsbulk_si_Vgm_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vgm_di));
  Vgdov_Vsbulk_si_Tempt_GND=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Tempt_GND));
  Vgdov_Vsbulk_si_Vgm_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgm_si)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vgm_si));
  Vgdov_Vsbulk_si_Vdbulk_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vdbulk_di));
  Vgdov_Vsbulk_si_Vsbulk_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vsbulk_si));
  Vgdov_Vsbulk_si_Vgi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vgi_bi));
  Vgdov_Vsbulk_si_Vdi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vdi_bi));
  Vgdov_Vsbulk_si_Vsi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vsbulk_si)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsbulk_si_Vsi_bi));
#endif
Vgdov_Vgi_bi=(0.5*(-T0_Vgi_bi));
#if defined(_DERIVATE2)
  Vgdov_Vgi_bi_Vgm_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vgm_di));
  Vgdov_Vgi_bi_Tempt_GND=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Tempt_GND));
  Vgdov_Vgi_bi_Vgm_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgm_si)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vgm_si));
  Vgdov_Vgi_bi_Vdbulk_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vdbulk_di));
  Vgdov_Vgi_bi_Vsbulk_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vsbulk_si));
  Vgdov_Vgi_bi_Vgi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vgi_bi));
  Vgdov_Vgi_bi_Vdi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vdi_bi));
  Vgdov_Vgi_bi_Vsi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vgi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vgi_bi_Vsi_bi));
#endif
Vgdov_Vdi_bi=(0.5*(-T0_Vdi_bi));
#if defined(_DERIVATE2)
  Vgdov_Vdi_bi_Vgm_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vgm_di));
  Vgdov_Vdi_bi_Tempt_GND=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Tempt_GND));
  Vgdov_Vdi_bi_Vgm_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgm_si)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vgm_si));
  Vgdov_Vdi_bi_Vdbulk_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vdbulk_di));
  Vgdov_Vdi_bi_Vsbulk_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vsbulk_si));
  Vgdov_Vdi_bi_Vgi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vgi_bi));
  Vgdov_Vdi_bi_Vdi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vdi_bi));
  Vgdov_Vdi_bi_Vsi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vdi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vdi_bi_Vsi_bi));
#endif
Vgdov_Vsi_bi=(0.5*(-T0_Vsi_bi));
#if defined(_DERIVATE2)
  Vgdov_Vsi_bi_Vgm_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(Vgd_ov_noswap_Vgm_di-T0_Vgm_di)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vgm_di));
  Vgdov_Vsi_bi_Tempt_GND=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*((-Vfbsdr_Tempt_GND)-T0_Tempt_GND)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Tempt_GND));
  Vgdov_Vsi_bi_Vgm_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgm_si)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vgm_si));
  Vgdov_Vsi_bi_Vdbulk_di=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdbulk_di)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vdbulk_di));
  Vgdov_Vsi_bi_Vsbulk_si=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsbulk_si)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vsbulk_si));
  Vgdov_Vsi_bi_Vgi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vgi_bi)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vgi_bi));
  Vgdov_Vsi_bi_Vdi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vdi_bi)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vdi_bi));
  Vgdov_Vsi_bi_Vsi_bi=(+0.0*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)+0.0*(-T0_Vsi_bi)+0.0*(-T0_Vsi_bi)+0.5*(+(+(+0.0-0.0)+0.0)-T0_Vsi_bi_Vsi_bi));
#endif
#endif
Vgdov=(0.5*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0));
EXIT_IF_ISNAN((0.5*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0)))
{
double m00_sqrt(d00_sqrt0,(1.0-((4.0*Vgdov)/CKAPPAD_i)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0-((4.0*Vgdov)/CKAPPAD_i)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=(-((4.0*Vgdov_Vgm_di)/CKAPPAD_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_di+0.0*Vgdov_Vgm_di+4.0*Vgdov_Vgm_di_Vgm_di)/CKAPPAD_i-((4.0*Vgdov_Vgm_di)*0.0+((4.0*Vgdov_Vgm_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_di_Vgm_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_si+0.0*Vgdov_Vgm_di+4.0*Vgdov_Vgm_di_Vgm_si)/CKAPPAD_i-((4.0*Vgdov_Vgm_di)*0.0+((4.0*Vgdov_Vgm_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_di_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdbulk_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdbulk_di+0.0*Vgdov_Vgm_di+4.0*Vgdov_Vgm_di_Vdbulk_di)/CKAPPAD_i-((4.0*Vgdov_Vgm_di)*0.0+((4.0*Vgdov_Vdbulk_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_di_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsbulk_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsbulk_si+0.0*Vgdov_Vgm_di+4.0*Vgdov_Vgm_di_Vsbulk_si)/CKAPPAD_i-((4.0*Vgdov_Vgm_di)*0.0+((4.0*Vgdov_Vsbulk_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_di_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgi_bi+0.0*Vgdov_Vgm_di+4.0*Vgdov_Vgm_di_Vgi_bi)/CKAPPAD_i-((4.0*Vgdov_Vgm_di)*0.0+((4.0*Vgdov_Vgi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_di_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdi_bi+0.0*Vgdov_Vgm_di+4.0*Vgdov_Vgm_di_Vdi_bi)/CKAPPAD_i-((4.0*Vgdov_Vgm_di)*0.0+((4.0*Vgdov_Vdi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_di_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsi_bi+0.0*Vgdov_Vgm_di+4.0*Vgdov_Vgm_di_Vsi_bi)/CKAPPAD_i-((4.0*Vgdov_Vgm_di)*0.0+((4.0*Vgdov_Vsi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_di_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Tempt_GND))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Tempt_GND+0.0*Vgdov_Vgm_di+4.0*Vgdov_Vgm_di_Tempt_GND)/CKAPPAD_i-((4.0*Vgdov_Vgm_di)*0.0+((4.0*Vgdov_Tempt_GND))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
#endif
T2_Vgm_si=(-((4.0*Vgdov_Vgm_si)/CKAPPAD_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_di+0.0*Vgdov_Vgm_si+4.0*Vgdov_Vgm_si_Vgm_di)/CKAPPAD_i-((4.0*Vgdov_Vgm_si)*0.0+((4.0*Vgdov_Vgm_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_si_Vgm_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_si+0.0*Vgdov_Vgm_si+4.0*Vgdov_Vgm_si_Vgm_si)/CKAPPAD_i-((4.0*Vgdov_Vgm_si)*0.0+((4.0*Vgdov_Vgm_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_si_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdbulk_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdbulk_di+0.0*Vgdov_Vgm_si+4.0*Vgdov_Vgm_si_Vdbulk_di)/CKAPPAD_i-((4.0*Vgdov_Vgm_si)*0.0+((4.0*Vgdov_Vdbulk_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_si_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsbulk_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsbulk_si+0.0*Vgdov_Vgm_si+4.0*Vgdov_Vgm_si_Vsbulk_si)/CKAPPAD_i-((4.0*Vgdov_Vgm_si)*0.0+((4.0*Vgdov_Vsbulk_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_si_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgi_bi+0.0*Vgdov_Vgm_si+4.0*Vgdov_Vgm_si_Vgi_bi)/CKAPPAD_i-((4.0*Vgdov_Vgm_si)*0.0+((4.0*Vgdov_Vgi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_si_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdi_bi+0.0*Vgdov_Vgm_si+4.0*Vgdov_Vgm_si_Vdi_bi)/CKAPPAD_i-((4.0*Vgdov_Vgm_si)*0.0+((4.0*Vgdov_Vdi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_si_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsi_bi+0.0*Vgdov_Vgm_si+4.0*Vgdov_Vgm_si_Vsi_bi)/CKAPPAD_i-((4.0*Vgdov_Vgm_si)*0.0+((4.0*Vgdov_Vsi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgm_si_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Tempt_GND))/CKAPPAD_i))*(-((4.0*Vgdov_Vgm_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Tempt_GND+0.0*Vgdov_Vgm_si+4.0*Vgdov_Vgm_si_Tempt_GND)/CKAPPAD_i-((4.0*Vgdov_Vgm_si)*0.0+((4.0*Vgdov_Tempt_GND))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
#endif
T2_Vdbulk_di=(-((4.0*Vgdov_Vdbulk_di)/CKAPPAD_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vdbulk_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_di+0.0*Vgdov_Vdbulk_di+4.0*Vgdov_Vdbulk_di_Vgm_di)/CKAPPAD_i-((4.0*Vgdov_Vdbulk_di)*0.0+((4.0*Vgdov_Vgm_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdbulk_di_Vgm_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vdbulk_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_si+0.0*Vgdov_Vdbulk_di+4.0*Vgdov_Vdbulk_di_Vgm_si)/CKAPPAD_i-((4.0*Vgdov_Vdbulk_di)*0.0+((4.0*Vgdov_Vgm_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdbulk_di_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdbulk_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vdbulk_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdbulk_di+0.0*Vgdov_Vdbulk_di+4.0*Vgdov_Vdbulk_di_Vdbulk_di)/CKAPPAD_i-((4.0*Vgdov_Vdbulk_di)*0.0+((4.0*Vgdov_Vdbulk_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdbulk_di_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsbulk_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vdbulk_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsbulk_si+0.0*Vgdov_Vdbulk_di+4.0*Vgdov_Vdbulk_di_Vsbulk_si)/CKAPPAD_i-((4.0*Vgdov_Vdbulk_di)*0.0+((4.0*Vgdov_Vsbulk_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdbulk_di_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vdbulk_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgi_bi+0.0*Vgdov_Vdbulk_di+4.0*Vgdov_Vdbulk_di_Vgi_bi)/CKAPPAD_i-((4.0*Vgdov_Vdbulk_di)*0.0+((4.0*Vgdov_Vgi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdbulk_di_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vdbulk_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdi_bi+0.0*Vgdov_Vdbulk_di+4.0*Vgdov_Vdbulk_di_Vdi_bi)/CKAPPAD_i-((4.0*Vgdov_Vdbulk_di)*0.0+((4.0*Vgdov_Vdi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdbulk_di_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vdbulk_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsi_bi+0.0*Vgdov_Vdbulk_di+4.0*Vgdov_Vdbulk_di_Vsi_bi)/CKAPPAD_i-((4.0*Vgdov_Vdbulk_di)*0.0+((4.0*Vgdov_Vsi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdbulk_di_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Tempt_GND))/CKAPPAD_i))*(-((4.0*Vgdov_Vdbulk_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Tempt_GND+0.0*Vgdov_Vdbulk_di+4.0*Vgdov_Vdbulk_di_Tempt_GND)/CKAPPAD_i-((4.0*Vgdov_Vdbulk_di)*0.0+((4.0*Vgdov_Tempt_GND))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
#endif
T2_Vsbulk_si=(-((4.0*Vgdov_Vsbulk_si)/CKAPPAD_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vsbulk_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_di+0.0*Vgdov_Vsbulk_si+4.0*Vgdov_Vsbulk_si_Vgm_di)/CKAPPAD_i-((4.0*Vgdov_Vsbulk_si)*0.0+((4.0*Vgdov_Vgm_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsbulk_si_Vgm_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vsbulk_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_si+0.0*Vgdov_Vsbulk_si+4.0*Vgdov_Vsbulk_si_Vgm_si)/CKAPPAD_i-((4.0*Vgdov_Vsbulk_si)*0.0+((4.0*Vgdov_Vgm_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsbulk_si_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdbulk_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vsbulk_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdbulk_di+0.0*Vgdov_Vsbulk_si+4.0*Vgdov_Vsbulk_si_Vdbulk_di)/CKAPPAD_i-((4.0*Vgdov_Vsbulk_si)*0.0+((4.0*Vgdov_Vdbulk_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsbulk_si_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsbulk_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vsbulk_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsbulk_si+0.0*Vgdov_Vsbulk_si+4.0*Vgdov_Vsbulk_si_Vsbulk_si)/CKAPPAD_i-((4.0*Vgdov_Vsbulk_si)*0.0+((4.0*Vgdov_Vsbulk_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsbulk_si_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vsbulk_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgi_bi+0.0*Vgdov_Vsbulk_si+4.0*Vgdov_Vsbulk_si_Vgi_bi)/CKAPPAD_i-((4.0*Vgdov_Vsbulk_si)*0.0+((4.0*Vgdov_Vgi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsbulk_si_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vsbulk_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdi_bi+0.0*Vgdov_Vsbulk_si+4.0*Vgdov_Vsbulk_si_Vdi_bi)/CKAPPAD_i-((4.0*Vgdov_Vsbulk_si)*0.0+((4.0*Vgdov_Vdi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsbulk_si_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vsbulk_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsi_bi+0.0*Vgdov_Vsbulk_si+4.0*Vgdov_Vsbulk_si_Vsi_bi)/CKAPPAD_i-((4.0*Vgdov_Vsbulk_si)*0.0+((4.0*Vgdov_Vsi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsbulk_si_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Tempt_GND))/CKAPPAD_i))*(-((4.0*Vgdov_Vsbulk_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Tempt_GND+0.0*Vgdov_Vsbulk_si+4.0*Vgdov_Vsbulk_si_Tempt_GND)/CKAPPAD_i-((4.0*Vgdov_Vsbulk_si)*0.0+((4.0*Vgdov_Tempt_GND))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
#endif
T2_Vgi_bi=(-((4.0*Vgdov_Vgi_bi)/CKAPPAD_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vgi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_di+0.0*Vgdov_Vgi_bi+4.0*Vgdov_Vgi_bi_Vgm_di)/CKAPPAD_i-((4.0*Vgdov_Vgi_bi)*0.0+((4.0*Vgdov_Vgm_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgi_bi_Vgm_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vgi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_si+0.0*Vgdov_Vgi_bi+4.0*Vgdov_Vgi_bi_Vgm_si)/CKAPPAD_i-((4.0*Vgdov_Vgi_bi)*0.0+((4.0*Vgdov_Vgm_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgi_bi_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdbulk_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vgi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdbulk_di+0.0*Vgdov_Vgi_bi+4.0*Vgdov_Vgi_bi_Vdbulk_di)/CKAPPAD_i-((4.0*Vgdov_Vgi_bi)*0.0+((4.0*Vgdov_Vdbulk_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgi_bi_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsbulk_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vgi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsbulk_si+0.0*Vgdov_Vgi_bi+4.0*Vgdov_Vgi_bi_Vsbulk_si)/CKAPPAD_i-((4.0*Vgdov_Vgi_bi)*0.0+((4.0*Vgdov_Vsbulk_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgi_bi_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vgi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgi_bi+0.0*Vgdov_Vgi_bi+4.0*Vgdov_Vgi_bi_Vgi_bi)/CKAPPAD_i-((4.0*Vgdov_Vgi_bi)*0.0+((4.0*Vgdov_Vgi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgi_bi_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vgi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdi_bi+0.0*Vgdov_Vgi_bi+4.0*Vgdov_Vgi_bi_Vdi_bi)/CKAPPAD_i-((4.0*Vgdov_Vgi_bi)*0.0+((4.0*Vgdov_Vdi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgi_bi_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vgi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsi_bi+0.0*Vgdov_Vgi_bi+4.0*Vgdov_Vgi_bi_Vsi_bi)/CKAPPAD_i-((4.0*Vgdov_Vgi_bi)*0.0+((4.0*Vgdov_Vsi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vgi_bi_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Tempt_GND))/CKAPPAD_i))*(-((4.0*Vgdov_Vgi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Tempt_GND+0.0*Vgdov_Vgi_bi+4.0*Vgdov_Vgi_bi_Tempt_GND)/CKAPPAD_i-((4.0*Vgdov_Vgi_bi)*0.0+((4.0*Vgdov_Tempt_GND))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
#endif
T2_Vdi_bi=(-((4.0*Vgdov_Vdi_bi)/CKAPPAD_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vdi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_di+0.0*Vgdov_Vdi_bi+4.0*Vgdov_Vdi_bi_Vgm_di)/CKAPPAD_i-((4.0*Vgdov_Vdi_bi)*0.0+((4.0*Vgdov_Vgm_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdi_bi_Vgm_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vdi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_si+0.0*Vgdov_Vdi_bi+4.0*Vgdov_Vdi_bi_Vgm_si)/CKAPPAD_i-((4.0*Vgdov_Vdi_bi)*0.0+((4.0*Vgdov_Vgm_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdi_bi_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdbulk_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vdi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdbulk_di+0.0*Vgdov_Vdi_bi+4.0*Vgdov_Vdi_bi_Vdbulk_di)/CKAPPAD_i-((4.0*Vgdov_Vdi_bi)*0.0+((4.0*Vgdov_Vdbulk_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdi_bi_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsbulk_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vdi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsbulk_si+0.0*Vgdov_Vdi_bi+4.0*Vgdov_Vdi_bi_Vsbulk_si)/CKAPPAD_i-((4.0*Vgdov_Vdi_bi)*0.0+((4.0*Vgdov_Vsbulk_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdi_bi_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vdi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgi_bi+0.0*Vgdov_Vdi_bi+4.0*Vgdov_Vdi_bi_Vgi_bi)/CKAPPAD_i-((4.0*Vgdov_Vdi_bi)*0.0+((4.0*Vgdov_Vgi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdi_bi_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vdi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdi_bi+0.0*Vgdov_Vdi_bi+4.0*Vgdov_Vdi_bi_Vdi_bi)/CKAPPAD_i-((4.0*Vgdov_Vdi_bi)*0.0+((4.0*Vgdov_Vdi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdi_bi_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vdi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsi_bi+0.0*Vgdov_Vdi_bi+4.0*Vgdov_Vdi_bi_Vsi_bi)/CKAPPAD_i-((4.0*Vgdov_Vdi_bi)*0.0+((4.0*Vgdov_Vsi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vdi_bi_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Tempt_GND))/CKAPPAD_i))*(-((4.0*Vgdov_Vdi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Tempt_GND+0.0*Vgdov_Vdi_bi+4.0*Vgdov_Vdi_bi_Tempt_GND)/CKAPPAD_i-((4.0*Vgdov_Vdi_bi)*0.0+((4.0*Vgdov_Tempt_GND))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
#endif
T2_Vsi_bi=(-((4.0*Vgdov_Vsi_bi)/CKAPPAD_i))*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vsi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_di+0.0*Vgdov_Vsi_bi+4.0*Vgdov_Vsi_bi_Vgm_di)/CKAPPAD_i-((4.0*Vgdov_Vsi_bi)*0.0+((4.0*Vgdov_Vgm_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsi_bi_Vgm_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgm_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vsi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgm_si+0.0*Vgdov_Vsi_bi+4.0*Vgdov_Vsi_bi_Vgm_si)/CKAPPAD_i-((4.0*Vgdov_Vsi_bi)*0.0+((4.0*Vgdov_Vgm_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsi_bi_Vdbulk_di=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdbulk_di))/CKAPPAD_i))*(-((4.0*Vgdov_Vsi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdbulk_di+0.0*Vgdov_Vsi_bi+4.0*Vgdov_Vsi_bi_Vdbulk_di)/CKAPPAD_i-((4.0*Vgdov_Vsi_bi)*0.0+((4.0*Vgdov_Vdbulk_di))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsi_bi_Vsbulk_si=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsbulk_si))/CKAPPAD_i))*(-((4.0*Vgdov_Vsi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsbulk_si+0.0*Vgdov_Vsi_bi+4.0*Vgdov_Vsi_bi_Vsbulk_si)/CKAPPAD_i-((4.0*Vgdov_Vsi_bi)*0.0+((4.0*Vgdov_Vsbulk_si))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsi_bi_Vgi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vgi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vsi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vgi_bi+0.0*Vgdov_Vsi_bi+4.0*Vgdov_Vsi_bi_Vgi_bi)/CKAPPAD_i-((4.0*Vgdov_Vsi_bi)*0.0+((4.0*Vgdov_Vgi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsi_bi_Vdi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vdi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vsi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vdi_bi+0.0*Vgdov_Vsi_bi+4.0*Vgdov_Vsi_bi_Vdi_bi)/CKAPPAD_i-((4.0*Vgdov_Vsi_bi)*0.0+((4.0*Vgdov_Vdi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsi_bi_Vsi_bi=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Vsi_bi))/CKAPPAD_i))*(-((4.0*Vgdov_Vsi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Vsi_bi+0.0*Vgdov_Vsi_bi+4.0*Vgdov_Vsi_bi_Vsi_bi)/CKAPPAD_i-((4.0*Vgdov_Vsi_bi)*0.0+((4.0*Vgdov_Vsi_bi))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
  T2_Vsi_bi_Tempt_GND=(m20_sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)))*(-(((4.0*Vgdov_Tempt_GND))/CKAPPAD_i))*(-((4.0*Vgdov_Vsi_bi)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*Vgdov+0.0*Vgdov_Tempt_GND+0.0*Vgdov_Vsi_bi+4.0*Vgdov_Vsi_bi_Tempt_GND)/CKAPPAD_i-((4.0*Vgdov_Vsi_bi)*0.0+((4.0*Vgdov_Tempt_GND))*0.0+(4.0*Vgdov)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*Vgdov)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(-((4.0*Vgdov_Tempt_GND)/CKAPPAD_i))*d10_sqrt0;
#endif
#endif
T2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)V(gm,di) ddxprobe=V(bi,GND)V(si,GND)V(di,GND)V(dbulk,GND)V(gm,GND) */
#if defined(_DERIVATE)
Qovd_Tempt_GND=(((-Wact)*pInst->NF)*(CGDL_i*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((0.5*CKAPPAD_i)*T2_Tempt_GND))));
#endif
Qovd_Vgm_si=(((-Wact)*pInst->NF)*(CGDL_i*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si))));
#if defined(_DERIVATE2)
  Qovd_Vgm_si_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND))))+0.0*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_si_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Tempt_GND+(0.0)*T2_Vgm_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_si_Tempt_GND))))));
  Qovd_Vgm_si_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si))))+0.0*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_si_Vgm_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_si+(0.0)*T2_Vgm_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_si_Vgm_si))))));
  Qovd_Vgm_si_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di))))+0.0*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_si_Vdbulk_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vgm_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_si_Vdbulk_di))))));
  Qovd_Vgm_si_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si))))+0.0*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_si_Vsbulk_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vgm_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_si_Vsbulk_si))))));
  Qovd_Vgm_si_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi))))+0.0*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_si_Vgi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgi_bi+(0.0)*T2_Vgm_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_si_Vgi_bi))))));
  Qovd_Vgm_si_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi))))+0.0*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_si_Vdi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdi_bi+(0.0)*T2_Vgm_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_si_Vdi_bi))))));
  Qovd_Vgm_si_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi))))+0.0*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_si_Vsi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsi_bi+(0.0)*T2_Vgm_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_si_Vsi_bi))))));
  Qovd_Vgm_si_Vgm_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*(((Cgdof*Vgd_ov_noswap_Vgm_di))+((CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*Vgd_ov_noswap_Vgm_di+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di))))+0.0*((-Vgdov_Vgm_si)-((0.5*CKAPPAD_i)*T2_Vgm_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_si_Vgm_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_di+(0.0)*T2_Vgm_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_si_Vgm_di))))));
#endif
Qovd_Vdbulk_di=(((-Wact)*pInst->NF)*(CGDL_i*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di))));
#if defined(_DERIVATE2)
  Qovd_Vdbulk_di_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND))))+0.0*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdbulk_di_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Tempt_GND+(0.0)*T2_Vdbulk_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vdbulk_di_Tempt_GND))))));
  Qovd_Vdbulk_di_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si))))+0.0*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdbulk_di_Vgm_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_si+(0.0)*T2_Vdbulk_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vdbulk_di_Vgm_si))))));
  Qovd_Vdbulk_di_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di))))+0.0*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdbulk_di_Vdbulk_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdbulk_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vdbulk_di_Vdbulk_di))))));
  Qovd_Vdbulk_di_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si))))+0.0*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdbulk_di_Vsbulk_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdbulk_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vdbulk_di_Vsbulk_si))))));
  Qovd_Vdbulk_di_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi))))+0.0*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdbulk_di_Vgi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdbulk_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vdbulk_di_Vgi_bi))))));
  Qovd_Vdbulk_di_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi))))+0.0*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdbulk_di_Vdi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdbulk_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vdbulk_di_Vdi_bi))))));
  Qovd_Vdbulk_di_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi))))+0.0*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdbulk_di_Vsi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdbulk_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vdbulk_di_Vsi_bi))))));
  Qovd_Vdbulk_di_Vgm_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*(((Cgdof*Vgd_ov_noswap_Vgm_di))+((CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*Vgd_ov_noswap_Vgm_di+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di))))+0.0*((-Vgdov_Vdbulk_di)-((0.5*CKAPPAD_i)*T2_Vdbulk_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdbulk_di_Vgm_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_di+(0.0)*T2_Vdbulk_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vdbulk_di_Vgm_di))))));
#endif
Qovd_Vsbulk_si=(((-Wact)*pInst->NF)*(CGDL_i*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si))));
#if defined(_DERIVATE2)
  Qovd_Vsbulk_si_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND))))+0.0*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsbulk_si_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Tempt_GND+(0.0)*T2_Vsbulk_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vsbulk_si_Tempt_GND))))));
  Qovd_Vsbulk_si_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si))))+0.0*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsbulk_si_Vgm_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_si+(0.0)*T2_Vsbulk_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vsbulk_si_Vgm_si))))));
  Qovd_Vsbulk_si_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di))))+0.0*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsbulk_si_Vdbulk_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsbulk_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vsbulk_si_Vdbulk_di))))));
  Qovd_Vsbulk_si_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si))))+0.0*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsbulk_si_Vsbulk_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsbulk_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vsbulk_si_Vsbulk_si))))));
  Qovd_Vsbulk_si_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi))))+0.0*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsbulk_si_Vgi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsbulk_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vsbulk_si_Vgi_bi))))));
  Qovd_Vsbulk_si_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi))))+0.0*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsbulk_si_Vdi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsbulk_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vsbulk_si_Vdi_bi))))));
  Qovd_Vsbulk_si_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi))))+0.0*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsbulk_si_Vsi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsbulk_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vsbulk_si_Vsi_bi))))));
  Qovd_Vsbulk_si_Vgm_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*(((Cgdof*Vgd_ov_noswap_Vgm_di))+((CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*Vgd_ov_noswap_Vgm_di+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di))))+0.0*((-Vgdov_Vsbulk_si)-((0.5*CKAPPAD_i)*T2_Vsbulk_si))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsbulk_si_Vgm_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_di+(0.0)*T2_Vsbulk_si+(0.5*CKAPPAD_i)*(+0.0+T2_Vsbulk_si_Vgm_di))))));
#endif
Qovd_Vgi_bi=(((-Wact)*pInst->NF)*(CGDL_i*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi))));
#if defined(_DERIVATE2)
  Qovd_Vgi_bi_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND))))+0.0*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgi_bi_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Tempt_GND+(0.0)*T2_Vgi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vgi_bi_Tempt_GND))))));
  Qovd_Vgi_bi_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si))))+0.0*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgi_bi_Vgm_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_si+(0.0)*T2_Vgi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vgi_bi_Vgm_si))))));
  Qovd_Vgi_bi_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di))))+0.0*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgi_bi_Vdbulk_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vgi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vgi_bi_Vdbulk_di))))));
  Qovd_Vgi_bi_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si))))+0.0*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgi_bi_Vsbulk_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vgi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vgi_bi_Vsbulk_si))))));
  Qovd_Vgi_bi_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi))))+0.0*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgi_bi_Vgi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgi_bi+(0.0)*T2_Vgi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vgi_bi_Vgi_bi))))));
  Qovd_Vgi_bi_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi))))+0.0*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgi_bi_Vdi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdi_bi+(0.0)*T2_Vgi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vgi_bi_Vdi_bi))))));
  Qovd_Vgi_bi_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi))))+0.0*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgi_bi_Vsi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsi_bi+(0.0)*T2_Vgi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vgi_bi_Vsi_bi))))));
  Qovd_Vgi_bi_Vgm_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*(((Cgdof*Vgd_ov_noswap_Vgm_di))+((CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*Vgd_ov_noswap_Vgm_di+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di))))+0.0*((-Vgdov_Vgi_bi)-((0.5*CKAPPAD_i)*T2_Vgi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgi_bi_Vgm_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_di+(0.0)*T2_Vgi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vgi_bi_Vgm_di))))));
#endif
Qovd_Vdi_bi=(((-Wact)*pInst->NF)*(CGDL_i*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi))));
#if defined(_DERIVATE2)
  Qovd_Vdi_bi_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND))))+0.0*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdi_bi_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Tempt_GND+(0.0)*T2_Vdi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vdi_bi_Tempt_GND))))));
  Qovd_Vdi_bi_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si))))+0.0*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdi_bi_Vgm_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_si+(0.0)*T2_Vdi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vdi_bi_Vgm_si))))));
  Qovd_Vdi_bi_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di))))+0.0*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdi_bi_Vdbulk_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vdi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vdi_bi_Vdbulk_di))))));
  Qovd_Vdi_bi_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si))))+0.0*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdi_bi_Vsbulk_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vdi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vdi_bi_Vsbulk_si))))));
  Qovd_Vdi_bi_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi))))+0.0*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdi_bi_Vgi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgi_bi+(0.0)*T2_Vdi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vdi_bi_Vgi_bi))))));
  Qovd_Vdi_bi_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi))))+0.0*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdi_bi_Vdi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdi_bi+(0.0)*T2_Vdi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vdi_bi_Vdi_bi))))));
  Qovd_Vdi_bi_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi))))+0.0*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdi_bi_Vsi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsi_bi+(0.0)*T2_Vdi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vdi_bi_Vsi_bi))))));
  Qovd_Vdi_bi_Vgm_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*(((Cgdof*Vgd_ov_noswap_Vgm_di))+((CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*Vgd_ov_noswap_Vgm_di+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di))))+0.0*((-Vgdov_Vdi_bi)-((0.5*CKAPPAD_i)*T2_Vdi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vdi_bi_Vgm_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_di+(0.0)*T2_Vdi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vdi_bi_Vgm_di))))));
#endif
Qovd_Vsi_bi=(((-Wact)*pInst->NF)*(CGDL_i*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi))));
#if defined(_DERIVATE2)
  Qovd_Vsi_bi_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND))))+0.0*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsi_bi_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Tempt_GND+(0.0)*T2_Vsi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vsi_bi_Tempt_GND))))));
  Qovd_Vsi_bi_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si))))+0.0*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsi_bi_Vgm_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_si+(0.0)*T2_Vsi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vsi_bi_Vgm_si))))));
  Qovd_Vsi_bi_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di))))+0.0*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsi_bi_Vdbulk_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vsi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vsi_bi_Vdbulk_di))))));
  Qovd_Vsi_bi_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si))))+0.0*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsi_bi_Vsbulk_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vsi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vsi_bi_Vsbulk_si))))));
  Qovd_Vsi_bi_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi))))+0.0*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsi_bi_Vgi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgi_bi+(0.0)*T2_Vsi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vsi_bi_Vgi_bi))))));
  Qovd_Vsi_bi_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi))))+0.0*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsi_bi_Vdi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdi_bi+(0.0)*T2_Vsi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vsi_bi_Vdi_bi))))));
  Qovd_Vsi_bi_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi))))+0.0*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsi_bi_Vsi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsi_bi+(0.0)*T2_Vsi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vsi_bi_Vsi_bi))))));
  Qovd_Vsi_bi_Vgm_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*(((Cgdof*Vgd_ov_noswap_Vgm_di))+((CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di)))))))+(0.0)*(CGDL_i*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi)))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*Vgd_ov_noswap_Vgm_di+0.0*0.0+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di))))+0.0*((-Vgdov_Vsi_bi)-((0.5*CKAPPAD_i)*T2_Vsi_bi))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vsi_bi_Vgm_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_di+(0.0)*T2_Vsi_bi+(0.5*CKAPPAD_i)*(+0.0+T2_Vsi_bi_Vgm_di))))));
#endif
Qovd_Vgm_di=(((-Wact)*pInst->NF)*((Cgdof*Vgd_ov_noswap_Vgm_di)+(CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di)))));
#if defined(_DERIVATE2)
  Qovd_Vgm_di_Tempt_GND=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND)))))))+(0.0)*((Cgdof*Vgd_ov_noswap_Vgm_di)+(CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*Vgd_ov_noswap_Vgm_di+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*(((-Vfbsdr_Tempt_GND)-Vgdov_Tempt_GND)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Tempt_GND))))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_di_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Tempt_GND+(0.0)*T2_Vgm_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_di_Tempt_GND))))));
  Qovd_Vgm_di_Vgm_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si)))))))+(0.0)*((Cgdof*Vgd_ov_noswap_Vgm_di)+(CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*Vgd_ov_noswap_Vgm_di+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgm_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_si))))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_di_Vgm_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_si+(0.0)*T2_Vgm_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_di_Vgm_si))))));
  Qovd_Vgm_di_Vdbulk_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di)))))))+(0.0)*((Cgdof*Vgd_ov_noswap_Vgm_di)+(CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*Vgd_ov_noswap_Vgm_di+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdbulk_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdbulk_di))))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_di_Vdbulk_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdbulk_di+(0.0)*T2_Vgm_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_di_Vdbulk_di))))));
  Qovd_Vgm_di_Vsbulk_si=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si)))))))+(0.0)*((Cgdof*Vgd_ov_noswap_Vgm_di)+(CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*Vgd_ov_noswap_Vgm_di+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsbulk_si)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsbulk_si))))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_di_Vsbulk_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsbulk_si+(0.0)*T2_Vgm_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_di_Vsbulk_si))))));
  Qovd_Vgm_di_Vgi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi)))))))+(0.0)*((Cgdof*Vgd_ov_noswap_Vgm_di)+(CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*Vgd_ov_noswap_Vgm_di+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vgi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgi_bi))))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_di_Vgi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgi_bi+(0.0)*T2_Vgm_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_di_Vgi_bi))))));
  Qovd_Vgm_di_Vdi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi)))))))+(0.0)*((Cgdof*Vgd_ov_noswap_Vgm_di)+(CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*Vgd_ov_noswap_Vgm_di+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vdi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vdi_bi))))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_di_Vdi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vdi_bi+(0.0)*T2_Vgm_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_di_Vdi_bi))))));
  Qovd_Vgm_di_Vsi_bi=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*((0.0)+((CGDL_i*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi)))))))+(0.0)*((Cgdof*Vgd_ov_noswap_Vgm_di)+(CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*0.0+0.0*Vgd_ov_noswap_Vgm_di+Cgdof*0.0)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((-Vgdov_Vsi_bi)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vsi_bi))))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))+CGDL_i*(+(+(+0.0-0.0)-Vgdov_Vgm_di_Vsi_bi)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vsi_bi+(0.0)*T2_Vgm_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_di_Vsi_bi))))));
  Qovd_Vgm_di_Vgm_di=(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-Wact)*0.0)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))+0.0*(((Cgdof*Vgd_ov_noswap_Vgm_di))+((CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di)))))))+(0.0)*((Cgdof*Vgd_ov_noswap_Vgm_di)+(CGDL_i*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))))+((-Wact)*pInst->NF)*(+(+0.0*Vgd_ov_noswap+0.0*Vgd_ov_noswap_Vgm_di+0.0*Vgd_ov_noswap_Vgm_di+Cgdof*Vgd_ov_noswap_Vgm_di_Vgm_di)+(+0.0*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((((0.0)*((-1.0)+T2))+((0.5*CKAPPAD_i)*T2_Vgm_di))))+0.0*((Vgd_ov_noswap_Vgm_di-Vgdov_Vgm_di)-((0.5*CKAPPAD_i)*T2_Vgm_di))+CGDL_i*(+(+(+Vgd_ov_noswap_Vgm_di_Vgm_di-0.0)-Vgdov_Vgm_di_Vgm_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*((-1.0)+T2)+0.0*T2_Vgm_di+(0.0)*T2_Vgm_di+(0.5*CKAPPAD_i)*(+0.0+T2_Vgm_di_Vgm_di))))));
#endif
#endif
Qovd=(((-Wact)*pInst->NF)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2))))));
EXIT_IF_ISNAN((((-Wact)*pInst->NF)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2)))))))
#endif
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,bi) ddxprobe=V(si,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(gi,GND)V(gm,GND)V(bi,GND) */
Qovb_Vgm_bi=(((((-devsign)*pInst->NF)*Lact)*pModel->CGBO));
#if defined(_DERIVATE2)
  Qovb_Vgm_bi_Vgm_bi=(+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+(-devsign)*0.0)*Lact+0.0*0.0+(0.0)*0.0+((-devsign)*pInst->NF)*0.0)*pModel->CGBO+0.0*0.0+((0.0)*Lact)*0.0+(((-devsign)*pInst->NF)*Lact)*0.0)*(NP(gm)-NP(bi))+0.0*1.0+(((0.0)*Lact)*pModel->CGBO)*1.0+((((-devsign)*pInst->NF)*Lact)*pModel->CGBO)*0.0);
#endif
#endif
Qovb=(((((-devsign)*pInst->NF)*Lact)*pModel->CGBO)*(NP(gm)-NP(bi)));
EXIT_IF_ISNAN((((((-devsign)*pInst->NF)*Lact)*pModel->CGBO)*(NP(gm)-NP(bi))))
#endif
#if defined(_DYNAMIC)
Qovg=(-((Qovs+Qovd)+Qovb));
EXIT_IF_ISNAN((-((Qovs+Qovd)+Qovb)))
#endif
if
((pInst->EDGEFET==1))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
NFACTOREDGE_t_Tempt_GND=(NFACTOREDGE_i*bsimbulk_d_hypsmooth((1.0+(TNFACTOREDGE_i*(TRatio-1.0))),1e-3,(TNFACTOREDGE_i*TRatio_Tempt_GND),0.0));
#endif
#endif
NFACTOREDGE_t=(NFACTOREDGE_i*bsimbulk_hypsmooth((1.0+(TNFACTOREDGE_i*(TRatio-1.0))),1e-3));
EXIT_IF_ISNAN((NFACTOREDGE_i*bsimbulk_hypsmooth((1.0+(TNFACTOREDGE_i*(TRatio-1.0))),1e-3)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
ETA0EDGE_t_Tempt_GND=((ETA0_EDGE_Tempt_GND*(1.0+(TETA0EDGE_i*(TRatio-1.0))))+(ETA0_EDGE*(TETA0EDGE_i*TRatio_Tempt_GND)));
#endif
ETA0EDGE_t=(ETA0_EDGE*(1.0+(TETA0EDGE_i*(TRatio-1.0))));
EXIT_IF_ISNAN((ETA0_EDGE*(1.0+(TETA0EDGE_i*(TRatio-1.0)))))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
#if defined(_DERIVATE)
cdsc_Tempt_GND=((NFACTOREDGE_t_Tempt_GND+(CDSCDEDGE_i*Vdsx_Tempt_GND))-(CDSCBEDGE_i*Vbsx_Tempt_GND));
#endif
cdsc_Vdi_bi=((CDSCDEDGE_i*Vdsx_Vdi_bi)-(CDSCBEDGE_i*Vbsx_Vdi_bi));
#if defined(_DERIVATE2)
  cdsc_Vdi_bi_Tempt_GND=(+(+(+0.0+0.0)+(+0.0*Vdsx+0.0*Vdsx_Tempt_GND+0.0*Vdsx_Vdi_bi+CDSCDEDGE_i*Vdsx_Vdi_bi_Tempt_GND))-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vdi_bi+CDSCBEDGE_i*Vbsx_Vdi_bi_Tempt_GND));
  cdsc_Vdi_bi_Vdi_bi=(+(+(+0.0+0.0)+(+0.0*Vdsx+0.0*Vdsx_Vdi_bi+0.0*Vdsx_Vdi_bi+CDSCDEDGE_i*Vdsx_Vdi_bi_Vdi_bi))-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+CDSCBEDGE_i*Vbsx_Vdi_bi_Vdi_bi));
  cdsc_Vdi_bi_Vsi_bi=(+(+(+0.0+0.0)+(+0.0*Vdsx+0.0*Vdsx_Vsi_bi+0.0*Vdsx_Vdi_bi+CDSCDEDGE_i*Vdsx_Vdi_bi_Vsi_bi))-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+CDSCBEDGE_i*Vbsx_Vdi_bi_Vsi_bi));
#endif
cdsc_Vsi_bi=((CDSCDEDGE_i*Vdsx_Vsi_bi)-(CDSCBEDGE_i*Vbsx_Vsi_bi));
#if defined(_DERIVATE2)
  cdsc_Vsi_bi_Tempt_GND=(+(+(+0.0+0.0)+(+0.0*Vdsx+0.0*Vdsx_Tempt_GND+0.0*Vdsx_Vsi_bi+CDSCDEDGE_i*Vdsx_Vsi_bi_Tempt_GND))-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vsi_bi+CDSCBEDGE_i*Vbsx_Vsi_bi_Tempt_GND));
  cdsc_Vsi_bi_Vdi_bi=(+(+(+0.0+0.0)+(+0.0*Vdsx+0.0*Vdsx_Vdi_bi+0.0*Vdsx_Vsi_bi+CDSCDEDGE_i*Vdsx_Vsi_bi_Vdi_bi))-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+CDSCBEDGE_i*Vbsx_Vsi_bi_Vdi_bi));
  cdsc_Vsi_bi_Vsi_bi=(+(+(+0.0+0.0)+(+0.0*Vdsx+0.0*Vdsx_Vsi_bi+0.0*Vdsx_Vsi_bi+CDSCDEDGE_i*Vdsx_Vsi_bi_Vsi_bi))-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+CDSCBEDGE_i*Vbsx_Vsi_bi_Vsi_bi));
#endif
#endif
cdsc=(((CITEDGE_i+NFACTOREDGE_t)+(CDSCDEDGE_i*Vdsx))-(CDSCBEDGE_i*Vbsx));
EXIT_IF_ISNAN((((CITEDGE_i+NFACTOREDGE_t)+(CDSCDEDGE_i*Vdsx))-(CDSCBEDGE_i*Vbsx)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=(cdsc_Vdi_bi/Cox);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vgm_si=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vdbulk_di=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vsbulk_si=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vgi_bi=(+0.0+(0.0/Cox-(cdsc_Vdi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vdi_bi=(+0.0+(cdsc_Vdi_bi_Vdi_bi/Cox-(cdsc_Vdi_bi*0.0+cdsc_Vdi_bi*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Vsi_bi=(+0.0+(cdsc_Vdi_bi_Vsi_bi/Cox-(cdsc_Vdi_bi*0.0+cdsc_Vsi_bi*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vdi_bi_Tempt_GND=(+0.0+(cdsc_Vdi_bi_Tempt_GND/Cox-(cdsc_Vdi_bi*0.0+cdsc_Tempt_GND*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
#endif
T1_Vsi_bi=(cdsc_Vsi_bi/Cox);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vgm_si=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vdbulk_di=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vsbulk_si=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vgi_bi=(+0.0+(0.0/Cox-(cdsc_Vsi_bi*0.0+0.0*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vdi_bi=(+0.0+(cdsc_Vsi_bi_Vdi_bi/Cox-(cdsc_Vsi_bi*0.0+cdsc_Vdi_bi*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Vsi_bi=(+0.0+(cdsc_Vsi_bi_Vsi_bi/Cox-(cdsc_Vsi_bi*0.0+cdsc_Vsi_bi*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
  T1_Vsi_bi_Tempt_GND=(+0.0+(cdsc_Vsi_bi_Tempt_GND/Cox-(cdsc_Vsi_bi*0.0+cdsc_Tempt_GND*0.0+cdsc*0.0)/Cox/Cox+2*cdsc*0.0*0.0/Cox/Cox/Cox));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(cdsc_Tempt_GND/Cox);
#endif
#endif
T1=(1.0+(cdsc/Cox));
EXIT_IF_ISNAN((1.0+(cdsc/Cox)))
{
double m00_sqrt(d00_sqrt0,(((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
n_Vgm_si=(0.5*(T1_Vgm_si+((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  n_Vgm_si_Vgm_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgm_si+((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgm_si+((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))*d10_sqrt0)+0.5*(+(+T1_Vgm_si_Vgm_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))+d10_sqrt0*(+(+(+T1_Vgm_si_Vgm_si-0.0)*(T1-1.0)+T1_Vgm_si*T1_Vgm_si+T1_Vgm_si*T1_Vgm_si+(T1-1.0)*(+T1_Vgm_si_Vgm_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgm_si_Vdbulk_di=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgm_si+((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))*d10_sqrt0)+0.5*(+(+T1_Vgm_si_Vdbulk_di+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))+d10_sqrt0*(+(+(+T1_Vgm_si_Vdbulk_di-0.0)*(T1-1.0)+T1_Vgm_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgm_si+(T1-1.0)*(+T1_Vgm_si_Vdbulk_di-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgm_si_Vsbulk_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgm_si+((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))*d10_sqrt0)+0.5*(+(+T1_Vgm_si_Vsbulk_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))+d10_sqrt0*(+(+(+T1_Vgm_si_Vsbulk_si-0.0)*(T1-1.0)+T1_Vgm_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgm_si+(T1-1.0)*(+T1_Vgm_si_Vsbulk_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgm_si_Vgi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgm_si+((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))*d10_sqrt0)+0.5*(+(+T1_Vgm_si_Vgi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))+d10_sqrt0*(+(+(+T1_Vgm_si_Vgi_bi-0.0)*(T1-1.0)+T1_Vgm_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vgm_si+(T1-1.0)*(+T1_Vgm_si_Vgi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgm_si_Vdi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgm_si+((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))*d10_sqrt0)+0.5*(+(+T1_Vgm_si_Vdi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))+d10_sqrt0*(+(+(+T1_Vgm_si_Vdi_bi-0.0)*(T1-1.0)+T1_Vgm_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vgm_si+(T1-1.0)*(+T1_Vgm_si_Vdi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgm_si_Vsi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgm_si+((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))*d10_sqrt0)+0.5*(+(+T1_Vgm_si_Vsi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))+d10_sqrt0*(+(+(+T1_Vgm_si_Vsi_bi-0.0)*(T1-1.0)+T1_Vgm_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vgm_si+(T1-1.0)*(+T1_Vgm_si_Vsi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgm_si_Tempt_GND=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgm_si+((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))*d10_sqrt0)+0.5*(+(+T1_Vgm_si_Tempt_GND+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si))+d10_sqrt0*(+(+(+T1_Vgm_si_Tempt_GND-0.0)*(T1-1.0)+T1_Vgm_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vgm_si+(T1-1.0)*(+T1_Vgm_si_Tempt_GND-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
#endif
n_Vdbulk_di=(0.5*(T1_Vdbulk_di+((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  n_Vdbulk_di_Vgm_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgm_si+((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vgm_si-0.0)*(T1-1.0)+T1_Vdbulk_di*T1_Vgm_si+T1_Vgm_si*T1_Vdbulk_di+(T1-1.0)*(+T1_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdbulk_di_Vdbulk_di=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vdbulk_di-0.0)*(T1-1.0)+T1_Vdbulk_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdbulk_di+(T1-1.0)*(+T1_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdbulk_di_Vsbulk_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vsbulk_si-0.0)*(T1-1.0)+T1_Vdbulk_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdbulk_di+(T1-1.0)*(+T1_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdbulk_di_Vgi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vgi_bi-0.0)*(T1-1.0)+T1_Vdbulk_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vdbulk_di+(T1-1.0)*(+T1_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdbulk_di_Vdi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vdi_bi-0.0)*(T1-1.0)+T1_Vdbulk_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vdbulk_di+(T1-1.0)*(+T1_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdbulk_di_Vsi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Vsi_bi-0.0)*(T1-1.0)+T1_Vdbulk_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vdbulk_di+(T1-1.0)*(+T1_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdbulk_di_Tempt_GND=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdbulk_di+((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T1_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di))+d10_sqrt0*(+(+(+T1_Vdbulk_di_Tempt_GND-0.0)*(T1-1.0)+T1_Vdbulk_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vdbulk_di+(T1-1.0)*(+T1_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
#endif
n_Vsbulk_si=(0.5*(T1_Vsbulk_si+((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  n_Vsbulk_si_Vgm_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgm_si+((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vgm_si-0.0)*(T1-1.0)+T1_Vsbulk_si*T1_Vgm_si+T1_Vgm_si*T1_Vsbulk_si+(T1-1.0)*(+T1_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsbulk_si_Vdbulk_di=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vdbulk_di-0.0)*(T1-1.0)+T1_Vsbulk_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsbulk_si+(T1-1.0)*(+T1_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsbulk_si_Vsbulk_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vsbulk_si-0.0)*(T1-1.0)+T1_Vsbulk_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsbulk_si+(T1-1.0)*(+T1_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsbulk_si_Vgi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vgi_bi-0.0)*(T1-1.0)+T1_Vsbulk_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vsbulk_si+(T1-1.0)*(+T1_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsbulk_si_Vdi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vdi_bi-0.0)*(T1-1.0)+T1_Vsbulk_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vsbulk_si+(T1-1.0)*(+T1_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsbulk_si_Vsi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Vsi_bi-0.0)*(T1-1.0)+T1_Vsbulk_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vsbulk_si+(T1-1.0)*(+T1_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsbulk_si_Tempt_GND=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsbulk_si+((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T1_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si))+d10_sqrt0*(+(+(+T1_Vsbulk_si_Tempt_GND-0.0)*(T1-1.0)+T1_Vsbulk_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vsbulk_si+(T1-1.0)*(+T1_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
#endif
n_Vgi_bi=(0.5*(T1_Vgi_bi+((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  n_Vgi_bi_Vgm_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgm_si+((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vgm_si-0.0)*(T1-1.0)+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+(T1-1.0)*(+T1_Vgi_bi_Vgm_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgi_bi_Vdbulk_di=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vdbulk_di-0.0)*(T1-1.0)+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+(T1-1.0)*(+T1_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgi_bi_Vsbulk_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vsbulk_si-0.0)*(T1-1.0)+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+(T1-1.0)*(+T1_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgi_bi_Vgi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vgi_bi-0.0)*(T1-1.0)+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+(T1-1.0)*(+T1_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgi_bi_Vdi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vdi_bi-0.0)*(T1-1.0)+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+(T1-1.0)*(+T1_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgi_bi_Vsi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Vsi_bi-0.0)*(T1-1.0)+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+(T1-1.0)*(+T1_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vgi_bi_Tempt_GND=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vgi_bi+((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))*d10_sqrt0)+0.5*(+(+T1_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi))+d10_sqrt0*(+(+(+T1_Vgi_bi_Tempt_GND-0.0)*(T1-1.0)+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+(T1-1.0)*(+T1_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
#endif
n_Vdi_bi=(0.5*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  n_Vdi_bi_Vgm_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgm_si+((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vgm_si-0.0)*(T1-1.0)+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+(T1-1.0)*(+T1_Vdi_bi_Vgm_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vdbulk_di=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vdbulk_di-0.0)*(T1-1.0)+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+(T1-1.0)*(+T1_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vsbulk_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vsbulk_si-0.0)*(T1-1.0)+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+(T1-1.0)*(+T1_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vgi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vgi_bi-0.0)*(T1-1.0)+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+(T1-1.0)*(+T1_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vdi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vdi_bi-0.0)*(T1-1.0)+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+(T1-1.0)*(+T1_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Vsi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Vsi_bi-0.0)*(T1-1.0)+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+(T1-1.0)*(+T1_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vdi_bi_Tempt_GND=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vdi_bi+((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))*d10_sqrt0)+0.5*(+(+T1_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi))+d10_sqrt0*(+(+(+T1_Vdi_bi_Tempt_GND-0.0)*(T1-1.0)+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+(T1-1.0)*(+T1_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
#endif
n_Vsi_bi=(0.5*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  n_Vsi_bi_Vgm_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgm_si+((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgm_si*(T1-1.0))+((T1-1.0)*T1_Vgm_si)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vgm_si-0.0)*(T1-1.0)+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+(T1-1.0)*(+T1_Vsi_bi_Vgm_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vdbulk_di=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdbulk_di+((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdbulk_di*(T1-1.0))+((T1-1.0)*T1_Vdbulk_di)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vdbulk_di-0.0)*(T1-1.0)+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+(T1-1.0)*(+T1_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vsbulk_si=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsbulk_si+((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsbulk_si*(T1-1.0))+((T1-1.0)*T1_Vsbulk_si)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vsbulk_si-0.0)*(T1-1.0)+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+(T1-1.0)*(+T1_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vgi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vgi_bi+((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vgi_bi*(T1-1.0))+((T1-1.0)*T1_Vgi_bi)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vgi_bi-0.0)*(T1-1.0)+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+(T1-1.0)*(+T1_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vdi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vdi_bi+((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vdi_bi*(T1-1.0))+((T1-1.0)*T1_Vdi_bi)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vdi_bi-0.0)*(T1-1.0)+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+(T1-1.0)*(+T1_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Vsi_bi=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Vsi_bi+((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Vsi_bi-0.0)*(T1-1.0)+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+(T1-1.0)*(+T1_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
  n_Vsi_bi_Tempt_GND=(+0.0*((T1+1.0)+d00_sqrt0)+0.0*(T1_Tempt_GND+((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*d10_sqrt0)+0.0*(T1_Vsi_bi+((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))*d10_sqrt0)+0.5*(+(+T1_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))*((((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND)))+((0.0)*0.05))*((T1_Vsi_bi*(T1-1.0))+((T1-1.0)*T1_Vsi_bi))+d10_sqrt0*(+(+(+T1_Vsi_bi_Tempt_GND-0.0)*(T1-1.0)+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+(T1-1.0)*(+T1_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*0.05+0.0*0.0+0.0*0.0+0.25*0.0)*0.05+0.0*0.0+(0.0)*0.0+(0.25*0.05)*0.0)))));
#endif
#if defined(_DERIVATE)
n_Tempt_GND=(0.5*(T1_Tempt_GND+((T1_Tempt_GND*(T1-1.0))+((T1-1.0)*T1_Tempt_GND))*d10_sqrt0));
#endif
#endif
n=(0.5*((T1+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T1+1.0)+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
nVt_Vgm_si=n_Vgm_si*Vt;
#if defined(_DERIVATE2)
  nVt_Vgm_si_Vgm_si=(+n_Vgm_si_Vgm_si*Vt+n_Vgm_si*0.0+n_Vgm_si*0.0+n*0.0);
  nVt_Vgm_si_Vdbulk_di=(+n_Vgm_si_Vdbulk_di*Vt+n_Vgm_si*0.0+n_Vdbulk_di*0.0+n*0.0);
  nVt_Vgm_si_Vsbulk_si=(+n_Vgm_si_Vsbulk_si*Vt+n_Vgm_si*0.0+n_Vsbulk_si*0.0+n*0.0);
  nVt_Vgm_si_Vgi_bi=(+n_Vgm_si_Vgi_bi*Vt+n_Vgm_si*0.0+n_Vgi_bi*0.0+n*0.0);
  nVt_Vgm_si_Vdi_bi=(+n_Vgm_si_Vdi_bi*Vt+n_Vgm_si*0.0+n_Vdi_bi*0.0+n*0.0);
  nVt_Vgm_si_Vsi_bi=(+n_Vgm_si_Vsi_bi*Vt+n_Vgm_si*0.0+n_Vsi_bi*0.0+n*0.0);
  nVt_Vgm_si_Tempt_GND=(+n_Vgm_si_Tempt_GND*Vt+n_Vgm_si*Vt_Tempt_GND+n_Tempt_GND*0.0+n*0.0);
#endif
nVt_Vdbulk_di=n_Vdbulk_di*Vt;
#if defined(_DERIVATE2)
  nVt_Vdbulk_di_Vgm_si=(+n_Vdbulk_di_Vgm_si*Vt+n_Vdbulk_di*0.0+n_Vgm_si*0.0+n*0.0);
  nVt_Vdbulk_di_Vdbulk_di=(+n_Vdbulk_di_Vdbulk_di*Vt+n_Vdbulk_di*0.0+n_Vdbulk_di*0.0+n*0.0);
  nVt_Vdbulk_di_Vsbulk_si=(+n_Vdbulk_di_Vsbulk_si*Vt+n_Vdbulk_di*0.0+n_Vsbulk_si*0.0+n*0.0);
  nVt_Vdbulk_di_Vgi_bi=(+n_Vdbulk_di_Vgi_bi*Vt+n_Vdbulk_di*0.0+n_Vgi_bi*0.0+n*0.0);
  nVt_Vdbulk_di_Vdi_bi=(+n_Vdbulk_di_Vdi_bi*Vt+n_Vdbulk_di*0.0+n_Vdi_bi*0.0+n*0.0);
  nVt_Vdbulk_di_Vsi_bi=(+n_Vdbulk_di_Vsi_bi*Vt+n_Vdbulk_di*0.0+n_Vsi_bi*0.0+n*0.0);
  nVt_Vdbulk_di_Tempt_GND=(+n_Vdbulk_di_Tempt_GND*Vt+n_Vdbulk_di*Vt_Tempt_GND+n_Tempt_GND*0.0+n*0.0);
#endif
nVt_Vsbulk_si=n_Vsbulk_si*Vt;
#if defined(_DERIVATE2)
  nVt_Vsbulk_si_Vgm_si=(+n_Vsbulk_si_Vgm_si*Vt+n_Vsbulk_si*0.0+n_Vgm_si*0.0+n*0.0);
  nVt_Vsbulk_si_Vdbulk_di=(+n_Vsbulk_si_Vdbulk_di*Vt+n_Vsbulk_si*0.0+n_Vdbulk_di*0.0+n*0.0);
  nVt_Vsbulk_si_Vsbulk_si=(+n_Vsbulk_si_Vsbulk_si*Vt+n_Vsbulk_si*0.0+n_Vsbulk_si*0.0+n*0.0);
  nVt_Vsbulk_si_Vgi_bi=(+n_Vsbulk_si_Vgi_bi*Vt+n_Vsbulk_si*0.0+n_Vgi_bi*0.0+n*0.0);
  nVt_Vsbulk_si_Vdi_bi=(+n_Vsbulk_si_Vdi_bi*Vt+n_Vsbulk_si*0.0+n_Vdi_bi*0.0+n*0.0);
  nVt_Vsbulk_si_Vsi_bi=(+n_Vsbulk_si_Vsi_bi*Vt+n_Vsbulk_si*0.0+n_Vsi_bi*0.0+n*0.0);
  nVt_Vsbulk_si_Tempt_GND=(+n_Vsbulk_si_Tempt_GND*Vt+n_Vsbulk_si*Vt_Tempt_GND+n_Tempt_GND*0.0+n*0.0);
#endif
nVt_Vgi_bi=n_Vgi_bi*Vt;
#if defined(_DERIVATE2)
  nVt_Vgi_bi_Vgm_si=(+n_Vgi_bi_Vgm_si*Vt+n_Vgi_bi*0.0+n_Vgm_si*0.0+n*0.0);
  nVt_Vgi_bi_Vdbulk_di=(+n_Vgi_bi_Vdbulk_di*Vt+n_Vgi_bi*0.0+n_Vdbulk_di*0.0+n*0.0);
  nVt_Vgi_bi_Vsbulk_si=(+n_Vgi_bi_Vsbulk_si*Vt+n_Vgi_bi*0.0+n_Vsbulk_si*0.0+n*0.0);
  nVt_Vgi_bi_Vgi_bi=(+n_Vgi_bi_Vgi_bi*Vt+n_Vgi_bi*0.0+n_Vgi_bi*0.0+n*0.0);
  nVt_Vgi_bi_Vdi_bi=(+n_Vgi_bi_Vdi_bi*Vt+n_Vgi_bi*0.0+n_Vdi_bi*0.0+n*0.0);
  nVt_Vgi_bi_Vsi_bi=(+n_Vgi_bi_Vsi_bi*Vt+n_Vgi_bi*0.0+n_Vsi_bi*0.0+n*0.0);
  nVt_Vgi_bi_Tempt_GND=(+n_Vgi_bi_Tempt_GND*Vt+n_Vgi_bi*Vt_Tempt_GND+n_Tempt_GND*0.0+n*0.0);
#endif
nVt_Vdi_bi=n_Vdi_bi*Vt;
#if defined(_DERIVATE2)
  nVt_Vdi_bi_Vgm_si=(+n_Vdi_bi_Vgm_si*Vt+n_Vdi_bi*0.0+n_Vgm_si*0.0+n*0.0);
  nVt_Vdi_bi_Vdbulk_di=(+n_Vdi_bi_Vdbulk_di*Vt+n_Vdi_bi*0.0+n_Vdbulk_di*0.0+n*0.0);
  nVt_Vdi_bi_Vsbulk_si=(+n_Vdi_bi_Vsbulk_si*Vt+n_Vdi_bi*0.0+n_Vsbulk_si*0.0+n*0.0);
  nVt_Vdi_bi_Vgi_bi=(+n_Vdi_bi_Vgi_bi*Vt+n_Vdi_bi*0.0+n_Vgi_bi*0.0+n*0.0);
  nVt_Vdi_bi_Vdi_bi=(+n_Vdi_bi_Vdi_bi*Vt+n_Vdi_bi*0.0+n_Vdi_bi*0.0+n*0.0);
  nVt_Vdi_bi_Vsi_bi=(+n_Vdi_bi_Vsi_bi*Vt+n_Vdi_bi*0.0+n_Vsi_bi*0.0+n*0.0);
  nVt_Vdi_bi_Tempt_GND=(+n_Vdi_bi_Tempt_GND*Vt+n_Vdi_bi*Vt_Tempt_GND+n_Tempt_GND*0.0+n*0.0);
#endif
nVt_Vsi_bi=n_Vsi_bi*Vt;
#if defined(_DERIVATE2)
  nVt_Vsi_bi_Vgm_si=(+n_Vsi_bi_Vgm_si*Vt+n_Vsi_bi*0.0+n_Vgm_si*0.0+n*0.0);
  nVt_Vsi_bi_Vdbulk_di=(+n_Vsi_bi_Vdbulk_di*Vt+n_Vsi_bi*0.0+n_Vdbulk_di*0.0+n*0.0);
  nVt_Vsi_bi_Vsbulk_si=(+n_Vsi_bi_Vsbulk_si*Vt+n_Vsi_bi*0.0+n_Vsbulk_si*0.0+n*0.0);
  nVt_Vsi_bi_Vgi_bi=(+n_Vsi_bi_Vgi_bi*Vt+n_Vsi_bi*0.0+n_Vgi_bi*0.0+n*0.0);
  nVt_Vsi_bi_Vdi_bi=(+n_Vsi_bi_Vdi_bi*Vt+n_Vsi_bi*0.0+n_Vdi_bi*0.0+n*0.0);
  nVt_Vsi_bi_Vsi_bi=(+n_Vsi_bi_Vsi_bi*Vt+n_Vsi_bi*0.0+n_Vsi_bi*0.0+n*0.0);
  nVt_Vsi_bi_Tempt_GND=(+n_Vsi_bi_Tempt_GND*Vt+n_Vsi_bi*Vt_Tempt_GND+n_Tempt_GND*0.0+n*0.0);
#endif
#if defined(_DERIVATE)
nVt_Tempt_GND=((n_Tempt_GND*Vt)+(n*Vt_Tempt_GND));
#endif
#endif
nVt=(n*Vt);
EXIT_IF_ISNAN((n*Vt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
inv_nVt_Vgm_si=(-nVt_Vgm_si/nVt/nVt);
#if defined(_DERIVATE2)
  inv_nVt_Vgm_si_Vgm_si=(0.0/nVt-(0.0*nVt_Vgm_si+0.0*nVt_Vgm_si+1.0*nVt_Vgm_si_Vgm_si)/nVt/nVt+2*1.0*nVt_Vgm_si*nVt_Vgm_si/nVt/nVt/nVt);
  inv_nVt_Vgm_si_Vdbulk_di=(0.0/nVt-(0.0*nVt_Vdbulk_di+0.0*nVt_Vgm_si+1.0*nVt_Vgm_si_Vdbulk_di)/nVt/nVt+2*1.0*nVt_Vgm_si*nVt_Vdbulk_di/nVt/nVt/nVt);
  inv_nVt_Vgm_si_Vsbulk_si=(0.0/nVt-(0.0*nVt_Vsbulk_si+0.0*nVt_Vgm_si+1.0*nVt_Vgm_si_Vsbulk_si)/nVt/nVt+2*1.0*nVt_Vgm_si*nVt_Vsbulk_si/nVt/nVt/nVt);
  inv_nVt_Vgm_si_Vgi_bi=(0.0/nVt-(0.0*nVt_Vgi_bi+0.0*nVt_Vgm_si+1.0*nVt_Vgm_si_Vgi_bi)/nVt/nVt+2*1.0*nVt_Vgm_si*nVt_Vgi_bi/nVt/nVt/nVt);
  inv_nVt_Vgm_si_Vdi_bi=(0.0/nVt-(0.0*nVt_Vdi_bi+0.0*nVt_Vgm_si+1.0*nVt_Vgm_si_Vdi_bi)/nVt/nVt+2*1.0*nVt_Vgm_si*nVt_Vdi_bi/nVt/nVt/nVt);
  inv_nVt_Vgm_si_Vsi_bi=(0.0/nVt-(0.0*nVt_Vsi_bi+0.0*nVt_Vgm_si+1.0*nVt_Vgm_si_Vsi_bi)/nVt/nVt+2*1.0*nVt_Vgm_si*nVt_Vsi_bi/nVt/nVt/nVt);
  inv_nVt_Vgm_si_Tempt_GND=(0.0/nVt-(0.0*nVt_Tempt_GND+0.0*nVt_Vgm_si+1.0*nVt_Vgm_si_Tempt_GND)/nVt/nVt+2*1.0*nVt_Vgm_si*nVt_Tempt_GND/nVt/nVt/nVt);
#endif
inv_nVt_Vdbulk_di=(-nVt_Vdbulk_di/nVt/nVt);
#if defined(_DERIVATE2)
  inv_nVt_Vdbulk_di_Vgm_si=(0.0/nVt-(0.0*nVt_Vgm_si+0.0*nVt_Vdbulk_di+1.0*nVt_Vdbulk_di_Vgm_si)/nVt/nVt+2*1.0*nVt_Vdbulk_di*nVt_Vgm_si/nVt/nVt/nVt);
  inv_nVt_Vdbulk_di_Vdbulk_di=(0.0/nVt-(0.0*nVt_Vdbulk_di+0.0*nVt_Vdbulk_di+1.0*nVt_Vdbulk_di_Vdbulk_di)/nVt/nVt+2*1.0*nVt_Vdbulk_di*nVt_Vdbulk_di/nVt/nVt/nVt);
  inv_nVt_Vdbulk_di_Vsbulk_si=(0.0/nVt-(0.0*nVt_Vsbulk_si+0.0*nVt_Vdbulk_di+1.0*nVt_Vdbulk_di_Vsbulk_si)/nVt/nVt+2*1.0*nVt_Vdbulk_di*nVt_Vsbulk_si/nVt/nVt/nVt);
  inv_nVt_Vdbulk_di_Vgi_bi=(0.0/nVt-(0.0*nVt_Vgi_bi+0.0*nVt_Vdbulk_di+1.0*nVt_Vdbulk_di_Vgi_bi)/nVt/nVt+2*1.0*nVt_Vdbulk_di*nVt_Vgi_bi/nVt/nVt/nVt);
  inv_nVt_Vdbulk_di_Vdi_bi=(0.0/nVt-(0.0*nVt_Vdi_bi+0.0*nVt_Vdbulk_di+1.0*nVt_Vdbulk_di_Vdi_bi)/nVt/nVt+2*1.0*nVt_Vdbulk_di*nVt_Vdi_bi/nVt/nVt/nVt);
  inv_nVt_Vdbulk_di_Vsi_bi=(0.0/nVt-(0.0*nVt_Vsi_bi+0.0*nVt_Vdbulk_di+1.0*nVt_Vdbulk_di_Vsi_bi)/nVt/nVt+2*1.0*nVt_Vdbulk_di*nVt_Vsi_bi/nVt/nVt/nVt);
  inv_nVt_Vdbulk_di_Tempt_GND=(0.0/nVt-(0.0*nVt_Tempt_GND+0.0*nVt_Vdbulk_di+1.0*nVt_Vdbulk_di_Tempt_GND)/nVt/nVt+2*1.0*nVt_Vdbulk_di*nVt_Tempt_GND/nVt/nVt/nVt);
#endif
inv_nVt_Vsbulk_si=(-nVt_Vsbulk_si/nVt/nVt);
#if defined(_DERIVATE2)
  inv_nVt_Vsbulk_si_Vgm_si=(0.0/nVt-(0.0*nVt_Vgm_si+0.0*nVt_Vsbulk_si+1.0*nVt_Vsbulk_si_Vgm_si)/nVt/nVt+2*1.0*nVt_Vsbulk_si*nVt_Vgm_si/nVt/nVt/nVt);
  inv_nVt_Vsbulk_si_Vdbulk_di=(0.0/nVt-(0.0*nVt_Vdbulk_di+0.0*nVt_Vsbulk_si+1.0*nVt_Vsbulk_si_Vdbulk_di)/nVt/nVt+2*1.0*nVt_Vsbulk_si*nVt_Vdbulk_di/nVt/nVt/nVt);
  inv_nVt_Vsbulk_si_Vsbulk_si=(0.0/nVt-(0.0*nVt_Vsbulk_si+0.0*nVt_Vsbulk_si+1.0*nVt_Vsbulk_si_Vsbulk_si)/nVt/nVt+2*1.0*nVt_Vsbulk_si*nVt_Vsbulk_si/nVt/nVt/nVt);
  inv_nVt_Vsbulk_si_Vgi_bi=(0.0/nVt-(0.0*nVt_Vgi_bi+0.0*nVt_Vsbulk_si+1.0*nVt_Vsbulk_si_Vgi_bi)/nVt/nVt+2*1.0*nVt_Vsbulk_si*nVt_Vgi_bi/nVt/nVt/nVt);
  inv_nVt_Vsbulk_si_Vdi_bi=(0.0/nVt-(0.0*nVt_Vdi_bi+0.0*nVt_Vsbulk_si+1.0*nVt_Vsbulk_si_Vdi_bi)/nVt/nVt+2*1.0*nVt_Vsbulk_si*nVt_Vdi_bi/nVt/nVt/nVt);
  inv_nVt_Vsbulk_si_Vsi_bi=(0.0/nVt-(0.0*nVt_Vsi_bi+0.0*nVt_Vsbulk_si+1.0*nVt_Vsbulk_si_Vsi_bi)/nVt/nVt+2*1.0*nVt_Vsbulk_si*nVt_Vsi_bi/nVt/nVt/nVt);
  inv_nVt_Vsbulk_si_Tempt_GND=(0.0/nVt-(0.0*nVt_Tempt_GND+0.0*nVt_Vsbulk_si+1.0*nVt_Vsbulk_si_Tempt_GND)/nVt/nVt+2*1.0*nVt_Vsbulk_si*nVt_Tempt_GND/nVt/nVt/nVt);
#endif
inv_nVt_Vgi_bi=(-nVt_Vgi_bi/nVt/nVt);
#if defined(_DERIVATE2)
  inv_nVt_Vgi_bi_Vgm_si=(0.0/nVt-(0.0*nVt_Vgm_si+0.0*nVt_Vgi_bi+1.0*nVt_Vgi_bi_Vgm_si)/nVt/nVt+2*1.0*nVt_Vgi_bi*nVt_Vgm_si/nVt/nVt/nVt);
  inv_nVt_Vgi_bi_Vdbulk_di=(0.0/nVt-(0.0*nVt_Vdbulk_di+0.0*nVt_Vgi_bi+1.0*nVt_Vgi_bi_Vdbulk_di)/nVt/nVt+2*1.0*nVt_Vgi_bi*nVt_Vdbulk_di/nVt/nVt/nVt);
  inv_nVt_Vgi_bi_Vsbulk_si=(0.0/nVt-(0.0*nVt_Vsbulk_si+0.0*nVt_Vgi_bi+1.0*nVt_Vgi_bi_Vsbulk_si)/nVt/nVt+2*1.0*nVt_Vgi_bi*nVt_Vsbulk_si/nVt/nVt/nVt);
  inv_nVt_Vgi_bi_Vgi_bi=(0.0/nVt-(0.0*nVt_Vgi_bi+0.0*nVt_Vgi_bi+1.0*nVt_Vgi_bi_Vgi_bi)/nVt/nVt+2*1.0*nVt_Vgi_bi*nVt_Vgi_bi/nVt/nVt/nVt);
  inv_nVt_Vgi_bi_Vdi_bi=(0.0/nVt-(0.0*nVt_Vdi_bi+0.0*nVt_Vgi_bi+1.0*nVt_Vgi_bi_Vdi_bi)/nVt/nVt+2*1.0*nVt_Vgi_bi*nVt_Vdi_bi/nVt/nVt/nVt);
  inv_nVt_Vgi_bi_Vsi_bi=(0.0/nVt-(0.0*nVt_Vsi_bi+0.0*nVt_Vgi_bi+1.0*nVt_Vgi_bi_Vsi_bi)/nVt/nVt+2*1.0*nVt_Vgi_bi*nVt_Vsi_bi/nVt/nVt/nVt);
  inv_nVt_Vgi_bi_Tempt_GND=(0.0/nVt-(0.0*nVt_Tempt_GND+0.0*nVt_Vgi_bi+1.0*nVt_Vgi_bi_Tempt_GND)/nVt/nVt+2*1.0*nVt_Vgi_bi*nVt_Tempt_GND/nVt/nVt/nVt);
#endif
inv_nVt_Vdi_bi=(-nVt_Vdi_bi/nVt/nVt);
#if defined(_DERIVATE2)
  inv_nVt_Vdi_bi_Vgm_si=(0.0/nVt-(0.0*nVt_Vgm_si+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vgm_si)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vgm_si/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vdbulk_di=(0.0/nVt-(0.0*nVt_Vdbulk_di+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vdbulk_di)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vdbulk_di/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vsbulk_si=(0.0/nVt-(0.0*nVt_Vsbulk_si+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vsbulk_si)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vsbulk_si/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vgi_bi=(0.0/nVt-(0.0*nVt_Vgi_bi+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vgi_bi)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vgi_bi/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vdi_bi=(0.0/nVt-(0.0*nVt_Vdi_bi+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vdi_bi)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vdi_bi/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Vsi_bi=(0.0/nVt-(0.0*nVt_Vsi_bi+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Vsi_bi)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Vsi_bi/nVt/nVt/nVt);
  inv_nVt_Vdi_bi_Tempt_GND=(0.0/nVt-(0.0*nVt_Tempt_GND+0.0*nVt_Vdi_bi+1.0*nVt_Vdi_bi_Tempt_GND)/nVt/nVt+2*1.0*nVt_Vdi_bi*nVt_Tempt_GND/nVt/nVt/nVt);
#endif
inv_nVt_Vsi_bi=(-nVt_Vsi_bi/nVt/nVt);
#if defined(_DERIVATE2)
  inv_nVt_Vsi_bi_Vgm_si=(0.0/nVt-(0.0*nVt_Vgm_si+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vgm_si)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vgm_si/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vdbulk_di=(0.0/nVt-(0.0*nVt_Vdbulk_di+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vdbulk_di)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vdbulk_di/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vsbulk_si=(0.0/nVt-(0.0*nVt_Vsbulk_si+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vsbulk_si)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vsbulk_si/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vgi_bi=(0.0/nVt-(0.0*nVt_Vgi_bi+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vgi_bi)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vgi_bi/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vdi_bi=(0.0/nVt-(0.0*nVt_Vdi_bi+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vdi_bi)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vdi_bi/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Vsi_bi=(0.0/nVt-(0.0*nVt_Vsi_bi+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Vsi_bi)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Vsi_bi/nVt/nVt/nVt);
  inv_nVt_Vsi_bi_Tempt_GND=(0.0/nVt-(0.0*nVt_Tempt_GND+0.0*nVt_Vsi_bi+1.0*nVt_Vsi_bi_Tempt_GND)/nVt/nVt+2*1.0*nVt_Vsi_bi*nVt_Tempt_GND/nVt/nVt/nVt);
#endif
#if defined(_DERIVATE)
inv_nVt_Tempt_GND=(-nVt_Tempt_GND/nVt/nVt);
#endif
#endif
inv_nVt=(1.0/nVt);
EXIT_IF_ISNAN((1.0/nVt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vg_Vgm_si=(Vg*inv_nVt_Vgm_si);
#if defined(_DERIVATE2)
  vg_Vgm_si_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vgm_si+Vg*inv_nVt_Vgm_si_Vgm_si);
  vg_Vgm_si_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vgm_si+Vg*inv_nVt_Vgm_si_Vdbulk_di);
  vg_Vgm_si_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vgm_si+Vg*inv_nVt_Vgm_si_Vsbulk_si);
  vg_Vgm_si_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+Vg_Vgi_bi*inv_nVt_Vgm_si+Vg*inv_nVt_Vgm_si_Vgi_bi);
  vg_Vgm_si_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vgm_si+Vg*inv_nVt_Vgm_si_Vdi_bi);
  vg_Vgm_si_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vgm_si+Vg*inv_nVt_Vgm_si_Vsi_bi);
  vg_Vgm_si_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vgm_si+Vg*inv_nVt_Vgm_si_Tempt_GND);
#endif
vg_Vdbulk_di=(Vg*inv_nVt_Vdbulk_di);
#if defined(_DERIVATE2)
  vg_Vdbulk_di_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vdbulk_di+Vg*inv_nVt_Vdbulk_di_Vgm_si);
  vg_Vdbulk_di_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vdbulk_di+Vg*inv_nVt_Vdbulk_di_Vdbulk_di);
  vg_Vdbulk_di_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vdbulk_di+Vg*inv_nVt_Vdbulk_di_Vsbulk_si);
  vg_Vdbulk_di_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+Vg_Vgi_bi*inv_nVt_Vdbulk_di+Vg*inv_nVt_Vdbulk_di_Vgi_bi);
  vg_Vdbulk_di_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vdbulk_di+Vg*inv_nVt_Vdbulk_di_Vdi_bi);
  vg_Vdbulk_di_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vdbulk_di+Vg*inv_nVt_Vdbulk_di_Vsi_bi);
  vg_Vdbulk_di_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vdbulk_di+Vg*inv_nVt_Vdbulk_di_Tempt_GND);
#endif
vg_Vsbulk_si=(Vg*inv_nVt_Vsbulk_si);
#if defined(_DERIVATE2)
  vg_Vsbulk_si_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vsbulk_si+Vg*inv_nVt_Vsbulk_si_Vgm_si);
  vg_Vsbulk_si_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vsbulk_si+Vg*inv_nVt_Vsbulk_si_Vdbulk_di);
  vg_Vsbulk_si_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vsbulk_si+Vg*inv_nVt_Vsbulk_si_Vsbulk_si);
  vg_Vsbulk_si_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+Vg_Vgi_bi*inv_nVt_Vsbulk_si+Vg*inv_nVt_Vsbulk_si_Vgi_bi);
  vg_Vsbulk_si_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vsbulk_si+Vg*inv_nVt_Vsbulk_si_Vdi_bi);
  vg_Vsbulk_si_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vsbulk_si+Vg*inv_nVt_Vsbulk_si_Vsi_bi);
  vg_Vsbulk_si_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vsbulk_si+Vg*inv_nVt_Vsbulk_si_Tempt_GND);
#endif
vg_Vgi_bi=((Vg_Vgi_bi*inv_nVt)+(Vg*inv_nVt_Vgi_bi));
#if defined(_DERIVATE2)
  vg_Vgi_bi_Vgm_si=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vgm_si+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vgm_si);
  vg_Vgi_bi_Vdbulk_di=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vdbulk_di);
  vg_Vgi_bi_Vsbulk_si=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vsbulk_si);
  vg_Vgi_bi_Vgi_bi=(+Vg_Vgi_bi_Vgi_bi*inv_nVt+Vg_Vgi_bi*inv_nVt_Vgi_bi+Vg_Vgi_bi*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vgi_bi);
  vg_Vgi_bi_Vdi_bi=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vdi_bi+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vdi_bi);
  vg_Vgi_bi_Vsi_bi=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Vsi_bi+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Vsi_bi);
  vg_Vgi_bi_Tempt_GND=(+0.0*inv_nVt+Vg_Vgi_bi*inv_nVt_Tempt_GND+0.0*inv_nVt_Vgi_bi+Vg*inv_nVt_Vgi_bi_Tempt_GND);
#endif
vg_Vdi_bi=(Vg*inv_nVt_Vdi_bi);
#if defined(_DERIVATE2)
  vg_Vdi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vgm_si);
  vg_Vdi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vdbulk_di);
  vg_Vdi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vsbulk_si);
  vg_Vdi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+Vg_Vgi_bi*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vgi_bi);
  vg_Vdi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vdi_bi);
  vg_Vdi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Vsi_bi);
  vg_Vdi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vdi_bi+Vg*inv_nVt_Vdi_bi_Tempt_GND);
#endif
vg_Vsi_bi=(Vg*inv_nVt_Vsi_bi);
#if defined(_DERIVATE2)
  vg_Vsi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vgm_si);
  vg_Vsi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vdbulk_di);
  vg_Vsi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vsbulk_si);
  vg_Vsi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+Vg_Vgi_bi*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vgi_bi);
  vg_Vsi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vdi_bi);
  vg_Vsi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Vsi_bi);
  vg_Vsi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vsi_bi+Vg*inv_nVt_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
vg_Tempt_GND=(Vg*inv_nVt_Tempt_GND);
#endif
#endif
vg=(Vg*inv_nVt);
EXIT_IF_ISNAN((Vg*inv_nVt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
vs_Vgm_si=(Vs*inv_nVt_Vgm_si);
#if defined(_DERIVATE2)
  vs_Vgm_si_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vgm_si+Vs*inv_nVt_Vgm_si_Vgm_si);
  vs_Vgm_si_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vgm_si+Vs*inv_nVt_Vgm_si_Vdbulk_di);
  vs_Vgm_si_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vgm_si+Vs*inv_nVt_Vgm_si_Vsbulk_si);
  vs_Vgm_si_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vgm_si+Vs*inv_nVt_Vgm_si_Vgi_bi);
  vs_Vgm_si_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+Vs_Vdi_bi*inv_nVt_Vgm_si+Vs*inv_nVt_Vgm_si_Vdi_bi);
  vs_Vgm_si_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+Vs_Vsi_bi*inv_nVt_Vgm_si+Vs*inv_nVt_Vgm_si_Vsi_bi);
  vs_Vgm_si_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vgm_si+Vs*inv_nVt_Vgm_si_Tempt_GND);
#endif
vs_Vdbulk_di=(Vs*inv_nVt_Vdbulk_di);
#if defined(_DERIVATE2)
  vs_Vdbulk_di_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vdbulk_di+Vs*inv_nVt_Vdbulk_di_Vgm_si);
  vs_Vdbulk_di_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vdbulk_di+Vs*inv_nVt_Vdbulk_di_Vdbulk_di);
  vs_Vdbulk_di_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vdbulk_di+Vs*inv_nVt_Vdbulk_di_Vsbulk_si);
  vs_Vdbulk_di_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vdbulk_di+Vs*inv_nVt_Vdbulk_di_Vgi_bi);
  vs_Vdbulk_di_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+Vs_Vdi_bi*inv_nVt_Vdbulk_di+Vs*inv_nVt_Vdbulk_di_Vdi_bi);
  vs_Vdbulk_di_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+Vs_Vsi_bi*inv_nVt_Vdbulk_di+Vs*inv_nVt_Vdbulk_di_Vsi_bi);
  vs_Vdbulk_di_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vdbulk_di+Vs*inv_nVt_Vdbulk_di_Tempt_GND);
#endif
vs_Vsbulk_si=(Vs*inv_nVt_Vsbulk_si);
#if defined(_DERIVATE2)
  vs_Vsbulk_si_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vsbulk_si+Vs*inv_nVt_Vsbulk_si_Vgm_si);
  vs_Vsbulk_si_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vsbulk_si+Vs*inv_nVt_Vsbulk_si_Vdbulk_di);
  vs_Vsbulk_si_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vsbulk_si+Vs*inv_nVt_Vsbulk_si_Vsbulk_si);
  vs_Vsbulk_si_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vsbulk_si+Vs*inv_nVt_Vsbulk_si_Vgi_bi);
  vs_Vsbulk_si_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+Vs_Vdi_bi*inv_nVt_Vsbulk_si+Vs*inv_nVt_Vsbulk_si_Vdi_bi);
  vs_Vsbulk_si_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+Vs_Vsi_bi*inv_nVt_Vsbulk_si+Vs*inv_nVt_Vsbulk_si_Vsi_bi);
  vs_Vsbulk_si_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vsbulk_si+Vs*inv_nVt_Vsbulk_si_Tempt_GND);
#endif
vs_Vgi_bi=(Vs*inv_nVt_Vgi_bi);
#if defined(_DERIVATE2)
  vs_Vgi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vgi_bi+Vs*inv_nVt_Vgi_bi_Vgm_si);
  vs_Vgi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vgi_bi+Vs*inv_nVt_Vgi_bi_Vdbulk_di);
  vs_Vgi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vgi_bi+Vs*inv_nVt_Vgi_bi_Vsbulk_si);
  vs_Vgi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vgi_bi+Vs*inv_nVt_Vgi_bi_Vgi_bi);
  vs_Vgi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+Vs_Vdi_bi*inv_nVt_Vgi_bi+Vs*inv_nVt_Vgi_bi_Vdi_bi);
  vs_Vgi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+Vs_Vsi_bi*inv_nVt_Vgi_bi+Vs*inv_nVt_Vgi_bi_Vsi_bi);
  vs_Vgi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vgi_bi+Vs*inv_nVt_Vgi_bi_Tempt_GND);
#endif
vs_Vdi_bi=((Vs_Vdi_bi*inv_nVt)+(Vs*inv_nVt_Vdi_bi));
#if defined(_DERIVATE2)
  vs_Vdi_bi_Vgm_si=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Vgm_si+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vgm_si);
  vs_Vdi_bi_Vdbulk_di=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vdbulk_di);
  vs_Vdi_bi_Vsbulk_si=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vsbulk_si);
  vs_Vdi_bi_Vgi_bi=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Vgi_bi+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vgi_bi);
  vs_Vdi_bi_Vdi_bi=(+Vs_Vdi_bi_Vdi_bi*inv_nVt+Vs_Vdi_bi*inv_nVt_Vdi_bi+Vs_Vdi_bi*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vdi_bi);
  vs_Vdi_bi_Vsi_bi=(+Vs_Vdi_bi_Vsi_bi*inv_nVt+Vs_Vdi_bi*inv_nVt_Vsi_bi+Vs_Vsi_bi*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Vsi_bi);
  vs_Vdi_bi_Tempt_GND=(+0.0*inv_nVt+Vs_Vdi_bi*inv_nVt_Tempt_GND+0.0*inv_nVt_Vdi_bi+Vs*inv_nVt_Vdi_bi_Tempt_GND);
#endif
vs_Vsi_bi=((Vs_Vsi_bi*inv_nVt)+(Vs*inv_nVt_Vsi_bi));
#if defined(_DERIVATE2)
  vs_Vsi_bi_Vgm_si=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Vgm_si+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vgm_si);
  vs_Vsi_bi_Vdbulk_di=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vdbulk_di);
  vs_Vsi_bi_Vsbulk_si=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vsbulk_si);
  vs_Vsi_bi_Vgi_bi=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Vgi_bi+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vgi_bi);
  vs_Vsi_bi_Vdi_bi=(+Vs_Vsi_bi_Vdi_bi*inv_nVt+Vs_Vsi_bi*inv_nVt_Vdi_bi+Vs_Vdi_bi*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vdi_bi);
  vs_Vsi_bi_Vsi_bi=(+Vs_Vsi_bi_Vsi_bi*inv_nVt+Vs_Vsi_bi*inv_nVt_Vsi_bi+Vs_Vsi_bi*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Vsi_bi);
  vs_Vsi_bi_Tempt_GND=(+0.0*inv_nVt+Vs_Vsi_bi*inv_nVt_Tempt_GND+0.0*inv_nVt_Vsi_bi+Vs*inv_nVt_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
vs_Tempt_GND=(Vs*inv_nVt_Tempt_GND);
#endif
#endif
vs=(Vs*inv_nVt);
EXIT_IF_ISNAN((Vs*inv_nVt))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vfb_Vgm_si=(VFB_i*inv_nVt_Vgm_si);
#if defined(_DERIVATE2)
  vfb_Vgm_si_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vgm_si+VFB_i*inv_nVt_Vgm_si_Vgm_si);
  vfb_Vgm_si_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vgm_si+VFB_i*inv_nVt_Vgm_si_Vdbulk_di);
  vfb_Vgm_si_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vgm_si+VFB_i*inv_nVt_Vgm_si_Vsbulk_si);
  vfb_Vgm_si_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vgm_si+VFB_i*inv_nVt_Vgm_si_Vgi_bi);
  vfb_Vgm_si_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vgm_si+VFB_i*inv_nVt_Vgm_si_Vdi_bi);
  vfb_Vgm_si_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vgm_si+VFB_i*inv_nVt_Vgm_si_Vsi_bi);
  vfb_Vgm_si_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vgm_si+VFB_i*inv_nVt_Vgm_si_Tempt_GND);
#endif
vfb_Vdbulk_di=(VFB_i*inv_nVt_Vdbulk_di);
#if defined(_DERIVATE2)
  vfb_Vdbulk_di_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vdbulk_di+VFB_i*inv_nVt_Vdbulk_di_Vgm_si);
  vfb_Vdbulk_di_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vdbulk_di+VFB_i*inv_nVt_Vdbulk_di_Vdbulk_di);
  vfb_Vdbulk_di_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vdbulk_di+VFB_i*inv_nVt_Vdbulk_di_Vsbulk_si);
  vfb_Vdbulk_di_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vdbulk_di+VFB_i*inv_nVt_Vdbulk_di_Vgi_bi);
  vfb_Vdbulk_di_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vdbulk_di+VFB_i*inv_nVt_Vdbulk_di_Vdi_bi);
  vfb_Vdbulk_di_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vdbulk_di+VFB_i*inv_nVt_Vdbulk_di_Vsi_bi);
  vfb_Vdbulk_di_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vdbulk_di+VFB_i*inv_nVt_Vdbulk_di_Tempt_GND);
#endif
vfb_Vsbulk_si=(VFB_i*inv_nVt_Vsbulk_si);
#if defined(_DERIVATE2)
  vfb_Vsbulk_si_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vsbulk_si+VFB_i*inv_nVt_Vsbulk_si_Vgm_si);
  vfb_Vsbulk_si_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vsbulk_si+VFB_i*inv_nVt_Vsbulk_si_Vdbulk_di);
  vfb_Vsbulk_si_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vsbulk_si+VFB_i*inv_nVt_Vsbulk_si_Vsbulk_si);
  vfb_Vsbulk_si_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vsbulk_si+VFB_i*inv_nVt_Vsbulk_si_Vgi_bi);
  vfb_Vsbulk_si_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vsbulk_si+VFB_i*inv_nVt_Vsbulk_si_Vdi_bi);
  vfb_Vsbulk_si_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vsbulk_si+VFB_i*inv_nVt_Vsbulk_si_Vsi_bi);
  vfb_Vsbulk_si_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vsbulk_si+VFB_i*inv_nVt_Vsbulk_si_Tempt_GND);
#endif
vfb_Vgi_bi=(VFB_i*inv_nVt_Vgi_bi);
#if defined(_DERIVATE2)
  vfb_Vgi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vgi_bi+VFB_i*inv_nVt_Vgi_bi_Vgm_si);
  vfb_Vgi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vgi_bi+VFB_i*inv_nVt_Vgi_bi_Vdbulk_di);
  vfb_Vgi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vgi_bi+VFB_i*inv_nVt_Vgi_bi_Vsbulk_si);
  vfb_Vgi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vgi_bi+VFB_i*inv_nVt_Vgi_bi_Vgi_bi);
  vfb_Vgi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vgi_bi+VFB_i*inv_nVt_Vgi_bi_Vdi_bi);
  vfb_Vgi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vgi_bi+VFB_i*inv_nVt_Vgi_bi_Vsi_bi);
  vfb_Vgi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vgi_bi+VFB_i*inv_nVt_Vgi_bi_Tempt_GND);
#endif
vfb_Vdi_bi=(VFB_i*inv_nVt_Vdi_bi);
#if defined(_DERIVATE2)
  vfb_Vdi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vgm_si);
  vfb_Vdi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vdbulk_di);
  vfb_Vdi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vsbulk_si);
  vfb_Vdi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vgi_bi);
  vfb_Vdi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vdi_bi);
  vfb_Vdi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Vsi_bi);
  vfb_Vdi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vdi_bi+VFB_i*inv_nVt_Vdi_bi_Tempt_GND);
#endif
vfb_Vsi_bi=(VFB_i*inv_nVt_Vsi_bi);
#if defined(_DERIVATE2)
  vfb_Vsi_bi_Vgm_si=(+0.0*inv_nVt+0.0*inv_nVt_Vgm_si+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vgm_si);
  vfb_Vsi_bi_Vdbulk_di=(+0.0*inv_nVt+0.0*inv_nVt_Vdbulk_di+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vdbulk_di);
  vfb_Vsi_bi_Vsbulk_si=(+0.0*inv_nVt+0.0*inv_nVt_Vsbulk_si+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vsbulk_si);
  vfb_Vsi_bi_Vgi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vgi_bi+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vgi_bi);
  vfb_Vsi_bi_Vdi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vdi_bi+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vdi_bi);
  vfb_Vsi_bi_Vsi_bi=(+0.0*inv_nVt+0.0*inv_nVt_Vsi_bi+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Vsi_bi);
  vfb_Vsi_bi_Tempt_GND=(+0.0*inv_nVt+0.0*inv_nVt_Tempt_GND+0.0*inv_nVt_Vsi_bi+VFB_i*inv_nVt_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
vfb_Tempt_GND=(VFB_i*inv_nVt_Tempt_GND);
#endif
#endif
vfb=(VFB_i*inv_nVt);
EXIT_IF_ISNAN((VFB_i*inv_nVt))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
#if defined(_DERIVATE)
dvth_dibl_Tempt_GND=(((-(ETA0EDGE_t_Tempt_GND+(ETABEDGE_i*Vbsx_Tempt_GND)))*Vdsx)+((-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx_Tempt_GND));
#endif
dvth_dibl_Vdi_bi=(((-(ETABEDGE_i*Vbsx_Vdi_bi))*Vdsx)+((-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx_Vdi_bi));
#if defined(_DERIVATE2)
  dvth_dibl_Vdi_bi_Tempt_GND=(+0.0*Vdsx+(-(ETABEDGE_i*Vbsx_Vdi_bi))*Vdsx_Tempt_GND+(-(ETA0EDGE_t_Tempt_GND+((ETABEDGE_i*Vbsx_Tempt_GND))))*Vdsx_Vdi_bi+(-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx_Vdi_bi_Tempt_GND);
  dvth_dibl_Vdi_bi_Vdi_bi=(+0.0*Vdsx+(-(ETABEDGE_i*Vbsx_Vdi_bi))*Vdsx_Vdi_bi+(-((ETABEDGE_i*Vbsx_Vdi_bi)))*Vdsx_Vdi_bi+(-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx_Vdi_bi_Vdi_bi);
  dvth_dibl_Vdi_bi_Vsi_bi=(+0.0*Vdsx+(-(ETABEDGE_i*Vbsx_Vdi_bi))*Vdsx_Vsi_bi+(-((ETABEDGE_i*Vbsx_Vsi_bi)))*Vdsx_Vdi_bi+(-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx_Vdi_bi_Vsi_bi);
#endif
dvth_dibl_Vsi_bi=(((-(ETABEDGE_i*Vbsx_Vsi_bi))*Vdsx)+((-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx_Vsi_bi));
#if defined(_DERIVATE2)
  dvth_dibl_Vsi_bi_Tempt_GND=(+0.0*Vdsx+(-(ETABEDGE_i*Vbsx_Vsi_bi))*Vdsx_Tempt_GND+(-(ETA0EDGE_t_Tempt_GND+((ETABEDGE_i*Vbsx_Tempt_GND))))*Vdsx_Vsi_bi+(-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx_Vsi_bi_Tempt_GND);
  dvth_dibl_Vsi_bi_Vdi_bi=(+0.0*Vdsx+(-(ETABEDGE_i*Vbsx_Vsi_bi))*Vdsx_Vdi_bi+(-((ETABEDGE_i*Vbsx_Vdi_bi)))*Vdsx_Vsi_bi+(-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx_Vsi_bi_Vdi_bi);
  dvth_dibl_Vsi_bi_Vsi_bi=(+0.0*Vdsx+(-(ETABEDGE_i*Vbsx_Vsi_bi))*Vdsx_Vsi_bi+(-((ETABEDGE_i*Vbsx_Vsi_bi)))*Vdsx_Vsi_bi+(-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx_Vsi_bi_Vsi_bi);
#endif
#endif
dvth_dibl=((-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx);
EXIT_IF_ISNAN(((-(ETA0EDGE_t+(ETABEDGE_i*Vbsx)))*Vdsx))
{
double m00_pow(d00_pow0,TRatio,KT1EXPEDGE_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,TRatio,KT1EXPEDGE_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
dvth_temp_Vdi_bi=(KT2EDGE_i*Vbsx_Vdi_bi)*(d00_pow0-1.0);
#if defined(_DERIVATE2)
  dvth_temp_Vdi_bi_Vdi_bi=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+KT1LEDGE_i*0.0)/Leff/Leff+2*KT1LEDGE_i*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+KT2EDGE_i*Vbsx_Vdi_bi_Vdi_bi))*(d00_pow0-1.0)+(KT2EDGE_i*Vbsx_Vdi_bi)*0.0+((KT2EDGE_i*Vbsx_Vdi_bi))*0.0+((KT1EDGE_i+(KT1LEDGE_i/Leff))+(KT2EDGE_i*Vbsx))*(+fixme-0.0));
  dvth_temp_Vdi_bi_Vsi_bi=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+KT1LEDGE_i*0.0)/Leff/Leff+2*KT1LEDGE_i*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+KT2EDGE_i*Vbsx_Vdi_bi_Vsi_bi))*(d00_pow0-1.0)+(KT2EDGE_i*Vbsx_Vdi_bi)*0.0+((KT2EDGE_i*Vbsx_Vsi_bi))*0.0+((KT1EDGE_i+(KT1LEDGE_i/Leff))+(KT2EDGE_i*Vbsx))*(+fixme-0.0));
  dvth_temp_Vdi_bi_Tempt_GND=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+KT1LEDGE_i*0.0)/Leff/Leff+2*KT1LEDGE_i*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vdi_bi+KT2EDGE_i*Vbsx_Vdi_bi_Tempt_GND))*(d00_pow0-1.0)+(KT2EDGE_i*Vbsx_Vdi_bi)*(d10_pow0*TRatio_Tempt_GND)+((KT2EDGE_i*Vbsx_Tempt_GND))*0.0+((KT1EDGE_i+(KT1LEDGE_i/Leff))+(KT2EDGE_i*Vbsx))*(+fixme-0.0));
#endif
dvth_temp_Vsi_bi=(KT2EDGE_i*Vbsx_Vsi_bi)*(d00_pow0-1.0);
#if defined(_DERIVATE2)
  dvth_temp_Vsi_bi_Vdi_bi=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+KT1LEDGE_i*0.0)/Leff/Leff+2*KT1LEDGE_i*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+KT2EDGE_i*Vbsx_Vsi_bi_Vdi_bi))*(d00_pow0-1.0)+(KT2EDGE_i*Vbsx_Vsi_bi)*0.0+((KT2EDGE_i*Vbsx_Vdi_bi))*0.0+((KT1EDGE_i+(KT1LEDGE_i/Leff))+(KT2EDGE_i*Vbsx))*(+fixme-0.0));
  dvth_temp_Vsi_bi_Vsi_bi=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+KT1LEDGE_i*0.0)/Leff/Leff+2*KT1LEDGE_i*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+KT2EDGE_i*Vbsx_Vsi_bi_Vsi_bi))*(d00_pow0-1.0)+(KT2EDGE_i*Vbsx_Vsi_bi)*0.0+((KT2EDGE_i*Vbsx_Vsi_bi))*0.0+((KT1EDGE_i+(KT1LEDGE_i/Leff))+(KT2EDGE_i*Vbsx))*(+fixme-0.0));
  dvth_temp_Vsi_bi_Tempt_GND=(+(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+KT1LEDGE_i*0.0)/Leff/Leff+2*KT1LEDGE_i*0.0*0.0/Leff/Leff/Leff))+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vsi_bi+KT2EDGE_i*Vbsx_Vsi_bi_Tempt_GND))*(d00_pow0-1.0)+(KT2EDGE_i*Vbsx_Vsi_bi)*(d10_pow0*TRatio_Tempt_GND)+((KT2EDGE_i*Vbsx_Tempt_GND))*0.0+((KT1EDGE_i+(KT1LEDGE_i/Leff))+(KT2EDGE_i*Vbsx))*(+fixme-0.0));
#endif
#if defined(_DERIVATE)
dvth_temp_Tempt_GND=(((KT2EDGE_i*Vbsx_Tempt_GND)*(d00_pow0-1.0))+(((KT1EDGE_i+(KT1LEDGE_i/Leff))+(KT2EDGE_i*Vbsx))*(d10_pow0*TRatio_Tempt_GND)));
#endif
#endif
dvth_temp=(((KT1EDGE_i+(KT1LEDGE_i/Leff))+(KT2EDGE_i*Vbsx))*(d00_pow0-1.0));
EXIT_IF_ISNAN((((KT1EDGE_i+(KT1LEDGE_i/Leff))+(KT2EDGE_i*Vbsx))*(d00_pow0-1.0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
litl_edge_Vdi_bi=(litl*(pModel->DVT2EDGE*Vbsx_Vdi_bi));
#if defined(_DERIVATE2)
  litl_edge_Vdi_bi_Vdi_bi=(+0.0*(1.0+(pModel->DVT2EDGE*Vbsx))+0.0*((pModel->DVT2EDGE*Vbsx_Vdi_bi))+0.0*(pModel->DVT2EDGE*Vbsx_Vdi_bi)+litl*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+pModel->DVT2EDGE*Vbsx_Vdi_bi_Vdi_bi)));
  litl_edge_Vdi_bi_Vsi_bi=(+0.0*(1.0+(pModel->DVT2EDGE*Vbsx))+0.0*((pModel->DVT2EDGE*Vbsx_Vsi_bi))+0.0*(pModel->DVT2EDGE*Vbsx_Vdi_bi)+litl*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+pModel->DVT2EDGE*Vbsx_Vdi_bi_Vsi_bi)));
  litl_edge_Vdi_bi_Tempt_GND=(+0.0*(1.0+(pModel->DVT2EDGE*Vbsx))+0.0*((pModel->DVT2EDGE*Vbsx_Tempt_GND))+0.0*(pModel->DVT2EDGE*Vbsx_Vdi_bi)+litl*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vdi_bi+pModel->DVT2EDGE*Vbsx_Vdi_bi_Tempt_GND)));
#endif
litl_edge_Vsi_bi=(litl*(pModel->DVT2EDGE*Vbsx_Vsi_bi));
#if defined(_DERIVATE2)
  litl_edge_Vsi_bi_Vdi_bi=(+0.0*(1.0+(pModel->DVT2EDGE*Vbsx))+0.0*((pModel->DVT2EDGE*Vbsx_Vdi_bi))+0.0*(pModel->DVT2EDGE*Vbsx_Vsi_bi)+litl*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+pModel->DVT2EDGE*Vbsx_Vsi_bi_Vdi_bi)));
  litl_edge_Vsi_bi_Vsi_bi=(+0.0*(1.0+(pModel->DVT2EDGE*Vbsx))+0.0*((pModel->DVT2EDGE*Vbsx_Vsi_bi))+0.0*(pModel->DVT2EDGE*Vbsx_Vsi_bi)+litl*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+pModel->DVT2EDGE*Vbsx_Vsi_bi_Vsi_bi)));
  litl_edge_Vsi_bi_Tempt_GND=(+0.0*(1.0+(pModel->DVT2EDGE*Vbsx))+0.0*((pModel->DVT2EDGE*Vbsx_Tempt_GND))+0.0*(pModel->DVT2EDGE*Vbsx_Vsi_bi)+litl*(+0.0+(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+0.0*Vbsx_Vsi_bi+pModel->DVT2EDGE*Vbsx_Vsi_bi_Tempt_GND)));
#endif
#if defined(_DERIVATE)
litl_edge_Tempt_GND=(litl*(pModel->DVT2EDGE*Vbsx_Tempt_GND));
#endif
#endif
litl_edge=(litl*(1.0+(pModel->DVT2EDGE*Vbsx)));
EXIT_IF_ISNAN((litl*(1.0+(pModel->DVT2EDGE*Vbsx))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=0.0;
  T0_Vgm_di_Vgm_si=0.0;
  T0_Vgm_di_Vdbulk_di=0.0;
  T0_Vgm_di_Vsbulk_si=0.0;
  T0_Vgm_di_Vgi_bi=0.0;
  T0_Vgm_di_Vdi_bi=0.0;
  T0_Vgm_di_Vsi_bi=0.0;
  T0_Vgm_di_Tempt_GND=0.0;
#endif
T0_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=0.0;
  T0_Vgm_si_Vgm_si=0.0;
  T0_Vgm_si_Vdbulk_di=0.0;
  T0_Vgm_si_Vsbulk_si=0.0;
  T0_Vgm_si_Vgi_bi=0.0;
  T0_Vgm_si_Vdi_bi=0.0;
  T0_Vgm_si_Vsi_bi=0.0;
  T0_Vgm_si_Tempt_GND=0.0;
#endif
T0_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=0.0;
  T0_Vdbulk_di_Vgm_si=0.0;
  T0_Vdbulk_di_Vdbulk_di=0.0;
  T0_Vdbulk_di_Vsbulk_si=0.0;
  T0_Vdbulk_di_Vgi_bi=0.0;
  T0_Vdbulk_di_Vdi_bi=0.0;
  T0_Vdbulk_di_Vsi_bi=0.0;
  T0_Vdbulk_di_Tempt_GND=0.0;
#endif
T0_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=0.0;
  T0_Vsbulk_si_Vgm_si=0.0;
  T0_Vsbulk_si_Vdbulk_di=0.0;
  T0_Vsbulk_si_Vsbulk_si=0.0;
  T0_Vsbulk_si_Vgi_bi=0.0;
  T0_Vsbulk_si_Vdi_bi=0.0;
  T0_Vsbulk_si_Vsi_bi=0.0;
  T0_Vsbulk_si_Tempt_GND=0.0;
#endif
T0_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=0.0;
  T0_Vgi_bi_Vgm_si=0.0;
  T0_Vgi_bi_Vdbulk_di=0.0;
  T0_Vgi_bi_Vsbulk_si=0.0;
  T0_Vgi_bi_Vgi_bi=0.0;
  T0_Vgi_bi_Vdi_bi=0.0;
  T0_Vgi_bi_Vsi_bi=0.0;
  T0_Vgi_bi_Tempt_GND=0.0;
#endif
T0_Vdi_bi=(-(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi/litl_edge/litl_edge);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vdi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vdi_bi_Vgm_si=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vdi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vdi_bi_Vdbulk_di=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vdi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vdi_bi_Vsbulk_si=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vdi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vdi_bi_Vgi_bi=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vdi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vdi_bi_Vdi_bi=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*litl_edge_Vdi_bi+(0.0)*litl_edge_Vdi_bi+(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi_Vdi_bi)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi*litl_edge_Vdi_bi/litl_edge/litl_edge/litl_edge);
  T0_Vdi_bi_Vsi_bi=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*litl_edge_Vsi_bi+(0.0)*litl_edge_Vdi_bi+(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi_Vsi_bi)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi*litl_edge_Vsi_bi/litl_edge/litl_edge/litl_edge);
  T0_Vdi_bi_Tempt_GND=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*litl_edge_Tempt_GND+(0.0)*litl_edge_Vdi_bi+(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi_Tempt_GND)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vdi_bi*litl_edge_Tempt_GND/litl_edge/litl_edge/litl_edge);
#endif
T0_Vsi_bi=(-(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi/litl_edge/litl_edge);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vsi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vsi_bi_Vgm_si=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vsi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vsi_bi_Vdbulk_di=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vsi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vsi_bi_Vsbulk_si=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vsi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vsi_bi_Vgi_bi=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*0.0+(0.0)*litl_edge_Vsi_bi+(pModel->DVT1EDGE*Leff)*0.0)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi*0.0/litl_edge/litl_edge/litl_edge);
  T0_Vsi_bi_Vdi_bi=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*litl_edge_Vdi_bi+(0.0)*litl_edge_Vsi_bi+(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi_Vdi_bi)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi*litl_edge_Vdi_bi/litl_edge/litl_edge/litl_edge);
  T0_Vsi_bi_Vsi_bi=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*litl_edge_Vsi_bi+(0.0)*litl_edge_Vsi_bi+(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi_Vsi_bi)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi*litl_edge_Vsi_bi/litl_edge/litl_edge/litl_edge);
  T0_Vsi_bi_Tempt_GND=((+0.0*Leff+0.0*0.0+0.0*0.0+pModel->DVT1EDGE*0.0)/litl_edge-(0.0*litl_edge_Tempt_GND+(0.0)*litl_edge_Vsi_bi+(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi_Tempt_GND)/litl_edge/litl_edge+2*(pModel->DVT1EDGE*Leff)*litl_edge_Vsi_bi*litl_edge_Tempt_GND/litl_edge/litl_edge/litl_edge);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(-(pModel->DVT1EDGE*Leff)*litl_edge_Tempt_GND/litl_edge/litl_edge);
#endif
#endif
T0=((pModel->DVT1EDGE*Leff)/litl_edge);
EXIT_IF_ISNAN(((pModel->DVT1EDGE*Leff)/litl_edge))
if
((T0<40.0))
{
{
double m00_cosh(d00_cosh0,T0)
#if defined(_DERIVATEFORDDX)
double m10_cosh(d10_cosh0,d00_cosh0,T0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
theta_sce_edge_Vgm_di=(-(0.5*pModel->DVT0EDGE)*T0_Vgm_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#if defined(_DERIVATE2)
  theta_sce_edge_Vgm_di_Vgm_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_di*d10_cosh0+(0.0)*T0_Vgm_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_di*T0_Vgm_di+d10_cosh0*T0_Vgm_di_Vgm_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgm_di*d10_cosh0*T0_Vgm_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgm_di_Vgm_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_si*d10_cosh0+(0.0)*T0_Vgm_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_si*T0_Vgm_di+d10_cosh0*T0_Vgm_di_Vgm_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgm_di*d10_cosh0*T0_Vgm_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgm_di_Vdbulk_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdbulk_di*d10_cosh0+(0.0)*T0_Vgm_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdbulk_di*T0_Vgm_di+d10_cosh0*T0_Vgm_di_Vdbulk_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgm_di*d10_cosh0*T0_Vdbulk_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgm_di_Vsbulk_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsbulk_si*d10_cosh0+(0.0)*T0_Vgm_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsbulk_si*T0_Vgm_di+d10_cosh0*T0_Vgm_di_Vsbulk_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgm_di*d10_cosh0*T0_Vsbulk_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgm_di_Vgi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgi_bi*d10_cosh0+(0.0)*T0_Vgm_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgi_bi*T0_Vgm_di+d10_cosh0*T0_Vgm_di_Vgi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgm_di*d10_cosh0*T0_Vgi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgm_di_Vdi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdi_bi*d10_cosh0+(0.0)*T0_Vgm_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdi_bi*T0_Vgm_di+d10_cosh0*T0_Vgm_di_Vdi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgm_di*d10_cosh0*T0_Vdi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgm_di_Vsi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsi_bi*d10_cosh0+(0.0)*T0_Vgm_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsi_bi*T0_Vgm_di+d10_cosh0*T0_Vgm_di_Vsi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgm_di*d10_cosh0*T0_Vsi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgm_di_Tempt_GND=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Tempt_GND*d10_cosh0+(0.0)*T0_Vgm_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Tempt_GND*T0_Vgm_di+d10_cosh0*T0_Vgm_di_Tempt_GND)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgm_di*d10_cosh0*T0_Tempt_GND*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#endif
#if defined(_DERIVATE)
theta_sce_edge_Vgm_si=(-(0.5*pModel->DVT0EDGE)*T0_Vgm_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#endif
theta_sce_edge_Vdbulk_di=(-(0.5*pModel->DVT0EDGE)*T0_Vdbulk_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#if defined(_DERIVATE2)
  theta_sce_edge_Vdbulk_di_Vgm_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_di*d10_cosh0+(0.0)*T0_Vdbulk_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_di*T0_Vdbulk_di+d10_cosh0*T0_Vdbulk_di_Vgm_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdbulk_di*d10_cosh0*T0_Vgm_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdbulk_di_Vgm_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_si*d10_cosh0+(0.0)*T0_Vdbulk_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_si*T0_Vdbulk_di+d10_cosh0*T0_Vdbulk_di_Vgm_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdbulk_di*d10_cosh0*T0_Vgm_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdbulk_di_Vdbulk_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdbulk_di*d10_cosh0+(0.0)*T0_Vdbulk_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdbulk_di*T0_Vdbulk_di+d10_cosh0*T0_Vdbulk_di_Vdbulk_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdbulk_di*d10_cosh0*T0_Vdbulk_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdbulk_di_Vsbulk_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsbulk_si*d10_cosh0+(0.0)*T0_Vdbulk_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsbulk_si*T0_Vdbulk_di+d10_cosh0*T0_Vdbulk_di_Vsbulk_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdbulk_di*d10_cosh0*T0_Vsbulk_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdbulk_di_Vgi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgi_bi*d10_cosh0+(0.0)*T0_Vdbulk_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgi_bi*T0_Vdbulk_di+d10_cosh0*T0_Vdbulk_di_Vgi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdbulk_di*d10_cosh0*T0_Vgi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdbulk_di_Vdi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdi_bi*d10_cosh0+(0.0)*T0_Vdbulk_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdi_bi*T0_Vdbulk_di+d10_cosh0*T0_Vdbulk_di_Vdi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdbulk_di*d10_cosh0*T0_Vdi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdbulk_di_Vsi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsi_bi*d10_cosh0+(0.0)*T0_Vdbulk_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsi_bi*T0_Vdbulk_di+d10_cosh0*T0_Vdbulk_di_Vsi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdbulk_di*d10_cosh0*T0_Vsi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdbulk_di_Tempt_GND=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Tempt_GND*d10_cosh0+(0.0)*T0_Vdbulk_di*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Tempt_GND*T0_Vdbulk_di+d10_cosh0*T0_Vdbulk_di_Tempt_GND)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdbulk_di*d10_cosh0*T0_Tempt_GND*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#endif
#if defined(_DERIVATE)
theta_sce_edge_Vsbulk_si=(-(0.5*pModel->DVT0EDGE)*T0_Vsbulk_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#endif
theta_sce_edge_Vgi_bi=(-(0.5*pModel->DVT0EDGE)*T0_Vgi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#if defined(_DERIVATE2)
  theta_sce_edge_Vgi_bi_Vgm_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_di*d10_cosh0+(0.0)*T0_Vgi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_di*T0_Vgi_bi+d10_cosh0*T0_Vgi_bi_Vgm_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgi_bi*d10_cosh0*T0_Vgm_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgi_bi_Vgm_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_si*d10_cosh0+(0.0)*T0_Vgi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_si*T0_Vgi_bi+d10_cosh0*T0_Vgi_bi_Vgm_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgi_bi*d10_cosh0*T0_Vgm_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgi_bi_Vdbulk_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdbulk_di*d10_cosh0+(0.0)*T0_Vgi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdbulk_di*T0_Vgi_bi+d10_cosh0*T0_Vgi_bi_Vdbulk_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgi_bi*d10_cosh0*T0_Vdbulk_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgi_bi_Vsbulk_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsbulk_si*d10_cosh0+(0.0)*T0_Vgi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsbulk_si*T0_Vgi_bi+d10_cosh0*T0_Vgi_bi_Vsbulk_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgi_bi*d10_cosh0*T0_Vsbulk_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgi_bi_Vgi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgi_bi*d10_cosh0+(0.0)*T0_Vgi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgi_bi*T0_Vgi_bi+d10_cosh0*T0_Vgi_bi_Vgi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgi_bi*d10_cosh0*T0_Vgi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgi_bi_Vdi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdi_bi*d10_cosh0+(0.0)*T0_Vgi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdi_bi*T0_Vgi_bi+d10_cosh0*T0_Vgi_bi_Vdi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgi_bi*d10_cosh0*T0_Vdi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgi_bi_Vsi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsi_bi*d10_cosh0+(0.0)*T0_Vgi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsi_bi*T0_Vgi_bi+d10_cosh0*T0_Vgi_bi_Vsi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgi_bi*d10_cosh0*T0_Vsi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vgi_bi_Tempt_GND=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Tempt_GND*d10_cosh0+(0.0)*T0_Vgi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Tempt_GND*T0_Vgi_bi+d10_cosh0*T0_Vgi_bi_Tempt_GND)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vgi_bi*d10_cosh0*T0_Tempt_GND*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#endif
theta_sce_edge_Vdi_bi=(-(0.5*pModel->DVT0EDGE)*T0_Vdi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#if defined(_DERIVATE2)
  theta_sce_edge_Vdi_bi_Vgm_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_di*d10_cosh0+(0.0)*T0_Vdi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_di*T0_Vdi_bi+d10_cosh0*T0_Vdi_bi_Vgm_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdi_bi*d10_cosh0*T0_Vgm_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdi_bi_Vgm_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_si*d10_cosh0+(0.0)*T0_Vdi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_si*T0_Vdi_bi+d10_cosh0*T0_Vdi_bi_Vgm_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdi_bi*d10_cosh0*T0_Vgm_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdi_bi_Vdbulk_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdbulk_di*d10_cosh0+(0.0)*T0_Vdi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdbulk_di*T0_Vdi_bi+d10_cosh0*T0_Vdi_bi_Vdbulk_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdi_bi*d10_cosh0*T0_Vdbulk_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdi_bi_Vsbulk_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsbulk_si*d10_cosh0+(0.0)*T0_Vdi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsbulk_si*T0_Vdi_bi+d10_cosh0*T0_Vdi_bi_Vsbulk_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdi_bi*d10_cosh0*T0_Vsbulk_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdi_bi_Vgi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgi_bi*d10_cosh0+(0.0)*T0_Vdi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgi_bi*T0_Vdi_bi+d10_cosh0*T0_Vdi_bi_Vgi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdi_bi*d10_cosh0*T0_Vgi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdi_bi_Vdi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdi_bi*d10_cosh0+(0.0)*T0_Vdi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdi_bi*T0_Vdi_bi+d10_cosh0*T0_Vdi_bi_Vdi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdi_bi*d10_cosh0*T0_Vdi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdi_bi_Vsi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsi_bi*d10_cosh0+(0.0)*T0_Vdi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsi_bi*T0_Vdi_bi+d10_cosh0*T0_Vdi_bi_Vsi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdi_bi*d10_cosh0*T0_Vsi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vdi_bi_Tempt_GND=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Tempt_GND*d10_cosh0+(0.0)*T0_Vdi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Tempt_GND*T0_Vdi_bi+d10_cosh0*T0_Vdi_bi_Tempt_GND)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vdi_bi*d10_cosh0*T0_Tempt_GND*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#endif
theta_sce_edge_Vsi_bi=(-(0.5*pModel->DVT0EDGE)*T0_Vsi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#if defined(_DERIVATE2)
  theta_sce_edge_Vsi_bi_Vgm_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_di*d10_cosh0+(0.0)*T0_Vsi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_di*T0_Vsi_bi+d10_cosh0*T0_Vsi_bi_Vgm_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vsi_bi*d10_cosh0*T0_Vgm_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vsi_bi_Vgm_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgm_si*d10_cosh0+(0.0)*T0_Vsi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgm_si*T0_Vsi_bi+d10_cosh0*T0_Vsi_bi_Vgm_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vsi_bi*d10_cosh0*T0_Vgm_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vsi_bi_Vdbulk_di=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdbulk_di*d10_cosh0+(0.0)*T0_Vsi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdbulk_di*T0_Vsi_bi+d10_cosh0*T0_Vsi_bi_Vdbulk_di)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vsi_bi*d10_cosh0*T0_Vdbulk_di*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vsi_bi_Vsbulk_si=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsbulk_si*d10_cosh0+(0.0)*T0_Vsi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsbulk_si*T0_Vsi_bi+d10_cosh0*T0_Vsi_bi_Vsbulk_si)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vsi_bi*d10_cosh0*T0_Vsbulk_si*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vsi_bi_Vgi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vgi_bi*d10_cosh0+(0.0)*T0_Vsi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vgi_bi*T0_Vsi_bi+d10_cosh0*T0_Vsi_bi_Vgi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vsi_bi*d10_cosh0*T0_Vgi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vsi_bi_Vdi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vdi_bi*d10_cosh0+(0.0)*T0_Vsi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vdi_bi*T0_Vsi_bi+d10_cosh0*T0_Vsi_bi_Vdi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vsi_bi*d10_cosh0*T0_Vdi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vsi_bi_Vsi_bi=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Vsi_bi*d10_cosh0+(0.0)*T0_Vsi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Vsi_bi*T0_Vsi_bi+d10_cosh0*T0_Vsi_bi_Vsi_bi)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vsi_bi*d10_cosh0*T0_Vsi_bi*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
  theta_sce_edge_Vsi_bi_Tempt_GND=((+0.0*pModel->DVT0EDGE+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_cosh0-1.0)-(0.0*T0_Tempt_GND*d10_cosh0+(0.0)*T0_Vsi_bi*d10_cosh0+(0.5*pModel->DVT0EDGE)*(+(m20_cosh(T0)*T0_Tempt_GND*T0_Vsi_bi+d10_cosh0*T0_Vsi_bi_Tempt_GND)-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*pModel->DVT0EDGE)*T0_Vsi_bi*d10_cosh0*T0_Tempt_GND*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#endif
#if defined(_DERIVATE)
theta_sce_edge_Tempt_GND=(-(0.5*pModel->DVT0EDGE)*T0_Tempt_GND*d10_cosh0/(d00_cosh0-1.0)/(d00_cosh0-1.0));
#endif
#endif
theta_sce_edge=((0.5*pModel->DVT0EDGE)/(d00_cosh0-1.0));
EXIT_IF_ISNAN(((0.5*pModel->DVT0EDGE)/(d00_cosh0-1.0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
theta_sce_edge_Vgm_di=(pModel->DVT0EDGE*bsimbulk_d_lexp((-T0),(-T0_Vgm_di)));
#if defined(_DERIVATE2)
  theta_sce_edge_Vgm_di_Vgm_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgm_di_Vgm_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgm_di_Vdbulk_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgm_di_Vsbulk_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgm_di_Vgi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgm_di_Vdi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgm_di_Vsi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgm_di_Tempt_GND=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgm_di))+pModel->DVT0EDGE*0.0);
#endif
#if defined(_DERIVATE)
theta_sce_edge_Vgm_si=(pModel->DVT0EDGE*bsimbulk_d_lexp((-T0),(-T0_Vgm_si)));
#endif
theta_sce_edge_Vdbulk_di=(pModel->DVT0EDGE*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di)));
#if defined(_DERIVATE2)
  theta_sce_edge_Vdbulk_di_Vgm_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdbulk_di_Vgm_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdbulk_di_Vdbulk_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdbulk_di_Vsbulk_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdbulk_di_Vgi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdbulk_di_Vdi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdbulk_di_Vsi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdbulk_di_Tempt_GND=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdbulk_di))+pModel->DVT0EDGE*0.0);
#endif
#if defined(_DERIVATE)
theta_sce_edge_Vsbulk_si=(pModel->DVT0EDGE*bsimbulk_d_lexp((-T0),(-T0_Vsbulk_si)));
#endif
theta_sce_edge_Vgi_bi=(pModel->DVT0EDGE*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi)));
#if defined(_DERIVATE2)
  theta_sce_edge_Vgi_bi_Vgm_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgi_bi_Vgm_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgi_bi_Vdbulk_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgi_bi_Vsbulk_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgi_bi_Vgi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgi_bi_Vdi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgi_bi_Vsi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vgi_bi_Tempt_GND=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vgi_bi))+pModel->DVT0EDGE*0.0);
#endif
theta_sce_edge_Vdi_bi=(pModel->DVT0EDGE*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi)));
#if defined(_DERIVATE2)
  theta_sce_edge_Vdi_bi_Vgm_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdi_bi_Vgm_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdi_bi_Vdbulk_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdi_bi_Vsbulk_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdi_bi_Vgi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdi_bi_Vdi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdi_bi_Vsi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vdi_bi_Tempt_GND=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vdi_bi))+pModel->DVT0EDGE*0.0);
#endif
theta_sce_edge_Vsi_bi=(pModel->DVT0EDGE*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi)));
#if defined(_DERIVATE2)
  theta_sce_edge_Vsi_bi_Vgm_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vsi_bi_Vgm_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vsi_bi_Vdbulk_di=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vsi_bi_Vsbulk_si=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vsi_bi_Vgi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vsi_bi_Vdi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vsi_bi_Vsi_bi=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+pModel->DVT0EDGE*0.0);
  theta_sce_edge_Vsi_bi_Tempt_GND=(+0.0*bsimbulk_lexp((-T0))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+0.0*bsimbulk_d_lexp((-T0),(-T0_Vsi_bi))+pModel->DVT0EDGE*0.0);
#endif
#if defined(_DERIVATE)
theta_sce_edge_Tempt_GND=(pModel->DVT0EDGE*bsimbulk_d_lexp((-T0),(-T0_Tempt_GND)));
#endif
#endif
theta_sce_edge=(pModel->DVT0EDGE*bsimbulk_lexp((-T0)));
EXIT_IF_ISNAN((pModel->DVT0EDGE*bsimbulk_lexp((-T0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
dvth_sce_Vgm_di=theta_sce_edge_Vgm_di*(Vbi-Phist);
#if defined(_DERIVATE2)
  dvth_sce_Vgm_di_Vgm_di=(+theta_sce_edge_Vgm_di_Vgm_di*(Vbi-Phist)+theta_sce_edge_Vgm_di*0.0+theta_sce_edge_Vgm_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgm_di_Vgm_si=(+theta_sce_edge_Vgm_di_Vgm_si*(Vbi-Phist)+theta_sce_edge_Vgm_di*0.0+theta_sce_edge_Vgm_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgm_di_Vdbulk_di=(+theta_sce_edge_Vgm_di_Vdbulk_di*(Vbi-Phist)+theta_sce_edge_Vgm_di*0.0+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgm_di_Vsbulk_si=(+theta_sce_edge_Vgm_di_Vsbulk_si*(Vbi-Phist)+theta_sce_edge_Vgm_di*0.0+theta_sce_edge_Vsbulk_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgm_di_Vgi_bi=(+theta_sce_edge_Vgm_di_Vgi_bi*(Vbi-Phist)+theta_sce_edge_Vgm_di*0.0+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgm_di_Vdi_bi=(+theta_sce_edge_Vgm_di_Vdi_bi*(Vbi-Phist)+theta_sce_edge_Vgm_di*0.0+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgm_di_Vsi_bi=(+theta_sce_edge_Vgm_di_Vsi_bi*(Vbi-Phist)+theta_sce_edge_Vgm_di*0.0+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgm_di_Tempt_GND=(+theta_sce_edge_Vgm_di_Tempt_GND*(Vbi-Phist)+theta_sce_edge_Vgm_di*(Vbi_Tempt_GND-Phist_Tempt_GND)+theta_sce_edge_Tempt_GND*0.0+theta_sce_edge*(+0.0-0.0));
#endif
#if defined(_DERIVATE)
dvth_sce_Vgm_si=theta_sce_edge_Vgm_si*(Vbi-Phist);
#endif
dvth_sce_Vdbulk_di=theta_sce_edge_Vdbulk_di*(Vbi-Phist);
#if defined(_DERIVATE2)
  dvth_sce_Vdbulk_di_Vgm_di=(+theta_sce_edge_Vdbulk_di_Vgm_di*(Vbi-Phist)+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge_Vgm_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdbulk_di_Vgm_si=(+theta_sce_edge_Vdbulk_di_Vgm_si*(Vbi-Phist)+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge_Vgm_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdbulk_di_Vdbulk_di=(+theta_sce_edge_Vdbulk_di_Vdbulk_di*(Vbi-Phist)+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdbulk_di_Vsbulk_si=(+theta_sce_edge_Vdbulk_di_Vsbulk_si*(Vbi-Phist)+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge_Vsbulk_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdbulk_di_Vgi_bi=(+theta_sce_edge_Vdbulk_di_Vgi_bi*(Vbi-Phist)+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdbulk_di_Vdi_bi=(+theta_sce_edge_Vdbulk_di_Vdi_bi*(Vbi-Phist)+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdbulk_di_Vsi_bi=(+theta_sce_edge_Vdbulk_di_Vsi_bi*(Vbi-Phist)+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdbulk_di_Tempt_GND=(+theta_sce_edge_Vdbulk_di_Tempt_GND*(Vbi-Phist)+theta_sce_edge_Vdbulk_di*(Vbi_Tempt_GND-Phist_Tempt_GND)+theta_sce_edge_Tempt_GND*0.0+theta_sce_edge*(+0.0-0.0));
#endif
#if defined(_DERIVATE)
dvth_sce_Vsbulk_si=theta_sce_edge_Vsbulk_si*(Vbi-Phist);
#endif
dvth_sce_Vgi_bi=theta_sce_edge_Vgi_bi*(Vbi-Phist);
#if defined(_DERIVATE2)
  dvth_sce_Vgi_bi_Vgm_di=(+theta_sce_edge_Vgi_bi_Vgm_di*(Vbi-Phist)+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge_Vgm_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgi_bi_Vgm_si=(+theta_sce_edge_Vgi_bi_Vgm_si*(Vbi-Phist)+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge_Vgm_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgi_bi_Vdbulk_di=(+theta_sce_edge_Vgi_bi_Vdbulk_di*(Vbi-Phist)+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgi_bi_Vsbulk_si=(+theta_sce_edge_Vgi_bi_Vsbulk_si*(Vbi-Phist)+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge_Vsbulk_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgi_bi_Vgi_bi=(+theta_sce_edge_Vgi_bi_Vgi_bi*(Vbi-Phist)+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgi_bi_Vdi_bi=(+theta_sce_edge_Vgi_bi_Vdi_bi*(Vbi-Phist)+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgi_bi_Vsi_bi=(+theta_sce_edge_Vgi_bi_Vsi_bi*(Vbi-Phist)+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vgi_bi_Tempt_GND=(+theta_sce_edge_Vgi_bi_Tempt_GND*(Vbi-Phist)+theta_sce_edge_Vgi_bi*(Vbi_Tempt_GND-Phist_Tempt_GND)+theta_sce_edge_Tempt_GND*0.0+theta_sce_edge*(+0.0-0.0));
#endif
dvth_sce_Vdi_bi=theta_sce_edge_Vdi_bi*(Vbi-Phist);
#if defined(_DERIVATE2)
  dvth_sce_Vdi_bi_Vgm_di=(+theta_sce_edge_Vdi_bi_Vgm_di*(Vbi-Phist)+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge_Vgm_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdi_bi_Vgm_si=(+theta_sce_edge_Vdi_bi_Vgm_si*(Vbi-Phist)+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge_Vgm_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdi_bi_Vdbulk_di=(+theta_sce_edge_Vdi_bi_Vdbulk_di*(Vbi-Phist)+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdi_bi_Vsbulk_si=(+theta_sce_edge_Vdi_bi_Vsbulk_si*(Vbi-Phist)+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge_Vsbulk_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdi_bi_Vgi_bi=(+theta_sce_edge_Vdi_bi_Vgi_bi*(Vbi-Phist)+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdi_bi_Vdi_bi=(+theta_sce_edge_Vdi_bi_Vdi_bi*(Vbi-Phist)+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdi_bi_Vsi_bi=(+theta_sce_edge_Vdi_bi_Vsi_bi*(Vbi-Phist)+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vdi_bi_Tempt_GND=(+theta_sce_edge_Vdi_bi_Tempt_GND*(Vbi-Phist)+theta_sce_edge_Vdi_bi*(Vbi_Tempt_GND-Phist_Tempt_GND)+theta_sce_edge_Tempt_GND*0.0+theta_sce_edge*(+0.0-0.0));
#endif
dvth_sce_Vsi_bi=theta_sce_edge_Vsi_bi*(Vbi-Phist);
#if defined(_DERIVATE2)
  dvth_sce_Vsi_bi_Vgm_di=(+theta_sce_edge_Vsi_bi_Vgm_di*(Vbi-Phist)+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge_Vgm_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vsi_bi_Vgm_si=(+theta_sce_edge_Vsi_bi_Vgm_si*(Vbi-Phist)+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge_Vgm_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vsi_bi_Vdbulk_di=(+theta_sce_edge_Vsi_bi_Vdbulk_di*(Vbi-Phist)+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge_Vdbulk_di*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vsi_bi_Vsbulk_si=(+theta_sce_edge_Vsi_bi_Vsbulk_si*(Vbi-Phist)+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge_Vsbulk_si*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vsi_bi_Vgi_bi=(+theta_sce_edge_Vsi_bi_Vgi_bi*(Vbi-Phist)+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge_Vgi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vsi_bi_Vdi_bi=(+theta_sce_edge_Vsi_bi_Vdi_bi*(Vbi-Phist)+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge_Vdi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vsi_bi_Vsi_bi=(+theta_sce_edge_Vsi_bi_Vsi_bi*(Vbi-Phist)+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge_Vsi_bi*0.0+theta_sce_edge*(+0.0-0.0));
  dvth_sce_Vsi_bi_Tempt_GND=(+theta_sce_edge_Vsi_bi_Tempt_GND*(Vbi-Phist)+theta_sce_edge_Vsi_bi*(Vbi_Tempt_GND-Phist_Tempt_GND)+theta_sce_edge_Tempt_GND*0.0+theta_sce_edge*(+0.0-0.0));
#endif
#if defined(_DERIVATE)
dvth_sce_Tempt_GND=((theta_sce_edge_Tempt_GND*(Vbi-Phist))+(theta_sce_edge*(Vbi_Tempt_GND-Phist_Tempt_GND)));
#endif
#endif
dvth_sce=(theta_sce_edge*(Vbi-Phist));
EXIT_IF_ISNAN((theta_sce_edge*(Vbi-Phist)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Vth_shift_Vgm_di=dvth_sce_Vgm_di;
#if defined(_DERIVATE2)
  Vth_shift_Vgm_di_Vgm_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_di_Vgm_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_di_Vgm_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_di_Vgm_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_di_Vdbulk_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_di_Vdbulk_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_di_Vsbulk_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_di_Vsbulk_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_di_Vgi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_di_Vgi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_di_Tempt_GND=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_di_Tempt_GND)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+K2_EDGE_Tempt_GND*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_di_Vdi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_di_Vdi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_di_Vsi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_di_Vsi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*0.0+K2_EDGE*0.0));
#endif
Vth_shift_Vgm_si=dvth_sce_Vgm_si;
#if defined(_DERIVATE2)
  Vth_shift_Vgm_si_Vgm_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_si_Vgm_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_si_Vgm_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_si_Vgm_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_si_Vdbulk_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_si_Vdbulk_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_si_Vsbulk_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_si_Vsbulk_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_si_Vgi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_si_Vgi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_si_Tempt_GND=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_si_Tempt_GND)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+K2_EDGE_Tempt_GND*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_si_Vdi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_si_Vdi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgm_si_Vsi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgm_si_Vsi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*0.0+K2_EDGE*0.0));
#endif
Vth_shift_Vdbulk_di=dvth_sce_Vdbulk_di;
#if defined(_DERIVATE2)
  Vth_shift_Vdbulk_di_Vgm_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdbulk_di_Vgm_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vdbulk_di_Vgm_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdbulk_di_Vgm_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vdbulk_di_Vdbulk_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdbulk_di_Vdbulk_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vdbulk_di_Vsbulk_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdbulk_di_Vsbulk_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vdbulk_di_Vgi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdbulk_di_Vgi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vdbulk_di_Tempt_GND=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdbulk_di_Tempt_GND)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+K2_EDGE_Tempt_GND*0.0+K2_EDGE*0.0));
  Vth_shift_Vdbulk_di_Vdi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdbulk_di_Vdi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vdbulk_di_Vsi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdbulk_di_Vsi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*0.0+K2_EDGE*0.0));
#endif
Vth_shift_Vsbulk_si=dvth_sce_Vsbulk_si;
#if defined(_DERIVATE2)
  Vth_shift_Vsbulk_si_Vgm_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsbulk_si_Vgm_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vsbulk_si_Vgm_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsbulk_si_Vgm_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vsbulk_si_Vdbulk_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsbulk_si_Vdbulk_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vsbulk_si_Vsbulk_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsbulk_si_Vsbulk_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vsbulk_si_Vgi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsbulk_si_Vgi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vsbulk_si_Tempt_GND=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsbulk_si_Tempt_GND)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+K2_EDGE_Tempt_GND*0.0+K2_EDGE*0.0));
  Vth_shift_Vsbulk_si_Vdi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsbulk_si_Vdi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vsbulk_si_Vsi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsbulk_si_Vsi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*0.0+K2_EDGE*0.0));
#endif
Vth_shift_Vgi_bi=dvth_sce_Vgi_bi;
#if defined(_DERIVATE2)
  Vth_shift_Vgi_bi_Vgm_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgi_bi_Vgm_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgi_bi_Vgm_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgi_bi_Vgm_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgi_bi_Vdbulk_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgi_bi_Vdbulk_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgi_bi_Vsbulk_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgi_bi_Vsbulk_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgi_bi_Vgi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgi_bi_Vgi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgi_bi_Tempt_GND=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgi_bi_Tempt_GND)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+K2_EDGE_Tempt_GND*0.0+K2_EDGE*0.0));
  Vth_shift_Vgi_bi_Vdi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgi_bi_Vdi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*0.0+K2_EDGE*0.0));
  Vth_shift_Vgi_bi_Vsi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vgi_bi_Vsi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*0.0+K2_EDGE*0.0));
#endif
#if defined(_DERIVATE)
Vth_shift_Tempt_GND=((((dvth_dibl_Tempt_GND-dvth_temp_Tempt_GND)+dvth_sce_Tempt_GND)+vth0_stress_EDGE_Tempt_GND)-((K2_EDGE_Tempt_GND*Vbsx)+(K2_EDGE*Vbsx_Tempt_GND)));
#endif
Vth_shift_Vdi_bi=(((dvth_dibl_Vdi_bi-dvth_temp_Vdi_bi)+dvth_sce_Vdi_bi)-(K2_EDGE*Vbsx_Vdi_bi));
#if defined(_DERIVATE2)
  Vth_shift_Vdi_bi_Vgm_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdi_bi_Vgm_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+K2_EDGE*0.0));
  Vth_shift_Vdi_bi_Vgm_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdi_bi_Vgm_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+K2_EDGE*0.0));
  Vth_shift_Vdi_bi_Vdbulk_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdi_bi_Vdbulk_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+K2_EDGE*0.0));
  Vth_shift_Vdi_bi_Vsbulk_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdi_bi_Vsbulk_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+K2_EDGE*0.0));
  Vth_shift_Vdi_bi_Vgi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vdi_bi_Vgi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vdi_bi+K2_EDGE*0.0));
  Vth_shift_Vdi_bi_Tempt_GND=(+(+(+(+(+dvth_dibl_Vdi_bi_Tempt_GND-dvth_temp_Vdi_bi_Tempt_GND)+dvth_sce_Vdi_bi_Tempt_GND)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+K2_EDGE_Tempt_GND*Vbsx_Vdi_bi+K2_EDGE*Vbsx_Vdi_bi_Tempt_GND));
  Vth_shift_Vdi_bi_Vdi_bi=(+(+(+(+(+dvth_dibl_Vdi_bi_Vdi_bi-dvth_temp_Vdi_bi_Vdi_bi)+dvth_sce_Vdi_bi_Vdi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vdi_bi+K2_EDGE*Vbsx_Vdi_bi_Vdi_bi));
  Vth_shift_Vdi_bi_Vsi_bi=(+(+(+(+(+dvth_dibl_Vdi_bi_Vsi_bi-dvth_temp_Vdi_bi_Vsi_bi)+dvth_sce_Vdi_bi_Vsi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vdi_bi+K2_EDGE*Vbsx_Vdi_bi_Vsi_bi));
#endif
Vth_shift_Vsi_bi=(((dvth_dibl_Vsi_bi-dvth_temp_Vsi_bi)+dvth_sce_Vsi_bi)-(K2_EDGE*Vbsx_Vsi_bi));
#if defined(_DERIVATE2)
  Vth_shift_Vsi_bi_Vgm_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsi_bi_Vgm_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+K2_EDGE*0.0));
  Vth_shift_Vsi_bi_Vgm_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsi_bi_Vgm_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+K2_EDGE*0.0));
  Vth_shift_Vsi_bi_Vdbulk_di=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsi_bi_Vdbulk_di)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+K2_EDGE*0.0));
  Vth_shift_Vsi_bi_Vsbulk_si=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsi_bi_Vsbulk_si)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+K2_EDGE*0.0));
  Vth_shift_Vsi_bi_Vgi_bi=(+(+(+(+(+0.0-0.0)+dvth_sce_Vsi_bi_Vgi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*0.0+0.0*Vbsx_Vsi_bi+K2_EDGE*0.0));
  Vth_shift_Vsi_bi_Tempt_GND=(+(+(+(+(+dvth_dibl_Vsi_bi_Tempt_GND-dvth_temp_Vsi_bi_Tempt_GND)+dvth_sce_Vsi_bi_Tempt_GND)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Tempt_GND+K2_EDGE_Tempt_GND*Vbsx_Vsi_bi+K2_EDGE*Vbsx_Vsi_bi_Tempt_GND));
  Vth_shift_Vsi_bi_Vdi_bi=(+(+(+(+(+dvth_dibl_Vsi_bi_Vdi_bi-dvth_temp_Vsi_bi_Vdi_bi)+dvth_sce_Vsi_bi_Vdi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vdi_bi+0.0*Vbsx_Vsi_bi+K2_EDGE*Vbsx_Vsi_bi_Vdi_bi));
  Vth_shift_Vsi_bi_Vsi_bi=(+(+(+(+(+dvth_dibl_Vsi_bi_Vsi_bi-dvth_temp_Vsi_bi_Vsi_bi)+dvth_sce_Vsi_bi_Vsi_bi)+0.0)+0.0)-(+0.0*Vbsx+0.0*Vbsx_Vsi_bi+0.0*Vbsx_Vsi_bi+K2_EDGE*Vbsx_Vsi_bi_Vsi_bi));
#endif
#endif
Vth_shift=(((((dvth_dibl-dvth_temp)+dvth_sce)+pModel->DVTEDGE)+vth0_stress_EDGE)-(K2_EDGE*Vbsx));
EXIT_IF_ISNAN((((((dvth_dibl-dvth_temp)+dvth_sce)+pModel->DVTEDGE)+vth0_stress_EDGE)-(K2_EDGE*Vbsx)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gm,di)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
vgfb_Vgm_si=((vg_Vgm_si-vfb_Vgm_si)-((Vth_shift_Vgm_si*inv_nVt)+(Vth_shift*inv_nVt_Vgm_si)));
#if defined(_DERIVATE2)
  vgfb_Vgm_si_Vgm_si=(+(+vg_Vgm_si_Vgm_si-vfb_Vgm_si_Vgm_si)-(+Vth_shift_Vgm_si_Vgm_si*inv_nVt+Vth_shift_Vgm_si*inv_nVt_Vgm_si+Vth_shift_Vgm_si*inv_nVt_Vgm_si+Vth_shift*inv_nVt_Vgm_si_Vgm_si));
  vgfb_Vgm_si_Vdbulk_di=(+(+vg_Vgm_si_Vdbulk_di-vfb_Vgm_si_Vdbulk_di)-(+Vth_shift_Vgm_si_Vdbulk_di*inv_nVt+Vth_shift_Vgm_si*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*inv_nVt_Vgm_si+Vth_shift*inv_nVt_Vgm_si_Vdbulk_di));
  vgfb_Vgm_si_Vsbulk_si=(+(+vg_Vgm_si_Vsbulk_si-vfb_Vgm_si_Vsbulk_si)-(+Vth_shift_Vgm_si_Vsbulk_si*inv_nVt+Vth_shift_Vgm_si*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*inv_nVt_Vgm_si+Vth_shift*inv_nVt_Vgm_si_Vsbulk_si));
  vgfb_Vgm_si_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vgm_si_Vgm_di*inv_nVt+Vth_shift_Vgm_si*0.0+Vth_shift_Vgm_di*inv_nVt_Vgm_si+Vth_shift*0.0));
  vgfb_Vgm_si_Vgi_bi=(+(+vg_Vgm_si_Vgi_bi-vfb_Vgm_si_Vgi_bi)-(+Vth_shift_Vgm_si_Vgi_bi*inv_nVt+Vth_shift_Vgm_si*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*inv_nVt_Vgm_si+Vth_shift*inv_nVt_Vgm_si_Vgi_bi));
  vgfb_Vgm_si_Vdi_bi=(+(+vg_Vgm_si_Vdi_bi-vfb_Vgm_si_Vdi_bi)-(+Vth_shift_Vgm_si_Vdi_bi*inv_nVt+Vth_shift_Vgm_si*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*inv_nVt_Vgm_si+Vth_shift*inv_nVt_Vgm_si_Vdi_bi));
  vgfb_Vgm_si_Vsi_bi=(+(+vg_Vgm_si_Vsi_bi-vfb_Vgm_si_Vsi_bi)-(+Vth_shift_Vgm_si_Vsi_bi*inv_nVt+Vth_shift_Vgm_si*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*inv_nVt_Vgm_si+Vth_shift*inv_nVt_Vgm_si_Vsi_bi));
  vgfb_Vgm_si_Tempt_GND=(+(+vg_Vgm_si_Tempt_GND-vfb_Vgm_si_Tempt_GND)-(+Vth_shift_Vgm_si_Tempt_GND*inv_nVt+Vth_shift_Vgm_si*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*inv_nVt_Vgm_si+Vth_shift*inv_nVt_Vgm_si_Tempt_GND));
#endif
vgfb_Vdbulk_di=((vg_Vdbulk_di-vfb_Vdbulk_di)-((Vth_shift_Vdbulk_di*inv_nVt)+(Vth_shift*inv_nVt_Vdbulk_di)));
#if defined(_DERIVATE2)
  vgfb_Vdbulk_di_Vgm_si=(+(+vg_Vdbulk_di_Vgm_si-vfb_Vdbulk_di_Vgm_si)-(+Vth_shift_Vdbulk_di_Vgm_si*inv_nVt+Vth_shift_Vdbulk_di*inv_nVt_Vgm_si+Vth_shift_Vgm_si*inv_nVt_Vdbulk_di+Vth_shift*inv_nVt_Vdbulk_di_Vgm_si));
  vgfb_Vdbulk_di_Vdbulk_di=(+(+vg_Vdbulk_di_Vdbulk_di-vfb_Vdbulk_di_Vdbulk_di)-(+Vth_shift_Vdbulk_di_Vdbulk_di*inv_nVt+Vth_shift_Vdbulk_di*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*inv_nVt_Vdbulk_di+Vth_shift*inv_nVt_Vdbulk_di_Vdbulk_di));
  vgfb_Vdbulk_di_Vsbulk_si=(+(+vg_Vdbulk_di_Vsbulk_si-vfb_Vdbulk_di_Vsbulk_si)-(+Vth_shift_Vdbulk_di_Vsbulk_si*inv_nVt+Vth_shift_Vdbulk_di*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*inv_nVt_Vdbulk_di+Vth_shift*inv_nVt_Vdbulk_di_Vsbulk_si));
  vgfb_Vdbulk_di_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vdbulk_di_Vgm_di*inv_nVt+Vth_shift_Vdbulk_di*0.0+Vth_shift_Vgm_di*inv_nVt_Vdbulk_di+Vth_shift*0.0));
  vgfb_Vdbulk_di_Vgi_bi=(+(+vg_Vdbulk_di_Vgi_bi-vfb_Vdbulk_di_Vgi_bi)-(+Vth_shift_Vdbulk_di_Vgi_bi*inv_nVt+Vth_shift_Vdbulk_di*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*inv_nVt_Vdbulk_di+Vth_shift*inv_nVt_Vdbulk_di_Vgi_bi));
  vgfb_Vdbulk_di_Vdi_bi=(+(+vg_Vdbulk_di_Vdi_bi-vfb_Vdbulk_di_Vdi_bi)-(+Vth_shift_Vdbulk_di_Vdi_bi*inv_nVt+Vth_shift_Vdbulk_di*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*inv_nVt_Vdbulk_di+Vth_shift*inv_nVt_Vdbulk_di_Vdi_bi));
  vgfb_Vdbulk_di_Vsi_bi=(+(+vg_Vdbulk_di_Vsi_bi-vfb_Vdbulk_di_Vsi_bi)-(+Vth_shift_Vdbulk_di_Vsi_bi*inv_nVt+Vth_shift_Vdbulk_di*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*inv_nVt_Vdbulk_di+Vth_shift*inv_nVt_Vdbulk_di_Vsi_bi));
  vgfb_Vdbulk_di_Tempt_GND=(+(+vg_Vdbulk_di_Tempt_GND-vfb_Vdbulk_di_Tempt_GND)-(+Vth_shift_Vdbulk_di_Tempt_GND*inv_nVt+Vth_shift_Vdbulk_di*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*inv_nVt_Vdbulk_di+Vth_shift*inv_nVt_Vdbulk_di_Tempt_GND));
#endif
vgfb_Vsbulk_si=((vg_Vsbulk_si-vfb_Vsbulk_si)-((Vth_shift_Vsbulk_si*inv_nVt)+(Vth_shift*inv_nVt_Vsbulk_si)));
#if defined(_DERIVATE2)
  vgfb_Vsbulk_si_Vgm_si=(+(+vg_Vsbulk_si_Vgm_si-vfb_Vsbulk_si_Vgm_si)-(+Vth_shift_Vsbulk_si_Vgm_si*inv_nVt+Vth_shift_Vsbulk_si*inv_nVt_Vgm_si+Vth_shift_Vgm_si*inv_nVt_Vsbulk_si+Vth_shift*inv_nVt_Vsbulk_si_Vgm_si));
  vgfb_Vsbulk_si_Vdbulk_di=(+(+vg_Vsbulk_si_Vdbulk_di-vfb_Vsbulk_si_Vdbulk_di)-(+Vth_shift_Vsbulk_si_Vdbulk_di*inv_nVt+Vth_shift_Vsbulk_si*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*inv_nVt_Vsbulk_si+Vth_shift*inv_nVt_Vsbulk_si_Vdbulk_di));
  vgfb_Vsbulk_si_Vsbulk_si=(+(+vg_Vsbulk_si_Vsbulk_si-vfb_Vsbulk_si_Vsbulk_si)-(+Vth_shift_Vsbulk_si_Vsbulk_si*inv_nVt+Vth_shift_Vsbulk_si*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*inv_nVt_Vsbulk_si+Vth_shift*inv_nVt_Vsbulk_si_Vsbulk_si));
  vgfb_Vsbulk_si_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vsbulk_si_Vgm_di*inv_nVt+Vth_shift_Vsbulk_si*0.0+Vth_shift_Vgm_di*inv_nVt_Vsbulk_si+Vth_shift*0.0));
  vgfb_Vsbulk_si_Vgi_bi=(+(+vg_Vsbulk_si_Vgi_bi-vfb_Vsbulk_si_Vgi_bi)-(+Vth_shift_Vsbulk_si_Vgi_bi*inv_nVt+Vth_shift_Vsbulk_si*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*inv_nVt_Vsbulk_si+Vth_shift*inv_nVt_Vsbulk_si_Vgi_bi));
  vgfb_Vsbulk_si_Vdi_bi=(+(+vg_Vsbulk_si_Vdi_bi-vfb_Vsbulk_si_Vdi_bi)-(+Vth_shift_Vsbulk_si_Vdi_bi*inv_nVt+Vth_shift_Vsbulk_si*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*inv_nVt_Vsbulk_si+Vth_shift*inv_nVt_Vsbulk_si_Vdi_bi));
  vgfb_Vsbulk_si_Vsi_bi=(+(+vg_Vsbulk_si_Vsi_bi-vfb_Vsbulk_si_Vsi_bi)-(+Vth_shift_Vsbulk_si_Vsi_bi*inv_nVt+Vth_shift_Vsbulk_si*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*inv_nVt_Vsbulk_si+Vth_shift*inv_nVt_Vsbulk_si_Vsi_bi));
  vgfb_Vsbulk_si_Tempt_GND=(+(+vg_Vsbulk_si_Tempt_GND-vfb_Vsbulk_si_Tempt_GND)-(+Vth_shift_Vsbulk_si_Tempt_GND*inv_nVt+Vth_shift_Vsbulk_si*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*inv_nVt_Vsbulk_si+Vth_shift*inv_nVt_Vsbulk_si_Tempt_GND));
#endif
vgfb_Vgm_di=(-Vth_shift_Vgm_di*inv_nVt);
#if defined(_DERIVATE2)
  vgfb_Vgm_di_Vgm_si=(+(+0.0-0.0)-(+Vth_shift_Vgm_di_Vgm_si*inv_nVt+Vth_shift_Vgm_di*inv_nVt_Vgm_si+Vth_shift_Vgm_si*0.0+Vth_shift*0.0));
  vgfb_Vgm_di_Vdbulk_di=(+(+0.0-0.0)-(+Vth_shift_Vgm_di_Vdbulk_di*inv_nVt+Vth_shift_Vgm_di*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*0.0+Vth_shift*0.0));
  vgfb_Vgm_di_Vsbulk_si=(+(+0.0-0.0)-(+Vth_shift_Vgm_di_Vsbulk_si*inv_nVt+Vth_shift_Vgm_di*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*0.0+Vth_shift*0.0));
  vgfb_Vgm_di_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vgm_di_Vgm_di*inv_nVt+Vth_shift_Vgm_di*0.0+Vth_shift_Vgm_di*0.0+Vth_shift*0.0));
  vgfb_Vgm_di_Vgi_bi=(+(+0.0-0.0)-(+Vth_shift_Vgm_di_Vgi_bi*inv_nVt+Vth_shift_Vgm_di*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*0.0+Vth_shift*0.0));
  vgfb_Vgm_di_Vdi_bi=(+(+0.0-0.0)-(+Vth_shift_Vgm_di_Vdi_bi*inv_nVt+Vth_shift_Vgm_di*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*0.0+Vth_shift*0.0));
  vgfb_Vgm_di_Vsi_bi=(+(+0.0-0.0)-(+Vth_shift_Vgm_di_Vsi_bi*inv_nVt+Vth_shift_Vgm_di*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*0.0+Vth_shift*0.0));
  vgfb_Vgm_di_Tempt_GND=(+(+0.0-0.0)-(+Vth_shift_Vgm_di_Tempt_GND*inv_nVt+Vth_shift_Vgm_di*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*0.0+Vth_shift*0.0));
#endif
vgfb_Vgi_bi=((vg_Vgi_bi-vfb_Vgi_bi)-((Vth_shift_Vgi_bi*inv_nVt)+(Vth_shift*inv_nVt_Vgi_bi)));
#if defined(_DERIVATE2)
  vgfb_Vgi_bi_Vgm_si=(+(+vg_Vgi_bi_Vgm_si-vfb_Vgi_bi_Vgm_si)-(+Vth_shift_Vgi_bi_Vgm_si*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vgm_si+Vth_shift_Vgm_si*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vgm_si));
  vgfb_Vgi_bi_Vdbulk_di=(+(+vg_Vgi_bi_Vdbulk_di-vfb_Vgi_bi_Vdbulk_di)-(+Vth_shift_Vgi_bi_Vdbulk_di*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vdbulk_di));
  vgfb_Vgi_bi_Vsbulk_si=(+(+vg_Vgi_bi_Vsbulk_si-vfb_Vgi_bi_Vsbulk_si)-(+Vth_shift_Vgi_bi_Vsbulk_si*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vsbulk_si));
  vgfb_Vgi_bi_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vgi_bi_Vgm_di*inv_nVt+Vth_shift_Vgi_bi*0.0+Vth_shift_Vgm_di*inv_nVt_Vgi_bi+Vth_shift*0.0));
  vgfb_Vgi_bi_Vgi_bi=(+(+vg_Vgi_bi_Vgi_bi-vfb_Vgi_bi_Vgi_bi)-(+Vth_shift_Vgi_bi_Vgi_bi*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vgi_bi));
  vgfb_Vgi_bi_Vdi_bi=(+(+vg_Vgi_bi_Vdi_bi-vfb_Vgi_bi_Vdi_bi)-(+Vth_shift_Vgi_bi_Vdi_bi*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vdi_bi));
  vgfb_Vgi_bi_Vsi_bi=(+(+vg_Vgi_bi_Vsi_bi-vfb_Vgi_bi_Vsi_bi)-(+Vth_shift_Vgi_bi_Vsi_bi*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Vsi_bi));
  vgfb_Vgi_bi_Tempt_GND=(+(+vg_Vgi_bi_Tempt_GND-vfb_Vgi_bi_Tempt_GND)-(+Vth_shift_Vgi_bi_Tempt_GND*inv_nVt+Vth_shift_Vgi_bi*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*inv_nVt_Vgi_bi+Vth_shift*inv_nVt_Vgi_bi_Tempt_GND));
#endif
vgfb_Vdi_bi=((vg_Vdi_bi-vfb_Vdi_bi)-((Vth_shift_Vdi_bi*inv_nVt)+(Vth_shift*inv_nVt_Vdi_bi)));
#if defined(_DERIVATE2)
  vgfb_Vdi_bi_Vgm_si=(+(+vg_Vdi_bi_Vgm_si-vfb_Vdi_bi_Vgm_si)-(+Vth_shift_Vdi_bi_Vgm_si*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vgm_si+Vth_shift_Vgm_si*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vgm_si));
  vgfb_Vdi_bi_Vdbulk_di=(+(+vg_Vdi_bi_Vdbulk_di-vfb_Vdi_bi_Vdbulk_di)-(+Vth_shift_Vdi_bi_Vdbulk_di*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vdbulk_di));
  vgfb_Vdi_bi_Vsbulk_si=(+(+vg_Vdi_bi_Vsbulk_si-vfb_Vdi_bi_Vsbulk_si)-(+Vth_shift_Vdi_bi_Vsbulk_si*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vsbulk_si));
  vgfb_Vdi_bi_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vdi_bi_Vgm_di*inv_nVt+Vth_shift_Vdi_bi*0.0+Vth_shift_Vgm_di*inv_nVt_Vdi_bi+Vth_shift*0.0));
  vgfb_Vdi_bi_Vgi_bi=(+(+vg_Vdi_bi_Vgi_bi-vfb_Vdi_bi_Vgi_bi)-(+Vth_shift_Vdi_bi_Vgi_bi*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vgi_bi));
  vgfb_Vdi_bi_Vdi_bi=(+(+vg_Vdi_bi_Vdi_bi-vfb_Vdi_bi_Vdi_bi)-(+Vth_shift_Vdi_bi_Vdi_bi*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vdi_bi));
  vgfb_Vdi_bi_Vsi_bi=(+(+vg_Vdi_bi_Vsi_bi-vfb_Vdi_bi_Vsi_bi)-(+Vth_shift_Vdi_bi_Vsi_bi*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Vsi_bi));
  vgfb_Vdi_bi_Tempt_GND=(+(+vg_Vdi_bi_Tempt_GND-vfb_Vdi_bi_Tempt_GND)-(+Vth_shift_Vdi_bi_Tempt_GND*inv_nVt+Vth_shift_Vdi_bi*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*inv_nVt_Vdi_bi+Vth_shift*inv_nVt_Vdi_bi_Tempt_GND));
#endif
vgfb_Vsi_bi=((vg_Vsi_bi-vfb_Vsi_bi)-((Vth_shift_Vsi_bi*inv_nVt)+(Vth_shift*inv_nVt_Vsi_bi)));
#if defined(_DERIVATE2)
  vgfb_Vsi_bi_Vgm_si=(+(+vg_Vsi_bi_Vgm_si-vfb_Vsi_bi_Vgm_si)-(+Vth_shift_Vsi_bi_Vgm_si*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vgm_si+Vth_shift_Vgm_si*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vgm_si));
  vgfb_Vsi_bi_Vdbulk_di=(+(+vg_Vsi_bi_Vdbulk_di-vfb_Vsi_bi_Vdbulk_di)-(+Vth_shift_Vsi_bi_Vdbulk_di*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vdbulk_di+Vth_shift_Vdbulk_di*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vdbulk_di));
  vgfb_Vsi_bi_Vsbulk_si=(+(+vg_Vsi_bi_Vsbulk_si-vfb_Vsi_bi_Vsbulk_si)-(+Vth_shift_Vsi_bi_Vsbulk_si*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vsbulk_si+Vth_shift_Vsbulk_si*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vsbulk_si));
  vgfb_Vsi_bi_Vgm_di=(+(+0.0-0.0)-(+Vth_shift_Vsi_bi_Vgm_di*inv_nVt+Vth_shift_Vsi_bi*0.0+Vth_shift_Vgm_di*inv_nVt_Vsi_bi+Vth_shift*0.0));
  vgfb_Vsi_bi_Vgi_bi=(+(+vg_Vsi_bi_Vgi_bi-vfb_Vsi_bi_Vgi_bi)-(+Vth_shift_Vsi_bi_Vgi_bi*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vgi_bi+Vth_shift_Vgi_bi*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vgi_bi));
  vgfb_Vsi_bi_Vdi_bi=(+(+vg_Vsi_bi_Vdi_bi-vfb_Vsi_bi_Vdi_bi)-(+Vth_shift_Vsi_bi_Vdi_bi*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vdi_bi+Vth_shift_Vdi_bi*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vdi_bi));
  vgfb_Vsi_bi_Vsi_bi=(+(+vg_Vsi_bi_Vsi_bi-vfb_Vsi_bi_Vsi_bi)-(+Vth_shift_Vsi_bi_Vsi_bi*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Vsi_bi+Vth_shift_Vsi_bi*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Vsi_bi));
  vgfb_Vsi_bi_Tempt_GND=(+(+vg_Vsi_bi_Tempt_GND-vfb_Vsi_bi_Tempt_GND)-(+Vth_shift_Vsi_bi_Tempt_GND*inv_nVt+Vth_shift_Vsi_bi*inv_nVt_Tempt_GND+Vth_shift_Tempt_GND*inv_nVt_Vsi_bi+Vth_shift*inv_nVt_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
vgfb_Tempt_GND=((vg_Tempt_GND-vfb_Tempt_GND)-((Vth_shift_Tempt_GND*inv_nVt)+(Vth_shift*inv_nVt_Tempt_GND)));
#endif
#endif
vgfb=((vg-vfb)-(Vth_shift*inv_nVt));
EXIT_IF_ISNAN(((vg-vfb)-(Vth_shift*inv_nVt)))
{
double m00_pow(d00_pow0,Leff,(-pModel->DGAMMAEDGELEXP))
DGAMMAEDGE_i=(pModel->DGAMMAEDGE*(1.0+(pModel->DGAMMAEDGEL*d00_pow0)));
EXIT_IF_ISNAN((pModel->DGAMMAEDGE*(1.0+(pModel->DGAMMAEDGEL*d00_pow0))))
}
{
double m00_sqrt(d00_sqrt0,((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gam_Vgm_si=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)*d10_sqrt0/Cox);
#if defined(_DERIVATE2)
  gam_Vgm_si_Vgm_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgm_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgm_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si_Vgm_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgm_si_Vdbulk_di=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdbulk_di+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgm_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si_Vdbulk_di))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgm_si_Vsbulk_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsbulk_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgm_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si_Vsbulk_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgm_si_Vgi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgm_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si_Vgi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgm_si_Vdi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgm_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si_Vdi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgm_si_Vsi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgm_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si_Vsi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgm_si_Tempt_GND=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Tempt_GND+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgm_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si_Tempt_GND))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
#endif
gam_Vdbulk_di=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)*d10_sqrt0/Cox);
#if defined(_DERIVATE2)
  gam_Vdbulk_di_Vgm_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgm_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di_Vgm_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdbulk_di_Vdbulk_di=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdbulk_di+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di_Vdbulk_di))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdbulk_di_Vsbulk_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsbulk_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di_Vsbulk_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdbulk_di_Vgi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di_Vgi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdbulk_di_Vdi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di_Vdi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdbulk_di_Vsi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di_Vsi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdbulk_di_Tempt_GND=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Tempt_GND+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di_Tempt_GND))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
#endif
gam_Vsbulk_si=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)*d10_sqrt0/Cox);
#if defined(_DERIVATE2)
  gam_Vsbulk_si_Vgm_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgm_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si_Vgm_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsbulk_si_Vdbulk_di=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdbulk_di+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si_Vdbulk_di))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsbulk_si_Vsbulk_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsbulk_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si_Vsbulk_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsbulk_si_Vgi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si_Vgi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsbulk_si_Vdi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si_Vdi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsbulk_si_Vsi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si_Vsi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsbulk_si_Tempt_GND=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Tempt_GND+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si_Tempt_GND))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
#endif
gam_Vgi_bi=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)*d10_sqrt0/Cox);
#if defined(_DERIVATE2)
  gam_Vgi_bi_Vgm_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgm_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi_Vgm_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgi_bi_Vdbulk_di=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdbulk_di+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi_Vdbulk_di))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgi_bi_Vsbulk_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsbulk_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi_Vsbulk_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgi_bi_Vgi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi_Vgi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgi_bi_Vdi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi_Vdi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgi_bi_Vsi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi_Vsi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vgi_bi_Tempt_GND=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Tempt_GND+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vgi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi_Tempt_GND))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
#endif
gam_Vdi_bi=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0/Cox);
#if defined(_DERIVATE2)
  gam_Vdi_bi_Vgm_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgm_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vgm_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vdbulk_di=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdbulk_di+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vdbulk_di))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vsbulk_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsbulk_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vsbulk_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vgi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vgi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vdi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vdi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Vsi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Vsi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vdi_bi_Tempt_GND=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Tempt_GND+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vdi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi_Tempt_GND))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
#endif
gam_Vsi_bi=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0/Cox);
#if defined(_DERIVATE2)
  gam_Vsi_bi_Vgm_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgm_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vgm_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgm_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vdbulk_di=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdbulk_di+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vdbulk_di))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdbulk_di)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vsbulk_si=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsbulk_si+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vsbulk_si))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsbulk_si)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vgi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vgi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vgi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vgi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vdi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vdi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vdi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vdi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Vsi_bi=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Vsi_bi+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Vsi_bi))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
  gam_Vsi_bi_Tempt_GND=((m20_sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))*((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)+d10_sqrt0*(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*epssi+0.0*0.0+(0.0)*0.0+(2.0*1.60219e-19)*0.0)*NDEP_i+0.0*0.0+((0.0)*epssi)*0.0+((2.0*1.60219e-19)*epssi)*0.0)*inv_nVt+0.0*inv_nVt_Tempt_GND+(((0.0)*epssi)*NDEP_i)*inv_nVt_Vsi_bi+(((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi_Tempt_GND))/Cox-(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Vsi_bi)*d10_sqrt0*0.0+((((((0.0)*epssi)*NDEP_i)*inv_nVt)+((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)))*d10_sqrt0*0.0+d00_sqrt0*0.0)/Cox/Cox+2*d00_sqrt0*0.0*0.0/Cox/Cox/Cox);
#endif
#if defined(_DERIVATE)
gam_Tempt_GND=(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt_Tempt_GND)*d10_sqrt0/Cox);
#endif
#endif
gam=(d00_sqrt0/Cox);
EXIT_IF_ISNAN((d00_sqrt0/Cox))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gam_Vgm_si=gam_Vgm_si*(1.0+DGAMMAEDGE_i);
#if defined(_DERIVATE2)
  gam_Vgm_si_Vgm_si=(+gam_Vgm_si_Vgm_si*(1.0+DGAMMAEDGE_i)+gam_Vgm_si*0.0+gam_Vgm_si*0.0+gam*(+0.0+0.0));
  gam_Vgm_si_Vdbulk_di=(+gam_Vgm_si_Vdbulk_di*(1.0+DGAMMAEDGE_i)+gam_Vgm_si*0.0+gam_Vdbulk_di*0.0+gam*(+0.0+0.0));
  gam_Vgm_si_Vsbulk_si=(+gam_Vgm_si_Vsbulk_si*(1.0+DGAMMAEDGE_i)+gam_Vgm_si*0.0+gam_Vsbulk_si*0.0+gam*(+0.0+0.0));
  gam_Vgm_si_Vgi_bi=(+gam_Vgm_si_Vgi_bi*(1.0+DGAMMAEDGE_i)+gam_Vgm_si*0.0+gam_Vgi_bi*0.0+gam*(+0.0+0.0));
  gam_Vgm_si_Vdi_bi=(+gam_Vgm_si_Vdi_bi*(1.0+DGAMMAEDGE_i)+gam_Vgm_si*0.0+gam_Vdi_bi*0.0+gam*(+0.0+0.0));
  gam_Vgm_si_Vsi_bi=(+gam_Vgm_si_Vsi_bi*(1.0+DGAMMAEDGE_i)+gam_Vgm_si*0.0+gam_Vsi_bi*0.0+gam*(+0.0+0.0));
  gam_Vgm_si_Tempt_GND=(+gam_Vgm_si_Tempt_GND*(1.0+DGAMMAEDGE_i)+gam_Vgm_si*0.0+gam_Tempt_GND*0.0+gam*(+0.0+0.0));
#endif
gam_Vdbulk_di=gam_Vdbulk_di*(1.0+DGAMMAEDGE_i);
#if defined(_DERIVATE2)
  gam_Vdbulk_di_Vgm_si=(+gam_Vdbulk_di_Vgm_si*(1.0+DGAMMAEDGE_i)+gam_Vdbulk_di*0.0+gam_Vgm_si*0.0+gam*(+0.0+0.0));
  gam_Vdbulk_di_Vdbulk_di=(+gam_Vdbulk_di_Vdbulk_di*(1.0+DGAMMAEDGE_i)+gam_Vdbulk_di*0.0+gam_Vdbulk_di*0.0+gam*(+0.0+0.0));
  gam_Vdbulk_di_Vsbulk_si=(+gam_Vdbulk_di_Vsbulk_si*(1.0+DGAMMAEDGE_i)+gam_Vdbulk_di*0.0+gam_Vsbulk_si*0.0+gam*(+0.0+0.0));
  gam_Vdbulk_di_Vgi_bi=(+gam_Vdbulk_di_Vgi_bi*(1.0+DGAMMAEDGE_i)+gam_Vdbulk_di*0.0+gam_Vgi_bi*0.0+gam*(+0.0+0.0));
  gam_Vdbulk_di_Vdi_bi=(+gam_Vdbulk_di_Vdi_bi*(1.0+DGAMMAEDGE_i)+gam_Vdbulk_di*0.0+gam_Vdi_bi*0.0+gam*(+0.0+0.0));
  gam_Vdbulk_di_Vsi_bi=(+gam_Vdbulk_di_Vsi_bi*(1.0+DGAMMAEDGE_i)+gam_Vdbulk_di*0.0+gam_Vsi_bi*0.0+gam*(+0.0+0.0));
  gam_Vdbulk_di_Tempt_GND=(+gam_Vdbulk_di_Tempt_GND*(1.0+DGAMMAEDGE_i)+gam_Vdbulk_di*0.0+gam_Tempt_GND*0.0+gam*(+0.0+0.0));
#endif
gam_Vsbulk_si=gam_Vsbulk_si*(1.0+DGAMMAEDGE_i);
#if defined(_DERIVATE2)
  gam_Vsbulk_si_Vgm_si=(+gam_Vsbulk_si_Vgm_si*(1.0+DGAMMAEDGE_i)+gam_Vsbulk_si*0.0+gam_Vgm_si*0.0+gam*(+0.0+0.0));
  gam_Vsbulk_si_Vdbulk_di=(+gam_Vsbulk_si_Vdbulk_di*(1.0+DGAMMAEDGE_i)+gam_Vsbulk_si*0.0+gam_Vdbulk_di*0.0+gam*(+0.0+0.0));
  gam_Vsbulk_si_Vsbulk_si=(+gam_Vsbulk_si_Vsbulk_si*(1.0+DGAMMAEDGE_i)+gam_Vsbulk_si*0.0+gam_Vsbulk_si*0.0+gam*(+0.0+0.0));
  gam_Vsbulk_si_Vgi_bi=(+gam_Vsbulk_si_Vgi_bi*(1.0+DGAMMAEDGE_i)+gam_Vsbulk_si*0.0+gam_Vgi_bi*0.0+gam*(+0.0+0.0));
  gam_Vsbulk_si_Vdi_bi=(+gam_Vsbulk_si_Vdi_bi*(1.0+DGAMMAEDGE_i)+gam_Vsbulk_si*0.0+gam_Vdi_bi*0.0+gam*(+0.0+0.0));
  gam_Vsbulk_si_Vsi_bi=(+gam_Vsbulk_si_Vsi_bi*(1.0+DGAMMAEDGE_i)+gam_Vsbulk_si*0.0+gam_Vsi_bi*0.0+gam*(+0.0+0.0));
  gam_Vsbulk_si_Tempt_GND=(+gam_Vsbulk_si_Tempt_GND*(1.0+DGAMMAEDGE_i)+gam_Vsbulk_si*0.0+gam_Tempt_GND*0.0+gam*(+0.0+0.0));
#endif
gam_Vgi_bi=gam_Vgi_bi*(1.0+DGAMMAEDGE_i);
#if defined(_DERIVATE2)
  gam_Vgi_bi_Vgm_si=(+gam_Vgi_bi_Vgm_si*(1.0+DGAMMAEDGE_i)+gam_Vgi_bi*0.0+gam_Vgm_si*0.0+gam*(+0.0+0.0));
  gam_Vgi_bi_Vdbulk_di=(+gam_Vgi_bi_Vdbulk_di*(1.0+DGAMMAEDGE_i)+gam_Vgi_bi*0.0+gam_Vdbulk_di*0.0+gam*(+0.0+0.0));
  gam_Vgi_bi_Vsbulk_si=(+gam_Vgi_bi_Vsbulk_si*(1.0+DGAMMAEDGE_i)+gam_Vgi_bi*0.0+gam_Vsbulk_si*0.0+gam*(+0.0+0.0));
  gam_Vgi_bi_Vgi_bi=(+gam_Vgi_bi_Vgi_bi*(1.0+DGAMMAEDGE_i)+gam_Vgi_bi*0.0+gam_Vgi_bi*0.0+gam*(+0.0+0.0));
  gam_Vgi_bi_Vdi_bi=(+gam_Vgi_bi_Vdi_bi*(1.0+DGAMMAEDGE_i)+gam_Vgi_bi*0.0+gam_Vdi_bi*0.0+gam*(+0.0+0.0));
  gam_Vgi_bi_Vsi_bi=(+gam_Vgi_bi_Vsi_bi*(1.0+DGAMMAEDGE_i)+gam_Vgi_bi*0.0+gam_Vsi_bi*0.0+gam*(+0.0+0.0));
  gam_Vgi_bi_Tempt_GND=(+gam_Vgi_bi_Tempt_GND*(1.0+DGAMMAEDGE_i)+gam_Vgi_bi*0.0+gam_Tempt_GND*0.0+gam*(+0.0+0.0));
#endif
gam_Vdi_bi=gam_Vdi_bi*(1.0+DGAMMAEDGE_i);
#if defined(_DERIVATE2)
  gam_Vdi_bi_Vgm_si=(+gam_Vdi_bi_Vgm_si*(1.0+DGAMMAEDGE_i)+gam_Vdi_bi*0.0+gam_Vgm_si*0.0+gam*(+0.0+0.0));
  gam_Vdi_bi_Vdbulk_di=(+gam_Vdi_bi_Vdbulk_di*(1.0+DGAMMAEDGE_i)+gam_Vdi_bi*0.0+gam_Vdbulk_di*0.0+gam*(+0.0+0.0));
  gam_Vdi_bi_Vsbulk_si=(+gam_Vdi_bi_Vsbulk_si*(1.0+DGAMMAEDGE_i)+gam_Vdi_bi*0.0+gam_Vsbulk_si*0.0+gam*(+0.0+0.0));
  gam_Vdi_bi_Vgi_bi=(+gam_Vdi_bi_Vgi_bi*(1.0+DGAMMAEDGE_i)+gam_Vdi_bi*0.0+gam_Vgi_bi*0.0+gam*(+0.0+0.0));
  gam_Vdi_bi_Vdi_bi=(+gam_Vdi_bi_Vdi_bi*(1.0+DGAMMAEDGE_i)+gam_Vdi_bi*0.0+gam_Vdi_bi*0.0+gam*(+0.0+0.0));
  gam_Vdi_bi_Vsi_bi=(+gam_Vdi_bi_Vsi_bi*(1.0+DGAMMAEDGE_i)+gam_Vdi_bi*0.0+gam_Vsi_bi*0.0+gam*(+0.0+0.0));
  gam_Vdi_bi_Tempt_GND=(+gam_Vdi_bi_Tempt_GND*(1.0+DGAMMAEDGE_i)+gam_Vdi_bi*0.0+gam_Tempt_GND*0.0+gam*(+0.0+0.0));
#endif
gam_Vsi_bi=gam_Vsi_bi*(1.0+DGAMMAEDGE_i);
#if defined(_DERIVATE2)
  gam_Vsi_bi_Vgm_si=(+gam_Vsi_bi_Vgm_si*(1.0+DGAMMAEDGE_i)+gam_Vsi_bi*0.0+gam_Vgm_si*0.0+gam*(+0.0+0.0));
  gam_Vsi_bi_Vdbulk_di=(+gam_Vsi_bi_Vdbulk_di*(1.0+DGAMMAEDGE_i)+gam_Vsi_bi*0.0+gam_Vdbulk_di*0.0+gam*(+0.0+0.0));
  gam_Vsi_bi_Vsbulk_si=(+gam_Vsi_bi_Vsbulk_si*(1.0+DGAMMAEDGE_i)+gam_Vsi_bi*0.0+gam_Vsbulk_si*0.0+gam*(+0.0+0.0));
  gam_Vsi_bi_Vgi_bi=(+gam_Vsi_bi_Vgi_bi*(1.0+DGAMMAEDGE_i)+gam_Vsi_bi*0.0+gam_Vgi_bi*0.0+gam*(+0.0+0.0));
  gam_Vsi_bi_Vdi_bi=(+gam_Vsi_bi_Vdi_bi*(1.0+DGAMMAEDGE_i)+gam_Vsi_bi*0.0+gam_Vdi_bi*0.0+gam*(+0.0+0.0));
  gam_Vsi_bi_Vsi_bi=(+gam_Vsi_bi_Vsi_bi*(1.0+DGAMMAEDGE_i)+gam_Vsi_bi*0.0+gam_Vsi_bi*0.0+gam*(+0.0+0.0));
  gam_Vsi_bi_Tempt_GND=(+gam_Vsi_bi_Tempt_GND*(1.0+DGAMMAEDGE_i)+gam_Vsi_bi*0.0+gam_Tempt_GND*0.0+gam*(+0.0+0.0));
#endif
#if defined(_DERIVATE)
gam_Tempt_GND=gam_Tempt_GND*(1.0+DGAMMAEDGE_i);
#endif
#endif
gam=(gam*(1.0+DGAMMAEDGE_i));
EXIT_IF_ISNAN((gam*(1.0+DGAMMAEDGE_i)))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND)V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND) */
inv_gam_Vgm_si=(-gam_Vgm_si/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vgm_si_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vgm_si+1.0*gam_Vgm_si_Vgm_si)/gam/gam+2*1.0*gam_Vgm_si*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vgm_si_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vgm_si+1.0*gam_Vgm_si_Vdbulk_di)/gam/gam+2*1.0*gam_Vgm_si*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vgm_si_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vgm_si+1.0*gam_Vgm_si_Vsbulk_si)/gam/gam+2*1.0*gam_Vgm_si*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vgm_si_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vgm_si+1.0*gam_Vgm_si_Vgi_bi)/gam/gam+2*1.0*gam_Vgm_si*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vgm_si_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vgm_si+1.0*gam_Vgm_si_Vdi_bi)/gam/gam+2*1.0*gam_Vgm_si*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vgm_si_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vgm_si+1.0*gam_Vgm_si_Vsi_bi)/gam/gam+2*1.0*gam_Vgm_si*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vgm_si_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vgm_si+1.0*gam_Vgm_si_Tempt_GND)/gam/gam+2*1.0*gam_Vgm_si*gam_Tempt_GND/gam/gam/gam);
#endif
inv_gam_Vdbulk_di=(-gam_Vdbulk_di/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vdbulk_di_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vdbulk_di+1.0*gam_Vdbulk_di_Vgm_si)/gam/gam+2*1.0*gam_Vdbulk_di*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vdbulk_di_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vdbulk_di+1.0*gam_Vdbulk_di_Vdbulk_di)/gam/gam+2*1.0*gam_Vdbulk_di*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vdbulk_di_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vdbulk_di+1.0*gam_Vdbulk_di_Vsbulk_si)/gam/gam+2*1.0*gam_Vdbulk_di*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vdbulk_di_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vdbulk_di+1.0*gam_Vdbulk_di_Vgi_bi)/gam/gam+2*1.0*gam_Vdbulk_di*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vdbulk_di_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vdbulk_di+1.0*gam_Vdbulk_di_Vdi_bi)/gam/gam+2*1.0*gam_Vdbulk_di*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vdbulk_di_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vdbulk_di+1.0*gam_Vdbulk_di_Vsi_bi)/gam/gam+2*1.0*gam_Vdbulk_di*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vdbulk_di_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vdbulk_di+1.0*gam_Vdbulk_di_Tempt_GND)/gam/gam+2*1.0*gam_Vdbulk_di*gam_Tempt_GND/gam/gam/gam);
#endif
inv_gam_Vsbulk_si=(-gam_Vsbulk_si/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vsbulk_si_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vsbulk_si+1.0*gam_Vsbulk_si_Vgm_si)/gam/gam+2*1.0*gam_Vsbulk_si*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vsbulk_si_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vsbulk_si+1.0*gam_Vsbulk_si_Vdbulk_di)/gam/gam+2*1.0*gam_Vsbulk_si*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vsbulk_si_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vsbulk_si+1.0*gam_Vsbulk_si_Vsbulk_si)/gam/gam+2*1.0*gam_Vsbulk_si*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vsbulk_si_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vsbulk_si+1.0*gam_Vsbulk_si_Vgi_bi)/gam/gam+2*1.0*gam_Vsbulk_si*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vsbulk_si_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vsbulk_si+1.0*gam_Vsbulk_si_Vdi_bi)/gam/gam+2*1.0*gam_Vsbulk_si*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vsbulk_si_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vsbulk_si+1.0*gam_Vsbulk_si_Vsi_bi)/gam/gam+2*1.0*gam_Vsbulk_si*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vsbulk_si_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vsbulk_si+1.0*gam_Vsbulk_si_Tempt_GND)/gam/gam+2*1.0*gam_Vsbulk_si*gam_Tempt_GND/gam/gam/gam);
#endif
inv_gam_Vgi_bi=(-gam_Vgi_bi/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vgi_bi_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vgi_bi+1.0*gam_Vgi_bi_Vgm_si)/gam/gam+2*1.0*gam_Vgi_bi*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vgi_bi_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vgi_bi+1.0*gam_Vgi_bi_Vdbulk_di)/gam/gam+2*1.0*gam_Vgi_bi*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vgi_bi_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vgi_bi+1.0*gam_Vgi_bi_Vsbulk_si)/gam/gam+2*1.0*gam_Vgi_bi*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vgi_bi_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vgi_bi+1.0*gam_Vgi_bi_Vgi_bi)/gam/gam+2*1.0*gam_Vgi_bi*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vgi_bi_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vgi_bi+1.0*gam_Vgi_bi_Vdi_bi)/gam/gam+2*1.0*gam_Vgi_bi*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vgi_bi_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vgi_bi+1.0*gam_Vgi_bi_Vsi_bi)/gam/gam+2*1.0*gam_Vgi_bi*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vgi_bi_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vgi_bi+1.0*gam_Vgi_bi_Tempt_GND)/gam/gam+2*1.0*gam_Vgi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
inv_gam_Vdi_bi=(-gam_Vdi_bi/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vdi_bi_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vgm_si)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vdi_bi_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vdbulk_di)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vdi_bi_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vsbulk_si)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vdi_bi_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vgi_bi)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vdi_bi_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vdi_bi)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vdi_bi_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Vsi_bi)/gam/gam+2*1.0*gam_Vdi_bi*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vdi_bi_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vdi_bi+1.0*gam_Vdi_bi_Tempt_GND)/gam/gam+2*1.0*gam_Vdi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
inv_gam_Vsi_bi=(-gam_Vsi_bi/gam/gam);
#if defined(_DERIVATE2)
  inv_gam_Vsi_bi_Vgm_si=(0.0/gam-(0.0*gam_Vgm_si+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vgm_si)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vgm_si/gam/gam/gam);
  inv_gam_Vsi_bi_Vdbulk_di=(0.0/gam-(0.0*gam_Vdbulk_di+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vdbulk_di)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vdbulk_di/gam/gam/gam);
  inv_gam_Vsi_bi_Vsbulk_si=(0.0/gam-(0.0*gam_Vsbulk_si+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vsbulk_si)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vsbulk_si/gam/gam/gam);
  inv_gam_Vsi_bi_Vgi_bi=(0.0/gam-(0.0*gam_Vgi_bi+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vgi_bi)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vgi_bi/gam/gam/gam);
  inv_gam_Vsi_bi_Vdi_bi=(0.0/gam-(0.0*gam_Vdi_bi+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vdi_bi)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vdi_bi/gam/gam/gam);
  inv_gam_Vsi_bi_Vsi_bi=(0.0/gam-(0.0*gam_Vsi_bi+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Vsi_bi)/gam/gam+2*1.0*gam_Vsi_bi*gam_Vsi_bi/gam/gam/gam);
  inv_gam_Vsi_bi_Tempt_GND=(0.0/gam-(0.0*gam_Tempt_GND+0.0*gam_Vsi_bi+1.0*gam_Vsi_bi_Tempt_GND)/gam/gam+2*1.0*gam_Vsi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
#if defined(_DERIVATE)
inv_gam_Tempt_GND=(-gam_Tempt_GND/gam/gam);
#endif
#endif
inv_gam=(1.0/gam);
EXIT_IF_ISNAN((1.0/gam))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
phib_n_Vgm_si=(-phib*n_Vgm_si/n/n);
#if defined(_DERIVATE2)
  phib_n_Vgm_si_Vgm_si=(0.0/n-(0.0*n_Vgm_si+0.0*n_Vgm_si+phib*n_Vgm_si_Vgm_si)/n/n+2*phib*n_Vgm_si*n_Vgm_si/n/n/n);
  phib_n_Vgm_si_Vdbulk_di=(0.0/n-(0.0*n_Vdbulk_di+0.0*n_Vgm_si+phib*n_Vgm_si_Vdbulk_di)/n/n+2*phib*n_Vgm_si*n_Vdbulk_di/n/n/n);
  phib_n_Vgm_si_Vsbulk_si=(0.0/n-(0.0*n_Vsbulk_si+0.0*n_Vgm_si+phib*n_Vgm_si_Vsbulk_si)/n/n+2*phib*n_Vgm_si*n_Vsbulk_si/n/n/n);
  phib_n_Vgm_si_Vgi_bi=(0.0/n-(0.0*n_Vgi_bi+0.0*n_Vgm_si+phib*n_Vgm_si_Vgi_bi)/n/n+2*phib*n_Vgm_si*n_Vgi_bi/n/n/n);
  phib_n_Vgm_si_Tempt_GND=(0.0/n-(0.0*n_Tempt_GND+phib_Tempt_GND*n_Vgm_si+phib*n_Vgm_si_Tempt_GND)/n/n+2*phib*n_Vgm_si*n_Tempt_GND/n/n/n);
  phib_n_Vgm_si_Vdi_bi=(0.0/n-(0.0*n_Vdi_bi+0.0*n_Vgm_si+phib*n_Vgm_si_Vdi_bi)/n/n+2*phib*n_Vgm_si*n_Vdi_bi/n/n/n);
  phib_n_Vgm_si_Vsi_bi=(0.0/n-(0.0*n_Vsi_bi+0.0*n_Vgm_si+phib*n_Vgm_si_Vsi_bi)/n/n+2*phib*n_Vgm_si*n_Vsi_bi/n/n/n);
#endif
phib_n_Vdbulk_di=(-phib*n_Vdbulk_di/n/n);
#if defined(_DERIVATE2)
  phib_n_Vdbulk_di_Vgm_si=(0.0/n-(0.0*n_Vgm_si+0.0*n_Vdbulk_di+phib*n_Vdbulk_di_Vgm_si)/n/n+2*phib*n_Vdbulk_di*n_Vgm_si/n/n/n);
  phib_n_Vdbulk_di_Vdbulk_di=(0.0/n-(0.0*n_Vdbulk_di+0.0*n_Vdbulk_di+phib*n_Vdbulk_di_Vdbulk_di)/n/n+2*phib*n_Vdbulk_di*n_Vdbulk_di/n/n/n);
  phib_n_Vdbulk_di_Vsbulk_si=(0.0/n-(0.0*n_Vsbulk_si+0.0*n_Vdbulk_di+phib*n_Vdbulk_di_Vsbulk_si)/n/n+2*phib*n_Vdbulk_di*n_Vsbulk_si/n/n/n);
  phib_n_Vdbulk_di_Vgi_bi=(0.0/n-(0.0*n_Vgi_bi+0.0*n_Vdbulk_di+phib*n_Vdbulk_di_Vgi_bi)/n/n+2*phib*n_Vdbulk_di*n_Vgi_bi/n/n/n);
  phib_n_Vdbulk_di_Tempt_GND=(0.0/n-(0.0*n_Tempt_GND+phib_Tempt_GND*n_Vdbulk_di+phib*n_Vdbulk_di_Tempt_GND)/n/n+2*phib*n_Vdbulk_di*n_Tempt_GND/n/n/n);
  phib_n_Vdbulk_di_Vdi_bi=(0.0/n-(0.0*n_Vdi_bi+0.0*n_Vdbulk_di+phib*n_Vdbulk_di_Vdi_bi)/n/n+2*phib*n_Vdbulk_di*n_Vdi_bi/n/n/n);
  phib_n_Vdbulk_di_Vsi_bi=(0.0/n-(0.0*n_Vsi_bi+0.0*n_Vdbulk_di+phib*n_Vdbulk_di_Vsi_bi)/n/n+2*phib*n_Vdbulk_di*n_Vsi_bi/n/n/n);
#endif
phib_n_Vsbulk_si=(-phib*n_Vsbulk_si/n/n);
#if defined(_DERIVATE2)
  phib_n_Vsbulk_si_Vgm_si=(0.0/n-(0.0*n_Vgm_si+0.0*n_Vsbulk_si+phib*n_Vsbulk_si_Vgm_si)/n/n+2*phib*n_Vsbulk_si*n_Vgm_si/n/n/n);
  phib_n_Vsbulk_si_Vdbulk_di=(0.0/n-(0.0*n_Vdbulk_di+0.0*n_Vsbulk_si+phib*n_Vsbulk_si_Vdbulk_di)/n/n+2*phib*n_Vsbulk_si*n_Vdbulk_di/n/n/n);
  phib_n_Vsbulk_si_Vsbulk_si=(0.0/n-(0.0*n_Vsbulk_si+0.0*n_Vsbulk_si+phib*n_Vsbulk_si_Vsbulk_si)/n/n+2*phib*n_Vsbulk_si*n_Vsbulk_si/n/n/n);
  phib_n_Vsbulk_si_Vgi_bi=(0.0/n-(0.0*n_Vgi_bi+0.0*n_Vsbulk_si+phib*n_Vsbulk_si_Vgi_bi)/n/n+2*phib*n_Vsbulk_si*n_Vgi_bi/n/n/n);
  phib_n_Vsbulk_si_Tempt_GND=(0.0/n-(0.0*n_Tempt_GND+phib_Tempt_GND*n_Vsbulk_si+phib*n_Vsbulk_si_Tempt_GND)/n/n+2*phib*n_Vsbulk_si*n_Tempt_GND/n/n/n);
  phib_n_Vsbulk_si_Vdi_bi=(0.0/n-(0.0*n_Vdi_bi+0.0*n_Vsbulk_si+phib*n_Vsbulk_si_Vdi_bi)/n/n+2*phib*n_Vsbulk_si*n_Vdi_bi/n/n/n);
  phib_n_Vsbulk_si_Vsi_bi=(0.0/n-(0.0*n_Vsi_bi+0.0*n_Vsbulk_si+phib*n_Vsbulk_si_Vsi_bi)/n/n+2*phib*n_Vsbulk_si*n_Vsi_bi/n/n/n);
#endif
phib_n_Vgi_bi=(-phib*n_Vgi_bi/n/n);
#if defined(_DERIVATE2)
  phib_n_Vgi_bi_Vgm_si=(0.0/n-(0.0*n_Vgm_si+0.0*n_Vgi_bi+phib*n_Vgi_bi_Vgm_si)/n/n+2*phib*n_Vgi_bi*n_Vgm_si/n/n/n);
  phib_n_Vgi_bi_Vdbulk_di=(0.0/n-(0.0*n_Vdbulk_di+0.0*n_Vgi_bi+phib*n_Vgi_bi_Vdbulk_di)/n/n+2*phib*n_Vgi_bi*n_Vdbulk_di/n/n/n);
  phib_n_Vgi_bi_Vsbulk_si=(0.0/n-(0.0*n_Vsbulk_si+0.0*n_Vgi_bi+phib*n_Vgi_bi_Vsbulk_si)/n/n+2*phib*n_Vgi_bi*n_Vsbulk_si/n/n/n);
  phib_n_Vgi_bi_Vgi_bi=(0.0/n-(0.0*n_Vgi_bi+0.0*n_Vgi_bi+phib*n_Vgi_bi_Vgi_bi)/n/n+2*phib*n_Vgi_bi*n_Vgi_bi/n/n/n);
  phib_n_Vgi_bi_Tempt_GND=(0.0/n-(0.0*n_Tempt_GND+phib_Tempt_GND*n_Vgi_bi+phib*n_Vgi_bi_Tempt_GND)/n/n+2*phib*n_Vgi_bi*n_Tempt_GND/n/n/n);
  phib_n_Vgi_bi_Vdi_bi=(0.0/n-(0.0*n_Vdi_bi+0.0*n_Vgi_bi+phib*n_Vgi_bi_Vdi_bi)/n/n+2*phib*n_Vgi_bi*n_Vdi_bi/n/n/n);
  phib_n_Vgi_bi_Vsi_bi=(0.0/n-(0.0*n_Vsi_bi+0.0*n_Vgi_bi+phib*n_Vgi_bi_Vsi_bi)/n/n+2*phib*n_Vgi_bi*n_Vsi_bi/n/n/n);
#endif
#if defined(_DERIVATE)
phib_n_Tempt_GND=((phib_Tempt_GND*n-phib*n_Tempt_GND)/n/n);
#endif
phib_n_Vdi_bi=(-phib*n_Vdi_bi/n/n);
#if defined(_DERIVATE2)
  phib_n_Vdi_bi_Vgm_si=(0.0/n-(0.0*n_Vgm_si+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vgm_si)/n/n+2*phib*n_Vdi_bi*n_Vgm_si/n/n/n);
  phib_n_Vdi_bi_Vdbulk_di=(0.0/n-(0.0*n_Vdbulk_di+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vdbulk_di)/n/n+2*phib*n_Vdi_bi*n_Vdbulk_di/n/n/n);
  phib_n_Vdi_bi_Vsbulk_si=(0.0/n-(0.0*n_Vsbulk_si+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vsbulk_si)/n/n+2*phib*n_Vdi_bi*n_Vsbulk_si/n/n/n);
  phib_n_Vdi_bi_Vgi_bi=(0.0/n-(0.0*n_Vgi_bi+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vgi_bi)/n/n+2*phib*n_Vdi_bi*n_Vgi_bi/n/n/n);
  phib_n_Vdi_bi_Tempt_GND=(0.0/n-(0.0*n_Tempt_GND+phib_Tempt_GND*n_Vdi_bi+phib*n_Vdi_bi_Tempt_GND)/n/n+2*phib*n_Vdi_bi*n_Tempt_GND/n/n/n);
  phib_n_Vdi_bi_Vdi_bi=(0.0/n-(0.0*n_Vdi_bi+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vdi_bi)/n/n+2*phib*n_Vdi_bi*n_Vdi_bi/n/n/n);
  phib_n_Vdi_bi_Vsi_bi=(0.0/n-(0.0*n_Vsi_bi+0.0*n_Vdi_bi+phib*n_Vdi_bi_Vsi_bi)/n/n+2*phib*n_Vdi_bi*n_Vsi_bi/n/n/n);
#endif
phib_n_Vsi_bi=(-phib*n_Vsi_bi/n/n);
#if defined(_DERIVATE2)
  phib_n_Vsi_bi_Vgm_si=(0.0/n-(0.0*n_Vgm_si+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vgm_si)/n/n+2*phib*n_Vsi_bi*n_Vgm_si/n/n/n);
  phib_n_Vsi_bi_Vdbulk_di=(0.0/n-(0.0*n_Vdbulk_di+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vdbulk_di)/n/n+2*phib*n_Vsi_bi*n_Vdbulk_di/n/n/n);
  phib_n_Vsi_bi_Vsbulk_si=(0.0/n-(0.0*n_Vsbulk_si+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vsbulk_si)/n/n+2*phib*n_Vsi_bi*n_Vsbulk_si/n/n/n);
  phib_n_Vsi_bi_Vgi_bi=(0.0/n-(0.0*n_Vgi_bi+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vgi_bi)/n/n+2*phib*n_Vsi_bi*n_Vgi_bi/n/n/n);
  phib_n_Vsi_bi_Tempt_GND=(0.0/n-(0.0*n_Tempt_GND+phib_Tempt_GND*n_Vsi_bi+phib*n_Vsi_bi_Tempt_GND)/n/n+2*phib*n_Vsi_bi*n_Tempt_GND/n/n/n);
  phib_n_Vsi_bi_Vdi_bi=(0.0/n-(0.0*n_Vdi_bi+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vdi_bi)/n/n+2*phib*n_Vsi_bi*n_Vdi_bi/n/n/n);
  phib_n_Vsi_bi_Vsi_bi=(0.0/n-(0.0*n_Vsi_bi+0.0*n_Vsi_bi+phib*n_Vsi_bi_Vsi_bi)/n/n+2*phib*n_Vsi_bi*n_Vsi_bi/n/n/n);
#endif
#endif
phib_n=(phib/n);
EXIT_IF_ISNAN((phib/n))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=0.0;
  T1_Vgm_si_Vgm_si=0.0;
  T1_Vgm_si_Vdbulk_di=0.0;
  T1_Vgm_si_Vsbulk_si=0.0;
  T1_Vgm_si_Vgi_bi=0.0;
  T1_Vgm_si_Vdi_bi=0.0;
  T1_Vgm_si_Vsi_bi=0.0;
  T1_Vgm_si_Tempt_GND=0.0;
#endif
T1_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=0.0;
  T1_Vdbulk_di_Vgm_si=0.0;
  T1_Vdbulk_di_Vdbulk_di=0.0;
  T1_Vdbulk_di_Vsbulk_si=0.0;
  T1_Vdbulk_di_Vgi_bi=0.0;
  T1_Vdbulk_di_Vdi_bi=0.0;
  T1_Vdbulk_di_Vsi_bi=0.0;
  T1_Vdbulk_di_Tempt_GND=0.0;
#endif
T1_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=0.0;
  T1_Vsbulk_si_Vgm_si=0.0;
  T1_Vsbulk_si_Vdbulk_di=0.0;
  T1_Vsbulk_si_Vsbulk_si=0.0;
  T1_Vsbulk_si_Vgi_bi=0.0;
  T1_Vsbulk_si_Vdi_bi=0.0;
  T1_Vsbulk_si_Vsi_bi=0.0;
  T1_Vsbulk_si_Tempt_GND=0.0;
#endif
T1_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=0.0;
  T1_Vgi_bi_Vgm_si=0.0;
  T1_Vgi_bi_Vdbulk_di=0.0;
  T1_Vgi_bi_Vsbulk_si=0.0;
  T1_Vgi_bi_Vgi_bi=0.0;
  T1_Vgi_bi_Vdi_bi=0.0;
  T1_Vgi_bi_Vsi_bi=0.0;
  T1_Vgi_bi_Tempt_GND=0.0;
#endif
T1_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=0.0;
  T1_Vdi_bi_Vgm_si=0.0;
  T1_Vdi_bi_Vdbulk_di=0.0;
  T1_Vdi_bi_Vsbulk_si=0.0;
  T1_Vdi_bi_Vgi_bi=0.0;
  T1_Vdi_bi_Vdi_bi=0.0;
  T1_Vdi_bi_Vsi_bi=0.0;
  T1_Vdi_bi_Tempt_GND=0.0;
#endif
T1_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=0.0;
  T1_Vsi_bi_Vgm_si=0.0;
  T1_Vsi_bi_Vdbulk_di=0.0;
  T1_Vsi_bi_Vsbulk_si=0.0;
  T1_Vsi_bi_Vgi_bi=0.0;
  T1_Vsi_bi_Vdi_bi=0.0;
  T1_Vsi_bi_Vsi_bi=0.0;
  T1_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=0.0;
#endif
#endif
T1=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
vgfbPD_Vgm_si=((vgfb_Vgm_si*T1-vgfb*T1_Vgm_si)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vgm_si_Vgm_si=(vgfb_Vgm_si_Vgm_si/T1-(vgfb_Vgm_si*T1_Vgm_si+vgfb_Vgm_si*T1_Vgm_si+vgfb*T1_Vgm_si_Vgm_si)/T1/T1+2*vgfb*T1_Vgm_si*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vgm_si_Vgm_di=(vgfb_Vgm_si_Vgm_di/T1-(vgfb_Vgm_si*T1_Vgm_di+vgfb_Vgm_di*T1_Vgm_si+vgfb*T1_Vgm_si_Vgm_di)/T1/T1+2*vgfb*T1_Vgm_si*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vgm_si_Vdbulk_di=(vgfb_Vgm_si_Vdbulk_di/T1-(vgfb_Vgm_si*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vgm_si+vgfb*T1_Vgm_si_Vdbulk_di)/T1/T1+2*vgfb*T1_Vgm_si*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vgm_si_Vsbulk_si=(vgfb_Vgm_si_Vsbulk_si/T1-(vgfb_Vgm_si*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vgm_si+vgfb*T1_Vgm_si_Vsbulk_si)/T1/T1+2*vgfb*T1_Vgm_si*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vgm_si_Vgi_bi=(vgfb_Vgm_si_Vgi_bi/T1-(vgfb_Vgm_si*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vgm_si+vgfb*T1_Vgm_si_Vgi_bi)/T1/T1+2*vgfb*T1_Vgm_si*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vgm_si_Vdi_bi=(vgfb_Vgm_si_Vdi_bi/T1-(vgfb_Vgm_si*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vgm_si+vgfb*T1_Vgm_si_Vdi_bi)/T1/T1+2*vgfb*T1_Vgm_si*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vgm_si_Vsi_bi=(vgfb_Vgm_si_Vsi_bi/T1-(vgfb_Vgm_si*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vgm_si+vgfb*T1_Vgm_si_Vsi_bi)/T1/T1+2*vgfb*T1_Vgm_si*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vgm_si_Tempt_GND=(vgfb_Vgm_si_Tempt_GND/T1-(vgfb_Vgm_si*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vgm_si+vgfb*T1_Vgm_si_Tempt_GND)/T1/T1+2*vgfb*T1_Vgm_si*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vgm_di=((vgfb_Vgm_di*T1-vgfb*T1_Vgm_di)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vgm_di_Vgm_si=(vgfb_Vgm_di_Vgm_si/T1-(vgfb_Vgm_di*T1_Vgm_si+vgfb_Vgm_si*T1_Vgm_di+vgfb*T1_Vgm_di_Vgm_si)/T1/T1+2*vgfb*T1_Vgm_di*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vgm_di_Vgm_di=(vgfb_Vgm_di_Vgm_di/T1-(vgfb_Vgm_di*T1_Vgm_di+vgfb_Vgm_di*T1_Vgm_di+vgfb*T1_Vgm_di_Vgm_di)/T1/T1+2*vgfb*T1_Vgm_di*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vgm_di_Vdbulk_di=(vgfb_Vgm_di_Vdbulk_di/T1-(vgfb_Vgm_di*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vgm_di+vgfb*T1_Vgm_di_Vdbulk_di)/T1/T1+2*vgfb*T1_Vgm_di*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vgm_di_Vsbulk_si=(vgfb_Vgm_di_Vsbulk_si/T1-(vgfb_Vgm_di*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vgm_di+vgfb*T1_Vgm_di_Vsbulk_si)/T1/T1+2*vgfb*T1_Vgm_di*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vgm_di_Vgi_bi=(vgfb_Vgm_di_Vgi_bi/T1-(vgfb_Vgm_di*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vgm_di+vgfb*T1_Vgm_di_Vgi_bi)/T1/T1+2*vgfb*T1_Vgm_di*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vgm_di_Vdi_bi=(vgfb_Vgm_di_Vdi_bi/T1-(vgfb_Vgm_di*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vgm_di+vgfb*T1_Vgm_di_Vdi_bi)/T1/T1+2*vgfb*T1_Vgm_di*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vgm_di_Vsi_bi=(vgfb_Vgm_di_Vsi_bi/T1-(vgfb_Vgm_di*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vgm_di+vgfb*T1_Vgm_di_Vsi_bi)/T1/T1+2*vgfb*T1_Vgm_di*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vgm_di_Tempt_GND=(vgfb_Vgm_di_Tempt_GND/T1-(vgfb_Vgm_di*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vgm_di+vgfb*T1_Vgm_di_Tempt_GND)/T1/T1+2*vgfb*T1_Vgm_di*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vdbulk_di=((vgfb_Vdbulk_di*T1-vgfb*T1_Vdbulk_di)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vdbulk_di_Vgm_si=(vgfb_Vdbulk_di_Vgm_si/T1-(vgfb_Vdbulk_di*T1_Vgm_si+vgfb_Vgm_si*T1_Vdbulk_di+vgfb*T1_Vdbulk_di_Vgm_si)/T1/T1+2*vgfb*T1_Vdbulk_di*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vgm_di=(vgfb_Vdbulk_di_Vgm_di/T1-(vgfb_Vdbulk_di*T1_Vgm_di+vgfb_Vgm_di*T1_Vdbulk_di+vgfb*T1_Vdbulk_di_Vgm_di)/T1/T1+2*vgfb*T1_Vdbulk_di*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vdbulk_di=(vgfb_Vdbulk_di_Vdbulk_di/T1-(vgfb_Vdbulk_di*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vdbulk_di+vgfb*T1_Vdbulk_di_Vdbulk_di)/T1/T1+2*vgfb*T1_Vdbulk_di*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vsbulk_si=(vgfb_Vdbulk_di_Vsbulk_si/T1-(vgfb_Vdbulk_di*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vdbulk_di+vgfb*T1_Vdbulk_di_Vsbulk_si)/T1/T1+2*vgfb*T1_Vdbulk_di*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vgi_bi=(vgfb_Vdbulk_di_Vgi_bi/T1-(vgfb_Vdbulk_di*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vdbulk_di+vgfb*T1_Vdbulk_di_Vgi_bi)/T1/T1+2*vgfb*T1_Vdbulk_di*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vdi_bi=(vgfb_Vdbulk_di_Vdi_bi/T1-(vgfb_Vdbulk_di*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vdbulk_di+vgfb*T1_Vdbulk_di_Vdi_bi)/T1/T1+2*vgfb*T1_Vdbulk_di*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vdbulk_di_Vsi_bi=(vgfb_Vdbulk_di_Vsi_bi/T1-(vgfb_Vdbulk_di*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vdbulk_di+vgfb*T1_Vdbulk_di_Vsi_bi)/T1/T1+2*vgfb*T1_Vdbulk_di*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vdbulk_di_Tempt_GND=(vgfb_Vdbulk_di_Tempt_GND/T1-(vgfb_Vdbulk_di*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vdbulk_di+vgfb*T1_Vdbulk_di_Tempt_GND)/T1/T1+2*vgfb*T1_Vdbulk_di*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vsbulk_si=((vgfb_Vsbulk_si*T1-vgfb*T1_Vsbulk_si)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vsbulk_si_Vgm_si=(vgfb_Vsbulk_si_Vgm_si/T1-(vgfb_Vsbulk_si*T1_Vgm_si+vgfb_Vgm_si*T1_Vsbulk_si+vgfb*T1_Vsbulk_si_Vgm_si)/T1/T1+2*vgfb*T1_Vsbulk_si*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vgm_di=(vgfb_Vsbulk_si_Vgm_di/T1-(vgfb_Vsbulk_si*T1_Vgm_di+vgfb_Vgm_di*T1_Vsbulk_si+vgfb*T1_Vsbulk_si_Vgm_di)/T1/T1+2*vgfb*T1_Vsbulk_si*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vdbulk_di=(vgfb_Vsbulk_si_Vdbulk_di/T1-(vgfb_Vsbulk_si*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vsbulk_si+vgfb*T1_Vsbulk_si_Vdbulk_di)/T1/T1+2*vgfb*T1_Vsbulk_si*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vsbulk_si=(vgfb_Vsbulk_si_Vsbulk_si/T1-(vgfb_Vsbulk_si*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vsbulk_si+vgfb*T1_Vsbulk_si_Vsbulk_si)/T1/T1+2*vgfb*T1_Vsbulk_si*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vgi_bi=(vgfb_Vsbulk_si_Vgi_bi/T1-(vgfb_Vsbulk_si*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vsbulk_si+vgfb*T1_Vsbulk_si_Vgi_bi)/T1/T1+2*vgfb*T1_Vsbulk_si*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vdi_bi=(vgfb_Vsbulk_si_Vdi_bi/T1-(vgfb_Vsbulk_si*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vsbulk_si+vgfb*T1_Vsbulk_si_Vdi_bi)/T1/T1+2*vgfb*T1_Vsbulk_si*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vsbulk_si_Vsi_bi=(vgfb_Vsbulk_si_Vsi_bi/T1-(vgfb_Vsbulk_si*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vsbulk_si+vgfb*T1_Vsbulk_si_Vsi_bi)/T1/T1+2*vgfb*T1_Vsbulk_si*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vsbulk_si_Tempt_GND=(vgfb_Vsbulk_si_Tempt_GND/T1-(vgfb_Vsbulk_si*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vsbulk_si+vgfb*T1_Vsbulk_si_Tempt_GND)/T1/T1+2*vgfb*T1_Vsbulk_si*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vgi_bi=((vgfb_Vgi_bi*T1-vgfb*T1_Vgi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vgi_bi_Vgm_si=(vgfb_Vgi_bi_Vgm_si/T1-(vgfb_Vgi_bi*T1_Vgm_si+vgfb_Vgm_si*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vgm_si)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vgi_bi_Vgm_di=(vgfb_Vgi_bi_Vgm_di/T1-(vgfb_Vgi_bi*T1_Vgm_di+vgfb_Vgm_di*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vgm_di)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vgi_bi_Vdbulk_di=(vgfb_Vgi_bi_Vdbulk_di/T1-(vgfb_Vgi_bi*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vgi_bi_Vsbulk_si=(vgfb_Vgi_bi_Vsbulk_si/T1-(vgfb_Vgi_bi*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vgi_bi_Vgi_bi=(vgfb_Vgi_bi_Vgi_bi/T1-(vgfb_Vgi_bi*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vgi_bi)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Vdi_bi=(vgfb_Vgi_bi_Vdi_bi/T1-(vgfb_Vgi_bi*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vdi_bi)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Vsi_bi=(vgfb_Vgi_bi_Vsi_bi/T1-(vgfb_Vgi_bi*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vgi_bi+vgfb*T1_Vgi_bi_Vsi_bi)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vgi_bi_Tempt_GND=(vgfb_Vgi_bi_Tempt_GND/T1-(vgfb_Vgi_bi*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vgi_bi+vgfb*T1_Vgi_bi_Tempt_GND)/T1/T1+2*vgfb*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vdi_bi=((vgfb_Vdi_bi*T1-vgfb*T1_Vdi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vdi_bi_Vgm_si=(vgfb_Vdi_bi_Vgm_si/T1-(vgfb_Vdi_bi*T1_Vgm_si+vgfb_Vgm_si*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vgm_si)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vdi_bi_Vgm_di=(vgfb_Vdi_bi_Vgm_di/T1-(vgfb_Vdi_bi*T1_Vgm_di+vgfb_Vgm_di*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vgm_di)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vdi_bi_Vdbulk_di=(vgfb_Vdi_bi_Vdbulk_di/T1-(vgfb_Vdi_bi*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vdi_bi_Vsbulk_si=(vgfb_Vdi_bi_Vsbulk_si/T1-(vgfb_Vdi_bi*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vdi_bi_Vgi_bi=(vgfb_Vdi_bi_Vgi_bi/T1-(vgfb_Vdi_bi*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vgi_bi)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Vdi_bi=(vgfb_Vdi_bi_Vdi_bi/T1-(vgfb_Vdi_bi*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vdi_bi)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Vsi_bi=(vgfb_Vdi_bi_Vsi_bi/T1-(vgfb_Vdi_bi*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vdi_bi+vgfb*T1_Vdi_bi_Vsi_bi)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vdi_bi_Tempt_GND=(vgfb_Vdi_bi_Tempt_GND/T1-(vgfb_Vdi_bi*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vdi_bi+vgfb*T1_Vdi_bi_Tempt_GND)/T1/T1+2*vgfb*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
vgfbPD_Vsi_bi=((vgfb_Vsi_bi*T1-vgfb*T1_Vsi_bi)/T1/T1);
#if defined(_DERIVATE2)
  vgfbPD_Vsi_bi_Vgm_si=(vgfb_Vsi_bi_Vgm_si/T1-(vgfb_Vsi_bi*T1_Vgm_si+vgfb_Vgm_si*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vgm_si)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1);
  vgfbPD_Vsi_bi_Vgm_di=(vgfb_Vsi_bi_Vgm_di/T1-(vgfb_Vsi_bi*T1_Vgm_di+vgfb_Vgm_di*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vgm_di)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vgm_di/T1/T1/T1);
  vgfbPD_Vsi_bi_Vdbulk_di=(vgfb_Vsi_bi_Vdbulk_di/T1-(vgfb_Vsi_bi*T1_Vdbulk_di+vgfb_Vdbulk_di*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1);
  vgfbPD_Vsi_bi_Vsbulk_si=(vgfb_Vsi_bi_Vsbulk_si/T1-(vgfb_Vsi_bi*T1_Vsbulk_si+vgfb_Vsbulk_si*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1);
  vgfbPD_Vsi_bi_Vgi_bi=(vgfb_Vsi_bi_Vgi_bi/T1-(vgfb_Vsi_bi*T1_Vgi_bi+vgfb_Vgi_bi*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vgi_bi)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Vdi_bi=(vgfb_Vsi_bi_Vdi_bi/T1-(vgfb_Vsi_bi*T1_Vdi_bi+vgfb_Vdi_bi*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vdi_bi)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Vsi_bi=(vgfb_Vsi_bi_Vsi_bi/T1-(vgfb_Vsi_bi*T1_Vsi_bi+vgfb_Vsi_bi*T1_Vsi_bi+vgfb*T1_Vsi_bi_Vsi_bi)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1);
  vgfbPD_Vsi_bi_Tempt_GND=(vgfb_Vsi_bi_Tempt_GND/T1-(vgfb_Vsi_bi*T1_Tempt_GND+vgfb_Tempt_GND*T1_Vsi_bi+vgfb*T1_Vsi_bi_Tempt_GND)/T1/T1+2*vgfb*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
#if defined(_DERIVATE)
vgfbPD_Tempt_GND=((vgfb_Tempt_GND*T1-vgfb*T1_Tempt_GND)/T1/T1);
#endif
#endif
vgfbPD=(vgfb/T1);
EXIT_IF_ISNAN((vgfb/T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
gammaPD_Vgm_si=((gam_Vgm_si*T1-gam*T1_Vgm_si)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vgm_si_Vgm_si=(gam_Vgm_si_Vgm_si/T1-(gam_Vgm_si*T1_Vgm_si+gam_Vgm_si*T1_Vgm_si+gam*T1_Vgm_si_Vgm_si)/T1/T1+2*gam*T1_Vgm_si*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vgm_si_Vdbulk_di=(gam_Vgm_si_Vdbulk_di/T1-(gam_Vgm_si*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vgm_si+gam*T1_Vgm_si_Vdbulk_di)/T1/T1+2*gam*T1_Vgm_si*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vgm_si_Vsbulk_si=(gam_Vgm_si_Vsbulk_si/T1-(gam_Vgm_si*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vgm_si+gam*T1_Vgm_si_Vsbulk_si)/T1/T1+2*gam*T1_Vgm_si*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vgm_si_Vgi_bi=(gam_Vgm_si_Vgi_bi/T1-(gam_Vgm_si*T1_Vgi_bi+gam_Vgi_bi*T1_Vgm_si+gam*T1_Vgm_si_Vgi_bi)/T1/T1+2*gam*T1_Vgm_si*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vgm_si_Vdi_bi=(gam_Vgm_si_Vdi_bi/T1-(gam_Vgm_si*T1_Vdi_bi+gam_Vdi_bi*T1_Vgm_si+gam*T1_Vgm_si_Vdi_bi)/T1/T1+2*gam*T1_Vgm_si*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vgm_si_Vsi_bi=(gam_Vgm_si_Vsi_bi/T1-(gam_Vgm_si*T1_Vsi_bi+gam_Vsi_bi*T1_Vgm_si+gam*T1_Vgm_si_Vsi_bi)/T1/T1+2*gam*T1_Vgm_si*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vgm_si_Tempt_GND=(gam_Vgm_si_Tempt_GND/T1-(gam_Vgm_si*T1_Tempt_GND+gam_Tempt_GND*T1_Vgm_si+gam*T1_Vgm_si_Tempt_GND)/T1/T1+2*gam*T1_Vgm_si*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vdbulk_di=((gam_Vdbulk_di*T1-gam*T1_Vdbulk_di)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vdbulk_di_Vgm_si=(gam_Vdbulk_di_Vgm_si/T1-(gam_Vdbulk_di*T1_Vgm_si+gam_Vgm_si*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vgm_si)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vdbulk_di_Vdbulk_di=(gam_Vdbulk_di_Vdbulk_di/T1-(gam_Vdbulk_di*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vdbulk_di)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vdbulk_di_Vsbulk_si=(gam_Vdbulk_di_Vsbulk_si/T1-(gam_Vdbulk_di*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vsbulk_si)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vdbulk_di_Vgi_bi=(gam_Vdbulk_di_Vgi_bi/T1-(gam_Vdbulk_di*T1_Vgi_bi+gam_Vgi_bi*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vgi_bi)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vdbulk_di_Vdi_bi=(gam_Vdbulk_di_Vdi_bi/T1-(gam_Vdbulk_di*T1_Vdi_bi+gam_Vdi_bi*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vdi_bi)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vdbulk_di_Vsi_bi=(gam_Vdbulk_di_Vsi_bi/T1-(gam_Vdbulk_di*T1_Vsi_bi+gam_Vsi_bi*T1_Vdbulk_di+gam*T1_Vdbulk_di_Vsi_bi)/T1/T1+2*gam*T1_Vdbulk_di*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vdbulk_di_Tempt_GND=(gam_Vdbulk_di_Tempt_GND/T1-(gam_Vdbulk_di*T1_Tempt_GND+gam_Tempt_GND*T1_Vdbulk_di+gam*T1_Vdbulk_di_Tempt_GND)/T1/T1+2*gam*T1_Vdbulk_di*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vsbulk_si=((gam_Vsbulk_si*T1-gam*T1_Vsbulk_si)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vsbulk_si_Vgm_si=(gam_Vsbulk_si_Vgm_si/T1-(gam_Vsbulk_si*T1_Vgm_si+gam_Vgm_si*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vgm_si)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vsbulk_si_Vdbulk_di=(gam_Vsbulk_si_Vdbulk_di/T1-(gam_Vsbulk_si*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vdbulk_di)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vsbulk_si_Vsbulk_si=(gam_Vsbulk_si_Vsbulk_si/T1-(gam_Vsbulk_si*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vsbulk_si)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vsbulk_si_Vgi_bi=(gam_Vsbulk_si_Vgi_bi/T1-(gam_Vsbulk_si*T1_Vgi_bi+gam_Vgi_bi*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vgi_bi)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vsbulk_si_Vdi_bi=(gam_Vsbulk_si_Vdi_bi/T1-(gam_Vsbulk_si*T1_Vdi_bi+gam_Vdi_bi*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vdi_bi)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vsbulk_si_Vsi_bi=(gam_Vsbulk_si_Vsi_bi/T1-(gam_Vsbulk_si*T1_Vsi_bi+gam_Vsi_bi*T1_Vsbulk_si+gam*T1_Vsbulk_si_Vsi_bi)/T1/T1+2*gam*T1_Vsbulk_si*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vsbulk_si_Tempt_GND=(gam_Vsbulk_si_Tempt_GND/T1-(gam_Vsbulk_si*T1_Tempt_GND+gam_Tempt_GND*T1_Vsbulk_si+gam*T1_Vsbulk_si_Tempt_GND)/T1/T1+2*gam*T1_Vsbulk_si*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vgi_bi=((gam_Vgi_bi*T1-gam*T1_Vgi_bi)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vgi_bi_Vgm_si=(gam_Vgi_bi_Vgm_si/T1-(gam_Vgi_bi*T1_Vgm_si+gam_Vgm_si*T1_Vgi_bi+gam*T1_Vgi_bi_Vgm_si)/T1/T1+2*gam*T1_Vgi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vgi_bi_Vdbulk_di=(gam_Vgi_bi_Vdbulk_di/T1-(gam_Vgi_bi*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vgi_bi+gam*T1_Vgi_bi_Vdbulk_di)/T1/T1+2*gam*T1_Vgi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vgi_bi_Vsbulk_si=(gam_Vgi_bi_Vsbulk_si/T1-(gam_Vgi_bi*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vgi_bi+gam*T1_Vgi_bi_Vsbulk_si)/T1/T1+2*gam*T1_Vgi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vgi_bi_Vgi_bi=(gam_Vgi_bi_Vgi_bi/T1-(gam_Vgi_bi*T1_Vgi_bi+gam_Vgi_bi*T1_Vgi_bi+gam*T1_Vgi_bi_Vgi_bi)/T1/T1+2*gam*T1_Vgi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vgi_bi_Vdi_bi=(gam_Vgi_bi_Vdi_bi/T1-(gam_Vgi_bi*T1_Vdi_bi+gam_Vdi_bi*T1_Vgi_bi+gam*T1_Vgi_bi_Vdi_bi)/T1/T1+2*gam*T1_Vgi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vgi_bi_Vsi_bi=(gam_Vgi_bi_Vsi_bi/T1-(gam_Vgi_bi*T1_Vsi_bi+gam_Vsi_bi*T1_Vgi_bi+gam*T1_Vgi_bi_Vsi_bi)/T1/T1+2*gam*T1_Vgi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vgi_bi_Tempt_GND=(gam_Vgi_bi_Tempt_GND/T1-(gam_Vgi_bi*T1_Tempt_GND+gam_Tempt_GND*T1_Vgi_bi+gam*T1_Vgi_bi_Tempt_GND)/T1/T1+2*gam*T1_Vgi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vdi_bi=((gam_Vdi_bi*T1-gam*T1_Vdi_bi)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vdi_bi_Vgm_si=(gam_Vdi_bi_Vgm_si/T1-(gam_Vdi_bi*T1_Vgm_si+gam_Vgm_si*T1_Vdi_bi+gam*T1_Vdi_bi_Vgm_si)/T1/T1+2*gam*T1_Vdi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vdi_bi_Vdbulk_di=(gam_Vdi_bi_Vdbulk_di/T1-(gam_Vdi_bi*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vdi_bi+gam*T1_Vdi_bi_Vdbulk_di)/T1/T1+2*gam*T1_Vdi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vdi_bi_Vsbulk_si=(gam_Vdi_bi_Vsbulk_si/T1-(gam_Vdi_bi*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vdi_bi+gam*T1_Vdi_bi_Vsbulk_si)/T1/T1+2*gam*T1_Vdi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vdi_bi_Vgi_bi=(gam_Vdi_bi_Vgi_bi/T1-(gam_Vdi_bi*T1_Vgi_bi+gam_Vgi_bi*T1_Vdi_bi+gam*T1_Vdi_bi_Vgi_bi)/T1/T1+2*gam*T1_Vdi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Vdi_bi=(gam_Vdi_bi_Vdi_bi/T1-(gam_Vdi_bi*T1_Vdi_bi+gam_Vdi_bi*T1_Vdi_bi+gam*T1_Vdi_bi_Vdi_bi)/T1/T1+2*gam*T1_Vdi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Vsi_bi=(gam_Vdi_bi_Vsi_bi/T1-(gam_Vdi_bi*T1_Vsi_bi+gam_Vsi_bi*T1_Vdi_bi+gam*T1_Vdi_bi_Vsi_bi)/T1/T1+2*gam*T1_Vdi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vdi_bi_Tempt_GND=(gam_Vdi_bi_Tempt_GND/T1-(gam_Vdi_bi*T1_Tempt_GND+gam_Tempt_GND*T1_Vdi_bi+gam*T1_Vdi_bi_Tempt_GND)/T1/T1+2*gam*T1_Vdi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
gammaPD_Vsi_bi=((gam_Vsi_bi*T1-gam*T1_Vsi_bi)/T1/T1);
#if defined(_DERIVATE2)
  gammaPD_Vsi_bi_Vgm_si=(gam_Vsi_bi_Vgm_si/T1-(gam_Vsi_bi*T1_Vgm_si+gam_Vgm_si*T1_Vsi_bi+gam*T1_Vsi_bi_Vgm_si)/T1/T1+2*gam*T1_Vsi_bi*T1_Vgm_si/T1/T1/T1);
  gammaPD_Vsi_bi_Vdbulk_di=(gam_Vsi_bi_Vdbulk_di/T1-(gam_Vsi_bi*T1_Vdbulk_di+gam_Vdbulk_di*T1_Vsi_bi+gam*T1_Vsi_bi_Vdbulk_di)/T1/T1+2*gam*T1_Vsi_bi*T1_Vdbulk_di/T1/T1/T1);
  gammaPD_Vsi_bi_Vsbulk_si=(gam_Vsi_bi_Vsbulk_si/T1-(gam_Vsi_bi*T1_Vsbulk_si+gam_Vsbulk_si*T1_Vsi_bi+gam*T1_Vsi_bi_Vsbulk_si)/T1/T1+2*gam*T1_Vsi_bi*T1_Vsbulk_si/T1/T1/T1);
  gammaPD_Vsi_bi_Vgi_bi=(gam_Vsi_bi_Vgi_bi/T1-(gam_Vsi_bi*T1_Vgi_bi+gam_Vgi_bi*T1_Vsi_bi+gam*T1_Vsi_bi_Vgi_bi)/T1/T1+2*gam*T1_Vsi_bi*T1_Vgi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Vdi_bi=(gam_Vsi_bi_Vdi_bi/T1-(gam_Vsi_bi*T1_Vdi_bi+gam_Vdi_bi*T1_Vsi_bi+gam*T1_Vsi_bi_Vdi_bi)/T1/T1+2*gam*T1_Vsi_bi*T1_Vdi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Vsi_bi=(gam_Vsi_bi_Vsi_bi/T1-(gam_Vsi_bi*T1_Vsi_bi+gam_Vsi_bi*T1_Vsi_bi+gam*T1_Vsi_bi_Vsi_bi)/T1/T1+2*gam*T1_Vsi_bi*T1_Vsi_bi/T1/T1/T1);
  gammaPD_Vsi_bi_Tempt_GND=(gam_Vsi_bi_Tempt_GND/T1-(gam_Vsi_bi*T1_Tempt_GND+gam_Tempt_GND*T1_Vsi_bi+gam*T1_Vsi_bi_Tempt_GND)/T1/T1+2*gam*T1_Vsi_bi*T1_Tempt_GND/T1/T1/T1);
#endif
#if defined(_DERIVATE)
gammaPD_Tempt_GND=((gam_Tempt_GND*T1-gam*T1_Tempt_GND)/T1/T1);
#endif
#endif
gammaPD=(gam/T1);
EXIT_IF_ISNAN((gam/T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=(0.5*vgfbPD_Vgm_di);
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgm_di+0.5*vgfbPD_Vgm_di_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*0.0+3.0*(+0.0+(0.0/1.41421356237309504880-(0.0*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_di_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgm_di+0.5*vgfbPD_Vgm_di_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*0.0+3.0*(+0.0+(0.0/1.41421356237309504880-(0.0*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_di_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgm_di+0.5*vgfbPD_Vgm_di_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*0.0+3.0*(+0.0+(0.0/1.41421356237309504880-(0.0*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_di_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgm_di+0.5*vgfbPD_Vgm_di_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*0.0+3.0*(+0.0+(0.0/1.41421356237309504880-(0.0*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_di_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgm_di+0.5*vgfbPD_Vgm_di_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*0.0+3.0*(+0.0+(0.0/1.41421356237309504880-(0.0*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_di_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgm_di+0.5*vgfbPD_Vgm_di_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*0.0+3.0*(+0.0+(0.0/1.41421356237309504880-(0.0*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_di_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgm_di+0.5*vgfbPD_Vgm_di_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*0.0+3.0*(+0.0+(0.0/1.41421356237309504880-(0.0*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_di_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgm_di+0.5*vgfbPD_Vgm_di_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*0.0+3.0*(+0.0+(0.0/1.41421356237309504880-(0.0*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vgm_si=((0.5*vgfbPD_Vgm_si)-(3.0*(gammaPD_Vgm_si/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgm_si+0.5*vgfbPD_Vgm_si_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vgm_si*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_si_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgm_si+0.5*vgfbPD_Vgm_si_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgm_si_Vgm_si/1.41421356237309504880-(gammaPD_Vgm_si*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_si_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgm_si+0.5*vgfbPD_Vgm_si_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgm_si_Vdbulk_di/1.41421356237309504880-(gammaPD_Vgm_si*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_si_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgm_si+0.5*vgfbPD_Vgm_si_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgm_si_Vsbulk_si/1.41421356237309504880-(gammaPD_Vgm_si*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_si_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgm_si+0.5*vgfbPD_Vgm_si_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgm_si_Vgi_bi/1.41421356237309504880-(gammaPD_Vgm_si*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_si_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgm_si+0.5*vgfbPD_Vgm_si_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgm_si_Vdi_bi/1.41421356237309504880-(gammaPD_Vgm_si*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_si_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgm_si+0.5*vgfbPD_Vgm_si_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgm_si_Vsi_bi/1.41421356237309504880-(gammaPD_Vgm_si*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgm_si_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgm_si+0.5*vgfbPD_Vgm_si_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgm_si_Tempt_GND/1.41421356237309504880-(gammaPD_Vgm_si*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vdbulk_di=((0.5*vgfbPD_Vdbulk_di)-(3.0*(gammaPD_Vdbulk_di/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vgm_si/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vdbulk_di/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vsbulk_si/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vgi_bi/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vdi_bi/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Vsi_bi/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdbulk_di_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdbulk_di+0.5*vgfbPD_Vdbulk_di_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdbulk_di_Tempt_GND/1.41421356237309504880-(gammaPD_Vdbulk_di*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vsbulk_si=((0.5*vgfbPD_Vsbulk_si)-(3.0*(gammaPD_Vsbulk_si/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vgm_si/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vdbulk_di/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vsbulk_si/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vgi_bi/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vdi_bi/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Vsi_bi/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsbulk_si_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsbulk_si+0.5*vgfbPD_Vsbulk_si_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsbulk_si_Tempt_GND/1.41421356237309504880-(gammaPD_Vsbulk_si*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vgi_bi=((0.5*vgfbPD_Vgi_bi)-(3.0*(gammaPD_Vgi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vgi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgi_bi+0.5*vgfbPD_Vgi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vgi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vgi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vdi_bi=((0.5*vgfbPD_Vdi_bi)-(3.0*(gammaPD_Vdi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vdi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdi_bi+0.5*vgfbPD_Vdi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vdi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vdi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
T1_Vsi_bi=((0.5*vgfbPD_Vsi_bi)-(3.0*(gammaPD_Vsi_bi/1.41421356237309504880)));
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgm_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*0.0+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(0.0/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+0.0*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vgm_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgm_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgm_si/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vgm_si/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vgm_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vdbulk_di=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vdbulk_di)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdbulk_di/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vdbulk_di/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vdbulk_di*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vsbulk_si=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vsbulk_si)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsbulk_si/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vsbulk_si/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vsbulk_si*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vgi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vgi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vgi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vgi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vgi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vdi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vdi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vdi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vdi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vdi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Vsi_bi=(+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Vsi_bi)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Vsi_bi/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Vsi_bi*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
  T1_Vsi_bi_Tempt_GND=(+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsi_bi+0.5*vgfbPD_Vsi_bi_Tempt_GND)-(+0.0*(1.0+(gammaPD/1.41421356237309504880))+0.0*(gammaPD_Tempt_GND/1.41421356237309504880)+0.0*(gammaPD_Vsi_bi/1.41421356237309504880)+3.0*(+0.0+(gammaPD_Vsi_bi_Tempt_GND/1.41421356237309504880-(gammaPD_Vsi_bi*0.0+gammaPD_Tempt_GND*0.0+gammaPD*0.0)/1.41421356237309504880/1.41421356237309504880+2*gammaPD*0.0*0.0/1.41421356237309504880/1.41421356237309504880/1.41421356237309504880))));
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((0.5*vgfbPD_Tempt_GND)-(3.0*(gammaPD_Tempt_GND/1.41421356237309504880)));
#endif
#endif
T1=((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
EXIT_IF_ISNAN(((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880)))))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+(6.0*vgfbPD)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+(6.0*vgfbPD)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=(T1_Vgm_di+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))+(6.0*vgfbPD_Vgm_di))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=(+T1_Vgm_di_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))+(6.0*vgfbPD_Vgm_di))+d10_sqrt0*(+(+T1_Vgm_di_Vgm_di*T1+T1_Vgm_di*T1_Vgm_di+T1_Vgm_di*T1_Vgm_di+T1*T1_Vgm_di_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgm_di+6.0*vgfbPD_Vgm_di_Vgm_di))));
  T2_Vgm_di_Vgm_si=(+T1_Vgm_di_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))+(6.0*vgfbPD_Vgm_di))+d10_sqrt0*(+(+T1_Vgm_di_Vgm_si*T1+T1_Vgm_di*T1_Vgm_si+T1_Vgm_si*T1_Vgm_di+T1*T1_Vgm_di_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgm_di+6.0*vgfbPD_Vgm_di_Vgm_si))));
  T2_Vgm_di_Vdbulk_di=(+T1_Vgm_di_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))+(6.0*vgfbPD_Vgm_di))+d10_sqrt0*(+(+T1_Vgm_di_Vdbulk_di*T1+T1_Vgm_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgm_di+T1*T1_Vgm_di_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgm_di+6.0*vgfbPD_Vgm_di_Vdbulk_di))));
  T2_Vgm_di_Vsbulk_si=(+T1_Vgm_di_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))+(6.0*vgfbPD_Vgm_di))+d10_sqrt0*(+(+T1_Vgm_di_Vsbulk_si*T1+T1_Vgm_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgm_di+T1*T1_Vgm_di_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgm_di+6.0*vgfbPD_Vgm_di_Vsbulk_si))));
  T2_Vgm_di_Vgi_bi=(+T1_Vgm_di_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))+(6.0*vgfbPD_Vgm_di))+d10_sqrt0*(+(+T1_Vgm_di_Vgi_bi*T1+T1_Vgm_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vgm_di+T1*T1_Vgm_di_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgm_di+6.0*vgfbPD_Vgm_di_Vgi_bi))));
  T2_Vgm_di_Vdi_bi=(+T1_Vgm_di_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))+(6.0*vgfbPD_Vgm_di))+d10_sqrt0*(+(+T1_Vgm_di_Vdi_bi*T1+T1_Vgm_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vgm_di+T1*T1_Vgm_di_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgm_di+6.0*vgfbPD_Vgm_di_Vdi_bi))));
  T2_Vgm_di_Vsi_bi=(+T1_Vgm_di_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))+(6.0*vgfbPD_Vgm_di))+d10_sqrt0*(+(+T1_Vgm_di_Vsi_bi*T1+T1_Vgm_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vgm_di+T1*T1_Vgm_di_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgm_di+6.0*vgfbPD_Vgm_di_Vsi_bi))));
  T2_Vgm_di_Tempt_GND=(+T1_Vgm_di_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))+(6.0*vgfbPD_Vgm_di))+d10_sqrt0*(+(+T1_Vgm_di_Tempt_GND*T1+T1_Vgm_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vgm_di+T1*T1_Vgm_di_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgm_di+6.0*vgfbPD_Vgm_di_Tempt_GND))));
#endif
T2_Vgm_si=(T1_Vgm_si+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))+(6.0*vgfbPD_Vgm_si))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=(+T1_Vgm_si_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))+(6.0*vgfbPD_Vgm_si))+d10_sqrt0*(+(+T1_Vgm_si_Vgm_di*T1+T1_Vgm_si*T1_Vgm_di+T1_Vgm_di*T1_Vgm_si+T1*T1_Vgm_si_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgm_si+6.0*vgfbPD_Vgm_si_Vgm_di))));
  T2_Vgm_si_Vgm_si=(+T1_Vgm_si_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))+(6.0*vgfbPD_Vgm_si))+d10_sqrt0*(+(+T1_Vgm_si_Vgm_si*T1+T1_Vgm_si*T1_Vgm_si+T1_Vgm_si*T1_Vgm_si+T1*T1_Vgm_si_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgm_si+6.0*vgfbPD_Vgm_si_Vgm_si))));
  T2_Vgm_si_Vdbulk_di=(+T1_Vgm_si_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))+(6.0*vgfbPD_Vgm_si))+d10_sqrt0*(+(+T1_Vgm_si_Vdbulk_di*T1+T1_Vgm_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgm_si+T1*T1_Vgm_si_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgm_si+6.0*vgfbPD_Vgm_si_Vdbulk_di))));
  T2_Vgm_si_Vsbulk_si=(+T1_Vgm_si_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))+(6.0*vgfbPD_Vgm_si))+d10_sqrt0*(+(+T1_Vgm_si_Vsbulk_si*T1+T1_Vgm_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgm_si+T1*T1_Vgm_si_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgm_si+6.0*vgfbPD_Vgm_si_Vsbulk_si))));
  T2_Vgm_si_Vgi_bi=(+T1_Vgm_si_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))+(6.0*vgfbPD_Vgm_si))+d10_sqrt0*(+(+T1_Vgm_si_Vgi_bi*T1+T1_Vgm_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vgm_si+T1*T1_Vgm_si_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgm_si+6.0*vgfbPD_Vgm_si_Vgi_bi))));
  T2_Vgm_si_Vdi_bi=(+T1_Vgm_si_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))+(6.0*vgfbPD_Vgm_si))+d10_sqrt0*(+(+T1_Vgm_si_Vdi_bi*T1+T1_Vgm_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vgm_si+T1*T1_Vgm_si_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgm_si+6.0*vgfbPD_Vgm_si_Vdi_bi))));
  T2_Vgm_si_Vsi_bi=(+T1_Vgm_si_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))+(6.0*vgfbPD_Vgm_si))+d10_sqrt0*(+(+T1_Vgm_si_Vsi_bi*T1+T1_Vgm_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vgm_si+T1*T1_Vgm_si_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgm_si+6.0*vgfbPD_Vgm_si_Vsi_bi))));
  T2_Vgm_si_Tempt_GND=(+T1_Vgm_si_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))+(6.0*vgfbPD_Vgm_si))+d10_sqrt0*(+(+T1_Vgm_si_Tempt_GND*T1+T1_Vgm_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vgm_si+T1*T1_Vgm_si_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgm_si+6.0*vgfbPD_Vgm_si_Tempt_GND))));
#endif
T2_Vdbulk_di=(T1_Vdbulk_di+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+T1_Vdbulk_di_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vgm_di*T1+T1_Vdbulk_di*T1_Vgm_di+T1_Vgm_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vgm_di))));
  T2_Vdbulk_di_Vgm_si=(+T1_Vdbulk_di_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vgm_si*T1+T1_Vdbulk_di*T1_Vgm_si+T1_Vgm_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vgm_si))));
  T2_Vdbulk_di_Vdbulk_di=(+T1_Vdbulk_di_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vdbulk_di*T1+T1_Vdbulk_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vdbulk_di))));
  T2_Vdbulk_di_Vsbulk_si=(+T1_Vdbulk_di_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vsbulk_si*T1+T1_Vdbulk_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vsbulk_si))));
  T2_Vdbulk_di_Vgi_bi=(+T1_Vdbulk_di_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vgi_bi*T1+T1_Vdbulk_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vgi_bi))));
  T2_Vdbulk_di_Vdi_bi=(+T1_Vdbulk_di_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vdi_bi*T1+T1_Vdbulk_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vdi_bi))));
  T2_Vdbulk_di_Vsi_bi=(+T1_Vdbulk_di_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Vsi_bi*T1+T1_Vdbulk_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Vsi_bi))));
  T2_Vdbulk_di_Tempt_GND=(+T1_Vdbulk_di_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))+(6.0*vgfbPD_Vdbulk_di))+d10_sqrt0*(+(+T1_Vdbulk_di_Tempt_GND*T1+T1_Vdbulk_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vdbulk_di+T1*T1_Vdbulk_di_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdbulk_di+6.0*vgfbPD_Vdbulk_di_Tempt_GND))));
#endif
T2_Vsbulk_si=(T1_Vsbulk_si+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+T1_Vsbulk_si_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vgm_di*T1+T1_Vsbulk_si*T1_Vgm_di+T1_Vgm_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vgm_di))));
  T2_Vsbulk_si_Vgm_si=(+T1_Vsbulk_si_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vgm_si*T1+T1_Vsbulk_si*T1_Vgm_si+T1_Vgm_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vgm_si))));
  T2_Vsbulk_si_Vdbulk_di=(+T1_Vsbulk_si_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vdbulk_di*T1+T1_Vsbulk_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vdbulk_di))));
  T2_Vsbulk_si_Vsbulk_si=(+T1_Vsbulk_si_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vsbulk_si*T1+T1_Vsbulk_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vsbulk_si))));
  T2_Vsbulk_si_Vgi_bi=(+T1_Vsbulk_si_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vgi_bi*T1+T1_Vsbulk_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vgi_bi))));
  T2_Vsbulk_si_Vdi_bi=(+T1_Vsbulk_si_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vdi_bi*T1+T1_Vsbulk_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vdi_bi))));
  T2_Vsbulk_si_Vsi_bi=(+T1_Vsbulk_si_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Vsi_bi*T1+T1_Vsbulk_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Vsi_bi))));
  T2_Vsbulk_si_Tempt_GND=(+T1_Vsbulk_si_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))+(6.0*vgfbPD_Vsbulk_si))+d10_sqrt0*(+(+T1_Vsbulk_si_Tempt_GND*T1+T1_Vsbulk_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vsbulk_si+T1*T1_Vsbulk_si_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsbulk_si+6.0*vgfbPD_Vsbulk_si_Tempt_GND))));
#endif
T2_Vgi_bi=(T1_Vgi_bi+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgm_di))));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgm_si))));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vdbulk_di))));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vsbulk_si))));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vgi_bi))));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vdi_bi))));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Vsi_bi))));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))+(6.0*vgfbPD_Vgi_bi))+d10_sqrt0*(+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vgi_bi+6.0*vgfbPD_Vgi_bi_Tempt_GND))));
#endif
T2_Vdi_bi=(T1_Vdi_bi+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgm_di))));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgm_si))));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vdbulk_di))));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vsbulk_si))));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vgi_bi))));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vdi_bi))));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Vsi_bi))));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))+(6.0*vgfbPD_Vdi_bi))+d10_sqrt0*(+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vdi_bi+6.0*vgfbPD_Vdi_bi_Tempt_GND))));
#endif
T2_Vsi_bi=(T1_Vsi_bi+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))*d10_sqrt0);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+((6.0*vgfbPD_Vgm_di)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_di+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgm_di))));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+((6.0*vgfbPD_Vgm_si)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vgm_si+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgm_si))));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+((6.0*vgfbPD_Vdbulk_di)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)+(+0.0*vgfbPD+0.0*vgfbPD_Vdbulk_di+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vdbulk_di))));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+((6.0*vgfbPD_Vsbulk_si)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)+(+0.0*vgfbPD+0.0*vgfbPD_Vsbulk_si+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vsbulk_si))));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+((6.0*vgfbPD_Vgi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vgi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vgi_bi))));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+((6.0*vgfbPD_Vdi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vdi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vdi_bi))));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+((6.0*vgfbPD_Vsi_bi)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)+(+0.0*vgfbPD+0.0*vgfbPD_Vsi_bi+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Vsi_bi))));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND+(m20_sqrt(((T1*T1)+(6.0*vgfbPD)))*((((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))+((6.0*vgfbPD_Tempt_GND)))*(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))+(6.0*vgfbPD_Vsi_bi))+d10_sqrt0*(+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)+(+0.0*vgfbPD+0.0*vgfbPD_Tempt_GND+0.0*vgfbPD_Vsi_bi+6.0*vgfbPD_Vsi_bi_Tempt_GND))));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+(6.0*vgfbPD_Tempt_GND))*d10_sqrt0);
#endif
#endif
T2=(T1+d00_sqrt0);
EXIT_IF_ISNAN((T1+d00_sqrt0))
}
if
((vgfbPD<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=(((vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD-(vgfbPD-T2)*gammaPD_Vgm_si)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=((+vgfbPD_Vgm_si_Vgm_si-T2_Vgm_si_Vgm_si)/gammaPD-((vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vgm_si+(vgfbPD-T2)*gammaPD_Vgm_si_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgm_si*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vgm_si_Vgm_di=((+vgfbPD_Vgm_si_Vgm_di-T2_Vgm_si_Vgm_di)/gammaPD-((vgfbPD_Vgm_si-T2_Vgm_si)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vgm_si+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgm_si*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vgm_si_Vdbulk_di=((+vgfbPD_Vgm_si_Vdbulk_di-T2_Vgm_si_Vdbulk_di)/gammaPD-((vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgm_si+(vgfbPD-T2)*gammaPD_Vgm_si_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgm_si*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vgm_si_Vsbulk_si=((+vgfbPD_Vgm_si_Vsbulk_si-T2_Vgm_si_Vsbulk_si)/gammaPD-((vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgm_si+(vgfbPD-T2)*gammaPD_Vgm_si_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgm_si*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vgm_si_Vgi_bi=((+vgfbPD_Vgm_si_Vgi_bi-T2_Vgm_si_Vgi_bi)/gammaPD-((vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgm_si+(vgfbPD-T2)*gammaPD_Vgm_si_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgm_si*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgm_si_Vdi_bi=((+vgfbPD_Vgm_si_Vdi_bi-T2_Vgm_si_Vdi_bi)/gammaPD-((vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgm_si+(vgfbPD-T2)*gammaPD_Vgm_si_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgm_si*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgm_si_Vsi_bi=((+vgfbPD_Vgm_si_Vsi_bi-T2_Vgm_si_Vsi_bi)/gammaPD-((vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgm_si+(vgfbPD-T2)*gammaPD_Vgm_si_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgm_si*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgm_si_Tempt_GND=((+vgfbPD_Vgm_si_Tempt_GND-T2_Vgm_si_Tempt_GND)/gammaPD-((vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vgm_si+(vgfbPD-T2)*gammaPD_Vgm_si_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgm_si*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vgm_di=((vgfbPD_Vgm_di-T2_Vgm_di)/gammaPD);
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=((+vgfbPD_Vgm_di_Vgm_si-T2_Vgm_di_Vgm_si)/gammaPD-((vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*0.0+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*0.0*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vgm_di_Vgm_di=((+vgfbPD_Vgm_di_Vgm_di-T2_Vgm_di_Vgm_di)/gammaPD-((vgfbPD_Vgm_di-T2_Vgm_di)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*0.0+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*0.0*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vgm_di_Vdbulk_di=((+vgfbPD_Vgm_di_Vdbulk_di-T2_Vgm_di_Vdbulk_di)/gammaPD-((vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*0.0+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*0.0*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vgm_di_Vsbulk_si=((+vgfbPD_Vgm_di_Vsbulk_si-T2_Vgm_di_Vsbulk_si)/gammaPD-((vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*0.0+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*0.0*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vgm_di_Vgi_bi=((+vgfbPD_Vgm_di_Vgi_bi-T2_Vgm_di_Vgi_bi)/gammaPD-((vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*0.0+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*0.0*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgm_di_Vdi_bi=((+vgfbPD_Vgm_di_Vdi_bi-T2_Vgm_di_Vdi_bi)/gammaPD-((vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*0.0+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*0.0*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgm_di_Vsi_bi=((+vgfbPD_Vgm_di_Vsi_bi-T2_Vgm_di_Vsi_bi)/gammaPD-((vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*0.0+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*0.0*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgm_di_Tempt_GND=((+vgfbPD_Vgm_di_Tempt_GND-T2_Vgm_di_Tempt_GND)/gammaPD-((vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*0.0+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*0.0*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vdbulk_di=(((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD-(vgfbPD-T2)*gammaPD_Vdbulk_di)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=((+vgfbPD_Vdbulk_di_Vgm_si-T2_Vdbulk_di_Vgm_si)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vgm_di=((+vgfbPD_Vdbulk_di_Vgm_di-T2_Vdbulk_di_Vgm_di)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vdbulk_di+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vdbulk_di=((+vgfbPD_Vdbulk_di_Vdbulk_di-T2_Vdbulk_di_Vdbulk_di)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vsbulk_si=((+vgfbPD_Vdbulk_di_Vsbulk_si-T2_Vdbulk_di_Vsbulk_si)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vgi_bi=((+vgfbPD_Vdbulk_di_Vgi_bi-T2_Vdbulk_di_Vgi_bi)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vdi_bi=((+vgfbPD_Vdbulk_di_Vdi_bi-T2_Vdbulk_di_Vdi_bi)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Vsi_bi=((+vgfbPD_Vdbulk_di_Vsi_bi-T2_Vdbulk_di_Vsi_bi)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdbulk_di_Tempt_GND=((+vgfbPD_Vdbulk_di_Tempt_GND-T2_Vdbulk_di_Tempt_GND)/gammaPD-((vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vdbulk_di+(vgfbPD-T2)*gammaPD_Vdbulk_di_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdbulk_di*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vsbulk_si=(((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD-(vgfbPD-T2)*gammaPD_Vsbulk_si)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=((+vgfbPD_Vsbulk_si_Vgm_si-T2_Vsbulk_si_Vgm_si)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vgm_di=((+vgfbPD_Vsbulk_si_Vgm_di-T2_Vsbulk_si_Vgm_di)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vsbulk_si+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vdbulk_di=((+vgfbPD_Vsbulk_si_Vdbulk_di-T2_Vsbulk_si_Vdbulk_di)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vsbulk_si=((+vgfbPD_Vsbulk_si_Vsbulk_si-T2_Vsbulk_si_Vsbulk_si)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vgi_bi=((+vgfbPD_Vsbulk_si_Vgi_bi-T2_Vsbulk_si_Vgi_bi)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vdi_bi=((+vgfbPD_Vsbulk_si_Vdi_bi-T2_Vsbulk_si_Vdi_bi)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Vsi_bi=((+vgfbPD_Vsbulk_si_Vsi_bi-T2_Vsbulk_si_Vsi_bi)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsbulk_si_Tempt_GND=((+vgfbPD_Vsbulk_si_Tempt_GND-T2_Vsbulk_si_Tempt_GND)/gammaPD-((vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vsbulk_si+(vgfbPD-T2)*gammaPD_Vsbulk_si_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsbulk_si*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vgi_bi=(((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vgi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=((+vgfbPD_Vgi_bi_Vgm_si-T2_Vgi_bi_Vgm_si)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vgm_di=((+vgfbPD_Vgi_bi_Vgm_di-T2_Vgi_bi_Vgm_di)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vgi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vdbulk_di=((+vgfbPD_Vgi_bi_Vdbulk_di-T2_Vgi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vsbulk_si=((+vgfbPD_Vgi_bi_Vsbulk_si-T2_Vgi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vgi_bi=((+vgfbPD_Vgi_bi_Vgi_bi-T2_Vgi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vdi_bi=((+vgfbPD_Vgi_bi_Vdi_bi-T2_Vgi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Vsi_bi=((+vgfbPD_Vgi_bi_Vsi_bi-T2_Vgi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vgi_bi_Tempt_GND=((+vgfbPD_Vgi_bi_Tempt_GND-T2_Vgi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vgi_bi+(vgfbPD-T2)*gammaPD_Vgi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vgi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vdi_bi=(((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vdi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=((+vgfbPD_Vdi_bi_Vgm_si-T2_Vdi_bi_Vgm_si)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vgm_di=((+vgfbPD_Vdi_bi_Vgm_di-T2_Vdi_bi_Vgm_di)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vdi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vdbulk_di=((+vgfbPD_Vdi_bi_Vdbulk_di-T2_Vdi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vsbulk_si=((+vgfbPD_Vdi_bi_Vsbulk_si-T2_Vdi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vgi_bi=((+vgfbPD_Vdi_bi_Vgi_bi-T2_Vdi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vdi_bi=((+vgfbPD_Vdi_bi_Vdi_bi-T2_Vdi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Vsi_bi=((+vgfbPD_Vdi_bi_Vsi_bi-T2_Vdi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vdi_bi_Tempt_GND=((+vgfbPD_Vdi_bi_Tempt_GND-T2_Vdi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vdi_bi+(vgfbPD-T2)*gammaPD_Vdi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vdi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
T3_Vsi_bi=(((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD-(vgfbPD-T2)*gammaPD_Vsi_bi)/gammaPD/gammaPD);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=((+vgfbPD_Vsi_bi_Vgm_si-T2_Vsi_bi_Vgm_si)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgm_si+(vgfbPD_Vgm_si-T2_Vgm_si)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vgm_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vgm_si/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vgm_di=((+vgfbPD_Vsi_bi_Vgm_di-T2_Vsi_bi_Vgm_di)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*0.0+(vgfbPD_Vgm_di-T2_Vgm_di)*gammaPD_Vsi_bi+(vgfbPD-T2)*0.0)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*0.0/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vdbulk_di=((+vgfbPD_Vsi_bi_Vdbulk_di-T2_Vsi_bi_Vdbulk_di)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdbulk_di+(vgfbPD_Vdbulk_di-T2_Vdbulk_di)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vdbulk_di)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vdbulk_di/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vsbulk_si=((+vgfbPD_Vsi_bi_Vsbulk_si-T2_Vsi_bi_Vsbulk_si)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsbulk_si+(vgfbPD_Vsbulk_si-T2_Vsbulk_si)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vsbulk_si)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vsbulk_si/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vgi_bi=((+vgfbPD_Vsi_bi_Vgi_bi-T2_Vsi_bi_Vgi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vgi_bi+(vgfbPD_Vgi_bi-T2_Vgi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vgi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vgi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vdi_bi=((+vgfbPD_Vsi_bi_Vdi_bi-T2_Vsi_bi_Vdi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vdi_bi+(vgfbPD_Vdi_bi-T2_Vdi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vdi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vdi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Vsi_bi=((+vgfbPD_Vsi_bi_Vsi_bi-T2_Vsi_bi_Vsi_bi)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsi_bi+(vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Vsi_bi)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Vsi_bi/gammaPD/gammaPD/gammaPD);
  T3_Vsi_bi_Tempt_GND=((+vgfbPD_Vsi_bi_Tempt_GND-T2_Vsi_bi_Tempt_GND)/gammaPD-((vgfbPD_Vsi_bi-T2_Vsi_bi)*gammaPD_Tempt_GND+(vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD_Vsi_bi+(vgfbPD-T2)*gammaPD_Vsi_bi_Tempt_GND)/gammaPD/gammaPD+2*(vgfbPD-T2)*gammaPD_Vsi_bi*gammaPD_Tempt_GND/gammaPD/gammaPD/gammaPD);
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(((vgfbPD_Tempt_GND-T2_Tempt_GND)*gammaPD-(vgfbPD-T2)*gammaPD_Tempt_GND)/gammaPD/gammaPD);
#endif
#endif
T3=((vgfbPD-T2)/gammaPD);
EXIT_IF_ISNAN(((vgfbPD-T2)/gammaPD))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
psip_Vgm_di=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vgm_di)+((T3_Vgm_di*T3)+(T3*T3_Vgm_di)))));
#if defined(_DERIVATE2)
  psip_Vgm_di_Vgm_di=0.0;
  psip_Vgm_di_Vgm_si=0.0;
  psip_Vgm_di_Vdbulk_di=0.0;
  psip_Vgm_di_Vsbulk_si=0.0;
  psip_Vgm_di_Vgi_bi=0.0;
  psip_Vgm_di_Vdi_bi=0.0;
  psip_Vgm_di_Vsi_bi=0.0;
  psip_Vgm_di_Tempt_GND=0.0;
#endif
psip_Vgm_si=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vgm_si)+((T3_Vgm_si*T3)+(T3*T3_Vgm_si)))));
#if defined(_DERIVATE2)
  psip_Vgm_si_Vgm_di=0.0;
  psip_Vgm_si_Vgm_si=0.0;
  psip_Vgm_si_Vdbulk_di=0.0;
  psip_Vgm_si_Vsbulk_si=0.0;
  psip_Vgm_si_Vgi_bi=0.0;
  psip_Vgm_si_Vdi_bi=0.0;
  psip_Vgm_si_Vsi_bi=0.0;
  psip_Vgm_si_Tempt_GND=0.0;
#endif
psip_Vdbulk_di=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vdbulk_di)+((T3_Vdbulk_di*T3)+(T3*T3_Vdbulk_di)))));
#if defined(_DERIVATE2)
  psip_Vdbulk_di_Vgm_di=0.0;
  psip_Vdbulk_di_Vgm_si=0.0;
  psip_Vdbulk_di_Vdbulk_di=0.0;
  psip_Vdbulk_di_Vsbulk_si=0.0;
  psip_Vdbulk_di_Vgi_bi=0.0;
  psip_Vdbulk_di_Vdi_bi=0.0;
  psip_Vdbulk_di_Vsi_bi=0.0;
  psip_Vdbulk_di_Tempt_GND=0.0;
#endif
psip_Vsbulk_si=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vsbulk_si)+((T3_Vsbulk_si*T3)+(T3*T3_Vsbulk_si)))));
#if defined(_DERIVATE2)
  psip_Vsbulk_si_Vgm_di=0.0;
  psip_Vsbulk_si_Vgm_si=0.0;
  psip_Vsbulk_si_Vdbulk_di=0.0;
  psip_Vsbulk_si_Vsbulk_si=0.0;
  psip_Vsbulk_si_Vgi_bi=0.0;
  psip_Vsbulk_si_Vdi_bi=0.0;
  psip_Vsbulk_si_Vsi_bi=0.0;
  psip_Vsbulk_si_Tempt_GND=0.0;
#endif
psip_Vgi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vgi_bi)+((T3_Vgi_bi*T3)+(T3*T3_Vgi_bi)))));
#if defined(_DERIVATE2)
  psip_Vgi_bi_Vgm_di=0.0;
  psip_Vgi_bi_Vgm_si=0.0;
  psip_Vgi_bi_Vdbulk_di=0.0;
  psip_Vgi_bi_Vsbulk_si=0.0;
  psip_Vgi_bi_Vgi_bi=0.0;
  psip_Vgi_bi_Vdi_bi=0.0;
  psip_Vgi_bi_Vsi_bi=0.0;
  psip_Vgi_bi_Tempt_GND=0.0;
#endif
psip_Vdi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vdi_bi)+((T3_Vdi_bi*T3)+(T3*T3_Vdi_bi)))));
#if defined(_DERIVATE2)
  psip_Vdi_bi_Vgm_di=0.0;
  psip_Vdi_bi_Vgm_si=0.0;
  psip_Vdi_bi_Vdbulk_di=0.0;
  psip_Vdi_bi_Vsbulk_si=0.0;
  psip_Vdi_bi_Vgi_bi=0.0;
  psip_Vdi_bi_Vdi_bi=0.0;
  psip_Vdi_bi_Vsi_bi=0.0;
  psip_Vdi_bi_Tempt_GND=0.0;
#endif
psip_Vsi_bi=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Vsi_bi)+((T3_Vsi_bi*T3)+(T3*T3_Vsi_bi)))));
#if defined(_DERIVATE2)
  psip_Vsi_bi_Vgm_di=0.0;
  psip_Vsi_bi_Vgm_si=0.0;
  psip_Vsi_bi_Vdbulk_di=0.0;
  psip_Vsi_bi_Vsbulk_si=0.0;
  psip_Vsi_bi_Vgi_bi=0.0;
  psip_Vsi_bi_Vdi_bi=0.0;
  psip_Vsi_bi_Vsi_bi=0.0;
  psip_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
psip_Tempt_GND=(-bsimbulk_d_lln(((1.0-T2)+(T3*T3)),((-T2_Tempt_GND)+((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))));
#endif
#endif
psip=(-bsimbulk_lln(((1.0-T2)+(T3*T3))));
EXIT_IF_ISNAN((-bsimbulk_lln(((1.0-T2)+(T3*T3)))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=bsimbulk_d_lexp((-T2),(-T2_Vgm_si));
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=bsimbulk_d_lexp((-T2),(-T2_Vgm_di));
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp((-T2),(-T2_Vdbulk_di));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=0.0;
  T3_Vdbulk_di_Vgm_di=0.0;
  T3_Vdbulk_di_Vdbulk_di=0.0;
  T3_Vdbulk_di_Vsbulk_si=0.0;
  T3_Vdbulk_di_Vgi_bi=0.0;
  T3_Vdbulk_di_Vdi_bi=0.0;
  T3_Vdbulk_di_Vsi_bi=0.0;
  T3_Vdbulk_di_Tempt_GND=0.0;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp((-T2),(-T2_Vsbulk_si));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=0.0;
  T3_Vsbulk_si_Vgm_di=0.0;
  T3_Vsbulk_si_Vdbulk_di=0.0;
  T3_Vsbulk_si_Vsbulk_si=0.0;
  T3_Vsbulk_si_Vgi_bi=0.0;
  T3_Vsbulk_si_Vdi_bi=0.0;
  T3_Vsbulk_si_Vsi_bi=0.0;
  T3_Vsbulk_si_Tempt_GND=0.0;
#endif
T3_Vgi_bi=bsimbulk_d_lexp((-T2),(-T2_Vgi_bi));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=0.0;
  T3_Vgi_bi_Vgm_di=0.0;
  T3_Vgi_bi_Vdbulk_di=0.0;
  T3_Vgi_bi_Vsbulk_si=0.0;
  T3_Vgi_bi_Vgi_bi=0.0;
  T3_Vgi_bi_Vdi_bi=0.0;
  T3_Vgi_bi_Vsi_bi=0.0;
  T3_Vgi_bi_Tempt_GND=0.0;
#endif
T3_Vdi_bi=bsimbulk_d_lexp((-T2),(-T2_Vdi_bi));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=0.0;
  T3_Vdi_bi_Vgm_di=0.0;
  T3_Vdi_bi_Vdbulk_di=0.0;
  T3_Vdi_bi_Vsbulk_si=0.0;
  T3_Vdi_bi_Vgi_bi=0.0;
  T3_Vdi_bi_Vdi_bi=0.0;
  T3_Vdi_bi_Vsi_bi=0.0;
  T3_Vdi_bi_Tempt_GND=0.0;
#endif
T3_Vsi_bi=bsimbulk_d_lexp((-T2),(-T2_Vsi_bi));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=0.0;
  T3_Vsi_bi_Vgm_di=0.0;
  T3_Vsi_bi_Vdbulk_di=0.0;
  T3_Vsi_bi_Vsbulk_si=0.0;
  T3_Vsi_bi_Vgi_bi=0.0;
  T3_Vsi_bi_Vdi_bi=0.0;
  T3_Vsi_bi_Vsi_bi=0.0;
  T3_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((-T2),(-T2_Tempt_GND));
#endif
#endif
T3=bsimbulk_lexp((-T2));
EXIT_IF_ISNAN(bsimbulk_lexp((-T2)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=0.0;
  T1_Vgm_di_Vgm_si=0.0;
  T1_Vgm_di_Vdbulk_di=0.0;
  T1_Vgm_di_Vsbulk_si=0.0;
  T1_Vgm_di_Vgi_bi=0.0;
  T1_Vgm_di_Vdi_bi=0.0;
  T1_Vgm_di_Vsi_bi=0.0;
  T1_Vgm_di_Tempt_GND=0.0;
#endif
T1_Vgm_si=(0.5*gammaPD_Vgm_si);
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vgm_si+0.5*0.0);
  T1_Vgm_si_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vgm_si+0.5*gammaPD_Vgm_si_Vgm_si);
  T1_Vgm_si_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vgm_si+0.5*gammaPD_Vgm_si_Vdbulk_di);
  T1_Vgm_si_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vgm_si+0.5*gammaPD_Vgm_si_Vsbulk_si);
  T1_Vgm_si_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vgm_si+0.5*gammaPD_Vgm_si_Vgi_bi);
  T1_Vgm_si_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vgm_si+0.5*gammaPD_Vgm_si_Vdi_bi);
  T1_Vgm_si_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vgm_si+0.5*gammaPD_Vgm_si_Vsi_bi);
  T1_Vgm_si_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vgm_si+0.5*gammaPD_Vgm_si_Tempt_GND);
#endif
T1_Vdbulk_di=(0.5*gammaPD_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vdbulk_di+0.5*0.0);
  T1_Vdbulk_di_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vgm_si);
  T1_Vdbulk_di_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vdbulk_di);
  T1_Vdbulk_di_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vsbulk_si);
  T1_Vdbulk_di_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vgi_bi);
  T1_Vdbulk_di_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vdi_bi);
  T1_Vdbulk_di_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Vsi_bi);
  T1_Vdbulk_di_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vdbulk_di+0.5*gammaPD_Vdbulk_di_Tempt_GND);
#endif
T1_Vsbulk_si=(0.5*gammaPD_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vsbulk_si+0.5*0.0);
  T1_Vsbulk_si_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vgm_si);
  T1_Vsbulk_si_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vdbulk_di);
  T1_Vsbulk_si_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vsbulk_si);
  T1_Vsbulk_si_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vgi_bi);
  T1_Vsbulk_si_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vdi_bi);
  T1_Vsbulk_si_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Vsi_bi);
  T1_Vsbulk_si_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vsbulk_si+0.5*gammaPD_Vsbulk_si_Tempt_GND);
#endif
T1_Vgi_bi=(0.5*gammaPD_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vgi_bi+0.5*0.0);
  T1_Vgi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vgi_bi+0.5*gammaPD_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=(0.5*gammaPD_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vdi_bi+0.5*0.0);
  T1_Vdi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vdi_bi+0.5*gammaPD_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=(0.5*gammaPD_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+0.0*gammaPD+0.0*0.0+0.0*gammaPD_Vsi_bi+0.5*0.0);
  T1_Vsi_bi_Vgm_si=(+0.0*gammaPD+0.0*gammaPD_Vgm_si+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+0.0*gammaPD+0.0*gammaPD_Vdbulk_di+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+0.0*gammaPD+0.0*gammaPD_Vsbulk_si+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+0.0*gammaPD+0.0*gammaPD_Vgi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+0.0*gammaPD+0.0*gammaPD_Vdi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+0.0*gammaPD+0.0*gammaPD_Vsi_bi+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+0.0*gammaPD+0.0*gammaPD_Tempt_GND+0.0*gammaPD_Vsi_bi+0.5*gammaPD_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=(0.5*gammaPD_Tempt_GND);
#endif
#endif
T1=(0.5*gammaPD);
EXIT_IF_ISNAN((0.5*gammaPD))
{
double m00_sqrt(d00_sqrt0,(((vgfbPD-1.0)+T3)+(T1*T1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((vgfbPD-1.0)+T3)+(T1*T1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=(((vgfbPD_Vgm_di+T3_Vgm_di)+((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))*d10_sqrt0-T1_Vgm_di);
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vgm_di+T3_Vgm_di)+((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_di_Vgm_di-0.0)+T3_Vgm_di_Vgm_di)+(+T1_Vgm_di_Vgm_di*T1+T1_Vgm_di*T1_Vgm_di+T1_Vgm_di*T1_Vgm_di+T1*T1_Vgm_di_Vgm_di)))-T1_Vgm_di_Vgm_di);
  T2_Vgm_di_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vgm_di+T3_Vgm_di)+((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_di_Vgm_si-0.0)+T3_Vgm_di_Vgm_si)+(+T1_Vgm_di_Vgm_si*T1+T1_Vgm_di*T1_Vgm_si+T1_Vgm_si*T1_Vgm_di+T1*T1_Vgm_di_Vgm_si)))-T1_Vgm_di_Vgm_si);
  T2_Vgm_di_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vgm_di+T3_Vgm_di)+((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_di_Vdbulk_di-0.0)+T3_Vgm_di_Vdbulk_di)+(+T1_Vgm_di_Vdbulk_di*T1+T1_Vgm_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgm_di+T1*T1_Vgm_di_Vdbulk_di)))-T1_Vgm_di_Vdbulk_di);
  T2_Vgm_di_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vgm_di+T3_Vgm_di)+((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_di_Vsbulk_si-0.0)+T3_Vgm_di_Vsbulk_si)+(+T1_Vgm_di_Vsbulk_si*T1+T1_Vgm_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgm_di+T1*T1_Vgm_di_Vsbulk_si)))-T1_Vgm_di_Vsbulk_si);
  T2_Vgm_di_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vgm_di+T3_Vgm_di)+((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_di_Vgi_bi-0.0)+T3_Vgm_di_Vgi_bi)+(+T1_Vgm_di_Vgi_bi*T1+T1_Vgm_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vgm_di+T1*T1_Vgm_di_Vgi_bi)))-T1_Vgm_di_Vgi_bi);
  T2_Vgm_di_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vgm_di+T3_Vgm_di)+((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_di_Vdi_bi-0.0)+T3_Vgm_di_Vdi_bi)+(+T1_Vgm_di_Vdi_bi*T1+T1_Vgm_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vgm_di+T1*T1_Vgm_di_Vdi_bi)))-T1_Vgm_di_Vdi_bi);
  T2_Vgm_di_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vgm_di+T3_Vgm_di)+((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_di_Vsi_bi-0.0)+T3_Vgm_di_Vsi_bi)+(+T1_Vgm_di_Vsi_bi*T1+T1_Vgm_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vgm_di+T1*T1_Vgm_di_Vsi_bi)))-T1_Vgm_di_Vsi_bi);
  T2_Vgm_di_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vgm_di+T3_Vgm_di)+((T1_Vgm_di*T1)+(T1*T1_Vgm_di)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_di_Tempt_GND-0.0)+T3_Vgm_di_Tempt_GND)+(+T1_Vgm_di_Tempt_GND*T1+T1_Vgm_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vgm_di+T1*T1_Vgm_di_Tempt_GND)))-T1_Vgm_di_Tempt_GND);
#endif
T2_Vgm_si=(((vgfbPD_Vgm_si+T3_Vgm_si)+((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))*d10_sqrt0-T1_Vgm_si);
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vgm_si+T3_Vgm_si)+((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_si_Vgm_di-0.0)+T3_Vgm_si_Vgm_di)+(+T1_Vgm_si_Vgm_di*T1+T1_Vgm_si*T1_Vgm_di+T1_Vgm_di*T1_Vgm_si+T1*T1_Vgm_si_Vgm_di)))-T1_Vgm_si_Vgm_di);
  T2_Vgm_si_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vgm_si+T3_Vgm_si)+((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_si_Vgm_si-0.0)+T3_Vgm_si_Vgm_si)+(+T1_Vgm_si_Vgm_si*T1+T1_Vgm_si*T1_Vgm_si+T1_Vgm_si*T1_Vgm_si+T1*T1_Vgm_si_Vgm_si)))-T1_Vgm_si_Vgm_si);
  T2_Vgm_si_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vgm_si+T3_Vgm_si)+((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_si_Vdbulk_di-0.0)+T3_Vgm_si_Vdbulk_di)+(+T1_Vgm_si_Vdbulk_di*T1+T1_Vgm_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgm_si+T1*T1_Vgm_si_Vdbulk_di)))-T1_Vgm_si_Vdbulk_di);
  T2_Vgm_si_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vgm_si+T3_Vgm_si)+((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_si_Vsbulk_si-0.0)+T3_Vgm_si_Vsbulk_si)+(+T1_Vgm_si_Vsbulk_si*T1+T1_Vgm_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgm_si+T1*T1_Vgm_si_Vsbulk_si)))-T1_Vgm_si_Vsbulk_si);
  T2_Vgm_si_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vgm_si+T3_Vgm_si)+((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_si_Vgi_bi-0.0)+T3_Vgm_si_Vgi_bi)+(+T1_Vgm_si_Vgi_bi*T1+T1_Vgm_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vgm_si+T1*T1_Vgm_si_Vgi_bi)))-T1_Vgm_si_Vgi_bi);
  T2_Vgm_si_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vgm_si+T3_Vgm_si)+((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_si_Vdi_bi-0.0)+T3_Vgm_si_Vdi_bi)+(+T1_Vgm_si_Vdi_bi*T1+T1_Vgm_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vgm_si+T1*T1_Vgm_si_Vdi_bi)))-T1_Vgm_si_Vdi_bi);
  T2_Vgm_si_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vgm_si+T3_Vgm_si)+((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_si_Vsi_bi-0.0)+T3_Vgm_si_Vsi_bi)+(+T1_Vgm_si_Vsi_bi*T1+T1_Vgm_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vgm_si+T1*T1_Vgm_si_Vsi_bi)))-T1_Vgm_si_Vsi_bi);
  T2_Vgm_si_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vgm_si+T3_Vgm_si)+((T1_Vgm_si*T1)+(T1*T1_Vgm_si)))+d10_sqrt0*(+(+(+vgfbPD_Vgm_si_Tempt_GND-0.0)+T3_Vgm_si_Tempt_GND)+(+T1_Vgm_si_Tempt_GND*T1+T1_Vgm_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vgm_si+T1*T1_Vgm_si_Tempt_GND)))-T1_Vgm_si_Tempt_GND);
#endif
T2_Vdbulk_di=(((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))*d10_sqrt0-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vgm_di-0.0)+T3_Vdbulk_di_Vgm_di)+(+T1_Vdbulk_di_Vgm_di*T1+T1_Vdbulk_di*T1_Vgm_di+T1_Vgm_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_di)))-T1_Vdbulk_di_Vgm_di);
  T2_Vdbulk_di_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vgm_si-0.0)+T3_Vdbulk_di_Vgm_si)+(+T1_Vdbulk_di_Vgm_si*T1+T1_Vdbulk_di*T1_Vgm_si+T1_Vgm_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgm_si)))-T1_Vdbulk_di_Vgm_si);
  T2_Vdbulk_di_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vdbulk_di-0.0)+T3_Vdbulk_di_Vdbulk_di)+(+T1_Vdbulk_di_Vdbulk_di*T1+T1_Vdbulk_di*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdbulk_di)))-T1_Vdbulk_di_Vdbulk_di);
  T2_Vdbulk_di_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vsbulk_si-0.0)+T3_Vdbulk_di_Vsbulk_si)+(+T1_Vdbulk_di_Vsbulk_si*T1+T1_Vdbulk_di*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsbulk_si)))-T1_Vdbulk_di_Vsbulk_si);
  T2_Vdbulk_di_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vgi_bi-0.0)+T3_Vdbulk_di_Vgi_bi)+(+T1_Vdbulk_di_Vgi_bi*T1+T1_Vdbulk_di*T1_Vgi_bi+T1_Vgi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vgi_bi)))-T1_Vdbulk_di_Vgi_bi);
  T2_Vdbulk_di_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vdi_bi-0.0)+T3_Vdbulk_di_Vdi_bi)+(+T1_Vdbulk_di_Vdi_bi*T1+T1_Vdbulk_di*T1_Vdi_bi+T1_Vdi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vdi_bi)))-T1_Vdbulk_di_Vdi_bi);
  T2_Vdbulk_di_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Vsi_bi-0.0)+T3_Vdbulk_di_Vsi_bi)+(+T1_Vdbulk_di_Vsi_bi*T1+T1_Vdbulk_di*T1_Vsi_bi+T1_Vsi_bi*T1_Vdbulk_di+T1*T1_Vdbulk_di_Vsi_bi)))-T1_Vdbulk_di_Vsi_bi);
  T2_Vdbulk_di_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di)))+d10_sqrt0*(+(+(+vgfbPD_Vdbulk_di_Tempt_GND-0.0)+T3_Vdbulk_di_Tempt_GND)+(+T1_Vdbulk_di_Tempt_GND*T1+T1_Vdbulk_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vdbulk_di+T1*T1_Vdbulk_di_Tempt_GND)))-T1_Vdbulk_di_Tempt_GND);
#endif
T2_Vsbulk_si=(((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))*d10_sqrt0-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vgm_di-0.0)+T3_Vsbulk_si_Vgm_di)+(+T1_Vsbulk_si_Vgm_di*T1+T1_Vsbulk_si*T1_Vgm_di+T1_Vgm_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_di)))-T1_Vsbulk_si_Vgm_di);
  T2_Vsbulk_si_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vgm_si-0.0)+T3_Vsbulk_si_Vgm_si)+(+T1_Vsbulk_si_Vgm_si*T1+T1_Vsbulk_si*T1_Vgm_si+T1_Vgm_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgm_si)))-T1_Vsbulk_si_Vgm_si);
  T2_Vsbulk_si_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vdbulk_di-0.0)+T3_Vsbulk_si_Vdbulk_di)+(+T1_Vsbulk_si_Vdbulk_di*T1+T1_Vsbulk_si*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdbulk_di)))-T1_Vsbulk_si_Vdbulk_di);
  T2_Vsbulk_si_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vsbulk_si-0.0)+T3_Vsbulk_si_Vsbulk_si)+(+T1_Vsbulk_si_Vsbulk_si*T1+T1_Vsbulk_si*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsbulk_si)))-T1_Vsbulk_si_Vsbulk_si);
  T2_Vsbulk_si_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vgi_bi-0.0)+T3_Vsbulk_si_Vgi_bi)+(+T1_Vsbulk_si_Vgi_bi*T1+T1_Vsbulk_si*T1_Vgi_bi+T1_Vgi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vgi_bi)))-T1_Vsbulk_si_Vgi_bi);
  T2_Vsbulk_si_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vdi_bi-0.0)+T3_Vsbulk_si_Vdi_bi)+(+T1_Vsbulk_si_Vdi_bi*T1+T1_Vsbulk_si*T1_Vdi_bi+T1_Vdi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vdi_bi)))-T1_Vsbulk_si_Vdi_bi);
  T2_Vsbulk_si_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Vsi_bi-0.0)+T3_Vsbulk_si_Vsi_bi)+(+T1_Vsbulk_si_Vsi_bi*T1+T1_Vsbulk_si*T1_Vsi_bi+T1_Vsi_bi*T1_Vsbulk_si+T1*T1_Vsbulk_si_Vsi_bi)))-T1_Vsbulk_si_Vsi_bi);
  T2_Vsbulk_si_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si)))+d10_sqrt0*(+(+(+vgfbPD_Vsbulk_si_Tempt_GND-0.0)+T3_Vsbulk_si_Tempt_GND)+(+T1_Vsbulk_si_Tempt_GND*T1+T1_Vsbulk_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vsbulk_si+T1*T1_Vsbulk_si_Tempt_GND)))-T1_Vsbulk_si_Tempt_GND);
#endif
T2_Vgi_bi=(((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))*d10_sqrt0-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgm_di-0.0)+T3_Vgi_bi_Vgm_di)+(+T1_Vgi_bi_Vgm_di*T1+T1_Vgi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_di)))-T1_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgm_si-0.0)+T3_Vgi_bi_Vgm_si)+(+T1_Vgi_bi_Vgm_si*T1+T1_Vgi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vgm_si)))-T1_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vdbulk_di-0.0)+T3_Vgi_bi_Vdbulk_di)+(+T1_Vgi_bi_Vdbulk_di*T1+T1_Vgi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vgi_bi+T1*T1_Vgi_bi_Vdbulk_di)))-T1_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vsbulk_si-0.0)+T3_Vgi_bi_Vsbulk_si)+(+T1_Vgi_bi_Vsbulk_si*T1+T1_Vgi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vgi_bi+T1*T1_Vgi_bi_Vsbulk_si)))-T1_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vgi_bi-0.0)+T3_Vgi_bi_Vgi_bi)+(+T1_Vgi_bi_Vgi_bi*T1+T1_Vgi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vgi_bi)))-T1_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vdi_bi-0.0)+T3_Vgi_bi_Vdi_bi)+(+T1_Vgi_bi_Vdi_bi*T1+T1_Vgi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vdi_bi)))-T1_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Vsi_bi-0.0)+T3_Vgi_bi_Vsi_bi)+(+T1_Vgi_bi_Vsi_bi*T1+T1_Vgi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vgi_bi+T1*T1_Vgi_bi_Vsi_bi)))-T1_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vgi_bi_Tempt_GND-0.0)+T3_Vgi_bi_Tempt_GND)+(+T1_Vgi_bi_Tempt_GND*T1+T1_Vgi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vgi_bi+T1*T1_Vgi_bi_Tempt_GND)))-T1_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=(((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))*d10_sqrt0-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgm_di-0.0)+T3_Vdi_bi_Vgm_di)+(+T1_Vdi_bi_Vgm_di*T1+T1_Vdi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_di)))-T1_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgm_si-0.0)+T3_Vdi_bi_Vgm_si)+(+T1_Vdi_bi_Vgm_si*T1+T1_Vdi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vgm_si)))-T1_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vdbulk_di-0.0)+T3_Vdi_bi_Vdbulk_di)+(+T1_Vdi_bi_Vdbulk_di*T1+T1_Vdi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vdi_bi+T1*T1_Vdi_bi_Vdbulk_di)))-T1_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vsbulk_si-0.0)+T3_Vdi_bi_Vsbulk_si)+(+T1_Vdi_bi_Vsbulk_si*T1+T1_Vdi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vdi_bi+T1*T1_Vdi_bi_Vsbulk_si)))-T1_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vgi_bi-0.0)+T3_Vdi_bi_Vgi_bi)+(+T1_Vdi_bi_Vgi_bi*T1+T1_Vdi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vgi_bi)))-T1_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vdi_bi-0.0)+T3_Vdi_bi_Vdi_bi)+(+T1_Vdi_bi_Vdi_bi*T1+T1_Vdi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vdi_bi)))-T1_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Vsi_bi-0.0)+T3_Vdi_bi_Vsi_bi)+(+T1_Vdi_bi_Vsi_bi*T1+T1_Vdi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vdi_bi+T1*T1_Vdi_bi_Vsi_bi)))-T1_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vdi_bi_Tempt_GND-0.0)+T3_Vdi_bi_Tempt_GND)+(+T1_Vdi_bi_Tempt_GND*T1+T1_Vdi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_bi+T1*T1_Vdi_bi_Tempt_GND)))-T1_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=(((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))*d10_sqrt0-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_di+T3_Vgm_di)+(((T1_Vgm_di*T1)+(T1*T1_Vgm_di))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgm_di-0.0)+T3_Vsi_bi_Vgm_di)+(+T1_Vsi_bi_Vgm_di*T1+T1_Vsi_bi*T1_Vgm_di+T1_Vgm_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_di)))-T1_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgm_si+T3_Vgm_si)+(((T1_Vgm_si*T1)+(T1*T1_Vgm_si))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgm_si-0.0)+T3_Vsi_bi_Vgm_si)+(+T1_Vsi_bi_Vgm_si*T1+T1_Vsi_bi*T1_Vgm_si+T1_Vgm_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vgm_si)))-T1_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdbulk_di+T3_Vdbulk_di)+(((T1_Vdbulk_di*T1)+(T1*T1_Vdbulk_di))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vdbulk_di-0.0)+T3_Vsi_bi_Vdbulk_di)+(+T1_Vsi_bi_Vdbulk_di*T1+T1_Vsi_bi*T1_Vdbulk_di+T1_Vdbulk_di*T1_Vsi_bi+T1*T1_Vsi_bi_Vdbulk_di)))-T1_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsbulk_si+T3_Vsbulk_si)+(((T1_Vsbulk_si*T1)+(T1*T1_Vsbulk_si))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vsbulk_si-0.0)+T3_Vsi_bi_Vsbulk_si)+(+T1_Vsi_bi_Vsbulk_si*T1+T1_Vsi_bi*T1_Vsbulk_si+T1_Vsbulk_si*T1_Vsi_bi+T1*T1_Vsi_bi_Vsbulk_si)))-T1_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vgi_bi+T3_Vgi_bi)+(((T1_Vgi_bi*T1)+(T1*T1_Vgi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vgi_bi-0.0)+T3_Vsi_bi_Vgi_bi)+(+T1_Vsi_bi_Vgi_bi*T1+T1_Vsi_bi*T1_Vgi_bi+T1_Vgi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vgi_bi)))-T1_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vdi_bi+T3_Vdi_bi)+(((T1_Vdi_bi*T1)+(T1*T1_Vdi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vdi_bi-0.0)+T3_Vsi_bi_Vdi_bi)+(+T1_Vsi_bi_Vdi_bi*T1+T1_Vsi_bi*T1_Vdi_bi+T1_Vdi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vdi_bi)))-T1_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+(((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Vsi_bi-0.0)+T3_Vsi_bi_Vsi_bi)+(+T1_Vsi_bi_Vsi_bi*T1+T1_Vsi_bi*T1_Vsi_bi+T1_Vsi_bi*T1_Vsi_bi+T1*T1_Vsi_bi_Vsi_bi)))-T1_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(+(m20_sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))*((vgfbPD_Tempt_GND+T3_Tempt_GND)+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))))*((vgfbPD_Vsi_bi+T3_Vsi_bi)+((T1_Vsi_bi*T1)+(T1*T1_Vsi_bi)))+d10_sqrt0*(+(+(+vgfbPD_Vsi_bi_Tempt_GND-0.0)+T3_Vsi_bi_Tempt_GND)+(+T1_Vsi_bi_Tempt_GND*T1+T1_Vsi_bi*T1_Tempt_GND+T1_Tempt_GND*T1_Vsi_bi+T1*T1_Vsi_bi_Tempt_GND)))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((vgfbPD_Tempt_GND+T3_Tempt_GND)+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0-T1_Tempt_GND);
#endif
#endif
T2=(d00_sqrt0-T1);
EXIT_IF_ISNAN((d00_sqrt0-T1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
psip_Vgm_di=(((T2_Vgm_di*T2)+(T2*T2_Vgm_di))-T3_Vgm_di);
#if defined(_DERIVATE2)
  psip_Vgm_di_Vgm_di=(+(+(+T2_Vgm_di_Vgm_di*T2+T2_Vgm_di*T2_Vgm_di+T2_Vgm_di*T2_Vgm_di+T2*T2_Vgm_di_Vgm_di)+0.0)-T3_Vgm_di_Vgm_di);
  psip_Vgm_di_Vgm_si=(+(+(+T2_Vgm_di_Vgm_si*T2+T2_Vgm_di*T2_Vgm_si+T2_Vgm_si*T2_Vgm_di+T2*T2_Vgm_di_Vgm_si)+0.0)-T3_Vgm_di_Vgm_si);
  psip_Vgm_di_Vdbulk_di=(+(+(+T2_Vgm_di_Vdbulk_di*T2+T2_Vgm_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_di+T2*T2_Vgm_di_Vdbulk_di)+0.0)-T3_Vgm_di_Vdbulk_di);
  psip_Vgm_di_Vsbulk_si=(+(+(+T2_Vgm_di_Vsbulk_si*T2+T2_Vgm_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_di+T2*T2_Vgm_di_Vsbulk_si)+0.0)-T3_Vgm_di_Vsbulk_si);
  psip_Vgm_di_Vgi_bi=(+(+(+T2_Vgm_di_Vgi_bi*T2+T2_Vgm_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_di+T2*T2_Vgm_di_Vgi_bi)+0.0)-T3_Vgm_di_Vgi_bi);
  psip_Vgm_di_Vdi_bi=(+(+(+T2_Vgm_di_Vdi_bi*T2+T2_Vgm_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_di+T2*T2_Vgm_di_Vdi_bi)+0.0)-T3_Vgm_di_Vdi_bi);
  psip_Vgm_di_Vsi_bi=(+(+(+T2_Vgm_di_Vsi_bi*T2+T2_Vgm_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_di+T2*T2_Vgm_di_Vsi_bi)+0.0)-T3_Vgm_di_Vsi_bi);
  psip_Vgm_di_Tempt_GND=(+(+(+T2_Vgm_di_Tempt_GND*T2+T2_Vgm_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_di+T2*T2_Vgm_di_Tempt_GND)+0.0)-T3_Vgm_di_Tempt_GND);
#endif
psip_Vgm_si=(((T2_Vgm_si*T2)+(T2*T2_Vgm_si))-T3_Vgm_si);
#if defined(_DERIVATE2)
  psip_Vgm_si_Vgm_di=(+(+(+T2_Vgm_si_Vgm_di*T2+T2_Vgm_si*T2_Vgm_di+T2_Vgm_di*T2_Vgm_si+T2*T2_Vgm_si_Vgm_di)+0.0)-T3_Vgm_si_Vgm_di);
  psip_Vgm_si_Vgm_si=(+(+(+T2_Vgm_si_Vgm_si*T2+T2_Vgm_si*T2_Vgm_si+T2_Vgm_si*T2_Vgm_si+T2*T2_Vgm_si_Vgm_si)+0.0)-T3_Vgm_si_Vgm_si);
  psip_Vgm_si_Vdbulk_di=(+(+(+T2_Vgm_si_Vdbulk_di*T2+T2_Vgm_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_si+T2*T2_Vgm_si_Vdbulk_di)+0.0)-T3_Vgm_si_Vdbulk_di);
  psip_Vgm_si_Vsbulk_si=(+(+(+T2_Vgm_si_Vsbulk_si*T2+T2_Vgm_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_si+T2*T2_Vgm_si_Vsbulk_si)+0.0)-T3_Vgm_si_Vsbulk_si);
  psip_Vgm_si_Vgi_bi=(+(+(+T2_Vgm_si_Vgi_bi*T2+T2_Vgm_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_si+T2*T2_Vgm_si_Vgi_bi)+0.0)-T3_Vgm_si_Vgi_bi);
  psip_Vgm_si_Vdi_bi=(+(+(+T2_Vgm_si_Vdi_bi*T2+T2_Vgm_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_si+T2*T2_Vgm_si_Vdi_bi)+0.0)-T3_Vgm_si_Vdi_bi);
  psip_Vgm_si_Vsi_bi=(+(+(+T2_Vgm_si_Vsi_bi*T2+T2_Vgm_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_si+T2*T2_Vgm_si_Vsi_bi)+0.0)-T3_Vgm_si_Vsi_bi);
  psip_Vgm_si_Tempt_GND=(+(+(+T2_Vgm_si_Tempt_GND*T2+T2_Vgm_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_si+T2*T2_Vgm_si_Tempt_GND)+0.0)-T3_Vgm_si_Tempt_GND);
#endif
psip_Vdbulk_di=(((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di))-T3_Vdbulk_di);
#if defined(_DERIVATE2)
  psip_Vdbulk_di_Vgm_di=(+(+(+T2_Vdbulk_di_Vgm_di*T2+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_di)+0.0)-T3_Vdbulk_di_Vgm_di);
  psip_Vdbulk_di_Vgm_si=(+(+(+T2_Vdbulk_di_Vgm_si*T2+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_si)+0.0)-T3_Vdbulk_di_Vgm_si);
  psip_Vdbulk_di_Vdbulk_di=(+(+(+T2_Vdbulk_di_Vdbulk_di*T2+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdbulk_di)+0.0)-T3_Vdbulk_di_Vdbulk_di);
  psip_Vdbulk_di_Vsbulk_si=(+(+(+T2_Vdbulk_di_Vsbulk_si*T2+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsbulk_si)+0.0)-T3_Vdbulk_di_Vsbulk_si);
  psip_Vdbulk_di_Vgi_bi=(+(+(+T2_Vdbulk_di_Vgi_bi*T2+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgi_bi)+0.0)-T3_Vdbulk_di_Vgi_bi);
  psip_Vdbulk_di_Vdi_bi=(+(+(+T2_Vdbulk_di_Vdi_bi*T2+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdi_bi)+0.0)-T3_Vdbulk_di_Vdi_bi);
  psip_Vdbulk_di_Vsi_bi=(+(+(+T2_Vdbulk_di_Vsi_bi*T2+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsi_bi)+0.0)-T3_Vdbulk_di_Vsi_bi);
  psip_Vdbulk_di_Tempt_GND=(+(+(+T2_Vdbulk_di_Tempt_GND*T2+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*T2_Vdbulk_di_Tempt_GND)+0.0)-T3_Vdbulk_di_Tempt_GND);
#endif
psip_Vsbulk_si=(((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si))-T3_Vsbulk_si);
#if defined(_DERIVATE2)
  psip_Vsbulk_si_Vgm_di=(+(+(+T2_Vsbulk_si_Vgm_di*T2+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_di)+0.0)-T3_Vsbulk_si_Vgm_di);
  psip_Vsbulk_si_Vgm_si=(+(+(+T2_Vsbulk_si_Vgm_si*T2+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_si)+0.0)-T3_Vsbulk_si_Vgm_si);
  psip_Vsbulk_si_Vdbulk_di=(+(+(+T2_Vsbulk_si_Vdbulk_di*T2+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdbulk_di)+0.0)-T3_Vsbulk_si_Vdbulk_di);
  psip_Vsbulk_si_Vsbulk_si=(+(+(+T2_Vsbulk_si_Vsbulk_si*T2+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsbulk_si)+0.0)-T3_Vsbulk_si_Vsbulk_si);
  psip_Vsbulk_si_Vgi_bi=(+(+(+T2_Vsbulk_si_Vgi_bi*T2+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgi_bi)+0.0)-T3_Vsbulk_si_Vgi_bi);
  psip_Vsbulk_si_Vdi_bi=(+(+(+T2_Vsbulk_si_Vdi_bi*T2+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdi_bi)+0.0)-T3_Vsbulk_si_Vdi_bi);
  psip_Vsbulk_si_Vsi_bi=(+(+(+T2_Vsbulk_si_Vsi_bi*T2+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsi_bi)+0.0)-T3_Vsbulk_si_Vsi_bi);
  psip_Vsbulk_si_Tempt_GND=(+(+(+T2_Vsbulk_si_Tempt_GND*T2+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*T2_Vsbulk_si_Tempt_GND)+0.0)-T3_Vsbulk_si_Tempt_GND);
#endif
psip_Vgi_bi=(((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi))-T3_Vgi_bi);
#if defined(_DERIVATE2)
  psip_Vgi_bi_Vgm_di=(+(+(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di)+0.0)-T3_Vgi_bi_Vgm_di);
  psip_Vgi_bi_Vgm_si=(+(+(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si)+0.0)-T3_Vgi_bi_Vgm_si);
  psip_Vgi_bi_Vdbulk_di=(+(+(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di)+0.0)-T3_Vgi_bi_Vdbulk_di);
  psip_Vgi_bi_Vsbulk_si=(+(+(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si)+0.0)-T3_Vgi_bi_Vsbulk_si);
  psip_Vgi_bi_Vgi_bi=(+(+(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi)+0.0)-T3_Vgi_bi_Vgi_bi);
  psip_Vgi_bi_Vdi_bi=(+(+(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi)+0.0)-T3_Vgi_bi_Vdi_bi);
  psip_Vgi_bi_Vsi_bi=(+(+(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi)+0.0)-T3_Vgi_bi_Vsi_bi);
  psip_Vgi_bi_Tempt_GND=(+(+(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND)+0.0)-T3_Vgi_bi_Tempt_GND);
#endif
psip_Vdi_bi=(((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi))-T3_Vdi_bi);
#if defined(_DERIVATE2)
  psip_Vdi_bi_Vgm_di=(+(+(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di)+0.0)-T3_Vdi_bi_Vgm_di);
  psip_Vdi_bi_Vgm_si=(+(+(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si)+0.0)-T3_Vdi_bi_Vgm_si);
  psip_Vdi_bi_Vdbulk_di=(+(+(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di)+0.0)-T3_Vdi_bi_Vdbulk_di);
  psip_Vdi_bi_Vsbulk_si=(+(+(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si)+0.0)-T3_Vdi_bi_Vsbulk_si);
  psip_Vdi_bi_Vgi_bi=(+(+(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi)+0.0)-T3_Vdi_bi_Vgi_bi);
  psip_Vdi_bi_Vdi_bi=(+(+(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi)+0.0)-T3_Vdi_bi_Vdi_bi);
  psip_Vdi_bi_Vsi_bi=(+(+(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi)+0.0)-T3_Vdi_bi_Vsi_bi);
  psip_Vdi_bi_Tempt_GND=(+(+(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND)+0.0)-T3_Vdi_bi_Tempt_GND);
#endif
psip_Vsi_bi=(((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi))-T3_Vsi_bi);
#if defined(_DERIVATE2)
  psip_Vsi_bi_Vgm_di=(+(+(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di)+0.0)-T3_Vsi_bi_Vgm_di);
  psip_Vsi_bi_Vgm_si=(+(+(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si)+0.0)-T3_Vsi_bi_Vgm_si);
  psip_Vsi_bi_Vdbulk_di=(+(+(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di)+0.0)-T3_Vsi_bi_Vdbulk_di);
  psip_Vsi_bi_Vsbulk_si=(+(+(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si)+0.0)-T3_Vsi_bi_Vsbulk_si);
  psip_Vsi_bi_Vgi_bi=(+(+(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi)+0.0)-T3_Vsi_bi_Vgi_bi);
  psip_Vsi_bi_Vdi_bi=(+(+(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi)+0.0)-T3_Vsi_bi_Vdi_bi);
  psip_Vsi_bi_Vsi_bi=(+(+(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi)+0.0)-T3_Vsi_bi_Vsi_bi);
  psip_Vsi_bi_Tempt_GND=(+(+(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND)+0.0)-T3_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
psip_Tempt_GND=(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))-T3_Tempt_GND);
#endif
#endif
psip=(((T2*T2)+1.0)-T3);
EXIT_IF_ISNAN((((T2*T2)+1.0)-T3))
}
{
double m00_sqrt(d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=(0.5*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vgm_di-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vgm_di+psip_Vgm_di*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vgm_si-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vgm_si+psip_Vgm_si*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vgi_bi-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vgi_bi+psip_Vgi_bi*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vdi_bi-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vdi_bi+psip_Vdi_bi*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vsi_bi-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vsi_bi+psip_Vsi_bi*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Tempt_GND-0.0)*(psip-1.0)+psip_Vgm_di*psip_Tempt_GND+psip_Tempt_GND*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vgm_si=(0.5*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vgm_di-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vgm_di+psip_Vgm_di*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vgm_si-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vgm_si+psip_Vgm_si*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vgi_bi-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vgi_bi+psip_Vgi_bi*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vdi_bi-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vdi_bi+psip_Vdi_bi*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vsi_bi-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vsi_bi+psip_Vsi_bi*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Tempt_GND-0.0)*(psip-1.0)+psip_Vgm_si*psip_Tempt_GND+psip_Tempt_GND*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vdbulk_di=(0.5*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_di+psip_Vgm_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_si+psip_Vgm_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgi_bi+psip_Vgi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdi_bi+psip_Vdi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsi_bi+psip_Vsi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Tempt_GND-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Tempt_GND+psip_Tempt_GND*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsbulk_si=(0.5*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_di+psip_Vgm_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_si+psip_Vgm_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgi_bi+psip_Vgi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdi_bi+psip_Vdi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsi_bi+psip_Vsi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Tempt_GND-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Tempt_GND+psip_Tempt_GND*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vgi_bi=(0.5*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vdi_bi=(0.5*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsi_bi=(0.5*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(psip_Tempt_GND+((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((psip+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psip+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T8)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T8)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=T8_Vgm_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vgm_di);
  sqrtpsip_Vgm_di_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vgm_si);
  sqrtpsip_Vgm_di_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vdbulk_di);
  sqrtpsip_Vgm_di_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vsbulk_si);
  sqrtpsip_Vgm_di_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vgi_bi);
  sqrtpsip_Vgm_di_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vdi_bi);
  sqrtpsip_Vgm_di_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vsi_bi);
  sqrtpsip_Vgm_di_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Tempt_GND);
#endif
sqrtpsip_Vgm_si=T8_Vgm_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vgm_di);
  sqrtpsip_Vgm_si_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vgm_si);
  sqrtpsip_Vgm_si_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vdbulk_di);
  sqrtpsip_Vgm_si_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vsbulk_si);
  sqrtpsip_Vgm_si_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vgi_bi);
  sqrtpsip_Vgm_si_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vdi_bi);
  sqrtpsip_Vgm_si_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vsi_bi);
  sqrtpsip_Vgm_si_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Tempt_GND);
#endif
sqrtpsip_Vdbulk_di=T8_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_di);
  sqrtpsip_Vdbulk_di_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_si);
  sqrtpsip_Vdbulk_di_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdbulk_di);
  sqrtpsip_Vdbulk_di_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsbulk_si);
  sqrtpsip_Vdbulk_di_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgi_bi);
  sqrtpsip_Vdbulk_di_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdi_bi);
  sqrtpsip_Vdbulk_di_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsi_bi);
  sqrtpsip_Vdbulk_di_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Tempt_GND);
#endif
sqrtpsip_Vsbulk_si=T8_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_di);
  sqrtpsip_Vsbulk_si_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_si);
  sqrtpsip_Vsbulk_si_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdbulk_di);
  sqrtpsip_Vsbulk_si_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsbulk_si);
  sqrtpsip_Vsbulk_si_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgi_bi);
  sqrtpsip_Vsbulk_si_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdi_bi);
  sqrtpsip_Vsbulk_si_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsi_bi);
  sqrtpsip_Vsbulk_si_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Tempt_GND);
#endif
sqrtpsip_Vgi_bi=T8_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=T8_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=T8_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=T8_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=(+0.0+(gam_Vgm_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vdbulk_di=(+0.0+(gam_Vgm_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vsbulk_si=(+0.0+(gam_Vgm_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vdi_bi=(+0.0+(gam_Vgm_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vsi_bi=(+0.0+(gam_Vgm_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Tempt_GND=(+0.0+(gam_Vgm_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vgi_bi=(+0.0+(gam_Vgm_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vgm_di=(-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vdbulk_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vsbulk_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vdi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vsi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Tempt_GND=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vgi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vdbulk_di=((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=(+0.0+(gam_Vdbulk_di_Vgm_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdbulk_di=(+0.0+(gam_Vdbulk_di_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsbulk_si=(+0.0+(gam_Vdbulk_di_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdi_bi=(+0.0+(gam_Vdbulk_di_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsi_bi=(+0.0+(gam_Vdbulk_di_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Tempt_GND=(+0.0+(gam_Vdbulk_di_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgi_bi=(+0.0+(gam_Vdbulk_di_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsbulk_si=((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=(+0.0+(gam_Vsbulk_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdbulk_di=(+0.0+(gam_Vsbulk_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsbulk_si=(+0.0+(gam_Vsbulk_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdi_bi=(+0.0+(gam_Vsbulk_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsi_bi=(+0.0+(gam_Vsbulk_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Tempt_GND=(+0.0+(gam_Vsbulk_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgi_bi=(+0.0+(gam_Vsbulk_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vdi_bi=((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsi_bi=((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#endif
T9_Vgi_bi=((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#endif
T9=(1.0+(gam/(2.0*sqrtpsip)));
EXIT_IF_ISNAN((1.0+(gam/(2.0*sqrtpsip))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))/gam);
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*0.0/gam/gam/gam);
  T0_Vgm_di_Vgm_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vgm_si/gam/gam/gam);
  T0_Vgm_di_Vdbulk_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgm_di_Vsbulk_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgm_di_Vgi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vgi_bi/gam/gam/gam);
  T0_Vgm_di_Vdi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vdi_bi/gam/gam/gam);
  T0_Vgm_di_Vsi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vsi_bi/gam/gam/gam);
  T0_Vgm_di_Tempt_GND=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vgm_si=((((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*0.0/gam/gam/gam);
  T0_Vgm_si_Vgm_si=((+0.0+(gam_Vgm_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vgm_si/gam/gam/gam);
  T0_Vgm_si_Vdbulk_di=((+0.0+(gam_Vgm_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgm_si_Vsbulk_si=((+0.0+(gam_Vgm_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgm_si_Vgi_bi=((+0.0+(gam_Vgm_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vgi_bi/gam/gam/gam);
  T0_Vgm_si_Vdi_bi=((+0.0+(gam_Vgm_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vdi_bi/gam/gam/gam);
  T0_Vgm_si_Vsi_bi=((+0.0+(gam_Vgm_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vsi_bi/gam/gam/gam);
  T0_Vgm_si_Tempt_GND=((+0.0+(gam_Vgm_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vdbulk_di=((((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*0.0/gam/gam/gam);
  T0_Vdbulk_di_Vgm_si=((+0.0+(gam_Vdbulk_di_Vgm_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vgm_si/gam/gam/gam);
  T0_Vdbulk_di_Vdbulk_di=((+0.0+(gam_Vdbulk_di_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdbulk_di_Vsbulk_si=((+0.0+(gam_Vdbulk_di_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdbulk_di_Vgi_bi=((+0.0+(gam_Vdbulk_di_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vgi_bi/gam/gam/gam);
  T0_Vdbulk_di_Vdi_bi=((+0.0+(gam_Vdbulk_di_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vdi_bi/gam/gam/gam);
  T0_Vdbulk_di_Vsi_bi=((+0.0+(gam_Vdbulk_di_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vsi_bi/gam/gam/gam);
  T0_Vdbulk_di_Tempt_GND=((+0.0+(gam_Vdbulk_di_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsbulk_si=((((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*0.0/gam/gam/gam);
  T0_Vsbulk_si_Vgm_si=((+0.0+(gam_Vsbulk_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vgm_si/gam/gam/gam);
  T0_Vsbulk_si_Vdbulk_di=((+0.0+(gam_Vsbulk_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsbulk_si_Vsbulk_si=((+0.0+(gam_Vsbulk_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsbulk_si_Vgi_bi=((+0.0+(gam_Vsbulk_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vgi_bi/gam/gam/gam);
  T0_Vsbulk_si_Vdi_bi=((+0.0+(gam_Vsbulk_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vdi_bi/gam/gam/gam);
  T0_Vsbulk_si_Vsi_bi=((+0.0+(gam_Vsbulk_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vsi_bi/gam/gam/gam);
  T0_Vsbulk_si_Tempt_GND=((+0.0+(gam_Vsbulk_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vgi_bi=((((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*0.0/gam/gam/gam);
  T0_Vgi_bi_Vgm_si=((+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vgi_bi_Vdbulk_di=((+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgi_bi_Vsbulk_si=((+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgi_bi_Vgi_bi=((+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vgi_bi_Vdi_bi=((+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vgi_bi_Vsi_bi=((+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vgi_bi_Tempt_GND=((+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vdi_bi=((((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*0.0/gam/gam/gam);
  T0_Vdi_bi_Vgm_si=((+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vdi_bi_Vdbulk_di=((+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdi_bi_Vsbulk_si=((+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdi_bi_Vgi_bi=((+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vdi_bi_Vdi_bi=((+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vdi_bi_Vsi_bi=((+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vdi_bi_Tempt_GND=((+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsi_bi=((((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*0.0/gam/gam/gam);
  T0_Vsi_bi_Vgm_si=((+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vsi_bi_Vdbulk_di=((+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsi_bi_Vsbulk_si=((+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsi_bi_Vgi_bi=((+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vsi_bi_Vdi_bi=((+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vsi_bi_Vsi_bi=((+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vsi_bi_Tempt_GND=((+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Tempt_GND)/gam/gam);
#endif
#endif
T0=((1.0+(gam/(2.0*sqrtpsip)))/gam);
EXIT_IF_ISNAN(((1.0+(gam/(2.0*sqrtpsip)))/gam))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=psip_Vgm_di;
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=(+(+psip_Vgm_di_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*0.0+2.0*0.0))-0.0);
  T1_Vgm_di_Vgm_si=(+(+psip_Vgm_di_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*0.0+2.0*0.0))-0.0);
  T1_Vgm_di_Vdbulk_di=(+(+psip_Vgm_di_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*0.0+2.0*0.0))-0.0);
  T1_Vgm_di_Vsbulk_si=(+(+psip_Vgm_di_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*0.0+2.0*0.0))-0.0);
  T1_Vgm_di_Vgi_bi=(+(+psip_Vgm_di_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*0.0+2.0*0.0))-0.0);
  T1_Vgm_di_Vdi_bi=(+(+psip_Vgm_di_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*0.0+2.0*0.0))-0.0);
  T1_Vgm_di_Vsi_bi=(+(+psip_Vgm_di_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*0.0+2.0*0.0))-0.0);
  T1_Vgm_di_Tempt_GND=(+(+psip_Vgm_di_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*0.0+2.0*0.0))-0.0);
#endif
T1_Vgm_si=((psip_Vgm_si-(2.0*phib_n_Vgm_si))-vs_Vgm_si);
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=(+(+psip_Vgm_si_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vgm_si+2.0*0.0))-0.0);
  T1_Vgm_si_Vgm_si=(+(+psip_Vgm_si_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vgm_si))-vs_Vgm_si_Vgm_si);
  T1_Vgm_si_Vdbulk_di=(+(+psip_Vgm_si_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vdbulk_di))-vs_Vgm_si_Vdbulk_di);
  T1_Vgm_si_Vsbulk_si=(+(+psip_Vgm_si_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vsbulk_si))-vs_Vgm_si_Vsbulk_si);
  T1_Vgm_si_Vgi_bi=(+(+psip_Vgm_si_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vgi_bi))-vs_Vgm_si_Vgi_bi);
  T1_Vgm_si_Vdi_bi=(+(+psip_Vgm_si_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vdi_bi))-vs_Vgm_si_Vdi_bi);
  T1_Vgm_si_Vsi_bi=(+(+psip_Vgm_si_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vsi_bi))-vs_Vgm_si_Vsi_bi);
  T1_Vgm_si_Tempt_GND=(+(+psip_Vgm_si_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Tempt_GND))-vs_Vgm_si_Tempt_GND);
#endif
T1_Vdbulk_di=((psip_Vdbulk_di-(2.0*phib_n_Vdbulk_di))-vs_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+psip_Vdbulk_di_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vdbulk_di+2.0*0.0))-0.0);
  T1_Vdbulk_di_Vgm_si=(+(+psip_Vdbulk_di_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vgm_si))-vs_Vdbulk_di_Vgm_si);
  T1_Vdbulk_di_Vdbulk_di=(+(+psip_Vdbulk_di_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vdbulk_di))-vs_Vdbulk_di_Vdbulk_di);
  T1_Vdbulk_di_Vsbulk_si=(+(+psip_Vdbulk_di_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vsbulk_si))-vs_Vdbulk_di_Vsbulk_si);
  T1_Vdbulk_di_Vgi_bi=(+(+psip_Vdbulk_di_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vgi_bi))-vs_Vdbulk_di_Vgi_bi);
  T1_Vdbulk_di_Vdi_bi=(+(+psip_Vdbulk_di_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vdi_bi))-vs_Vdbulk_di_Vdi_bi);
  T1_Vdbulk_di_Vsi_bi=(+(+psip_Vdbulk_di_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vsi_bi))-vs_Vdbulk_di_Vsi_bi);
  T1_Vdbulk_di_Tempt_GND=(+(+psip_Vdbulk_di_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Tempt_GND))-vs_Vdbulk_di_Tempt_GND);
#endif
T1_Vsbulk_si=((psip_Vsbulk_si-(2.0*phib_n_Vsbulk_si))-vs_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+psip_Vsbulk_si_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vsbulk_si+2.0*0.0))-0.0);
  T1_Vsbulk_si_Vgm_si=(+(+psip_Vsbulk_si_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vgm_si))-vs_Vsbulk_si_Vgm_si);
  T1_Vsbulk_si_Vdbulk_di=(+(+psip_Vsbulk_si_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vdbulk_di))-vs_Vsbulk_si_Vdbulk_di);
  T1_Vsbulk_si_Vsbulk_si=(+(+psip_Vsbulk_si_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vsbulk_si))-vs_Vsbulk_si_Vsbulk_si);
  T1_Vsbulk_si_Vgi_bi=(+(+psip_Vsbulk_si_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vgi_bi))-vs_Vsbulk_si_Vgi_bi);
  T1_Vsbulk_si_Vdi_bi=(+(+psip_Vsbulk_si_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vdi_bi))-vs_Vsbulk_si_Vdi_bi);
  T1_Vsbulk_si_Vsi_bi=(+(+psip_Vsbulk_si_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vsi_bi))-vs_Vsbulk_si_Vsi_bi);
  T1_Vsbulk_si_Tempt_GND=(+(+psip_Vsbulk_si_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Tempt_GND))-vs_Vsbulk_si_Tempt_GND);
#endif
T1_Vgi_bi=((psip_Vgi_bi-(2.0*phib_n_Vgi_bi))-vs_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+psip_Vgi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vgi_bi+2.0*0.0))-0.0);
  T1_Vgi_bi_Vgm_si=(+(+psip_Vgi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vgm_si))-vs_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+(+psip_Vgi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vdbulk_di))-vs_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+(+psip_Vgi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vsbulk_si))-vs_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+(+psip_Vgi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vgi_bi))-vs_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+(+psip_Vgi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vdi_bi))-vs_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+(+psip_Vgi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vsi_bi))-vs_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+(+psip_Vgi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Tempt_GND))-vs_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=((psip_Vdi_bi-(2.0*phib_n_Vdi_bi))-vs_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+psip_Vdi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vdi_bi+2.0*0.0))-0.0);
  T1_Vdi_bi_Vgm_si=(+(+psip_Vdi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vgm_si))-vs_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+(+psip_Vdi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vdbulk_di))-vs_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+(+psip_Vdi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vsbulk_si))-vs_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+(+psip_Vdi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vgi_bi))-vs_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+(+psip_Vdi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vdi_bi))-vs_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+(+psip_Vdi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vsi_bi))-vs_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+(+psip_Vdi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Tempt_GND))-vs_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=((psip_Vsi_bi-(2.0*phib_n_Vsi_bi))-vs_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+psip_Vsi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vsi_bi+2.0*0.0))-0.0);
  T1_Vsi_bi_Vgm_si=(+(+psip_Vsi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vgm_si))-vs_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+(+psip_Vsi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vdbulk_di))-vs_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+(+psip_Vsi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vsbulk_si))-vs_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+(+psip_Vsi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vgi_bi))-vs_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+(+psip_Vsi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vdi_bi))-vs_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+(+psip_Vsi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vsi_bi))-vs_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+(+psip_Vsi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Tempt_GND))-vs_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((psip_Tempt_GND-(2.0*phib_n_Tempt_GND))-vs_Tempt_GND);
#endif
#endif
T1=((psip-(2.0*phib_n))-vs);
EXIT_IF_ISNAN(((psip-(2.0*phib_n))-vs))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=(T1_Vgm_di-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgm_di)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgm_di))));
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=(+T1_Vgm_di_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vgm_di)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vgm_di));
  T2_Vgm_di_Vgm_si=(+T1_Vgm_di_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vgm_si)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vgm_si));
  T2_Vgm_di_Vdbulk_di=(+T1_Vgm_di_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vdbulk_di));
  T2_Vgm_di_Vsbulk_si=(+T1_Vgm_di_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vsbulk_si));
  T2_Vgm_di_Vgi_bi=(+T1_Vgm_di_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vgi_bi)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vgi_bi));
  T2_Vgm_di_Vdi_bi=(+T1_Vgm_di_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vdi_bi)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vdi_bi));
  T2_Vgm_di_Vsi_bi=(+T1_Vgm_di_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vsi_bi)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vsi_bi));
  T2_Vgm_di_Tempt_GND=(+T1_Vgm_di_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Tempt_GND)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Tempt_GND));
#endif
T2_Vgm_si=(T1_Vgm_si-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgm_si)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgm_si))));
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=(+T1_Vgm_si_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vgm_di)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vgm_di));
  T2_Vgm_si_Vgm_si=(+T1_Vgm_si_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vgm_si)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vgm_si));
  T2_Vgm_si_Vdbulk_di=(+T1_Vgm_si_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vdbulk_di));
  T2_Vgm_si_Vsbulk_si=(+T1_Vgm_si_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vsbulk_si));
  T2_Vgm_si_Vgi_bi=(+T1_Vgm_si_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vgi_bi)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vgi_bi));
  T2_Vgm_si_Vdi_bi=(+T1_Vgm_si_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vdi_bi)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vdi_bi));
  T2_Vgm_si_Vsi_bi=(+T1_Vgm_si_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vsi_bi)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vsi_bi));
  T2_Vgm_si_Tempt_GND=(+T1_Vgm_si_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Tempt_GND)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Tempt_GND));
#endif
T2_Vdbulk_di=(T1_Vdbulk_di-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdbulk_di)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdbulk_di))));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+T1_Vdbulk_di_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_di));
  T2_Vdbulk_di_Vgm_si=(+T1_Vdbulk_di_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_si));
  T2_Vdbulk_di_Vdbulk_di=(+T1_Vdbulk_di_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdbulk_di));
  T2_Vdbulk_di_Vsbulk_si=(+T1_Vdbulk_di_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsbulk_si));
  T2_Vdbulk_di_Vgi_bi=(+T1_Vdbulk_di_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgi_bi));
  T2_Vdbulk_di_Vdi_bi=(+T1_Vdbulk_di_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdi_bi));
  T2_Vdbulk_di_Vsi_bi=(+T1_Vdbulk_di_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsi_bi));
  T2_Vdbulk_di_Tempt_GND=(+T1_Vdbulk_di_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Tempt_GND)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Tempt_GND));
#endif
T2_Vsbulk_si=(T1_Vsbulk_si-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsbulk_si)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsbulk_si))));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+T1_Vsbulk_si_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_di));
  T2_Vsbulk_si_Vgm_si=(+T1_Vsbulk_si_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_si));
  T2_Vsbulk_si_Vdbulk_di=(+T1_Vsbulk_si_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdbulk_di));
  T2_Vsbulk_si_Vsbulk_si=(+T1_Vsbulk_si_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsbulk_si));
  T2_Vsbulk_si_Vgi_bi=(+T1_Vsbulk_si_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgi_bi));
  T2_Vsbulk_si_Vdi_bi=(+T1_Vsbulk_si_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdi_bi));
  T2_Vsbulk_si_Vsi_bi=(+T1_Vsbulk_si_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsi_bi));
  T2_Vsbulk_si_Tempt_GND=(+T1_Vsbulk_si_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Tempt_GND)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Tempt_GND));
#endif
T2_Vgi_bi=(T1_Vgi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgi_bi))));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_di));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_si));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdbulk_di));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsbulk_si));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(T1_Vdi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdi_bi))));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_di));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_si));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdbulk_di));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsbulk_si));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(T1_Vsi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsi_bi))));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_di));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_si));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdbulk_di));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsbulk_si));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Tempt_GND)*sqrtpsip)+((4.0*T0)*sqrtpsip_Tempt_GND))));
#endif
#endif
T2=(T1-bsimbulk_lln(((4.0*T0)*sqrtpsip)));
EXIT_IF_ISNAN((T1-bsimbulk_lln(((4.0*T0)*sqrtpsip))))
{
double m00_sqrt(d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=(0.5*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vgm_di*(T2+0.402982)+T2_Vgm_di*T2_Vgm_di+T2_Vgm_di*T2_Vgm_di+T2*(+T2_Vgm_di_Vgm_di+0.0))+0.0))));
  T8_Vgm_di_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vgm_si*(T2+0.402982)+T2_Vgm_di*T2_Vgm_si+T2_Vgm_si*T2_Vgm_di+T2*(+T2_Vgm_di_Vgm_si+0.0))+0.0))));
  T8_Vgm_di_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vdbulk_di*(T2+0.402982)+T2_Vgm_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_di+T2*(+T2_Vgm_di_Vdbulk_di+0.0))+0.0))));
  T8_Vgm_di_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vsbulk_si*(T2+0.402982)+T2_Vgm_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_di+T2*(+T2_Vgm_di_Vsbulk_si+0.0))+0.0))));
  T8_Vgm_di_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vgi_bi*(T2+0.402982)+T2_Vgm_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_di+T2*(+T2_Vgm_di_Vgi_bi+0.0))+0.0))));
  T8_Vgm_di_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vdi_bi*(T2+0.402982)+T2_Vgm_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_di+T2*(+T2_Vgm_di_Vdi_bi+0.0))+0.0))));
  T8_Vgm_di_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vsi_bi*(T2+0.402982)+T2_Vgm_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_di+T2*(+T2_Vgm_di_Vsi_bi+0.0))+0.0))));
  T8_Vgm_di_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Tempt_GND*(T2+0.402982)+T2_Vgm_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_di+T2*(+T2_Vgm_di_Tempt_GND+0.0))+0.0))));
#endif
T8_Vgm_si=(0.5*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vgm_di*(T2+0.402982)+T2_Vgm_si*T2_Vgm_di+T2_Vgm_di*T2_Vgm_si+T2*(+T2_Vgm_si_Vgm_di+0.0))+0.0))));
  T8_Vgm_si_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vgm_si*(T2+0.402982)+T2_Vgm_si*T2_Vgm_si+T2_Vgm_si*T2_Vgm_si+T2*(+T2_Vgm_si_Vgm_si+0.0))+0.0))));
  T8_Vgm_si_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vdbulk_di*(T2+0.402982)+T2_Vgm_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_si+T2*(+T2_Vgm_si_Vdbulk_di+0.0))+0.0))));
  T8_Vgm_si_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vsbulk_si*(T2+0.402982)+T2_Vgm_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_si+T2*(+T2_Vgm_si_Vsbulk_si+0.0))+0.0))));
  T8_Vgm_si_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vgi_bi*(T2+0.402982)+T2_Vgm_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_si+T2*(+T2_Vgm_si_Vgi_bi+0.0))+0.0))));
  T8_Vgm_si_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vdi_bi*(T2+0.402982)+T2_Vgm_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_si+T2*(+T2_Vgm_si_Vdi_bi+0.0))+0.0))));
  T8_Vgm_si_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vsi_bi*(T2+0.402982)+T2_Vgm_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_si+T2*(+T2_Vgm_si_Vsi_bi+0.0))+0.0))));
  T8_Vgm_si_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Tempt_GND*(T2+0.402982)+T2_Vgm_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_si+T2*(+T2_Vgm_si_Tempt_GND+0.0))+0.0))));
#endif
T8_Vdbulk_di=(0.5*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_di+0.0))+0.0))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_si+0.0))+0.0))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdbulk_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdbulk_di+0.0))+0.0))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsbulk_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsbulk_si+0.0))+0.0))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Tempt_GND*(T2+0.402982)+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsbulk_si=(0.5*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_di+0.0))+0.0))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_si+0.0))+0.0))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdbulk_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdbulk_di+0.0))+0.0))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsbulk_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsbulk_si+0.0))+0.0))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Tempt_GND*(T2+0.402982)+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Tempt_GND+0.0))+0.0))));
#endif
T8_Vgi_bi=(0.5*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_di+0.0))+0.0))));
  T8_Vgi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_si+0.0))+0.0))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*(T2+0.402982)+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*(T2+0.402982)+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*(T2+0.402982)+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*(+T2_Vgi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vdi_bi=(0.5*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_di+0.0))+0.0))));
  T8_Vdi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_si+0.0))+0.0))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*(T2+0.402982)+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*(T2+0.402982)+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*(T2+0.402982)+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*(+T2_Vdi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsi_bi=(0.5*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_di+0.0))+0.0))));
  T8_Vsi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_si+0.0))+0.0))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*(T2+0.402982)+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*(T2+0.402982)+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*(T2+0.402982)+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*(+T2_Vsi_bi_Tempt_GND+0.0))+0.0))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(T2_Tempt_GND-((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((T2-0.201491)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T2-0.201491)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
sqrtpsisa_Vgm_di=sqrtpsip_Vgm_di;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_di_Vgm_di=sqrtpsip_Vgm_di_Vgm_di;
  sqrtpsisa_Vgm_di_Vgm_si=sqrtpsip_Vgm_di_Vgm_si;
  sqrtpsisa_Vgm_di_Vdbulk_di=sqrtpsip_Vgm_di_Vdbulk_di;
  sqrtpsisa_Vgm_di_Vsbulk_si=sqrtpsip_Vgm_di_Vsbulk_si;
  sqrtpsisa_Vgm_di_Vgi_bi=sqrtpsip_Vgm_di_Vgi_bi;
  sqrtpsisa_Vgm_di_Vdi_bi=sqrtpsip_Vgm_di_Vdi_bi;
  sqrtpsisa_Vgm_di_Vsi_bi=sqrtpsip_Vgm_di_Vsi_bi;
  sqrtpsisa_Vgm_di_Tempt_GND=sqrtpsip_Vgm_di_Tempt_GND;
#endif
sqrtpsisa_Vgm_si=sqrtpsip_Vgm_si;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_si_Vgm_di=sqrtpsip_Vgm_si_Vgm_di;
  sqrtpsisa_Vgm_si_Vgm_si=sqrtpsip_Vgm_si_Vgm_si;
  sqrtpsisa_Vgm_si_Vdbulk_di=sqrtpsip_Vgm_si_Vdbulk_di;
  sqrtpsisa_Vgm_si_Vsbulk_si=sqrtpsip_Vgm_si_Vsbulk_si;
  sqrtpsisa_Vgm_si_Vgi_bi=sqrtpsip_Vgm_si_Vgi_bi;
  sqrtpsisa_Vgm_si_Vdi_bi=sqrtpsip_Vgm_si_Vdi_bi;
  sqrtpsisa_Vgm_si_Vsi_bi=sqrtpsip_Vgm_si_Vsi_bi;
  sqrtpsisa_Vgm_si_Tempt_GND=sqrtpsip_Vgm_si_Tempt_GND;
#endif
sqrtpsisa_Vdbulk_di=sqrtpsip_Vdbulk_di;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdbulk_di_Vgm_di=sqrtpsip_Vdbulk_di_Vgm_di;
  sqrtpsisa_Vdbulk_di_Vgm_si=sqrtpsip_Vdbulk_di_Vgm_si;
  sqrtpsisa_Vdbulk_di_Vdbulk_di=sqrtpsip_Vdbulk_di_Vdbulk_di;
  sqrtpsisa_Vdbulk_di_Vsbulk_si=sqrtpsip_Vdbulk_di_Vsbulk_si;
  sqrtpsisa_Vdbulk_di_Vgi_bi=sqrtpsip_Vdbulk_di_Vgi_bi;
  sqrtpsisa_Vdbulk_di_Vdi_bi=sqrtpsip_Vdbulk_di_Vdi_bi;
  sqrtpsisa_Vdbulk_di_Vsi_bi=sqrtpsip_Vdbulk_di_Vsi_bi;
  sqrtpsisa_Vdbulk_di_Tempt_GND=sqrtpsip_Vdbulk_di_Tempt_GND;
#endif
sqrtpsisa_Vsbulk_si=sqrtpsip_Vsbulk_si;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsbulk_si_Vgm_di=sqrtpsip_Vsbulk_si_Vgm_di;
  sqrtpsisa_Vsbulk_si_Vgm_si=sqrtpsip_Vsbulk_si_Vgm_si;
  sqrtpsisa_Vsbulk_si_Vdbulk_di=sqrtpsip_Vsbulk_si_Vdbulk_di;
  sqrtpsisa_Vsbulk_si_Vsbulk_si=sqrtpsip_Vsbulk_si_Vsbulk_si;
  sqrtpsisa_Vsbulk_si_Vgi_bi=sqrtpsip_Vsbulk_si_Vgi_bi;
  sqrtpsisa_Vsbulk_si_Vdi_bi=sqrtpsip_Vsbulk_si_Vdi_bi;
  sqrtpsisa_Vsbulk_si_Vsi_bi=sqrtpsip_Vsbulk_si_Vsi_bi;
  sqrtpsisa_Vsbulk_si_Tempt_GND=sqrtpsip_Vsbulk_si_Tempt_GND;
#endif
sqrtpsisa_Vgi_bi=sqrtpsip_Vgi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgi_bi_Vgm_di=sqrtpsip_Vgi_bi_Vgm_di;
  sqrtpsisa_Vgi_bi_Vgm_si=sqrtpsip_Vgi_bi_Vgm_si;
  sqrtpsisa_Vgi_bi_Vdbulk_di=sqrtpsip_Vgi_bi_Vdbulk_di;
  sqrtpsisa_Vgi_bi_Vsbulk_si=sqrtpsip_Vgi_bi_Vsbulk_si;
  sqrtpsisa_Vgi_bi_Vgi_bi=sqrtpsip_Vgi_bi_Vgi_bi;
  sqrtpsisa_Vgi_bi_Vdi_bi=sqrtpsip_Vgi_bi_Vdi_bi;
  sqrtpsisa_Vgi_bi_Vsi_bi=sqrtpsip_Vgi_bi_Vsi_bi;
  sqrtpsisa_Vgi_bi_Tempt_GND=sqrtpsip_Vgi_bi_Tempt_GND;
#endif
sqrtpsisa_Vdi_bi=sqrtpsip_Vdi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdi_bi_Vgm_di=sqrtpsip_Vdi_bi_Vgm_di;
  sqrtpsisa_Vdi_bi_Vgm_si=sqrtpsip_Vdi_bi_Vgm_si;
  sqrtpsisa_Vdi_bi_Vdbulk_di=sqrtpsip_Vdi_bi_Vdbulk_di;
  sqrtpsisa_Vdi_bi_Vsbulk_si=sqrtpsip_Vdi_bi_Vsbulk_si;
  sqrtpsisa_Vdi_bi_Vgi_bi=sqrtpsip_Vdi_bi_Vgi_bi;
  sqrtpsisa_Vdi_bi_Vdi_bi=sqrtpsip_Vdi_bi_Vdi_bi;
  sqrtpsisa_Vdi_bi_Vsi_bi=sqrtpsip_Vdi_bi_Vsi_bi;
  sqrtpsisa_Vdi_bi_Tempt_GND=sqrtpsip_Vdi_bi_Tempt_GND;
#endif
sqrtpsisa_Vsi_bi=sqrtpsip_Vsi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsi_bi_Vgm_di=sqrtpsip_Vsi_bi_Vgm_di;
  sqrtpsisa_Vsi_bi_Vgm_si=sqrtpsip_Vsi_bi_Vgm_si;
  sqrtpsisa_Vsi_bi_Vdbulk_di=sqrtpsip_Vsi_bi_Vdbulk_di;
  sqrtpsisa_Vsi_bi_Vsbulk_si=sqrtpsip_Vsi_bi_Vsbulk_si;
  sqrtpsisa_Vsi_bi_Vgi_bi=sqrtpsip_Vsi_bi_Vgi_bi;
  sqrtpsisa_Vsi_bi_Vdi_bi=sqrtpsip_Vsi_bi_Vdi_bi;
  sqrtpsisa_Vsi_bi_Vsi_bi=sqrtpsip_Vsi_bi_Vsi_bi;
  sqrtpsisa_Vsi_bi_Tempt_GND=sqrtpsip_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
sqrtpsisa_Tempt_GND=sqrtpsip_Tempt_GND;
#endif
#endif
sqrtpsisa=sqrtpsip;
EXIT_IF_ISNAN(sqrtpsip)
if
((T8<=(-68.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=0.0;
#endif
#endif
T4=(-100.0);
EXIT_IF_ISNAN((-100.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=20.0;
EXIT_IF_ISNAN(20.0)
if
((T8<(T4-(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=0.0;
  T3_Vgm_si_Vgm_di=0.0;
  T3_Vgm_si_Vdbulk_di=0.0;
  T3_Vgm_si_Vsbulk_si=0.0;
  T3_Vgm_si_Vgi_bi=0.0;
  T3_Vgm_si_Vdi_bi=0.0;
  T3_Vgm_si_Vsi_bi=0.0;
  T3_Vgm_si_Tempt_GND=0.0;
#endif
T3_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=0.0;
  T3_Vgm_di_Vgm_di=0.0;
  T3_Vgm_di_Vdbulk_di=0.0;
  T3_Vgm_di_Vsbulk_si=0.0;
  T3_Vgm_di_Vgi_bi=0.0;
  T3_Vgm_di_Vdi_bi=0.0;
  T3_Vgm_di_Vsi_bi=0.0;
  T3_Vgm_di_Tempt_GND=0.0;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T4,T4_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T4_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T4_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T4_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T4_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T4_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T4_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T4_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T4_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T4,T4_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T4_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T4_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T4_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T4_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T4_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T4_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T4_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T4_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T4,T4_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T4_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T4_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T4_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T4_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T4_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T4_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T4_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T4_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T4,T4_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T4_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T4_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T4_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T4_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T4_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T4_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T4_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T4_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T4,T4_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T4_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T4_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T4_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T4_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T4_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T4_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T4_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T4_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T4,T4_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T4);
EXIT_IF_ISNAN(bsimbulk_lexp(T4))
}
else
{
if
((T8>(T4+(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=bsimbulk_d_lexp(T8,T8_Vgm_si);
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=T8_Vgm_si_Vgm_si;
  T3_Vgm_si_Vgm_di=T8_Vgm_si_Vgm_di;
  T3_Vgm_si_Vdbulk_di=T8_Vgm_si_Vdbulk_di;
  T3_Vgm_si_Vsbulk_si=T8_Vgm_si_Vsbulk_si;
  T3_Vgm_si_Vgi_bi=T8_Vgm_si_Vgi_bi;
  T3_Vgm_si_Vdi_bi=T8_Vgm_si_Vdi_bi;
  T3_Vgm_si_Vsi_bi=T8_Vgm_si_Vsi_bi;
  T3_Vgm_si_Tempt_GND=T8_Vgm_si_Tempt_GND;
#endif
T3_Vgm_di=bsimbulk_d_lexp(T8,T8_Vgm_di);
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=T8_Vgm_di_Vgm_si;
  T3_Vgm_di_Vgm_di=T8_Vgm_di_Vgm_di;
  T3_Vgm_di_Vdbulk_di=T8_Vgm_di_Vdbulk_di;
  T3_Vgm_di_Vsbulk_si=T8_Vgm_di_Vsbulk_si;
  T3_Vgm_di_Vgi_bi=T8_Vgm_di_Vgi_bi;
  T3_Vgm_di_Vdi_bi=T8_Vgm_di_Vdi_bi;
  T3_Vgm_di_Vsi_bi=T8_Vgm_di_Vsi_bi;
  T3_Vgm_di_Tempt_GND=T8_Vgm_di_Tempt_GND;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=(((T8_Vgm_di-T4_Vgm_di)*T5-(T8-T4)*T5_Vgm_di)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=((+T8_Vgm_di_Vgm_di-T4_Vgm_di_Vgm_di)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vgm_di/T5/T5/T5);
  T2_Vgm_di_Vgm_si=((+T8_Vgm_di_Vgm_si-T4_Vgm_di_Vgm_si)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vgm_si/T5/T5/T5);
  T2_Vgm_di_Vdbulk_di=((+T8_Vgm_di_Vdbulk_di-T4_Vgm_di_Vdbulk_di)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgm_di_Vsbulk_si=((+T8_Vgm_di_Vsbulk_si-T4_Vgm_di_Vsbulk_si)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgm_di_Vgi_bi=((+T8_Vgm_di_Vgi_bi-T4_Vgm_di_Vgi_bi)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vgi_bi/T5/T5/T5);
  T2_Vgm_di_Vdi_bi=((+T8_Vgm_di_Vdi_bi-T4_Vgm_di_Vdi_bi)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vdi_bi/T5/T5/T5);
  T2_Vgm_di_Vsi_bi=((+T8_Vgm_di_Vsi_bi-T4_Vgm_di_Vsi_bi)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vsi_bi/T5/T5/T5);
  T2_Vgm_di_Tempt_GND=((+T8_Vgm_di_Tempt_GND-T4_Vgm_di_Tempt_GND)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vgm_si=(((T8_Vgm_si-T4_Vgm_si)*T5-(T8-T4)*T5_Vgm_si)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=((+T8_Vgm_si_Vgm_di-T4_Vgm_si_Vgm_di)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vgm_di/T5/T5/T5);
  T2_Vgm_si_Vgm_si=((+T8_Vgm_si_Vgm_si-T4_Vgm_si_Vgm_si)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vgm_si/T5/T5/T5);
  T2_Vgm_si_Vdbulk_di=((+T8_Vgm_si_Vdbulk_di-T4_Vgm_si_Vdbulk_di)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgm_si_Vsbulk_si=((+T8_Vgm_si_Vsbulk_si-T4_Vgm_si_Vsbulk_si)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgm_si_Vgi_bi=((+T8_Vgm_si_Vgi_bi-T4_Vgm_si_Vgi_bi)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vgi_bi/T5/T5/T5);
  T2_Vgm_si_Vdi_bi=((+T8_Vgm_si_Vdi_bi-T4_Vgm_si_Vdi_bi)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vdi_bi/T5/T5/T5);
  T2_Vgm_si_Vsi_bi=((+T8_Vgm_si_Vsi_bi-T4_Vgm_si_Vsi_bi)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vsi_bi/T5/T5/T5);
  T2_Vgm_si_Tempt_GND=((+T8_Vgm_si_Tempt_GND-T4_Vgm_si_Tempt_GND)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vdbulk_di=(((T8_Vdbulk_di-T4_Vdbulk_di)*T5-(T8-T4)*T5_Vdbulk_di)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=((+T8_Vdbulk_di_Vgm_di-T4_Vdbulk_di_Vgm_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5);
  T2_Vdbulk_di_Vgm_si=((+T8_Vdbulk_di_Vgm_si-T4_Vdbulk_di_Vgm_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5);
  T2_Vdbulk_di_Vdbulk_di=((+T8_Vdbulk_di_Vdbulk_di-T4_Vdbulk_di_Vdbulk_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdbulk_di_Vsbulk_si=((+T8_Vdbulk_di_Vsbulk_si-T4_Vdbulk_di_Vsbulk_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdbulk_di_Vgi_bi=((+T8_Vdbulk_di_Vgi_bi-T4_Vdbulk_di_Vgi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vdi_bi=((+T8_Vdbulk_di_Vdi_bi-T4_Vdbulk_di_Vdi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vsi_bi=((+T8_Vdbulk_di_Vsi_bi-T4_Vdbulk_di_Vsi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5);
  T2_Vdbulk_di_Tempt_GND=((+T8_Vdbulk_di_Tempt_GND-T4_Vdbulk_di_Tempt_GND)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsbulk_si=(((T8_Vsbulk_si-T4_Vsbulk_si)*T5-(T8-T4)*T5_Vsbulk_si)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=((+T8_Vsbulk_si_Vgm_di-T4_Vsbulk_si_Vgm_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5);
  T2_Vsbulk_si_Vgm_si=((+T8_Vsbulk_si_Vgm_si-T4_Vsbulk_si_Vgm_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5);
  T2_Vsbulk_si_Vdbulk_di=((+T8_Vsbulk_si_Vdbulk_di-T4_Vsbulk_si_Vdbulk_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsbulk_si_Vsbulk_si=((+T8_Vsbulk_si_Vsbulk_si-T4_Vsbulk_si_Vsbulk_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsbulk_si_Vgi_bi=((+T8_Vsbulk_si_Vgi_bi-T4_Vsbulk_si_Vgi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vdi_bi=((+T8_Vsbulk_si_Vdi_bi-T4_Vsbulk_si_Vdi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vsi_bi=((+T8_Vsbulk_si_Vsi_bi-T4_Vsbulk_si_Vsi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5);
  T2_Vsbulk_si_Tempt_GND=((+T8_Vsbulk_si_Tempt_GND-T4_Vsbulk_si_Tempt_GND)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vgi_bi=(((T8_Vgi_bi-T4_Vgi_bi)*T5-(T8-T4)*T5_Vgi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=((+T8_Vgi_bi_Vgm_di-T4_Vgi_bi_Vgm_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vgi_bi_Vgm_si=((+T8_Vgi_bi_Vgm_si-T4_Vgi_bi_Vgm_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vgi_bi_Vdbulk_di=((+T8_Vgi_bi_Vdbulk_di-T4_Vgi_bi_Vdbulk_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgi_bi_Vsbulk_si=((+T8_Vgi_bi_Vsbulk_si-T4_Vgi_bi_Vsbulk_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgi_bi_Vgi_bi=((+T8_Vgi_bi_Vgi_bi-T4_Vgi_bi_Vgi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vgi_bi_Vdi_bi=((+T8_Vgi_bi_Vdi_bi-T4_Vgi_bi_Vdi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vgi_bi_Vsi_bi=((+T8_Vgi_bi_Vsi_bi-T4_Vgi_bi_Vsi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vgi_bi_Tempt_GND=((+T8_Vgi_bi_Tempt_GND-T4_Vgi_bi_Tempt_GND)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vdi_bi=(((T8_Vdi_bi-T4_Vdi_bi)*T5-(T8-T4)*T5_Vdi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=((+T8_Vdi_bi_Vgm_di-T4_Vdi_bi_Vgm_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vdi_bi_Vgm_si=((+T8_Vdi_bi_Vgm_si-T4_Vdi_bi_Vgm_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vdi_bi_Vdbulk_di=((+T8_Vdi_bi_Vdbulk_di-T4_Vdi_bi_Vdbulk_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdi_bi_Vsbulk_si=((+T8_Vdi_bi_Vsbulk_si-T4_Vdi_bi_Vsbulk_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdi_bi_Vgi_bi=((+T8_Vdi_bi_Vgi_bi-T4_Vdi_bi_Vgi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vdi_bi_Vdi_bi=((+T8_Vdi_bi_Vdi_bi-T4_Vdi_bi_Vdi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vdi_bi_Vsi_bi=((+T8_Vdi_bi_Vsi_bi-T4_Vdi_bi_Vsi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vdi_bi_Tempt_GND=((+T8_Vdi_bi_Tempt_GND-T4_Vdi_bi_Tempt_GND)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsi_bi=(((T8_Vsi_bi-T4_Vsi_bi)*T5-(T8-T4)*T5_Vsi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=((+T8_Vsi_bi_Vgm_di-T4_Vsi_bi_Vgm_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vsi_bi_Vgm_si=((+T8_Vsi_bi_Vgm_si-T4_Vsi_bi_Vgm_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vsi_bi_Vdbulk_di=((+T8_Vsi_bi_Vdbulk_di-T4_Vsi_bi_Vdbulk_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsi_bi_Vsbulk_si=((+T8_Vsi_bi_Vsbulk_si-T4_Vsi_bi_Vsbulk_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsi_bi_Vgi_bi=((+T8_Vsi_bi_Vgi_bi-T4_Vsi_bi_Vgi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vsi_bi_Vdi_bi=((+T8_Vsi_bi_Vdi_bi-T4_Vsi_bi_Vdi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vsi_bi_Vsi_bi=((+T8_Vsi_bi_Vsi_bi-T4_Vsi_bi_Vsi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vsi_bi_Tempt_GND=((+T8_Vsi_bi_Tempt_GND-T4_Vsi_bi_Tempt_GND)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((T8_Tempt_GND-T4_Tempt_GND)*T5-(T8-T4)*T5_Tempt_GND)/T5/T5);
#endif
#endif
T2=((T8-T4)/T5);
EXIT_IF_ISNAN(((T8-T4)/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=((T2_Vgm_di*T2)+(T2*T2_Vgm_di));
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=(+T2_Vgm_di_Vgm_di*T2+T2_Vgm_di*T2_Vgm_di+T2_Vgm_di*T2_Vgm_di+T2*T2_Vgm_di_Vgm_di);
  T6_Vgm_di_Vgm_si=(+T2_Vgm_di_Vgm_si*T2+T2_Vgm_di*T2_Vgm_si+T2_Vgm_si*T2_Vgm_di+T2*T2_Vgm_di_Vgm_si);
  T6_Vgm_di_Vdbulk_di=(+T2_Vgm_di_Vdbulk_di*T2+T2_Vgm_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_di+T2*T2_Vgm_di_Vdbulk_di);
  T6_Vgm_di_Vsbulk_si=(+T2_Vgm_di_Vsbulk_si*T2+T2_Vgm_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_di+T2*T2_Vgm_di_Vsbulk_si);
  T6_Vgm_di_Vgi_bi=(+T2_Vgm_di_Vgi_bi*T2+T2_Vgm_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_di+T2*T2_Vgm_di_Vgi_bi);
  T6_Vgm_di_Vdi_bi=(+T2_Vgm_di_Vdi_bi*T2+T2_Vgm_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_di+T2*T2_Vgm_di_Vdi_bi);
  T6_Vgm_di_Vsi_bi=(+T2_Vgm_di_Vsi_bi*T2+T2_Vgm_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_di+T2*T2_Vgm_di_Vsi_bi);
  T6_Vgm_di_Tempt_GND=(+T2_Vgm_di_Tempt_GND*T2+T2_Vgm_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_di+T2*T2_Vgm_di_Tempt_GND);
#endif
T6_Vgm_si=((T2_Vgm_si*T2)+(T2*T2_Vgm_si));
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=(+T2_Vgm_si_Vgm_di*T2+T2_Vgm_si*T2_Vgm_di+T2_Vgm_di*T2_Vgm_si+T2*T2_Vgm_si_Vgm_di);
  T6_Vgm_si_Vgm_si=(+T2_Vgm_si_Vgm_si*T2+T2_Vgm_si*T2_Vgm_si+T2_Vgm_si*T2_Vgm_si+T2*T2_Vgm_si_Vgm_si);
  T6_Vgm_si_Vdbulk_di=(+T2_Vgm_si_Vdbulk_di*T2+T2_Vgm_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_si+T2*T2_Vgm_si_Vdbulk_di);
  T6_Vgm_si_Vsbulk_si=(+T2_Vgm_si_Vsbulk_si*T2+T2_Vgm_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_si+T2*T2_Vgm_si_Vsbulk_si);
  T6_Vgm_si_Vgi_bi=(+T2_Vgm_si_Vgi_bi*T2+T2_Vgm_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_si+T2*T2_Vgm_si_Vgi_bi);
  T6_Vgm_si_Vdi_bi=(+T2_Vgm_si_Vdi_bi*T2+T2_Vgm_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_si+T2*T2_Vgm_si_Vdi_bi);
  T6_Vgm_si_Vsi_bi=(+T2_Vgm_si_Vsi_bi*T2+T2_Vgm_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_si+T2*T2_Vgm_si_Vsi_bi);
  T6_Vgm_si_Tempt_GND=(+T2_Vgm_si_Tempt_GND*T2+T2_Vgm_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_si+T2*T2_Vgm_si_Tempt_GND);
#endif
T6_Vdbulk_di=((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+T2_Vdbulk_di_Vgm_di*T2+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_di);
  T6_Vdbulk_di_Vgm_si=(+T2_Vdbulk_di_Vgm_si*T2+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_si);
  T6_Vdbulk_di_Vdbulk_di=(+T2_Vdbulk_di_Vdbulk_di*T2+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdbulk_di);
  T6_Vdbulk_di_Vsbulk_si=(+T2_Vdbulk_di_Vsbulk_si*T2+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsbulk_si);
  T6_Vdbulk_di_Vgi_bi=(+T2_Vdbulk_di_Vgi_bi*T2+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgi_bi);
  T6_Vdbulk_di_Vdi_bi=(+T2_Vdbulk_di_Vdi_bi*T2+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdi_bi);
  T6_Vdbulk_di_Vsi_bi=(+T2_Vdbulk_di_Vsi_bi*T2+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsi_bi);
  T6_Vdbulk_di_Tempt_GND=(+T2_Vdbulk_di_Tempt_GND*T2+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*T2_Vdbulk_di_Tempt_GND);
#endif
T6_Vsbulk_si=((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+T2_Vsbulk_si_Vgm_di*T2+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_di);
  T6_Vsbulk_si_Vgm_si=(+T2_Vsbulk_si_Vgm_si*T2+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_si);
  T6_Vsbulk_si_Vdbulk_di=(+T2_Vsbulk_si_Vdbulk_di*T2+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdbulk_di);
  T6_Vsbulk_si_Vsbulk_si=(+T2_Vsbulk_si_Vsbulk_si*T2+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsbulk_si);
  T6_Vsbulk_si_Vgi_bi=(+T2_Vsbulk_si_Vgi_bi*T2+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgi_bi);
  T6_Vsbulk_si_Vdi_bi=(+T2_Vsbulk_si_Vdi_bi*T2+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdi_bi);
  T6_Vsbulk_si_Vsi_bi=(+T2_Vsbulk_si_Vsi_bi*T2+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsi_bi);
  T6_Vsbulk_si_Tempt_GND=(+T2_Vsbulk_si_Tempt_GND*T2+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*T2_Vsbulk_si_Tempt_GND);
#endif
T6_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND));
#endif
#endif
T6=(T2*T2);
EXIT_IF_ISNAN((T2*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgm_si+((T5_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))));
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=(+T4_Vgm_si_Vgm_si+(+T5_Vgm_si_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vgm_si))+(+T6_Vgm_si_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vgm_si*(1.25-T6)+T6_Vgm_si*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vgm_si)))))));
  T3_Vgm_si_Vgm_di=(+T4_Vgm_si_Vgm_di+(+T5_Vgm_si_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vgm_di))+(+T6_Vgm_si_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vgm_di*(1.25-T6)+T6_Vgm_si*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vgm_di)))))));
  T3_Vgm_si_Vdbulk_di=(+T4_Vgm_si_Vdbulk_di+(+T5_Vgm_si_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vdbulk_di))+(+T6_Vgm_si_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vdbulk_di*(1.25-T6)+T6_Vgm_si*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vdbulk_di)))))));
  T3_Vgm_si_Vsbulk_si=(+T4_Vgm_si_Vsbulk_si+(+T5_Vgm_si_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vsbulk_si))+(+T6_Vgm_si_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vsbulk_si*(1.25-T6)+T6_Vgm_si*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vsbulk_si)))))));
  T3_Vgm_si_Vgi_bi=(+T4_Vgm_si_Vgi_bi+(+T5_Vgm_si_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vgi_bi))+(+T6_Vgm_si_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vgi_bi*(1.25-T6)+T6_Vgm_si*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vgi_bi)))))));
  T3_Vgm_si_Vdi_bi=(+T4_Vgm_si_Vdi_bi+(+T5_Vgm_si_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vdi_bi))+(+T6_Vgm_si_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vdi_bi*(1.25-T6)+T6_Vgm_si*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vdi_bi)))))));
  T3_Vgm_si_Vsi_bi=(+T4_Vgm_si_Vsi_bi+(+T5_Vgm_si_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vsi_bi))+(+T6_Vgm_si_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vsi_bi*(1.25-T6)+T6_Vgm_si*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vsi_bi)))))));
  T3_Vgm_si_Tempt_GND=(+T4_Vgm_si_Tempt_GND+(+T5_Vgm_si_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Tempt_GND))+(+T6_Vgm_si_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Tempt_GND*(1.25-T6)+T6_Vgm_si*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Tempt_GND)))))));
#endif
T3_Vgm_di=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgm_di+((T5_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))));
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=(+T4_Vgm_di_Vgm_si+(+T5_Vgm_di_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vgm_si))+(+T6_Vgm_di_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vgm_si*(1.25-T6)+T6_Vgm_di*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vgm_si)))))));
  T3_Vgm_di_Vgm_di=(+T4_Vgm_di_Vgm_di+(+T5_Vgm_di_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vgm_di))+(+T6_Vgm_di_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vgm_di*(1.25-T6)+T6_Vgm_di*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vgm_di)))))));
  T3_Vgm_di_Vdbulk_di=(+T4_Vgm_di_Vdbulk_di+(+T5_Vgm_di_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vdbulk_di))+(+T6_Vgm_di_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vdbulk_di*(1.25-T6)+T6_Vgm_di*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vdbulk_di)))))));
  T3_Vgm_di_Vsbulk_si=(+T4_Vgm_di_Vsbulk_si+(+T5_Vgm_di_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vsbulk_si))+(+T6_Vgm_di_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vsbulk_si*(1.25-T6)+T6_Vgm_di*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vsbulk_si)))))));
  T3_Vgm_di_Vgi_bi=(+T4_Vgm_di_Vgi_bi+(+T5_Vgm_di_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vgi_bi))+(+T6_Vgm_di_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vgi_bi*(1.25-T6)+T6_Vgm_di*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vgi_bi)))))));
  T3_Vgm_di_Vdi_bi=(+T4_Vgm_di_Vdi_bi+(+T5_Vgm_di_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vdi_bi))+(+T6_Vgm_di_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vdi_bi*(1.25-T6)+T6_Vgm_di*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vdi_bi)))))));
  T3_Vgm_di_Vsi_bi=(+T4_Vgm_di_Vsi_bi+(+T5_Vgm_di_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vsi_bi))+(+T6_Vgm_di_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vsi_bi*(1.25-T6)+T6_Vgm_di*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vsi_bi)))))));
  T3_Vgm_di_Tempt_GND=(+T4_Vgm_di_Tempt_GND+(+T5_Vgm_di_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Tempt_GND))+(+T6_Vgm_di_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Tempt_GND*(1.25-T6)+T6_Vgm_di*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Tempt_GND)))))));
#endif
T3_Vdbulk_di=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdbulk_di+((T5_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T4_Vdbulk_di_Vgm_si+(+T5_Vdbulk_di_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_si))+(+T6_Vdbulk_di_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_si)))))));
  T3_Vdbulk_di_Vgm_di=(+T4_Vdbulk_di_Vgm_di+(+T5_Vdbulk_di_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_di))+(+T6_Vdbulk_di_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_di)))))));
  T3_Vdbulk_di_Vdbulk_di=(+T4_Vdbulk_di_Vdbulk_di+(+T5_Vdbulk_di_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdbulk_di))+(+T6_Vdbulk_di_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdbulk_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdbulk_di)))))));
  T3_Vdbulk_di_Vsbulk_si=(+T4_Vdbulk_di_Vsbulk_si+(+T5_Vdbulk_di_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsbulk_si))+(+T6_Vdbulk_di_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsbulk_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsbulk_si)))))));
  T3_Vdbulk_di_Vgi_bi=(+T4_Vdbulk_di_Vgi_bi+(+T5_Vdbulk_di_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgi_bi))+(+T6_Vdbulk_di_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgi_bi)))))));
  T3_Vdbulk_di_Vdi_bi=(+T4_Vdbulk_di_Vdi_bi+(+T5_Vdbulk_di_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdi_bi))+(+T6_Vdbulk_di_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdi_bi)))))));
  T3_Vdbulk_di_Vsi_bi=(+T4_Vdbulk_di_Vsi_bi+(+T5_Vdbulk_di_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsi_bi))+(+T6_Vdbulk_di_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsi_bi)))))));
  T3_Vdbulk_di_Tempt_GND=(+T4_Vdbulk_di_Tempt_GND+(+T5_Vdbulk_di_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Tempt_GND))+(+T6_Vdbulk_di_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Tempt_GND*(1.25-T6)+T6_Vdbulk_di*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Tempt_GND)))))));
#endif
T3_Vsbulk_si=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsbulk_si+((T5_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T4_Vsbulk_si_Vgm_si+(+T5_Vsbulk_si_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_si))+(+T6_Vsbulk_si_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_si)))))));
  T3_Vsbulk_si_Vgm_di=(+T4_Vsbulk_si_Vgm_di+(+T5_Vsbulk_si_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_di))+(+T6_Vsbulk_si_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_di)))))));
  T3_Vsbulk_si_Vdbulk_di=(+T4_Vsbulk_si_Vdbulk_di+(+T5_Vsbulk_si_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdbulk_di))+(+T6_Vsbulk_si_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdbulk_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdbulk_di)))))));
  T3_Vsbulk_si_Vsbulk_si=(+T4_Vsbulk_si_Vsbulk_si+(+T5_Vsbulk_si_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsbulk_si))+(+T6_Vsbulk_si_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsbulk_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsbulk_si)))))));
  T3_Vsbulk_si_Vgi_bi=(+T4_Vsbulk_si_Vgi_bi+(+T5_Vsbulk_si_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgi_bi))+(+T6_Vsbulk_si_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgi_bi)))))));
  T3_Vsbulk_si_Vdi_bi=(+T4_Vsbulk_si_Vdi_bi+(+T5_Vsbulk_si_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdi_bi))+(+T6_Vsbulk_si_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdi_bi)))))));
  T3_Vsbulk_si_Vsi_bi=(+T4_Vsbulk_si_Vsi_bi+(+T5_Vsbulk_si_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsi_bi))+(+T6_Vsbulk_si_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsi_bi)))))));
  T3_Vsbulk_si_Tempt_GND=(+T4_Vsbulk_si_Tempt_GND+(+T5_Vsbulk_si_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Tempt_GND))+(+T6_Vsbulk_si_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Tempt_GND*(1.25-T6)+T6_Vsbulk_si*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Tempt_GND)))))));
#endif
T3_Vgi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgi_bi+((T5_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T4_Vgi_bi_Vgm_si+(+T5_Vgi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_si))+(+T6_Vgi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_si)))))));
  T3_Vgi_bi_Vgm_di=(+T4_Vgi_bi_Vgm_di+(+T5_Vgi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_di))+(+T6_Vgi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_di)))))));
  T3_Vgi_bi_Vdbulk_di=(+T4_Vgi_bi_Vdbulk_di+(+T5_Vgi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdbulk_di))+(+T6_Vgi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdbulk_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdbulk_di)))))));
  T3_Vgi_bi_Vsbulk_si=(+T4_Vgi_bi_Vsbulk_si+(+T5_Vgi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsbulk_si))+(+T6_Vgi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsbulk_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsbulk_si)))))));
  T3_Vgi_bi_Vgi_bi=(+T4_Vgi_bi_Vgi_bi+(+T5_Vgi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgi_bi))+(+T6_Vgi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgi_bi)))))));
  T3_Vgi_bi_Vdi_bi=(+T4_Vgi_bi_Vdi_bi+(+T5_Vgi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdi_bi))+(+T6_Vgi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdi_bi)))))));
  T3_Vgi_bi_Vsi_bi=(+T4_Vgi_bi_Vsi_bi+(+T5_Vgi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsi_bi))+(+T6_Vgi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsi_bi)))))));
  T3_Vgi_bi_Tempt_GND=(+T4_Vgi_bi_Tempt_GND+(+T5_Vgi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Tempt_GND))+(+T6_Vgi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Tempt_GND*(1.25-T6)+T6_Vgi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Tempt_GND)))))));
#endif
T3_Vdi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdi_bi+((T5_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T4_Vdi_bi_Vgm_si+(+T5_Vdi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_si))+(+T6_Vdi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_si)))))));
  T3_Vdi_bi_Vgm_di=(+T4_Vdi_bi_Vgm_di+(+T5_Vdi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_di))+(+T6_Vdi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_di)))))));
  T3_Vdi_bi_Vdbulk_di=(+T4_Vdi_bi_Vdbulk_di+(+T5_Vdi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdbulk_di))+(+T6_Vdi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdbulk_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdbulk_di)))))));
  T3_Vdi_bi_Vsbulk_si=(+T4_Vdi_bi_Vsbulk_si+(+T5_Vdi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsbulk_si))+(+T6_Vdi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsbulk_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsbulk_si)))))));
  T3_Vdi_bi_Vgi_bi=(+T4_Vdi_bi_Vgi_bi+(+T5_Vdi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgi_bi))+(+T6_Vdi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgi_bi)))))));
  T3_Vdi_bi_Vdi_bi=(+T4_Vdi_bi_Vdi_bi+(+T5_Vdi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdi_bi))+(+T6_Vdi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdi_bi)))))));
  T3_Vdi_bi_Vsi_bi=(+T4_Vdi_bi_Vsi_bi+(+T5_Vdi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsi_bi))+(+T6_Vdi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsi_bi)))))));
  T3_Vdi_bi_Tempt_GND=(+T4_Vdi_bi_Tempt_GND+(+T5_Vdi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Tempt_GND))+(+T6_Vdi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Tempt_GND*(1.25-T6)+T6_Vdi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Tempt_GND)))))));
#endif
T3_Vsi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsi_bi+((T5_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T4_Vsi_bi_Vgm_si+(+T5_Vsi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_si))+(+T6_Vsi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_si)))))));
  T3_Vsi_bi_Vgm_di=(+T4_Vsi_bi_Vgm_di+(+T5_Vsi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_di))+(+T6_Vsi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_di)))))));
  T3_Vsi_bi_Vdbulk_di=(+T4_Vsi_bi_Vdbulk_di+(+T5_Vsi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdbulk_di))+(+T6_Vsi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdbulk_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdbulk_di)))))));
  T3_Vsi_bi_Vsbulk_si=(+T4_Vsi_bi_Vsbulk_si+(+T5_Vsi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsbulk_si))+(+T6_Vsi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsbulk_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsbulk_si)))))));
  T3_Vsi_bi_Vgi_bi=(+T4_Vsi_bi_Vgi_bi+(+T5_Vsi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgi_bi))+(+T6_Vsi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgi_bi)))))));
  T3_Vsi_bi_Vdi_bi=(+T4_Vsi_bi_Vdi_bi+(+T5_Vsi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdi_bi))+(+T6_Vsi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdi_bi)))))));
  T3_Vsi_bi_Vsi_bi=(+T4_Vsi_bi_Vsi_bi+(+T5_Vsi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsi_bi))+(+T6_Vsi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsi_bi)))))));
  T3_Vsi_bi_Tempt_GND=(+T4_Vsi_bi_Tempt_GND+(+T5_Vsi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Tempt_GND))+(+T6_Vsi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Tempt_GND*(1.25-T6)+T6_Vsi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Tempt_GND)))))));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Tempt_GND+((T5_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Tempt_GND)+((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))));
#endif
#endif
T3=bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
EXIT_IF_ISNAN(bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qs_Vgm_si=((T3_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))));
#if defined(_DERIVATE2)
  qs_Vgm_si_Vgm_si=(+T3_Vgm_si_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vgm_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vgm_si)-T8_Vgm_si_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_si)))));
  qs_Vgm_si_Vgm_di=(+T3_Vgm_si_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vgm_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vgm_di)-T8_Vgm_si_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_di)))));
  qs_Vgm_si_Vdbulk_di=(+T3_Vgm_si_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vdbulk_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vdbulk_di)-T8_Vgm_si_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdbulk_di)))));
  qs_Vgm_si_Vsbulk_si=(+T3_Vgm_si_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vsbulk_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vsbulk_si)-T8_Vgm_si_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsbulk_si)))));
  qs_Vgm_si_Vgi_bi=(+T3_Vgm_si_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vgi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vgi_bi)-T8_Vgm_si_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgi_bi)))));
  qs_Vgm_si_Vdi_bi=(+T3_Vgm_si_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vdi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vdi_bi)-T8_Vgm_si_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdi_bi)))));
  qs_Vgm_si_Vsi_bi=(+T3_Vgm_si_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vsi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vsi_bi)-T8_Vgm_si_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsi_bi)))));
  qs_Vgm_si_Tempt_GND=(+T3_Vgm_si_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Tempt_GND*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Tempt_GND)-T8_Vgm_si_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Tempt_GND)))));
#endif
qs_Vgm_di=((T3_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))));
#if defined(_DERIVATE2)
  qs_Vgm_di_Vgm_si=(+T3_Vgm_di_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vgm_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vgm_si)-T8_Vgm_di_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_si)))));
  qs_Vgm_di_Vgm_di=(+T3_Vgm_di_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vgm_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vgm_di)-T8_Vgm_di_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_di)))));
  qs_Vgm_di_Vdbulk_di=(+T3_Vgm_di_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vdbulk_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vdbulk_di)-T8_Vgm_di_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdbulk_di)))));
  qs_Vgm_di_Vsbulk_si=(+T3_Vgm_di_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vsbulk_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vsbulk_si)-T8_Vgm_di_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsbulk_si)))));
  qs_Vgm_di_Vgi_bi=(+T3_Vgm_di_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vgi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vgi_bi)-T8_Vgm_di_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgi_bi)))));
  qs_Vgm_di_Vdi_bi=(+T3_Vgm_di_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vdi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vdi_bi)-T8_Vgm_di_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdi_bi)))));
  qs_Vgm_di_Vsi_bi=(+T3_Vgm_di_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vsi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vsi_bi)-T8_Vgm_di_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsi_bi)))));
  qs_Vgm_di_Tempt_GND=(+T3_Vgm_di_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Tempt_GND*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Tempt_GND)-T8_Vgm_di_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Tempt_GND)))));
#endif
qs_Vdbulk_di=((T3_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))));
#if defined(_DERIVATE2)
  qs_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgm_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgm_si)-T8_Vdbulk_di_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si)))));
  qs_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgm_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgm_di)-T8_Vdbulk_di_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di)))));
  qs_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdbulk_di)-T8_Vdbulk_di_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)))));
  qs_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsbulk_si)-T8_Vdbulk_di_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)))));
  qs_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgi_bi)-T8_Vdbulk_di_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi)))));
  qs_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdi_bi)-T8_Vdbulk_di_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi)))));
  qs_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsi_bi)-T8_Vdbulk_di_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi)))));
  qs_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Tempt_GND*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Tempt_GND)-T8_Vdbulk_di_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND)))));
#endif
qs_Vsbulk_si=((T3_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))));
#if defined(_DERIVATE2)
  qs_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgm_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgm_si)-T8_Vsbulk_si_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si)))));
  qs_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgm_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgm_di)-T8_Vsbulk_si_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di)))));
  qs_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdbulk_di)-T8_Vsbulk_si_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)))));
  qs_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsbulk_si)-T8_Vsbulk_si_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)))));
  qs_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgi_bi)-T8_Vsbulk_si_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi)))));
  qs_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdi_bi)-T8_Vsbulk_si_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi)))));
  qs_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsi_bi)-T8_Vsbulk_si_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi)))));
  qs_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Tempt_GND*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Tempt_GND)-T8_Vsbulk_si_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND)))));
#endif
qs_Vgi_bi=((T3_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))));
#if defined(_DERIVATE2)
  qs_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_si)-T8_Vgi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si)))));
  qs_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_di)-T8_Vgi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di)))));
  qs_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdbulk_di)-T8_Vgi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di)))));
  qs_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsbulk_si)-T8_Vgi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si)))));
  qs_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgi_bi)-T8_Vgi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi)))));
  qs_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdi_bi)-T8_Vgi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi)))));
  qs_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsi_bi)-T8_Vgi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi)))));
  qs_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Tempt_GND*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Tempt_GND)-T8_Vgi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND)))));
#endif
qs_Vdi_bi=((T3_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))));
#if defined(_DERIVATE2)
  qs_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_si)-T8_Vdi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si)))));
  qs_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_di)-T8_Vdi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di)))));
  qs_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdbulk_di)-T8_Vdi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di)))));
  qs_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsbulk_si)-T8_Vdi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si)))));
  qs_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgi_bi)-T8_Vdi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi)))));
  qs_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdi_bi)-T8_Vdi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi)))));
  qs_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsi_bi)-T8_Vdi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi)))));
  qs_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Tempt_GND*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Tempt_GND)-T8_Vdi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND)))));
#endif
qs_Vsi_bi=((T3_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))));
#if defined(_DERIVATE2)
  qs_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_si)-T8_Vsi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si)))));
  qs_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_di)-T8_Vsi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di)))));
  qs_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdbulk_di)-T8_Vsi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di)))));
  qs_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsbulk_si)-T8_Vsi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si)))));
  qs_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgi_bi)-T8_Vsi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi)))));
  qs_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdi_bi)-T8_Vsi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi)))));
  qs_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsi_bi)-T8_Vsi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi)))));
  qs_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Tempt_GND*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Tempt_GND)-T8_Vsi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND)))));
#endif
#if defined(_DERIVATE)
qs_Tempt_GND=((T3_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))));
#endif
#endif
qs=(T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
EXIT_IF_ISNAN((T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=bsimbulk_d_lexp(T8,T8_Vgm_si);
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=T8_Vgm_si_Vgm_si;
  T3_Vgm_si_Vgm_di=T8_Vgm_si_Vgm_di;
  T3_Vgm_si_Vdbulk_di=T8_Vgm_si_Vdbulk_di;
  T3_Vgm_si_Vsbulk_si=T8_Vgm_si_Vsbulk_si;
  T3_Vgm_si_Vgi_bi=T8_Vgm_si_Vgi_bi;
  T3_Vgm_si_Vdi_bi=T8_Vgm_si_Vdi_bi;
  T3_Vgm_si_Vsi_bi=T8_Vgm_si_Vsi_bi;
  T3_Vgm_si_Tempt_GND=T8_Vgm_si_Tempt_GND;
#endif
T3_Vgm_di=bsimbulk_d_lexp(T8,T8_Vgm_di);
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=T8_Vgm_di_Vgm_si;
  T3_Vgm_di_Vgm_di=T8_Vgm_di_Vgm_di;
  T3_Vgm_di_Vdbulk_di=T8_Vgm_di_Vdbulk_di;
  T3_Vgm_di_Vsbulk_si=T8_Vgm_di_Vsbulk_si;
  T3_Vgm_di_Vgi_bi=T8_Vgm_di_Vgi_bi;
  T3_Vgm_di_Vdi_bi=T8_Vgm_di_Vdi_bi;
  T3_Vgm_di_Vsi_bi=T8_Vgm_di_Vsi_bi;
  T3_Vgm_di_Tempt_GND=T8_Vgm_di_Tempt_GND;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsisainv_Vgm_di=(-sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_di_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vgm_si=(-sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_si_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vdbulk_di=(-sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdbulk_di_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsbulk_si=(-sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsbulk_si_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vgi_bi=(-sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vdi_bi=(-sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsi_bi=(-sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
#if defined(_DERIVATE)
sqrtpsisainv_Tempt_GND=(-sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa);
#endif
#endif
sqrtpsisainv=(1.0/sqrtpsisa);
EXIT_IF_ISNAN((1.0/sqrtpsisa))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=(((2.0*T3_Vgm_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))-T1_Vgm_si);
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgm_si)+(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_si))))-T1_Vgm_si_Vgm_si);
  T4_Vgm_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgm_di)+(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_di))))-T1_Vgm_si_Vgm_di);
  T4_Vgm_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vdbulk_di)+(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdbulk_di))))-T1_Vgm_si_Vdbulk_di);
  T4_Vgm_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vsbulk_si)+(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsbulk_si))))-T1_Vgm_si_Vsbulk_si);
  T4_Vgm_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgi_bi)+(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgi_bi))))-T1_Vgm_si_Vgi_bi);
  T4_Vgm_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vdi_bi)+(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdi_bi))))-T1_Vgm_si_Vdi_bi);
  T4_Vgm_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vsi_bi)+(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsi_bi))))-T1_Vgm_si_Vsi_bi);
  T4_Vgm_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Tempt_GND)+(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Tempt_GND))))-T1_Vgm_si_Tempt_GND);
#endif
T4_Vgm_di=(((2.0*T3_Vgm_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))-T1_Vgm_di);
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgm_si)+(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_si))))-T1_Vgm_di_Vgm_si);
  T4_Vgm_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgm_di)+(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_di))))-T1_Vgm_di_Vgm_di);
  T4_Vgm_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vdbulk_di)+(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdbulk_di))))-T1_Vgm_di_Vdbulk_di);
  T4_Vgm_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vsbulk_si)+(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsbulk_si))))-T1_Vgm_di_Vsbulk_si);
  T4_Vgm_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgi_bi)+(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgi_bi))))-T1_Vgm_di_Vgi_bi);
  T4_Vgm_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vdi_bi)+(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdi_bi))))-T1_Vgm_di_Vdi_bi);
  T4_Vgm_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vsi_bi)+(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsi_bi))))-T1_Vgm_di_Vsi_bi);
  T4_Vgm_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Tempt_GND)+(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Tempt_GND))))-T1_Vgm_di_Tempt_GND);
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=((-T3_Vgm_si/T3/T3)+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgm_si)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vgm_si_Vgm_si+sqrtpsisainv_Vgm_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgm_di)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vgm_si_Vgm_di+sqrtpsisainv_Vgm_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vgm_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgm_si_Vdbulk_di+sqrtpsisainv_Vgm_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vgm_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgm_si_Vsbulk_si+sqrtpsisainv_Vgm_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgm_si_Vgi_bi+sqrtpsisainv_Vgm_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vdi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgm_si_Vdi_bi+sqrtpsisainv_Vgm_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vsi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgm_si_Vsi_bi+sqrtpsisainv_Vgm_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Tempt_GND)/T3/T3+2*1.0*T3_Vgm_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgm_si_Tempt_GND+sqrtpsisainv_Vgm_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgm_di=((-T3_Vgm_di/T3/T3)+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgm_si)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vgm_di_Vgm_si+sqrtpsisainv_Vgm_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgm_di)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vgm_di_Vgm_di+sqrtpsisainv_Vgm_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vgm_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgm_di_Vdbulk_di+sqrtpsisainv_Vgm_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vgm_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgm_di_Vsbulk_si+sqrtpsisainv_Vgm_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgm_di_Vgi_bi+sqrtpsisainv_Vgm_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vdi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgm_di_Vdi_bi+sqrtpsisainv_Vgm_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vsi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgm_di_Vsi_bi+sqrtpsisainv_Vgm_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Tempt_GND)/T3/T3+2*1.0*T3_Vgm_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgm_di_Tempt_GND+sqrtpsisainv_Vgm_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=(T3_Vgm_si-((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=(+T3_Vgm_si_Vgm_si-(T4_Vgm_si_Vgm_si/T5-(T4_Vgm_si*T5_Vgm_si+T4_Vgm_si*T5_Vgm_si+T4*T5_Vgm_si_Vgm_si)/T5/T5+2*T4*T5_Vgm_si*T5_Vgm_si/T5/T5/T5));
  T3_Vgm_si_Vgm_di=(+T3_Vgm_si_Vgm_di-(T4_Vgm_si_Vgm_di/T5-(T4_Vgm_si*T5_Vgm_di+T4_Vgm_di*T5_Vgm_si+T4*T5_Vgm_si_Vgm_di)/T5/T5+2*T4*T5_Vgm_si*T5_Vgm_di/T5/T5/T5));
  T3_Vgm_si_Vdbulk_di=(+T3_Vgm_si_Vdbulk_di-(T4_Vgm_si_Vdbulk_di/T5-(T4_Vgm_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgm_si+T4*T5_Vgm_si_Vdbulk_di)/T5/T5+2*T4*T5_Vgm_si*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgm_si_Vsbulk_si=(+T3_Vgm_si_Vsbulk_si-(T4_Vgm_si_Vsbulk_si/T5-(T4_Vgm_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgm_si+T4*T5_Vgm_si_Vsbulk_si)/T5/T5+2*T4*T5_Vgm_si*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgm_si_Vgi_bi=(+T3_Vgm_si_Vgi_bi-(T4_Vgm_si_Vgi_bi/T5-(T4_Vgm_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vgi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vgi_bi/T5/T5/T5));
  T3_Vgm_si_Vdi_bi=(+T3_Vgm_si_Vdi_bi-(T4_Vgm_si_Vdi_bi/T5-(T4_Vgm_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vdi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vdi_bi/T5/T5/T5));
  T3_Vgm_si_Vsi_bi=(+T3_Vgm_si_Vsi_bi-(T4_Vgm_si_Vsi_bi/T5-(T4_Vgm_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vsi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vsi_bi/T5/T5/T5));
  T3_Vgm_si_Tempt_GND=(+T3_Vgm_si_Tempt_GND-(T4_Vgm_si_Tempt_GND/T5-(T4_Vgm_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vgm_si+T4*T5_Vgm_si_Tempt_GND)/T5/T5+2*T4*T5_Vgm_si*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vgm_di=(T3_Vgm_di-((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=(+T3_Vgm_di_Vgm_si-(T4_Vgm_di_Vgm_si/T5-(T4_Vgm_di*T5_Vgm_si+T4_Vgm_si*T5_Vgm_di+T4*T5_Vgm_di_Vgm_si)/T5/T5+2*T4*T5_Vgm_di*T5_Vgm_si/T5/T5/T5));
  T3_Vgm_di_Vgm_di=(+T3_Vgm_di_Vgm_di-(T4_Vgm_di_Vgm_di/T5-(T4_Vgm_di*T5_Vgm_di+T4_Vgm_di*T5_Vgm_di+T4*T5_Vgm_di_Vgm_di)/T5/T5+2*T4*T5_Vgm_di*T5_Vgm_di/T5/T5/T5));
  T3_Vgm_di_Vdbulk_di=(+T3_Vgm_di_Vdbulk_di-(T4_Vgm_di_Vdbulk_di/T5-(T4_Vgm_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgm_di+T4*T5_Vgm_di_Vdbulk_di)/T5/T5+2*T4*T5_Vgm_di*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgm_di_Vsbulk_si=(+T3_Vgm_di_Vsbulk_si-(T4_Vgm_di_Vsbulk_si/T5-(T4_Vgm_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgm_di+T4*T5_Vgm_di_Vsbulk_si)/T5/T5+2*T4*T5_Vgm_di*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgm_di_Vgi_bi=(+T3_Vgm_di_Vgi_bi-(T4_Vgm_di_Vgi_bi/T5-(T4_Vgm_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vgi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vgi_bi/T5/T5/T5));
  T3_Vgm_di_Vdi_bi=(+T3_Vgm_di_Vdi_bi-(T4_Vgm_di_Vdi_bi/T5-(T4_Vgm_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vdi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vdi_bi/T5/T5/T5));
  T3_Vgm_di_Vsi_bi=(+T3_Vgm_di_Vsi_bi-(T4_Vgm_di_Vsi_bi/T5-(T4_Vgm_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vsi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vsi_bi/T5/T5/T5));
  T3_Vgm_di_Tempt_GND=(+T3_Vgm_di_Tempt_GND-(T4_Vgm_di_Tempt_GND/T5-(T4_Vgm_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vgm_di+T4*T5_Vgm_di_Tempt_GND)/T5/T5+2*T4*T5_Vgm_di*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vdbulk_di=(T3_Vdbulk_di-((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si-(T4_Vdbulk_di_Vgm_si/T5-(T4_Vdbulk_di*T5_Vgm_si+T4_Vgm_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5));
  T3_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di-(T4_Vdbulk_di_Vgm_di/T5-(T4_Vdbulk_di*T5_Vgm_di+T4_Vgm_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5));
  T3_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5));
  T3_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsbulk_si=(T3_Vsbulk_si-((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si-(T4_Vsbulk_si_Vgm_si/T5-(T4_Vsbulk_si*T5_Vgm_si+T4_Vgm_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5));
  T3_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di-(T4_Vsbulk_si_Vgm_di/T5-(T4_Vsbulk_si*T5_Vgm_di+T4_Vgm_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5));
  T3_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5));
  T3_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vgi_bi=(T3_Vgi_bi-((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vdi_bi=(T3_Vdi_bi-((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsi_bi=(T3_Vsi_bi-((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T3_Tempt_GND-((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5));
#endif
#endif
T3=(T3-(T4/T5));
EXIT_IF_ISNAN((T3-(T4/T5)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=(((2.0*T3_Vgm_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))-T1_Vgm_si);
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgm_si)+(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_si))))-T1_Vgm_si_Vgm_si);
  T4_Vgm_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgm_di)+(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_di))))-T1_Vgm_si_Vgm_di);
  T4_Vgm_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vdbulk_di)+(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdbulk_di))))-T1_Vgm_si_Vdbulk_di);
  T4_Vgm_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vsbulk_si)+(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsbulk_si))))-T1_Vgm_si_Vsbulk_si);
  T4_Vgm_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgi_bi)+(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgi_bi))))-T1_Vgm_si_Vgi_bi);
  T4_Vgm_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vdi_bi)+(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdi_bi))))-T1_Vgm_si_Vdi_bi);
  T4_Vgm_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vsi_bi)+(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsi_bi))))-T1_Vgm_si_Vsi_bi);
  T4_Vgm_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Tempt_GND)+(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Tempt_GND))))-T1_Vgm_si_Tempt_GND);
#endif
T4_Vgm_di=(((2.0*T3_Vgm_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))-T1_Vgm_di);
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgm_si)+(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_si))))-T1_Vgm_di_Vgm_si);
  T4_Vgm_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgm_di)+(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_di))))-T1_Vgm_di_Vgm_di);
  T4_Vgm_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vdbulk_di)+(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdbulk_di))))-T1_Vgm_di_Vdbulk_di);
  T4_Vgm_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vsbulk_si)+(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsbulk_si))))-T1_Vgm_di_Vsbulk_si);
  T4_Vgm_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgi_bi)+(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgi_bi))))-T1_Vgm_di_Vgi_bi);
  T4_Vgm_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vdi_bi)+(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdi_bi))))-T1_Vgm_di_Vdi_bi);
  T4_Vgm_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vsi_bi)+(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsi_bi))))-T1_Vgm_di_Vsi_bi);
  T4_Vgm_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Tempt_GND)+(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Tempt_GND))))-T1_Vgm_di_Tempt_GND);
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=((-T3_Vgm_si/T3/T3)+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgm_si)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vgm_si_Vgm_si+sqrtpsisainv_Vgm_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgm_di)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vgm_si_Vgm_di+sqrtpsisainv_Vgm_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vgm_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgm_si_Vdbulk_di+sqrtpsisainv_Vgm_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vgm_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgm_si_Vsbulk_si+sqrtpsisainv_Vgm_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgm_si_Vgi_bi+sqrtpsisainv_Vgm_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vdi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgm_si_Vdi_bi+sqrtpsisainv_Vgm_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vsi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgm_si_Vsi_bi+sqrtpsisainv_Vgm_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Tempt_GND)/T3/T3+2*1.0*T3_Vgm_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgm_si_Tempt_GND+sqrtpsisainv_Vgm_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgm_di=((-T3_Vgm_di/T3/T3)+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgm_si)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vgm_di_Vgm_si+sqrtpsisainv_Vgm_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgm_di)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vgm_di_Vgm_di+sqrtpsisainv_Vgm_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vgm_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgm_di_Vdbulk_di+sqrtpsisainv_Vgm_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vgm_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgm_di_Vsbulk_si+sqrtpsisainv_Vgm_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgm_di_Vgi_bi+sqrtpsisainv_Vgm_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vdi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgm_di_Vdi_bi+sqrtpsisainv_Vgm_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vsi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgm_di_Vsi_bi+sqrtpsisainv_Vgm_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Tempt_GND)/T3/T3+2*1.0*T3_Vgm_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgm_di_Tempt_GND+sqrtpsisainv_Vgm_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=(((((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=(+((+T0_Vgm_di_Vgm_di+sqrtpsisainv_Vgm_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vgm_di+sqrtpsisainv_Vgm_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vgm_si=(+((+T0_Vgm_di_Vgm_si+sqrtpsisainv_Vgm_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vgm_si+sqrtpsisainv_Vgm_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vdbulk_di=(+((+T0_Vgm_di_Vdbulk_di+sqrtpsisainv_Vgm_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vdbulk_di+sqrtpsisainv_Vgm_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vsbulk_si=(+((+T0_Vgm_di_Vsbulk_si+sqrtpsisainv_Vgm_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vsbulk_si+sqrtpsisainv_Vgm_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vgi_bi=(+((+T0_Vgm_di_Vgi_bi+sqrtpsisainv_Vgm_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vgi_bi+sqrtpsisainv_Vgm_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vdi_bi=(+((+T0_Vgm_di_Vdi_bi+sqrtpsisainv_Vgm_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vdi_bi+sqrtpsisainv_Vgm_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vsi_bi=(+((+T0_Vgm_di_Vsi_bi+sqrtpsisainv_Vgm_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vsi_bi+sqrtpsisainv_Vgm_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Tempt_GND=(+((+T0_Vgm_di_Tempt_GND+sqrtpsisainv_Vgm_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Tempt_GND+sqrtpsisainv_Vgm_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vgm_si=(((((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=(+((+T0_Vgm_si_Vgm_di+sqrtpsisainv_Vgm_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vgm_di+sqrtpsisainv_Vgm_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vgm_si=(+((+T0_Vgm_si_Vgm_si+sqrtpsisainv_Vgm_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vgm_si+sqrtpsisainv_Vgm_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vdbulk_di=(+((+T0_Vgm_si_Vdbulk_di+sqrtpsisainv_Vgm_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vdbulk_di+sqrtpsisainv_Vgm_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vsbulk_si=(+((+T0_Vgm_si_Vsbulk_si+sqrtpsisainv_Vgm_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vsbulk_si+sqrtpsisainv_Vgm_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vgi_bi=(+((+T0_Vgm_si_Vgi_bi+sqrtpsisainv_Vgm_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vgi_bi+sqrtpsisainv_Vgm_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vdi_bi=(+((+T0_Vgm_si_Vdi_bi+sqrtpsisainv_Vgm_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vdi_bi+sqrtpsisainv_Vgm_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vsi_bi=(+((+T0_Vgm_si_Vsi_bi+sqrtpsisainv_Vgm_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vsi_bi+sqrtpsisainv_Vgm_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Tempt_GND=(+((+T0_Vgm_si_Tempt_GND+sqrtpsisainv_Vgm_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Tempt_GND+sqrtpsisainv_Vgm_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vdbulk_di=(((((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgm_si=(+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdbulk_di=(+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsbulk_si=(+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgi_bi=(+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdi_bi=(+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsi_bi=(+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Tempt_GND=(+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsbulk_si=(((((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vgi_bi=(((((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vdi_bi=(((((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsi_bi=(((((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#endif
#endif
T6=(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN((((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=(((-(((-T3_Vgm_si/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgm_si/T3/T3))))-(-((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si);
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vgm_si*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vgm_si);
  T7_Vgm_si_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vgm_di*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vgm_di);
  T7_Vgm_si_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vdbulk_di);
  T7_Vgm_si_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vsbulk_si);
  T7_Vgm_si_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vgi_bi);
  T7_Vgm_si_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vdi_bi);
  T7_Vgm_si_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vsi_bi);
  T7_Vgm_si_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Tempt_GND);
#endif
T7_Vgm_di=(((-(((-T3_Vgm_di/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgm_di/T3/T3))))-(-((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di);
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vgm_si*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vgm_si);
  T7_Vgm_di_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vgm_di*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vgm_di);
  T7_Vgm_di_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vdbulk_di);
  T7_Vgm_di_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vsbulk_si);
  T7_Vgm_di_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vgi_bi);
  T7_Vgm_di_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vdi_bi);
  T7_Vgm_di_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vsi_bi);
  T7_Vgm_di_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Tempt_GND);
#endif
T7_Vdbulk_di=(((-(((-T3_Vdbulk_di/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdbulk_di/T3/T3))))-(-((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di);
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_si);
  T7_Vdbulk_di_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_di);
  T7_Vdbulk_di_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdbulk_di);
  T7_Vdbulk_di_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsbulk_si);
  T7_Vdbulk_di_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgi_bi);
  T7_Vdbulk_di_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdi_bi);
  T7_Vdbulk_di_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsi_bi);
  T7_Vdbulk_di_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Tempt_GND);
#endif
T7_Vsbulk_si=(((-(((-T3_Vsbulk_si/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsbulk_si/T3/T3))))-(-((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si);
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_si);
  T7_Vsbulk_si_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_di);
  T7_Vsbulk_si_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdbulk_di);
  T7_Vsbulk_si_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsbulk_si);
  T7_Vsbulk_si_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgi_bi);
  T7_Vsbulk_si_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdi_bi);
  T7_Vsbulk_si_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsi_bi);
  T7_Vsbulk_si_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Tempt_GND);
#endif
T7_Vgi_bi=(((-(((-T3_Vgi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgi_bi/T3/T3))))-(-((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi);
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_si);
  T7_Vgi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_di);
  T7_Vgi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdbulk_di);
  T7_Vgi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsbulk_si);
  T7_Vgi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgi_bi);
  T7_Vgi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdi_bi);
  T7_Vgi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsi_bi);
  T7_Vgi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Tempt_GND);
#endif
T7_Vdi_bi=(((-(((-T3_Vdi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdi_bi/T3/T3))))-(-((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi);
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_si);
  T7_Vdi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_di);
  T7_Vdi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdbulk_di);
  T7_Vdi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsbulk_si);
  T7_Vdi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgi_bi);
  T7_Vdi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdi_bi);
  T7_Vdi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsi_bi);
  T7_Vdi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Tempt_GND);
#endif
T7_Vsi_bi=(((-(((-T3_Vsi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsi_bi/T3/T3))))-(-((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi);
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_si);
  T7_Vsi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_di);
  T7_Vsi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdbulk_di);
  T7_Vsi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsbulk_si);
  T7_Vsi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgi_bi);
  T7_Vsi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdi_bi);
  T7_Vsi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsi_bi);
  T7_Vsi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(((-(((-T3_Tempt_GND/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Tempt_GND/T3/T3))))-(-((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Tempt_GND);
#endif
#endif
T7=(((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
EXIT_IF_ISNAN((((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(si,GND)V(sbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qs_Vgm_si=(T3_Vgm_si-((((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vgm_si_Vgm_si=(+T3_Vgm_si_Vgm_si-(+(T4_Vgm_si_Vgm_si/T5-(T4_Vgm_si*T5_Vgm_si+T4_Vgm_si*T5_Vgm_si+T4*T5_Vgm_si_Vgm_si)/T5/T5+2*T4*T5_Vgm_si*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vgm_si*T7+T4_Vgm_si*T7_Vgm_si+T4_Vgm_si*T7_Vgm_si+T4*T7_Vgm_si_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vgm_si)*T5+(2.0*T5_Vgm_si)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_si_Vgm_di=(+T3_Vgm_si_Vgm_di-(+(T4_Vgm_si_Vgm_di/T5-(T4_Vgm_si*T5_Vgm_di+T4_Vgm_di*T5_Vgm_si+T4*T5_Vgm_si_Vgm_di)/T5/T5+2*T4*T5_Vgm_si*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vgm_di*T7+T4_Vgm_si*T7_Vgm_di+T4_Vgm_di*T7_Vgm_si+T4*T7_Vgm_si_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vgm_di)*T5+(2.0*T5_Vgm_si)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_si_Vdbulk_di=(+T3_Vgm_si_Vdbulk_di-(+(T4_Vgm_si_Vdbulk_di/T5-(T4_Vgm_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgm_si+T4*T5_Vgm_si_Vdbulk_di)/T5/T5+2*T4*T5_Vgm_si*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vdbulk_di*T7+T4_Vgm_si*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgm_si+T4*T7_Vgm_si_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vdbulk_di)*T5+(2.0*T5_Vgm_si)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_si_Vsbulk_si=(+T3_Vgm_si_Vsbulk_si-(+(T4_Vgm_si_Vsbulk_si/T5-(T4_Vgm_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgm_si+T4*T5_Vgm_si_Vsbulk_si)/T5/T5+2*T4*T5_Vgm_si*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vsbulk_si*T7+T4_Vgm_si*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgm_si+T4*T7_Vgm_si_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vsbulk_si)*T5+(2.0*T5_Vgm_si)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_si_Vgi_bi=(+T3_Vgm_si_Vgi_bi-(+(T4_Vgm_si_Vgi_bi/T5-(T4_Vgm_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vgi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vgi_bi*T7+T4_Vgm_si*T7_Vgi_bi+T4_Vgi_bi*T7_Vgm_si+T4*T7_Vgm_si_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vgi_bi)*T5+(2.0*T5_Vgm_si)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_si_Vdi_bi=(+T3_Vgm_si_Vdi_bi-(+(T4_Vgm_si_Vdi_bi/T5-(T4_Vgm_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vdi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vdi_bi*T7+T4_Vgm_si*T7_Vdi_bi+T4_Vdi_bi*T7_Vgm_si+T4*T7_Vgm_si_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vdi_bi)*T5+(2.0*T5_Vgm_si)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_si_Vsi_bi=(+T3_Vgm_si_Vsi_bi-(+(T4_Vgm_si_Vsi_bi/T5-(T4_Vgm_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vsi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vsi_bi*T7+T4_Vgm_si*T7_Vsi_bi+T4_Vsi_bi*T7_Vgm_si+T4*T7_Vgm_si_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vsi_bi)*T5+(2.0*T5_Vgm_si)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_si_Tempt_GND=(+T3_Vgm_si_Tempt_GND-(+(T4_Vgm_si_Tempt_GND/T5-(T4_Vgm_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vgm_si+T4*T5_Vgm_si_Tempt_GND)/T5/T5+2*T4*T5_Vgm_si*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Tempt_GND*T7+T4_Vgm_si*T7_Tempt_GND+T4_Tempt_GND*T7_Vgm_si+T4*T7_Vgm_si_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Tempt_GND)*T5+(2.0*T5_Vgm_si)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vgm_di=(T3_Vgm_di-((((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vgm_di_Vgm_si=(+T3_Vgm_di_Vgm_si-(+(T4_Vgm_di_Vgm_si/T5-(T4_Vgm_di*T5_Vgm_si+T4_Vgm_si*T5_Vgm_di+T4*T5_Vgm_di_Vgm_si)/T5/T5+2*T4*T5_Vgm_di*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vgm_si*T7+T4_Vgm_di*T7_Vgm_si+T4_Vgm_si*T7_Vgm_di+T4*T7_Vgm_di_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vgm_si)*T5+(2.0*T5_Vgm_di)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_di_Vgm_di=(+T3_Vgm_di_Vgm_di-(+(T4_Vgm_di_Vgm_di/T5-(T4_Vgm_di*T5_Vgm_di+T4_Vgm_di*T5_Vgm_di+T4*T5_Vgm_di_Vgm_di)/T5/T5+2*T4*T5_Vgm_di*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vgm_di*T7+T4_Vgm_di*T7_Vgm_di+T4_Vgm_di*T7_Vgm_di+T4*T7_Vgm_di_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vgm_di)*T5+(2.0*T5_Vgm_di)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_di_Vdbulk_di=(+T3_Vgm_di_Vdbulk_di-(+(T4_Vgm_di_Vdbulk_di/T5-(T4_Vgm_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgm_di+T4*T5_Vgm_di_Vdbulk_di)/T5/T5+2*T4*T5_Vgm_di*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vdbulk_di*T7+T4_Vgm_di*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgm_di+T4*T7_Vgm_di_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vdbulk_di)*T5+(2.0*T5_Vgm_di)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_di_Vsbulk_si=(+T3_Vgm_di_Vsbulk_si-(+(T4_Vgm_di_Vsbulk_si/T5-(T4_Vgm_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgm_di+T4*T5_Vgm_di_Vsbulk_si)/T5/T5+2*T4*T5_Vgm_di*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vsbulk_si*T7+T4_Vgm_di*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgm_di+T4*T7_Vgm_di_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vsbulk_si)*T5+(2.0*T5_Vgm_di)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_di_Vgi_bi=(+T3_Vgm_di_Vgi_bi-(+(T4_Vgm_di_Vgi_bi/T5-(T4_Vgm_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vgi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vgi_bi*T7+T4_Vgm_di*T7_Vgi_bi+T4_Vgi_bi*T7_Vgm_di+T4*T7_Vgm_di_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vgi_bi)*T5+(2.0*T5_Vgm_di)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_di_Vdi_bi=(+T3_Vgm_di_Vdi_bi-(+(T4_Vgm_di_Vdi_bi/T5-(T4_Vgm_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vdi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vdi_bi*T7+T4_Vgm_di*T7_Vdi_bi+T4_Vdi_bi*T7_Vgm_di+T4*T7_Vgm_di_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vdi_bi)*T5+(2.0*T5_Vgm_di)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_di_Vsi_bi=(+T3_Vgm_di_Vsi_bi-(+(T4_Vgm_di_Vsi_bi/T5-(T4_Vgm_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vsi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vsi_bi*T7+T4_Vgm_di*T7_Vsi_bi+T4_Vsi_bi*T7_Vgm_di+T4*T7_Vgm_di_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vsi_bi)*T5+(2.0*T5_Vgm_di)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgm_di_Tempt_GND=(+T3_Vgm_di_Tempt_GND-(+(T4_Vgm_di_Tempt_GND/T5-(T4_Vgm_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vgm_di+T4*T5_Vgm_di_Tempt_GND)/T5/T5+2*T4*T5_Vgm_di*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Tempt_GND*T7+T4_Vgm_di*T7_Tempt_GND+T4_Tempt_GND*T7_Vgm_di+T4*T7_Vgm_di_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Tempt_GND)*T5+(2.0*T5_Vgm_di)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vdbulk_di=(T3_Vdbulk_di-((((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si-(+(T4_Vdbulk_di_Vgm_si/T5-(T4_Vdbulk_di*T5_Vgm_si+T4_Vgm_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgm_si*T7+T4_Vdbulk_di*T7_Vgm_si+T4_Vgm_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgm_si)*T5+(2.0*T5_Vdbulk_di)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di-(+(T4_Vdbulk_di_Vgm_di/T5-(T4_Vdbulk_di*T5_Vgm_di+T4_Vgm_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgm_di*T7+T4_Vdbulk_di*T7_Vgm_di+T4_Vgm_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgm_di)*T5+(2.0*T5_Vdbulk_di)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(+(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdbulk_di*T7+T4_Vdbulk_di*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdbulk_di)*T5+(2.0*T5_Vdbulk_di)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(+(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsbulk_si*T7+T4_Vdbulk_di*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsbulk_si)*T5+(2.0*T5_Vdbulk_di)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(+(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgi_bi*T7+T4_Vdbulk_di*T7_Vgi_bi+T4_Vgi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(+(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdi_bi*T7+T4_Vdbulk_di*T7_Vdi_bi+T4_Vdi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(+(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsi_bi*T7+T4_Vdbulk_di*T7_Vsi_bi+T4_Vsi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(+(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Tempt_GND*T7+T4_Vdbulk_di*T7_Tempt_GND+T4_Tempt_GND*T7_Vdbulk_di+T4*T7_Vdbulk_di_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Tempt_GND)*T5+(2.0*T5_Vdbulk_di)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vsbulk_si=(T3_Vsbulk_si-((((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si-(+(T4_Vsbulk_si_Vgm_si/T5-(T4_Vsbulk_si*T5_Vgm_si+T4_Vgm_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgm_si*T7+T4_Vsbulk_si*T7_Vgm_si+T4_Vgm_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgm_si)*T5+(2.0*T5_Vsbulk_si)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di-(+(T4_Vsbulk_si_Vgm_di/T5-(T4_Vsbulk_si*T5_Vgm_di+T4_Vgm_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgm_di*T7+T4_Vsbulk_si*T7_Vgm_di+T4_Vgm_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgm_di)*T5+(2.0*T5_Vsbulk_si)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(+(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdbulk_di*T7+T4_Vsbulk_si*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdbulk_di)*T5+(2.0*T5_Vsbulk_si)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(+(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsbulk_si*T7+T4_Vsbulk_si*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsbulk_si)*T5+(2.0*T5_Vsbulk_si)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(+(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgi_bi*T7+T4_Vsbulk_si*T7_Vgi_bi+T4_Vgi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(+(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdi_bi*T7+T4_Vsbulk_si*T7_Vdi_bi+T4_Vdi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(+(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsi_bi*T7+T4_Vsbulk_si*T7_Vsi_bi+T4_Vsi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(+(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Tempt_GND*T7+T4_Vsbulk_si*T7_Tempt_GND+T4_Tempt_GND*T7_Vsbulk_si+T4*T7_Vsbulk_si_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Tempt_GND)*T5+(2.0*T5_Vsbulk_si)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vgi_bi=(T3_Vgi_bi-((((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(+(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_si*T7+T4_Vgi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_si)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(+(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_di*T7+T4_Vgi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_di)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(+(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdbulk_di*T7+T4_Vgi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdbulk_di)*T5+(2.0*T5_Vgi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(+(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsbulk_si*T7+T4_Vgi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsbulk_si)*T5+(2.0*T5_Vgi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(+(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgi_bi*T7+T4_Vgi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(+(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdi_bi*T7+T4_Vgi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(+(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsi_bi*T7+T4_Vgi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(+(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Tempt_GND*T7+T4_Vgi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vgi_bi+T4*T7_Vgi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Tempt_GND)*T5+(2.0*T5_Vgi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vdi_bi=(T3_Vdi_bi-((((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(+(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_si*T7+T4_Vdi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_si)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(+(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_di*T7+T4_Vdi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_di)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(+(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdbulk_di*T7+T4_Vdi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdbulk_di)*T5+(2.0*T5_Vdi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(+(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsbulk_si*T7+T4_Vdi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsbulk_si)*T5+(2.0*T5_Vdi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(+(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgi_bi*T7+T4_Vdi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(+(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdi_bi*T7+T4_Vdi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(+(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsi_bi*T7+T4_Vdi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(+(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Tempt_GND*T7+T4_Vdi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vdi_bi+T4*T7_Vdi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Tempt_GND)*T5+(2.0*T5_Vdi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qs_Vsi_bi=(T3_Vsi_bi-((((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qs_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(+(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_si*T7+T4_Vsi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_si)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(+(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_di*T7+T4_Vsi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_di)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(+(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdbulk_di*T7+T4_Vsi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdbulk_di)*T5+(2.0*T5_Vsi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(+(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsbulk_si*T7+T4_Vsi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsbulk_si)*T5+(2.0*T5_Vsi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(+(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgi_bi*T7+T4_Vsi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(+(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdi_bi*T7+T4_Vsi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(+(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsi_bi*T7+T4_Vsi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qs_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(+(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Tempt_GND*T7+T4_Vsi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vsi_bi+T4*T7_Vsi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Tempt_GND)*T5+(2.0*T5_Vsi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#if defined(_DERIVATE)
qs_Tempt_GND=(T3_Tempt_GND-((((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Tempt_GND)*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#endif
qs=(T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
EXIT_IF_ISNAN((T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(gm,di) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
vdsatedge_Vgm_si=((((2.0*nVt_Vgm_si)*qs)+((2.0*nVt)*qs_Vgm_si))+(2.0*nVt_Vgm_si));
#endif
vdsatedge_Vdbulk_di=((((2.0*nVt_Vdbulk_di)*qs)+((2.0*nVt)*qs_Vdbulk_di))+(2.0*nVt_Vdbulk_di));
#if defined(_DERIVATE2)
  vdsatedge_Vdbulk_di_Vgm_si=(+(+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vgm_si)*qs+(2.0*nVt_Vdbulk_di)*qs_Vgm_si+((2.0*nVt_Vgm_si))*qs_Vdbulk_di+(2.0*nVt)*qs_Vdbulk_di_Vgm_si)+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vgm_si));
  vdsatedge_Vdbulk_di_Vdbulk_di=(+(+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vdbulk_di)*qs+(2.0*nVt_Vdbulk_di)*qs_Vdbulk_di+((2.0*nVt_Vdbulk_di))*qs_Vdbulk_di+(2.0*nVt)*qs_Vdbulk_di_Vdbulk_di)+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vdbulk_di));
  vdsatedge_Vdbulk_di_Vsbulk_si=(+(+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vsbulk_si)*qs+(2.0*nVt_Vdbulk_di)*qs_Vsbulk_si+((2.0*nVt_Vsbulk_si))*qs_Vdbulk_di+(2.0*nVt)*qs_Vdbulk_di_Vsbulk_si)+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vsbulk_si));
  vdsatedge_Vdbulk_di_Vgi_bi=(+(+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vgi_bi)*qs+(2.0*nVt_Vdbulk_di)*qs_Vgi_bi+((2.0*nVt_Vgi_bi))*qs_Vdbulk_di+(2.0*nVt)*qs_Vdbulk_di_Vgi_bi)+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vgi_bi));
  vdsatedge_Vdbulk_di_Vdi_bi=(+(+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vdi_bi)*qs+(2.0*nVt_Vdbulk_di)*qs_Vdi_bi+((2.0*nVt_Vdi_bi))*qs_Vdbulk_di+(2.0*nVt)*qs_Vdbulk_di_Vdi_bi)+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vdi_bi));
  vdsatedge_Vdbulk_di_Vsi_bi=(+(+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vsi_bi)*qs+(2.0*nVt_Vdbulk_di)*qs_Vsi_bi+((2.0*nVt_Vsi_bi))*qs_Vdbulk_di+(2.0*nVt)*qs_Vdbulk_di_Vsi_bi)+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Vsi_bi));
  vdsatedge_Vdbulk_di_Tempt_GND=(+(+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Tempt_GND)*qs+(2.0*nVt_Vdbulk_di)*qs_Tempt_GND+((2.0*nVt_Tempt_GND))*qs_Vdbulk_di+(2.0*nVt)*qs_Vdbulk_di_Tempt_GND)+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vdbulk_di+2.0*nVt_Vdbulk_di_Tempt_GND));
  vdsatedge_Vdbulk_di_Vgm_di=(+(+(+0.0*nVt+0.0*0.0+0.0*nVt_Vdbulk_di+2.0*0.0)*qs+(2.0*nVt_Vdbulk_di)*qs_Vgm_di+(0.0)*qs_Vdbulk_di+(2.0*nVt)*qs_Vdbulk_di_Vgm_di)+(+0.0*nVt+0.0*0.0+0.0*nVt_Vdbulk_di+2.0*0.0));
#endif
#if defined(_DERIVATE)
vdsatedge_Vsbulk_si=((((2.0*nVt_Vsbulk_si)*qs)+((2.0*nVt)*qs_Vsbulk_si))+(2.0*nVt_Vsbulk_si));
#endif
vdsatedge_Vgi_bi=((((2.0*nVt_Vgi_bi)*qs)+((2.0*nVt)*qs_Vgi_bi))+(2.0*nVt_Vgi_bi));
#if defined(_DERIVATE2)
  vdsatedge_Vgi_bi_Vgm_si=(+(+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vgm_si)*qs+(2.0*nVt_Vgi_bi)*qs_Vgm_si+((2.0*nVt_Vgm_si))*qs_Vgi_bi+(2.0*nVt)*qs_Vgi_bi_Vgm_si)+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vgm_si));
  vdsatedge_Vgi_bi_Vdbulk_di=(+(+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vdbulk_di)*qs+(2.0*nVt_Vgi_bi)*qs_Vdbulk_di+((2.0*nVt_Vdbulk_di))*qs_Vgi_bi+(2.0*nVt)*qs_Vgi_bi_Vdbulk_di)+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vdbulk_di));
  vdsatedge_Vgi_bi_Vsbulk_si=(+(+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vsbulk_si)*qs+(2.0*nVt_Vgi_bi)*qs_Vsbulk_si+((2.0*nVt_Vsbulk_si))*qs_Vgi_bi+(2.0*nVt)*qs_Vgi_bi_Vsbulk_si)+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vsbulk_si));
  vdsatedge_Vgi_bi_Vgi_bi=(+(+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vgi_bi)*qs+(2.0*nVt_Vgi_bi)*qs_Vgi_bi+((2.0*nVt_Vgi_bi))*qs_Vgi_bi+(2.0*nVt)*qs_Vgi_bi_Vgi_bi)+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vgi_bi));
  vdsatedge_Vgi_bi_Vdi_bi=(+(+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vdi_bi)*qs+(2.0*nVt_Vgi_bi)*qs_Vdi_bi+((2.0*nVt_Vdi_bi))*qs_Vgi_bi+(2.0*nVt)*qs_Vgi_bi_Vdi_bi)+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vdi_bi));
  vdsatedge_Vgi_bi_Vsi_bi=(+(+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vsi_bi)*qs+(2.0*nVt_Vgi_bi)*qs_Vsi_bi+((2.0*nVt_Vsi_bi))*qs_Vgi_bi+(2.0*nVt)*qs_Vgi_bi_Vsi_bi)+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Vsi_bi));
  vdsatedge_Vgi_bi_Tempt_GND=(+(+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Tempt_GND)*qs+(2.0*nVt_Vgi_bi)*qs_Tempt_GND+((2.0*nVt_Tempt_GND))*qs_Vgi_bi+(2.0*nVt)*qs_Vgi_bi_Tempt_GND)+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vgi_bi+2.0*nVt_Vgi_bi_Tempt_GND));
  vdsatedge_Vgi_bi_Vgm_di=(+(+(+0.0*nVt+0.0*0.0+0.0*nVt_Vgi_bi+2.0*0.0)*qs+(2.0*nVt_Vgi_bi)*qs_Vgm_di+(0.0)*qs_Vgi_bi+(2.0*nVt)*qs_Vgi_bi_Vgm_di)+(+0.0*nVt+0.0*0.0+0.0*nVt_Vgi_bi+2.0*0.0));
#endif
vdsatedge_Vdi_bi=((((2.0*nVt_Vdi_bi)*qs)+((2.0*nVt)*qs_Vdi_bi))+(2.0*nVt_Vdi_bi));
#if defined(_DERIVATE2)
  vdsatedge_Vdi_bi_Vgm_si=(+(+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vgm_si)*qs+(2.0*nVt_Vdi_bi)*qs_Vgm_si+((2.0*nVt_Vgm_si))*qs_Vdi_bi+(2.0*nVt)*qs_Vdi_bi_Vgm_si)+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vgm_si));
  vdsatedge_Vdi_bi_Vdbulk_di=(+(+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vdbulk_di)*qs+(2.0*nVt_Vdi_bi)*qs_Vdbulk_di+((2.0*nVt_Vdbulk_di))*qs_Vdi_bi+(2.0*nVt)*qs_Vdi_bi_Vdbulk_di)+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vdbulk_di));
  vdsatedge_Vdi_bi_Vsbulk_si=(+(+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vsbulk_si)*qs+(2.0*nVt_Vdi_bi)*qs_Vsbulk_si+((2.0*nVt_Vsbulk_si))*qs_Vdi_bi+(2.0*nVt)*qs_Vdi_bi_Vsbulk_si)+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vsbulk_si));
  vdsatedge_Vdi_bi_Vgi_bi=(+(+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vgi_bi)*qs+(2.0*nVt_Vdi_bi)*qs_Vgi_bi+((2.0*nVt_Vgi_bi))*qs_Vdi_bi+(2.0*nVt)*qs_Vdi_bi_Vgi_bi)+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vgi_bi));
  vdsatedge_Vdi_bi_Vdi_bi=(+(+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vdi_bi)*qs+(2.0*nVt_Vdi_bi)*qs_Vdi_bi+((2.0*nVt_Vdi_bi))*qs_Vdi_bi+(2.0*nVt)*qs_Vdi_bi_Vdi_bi)+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vdi_bi));
  vdsatedge_Vdi_bi_Vsi_bi=(+(+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vsi_bi)*qs+(2.0*nVt_Vdi_bi)*qs_Vsi_bi+((2.0*nVt_Vsi_bi))*qs_Vdi_bi+(2.0*nVt)*qs_Vdi_bi_Vsi_bi)+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Vsi_bi));
  vdsatedge_Vdi_bi_Tempt_GND=(+(+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Tempt_GND)*qs+(2.0*nVt_Vdi_bi)*qs_Tempt_GND+((2.0*nVt_Tempt_GND))*qs_Vdi_bi+(2.0*nVt)*qs_Vdi_bi_Tempt_GND)+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vdi_bi+2.0*nVt_Vdi_bi_Tempt_GND));
  vdsatedge_Vdi_bi_Vgm_di=(+(+(+0.0*nVt+0.0*0.0+0.0*nVt_Vdi_bi+2.0*0.0)*qs+(2.0*nVt_Vdi_bi)*qs_Vgm_di+(0.0)*qs_Vdi_bi+(2.0*nVt)*qs_Vdi_bi_Vgm_di)+(+0.0*nVt+0.0*0.0+0.0*nVt_Vdi_bi+2.0*0.0));
#endif
vdsatedge_Vsi_bi=((((2.0*nVt_Vsi_bi)*qs)+((2.0*nVt)*qs_Vsi_bi))+(2.0*nVt_Vsi_bi));
#if defined(_DERIVATE2)
  vdsatedge_Vsi_bi_Vgm_si=(+(+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vgm_si)*qs+(2.0*nVt_Vsi_bi)*qs_Vgm_si+((2.0*nVt_Vgm_si))*qs_Vsi_bi+(2.0*nVt)*qs_Vsi_bi_Vgm_si)+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vgm_si));
  vdsatedge_Vsi_bi_Vdbulk_di=(+(+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vdbulk_di)*qs+(2.0*nVt_Vsi_bi)*qs_Vdbulk_di+((2.0*nVt_Vdbulk_di))*qs_Vsi_bi+(2.0*nVt)*qs_Vsi_bi_Vdbulk_di)+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vdbulk_di));
  vdsatedge_Vsi_bi_Vsbulk_si=(+(+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vsbulk_si)*qs+(2.0*nVt_Vsi_bi)*qs_Vsbulk_si+((2.0*nVt_Vsbulk_si))*qs_Vsi_bi+(2.0*nVt)*qs_Vsi_bi_Vsbulk_si)+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vsbulk_si));
  vdsatedge_Vsi_bi_Vgi_bi=(+(+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vgi_bi)*qs+(2.0*nVt_Vsi_bi)*qs_Vgi_bi+((2.0*nVt_Vgi_bi))*qs_Vsi_bi+(2.0*nVt)*qs_Vsi_bi_Vgi_bi)+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vgi_bi));
  vdsatedge_Vsi_bi_Vdi_bi=(+(+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vdi_bi)*qs+(2.0*nVt_Vsi_bi)*qs_Vdi_bi+((2.0*nVt_Vdi_bi))*qs_Vsi_bi+(2.0*nVt)*qs_Vsi_bi_Vdi_bi)+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vdi_bi));
  vdsatedge_Vsi_bi_Vsi_bi=(+(+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vsi_bi)*qs+(2.0*nVt_Vsi_bi)*qs_Vsi_bi+((2.0*nVt_Vsi_bi))*qs_Vsi_bi+(2.0*nVt)*qs_Vsi_bi_Vsi_bi)+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Vsi_bi));
  vdsatedge_Vsi_bi_Tempt_GND=(+(+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Tempt_GND)*qs+(2.0*nVt_Vsi_bi)*qs_Tempt_GND+((2.0*nVt_Tempt_GND))*qs_Vsi_bi+(2.0*nVt)*qs_Vsi_bi_Tempt_GND)+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*nVt_Vsi_bi+2.0*nVt_Vsi_bi_Tempt_GND));
  vdsatedge_Vsi_bi_Vgm_di=(+(+(+0.0*nVt+0.0*0.0+0.0*nVt_Vsi_bi+2.0*0.0)*qs+(2.0*nVt_Vsi_bi)*qs_Vgm_di+(0.0)*qs_Vsi_bi+(2.0*nVt)*qs_Vsi_bi_Vgm_di)+(+0.0*nVt+0.0*0.0+0.0*nVt_Vsi_bi+2.0*0.0));
#endif
#if defined(_DERIVATE)
vdsatedge_Tempt_GND=((((2.0*nVt_Tempt_GND)*qs)+((2.0*nVt)*qs_Tempt_GND))+(2.0*nVt_Tempt_GND));
#endif
vdsatedge_Vgm_di=((2.0*nVt)*qs_Vgm_di);
#if defined(_DERIVATE2)
  vdsatedge_Vgm_di_Vgm_si=(+(+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*0.0+2.0*0.0)*qs+0.0*qs_Vgm_si+((2.0*nVt_Vgm_si))*qs_Vgm_di+(2.0*nVt)*qs_Vgm_di_Vgm_si)+(+0.0*nVt+0.0*nVt_Vgm_si+0.0*0.0+2.0*0.0));
  vdsatedge_Vgm_di_Vdbulk_di=(+(+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*0.0+2.0*0.0)*qs+0.0*qs_Vdbulk_di+((2.0*nVt_Vdbulk_di))*qs_Vgm_di+(2.0*nVt)*qs_Vgm_di_Vdbulk_di)+(+0.0*nVt+0.0*nVt_Vdbulk_di+0.0*0.0+2.0*0.0));
  vdsatedge_Vgm_di_Vsbulk_si=(+(+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*0.0+2.0*0.0)*qs+0.0*qs_Vsbulk_si+((2.0*nVt_Vsbulk_si))*qs_Vgm_di+(2.0*nVt)*qs_Vgm_di_Vsbulk_si)+(+0.0*nVt+0.0*nVt_Vsbulk_si+0.0*0.0+2.0*0.0));
  vdsatedge_Vgm_di_Vgi_bi=(+(+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*0.0+2.0*0.0)*qs+0.0*qs_Vgi_bi+((2.0*nVt_Vgi_bi))*qs_Vgm_di+(2.0*nVt)*qs_Vgm_di_Vgi_bi)+(+0.0*nVt+0.0*nVt_Vgi_bi+0.0*0.0+2.0*0.0));
  vdsatedge_Vgm_di_Vdi_bi=(+(+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*0.0+2.0*0.0)*qs+0.0*qs_Vdi_bi+((2.0*nVt_Vdi_bi))*qs_Vgm_di+(2.0*nVt)*qs_Vgm_di_Vdi_bi)+(+0.0*nVt+0.0*nVt_Vdi_bi+0.0*0.0+2.0*0.0));
  vdsatedge_Vgm_di_Vsi_bi=(+(+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*0.0+2.0*0.0)*qs+0.0*qs_Vsi_bi+((2.0*nVt_Vsi_bi))*qs_Vgm_di+(2.0*nVt)*qs_Vgm_di_Vsi_bi)+(+0.0*nVt+0.0*nVt_Vsi_bi+0.0*0.0+2.0*0.0));
  vdsatedge_Vgm_di_Tempt_GND=(+(+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*0.0+2.0*0.0)*qs+0.0*qs_Tempt_GND+((2.0*nVt_Tempt_GND))*qs_Vgm_di+(2.0*nVt)*qs_Vgm_di_Tempt_GND)+(+0.0*nVt+0.0*nVt_Tempt_GND+0.0*0.0+2.0*0.0));
  vdsatedge_Vgm_di_Vgm_di=(+(+(+0.0*nVt+0.0*0.0+0.0*0.0+2.0*0.0)*qs+0.0*qs_Vgm_di+(0.0)*qs_Vgm_di+(2.0*nVt)*qs_Vgm_di_Vgm_di)+(+0.0*nVt+0.0*0.0+0.0*0.0+2.0*0.0));
#endif
#endif
vdsatedge=(((2.0*nVt)*qs)+(2.0*nVt));
EXIT_IF_ISNAN((((2.0*nVt)*qs)+(2.0*nVt)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(gm,di) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
#if defined(_DERIVATE)
Vdsatedge_Vgm_si=vdsatedge_Vgm_si;
#endif
Vdsatedge_Vdbulk_di=vdsatedge_Vdbulk_di;
#if defined(_DERIVATE2)
  Vdsatedge_Vdbulk_di_Vgm_si=vdsatedge_Vdbulk_di_Vgm_si;
  Vdsatedge_Vdbulk_di_Vdbulk_di=vdsatedge_Vdbulk_di_Vdbulk_di;
  Vdsatedge_Vdbulk_di_Vsbulk_si=vdsatedge_Vdbulk_di_Vsbulk_si;
  Vdsatedge_Vdbulk_di_Vgi_bi=vdsatedge_Vdbulk_di_Vgi_bi;
  Vdsatedge_Vdbulk_di_Vdi_bi=vdsatedge_Vdbulk_di_Vdi_bi;
  Vdsatedge_Vdbulk_di_Vsi_bi=vdsatedge_Vdbulk_di_Vsi_bi;
  Vdsatedge_Vdbulk_di_Tempt_GND=vdsatedge_Vdbulk_di_Tempt_GND;
  Vdsatedge_Vdbulk_di_Vgm_di=vdsatedge_Vdbulk_di_Vgm_di;
#endif
#if defined(_DERIVATE)
Vdsatedge_Vsbulk_si=vdsatedge_Vsbulk_si;
#endif
Vdsatedge_Vgi_bi=vdsatedge_Vgi_bi;
#if defined(_DERIVATE2)
  Vdsatedge_Vgi_bi_Vgm_si=vdsatedge_Vgi_bi_Vgm_si;
  Vdsatedge_Vgi_bi_Vdbulk_di=vdsatedge_Vgi_bi_Vdbulk_di;
  Vdsatedge_Vgi_bi_Vsbulk_si=vdsatedge_Vgi_bi_Vsbulk_si;
  Vdsatedge_Vgi_bi_Vgi_bi=vdsatedge_Vgi_bi_Vgi_bi;
  Vdsatedge_Vgi_bi_Vdi_bi=vdsatedge_Vgi_bi_Vdi_bi;
  Vdsatedge_Vgi_bi_Vsi_bi=vdsatedge_Vgi_bi_Vsi_bi;
  Vdsatedge_Vgi_bi_Tempt_GND=vdsatedge_Vgi_bi_Tempt_GND;
  Vdsatedge_Vgi_bi_Vgm_di=vdsatedge_Vgi_bi_Vgm_di;
#endif
Vdsatedge_Vdi_bi=vdsatedge_Vdi_bi;
#if defined(_DERIVATE2)
  Vdsatedge_Vdi_bi_Vgm_si=vdsatedge_Vdi_bi_Vgm_si;
  Vdsatedge_Vdi_bi_Vdbulk_di=vdsatedge_Vdi_bi_Vdbulk_di;
  Vdsatedge_Vdi_bi_Vsbulk_si=vdsatedge_Vdi_bi_Vsbulk_si;
  Vdsatedge_Vdi_bi_Vgi_bi=vdsatedge_Vdi_bi_Vgi_bi;
  Vdsatedge_Vdi_bi_Vdi_bi=vdsatedge_Vdi_bi_Vdi_bi;
  Vdsatedge_Vdi_bi_Vsi_bi=vdsatedge_Vdi_bi_Vsi_bi;
  Vdsatedge_Vdi_bi_Tempt_GND=vdsatedge_Vdi_bi_Tempt_GND;
  Vdsatedge_Vdi_bi_Vgm_di=vdsatedge_Vdi_bi_Vgm_di;
#endif
Vdsatedge_Vsi_bi=vdsatedge_Vsi_bi;
#if defined(_DERIVATE2)
  Vdsatedge_Vsi_bi_Vgm_si=vdsatedge_Vsi_bi_Vgm_si;
  Vdsatedge_Vsi_bi_Vdbulk_di=vdsatedge_Vsi_bi_Vdbulk_di;
  Vdsatedge_Vsi_bi_Vsbulk_si=vdsatedge_Vsi_bi_Vsbulk_si;
  Vdsatedge_Vsi_bi_Vgi_bi=vdsatedge_Vsi_bi_Vgi_bi;
  Vdsatedge_Vsi_bi_Vdi_bi=vdsatedge_Vsi_bi_Vdi_bi;
  Vdsatedge_Vsi_bi_Vsi_bi=vdsatedge_Vsi_bi_Vsi_bi;
  Vdsatedge_Vsi_bi_Tempt_GND=vdsatedge_Vsi_bi_Tempt_GND;
  Vdsatedge_Vsi_bi_Vgm_di=vdsatedge_Vsi_bi_Vgm_di;
#endif
#if defined(_DERIVATE)
Vdsatedge_Tempt_GND=vdsatedge_Tempt_GND;
#endif
Vdsatedge_Vgm_di=vdsatedge_Vgm_di;
#if defined(_DERIVATE2)
  Vdsatedge_Vgm_di_Vgm_si=vdsatedge_Vgm_di_Vgm_si;
  Vdsatedge_Vgm_di_Vdbulk_di=vdsatedge_Vgm_di_Vdbulk_di;
  Vdsatedge_Vgm_di_Vsbulk_si=vdsatedge_Vgm_di_Vsbulk_si;
  Vdsatedge_Vgm_di_Vgi_bi=vdsatedge_Vgm_di_Vgi_bi;
  Vdsatedge_Vgm_di_Vdi_bi=vdsatedge_Vgm_di_Vdi_bi;
  Vdsatedge_Vgm_di_Vsi_bi=vdsatedge_Vgm_di_Vsi_bi;
  Vdsatedge_Vgm_di_Tempt_GND=vdsatedge_Vgm_di_Tempt_GND;
  Vdsatedge_Vgm_di_Vgm_di=vdsatedge_Vgm_di_Vgm_di;
#endif
#endif
Vdsatedge=vdsatedge;
EXIT_IF_ISNAN(vdsatedge)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(gm,di) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
#if defined(_DERIVATE)
Vdsatedge_Vgm_si=Vdsatedge_Vgm_si;
#endif
Vdsatedge_Vdbulk_di=Vdsatedge_Vdbulk_di;
#if defined(_DERIVATE2)
  Vdsatedge_Vdbulk_di_Vgm_si=(+Vdsatedge_Vdbulk_di_Vgm_si+0.0);
  Vdsatedge_Vdbulk_di_Vdbulk_di=(+Vdsatedge_Vdbulk_di_Vdbulk_di+0.0);
  Vdsatedge_Vdbulk_di_Vsbulk_si=(+Vdsatedge_Vdbulk_di_Vsbulk_si+0.0);
  Vdsatedge_Vdbulk_di_Vgi_bi=(+Vdsatedge_Vdbulk_di_Vgi_bi+0.0);
  Vdsatedge_Vdbulk_di_Vdi_bi=(+Vdsatedge_Vdbulk_di_Vdi_bi+0.0);
  Vdsatedge_Vdbulk_di_Vsi_bi=(+Vdsatedge_Vdbulk_di_Vsi_bi+0.0);
  Vdsatedge_Vdbulk_di_Tempt_GND=(+Vdsatedge_Vdbulk_di_Tempt_GND+0.0);
  Vdsatedge_Vdbulk_di_Vgm_di=(+Vdsatedge_Vdbulk_di_Vgm_di+0.0);
#endif
#if defined(_DERIVATE)
Vdsatedge_Vsbulk_si=Vdsatedge_Vsbulk_si;
#endif
Vdsatedge_Vgi_bi=Vdsatedge_Vgi_bi;
#if defined(_DERIVATE2)
  Vdsatedge_Vgi_bi_Vgm_si=(+Vdsatedge_Vgi_bi_Vgm_si+0.0);
  Vdsatedge_Vgi_bi_Vdbulk_di=(+Vdsatedge_Vgi_bi_Vdbulk_di+0.0);
  Vdsatedge_Vgi_bi_Vsbulk_si=(+Vdsatedge_Vgi_bi_Vsbulk_si+0.0);
  Vdsatedge_Vgi_bi_Vgi_bi=(+Vdsatedge_Vgi_bi_Vgi_bi+0.0);
  Vdsatedge_Vgi_bi_Vdi_bi=(+Vdsatedge_Vgi_bi_Vdi_bi+0.0);
  Vdsatedge_Vgi_bi_Vsi_bi=(+Vdsatedge_Vgi_bi_Vsi_bi+0.0);
  Vdsatedge_Vgi_bi_Tempt_GND=(+Vdsatedge_Vgi_bi_Tempt_GND+0.0);
  Vdsatedge_Vgi_bi_Vgm_di=(+Vdsatedge_Vgi_bi_Vgm_di+0.0);
#endif
Vdsatedge_Vdi_bi=(Vdsatedge_Vdi_bi+Vs_Vdi_bi);
#if defined(_DERIVATE2)
  Vdsatedge_Vdi_bi_Vgm_si=(+Vdsatedge_Vdi_bi_Vgm_si+0.0);
  Vdsatedge_Vdi_bi_Vdbulk_di=(+Vdsatedge_Vdi_bi_Vdbulk_di+0.0);
  Vdsatedge_Vdi_bi_Vsbulk_si=(+Vdsatedge_Vdi_bi_Vsbulk_si+0.0);
  Vdsatedge_Vdi_bi_Vgi_bi=(+Vdsatedge_Vdi_bi_Vgi_bi+0.0);
  Vdsatedge_Vdi_bi_Vdi_bi=(+Vdsatedge_Vdi_bi_Vdi_bi+Vs_Vdi_bi_Vdi_bi);
  Vdsatedge_Vdi_bi_Vsi_bi=(+Vdsatedge_Vdi_bi_Vsi_bi+Vs_Vdi_bi_Vsi_bi);
  Vdsatedge_Vdi_bi_Tempt_GND=(+Vdsatedge_Vdi_bi_Tempt_GND+0.0);
  Vdsatedge_Vdi_bi_Vgm_di=(+Vdsatedge_Vdi_bi_Vgm_di+0.0);
#endif
Vdsatedge_Vsi_bi=(Vdsatedge_Vsi_bi+Vs_Vsi_bi);
#if defined(_DERIVATE2)
  Vdsatedge_Vsi_bi_Vgm_si=(+Vdsatedge_Vsi_bi_Vgm_si+0.0);
  Vdsatedge_Vsi_bi_Vdbulk_di=(+Vdsatedge_Vsi_bi_Vdbulk_di+0.0);
  Vdsatedge_Vsi_bi_Vsbulk_si=(+Vdsatedge_Vsi_bi_Vsbulk_si+0.0);
  Vdsatedge_Vsi_bi_Vgi_bi=(+Vdsatedge_Vsi_bi_Vgi_bi+0.0);
  Vdsatedge_Vsi_bi_Vdi_bi=(+Vdsatedge_Vsi_bi_Vdi_bi+Vs_Vsi_bi_Vdi_bi);
  Vdsatedge_Vsi_bi_Vsi_bi=(+Vdsatedge_Vsi_bi_Vsi_bi+Vs_Vsi_bi_Vsi_bi);
  Vdsatedge_Vsi_bi_Tempt_GND=(+Vdsatedge_Vsi_bi_Tempt_GND+0.0);
  Vdsatedge_Vsi_bi_Vgm_di=(+Vdsatedge_Vsi_bi_Vgm_di+0.0);
#endif
#if defined(_DERIVATE)
Vdsatedge_Tempt_GND=Vdsatedge_Tempt_GND;
#endif
Vdsatedge_Vgm_di=Vdsatedge_Vgm_di;
#if defined(_DERIVATE2)
  Vdsatedge_Vgm_di_Vgm_si=(+Vdsatedge_Vgm_di_Vgm_si+0.0);
  Vdsatedge_Vgm_di_Vdbulk_di=(+Vdsatedge_Vgm_di_Vdbulk_di+0.0);
  Vdsatedge_Vgm_di_Vsbulk_si=(+Vdsatedge_Vgm_di_Vsbulk_si+0.0);
  Vdsatedge_Vgm_di_Vgi_bi=(+Vdsatedge_Vgm_di_Vgi_bi+0.0);
  Vdsatedge_Vgm_di_Vdi_bi=(+Vdsatedge_Vgm_di_Vdi_bi+0.0);
  Vdsatedge_Vgm_di_Vsi_bi=(+Vdsatedge_Vgm_di_Vsi_bi+0.0);
  Vdsatedge_Vgm_di_Tempt_GND=(+Vdsatedge_Vgm_di_Tempt_GND+0.0);
  Vdsatedge_Vgm_di_Vgm_di=(+Vdsatedge_Vgm_di_Vgm_di+0.0);
#endif
#endif
Vdsatedge=(Vdsatedge+Vs);
EXIT_IF_ISNAN((Vdsatedge+Vs))
{
double m00_sqrt(d00_sqrt0,(((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND)V(gm,di) ddxprobe=V(gi,GND)V(bi,GND)V(di,GND) */
#if defined(_DERIVATE)
Vdssate_Vgm_si=(0.5*(Vdsatedge_Vgm_si+((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si))*d10_sqrt0));
#endif
Vdssate_Vdbulk_di=(0.5*(Vdsatedge_Vdbulk_di+((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  Vdssate_Vdbulk_di_Vgm_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_si+((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdbulk_di_Vgm_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdbulk_di_Vgm_si-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vdbulk_di*Vdsatedge_Vgm_si+Vdsatedge_Vgm_si*Vdsatedge_Vdbulk_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdbulk_di_Vgm_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdbulk_di_Vdbulk_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdbulk_di_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdbulk_di_Vdbulk_di-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vdbulk_di*Vdsatedge_Vdbulk_di+Vdsatedge_Vdbulk_di*Vdsatedge_Vdbulk_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdbulk_di_Vdbulk_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdbulk_di_Vsbulk_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vsbulk_si+((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdbulk_di_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdbulk_di_Vsbulk_si-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vdbulk_di*Vdsatedge_Vsbulk_si+Vdsatedge_Vsbulk_si*Vdsatedge_Vdbulk_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdbulk_di_Vsbulk_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdbulk_di_Vgi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdbulk_di_Vgi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdbulk_di_Vgi_bi-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vdbulk_di*Vdsatedge_Vgi_bi+Vdsatedge_Vgi_bi*Vdsatedge_Vdbulk_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdbulk_di_Vgi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdbulk_di_Vdi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdbulk_di_Vdi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdbulk_di_Vdi_bi-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vdbulk_di*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*Vdsatedge_Vdbulk_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdbulk_di_Vdi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdbulk_di_Vsi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdbulk_di_Vsi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdbulk_di_Vsi_bi-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vdbulk_di*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*Vdsatedge_Vdbulk_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdbulk_di_Vsi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdbulk_di_Tempt_GND=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Tempt_GND+((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdbulk_di_Tempt_GND-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdbulk_di_Tempt_GND-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vdbulk_di*Vdsatedge_Tempt_GND+Vdsatedge_Tempt_GND*Vdsatedge_Vdbulk_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdbulk_di_Tempt_GND-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdbulk_di_Vgm_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_di+((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdbulk_di_Vgm_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdbulk_di_Vgm_di-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vdbulk_di*Vdsatedge_Vgm_di+Vdsatedge_Vgm_di*Vdsatedge_Vdbulk_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdbulk_di_Vgm_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
#endif
#if defined(_DERIVATE)
Vdssate_Vsbulk_si=(0.5*(Vdsatedge_Vsbulk_si+((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si))*d10_sqrt0));
#endif
Vdssate_Vgi_bi=(0.5*(Vdsatedge_Vgi_bi+((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  Vdssate_Vgi_bi_Vgm_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_si+((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgi_bi_Vgm_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgi_bi_Vgm_si-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgi_bi*Vdsatedge_Vgm_si+Vdsatedge_Vgm_si*Vdsatedge_Vgi_bi+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgi_bi_Vgm_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgi_bi_Vdbulk_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgi_bi_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgi_bi_Vdbulk_di-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgi_bi*Vdsatedge_Vdbulk_di+Vdsatedge_Vdbulk_di*Vdsatedge_Vgi_bi+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgi_bi_Vdbulk_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgi_bi_Vsbulk_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vsbulk_si+((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgi_bi_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgi_bi_Vsbulk_si-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgi_bi*Vdsatedge_Vsbulk_si+Vdsatedge_Vsbulk_si*Vdsatedge_Vgi_bi+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgi_bi_Vsbulk_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgi_bi_Vgi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgi_bi_Vgi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgi_bi_Vgi_bi-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgi_bi*Vdsatedge_Vgi_bi+Vdsatedge_Vgi_bi*Vdsatedge_Vgi_bi+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgi_bi_Vgi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgi_bi_Vdi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgi_bi_Vdi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgi_bi_Vdi_bi-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgi_bi*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*Vdsatedge_Vgi_bi+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgi_bi_Vdi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgi_bi_Vsi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgi_bi_Vsi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgi_bi_Vsi_bi-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgi_bi*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*Vdsatedge_Vgi_bi+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgi_bi_Vsi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgi_bi_Tempt_GND=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Tempt_GND+((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgi_bi_Tempt_GND-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgi_bi_Tempt_GND-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgi_bi*Vdsatedge_Tempt_GND+Vdsatedge_Tempt_GND*Vdsatedge_Vgi_bi+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgi_bi_Tempt_GND-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgi_bi_Vgm_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_di+((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgi_bi_Vgm_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgi_bi_Vgm_di-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgi_bi*Vdsatedge_Vgm_di+Vdsatedge_Vgm_di*Vdsatedge_Vgi_bi+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgi_bi_Vgm_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
#endif
Vdssate_Vdi_bi=(0.5*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  Vdssate_Vdi_bi_Vgm_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_si+((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdi_bi_Vgm_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdi_bi_Vgm_si-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*Vdsatedge_Vgm_si+Vdsatedge_Vgm_si*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdi_bi_Vgm_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdi_bi_Vdbulk_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdi_bi_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdi_bi_Vdbulk_di-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*Vdsatedge_Vdbulk_di+Vdsatedge_Vdbulk_di*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdi_bi_Vdbulk_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdi_bi_Vsbulk_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vsbulk_si+((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdi_bi_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdi_bi_Vsbulk_si-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*Vdsatedge_Vsbulk_si+Vdsatedge_Vsbulk_si*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdi_bi_Vsbulk_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdi_bi_Vgi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdi_bi_Vgi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdi_bi_Vgi_bi-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*Vdsatedge_Vgi_bi+Vdsatedge_Vgi_bi*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdi_bi_Vgi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdi_bi_Vdi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdi_bi_Vdi_bi-Vs_Vdi_bi_Vdi_bi)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdi_bi_Vsi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdi_bi_Vsi_bi-Vs_Vdi_bi_Vsi_bi)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdi_bi_Tempt_GND=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Tempt_GND+((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdi_bi_Tempt_GND-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdi_bi_Tempt_GND-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*Vdsatedge_Tempt_GND+Vdsatedge_Tempt_GND*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdi_bi_Tempt_GND-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vdi_bi_Vgm_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_di+((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vdi_bi_Vgm_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*(((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vdi_bi_Vgm_di-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*Vdsatedge_Vgm_di+Vdsatedge_Vgm_di*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vdi_bi_Vgm_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
#endif
Vdssate_Vsi_bi=(0.5*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0));
#if defined(_DERIVATE2)
  Vdssate_Vsi_bi_Vgm_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_si+((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vsi_bi_Vgm_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vsi_bi_Vgm_si-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*Vdsatedge_Vgm_si+Vdsatedge_Vgm_si*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vsi_bi_Vgm_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vsi_bi_Vdbulk_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vsi_bi_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vsi_bi_Vdbulk_di-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*Vdsatedge_Vdbulk_di+Vdsatedge_Vdbulk_di*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vsi_bi_Vdbulk_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vsi_bi_Vsbulk_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vsbulk_si+((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vsi_bi_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vsi_bi_Vsbulk_si-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*Vdsatedge_Vsbulk_si+Vdsatedge_Vsbulk_si*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vsi_bi_Vsbulk_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vsi_bi_Vgi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vsi_bi_Vgi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vsi_bi_Vgi_bi-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*Vdsatedge_Vgi_bi+Vdsatedge_Vgi_bi*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vsi_bi_Vgi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vsi_bi_Vdi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vsi_bi_Vdi_bi-Vs_Vsi_bi_Vdi_bi)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vsi_bi_Vsi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vsi_bi_Vsi_bi-Vs_Vsi_bi_Vsi_bi)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vsi_bi_Tempt_GND=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Tempt_GND+((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vsi_bi_Tempt_GND-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vsi_bi_Tempt_GND-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*Vdsatedge_Tempt_GND+Vdsatedge_Tempt_GND*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vsi_bi_Tempt_GND-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vsi_bi_Vgm_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_di+((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vsi_bi_Vgm_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*(((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)))+d10_sqrt0*(+(+(+(+Vdsatedge_Vsi_bi_Vgm_di-0.0)-0.0)*(Vdsatedge-Vs)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*Vdsatedge_Vgm_di+Vdsatedge_Vgm_di*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge-Vs)*(+(+Vdsatedge_Vsi_bi_Vgm_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
#endif
#if defined(_DERIVATE)
Vdssate_Tempt_GND=(0.5*(Vdsatedge_Tempt_GND+((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND))*d10_sqrt0));
#endif
Vdssate_Vgm_di=(0.5*(Vdsatedge_Vgm_di+((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  Vdssate_Vgm_di_Vgm_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_si+((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgm_di+((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgm_di_Vgm_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_si)))+((0.0)*1.0e-3))*((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgm_di_Vgm_si-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgm_di*Vdsatedge_Vgm_si+Vdsatedge_Vgm_si*Vdsatedge_Vgm_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgm_di_Vgm_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgm_di_Vdbulk_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vdbulk_di+((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgm_di+((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgm_di_Vdbulk_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vdbulk_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vdbulk_di)))+((0.0)*1.0e-3))*((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgm_di_Vdbulk_di-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgm_di*Vdsatedge_Vdbulk_di+Vdsatedge_Vdbulk_di*Vdsatedge_Vgm_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgm_di_Vdbulk_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgm_di_Vsbulk_si=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vsbulk_si+((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgm_di+((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgm_di_Vsbulk_si-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vsbulk_si*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vsbulk_si)))+((0.0)*1.0e-3))*((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgm_di_Vsbulk_si-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgm_di*Vdsatedge_Vsbulk_si+Vdsatedge_Vsbulk_si*Vdsatedge_Vgm_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgm_di_Vsbulk_si-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgm_di_Vgi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgi_bi+((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgm_di+((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgm_di_Vgi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgi_bi*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgi_bi)))+((0.0)*1.0e-3))*((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgm_di_Vgi_bi-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgm_di*Vdsatedge_Vgi_bi+Vdsatedge_Vgi_bi*Vdsatedge_Vgm_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgm_di_Vgi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgm_di_Vdi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgm_di+((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgm_di_Vdi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vdi_bi-Vs_Vdi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vdi_bi-Vs_Vdi_bi))))+((0.0)*1.0e-3))*((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgm_di_Vdi_bi-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgm_di*(Vdsatedge_Vdi_bi-Vs_Vdi_bi)+(Vdsatedge_Vdi_bi-Vs_Vdi_bi)*Vdsatedge_Vgm_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgm_di_Vdi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgm_di_Vsi_bi=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*((Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgm_di+((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgm_di_Vsi_bi-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*(((((Vdsatedge_Vsi_bi-Vs_Vsi_bi)*(Vdsatedge-Vs))+((Vdsatedge-Vs)*(Vdsatedge_Vsi_bi-Vs_Vsi_bi))))+((0.0)*1.0e-3))*((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgm_di_Vsi_bi-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgm_di*(Vdsatedge_Vsi_bi-Vs_Vsi_bi)+(Vdsatedge_Vsi_bi-Vs_Vsi_bi)*Vdsatedge_Vgm_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgm_di_Vsi_bi-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgm_di_Tempt_GND=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Tempt_GND+((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgm_di+((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgm_di_Tempt_GND-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Tempt_GND*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Tempt_GND)))+((0.0)*1.0e-3))*((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgm_di_Tempt_GND-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgm_di*Vdsatedge_Tempt_GND+Vdsatedge_Tempt_GND*Vdsatedge_Vgm_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgm_di_Tempt_GND-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
  Vdssate_Vgm_di_Vgm_di=(+0.0*((Vdsatedge-Vs)+d00_sqrt0)+0.0*(Vdsatedge_Vgm_di+((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*d10_sqrt0)+0.0*(Vdsatedge_Vgm_di+((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))*d10_sqrt0)+0.5*(+(+(+Vdsatedge_Vgm_di_Vgm_di-0.0)+0.0)+(m20_sqrt((((Vdsatedge-Vs)*(Vdsatedge-Vs))+((0.25*1.0e-3)*1.0e-3)))*((((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di)))+((0.0)*1.0e-3))*((Vdsatedge_Vgm_di*(Vdsatedge-Vs))+((Vdsatedge-Vs)*Vdsatedge_Vgm_di))+d10_sqrt0*(+(+(+(+Vdsatedge_Vgm_di_Vgm_di-0.0)-0.0)*(Vdsatedge-Vs)+Vdsatedge_Vgm_di*Vdsatedge_Vgm_di+Vdsatedge_Vgm_di*Vdsatedge_Vgm_di+(Vdsatedge-Vs)*(+(+Vdsatedge_Vgm_di_Vgm_di-0.0)-0.0))+(+(+0.0*1.0e-3+0.0*0.0+0.0*0.0+0.25*0.0)*1.0e-3+0.0*0.0+(0.0)*0.0+(0.25*1.0e-3)*0.0)))));
#endif
#endif
Vdssate=(0.5*((Vdsatedge-Vs)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((Vdsatedge-Vs)+d00_sqrt0)))
}
{
double m00_pow(d00_pow0,(Vds/Vdssate),(1.0/DELTA_t))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(Vds/Vdssate),(1.0/DELTA_t))
double m11_pow(d11_pow0,d00_pow0,(Vds/Vdssate),(1.0/DELTA_t))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=(d10_pow0*(-Vds*Vdssate_Vgm_si/Vdssate/Vdssate));
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=fixme;
  T7_Vgm_si_Vgm_di=fixme;
  T7_Vgm_si_Vdbulk_di=fixme;
  T7_Vgm_si_Vsbulk_si=fixme;
  T7_Vgm_si_Vgi_bi=fixme;
  T7_Vgm_si_Vdi_bi=fixme;
  T7_Vgm_si_Vsi_bi=fixme;
  T7_Vgm_si_Tempt_GND=fixme;
#endif
T7_Vgm_di=(d10_pow0*(-Vds*Vdssate_Vgm_di/Vdssate/Vdssate));
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=fixme;
  T7_Vgm_di_Vgm_di=fixme;
  T7_Vgm_di_Vdbulk_di=fixme;
  T7_Vgm_di_Vsbulk_si=fixme;
  T7_Vgm_di_Vgi_bi=fixme;
  T7_Vgm_di_Vdi_bi=fixme;
  T7_Vgm_di_Vsi_bi=fixme;
  T7_Vgm_di_Tempt_GND=fixme;
#endif
T7_Vdbulk_di=(d10_pow0*(-Vds*Vdssate_Vdbulk_di/Vdssate/Vdssate));
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=fixme;
  T7_Vdbulk_di_Vgm_di=fixme;
  T7_Vdbulk_di_Vdbulk_di=fixme;
  T7_Vdbulk_di_Vsbulk_si=fixme;
  T7_Vdbulk_di_Vgi_bi=fixme;
  T7_Vdbulk_di_Vdi_bi=fixme;
  T7_Vdbulk_di_Vsi_bi=fixme;
  T7_Vdbulk_di_Tempt_GND=fixme;
#endif
T7_Vsbulk_si=(d10_pow0*(-Vds*Vdssate_Vsbulk_si/Vdssate/Vdssate));
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=fixme;
  T7_Vsbulk_si_Vgm_di=fixme;
  T7_Vsbulk_si_Vdbulk_di=fixme;
  T7_Vsbulk_si_Vsbulk_si=fixme;
  T7_Vsbulk_si_Vgi_bi=fixme;
  T7_Vsbulk_si_Vdi_bi=fixme;
  T7_Vsbulk_si_Vsi_bi=fixme;
  T7_Vsbulk_si_Tempt_GND=fixme;
#endif
T7_Vgi_bi=(d10_pow0*(-Vds*Vdssate_Vgi_bi/Vdssate/Vdssate));
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=fixme;
  T7_Vgi_bi_Vgm_di=fixme;
  T7_Vgi_bi_Vdbulk_di=fixme;
  T7_Vgi_bi_Vsbulk_si=fixme;
  T7_Vgi_bi_Vgi_bi=fixme;
  T7_Vgi_bi_Vdi_bi=fixme;
  T7_Vgi_bi_Vsi_bi=fixme;
  T7_Vgi_bi_Tempt_GND=fixme;
#endif
T7_Vdi_bi=(d10_pow0*((Vds_Vdi_bi*Vdssate-Vds*Vdssate_Vdi_bi)/Vdssate/Vdssate));
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=fixme;
  T7_Vdi_bi_Vgm_di=fixme;
  T7_Vdi_bi_Vdbulk_di=fixme;
  T7_Vdi_bi_Vsbulk_si=fixme;
  T7_Vdi_bi_Vgi_bi=fixme;
  T7_Vdi_bi_Vdi_bi=fixme;
  T7_Vdi_bi_Vsi_bi=fixme;
  T7_Vdi_bi_Tempt_GND=fixme;
#endif
T7_Vsi_bi=(d10_pow0*((Vds_Vsi_bi*Vdssate-Vds*Vdssate_Vsi_bi)/Vdssate/Vdssate));
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=fixme;
  T7_Vsi_bi_Vgm_di=fixme;
  T7_Vsi_bi_Vdbulk_di=fixme;
  T7_Vsi_bi_Vsbulk_si=fixme;
  T7_Vsi_bi_Vgi_bi=fixme;
  T7_Vsi_bi_Vdi_bi=fixme;
  T7_Vsi_bi_Vsi_bi=fixme;
  T7_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(d10_pow0*(-Vds*Vdssate_Tempt_GND/Vdssate/Vdssate)+d11_pow0*(-DELTA_t_Tempt_GND/DELTA_t/DELTA_t));
#endif
#endif
T7=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(1.0+T7),(-DELTA_t))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0+T7),(-DELTA_t))
double m11_pow(d11_pow0,d00_pow0,(1.0+T7),(-DELTA_t))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=(d10_pow0*T7_Vgm_di);
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=fixme;
  T8_Vgm_di_Vgm_si=fixme;
  T8_Vgm_di_Vdbulk_di=fixme;
  T8_Vgm_di_Vsbulk_si=fixme;
  T8_Vgm_di_Vgi_bi=fixme;
  T8_Vgm_di_Vdi_bi=fixme;
  T8_Vgm_di_Vsi_bi=fixme;
  T8_Vgm_di_Tempt_GND=fixme;
#endif
T8_Vgm_si=(d10_pow0*T7_Vgm_si);
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=fixme;
  T8_Vgm_si_Vgm_si=fixme;
  T8_Vgm_si_Vdbulk_di=fixme;
  T8_Vgm_si_Vsbulk_si=fixme;
  T8_Vgm_si_Vgi_bi=fixme;
  T8_Vgm_si_Vdi_bi=fixme;
  T8_Vgm_si_Vsi_bi=fixme;
  T8_Vgm_si_Tempt_GND=fixme;
#endif
T8_Vdbulk_di=(d10_pow0*T7_Vdbulk_di);
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=fixme;
  T8_Vdbulk_di_Vgm_si=fixme;
  T8_Vdbulk_di_Vdbulk_di=fixme;
  T8_Vdbulk_di_Vsbulk_si=fixme;
  T8_Vdbulk_di_Vgi_bi=fixme;
  T8_Vdbulk_di_Vdi_bi=fixme;
  T8_Vdbulk_di_Vsi_bi=fixme;
  T8_Vdbulk_di_Tempt_GND=fixme;
#endif
T8_Vsbulk_si=(d10_pow0*T7_Vsbulk_si);
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=fixme;
  T8_Vsbulk_si_Vgm_si=fixme;
  T8_Vsbulk_si_Vdbulk_di=fixme;
  T8_Vsbulk_si_Vsbulk_si=fixme;
  T8_Vsbulk_si_Vgi_bi=fixme;
  T8_Vsbulk_si_Vdi_bi=fixme;
  T8_Vsbulk_si_Vsi_bi=fixme;
  T8_Vsbulk_si_Tempt_GND=fixme;
#endif
T8_Vgi_bi=(d10_pow0*T7_Vgi_bi);
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=fixme;
  T8_Vgi_bi_Vgm_si=fixme;
  T8_Vgi_bi_Vdbulk_di=fixme;
  T8_Vgi_bi_Vsbulk_si=fixme;
  T8_Vgi_bi_Vgi_bi=fixme;
  T8_Vgi_bi_Vdi_bi=fixme;
  T8_Vgi_bi_Vsi_bi=fixme;
  T8_Vgi_bi_Tempt_GND=fixme;
#endif
T8_Vdi_bi=(d10_pow0*T7_Vdi_bi);
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=fixme;
  T8_Vdi_bi_Vgm_si=fixme;
  T8_Vdi_bi_Vdbulk_di=fixme;
  T8_Vdi_bi_Vsbulk_si=fixme;
  T8_Vdi_bi_Vgi_bi=fixme;
  T8_Vdi_bi_Vdi_bi=fixme;
  T8_Vdi_bi_Vsi_bi=fixme;
  T8_Vdi_bi_Tempt_GND=fixme;
#endif
T8_Vsi_bi=(d10_pow0*T7_Vsi_bi);
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=fixme;
  T8_Vsi_bi_Vgm_si=fixme;
  T8_Vsi_bi_Vdbulk_di=fixme;
  T8_Vsi_bi_Vsbulk_si=fixme;
  T8_Vsi_bi_Vgi_bi=fixme;
  T8_Vsi_bi_Vdi_bi=fixme;
  T8_Vsi_bi_Vsi_bi=fixme;
  T8_Vsi_bi_Tempt_GND=fixme;
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(d10_pow0*T7_Tempt_GND+d11_pow0*(-DELTA_t_Tempt_GND));
#endif
#endif
T8=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
Vdseff_Vgm_di=(Vds*T8_Vgm_di);
#if defined(_DERIVATE2)
  Vdseff_Vgm_di_Vgm_di=(+0.0*T8+0.0*T8_Vgm_di+0.0*T8_Vgm_di+Vds*T8_Vgm_di_Vgm_di);
  Vdseff_Vgm_di_Vgm_si=(+0.0*T8+0.0*T8_Vgm_si+0.0*T8_Vgm_di+Vds*T8_Vgm_di_Vgm_si);
  Vdseff_Vgm_di_Vdbulk_di=(+0.0*T8+0.0*T8_Vdbulk_di+0.0*T8_Vgm_di+Vds*T8_Vgm_di_Vdbulk_di);
  Vdseff_Vgm_di_Vsbulk_si=(+0.0*T8+0.0*T8_Vsbulk_si+0.0*T8_Vgm_di+Vds*T8_Vgm_di_Vsbulk_si);
  Vdseff_Vgm_di_Vdi_bi=(+0.0*T8+0.0*T8_Vdi_bi+Vds_Vdi_bi*T8_Vgm_di+Vds*T8_Vgm_di_Vdi_bi);
  Vdseff_Vgm_di_Vsi_bi=(+0.0*T8+0.0*T8_Vsi_bi+Vds_Vsi_bi*T8_Vgm_di+Vds*T8_Vgm_di_Vsi_bi);
  Vdseff_Vgm_di_Vgi_bi=(+0.0*T8+0.0*T8_Vgi_bi+0.0*T8_Vgm_di+Vds*T8_Vgm_di_Vgi_bi);
  Vdseff_Vgm_di_Tempt_GND=(+0.0*T8+0.0*T8_Tempt_GND+0.0*T8_Vgm_di+Vds*T8_Vgm_di_Tempt_GND);
#endif
Vdseff_Vgm_si=(Vds*T8_Vgm_si);
#if defined(_DERIVATE2)
  Vdseff_Vgm_si_Vgm_di=(+0.0*T8+0.0*T8_Vgm_di+0.0*T8_Vgm_si+Vds*T8_Vgm_si_Vgm_di);
  Vdseff_Vgm_si_Vgm_si=(+0.0*T8+0.0*T8_Vgm_si+0.0*T8_Vgm_si+Vds*T8_Vgm_si_Vgm_si);
  Vdseff_Vgm_si_Vdbulk_di=(+0.0*T8+0.0*T8_Vdbulk_di+0.0*T8_Vgm_si+Vds*T8_Vgm_si_Vdbulk_di);
  Vdseff_Vgm_si_Vsbulk_si=(+0.0*T8+0.0*T8_Vsbulk_si+0.0*T8_Vgm_si+Vds*T8_Vgm_si_Vsbulk_si);
  Vdseff_Vgm_si_Vdi_bi=(+0.0*T8+0.0*T8_Vdi_bi+Vds_Vdi_bi*T8_Vgm_si+Vds*T8_Vgm_si_Vdi_bi);
  Vdseff_Vgm_si_Vsi_bi=(+0.0*T8+0.0*T8_Vsi_bi+Vds_Vsi_bi*T8_Vgm_si+Vds*T8_Vgm_si_Vsi_bi);
  Vdseff_Vgm_si_Vgi_bi=(+0.0*T8+0.0*T8_Vgi_bi+0.0*T8_Vgm_si+Vds*T8_Vgm_si_Vgi_bi);
  Vdseff_Vgm_si_Tempt_GND=(+0.0*T8+0.0*T8_Tempt_GND+0.0*T8_Vgm_si+Vds*T8_Vgm_si_Tempt_GND);
#endif
Vdseff_Vdbulk_di=(Vds*T8_Vdbulk_di);
#if defined(_DERIVATE2)
  Vdseff_Vdbulk_di_Vgm_di=(+0.0*T8+0.0*T8_Vgm_di+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vgm_di);
  Vdseff_Vdbulk_di_Vgm_si=(+0.0*T8+0.0*T8_Vgm_si+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vgm_si);
  Vdseff_Vdbulk_di_Vdbulk_di=(+0.0*T8+0.0*T8_Vdbulk_di+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vdbulk_di);
  Vdseff_Vdbulk_di_Vsbulk_si=(+0.0*T8+0.0*T8_Vsbulk_si+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vsbulk_si);
  Vdseff_Vdbulk_di_Vdi_bi=(+0.0*T8+0.0*T8_Vdi_bi+Vds_Vdi_bi*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vdi_bi);
  Vdseff_Vdbulk_di_Vsi_bi=(+0.0*T8+0.0*T8_Vsi_bi+Vds_Vsi_bi*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vsi_bi);
  Vdseff_Vdbulk_di_Vgi_bi=(+0.0*T8+0.0*T8_Vgi_bi+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Vgi_bi);
  Vdseff_Vdbulk_di_Tempt_GND=(+0.0*T8+0.0*T8_Tempt_GND+0.0*T8_Vdbulk_di+Vds*T8_Vdbulk_di_Tempt_GND);
#endif
Vdseff_Vsbulk_si=(Vds*T8_Vsbulk_si);
#if defined(_DERIVATE2)
  Vdseff_Vsbulk_si_Vgm_di=(+0.0*T8+0.0*T8_Vgm_di+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vgm_di);
  Vdseff_Vsbulk_si_Vgm_si=(+0.0*T8+0.0*T8_Vgm_si+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vgm_si);
  Vdseff_Vsbulk_si_Vdbulk_di=(+0.0*T8+0.0*T8_Vdbulk_di+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vdbulk_di);
  Vdseff_Vsbulk_si_Vsbulk_si=(+0.0*T8+0.0*T8_Vsbulk_si+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vsbulk_si);
  Vdseff_Vsbulk_si_Vdi_bi=(+0.0*T8+0.0*T8_Vdi_bi+Vds_Vdi_bi*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vdi_bi);
  Vdseff_Vsbulk_si_Vsi_bi=(+0.0*T8+0.0*T8_Vsi_bi+Vds_Vsi_bi*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vsi_bi);
  Vdseff_Vsbulk_si_Vgi_bi=(+0.0*T8+0.0*T8_Vgi_bi+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Vgi_bi);
  Vdseff_Vsbulk_si_Tempt_GND=(+0.0*T8+0.0*T8_Tempt_GND+0.0*T8_Vsbulk_si+Vds*T8_Vsbulk_si_Tempt_GND);
#endif
Vdseff_Vdi_bi=((Vds_Vdi_bi*T8)+(Vds*T8_Vdi_bi));
#if defined(_DERIVATE2)
  Vdseff_Vdi_bi_Vgm_di=(+0.0*T8+Vds_Vdi_bi*T8_Vgm_di+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vgm_di);
  Vdseff_Vdi_bi_Vgm_si=(+0.0*T8+Vds_Vdi_bi*T8_Vgm_si+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vgm_si);
  Vdseff_Vdi_bi_Vdbulk_di=(+0.0*T8+Vds_Vdi_bi*T8_Vdbulk_di+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vdbulk_di);
  Vdseff_Vdi_bi_Vsbulk_si=(+0.0*T8+Vds_Vdi_bi*T8_Vsbulk_si+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vsbulk_si);
  Vdseff_Vdi_bi_Vdi_bi=(+Vds_Vdi_bi_Vdi_bi*T8+Vds_Vdi_bi*T8_Vdi_bi+Vds_Vdi_bi*T8_Vdi_bi+Vds*T8_Vdi_bi_Vdi_bi);
  Vdseff_Vdi_bi_Vsi_bi=(+Vds_Vdi_bi_Vsi_bi*T8+Vds_Vdi_bi*T8_Vsi_bi+Vds_Vsi_bi*T8_Vdi_bi+Vds*T8_Vdi_bi_Vsi_bi);
  Vdseff_Vdi_bi_Vgi_bi=(+0.0*T8+Vds_Vdi_bi*T8_Vgi_bi+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Vgi_bi);
  Vdseff_Vdi_bi_Tempt_GND=(+0.0*T8+Vds_Vdi_bi*T8_Tempt_GND+0.0*T8_Vdi_bi+Vds*T8_Vdi_bi_Tempt_GND);
#endif
Vdseff_Vsi_bi=((Vds_Vsi_bi*T8)+(Vds*T8_Vsi_bi));
#if defined(_DERIVATE2)
  Vdseff_Vsi_bi_Vgm_di=(+0.0*T8+Vds_Vsi_bi*T8_Vgm_di+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vgm_di);
  Vdseff_Vsi_bi_Vgm_si=(+0.0*T8+Vds_Vsi_bi*T8_Vgm_si+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vgm_si);
  Vdseff_Vsi_bi_Vdbulk_di=(+0.0*T8+Vds_Vsi_bi*T8_Vdbulk_di+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vdbulk_di);
  Vdseff_Vsi_bi_Vsbulk_si=(+0.0*T8+Vds_Vsi_bi*T8_Vsbulk_si+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vsbulk_si);
  Vdseff_Vsi_bi_Vdi_bi=(+Vds_Vsi_bi_Vdi_bi*T8+Vds_Vsi_bi*T8_Vdi_bi+Vds_Vdi_bi*T8_Vsi_bi+Vds*T8_Vsi_bi_Vdi_bi);
  Vdseff_Vsi_bi_Vsi_bi=(+Vds_Vsi_bi_Vsi_bi*T8+Vds_Vsi_bi*T8_Vsi_bi+Vds_Vsi_bi*T8_Vsi_bi+Vds*T8_Vsi_bi_Vsi_bi);
  Vdseff_Vsi_bi_Vgi_bi=(+0.0*T8+Vds_Vsi_bi*T8_Vgi_bi+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Vgi_bi);
  Vdseff_Vsi_bi_Tempt_GND=(+0.0*T8+Vds_Vsi_bi*T8_Tempt_GND+0.0*T8_Vsi_bi+Vds*T8_Vsi_bi_Tempt_GND);
#endif
Vdseff_Vgi_bi=(Vds*T8_Vgi_bi);
#if defined(_DERIVATE2)
  Vdseff_Vgi_bi_Vgm_di=(+0.0*T8+0.0*T8_Vgm_di+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vgm_di);
  Vdseff_Vgi_bi_Vgm_si=(+0.0*T8+0.0*T8_Vgm_si+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vgm_si);
  Vdseff_Vgi_bi_Vdbulk_di=(+0.0*T8+0.0*T8_Vdbulk_di+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vdbulk_di);
  Vdseff_Vgi_bi_Vsbulk_si=(+0.0*T8+0.0*T8_Vsbulk_si+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vsbulk_si);
  Vdseff_Vgi_bi_Vdi_bi=(+0.0*T8+0.0*T8_Vdi_bi+Vds_Vdi_bi*T8_Vgi_bi+Vds*T8_Vgi_bi_Vdi_bi);
  Vdseff_Vgi_bi_Vsi_bi=(+0.0*T8+0.0*T8_Vsi_bi+Vds_Vsi_bi*T8_Vgi_bi+Vds*T8_Vgi_bi_Vsi_bi);
  Vdseff_Vgi_bi_Vgi_bi=(+0.0*T8+0.0*T8_Vgi_bi+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Vgi_bi);
  Vdseff_Vgi_bi_Tempt_GND=(+0.0*T8+0.0*T8_Tempt_GND+0.0*T8_Vgi_bi+Vds*T8_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
Vdseff_Tempt_GND=(Vds*T8_Tempt_GND);
#endif
#endif
Vdseff=(Vds*T8);
EXIT_IF_ISNAN((Vds*T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)V(gi,bi)Temp(t,GND) ddxprobe=V(si,GND)V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
vdeff_Vgm_di=Vdseff_Vgm_di*inv_nVt;
#if defined(_DERIVATE2)
  vdeff_Vgm_di_Vgm_di=(+(+Vdseff_Vgm_di_Vgm_di+0.0)*inv_nVt+Vdseff_Vgm_di*0.0+Vdseff_Vgm_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgm_di_Vgm_si=(+(+Vdseff_Vgm_di_Vgm_si+0.0)*inv_nVt+Vdseff_Vgm_di*inv_nVt_Vgm_si+Vdseff_Vgm_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgm_di_Vdbulk_di=(+(+Vdseff_Vgm_di_Vdbulk_di+0.0)*inv_nVt+Vdseff_Vgm_di*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgm_di_Vsbulk_si=(+(+Vdseff_Vgm_di_Vsbulk_si+0.0)*inv_nVt+Vdseff_Vgm_di*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgm_di_Vdi_bi=(+(+Vdseff_Vgm_di_Vdi_bi+0.0)*inv_nVt+Vdseff_Vgm_di*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgm_di_Vsi_bi=(+(+Vdseff_Vgm_di_Vsi_bi+0.0)*inv_nVt+Vdseff_Vgm_di*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgm_di_Vgi_bi=(+(+Vdseff_Vgm_di_Vgi_bi+0.0)*inv_nVt+Vdseff_Vgm_di*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*0.0+(Vdseff+Vs)*0.0);
  vdeff_Vgm_di_Tempt_GND=(+(+Vdseff_Vgm_di_Tempt_GND+0.0)*inv_nVt+Vdseff_Vgm_di*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*0.0+(Vdseff+Vs)*0.0);
#endif
vdeff_Vgm_si=((Vdseff_Vgm_si*inv_nVt)+((Vdseff+Vs)*inv_nVt_Vgm_si));
#if defined(_DERIVATE2)
  vdeff_Vgm_si_Vgm_di=(+(+Vdseff_Vgm_si_Vgm_di+0.0)*inv_nVt+Vdseff_Vgm_si*0.0+Vdseff_Vgm_di*inv_nVt_Vgm_si+(Vdseff+Vs)*0.0);
  vdeff_Vgm_si_Vgm_si=(+(+Vdseff_Vgm_si_Vgm_si+0.0)*inv_nVt+Vdseff_Vgm_si*inv_nVt_Vgm_si+Vdseff_Vgm_si*inv_nVt_Vgm_si+(Vdseff+Vs)*inv_nVt_Vgm_si_Vgm_si);
  vdeff_Vgm_si_Vdbulk_di=(+(+Vdseff_Vgm_si_Vdbulk_di+0.0)*inv_nVt+Vdseff_Vgm_si*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*inv_nVt_Vgm_si+(Vdseff+Vs)*inv_nVt_Vgm_si_Vdbulk_di);
  vdeff_Vgm_si_Vsbulk_si=(+(+Vdseff_Vgm_si_Vsbulk_si+0.0)*inv_nVt+Vdseff_Vgm_si*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*inv_nVt_Vgm_si+(Vdseff+Vs)*inv_nVt_Vgm_si_Vsbulk_si);
  vdeff_Vgm_si_Vdi_bi=(+(+Vdseff_Vgm_si_Vdi_bi+0.0)*inv_nVt+Vdseff_Vgm_si*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vgm_si+(Vdseff+Vs)*inv_nVt_Vgm_si_Vdi_bi);
  vdeff_Vgm_si_Vsi_bi=(+(+Vdseff_Vgm_si_Vsi_bi+0.0)*inv_nVt+Vdseff_Vgm_si*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vgm_si+(Vdseff+Vs)*inv_nVt_Vgm_si_Vsi_bi);
  vdeff_Vgm_si_Vgi_bi=(+(+Vdseff_Vgm_si_Vgi_bi+0.0)*inv_nVt+Vdseff_Vgm_si*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*inv_nVt_Vgm_si+(Vdseff+Vs)*inv_nVt_Vgm_si_Vgi_bi);
  vdeff_Vgm_si_Tempt_GND=(+(+Vdseff_Vgm_si_Tempt_GND+0.0)*inv_nVt+Vdseff_Vgm_si*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*inv_nVt_Vgm_si+(Vdseff+Vs)*inv_nVt_Vgm_si_Tempt_GND);
#endif
vdeff_Vdbulk_di=((Vdseff_Vdbulk_di*inv_nVt)+((Vdseff+Vs)*inv_nVt_Vdbulk_di));
#if defined(_DERIVATE2)
  vdeff_Vdbulk_di_Vgm_di=(+(+Vdseff_Vdbulk_di_Vgm_di+0.0)*inv_nVt+Vdseff_Vdbulk_di*0.0+Vdseff_Vgm_di*inv_nVt_Vdbulk_di+(Vdseff+Vs)*0.0);
  vdeff_Vdbulk_di_Vgm_si=(+(+Vdseff_Vdbulk_di_Vgm_si+0.0)*inv_nVt+Vdseff_Vdbulk_di*inv_nVt_Vgm_si+Vdseff_Vgm_si*inv_nVt_Vdbulk_di+(Vdseff+Vs)*inv_nVt_Vdbulk_di_Vgm_si);
  vdeff_Vdbulk_di_Vdbulk_di=(+(+Vdseff_Vdbulk_di_Vdbulk_di+0.0)*inv_nVt+Vdseff_Vdbulk_di*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*inv_nVt_Vdbulk_di+(Vdseff+Vs)*inv_nVt_Vdbulk_di_Vdbulk_di);
  vdeff_Vdbulk_di_Vsbulk_si=(+(+Vdseff_Vdbulk_di_Vsbulk_si+0.0)*inv_nVt+Vdseff_Vdbulk_di*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*inv_nVt_Vdbulk_di+(Vdseff+Vs)*inv_nVt_Vdbulk_di_Vsbulk_si);
  vdeff_Vdbulk_di_Vdi_bi=(+(+Vdseff_Vdbulk_di_Vdi_bi+0.0)*inv_nVt+Vdseff_Vdbulk_di*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vdbulk_di+(Vdseff+Vs)*inv_nVt_Vdbulk_di_Vdi_bi);
  vdeff_Vdbulk_di_Vsi_bi=(+(+Vdseff_Vdbulk_di_Vsi_bi+0.0)*inv_nVt+Vdseff_Vdbulk_di*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vdbulk_di+(Vdseff+Vs)*inv_nVt_Vdbulk_di_Vsi_bi);
  vdeff_Vdbulk_di_Vgi_bi=(+(+Vdseff_Vdbulk_di_Vgi_bi+0.0)*inv_nVt+Vdseff_Vdbulk_di*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*inv_nVt_Vdbulk_di+(Vdseff+Vs)*inv_nVt_Vdbulk_di_Vgi_bi);
  vdeff_Vdbulk_di_Tempt_GND=(+(+Vdseff_Vdbulk_di_Tempt_GND+0.0)*inv_nVt+Vdseff_Vdbulk_di*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*inv_nVt_Vdbulk_di+(Vdseff+Vs)*inv_nVt_Vdbulk_di_Tempt_GND);
#endif
vdeff_Vsbulk_si=((Vdseff_Vsbulk_si*inv_nVt)+((Vdseff+Vs)*inv_nVt_Vsbulk_si));
#if defined(_DERIVATE2)
  vdeff_Vsbulk_si_Vgm_di=(+(+Vdseff_Vsbulk_si_Vgm_di+0.0)*inv_nVt+Vdseff_Vsbulk_si*0.0+Vdseff_Vgm_di*inv_nVt_Vsbulk_si+(Vdseff+Vs)*0.0);
  vdeff_Vsbulk_si_Vgm_si=(+(+Vdseff_Vsbulk_si_Vgm_si+0.0)*inv_nVt+Vdseff_Vsbulk_si*inv_nVt_Vgm_si+Vdseff_Vgm_si*inv_nVt_Vsbulk_si+(Vdseff+Vs)*inv_nVt_Vsbulk_si_Vgm_si);
  vdeff_Vsbulk_si_Vdbulk_di=(+(+Vdseff_Vsbulk_si_Vdbulk_di+0.0)*inv_nVt+Vdseff_Vsbulk_si*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*inv_nVt_Vsbulk_si+(Vdseff+Vs)*inv_nVt_Vsbulk_si_Vdbulk_di);
  vdeff_Vsbulk_si_Vsbulk_si=(+(+Vdseff_Vsbulk_si_Vsbulk_si+0.0)*inv_nVt+Vdseff_Vsbulk_si*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*inv_nVt_Vsbulk_si+(Vdseff+Vs)*inv_nVt_Vsbulk_si_Vsbulk_si);
  vdeff_Vsbulk_si_Vdi_bi=(+(+Vdseff_Vsbulk_si_Vdi_bi+0.0)*inv_nVt+Vdseff_Vsbulk_si*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vsbulk_si+(Vdseff+Vs)*inv_nVt_Vsbulk_si_Vdi_bi);
  vdeff_Vsbulk_si_Vsi_bi=(+(+Vdseff_Vsbulk_si_Vsi_bi+0.0)*inv_nVt+Vdseff_Vsbulk_si*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vsbulk_si+(Vdseff+Vs)*inv_nVt_Vsbulk_si_Vsi_bi);
  vdeff_Vsbulk_si_Vgi_bi=(+(+Vdseff_Vsbulk_si_Vgi_bi+0.0)*inv_nVt+Vdseff_Vsbulk_si*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*inv_nVt_Vsbulk_si+(Vdseff+Vs)*inv_nVt_Vsbulk_si_Vgi_bi);
  vdeff_Vsbulk_si_Tempt_GND=(+(+Vdseff_Vsbulk_si_Tempt_GND+0.0)*inv_nVt+Vdseff_Vsbulk_si*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*inv_nVt_Vsbulk_si+(Vdseff+Vs)*inv_nVt_Vsbulk_si_Tempt_GND);
#endif
vdeff_Vdi_bi=(((Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt)+((Vdseff+Vs)*inv_nVt_Vdi_bi));
#if defined(_DERIVATE2)
  vdeff_Vdi_bi_Vgm_di=(+(+Vdseff_Vdi_bi_Vgm_di+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*0.0+Vdseff_Vgm_di*inv_nVt_Vdi_bi+(Vdseff+Vs)*0.0);
  vdeff_Vdi_bi_Vgm_si=(+(+Vdseff_Vdi_bi_Vgm_si+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vgm_si+Vdseff_Vgm_si*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vgm_si);
  vdeff_Vdi_bi_Vdbulk_di=(+(+Vdseff_Vdi_bi_Vdbulk_di+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vdbulk_di);
  vdeff_Vdi_bi_Vsbulk_si=(+(+Vdseff_Vdi_bi_Vsbulk_si+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vsbulk_si);
  vdeff_Vdi_bi_Vdi_bi=(+(+Vdseff_Vdi_bi_Vdi_bi+Vs_Vdi_bi_Vdi_bi)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vdi_bi);
  vdeff_Vdi_bi_Vsi_bi=(+(+Vdseff_Vdi_bi_Vsi_bi+Vs_Vdi_bi_Vsi_bi)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vsi_bi);
  vdeff_Vdi_bi_Vgi_bi=(+(+Vdseff_Vdi_bi_Vgi_bi+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Vgi_bi);
  vdeff_Vdi_bi_Tempt_GND=(+(+Vdseff_Vdi_bi_Tempt_GND+0.0)*inv_nVt+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*inv_nVt_Vdi_bi+(Vdseff+Vs)*inv_nVt_Vdi_bi_Tempt_GND);
#endif
vdeff_Vsi_bi=(((Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt)+((Vdseff+Vs)*inv_nVt_Vsi_bi));
#if defined(_DERIVATE2)
  vdeff_Vsi_bi_Vgm_di=(+(+Vdseff_Vsi_bi_Vgm_di+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*0.0+Vdseff_Vgm_di*inv_nVt_Vsi_bi+(Vdseff+Vs)*0.0);
  vdeff_Vsi_bi_Vgm_si=(+(+Vdseff_Vsi_bi_Vgm_si+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vgm_si+Vdseff_Vgm_si*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vgm_si);
  vdeff_Vsi_bi_Vdbulk_di=(+(+Vdseff_Vsi_bi_Vdbulk_di+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vdbulk_di);
  vdeff_Vsi_bi_Vsbulk_si=(+(+Vdseff_Vsi_bi_Vsbulk_si+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vsbulk_si);
  vdeff_Vsi_bi_Vdi_bi=(+(+Vdseff_Vsi_bi_Vdi_bi+Vs_Vsi_bi_Vdi_bi)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vdi_bi);
  vdeff_Vsi_bi_Vsi_bi=(+(+Vdseff_Vsi_bi_Vsi_bi+Vs_Vsi_bi_Vsi_bi)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vsi_bi);
  vdeff_Vsi_bi_Vgi_bi=(+(+Vdseff_Vsi_bi_Vgi_bi+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Vgi_bi);
  vdeff_Vsi_bi_Tempt_GND=(+(+Vdseff_Vsi_bi_Tempt_GND+0.0)*inv_nVt+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*inv_nVt_Vsi_bi+(Vdseff+Vs)*inv_nVt_Vsi_bi_Tempt_GND);
#endif
vdeff_Vgi_bi=((Vdseff_Vgi_bi*inv_nVt)+((Vdseff+Vs)*inv_nVt_Vgi_bi));
#if defined(_DERIVATE2)
  vdeff_Vgi_bi_Vgm_di=(+(+Vdseff_Vgi_bi_Vgm_di+0.0)*inv_nVt+Vdseff_Vgi_bi*0.0+Vdseff_Vgm_di*inv_nVt_Vgi_bi+(Vdseff+Vs)*0.0);
  vdeff_Vgi_bi_Vgm_si=(+(+Vdseff_Vgi_bi_Vgm_si+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vgm_si+Vdseff_Vgm_si*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vgm_si);
  vdeff_Vgi_bi_Vdbulk_di=(+(+Vdseff_Vgi_bi_Vdbulk_di+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vdbulk_di+Vdseff_Vdbulk_di*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vdbulk_di);
  vdeff_Vgi_bi_Vsbulk_si=(+(+Vdseff_Vgi_bi_Vsbulk_si+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vsbulk_si+Vdseff_Vsbulk_si*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vsbulk_si);
  vdeff_Vgi_bi_Vdi_bi=(+(+Vdseff_Vgi_bi_Vdi_bi+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vdi_bi+(Vdseff_Vdi_bi+Vs_Vdi_bi)*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vdi_bi);
  vdeff_Vgi_bi_Vsi_bi=(+(+Vdseff_Vgi_bi_Vsi_bi+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vsi_bi+(Vdseff_Vsi_bi+Vs_Vsi_bi)*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vsi_bi);
  vdeff_Vgi_bi_Vgi_bi=(+(+Vdseff_Vgi_bi_Vgi_bi+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Vgi_bi+Vdseff_Vgi_bi*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Vgi_bi);
  vdeff_Vgi_bi_Tempt_GND=(+(+Vdseff_Vgi_bi_Tempt_GND+0.0)*inv_nVt+Vdseff_Vgi_bi*inv_nVt_Tempt_GND+Vdseff_Tempt_GND*inv_nVt_Vgi_bi+(Vdseff+Vs)*inv_nVt_Vgi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
vdeff_Tempt_GND=((Vdseff_Tempt_GND*inv_nVt)+((Vdseff+Vs)*inv_nVt_Tempt_GND));
#endif
#endif
vdeff=((Vdseff+Vs)*inv_nVt);
EXIT_IF_ISNAN(((Vdseff+Vs)*inv_nVt))
{
double m00_sqrt(d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=(0.5*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vgm_di-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vgm_di+psip_Vgm_di*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vgm_si-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vgm_si+psip_Vgm_si*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vgi_bi-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vgi_bi+psip_Vgi_bi*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vdi_bi-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vdi_bi+psip_Vdi_bi*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vsi_bi-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vsi_bi+psip_Vsi_bi*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_di_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Tempt_GND-0.0)*(psip-1.0)+psip_Vgm_di*psip_Tempt_GND+psip_Tempt_GND*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vgm_si=(0.5*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vgm_di-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vgm_di+psip_Vgm_di*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vgm_si-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vgm_si+psip_Vgm_si*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vgi_bi-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vgi_bi+psip_Vgi_bi*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vdi_bi-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vdi_bi+psip_Vdi_bi*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vsi_bi-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vsi_bi+psip_Vsi_bi*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgm_si_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Tempt_GND-0.0)*(psip-1.0)+psip_Vgm_si*psip_Tempt_GND+psip_Tempt_GND*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vdbulk_di=(0.5*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_di+psip_Vgm_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_si+psip_Vgm_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgi_bi+psip_Vgi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdi_bi+psip_Vdi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsi_bi+psip_Vsi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Tempt_GND-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Tempt_GND+psip_Tempt_GND*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsbulk_si=(0.5*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_di+psip_Vgm_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_si+psip_Vgm_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgi_bi+psip_Vgi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdi_bi+psip_Vdi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsi_bi+psip_Vsi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Tempt_GND-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Tempt_GND+psip_Tempt_GND*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vgi_bi=(0.5*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vdi_bi=(0.5*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T8_Vsi_bi=(0.5*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(psip_Tempt_GND+((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((psip+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psip+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T8)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T8)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=T8_Vgm_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vgm_di);
  sqrtpsip_Vgm_di_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vgm_si);
  sqrtpsip_Vgm_di_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vdbulk_di);
  sqrtpsip_Vgm_di_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vsbulk_si);
  sqrtpsip_Vgm_di_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vgi_bi);
  sqrtpsip_Vgm_di_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vdi_bi);
  sqrtpsip_Vgm_di_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Vsi_bi);
  sqrtpsip_Vgm_di_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgm_di+d10_sqrt0*T8_Vgm_di_Tempt_GND);
#endif
sqrtpsip_Vgm_si=T8_Vgm_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vgm_di);
  sqrtpsip_Vgm_si_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vgm_si);
  sqrtpsip_Vgm_si_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vdbulk_di);
  sqrtpsip_Vgm_si_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vsbulk_si);
  sqrtpsip_Vgm_si_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vgi_bi);
  sqrtpsip_Vgm_si_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vdi_bi);
  sqrtpsip_Vgm_si_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Vsi_bi);
  sqrtpsip_Vgm_si_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgm_si+d10_sqrt0*T8_Vgm_si_Tempt_GND);
#endif
sqrtpsip_Vdbulk_di=T8_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_di);
  sqrtpsip_Vdbulk_di_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgm_si);
  sqrtpsip_Vdbulk_di_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdbulk_di);
  sqrtpsip_Vdbulk_di_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsbulk_si);
  sqrtpsip_Vdbulk_di_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vgi_bi);
  sqrtpsip_Vdbulk_di_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vdi_bi);
  sqrtpsip_Vdbulk_di_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Vsi_bi);
  sqrtpsip_Vdbulk_di_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdbulk_di+d10_sqrt0*T8_Vdbulk_di_Tempt_GND);
#endif
sqrtpsip_Vsbulk_si=T8_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_di);
  sqrtpsip_Vsbulk_si_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgm_si);
  sqrtpsip_Vsbulk_si_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdbulk_di);
  sqrtpsip_Vsbulk_si_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsbulk_si);
  sqrtpsip_Vsbulk_si_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vgi_bi);
  sqrtpsip_Vsbulk_si_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vdi_bi);
  sqrtpsip_Vsbulk_si_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Vsi_bi);
  sqrtpsip_Vsbulk_si_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsbulk_si+d10_sqrt0*T8_Vsbulk_si_Tempt_GND);
#endif
sqrtpsip_Vgi_bi=T8_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vgi_bi+d10_sqrt0*T8_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=T8_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vdi_bi+d10_sqrt0*T8_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=T8_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(T8)*T8_Vgm_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(T8)*T8_Vgm_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(T8)*T8_Vdbulk_di*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(T8)*T8_Vsbulk_si*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(T8)*T8_Vgi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(T8)*T8_Vdi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(T8)*T8_Vsi_bi*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(T8)*T8_Tempt_GND*T8_Vsi_bi+d10_sqrt0*T8_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=T8_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(di,bi)V(si,bi)Temp(t,GND)V(gi,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(di,GND)V(si,GND)V(gi,GND)V(bi,GND)V(dbulk,GND) */
T9_Vgm_si=((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgm_si_Vgm_si=(+0.0+(gam_Vgm_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vdbulk_di=(+0.0+(gam_Vgm_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vsbulk_si=(+0.0+(gam_Vgm_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vdi_bi=(+0.0+(gam_Vgm_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vsi_bi=(+0.0+(gam_Vgm_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Tempt_GND=(+0.0+(gam_Vgm_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_si_Vgi_bi=(+0.0+(gam_Vgm_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vgm_di=(-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgm_di_Vgm_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vdbulk_di=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vsbulk_si=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vdi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vsi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Tempt_GND=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgm_di_Vgi_bi=(+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vdbulk_di=((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdbulk_di_Vgm_si=(+0.0+(gam_Vdbulk_di_Vgm_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdbulk_di=(+0.0+(gam_Vdbulk_di_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsbulk_si=(+0.0+(gam_Vdbulk_di_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vdi_bi=(+0.0+(gam_Vdbulk_di_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vsi_bi=(+0.0+(gam_Vdbulk_di_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Tempt_GND=(+0.0+(gam_Vdbulk_di_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdbulk_di_Vgi_bi=(+0.0+(gam_Vdbulk_di_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsbulk_si=((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsbulk_si_Vgm_si=(+0.0+(gam_Vsbulk_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdbulk_di=(+0.0+(gam_Vsbulk_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsbulk_si=(+0.0+(gam_Vsbulk_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vdi_bi=(+0.0+(gam_Vsbulk_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vsi_bi=(+0.0+(gam_Vsbulk_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Tempt_GND=(+0.0+(gam_Vsbulk_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsbulk_si_Vgi_bi=(+0.0+(gam_Vsbulk_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vdi_bi=((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
T9_Vsi_bi=((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#if defined(_DERIVATE)
T9_Tempt_GND=((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#endif
T9_Vgi_bi=((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip));
#if defined(_DERIVATE2)
  T9_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgm_di=(+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
  T9_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)));
#endif
#endif
T9=(1.0+(gam/(2.0*sqrtpsip)));
EXIT_IF_ISNAN((1.0+(gam/(2.0*sqrtpsip))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))/gam);
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*0.0/gam/gam/gam);
  T0_Vgm_di_Vgm_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vgm_si/gam/gam/gam);
  T0_Vgm_di_Vdbulk_di=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgm_di_Vsbulk_si=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgm_di_Vgi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vgi_bi/gam/gam/gam);
  T0_Vgm_di_Vdi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vdi_bi/gam/gam/gam);
  T0_Vgm_di_Vsi_bi=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Vsi_bi/gam/gam/gam);
  T0_Vgm_di_Tempt_GND=((+0.0+(0.0/(2.0*sqrtpsip)-(0.0*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgm_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgm_di+2.0*sqrtpsip_Vgm_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-((-gam*(2.0*sqrtpsip_Vgm_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*0.0*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vgm_si=((((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*0.0/gam/gam/gam);
  T0_Vgm_si_Vgm_si=((+0.0+(gam_Vgm_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vgm_si/gam/gam/gam);
  T0_Vgm_si_Vdbulk_di=((+0.0+(gam_Vgm_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgm_si_Vsbulk_si=((+0.0+(gam_Vgm_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgm_si_Vgi_bi=((+0.0+(gam_Vgm_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vgi_bi/gam/gam/gam);
  T0_Vgm_si_Vdi_bi=((+0.0+(gam_Vgm_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vdi_bi/gam/gam/gam);
  T0_Vgm_si_Vsi_bi=((+0.0+(gam_Vgm_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Vsi_bi/gam/gam/gam);
  T0_Vgm_si_Tempt_GND=((+0.0+(gam_Vgm_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgm_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgm_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgm_si+2.0*sqrtpsip_Vgm_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgm_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgm_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgm_si*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vdbulk_di=((((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*0.0/gam/gam/gam);
  T0_Vdbulk_di_Vgm_si=((+0.0+(gam_Vdbulk_di_Vgm_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vgm_si/gam/gam/gam);
  T0_Vdbulk_di_Vdbulk_di=((+0.0+(gam_Vdbulk_di_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdbulk_di_Vsbulk_si=((+0.0+(gam_Vdbulk_di_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdbulk_di_Vgi_bi=((+0.0+(gam_Vdbulk_di_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vgi_bi/gam/gam/gam);
  T0_Vdbulk_di_Vdi_bi=((+0.0+(gam_Vdbulk_di_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vdi_bi/gam/gam/gam);
  T0_Vdbulk_di_Vsi_bi=((+0.0+(gam_Vdbulk_di_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Vsi_bi/gam/gam/gam);
  T0_Vdbulk_di_Tempt_GND=((+0.0+(gam_Vdbulk_di_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdbulk_di*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdbulk_di)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdbulk_di+2.0*sqrtpsip_Vdbulk_di_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdbulk_di)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdbulk_di*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsbulk_si=((((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*0.0/gam/gam/gam);
  T0_Vsbulk_si_Vgm_si=((+0.0+(gam_Vsbulk_si_Vgm_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vgm_si/gam/gam/gam);
  T0_Vsbulk_si_Vdbulk_di=((+0.0+(gam_Vsbulk_si_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsbulk_si_Vsbulk_si=((+0.0+(gam_Vsbulk_si_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsbulk_si_Vgi_bi=((+0.0+(gam_Vsbulk_si_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vgi_bi/gam/gam/gam);
  T0_Vsbulk_si_Vdi_bi=((+0.0+(gam_Vsbulk_si_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vdi_bi/gam/gam/gam);
  T0_Vsbulk_si_Vsi_bi=((+0.0+(gam_Vsbulk_si_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Vsi_bi/gam/gam/gam);
  T0_Vsbulk_si_Tempt_GND=((+0.0+(gam_Vsbulk_si_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsbulk_si*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsbulk_si)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsbulk_si+2.0*sqrtpsip_Vsbulk_si_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsbulk_si)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsbulk_si*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vgi_bi=((((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*0.0/gam/gam/gam);
  T0_Vgi_bi_Vgm_si=((+0.0+(gam_Vgi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vgi_bi_Vdbulk_di=((+0.0+(gam_Vgi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vgi_bi_Vsbulk_si=((+0.0+(gam_Vgi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vgi_bi_Vgi_bi=((+0.0+(gam_Vgi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vgi_bi_Vdi_bi=((+0.0+(gam_Vgi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vgi_bi_Vsi_bi=((+0.0+(gam_Vgi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vgi_bi_Tempt_GND=((+0.0+(gam_Vgi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vgi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vgi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vgi_bi+2.0*sqrtpsip_Vgi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vgi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vgi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vgi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vdi_bi=((((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*0.0/gam/gam/gam);
  T0_Vdi_bi_Vgm_si=((+0.0+(gam_Vdi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vdi_bi_Vdbulk_di=((+0.0+(gam_Vdi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vdi_bi_Vsbulk_si=((+0.0+(gam_Vdi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vdi_bi_Vgi_bi=((+0.0+(gam_Vdi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vdi_bi_Vdi_bi=((+0.0+(gam_Vdi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vdi_bi_Vsi_bi=((+0.0+(gam_Vdi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vdi_bi_Tempt_GND=((+0.0+(gam_Vdi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vdi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vdi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vdi_bi+2.0*sqrtpsip_Vdi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vdi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vdi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vdi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
T0_Vsi_bi=((((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi)/gam/gam);
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=((+0.0+(0.0/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_di))+0.0*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*0.0+(-gam*((2.0*sqrtpsip_Vgm_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*0.0)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*0.0/gam/gam/gam);
  T0_Vsi_bi_Vgm_si=((+0.0+(gam_Vsi_bi_Vgm_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgm_si))+gam_Vgm_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgm_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgm_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgm_si+((gam_Vgm_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgm_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgm_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgm_si/gam/gam/gam);
  T0_Vsi_bi_Vdbulk_di=((+0.0+(gam_Vsi_bi_Vdbulk_di/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdbulk_di))+gam_Vdbulk_di*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdbulk_di+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdbulk_di))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdbulk_di+((gam_Vdbulk_di*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdbulk_di)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdbulk_di)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdbulk_di/gam/gam/gam);
  T0_Vsi_bi_Vsbulk_si=((+0.0+(gam_Vsi_bi_Vsbulk_si/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsbulk_si))+gam_Vsbulk_si*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsbulk_si+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsbulk_si))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsbulk_si+((gam_Vsbulk_si*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsbulk_si)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsbulk_si)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsbulk_si/gam/gam/gam);
  T0_Vsi_bi_Vgi_bi=((+0.0+(gam_Vsi_bi_Vgi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vgi_bi))+gam_Vgi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vgi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vgi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vgi_bi+((gam_Vgi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vgi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vgi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vgi_bi/gam/gam/gam);
  T0_Vsi_bi_Vdi_bi=((+0.0+(gam_Vsi_bi_Vdi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vdi_bi))+gam_Vdi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vdi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vdi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vdi_bi+((gam_Vdi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vdi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vdi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vdi_bi/gam/gam/gam);
  T0_Vsi_bi_Vsi_bi=((+0.0+(gam_Vsi_bi_Vsi_bi/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Vsi_bi))+gam_Vsi_bi*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Vsi_bi+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+((gam_Vsi_bi*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Vsi_bi)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Vsi_bi)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Vsi_bi/gam/gam/gam);
  T0_Vsi_bi_Tempt_GND=((+0.0+(gam_Vsi_bi_Tempt_GND/(2.0*sqrtpsip)-(gam_Vsi_bi*((2.0*sqrtpsip_Tempt_GND))+gam_Tempt_GND*(2.0*sqrtpsip_Vsi_bi)+gam*(+0.0*sqrtpsip+0.0*sqrtpsip_Tempt_GND+0.0*sqrtpsip_Vsi_bi+2.0*sqrtpsip_Vsi_bi_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)+2*gam*(2.0*sqrtpsip_Vsi_bi)*((2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip)/(2.0*sqrtpsip)))/gam-(((gam_Vsi_bi*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Vsi_bi))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Tempt_GND+((gam_Tempt_GND*(2.0*sqrtpsip)-gam*((2.0*sqrtpsip_Tempt_GND)))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam_Vsi_bi+(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi_Tempt_GND)/gam/gam+2*(1.0+(gam/(2.0*sqrtpsip)))*gam_Vsi_bi*gam_Tempt_GND/gam/gam/gam);
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=((((gam_Tempt_GND*(2.0*sqrtpsip)-gam*(2.0*sqrtpsip_Tempt_GND))/(2.0*sqrtpsip)/(2.0*sqrtpsip))*gam-(1.0+(gam/(2.0*sqrtpsip)))*gam_Tempt_GND)/gam/gam);
#endif
#endif
T0=((1.0+(gam/(2.0*sqrtpsip)))/gam);
EXIT_IF_ISNAN(((1.0+(gam/(2.0*sqrtpsip)))/gam))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(dbulk,GND)V(gm,GND)V(sbulk,GND)V(si,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T1_Vgm_di=(psip_Vgm_di-vdeff_Vgm_di);
#if defined(_DERIVATE2)
  T1_Vgm_di_Vgm_di=(+(+psip_Vgm_di_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*0.0+2.0*0.0))-vdeff_Vgm_di_Vgm_di);
  T1_Vgm_di_Vgm_si=(+(+psip_Vgm_di_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*0.0+2.0*0.0))-vdeff_Vgm_di_Vgm_si);
  T1_Vgm_di_Vdbulk_di=(+(+psip_Vgm_di_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*0.0+2.0*0.0))-vdeff_Vgm_di_Vdbulk_di);
  T1_Vgm_di_Vsbulk_si=(+(+psip_Vgm_di_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*0.0+2.0*0.0))-vdeff_Vgm_di_Vsbulk_si);
  T1_Vgm_di_Vgi_bi=(+(+psip_Vgm_di_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*0.0+2.0*0.0))-vdeff_Vgm_di_Vgi_bi);
  T1_Vgm_di_Vdi_bi=(+(+psip_Vgm_di_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*0.0+2.0*0.0))-vdeff_Vgm_di_Vdi_bi);
  T1_Vgm_di_Vsi_bi=(+(+psip_Vgm_di_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*0.0+2.0*0.0))-vdeff_Vgm_di_Vsi_bi);
  T1_Vgm_di_Tempt_GND=(+(+psip_Vgm_di_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*0.0+2.0*0.0))-vdeff_Vgm_di_Tempt_GND);
#endif
T1_Vgm_si=((psip_Vgm_si-(2.0*phib_n_Vgm_si))-vdeff_Vgm_si);
#if defined(_DERIVATE2)
  T1_Vgm_si_Vgm_di=(+(+psip_Vgm_si_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vgm_si+2.0*0.0))-vdeff_Vgm_si_Vgm_di);
  T1_Vgm_si_Vgm_si=(+(+psip_Vgm_si_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vgm_si))-vdeff_Vgm_si_Vgm_si);
  T1_Vgm_si_Vdbulk_di=(+(+psip_Vgm_si_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vdbulk_di))-vdeff_Vgm_si_Vdbulk_di);
  T1_Vgm_si_Vsbulk_si=(+(+psip_Vgm_si_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vsbulk_si))-vdeff_Vgm_si_Vsbulk_si);
  T1_Vgm_si_Vgi_bi=(+(+psip_Vgm_si_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vgi_bi))-vdeff_Vgm_si_Vgi_bi);
  T1_Vgm_si_Vdi_bi=(+(+psip_Vgm_si_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vdi_bi))-vdeff_Vgm_si_Vdi_bi);
  T1_Vgm_si_Vsi_bi=(+(+psip_Vgm_si_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Vsi_bi))-vdeff_Vgm_si_Vsi_bi);
  T1_Vgm_si_Tempt_GND=(+(+psip_Vgm_si_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vgm_si+2.0*phib_n_Vgm_si_Tempt_GND))-vdeff_Vgm_si_Tempt_GND);
#endif
T1_Vdbulk_di=((psip_Vdbulk_di-(2.0*phib_n_Vdbulk_di))-vdeff_Vdbulk_di);
#if defined(_DERIVATE2)
  T1_Vdbulk_di_Vgm_di=(+(+psip_Vdbulk_di_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vdbulk_di+2.0*0.0))-vdeff_Vdbulk_di_Vgm_di);
  T1_Vdbulk_di_Vgm_si=(+(+psip_Vdbulk_di_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vgm_si))-vdeff_Vdbulk_di_Vgm_si);
  T1_Vdbulk_di_Vdbulk_di=(+(+psip_Vdbulk_di_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vdbulk_di))-vdeff_Vdbulk_di_Vdbulk_di);
  T1_Vdbulk_di_Vsbulk_si=(+(+psip_Vdbulk_di_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vsbulk_si))-vdeff_Vdbulk_di_Vsbulk_si);
  T1_Vdbulk_di_Vgi_bi=(+(+psip_Vdbulk_di_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vgi_bi))-vdeff_Vdbulk_di_Vgi_bi);
  T1_Vdbulk_di_Vdi_bi=(+(+psip_Vdbulk_di_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vdi_bi))-vdeff_Vdbulk_di_Vdi_bi);
  T1_Vdbulk_di_Vsi_bi=(+(+psip_Vdbulk_di_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Vsi_bi))-vdeff_Vdbulk_di_Vsi_bi);
  T1_Vdbulk_di_Tempt_GND=(+(+psip_Vdbulk_di_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vdbulk_di+2.0*phib_n_Vdbulk_di_Tempt_GND))-vdeff_Vdbulk_di_Tempt_GND);
#endif
T1_Vsbulk_si=((psip_Vsbulk_si-(2.0*phib_n_Vsbulk_si))-vdeff_Vsbulk_si);
#if defined(_DERIVATE2)
  T1_Vsbulk_si_Vgm_di=(+(+psip_Vsbulk_si_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vsbulk_si+2.0*0.0))-vdeff_Vsbulk_si_Vgm_di);
  T1_Vsbulk_si_Vgm_si=(+(+psip_Vsbulk_si_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vgm_si))-vdeff_Vsbulk_si_Vgm_si);
  T1_Vsbulk_si_Vdbulk_di=(+(+psip_Vsbulk_si_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vdbulk_di))-vdeff_Vsbulk_si_Vdbulk_di);
  T1_Vsbulk_si_Vsbulk_si=(+(+psip_Vsbulk_si_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vsbulk_si))-vdeff_Vsbulk_si_Vsbulk_si);
  T1_Vsbulk_si_Vgi_bi=(+(+psip_Vsbulk_si_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vgi_bi))-vdeff_Vsbulk_si_Vgi_bi);
  T1_Vsbulk_si_Vdi_bi=(+(+psip_Vsbulk_si_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vdi_bi))-vdeff_Vsbulk_si_Vdi_bi);
  T1_Vsbulk_si_Vsi_bi=(+(+psip_Vsbulk_si_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Vsi_bi))-vdeff_Vsbulk_si_Vsi_bi);
  T1_Vsbulk_si_Tempt_GND=(+(+psip_Vsbulk_si_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vsbulk_si+2.0*phib_n_Vsbulk_si_Tempt_GND))-vdeff_Vsbulk_si_Tempt_GND);
#endif
T1_Vgi_bi=((psip_Vgi_bi-(2.0*phib_n_Vgi_bi))-vdeff_Vgi_bi);
#if defined(_DERIVATE2)
  T1_Vgi_bi_Vgm_di=(+(+psip_Vgi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vgi_bi+2.0*0.0))-vdeff_Vgi_bi_Vgm_di);
  T1_Vgi_bi_Vgm_si=(+(+psip_Vgi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vgm_si))-vdeff_Vgi_bi_Vgm_si);
  T1_Vgi_bi_Vdbulk_di=(+(+psip_Vgi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vdbulk_di))-vdeff_Vgi_bi_Vdbulk_di);
  T1_Vgi_bi_Vsbulk_si=(+(+psip_Vgi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vsbulk_si))-vdeff_Vgi_bi_Vsbulk_si);
  T1_Vgi_bi_Vgi_bi=(+(+psip_Vgi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vgi_bi))-vdeff_Vgi_bi_Vgi_bi);
  T1_Vgi_bi_Vdi_bi=(+(+psip_Vgi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vdi_bi))-vdeff_Vgi_bi_Vdi_bi);
  T1_Vgi_bi_Vsi_bi=(+(+psip_Vgi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Vsi_bi))-vdeff_Vgi_bi_Vsi_bi);
  T1_Vgi_bi_Tempt_GND=(+(+psip_Vgi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vgi_bi+2.0*phib_n_Vgi_bi_Tempt_GND))-vdeff_Vgi_bi_Tempt_GND);
#endif
T1_Vdi_bi=((psip_Vdi_bi-(2.0*phib_n_Vdi_bi))-vdeff_Vdi_bi);
#if defined(_DERIVATE2)
  T1_Vdi_bi_Vgm_di=(+(+psip_Vdi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vdi_bi+2.0*0.0))-vdeff_Vdi_bi_Vgm_di);
  T1_Vdi_bi_Vgm_si=(+(+psip_Vdi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vgm_si))-vdeff_Vdi_bi_Vgm_si);
  T1_Vdi_bi_Vdbulk_di=(+(+psip_Vdi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vdbulk_di))-vdeff_Vdi_bi_Vdbulk_di);
  T1_Vdi_bi_Vsbulk_si=(+(+psip_Vdi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vsbulk_si))-vdeff_Vdi_bi_Vsbulk_si);
  T1_Vdi_bi_Vgi_bi=(+(+psip_Vdi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vgi_bi))-vdeff_Vdi_bi_Vgi_bi);
  T1_Vdi_bi_Vdi_bi=(+(+psip_Vdi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vdi_bi))-vdeff_Vdi_bi_Vdi_bi);
  T1_Vdi_bi_Vsi_bi=(+(+psip_Vdi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Vsi_bi))-vdeff_Vdi_bi_Vsi_bi);
  T1_Vdi_bi_Tempt_GND=(+(+psip_Vdi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vdi_bi+2.0*phib_n_Vdi_bi_Tempt_GND))-vdeff_Vdi_bi_Tempt_GND);
#endif
T1_Vsi_bi=((psip_Vsi_bi-(2.0*phib_n_Vsi_bi))-vdeff_Vsi_bi);
#if defined(_DERIVATE2)
  T1_Vsi_bi_Vgm_di=(+(+psip_Vsi_bi_Vgm_di-(+0.0*phib_n+0.0*0.0+0.0*phib_n_Vsi_bi+2.0*0.0))-vdeff_Vsi_bi_Vgm_di);
  T1_Vsi_bi_Vgm_si=(+(+psip_Vsi_bi_Vgm_si-(+0.0*phib_n+0.0*phib_n_Vgm_si+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vgm_si))-vdeff_Vsi_bi_Vgm_si);
  T1_Vsi_bi_Vdbulk_di=(+(+psip_Vsi_bi_Vdbulk_di-(+0.0*phib_n+0.0*phib_n_Vdbulk_di+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vdbulk_di))-vdeff_Vsi_bi_Vdbulk_di);
  T1_Vsi_bi_Vsbulk_si=(+(+psip_Vsi_bi_Vsbulk_si-(+0.0*phib_n+0.0*phib_n_Vsbulk_si+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vsbulk_si))-vdeff_Vsi_bi_Vsbulk_si);
  T1_Vsi_bi_Vgi_bi=(+(+psip_Vsi_bi_Vgi_bi-(+0.0*phib_n+0.0*phib_n_Vgi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vgi_bi))-vdeff_Vsi_bi_Vgi_bi);
  T1_Vsi_bi_Vdi_bi=(+(+psip_Vsi_bi_Vdi_bi-(+0.0*phib_n+0.0*phib_n_Vdi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vdi_bi))-vdeff_Vsi_bi_Vdi_bi);
  T1_Vsi_bi_Vsi_bi=(+(+psip_Vsi_bi_Vsi_bi-(+0.0*phib_n+0.0*phib_n_Vsi_bi+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Vsi_bi))-vdeff_Vsi_bi_Vsi_bi);
  T1_Vsi_bi_Tempt_GND=(+(+psip_Vsi_bi_Tempt_GND-(+0.0*phib_n+0.0*phib_n_Tempt_GND+0.0*phib_n_Vsi_bi+2.0*phib_n_Vsi_bi_Tempt_GND))-vdeff_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T1_Tempt_GND=((psip_Tempt_GND-(2.0*phib_n_Tempt_GND))-vdeff_Tempt_GND);
#endif
#endif
T1=((psip-(2.0*phib_n))-vdeff);
EXIT_IF_ISNAN(((psip-(2.0*phib_n))-vdeff))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=(T1_Vgm_di-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgm_di)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgm_di))));
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=(+T1_Vgm_di_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vgm_di)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vgm_di));
  T2_Vgm_di_Vgm_si=(+T1_Vgm_di_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vgm_si)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vgm_si));
  T2_Vgm_di_Vdbulk_di=(+T1_Vgm_di_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vdbulk_di));
  T2_Vgm_di_Vsbulk_si=(+T1_Vgm_di_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vsbulk_si));
  T2_Vgm_di_Vgi_bi=(+T1_Vgm_di_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vgi_bi)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vgi_bi));
  T2_Vgm_di_Vdi_bi=(+T1_Vgm_di_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vdi_bi)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vdi_bi));
  T2_Vgm_di_Vsi_bi=(+T1_Vgm_di_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Vsi_bi)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Vsi_bi));
  T2_Vgm_di_Tempt_GND=(+T1_Vgm_di_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgm_di+4.0*T0_Vgm_di_Tempt_GND)*sqrtpsip+(4.0*T0_Vgm_di)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgm_di+(4.0*T0)*sqrtpsip_Vgm_di_Tempt_GND));
#endif
T2_Vgm_si=(T1_Vgm_si-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgm_si)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgm_si))));
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=(+T1_Vgm_si_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vgm_di)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vgm_di));
  T2_Vgm_si_Vgm_si=(+T1_Vgm_si_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vgm_si)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vgm_si));
  T2_Vgm_si_Vdbulk_di=(+T1_Vgm_si_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vdbulk_di));
  T2_Vgm_si_Vsbulk_si=(+T1_Vgm_si_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vsbulk_si));
  T2_Vgm_si_Vgi_bi=(+T1_Vgm_si_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vgi_bi)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vgi_bi));
  T2_Vgm_si_Vdi_bi=(+T1_Vgm_si_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vdi_bi)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vdi_bi));
  T2_Vgm_si_Vsi_bi=(+T1_Vgm_si_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Vsi_bi)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Vsi_bi));
  T2_Vgm_si_Tempt_GND=(+T1_Vgm_si_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgm_si+4.0*T0_Vgm_si_Tempt_GND)*sqrtpsip+(4.0*T0_Vgm_si)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgm_si+(4.0*T0)*sqrtpsip_Vgm_si_Tempt_GND));
#endif
T2_Vdbulk_di=(T1_Vdbulk_di-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdbulk_di)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdbulk_di))));
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(+T1_Vdbulk_di_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_di));
  T2_Vdbulk_di_Vgm_si=(+T1_Vdbulk_di_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgm_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgm_si));
  T2_Vdbulk_di_Vdbulk_di=(+T1_Vdbulk_di_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdbulk_di));
  T2_Vdbulk_di_Vsbulk_si=(+T1_Vdbulk_di_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsbulk_si));
  T2_Vdbulk_di_Vgi_bi=(+T1_Vdbulk_di_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vgi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vgi_bi));
  T2_Vdbulk_di_Vdi_bi=(+T1_Vdbulk_di_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vdi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vdi_bi));
  T2_Vdbulk_di_Vsi_bi=(+T1_Vdbulk_di_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Vsi_bi)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Vsi_bi));
  T2_Vdbulk_di_Tempt_GND=(+T1_Vdbulk_di_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+4.0*T0_Vdbulk_di_Tempt_GND)*sqrtpsip+(4.0*T0_Vdbulk_di)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdbulk_di+(4.0*T0)*sqrtpsip_Vdbulk_di_Tempt_GND));
#endif
T2_Vsbulk_si=(T1_Vsbulk_si-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsbulk_si)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsbulk_si))));
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(+T1_Vsbulk_si_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_di));
  T2_Vsbulk_si_Vgm_si=(+T1_Vsbulk_si_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgm_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgm_si));
  T2_Vsbulk_si_Vdbulk_di=(+T1_Vsbulk_si_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdbulk_di));
  T2_Vsbulk_si_Vsbulk_si=(+T1_Vsbulk_si_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsbulk_si));
  T2_Vsbulk_si_Vgi_bi=(+T1_Vsbulk_si_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vgi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vgi_bi));
  T2_Vsbulk_si_Vdi_bi=(+T1_Vsbulk_si_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vdi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vdi_bi));
  T2_Vsbulk_si_Vsi_bi=(+T1_Vsbulk_si_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Vsi_bi)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Vsi_bi));
  T2_Vsbulk_si_Tempt_GND=(+T1_Vsbulk_si_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+4.0*T0_Vsbulk_si_Tempt_GND)*sqrtpsip+(4.0*T0_Vsbulk_si)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsbulk_si+(4.0*T0)*sqrtpsip_Vsbulk_si_Tempt_GND));
#endif
T2_Vgi_bi=(T1_Vgi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vgi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vgi_bi))));
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(+T1_Vgi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_di));
  T2_Vgi_bi_Vgm_si=(+T1_Vgi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgm_si));
  T2_Vgi_bi_Vdbulk_di=(+T1_Vgi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdbulk_di));
  T2_Vgi_bi_Vsbulk_si=(+T1_Vgi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsbulk_si));
  T2_Vgi_bi_Vgi_bi=(+T1_Vgi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vgi_bi));
  T2_Vgi_bi_Vdi_bi=(+T1_Vgi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vdi_bi));
  T2_Vgi_bi_Vsi_bi=(+T1_Vgi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Vsi_bi));
  T2_Vgi_bi_Tempt_GND=(+T1_Vgi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+4.0*T0_Vgi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vgi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vgi_bi+(4.0*T0)*sqrtpsip_Vgi_bi_Tempt_GND));
#endif
T2_Vdi_bi=(T1_Vdi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vdi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vdi_bi))));
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(+T1_Vdi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_di));
  T2_Vdi_bi_Vgm_si=(+T1_Vdi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgm_si));
  T2_Vdi_bi_Vdbulk_di=(+T1_Vdi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdbulk_di));
  T2_Vdi_bi_Vsbulk_si=(+T1_Vdi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsbulk_si));
  T2_Vdi_bi_Vgi_bi=(+T1_Vdi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vgi_bi));
  T2_Vdi_bi_Vdi_bi=(+T1_Vdi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vdi_bi));
  T2_Vdi_bi_Vsi_bi=(+T1_Vdi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Vsi_bi));
  T2_Vdi_bi_Tempt_GND=(+T1_Vdi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+4.0*T0_Vdi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vdi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vdi_bi+(4.0*T0)*sqrtpsip_Vdi_bi_Tempt_GND));
#endif
T2_Vsi_bi=(T1_Vsi_bi-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Vsi_bi)*sqrtpsip)+((4.0*T0)*sqrtpsip_Vsi_bi))));
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(+T1_Vsi_bi_Vgm_di-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_di+((4.0*T0_Vgm_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_di));
  T2_Vsi_bi_Vgm_si=(+T1_Vsi_bi_Vgm_si-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgm_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgm_si+((4.0*T0_Vgm_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgm_si));
  T2_Vsi_bi_Vdbulk_di=(+T1_Vsi_bi_Vdbulk_di-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdbulk_di)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdbulk_di+((4.0*T0_Vdbulk_di))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdbulk_di));
  T2_Vsi_bi_Vsbulk_si=(+T1_Vsi_bi_Vsbulk_si-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsbulk_si)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsbulk_si+((4.0*T0_Vsbulk_si))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsbulk_si));
  T2_Vsi_bi_Vgi_bi=(+T1_Vsi_bi_Vgi_bi-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vgi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vgi_bi+((4.0*T0_Vgi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vgi_bi));
  T2_Vsi_bi_Vdi_bi=(+T1_Vsi_bi_Vdi_bi-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vdi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vdi_bi+((4.0*T0_Vdi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vdi_bi));
  T2_Vsi_bi_Vsi_bi=(+T1_Vsi_bi_Vsi_bi-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Vsi_bi)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Vsi_bi+((4.0*T0_Vsi_bi))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Vsi_bi));
  T2_Vsi_bi_Tempt_GND=(+T1_Vsi_bi_Tempt_GND-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+4.0*T0_Vsi_bi_Tempt_GND)*sqrtpsip+(4.0*T0_Vsi_bi)*sqrtpsip_Tempt_GND+((4.0*T0_Tempt_GND))*sqrtpsip_Vsi_bi+(4.0*T0)*sqrtpsip_Vsi_bi_Tempt_GND));
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(T1_Tempt_GND-bsimbulk_d_lln(((4.0*T0)*sqrtpsip),(((4.0*T0_Tempt_GND)*sqrtpsip)+((4.0*T0)*sqrtpsip_Tempt_GND))));
#endif
#endif
T2=(T1-bsimbulk_lln(((4.0*T0)*sqrtpsip)));
EXIT_IF_ISNAN((T1-bsimbulk_lln(((4.0*T0)*sqrtpsip))))
{
double m00_sqrt(d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*(T2+0.402982))+2.446562))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T8_Vgm_di=(0.5*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgm_di_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vgm_di*(T2+0.402982)+T2_Vgm_di*T2_Vgm_di+T2_Vgm_di*T2_Vgm_di+T2*(+T2_Vgm_di_Vgm_di+0.0))+0.0))));
  T8_Vgm_di_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vgm_si*(T2+0.402982)+T2_Vgm_di*T2_Vgm_si+T2_Vgm_si*T2_Vgm_di+T2*(+T2_Vgm_di_Vgm_si+0.0))+0.0))));
  T8_Vgm_di_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vdbulk_di*(T2+0.402982)+T2_Vgm_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_di+T2*(+T2_Vgm_di_Vdbulk_di+0.0))+0.0))));
  T8_Vgm_di_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vsbulk_si*(T2+0.402982)+T2_Vgm_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_di+T2*(+T2_Vgm_di_Vsbulk_si+0.0))+0.0))));
  T8_Vgm_di_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vgi_bi*(T2+0.402982)+T2_Vgm_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_di+T2*(+T2_Vgm_di_Vgi_bi+0.0))+0.0))));
  T8_Vgm_di_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vdi_bi*(T2+0.402982)+T2_Vgm_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_di+T2*(+T2_Vgm_di_Vdi_bi+0.0))+0.0))));
  T8_Vgm_di_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Vsi_bi*(T2+0.402982)+T2_Vgm_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_di+T2*(+T2_Vgm_di_Vsi_bi+0.0))+0.0))));
  T8_Vgm_di_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgm_di-((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))*d10_sqrt0)+0.5*(+(+T2_Vgm_di_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di))+d10_sqrt0*(+(+T2_Vgm_di_Tempt_GND*(T2+0.402982)+T2_Vgm_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_di+T2*(+T2_Vgm_di_Tempt_GND+0.0))+0.0))));
#endif
T8_Vgm_si=(0.5*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgm_si_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vgm_di*(T2+0.402982)+T2_Vgm_si*T2_Vgm_di+T2_Vgm_di*T2_Vgm_si+T2*(+T2_Vgm_si_Vgm_di+0.0))+0.0))));
  T8_Vgm_si_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vgm_si*(T2+0.402982)+T2_Vgm_si*T2_Vgm_si+T2_Vgm_si*T2_Vgm_si+T2*(+T2_Vgm_si_Vgm_si+0.0))+0.0))));
  T8_Vgm_si_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vdbulk_di*(T2+0.402982)+T2_Vgm_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_si+T2*(+T2_Vgm_si_Vdbulk_di+0.0))+0.0))));
  T8_Vgm_si_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vsbulk_si*(T2+0.402982)+T2_Vgm_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_si+T2*(+T2_Vgm_si_Vsbulk_si+0.0))+0.0))));
  T8_Vgm_si_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vgi_bi*(T2+0.402982)+T2_Vgm_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_si+T2*(+T2_Vgm_si_Vgi_bi+0.0))+0.0))));
  T8_Vgm_si_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vdi_bi*(T2+0.402982)+T2_Vgm_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_si+T2*(+T2_Vgm_si_Vdi_bi+0.0))+0.0))));
  T8_Vgm_si_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Vsi_bi*(T2+0.402982)+T2_Vgm_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_si+T2*(+T2_Vgm_si_Vsi_bi+0.0))+0.0))));
  T8_Vgm_si_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgm_si-((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))*d10_sqrt0)+0.5*(+(+T2_Vgm_si_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si))+d10_sqrt0*(+(+T2_Vgm_si_Tempt_GND*(T2+0.402982)+T2_Vgm_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_si+T2*(+T2_Vgm_si_Tempt_GND+0.0))+0.0))));
#endif
T8_Vdbulk_di=(0.5*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdbulk_di_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_di+0.0))+0.0))));
  T8_Vdbulk_di_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgm_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgm_si+0.0))+0.0))));
  T8_Vdbulk_di_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdbulk_di*(T2+0.402982)+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdbulk_di+0.0))+0.0))));
  T8_Vdbulk_di_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsbulk_si*(T2+0.402982)+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsbulk_si+0.0))+0.0))));
  T8_Vdbulk_di_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vgi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vgi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vdi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vdi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Vsi_bi*(T2+0.402982)+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Vsi_bi+0.0))+0.0))));
  T8_Vdbulk_di_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdbulk_di-((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))*d10_sqrt0)+0.5*(+(+T2_Vdbulk_di_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di))+d10_sqrt0*(+(+T2_Vdbulk_di_Tempt_GND*(T2+0.402982)+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*(+T2_Vdbulk_di_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsbulk_si=(0.5*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsbulk_si_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_di+0.0))+0.0))));
  T8_Vsbulk_si_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgm_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgm_si+0.0))+0.0))));
  T8_Vsbulk_si_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdbulk_di*(T2+0.402982)+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdbulk_di+0.0))+0.0))));
  T8_Vsbulk_si_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsbulk_si*(T2+0.402982)+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsbulk_si+0.0))+0.0))));
  T8_Vsbulk_si_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vgi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vgi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vdi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vdi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Vsi_bi*(T2+0.402982)+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Vsi_bi+0.0))+0.0))));
  T8_Vsbulk_si_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsbulk_si-((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))*d10_sqrt0)+0.5*(+(+T2_Vsbulk_si_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si))+d10_sqrt0*(+(+T2_Vsbulk_si_Tempt_GND*(T2+0.402982)+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*(+T2_Vsbulk_si_Tempt_GND+0.0))+0.0))));
#endif
T8_Vgi_bi=(0.5*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vgi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_di*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_di+0.0))+0.0))));
  T8_Vgi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgm_si*(T2+0.402982)+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgm_si+0.0))+0.0))));
  T8_Vgi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdbulk_di*(T2+0.402982)+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vgi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsbulk_si*(T2+0.402982)+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vgi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vgi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vdi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vgi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Vsi_bi*(T2+0.402982)+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*(+T2_Vgi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vgi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vgi_bi-((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))*d10_sqrt0)+0.5*(+(+T2_Vgi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi))+d10_sqrt0*(+(+T2_Vgi_bi_Tempt_GND*(T2+0.402982)+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*(+T2_Vgi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vdi_bi=(0.5*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vdi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_di*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_di+0.0))+0.0))));
  T8_Vdi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgm_si*(T2+0.402982)+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgm_si+0.0))+0.0))));
  T8_Vdi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdbulk_di*(T2+0.402982)+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vdi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsbulk_si*(T2+0.402982)+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vdi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vgi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vdi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vdi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Vsi_bi*(T2+0.402982)+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*(+T2_Vdi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vdi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_bi-((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))*d10_sqrt0)+0.5*(+(+T2_Vdi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi))+d10_sqrt0*(+(+T2_Vdi_bi_Tempt_GND*(T2+0.402982)+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*(+T2_Vdi_bi_Tempt_GND+0.0))+0.0))));
#endif
T8_Vsi_bi=(0.5*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T8_Vsi_bi_Vgm_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_di-(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_di*(T2+0.402982))+(T2*T2_Vgm_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_di*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_di+0.0))+0.0))));
  T8_Vsi_bi_Vgm_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgm_si-(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgm_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgm_si*(T2+0.402982))+(T2*T2_Vgm_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgm_si*(T2+0.402982)+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgm_si+0.0))+0.0))));
  T8_Vsi_bi_Vdbulk_di=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdbulk_di-(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdbulk_di-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdbulk_di*(T2+0.402982))+(T2*T2_Vdbulk_di)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdbulk_di*(T2+0.402982)+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdbulk_di+0.0))+0.0))));
  T8_Vsi_bi_Vsbulk_si=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsbulk_si-(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsbulk_si-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsbulk_si*(T2+0.402982))+(T2*T2_Vsbulk_si)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsbulk_si*(T2+0.402982)+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsbulk_si+0.0))+0.0))));
  T8_Vsi_bi_Vgi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vgi_bi-(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vgi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vgi_bi*(T2+0.402982))+(T2*T2_Vgi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vgi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vgi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vdi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vdi_bi-(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vdi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vdi_bi*(T2+0.402982))+(T2*T2_Vdi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vdi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vdi_bi+0.0))+0.0))));
  T8_Vsi_bi_Vsi_bi=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Vsi_bi-(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Vsi_bi-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Vsi_bi*(T2+0.402982)+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*(+T2_Vsi_bi_Vsi_bi+0.0))+0.0))));
  T8_Vsi_bi_Tempt_GND=(+0.0*((T2-0.201491)-d00_sqrt0)+0.0*(T2_Tempt_GND-(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vsi_bi-((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))*d10_sqrt0)+0.5*(+(+T2_Vsi_bi_Tempt_GND-0.0)-(m20_sqrt(((T2*(T2+0.402982))+2.446562))*(((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND)))*((T2_Vsi_bi*(T2+0.402982))+(T2*T2_Vsi_bi))+d10_sqrt0*(+(+T2_Vsi_bi_Tempt_GND*(T2+0.402982)+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*(+T2_Vsi_bi_Tempt_GND+0.0))+0.0))));
#endif
#if defined(_DERIVATE)
T8_Tempt_GND=(0.5*(T2_Tempt_GND-((T2_Tempt_GND*(T2+0.402982))+(T2*T2_Tempt_GND))*d10_sqrt0));
#endif
#endif
T8=(0.5*((T2-0.201491)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T2-0.201491)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
sqrtpsisa_Vgm_di=sqrtpsip_Vgm_di;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_di_Vgm_di=sqrtpsip_Vgm_di_Vgm_di;
  sqrtpsisa_Vgm_di_Vgm_si=sqrtpsip_Vgm_di_Vgm_si;
  sqrtpsisa_Vgm_di_Vdbulk_di=sqrtpsip_Vgm_di_Vdbulk_di;
  sqrtpsisa_Vgm_di_Vsbulk_si=sqrtpsip_Vgm_di_Vsbulk_si;
  sqrtpsisa_Vgm_di_Vgi_bi=sqrtpsip_Vgm_di_Vgi_bi;
  sqrtpsisa_Vgm_di_Vdi_bi=sqrtpsip_Vgm_di_Vdi_bi;
  sqrtpsisa_Vgm_di_Vsi_bi=sqrtpsip_Vgm_di_Vsi_bi;
  sqrtpsisa_Vgm_di_Tempt_GND=sqrtpsip_Vgm_di_Tempt_GND;
#endif
sqrtpsisa_Vgm_si=sqrtpsip_Vgm_si;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgm_si_Vgm_di=sqrtpsip_Vgm_si_Vgm_di;
  sqrtpsisa_Vgm_si_Vgm_si=sqrtpsip_Vgm_si_Vgm_si;
  sqrtpsisa_Vgm_si_Vdbulk_di=sqrtpsip_Vgm_si_Vdbulk_di;
  sqrtpsisa_Vgm_si_Vsbulk_si=sqrtpsip_Vgm_si_Vsbulk_si;
  sqrtpsisa_Vgm_si_Vgi_bi=sqrtpsip_Vgm_si_Vgi_bi;
  sqrtpsisa_Vgm_si_Vdi_bi=sqrtpsip_Vgm_si_Vdi_bi;
  sqrtpsisa_Vgm_si_Vsi_bi=sqrtpsip_Vgm_si_Vsi_bi;
  sqrtpsisa_Vgm_si_Tempt_GND=sqrtpsip_Vgm_si_Tempt_GND;
#endif
sqrtpsisa_Vdbulk_di=sqrtpsip_Vdbulk_di;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdbulk_di_Vgm_di=sqrtpsip_Vdbulk_di_Vgm_di;
  sqrtpsisa_Vdbulk_di_Vgm_si=sqrtpsip_Vdbulk_di_Vgm_si;
  sqrtpsisa_Vdbulk_di_Vdbulk_di=sqrtpsip_Vdbulk_di_Vdbulk_di;
  sqrtpsisa_Vdbulk_di_Vsbulk_si=sqrtpsip_Vdbulk_di_Vsbulk_si;
  sqrtpsisa_Vdbulk_di_Vgi_bi=sqrtpsip_Vdbulk_di_Vgi_bi;
  sqrtpsisa_Vdbulk_di_Vdi_bi=sqrtpsip_Vdbulk_di_Vdi_bi;
  sqrtpsisa_Vdbulk_di_Vsi_bi=sqrtpsip_Vdbulk_di_Vsi_bi;
  sqrtpsisa_Vdbulk_di_Tempt_GND=sqrtpsip_Vdbulk_di_Tempt_GND;
#endif
sqrtpsisa_Vsbulk_si=sqrtpsip_Vsbulk_si;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsbulk_si_Vgm_di=sqrtpsip_Vsbulk_si_Vgm_di;
  sqrtpsisa_Vsbulk_si_Vgm_si=sqrtpsip_Vsbulk_si_Vgm_si;
  sqrtpsisa_Vsbulk_si_Vdbulk_di=sqrtpsip_Vsbulk_si_Vdbulk_di;
  sqrtpsisa_Vsbulk_si_Vsbulk_si=sqrtpsip_Vsbulk_si_Vsbulk_si;
  sqrtpsisa_Vsbulk_si_Vgi_bi=sqrtpsip_Vsbulk_si_Vgi_bi;
  sqrtpsisa_Vsbulk_si_Vdi_bi=sqrtpsip_Vsbulk_si_Vdi_bi;
  sqrtpsisa_Vsbulk_si_Vsi_bi=sqrtpsip_Vsbulk_si_Vsi_bi;
  sqrtpsisa_Vsbulk_si_Tempt_GND=sqrtpsip_Vsbulk_si_Tempt_GND;
#endif
sqrtpsisa_Vgi_bi=sqrtpsip_Vgi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vgi_bi_Vgm_di=sqrtpsip_Vgi_bi_Vgm_di;
  sqrtpsisa_Vgi_bi_Vgm_si=sqrtpsip_Vgi_bi_Vgm_si;
  sqrtpsisa_Vgi_bi_Vdbulk_di=sqrtpsip_Vgi_bi_Vdbulk_di;
  sqrtpsisa_Vgi_bi_Vsbulk_si=sqrtpsip_Vgi_bi_Vsbulk_si;
  sqrtpsisa_Vgi_bi_Vgi_bi=sqrtpsip_Vgi_bi_Vgi_bi;
  sqrtpsisa_Vgi_bi_Vdi_bi=sqrtpsip_Vgi_bi_Vdi_bi;
  sqrtpsisa_Vgi_bi_Vsi_bi=sqrtpsip_Vgi_bi_Vsi_bi;
  sqrtpsisa_Vgi_bi_Tempt_GND=sqrtpsip_Vgi_bi_Tempt_GND;
#endif
sqrtpsisa_Vdi_bi=sqrtpsip_Vdi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vdi_bi_Vgm_di=sqrtpsip_Vdi_bi_Vgm_di;
  sqrtpsisa_Vdi_bi_Vgm_si=sqrtpsip_Vdi_bi_Vgm_si;
  sqrtpsisa_Vdi_bi_Vdbulk_di=sqrtpsip_Vdi_bi_Vdbulk_di;
  sqrtpsisa_Vdi_bi_Vsbulk_si=sqrtpsip_Vdi_bi_Vsbulk_si;
  sqrtpsisa_Vdi_bi_Vgi_bi=sqrtpsip_Vdi_bi_Vgi_bi;
  sqrtpsisa_Vdi_bi_Vdi_bi=sqrtpsip_Vdi_bi_Vdi_bi;
  sqrtpsisa_Vdi_bi_Vsi_bi=sqrtpsip_Vdi_bi_Vsi_bi;
  sqrtpsisa_Vdi_bi_Tempt_GND=sqrtpsip_Vdi_bi_Tempt_GND;
#endif
sqrtpsisa_Vsi_bi=sqrtpsip_Vsi_bi;
#if defined(_DERIVATE2)
  sqrtpsisa_Vsi_bi_Vgm_di=sqrtpsip_Vsi_bi_Vgm_di;
  sqrtpsisa_Vsi_bi_Vgm_si=sqrtpsip_Vsi_bi_Vgm_si;
  sqrtpsisa_Vsi_bi_Vdbulk_di=sqrtpsip_Vsi_bi_Vdbulk_di;
  sqrtpsisa_Vsi_bi_Vsbulk_si=sqrtpsip_Vsi_bi_Vsbulk_si;
  sqrtpsisa_Vsi_bi_Vgi_bi=sqrtpsip_Vsi_bi_Vgi_bi;
  sqrtpsisa_Vsi_bi_Vdi_bi=sqrtpsip_Vsi_bi_Vdi_bi;
  sqrtpsisa_Vsi_bi_Vsi_bi=sqrtpsip_Vsi_bi_Vsi_bi;
  sqrtpsisa_Vsi_bi_Tempt_GND=sqrtpsip_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
sqrtpsisa_Tempt_GND=sqrtpsip_Tempt_GND;
#endif
#endif
sqrtpsisa=sqrtpsip;
EXIT_IF_ISNAN(sqrtpsip)
if
((T8<=(-68.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=0.0;
  T4_Vgm_si_Vgm_di=0.0;
  T4_Vgm_si_Vdbulk_di=0.0;
  T4_Vgm_si_Vsbulk_si=0.0;
  T4_Vgm_si_Vgi_bi=0.0;
  T4_Vgm_si_Vdi_bi=0.0;
  T4_Vgm_si_Vsi_bi=0.0;
  T4_Vgm_si_Tempt_GND=0.0;
#endif
T4_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=0.0;
  T4_Vgm_di_Vgm_di=0.0;
  T4_Vgm_di_Vdbulk_di=0.0;
  T4_Vgm_di_Vsbulk_si=0.0;
  T4_Vgm_di_Vgi_bi=0.0;
  T4_Vgm_di_Vdi_bi=0.0;
  T4_Vgm_di_Vsi_bi=0.0;
  T4_Vgm_di_Tempt_GND=0.0;
#endif
T4_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=0.0;
  T4_Vdbulk_di_Vgm_di=0.0;
  T4_Vdbulk_di_Vdbulk_di=0.0;
  T4_Vdbulk_di_Vsbulk_si=0.0;
  T4_Vdbulk_di_Vgi_bi=0.0;
  T4_Vdbulk_di_Vdi_bi=0.0;
  T4_Vdbulk_di_Vsi_bi=0.0;
  T4_Vdbulk_di_Tempt_GND=0.0;
#endif
T4_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=0.0;
  T4_Vsbulk_si_Vgm_di=0.0;
  T4_Vsbulk_si_Vdbulk_di=0.0;
  T4_Vsbulk_si_Vsbulk_si=0.0;
  T4_Vsbulk_si_Vgi_bi=0.0;
  T4_Vsbulk_si_Vdi_bi=0.0;
  T4_Vsbulk_si_Vsi_bi=0.0;
  T4_Vsbulk_si_Tempt_GND=0.0;
#endif
T4_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=0.0;
  T4_Vgi_bi_Vgm_di=0.0;
  T4_Vgi_bi_Vdbulk_di=0.0;
  T4_Vgi_bi_Vsbulk_si=0.0;
  T4_Vgi_bi_Vgi_bi=0.0;
  T4_Vgi_bi_Vdi_bi=0.0;
  T4_Vgi_bi_Vsi_bi=0.0;
  T4_Vgi_bi_Tempt_GND=0.0;
#endif
T4_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=0.0;
  T4_Vdi_bi_Vgm_di=0.0;
  T4_Vdi_bi_Vdbulk_di=0.0;
  T4_Vdi_bi_Vsbulk_si=0.0;
  T4_Vdi_bi_Vgi_bi=0.0;
  T4_Vdi_bi_Vdi_bi=0.0;
  T4_Vdi_bi_Vsi_bi=0.0;
  T4_Vdi_bi_Tempt_GND=0.0;
#endif
T4_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=0.0;
  T4_Vsi_bi_Vgm_di=0.0;
  T4_Vsi_bi_Vdbulk_di=0.0;
  T4_Vsi_bi_Vsbulk_si=0.0;
  T4_Vsi_bi_Vgi_bi=0.0;
  T4_Vsi_bi_Vdi_bi=0.0;
  T4_Vsi_bi_Vsi_bi=0.0;
  T4_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=0.0;
#endif
#endif
T4=(-100.0);
EXIT_IF_ISNAN((-100.0))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=0.0;
  T5_Vgm_si_Vgm_di=0.0;
  T5_Vgm_si_Vdbulk_di=0.0;
  T5_Vgm_si_Vsbulk_si=0.0;
  T5_Vgm_si_Vgi_bi=0.0;
  T5_Vgm_si_Vdi_bi=0.0;
  T5_Vgm_si_Vsi_bi=0.0;
  T5_Vgm_si_Tempt_GND=0.0;
#endif
T5_Vgm_di=0.0;
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=0.0;
  T5_Vgm_di_Vgm_di=0.0;
  T5_Vgm_di_Vdbulk_di=0.0;
  T5_Vgm_di_Vsbulk_si=0.0;
  T5_Vgm_di_Vgi_bi=0.0;
  T5_Vgm_di_Vdi_bi=0.0;
  T5_Vgm_di_Vsi_bi=0.0;
  T5_Vgm_di_Tempt_GND=0.0;
#endif
T5_Vdbulk_di=0.0;
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=0.0;
  T5_Vdbulk_di_Vgm_di=0.0;
  T5_Vdbulk_di_Vdbulk_di=0.0;
  T5_Vdbulk_di_Vsbulk_si=0.0;
  T5_Vdbulk_di_Vgi_bi=0.0;
  T5_Vdbulk_di_Vdi_bi=0.0;
  T5_Vdbulk_di_Vsi_bi=0.0;
  T5_Vdbulk_di_Tempt_GND=0.0;
#endif
T5_Vsbulk_si=0.0;
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=0.0;
  T5_Vsbulk_si_Vgm_di=0.0;
  T5_Vsbulk_si_Vdbulk_di=0.0;
  T5_Vsbulk_si_Vsbulk_si=0.0;
  T5_Vsbulk_si_Vgi_bi=0.0;
  T5_Vsbulk_si_Vdi_bi=0.0;
  T5_Vsbulk_si_Vsi_bi=0.0;
  T5_Vsbulk_si_Tempt_GND=0.0;
#endif
T5_Vgi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=0.0;
  T5_Vgi_bi_Vgm_di=0.0;
  T5_Vgi_bi_Vdbulk_di=0.0;
  T5_Vgi_bi_Vsbulk_si=0.0;
  T5_Vgi_bi_Vgi_bi=0.0;
  T5_Vgi_bi_Vdi_bi=0.0;
  T5_Vgi_bi_Vsi_bi=0.0;
  T5_Vgi_bi_Tempt_GND=0.0;
#endif
T5_Vdi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=0.0;
  T5_Vdi_bi_Vgm_di=0.0;
  T5_Vdi_bi_Vdbulk_di=0.0;
  T5_Vdi_bi_Vsbulk_si=0.0;
  T5_Vdi_bi_Vgi_bi=0.0;
  T5_Vdi_bi_Vdi_bi=0.0;
  T5_Vdi_bi_Vsi_bi=0.0;
  T5_Vdi_bi_Tempt_GND=0.0;
#endif
T5_Vsi_bi=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=0.0;
  T5_Vsi_bi_Vgm_di=0.0;
  T5_Vsi_bi_Vdbulk_di=0.0;
  T5_Vsi_bi_Vsbulk_si=0.0;
  T5_Vsi_bi_Vgi_bi=0.0;
  T5_Vsi_bi_Vdi_bi=0.0;
  T5_Vsi_bi_Vsi_bi=0.0;
  T5_Vsi_bi_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=0.0;
#endif
#endif
T5=20.0;
EXIT_IF_ISNAN(20.0)
if
((T8<(T4-(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=bsimbulk_d_lexp(T4,T4_Vgm_si);
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=T4_Vgm_si_Vgm_si;
  T3_Vgm_si_Vgm_di=T4_Vgm_si_Vgm_di;
  T3_Vgm_si_Vdbulk_di=T4_Vgm_si_Vdbulk_di;
  T3_Vgm_si_Vsbulk_si=T4_Vgm_si_Vsbulk_si;
  T3_Vgm_si_Vgi_bi=T4_Vgm_si_Vgi_bi;
  T3_Vgm_si_Vdi_bi=T4_Vgm_si_Vdi_bi;
  T3_Vgm_si_Vsi_bi=T4_Vgm_si_Vsi_bi;
  T3_Vgm_si_Tempt_GND=T4_Vgm_si_Tempt_GND;
#endif
T3_Vgm_di=bsimbulk_d_lexp(T4,T4_Vgm_di);
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=T4_Vgm_di_Vgm_si;
  T3_Vgm_di_Vgm_di=T4_Vgm_di_Vgm_di;
  T3_Vgm_di_Vdbulk_di=T4_Vgm_di_Vdbulk_di;
  T3_Vgm_di_Vsbulk_si=T4_Vgm_di_Vsbulk_si;
  T3_Vgm_di_Vgi_bi=T4_Vgm_di_Vgi_bi;
  T3_Vgm_di_Vdi_bi=T4_Vgm_di_Vdi_bi;
  T3_Vgm_di_Vsi_bi=T4_Vgm_di_Vsi_bi;
  T3_Vgm_di_Tempt_GND=T4_Vgm_di_Tempt_GND;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T4,T4_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T4_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T4_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T4_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T4_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T4_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T4_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T4_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T4_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T4,T4_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T4_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T4_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T4_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T4_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T4_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T4_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T4_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T4_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T4,T4_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T4_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T4_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T4_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T4_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T4_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T4_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T4_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T4_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T4,T4_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T4_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T4_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T4_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T4_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T4_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T4_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T4_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T4_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T4,T4_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T4_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T4_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T4_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T4_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T4_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T4_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T4_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T4_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T4,T4_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T4);
EXIT_IF_ISNAN(bsimbulk_lexp(T4))
}
else
{
if
((T8>(T4+(0.5*T5))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=bsimbulk_d_lexp(T8,T8_Vgm_si);
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=T8_Vgm_si_Vgm_si;
  T3_Vgm_si_Vgm_di=T8_Vgm_si_Vgm_di;
  T3_Vgm_si_Vdbulk_di=T8_Vgm_si_Vdbulk_di;
  T3_Vgm_si_Vsbulk_si=T8_Vgm_si_Vsbulk_si;
  T3_Vgm_si_Vgi_bi=T8_Vgm_si_Vgi_bi;
  T3_Vgm_si_Vdi_bi=T8_Vgm_si_Vdi_bi;
  T3_Vgm_si_Vsi_bi=T8_Vgm_si_Vsi_bi;
  T3_Vgm_si_Tempt_GND=T8_Vgm_si_Tempt_GND;
#endif
T3_Vgm_di=bsimbulk_d_lexp(T8,T8_Vgm_di);
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=T8_Vgm_di_Vgm_si;
  T3_Vgm_di_Vgm_di=T8_Vgm_di_Vgm_di;
  T3_Vgm_di_Vdbulk_di=T8_Vgm_di_Vdbulk_di;
  T3_Vgm_di_Vsbulk_si=T8_Vgm_di_Vsbulk_si;
  T3_Vgm_di_Vgi_bi=T8_Vgm_di_Vgi_bi;
  T3_Vgm_di_Vdi_bi=T8_Vgm_di_Vdi_bi;
  T3_Vgm_di_Vsi_bi=T8_Vgm_di_Vsi_bi;
  T3_Vgm_di_Tempt_GND=T8_Vgm_di_Tempt_GND;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=(((T8_Vgm_di-T4_Vgm_di)*T5-(T8-T4)*T5_Vgm_di)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=((+T8_Vgm_di_Vgm_di-T4_Vgm_di_Vgm_di)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vgm_di/T5/T5/T5);
  T2_Vgm_di_Vgm_si=((+T8_Vgm_di_Vgm_si-T4_Vgm_di_Vgm_si)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vgm_si/T5/T5/T5);
  T2_Vgm_di_Vdbulk_di=((+T8_Vgm_di_Vdbulk_di-T4_Vgm_di_Vdbulk_di)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgm_di_Vsbulk_si=((+T8_Vgm_di_Vsbulk_si-T4_Vgm_di_Vsbulk_si)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgm_di_Vgi_bi=((+T8_Vgm_di_Vgi_bi-T4_Vgm_di_Vgi_bi)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vgi_bi/T5/T5/T5);
  T2_Vgm_di_Vdi_bi=((+T8_Vgm_di_Vdi_bi-T4_Vgm_di_Vdi_bi)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vdi_bi/T5/T5/T5);
  T2_Vgm_di_Vsi_bi=((+T8_Vgm_di_Vsi_bi-T4_Vgm_di_Vsi_bi)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Vsi_bi/T5/T5/T5);
  T2_Vgm_di_Tempt_GND=((+T8_Vgm_di_Tempt_GND-T4_Vgm_di_Tempt_GND)/T5-((T8_Vgm_di-T4_Vgm_di)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgm_di+(T8-T4)*T5_Vgm_di_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgm_di*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vgm_si=(((T8_Vgm_si-T4_Vgm_si)*T5-(T8-T4)*T5_Vgm_si)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=((+T8_Vgm_si_Vgm_di-T4_Vgm_si_Vgm_di)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vgm_di/T5/T5/T5);
  T2_Vgm_si_Vgm_si=((+T8_Vgm_si_Vgm_si-T4_Vgm_si_Vgm_si)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vgm_si/T5/T5/T5);
  T2_Vgm_si_Vdbulk_di=((+T8_Vgm_si_Vdbulk_di-T4_Vgm_si_Vdbulk_di)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgm_si_Vsbulk_si=((+T8_Vgm_si_Vsbulk_si-T4_Vgm_si_Vsbulk_si)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgm_si_Vgi_bi=((+T8_Vgm_si_Vgi_bi-T4_Vgm_si_Vgi_bi)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vgi_bi/T5/T5/T5);
  T2_Vgm_si_Vdi_bi=((+T8_Vgm_si_Vdi_bi-T4_Vgm_si_Vdi_bi)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vdi_bi/T5/T5/T5);
  T2_Vgm_si_Vsi_bi=((+T8_Vgm_si_Vsi_bi-T4_Vgm_si_Vsi_bi)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Vsi_bi/T5/T5/T5);
  T2_Vgm_si_Tempt_GND=((+T8_Vgm_si_Tempt_GND-T4_Vgm_si_Tempt_GND)/T5-((T8_Vgm_si-T4_Vgm_si)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgm_si+(T8-T4)*T5_Vgm_si_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgm_si*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vdbulk_di=(((T8_Vdbulk_di-T4_Vdbulk_di)*T5-(T8-T4)*T5_Vdbulk_di)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=((+T8_Vdbulk_di_Vgm_di-T4_Vdbulk_di_Vgm_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5);
  T2_Vdbulk_di_Vgm_si=((+T8_Vdbulk_di_Vgm_si-T4_Vdbulk_di_Vgm_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5);
  T2_Vdbulk_di_Vdbulk_di=((+T8_Vdbulk_di_Vdbulk_di-T4_Vdbulk_di_Vdbulk_di)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdbulk_di_Vsbulk_si=((+T8_Vdbulk_di_Vsbulk_si-T4_Vdbulk_di_Vsbulk_si)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdbulk_di_Vgi_bi=((+T8_Vdbulk_di_Vgi_bi-T4_Vdbulk_di_Vgi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vdi_bi=((+T8_Vdbulk_di_Vdi_bi-T4_Vdbulk_di_Vdi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5);
  T2_Vdbulk_di_Vsi_bi=((+T8_Vdbulk_di_Vsi_bi-T4_Vdbulk_di_Vsi_bi)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5);
  T2_Vdbulk_di_Tempt_GND=((+T8_Vdbulk_di_Tempt_GND-T4_Vdbulk_di_Tempt_GND)/T5-((T8_Vdbulk_di-T4_Vdbulk_di)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdbulk_di+(T8-T4)*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsbulk_si=(((T8_Vsbulk_si-T4_Vsbulk_si)*T5-(T8-T4)*T5_Vsbulk_si)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=((+T8_Vsbulk_si_Vgm_di-T4_Vsbulk_si_Vgm_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5);
  T2_Vsbulk_si_Vgm_si=((+T8_Vsbulk_si_Vgm_si-T4_Vsbulk_si_Vgm_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5);
  T2_Vsbulk_si_Vdbulk_di=((+T8_Vsbulk_si_Vdbulk_di-T4_Vsbulk_si_Vdbulk_di)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsbulk_si_Vsbulk_si=((+T8_Vsbulk_si_Vsbulk_si-T4_Vsbulk_si_Vsbulk_si)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsbulk_si_Vgi_bi=((+T8_Vsbulk_si_Vgi_bi-T4_Vsbulk_si_Vgi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vdi_bi=((+T8_Vsbulk_si_Vdi_bi-T4_Vsbulk_si_Vdi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5);
  T2_Vsbulk_si_Vsi_bi=((+T8_Vsbulk_si_Vsi_bi-T4_Vsbulk_si_Vsi_bi)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5);
  T2_Vsbulk_si_Tempt_GND=((+T8_Vsbulk_si_Tempt_GND-T4_Vsbulk_si_Tempt_GND)/T5-((T8_Vsbulk_si-T4_Vsbulk_si)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsbulk_si+(T8-T4)*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vgi_bi=(((T8_Vgi_bi-T4_Vgi_bi)*T5-(T8-T4)*T5_Vgi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=((+T8_Vgi_bi_Vgm_di-T4_Vgi_bi_Vgm_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vgi_bi_Vgm_si=((+T8_Vgi_bi_Vgm_si-T4_Vgi_bi_Vgm_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vgi_bi_Vdbulk_di=((+T8_Vgi_bi_Vdbulk_di-T4_Vgi_bi_Vdbulk_di)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vgi_bi_Vsbulk_si=((+T8_Vgi_bi_Vsbulk_si-T4_Vgi_bi_Vsbulk_si)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vgi_bi_Vgi_bi=((+T8_Vgi_bi_Vgi_bi-T4_Vgi_bi_Vgi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vgi_bi_Vdi_bi=((+T8_Vgi_bi_Vdi_bi-T4_Vgi_bi_Vdi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vgi_bi_Vsi_bi=((+T8_Vgi_bi_Vsi_bi-T4_Vgi_bi_Vsi_bi)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vgi_bi_Tempt_GND=((+T8_Vgi_bi_Tempt_GND-T4_Vgi_bi_Tempt_GND)/T5-((T8_Vgi_bi-T4_Vgi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vgi_bi+(T8-T4)*T5_Vgi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vdi_bi=(((T8_Vdi_bi-T4_Vdi_bi)*T5-(T8-T4)*T5_Vdi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=((+T8_Vdi_bi_Vgm_di-T4_Vdi_bi_Vgm_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vdi_bi_Vgm_si=((+T8_Vdi_bi_Vgm_si-T4_Vdi_bi_Vgm_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vdi_bi_Vdbulk_di=((+T8_Vdi_bi_Vdbulk_di-T4_Vdi_bi_Vdbulk_di)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vdi_bi_Vsbulk_si=((+T8_Vdi_bi_Vsbulk_si-T4_Vdi_bi_Vsbulk_si)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vdi_bi_Vgi_bi=((+T8_Vdi_bi_Vgi_bi-T4_Vdi_bi_Vgi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vdi_bi_Vdi_bi=((+T8_Vdi_bi_Vdi_bi-T4_Vdi_bi_Vdi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vdi_bi_Vsi_bi=((+T8_Vdi_bi_Vsi_bi-T4_Vdi_bi_Vsi_bi)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vdi_bi_Tempt_GND=((+T8_Vdi_bi_Tempt_GND-T4_Vdi_bi_Tempt_GND)/T5-((T8_Vdi_bi-T4_Vdi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vdi_bi+(T8-T4)*T5_Vdi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
T2_Vsi_bi=(((T8_Vsi_bi-T4_Vsi_bi)*T5-(T8-T4)*T5_Vsi_bi)/T5/T5);
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=((+T8_Vsi_bi_Vgm_di-T4_Vsi_bi_Vgm_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_di+(T8_Vgm_di-T4_Vgm_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5);
  T2_Vsi_bi_Vgm_si=((+T8_Vsi_bi_Vgm_si-T4_Vsi_bi_Vgm_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgm_si+(T8_Vgm_si-T4_Vgm_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgm_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5);
  T2_Vsi_bi_Vdbulk_di=((+T8_Vsi_bi_Vdbulk_di-T4_Vsi_bi_Vdbulk_di)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdbulk_di+(T8_Vdbulk_di-T4_Vdbulk_di)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5);
  T2_Vsi_bi_Vsbulk_si=((+T8_Vsi_bi_Vsbulk_si-T4_Vsi_bi_Vsbulk_si)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsbulk_si+(T8_Vsbulk_si-T4_Vsbulk_si)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5);
  T2_Vsi_bi_Vgi_bi=((+T8_Vsi_bi_Vgi_bi-T4_Vsi_bi_Vgi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vgi_bi+(T8_Vgi_bi-T4_Vgi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vgi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5);
  T2_Vsi_bi_Vdi_bi=((+T8_Vsi_bi_Vdi_bi-T4_Vsi_bi_Vdi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vdi_bi+(T8_Vdi_bi-T4_Vdi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vdi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5);
  T2_Vsi_bi_Vsi_bi=((+T8_Vsi_bi_Vsi_bi-T4_Vsi_bi_Vsi_bi)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8_Vsi_bi-T4_Vsi_bi)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Vsi_bi)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5);
  T2_Vsi_bi_Tempt_GND=((+T8_Vsi_bi_Tempt_GND-T4_Vsi_bi_Tempt_GND)/T5-((T8_Vsi_bi-T4_Vsi_bi)*T5_Tempt_GND+(T8_Tempt_GND-T4_Tempt_GND)*T5_Vsi_bi+(T8-T4)*T5_Vsi_bi_Tempt_GND)/T5/T5+2*(T8-T4)*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=(((T8_Tempt_GND-T4_Tempt_GND)*T5-(T8-T4)*T5_Tempt_GND)/T5/T5);
#endif
#endif
T2=((T8-T4)/T5);
EXIT_IF_ISNAN(((T8-T4)/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=((T2_Vgm_di*T2)+(T2*T2_Vgm_di));
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=(+T2_Vgm_di_Vgm_di*T2+T2_Vgm_di*T2_Vgm_di+T2_Vgm_di*T2_Vgm_di+T2*T2_Vgm_di_Vgm_di);
  T6_Vgm_di_Vgm_si=(+T2_Vgm_di_Vgm_si*T2+T2_Vgm_di*T2_Vgm_si+T2_Vgm_si*T2_Vgm_di+T2*T2_Vgm_di_Vgm_si);
  T6_Vgm_di_Vdbulk_di=(+T2_Vgm_di_Vdbulk_di*T2+T2_Vgm_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_di+T2*T2_Vgm_di_Vdbulk_di);
  T6_Vgm_di_Vsbulk_si=(+T2_Vgm_di_Vsbulk_si*T2+T2_Vgm_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_di+T2*T2_Vgm_di_Vsbulk_si);
  T6_Vgm_di_Vgi_bi=(+T2_Vgm_di_Vgi_bi*T2+T2_Vgm_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_di+T2*T2_Vgm_di_Vgi_bi);
  T6_Vgm_di_Vdi_bi=(+T2_Vgm_di_Vdi_bi*T2+T2_Vgm_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_di+T2*T2_Vgm_di_Vdi_bi);
  T6_Vgm_di_Vsi_bi=(+T2_Vgm_di_Vsi_bi*T2+T2_Vgm_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_di+T2*T2_Vgm_di_Vsi_bi);
  T6_Vgm_di_Tempt_GND=(+T2_Vgm_di_Tempt_GND*T2+T2_Vgm_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_di+T2*T2_Vgm_di_Tempt_GND);
#endif
T6_Vgm_si=((T2_Vgm_si*T2)+(T2*T2_Vgm_si));
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=(+T2_Vgm_si_Vgm_di*T2+T2_Vgm_si*T2_Vgm_di+T2_Vgm_di*T2_Vgm_si+T2*T2_Vgm_si_Vgm_di);
  T6_Vgm_si_Vgm_si=(+T2_Vgm_si_Vgm_si*T2+T2_Vgm_si*T2_Vgm_si+T2_Vgm_si*T2_Vgm_si+T2*T2_Vgm_si_Vgm_si);
  T6_Vgm_si_Vdbulk_di=(+T2_Vgm_si_Vdbulk_di*T2+T2_Vgm_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgm_si+T2*T2_Vgm_si_Vdbulk_di);
  T6_Vgm_si_Vsbulk_si=(+T2_Vgm_si_Vsbulk_si*T2+T2_Vgm_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgm_si+T2*T2_Vgm_si_Vsbulk_si);
  T6_Vgm_si_Vgi_bi=(+T2_Vgm_si_Vgi_bi*T2+T2_Vgm_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vgm_si+T2*T2_Vgm_si_Vgi_bi);
  T6_Vgm_si_Vdi_bi=(+T2_Vgm_si_Vdi_bi*T2+T2_Vgm_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vgm_si+T2*T2_Vgm_si_Vdi_bi);
  T6_Vgm_si_Vsi_bi=(+T2_Vgm_si_Vsi_bi*T2+T2_Vgm_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vgm_si+T2*T2_Vgm_si_Vsi_bi);
  T6_Vgm_si_Tempt_GND=(+T2_Vgm_si_Tempt_GND*T2+T2_Vgm_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vgm_si+T2*T2_Vgm_si_Tempt_GND);
#endif
T6_Vdbulk_di=((T2_Vdbulk_di*T2)+(T2*T2_Vdbulk_di));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+T2_Vdbulk_di_Vgm_di*T2+T2_Vdbulk_di*T2_Vgm_di+T2_Vgm_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_di);
  T6_Vdbulk_di_Vgm_si=(+T2_Vdbulk_di_Vgm_si*T2+T2_Vdbulk_di*T2_Vgm_si+T2_Vgm_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgm_si);
  T6_Vdbulk_di_Vdbulk_di=(+T2_Vdbulk_di_Vdbulk_di*T2+T2_Vdbulk_di*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdbulk_di);
  T6_Vdbulk_di_Vsbulk_si=(+T2_Vdbulk_di_Vsbulk_si*T2+T2_Vdbulk_di*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsbulk_si);
  T6_Vdbulk_di_Vgi_bi=(+T2_Vdbulk_di_Vgi_bi*T2+T2_Vdbulk_di*T2_Vgi_bi+T2_Vgi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vgi_bi);
  T6_Vdbulk_di_Vdi_bi=(+T2_Vdbulk_di_Vdi_bi*T2+T2_Vdbulk_di*T2_Vdi_bi+T2_Vdi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vdi_bi);
  T6_Vdbulk_di_Vsi_bi=(+T2_Vdbulk_di_Vsi_bi*T2+T2_Vdbulk_di*T2_Vsi_bi+T2_Vsi_bi*T2_Vdbulk_di+T2*T2_Vdbulk_di_Vsi_bi);
  T6_Vdbulk_di_Tempt_GND=(+T2_Vdbulk_di_Tempt_GND*T2+T2_Vdbulk_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vdbulk_di+T2*T2_Vdbulk_di_Tempt_GND);
#endif
T6_Vsbulk_si=((T2_Vsbulk_si*T2)+(T2*T2_Vsbulk_si));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+T2_Vsbulk_si_Vgm_di*T2+T2_Vsbulk_si*T2_Vgm_di+T2_Vgm_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_di);
  T6_Vsbulk_si_Vgm_si=(+T2_Vsbulk_si_Vgm_si*T2+T2_Vsbulk_si*T2_Vgm_si+T2_Vgm_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgm_si);
  T6_Vsbulk_si_Vdbulk_di=(+T2_Vsbulk_si_Vdbulk_di*T2+T2_Vsbulk_si*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdbulk_di);
  T6_Vsbulk_si_Vsbulk_si=(+T2_Vsbulk_si_Vsbulk_si*T2+T2_Vsbulk_si*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsbulk_si);
  T6_Vsbulk_si_Vgi_bi=(+T2_Vsbulk_si_Vgi_bi*T2+T2_Vsbulk_si*T2_Vgi_bi+T2_Vgi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vgi_bi);
  T6_Vsbulk_si_Vdi_bi=(+T2_Vsbulk_si_Vdi_bi*T2+T2_Vsbulk_si*T2_Vdi_bi+T2_Vdi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vdi_bi);
  T6_Vsbulk_si_Vsi_bi=(+T2_Vsbulk_si_Vsi_bi*T2+T2_Vsbulk_si*T2_Vsi_bi+T2_Vsi_bi*T2_Vsbulk_si+T2*T2_Vsbulk_si_Vsi_bi);
  T6_Vsbulk_si_Tempt_GND=(+T2_Vsbulk_si_Tempt_GND*T2+T2_Vsbulk_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vsbulk_si+T2*T2_Vsbulk_si_Tempt_GND);
#endif
T6_Vgi_bi=((T2_Vgi_bi*T2)+(T2*T2_Vgi_bi));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+T2_Vgi_bi_Vgm_di*T2+T2_Vgi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_di);
  T6_Vgi_bi_Vgm_si=(+T2_Vgi_bi_Vgm_si*T2+T2_Vgi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vgm_si);
  T6_Vgi_bi_Vdbulk_di=(+T2_Vgi_bi_Vdbulk_di*T2+T2_Vgi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vgi_bi+T2*T2_Vgi_bi_Vdbulk_di);
  T6_Vgi_bi_Vsbulk_si=(+T2_Vgi_bi_Vsbulk_si*T2+T2_Vgi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vgi_bi+T2*T2_Vgi_bi_Vsbulk_si);
  T6_Vgi_bi_Vgi_bi=(+T2_Vgi_bi_Vgi_bi*T2+T2_Vgi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vgi_bi);
  T6_Vgi_bi_Vdi_bi=(+T2_Vgi_bi_Vdi_bi*T2+T2_Vgi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vdi_bi);
  T6_Vgi_bi_Vsi_bi=(+T2_Vgi_bi_Vsi_bi*T2+T2_Vgi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vgi_bi+T2*T2_Vgi_bi_Vsi_bi);
  T6_Vgi_bi_Tempt_GND=(+T2_Vgi_bi_Tempt_GND*T2+T2_Vgi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vgi_bi+T2*T2_Vgi_bi_Tempt_GND);
#endif
T6_Vdi_bi=((T2_Vdi_bi*T2)+(T2*T2_Vdi_bi));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+T2_Vdi_bi_Vgm_di*T2+T2_Vdi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_di);
  T6_Vdi_bi_Vgm_si=(+T2_Vdi_bi_Vgm_si*T2+T2_Vdi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vgm_si);
  T6_Vdi_bi_Vdbulk_di=(+T2_Vdi_bi_Vdbulk_di*T2+T2_Vdi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vdi_bi+T2*T2_Vdi_bi_Vdbulk_di);
  T6_Vdi_bi_Vsbulk_si=(+T2_Vdi_bi_Vsbulk_si*T2+T2_Vdi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vdi_bi+T2*T2_Vdi_bi_Vsbulk_si);
  T6_Vdi_bi_Vgi_bi=(+T2_Vdi_bi_Vgi_bi*T2+T2_Vdi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vgi_bi);
  T6_Vdi_bi_Vdi_bi=(+T2_Vdi_bi_Vdi_bi*T2+T2_Vdi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vdi_bi);
  T6_Vdi_bi_Vsi_bi=(+T2_Vdi_bi_Vsi_bi*T2+T2_Vdi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vdi_bi+T2*T2_Vdi_bi_Vsi_bi);
  T6_Vdi_bi_Tempt_GND=(+T2_Vdi_bi_Tempt_GND*T2+T2_Vdi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_bi+T2*T2_Vdi_bi_Tempt_GND);
#endif
T6_Vsi_bi=((T2_Vsi_bi*T2)+(T2*T2_Vsi_bi));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+T2_Vsi_bi_Vgm_di*T2+T2_Vsi_bi*T2_Vgm_di+T2_Vgm_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_di);
  T6_Vsi_bi_Vgm_si=(+T2_Vsi_bi_Vgm_si*T2+T2_Vsi_bi*T2_Vgm_si+T2_Vgm_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vgm_si);
  T6_Vsi_bi_Vdbulk_di=(+T2_Vsi_bi_Vdbulk_di*T2+T2_Vsi_bi*T2_Vdbulk_di+T2_Vdbulk_di*T2_Vsi_bi+T2*T2_Vsi_bi_Vdbulk_di);
  T6_Vsi_bi_Vsbulk_si=(+T2_Vsi_bi_Vsbulk_si*T2+T2_Vsi_bi*T2_Vsbulk_si+T2_Vsbulk_si*T2_Vsi_bi+T2*T2_Vsi_bi_Vsbulk_si);
  T6_Vsi_bi_Vgi_bi=(+T2_Vsi_bi_Vgi_bi*T2+T2_Vsi_bi*T2_Vgi_bi+T2_Vgi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vgi_bi);
  T6_Vsi_bi_Vdi_bi=(+T2_Vsi_bi_Vdi_bi*T2+T2_Vsi_bi*T2_Vdi_bi+T2_Vdi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vdi_bi);
  T6_Vsi_bi_Vsi_bi=(+T2_Vsi_bi_Vsi_bi*T2+T2_Vsi_bi*T2_Vsi_bi+T2_Vsi_bi*T2_Vsi_bi+T2*T2_Vsi_bi_Vsi_bi);
  T6_Vsi_bi_Tempt_GND=(+T2_Vsi_bi_Tempt_GND*T2+T2_Vsi_bi*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_bi+T2*T2_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND));
#endif
#endif
T6=(T2*T2);
EXIT_IF_ISNAN((T2*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgm_si+((T5_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))));
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=(+T4_Vgm_si_Vgm_si+(+T5_Vgm_si_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vgm_si))+(+T6_Vgm_si_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vgm_si*(1.25-T6)+T6_Vgm_si*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vgm_si)))))));
  T3_Vgm_si_Vgm_di=(+T4_Vgm_si_Vgm_di+(+T5_Vgm_si_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vgm_di))+(+T6_Vgm_si_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vgm_di*(1.25-T6)+T6_Vgm_si*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vgm_di)))))));
  T3_Vgm_si_Vdbulk_di=(+T4_Vgm_si_Vdbulk_di+(+T5_Vgm_si_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vdbulk_di))+(+T6_Vgm_si_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vdbulk_di*(1.25-T6)+T6_Vgm_si*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vdbulk_di)))))));
  T3_Vgm_si_Vsbulk_si=(+T4_Vgm_si_Vsbulk_si+(+T5_Vgm_si_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vsbulk_si))+(+T6_Vgm_si_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vsbulk_si*(1.25-T6)+T6_Vgm_si*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vsbulk_si)))))));
  T3_Vgm_si_Vgi_bi=(+T4_Vgm_si_Vgi_bi+(+T5_Vgm_si_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vgi_bi))+(+T6_Vgm_si_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vgi_bi*(1.25-T6)+T6_Vgm_si*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vgi_bi)))))));
  T3_Vgm_si_Vdi_bi=(+T4_Vgm_si_Vdi_bi+(+T5_Vgm_si_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vdi_bi))+(+T6_Vgm_si_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vdi_bi*(1.25-T6)+T6_Vgm_si*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vdi_bi)))))));
  T3_Vgm_si_Vsi_bi=(+T4_Vgm_si_Vsi_bi+(+T5_Vgm_si_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Vsi_bi))+(+T6_Vgm_si_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Vsi_bi*(1.25-T6)+T6_Vgm_si*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Vsi_bi)))))));
  T3_Vgm_si_Tempt_GND=(+T4_Vgm_si_Tempt_GND+(+T5_Vgm_si_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_si*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgm_si)+((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgm_si+0.5*T2_Vgm_si_Tempt_GND))+(+T6_Vgm_si_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_si*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_si_Tempt_GND*(1.25-T6)+T6_Vgm_si*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgm_si)+T6*(+0.0-T6_Vgm_si_Tempt_GND)))))));
#endif
T3_Vgm_di=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgm_di+((T5_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))));
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=(+T4_Vgm_di_Vgm_si+(+T5_Vgm_di_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vgm_si))+(+T6_Vgm_di_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vgm_si*(1.25-T6)+T6_Vgm_di*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vgm_si)))))));
  T3_Vgm_di_Vgm_di=(+T4_Vgm_di_Vgm_di+(+T5_Vgm_di_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vgm_di))+(+T6_Vgm_di_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vgm_di*(1.25-T6)+T6_Vgm_di*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vgm_di)))))));
  T3_Vgm_di_Vdbulk_di=(+T4_Vgm_di_Vdbulk_di+(+T5_Vgm_di_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vdbulk_di))+(+T6_Vgm_di_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vdbulk_di*(1.25-T6)+T6_Vgm_di*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vdbulk_di)))))));
  T3_Vgm_di_Vsbulk_si=(+T4_Vgm_di_Vsbulk_si+(+T5_Vgm_di_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vsbulk_si))+(+T6_Vgm_di_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vsbulk_si*(1.25-T6)+T6_Vgm_di*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vsbulk_si)))))));
  T3_Vgm_di_Vgi_bi=(+T4_Vgm_di_Vgi_bi+(+T5_Vgm_di_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vgi_bi))+(+T6_Vgm_di_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vgi_bi*(1.25-T6)+T6_Vgm_di*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vgi_bi)))))));
  T3_Vgm_di_Vdi_bi=(+T4_Vgm_di_Vdi_bi+(+T5_Vgm_di_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vdi_bi))+(+T6_Vgm_di_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vdi_bi*(1.25-T6)+T6_Vgm_di*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vdi_bi)))))));
  T3_Vgm_di_Vsi_bi=(+T4_Vgm_di_Vsi_bi+(+T5_Vgm_di_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Vsi_bi))+(+T6_Vgm_di_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Vsi_bi*(1.25-T6)+T6_Vgm_di*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Vsi_bi)))))));
  T3_Vgm_di_Tempt_GND=(+T4_Vgm_di_Tempt_GND+(+T5_Vgm_di_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgm_di*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgm_di)+((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgm_di+0.5*T2_Vgm_di_Tempt_GND))+(+T6_Vgm_di_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgm_di*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgm_di_Tempt_GND*(1.25-T6)+T6_Vgm_di*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgm_di)+T6*(+0.0-T6_Vgm_di_Tempt_GND)))))));
#endif
T3_Vdbulk_di=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdbulk_di+((T5_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T4_Vdbulk_di_Vgm_si+(+T5_Vdbulk_di_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_si))+(+T6_Vdbulk_di_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_si)))))));
  T3_Vdbulk_di_Vgm_di=(+T4_Vdbulk_di_Vgm_di+(+T5_Vdbulk_di_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgm_di))+(+T6_Vdbulk_di_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgm_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgm_di)))))));
  T3_Vdbulk_di_Vdbulk_di=(+T4_Vdbulk_di_Vdbulk_di+(+T5_Vdbulk_di_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdbulk_di))+(+T6_Vdbulk_di_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdbulk_di*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdbulk_di)))))));
  T3_Vdbulk_di_Vsbulk_si=(+T4_Vdbulk_di_Vsbulk_si+(+T5_Vdbulk_di_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsbulk_si))+(+T6_Vdbulk_di_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsbulk_si*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsbulk_si)))))));
  T3_Vdbulk_di_Vgi_bi=(+T4_Vdbulk_di_Vgi_bi+(+T5_Vdbulk_di_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vgi_bi))+(+T6_Vdbulk_di_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vgi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vgi_bi)))))));
  T3_Vdbulk_di_Vdi_bi=(+T4_Vdbulk_di_Vdi_bi+(+T5_Vdbulk_di_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vdi_bi))+(+T6_Vdbulk_di_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vdi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vdi_bi)))))));
  T3_Vdbulk_di_Vsi_bi=(+T4_Vdbulk_di_Vsi_bi+(+T5_Vdbulk_di_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Vsi_bi))+(+T6_Vdbulk_di_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Vsi_bi*(1.25-T6)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Vsi_bi)))))));
  T3_Vdbulk_di_Tempt_GND=(+T4_Vdbulk_di_Tempt_GND+(+T5_Vdbulk_di_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdbulk_di*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdbulk_di)+((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdbulk_di+0.5*T2_Vdbulk_di_Tempt_GND))+(+T6_Vdbulk_di_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdbulk_di*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdbulk_di_Tempt_GND*(1.25-T6)+T6_Vdbulk_di*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdbulk_di)+T6*(+0.0-T6_Vdbulk_di_Tempt_GND)))))));
#endif
T3_Vsbulk_si=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsbulk_si+((T5_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T4_Vsbulk_si_Vgm_si+(+T5_Vsbulk_si_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_si))+(+T6_Vsbulk_si_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_si)))))));
  T3_Vsbulk_si_Vgm_di=(+T4_Vsbulk_si_Vgm_di+(+T5_Vsbulk_si_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgm_di))+(+T6_Vsbulk_si_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgm_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgm_di)))))));
  T3_Vsbulk_si_Vdbulk_di=(+T4_Vsbulk_si_Vdbulk_di+(+T5_Vsbulk_si_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdbulk_di))+(+T6_Vsbulk_si_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdbulk_di*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdbulk_di)))))));
  T3_Vsbulk_si_Vsbulk_si=(+T4_Vsbulk_si_Vsbulk_si+(+T5_Vsbulk_si_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsbulk_si))+(+T6_Vsbulk_si_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsbulk_si*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsbulk_si)))))));
  T3_Vsbulk_si_Vgi_bi=(+T4_Vsbulk_si_Vgi_bi+(+T5_Vsbulk_si_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vgi_bi))+(+T6_Vsbulk_si_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vgi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vgi_bi)))))));
  T3_Vsbulk_si_Vdi_bi=(+T4_Vsbulk_si_Vdi_bi+(+T5_Vsbulk_si_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vdi_bi))+(+T6_Vsbulk_si_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vdi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vdi_bi)))))));
  T3_Vsbulk_si_Vsi_bi=(+T4_Vsbulk_si_Vsi_bi+(+T5_Vsbulk_si_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Vsi_bi))+(+T6_Vsbulk_si_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Vsi_bi*(1.25-T6)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Vsi_bi)))))));
  T3_Vsbulk_si_Tempt_GND=(+T4_Vsbulk_si_Tempt_GND+(+T5_Vsbulk_si_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsbulk_si*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsbulk_si)+((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsbulk_si+0.5*T2_Vsbulk_si_Tempt_GND))+(+T6_Vsbulk_si_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsbulk_si*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsbulk_si_Tempt_GND*(1.25-T6)+T6_Vsbulk_si*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsbulk_si)+T6*(+0.0-T6_Vsbulk_si_Tempt_GND)))))));
#endif
T3_Vgi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vgi_bi+((T5_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T4_Vgi_bi_Vgm_si+(+T5_Vgi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_si))+(+T6_Vgi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_si)))))));
  T3_Vgi_bi_Vgm_di=(+T4_Vgi_bi_Vgm_di+(+T5_Vgi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgm_di))+(+T6_Vgi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgm_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgm_di)))))));
  T3_Vgi_bi_Vdbulk_di=(+T4_Vgi_bi_Vdbulk_di+(+T5_Vgi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdbulk_di))+(+T6_Vgi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdbulk_di*(1.25-T6)+T6_Vgi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdbulk_di)))))));
  T3_Vgi_bi_Vsbulk_si=(+T4_Vgi_bi_Vsbulk_si+(+T5_Vgi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsbulk_si))+(+T6_Vgi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsbulk_si*(1.25-T6)+T6_Vgi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsbulk_si)))))));
  T3_Vgi_bi_Vgi_bi=(+T4_Vgi_bi_Vgi_bi+(+T5_Vgi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vgi_bi))+(+T6_Vgi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vgi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vgi_bi)))))));
  T3_Vgi_bi_Vdi_bi=(+T4_Vgi_bi_Vdi_bi+(+T5_Vgi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vdi_bi))+(+T6_Vgi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vdi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vdi_bi)))))));
  T3_Vgi_bi_Vsi_bi=(+T4_Vgi_bi_Vsi_bi+(+T5_Vgi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Vsi_bi))+(+T6_Vgi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Vsi_bi*(1.25-T6)+T6_Vgi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Vsi_bi)))))));
  T3_Vgi_bi_Tempt_GND=(+T4_Vgi_bi_Tempt_GND+(+T5_Vgi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vgi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vgi_bi)+((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vgi_bi+0.5*T2_Vgi_bi_Tempt_GND))+(+T6_Vgi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vgi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vgi_bi_Tempt_GND*(1.25-T6)+T6_Vgi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vgi_bi)+T6*(+0.0-T6_Vgi_bi_Tempt_GND)))))));
#endif
T3_Vdi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vdi_bi+((T5_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T4_Vdi_bi_Vgm_si+(+T5_Vdi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_si))+(+T6_Vdi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_si)))))));
  T3_Vdi_bi_Vgm_di=(+T4_Vdi_bi_Vgm_di+(+T5_Vdi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgm_di))+(+T6_Vdi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgm_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgm_di)))))));
  T3_Vdi_bi_Vdbulk_di=(+T4_Vdi_bi_Vdbulk_di+(+T5_Vdi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdbulk_di))+(+T6_Vdi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdbulk_di*(1.25-T6)+T6_Vdi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdbulk_di)))))));
  T3_Vdi_bi_Vsbulk_si=(+T4_Vdi_bi_Vsbulk_si+(+T5_Vdi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsbulk_si))+(+T6_Vdi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsbulk_si*(1.25-T6)+T6_Vdi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsbulk_si)))))));
  T3_Vdi_bi_Vgi_bi=(+T4_Vdi_bi_Vgi_bi+(+T5_Vdi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vgi_bi))+(+T6_Vdi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vgi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vgi_bi)))))));
  T3_Vdi_bi_Vdi_bi=(+T4_Vdi_bi_Vdi_bi+(+T5_Vdi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vdi_bi))+(+T6_Vdi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vdi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vdi_bi)))))));
  T3_Vdi_bi_Vsi_bi=(+T4_Vdi_bi_Vsi_bi+(+T5_Vdi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Vsi_bi))+(+T6_Vdi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Vsi_bi*(1.25-T6)+T6_Vdi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Vsi_bi)))))));
  T3_Vdi_bi_Tempt_GND=(+T4_Vdi_bi_Tempt_GND+(+T5_Vdi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vdi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vdi_bi)+((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_bi+0.5*T2_Vdi_bi_Tempt_GND))+(+T6_Vdi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vdi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vdi_bi_Tempt_GND*(1.25-T6)+T6_Vdi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vdi_bi)+T6*(+0.0-T6_Vdi_bi_Tempt_GND)))))));
#endif
T3_Vsi_bi=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Vsi_bi+((T5_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T4_Vsi_bi_Vgm_si+(+T5_Vsi_bi_Vgm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_si))+(((T6_Vgm_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))))))+T5_Vgm_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_si))+(+T6_Vsi_bi_Vgm_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_si*(1.25-T6))+(T6*(-T6_Vgm_si)))))+T6_Vgm_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_si)+T6_Vgm_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_si)))))));
  T3_Vsi_bi_Vgm_di=(+T4_Vsi_bi_Vgm_di+(+T5_Vsi_bi_Vgm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgm_di))+(((T6_Vgm_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))))))+T5_Vgm_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgm_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgm_di))+(+T6_Vsi_bi_Vgm_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgm_di*(1.25-T6))+(T6*(-T6_Vgm_di)))))+T6_Vgm_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgm_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vgm_di)+T6_Vgm_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgm_di)))))));
  T3_Vsi_bi_Vdbulk_di=(+T4_Vsi_bi_Vdbulk_di+(+T5_Vsi_bi_Vdbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdbulk_di))+(((T6_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))))))+T5_Vdbulk_di*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdbulk_di+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdbulk_di))+(+T6_Vsi_bi_Vdbulk_di*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdbulk_di*(1.25-T6))+(T6*(-T6_Vdbulk_di)))))+T6_Vdbulk_di*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdbulk_di*(1.25-T6)+T6_Vsi_bi*(-T6_Vdbulk_di)+T6_Vdbulk_di*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdbulk_di)))))));
  T3_Vsi_bi_Vsbulk_si=(+T4_Vsi_bi_Vsbulk_si+(+T5_Vsi_bi_Vsbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsbulk_si))+(((T6_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))))))+T5_Vsbulk_si*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsbulk_si+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsbulk_si))+(+T6_Vsi_bi_Vsbulk_si*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsbulk_si*(1.25-T6))+(T6*(-T6_Vsbulk_si)))))+T6_Vsbulk_si*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsbulk_si*(1.25-T6)+T6_Vsi_bi*(-T6_Vsbulk_si)+T6_Vsbulk_si*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsbulk_si)))))));
  T3_Vsi_bi_Vgi_bi=(+T4_Vsi_bi_Vgi_bi+(+T5_Vsi_bi_Vgi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vgi_bi))+(((T6_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))))))+T5_Vgi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vgi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vgi_bi))+(+T6_Vsi_bi_Vgi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vgi_bi*(1.25-T6))+(T6*(-T6_Vgi_bi)))))+T6_Vgi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vgi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vgi_bi)+T6_Vgi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vgi_bi)))))));
  T3_Vsi_bi_Vdi_bi=(+T4_Vsi_bi_Vdi_bi+(+T5_Vsi_bi_Vdi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vdi_bi))+(((T6_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))))))+T5_Vdi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vdi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vdi_bi))+(+T6_Vsi_bi_Vdi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vdi_bi*(1.25-T6))+(T6*(-T6_Vdi_bi)))))+T6_Vdi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vdi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vdi_bi)+T6_Vdi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vdi_bi)))))));
  T3_Vsi_bi_Vsi_bi=(+T4_Vsi_bi_Vsi_bi+(+T5_Vsi_bi_Vsi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Vsi_bi))+(((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))))+T5_Vsi_bi*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Vsi_bi+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Vsi_bi))+(+T6_Vsi_bi_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))+T6_Vsi_bi*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Vsi_bi*(1.25-T6)+T6_Vsi_bi*(-T6_Vsi_bi)+T6_Vsi_bi*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Vsi_bi)))))));
  T3_Vsi_bi_Tempt_GND=(+T4_Vsi_bi_Tempt_GND+(+T5_Vsi_bi_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))+T5_Vsi_bi*(((0.5*T2_Tempt_GND))+(((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))+T5_Tempt_GND*((0.5*T2_Vsi_bi)+((T6_Vsi_bi*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi)))))))+T5*(+(+(0.0/64.0-(0.0*0.0+0.0*0.0+5.0*0.0)/64.0/64.0+2*5.0*0.0*0.0/64.0/64.0/64.0)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vsi_bi+0.5*T2_Vsi_bi_Tempt_GND))+(+T6_Vsi_bi_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6)))+T6_Vsi_bi*(-(((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))+T6_Tempt_GND*(-((T6_Vsi_bi*(1.25-T6))+(T6*(-T6_Vsi_bi))))+T6*(+(0.0/16.0-(0.0*0.0+0.0*0.0+15.0*0.0)/16.0/16.0+2*15.0*0.0*0.0/16.0/16.0/16.0)-(+T6_Vsi_bi_Tempt_GND*(1.25-T6)+T6_Vsi_bi*(-T6_Tempt_GND)+T6_Tempt_GND*(-T6_Vsi_bi)+T6*(+0.0-T6_Vsi_bi_Tempt_GND)))))));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))),(T4_Tempt_GND+((T5_Tempt_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))+(T5*((0.5*T2_Tempt_GND)+((T6_Tempt_GND*((15.0/16.0)-(T6*(1.25-T6))))+(T6*(-((T6_Tempt_GND*(1.25-T6))+(T6*(-T6_Tempt_GND)))))))))));
#endif
#endif
T3=bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
EXIT_IF_ISNAN(bsimbulk_lexp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qdeff_Vgm_si=((T3_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))));
#if defined(_DERIVATE2)
  qdeff_Vgm_si_Vgm_si=(+T3_Vgm_si_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vgm_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vgm_si)-T8_Vgm_si_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_si)))));
  qdeff_Vgm_si_Vgm_di=(+T3_Vgm_si_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vgm_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vgm_di)-T8_Vgm_si_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_di)))));
  qdeff_Vgm_si_Vdbulk_di=(+T3_Vgm_si_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vdbulk_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vdbulk_di)-T8_Vgm_si_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdbulk_di)))));
  qdeff_Vgm_si_Vsbulk_si=(+T3_Vgm_si_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vsbulk_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vsbulk_si)-T8_Vgm_si_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsbulk_si)))));
  qdeff_Vgm_si_Vgi_bi=(+T3_Vgm_si_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vgi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vgi_bi)-T8_Vgm_si_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgi_bi)))));
  qdeff_Vgm_si_Vdi_bi=(+T3_Vgm_si_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vdi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vdi_bi)-T8_Vgm_si_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdi_bi)))));
  qdeff_Vgm_si_Vsi_bi=(+T3_Vgm_si_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Vsi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Vsi_bi)-T8_Vgm_si_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsi_bi)))));
  qdeff_Vgm_si_Tempt_GND=(+T3_Vgm_si_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_si*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3_Tempt_GND*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))+T3*(+(+(+0.0+T1_Vgm_si_Tempt_GND)-T8_Vgm_si_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgm_si+2.0*T0_Vgm_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_si)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+(2.0*T0)*(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Tempt_GND)))));
#endif
qdeff_Vgm_di=((T3_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))));
#if defined(_DERIVATE2)
  qdeff_Vgm_di_Vgm_si=(+T3_Vgm_di_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vgm_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vgm_si)-T8_Vgm_di_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_si)))));
  qdeff_Vgm_di_Vgm_di=(+T3_Vgm_di_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vgm_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vgm_di)-T8_Vgm_di_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_di)))));
  qdeff_Vgm_di_Vdbulk_di=(+T3_Vgm_di_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vdbulk_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vdbulk_di)-T8_Vgm_di_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdbulk_di)))));
  qdeff_Vgm_di_Vsbulk_si=(+T3_Vgm_di_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vsbulk_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vsbulk_si)-T8_Vgm_di_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsbulk_si)))));
  qdeff_Vgm_di_Vgi_bi=(+T3_Vgm_di_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vgi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vgi_bi)-T8_Vgm_di_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgi_bi)))));
  qdeff_Vgm_di_Vdi_bi=(+T3_Vgm_di_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vdi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vdi_bi)-T8_Vgm_di_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdi_bi)))));
  qdeff_Vgm_di_Vsi_bi=(+T3_Vgm_di_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Vsi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Vsi_bi)-T8_Vgm_di_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsi_bi)))));
  qdeff_Vgm_di_Tempt_GND=(+T3_Vgm_di_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgm_di*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3_Tempt_GND*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))+T3*(+(+(+0.0+T1_Vgm_di_Tempt_GND)-T8_Vgm_di_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgm_di+2.0*T0_Vgm_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgm_di)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+(2.0*T0)*(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Tempt_GND)))));
#endif
qdeff_Vdbulk_di=((T3_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))));
#if defined(_DERIVATE2)
  qdeff_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgm_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgm_si)-T8_Vdbulk_di_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si)))));
  qdeff_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgm_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgm_di)-T8_Vdbulk_di_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di)))));
  qdeff_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdbulk_di*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdbulk_di)-T8_Vdbulk_di_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)))));
  qdeff_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsbulk_si)-T8_Vdbulk_di_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)))));
  qdeff_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vgi_bi)-T8_Vdbulk_di_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi)))));
  qdeff_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vdi_bi)-T8_Vdbulk_di_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi)))));
  qdeff_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Vsi_bi)-T8_Vdbulk_di_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi)))));
  qdeff_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdbulk_di*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3_Tempt_GND*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))+T3*(+(+(+0.0+T1_Vdbulk_di_Tempt_GND)-T8_Vdbulk_di_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdbulk_di+2.0*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdbulk_di)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+(2.0*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND)))));
#endif
qdeff_Vsbulk_si=((T3_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))));
#if defined(_DERIVATE2)
  qdeff_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgm_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgm_si)-T8_Vsbulk_si_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si)))));
  qdeff_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgm_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgm_di)-T8_Vsbulk_si_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di)))));
  qdeff_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdbulk_di*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdbulk_di)-T8_Vsbulk_si_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)))));
  qdeff_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsbulk_si*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsbulk_si)-T8_Vsbulk_si_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)))));
  qdeff_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vgi_bi)-T8_Vsbulk_si_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi)))));
  qdeff_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vdi_bi)-T8_Vsbulk_si_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi)))));
  qdeff_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Vsi_bi)-T8_Vsbulk_si_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi)))));
  qdeff_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsbulk_si*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3_Tempt_GND*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))+T3*(+(+(+0.0+T1_Vsbulk_si_Tempt_GND)-T8_Vsbulk_si_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsbulk_si+2.0*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsbulk_si)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+(2.0*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND)))));
#endif
qdeff_Vgi_bi=((T3_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))));
#if defined(_DERIVATE2)
  qdeff_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_si)-T8_Vgi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si)))));
  qdeff_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgm_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgm_di)-T8_Vgi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di)))));
  qdeff_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdbulk_di*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdbulk_di)-T8_Vgi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di)))));
  qdeff_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsbulk_si*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsbulk_si)-T8_Vgi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si)))));
  qdeff_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vgi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vgi_bi)-T8_Vgi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi)))));
  qdeff_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vdi_bi)-T8_Vgi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi)))));
  qdeff_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Vsi_bi)-T8_Vgi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi)))));
  qdeff_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vgi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3_Tempt_GND*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))+T3*(+(+(+0.0+T1_Vgi_bi_Tempt_GND)-T8_Vgi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vgi_bi+2.0*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vgi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+(2.0*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND)))));
#endif
qdeff_Vdi_bi=((T3_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))));
#if defined(_DERIVATE2)
  qdeff_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_si)-T8_Vdi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si)))));
  qdeff_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgm_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgm_di)-T8_Vdi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di)))));
  qdeff_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdbulk_di*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdbulk_di)-T8_Vdi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di)))));
  qdeff_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsbulk_si*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsbulk_si)-T8_Vdi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si)))));
  qdeff_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vgi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vgi_bi)-T8_Vdi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi)))));
  qdeff_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vdi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vdi_bi)-T8_Vdi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi)))));
  qdeff_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Vsi_bi)-T8_Vdi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi)))));
  qdeff_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vdi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3_Tempt_GND*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))+T3*(+(+(+0.0+T1_Vdi_bi_Tempt_GND)-T8_Vdi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_bi+2.0*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vdi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+(2.0*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND)))));
#endif
qdeff_Vsi_bi=((T3_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))));
#if defined(_DERIVATE2)
  qdeff_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_si-T8_Vgm_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_si)-T8_Vsi_bi_Vgm_si)-(+(+0.0*T0+0.0*T0_Vgm_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((2.0*T0_Vgm_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si)))));
  qdeff_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgm_di-T8_Vgm_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgm_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgm_di)-T8_Vsi_bi_Vgm_di)-(+(+0.0*T0+0.0*T0_Vgm_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((2.0*T0_Vgm_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di)))));
  qdeff_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdbulk_di-T8_Vdbulk_di)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdbulk_di*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdbulk_di)-T8_Vsi_bi_Vdbulk_di)-(+(+0.0*T0+0.0*T0_Vdbulk_di+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((2.0*T0_Vdbulk_di))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di)))));
  qdeff_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsbulk_si-T8_Vsbulk_si)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsbulk_si*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsbulk_si)-T8_Vsi_bi_Vsbulk_si)-(+(+0.0*T0+0.0*T0_Vsbulk_si+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((2.0*T0_Vsbulk_si))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si)))));
  qdeff_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vgi_bi-T8_Vgi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vgi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vgi_bi)-T8_Vsi_bi_Vgi_bi)-(+(+0.0*T0+0.0*T0_Vgi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((2.0*T0_Vgi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi)))));
  qdeff_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vdi_bi-T8_Vdi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vdi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vdi_bi)-T8_Vsi_bi_Vdi_bi)-(+(+0.0*T0+0.0*T0_Vdi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((2.0*T0_Vdi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi)))));
  qdeff_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Vsi_bi*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Vsi_bi)-T8_Vsi_bi_Vsi_bi)-(+(+0.0*T0+0.0*T0_Vsi_bi+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((2.0*T0_Vsi_bi))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi)))));
  qdeff_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))+T3_Vsi_bi*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3_Tempt_GND*((T1_Vsi_bi-T8_Vsi_bi)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))+T3*(+(+(+0.0+T1_Vsi_bi_Tempt_GND)-T8_Vsi_bi_Tempt_GND)-(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vsi_bi+2.0*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+(2.0*T0_Vsi_bi)*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((2.0*T0_Tempt_GND))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+(2.0*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND)))));
#endif
#if defined(_DERIVATE)
qdeff_Tempt_GND=((T3_Tempt_GND*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+(T3*((T1_Tempt_GND-T8_Tempt_GND)-bsimbulk_d_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),(((2.0*T0_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+((2.0*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))));
#endif
#endif
qdeff=(T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
EXIT_IF_ISNAN((T3*(((1.0+T1)-T8)-bsimbulk_lln(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=bsimbulk_d_lexp(T8,T8_Vgm_si);
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=T8_Vgm_si_Vgm_si;
  T3_Vgm_si_Vgm_di=T8_Vgm_si_Vgm_di;
  T3_Vgm_si_Vdbulk_di=T8_Vgm_si_Vdbulk_di;
  T3_Vgm_si_Vsbulk_si=T8_Vgm_si_Vsbulk_si;
  T3_Vgm_si_Vgi_bi=T8_Vgm_si_Vgi_bi;
  T3_Vgm_si_Vdi_bi=T8_Vgm_si_Vdi_bi;
  T3_Vgm_si_Vsi_bi=T8_Vgm_si_Vsi_bi;
  T3_Vgm_si_Tempt_GND=T8_Vgm_si_Tempt_GND;
#endif
T3_Vgm_di=bsimbulk_d_lexp(T8,T8_Vgm_di);
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=T8_Vgm_di_Vgm_si;
  T3_Vgm_di_Vgm_di=T8_Vgm_di_Vgm_di;
  T3_Vgm_di_Vdbulk_di=T8_Vgm_di_Vdbulk_di;
  T3_Vgm_di_Vsbulk_si=T8_Vgm_di_Vsbulk_si;
  T3_Vgm_di_Vgi_bi=T8_Vgm_di_Vgi_bi;
  T3_Vgm_di_Vdi_bi=T8_Vgm_di_Vdi_bi;
  T3_Vgm_di_Vsi_bi=T8_Vgm_di_Vsi_bi;
  T3_Vgm_di_Tempt_GND=T8_Vgm_di_Tempt_GND;
#endif
T3_Vdbulk_di=bsimbulk_d_lexp(T8,T8_Vdbulk_di);
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=T8_Vdbulk_di_Vgm_si;
  T3_Vdbulk_di_Vgm_di=T8_Vdbulk_di_Vgm_di;
  T3_Vdbulk_di_Vdbulk_di=T8_Vdbulk_di_Vdbulk_di;
  T3_Vdbulk_di_Vsbulk_si=T8_Vdbulk_di_Vsbulk_si;
  T3_Vdbulk_di_Vgi_bi=T8_Vdbulk_di_Vgi_bi;
  T3_Vdbulk_di_Vdi_bi=T8_Vdbulk_di_Vdi_bi;
  T3_Vdbulk_di_Vsi_bi=T8_Vdbulk_di_Vsi_bi;
  T3_Vdbulk_di_Tempt_GND=T8_Vdbulk_di_Tempt_GND;
#endif
T3_Vsbulk_si=bsimbulk_d_lexp(T8,T8_Vsbulk_si);
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=T8_Vsbulk_si_Vgm_si;
  T3_Vsbulk_si_Vgm_di=T8_Vsbulk_si_Vgm_di;
  T3_Vsbulk_si_Vdbulk_di=T8_Vsbulk_si_Vdbulk_di;
  T3_Vsbulk_si_Vsbulk_si=T8_Vsbulk_si_Vsbulk_si;
  T3_Vsbulk_si_Vgi_bi=T8_Vsbulk_si_Vgi_bi;
  T3_Vsbulk_si_Vdi_bi=T8_Vsbulk_si_Vdi_bi;
  T3_Vsbulk_si_Vsi_bi=T8_Vsbulk_si_Vsi_bi;
  T3_Vsbulk_si_Tempt_GND=T8_Vsbulk_si_Tempt_GND;
#endif
T3_Vgi_bi=bsimbulk_d_lexp(T8,T8_Vgi_bi);
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=T8_Vgi_bi_Vgm_si;
  T3_Vgi_bi_Vgm_di=T8_Vgi_bi_Vgm_di;
  T3_Vgi_bi_Vdbulk_di=T8_Vgi_bi_Vdbulk_di;
  T3_Vgi_bi_Vsbulk_si=T8_Vgi_bi_Vsbulk_si;
  T3_Vgi_bi_Vgi_bi=T8_Vgi_bi_Vgi_bi;
  T3_Vgi_bi_Vdi_bi=T8_Vgi_bi_Vdi_bi;
  T3_Vgi_bi_Vsi_bi=T8_Vgi_bi_Vsi_bi;
  T3_Vgi_bi_Tempt_GND=T8_Vgi_bi_Tempt_GND;
#endif
T3_Vdi_bi=bsimbulk_d_lexp(T8,T8_Vdi_bi);
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=T8_Vdi_bi_Vgm_si;
  T3_Vdi_bi_Vgm_di=T8_Vdi_bi_Vgm_di;
  T3_Vdi_bi_Vdbulk_di=T8_Vdi_bi_Vdbulk_di;
  T3_Vdi_bi_Vsbulk_si=T8_Vdi_bi_Vsbulk_si;
  T3_Vdi_bi_Vgi_bi=T8_Vdi_bi_Vgi_bi;
  T3_Vdi_bi_Vdi_bi=T8_Vdi_bi_Vdi_bi;
  T3_Vdi_bi_Vsi_bi=T8_Vdi_bi_Vsi_bi;
  T3_Vdi_bi_Tempt_GND=T8_Vdi_bi_Tempt_GND;
#endif
T3_Vsi_bi=bsimbulk_d_lexp(T8,T8_Vsi_bi);
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=T8_Vsi_bi_Vgm_si;
  T3_Vsi_bi_Vgm_di=T8_Vsi_bi_Vgm_di;
  T3_Vsi_bi_Vdbulk_di=T8_Vsi_bi_Vdbulk_di;
  T3_Vsi_bi_Vsbulk_si=T8_Vsi_bi_Vsbulk_si;
  T3_Vsi_bi_Vgi_bi=T8_Vsi_bi_Vgi_bi;
  T3_Vsi_bi_Vdi_bi=T8_Vsi_bi_Vdi_bi;
  T3_Vsi_bi_Vsi_bi=T8_Vsi_bi_Vsi_bi;
  T3_Vsi_bi_Tempt_GND=T8_Vsi_bi_Tempt_GND;
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=bsimbulk_d_lexp(T8,T8_Tempt_GND);
#endif
#endif
T3=bsimbulk_lexp(T8);
EXIT_IF_ISNAN(bsimbulk_lexp(T8))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsisainv_Vgm_di=(-sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_di_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_di_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_di+1.0*sqrtpsisa_Vgm_di_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_di*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vgm_si=(-sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgm_si_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgm_si_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_si+1.0*sqrtpsisa_Vgm_si_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgm_si*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vdbulk_di=(-sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdbulk_di_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdbulk_di_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+1.0*sqrtpsisa_Vdbulk_di_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsbulk_si=(-sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsbulk_si_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsbulk_si_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+1.0*sqrtpsisa_Vsbulk_si_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vgi_bi=(-sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vgi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vgi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+1.0*sqrtpsisa_Vgi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vdi_bi=(-sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vdi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vdi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+1.0*sqrtpsisa_Vdi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
sqrtpsisainv_Vsi_bi=(-sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa);
#if defined(_DERIVATE2)
  sqrtpsisainv_Vsi_bi_Vgm_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgm_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgm_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdbulk_di=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdbulk_di)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsbulk_si=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsbulk_si)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vgi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vgi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vdi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vdi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Vsi_bi=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Vsi_bi)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi/sqrtpsisa/sqrtpsisa/sqrtpsisa);
  sqrtpsisainv_Vsi_bi_Tempt_GND=(0.0/sqrtpsisa-(0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+1.0*sqrtpsisa_Vsi_bi_Tempt_GND)/sqrtpsisa/sqrtpsisa+2*1.0*sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa/sqrtpsisa);
#endif
#if defined(_DERIVATE)
sqrtpsisainv_Tempt_GND=(-sqrtpsisa_Tempt_GND/sqrtpsisa/sqrtpsisa);
#endif
#endif
sqrtpsisainv=(1.0/sqrtpsisa);
EXIT_IF_ISNAN((1.0/sqrtpsisa))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=(((2.0*T3_Vgm_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))-T1_Vgm_si);
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgm_si)+(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_si))))-T1_Vgm_si_Vgm_si);
  T4_Vgm_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgm_di)+(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_di))))-T1_Vgm_si_Vgm_di);
  T4_Vgm_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vdbulk_di)+(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdbulk_di))))-T1_Vgm_si_Vdbulk_di);
  T4_Vgm_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vsbulk_si)+(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsbulk_si))))-T1_Vgm_si_Vsbulk_si);
  T4_Vgm_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgi_bi)+(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgi_bi))))-T1_Vgm_si_Vgi_bi);
  T4_Vgm_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vdi_bi)+(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdi_bi))))-T1_Vgm_si_Vdi_bi);
  T4_Vgm_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vsi_bi)+(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsi_bi))))-T1_Vgm_si_Vsi_bi);
  T4_Vgm_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Tempt_GND)+(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Tempt_GND))))-T1_Vgm_si_Tempt_GND);
#endif
T4_Vgm_di=(((2.0*T3_Vgm_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))-T1_Vgm_di);
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgm_si)+(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_si))))-T1_Vgm_di_Vgm_si);
  T4_Vgm_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgm_di)+(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_di))))-T1_Vgm_di_Vgm_di);
  T4_Vgm_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vdbulk_di)+(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdbulk_di))))-T1_Vgm_di_Vdbulk_di);
  T4_Vgm_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vsbulk_si)+(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsbulk_si))))-T1_Vgm_di_Vsbulk_si);
  T4_Vgm_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgi_bi)+(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgi_bi))))-T1_Vgm_di_Vgi_bi);
  T4_Vgm_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vdi_bi)+(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdi_bi))))-T1_Vgm_di_Vdi_bi);
  T4_Vgm_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vsi_bi)+(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsi_bi))))-T1_Vgm_di_Vsi_bi);
  T4_Vgm_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Tempt_GND)+(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Tempt_GND))))-T1_Vgm_di_Tempt_GND);
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=((-T3_Vgm_si/T3/T3)+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgm_si)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vgm_si_Vgm_si+sqrtpsisainv_Vgm_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgm_di)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vgm_si_Vgm_di+sqrtpsisainv_Vgm_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vgm_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgm_si_Vdbulk_di+sqrtpsisainv_Vgm_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vgm_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgm_si_Vsbulk_si+sqrtpsisainv_Vgm_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgm_si_Vgi_bi+sqrtpsisainv_Vgm_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vdi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgm_si_Vdi_bi+sqrtpsisainv_Vgm_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vsi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgm_si_Vsi_bi+sqrtpsisainv_Vgm_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Tempt_GND)/T3/T3+2*1.0*T3_Vgm_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgm_si_Tempt_GND+sqrtpsisainv_Vgm_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgm_di=((-T3_Vgm_di/T3/T3)+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgm_si)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vgm_di_Vgm_si+sqrtpsisainv_Vgm_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgm_di)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vgm_di_Vgm_di+sqrtpsisainv_Vgm_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vgm_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgm_di_Vdbulk_di+sqrtpsisainv_Vgm_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vgm_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgm_di_Vsbulk_si+sqrtpsisainv_Vgm_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgm_di_Vgi_bi+sqrtpsisainv_Vgm_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vdi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgm_di_Vdi_bi+sqrtpsisainv_Vgm_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vsi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgm_di_Vsi_bi+sqrtpsisainv_Vgm_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Tempt_GND)/T3/T3+2*1.0*T3_Vgm_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgm_di_Tempt_GND+sqrtpsisainv_Vgm_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T3_Vgm_si=(T3_Vgm_si-((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgm_si_Vgm_si=(+T3_Vgm_si_Vgm_si-(T4_Vgm_si_Vgm_si/T5-(T4_Vgm_si*T5_Vgm_si+T4_Vgm_si*T5_Vgm_si+T4*T5_Vgm_si_Vgm_si)/T5/T5+2*T4*T5_Vgm_si*T5_Vgm_si/T5/T5/T5));
  T3_Vgm_si_Vgm_di=(+T3_Vgm_si_Vgm_di-(T4_Vgm_si_Vgm_di/T5-(T4_Vgm_si*T5_Vgm_di+T4_Vgm_di*T5_Vgm_si+T4*T5_Vgm_si_Vgm_di)/T5/T5+2*T4*T5_Vgm_si*T5_Vgm_di/T5/T5/T5));
  T3_Vgm_si_Vdbulk_di=(+T3_Vgm_si_Vdbulk_di-(T4_Vgm_si_Vdbulk_di/T5-(T4_Vgm_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgm_si+T4*T5_Vgm_si_Vdbulk_di)/T5/T5+2*T4*T5_Vgm_si*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgm_si_Vsbulk_si=(+T3_Vgm_si_Vsbulk_si-(T4_Vgm_si_Vsbulk_si/T5-(T4_Vgm_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgm_si+T4*T5_Vgm_si_Vsbulk_si)/T5/T5+2*T4*T5_Vgm_si*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgm_si_Vgi_bi=(+T3_Vgm_si_Vgi_bi-(T4_Vgm_si_Vgi_bi/T5-(T4_Vgm_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vgi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vgi_bi/T5/T5/T5));
  T3_Vgm_si_Vdi_bi=(+T3_Vgm_si_Vdi_bi-(T4_Vgm_si_Vdi_bi/T5-(T4_Vgm_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vdi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vdi_bi/T5/T5/T5));
  T3_Vgm_si_Vsi_bi=(+T3_Vgm_si_Vsi_bi-(T4_Vgm_si_Vsi_bi/T5-(T4_Vgm_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vsi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vsi_bi/T5/T5/T5));
  T3_Vgm_si_Tempt_GND=(+T3_Vgm_si_Tempt_GND-(T4_Vgm_si_Tempt_GND/T5-(T4_Vgm_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vgm_si+T4*T5_Vgm_si_Tempt_GND)/T5/T5+2*T4*T5_Vgm_si*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vgm_di=(T3_Vgm_di-((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgm_di_Vgm_si=(+T3_Vgm_di_Vgm_si-(T4_Vgm_di_Vgm_si/T5-(T4_Vgm_di*T5_Vgm_si+T4_Vgm_si*T5_Vgm_di+T4*T5_Vgm_di_Vgm_si)/T5/T5+2*T4*T5_Vgm_di*T5_Vgm_si/T5/T5/T5));
  T3_Vgm_di_Vgm_di=(+T3_Vgm_di_Vgm_di-(T4_Vgm_di_Vgm_di/T5-(T4_Vgm_di*T5_Vgm_di+T4_Vgm_di*T5_Vgm_di+T4*T5_Vgm_di_Vgm_di)/T5/T5+2*T4*T5_Vgm_di*T5_Vgm_di/T5/T5/T5));
  T3_Vgm_di_Vdbulk_di=(+T3_Vgm_di_Vdbulk_di-(T4_Vgm_di_Vdbulk_di/T5-(T4_Vgm_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgm_di+T4*T5_Vgm_di_Vdbulk_di)/T5/T5+2*T4*T5_Vgm_di*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgm_di_Vsbulk_si=(+T3_Vgm_di_Vsbulk_si-(T4_Vgm_di_Vsbulk_si/T5-(T4_Vgm_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgm_di+T4*T5_Vgm_di_Vsbulk_si)/T5/T5+2*T4*T5_Vgm_di*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgm_di_Vgi_bi=(+T3_Vgm_di_Vgi_bi-(T4_Vgm_di_Vgi_bi/T5-(T4_Vgm_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vgi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vgi_bi/T5/T5/T5));
  T3_Vgm_di_Vdi_bi=(+T3_Vgm_di_Vdi_bi-(T4_Vgm_di_Vdi_bi/T5-(T4_Vgm_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vdi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vdi_bi/T5/T5/T5));
  T3_Vgm_di_Vsi_bi=(+T3_Vgm_di_Vsi_bi-(T4_Vgm_di_Vsi_bi/T5-(T4_Vgm_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vsi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vsi_bi/T5/T5/T5));
  T3_Vgm_di_Tempt_GND=(+T3_Vgm_di_Tempt_GND-(T4_Vgm_di_Tempt_GND/T5-(T4_Vgm_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vgm_di+T4*T5_Vgm_di_Tempt_GND)/T5/T5+2*T4*T5_Vgm_di*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vdbulk_di=(T3_Vdbulk_di-((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si-(T4_Vdbulk_di_Vgm_si/T5-(T4_Vdbulk_di*T5_Vgm_si+T4_Vgm_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5));
  T3_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di-(T4_Vdbulk_di_Vgm_di/T5-(T4_Vdbulk_di*T5_Vgm_di+T4_Vgm_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5));
  T3_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5));
  T3_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5));
  T3_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsbulk_si=(T3_Vsbulk_si-((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si-(T4_Vsbulk_si_Vgm_si/T5-(T4_Vsbulk_si*T5_Vgm_si+T4_Vgm_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5));
  T3_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di-(T4_Vsbulk_si_Vgm_di/T5-(T4_Vsbulk_si*T5_Vgm_di+T4_Vgm_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5));
  T3_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5));
  T3_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5));
  T3_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vgi_bi=(T3_Vgi_bi-((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vdi_bi=(T3_Vdi_bi-((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
T3_Vsi_bi=(T3_Vsi_bi-((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5));
#if defined(_DERIVATE2)
  T3_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5));
  T3_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5));
  T3_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5));
  T3_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5));
  T3_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5));
  T3_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5));
  T3_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5));
  T3_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5));
#endif
#if defined(_DERIVATE)
T3_Tempt_GND=(T3_Tempt_GND-((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5));
#endif
#endif
T3=(T3-(T4/T5));
EXIT_IF_ISNAN((T3-(T4/T5)))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T4_Vgm_si=(((2.0*T3_Vgm_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))))))-T1_Vgm_si);
#if defined(_DERIVATE2)
  T4_Vgm_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgm_si)+(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgm_si*2.0+T3_Vgm_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_si))))-T1_Vgm_si_Vgm_si);
  T4_Vgm_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgm_di)+(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgm_di*2.0+T3_Vgm_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgm_di))))-T1_Vgm_si_Vgm_di);
  T4_Vgm_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vdbulk_di)+(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vdbulk_di*2.0+T3_Vgm_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdbulk_di))))-T1_Vgm_si_Vdbulk_di);
  T4_Vgm_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vsbulk_si)+(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vsbulk_si*2.0+T3_Vgm_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsbulk_si))))-T1_Vgm_si_Vsbulk_si);
  T4_Vgm_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vgi_bi)+(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vgi_bi*2.0+T3_Vgm_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vgi_bi))))-T1_Vgm_si_Vgi_bi);
  T4_Vgm_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vdi_bi)+(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vdi_bi*2.0+T3_Vgm_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vdi_bi))))-T1_Vgm_si_Vdi_bi);
  T4_Vgm_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Vsi_bi)+(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Vsi_bi*2.0+T3_Vgm_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Vsi_bi))))-T1_Vgm_si_Vsi_bi);
  T4_Vgm_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgm_si+2.0*T3_Vgm_si_Tempt_GND)+(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgm_si*2.0*T0)+((T3*2.0)*T0_Vgm_si))+(2.0*sqrtpsisa_Vgm_si))+((T3*2.0)*T0)*(+(+(+T3_Vgm_si_Tempt_GND*2.0+T3_Vgm_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_si+(T3*2.0)*T0_Vgm_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_si+2.0*sqrtpsisa_Vgm_si_Tempt_GND))))-T1_Vgm_si_Tempt_GND);
#endif
T4_Vgm_di=(((2.0*T3_Vgm_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))))))-T1_Vgm_di);
#if defined(_DERIVATE2)
  T4_Vgm_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgm_si)+(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgm_si*2.0+T3_Vgm_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_si))))-T1_Vgm_di_Vgm_si);
  T4_Vgm_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgm_di)+(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgm_di*2.0+T3_Vgm_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgm_di))))-T1_Vgm_di_Vgm_di);
  T4_Vgm_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vdbulk_di)+(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vdbulk_di*2.0+T3_Vgm_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdbulk_di))))-T1_Vgm_di_Vdbulk_di);
  T4_Vgm_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vsbulk_si)+(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vsbulk_si*2.0+T3_Vgm_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsbulk_si))))-T1_Vgm_di_Vsbulk_si);
  T4_Vgm_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vgi_bi)+(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vgi_bi*2.0+T3_Vgm_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vgi_bi))))-T1_Vgm_di_Vgi_bi);
  T4_Vgm_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vdi_bi)+(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vdi_bi*2.0+T3_Vgm_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vdi_bi))))-T1_Vgm_di_Vdi_bi);
  T4_Vgm_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Vsi_bi)+(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Vsi_bi*2.0+T3_Vgm_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Vsi_bi))))-T1_Vgm_di_Vsi_bi);
  T4_Vgm_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgm_di+2.0*T3_Vgm_di_Tempt_GND)+(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgm_di*2.0*T0)+((T3*2.0)*T0_Vgm_di))+(2.0*sqrtpsisa_Vgm_di))+((T3*2.0)*T0)*(+(+(+T3_Vgm_di_Tempt_GND*2.0+T3_Vgm_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgm_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgm_di+(T3*2.0)*T0_Vgm_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgm_di+2.0*sqrtpsisa_Vgm_di_Tempt_GND))))-T1_Vgm_di_Tempt_GND);
#endif
T4_Vdbulk_di=(((2.0*T3_Vdbulk_di)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))))))-T1_Vdbulk_di);
#if defined(_DERIVATE2)
  T4_Vdbulk_di_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_si)+(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_si*2.0+T3_Vdbulk_di*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_si))))-T1_Vdbulk_di_Vgm_si);
  T4_Vdbulk_di_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgm_di)+(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgm_di*2.0+T3_Vdbulk_di*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgm_di))))-T1_Vdbulk_di_Vgm_di);
  T4_Vdbulk_di_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdbulk_di)+(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdbulk_di*2.0+T3_Vdbulk_di*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdbulk_di))))-T1_Vdbulk_di_Vdbulk_di);
  T4_Vdbulk_di_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsbulk_si)+(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsbulk_si*2.0+T3_Vdbulk_di*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsbulk_si))))-T1_Vdbulk_di_Vsbulk_si);
  T4_Vdbulk_di_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vgi_bi)+(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vgi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vgi_bi))))-T1_Vdbulk_di_Vgi_bi);
  T4_Vdbulk_di_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vdi_bi)+(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vdi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vdi_bi))))-T1_Vdbulk_di_Vdi_bi);
  T4_Vdbulk_di_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Vsi_bi)+(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Vsi_bi*2.0+T3_Vdbulk_di*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Vsi_bi))))-T1_Vdbulk_di_Vsi_bi);
  T4_Vdbulk_di_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+2.0*T3_Vdbulk_di_Tempt_GND)+(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdbulk_di*2.0*T0)+((T3*2.0)*T0_Vdbulk_di))+(2.0*sqrtpsisa_Vdbulk_di))+((T3*2.0)*T0)*(+(+(+T3_Vdbulk_di_Tempt_GND*2.0+T3_Vdbulk_di*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdbulk_di*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdbulk_di+(T3*2.0)*T0_Vdbulk_di_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdbulk_di+2.0*sqrtpsisa_Vdbulk_di_Tempt_GND))))-T1_Vdbulk_di_Tempt_GND);
#endif
T4_Vsbulk_si=(((2.0*T3_Vsbulk_si)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))))))-T1_Vsbulk_si);
#if defined(_DERIVATE2)
  T4_Vsbulk_si_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_si)+(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_si*2.0+T3_Vsbulk_si*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_si))))-T1_Vsbulk_si_Vgm_si);
  T4_Vsbulk_si_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgm_di)+(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgm_di*2.0+T3_Vsbulk_si*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgm_di))))-T1_Vsbulk_si_Vgm_di);
  T4_Vsbulk_si_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdbulk_di)+(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdbulk_di*2.0+T3_Vsbulk_si*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdbulk_di))))-T1_Vsbulk_si_Vdbulk_di);
  T4_Vsbulk_si_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsbulk_si)+(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsbulk_si*2.0+T3_Vsbulk_si*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsbulk_si))))-T1_Vsbulk_si_Vsbulk_si);
  T4_Vsbulk_si_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vgi_bi)+(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vgi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vgi_bi))))-T1_Vsbulk_si_Vgi_bi);
  T4_Vsbulk_si_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vdi_bi)+(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vdi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vdi_bi))))-T1_Vsbulk_si_Vdi_bi);
  T4_Vsbulk_si_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Vsi_bi)+(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Vsi_bi*2.0+T3_Vsbulk_si*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Vsi_bi))))-T1_Vsbulk_si_Vsi_bi);
  T4_Vsbulk_si_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+2.0*T3_Vsbulk_si_Tempt_GND)+(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsbulk_si*2.0*T0)+((T3*2.0)*T0_Vsbulk_si))+(2.0*sqrtpsisa_Vsbulk_si))+((T3*2.0)*T0)*(+(+(+T3_Vsbulk_si_Tempt_GND*2.0+T3_Vsbulk_si*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsbulk_si*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsbulk_si+(T3*2.0)*T0_Vsbulk_si_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsbulk_si+2.0*sqrtpsisa_Vsbulk_si_Tempt_GND))))-T1_Vsbulk_si_Tempt_GND);
#endif
T4_Vgi_bi=(((2.0*T3_Vgi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))))))-T1_Vgi_bi);
#if defined(_DERIVATE2)
  T4_Vgi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_si)+(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_si*2.0+T3_Vgi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_si))))-T1_Vgi_bi_Vgm_si);
  T4_Vgi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgm_di)+(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgm_di*2.0+T3_Vgi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgm_di))))-T1_Vgi_bi_Vgm_di);
  T4_Vgi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdbulk_di)+(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdbulk_di*2.0+T3_Vgi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdbulk_di))))-T1_Vgi_bi_Vdbulk_di);
  T4_Vgi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsbulk_si)+(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsbulk_si*2.0+T3_Vgi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsbulk_si))))-T1_Vgi_bi_Vsbulk_si);
  T4_Vgi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vgi_bi)+(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vgi_bi*2.0+T3_Vgi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vgi_bi))))-T1_Vgi_bi_Vgi_bi);
  T4_Vgi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vdi_bi)+(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vdi_bi*2.0+T3_Vgi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vdi_bi))))-T1_Vgi_bi_Vdi_bi);
  T4_Vgi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Vsi_bi)+(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Vsi_bi*2.0+T3_Vgi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Vsi_bi))))-T1_Vgi_bi_Vsi_bi);
  T4_Vgi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+2.0*T3_Vgi_bi_Tempt_GND)+(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vgi_bi*2.0*T0)+((T3*2.0)*T0_Vgi_bi))+(2.0*sqrtpsisa_Vgi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vgi_bi_Tempt_GND*2.0+T3_Vgi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vgi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vgi_bi+(T3*2.0)*T0_Vgi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vgi_bi+2.0*sqrtpsisa_Vgi_bi_Tempt_GND))))-T1_Vgi_bi_Tempt_GND);
#endif
T4_Vdi_bi=(((2.0*T3_Vdi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))))))-T1_Vdi_bi);
#if defined(_DERIVATE2)
  T4_Vdi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_si)+(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_si*2.0+T3_Vdi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_si))))-T1_Vdi_bi_Vgm_si);
  T4_Vdi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgm_di)+(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgm_di*2.0+T3_Vdi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgm_di))))-T1_Vdi_bi_Vgm_di);
  T4_Vdi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdbulk_di)+(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdbulk_di*2.0+T3_Vdi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdbulk_di))))-T1_Vdi_bi_Vdbulk_di);
  T4_Vdi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsbulk_si)+(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsbulk_si*2.0+T3_Vdi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsbulk_si))))-T1_Vdi_bi_Vsbulk_si);
  T4_Vdi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vgi_bi)+(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vgi_bi*2.0+T3_Vdi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vgi_bi))))-T1_Vdi_bi_Vgi_bi);
  T4_Vdi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vdi_bi)+(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vdi_bi*2.0+T3_Vdi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vdi_bi))))-T1_Vdi_bi_Vdi_bi);
  T4_Vdi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Vsi_bi)+(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Vsi_bi*2.0+T3_Vdi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Vsi_bi))))-T1_Vdi_bi_Vsi_bi);
  T4_Vdi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+2.0*T3_Vdi_bi_Tempt_GND)+(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vdi_bi*2.0*T0)+((T3*2.0)*T0_Vdi_bi))+(2.0*sqrtpsisa_Vdi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vdi_bi_Tempt_GND*2.0+T3_Vdi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vdi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vdi_bi+(T3*2.0)*T0_Vdi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vdi_bi+2.0*sqrtpsisa_Vdi_bi_Tempt_GND))))-T1_Vdi_bi_Tempt_GND);
#endif
T4_Vsi_bi=(((2.0*T3_Vsi_bi)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))))))-T1_Vsi_bi);
#if defined(_DERIVATE2)
  T4_Vsi_bi_Vgm_si=(+(+(+0.0*T3+0.0*T3_Vgm_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_si)+(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))+((2.0*sqrtpsisa_Vgm_si)))+((((T3_Vgm_si*2.0)*T0)+((T3*2.0)*T0_Vgm_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_si*2.0+T3_Vsi_bi*0.0+T3_Vgm_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_si+(T3_Vgm_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_si))))-T1_Vsi_bi_Vgm_si);
  T4_Vsi_bi_Vgm_di=(+(+(+0.0*T3+0.0*T3_Vgm_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgm_di)+(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))+((2.0*sqrtpsisa_Vgm_di)))+((((T3_Vgm_di*2.0)*T0)+((T3*2.0)*T0_Vgm_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgm_di*2.0+T3_Vsi_bi*0.0+T3_Vgm_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgm_di+(T3_Vgm_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgm_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgm_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgm_di))))-T1_Vsi_bi_Vgm_di);
  T4_Vsi_bi_Vdbulk_di=(+(+(+0.0*T3+0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdbulk_di)+(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))+((2.0*sqrtpsisa_Vdbulk_di)))+((((T3_Vdbulk_di*2.0)*T0)+((T3*2.0)*T0_Vdbulk_di)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdbulk_di*2.0+T3_Vsi_bi*0.0+T3_Vdbulk_di*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdbulk_di+(T3_Vdbulk_di*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdbulk_di)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdbulk_di+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdbulk_di))))-T1_Vsi_bi_Vdbulk_di);
  T4_Vsi_bi_Vsbulk_si=(+(+(+0.0*T3+0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsbulk_si)+(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))+((2.0*sqrtpsisa_Vsbulk_si)))+((((T3_Vsbulk_si*2.0)*T0)+((T3*2.0)*T0_Vsbulk_si)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsbulk_si*2.0+T3_Vsi_bi*0.0+T3_Vsbulk_si*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsbulk_si+(T3_Vsbulk_si*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsbulk_si)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsbulk_si+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsbulk_si))))-T1_Vsi_bi_Vsbulk_si);
  T4_Vsi_bi_Vgi_bi=(+(+(+0.0*T3+0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vgi_bi)+(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))+((2.0*sqrtpsisa_Vgi_bi)))+((((T3_Vgi_bi*2.0)*T0)+((T3*2.0)*T0_Vgi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vgi_bi*2.0+T3_Vsi_bi*0.0+T3_Vgi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vgi_bi+(T3_Vgi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vgi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vgi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vgi_bi))))-T1_Vsi_bi_Vgi_bi);
  T4_Vsi_bi_Vdi_bi=(+(+(+0.0*T3+0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vdi_bi)+(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))+((2.0*sqrtpsisa_Vdi_bi)))+((((T3_Vdi_bi*2.0)*T0)+((T3*2.0)*T0_Vdi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vdi_bi*2.0+T3_Vsi_bi*0.0+T3_Vdi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vdi_bi+(T3_Vdi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vdi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vdi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vdi_bi))))-T1_Vsi_bi_Vdi_bi);
  T4_Vsi_bi_Vsi_bi=(+(+(+0.0*T3+0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Vsi_bi)+(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))+((2.0*sqrtpsisa_Vsi_bi)))+((((T3_Vsi_bi*2.0)*T0)+((T3*2.0)*T0_Vsi_bi)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Vsi_bi*2.0+T3_Vsi_bi*0.0+T3_Vsi_bi*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Vsi_bi+(T3_Vsi_bi*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Vsi_bi)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Vsi_bi+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Vsi_bi))))-T1_Vsi_bi_Vsi_bi);
  T4_Vsi_bi_Tempt_GND=(+(+(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+2.0*T3_Vsi_bi_Tempt_GND)+(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))+((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))*(((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))+((2.0*sqrtpsisa_Tempt_GND)))+((((T3_Tempt_GND*2.0)*T0)+((T3*2.0)*T0_Tempt_GND)))*(((T3_Vsi_bi*2.0*T0)+((T3*2.0)*T0_Vsi_bi))+(2.0*sqrtpsisa_Vsi_bi))+((T3*2.0)*T0)*(+(+(+T3_Vsi_bi_Tempt_GND*2.0+T3_Vsi_bi*0.0+T3_Tempt_GND*0.0+T3*0.0)*T0+T3_Vsi_bi*2.0*T0_Tempt_GND+(T3_Tempt_GND*2.0)*T0_Vsi_bi+(T3*2.0)*T0_Vsi_bi_Tempt_GND)+(+0.0*sqrtpsisa+0.0*sqrtpsisa_Tempt_GND+0.0*sqrtpsisa_Vsi_bi+2.0*sqrtpsisa_Vsi_bi_Tempt_GND))))-T1_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T4_Tempt_GND=(((2.0*T3_Tempt_GND)+bsimbulk_d_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))),((((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))+(((T3*2.0)*T0)*(((T3_Tempt_GND*2.0*T0)+((T3*2.0)*T0_Tempt_GND))+(2.0*sqrtpsisa_Tempt_GND))))))-T1_Tempt_GND);
#endif
#endif
T4=(((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
EXIT_IF_ISNAN((((2.0*T3)+bsimbulk_lln((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T5_Vgm_si=((-T3_Vgm_si/T3/T3)+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgm_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgm_si)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vgm_si_Vgm_si+sqrtpsisainv_Vgm_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgm_di)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vgm_si_Vgm_di+sqrtpsisainv_Vgm_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vgm_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgm_si_Vdbulk_di+sqrtpsisainv_Vgm_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vgm_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgm_si_Vsbulk_si+sqrtpsisainv_Vgm_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vgi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgm_si_Vgi_bi+sqrtpsisainv_Vgm_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vdi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgm_si_Vdi_bi+sqrtpsisainv_Vgm_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Vsi_bi)/T3/T3+2*1.0*T3_Vgm_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgm_si_Vsi_bi+sqrtpsisainv_Vgm_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgm_si+1.0*T3_Vgm_si_Tempt_GND)/T3/T3+2*1.0*T3_Vgm_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgm_si_Tempt_GND+sqrtpsisainv_Vgm_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgm_di=((-T3_Vgm_di/T3/T3)+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgm_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgm_si)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vgm_di_Vgm_si+sqrtpsisainv_Vgm_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgm_di)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vgm_di_Vgm_di+sqrtpsisainv_Vgm_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vgm_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgm_di_Vdbulk_di+sqrtpsisainv_Vgm_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vgm_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgm_di_Vsbulk_si+sqrtpsisainv_Vgm_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vgi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgm_di_Vgi_bi+sqrtpsisainv_Vgm_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vdi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgm_di_Vdi_bi+sqrtpsisainv_Vgm_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Vsi_bi)/T3/T3+2*1.0*T3_Vgm_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgm_di_Vsi_bi+sqrtpsisainv_Vgm_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgm_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgm_di+1.0*T3_Vgm_di_Tempt_GND)/T3/T3+2*1.0*T3_Vgm_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgm_di_Tempt_GND+sqrtpsisainv_Vgm_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdbulk_di=((-T3_Vdbulk_di/T3/T3)+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdbulk_di_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_si/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgm_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgm_di/T3/T3/T3))+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdbulk_di)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsbulk_si)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vgi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vdi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Vsi_bi)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdbulk_di_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdbulk_di+1.0*T3_Vdbulk_di_Tempt_GND)/T3/T3+2*1.0*T3_Vdbulk_di*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsbulk_si=((-T3_Vsbulk_si/T3/T3)+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsbulk_si_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_si/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgm_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgm_di/T3/T3/T3))+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdbulk_di)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsbulk_si)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vgi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vdi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Vsi_bi)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsbulk_si_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsbulk_si+1.0*T3_Vsbulk_si_Tempt_GND)/T3/T3+2*1.0*T3_Vsbulk_si*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vgi_bi=((-T3_Vgi_bi/T3/T3)+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vgi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vgi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vgi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vgi_bi+1.0*T3_Vgi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vgi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vdi_bi=((-T3_Vdi_bi/T3/T3)+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vdi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vdi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vdi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vdi_bi+1.0*T3_Vdi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vdi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T5_Vsi_bi=((-T3_Vsi_bi/T3/T3)+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#if defined(_DERIVATE2)
  T5_Vsi_bi_Vgm_si=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_si/T3/T3/T3))+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgm_di=(+(+0.0+(0.0/T3-(0.0*T3_Vgm_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgm_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgm_di/T3/T3/T3))+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdbulk_di=(+(+0.0+(0.0/T3-(0.0*T3_Vdbulk_di+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdbulk_di)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdbulk_di/T3/T3/T3))+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsbulk_si=(+(+0.0+(0.0/T3-(0.0*T3_Vsbulk_si+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsbulk_si)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsbulk_si/T3/T3/T3))+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vgi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vgi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vgi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vgi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vdi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vdi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vdi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vdi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Vsi_bi=(+(+0.0+(0.0/T3-(0.0*T3_Vsi_bi+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Vsi_bi)/T3/T3+2*1.0*T3_Vsi_bi*T3_Vsi_bi/T3/T3/T3))+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T5_Vsi_bi_Tempt_GND=(+(+0.0+(0.0/T3-(0.0*T3_Tempt_GND+0.0*T3_Vsi_bi+1.0*T3_Vsi_bi_Tempt_GND)/T3/T3+2*1.0*T3_Vsi_bi*T3_Tempt_GND/T3/T3/T3))+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T5_Tempt_GND=((-T3_Tempt_GND/T3/T3)+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#endif
T5=((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN(((2.0+(1.0/T3))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T6_Vgm_di=(((((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgm_di_Vgm_di=(+((+T0_Vgm_di_Vgm_di+sqrtpsisainv_Vgm_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vgm_di+sqrtpsisainv_Vgm_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vgm_si=(+((+T0_Vgm_di_Vgm_si+sqrtpsisainv_Vgm_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vgm_si+sqrtpsisainv_Vgm_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vdbulk_di=(+((+T0_Vgm_di_Vdbulk_di+sqrtpsisainv_Vgm_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vdbulk_di+sqrtpsisainv_Vgm_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vsbulk_si=(+((+T0_Vgm_di_Vsbulk_si+sqrtpsisainv_Vgm_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vsbulk_si+sqrtpsisainv_Vgm_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vgi_bi=(+((+T0_Vgm_di_Vgi_bi+sqrtpsisainv_Vgm_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vgi_bi+sqrtpsisainv_Vgm_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vdi_bi=(+((+T0_Vgm_di_Vdi_bi+sqrtpsisainv_Vgm_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vdi_bi+sqrtpsisainv_Vgm_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Vsi_bi=(+((+T0_Vgm_di_Vsi_bi+sqrtpsisainv_Vgm_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Vsi_bi+sqrtpsisainv_Vgm_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_di_Tempt_GND=(+((+T0_Vgm_di_Tempt_GND+sqrtpsisainv_Vgm_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_di_Tempt_GND+sqrtpsisainv_Vgm_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+(T0+sqrtpsisainv)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vgm_si=(((((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgm_si_Vgm_di=(+((+T0_Vgm_si_Vgm_di+sqrtpsisainv_Vgm_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vgm_di+sqrtpsisainv_Vgm_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vgm_si=(+((+T0_Vgm_si_Vgm_si+sqrtpsisainv_Vgm_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vgm_si+sqrtpsisainv_Vgm_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vdbulk_di=(+((+T0_Vgm_si_Vdbulk_di+sqrtpsisainv_Vgm_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vdbulk_di+sqrtpsisainv_Vgm_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vsbulk_si=(+((+T0_Vgm_si_Vsbulk_si+sqrtpsisainv_Vgm_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vsbulk_si+sqrtpsisainv_Vgm_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vgi_bi=(+((+T0_Vgm_si_Vgi_bi+sqrtpsisainv_Vgm_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vgi_bi+sqrtpsisainv_Vgm_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vdi_bi=(+((+T0_Vgm_si_Vdi_bi+sqrtpsisainv_Vgm_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vdi_bi+sqrtpsisainv_Vgm_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Vsi_bi=(+((+T0_Vgm_si_Vsi_bi+sqrtpsisainv_Vgm_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Vsi_bi+sqrtpsisainv_Vgm_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgm_si_Tempt_GND=(+((+T0_Vgm_si_Tempt_GND+sqrtpsisainv_Vgm_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgm_si_Tempt_GND+sqrtpsisainv_Vgm_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+(T0+sqrtpsisainv)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vdbulk_di=(((((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdbulk_di_Vgm_di=(+((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_di+sqrtpsisainv_Vdbulk_di_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgm_si=(+((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgm_si+sqrtpsisainv_Vdbulk_di_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdbulk_di=(+((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdbulk_di+sqrtpsisainv_Vdbulk_di_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsbulk_si=(+((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsbulk_si+sqrtpsisainv_Vdbulk_di_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vgi_bi=(+((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vgi_bi+sqrtpsisainv_Vdbulk_di_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vdi_bi=(+((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vdi_bi+sqrtpsisainv_Vdbulk_di_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Vsi_bi=(+((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Vsi_bi+sqrtpsisainv_Vdbulk_di_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdbulk_di_Tempt_GND=(+((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdbulk_di_Tempt_GND+sqrtpsisainv_Vdbulk_di_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+(T0+sqrtpsisainv)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsbulk_si=(((((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsbulk_si_Vgm_di=(+((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_di+sqrtpsisainv_Vsbulk_si_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgm_si=(+((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgm_si+sqrtpsisainv_Vsbulk_si_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdbulk_di=(+((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdbulk_di+sqrtpsisainv_Vsbulk_si_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsbulk_si=(+((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsbulk_si+sqrtpsisainv_Vsbulk_si_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vgi_bi=(+((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vgi_bi+sqrtpsisainv_Vsbulk_si_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vdi_bi=(+((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vdi_bi+sqrtpsisainv_Vsbulk_si_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Vsi_bi=(+((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Vsi_bi+sqrtpsisainv_Vsbulk_si_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsbulk_si_Tempt_GND=(+((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsbulk_si_Tempt_GND+sqrtpsisainv_Vsbulk_si_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+(T0+sqrtpsisainv)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vgi_bi=(((((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vgi_bi_Vgm_di=(+((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_di+sqrtpsisainv_Vgi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgm_si=(+((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgm_si+sqrtpsisainv_Vgi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdbulk_di=(+((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdbulk_di+sqrtpsisainv_Vgi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsbulk_si=(+((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsbulk_si+sqrtpsisainv_Vgi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vgi_bi=(+((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vgi_bi+sqrtpsisainv_Vgi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vdi_bi=(+((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vdi_bi+sqrtpsisainv_Vgi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Vsi_bi=(+((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Vsi_bi+sqrtpsisainv_Vgi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vgi_bi_Tempt_GND=(+((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vgi_bi_Tempt_GND+sqrtpsisainv_Vgi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vdi_bi=(((((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vdi_bi_Vgm_di=(+((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_di+sqrtpsisainv_Vdi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgm_si=(+((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgm_si+sqrtpsisainv_Vdi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdbulk_di=(+((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdbulk_di+sqrtpsisainv_Vdi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsbulk_si=(+((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsbulk_si+sqrtpsisainv_Vdi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vgi_bi=(+((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vgi_bi+sqrtpsisainv_Vdi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vdi_bi=(+((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vdi_bi+sqrtpsisainv_Vdi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Vsi_bi=(+((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Vsi_bi+sqrtpsisainv_Vdi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vdi_bi_Tempt_GND=(+((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vdi_bi_Tempt_GND+sqrtpsisainv_Vdi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
T6_Vsi_bi=(((((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#if defined(_DERIVATE2)
  T6_Vsi_bi_Vgm_di=(+((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_di+sqrtpsisainv_Vgm_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_di+sqrtpsisainv_Vsi_bi_Vgm_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+(T0_Vgm_di+sqrtpsisainv_Vgm_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgm_si=(+((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgm_si+sqrtpsisainv_Vgm_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgm_si+sqrtpsisainv_Vsi_bi_Vgm_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+(T0_Vgm_si+sqrtpsisainv_Vgm_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdbulk_di=(+((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdbulk_di+sqrtpsisainv_Vsi_bi_Vdbulk_di)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+(T0_Vdbulk_di+sqrtpsisainv_Vdbulk_di)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsbulk_si=(+((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsbulk_si+sqrtpsisainv_Vsi_bi_Vsbulk_si)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+(T0_Vsbulk_si+sqrtpsisainv_Vsbulk_si)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vgi_bi=(+((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vgi_bi+sqrtpsisainv_Vsi_bi_Vgi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+(T0_Vgi_bi+sqrtpsisainv_Vgi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vdi_bi=(+((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vdi_bi+sqrtpsisainv_Vsi_bi_Vdi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+(T0_Vdi_bi+sqrtpsisainv_Vdi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Vsi_bi=(+((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Vsi_bi+sqrtpsisainv_Vsi_bi_Vsi_bi)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+(T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
  T6_Vsi_bi_Tempt_GND=(+((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))+(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*(((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((+T0_Vsi_bi_Tempt_GND+sqrtpsisainv_Vsi_bi_Tempt_GND)/((T0*T3)+sqrtpsisa)-((T0_Vsi_bi+sqrtpsisainv_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+(T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+(T0+sqrtpsisainv)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)+2*(T0+sqrtpsisainv)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
#endif
#if defined(_DERIVATE)
T6_Tempt_GND=(((((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)))+(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*(((T0_Tempt_GND+sqrtpsisainv_Tempt_GND)*((T0*T3)+sqrtpsisa)-(T0+sqrtpsisainv)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))));
#endif
#endif
T6=(((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
EXIT_IF_ISNAN((((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0+sqrtpsisainv)/((T0*T3)+sqrtpsisa))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T7_Vgm_si=(((-(((-T3_Vgm_si/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgm_si/T3/T3))))-(-((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si);
#if defined(_DERIVATE2)
  T7_Vgm_si_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vgm_si*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vgm_si*T3+T0_Vgm_si*T3_Vgm_si+T0_Vgm_si*T3_Vgm_si+T0*T3_Vgm_si_Vgm_si)+sqrtpsisa_Vgm_si_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vgm_si);
  T7_Vgm_si_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vgm_di*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vgm_di*T3+T0_Vgm_si*T3_Vgm_di+T0_Vgm_di*T3_Vgm_si+T0*T3_Vgm_si_Vgm_di)+sqrtpsisa_Vgm_si_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vgm_di);
  T7_Vgm_si_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vdbulk_di*T3+T0_Vgm_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_si+T0*T3_Vgm_si_Vdbulk_di)+sqrtpsisa_Vgm_si_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vdbulk_di);
  T7_Vgm_si_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vsbulk_si*T3+T0_Vgm_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_si+T0*T3_Vgm_si_Vsbulk_si)+sqrtpsisa_Vgm_si_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vsbulk_si);
  T7_Vgm_si_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vgi_bi*T3+T0_Vgm_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vgi_bi)+sqrtpsisa_Vgm_si_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vgi_bi);
  T7_Vgm_si_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vdi_bi*T3+T0_Vgm_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vdi_bi)+sqrtpsisa_Vgm_si_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vdi_bi);
  T7_Vgm_si_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Vsi_bi*T3+T0_Vgm_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_si+T0*T3_Vgm_si_Vsi_bi)+sqrtpsisa_Vgm_si_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Vsi_bi);
  T7_Vgm_si_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))+1.0*(+(+(+sqrtpsisa_Vgm_si_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgm_si*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgm_si+sqrtpsisa*sqrtpsisa_Vgm_si_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgm_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_si_Tempt_GND*T3+T0_Vgm_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_si+T0*T3_Vgm_si_Tempt_GND)+sqrtpsisa_Vgm_si_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_si*T3)+(T0*T3_Vgm_si))+sqrtpsisa_Vgm_si)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_si_Tempt_GND);
#endif
T7_Vgm_di=(((-(((-T3_Vgm_di/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgm_di/T3/T3))))-(-((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di);
#if defined(_DERIVATE2)
  T7_Vgm_di_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vgm_si*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vgm_si*T3+T0_Vgm_di*T3_Vgm_si+T0_Vgm_si*T3_Vgm_di+T0*T3_Vgm_di_Vgm_si)+sqrtpsisa_Vgm_di_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vgm_si);
  T7_Vgm_di_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vgm_di*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vgm_di*T3+T0_Vgm_di*T3_Vgm_di+T0_Vgm_di*T3_Vgm_di+T0*T3_Vgm_di_Vgm_di)+sqrtpsisa_Vgm_di_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vgm_di);
  T7_Vgm_di_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vdbulk_di*T3+T0_Vgm_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgm_di+T0*T3_Vgm_di_Vdbulk_di)+sqrtpsisa_Vgm_di_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vdbulk_di);
  T7_Vgm_di_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vsbulk_si*T3+T0_Vgm_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgm_di+T0*T3_Vgm_di_Vsbulk_si)+sqrtpsisa_Vgm_di_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vsbulk_si);
  T7_Vgm_di_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vgi_bi*T3+T0_Vgm_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vgi_bi)+sqrtpsisa_Vgm_di_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vgi_bi);
  T7_Vgm_di_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vdi_bi*T3+T0_Vgm_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vdi_bi)+sqrtpsisa_Vgm_di_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vdi_bi);
  T7_Vgm_di_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Vsi_bi*T3+T0_Vgm_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vgm_di+T0*T3_Vgm_di_Vsi_bi)+sqrtpsisa_Vgm_di_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Vsi_bi);
  T7_Vgm_di_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))+1.0*(+(+(+sqrtpsisa_Vgm_di_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgm_di*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgm_di+sqrtpsisa*sqrtpsisa_Vgm_di_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgm_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgm_di_Tempt_GND*T3+T0_Vgm_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vgm_di+T0*T3_Vgm_di_Tempt_GND)+sqrtpsisa_Vgm_di_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgm_di*T3)+(T0*T3_Vgm_di))+sqrtpsisa_Vgm_di)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgm_di_Tempt_GND);
#endif
T7_Vdbulk_di=(((-(((-T3_Vdbulk_di/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdbulk_di/T3/T3))))-(-((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di);
#if defined(_DERIVATE2)
  T7_Vdbulk_di_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_si*T3+T0_Vdbulk_di*T3_Vgm_si+T0_Vgm_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_si)+sqrtpsisa_Vdbulk_di_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_si);
  T7_Vdbulk_di_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgm_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgm_di*T3+T0_Vdbulk_di*T3_Vgm_di+T0_Vgm_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgm_di)+sqrtpsisa_Vdbulk_di_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgm_di);
  T7_Vdbulk_di_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdbulk_di*T3+T0_Vdbulk_di*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdbulk_di)+sqrtpsisa_Vdbulk_di_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdbulk_di);
  T7_Vdbulk_di_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsbulk_si*T3+T0_Vdbulk_di*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsbulk_si)+sqrtpsisa_Vdbulk_di_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsbulk_si);
  T7_Vdbulk_di_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vgi_bi*T3+T0_Vdbulk_di*T3_Vgi_bi+T0_Vgi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vgi_bi)+sqrtpsisa_Vdbulk_di_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vgi_bi);
  T7_Vdbulk_di_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vdi_bi*T3+T0_Vdbulk_di*T3_Vdi_bi+T0_Vdi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vdi_bi)+sqrtpsisa_Vdbulk_di_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vdi_bi);
  T7_Vdbulk_di_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Vsi_bi*T3+T0_Vdbulk_di*T3_Vsi_bi+T0_Vsi_bi*T3_Vdbulk_di+T0*T3_Vdbulk_di_Vsi_bi)+sqrtpsisa_Vdbulk_di_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Vsi_bi);
  T7_Vdbulk_di_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))+1.0*(+(+(+sqrtpsisa_Vdbulk_di_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdbulk_di*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdbulk_di+sqrtpsisa*sqrtpsisa_Vdbulk_di_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdbulk_di+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdbulk_di_Tempt_GND*T3+T0_Vdbulk_di*T3_Tempt_GND+T0_Tempt_GND*T3_Vdbulk_di+T0*T3_Vdbulk_di_Tempt_GND)+sqrtpsisa_Vdbulk_di_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di))+sqrtpsisa_Vdbulk_di)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdbulk_di_Tempt_GND);
#endif
T7_Vsbulk_si=(((-(((-T3_Vsbulk_si/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsbulk_si/T3/T3))))-(-((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si);
#if defined(_DERIVATE2)
  T7_Vsbulk_si_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_si*T3+T0_Vsbulk_si*T3_Vgm_si+T0_Vgm_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_si)+sqrtpsisa_Vsbulk_si_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_si);
  T7_Vsbulk_si_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgm_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgm_di*T3+T0_Vsbulk_si*T3_Vgm_di+T0_Vgm_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgm_di)+sqrtpsisa_Vsbulk_si_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgm_di);
  T7_Vsbulk_si_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdbulk_di*T3+T0_Vsbulk_si*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdbulk_di)+sqrtpsisa_Vsbulk_si_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdbulk_di);
  T7_Vsbulk_si_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsbulk_si*T3+T0_Vsbulk_si*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsbulk_si)+sqrtpsisa_Vsbulk_si_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsbulk_si);
  T7_Vsbulk_si_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vgi_bi*T3+T0_Vsbulk_si*T3_Vgi_bi+T0_Vgi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vgi_bi)+sqrtpsisa_Vsbulk_si_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vgi_bi);
  T7_Vsbulk_si_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vdi_bi*T3+T0_Vsbulk_si*T3_Vdi_bi+T0_Vdi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vdi_bi)+sqrtpsisa_Vsbulk_si_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vdi_bi);
  T7_Vsbulk_si_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Vsi_bi*T3+T0_Vsbulk_si*T3_Vsi_bi+T0_Vsi_bi*T3_Vsbulk_si+T0*T3_Vsbulk_si_Vsi_bi)+sqrtpsisa_Vsbulk_si_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Vsi_bi);
  T7_Vsbulk_si_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))+1.0*(+(+(+sqrtpsisa_Vsbulk_si_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsbulk_si*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsbulk_si+sqrtpsisa*sqrtpsisa_Vsbulk_si_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsbulk_si+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsbulk_si_Tempt_GND*T3+T0_Vsbulk_si*T3_Tempt_GND+T0_Tempt_GND*T3_Vsbulk_si+T0*T3_Vsbulk_si_Tempt_GND)+sqrtpsisa_Vsbulk_si_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si))+sqrtpsisa_Vsbulk_si)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsbulk_si_Tempt_GND);
#endif
T7_Vgi_bi=(((-(((-T3_Vgi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vgi_bi/T3/T3))))-(-((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi);
#if defined(_DERIVATE2)
  T7_Vgi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_si*T3+T0_Vgi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_si)+sqrtpsisa_Vgi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_si);
  T7_Vgi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgm_di*T3+T0_Vgi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vgm_di)+sqrtpsisa_Vgi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgm_di);
  T7_Vgi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdbulk_di*T3+T0_Vgi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vgi_bi+T0*T3_Vgi_bi_Vdbulk_di)+sqrtpsisa_Vgi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdbulk_di);
  T7_Vgi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsbulk_si*T3+T0_Vgi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vgi_bi+T0*T3_Vgi_bi_Vsbulk_si)+sqrtpsisa_Vgi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsbulk_si);
  T7_Vgi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vgi_bi*T3+T0_Vgi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vgi_bi)+sqrtpsisa_Vgi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vgi_bi);
  T7_Vgi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vdi_bi*T3+T0_Vgi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vdi_bi)+sqrtpsisa_Vgi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vdi_bi);
  T7_Vgi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Vsi_bi*T3+T0_Vgi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vgi_bi+T0*T3_Vgi_bi_Vsi_bi)+sqrtpsisa_Vgi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Vsi_bi);
  T7_Vgi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))+1.0*(+(+(+sqrtpsisa_Vgi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vgi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vgi_bi+sqrtpsisa*sqrtpsisa_Vgi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vgi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vgi_bi_Tempt_GND*T3+T0_Vgi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vgi_bi+T0*T3_Vgi_bi_Tempt_GND)+sqrtpsisa_Vgi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi))+sqrtpsisa_Vgi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vgi_bi_Tempt_GND);
#endif
T7_Vdi_bi=(((-(((-T3_Vdi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vdi_bi/T3/T3))))-(-((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi);
#if defined(_DERIVATE2)
  T7_Vdi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_si*T3+T0_Vdi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_si)+sqrtpsisa_Vdi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_si);
  T7_Vdi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgm_di*T3+T0_Vdi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vgm_di)+sqrtpsisa_Vdi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgm_di);
  T7_Vdi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdbulk_di*T3+T0_Vdi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vdi_bi+T0*T3_Vdi_bi_Vdbulk_di)+sqrtpsisa_Vdi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdbulk_di);
  T7_Vdi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsbulk_si*T3+T0_Vdi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vdi_bi+T0*T3_Vdi_bi_Vsbulk_si)+sqrtpsisa_Vdi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsbulk_si);
  T7_Vdi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vgi_bi*T3+T0_Vdi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vgi_bi)+sqrtpsisa_Vdi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vgi_bi);
  T7_Vdi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vdi_bi*T3+T0_Vdi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vdi_bi)+sqrtpsisa_Vdi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vdi_bi);
  T7_Vdi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Vsi_bi*T3+T0_Vdi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vdi_bi+T0*T3_Vdi_bi_Vsi_bi)+sqrtpsisa_Vdi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Vsi_bi);
  T7_Vdi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))+1.0*(+(+(+sqrtpsisa_Vdi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vdi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vdi_bi+sqrtpsisa*sqrtpsisa_Vdi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vdi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vdi_bi_Tempt_GND*T3+T0_Vdi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vdi_bi+T0*T3_Vdi_bi_Tempt_GND)+sqrtpsisa_Vdi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi))+sqrtpsisa_Vdi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vdi_bi_Tempt_GND);
#endif
T7_Vsi_bi=(((-(((-T3_Vsi_bi/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Vsi_bi/T3/T3))))-(-((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi);
#if defined(_DERIVATE2)
  T7_Vsi_bi_Vgm_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_si+sqrtpsisa_Vgm_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_si+(((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si)+((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_si*T3+T0_Vsi_bi*T3_Vgm_si+T0_Vgm_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_si)+sqrtpsisa_Vsi_bi_Vgm_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_si*T3)+(T0*T3_Vgm_si)))+sqrtpsisa_Vgm_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_si);
  T7_Vsi_bi_Vgm_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgm_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgm_di+sqrtpsisa_Vgm_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgm_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgm_di+(((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgm_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di)+((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgm_di*T3+T0_Vsi_bi*T3_Vgm_di+T0_Vgm_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vgm_di)+sqrtpsisa_Vsi_bi_Vgm_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgm_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgm_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgm_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgm_di*T3)+(T0*T3_Vgm_di)))+sqrtpsisa_Vgm_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgm_di);
  T7_Vsi_bi_Vdbulk_di=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdbulk_di*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdbulk_di+sqrtpsisa_Vdbulk_di*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdbulk_di)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdbulk_di+(((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdbulk_di)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di)+((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdbulk_di*T3+T0_Vsi_bi*T3_Vdbulk_di+T0_Vdbulk_di*T3_Vsi_bi+T0*T3_Vsi_bi_Vdbulk_di)+sqrtpsisa_Vsi_bi_Vdbulk_di)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdbulk_di*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdbulk_di)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdbulk_di)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdbulk_di*T3)+(T0*T3_Vdbulk_di)))+sqrtpsisa_Vdbulk_di))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdbulk_di);
  T7_Vsi_bi_Vsbulk_si=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsbulk_si*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsbulk_si+sqrtpsisa_Vsbulk_si*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsbulk_si)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsbulk_si+(((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsbulk_si)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si)+((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsbulk_si*T3+T0_Vsi_bi*T3_Vsbulk_si+T0_Vsbulk_si*T3_Vsi_bi+T0*T3_Vsi_bi_Vsbulk_si)+sqrtpsisa_Vsi_bi_Vsbulk_si)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsbulk_si*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsbulk_si)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsbulk_si)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsbulk_si*T3)+(T0*T3_Vsbulk_si)))+sqrtpsisa_Vsbulk_si))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsbulk_si);
  T7_Vsi_bi_Vgi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vgi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vgi_bi+sqrtpsisa_Vgi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vgi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vgi_bi+(((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vgi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi)+((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vgi_bi*T3+T0_Vsi_bi*T3_Vgi_bi+T0_Vgi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vgi_bi)+sqrtpsisa_Vsi_bi_Vgi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vgi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vgi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vgi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vgi_bi*T3)+(T0*T3_Vgi_bi)))+sqrtpsisa_Vgi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vgi_bi);
  T7_Vsi_bi_Vdi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vdi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vdi_bi+sqrtpsisa_Vdi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vdi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vdi_bi+(((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vdi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi)+((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vdi_bi*T3+T0_Vsi_bi*T3_Vdi_bi+T0_Vdi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vdi_bi)+sqrtpsisa_Vsi_bi_Vdi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vdi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vdi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vdi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vdi_bi*T3)+(T0*T3_Vdi_bi)))+sqrtpsisa_Vdi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vdi_bi);
  T7_Vsi_bi_Vsi_bi=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Vsi_bi*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa_Vsi_bi*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Vsi_bi)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Vsi_bi+(((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Vsi_bi)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi)+((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Vsi_bi*T3+T0_Vsi_bi*T3_Vsi_bi+T0_Vsi_bi*T3_Vsi_bi+T0*T3_Vsi_bi_Vsi_bi)+sqrtpsisa_Vsi_bi_Vsi_bi)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi)))+sqrtpsisa_Vsi_bi))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Vsi_bi);
  T7_Vsi_bi_Tempt_GND=(+(+0.0-(0.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))-(0.0*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))+0.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))+1.0*(+(+(+sqrtpsisa_Vsi_bi_Tempt_GND*sqrtpsisa+sqrtpsisa_Vsi_bi*sqrtpsisa_Tempt_GND+sqrtpsisa_Tempt_GND*sqrtpsisa_Vsi_bi+sqrtpsisa*sqrtpsisa_Vsi_bi_Tempt_GND)*sqrtpsisa+((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa_Tempt_GND+(((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa_Vsi_bi+(sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi_Tempt_GND)*((T0*T3)+sqrtpsisa)+((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND)+((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(+(+T0_Vsi_bi_Tempt_GND*T3+T0_Vsi_bi*T3_Tempt_GND+T0_Tempt_GND*T3_Vsi_bi+T0*T3_Vsi_bi_Tempt_GND)+sqrtpsisa_Vsi_bi_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))+2*1.0*((((((sqrtpsisa_Vsi_bi*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Vsi_bi))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Vsi_bi))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Vsi_bi*T3)+(T0*T3_Vsi_bi))+sqrtpsisa_Vsi_bi)))*(((((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND)))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND)))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND)))+sqrtpsisa_Tempt_GND))))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T7_Tempt_GND=(((-(((-T3_Tempt_GND/T3/T3)*(1.0/T3))+((1.0/T3)*(-T3_Tempt_GND/T3/T3))))-(-((((((sqrtpsisa_Tempt_GND*sqrtpsisa)+(sqrtpsisa*sqrtpsisa_Tempt_GND))*sqrtpsisa)+((sqrtpsisa*sqrtpsisa)*sqrtpsisa_Tempt_GND))*((T0*T3)+sqrtpsisa))+(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*(((T0_Tempt_GND*T3)+(T0*T3_Tempt_GND))+sqrtpsisa_Tempt_GND)))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6_Tempt_GND);
#endif
#endif
T7=(((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
EXIT_IF_ISNAN((((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
qdeff_Vgm_si=(T3_Vgm_si-((((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vgm_si_Vgm_si=(+T3_Vgm_si_Vgm_si-(+(T4_Vgm_si_Vgm_si/T5-(T4_Vgm_si*T5_Vgm_si+T4_Vgm_si*T5_Vgm_si+T4*T5_Vgm_si_Vgm_si)/T5/T5+2*T4*T5_Vgm_si*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vgm_si*T7+T4_Vgm_si*T7_Vgm_si+T4_Vgm_si*T7_Vgm_si+T4*T7_Vgm_si_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vgm_si)*T5+(2.0*T5_Vgm_si)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_si_Vgm_di=(+T3_Vgm_si_Vgm_di-(+(T4_Vgm_si_Vgm_di/T5-(T4_Vgm_si*T5_Vgm_di+T4_Vgm_di*T5_Vgm_si+T4*T5_Vgm_si_Vgm_di)/T5/T5+2*T4*T5_Vgm_si*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vgm_di*T7+T4_Vgm_si*T7_Vgm_di+T4_Vgm_di*T7_Vgm_si+T4*T7_Vgm_si_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vgm_di)*T5+(2.0*T5_Vgm_si)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_si_Vdbulk_di=(+T3_Vgm_si_Vdbulk_di-(+(T4_Vgm_si_Vdbulk_di/T5-(T4_Vgm_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgm_si+T4*T5_Vgm_si_Vdbulk_di)/T5/T5+2*T4*T5_Vgm_si*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vdbulk_di*T7+T4_Vgm_si*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgm_si+T4*T7_Vgm_si_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vdbulk_di)*T5+(2.0*T5_Vgm_si)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_si_Vsbulk_si=(+T3_Vgm_si_Vsbulk_si-(+(T4_Vgm_si_Vsbulk_si/T5-(T4_Vgm_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgm_si+T4*T5_Vgm_si_Vsbulk_si)/T5/T5+2*T4*T5_Vgm_si*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vsbulk_si*T7+T4_Vgm_si*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgm_si+T4*T7_Vgm_si_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vsbulk_si)*T5+(2.0*T5_Vgm_si)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_si_Vgi_bi=(+T3_Vgm_si_Vgi_bi-(+(T4_Vgm_si_Vgi_bi/T5-(T4_Vgm_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vgi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vgi_bi*T7+T4_Vgm_si*T7_Vgi_bi+T4_Vgi_bi*T7_Vgm_si+T4*T7_Vgm_si_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vgi_bi)*T5+(2.0*T5_Vgm_si)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_si_Vdi_bi=(+T3_Vgm_si_Vdi_bi-(+(T4_Vgm_si_Vdi_bi/T5-(T4_Vgm_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vdi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vdi_bi*T7+T4_Vgm_si*T7_Vdi_bi+T4_Vdi_bi*T7_Vgm_si+T4*T7_Vgm_si_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vdi_bi)*T5+(2.0*T5_Vgm_si)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_si_Vsi_bi=(+T3_Vgm_si_Vsi_bi-(+(T4_Vgm_si_Vsi_bi/T5-(T4_Vgm_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vgm_si+T4*T5_Vgm_si_Vsi_bi)/T5/T5+2*T4*T5_Vgm_si*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Vsi_bi*T7+T4_Vgm_si*T7_Vsi_bi+T4_Vsi_bi*T7_Vgm_si+T4*T7_Vgm_si_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Vsi_bi)*T5+(2.0*T5_Vgm_si)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_si_Tempt_GND=(+T3_Vgm_si_Tempt_GND-(+(T4_Vgm_si_Tempt_GND/T5-(T4_Vgm_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vgm_si+T4*T5_Vgm_si_Tempt_GND)/T5/T5+2*T4*T5_Vgm_si*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_si_Tempt_GND*T7+T4_Vgm_si*T7_Tempt_GND+T4_Tempt_GND*T7_Vgm_si+T4*T7_Vgm_si_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgm_si*T7)+(T4*T7_Vgm_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgm_si+2.0*T5_Vgm_si_Tempt_GND)*T5+(2.0*T5_Vgm_si)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgm_si+(2.0*T5)*T5_Vgm_si_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_si)*T5)+((2.0*T5)*T5_Vgm_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vgm_di=(T3_Vgm_di-((((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vgm_di_Vgm_si=(+T3_Vgm_di_Vgm_si-(+(T4_Vgm_di_Vgm_si/T5-(T4_Vgm_di*T5_Vgm_si+T4_Vgm_si*T5_Vgm_di+T4*T5_Vgm_di_Vgm_si)/T5/T5+2*T4*T5_Vgm_di*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vgm_si*T7+T4_Vgm_di*T7_Vgm_si+T4_Vgm_si*T7_Vgm_di+T4*T7_Vgm_di_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vgm_si)*T5+(2.0*T5_Vgm_di)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_di_Vgm_di=(+T3_Vgm_di_Vgm_di-(+(T4_Vgm_di_Vgm_di/T5-(T4_Vgm_di*T5_Vgm_di+T4_Vgm_di*T5_Vgm_di+T4*T5_Vgm_di_Vgm_di)/T5/T5+2*T4*T5_Vgm_di*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vgm_di*T7+T4_Vgm_di*T7_Vgm_di+T4_Vgm_di*T7_Vgm_di+T4*T7_Vgm_di_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vgm_di)*T5+(2.0*T5_Vgm_di)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_di_Vdbulk_di=(+T3_Vgm_di_Vdbulk_di-(+(T4_Vgm_di_Vdbulk_di/T5-(T4_Vgm_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgm_di+T4*T5_Vgm_di_Vdbulk_di)/T5/T5+2*T4*T5_Vgm_di*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vdbulk_di*T7+T4_Vgm_di*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgm_di+T4*T7_Vgm_di_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vdbulk_di)*T5+(2.0*T5_Vgm_di)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_di_Vsbulk_si=(+T3_Vgm_di_Vsbulk_si-(+(T4_Vgm_di_Vsbulk_si/T5-(T4_Vgm_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgm_di+T4*T5_Vgm_di_Vsbulk_si)/T5/T5+2*T4*T5_Vgm_di*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vsbulk_si*T7+T4_Vgm_di*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgm_di+T4*T7_Vgm_di_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vsbulk_si)*T5+(2.0*T5_Vgm_di)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_di_Vgi_bi=(+T3_Vgm_di_Vgi_bi-(+(T4_Vgm_di_Vgi_bi/T5-(T4_Vgm_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vgi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vgi_bi*T7+T4_Vgm_di*T7_Vgi_bi+T4_Vgi_bi*T7_Vgm_di+T4*T7_Vgm_di_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vgi_bi)*T5+(2.0*T5_Vgm_di)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_di_Vdi_bi=(+T3_Vgm_di_Vdi_bi-(+(T4_Vgm_di_Vdi_bi/T5-(T4_Vgm_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vdi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vdi_bi*T7+T4_Vgm_di*T7_Vdi_bi+T4_Vdi_bi*T7_Vgm_di+T4*T7_Vgm_di_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vdi_bi)*T5+(2.0*T5_Vgm_di)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_di_Vsi_bi=(+T3_Vgm_di_Vsi_bi-(+(T4_Vgm_di_Vsi_bi/T5-(T4_Vgm_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vgm_di+T4*T5_Vgm_di_Vsi_bi)/T5/T5+2*T4*T5_Vgm_di*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Vsi_bi*T7+T4_Vgm_di*T7_Vsi_bi+T4_Vsi_bi*T7_Vgm_di+T4*T7_Vgm_di_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Vsi_bi)*T5+(2.0*T5_Vgm_di)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgm_di_Tempt_GND=(+T3_Vgm_di_Tempt_GND-(+(T4_Vgm_di_Tempt_GND/T5-(T4_Vgm_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vgm_di+T4*T5_Vgm_di_Tempt_GND)/T5/T5+2*T4*T5_Vgm_di*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgm_di_Tempt_GND*T7+T4_Vgm_di*T7_Tempt_GND+T4_Tempt_GND*T7_Vgm_di+T4*T7_Vgm_di_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgm_di*T7)+(T4*T7_Vgm_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgm_di+2.0*T5_Vgm_di_Tempt_GND)*T5+(2.0*T5_Vgm_di)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgm_di+(2.0*T5)*T5_Vgm_di_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgm_di)*T5)+((2.0*T5)*T5_Vgm_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vdbulk_di=(T3_Vdbulk_di-((((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vdbulk_di_Vgm_si=(+T3_Vdbulk_di_Vgm_si-(+(T4_Vdbulk_di_Vgm_si/T5-(T4_Vdbulk_di*T5_Vgm_si+T4_Vgm_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgm_si*T7+T4_Vdbulk_di*T7_Vgm_si+T4_Vgm_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgm_si)*T5+(2.0*T5_Vdbulk_di)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vgm_di=(+T3_Vdbulk_di_Vgm_di-(+(T4_Vdbulk_di_Vgm_di/T5-(T4_Vdbulk_di*T5_Vgm_di+T4_Vgm_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgm_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgm_di*T7+T4_Vdbulk_di*T7_Vgm_di+T4_Vgm_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgm_di)*T5+(2.0*T5_Vdbulk_di)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vdbulk_di=(+T3_Vdbulk_di_Vdbulk_di-(+(T4_Vdbulk_di_Vdbulk_di/T5-(T4_Vdbulk_di*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdbulk_di)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdbulk_di*T7+T4_Vdbulk_di*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdbulk_di)*T5+(2.0*T5_Vdbulk_di)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vsbulk_si=(+T3_Vdbulk_di_Vsbulk_si-(+(T4_Vdbulk_di_Vsbulk_si/T5-(T4_Vdbulk_di*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsbulk_si)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsbulk_si*T7+T4_Vdbulk_di*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsbulk_si)*T5+(2.0*T5_Vdbulk_di)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vgi_bi=(+T3_Vdbulk_di_Vgi_bi-(+(T4_Vdbulk_di_Vgi_bi/T5-(T4_Vdbulk_di*T5_Vgi_bi+T4_Vgi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vgi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vgi_bi*T7+T4_Vdbulk_di*T7_Vgi_bi+T4_Vgi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vgi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vdi_bi=(+T3_Vdbulk_di_Vdi_bi-(+(T4_Vdbulk_di_Vdi_bi/T5-(T4_Vdbulk_di*T5_Vdi_bi+T4_Vdi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vdi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vdi_bi*T7+T4_Vdbulk_di*T7_Vdi_bi+T4_Vdi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vdi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Vsi_bi=(+T3_Vdbulk_di_Vsi_bi-(+(T4_Vdbulk_di_Vsi_bi/T5-(T4_Vdbulk_di*T5_Vsi_bi+T4_Vsi_bi*T5_Vdbulk_di+T4*T5_Vdbulk_di_Vsi_bi)/T5/T5+2*T4*T5_Vdbulk_di*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Vsi_bi*T7+T4_Vdbulk_di*T7_Vsi_bi+T4_Vsi_bi*T7_Vdbulk_di+T4*T7_Vdbulk_di_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Vsi_bi)*T5+(2.0*T5_Vdbulk_di)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdbulk_di_Tempt_GND=(+T3_Vdbulk_di_Tempt_GND-(+(T4_Vdbulk_di_Tempt_GND/T5-(T4_Vdbulk_di*T5_Tempt_GND+T4_Tempt_GND*T5_Vdbulk_di+T4*T5_Vdbulk_di_Tempt_GND)/T5/T5+2*T4*T5_Vdbulk_di*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdbulk_di_Tempt_GND*T7+T4_Vdbulk_di*T7_Tempt_GND+T4_Tempt_GND*T7_Vdbulk_di+T4*T7_Vdbulk_di_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdbulk_di+2.0*T5_Vdbulk_di_Tempt_GND)*T5+(2.0*T5_Vdbulk_di)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdbulk_di+(2.0*T5)*T5_Vdbulk_di_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdbulk_di)*T5)+((2.0*T5)*T5_Vdbulk_di))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vsbulk_si=(T3_Vsbulk_si-((((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vsbulk_si_Vgm_si=(+T3_Vsbulk_si_Vgm_si-(+(T4_Vsbulk_si_Vgm_si/T5-(T4_Vsbulk_si*T5_Vgm_si+T4_Vgm_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgm_si*T7+T4_Vsbulk_si*T7_Vgm_si+T4_Vgm_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgm_si)*T5+(2.0*T5_Vsbulk_si)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vgm_di=(+T3_Vsbulk_si_Vgm_di-(+(T4_Vsbulk_si_Vgm_di/T5-(T4_Vsbulk_si*T5_Vgm_di+T4_Vgm_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgm_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgm_di*T7+T4_Vsbulk_si*T7_Vgm_di+T4_Vgm_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgm_di)*T5+(2.0*T5_Vsbulk_si)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vdbulk_di=(+T3_Vsbulk_si_Vdbulk_di-(+(T4_Vsbulk_si_Vdbulk_di/T5-(T4_Vsbulk_si*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdbulk_di)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdbulk_di*T7+T4_Vsbulk_si*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdbulk_di)*T5+(2.0*T5_Vsbulk_si)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vsbulk_si=(+T3_Vsbulk_si_Vsbulk_si-(+(T4_Vsbulk_si_Vsbulk_si/T5-(T4_Vsbulk_si*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsbulk_si)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsbulk_si*T7+T4_Vsbulk_si*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsbulk_si)*T5+(2.0*T5_Vsbulk_si)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vgi_bi=(+T3_Vsbulk_si_Vgi_bi-(+(T4_Vsbulk_si_Vgi_bi/T5-(T4_Vsbulk_si*T5_Vgi_bi+T4_Vgi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vgi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vgi_bi*T7+T4_Vsbulk_si*T7_Vgi_bi+T4_Vgi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vgi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vdi_bi=(+T3_Vsbulk_si_Vdi_bi-(+(T4_Vsbulk_si_Vdi_bi/T5-(T4_Vsbulk_si*T5_Vdi_bi+T4_Vdi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vdi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vdi_bi*T7+T4_Vsbulk_si*T7_Vdi_bi+T4_Vdi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vdi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Vsi_bi=(+T3_Vsbulk_si_Vsi_bi-(+(T4_Vsbulk_si_Vsi_bi/T5-(T4_Vsbulk_si*T5_Vsi_bi+T4_Vsi_bi*T5_Vsbulk_si+T4*T5_Vsbulk_si_Vsi_bi)/T5/T5+2*T4*T5_Vsbulk_si*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Vsi_bi*T7+T4_Vsbulk_si*T7_Vsi_bi+T4_Vsi_bi*T7_Vsbulk_si+T4*T7_Vsbulk_si_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Vsi_bi)*T5+(2.0*T5_Vsbulk_si)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsbulk_si_Tempt_GND=(+T3_Vsbulk_si_Tempt_GND-(+(T4_Vsbulk_si_Tempt_GND/T5-(T4_Vsbulk_si*T5_Tempt_GND+T4_Tempt_GND*T5_Vsbulk_si+T4*T5_Vsbulk_si_Tempt_GND)/T5/T5+2*T4*T5_Vsbulk_si*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsbulk_si_Tempt_GND*T7+T4_Vsbulk_si*T7_Tempt_GND+T4_Tempt_GND*T7_Vsbulk_si+T4*T7_Vsbulk_si_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsbulk_si+2.0*T5_Vsbulk_si_Tempt_GND)*T5+(2.0*T5_Vsbulk_si)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsbulk_si+(2.0*T5)*T5_Vsbulk_si_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsbulk_si)*T5)+((2.0*T5)*T5_Vsbulk_si))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vgi_bi=(T3_Vgi_bi-((((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vgi_bi_Vgm_si=(+T3_Vgi_bi_Vgm_si-(+(T4_Vgi_bi_Vgm_si/T5-(T4_Vgi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_si*T7+T4_Vgi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_si)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vgm_di=(+T3_Vgi_bi_Vgm_di-(+(T4_Vgi_bi_Vgm_di/T5-(T4_Vgi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vgm_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgm_di*T7+T4_Vgi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgm_di)*T5+(2.0*T5_Vgi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vdbulk_di=(+T3_Vgi_bi_Vdbulk_di-(+(T4_Vgi_bi_Vdbulk_di/T5-(T4_Vgi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vgi_bi+T4*T5_Vgi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdbulk_di*T7+T4_Vgi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vgi_bi+T4*T7_Vgi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdbulk_di)*T5+(2.0*T5_Vgi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vsbulk_si=(+T3_Vgi_bi_Vsbulk_si-(+(T4_Vgi_bi_Vsbulk_si/T5-(T4_Vgi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vgi_bi+T4*T5_Vgi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsbulk_si*T7+T4_Vgi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vgi_bi+T4*T7_Vgi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsbulk_si)*T5+(2.0*T5_Vgi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vgi_bi=(+T3_Vgi_bi_Vgi_bi-(+(T4_Vgi_bi_Vgi_bi/T5-(T4_Vgi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vgi_bi*T7+T4_Vgi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vgi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vdi_bi=(+T3_Vgi_bi_Vdi_bi-(+(T4_Vgi_bi_Vdi_bi/T5-(T4_Vgi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vdi_bi*T7+T4_Vgi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vdi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Vsi_bi=(+T3_Vgi_bi_Vsi_bi-(+(T4_Vgi_bi_Vsi_bi/T5-(T4_Vgi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vgi_bi+T4*T5_Vgi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vgi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Vsi_bi*T7+T4_Vgi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vgi_bi+T4*T7_Vgi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Vsi_bi)*T5+(2.0*T5_Vgi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vgi_bi_Tempt_GND=(+T3_Vgi_bi_Tempt_GND-(+(T4_Vgi_bi_Tempt_GND/T5-(T4_Vgi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vgi_bi+T4*T5_Vgi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vgi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vgi_bi_Tempt_GND*T7+T4_Vgi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vgi_bi+T4*T7_Vgi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vgi_bi+2.0*T5_Vgi_bi_Tempt_GND)*T5+(2.0*T5_Vgi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vgi_bi+(2.0*T5)*T5_Vgi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vgi_bi)*T5)+((2.0*T5)*T5_Vgi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vdi_bi=(T3_Vdi_bi-((((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vdi_bi_Vgm_si=(+T3_Vdi_bi_Vgm_si-(+(T4_Vdi_bi_Vgm_si/T5-(T4_Vdi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_si*T7+T4_Vdi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_si)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vgm_di=(+T3_Vdi_bi_Vgm_di-(+(T4_Vdi_bi_Vgm_di/T5-(T4_Vdi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vgm_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgm_di*T7+T4_Vdi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgm_di)*T5+(2.0*T5_Vdi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vdbulk_di=(+T3_Vdi_bi_Vdbulk_di-(+(T4_Vdi_bi_Vdbulk_di/T5-(T4_Vdi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vdi_bi+T4*T5_Vdi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdbulk_di*T7+T4_Vdi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vdi_bi+T4*T7_Vdi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdbulk_di)*T5+(2.0*T5_Vdi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vsbulk_si=(+T3_Vdi_bi_Vsbulk_si-(+(T4_Vdi_bi_Vsbulk_si/T5-(T4_Vdi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vdi_bi+T4*T5_Vdi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsbulk_si*T7+T4_Vdi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vdi_bi+T4*T7_Vdi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsbulk_si)*T5+(2.0*T5_Vdi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vgi_bi=(+T3_Vdi_bi_Vgi_bi-(+(T4_Vdi_bi_Vgi_bi/T5-(T4_Vdi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vgi_bi*T7+T4_Vdi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vgi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vdi_bi=(+T3_Vdi_bi_Vdi_bi-(+(T4_Vdi_bi_Vdi_bi/T5-(T4_Vdi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vdi_bi*T7+T4_Vdi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vdi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Vsi_bi=(+T3_Vdi_bi_Vsi_bi-(+(T4_Vdi_bi_Vsi_bi/T5-(T4_Vdi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vdi_bi+T4*T5_Vdi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vdi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Vsi_bi*T7+T4_Vdi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vdi_bi+T4*T7_Vdi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Vsi_bi)*T5+(2.0*T5_Vdi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vdi_bi_Tempt_GND=(+T3_Vdi_bi_Tempt_GND-(+(T4_Vdi_bi_Tempt_GND/T5-(T4_Vdi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vdi_bi+T4*T5_Vdi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vdi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vdi_bi_Tempt_GND*T7+T4_Vdi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vdi_bi+T4*T7_Vdi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vdi_bi+2.0*T5_Vdi_bi_Tempt_GND)*T5+(2.0*T5_Vdi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vdi_bi+(2.0*T5)*T5_Vdi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vdi_bi)*T5)+((2.0*T5)*T5_Vdi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
qdeff_Vsi_bi=(T3_Vsi_bi-((((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#if defined(_DERIVATE2)
  qdeff_Vsi_bi_Vgm_si=(+T3_Vsi_bi_Vgm_si-(+(T4_Vsi_bi_Vgm_si/T5-(T4_Vsi_bi*T5_Vgm_si+T4_Vgm_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_si*T5-T4*T5_Vgm_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_si*T7+T4_Vsi_bi*T7_Vgm_si+T4_Vgm_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))+(((T4_Vgm_si*T7)+(T4*T7_Vgm_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_si)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_si+((2.0*T5_Vgm_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_si))*T5)+((2.0*T5)*T5_Vgm_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vgm_di=(+T3_Vsi_bi_Vgm_di-(+(T4_Vsi_bi_Vgm_di/T5-(T4_Vsi_bi*T5_Vgm_di+T4_Vgm_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vgm_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgm_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgm_di*T5-T4*T5_Vgm_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgm_di*T7+T4_Vsi_bi*T7_Vgm_di+T4_Vgm_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vgm_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))+(((T4_Vgm_di*T7)+(T4*T7_Vgm_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgm_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgm_di)*T5+(2.0*T5_Vsi_bi)*T5_Vgm_di+((2.0*T5_Vgm_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgm_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgm_di))*T5)+((2.0*T5)*T5_Vgm_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vdbulk_di=(+T3_Vsi_bi_Vdbulk_di-(+(T4_Vsi_bi_Vdbulk_di/T5-(T4_Vsi_bi*T5_Vdbulk_di+T4_Vdbulk_di*T5_Vsi_bi+T4*T5_Vsi_bi_Vdbulk_di)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdbulk_di/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdbulk_di*T5-T4*T5_Vdbulk_di)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdbulk_di*T7+T4_Vsi_bi*T7_Vdbulk_di+T4_Vdbulk_di*T7_Vsi_bi+T4*T7_Vsi_bi_Vdbulk_di)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))+(((T4_Vdbulk_di*T7)+(T4*T7_Vdbulk_di)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdbulk_di+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdbulk_di)*T5+(2.0*T5_Vsi_bi)*T5_Vdbulk_di+((2.0*T5_Vdbulk_di))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdbulk_di))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdbulk_di))*T5)+((2.0*T5)*T5_Vdbulk_di)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vsbulk_si=(+T3_Vsi_bi_Vsbulk_si-(+(T4_Vsi_bi_Vsbulk_si/T5-(T4_Vsi_bi*T5_Vsbulk_si+T4_Vsbulk_si*T5_Vsi_bi+T4*T5_Vsi_bi_Vsbulk_si)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsbulk_si/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsbulk_si*T5-T4*T5_Vsbulk_si)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsbulk_si*T7+T4_Vsi_bi*T7_Vsbulk_si+T4_Vsbulk_si*T7_Vsi_bi+T4*T7_Vsi_bi_Vsbulk_si)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))+(((T4_Vsbulk_si*T7)+(T4*T7_Vsbulk_si)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsbulk_si+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsbulk_si)*T5+(2.0*T5_Vsi_bi)*T5_Vsbulk_si+((2.0*T5_Vsbulk_si))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsbulk_si))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsbulk_si))*T5)+((2.0*T5)*T5_Vsbulk_si)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vgi_bi=(+T3_Vsi_bi_Vgi_bi-(+(T4_Vsi_bi_Vgi_bi/T5-(T4_Vsi_bi*T5_Vgi_bi+T4_Vgi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vgi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vgi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vgi_bi*T5-T4*T5_Vgi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vgi_bi*T7+T4_Vsi_bi*T7_Vgi_bi+T4_Vgi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vgi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))+(((T4_Vgi_bi*T7)+(T4*T7_Vgi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vgi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vgi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vgi_bi+((2.0*T5_Vgi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vgi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vgi_bi))*T5)+((2.0*T5)*T5_Vgi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vdi_bi=(+T3_Vsi_bi_Vdi_bi-(+(T4_Vsi_bi_Vdi_bi/T5-(T4_Vsi_bi*T5_Vdi_bi+T4_Vdi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vdi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vdi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vdi_bi*T5-T4*T5_Vdi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vdi_bi*T7+T4_Vsi_bi*T7_Vdi_bi+T4_Vdi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vdi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))+(((T4_Vdi_bi*T7)+(T4*T7_Vdi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vdi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vdi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vdi_bi+((2.0*T5_Vdi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vdi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vdi_bi))*T5)+((2.0*T5)*T5_Vdi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Vsi_bi=(+T3_Vsi_bi_Vsi_bi-(+(T4_Vsi_bi_Vsi_bi/T5-(T4_Vsi_bi*T5_Vsi_bi+T4_Vsi_bi*T5_Vsi_bi+T4*T5_Vsi_bi_Vsi_bi)/T5/T5+2*T4*T5_Vsi_bi*T5_Vsi_bi/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Vsi_bi*T7+T4_Vsi_bi*T7_Vsi_bi+T4_Vsi_bi*T7_Vsi_bi+T4*T7_Vsi_bi_Vsi_bi)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))+(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Vsi_bi+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Vsi_bi)*T5+(2.0*T5_Vsi_bi)*T5_Vsi_bi+((2.0*T5_Vsi_bi))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Vsi_bi))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Vsi_bi))*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
  qdeff_Vsi_bi_Tempt_GND=(+T3_Vsi_bi_Tempt_GND-(+(T4_Vsi_bi_Tempt_GND/T5-(T4_Vsi_bi*T5_Tempt_GND+T4_Tempt_GND*T5_Vsi_bi+T4*T5_Vsi_bi_Tempt_GND)/T5/T5+2*T4*T5_Vsi_bi*T5_Tempt_GND/T5/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))+((T4_Vsi_bi*T5-T4*T5_Vsi_bi)/T5/T5)*(((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*((2.0*T5)*T5)-(T4*T7)*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND))))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*((((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi)))/((2.0*T5)*T5)/((2.0*T5)*T5))+(T4/T5)*(+0.0+((+T4_Vsi_bi_Tempt_GND*T7+T4_Vsi_bi*T7_Tempt_GND+T4_Tempt_GND*T7_Vsi_bi+T4*T7_Vsi_bi_Tempt_GND)/((2.0*T5)*T5)-(((T4_Vsi_bi*T7)+(T4*T7_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))+(((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND)))*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))+(T4*T7)*(+(+0.0*T5+0.0*T5_Tempt_GND+0.0*T5_Vsi_bi+2.0*T5_Vsi_bi_Tempt_GND)*T5+(2.0*T5_Vsi_bi)*T5_Tempt_GND+((2.0*T5_Tempt_GND))*T5_Vsi_bi+(2.0*T5)*T5_Vsi_bi_Tempt_GND))/((2.0*T5)*T5)/((2.0*T5)*T5)+2*(T4*T7)*(((2.0*T5_Vsi_bi)*T5)+((2.0*T5)*T5_Vsi_bi))*(((((2.0*T5_Tempt_GND))*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#if defined(_DERIVATE)
qdeff_Tempt_GND=(T3_Tempt_GND-((((T4_Tempt_GND*T5-T4*T5_Tempt_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))+((T4/T5)*((((T4_Tempt_GND*T7)+(T4*T7_Tempt_GND))*((2.0*T5)*T5)-(T4*T7)*(((2.0*T5_Tempt_GND)*T5)+((2.0*T5)*T5_Tempt_GND)))/((2.0*T5)*T5)/((2.0*T5)*T5)))));
#endif
#endif
qdeff=(T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
EXIT_IF_ISNAN((T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5))))))
}
{
double m00_sqrt(d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(si,GND)V(dbulk,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
psipclamp_Vgm_di=(0.5*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vgm_di_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vgm_di-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vgm_di+psip_Vgm_di*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_di_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vgm_si-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vgm_si+psip_Vgm_si*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_di_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_di_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_di_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vgi_bi-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vgi_bi+psip_Vgi_bi*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_di_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vdi_bi-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vdi_bi+psip_Vdi_bi*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_di_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Vsi_bi-0.0)*(psip-1.0)+psip_Vgm_di*psip_Vsi_bi+psip_Vsi_bi*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_di_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_di+((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))*d10_sqrt0)+0.5*(+(+psip_Vgm_di_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di))+d10_sqrt0*(+(+(+psip_Vgm_di_Tempt_GND-0.0)*(psip-1.0)+psip_Vgm_di*psip_Tempt_GND+psip_Tempt_GND*psip_Vgm_di+(psip-1.0)*(+psip_Vgm_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vgm_si=(0.5*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vgm_si_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vgm_di-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vgm_di+psip_Vgm_di*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_si_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vgm_si-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vgm_si+psip_Vgm_si*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_si_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_si_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_si_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vgi_bi-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vgi_bi+psip_Vgi_bi*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_si_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vdi_bi-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vdi_bi+psip_Vdi_bi*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_si_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Vsi_bi-0.0)*(psip-1.0)+psip_Vgm_si*psip_Vsi_bi+psip_Vsi_bi*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgm_si_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgm_si+((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))*d10_sqrt0)+0.5*(+(+psip_Vgm_si_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si))+d10_sqrt0*(+(+(+psip_Vgm_si_Tempt_GND-0.0)*(psip-1.0)+psip_Vgm_si*psip_Tempt_GND+psip_Tempt_GND*psip_Vgm_si+(psip-1.0)*(+psip_Vgm_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vdbulk_di=(0.5*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vdbulk_di_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_di+psip_Vgm_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgm_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgm_si+psip_Vgm_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vgi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vgi_bi+psip_Vgi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vdi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vdi_bi+psip_Vdi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Vsi_bi-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Vsi_bi+psip_Vsi_bi*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdbulk_di_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdbulk_di+((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psip_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di))+d10_sqrt0*(+(+(+psip_Vdbulk_di_Tempt_GND-0.0)*(psip-1.0)+psip_Vdbulk_di*psip_Tempt_GND+psip_Tempt_GND*psip_Vdbulk_di+(psip-1.0)*(+psip_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vsbulk_si=(0.5*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vsbulk_si_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_di+psip_Vgm_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgm_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgm_si+psip_Vgm_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vgi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vgi_bi+psip_Vgi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vdi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vdi_bi+psip_Vdi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Vsi_bi-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Vsi_bi+psip_Vsi_bi*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsbulk_si_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsbulk_si+((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psip_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si))+d10_sqrt0*(+(+(+psip_Vsbulk_si_Tempt_GND-0.0)*(psip-1.0)+psip_Vsbulk_si*psip_Tempt_GND+psip_Tempt_GND*psip_Vsbulk_si+(psip-1.0)*(+psip_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vgi_bi=(0.5*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vgi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vgi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vgi_bi+((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))*d10_sqrt0)+0.5*(+(+psip_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi))+d10_sqrt0*(+(+(+psip_Vgi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vgi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vgi_bi+(psip-1.0)*(+psip_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vdi_bi=(0.5*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vdi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vdi_bi+((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))*d10_sqrt0)+0.5*(+(+psip_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi))+d10_sqrt0*(+(+(+psip_Vdi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vdi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vdi_bi+(psip-1.0)*(+psip_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vsi_bi=(0.5*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vsi_bi_Vgm_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_di+((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_di*(psip-1.0))+((psip-1.0)*psip_Vgm_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_di+psip_Vgm_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vgm_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgm_si+((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgm_si*(psip-1.0))+((psip-1.0)*psip_Vgm_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgm_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgm_si+psip_Vgm_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vdbulk_di=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdbulk_di+((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdbulk_di*(psip-1.0))+((psip-1.0)*psip_Vdbulk_di)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdbulk_di-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdbulk_di+psip_Vdbulk_di*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vsbulk_si=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsbulk_si+((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsbulk_si*(psip-1.0))+((psip-1.0)*psip_Vsbulk_si)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsbulk_si-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsbulk_si+psip_Vsbulk_si*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vgi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vgi_bi+((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vgi_bi*(psip-1.0))+((psip-1.0)*psip_Vgi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vgi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vgi_bi+psip_Vgi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vdi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vdi_bi+((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vdi_bi*(psip-1.0))+((psip-1.0)*psip_Vdi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vdi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vdi_bi+psip_Vdi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Vsi_bi=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Vsi_bi+((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Vsi_bi-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Vsi_bi+psip_Vsi_bi*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vsi_bi_Tempt_GND=(+0.0*((psip+1.0)+d00_sqrt0)+0.0*(psip_Tempt_GND+((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psip_Vsi_bi+((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))*d10_sqrt0)+0.5*(+(+psip_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))*((((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND)))+((0.0)*2.0))*((psip_Vsi_bi*(psip-1.0))+((psip-1.0)*psip_Vsi_bi))+d10_sqrt0*(+(+(+psip_Vsi_bi_Tempt_GND-0.0)*(psip-1.0)+psip_Vsi_bi*psip_Tempt_GND+psip_Tempt_GND*psip_Vsi_bi+(psip-1.0)*(+psip_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
psipclamp_Tempt_GND=(0.5*(psip_Tempt_GND+((psip_Tempt_GND*(psip-1.0))+((psip-1.0)*psip_Tempt_GND))*d10_sqrt0));
#endif
#endif
psipclamp=(0.5*((psip+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psip+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,psipclamp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,psipclamp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(di,GND)V(bi,GND)V(gi,GND) */
sqrtpsip_Vgm_di=psipclamp_Vgm_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_di_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vgm_di+d10_sqrt0*psipclamp_Vgm_di_Vgm_di);
  sqrtpsip_Vgm_di_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vgm_di+d10_sqrt0*psipclamp_Vgm_di_Vgm_si);
  sqrtpsip_Vgm_di_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vgm_di+d10_sqrt0*psipclamp_Vgm_di_Vdbulk_di);
  sqrtpsip_Vgm_di_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vgm_di+d10_sqrt0*psipclamp_Vgm_di_Vsbulk_si);
  sqrtpsip_Vgm_di_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vgm_di+d10_sqrt0*psipclamp_Vgm_di_Vgi_bi);
  sqrtpsip_Vgm_di_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vgm_di+d10_sqrt0*psipclamp_Vgm_di_Vdi_bi);
  sqrtpsip_Vgm_di_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vgm_di+d10_sqrt0*psipclamp_Vgm_di_Vsi_bi);
  sqrtpsip_Vgm_di_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vgm_di+d10_sqrt0*psipclamp_Vgm_di_Tempt_GND);
#endif
sqrtpsip_Vgm_si=psipclamp_Vgm_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgm_si_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vgm_si+d10_sqrt0*psipclamp_Vgm_si_Vgm_di);
  sqrtpsip_Vgm_si_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vgm_si+d10_sqrt0*psipclamp_Vgm_si_Vgm_si);
  sqrtpsip_Vgm_si_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vgm_si+d10_sqrt0*psipclamp_Vgm_si_Vdbulk_di);
  sqrtpsip_Vgm_si_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vgm_si+d10_sqrt0*psipclamp_Vgm_si_Vsbulk_si);
  sqrtpsip_Vgm_si_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vgm_si+d10_sqrt0*psipclamp_Vgm_si_Vgi_bi);
  sqrtpsip_Vgm_si_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vgm_si+d10_sqrt0*psipclamp_Vgm_si_Vdi_bi);
  sqrtpsip_Vgm_si_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vgm_si+d10_sqrt0*psipclamp_Vgm_si_Vsi_bi);
  sqrtpsip_Vgm_si_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vgm_si+d10_sqrt0*psipclamp_Vgm_si_Tempt_GND);
#endif
sqrtpsip_Vdbulk_di=psipclamp_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdbulk_di_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vgm_di);
  sqrtpsip_Vdbulk_di_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vgm_si);
  sqrtpsip_Vdbulk_di_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vdbulk_di);
  sqrtpsip_Vdbulk_di_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vsbulk_si);
  sqrtpsip_Vdbulk_di_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vgi_bi);
  sqrtpsip_Vdbulk_di_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vdi_bi);
  sqrtpsip_Vdbulk_di_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Vsi_bi);
  sqrtpsip_Vdbulk_di_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vdbulk_di+d10_sqrt0*psipclamp_Vdbulk_di_Tempt_GND);
#endif
sqrtpsip_Vsbulk_si=psipclamp_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsbulk_si_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vgm_di);
  sqrtpsip_Vsbulk_si_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vgm_si);
  sqrtpsip_Vsbulk_si_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vdbulk_di);
  sqrtpsip_Vsbulk_si_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vsbulk_si);
  sqrtpsip_Vsbulk_si_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vgi_bi);
  sqrtpsip_Vsbulk_si_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vdi_bi);
  sqrtpsip_Vsbulk_si_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Vsi_bi);
  sqrtpsip_Vsbulk_si_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vsbulk_si+d10_sqrt0*psipclamp_Vsbulk_si_Tempt_GND);
#endif
sqrtpsip_Vgi_bi=psipclamp_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vgi_bi_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vgm_di);
  sqrtpsip_Vgi_bi_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vgm_si);
  sqrtpsip_Vgi_bi_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vdbulk_di);
  sqrtpsip_Vgi_bi_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vsbulk_si);
  sqrtpsip_Vgi_bi_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vgi_bi);
  sqrtpsip_Vgi_bi_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vdi_bi);
  sqrtpsip_Vgi_bi_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Vsi_bi);
  sqrtpsip_Vgi_bi_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vgi_bi+d10_sqrt0*psipclamp_Vgi_bi_Tempt_GND);
#endif
sqrtpsip_Vdi_bi=psipclamp_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_bi_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vgm_di);
  sqrtpsip_Vdi_bi_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vgm_si);
  sqrtpsip_Vdi_bi_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vdbulk_di);
  sqrtpsip_Vdi_bi_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vsbulk_si);
  sqrtpsip_Vdi_bi_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vgi_bi);
  sqrtpsip_Vdi_bi_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vdi_bi);
  sqrtpsip_Vdi_bi_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Vsi_bi);
  sqrtpsip_Vdi_bi_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vdi_bi+d10_sqrt0*psipclamp_Vdi_bi_Tempt_GND);
#endif
sqrtpsip_Vsi_bi=psipclamp_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vsi_bi_Vgm_di=(m20_sqrt(psipclamp)*psipclamp_Vgm_di*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vgm_di);
  sqrtpsip_Vsi_bi_Vgm_si=(m20_sqrt(psipclamp)*psipclamp_Vgm_si*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vgm_si);
  sqrtpsip_Vsi_bi_Vdbulk_di=(m20_sqrt(psipclamp)*psipclamp_Vdbulk_di*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vdbulk_di);
  sqrtpsip_Vsi_bi_Vsbulk_si=(m20_sqrt(psipclamp)*psipclamp_Vsbulk_si*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vsbulk_si);
  sqrtpsip_Vsi_bi_Vgi_bi=(m20_sqrt(psipclamp)*psipclamp_Vgi_bi*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vgi_bi);
  sqrtpsip_Vsi_bi_Vdi_bi=(m20_sqrt(psipclamp)*psipclamp_Vdi_bi*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vdi_bi);
  sqrtpsip_Vsi_bi_Vsi_bi=(m20_sqrt(psipclamp)*psipclamp_Vsi_bi*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Vsi_bi);
  sqrtpsip_Vsi_bi_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vsi_bi+d10_sqrt0*psipclamp_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
sqrtpsip_Tempt_GND=psipclamp_Tempt_GND*d10_sqrt0;
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(gm,GND)V(dbulk,GND)V(si,GND)V(sbulk,GND)V(di,GND)V(bi,GND)V(gi,GND) */
psiavg_Vgm_di=((psip_Vgm_di-qs_Vgm_di)-qdeff_Vgm_di);
#if defined(_DERIVATE2)
  psiavg_Vgm_di_Vgm_di=(+(+(+psip_Vgm_di_Vgm_di-qs_Vgm_di_Vgm_di)-qdeff_Vgm_di_Vgm_di)-0.0);
  psiavg_Vgm_di_Vgm_si=(+(+(+psip_Vgm_di_Vgm_si-qs_Vgm_di_Vgm_si)-qdeff_Vgm_di_Vgm_si)-0.0);
  psiavg_Vgm_di_Vdbulk_di=(+(+(+psip_Vgm_di_Vdbulk_di-qs_Vgm_di_Vdbulk_di)-qdeff_Vgm_di_Vdbulk_di)-0.0);
  psiavg_Vgm_di_Vsbulk_si=(+(+(+psip_Vgm_di_Vsbulk_si-qs_Vgm_di_Vsbulk_si)-qdeff_Vgm_di_Vsbulk_si)-0.0);
  psiavg_Vgm_di_Vgi_bi=(+(+(+psip_Vgm_di_Vgi_bi-qs_Vgm_di_Vgi_bi)-qdeff_Vgm_di_Vgi_bi)-0.0);
  psiavg_Vgm_di_Vdi_bi=(+(+(+psip_Vgm_di_Vdi_bi-qs_Vgm_di_Vdi_bi)-qdeff_Vgm_di_Vdi_bi)-0.0);
  psiavg_Vgm_di_Vsi_bi=(+(+(+psip_Vgm_di_Vsi_bi-qs_Vgm_di_Vsi_bi)-qdeff_Vgm_di_Vsi_bi)-0.0);
  psiavg_Vgm_di_Tempt_GND=(+(+(+psip_Vgm_di_Tempt_GND-qs_Vgm_di_Tempt_GND)-qdeff_Vgm_di_Tempt_GND)-0.0);
#endif
psiavg_Vgm_si=((psip_Vgm_si-qs_Vgm_si)-qdeff_Vgm_si);
#if defined(_DERIVATE2)
  psiavg_Vgm_si_Vgm_di=(+(+(+psip_Vgm_si_Vgm_di-qs_Vgm_si_Vgm_di)-qdeff_Vgm_si_Vgm_di)-0.0);
  psiavg_Vgm_si_Vgm_si=(+(+(+psip_Vgm_si_Vgm_si-qs_Vgm_si_Vgm_si)-qdeff_Vgm_si_Vgm_si)-0.0);
  psiavg_Vgm_si_Vdbulk_di=(+(+(+psip_Vgm_si_Vdbulk_di-qs_Vgm_si_Vdbulk_di)-qdeff_Vgm_si_Vdbulk_di)-0.0);
  psiavg_Vgm_si_Vsbulk_si=(+(+(+psip_Vgm_si_Vsbulk_si-qs_Vgm_si_Vsbulk_si)-qdeff_Vgm_si_Vsbulk_si)-0.0);
  psiavg_Vgm_si_Vgi_bi=(+(+(+psip_Vgm_si_Vgi_bi-qs_Vgm_si_Vgi_bi)-qdeff_Vgm_si_Vgi_bi)-0.0);
  psiavg_Vgm_si_Vdi_bi=(+(+(+psip_Vgm_si_Vdi_bi-qs_Vgm_si_Vdi_bi)-qdeff_Vgm_si_Vdi_bi)-0.0);
  psiavg_Vgm_si_Vsi_bi=(+(+(+psip_Vgm_si_Vsi_bi-qs_Vgm_si_Vsi_bi)-qdeff_Vgm_si_Vsi_bi)-0.0);
  psiavg_Vgm_si_Tempt_GND=(+(+(+psip_Vgm_si_Tempt_GND-qs_Vgm_si_Tempt_GND)-qdeff_Vgm_si_Tempt_GND)-0.0);
#endif
psiavg_Vdbulk_di=((psip_Vdbulk_di-qs_Vdbulk_di)-qdeff_Vdbulk_di);
#if defined(_DERIVATE2)
  psiavg_Vdbulk_di_Vgm_di=(+(+(+psip_Vdbulk_di_Vgm_di-qs_Vdbulk_di_Vgm_di)-qdeff_Vdbulk_di_Vgm_di)-0.0);
  psiavg_Vdbulk_di_Vgm_si=(+(+(+psip_Vdbulk_di_Vgm_si-qs_Vdbulk_di_Vgm_si)-qdeff_Vdbulk_di_Vgm_si)-0.0);
  psiavg_Vdbulk_di_Vdbulk_di=(+(+(+psip_Vdbulk_di_Vdbulk_di-qs_Vdbulk_di_Vdbulk_di)-qdeff_Vdbulk_di_Vdbulk_di)-0.0);
  psiavg_Vdbulk_di_Vsbulk_si=(+(+(+psip_Vdbulk_di_Vsbulk_si-qs_Vdbulk_di_Vsbulk_si)-qdeff_Vdbulk_di_Vsbulk_si)-0.0);
  psiavg_Vdbulk_di_Vgi_bi=(+(+(+psip_Vdbulk_di_Vgi_bi-qs_Vdbulk_di_Vgi_bi)-qdeff_Vdbulk_di_Vgi_bi)-0.0);
  psiavg_Vdbulk_di_Vdi_bi=(+(+(+psip_Vdbulk_di_Vdi_bi-qs_Vdbulk_di_Vdi_bi)-qdeff_Vdbulk_di_Vdi_bi)-0.0);
  psiavg_Vdbulk_di_Vsi_bi=(+(+(+psip_Vdbulk_di_Vsi_bi-qs_Vdbulk_di_Vsi_bi)-qdeff_Vdbulk_di_Vsi_bi)-0.0);
  psiavg_Vdbulk_di_Tempt_GND=(+(+(+psip_Vdbulk_di_Tempt_GND-qs_Vdbulk_di_Tempt_GND)-qdeff_Vdbulk_di_Tempt_GND)-0.0);
#endif
psiavg_Vsbulk_si=((psip_Vsbulk_si-qs_Vsbulk_si)-qdeff_Vsbulk_si);
#if defined(_DERIVATE2)
  psiavg_Vsbulk_si_Vgm_di=(+(+(+psip_Vsbulk_si_Vgm_di-qs_Vsbulk_si_Vgm_di)-qdeff_Vsbulk_si_Vgm_di)-0.0);
  psiavg_Vsbulk_si_Vgm_si=(+(+(+psip_Vsbulk_si_Vgm_si-qs_Vsbulk_si_Vgm_si)-qdeff_Vsbulk_si_Vgm_si)-0.0);
  psiavg_Vsbulk_si_Vdbulk_di=(+(+(+psip_Vsbulk_si_Vdbulk_di-qs_Vsbulk_si_Vdbulk_di)-qdeff_Vsbulk_si_Vdbulk_di)-0.0);
  psiavg_Vsbulk_si_Vsbulk_si=(+(+(+psip_Vsbulk_si_Vsbulk_si-qs_Vsbulk_si_Vsbulk_si)-qdeff_Vsbulk_si_Vsbulk_si)-0.0);
  psiavg_Vsbulk_si_Vgi_bi=(+(+(+psip_Vsbulk_si_Vgi_bi-qs_Vsbulk_si_Vgi_bi)-qdeff_Vsbulk_si_Vgi_bi)-0.0);
  psiavg_Vsbulk_si_Vdi_bi=(+(+(+psip_Vsbulk_si_Vdi_bi-qs_Vsbulk_si_Vdi_bi)-qdeff_Vsbulk_si_Vdi_bi)-0.0);
  psiavg_Vsbulk_si_Vsi_bi=(+(+(+psip_Vsbulk_si_Vsi_bi-qs_Vsbulk_si_Vsi_bi)-qdeff_Vsbulk_si_Vsi_bi)-0.0);
  psiavg_Vsbulk_si_Tempt_GND=(+(+(+psip_Vsbulk_si_Tempt_GND-qs_Vsbulk_si_Tempt_GND)-qdeff_Vsbulk_si_Tempt_GND)-0.0);
#endif
psiavg_Vgi_bi=((psip_Vgi_bi-qs_Vgi_bi)-qdeff_Vgi_bi);
#if defined(_DERIVATE2)
  psiavg_Vgi_bi_Vgm_di=(+(+(+psip_Vgi_bi_Vgm_di-qs_Vgi_bi_Vgm_di)-qdeff_Vgi_bi_Vgm_di)-0.0);
  psiavg_Vgi_bi_Vgm_si=(+(+(+psip_Vgi_bi_Vgm_si-qs_Vgi_bi_Vgm_si)-qdeff_Vgi_bi_Vgm_si)-0.0);
  psiavg_Vgi_bi_Vdbulk_di=(+(+(+psip_Vgi_bi_Vdbulk_di-qs_Vgi_bi_Vdbulk_di)-qdeff_Vgi_bi_Vdbulk_di)-0.0);
  psiavg_Vgi_bi_Vsbulk_si=(+(+(+psip_Vgi_bi_Vsbulk_si-qs_Vgi_bi_Vsbulk_si)-qdeff_Vgi_bi_Vsbulk_si)-0.0);
  psiavg_Vgi_bi_Vgi_bi=(+(+(+psip_Vgi_bi_Vgi_bi-qs_Vgi_bi_Vgi_bi)-qdeff_Vgi_bi_Vgi_bi)-0.0);
  psiavg_Vgi_bi_Vdi_bi=(+(+(+psip_Vgi_bi_Vdi_bi-qs_Vgi_bi_Vdi_bi)-qdeff_Vgi_bi_Vdi_bi)-0.0);
  psiavg_Vgi_bi_Vsi_bi=(+(+(+psip_Vgi_bi_Vsi_bi-qs_Vgi_bi_Vsi_bi)-qdeff_Vgi_bi_Vsi_bi)-0.0);
  psiavg_Vgi_bi_Tempt_GND=(+(+(+psip_Vgi_bi_Tempt_GND-qs_Vgi_bi_Tempt_GND)-qdeff_Vgi_bi_Tempt_GND)-0.0);
#endif
psiavg_Vdi_bi=((psip_Vdi_bi-qs_Vdi_bi)-qdeff_Vdi_bi);
#if defined(_DERIVATE2)
  psiavg_Vdi_bi_Vgm_di=(+(+(+psip_Vdi_bi_Vgm_di-qs_Vdi_bi_Vgm_di)-qdeff_Vdi_bi_Vgm_di)-0.0);
  psiavg_Vdi_bi_Vgm_si=(+(+(+psip_Vdi_bi_Vgm_si-qs_Vdi_bi_Vgm_si)-qdeff_Vdi_bi_Vgm_si)-0.0);
  psiavg_Vdi_bi_Vdbulk_di=(+(+(+psip_Vdi_bi_Vdbulk_di-qs_Vdi_bi_Vdbulk_di)-qdeff_Vdi_bi_Vdbulk_di)-0.0);
  psiavg_Vdi_bi_Vsbulk_si=(+(+(+psip_Vdi_bi_Vsbulk_si-qs_Vdi_bi_Vsbulk_si)-qdeff_Vdi_bi_Vsbulk_si)-0.0);
  psiavg_Vdi_bi_Vgi_bi=(+(+(+psip_Vdi_bi_Vgi_bi-qs_Vdi_bi_Vgi_bi)-qdeff_Vdi_bi_Vgi_bi)-0.0);
  psiavg_Vdi_bi_Vdi_bi=(+(+(+psip_Vdi_bi_Vdi_bi-qs_Vdi_bi_Vdi_bi)-qdeff_Vdi_bi_Vdi_bi)-0.0);
  psiavg_Vdi_bi_Vsi_bi=(+(+(+psip_Vdi_bi_Vsi_bi-qs_Vdi_bi_Vsi_bi)-qdeff_Vdi_bi_Vsi_bi)-0.0);
  psiavg_Vdi_bi_Tempt_GND=(+(+(+psip_Vdi_bi_Tempt_GND-qs_Vdi_bi_Tempt_GND)-qdeff_Vdi_bi_Tempt_GND)-0.0);
#endif
psiavg_Vsi_bi=((psip_Vsi_bi-qs_Vsi_bi)-qdeff_Vsi_bi);
#if defined(_DERIVATE2)
  psiavg_Vsi_bi_Vgm_di=(+(+(+psip_Vsi_bi_Vgm_di-qs_Vsi_bi_Vgm_di)-qdeff_Vsi_bi_Vgm_di)-0.0);
  psiavg_Vsi_bi_Vgm_si=(+(+(+psip_Vsi_bi_Vgm_si-qs_Vsi_bi_Vgm_si)-qdeff_Vsi_bi_Vgm_si)-0.0);
  psiavg_Vsi_bi_Vdbulk_di=(+(+(+psip_Vsi_bi_Vdbulk_di-qs_Vsi_bi_Vdbulk_di)-qdeff_Vsi_bi_Vdbulk_di)-0.0);
  psiavg_Vsi_bi_Vsbulk_si=(+(+(+psip_Vsi_bi_Vsbulk_si-qs_Vsi_bi_Vsbulk_si)-qdeff_Vsi_bi_Vsbulk_si)-0.0);
  psiavg_Vsi_bi_Vgi_bi=(+(+(+psip_Vsi_bi_Vgi_bi-qs_Vsi_bi_Vgi_bi)-qdeff_Vsi_bi_Vgi_bi)-0.0);
  psiavg_Vsi_bi_Vdi_bi=(+(+(+psip_Vsi_bi_Vdi_bi-qs_Vsi_bi_Vdi_bi)-qdeff_Vsi_bi_Vdi_bi)-0.0);
  psiavg_Vsi_bi_Vsi_bi=(+(+(+psip_Vsi_bi_Vsi_bi-qs_Vsi_bi_Vsi_bi)-qdeff_Vsi_bi_Vsi_bi)-0.0);
  psiavg_Vsi_bi_Tempt_GND=(+(+(+psip_Vsi_bi_Tempt_GND-qs_Vsi_bi_Tempt_GND)-qdeff_Vsi_bi_Tempt_GND)-0.0);
#endif
#if defined(_DERIVATE)
psiavg_Tempt_GND=((psip_Tempt_GND-qs_Tempt_GND)-qdeff_Tempt_GND);
#endif
#endif
psiavg=(((psip-qs)-qdeff)-1.0);
EXIT_IF_ISNAN((((psip-qs)-qdeff)-1.0))
{
double m00_sqrt(d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
T0_Vgm_di=(0.5*(psiavg_Vgm_di+((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vgm_di_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_di+((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_di_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))+d10_sqrt0*(+(+(+psiavg_Vgm_di_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vgm_di*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vgm_di+(psiavg-1.0)*(+psiavg_Vgm_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_di_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_di+((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_di_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))+d10_sqrt0*(+(+(+psiavg_Vgm_di_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vgm_di*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vgm_di+(psiavg-1.0)*(+psiavg_Vgm_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_di_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_di+((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_di_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))+d10_sqrt0*(+(+(+psiavg_Vgm_di_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vgm_di*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vgm_di+(psiavg-1.0)*(+psiavg_Vgm_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_di_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_di+((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_di_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))+d10_sqrt0*(+(+(+psiavg_Vgm_di_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vgm_di*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vgm_di+(psiavg-1.0)*(+psiavg_Vgm_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_di_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_di+((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_di_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))+d10_sqrt0*(+(+(+psiavg_Vgm_di_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vgm_di*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vgm_di+(psiavg-1.0)*(+psiavg_Vgm_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_di_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_di+((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_di_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))+d10_sqrt0*(+(+(+psiavg_Vgm_di_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vgm_di*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vgm_di+(psiavg-1.0)*(+psiavg_Vgm_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_di_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_di+((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_di_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))+d10_sqrt0*(+(+(+psiavg_Vgm_di_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vgm_di*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vgm_di+(psiavg-1.0)*(+psiavg_Vgm_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_di_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_di+((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_di_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di))+d10_sqrt0*(+(+(+psiavg_Vgm_di_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vgm_di*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vgm_di+(psiavg-1.0)*(+psiavg_Vgm_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vgm_si=(0.5*(psiavg_Vgm_si+((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vgm_si_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_si+((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_si_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))+d10_sqrt0*(+(+(+psiavg_Vgm_si_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vgm_si*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vgm_si+(psiavg-1.0)*(+psiavg_Vgm_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_si_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_si+((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_si_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))+d10_sqrt0*(+(+(+psiavg_Vgm_si_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vgm_si*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vgm_si+(psiavg-1.0)*(+psiavg_Vgm_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_si_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_si+((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_si_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))+d10_sqrt0*(+(+(+psiavg_Vgm_si_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vgm_si*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vgm_si+(psiavg-1.0)*(+psiavg_Vgm_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_si_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_si+((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_si_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))+d10_sqrt0*(+(+(+psiavg_Vgm_si_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vgm_si*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vgm_si+(psiavg-1.0)*(+psiavg_Vgm_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_si_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_si+((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_si_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))+d10_sqrt0*(+(+(+psiavg_Vgm_si_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vgm_si*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vgm_si+(psiavg-1.0)*(+psiavg_Vgm_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_si_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_si+((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_si_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))+d10_sqrt0*(+(+(+psiavg_Vgm_si_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vgm_si*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vgm_si+(psiavg-1.0)*(+psiavg_Vgm_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_si_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_si+((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_si_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))+d10_sqrt0*(+(+(+psiavg_Vgm_si_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vgm_si*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vgm_si+(psiavg-1.0)*(+psiavg_Vgm_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgm_si_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgm_si+((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))*d10_sqrt0)+0.5*(+(+psiavg_Vgm_si_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si))+d10_sqrt0*(+(+(+psiavg_Vgm_si_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vgm_si*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vgm_si+(psiavg-1.0)*(+psiavg_Vgm_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vdbulk_di=(0.5*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdbulk_di_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdbulk_di_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdbulk_di+((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))*d10_sqrt0)+0.5*(+(+psiavg_Vdbulk_di_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di))+d10_sqrt0*(+(+(+psiavg_Vdbulk_di_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vdbulk_di*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vdbulk_di+(psiavg-1.0)*(+psiavg_Vdbulk_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vsbulk_si=(0.5*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vsbulk_si_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsbulk_si_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsbulk_si+((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))*d10_sqrt0)+0.5*(+(+psiavg_Vsbulk_si_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si))+d10_sqrt0*(+(+(+psiavg_Vsbulk_si_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vsbulk_si*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vsbulk_si+(psiavg-1.0)*(+psiavg_Vsbulk_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vgi_bi=(0.5*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vgi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vgi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vgi_bi+((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vgi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi))+d10_sqrt0*(+(+(+psiavg_Vgi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vgi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vgi_bi+(psiavg-1.0)*(+psiavg_Vgi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vdi_bi=(0.5*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vdi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vdi_bi+((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vdi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi))+d10_sqrt0*(+(+(+psiavg_Vdi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vdi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vdi_bi+(psiavg-1.0)*(+psiavg_Vdi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
T0_Vsi_bi=(0.5*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vsi_bi_Vgm_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_di+((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_di+psiavg_Vgm_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgm_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgm_si+((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgm_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgm_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgm_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgm_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgm_si+psiavg_Vgm_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgm_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdbulk_di=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdbulk_di+((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdbulk_di+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdbulk_di*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdbulk_di)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdbulk_di-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdbulk_di+psiavg_Vdbulk_di*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdbulk_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsbulk_si=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsbulk_si+((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsbulk_si+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsbulk_si*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsbulk_si)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsbulk_si-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsbulk_si+psiavg_Vsbulk_si*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsbulk_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vgi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vgi_bi+((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vgi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vgi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vgi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vgi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vgi_bi+psiavg_Vgi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vgi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vdi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vdi_bi+((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vdi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vdi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vdi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vdi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vdi_bi+psiavg_Vdi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vdi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Vsi_bi=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Vsi_bi+((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Vsi_bi+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Vsi_bi-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Vsi_bi+psiavg_Vsi_bi*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Vsi_bi-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  T0_Vsi_bi_Tempt_GND=(+0.0*((psiavg+1.0)+d00_sqrt0)+0.0*(psiavg_Tempt_GND+((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(psiavg_Vsi_bi+((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))*d10_sqrt0)+0.5*(+(+psiavg_Vsi_bi_Tempt_GND+0.0)+(m20_sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))*((((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND)))+((0.0)*2.0))*((psiavg_Vsi_bi*(psiavg-1.0))+((psiavg-1.0)*psiavg_Vsi_bi))+d10_sqrt0*(+(+(+psiavg_Vsi_bi_Tempt_GND-0.0)*(psiavg-1.0)+psiavg_Vsi_bi*psiavg_Tempt_GND+psiavg_Tempt_GND*psiavg_Vsi_bi+(psiavg-1.0)*(+psiavg_Vsi_bi_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#if defined(_DERIVATE)
T0_Tempt_GND=(0.5*(psiavg_Tempt_GND+((psiavg_Tempt_GND*(psiavg-1.0))+((psiavg-1.0)*psiavg_Tempt_GND))*d10_sqrt0));
#endif
#endif
T0=(0.5*((psiavg+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((psiavg+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,T0)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(gm,di)V(gm,si)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe=V(sbulk,GND)V(gm,GND)V(dbulk,GND)V(si,GND)V(di,GND)V(bi,GND)V(gi,GND) */
T2_Vgm_di=T0_Vgm_di*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgm_di_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vgm_di+d10_sqrt0*T0_Vgm_di_Vgm_di);
  T2_Vgm_di_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vgm_di+d10_sqrt0*T0_Vgm_di_Vgm_si);
  T2_Vgm_di_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vgm_di+d10_sqrt0*T0_Vgm_di_Vdbulk_di);
  T2_Vgm_di_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vgm_di+d10_sqrt0*T0_Vgm_di_Vsbulk_si);
  T2_Vgm_di_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vgm_di+d10_sqrt0*T0_Vgm_di_Vgi_bi);
  T2_Vgm_di_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vgm_di+d10_sqrt0*T0_Vgm_di_Vdi_bi);
  T2_Vgm_di_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vgm_di+d10_sqrt0*T0_Vgm_di_Vsi_bi);
  T2_Vgm_di_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vgm_di+d10_sqrt0*T0_Vgm_di_Tempt_GND);
#endif
T2_Vgm_si=T0_Vgm_si*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgm_si_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vgm_si+d10_sqrt0*T0_Vgm_si_Vgm_di);
  T2_Vgm_si_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vgm_si+d10_sqrt0*T0_Vgm_si_Vgm_si);
  T2_Vgm_si_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vgm_si+d10_sqrt0*T0_Vgm_si_Vdbulk_di);
  T2_Vgm_si_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vgm_si+d10_sqrt0*T0_Vgm_si_Vsbulk_si);
  T2_Vgm_si_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vgm_si+d10_sqrt0*T0_Vgm_si_Vgi_bi);
  T2_Vgm_si_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vgm_si+d10_sqrt0*T0_Vgm_si_Vdi_bi);
  T2_Vgm_si_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vgm_si+d10_sqrt0*T0_Vgm_si_Vsi_bi);
  T2_Vgm_si_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vgm_si+d10_sqrt0*T0_Vgm_si_Tempt_GND);
#endif
T2_Vdbulk_di=T0_Vdbulk_di*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdbulk_di_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vgm_di);
  T2_Vdbulk_di_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vgm_si);
  T2_Vdbulk_di_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vdbulk_di);
  T2_Vdbulk_di_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vsbulk_si);
  T2_Vdbulk_di_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vgi_bi);
  T2_Vdbulk_di_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vdi_bi);
  T2_Vdbulk_di_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Vsi_bi);
  T2_Vdbulk_di_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vdbulk_di+d10_sqrt0*T0_Vdbulk_di_Tempt_GND);
#endif
T2_Vsbulk_si=T0_Vsbulk_si*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsbulk_si_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vgm_di);
  T2_Vsbulk_si_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vgm_si);
  T2_Vsbulk_si_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vdbulk_di);
  T2_Vsbulk_si_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vsbulk_si);
  T2_Vsbulk_si_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vgi_bi);
  T2_Vsbulk_si_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vdi_bi);
  T2_Vsbulk_si_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Vsi_bi);
  T2_Vsbulk_si_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vsbulk_si+d10_sqrt0*T0_Vsbulk_si_Tempt_GND);
#endif
T2_Vgi_bi=T0_Vgi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vgi_bi_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_di);
  T2_Vgi_bi_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgm_si);
  T2_Vgi_bi_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdbulk_di);
  T2_Vgi_bi_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsbulk_si);
  T2_Vgi_bi_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vgi_bi);
  T2_Vgi_bi_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vdi_bi);
  T2_Vgi_bi_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Vsi_bi);
  T2_Vgi_bi_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vgi_bi+d10_sqrt0*T0_Vgi_bi_Tempt_GND);
#endif
T2_Vdi_bi=T0_Vdi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vdi_bi_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_di);
  T2_Vdi_bi_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgm_si);
  T2_Vdi_bi_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdbulk_di);
  T2_Vdi_bi_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsbulk_si);
  T2_Vdi_bi_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vgi_bi);
  T2_Vdi_bi_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vdi_bi);
  T2_Vdi_bi_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Vsi_bi);
  T2_Vdi_bi_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vdi_bi+d10_sqrt0*T0_Vdi_bi_Tempt_GND);
#endif
T2_Vsi_bi=T0_Vsi_bi*d10_sqrt0;
#if defined(_DERIVATE2)
  T2_Vsi_bi_Vgm_di=(m20_sqrt(T0)*T0_Vgm_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_di);
  T2_Vsi_bi_Vgm_si=(m20_sqrt(T0)*T0_Vgm_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgm_si);
  T2_Vsi_bi_Vdbulk_di=(m20_sqrt(T0)*T0_Vdbulk_di*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdbulk_di);
  T2_Vsi_bi_Vsbulk_si=(m20_sqrt(T0)*T0_Vsbulk_si*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsbulk_si);
  T2_Vsi_bi_Vgi_bi=(m20_sqrt(T0)*T0_Vgi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vgi_bi);
  T2_Vsi_bi_Vdi_bi=(m20_sqrt(T0)*T0_Vdi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vdi_bi);
  T2_Vsi_bi_Vsi_bi=(m20_sqrt(T0)*T0_Vsi_bi*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Vsi_bi);
  T2_Vsi_bi_Tempt_GND=(m20_sqrt(T0)*T0_Tempt_GND*T0_Vsi_bi+d10_sqrt0*T0_Vsi_bi_Tempt_GND);
#endif
#if defined(_DERIVATE)
T2_Tempt_GND=T0_Tempt_GND*d10_sqrt0;
#endif
#endif
T2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(si,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND) */
nq_Vgm_si=((gam_Vgm_si*(sqrtpsip+T2)-gam*(sqrtpsip_Vgm_si+T2_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vgm_si_Vgm_si=(+0.0+(gam_Vgm_si_Vgm_si/(sqrtpsip+T2)-(gam_Vgm_si*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam*(+sqrtpsip_Vgm_si_Vgm_si+T2_Vgm_si_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_si+T2_Vgm_si)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_si_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(gam_Vgm_si*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam*(+sqrtpsip_Vgm_si_Vgm_di+T2_Vgm_si_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_si+T2_Vgm_si)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_si_Vdbulk_di=(+0.0+(gam_Vgm_si_Vdbulk_di/(sqrtpsip+T2)-(gam_Vgm_si*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam*(+sqrtpsip_Vgm_si_Vdbulk_di+T2_Vgm_si_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_si+T2_Vgm_si)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_si_Vsbulk_si=(+0.0+(gam_Vgm_si_Vsbulk_si/(sqrtpsip+T2)-(gam_Vgm_si*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam*(+sqrtpsip_Vgm_si_Vsbulk_si+T2_Vgm_si_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_si+T2_Vgm_si)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_si_Vgi_bi=(+0.0+(gam_Vgm_si_Vgi_bi/(sqrtpsip+T2)-(gam_Vgm_si*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam*(+sqrtpsip_Vgm_si_Vgi_bi+T2_Vgm_si_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_si+T2_Vgm_si)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_si_Tempt_GND=(+0.0+(gam_Vgm_si_Tempt_GND/(sqrtpsip+T2)-(gam_Vgm_si*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam*(+sqrtpsip_Vgm_si_Tempt_GND+T2_Vgm_si_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_si+T2_Vgm_si)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_si_Vdi_bi=(+0.0+(gam_Vgm_si_Vdi_bi/(sqrtpsip+T2)-(gam_Vgm_si*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam*(+sqrtpsip_Vgm_si_Vdi_bi+T2_Vgm_si_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_si+T2_Vgm_si)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_si_Vsi_bi=(+0.0+(gam_Vgm_si_Vsi_bi/(sqrtpsip+T2)-(gam_Vgm_si*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam*(+sqrtpsip_Vgm_si_Vsi_bi+T2_Vgm_si_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_si+T2_Vgm_si)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
nq_Vgm_di=(-gam*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vgm_di_Vgm_si=(+0.0+(0.0/(sqrtpsip+T2)-(0.0*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vgm_di+T2_Vgm_di)+gam*(+sqrtpsip_Vgm_di_Vgm_si+T2_Vgm_di_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_di+T2_Vgm_di)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_di_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(0.0*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vgm_di+T2_Vgm_di)+gam*(+sqrtpsip_Vgm_di_Vgm_di+T2_Vgm_di_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_di+T2_Vgm_di)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_di_Vdbulk_di=(+0.0+(0.0/(sqrtpsip+T2)-(0.0*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vgm_di+T2_Vgm_di)+gam*(+sqrtpsip_Vgm_di_Vdbulk_di+T2_Vgm_di_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_di+T2_Vgm_di)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_di_Vsbulk_si=(+0.0+(0.0/(sqrtpsip+T2)-(0.0*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vgm_di+T2_Vgm_di)+gam*(+sqrtpsip_Vgm_di_Vsbulk_si+T2_Vgm_di_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_di+T2_Vgm_di)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_di_Vgi_bi=(+0.0+(0.0/(sqrtpsip+T2)-(0.0*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+gam*(+sqrtpsip_Vgm_di_Vgi_bi+T2_Vgm_di_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_di+T2_Vgm_di)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_di_Tempt_GND=(+0.0+(0.0/(sqrtpsip+T2)-(0.0*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vgm_di+T2_Vgm_di)+gam*(+sqrtpsip_Vgm_di_Tempt_GND+T2_Vgm_di_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_di+T2_Vgm_di)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_di_Vdi_bi=(+0.0+(0.0/(sqrtpsip+T2)-(0.0*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+gam*(+sqrtpsip_Vgm_di_Vdi_bi+T2_Vgm_di_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_di+T2_Vgm_di)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgm_di_Vsi_bi=(+0.0+(0.0/(sqrtpsip+T2)-(0.0*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+gam*(+sqrtpsip_Vgm_di_Vsi_bi+T2_Vgm_di_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgm_di+T2_Vgm_di)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
nq_Vdbulk_di=((gam_Vdbulk_di*(sqrtpsip+T2)-gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vdbulk_di_Vgm_si=(+0.0+(gam_Vdbulk_di_Vgm_si/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vgm_si+T2_Vdbulk_di_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdbulk_di_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vgm_di+T2_Vdbulk_di_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdbulk_di_Vdbulk_di=(+0.0+(gam_Vdbulk_di_Vdbulk_di/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vdbulk_di+T2_Vdbulk_di_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdbulk_di_Vsbulk_si=(+0.0+(gam_Vdbulk_di_Vsbulk_si/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vsbulk_si+T2_Vdbulk_di_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdbulk_di_Vgi_bi=(+0.0+(gam_Vdbulk_di_Vgi_bi/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vgi_bi+T2_Vdbulk_di_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdbulk_di_Tempt_GND=(+0.0+(gam_Vdbulk_di_Tempt_GND/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Tempt_GND+T2_Vdbulk_di_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdbulk_di_Vdi_bi=(+0.0+(gam_Vdbulk_di_Vdi_bi/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vdi_bi+T2_Vdbulk_di_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdbulk_di_Vsi_bi=(+0.0+(gam_Vdbulk_di_Vsi_bi/(sqrtpsip+T2)-(gam_Vdbulk_di*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam*(+sqrtpsip_Vdbulk_di_Vsi_bi+T2_Vdbulk_di_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
nq_Vsbulk_si=((gam_Vsbulk_si*(sqrtpsip+T2)-gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vsbulk_si_Vgm_si=(+0.0+(gam_Vsbulk_si_Vgm_si/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vgm_si+T2_Vsbulk_si_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsbulk_si_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vgm_di+T2_Vsbulk_si_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsbulk_si_Vdbulk_di=(+0.0+(gam_Vsbulk_si_Vdbulk_di/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vdbulk_di+T2_Vsbulk_si_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsbulk_si_Vsbulk_si=(+0.0+(gam_Vsbulk_si_Vsbulk_si/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vsbulk_si+T2_Vsbulk_si_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsbulk_si_Vgi_bi=(+0.0+(gam_Vsbulk_si_Vgi_bi/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vgi_bi+T2_Vsbulk_si_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsbulk_si_Tempt_GND=(+0.0+(gam_Vsbulk_si_Tempt_GND/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Tempt_GND+T2_Vsbulk_si_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsbulk_si_Vdi_bi=(+0.0+(gam_Vsbulk_si_Vdi_bi/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vdi_bi+T2_Vsbulk_si_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsbulk_si_Vsi_bi=(+0.0+(gam_Vsbulk_si_Vsi_bi/(sqrtpsip+T2)-(gam_Vsbulk_si*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam*(+sqrtpsip_Vsbulk_si_Vsi_bi+T2_Vsbulk_si_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
nq_Vgi_bi=((gam_Vgi_bi*(sqrtpsip+T2)-gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vgi_bi_Vgm_si=(+0.0+(gam_Vgi_bi_Vgm_si/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vgm_si+T2_Vgi_bi_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vgm_di+T2_Vgi_bi_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vdbulk_di=(+0.0+(gam_Vgi_bi_Vdbulk_di/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vdbulk_di+T2_Vgi_bi_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vsbulk_si=(+0.0+(gam_Vgi_bi_Vsbulk_si/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vsbulk_si+T2_Vgi_bi_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vgi_bi=(+0.0+(gam_Vgi_bi_Vgi_bi/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vgi_bi+T2_Vgi_bi_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Tempt_GND=(+0.0+(gam_Vgi_bi_Tempt_GND/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Tempt_GND+T2_Vgi_bi_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vdi_bi=(+0.0+(gam_Vgi_bi_Vdi_bi/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vdi_bi+T2_Vgi_bi_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vgi_bi_Vsi_bi=(+0.0+(gam_Vgi_bi_Vsi_bi/(sqrtpsip+T2)-(gam_Vgi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam*(+sqrtpsip_Vgi_bi_Vsi_bi+T2_Vgi_bi_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vgi_bi+T2_Vgi_bi)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
#if defined(_DERIVATE)
nq_Tempt_GND=((gam_Tempt_GND*(sqrtpsip+T2)-gam*(sqrtpsip_Tempt_GND+T2_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2));
#endif
nq_Vdi_bi=((gam_Vdi_bi*(sqrtpsip+T2)-gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vdi_bi_Vgm_si=(+0.0+(gam_Vdi_bi_Vgm_si/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vgm_si+T2_Vdi_bi_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vgm_di+T2_Vdi_bi_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vdbulk_di=(+0.0+(gam_Vdi_bi_Vdbulk_di/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vdbulk_di+T2_Vdi_bi_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vsbulk_si=(+0.0+(gam_Vdi_bi_Vsbulk_si/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vsbulk_si+T2_Vdi_bi_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vgi_bi=(+0.0+(gam_Vdi_bi_Vgi_bi/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vgi_bi+T2_Vdi_bi_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Tempt_GND=(+0.0+(gam_Vdi_bi_Tempt_GND/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Tempt_GND+T2_Vdi_bi_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vdi_bi=(+0.0+(gam_Vdi_bi_Vdi_bi/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vdi_bi+T2_Vdi_bi_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vdi_bi_Vsi_bi=(+0.0+(gam_Vdi_bi_Vsi_bi/(sqrtpsip+T2)-(gam_Vdi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam*(+sqrtpsip_Vdi_bi_Vsi_bi+T2_Vdi_bi_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vdi_bi+T2_Vdi_bi)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
nq_Vsi_bi=((gam_Vsi_bi*(sqrtpsip+T2)-gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
#if defined(_DERIVATE2)
  nq_Vsi_bi_Vgm_si=(+0.0+(gam_Vsi_bi_Vgm_si/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vgm_si+T2_Vgm_si)+gam_Vgm_si*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vgm_si+T2_Vsi_bi_Vgm_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vgm_si+T2_Vgm_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vgm_di=(+0.0+(0.0/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vgm_di+T2_Vgm_di)+0.0*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vgm_di+T2_Vsi_bi_Vgm_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vgm_di+T2_Vgm_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vdbulk_di=(+0.0+(gam_Vsi_bi_Vdbulk_di/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)+gam_Vdbulk_di*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vdbulk_di+T2_Vsi_bi_Vdbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vdbulk_di+T2_Vdbulk_di)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vsbulk_si=(+0.0+(gam_Vsi_bi_Vsbulk_si/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)+gam_Vsbulk_si*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vsbulk_si+T2_Vsi_bi_Vsbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vsbulk_si+T2_Vsbulk_si)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vgi_bi=(+0.0+(gam_Vsi_bi_Vgi_bi/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vgi_bi+T2_Vgi_bi)+gam_Vgi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vgi_bi+T2_Vsi_bi_Vgi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vgi_bi+T2_Vgi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Tempt_GND=(+0.0+(gam_Vsi_bi_Tempt_GND/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Tempt_GND+T2_Tempt_GND)+gam_Tempt_GND*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Tempt_GND+T2_Vsi_bi_Tempt_GND))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Tempt_GND+T2_Tempt_GND)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vdi_bi=(+0.0+(gam_Vsi_bi_Vdi_bi/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vdi_bi+T2_Vdi_bi)+gam_Vdi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vdi_bi+T2_Vsi_bi_Vdi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vdi_bi+T2_Vdi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
  nq_Vsi_bi_Vsi_bi=(+0.0+(gam_Vsi_bi_Vsi_bi/(sqrtpsip+T2)-(gam_Vsi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam_Vsi_bi*(sqrtpsip_Vsi_bi+T2_Vsi_bi)+gam*(+sqrtpsip_Vsi_bi_Vsi_bi+T2_Vsi_bi_Vsi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2)+2*gam*(sqrtpsip_Vsi_bi+T2_Vsi_bi)*(sqrtpsip_Vsi_bi+T2_Vsi_bi)/(sqrtpsip+T2)/(sqrtpsip+T2)/(sqrtpsip+T2)));
#endif
#endif
nq=(1.0+(gam/(sqrtpsip+T2)));
EXIT_IF_ISNAN((1.0+(gam/(sqrtpsip+T2))))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(di,GND)V(bi,GND)V(gi,GND) */
#if defined(_DERIVATE)
ids_edge_Vgm_si=(((((((((2.0*pInst->NF)*nq_Vgm_si)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))*Moc;
#endif
ids_edge_Vgm_di=(((((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))*Moc;
#if defined(_DERIVATE2)
  ids_edge_Vgm_di_Vgm_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_si+(0.0)*nq_Vgm_di+(2.0*pInst->NF)*nq_Vgm_di_Vgm_si)*ueff+((2.0*pInst->NF)*nq_Vgm_di)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vgm_di)*ueff*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vgm_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt_Vgm_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*0.0+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgm_di_Vgm_si-qdeff_Vgm_di_Vgm_si)*((1.0+qs)+qdeff)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vgm_si+qdeff_Vgm_si)+(qs_Vgm_si-qdeff_Vgm_si)*(qs_Vgm_di+qdeff_Vgm_di)+(qs-qdeff)*(+(+0.0+qs_Vgm_di_Vgm_si)+qdeff_Vgm_di_Vgm_si)))*Moc+(((((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgm_di_Vgm_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_di+(0.0)*nq_Vgm_di+(2.0*pInst->NF)*nq_Vgm_di_Vgm_di)*ueff+((2.0*pInst->NF)*nq_Vgm_di)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vgm_di)*ueff*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di))))+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgm_di_Vgm_di-qdeff_Vgm_di_Vgm_di)*((1.0+qs)+qdeff)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vgm_di+qdeff_Vgm_di)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vgm_di+qdeff_Vgm_di)+(qs-qdeff)*(+(+0.0+qs_Vgm_di_Vgm_di)+qdeff_Vgm_di_Vgm_di)))*Moc+(((((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))*0.0+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgm_di_Vdbulk_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdbulk_di+(0.0)*nq_Vgm_di+(2.0*pInst->NF)*nq_Vgm_di_Vdbulk_di)*ueff+((2.0*pInst->NF)*nq_Vgm_di)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vgm_di)*ueff*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vdbulk_di+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt_Vdbulk_di+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*0.0+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgm_di_Vdbulk_di-qdeff_Vgm_di_Vdbulk_di)*((1.0+qs)+qdeff)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vgm_di+qdeff_Vgm_di)+(qs-qdeff)*(+(+0.0+qs_Vgm_di_Vdbulk_di)+qdeff_Vgm_di_Vdbulk_di)))*Moc+(((((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgm_di_Vsbulk_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsbulk_si+(0.0)*nq_Vgm_di+(2.0*pInst->NF)*nq_Vgm_di_Vsbulk_si)*ueff+((2.0*pInst->NF)*nq_Vgm_di)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vgm_di)*ueff*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vsbulk_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt_Vsbulk_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*0.0+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgm_di_Vsbulk_si-qdeff_Vgm_di_Vsbulk_si)*((1.0+qs)+qdeff)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vgm_di+qdeff_Vgm_di)+(qs-qdeff)*(+(+0.0+qs_Vgm_di_Vsbulk_si)+qdeff_Vgm_di_Vsbulk_si)))*Moc+(((((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgm_di_Vgi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vgm_di+(2.0*pInst->NF)*nq_Vgm_di_Vgi_bi)*ueff+((2.0*pInst->NF)*nq_Vgm_di)*ueff_Vgi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vgm_di)*ueff*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vgi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*0.0+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt_Vgi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*0.0+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgm_di_Vgi_bi-qdeff_Vgm_di_Vgi_bi)*((1.0+qs)+qdeff)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgm_di+qdeff_Vgm_di)+(qs-qdeff)*(+(+0.0+qs_Vgm_di_Vgi_bi)+qdeff_Vgm_di_Vgi_bi)))*Moc+(((((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))*Moc_Vgi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgm_di_Tempt_GND=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vgm_di+(2.0*pInst->NF)*nq_Vgm_di_Tempt_GND)*ueff+((2.0*pInst->NF)*nq_Vgm_di)*ueff_Tempt_GND+((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vgm_di)*ueff*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Tempt_GND+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*0.0+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt_Tempt_GND+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*0.0+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgm_di_Tempt_GND-qdeff_Vgm_di_Tempt_GND)*((1.0+qs)+qdeff)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Tempt_GND+qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vgm_di+qdeff_Vgm_di)+(qs-qdeff)*(+(+0.0+qs_Vgm_di_Tempt_GND)+qdeff_Vgm_di_Tempt_GND)))*Moc+(((((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))*Moc_Tempt_GND+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgm_di_Vdi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vgm_di+(2.0*pInst->NF)*nq_Vgm_di_Vdi_bi)*ueff+((2.0*pInst->NF)*nq_Vgm_di)*ueff_Vdi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vgm_di)*ueff*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vdi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*0.0+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt_Vdi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*0.0+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgm_di_Vdi_bi-qdeff_Vgm_di_Vdi_bi)*((1.0+qs)+qdeff)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgm_di+qdeff_Vgm_di)+(qs-qdeff)*(+(+0.0+qs_Vgm_di_Vdi_bi)+qdeff_Vgm_di_Vdi_bi)))*Moc+(((((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))*Moc_Vdi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgm_di_Vsi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vgm_di+(2.0*pInst->NF)*nq_Vgm_di_Vsi_bi)*ueff+((2.0*pInst->NF)*nq_Vgm_di)*ueff_Vsi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vgm_di)*ueff*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vsi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*0.0+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt_Vsi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*0.0+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgm_di_Vsi_bi-qdeff_Vgm_di_Vsi_bi)*((1.0+qs)+qdeff)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgm_di+qdeff_Vgm_di)+(qs-qdeff)*(+(+0.0+qs_Vgm_di_Vsi_bi)+qdeff_Vgm_di_Vsi_bi)))*Moc+(((((2.0*pInst->NF)*nq_Vgm_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))*Moc_Vsi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
#endif
ids_edge_Vdbulk_di=(((((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))*Moc;
#if defined(_DERIVATE2)
  ids_edge_Vdbulk_di_Vgm_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_si+(0.0)*nq_Vdbulk_di+(2.0*pInst->NF)*nq_Vdbulk_di_Vgm_si)*ueff+((2.0*pInst->NF)*nq_Vdbulk_di)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vgm_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di_Vgm_si)*nVt+(((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt_Vgm_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt_Vdbulk_di+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di_Vgm_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdbulk_di_Vgm_si-qdeff_Vdbulk_di_Vgm_si)*((1.0+qs)+qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vgm_si+qdeff_Vgm_si)+(qs_Vgm_si-qdeff_Vgm_si)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs-qdeff)*(+(+0.0+qs_Vdbulk_di_Vgm_si)+qdeff_Vdbulk_di_Vgm_si)))*Moc+(((((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdbulk_di_Vgm_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_di+(0.0)*nq_Vdbulk_di+(2.0*pInst->NF)*nq_Vdbulk_di_Vgm_di)*ueff+((2.0*pInst->NF)*nq_Vdbulk_di)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di))))+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdbulk_di_Vgm_di-qdeff_Vdbulk_di_Vgm_di)*((1.0+qs)+qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vgm_di+qdeff_Vgm_di)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs-qdeff)*(+(+0.0+qs_Vdbulk_di_Vgm_di)+qdeff_Vdbulk_di_Vgm_di)))*Moc+(((((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))*0.0+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdbulk_di_Vdbulk_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdbulk_di+(0.0)*nq_Vdbulk_di+(2.0*pInst->NF)*nq_Vdbulk_di_Vdbulk_di)*ueff+((2.0*pInst->NF)*nq_Vdbulk_di)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vdbulk_di+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di_Vdbulk_di)*nVt+(((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt_Vdbulk_di+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt_Vdbulk_di+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di_Vdbulk_di)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdbulk_di_Vdbulk_di-qdeff_Vdbulk_di_Vdbulk_di)*((1.0+qs)+qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs-qdeff)*(+(+0.0+qs_Vdbulk_di_Vdbulk_di)+qdeff_Vdbulk_di_Vdbulk_di)))*Moc+(((((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdbulk_di_Vsbulk_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsbulk_si+(0.0)*nq_Vdbulk_di+(2.0*pInst->NF)*nq_Vdbulk_di_Vsbulk_si)*ueff+((2.0*pInst->NF)*nq_Vdbulk_di)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vsbulk_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di_Vsbulk_si)*nVt+(((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt_Vsbulk_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt_Vdbulk_di+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di_Vsbulk_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdbulk_di_Vsbulk_si-qdeff_Vdbulk_di_Vsbulk_si)*((1.0+qs)+qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs-qdeff)*(+(+0.0+qs_Vdbulk_di_Vsbulk_si)+qdeff_Vdbulk_di_Vsbulk_si)))*Moc+(((((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdbulk_di_Vgi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vdbulk_di+(2.0*pInst->NF)*nq_Vdbulk_di_Vgi_bi)*ueff+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff_Vgi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vgi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di_Vgi_bi)*nVt+(((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt_Vgi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt_Vdbulk_di+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di_Vgi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdbulk_di_Vgi_bi-qdeff_Vdbulk_di_Vgi_bi)*((1.0+qs)+qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs-qdeff)*(+(+0.0+qs_Vdbulk_di_Vgi_bi)+qdeff_Vdbulk_di_Vgi_bi)))*Moc+(((((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))*Moc_Vgi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdbulk_di_Tempt_GND=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vdbulk_di+(2.0*pInst->NF)*nq_Vdbulk_di_Tempt_GND)*ueff+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff_Tempt_GND+((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Tempt_GND+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di_Tempt_GND)*nVt+(((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt_Tempt_GND+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt_Vdbulk_di+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di_Tempt_GND)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdbulk_di_Tempt_GND-qdeff_Vdbulk_di_Tempt_GND)*((1.0+qs)+qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Tempt_GND+qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs-qdeff)*(+(+0.0+qs_Vdbulk_di_Tempt_GND)+qdeff_Vdbulk_di_Tempt_GND)))*Moc+(((((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))*Moc_Tempt_GND+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdbulk_di_Vdi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vdbulk_di+(2.0*pInst->NF)*nq_Vdbulk_di_Vdi_bi)*ueff+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff_Vdi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vdi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di_Vdi_bi)*nVt+(((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt_Vdi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt_Vdbulk_di+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di_Vdi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdbulk_di_Vdi_bi-qdeff_Vdbulk_di_Vdi_bi)*((1.0+qs)+qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs-qdeff)*(+(+0.0+qs_Vdbulk_di_Vdi_bi)+qdeff_Vdbulk_di_Vdi_bi)))*Moc+(((((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))*Moc_Vdi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdbulk_di_Vsi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vdbulk_di+(2.0*pInst->NF)*nq_Vdbulk_di_Vsi_bi)*ueff+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff_Vsi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*0.0+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt_Vsi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di_Vsi_bi)*nVt+(((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt_Vsi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt_Vdbulk_di+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di_Vsi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdbulk_di_Vsi_bi-qdeff_Vdbulk_di_Vsi_bi)*((1.0+qs)+qdeff)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs-qdeff)*(+(+0.0+qs_Vdbulk_di_Vsi_bi)+qdeff_Vdbulk_di_Vsi_bi)))*Moc+(((((((((2.0*pInst->NF)*nq_Vdbulk_di)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))*Moc_Vsi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*0.0+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
#endif
#if defined(_DERIVATE)
ids_edge_Vsbulk_si=(((((((((2.0*pInst->NF)*nq_Vsbulk_si)*ueff*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))*Moc;
#endif
ids_edge_Vgi_bi=(((((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi));
#if defined(_DERIVATE2)
  ids_edge_Vgi_bi_Vgm_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_si+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vgm_si)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vgm_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi_Vgm_si)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vgm_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vgm_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vgm_si-qdeff_Vgi_bi_Vgm_si)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgm_si+qdeff_Vgm_si)+(qs_Vgm_si-qdeff_Vgm_si)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vgm_si)+qdeff_Vgi_bi_Vgm_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgi_bi_Vgm_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_di+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vgm_di)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di))))+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vgm_di-qdeff_Vgi_bi_Vgm_di)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgm_di+qdeff_Vgm_di)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vgm_di)+qdeff_Vgi_bi_Vgm_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*0.0+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgi_bi_Vdbulk_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdbulk_di+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vdbulk_di)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vdbulk_di+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi_Vdbulk_di)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vdbulk_di+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vdbulk_di)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vdbulk_di-qdeff_Vgi_bi_Vdbulk_di)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vdbulk_di)+qdeff_Vgi_bi_Vdbulk_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgi_bi_Vsbulk_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsbulk_si+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vsbulk_si)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vsbulk_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi_Vsbulk_si)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vsbulk_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vsbulk_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vsbulk_si-qdeff_Vgi_bi_Vsbulk_si)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vsbulk_si)+qdeff_Vgi_bi_Vsbulk_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vgi_bi_Vgi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vgi_bi)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*ueff_Vgi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*ueff_Vgi_bi_Vgi_bi)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vgi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi_Vgi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vgi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vgi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vgi_bi-qdeff_Vgi_bi_Vgi_bi)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vgi_bi)+qdeff_Vgi_bi_Vgi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc_Vgi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi_Vgi_bi);
  ids_edge_Vgi_bi_Tempt_GND=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Tempt_GND)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*ueff_Tempt_GND+((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*ueff_Vgi_bi_Tempt_GND)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Tempt_GND+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi_Tempt_GND)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Tempt_GND+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Tempt_GND)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Tempt_GND-qdeff_Vgi_bi_Tempt_GND)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Tempt_GND)+qdeff_Vgi_bi_Tempt_GND)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc_Tempt_GND+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi_Tempt_GND);
  ids_edge_Vgi_bi_Vdi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vdi_bi)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*ueff_Vdi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*ueff_Vgi_bi_Vdi_bi)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vdi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi_Vdi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vdi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vdi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vdi_bi-qdeff_Vgi_bi_Vdi_bi)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vdi_bi)+qdeff_Vgi_bi_Vdi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc_Vdi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi_Vdi_bi);
  ids_edge_Vgi_bi_Vsi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vgi_bi+(2.0*pInst->NF)*nq_Vgi_bi_Vsi_bi)*ueff+((2.0*pInst->NF)*nq_Vgi_bi)*ueff_Vsi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff_Vgi_bi+((2.0*pInst->NF)*nq)*ueff_Vgi_bi_Vsi_bi)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vsi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi_Vsi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt_Vsi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt_Vgi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi_Vsi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vgi_bi_Vsi_bi-qdeff_Vgi_bi_Vsi_bi)*((1.0+qs)+qdeff)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs-qdeff)*(+(+0.0+qs_Vgi_bi_Vsi_bi)+qdeff_Vgi_bi_Vsi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vgi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))*Moc_Vsi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc_Vgi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vgi_bi_Vsi_bi);
#endif
#if defined(_DERIVATE)
ids_edge_Tempt_GND=(((((((((((((2.0*pInst->NF)*nq_Tempt_GND)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Tempt_GND));
#endif
ids_edge_Vdi_bi=(((((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi));
#if defined(_DERIVATE2)
  ids_edge_Vdi_bi_Vgm_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_si+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vgm_si)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vgm_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi_Vgm_si)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vgm_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vgm_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vgm_si-qdeff_Vdi_bi_Vgm_si)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgm_si+qdeff_Vgm_si)+(qs_Vgm_si-qdeff_Vgm_si)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vgm_si)+qdeff_Vdi_bi_Vgm_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdi_bi_Vgm_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_di+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vgm_di)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di))))+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vgm_di-qdeff_Vdi_bi_Vgm_di)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgm_di+qdeff_Vgm_di)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vgm_di)+qdeff_Vdi_bi_Vgm_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*0.0+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdi_bi_Vdbulk_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdbulk_di+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vdbulk_di)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vdbulk_di+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi_Vdbulk_di)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vdbulk_di+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vdbulk_di)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vdbulk_di-qdeff_Vdi_bi_Vdbulk_di)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vdbulk_di)+qdeff_Vdi_bi_Vdbulk_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdi_bi_Vsbulk_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsbulk_si+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vsbulk_si)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vsbulk_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi_Vsbulk_si)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vsbulk_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vsbulk_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vsbulk_si-qdeff_Vdi_bi_Vsbulk_si)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vsbulk_si)+qdeff_Vdi_bi_Vsbulk_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vdi_bi_Vgi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vgi_bi)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*ueff_Vgi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*ueff_Vdi_bi_Vgi_bi)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vgi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi_Vgi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vgi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vgi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vgi_bi-qdeff_Vdi_bi_Vgi_bi)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vgi_bi)+qdeff_Vdi_bi_Vgi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc_Vgi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi_Vgi_bi);
  ids_edge_Vdi_bi_Tempt_GND=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Tempt_GND)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*ueff_Tempt_GND+((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*ueff_Vdi_bi_Tempt_GND)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Tempt_GND+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi_Tempt_GND)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Tempt_GND+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Tempt_GND)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Tempt_GND-qdeff_Vdi_bi_Tempt_GND)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Tempt_GND)+qdeff_Vdi_bi_Tempt_GND)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc_Tempt_GND+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi_Tempt_GND);
  ids_edge_Vdi_bi_Vdi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vdi_bi)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*ueff_Vdi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*ueff_Vdi_bi_Vdi_bi)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vdi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi_Vdi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vdi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vdi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vdi_bi-qdeff_Vdi_bi_Vdi_bi)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vdi_bi)+qdeff_Vdi_bi_Vdi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc_Vdi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi_Vdi_bi);
  ids_edge_Vdi_bi_Vsi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vdi_bi+(2.0*pInst->NF)*nq_Vdi_bi_Vsi_bi)*ueff+((2.0*pInst->NF)*nq_Vdi_bi)*ueff_Vsi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff_Vdi_bi+((2.0*pInst->NF)*nq)*ueff_Vdi_bi_Vsi_bi)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vsi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi_Vsi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt_Vsi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt_Vdi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi_Vsi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vdi_bi_Vsi_bi-qdeff_Vdi_bi_Vsi_bi)*((1.0+qs)+qdeff)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs-qdeff)*(+(+0.0+qs_Vdi_bi_Vsi_bi)+qdeff_Vdi_bi_Vsi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vdi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))*Moc_Vsi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc_Vdi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vdi_bi_Vsi_bi);
#endif
ids_edge_Vsi_bi=(((((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc)+((((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi));
#if defined(_DERIVATE2)
  ids_edge_Vsi_bi_Vgm_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_si+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vgm_si)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vgm_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi_Vgm_si)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vgm_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vgm_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vgm_si-qdeff_Vsi_bi_Vgm_si)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgm_si+qdeff_Vgm_si)+(qs_Vgm_si-qdeff_Vgm_si)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vgm_si)+qdeff_Vsi_bi_Vgm_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgm_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgm_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_si-qdeff_Vgm_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_si+qdeff_Vgm_si)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vsi_bi_Vgm_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgm_di+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vgm_di)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*0.0)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*0.0)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di))))+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vgm_di-qdeff_Vsi_bi_Vgm_di)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgm_di+qdeff_Vgm_di)+(qs_Vgm_di-qdeff_Vgm_di)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vgm_di)+qdeff_Vsi_bi_Vgm_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*0.0+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgm_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgm_di-qdeff_Vgm_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgm_di+qdeff_Vgm_di)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vsi_bi_Vdbulk_di=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdbulk_di+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vdbulk_di)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vdbulk_di+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi_Vdbulk_di)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vdbulk_di+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vdbulk_di)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vdbulk_di-qdeff_Vsi_bi_Vdbulk_di)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdbulk_di+qdeff_Vdbulk_di)+(qs_Vdbulk_di-qdeff_Vdbulk_di)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vdbulk_di)+qdeff_Vsi_bi_Vdbulk_di)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdbulk_di)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdbulk_di)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdbulk_di)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdbulk_di-qdeff_Vdbulk_di)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdbulk_di+qdeff_Vdbulk_di)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vsi_bi_Vsbulk_si=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsbulk_si+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vsbulk_si)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*0.0+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*0.0)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE*0.0+((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vsbulk_si+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi_Vsbulk_si)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vsbulk_si+(((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vsbulk_si)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si))))+((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vsbulk_si-qdeff_Vsi_bi_Vsbulk_si)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsbulk_si+qdeff_Vsbulk_si)+(qs_Vsbulk_si-qdeff_Vsbulk_si)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vsbulk_si)+qdeff_Vsi_bi_Vsbulk_si)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*0.0+(((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsbulk_si)))*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsbulk_si)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsbulk_si)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsbulk_si-qdeff_Vsbulk_si)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsbulk_si+qdeff_Vsbulk_si)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*0.0);
  ids_edge_Vsi_bi_Vgi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vgi_bi+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vgi_bi)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*ueff_Vgi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*ueff_Vsi_bi_Vgi_bi)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vgi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi_Vgi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vgi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vgi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vgi_bi-qdeff_Vsi_bi_Vgi_bi)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vgi_bi+qdeff_Vgi_bi)+(qs_Vgi_bi-qdeff_Vgi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vgi_bi)+qdeff_Vsi_bi_Vgi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc_Vgi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vgi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vgi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vgi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vgi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vgi_bi-qdeff_Vgi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vgi_bi+qdeff_Vgi_bi)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi_Vgi_bi);
  ids_edge_Vsi_bi_Tempt_GND=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Tempt_GND+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Tempt_GND)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*ueff_Tempt_GND+((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*ueff_Vsi_bi_Tempt_GND)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Tempt_GND+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi_Tempt_GND)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Tempt_GND+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Tempt_GND)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Tempt_GND-qdeff_Vsi_bi_Tempt_GND)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Tempt_GND+qdeff_Tempt_GND)+(qs_Tempt_GND-qdeff_Tempt_GND)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Tempt_GND)+qdeff_Vsi_bi_Tempt_GND)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc_Tempt_GND+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Tempt_GND)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Tempt_GND)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Tempt_GND)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Tempt_GND)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Tempt_GND-qdeff_Tempt_GND)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Tempt_GND+qdeff_Tempt_GND)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi_Tempt_GND);
  ids_edge_Vsi_bi_Vdi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vdi_bi+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vdi_bi)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*ueff_Vdi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*ueff_Vsi_bi_Vdi_bi)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vdi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi_Vdi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vdi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vdi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vdi_bi-qdeff_Vsi_bi_Vdi_bi)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vdi_bi+qdeff_Vdi_bi)+(qs_Vdi_bi-qdeff_Vdi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vdi_bi)+qdeff_Vsi_bi_Vdi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc_Vdi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vdi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vdi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vdi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vdi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vdi_bi-qdeff_Vdi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vdi_bi+qdeff_Vdi_bi)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi_Vdi_bi);
  ids_edge_Vsi_bi_Vsi_bi=(+(+(+(+(+((+(+(+(+0.0*pInst->NF+0.0*0.0+0.0*0.0+2.0*0.0)*nq+0.0*nq_Vsi_bi+(0.0)*nq_Vsi_bi+(2.0*pInst->NF)*nq_Vsi_bi_Vsi_bi)*ueff+((2.0*pInst->NF)*nq_Vsi_bi)*ueff_Vsi_bi+((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff_Vsi_bi+((2.0*pInst->NF)*nq)*ueff_Vsi_bi_Vsi_bi)*pModel->WEDGE+((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*0.0+(((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*0.0+(((2.0*pInst->NF)*nq)*ueff)*0.0)/Leff-(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE*0.0+((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)*0.0+((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0)/Leff/Leff+2*((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)*0.0*0.0/Leff/Leff/Leff)*Cox+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*0.0+(((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*0.0+(((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*0.0)*nVt+(((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt_Vsi_bi+((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi+((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi_Vsi_bi)*nVt+(((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt_Vsi_bi+(((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt_Vsi_bi+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi_Vsi_bi)*((qs-qdeff)*((1.0+qs)+qdeff))+(((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi))))+((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(+(+qs_Vsi_bi_Vsi_bi-qdeff_Vsi_bi_Vsi_bi)*((1.0+qs)+qdeff)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs_Vsi_bi-qdeff_Vsi_bi)*(qs_Vsi_bi+qdeff_Vsi_bi)+(qs-qdeff)*(+(+0.0+qs_Vsi_bi_Vsi_bi)+qdeff_Vsi_bi_Vsi_bi)))*Moc+(((((((((((2.0*pInst->NF)*nq_Vsi_bi)*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi))*pModel->WEDGE/Leff)*Cox*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*(((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))*Moc_Vsi_bi+(((((((((((((((((((0.0)*nq)+((2.0*pInst->NF)*nq_Vsi_bi)))*ueff)+(((2.0*pInst->NF)*nq)*ueff_Vsi_bi)))*pModel->WEDGE)/Leff)*Cox)*nVt)+(((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt_Vsi_bi)))*nVt)+((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt_Vsi_bi)))*((qs-qdeff)*((1.0+qs)+qdeff)))+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((((qs_Vsi_bi-qdeff_Vsi_bi)*((1.0+qs)+qdeff))+((qs-qdeff)*(qs_Vsi_bi+qdeff_Vsi_bi)))))))*Moc_Vsi_bi+(((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc_Vsi_bi_Vsi_bi);
#endif
#endif
ids_edge=((((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);
EXIT_IF_ISNAN(((((((((((2.0*pInst->NF)*nq)*ueff)*pModel->WEDGE)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc))
#if defined(_DERIVATEFORDDX) /* probe=V(gm,si)V(gm,di)V(dbulk,di)V(sbulk,si)V(gi,bi)Temp(t,GND)V(di,bi)V(si,bi) ddxprobe=V(sbulk,GND)V(dbulk,GND)V(si,GND)V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND) */
ids_Vgm_si=(ids_edge_Vgm_si+ids_Vgm_si);
#if defined(_DERIVATE2)
  ids_Vgm_si_Vgm_si=(+ids_edge_Vgm_si_Vgm_si+ids_Vgm_si_Vgm_si);
  ids_Vgm_si_Vgm_di=(+ids_edge_Vgm_si_Vgm_di+ids_Vgm_si_Vgm_di);
  ids_Vgm_si_Vdbulk_di=(+ids_edge_Vgm_si_Vdbulk_di+ids_Vgm_si_Vdbulk_di);
  ids_Vgm_si_Vsbulk_si=(+ids_edge_Vgm_si_Vsbulk_si+ids_Vgm_si_Vsbulk_si);
  ids_Vgm_si_Vgi_bi=(+ids_edge_Vgm_si_Vgi_bi+ids_Vgm_si_Vgi_bi);
  ids_Vgm_si_Tempt_GND=(+ids_edge_Vgm_si_Tempt_GND+ids_Vgm_si_Tempt_GND);
  ids_Vgm_si_Vdi_bi=(+ids_edge_Vgm_si_Vdi_bi+ids_Vgm_si_Vdi_bi);
  ids_Vgm_si_Vsi_bi=(+ids_edge_Vgm_si_Vsi_bi+ids_Vgm_si_Vsi_bi);
#endif
ids_Vgm_di=(ids_edge_Vgm_di+ids_Vgm_di);
#if defined(_DERIVATE2)
  ids_Vgm_di_Vgm_si=(+ids_edge_Vgm_di_Vgm_si+ids_Vgm_di_Vgm_si);
  ids_Vgm_di_Vgm_di=(+ids_edge_Vgm_di_Vgm_di+ids_Vgm_di_Vgm_di);
  ids_Vgm_di_Vdbulk_di=(+ids_edge_Vgm_di_Vdbulk_di+ids_Vgm_di_Vdbulk_di);
  ids_Vgm_di_Vsbulk_si=(+ids_edge_Vgm_di_Vsbulk_si+ids_Vgm_di_Vsbulk_si);
  ids_Vgm_di_Vgi_bi=(+ids_edge_Vgm_di_Vgi_bi+ids_Vgm_di_Vgi_bi);
  ids_Vgm_di_Tempt_GND=(+ids_edge_Vgm_di_Tempt_GND+ids_Vgm_di_Tempt_GND);
  ids_Vgm_di_Vdi_bi=(+ids_edge_Vgm_di_Vdi_bi+ids_Vgm_di_Vdi_bi);
  ids_Vgm_di_Vsi_bi=(+ids_edge_Vgm_di_Vsi_bi+ids_Vgm_di_Vsi_bi);
#endif
ids_Vdbulk_di=(ids_edge_Vdbulk_di+ids_Vdbulk_di);
#if defined(_DERIVATE2)
  ids_Vdbulk_di_Vgm_si=(+ids_edge_Vdbulk_di_Vgm_si+ids_Vdbulk_di_Vgm_si);
  ids_Vdbulk_di_Vgm_di=(+ids_edge_Vdbulk_di_Vgm_di+ids_Vdbulk_di_Vgm_di);
  ids_Vdbulk_di_Vdbulk_di=(+ids_edge_Vdbulk_di_Vdbulk_di+ids_Vdbulk_di_Vdbulk_di);
  ids_Vdbulk_di_Vsbulk_si=(+ids_edge_Vdbulk_di_Vsbulk_si+ids_Vdbulk_di_Vsbulk_si);
  ids_Vdbulk_di_Vgi_bi=(+ids_edge_Vdbulk_di_Vgi_bi+ids_Vdbulk_di_Vgi_bi);
  ids_Vdbulk_di_Tempt_GND=(+ids_edge_Vdbulk_di_Tempt_GND+ids_Vdbulk_di_Tempt_GND);
  ids_Vdbulk_di_Vdi_bi=(+ids_edge_Vdbulk_di_Vdi_bi+ids_Vdbulk_di_Vdi_bi);
  ids_Vdbulk_di_Vsi_bi=(+ids_edge_Vdbulk_di_Vsi_bi+ids_Vdbulk_di_Vsi_bi);
#endif
ids_Vsbulk_si=(ids_edge_Vsbulk_si+ids_Vsbulk_si);
#if defined(_DERIVATE2)
  ids_Vsbulk_si_Vgm_si=(+ids_edge_Vsbulk_si_Vgm_si+ids_Vsbulk_si_Vgm_si);
  ids_Vsbulk_si_Vgm_di=(+ids_edge_Vsbulk_si_Vgm_di+ids_Vsbulk_si_Vgm_di);
  ids_Vsbulk_si_Vdbulk_di=(+ids_edge_Vsbulk_si_Vdbulk_di+ids_Vsbulk_si_Vdbulk_di);
  ids_Vsbulk_si_Vsbulk_si=(+ids_edge_Vsbulk_si_Vsbulk_si+ids_Vsbulk_si_Vsbulk_si);
  ids_Vsbulk_si_Vgi_bi=(+ids_edge_Vsbulk_si_Vgi_bi+ids_Vsbulk_si_Vgi_bi);
  ids_Vsbulk_si_Tempt_GND=(+ids_edge_Vsbulk_si_Tempt_GND+ids_Vsbulk_si_Tempt_GND);
  ids_Vsbulk_si_Vdi_bi=(+ids_edge_Vsbulk_si_Vdi_bi+ids_Vsbulk_si_Vdi_bi);
  ids_Vsbulk_si_Vsi_bi=(+ids_edge_Vsbulk_si_Vsi_bi+ids_Vsbulk_si_Vsi_bi);
#endif
ids_Vgi_bi=(ids_edge_Vgi_bi+ids_Vgi_bi);
#if defined(_DERIVATE2)
  ids_Vgi_bi_Vgm_si=(+ids_edge_Vgi_bi_Vgm_si+ids_Vgi_bi_Vgm_si);
  ids_Vgi_bi_Vgm_di=(+ids_edge_Vgi_bi_Vgm_di+ids_Vgi_bi_Vgm_di);
  ids_Vgi_bi_Vdbulk_di=(+ids_edge_Vgi_bi_Vdbulk_di+ids_Vgi_bi_Vdbulk_di);
  ids_Vgi_bi_Vsbulk_si=(+ids_edge_Vgi_bi_Vsbulk_si+ids_Vgi_bi_Vsbulk_si);
  ids_Vgi_bi_Vgi_bi=(+ids_edge_Vgi_bi_Vgi_bi+ids_Vgi_bi_Vgi_bi);
  ids_Vgi_bi_Tempt_GND=(+ids_edge_Vgi_bi_Tempt_GND+ids_Vgi_bi_Tempt_GND);
  ids_Vgi_bi_Vdi_bi=(+ids_edge_Vgi_bi_Vdi_bi+ids_Vgi_bi_Vdi_bi);
  ids_Vgi_bi_Vsi_bi=(+ids_edge_Vgi_bi_Vsi_bi+ids_Vgi_bi_Vsi_bi);
#endif
#if defined(_DERIVATE)
ids_Tempt_GND=(ids_edge_Tempt_GND+ids_Tempt_GND);
#endif
ids_Vdi_bi=(ids_edge_Vdi_bi+ids_Vdi_bi);
#if defined(_DERIVATE2)
  ids_Vdi_bi_Vgm_si=(+ids_edge_Vdi_bi_Vgm_si+ids_Vdi_bi_Vgm_si);
  ids_Vdi_bi_Vgm_di=(+ids_edge_Vdi_bi_Vgm_di+ids_Vdi_bi_Vgm_di);
  ids_Vdi_bi_Vdbulk_di=(+ids_edge_Vdi_bi_Vdbulk_di+ids_Vdi_bi_Vdbulk_di);
  ids_Vdi_bi_Vsbulk_si=(+ids_edge_Vdi_bi_Vsbulk_si+ids_Vdi_bi_Vsbulk_si);
  ids_Vdi_bi_Vgi_bi=(+ids_edge_Vdi_bi_Vgi_bi+ids_Vdi_bi_Vgi_bi);
  ids_Vdi_bi_Tempt_GND=(+ids_edge_Vdi_bi_Tempt_GND+ids_Vdi_bi_Tempt_GND);
  ids_Vdi_bi_Vdi_bi=(+ids_edge_Vdi_bi_Vdi_bi+ids_Vdi_bi_Vdi_bi);
  ids_Vdi_bi_Vsi_bi=(+ids_edge_Vdi_bi_Vsi_bi+ids_Vdi_bi_Vsi_bi);
#endif
ids_Vsi_bi=(ids_edge_Vsi_bi+ids_Vsi_bi);
#if defined(_DERIVATE2)
  ids_Vsi_bi_Vgm_si=(+ids_edge_Vsi_bi_Vgm_si+ids_Vsi_bi_Vgm_si);
  ids_Vsi_bi_Vgm_di=(+ids_edge_Vsi_bi_Vgm_di+ids_Vsi_bi_Vgm_di);
  ids_Vsi_bi_Vdbulk_di=(+ids_edge_Vsi_bi_Vdbulk_di+ids_Vsi_bi_Vdbulk_di);
  ids_Vsi_bi_Vsbulk_si=(+ids_edge_Vsi_bi_Vsbulk_si+ids_Vsi_bi_Vsbulk_si);
  ids_Vsi_bi_Vgi_bi=(+ids_edge_Vsi_bi_Vgi_bi+ids_Vsi_bi_Vgi_bi);
  ids_Vsi_bi_Tempt_GND=(+ids_edge_Vsi_bi_Tempt_GND+ids_Vsi_bi_Tempt_GND);
  ids_Vsi_bi_Vdi_bi=(+ids_edge_Vsi_bi_Vdi_bi+ids_Vsi_bi_Vdi_bi);
  ids_Vsi_bi_Vsi_bi=(+ids_edge_Vsi_bi_Vsi_bi+ids_Vsi_bi_Vsi_bi);
#endif
#endif
ids=(ids_edge+ids);
EXIT_IF_ISNAN((ids_edge+ids))
}
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QB]=(devsign*(((QBi+Qovb)+Qbsj)+Qbdj));
EXIT_IF_ISNAN((devsign*(((QBi+Qovb)+Qbsj)+Qbdj)))
#endif
#ifdef _DYNAMIC
if
((sigvds>0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND)V(si,GND) */
QSI_Vdbulk_di=(devsign*QSi_Vdbulk_di);
#if defined(_DERIVATE2)
  QSI_Vdbulk_di_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vdbulk_di);
  QSI_Vdbulk_di_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vsbulk_si);
  QSI_Vdbulk_di_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Tempt_GND);
  QSI_Vdbulk_di_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vgi_bi);
  QSI_Vdbulk_di_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vdi_bi);
  QSI_Vdbulk_di_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vsi_bi);
#endif
QSI_Vsbulk_si=(devsign*QSi_Vsbulk_si);
#if defined(_DERIVATE2)
  QSI_Vsbulk_si_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vdbulk_di);
  QSI_Vsbulk_si_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vsbulk_si);
  QSI_Vsbulk_si_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Tempt_GND);
  QSI_Vsbulk_si_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vgi_bi);
  QSI_Vsbulk_si_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vdi_bi);
  QSI_Vsbulk_si_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vsi_bi);
#endif
#if defined(_DERIVATE)
QSI_Tempt_GND=(devsign*QSi_Tempt_GND);
#endif
QSI_Vgi_bi=(devsign*QSi_Vgi_bi);
#if defined(_DERIVATE2)
  QSI_Vgi_bi_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vdbulk_di);
  QSI_Vgi_bi_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vsbulk_si);
  QSI_Vgi_bi_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Tempt_GND);
  QSI_Vgi_bi_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vgi_bi);
  QSI_Vgi_bi_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vdi_bi);
  QSI_Vgi_bi_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vsi_bi);
#endif
QSI_Vdi_bi=(devsign*QSi_Vdi_bi);
#if defined(_DERIVATE2)
  QSI_Vdi_bi_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vdbulk_di);
  QSI_Vdi_bi_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vsbulk_si);
  QSI_Vdi_bi_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Tempt_GND);
  QSI_Vdi_bi_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vgi_bi);
  QSI_Vdi_bi_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vdi_bi);
  QSI_Vdi_bi_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vsi_bi);
#endif
QSI_Vsi_bi=(devsign*QSi_Vsi_bi);
#if defined(_DERIVATE2)
  QSI_Vsi_bi_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vdbulk_di);
  QSI_Vsi_bi_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vsbulk_si);
  QSI_Vsi_bi_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Tempt_GND);
  QSI_Vsi_bi_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vgi_bi);
  QSI_Vsi_bi_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vdi_bi);
  QSI_Vsi_bi_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vsi_bi);
#endif
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QSI]=(devsign*QSi);
EXIT_IF_ISNAN((devsign*QSi))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND)V(si,GND) */
QDI_Vdbulk_di=(devsign*QDi_Vdbulk_di);
#if defined(_DERIVATE2)
  QDI_Vdbulk_di_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vdbulk_di);
  QDI_Vdbulk_di_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vsbulk_si);
  QDI_Vdbulk_di_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Tempt_GND);
  QDI_Vdbulk_di_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vgi_bi);
  QDI_Vdbulk_di_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vdi_bi);
  QDI_Vdbulk_di_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vsi_bi);
#endif
QDI_Vsbulk_si=(devsign*QDi_Vsbulk_si);
#if defined(_DERIVATE2)
  QDI_Vsbulk_si_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vdbulk_di);
  QDI_Vsbulk_si_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vsbulk_si);
  QDI_Vsbulk_si_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Tempt_GND);
  QDI_Vsbulk_si_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vgi_bi);
  QDI_Vsbulk_si_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vdi_bi);
  QDI_Vsbulk_si_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vsi_bi);
#endif
#if defined(_DERIVATE)
QDI_Tempt_GND=(devsign*QDi_Tempt_GND);
#endif
QDI_Vgi_bi=(devsign*QDi_Vgi_bi);
#if defined(_DERIVATE2)
  QDI_Vgi_bi_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vdbulk_di);
  QDI_Vgi_bi_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vsbulk_si);
  QDI_Vgi_bi_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Tempt_GND);
  QDI_Vgi_bi_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vgi_bi);
  QDI_Vgi_bi_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vdi_bi);
  QDI_Vgi_bi_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vsi_bi);
#endif
QDI_Vdi_bi=(devsign*QDi_Vdi_bi);
#if defined(_DERIVATE2)
  QDI_Vdi_bi_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vdbulk_di);
  QDI_Vdi_bi_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vsbulk_si);
  QDI_Vdi_bi_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Tempt_GND);
  QDI_Vdi_bi_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vgi_bi);
  QDI_Vdi_bi_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vdi_bi);
  QDI_Vdi_bi_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vsi_bi);
#endif
QDI_Vsi_bi=(devsign*QDi_Vsi_bi);
#if defined(_DERIVATE2)
  QDI_Vsi_bi_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vdbulk_di);
  QDI_Vsi_bi_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vsbulk_si);
  QDI_Vsi_bi_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Tempt_GND);
  QDI_Vsi_bi_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vgi_bi);
  QDI_Vsi_bi_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vdi_bi);
  QDI_Vsi_bi_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vsi_bi);
#endif
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QDI]=(devsign*QDi);
EXIT_IF_ISNAN((devsign*QDi))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QS]=(devsign*((QSi+Qovs)-Qbsj));
EXIT_IF_ISNAN((devsign*((QSi+Qovs)-Qbsj)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QD]=(devsign*((QDi+Qovd)-Qbdj));
EXIT_IF_ISNAN((devsign*((QDi+Qovd)-Qbdj)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(sbulk,GND)V(gi,GND)V(bi,GND)V(di,GND)V(si,GND) */
QSI_Vdbulk_di=(devsign*QDi_Vdbulk_di);
#if defined(_DERIVATE2)
  QSI_Vdbulk_di_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vdbulk_di);
  QSI_Vdbulk_di_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vsbulk_si);
  QSI_Vdbulk_di_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Tempt_GND);
  QSI_Vdbulk_di_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vgi_bi);
  QSI_Vdbulk_di_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vdi_bi);
  QSI_Vdbulk_di_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vdbulk_di+devsign*QDi_Vdbulk_di_Vsi_bi);
#endif
QSI_Vsbulk_si=(devsign*QDi_Vsbulk_si);
#if defined(_DERIVATE2)
  QSI_Vsbulk_si_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vdbulk_di);
  QSI_Vsbulk_si_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vsbulk_si);
  QSI_Vsbulk_si_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Tempt_GND);
  QSI_Vsbulk_si_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vgi_bi);
  QSI_Vsbulk_si_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vdi_bi);
  QSI_Vsbulk_si_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vsbulk_si+devsign*QDi_Vsbulk_si_Vsi_bi);
#endif
#if defined(_DERIVATE)
QSI_Tempt_GND=(devsign*QDi_Tempt_GND);
#endif
QSI_Vgi_bi=(devsign*QDi_Vgi_bi);
#if defined(_DERIVATE2)
  QSI_Vgi_bi_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vdbulk_di);
  QSI_Vgi_bi_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vsbulk_si);
  QSI_Vgi_bi_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Tempt_GND);
  QSI_Vgi_bi_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vgi_bi);
  QSI_Vgi_bi_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vdi_bi);
  QSI_Vgi_bi_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vgi_bi+devsign*QDi_Vgi_bi_Vsi_bi);
#endif
QSI_Vdi_bi=(devsign*QDi_Vdi_bi);
#if defined(_DERIVATE2)
  QSI_Vdi_bi_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vdbulk_di);
  QSI_Vdi_bi_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vsbulk_si);
  QSI_Vdi_bi_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Tempt_GND);
  QSI_Vdi_bi_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vgi_bi);
  QSI_Vdi_bi_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vdi_bi);
  QSI_Vdi_bi_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vdi_bi+devsign*QDi_Vdi_bi_Vsi_bi);
#endif
QSI_Vsi_bi=(devsign*QDi_Vsi_bi);
#if defined(_DERIVATE2)
  QSI_Vsi_bi_Vdbulk_di=(+0.0*QDi+0.0*QDi_Vdbulk_di+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vdbulk_di);
  QSI_Vsi_bi_Vsbulk_si=(+0.0*QDi+0.0*QDi_Vsbulk_si+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vsbulk_si);
  QSI_Vsi_bi_Tempt_GND=(+0.0*QDi+0.0*QDi_Tempt_GND+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Tempt_GND);
  QSI_Vsi_bi_Vgi_bi=(+0.0*QDi+0.0*QDi_Vgi_bi+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vgi_bi);
  QSI_Vsi_bi_Vdi_bi=(+0.0*QDi+0.0*QDi_Vdi_bi+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vdi_bi);
  QSI_Vsi_bi_Vsi_bi=(+0.0*QDi+0.0*QDi_Vsi_bi+0.0*QDi_Vsi_bi+devsign*QDi_Vsi_bi_Vsi_bi);
#endif
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QSI]=(devsign*QDi);
EXIT_IF_ISNAN((devsign*QDi))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dbulk,di)V(sbulk,si)Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(dbulk,GND)V(gi,GND)V(bi,GND)V(di,GND)V(si,GND) */
QDI_Vdbulk_di=(devsign*QSi_Vdbulk_di);
#if defined(_DERIVATE2)
  QDI_Vdbulk_di_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vdbulk_di);
  QDI_Vdbulk_di_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vsbulk_si);
  QDI_Vdbulk_di_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Tempt_GND);
  QDI_Vdbulk_di_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vgi_bi);
  QDI_Vdbulk_di_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vdi_bi);
  QDI_Vdbulk_di_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vdbulk_di+devsign*QSi_Vdbulk_di_Vsi_bi);
#endif
QDI_Vsbulk_si=(devsign*QSi_Vsbulk_si);
#if defined(_DERIVATE2)
  QDI_Vsbulk_si_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vdbulk_di);
  QDI_Vsbulk_si_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vsbulk_si);
  QDI_Vsbulk_si_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Tempt_GND);
  QDI_Vsbulk_si_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vgi_bi);
  QDI_Vsbulk_si_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vdi_bi);
  QDI_Vsbulk_si_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vsbulk_si+devsign*QSi_Vsbulk_si_Vsi_bi);
#endif
#if defined(_DERIVATE)
QDI_Tempt_GND=(devsign*QSi_Tempt_GND);
#endif
QDI_Vgi_bi=(devsign*QSi_Vgi_bi);
#if defined(_DERIVATE2)
  QDI_Vgi_bi_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vdbulk_di);
  QDI_Vgi_bi_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vsbulk_si);
  QDI_Vgi_bi_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Tempt_GND);
  QDI_Vgi_bi_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vgi_bi);
  QDI_Vgi_bi_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vdi_bi);
  QDI_Vgi_bi_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vgi_bi+devsign*QSi_Vgi_bi_Vsi_bi);
#endif
QDI_Vdi_bi=(devsign*QSi_Vdi_bi);
#if defined(_DERIVATE2)
  QDI_Vdi_bi_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vdbulk_di);
  QDI_Vdi_bi_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vsbulk_si);
  QDI_Vdi_bi_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Tempt_GND);
  QDI_Vdi_bi_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vgi_bi);
  QDI_Vdi_bi_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vdi_bi);
  QDI_Vdi_bi_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vdi_bi+devsign*QSi_Vdi_bi_Vsi_bi);
#endif
QDI_Vsi_bi=(devsign*QSi_Vsi_bi);
#if defined(_DERIVATE2)
  QDI_Vsi_bi_Vdbulk_di=(+0.0*QSi+0.0*QSi_Vdbulk_di+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vdbulk_di);
  QDI_Vsi_bi_Vsbulk_si=(+0.0*QSi+0.0*QSi_Vsbulk_si+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vsbulk_si);
  QDI_Vsi_bi_Tempt_GND=(+0.0*QSi+0.0*QSi_Tempt_GND+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Tempt_GND);
  QDI_Vsi_bi_Vgi_bi=(+0.0*QSi+0.0*QSi_Vgi_bi+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vgi_bi);
  QDI_Vsi_bi_Vdi_bi=(+0.0*QSi+0.0*QSi_Vdi_bi+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vdi_bi);
  QDI_Vsi_bi_Vsi_bi=(+0.0*QSi+0.0*QSi_Vsi_bi+0.0*QSi_Vsi_bi+devsign*QSi_Vsi_bi_Vsi_bi);
#endif
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QDI]=(devsign*QSi);
EXIT_IF_ISNAN((devsign*QSi))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QS]=(devsign*((QDi+Qovs)-Qbsj));
EXIT_IF_ISNAN((devsign*((QDi+Qovs)-Qbsj)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QD]=(devsign*((QSi+Qovd)-Qbdj));
EXIT_IF_ISNAN((devsign*((QSi+Qovd)-Qbdj)))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QG]=(devsign*(QGi+Qovg));
EXIT_IF_ISNAN((devsign*(QGi+Qovg)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QBI]=(devsign*QBi);
EXIT_IF_ISNAN((devsign*QBi))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(dbulk,di)V(sbulk,si)V(gi,bi)V(di,bi)V(si,bi) ddxprobe=V(gm,GND)V(gi,GND)V(bi,GND)V(di,GND)V(si,GND) */
#if defined(_DERIVATE)
QGI_Tempt_GND=(devsign*QGi_Tempt_GND);
#endif
QGI_Vdbulk_di=(devsign*QGi_Vdbulk_di);
#if defined(_DERIVATE2)
  QGI_Vdbulk_di_Tempt_GND=(+0.0*QGi+0.0*QGi_Tempt_GND+0.0*QGi_Vdbulk_di+devsign*QGi_Vdbulk_di_Tempt_GND);
  QGI_Vdbulk_di_Vdbulk_di=(+0.0*QGi+0.0*QGi_Vdbulk_di+0.0*QGi_Vdbulk_di+devsign*QGi_Vdbulk_di_Vdbulk_di);
  QGI_Vdbulk_di_Vsbulk_si=(+0.0*QGi+0.0*QGi_Vsbulk_si+0.0*QGi_Vdbulk_di+devsign*QGi_Vdbulk_di_Vsbulk_si);
  QGI_Vdbulk_di_Vgi_bi=(+0.0*QGi+0.0*QGi_Vgi_bi+0.0*QGi_Vdbulk_di+devsign*QGi_Vdbulk_di_Vgi_bi);
  QGI_Vdbulk_di_Vdi_bi=(+0.0*QGi+0.0*QGi_Vdi_bi+0.0*QGi_Vdbulk_di+devsign*QGi_Vdbulk_di_Vdi_bi);
  QGI_Vdbulk_di_Vsi_bi=(+0.0*QGi+0.0*QGi_Vsi_bi+0.0*QGi_Vdbulk_di+devsign*QGi_Vdbulk_di_Vsi_bi);
#endif
QGI_Vsbulk_si=(devsign*QGi_Vsbulk_si);
#if defined(_DERIVATE2)
  QGI_Vsbulk_si_Tempt_GND=(+0.0*QGi+0.0*QGi_Tempt_GND+0.0*QGi_Vsbulk_si+devsign*QGi_Vsbulk_si_Tempt_GND);
  QGI_Vsbulk_si_Vdbulk_di=(+0.0*QGi+0.0*QGi_Vdbulk_di+0.0*QGi_Vsbulk_si+devsign*QGi_Vsbulk_si_Vdbulk_di);
  QGI_Vsbulk_si_Vsbulk_si=(+0.0*QGi+0.0*QGi_Vsbulk_si+0.0*QGi_Vsbulk_si+devsign*QGi_Vsbulk_si_Vsbulk_si);
  QGI_Vsbulk_si_Vgi_bi=(+0.0*QGi+0.0*QGi_Vgi_bi+0.0*QGi_Vsbulk_si+devsign*QGi_Vsbulk_si_Vgi_bi);
  QGI_Vsbulk_si_Vdi_bi=(+0.0*QGi+0.0*QGi_Vdi_bi+0.0*QGi_Vsbulk_si+devsign*QGi_Vsbulk_si_Vdi_bi);
  QGI_Vsbulk_si_Vsi_bi=(+0.0*QGi+0.0*QGi_Vsi_bi+0.0*QGi_Vsbulk_si+devsign*QGi_Vsbulk_si_Vsi_bi);
#endif
QGI_Vgi_bi=(devsign*QGi_Vgi_bi);
#if defined(_DERIVATE2)
  QGI_Vgi_bi_Tempt_GND=(+0.0*QGi+0.0*QGi_Tempt_GND+0.0*QGi_Vgi_bi+devsign*QGi_Vgi_bi_Tempt_GND);
  QGI_Vgi_bi_Vdbulk_di=(+0.0*QGi+0.0*QGi_Vdbulk_di+0.0*QGi_Vgi_bi+devsign*QGi_Vgi_bi_Vdbulk_di);
  QGI_Vgi_bi_Vsbulk_si=(+0.0*QGi+0.0*QGi_Vsbulk_si+0.0*QGi_Vgi_bi+devsign*QGi_Vgi_bi_Vsbulk_si);
  QGI_Vgi_bi_Vgi_bi=(+0.0*QGi+0.0*QGi_Vgi_bi+0.0*QGi_Vgi_bi+devsign*QGi_Vgi_bi_Vgi_bi);
  QGI_Vgi_bi_Vdi_bi=(+0.0*QGi+0.0*QGi_Vdi_bi+0.0*QGi_Vgi_bi+devsign*QGi_Vgi_bi_Vdi_bi);
  QGI_Vgi_bi_Vsi_bi=(+0.0*QGi+0.0*QGi_Vsi_bi+0.0*QGi_Vgi_bi+devsign*QGi_Vgi_bi_Vsi_bi);
#endif
QGI_Vdi_bi=(devsign*QGi_Vdi_bi);
#if defined(_DERIVATE2)
  QGI_Vdi_bi_Tempt_GND=(+0.0*QGi+0.0*QGi_Tempt_GND+0.0*QGi_Vdi_bi+devsign*QGi_Vdi_bi_Tempt_GND);
  QGI_Vdi_bi_Vdbulk_di=(+0.0*QGi+0.0*QGi_Vdbulk_di+0.0*QGi_Vdi_bi+devsign*QGi_Vdi_bi_Vdbulk_di);
  QGI_Vdi_bi_Vsbulk_si=(+0.0*QGi+0.0*QGi_Vsbulk_si+0.0*QGi_Vdi_bi+devsign*QGi_Vdi_bi_Vsbulk_si);
  QGI_Vdi_bi_Vgi_bi=(+0.0*QGi+0.0*QGi_Vgi_bi+0.0*QGi_Vdi_bi+devsign*QGi_Vdi_bi_Vgi_bi);
  QGI_Vdi_bi_Vdi_bi=(+0.0*QGi+0.0*QGi_Vdi_bi+0.0*QGi_Vdi_bi+devsign*QGi_Vdi_bi_Vdi_bi);
  QGI_Vdi_bi_Vsi_bi=(+0.0*QGi+0.0*QGi_Vsi_bi+0.0*QGi_Vdi_bi+devsign*QGi_Vdi_bi_Vsi_bi);
#endif
QGI_Vsi_bi=(devsign*QGi_Vsi_bi);
#if defined(_DERIVATE2)
  QGI_Vsi_bi_Tempt_GND=(+0.0*QGi+0.0*QGi_Tempt_GND+0.0*QGi_Vsi_bi+devsign*QGi_Vsi_bi_Tempt_GND);
  QGI_Vsi_bi_Vdbulk_di=(+0.0*QGi+0.0*QGi_Vdbulk_di+0.0*QGi_Vsi_bi+devsign*QGi_Vsi_bi_Vdbulk_di);
  QGI_Vsi_bi_Vsbulk_si=(+0.0*QGi+0.0*QGi_Vsbulk_si+0.0*QGi_Vsi_bi+devsign*QGi_Vsi_bi_Vsbulk_si);
  QGI_Vsi_bi_Vgi_bi=(+0.0*QGi+0.0*QGi_Vgi_bi+0.0*QGi_Vsi_bi+devsign*QGi_Vsi_bi_Vgi_bi);
  QGI_Vsi_bi_Vdi_bi=(+0.0*QGi+0.0*QGi_Vdi_bi+0.0*QGi_Vsi_bi+devsign*QGi_Vsi_bi_Vdi_bi);
  QGI_Vsi_bi_Vsi_bi=(+0.0*QGi+0.0*QGi_Vsi_bi+0.0*QGi_Vsi_bi+devsign*QGi_Vsi_bi_Vsi_bi);
#endif
#endif
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QGI]=(devsign*QGi);
EXIT_IF_ISNAN((devsign*QGi))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGSI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGDI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGBI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGGI]=+(QGI_Vgi_bi); /* indeed 3 */
EXIT_IF_ISNAN(CGGI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSSI]=-(QSI_Vsbulk_si)+(QSI_Vsi_bi); /* indeed 3 */
EXIT_IF_ISNAN(CSSI)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSDI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSBI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSGI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDSI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDDI]=-(QDI_Vdbulk_di)+(QDI_Vdi_bi); /* indeed 3 */
EXIT_IF_ISNAN(CDDI)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDBI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDGI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBSI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBDI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBBI]=-(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CBBI)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBGI]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGS]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGD]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGB]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGG]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGGI]+0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGGI]+0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSS]=-(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CSS)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSD]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSB]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSBI]-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSBI]-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSG]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSGI]-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSGI]-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDS]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDD]=-(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDD)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDB]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDBI]-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDBI]-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDG]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDGI]-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDGI]-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBS]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBD]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBB]=(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBBI]+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBBI]+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBG]=((-0.0 /*ddx should be top node of expression!*/)-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-0.0 /*ddx should be top node of expression!*/)-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGSEXT]=((-devsign)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-devsign)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGDEXT]=((-devsign)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-devsign)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGBOV]=((-devsign)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-devsign)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CAPBS]=((-devsign)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-devsign)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CAPBD]=((-devsign)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-devsign)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_WEFF]=Weff;
EXIT_IF_ISNAN(Weff)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_LEFF]=Leff;
EXIT_IF_ISNAN(Leff)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_WEFFCV]=Wact;
EXIT_IF_ISNAN(Wact)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_LEFFCV]=Lact;
EXIT_IF_ISNAN(Lact)
#endif
#ifdef _DYNAMIC
if
((sigvds>0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]=(devsign*ids);
EXIT_IF_ISNAN((devsign*ids))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDEFF]=(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGD]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCD]))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL]);
EXIT_IF_ISNAN((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGD]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCD]))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISEFF]=(((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGS]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCS]))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL]);
EXIT_IF_ISNAN((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGS]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCS]))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL]))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]=((-devsign)*ids);
EXIT_IF_ISNAN(((-devsign)*ids))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDEFF]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGD]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCD]))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGD]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCD]))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISEFF]=((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGS]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCS]))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL]);
EXIT_IF_ISNAN(((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGS]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCS]))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL]))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGEFF]=((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGB]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGS])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCS])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGD])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCD]);
EXIT_IF_ISNAN(((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGB]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGS])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCS])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGD])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCD]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IBS]=((-devsign)*Ibs);
EXIT_IF_ISNAN(((-devsign)*Ibs))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IBD]=((-devsign)*Ibd);
EXIT_IF_ISNAN(((-devsign)*Ibd))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VDS]=(NP(di)-NP(si));
EXIT_IF_ISNAN((NP(di)-NP(si)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VGS]=(NP(gi)-NP(si));
EXIT_IF_ISNAN((NP(gi)-NP(si)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VBS]=(-(NP(si)-NP(bi)));
EXIT_IF_ISNAN((-(NP(si)-NP(bi))))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VDSAT]=Vdssat;
EXIT_IF_ISNAN(Vdssat)
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GM]=+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(GM)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMBS]=-(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(GMBS)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GDS]=-(0.0)-(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(GDS)
#endif
#endif
  _load_dynamic_residual2(gi,bi,_DDT(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QGI]))
  _load_dynamic_jacobian4(gi,bi,si,bi,QGI_Vsi_bi)
  _load_dynamic_jacobian4(gi,bi,di,bi,QGI_Vdi_bi)
  _load_dynamic_jacobian4(gi,bi,gi,bi,QGI_Vgi_bi)
  _load_dynamic_jacobian4(gi,bi,sbulk,si,QGI_Vsbulk_si)
  _load_dynamic_jacobian4(gi,bi,dbulk,di,QGI_Vdbulk_di)
  _load_dynamic_jacobian2s(gi,bi,t,QGI_Tempt_GND)
  _load_dynamic_residual2(si,bi,_DDT(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QSI]))
  _load_dynamic_jacobian4(si,bi,si,bi,QSI_Vsi_bi)
  _load_dynamic_jacobian4(si,bi,di,bi,QSI_Vdi_bi)
  _load_dynamic_jacobian4(si,bi,gi,bi,QSI_Vgi_bi)
  _load_dynamic_jacobian2s(si,bi,t,QSI_Tempt_GND)
  _load_dynamic_jacobian4(si,bi,sbulk,si,QSI_Vsbulk_si)
  _load_dynamic_jacobian4(si,bi,dbulk,di,QSI_Vdbulk_di)
  _load_dynamic_residual2(di,bi,_DDT(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QDI]))
  _load_dynamic_jacobian4(di,bi,si,bi,QDI_Vsi_bi)
  _load_dynamic_jacobian4(di,bi,di,bi,QDI_Vdi_bi)
  _load_dynamic_jacobian4(di,bi,gi,bi,QDI_Vgi_bi)
  _load_dynamic_jacobian2s(di,bi,t,QDI_Tempt_GND)
  _load_dynamic_jacobian4(di,bi,sbulk,si,QDI_Vsbulk_si)
  _load_dynamic_jacobian4(di,bi,dbulk,di,QDI_Vdbulk_di)
  _load_dynamic_residual2(gm,si,_DDT(((-devsign)*Qovs)))
  _load_dynamic_jacobian4(gm,si,gm,si,((-devsign)*Qovs_Vgm_si))
  _load_dynamic_jacobian4(gm,si,si,bi,((-devsign)*Qovs_Vsi_bi))
  _load_dynamic_jacobian4(gm,si,di,bi,((-devsign)*Qovs_Vdi_bi))
  _load_dynamic_jacobian4(gm,si,gi,bi,((-devsign)*Qovs_Vgi_bi))
  _load_dynamic_jacobian4(gm,si,sbulk,si,((-devsign)*Qovs_Vsbulk_si))
  _load_dynamic_jacobian4(gm,si,dbulk,di,((-devsign)*Qovs_Vdbulk_di))
  _load_dynamic_jacobian2s(gm,si,t,((-devsign)*Qovs_Tempt_GND))
  _load_dynamic_residual2(gm,di,_DDT(((-devsign)*Qovd)))
  _load_dynamic_jacobian4(gm,di,gm,di,((-devsign)*Qovd_Vgm_di))
  _load_dynamic_jacobian4(gm,di,si,bi,((-devsign)*Qovd_Vsi_bi))
  _load_dynamic_jacobian4(gm,di,di,bi,((-devsign)*Qovd_Vdi_bi))
  _load_dynamic_jacobian4(gm,di,gi,bi,((-devsign)*Qovd_Vgi_bi))
  _load_dynamic_jacobian4(gm,di,sbulk,si,((-devsign)*Qovd_Vsbulk_si))
  _load_dynamic_jacobian4(gm,di,dbulk,di,((-devsign)*Qovd_Vdbulk_di))
  _load_dynamic_jacobian4(gm,di,gm,si,((-devsign)*Qovd_Vgm_si))
  _load_dynamic_jacobian2s(gm,di,t,((-devsign)*Qovd_Tempt_GND))
  _load_dynamic_residual2(gm,bi,_DDT(((-devsign)*Qovb)))
  _load_dynamic_jacobian4(gm,bi,gm,bi,((-devsign)*Qovb_Vgm_bi))
  _load_static_residual2(di,si,((devsign*sigvds)*ids))
  _load_static_jacobian4(di,si,si,bi,((devsign*sigvds)*ids_Vsi_bi))
  _load_static_jacobian4(di,si,di,bi,((devsign*sigvds)*ids_Vdi_bi))
  _load_static_jacobian2s(di,si,t,((devsign*sigvds)*ids_Tempt_GND))
  _load_static_jacobian4(di,si,gi,bi,((devsign*sigvds)*ids_Vgi_bi))
  _load_static_jacobian4(di,si,sbulk,si,((devsign*sigvds)*ids_Vsbulk_si))
  _load_static_jacobian4(di,si,dbulk,di,((devsign*sigvds)*ids_Vdbulk_di))
  _load_static_jacobian4(di,si,gm,di,((devsign*sigvds)*ids_Vgm_di))
  _load_static_jacobian4(di,si,gm,si,((devsign*sigvds)*ids_Vgm_si))
if
((pModel->IGBMOD!=0))
{
  _load_static_residual2(gi,bi,ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGB])
  _load_static_jacobian2s(gi,bi,t,IGB_Tempt_GND)
  _load_static_jacobian4(gi,bi,si,bi,IGB_Vsi_bi)
  _load_static_jacobian4(gi,bi,di,bi,IGB_Vdi_bi)
  _load_static_jacobian4(gi,bi,gi,bi,IGB_Vgi_bi)
}
if
((pModel->IGCMOD!=0))
{
  _load_static_residual2(gi,si,(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGS]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCS]))
  _load_static_jacobian4(gi,si,di,bi,(IGS_Vdi_bi+IGCS_Vdi_bi))
  _load_static_jacobian4(gi,si,si,bi,(IGS_Vsi_bi+IGCS_Vsi_bi))
  _load_static_jacobian4(gi,si,gi,bi,(IGS_Vgi_bi+IGCS_Vgi_bi))
  _load_static_jacobian2s(gi,si,t,(IGS_Tempt_GND+IGCS_Tempt_GND))
  _load_static_residual2(gi,di,(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGD]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCD]))
  _load_static_jacobian4(gi,di,si,bi,(IGD_Vsi_bi+IGCD_Vsi_bi))
  _load_static_jacobian4(gi,di,di,bi,(IGD_Vdi_bi+IGCD_Vdi_bi))
  _load_static_jacobian4(gi,di,gi,bi,(IGD_Vgi_bi+IGCD_Vgi_bi))
  _load_static_jacobian2s(gi,di,t,(IGD_Tempt_GND+IGCD_Tempt_GND))
}
if
((sigvds>0))
{
  _load_static_residual2(di,bi,(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL]))
  _load_static_jacobian2s(di,bi,t,(ISUB_Tempt_GND+IGIDL_Tempt_GND))
  _load_static_jacobian4(di,bi,gi,bi,(ISUB_Vgi_bi+IGIDL_Vgi_bi))
  _load_static_jacobian4(di,bi,si,bi,(ISUB_Vsi_bi+IGIDL_Vsi_bi))
  _load_static_jacobian4(di,bi,di,bi,(ISUB_Vdi_bi+IGIDL_Vdi_bi))
  _load_static_residual2(si,bi,ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL])
  _load_static_jacobian2s(si,bi,t,IGISL_Tempt_GND)
  _load_static_jacobian4(si,bi,si,bi,IGISL_Vsi_bi)
  _load_static_jacobian4(si,bi,di,bi,IGISL_Vdi_bi)
  _load_static_jacobian4(si,bi,gi,bi,IGISL_Vgi_bi)
}
else
{
  _load_static_residual2(di,bi,ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL])
  _load_static_jacobian2s(di,bi,t,IGIDL_Tempt_GND)
  _load_static_jacobian4(di,bi,si,bi,IGIDL_Vsi_bi)
  _load_static_jacobian4(di,bi,di,bi,IGIDL_Vdi_bi)
  _load_static_jacobian4(di,bi,gi,bi,IGIDL_Vgi_bi)
  _load_static_residual2(si,bi,(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL]))
  _load_static_jacobian2s(si,bi,t,(ISUB_Tempt_GND+IGISL_Tempt_GND))
  _load_static_jacobian4(si,bi,gi,bi,(ISUB_Vgi_bi+IGISL_Vgi_bi))
  _load_static_jacobian4(si,bi,si,bi,(ISUB_Vsi_bi+IGISL_Vsi_bi))
  _load_static_jacobian4(si,bi,di,bi,(ISUB_Vdi_bi+IGISL_Vdi_bi))
}
if
((pModel->RDSMOD!=2))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
#if defined(_DERIVATE)
gdpr_Tempt_GND=(-Rdrain_Tempt_GND/Rdrain/Rdrain);
#endif
#if defined(_DERIVATE)
gdpr_Vgi_bi=(-Rdrain_Vgi_bi/Rdrain/Rdrain);
#endif
#if defined(_DERIVATE)
gdpr_Vdi_bi=(-Rdrain_Vdi_bi/Rdrain/Rdrain);
#endif
#if defined(_DERIVATE)
gdpr_Vsi_bi=(-Rdrain_Vsi_bi/Rdrain/Rdrain);
#endif
#endif
gdpr=(1.0/Rdrain);
EXIT_IF_ISNAN((1.0/Rdrain))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(gi,bi)V(di,bi)V(si,bi) ddxprobe= */
gspr_Tempt_GND=(-Rsource_Tempt_GND/Rsource/Rsource);
gspr_Vgi_bi=(-Rsource_Vgi_bi/Rsource/Rsource);
gspr_Vdi_bi=(-Rsource_Vdi_bi/Rsource/Rsource);
gspr_Vsi_bi=(-Rsource_Vsi_bi/Rsource/Rsource);
#endif
gspr=(1.0/Rsource);
EXIT_IF_ISNAN((1.0/Rsource))
  _load_static_residual2(d,di,((NP(d)-NP(di))*gdpr))
  _load_static_jacobian4(d,di,si,bi,((NP(d)-NP(di))*gdpr_Vsi_bi))
  _load_static_jacobian4(d,di,di,bi,((NP(d)-NP(di))*gdpr_Vdi_bi))
  _load_static_jacobian4(d,di,gi,bi,((NP(d)-NP(di))*gdpr_Vgi_bi))
  _load_static_jacobian2s(d,di,t,((NP(d)-NP(di))*gdpr_Tempt_GND))
  _load_static_jacobian4(d,di,d,di,(gdpr))
  _load_static_residual2(s,si,((NP(s)-NP(si))*gspr))
  _load_static_jacobian4(s,si,si,bi,((NP(s)-NP(si))*gspr_Vsi_bi))
  _load_static_jacobian4(s,si,di,bi,((NP(s)-NP(si))*gspr_Vdi_bi))
  _load_static_jacobian4(s,si,gi,bi,((NP(s)-NP(si))*gspr_Vgi_bi))
  _load_static_jacobian2s(s,si,t,((NP(s)-NP(si))*gspr_Tempt_GND))
  _load_static_jacobian4(s,si,s,si,(gspr))
pInst->wnoise7=(Nt*gdpr);
pInst->wnoise6=(Nt*gspr);
}
else
{
  _load_static_residual2(d,di,0.0)
  _load_static_residual2(s,si,0.0)
}
if
((pInst->RGATEMOD==0))
{
  _load_static_residual2(g,gm,0.0)
}
else
{
if
((pInst->RGATEMOD==2))
{
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ggate_Vgi_bi=Gcrg_Vgi_bi;
Ggate_Vdi_bi=Gcrg_Vdi_bi;
Ggate_Vsi_bi=Gcrg_Vsi_bi;
Ggate_Tempt_GND=Gcrg_Tempt_GND;
#endif
Ggate=Gcrg;
EXIT_IF_ISNAN(Gcrg)
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Gnoise_Vgi_bi=(((Gcrg_Vgi_bi*Gcrg)+(Gcrg*Gcrg_Vgi_bi))/Grgeltd);
Gnoise_Vdi_bi=(((Gcrg_Vdi_bi*Gcrg)+(Gcrg*Gcrg_Vdi_bi))/Grgeltd);
Gnoise_Vsi_bi=(((Gcrg_Vsi_bi*Gcrg)+(Gcrg*Gcrg_Vsi_bi))/Grgeltd);
Gnoise_Tempt_GND=(((Gcrg_Tempt_GND*Gcrg)+(Gcrg*Gcrg_Tempt_GND))/Grgeltd);
#endif
Gnoise=((Gcrg*Gcrg)/Grgeltd);
EXIT_IF_ISNAN(((Gcrg*Gcrg)/Grgeltd))
}
else
{
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Ggate_Vgi_bi=0.0;
Ggate_Vdi_bi=0.0;
Ggate_Vsi_bi=0.0;
Ggate_Tempt_GND=0.0;
#endif
Ggate=Grgeltd;
EXIT_IF_ISNAN(Grgeltd)
#if defined(_DERIVATE) /* probe=V(gi,bi)V(di,bi)V(si,bi)Temp(t,GND) ddxprobe= */
Gnoise_Vgi_bi=0.0;
Gnoise_Vdi_bi=0.0;
Gnoise_Vsi_bi=0.0;
Gnoise_Tempt_GND=0.0;
#endif
Gnoise=Grgeltd;
EXIT_IF_ISNAN(Grgeltd)
}
  _load_static_residual2(g,gm,((NP(g)-NP(gm))*Ggate))
  _load_static_jacobian2s(g,gm,t,((NP(g)-NP(gm))*Ggate_Tempt_GND))
  _load_static_jacobian4(g,gm,si,bi,((NP(g)-NP(gm))*Ggate_Vsi_bi))
  _load_static_jacobian4(g,gm,di,bi,((NP(g)-NP(gm))*Ggate_Vdi_bi))
  _load_static_jacobian4(g,gm,gi,bi,((NP(g)-NP(gm))*Ggate_Vgi_bi))
  _load_static_jacobian4(g,gm,g,gm,(Ggate))
pInst->wnoise5=(Nt*Gnoise);
}
if
((pInst->RGATEMOD==3))
{
  _load_static_residual2(gm,gi,((NP(gm)-NP(gi))*Gcrg))
  _load_static_jacobian2s(gm,gi,t,((NP(gm)-NP(gi))*Gcrg_Tempt_GND))
  _load_static_jacobian4(gm,gi,si,bi,((NP(gm)-NP(gi))*Gcrg_Vsi_bi))
  _load_static_jacobian4(gm,gi,di,bi,((NP(gm)-NP(gi))*Gcrg_Vdi_bi))
  _load_static_jacobian4(gm,gi,gi,bi,((NP(gm)-NP(gi))*Gcrg_Vgi_bi))
  _load_static_jacobian4(gm,gi,gm,gi,(Gcrg))
}
else
{
  _load_static_residual2(gm,gi,0)
}
if
(((pModel->SHMOD!=0)&&(pModel->RTH0>0.0)))
{
if
((pModel->RDSMOD!=2))
{
  _load_static_residual1(t,((-(((((devsign*sigvds)*ids)*(NP(di)-NP(si)))+(((NP(d)-NP(di))*(NP(d)-NP(di)))/Rdrain))+(((NP(s)-NP(si))*(NP(s)-NP(si)))/Rsource)))+(delTemp1*gth)))
  _load_static_jacobian2p(t,s,si,(-(((NP(s)-NP(si))+(NP(s)-NP(si)))/Rsource)))
  _load_static_jacobian2p(t,d,di,(-(((NP(d)-NP(di))+(NP(d)-NP(di)))/Rdrain)))
  _load_static_jacobian2p(t,di,si,(-(((devsign*sigvds)*ids))))
  _load_static_jacobian2p(t,si,bi,(-((((devsign*sigvds)*ids_Vsi_bi)*(NP(di)-NP(si))+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Vsi_bi/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Vsi_bi/Rsource/Rsource))))
  _load_static_jacobian2p(t,di,bi,(-((((devsign*sigvds)*ids_Vdi_bi)*(NP(di)-NP(si))+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Vdi_bi/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Vdi_bi/Rsource/Rsource))))
  _load_static_jacobian1(t,t,((-((((devsign*sigvds)*ids_Tempt_GND)*(NP(di)-NP(si))+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Tempt_GND/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Tempt_GND/Rsource/Rsource)))+delTemp1_Tempt_GND*gth))
  _load_static_jacobian2p(t,gi,bi,(-((((devsign*sigvds)*ids_Vgi_bi)*(NP(di)-NP(si))+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Vgi_bi/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Vgi_bi/Rsource/Rsource))))
  _load_static_jacobian2p(t,sbulk,si,(-((devsign*sigvds)*ids_Vsbulk_si)*(NP(di)-NP(si))))
  _load_static_jacobian2p(t,dbulk,di,(-((devsign*sigvds)*ids_Vdbulk_di)*(NP(di)-NP(si))))
  _load_static_jacobian2p(t,gm,di,(-((devsign*sigvds)*ids_Vgm_di)*(NP(di)-NP(si))))
  _load_static_jacobian2p(t,gm,si,(-((devsign*sigvds)*ids_Vgm_si)*(NP(di)-NP(si))))
}
else
{
  _load_static_residual1(t,((-(((devsign*sigvds)*ids)*(NP(di)-NP(si))))+(delTemp1*gth)))
  _load_static_jacobian2p(t,di,si,(-(((devsign*sigvds)*ids))))
  _load_static_jacobian2p(t,si,bi,(-((devsign*sigvds)*ids_Vsi_bi)*(NP(di)-NP(si))))
  _load_static_jacobian2p(t,di,bi,(-((devsign*sigvds)*ids_Vdi_bi)*(NP(di)-NP(si))))
  _load_static_jacobian1(t,t,((-((devsign*sigvds)*ids_Tempt_GND)*(NP(di)-NP(si)))+delTemp1_Tempt_GND*gth))
  _load_static_jacobian2p(t,gi,bi,(-((devsign*sigvds)*ids_Vgi_bi)*(NP(di)-NP(si))))
  _load_static_jacobian2p(t,sbulk,si,(-((devsign*sigvds)*ids_Vsbulk_si)*(NP(di)-NP(si))))
  _load_static_jacobian2p(t,dbulk,di,(-((devsign*sigvds)*ids_Vdbulk_di)*(NP(di)-NP(si))))
  _load_static_jacobian2p(t,gm,di,(-((devsign*sigvds)*ids_Vgm_di)*(NP(di)-NP(si))))
  _load_static_jacobian2p(t,gm,si,(-((devsign*sigvds)*ids_Vgm_si)*(NP(di)-NP(si))))
}
  _load_dynamic_residual1(t,_DDT((delTemp1*cth)))
  _load_dynamic_jacobian1(t,t,delTemp1_Tempt_GND*cth)
}
else
{
  _load_static_residual1(t,0.0)
}
if
((pInst->RBODYMOD!=0))
{
  _load_static_residual2(bi,sbulk,((NP(bi)-NP(sbulk))*Grbps))
  _load_static_jacobian4(bi,sbulk,bi,sbulk,(Grbps))
  _load_static_residual2(b,sbulk,((NP(b)-NP(sbulk))*Grbsb))
  _load_static_jacobian4(b,sbulk,b,sbulk,(Grbsb))
  _load_static_residual2(b,bi,((NP(b)-NP(bi))*Grbpb))
  _load_static_jacobian4(b,bi,b,bi,(Grbpb))
  _load_static_residual2(b,dbulk,((NP(b)-NP(dbulk))*Grbdb))
  _load_static_jacobian4(b,dbulk,b,dbulk,(Grbdb))
  _load_static_residual2(bi,dbulk,((NP(bi)-NP(dbulk))*Grbpd))
  _load_static_jacobian4(bi,dbulk,bi,dbulk,(Grbpd))
pInst->wnoise4=(Nt*Grbps);
pInst->wnoise3=(Nt*Grbsb);
pInst->wnoise2=(Nt*Grbpb);
pInst->wnoise1=(Nt*Grbpd);
pInst->wnoise0=(Nt*Grbdb);
}
else
{
  _load_static_residual2(b,sbulk,0.0)
  _load_static_residual2(b,bi,0.0)
  _load_static_residual2(b,dbulk,0.0)
}
if
((pInst->RBODYMOD!=0))
{
  _load_static_residual2(sbulk,si,(devsign*Ibs))
  _load_static_jacobian2s(sbulk,si,t,(devsign*Ibs_Tempt_GND))
  _load_static_jacobian4(sbulk,si,si,bi,(devsign*Ibs_Vsi_bi))
  _load_static_jacobian4(sbulk,si,di,bi,(devsign*Ibs_Vdi_bi))
  _load_static_jacobian4(sbulk,si,gi,bi,(devsign*Ibs_Vgi_bi))
  _load_static_jacobian4(sbulk,si,sbulk,si,(devsign*Ibs_Vsbulk_si))
  _load_static_residual2(dbulk,di,(devsign*Ibd))
  _load_static_jacobian2s(dbulk,di,t,(devsign*Ibd_Tempt_GND))
  _load_static_jacobian4(dbulk,di,si,bi,(devsign*Ibd_Vsi_bi))
  _load_static_jacobian4(dbulk,di,di,bi,(devsign*Ibd_Vdi_bi))
  _load_static_jacobian4(dbulk,di,gi,bi,(devsign*Ibd_Vgi_bi))
  _load_static_jacobian4(dbulk,di,sbulk,si,(devsign*Ibd_Vsbulk_si))
  _load_static_jacobian4(dbulk,di,dbulk,di,(devsign*Ibd_Vdbulk_di))
  _load_dynamic_residual2(sbulk,si,(devsign*_DDT(Qbsj)))
  _load_dynamic_jacobian4(sbulk,si,si,bi,(devsign*Qbsj_Vsi_bi))
  _load_dynamic_jacobian4(sbulk,si,di,bi,(devsign*Qbsj_Vdi_bi))
  _load_dynamic_jacobian4(sbulk,si,gi,bi,(devsign*Qbsj_Vgi_bi))
  _load_dynamic_jacobian4(sbulk,si,sbulk,si,(devsign*Qbsj_Vsbulk_si))
  _load_dynamic_jacobian4(sbulk,si,dbulk,di,(devsign*Qbsj_Vdbulk_di))
  _load_dynamic_jacobian2s(sbulk,si,t,(devsign*Qbsj_Tempt_GND))
  _load_dynamic_residual2(dbulk,di,(devsign*_DDT(Qbdj)))
  _load_dynamic_jacobian4(dbulk,di,si,bi,(devsign*Qbdj_Vsi_bi))
  _load_dynamic_jacobian4(dbulk,di,di,bi,(devsign*Qbdj_Vdi_bi))
  _load_dynamic_jacobian4(dbulk,di,gi,bi,(devsign*Qbdj_Vgi_bi))
  _load_dynamic_jacobian4(dbulk,di,sbulk,si,(devsign*Qbdj_Vsbulk_si))
  _load_dynamic_jacobian4(dbulk,di,dbulk,di,(devsign*Qbdj_Vdbulk_di))
  _load_dynamic_jacobian2s(dbulk,di,t,(devsign*Qbdj_Tempt_GND))
}
else
{
  _load_static_residual2(bi,si,(devsign*Ibs))
  _load_static_jacobian2s(bi,si,t,(devsign*Ibs_Tempt_GND))
  _load_static_jacobian4(bi,si,si,bi,(devsign*Ibs_Vsi_bi))
  _load_static_jacobian4(bi,si,di,bi,(devsign*Ibs_Vdi_bi))
  _load_static_jacobian4(bi,si,gi,bi,(devsign*Ibs_Vgi_bi))
  _load_static_jacobian4(bi,si,sbulk,si,(devsign*Ibs_Vsbulk_si))
  _load_static_residual2(bi,di,(devsign*Ibd))
  _load_static_jacobian2s(bi,di,t,(devsign*Ibd_Tempt_GND))
  _load_static_jacobian4(bi,di,si,bi,(devsign*Ibd_Vsi_bi))
  _load_static_jacobian4(bi,di,di,bi,(devsign*Ibd_Vdi_bi))
  _load_static_jacobian4(bi,di,gi,bi,(devsign*Ibd_Vgi_bi))
  _load_static_jacobian4(bi,di,sbulk,si,(devsign*Ibd_Vsbulk_si))
  _load_static_jacobian4(bi,di,dbulk,di,(devsign*Ibd_Vdbulk_di))
  _load_dynamic_residual2(bi,si,(devsign*_DDT(Qbsj)))
  _load_dynamic_jacobian4(bi,si,si,bi,(devsign*Qbsj_Vsi_bi))
  _load_dynamic_jacobian4(bi,si,di,bi,(devsign*Qbsj_Vdi_bi))
  _load_dynamic_jacobian4(bi,si,gi,bi,(devsign*Qbsj_Vgi_bi))
  _load_dynamic_jacobian4(bi,si,sbulk,si,(devsign*Qbsj_Vsbulk_si))
  _load_dynamic_jacobian4(bi,si,dbulk,di,(devsign*Qbsj_Vdbulk_di))
  _load_dynamic_jacobian2s(bi,si,t,(devsign*Qbsj_Tempt_GND))
  _load_dynamic_residual2(bi,di,(devsign*_DDT(Qbdj)))
  _load_dynamic_jacobian4(bi,di,si,bi,(devsign*Qbdj_Vsi_bi))
  _load_dynamic_jacobian4(bi,di,di,bi,(devsign*Qbdj_Vdi_bi))
  _load_dynamic_jacobian4(bi,di,gi,bi,(devsign*Qbdj_Vgi_bi))
  _load_dynamic_jacobian4(bi,di,sbulk,si,(devsign*Qbdj_Vsbulk_si))
  _load_dynamic_jacobian4(bi,di,dbulk,di,(devsign*Qbdj_Vdbulk_di))
  _load_dynamic_jacobian2s(bi,di,t,(devsign*Qbdj_Tempt_GND))
}
